#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1836
#define LARGE_STATE_COUNT 656
#define SYMBOL_COUNT 508
#define ALIAS_COUNT 0
#define TOKEN_COUNT 350
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 13
#define PRODUCTION_ID_COUNT 18

enum {
  sym_comment = 1,
  sym_attr_ref = 2,
  sym_comdat_ref = 3,
  sym_global_var = 4,
  sym_local_var = 5,
  sym_label = 6,
  aux_sym_metadata_ref_token1 = 7,
  sym_summary_ref = 8,
  sym_string = 9,
  aux_sym_number_token1 = 10,
  aux_sym_number_token2 = 11,
  sym_float = 12,
  sym_cstring = 13,
  anon_sym_target = 14,
  anon_sym_triple = 15,
  anon_sym_EQ = 16,
  anon_sym_datalayout = 17,
  anon_sym_source_filename = 18,
  anon_sym_declare = 19,
  anon_sym_define = 20,
  anon_sym_no_cfi = 21,
  anon_sym_private = 22,
  anon_sym_internal = 23,
  anon_sym_weak = 24,
  anon_sym_weak_odr = 25,
  anon_sym_linkonce = 26,
  anon_sym_linkonce_odr = 27,
  anon_sym_available_externally = 28,
  anon_sym_appending = 29,
  anon_sym_common = 30,
  anon_sym_extern_weak = 31,
  anon_sym_external = 32,
  anon_sym_dso_local = 33,
  anon_sym_dso_local_equivalent = 34,
  anon_sym_dso_preemptable = 35,
  anon_sym_default = 36,
  anon_sym_hidden = 37,
  anon_sym_protected = 38,
  anon_sym_dllimport = 39,
  anon_sym_dllexport = 40,
  anon_sym_ccc = 41,
  anon_sym_fastcc = 42,
  anon_sym_coldcc = 43,
  anon_sym_webkit_jscc = 44,
  anon_sym_anyregcc = 45,
  anon_sym_preserve_mostcc = 46,
  anon_sym_preserve_allcc = 47,
  anon_sym_cxx_fast_tlscc = 48,
  anon_sym_tailcc = 49,
  anon_sym_swiftcc = 50,
  anon_sym_swifttailcc = 51,
  anon_sym_cfguard_checkcc = 52,
  aux_sym_calling_conv_token1 = 53,
  aux_sym_calling_conv_token2 = 54,
  aux_sym_calling_conv_token3 = 55,
  aux_sym_calling_conv_token4 = 56,
  aux_sym_calling_conv_token5 = 57,
  aux_sym_calling_conv_token6 = 58,
  aux_sym_calling_conv_token7 = 59,
  aux_sym_calling_conv_token8 = 60,
  aux_sym_calling_conv_token9 = 61,
  aux_sym_calling_conv_token10 = 62,
  anon_sym_ghccc = 63,
  aux_sym_calling_conv_token11 = 64,
  aux_sym_calling_conv_token12 = 65,
  aux_sym_calling_conv_token13 = 66,
  aux_sym_calling_conv_token14 = 67,
  anon_sym_cc = 68,
  anon_sym_unnamed_addr = 69,
  anon_sym_local_unnamed_addr = 70,
  anon_sym_STAR = 71,
  anon_sym_void = 72,
  anon_sym_half = 73,
  anon_sym_bfloat = 74,
  anon_sym_float = 75,
  anon_sym_double = 76,
  anon_sym_x86_fp80 = 77,
  anon_sym_fp128 = 78,
  anon_sym_ppc_fp128 = 79,
  anon_sym_label = 80,
  anon_sym_metadata = 81,
  anon_sym_x86_mmx = 82,
  anon_sym_x86_amx = 83,
  anon_sym_token = 84,
  anon_sym_opaque = 85,
  anon_sym_ptr = 86,
  aux_sym_type_keyword_token1 = 87,
  anon_sym_LBRACE = 88,
  anon_sym_RBRACE = 89,
  anon_sym_LT_LBRACE = 90,
  anon_sym_RBRACE_GT = 91,
  anon_sym_LBRACK = 92,
  anon_sym_RBRACK = 93,
  anon_sym_LT = 94,
  anon_sym_GT = 95,
  anon_sym_COMMA = 96,
  anon_sym_vscale = 97,
  anon_sym_x = 98,
  anon_sym_addrspace = 99,
  anon_sym_LPAREN = 100,
  anon_sym_RPAREN = 101,
  anon_sym_DOT_DOT_DOT = 102,
  anon_sym_align = 103,
  anon_sym_section = 104,
  anon_sym_partition = 105,
  anon_sym_comdat = 106,
  anon_sym_gc = 107,
  anon_sym_prefix = 108,
  anon_sym_prologue = 109,
  anon_sym_personality = 110,
  anon_sym_alignstack = 111,
  anon_sym_allocsize = 112,
  anon_sym_alwaysinline = 113,
  anon_sym_builtin = 114,
  anon_sym_cold = 115,
  anon_sym_convergent = 116,
  anon_sym_disable_sanitizer_instrumentation = 117,
  anon_sym_hot = 118,
  anon_sym_inaccessiblememonly = 119,
  anon_sym_inaccessiblemem_or_argmemonly = 120,
  anon_sym_inlinehint = 121,
  anon_sym_jumptable = 122,
  anon_sym_minsize = 123,
  anon_sym_naked = 124,
  anon_sym_no_DASHjump_DASHtables = 125,
  anon_sym_nobuiltin = 126,
  anon_sym_noduplicate = 127,
  anon_sym_nofree = 128,
  anon_sym_noimplicitfloat = 129,
  anon_sym_noinline = 130,
  anon_sym_nomerge = 131,
  anon_sym_nonlazybind = 132,
  anon_sym_noprofile = 133,
  anon_sym_noredzone = 134,
  anon_sym_indirect_DASHtls_DASHseg_DASHrefs = 135,
  anon_sym_noreturn = 136,
  anon_sym_norecurse = 137,
  anon_sym_willreturn = 138,
  anon_sym_nosync = 139,
  anon_sym_nounwind = 140,
  anon_sym_nosanitize_coverage = 141,
  anon_sym_null_pointer_is_valid = 142,
  anon_sym_optforfuzzing = 143,
  anon_sym_optnone = 144,
  anon_sym_optsize = 145,
  anon_sym_readnone = 146,
  anon_sym_readonly = 147,
  anon_sym_writeonly = 148,
  anon_sym_argmemonly = 149,
  anon_sym_returns_twice = 150,
  anon_sym_safestack = 151,
  anon_sym_sanitize_address = 152,
  anon_sym_sanitize_memory = 153,
  anon_sym_sanitize_thread = 154,
  anon_sym_sanitize_hwaddress = 155,
  anon_sym_sanitize_memtag = 156,
  anon_sym_speculative_load_hardening = 157,
  anon_sym_speculatable = 158,
  anon_sym_ssp = 159,
  anon_sym_sspstrong = 160,
  anon_sym_sspreq = 161,
  anon_sym_strictfp = 162,
  anon_sym_uwtable = 163,
  anon_sym_nocf_check = 164,
  anon_sym_shadowcallstack = 165,
  anon_sym_mustprogress = 166,
  anon_sym_vscale_range = 167,
  anon_sym_preallocated = 168,
  anon_sym_zeroext = 169,
  anon_sym_signext = 170,
  anon_sym_inreg = 171,
  anon_sym_byval = 172,
  anon_sym_byref = 173,
  anon_sym_inalloca = 174,
  anon_sym_sret = 175,
  anon_sym_elementtype = 176,
  anon_sym_noalias = 177,
  anon_sym_nocapture = 178,
  anon_sym_nest = 179,
  anon_sym_returned = 180,
  anon_sym_nonnull = 181,
  anon_sym_dereferenceable = 182,
  anon_sym_dereferenceable_or_null = 183,
  anon_sym_swiftself = 184,
  anon_sym_swiftasync = 185,
  anon_sym_swifterror = 186,
  anon_sym_immarg = 187,
  anon_sym_noundef = 188,
  anon_sym_unreachable = 189,
  anon_sym_ret = 190,
  anon_sym_br = 191,
  anon_sym_resume = 192,
  anon_sym_freeze = 193,
  anon_sym_indirectbr = 194,
  anon_sym_extractelement = 195,
  anon_sym_insertelement = 196,
  anon_sym_select = 197,
  anon_sym_shufflevector = 198,
  anon_sym_fneg = 199,
  anon_sym_nsw = 200,
  anon_sym_nuw = 201,
  anon_sym_exact = 202,
  anon_sym_switch = 203,
  anon_sym_invoke = 204,
  anon_sym_to = 205,
  anon_sym_unwind = 206,
  anon_sym_cleanupret = 207,
  anon_sym_from = 208,
  anon_sym_catchret = 209,
  anon_sym_catchswitch = 210,
  anon_sym_catchpad = 211,
  anon_sym_cleanuppad = 212,
  anon_sym_callbr = 213,
  anon_sym_icmp = 214,
  anon_sym_fcmp = 215,
  anon_sym_va_arg = 216,
  anon_sym_phi = 217,
  anon_sym_landingpad = 218,
  anon_sym_cleanup = 219,
  anon_sym_tail = 220,
  anon_sym_musttail = 221,
  anon_sym_notail = 222,
  anon_sym_call = 223,
  anon_sym_alloca = 224,
  anon_sym_load = 225,
  anon_sym_atomic = 226,
  anon_sym_volatile = 227,
  anon_sym_store = 228,
  anon_sym_cmpxchg = 229,
  anon_sym_atomicrmw = 230,
  anon_sym_fence = 231,
  anon_sym_getelementptr = 232,
  anon_sym_inbounds = 233,
  anon_sym_inrange = 234,
  anon_sym_extractvalue = 235,
  anon_sym_insertvalue = 236,
  anon_sym_true = 237,
  anon_sym_false = 238,
  anon_sym_null = 239,
  anon_sym_none = 240,
  anon_sym_undef = 241,
  anon_sym_poison = 242,
  anon_sym_zeroinitializer = 243,
  anon_sym_catch = 244,
  anon_sym_filter = 245,
  anon_sym_blockaddress = 246,
  anon_sym_mul = 247,
  anon_sym_urem = 248,
  anon_sym_srem = 249,
  anon_sym_shl = 250,
  anon_sym_udiv = 251,
  anon_sym_sdiv = 252,
  anon_sym_lshr = 253,
  anon_sym_ashr = 254,
  anon_sym_fmul = 255,
  anon_sym_fdiv = 256,
  anon_sym_frem = 257,
  anon_sym_xchg = 258,
  anon_sym_add = 259,
  anon_sym_sub = 260,
  anon_sym_and = 261,
  anon_sym_nand = 262,
  anon_sym_or = 263,
  anon_sym_xor = 264,
  anon_sym_max = 265,
  anon_sym_min = 266,
  anon_sym_umax = 267,
  anon_sym_umin = 268,
  anon_sym_fadd = 269,
  anon_sym_fsub = 270,
  anon_sym_eq = 271,
  anon_sym_ne = 272,
  anon_sym_ugt = 273,
  anon_sym_uge = 274,
  anon_sym_ult = 275,
  anon_sym_ule = 276,
  anon_sym_sgt = 277,
  anon_sym_sge = 278,
  anon_sym_slt = 279,
  anon_sym_sle = 280,
  anon_sym_oeq = 281,
  anon_sym_ogt = 282,
  anon_sym_oge = 283,
  anon_sym_olt = 284,
  anon_sym_ole = 285,
  anon_sym_one = 286,
  anon_sym_ord = 287,
  anon_sym_ueq = 288,
  anon_sym_une = 289,
  anon_sym_uno = 290,
  anon_sym_bitcast = 291,
  anon_sym_trunc = 292,
  anon_sym_zext = 293,
  anon_sym_sext = 294,
  anon_sym_fptrunc = 295,
  anon_sym_fpext = 296,
  anon_sym_addrspacecast = 297,
  anon_sym_uitofp = 298,
  anon_sym_sitofp = 299,
  anon_sym_fptoui = 300,
  anon_sym_fptosi = 301,
  anon_sym_inttoptr = 302,
  anon_sym_ptrtoint = 303,
  anon_sym_unordered = 304,
  anon_sym_monotonic = 305,
  anon_sym_acquire = 306,
  anon_sym_release = 307,
  anon_sym_acq_rel = 308,
  anon_sym_seq_cst = 309,
  anon_sym_syncscope = 310,
  anon_sym_nnan = 311,
  anon_sym_ninf = 312,
  anon_sym_nsz = 313,
  anon_sym_arcp = 314,
  anon_sym_contract = 315,
  anon_sym_afn = 316,
  anon_sym_reassoc = 317,
  anon_sym_fast = 318,
  anon_sym_within = 319,
  anon_sym_caller = 320,
  anon_sym_uselistorder = 321,
  anon_sym_uselistorder_bb = 322,
  anon_sym_module = 323,
  anon_sym_asm = 324,
  anon_sym_sideeffect = 325,
  anon_sym_inteldialect = 326,
  anon_sym_type = 327,
  anon_sym_externally_initialized = 328,
  anon_sym_global = 329,
  anon_sym_constant = 330,
  anon_sym_alias = 331,
  anon_sym_ifunc = 332,
  anon_sym_thread_local = 333,
  anon_sym_localdynamic = 334,
  anon_sym_initialexec = 335,
  anon_sym_localexec = 336,
  anon_sym_any = 337,
  anon_sym_exactmatch = 338,
  anon_sym_largest = 339,
  anon_sym_nodeduplicate = 340,
  anon_sym_samesize = 341,
  anon_sym_distinct = 342,
  anon_sym_BANG = 343,
  anon_sym_LBRACE2 = 344,
  anon_sym_LPAREN2 = 345,
  aux_sym_specialized_md_value_token1 = 346,
  anon_sym_PIPE = 347,
  anon_sym_COLON = 348,
  anon_sym_attributes = 349,
  sym_module = 350,
  sym_metadata_ref = 351,
  sym_metadata_name = 352,
  sym_number = 353,
  sym_var = 354,
  sym_target_definition = 355,
  sym_target_triple = 356,
  sym_data_layout = 357,
  sym_source_file_name = 358,
  sym_declare = 359,
  sym_define = 360,
  sym_metadata_attachment = 361,
  sym_function_header = 362,
  sym_linkage = 363,
  sym_linkage_aux = 364,
  sym_dso_local = 365,
  sym_visibility = 366,
  sym_dll_storage_class = 367,
  sym_calling_conv = 368,
  sym_unnamed_addr = 369,
  sym_type = 370,
  sym_type_keyword = 371,
  sym_struct_type = 372,
  sym_packed_struct_type = 373,
  sym_array_type = 374,
  sym_vector_type = 375,
  sym_struct_body = 376,
  sym_array_vector_body = 377,
  sym_addrspace = 378,
  sym_argument_list = 379,
  sym_argument = 380,
  sym_param_or_return_attrs = 381,
  sym_attribute = 382,
  sym_attribute_name = 383,
  sym_function_body = 384,
  sym_instruction = 385,
  sym__instruction_body = 386,
  sym_instruction_unreachable = 387,
  sym_instruction_ret = 388,
  sym_instruction_br = 389,
  sym_instruction_resume = 390,
  sym_instruction_freeze = 391,
  sym_instruction_indirectbr = 392,
  sym_instruction_extractelement = 393,
  sym_instruction_insertelement = 394,
  sym_instruction_select = 395,
  sym_instruction_shufflevector = 396,
  sym_instruction_fneg = 397,
  sym_instruction_bin_op = 398,
  sym_instruction_switch = 399,
  sym_instruction_invoke = 400,
  sym_instruction_cleanupret = 401,
  sym_instruction_catchret = 402,
  sym_instruction_catchswitch = 403,
  sym_instruction_catchpad = 404,
  sym_instruction_cleanuppad = 405,
  sym_instruction_callbr = 406,
  sym_instruction_icmp = 407,
  sym_instruction_fcmp = 408,
  sym_instruction_cast = 409,
  sym_instruction_va_arg = 410,
  sym_instruction_phi = 411,
  sym_instruction_landingpad = 412,
  sym_instruction_call = 413,
  sym_instruction_alloca = 414,
  sym_instruction_load = 415,
  sym_instruction_store = 416,
  sym_instruction_cmpxchg = 417,
  sym_instruction_atomicrmw = 418,
  sym_instruction_fence = 419,
  sym_instruction_getelementptr = 420,
  sym_instruction_extractvalue = 421,
  sym_instruction_insertvalue = 422,
  sym__call_part = 423,
  sym_type_and_value = 424,
  sym_value = 425,
  sym__primitive_value = 426,
  sym_struct_value = 427,
  sym_packed_struct_value = 428,
  sym_array_value = 429,
  sym_vector_value = 430,
  sym_metadata_refs = 431,
  sym_operand_bundles = 432,
  sym_landingpad_clause = 433,
  sym_blockaddress = 434,
  sym_constant_expr = 435,
  sym_constant_cast = 436,
  sym_constant_getelementptr = 437,
  sym_constant_select = 438,
  sym_constant_icmp = 439,
  sym_constant_fcmp = 440,
  sym_constant_extractelement = 441,
  sym_constant_insertelement = 442,
  sym_constant_shufflevector = 443,
  sym_constant_extractvalue = 444,
  sym_constant_insertvalue = 445,
  sym_constant_fneg = 446,
  sym_constant_bin_op = 447,
  sym_bin_op_keyword = 448,
  sym_atomic_bin_op_keyword = 449,
  sym_icmp_cond = 450,
  sym_fcmp_cond = 451,
  sym_cast_inst = 452,
  sym_atomic_ordering = 453,
  sym_alignment = 454,
  sym__load_store_suffix = 455,
  sym_syncscope = 456,
  sym_fast_math = 457,
  sym__value_array = 458,
  sym__within = 459,
  sym__unwind_label = 460,
  sym_use_list_order = 461,
  sym_use_list_order_bb = 462,
  sym_module_asm = 463,
  sym_inline_asm = 464,
  sym_asm = 465,
  sym_global_type = 466,
  sym__global_prefix = 467,
  sym_global_global = 468,
  sym_alias = 469,
  sym_ifunc = 470,
  sym_thread_local = 471,
  sym_comdat = 472,
  sym_global_metadata = 473,
  sym_metadata = 474,
  sym_metadata_tuple = 475,
  sym_specialized_md = 476,
  sym_specialized_md_value = 477,
  sym_summary_entry = 478,
  sym_summary_value = 479,
  sym_unnamed_attr_grp = 480,
  aux_sym_module_repeat1 = 481,
  aux_sym_declare_repeat1 = 482,
  aux_sym_function_header_repeat1 = 483,
  aux_sym_function_header_repeat2 = 484,
  aux_sym_function_header_repeat3 = 485,
  aux_sym_type_repeat1 = 486,
  aux_sym_type_repeat2 = 487,
  aux_sym_struct_body_repeat1 = 488,
  aux_sym_argument_list_repeat1 = 489,
  aux_sym_attribute_repeat1 = 490,
  aux_sym_function_body_repeat1 = 491,
  aux_sym_function_body_repeat2 = 492,
  aux_sym_instruction_repeat1 = 493,
  aux_sym_instruction_select_repeat1 = 494,
  aux_sym_instruction_bin_op_repeat1 = 495,
  aux_sym_instruction_switch_repeat1 = 496,
  aux_sym_instruction_callbr_repeat1 = 497,
  aux_sym_instruction_phi_repeat1 = 498,
  aux_sym_instruction_landingpad_repeat1 = 499,
  aux_sym_instruction_alloca_repeat1 = 500,
  aux_sym_instruction_getelementptr_repeat1 = 501,
  aux_sym_instruction_extractvalue_repeat1 = 502,
  aux_sym_operand_bundles_repeat1 = 503,
  aux_sym_global_global_repeat1 = 504,
  aux_sym_metadata_tuple_repeat1 = 505,
  aux_sym_specialized_md_repeat1 = 506,
  aux_sym_summary_entry_repeat1 = 507,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_comment] = "comment",
  [sym_attr_ref] = "attr_ref",
  [sym_comdat_ref] = "comdat_ref",
  [sym_global_var] = "global_var",
  [sym_local_var] = "local_var",
  [sym_label] = "label",
  [aux_sym_metadata_ref_token1] = "metadata_ref_token1",
  [sym_summary_ref] = "summary_ref",
  [sym_string] = "string",
  [aux_sym_number_token1] = "number_token1",
  [aux_sym_number_token2] = "number_token2",
  [sym_float] = "float",
  [sym_cstring] = "cstring",
  [anon_sym_target] = "target",
  [anon_sym_triple] = "triple",
  [anon_sym_EQ] = "=",
  [anon_sym_datalayout] = "datalayout",
  [anon_sym_source_filename] = "source_filename",
  [anon_sym_declare] = "declare",
  [anon_sym_define] = "define",
  [anon_sym_no_cfi] = "no_cfi",
  [anon_sym_private] = "private",
  [anon_sym_internal] = "internal",
  [anon_sym_weak] = "weak",
  [anon_sym_weak_odr] = "weak_odr",
  [anon_sym_linkonce] = "linkonce",
  [anon_sym_linkonce_odr] = "linkonce_odr",
  [anon_sym_available_externally] = "available_externally",
  [anon_sym_appending] = "appending",
  [anon_sym_common] = "common",
  [anon_sym_extern_weak] = "extern_weak",
  [anon_sym_external] = "external",
  [anon_sym_dso_local] = "dso_local",
  [anon_sym_dso_local_equivalent] = "dso_local_equivalent",
  [anon_sym_dso_preemptable] = "dso_preemptable",
  [anon_sym_default] = "default",
  [anon_sym_hidden] = "hidden",
  [anon_sym_protected] = "protected",
  [anon_sym_dllimport] = "dllimport",
  [anon_sym_dllexport] = "dllexport",
  [anon_sym_ccc] = "ccc",
  [anon_sym_fastcc] = "fastcc",
  [anon_sym_coldcc] = "coldcc",
  [anon_sym_webkit_jscc] = "webkit_jscc",
  [anon_sym_anyregcc] = "anyregcc",
  [anon_sym_preserve_mostcc] = "preserve_mostcc",
  [anon_sym_preserve_allcc] = "preserve_allcc",
  [anon_sym_cxx_fast_tlscc] = "cxx_fast_tlscc",
  [anon_sym_tailcc] = "tailcc",
  [anon_sym_swiftcc] = "swiftcc",
  [anon_sym_swifttailcc] = "swifttailcc",
  [anon_sym_cfguard_checkcc] = "cfguard_checkcc",
  [aux_sym_calling_conv_token1] = "calling_conv_token1",
  [aux_sym_calling_conv_token2] = "calling_conv_token2",
  [aux_sym_calling_conv_token3] = "calling_conv_token3",
  [aux_sym_calling_conv_token4] = "calling_conv_token4",
  [aux_sym_calling_conv_token5] = "calling_conv_token5",
  [aux_sym_calling_conv_token6] = "calling_conv_token6",
  [aux_sym_calling_conv_token7] = "calling_conv_token7",
  [aux_sym_calling_conv_token8] = "calling_conv_token8",
  [aux_sym_calling_conv_token9] = "calling_conv_token9",
  [aux_sym_calling_conv_token10] = "calling_conv_token10",
  [anon_sym_ghccc] = "ghccc",
  [aux_sym_calling_conv_token11] = "calling_conv_token11",
  [aux_sym_calling_conv_token12] = "calling_conv_token12",
  [aux_sym_calling_conv_token13] = "calling_conv_token13",
  [aux_sym_calling_conv_token14] = "calling_conv_token14",
  [anon_sym_cc] = "cc",
  [anon_sym_unnamed_addr] = "unnamed_addr",
  [anon_sym_local_unnamed_addr] = "local_unnamed_addr",
  [anon_sym_STAR] = "*",
  [anon_sym_void] = "void",
  [anon_sym_half] = "half",
  [anon_sym_bfloat] = "bfloat",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [anon_sym_x86_fp80] = "x86_fp80",
  [anon_sym_fp128] = "fp128",
  [anon_sym_ppc_fp128] = "ppc_fp128",
  [anon_sym_label] = "label",
  [anon_sym_metadata] = "metadata",
  [anon_sym_x86_mmx] = "x86_mmx",
  [anon_sym_x86_amx] = "x86_amx",
  [anon_sym_token] = "token",
  [anon_sym_opaque] = "opaque",
  [anon_sym_ptr] = "ptr",
  [aux_sym_type_keyword_token1] = "type_keyword_token1",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_LBRACE] = "<{",
  [anon_sym_RBRACE_GT] = "}>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_COMMA] = ",",
  [anon_sym_vscale] = "vscale",
  [anon_sym_x] = "x",
  [anon_sym_addrspace] = "addrspace",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_align] = "align",
  [anon_sym_section] = "section",
  [anon_sym_partition] = "partition",
  [anon_sym_comdat] = "comdat",
  [anon_sym_gc] = "gc",
  [anon_sym_prefix] = "prefix",
  [anon_sym_prologue] = "prologue",
  [anon_sym_personality] = "personality",
  [anon_sym_alignstack] = "alignstack",
  [anon_sym_allocsize] = "allocsize",
  [anon_sym_alwaysinline] = "alwaysinline",
  [anon_sym_builtin] = "builtin",
  [anon_sym_cold] = "cold",
  [anon_sym_convergent] = "convergent",
  [anon_sym_disable_sanitizer_instrumentation] = "disable_sanitizer_instrumentation",
  [anon_sym_hot] = "hot",
  [anon_sym_inaccessiblememonly] = "inaccessiblememonly",
  [anon_sym_inaccessiblemem_or_argmemonly] = "inaccessiblemem_or_argmemonly",
  [anon_sym_inlinehint] = "inlinehint",
  [anon_sym_jumptable] = "jumptable",
  [anon_sym_minsize] = "minsize",
  [anon_sym_naked] = "naked",
  [anon_sym_no_DASHjump_DASHtables] = "no-jump-tables",
  [anon_sym_nobuiltin] = "nobuiltin",
  [anon_sym_noduplicate] = "noduplicate",
  [anon_sym_nofree] = "nofree",
  [anon_sym_noimplicitfloat] = "noimplicitfloat",
  [anon_sym_noinline] = "noinline",
  [anon_sym_nomerge] = "nomerge",
  [anon_sym_nonlazybind] = "nonlazybind",
  [anon_sym_noprofile] = "noprofile",
  [anon_sym_noredzone] = "noredzone",
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = "indirect-tls-seg-refs",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_norecurse] = "norecurse",
  [anon_sym_willreturn] = "willreturn",
  [anon_sym_nosync] = "nosync",
  [anon_sym_nounwind] = "nounwind",
  [anon_sym_nosanitize_coverage] = "nosanitize_coverage",
  [anon_sym_null_pointer_is_valid] = "null_pointer_is_valid",
  [anon_sym_optforfuzzing] = "optforfuzzing",
  [anon_sym_optnone] = "optnone",
  [anon_sym_optsize] = "optsize",
  [anon_sym_readnone] = "readnone",
  [anon_sym_readonly] = "readonly",
  [anon_sym_writeonly] = "writeonly",
  [anon_sym_argmemonly] = "argmemonly",
  [anon_sym_returns_twice] = "returns_twice",
  [anon_sym_safestack] = "safestack",
  [anon_sym_sanitize_address] = "sanitize_address",
  [anon_sym_sanitize_memory] = "sanitize_memory",
  [anon_sym_sanitize_thread] = "sanitize_thread",
  [anon_sym_sanitize_hwaddress] = "sanitize_hwaddress",
  [anon_sym_sanitize_memtag] = "sanitize_memtag",
  [anon_sym_speculative_load_hardening] = "speculative_load_hardening",
  [anon_sym_speculatable] = "speculatable",
  [anon_sym_ssp] = "ssp",
  [anon_sym_sspstrong] = "sspstrong",
  [anon_sym_sspreq] = "sspreq",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_uwtable] = "uwtable",
  [anon_sym_nocf_check] = "nocf_check",
  [anon_sym_shadowcallstack] = "shadowcallstack",
  [anon_sym_mustprogress] = "mustprogress",
  [anon_sym_vscale_range] = "vscale_range",
  [anon_sym_preallocated] = "preallocated",
  [anon_sym_zeroext] = "zeroext",
  [anon_sym_signext] = "signext",
  [anon_sym_inreg] = "inreg",
  [anon_sym_byval] = "byval",
  [anon_sym_byref] = "byref",
  [anon_sym_inalloca] = "inalloca",
  [anon_sym_sret] = "sret",
  [anon_sym_elementtype] = "elementtype",
  [anon_sym_noalias] = "noalias",
  [anon_sym_nocapture] = "nocapture",
  [anon_sym_nest] = "nest",
  [anon_sym_returned] = "returned",
  [anon_sym_nonnull] = "nonnull",
  [anon_sym_dereferenceable] = "dereferenceable",
  [anon_sym_dereferenceable_or_null] = "dereferenceable_or_null",
  [anon_sym_swiftself] = "swiftself",
  [anon_sym_swiftasync] = "swiftasync",
  [anon_sym_swifterror] = "swifterror",
  [anon_sym_immarg] = "immarg",
  [anon_sym_noundef] = "noundef",
  [anon_sym_unreachable] = "unreachable",
  [anon_sym_ret] = "ret",
  [anon_sym_br] = "br",
  [anon_sym_resume] = "resume",
  [anon_sym_freeze] = "freeze",
  [anon_sym_indirectbr] = "indirectbr",
  [anon_sym_extractelement] = "extractelement",
  [anon_sym_insertelement] = "insertelement",
  [anon_sym_select] = "select",
  [anon_sym_shufflevector] = "shufflevector",
  [anon_sym_fneg] = "fneg",
  [anon_sym_nsw] = "nsw",
  [anon_sym_nuw] = "nuw",
  [anon_sym_exact] = "exact",
  [anon_sym_switch] = "switch",
  [anon_sym_invoke] = "invoke",
  [anon_sym_to] = "to",
  [anon_sym_unwind] = "unwind",
  [anon_sym_cleanupret] = "cleanupret",
  [anon_sym_from] = "from",
  [anon_sym_catchret] = "catchret",
  [anon_sym_catchswitch] = "catchswitch",
  [anon_sym_catchpad] = "catchpad",
  [anon_sym_cleanuppad] = "cleanuppad",
  [anon_sym_callbr] = "callbr",
  [anon_sym_icmp] = "icmp",
  [anon_sym_fcmp] = "fcmp",
  [anon_sym_va_arg] = "va_arg",
  [anon_sym_phi] = "phi",
  [anon_sym_landingpad] = "landingpad",
  [anon_sym_cleanup] = "cleanup",
  [anon_sym_tail] = "tail",
  [anon_sym_musttail] = "musttail",
  [anon_sym_notail] = "notail",
  [anon_sym_call] = "call",
  [anon_sym_alloca] = "alloca",
  [anon_sym_load] = "load",
  [anon_sym_atomic] = "atomic",
  [anon_sym_volatile] = "volatile",
  [anon_sym_store] = "store",
  [anon_sym_cmpxchg] = "cmpxchg",
  [anon_sym_atomicrmw] = "atomicrmw",
  [anon_sym_fence] = "fence",
  [anon_sym_getelementptr] = "getelementptr",
  [anon_sym_inbounds] = "inbounds",
  [anon_sym_inrange] = "inrange",
  [anon_sym_extractvalue] = "extractvalue",
  [anon_sym_insertvalue] = "insertvalue",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_none] = "none",
  [anon_sym_undef] = "undef",
  [anon_sym_poison] = "poison",
  [anon_sym_zeroinitializer] = "zeroinitializer",
  [anon_sym_catch] = "catch",
  [anon_sym_filter] = "filter",
  [anon_sym_blockaddress] = "blockaddress",
  [anon_sym_mul] = "mul",
  [anon_sym_urem] = "urem",
  [anon_sym_srem] = "srem",
  [anon_sym_shl] = "shl",
  [anon_sym_udiv] = "udiv",
  [anon_sym_sdiv] = "sdiv",
  [anon_sym_lshr] = "lshr",
  [anon_sym_ashr] = "ashr",
  [anon_sym_fmul] = "fmul",
  [anon_sym_fdiv] = "fdiv",
  [anon_sym_frem] = "frem",
  [anon_sym_xchg] = "xchg",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_and] = "and",
  [anon_sym_nand] = "nand",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_max] = "max",
  [anon_sym_min] = "min",
  [anon_sym_umax] = "umax",
  [anon_sym_umin] = "umin",
  [anon_sym_fadd] = "fadd",
  [anon_sym_fsub] = "fsub",
  [anon_sym_eq] = "eq",
  [anon_sym_ne] = "ne",
  [anon_sym_ugt] = "ugt",
  [anon_sym_uge] = "uge",
  [anon_sym_ult] = "ult",
  [anon_sym_ule] = "ule",
  [anon_sym_sgt] = "sgt",
  [anon_sym_sge] = "sge",
  [anon_sym_slt] = "slt",
  [anon_sym_sle] = "sle",
  [anon_sym_oeq] = "oeq",
  [anon_sym_ogt] = "ogt",
  [anon_sym_oge] = "oge",
  [anon_sym_olt] = "olt",
  [anon_sym_ole] = "ole",
  [anon_sym_one] = "one",
  [anon_sym_ord] = "ord",
  [anon_sym_ueq] = "ueq",
  [anon_sym_une] = "une",
  [anon_sym_uno] = "uno",
  [anon_sym_bitcast] = "bitcast",
  [anon_sym_trunc] = "trunc",
  [anon_sym_zext] = "zext",
  [anon_sym_sext] = "sext",
  [anon_sym_fptrunc] = "fptrunc",
  [anon_sym_fpext] = "fpext",
  [anon_sym_addrspacecast] = "addrspacecast",
  [anon_sym_uitofp] = "uitofp",
  [anon_sym_sitofp] = "sitofp",
  [anon_sym_fptoui] = "fptoui",
  [anon_sym_fptosi] = "fptosi",
  [anon_sym_inttoptr] = "inttoptr",
  [anon_sym_ptrtoint] = "ptrtoint",
  [anon_sym_unordered] = "unordered",
  [anon_sym_monotonic] = "monotonic",
  [anon_sym_acquire] = "acquire",
  [anon_sym_release] = "release",
  [anon_sym_acq_rel] = "acq_rel",
  [anon_sym_seq_cst] = "seq_cst",
  [anon_sym_syncscope] = "syncscope",
  [anon_sym_nnan] = "nnan",
  [anon_sym_ninf] = "ninf",
  [anon_sym_nsz] = "nsz",
  [anon_sym_arcp] = "arcp",
  [anon_sym_contract] = "contract",
  [anon_sym_afn] = "afn",
  [anon_sym_reassoc] = "reassoc",
  [anon_sym_fast] = "fast",
  [anon_sym_within] = "within",
  [anon_sym_caller] = "caller",
  [anon_sym_uselistorder] = "uselistorder",
  [anon_sym_uselistorder_bb] = "uselistorder_bb",
  [anon_sym_module] = "module",
  [anon_sym_asm] = "asm",
  [anon_sym_sideeffect] = "sideeffect",
  [anon_sym_inteldialect] = "inteldialect",
  [anon_sym_type] = "type",
  [anon_sym_externally_initialized] = "externally_initialized",
  [anon_sym_global] = "global",
  [anon_sym_constant] = "constant",
  [anon_sym_alias] = "alias",
  [anon_sym_ifunc] = "ifunc",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym_localdynamic] = "localdynamic",
  [anon_sym_initialexec] = "initialexec",
  [anon_sym_localexec] = "localexec",
  [anon_sym_any] = "any",
  [anon_sym_exactmatch] = "exactmatch",
  [anon_sym_largest] = "largest",
  [anon_sym_nodeduplicate] = "nodeduplicate",
  [anon_sym_samesize] = "samesize",
  [anon_sym_distinct] = "distinct",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_LPAREN2] = "(",
  [aux_sym_specialized_md_value_token1] = "specialized_md_value_token1",
  [anon_sym_PIPE] = "|",
  [anon_sym_COLON] = ":",
  [anon_sym_attributes] = "attributes",
  [sym_module] = "module",
  [sym_metadata_ref] = "metadata_ref",
  [sym_metadata_name] = "metadata_name",
  [sym_number] = "number",
  [sym_var] = "var",
  [sym_target_definition] = "target_definition",
  [sym_target_triple] = "target_triple",
  [sym_data_layout] = "data_layout",
  [sym_source_file_name] = "source_file_name",
  [sym_declare] = "declare",
  [sym_define] = "define",
  [sym_metadata_attachment] = "metadata_attachment",
  [sym_function_header] = "function_header",
  [sym_linkage] = "linkage",
  [sym_linkage_aux] = "linkage_aux",
  [sym_dso_local] = "dso_local",
  [sym_visibility] = "visibility",
  [sym_dll_storage_class] = "dll_storage_class",
  [sym_calling_conv] = "calling_conv",
  [sym_unnamed_addr] = "unnamed_addr",
  [sym_type] = "type",
  [sym_type_keyword] = "type_keyword",
  [sym_struct_type] = "struct_type",
  [sym_packed_struct_type] = "packed_struct_type",
  [sym_array_type] = "array_type",
  [sym_vector_type] = "vector_type",
  [sym_struct_body] = "struct_body",
  [sym_array_vector_body] = "array_vector_body",
  [sym_addrspace] = "addrspace",
  [sym_argument_list] = "argument_list",
  [sym_argument] = "argument",
  [sym_param_or_return_attrs] = "param_or_return_attrs",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym_function_body] = "function_body",
  [sym_instruction] = "instruction",
  [sym__instruction_body] = "_instruction_body",
  [sym_instruction_unreachable] = "instruction_unreachable",
  [sym_instruction_ret] = "instruction_ret",
  [sym_instruction_br] = "instruction_br",
  [sym_instruction_resume] = "instruction_resume",
  [sym_instruction_freeze] = "instruction_freeze",
  [sym_instruction_indirectbr] = "instruction_indirectbr",
  [sym_instruction_extractelement] = "instruction_extractelement",
  [sym_instruction_insertelement] = "instruction_insertelement",
  [sym_instruction_select] = "instruction_select",
  [sym_instruction_shufflevector] = "instruction_shufflevector",
  [sym_instruction_fneg] = "instruction_fneg",
  [sym_instruction_bin_op] = "instruction_bin_op",
  [sym_instruction_switch] = "instruction_switch",
  [sym_instruction_invoke] = "instruction_invoke",
  [sym_instruction_cleanupret] = "instruction_cleanupret",
  [sym_instruction_catchret] = "instruction_catchret",
  [sym_instruction_catchswitch] = "instruction_catchswitch",
  [sym_instruction_catchpad] = "instruction_catchpad",
  [sym_instruction_cleanuppad] = "instruction_cleanuppad",
  [sym_instruction_callbr] = "instruction_callbr",
  [sym_instruction_icmp] = "instruction_icmp",
  [sym_instruction_fcmp] = "instruction_fcmp",
  [sym_instruction_cast] = "instruction_cast",
  [sym_instruction_va_arg] = "instruction_va_arg",
  [sym_instruction_phi] = "instruction_phi",
  [sym_instruction_landingpad] = "instruction_landingpad",
  [sym_instruction_call] = "instruction_call",
  [sym_instruction_alloca] = "instruction_alloca",
  [sym_instruction_load] = "instruction_load",
  [sym_instruction_store] = "instruction_store",
  [sym_instruction_cmpxchg] = "instruction_cmpxchg",
  [sym_instruction_atomicrmw] = "instruction_atomicrmw",
  [sym_instruction_fence] = "instruction_fence",
  [sym_instruction_getelementptr] = "instruction_getelementptr",
  [sym_instruction_extractvalue] = "instruction_extractvalue",
  [sym_instruction_insertvalue] = "instruction_insertvalue",
  [sym__call_part] = "_call_part",
  [sym_type_and_value] = "type_and_value",
  [sym_value] = "value",
  [sym__primitive_value] = "_primitive_value",
  [sym_struct_value] = "struct_value",
  [sym_packed_struct_value] = "packed_struct_value",
  [sym_array_value] = "array_value",
  [sym_vector_value] = "vector_value",
  [sym_metadata_refs] = "metadata_refs",
  [sym_operand_bundles] = "operand_bundles",
  [sym_landingpad_clause] = "landingpad_clause",
  [sym_blockaddress] = "blockaddress",
  [sym_constant_expr] = "constant_expr",
  [sym_constant_cast] = "constant_cast",
  [sym_constant_getelementptr] = "constant_getelementptr",
  [sym_constant_select] = "constant_select",
  [sym_constant_icmp] = "constant_icmp",
  [sym_constant_fcmp] = "constant_fcmp",
  [sym_constant_extractelement] = "constant_extractelement",
  [sym_constant_insertelement] = "constant_insertelement",
  [sym_constant_shufflevector] = "constant_shufflevector",
  [sym_constant_extractvalue] = "constant_extractvalue",
  [sym_constant_insertvalue] = "constant_insertvalue",
  [sym_constant_fneg] = "constant_fneg",
  [sym_constant_bin_op] = "constant_bin_op",
  [sym_bin_op_keyword] = "bin_op_keyword",
  [sym_atomic_bin_op_keyword] = "atomic_bin_op_keyword",
  [sym_icmp_cond] = "icmp_cond",
  [sym_fcmp_cond] = "fcmp_cond",
  [sym_cast_inst] = "cast_inst",
  [sym_atomic_ordering] = "atomic_ordering",
  [sym_alignment] = "alignment",
  [sym__load_store_suffix] = "_load_store_suffix",
  [sym_syncscope] = "syncscope",
  [sym_fast_math] = "fast_math",
  [sym__value_array] = "_value_array",
  [sym__within] = "_within",
  [sym__unwind_label] = "_unwind_label",
  [sym_use_list_order] = "use_list_order",
  [sym_use_list_order_bb] = "use_list_order_bb",
  [sym_module_asm] = "module_asm",
  [sym_inline_asm] = "inline_asm",
  [sym_asm] = "asm",
  [sym_global_type] = "global_type",
  [sym__global_prefix] = "_global_prefix",
  [sym_global_global] = "global_global",
  [sym_alias] = "alias",
  [sym_ifunc] = "ifunc",
  [sym_thread_local] = "thread_local",
  [sym_comdat] = "comdat",
  [sym_global_metadata] = "global_metadata",
  [sym_metadata] = "metadata",
  [sym_metadata_tuple] = "metadata_tuple",
  [sym_specialized_md] = "specialized_md",
  [sym_specialized_md_value] = "specialized_md_value",
  [sym_summary_entry] = "summary_entry",
  [sym_summary_value] = "summary_value",
  [sym_unnamed_attr_grp] = "unnamed_attr_grp",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_declare_repeat1] = "declare_repeat1",
  [aux_sym_function_header_repeat1] = "function_header_repeat1",
  [aux_sym_function_header_repeat2] = "function_header_repeat2",
  [aux_sym_function_header_repeat3] = "function_header_repeat3",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_type_repeat2] = "type_repeat2",
  [aux_sym_struct_body_repeat1] = "struct_body_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_function_body_repeat1] = "function_body_repeat1",
  [aux_sym_function_body_repeat2] = "function_body_repeat2",
  [aux_sym_instruction_repeat1] = "instruction_repeat1",
  [aux_sym_instruction_select_repeat1] = "instruction_select_repeat1",
  [aux_sym_instruction_bin_op_repeat1] = "instruction_bin_op_repeat1",
  [aux_sym_instruction_switch_repeat1] = "instruction_switch_repeat1",
  [aux_sym_instruction_callbr_repeat1] = "instruction_callbr_repeat1",
  [aux_sym_instruction_phi_repeat1] = "instruction_phi_repeat1",
  [aux_sym_instruction_landingpad_repeat1] = "instruction_landingpad_repeat1",
  [aux_sym_instruction_alloca_repeat1] = "instruction_alloca_repeat1",
  [aux_sym_instruction_getelementptr_repeat1] = "instruction_getelementptr_repeat1",
  [aux_sym_instruction_extractvalue_repeat1] = "instruction_extractvalue_repeat1",
  [aux_sym_operand_bundles_repeat1] = "operand_bundles_repeat1",
  [aux_sym_global_global_repeat1] = "global_global_repeat1",
  [aux_sym_metadata_tuple_repeat1] = "metadata_tuple_repeat1",
  [aux_sym_specialized_md_repeat1] = "specialized_md_repeat1",
  [aux_sym_summary_entry_repeat1] = "summary_entry_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_comment] = sym_comment,
  [sym_attr_ref] = sym_attr_ref,
  [sym_comdat_ref] = sym_comdat_ref,
  [sym_global_var] = sym_global_var,
  [sym_local_var] = sym_local_var,
  [sym_label] = sym_label,
  [aux_sym_metadata_ref_token1] = aux_sym_metadata_ref_token1,
  [sym_summary_ref] = sym_summary_ref,
  [sym_string] = sym_string,
  [aux_sym_number_token1] = aux_sym_number_token1,
  [aux_sym_number_token2] = aux_sym_number_token2,
  [sym_float] = sym_float,
  [sym_cstring] = sym_cstring,
  [anon_sym_target] = anon_sym_target,
  [anon_sym_triple] = anon_sym_triple,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_datalayout] = anon_sym_datalayout,
  [anon_sym_source_filename] = anon_sym_source_filename,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_no_cfi] = anon_sym_no_cfi,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_weak] = anon_sym_weak,
  [anon_sym_weak_odr] = anon_sym_weak_odr,
  [anon_sym_linkonce] = anon_sym_linkonce,
  [anon_sym_linkonce_odr] = anon_sym_linkonce_odr,
  [anon_sym_available_externally] = anon_sym_available_externally,
  [anon_sym_appending] = anon_sym_appending,
  [anon_sym_common] = anon_sym_common,
  [anon_sym_extern_weak] = anon_sym_extern_weak,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_dso_local] = anon_sym_dso_local,
  [anon_sym_dso_local_equivalent] = anon_sym_dso_local_equivalent,
  [anon_sym_dso_preemptable] = anon_sym_dso_preemptable,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_hidden] = anon_sym_hidden,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_dllimport] = anon_sym_dllimport,
  [anon_sym_dllexport] = anon_sym_dllexport,
  [anon_sym_ccc] = anon_sym_ccc,
  [anon_sym_fastcc] = anon_sym_fastcc,
  [anon_sym_coldcc] = anon_sym_coldcc,
  [anon_sym_webkit_jscc] = anon_sym_webkit_jscc,
  [anon_sym_anyregcc] = anon_sym_anyregcc,
  [anon_sym_preserve_mostcc] = anon_sym_preserve_mostcc,
  [anon_sym_preserve_allcc] = anon_sym_preserve_allcc,
  [anon_sym_cxx_fast_tlscc] = anon_sym_cxx_fast_tlscc,
  [anon_sym_tailcc] = anon_sym_tailcc,
  [anon_sym_swiftcc] = anon_sym_swiftcc,
  [anon_sym_swifttailcc] = anon_sym_swifttailcc,
  [anon_sym_cfguard_checkcc] = anon_sym_cfguard_checkcc,
  [aux_sym_calling_conv_token1] = aux_sym_calling_conv_token1,
  [aux_sym_calling_conv_token2] = aux_sym_calling_conv_token2,
  [aux_sym_calling_conv_token3] = aux_sym_calling_conv_token3,
  [aux_sym_calling_conv_token4] = aux_sym_calling_conv_token4,
  [aux_sym_calling_conv_token5] = aux_sym_calling_conv_token5,
  [aux_sym_calling_conv_token6] = aux_sym_calling_conv_token6,
  [aux_sym_calling_conv_token7] = aux_sym_calling_conv_token7,
  [aux_sym_calling_conv_token8] = aux_sym_calling_conv_token8,
  [aux_sym_calling_conv_token9] = aux_sym_calling_conv_token9,
  [aux_sym_calling_conv_token10] = aux_sym_calling_conv_token10,
  [anon_sym_ghccc] = anon_sym_ghccc,
  [aux_sym_calling_conv_token11] = aux_sym_calling_conv_token11,
  [aux_sym_calling_conv_token12] = aux_sym_calling_conv_token12,
  [aux_sym_calling_conv_token13] = aux_sym_calling_conv_token13,
  [aux_sym_calling_conv_token14] = aux_sym_calling_conv_token14,
  [anon_sym_cc] = anon_sym_cc,
  [anon_sym_unnamed_addr] = anon_sym_unnamed_addr,
  [anon_sym_local_unnamed_addr] = anon_sym_local_unnamed_addr,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_half] = anon_sym_half,
  [anon_sym_bfloat] = anon_sym_bfloat,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_x86_fp80] = anon_sym_x86_fp80,
  [anon_sym_fp128] = anon_sym_fp128,
  [anon_sym_ppc_fp128] = anon_sym_ppc_fp128,
  [anon_sym_label] = anon_sym_label,
  [anon_sym_metadata] = anon_sym_metadata,
  [anon_sym_x86_mmx] = anon_sym_x86_mmx,
  [anon_sym_x86_amx] = anon_sym_x86_amx,
  [anon_sym_token] = anon_sym_token,
  [anon_sym_opaque] = anon_sym_opaque,
  [anon_sym_ptr] = anon_sym_ptr,
  [aux_sym_type_keyword_token1] = aux_sym_type_keyword_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_LBRACE] = anon_sym_LT_LBRACE,
  [anon_sym_RBRACE_GT] = anon_sym_RBRACE_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_vscale] = anon_sym_vscale,
  [anon_sym_x] = anon_sym_x,
  [anon_sym_addrspace] = anon_sym_addrspace,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_align] = anon_sym_align,
  [anon_sym_section] = anon_sym_section,
  [anon_sym_partition] = anon_sym_partition,
  [anon_sym_comdat] = anon_sym_comdat,
  [anon_sym_gc] = anon_sym_gc,
  [anon_sym_prefix] = anon_sym_prefix,
  [anon_sym_prologue] = anon_sym_prologue,
  [anon_sym_personality] = anon_sym_personality,
  [anon_sym_alignstack] = anon_sym_alignstack,
  [anon_sym_allocsize] = anon_sym_allocsize,
  [anon_sym_alwaysinline] = anon_sym_alwaysinline,
  [anon_sym_builtin] = anon_sym_builtin,
  [anon_sym_cold] = anon_sym_cold,
  [anon_sym_convergent] = anon_sym_convergent,
  [anon_sym_disable_sanitizer_instrumentation] = anon_sym_disable_sanitizer_instrumentation,
  [anon_sym_hot] = anon_sym_hot,
  [anon_sym_inaccessiblememonly] = anon_sym_inaccessiblememonly,
  [anon_sym_inaccessiblemem_or_argmemonly] = anon_sym_inaccessiblemem_or_argmemonly,
  [anon_sym_inlinehint] = anon_sym_inlinehint,
  [anon_sym_jumptable] = anon_sym_jumptable,
  [anon_sym_minsize] = anon_sym_minsize,
  [anon_sym_naked] = anon_sym_naked,
  [anon_sym_no_DASHjump_DASHtables] = anon_sym_no_DASHjump_DASHtables,
  [anon_sym_nobuiltin] = anon_sym_nobuiltin,
  [anon_sym_noduplicate] = anon_sym_noduplicate,
  [anon_sym_nofree] = anon_sym_nofree,
  [anon_sym_noimplicitfloat] = anon_sym_noimplicitfloat,
  [anon_sym_noinline] = anon_sym_noinline,
  [anon_sym_nomerge] = anon_sym_nomerge,
  [anon_sym_nonlazybind] = anon_sym_nonlazybind,
  [anon_sym_noprofile] = anon_sym_noprofile,
  [anon_sym_noredzone] = anon_sym_noredzone,
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = anon_sym_indirect_DASHtls_DASHseg_DASHrefs,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_norecurse] = anon_sym_norecurse,
  [anon_sym_willreturn] = anon_sym_willreturn,
  [anon_sym_nosync] = anon_sym_nosync,
  [anon_sym_nounwind] = anon_sym_nounwind,
  [anon_sym_nosanitize_coverage] = anon_sym_nosanitize_coverage,
  [anon_sym_null_pointer_is_valid] = anon_sym_null_pointer_is_valid,
  [anon_sym_optforfuzzing] = anon_sym_optforfuzzing,
  [anon_sym_optnone] = anon_sym_optnone,
  [anon_sym_optsize] = anon_sym_optsize,
  [anon_sym_readnone] = anon_sym_readnone,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_writeonly] = anon_sym_writeonly,
  [anon_sym_argmemonly] = anon_sym_argmemonly,
  [anon_sym_returns_twice] = anon_sym_returns_twice,
  [anon_sym_safestack] = anon_sym_safestack,
  [anon_sym_sanitize_address] = anon_sym_sanitize_address,
  [anon_sym_sanitize_memory] = anon_sym_sanitize_memory,
  [anon_sym_sanitize_thread] = anon_sym_sanitize_thread,
  [anon_sym_sanitize_hwaddress] = anon_sym_sanitize_hwaddress,
  [anon_sym_sanitize_memtag] = anon_sym_sanitize_memtag,
  [anon_sym_speculative_load_hardening] = anon_sym_speculative_load_hardening,
  [anon_sym_speculatable] = anon_sym_speculatable,
  [anon_sym_ssp] = anon_sym_ssp,
  [anon_sym_sspstrong] = anon_sym_sspstrong,
  [anon_sym_sspreq] = anon_sym_sspreq,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_uwtable] = anon_sym_uwtable,
  [anon_sym_nocf_check] = anon_sym_nocf_check,
  [anon_sym_shadowcallstack] = anon_sym_shadowcallstack,
  [anon_sym_mustprogress] = anon_sym_mustprogress,
  [anon_sym_vscale_range] = anon_sym_vscale_range,
  [anon_sym_preallocated] = anon_sym_preallocated,
  [anon_sym_zeroext] = anon_sym_zeroext,
  [anon_sym_signext] = anon_sym_signext,
  [anon_sym_inreg] = anon_sym_inreg,
  [anon_sym_byval] = anon_sym_byval,
  [anon_sym_byref] = anon_sym_byref,
  [anon_sym_inalloca] = anon_sym_inalloca,
  [anon_sym_sret] = anon_sym_sret,
  [anon_sym_elementtype] = anon_sym_elementtype,
  [anon_sym_noalias] = anon_sym_noalias,
  [anon_sym_nocapture] = anon_sym_nocapture,
  [anon_sym_nest] = anon_sym_nest,
  [anon_sym_returned] = anon_sym_returned,
  [anon_sym_nonnull] = anon_sym_nonnull,
  [anon_sym_dereferenceable] = anon_sym_dereferenceable,
  [anon_sym_dereferenceable_or_null] = anon_sym_dereferenceable_or_null,
  [anon_sym_swiftself] = anon_sym_swiftself,
  [anon_sym_swiftasync] = anon_sym_swiftasync,
  [anon_sym_swifterror] = anon_sym_swifterror,
  [anon_sym_immarg] = anon_sym_immarg,
  [anon_sym_noundef] = anon_sym_noundef,
  [anon_sym_unreachable] = anon_sym_unreachable,
  [anon_sym_ret] = anon_sym_ret,
  [anon_sym_br] = anon_sym_br,
  [anon_sym_resume] = anon_sym_resume,
  [anon_sym_freeze] = anon_sym_freeze,
  [anon_sym_indirectbr] = anon_sym_indirectbr,
  [anon_sym_extractelement] = anon_sym_extractelement,
  [anon_sym_insertelement] = anon_sym_insertelement,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_shufflevector] = anon_sym_shufflevector,
  [anon_sym_fneg] = anon_sym_fneg,
  [anon_sym_nsw] = anon_sym_nsw,
  [anon_sym_nuw] = anon_sym_nuw,
  [anon_sym_exact] = anon_sym_exact,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_invoke] = anon_sym_invoke,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_unwind] = anon_sym_unwind,
  [anon_sym_cleanupret] = anon_sym_cleanupret,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_catchret] = anon_sym_catchret,
  [anon_sym_catchswitch] = anon_sym_catchswitch,
  [anon_sym_catchpad] = anon_sym_catchpad,
  [anon_sym_cleanuppad] = anon_sym_cleanuppad,
  [anon_sym_callbr] = anon_sym_callbr,
  [anon_sym_icmp] = anon_sym_icmp,
  [anon_sym_fcmp] = anon_sym_fcmp,
  [anon_sym_va_arg] = anon_sym_va_arg,
  [anon_sym_phi] = anon_sym_phi,
  [anon_sym_landingpad] = anon_sym_landingpad,
  [anon_sym_cleanup] = anon_sym_cleanup,
  [anon_sym_tail] = anon_sym_tail,
  [anon_sym_musttail] = anon_sym_musttail,
  [anon_sym_notail] = anon_sym_notail,
  [anon_sym_call] = anon_sym_call,
  [anon_sym_alloca] = anon_sym_alloca,
  [anon_sym_load] = anon_sym_load,
  [anon_sym_atomic] = anon_sym_atomic,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_store] = anon_sym_store,
  [anon_sym_cmpxchg] = anon_sym_cmpxchg,
  [anon_sym_atomicrmw] = anon_sym_atomicrmw,
  [anon_sym_fence] = anon_sym_fence,
  [anon_sym_getelementptr] = anon_sym_getelementptr,
  [anon_sym_inbounds] = anon_sym_inbounds,
  [anon_sym_inrange] = anon_sym_inrange,
  [anon_sym_extractvalue] = anon_sym_extractvalue,
  [anon_sym_insertvalue] = anon_sym_insertvalue,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_none] = anon_sym_none,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_poison] = anon_sym_poison,
  [anon_sym_zeroinitializer] = anon_sym_zeroinitializer,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_filter] = anon_sym_filter,
  [anon_sym_blockaddress] = anon_sym_blockaddress,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_urem] = anon_sym_urem,
  [anon_sym_srem] = anon_sym_srem,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_udiv] = anon_sym_udiv,
  [anon_sym_sdiv] = anon_sym_sdiv,
  [anon_sym_lshr] = anon_sym_lshr,
  [anon_sym_ashr] = anon_sym_ashr,
  [anon_sym_fmul] = anon_sym_fmul,
  [anon_sym_fdiv] = anon_sym_fdiv,
  [anon_sym_frem] = anon_sym_frem,
  [anon_sym_xchg] = anon_sym_xchg,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_nand] = anon_sym_nand,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_max] = anon_sym_max,
  [anon_sym_min] = anon_sym_min,
  [anon_sym_umax] = anon_sym_umax,
  [anon_sym_umin] = anon_sym_umin,
  [anon_sym_fadd] = anon_sym_fadd,
  [anon_sym_fsub] = anon_sym_fsub,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_ne] = anon_sym_ne,
  [anon_sym_ugt] = anon_sym_ugt,
  [anon_sym_uge] = anon_sym_uge,
  [anon_sym_ult] = anon_sym_ult,
  [anon_sym_ule] = anon_sym_ule,
  [anon_sym_sgt] = anon_sym_sgt,
  [anon_sym_sge] = anon_sym_sge,
  [anon_sym_slt] = anon_sym_slt,
  [anon_sym_sle] = anon_sym_sle,
  [anon_sym_oeq] = anon_sym_oeq,
  [anon_sym_ogt] = anon_sym_ogt,
  [anon_sym_oge] = anon_sym_oge,
  [anon_sym_olt] = anon_sym_olt,
  [anon_sym_ole] = anon_sym_ole,
  [anon_sym_one] = anon_sym_one,
  [anon_sym_ord] = anon_sym_ord,
  [anon_sym_ueq] = anon_sym_ueq,
  [anon_sym_une] = anon_sym_une,
  [anon_sym_uno] = anon_sym_uno,
  [anon_sym_bitcast] = anon_sym_bitcast,
  [anon_sym_trunc] = anon_sym_trunc,
  [anon_sym_zext] = anon_sym_zext,
  [anon_sym_sext] = anon_sym_sext,
  [anon_sym_fptrunc] = anon_sym_fptrunc,
  [anon_sym_fpext] = anon_sym_fpext,
  [anon_sym_addrspacecast] = anon_sym_addrspacecast,
  [anon_sym_uitofp] = anon_sym_uitofp,
  [anon_sym_sitofp] = anon_sym_sitofp,
  [anon_sym_fptoui] = anon_sym_fptoui,
  [anon_sym_fptosi] = anon_sym_fptosi,
  [anon_sym_inttoptr] = anon_sym_inttoptr,
  [anon_sym_ptrtoint] = anon_sym_ptrtoint,
  [anon_sym_unordered] = anon_sym_unordered,
  [anon_sym_monotonic] = anon_sym_monotonic,
  [anon_sym_acquire] = anon_sym_acquire,
  [anon_sym_release] = anon_sym_release,
  [anon_sym_acq_rel] = anon_sym_acq_rel,
  [anon_sym_seq_cst] = anon_sym_seq_cst,
  [anon_sym_syncscope] = anon_sym_syncscope,
  [anon_sym_nnan] = anon_sym_nnan,
  [anon_sym_ninf] = anon_sym_ninf,
  [anon_sym_nsz] = anon_sym_nsz,
  [anon_sym_arcp] = anon_sym_arcp,
  [anon_sym_contract] = anon_sym_contract,
  [anon_sym_afn] = anon_sym_afn,
  [anon_sym_reassoc] = anon_sym_reassoc,
  [anon_sym_fast] = anon_sym_fast,
  [anon_sym_within] = anon_sym_within,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_uselistorder] = anon_sym_uselistorder,
  [anon_sym_uselistorder_bb] = anon_sym_uselistorder_bb,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym_sideeffect] = anon_sym_sideeffect,
  [anon_sym_inteldialect] = anon_sym_inteldialect,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_externally_initialized] = anon_sym_externally_initialized,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_ifunc] = anon_sym_ifunc,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym_localdynamic] = anon_sym_localdynamic,
  [anon_sym_initialexec] = anon_sym_initialexec,
  [anon_sym_localexec] = anon_sym_localexec,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_exactmatch] = anon_sym_exactmatch,
  [anon_sym_largest] = anon_sym_largest,
  [anon_sym_nodeduplicate] = anon_sym_nodeduplicate,
  [anon_sym_samesize] = anon_sym_samesize,
  [anon_sym_distinct] = anon_sym_distinct,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [aux_sym_specialized_md_value_token1] = aux_sym_specialized_md_value_token1,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_attributes] = anon_sym_attributes,
  [sym_module] = sym_module,
  [sym_metadata_ref] = sym_metadata_ref,
  [sym_metadata_name] = sym_metadata_name,
  [sym_number] = sym_number,
  [sym_var] = sym_var,
  [sym_target_definition] = sym_target_definition,
  [sym_target_triple] = sym_target_triple,
  [sym_data_layout] = sym_data_layout,
  [sym_source_file_name] = sym_source_file_name,
  [sym_declare] = sym_declare,
  [sym_define] = sym_define,
  [sym_metadata_attachment] = sym_metadata_attachment,
  [sym_function_header] = sym_function_header,
  [sym_linkage] = sym_linkage,
  [sym_linkage_aux] = sym_linkage_aux,
  [sym_dso_local] = sym_dso_local,
  [sym_visibility] = sym_visibility,
  [sym_dll_storage_class] = sym_dll_storage_class,
  [sym_calling_conv] = sym_calling_conv,
  [sym_unnamed_addr] = sym_unnamed_addr,
  [sym_type] = sym_type,
  [sym_type_keyword] = sym_type_keyword,
  [sym_struct_type] = sym_struct_type,
  [sym_packed_struct_type] = sym_packed_struct_type,
  [sym_array_type] = sym_array_type,
  [sym_vector_type] = sym_vector_type,
  [sym_struct_body] = sym_struct_body,
  [sym_array_vector_body] = sym_array_vector_body,
  [sym_addrspace] = sym_addrspace,
  [sym_argument_list] = sym_argument_list,
  [sym_argument] = sym_argument,
  [sym_param_or_return_attrs] = sym_param_or_return_attrs,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym_function_body] = sym_function_body,
  [sym_instruction] = sym_instruction,
  [sym__instruction_body] = sym__instruction_body,
  [sym_instruction_unreachable] = sym_instruction_unreachable,
  [sym_instruction_ret] = sym_instruction_ret,
  [sym_instruction_br] = sym_instruction_br,
  [sym_instruction_resume] = sym_instruction_resume,
  [sym_instruction_freeze] = sym_instruction_freeze,
  [sym_instruction_indirectbr] = sym_instruction_indirectbr,
  [sym_instruction_extractelement] = sym_instruction_extractelement,
  [sym_instruction_insertelement] = sym_instruction_insertelement,
  [sym_instruction_select] = sym_instruction_select,
  [sym_instruction_shufflevector] = sym_instruction_shufflevector,
  [sym_instruction_fneg] = sym_instruction_fneg,
  [sym_instruction_bin_op] = sym_instruction_bin_op,
  [sym_instruction_switch] = sym_instruction_switch,
  [sym_instruction_invoke] = sym_instruction_invoke,
  [sym_instruction_cleanupret] = sym_instruction_cleanupret,
  [sym_instruction_catchret] = sym_instruction_catchret,
  [sym_instruction_catchswitch] = sym_instruction_catchswitch,
  [sym_instruction_catchpad] = sym_instruction_catchpad,
  [sym_instruction_cleanuppad] = sym_instruction_cleanuppad,
  [sym_instruction_callbr] = sym_instruction_callbr,
  [sym_instruction_icmp] = sym_instruction_icmp,
  [sym_instruction_fcmp] = sym_instruction_fcmp,
  [sym_instruction_cast] = sym_instruction_cast,
  [sym_instruction_va_arg] = sym_instruction_va_arg,
  [sym_instruction_phi] = sym_instruction_phi,
  [sym_instruction_landingpad] = sym_instruction_landingpad,
  [sym_instruction_call] = sym_instruction_call,
  [sym_instruction_alloca] = sym_instruction_alloca,
  [sym_instruction_load] = sym_instruction_load,
  [sym_instruction_store] = sym_instruction_store,
  [sym_instruction_cmpxchg] = sym_instruction_cmpxchg,
  [sym_instruction_atomicrmw] = sym_instruction_atomicrmw,
  [sym_instruction_fence] = sym_instruction_fence,
  [sym_instruction_getelementptr] = sym_instruction_getelementptr,
  [sym_instruction_extractvalue] = sym_instruction_extractvalue,
  [sym_instruction_insertvalue] = sym_instruction_insertvalue,
  [sym__call_part] = sym__call_part,
  [sym_type_and_value] = sym_type_and_value,
  [sym_value] = sym_value,
  [sym__primitive_value] = sym__primitive_value,
  [sym_struct_value] = sym_struct_value,
  [sym_packed_struct_value] = sym_packed_struct_value,
  [sym_array_value] = sym_array_value,
  [sym_vector_value] = sym_vector_value,
  [sym_metadata_refs] = sym_metadata_refs,
  [sym_operand_bundles] = sym_operand_bundles,
  [sym_landingpad_clause] = sym_landingpad_clause,
  [sym_blockaddress] = sym_blockaddress,
  [sym_constant_expr] = sym_constant_expr,
  [sym_constant_cast] = sym_constant_cast,
  [sym_constant_getelementptr] = sym_constant_getelementptr,
  [sym_constant_select] = sym_constant_select,
  [sym_constant_icmp] = sym_constant_icmp,
  [sym_constant_fcmp] = sym_constant_fcmp,
  [sym_constant_extractelement] = sym_constant_extractelement,
  [sym_constant_insertelement] = sym_constant_insertelement,
  [sym_constant_shufflevector] = sym_constant_shufflevector,
  [sym_constant_extractvalue] = sym_constant_extractvalue,
  [sym_constant_insertvalue] = sym_constant_insertvalue,
  [sym_constant_fneg] = sym_constant_fneg,
  [sym_constant_bin_op] = sym_constant_bin_op,
  [sym_bin_op_keyword] = sym_bin_op_keyword,
  [sym_atomic_bin_op_keyword] = sym_atomic_bin_op_keyword,
  [sym_icmp_cond] = sym_icmp_cond,
  [sym_fcmp_cond] = sym_fcmp_cond,
  [sym_cast_inst] = sym_cast_inst,
  [sym_atomic_ordering] = sym_atomic_ordering,
  [sym_alignment] = sym_alignment,
  [sym__load_store_suffix] = sym__load_store_suffix,
  [sym_syncscope] = sym_syncscope,
  [sym_fast_math] = sym_fast_math,
  [sym__value_array] = sym__value_array,
  [sym__within] = sym__within,
  [sym__unwind_label] = sym__unwind_label,
  [sym_use_list_order] = sym_use_list_order,
  [sym_use_list_order_bb] = sym_use_list_order_bb,
  [sym_module_asm] = sym_module_asm,
  [sym_inline_asm] = sym_inline_asm,
  [sym_asm] = sym_asm,
  [sym_global_type] = sym_global_type,
  [sym__global_prefix] = sym__global_prefix,
  [sym_global_global] = sym_global_global,
  [sym_alias] = sym_alias,
  [sym_ifunc] = sym_ifunc,
  [sym_thread_local] = sym_thread_local,
  [sym_comdat] = sym_comdat,
  [sym_global_metadata] = sym_global_metadata,
  [sym_metadata] = sym_metadata,
  [sym_metadata_tuple] = sym_metadata_tuple,
  [sym_specialized_md] = sym_specialized_md,
  [sym_specialized_md_value] = sym_specialized_md_value,
  [sym_summary_entry] = sym_summary_entry,
  [sym_summary_value] = sym_summary_value,
  [sym_unnamed_attr_grp] = sym_unnamed_attr_grp,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_declare_repeat1] = aux_sym_declare_repeat1,
  [aux_sym_function_header_repeat1] = aux_sym_function_header_repeat1,
  [aux_sym_function_header_repeat2] = aux_sym_function_header_repeat2,
  [aux_sym_function_header_repeat3] = aux_sym_function_header_repeat3,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_type_repeat2] = aux_sym_type_repeat2,
  [aux_sym_struct_body_repeat1] = aux_sym_struct_body_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_function_body_repeat1] = aux_sym_function_body_repeat1,
  [aux_sym_function_body_repeat2] = aux_sym_function_body_repeat2,
  [aux_sym_instruction_repeat1] = aux_sym_instruction_repeat1,
  [aux_sym_instruction_select_repeat1] = aux_sym_instruction_select_repeat1,
  [aux_sym_instruction_bin_op_repeat1] = aux_sym_instruction_bin_op_repeat1,
  [aux_sym_instruction_switch_repeat1] = aux_sym_instruction_switch_repeat1,
  [aux_sym_instruction_callbr_repeat1] = aux_sym_instruction_callbr_repeat1,
  [aux_sym_instruction_phi_repeat1] = aux_sym_instruction_phi_repeat1,
  [aux_sym_instruction_landingpad_repeat1] = aux_sym_instruction_landingpad_repeat1,
  [aux_sym_instruction_alloca_repeat1] = aux_sym_instruction_alloca_repeat1,
  [aux_sym_instruction_getelementptr_repeat1] = aux_sym_instruction_getelementptr_repeat1,
  [aux_sym_instruction_extractvalue_repeat1] = aux_sym_instruction_extractvalue_repeat1,
  [aux_sym_operand_bundles_repeat1] = aux_sym_operand_bundles_repeat1,
  [aux_sym_global_global_repeat1] = aux_sym_global_global_repeat1,
  [aux_sym_metadata_tuple_repeat1] = aux_sym_metadata_tuple_repeat1,
  [aux_sym_specialized_md_repeat1] = aux_sym_specialized_md_repeat1,
  [aux_sym_summary_entry_repeat1] = aux_sym_summary_entry_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_attr_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_comdat_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_global_var] = {
    .visible = true,
    .named = true,
  },
  [sym_local_var] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_metadata_ref_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_summary_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_cstring] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triple] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_datalayout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_source_filename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no_cfi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weak] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weak_odr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linkonce] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linkonce_odr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_available_externally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_appending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_common] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern_weak] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_local_equivalent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_preemptable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dllimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dllexport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ccc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fastcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coldcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_webkit_jscc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyregcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preserve_mostcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preserve_allcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cxx_fast_tlscc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tailcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swifttailcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cfguard_checkcc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_calling_conv_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token6] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token10] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_ghccc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_calling_conv_token11] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token12] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token13] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token14] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_cc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unnamed_addr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local_unnamed_addr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_half] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bfloat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_fp80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fp128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ppc_fp128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_label] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_metadata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_mmx] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_amx] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_token] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opaque] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptr] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_keyword_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vscale] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_section] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partition] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comdat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prefix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prologue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_personality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignstack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_allocsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alwaysinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_builtin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cold] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_convergent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable_sanitizer_instrumentation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inaccessiblememonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inaccessiblemem_or_argmemonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inlinehint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_jumptable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_naked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no_DASHjump_DASHtables] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nobuiltin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noduplicate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nofree] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noimplicitfloat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nomerge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlazybind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noprofile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noredzone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_norecurse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_willreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nounwind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosanitize_coverage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null_pointer_is_valid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optforfuzzing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optnone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readnone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_writeonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_argmemonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returns_twice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_safestack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_address] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_hwaddress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_memtag] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_speculative_load_hardening] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_speculatable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ssp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sspstrong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sspreq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uwtable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nocf_check] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shadowcallstack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mustprogress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vscale_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preallocated] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zeroext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inreg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inalloca] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elementtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nocapture] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nest] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dereferenceable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dereferenceable_or_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftself] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftasync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swifterror] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_immarg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noundef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unreachable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_br] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_resume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_freeze] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indirectbr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extractelement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_insertelement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shufflevector] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fneg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nsw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nuw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exact] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invoke] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unwind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanupret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchswitch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchpad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanuppad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callbr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_icmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fcmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_va_arg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_landingpad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanup] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_musttail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alloca] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_load] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_store] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cmpxchg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomicrmw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fence] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getelementptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inbounds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inrange] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extractvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_insertvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_none] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_poison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zeroinitializer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_filter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blockaddress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_urem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_srem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_udiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lshr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ashr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fmul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_frem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xchg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_max] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_min] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_umax] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_umin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fadd] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fsub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ugt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ult] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_slt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_oeq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ogt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_oge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_olt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ole] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_one] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ord] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ueq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_une] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uno] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptrunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fpext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspacecast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uitofp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sitofp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptoui] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptosi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inttoptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptrtoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_monotonic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_acquire] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_release] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_acq_rel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_seq_cst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_syncscope] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nnan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ninf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nsz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_arcp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_contract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_afn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reassoc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_within] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uselistorder] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uselistorder_bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sideeffect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inteldialect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_externally_initialized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ifunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localdynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_initialexec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localexec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exactmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_largest] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nodeduplicate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_distinct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_specialized_md_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_attributes] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_name] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_target_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_target_triple] = {
    .visible = true,
    .named = true,
  },
  [sym_data_layout] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file_name] = {
    .visible = true,
    .named = true,
  },
  [sym_declare] = {
    .visible = true,
    .named = true,
  },
  [sym_define] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_attachment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_header] = {
    .visible = true,
    .named = true,
  },
  [sym_linkage] = {
    .visible = true,
    .named = true,
  },
  [sym_linkage_aux] = {
    .visible = true,
    .named = true,
  },
  [sym_dso_local] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility] = {
    .visible = true,
    .named = true,
  },
  [sym_dll_storage_class] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_conv] = {
    .visible = true,
    .named = true,
  },
  [sym_unnamed_addr] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_packed_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_body] = {
    .visible = true,
    .named = true,
  },
  [sym_array_vector_body] = {
    .visible = true,
    .named = true,
  },
  [sym_addrspace] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_param_or_return_attrs] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym__instruction_body] = {
    .visible = false,
    .named = true,
  },
  [sym_instruction_unreachable] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_ret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_br] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_resume] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_freeze] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_indirectbr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_extractelement] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_insertelement] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_select] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_shufflevector] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fneg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_bin_op] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_switch] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_invoke] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cleanupret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchswitch] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchpad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cleanuppad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_callbr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_icmp] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fcmp] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_va_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_phi] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_landingpad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_call] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_alloca] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_load] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_store] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cmpxchg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_atomicrmw] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fence] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_getelementptr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_extractvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_insertvalue] = {
    .visible = true,
    .named = true,
  },
  [sym__call_part] = {
    .visible = false,
    .named = true,
  },
  [sym_type_and_value] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym__primitive_value] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_value] = {
    .visible = true,
    .named = true,
  },
  [sym_packed_struct_value] = {
    .visible = true,
    .named = true,
  },
  [sym_array_value] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_value] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_refs] = {
    .visible = true,
    .named = true,
  },
  [sym_operand_bundles] = {
    .visible = true,
    .named = true,
  },
  [sym_landingpad_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_blockaddress] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_getelementptr] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_select] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_icmp] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_fcmp] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_extractelement] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_insertelement] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_shufflevector] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_extractvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_insertvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_fneg] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bin_op] = {
    .visible = true,
    .named = true,
  },
  [sym_bin_op_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_bin_op_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_icmp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_fcmp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_inst] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_ordering] = {
    .visible = true,
    .named = true,
  },
  [sym_alignment] = {
    .visible = true,
    .named = true,
  },
  [sym__load_store_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym_syncscope] = {
    .visible = true,
    .named = true,
  },
  [sym_fast_math] = {
    .visible = true,
    .named = true,
  },
  [sym__value_array] = {
    .visible = false,
    .named = true,
  },
  [sym__within] = {
    .visible = false,
    .named = true,
  },
  [sym__unwind_label] = {
    .visible = false,
    .named = true,
  },
  [sym_use_list_order] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list_order_bb] = {
    .visible = true,
    .named = true,
  },
  [sym_module_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_global_type] = {
    .visible = true,
    .named = true,
  },
  [sym__global_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_global_global] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_ifunc] = {
    .visible = true,
    .named = true,
  },
  [sym_thread_local] = {
    .visible = true,
    .named = true,
  },
  [sym_comdat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_specialized_md] = {
    .visible = true,
    .named = true,
  },
  [sym_specialized_md_value] = {
    .visible = true,
    .named = true,
  },
  [sym_summary_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_summary_value] = {
    .visible = true,
    .named = true,
  },
  [sym_unnamed_attr_grp] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declare_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_select_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_bin_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_switch_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_callbr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_phi_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_landingpad_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_alloca_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_getelementptr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_extractvalue_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operand_bundles_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_global_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_metadata_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_specialized_md_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_summary_entry_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_arguments = 1,
  field_body = 2,
  field_callee = 3,
  field_inst_name = 4,
  field_name = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_callee] = "callee",
  [field_inst_name] = "inst_name",
  [field_name] = "name",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 2},
  [7] = {.index = 8, .length = 3},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 3},
  [10] = {.index = 16, .length = 3},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 3},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 2},
  [17] = {.index = 32, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
  [1] =
    {field_arguments, 2},
    {field_name, 1},
  [3] =
    {field_inst_name, 0},
  [4] =
    {field_body, 3},
  [5] =
    {field_name, 2},
  [6] =
    {field_arguments, 3},
    {field_name, 2},
  [8] =
    {field_arguments, 1, .inherited = true},
    {field_callee, 1, .inherited = true},
    {field_inst_name, 0},
  [11] =
    {field_arguments, 4},
    {field_name, 3},
  [13] =
    {field_arguments, 2, .inherited = true},
    {field_callee, 2, .inherited = true},
    {field_inst_name, 1},
  [16] =
    {field_arguments, 2, .inherited = true},
    {field_callee, 2, .inherited = true},
    {field_inst_name, 0},
  [19] =
    {field_arguments, 5},
    {field_name, 4},
  [21] =
    {field_arguments, 2},
    {field_callee, 1},
  [23] =
    {field_arguments, 3, .inherited = true},
    {field_callee, 3, .inherited = true},
    {field_inst_name, 1},
  [26] =
    {field_arguments, 6},
    {field_name, 5},
  [28] =
    {field_arguments, 3},
    {field_callee, 2},
  [30] =
    {field_arguments, 4},
    {field_callee, 3},
  [32] =
    {field_arguments, 5},
    {field_callee, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1339);
      if (lookahead == 'b') ADVANCE(2015);
      if (lookahead == 'c') ADVANCE(29);
      if (lookahead == 'd') ADVANCE(1383);
      if (lookahead == 'e') ADVANCE(2257);
      if (lookahead == 'f') ADVANCE(1344);
      if (lookahead == 'g') ADVANCE(1576);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(1656);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1345);
      if (lookahead == 'm') ADVANCE(1384);
      if (lookahead == 'n') ADVANCE(1346);
      if (lookahead == 'o') ADVANCE(1852);
      if (lookahead == 'p') ADVANCE(1379);
      if (lookahead == 'r') ADVANCE(1772);
      if (lookahead == 's') ADVANCE(73);
      if (lookahead == 't') ADVANCE(1351);
      if (lookahead == 'u') ADVANCE(84);
      if (lookahead == 'v') ADVANCE(1353);
      if (lookahead == 'w') ADVANCE(1773);
      if (lookahead == 'x') ADVANCE(3273);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3806);
      if (lookahead == '|') ADVANCE(4541);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3025)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(4536);
      if (lookahead == '0') ADVANCE(3062);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3266);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == 'a') ADVANCE(3964);
      if (lookahead == 'b') ADVANCE(4085);
      if (lookahead == 'c') ADVANCE(3808);
      if (lookahead == 'd') ADVANCE(4303);
      if (lookahead == 'f') ADVANCE(3881);
      if (lookahead == 'h') ADVANCE(3882);
      if (lookahead == 'i') ADVANCE(4537);
      if (lookahead == 'l') ADVANCE(3859);
      if (lookahead == 'm') ADVANCE(4044);
      if (lookahead == 'n') ADVANCE(4330);
      if (lookahead == 'o') ADVANCE(4343);
      if (lookahead == 'p') ADVANCE(4321);
      if (lookahead == 's') ADVANCE(3818);
      if (lookahead == 't') ADVANCE(4317);
      if (lookahead == 'u') ADVANCE(3816);
      if (lookahead == 'v') ADVANCE(4323);
      if (lookahead == 'x') ADVANCE(3825);
      if (lookahead == 'z') ADVANCE(4062);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '|') ADVANCE(4541);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3063);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '\\') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(4536);
      if (lookahead == '0') ADVANCE(3062);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3266);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == 'a') ADVANCE(3964);
      if (lookahead == 'b') ADVANCE(4085);
      if (lookahead == 'c') ADVANCE(3808);
      if (lookahead == 'd') ADVANCE(4303);
      if (lookahead == 'f') ADVANCE(3881);
      if (lookahead == 'h') ADVANCE(3882);
      if (lookahead == 'i') ADVANCE(4537);
      if (lookahead == 'l') ADVANCE(3859);
      if (lookahead == 'm') ADVANCE(4044);
      if (lookahead == 'n') ADVANCE(4330);
      if (lookahead == 'o') ADVANCE(4343);
      if (lookahead == 'p') ADVANCE(4321);
      if (lookahead == 's') ADVANCE(3818);
      if (lookahead == 't') ADVANCE(4317);
      if (lookahead == 'u') ADVANCE(3816);
      if (lookahead == 'v') ADVANCE(4323);
      if (lookahead == 'x') ADVANCE(3825);
      if (lookahead == 'z') ADVANCE(4062);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '|') ADVANCE(4541);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3063);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '\\') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1343);
      if (lookahead == 'b') ADVANCE(2016);
      if (lookahead == 'c') ADVANCE(30);
      if (lookahead == 'd') ADVANCE(1846);
      if (lookahead == 'e') ADVANCE(2259);
      if (lookahead == 'f') ADVANCE(1394);
      if (lookahead == 'g') ADVANCE(1865);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(1658);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1419);
      if (lookahead == 'm') ADVANCE(1389);
      if (lookahead == 'n') ADVANCE(1348);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(2509);
      if (lookahead == 'r') ADVANCE(1867);
      if (lookahead == 's') ADVANCE(77);
      if (lookahead == 't') ADVANCE(1504);
      if (lookahead == 'u') ADVANCE(90);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(119);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1690);
      if (lookahead == 'b') ADVANCE(2014);
      if (lookahead == 'c') ADVANCE(35);
      if (lookahead == 'd') ADVANCE(1909);
      if (lookahead == 'e') ADVANCE(2971);
      if (lookahead == 'f') ADVANCE(1376);
      if (lookahead == 'g') ADVANCE(1864);
      if (lookahead == 'h') ADVANCE(1405);
      if (lookahead == 'i') ADVANCE(1662);
      if (lookahead == 'l') ADVANCE(1420);
      if (lookahead == 'm') ADVANCE(1391);
      if (lookahead == 'n') ADVANCE(1470);
      if (lookahead == 'o') ADVANCE(2606);
      if (lookahead == 'p') ADVANCE(2508);
      if (lookahead == 's') ADVANCE(83);
      if (lookahead == 't') ADVANCE(2550);
      if (lookahead == 'u') ADVANCE(91);
      if (lookahead == 'v') ADVANCE(2535);
      if (lookahead == 'w') ADVANCE(1928);
      if (lookahead == 'x') ADVANCE(122);
      if (lookahead == 'z') ADVANCE(1956);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1286);
      if (lookahead == '0') ADVANCE(3057);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(341);
      if (lookahead == 'b') ADVANCE(555);
      if (lookahead == 'c') ADVANCE(26);
      if (lookahead == 'd') ADVANCE(390);
      if (lookahead == 'e') ADVANCE(729);
      if (lookahead == 'f') ADVANCE(150);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'h') ADVANCE(176);
      if (lookahead == 'i') ADVANCE(321);
      if (lookahead == 'j') ADVANCE(1219);
      if (lookahead == 'l') ADVANCE(151);
      if (lookahead == 'm') ADVANCE(152);
      if (lookahead == 'n') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(963);
      if (lookahead == 'p') ADVANCE(159);
      if (lookahead == 'r') ADVANCE(392);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(214);
      if (lookahead == 'u') ADVANCE(68);
      if (lookahead == 'v') ADVANCE(162);
      if (lookahead == 'w') ADVANCE(448);
      if (lookahead == 'x') ADVANCE(114);
      if (lookahead == 'z') ADVANCE(393);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1286);
      if (lookahead == '0') ADVANCE(3057);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(287);
      if (lookahead == 'b') ADVANCE(556);
      if (lookahead == 'c') ADVANCE(28);
      if (lookahead == 'd') ADVANCE(486);
      if (lookahead == 'e') ADVANCE(1254);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'g') ADVANCE(450);
      if (lookahead == 'h') ADVANCE(177);
      if (lookahead == 'i') ADVANCE(324);
      if (lookahead == 'l') ADVANCE(151);
      if (lookahead == 'm') ADVANCE(153);
      if (lookahead == 'n') ADVANCE(212);
      if (lookahead == 'o') ADVANCE(980);
      if (lookahead == 'p') ADVANCE(606);
      if (lookahead == 'r') ADVANCE(443);
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(214);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'v') ADVANCE(163);
      if (lookahead == 'w') ADVANCE(449);
      if (lookahead == 'x') ADVANCE(114);
      if (lookahead == 'z') ADVANCE(524);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '0') ADVANCE(3067);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1744);
      if (lookahead == 'b') ADVANCE(2013);
      if (lookahead == 'c') ADVANCE(2569);
      if (lookahead == 'd') ADVANCE(2141);
      if (lookahead == 'e') ADVANCE(2974);
      if (lookahead == 'f') ADVANCE(1395);
      if (lookahead == 'h') ADVANCE(1403);
      if (lookahead == 'i') ADVANCE(3011);
      if (lookahead == 'l') ADVANCE(1417);
      if (lookahead == 'm') ADVANCE(1952);
      if (lookahead == 'n') ADVANCE(2115);
      if (lookahead == 'o') ADVANCE(1854);
      if (lookahead == 'p') ADVANCE(2594);
      if (lookahead == 'r') ADVANCE(1940);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 't') ADVANCE(2551);
      if (lookahead == 'u') ADVANCE(92);
      if (lookahead == 'v') ADVANCE(2537);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(3013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1342);
      if (lookahead == 'b') ADVANCE(2016);
      if (lookahead == 'c') ADVANCE(31);
      if (lookahead == 'd') ADVANCE(1846);
      if (lookahead == 'e') ADVANCE(2259);
      if (lookahead == 'f') ADVANCE(1393);
      if (lookahead == 'g') ADVANCE(1865);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(1657);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1419);
      if (lookahead == 'm') ADVANCE(1388);
      if (lookahead == 'n') ADVANCE(1348);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(2509);
      if (lookahead == 'r') ADVANCE(1847);
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 't') ADVANCE(1504);
      if (lookahead == 'u') ADVANCE(86);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(119);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1342);
      if (lookahead == 'b') ADVANCE(2016);
      if (lookahead == 'c') ADVANCE(31);
      if (lookahead == 'd') ADVANCE(1846);
      if (lookahead == 'e') ADVANCE(2259);
      if (lookahead == 'f') ADVANCE(1393);
      if (lookahead == 'g') ADVANCE(1865);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(1657);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1419);
      if (lookahead == 'm') ADVANCE(1388);
      if (lookahead == 'n') ADVANCE(1348);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(2509);
      if (lookahead == 'r') ADVANCE(1847);
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 't') ADVANCE(1504);
      if (lookahead == 'u') ADVANCE(86);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(119);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(1770);
      if (lookahead == 'b') ADVANCE(2102);
      if (lookahead == 'c') ADVANCE(35);
      if (lookahead == 'd') ADVANCE(1910);
      if (lookahead == 'e') ADVANCE(2971);
      if (lookahead == 'f') ADVANCE(1377);
      if (lookahead == 'g') ADVANCE(1864);
      if (lookahead == 'h') ADVANCE(2111);
      if (lookahead == 'i') ADVANCE(1661);
      if (lookahead == 'l') ADVANCE(2112);
      if (lookahead == 'm') ADVANCE(1392);
      if (lookahead == 'n') ADVANCE(1470);
      if (lookahead == 'o') ADVANCE(2633);
      if (lookahead == 'p') ADVANCE(2510);
      if (lookahead == 's') ADVANCE(83);
      if (lookahead == 't') ADVANCE(2671);
      if (lookahead == 'u') ADVANCE(91);
      if (lookahead == 'w') ADVANCE(1928);
      if (lookahead == 'x') ADVANCE(1599);
      if (lookahead == 'z') ADVANCE(1956);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '+') ADVANCE(3013);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(4535);
      if (lookahead == '0') ADVANCE(3068);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(4166);
      if (lookahead == 'b') ADVANCE(4479);
      if (lookahead == 'c') ADVANCE(4296);
      if (lookahead == 'd') ADVANCE(4004);
      if (lookahead == 'e') ADVANCE(4176);
      if (lookahead == 'h') ADVANCE(4298);
      if (lookahead == 'i') ADVANCE(4225);
      if (lookahead == 'j') ADVANCE(4480);
      if (lookahead == 'l') ADVANCE(4107);
      if (lookahead == 'm') ADVANCE(4110);
      if (lookahead == 'n') ADVANCE(3848);
      if (lookahead == 'o') ADVANCE(4338);
      if (lookahead == 'p') ADVANCE(4358);
      if (lookahead == 'r') ADVANCE(3970);
      if (lookahead == 's') ADVANCE(3815);
      if (lookahead == 'u') ADVANCE(3817);
      if (lookahead == 'v') ADVANCE(4401);
      if (lookahead == 'w') ADVANCE(4009);
      if (lookahead == 'z') ADVANCE(4013);
      if (lookahead == '{') ADVANCE(3806);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3070);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '_') ||
          ('f' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '+') ADVANCE(3013);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(4535);
      if (lookahead == '0') ADVANCE(3068);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(4166);
      if (lookahead == 'b') ADVANCE(4479);
      if (lookahead == 'c') ADVANCE(4296);
      if (lookahead == 'd') ADVANCE(4004);
      if (lookahead == 'e') ADVANCE(4176);
      if (lookahead == 'h') ADVANCE(4298);
      if (lookahead == 'i') ADVANCE(4225);
      if (lookahead == 'j') ADVANCE(4480);
      if (lookahead == 'l') ADVANCE(4107);
      if (lookahead == 'm') ADVANCE(4110);
      if (lookahead == 'n') ADVANCE(3848);
      if (lookahead == 'o') ADVANCE(4338);
      if (lookahead == 'p') ADVANCE(4358);
      if (lookahead == 'r') ADVANCE(3970);
      if (lookahead == 's') ADVANCE(3815);
      if (lookahead == 'u') ADVANCE(3817);
      if (lookahead == 'v') ADVANCE(4401);
      if (lookahead == 'w') ADVANCE(4009);
      if (lookahead == 'z') ADVANCE(4013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3070);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '_') ||
          ('f' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(3055);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(3049);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(3039);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(3045);
      if (lookahead != 0) ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(3042);
      if (lookahead != 0) ADVANCE(17);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(3052);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(3080);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(3056);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3051);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3040);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3041);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3046);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3047);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3044);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3053);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3054);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(733);
      if (lookahead == 'l') ADVANCE(457);
      if (lookahead == 'm') ADVANCE(974);
      if (lookahead == 'o') ADVANCE(731);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(734);
      if (lookahead == 'l') ADVANCE(457);
      if (lookahead == 'm') ADVANCE(974);
      if (lookahead == 'o') ADVANCE(731);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 28:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(734);
      if (lookahead == 'l') ADVANCE(457);
      if (lookahead == 'm') ADVANCE(974);
      if (lookahead == 'o') ADVANCE(826);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 29:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2266);
      if (lookahead == 'c') ADVANCE(3204);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'l') ADVANCE(1950);
      if (lookahead == 'm') ADVANCE(2597);
      if (lookahead == 'o') ADVANCE(2263);
      if (lookahead == 'x') ADVANCE(2965);
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2347);
      if (lookahead == 'c') ADVANCE(3204);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'o') ADVANCE(2265);
      if (lookahead == 'x') ADVANCE(2965);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2306);
      if (lookahead == 'c') ADVANCE(3204);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'l') ADVANCE(1950);
      if (lookahead == 'o') ADVANCE(2265);
      if (lookahead == 'x') ADVANCE(2965);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2267);
      if (lookahead == 'l') ADVANCE(1983);
      if (lookahead == 'm') ADVANCE(2597);
      if (lookahead == 'o') ADVANCE(2300);
      END_STATE();
    case 33:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2883);
      if (lookahead == 'l') ADVANCE(1950);
      if (lookahead == 'o') ADVANCE(2301);
      END_STATE();
    case 34:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2883);
      if (lookahead == 'l') ADVANCE(1950);
      if (lookahead == 'o') ADVANCE(2404);
      END_STATE();
    case 35:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'o') ADVANCE(2404);
      END_STATE();
    case 36:
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1286);
      if (lookahead == '0') ADVANCE(3057);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(288);
      if (lookahead == 'b') ADVANCE(617);
      if (lookahead == 'c') ADVANCE(27);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(729);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'h') ADVANCE(627);
      if (lookahead == 'i') ADVANCE(322);
      if (lookahead == 'j') ADVANCE(1219);
      if (lookahead == 'l') ADVANCE(245);
      if (lookahead == 'm') ADVANCE(154);
      if (lookahead == 'n') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(981);
      if (lookahead == 'p') ADVANCE(160);
      if (lookahead == 'r') ADVANCE(439);
      if (lookahead == 's') ADVANCE(66);
      if (lookahead == 't') ADVANCE(215);
      if (lookahead == 'u') ADVANCE(69);
      if (lookahead == 'v') ADVANCE(164);
      if (lookahead == 'w') ADVANCE(448);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == 'z') ADVANCE(393);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 37:
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '+') ADVANCE(3013);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1288);
      if (lookahead == '0') ADVANCE(3064);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(389);
      if (lookahead == 'b') ADVANCE(619);
      if (lookahead == 'c') ADVANCE(147);
      if (lookahead == 'd') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(730);
      if (lookahead == 'f') ADVANCE(224);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'h') ADVANCE(910);
      if (lookahead == 'i') ADVANCE(323);
      if (lookahead == 'j') ADVANCE(1219);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'm') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(158);
      if (lookahead == 'o') ADVANCE(981);
      if (lookahead == 'p') ADVANCE(161);
      if (lookahead == 'r') ADVANCE(392);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(216);
      if (lookahead == 'u') ADVANCE(71);
      if (lookahead == 'v') ADVANCE(164);
      if (lookahead == 'w') ADVANCE(664);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == 'z') ADVANCE(512);
      if (lookahead == '{') ADVANCE(3806);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3065);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 38:
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == '+') ADVANCE(3013);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1288);
      if (lookahead == '0') ADVANCE(3064);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(389);
      if (lookahead == 'b') ADVANCE(619);
      if (lookahead == 'c') ADVANCE(147);
      if (lookahead == 'd') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(730);
      if (lookahead == 'f') ADVANCE(224);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'h') ADVANCE(910);
      if (lookahead == 'i') ADVANCE(323);
      if (lookahead == 'j') ADVANCE(1219);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'm') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(158);
      if (lookahead == 'o') ADVANCE(981);
      if (lookahead == 'p') ADVANCE(161);
      if (lookahead == 'r') ADVANCE(392);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead == 't') ADVANCE(216);
      if (lookahead == 'u') ADVANCE(71);
      if (lookahead == 'v') ADVANCE(164);
      if (lookahead == 'w') ADVANCE(664);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == 'z') ADVANCE(512);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3065);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 39:
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1286);
      if (lookahead == '0') ADVANCE(3057);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(288);
      if (lookahead == 'b') ADVANCE(617);
      if (lookahead == 'c') ADVANCE(27);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == 'e') ADVANCE(729);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'g') ADVANCE(277);
      if (lookahead == 'h') ADVANCE(627);
      if (lookahead == 'i') ADVANCE(322);
      if (lookahead == 'j') ADVANCE(1219);
      if (lookahead == 'l') ADVANCE(245);
      if (lookahead == 'm') ADVANCE(154);
      if (lookahead == 'n') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(981);
      if (lookahead == 'p') ADVANCE(160);
      if (lookahead == 'r') ADVANCE(439);
      if (lookahead == 's') ADVANCE(66);
      if (lookahead == 't') ADVANCE(215);
      if (lookahead == 'u') ADVANCE(69);
      if (lookahead == 'v') ADVANCE(164);
      if (lookahead == 'w') ADVANCE(448);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == 'z') ADVANCE(393);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 40:
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == '+') ADVANCE(3009);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '-') ADVANCE(1286);
      if (lookahead == '0') ADVANCE(3057);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'a') ADVANCE(289);
      if (lookahead == 'b') ADVANCE(618);
      if (lookahead == 'c') ADVANCE(28);
      if (lookahead == 'd') ADVANCE(487);
      if (lookahead == 'e') ADVANCE(1254);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'g') ADVANCE(450);
      if (lookahead == 'h') ADVANCE(628);
      if (lookahead == 'i') ADVANCE(325);
      if (lookahead == 'l') ADVANCE(245);
      if (lookahead == 'm') ADVANCE(156);
      if (lookahead == 'n') ADVANCE(212);
      if (lookahead == 'o') ADVANCE(1000);
      if (lookahead == 'p') ADVANCE(607);
      if (lookahead == 'r') ADVANCE(443);
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(215);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'v') ADVANCE(165);
      if (lookahead == 'w') ADVANCE(449);
      if (lookahead == 'x') ADVANCE(284);
      if (lookahead == 'z') ADVANCE(524);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(40)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 41:
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == 'b') ADVANCE(2013);
      if (lookahead == 'd') ADVANCE(2506);
      if (lookahead == 'f') ADVANCE(2255);
      if (lookahead == 'h') ADVANCE(1403);
      if (lookahead == 'i') ADVANCE(3011);
      if (lookahead == 'l') ADVANCE(1417);
      if (lookahead == 'm') ADVANCE(1952);
      if (lookahead == 'o') ADVANCE(2605);
      if (lookahead == 'p') ADVANCE(2594);
      if (lookahead == 't') ADVANCE(2549);
      if (lookahead == 'v') ADVANCE(2535);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(1292);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(41)
      END_STATE();
    case 42:
      if (lookahead == '+') ADVANCE(3012);
      if (lookahead == '-') ADVANCE(1287);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3075);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 43:
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == 'x') ADVANCE(3272);
      if (lookahead == '}') ADVANCE(1292);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(43)
      END_STATE();
    case 44:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(1896);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(1790);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 't') ADVANCE(1482);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 45:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(1896);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(1790);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 46:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(2906);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(1790);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 't') ADVANCE(1482);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 47:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(2906);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(1790);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 48:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(2906);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(2279);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 49:
      if (lookahead == '-') ADVANCE(2211);
      if (lookahead == 'a') ADVANCE(2285);
      if (lookahead == 'b') ADVANCE(2938);
      if (lookahead == 'c') ADVANCE(1426);
      if (lookahead == 'd') ADVANCE(2906);
      if (lookahead == 'f') ADVANCE(2699);
      if (lookahead == 'i') ADVANCE(2401);
      if (lookahead == 'm') ADVANCE(1893);
      if (lookahead == 'n') ADVANCE(2279);
      if (lookahead == 'p') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(1791);
      if (lookahead == 's') ADVANCE(1436);
      if (lookahead == 'u') ADVANCE(2412);
      END_STATE();
    case 50:
      if (lookahead == '-') ADVANCE(696);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(293);
      if (lookahead == 'a') ADVANCE(747);
      if (lookahead == 'b') ADVANCE(1231);
      if (lookahead == 'c') ADVANCE(220);
      if (lookahead == 'd') ADVANCE(1209);
      if (lookahead == 'f') ADVANCE(1041);
      if (lookahead == 'i') ADVANCE(823);
      if (lookahead == 'm') ADVANCE(478);
      if (lookahead == 'n') ADVANCE(397);
      if (lookahead == 'p') ADVANCE(1059);
      if (lookahead == 'r') ADVANCE(399);
      if (lookahead == 's') ADVANCE(188);
      if (lookahead == 't') ADVANCE(229);
      if (lookahead == 'u') ADVANCE(832);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 51:
      if (lookahead == '-') ADVANCE(696);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(747);
      if (lookahead == 'b') ADVANCE(1231);
      if (lookahead == 'c') ADVANCE(220);
      if (lookahead == 'd') ADVANCE(1209);
      if (lookahead == 'f') ADVANCE(1041);
      if (lookahead == 'i') ADVANCE(823);
      if (lookahead == 'm') ADVANCE(478);
      if (lookahead == 'n') ADVANCE(746);
      if (lookahead == 'p') ADVANCE(1059);
      if (lookahead == 'r') ADVANCE(399);
      if (lookahead == 's') ADVANCE(188);
      if (lookahead == 't') ADVANCE(229);
      if (lookahead == 'u') ADVANCE(832);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 52:
      if (lookahead == '-') ADVANCE(1164);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(1008);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 53:
      if (lookahead == '-') ADVANCE(2850);
      END_STATE();
    case 54:
      if (lookahead == '-') ADVANCE(2850);
      if (lookahead == 'b') ADVANCE(2642);
      END_STATE();
    case 55:
      if (lookahead == '-') ADVANCE(1102);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 56:
      if (lookahead == '-') ADVANCE(2766);
      END_STATE();
    case 57:
      if (lookahead == '-') ADVANCE(1053);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 58:
      if (lookahead == '-') ADVANCE(2694);
      END_STATE();
    case 59:
      if (lookahead == '-') ADVANCE(2899);
      END_STATE();
    case 60:
      if (lookahead == '-') ADVANCE(1203);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 61:
      if (lookahead == '.') ADVANCE(3280);
      END_STATE();
    case 62:
      if (lookahead == '.') ADVANCE(61);
      END_STATE();
    case 63:
      if (lookahead == '0') ADVANCE(3224);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 64:
      if (lookahead == '0') ADVANCE(3223);
      END_STATE();
    case 65:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(573);
      if (lookahead == 'd') ADVANCE(630);
      if (lookahead == 'e') ADVANCE(330);
      if (lookahead == 'h') ADVANCE(190);
      if (lookahead == 'i') ADVANCE(592);
      if (lookahead == 'p') ADVANCE(462);
      if (lookahead == 'r') ADVANCE(395);
      if (lookahead == 's') ADVANCE(964);
      if (lookahead == 't') ADVANCE(936);
      if (lookahead == 'u') ADVANCE(261);
      if (lookahead == 'w') ADVANCE(621);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 66:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(573);
      if (lookahead == 'd') ADVANCE(630);
      if (lookahead == 'e') ADVANCE(329);
      if (lookahead == 'h') ADVANCE(190);
      if (lookahead == 'i') ADVANCE(592);
      if (lookahead == 'p') ADVANCE(462);
      if (lookahead == 'r') ADVANCE(395);
      if (lookahead == 's') ADVANCE(964);
      if (lookahead == 't') ADVANCE(936);
      if (lookahead == 'u') ADVANCE(261);
      if (lookahead == 'w') ADVANCE(621);
      if (lookahead == 'y') ADVANCE(868);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 67:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(630);
      if (lookahead == 'e') ADVANCE(773);
      if (lookahead == 'h') ADVANCE(712);
      if (lookahead == 'i') ADVANCE(1148);
      if (lookahead == 'r') ADVANCE(477);
      if (lookahead == 't') ADVANCE(937);
      if (lookahead == 'u') ADVANCE(261);
      if (lookahead == 'w') ADVANCE(668);
      if (lookahead == 'y') ADVANCE(868);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 68:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(632);
      if (lookahead == 'i') ADVANCE(1189);
      if (lookahead == 'm') ADVANCE(179);
      if (lookahead == 'n') ADVANCE(371);
      if (lookahead == 'r') ADVANCE(456);
      if (lookahead == 's') ADVANCE(520);
      if (lookahead == 'w') ADVANCE(1201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 69:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(632);
      if (lookahead == 'i') ADVANCE(1189);
      if (lookahead == 'm') ADVANCE(179);
      if (lookahead == 'n') ADVANCE(370);
      if (lookahead == 'r') ADVANCE(456);
      if (lookahead == 's') ADVANCE(520);
      if (lookahead == 'w') ADVANCE(1201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 70:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(632);
      if (lookahead == 'i') ADVANCE(1189);
      if (lookahead == 'm') ADVANCE(179);
      if (lookahead == 'n') ADVANCE(370);
      if (lookahead == 'r') ADVANCE(456);
      if (lookahead == 's') ADVANCE(520);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 71:
      if (lookahead == '0') ADVANCE(1249);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(632);
      if (lookahead == 'i') ADVANCE(1189);
      if (lookahead == 'm') ADVANCE(179);
      if (lookahead == 'n') ADVANCE(1056);
      if (lookahead == 'r') ADVANCE(456);
      if (lookahead == 's') ADVANCE(520);
      if (lookahead == 'w') ADVANCE(1201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 72:
      if (lookahead == '0') ADVANCE(2959);
      END_STATE();
    case 73:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2034);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(1670);
      if (lookahead == 'g') ADVANCE(1781);
      if (lookahead == 'h') ADVANCE(1424);
      if (lookahead == 'i') ADVANCE(1733);
      if (lookahead == 'l') ADVANCE(1782);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1881);
      if (lookahead == 'r') ADVANCE(1783);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2558);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2106);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 74:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2034);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(1671);
      if (lookahead == 'h') ADVANCE(1424);
      if (lookahead == 'i') ADVANCE(2066);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1880);
      if (lookahead == 'r') ADVANCE(1783);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2167);
      END_STATE();
    case 75:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(1671);
      if (lookahead == 'h') ADVANCE(1424);
      if (lookahead == 'i') ADVANCE(2066);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1880);
      if (lookahead == 'r') ADVANCE(1783);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2558);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2159);
      END_STATE();
    case 76:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(2290);
      if (lookahead == 'h') ADVANCE(1424);
      if (lookahead == 'i') ADVANCE(2066);
      if (lookahead == 'p') ADVANCE(1881);
      if (lookahead == 'r') ADVANCE(1783);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2124);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 77:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(2291);
      if (lookahead == 'h') ADVANCE(1424);
      if (lookahead == 'i') ADVANCE(2066);
      if (lookahead == 'p') ADVANCE(1881);
      if (lookahead == 'r') ADVANCE(1783);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2124);
      END_STATE();
    case 78:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'e') ADVANCE(1672);
      if (lookahead == 'h') ADVANCE(1423);
      if (lookahead == 'i') ADVANCE(2065);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1880);
      if (lookahead == 'r') ADVANCE(1948);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'w') ADVANCE(2167);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 79:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'e') ADVANCE(2630);
      if (lookahead == 'h') ADVANCE(1423);
      if (lookahead == 'i') ADVANCE(2065);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1881);
      if (lookahead == 'r') ADVANCE(1948);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'w') ADVANCE(2124);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 80:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'e') ADVANCE(2630);
      if (lookahead == 'h') ADVANCE(1423);
      if (lookahead == 'i') ADVANCE(2065);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1881);
      if (lookahead == 'r') ADVANCE(1948);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'w') ADVANCE(2124);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 81:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(2290);
      if (lookahead == 'g') ADVANCE(1781);
      if (lookahead == 'h') ADVANCE(2231);
      if (lookahead == 'i') ADVANCE(2830);
      if (lookahead == 'l') ADVANCE(1782);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'r') ADVANCE(1905);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 82:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(2290);
      if (lookahead == 'h') ADVANCE(2231);
      if (lookahead == 'i') ADVANCE(2830);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'r') ADVANCE(1905);
      if (lookahead == 'u') ADVANCE(1547);
      if (lookahead == 'y') ADVANCE(2436);
      END_STATE();
    case 83:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2114);
      if (lookahead == 'e') ADVANCE(2291);
      if (lookahead == 'h') ADVANCE(2231);
      if (lookahead == 'i') ADVANCE(2830);
      if (lookahead == 'r') ADVANCE(1905);
      if (lookahead == 'u') ADVANCE(1547);
      END_STATE();
    case 84:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'e') ADVANCE(2628);
      if (lookahead == 'g') ADVANCE(1784);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'l') ADVANCE(1785);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1736);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 85:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'g') ADVANCE(1784);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'l') ADVANCE(1785);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1739);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 's') ADVANCE(1966);
      END_STATE();
    case 86:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1738);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 87:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1740);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 88:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1739);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 's') ADVANCE(1966);
      END_STATE();
    case 89:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1737);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 90:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1737);
      if (lookahead == 'r') ADVANCE(1877);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 91:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'd') ADVANCE(2116);
      if (lookahead == 'i') ADVANCE(2886);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(1735);
      if (lookahead == 'r') ADVANCE(1877);
      END_STATE();
    case 92:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'e') ADVANCE(2628);
      if (lookahead == 'g') ADVANCE(1784);
      if (lookahead == 'l') ADVANCE(1785);
      if (lookahead == 'n') ADVANCE(1786);
      END_STATE();
    case 93:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'm') ADVANCE(1410);
      if (lookahead == 'n') ADVANCE(2434);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 94:
      if (lookahead == '0') ADVANCE(2959);
      if (lookahead == 'n') ADVANCE(2434);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 95:
      if (lookahead == '0') ADVANCE(1311);
      END_STATE();
    case 96:
      if (lookahead == '1') ADVANCE(101);
      END_STATE();
    case 97:
      if (lookahead == '1') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(2968);
      if (lookahead == 't') ADVANCE(2504);
      END_STATE();
    case 98:
      if (lookahead == '1') ADVANCE(102);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1257);
      if (lookahead == 't') ADVANCE(905);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 99:
      if (lookahead == '1') ADVANCE(103);
      END_STATE();
    case 100:
      if (lookahead == '1') ADVANCE(104);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 101:
      if (lookahead == '2') ADVANCE(112);
      END_STATE();
    case 102:
      if (lookahead == '2') ADVANCE(115);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 103:
      if (lookahead == '2') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == '2') ADVANCE(117);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 105:
      if (lookahead == '3') ADVANCE(95);
      END_STATE();
    case 106:
      if (lookahead == '4') ADVANCE(105);
      END_STATE();
    case 107:
      if (lookahead == '4') ADVANCE(1313);
      END_STATE();
    case 108:
      if (lookahead == '6') ADVANCE(107);
      END_STATE();
    case 109:
      if (lookahead == '6') ADVANCE(124);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 110:
      if (lookahead == '6') ADVANCE(1298);
      END_STATE();
    case 111:
      if (lookahead == '6') ADVANCE(1299);
      END_STATE();
    case 112:
      if (lookahead == '8') ADVANCE(3227);
      END_STATE();
    case 113:
      if (lookahead == '8') ADVANCE(3230);
      END_STATE();
    case 114:
      if (lookahead == '8') ADVANCE(109);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(608);
      if (lookahead == 'o') ADVANCE(1002);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 115:
      if (lookahead == '8') ADVANCE(3228);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 116:
      if (lookahead == '8') ADVANCE(63);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 117:
      if (lookahead == '8') ADVANCE(3231);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 118:
      if (lookahead == '8') ADVANCE(110);
      END_STATE();
    case 119:
      if (lookahead == '8') ADVANCE(110);
      if (lookahead == 'c') ADVANCE(2092);
      if (lookahead == 'o') ADVANCE(2650);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(64);
      END_STATE();
    case 121:
      if (lookahead == '8') ADVANCE(111);
      END_STATE();
    case 122:
      if (lookahead == '8') ADVANCE(111);
      if (lookahead == 'c') ADVANCE(2092);
      if (lookahead == 'o') ADVANCE(2650);
      END_STATE();
    case 123:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(776);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 124:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 125:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 126:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1245);
      if (lookahead == 'a') ADVANCE(721);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 127:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(293);
      if (lookahead == 'n') ADVANCE(398);
      if (lookahead == 't') ADVANCE(229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 128:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 129:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 130:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1060);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 131:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(304);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 132:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 133:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(900);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 134:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1179);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 135:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(471);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 136:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1107);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 137:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(639);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 138:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(613);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 139:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(991);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 140:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 141:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(750);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 142:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 143:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(930);
      if (lookahead == 'o') ADVANCE(872);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 144:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1069);
      if (lookahead == 'u') ADVANCE(687);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 145:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(655);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 146:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(1239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 147:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(733);
      if (lookahead == 'l') ADVANCE(457);
      if (lookahead == 'm') ADVANCE(974);
      if (lookahead == 'o') ADVANCE(732);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 148:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(362);
      if (lookahead == 'c') ADVANCE(806);
      if (lookahead == 'd') ADVANCE(626);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'i') ADVANCE(786);
      if (lookahead == 'l') ADVANCE(914);
      if (lookahead == 'm') ADVANCE(1210);
      if (lookahead == 'n') ADVANCE(447);
      if (lookahead == 'p') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(394);
      if (lookahead == 's') ADVANCE(1207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 149:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(362);
      if (lookahead == 'c') ADVANCE(806);
      if (lookahead == 'd') ADVANCE(626);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'i') ADVANCE(786);
      if (lookahead == 'm') ADVANCE(1210);
      if (lookahead == 'n') ADVANCE(447);
      if (lookahead == 'p') ADVANCE(452);
      if (lookahead == 'r') ADVANCE(394);
      if (lookahead == 's') ADVANCE(1207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 150:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(362);
      if (lookahead == 'c') ADVANCE(806);
      if (lookahead == 'd') ADVANCE(626);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'l') ADVANCE(914);
      if (lookahead == 'm') ADVANCE(1210);
      if (lookahead == 'n') ADVANCE(447);
      if (lookahead == 'p') ADVANCE(98);
      if (lookahead == 'r') ADVANCE(394);
      if (lookahead == 's') ADVANCE(1207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 151:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(265);
      if (lookahead == 'i') ADVANCE(849);
      if (lookahead == 'o') ADVANCE(181);
      if (lookahead == 's') ADVANCE(610);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 152:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1248);
      if (lookahead == 'e') ADVANCE(1177);
      if (lookahead == 'i') ADVANCE(831);
      if (lookahead == 'u') ADVANCE(710);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 153:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1248);
      if (lookahead == 'e') ADVANCE(1177);
      if (lookahead == 'i') ADVANCE(848);
      if (lookahead == 'o') ADVANCE(862);
      if (lookahead == 'u') ADVANCE(711);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 154:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1248);
      if (lookahead == 'i') ADVANCE(831);
      if (lookahead == 'o') ADVANCE(862);
      if (lookahead == 'u') ADVANCE(710);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 155:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1248);
      if (lookahead == 'i') ADVANCE(831);
      if (lookahead == 'u') ADVANCE(710);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 156:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1248);
      if (lookahead == 'i') ADVANCE(848);
      if (lookahead == 'o') ADVANCE(862);
      if (lookahead == 'u') ADVANCE(711);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 157:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(704);
      if (lookahead == 'e') ADVANCE(1087);
      if (lookahead == 'o') ADVANCE(50);
      if (lookahead == 'u') ADVANCE(737);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 158:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(704);
      if (lookahead == 'e') ADVANCE(1087);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(758);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 159:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1023);
      if (lookahead == 'e') ADVANCE(1016);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'o') ADVANCE(688);
      if (lookahead == 'p') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(444);
      if (lookahead == 't') ADVANCE(1001);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 160:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1023);
      if (lookahead == 'e') ADVANCE(1016);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'o') ADVANCE(688);
      if (lookahead == 'r') ADVANCE(444);
      if (lookahead == 't') ADVANCE(1048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 161:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1023);
      if (lookahead == 'e') ADVANCE(1016);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'r') ADVANCE(445);
      if (lookahead == 't') ADVANCE(1048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 162:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(636);
      if (lookahead == 's') ADVANCE(327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 163:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(636);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 164:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(140);
      if (lookahead == 's') ADVANCE(327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 165:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 166:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(328);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(665);
      if (lookahead == 'r') ADVANCE(454);
      if (lookahead == 's') ADVANCE(511);
      if (lookahead == 't') ADVANCE(521);
      if (lookahead == 'v') ADVANCE(934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 167:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(328);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'l') ADVANCE(665);
      if (lookahead == 'r') ADVANCE(454);
      if (lookahead == 's') ADVANCE(511);
      if (lookahead == 't') ADVANCE(1150);
      if (lookahead == 'v') ADVANCE(934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 168:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(998);
      if (lookahead == 't') ADVANCE(567);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 169:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(998);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 170:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 171:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(3603);
      if (lookahead == 's') ADVANCE(675);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 172:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(3603);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 173:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(3490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 174:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(3237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 175:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 176:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(709);
      if (lookahead == 'i') ADVANCE(364);
      if (lookahead == 'o') ADVANCE(1114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 177:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(709);
      if (lookahead == 'i') ADVANCE(364);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 178:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(697);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 179:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1250);
      if (lookahead == 'i') ADVANCE(833);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 180:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(811);
      if (lookahead == 'f') ADVANCE(973);
      if (lookahead == 'm') ADVANCE(812);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 181:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 182:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1076);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 183:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(701);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 184:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1084);
      if (lookahead == 'e') ADVANCE(1036);
      if (lookahead == 's') ADVANCE(495);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 185:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(887);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 186:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(348);
      if (lookahead == 'l') ADVANCE(494);
      if (lookahead == 's') ADVANCE(1221);
      if (lookahead == 't') ADVANCE(3539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 187:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(348);
      if (lookahead == 's') ADVANCE(1221);
      if (lookahead == 't') ADVANCE(3539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 188:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(903);
      if (lookahead == 'y') ADVANCE(858);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 189:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1017);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 190:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(367);
      if (lookahead == 'l') ADVANCE(3662);
      if (lookahead == 'u') ADVANCE(564);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 191:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(369);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 192:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(717);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 193:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 194:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1021);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 195:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(588);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 196:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 197:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(790);
      if (lookahead == 'f') ADVANCE(633);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 198:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 199:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 200:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 201:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 202:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 203:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(722);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 204:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(359);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 205:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(366);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 206:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(724);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 207:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(778);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 208:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(890);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 209:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(772);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 210:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 211:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 212:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(852);
      if (lookahead == 'o') ADVANCE(127);
      if (lookahead == 'u') ADVANCE(759);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 213:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 214:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(634);
      if (lookahead == 'o') ADVANCE(705);
      if (lookahead == 'r') ADVANCE(1205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 215:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(634);
      if (lookahead == 'r') ADVANCE(1205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 216:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(634);
      if (lookahead == 'r') ADVANCE(1230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 217:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 218:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(368);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 219:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(292);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 220:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(979);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 221:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(760);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 222:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(637);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 223:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1094);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 224:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(363);
      if (lookahead == 'c') ADVANCE(806);
      if (lookahead == 'd') ADVANCE(626);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'm') ADVANCE(1210);
      if (lookahead == 'n') ADVANCE(447);
      if (lookahead == 'p') ADVANCE(452);
      if (lookahead == 'r') ADVANCE(394);
      if (lookahead == 's') ADVANCE(1207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 225:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1169);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 226:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(295);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 227:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1161);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 228:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 229:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(642);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 230:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 231:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(754);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 232:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 233:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(597);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 234:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(646);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 235:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1099);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 236:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 237:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(301);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 238:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(755);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 239:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(320);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 240:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(775);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 241:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 242:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(796);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 243:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(795);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 244:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 245:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(851);
      if (lookahead == 'i') ADVANCE(849);
      if (lookahead == 'o') ADVANCE(181);
      if (lookahead == 's') ADVANCE(610);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 246:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(851);
      if (lookahead == 'o') ADVANCE(181);
      if (lookahead == 's') ADVANCE(610);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 247:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1064);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 248:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(781);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 249:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(384);
      if (lookahead == 'h') ADVANCE(1247);
      if (lookahead == 'm') ADVANCE(466);
      if (lookahead == 't') ADVANCE(615);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 250:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 251:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(386);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 252:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(1196);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 253:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 254:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 255:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 256:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(272);
      if (lookahead == 'i') ADVANCE(1236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 257:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 258:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 259:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 260:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'a') ADVANCE(904);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 261:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(3685);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 262:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(3707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 263:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(756);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 264:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(1008);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 265:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(488);
      if (lookahead == 'n') ADVANCE(365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 266:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(761);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 267:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(763);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 268:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(764);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 269:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 270:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(767);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 271:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(653);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 272:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(768);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 273:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(769);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 274:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(770);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 275:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(771);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 276:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(792);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 277:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3292);
      if (lookahead == 'e') ADVANCE(1154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 278:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 279:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3733);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 280:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 281:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3739);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 282:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 283:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(3759);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 284:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(608);
      if (lookahead == 'o') ADVANCE(1002);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 285:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(602);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 286:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 287:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(997);
      if (lookahead == 'd') ADVANCE(342);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'n') ADVANCE(343);
      if (lookahead == 'p') ADVANCE(975);
      if (lookahead == 's') ADVANCE(609);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == 'v') ADVANCE(222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 288:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(997);
      if (lookahead == 'd') ADVANCE(388);
      if (lookahead == 'l') ADVANCE(625);
      if (lookahead == 'n') ADVANCE(343);
      if (lookahead == 'p') ADVANCE(975);
      if (lookahead == 'r') ADVANCE(590);
      if (lookahead == 's') ADVANCE(609);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == 'v') ADVANCE(222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 289:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(997);
      if (lookahead == 'd') ADVANCE(388);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'n') ADVANCE(343);
      if (lookahead == 'p') ADVANCE(975);
      if (lookahead == 's') ADVANCE(609);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == 'v') ADVANCE(222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 290:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(603);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 291:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 292:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(698);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 293:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(574);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 294:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(612);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 295:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(699);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 296:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 297:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(700);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 298:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 299:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1217);
      if (lookahead == 'd') ADVANCE(1284);
      if (lookahead == 't') ADVANCE(1224);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 300:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 301:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 302:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 303:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1020);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 304:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(949);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 305:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1098);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 306:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 307:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 308:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 309:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(231);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 310:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 311:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(657);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 312:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(402);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 313:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 314:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 315:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 316:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 317:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 318:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(420);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 319:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(435);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 320:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(548);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 321:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(808);
      if (lookahead == 'm') ADVANCE(813);
      if (lookahead == 'n') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 322:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(808);
      if (lookahead == 'm') ADVANCE(813);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 323:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(808);
      if (lookahead == 'm') ADVANCE(813);
      if (lookahead == 'n') ADVANCE(167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 324:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(808);
      if (lookahead == 'n') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 325:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(808);
      if (lookahead == 'n') ADVANCE(387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 326:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 327:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 328:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(315);
      if (lookahead == 'l') ADVANCE(780);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 329:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1156);
      if (lookahead == 'l') ADVANCE(472);
      if (lookahead == 'q') ADVANCE(132);
      if (lookahead == 'x') ADVANCE(1118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 330:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1156);
      if (lookahead == 'l') ADVANCE(472);
      if (lookahead == 'x') ADVANCE(1118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 331:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 332:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(551);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 333:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 334:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 335:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1100);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 336:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 337:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 338:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1185);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 339:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 340:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(1200);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 341:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(342);
      if (lookahead == 'l') ADVANCE(625);
      if (lookahead == 'n') ADVANCE(343);
      if (lookahead == 'p') ADVANCE(975);
      if (lookahead == 'r') ADVANCE(590);
      if (lookahead == 's') ADVANCE(609);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == 'v') ADVANCE(222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 342:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3680);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 343:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3687);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 344:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 345:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3705);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 346:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 347:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3689);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 348:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(898);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 349:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 350:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 351:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 352:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 353:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 354:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 355:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3579);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 356:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3591);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 357:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3364);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 358:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 359:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 360:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3394);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 361:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3757);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 362:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(345);
      if (lookahead == 'l') ADVANCE(1096);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 363:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(345);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 364:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(373);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 365:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 366:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 367:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(906);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 368:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(380);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 369:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 370:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(465);
      if (lookahead == 'o') ADVANCE(1067);
      if (lookahead == 'r') ADVANCE(483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 371:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(465);
      if (lookahead == 'r') ADVANCE(483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 372:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(1007);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 373:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 374:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(1010);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 375:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(474);
      if (lookahead == 'w') ADVANCE(645);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 376:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 377:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 378:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(200);
      if (lookahead == 'm') ADVANCE(917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 379:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(200);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 380:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(1051);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 381:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(648);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 382:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(1066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 383:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(1070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 384:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 385:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 386:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(383);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 387:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(693);
      if (lookahead == 's') ADVANCE(511);
      if (lookahead == 't') ADVANCE(521);
      if (lookahead == 'v') ADVANCE(934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 388:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(3681);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 389:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'd') ADVANCE(388);
      if (lookahead == 'l') ADVANCE(625);
      if (lookahead == 'n') ADVANCE(343);
      if (lookahead == 'r') ADVANCE(590);
      if (lookahead == 's') ADVANCE(609);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 390:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(562);
      if (lookahead == 'i') ADVANCE(1086);
      if (lookahead == 'l') ADVANCE(708);
      if (lookahead == 'o') ADVANCE(1206);
      if (lookahead == 's') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 391:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(562);
      if (lookahead == 'i') ADVANCE(1086);
      if (lookahead == 'l') ADVANCE(708);
      if (lookahead == 's') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 392:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 393:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1019);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 394:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(396);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 395:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(801);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 396:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1275);
      if (lookahead == 'm') ADVANCE(3676);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 397:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3637);
      if (lookahead == 'l') ADVANCE(175);
      if (lookahead == 'n') ADVANCE(1222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 398:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3637);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 399:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(299);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 400:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3626);
      if (lookahead == 'n') ADVANCE(279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 401:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3629);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 402:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 403:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3610);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 404:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 405:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3547);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 406:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3566);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 407:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 408:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 409:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 410:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 411:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3361);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 412:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 413:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 414:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3091);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 415:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3457);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 416:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 417:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3358);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 418:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3296);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 419:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 420:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 421:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 422:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3334);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 423:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3502);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 424:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3367);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 425:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3379);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 426:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3370);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 427:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3496);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 428:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3624);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 429:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3349);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 430:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3538);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 431:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3306);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 432:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3622);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 433:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 434:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 435:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 436:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 437:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 438:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3391);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 439:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 440:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3761);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 441:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3763);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 442:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(3769);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 443:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(784);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 444:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(197);
      if (lookahead == 'i') ADVANCE(1235);
      if (lookahead == 'o') ADVANCE(744);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 445:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(745);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 446:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(996);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 447:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(579);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 448:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(178);
      if (lookahead == 'i') ADVANCE(739);
      if (lookahead == 'r') ADVANCE(662);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 449:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(178);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 450:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 451:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(558);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 452:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1257);
      if (lookahead == 't') ADVANCE(905);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 453:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(575);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 454:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 455:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 456:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(803);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 457:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(185);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 458:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(821);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 459:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1255);
      if (lookahead == 'i') ADVANCE(829);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 460:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 461:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 462:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(331);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 463:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 464:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 465:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 466:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(804);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 467:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1029);
      if (lookahead == 'r') ADVANCE(228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 468:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 469:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1088);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 470:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(805);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 471:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1260);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 472:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 473:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 474:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(560);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 475:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(835);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 476:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 477:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 478:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1018);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 479:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(867);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 480:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 481:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 482:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(572);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 483:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 484:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(787);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 485:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(838);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 486:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(563);
      if (lookahead == 'l') ADVANCE(708);
      if (lookahead == 'o') ADVANCE(1206);
      if (lookahead == 's') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 487:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(563);
      if (lookahead == 'l') ADVANCE(708);
      if (lookahead == 's') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 488:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(718);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 489:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(333);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 490:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(591);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 491:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(353);
      if (lookahead == 's') ADVANCE(134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 492:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(354);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 493:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(358);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 494:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 495:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(742);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 496:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(361);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 497:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 498:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 499:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1011);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 500:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 501:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1014);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 502:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1038);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 503:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1030);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 504:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(726);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 505:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 506:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(896);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 507:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(407);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 508:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(893);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 509:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1015);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 510:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(554);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 511:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1034);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 512:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1037);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 513:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 514:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(999);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 515:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1105);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 516:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 517:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(817);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 518:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 519:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 520:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(749);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 521:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1031);
      if (lookahead == 't') ADVANCE(945);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 522:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 523:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 524:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1039);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 525:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1259);
      if (lookahead == 'i') ADVANCE(901);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 526:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 527:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1091);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 528:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(876);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 529:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(864);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 530:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(825);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 531:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 532:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1049);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 533:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1092);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 534:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 535:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(877);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 536:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(819);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 537:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(940);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 538:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 539:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1045);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 540:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 541:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(879);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 542:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 543:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(880);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 544:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(882);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 545:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1055);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 546:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(1028);
      if (lookahead == 'i') ADVANCE(1086);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 547:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(822);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 548:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(336);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 549:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(827);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 550:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(828);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 551:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 552:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(798);
      if (lookahead == 'v') ADVANCE(207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 553:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(800);
      if (lookahead == 'v') ADVANCE(248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 554:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'e') ADVANCE(830);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 555:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(788);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == 'l') ADVANCE(909);
      if (lookahead == 'r') ADVANCE(3543);
      if (lookahead == 'u') ADVANCE(631);
      if (lookahead == 'y') ADVANCE(1025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 556:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(788);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == 'l') ADVANCE(909);
      if (lookahead == 'r') ADVANCE(3543);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 557:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(3212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 558:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(3487);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 559:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(3640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 560:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(3535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 561:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(3520);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 562:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(217);
      if (lookahead == 'r') ADVANCE(453);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 563:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 564:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(576);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 565:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(967);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 566:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(968);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 567:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(919);
      if (lookahead == 'n') ADVANCE(944);
      if (lookahead == 's') ADVANCE(669);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 568:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(1208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 569:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(969);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 570:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(1122);
      if (lookahead == 't') ADVANCE(290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 571:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(971);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 572:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(1082);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 573:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(515);
      if (lookahead == 'n') ADVANCE(674);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 574:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(624);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 575:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(532);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 576:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(762);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 577:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(685);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 578:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'f') ADVANCE(793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 579:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 580:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3678);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 581:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 582:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3532);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 583:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3587);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 584:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3612);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 585:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 586:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3448);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 587:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3397);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 588:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3436);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 589:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(3439);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 590:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(816);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 591:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(57);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 592:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(871);
      if (lookahead == 't') ADVANCE(935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 593:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(834);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 594:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(990);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 595:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 596:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 597:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(438);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 598:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(1214);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 599:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 600:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(1063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 601:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'g') ADVANCE(824);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 602:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(986);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 603:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(3564);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 604:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(3575);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 605:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(3649);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 606:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'o') ADVANCE(688);
      if (lookahead == 'p') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(629);
      if (lookahead == 't') ADVANCE(1001);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 607:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'o') ADVANCE(688);
      if (lookahead == 'r') ADVANCE(629);
      if (lookahead == 't') ADVANCE(1048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 608:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(580);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 609:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(1003);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 610:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(1004);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 611:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(584);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 612:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(531);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 613:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 614:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(678);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 615:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(1052);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 616:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'h') ADVANCE(255);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 617:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == 'l') ADVANCE(909);
      if (lookahead == 'r') ADVANCE(3543);
      if (lookahead == 'u') ADVANCE(631);
      if (lookahead == 'y') ADVANCE(1025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 618:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == 'l') ADVANCE(909);
      if (lookahead == 'r') ADVANCE(3543);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 619:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == 'r') ADVANCE(3543);
      if (lookahead == 'u') ADVANCE(631);
      if (lookahead == 'y') ADVANCE(1025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 620:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(3589);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 621:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(570);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 622:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(3751);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 623:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(3749);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 624:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(3089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 625:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(593);
      if (lookahead == 'l') ADVANCE(913);
      if (lookahead == 'w') ADVANCE(170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 626:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 627:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(364);
      if (lookahead == 'o') ADVANCE(1114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 628:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(364);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 629:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1235);
      if (lookahead == 'o') ADVANCE(1182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 630:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 631:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(779);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 632:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 633:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 634:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(716);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 635:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1068);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 636:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(349);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 637:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(799);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 638:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 639:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1090);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 640:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 641:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(853);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 642:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(719);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 643:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(311);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 644:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 645:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(859);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 646:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(723);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 647:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(902);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 648:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(855);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 649:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(360);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 650:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(844);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 651:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 652:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(895);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 653:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(866);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 654:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(857);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 655:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 656:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(860);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 657:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1153);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 658:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1149);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 659:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 660:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 661:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 662:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1166);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 663:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1240);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 664:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(739);
      if (lookahead == 'r') ADVANCE(662);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 665:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(875);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 666:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 667:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(873);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 668:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 669:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 670:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 671:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1097);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 672:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(883);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 673:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 674:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 675:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 676:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 677:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 678:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(878);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 679:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1280);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 680:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1162);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 681:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1281);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 682:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(886);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 683:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 684:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(926);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 685:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(766);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 686:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(931);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 687:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1054);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 688:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1108);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 689:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(785);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 690:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(901);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 691:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 692:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(242);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 693:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1074);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 694:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 695:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'i') ADVANCE(1199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 696:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'j') ADVANCE(1225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 697:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3097);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 698:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 699:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 700:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 701:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 702:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(3463);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 703:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(958);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 704:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(480);
      if (lookahead == 'n') ADVANCE(347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 705:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(475);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 706:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 707:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'k') ADVANCE(218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 708:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(459);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 709:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(557);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 710:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3656);
      if (lookahead == 's') ADVANCE(1116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 711:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3656);
      if (lookahead == 's') ADVANCE(1170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 712:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3662);
      if (lookahead == 'u') ADVANCE(564);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 713:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3600);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 714:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3672);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 715:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3632);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 716:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3594);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 717:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 718:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 719:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3598);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 720:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3511);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 721:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3122);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 722:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3094);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 723:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3596);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 724:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 725:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3517);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 726:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 727:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(3633);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 728:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1261);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 729:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(517);
      if (lookahead == 'x') ADVANCE(1113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 730:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(517);
      if (lookahead == 'x') ADVANCE(1168);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 731:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(344);
      if (lookahead == 'm') ADVANCE(378);
      if (lookahead == 'n') ADVANCE(1238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 732:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(344);
      if (lookahead == 'm') ADVANCE(379);
      if (lookahead == 'n') ADVANCE(1238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 733:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(713);
      if (lookahead == 't') ADVANCE(285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 734:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(713);
      if (lookahead == 't') ADVANCE(300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 735:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 736:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 737:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(715);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 738:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 739:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(777);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 740:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 741:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1083);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 742:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(561);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 743:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 744:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(912);
      if (lookahead == 't') ADVANCE(489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 745:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(912);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 746:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(175);
      if (lookahead == 'n') ADVANCE(1222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 747:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 748:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 749:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(671);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 750:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(956);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 751:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(720);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 752:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(676);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 753:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 754:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(797);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 755:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(740);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 756:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 757:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(725);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 758:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(748);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 759:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(727);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 760:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 761:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(463);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 762:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 763:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 764:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(473);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 765:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(422);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 766:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(424);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 767:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 768:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 769:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 770:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(436);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 771:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 772:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(649);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 773:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(472);
      if (lookahead == 'q') ADVANCE(132);
      if (lookahead == 'x') ADVANCE(1118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 774:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(643);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 775:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(658);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 776:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(959);
      if (lookahead == 'p') ADVANCE(1062);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 777:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1047);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 778:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 779:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1181);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 780:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(943);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 781:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1216);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 782:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 783:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(962);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 784:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(494);
      if (lookahead == 's') ADVANCE(1221);
      if (lookahead == 't') ADVANCE(3540);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 785:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 786:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1176);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 787:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(530);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 788:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 789:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(672);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 790:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(783);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 791:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(954);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 792:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 793:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(952);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 794:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(682);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 795:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(544);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 796:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(681);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 797:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(1111);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 798:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(549);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 799:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 800:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'l') ADVANCE(550);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 801:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(3660);
      if (lookahead == 't') ADVANCE(3493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 802:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(3660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 803:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(3658);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 804:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 805:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 806:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(965);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 807:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(1242);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 808:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(966);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 809:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(994);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 810:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 811:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(1252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 812:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(1253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 813:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 814:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(638);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 815:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(970);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 816:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(458);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 817:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(479);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 818:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(409);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 819:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 820:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 821:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 822:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(953);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 823:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(989);
      if (lookahead == 'n') ADVANCE(789);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 824:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(547);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 825:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 826:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(810);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 827:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(541);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 828:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(543);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 829:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(992);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 830:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'm') ADVANCE(995);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 831:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3697);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 832:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(375);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 833:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3703);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 834:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 835:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 836:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 837:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 838:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 839:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3643);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 840:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 841:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3309);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 842:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3286);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 843:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3376);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 844:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 845:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3288);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 846:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 847:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 848:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(3698);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 849:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(703);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 850:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 851:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 852:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 853:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(594);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 854:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 855:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(585);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 856:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(586);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 857:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(587);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 858:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(280);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 859:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 860:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(589);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 861:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(281);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 862:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(933);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 863:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(728);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 864:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 865:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 866:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(357);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 867:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1165);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 868:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(305);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 869:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(735);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 870:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(736);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 871:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 872:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 873:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 874:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(743);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 875:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 876:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 877:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 878:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 879:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 880:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 881:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 882:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 883:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(417);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 884:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 885:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(426);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 886:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 887:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 888:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 889:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(316);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 890:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(596);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 891:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(651);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 892:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(240);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 893:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 894:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1109);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 895:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 896:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(656);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 897:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 898:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(951);
      if (lookahead == 'o') ADVANCE(863);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 899:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 900:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(1229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 901:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(680);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 902:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(794);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 903:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(694);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 904:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'n') ADVANCE(695);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 905:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1093);
      if (lookahead == 'r') ADVANCE(1220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 906:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 907:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 908:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(525);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 909:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 910:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 911:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(814);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 912:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(598);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 913:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 914:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 915:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 916:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(600);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 917:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(836);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 918:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(372);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 919:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 920:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(839);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 921:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(842);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 922:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 923:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1009);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 924:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(856);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 925:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(690);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 926:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(845);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 927:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1013);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 928:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1022);
      if (lookahead == 't') ADVANCE(195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 929:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 930:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1072);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 931:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(847);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 932:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(891);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 933:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 934:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(706);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 935:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(566);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 936:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1042);
      if (lookahead == 'r') ADVANCE(666);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 937:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1042);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 938:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 939:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(374);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 940:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 941:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(983);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 942:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1044);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 943:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(306);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 944:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(881);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 945:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(984);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 946:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(569);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 947:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(870);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 948:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1046);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 949:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(1237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 950:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(667);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 951:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(884);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 952:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(213);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 953:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(874);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 954:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(313);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 955:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(885);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 956:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 957:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(652);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 958:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 959:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(334);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 960:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(892);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 961:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 962:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'o') ADVANCE(339);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 963:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(168);
      if (lookahead == 'r') ADVANCE(3691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 964:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3444);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 965:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3585);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 966:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3583);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 967:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(100);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 968:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3747);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 969:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3745);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 970:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(60);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 971:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(3454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 972:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(988);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 973:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 974:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 975:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 976:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1033);
      if (lookahead == 't') ADVANCE(234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 977:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(942);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 978:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 979:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 980:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(169);
      if (lookahead == 'r') ADVANCE(3691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 981:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1115);
      if (lookahead == 'r') ADVANCE(3691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 982:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 983:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 984:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1159);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 985:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1163);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 986:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(196);
      if (lookahead == 'r') ADVANCE(500);
      if (lookahead == 's') ADVANCE(1243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 987:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(752);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 988:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(201);
      if (lookahead == 'r') ADVANCE(505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 989:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(774);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 990:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 991:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 992:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(948);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 993:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 994:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 995:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(1204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 996:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'q') ADVANCE(3451);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 997:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'q') ADVANCE(144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 998:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'q') ADVANCE(1213);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 999:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'q') ADVANCE(1223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1000:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1001:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1002:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3693);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1003:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3670);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1004:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3668);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1005:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1006:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3753);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1007:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3101);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1008:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3549);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1009:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1010:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3107);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1011:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3781);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1012:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3618);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1013:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3557);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1014:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1015:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(3652);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1016:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1106);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1017:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(582);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1018:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(595);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1019:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(908);
      if (lookahead == 'x') ADVANCE(1119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1020:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(807);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1021:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(583);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1022:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1265);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1023:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1024:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(568);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1025:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(451);
      if (lookahead == 'v') ADVANCE(192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1026:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1027:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1028:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(453);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1029:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(837);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1030:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1031:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(888);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1032:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1033:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(916);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1034:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1035:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(840);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1036:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1037:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(961);
      if (lookahead == 'x') ADVANCE(1119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1038:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1039:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(925);
      if (lookahead == 'x') ADVANCE(1119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1040:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(843);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1041:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(507);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1042:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1043:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(846);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1044:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1045:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(899);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1046:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1047:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1048:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1155);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1049:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1050:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(423);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1051:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1052:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(542);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1053:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(482);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1054:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1055:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(496);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1056:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1057:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1101);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1058:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(376);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1059:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(915);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1060:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1061:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1062:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(510);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1063:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(522);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1064:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1065:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1066:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(527);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1067:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1068:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(534);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1069:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(504);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1070:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1071:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(924);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1072:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1073:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1074:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(540);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1075:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(601);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1076:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1077:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3654);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1078:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3466);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1079:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3343);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1080:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3424);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1081:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1082:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(3373);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1083:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(55);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1084:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1272);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1085:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(978);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1086:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1087:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1088:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1077);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1089:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1078);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1090:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1091:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1080);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1092:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1081);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1093:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(622);
      if (lookahead == 'u') ADVANCE(623);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1094:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1095:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1096:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(401);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1097:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1098:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(308);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1099:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1100:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1101:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1102:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1103:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(441);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1104:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1095);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1105:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1158);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1106:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(960);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1107:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(260);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1108:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(920);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1109:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1110:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(647);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1111:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1112:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(993);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1113:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1114:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3322);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1115:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(567);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1116:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(976);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1117:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1118:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3737);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1119:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3735);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1120:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1121:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3741);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1122:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1123:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1124:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1125:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(552);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1126:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3555);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1127:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3731);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1128:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1129:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3478);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1130:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3475);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1131:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3573);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1132:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(52);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1133:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3755);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1134:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1135:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1136:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3570);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1137:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3316);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1138:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3331);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1139:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3743);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1140:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1141:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3551);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1142:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1143:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1144:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(3767);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1145:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1146:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(264);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1147:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1271);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1148:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1149:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1264);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1150:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(945);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1151:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1152:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1153:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(578);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1154:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1155:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(950);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1156:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(673);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1157:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1158:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1159:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1006);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1160:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(298);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1161:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1162:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(692);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1163:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1012);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1164:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(741);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1165:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1166:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(537);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1167:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1168:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1026);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1169:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(414);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1170:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1171:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(492);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1172:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(429);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1173:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(498);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1174:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1175:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1176:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1177:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1178:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1179:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1180:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(922);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1181:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(644);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1182:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1183:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(985);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1184:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(571);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1185:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1186:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1187:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(650);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1188:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(932);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1189:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(946);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1190:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(1227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1191:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1192:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(684);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1193:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1194:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1195:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(670);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1196:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(686);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1197:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1198:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(679);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1199:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(683);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1200:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1201:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1202:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1203:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1204:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1205:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1206:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1207:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1208:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1209:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(987);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1210:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1211:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(972);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1212:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(782);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1213:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(408);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1214:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1215:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(428);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1216:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(432);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1217:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1057);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1218:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(753);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1219:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(809);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1220:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(861);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1221:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(818);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1222:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(751);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1223:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(663);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1224:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1040);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1225:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(815);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1226:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1227:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1228:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(820);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1229:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(757);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1230:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(854);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1231:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(689);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1232:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(3674);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1233:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(3666);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1234:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(3664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1235:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1236:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(476);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1237:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(502);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1238:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1239:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1240:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1241:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'v') ADVANCE(538);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1242:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(3614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1243:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(659);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1244:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(677);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1245:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(516);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1246:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(309);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1247:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'w') ADVANCE(251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1248:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3695);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1249:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1250:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3701);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1251:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1252:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1253:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3240);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1254:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1255:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(977);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1256:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(326);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1257:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1258:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1259:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1260:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(1175);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1261:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3409);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1262:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1263:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1264:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3298);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1265:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1266:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3325);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1267:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3110);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1268:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(3328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1269:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(271);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1270:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(1110);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1271:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(982);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1272:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'y') ADVANCE(865);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1273:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(1269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1274:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(1283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1275:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(405);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1276:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1277:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1278:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(468);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1279:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1280:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(519);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1281:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(501);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1282:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(503);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1283:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(654);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1284:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'z') ADVANCE(955);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1290);
      END_STATE();
    case 1285:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(1289);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1286:
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1287:
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1288:
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1289:
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1290:
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 1291:
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1291)
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 1292:
      if (lookahead == '>') ADVANCE(3263);
      END_STATE();
    case 1293:
      if (lookahead == '_') ADVANCE(2021);
      END_STATE();
    case 1294:
      if (lookahead == '_') ADVANCE(2334);
      END_STATE();
    case 1295:
      if (lookahead == '_') ADVANCE(2210);
      END_STATE();
    case 1296:
      if (lookahead == '_') ADVANCE(1490);
      END_STATE();
    case 1297:
      if (lookahead == '_') ADVANCE(1528);
      END_STATE();
    case 1298:
      if (lookahead == '_') ADVANCE(1373);
      END_STATE();
    case 1299:
      if (lookahead == '_') ADVANCE(1434);
      END_STATE();
    case 1300:
      if (lookahead == '_') ADVANCE(3016);
      END_STATE();
    case 1301:
      if (lookahead == '_') ADVANCE(3017);
      END_STATE();
    case 1302:
      if (lookahead == '_') ADVANCE(2956);
      if (lookahead == 'a') ADVANCE(2244);
      END_STATE();
    case 1303:
      if (lookahead == '_') ADVANCE(2956);
      if (lookahead == 'a') ADVANCE(2251);
      END_STATE();
    case 1304:
      if (lookahead == '_') ADVANCE(3019);
      END_STATE();
    case 1305:
      if (lookahead == '_') ADVANCE(3020);
      END_STATE();
    case 1306:
      if (lookahead == '_') ADVANCE(2028);
      END_STATE();
    case 1307:
      if (lookahead == '_') ADVANCE(3021);
      END_STATE();
    case 1308:
      if (lookahead == '_') ADVANCE(3021);
      if (lookahead == 'd') ADVANCE(2200);
      END_STATE();
    case 1309:
      if (lookahead == '_') ADVANCE(1611);
      if (lookahead == 'n') ADVANCE(1789);
      END_STATE();
    case 1310:
      if (lookahead == '_') ADVANCE(3022);
      END_STATE();
    case 1311:
      if (lookahead == '_') ADVANCE(3023);
      END_STATE();
    case 1312:
      if (lookahead == '_') ADVANCE(2098);
      END_STATE();
    case 1313:
      if (lookahead == '_') ADVANCE(3024);
      END_STATE();
    case 1314:
      if (lookahead == '_') ADVANCE(2774);
      END_STATE();
    case 1315:
      if (lookahead == '_') ADVANCE(1673);
      END_STATE();
    case 1316:
      if (lookahead == '_') ADVANCE(2707);
      END_STATE();
    case 1317:
      if (lookahead == '_') ADVANCE(2133);
      END_STATE();
    case 1318:
      if (lookahead == '_') ADVANCE(1633);
      END_STATE();
    case 1319:
      if (lookahead == '_') ADVANCE(2864);
      END_STATE();
    case 1320:
      if (lookahead == '_') ADVANCE(2483);
      END_STATE();
    case 1321:
      if (lookahead == '_') ADVANCE(1883);
      END_STATE();
    case 1322:
      if (lookahead == '_') ADVANCE(1435);
      END_STATE();
    case 1323:
      if (lookahead == '_') ADVANCE(2913);
      END_STATE();
    case 1324:
      if (lookahead == '_') ADVANCE(2913);
      if (lookahead == 'd') ADVANCE(2986);
      if (lookahead == 'e') ADVANCE(2972);
      END_STATE();
    case 1325:
      if (lookahead == '_') ADVANCE(2618);
      END_STATE();
    case 1326:
      if (lookahead == '_') ADVANCE(2704);
      if (lookahead == 'u') ADVANCE(2184);
      END_STATE();
    case 1327:
      if (lookahead == '_') ADVANCE(1613);
      END_STATE();
    case 1328:
      if (lookahead == '_') ADVANCE(1464);
      END_STATE();
    case 1329:
      if (lookahead == '_') ADVANCE(2540);
      if (lookahead == 'o') ADVANCE(2455);
      END_STATE();
    case 1330:
      if (lookahead == '_') ADVANCE(1666);
      END_STATE();
    case 1331:
      if (lookahead == '_') ADVANCE(2209);
      END_STATE();
    case 1332:
      if (lookahead == '_') ADVANCE(2154);
      END_STATE();
    case 1333:
      if (lookahead == '_') ADVANCE(2332);
      END_STATE();
    case 1334:
      if (lookahead == '_') ADVANCE(2045);
      END_STATE();
    case 1335:
      if (lookahead == '_') ADVANCE(1485);
      END_STATE();
    case 1336:
      if (lookahead == '_') ADVANCE(2950);
      END_STATE();
    case 1337:
      if (lookahead == '_') ADVANCE(1529);
      END_STATE();
    case 1338:
      if (lookahead == '_') ADVANCE(2362);
      END_STATE();
    case 1339:
      if (lookahead == 'a') ADVANCE(2656);
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1691);
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2103);
      if (lookahead == 'm') ADVANCE(1720);
      if (lookahead == 'n') ADVANCE(1693);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(1604);
      if (lookahead == 's') ADVANCE(2091);
      if (lookahead == 't') ADVANCE(2511);
      if (lookahead == 'v') ADVANCE(1473);
      END_STATE();
    case 1340:
      if (lookahead == 'a') ADVANCE(2656);
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1750);
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'm') ADVANCE(1720);
      if (lookahead == 'n') ADVANCE(2991);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(1604);
      if (lookahead == 't') ADVANCE(2827);
      if (lookahead == 'v') ADVANCE(1473);
      END_STATE();
    case 1341:
      if (lookahead == 'a') ADVANCE(2656);
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1718);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'm') ADVANCE(1720);
      if (lookahead == 'n') ADVANCE(1695);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(2062);
      if (lookahead == 't') ADVANCE(2827);
      if (lookahead == 'v') ADVANCE(1473);
      END_STATE();
    case 1342:
      if (lookahead == 'a') ADVANCE(2656);
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1768);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'm') ADVANCE(1720);
      if (lookahead == 'n') ADVANCE(1695);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(2062);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 'v') ADVANCE(1473);
      END_STATE();
    case 1343:
      if (lookahead == 'a') ADVANCE(2656);
      if (lookahead == 'd') ADVANCE(1691);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'm') ADVANCE(1720);
      if (lookahead == 'n') ADVANCE(1695);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(2062);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 'v') ADVANCE(1473);
      END_STATE();
    case 1344:
      if (lookahead == 'a') ADVANCE(1722);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'e') ADVANCE(2433);
      if (lookahead == 'i') ADVANCE(2331);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1776);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1345:
      if (lookahead == 'a') ADVANCE(1555);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 'o') ADVANCE(1416);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 1346:
      if (lookahead == 'a') ADVANCE(2221);
      if (lookahead == 'e') ADVANCE(3710);
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 'o') ADVANCE(44);
      if (lookahead == 's') ADVANCE(2952);
      if (lookahead == 'u') ADVANCE(2272);
      END_STATE();
    case 1347:
      if (lookahead == 'a') ADVANCE(2221);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 's') ADVANCE(2952);
      if (lookahead == 'u') ADVANCE(2272);
      END_STATE();
    case 1348:
      if (lookahead == 'a') ADVANCE(2221);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(2271);
      END_STATE();
    case 1349:
      if (lookahead == 'a') ADVANCE(2221);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'o') ADVANCE(45);
      if (lookahead == 'u') ADVANCE(2271);
      END_STATE();
    case 1350:
      if (lookahead == 'a') ADVANCE(2221);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 'u') ADVANCE(2309);
      END_STATE();
    case 1351:
      if (lookahead == 'a') ADVANCE(2120);
      if (lookahead == 'h') ADVANCE(2677);
      if (lookahead == 'o') ADVANCE(3567);
      if (lookahead == 'r') ADVANCE(2119);
      if (lookahead == 'y') ADVANCE(2603);
      END_STATE();
    case 1352:
      if (lookahead == 'a') ADVANCE(2120);
      if (lookahead == 'o') ADVANCE(3567);
      if (lookahead == 'r') ADVANCE(2901);
      END_STATE();
    case 1353:
      if (lookahead == 'a') ADVANCE(1322);
      if (lookahead == 'o') ADVANCE(2122);
      if (lookahead == 's') ADVANCE(1674);
      END_STATE();
    case 1354:
      if (lookahead == 'a') ADVANCE(1322);
      if (lookahead == 'o') ADVANCE(2121);
      if (lookahead == 's') ADVANCE(1685);
      END_STATE();
    case 1355:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'b') ADVANCE(2518);
      if (lookahead == 'd') ADVANCE(2177);
      if (lookahead == 'i') ADVANCE(2840);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1432);
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(1788);
      if (lookahead == 'v') ADVANCE(2516);
      END_STATE();
    case 1356:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'b') ADVANCE(2518);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1432);
      END_STATE();
    case 1357:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'b') ADVANCE(2518);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(1860);
      END_STATE();
    case 1358:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'd') ADVANCE(2177);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(2002);
      if (lookahead == 'v') ADVANCE(2516);
      END_STATE();
    case 1359:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      END_STATE();
    case 1360:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(1860);
      END_STATE();
    case 1361:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(2002);
      END_STATE();
    case 1362:
      if (lookahead == 'a') ADVANCE(1665);
      if (lookahead == 'd') ADVANCE(2203);
      if (lookahead == 'l') ADVANCE(2171);
      if (lookahead == 'r') ADVANCE(1872);
      if (lookahead == 't') ADVANCE(1859);
      END_STATE();
    case 1363:
      if (lookahead == 'a') ADVANCE(1701);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 's') ADVANCE(2926);
      if (lookahead == 't') ADVANCE(3541);
      END_STATE();
    case 1364:
      if (lookahead == 'a') ADVANCE(1701);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 't') ADVANCE(2921);
      END_STATE();
    case 1365:
      if (lookahead == 'a') ADVANCE(1701);
      if (lookahead == 's') ADVANCE(2926);
      if (lookahead == 't') ADVANCE(3541);
      END_STATE();
    case 1366:
      if (lookahead == 'a') ADVANCE(1701);
      if (lookahead == 't') ADVANCE(2921);
      END_STATE();
    case 1367:
      if (lookahead == 'a') ADVANCE(2988);
      END_STATE();
    case 1368:
      if (lookahead == 'a') ADVANCE(3602);
      if (lookahead == 's') ADVANCE(2181);
      END_STATE();
    case 1369:
      if (lookahead == 'a') ADVANCE(3189);
      if (lookahead == 'c') ADVANCE(3175);
      if (lookahead == 'e') ADVANCE(3188);
      if (lookahead == 's') ADVANCE(3179);
      if (lookahead == 't') ADVANCE(3174);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 1370:
      if (lookahead == 'a') ADVANCE(3489);
      END_STATE();
    case 1371:
      if (lookahead == 'a') ADVANCE(3236);
      END_STATE();
    case 1372:
      if (lookahead == 'a') ADVANCE(2035);
      if (lookahead == 'e') ADVANCE(1669);
      if (lookahead == 'h') ADVANCE(1423);
      if (lookahead == 'i') ADVANCE(2065);
      if (lookahead == 'o') ADVANCE(2920);
      if (lookahead == 'p') ADVANCE(1880);
      if (lookahead == 'r') ADVANCE(1948);
      if (lookahead == 's') ADVANCE(2581);
      if (lookahead == 't') ADVANCE(2662);
      if (lookahead == 'w') ADVANCE(2167);
      END_STATE();
    case 1373:
      if (lookahead == 'a') ADVANCE(3155);
      if (lookahead == 'f') ADVANCE(3157);
      if (lookahead == 'm') ADVANCE(3156);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 1374:
      if (lookahead == 'a') ADVANCE(1554);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 'o') ADVANCE(1415);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 1375:
      if (lookahead == 'a') ADVANCE(1721);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'i') ADVANCE(2331);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1376:
      if (lookahead == 'a') ADVANCE(1721);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1377:
      if (lookahead == 'a') ADVANCE(1721);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(1870);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1378:
      if (lookahead == 'a') ADVANCE(1556);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 'o') ADVANCE(1681);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 1379:
      if (lookahead == 'a') ADVANCE(2697);
      if (lookahead == 'e') ADVANCE(2655);
      if (lookahead == 'h') ADVANCE(2105);
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1780);
      if (lookahead == 't') ADVANCE(2635);
      END_STATE();
    case 1380:
      if (lookahead == 'a') ADVANCE(2697);
      if (lookahead == 'e') ADVANCE(2655);
      if (lookahead == 'h') ADVANCE(2105);
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1857);
      if (lookahead == 't') ADVANCE(2634);
      END_STATE();
    case 1381:
      if (lookahead == 'a') ADVANCE(2697);
      if (lookahead == 'e') ADVANCE(2655);
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1857);
      if (lookahead == 't') ADVANCE(2634);
      END_STATE();
    case 1382:
      if (lookahead == 'a') ADVANCE(2697);
      if (lookahead == 'e') ADVANCE(2655);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1858);
      if (lookahead == 't') ADVANCE(2653);
      END_STATE();
    case 1383:
      if (lookahead == 'a') ADVANCE(2866);
      if (lookahead == 'e') ADVANCE(1608);
      if (lookahead == 'i') ADVANCE(2739);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 'o') ADVANCE(2902);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1384:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 'o') ADVANCE(1749);
      if (lookahead == 's') ADVANCE(2580);
      if (lookahead == 'u') ADVANCE(2229);
      END_STATE();
    case 1385:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 'o') ADVANCE(1749);
      if (lookahead == 's') ADVANCE(2580);
      if (lookahead == 'u') ADVANCE(2762);
      END_STATE();
    case 1386:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 'o') ADVANCE(1748);
      if (lookahead == 'u') ADVANCE(2229);
      END_STATE();
    case 1387:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 'o') ADVANCE(1748);
      if (lookahead == 'u') ADVANCE(2230);
      END_STATE();
    case 1388:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 'o') ADVANCE(2432);
      if (lookahead == 's') ADVANCE(2580);
      if (lookahead == 'u') ADVANCE(2230);
      END_STATE();
    case 1389:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2410);
      if (lookahead == 's') ADVANCE(2580);
      if (lookahead == 'u') ADVANCE(2230);
      END_STATE();
    case 1390:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2429);
      if (lookahead == 'o') ADVANCE(1749);
      if (lookahead == 'u') ADVANCE(2228);
      END_STATE();
    case 1391:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2429);
      if (lookahead == 'u') ADVANCE(2228);
      END_STATE();
    case 1392:
      if (lookahead == 'a') ADVANCE(2960);
      if (lookahead == 'i') ADVANCE(2429);
      if (lookahead == 'u') ADVANCE(2228);
      END_STATE();
    case 1393:
      if (lookahead == 'a') ADVANCE(1724);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'i') ADVANCE(2331);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1394:
      if (lookahead == 'a') ADVANCE(1724);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1395:
      if (lookahead == 'a') ADVANCE(2253);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 1396:
      if (lookahead == 'a') ADVANCE(2212);
      END_STATE();
    case 1397:
      if (lookahead == 'a') ADVANCE(2212);
      if (lookahead == 'b') ADVANCE(2223);
      END_STATE();
    case 1398:
      if (lookahead == 'a') ADVANCE(1725);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'p') ADVANCE(96);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1399:
      if (lookahead == 'a') ADVANCE(2987);
      END_STATE();
    case 1400:
      if (lookahead == 'a') ADVANCE(2993);
      END_STATE();
    case 1401:
      if (lookahead == 'a') ADVANCE(2631);
      END_STATE();
    case 1402:
      if (lookahead == 'a') ADVANCE(2631);
      if (lookahead == 't') ADVANCE(2027);
      END_STATE();
    case 1403:
      if (lookahead == 'a') ADVANCE(2227);
      END_STATE();
    case 1404:
      if (lookahead == 'a') ADVANCE(2227);
      if (lookahead == 'h') ADVANCE(2943);
      if (lookahead == 'i') ADVANCE(1726);
      if (lookahead == 'o') ADVANCE(2783);
      END_STATE();
    case 1405:
      if (lookahead == 'a') ADVANCE(2227);
      if (lookahead == 'i') ADVANCE(1726);
      END_STATE();
    case 1406:
      if (lookahead == 'a') ADVANCE(2227);
      if (lookahead == 'i') ADVANCE(1726);
      if (lookahead == 'o') ADVANCE(2783);
      END_STATE();
    case 1407:
      if (lookahead == 'a') ADVANCE(2227);
      if (lookahead == 'o') ADVANCE(2783);
      END_STATE();
    case 1408:
      if (lookahead == 'a') ADVANCE(2728);
      if (lookahead == 'g') ADVANCE(2414);
      END_STATE();
    case 1409:
      if (lookahead == 'a') ADVANCE(2411);
      END_STATE();
    case 1410:
      if (lookahead == 'a') ADVANCE(2961);
      if (lookahead == 'i') ADVANCE(2413);
      END_STATE();
    case 1411:
      if (lookahead == 'a') ADVANCE(1625);
      END_STATE();
    case 1412:
      if (lookahead == 'a') ADVANCE(1625);
      if (lookahead == 't') ADVANCE(1886);
      END_STATE();
    case 1413:
      if (lookahead == 'a') ADVANCE(1625);
      if (lookahead == 't') ADVANCE(1998);
      END_STATE();
    case 1414:
      if (lookahead == 'a') ADVANCE(1625);
      if (lookahead == 't') ADVANCE(2006);
      END_STATE();
    case 1415:
      if (lookahead == 'a') ADVANCE(1698);
      END_STATE();
    case 1416:
      if (lookahead == 'a') ADVANCE(1698);
      if (lookahead == 'c') ADVANCE(1441);
      END_STATE();
    case 1417:
      if (lookahead == 'a') ADVANCE(1553);
      END_STATE();
    case 1418:
      if (lookahead == 'a') ADVANCE(1553);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 'o') ADVANCE(1681);
      END_STATE();
    case 1419:
      if (lookahead == 'a') ADVANCE(1553);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 'o') ADVANCE(1681);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 1420:
      if (lookahead == 'a') ADVANCE(1553);
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 1421:
      if (lookahead == 'a') ADVANCE(1553);
      if (lookahead == 'o') ADVANCE(1681);
      END_STATE();
    case 1422:
      if (lookahead == 'a') ADVANCE(2216);
      END_STATE();
    case 1423:
      if (lookahead == 'a') ADVANCE(1729);
      END_STATE();
    case 1424:
      if (lookahead == 'a') ADVANCE(1729);
      if (lookahead == 'l') ADVANCE(3661);
      if (lookahead == 'u') ADVANCE(2026);
      END_STATE();
    case 1425:
      if (lookahead == 'a') ADVANCE(2755);
      END_STATE();
    case 1426:
      if (lookahead == 'a') ADVANCE(2602);
      if (lookahead == 'f') ADVANCE(1327);
      END_STATE();
    case 1427:
      if (lookahead == 'a') ADVANCE(2658);
      END_STATE();
    case 1428:
      if (lookahead == 'a') ADVANCE(1731);
      END_STATE();
    case 1429:
      if (lookahead == 'a') ADVANCE(2437);
      END_STATE();
    case 1430:
      if (lookahead == 'a') ADVANCE(2236);
      END_STATE();
    case 1431:
      if (lookahead == 'a') ADVANCE(2218);
      END_STATE();
    case 1432:
      if (lookahead == 'a') ADVANCE(2478);
      if (lookahead == 'e') ADVANCE(2052);
      END_STATE();
    case 1433:
      if (lookahead == 'a') ADVANCE(2729);
      END_STATE();
    case 1434:
      if (lookahead == 'a') ADVANCE(2382);
      if (lookahead == 'f') ADVANCE(2596);
      if (lookahead == 'm') ADVANCE(2384);
      END_STATE();
    case 1435:
      if (lookahead == 'a') ADVANCE(2660);
      END_STATE();
    case 1436:
      if (lookahead == 'a') ADVANCE(2499);
      if (lookahead == 'y') ADVANCE(2445);
      END_STATE();
    case 1437:
      if (lookahead == 'a') ADVANCE(2791);
      END_STATE();
    case 1438:
      if (lookahead == 'a') ADVANCE(1727);
      END_STATE();
    case 1439:
      if (lookahead == 'a') ADVANCE(2059);
      END_STATE();
    case 1440:
      if (lookahead == 'a') ADVANCE(2669);
      END_STATE();
    case 1441:
      if (lookahead == 'a') ADVANCE(2239);
      END_STATE();
    case 1442:
      if (lookahead == 'a') ADVANCE(2352);
      if (lookahead == 'f') ADVANCE(2118);
      END_STATE();
    case 1443:
      if (lookahead == 'a') ADVANCE(2352);
      if (lookahead == 'f') ADVANCE(2118);
      if (lookahead == 's') ADVANCE(1912);
      END_STATE();
    case 1444:
      if (lookahead == 'a') ADVANCE(2352);
      if (lookahead == 's') ADVANCE(1912);
      END_STATE();
    case 1445:
      if (lookahead == 'a') ADVANCE(2240);
      END_STATE();
    case 1446:
      if (lookahead == 'a') ADVANCE(2875);
      END_STATE();
    case 1447:
      if (lookahead == 'a') ADVANCE(2794);
      END_STATE();
    case 1448:
      if (lookahead == 'a') ADVANCE(2795);
      END_STATE();
    case 1449:
      if (lookahead == 'a') ADVANCE(1705);
      END_STATE();
    case 1450:
      if (lookahead == 'a') ADVANCE(2245);
      END_STATE();
    case 1451:
      if (lookahead == 'a') ADVANCE(1710);
      END_STATE();
    case 1452:
      if (lookahead == 'a') ADVANCE(1612);
      END_STATE();
    case 1453:
      if (lookahead == 'a') ADVANCE(1614);
      END_STATE();
    case 1454:
      if (lookahead == 'a') ADVANCE(2746);
      if (lookahead == 'e') ADVANCE(2710);
      if (lookahead == 's') ADVANCE(1943);
      END_STATE();
    case 1455:
      if (lookahead == 'a') ADVANCE(1713);
      END_STATE();
    case 1456:
      if (lookahead == 'a') ADVANCE(2247);
      END_STATE();
    case 1457:
      if (lookahead == 'a') ADVANCE(2740);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 1458:
      if (lookahead == 'a') ADVANCE(1730);
      END_STATE();
    case 1459:
      if (lookahead == 'a') ADVANCE(2335);
      END_STATE();
    case 1460:
      if (lookahead == 'a') ADVANCE(2741);
      END_STATE();
    case 1461:
      if (lookahead == 'a') ADVANCE(1700);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 't') ADVANCE(2921);
      END_STATE();
    case 1462:
      if (lookahead == 'a') ADVANCE(1700);
      if (lookahead == 't') ADVANCE(2921);
      END_STATE();
    case 1463:
      if (lookahead == 'a') ADVANCE(2248);
      END_STATE();
    case 1464:
      if (lookahead == 'a') ADVANCE(2670);
      END_STATE();
    case 1465:
      if (lookahead == 'a') ADVANCE(1717);
      END_STATE();
    case 1466:
      if (lookahead == 'a') ADVANCE(1622);
      END_STATE();
    case 1467:
      if (lookahead == 'a') ADVANCE(2292);
      END_STATE();
    case 1468:
      if (lookahead == 'a') ADVANCE(2826);
      END_STATE();
    case 1469:
      if (lookahead == 'a') ADVANCE(2435);
      if (lookahead == 'e') ADVANCE(3709);
      if (lookahead == 'o') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(2311);
      END_STATE();
    case 1470:
      if (lookahead == 'a') ADVANCE(2435);
      if (lookahead == 'o') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(2311);
      END_STATE();
    case 1471:
      if (lookahead == 'a') ADVANCE(2821);
      END_STATE();
    case 1472:
      if (lookahead == 'a') ADVANCE(2164);
      END_STATE();
    case 1473:
      if (lookahead == 'a') ADVANCE(2164);
      if (lookahead == 'r') ADVANCE(1301);
      END_STATE();
    case 1474:
      if (lookahead == 'a') ADVANCE(1723);
      if (lookahead == 'c') ADVANCE(2378);
      if (lookahead == 'd') ADVANCE(2110);
      if (lookahead == 'e') ADVANCE(2433);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'm') ADVANCE(2905);
      if (lookahead == 'n') ADVANCE(1866);
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(1775);
      if (lookahead == 's') ADVANCE(2903);
      END_STATE();
    case 1475:
      if (lookahead == 'a') ADVANCE(2197);
      if (lookahead == 'o') ADVANCE(3567);
      END_STATE();
    case 1476:
      if (lookahead == 'a') ADVANCE(2764);
      END_STATE();
    case 1477:
      if (lookahead == 'a') ADVANCE(1732);
      END_STATE();
    case 1478:
      if (lookahead == 'a') ADVANCE(2479);
      END_STATE();
    case 1479:
      if (lookahead == 'a') ADVANCE(2456);
      END_STATE();
    case 1480:
      if (lookahead == 'a') ADVANCE(2298);
      END_STATE();
    case 1481:
      if (lookahead == 'a') ADVANCE(2717);
      END_STATE();
    case 1482:
      if (lookahead == 'a') ADVANCE(2129);
      END_STATE();
    case 1483:
      if (lookahead == 'a') ADVANCE(2925);
      END_STATE();
    case 1484:
      if (lookahead == 'a') ADVANCE(2925);
      if (lookahead == 'i') ADVANCE(2459);
      END_STATE();
    case 1485:
      if (lookahead == 'a') ADVANCE(1753);
      END_STATE();
    case 1486:
      if (lookahead == 'a') ADVANCE(2220);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 'o') ADVANCE(49);
      if (lookahead == 's') ADVANCE(2952);
      if (lookahead == 'u') ADVANCE(2272);
      END_STATE();
    case 1487:
      if (lookahead == 'a') ADVANCE(2220);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 'o') ADVANCE(49);
      if (lookahead == 's') ADVANCE(2992);
      if (lookahead == 'u') ADVANCE(2309);
      END_STATE();
    case 1488:
      if (lookahead == 'a') ADVANCE(2220);
      if (lookahead == 'e') ADVANCE(2742);
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 's') ADVANCE(2992);
      if (lookahead == 'u') ADVANCE(2309);
      END_STATE();
    case 1489:
      if (lookahead == 'a') ADVANCE(2287);
      END_STATE();
    case 1490:
      if (lookahead == 'a') ADVANCE(2299);
      if (lookahead == 'm') ADVANCE(2526);
      END_STATE();
    case 1491:
      if (lookahead == 'a') ADVANCE(2854);
      END_STATE();
    case 1492:
      if (lookahead == 'a') ADVANCE(2389);
      END_STATE();
    case 1493:
      if (lookahead == 'a') ADVANCE(1688);
      END_STATE();
    case 1494:
      if (lookahead == 'a') ADVANCE(2760);
      END_STATE();
    case 1495:
      if (lookahead == 'a') ADVANCE(2314);
      END_STATE();
    case 1496:
      if (lookahead == 'a') ADVANCE(2304);
      END_STATE();
    case 1497:
      if (lookahead == 'a') ADVANCE(2137);
      END_STATE();
    case 1498:
      if (lookahead == 'a') ADVANCE(1615);
      END_STATE();
    case 1499:
      if (lookahead == 'a') ADVANCE(1637);
      END_STATE();
    case 1500:
      if (lookahead == 'a') ADVANCE(1651);
      END_STATE();
    case 1501:
      if (lookahead == 'a') ADVANCE(2846);
      END_STATE();
    case 1502:
      if (lookahead == 'a') ADVANCE(2391);
      END_STATE();
    case 1503:
      if (lookahead == 'a') ADVANCE(2336);
      END_STATE();
    case 1504:
      if (lookahead == 'a') ADVANCE(2196);
      if (lookahead == 'o') ADVANCE(2225);
      if (lookahead == 'r') ADVANCE(2901);
      END_STATE();
    case 1505:
      if (lookahead == 'a') ADVANCE(2857);
      END_STATE();
    case 1506:
      if (lookahead == 'a') ADVANCE(2076);
      END_STATE();
    case 1507:
      if (lookahead == 'a') ADVANCE(2358);
      END_STATE();
    case 1508:
      if (lookahead == 'a') ADVANCE(2763);
      if (lookahead == 'i') ADVANCE(2331);
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 1509:
      if (lookahead == 'a') ADVANCE(2310);
      END_STATE();
    case 1510:
      if (lookahead == 'a') ADVANCE(2689);
      END_STATE();
    case 1511:
      if (lookahead == 'a') ADVANCE(1654);
      END_STATE();
    case 1512:
      if (lookahead == 'a') ADVANCE(2297);
      END_STATE();
    case 1513:
      if (lookahead == 'a') ADVANCE(2318);
      END_STATE();
    case 1514:
      if (lookahead == 'a') ADVANCE(2859);
      END_STATE();
    case 1515:
      if (lookahead == 'a') ADVANCE(1655);
      END_STATE();
    case 1516:
      if (lookahead == 'a') ADVANCE(2860);
      END_STATE();
    case 1517:
      if (lookahead == 'a') ADVANCE(1649);
      if (lookahead == 't') ADVANCE(1998);
      END_STATE();
    case 1518:
      if (lookahead == 'a') ADVANCE(2357);
      END_STATE();
    case 1519:
      if (lookahead == 'a') ADVANCE(2328);
      END_STATE();
    case 1520:
      if (lookahead == 'a') ADVANCE(2330);
      END_STATE();
    case 1521:
      if (lookahead == 'a') ADVANCE(1558);
      END_STATE();
    case 1522:
      if (lookahead == 'a') ADVANCE(1558);
      if (lookahead == 't') ADVANCE(2176);
      END_STATE();
    case 1523:
      if (lookahead == 'a') ADVANCE(2393);
      END_STATE();
    case 1524:
      if (lookahead == 'a') ADVANCE(2485);
      END_STATE();
    case 1525:
      if (lookahead == 'a') ADVANCE(2340);
      END_STATE();
    case 1526:
      if (lookahead == 'a') ADVANCE(2356);
      END_STATE();
    case 1527:
      if (lookahead == 'a') ADVANCE(2883);
      if (lookahead == 'l') ADVANCE(1950);
      if (lookahead == 'o') ADVANCE(2302);
      END_STATE();
    case 1528:
      if (lookahead == 'a') ADVANCE(1764);
      if (lookahead == 'h') ADVANCE(2958);
      if (lookahead == 'm') ADVANCE(1884);
      if (lookahead == 't') ADVANCE(2100);
      END_STATE();
    case 1529:
      if (lookahead == 'a') ADVANCE(1757);
      END_STATE();
    case 1530:
      if (lookahead == 'a') ADVANCE(1559);
      END_STATE();
    case 1531:
      if (lookahead == 'a') ADVANCE(2695);
      if (lookahead == 'o') ADVANCE(3567);
      END_STATE();
    case 1532:
      if (lookahead == 'a') ADVANCE(2695);
      if (lookahead == 'o') ADVANCE(3567);
      if (lookahead == 'r') ADVANCE(2901);
      END_STATE();
    case 1533:
      if (lookahead == 'a') ADVANCE(2695);
      if (lookahead == 'o') ADVANCE(3567);
      if (lookahead == 'r') ADVANCE(2919);
      END_STATE();
    case 1534:
      if (lookahead == 'a') ADVANCE(2884);
      END_STATE();
    case 1535:
      if (lookahead == 'a') ADVANCE(1766);
      END_STATE();
    case 1536:
      if (lookahead == 'a') ADVANCE(2891);
      END_STATE();
    case 1537:
      if (lookahead == 'a') ADVANCE(1560);
      END_STATE();
    case 1538:
      if (lookahead == 'a') ADVANCE(1561);
      END_STATE();
    case 1539:
      if (lookahead == 'a') ADVANCE(1563);
      END_STATE();
    case 1540:
      if (lookahead == 'a') ADVANCE(1564);
      if (lookahead == 'i') ADVANCE(2947);
      END_STATE();
    case 1541:
      if (lookahead == 'a') ADVANCE(1565);
      END_STATE();
    case 1542:
      if (lookahead == 'a') ADVANCE(1566);
      END_STATE();
    case 1543:
      if (lookahead == 'a') ADVANCE(1567);
      END_STATE();
    case 1544:
      if (lookahead == 'a') ADVANCE(2359);
      END_STATE();
    case 1545:
      if (lookahead == 'a') ADVANCE(2406);
      END_STATE();
    case 1546:
      if (lookahead == 'a') ADVANCE(2501);
      END_STATE();
    case 1547:
      if (lookahead == 'b') ADVANCE(3684);
      END_STATE();
    case 1548:
      if (lookahead == 'b') ADVANCE(3706);
      END_STATE();
    case 1549:
      if (lookahead == 'b') ADVANCE(3783);
      END_STATE();
    case 1550:
      if (lookahead == 'b') ADVANCE(1549);
      END_STATE();
    case 1551:
      if (lookahead == 'b') ADVANCE(2307);
      END_STATE();
    case 1552:
      if (lookahead == 'b') ADVANCE(2935);
      END_STATE();
    case 1553:
      if (lookahead == 'b') ADVANCE(1901);
      END_STATE();
    case 1554:
      if (lookahead == 'b') ADVANCE(1901);
      if (lookahead == 'n') ADVANCE(1752);
      END_STATE();
    case 1555:
      if (lookahead == 'b') ADVANCE(1901);
      if (lookahead == 'n') ADVANCE(1752);
      if (lookahead == 'r') ADVANCE(2070);
      END_STATE();
    case 1556:
      if (lookahead == 'b') ADVANCE(1901);
      if (lookahead == 'r') ADVANCE(2070);
      END_STATE();
    case 1557:
      if (lookahead == 'b') ADVANCE(1445);
      END_STATE();
    case 1558:
      if (lookahead == 'b') ADVANCE(2315);
      END_STATE();
    case 1559:
      if (lookahead == 'b') ADVANCE(2317);
      END_STATE();
    case 1560:
      if (lookahead == 'b') ADVANCE(2320);
      END_STATE();
    case 1561:
      if (lookahead == 'b') ADVANCE(2321);
      END_STATE();
    case 1562:
      if (lookahead == 'b') ADVANCE(2150);
      END_STATE();
    case 1563:
      if (lookahead == 'b') ADVANCE(2323);
      END_STATE();
    case 1564:
      if (lookahead == 'b') ADVANCE(2324);
      END_STATE();
    case 1565:
      if (lookahead == 'b') ADVANCE(2325);
      END_STATE();
    case 1566:
      if (lookahead == 'b') ADVANCE(2326);
      END_STATE();
    case 1567:
      if (lookahead == 'b') ADVANCE(2327);
      END_STATE();
    case 1568:
      if (lookahead == 'b') ADVANCE(2349);
      END_STATE();
    case 1569:
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1691);
      if (lookahead == 'l') ADVANCE(2131);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 's') ADVANCE(2091);
      if (lookahead == 't') ADVANCE(2827);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1570:
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1750);
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2104);
      if (lookahead == 'r') ADVANCE(1603);
      if (lookahead == 't') ADVANCE(2577);
      END_STATE();
    case 1571:
      if (lookahead == 'c') ADVANCE(2626);
      if (lookahead == 'd') ADVANCE(1768);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 's') ADVANCE(2091);
      if (lookahead == 't') ADVANCE(2827);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1572:
      if (lookahead == 'c') ADVANCE(3204);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'o') ADVANCE(2265);
      if (lookahead == 'x') ADVANCE(2965);
      END_STATE();
    case 1573:
      if (lookahead == 'c') ADVANCE(3204);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'o') ADVANCE(2264);
      if (lookahead == 'x') ADVANCE(2965);
      END_STATE();
    case 1574:
      if (lookahead == 'c') ADVANCE(3291);
      END_STATE();
    case 1575:
      if (lookahead == 'c') ADVANCE(3291);
      if (lookahead == 'e') ADVANCE(2836);
      END_STATE();
    case 1576:
      if (lookahead == 'c') ADVANCE(3291);
      if (lookahead == 'e') ADVANCE(2836);
      if (lookahead == 'h') ADVANCE(1663);
      if (lookahead == 'l') ADVANCE(2513);
      END_STATE();
    case 1577:
      if (lookahead == 'c') ADVANCE(3291);
      if (lookahead == 'l') ADVANCE(2513);
      END_STATE();
    case 1578:
      if (lookahead == 'c') ADVANCE(1368);
      END_STATE();
    case 1579:
      if (lookahead == 'c') ADVANCE(3173);
      END_STATE();
    case 1580:
      if (lookahead == 'c') ADVANCE(3793);
      END_STATE();
    case 1581:
      if (lookahead == 'c') ADVANCE(3732);
      END_STATE();
    case 1582:
      if (lookahead == 'c') ADVANCE(3607);
      END_STATE();
    case 1583:
      if (lookahead == 'c') ADVANCE(3143);
      END_STATE();
    case 1584:
      if (lookahead == 'c') ADVANCE(3142);
      END_STATE();
    case 1585:
      if (lookahead == 'c') ADVANCE(3384);
      END_STATE();
    case 1586:
      if (lookahead == 'c') ADVANCE(3738);
      END_STATE();
    case 1587:
      if (lookahead == 'c') ADVANCE(3776);
      END_STATE();
    case 1588:
      if (lookahead == 'c') ADVANCE(3145);
      END_STATE();
    case 1589:
      if (lookahead == 'c') ADVANCE(3797);
      END_STATE();
    case 1590:
      if (lookahead == 'c') ADVANCE(3758);
      END_STATE();
    case 1591:
      if (lookahead == 'c') ADVANCE(3796);
      END_STATE();
    case 1592:
      if (lookahead == 'c') ADVANCE(3795);
      END_STATE();
    case 1593:
      if (lookahead == 'c') ADVANCE(3147);
      END_STATE();
    case 1594:
      if (lookahead == 'c') ADVANCE(3152);
      END_STATE();
    case 1595:
      if (lookahead == 'c') ADVANCE(3146);
      END_STATE();
    case 1596:
      if (lookahead == 'c') ADVANCE(3149);
      END_STATE();
    case 1597:
      if (lookahead == 'c') ADVANCE(3523);
      END_STATE();
    case 1598:
      if (lookahead == 'c') ADVANCE(3606);
      END_STATE();
    case 1599:
      if (lookahead == 'c') ADVANCE(2092);
      if (lookahead == 'o') ADVANCE(2650);
      END_STATE();
    case 1600:
      if (lookahead == 'c') ADVANCE(2083);
      END_STATE();
    case 1601:
      if (lookahead == 'c') ADVANCE(2222);
      END_STATE();
    case 1602:
      if (lookahead == 'c') ADVANCE(2582);
      END_STATE();
    case 1603:
      if (lookahead == 'c') ADVANCE(2582);
      if (lookahead == 'g') ADVANCE(2386);
      END_STATE();
    case 1604:
      if (lookahead == 'c') ADVANCE(2582);
      if (lookahead == 'g') ADVANCE(2386);
      if (lookahead == 'm') ADVANCE(1300);
      END_STATE();
    case 1605:
      if (lookahead == 'c') ADVANCE(2084);
      END_STATE();
    case 1606:
      if (lookahead == 'c') ADVANCE(1306);
      END_STATE();
    case 1607:
      if (lookahead == 'c') ADVANCE(2277);
      if (lookahead == 'f') ADVANCE(1484);
      END_STATE();
    case 1608:
      if (lookahead == 'c') ADVANCE(2277);
      if (lookahead == 'f') ADVANCE(1484);
      if (lookahead == 'r') ADVANCE(1871);
      END_STATE();
    case 1609:
      if (lookahead == 'c') ADVANCE(2277);
      if (lookahead == 'f') ADVANCE(2165);
      if (lookahead == 'r') ADVANCE(1871);
      END_STATE();
    case 1610:
      if (lookahead == 'c') ADVANCE(2085);
      END_STATE();
    case 1611:
      if (lookahead == 'c') ADVANCE(2037);
      END_STATE();
    case 1612:
      if (lookahead == 'c') ADVANCE(2213);
      END_STATE();
    case 1613:
      if (lookahead == 'c') ADVANCE(2095);
      END_STATE();
    case 1614:
      if (lookahead == 'c') ADVANCE(2214);
      END_STATE();
    case 1615:
      if (lookahead == 'c') ADVANCE(2101);
      END_STATE();
    case 1616:
      if (lookahead == 'c') ADVANCE(2215);
      END_STATE();
    case 1617:
      if (lookahead == 'c') ADVANCE(2752);
      END_STATE();
    case 1618:
      if (lookahead == 'c') ADVANCE(2086);
      END_STATE();
    case 1619:
      if (lookahead == 'c') ADVANCE(1425);
      END_STATE();
    case 1620:
      if (lookahead == 'c') ADVANCE(2226);
      END_STATE();
    case 1621:
      if (lookahead == 'c') ADVANCE(2087);
      END_STATE();
    case 1622:
      if (lookahead == 'c') ADVANCE(2217);
      END_STATE();
    case 1623:
      if (lookahead == 'c') ADVANCE(2909);
      if (lookahead == 'd') ADVANCE(3006);
      if (lookahead == 't') ADVANCE(2928);
      END_STATE();
    case 1624:
      if (lookahead == 'c') ADVANCE(2088);
      END_STATE();
    case 1625:
      if (lookahead == 'c') ADVANCE(2790);
      END_STATE();
    case 1626:
      if (lookahead == 'c') ADVANCE(1579);
      END_STATE();
    case 1627:
      if (lookahead == 'c') ADVANCE(2089);
      END_STATE();
    case 1628:
      if (lookahead == 'c') ADVANCE(1584);
      END_STATE();
    case 1629:
      if (lookahead == 'c') ADVANCE(2555);
      END_STATE();
    case 1630:
      if (lookahead == 'c') ADVANCE(2797);
      END_STATE();
    case 1631:
      if (lookahead == 'c') ADVANCE(1370);
      END_STATE();
    case 1632:
      if (lookahead == 'c') ADVANCE(2876);
      END_STATE();
    case 1633:
      if (lookahead == 'c') ADVANCE(2562);
      END_STATE();
    case 1634:
      if (lookahead == 'c') ADVANCE(1588);
      END_STATE();
    case 1635:
      if (lookahead == 'c') ADVANCE(1796);
      END_STATE();
    case 1636:
      if (lookahead == 'c') ADVANCE(1593);
      END_STATE();
    case 1637:
      if (lookahead == 'c') ADVANCE(2807);
      END_STATE();
    case 1638:
      if (lookahead == 'c') ADVANCE(2808);
      END_STATE();
    case 1639:
      if (lookahead == 'c') ADVANCE(1594);
      END_STATE();
    case 1640:
      if (lookahead == 'c') ADVANCE(1595);
      END_STATE();
    case 1641:
      if (lookahead == 'c') ADVANCE(2809);
      END_STATE();
    case 1642:
      if (lookahead == 'c') ADVANCE(1596);
      END_STATE();
    case 1643:
      if (lookahead == 'c') ADVANCE(2661);
      END_STATE();
    case 1644:
      if (lookahead == 'c') ADVANCE(1890);
      END_STATE();
    case 1645:
      if (lookahead == 'c') ADVANCE(1961);
      END_STATE();
    case 1646:
      if (lookahead == 'c') ADVANCE(2816);
      END_STATE();
    case 1647:
      if (lookahead == 'c') ADVANCE(2817);
      END_STATE();
    case 1648:
      if (lookahead == 'c') ADVANCE(2862);
      END_STATE();
    case 1649:
      if (lookahead == 'c') ADVANCE(2863);
      END_STATE();
    case 1650:
      if (lookahead == 'c') ADVANCE(1818);
      END_STATE();
    case 1651:
      if (lookahead == 'c') ADVANCE(1824);
      END_STATE();
    case 1652:
      if (lookahead == 'c') ADVANCE(2007);
      END_STATE();
    case 1653:
      if (lookahead == 'c') ADVANCE(1841);
      END_STATE();
    case 1654:
      if (lookahead == 'c') ADVANCE(1978);
      END_STATE();
    case 1655:
      if (lookahead == 'c') ADVANCE(1849);
      END_STATE();
    case 1656:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'f') ADVANCE(2924);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1355);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1657:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1360);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1658:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1357);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1659:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1358);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1660:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1361);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1661:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'n') ADVANCE(2745);
      END_STATE();
    case 1662:
      if (lookahead == 'c') ADVANCE(2379);
      if (lookahead == 'n') ADVANCE(2745);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 1663:
      if (lookahead == 'c') ADVANCE(1626);
      END_STATE();
    case 1664:
      if (lookahead == 'c') ADVANCE(2094);
      END_STATE();
    case 1665:
      if (lookahead == 'c') ADVANCE(1644);
      if (lookahead == 'l') ADVANCE(2337);
      END_STATE();
    case 1666:
      if (lookahead == 'c') ADVANCE(2096);
      END_STATE();
    case 1667:
      if (lookahead == 'c') ADVANCE(1494);
      END_STATE();
    case 1668:
      if (lookahead == 'c') ADVANCE(2156);
      END_STATE();
    case 1669:
      if (lookahead == 'c') ADVANCE(2842);
      END_STATE();
    case 1670:
      if (lookahead == 'c') ADVANCE(2842);
      if (lookahead == 'l') ADVANCE(1962);
      if (lookahead == 'q') ADVANCE(1315);
      if (lookahead == 'x') ADVANCE(2787);
      END_STATE();
    case 1671:
      if (lookahead == 'c') ADVANCE(2842);
      if (lookahead == 'l') ADVANCE(1962);
      if (lookahead == 'x') ADVANCE(2787);
      END_STATE();
    case 1672:
      if (lookahead == 'c') ADVANCE(2842);
      if (lookahead == 'q') ADVANCE(1315);
      END_STATE();
    case 1673:
      if (lookahead == 'c') ADVANCE(2759);
      END_STATE();
    case 1674:
      if (lookahead == 'c') ADVANCE(1495);
      END_STATE();
    case 1675:
      if (lookahead == 'c') ADVANCE(2873);
      END_STATE();
    case 1676:
      if (lookahead == 'c') ADVANCE(2911);
      END_STATE();
    case 1677:
      if (lookahead == 'c') ADVANCE(2855);
      END_STATE();
    case 1678:
      if (lookahead == 'c') ADVANCE(1456);
      END_STATE();
    case 1679:
      if (lookahead == 'c') ADVANCE(1480);
      END_STATE();
    case 1680:
      if (lookahead == 'c') ADVANCE(1463);
      END_STATE();
    case 1681:
      if (lookahead == 'c') ADVANCE(1467);
      END_STATE();
    case 1682:
      if (lookahead == 'c') ADVANCE(1505);
      END_STATE();
    case 1683:
      if (lookahead == 'c') ADVANCE(1514);
      END_STATE();
    case 1684:
      if (lookahead == 'c') ADVANCE(1516);
      END_STATE();
    case 1685:
      if (lookahead == 'c') ADVANCE(1519);
      END_STATE();
    case 1686:
      if (lookahead == 'c') ADVANCE(1520);
      END_STATE();
    case 1687:
      if (lookahead == 'c') ADVANCE(2779);
      END_STATE();
    case 1688:
      if (lookahead == 'c') ADVANCE(2896);
      END_STATE();
    case 1689:
      if (lookahead == 'd') ADVANCE(1691);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'n') ADVANCE(1694);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(2061);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 't') ADVANCE(2827);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1690:
      if (lookahead == 'd') ADVANCE(1691);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1691:
      if (lookahead == 'd') ADVANCE(3682);
      END_STATE();
    case 1692:
      if (lookahead == 'd') ADVANCE(3686);
      END_STATE();
    case 1693:
      if (lookahead == 'd') ADVANCE(3686);
      if (lookahead == 'y') ADVANCE(3799);
      END_STATE();
    case 1694:
      if (lookahead == 'd') ADVANCE(3686);
      if (lookahead == 'y') ADVANCE(3798);
      END_STATE();
    case 1695:
      if (lookahead == 'd') ADVANCE(3686);
      if (lookahead == 'y') ADVANCE(2680);
      END_STATE();
    case 1696:
      if (lookahead == 'd') ADVANCE(3313);
      END_STATE();
    case 1697:
      if (lookahead == 'd') ADVANCE(3704);
      END_STATE();
    case 1698:
      if (lookahead == 'd') ADVANCE(3604);
      END_STATE();
    case 1699:
      if (lookahead == 'd') ADVANCE(3688);
      END_STATE();
    case 1700:
      if (lookahead == 'd') ADVANCE(2496);
      END_STATE();
    case 1701:
      if (lookahead == 'd') ADVANCE(2496);
      if (lookahead == 's') ADVANCE(2773);
      END_STATE();
    case 1702:
      if (lookahead == 'd') ADVANCE(3208);
      END_STATE();
    case 1703:
      if (lookahead == 'd') ADVANCE(3339);
      END_STATE();
    case 1704:
      if (lookahead == 'd') ADVANCE(3568);
      END_STATE();
    case 1705:
      if (lookahead == 'd') ADVANCE(3576);
      END_STATE();
    case 1706:
      if (lookahead == 'd') ADVANCE(3387);
      END_STATE();
    case 1707:
      if (lookahead == 'd') ADVANCE(3507);
      END_STATE();
    case 1708:
      if (lookahead == 'd') ADVANCE(3135);
      END_STATE();
    case 1709:
      if (lookahead == 'd') ADVANCE(3756);
      END_STATE();
    case 1710:
      if (lookahead == 'd') ADVANCE(3590);
      END_STATE();
    case 1711:
      if (lookahead == 'd') ADVANCE(3363);
      END_STATE();
    case 1712:
      if (lookahead == 'd') ADVANCE(3471);
      END_STATE();
    case 1713:
      if (lookahead == 'd') ADVANCE(3429);
      END_STATE();
    case 1714:
      if (lookahead == 'd') ADVANCE(3393);
      END_STATE();
    case 1715:
      if (lookahead == 'd') ADVANCE(3789);
      END_STATE();
    case 1716:
      if (lookahead == 'd') ADVANCE(3311);
      END_STATE();
    case 1717:
      if (lookahead == 'd') ADVANCE(3578);
      END_STATE();
    case 1718:
      if (lookahead == 'd') ADVANCE(3679);
      END_STATE();
    case 1719:
      if (lookahead == 'd') ADVANCE(3725);
      END_STATE();
    case 1720:
      if (lookahead == 'd') ADVANCE(2068);
      END_STATE();
    case 1721:
      if (lookahead == 'd') ADVANCE(1697);
      if (lookahead == 'l') ADVANCE(2757);
      END_STATE();
    case 1722:
      if (lookahead == 'd') ADVANCE(1697);
      if (lookahead == 'l') ADVANCE(2757);
      if (lookahead == 's') ADVANCE(2784);
      END_STATE();
    case 1723:
      if (lookahead == 'd') ADVANCE(1697);
      if (lookahead == 'l') ADVANCE(2757);
      if (lookahead == 's') ADVANCE(2823);
      END_STATE();
    case 1724:
      if (lookahead == 'd') ADVANCE(1697);
      if (lookahead == 'l') ADVANCE(2757);
      if (lookahead == 's') ADVANCE(2880);
      END_STATE();
    case 1725:
      if (lookahead == 'd') ADVANCE(1697);
      if (lookahead == 's') ADVANCE(2880);
      END_STATE();
    case 1726:
      if (lookahead == 'd') ADVANCE(1756);
      END_STATE();
    case 1727:
      if (lookahead == 'd') ADVANCE(1338);
      END_STATE();
    case 1728:
      if (lookahead == 'd') ADVANCE(2730);
      END_STATE();
    case 1729:
      if (lookahead == 'd') ADVANCE(2505);
      END_STATE();
    case 1730:
      if (lookahead == 'd') ADVANCE(1312);
      END_STATE();
    case 1731:
      if (lookahead == 'd') ADVANCE(1501);
      END_STATE();
    case 1732:
      if (lookahead == 'd') ADVANCE(1760);
      END_STATE();
    case 1733:
      if (lookahead == 'd') ADVANCE(1939);
      if (lookahead == 'g') ADVANCE(2454);
      if (lookahead == 't') ADVANCE(2552);
      END_STATE();
    case 1734:
      if (lookahead == 'd') ADVANCE(2641);
      END_STATE();
    case 1735:
      if (lookahead == 'd') ADVANCE(1882);
      END_STATE();
    case 1736:
      if (lookahead == 'd') ADVANCE(1882);
      if (lookahead == 'e') ADVANCE(3727);
      if (lookahead == 'n') ADVANCE(1492);
      if (lookahead == 'o') ADVANCE(3729);
      if (lookahead == 'r') ADVANCE(1906);
      if (lookahead == 'w') ADVANCE(2125);
      END_STATE();
    case 1737:
      if (lookahead == 'd') ADVANCE(1882);
      if (lookahead == 'n') ADVANCE(1492);
      END_STATE();
    case 1738:
      if (lookahead == 'd') ADVANCE(1882);
      if (lookahead == 'n') ADVANCE(1492);
      if (lookahead == 'o') ADVANCE(2696);
      END_STATE();
    case 1739:
      if (lookahead == 'd') ADVANCE(1882);
      if (lookahead == 'o') ADVANCE(2696);
      if (lookahead == 'w') ADVANCE(2125);
      END_STATE();
    case 1740:
      if (lookahead == 'd') ADVANCE(1882);
      if (lookahead == 'r') ADVANCE(1906);
      END_STATE();
    case 1741:
      if (lookahead == 'd') ADVANCE(2643);
      END_STATE();
    case 1742:
      if (lookahead == 'd') ADVANCE(2644);
      END_STATE();
    case 1743:
      if (lookahead == 'd') ADVANCE(2649);
      END_STATE();
    case 1744:
      if (lookahead == 'd') ADVANCE(1750);
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2131);
      if (lookahead == 'r') ADVANCE(1602);
      END_STATE();
    case 1745:
      if (lookahead == 'd') ADVANCE(1889);
      if (lookahead == 'w') ADVANCE(2139);
      END_STATE();
    case 1746:
      if (lookahead == 'd') ADVANCE(1925);
      END_STATE();
    case 1747:
      if (lookahead == 'd') ADVANCE(1335);
      END_STATE();
    case 1748:
      if (lookahead == 'd') ADVANCE(2922);
      END_STATE();
    case 1749:
      if (lookahead == 'd') ADVANCE(2922);
      if (lookahead == 'n') ADVANCE(2548);
      END_STATE();
    case 1750:
      if (lookahead == 'd') ADVANCE(2727);
      END_STATE();
    case 1751:
      if (lookahead == 'd') ADVANCE(2939);
      END_STATE();
    case 1752:
      if (lookahead == 'd') ADVANCE(2132);
      END_STATE();
    case 1753:
      if (lookahead == 'd') ADVANCE(1742);
      END_STATE();
    case 1754:
      if (lookahead == 'd') ADVANCE(1448);
      END_STATE();
    case 1755:
      if (lookahead == 'd') ADVANCE(1448);
      if (lookahead == 'm') ADVANCE(2523);
      END_STATE();
    case 1756:
      if (lookahead == 'd') ADVANCE(1914);
      END_STATE();
    case 1757:
      if (lookahead == 'd') ADVANCE(1743);
      END_STATE();
    case 1758:
      if (lookahead == 'd') ADVANCE(2145);
      END_STATE();
    case 1759:
      if (lookahead == 'd') ADVANCE(1945);
      END_STATE();
    case 1760:
      if (lookahead == 'd') ADVANCE(2693);
      END_STATE();
    case 1761:
      if (lookahead == 'd') ADVANCE(2706);
      END_STATE();
    case 1762:
      if (lookahead == 'd') ADVANCE(2711);
      END_STATE();
    case 1763:
      if (lookahead == 'd') ADVANCE(1330);
      END_STATE();
    case 1764:
      if (lookahead == 'd') ADVANCE(1761);
      END_STATE();
    case 1765:
      if (lookahead == 'd') ADVANCE(1992);
      END_STATE();
    case 1766:
      if (lookahead == 'd') ADVANCE(1762);
      END_STATE();
    case 1767:
      if (lookahead == 'd') ADVANCE(1337);
      END_STATE();
    case 1768:
      if (lookahead == 'd') ADVANCE(3683);
      END_STATE();
    case 1769:
      if (lookahead == 'd') ADVANCE(1768);
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2127);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 'r') ADVANCE(1603);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 't') ADVANCE(2575);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1770:
      if (lookahead == 'd') ADVANCE(1768);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(2599);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == 'v') ADVANCE(1472);
      END_STATE();
    case 1771:
      if (lookahead == 'e') ADVANCE(1608);
      if (lookahead == 'i') ADVANCE(2782);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 'o') ADVANCE(2902);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1772:
      if (lookahead == 'e') ADVANCE(1363);
      END_STATE();
    case 1773:
      if (lookahead == 'e') ADVANCE(1397);
      if (lookahead == 'i') ADVANCE(2276);
      if (lookahead == 'r') ADVANCE(2169);
      END_STATE();
    case 1774:
      if (lookahead == 'e') ADVANCE(1397);
      if (lookahead == 'i') ADVANCE(2275);
      if (lookahead == 'r') ADVANCE(2169);
      END_STATE();
    case 1775:
      if (lookahead == 'e') ADVANCE(1787);
      END_STATE();
    case 1776:
      if (lookahead == 'e') ADVANCE(1787);
      if (lookahead == 'o') ADVANCE(2367);
      END_STATE();
    case 1777:
      if (lookahead == 'e') ADVANCE(3721);
      if (lookahead == 't') ADVANCE(3720);
      END_STATE();
    case 1778:
      if (lookahead == 'e') ADVANCE(3723);
      if (lookahead == 't') ADVANCE(3722);
      END_STATE();
    case 1779:
      if (lookahead == 'e') ADVANCE(3724);
      END_STATE();
    case 1780:
      if (lookahead == 'e') ADVANCE(1443);
      if (lookahead == 'i') ADVANCE(2944);
      if (lookahead == 'o') ADVANCE(2283);
      END_STATE();
    case 1781:
      if (lookahead == 'e') ADVANCE(3716);
      if (lookahead == 't') ADVANCE(3715);
      END_STATE();
    case 1782:
      if (lookahead == 'e') ADVANCE(3718);
      if (lookahead == 't') ADVANCE(3717);
      END_STATE();
    case 1783:
      if (lookahead == 'e') ADVANCE(2369);
      END_STATE();
    case 1784:
      if (lookahead == 'e') ADVANCE(3712);
      if (lookahead == 't') ADVANCE(3711);
      END_STATE();
    case 1785:
      if (lookahead == 'e') ADVANCE(3714);
      if (lookahead == 't') ADVANCE(3713);
      END_STATE();
    case 1786:
      if (lookahead == 'e') ADVANCE(3727);
      if (lookahead == 'o') ADVANCE(3728);
      END_STATE();
    case 1787:
      if (lookahead == 'e') ADVANCE(2995);
      if (lookahead == 'm') ADVANCE(3675);
      END_STATE();
    case 1788:
      if (lookahead == 'e') ADVANCE(2237);
      if (lookahead == 't') ADVANCE(2553);
      END_STATE();
    case 1789:
      if (lookahead == 'e') ADVANCE(3636);
      END_STATE();
    case 1790:
      if (lookahead == 'e') ADVANCE(3636);
      if (lookahead == 'l') ADVANCE(1400);
      if (lookahead == 'n') ADVANCE(2908);
      END_STATE();
    case 1791:
      if (lookahead == 'e') ADVANCE(1623);
      END_STATE();
    case 1792:
      if (lookahead == 'e') ADVANCE(3625);
      END_STATE();
    case 1793:
      if (lookahead == 'e') ADVANCE(3625);
      if (lookahead == 'n') ADVANCE(1581);
      END_STATE();
    case 1794:
      if (lookahead == 'e') ADVANCE(3788);
      END_STATE();
    case 1795:
      if (lookahead == 'e') ADVANCE(3628);
      END_STATE();
    case 1796:
      if (lookahead == 'e') ADVANCE(3615);
      END_STATE();
    case 1797:
      if (lookahead == 'e') ADVANCE(3609);
      END_STATE();
    case 1798:
      if (lookahead == 'e') ADVANCE(3087);
      END_STATE();
    case 1799:
      if (lookahead == 'e') ADVANCE(3220);
      END_STATE();
    case 1800:
      if (lookahead == 'e') ADVANCE(3546);
      END_STATE();
    case 1801:
      if (lookahead == 'e') ADVANCE(3565);
      END_STATE();
    case 1802:
      if (lookahead == 'e') ADVANCE(3784);
      END_STATE();
    case 1803:
      if (lookahead == 'e') ADVANCE(3351);
      END_STATE();
    case 1804:
      if (lookahead == 'e') ADVANCE(3250);
      END_STATE();
    case 1805:
      if (lookahead == 'e') ADVANCE(3544);
      END_STATE();
    case 1806:
      if (lookahead == 'e') ADVANCE(3082);
      END_STATE();
    case 1807:
      if (lookahead == 'e') ADVANCE(3271);
      END_STATE();
    case 1808:
      if (lookahead == 'e') ADVANCE(3760);
      END_STATE();
    case 1809:
      if (lookahead == 'e') ADVANCE(3086);
      END_STATE();
    case 1810:
      if (lookahead == 'e') ADVANCE(3620);
      END_STATE();
    case 1811:
      if (lookahead == 'e') ADVANCE(3336);
      END_STATE();
    case 1812:
      if (lookahead == 'e') ADVANCE(3360);
      END_STATE();
    case 1813:
      if (lookahead == 'e') ADVANCE(3399);
      END_STATE();
    case 1814:
      if (lookahead == 'e') ADVANCE(3402);
      END_STATE();
    case 1815:
      if (lookahead == 'e') ADVANCE(3090);
      END_STATE();
    case 1816:
      if (lookahead == 'e') ADVANCE(3762);
      END_STATE();
    case 1817:
      if (lookahead == 'e') ADVANCE(3456);
      END_STATE();
    case 1818:
      if (lookahead == 'e') ADVANCE(3105);
      END_STATE();
    case 1819:
      if (lookahead == 'e') ADVANCE(3357);
      END_STATE();
    case 1820:
      if (lookahead == 'e') ADVANCE(3295);
      END_STATE();
    case 1821:
      if (lookahead == 'e') ADVANCE(3405);
      END_STATE();
    case 1822:
      if (lookahead == 'e') ADVANCE(3803);
      END_STATE();
    case 1823:
      if (lookahead == 'e') ADVANCE(3608);
      END_STATE();
    case 1824:
      if (lookahead == 'e') ADVANCE(3276);
      END_STATE();
    case 1825:
      if (lookahead == 'e') ADVANCE(3302);
      END_STATE();
    case 1826:
      if (lookahead == 'e') ADVANCE(3333);
      END_STATE();
    case 1827:
      if (lookahead == 'e') ADVANCE(3501);
      END_STATE();
    case 1828:
      if (lookahead == 'e') ADVANCE(3366);
      END_STATE();
    case 1829:
      if (lookahead == 'e') ADVANCE(3378);
      END_STATE();
    case 1830:
      if (lookahead == 'e') ADVANCE(3369);
      END_STATE();
    case 1831:
      if (lookahead == 'e') ADVANCE(3768);
      END_STATE();
    case 1832:
      if (lookahead == 'e') ADVANCE(3495);
      END_STATE();
    case 1833:
      if (lookahead == 'e') ADVANCE(3623);
      END_STATE();
    case 1834:
      if (lookahead == 'e') ADVANCE(3348);
      END_STATE();
    case 1835:
      if (lookahead == 'e') ADVANCE(3537);
      END_STATE();
    case 1836:
      if (lookahead == 'e') ADVANCE(3305);
      END_STATE();
    case 1837:
      if (lookahead == 'e') ADVANCE(3621);
      END_STATE();
    case 1838:
      if (lookahead == 'e') ADVANCE(3441);
      END_STATE();
    case 1839:
      if (lookahead == 'e') ADVANCE(3468);
      END_STATE();
    case 1840:
      if (lookahead == 'e') ADVANCE(3802);
      END_STATE();
    case 1841:
      if (lookahead == 'e') ADVANCE(3417);
      END_STATE();
    case 1842:
      if (lookahead == 'e') ADVANCE(3515);
      END_STATE();
    case 1843:
      if (lookahead == 'e') ADVANCE(3129);
      END_STATE();
    case 1844:
      if (lookahead == 'e') ADVANCE(3085);
      END_STATE();
    case 1845:
      if (lookahead == 'e') ADVANCE(3390);
      END_STATE();
    case 1846:
      if (lookahead == 'e') ADVANCE(2040);
      if (lookahead == 'i') ADVANCE(2782);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 'o') ADVANCE(2902);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1847:
      if (lookahead == 'e') ADVANCE(1461);
      END_STATE();
    case 1848:
      if (lookahead == 'e') ADVANCE(1365);
      END_STATE();
    case 1849:
      if (lookahead == 'e') ADVANCE(3274);
      END_STATE();
    case 1850:
      if (lookahead == 'e') ADVANCE(1607);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 'o') ADVANCE(2902);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1851:
      if (lookahead == 'e') ADVANCE(3270);
      END_STATE();
    case 1852:
      if (lookahead == 'e') ADVANCE(2627);
      if (lookahead == 'g') ADVANCE(1777);
      if (lookahead == 'l') ADVANCE(1778);
      if (lookahead == 'n') ADVANCE(1779);
      if (lookahead == 'p') ADVANCE(1402);
      if (lookahead == 'r') ADVANCE(3690);
      END_STATE();
    case 1853:
      if (lookahead == 'e') ADVANCE(2627);
      if (lookahead == 'g') ADVANCE(1777);
      if (lookahead == 'l') ADVANCE(1778);
      if (lookahead == 'n') ADVANCE(1779);
      if (lookahead == 'p') ADVANCE(1402);
      if (lookahead == 'r') ADVANCE(1719);
      END_STATE();
    case 1854:
      if (lookahead == 'e') ADVANCE(2627);
      if (lookahead == 'g') ADVANCE(1777);
      if (lookahead == 'l') ADVANCE(1778);
      if (lookahead == 'n') ADVANCE(1779);
      if (lookahead == 'p') ADVANCE(1401);
      if (lookahead == 'r') ADVANCE(1719);
      END_STATE();
    case 1855:
      if (lookahead == 'e') ADVANCE(1609);
      if (lookahead == 'i') ADVANCE(2782);
      if (lookahead == 'o') ADVANCE(2902);
      END_STATE();
    case 1856:
      if (lookahead == 'e') ADVANCE(2659);
      END_STATE();
    case 1857:
      if (lookahead == 'e') ADVANCE(1442);
      if (lookahead == 'i') ADVANCE(2944);
      if (lookahead == 'o') ADVANCE(2283);
      END_STATE();
    case 1858:
      if (lookahead == 'e') ADVANCE(1442);
      if (lookahead == 'o') ADVANCE(2282);
      END_STATE();
    case 1859:
      if (lookahead == 'e') ADVANCE(2345);
      END_STATE();
    case 1860:
      if (lookahead == 'e') ADVANCE(2345);
      if (lookahead == 't') ADVANCE(2553);
      END_STATE();
    case 1861:
      if (lookahead == 'e') ADVANCE(1444);
      if (lookahead == 'i') ADVANCE(2944);
      if (lookahead == 'o') ADVANCE(2849);
      END_STATE();
    case 1862:
      if (lookahead == 'e') ADVANCE(1364);
      END_STATE();
    case 1863:
      if (lookahead == 'e') ADVANCE(2628);
      if (lookahead == 'g') ADVANCE(1784);
      if (lookahead == 'l') ADVANCE(1785);
      if (lookahead == 'n') ADVANCE(1786);
      if (lookahead == 's') ADVANCE(1966);
      if (lookahead == 'w') ADVANCE(2831);
      END_STATE();
    case 1864:
      if (lookahead == 'e') ADVANCE(2836);
      END_STATE();
    case 1865:
      if (lookahead == 'e') ADVANCE(2836);
      if (lookahead == 'h') ADVANCE(1663);
      END_STATE();
    case 1866:
      if (lookahead == 'e') ADVANCE(2050);
      END_STATE();
    case 1867:
      if (lookahead == 'e') ADVANCE(1462);
      END_STATE();
    case 1868:
      if (lookahead == 'e') ADVANCE(2020);
      END_STATE();
    case 1869:
      if (lookahead == 'e') ADVANCE(2629);
      END_STATE();
    case 1870:
      if (lookahead == 'e') ADVANCE(2968);
      if (lookahead == 't') ADVANCE(2504);
      END_STATE();
    case 1871:
      if (lookahead == 'e') ADVANCE(2041);
      END_STATE();
    case 1872:
      if (lookahead == 'e') ADVANCE(2052);
      END_STATE();
    case 1873:
      if (lookahead == 'e') ADVANCE(1366);
      END_STATE();
    case 1874:
      if (lookahead == 'e') ADVANCE(2078);
      END_STATE();
    case 1875:
      if (lookahead == 'e') ADVANCE(2967);
      if (lookahead == 'i') ADVANCE(2405);
      END_STATE();
    case 1876:
      if (lookahead == 'e') ADVANCE(2772);
      END_STATE();
    case 1877:
      if (lookahead == 'e') ADVANCE(2370);
      END_STATE();
    case 1878:
      if (lookahead == 'e') ADVANCE(2778);
      END_STATE();
    case 1879:
      if (lookahead == 'e') ADVANCE(2398);
      END_STATE();
    case 1880:
      if (lookahead == 'e') ADVANCE(1676);
      END_STATE();
    case 1881:
      if (lookahead == 'e') ADVANCE(1676);
      if (lookahead == 'i') ADVANCE(2708);
      END_STATE();
    case 1882:
      if (lookahead == 'e') ADVANCE(2022);
      END_STATE();
    case 1883:
      if (lookahead == 'e') ADVANCE(2975);
      END_STATE();
    case 1884:
      if (lookahead == 'e') ADVANCE(2372);
      END_STATE();
    case 1885:
      if (lookahead == 'e') ADVANCE(1314);
      END_STATE();
    case 1886:
      if (lookahead == 'e') ADVANCE(2672);
      if (lookahead == 'r') ADVANCE(1493);
      END_STATE();
    case 1887:
      if (lookahead == 'e') ADVANCE(2494);
      END_STATE();
    case 1888:
      if (lookahead == 'e') ADVANCE(2371);
      END_STATE();
    case 1889:
      if (lookahead == 'e') ADVANCE(2023);
      END_STATE();
    case 1890:
      if (lookahead == 'e') ADVANCE(2770);
      END_STATE();
    case 1891:
      if (lookahead == 'e') ADVANCE(2366);
      END_STATE();
    case 1892:
      if (lookahead == 'e') ADVANCE(1296);
      END_STATE();
    case 1893:
      if (lookahead == 'e') ADVANCE(2709);
      END_STATE();
    case 1894:
      if (lookahead == 'e') ADVANCE(1703);
      END_STATE();
    case 1895:
      if (lookahead == 'e') ADVANCE(1297);
      END_STATE();
    case 1896:
      if (lookahead == 'e') ADVANCE(1751);
      if (lookahead == 'u') ADVANCE(2615);
      END_STATE();
    case 1897:
      if (lookahead == 'e') ADVANCE(2360);
      END_STATE();
    case 1898:
      if (lookahead == 'e') ADVANCE(1321);
      END_STATE();
    case 1899:
      if (lookahead == 'e') ADVANCE(2038);
      END_STATE();
    case 1900:
      if (lookahead == 'e') ADVANCE(2415);
      END_STATE();
    case 1901:
      if (lookahead == 'e') ADVANCE(2238);
      END_STATE();
    case 1902:
      if (lookahead == 'e') ADVANCE(1476);
      END_STATE();
    case 1903:
      if (lookahead == 'e') ADVANCE(2063);
      END_STATE();
    case 1904:
      if (lookahead == 'e') ADVANCE(2731);
      END_STATE();
    case 1905:
      if (lookahead == 'e') ADVANCE(2368);
      END_STATE();
    case 1906:
      if (lookahead == 'e') ADVANCE(1498);
      END_STATE();
    case 1907:
      if (lookahead == 'e') ADVANCE(2639);
      END_STATE();
    case 1908:
      if (lookahead == 'e') ADVANCE(2749);
      END_STATE();
    case 1909:
      if (lookahead == 'e') ADVANCE(2039);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 'o') ADVANCE(2902);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1910:
      if (lookahead == 'e') ADVANCE(2039);
      if (lookahead == 'l') ADVANCE(2254);
      if (lookahead == 's') ADVANCE(2514);
      END_STATE();
    case 1911:
      if (lookahead == 'e') ADVANCE(2453);
      END_STATE();
    case 1912:
      if (lookahead == 'e') ADVANCE(2657);
      END_STATE();
    case 1913:
      if (lookahead == 'e') ADVANCE(1747);
      END_STATE();
    case 1914:
      if (lookahead == 'e') ADVANCE(2418);
      END_STATE();
    case 1915:
      if (lookahead == 'e') ADVANCE(1677);
      END_STATE();
    case 1916:
      if (lookahead == 'e') ADVANCE(2242);
      END_STATE();
    case 1917:
      if (lookahead == 'e') ADVANCE(2734);
      END_STATE();
    case 1918:
      if (lookahead == 'e') ADVANCE(1316);
      END_STATE();
    case 1919:
      if (lookahead == 'e') ADVANCE(1707);
      if (lookahead == 's') ADVANCE(1319);
      END_STATE();
    case 1920:
      if (lookahead == 'e') ADVANCE(1708);
      END_STATE();
    case 1921:
      if (lookahead == 'e') ADVANCE(2798);
      END_STATE();
    case 1922:
      if (lookahead == 'e') ADVANCE(1709);
      END_STATE();
    case 1923:
      if (lookahead == 'e') ADVANCE(1422);
      END_STATE();
    case 1924:
      if (lookahead == 'e') ADVANCE(2668);
      END_STATE();
    case 1925:
      if (lookahead == 'e') ADVANCE(2645);
      END_STATE();
    case 1926:
      if (lookahead == 'e') ADVANCE(1712);
      END_STATE();
    case 1927:
      if (lookahead == 'e') ADVANCE(1589);
      END_STATE();
    case 1928:
      if (lookahead == 'e') ADVANCE(1396);
      END_STATE();
    case 1929:
      if (lookahead == 'e') ADVANCE(1396);
      if (lookahead == 'i') ADVANCE(2274);
      if (lookahead == 'r') ADVANCE(2169);
      END_STATE();
    case 1930:
      if (lookahead == 'e') ADVANCE(1616);
      END_STATE();
    case 1931:
      if (lookahead == 'e') ADVANCE(1675);
      END_STATE();
    case 1932:
      if (lookahead == 'e') ADVANCE(1431);
      if (lookahead == 'i') ADVANCE(2274);
      if (lookahead == 'r') ADVANCE(2169);
      END_STATE();
    case 1933:
      if (lookahead == 'e') ADVANCE(2648);
      END_STATE();
    case 1934:
      if (lookahead == 'e') ADVANCE(1715);
      END_STATE();
    case 1935:
      if (lookahead == 'e') ADVANCE(1591);
      END_STATE();
    case 1936:
      if (lookahead == 'e') ADVANCE(2719);
      END_STATE();
    case 1937:
      if (lookahead == 'e') ADVANCE(2888);
      END_STATE();
    case 1938:
      if (lookahead == 'e') ADVANCE(1620);
      END_STATE();
    case 1939:
      if (lookahead == 'e') ADVANCE(1958);
      END_STATE();
    case 1940:
      if (lookahead == 'e') ADVANCE(1460);
      END_STATE();
    case 1941:
      if (lookahead == 'e') ADVANCE(2805);
      END_STATE();
    case 1942:
      if (lookahead == 'e') ADVANCE(2651);
      END_STATE();
    case 1943:
      if (lookahead == 'e') ADVANCE(2284);
      END_STATE();
    case 1944:
      if (lookahead == 'e') ADVANCE(1803);
      END_STATE();
    case 1945:
      if (lookahead == 'e') ADVANCE(2492);
      END_STATE();
    case 1946:
      if (lookahead == 'e') ADVANCE(2489);
      END_STATE();
    case 1947:
      if (lookahead == 'e') ADVANCE(2825);
      END_STATE();
    case 1948:
      if (lookahead == 'e') ADVANCE(2788);
      END_STATE();
    case 1949:
      if (lookahead == 'e') ADVANCE(2011);
      END_STATE();
    case 1950:
      if (lookahead == 'e') ADVANCE(1429);
      END_STATE();
    case 1951:
      if (lookahead == 'e') ADVANCE(2674);
      END_STATE();
    case 1952:
      if (lookahead == 'e') ADVANCE(2828);
      END_STATE();
    case 1953:
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2498);
      if (lookahead == 'o') ADVANCE(1749);
      if (lookahead == 's') ADVANCE(2580);
      if (lookahead == 'u') ADVANCE(2762);
      END_STATE();
    case 1954:
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2498);
      if (lookahead == 'o') ADVANCE(1749);
      if (lookahead == 'u') ADVANCE(2762);
      END_STATE();
    case 1955:
      if (lookahead == 'e') ADVANCE(2828);
      if (lookahead == 'i') ADVANCE(2498);
      if (lookahead == 'o') ADVANCE(1748);
      if (lookahead == 'u') ADVANCE(2762);
      END_STATE();
    case 1956:
      if (lookahead == 'e') ADVANCE(2723);
      END_STATE();
    case 1957:
      if (lookahead == 'e') ADVANCE(2392);
      END_STATE();
    case 1958:
      if (lookahead == 'e') ADVANCE(2044);
      END_STATE();
    case 1959:
      if (lookahead == 'e') ADVANCE(2632);
      END_STATE();
    case 1960:
      if (lookahead == 'e') ADVANCE(2969);
      END_STATE();
    case 1961:
      if (lookahead == 'e') ADVANCE(1334);
      END_STATE();
    case 1962:
      if (lookahead == 'e') ADVANCE(1630);
      END_STATE();
    case 1963:
      if (lookahead == 'e') ADVANCE(2946);
      END_STATE();
    case 1964:
      if (lookahead == 'e') ADVANCE(1438);
      END_STATE();
    case 1965:
      if (lookahead == 'e') ADVANCE(1318);
      END_STATE();
    case 1966:
      if (lookahead == 'e') ADVANCE(2289);
      END_STATE();
    case 1967:
      if (lookahead == 'e') ADVANCE(1333);
      END_STATE();
    case 1968:
      if (lookahead == 'e') ADVANCE(2973);
      END_STATE();
    case 1969:
      if (lookahead == 'e') ADVANCE(2681);
      END_STATE();
    case 1970:
      if (lookahead == 'e') ADVANCE(2758);
      END_STATE();
    case 1971:
      if (lookahead == 'e') ADVANCE(2750);
      END_STATE();
    case 1972:
      if (lookahead == 'e') ADVANCE(2970);
      END_STATE();
    case 1973:
      if (lookahead == 'e') ADVANCE(2970);
      if (lookahead == 'i') ADVANCE(2477);
      END_STATE();
    case 1974:
      if (lookahead == 'e') ADVANCE(2753);
      END_STATE();
    case 1975:
      if (lookahead == 'e') ADVANCE(2754);
      END_STATE();
    case 1976:
      if (lookahead == 'e') ADVANCE(2463);
      END_STATE();
    case 1977:
      if (lookahead == 'e') ADVANCE(2390);
      END_STATE();
    case 1978:
      if (lookahead == 'e') ADVANCE(1667);
      END_STATE();
    case 1979:
      if (lookahead == 'e') ADVANCE(1455);
      END_STATE();
    case 1980:
      if (lookahead == 'e') ADVANCE(2678);
      END_STATE();
    case 1981:
      if (lookahead == 'e') ADVANCE(2724);
      END_STATE();
    case 1982:
      if (lookahead == 'e') ADVANCE(2464);
      END_STATE();
    case 1983:
      if (lookahead == 'e') ADVANCE(1478);
      END_STATE();
    case 1984:
      if (lookahead == 'e') ADVANCE(2534);
      END_STATE();
    case 1985:
      if (lookahead == 'e') ADVANCE(1641);
      END_STATE();
    case 1986:
      if (lookahead == 'e') ADVANCE(2466);
      END_STATE();
    case 1987:
      if (lookahead == 'e') ADVANCE(1646);
      END_STATE();
    case 1988:
      if (lookahead == 'e') ADVANCE(2467);
      END_STATE();
    case 1989:
      if (lookahead == 'e') ADVANCE(2690);
      END_STATE();
    case 1990:
      if (lookahead == 'e') ADVANCE(1647);
      END_STATE();
    case 1991:
      if (lookahead == 'e') ADVANCE(2468);
      END_STATE();
    case 1992:
      if (lookahead == 'e') ADVANCE(2691);
      END_STATE();
    case 1993:
      if (lookahead == 'e') ADVANCE(1648);
      END_STATE();
    case 1994:
      if (lookahead == 'e') ADVANCE(2286);
      END_STATE();
    case 1995:
      if (lookahead == 'e') ADVANCE(2099);
      END_STATE();
    case 1996:
      if (lookahead == 'e') ADVANCE(2400);
      END_STATE();
    case 1997:
      if (lookahead == 'e') ADVANCE(2698);
      END_STATE();
    case 1998:
      if (lookahead == 'e') ADVANCE(2698);
      if (lookahead == 'r') ADVANCE(1493);
      END_STATE();
    case 1999:
      if (lookahead == 'e') ADVANCE(2712);
      END_STATE();
    case 2000:
      if (lookahead == 'e') ADVANCE(2495);
      END_STATE();
    case 2001:
      if (lookahead == 'e') ADVANCE(2395);
      END_STATE();
    case 2002:
      if (lookahead == 'e') ADVANCE(2676);
      if (lookahead == 't') ADVANCE(2553);
      END_STATE();
    case 2003:
      if (lookahead == 'e') ADVANCE(2487);
      END_STATE();
    case 2004:
      if (lookahead == 'e') ADVANCE(2397);
      END_STATE();
    case 2005:
      if (lookahead == 'e') ADVANCE(2403);
      END_STATE();
    case 2006:
      if (lookahead == 'e') ADVANCE(2725);
      END_STATE();
    case 2007:
      if (lookahead == 'e') ADVANCE(1542);
      END_STATE();
    case 2008:
      if (lookahead == 'e') ADVANCE(2363);
      if (lookahead == 'v') ADVANCE(1459);
      END_STATE();
    case 2009:
      if (lookahead == 'e') ADVANCE(1767);
      END_STATE();
    case 2010:
      if (lookahead == 'e') ADVANCE(2364);
      if (lookahead == 'v') ADVANCE(1525);
      END_STATE();
    case 2011:
      if (lookahead == 'e') ADVANCE(2407);
      END_STATE();
    case 2012:
      if (lookahead == 'f') ADVANCE(2408);
      if (lookahead == 'l') ADVANCE(2128);
      if (lookahead == 'r') ADVANCE(1603);
      if (lookahead == 't') ADVANCE(2827);
      END_STATE();
    case 2013:
      if (lookahead == 'f') ADVANCE(2348);
      END_STATE();
    case 2014:
      if (lookahead == 'f') ADVANCE(2348);
      if (lookahead == 'i') ADVANCE(2865);
      if (lookahead == 'l') ADVANCE(2515);
      END_STATE();
    case 2015:
      if (lookahead == 'f') ADVANCE(2348);
      if (lookahead == 'i') ADVANCE(2865);
      if (lookahead == 'l') ADVANCE(2515);
      if (lookahead == 'r') ADVANCE(3542);
      if (lookahead == 'u') ADVANCE(2162);
      if (lookahead == 'y') ADVANCE(2663);
      END_STATE();
    case 2016:
      if (lookahead == 'f') ADVANCE(2348);
      if (lookahead == 'i') ADVANCE(2865);
      if (lookahead == 'l') ADVANCE(2515);
      if (lookahead == 'u') ADVANCE(2162);
      if (lookahead == 'y') ADVANCE(2663);
      END_STATE();
    case 2017:
      if (lookahead == 'f') ADVANCE(2348);
      if (lookahead == 'u') ADVANCE(2162);
      if (lookahead == 'y') ADVANCE(2663);
      END_STATE();
    case 2018:
      if (lookahead == 'f') ADVANCE(3211);
      END_STATE();
    case 2019:
      if (lookahead == 'f') ADVANCE(3771);
      END_STATE();
    case 2020:
      if (lookahead == 'f') ADVANCE(3486);
      END_STATE();
    case 2021:
      if (lookahead == 'f') ADVANCE(3194);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 2022:
      if (lookahead == 'f') ADVANCE(3639);
      END_STATE();
    case 2023:
      if (lookahead == 'f') ADVANCE(3534);
      END_STATE();
    case 2024:
      if (lookahead == 'f') ADVANCE(3519);
      END_STATE();
    case 2025:
      if (lookahead == 'f') ADVANCE(2924);
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1356);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 2026:
      if (lookahead == 'f') ADVANCE(2046);
      END_STATE();
    case 2027:
      if (lookahead == 'f') ADVANCE(2524);
      if (lookahead == 'n') ADVANCE(2563);
      if (lookahead == 's') ADVANCE(2168);
      END_STATE();
    case 2028:
      if (lookahead == 'f') ADVANCE(2585);
      END_STATE();
    case 2029:
      if (lookahead == 'f') ADVANCE(2904);
      END_STATE();
    case 2030:
      if (lookahead == 'f') ADVANCE(2586);
      END_STATE();
    case 2031:
      if (lookahead == 'f') ADVANCE(2587);
      END_STATE();
    case 2032:
      if (lookahead == 'f') ADVANCE(2793);
      END_STATE();
    case 2033:
      if (lookahead == 'f') ADVANCE(2793);
      if (lookahead == 't') ADVANCE(1610);
      END_STATE();
    case 2034:
      if (lookahead == 'f') ADVANCE(1876);
      if (lookahead == 'm') ADVANCE(1878);
      if (lookahead == 'n') ADVANCE(2178);
      END_STATE();
    case 2035:
      if (lookahead == 'f') ADVANCE(1876);
      if (lookahead == 'n') ADVANCE(2178);
      END_STATE();
    case 2036:
      if (lookahead == 'f') ADVANCE(2590);
      END_STATE();
    case 2037:
      if (lookahead == 'f') ADVANCE(2109);
      END_STATE();
    case 2038:
      if (lookahead == 'f') ADVANCE(2737);
      END_STATE();
    case 2039:
      if (lookahead == 'f') ADVANCE(1483);
      END_STATE();
    case 2040:
      if (lookahead == 'f') ADVANCE(1483);
      if (lookahead == 'r') ADVANCE(1871);
      END_STATE();
    case 2041:
      if (lookahead == 'f') ADVANCE(1989);
      END_STATE();
    case 2042:
      if (lookahead == 'f') ADVANCE(2824);
      END_STATE();
    case 2043:
      if (lookahead == 'f') ADVANCE(2824);
      if (lookahead == 't') ADVANCE(1610);
      END_STATE();
    case 2044:
      if (lookahead == 'f') ADVANCE(2048);
      END_STATE();
    case 2045:
      if (lookahead == 'f') ADVANCE(2144);
      END_STATE();
    case 2046:
      if (lookahead == 'f') ADVANCE(2316);
      END_STATE();
    case 2047:
      if (lookahead == 'f') ADVANCE(2194);
      END_STATE();
    case 2048:
      if (lookahead == 'f') ADVANCE(1987);
      END_STATE();
    case 2049:
      if (lookahead == 'f') ADVANCE(2354);
      END_STATE();
    case 2050:
      if (lookahead == 'g') ADVANCE(3558);
      END_STATE();
    case 2051:
      if (lookahead == 'g') ADVANCE(3677);
      END_STATE();
    case 2052:
      if (lookahead == 'g') ADVANCE(3480);
      END_STATE();
    case 2053:
      if (lookahead == 'g') ADVANCE(3531);
      END_STATE();
    case 2054:
      if (lookahead == 'g') ADVANCE(3586);
      END_STATE();
    case 2055:
      if (lookahead == 'g') ADVANCE(3611);
      END_STATE();
    case 2056:
      if (lookahead == 'g') ADVANCE(3112);
      END_STATE();
    case 2057:
      if (lookahead == 'g') ADVANCE(3447);
      END_STATE();
    case 2058:
      if (lookahead == 'g') ADVANCE(3396);
      END_STATE();
    case 2059:
      if (lookahead == 'g') ADVANCE(3435);
      END_STATE();
    case 2060:
      if (lookahead == 'g') ADVANCE(3438);
      END_STATE();
    case 2061:
      if (lookahead == 'g') ADVANCE(2386);
      END_STATE();
    case 2062:
      if (lookahead == 'g') ADVANCE(2386);
      if (lookahead == 'm') ADVANCE(1300);
      END_STATE();
    case 2063:
      if (lookahead == 'g') ADVANCE(58);
      END_STATE();
    case 2064:
      if (lookahead == 'g') ADVANCE(2927);
      END_STATE();
    case 2065:
      if (lookahead == 'g') ADVANCE(2454);
      END_STATE();
    case 2066:
      if (lookahead == 'g') ADVANCE(2454);
      if (lookahead == 't') ADVANCE(2552);
      END_STATE();
    case 2067:
      if (lookahead == 'g') ADVANCE(2414);
      END_STATE();
    case 2068:
      if (lookahead == 'g') ADVANCE(2598);
      END_STATE();
    case 2069:
      if (lookahead == 'g') ADVANCE(2614);
      END_STATE();
    case 2070:
      if (lookahead == 'g') ADVANCE(1970);
      END_STATE();
    case 2071:
      if (lookahead == 'g') ADVANCE(1921);
      END_STATE();
    case 2072:
      if (lookahead == 'g') ADVANCE(2430);
      END_STATE();
    case 2073:
      if (lookahead == 'g') ADVANCE(1810);
      END_STATE();
    case 2074:
      if (lookahead == 'g') ADVANCE(1812);
      END_STATE();
    case 2075:
      if (lookahead == 'g') ADVANCE(1839);
      END_STATE();
    case 2076:
      if (lookahead == 'g') ADVANCE(1845);
      END_STATE();
    case 2077:
      if (lookahead == 'g') ADVANCE(2916);
      END_STATE();
    case 2078:
      if (lookahead == 'g') ADVANCE(1634);
      END_STATE();
    case 2079:
      if (lookahead == 'g') ADVANCE(1976);
      END_STATE();
    case 2080:
      if (lookahead == 'g') ADVANCE(2700);
      END_STATE();
    case 2081:
      if (lookahead == 'g') ADVANCE(2402);
      END_STATE();
    case 2082:
      if (lookahead == 'h') ADVANCE(1663);
      END_STATE();
    case 2083:
      if (lookahead == 'h') ADVANCE(108);
      END_STATE();
    case 2084:
      if (lookahead == 'h') ADVANCE(3650);
      END_STATE();
    case 2085:
      if (lookahead == 'h') ADVANCE(3563);
      END_STATE();
    case 2086:
      if (lookahead == 'h') ADVANCE(3574);
      END_STATE();
    case 2087:
      if (lookahead == 'h') ADVANCE(3648);
      END_STATE();
    case 2088:
      if (lookahead == 'h') ADVANCE(2612);
      END_STATE();
    case 2089:
      if (lookahead == 'h') ADVANCE(3800);
      END_STATE();
    case 2090:
      if (lookahead == 'h') ADVANCE(2636);
      END_STATE();
    case 2091:
      if (lookahead == 'h') ADVANCE(2636);
      if (lookahead == 'm') ADVANCE(3785);
      END_STATE();
    case 2092:
      if (lookahead == 'h') ADVANCE(2051);
      END_STATE();
    case 2093:
      if (lookahead == 'h') ADVANCE(2637);
      END_STATE();
    case 2094:
      if (lookahead == 'h') ADVANCE(2055);
      END_STATE();
    case 2095:
      if (lookahead == 'h') ADVANCE(1930);
      END_STATE();
    case 2096:
      if (lookahead == 'h') ADVANCE(1938);
      END_STATE();
    case 2097:
      if (lookahead == 'h') ADVANCE(2136);
      END_STATE();
    case 2098:
      if (lookahead == 'h') ADVANCE(1481);
      END_STATE();
    case 2099:
      if (lookahead == 'h') ADVANCE(2182);
      END_STATE();
    case 2100:
      if (lookahead == 'h') ADVANCE(2721);
      END_STATE();
    case 2101:
      if (lookahead == 'h') ADVANCE(1539);
      END_STATE();
    case 2102:
      if (lookahead == 'i') ADVANCE(2865);
      if (lookahead == 'l') ADVANCE(2515);
      END_STATE();
    case 2103:
      if (lookahead == 'i') ADVANCE(1408);
      if (lookahead == 'l') ADVANCE(2521);
      if (lookahead == 'w') ADVANCE(1367);
      END_STATE();
    case 2104:
      if (lookahead == 'i') ADVANCE(1408);
      if (lookahead == 'l') ADVANCE(2542);
      if (lookahead == 'w') ADVANCE(1367);
      END_STATE();
    case 2105:
      if (lookahead == 'i') ADVANCE(3588);
      END_STATE();
    case 2106:
      if (lookahead == 'i') ADVANCE(2033);
      END_STATE();
    case 2107:
      if (lookahead == 'i') ADVANCE(3750);
      END_STATE();
    case 2108:
      if (lookahead == 'i') ADVANCE(3748);
      END_STATE();
    case 2109:
      if (lookahead == 'i') ADVANCE(3088);
      END_STATE();
    case 2110:
      if (lookahead == 'i') ADVANCE(2940);
      END_STATE();
    case 2111:
      if (lookahead == 'i') ADVANCE(1726);
      END_STATE();
    case 2112:
      if (lookahead == 'i') ADVANCE(2409);
      if (lookahead == 's') ADVANCE(2093);
      END_STATE();
    case 2113:
      if (lookahead == 'i') ADVANCE(2944);
      if (lookahead == 'o') ADVANCE(2849);
      END_STATE();
    case 2114:
      if (lookahead == 'i') ADVANCE(2941);
      END_STATE();
    case 2115:
      if (lookahead == 'i') ADVANCE(2431);
      if (lookahead == 'n') ADVANCE(1409);
      if (lookahead == 's') ADVANCE(2952);
      if (lookahead == 'u') ADVANCE(2312);
      END_STATE();
    case 2116:
      if (lookahead == 'i') ADVANCE(2942);
      END_STATE();
    case 2117:
      if (lookahead == 'i') ADVANCE(1552);
      END_STATE();
    case 2118:
      if (lookahead == 'i') ADVANCE(2962);
      END_STATE();
    case 2119:
      if (lookahead == 'i') ADVANCE(2613);
      if (lookahead == 'u') ADVANCE(1793);
      END_STATE();
    case 2120:
      if (lookahead == 'i') ADVANCE(2235);
      if (lookahead == 'r') ADVANCE(2071);
      END_STATE();
    case 2121:
      if (lookahead == 'i') ADVANCE(1702);
      END_STATE();
    case 2122:
      if (lookahead == 'i') ADVANCE(1702);
      if (lookahead == 'l') ADVANCE(1446);
      END_STATE();
    case 2123:
      if (lookahead == 'i') ADVANCE(2769);
      END_STATE();
    case 2124:
      if (lookahead == 'i') ADVANCE(2032);
      END_STATE();
    case 2125:
      if (lookahead == 'i') ADVANCE(2442);
      END_STATE();
    case 2126:
      if (lookahead == 'i') ADVANCE(1582);
      END_STATE();
    case 2127:
      if (lookahead == 'i') ADVANCE(2067);
      if (lookahead == 'l') ADVANCE(2521);
      if (lookahead == 'w') ADVANCE(1367);
      END_STATE();
    case 2128:
      if (lookahead == 'i') ADVANCE(2067);
      if (lookahead == 'l') ADVANCE(2542);
      if (lookahead == 'w') ADVANCE(1367);
      END_STATE();
    case 2129:
      if (lookahead == 'i') ADVANCE(2241);
      END_STATE();
    case 2130:
      if (lookahead == 'i') ADVANCE(1433);
      END_STATE();
    case 2131:
      if (lookahead == 'i') ADVANCE(2072);
      END_STATE();
    case 2132:
      if (lookahead == 'i') ADVANCE(2476);
      END_STATE();
    case 2133:
      if (lookahead == 'i') ADVANCE(2748);
      END_STATE();
    case 2134:
      if (lookahead == 'i') ADVANCE(2832);
      END_STATE();
    case 2135:
      if (lookahead == 'i') ADVANCE(1668);
      END_STATE();
    case 2136:
      if (lookahead == 'i') ADVANCE(2421);
      END_STATE();
    case 2137:
      if (lookahead == 'i') ADVANCE(2246);
      END_STATE();
    case 2138:
      if (lookahead == 'i') ADVANCE(2422);
      END_STATE();
    case 2139:
      if (lookahead == 'i') ADVANCE(2446);
      END_STATE();
    case 2140:
      if (lookahead == 'i') ADVANCE(1590);
      END_STATE();
    case 2141:
      if (lookahead == 'i') ADVANCE(2775);
      if (lookahead == 'o') ADVANCE(2902);
      END_STATE();
    case 2142:
      if (lookahead == 'i') ADVANCE(1714);
      END_STATE();
    case 2143:
      if (lookahead == 'i') ADVANCE(2497);
      END_STATE();
    case 2144:
      if (lookahead == 'i') ADVANCE(2346);
      END_STATE();
    case 2145:
      if (lookahead == 'i') ADVANCE(2438);
      END_STATE();
    case 2146:
      if (lookahead == 'i') ADVANCE(1592);
      END_STATE();
    case 2147:
      if (lookahead == 'i') ADVANCE(2425);
      END_STATE();
    case 2148:
      if (lookahead == 'i') ADVANCE(2490);
      END_STATE();
    case 2149:
      if (lookahead == 'i') ADVANCE(1643);
      END_STATE();
    case 2150:
      if (lookahead == 'i') ADVANCE(2450);
      END_STATE();
    case 2151:
      if (lookahead == 'i') ADVANCE(1598);
      END_STATE();
    case 2152:
      if (lookahead == 'i') ADVANCE(2440);
      END_STATE();
    case 2153:
      if (lookahead == 'i') ADVANCE(2274);
      if (lookahead == 'r') ADVANCE(2169);
      END_STATE();
    case 2154:
      if (lookahead == 'i') ADVANCE(2482);
      END_STATE();
    case 2155:
      if (lookahead == 'i') ADVANCE(2444);
      END_STATE();
    case 2156:
      if (lookahead == 'i') ADVANCE(2837);
      END_STATE();
    case 2157:
      if (lookahead == 'i') ADVANCE(2835);
      END_STATE();
    case 2158:
      if (lookahead == 'i') ADVANCE(2881);
      END_STATE();
    case 2159:
      if (lookahead == 'i') ADVANCE(2043);
      END_STATE();
    case 2160:
      if (lookahead == 'i') ADVANCE(2996);
      END_STATE();
    case 2161:
      if (lookahead == 'i') ADVANCE(1568);
      END_STATE();
    case 2162:
      if (lookahead == 'i') ADVANCE(2339);
      END_STATE();
    case 2163:
      if (lookahead == 'i') ADVANCE(2949);
      END_STATE();
    case 2164:
      if (lookahead == 'i') ADVANCE(2361);
      END_STATE();
    case 2165:
      if (lookahead == 'i') ADVANCE(2459);
      END_STATE();
    case 2166:
      if (lookahead == 'i') ADVANCE(2477);
      END_STATE();
    case 2167:
      if (lookahead == 'i') ADVANCE(2042);
      END_STATE();
    case 2168:
      if (lookahead == 'i') ADVANCE(2997);
      END_STATE();
    case 2169:
      if (lookahead == 'i') ADVANCE(2852);
      END_STATE();
    case 2170:
      if (lookahead == 'i') ADVANCE(1632);
      END_STATE();
    case 2171:
      if (lookahead == 'i') ADVANCE(2462);
      END_STATE();
    case 2172:
      if (lookahead == 'i') ADVANCE(2460);
      END_STATE();
    case 2173:
      if (lookahead == 'i') ADVANCE(2998);
      END_STATE();
    case 2174:
      if (lookahead == 'i') ADVANCE(1682);
      END_STATE();
    case 2175:
      if (lookahead == 'i') ADVANCE(2999);
      END_STATE();
    case 2176:
      if (lookahead == 'i') ADVANCE(2486);
      END_STATE();
    case 2177:
      if (lookahead == 'i') ADVANCE(2720);
      END_STATE();
    case 2178:
      if (lookahead == 'i') ADVANCE(2892);
      END_STATE();
    case 2179:
      if (lookahead == 'i') ADVANCE(2471);
      END_STATE();
    case 2180:
      if (lookahead == 'i') ADVANCE(2532);
      END_STATE();
    case 2181:
      if (lookahead == 'i') ADVANCE(3000);
      END_STATE();
    case 2182:
      if (lookahead == 'i') ADVANCE(2465);
      END_STATE();
    case 2183:
      if (lookahead == 'i') ADVANCE(3001);
      END_STATE();
    case 2184:
      if (lookahead == 'i') ADVANCE(2688);
      END_STATE();
    case 2185:
      if (lookahead == 'i') ADVANCE(1653);
      END_STATE();
    case 2186:
      if (lookahead == 'i') ADVANCE(3002);
      END_STATE();
    case 2187:
      if (lookahead == 'i') ADVANCE(2474);
      END_STATE();
    case 2188:
      if (lookahead == 'i') ADVANCE(3003);
      END_STATE();
    case 2189:
      if (lookahead == 'i') ADVANCE(2543);
      END_STATE();
    case 2190:
      if (lookahead == 'i') ADVANCE(2319);
      END_STATE();
    case 2191:
      if (lookahead == 'i') ADVANCE(3004);
      END_STATE();
    case 2192:
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 2193:
      if (lookahead == 'i') ADVANCE(2546);
      END_STATE();
    case 2194:
      if (lookahead == 'i') ADVANCE(2322);
      END_STATE();
    case 2195:
      if (lookahead == 'i') ADVANCE(2771);
      END_STATE();
    case 2196:
      if (lookahead == 'i') ADVANCE(2344);
      END_STATE();
    case 2197:
      if (lookahead == 'i') ADVANCE(2344);
      if (lookahead == 'r') ADVANCE(2071);
      END_STATE();
    case 2198:
      if (lookahead == 'i') ADVANCE(2890);
      END_STATE();
    case 2199:
      if (lookahead == 'i') ADVANCE(1513);
      END_STATE();
    case 2200:
      if (lookahead == 'i') ADVANCE(1518);
      END_STATE();
    case 2201:
      if (lookahead == 'i') ADVANCE(2889);
      END_STATE();
    case 2202:
      if (lookahead == 'i') ADVANCE(2353);
      END_STATE();
    case 2203:
      if (lookahead == 'i') ADVANCE(2726);
      END_STATE();
    case 2204:
      if (lookahead == 'i') ADVANCE(2893);
      END_STATE();
    case 2205:
      if (lookahead == 'i') ADVANCE(1544);
      END_STATE();
    case 2206:
      if (lookahead == 'i') ADVANCE(2897);
      END_STATE();
    case 2207:
      if (lookahead == 'i') ADVANCE(1684);
      END_STATE();
    case 2208:
      if (lookahead == 'i') ADVANCE(2894);
      END_STATE();
    case 2209:
      if (lookahead == 'i') ADVANCE(2500);
      END_STATE();
    case 2210:
      if (lookahead == 'j') ADVANCE(3171);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 2211:
      if (lookahead == 'j') ADVANCE(2931);
      END_STATE();
    case 2212:
      if (lookahead == 'k') ADVANCE(3099);
      END_STATE();
    case 2213:
      if (lookahead == 'k') ADVANCE(3420);
      END_STATE();
    case 2214:
      if (lookahead == 'k') ADVANCE(3299);
      END_STATE();
    case 2215:
      if (lookahead == 'k') ADVANCE(3459);
      END_STATE();
    case 2216:
      if (lookahead == 'k') ADVANCE(3118);
      END_STATE();
    case 2217:
      if (lookahead == 'k') ADVANCE(3462);
      END_STATE();
    case 2218:
      if (lookahead == 'k') ADVANCE(3096);
      END_STATE();
    case 2219:
      if (lookahead == 'k') ADVANCE(2571);
      END_STATE();
    case 2220:
      if (lookahead == 'k') ADVANCE(1894);
      END_STATE();
    case 2221:
      if (lookahead == 'k') ADVANCE(1894);
      if (lookahead == 'n') ADVANCE(1699);
      END_STATE();
    case 2222:
      if (lookahead == 'k') ADVANCE(1477);
      END_STATE();
    case 2223:
      if (lookahead == 'k') ADVANCE(2134);
      END_STATE();
    case 2224:
      if (lookahead == 'k') ADVANCE(1801);
      END_STATE();
    case 2225:
      if (lookahead == 'k') ADVANCE(1900);
      END_STATE();
    case 2226:
      if (lookahead == 'k') ADVANCE(1639);
      END_STATE();
    case 2227:
      if (lookahead == 'l') ADVANCE(2018);
      END_STATE();
    case 2228:
      if (lookahead == 'l') ADVANCE(3655);
      END_STATE();
    case 2229:
      if (lookahead == 'l') ADVANCE(3655);
      if (lookahead == 's') ADVANCE(2785);
      END_STATE();
    case 2230:
      if (lookahead == 'l') ADVANCE(3655);
      if (lookahead == 's') ADVANCE(2844);
      END_STATE();
    case 2231:
      if (lookahead == 'l') ADVANCE(3661);
      if (lookahead == 'u') ADVANCE(2026);
      END_STATE();
    case 2232:
      if (lookahead == 'l') ADVANCE(3601);
      END_STATE();
    case 2233:
      if (lookahead == 'l') ADVANCE(3671);
      END_STATE();
    case 2234:
      if (lookahead == 'l') ADVANCE(3634);
      END_STATE();
    case 2235:
      if (lookahead == 'l') ADVANCE(3593);
      END_STATE();
    case 2236:
      if (lookahead == 'l') ADVANCE(3483);
      END_STATE();
    case 2237:
      if (lookahead == 'l') ADVANCE(1308);
      if (lookahead == 'r') ADVANCE(2484);
      END_STATE();
    case 2238:
      if (lookahead == 'l') ADVANCE(3233);
      END_STATE();
    case 2239:
      if (lookahead == 'l') ADVANCE(1324);
      END_STATE();
    case 2240:
      if (lookahead == 'l') ADVANCE(3790);
      END_STATE();
    case 2241:
      if (lookahead == 'l') ADVANCE(3597);
      END_STATE();
    case 2242:
      if (lookahead == 'l') ADVANCE(3764);
      END_STATE();
    case 2243:
      if (lookahead == 'l') ADVANCE(3510);
      END_STATE();
    case 2244:
      if (lookahead == 'l') ADVANCE(3123);
      END_STATE();
    case 2245:
      if (lookahead == 'l') ADVANCE(3093);
      END_STATE();
    case 2246:
      if (lookahead == 'l') ADVANCE(3595);
      END_STATE();
    case 2247:
      if (lookahead == 'l') ADVANCE(3126);
      END_STATE();
    case 2248:
      if (lookahead == 'l') ADVANCE(3794);
      END_STATE();
    case 2249:
      if (lookahead == 'l') ADVANCE(3516);
      END_STATE();
    case 2250:
      if (lookahead == 'l') ADVANCE(3599);
      END_STATE();
    case 2251:
      if (lookahead == 'l') ADVANCE(3121);
      END_STATE();
    case 2252:
      if (lookahead == 'l') ADVANCE(3631);
      END_STATE();
    case 2253:
      if (lookahead == 'l') ADVANCE(2757);
      if (lookahead == 's') ADVANCE(2823);
      END_STATE();
    case 2254:
      if (lookahead == 'l') ADVANCE(1875);
      END_STATE();
    case 2255:
      if (lookahead == 'l') ADVANCE(2512);
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 2256:
      if (lookahead == 'l') ADVANCE(1957);
      END_STATE();
    case 2257:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'q') ADVANCE(3708);
      if (lookahead == 'x') ADVANCE(1412);
      END_STATE();
    case 2258:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'x') ADVANCE(1414);
      END_STATE();
    case 2259:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'x') ADVANCE(2895);
      END_STATE();
    case 2260:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'x') ADVANCE(2869);
      END_STATE();
    case 2261:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'x') ADVANCE(1517);
      END_STATE();
    case 2262:
      if (lookahead == 'l') ADVANCE(1957);
      if (lookahead == 'x') ADVANCE(1413);
      END_STATE();
    case 2263:
      if (lookahead == 'l') ADVANCE(1696);
      if (lookahead == 'm') ADVANCE(1755);
      if (lookahead == 'n') ADVANCE(2743);
      END_STATE();
    case 2264:
      if (lookahead == 'l') ADVANCE(1696);
      if (lookahead == 'm') ADVANCE(2381);
      if (lookahead == 'n') ADVANCE(2834);
      END_STATE();
    case 2265:
      if (lookahead == 'l') ADVANCE(1696);
      if (lookahead == 'm') ADVANCE(2381);
      if (lookahead == 'n') ADVANCE(2951);
      END_STATE();
    case 2266:
      if (lookahead == 'l') ADVANCE(2232);
      if (lookahead == 't') ADVANCE(1605);
      END_STATE();
    case 2267:
      if (lookahead == 'l') ADVANCE(2232);
      if (lookahead == 't') ADVANCE(1624);
      END_STATE();
    case 2268:
      if (lookahead == 'l') ADVANCE(2976);
      END_STATE();
    case 2269:
      if (lookahead == 'l') ADVANCE(2977);
      END_STATE();
    case 2270:
      if (lookahead == 'l') ADVANCE(2978);
      END_STATE();
    case 2271:
      if (lookahead == 'l') ADVANCE(2234);
      END_STATE();
    case 2272:
      if (lookahead == 'l') ADVANCE(2234);
      if (lookahead == 'w') ADVANCE(3561);
      END_STATE();
    case 2273:
      if (lookahead == 'l') ADVANCE(2985);
      END_STATE();
    case 2274:
      if (lookahead == 'l') ADVANCE(2343);
      END_STATE();
    case 2275:
      if (lookahead == 'l') ADVANCE(2343);
      if (lookahead == 'n') ADVANCE(3015);
      END_STATE();
    case 2276:
      if (lookahead == 'l') ADVANCE(2343);
      if (lookahead == 'n') ADVANCE(3015);
      if (lookahead == 't') ADVANCE(2097);
      END_STATE();
    case 2277:
      if (lookahead == 'l') ADVANCE(1510);
      END_STATE();
    case 2278:
      if (lookahead == 'l') ADVANCE(2981);
      END_STATE();
    case 2279:
      if (lookahead == 'l') ADVANCE(1400);
      if (lookahead == 'n') ADVANCE(2908);
      END_STATE();
    case 2280:
      if (lookahead == 'l') ADVANCE(2982);
      END_STATE();
    case 2281:
      if (lookahead == 'l') ADVANCE(2983);
      END_STATE();
    case 2282:
      if (lookahead == 'l') ADVANCE(2547);
      END_STATE();
    case 2283:
      if (lookahead == 'l') ADVANCE(2547);
      if (lookahead == 't') ADVANCE(1915);
      END_STATE();
    case 2284:
      if (lookahead == 'l') ADVANCE(2024);
      END_STATE();
    case 2285:
      if (lookahead == 'l') ADVANCE(2130);
      END_STATE();
    case 2286:
      if (lookahead == 'l') ADVANCE(1902);
      END_STATE();
    case 2287:
      if (lookahead == 'l') ADVANCE(1399);
      END_STATE();
    case 2288:
      if (lookahead == 'l') ADVANCE(2738);
      END_STATE();
    case 2289:
      if (lookahead == 'l') ADVANCE(2123);
      END_STATE();
    case 2290:
      if (lookahead == 'l') ADVANCE(1962);
      if (lookahead == 'q') ADVANCE(1315);
      if (lookahead == 'x') ADVANCE(2787);
      END_STATE();
    case 2291:
      if (lookahead == 'l') ADVANCE(1962);
      if (lookahead == 'x') ADVANCE(2787);
      END_STATE();
    case 2292:
      if (lookahead == 'l') ADVANCE(1323);
      END_STATE();
    case 2293:
      if (lookahead == 'l') ADVANCE(2243);
      END_STATE();
    case 2294:
      if (lookahead == 'l') ADVANCE(1325);
      END_STATE();
    case 2295:
      if (lookahead == 'l') ADVANCE(2174);
      END_STATE();
    case 2296:
      if (lookahead == 'l') ADVANCE(2800);
      END_STATE();
    case 2297:
      if (lookahead == 'l') ADVANCE(2142);
      END_STATE();
    case 2298:
      if (lookahead == 'l') ADVANCE(2350);
      END_STATE();
    case 2299:
      if (lookahead == 'l') ADVANCE(2338);
      END_STATE();
    case 2300:
      if (lookahead == 'l') ADVANCE(1716);
      if (lookahead == 'm') ADVANCE(1755);
      if (lookahead == 'n') ADVANCE(2834);
      END_STATE();
    case 2301:
      if (lookahead == 'l') ADVANCE(1716);
      if (lookahead == 'm') ADVANCE(1755);
      if (lookahead == 'n') ADVANCE(2951);
      END_STATE();
    case 2302:
      if (lookahead == 'l') ADVANCE(1716);
      if (lookahead == 'm') ADVANCE(1754);
      if (lookahead == 'n') ADVANCE(2743);
      END_STATE();
    case 2303:
      if (lookahead == 'l') ADVANCE(1716);
      if (lookahead == 'm') ADVANCE(1754);
      if (lookahead == 'n') ADVANCE(2834);
      END_STATE();
    case 2304:
      if (lookahead == 'l') ADVANCE(2280);
      END_STATE();
    case 2305:
      if (lookahead == 'l') ADVANCE(2249);
      END_STATE();
    case 2306:
      if (lookahead == 'l') ADVANCE(2250);
      if (lookahead == 't') ADVANCE(1621);
      END_STATE();
    case 2307:
      if (lookahead == 'l') ADVANCE(1799);
      END_STATE();
    case 2308:
      if (lookahead == 'l') ADVANCE(1802);
      END_STATE();
    case 2309:
      if (lookahead == 'l') ADVANCE(2294);
      END_STATE();
    case 2310:
      if (lookahead == 'l') ADVANCE(2273);
      END_STATE();
    case 2311:
      if (lookahead == 'l') ADVANCE(2252);
      END_STATE();
    case 2312:
      if (lookahead == 'l') ADVANCE(2252);
      if (lookahead == 'w') ADVANCE(3561);
      END_STATE();
    case 2313:
      if (lookahead == 'l') ADVANCE(1806);
      END_STATE();
    case 2314:
      if (lookahead == 'l') ADVANCE(1807);
      END_STATE();
    case 2315:
      if (lookahead == 'l') ADVANCE(1885);
      END_STATE();
    case 2316:
      if (lookahead == 'l') ADVANCE(1963);
      END_STATE();
    case 2317:
      if (lookahead == 'l') ADVANCE(1817);
      END_STATE();
    case 2318:
      if (lookahead == 'l') ADVANCE(1968);
      END_STATE();
    case 2319:
      if (lookahead == 'l') ADVANCE(1823);
      END_STATE();
    case 2320:
      if (lookahead == 'l') ADVANCE(1898);
      END_STATE();
    case 2321:
      if (lookahead == 'l') ADVANCE(1826);
      END_STATE();
    case 2322:
      if (lookahead == 'l') ADVANCE(1828);
      END_STATE();
    case 2323:
      if (lookahead == 'l') ADVANCE(1835);
      END_STATE();
    case 2324:
      if (lookahead == 'l') ADVANCE(1838);
      END_STATE();
    case 2325:
      if (lookahead == 'l') ADVANCE(1917);
      END_STATE();
    case 2326:
      if (lookahead == 'l') ADVANCE(1842);
      END_STATE();
    case 2327:
      if (lookahead == 'l') ADVANCE(1843);
      END_STATE();
    case 2328:
      if (lookahead == 'l') ADVANCE(1918);
      END_STATE();
    case 2329:
      if (lookahead == 'l') ADVANCE(1942);
      END_STATE();
    case 2330:
      if (lookahead == 'l') ADVANCE(1851);
      END_STATE();
    case 2331:
      if (lookahead == 'l') ADVANCE(2848);
      END_STATE();
    case 2332:
      if (lookahead == 'l') ADVANCE(2565);
      END_STATE();
    case 2333:
      if (lookahead == 'l') ADVANCE(2135);
      END_STATE();
    case 2334:
      if (lookahead == 'l') ADVANCE(2572);
      if (lookahead == 'p') ADVANCE(2705);
      END_STATE();
    case 2335:
      if (lookahead == 'l') ADVANCE(2917);
      END_STATE();
    case 2336:
      if (lookahead == 'l') ADVANCE(2157);
      END_STATE();
    case 2337:
      if (lookahead == 'l') ADVANCE(2557);
      END_STATE();
    case 2338:
      if (lookahead == 'l') ADVANCE(1636);
      END_STATE();
    case 2339:
      if (lookahead == 'l') ADVANCE(2878);
      END_STATE();
    case 2340:
      if (lookahead == 'l') ADVANCE(2918);
      END_STATE();
    case 2341:
      if (lookahead == 'l') ADVANCE(1468);
      END_STATE();
    case 2342:
      if (lookahead == 'l') ADVANCE(2578);
      END_STATE();
    case 2343:
      if (lookahead == 'l') ADVANCE(2687);
      END_STATE();
    case 2344:
      if (lookahead == 'l') ADVANCE(1642);
      END_STATE();
    case 2345:
      if (lookahead == 'l') ADVANCE(1307);
      if (lookahead == 'r') ADVANCE(2484);
      END_STATE();
    case 2346:
      if (lookahead == 'l') ADVANCE(2000);
      END_STATE();
    case 2347:
      if (lookahead == 'l') ADVANCE(2329);
      END_STATE();
    case 2348:
      if (lookahead == 'l') ADVANCE(2559);
      END_STATE();
    case 2349:
      if (lookahead == 'l') ADVANCE(1977);
      END_STATE();
    case 2350:
      if (lookahead == 'l') ADVANCE(2776);
      END_STATE();
    case 2351:
      if (lookahead == 'l') ADVANCE(2179);
      END_STATE();
    case 2352:
      if (lookahead == 'l') ADVANCE(2342);
      END_STATE();
    case 2353:
      if (lookahead == 'l') ADVANCE(2885);
      END_STATE();
    case 2354:
      if (lookahead == 'l') ADVANCE(2564);
      END_STATE();
    case 2355:
      if (lookahead == 'l') ADVANCE(2187);
      END_STATE();
    case 2356:
      if (lookahead == 'l') ADVANCE(1991);
      END_STATE();
    case 2357:
      if (lookahead == 'l') ADVANCE(1990);
      END_STATE();
    case 2358:
      if (lookahead == 'l') ADVANCE(2186);
      END_STATE();
    case 2359:
      if (lookahead == 'l') ADVANCE(2191);
      END_STATE();
    case 2360:
      if (lookahead == 'l') ADVANCE(2001);
      END_STATE();
    case 2361:
      if (lookahead == 'l') ADVANCE(1537);
      END_STATE();
    case 2362:
      if (lookahead == 'l') ADVANCE(2576);
      END_STATE();
    case 2363:
      if (lookahead == 'l') ADVANCE(2004);
      END_STATE();
    case 2364:
      if (lookahead == 'l') ADVANCE(2005);
      END_STATE();
    case 2365:
      if (lookahead == 'l') ADVANCE(2207);
      END_STATE();
    case 2366:
      if (lookahead == 'm') ADVANCE(3675);
      END_STATE();
    case 2367:
      if (lookahead == 'm') ADVANCE(3571);
      END_STATE();
    case 2368:
      if (lookahead == 'm') ADVANCE(3659);
      END_STATE();
    case 2369:
      if (lookahead == 'm') ADVANCE(3659);
      if (lookahead == 't') ADVANCE(3492);
      END_STATE();
    case 2370:
      if (lookahead == 'm') ADVANCE(3657);
      END_STATE();
    case 2371:
      if (lookahead == 'm') ADVANCE(1329);
      END_STATE();
    case 2372:
      if (lookahead == 'm') ADVANCE(2533);
      END_STATE();
    case 2373:
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1362);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 2374:
      if (lookahead == 'm') ADVANCE(2377);
      if (lookahead == 'n') ADVANCE(1359);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 2375:
      if (lookahead == 'm') ADVANCE(3018);
      END_STATE();
    case 2376:
      if (lookahead == 'm') ADVANCE(2953);
      END_STATE();
    case 2377:
      if (lookahead == 'm') ADVANCE(1427);
      END_STATE();
    case 2378:
      if (lookahead == 'm') ADVANCE(2583);
      END_STATE();
    case 2379:
      if (lookahead == 'm') ADVANCE(2584);
      END_STATE();
    case 2380:
      if (lookahead == 'm') ADVANCE(2622);
      END_STATE();
    case 2381:
      if (lookahead == 'm') ADVANCE(2523);
      END_STATE();
    case 2382:
      if (lookahead == 'm') ADVANCE(2963);
      END_STATE();
    case 2383:
      if (lookahead == 'm') ADVANCE(2126);
      END_STATE();
    case 2384:
      if (lookahead == 'm') ADVANCE(2964);
      END_STATE();
    case 2385:
      if (lookahead == 'm') ADVANCE(2589);
      END_STATE();
    case 2386:
      if (lookahead == 'm') ADVANCE(1879);
      END_STATE();
    case 2387:
      if (lookahead == 'm') ADVANCE(1534);
      END_STATE();
    case 2388:
      if (lookahead == 'm') ADVANCE(1805);
      END_STATE();
    case 2389:
      if (lookahead == 'm') ADVANCE(1913);
      END_STATE();
    case 2390:
      if (lookahead == 'm') ADVANCE(1888);
      END_STATE();
    case 2391:
      if (lookahead == 'm') ADVANCE(1844);
      END_STATE();
    case 2392:
      if (lookahead == 'm') ADVANCE(1911);
      END_STATE();
    case 2393:
      if (lookahead == 'm') ADVANCE(2146);
      END_STATE();
    case 2394:
      if (lookahead == 'm') ADVANCE(2149);
      END_STATE();
    case 2395:
      if (lookahead == 'm') ADVANCE(1982);
      END_STATE();
    case 2396:
      if (lookahead == 'm') ADVANCE(2151);
      END_STATE();
    case 2397:
      if (lookahead == 'm') ADVANCE(1986);
      END_STATE();
    case 2398:
      if (lookahead == 'm') ADVANCE(2539);
      END_STATE();
    case 2399:
      if (lookahead == 'm') ADVANCE(1946);
      END_STATE();
    case 2400:
      if (lookahead == 'm') ADVANCE(2545);
      END_STATE();
    case 2401:
      if (lookahead == 'm') ADVANCE(2616);
      if (lookahead == 'n') ADVANCE(2351);
      END_STATE();
    case 2402:
      if (lookahead == 'm') ADVANCE(1996);
      END_STATE();
    case 2403:
      if (lookahead == 'm') ADVANCE(1988);
      END_STATE();
    case 2404:
      if (lookahead == 'm') ADVANCE(2381);
      END_STATE();
    case 2405:
      if (lookahead == 'm') ADVANCE(2619);
      END_STATE();
    case 2406:
      if (lookahead == 'm') ADVANCE(2009);
      END_STATE();
    case 2407:
      if (lookahead == 'm') ADVANCE(2624);
      END_STATE();
    case 2408:
      if (lookahead == 'n') ADVANCE(3775);
      END_STATE();
    case 2409:
      if (lookahead == 'n') ADVANCE(2219);
      END_STATE();
    case 2410:
      if (lookahead == 'n') ADVANCE(3699);
      END_STATE();
    case 2411:
      if (lookahead == 'n') ADVANCE(3770);
      END_STATE();
    case 2412:
      if (lookahead == 'n') ADVANCE(1745);
      END_STATE();
    case 2413:
      if (lookahead == 'n') ADVANCE(3702);
      END_STATE();
    case 2414:
      if (lookahead == 'n') ADVANCE(3284);
      END_STATE();
    case 2415:
      if (lookahead == 'n') ADVANCE(3247);
      END_STATE();
    case 2416:
      if (lookahead == 'n') ADVANCE(3115);
      END_STATE();
    case 2417:
      if (lookahead == 'n') ADVANCE(1302);
      END_STATE();
    case 2418:
      if (lookahead == 'n') ADVANCE(3133);
      END_STATE();
    case 2419:
      if (lookahead == 'n') ADVANCE(3642);
      END_STATE();
    case 2420:
      if (lookahead == 'n') ADVANCE(1919);
      END_STATE();
    case 2421:
      if (lookahead == 'n') ADVANCE(3779);
      END_STATE();
    case 2422:
      if (lookahead == 'n') ADVANCE(3308);
      END_STATE();
    case 2423:
      if (lookahead == 'n') ADVANCE(3285);
      END_STATE();
    case 2424:
      if (lookahead == 'n') ADVANCE(3375);
      END_STATE();
    case 2425:
      if (lookahead == 'n') ADVANCE(3345);
      END_STATE();
    case 2426:
      if (lookahead == 'n') ADVANCE(3287);
      END_STATE();
    case 2427:
      if (lookahead == 'n') ADVANCE(3381);
      END_STATE();
    case 2428:
      if (lookahead == 'n') ADVANCE(3318);
      END_STATE();
    case 2429:
      if (lookahead == 'n') ADVANCE(3696);
      END_STATE();
    case 2430:
      if (lookahead == 'n') ADVANCE(3281);
      END_STATE();
    case 2431:
      if (lookahead == 'n') ADVANCE(2019);
      END_STATE();
    case 2432:
      if (lookahead == 'n') ADVANCE(2548);
      END_STATE();
    case 2433:
      if (lookahead == 'n') ADVANCE(1635);
      END_STATE();
    case 2434:
      if (lookahead == 'n') ADVANCE(1492);
      if (lookahead == 'o') ADVANCE(2696);
      if (lookahead == 'w') ADVANCE(2125);
      END_STATE();
    case 2435:
      if (lookahead == 'n') ADVANCE(1699);
      END_STATE();
    case 2436:
      if (lookahead == 'n') ADVANCE(1617);
      END_STATE();
    case 2437:
      if (lookahead == 'n') ADVANCE(2907);
      END_STATE();
    case 2438:
      if (lookahead == 'n') ADVANCE(2056);
      END_STATE();
    case 2439:
      if (lookahead == 'n') ADVANCE(2057);
      END_STATE();
    case 2440:
      if (lookahead == 'n') ADVANCE(2058);
      END_STATE();
    case 2441:
      if (lookahead == 'n') ADVANCE(1580);
      END_STATE();
    case 2442:
      if (lookahead == 'n') ADVANCE(1704);
      END_STATE();
    case 2443:
      if (lookahead == 'n') ADVANCE(1728);
      END_STATE();
    case 2444:
      if (lookahead == 'n') ADVANCE(2060);
      END_STATE();
    case 2445:
      if (lookahead == 'n') ADVANCE(1585);
      END_STATE();
    case 2446:
      if (lookahead == 'n') ADVANCE(1706);
      END_STATE();
    case 2447:
      if (lookahead == 'n') ADVANCE(1586);
      END_STATE();
    case 2448:
      if (lookahead == 'n') ADVANCE(2268);
      END_STATE();
    case 2449:
      if (lookahead == 'n') ADVANCE(1523);
      END_STATE();
    case 2450:
      if (lookahead == 'n') ADVANCE(1711);
      END_STATE();
    case 2451:
      if (lookahead == 'n') ADVANCE(2269);
      END_STATE();
    case 2452:
      if (lookahead == 'n') ADVANCE(2270);
      END_STATE();
    case 2453:
      if (lookahead == 'n') ADVANCE(2853);
      END_STATE();
    case 2454:
      if (lookahead == 'n') ADVANCE(1960);
      END_STATE();
    case 2455:
      if (lookahead == 'n') ADVANCE(2278);
      END_STATE();
    case 2456:
      if (lookahead == 'n') ADVANCE(2806);
      END_STATE();
    case 2457:
      if (lookahead == 'n') ADVANCE(2502);
      END_STATE();
    case 2458:
      if (lookahead == 'n') ADVANCE(2281);
      END_STATE();
    case 2459:
      if (lookahead == 'n') ADVANCE(1798);
      END_STATE();
    case 2460:
      if (lookahead == 'n') ADVANCE(2810);
      END_STATE();
    case 2461:
      if (lookahead == 'n') ADVANCE(1597);
      END_STATE();
    case 2462:
      if (lookahead == 'n') ADVANCE(1995);
      END_STATE();
    case 2463:
      if (lookahead == 'n') ADVANCE(2813);
      END_STATE();
    case 2464:
      if (lookahead == 'n') ADVANCE(2872);
      END_STATE();
    case 2465:
      if (lookahead == 'n') ADVANCE(2815);
      END_STATE();
    case 2466:
      if (lookahead == 'n') ADVANCE(2819);
      END_STATE();
    case 2467:
      if (lookahead == 'n') ADVANCE(2820);
      END_STATE();
    case 2468:
      if (lookahead == 'n') ADVANCE(2822);
      END_STATE();
    case 2469:
      if (lookahead == 'n') ADVANCE(1813);
      END_STATE();
    case 2470:
      if (lookahead == 'n') ADVANCE(2833);
      END_STATE();
    case 2471:
      if (lookahead == 'n') ADVANCE(1819);
      END_STATE();
    case 2472:
      if (lookahead == 'n') ADVANCE(1821);
      END_STATE();
    case 2473:
      if (lookahead == 'n') ADVANCE(1830);
      END_STATE();
    case 2474:
      if (lookahead == 'n') ADVANCE(1836);
      END_STATE();
    case 2475:
      if (lookahead == 'n') ADVANCE(1303);
      END_STATE();
    case 2476:
      if (lookahead == 'n') ADVANCE(2069);
      END_STATE();
    case 2477:
      if (lookahead == 'n') ADVANCE(2201);
      END_STATE();
    case 2478:
      if (lookahead == 'n') ADVANCE(2073);
      END_STATE();
    case 2479:
      if (lookahead == 'n') ADVANCE(2912);
      END_STATE();
    case 2480:
      if (lookahead == 'n') ADVANCE(2140);
      END_STATE();
    case 2481:
      if (lookahead == 'n') ADVANCE(1650);
      END_STATE();
    case 2482:
      if (lookahead == 'n') ADVANCE(2761);
      END_STATE();
    case 2483:
      if (lookahead == 'n') ADVANCE(2933);
      END_STATE();
    case 2484:
      if (lookahead == 'n') ADVANCE(1450);
      END_STATE();
    case 2485:
      if (lookahead == 'n') ADVANCE(2075);
      END_STATE();
    case 2486:
      if (lookahead == 'n') ADVANCE(1638);
      END_STATE();
    case 2487:
      if (lookahead == 'n') ADVANCE(1652);
      END_STATE();
    case 2488:
      if (lookahead == 'n') ADVANCE(1503);
      END_STATE();
    case 2489:
      if (lookahead == 'n') ADVANCE(2882);
      END_STATE();
    case 2490:
      if (lookahead == 'n') ADVANCE(2858);
      END_STATE();
    case 2491:
      if (lookahead == 'n') ADVANCE(1496);
      END_STATE();
    case 2492:
      if (lookahead == 'n') ADVANCE(2155);
      END_STATE();
    case 2493:
      if (lookahead == 'n') ADVANCE(1509);
      END_STATE();
    case 2494:
      if (lookahead == 'n') ADVANCE(1758);
      END_STATE();
    case 2495:
      if (lookahead == 'n') ADVANCE(1502);
      END_STATE();
    case 2496:
      if (lookahead == 'n') ADVANCE(2566);
      if (lookahead == 'o') ADVANCE(2448);
      END_STATE();
    case 2497:
      if (lookahead == 'n') ADVANCE(2355);
      END_STATE();
    case 2498:
      if (lookahead == 'n') ADVANCE(2747);
      END_STATE();
    case 2499:
      if (lookahead == 'n') ADVANCE(2204);
      END_STATE();
    case 2500:
      if (lookahead == 'n') ADVANCE(2206);
      END_STATE();
    case 2501:
      if (lookahead == 'n') ADVANCE(2208);
      END_STATE();
    case 2502:
      if (lookahead == 'n') ADVANCE(1545);
      END_STATE();
    case 2503:
      if (lookahead == 'o') ADVANCE(2122);
      if (lookahead == 's') ADVANCE(1685);
      END_STATE();
    case 2504:
      if (lookahead == 'o') ADVANCE(2751);
      if (lookahead == 'r') ADVANCE(2934);
      END_STATE();
    case 2505:
      if (lookahead == 'o') ADVANCE(2957);
      END_STATE();
    case 2506:
      if (lookahead == 'o') ADVANCE(2902);
      END_STATE();
    case 2507:
      if (lookahead == 'o') ADVANCE(1973);
      END_STATE();
    case 2508:
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(2113);
      if (lookahead == 't') ADVANCE(2634);
      END_STATE();
    case 2509:
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1861);
      if (lookahead == 't') ADVANCE(2635);
      END_STATE();
    case 2510:
      if (lookahead == 'o') ADVANCE(2195);
      if (lookahead == 'r') ADVANCE(2113);
      if (lookahead == 't') ADVANCE(2713);
      END_STATE();
    case 2511:
      if (lookahead == 'o') ADVANCE(2383);
      if (lookahead == 't') ADVANCE(2667);
      END_STATE();
    case 2512:
      if (lookahead == 'o') ADVANCE(1437);
      END_STATE();
    case 2513:
      if (lookahead == 'o') ADVANCE(1557);
      END_STATE();
    case 2514:
      if (lookahead == 'o') ADVANCE(1294);
      END_STATE();
    case 2515:
      if (lookahead == 'o') ADVANCE(1601);
      END_STATE();
    case 2516:
      if (lookahead == 'o') ADVANCE(2224);
      END_STATE();
    case 2517:
      if (lookahead == 'o') ADVANCE(2303);
      END_STATE();
    case 2518:
      if (lookahead == 'o') ADVANCE(2910);
      END_STATE();
    case 2519:
      if (lookahead == 'o') ADVANCE(2047);
      END_STATE();
    case 2520:
      if (lookahead == 'o') ADVANCE(2080);
      END_STATE();
    case 2521:
      if (lookahead == 'o') ADVANCE(1578);
      END_STATE();
    case 2522:
      if (lookahead == 'o') ADVANCE(2914);
      END_STATE();
    case 2523:
      if (lookahead == 'o') ADVANCE(2416);
      END_STATE();
    case 2524:
      if (lookahead == 'o') ADVANCE(2665);
      END_STATE();
    case 2525:
      if (lookahead == 'o') ADVANCE(1734);
      END_STATE();
    case 2526:
      if (lookahead == 'o') ADVANCE(2768);
      END_STATE();
    case 2527:
      if (lookahead == 'o') ADVANCE(2702);
      END_STATE();
    case 2528:
      if (lookahead == 'o') ADVANCE(2419);
      END_STATE();
    case 2529:
      if (lookahead == 'o') ADVANCE(1587);
      END_STATE();
    case 2530:
      if (lookahead == 'o') ADVANCE(2480);
      END_STATE();
    case 2531:
      if (lookahead == 'o') ADVANCE(2647);
      END_STATE();
    case 2532:
      if (lookahead == 'o') ADVANCE(2423);
      END_STATE();
    case 2533:
      if (lookahead == 'o') ADVANCE(2664);
      if (lookahead == 't') ADVANCE(1439);
      END_STATE();
    case 2534:
      if (lookahead == 'o') ADVANCE(2451);
      END_STATE();
    case 2535:
      if (lookahead == 'o') ADVANCE(2121);
      END_STATE();
    case 2536:
      if (lookahead == 'o') ADVANCE(2121);
      if (lookahead == 's') ADVANCE(1685);
      END_STATE();
    case 2537:
      if (lookahead == 'o') ADVANCE(2121);
      if (lookahead == 's') ADVANCE(1686);
      END_STATE();
    case 2538:
      if (lookahead == 'o') ADVANCE(2673);
      END_STATE();
    case 2539:
      if (lookahead == 'o') ADVANCE(2452);
      END_STATE();
    case 2540:
      if (lookahead == 'o') ADVANCE(2716);
      END_STATE();
    case 2541:
      if (lookahead == 'o') ADVANCE(2439);
      END_STATE();
    case 2542:
      if (lookahead == 'o') ADVANCE(1687);
      END_STATE();
    case 2543:
      if (lookahead == 'o') ADVANCE(2426);
      END_STATE();
    case 2544:
      if (lookahead == 'o') ADVANCE(2652);
      END_STATE();
    case 2545:
      if (lookahead == 'o') ADVANCE(2458);
      END_STATE();
    case 2546:
      if (lookahead == 'o') ADVANCE(2428);
      END_STATE();
    case 2547:
      if (lookahead == 'o') ADVANCE(2077);
      END_STATE();
    case 2548:
      if (lookahead == 'o') ADVANCE(2877);
      END_STATE();
    case 2549:
      if (lookahead == 'o') ADVANCE(2225);
      END_STATE();
    case 2550:
      if (lookahead == 'o') ADVANCE(2225);
      if (lookahead == 'r') ADVANCE(2901);
      END_STATE();
    case 2551:
      if (lookahead == 'o') ADVANCE(2225);
      if (lookahead == 'r') ADVANCE(2919);
      END_STATE();
    case 2552:
      if (lookahead == 'o') ADVANCE(2030);
      END_STATE();
    case 2553:
      if (lookahead == 'o') ADVANCE(2604);
      END_STATE();
    case 2554:
      if (lookahead == 'o') ADVANCE(1741);
      END_STATE();
    case 2555:
      if (lookahead == 'o') ADVANCE(2608);
      END_STATE();
    case 2556:
      if (lookahead == 'o') ADVANCE(2684);
      END_STATE();
    case 2557:
      if (lookahead == 'o') ADVANCE(1631);
      END_STATE();
    case 2558:
      if (lookahead == 'o') ADVANCE(2682);
      if (lookahead == 'r') ADVANCE(2170);
      END_STATE();
    case 2559:
      if (lookahead == 'o') ADVANCE(1447);
      END_STATE();
    case 2560:
      if (lookahead == 'o') ADVANCE(2031);
      END_STATE();
    case 2561:
      if (lookahead == 'o') ADVANCE(2686);
      END_STATE();
    case 2562:
      if (lookahead == 'o') ADVANCE(2948);
      END_STATE();
    case 2563:
      if (lookahead == 'o') ADVANCE(2469);
      END_STATE();
    case 2564:
      if (lookahead == 'o') ADVANCE(1471);
      END_STATE();
    case 2565:
      if (lookahead == 'o') ADVANCE(1458);
      END_STATE();
    case 2566:
      if (lookahead == 'o') ADVANCE(2472);
      END_STATE();
    case 2567:
      if (lookahead == 'o') ADVANCE(2172);
      END_STATE();
    case 2568:
      if (lookahead == 'o') ADVANCE(2473);
      END_STATE();
    case 2569:
      if (lookahead == 'o') ADVANCE(2470);
      END_STATE();
    case 2570:
      if (lookahead == 'o') ADVANCE(2148);
      END_STATE();
    case 2571:
      if (lookahead == 'o') ADVANCE(2481);
      END_STATE();
    case 2572:
      if (lookahead == 'o') ADVANCE(1678);
      END_STATE();
    case 2573:
      if (lookahead == 'o') ADVANCE(2488);
      END_STATE();
    case 2574:
      if (lookahead == 'o') ADVANCE(1972);
      END_STATE();
    case 2575:
      if (lookahead == 'o') ADVANCE(2394);
      if (lookahead == 't') ADVANCE(2667);
      END_STATE();
    case 2576:
      if (lookahead == 'o') ADVANCE(1680);
      END_STATE();
    case 2577:
      if (lookahead == 'o') ADVANCE(2396);
      if (lookahead == 't') ADVANCE(2667);
      END_STATE();
    case 2578:
      if (lookahead == 'o') ADVANCE(1683);
      END_STATE();
    case 2579:
      if (lookahead == 'o') ADVANCE(2166);
      END_STATE();
    case 2580:
      if (lookahead == 'p') ADVANCE(106);
      END_STATE();
    case 2581:
      if (lookahead == 'p') ADVANCE(3446);
      END_STATE();
    case 2582:
      if (lookahead == 'p') ADVANCE(3773);
      END_STATE();
    case 2583:
      if (lookahead == 'p') ADVANCE(3584);
      END_STATE();
    case 2584:
      if (lookahead == 'p') ADVANCE(3582);
      END_STATE();
    case 2585:
      if (lookahead == 'p') ADVANCE(99);
      END_STATE();
    case 2586:
      if (lookahead == 'p') ADVANCE(3746);
      END_STATE();
    case 2587:
      if (lookahead == 'p') ADVANCE(3744);
      END_STATE();
    case 2588:
      if (lookahead == 'p') ADVANCE(3592);
      END_STATE();
    case 2589:
      if (lookahead == 'p') ADVANCE(59);
      END_STATE();
    case 2590:
      if (lookahead == 'p') ADVANCE(3453);
      END_STATE();
    case 2591:
      if (lookahead == 'p') ADVANCE(1402);
      END_STATE();
    case 2592:
      if (lookahead == 'p') ADVANCE(1402);
      if (lookahead == 'r') ADVANCE(3690);
      END_STATE();
    case 2593:
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 'r') ADVANCE(1861);
      if (lookahead == 't') ADVANCE(2654);
      END_STATE();
    case 2594:
      if (lookahead == 'p') ADVANCE(1606);
      if (lookahead == 't') ADVANCE(2653);
      END_STATE();
    case 2595:
      if (lookahead == 'p') ADVANCE(2617);
      END_STATE();
    case 2596:
      if (lookahead == 'p') ADVANCE(120);
      END_STATE();
    case 2597:
      if (lookahead == 'p') ADVANCE(2966);
      END_STATE();
    case 2598:
      if (lookahead == 'p') ADVANCE(2932);
      END_STATE();
    case 2599:
      if (lookahead == 'p') ADVANCE(1887);
      END_STATE();
    case 2600:
      if (lookahead == 'p') ADVANCE(2556);
      END_STATE();
    case 2601:
      if (lookahead == 'p') ADVANCE(1500);
      END_STATE();
    case 2602:
      if (lookahead == 'p') ADVANCE(2839);
      END_STATE();
    case 2603:
      if (lookahead == 'p') ADVANCE(1794);
      END_STATE();
    case 2604:
      if (lookahead == 'p') ADVANCE(2843);
      END_STATE();
    case 2605:
      if (lookahead == 'p') ADVANCE(1401);
      END_STATE();
    case 2606:
      if (lookahead == 'p') ADVANCE(1401);
      if (lookahead == 'r') ADVANCE(3690);
      END_STATE();
    case 2607:
      if (lookahead == 'p') ADVANCE(2847);
      END_STATE();
    case 2608:
      if (lookahead == 'p') ADVANCE(1831);
      END_STATE();
    case 2609:
      if (lookahead == 'p') ADVANCE(1832);
      END_STATE();
    case 2610:
      if (lookahead == 'p') ADVANCE(2675);
      END_STATE();
    case 2611:
      if (lookahead == 'p') ADVANCE(2675);
      if (lookahead == 't') ADVANCE(1497);
      END_STATE();
    case 2612:
      if (lookahead == 'p') ADVANCE(1449);
      if (lookahead == 'r') ADVANCE(1941);
      if (lookahead == 's') ADVANCE(2954);
      END_STATE();
    case 2613:
      if (lookahead == 'p') ADVANCE(2313);
      END_STATE();
    case 2614:
      if (lookahead == 'p') ADVANCE(1451);
      END_STATE();
    case 2615:
      if (lookahead == 'p') ADVANCE(2295);
      END_STATE();
    case 2616:
      if (lookahead == 'p') ADVANCE(2333);
      END_STATE();
    case 2617:
      if (lookahead == 'p') ADVANCE(1465);
      if (lookahead == 'r') ADVANCE(1947);
      END_STATE();
    case 2618:
      if (lookahead == 'p') ADVANCE(2570);
      END_STATE();
    case 2619:
      if (lookahead == 'p') ADVANCE(2561);
      END_STATE();
    case 2620:
      if (lookahead == 'p') ADVANCE(1511);
      END_STATE();
    case 2621:
      if (lookahead == 'p') ADVANCE(1515);
      END_STATE();
    case 2622:
      if (lookahead == 'p') ADVANCE(2898);
      END_STATE();
    case 2623:
      if (lookahead == 'p') ADVANCE(2365);
      END_STATE();
    case 2624:
      if (lookahead == 'p') ADVANCE(2900);
      END_STATE();
    case 2625:
      if (lookahead == 'q') ADVANCE(3708);
      if (lookahead == 'x') ADVANCE(2895);
      END_STATE();
    case 2626:
      if (lookahead == 'q') ADVANCE(1326);
      END_STATE();
    case 2627:
      if (lookahead == 'q') ADVANCE(3719);
      END_STATE();
    case 2628:
      if (lookahead == 'q') ADVANCE(3726);
      END_STATE();
    case 2629:
      if (lookahead == 'q') ADVANCE(3450);
      END_STATE();
    case 2630:
      if (lookahead == 'q') ADVANCE(1315);
      END_STATE();
    case 2631:
      if (lookahead == 'q') ADVANCE(2915);
      END_STATE();
    case 2632:
      if (lookahead == 'q') ADVANCE(2929);
      END_STATE();
    case 2633:
      if (lookahead == 'r') ADVANCE(3690);
      END_STATE();
    case 2634:
      if (lookahead == 'r') ADVANCE(3255);
      END_STATE();
    case 2635:
      if (lookahead == 'r') ADVANCE(3255);
      if (lookahead == 'x') ADVANCE(1304);
      END_STATE();
    case 2636:
      if (lookahead == 'r') ADVANCE(3669);
      END_STATE();
    case 2637:
      if (lookahead == 'r') ADVANCE(3667);
      END_STATE();
    case 2638:
      if (lookahead == 'r') ADVANCE(3580);
      END_STATE();
    case 2639:
      if (lookahead == 'r') ADVANCE(3651);
      END_STATE();
    case 2640:
      if (lookahead == 'r') ADVANCE(3752);
      END_STATE();
    case 2641:
      if (lookahead == 'r') ADVANCE(3100);
      END_STATE();
    case 2642:
      if (lookahead == 'r') ADVANCE(3548);
      END_STATE();
    case 2643:
      if (lookahead == 'r') ADVANCE(3106);
      END_STATE();
    case 2644:
      if (lookahead == 'r') ADVANCE(3205);
      END_STATE();
    case 2645:
      if (lookahead == 'r') ADVANCE(3782);
      END_STATE();
    case 2646:
      if (lookahead == 'r') ADVANCE(3617);
      END_STATE();
    case 2647:
      if (lookahead == 'r') ADVANCE(3556);
      END_STATE();
    case 2648:
      if (lookahead == 'r') ADVANCE(3645);
      END_STATE();
    case 2649:
      if (lookahead == 'r') ADVANCE(3206);
      END_STATE();
    case 2650:
      if (lookahead == 'r') ADVANCE(3692);
      END_STATE();
    case 2651:
      if (lookahead == 'r') ADVANCE(3780);
      END_STATE();
    case 2652:
      if (lookahead == 'r') ADVANCE(3527);
      END_STATE();
    case 2653:
      if (lookahead == 'r') ADVANCE(3253);
      END_STATE();
    case 2654:
      if (lookahead == 'r') ADVANCE(3253);
      if (lookahead == 'x') ADVANCE(1304);
      END_STATE();
    case 2655:
      if (lookahead == 'r') ADVANCE(2767);
      END_STATE();
    case 2656:
      if (lookahead == 'r') ADVANCE(1600);
      END_STATE();
    case 2657:
      if (lookahead == 'r') ADVANCE(2945);
      END_STATE();
    case 2658:
      if (lookahead == 'r') ADVANCE(2053);
      END_STATE();
    case 2659:
      if (lookahead == 'r') ADVANCE(2507);
      if (lookahead == 'x') ADVANCE(2789);
      END_STATE();
    case 2660:
      if (lookahead == 'r') ADVANCE(2054);
      END_STATE();
    case 2661:
      if (lookahead == 'r') ADVANCE(2376);
      END_STATE();
    case 2662:
      if (lookahead == 'r') ADVANCE(2170);
      END_STATE();
    case 2663:
      if (lookahead == 'r') ADVANCE(1868);
      if (lookahead == 'v') ADVANCE(1430);
      END_STATE();
    case 2664:
      if (lookahead == 'r') ADVANCE(2980);
      END_STATE();
    case 2665:
      if (lookahead == 'r') ADVANCE(2029);
      END_STATE();
    case 2666:
      if (lookahead == 'r') ADVANCE(2519);
      END_STATE();
    case 2667:
      if (lookahead == 'r') ADVANCE(2117);
      END_STATE();
    case 2668:
      if (lookahead == 'r') ADVANCE(1317);
      END_STATE();
    case 2669:
      if (lookahead == 'r') ADVANCE(1763);
      END_STATE();
    case 2670:
      if (lookahead == 'r') ADVANCE(2081);
      END_STATE();
    case 2671:
      if (lookahead == 'r') ADVANCE(2901);
      END_STATE();
    case 2672:
      if (lookahead == 'r') ADVANCE(2417);
      END_STATE();
    case 2673:
      if (lookahead == 'r') ADVANCE(1320);
      END_STATE();
    case 2674:
      if (lookahead == 'r') ADVANCE(2796);
      END_STATE();
    case 2675:
      if (lookahead == 'r') ADVANCE(2520);
      END_STATE();
    case 2676:
      if (lookahead == 'r') ADVANCE(2484);
      END_STATE();
    case 2677:
      if (lookahead == 'r') ADVANCE(1964);
      END_STATE();
    case 2678:
      if (lookahead == 'r') ADVANCE(2574);
      END_STATE();
    case 2679:
      if (lookahead == 'r') ADVANCE(2420);
      END_STATE();
    case 2680:
      if (lookahead == 'r') ADVANCE(1874);
      END_STATE();
    case 2681:
      if (lookahead == 'r') ADVANCE(1506);
      END_STATE();
    case 2682:
      if (lookahead == 'r') ADVANCE(1797);
      END_STATE();
    case 2683:
      if (lookahead == 'r') ADVANCE(2424);
      END_STATE();
    case 2684:
      if (lookahead == 'r') ADVANCE(2811);
      END_STATE();
    case 2685:
      if (lookahead == 'r') ADVANCE(2427);
      END_STATE();
    case 2686:
      if (lookahead == 'r') ADVANCE(2812);
      END_STATE();
    case 2687:
      if (lookahead == 'r') ADVANCE(1937);
      END_STATE();
    case 2688:
      if (lookahead == 'r') ADVANCE(1808);
      END_STATE();
    case 2689:
      if (lookahead == 'r') ADVANCE(1809);
      END_STATE();
    case 2690:
      if (lookahead == 'r') ADVANCE(2003);
      END_STATE();
    case 2691:
      if (lookahead == 'r') ADVANCE(1922);
      END_STATE();
    case 2692:
      if (lookahead == 'r') ADVANCE(1827);
      END_STATE();
    case 2693:
      if (lookahead == 'r') ADVANCE(1908);
      END_STATE();
    case 2694:
      if (lookahead == 'r') ADVANCE(1899);
      END_STATE();
    case 2695:
      if (lookahead == 'r') ADVANCE(2071);
      END_STATE();
    case 2696:
      if (lookahead == 'r') ADVANCE(1765);
      END_STATE();
    case 2697:
      if (lookahead == 'r') ADVANCE(2887);
      END_STATE();
    case 2698:
      if (lookahead == 'r') ADVANCE(2475);
      END_STATE();
    case 2699:
      if (lookahead == 'r') ADVANCE(1944);
      END_STATE();
    case 2700:
      if (lookahead == 'r') ADVANCE(1971);
      END_STATE();
    case 2701:
      if (lookahead == 'r') ADVANCE(2765);
      END_STATE();
    case 2702:
      if (lookahead == 'r') ADVANCE(1746);
      END_STATE();
    case 2703:
      if (lookahead == 'r') ADVANCE(1645);
      END_STATE();
    case 2704:
      if (lookahead == 'r') ADVANCE(1916);
      END_STATE();
    case 2705:
      if (lookahead == 'r') ADVANCE(1949);
      END_STATE();
    case 2706:
      if (lookahead == 'r') ADVANCE(1974);
      END_STATE();
    case 2707:
      if (lookahead == 'r') ADVANCE(1524);
      END_STATE();
    case 2708:
      if (lookahead == 'r') ADVANCE(1305);
      END_STATE();
    case 2709:
      if (lookahead == 'r') ADVANCE(2074);
      END_STATE();
    case 2710:
      if (lookahead == 'r') ADVANCE(2714);
      END_STATE();
    case 2711:
      if (lookahead == 'r') ADVANCE(1975);
      END_STATE();
    case 2712:
      if (lookahead == 'r') ADVANCE(2079);
      END_STATE();
    case 2713:
      if (lookahead == 'r') ADVANCE(2841);
      END_STATE();
    case 2714:
      if (lookahead == 'r') ADVANCE(2544);
      END_STATE();
    case 2715:
      if (lookahead == 'r') ADVANCE(2541);
      END_STATE();
    case 2716:
      if (lookahead == 'r') ADVANCE(1328);
      END_STATE();
    case 2717:
      if (lookahead == 'r') ADVANCE(1759);
      END_STATE();
    case 2718:
      if (lookahead == 'r') ADVANCE(1499);
      END_STATE();
    case 2719:
      if (lookahead == 'r') ADVANCE(1332);
      END_STATE();
    case 2720:
      if (lookahead == 'r') ADVANCE(1985);
      END_STATE();
    case 2721:
      if (lookahead == 'r') ADVANCE(1979);
      END_STATE();
    case 2722:
      if (lookahead == 'r') ADVANCE(2937);
      END_STATE();
    case 2723:
      if (lookahead == 'r') ADVANCE(2579);
      if (lookahead == 'x') ADVANCE(2789);
      END_STATE();
    case 2724:
      if (lookahead == 'r') ADVANCE(2491);
      END_STATE();
    case 2725:
      if (lookahead == 'r') ADVANCE(2493);
      END_STATE();
    case 2726:
      if (lookahead == 'r') ADVANCE(1993);
      END_STATE();
    case 2727:
      if (lookahead == 'r') ADVANCE(2781);
      END_STATE();
    case 2728:
      if (lookahead == 's') ADVANCE(3792);
      END_STATE();
    case 2729:
      if (lookahead == 's') ADVANCE(3498);
      END_STATE();
    case 2730:
      if (lookahead == 's') ADVANCE(3619);
      END_STATE();
    case 2731:
      if (lookahead == 's') ADVANCE(4543);
      END_STATE();
    case 2732:
      if (lookahead == 's') ADVANCE(3653);
      END_STATE();
    case 2733:
      if (lookahead == 's') ADVANCE(3465);
      END_STATE();
    case 2734:
      if (lookahead == 's') ADVANCE(3342);
      END_STATE();
    case 2735:
      if (lookahead == 's') ADVANCE(3423);
      END_STATE();
    case 2736:
      if (lookahead == 's') ADVANCE(3432);
      END_STATE();
    case 2737:
      if (lookahead == 's') ADVANCE(3372);
      END_STATE();
    case 2738:
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 2739:
      if (lookahead == 's') ADVANCE(1522);
      END_STATE();
    case 2740:
      if (lookahead == 's') ADVANCE(2784);
      END_STATE();
    case 2741:
      if (lookahead == 's') ADVANCE(2773);
      END_STATE();
    case 2742:
      if (lookahead == 's') ADVANCE(2786);
      END_STATE();
    case 2743:
      if (lookahead == 's') ADVANCE(2870);
      if (lookahead == 't') ADVANCE(2718);
      if (lookahead == 'v') ADVANCE(1999);
      END_STATE();
    case 2744:
      if (lookahead == 's') ADVANCE(2601);
      END_STATE();
    case 2745:
      if (lookahead == 's') ADVANCE(1951);
      if (lookahead == 't') ADVANCE(2002);
      END_STATE();
    case 2746:
      if (lookahead == 's') ADVANCE(2990);
      END_STATE();
    case 2747:
      if (lookahead == 's') ADVANCE(2160);
      END_STATE();
    case 2748:
      if (lookahead == 's') ADVANCE(1336);
      END_STATE();
    case 2749:
      if (lookahead == 's') ADVANCE(2732);
      END_STATE();
    case 2750:
      if (lookahead == 's') ADVANCE(2733);
      END_STATE();
    case 2751:
      if (lookahead == 's') ADVANCE(2107);
      if (lookahead == 'u') ADVANCE(2108);
      END_STATE();
    case 2752:
      if (lookahead == 's') ADVANCE(1629);
      END_STATE();
    case 2753:
      if (lookahead == 's') ADVANCE(2735);
      END_STATE();
    case 2754:
      if (lookahead == 's') ADVANCE(2736);
      END_STATE();
    case 2755:
      if (lookahead == 's') ADVANCE(2799);
      END_STATE();
    case 2756:
      if (lookahead == 's') ADVANCE(2161);
      END_STATE();
    case 2757:
      if (lookahead == 's') ADVANCE(1795);
      END_STATE();
    case 2758:
      if (lookahead == 's') ADVANCE(2801);
      END_STATE();
    case 2759:
      if (lookahead == 's') ADVANCE(2802);
      END_STATE();
    case 2760:
      if (lookahead == 's') ADVANCE(2818);
      END_STATE();
    case 2761:
      if (lookahead == 's') ADVANCE(2851);
      END_STATE();
    case 2762:
      if (lookahead == 's') ADVANCE(2844);
      END_STATE();
    case 2763:
      if (lookahead == 's') ADVANCE(2823);
      END_STATE();
    case 2764:
      if (lookahead == 's') ADVANCE(1816);
      END_STATE();
    case 2765:
      if (lookahead == 's') ADVANCE(1829);
      END_STATE();
    case 2766:
      if (lookahead == 's') ADVANCE(1903);
      END_STATE();
    case 2767:
      if (lookahead == 's') ADVANCE(2573);
      END_STATE();
    case 2768:
      if (lookahead == 's') ADVANCE(2879);
      END_STATE();
    case 2769:
      if (lookahead == 's') ADVANCE(2867);
      END_STATE();
    case 2770:
      if (lookahead == 's') ADVANCE(2756);
      END_STATE();
    case 2771:
      if (lookahead == 's') ADVANCE(2528);
      END_STATE();
    case 2772:
      if (lookahead == 's') ADVANCE(2845);
      END_STATE();
    case 2773:
      if (lookahead == 's') ADVANCE(2529);
      END_STATE();
    case 2774:
      if (lookahead == 's') ADVANCE(1546);
      END_STATE();
    case 2775:
      if (lookahead == 's') ADVANCE(2838);
      END_STATE();
    case 2776:
      if (lookahead == 's') ADVANCE(2874);
      END_STATE();
    case 2777:
      if (lookahead == 's') ADVANCE(2143);
      END_STATE();
    case 2778:
      if (lookahead == 's') ADVANCE(2173);
      END_STATE();
    case 2779:
      if (lookahead == 's') ADVANCE(2181);
      END_STATE();
    case 2780:
      if (lookahead == 's') ADVANCE(2620);
      END_STATE();
    case 2781:
      if (lookahead == 's') ADVANCE(2621);
      END_STATE();
    case 2782:
      if (lookahead == 's') ADVANCE(1521);
      END_STATE();
    case 2783:
      if (lookahead == 't') ADVANCE(3321);
      END_STATE();
    case 2784:
      if (lookahead == 't') ADVANCE(3778);
      END_STATE();
    case 2785:
      if (lookahead == 't') ADVANCE(2611);
      END_STATE();
    case 2786:
      if (lookahead == 't') ADVANCE(3504);
      END_STATE();
    case 2787:
      if (lookahead == 't') ADVANCE(3736);
      END_STATE();
    case 2788:
      if (lookahead == 't') ADVANCE(3492);
      END_STATE();
    case 2789:
      if (lookahead == 't') ADVANCE(3734);
      END_STATE();
    case 2790:
      if (lookahead == 't') ADVANCE(3562);
      END_STATE();
    case 2791:
      if (lookahead == 't') ADVANCE(3217);
      END_STATE();
    case 2792:
      if (lookahead == 't') ADVANCE(3740);
      END_STATE();
    case 2793:
      if (lookahead == 't') ADVANCE(1369);
      END_STATE();
    case 2794:
      if (lookahead == 't') ADVANCE(3214);
      END_STATE();
    case 2795:
      if (lookahead == 't') ADVANCE(3289);
      END_STATE();
    case 2796:
      if (lookahead == 't') ADVANCE(2008);
      END_STATE();
    case 2797:
      if (lookahead == 't') ADVANCE(3554);
      END_STATE();
    case 2798:
      if (lookahead == 't') ADVANCE(3081);
      END_STATE();
    case 2799:
      if (lookahead == 't') ADVANCE(3730);
      END_STATE();
    case 2800:
      if (lookahead == 't') ADVANCE(3131);
      END_STATE();
    case 2801:
      if (lookahead == 't') ADVANCE(3801);
      END_STATE();
    case 2802:
      if (lookahead == 't') ADVANCE(3766);
      END_STATE();
    case 2803:
      if (lookahead == 't') ADVANCE(3477);
      END_STATE();
    case 2804:
      if (lookahead == 't') ADVANCE(3474);
      END_STATE();
    case 2805:
      if (lookahead == 't') ADVANCE(3572);
      END_STATE();
    case 2806:
      if (lookahead == 't') ADVANCE(3791);
      END_STATE();
    case 2807:
      if (lookahead == 't') ADVANCE(3774);
      END_STATE();
    case 2808:
      if (lookahead == 't') ADVANCE(3804);
      END_STATE();
    case 2809:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 2810:
      if (lookahead == 't') ADVANCE(3754);
      END_STATE();
    case 2811:
      if (lookahead == 't') ADVANCE(3139);
      END_STATE();
    case 2812:
      if (lookahead == 't') ADVANCE(3137);
      END_STATE();
    case 2813:
      if (lookahead == 't') ADVANCE(3315);
      END_STATE();
    case 2814:
      if (lookahead == 't') ADVANCE(3084);
      END_STATE();
    case 2815:
      if (lookahead == 't') ADVANCE(3330);
      END_STATE();
    case 2816:
      if (lookahead == 't') ADVANCE(3786);
      END_STATE();
    case 2817:
      if (lookahead == 't') ADVANCE(3787);
      END_STATE();
    case 2818:
      if (lookahead == 't') ADVANCE(3742);
      END_STATE();
    case 2819:
      if (lookahead == 't') ADVANCE(3552);
      END_STATE();
    case 2820:
      if (lookahead == 't') ADVANCE(3550);
      END_STATE();
    case 2821:
      if (lookahead == 't') ADVANCE(3354);
      END_STATE();
    case 2822:
      if (lookahead == 't') ADVANCE(3127);
      END_STATE();
    case 2823:
      if (lookahead == 't') ADVANCE(3777);
      END_STATE();
    case 2824:
      if (lookahead == 't') ADVANCE(1454);
      END_STATE();
    case 2825:
      if (lookahead == 't') ADVANCE(3569);
      END_STATE();
    case 2826:
      if (lookahead == 't') ADVANCE(1540);
      END_STATE();
    case 2827:
      if (lookahead == 't') ADVANCE(2667);
      END_STATE();
    case 2828:
      if (lookahead == 't') ADVANCE(1428);
      END_STATE();
    case 2829:
      if (lookahead == 't') ADVANCE(2989);
      END_STATE();
    case 2830:
      if (lookahead == 't') ADVANCE(2552);
      END_STATE();
    case 2831:
      if (lookahead == 't') ADVANCE(1530);
      END_STATE();
    case 2832:
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 2833:
      if (lookahead == 't') ADVANCE(2718);
      END_STATE();
    case 2834:
      if (lookahead == 't') ADVANCE(2718);
      if (lookahead == 'v') ADVANCE(1999);
      END_STATE();
    case 2835:
      if (lookahead == 't') ADVANCE(2979);
      END_STATE();
    case 2836:
      if (lookahead == 't') ADVANCE(1897);
      END_STATE();
    case 2837:
      if (lookahead == 't') ADVANCE(2049);
      END_STATE();
    case 2838:
      if (lookahead == 't') ADVANCE(2176);
      END_STATE();
    case 2839:
      if (lookahead == 't') ADVANCE(2936);
      END_STATE();
    case 2840:
      if (lookahead == 't') ADVANCE(2199);
      END_STATE();
    case 2841:
      if (lookahead == 't') ADVANCE(2567);
      END_STATE();
    case 2842:
      if (lookahead == 't') ADVANCE(2180);
      END_STATE();
    case 2843:
      if (lookahead == 't') ADVANCE(2640);
      END_STATE();
    case 2844:
      if (lookahead == 't') ADVANCE(2610);
      END_STATE();
    case 2845:
      if (lookahead == 't') ADVANCE(1452);
      END_STATE();
    case 2846:
      if (lookahead == 't') ADVANCE(1371);
      END_STATE();
    case 2847:
      if (lookahead == 't') ADVANCE(2646);
      END_STATE();
    case 2848:
      if (lookahead == 't') ADVANCE(1907);
      END_STATE();
    case 2849:
      if (lookahead == 't') ADVANCE(1915);
      END_STATE();
    case 2850:
      if (lookahead == 't') ADVANCE(2288);
      END_STATE();
    case 2851:
      if (lookahead == 't') ADVANCE(2722);
      END_STATE();
    case 2852:
      if (lookahead == 't') ADVANCE(1984);
      END_STATE();
    case 2853:
      if (lookahead == 't') ADVANCE(2829);
      END_STATE();
    case 2854:
      if (lookahead == 't') ADVANCE(1815);
      END_STATE();
    case 2855:
      if (lookahead == 't') ADVANCE(1920);
      END_STATE();
    case 2856:
      if (lookahead == 't') ADVANCE(1904);
      END_STATE();
    case 2857:
      if (lookahead == 't') ADVANCE(1834);
      END_STATE();
    case 2858:
      if (lookahead == 't') ADVANCE(1924);
      END_STATE();
    case 2859:
      if (lookahead == 't') ADVANCE(1926);
      END_STATE();
    case 2860:
      if (lookahead == 't') ADVANCE(1840);
      END_STATE();
    case 2861:
      if (lookahead == 't') ADVANCE(1981);
      END_STATE();
    case 2862:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 2863:
      if (lookahead == 't') ADVANCE(2387);
      END_STATE();
    case 2864:
      if (lookahead == 't') ADVANCE(2955);
      END_STATE();
    case 2865:
      if (lookahead == 't') ADVANCE(1619);
      END_STATE();
    case 2866:
      if (lookahead == 't') ADVANCE(1489);
      END_STATE();
    case 2867:
      if (lookahead == 't') ADVANCE(2527);
      END_STATE();
    case 2868:
      if (lookahead == 't') ADVANCE(1453);
      END_STATE();
    case 2869:
      if (lookahead == 't') ADVANCE(1997);
      END_STATE();
    case 2870:
      if (lookahead == 't') ADVANCE(1479);
      END_STATE();
    case 2871:
      if (lookahead == 't') ADVANCE(2715);
      END_STATE();
    case 2872:
      if (lookahead == 't') ADVANCE(2607);
      END_STATE();
    case 2873:
      if (lookahead == 't') ADVANCE(2531);
      END_STATE();
    case 2874:
      if (lookahead == 't') ADVANCE(1466);
      END_STATE();
    case 2875:
      if (lookahead == 't') ADVANCE(2190);
      END_STATE();
    case 2876:
      if (lookahead == 't') ADVANCE(2036);
      END_STATE();
    case 2877:
      if (lookahead == 't') ADVANCE(2530);
      END_STATE();
    case 2878:
      if (lookahead == 't') ADVANCE(2138);
      END_STATE();
    case 2879:
      if (lookahead == 't') ADVANCE(1640);
      END_STATE();
    case 2880:
      if (lookahead == 't') ADVANCE(1628);
      END_STATE();
    case 2881:
      if (lookahead == 't') ADVANCE(1618);
      END_STATE();
    case 2882:
      if (lookahead == 't') ADVANCE(1536);
      END_STATE();
    case 2883:
      if (lookahead == 't') ADVANCE(1621);
      END_STATE();
    case 2884:
      if (lookahead == 't') ADVANCE(1627);
      END_STATE();
    case 2885:
      if (lookahead == 't') ADVANCE(2147);
      END_STATE();
    case 2886:
      if (lookahead == 't') ADVANCE(2560);
      END_STATE();
    case 2887:
      if (lookahead == 't') ADVANCE(2198);
      END_STATE();
    case 2888:
      if (lookahead == 't') ADVANCE(2930);
      END_STATE();
    case 2889:
      if (lookahead == 't') ADVANCE(2192);
      END_STATE();
    case 2890:
      if (lookahead == 't') ADVANCE(2189);
      END_STATE();
    case 2891:
      if (lookahead == 't') ADVANCE(2193);
      END_STATE();
    case 2892:
      if (lookahead == 't') ADVANCE(2175);
      END_STATE();
    case 2893:
      if (lookahead == 't') ADVANCE(2183);
      END_STATE();
    case 2894:
      if (lookahead == 't') ADVANCE(2188);
      END_STATE();
    case 2895:
      if (lookahead == 't') ADVANCE(1998);
      END_STATE();
    case 2896:
      if (lookahead == 't') ADVANCE(2010);
      END_STATE();
    case 2897:
      if (lookahead == 't') ADVANCE(2205);
      END_STATE();
    case 2898:
      if (lookahead == 't') ADVANCE(1538);
      END_STATE();
    case 2899:
      if (lookahead == 't') ADVANCE(1541);
      END_STATE();
    case 2900:
      if (lookahead == 't') ADVANCE(1543);
      END_STATE();
    case 2901:
      if (lookahead == 'u') ADVANCE(1793);
      END_STATE();
    case 2902:
      if (lookahead == 'u') ADVANCE(1551);
      END_STATE();
    case 2903:
      if (lookahead == 'u') ADVANCE(1548);
      END_STATE();
    case 2904:
      if (lookahead == 'u') ADVANCE(2994);
      END_STATE();
    case 2905:
      if (lookahead == 'u') ADVANCE(2233);
      END_STATE();
    case 2906:
      if (lookahead == 'u') ADVANCE(2615);
      END_STATE();
    case 2907:
      if (lookahead == 'u') ADVANCE(2588);
      END_STATE();
    case 2908:
      if (lookahead == 'u') ADVANCE(2293);
      END_STATE();
    case 2909:
      if (lookahead == 'u') ADVANCE(2701);
      END_STATE();
    case 2910:
      if (lookahead == 'u') ADVANCE(2443);
      END_STATE();
    case 2911:
      if (lookahead == 'u') ADVANCE(2341);
      END_STATE();
    case 2912:
      if (lookahead == 'u') ADVANCE(2595);
      END_STATE();
    case 2913:
      if (lookahead == 'u') ADVANCE(2457);
      END_STATE();
    case 2914:
      if (lookahead == 'u') ADVANCE(2814);
      END_STATE();
    case 2915:
      if (lookahead == 'u') ADVANCE(1804);
      END_STATE();
    case 2916:
      if (lookahead == 'u') ADVANCE(1820);
      END_STATE();
    case 2917:
      if (lookahead == 'u') ADVANCE(1833);
      END_STATE();
    case 2918:
      if (lookahead == 'u') ADVANCE(1837);
      END_STATE();
    case 2919:
      if (lookahead == 'u') ADVANCE(1792);
      END_STATE();
    case 2920:
      if (lookahead == 'u') ADVANCE(2703);
      END_STATE();
    case 2921:
      if (lookahead == 'u') ADVANCE(2679);
      END_STATE();
    case 2922:
      if (lookahead == 'u') ADVANCE(2308);
      END_STATE();
    case 2923:
      if (lookahead == 'u') ADVANCE(2380);
      END_STATE();
    case 2924:
      if (lookahead == 'u') ADVANCE(2441);
      END_STATE();
    case 2925:
      if (lookahead == 'u') ADVANCE(2296);
      END_STATE();
    case 2926:
      if (lookahead == 'u') ADVANCE(2388);
      END_STATE();
    case 2927:
      if (lookahead == 'u') ADVANCE(1440);
      END_STATE();
    case 2928:
      if (lookahead == 'u') ADVANCE(2683);
      END_STATE();
    case 2929:
      if (lookahead == 'u') ADVANCE(2163);
      END_STATE();
    case 2930:
      if (lookahead == 'u') ADVANCE(2685);
      END_STATE();
    case 2931:
      if (lookahead == 'u') ADVANCE(2385);
      END_STATE();
    case 2932:
      if (lookahead == 'u') ADVANCE(1310);
      END_STATE();
    case 2933:
      if (lookahead == 'u') ADVANCE(2305);
      END_STATE();
    case 2934:
      if (lookahead == 'u') ADVANCE(2447);
      END_STATE();
    case 2935:
      if (lookahead == 'u') ADVANCE(2856);
      END_STATE();
    case 2936:
      if (lookahead == 'u') ADVANCE(2692);
      END_STATE();
    case 2937:
      if (lookahead == 'u') ADVANCE(2399);
      END_STATE();
    case 2938:
      if (lookahead == 'u') ADVANCE(2202);
      END_STATE();
    case 2939:
      if (lookahead == 'u') ADVANCE(2623);
      END_STATE();
    case 2940:
      if (lookahead == 'v') ADVANCE(3673);
      END_STATE();
    case 2941:
      if (lookahead == 'v') ADVANCE(3665);
      END_STATE();
    case 2942:
      if (lookahead == 'v') ADVANCE(3663);
      END_STATE();
    case 2943:
      if (lookahead == 'v') ADVANCE(2375);
      END_STATE();
    case 2944:
      if (lookahead == 'v') ADVANCE(1491);
      END_STATE();
    case 2945:
      if (lookahead == 'v') ADVANCE(1892);
      END_STATE();
    case 2946:
      if (lookahead == 'v') ADVANCE(1931);
      END_STATE();
    case 2947:
      if (lookahead == 'v') ADVANCE(1967);
      END_STATE();
    case 2948:
      if (lookahead == 'v') ADVANCE(1969);
      END_STATE();
    case 2949:
      if (lookahead == 'v') ADVANCE(1526);
      END_STATE();
    case 2950:
      if (lookahead == 'v') ADVANCE(1512);
      END_STATE();
    case 2951:
      if (lookahead == 'v') ADVANCE(1999);
      END_STATE();
    case 2952:
      if (lookahead == 'w') ADVANCE(3560);
      if (lookahead == 'z') ADVANCE(3772);
      END_STATE();
    case 2953:
      if (lookahead == 'w') ADVANCE(3613);
      END_STATE();
    case 2954:
      if (lookahead == 'w') ADVANCE(2158);
      END_STATE();
    case 2955:
      if (lookahead == 'w') ADVANCE(2185);
      END_STATE();
    case 2956:
      if (lookahead == 'w') ADVANCE(1923);
      END_STATE();
    case 2957:
      if (lookahead == 'w') ADVANCE(1679);
      END_STATE();
    case 2958:
      if (lookahead == 'w') ADVANCE(1535);
      END_STATE();
    case 2959:
      if (lookahead == 'x') ADVANCE(3008);
      END_STATE();
    case 2960:
      if (lookahead == 'x') ADVANCE(3694);
      END_STATE();
    case 2961:
      if (lookahead == 'x') ADVANCE(3700);
      END_STATE();
    case 2962:
      if (lookahead == 'x') ADVANCE(3293);
      END_STATE();
    case 2963:
      if (lookahead == 'x') ADVANCE(3243);
      END_STATE();
    case 2964:
      if (lookahead == 'x') ADVANCE(3239);
      END_STATE();
    case 2965:
      if (lookahead == 'x') ADVANCE(1293);
      END_STATE();
    case 2966:
      if (lookahead == 'x') ADVANCE(1664);
      END_STATE();
    case 2967:
      if (lookahead == 'x') ADVANCE(2600);
      END_STATE();
    case 2968:
      if (lookahead == 'x') ADVANCE(2792);
      END_STATE();
    case 2969:
      if (lookahead == 'x') ADVANCE(2803);
      END_STATE();
    case 2970:
      if (lookahead == 'x') ADVANCE(2804);
      END_STATE();
    case 2971:
      if (lookahead == 'x') ADVANCE(2895);
      END_STATE();
    case 2972:
      if (lookahead == 'x') ADVANCE(1927);
      END_STATE();
    case 2973:
      if (lookahead == 'x') ADVANCE(1935);
      END_STATE();
    case 2974:
      if (lookahead == 'x') ADVANCE(1411);
      END_STATE();
    case 2975:
      if (lookahead == 'x') ADVANCE(2861);
      END_STATE();
    case 2976:
      if (lookahead == 'y') ADVANCE(3408);
      END_STATE();
    case 2977:
      if (lookahead == 'y') ADVANCE(3411);
      END_STATE();
    case 2978:
      if (lookahead == 'y') ADVANCE(3414);
      END_STATE();
    case 2979:
      if (lookahead == 'y') ADVANCE(3297);
      END_STATE();
    case 2980:
      if (lookahead == 'y') ADVANCE(3426);
      END_STATE();
    case 2981:
      if (lookahead == 'y') ADVANCE(3324);
      END_STATE();
    case 2982:
      if (lookahead == 'y') ADVANCE(3109);
      END_STATE();
    case 2983:
      if (lookahead == 'y') ADVANCE(3327);
      END_STATE();
    case 2984:
      if (lookahead == 'y') ADVANCE(1562);
      END_STATE();
    case 2985:
      if (lookahead == 'y') ADVANCE(1331);
      END_STATE();
    case 2986:
      if (lookahead == 'y') ADVANCE(2449);
      END_STATE();
    case 2987:
      if (lookahead == 'y') ADVANCE(2522);
      END_STATE();
    case 2988:
      if (lookahead == 'y') ADVANCE(2777);
      END_STATE();
    case 2989:
      if (lookahead == 'y') ADVANCE(2609);
      END_STATE();
    case 2990:
      if (lookahead == 'y') ADVANCE(2461);
      END_STATE();
    case 2991:
      if (lookahead == 'y') ADVANCE(2680);
      END_STATE();
    case 2992:
      if (lookahead == 'z') ADVANCE(3772);
      END_STATE();
    case 2993:
      if (lookahead == 'z') ADVANCE(2984);
      END_STATE();
    case 2994:
      if (lookahead == 'z') ADVANCE(3005);
      END_STATE();
    case 2995:
      if (lookahead == 'z') ADVANCE(1800);
      END_STATE();
    case 2996:
      if (lookahead == 'z') ADVANCE(1811);
      END_STATE();
    case 2997:
      if (lookahead == 'z') ADVANCE(1814);
      END_STATE();
    case 2998:
      if (lookahead == 'z') ADVANCE(1822);
      END_STATE();
    case 2999:
      if (lookahead == 'z') ADVANCE(1895);
      END_STATE();
    case 3000:
      if (lookahead == 'z') ADVANCE(1825);
      END_STATE();
    case 3001:
      if (lookahead == 'z') ADVANCE(1965);
      END_STATE();
    case 3002:
      if (lookahead == 'z') ADVANCE(1933);
      END_STATE();
    case 3003:
      if (lookahead == 'z') ADVANCE(1936);
      END_STATE();
    case 3004:
      if (lookahead == 'z') ADVANCE(1934);
      END_STATE();
    case 3005:
      if (lookahead == 'z') ADVANCE(2152);
      END_STATE();
    case 3006:
      if (lookahead == 'z') ADVANCE(2568);
      END_STATE();
    case 3007:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(3012);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3078);
      END_STATE();
    case 3008:
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(3014);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3072);
      END_STATE();
    case 3009:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3010:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3038);
      END_STATE();
    case 3011:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 3012:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3078);
      END_STATE();
    case 3013:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3014:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3072);
      END_STATE();
    case 3015:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3168);
      END_STATE();
    case 3016:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3161);
      END_STATE();
    case 3017:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3164);
      END_STATE();
    case 3018:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3192);
      END_STATE();
    case 3019:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3165);
      END_STATE();
    case 3020:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3166);
      END_STATE();
    case 3021:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3167);
      END_STATE();
    case 3022:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3203);
      END_STATE();
    case 3023:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3163);
      END_STATE();
    case 3024:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3162);
      END_STATE();
    case 3025:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ':') ADVANCE(4542);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1339);
      if (lookahead == 'b') ADVANCE(2015);
      if (lookahead == 'c') ADVANCE(29);
      if (lookahead == 'd') ADVANCE(1383);
      if (lookahead == 'e') ADVANCE(2257);
      if (lookahead == 'f') ADVANCE(1344);
      if (lookahead == 'g') ADVANCE(1576);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(1656);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1345);
      if (lookahead == 'm') ADVANCE(1384);
      if (lookahead == 'n') ADVANCE(1346);
      if (lookahead == 'o') ADVANCE(1852);
      if (lookahead == 'p') ADVANCE(1379);
      if (lookahead == 'r') ADVANCE(1772);
      if (lookahead == 's') ADVANCE(73);
      if (lookahead == 't') ADVANCE(1351);
      if (lookahead == 'u') ADVANCE(84);
      if (lookahead == 'v') ADVANCE(1353);
      if (lookahead == 'w') ADVANCE(1773);
      if (lookahead == 'x') ADVANCE(3273);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '|') ADVANCE(4541);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3025)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3026:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '0') ADVANCE(3067);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1570);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(1527);
      if (lookahead == 'd') ADVANCE(1855);
      if (lookahead == 'e') ADVANCE(2258);
      if (lookahead == 'f') ADVANCE(1508);
      if (lookahead == 'g') ADVANCE(1577);
      if (lookahead == 'h') ADVANCE(1407);
      if (lookahead == 'i') ADVANCE(2025);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1421);
      if (lookahead == 'm') ADVANCE(1954);
      if (lookahead == 'n') ADVANCE(1486);
      if (lookahead == 'o') ADVANCE(2591);
      if (lookahead == 'p') ADVANCE(1382);
      if (lookahead == 'r') ADVANCE(1862);
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(1531);
      if (lookahead == 'u') ADVANCE(94);
      if (lookahead == 'v') ADVANCE(2503);
      if (lookahead == 'w') ADVANCE(1932);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3026)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3027:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1689);
      if (lookahead == 'b') ADVANCE(2016);
      if (lookahead == 'c') ADVANCE(33);
      if (lookahead == 'd') ADVANCE(1771);
      if (lookahead == 'e') ADVANCE(2261);
      if (lookahead == 'f') ADVANCE(1375);
      if (lookahead == 'g') ADVANCE(1575);
      if (lookahead == 'h') ADVANCE(1406);
      if (lookahead == 'i') ADVANCE(1660);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1378);
      if (lookahead == 'm') ADVANCE(1387);
      if (lookahead == 'n') ADVANCE(1349);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(1381);
      if (lookahead == 'r') ADVANCE(1867);
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 't') ADVANCE(1532);
      if (lookahead == 'u') ADVANCE(89);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1929);
      if (lookahead == 'x') ADVANCE(122);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3027)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3028:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(3805);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1569);
      if (lookahead == 'b') ADVANCE(2014);
      if (lookahead == 'c') ADVANCE(34);
      if (lookahead == 'd') ADVANCE(1850);
      if (lookahead == 'e') ADVANCE(2625);
      if (lookahead == 'f') ADVANCE(1375);
      if (lookahead == 'g') ADVANCE(1864);
      if (lookahead == 'h') ADVANCE(1405);
      if (lookahead == 'i') ADVANCE(1662);
      if (lookahead == 'l') ADVANCE(1420);
      if (lookahead == 'm') ADVANCE(1390);
      if (lookahead == 'n') ADVANCE(1469);
      if (lookahead == 'o') ADVANCE(2606);
      if (lookahead == 'p') ADVANCE(2508);
      if (lookahead == 'r') ADVANCE(1994);
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 't') ADVANCE(1532);
      if (lookahead == 'u') ADVANCE(85);
      if (lookahead == 'v') ADVANCE(2535);
      if (lookahead == 'w') ADVANCE(1928);
      if (lookahead == 'x') ADVANCE(122);
      if (lookahead == 'z') ADVANCE(1956);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3028)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3029:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(2012);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(2517);
      if (lookahead == 'd') ADVANCE(1855);
      if (lookahead == 'e') ADVANCE(2256);
      if (lookahead == 'f') ADVANCE(1395);
      if (lookahead == 'g') ADVANCE(1574);
      if (lookahead == 'h') ADVANCE(1407);
      if (lookahead == 'i') ADVANCE(2374);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1417);
      if (lookahead == 'm') ADVANCE(1955);
      if (lookahead == 'n') ADVANCE(1487);
      if (lookahead == 'o') ADVANCE(1853);
      if (lookahead == 'p') ADVANCE(1382);
      if (lookahead == 'r') ADVANCE(1873);
      if (lookahead == 's') ADVANCE(1372);
      if (lookahead == 't') ADVANCE(1533);
      if (lookahead == 'u') ADVANCE(1863);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(2153);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3031)
      END_STATE();
    case 3030:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1769);
      if (lookahead == 'b') ADVANCE(2015);
      if (lookahead == 'c') ADVANCE(32);
      if (lookahead == 'd') ADVANCE(1771);
      if (lookahead == 'e') ADVANCE(2262);
      if (lookahead == 'f') ADVANCE(1474);
      if (lookahead == 'g') ADVANCE(1575);
      if (lookahead == 'h') ADVANCE(1406);
      if (lookahead == 'i') ADVANCE(1659);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1374);
      if (lookahead == 'm') ADVANCE(1386);
      if (lookahead == 'n') ADVANCE(1347);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(1380);
      if (lookahead == 'r') ADVANCE(1848);
      if (lookahead == 's') ADVANCE(75);
      if (lookahead == 't') ADVANCE(1352);
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'v') ADVANCE(1354);
      if (lookahead == 'w') ADVANCE(1929);
      if (lookahead == 'x') ADVANCE(122);
      if (lookahead == 'z') ADVANCE(1856);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3030)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3031:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '#') ADVANCE(3010);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(2012);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(2517);
      if (lookahead == 'd') ADVANCE(1855);
      if (lookahead == 'e') ADVANCE(2256);
      if (lookahead == 'f') ADVANCE(1395);
      if (lookahead == 'g') ADVANCE(1574);
      if (lookahead == 'h') ADVANCE(1407);
      if (lookahead == 'i') ADVANCE(2374);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1417);
      if (lookahead == 'm') ADVANCE(1955);
      if (lookahead == 'n') ADVANCE(1487);
      if (lookahead == 'o') ADVANCE(1853);
      if (lookahead == 'p') ADVANCE(1382);
      if (lookahead == 'r') ADVANCE(1873);
      if (lookahead == 's') ADVANCE(1372);
      if (lookahead == 't') ADVANCE(1533);
      if (lookahead == 'u') ADVANCE(1863);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(2153);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3031)
      END_STATE();
    case 3032:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3807);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3067);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1340);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(1573);
      if (lookahead == 'd') ADVANCE(1771);
      if (lookahead == 'e') ADVANCE(2260);
      if (lookahead == 'f') ADVANCE(1457);
      if (lookahead == 'g') ADVANCE(2082);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(2373);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1418);
      if (lookahead == 'm') ADVANCE(1953);
      if (lookahead == 'n') ADVANCE(1488);
      if (lookahead == 'o') ADVANCE(2591);
      if (lookahead == 'p') ADVANCE(2593);
      if (lookahead == 'r') ADVANCE(1862);
      if (lookahead == 's') ADVANCE(80);
      if (lookahead == 't') ADVANCE(1475);
      if (lookahead == 'u') ADVANCE(94);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(118);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3035)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3033:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '(') ADVANCE(3278);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3067);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1341);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(1572);
      if (lookahead == 'd') ADVANCE(1771);
      if (lookahead == 'e') ADVANCE(2260);
      if (lookahead == 'f') ADVANCE(1398);
      if (lookahead == 'g') ADVANCE(2082);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(2373);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1418);
      if (lookahead == 'm') ADVANCE(1385);
      if (lookahead == 'n') ADVANCE(1350);
      if (lookahead == 'o') ADVANCE(2592);
      if (lookahead == 'p') ADVANCE(2593);
      if (lookahead == 'r') ADVANCE(1847);
      if (lookahead == 's') ADVANCE(79);
      if (lookahead == 't') ADVANCE(1475);
      if (lookahead == 'u') ADVANCE(93);
      if (lookahead == 'v') ADVANCE(2503);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(119);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3033)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3034:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == '*') ADVANCE(3207);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3059);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1571);
      if (lookahead == 'b') ADVANCE(2014);
      if (lookahead == 'c') ADVANCE(34);
      if (lookahead == 'd') ADVANCE(1850);
      if (lookahead == 'e') ADVANCE(2971);
      if (lookahead == 'f') ADVANCE(1375);
      if (lookahead == 'g') ADVANCE(1864);
      if (lookahead == 'h') ADVANCE(1405);
      if (lookahead == 'i') ADVANCE(1662);
      if (lookahead == 'l') ADVANCE(1420);
      if (lookahead == 'm') ADVANCE(1390);
      if (lookahead == 'n') ADVANCE(1470);
      if (lookahead == 'o') ADVANCE(2606);
      if (lookahead == 'p') ADVANCE(2508);
      if (lookahead == 'r') ADVANCE(1994);
      if (lookahead == 's') ADVANCE(82);
      if (lookahead == 't') ADVANCE(1532);
      if (lookahead == 'u') ADVANCE(88);
      if (lookahead == 'v') ADVANCE(2535);
      if (lookahead == 'w') ADVANCE(1928);
      if (lookahead == 'x') ADVANCE(122);
      if (lookahead == 'z') ADVANCE(1956);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3009);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3034)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3035:
      if (eof) ADVANCE(3036);
      if (lookahead == '!') ADVANCE(21);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == ')') ADVANCE(3279);
      if (lookahead == ',') ADVANCE(3269);
      if (lookahead == '0') ADVANCE(3067);
      if (lookahead == ';') ADVANCE(3037);
      if (lookahead == '<') ADVANCE(3267);
      if (lookahead == '=') ADVANCE(3083);
      if (lookahead == '>') ADVANCE(3268);
      if (lookahead == '@') ADVANCE(24);
      if (lookahead == '[') ADVANCE(3264);
      if (lookahead == ']') ADVANCE(3265);
      if (lookahead == '^') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(1340);
      if (lookahead == 'b') ADVANCE(2017);
      if (lookahead == 'c') ADVANCE(1573);
      if (lookahead == 'd') ADVANCE(1771);
      if (lookahead == 'e') ADVANCE(2260);
      if (lookahead == 'f') ADVANCE(1457);
      if (lookahead == 'g') ADVANCE(2082);
      if (lookahead == 'h') ADVANCE(1404);
      if (lookahead == 'i') ADVANCE(2373);
      if (lookahead == 'j') ADVANCE(2923);
      if (lookahead == 'l') ADVANCE(1418);
      if (lookahead == 'm') ADVANCE(1953);
      if (lookahead == 'n') ADVANCE(1488);
      if (lookahead == 'o') ADVANCE(2591);
      if (lookahead == 'p') ADVANCE(2593);
      if (lookahead == 'r') ADVANCE(1862);
      if (lookahead == 's') ADVANCE(80);
      if (lookahead == 't') ADVANCE(1475);
      if (lookahead == 'u') ADVANCE(94);
      if (lookahead == 'v') ADVANCE(2536);
      if (lookahead == 'w') ADVANCE(1774);
      if (lookahead == 'x') ADVANCE(118);
      if (lookahead == 'z') ADVANCE(1980);
      if (lookahead == '{') ADVANCE(3260);
      if (lookahead == '}') ADVANCE(3261);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(3013);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3035)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3036:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 3037:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(3037);
      END_STATE();
    case 3038:
      ACCEPT_TOKEN(sym_attr_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3038);
      END_STATE();
    case 3039:
      ACCEPT_TOKEN(sym_comdat_ref);
      END_STATE();
    case 3040:
      ACCEPT_TOKEN(sym_comdat_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3040);
      END_STATE();
    case 3041:
      ACCEPT_TOKEN(sym_comdat_ref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3041);
      END_STATE();
    case 3042:
      ACCEPT_TOKEN(sym_global_var);
      END_STATE();
    case 3043:
      ACCEPT_TOKEN(sym_global_var);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3043);
      END_STATE();
    case 3044:
      ACCEPT_TOKEN(sym_global_var);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3044);
      END_STATE();
    case 3045:
      ACCEPT_TOKEN(sym_local_var);
      END_STATE();
    case 3046:
      ACCEPT_TOKEN(sym_local_var);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3046);
      END_STATE();
    case 3047:
      ACCEPT_TOKEN(sym_local_var);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3047);
      END_STATE();
    case 3048:
      ACCEPT_TOKEN(sym_label);
      END_STATE();
    case 3049:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      END_STATE();
    case 3050:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3050);
      END_STATE();
    case 3051:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3051);
      END_STATE();
    case 3052:
      ACCEPT_TOKEN(sym_summary_ref);
      END_STATE();
    case 3053:
      ACCEPT_TOKEN(sym_summary_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3053);
      END_STATE();
    case 3054:
      ACCEPT_TOKEN(sym_summary_ref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3054);
      END_STATE();
    case 3055:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 3056:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == ':') ADVANCE(3048);
      END_STATE();
    case 3057:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3076);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3008);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      END_STATE();
    case 3058:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3076);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3058);
      END_STATE();
    case 3059:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3076);
      if (lookahead == 'x') ADVANCE(3008);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3060:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3076);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3060);
      END_STATE();
    case 3061:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3074);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3062:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3077);
      if (lookahead == 'x') ADVANCE(4534);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3063:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3077);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3064:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'x') ADVANCE(3008);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3065);
      END_STATE();
    case 3065:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3065);
      END_STATE();
    case 3066:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3067:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == 'x') ADVANCE(3008);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3068:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == 'x') ADVANCE(4534);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3069:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3069);
      END_STATE();
    case 3070:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3071:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3072:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3072);
      END_STATE();
    case 3073:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3074:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3074);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3075:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3076:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(3007);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3076);
      END_STATE();
    case 3077:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(3809);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3077);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3078:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3078);
      END_STATE();
    case 3079:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3080:
      ACCEPT_TOKEN(sym_cstring);
      END_STATE();
    case 3081:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 3082:
      ACCEPT_TOKEN(anon_sym_triple);
      END_STATE();
    case 3083:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 3084:
      ACCEPT_TOKEN(anon_sym_datalayout);
      END_STATE();
    case 3085:
      ACCEPT_TOKEN(anon_sym_source_filename);
      END_STATE();
    case 3086:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 3087:
      ACCEPT_TOKEN(anon_sym_define);
      END_STATE();
    case 3088:
      ACCEPT_TOKEN(anon_sym_no_cfi);
      END_STATE();
    case 3089:
      ACCEPT_TOKEN(anon_sym_no_cfi);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3090:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 3091:
      ACCEPT_TOKEN(anon_sym_private);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3092:
      ACCEPT_TOKEN(anon_sym_private);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3093:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 3094:
      ACCEPT_TOKEN(anon_sym_internal);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3095:
      ACCEPT_TOKEN(anon_sym_internal);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3096:
      ACCEPT_TOKEN(anon_sym_weak);
      END_STATE();
    case 3097:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(918);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3098:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == '_') ADVANCE(4302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3099:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == '_') ADVANCE(2525);
      END_STATE();
    case 3100:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      END_STATE();
    case 3101:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3102:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3103:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(939);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3104:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == '_') ADVANCE(4319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3105:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == '_') ADVANCE(2554);
      END_STATE();
    case 3106:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      END_STATE();
    case 3107:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3108:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3109:
      ACCEPT_TOKEN(anon_sym_available_externally);
      END_STATE();
    case 3110:
      ACCEPT_TOKEN(anon_sym_available_externally);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3111:
      ACCEPT_TOKEN(anon_sym_available_externally);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3112:
      ACCEPT_TOKEN(anon_sym_appending);
      END_STATE();
    case 3113:
      ACCEPT_TOKEN(anon_sym_appending);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3114:
      ACCEPT_TOKEN(anon_sym_appending);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3115:
      ACCEPT_TOKEN(anon_sym_common);
      END_STATE();
    case 3116:
      ACCEPT_TOKEN(anon_sym_common);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3117:
      ACCEPT_TOKEN(anon_sym_common);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3118:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      END_STATE();
    case 3119:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3120:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3121:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 3122:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3123:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == 'l') ADVANCE(2985);
      END_STATE();
    case 3124:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3125:
      ACCEPT_TOKEN(anon_sym_dso_local);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(514);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3126:
      ACCEPT_TOKEN(anon_sym_dso_local);
      if (lookahead == '_') ADVANCE(1959);
      END_STATE();
    case 3127:
      ACCEPT_TOKEN(anon_sym_dso_local_equivalent);
      END_STATE();
    case 3128:
      ACCEPT_TOKEN(anon_sym_dso_local_equivalent);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3129:
      ACCEPT_TOKEN(anon_sym_dso_preemptable);
      END_STATE();
    case 3130:
      ACCEPT_TOKEN(anon_sym_dso_preemptable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3131:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 3132:
      ACCEPT_TOKEN(anon_sym_default);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3133:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 3134:
      ACCEPT_TOKEN(anon_sym_hidden);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3135:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 3136:
      ACCEPT_TOKEN(anon_sym_protected);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3137:
      ACCEPT_TOKEN(anon_sym_dllimport);
      END_STATE();
    case 3138:
      ACCEPT_TOKEN(anon_sym_dllimport);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3139:
      ACCEPT_TOKEN(anon_sym_dllexport);
      END_STATE();
    case 3140:
      ACCEPT_TOKEN(anon_sym_dllexport);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3141:
      ACCEPT_TOKEN(anon_sym_ccc);
      END_STATE();
    case 3142:
      ACCEPT_TOKEN(anon_sym_fastcc);
      END_STATE();
    case 3143:
      ACCEPT_TOKEN(anon_sym_coldcc);
      END_STATE();
    case 3144:
      ACCEPT_TOKEN(anon_sym_webkit_jscc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 3145:
      ACCEPT_TOKEN(anon_sym_anyregcc);
      END_STATE();
    case 3146:
      ACCEPT_TOKEN(anon_sym_preserve_mostcc);
      END_STATE();
    case 3147:
      ACCEPT_TOKEN(anon_sym_preserve_allcc);
      END_STATE();
    case 3148:
      ACCEPT_TOKEN(anon_sym_cxx_fast_tlscc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3149:
      ACCEPT_TOKEN(anon_sym_tailcc);
      END_STATE();
    case 3150:
      ACCEPT_TOKEN(anon_sym_swiftcc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3151:
      ACCEPT_TOKEN(anon_sym_swifttailcc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3152:
      ACCEPT_TOKEN(anon_sym_cfguard_checkcc);
      END_STATE();
    case 3153:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == '0') ADVANCE(3225);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3154:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == '8') ADVANCE(3153);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3155:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'm') ADVANCE(3158);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3156:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'm') ADVANCE(3159);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3157:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'p') ADVANCE(3154);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3158:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'x') ADVANCE(3245);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3159:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'x') ADVANCE(3241);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3160:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3161:
      ACCEPT_TOKEN(aux_sym_calling_conv_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3161);
      END_STATE();
    case 3162:
      ACCEPT_TOKEN(aux_sym_calling_conv_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3162);
      END_STATE();
    case 3163:
      ACCEPT_TOKEN(aux_sym_calling_conv_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3163);
      END_STATE();
    case 3164:
      ACCEPT_TOKEN(aux_sym_calling_conv_token5);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3164);
      END_STATE();
    case 3165:
      ACCEPT_TOKEN(aux_sym_calling_conv_token6);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3165);
      END_STATE();
    case 3166:
      ACCEPT_TOKEN(aux_sym_calling_conv_token7);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3166);
      END_STATE();
    case 3167:
      ACCEPT_TOKEN(aux_sym_calling_conv_token8);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3167);
      END_STATE();
    case 3168:
      ACCEPT_TOKEN(aux_sym_calling_conv_token9);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3168);
      END_STATE();
    case 3169:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 'c') ADVANCE(3144);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 3170:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 'c') ADVANCE(3169);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 3171:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 's') ADVANCE(3170);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 3172:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3172);
      END_STATE();
    case 3173:
      ACCEPT_TOKEN(anon_sym_ghccc);
      END_STATE();
    case 3174:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'a') ADVANCE(3181);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3175:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3150);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3176:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3525);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3177:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3151);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3178:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3177);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3179:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'e') ADVANCE(3182);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3180:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'f') ADVANCE(3521);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3181:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'i') ADVANCE(3183);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3182:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'l') ADVANCE(3180);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3183:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'l') ADVANCE(3178);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3184:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'n') ADVANCE(3176);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3185:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'o') ADVANCE(3187);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3186:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3185);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3187:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3529);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3188:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3186);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3189:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 's') ADVANCE(3190);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3190:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'y') ADVANCE(3184);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3191:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3192:
      ACCEPT_TOKEN(aux_sym_calling_conv_token12);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3192);
      END_STATE();
    case 3193:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == '_') ADVANCE(3201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3194:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'a') ADVANCE(3198);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3195:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'c') ADVANCE(3148);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3196:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'c') ADVANCE(3195);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3197:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'l') ADVANCE(3199);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3198:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 's') ADVANCE(3200);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3199:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 's') ADVANCE(3196);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3200:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 't') ADVANCE(3193);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3201:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 't') ADVANCE(3197);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3202:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3202);
      END_STATE();
    case 3203:
      ACCEPT_TOKEN(aux_sym_calling_conv_token14);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3203);
      END_STATE();
    case 3204:
      ACCEPT_TOKEN(anon_sym_cc);
      if (lookahead == 'c') ADVANCE(3141);
      END_STATE();
    case 3205:
      ACCEPT_TOKEN(anon_sym_unnamed_addr);
      END_STATE();
    case 3206:
      ACCEPT_TOKEN(anon_sym_local_unnamed_addr);
      END_STATE();
    case 3207:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 3208:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 3209:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3210:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3211:
      ACCEPT_TOKEN(anon_sym_half);
      END_STATE();
    case 3212:
      ACCEPT_TOKEN(anon_sym_half);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3213:
      ACCEPT_TOKEN(anon_sym_half);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3214:
      ACCEPT_TOKEN(anon_sym_bfloat);
      END_STATE();
    case 3215:
      ACCEPT_TOKEN(anon_sym_bfloat);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3216:
      ACCEPT_TOKEN(anon_sym_bfloat);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3217:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 3218:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3219:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3220:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 3221:
      ACCEPT_TOKEN(anon_sym_double);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3222:
      ACCEPT_TOKEN(anon_sym_double);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3223:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      END_STATE();
    case 3224:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3225:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3226:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3227:
      ACCEPT_TOKEN(anon_sym_fp128);
      END_STATE();
    case 3228:
      ACCEPT_TOKEN(anon_sym_fp128);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3229:
      ACCEPT_TOKEN(anon_sym_fp128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3230:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      END_STATE();
    case 3231:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3232:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3233:
      ACCEPT_TOKEN(anon_sym_label);
      END_STATE();
    case 3234:
      ACCEPT_TOKEN(anon_sym_label);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3235:
      ACCEPT_TOKEN(anon_sym_label);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3236:
      ACCEPT_TOKEN(anon_sym_metadata);
      END_STATE();
    case 3237:
      ACCEPT_TOKEN(anon_sym_metadata);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3238:
      ACCEPT_TOKEN(anon_sym_metadata);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3239:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      END_STATE();
    case 3240:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3241:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3242:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3243:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      END_STATE();
    case 3244:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3245:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3160);
      END_STATE();
    case 3246:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3247:
      ACCEPT_TOKEN(anon_sym_token);
      END_STATE();
    case 3248:
      ACCEPT_TOKEN(anon_sym_token);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3249:
      ACCEPT_TOKEN(anon_sym_token);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3250:
      ACCEPT_TOKEN(anon_sym_opaque);
      END_STATE();
    case 3251:
      ACCEPT_TOKEN(anon_sym_opaque);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3252:
      ACCEPT_TOKEN(anon_sym_opaque);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3253:
      ACCEPT_TOKEN(anon_sym_ptr);
      END_STATE();
    case 3254:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 't') ADVANCE(950);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3255:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == 't') ADVANCE(2567);
      END_STATE();
    case 3256:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3257:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (lookahead == ':') ADVANCE(3048);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3258:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3258);
      END_STATE();
    case 3259:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3260:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 3261:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 3262:
      ACCEPT_TOKEN(anon_sym_LT_LBRACE);
      END_STATE();
    case 3263:
      ACCEPT_TOKEN(anon_sym_RBRACE_GT);
      END_STATE();
    case 3264:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 3265:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 3266:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 3267:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '{') ADVANCE(3262);
      END_STATE();
    case 3268:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 3269:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 3270:
      ACCEPT_TOKEN(anon_sym_vscale);
      END_STATE();
    case 3271:
      ACCEPT_TOKEN(anon_sym_vscale);
      if (lookahead == '_') ADVANCE(2707);
      END_STATE();
    case 3272:
      ACCEPT_TOKEN(anon_sym_x);
      END_STATE();
    case 3273:
      ACCEPT_TOKEN(anon_sym_x);
      if (lookahead == 'c') ADVANCE(2092);
      END_STATE();
    case 3274:
      ACCEPT_TOKEN(anon_sym_addrspace);
      END_STATE();
    case 3275:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'c') ADVANCE(235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3276:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == 'c') ADVANCE(1494);
      END_STATE();
    case 3277:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3278:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 3279:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 3280:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 3281:
      ACCEPT_TOKEN(anon_sym_align);
      END_STATE();
    case 3282:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(1193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3283:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == 's') ADVANCE(4452);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3284:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == 's') ADVANCE(2868);
      END_STATE();
    case 3285:
      ACCEPT_TOKEN(anon_sym_section);
      END_STATE();
    case 3286:
      ACCEPT_TOKEN(anon_sym_section);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3287:
      ACCEPT_TOKEN(anon_sym_partition);
      END_STATE();
    case 3288:
      ACCEPT_TOKEN(anon_sym_partition);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3289:
      ACCEPT_TOKEN(anon_sym_comdat);
      END_STATE();
    case 3290:
      ACCEPT_TOKEN(anon_sym_comdat);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3291:
      ACCEPT_TOKEN(anon_sym_gc);
      END_STATE();
    case 3292:
      ACCEPT_TOKEN(anon_sym_gc);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3293:
      ACCEPT_TOKEN(anon_sym_prefix);
      END_STATE();
    case 3294:
      ACCEPT_TOKEN(anon_sym_prefix);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3295:
      ACCEPT_TOKEN(anon_sym_prologue);
      END_STATE();
    case 3296:
      ACCEPT_TOKEN(anon_sym_prologue);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3297:
      ACCEPT_TOKEN(anon_sym_personality);
      END_STATE();
    case 3298:
      ACCEPT_TOKEN(anon_sym_personality);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3299:
      ACCEPT_TOKEN(anon_sym_alignstack);
      END_STATE();
    case 3300:
      ACCEPT_TOKEN(anon_sym_alignstack);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3301:
      ACCEPT_TOKEN(anon_sym_alignstack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3302:
      ACCEPT_TOKEN(anon_sym_allocsize);
      END_STATE();
    case 3303:
      ACCEPT_TOKEN(anon_sym_allocsize);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3304:
      ACCEPT_TOKEN(anon_sym_allocsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3305:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      END_STATE();
    case 3306:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3307:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3308:
      ACCEPT_TOKEN(anon_sym_builtin);
      END_STATE();
    case 3309:
      ACCEPT_TOKEN(anon_sym_builtin);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3310:
      ACCEPT_TOKEN(anon_sym_builtin);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3311:
      ACCEPT_TOKEN(anon_sym_cold);
      END_STATE();
    case 3312:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3313:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == 'c') ADVANCE(1583);
      END_STATE();
    case 3314:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3315:
      ACCEPT_TOKEN(anon_sym_convergent);
      END_STATE();
    case 3316:
      ACCEPT_TOKEN(anon_sym_convergent);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3317:
      ACCEPT_TOKEN(anon_sym_convergent);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3318:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      END_STATE();
    case 3319:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3320:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3321:
      ACCEPT_TOKEN(anon_sym_hot);
      END_STATE();
    case 3322:
      ACCEPT_TOKEN(anon_sym_hot);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3323:
      ACCEPT_TOKEN(anon_sym_hot);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3324:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      END_STATE();
    case 3325:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3326:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3327:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      END_STATE();
    case 3328:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3329:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3330:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      END_STATE();
    case 3331:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3332:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3333:
      ACCEPT_TOKEN(anon_sym_jumptable);
      END_STATE();
    case 3334:
      ACCEPT_TOKEN(anon_sym_jumptable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3335:
      ACCEPT_TOKEN(anon_sym_jumptable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3336:
      ACCEPT_TOKEN(anon_sym_minsize);
      END_STATE();
    case 3337:
      ACCEPT_TOKEN(anon_sym_minsize);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3338:
      ACCEPT_TOKEN(anon_sym_minsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3339:
      ACCEPT_TOKEN(anon_sym_naked);
      END_STATE();
    case 3340:
      ACCEPT_TOKEN(anon_sym_naked);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3341:
      ACCEPT_TOKEN(anon_sym_naked);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3342:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      END_STATE();
    case 3343:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3344:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3345:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      END_STATE();
    case 3346:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3347:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3348:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      END_STATE();
    case 3349:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3350:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3351:
      ACCEPT_TOKEN(anon_sym_nofree);
      END_STATE();
    case 3352:
      ACCEPT_TOKEN(anon_sym_nofree);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3353:
      ACCEPT_TOKEN(anon_sym_nofree);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3354:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      END_STATE();
    case 3355:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3356:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3357:
      ACCEPT_TOKEN(anon_sym_noinline);
      END_STATE();
    case 3358:
      ACCEPT_TOKEN(anon_sym_noinline);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3359:
      ACCEPT_TOKEN(anon_sym_noinline);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3360:
      ACCEPT_TOKEN(anon_sym_nomerge);
      END_STATE();
    case 3361:
      ACCEPT_TOKEN(anon_sym_nomerge);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3362:
      ACCEPT_TOKEN(anon_sym_nomerge);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3363:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      END_STATE();
    case 3364:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3365:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3366:
      ACCEPT_TOKEN(anon_sym_noprofile);
      END_STATE();
    case 3367:
      ACCEPT_TOKEN(anon_sym_noprofile);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3368:
      ACCEPT_TOKEN(anon_sym_noprofile);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3369:
      ACCEPT_TOKEN(anon_sym_noredzone);
      END_STATE();
    case 3370:
      ACCEPT_TOKEN(anon_sym_noredzone);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3371:
      ACCEPT_TOKEN(anon_sym_noredzone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3372:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      END_STATE();
    case 3373:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3374:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3375:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 3376:
      ACCEPT_TOKEN(anon_sym_noreturn);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3377:
      ACCEPT_TOKEN(anon_sym_noreturn);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3378:
      ACCEPT_TOKEN(anon_sym_norecurse);
      END_STATE();
    case 3379:
      ACCEPT_TOKEN(anon_sym_norecurse);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3380:
      ACCEPT_TOKEN(anon_sym_norecurse);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3381:
      ACCEPT_TOKEN(anon_sym_willreturn);
      END_STATE();
    case 3382:
      ACCEPT_TOKEN(anon_sym_willreturn);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3383:
      ACCEPT_TOKEN(anon_sym_willreturn);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3384:
      ACCEPT_TOKEN(anon_sym_nosync);
      END_STATE();
    case 3385:
      ACCEPT_TOKEN(anon_sym_nosync);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3386:
      ACCEPT_TOKEN(anon_sym_nosync);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3387:
      ACCEPT_TOKEN(anon_sym_nounwind);
      END_STATE();
    case 3388:
      ACCEPT_TOKEN(anon_sym_nounwind);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3389:
      ACCEPT_TOKEN(anon_sym_nounwind);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3390:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      END_STATE();
    case 3391:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3392:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3393:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      END_STATE();
    case 3394:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3395:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3396:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      END_STATE();
    case 3397:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3398:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3399:
      ACCEPT_TOKEN(anon_sym_optnone);
      END_STATE();
    case 3400:
      ACCEPT_TOKEN(anon_sym_optnone);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3401:
      ACCEPT_TOKEN(anon_sym_optnone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3402:
      ACCEPT_TOKEN(anon_sym_optsize);
      END_STATE();
    case 3403:
      ACCEPT_TOKEN(anon_sym_optsize);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3404:
      ACCEPT_TOKEN(anon_sym_optsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3405:
      ACCEPT_TOKEN(anon_sym_readnone);
      END_STATE();
    case 3406:
      ACCEPT_TOKEN(anon_sym_readnone);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3407:
      ACCEPT_TOKEN(anon_sym_readnone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3408:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 3409:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3410:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3411:
      ACCEPT_TOKEN(anon_sym_writeonly);
      END_STATE();
    case 3412:
      ACCEPT_TOKEN(anon_sym_writeonly);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3413:
      ACCEPT_TOKEN(anon_sym_writeonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3414:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      END_STATE();
    case 3415:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3416:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3417:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      END_STATE();
    case 3418:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3419:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3420:
      ACCEPT_TOKEN(anon_sym_safestack);
      END_STATE();
    case 3421:
      ACCEPT_TOKEN(anon_sym_safestack);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3422:
      ACCEPT_TOKEN(anon_sym_safestack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3423:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      END_STATE();
    case 3424:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3425:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3426:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      END_STATE();
    case 3427:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3428:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3429:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      END_STATE();
    case 3430:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3431:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3432:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      END_STATE();
    case 3433:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3434:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3435:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      END_STATE();
    case 3436:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3437:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3438:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      END_STATE();
    case 3439:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3440:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3441:
      ACCEPT_TOKEN(anon_sym_speculatable);
      END_STATE();
    case 3442:
      ACCEPT_TOKEN(anon_sym_speculatable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3443:
      ACCEPT_TOKEN(anon_sym_speculatable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3444:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(446);
      if (lookahead == 's') ADVANCE(1157);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3445:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == 'r') ADVANCE(3972);
      if (lookahead == 's') ADVANCE(4450);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3446:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == 'r') ADVANCE(1869);
      if (lookahead == 's') ADVANCE(2871);
      END_STATE();
    case 3447:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      END_STATE();
    case 3448:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3449:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3450:
      ACCEPT_TOKEN(anon_sym_sspreq);
      END_STATE();
    case 3451:
      ACCEPT_TOKEN(anon_sym_sspreq);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3452:
      ACCEPT_TOKEN(anon_sym_sspreq);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3453:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 3454:
      ACCEPT_TOKEN(anon_sym_strictfp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3455:
      ACCEPT_TOKEN(anon_sym_strictfp);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3456:
      ACCEPT_TOKEN(anon_sym_uwtable);
      END_STATE();
    case 3457:
      ACCEPT_TOKEN(anon_sym_uwtable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3458:
      ACCEPT_TOKEN(anon_sym_uwtable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3459:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      END_STATE();
    case 3460:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3461:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3462:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      END_STATE();
    case 3463:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3464:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3465:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      END_STATE();
    case 3466:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3467:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3468:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      END_STATE();
    case 3469:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3470:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3471:
      ACCEPT_TOKEN(anon_sym_preallocated);
      END_STATE();
    case 3472:
      ACCEPT_TOKEN(anon_sym_preallocated);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3473:
      ACCEPT_TOKEN(anon_sym_preallocated);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3474:
      ACCEPT_TOKEN(anon_sym_zeroext);
      END_STATE();
    case 3475:
      ACCEPT_TOKEN(anon_sym_zeroext);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3476:
      ACCEPT_TOKEN(anon_sym_zeroext);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3477:
      ACCEPT_TOKEN(anon_sym_signext);
      END_STATE();
    case 3478:
      ACCEPT_TOKEN(anon_sym_signext);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3479:
      ACCEPT_TOKEN(anon_sym_signext);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3480:
      ACCEPT_TOKEN(anon_sym_inreg);
      END_STATE();
    case 3481:
      ACCEPT_TOKEN(anon_sym_inreg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3482:
      ACCEPT_TOKEN(anon_sym_inreg);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3483:
      ACCEPT_TOKEN(anon_sym_byval);
      END_STATE();
    case 3484:
      ACCEPT_TOKEN(anon_sym_byval);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3485:
      ACCEPT_TOKEN(anon_sym_byval);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3486:
      ACCEPT_TOKEN(anon_sym_byref);
      END_STATE();
    case 3487:
      ACCEPT_TOKEN(anon_sym_byref);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3488:
      ACCEPT_TOKEN(anon_sym_byref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3489:
      ACCEPT_TOKEN(anon_sym_inalloca);
      END_STATE();
    case 3490:
      ACCEPT_TOKEN(anon_sym_inalloca);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3491:
      ACCEPT_TOKEN(anon_sym_inalloca);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3492:
      ACCEPT_TOKEN(anon_sym_sret);
      END_STATE();
    case 3493:
      ACCEPT_TOKEN(anon_sym_sret);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3494:
      ACCEPT_TOKEN(anon_sym_sret);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3495:
      ACCEPT_TOKEN(anon_sym_elementtype);
      END_STATE();
    case 3496:
      ACCEPT_TOKEN(anon_sym_elementtype);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3497:
      ACCEPT_TOKEN(anon_sym_elementtype);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3498:
      ACCEPT_TOKEN(anon_sym_noalias);
      END_STATE();
    case 3499:
      ACCEPT_TOKEN(anon_sym_noalias);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3500:
      ACCEPT_TOKEN(anon_sym_noalias);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3501:
      ACCEPT_TOKEN(anon_sym_nocapture);
      END_STATE();
    case 3502:
      ACCEPT_TOKEN(anon_sym_nocapture);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3503:
      ACCEPT_TOKEN(anon_sym_nocapture);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3504:
      ACCEPT_TOKEN(anon_sym_nest);
      END_STATE();
    case 3505:
      ACCEPT_TOKEN(anon_sym_nest);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3506:
      ACCEPT_TOKEN(anon_sym_nest);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3507:
      ACCEPT_TOKEN(anon_sym_returned);
      END_STATE();
    case 3508:
      ACCEPT_TOKEN(anon_sym_returned);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3509:
      ACCEPT_TOKEN(anon_sym_returned);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3510:
      ACCEPT_TOKEN(anon_sym_nonnull);
      END_STATE();
    case 3511:
      ACCEPT_TOKEN(anon_sym_nonnull);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3512:
      ACCEPT_TOKEN(anon_sym_nonnull);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3513:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(929);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3514:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == '_') ADVANCE(4310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3515:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == '_') ADVANCE(2538);
      END_STATE();
    case 3516:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      END_STATE();
    case 3517:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3518:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3519:
      ACCEPT_TOKEN(anon_sym_swiftself);
      END_STATE();
    case 3520:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3521:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3522:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3523:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      END_STATE();
    case 3524:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3525:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3526:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3527:
      ACCEPT_TOKEN(anon_sym_swifterror);
      END_STATE();
    case 3528:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3529:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3191);
      END_STATE();
    case 3530:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3531:
      ACCEPT_TOKEN(anon_sym_immarg);
      END_STATE();
    case 3532:
      ACCEPT_TOKEN(anon_sym_immarg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3533:
      ACCEPT_TOKEN(anon_sym_immarg);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3534:
      ACCEPT_TOKEN(anon_sym_noundef);
      END_STATE();
    case 3535:
      ACCEPT_TOKEN(anon_sym_noundef);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3536:
      ACCEPT_TOKEN(anon_sym_noundef);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3537:
      ACCEPT_TOKEN(anon_sym_unreachable);
      END_STATE();
    case 3538:
      ACCEPT_TOKEN(anon_sym_unreachable);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3539:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'u') ADVANCE(1035);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3540:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3541:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == 'u') ADVANCE(2679);
      END_STATE();
    case 3542:
      ACCEPT_TOKEN(anon_sym_br);
      END_STATE();
    case 3543:
      ACCEPT_TOKEN(anon_sym_br);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3544:
      ACCEPT_TOKEN(anon_sym_resume);
      END_STATE();
    case 3545:
      ACCEPT_TOKEN(anon_sym_resume);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3546:
      ACCEPT_TOKEN(anon_sym_freeze);
      END_STATE();
    case 3547:
      ACCEPT_TOKEN(anon_sym_freeze);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3548:
      ACCEPT_TOKEN(anon_sym_indirectbr);
      END_STATE();
    case 3549:
      ACCEPT_TOKEN(anon_sym_indirectbr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3550:
      ACCEPT_TOKEN(anon_sym_extractelement);
      END_STATE();
    case 3551:
      ACCEPT_TOKEN(anon_sym_extractelement);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3552:
      ACCEPT_TOKEN(anon_sym_insertelement);
      END_STATE();
    case 3553:
      ACCEPT_TOKEN(anon_sym_insertelement);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3554:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 3555:
      ACCEPT_TOKEN(anon_sym_select);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3556:
      ACCEPT_TOKEN(anon_sym_shufflevector);
      END_STATE();
    case 3557:
      ACCEPT_TOKEN(anon_sym_shufflevector);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3558:
      ACCEPT_TOKEN(anon_sym_fneg);
      END_STATE();
    case 3559:
      ACCEPT_TOKEN(anon_sym_fneg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3560:
      ACCEPT_TOKEN(anon_sym_nsw);
      END_STATE();
    case 3561:
      ACCEPT_TOKEN(anon_sym_nuw);
      END_STATE();
    case 3562:
      ACCEPT_TOKEN(anon_sym_exact);
      END_STATE();
    case 3563:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 3564:
      ACCEPT_TOKEN(anon_sym_switch);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3565:
      ACCEPT_TOKEN(anon_sym_invoke);
      END_STATE();
    case 3566:
      ACCEPT_TOKEN(anon_sym_invoke);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3567:
      ACCEPT_TOKEN(anon_sym_to);
      if (lookahead == 'k') ADVANCE(1900);
      END_STATE();
    case 3568:
      ACCEPT_TOKEN(anon_sym_unwind);
      END_STATE();
    case 3569:
      ACCEPT_TOKEN(anon_sym_cleanupret);
      END_STATE();
    case 3570:
      ACCEPT_TOKEN(anon_sym_cleanupret);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3571:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 3572:
      ACCEPT_TOKEN(anon_sym_catchret);
      END_STATE();
    case 3573:
      ACCEPT_TOKEN(anon_sym_catchret);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3574:
      ACCEPT_TOKEN(anon_sym_catchswitch);
      END_STATE();
    case 3575:
      ACCEPT_TOKEN(anon_sym_catchswitch);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3576:
      ACCEPT_TOKEN(anon_sym_catchpad);
      END_STATE();
    case 3577:
      ACCEPT_TOKEN(anon_sym_catchpad);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3578:
      ACCEPT_TOKEN(anon_sym_cleanuppad);
      END_STATE();
    case 3579:
      ACCEPT_TOKEN(anon_sym_cleanuppad);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3580:
      ACCEPT_TOKEN(anon_sym_callbr);
      END_STATE();
    case 3581:
      ACCEPT_TOKEN(anon_sym_callbr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3582:
      ACCEPT_TOKEN(anon_sym_icmp);
      END_STATE();
    case 3583:
      ACCEPT_TOKEN(anon_sym_icmp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3584:
      ACCEPT_TOKEN(anon_sym_fcmp);
      END_STATE();
    case 3585:
      ACCEPT_TOKEN(anon_sym_fcmp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3586:
      ACCEPT_TOKEN(anon_sym_va_arg);
      END_STATE();
    case 3587:
      ACCEPT_TOKEN(anon_sym_va_arg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3588:
      ACCEPT_TOKEN(anon_sym_phi);
      END_STATE();
    case 3589:
      ACCEPT_TOKEN(anon_sym_phi);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3590:
      ACCEPT_TOKEN(anon_sym_landingpad);
      END_STATE();
    case 3591:
      ACCEPT_TOKEN(anon_sym_landingpad);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3592:
      ACCEPT_TOKEN(anon_sym_cleanup);
      END_STATE();
    case 3593:
      ACCEPT_TOKEN(anon_sym_tail);
      END_STATE();
    case 3594:
      ACCEPT_TOKEN(anon_sym_tail);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3595:
      ACCEPT_TOKEN(anon_sym_musttail);
      END_STATE();
    case 3596:
      ACCEPT_TOKEN(anon_sym_musttail);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3597:
      ACCEPT_TOKEN(anon_sym_notail);
      END_STATE();
    case 3598:
      ACCEPT_TOKEN(anon_sym_notail);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3599:
      ACCEPT_TOKEN(anon_sym_call);
      END_STATE();
    case 3600:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'b') ADVANCE(1005);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3601:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == 'b') ADVANCE(2638);
      END_STATE();
    case 3602:
      ACCEPT_TOKEN(anon_sym_alloca);
      END_STATE();
    case 3603:
      ACCEPT_TOKEN(anon_sym_alloca);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3604:
      ACCEPT_TOKEN(anon_sym_load);
      END_STATE();
    case 3605:
      ACCEPT_TOKEN(anon_sym_load);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3606:
      ACCEPT_TOKEN(anon_sym_atomic);
      END_STATE();
    case 3607:
      ACCEPT_TOKEN(anon_sym_atomic);
      if (lookahead == 'r') ADVANCE(2376);
      END_STATE();
    case 3608:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 3609:
      ACCEPT_TOKEN(anon_sym_store);
      END_STATE();
    case 3610:
      ACCEPT_TOKEN(anon_sym_store);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3611:
      ACCEPT_TOKEN(anon_sym_cmpxchg);
      END_STATE();
    case 3612:
      ACCEPT_TOKEN(anon_sym_cmpxchg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3613:
      ACCEPT_TOKEN(anon_sym_atomicrmw);
      END_STATE();
    case 3614:
      ACCEPT_TOKEN(anon_sym_atomicrmw);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3615:
      ACCEPT_TOKEN(anon_sym_fence);
      END_STATE();
    case 3616:
      ACCEPT_TOKEN(anon_sym_fence);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3617:
      ACCEPT_TOKEN(anon_sym_getelementptr);
      END_STATE();
    case 3618:
      ACCEPT_TOKEN(anon_sym_getelementptr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3619:
      ACCEPT_TOKEN(anon_sym_inbounds);
      END_STATE();
    case 3620:
      ACCEPT_TOKEN(anon_sym_inrange);
      END_STATE();
    case 3621:
      ACCEPT_TOKEN(anon_sym_extractvalue);
      END_STATE();
    case 3622:
      ACCEPT_TOKEN(anon_sym_extractvalue);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3623:
      ACCEPT_TOKEN(anon_sym_insertvalue);
      END_STATE();
    case 3624:
      ACCEPT_TOKEN(anon_sym_insertvalue);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3625:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 3626:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3627:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3628:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 3629:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3630:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3631:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 3632:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '_') ADVANCE(991);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3633:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3634:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == '_') ADVANCE(2618);
      END_STATE();
    case 3635:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3636:
      ACCEPT_TOKEN(anon_sym_none);
      END_STATE();
    case 3637:
      ACCEPT_TOKEN(anon_sym_none);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3638:
      ACCEPT_TOKEN(anon_sym_none);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3639:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 3640:
      ACCEPT_TOKEN(anon_sym_undef);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3641:
      ACCEPT_TOKEN(anon_sym_undef);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3642:
      ACCEPT_TOKEN(anon_sym_poison);
      END_STATE();
    case 3643:
      ACCEPT_TOKEN(anon_sym_poison);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3644:
      ACCEPT_TOKEN(anon_sym_poison);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3645:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      END_STATE();
    case 3646:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3647:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3648:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 3649:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'p') ADVANCE(196);
      if (lookahead == 'r') ADVANCE(500);
      if (lookahead == 's') ADVANCE(1243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3650:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == 'p') ADVANCE(1449);
      if (lookahead == 'r') ADVANCE(1941);
      if (lookahead == 's') ADVANCE(2954);
      END_STATE();
    case 3651:
      ACCEPT_TOKEN(anon_sym_filter);
      END_STATE();
    case 3652:
      ACCEPT_TOKEN(anon_sym_filter);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3653:
      ACCEPT_TOKEN(anon_sym_blockaddress);
      END_STATE();
    case 3654:
      ACCEPT_TOKEN(anon_sym_blockaddress);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3655:
      ACCEPT_TOKEN(anon_sym_mul);
      END_STATE();
    case 3656:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3657:
      ACCEPT_TOKEN(anon_sym_urem);
      END_STATE();
    case 3658:
      ACCEPT_TOKEN(anon_sym_urem);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3659:
      ACCEPT_TOKEN(anon_sym_srem);
      END_STATE();
    case 3660:
      ACCEPT_TOKEN(anon_sym_srem);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3661:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 3662:
      ACCEPT_TOKEN(anon_sym_shl);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3663:
      ACCEPT_TOKEN(anon_sym_udiv);
      END_STATE();
    case 3664:
      ACCEPT_TOKEN(anon_sym_udiv);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3665:
      ACCEPT_TOKEN(anon_sym_sdiv);
      END_STATE();
    case 3666:
      ACCEPT_TOKEN(anon_sym_sdiv);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3667:
      ACCEPT_TOKEN(anon_sym_lshr);
      END_STATE();
    case 3668:
      ACCEPT_TOKEN(anon_sym_lshr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3669:
      ACCEPT_TOKEN(anon_sym_ashr);
      END_STATE();
    case 3670:
      ACCEPT_TOKEN(anon_sym_ashr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3671:
      ACCEPT_TOKEN(anon_sym_fmul);
      END_STATE();
    case 3672:
      ACCEPT_TOKEN(anon_sym_fmul);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3673:
      ACCEPT_TOKEN(anon_sym_fdiv);
      END_STATE();
    case 3674:
      ACCEPT_TOKEN(anon_sym_fdiv);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3675:
      ACCEPT_TOKEN(anon_sym_frem);
      END_STATE();
    case 3676:
      ACCEPT_TOKEN(anon_sym_frem);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3677:
      ACCEPT_TOKEN(anon_sym_xchg);
      END_STATE();
    case 3678:
      ACCEPT_TOKEN(anon_sym_xchg);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3679:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 3680:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3681:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 'r') ADVANCE(1112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3682:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'r') ADVANCE(2744);
      END_STATE();
    case 3683:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'r') ADVANCE(2780);
      END_STATE();
    case 3684:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 3685:
      ACCEPT_TOKEN(anon_sym_sub);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3686:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 3687:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3688:
      ACCEPT_TOKEN(anon_sym_nand);
      END_STATE();
    case 3689:
      ACCEPT_TOKEN(anon_sym_nand);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3690:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 3691:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3692:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 3693:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3694:
      ACCEPT_TOKEN(anon_sym_max);
      END_STATE();
    case 3695:
      ACCEPT_TOKEN(anon_sym_max);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3696:
      ACCEPT_TOKEN(anon_sym_min);
      END_STATE();
    case 3697:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == 's') ADVANCE(660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3698:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3699:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == 's') ADVANCE(2160);
      END_STATE();
    case 3700:
      ACCEPT_TOKEN(anon_sym_umax);
      END_STATE();
    case 3701:
      ACCEPT_TOKEN(anon_sym_umax);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3702:
      ACCEPT_TOKEN(anon_sym_umin);
      END_STATE();
    case 3703:
      ACCEPT_TOKEN(anon_sym_umin);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3704:
      ACCEPT_TOKEN(anon_sym_fadd);
      END_STATE();
    case 3705:
      ACCEPT_TOKEN(anon_sym_fadd);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3706:
      ACCEPT_TOKEN(anon_sym_fsub);
      END_STATE();
    case 3707:
      ACCEPT_TOKEN(anon_sym_fsub);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3708:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 3709:
      ACCEPT_TOKEN(anon_sym_ne);
      END_STATE();
    case 3710:
      ACCEPT_TOKEN(anon_sym_ne);
      if (lookahead == 's') ADVANCE(2786);
      END_STATE();
    case 3711:
      ACCEPT_TOKEN(anon_sym_ugt);
      END_STATE();
    case 3712:
      ACCEPT_TOKEN(anon_sym_uge);
      END_STATE();
    case 3713:
      ACCEPT_TOKEN(anon_sym_ult);
      END_STATE();
    case 3714:
      ACCEPT_TOKEN(anon_sym_ule);
      END_STATE();
    case 3715:
      ACCEPT_TOKEN(anon_sym_sgt);
      END_STATE();
    case 3716:
      ACCEPT_TOKEN(anon_sym_sge);
      END_STATE();
    case 3717:
      ACCEPT_TOKEN(anon_sym_slt);
      END_STATE();
    case 3718:
      ACCEPT_TOKEN(anon_sym_sle);
      END_STATE();
    case 3719:
      ACCEPT_TOKEN(anon_sym_oeq);
      END_STATE();
    case 3720:
      ACCEPT_TOKEN(anon_sym_ogt);
      END_STATE();
    case 3721:
      ACCEPT_TOKEN(anon_sym_oge);
      END_STATE();
    case 3722:
      ACCEPT_TOKEN(anon_sym_olt);
      END_STATE();
    case 3723:
      ACCEPT_TOKEN(anon_sym_ole);
      END_STATE();
    case 3724:
      ACCEPT_TOKEN(anon_sym_one);
      END_STATE();
    case 3725:
      ACCEPT_TOKEN(anon_sym_ord);
      END_STATE();
    case 3726:
      ACCEPT_TOKEN(anon_sym_ueq);
      END_STATE();
    case 3727:
      ACCEPT_TOKEN(anon_sym_une);
      END_STATE();
    case 3728:
      ACCEPT_TOKEN(anon_sym_uno);
      END_STATE();
    case 3729:
      ACCEPT_TOKEN(anon_sym_uno);
      if (lookahead == 'r') ADVANCE(1765);
      END_STATE();
    case 3730:
      ACCEPT_TOKEN(anon_sym_bitcast);
      END_STATE();
    case 3731:
      ACCEPT_TOKEN(anon_sym_bitcast);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3732:
      ACCEPT_TOKEN(anon_sym_trunc);
      END_STATE();
    case 3733:
      ACCEPT_TOKEN(anon_sym_trunc);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3734:
      ACCEPT_TOKEN(anon_sym_zext);
      END_STATE();
    case 3735:
      ACCEPT_TOKEN(anon_sym_zext);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3736:
      ACCEPT_TOKEN(anon_sym_sext);
      END_STATE();
    case 3737:
      ACCEPT_TOKEN(anon_sym_sext);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3738:
      ACCEPT_TOKEN(anon_sym_fptrunc);
      END_STATE();
    case 3739:
      ACCEPT_TOKEN(anon_sym_fptrunc);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3740:
      ACCEPT_TOKEN(anon_sym_fpext);
      END_STATE();
    case 3741:
      ACCEPT_TOKEN(anon_sym_fpext);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3742:
      ACCEPT_TOKEN(anon_sym_addrspacecast);
      END_STATE();
    case 3743:
      ACCEPT_TOKEN(anon_sym_addrspacecast);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3744:
      ACCEPT_TOKEN(anon_sym_uitofp);
      END_STATE();
    case 3745:
      ACCEPT_TOKEN(anon_sym_uitofp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3746:
      ACCEPT_TOKEN(anon_sym_sitofp);
      END_STATE();
    case 3747:
      ACCEPT_TOKEN(anon_sym_sitofp);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3748:
      ACCEPT_TOKEN(anon_sym_fptoui);
      END_STATE();
    case 3749:
      ACCEPT_TOKEN(anon_sym_fptoui);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3750:
      ACCEPT_TOKEN(anon_sym_fptosi);
      END_STATE();
    case 3751:
      ACCEPT_TOKEN(anon_sym_fptosi);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3752:
      ACCEPT_TOKEN(anon_sym_inttoptr);
      END_STATE();
    case 3753:
      ACCEPT_TOKEN(anon_sym_inttoptr);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3754:
      ACCEPT_TOKEN(anon_sym_ptrtoint);
      END_STATE();
    case 3755:
      ACCEPT_TOKEN(anon_sym_ptrtoint);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3756:
      ACCEPT_TOKEN(anon_sym_unordered);
      END_STATE();
    case 3757:
      ACCEPT_TOKEN(anon_sym_unordered);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3758:
      ACCEPT_TOKEN(anon_sym_monotonic);
      END_STATE();
    case 3759:
      ACCEPT_TOKEN(anon_sym_monotonic);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3760:
      ACCEPT_TOKEN(anon_sym_acquire);
      END_STATE();
    case 3761:
      ACCEPT_TOKEN(anon_sym_acquire);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3762:
      ACCEPT_TOKEN(anon_sym_release);
      END_STATE();
    case 3763:
      ACCEPT_TOKEN(anon_sym_release);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3764:
      ACCEPT_TOKEN(anon_sym_acq_rel);
      END_STATE();
    case 3765:
      ACCEPT_TOKEN(anon_sym_acq_rel);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3766:
      ACCEPT_TOKEN(anon_sym_seq_cst);
      END_STATE();
    case 3767:
      ACCEPT_TOKEN(anon_sym_seq_cst);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3768:
      ACCEPT_TOKEN(anon_sym_syncscope);
      END_STATE();
    case 3769:
      ACCEPT_TOKEN(anon_sym_syncscope);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3770:
      ACCEPT_TOKEN(anon_sym_nnan);
      END_STATE();
    case 3771:
      ACCEPT_TOKEN(anon_sym_ninf);
      END_STATE();
    case 3772:
      ACCEPT_TOKEN(anon_sym_nsz);
      END_STATE();
    case 3773:
      ACCEPT_TOKEN(anon_sym_arcp);
      END_STATE();
    case 3774:
      ACCEPT_TOKEN(anon_sym_contract);
      END_STATE();
    case 3775:
      ACCEPT_TOKEN(anon_sym_afn);
      END_STATE();
    case 3776:
      ACCEPT_TOKEN(anon_sym_reassoc);
      END_STATE();
    case 3777:
      ACCEPT_TOKEN(anon_sym_fast);
      END_STATE();
    case 3778:
      ACCEPT_TOKEN(anon_sym_fast);
      if (lookahead == 'c') ADVANCE(1584);
      END_STATE();
    case 3779:
      ACCEPT_TOKEN(anon_sym_within);
      END_STATE();
    case 3780:
      ACCEPT_TOKEN(anon_sym_caller);
      END_STATE();
    case 3781:
      ACCEPT_TOKEN(anon_sym_uselistorder);
      if (lookahead == ':') ADVANCE(3048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1290);
      END_STATE();
    case 3782:
      ACCEPT_TOKEN(anon_sym_uselistorder);
      if (lookahead == '_') ADVANCE(1550);
      END_STATE();
    case 3783:
      ACCEPT_TOKEN(anon_sym_uselistorder_bb);
      END_STATE();
    case 3784:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 3785:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 3786:
      ACCEPT_TOKEN(anon_sym_sideeffect);
      END_STATE();
    case 3787:
      ACCEPT_TOKEN(anon_sym_inteldialect);
      END_STATE();
    case 3788:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 3789:
      ACCEPT_TOKEN(anon_sym_externally_initialized);
      END_STATE();
    case 3790:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 3791:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 3792:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 3793:
      ACCEPT_TOKEN(anon_sym_ifunc);
      END_STATE();
    case 3794:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 3795:
      ACCEPT_TOKEN(anon_sym_localdynamic);
      END_STATE();
    case 3796:
      ACCEPT_TOKEN(anon_sym_initialexec);
      END_STATE();
    case 3797:
      ACCEPT_TOKEN(anon_sym_localexec);
      END_STATE();
    case 3798:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 3799:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == 'r') ADVANCE(1874);
      END_STATE();
    case 3800:
      ACCEPT_TOKEN(anon_sym_exactmatch);
      END_STATE();
    case 3801:
      ACCEPT_TOKEN(anon_sym_largest);
      END_STATE();
    case 3802:
      ACCEPT_TOKEN(anon_sym_nodeduplicate);
      END_STATE();
    case 3803:
      ACCEPT_TOKEN(anon_sym_samesize);
      END_STATE();
    case 3804:
      ACCEPT_TOKEN(anon_sym_distinct);
      END_STATE();
    case 3805:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '"') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3051);
      END_STATE();
    case 3806:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 3807:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 3808:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3809:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '+') ADVANCE(3012);
      if (lookahead == '-') ADVANCE(4538);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3079);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3810:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4156);
      if (lookahead == 'a') ADVANCE(4184);
      if (lookahead == 'b') ADVANCE(4496);
      if (lookahead == 'c') ADVANCE(3888);
      if (lookahead == 'd') ADVANCE(4482);
      if (lookahead == 'f') ADVANCE(4374);
      if (lookahead == 'i') ADVANCE(4240);
      if (lookahead == 'm') ADVANCE(4025);
      if (lookahead == 'n') ADVANCE(4185);
      if (lookahead == 'p') ADVANCE(4362);
      if (lookahead == 'r') ADVANCE(3971);
      if (lookahead == 's') ADVANCE(3862);
      if (lookahead == 'u') ADVANCE(4242);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3811:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4457);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3812:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4422);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3813:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4389);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3814:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4478);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3815:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4506);
      if (lookahead == 'a') ADVANCE(4080);
      if (lookahead == 'h') ADVANCE(3858);
      if (lookahead == 'i') ADVANCE(4095);
      if (lookahead == 'p') ADVANCE(4006);
      if (lookahead == 'r') ADVANCE(4022);
      if (lookahead == 's') ADVANCE(4335);
      if (lookahead == 't') ADVANCE(4364);
      if (lookahead == 'w') ADVANCE(4108);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3816:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4506);
      if (lookahead == 'n') ADVANCE(3963);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3817:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4506);
      if (lookahead == 'w') ADVANCE(4475);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3818:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3819:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(3226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3820:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '1') ADVANCE(3822);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3821:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '1') ADVANCE(3823);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3822:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '2') ADVANCE(3826);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3823:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '2') ADVANCE(3827);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3824:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '6') ADVANCE(3830);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3825:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3824);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3826:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3827:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3828:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3819);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3829:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3830:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3866);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3831:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4503);
      if (lookahead == 'a') ADVANCE(4170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3832:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3833:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4342);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3834:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3835:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4378);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3836:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3929);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3837:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3838:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4444);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3839:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3879);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3840:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3841:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4010);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3842:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3843:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4498);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3844:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4078);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3845:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3846:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4311);
      if (lookahead == 'o') ADVANCE(4272);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3847:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3848:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4163);
      if (lookahead == 'e') ADVANCE(4412);
      if (lookahead == 'o') ADVANCE(3810);
      if (lookahead == 'u') ADVANCE(4178);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3849:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3923);
      if (lookahead == 'd') ADVANCE(4140);
      if (lookahead == 'l') ADVANCE(4137);
      if (lookahead == 'r') ADVANCE(4008);
      if (lookahead == 't') ADVANCE(4053);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3850:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4520);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3851:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3910);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3852:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3853:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3854:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3946);
      if (lookahead == 't') ADVANCE(4488);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3855:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3856:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3857:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4157);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3858:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3955);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3859:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3909);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3860:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4360);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3861:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4402);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3862:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4293);
      if (lookahead == 'y') ADVANCE(4258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3863:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4161);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3864:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4168);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3865:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4409);
      if (lookahead == 'e') ADVANCE(4395);
      if (lookahead == 's') ADVANCE(4039);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3866:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4228);
      if (lookahead == 'f') ADVANCE(4339);
      if (lookahead == 'm') ADVANCE(4230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3867:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3922);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3868:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4091);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3869:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4200);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3870:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3924);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3871:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3957);
      if (lookahead == 'h') ADVANCE(4504);
      if (lookahead == 'm') ADVANCE(4023);
      if (lookahead == 't') ADVANCE(4106);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3872:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3952);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3873:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3874:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3956);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3875:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3876:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4438);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3877:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3962);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3878:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4379);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3879:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3880:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4441);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3881:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4213);
      if (lookahead == 'l') ADVANCE(4326);
      if (lookahead == 'p') ADVANCE(3820);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3882:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3883:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4453);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3884:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3885:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3886:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4443);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3887:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3888:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4341);
      if (lookahead == 'f') ADVANCE(3834);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3889:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3890:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4224);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3891:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3892:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3893:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4099);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3894:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4462);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3895:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3896:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3897:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3937);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3898:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3899:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4459);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3900:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3911);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3901:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3912);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3902:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3903:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3914);
      if (lookahead == 'i') ADVANCE(4499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3904:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3915);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3905:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3916);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3906:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3969);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3907:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4295);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3908:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3909:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4045);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3910:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3911:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3912:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3913:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3914:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3915:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3916:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3917:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3918:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3919:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3386);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3920:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3921:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3922:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4158);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3923:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3932);
      if (lookahead == 'l') ADVANCE(4187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3924:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4159);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3925:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3926:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3927:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4162);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3928:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4448);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3929:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4333);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3930:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3852);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3931:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3844);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3932:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4019);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3933:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4463);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3934:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3981);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3935:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4069);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3936:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3995);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3937:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4003);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3938:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4484);
      if (lookahead == 'd') ADVANCE(4533);
      if (lookahead == 't') ADVANCE(4490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3939:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3869);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3940:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3941:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4428);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3942:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3895);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3943:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3891);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3944:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3945:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3946:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3947:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3341);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3948:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3389);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3949:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3950:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3951:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3473);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3952:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3953:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3395);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3954:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3955:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3956:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3832);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3957:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3967);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3958:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4353);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3959:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3960:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4017);
      if (lookahead == 'w') ADVANCE(4120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3961:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3962:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3899);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3963:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4036);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3964:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3961);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3965:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4046);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3966:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3967:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4393);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3968:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4396);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3969:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3968);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3970:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3854);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3971:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3972:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3973:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4105);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3974:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3353);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3975:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3976:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3362);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3977:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3401);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3978:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3979:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3092);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3980:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3458);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3981:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3982:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3359);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3983:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3407);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3984:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3304);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3985:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3986:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3503);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3987:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3368);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3988:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3380);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3989:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3371);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3990:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3991:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3992:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3993:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3443);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3994:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3995:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3996:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3514);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3997:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3392);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3998:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3638);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 3999:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3627);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4000:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3630);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4001:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4002:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4003:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4004:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4366);
      if (lookahead == 'i') ADVANCE(4411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4005:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4006:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3925);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4007:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4008:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4086);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4009:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3857);
      if (lookahead == 'i') ADVANCE(4179);
      if (lookahead == 'r') ADVANCE(4132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4010:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4511);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4011:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4081);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4012:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3835);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4013:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4359);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4014:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4015:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3842);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4016:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4017:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4018:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4370);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4019:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4424);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4020:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4021:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3829);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4022:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4023:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4024:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4025:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4361);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4026:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3890);
      if (lookahead == 'i') ADVANCE(4497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4027:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4028:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3949);
      if (lookahead == 's') ADVANCE(3838);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4029:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3845);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4030:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4031:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4032:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4082);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4033:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4094);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4034:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3926);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4035:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3951);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4036:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4074);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4037:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4038:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4476);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4039:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4040:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4369);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4041:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4373);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4042:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3974);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4043:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4357);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4044:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4045:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4046:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4288);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4047:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4287);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4048:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4049:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3836);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4050:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4510);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4051:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3863);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4052:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3933);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4053:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4372);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4054:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4391);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4055:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4417);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4056:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4271);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4057:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4058:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3872);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4059:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4060:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4309);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4061:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4062:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4399);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4063:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4397);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4064:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4065:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4066:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4067:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4068:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4069:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3905);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4070:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3488);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4071:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4072:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3522);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4073:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3213);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4074:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4075:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4304);
      if (lookahead == 'n') ADVANCE(4324);
      if (lookahead == 's') ADVANCE(4134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4076:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4077:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4078:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4349);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4079:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4435);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4080:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4059);
      if (lookahead == 'n') ADVANCE(4115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4081:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4082:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4407);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4083:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4196);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4084:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4148);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4085:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4086:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3482);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4087:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4088:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4089:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3449);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4090:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4091:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4092:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4093:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4094:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3813);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4095:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4096:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4097:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3976);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4098:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3994);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4099:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3997);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4100:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4056);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4101:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4102:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4103:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(3878);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4104:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4034);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4105:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4106:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4107:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4108:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4109:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4525);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4110:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4255);
      if (lookahead == 'u') ADVANCE(4410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4111:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4112:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4113:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4114:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3940);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4115:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4467);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4116:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3861);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4117:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4414);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4118:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3953);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4119:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4120:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4121:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4122:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4123:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3954);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4124:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4125:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4126:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4449);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4127:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4289);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4128:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4129:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4261);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4130:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4465);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4131:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4132:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4133:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3908);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4134:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4135:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4096);
      if (lookahead == 'l') ADVANCE(4299);
      if (lookahead == 'w') ADVANCE(3850);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4136:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4286);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4137:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4138:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4139:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4527);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4140:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4380);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4141:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4142:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3943);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4143:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4144:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4145:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3936);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4146:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4147:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4530);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4148:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4149:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4150:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4315);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4151:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4152:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3896);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4153:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4532);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4154:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4155:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4156:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'j') ADVANCE(4483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4157:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3098);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4158:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3422);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4159:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3301);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4160:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4161:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4162:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4163:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4014);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4164:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4306);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4165:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4166:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4135);
      if (lookahead == 'p') ADVANCE(4340);
      if (lookahead == 'r') ADVANCE(4093);
      if (lookahead == 'v') ADVANCE(3887);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4167:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3945);
      if (lookahead == 'm') ADVANCE(4229);
      if (lookahead == 'n') ADVANCE(4500);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4168:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4169:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4170:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4171:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3095);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4172:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4173:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3635);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4174:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4175:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3833);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4176:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4016);
      if (lookahead == 'x') ADVANCE(4464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4177:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4178:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4175);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4179:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4214);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4180:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4181:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4514);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4182:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4466);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4183:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4072);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4184:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4185:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3855);
      if (lookahead == 'n') ADVANCE(4489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4186:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4516);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4187:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4188:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4189:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4517);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4190:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4191:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4408);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4192:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4193:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4194:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4169);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4195:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3876);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4196:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4320);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4197:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4198:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4325);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4199:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4216);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4200:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4012);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4201:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4202:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4015);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4203:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4204:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4205:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3980);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4206:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4207:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3985);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4208:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3987);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4209:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3993);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4210:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4037);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4211:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3996);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4212:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4001);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4213:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4423);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4214:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4390);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4215:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4216:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4217:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4474);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4218:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4334);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4219:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4220:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4153);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4221:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3901);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4222:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4223:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4149);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4224:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4225:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4232);
      if (lookahead == 'n') ADVANCE(3849);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4226:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4308);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4227:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(3846);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4228:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4507);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4229:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4305);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4230:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4231:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4336);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4232:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(3860);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4233:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4234:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4235:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4031);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4236:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4237:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4238:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4239:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4047);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4240:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4348);
      if (lookahead == 'n') ADVANCE(4219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4241:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4068);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4242:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3960);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4243:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4244:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4245:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3831);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4246:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4028);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4247:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4248:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4249:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4250:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3383);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4251:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3320);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4252:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4253:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3644);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4254:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4164);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4255:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4256:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3966);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4257:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4088);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4258:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3919);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4259:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3948);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4260:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4261:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4090);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4262:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3950);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4263:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4092);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4264:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3920);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4265:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4177);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4266:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4005);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4267:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4456);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4268:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4269:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4181);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4270:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3973);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4271:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4439);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4272:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4273:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4274:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4275:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3977);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4276:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3982);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4277:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3983);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4278:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3989);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4279:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3992);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4280:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3998);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4281:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4282:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4283:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4098);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4284:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3875);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4285:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4286:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4420);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4287:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4468);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4288:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4289:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4471);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4290:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4291:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4327);
      if (lookahead == 'o') ADVANCE(4265);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4292:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3898);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4293:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4294:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4295:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4296:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4297:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4298:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4299:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4300:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4084);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4301:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4101);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4302:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3958);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4303:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4495);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4304:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4363);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4305:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4306:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4281);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4307:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4354);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4308:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4367);
      if (lookahead == 't') ADVANCE(3868);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4309:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4310:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4375);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4311:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4376);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4312:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4313:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4260);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4314:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4315:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4316:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4317:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4165);
      if (lookahead == 'r') ADVANCE(4486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4318:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4319:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4320:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3880);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4321:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4121);
      if (lookahead == 'p') ADVANCE(3931);
      if (lookahead == 't') ADVANCE(4356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4322:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4323:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4324:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4325:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3874);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4326:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3885);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4327:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4328:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3886);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4329:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4330:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4280);
      if (lookahead == 'u') ADVANCE(4204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4331:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4332:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4333:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4501);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4334:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3944);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4335:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3445);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4336:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3814);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4337:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4338:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4432);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4339:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3828);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4340:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4020);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4341:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4447);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4342:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4331);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4343:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3856);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4344:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3897);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4345:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3990);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4346:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4347:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4371);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4348:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4349:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3821);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4350:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4351:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'q') ADVANCE(3452);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4352:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'q') ADVANCE(4487);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4353:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3102);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4354:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3530);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4355:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3108);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4356:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4357:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3647);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4358:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4026);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4359:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4322);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4360:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4087);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4361:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4097);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4362:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4363:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4076);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4364:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4365:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4007);
      if (lookahead == 'v') ADVANCE(3864);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4366:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4011);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4367:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4515);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4368:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4369:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3837);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4370:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4245);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4371:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4301);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4372:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4284);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4373:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3847);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4374:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4042);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4375:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3840);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4376:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3839);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4377:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4378:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3884);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4379:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3965);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4380:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4052);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4381:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4426);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4382:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3893);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4383:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4384:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4385:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4292);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4386:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3986);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4387:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4030);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4388:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4389:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4390:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4038);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4391:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4100);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4392:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4393:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4055);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4394:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4395:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4392);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4396:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4397:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4067);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4398:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4313);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4399:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4400:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4102);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4401:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3939);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4402:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3500);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4403:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3467);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4404:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3344);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4405:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4406:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4407:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3374);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4408:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3812);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4409:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4521);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4410:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4445);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4411:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3851);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4412:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4413:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4109);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4414:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3843);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4415:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4416:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4417:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4405);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4418:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4419:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4420:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4458);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4421:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3988);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4422:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4033);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4423:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4000);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4424:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4425:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4451);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4426:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4344);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4427:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4428:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4429:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4122);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4430:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4316);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4431:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3323);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4432:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4433:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4434:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4435:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3865);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4436:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3479);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4437:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3476);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4438:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3903);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4439:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4440:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4441:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4442:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4443:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3216);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4444:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4502);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4445:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4446:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4522);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4447:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4492);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4448:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4077);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4449:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4083);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4450:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4451:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3867);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4452:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3870);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4453:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4150);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4454:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4060);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4455:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3873);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4456:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4446);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4457:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4458:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4394);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4459:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3853);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4460:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3979);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4461:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3991);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4462:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4035);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4463:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3811);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4464:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4018);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4465:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4466:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4467:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4468:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3883);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4469:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3877);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4470:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4471:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4040);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4472:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4473:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4064);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4474:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4475:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3900);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4476:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4477:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3902);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4478:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3904);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4479:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4111);
      if (lookahead == 'y') ADVANCE(4365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4480:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4481:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4482:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4483:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4231);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4484:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4368);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4485:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4486:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(3999);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4487:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4002);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4488:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4489:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4490:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4383);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4491:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4492:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4386);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4493:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4494:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4495:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(3918);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4496:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4155);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4497:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(3889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4498:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(3892);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4499:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4029);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4500:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4054);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4501:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4057);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4502:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4503:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4051);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4504:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(3906);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4505:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(3942);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4506:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4534);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4507:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(3246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4508:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(3242);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4509:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4436);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4510:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4511:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4473);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4512:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4513:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4514:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4515:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3428);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4516:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3326);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4517:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3111);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4518:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3329);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4519:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4520:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4429);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4521:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4264);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4522:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4345);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4523:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4519);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4524:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4531);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4525:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(3975);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4526:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(3978);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4527:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4021);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4528:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(3984);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4529:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4049);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4530:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4041);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4531:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4532:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4533:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4329);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4540);
      END_STATE();
    case 4534:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(4539);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4535:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4536:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4537:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4538:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4539:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4540:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4540);
      END_STATE();
    case 4541:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 4542:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 4543:
      ACCEPT_TOKEN(anon_sym_attributes);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 8},
  [3] = {.lex_state = 5},
  [4] = {.lex_state = 36},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3030},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3027},
  [26] = {.lex_state = 8},
  [27] = {.lex_state = 8},
  [28] = {.lex_state = 8},
  [29] = {.lex_state = 8},
  [30] = {.lex_state = 5},
  [31] = {.lex_state = 5},
  [32] = {.lex_state = 5},
  [33] = {.lex_state = 5},
  [34] = {.lex_state = 5},
  [35] = {.lex_state = 5},
  [36] = {.lex_state = 5},
  [37] = {.lex_state = 5},
  [38] = {.lex_state = 5},
  [39] = {.lex_state = 5},
  [40] = {.lex_state = 5},
  [41] = {.lex_state = 5},
  [42] = {.lex_state = 5},
  [43] = {.lex_state = 5},
  [44] = {.lex_state = 5},
  [45] = {.lex_state = 5},
  [46] = {.lex_state = 5},
  [47] = {.lex_state = 5},
  [48] = {.lex_state = 3027},
  [49] = {.lex_state = 3027},
  [50] = {.lex_state = 36},
  [51] = {.lex_state = 36},
  [52] = {.lex_state = 3027},
  [53] = {.lex_state = 36},
  [54] = {.lex_state = 36},
  [55] = {.lex_state = 3030},
  [56] = {.lex_state = 3030},
  [57] = {.lex_state = 3030},
  [58] = {.lex_state = 3027},
  [59] = {.lex_state = 3030},
  [60] = {.lex_state = 3030},
  [61] = {.lex_state = 3027},
  [62] = {.lex_state = 3027},
  [63] = {.lex_state = 3027},
  [64] = {.lex_state = 3027},
  [65] = {.lex_state = 3027},
  [66] = {.lex_state = 3027},
  [67] = {.lex_state = 3027},
  [68] = {.lex_state = 3027},
  [69] = {.lex_state = 3027},
  [70] = {.lex_state = 3027},
  [71] = {.lex_state = 3027},
  [72] = {.lex_state = 3027},
  [73] = {.lex_state = 3027},
  [74] = {.lex_state = 3027},
  [75] = {.lex_state = 3027},
  [76] = {.lex_state = 3027},
  [77] = {.lex_state = 3027},
  [78] = {.lex_state = 3027},
  [79] = {.lex_state = 3030},
  [80] = {.lex_state = 3030},
  [81] = {.lex_state = 3030},
  [82] = {.lex_state = 3030},
  [83] = {.lex_state = 3032},
  [84] = {.lex_state = 3033},
  [85] = {.lex_state = 3033},
  [86] = {.lex_state = 3033},
  [87] = {.lex_state = 3033},
  [88] = {.lex_state = 3033},
  [89] = {.lex_state = 3033},
  [90] = {.lex_state = 3033},
  [91] = {.lex_state = 3033},
  [92] = {.lex_state = 3033},
  [93] = {.lex_state = 3033},
  [94] = {.lex_state = 3033},
  [95] = {.lex_state = 3033},
  [96] = {.lex_state = 3033},
  [97] = {.lex_state = 3033},
  [98] = {.lex_state = 3033},
  [99] = {.lex_state = 3033},
  [100] = {.lex_state = 3033},
  [101] = {.lex_state = 3033},
  [102] = {.lex_state = 3033},
  [103] = {.lex_state = 3033},
  [104] = {.lex_state = 3033},
  [105] = {.lex_state = 3032},
  [106] = {.lex_state = 3033},
  [107] = {.lex_state = 3033},
  [108] = {.lex_state = 3033},
  [109] = {.lex_state = 3033},
  [110] = {.lex_state = 3033},
  [111] = {.lex_state = 3033},
  [112] = {.lex_state = 3033},
  [113] = {.lex_state = 3033},
  [114] = {.lex_state = 3033},
  [115] = {.lex_state = 3033},
  [116] = {.lex_state = 3033},
  [117] = {.lex_state = 3033},
  [118] = {.lex_state = 3033},
  [119] = {.lex_state = 3033},
  [120] = {.lex_state = 3033},
  [121] = {.lex_state = 3033},
  [122] = {.lex_state = 3032},
  [123] = {.lex_state = 3032},
  [124] = {.lex_state = 3032},
  [125] = {.lex_state = 3032},
  [126] = {.lex_state = 36},
  [127] = {.lex_state = 3032},
  [128] = {.lex_state = 3032},
  [129] = {.lex_state = 3032},
  [130] = {.lex_state = 36},
  [131] = {.lex_state = 3032},
  [132] = {.lex_state = 3032},
  [133] = {.lex_state = 36},
  [134] = {.lex_state = 36},
  [135] = {.lex_state = 36},
  [136] = {.lex_state = 36},
  [137] = {.lex_state = 36},
  [138] = {.lex_state = 36},
  [139] = {.lex_state = 36},
  [140] = {.lex_state = 36},
  [141] = {.lex_state = 36},
  [142] = {.lex_state = 36},
  [143] = {.lex_state = 36},
  [144] = {.lex_state = 36},
  [145] = {.lex_state = 36},
  [146] = {.lex_state = 36},
  [147] = {.lex_state = 36},
  [148] = {.lex_state = 36},
  [149] = {.lex_state = 36},
  [150] = {.lex_state = 36},
  [151] = {.lex_state = 36},
  [152] = {.lex_state = 36},
  [153] = {.lex_state = 36},
  [154] = {.lex_state = 36},
  [155] = {.lex_state = 36},
  [156] = {.lex_state = 36},
  [157] = {.lex_state = 36},
  [158] = {.lex_state = 36},
  [159] = {.lex_state = 36},
  [160] = {.lex_state = 36},
  [161] = {.lex_state = 36},
  [162] = {.lex_state = 36},
  [163] = {.lex_state = 36},
  [164] = {.lex_state = 36},
  [165] = {.lex_state = 36},
  [166] = {.lex_state = 36},
  [167] = {.lex_state = 36},
  [168] = {.lex_state = 36},
  [169] = {.lex_state = 36},
  [170] = {.lex_state = 36},
  [171] = {.lex_state = 36},
  [172] = {.lex_state = 36},
  [173] = {.lex_state = 36},
  [174] = {.lex_state = 36},
  [175] = {.lex_state = 36},
  [176] = {.lex_state = 36},
  [177] = {.lex_state = 36},
  [178] = {.lex_state = 36},
  [179] = {.lex_state = 36},
  [180] = {.lex_state = 36},
  [181] = {.lex_state = 37},
  [182] = {.lex_state = 36},
  [183] = {.lex_state = 36},
  [184] = {.lex_state = 36},
  [185] = {.lex_state = 36},
  [186] = {.lex_state = 36},
  [187] = {.lex_state = 3032},
  [188] = {.lex_state = 3032},
  [189] = {.lex_state = 36},
  [190] = {.lex_state = 36},
  [191] = {.lex_state = 36},
  [192] = {.lex_state = 3030},
  [193] = {.lex_state = 37},
  [194] = {.lex_state = 37},
  [195] = {.lex_state = 37},
  [196] = {.lex_state = 3032},
  [197] = {.lex_state = 3030},
  [198] = {.lex_state = 36},
  [199] = {.lex_state = 36},
  [200] = {.lex_state = 36},
  [201] = {.lex_state = 36},
  [202] = {.lex_state = 3032},
  [203] = {.lex_state = 36},
  [204] = {.lex_state = 36},
  [205] = {.lex_state = 36},
  [206] = {.lex_state = 36},
  [207] = {.lex_state = 36},
  [208] = {.lex_state = 3032},
  [209] = {.lex_state = 3030},
  [210] = {.lex_state = 3030},
  [211] = {.lex_state = 3030},
  [212] = {.lex_state = 3030},
  [213] = {.lex_state = 3030},
  [214] = {.lex_state = 3032},
  [215] = {.lex_state = 6},
  [216] = {.lex_state = 40},
  [217] = {.lex_state = 3032},
  [218] = {.lex_state = 3032},
  [219] = {.lex_state = 3032},
  [220] = {.lex_state = 3032},
  [221] = {.lex_state = 3032},
  [222] = {.lex_state = 3032},
  [223] = {.lex_state = 3032},
  [224] = {.lex_state = 3032},
  [225] = {.lex_state = 3032},
  [226] = {.lex_state = 3032},
  [227] = {.lex_state = 3032},
  [228] = {.lex_state = 3032},
  [229] = {.lex_state = 6},
  [230] = {.lex_state = 40},
  [231] = {.lex_state = 3026},
  [232] = {.lex_state = 3032},
  [233] = {.lex_state = 3032},
  [234] = {.lex_state = 3032},
  [235] = {.lex_state = 3028},
  [236] = {.lex_state = 3032},
  [237] = {.lex_state = 3028},
  [238] = {.lex_state = 3028},
  [239] = {.lex_state = 3028},
  [240] = {.lex_state = 3026},
  [241] = {.lex_state = 3028},
  [242] = {.lex_state = 3028},
  [243] = {.lex_state = 3028},
  [244] = {.lex_state = 3028},
  [245] = {.lex_state = 3028},
  [246] = {.lex_state = 3028},
  [247] = {.lex_state = 3028},
  [248] = {.lex_state = 3028},
  [249] = {.lex_state = 3028},
  [250] = {.lex_state = 3028},
  [251] = {.lex_state = 3028},
  [252] = {.lex_state = 3028},
  [253] = {.lex_state = 3028},
  [254] = {.lex_state = 3028},
  [255] = {.lex_state = 3034},
  [256] = {.lex_state = 6},
  [257] = {.lex_state = 6},
  [258] = {.lex_state = 3034},
  [259] = {.lex_state = 3034},
  [260] = {.lex_state = 3026},
  [261] = {.lex_state = 3034},
  [262] = {.lex_state = 6},
  [263] = {.lex_state = 3028},
  [264] = {.lex_state = 6},
  [265] = {.lex_state = 6},
  [266] = {.lex_state = 3034},
  [267] = {.lex_state = 6},
  [268] = {.lex_state = 3034},
  [269] = {.lex_state = 3034},
  [270] = {.lex_state = 3028},
  [271] = {.lex_state = 6},
  [272] = {.lex_state = 6},
  [273] = {.lex_state = 6},
  [274] = {.lex_state = 6},
  [275] = {.lex_state = 6},
  [276] = {.lex_state = 6},
  [277] = {.lex_state = 6},
  [278] = {.lex_state = 6},
  [279] = {.lex_state = 6},
  [280] = {.lex_state = 6},
  [281] = {.lex_state = 6},
  [282] = {.lex_state = 6},
  [283] = {.lex_state = 3026},
  [284] = {.lex_state = 3029},
  [285] = {.lex_state = 40},
  [286] = {.lex_state = 3029},
  [287] = {.lex_state = 40},
  [288] = {.lex_state = 40},
  [289] = {.lex_state = 40},
  [290] = {.lex_state = 3026},
  [291] = {.lex_state = 3026},
  [292] = {.lex_state = 3026},
  [293] = {.lex_state = 3026},
  [294] = {.lex_state = 3026},
  [295] = {.lex_state = 3026},
  [296] = {.lex_state = 3026},
  [297] = {.lex_state = 3026},
  [298] = {.lex_state = 3026},
  [299] = {.lex_state = 3026},
  [300] = {.lex_state = 3026},
  [301] = {.lex_state = 3026},
  [302] = {.lex_state = 3026},
  [303] = {.lex_state = 3026},
  [304] = {.lex_state = 3026},
  [305] = {.lex_state = 3026},
  [306] = {.lex_state = 3026},
  [307] = {.lex_state = 3026},
  [308] = {.lex_state = 3026},
  [309] = {.lex_state = 3026},
  [310] = {.lex_state = 3026},
  [311] = {.lex_state = 3026},
  [312] = {.lex_state = 3026},
  [313] = {.lex_state = 3026},
  [314] = {.lex_state = 3026},
  [315] = {.lex_state = 3026},
  [316] = {.lex_state = 3026},
  [317] = {.lex_state = 3026},
  [318] = {.lex_state = 3026},
  [319] = {.lex_state = 3026},
  [320] = {.lex_state = 3026},
  [321] = {.lex_state = 3026},
  [322] = {.lex_state = 3026},
  [323] = {.lex_state = 3026},
  [324] = {.lex_state = 3026},
  [325] = {.lex_state = 3026},
  [326] = {.lex_state = 3026},
  [327] = {.lex_state = 3026},
  [328] = {.lex_state = 3026},
  [329] = {.lex_state = 3026},
  [330] = {.lex_state = 3026},
  [331] = {.lex_state = 3026},
  [332] = {.lex_state = 3026},
  [333] = {.lex_state = 3026},
  [334] = {.lex_state = 3026},
  [335] = {.lex_state = 3026},
  [336] = {.lex_state = 36},
  [337] = {.lex_state = 36},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 36},
  [340] = {.lex_state = 3026},
  [341] = {.lex_state = 3034},
  [342] = {.lex_state = 3034},
  [343] = {.lex_state = 3034},
  [344] = {.lex_state = 3028},
  [345] = {.lex_state = 3034},
  [346] = {.lex_state = 3034},
  [347] = {.lex_state = 10},
  [348] = {.lex_state = 3034},
  [349] = {.lex_state = 3034},
  [350] = {.lex_state = 3034},
  [351] = {.lex_state = 3034},
  [352] = {.lex_state = 3028},
  [353] = {.lex_state = 3028},
  [354] = {.lex_state = 3034},
  [355] = {.lex_state = 3034},
  [356] = {.lex_state = 3034},
  [357] = {.lex_state = 3034},
  [358] = {.lex_state = 3034},
  [359] = {.lex_state = 3034},
  [360] = {.lex_state = 3034},
  [361] = {.lex_state = 3034},
  [362] = {.lex_state = 3034},
  [363] = {.lex_state = 3030},
  [364] = {.lex_state = 3026},
  [365] = {.lex_state = 3026},
  [366] = {.lex_state = 3026},
  [367] = {.lex_state = 3026},
  [368] = {.lex_state = 3026},
  [369] = {.lex_state = 3026},
  [370] = {.lex_state = 3026},
  [371] = {.lex_state = 3026},
  [372] = {.lex_state = 3026},
  [373] = {.lex_state = 3026},
  [374] = {.lex_state = 3026},
  [375] = {.lex_state = 3026},
  [376] = {.lex_state = 3027},
  [377] = {.lex_state = 3026},
  [378] = {.lex_state = 3026},
  [379] = {.lex_state = 3027},
  [380] = {.lex_state = 3027},
  [381] = {.lex_state = 3026},
  [382] = {.lex_state = 3027},
  [383] = {.lex_state = 3026},
  [384] = {.lex_state = 3026},
  [385] = {.lex_state = 3026},
  [386] = {.lex_state = 3027},
  [387] = {.lex_state = 3026},
  [388] = {.lex_state = 3030},
  [389] = {.lex_state = 3026},
  [390] = {.lex_state = 3030},
  [391] = {.lex_state = 3030},
  [392] = {.lex_state = 3030},
  [393] = {.lex_state = 3030},
  [394] = {.lex_state = 3030},
  [395] = {.lex_state = 3030},
  [396] = {.lex_state = 3030},
  [397] = {.lex_state = 3030},
  [398] = {.lex_state = 3030},
  [399] = {.lex_state = 3030},
  [400] = {.lex_state = 3027},
  [401] = {.lex_state = 3030},
  [402] = {.lex_state = 3026},
  [403] = {.lex_state = 3027},
  [404] = {.lex_state = 3027},
  [405] = {.lex_state = 3026},
  [406] = {.lex_state = 3027},
  [407] = {.lex_state = 3027},
  [408] = {.lex_state = 3030},
  [409] = {.lex_state = 3030},
  [410] = {.lex_state = 3030},
  [411] = {.lex_state = 3030},
  [412] = {.lex_state = 3030},
  [413] = {.lex_state = 3030},
  [414] = {.lex_state = 3030},
  [415] = {.lex_state = 3030},
  [416] = {.lex_state = 3030},
  [417] = {.lex_state = 3030},
  [418] = {.lex_state = 3030},
  [419] = {.lex_state = 3030},
  [420] = {.lex_state = 3030},
  [421] = {.lex_state = 3030},
  [422] = {.lex_state = 3030},
  [423] = {.lex_state = 3030},
  [424] = {.lex_state = 3030},
  [425] = {.lex_state = 3030},
  [426] = {.lex_state = 3030},
  [427] = {.lex_state = 3030},
  [428] = {.lex_state = 3030},
  [429] = {.lex_state = 3030},
  [430] = {.lex_state = 3030},
  [431] = {.lex_state = 3030},
  [432] = {.lex_state = 11},
  [433] = {.lex_state = 3030},
  [434] = {.lex_state = 3030},
  [435] = {.lex_state = 3030},
  [436] = {.lex_state = 3030},
  [437] = {.lex_state = 3030},
  [438] = {.lex_state = 3030},
  [439] = {.lex_state = 3030},
  [440] = {.lex_state = 3030},
  [441] = {.lex_state = 3030},
  [442] = {.lex_state = 11},
  [443] = {.lex_state = 11},
  [444] = {.lex_state = 11},
  [445] = {.lex_state = 11},
  [446] = {.lex_state = 11},
  [447] = {.lex_state = 11},
  [448] = {.lex_state = 3030},
  [449] = {.lex_state = 3026},
  [450] = {.lex_state = 3026},
  [451] = {.lex_state = 11},
  [452] = {.lex_state = 11},
  [453] = {.lex_state = 11},
  [454] = {.lex_state = 11},
  [455] = {.lex_state = 11},
  [456] = {.lex_state = 11},
  [457] = {.lex_state = 3027},
  [458] = {.lex_state = 3027},
  [459] = {.lex_state = 3027},
  [460] = {.lex_state = 3027},
  [461] = {.lex_state = 3027},
  [462] = {.lex_state = 3027},
  [463] = {.lex_state = 3027},
  [464] = {.lex_state = 3027},
  [465] = {.lex_state = 3027},
  [466] = {.lex_state = 3027},
  [467] = {.lex_state = 3030},
  [468] = {.lex_state = 3030},
  [469] = {.lex_state = 3030},
  [470] = {.lex_state = 3030},
  [471] = {.lex_state = 3030},
  [472] = {.lex_state = 3030},
  [473] = {.lex_state = 4},
  [474] = {.lex_state = 3030},
  [475] = {.lex_state = 4},
  [476] = {.lex_state = 3030},
  [477] = {.lex_state = 4},
  [478] = {.lex_state = 3030},
  [479] = {.lex_state = 3030},
  [480] = {.lex_state = 3030},
  [481] = {.lex_state = 3030},
  [482] = {.lex_state = 3030},
  [483] = {.lex_state = 3030},
  [484] = {.lex_state = 3030},
  [485] = {.lex_state = 3030},
  [486] = {.lex_state = 3030},
  [487] = {.lex_state = 3030},
  [488] = {.lex_state = 3030},
  [489] = {.lex_state = 3030},
  [490] = {.lex_state = 4},
  [491] = {.lex_state = 3030},
  [492] = {.lex_state = 3030},
  [493] = {.lex_state = 3030},
  [494] = {.lex_state = 3030},
  [495] = {.lex_state = 3030},
  [496] = {.lex_state = 3030},
  [497] = {.lex_state = 3030},
  [498] = {.lex_state = 3030},
  [499] = {.lex_state = 4},
  [500] = {.lex_state = 3030},
  [501] = {.lex_state = 3030},
  [502] = {.lex_state = 3030},
  [503] = {.lex_state = 3030},
  [504] = {.lex_state = 3030},
  [505] = {.lex_state = 3030},
  [506] = {.lex_state = 3030},
  [507] = {.lex_state = 3030},
  [508] = {.lex_state = 3030},
  [509] = {.lex_state = 3030},
  [510] = {.lex_state = 4},
  [511] = {.lex_state = 3030},
  [512] = {.lex_state = 3030},
  [513] = {.lex_state = 4},
  [514] = {.lex_state = 4},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 4},
  [517] = {.lex_state = 4},
  [518] = {.lex_state = 4},
  [519] = {.lex_state = 3030},
  [520] = {.lex_state = 3030},
  [521] = {.lex_state = 4},
  [522] = {.lex_state = 4},
  [523] = {.lex_state = 4},
  [524] = {.lex_state = 4},
  [525] = {.lex_state = 4},
  [526] = {.lex_state = 4},
  [527] = {.lex_state = 10},
  [528] = {.lex_state = 10},
  [529] = {.lex_state = 10},
  [530] = {.lex_state = 10},
  [531] = {.lex_state = 36},
  [532] = {.lex_state = 36},
  [533] = {.lex_state = 36},
  [534] = {.lex_state = 36},
  [535] = {.lex_state = 36},
  [536] = {.lex_state = 36},
  [537] = {.lex_state = 36},
  [538] = {.lex_state = 36},
  [539] = {.lex_state = 36},
  [540] = {.lex_state = 36},
  [541] = {.lex_state = 36},
  [542] = {.lex_state = 36},
  [543] = {.lex_state = 36},
  [544] = {.lex_state = 36},
  [545] = {.lex_state = 36},
  [546] = {.lex_state = 36},
  [547] = {.lex_state = 36},
  [548] = {.lex_state = 36},
  [549] = {.lex_state = 36},
  [550] = {.lex_state = 36},
  [551] = {.lex_state = 36},
  [552] = {.lex_state = 36},
  [553] = {.lex_state = 36},
  [554] = {.lex_state = 36},
  [555] = {.lex_state = 36},
  [556] = {.lex_state = 36},
  [557] = {.lex_state = 36},
  [558] = {.lex_state = 36},
  [559] = {.lex_state = 36},
  [560] = {.lex_state = 36},
  [561] = {.lex_state = 36},
  [562] = {.lex_state = 36},
  [563] = {.lex_state = 36},
  [564] = {.lex_state = 36},
  [565] = {.lex_state = 36},
  [566] = {.lex_state = 36},
  [567] = {.lex_state = 36},
  [568] = {.lex_state = 36},
  [569] = {.lex_state = 36},
  [570] = {.lex_state = 36},
  [571] = {.lex_state = 36},
  [572] = {.lex_state = 36},
  [573] = {.lex_state = 36},
  [574] = {.lex_state = 36},
  [575] = {.lex_state = 36},
  [576] = {.lex_state = 36},
  [577] = {.lex_state = 36},
  [578] = {.lex_state = 36},
  [579] = {.lex_state = 36},
  [580] = {.lex_state = 36},
  [581] = {.lex_state = 36},
  [582] = {.lex_state = 36},
  [583] = {.lex_state = 36},
  [584] = {.lex_state = 36},
  [585] = {.lex_state = 36},
  [586] = {.lex_state = 36},
  [587] = {.lex_state = 36},
  [588] = {.lex_state = 36},
  [589] = {.lex_state = 36},
  [590] = {.lex_state = 36},
  [591] = {.lex_state = 36},
  [592] = {.lex_state = 36},
  [593] = {.lex_state = 36},
  [594] = {.lex_state = 36},
  [595] = {.lex_state = 36},
  [596] = {.lex_state = 36},
  [597] = {.lex_state = 36},
  [598] = {.lex_state = 36},
  [599] = {.lex_state = 36},
  [600] = {.lex_state = 36},
  [601] = {.lex_state = 36},
  [602] = {.lex_state = 36},
  [603] = {.lex_state = 36},
  [604] = {.lex_state = 36},
  [605] = {.lex_state = 36},
  [606] = {.lex_state = 36},
  [607] = {.lex_state = 36},
  [608] = {.lex_state = 36},
  [609] = {.lex_state = 36},
  [610] = {.lex_state = 36},
  [611] = {.lex_state = 36},
  [612] = {.lex_state = 36},
  [613] = {.lex_state = 36},
  [614] = {.lex_state = 36},
  [615] = {.lex_state = 36},
  [616] = {.lex_state = 36},
  [617] = {.lex_state = 36},
  [618] = {.lex_state = 36},
  [619] = {.lex_state = 36},
  [620] = {.lex_state = 36},
  [621] = {.lex_state = 36},
  [622] = {.lex_state = 36},
  [623] = {.lex_state = 36},
  [624] = {.lex_state = 36},
  [625] = {.lex_state = 36},
  [626] = {.lex_state = 36},
  [627] = {.lex_state = 36},
  [628] = {.lex_state = 36},
  [629] = {.lex_state = 36},
  [630] = {.lex_state = 36},
  [631] = {.lex_state = 36},
  [632] = {.lex_state = 36},
  [633] = {.lex_state = 36},
  [634] = {.lex_state = 36},
  [635] = {.lex_state = 36},
  [636] = {.lex_state = 36},
  [637] = {.lex_state = 36},
  [638] = {.lex_state = 36},
  [639] = {.lex_state = 36},
  [640] = {.lex_state = 36},
  [641] = {.lex_state = 36},
  [642] = {.lex_state = 36},
  [643] = {.lex_state = 36},
  [644] = {.lex_state = 36},
  [645] = {.lex_state = 36},
  [646] = {.lex_state = 36},
  [647] = {.lex_state = 36},
  [648] = {.lex_state = 36},
  [649] = {.lex_state = 36},
  [650] = {.lex_state = 36},
  [651] = {.lex_state = 36},
  [652] = {.lex_state = 36},
  [653] = {.lex_state = 36},
  [654] = {.lex_state = 8},
  [655] = {.lex_state = 8},
  [656] = {.lex_state = 2},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 2},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 2},
  [661] = {.lex_state = 2},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 2},
  [664] = {.lex_state = 2},
  [665] = {.lex_state = 2},
  [666] = {.lex_state = 2},
  [667] = {.lex_state = 2},
  [668] = {.lex_state = 2},
  [669] = {.lex_state = 2},
  [670] = {.lex_state = 2},
  [671] = {.lex_state = 2},
  [672] = {.lex_state = 2},
  [673] = {.lex_state = 2},
  [674] = {.lex_state = 2},
  [675] = {.lex_state = 7},
  [676] = {.lex_state = 7},
  [677] = {.lex_state = 1},
  [678] = {.lex_state = 1},
  [679] = {.lex_state = 2},
  [680] = {.lex_state = 2},
  [681] = {.lex_state = 2},
  [682] = {.lex_state = 2},
  [683] = {.lex_state = 2},
  [684] = {.lex_state = 2},
  [685] = {.lex_state = 2},
  [686] = {.lex_state = 2},
  [687] = {.lex_state = 2},
  [688] = {.lex_state = 2},
  [689] = {.lex_state = 2},
  [690] = {.lex_state = 2},
  [691] = {.lex_state = 3026},
  [692] = {.lex_state = 3026},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 3026},
  [696] = {.lex_state = 3026},
  [697] = {.lex_state = 3026},
  [698] = {.lex_state = 3026},
  [699] = {.lex_state = 3026},
  [700] = {.lex_state = 3026},
  [701] = {.lex_state = 7},
  [702] = {.lex_state = 7},
  [703] = {.lex_state = 7},
  [704] = {.lex_state = 7},
  [705] = {.lex_state = 7},
  [706] = {.lex_state = 7},
  [707] = {.lex_state = 3026},
  [708] = {.lex_state = 7},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 7},
  [711] = {.lex_state = 7},
  [712] = {.lex_state = 7},
  [713] = {.lex_state = 7},
  [714] = {.lex_state = 7},
  [715] = {.lex_state = 3026},
  [716] = {.lex_state = 3026},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 7},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 3026},
  [721] = {.lex_state = 3026},
  [722] = {.lex_state = 3026},
  [723] = {.lex_state = 3026},
  [724] = {.lex_state = 3026},
  [725] = {.lex_state = 3026},
  [726] = {.lex_state = 3026},
  [727] = {.lex_state = 3026},
  [728] = {.lex_state = 3026},
  [729] = {.lex_state = 3026},
  [730] = {.lex_state = 3027},
  [731] = {.lex_state = 3026},
  [732] = {.lex_state = 3026},
  [733] = {.lex_state = 3026},
  [734] = {.lex_state = 3026},
  [735] = {.lex_state = 3026},
  [736] = {.lex_state = 3027},
  [737] = {.lex_state = 3026},
  [738] = {.lex_state = 3026},
  [739] = {.lex_state = 3026},
  [740] = {.lex_state = 3026},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 3026},
  [743] = {.lex_state = 41},
  [744] = {.lex_state = 41},
  [745] = {.lex_state = 3026},
  [746] = {.lex_state = 41},
  [747] = {.lex_state = 3026},
  [748] = {.lex_state = 3026},
  [749] = {.lex_state = 3026},
  [750] = {.lex_state = 8},
  [751] = {.lex_state = 3026},
  [752] = {.lex_state = 3026},
  [753] = {.lex_state = 3026},
  [754] = {.lex_state = 8},
  [755] = {.lex_state = 3026},
  [756] = {.lex_state = 3027},
  [757] = {.lex_state = 41},
  [758] = {.lex_state = 3026},
  [759] = {.lex_state = 3026},
  [760] = {.lex_state = 3026},
  [761] = {.lex_state = 3026},
  [762] = {.lex_state = 3026},
  [763] = {.lex_state = 41},
  [764] = {.lex_state = 3026},
  [765] = {.lex_state = 8},
  [766] = {.lex_state = 3026},
  [767] = {.lex_state = 3026},
  [768] = {.lex_state = 3026},
  [769] = {.lex_state = 3026},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 3026},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 3026},
  [776] = {.lex_state = 3026},
  [777] = {.lex_state = 3026},
  [778] = {.lex_state = 41},
  [779] = {.lex_state = 3026},
  [780] = {.lex_state = 3026},
  [781] = {.lex_state = 3026},
  [782] = {.lex_state = 41},
  [783] = {.lex_state = 3026},
  [784] = {.lex_state = 3026},
  [785] = {.lex_state = 3026},
  [786] = {.lex_state = 3026},
  [787] = {.lex_state = 3026},
  [788] = {.lex_state = 41},
  [789] = {.lex_state = 3026},
  [790] = {.lex_state = 3026},
  [791] = {.lex_state = 3026},
  [792] = {.lex_state = 3027},
  [793] = {.lex_state = 3026},
  [794] = {.lex_state = 3026},
  [795] = {.lex_state = 8},
  [796] = {.lex_state = 41},
  [797] = {.lex_state = 3026},
  [798] = {.lex_state = 3026},
  [799] = {.lex_state = 3026},
  [800] = {.lex_state = 41},
  [801] = {.lex_state = 3026},
  [802] = {.lex_state = 3026},
  [803] = {.lex_state = 3026},
  [804] = {.lex_state = 3026},
  [805] = {.lex_state = 3026},
  [806] = {.lex_state = 3026},
  [807] = {.lex_state = 3026},
  [808] = {.lex_state = 3026},
  [809] = {.lex_state = 3026},
  [810] = {.lex_state = 3026},
  [811] = {.lex_state = 3026},
  [812] = {.lex_state = 3026},
  [813] = {.lex_state = 3026},
  [814] = {.lex_state = 3026},
  [815] = {.lex_state = 3026},
  [816] = {.lex_state = 3026},
  [817] = {.lex_state = 3026},
  [818] = {.lex_state = 3026},
  [819] = {.lex_state = 3026},
  [820] = {.lex_state = 3026},
  [821] = {.lex_state = 3026},
  [822] = {.lex_state = 3026},
  [823] = {.lex_state = 3026},
  [824] = {.lex_state = 3026},
  [825] = {.lex_state = 3026},
  [826] = {.lex_state = 3026},
  [827] = {.lex_state = 3026},
  [828] = {.lex_state = 3026},
  [829] = {.lex_state = 3026},
  [830] = {.lex_state = 3026},
  [831] = {.lex_state = 3026},
  [832] = {.lex_state = 3026},
  [833] = {.lex_state = 3026},
  [834] = {.lex_state = 3026},
  [835] = {.lex_state = 3026},
  [836] = {.lex_state = 3026},
  [837] = {.lex_state = 3026},
  [838] = {.lex_state = 3026},
  [839] = {.lex_state = 3026},
  [840] = {.lex_state = 3026},
  [841] = {.lex_state = 3026},
  [842] = {.lex_state = 3026},
  [843] = {.lex_state = 3026},
  [844] = {.lex_state = 3026},
  [845] = {.lex_state = 3026},
  [846] = {.lex_state = 3026},
  [847] = {.lex_state = 3026},
  [848] = {.lex_state = 3026},
  [849] = {.lex_state = 3026},
  [850] = {.lex_state = 3026},
  [851] = {.lex_state = 3026},
  [852] = {.lex_state = 3026},
  [853] = {.lex_state = 3026},
  [854] = {.lex_state = 3026},
  [855] = {.lex_state = 3026},
  [856] = {.lex_state = 3026},
  [857] = {.lex_state = 3026},
  [858] = {.lex_state = 3026},
  [859] = {.lex_state = 3026},
  [860] = {.lex_state = 3026},
  [861] = {.lex_state = 3026},
  [862] = {.lex_state = 3026},
  [863] = {.lex_state = 3026},
  [864] = {.lex_state = 3026},
  [865] = {.lex_state = 3026},
  [866] = {.lex_state = 3026},
  [867] = {.lex_state = 3026},
  [868] = {.lex_state = 3026},
  [869] = {.lex_state = 3026},
  [870] = {.lex_state = 3026},
  [871] = {.lex_state = 3026},
  [872] = {.lex_state = 3026},
  [873] = {.lex_state = 3026},
  [874] = {.lex_state = 3026},
  [875] = {.lex_state = 3026},
  [876] = {.lex_state = 3026},
  [877] = {.lex_state = 3026},
  [878] = {.lex_state = 3026},
  [879] = {.lex_state = 3026},
  [880] = {.lex_state = 3026},
  [881] = {.lex_state = 3026},
  [882] = {.lex_state = 3026},
  [883] = {.lex_state = 3026},
  [884] = {.lex_state = 3026},
  [885] = {.lex_state = 3026},
  [886] = {.lex_state = 3026},
  [887] = {.lex_state = 3026},
  [888] = {.lex_state = 3026},
  [889] = {.lex_state = 3026},
  [890] = {.lex_state = 3026},
  [891] = {.lex_state = 3026},
  [892] = {.lex_state = 3026},
  [893] = {.lex_state = 3026},
  [894] = {.lex_state = 3026},
  [895] = {.lex_state = 3026},
  [896] = {.lex_state = 3026},
  [897] = {.lex_state = 3026},
  [898] = {.lex_state = 3026},
  [899] = {.lex_state = 3026},
  [900] = {.lex_state = 3026},
  [901] = {.lex_state = 3026},
  [902] = {.lex_state = 3026},
  [903] = {.lex_state = 3026},
  [904] = {.lex_state = 3026},
  [905] = {.lex_state = 3026},
  [906] = {.lex_state = 3026},
  [907] = {.lex_state = 3026},
  [908] = {.lex_state = 3026},
  [909] = {.lex_state = 3026},
  [910] = {.lex_state = 3026},
  [911] = {.lex_state = 3026},
  [912] = {.lex_state = 3026},
  [913] = {.lex_state = 3026},
  [914] = {.lex_state = 3026},
  [915] = {.lex_state = 3026},
  [916] = {.lex_state = 3026},
  [917] = {.lex_state = 3026},
  [918] = {.lex_state = 3026},
  [919] = {.lex_state = 3026},
  [920] = {.lex_state = 3026},
  [921] = {.lex_state = 3026},
  [922] = {.lex_state = 3026},
  [923] = {.lex_state = 3026},
  [924] = {.lex_state = 3026},
  [925] = {.lex_state = 3026},
  [926] = {.lex_state = 3026},
  [927] = {.lex_state = 3026},
  [928] = {.lex_state = 3026},
  [929] = {.lex_state = 3026},
  [930] = {.lex_state = 3026},
  [931] = {.lex_state = 3026},
  [932] = {.lex_state = 3026},
  [933] = {.lex_state = 3026},
  [934] = {.lex_state = 3026},
  [935] = {.lex_state = 3026},
  [936] = {.lex_state = 3026},
  [937] = {.lex_state = 3026},
  [938] = {.lex_state = 3026},
  [939] = {.lex_state = 3026},
  [940] = {.lex_state = 3026},
  [941] = {.lex_state = 3026},
  [942] = {.lex_state = 3026},
  [943] = {.lex_state = 3026},
  [944] = {.lex_state = 3026},
  [945] = {.lex_state = 3026},
  [946] = {.lex_state = 3026},
  [947] = {.lex_state = 3026},
  [948] = {.lex_state = 3026},
  [949] = {.lex_state = 3026},
  [950] = {.lex_state = 3026},
  [951] = {.lex_state = 3026},
  [952] = {.lex_state = 3026},
  [953] = {.lex_state = 3026},
  [954] = {.lex_state = 3026},
  [955] = {.lex_state = 3026},
  [956] = {.lex_state = 3026},
  [957] = {.lex_state = 3026},
  [958] = {.lex_state = 3026},
  [959] = {.lex_state = 3026},
  [960] = {.lex_state = 3026},
  [961] = {.lex_state = 3026},
  [962] = {.lex_state = 3026},
  [963] = {.lex_state = 3026},
  [964] = {.lex_state = 3026},
  [965] = {.lex_state = 3026},
  [966] = {.lex_state = 3026},
  [967] = {.lex_state = 3026},
  [968] = {.lex_state = 3026},
  [969] = {.lex_state = 3026},
  [970] = {.lex_state = 3026},
  [971] = {.lex_state = 3026},
  [972] = {.lex_state = 3026},
  [973] = {.lex_state = 3026},
  [974] = {.lex_state = 3026},
  [975] = {.lex_state = 3026},
  [976] = {.lex_state = 3026},
  [977] = {.lex_state = 3026},
  [978] = {.lex_state = 3026},
  [979] = {.lex_state = 3026},
  [980] = {.lex_state = 3026},
  [981] = {.lex_state = 3026},
  [982] = {.lex_state = 3026},
  [983] = {.lex_state = 3026},
  [984] = {.lex_state = 3026},
  [985] = {.lex_state = 3026},
  [986] = {.lex_state = 3026},
  [987] = {.lex_state = 3026},
  [988] = {.lex_state = 3026},
  [989] = {.lex_state = 3026},
  [990] = {.lex_state = 3029},
  [991] = {.lex_state = 3026},
  [992] = {.lex_state = 3026},
  [993] = {.lex_state = 3026},
  [994] = {.lex_state = 3029},
  [995] = {.lex_state = 3029},
  [996] = {.lex_state = 3026},
  [997] = {.lex_state = 3026},
  [998] = {.lex_state = 3026},
  [999] = {.lex_state = 3029},
  [1000] = {.lex_state = 3026},
  [1001] = {.lex_state = 3026},
  [1002] = {.lex_state = 3026},
  [1003] = {.lex_state = 3029},
  [1004] = {.lex_state = 3026},
  [1005] = {.lex_state = 3029},
  [1006] = {.lex_state = 3026},
  [1007] = {.lex_state = 3026},
  [1008] = {.lex_state = 3026},
  [1009] = {.lex_state = 3029},
  [1010] = {.lex_state = 3026},
  [1011] = {.lex_state = 3026},
  [1012] = {.lex_state = 3026},
  [1013] = {.lex_state = 3026},
  [1014] = {.lex_state = 3029},
  [1015] = {.lex_state = 3029},
  [1016] = {.lex_state = 3026},
  [1017] = {.lex_state = 3026},
  [1018] = {.lex_state = 3026},
  [1019] = {.lex_state = 3026},
  [1020] = {.lex_state = 3026},
  [1021] = {.lex_state = 3026},
  [1022] = {.lex_state = 3026},
  [1023] = {.lex_state = 3029},
  [1024] = {.lex_state = 3026},
  [1025] = {.lex_state = 3026},
  [1026] = {.lex_state = 3026},
  [1027] = {.lex_state = 3026},
  [1028] = {.lex_state = 3026},
  [1029] = {.lex_state = 3026},
  [1030] = {.lex_state = 7},
  [1031] = {.lex_state = 3026},
  [1032] = {.lex_state = 3026},
  [1033] = {.lex_state = 3026},
  [1034] = {.lex_state = 3026},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 3033},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 3030},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 3030},
  [1060] = {.lex_state = 3030},
  [1061] = {.lex_state = 3030},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 3030},
  [1065] = {.lex_state = 3030},
  [1066] = {.lex_state = 3030},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 3033},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 3030},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 3030},
  [1084] = {.lex_state = 3030},
  [1085] = {.lex_state = 3028},
  [1086] = {.lex_state = 3028},
  [1087] = {.lex_state = 3028},
  [1088] = {.lex_state = 3028},
  [1089] = {.lex_state = 3030},
  [1090] = {.lex_state = 3030},
  [1091] = {.lex_state = 3030},
  [1092] = {.lex_state = 3030},
  [1093] = {.lex_state = 3030},
  [1094] = {.lex_state = 3030},
  [1095] = {.lex_state = 3028},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 8},
  [1099] = {.lex_state = 8},
  [1100] = {.lex_state = 8},
  [1101] = {.lex_state = 3026},
  [1102] = {.lex_state = 8},
  [1103] = {.lex_state = 8},
  [1104] = {.lex_state = 8},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 8},
  [1107] = {.lex_state = 8},
  [1108] = {.lex_state = 8},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 8},
  [1113] = {.lex_state = 8},
  [1114] = {.lex_state = 8},
  [1115] = {.lex_state = 8},
  [1116] = {.lex_state = 8},
  [1117] = {.lex_state = 8},
  [1118] = {.lex_state = 8},
  [1119] = {.lex_state = 5},
  [1120] = {.lex_state = 5},
  [1121] = {.lex_state = 5},
  [1122] = {.lex_state = 5},
  [1123] = {.lex_state = 8},
  [1124] = {.lex_state = 8},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 8},
  [1128] = {.lex_state = 5},
  [1129] = {.lex_state = 3033},
  [1130] = {.lex_state = 8},
  [1131] = {.lex_state = 5},
  [1132] = {.lex_state = 7},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 7},
  [1136] = {.lex_state = 7},
  [1137] = {.lex_state = 7},
  [1138] = {.lex_state = 7},
  [1139] = {.lex_state = 3027},
  [1140] = {.lex_state = 7},
  [1141] = {.lex_state = 7},
  [1142] = {.lex_state = 7},
  [1143] = {.lex_state = 7},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 7},
  [1147] = {.lex_state = 7},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 7},
  [1151] = {.lex_state = 8},
  [1152] = {.lex_state = 3032},
  [1153] = {.lex_state = 3032},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 3032},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 3032},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 8},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 3032},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 8},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 3032},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 3032},
  [1179] = {.lex_state = 3032},
  [1180] = {.lex_state = 3032},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 43},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 3032},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 3032},
  [1196] = {.lex_state = 8},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 8},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 3032},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 3032},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 8},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 3032},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 8},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 3032},
  [1225] = {.lex_state = 3032},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 8},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 8},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 3032},
  [1258] = {.lex_state = 3032},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 3032},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 3032},
  [1272] = {.lex_state = 3032},
  [1273] = {.lex_state = 3032},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 3032},
  [1283] = {.lex_state = 3032},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 3032},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 8},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 3032},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 3032},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 3032},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 3032},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 8},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 8},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 8},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 8},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 8},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 8},
  [1333] = {.lex_state = 3032},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 8},
  [1344] = {.lex_state = 8},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 5},
  [1347] = {.lex_state = 5},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 5},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 5},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 5},
  [1355] = {.lex_state = 5},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 5},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 11},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 3},
  [1365] = {.lex_state = 3},
  [1366] = {.lex_state = 3},
  [1367] = {.lex_state = 5},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 5},
  [1371] = {.lex_state = 5},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 3028},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 3028},
  [1377] = {.lex_state = 3028},
  [1378] = {.lex_state = 3028},
  [1379] = {.lex_state = 5},
  [1380] = {.lex_state = 3028},
  [1381] = {.lex_state = 8},
  [1382] = {.lex_state = 8},
  [1383] = {.lex_state = 5},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 3028},
  [1386] = {.lex_state = 3028},
  [1387] = {.lex_state = 5},
  [1388] = {.lex_state = 8},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 8},
  [1391] = {.lex_state = 8},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 5},
  [1394] = {.lex_state = 5},
  [1395] = {.lex_state = 11},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 5},
  [1398] = {.lex_state = 8},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 8},
  [1403] = {.lex_state = 5},
  [1404] = {.lex_state = 3},
  [1405] = {.lex_state = 8},
  [1406] = {.lex_state = 8},
  [1407] = {.lex_state = 8},
  [1408] = {.lex_state = 8},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 11},
  [1413] = {.lex_state = 8},
  [1414] = {.lex_state = 8},
  [1415] = {.lex_state = 8},
  [1416] = {.lex_state = 8},
  [1417] = {.lex_state = 8},
  [1418] = {.lex_state = 8},
  [1419] = {.lex_state = 8},
  [1420] = {.lex_state = 8},
  [1421] = {.lex_state = 8},
  [1422] = {.lex_state = 8},
  [1423] = {.lex_state = 8},
  [1424] = {.lex_state = 8},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 8},
  [1427] = {.lex_state = 8},
  [1428] = {.lex_state = 8},
  [1429] = {.lex_state = 8},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 8},
  [1432] = {.lex_state = 8},
  [1433] = {.lex_state = 8},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 8},
  [1436] = {.lex_state = 8},
  [1437] = {.lex_state = 8},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 5},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 8},
  [1442] = {.lex_state = 8},
  [1443] = {.lex_state = 8},
  [1444] = {.lex_state = 8},
  [1445] = {.lex_state = 8},
  [1446] = {.lex_state = 8},
  [1447] = {.lex_state = 8},
  [1448] = {.lex_state = 8},
  [1449] = {.lex_state = 11},
  [1450] = {.lex_state = 8},
  [1451] = {.lex_state = 8},
  [1452] = {.lex_state = 8},
  [1453] = {.lex_state = 8},
  [1454] = {.lex_state = 8},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 5},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 8},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 8},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 8},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 37},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 5},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 0},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 0},
  [1492] = {.lex_state = 8},
  [1493] = {.lex_state = 5},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 5},
  [1496] = {.lex_state = 5},
  [1497] = {.lex_state = 0},
  [1498] = {.lex_state = 0},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 0},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 0},
  [1513] = {.lex_state = 5},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 0},
  [1517] = {.lex_state = 43},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 0},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 5},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 8},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 0},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 0},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 5},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 5},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 5},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 0},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 1291},
  [1559] = {.lex_state = 5},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 43},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 5},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 8},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 5},
  [1580] = {.lex_state = 5},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 0},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 5},
  [1588] = {.lex_state = 0},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 5},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 0},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 3028},
  [1604] = {.lex_state = 0},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 5},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 0},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 0},
  [1612] = {.lex_state = 0},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 3028},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 0},
  [1626] = {.lex_state = 5},
  [1627] = {.lex_state = 5},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 0},
  [1631] = {.lex_state = 0},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 0},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 5},
  [1636] = {.lex_state = 5},
  [1637] = {.lex_state = 0},
  [1638] = {.lex_state = 5},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 0},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 5},
  [1649] = {.lex_state = 0},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 5},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 0},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 0},
  [1662] = {.lex_state = 0},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 0},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 0},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 0},
  [1670] = {.lex_state = 0},
  [1671] = {.lex_state = 5},
  [1672] = {.lex_state = 5},
  [1673] = {.lex_state = 0},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 3028},
  [1676] = {.lex_state = 5},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 0},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 0},
  [1685] = {.lex_state = 0},
  [1686] = {.lex_state = 0},
  [1687] = {.lex_state = 0},
  [1688] = {.lex_state = 0},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 5},
  [1691] = {.lex_state = 0},
  [1692] = {.lex_state = 8},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 5},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 0},
  [1697] = {.lex_state = 0},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 0},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 0},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 0},
  [1706] = {.lex_state = 0},
  [1707] = {.lex_state = 0},
  [1708] = {.lex_state = 5},
  [1709] = {.lex_state = 5},
  [1710] = {.lex_state = 5},
  [1711] = {.lex_state = 5},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 0},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 3},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 0},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 0},
  [1728] = {.lex_state = 8},
  [1729] = {.lex_state = 0},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 0},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 0},
  [1736] = {.lex_state = 0},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 0},
  [1753] = {.lex_state = 0},
  [1754] = {.lex_state = 0},
  [1755] = {.lex_state = 0},
  [1756] = {.lex_state = 0},
  [1757] = {.lex_state = 0},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 43},
  [1760] = {.lex_state = 0},
  [1761] = {.lex_state = 0},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 5},
  [1765] = {.lex_state = 5},
  [1766] = {.lex_state = 5},
  [1767] = {.lex_state = 0},
  [1768] = {.lex_state = 5},
  [1769] = {.lex_state = 5},
  [1770] = {.lex_state = 5},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 0},
  [1774] = {.lex_state = 0},
  [1775] = {.lex_state = 5},
  [1776] = {.lex_state = 0},
  [1777] = {.lex_state = 5},
  [1778] = {.lex_state = 5},
  [1779] = {.lex_state = 5},
  [1780] = {.lex_state = 0},
  [1781] = {.lex_state = 5},
  [1782] = {.lex_state = 5},
  [1783] = {.lex_state = 5},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 5},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 5},
  [1791] = {.lex_state = 5},
  [1792] = {.lex_state = 5},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 5},
  [1795] = {.lex_state = 5},
  [1796] = {.lex_state = 5},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 0},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 5},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 0},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 0},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 0},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 0},
  [1814] = {.lex_state = 0},
  [1815] = {.lex_state = 0},
  [1816] = {.lex_state = 0},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 0},
  [1819] = {.lex_state = 0},
  [1820] = {.lex_state = 0},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 0},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 5},
  [1825] = {.lex_state = 5},
  [1826] = {.lex_state = 5},
  [1827] = {.lex_state = 5},
  [1828] = {.lex_state = 5},
  [1829] = {.lex_state = 5},
  [1830] = {.lex_state = 5},
  [1831] = {.lex_state = 5},
  [1832] = {.lex_state = 5},
  [1833] = {.lex_state = 5},
  [1834] = {.lex_state = 5},
  [1835] = {.lex_state = 5},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1),
    [sym_comdat_ref] = ACTIONS(1),
    [sym_global_var] = ACTIONS(1),
    [sym_local_var] = ACTIONS(1),
    [aux_sym_metadata_ref_token1] = ACTIONS(1),
    [sym_summary_ref] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [aux_sym_number_token1] = ACTIONS(1),
    [aux_sym_number_token2] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_cstring] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_triple] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_datalayout] = ACTIONS(1),
    [anon_sym_source_filename] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_no_cfi] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_weak] = ACTIONS(1),
    [anon_sym_weak_odr] = ACTIONS(1),
    [anon_sym_linkonce] = ACTIONS(1),
    [anon_sym_linkonce_odr] = ACTIONS(1),
    [anon_sym_available_externally] = ACTIONS(1),
    [anon_sym_appending] = ACTIONS(1),
    [anon_sym_common] = ACTIONS(1),
    [anon_sym_extern_weak] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_dso_local] = ACTIONS(1),
    [anon_sym_dso_local_equivalent] = ACTIONS(1),
    [anon_sym_dso_preemptable] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_hidden] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_dllimport] = ACTIONS(1),
    [anon_sym_dllexport] = ACTIONS(1),
    [anon_sym_ccc] = ACTIONS(1),
    [anon_sym_fastcc] = ACTIONS(1),
    [anon_sym_coldcc] = ACTIONS(1),
    [anon_sym_webkit_jscc] = ACTIONS(1),
    [anon_sym_anyregcc] = ACTIONS(1),
    [anon_sym_preserve_mostcc] = ACTIONS(1),
    [anon_sym_preserve_allcc] = ACTIONS(1),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(1),
    [anon_sym_swiftcc] = ACTIONS(1),
    [anon_sym_swifttailcc] = ACTIONS(1),
    [anon_sym_cfguard_checkcc] = ACTIONS(1),
    [aux_sym_calling_conv_token2] = ACTIONS(1),
    [aux_sym_calling_conv_token3] = ACTIONS(1),
    [aux_sym_calling_conv_token4] = ACTIONS(1),
    [aux_sym_calling_conv_token5] = ACTIONS(1),
    [aux_sym_calling_conv_token6] = ACTIONS(1),
    [aux_sym_calling_conv_token7] = ACTIONS(1),
    [aux_sym_calling_conv_token8] = ACTIONS(1),
    [aux_sym_calling_conv_token9] = ACTIONS(1),
    [aux_sym_calling_conv_token10] = ACTIONS(1),
    [anon_sym_ghccc] = ACTIONS(1),
    [aux_sym_calling_conv_token11] = ACTIONS(1),
    [aux_sym_calling_conv_token12] = ACTIONS(1),
    [aux_sym_calling_conv_token13] = ACTIONS(1),
    [aux_sym_calling_conv_token14] = ACTIONS(1),
    [anon_sym_cc] = ACTIONS(1),
    [anon_sym_unnamed_addr] = ACTIONS(1),
    [anon_sym_local_unnamed_addr] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_half] = ACTIONS(1),
    [anon_sym_bfloat] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_fp128] = ACTIONS(1),
    [anon_sym_ppc_fp128] = ACTIONS(1),
    [anon_sym_label] = ACTIONS(1),
    [anon_sym_metadata] = ACTIONS(1),
    [anon_sym_token] = ACTIONS(1),
    [anon_sym_opaque] = ACTIONS(1),
    [anon_sym_ptr] = ACTIONS(1),
    [aux_sym_type_keyword_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_vscale] = ACTIONS(1),
    [anon_sym_x] = ACTIONS(1),
    [anon_sym_addrspace] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_align] = ACTIONS(1),
    [anon_sym_section] = ACTIONS(1),
    [anon_sym_partition] = ACTIONS(1),
    [anon_sym_comdat] = ACTIONS(1),
    [anon_sym_gc] = ACTIONS(1),
    [anon_sym_prefix] = ACTIONS(1),
    [anon_sym_prologue] = ACTIONS(1),
    [anon_sym_personality] = ACTIONS(1),
    [anon_sym_alignstack] = ACTIONS(1),
    [anon_sym_allocsize] = ACTIONS(1),
    [anon_sym_alwaysinline] = ACTIONS(1),
    [anon_sym_builtin] = ACTIONS(1),
    [anon_sym_cold] = ACTIONS(1),
    [anon_sym_convergent] = ACTIONS(1),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1),
    [anon_sym_hot] = ACTIONS(1),
    [anon_sym_inaccessiblememonly] = ACTIONS(1),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1),
    [anon_sym_inlinehint] = ACTIONS(1),
    [anon_sym_jumptable] = ACTIONS(1),
    [anon_sym_minsize] = ACTIONS(1),
    [anon_sym_naked] = ACTIONS(1),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1),
    [anon_sym_nobuiltin] = ACTIONS(1),
    [anon_sym_noduplicate] = ACTIONS(1),
    [anon_sym_nofree] = ACTIONS(1),
    [anon_sym_noimplicitfloat] = ACTIONS(1),
    [anon_sym_noinline] = ACTIONS(1),
    [anon_sym_nomerge] = ACTIONS(1),
    [anon_sym_nonlazybind] = ACTIONS(1),
    [anon_sym_noprofile] = ACTIONS(1),
    [anon_sym_noredzone] = ACTIONS(1),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_norecurse] = ACTIONS(1),
    [anon_sym_willreturn] = ACTIONS(1),
    [anon_sym_nosync] = ACTIONS(1),
    [anon_sym_nounwind] = ACTIONS(1),
    [anon_sym_nosanitize_coverage] = ACTIONS(1),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1),
    [anon_sym_optforfuzzing] = ACTIONS(1),
    [anon_sym_optnone] = ACTIONS(1),
    [anon_sym_optsize] = ACTIONS(1),
    [anon_sym_readnone] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_writeonly] = ACTIONS(1),
    [anon_sym_argmemonly] = ACTIONS(1),
    [anon_sym_returns_twice] = ACTIONS(1),
    [anon_sym_safestack] = ACTIONS(1),
    [anon_sym_sanitize_address] = ACTIONS(1),
    [anon_sym_sanitize_memory] = ACTIONS(1),
    [anon_sym_sanitize_thread] = ACTIONS(1),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1),
    [anon_sym_sanitize_memtag] = ACTIONS(1),
    [anon_sym_speculative_load_hardening] = ACTIONS(1),
    [anon_sym_speculatable] = ACTIONS(1),
    [anon_sym_ssp] = ACTIONS(1),
    [anon_sym_sspstrong] = ACTIONS(1),
    [anon_sym_sspreq] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_uwtable] = ACTIONS(1),
    [anon_sym_nocf_check] = ACTIONS(1),
    [anon_sym_shadowcallstack] = ACTIONS(1),
    [anon_sym_mustprogress] = ACTIONS(1),
    [anon_sym_vscale_range] = ACTIONS(1),
    [anon_sym_preallocated] = ACTIONS(1),
    [anon_sym_zeroext] = ACTIONS(1),
    [anon_sym_signext] = ACTIONS(1),
    [anon_sym_inreg] = ACTIONS(1),
    [anon_sym_byval] = ACTIONS(1),
    [anon_sym_byref] = ACTIONS(1),
    [anon_sym_inalloca] = ACTIONS(1),
    [anon_sym_sret] = ACTIONS(1),
    [anon_sym_elementtype] = ACTIONS(1),
    [anon_sym_noalias] = ACTIONS(1),
    [anon_sym_nocapture] = ACTIONS(1),
    [anon_sym_nest] = ACTIONS(1),
    [anon_sym_returned] = ACTIONS(1),
    [anon_sym_nonnull] = ACTIONS(1),
    [anon_sym_dereferenceable] = ACTIONS(1),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1),
    [anon_sym_swiftself] = ACTIONS(1),
    [anon_sym_swiftasync] = ACTIONS(1),
    [anon_sym_swifterror] = ACTIONS(1),
    [anon_sym_immarg] = ACTIONS(1),
    [anon_sym_noundef] = ACTIONS(1),
    [anon_sym_unreachable] = ACTIONS(1),
    [anon_sym_ret] = ACTIONS(1),
    [anon_sym_br] = ACTIONS(1),
    [anon_sym_resume] = ACTIONS(1),
    [anon_sym_freeze] = ACTIONS(1),
    [anon_sym_indirectbr] = ACTIONS(1),
    [anon_sym_extractelement] = ACTIONS(1),
    [anon_sym_insertelement] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_shufflevector] = ACTIONS(1),
    [anon_sym_fneg] = ACTIONS(1),
    [anon_sym_nsw] = ACTIONS(1),
    [anon_sym_nuw] = ACTIONS(1),
    [anon_sym_exact] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_invoke] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_unwind] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_catchret] = ACTIONS(1),
    [anon_sym_catchswitch] = ACTIONS(1),
    [anon_sym_catchpad] = ACTIONS(1),
    [anon_sym_callbr] = ACTIONS(1),
    [anon_sym_icmp] = ACTIONS(1),
    [anon_sym_fcmp] = ACTIONS(1),
    [anon_sym_va_arg] = ACTIONS(1),
    [anon_sym_phi] = ACTIONS(1),
    [anon_sym_landingpad] = ACTIONS(1),
    [anon_sym_cleanup] = ACTIONS(1),
    [anon_sym_tail] = ACTIONS(1),
    [anon_sym_musttail] = ACTIONS(1),
    [anon_sym_notail] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [anon_sym_alloca] = ACTIONS(1),
    [anon_sym_load] = ACTIONS(1),
    [anon_sym_atomic] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_store] = ACTIONS(1),
    [anon_sym_cmpxchg] = ACTIONS(1),
    [anon_sym_atomicrmw] = ACTIONS(1),
    [anon_sym_fence] = ACTIONS(1),
    [anon_sym_getelementptr] = ACTIONS(1),
    [anon_sym_inbounds] = ACTIONS(1),
    [anon_sym_inrange] = ACTIONS(1),
    [anon_sym_extractvalue] = ACTIONS(1),
    [anon_sym_insertvalue] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_none] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_poison] = ACTIONS(1),
    [anon_sym_zeroinitializer] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_filter] = ACTIONS(1),
    [anon_sym_blockaddress] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_urem] = ACTIONS(1),
    [anon_sym_srem] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_udiv] = ACTIONS(1),
    [anon_sym_sdiv] = ACTIONS(1),
    [anon_sym_lshr] = ACTIONS(1),
    [anon_sym_ashr] = ACTIONS(1),
    [anon_sym_fmul] = ACTIONS(1),
    [anon_sym_fdiv] = ACTIONS(1),
    [anon_sym_frem] = ACTIONS(1),
    [anon_sym_xchg] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_nand] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_max] = ACTIONS(1),
    [anon_sym_min] = ACTIONS(1),
    [anon_sym_umax] = ACTIONS(1),
    [anon_sym_umin] = ACTIONS(1),
    [anon_sym_fadd] = ACTIONS(1),
    [anon_sym_fsub] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_ne] = ACTIONS(1),
    [anon_sym_ugt] = ACTIONS(1),
    [anon_sym_uge] = ACTIONS(1),
    [anon_sym_ult] = ACTIONS(1),
    [anon_sym_ule] = ACTIONS(1),
    [anon_sym_sgt] = ACTIONS(1),
    [anon_sym_sge] = ACTIONS(1),
    [anon_sym_slt] = ACTIONS(1),
    [anon_sym_sle] = ACTIONS(1),
    [anon_sym_oeq] = ACTIONS(1),
    [anon_sym_ogt] = ACTIONS(1),
    [anon_sym_oge] = ACTIONS(1),
    [anon_sym_olt] = ACTIONS(1),
    [anon_sym_ole] = ACTIONS(1),
    [anon_sym_one] = ACTIONS(1),
    [anon_sym_ueq] = ACTIONS(1),
    [anon_sym_une] = ACTIONS(1),
    [anon_sym_uno] = ACTIONS(1),
    [anon_sym_bitcast] = ACTIONS(1),
    [anon_sym_trunc] = ACTIONS(1),
    [anon_sym_zext] = ACTIONS(1),
    [anon_sym_sext] = ACTIONS(1),
    [anon_sym_fptrunc] = ACTIONS(1),
    [anon_sym_fpext] = ACTIONS(1),
    [anon_sym_addrspacecast] = ACTIONS(1),
    [anon_sym_uitofp] = ACTIONS(1),
    [anon_sym_sitofp] = ACTIONS(1),
    [anon_sym_fptoui] = ACTIONS(1),
    [anon_sym_fptosi] = ACTIONS(1),
    [anon_sym_inttoptr] = ACTIONS(1),
    [anon_sym_ptrtoint] = ACTIONS(1),
    [anon_sym_unordered] = ACTIONS(1),
    [anon_sym_monotonic] = ACTIONS(1),
    [anon_sym_acquire] = ACTIONS(1),
    [anon_sym_release] = ACTIONS(1),
    [anon_sym_acq_rel] = ACTIONS(1),
    [anon_sym_seq_cst] = ACTIONS(1),
    [anon_sym_syncscope] = ACTIONS(1),
    [anon_sym_nnan] = ACTIONS(1),
    [anon_sym_ninf] = ACTIONS(1),
    [anon_sym_nsz] = ACTIONS(1),
    [anon_sym_arcp] = ACTIONS(1),
    [anon_sym_contract] = ACTIONS(1),
    [anon_sym_afn] = ACTIONS(1),
    [anon_sym_reassoc] = ACTIONS(1),
    [anon_sym_fast] = ACTIONS(1),
    [anon_sym_within] = ACTIONS(1),
    [anon_sym_uselistorder] = ACTIONS(1),
    [anon_sym_uselistorder_bb] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym_sideeffect] = ACTIONS(1),
    [anon_sym_inteldialect] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_externally_initialized] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_ifunc] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym_localdynamic] = ACTIONS(1),
    [anon_sym_initialexec] = ACTIONS(1),
    [anon_sym_localexec] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_largest] = ACTIONS(1),
    [anon_sym_nodeduplicate] = ACTIONS(1),
    [anon_sym_samesize] = ACTIONS(1),
    [anon_sym_distinct] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_attributes] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(1650),
    [sym_metadata_ref] = STATE(1645),
    [sym_target_definition] = STATE(717),
    [sym_source_file_name] = STATE(717),
    [sym_declare] = STATE(717),
    [sym_define] = STATE(717),
    [sym_use_list_order] = STATE(717),
    [sym_use_list_order_bb] = STATE(717),
    [sym_module_asm] = STATE(717),
    [sym_global_type] = STATE(717),
    [sym__global_prefix] = STATE(1168),
    [sym_global_global] = STATE(717),
    [sym_alias] = STATE(717),
    [sym_ifunc] = STATE(717),
    [sym_comdat] = STATE(717),
    [sym_global_metadata] = STATE(717),
    [sym_summary_entry] = STATE(717),
    [sym_unnamed_attr_grp] = STATE(717),
    [aux_sym_module_repeat1] = STATE(717),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(7),
    [sym_global_var] = ACTIONS(9),
    [sym_local_var] = ACTIONS(11),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_summary_ref] = ACTIONS(15),
    [anon_sym_target] = ACTIONS(17),
    [anon_sym_source_filename] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_define] = ACTIONS(23),
    [anon_sym_uselistorder] = ACTIONS(25),
    [anon_sym_uselistorder_bb] = ACTIONS(27),
    [anon_sym_module] = ACTIONS(29),
    [anon_sym_attributes] = ACTIONS(31),
  },
  [2] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(132),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(35),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(40),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_number_token2] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(49),
    [anon_sym_private] = ACTIONS(52),
    [anon_sym_internal] = ACTIONS(52),
    [anon_sym_weak] = ACTIONS(55),
    [anon_sym_weak_odr] = ACTIONS(52),
    [anon_sym_linkonce] = ACTIONS(55),
    [anon_sym_linkonce_odr] = ACTIONS(52),
    [anon_sym_available_externally] = ACTIONS(52),
    [anon_sym_appending] = ACTIONS(52),
    [anon_sym_common] = ACTIONS(52),
    [anon_sym_extern_weak] = ACTIONS(52),
    [anon_sym_external] = ACTIONS(52),
    [anon_sym_dso_local] = ACTIONS(58),
    [anon_sym_dso_local_equivalent] = ACTIONS(61),
    [anon_sym_dso_preemptable] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(64),
    [anon_sym_hidden] = ACTIONS(64),
    [anon_sym_protected] = ACTIONS(64),
    [anon_sym_dllimport] = ACTIONS(67),
    [anon_sym_dllexport] = ACTIONS(67),
    [anon_sym_ccc] = ACTIONS(38),
    [anon_sym_fastcc] = ACTIONS(38),
    [anon_sym_coldcc] = ACTIONS(38),
    [anon_sym_webkit_jscc] = ACTIONS(70),
    [anon_sym_anyregcc] = ACTIONS(38),
    [anon_sym_preserve_mostcc] = ACTIONS(38),
    [anon_sym_preserve_allcc] = ACTIONS(38),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(70),
    [anon_sym_tailcc] = ACTIONS(38),
    [anon_sym_swiftcc] = ACTIONS(70),
    [anon_sym_swifttailcc] = ACTIONS(70),
    [anon_sym_cfguard_checkcc] = ACTIONS(38),
    [aux_sym_calling_conv_token1] = ACTIONS(70),
    [aux_sym_calling_conv_token2] = ACTIONS(38),
    [aux_sym_calling_conv_token3] = ACTIONS(38),
    [aux_sym_calling_conv_token4] = ACTIONS(38),
    [aux_sym_calling_conv_token5] = ACTIONS(38),
    [aux_sym_calling_conv_token6] = ACTIONS(38),
    [aux_sym_calling_conv_token7] = ACTIONS(38),
    [aux_sym_calling_conv_token8] = ACTIONS(38),
    [aux_sym_calling_conv_token9] = ACTIONS(38),
    [aux_sym_calling_conv_token10] = ACTIONS(70),
    [anon_sym_ghccc] = ACTIONS(38),
    [aux_sym_calling_conv_token11] = ACTIONS(70),
    [aux_sym_calling_conv_token12] = ACTIONS(38),
    [aux_sym_calling_conv_token13] = ACTIONS(70),
    [aux_sym_calling_conv_token14] = ACTIONS(38),
    [anon_sym_cc] = ACTIONS(70),
    [anon_sym_unnamed_addr] = ACTIONS(38),
    [anon_sym_local_unnamed_addr] = ACTIONS(38),
    [anon_sym_void] = ACTIONS(38),
    [anon_sym_half] = ACTIONS(38),
    [anon_sym_bfloat] = ACTIONS(38),
    [anon_sym_float] = ACTIONS(38),
    [anon_sym_double] = ACTIONS(38),
    [anon_sym_x86_fp80] = ACTIONS(70),
    [anon_sym_fp128] = ACTIONS(38),
    [anon_sym_ppc_fp128] = ACTIONS(38),
    [anon_sym_label] = ACTIONS(38),
    [anon_sym_metadata] = ACTIONS(38),
    [anon_sym_x86_mmx] = ACTIONS(70),
    [anon_sym_x86_amx] = ACTIONS(70),
    [anon_sym_token] = ACTIONS(38),
    [anon_sym_opaque] = ACTIONS(38),
    [anon_sym_ptr] = ACTIONS(70),
    [aux_sym_type_keyword_token1] = ACTIONS(38),
    [anon_sym_LBRACE] = ACTIONS(72),
    [anon_sym_LT_LBRACE] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(78),
    [anon_sym_LT] = ACTIONS(81),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(70),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(70),
    [anon_sym_swiftasync] = ACTIONS(70),
    [anon_sym_swifterror] = ACTIONS(70),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [3] = {
    [sym_metadata_ref] = STATE(130),
    [sym_type] = STATE(4),
    [sym_type_keyword] = STATE(31),
    [sym_struct_type] = STATE(31),
    [sym_packed_struct_type] = STATE(31),
    [sym_array_type] = STATE(31),
    [sym_vector_type] = STATE(31),
    [sym_type_and_value] = STATE(173),
    [sym_metadata] = STATE(165),
    [sym_metadata_tuple] = STATE(173),
    [sym_specialized_md] = STATE(173),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(118),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(124),
    [anon_sym_half] = ACTIONS(124),
    [anon_sym_bfloat] = ACTIONS(124),
    [anon_sym_float] = ACTIONS(124),
    [anon_sym_double] = ACTIONS(124),
    [anon_sym_x86_fp80] = ACTIONS(124),
    [anon_sym_fp128] = ACTIONS(124),
    [anon_sym_ppc_fp128] = ACTIONS(124),
    [anon_sym_label] = ACTIONS(124),
    [anon_sym_metadata] = ACTIONS(126),
    [anon_sym_x86_mmx] = ACTIONS(124),
    [anon_sym_x86_amx] = ACTIONS(124),
    [anon_sym_token] = ACTIONS(124),
    [anon_sym_opaque] = ACTIONS(124),
    [anon_sym_ptr] = ACTIONS(124),
    [aux_sym_type_keyword_token1] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(130),
    [anon_sym_LBRACK] = ACTIONS(132),
    [anon_sym_LT] = ACTIONS(134),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(122),
    [anon_sym_partition] = ACTIONS(122),
    [anon_sym_comdat] = ACTIONS(122),
    [anon_sym_gc] = ACTIONS(122),
    [anon_sym_prefix] = ACTIONS(122),
    [anon_sym_prologue] = ACTIONS(122),
    [anon_sym_personality] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(122),
    [anon_sym_allocsize] = ACTIONS(122),
    [anon_sym_alwaysinline] = ACTIONS(122),
    [anon_sym_builtin] = ACTIONS(122),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(122),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(122),
    [anon_sym_hot] = ACTIONS(122),
    [anon_sym_inaccessiblememonly] = ACTIONS(122),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(122),
    [anon_sym_inlinehint] = ACTIONS(122),
    [anon_sym_jumptable] = ACTIONS(122),
    [anon_sym_minsize] = ACTIONS(122),
    [anon_sym_naked] = ACTIONS(122),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(122),
    [anon_sym_nobuiltin] = ACTIONS(122),
    [anon_sym_noduplicate] = ACTIONS(122),
    [anon_sym_nofree] = ACTIONS(122),
    [anon_sym_noimplicitfloat] = ACTIONS(122),
    [anon_sym_noinline] = ACTIONS(122),
    [anon_sym_nomerge] = ACTIONS(122),
    [anon_sym_nonlazybind] = ACTIONS(122),
    [anon_sym_noprofile] = ACTIONS(122),
    [anon_sym_noredzone] = ACTIONS(122),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(122),
    [anon_sym_noreturn] = ACTIONS(122),
    [anon_sym_norecurse] = ACTIONS(122),
    [anon_sym_willreturn] = ACTIONS(122),
    [anon_sym_nosync] = ACTIONS(122),
    [anon_sym_nounwind] = ACTIONS(122),
    [anon_sym_nosanitize_coverage] = ACTIONS(122),
    [anon_sym_null_pointer_is_valid] = ACTIONS(122),
    [anon_sym_optforfuzzing] = ACTIONS(122),
    [anon_sym_optnone] = ACTIONS(122),
    [anon_sym_optsize] = ACTIONS(122),
    [anon_sym_readnone] = ACTIONS(122),
    [anon_sym_readonly] = ACTIONS(122),
    [anon_sym_writeonly] = ACTIONS(122),
    [anon_sym_argmemonly] = ACTIONS(122),
    [anon_sym_returns_twice] = ACTIONS(122),
    [anon_sym_safestack] = ACTIONS(122),
    [anon_sym_sanitize_address] = ACTIONS(122),
    [anon_sym_sanitize_memory] = ACTIONS(122),
    [anon_sym_sanitize_thread] = ACTIONS(122),
    [anon_sym_sanitize_hwaddress] = ACTIONS(122),
    [anon_sym_sanitize_memtag] = ACTIONS(122),
    [anon_sym_speculative_load_hardening] = ACTIONS(122),
    [anon_sym_speculatable] = ACTIONS(122),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(122),
    [anon_sym_sspreq] = ACTIONS(122),
    [anon_sym_strictfp] = ACTIONS(122),
    [anon_sym_uwtable] = ACTIONS(122),
    [anon_sym_nocf_check] = ACTIONS(122),
    [anon_sym_shadowcallstack] = ACTIONS(122),
    [anon_sym_mustprogress] = ACTIONS(122),
    [anon_sym_vscale_range] = ACTIONS(122),
    [anon_sym_preallocated] = ACTIONS(122),
    [anon_sym_zeroext] = ACTIONS(122),
    [anon_sym_signext] = ACTIONS(122),
    [anon_sym_inreg] = ACTIONS(122),
    [anon_sym_byval] = ACTIONS(122),
    [anon_sym_byref] = ACTIONS(122),
    [anon_sym_inalloca] = ACTIONS(122),
    [anon_sym_sret] = ACTIONS(122),
    [anon_sym_elementtype] = ACTIONS(122),
    [anon_sym_noalias] = ACTIONS(122),
    [anon_sym_nocapture] = ACTIONS(122),
    [anon_sym_nest] = ACTIONS(122),
    [anon_sym_returned] = ACTIONS(122),
    [anon_sym_nonnull] = ACTIONS(122),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(122),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(122),
    [anon_sym_noundef] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [4] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(170),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(145),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(70),
    [anon_sym_partition] = ACTIONS(70),
    [anon_sym_comdat] = ACTIONS(70),
    [anon_sym_gc] = ACTIONS(70),
    [anon_sym_prefix] = ACTIONS(70),
    [anon_sym_prologue] = ACTIONS(70),
    [anon_sym_personality] = ACTIONS(70),
    [anon_sym_alignstack] = ACTIONS(70),
    [anon_sym_allocsize] = ACTIONS(70),
    [anon_sym_alwaysinline] = ACTIONS(70),
    [anon_sym_builtin] = ACTIONS(70),
    [anon_sym_cold] = ACTIONS(70),
    [anon_sym_convergent] = ACTIONS(70),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(70),
    [anon_sym_hot] = ACTIONS(70),
    [anon_sym_inaccessiblememonly] = ACTIONS(70),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(70),
    [anon_sym_inlinehint] = ACTIONS(70),
    [anon_sym_jumptable] = ACTIONS(70),
    [anon_sym_minsize] = ACTIONS(70),
    [anon_sym_naked] = ACTIONS(70),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(70),
    [anon_sym_nobuiltin] = ACTIONS(70),
    [anon_sym_noduplicate] = ACTIONS(70),
    [anon_sym_nofree] = ACTIONS(70),
    [anon_sym_noimplicitfloat] = ACTIONS(70),
    [anon_sym_noinline] = ACTIONS(70),
    [anon_sym_nomerge] = ACTIONS(70),
    [anon_sym_nonlazybind] = ACTIONS(70),
    [anon_sym_noprofile] = ACTIONS(70),
    [anon_sym_noredzone] = ACTIONS(70),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(70),
    [anon_sym_noreturn] = ACTIONS(70),
    [anon_sym_norecurse] = ACTIONS(70),
    [anon_sym_willreturn] = ACTIONS(70),
    [anon_sym_nosync] = ACTIONS(70),
    [anon_sym_nounwind] = ACTIONS(70),
    [anon_sym_nosanitize_coverage] = ACTIONS(70),
    [anon_sym_null_pointer_is_valid] = ACTIONS(70),
    [anon_sym_optforfuzzing] = ACTIONS(70),
    [anon_sym_optnone] = ACTIONS(70),
    [anon_sym_optsize] = ACTIONS(70),
    [anon_sym_readnone] = ACTIONS(70),
    [anon_sym_readonly] = ACTIONS(70),
    [anon_sym_writeonly] = ACTIONS(70),
    [anon_sym_argmemonly] = ACTIONS(70),
    [anon_sym_returns_twice] = ACTIONS(70),
    [anon_sym_safestack] = ACTIONS(70),
    [anon_sym_sanitize_address] = ACTIONS(70),
    [anon_sym_sanitize_memory] = ACTIONS(70),
    [anon_sym_sanitize_thread] = ACTIONS(70),
    [anon_sym_sanitize_hwaddress] = ACTIONS(70),
    [anon_sym_sanitize_memtag] = ACTIONS(70),
    [anon_sym_speculative_load_hardening] = ACTIONS(70),
    [anon_sym_speculatable] = ACTIONS(70),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(70),
    [anon_sym_sspreq] = ACTIONS(70),
    [anon_sym_strictfp] = ACTIONS(70),
    [anon_sym_uwtable] = ACTIONS(70),
    [anon_sym_nocf_check] = ACTIONS(70),
    [anon_sym_shadowcallstack] = ACTIONS(70),
    [anon_sym_mustprogress] = ACTIONS(70),
    [anon_sym_vscale_range] = ACTIONS(70),
    [anon_sym_preallocated] = ACTIONS(70),
    [anon_sym_zeroext] = ACTIONS(70),
    [anon_sym_signext] = ACTIONS(70),
    [anon_sym_inreg] = ACTIONS(70),
    [anon_sym_byval] = ACTIONS(70),
    [anon_sym_byref] = ACTIONS(70),
    [anon_sym_inalloca] = ACTIONS(70),
    [anon_sym_sret] = ACTIONS(70),
    [anon_sym_elementtype] = ACTIONS(70),
    [anon_sym_noalias] = ACTIONS(70),
    [anon_sym_nocapture] = ACTIONS(70),
    [anon_sym_nest] = ACTIONS(70),
    [anon_sym_returned] = ACTIONS(70),
    [anon_sym_nonnull] = ACTIONS(70),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(70),
    [anon_sym_swiftself] = ACTIONS(70),
    [anon_sym_swiftasync] = ACTIONS(70),
    [anon_sym_swifterror] = ACTIONS(70),
    [anon_sym_immarg] = ACTIONS(70),
    [anon_sym_noundef] = ACTIONS(70),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [5] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(2),
    [sym_type_keyword] = STATE(6),
    [sym_struct_type] = STATE(6),
    [sym_packed_struct_type] = STATE(6),
    [sym_array_type] = STATE(6),
    [sym_vector_type] = STATE(6),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(125),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(214),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_ccc] = ACTIONS(116),
    [anon_sym_fastcc] = ACTIONS(116),
    [anon_sym_coldcc] = ACTIONS(116),
    [anon_sym_webkit_jscc] = ACTIONS(122),
    [anon_sym_anyregcc] = ACTIONS(116),
    [anon_sym_preserve_mostcc] = ACTIONS(116),
    [anon_sym_preserve_allcc] = ACTIONS(116),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(122),
    [anon_sym_tailcc] = ACTIONS(116),
    [anon_sym_swiftcc] = ACTIONS(122),
    [anon_sym_swifttailcc] = ACTIONS(122),
    [anon_sym_cfguard_checkcc] = ACTIONS(116),
    [aux_sym_calling_conv_token1] = ACTIONS(122),
    [aux_sym_calling_conv_token2] = ACTIONS(116),
    [aux_sym_calling_conv_token3] = ACTIONS(116),
    [aux_sym_calling_conv_token4] = ACTIONS(116),
    [aux_sym_calling_conv_token5] = ACTIONS(116),
    [aux_sym_calling_conv_token6] = ACTIONS(116),
    [aux_sym_calling_conv_token7] = ACTIONS(116),
    [aux_sym_calling_conv_token8] = ACTIONS(116),
    [aux_sym_calling_conv_token9] = ACTIONS(116),
    [aux_sym_calling_conv_token10] = ACTIONS(122),
    [anon_sym_ghccc] = ACTIONS(116),
    [aux_sym_calling_conv_token11] = ACTIONS(122),
    [aux_sym_calling_conv_token12] = ACTIONS(116),
    [aux_sym_calling_conv_token13] = ACTIONS(122),
    [aux_sym_calling_conv_token14] = ACTIONS(116),
    [anon_sym_cc] = ACTIONS(122),
    [anon_sym_unnamed_addr] = ACTIONS(116),
    [anon_sym_local_unnamed_addr] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(216),
    [anon_sym_half] = ACTIONS(216),
    [anon_sym_bfloat] = ACTIONS(216),
    [anon_sym_float] = ACTIONS(216),
    [anon_sym_double] = ACTIONS(216),
    [anon_sym_x86_fp80] = ACTIONS(218),
    [anon_sym_fp128] = ACTIONS(216),
    [anon_sym_ppc_fp128] = ACTIONS(216),
    [anon_sym_label] = ACTIONS(216),
    [anon_sym_metadata] = ACTIONS(220),
    [anon_sym_x86_mmx] = ACTIONS(218),
    [anon_sym_x86_amx] = ACTIONS(218),
    [anon_sym_token] = ACTIONS(216),
    [anon_sym_opaque] = ACTIONS(216),
    [anon_sym_ptr] = ACTIONS(218),
    [aux_sym_type_keyword_token1] = ACTIONS(216),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_LT_LBRACE] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(226),
    [anon_sym_LT] = ACTIONS(228),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [6] = {
    [sym_addrspace] = STATE(26),
    [sym_argument_list] = STATE(7),
    [aux_sym_type_repeat1] = STATE(10),
    [aux_sym_type_repeat2] = STATE(7),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_ccc] = ACTIONS(234),
    [anon_sym_fastcc] = ACTIONS(234),
    [anon_sym_coldcc] = ACTIONS(234),
    [anon_sym_webkit_jscc] = ACTIONS(236),
    [anon_sym_anyregcc] = ACTIONS(234),
    [anon_sym_preserve_mostcc] = ACTIONS(234),
    [anon_sym_preserve_allcc] = ACTIONS(234),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(236),
    [anon_sym_tailcc] = ACTIONS(234),
    [anon_sym_swiftcc] = ACTIONS(236),
    [anon_sym_swifttailcc] = ACTIONS(236),
    [anon_sym_cfguard_checkcc] = ACTIONS(234),
    [aux_sym_calling_conv_token1] = ACTIONS(236),
    [aux_sym_calling_conv_token2] = ACTIONS(234),
    [aux_sym_calling_conv_token3] = ACTIONS(234),
    [aux_sym_calling_conv_token4] = ACTIONS(234),
    [aux_sym_calling_conv_token5] = ACTIONS(234),
    [aux_sym_calling_conv_token6] = ACTIONS(234),
    [aux_sym_calling_conv_token7] = ACTIONS(234),
    [aux_sym_calling_conv_token8] = ACTIONS(234),
    [aux_sym_calling_conv_token9] = ACTIONS(234),
    [aux_sym_calling_conv_token10] = ACTIONS(236),
    [anon_sym_ghccc] = ACTIONS(234),
    [aux_sym_calling_conv_token11] = ACTIONS(236),
    [aux_sym_calling_conv_token12] = ACTIONS(234),
    [aux_sym_calling_conv_token13] = ACTIONS(236),
    [aux_sym_calling_conv_token14] = ACTIONS(234),
    [anon_sym_cc] = ACTIONS(236),
    [anon_sym_unnamed_addr] = ACTIONS(234),
    [anon_sym_local_unnamed_addr] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_void] = ACTIONS(234),
    [anon_sym_half] = ACTIONS(234),
    [anon_sym_bfloat] = ACTIONS(234),
    [anon_sym_float] = ACTIONS(234),
    [anon_sym_double] = ACTIONS(234),
    [anon_sym_x86_fp80] = ACTIONS(236),
    [anon_sym_fp128] = ACTIONS(234),
    [anon_sym_ppc_fp128] = ACTIONS(234),
    [anon_sym_label] = ACTIONS(234),
    [anon_sym_metadata] = ACTIONS(234),
    [anon_sym_x86_mmx] = ACTIONS(236),
    [anon_sym_x86_amx] = ACTIONS(236),
    [anon_sym_token] = ACTIONS(234),
    [anon_sym_opaque] = ACTIONS(234),
    [anon_sym_ptr] = ACTIONS(236),
    [aux_sym_type_keyword_token1] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE_GT] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_alignstack] = ACTIONS(234),
    [anon_sym_allocsize] = ACTIONS(234),
    [anon_sym_alwaysinline] = ACTIONS(234),
    [anon_sym_builtin] = ACTIONS(234),
    [anon_sym_cold] = ACTIONS(236),
    [anon_sym_convergent] = ACTIONS(234),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(234),
    [anon_sym_hot] = ACTIONS(234),
    [anon_sym_inaccessiblememonly] = ACTIONS(234),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(234),
    [anon_sym_inlinehint] = ACTIONS(234),
    [anon_sym_jumptable] = ACTIONS(234),
    [anon_sym_minsize] = ACTIONS(234),
    [anon_sym_naked] = ACTIONS(234),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(234),
    [anon_sym_nobuiltin] = ACTIONS(234),
    [anon_sym_noduplicate] = ACTIONS(234),
    [anon_sym_nofree] = ACTIONS(234),
    [anon_sym_noimplicitfloat] = ACTIONS(234),
    [anon_sym_noinline] = ACTIONS(234),
    [anon_sym_nomerge] = ACTIONS(234),
    [anon_sym_nonlazybind] = ACTIONS(234),
    [anon_sym_noprofile] = ACTIONS(234),
    [anon_sym_noredzone] = ACTIONS(234),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(234),
    [anon_sym_noreturn] = ACTIONS(234),
    [anon_sym_norecurse] = ACTIONS(234),
    [anon_sym_willreturn] = ACTIONS(234),
    [anon_sym_nosync] = ACTIONS(234),
    [anon_sym_nounwind] = ACTIONS(234),
    [anon_sym_nosanitize_coverage] = ACTIONS(234),
    [anon_sym_null_pointer_is_valid] = ACTIONS(234),
    [anon_sym_optforfuzzing] = ACTIONS(234),
    [anon_sym_optnone] = ACTIONS(234),
    [anon_sym_optsize] = ACTIONS(234),
    [anon_sym_readnone] = ACTIONS(234),
    [anon_sym_readonly] = ACTIONS(234),
    [anon_sym_writeonly] = ACTIONS(234),
    [anon_sym_argmemonly] = ACTIONS(234),
    [anon_sym_returns_twice] = ACTIONS(234),
    [anon_sym_safestack] = ACTIONS(234),
    [anon_sym_sanitize_address] = ACTIONS(234),
    [anon_sym_sanitize_memory] = ACTIONS(234),
    [anon_sym_sanitize_thread] = ACTIONS(234),
    [anon_sym_sanitize_hwaddress] = ACTIONS(234),
    [anon_sym_sanitize_memtag] = ACTIONS(234),
    [anon_sym_speculative_load_hardening] = ACTIONS(234),
    [anon_sym_speculatable] = ACTIONS(234),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(234),
    [anon_sym_sspreq] = ACTIONS(234),
    [anon_sym_strictfp] = ACTIONS(234),
    [anon_sym_uwtable] = ACTIONS(234),
    [anon_sym_nocf_check] = ACTIONS(234),
    [anon_sym_shadowcallstack] = ACTIONS(234),
    [anon_sym_mustprogress] = ACTIONS(234),
    [anon_sym_vscale_range] = ACTIONS(234),
    [anon_sym_preallocated] = ACTIONS(234),
    [anon_sym_zeroext] = ACTIONS(234),
    [anon_sym_signext] = ACTIONS(234),
    [anon_sym_inreg] = ACTIONS(234),
    [anon_sym_byval] = ACTIONS(234),
    [anon_sym_byref] = ACTIONS(234),
    [anon_sym_inalloca] = ACTIONS(234),
    [anon_sym_sret] = ACTIONS(234),
    [anon_sym_elementtype] = ACTIONS(234),
    [anon_sym_noalias] = ACTIONS(234),
    [anon_sym_nocapture] = ACTIONS(234),
    [anon_sym_nest] = ACTIONS(234),
    [anon_sym_returned] = ACTIONS(234),
    [anon_sym_nonnull] = ACTIONS(234),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(234),
    [anon_sym_swiftself] = ACTIONS(236),
    [anon_sym_swiftasync] = ACTIONS(236),
    [anon_sym_swifterror] = ACTIONS(236),
    [anon_sym_immarg] = ACTIONS(234),
    [anon_sym_noundef] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
  },
  [7] = {
    [sym_addrspace] = STATE(29),
    [sym_argument_list] = STATE(8),
    [aux_sym_type_repeat1] = STATE(9),
    [aux_sym_type_repeat2] = STATE(8),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(248),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [8] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(8),
    [aux_sym_type_repeat1] = STATE(1128),
    [aux_sym_type_repeat2] = STATE(8),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_ccc] = ACTIONS(250),
    [anon_sym_fastcc] = ACTIONS(250),
    [anon_sym_coldcc] = ACTIONS(250),
    [anon_sym_webkit_jscc] = ACTIONS(252),
    [anon_sym_anyregcc] = ACTIONS(250),
    [anon_sym_preserve_mostcc] = ACTIONS(250),
    [anon_sym_preserve_allcc] = ACTIONS(250),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(252),
    [anon_sym_tailcc] = ACTIONS(250),
    [anon_sym_swiftcc] = ACTIONS(252),
    [anon_sym_swifttailcc] = ACTIONS(252),
    [anon_sym_cfguard_checkcc] = ACTIONS(250),
    [aux_sym_calling_conv_token1] = ACTIONS(252),
    [aux_sym_calling_conv_token2] = ACTIONS(250),
    [aux_sym_calling_conv_token3] = ACTIONS(250),
    [aux_sym_calling_conv_token4] = ACTIONS(250),
    [aux_sym_calling_conv_token5] = ACTIONS(250),
    [aux_sym_calling_conv_token6] = ACTIONS(250),
    [aux_sym_calling_conv_token7] = ACTIONS(250),
    [aux_sym_calling_conv_token8] = ACTIONS(250),
    [aux_sym_calling_conv_token9] = ACTIONS(250),
    [aux_sym_calling_conv_token10] = ACTIONS(252),
    [anon_sym_ghccc] = ACTIONS(250),
    [aux_sym_calling_conv_token11] = ACTIONS(252),
    [aux_sym_calling_conv_token12] = ACTIONS(250),
    [aux_sym_calling_conv_token13] = ACTIONS(252),
    [aux_sym_calling_conv_token14] = ACTIONS(250),
    [anon_sym_cc] = ACTIONS(252),
    [anon_sym_unnamed_addr] = ACTIONS(250),
    [anon_sym_local_unnamed_addr] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(252),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(252),
    [anon_sym_x86_amx] = ACTIONS(252),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [9] = {
    [sym_addrspace] = STATE(27),
    [sym_argument_list] = STATE(16),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_ccc] = ACTIONS(263),
    [anon_sym_fastcc] = ACTIONS(263),
    [anon_sym_coldcc] = ACTIONS(263),
    [anon_sym_webkit_jscc] = ACTIONS(265),
    [anon_sym_anyregcc] = ACTIONS(263),
    [anon_sym_preserve_mostcc] = ACTIONS(263),
    [anon_sym_preserve_allcc] = ACTIONS(263),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(265),
    [anon_sym_tailcc] = ACTIONS(263),
    [anon_sym_swiftcc] = ACTIONS(265),
    [anon_sym_swifttailcc] = ACTIONS(265),
    [anon_sym_cfguard_checkcc] = ACTIONS(263),
    [aux_sym_calling_conv_token1] = ACTIONS(265),
    [aux_sym_calling_conv_token2] = ACTIONS(263),
    [aux_sym_calling_conv_token3] = ACTIONS(263),
    [aux_sym_calling_conv_token4] = ACTIONS(263),
    [aux_sym_calling_conv_token5] = ACTIONS(263),
    [aux_sym_calling_conv_token6] = ACTIONS(263),
    [aux_sym_calling_conv_token7] = ACTIONS(263),
    [aux_sym_calling_conv_token8] = ACTIONS(263),
    [aux_sym_calling_conv_token9] = ACTIONS(263),
    [aux_sym_calling_conv_token10] = ACTIONS(265),
    [anon_sym_ghccc] = ACTIONS(263),
    [aux_sym_calling_conv_token11] = ACTIONS(265),
    [aux_sym_calling_conv_token12] = ACTIONS(263),
    [aux_sym_calling_conv_token13] = ACTIONS(265),
    [aux_sym_calling_conv_token14] = ACTIONS(263),
    [anon_sym_cc] = ACTIONS(265),
    [anon_sym_unnamed_addr] = ACTIONS(263),
    [anon_sym_local_unnamed_addr] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(267),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(265),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(265),
    [anon_sym_x86_amx] = ACTIONS(265),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [10] = {
    [sym_addrspace] = STATE(29),
    [sym_argument_list] = STATE(16),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(267),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [11] = {
    [sym_addrspace] = STATE(1531),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_ccc] = ACTIONS(269),
    [anon_sym_fastcc] = ACTIONS(269),
    [anon_sym_coldcc] = ACTIONS(269),
    [anon_sym_webkit_jscc] = ACTIONS(271),
    [anon_sym_anyregcc] = ACTIONS(269),
    [anon_sym_preserve_mostcc] = ACTIONS(269),
    [anon_sym_preserve_allcc] = ACTIONS(269),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(271),
    [anon_sym_tailcc] = ACTIONS(269),
    [anon_sym_swiftcc] = ACTIONS(271),
    [anon_sym_swifttailcc] = ACTIONS(271),
    [anon_sym_cfguard_checkcc] = ACTIONS(269),
    [aux_sym_calling_conv_token1] = ACTIONS(271),
    [aux_sym_calling_conv_token2] = ACTIONS(269),
    [aux_sym_calling_conv_token3] = ACTIONS(269),
    [aux_sym_calling_conv_token4] = ACTIONS(269),
    [aux_sym_calling_conv_token5] = ACTIONS(269),
    [aux_sym_calling_conv_token6] = ACTIONS(269),
    [aux_sym_calling_conv_token7] = ACTIONS(269),
    [aux_sym_calling_conv_token8] = ACTIONS(269),
    [aux_sym_calling_conv_token9] = ACTIONS(269),
    [aux_sym_calling_conv_token10] = ACTIONS(271),
    [anon_sym_ghccc] = ACTIONS(269),
    [aux_sym_calling_conv_token11] = ACTIONS(271),
    [aux_sym_calling_conv_token12] = ACTIONS(269),
    [aux_sym_calling_conv_token13] = ACTIONS(271),
    [aux_sym_calling_conv_token14] = ACTIONS(269),
    [anon_sym_cc] = ACTIONS(271),
    [anon_sym_unnamed_addr] = ACTIONS(269),
    [anon_sym_local_unnamed_addr] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(271),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(271),
    [anon_sym_x86_amx] = ACTIONS(271),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [12] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_ccc] = ACTIONS(279),
    [anon_sym_fastcc] = ACTIONS(279),
    [anon_sym_coldcc] = ACTIONS(279),
    [anon_sym_webkit_jscc] = ACTIONS(281),
    [anon_sym_anyregcc] = ACTIONS(279),
    [anon_sym_preserve_mostcc] = ACTIONS(279),
    [anon_sym_preserve_allcc] = ACTIONS(279),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(281),
    [anon_sym_tailcc] = ACTIONS(279),
    [anon_sym_swiftcc] = ACTIONS(281),
    [anon_sym_swifttailcc] = ACTIONS(281),
    [anon_sym_cfguard_checkcc] = ACTIONS(279),
    [aux_sym_calling_conv_token1] = ACTIONS(281),
    [aux_sym_calling_conv_token2] = ACTIONS(279),
    [aux_sym_calling_conv_token3] = ACTIONS(279),
    [aux_sym_calling_conv_token4] = ACTIONS(279),
    [aux_sym_calling_conv_token5] = ACTIONS(279),
    [aux_sym_calling_conv_token6] = ACTIONS(279),
    [aux_sym_calling_conv_token7] = ACTIONS(279),
    [aux_sym_calling_conv_token8] = ACTIONS(279),
    [aux_sym_calling_conv_token9] = ACTIONS(279),
    [aux_sym_calling_conv_token10] = ACTIONS(281),
    [anon_sym_ghccc] = ACTIONS(279),
    [aux_sym_calling_conv_token11] = ACTIONS(281),
    [aux_sym_calling_conv_token12] = ACTIONS(279),
    [aux_sym_calling_conv_token13] = ACTIONS(281),
    [aux_sym_calling_conv_token14] = ACTIONS(279),
    [anon_sym_cc] = ACTIONS(281),
    [anon_sym_unnamed_addr] = ACTIONS(279),
    [anon_sym_local_unnamed_addr] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_void] = ACTIONS(279),
    [anon_sym_half] = ACTIONS(279),
    [anon_sym_bfloat] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [anon_sym_x86_fp80] = ACTIONS(281),
    [anon_sym_fp128] = ACTIONS(279),
    [anon_sym_ppc_fp128] = ACTIONS(279),
    [anon_sym_label] = ACTIONS(279),
    [anon_sym_metadata] = ACTIONS(279),
    [anon_sym_x86_mmx] = ACTIONS(281),
    [anon_sym_x86_amx] = ACTIONS(281),
    [anon_sym_token] = ACTIONS(279),
    [anon_sym_opaque] = ACTIONS(279),
    [anon_sym_ptr] = ACTIONS(281),
    [aux_sym_type_keyword_token1] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE_GT] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_alignstack] = ACTIONS(279),
    [anon_sym_allocsize] = ACTIONS(279),
    [anon_sym_alwaysinline] = ACTIONS(279),
    [anon_sym_builtin] = ACTIONS(279),
    [anon_sym_cold] = ACTIONS(281),
    [anon_sym_convergent] = ACTIONS(279),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(279),
    [anon_sym_hot] = ACTIONS(279),
    [anon_sym_inaccessiblememonly] = ACTIONS(279),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(279),
    [anon_sym_inlinehint] = ACTIONS(279),
    [anon_sym_jumptable] = ACTIONS(279),
    [anon_sym_minsize] = ACTIONS(279),
    [anon_sym_naked] = ACTIONS(279),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(279),
    [anon_sym_nobuiltin] = ACTIONS(279),
    [anon_sym_noduplicate] = ACTIONS(279),
    [anon_sym_nofree] = ACTIONS(279),
    [anon_sym_noimplicitfloat] = ACTIONS(279),
    [anon_sym_noinline] = ACTIONS(279),
    [anon_sym_nomerge] = ACTIONS(279),
    [anon_sym_nonlazybind] = ACTIONS(279),
    [anon_sym_noprofile] = ACTIONS(279),
    [anon_sym_noredzone] = ACTIONS(279),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(279),
    [anon_sym_noreturn] = ACTIONS(279),
    [anon_sym_norecurse] = ACTIONS(279),
    [anon_sym_willreturn] = ACTIONS(279),
    [anon_sym_nosync] = ACTIONS(279),
    [anon_sym_nounwind] = ACTIONS(279),
    [anon_sym_nosanitize_coverage] = ACTIONS(279),
    [anon_sym_null_pointer_is_valid] = ACTIONS(279),
    [anon_sym_optforfuzzing] = ACTIONS(279),
    [anon_sym_optnone] = ACTIONS(279),
    [anon_sym_optsize] = ACTIONS(279),
    [anon_sym_readnone] = ACTIONS(279),
    [anon_sym_readonly] = ACTIONS(279),
    [anon_sym_writeonly] = ACTIONS(279),
    [anon_sym_argmemonly] = ACTIONS(279),
    [anon_sym_returns_twice] = ACTIONS(279),
    [anon_sym_safestack] = ACTIONS(279),
    [anon_sym_sanitize_address] = ACTIONS(279),
    [anon_sym_sanitize_memory] = ACTIONS(279),
    [anon_sym_sanitize_thread] = ACTIONS(279),
    [anon_sym_sanitize_hwaddress] = ACTIONS(279),
    [anon_sym_sanitize_memtag] = ACTIONS(279),
    [anon_sym_speculative_load_hardening] = ACTIONS(279),
    [anon_sym_speculatable] = ACTIONS(279),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(279),
    [anon_sym_sspreq] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_uwtable] = ACTIONS(279),
    [anon_sym_nocf_check] = ACTIONS(279),
    [anon_sym_shadowcallstack] = ACTIONS(279),
    [anon_sym_mustprogress] = ACTIONS(279),
    [anon_sym_vscale_range] = ACTIONS(279),
    [anon_sym_preallocated] = ACTIONS(279),
    [anon_sym_zeroext] = ACTIONS(279),
    [anon_sym_signext] = ACTIONS(279),
    [anon_sym_inreg] = ACTIONS(279),
    [anon_sym_byval] = ACTIONS(279),
    [anon_sym_byref] = ACTIONS(279),
    [anon_sym_inalloca] = ACTIONS(279),
    [anon_sym_sret] = ACTIONS(279),
    [anon_sym_elementtype] = ACTIONS(279),
    [anon_sym_noalias] = ACTIONS(279),
    [anon_sym_nocapture] = ACTIONS(279),
    [anon_sym_nest] = ACTIONS(279),
    [anon_sym_returned] = ACTIONS(279),
    [anon_sym_nonnull] = ACTIONS(279),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(279),
    [anon_sym_swiftself] = ACTIONS(281),
    [anon_sym_swiftasync] = ACTIONS(281),
    [anon_sym_swifterror] = ACTIONS(281),
    [anon_sym_immarg] = ACTIONS(279),
    [anon_sym_noundef] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
  },
  [13] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(283),
    [sym_string] = ACTIONS(283),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(283),
    [sym_float] = ACTIONS(283),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_internal] = ACTIONS(283),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(283),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(283),
    [anon_sym_available_externally] = ACTIONS(283),
    [anon_sym_appending] = ACTIONS(283),
    [anon_sym_common] = ACTIONS(283),
    [anon_sym_extern_weak] = ACTIONS(283),
    [anon_sym_external] = ACTIONS(283),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(283),
    [anon_sym_dso_preemptable] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_hidden] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_dllimport] = ACTIONS(283),
    [anon_sym_dllexport] = ACTIONS(283),
    [anon_sym_ccc] = ACTIONS(283),
    [anon_sym_fastcc] = ACTIONS(283),
    [anon_sym_coldcc] = ACTIONS(283),
    [anon_sym_webkit_jscc] = ACTIONS(285),
    [anon_sym_anyregcc] = ACTIONS(283),
    [anon_sym_preserve_mostcc] = ACTIONS(283),
    [anon_sym_preserve_allcc] = ACTIONS(283),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(285),
    [anon_sym_tailcc] = ACTIONS(283),
    [anon_sym_swiftcc] = ACTIONS(285),
    [anon_sym_swifttailcc] = ACTIONS(285),
    [anon_sym_cfguard_checkcc] = ACTIONS(283),
    [aux_sym_calling_conv_token1] = ACTIONS(285),
    [aux_sym_calling_conv_token2] = ACTIONS(283),
    [aux_sym_calling_conv_token3] = ACTIONS(283),
    [aux_sym_calling_conv_token4] = ACTIONS(283),
    [aux_sym_calling_conv_token5] = ACTIONS(283),
    [aux_sym_calling_conv_token6] = ACTIONS(283),
    [aux_sym_calling_conv_token7] = ACTIONS(283),
    [aux_sym_calling_conv_token8] = ACTIONS(283),
    [aux_sym_calling_conv_token9] = ACTIONS(283),
    [aux_sym_calling_conv_token10] = ACTIONS(285),
    [anon_sym_ghccc] = ACTIONS(283),
    [aux_sym_calling_conv_token11] = ACTIONS(285),
    [aux_sym_calling_conv_token12] = ACTIONS(283),
    [aux_sym_calling_conv_token13] = ACTIONS(285),
    [aux_sym_calling_conv_token14] = ACTIONS(283),
    [anon_sym_cc] = ACTIONS(285),
    [anon_sym_unnamed_addr] = ACTIONS(283),
    [anon_sym_local_unnamed_addr] = ACTIONS(283),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_void] = ACTIONS(283),
    [anon_sym_half] = ACTIONS(283),
    [anon_sym_bfloat] = ACTIONS(283),
    [anon_sym_float] = ACTIONS(283),
    [anon_sym_double] = ACTIONS(283),
    [anon_sym_x86_fp80] = ACTIONS(285),
    [anon_sym_fp128] = ACTIONS(283),
    [anon_sym_ppc_fp128] = ACTIONS(283),
    [anon_sym_label] = ACTIONS(283),
    [anon_sym_metadata] = ACTIONS(283),
    [anon_sym_x86_mmx] = ACTIONS(285),
    [anon_sym_x86_amx] = ACTIONS(285),
    [anon_sym_token] = ACTIONS(283),
    [anon_sym_opaque] = ACTIONS(283),
    [anon_sym_ptr] = ACTIONS(285),
    [aux_sym_type_keyword_token1] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE_GT] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_align] = ACTIONS(285),
    [anon_sym_alignstack] = ACTIONS(283),
    [anon_sym_allocsize] = ACTIONS(283),
    [anon_sym_alwaysinline] = ACTIONS(283),
    [anon_sym_builtin] = ACTIONS(283),
    [anon_sym_cold] = ACTIONS(285),
    [anon_sym_convergent] = ACTIONS(283),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(283),
    [anon_sym_hot] = ACTIONS(283),
    [anon_sym_inaccessiblememonly] = ACTIONS(283),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(283),
    [anon_sym_inlinehint] = ACTIONS(283),
    [anon_sym_jumptable] = ACTIONS(283),
    [anon_sym_minsize] = ACTIONS(283),
    [anon_sym_naked] = ACTIONS(283),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(283),
    [anon_sym_nobuiltin] = ACTIONS(283),
    [anon_sym_noduplicate] = ACTIONS(283),
    [anon_sym_nofree] = ACTIONS(283),
    [anon_sym_noimplicitfloat] = ACTIONS(283),
    [anon_sym_noinline] = ACTIONS(283),
    [anon_sym_nomerge] = ACTIONS(283),
    [anon_sym_nonlazybind] = ACTIONS(283),
    [anon_sym_noprofile] = ACTIONS(283),
    [anon_sym_noredzone] = ACTIONS(283),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(283),
    [anon_sym_noreturn] = ACTIONS(283),
    [anon_sym_norecurse] = ACTIONS(283),
    [anon_sym_willreturn] = ACTIONS(283),
    [anon_sym_nosync] = ACTIONS(283),
    [anon_sym_nounwind] = ACTIONS(283),
    [anon_sym_nosanitize_coverage] = ACTIONS(283),
    [anon_sym_null_pointer_is_valid] = ACTIONS(283),
    [anon_sym_optforfuzzing] = ACTIONS(283),
    [anon_sym_optnone] = ACTIONS(283),
    [anon_sym_optsize] = ACTIONS(283),
    [anon_sym_readnone] = ACTIONS(283),
    [anon_sym_readonly] = ACTIONS(283),
    [anon_sym_writeonly] = ACTIONS(283),
    [anon_sym_argmemonly] = ACTIONS(283),
    [anon_sym_returns_twice] = ACTIONS(283),
    [anon_sym_safestack] = ACTIONS(283),
    [anon_sym_sanitize_address] = ACTIONS(283),
    [anon_sym_sanitize_memory] = ACTIONS(283),
    [anon_sym_sanitize_thread] = ACTIONS(283),
    [anon_sym_sanitize_hwaddress] = ACTIONS(283),
    [anon_sym_sanitize_memtag] = ACTIONS(283),
    [anon_sym_speculative_load_hardening] = ACTIONS(283),
    [anon_sym_speculatable] = ACTIONS(283),
    [anon_sym_ssp] = ACTIONS(285),
    [anon_sym_sspstrong] = ACTIONS(283),
    [anon_sym_sspreq] = ACTIONS(283),
    [anon_sym_strictfp] = ACTIONS(283),
    [anon_sym_uwtable] = ACTIONS(283),
    [anon_sym_nocf_check] = ACTIONS(283),
    [anon_sym_shadowcallstack] = ACTIONS(283),
    [anon_sym_mustprogress] = ACTIONS(283),
    [anon_sym_vscale_range] = ACTIONS(283),
    [anon_sym_preallocated] = ACTIONS(283),
    [anon_sym_zeroext] = ACTIONS(283),
    [anon_sym_signext] = ACTIONS(283),
    [anon_sym_inreg] = ACTIONS(283),
    [anon_sym_byval] = ACTIONS(283),
    [anon_sym_byref] = ACTIONS(283),
    [anon_sym_inalloca] = ACTIONS(283),
    [anon_sym_sret] = ACTIONS(283),
    [anon_sym_elementtype] = ACTIONS(283),
    [anon_sym_noalias] = ACTIONS(283),
    [anon_sym_nocapture] = ACTIONS(283),
    [anon_sym_nest] = ACTIONS(283),
    [anon_sym_returned] = ACTIONS(283),
    [anon_sym_nonnull] = ACTIONS(283),
    [anon_sym_dereferenceable] = ACTIONS(285),
    [anon_sym_dereferenceable_or_null] = ACTIONS(283),
    [anon_sym_swiftself] = ACTIONS(285),
    [anon_sym_swiftasync] = ACTIONS(285),
    [anon_sym_swifterror] = ACTIONS(285),
    [anon_sym_immarg] = ACTIONS(283),
    [anon_sym_noundef] = ACTIONS(283),
    [anon_sym_extractelement] = ACTIONS(283),
    [anon_sym_insertelement] = ACTIONS(283),
    [anon_sym_select] = ACTIONS(283),
    [anon_sym_shufflevector] = ACTIONS(283),
    [anon_sym_fneg] = ACTIONS(283),
    [anon_sym_icmp] = ACTIONS(283),
    [anon_sym_fcmp] = ACTIONS(283),
    [anon_sym_getelementptr] = ACTIONS(283),
    [anon_sym_extractvalue] = ACTIONS(283),
    [anon_sym_insertvalue] = ACTIONS(283),
    [anon_sym_true] = ACTIONS(283),
    [anon_sym_false] = ACTIONS(283),
    [anon_sym_null] = ACTIONS(285),
    [anon_sym_none] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(283),
    [anon_sym_poison] = ACTIONS(283),
    [anon_sym_zeroinitializer] = ACTIONS(283),
    [anon_sym_blockaddress] = ACTIONS(283),
    [anon_sym_mul] = ACTIONS(283),
    [anon_sym_urem] = ACTIONS(283),
    [anon_sym_srem] = ACTIONS(283),
    [anon_sym_shl] = ACTIONS(283),
    [anon_sym_udiv] = ACTIONS(283),
    [anon_sym_sdiv] = ACTIONS(283),
    [anon_sym_lshr] = ACTIONS(283),
    [anon_sym_ashr] = ACTIONS(283),
    [anon_sym_fmul] = ACTIONS(283),
    [anon_sym_fdiv] = ACTIONS(283),
    [anon_sym_frem] = ACTIONS(283),
    [anon_sym_xchg] = ACTIONS(283),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(283),
    [anon_sym_nand] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(283),
    [anon_sym_xor] = ACTIONS(283),
    [anon_sym_max] = ACTIONS(283),
    [anon_sym_min] = ACTIONS(285),
    [anon_sym_umax] = ACTIONS(283),
    [anon_sym_umin] = ACTIONS(283),
    [anon_sym_fadd] = ACTIONS(283),
    [anon_sym_fsub] = ACTIONS(283),
    [anon_sym_bitcast] = ACTIONS(283),
    [anon_sym_trunc] = ACTIONS(283),
    [anon_sym_zext] = ACTIONS(283),
    [anon_sym_sext] = ACTIONS(283),
    [anon_sym_fptrunc] = ACTIONS(283),
    [anon_sym_fpext] = ACTIONS(283),
    [anon_sym_addrspacecast] = ACTIONS(283),
    [anon_sym_uitofp] = ACTIONS(283),
    [anon_sym_sitofp] = ACTIONS(283),
    [anon_sym_fptoui] = ACTIONS(283),
    [anon_sym_fptosi] = ACTIONS(283),
    [anon_sym_inttoptr] = ACTIONS(283),
    [anon_sym_ptrtoint] = ACTIONS(283),
  },
  [14] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_ccc] = ACTIONS(269),
    [anon_sym_fastcc] = ACTIONS(269),
    [anon_sym_coldcc] = ACTIONS(269),
    [anon_sym_webkit_jscc] = ACTIONS(271),
    [anon_sym_anyregcc] = ACTIONS(269),
    [anon_sym_preserve_mostcc] = ACTIONS(269),
    [anon_sym_preserve_allcc] = ACTIONS(269),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(271),
    [anon_sym_tailcc] = ACTIONS(269),
    [anon_sym_swiftcc] = ACTIONS(271),
    [anon_sym_swifttailcc] = ACTIONS(271),
    [anon_sym_cfguard_checkcc] = ACTIONS(269),
    [aux_sym_calling_conv_token1] = ACTIONS(271),
    [aux_sym_calling_conv_token2] = ACTIONS(269),
    [aux_sym_calling_conv_token3] = ACTIONS(269),
    [aux_sym_calling_conv_token4] = ACTIONS(269),
    [aux_sym_calling_conv_token5] = ACTIONS(269),
    [aux_sym_calling_conv_token6] = ACTIONS(269),
    [aux_sym_calling_conv_token7] = ACTIONS(269),
    [aux_sym_calling_conv_token8] = ACTIONS(269),
    [aux_sym_calling_conv_token9] = ACTIONS(269),
    [aux_sym_calling_conv_token10] = ACTIONS(271),
    [anon_sym_ghccc] = ACTIONS(269),
    [aux_sym_calling_conv_token11] = ACTIONS(271),
    [aux_sym_calling_conv_token12] = ACTIONS(269),
    [aux_sym_calling_conv_token13] = ACTIONS(271),
    [aux_sym_calling_conv_token14] = ACTIONS(269),
    [anon_sym_cc] = ACTIONS(271),
    [anon_sym_unnamed_addr] = ACTIONS(269),
    [anon_sym_local_unnamed_addr] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(271),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(271),
    [anon_sym_x86_amx] = ACTIONS(271),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [15] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_ccc] = ACTIONS(116),
    [anon_sym_fastcc] = ACTIONS(116),
    [anon_sym_coldcc] = ACTIONS(116),
    [anon_sym_webkit_jscc] = ACTIONS(122),
    [anon_sym_anyregcc] = ACTIONS(116),
    [anon_sym_preserve_mostcc] = ACTIONS(116),
    [anon_sym_preserve_allcc] = ACTIONS(116),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(122),
    [anon_sym_tailcc] = ACTIONS(116),
    [anon_sym_swiftcc] = ACTIONS(122),
    [anon_sym_swifttailcc] = ACTIONS(122),
    [anon_sym_cfguard_checkcc] = ACTIONS(116),
    [aux_sym_calling_conv_token1] = ACTIONS(122),
    [aux_sym_calling_conv_token2] = ACTIONS(116),
    [aux_sym_calling_conv_token3] = ACTIONS(116),
    [aux_sym_calling_conv_token4] = ACTIONS(116),
    [aux_sym_calling_conv_token5] = ACTIONS(116),
    [aux_sym_calling_conv_token6] = ACTIONS(116),
    [aux_sym_calling_conv_token7] = ACTIONS(116),
    [aux_sym_calling_conv_token8] = ACTIONS(116),
    [aux_sym_calling_conv_token9] = ACTIONS(116),
    [aux_sym_calling_conv_token10] = ACTIONS(122),
    [anon_sym_ghccc] = ACTIONS(116),
    [aux_sym_calling_conv_token11] = ACTIONS(122),
    [aux_sym_calling_conv_token12] = ACTIONS(116),
    [aux_sym_calling_conv_token13] = ACTIONS(122),
    [aux_sym_calling_conv_token14] = ACTIONS(116),
    [anon_sym_cc] = ACTIONS(122),
    [anon_sym_unnamed_addr] = ACTIONS(116),
    [anon_sym_local_unnamed_addr] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_half] = ACTIONS(116),
    [anon_sym_bfloat] = ACTIONS(116),
    [anon_sym_float] = ACTIONS(116),
    [anon_sym_double] = ACTIONS(116),
    [anon_sym_x86_fp80] = ACTIONS(122),
    [anon_sym_fp128] = ACTIONS(116),
    [anon_sym_ppc_fp128] = ACTIONS(116),
    [anon_sym_label] = ACTIONS(116),
    [anon_sym_metadata] = ACTIONS(116),
    [anon_sym_x86_mmx] = ACTIONS(122),
    [anon_sym_x86_amx] = ACTIONS(122),
    [anon_sym_token] = ACTIONS(116),
    [anon_sym_opaque] = ACTIONS(116),
    [anon_sym_ptr] = ACTIONS(122),
    [aux_sym_type_keyword_token1] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
  },
  [16] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_ccc] = ACTIONS(250),
    [anon_sym_fastcc] = ACTIONS(250),
    [anon_sym_coldcc] = ACTIONS(250),
    [anon_sym_webkit_jscc] = ACTIONS(252),
    [anon_sym_anyregcc] = ACTIONS(250),
    [anon_sym_preserve_mostcc] = ACTIONS(250),
    [anon_sym_preserve_allcc] = ACTIONS(250),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(252),
    [anon_sym_tailcc] = ACTIONS(250),
    [anon_sym_swiftcc] = ACTIONS(252),
    [anon_sym_swifttailcc] = ACTIONS(252),
    [anon_sym_cfguard_checkcc] = ACTIONS(250),
    [aux_sym_calling_conv_token1] = ACTIONS(252),
    [aux_sym_calling_conv_token2] = ACTIONS(250),
    [aux_sym_calling_conv_token3] = ACTIONS(250),
    [aux_sym_calling_conv_token4] = ACTIONS(250),
    [aux_sym_calling_conv_token5] = ACTIONS(250),
    [aux_sym_calling_conv_token6] = ACTIONS(250),
    [aux_sym_calling_conv_token7] = ACTIONS(250),
    [aux_sym_calling_conv_token8] = ACTIONS(250),
    [aux_sym_calling_conv_token9] = ACTIONS(250),
    [aux_sym_calling_conv_token10] = ACTIONS(252),
    [anon_sym_ghccc] = ACTIONS(250),
    [aux_sym_calling_conv_token11] = ACTIONS(252),
    [aux_sym_calling_conv_token12] = ACTIONS(250),
    [aux_sym_calling_conv_token13] = ACTIONS(252),
    [aux_sym_calling_conv_token14] = ACTIONS(250),
    [anon_sym_cc] = ACTIONS(252),
    [anon_sym_unnamed_addr] = ACTIONS(250),
    [anon_sym_local_unnamed_addr] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(252),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(252),
    [anon_sym_x86_amx] = ACTIONS(252),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [17] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [aux_sym_metadata_ref_token1] = ACTIONS(287),
    [sym_string] = ACTIONS(287),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(287),
    [sym_float] = ACTIONS(287),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_internal] = ACTIONS(287),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(287),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(287),
    [anon_sym_available_externally] = ACTIONS(287),
    [anon_sym_appending] = ACTIONS(287),
    [anon_sym_common] = ACTIONS(287),
    [anon_sym_extern_weak] = ACTIONS(287),
    [anon_sym_external] = ACTIONS(287),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(287),
    [anon_sym_dso_preemptable] = ACTIONS(287),
    [anon_sym_default] = ACTIONS(287),
    [anon_sym_hidden] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_dllimport] = ACTIONS(287),
    [anon_sym_dllexport] = ACTIONS(287),
    [anon_sym_ccc] = ACTIONS(287),
    [anon_sym_fastcc] = ACTIONS(287),
    [anon_sym_coldcc] = ACTIONS(287),
    [anon_sym_webkit_jscc] = ACTIONS(289),
    [anon_sym_anyregcc] = ACTIONS(287),
    [anon_sym_preserve_mostcc] = ACTIONS(287),
    [anon_sym_preserve_allcc] = ACTIONS(287),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(289),
    [anon_sym_tailcc] = ACTIONS(287),
    [anon_sym_swiftcc] = ACTIONS(289),
    [anon_sym_swifttailcc] = ACTIONS(289),
    [anon_sym_cfguard_checkcc] = ACTIONS(287),
    [aux_sym_calling_conv_token1] = ACTIONS(289),
    [aux_sym_calling_conv_token2] = ACTIONS(287),
    [aux_sym_calling_conv_token3] = ACTIONS(287),
    [aux_sym_calling_conv_token4] = ACTIONS(287),
    [aux_sym_calling_conv_token5] = ACTIONS(287),
    [aux_sym_calling_conv_token6] = ACTIONS(287),
    [aux_sym_calling_conv_token7] = ACTIONS(287),
    [aux_sym_calling_conv_token8] = ACTIONS(287),
    [aux_sym_calling_conv_token9] = ACTIONS(287),
    [aux_sym_calling_conv_token10] = ACTIONS(289),
    [anon_sym_ghccc] = ACTIONS(287),
    [aux_sym_calling_conv_token11] = ACTIONS(289),
    [aux_sym_calling_conv_token12] = ACTIONS(287),
    [aux_sym_calling_conv_token13] = ACTIONS(289),
    [aux_sym_calling_conv_token14] = ACTIONS(287),
    [anon_sym_cc] = ACTIONS(289),
    [anon_sym_unnamed_addr] = ACTIONS(287),
    [anon_sym_local_unnamed_addr] = ACTIONS(287),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(289),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(287),
    [anon_sym_x86_mmx] = ACTIONS(289),
    [anon_sym_x86_amx] = ACTIONS(289),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(289),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE_GT] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_align] = ACTIONS(289),
    [anon_sym_alignstack] = ACTIONS(287),
    [anon_sym_allocsize] = ACTIONS(287),
    [anon_sym_alwaysinline] = ACTIONS(287),
    [anon_sym_builtin] = ACTIONS(287),
    [anon_sym_cold] = ACTIONS(289),
    [anon_sym_convergent] = ACTIONS(287),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(287),
    [anon_sym_hot] = ACTIONS(287),
    [anon_sym_inaccessiblememonly] = ACTIONS(287),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(287),
    [anon_sym_inlinehint] = ACTIONS(287),
    [anon_sym_jumptable] = ACTIONS(287),
    [anon_sym_minsize] = ACTIONS(287),
    [anon_sym_naked] = ACTIONS(287),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(287),
    [anon_sym_nobuiltin] = ACTIONS(287),
    [anon_sym_noduplicate] = ACTIONS(287),
    [anon_sym_nofree] = ACTIONS(287),
    [anon_sym_noimplicitfloat] = ACTIONS(287),
    [anon_sym_noinline] = ACTIONS(287),
    [anon_sym_nomerge] = ACTIONS(287),
    [anon_sym_nonlazybind] = ACTIONS(287),
    [anon_sym_noprofile] = ACTIONS(287),
    [anon_sym_noredzone] = ACTIONS(287),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(287),
    [anon_sym_noreturn] = ACTIONS(287),
    [anon_sym_norecurse] = ACTIONS(287),
    [anon_sym_willreturn] = ACTIONS(287),
    [anon_sym_nosync] = ACTIONS(287),
    [anon_sym_nounwind] = ACTIONS(287),
    [anon_sym_nosanitize_coverage] = ACTIONS(287),
    [anon_sym_null_pointer_is_valid] = ACTIONS(287),
    [anon_sym_optforfuzzing] = ACTIONS(287),
    [anon_sym_optnone] = ACTIONS(287),
    [anon_sym_optsize] = ACTIONS(287),
    [anon_sym_readnone] = ACTIONS(287),
    [anon_sym_readonly] = ACTIONS(287),
    [anon_sym_writeonly] = ACTIONS(287),
    [anon_sym_argmemonly] = ACTIONS(287),
    [anon_sym_returns_twice] = ACTIONS(287),
    [anon_sym_safestack] = ACTIONS(287),
    [anon_sym_sanitize_address] = ACTIONS(287),
    [anon_sym_sanitize_memory] = ACTIONS(287),
    [anon_sym_sanitize_thread] = ACTIONS(287),
    [anon_sym_sanitize_hwaddress] = ACTIONS(287),
    [anon_sym_sanitize_memtag] = ACTIONS(287),
    [anon_sym_speculative_load_hardening] = ACTIONS(287),
    [anon_sym_speculatable] = ACTIONS(287),
    [anon_sym_ssp] = ACTIONS(289),
    [anon_sym_sspstrong] = ACTIONS(287),
    [anon_sym_sspreq] = ACTIONS(287),
    [anon_sym_strictfp] = ACTIONS(287),
    [anon_sym_uwtable] = ACTIONS(287),
    [anon_sym_nocf_check] = ACTIONS(287),
    [anon_sym_shadowcallstack] = ACTIONS(287),
    [anon_sym_mustprogress] = ACTIONS(287),
    [anon_sym_vscale_range] = ACTIONS(287),
    [anon_sym_preallocated] = ACTIONS(287),
    [anon_sym_zeroext] = ACTIONS(287),
    [anon_sym_signext] = ACTIONS(287),
    [anon_sym_inreg] = ACTIONS(287),
    [anon_sym_byval] = ACTIONS(287),
    [anon_sym_byref] = ACTIONS(287),
    [anon_sym_inalloca] = ACTIONS(287),
    [anon_sym_sret] = ACTIONS(287),
    [anon_sym_elementtype] = ACTIONS(287),
    [anon_sym_noalias] = ACTIONS(287),
    [anon_sym_nocapture] = ACTIONS(287),
    [anon_sym_nest] = ACTIONS(287),
    [anon_sym_returned] = ACTIONS(287),
    [anon_sym_nonnull] = ACTIONS(287),
    [anon_sym_dereferenceable] = ACTIONS(289),
    [anon_sym_dereferenceable_or_null] = ACTIONS(287),
    [anon_sym_swiftself] = ACTIONS(289),
    [anon_sym_swiftasync] = ACTIONS(289),
    [anon_sym_swifterror] = ACTIONS(289),
    [anon_sym_immarg] = ACTIONS(287),
    [anon_sym_noundef] = ACTIONS(287),
    [anon_sym_extractelement] = ACTIONS(287),
    [anon_sym_insertelement] = ACTIONS(287),
    [anon_sym_select] = ACTIONS(287),
    [anon_sym_shufflevector] = ACTIONS(287),
    [anon_sym_fneg] = ACTIONS(287),
    [anon_sym_icmp] = ACTIONS(287),
    [anon_sym_fcmp] = ACTIONS(287),
    [anon_sym_getelementptr] = ACTIONS(287),
    [anon_sym_extractvalue] = ACTIONS(287),
    [anon_sym_insertvalue] = ACTIONS(287),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_none] = ACTIONS(287),
    [anon_sym_undef] = ACTIONS(287),
    [anon_sym_poison] = ACTIONS(287),
    [anon_sym_zeroinitializer] = ACTIONS(287),
    [anon_sym_blockaddress] = ACTIONS(287),
    [anon_sym_mul] = ACTIONS(287),
    [anon_sym_urem] = ACTIONS(287),
    [anon_sym_srem] = ACTIONS(287),
    [anon_sym_shl] = ACTIONS(287),
    [anon_sym_udiv] = ACTIONS(287),
    [anon_sym_sdiv] = ACTIONS(287),
    [anon_sym_lshr] = ACTIONS(287),
    [anon_sym_ashr] = ACTIONS(287),
    [anon_sym_fmul] = ACTIONS(287),
    [anon_sym_fdiv] = ACTIONS(287),
    [anon_sym_frem] = ACTIONS(287),
    [anon_sym_xchg] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(287),
    [anon_sym_and] = ACTIONS(287),
    [anon_sym_nand] = ACTIONS(287),
    [anon_sym_or] = ACTIONS(287),
    [anon_sym_xor] = ACTIONS(287),
    [anon_sym_max] = ACTIONS(287),
    [anon_sym_min] = ACTIONS(289),
    [anon_sym_umax] = ACTIONS(287),
    [anon_sym_umin] = ACTIONS(287),
    [anon_sym_fadd] = ACTIONS(287),
    [anon_sym_fsub] = ACTIONS(287),
    [anon_sym_bitcast] = ACTIONS(287),
    [anon_sym_trunc] = ACTIONS(287),
    [anon_sym_zext] = ACTIONS(287),
    [anon_sym_sext] = ACTIONS(287),
    [anon_sym_fptrunc] = ACTIONS(287),
    [anon_sym_fpext] = ACTIONS(287),
    [anon_sym_addrspacecast] = ACTIONS(287),
    [anon_sym_uitofp] = ACTIONS(287),
    [anon_sym_sitofp] = ACTIONS(287),
    [anon_sym_fptoui] = ACTIONS(287),
    [anon_sym_fptosi] = ACTIONS(287),
    [anon_sym_inttoptr] = ACTIONS(287),
    [anon_sym_ptrtoint] = ACTIONS(287),
  },
  [18] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [aux_sym_metadata_ref_token1] = ACTIONS(291),
    [sym_string] = ACTIONS(291),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_internal] = ACTIONS(291),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(291),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(291),
    [anon_sym_available_externally] = ACTIONS(291),
    [anon_sym_appending] = ACTIONS(291),
    [anon_sym_common] = ACTIONS(291),
    [anon_sym_extern_weak] = ACTIONS(291),
    [anon_sym_external] = ACTIONS(291),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(291),
    [anon_sym_dso_preemptable] = ACTIONS(291),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_hidden] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_dllimport] = ACTIONS(291),
    [anon_sym_dllexport] = ACTIONS(291),
    [anon_sym_ccc] = ACTIONS(291),
    [anon_sym_fastcc] = ACTIONS(291),
    [anon_sym_coldcc] = ACTIONS(291),
    [anon_sym_webkit_jscc] = ACTIONS(293),
    [anon_sym_anyregcc] = ACTIONS(291),
    [anon_sym_preserve_mostcc] = ACTIONS(291),
    [anon_sym_preserve_allcc] = ACTIONS(291),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(293),
    [anon_sym_tailcc] = ACTIONS(291),
    [anon_sym_swiftcc] = ACTIONS(293),
    [anon_sym_swifttailcc] = ACTIONS(293),
    [anon_sym_cfguard_checkcc] = ACTIONS(291),
    [aux_sym_calling_conv_token1] = ACTIONS(293),
    [aux_sym_calling_conv_token2] = ACTIONS(291),
    [aux_sym_calling_conv_token3] = ACTIONS(291),
    [aux_sym_calling_conv_token4] = ACTIONS(291),
    [aux_sym_calling_conv_token5] = ACTIONS(291),
    [aux_sym_calling_conv_token6] = ACTIONS(291),
    [aux_sym_calling_conv_token7] = ACTIONS(291),
    [aux_sym_calling_conv_token8] = ACTIONS(291),
    [aux_sym_calling_conv_token9] = ACTIONS(291),
    [aux_sym_calling_conv_token10] = ACTIONS(293),
    [anon_sym_ghccc] = ACTIONS(291),
    [aux_sym_calling_conv_token11] = ACTIONS(293),
    [aux_sym_calling_conv_token12] = ACTIONS(291),
    [aux_sym_calling_conv_token13] = ACTIONS(293),
    [aux_sym_calling_conv_token14] = ACTIONS(291),
    [anon_sym_cc] = ACTIONS(293),
    [anon_sym_unnamed_addr] = ACTIONS(291),
    [anon_sym_local_unnamed_addr] = ACTIONS(291),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_void] = ACTIONS(291),
    [anon_sym_half] = ACTIONS(291),
    [anon_sym_bfloat] = ACTIONS(291),
    [anon_sym_float] = ACTIONS(291),
    [anon_sym_double] = ACTIONS(291),
    [anon_sym_x86_fp80] = ACTIONS(293),
    [anon_sym_fp128] = ACTIONS(291),
    [anon_sym_ppc_fp128] = ACTIONS(291),
    [anon_sym_label] = ACTIONS(291),
    [anon_sym_metadata] = ACTIONS(291),
    [anon_sym_x86_mmx] = ACTIONS(293),
    [anon_sym_x86_amx] = ACTIONS(293),
    [anon_sym_token] = ACTIONS(291),
    [anon_sym_opaque] = ACTIONS(291),
    [anon_sym_ptr] = ACTIONS(293),
    [aux_sym_type_keyword_token1] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE_GT] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_align] = ACTIONS(293),
    [anon_sym_alignstack] = ACTIONS(291),
    [anon_sym_allocsize] = ACTIONS(291),
    [anon_sym_alwaysinline] = ACTIONS(291),
    [anon_sym_builtin] = ACTIONS(291),
    [anon_sym_cold] = ACTIONS(293),
    [anon_sym_convergent] = ACTIONS(291),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(291),
    [anon_sym_hot] = ACTIONS(291),
    [anon_sym_inaccessiblememonly] = ACTIONS(291),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(291),
    [anon_sym_inlinehint] = ACTIONS(291),
    [anon_sym_jumptable] = ACTIONS(291),
    [anon_sym_minsize] = ACTIONS(291),
    [anon_sym_naked] = ACTIONS(291),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(291),
    [anon_sym_nobuiltin] = ACTIONS(291),
    [anon_sym_noduplicate] = ACTIONS(291),
    [anon_sym_nofree] = ACTIONS(291),
    [anon_sym_noimplicitfloat] = ACTIONS(291),
    [anon_sym_noinline] = ACTIONS(291),
    [anon_sym_nomerge] = ACTIONS(291),
    [anon_sym_nonlazybind] = ACTIONS(291),
    [anon_sym_noprofile] = ACTIONS(291),
    [anon_sym_noredzone] = ACTIONS(291),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(291),
    [anon_sym_noreturn] = ACTIONS(291),
    [anon_sym_norecurse] = ACTIONS(291),
    [anon_sym_willreturn] = ACTIONS(291),
    [anon_sym_nosync] = ACTIONS(291),
    [anon_sym_nounwind] = ACTIONS(291),
    [anon_sym_nosanitize_coverage] = ACTIONS(291),
    [anon_sym_null_pointer_is_valid] = ACTIONS(291),
    [anon_sym_optforfuzzing] = ACTIONS(291),
    [anon_sym_optnone] = ACTIONS(291),
    [anon_sym_optsize] = ACTIONS(291),
    [anon_sym_readnone] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_writeonly] = ACTIONS(291),
    [anon_sym_argmemonly] = ACTIONS(291),
    [anon_sym_returns_twice] = ACTIONS(291),
    [anon_sym_safestack] = ACTIONS(291),
    [anon_sym_sanitize_address] = ACTIONS(291),
    [anon_sym_sanitize_memory] = ACTIONS(291),
    [anon_sym_sanitize_thread] = ACTIONS(291),
    [anon_sym_sanitize_hwaddress] = ACTIONS(291),
    [anon_sym_sanitize_memtag] = ACTIONS(291),
    [anon_sym_speculative_load_hardening] = ACTIONS(291),
    [anon_sym_speculatable] = ACTIONS(291),
    [anon_sym_ssp] = ACTIONS(293),
    [anon_sym_sspstrong] = ACTIONS(291),
    [anon_sym_sspreq] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_uwtable] = ACTIONS(291),
    [anon_sym_nocf_check] = ACTIONS(291),
    [anon_sym_shadowcallstack] = ACTIONS(291),
    [anon_sym_mustprogress] = ACTIONS(291),
    [anon_sym_vscale_range] = ACTIONS(291),
    [anon_sym_preallocated] = ACTIONS(291),
    [anon_sym_zeroext] = ACTIONS(291),
    [anon_sym_signext] = ACTIONS(291),
    [anon_sym_inreg] = ACTIONS(291),
    [anon_sym_byval] = ACTIONS(291),
    [anon_sym_byref] = ACTIONS(291),
    [anon_sym_inalloca] = ACTIONS(291),
    [anon_sym_sret] = ACTIONS(291),
    [anon_sym_elementtype] = ACTIONS(291),
    [anon_sym_noalias] = ACTIONS(291),
    [anon_sym_nocapture] = ACTIONS(291),
    [anon_sym_nest] = ACTIONS(291),
    [anon_sym_returned] = ACTIONS(291),
    [anon_sym_nonnull] = ACTIONS(291),
    [anon_sym_dereferenceable] = ACTIONS(293),
    [anon_sym_dereferenceable_or_null] = ACTIONS(291),
    [anon_sym_swiftself] = ACTIONS(293),
    [anon_sym_swiftasync] = ACTIONS(293),
    [anon_sym_swifterror] = ACTIONS(293),
    [anon_sym_immarg] = ACTIONS(291),
    [anon_sym_noundef] = ACTIONS(291),
    [anon_sym_extractelement] = ACTIONS(291),
    [anon_sym_insertelement] = ACTIONS(291),
    [anon_sym_select] = ACTIONS(291),
    [anon_sym_shufflevector] = ACTIONS(291),
    [anon_sym_fneg] = ACTIONS(291),
    [anon_sym_icmp] = ACTIONS(291),
    [anon_sym_fcmp] = ACTIONS(291),
    [anon_sym_getelementptr] = ACTIONS(291),
    [anon_sym_extractvalue] = ACTIONS(291),
    [anon_sym_insertvalue] = ACTIONS(291),
    [anon_sym_true] = ACTIONS(291),
    [anon_sym_false] = ACTIONS(291),
    [anon_sym_null] = ACTIONS(293),
    [anon_sym_none] = ACTIONS(291),
    [anon_sym_undef] = ACTIONS(291),
    [anon_sym_poison] = ACTIONS(291),
    [anon_sym_zeroinitializer] = ACTIONS(291),
    [anon_sym_blockaddress] = ACTIONS(291),
    [anon_sym_mul] = ACTIONS(291),
    [anon_sym_urem] = ACTIONS(291),
    [anon_sym_srem] = ACTIONS(291),
    [anon_sym_shl] = ACTIONS(291),
    [anon_sym_udiv] = ACTIONS(291),
    [anon_sym_sdiv] = ACTIONS(291),
    [anon_sym_lshr] = ACTIONS(291),
    [anon_sym_ashr] = ACTIONS(291),
    [anon_sym_fmul] = ACTIONS(291),
    [anon_sym_fdiv] = ACTIONS(291),
    [anon_sym_frem] = ACTIONS(291),
    [anon_sym_xchg] = ACTIONS(291),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(291),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_nand] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_xor] = ACTIONS(291),
    [anon_sym_max] = ACTIONS(291),
    [anon_sym_min] = ACTIONS(293),
    [anon_sym_umax] = ACTIONS(291),
    [anon_sym_umin] = ACTIONS(291),
    [anon_sym_fadd] = ACTIONS(291),
    [anon_sym_fsub] = ACTIONS(291),
    [anon_sym_bitcast] = ACTIONS(291),
    [anon_sym_trunc] = ACTIONS(291),
    [anon_sym_zext] = ACTIONS(291),
    [anon_sym_sext] = ACTIONS(291),
    [anon_sym_fptrunc] = ACTIONS(291),
    [anon_sym_fpext] = ACTIONS(291),
    [anon_sym_addrspacecast] = ACTIONS(291),
    [anon_sym_uitofp] = ACTIONS(291),
    [anon_sym_sitofp] = ACTIONS(291),
    [anon_sym_fptoui] = ACTIONS(291),
    [anon_sym_fptosi] = ACTIONS(291),
    [anon_sym_inttoptr] = ACTIONS(291),
    [anon_sym_ptrtoint] = ACTIONS(291),
  },
  [19] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [aux_sym_metadata_ref_token1] = ACTIONS(295),
    [sym_string] = ACTIONS(295),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(295),
    [sym_float] = ACTIONS(295),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(295),
    [anon_sym_private] = ACTIONS(295),
    [anon_sym_internal] = ACTIONS(295),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(295),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(295),
    [anon_sym_available_externally] = ACTIONS(295),
    [anon_sym_appending] = ACTIONS(295),
    [anon_sym_common] = ACTIONS(295),
    [anon_sym_extern_weak] = ACTIONS(295),
    [anon_sym_external] = ACTIONS(295),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(295),
    [anon_sym_dso_preemptable] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(295),
    [anon_sym_hidden] = ACTIONS(295),
    [anon_sym_protected] = ACTIONS(295),
    [anon_sym_dllimport] = ACTIONS(295),
    [anon_sym_dllexport] = ACTIONS(295),
    [anon_sym_ccc] = ACTIONS(295),
    [anon_sym_fastcc] = ACTIONS(295),
    [anon_sym_coldcc] = ACTIONS(295),
    [anon_sym_webkit_jscc] = ACTIONS(297),
    [anon_sym_anyregcc] = ACTIONS(295),
    [anon_sym_preserve_mostcc] = ACTIONS(295),
    [anon_sym_preserve_allcc] = ACTIONS(295),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(297),
    [anon_sym_tailcc] = ACTIONS(295),
    [anon_sym_swiftcc] = ACTIONS(297),
    [anon_sym_swifttailcc] = ACTIONS(297),
    [anon_sym_cfguard_checkcc] = ACTIONS(295),
    [aux_sym_calling_conv_token1] = ACTIONS(297),
    [aux_sym_calling_conv_token2] = ACTIONS(295),
    [aux_sym_calling_conv_token3] = ACTIONS(295),
    [aux_sym_calling_conv_token4] = ACTIONS(295),
    [aux_sym_calling_conv_token5] = ACTIONS(295),
    [aux_sym_calling_conv_token6] = ACTIONS(295),
    [aux_sym_calling_conv_token7] = ACTIONS(295),
    [aux_sym_calling_conv_token8] = ACTIONS(295),
    [aux_sym_calling_conv_token9] = ACTIONS(295),
    [aux_sym_calling_conv_token10] = ACTIONS(297),
    [anon_sym_ghccc] = ACTIONS(295),
    [aux_sym_calling_conv_token11] = ACTIONS(297),
    [aux_sym_calling_conv_token12] = ACTIONS(295),
    [aux_sym_calling_conv_token13] = ACTIONS(297),
    [aux_sym_calling_conv_token14] = ACTIONS(295),
    [anon_sym_cc] = ACTIONS(297),
    [anon_sym_unnamed_addr] = ACTIONS(295),
    [anon_sym_local_unnamed_addr] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_void] = ACTIONS(295),
    [anon_sym_half] = ACTIONS(295),
    [anon_sym_bfloat] = ACTIONS(295),
    [anon_sym_float] = ACTIONS(295),
    [anon_sym_double] = ACTIONS(295),
    [anon_sym_x86_fp80] = ACTIONS(297),
    [anon_sym_fp128] = ACTIONS(295),
    [anon_sym_ppc_fp128] = ACTIONS(295),
    [anon_sym_label] = ACTIONS(295),
    [anon_sym_metadata] = ACTIONS(295),
    [anon_sym_x86_mmx] = ACTIONS(297),
    [anon_sym_x86_amx] = ACTIONS(297),
    [anon_sym_token] = ACTIONS(295),
    [anon_sym_opaque] = ACTIONS(295),
    [anon_sym_ptr] = ACTIONS(297),
    [aux_sym_type_keyword_token1] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE_GT] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_align] = ACTIONS(297),
    [anon_sym_alignstack] = ACTIONS(295),
    [anon_sym_allocsize] = ACTIONS(295),
    [anon_sym_alwaysinline] = ACTIONS(295),
    [anon_sym_builtin] = ACTIONS(295),
    [anon_sym_cold] = ACTIONS(297),
    [anon_sym_convergent] = ACTIONS(295),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(295),
    [anon_sym_hot] = ACTIONS(295),
    [anon_sym_inaccessiblememonly] = ACTIONS(295),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(295),
    [anon_sym_inlinehint] = ACTIONS(295),
    [anon_sym_jumptable] = ACTIONS(295),
    [anon_sym_minsize] = ACTIONS(295),
    [anon_sym_naked] = ACTIONS(295),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(295),
    [anon_sym_nobuiltin] = ACTIONS(295),
    [anon_sym_noduplicate] = ACTIONS(295),
    [anon_sym_nofree] = ACTIONS(295),
    [anon_sym_noimplicitfloat] = ACTIONS(295),
    [anon_sym_noinline] = ACTIONS(295),
    [anon_sym_nomerge] = ACTIONS(295),
    [anon_sym_nonlazybind] = ACTIONS(295),
    [anon_sym_noprofile] = ACTIONS(295),
    [anon_sym_noredzone] = ACTIONS(295),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(295),
    [anon_sym_noreturn] = ACTIONS(295),
    [anon_sym_norecurse] = ACTIONS(295),
    [anon_sym_willreturn] = ACTIONS(295),
    [anon_sym_nosync] = ACTIONS(295),
    [anon_sym_nounwind] = ACTIONS(295),
    [anon_sym_nosanitize_coverage] = ACTIONS(295),
    [anon_sym_null_pointer_is_valid] = ACTIONS(295),
    [anon_sym_optforfuzzing] = ACTIONS(295),
    [anon_sym_optnone] = ACTIONS(295),
    [anon_sym_optsize] = ACTIONS(295),
    [anon_sym_readnone] = ACTIONS(295),
    [anon_sym_readonly] = ACTIONS(295),
    [anon_sym_writeonly] = ACTIONS(295),
    [anon_sym_argmemonly] = ACTIONS(295),
    [anon_sym_returns_twice] = ACTIONS(295),
    [anon_sym_safestack] = ACTIONS(295),
    [anon_sym_sanitize_address] = ACTIONS(295),
    [anon_sym_sanitize_memory] = ACTIONS(295),
    [anon_sym_sanitize_thread] = ACTIONS(295),
    [anon_sym_sanitize_hwaddress] = ACTIONS(295),
    [anon_sym_sanitize_memtag] = ACTIONS(295),
    [anon_sym_speculative_load_hardening] = ACTIONS(295),
    [anon_sym_speculatable] = ACTIONS(295),
    [anon_sym_ssp] = ACTIONS(297),
    [anon_sym_sspstrong] = ACTIONS(295),
    [anon_sym_sspreq] = ACTIONS(295),
    [anon_sym_strictfp] = ACTIONS(295),
    [anon_sym_uwtable] = ACTIONS(295),
    [anon_sym_nocf_check] = ACTIONS(295),
    [anon_sym_shadowcallstack] = ACTIONS(295),
    [anon_sym_mustprogress] = ACTIONS(295),
    [anon_sym_vscale_range] = ACTIONS(295),
    [anon_sym_preallocated] = ACTIONS(295),
    [anon_sym_zeroext] = ACTIONS(295),
    [anon_sym_signext] = ACTIONS(295),
    [anon_sym_inreg] = ACTIONS(295),
    [anon_sym_byval] = ACTIONS(295),
    [anon_sym_byref] = ACTIONS(295),
    [anon_sym_inalloca] = ACTIONS(295),
    [anon_sym_sret] = ACTIONS(295),
    [anon_sym_elementtype] = ACTIONS(295),
    [anon_sym_noalias] = ACTIONS(295),
    [anon_sym_nocapture] = ACTIONS(295),
    [anon_sym_nest] = ACTIONS(295),
    [anon_sym_returned] = ACTIONS(295),
    [anon_sym_nonnull] = ACTIONS(295),
    [anon_sym_dereferenceable] = ACTIONS(297),
    [anon_sym_dereferenceable_or_null] = ACTIONS(295),
    [anon_sym_swiftself] = ACTIONS(297),
    [anon_sym_swiftasync] = ACTIONS(297),
    [anon_sym_swifterror] = ACTIONS(297),
    [anon_sym_immarg] = ACTIONS(295),
    [anon_sym_noundef] = ACTIONS(295),
    [anon_sym_extractelement] = ACTIONS(295),
    [anon_sym_insertelement] = ACTIONS(295),
    [anon_sym_select] = ACTIONS(295),
    [anon_sym_shufflevector] = ACTIONS(295),
    [anon_sym_fneg] = ACTIONS(295),
    [anon_sym_icmp] = ACTIONS(295),
    [anon_sym_fcmp] = ACTIONS(295),
    [anon_sym_getelementptr] = ACTIONS(295),
    [anon_sym_extractvalue] = ACTIONS(295),
    [anon_sym_insertvalue] = ACTIONS(295),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(297),
    [anon_sym_none] = ACTIONS(295),
    [anon_sym_undef] = ACTIONS(295),
    [anon_sym_poison] = ACTIONS(295),
    [anon_sym_zeroinitializer] = ACTIONS(295),
    [anon_sym_blockaddress] = ACTIONS(295),
    [anon_sym_mul] = ACTIONS(295),
    [anon_sym_urem] = ACTIONS(295),
    [anon_sym_srem] = ACTIONS(295),
    [anon_sym_shl] = ACTIONS(295),
    [anon_sym_udiv] = ACTIONS(295),
    [anon_sym_sdiv] = ACTIONS(295),
    [anon_sym_lshr] = ACTIONS(295),
    [anon_sym_ashr] = ACTIONS(295),
    [anon_sym_fmul] = ACTIONS(295),
    [anon_sym_fdiv] = ACTIONS(295),
    [anon_sym_frem] = ACTIONS(295),
    [anon_sym_xchg] = ACTIONS(295),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(295),
    [anon_sym_nand] = ACTIONS(295),
    [anon_sym_or] = ACTIONS(295),
    [anon_sym_xor] = ACTIONS(295),
    [anon_sym_max] = ACTIONS(295),
    [anon_sym_min] = ACTIONS(297),
    [anon_sym_umax] = ACTIONS(295),
    [anon_sym_umin] = ACTIONS(295),
    [anon_sym_fadd] = ACTIONS(295),
    [anon_sym_fsub] = ACTIONS(295),
    [anon_sym_bitcast] = ACTIONS(295),
    [anon_sym_trunc] = ACTIONS(295),
    [anon_sym_zext] = ACTIONS(295),
    [anon_sym_sext] = ACTIONS(295),
    [anon_sym_fptrunc] = ACTIONS(295),
    [anon_sym_fpext] = ACTIONS(295),
    [anon_sym_addrspacecast] = ACTIONS(295),
    [anon_sym_uitofp] = ACTIONS(295),
    [anon_sym_sitofp] = ACTIONS(295),
    [anon_sym_fptoui] = ACTIONS(295),
    [anon_sym_fptosi] = ACTIONS(295),
    [anon_sym_inttoptr] = ACTIONS(295),
    [anon_sym_ptrtoint] = ACTIONS(295),
  },
  [20] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [aux_sym_metadata_ref_token1] = ACTIONS(299),
    [sym_string] = ACTIONS(299),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(299),
    [sym_float] = ACTIONS(299),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_internal] = ACTIONS(299),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(299),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(299),
    [anon_sym_available_externally] = ACTIONS(299),
    [anon_sym_appending] = ACTIONS(299),
    [anon_sym_common] = ACTIONS(299),
    [anon_sym_extern_weak] = ACTIONS(299),
    [anon_sym_external] = ACTIONS(299),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(299),
    [anon_sym_dso_preemptable] = ACTIONS(299),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_hidden] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_dllimport] = ACTIONS(299),
    [anon_sym_dllexport] = ACTIONS(299),
    [anon_sym_ccc] = ACTIONS(299),
    [anon_sym_fastcc] = ACTIONS(299),
    [anon_sym_coldcc] = ACTIONS(299),
    [anon_sym_webkit_jscc] = ACTIONS(301),
    [anon_sym_anyregcc] = ACTIONS(299),
    [anon_sym_preserve_mostcc] = ACTIONS(299),
    [anon_sym_preserve_allcc] = ACTIONS(299),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(301),
    [anon_sym_tailcc] = ACTIONS(299),
    [anon_sym_swiftcc] = ACTIONS(301),
    [anon_sym_swifttailcc] = ACTIONS(301),
    [anon_sym_cfguard_checkcc] = ACTIONS(299),
    [aux_sym_calling_conv_token1] = ACTIONS(301),
    [aux_sym_calling_conv_token2] = ACTIONS(299),
    [aux_sym_calling_conv_token3] = ACTIONS(299),
    [aux_sym_calling_conv_token4] = ACTIONS(299),
    [aux_sym_calling_conv_token5] = ACTIONS(299),
    [aux_sym_calling_conv_token6] = ACTIONS(299),
    [aux_sym_calling_conv_token7] = ACTIONS(299),
    [aux_sym_calling_conv_token8] = ACTIONS(299),
    [aux_sym_calling_conv_token9] = ACTIONS(299),
    [aux_sym_calling_conv_token10] = ACTIONS(301),
    [anon_sym_ghccc] = ACTIONS(299),
    [aux_sym_calling_conv_token11] = ACTIONS(301),
    [aux_sym_calling_conv_token12] = ACTIONS(299),
    [aux_sym_calling_conv_token13] = ACTIONS(301),
    [aux_sym_calling_conv_token14] = ACTIONS(299),
    [anon_sym_cc] = ACTIONS(301),
    [anon_sym_unnamed_addr] = ACTIONS(299),
    [anon_sym_local_unnamed_addr] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_void] = ACTIONS(299),
    [anon_sym_half] = ACTIONS(299),
    [anon_sym_bfloat] = ACTIONS(299),
    [anon_sym_float] = ACTIONS(299),
    [anon_sym_double] = ACTIONS(299),
    [anon_sym_x86_fp80] = ACTIONS(301),
    [anon_sym_fp128] = ACTIONS(299),
    [anon_sym_ppc_fp128] = ACTIONS(299),
    [anon_sym_label] = ACTIONS(299),
    [anon_sym_metadata] = ACTIONS(299),
    [anon_sym_x86_mmx] = ACTIONS(301),
    [anon_sym_x86_amx] = ACTIONS(301),
    [anon_sym_token] = ACTIONS(299),
    [anon_sym_opaque] = ACTIONS(299),
    [anon_sym_ptr] = ACTIONS(301),
    [aux_sym_type_keyword_token1] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE_GT] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_align] = ACTIONS(301),
    [anon_sym_alignstack] = ACTIONS(299),
    [anon_sym_allocsize] = ACTIONS(299),
    [anon_sym_alwaysinline] = ACTIONS(299),
    [anon_sym_builtin] = ACTIONS(299),
    [anon_sym_cold] = ACTIONS(301),
    [anon_sym_convergent] = ACTIONS(299),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(299),
    [anon_sym_hot] = ACTIONS(299),
    [anon_sym_inaccessiblememonly] = ACTIONS(299),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(299),
    [anon_sym_inlinehint] = ACTIONS(299),
    [anon_sym_jumptable] = ACTIONS(299),
    [anon_sym_minsize] = ACTIONS(299),
    [anon_sym_naked] = ACTIONS(299),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(299),
    [anon_sym_nobuiltin] = ACTIONS(299),
    [anon_sym_noduplicate] = ACTIONS(299),
    [anon_sym_nofree] = ACTIONS(299),
    [anon_sym_noimplicitfloat] = ACTIONS(299),
    [anon_sym_noinline] = ACTIONS(299),
    [anon_sym_nomerge] = ACTIONS(299),
    [anon_sym_nonlazybind] = ACTIONS(299),
    [anon_sym_noprofile] = ACTIONS(299),
    [anon_sym_noredzone] = ACTIONS(299),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(299),
    [anon_sym_noreturn] = ACTIONS(299),
    [anon_sym_norecurse] = ACTIONS(299),
    [anon_sym_willreturn] = ACTIONS(299),
    [anon_sym_nosync] = ACTIONS(299),
    [anon_sym_nounwind] = ACTIONS(299),
    [anon_sym_nosanitize_coverage] = ACTIONS(299),
    [anon_sym_null_pointer_is_valid] = ACTIONS(299),
    [anon_sym_optforfuzzing] = ACTIONS(299),
    [anon_sym_optnone] = ACTIONS(299),
    [anon_sym_optsize] = ACTIONS(299),
    [anon_sym_readnone] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_writeonly] = ACTIONS(299),
    [anon_sym_argmemonly] = ACTIONS(299),
    [anon_sym_returns_twice] = ACTIONS(299),
    [anon_sym_safestack] = ACTIONS(299),
    [anon_sym_sanitize_address] = ACTIONS(299),
    [anon_sym_sanitize_memory] = ACTIONS(299),
    [anon_sym_sanitize_thread] = ACTIONS(299),
    [anon_sym_sanitize_hwaddress] = ACTIONS(299),
    [anon_sym_sanitize_memtag] = ACTIONS(299),
    [anon_sym_speculative_load_hardening] = ACTIONS(299),
    [anon_sym_speculatable] = ACTIONS(299),
    [anon_sym_ssp] = ACTIONS(301),
    [anon_sym_sspstrong] = ACTIONS(299),
    [anon_sym_sspreq] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_uwtable] = ACTIONS(299),
    [anon_sym_nocf_check] = ACTIONS(299),
    [anon_sym_shadowcallstack] = ACTIONS(299),
    [anon_sym_mustprogress] = ACTIONS(299),
    [anon_sym_vscale_range] = ACTIONS(299),
    [anon_sym_preallocated] = ACTIONS(299),
    [anon_sym_zeroext] = ACTIONS(299),
    [anon_sym_signext] = ACTIONS(299),
    [anon_sym_inreg] = ACTIONS(299),
    [anon_sym_byval] = ACTIONS(299),
    [anon_sym_byref] = ACTIONS(299),
    [anon_sym_inalloca] = ACTIONS(299),
    [anon_sym_sret] = ACTIONS(299),
    [anon_sym_elementtype] = ACTIONS(299),
    [anon_sym_noalias] = ACTIONS(299),
    [anon_sym_nocapture] = ACTIONS(299),
    [anon_sym_nest] = ACTIONS(299),
    [anon_sym_returned] = ACTIONS(299),
    [anon_sym_nonnull] = ACTIONS(299),
    [anon_sym_dereferenceable] = ACTIONS(301),
    [anon_sym_dereferenceable_or_null] = ACTIONS(299),
    [anon_sym_swiftself] = ACTIONS(301),
    [anon_sym_swiftasync] = ACTIONS(301),
    [anon_sym_swifterror] = ACTIONS(301),
    [anon_sym_immarg] = ACTIONS(299),
    [anon_sym_noundef] = ACTIONS(299),
    [anon_sym_extractelement] = ACTIONS(299),
    [anon_sym_insertelement] = ACTIONS(299),
    [anon_sym_select] = ACTIONS(299),
    [anon_sym_shufflevector] = ACTIONS(299),
    [anon_sym_fneg] = ACTIONS(299),
    [anon_sym_icmp] = ACTIONS(299),
    [anon_sym_fcmp] = ACTIONS(299),
    [anon_sym_getelementptr] = ACTIONS(299),
    [anon_sym_extractvalue] = ACTIONS(299),
    [anon_sym_insertvalue] = ACTIONS(299),
    [anon_sym_true] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_none] = ACTIONS(299),
    [anon_sym_undef] = ACTIONS(299),
    [anon_sym_poison] = ACTIONS(299),
    [anon_sym_zeroinitializer] = ACTIONS(299),
    [anon_sym_blockaddress] = ACTIONS(299),
    [anon_sym_mul] = ACTIONS(299),
    [anon_sym_urem] = ACTIONS(299),
    [anon_sym_srem] = ACTIONS(299),
    [anon_sym_shl] = ACTIONS(299),
    [anon_sym_udiv] = ACTIONS(299),
    [anon_sym_sdiv] = ACTIONS(299),
    [anon_sym_lshr] = ACTIONS(299),
    [anon_sym_ashr] = ACTIONS(299),
    [anon_sym_fmul] = ACTIONS(299),
    [anon_sym_fdiv] = ACTIONS(299),
    [anon_sym_frem] = ACTIONS(299),
    [anon_sym_xchg] = ACTIONS(299),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(299),
    [anon_sym_nand] = ACTIONS(299),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_xor] = ACTIONS(299),
    [anon_sym_max] = ACTIONS(299),
    [anon_sym_min] = ACTIONS(301),
    [anon_sym_umax] = ACTIONS(299),
    [anon_sym_umin] = ACTIONS(299),
    [anon_sym_fadd] = ACTIONS(299),
    [anon_sym_fsub] = ACTIONS(299),
    [anon_sym_bitcast] = ACTIONS(299),
    [anon_sym_trunc] = ACTIONS(299),
    [anon_sym_zext] = ACTIONS(299),
    [anon_sym_sext] = ACTIONS(299),
    [anon_sym_fptrunc] = ACTIONS(299),
    [anon_sym_fpext] = ACTIONS(299),
    [anon_sym_addrspacecast] = ACTIONS(299),
    [anon_sym_uitofp] = ACTIONS(299),
    [anon_sym_sitofp] = ACTIONS(299),
    [anon_sym_fptoui] = ACTIONS(299),
    [anon_sym_fptosi] = ACTIONS(299),
    [anon_sym_inttoptr] = ACTIONS(299),
    [anon_sym_ptrtoint] = ACTIONS(299),
  },
  [21] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [aux_sym_metadata_ref_token1] = ACTIONS(303),
    [sym_string] = ACTIONS(303),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(303),
    [sym_float] = ACTIONS(303),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(303),
    [anon_sym_private] = ACTIONS(303),
    [anon_sym_internal] = ACTIONS(303),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(303),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(303),
    [anon_sym_available_externally] = ACTIONS(303),
    [anon_sym_appending] = ACTIONS(303),
    [anon_sym_common] = ACTIONS(303),
    [anon_sym_extern_weak] = ACTIONS(303),
    [anon_sym_external] = ACTIONS(303),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(303),
    [anon_sym_dso_preemptable] = ACTIONS(303),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_hidden] = ACTIONS(303),
    [anon_sym_protected] = ACTIONS(303),
    [anon_sym_dllimport] = ACTIONS(303),
    [anon_sym_dllexport] = ACTIONS(303),
    [anon_sym_ccc] = ACTIONS(303),
    [anon_sym_fastcc] = ACTIONS(303),
    [anon_sym_coldcc] = ACTIONS(303),
    [anon_sym_webkit_jscc] = ACTIONS(305),
    [anon_sym_anyregcc] = ACTIONS(303),
    [anon_sym_preserve_mostcc] = ACTIONS(303),
    [anon_sym_preserve_allcc] = ACTIONS(303),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(305),
    [anon_sym_tailcc] = ACTIONS(303),
    [anon_sym_swiftcc] = ACTIONS(305),
    [anon_sym_swifttailcc] = ACTIONS(305),
    [anon_sym_cfguard_checkcc] = ACTIONS(303),
    [aux_sym_calling_conv_token1] = ACTIONS(305),
    [aux_sym_calling_conv_token2] = ACTIONS(303),
    [aux_sym_calling_conv_token3] = ACTIONS(303),
    [aux_sym_calling_conv_token4] = ACTIONS(303),
    [aux_sym_calling_conv_token5] = ACTIONS(303),
    [aux_sym_calling_conv_token6] = ACTIONS(303),
    [aux_sym_calling_conv_token7] = ACTIONS(303),
    [aux_sym_calling_conv_token8] = ACTIONS(303),
    [aux_sym_calling_conv_token9] = ACTIONS(303),
    [aux_sym_calling_conv_token10] = ACTIONS(305),
    [anon_sym_ghccc] = ACTIONS(303),
    [aux_sym_calling_conv_token11] = ACTIONS(305),
    [aux_sym_calling_conv_token12] = ACTIONS(303),
    [aux_sym_calling_conv_token13] = ACTIONS(305),
    [aux_sym_calling_conv_token14] = ACTIONS(303),
    [anon_sym_cc] = ACTIONS(305),
    [anon_sym_unnamed_addr] = ACTIONS(303),
    [anon_sym_local_unnamed_addr] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_void] = ACTIONS(303),
    [anon_sym_half] = ACTIONS(303),
    [anon_sym_bfloat] = ACTIONS(303),
    [anon_sym_float] = ACTIONS(303),
    [anon_sym_double] = ACTIONS(303),
    [anon_sym_x86_fp80] = ACTIONS(305),
    [anon_sym_fp128] = ACTIONS(303),
    [anon_sym_ppc_fp128] = ACTIONS(303),
    [anon_sym_label] = ACTIONS(303),
    [anon_sym_metadata] = ACTIONS(303),
    [anon_sym_x86_mmx] = ACTIONS(305),
    [anon_sym_x86_amx] = ACTIONS(305),
    [anon_sym_token] = ACTIONS(303),
    [anon_sym_opaque] = ACTIONS(303),
    [anon_sym_ptr] = ACTIONS(305),
    [aux_sym_type_keyword_token1] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE_GT] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_align] = ACTIONS(305),
    [anon_sym_alignstack] = ACTIONS(303),
    [anon_sym_allocsize] = ACTIONS(303),
    [anon_sym_alwaysinline] = ACTIONS(303),
    [anon_sym_builtin] = ACTIONS(303),
    [anon_sym_cold] = ACTIONS(305),
    [anon_sym_convergent] = ACTIONS(303),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(303),
    [anon_sym_hot] = ACTIONS(303),
    [anon_sym_inaccessiblememonly] = ACTIONS(303),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(303),
    [anon_sym_inlinehint] = ACTIONS(303),
    [anon_sym_jumptable] = ACTIONS(303),
    [anon_sym_minsize] = ACTIONS(303),
    [anon_sym_naked] = ACTIONS(303),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(303),
    [anon_sym_nobuiltin] = ACTIONS(303),
    [anon_sym_noduplicate] = ACTIONS(303),
    [anon_sym_nofree] = ACTIONS(303),
    [anon_sym_noimplicitfloat] = ACTIONS(303),
    [anon_sym_noinline] = ACTIONS(303),
    [anon_sym_nomerge] = ACTIONS(303),
    [anon_sym_nonlazybind] = ACTIONS(303),
    [anon_sym_noprofile] = ACTIONS(303),
    [anon_sym_noredzone] = ACTIONS(303),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(303),
    [anon_sym_noreturn] = ACTIONS(303),
    [anon_sym_norecurse] = ACTIONS(303),
    [anon_sym_willreturn] = ACTIONS(303),
    [anon_sym_nosync] = ACTIONS(303),
    [anon_sym_nounwind] = ACTIONS(303),
    [anon_sym_nosanitize_coverage] = ACTIONS(303),
    [anon_sym_null_pointer_is_valid] = ACTIONS(303),
    [anon_sym_optforfuzzing] = ACTIONS(303),
    [anon_sym_optnone] = ACTIONS(303),
    [anon_sym_optsize] = ACTIONS(303),
    [anon_sym_readnone] = ACTIONS(303),
    [anon_sym_readonly] = ACTIONS(303),
    [anon_sym_writeonly] = ACTIONS(303),
    [anon_sym_argmemonly] = ACTIONS(303),
    [anon_sym_returns_twice] = ACTIONS(303),
    [anon_sym_safestack] = ACTIONS(303),
    [anon_sym_sanitize_address] = ACTIONS(303),
    [anon_sym_sanitize_memory] = ACTIONS(303),
    [anon_sym_sanitize_thread] = ACTIONS(303),
    [anon_sym_sanitize_hwaddress] = ACTIONS(303),
    [anon_sym_sanitize_memtag] = ACTIONS(303),
    [anon_sym_speculative_load_hardening] = ACTIONS(303),
    [anon_sym_speculatable] = ACTIONS(303),
    [anon_sym_ssp] = ACTIONS(305),
    [anon_sym_sspstrong] = ACTIONS(303),
    [anon_sym_sspreq] = ACTIONS(303),
    [anon_sym_strictfp] = ACTIONS(303),
    [anon_sym_uwtable] = ACTIONS(303),
    [anon_sym_nocf_check] = ACTIONS(303),
    [anon_sym_shadowcallstack] = ACTIONS(303),
    [anon_sym_mustprogress] = ACTIONS(303),
    [anon_sym_vscale_range] = ACTIONS(303),
    [anon_sym_preallocated] = ACTIONS(303),
    [anon_sym_zeroext] = ACTIONS(303),
    [anon_sym_signext] = ACTIONS(303),
    [anon_sym_inreg] = ACTIONS(303),
    [anon_sym_byval] = ACTIONS(303),
    [anon_sym_byref] = ACTIONS(303),
    [anon_sym_inalloca] = ACTIONS(303),
    [anon_sym_sret] = ACTIONS(303),
    [anon_sym_elementtype] = ACTIONS(303),
    [anon_sym_noalias] = ACTIONS(303),
    [anon_sym_nocapture] = ACTIONS(303),
    [anon_sym_nest] = ACTIONS(303),
    [anon_sym_returned] = ACTIONS(303),
    [anon_sym_nonnull] = ACTIONS(303),
    [anon_sym_dereferenceable] = ACTIONS(305),
    [anon_sym_dereferenceable_or_null] = ACTIONS(303),
    [anon_sym_swiftself] = ACTIONS(305),
    [anon_sym_swiftasync] = ACTIONS(305),
    [anon_sym_swifterror] = ACTIONS(305),
    [anon_sym_immarg] = ACTIONS(303),
    [anon_sym_noundef] = ACTIONS(303),
    [anon_sym_extractelement] = ACTIONS(303),
    [anon_sym_insertelement] = ACTIONS(303),
    [anon_sym_select] = ACTIONS(303),
    [anon_sym_shufflevector] = ACTIONS(303),
    [anon_sym_fneg] = ACTIONS(303),
    [anon_sym_icmp] = ACTIONS(303),
    [anon_sym_fcmp] = ACTIONS(303),
    [anon_sym_getelementptr] = ACTIONS(303),
    [anon_sym_extractvalue] = ACTIONS(303),
    [anon_sym_insertvalue] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_null] = ACTIONS(305),
    [anon_sym_none] = ACTIONS(303),
    [anon_sym_undef] = ACTIONS(303),
    [anon_sym_poison] = ACTIONS(303),
    [anon_sym_zeroinitializer] = ACTIONS(303),
    [anon_sym_blockaddress] = ACTIONS(303),
    [anon_sym_mul] = ACTIONS(303),
    [anon_sym_urem] = ACTIONS(303),
    [anon_sym_srem] = ACTIONS(303),
    [anon_sym_shl] = ACTIONS(303),
    [anon_sym_udiv] = ACTIONS(303),
    [anon_sym_sdiv] = ACTIONS(303),
    [anon_sym_lshr] = ACTIONS(303),
    [anon_sym_ashr] = ACTIONS(303),
    [anon_sym_fmul] = ACTIONS(303),
    [anon_sym_fdiv] = ACTIONS(303),
    [anon_sym_frem] = ACTIONS(303),
    [anon_sym_xchg] = ACTIONS(303),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_nand] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_xor] = ACTIONS(303),
    [anon_sym_max] = ACTIONS(303),
    [anon_sym_min] = ACTIONS(305),
    [anon_sym_umax] = ACTIONS(303),
    [anon_sym_umin] = ACTIONS(303),
    [anon_sym_fadd] = ACTIONS(303),
    [anon_sym_fsub] = ACTIONS(303),
    [anon_sym_bitcast] = ACTIONS(303),
    [anon_sym_trunc] = ACTIONS(303),
    [anon_sym_zext] = ACTIONS(303),
    [anon_sym_sext] = ACTIONS(303),
    [anon_sym_fptrunc] = ACTIONS(303),
    [anon_sym_fpext] = ACTIONS(303),
    [anon_sym_addrspacecast] = ACTIONS(303),
    [anon_sym_uitofp] = ACTIONS(303),
    [anon_sym_sitofp] = ACTIONS(303),
    [anon_sym_fptoui] = ACTIONS(303),
    [anon_sym_fptosi] = ACTIONS(303),
    [anon_sym_inttoptr] = ACTIONS(303),
    [anon_sym_ptrtoint] = ACTIONS(303),
  },
  [22] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [aux_sym_metadata_ref_token1] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(307),
    [sym_float] = ACTIONS(307),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(307),
    [anon_sym_private] = ACTIONS(307),
    [anon_sym_internal] = ACTIONS(307),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(307),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(307),
    [anon_sym_available_externally] = ACTIONS(307),
    [anon_sym_appending] = ACTIONS(307),
    [anon_sym_common] = ACTIONS(307),
    [anon_sym_extern_weak] = ACTIONS(307),
    [anon_sym_external] = ACTIONS(307),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(307),
    [anon_sym_dso_preemptable] = ACTIONS(307),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_hidden] = ACTIONS(307),
    [anon_sym_protected] = ACTIONS(307),
    [anon_sym_dllimport] = ACTIONS(307),
    [anon_sym_dllexport] = ACTIONS(307),
    [anon_sym_ccc] = ACTIONS(307),
    [anon_sym_fastcc] = ACTIONS(307),
    [anon_sym_coldcc] = ACTIONS(307),
    [anon_sym_webkit_jscc] = ACTIONS(309),
    [anon_sym_anyregcc] = ACTIONS(307),
    [anon_sym_preserve_mostcc] = ACTIONS(307),
    [anon_sym_preserve_allcc] = ACTIONS(307),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(309),
    [anon_sym_tailcc] = ACTIONS(307),
    [anon_sym_swiftcc] = ACTIONS(309),
    [anon_sym_swifttailcc] = ACTIONS(309),
    [anon_sym_cfguard_checkcc] = ACTIONS(307),
    [aux_sym_calling_conv_token1] = ACTIONS(309),
    [aux_sym_calling_conv_token2] = ACTIONS(307),
    [aux_sym_calling_conv_token3] = ACTIONS(307),
    [aux_sym_calling_conv_token4] = ACTIONS(307),
    [aux_sym_calling_conv_token5] = ACTIONS(307),
    [aux_sym_calling_conv_token6] = ACTIONS(307),
    [aux_sym_calling_conv_token7] = ACTIONS(307),
    [aux_sym_calling_conv_token8] = ACTIONS(307),
    [aux_sym_calling_conv_token9] = ACTIONS(307),
    [aux_sym_calling_conv_token10] = ACTIONS(309),
    [anon_sym_ghccc] = ACTIONS(307),
    [aux_sym_calling_conv_token11] = ACTIONS(309),
    [aux_sym_calling_conv_token12] = ACTIONS(307),
    [aux_sym_calling_conv_token13] = ACTIONS(309),
    [aux_sym_calling_conv_token14] = ACTIONS(307),
    [anon_sym_cc] = ACTIONS(309),
    [anon_sym_unnamed_addr] = ACTIONS(307),
    [anon_sym_local_unnamed_addr] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_void] = ACTIONS(307),
    [anon_sym_half] = ACTIONS(307),
    [anon_sym_bfloat] = ACTIONS(307),
    [anon_sym_float] = ACTIONS(307),
    [anon_sym_double] = ACTIONS(307),
    [anon_sym_x86_fp80] = ACTIONS(309),
    [anon_sym_fp128] = ACTIONS(307),
    [anon_sym_ppc_fp128] = ACTIONS(307),
    [anon_sym_label] = ACTIONS(307),
    [anon_sym_metadata] = ACTIONS(307),
    [anon_sym_x86_mmx] = ACTIONS(309),
    [anon_sym_x86_amx] = ACTIONS(309),
    [anon_sym_token] = ACTIONS(307),
    [anon_sym_opaque] = ACTIONS(307),
    [anon_sym_ptr] = ACTIONS(309),
    [aux_sym_type_keyword_token1] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE_GT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_align] = ACTIONS(309),
    [anon_sym_alignstack] = ACTIONS(307),
    [anon_sym_allocsize] = ACTIONS(307),
    [anon_sym_alwaysinline] = ACTIONS(307),
    [anon_sym_builtin] = ACTIONS(307),
    [anon_sym_cold] = ACTIONS(309),
    [anon_sym_convergent] = ACTIONS(307),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(307),
    [anon_sym_hot] = ACTIONS(307),
    [anon_sym_inaccessiblememonly] = ACTIONS(307),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(307),
    [anon_sym_inlinehint] = ACTIONS(307),
    [anon_sym_jumptable] = ACTIONS(307),
    [anon_sym_minsize] = ACTIONS(307),
    [anon_sym_naked] = ACTIONS(307),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(307),
    [anon_sym_nobuiltin] = ACTIONS(307),
    [anon_sym_noduplicate] = ACTIONS(307),
    [anon_sym_nofree] = ACTIONS(307),
    [anon_sym_noimplicitfloat] = ACTIONS(307),
    [anon_sym_noinline] = ACTIONS(307),
    [anon_sym_nomerge] = ACTIONS(307),
    [anon_sym_nonlazybind] = ACTIONS(307),
    [anon_sym_noprofile] = ACTIONS(307),
    [anon_sym_noredzone] = ACTIONS(307),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(307),
    [anon_sym_noreturn] = ACTIONS(307),
    [anon_sym_norecurse] = ACTIONS(307),
    [anon_sym_willreturn] = ACTIONS(307),
    [anon_sym_nosync] = ACTIONS(307),
    [anon_sym_nounwind] = ACTIONS(307),
    [anon_sym_nosanitize_coverage] = ACTIONS(307),
    [anon_sym_null_pointer_is_valid] = ACTIONS(307),
    [anon_sym_optforfuzzing] = ACTIONS(307),
    [anon_sym_optnone] = ACTIONS(307),
    [anon_sym_optsize] = ACTIONS(307),
    [anon_sym_readnone] = ACTIONS(307),
    [anon_sym_readonly] = ACTIONS(307),
    [anon_sym_writeonly] = ACTIONS(307),
    [anon_sym_argmemonly] = ACTIONS(307),
    [anon_sym_returns_twice] = ACTIONS(307),
    [anon_sym_safestack] = ACTIONS(307),
    [anon_sym_sanitize_address] = ACTIONS(307),
    [anon_sym_sanitize_memory] = ACTIONS(307),
    [anon_sym_sanitize_thread] = ACTIONS(307),
    [anon_sym_sanitize_hwaddress] = ACTIONS(307),
    [anon_sym_sanitize_memtag] = ACTIONS(307),
    [anon_sym_speculative_load_hardening] = ACTIONS(307),
    [anon_sym_speculatable] = ACTIONS(307),
    [anon_sym_ssp] = ACTIONS(309),
    [anon_sym_sspstrong] = ACTIONS(307),
    [anon_sym_sspreq] = ACTIONS(307),
    [anon_sym_strictfp] = ACTIONS(307),
    [anon_sym_uwtable] = ACTIONS(307),
    [anon_sym_nocf_check] = ACTIONS(307),
    [anon_sym_shadowcallstack] = ACTIONS(307),
    [anon_sym_mustprogress] = ACTIONS(307),
    [anon_sym_vscale_range] = ACTIONS(307),
    [anon_sym_preallocated] = ACTIONS(307),
    [anon_sym_zeroext] = ACTIONS(307),
    [anon_sym_signext] = ACTIONS(307),
    [anon_sym_inreg] = ACTIONS(307),
    [anon_sym_byval] = ACTIONS(307),
    [anon_sym_byref] = ACTIONS(307),
    [anon_sym_inalloca] = ACTIONS(307),
    [anon_sym_sret] = ACTIONS(307),
    [anon_sym_elementtype] = ACTIONS(307),
    [anon_sym_noalias] = ACTIONS(307),
    [anon_sym_nocapture] = ACTIONS(307),
    [anon_sym_nest] = ACTIONS(307),
    [anon_sym_returned] = ACTIONS(307),
    [anon_sym_nonnull] = ACTIONS(307),
    [anon_sym_dereferenceable] = ACTIONS(309),
    [anon_sym_dereferenceable_or_null] = ACTIONS(307),
    [anon_sym_swiftself] = ACTIONS(309),
    [anon_sym_swiftasync] = ACTIONS(309),
    [anon_sym_swifterror] = ACTIONS(309),
    [anon_sym_immarg] = ACTIONS(307),
    [anon_sym_noundef] = ACTIONS(307),
    [anon_sym_extractelement] = ACTIONS(307),
    [anon_sym_insertelement] = ACTIONS(307),
    [anon_sym_select] = ACTIONS(307),
    [anon_sym_shufflevector] = ACTIONS(307),
    [anon_sym_fneg] = ACTIONS(307),
    [anon_sym_icmp] = ACTIONS(307),
    [anon_sym_fcmp] = ACTIONS(307),
    [anon_sym_getelementptr] = ACTIONS(307),
    [anon_sym_extractvalue] = ACTIONS(307),
    [anon_sym_insertvalue] = ACTIONS(307),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [anon_sym_null] = ACTIONS(309),
    [anon_sym_none] = ACTIONS(307),
    [anon_sym_undef] = ACTIONS(307),
    [anon_sym_poison] = ACTIONS(307),
    [anon_sym_zeroinitializer] = ACTIONS(307),
    [anon_sym_blockaddress] = ACTIONS(307),
    [anon_sym_mul] = ACTIONS(307),
    [anon_sym_urem] = ACTIONS(307),
    [anon_sym_srem] = ACTIONS(307),
    [anon_sym_shl] = ACTIONS(307),
    [anon_sym_udiv] = ACTIONS(307),
    [anon_sym_sdiv] = ACTIONS(307),
    [anon_sym_lshr] = ACTIONS(307),
    [anon_sym_ashr] = ACTIONS(307),
    [anon_sym_fmul] = ACTIONS(307),
    [anon_sym_fdiv] = ACTIONS(307),
    [anon_sym_frem] = ACTIONS(307),
    [anon_sym_xchg] = ACTIONS(307),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(307),
    [anon_sym_and] = ACTIONS(307),
    [anon_sym_nand] = ACTIONS(307),
    [anon_sym_or] = ACTIONS(307),
    [anon_sym_xor] = ACTIONS(307),
    [anon_sym_max] = ACTIONS(307),
    [anon_sym_min] = ACTIONS(309),
    [anon_sym_umax] = ACTIONS(307),
    [anon_sym_umin] = ACTIONS(307),
    [anon_sym_fadd] = ACTIONS(307),
    [anon_sym_fsub] = ACTIONS(307),
    [anon_sym_bitcast] = ACTIONS(307),
    [anon_sym_trunc] = ACTIONS(307),
    [anon_sym_zext] = ACTIONS(307),
    [anon_sym_sext] = ACTIONS(307),
    [anon_sym_fptrunc] = ACTIONS(307),
    [anon_sym_fpext] = ACTIONS(307),
    [anon_sym_addrspacecast] = ACTIONS(307),
    [anon_sym_uitofp] = ACTIONS(307),
    [anon_sym_sitofp] = ACTIONS(307),
    [anon_sym_fptoui] = ACTIONS(307),
    [anon_sym_fptosi] = ACTIONS(307),
    [anon_sym_inttoptr] = ACTIONS(307),
    [anon_sym_ptrtoint] = ACTIONS(307),
  },
  [23] = {
    [sym_number] = STATE(317),
    [sym_var] = STATE(317),
    [sym_linkage] = STATE(750),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(321),
    [sym__primitive_value] = STATE(317),
    [sym_struct_value] = STATE(317),
    [sym_packed_struct_value] = STATE(317),
    [sym_array_value] = STATE(317),
    [sym_vector_value] = STATE(317),
    [sym_blockaddress] = STATE(317),
    [sym_constant_expr] = STATE(317),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [aux_sym_function_header_repeat1] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(38),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_comdat_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(311),
    [sym_local_var] = ACTIONS(311),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_summary_ref] = ACTIONS(38),
    [sym_string] = ACTIONS(314),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(321),
    [sym_cstring] = ACTIONS(321),
    [anon_sym_target] = ACTIONS(38),
    [anon_sym_source_filename] = ACTIONS(38),
    [anon_sym_declare] = ACTIONS(38),
    [anon_sym_define] = ACTIONS(38),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LT_LBRACE] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_none] = ACTIONS(321),
    [anon_sym_undef] = ACTIONS(321),
    [anon_sym_poison] = ACTIONS(321),
    [anon_sym_zeroinitializer] = ACTIONS(321),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_uselistorder] = ACTIONS(70),
    [anon_sym_uselistorder_bb] = ACTIONS(38),
    [anon_sym_module] = ACTIONS(38),
    [anon_sym_attributes] = ACTIONS(38),
  },
  [24] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [aux_sym_metadata_ref_token1] = ACTIONS(365),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_ccc] = ACTIONS(365),
    [anon_sym_fastcc] = ACTIONS(365),
    [anon_sym_coldcc] = ACTIONS(365),
    [anon_sym_webkit_jscc] = ACTIONS(367),
    [anon_sym_anyregcc] = ACTIONS(365),
    [anon_sym_preserve_mostcc] = ACTIONS(365),
    [anon_sym_preserve_allcc] = ACTIONS(365),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(367),
    [anon_sym_tailcc] = ACTIONS(365),
    [anon_sym_swiftcc] = ACTIONS(367),
    [anon_sym_swifttailcc] = ACTIONS(367),
    [anon_sym_cfguard_checkcc] = ACTIONS(365),
    [aux_sym_calling_conv_token1] = ACTIONS(367),
    [aux_sym_calling_conv_token2] = ACTIONS(365),
    [aux_sym_calling_conv_token3] = ACTIONS(365),
    [aux_sym_calling_conv_token4] = ACTIONS(365),
    [aux_sym_calling_conv_token5] = ACTIONS(365),
    [aux_sym_calling_conv_token6] = ACTIONS(365),
    [aux_sym_calling_conv_token7] = ACTIONS(365),
    [aux_sym_calling_conv_token8] = ACTIONS(365),
    [aux_sym_calling_conv_token9] = ACTIONS(365),
    [aux_sym_calling_conv_token10] = ACTIONS(367),
    [anon_sym_ghccc] = ACTIONS(365),
    [aux_sym_calling_conv_token11] = ACTIONS(367),
    [aux_sym_calling_conv_token12] = ACTIONS(365),
    [aux_sym_calling_conv_token13] = ACTIONS(367),
    [aux_sym_calling_conv_token14] = ACTIONS(365),
    [anon_sym_cc] = ACTIONS(367),
    [anon_sym_unnamed_addr] = ACTIONS(365),
    [anon_sym_local_unnamed_addr] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_void] = ACTIONS(365),
    [anon_sym_half] = ACTIONS(365),
    [anon_sym_bfloat] = ACTIONS(365),
    [anon_sym_float] = ACTIONS(365),
    [anon_sym_double] = ACTIONS(365),
    [anon_sym_x86_fp80] = ACTIONS(367),
    [anon_sym_fp128] = ACTIONS(365),
    [anon_sym_ppc_fp128] = ACTIONS(365),
    [anon_sym_label] = ACTIONS(365),
    [anon_sym_metadata] = ACTIONS(365),
    [anon_sym_x86_mmx] = ACTIONS(367),
    [anon_sym_x86_amx] = ACTIONS(367),
    [anon_sym_token] = ACTIONS(365),
    [anon_sym_opaque] = ACTIONS(365),
    [anon_sym_ptr] = ACTIONS(367),
    [aux_sym_type_keyword_token1] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_align] = ACTIONS(367),
    [anon_sym_alignstack] = ACTIONS(365),
    [anon_sym_allocsize] = ACTIONS(365),
    [anon_sym_alwaysinline] = ACTIONS(365),
    [anon_sym_builtin] = ACTIONS(365),
    [anon_sym_cold] = ACTIONS(367),
    [anon_sym_convergent] = ACTIONS(365),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(365),
    [anon_sym_hot] = ACTIONS(365),
    [anon_sym_inaccessiblememonly] = ACTIONS(365),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(365),
    [anon_sym_inlinehint] = ACTIONS(365),
    [anon_sym_jumptable] = ACTIONS(365),
    [anon_sym_minsize] = ACTIONS(365),
    [anon_sym_naked] = ACTIONS(365),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(365),
    [anon_sym_nobuiltin] = ACTIONS(365),
    [anon_sym_noduplicate] = ACTIONS(365),
    [anon_sym_nofree] = ACTIONS(365),
    [anon_sym_noimplicitfloat] = ACTIONS(365),
    [anon_sym_noinline] = ACTIONS(365),
    [anon_sym_nomerge] = ACTIONS(365),
    [anon_sym_nonlazybind] = ACTIONS(365),
    [anon_sym_noprofile] = ACTIONS(365),
    [anon_sym_noredzone] = ACTIONS(365),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(365),
    [anon_sym_noreturn] = ACTIONS(365),
    [anon_sym_norecurse] = ACTIONS(365),
    [anon_sym_willreturn] = ACTIONS(365),
    [anon_sym_nosync] = ACTIONS(365),
    [anon_sym_nounwind] = ACTIONS(365),
    [anon_sym_nosanitize_coverage] = ACTIONS(365),
    [anon_sym_null_pointer_is_valid] = ACTIONS(365),
    [anon_sym_optforfuzzing] = ACTIONS(365),
    [anon_sym_optnone] = ACTIONS(365),
    [anon_sym_optsize] = ACTIONS(365),
    [anon_sym_readnone] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_writeonly] = ACTIONS(365),
    [anon_sym_argmemonly] = ACTIONS(365),
    [anon_sym_returns_twice] = ACTIONS(365),
    [anon_sym_safestack] = ACTIONS(365),
    [anon_sym_sanitize_address] = ACTIONS(365),
    [anon_sym_sanitize_memory] = ACTIONS(365),
    [anon_sym_sanitize_thread] = ACTIONS(365),
    [anon_sym_sanitize_hwaddress] = ACTIONS(365),
    [anon_sym_sanitize_memtag] = ACTIONS(365),
    [anon_sym_speculative_load_hardening] = ACTIONS(365),
    [anon_sym_speculatable] = ACTIONS(365),
    [anon_sym_ssp] = ACTIONS(367),
    [anon_sym_sspstrong] = ACTIONS(365),
    [anon_sym_sspreq] = ACTIONS(365),
    [anon_sym_strictfp] = ACTIONS(365),
    [anon_sym_uwtable] = ACTIONS(365),
    [anon_sym_nocf_check] = ACTIONS(365),
    [anon_sym_shadowcallstack] = ACTIONS(365),
    [anon_sym_mustprogress] = ACTIONS(365),
    [anon_sym_vscale_range] = ACTIONS(365),
    [anon_sym_preallocated] = ACTIONS(365),
    [anon_sym_zeroext] = ACTIONS(365),
    [anon_sym_signext] = ACTIONS(365),
    [anon_sym_inreg] = ACTIONS(365),
    [anon_sym_byval] = ACTIONS(365),
    [anon_sym_byref] = ACTIONS(365),
    [anon_sym_inalloca] = ACTIONS(365),
    [anon_sym_sret] = ACTIONS(365),
    [anon_sym_elementtype] = ACTIONS(365),
    [anon_sym_noalias] = ACTIONS(365),
    [anon_sym_nocapture] = ACTIONS(365),
    [anon_sym_nest] = ACTIONS(365),
    [anon_sym_returned] = ACTIONS(365),
    [anon_sym_nonnull] = ACTIONS(365),
    [anon_sym_dereferenceable] = ACTIONS(367),
    [anon_sym_dereferenceable_or_null] = ACTIONS(365),
    [anon_sym_swiftself] = ACTIONS(367),
    [anon_sym_swiftasync] = ACTIONS(367),
    [anon_sym_swifterror] = ACTIONS(367),
    [anon_sym_immarg] = ACTIONS(365),
    [anon_sym_noundef] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
  },
  [25] = {
    [sym_metadata_ref] = STATE(286),
    [sym_type] = STATE(23),
    [sym_type_keyword] = STATE(63),
    [sym_struct_type] = STATE(63),
    [sym_packed_struct_type] = STATE(63),
    [sym_array_type] = STATE(63),
    [sym_vector_type] = STATE(63),
    [sym_type_and_value] = STATE(300),
    [sym_metadata] = STATE(308),
    [sym_metadata_tuple] = STATE(300),
    [sym_specialized_md] = STATE(300),
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(369),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(373),
    [anon_sym_half] = ACTIONS(373),
    [anon_sym_bfloat] = ACTIONS(373),
    [anon_sym_float] = ACTIONS(373),
    [anon_sym_double] = ACTIONS(373),
    [anon_sym_x86_fp80] = ACTIONS(373),
    [anon_sym_fp128] = ACTIONS(373),
    [anon_sym_ppc_fp128] = ACTIONS(373),
    [anon_sym_label] = ACTIONS(373),
    [anon_sym_metadata] = ACTIONS(375),
    [anon_sym_x86_mmx] = ACTIONS(373),
    [anon_sym_x86_amx] = ACTIONS(373),
    [anon_sym_token] = ACTIONS(373),
    [anon_sym_opaque] = ACTIONS(373),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [26] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [27] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [aux_sym_metadata_ref_token1] = ACTIONS(393),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_ccc] = ACTIONS(393),
    [anon_sym_fastcc] = ACTIONS(393),
    [anon_sym_coldcc] = ACTIONS(393),
    [anon_sym_webkit_jscc] = ACTIONS(395),
    [anon_sym_anyregcc] = ACTIONS(393),
    [anon_sym_preserve_mostcc] = ACTIONS(393),
    [anon_sym_preserve_allcc] = ACTIONS(393),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(395),
    [anon_sym_tailcc] = ACTIONS(393),
    [anon_sym_swiftcc] = ACTIONS(395),
    [anon_sym_swifttailcc] = ACTIONS(395),
    [anon_sym_cfguard_checkcc] = ACTIONS(393),
    [aux_sym_calling_conv_token1] = ACTIONS(395),
    [aux_sym_calling_conv_token2] = ACTIONS(393),
    [aux_sym_calling_conv_token3] = ACTIONS(393),
    [aux_sym_calling_conv_token4] = ACTIONS(393),
    [aux_sym_calling_conv_token5] = ACTIONS(393),
    [aux_sym_calling_conv_token6] = ACTIONS(393),
    [aux_sym_calling_conv_token7] = ACTIONS(393),
    [aux_sym_calling_conv_token8] = ACTIONS(393),
    [aux_sym_calling_conv_token9] = ACTIONS(393),
    [aux_sym_calling_conv_token10] = ACTIONS(395),
    [anon_sym_ghccc] = ACTIONS(393),
    [aux_sym_calling_conv_token11] = ACTIONS(395),
    [aux_sym_calling_conv_token12] = ACTIONS(393),
    [aux_sym_calling_conv_token13] = ACTIONS(395),
    [aux_sym_calling_conv_token14] = ACTIONS(393),
    [anon_sym_cc] = ACTIONS(395),
    [anon_sym_unnamed_addr] = ACTIONS(393),
    [anon_sym_local_unnamed_addr] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(393),
    [anon_sym_half] = ACTIONS(393),
    [anon_sym_bfloat] = ACTIONS(393),
    [anon_sym_float] = ACTIONS(393),
    [anon_sym_double] = ACTIONS(393),
    [anon_sym_x86_fp80] = ACTIONS(395),
    [anon_sym_fp128] = ACTIONS(393),
    [anon_sym_ppc_fp128] = ACTIONS(393),
    [anon_sym_label] = ACTIONS(393),
    [anon_sym_metadata] = ACTIONS(393),
    [anon_sym_x86_mmx] = ACTIONS(395),
    [anon_sym_x86_amx] = ACTIONS(395),
    [anon_sym_token] = ACTIONS(393),
    [anon_sym_opaque] = ACTIONS(393),
    [anon_sym_ptr] = ACTIONS(395),
    [aux_sym_type_keyword_token1] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE_GT] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_align] = ACTIONS(395),
    [anon_sym_alignstack] = ACTIONS(393),
    [anon_sym_allocsize] = ACTIONS(393),
    [anon_sym_alwaysinline] = ACTIONS(393),
    [anon_sym_builtin] = ACTIONS(393),
    [anon_sym_cold] = ACTIONS(395),
    [anon_sym_convergent] = ACTIONS(393),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(393),
    [anon_sym_hot] = ACTIONS(393),
    [anon_sym_inaccessiblememonly] = ACTIONS(393),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(393),
    [anon_sym_inlinehint] = ACTIONS(393),
    [anon_sym_jumptable] = ACTIONS(393),
    [anon_sym_minsize] = ACTIONS(393),
    [anon_sym_naked] = ACTIONS(393),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(393),
    [anon_sym_nobuiltin] = ACTIONS(393),
    [anon_sym_noduplicate] = ACTIONS(393),
    [anon_sym_nofree] = ACTIONS(393),
    [anon_sym_noimplicitfloat] = ACTIONS(393),
    [anon_sym_noinline] = ACTIONS(393),
    [anon_sym_nomerge] = ACTIONS(393),
    [anon_sym_nonlazybind] = ACTIONS(393),
    [anon_sym_noprofile] = ACTIONS(393),
    [anon_sym_noredzone] = ACTIONS(393),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(393),
    [anon_sym_noreturn] = ACTIONS(393),
    [anon_sym_norecurse] = ACTIONS(393),
    [anon_sym_willreturn] = ACTIONS(393),
    [anon_sym_nosync] = ACTIONS(393),
    [anon_sym_nounwind] = ACTIONS(393),
    [anon_sym_nosanitize_coverage] = ACTIONS(393),
    [anon_sym_null_pointer_is_valid] = ACTIONS(393),
    [anon_sym_optforfuzzing] = ACTIONS(393),
    [anon_sym_optnone] = ACTIONS(393),
    [anon_sym_optsize] = ACTIONS(393),
    [anon_sym_readnone] = ACTIONS(393),
    [anon_sym_readonly] = ACTIONS(393),
    [anon_sym_writeonly] = ACTIONS(393),
    [anon_sym_argmemonly] = ACTIONS(393),
    [anon_sym_returns_twice] = ACTIONS(393),
    [anon_sym_safestack] = ACTIONS(393),
    [anon_sym_sanitize_address] = ACTIONS(393),
    [anon_sym_sanitize_memory] = ACTIONS(393),
    [anon_sym_sanitize_thread] = ACTIONS(393),
    [anon_sym_sanitize_hwaddress] = ACTIONS(393),
    [anon_sym_sanitize_memtag] = ACTIONS(393),
    [anon_sym_speculative_load_hardening] = ACTIONS(393),
    [anon_sym_speculatable] = ACTIONS(393),
    [anon_sym_ssp] = ACTIONS(395),
    [anon_sym_sspstrong] = ACTIONS(393),
    [anon_sym_sspreq] = ACTIONS(393),
    [anon_sym_strictfp] = ACTIONS(393),
    [anon_sym_uwtable] = ACTIONS(393),
    [anon_sym_nocf_check] = ACTIONS(393),
    [anon_sym_shadowcallstack] = ACTIONS(393),
    [anon_sym_mustprogress] = ACTIONS(393),
    [anon_sym_vscale_range] = ACTIONS(393),
    [anon_sym_preallocated] = ACTIONS(393),
    [anon_sym_zeroext] = ACTIONS(393),
    [anon_sym_signext] = ACTIONS(393),
    [anon_sym_inreg] = ACTIONS(393),
    [anon_sym_byval] = ACTIONS(393),
    [anon_sym_byref] = ACTIONS(393),
    [anon_sym_inalloca] = ACTIONS(393),
    [anon_sym_sret] = ACTIONS(393),
    [anon_sym_elementtype] = ACTIONS(393),
    [anon_sym_noalias] = ACTIONS(393),
    [anon_sym_nocapture] = ACTIONS(393),
    [anon_sym_nest] = ACTIONS(393),
    [anon_sym_returned] = ACTIONS(393),
    [anon_sym_nonnull] = ACTIONS(393),
    [anon_sym_dereferenceable] = ACTIONS(395),
    [anon_sym_dereferenceable_or_null] = ACTIONS(393),
    [anon_sym_swiftself] = ACTIONS(395),
    [anon_sym_swiftasync] = ACTIONS(395),
    [anon_sym_swifterror] = ACTIONS(395),
    [anon_sym_immarg] = ACTIONS(393),
    [anon_sym_noundef] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
  },
  [28] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [aux_sym_metadata_ref_token1] = ACTIONS(397),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_ccc] = ACTIONS(397),
    [anon_sym_fastcc] = ACTIONS(397),
    [anon_sym_coldcc] = ACTIONS(397),
    [anon_sym_webkit_jscc] = ACTIONS(399),
    [anon_sym_anyregcc] = ACTIONS(397),
    [anon_sym_preserve_mostcc] = ACTIONS(397),
    [anon_sym_preserve_allcc] = ACTIONS(397),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(399),
    [anon_sym_tailcc] = ACTIONS(397),
    [anon_sym_swiftcc] = ACTIONS(399),
    [anon_sym_swifttailcc] = ACTIONS(399),
    [anon_sym_cfguard_checkcc] = ACTIONS(397),
    [aux_sym_calling_conv_token1] = ACTIONS(399),
    [aux_sym_calling_conv_token2] = ACTIONS(397),
    [aux_sym_calling_conv_token3] = ACTIONS(397),
    [aux_sym_calling_conv_token4] = ACTIONS(397),
    [aux_sym_calling_conv_token5] = ACTIONS(397),
    [aux_sym_calling_conv_token6] = ACTIONS(397),
    [aux_sym_calling_conv_token7] = ACTIONS(397),
    [aux_sym_calling_conv_token8] = ACTIONS(397),
    [aux_sym_calling_conv_token9] = ACTIONS(397),
    [aux_sym_calling_conv_token10] = ACTIONS(399),
    [anon_sym_ghccc] = ACTIONS(397),
    [aux_sym_calling_conv_token11] = ACTIONS(399),
    [aux_sym_calling_conv_token12] = ACTIONS(397),
    [aux_sym_calling_conv_token13] = ACTIONS(399),
    [aux_sym_calling_conv_token14] = ACTIONS(397),
    [anon_sym_cc] = ACTIONS(399),
    [anon_sym_unnamed_addr] = ACTIONS(397),
    [anon_sym_local_unnamed_addr] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_void] = ACTIONS(397),
    [anon_sym_half] = ACTIONS(397),
    [anon_sym_bfloat] = ACTIONS(397),
    [anon_sym_float] = ACTIONS(397),
    [anon_sym_double] = ACTIONS(397),
    [anon_sym_x86_fp80] = ACTIONS(399),
    [anon_sym_fp128] = ACTIONS(397),
    [anon_sym_ppc_fp128] = ACTIONS(397),
    [anon_sym_label] = ACTIONS(397),
    [anon_sym_metadata] = ACTIONS(397),
    [anon_sym_x86_mmx] = ACTIONS(399),
    [anon_sym_x86_amx] = ACTIONS(399),
    [anon_sym_token] = ACTIONS(397),
    [anon_sym_opaque] = ACTIONS(397),
    [anon_sym_ptr] = ACTIONS(399),
    [aux_sym_type_keyword_token1] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE_GT] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_align] = ACTIONS(399),
    [anon_sym_alignstack] = ACTIONS(397),
    [anon_sym_allocsize] = ACTIONS(397),
    [anon_sym_alwaysinline] = ACTIONS(397),
    [anon_sym_builtin] = ACTIONS(397),
    [anon_sym_cold] = ACTIONS(399),
    [anon_sym_convergent] = ACTIONS(397),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(397),
    [anon_sym_hot] = ACTIONS(397),
    [anon_sym_inaccessiblememonly] = ACTIONS(397),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(397),
    [anon_sym_inlinehint] = ACTIONS(397),
    [anon_sym_jumptable] = ACTIONS(397),
    [anon_sym_minsize] = ACTIONS(397),
    [anon_sym_naked] = ACTIONS(397),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(397),
    [anon_sym_nobuiltin] = ACTIONS(397),
    [anon_sym_noduplicate] = ACTIONS(397),
    [anon_sym_nofree] = ACTIONS(397),
    [anon_sym_noimplicitfloat] = ACTIONS(397),
    [anon_sym_noinline] = ACTIONS(397),
    [anon_sym_nomerge] = ACTIONS(397),
    [anon_sym_nonlazybind] = ACTIONS(397),
    [anon_sym_noprofile] = ACTIONS(397),
    [anon_sym_noredzone] = ACTIONS(397),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(397),
    [anon_sym_noreturn] = ACTIONS(397),
    [anon_sym_norecurse] = ACTIONS(397),
    [anon_sym_willreturn] = ACTIONS(397),
    [anon_sym_nosync] = ACTIONS(397),
    [anon_sym_nounwind] = ACTIONS(397),
    [anon_sym_nosanitize_coverage] = ACTIONS(397),
    [anon_sym_null_pointer_is_valid] = ACTIONS(397),
    [anon_sym_optforfuzzing] = ACTIONS(397),
    [anon_sym_optnone] = ACTIONS(397),
    [anon_sym_optsize] = ACTIONS(397),
    [anon_sym_readnone] = ACTIONS(397),
    [anon_sym_readonly] = ACTIONS(397),
    [anon_sym_writeonly] = ACTIONS(397),
    [anon_sym_argmemonly] = ACTIONS(397),
    [anon_sym_returns_twice] = ACTIONS(397),
    [anon_sym_safestack] = ACTIONS(397),
    [anon_sym_sanitize_address] = ACTIONS(397),
    [anon_sym_sanitize_memory] = ACTIONS(397),
    [anon_sym_sanitize_thread] = ACTIONS(397),
    [anon_sym_sanitize_hwaddress] = ACTIONS(397),
    [anon_sym_sanitize_memtag] = ACTIONS(397),
    [anon_sym_speculative_load_hardening] = ACTIONS(397),
    [anon_sym_speculatable] = ACTIONS(397),
    [anon_sym_ssp] = ACTIONS(399),
    [anon_sym_sspstrong] = ACTIONS(397),
    [anon_sym_sspreq] = ACTIONS(397),
    [anon_sym_strictfp] = ACTIONS(397),
    [anon_sym_uwtable] = ACTIONS(397),
    [anon_sym_nocf_check] = ACTIONS(397),
    [anon_sym_shadowcallstack] = ACTIONS(397),
    [anon_sym_mustprogress] = ACTIONS(397),
    [anon_sym_vscale_range] = ACTIONS(397),
    [anon_sym_preallocated] = ACTIONS(397),
    [anon_sym_zeroext] = ACTIONS(397),
    [anon_sym_signext] = ACTIONS(397),
    [anon_sym_inreg] = ACTIONS(397),
    [anon_sym_byval] = ACTIONS(397),
    [anon_sym_byref] = ACTIONS(397),
    [anon_sym_inalloca] = ACTIONS(397),
    [anon_sym_sret] = ACTIONS(397),
    [anon_sym_elementtype] = ACTIONS(397),
    [anon_sym_noalias] = ACTIONS(397),
    [anon_sym_nocapture] = ACTIONS(397),
    [anon_sym_nest] = ACTIONS(397),
    [anon_sym_returned] = ACTIONS(397),
    [anon_sym_nonnull] = ACTIONS(397),
    [anon_sym_dereferenceable] = ACTIONS(399),
    [anon_sym_dereferenceable_or_null] = ACTIONS(397),
    [anon_sym_swiftself] = ACTIONS(399),
    [anon_sym_swiftasync] = ACTIONS(399),
    [anon_sym_swifterror] = ACTIONS(399),
    [anon_sym_immarg] = ACTIONS(397),
    [anon_sym_noundef] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(399),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(399),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
  },
  [29] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_ccc] = ACTIONS(263),
    [anon_sym_fastcc] = ACTIONS(263),
    [anon_sym_coldcc] = ACTIONS(263),
    [anon_sym_webkit_jscc] = ACTIONS(265),
    [anon_sym_anyregcc] = ACTIONS(263),
    [anon_sym_preserve_mostcc] = ACTIONS(263),
    [anon_sym_preserve_allcc] = ACTIONS(263),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(265),
    [anon_sym_tailcc] = ACTIONS(263),
    [anon_sym_swiftcc] = ACTIONS(265),
    [anon_sym_swifttailcc] = ACTIONS(265),
    [anon_sym_cfguard_checkcc] = ACTIONS(263),
    [aux_sym_calling_conv_token1] = ACTIONS(265),
    [aux_sym_calling_conv_token2] = ACTIONS(263),
    [aux_sym_calling_conv_token3] = ACTIONS(263),
    [aux_sym_calling_conv_token4] = ACTIONS(263),
    [aux_sym_calling_conv_token5] = ACTIONS(263),
    [aux_sym_calling_conv_token6] = ACTIONS(263),
    [aux_sym_calling_conv_token7] = ACTIONS(263),
    [aux_sym_calling_conv_token8] = ACTIONS(263),
    [aux_sym_calling_conv_token9] = ACTIONS(263),
    [aux_sym_calling_conv_token10] = ACTIONS(265),
    [anon_sym_ghccc] = ACTIONS(263),
    [aux_sym_calling_conv_token11] = ACTIONS(265),
    [aux_sym_calling_conv_token12] = ACTIONS(263),
    [aux_sym_calling_conv_token13] = ACTIONS(265),
    [aux_sym_calling_conv_token14] = ACTIONS(263),
    [anon_sym_cc] = ACTIONS(265),
    [anon_sym_unnamed_addr] = ACTIONS(263),
    [anon_sym_local_unnamed_addr] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(265),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(265),
    [anon_sym_x86_amx] = ACTIONS(265),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [30] = {
    [sym_addrspace] = STATE(50),
    [sym_argument_list] = STATE(32),
    [aux_sym_type_repeat1] = STATE(34),
    [aux_sym_type_repeat2] = STATE(32),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(401),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [31] = {
    [sym_addrspace] = STATE(53),
    [sym_argument_list] = STATE(30),
    [aux_sym_type_repeat1] = STATE(33),
    [aux_sym_type_repeat2] = STATE(30),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_label] = ACTIONS(234),
    [sym_string] = ACTIONS(236),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(236),
    [sym_float] = ACTIONS(236),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(236),
    [anon_sym_private] = ACTIONS(236),
    [anon_sym_internal] = ACTIONS(236),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(236),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(236),
    [anon_sym_available_externally] = ACTIONS(236),
    [anon_sym_appending] = ACTIONS(236),
    [anon_sym_common] = ACTIONS(236),
    [anon_sym_extern_weak] = ACTIONS(236),
    [anon_sym_external] = ACTIONS(236),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(236),
    [anon_sym_dso_preemptable] = ACTIONS(236),
    [anon_sym_default] = ACTIONS(236),
    [anon_sym_hidden] = ACTIONS(236),
    [anon_sym_protected] = ACTIONS(236),
    [anon_sym_dllimport] = ACTIONS(236),
    [anon_sym_dllexport] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_section] = ACTIONS(236),
    [anon_sym_partition] = ACTIONS(236),
    [anon_sym_comdat] = ACTIONS(236),
    [anon_sym_gc] = ACTIONS(236),
    [anon_sym_prefix] = ACTIONS(236),
    [anon_sym_prologue] = ACTIONS(236),
    [anon_sym_personality] = ACTIONS(236),
    [anon_sym_alignstack] = ACTIONS(236),
    [anon_sym_allocsize] = ACTIONS(236),
    [anon_sym_alwaysinline] = ACTIONS(236),
    [anon_sym_builtin] = ACTIONS(236),
    [anon_sym_cold] = ACTIONS(236),
    [anon_sym_convergent] = ACTIONS(236),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(236),
    [anon_sym_hot] = ACTIONS(236),
    [anon_sym_inaccessiblememonly] = ACTIONS(236),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(236),
    [anon_sym_inlinehint] = ACTIONS(236),
    [anon_sym_jumptable] = ACTIONS(236),
    [anon_sym_minsize] = ACTIONS(236),
    [anon_sym_naked] = ACTIONS(236),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(236),
    [anon_sym_nobuiltin] = ACTIONS(236),
    [anon_sym_noduplicate] = ACTIONS(236),
    [anon_sym_nofree] = ACTIONS(236),
    [anon_sym_noimplicitfloat] = ACTIONS(236),
    [anon_sym_noinline] = ACTIONS(236),
    [anon_sym_nomerge] = ACTIONS(236),
    [anon_sym_nonlazybind] = ACTIONS(236),
    [anon_sym_noprofile] = ACTIONS(236),
    [anon_sym_noredzone] = ACTIONS(236),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(236),
    [anon_sym_noreturn] = ACTIONS(236),
    [anon_sym_norecurse] = ACTIONS(236),
    [anon_sym_willreturn] = ACTIONS(236),
    [anon_sym_nosync] = ACTIONS(236),
    [anon_sym_nounwind] = ACTIONS(236),
    [anon_sym_nosanitize_coverage] = ACTIONS(236),
    [anon_sym_null_pointer_is_valid] = ACTIONS(236),
    [anon_sym_optforfuzzing] = ACTIONS(236),
    [anon_sym_optnone] = ACTIONS(236),
    [anon_sym_optsize] = ACTIONS(236),
    [anon_sym_readnone] = ACTIONS(236),
    [anon_sym_readonly] = ACTIONS(236),
    [anon_sym_writeonly] = ACTIONS(236),
    [anon_sym_argmemonly] = ACTIONS(236),
    [anon_sym_returns_twice] = ACTIONS(236),
    [anon_sym_safestack] = ACTIONS(236),
    [anon_sym_sanitize_address] = ACTIONS(236),
    [anon_sym_sanitize_memory] = ACTIONS(236),
    [anon_sym_sanitize_thread] = ACTIONS(236),
    [anon_sym_sanitize_hwaddress] = ACTIONS(236),
    [anon_sym_sanitize_memtag] = ACTIONS(236),
    [anon_sym_speculative_load_hardening] = ACTIONS(236),
    [anon_sym_speculatable] = ACTIONS(236),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(236),
    [anon_sym_sspreq] = ACTIONS(236),
    [anon_sym_strictfp] = ACTIONS(236),
    [anon_sym_uwtable] = ACTIONS(236),
    [anon_sym_nocf_check] = ACTIONS(236),
    [anon_sym_shadowcallstack] = ACTIONS(236),
    [anon_sym_mustprogress] = ACTIONS(236),
    [anon_sym_vscale_range] = ACTIONS(236),
    [anon_sym_preallocated] = ACTIONS(236),
    [anon_sym_zeroext] = ACTIONS(236),
    [anon_sym_signext] = ACTIONS(236),
    [anon_sym_inreg] = ACTIONS(236),
    [anon_sym_byval] = ACTIONS(236),
    [anon_sym_byref] = ACTIONS(236),
    [anon_sym_inalloca] = ACTIONS(236),
    [anon_sym_sret] = ACTIONS(236),
    [anon_sym_elementtype] = ACTIONS(236),
    [anon_sym_noalias] = ACTIONS(236),
    [anon_sym_nocapture] = ACTIONS(236),
    [anon_sym_nest] = ACTIONS(236),
    [anon_sym_returned] = ACTIONS(236),
    [anon_sym_nonnull] = ACTIONS(236),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(236),
    [anon_sym_swiftself] = ACTIONS(236),
    [anon_sym_swiftasync] = ACTIONS(236),
    [anon_sym_swifterror] = ACTIONS(236),
    [anon_sym_immarg] = ACTIONS(236),
    [anon_sym_noundef] = ACTIONS(236),
    [anon_sym_unreachable] = ACTIONS(236),
    [anon_sym_ret] = ACTIONS(236),
    [anon_sym_br] = ACTIONS(236),
    [anon_sym_resume] = ACTIONS(236),
    [anon_sym_freeze] = ACTIONS(236),
    [anon_sym_indirectbr] = ACTIONS(236),
    [anon_sym_extractelement] = ACTIONS(236),
    [anon_sym_insertelement] = ACTIONS(236),
    [anon_sym_select] = ACTIONS(236),
    [anon_sym_shufflevector] = ACTIONS(236),
    [anon_sym_fneg] = ACTIONS(236),
    [anon_sym_switch] = ACTIONS(236),
    [anon_sym_invoke] = ACTIONS(236),
    [anon_sym_cleanupret] = ACTIONS(236),
    [anon_sym_catchret] = ACTIONS(236),
    [anon_sym_catchswitch] = ACTIONS(236),
    [anon_sym_catchpad] = ACTIONS(236),
    [anon_sym_cleanuppad] = ACTIONS(236),
    [anon_sym_callbr] = ACTIONS(236),
    [anon_sym_icmp] = ACTIONS(236),
    [anon_sym_fcmp] = ACTIONS(236),
    [anon_sym_va_arg] = ACTIONS(236),
    [anon_sym_phi] = ACTIONS(236),
    [anon_sym_landingpad] = ACTIONS(236),
    [anon_sym_tail] = ACTIONS(236),
    [anon_sym_musttail] = ACTIONS(236),
    [anon_sym_notail] = ACTIONS(236),
    [anon_sym_call] = ACTIONS(236),
    [anon_sym_alloca] = ACTIONS(236),
    [anon_sym_load] = ACTIONS(236),
    [anon_sym_store] = ACTIONS(236),
    [anon_sym_cmpxchg] = ACTIONS(236),
    [anon_sym_atomicrmw] = ACTIONS(236),
    [anon_sym_fence] = ACTIONS(236),
    [anon_sym_getelementptr] = ACTIONS(236),
    [anon_sym_extractvalue] = ACTIONS(236),
    [anon_sym_insertvalue] = ACTIONS(236),
    [anon_sym_true] = ACTIONS(236),
    [anon_sym_false] = ACTIONS(236),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_none] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(236),
    [anon_sym_poison] = ACTIONS(236),
    [anon_sym_zeroinitializer] = ACTIONS(236),
    [anon_sym_blockaddress] = ACTIONS(236),
    [anon_sym_mul] = ACTIONS(236),
    [anon_sym_urem] = ACTIONS(236),
    [anon_sym_srem] = ACTIONS(236),
    [anon_sym_shl] = ACTIONS(236),
    [anon_sym_udiv] = ACTIONS(236),
    [anon_sym_sdiv] = ACTIONS(236),
    [anon_sym_lshr] = ACTIONS(236),
    [anon_sym_ashr] = ACTIONS(236),
    [anon_sym_fmul] = ACTIONS(236),
    [anon_sym_fdiv] = ACTIONS(236),
    [anon_sym_frem] = ACTIONS(236),
    [anon_sym_xchg] = ACTIONS(236),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(236),
    [anon_sym_and] = ACTIONS(236),
    [anon_sym_nand] = ACTIONS(236),
    [anon_sym_or] = ACTIONS(236),
    [anon_sym_xor] = ACTIONS(236),
    [anon_sym_max] = ACTIONS(236),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(236),
    [anon_sym_umin] = ACTIONS(236),
    [anon_sym_fadd] = ACTIONS(236),
    [anon_sym_fsub] = ACTIONS(236),
    [anon_sym_bitcast] = ACTIONS(236),
    [anon_sym_trunc] = ACTIONS(236),
    [anon_sym_zext] = ACTIONS(236),
    [anon_sym_sext] = ACTIONS(236),
    [anon_sym_fptrunc] = ACTIONS(236),
    [anon_sym_fpext] = ACTIONS(236),
    [anon_sym_addrspacecast] = ACTIONS(236),
    [anon_sym_uitofp] = ACTIONS(236),
    [anon_sym_sitofp] = ACTIONS(236),
    [anon_sym_fptoui] = ACTIONS(236),
    [anon_sym_fptosi] = ACTIONS(236),
    [anon_sym_inttoptr] = ACTIONS(236),
    [anon_sym_ptrtoint] = ACTIONS(236),
    [anon_sym_uselistorder] = ACTIONS(236),
  },
  [32] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(32),
    [aux_sym_type_repeat1] = STATE(1121),
    [aux_sym_type_repeat2] = STATE(32),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(412),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(252),
    [anon_sym_partition] = ACTIONS(252),
    [anon_sym_comdat] = ACTIONS(252),
    [anon_sym_gc] = ACTIONS(252),
    [anon_sym_prefix] = ACTIONS(252),
    [anon_sym_prologue] = ACTIONS(252),
    [anon_sym_personality] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(252),
    [anon_sym_allocsize] = ACTIONS(252),
    [anon_sym_alwaysinline] = ACTIONS(252),
    [anon_sym_builtin] = ACTIONS(252),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(252),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(252),
    [anon_sym_hot] = ACTIONS(252),
    [anon_sym_inaccessiblememonly] = ACTIONS(252),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(252),
    [anon_sym_inlinehint] = ACTIONS(252),
    [anon_sym_jumptable] = ACTIONS(252),
    [anon_sym_minsize] = ACTIONS(252),
    [anon_sym_naked] = ACTIONS(252),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(252),
    [anon_sym_nobuiltin] = ACTIONS(252),
    [anon_sym_noduplicate] = ACTIONS(252),
    [anon_sym_nofree] = ACTIONS(252),
    [anon_sym_noimplicitfloat] = ACTIONS(252),
    [anon_sym_noinline] = ACTIONS(252),
    [anon_sym_nomerge] = ACTIONS(252),
    [anon_sym_nonlazybind] = ACTIONS(252),
    [anon_sym_noprofile] = ACTIONS(252),
    [anon_sym_noredzone] = ACTIONS(252),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(252),
    [anon_sym_noreturn] = ACTIONS(252),
    [anon_sym_norecurse] = ACTIONS(252),
    [anon_sym_willreturn] = ACTIONS(252),
    [anon_sym_nosync] = ACTIONS(252),
    [anon_sym_nounwind] = ACTIONS(252),
    [anon_sym_nosanitize_coverage] = ACTIONS(252),
    [anon_sym_null_pointer_is_valid] = ACTIONS(252),
    [anon_sym_optforfuzzing] = ACTIONS(252),
    [anon_sym_optnone] = ACTIONS(252),
    [anon_sym_optsize] = ACTIONS(252),
    [anon_sym_readnone] = ACTIONS(252),
    [anon_sym_readonly] = ACTIONS(252),
    [anon_sym_writeonly] = ACTIONS(252),
    [anon_sym_argmemonly] = ACTIONS(252),
    [anon_sym_returns_twice] = ACTIONS(252),
    [anon_sym_safestack] = ACTIONS(252),
    [anon_sym_sanitize_address] = ACTIONS(252),
    [anon_sym_sanitize_memory] = ACTIONS(252),
    [anon_sym_sanitize_thread] = ACTIONS(252),
    [anon_sym_sanitize_hwaddress] = ACTIONS(252),
    [anon_sym_sanitize_memtag] = ACTIONS(252),
    [anon_sym_speculative_load_hardening] = ACTIONS(252),
    [anon_sym_speculatable] = ACTIONS(252),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(252),
    [anon_sym_sspreq] = ACTIONS(252),
    [anon_sym_strictfp] = ACTIONS(252),
    [anon_sym_uwtable] = ACTIONS(252),
    [anon_sym_nocf_check] = ACTIONS(252),
    [anon_sym_shadowcallstack] = ACTIONS(252),
    [anon_sym_mustprogress] = ACTIONS(252),
    [anon_sym_vscale_range] = ACTIONS(252),
    [anon_sym_preallocated] = ACTIONS(252),
    [anon_sym_zeroext] = ACTIONS(252),
    [anon_sym_signext] = ACTIONS(252),
    [anon_sym_inreg] = ACTIONS(252),
    [anon_sym_byval] = ACTIONS(252),
    [anon_sym_byref] = ACTIONS(252),
    [anon_sym_inalloca] = ACTIONS(252),
    [anon_sym_sret] = ACTIONS(252),
    [anon_sym_elementtype] = ACTIONS(252),
    [anon_sym_noalias] = ACTIONS(252),
    [anon_sym_nocapture] = ACTIONS(252),
    [anon_sym_nest] = ACTIONS(252),
    [anon_sym_returned] = ACTIONS(252),
    [anon_sym_nonnull] = ACTIONS(252),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(252),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(252),
    [anon_sym_noundef] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [33] = {
    [sym_addrspace] = STATE(50),
    [sym_argument_list] = STATE(46),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [34] = {
    [sym_addrspace] = STATE(54),
    [sym_argument_list] = STATE(46),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(265),
    [anon_sym_partition] = ACTIONS(265),
    [anon_sym_comdat] = ACTIONS(265),
    [anon_sym_gc] = ACTIONS(265),
    [anon_sym_prefix] = ACTIONS(265),
    [anon_sym_prologue] = ACTIONS(265),
    [anon_sym_personality] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(265),
    [anon_sym_allocsize] = ACTIONS(265),
    [anon_sym_alwaysinline] = ACTIONS(265),
    [anon_sym_builtin] = ACTIONS(265),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(265),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(265),
    [anon_sym_hot] = ACTIONS(265),
    [anon_sym_inaccessiblememonly] = ACTIONS(265),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(265),
    [anon_sym_inlinehint] = ACTIONS(265),
    [anon_sym_jumptable] = ACTIONS(265),
    [anon_sym_minsize] = ACTIONS(265),
    [anon_sym_naked] = ACTIONS(265),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(265),
    [anon_sym_nobuiltin] = ACTIONS(265),
    [anon_sym_noduplicate] = ACTIONS(265),
    [anon_sym_nofree] = ACTIONS(265),
    [anon_sym_noimplicitfloat] = ACTIONS(265),
    [anon_sym_noinline] = ACTIONS(265),
    [anon_sym_nomerge] = ACTIONS(265),
    [anon_sym_nonlazybind] = ACTIONS(265),
    [anon_sym_noprofile] = ACTIONS(265),
    [anon_sym_noredzone] = ACTIONS(265),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(265),
    [anon_sym_noreturn] = ACTIONS(265),
    [anon_sym_norecurse] = ACTIONS(265),
    [anon_sym_willreturn] = ACTIONS(265),
    [anon_sym_nosync] = ACTIONS(265),
    [anon_sym_nounwind] = ACTIONS(265),
    [anon_sym_nosanitize_coverage] = ACTIONS(265),
    [anon_sym_null_pointer_is_valid] = ACTIONS(265),
    [anon_sym_optforfuzzing] = ACTIONS(265),
    [anon_sym_optnone] = ACTIONS(265),
    [anon_sym_optsize] = ACTIONS(265),
    [anon_sym_readnone] = ACTIONS(265),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_writeonly] = ACTIONS(265),
    [anon_sym_argmemonly] = ACTIONS(265),
    [anon_sym_returns_twice] = ACTIONS(265),
    [anon_sym_safestack] = ACTIONS(265),
    [anon_sym_sanitize_address] = ACTIONS(265),
    [anon_sym_sanitize_memory] = ACTIONS(265),
    [anon_sym_sanitize_thread] = ACTIONS(265),
    [anon_sym_sanitize_hwaddress] = ACTIONS(265),
    [anon_sym_sanitize_memtag] = ACTIONS(265),
    [anon_sym_speculative_load_hardening] = ACTIONS(265),
    [anon_sym_speculatable] = ACTIONS(265),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(265),
    [anon_sym_sspreq] = ACTIONS(265),
    [anon_sym_strictfp] = ACTIONS(265),
    [anon_sym_uwtable] = ACTIONS(265),
    [anon_sym_nocf_check] = ACTIONS(265),
    [anon_sym_shadowcallstack] = ACTIONS(265),
    [anon_sym_mustprogress] = ACTIONS(265),
    [anon_sym_vscale_range] = ACTIONS(265),
    [anon_sym_preallocated] = ACTIONS(265),
    [anon_sym_zeroext] = ACTIONS(265),
    [anon_sym_signext] = ACTIONS(265),
    [anon_sym_inreg] = ACTIONS(265),
    [anon_sym_byval] = ACTIONS(265),
    [anon_sym_byref] = ACTIONS(265),
    [anon_sym_inalloca] = ACTIONS(265),
    [anon_sym_sret] = ACTIONS(265),
    [anon_sym_elementtype] = ACTIONS(265),
    [anon_sym_noalias] = ACTIONS(265),
    [anon_sym_nocapture] = ACTIONS(265),
    [anon_sym_nest] = ACTIONS(265),
    [anon_sym_returned] = ACTIONS(265),
    [anon_sym_nonnull] = ACTIONS(265),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(265),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(265),
    [anon_sym_noundef] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [35] = {
    [sym_addrspace] = STATE(1544),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(271),
    [anon_sym_partition] = ACTIONS(271),
    [anon_sym_comdat] = ACTIONS(271),
    [anon_sym_gc] = ACTIONS(271),
    [anon_sym_prefix] = ACTIONS(271),
    [anon_sym_prologue] = ACTIONS(271),
    [anon_sym_personality] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(271),
    [anon_sym_allocsize] = ACTIONS(271),
    [anon_sym_alwaysinline] = ACTIONS(271),
    [anon_sym_builtin] = ACTIONS(271),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(271),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(271),
    [anon_sym_hot] = ACTIONS(271),
    [anon_sym_inaccessiblememonly] = ACTIONS(271),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(271),
    [anon_sym_inlinehint] = ACTIONS(271),
    [anon_sym_jumptable] = ACTIONS(271),
    [anon_sym_minsize] = ACTIONS(271),
    [anon_sym_naked] = ACTIONS(271),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(271),
    [anon_sym_nobuiltin] = ACTIONS(271),
    [anon_sym_noduplicate] = ACTIONS(271),
    [anon_sym_nofree] = ACTIONS(271),
    [anon_sym_noimplicitfloat] = ACTIONS(271),
    [anon_sym_noinline] = ACTIONS(271),
    [anon_sym_nomerge] = ACTIONS(271),
    [anon_sym_nonlazybind] = ACTIONS(271),
    [anon_sym_noprofile] = ACTIONS(271),
    [anon_sym_noredzone] = ACTIONS(271),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(271),
    [anon_sym_noreturn] = ACTIONS(271),
    [anon_sym_norecurse] = ACTIONS(271),
    [anon_sym_willreturn] = ACTIONS(271),
    [anon_sym_nosync] = ACTIONS(271),
    [anon_sym_nounwind] = ACTIONS(271),
    [anon_sym_nosanitize_coverage] = ACTIONS(271),
    [anon_sym_null_pointer_is_valid] = ACTIONS(271),
    [anon_sym_optforfuzzing] = ACTIONS(271),
    [anon_sym_optnone] = ACTIONS(271),
    [anon_sym_optsize] = ACTIONS(271),
    [anon_sym_readnone] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(271),
    [anon_sym_writeonly] = ACTIONS(271),
    [anon_sym_argmemonly] = ACTIONS(271),
    [anon_sym_returns_twice] = ACTIONS(271),
    [anon_sym_safestack] = ACTIONS(271),
    [anon_sym_sanitize_address] = ACTIONS(271),
    [anon_sym_sanitize_memory] = ACTIONS(271),
    [anon_sym_sanitize_thread] = ACTIONS(271),
    [anon_sym_sanitize_hwaddress] = ACTIONS(271),
    [anon_sym_sanitize_memtag] = ACTIONS(271),
    [anon_sym_speculative_load_hardening] = ACTIONS(271),
    [anon_sym_speculatable] = ACTIONS(271),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(271),
    [anon_sym_sspreq] = ACTIONS(271),
    [anon_sym_strictfp] = ACTIONS(271),
    [anon_sym_uwtable] = ACTIONS(271),
    [anon_sym_nocf_check] = ACTIONS(271),
    [anon_sym_shadowcallstack] = ACTIONS(271),
    [anon_sym_mustprogress] = ACTIONS(271),
    [anon_sym_vscale_range] = ACTIONS(271),
    [anon_sym_preallocated] = ACTIONS(271),
    [anon_sym_zeroext] = ACTIONS(271),
    [anon_sym_signext] = ACTIONS(271),
    [anon_sym_inreg] = ACTIONS(271),
    [anon_sym_byval] = ACTIONS(271),
    [anon_sym_byref] = ACTIONS(271),
    [anon_sym_inalloca] = ACTIONS(271),
    [anon_sym_sret] = ACTIONS(271),
    [anon_sym_elementtype] = ACTIONS(271),
    [anon_sym_noalias] = ACTIONS(271),
    [anon_sym_nocapture] = ACTIONS(271),
    [anon_sym_nest] = ACTIONS(271),
    [anon_sym_returned] = ACTIONS(271),
    [anon_sym_nonnull] = ACTIONS(271),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(271),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(271),
    [anon_sym_noundef] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [36] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(299),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [sym_label] = ACTIONS(299),
    [sym_string] = ACTIONS(301),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(301),
    [sym_float] = ACTIONS(301),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(301),
    [anon_sym_private] = ACTIONS(301),
    [anon_sym_internal] = ACTIONS(301),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(301),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(301),
    [anon_sym_available_externally] = ACTIONS(301),
    [anon_sym_appending] = ACTIONS(301),
    [anon_sym_common] = ACTIONS(301),
    [anon_sym_extern_weak] = ACTIONS(301),
    [anon_sym_external] = ACTIONS(301),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(301),
    [anon_sym_dso_preemptable] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(301),
    [anon_sym_hidden] = ACTIONS(301),
    [anon_sym_protected] = ACTIONS(301),
    [anon_sym_dllimport] = ACTIONS(301),
    [anon_sym_dllexport] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_align] = ACTIONS(301),
    [anon_sym_section] = ACTIONS(301),
    [anon_sym_partition] = ACTIONS(301),
    [anon_sym_comdat] = ACTIONS(301),
    [anon_sym_gc] = ACTIONS(301),
    [anon_sym_prefix] = ACTIONS(301),
    [anon_sym_prologue] = ACTIONS(301),
    [anon_sym_personality] = ACTIONS(301),
    [anon_sym_alignstack] = ACTIONS(301),
    [anon_sym_allocsize] = ACTIONS(301),
    [anon_sym_alwaysinline] = ACTIONS(301),
    [anon_sym_builtin] = ACTIONS(301),
    [anon_sym_cold] = ACTIONS(301),
    [anon_sym_convergent] = ACTIONS(301),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(301),
    [anon_sym_hot] = ACTIONS(301),
    [anon_sym_inaccessiblememonly] = ACTIONS(301),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(301),
    [anon_sym_inlinehint] = ACTIONS(301),
    [anon_sym_jumptable] = ACTIONS(301),
    [anon_sym_minsize] = ACTIONS(301),
    [anon_sym_naked] = ACTIONS(301),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(301),
    [anon_sym_nobuiltin] = ACTIONS(301),
    [anon_sym_noduplicate] = ACTIONS(301),
    [anon_sym_nofree] = ACTIONS(301),
    [anon_sym_noimplicitfloat] = ACTIONS(301),
    [anon_sym_noinline] = ACTIONS(301),
    [anon_sym_nomerge] = ACTIONS(301),
    [anon_sym_nonlazybind] = ACTIONS(301),
    [anon_sym_noprofile] = ACTIONS(301),
    [anon_sym_noredzone] = ACTIONS(301),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(301),
    [anon_sym_noreturn] = ACTIONS(301),
    [anon_sym_norecurse] = ACTIONS(301),
    [anon_sym_willreturn] = ACTIONS(301),
    [anon_sym_nosync] = ACTIONS(301),
    [anon_sym_nounwind] = ACTIONS(301),
    [anon_sym_nosanitize_coverage] = ACTIONS(301),
    [anon_sym_null_pointer_is_valid] = ACTIONS(301),
    [anon_sym_optforfuzzing] = ACTIONS(301),
    [anon_sym_optnone] = ACTIONS(301),
    [anon_sym_optsize] = ACTIONS(301),
    [anon_sym_readnone] = ACTIONS(301),
    [anon_sym_readonly] = ACTIONS(301),
    [anon_sym_writeonly] = ACTIONS(301),
    [anon_sym_argmemonly] = ACTIONS(301),
    [anon_sym_returns_twice] = ACTIONS(301),
    [anon_sym_safestack] = ACTIONS(301),
    [anon_sym_sanitize_address] = ACTIONS(301),
    [anon_sym_sanitize_memory] = ACTIONS(301),
    [anon_sym_sanitize_thread] = ACTIONS(301),
    [anon_sym_sanitize_hwaddress] = ACTIONS(301),
    [anon_sym_sanitize_memtag] = ACTIONS(301),
    [anon_sym_speculative_load_hardening] = ACTIONS(301),
    [anon_sym_speculatable] = ACTIONS(301),
    [anon_sym_ssp] = ACTIONS(301),
    [anon_sym_sspstrong] = ACTIONS(301),
    [anon_sym_sspreq] = ACTIONS(301),
    [anon_sym_strictfp] = ACTIONS(301),
    [anon_sym_uwtable] = ACTIONS(301),
    [anon_sym_nocf_check] = ACTIONS(301),
    [anon_sym_shadowcallstack] = ACTIONS(301),
    [anon_sym_mustprogress] = ACTIONS(301),
    [anon_sym_vscale_range] = ACTIONS(301),
    [anon_sym_preallocated] = ACTIONS(301),
    [anon_sym_zeroext] = ACTIONS(301),
    [anon_sym_signext] = ACTIONS(301),
    [anon_sym_inreg] = ACTIONS(301),
    [anon_sym_byval] = ACTIONS(301),
    [anon_sym_byref] = ACTIONS(301),
    [anon_sym_inalloca] = ACTIONS(301),
    [anon_sym_sret] = ACTIONS(301),
    [anon_sym_elementtype] = ACTIONS(301),
    [anon_sym_noalias] = ACTIONS(301),
    [anon_sym_nocapture] = ACTIONS(301),
    [anon_sym_nest] = ACTIONS(301),
    [anon_sym_returned] = ACTIONS(301),
    [anon_sym_nonnull] = ACTIONS(301),
    [anon_sym_dereferenceable] = ACTIONS(301),
    [anon_sym_dereferenceable_or_null] = ACTIONS(301),
    [anon_sym_swiftself] = ACTIONS(301),
    [anon_sym_swiftasync] = ACTIONS(301),
    [anon_sym_swifterror] = ACTIONS(301),
    [anon_sym_immarg] = ACTIONS(301),
    [anon_sym_noundef] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [anon_sym_ret] = ACTIONS(301),
    [anon_sym_br] = ACTIONS(301),
    [anon_sym_resume] = ACTIONS(301),
    [anon_sym_freeze] = ACTIONS(301),
    [anon_sym_indirectbr] = ACTIONS(301),
    [anon_sym_extractelement] = ACTIONS(301),
    [anon_sym_insertelement] = ACTIONS(301),
    [anon_sym_select] = ACTIONS(301),
    [anon_sym_shufflevector] = ACTIONS(301),
    [anon_sym_fneg] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(301),
    [anon_sym_invoke] = ACTIONS(301),
    [anon_sym_cleanupret] = ACTIONS(301),
    [anon_sym_catchret] = ACTIONS(301),
    [anon_sym_catchswitch] = ACTIONS(301),
    [anon_sym_catchpad] = ACTIONS(301),
    [anon_sym_cleanuppad] = ACTIONS(301),
    [anon_sym_callbr] = ACTIONS(301),
    [anon_sym_icmp] = ACTIONS(301),
    [anon_sym_fcmp] = ACTIONS(301),
    [anon_sym_va_arg] = ACTIONS(301),
    [anon_sym_phi] = ACTIONS(301),
    [anon_sym_landingpad] = ACTIONS(301),
    [anon_sym_tail] = ACTIONS(301),
    [anon_sym_musttail] = ACTIONS(301),
    [anon_sym_notail] = ACTIONS(301),
    [anon_sym_call] = ACTIONS(301),
    [anon_sym_alloca] = ACTIONS(301),
    [anon_sym_load] = ACTIONS(301),
    [anon_sym_store] = ACTIONS(301),
    [anon_sym_cmpxchg] = ACTIONS(301),
    [anon_sym_atomicrmw] = ACTIONS(301),
    [anon_sym_fence] = ACTIONS(301),
    [anon_sym_getelementptr] = ACTIONS(301),
    [anon_sym_extractvalue] = ACTIONS(301),
    [anon_sym_insertvalue] = ACTIONS(301),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_none] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(301),
    [anon_sym_poison] = ACTIONS(301),
    [anon_sym_zeroinitializer] = ACTIONS(301),
    [anon_sym_blockaddress] = ACTIONS(301),
    [anon_sym_mul] = ACTIONS(301),
    [anon_sym_urem] = ACTIONS(301),
    [anon_sym_srem] = ACTIONS(301),
    [anon_sym_shl] = ACTIONS(301),
    [anon_sym_udiv] = ACTIONS(301),
    [anon_sym_sdiv] = ACTIONS(301),
    [anon_sym_lshr] = ACTIONS(301),
    [anon_sym_ashr] = ACTIONS(301),
    [anon_sym_fmul] = ACTIONS(301),
    [anon_sym_fdiv] = ACTIONS(301),
    [anon_sym_frem] = ACTIONS(301),
    [anon_sym_xchg] = ACTIONS(301),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(301),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_nand] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_xor] = ACTIONS(301),
    [anon_sym_max] = ACTIONS(301),
    [anon_sym_min] = ACTIONS(301),
    [anon_sym_umax] = ACTIONS(301),
    [anon_sym_umin] = ACTIONS(301),
    [anon_sym_fadd] = ACTIONS(301),
    [anon_sym_fsub] = ACTIONS(301),
    [anon_sym_bitcast] = ACTIONS(301),
    [anon_sym_trunc] = ACTIONS(301),
    [anon_sym_zext] = ACTIONS(301),
    [anon_sym_sext] = ACTIONS(301),
    [anon_sym_fptrunc] = ACTIONS(301),
    [anon_sym_fpext] = ACTIONS(301),
    [anon_sym_addrspacecast] = ACTIONS(301),
    [anon_sym_uitofp] = ACTIONS(301),
    [anon_sym_sitofp] = ACTIONS(301),
    [anon_sym_fptoui] = ACTIONS(301),
    [anon_sym_fptosi] = ACTIONS(301),
    [anon_sym_inttoptr] = ACTIONS(301),
    [anon_sym_ptrtoint] = ACTIONS(301),
    [anon_sym_uselistorder] = ACTIONS(301),
  },
  [37] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(295),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [sym_label] = ACTIONS(295),
    [sym_string] = ACTIONS(297),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(297),
    [sym_float] = ACTIONS(297),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(297),
    [anon_sym_private] = ACTIONS(297),
    [anon_sym_internal] = ACTIONS(297),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(297),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(297),
    [anon_sym_available_externally] = ACTIONS(297),
    [anon_sym_appending] = ACTIONS(297),
    [anon_sym_common] = ACTIONS(297),
    [anon_sym_extern_weak] = ACTIONS(297),
    [anon_sym_external] = ACTIONS(297),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(297),
    [anon_sym_dso_preemptable] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_hidden] = ACTIONS(297),
    [anon_sym_protected] = ACTIONS(297),
    [anon_sym_dllimport] = ACTIONS(297),
    [anon_sym_dllexport] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_align] = ACTIONS(297),
    [anon_sym_section] = ACTIONS(297),
    [anon_sym_partition] = ACTIONS(297),
    [anon_sym_comdat] = ACTIONS(297),
    [anon_sym_gc] = ACTIONS(297),
    [anon_sym_prefix] = ACTIONS(297),
    [anon_sym_prologue] = ACTIONS(297),
    [anon_sym_personality] = ACTIONS(297),
    [anon_sym_alignstack] = ACTIONS(297),
    [anon_sym_allocsize] = ACTIONS(297),
    [anon_sym_alwaysinline] = ACTIONS(297),
    [anon_sym_builtin] = ACTIONS(297),
    [anon_sym_cold] = ACTIONS(297),
    [anon_sym_convergent] = ACTIONS(297),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(297),
    [anon_sym_hot] = ACTIONS(297),
    [anon_sym_inaccessiblememonly] = ACTIONS(297),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(297),
    [anon_sym_inlinehint] = ACTIONS(297),
    [anon_sym_jumptable] = ACTIONS(297),
    [anon_sym_minsize] = ACTIONS(297),
    [anon_sym_naked] = ACTIONS(297),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(297),
    [anon_sym_nobuiltin] = ACTIONS(297),
    [anon_sym_noduplicate] = ACTIONS(297),
    [anon_sym_nofree] = ACTIONS(297),
    [anon_sym_noimplicitfloat] = ACTIONS(297),
    [anon_sym_noinline] = ACTIONS(297),
    [anon_sym_nomerge] = ACTIONS(297),
    [anon_sym_nonlazybind] = ACTIONS(297),
    [anon_sym_noprofile] = ACTIONS(297),
    [anon_sym_noredzone] = ACTIONS(297),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(297),
    [anon_sym_noreturn] = ACTIONS(297),
    [anon_sym_norecurse] = ACTIONS(297),
    [anon_sym_willreturn] = ACTIONS(297),
    [anon_sym_nosync] = ACTIONS(297),
    [anon_sym_nounwind] = ACTIONS(297),
    [anon_sym_nosanitize_coverage] = ACTIONS(297),
    [anon_sym_null_pointer_is_valid] = ACTIONS(297),
    [anon_sym_optforfuzzing] = ACTIONS(297),
    [anon_sym_optnone] = ACTIONS(297),
    [anon_sym_optsize] = ACTIONS(297),
    [anon_sym_readnone] = ACTIONS(297),
    [anon_sym_readonly] = ACTIONS(297),
    [anon_sym_writeonly] = ACTIONS(297),
    [anon_sym_argmemonly] = ACTIONS(297),
    [anon_sym_returns_twice] = ACTIONS(297),
    [anon_sym_safestack] = ACTIONS(297),
    [anon_sym_sanitize_address] = ACTIONS(297),
    [anon_sym_sanitize_memory] = ACTIONS(297),
    [anon_sym_sanitize_thread] = ACTIONS(297),
    [anon_sym_sanitize_hwaddress] = ACTIONS(297),
    [anon_sym_sanitize_memtag] = ACTIONS(297),
    [anon_sym_speculative_load_hardening] = ACTIONS(297),
    [anon_sym_speculatable] = ACTIONS(297),
    [anon_sym_ssp] = ACTIONS(297),
    [anon_sym_sspstrong] = ACTIONS(297),
    [anon_sym_sspreq] = ACTIONS(297),
    [anon_sym_strictfp] = ACTIONS(297),
    [anon_sym_uwtable] = ACTIONS(297),
    [anon_sym_nocf_check] = ACTIONS(297),
    [anon_sym_shadowcallstack] = ACTIONS(297),
    [anon_sym_mustprogress] = ACTIONS(297),
    [anon_sym_vscale_range] = ACTIONS(297),
    [anon_sym_preallocated] = ACTIONS(297),
    [anon_sym_zeroext] = ACTIONS(297),
    [anon_sym_signext] = ACTIONS(297),
    [anon_sym_inreg] = ACTIONS(297),
    [anon_sym_byval] = ACTIONS(297),
    [anon_sym_byref] = ACTIONS(297),
    [anon_sym_inalloca] = ACTIONS(297),
    [anon_sym_sret] = ACTIONS(297),
    [anon_sym_elementtype] = ACTIONS(297),
    [anon_sym_noalias] = ACTIONS(297),
    [anon_sym_nocapture] = ACTIONS(297),
    [anon_sym_nest] = ACTIONS(297),
    [anon_sym_returned] = ACTIONS(297),
    [anon_sym_nonnull] = ACTIONS(297),
    [anon_sym_dereferenceable] = ACTIONS(297),
    [anon_sym_dereferenceable_or_null] = ACTIONS(297),
    [anon_sym_swiftself] = ACTIONS(297),
    [anon_sym_swiftasync] = ACTIONS(297),
    [anon_sym_swifterror] = ACTIONS(297),
    [anon_sym_immarg] = ACTIONS(297),
    [anon_sym_noundef] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(297),
    [anon_sym_ret] = ACTIONS(297),
    [anon_sym_br] = ACTIONS(297),
    [anon_sym_resume] = ACTIONS(297),
    [anon_sym_freeze] = ACTIONS(297),
    [anon_sym_indirectbr] = ACTIONS(297),
    [anon_sym_extractelement] = ACTIONS(297),
    [anon_sym_insertelement] = ACTIONS(297),
    [anon_sym_select] = ACTIONS(297),
    [anon_sym_shufflevector] = ACTIONS(297),
    [anon_sym_fneg] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(297),
    [anon_sym_invoke] = ACTIONS(297),
    [anon_sym_cleanupret] = ACTIONS(297),
    [anon_sym_catchret] = ACTIONS(297),
    [anon_sym_catchswitch] = ACTIONS(297),
    [anon_sym_catchpad] = ACTIONS(297),
    [anon_sym_cleanuppad] = ACTIONS(297),
    [anon_sym_callbr] = ACTIONS(297),
    [anon_sym_icmp] = ACTIONS(297),
    [anon_sym_fcmp] = ACTIONS(297),
    [anon_sym_va_arg] = ACTIONS(297),
    [anon_sym_phi] = ACTIONS(297),
    [anon_sym_landingpad] = ACTIONS(297),
    [anon_sym_tail] = ACTIONS(297),
    [anon_sym_musttail] = ACTIONS(297),
    [anon_sym_notail] = ACTIONS(297),
    [anon_sym_call] = ACTIONS(297),
    [anon_sym_alloca] = ACTIONS(297),
    [anon_sym_load] = ACTIONS(297),
    [anon_sym_store] = ACTIONS(297),
    [anon_sym_cmpxchg] = ACTIONS(297),
    [anon_sym_atomicrmw] = ACTIONS(297),
    [anon_sym_fence] = ACTIONS(297),
    [anon_sym_getelementptr] = ACTIONS(297),
    [anon_sym_extractvalue] = ACTIONS(297),
    [anon_sym_insertvalue] = ACTIONS(297),
    [anon_sym_true] = ACTIONS(297),
    [anon_sym_false] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(297),
    [anon_sym_none] = ACTIONS(297),
    [anon_sym_undef] = ACTIONS(297),
    [anon_sym_poison] = ACTIONS(297),
    [anon_sym_zeroinitializer] = ACTIONS(297),
    [anon_sym_blockaddress] = ACTIONS(297),
    [anon_sym_mul] = ACTIONS(297),
    [anon_sym_urem] = ACTIONS(297),
    [anon_sym_srem] = ACTIONS(297),
    [anon_sym_shl] = ACTIONS(297),
    [anon_sym_udiv] = ACTIONS(297),
    [anon_sym_sdiv] = ACTIONS(297),
    [anon_sym_lshr] = ACTIONS(297),
    [anon_sym_ashr] = ACTIONS(297),
    [anon_sym_fmul] = ACTIONS(297),
    [anon_sym_fdiv] = ACTIONS(297),
    [anon_sym_frem] = ACTIONS(297),
    [anon_sym_xchg] = ACTIONS(297),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(297),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_nand] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_xor] = ACTIONS(297),
    [anon_sym_max] = ACTIONS(297),
    [anon_sym_min] = ACTIONS(297),
    [anon_sym_umax] = ACTIONS(297),
    [anon_sym_umin] = ACTIONS(297),
    [anon_sym_fadd] = ACTIONS(297),
    [anon_sym_fsub] = ACTIONS(297),
    [anon_sym_bitcast] = ACTIONS(297),
    [anon_sym_trunc] = ACTIONS(297),
    [anon_sym_zext] = ACTIONS(297),
    [anon_sym_sext] = ACTIONS(297),
    [anon_sym_fptrunc] = ACTIONS(297),
    [anon_sym_fpext] = ACTIONS(297),
    [anon_sym_addrspacecast] = ACTIONS(297),
    [anon_sym_uitofp] = ACTIONS(297),
    [anon_sym_sitofp] = ACTIONS(297),
    [anon_sym_fptoui] = ACTIONS(297),
    [anon_sym_fptosi] = ACTIONS(297),
    [anon_sym_inttoptr] = ACTIONS(297),
    [anon_sym_ptrtoint] = ACTIONS(297),
    [anon_sym_uselistorder] = ACTIONS(297),
  },
  [38] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(287),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [sym_label] = ACTIONS(287),
    [sym_string] = ACTIONS(289),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(289),
    [sym_float] = ACTIONS(289),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(289),
    [anon_sym_private] = ACTIONS(289),
    [anon_sym_internal] = ACTIONS(289),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(289),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(289),
    [anon_sym_available_externally] = ACTIONS(289),
    [anon_sym_appending] = ACTIONS(289),
    [anon_sym_common] = ACTIONS(289),
    [anon_sym_extern_weak] = ACTIONS(289),
    [anon_sym_external] = ACTIONS(289),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(289),
    [anon_sym_dso_preemptable] = ACTIONS(289),
    [anon_sym_default] = ACTIONS(289),
    [anon_sym_hidden] = ACTIONS(289),
    [anon_sym_protected] = ACTIONS(289),
    [anon_sym_dllimport] = ACTIONS(289),
    [anon_sym_dllexport] = ACTIONS(289),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_align] = ACTIONS(289),
    [anon_sym_section] = ACTIONS(289),
    [anon_sym_partition] = ACTIONS(289),
    [anon_sym_comdat] = ACTIONS(289),
    [anon_sym_gc] = ACTIONS(289),
    [anon_sym_prefix] = ACTIONS(289),
    [anon_sym_prologue] = ACTIONS(289),
    [anon_sym_personality] = ACTIONS(289),
    [anon_sym_alignstack] = ACTIONS(289),
    [anon_sym_allocsize] = ACTIONS(289),
    [anon_sym_alwaysinline] = ACTIONS(289),
    [anon_sym_builtin] = ACTIONS(289),
    [anon_sym_cold] = ACTIONS(289),
    [anon_sym_convergent] = ACTIONS(289),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(289),
    [anon_sym_hot] = ACTIONS(289),
    [anon_sym_inaccessiblememonly] = ACTIONS(289),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(289),
    [anon_sym_inlinehint] = ACTIONS(289),
    [anon_sym_jumptable] = ACTIONS(289),
    [anon_sym_minsize] = ACTIONS(289),
    [anon_sym_naked] = ACTIONS(289),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(289),
    [anon_sym_nobuiltin] = ACTIONS(289),
    [anon_sym_noduplicate] = ACTIONS(289),
    [anon_sym_nofree] = ACTIONS(289),
    [anon_sym_noimplicitfloat] = ACTIONS(289),
    [anon_sym_noinline] = ACTIONS(289),
    [anon_sym_nomerge] = ACTIONS(289),
    [anon_sym_nonlazybind] = ACTIONS(289),
    [anon_sym_noprofile] = ACTIONS(289),
    [anon_sym_noredzone] = ACTIONS(289),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(289),
    [anon_sym_noreturn] = ACTIONS(289),
    [anon_sym_norecurse] = ACTIONS(289),
    [anon_sym_willreturn] = ACTIONS(289),
    [anon_sym_nosync] = ACTIONS(289),
    [anon_sym_nounwind] = ACTIONS(289),
    [anon_sym_nosanitize_coverage] = ACTIONS(289),
    [anon_sym_null_pointer_is_valid] = ACTIONS(289),
    [anon_sym_optforfuzzing] = ACTIONS(289),
    [anon_sym_optnone] = ACTIONS(289),
    [anon_sym_optsize] = ACTIONS(289),
    [anon_sym_readnone] = ACTIONS(289),
    [anon_sym_readonly] = ACTIONS(289),
    [anon_sym_writeonly] = ACTIONS(289),
    [anon_sym_argmemonly] = ACTIONS(289),
    [anon_sym_returns_twice] = ACTIONS(289),
    [anon_sym_safestack] = ACTIONS(289),
    [anon_sym_sanitize_address] = ACTIONS(289),
    [anon_sym_sanitize_memory] = ACTIONS(289),
    [anon_sym_sanitize_thread] = ACTIONS(289),
    [anon_sym_sanitize_hwaddress] = ACTIONS(289),
    [anon_sym_sanitize_memtag] = ACTIONS(289),
    [anon_sym_speculative_load_hardening] = ACTIONS(289),
    [anon_sym_speculatable] = ACTIONS(289),
    [anon_sym_ssp] = ACTIONS(289),
    [anon_sym_sspstrong] = ACTIONS(289),
    [anon_sym_sspreq] = ACTIONS(289),
    [anon_sym_strictfp] = ACTIONS(289),
    [anon_sym_uwtable] = ACTIONS(289),
    [anon_sym_nocf_check] = ACTIONS(289),
    [anon_sym_shadowcallstack] = ACTIONS(289),
    [anon_sym_mustprogress] = ACTIONS(289),
    [anon_sym_vscale_range] = ACTIONS(289),
    [anon_sym_preallocated] = ACTIONS(289),
    [anon_sym_zeroext] = ACTIONS(289),
    [anon_sym_signext] = ACTIONS(289),
    [anon_sym_inreg] = ACTIONS(289),
    [anon_sym_byval] = ACTIONS(289),
    [anon_sym_byref] = ACTIONS(289),
    [anon_sym_inalloca] = ACTIONS(289),
    [anon_sym_sret] = ACTIONS(289),
    [anon_sym_elementtype] = ACTIONS(289),
    [anon_sym_noalias] = ACTIONS(289),
    [anon_sym_nocapture] = ACTIONS(289),
    [anon_sym_nest] = ACTIONS(289),
    [anon_sym_returned] = ACTIONS(289),
    [anon_sym_nonnull] = ACTIONS(289),
    [anon_sym_dereferenceable] = ACTIONS(289),
    [anon_sym_dereferenceable_or_null] = ACTIONS(289),
    [anon_sym_swiftself] = ACTIONS(289),
    [anon_sym_swiftasync] = ACTIONS(289),
    [anon_sym_swifterror] = ACTIONS(289),
    [anon_sym_immarg] = ACTIONS(289),
    [anon_sym_noundef] = ACTIONS(289),
    [anon_sym_unreachable] = ACTIONS(289),
    [anon_sym_ret] = ACTIONS(289),
    [anon_sym_br] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_freeze] = ACTIONS(289),
    [anon_sym_indirectbr] = ACTIONS(289),
    [anon_sym_extractelement] = ACTIONS(289),
    [anon_sym_insertelement] = ACTIONS(289),
    [anon_sym_select] = ACTIONS(289),
    [anon_sym_shufflevector] = ACTIONS(289),
    [anon_sym_fneg] = ACTIONS(289),
    [anon_sym_switch] = ACTIONS(289),
    [anon_sym_invoke] = ACTIONS(289),
    [anon_sym_cleanupret] = ACTIONS(289),
    [anon_sym_catchret] = ACTIONS(289),
    [anon_sym_catchswitch] = ACTIONS(289),
    [anon_sym_catchpad] = ACTIONS(289),
    [anon_sym_cleanuppad] = ACTIONS(289),
    [anon_sym_callbr] = ACTIONS(289),
    [anon_sym_icmp] = ACTIONS(289),
    [anon_sym_fcmp] = ACTIONS(289),
    [anon_sym_va_arg] = ACTIONS(289),
    [anon_sym_phi] = ACTIONS(289),
    [anon_sym_landingpad] = ACTIONS(289),
    [anon_sym_tail] = ACTIONS(289),
    [anon_sym_musttail] = ACTIONS(289),
    [anon_sym_notail] = ACTIONS(289),
    [anon_sym_call] = ACTIONS(289),
    [anon_sym_alloca] = ACTIONS(289),
    [anon_sym_load] = ACTIONS(289),
    [anon_sym_store] = ACTIONS(289),
    [anon_sym_cmpxchg] = ACTIONS(289),
    [anon_sym_atomicrmw] = ACTIONS(289),
    [anon_sym_fence] = ACTIONS(289),
    [anon_sym_getelementptr] = ACTIONS(289),
    [anon_sym_extractvalue] = ACTIONS(289),
    [anon_sym_insertvalue] = ACTIONS(289),
    [anon_sym_true] = ACTIONS(289),
    [anon_sym_false] = ACTIONS(289),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_none] = ACTIONS(289),
    [anon_sym_undef] = ACTIONS(289),
    [anon_sym_poison] = ACTIONS(289),
    [anon_sym_zeroinitializer] = ACTIONS(289),
    [anon_sym_blockaddress] = ACTIONS(289),
    [anon_sym_mul] = ACTIONS(289),
    [anon_sym_urem] = ACTIONS(289),
    [anon_sym_srem] = ACTIONS(289),
    [anon_sym_shl] = ACTIONS(289),
    [anon_sym_udiv] = ACTIONS(289),
    [anon_sym_sdiv] = ACTIONS(289),
    [anon_sym_lshr] = ACTIONS(289),
    [anon_sym_ashr] = ACTIONS(289),
    [anon_sym_fmul] = ACTIONS(289),
    [anon_sym_fdiv] = ACTIONS(289),
    [anon_sym_frem] = ACTIONS(289),
    [anon_sym_xchg] = ACTIONS(289),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(289),
    [anon_sym_nand] = ACTIONS(289),
    [anon_sym_or] = ACTIONS(289),
    [anon_sym_xor] = ACTIONS(289),
    [anon_sym_max] = ACTIONS(289),
    [anon_sym_min] = ACTIONS(289),
    [anon_sym_umax] = ACTIONS(289),
    [anon_sym_umin] = ACTIONS(289),
    [anon_sym_fadd] = ACTIONS(289),
    [anon_sym_fsub] = ACTIONS(289),
    [anon_sym_bitcast] = ACTIONS(289),
    [anon_sym_trunc] = ACTIONS(289),
    [anon_sym_zext] = ACTIONS(289),
    [anon_sym_sext] = ACTIONS(289),
    [anon_sym_fptrunc] = ACTIONS(289),
    [anon_sym_fpext] = ACTIONS(289),
    [anon_sym_addrspacecast] = ACTIONS(289),
    [anon_sym_uitofp] = ACTIONS(289),
    [anon_sym_sitofp] = ACTIONS(289),
    [anon_sym_fptoui] = ACTIONS(289),
    [anon_sym_fptosi] = ACTIONS(289),
    [anon_sym_inttoptr] = ACTIONS(289),
    [anon_sym_ptrtoint] = ACTIONS(289),
    [anon_sym_uselistorder] = ACTIONS(289),
  },
  [39] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(291),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [sym_label] = ACTIONS(291),
    [sym_string] = ACTIONS(293),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(293),
    [anon_sym_private] = ACTIONS(293),
    [anon_sym_internal] = ACTIONS(293),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(293),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(293),
    [anon_sym_available_externally] = ACTIONS(293),
    [anon_sym_appending] = ACTIONS(293),
    [anon_sym_common] = ACTIONS(293),
    [anon_sym_extern_weak] = ACTIONS(293),
    [anon_sym_external] = ACTIONS(293),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(293),
    [anon_sym_dso_preemptable] = ACTIONS(293),
    [anon_sym_default] = ACTIONS(293),
    [anon_sym_hidden] = ACTIONS(293),
    [anon_sym_protected] = ACTIONS(293),
    [anon_sym_dllimport] = ACTIONS(293),
    [anon_sym_dllexport] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_align] = ACTIONS(293),
    [anon_sym_section] = ACTIONS(293),
    [anon_sym_partition] = ACTIONS(293),
    [anon_sym_comdat] = ACTIONS(293),
    [anon_sym_gc] = ACTIONS(293),
    [anon_sym_prefix] = ACTIONS(293),
    [anon_sym_prologue] = ACTIONS(293),
    [anon_sym_personality] = ACTIONS(293),
    [anon_sym_alignstack] = ACTIONS(293),
    [anon_sym_allocsize] = ACTIONS(293),
    [anon_sym_alwaysinline] = ACTIONS(293),
    [anon_sym_builtin] = ACTIONS(293),
    [anon_sym_cold] = ACTIONS(293),
    [anon_sym_convergent] = ACTIONS(293),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(293),
    [anon_sym_hot] = ACTIONS(293),
    [anon_sym_inaccessiblememonly] = ACTIONS(293),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(293),
    [anon_sym_inlinehint] = ACTIONS(293),
    [anon_sym_jumptable] = ACTIONS(293),
    [anon_sym_minsize] = ACTIONS(293),
    [anon_sym_naked] = ACTIONS(293),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(293),
    [anon_sym_nobuiltin] = ACTIONS(293),
    [anon_sym_noduplicate] = ACTIONS(293),
    [anon_sym_nofree] = ACTIONS(293),
    [anon_sym_noimplicitfloat] = ACTIONS(293),
    [anon_sym_noinline] = ACTIONS(293),
    [anon_sym_nomerge] = ACTIONS(293),
    [anon_sym_nonlazybind] = ACTIONS(293),
    [anon_sym_noprofile] = ACTIONS(293),
    [anon_sym_noredzone] = ACTIONS(293),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(293),
    [anon_sym_noreturn] = ACTIONS(293),
    [anon_sym_norecurse] = ACTIONS(293),
    [anon_sym_willreturn] = ACTIONS(293),
    [anon_sym_nosync] = ACTIONS(293),
    [anon_sym_nounwind] = ACTIONS(293),
    [anon_sym_nosanitize_coverage] = ACTIONS(293),
    [anon_sym_null_pointer_is_valid] = ACTIONS(293),
    [anon_sym_optforfuzzing] = ACTIONS(293),
    [anon_sym_optnone] = ACTIONS(293),
    [anon_sym_optsize] = ACTIONS(293),
    [anon_sym_readnone] = ACTIONS(293),
    [anon_sym_readonly] = ACTIONS(293),
    [anon_sym_writeonly] = ACTIONS(293),
    [anon_sym_argmemonly] = ACTIONS(293),
    [anon_sym_returns_twice] = ACTIONS(293),
    [anon_sym_safestack] = ACTIONS(293),
    [anon_sym_sanitize_address] = ACTIONS(293),
    [anon_sym_sanitize_memory] = ACTIONS(293),
    [anon_sym_sanitize_thread] = ACTIONS(293),
    [anon_sym_sanitize_hwaddress] = ACTIONS(293),
    [anon_sym_sanitize_memtag] = ACTIONS(293),
    [anon_sym_speculative_load_hardening] = ACTIONS(293),
    [anon_sym_speculatable] = ACTIONS(293),
    [anon_sym_ssp] = ACTIONS(293),
    [anon_sym_sspstrong] = ACTIONS(293),
    [anon_sym_sspreq] = ACTIONS(293),
    [anon_sym_strictfp] = ACTIONS(293),
    [anon_sym_uwtable] = ACTIONS(293),
    [anon_sym_nocf_check] = ACTIONS(293),
    [anon_sym_shadowcallstack] = ACTIONS(293),
    [anon_sym_mustprogress] = ACTIONS(293),
    [anon_sym_vscale_range] = ACTIONS(293),
    [anon_sym_preallocated] = ACTIONS(293),
    [anon_sym_zeroext] = ACTIONS(293),
    [anon_sym_signext] = ACTIONS(293),
    [anon_sym_inreg] = ACTIONS(293),
    [anon_sym_byval] = ACTIONS(293),
    [anon_sym_byref] = ACTIONS(293),
    [anon_sym_inalloca] = ACTIONS(293),
    [anon_sym_sret] = ACTIONS(293),
    [anon_sym_elementtype] = ACTIONS(293),
    [anon_sym_noalias] = ACTIONS(293),
    [anon_sym_nocapture] = ACTIONS(293),
    [anon_sym_nest] = ACTIONS(293),
    [anon_sym_returned] = ACTIONS(293),
    [anon_sym_nonnull] = ACTIONS(293),
    [anon_sym_dereferenceable] = ACTIONS(293),
    [anon_sym_dereferenceable_or_null] = ACTIONS(293),
    [anon_sym_swiftself] = ACTIONS(293),
    [anon_sym_swiftasync] = ACTIONS(293),
    [anon_sym_swifterror] = ACTIONS(293),
    [anon_sym_immarg] = ACTIONS(293),
    [anon_sym_noundef] = ACTIONS(293),
    [anon_sym_unreachable] = ACTIONS(293),
    [anon_sym_ret] = ACTIONS(293),
    [anon_sym_br] = ACTIONS(293),
    [anon_sym_resume] = ACTIONS(293),
    [anon_sym_freeze] = ACTIONS(293),
    [anon_sym_indirectbr] = ACTIONS(293),
    [anon_sym_extractelement] = ACTIONS(293),
    [anon_sym_insertelement] = ACTIONS(293),
    [anon_sym_select] = ACTIONS(293),
    [anon_sym_shufflevector] = ACTIONS(293),
    [anon_sym_fneg] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_invoke] = ACTIONS(293),
    [anon_sym_cleanupret] = ACTIONS(293),
    [anon_sym_catchret] = ACTIONS(293),
    [anon_sym_catchswitch] = ACTIONS(293),
    [anon_sym_catchpad] = ACTIONS(293),
    [anon_sym_cleanuppad] = ACTIONS(293),
    [anon_sym_callbr] = ACTIONS(293),
    [anon_sym_icmp] = ACTIONS(293),
    [anon_sym_fcmp] = ACTIONS(293),
    [anon_sym_va_arg] = ACTIONS(293),
    [anon_sym_phi] = ACTIONS(293),
    [anon_sym_landingpad] = ACTIONS(293),
    [anon_sym_tail] = ACTIONS(293),
    [anon_sym_musttail] = ACTIONS(293),
    [anon_sym_notail] = ACTIONS(293),
    [anon_sym_call] = ACTIONS(293),
    [anon_sym_alloca] = ACTIONS(293),
    [anon_sym_load] = ACTIONS(293),
    [anon_sym_store] = ACTIONS(293),
    [anon_sym_cmpxchg] = ACTIONS(293),
    [anon_sym_atomicrmw] = ACTIONS(293),
    [anon_sym_fence] = ACTIONS(293),
    [anon_sym_getelementptr] = ACTIONS(293),
    [anon_sym_extractvalue] = ACTIONS(293),
    [anon_sym_insertvalue] = ACTIONS(293),
    [anon_sym_true] = ACTIONS(293),
    [anon_sym_false] = ACTIONS(293),
    [anon_sym_null] = ACTIONS(293),
    [anon_sym_none] = ACTIONS(293),
    [anon_sym_undef] = ACTIONS(293),
    [anon_sym_poison] = ACTIONS(293),
    [anon_sym_zeroinitializer] = ACTIONS(293),
    [anon_sym_blockaddress] = ACTIONS(293),
    [anon_sym_mul] = ACTIONS(293),
    [anon_sym_urem] = ACTIONS(293),
    [anon_sym_srem] = ACTIONS(293),
    [anon_sym_shl] = ACTIONS(293),
    [anon_sym_udiv] = ACTIONS(293),
    [anon_sym_sdiv] = ACTIONS(293),
    [anon_sym_lshr] = ACTIONS(293),
    [anon_sym_ashr] = ACTIONS(293),
    [anon_sym_fmul] = ACTIONS(293),
    [anon_sym_fdiv] = ACTIONS(293),
    [anon_sym_frem] = ACTIONS(293),
    [anon_sym_xchg] = ACTIONS(293),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(293),
    [anon_sym_and] = ACTIONS(293),
    [anon_sym_nand] = ACTIONS(293),
    [anon_sym_or] = ACTIONS(293),
    [anon_sym_xor] = ACTIONS(293),
    [anon_sym_max] = ACTIONS(293),
    [anon_sym_min] = ACTIONS(293),
    [anon_sym_umax] = ACTIONS(293),
    [anon_sym_umin] = ACTIONS(293),
    [anon_sym_fadd] = ACTIONS(293),
    [anon_sym_fsub] = ACTIONS(293),
    [anon_sym_bitcast] = ACTIONS(293),
    [anon_sym_trunc] = ACTIONS(293),
    [anon_sym_zext] = ACTIONS(293),
    [anon_sym_sext] = ACTIONS(293),
    [anon_sym_fptrunc] = ACTIONS(293),
    [anon_sym_fpext] = ACTIONS(293),
    [anon_sym_addrspacecast] = ACTIONS(293),
    [anon_sym_uitofp] = ACTIONS(293),
    [anon_sym_sitofp] = ACTIONS(293),
    [anon_sym_fptoui] = ACTIONS(293),
    [anon_sym_fptosi] = ACTIONS(293),
    [anon_sym_inttoptr] = ACTIONS(293),
    [anon_sym_ptrtoint] = ACTIONS(293),
    [anon_sym_uselistorder] = ACTIONS(293),
  },
  [40] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(271),
    [anon_sym_partition] = ACTIONS(271),
    [anon_sym_comdat] = ACTIONS(271),
    [anon_sym_gc] = ACTIONS(271),
    [anon_sym_prefix] = ACTIONS(271),
    [anon_sym_prologue] = ACTIONS(271),
    [anon_sym_personality] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(271),
    [anon_sym_allocsize] = ACTIONS(271),
    [anon_sym_alwaysinline] = ACTIONS(271),
    [anon_sym_builtin] = ACTIONS(271),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(271),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(271),
    [anon_sym_hot] = ACTIONS(271),
    [anon_sym_inaccessiblememonly] = ACTIONS(271),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(271),
    [anon_sym_inlinehint] = ACTIONS(271),
    [anon_sym_jumptable] = ACTIONS(271),
    [anon_sym_minsize] = ACTIONS(271),
    [anon_sym_naked] = ACTIONS(271),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(271),
    [anon_sym_nobuiltin] = ACTIONS(271),
    [anon_sym_noduplicate] = ACTIONS(271),
    [anon_sym_nofree] = ACTIONS(271),
    [anon_sym_noimplicitfloat] = ACTIONS(271),
    [anon_sym_noinline] = ACTIONS(271),
    [anon_sym_nomerge] = ACTIONS(271),
    [anon_sym_nonlazybind] = ACTIONS(271),
    [anon_sym_noprofile] = ACTIONS(271),
    [anon_sym_noredzone] = ACTIONS(271),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(271),
    [anon_sym_noreturn] = ACTIONS(271),
    [anon_sym_norecurse] = ACTIONS(271),
    [anon_sym_willreturn] = ACTIONS(271),
    [anon_sym_nosync] = ACTIONS(271),
    [anon_sym_nounwind] = ACTIONS(271),
    [anon_sym_nosanitize_coverage] = ACTIONS(271),
    [anon_sym_null_pointer_is_valid] = ACTIONS(271),
    [anon_sym_optforfuzzing] = ACTIONS(271),
    [anon_sym_optnone] = ACTIONS(271),
    [anon_sym_optsize] = ACTIONS(271),
    [anon_sym_readnone] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(271),
    [anon_sym_writeonly] = ACTIONS(271),
    [anon_sym_argmemonly] = ACTIONS(271),
    [anon_sym_returns_twice] = ACTIONS(271),
    [anon_sym_safestack] = ACTIONS(271),
    [anon_sym_sanitize_address] = ACTIONS(271),
    [anon_sym_sanitize_memory] = ACTIONS(271),
    [anon_sym_sanitize_thread] = ACTIONS(271),
    [anon_sym_sanitize_hwaddress] = ACTIONS(271),
    [anon_sym_sanitize_memtag] = ACTIONS(271),
    [anon_sym_speculative_load_hardening] = ACTIONS(271),
    [anon_sym_speculatable] = ACTIONS(271),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(271),
    [anon_sym_sspreq] = ACTIONS(271),
    [anon_sym_strictfp] = ACTIONS(271),
    [anon_sym_uwtable] = ACTIONS(271),
    [anon_sym_nocf_check] = ACTIONS(271),
    [anon_sym_shadowcallstack] = ACTIONS(271),
    [anon_sym_mustprogress] = ACTIONS(271),
    [anon_sym_vscale_range] = ACTIONS(271),
    [anon_sym_preallocated] = ACTIONS(271),
    [anon_sym_zeroext] = ACTIONS(271),
    [anon_sym_signext] = ACTIONS(271),
    [anon_sym_inreg] = ACTIONS(271),
    [anon_sym_byval] = ACTIONS(271),
    [anon_sym_byref] = ACTIONS(271),
    [anon_sym_inalloca] = ACTIONS(271),
    [anon_sym_sret] = ACTIONS(271),
    [anon_sym_elementtype] = ACTIONS(271),
    [anon_sym_noalias] = ACTIONS(271),
    [anon_sym_nocapture] = ACTIONS(271),
    [anon_sym_nest] = ACTIONS(271),
    [anon_sym_returned] = ACTIONS(271),
    [anon_sym_nonnull] = ACTIONS(271),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(271),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(271),
    [anon_sym_noundef] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [41] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_label] = ACTIONS(279),
    [sym_string] = ACTIONS(281),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(281),
    [sym_float] = ACTIONS(281),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_internal] = ACTIONS(281),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(281),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(281),
    [anon_sym_available_externally] = ACTIONS(281),
    [anon_sym_appending] = ACTIONS(281),
    [anon_sym_common] = ACTIONS(281),
    [anon_sym_extern_weak] = ACTIONS(281),
    [anon_sym_external] = ACTIONS(281),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(281),
    [anon_sym_dso_preemptable] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_hidden] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_dllimport] = ACTIONS(281),
    [anon_sym_dllexport] = ACTIONS(281),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_section] = ACTIONS(281),
    [anon_sym_partition] = ACTIONS(281),
    [anon_sym_comdat] = ACTIONS(281),
    [anon_sym_gc] = ACTIONS(281),
    [anon_sym_prefix] = ACTIONS(281),
    [anon_sym_prologue] = ACTIONS(281),
    [anon_sym_personality] = ACTIONS(281),
    [anon_sym_alignstack] = ACTIONS(281),
    [anon_sym_allocsize] = ACTIONS(281),
    [anon_sym_alwaysinline] = ACTIONS(281),
    [anon_sym_builtin] = ACTIONS(281),
    [anon_sym_cold] = ACTIONS(281),
    [anon_sym_convergent] = ACTIONS(281),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(281),
    [anon_sym_hot] = ACTIONS(281),
    [anon_sym_inaccessiblememonly] = ACTIONS(281),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(281),
    [anon_sym_inlinehint] = ACTIONS(281),
    [anon_sym_jumptable] = ACTIONS(281),
    [anon_sym_minsize] = ACTIONS(281),
    [anon_sym_naked] = ACTIONS(281),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(281),
    [anon_sym_nobuiltin] = ACTIONS(281),
    [anon_sym_noduplicate] = ACTIONS(281),
    [anon_sym_nofree] = ACTIONS(281),
    [anon_sym_noimplicitfloat] = ACTIONS(281),
    [anon_sym_noinline] = ACTIONS(281),
    [anon_sym_nomerge] = ACTIONS(281),
    [anon_sym_nonlazybind] = ACTIONS(281),
    [anon_sym_noprofile] = ACTIONS(281),
    [anon_sym_noredzone] = ACTIONS(281),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(281),
    [anon_sym_noreturn] = ACTIONS(281),
    [anon_sym_norecurse] = ACTIONS(281),
    [anon_sym_willreturn] = ACTIONS(281),
    [anon_sym_nosync] = ACTIONS(281),
    [anon_sym_nounwind] = ACTIONS(281),
    [anon_sym_nosanitize_coverage] = ACTIONS(281),
    [anon_sym_null_pointer_is_valid] = ACTIONS(281),
    [anon_sym_optforfuzzing] = ACTIONS(281),
    [anon_sym_optnone] = ACTIONS(281),
    [anon_sym_optsize] = ACTIONS(281),
    [anon_sym_readnone] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_writeonly] = ACTIONS(281),
    [anon_sym_argmemonly] = ACTIONS(281),
    [anon_sym_returns_twice] = ACTIONS(281),
    [anon_sym_safestack] = ACTIONS(281),
    [anon_sym_sanitize_address] = ACTIONS(281),
    [anon_sym_sanitize_memory] = ACTIONS(281),
    [anon_sym_sanitize_thread] = ACTIONS(281),
    [anon_sym_sanitize_hwaddress] = ACTIONS(281),
    [anon_sym_sanitize_memtag] = ACTIONS(281),
    [anon_sym_speculative_load_hardening] = ACTIONS(281),
    [anon_sym_speculatable] = ACTIONS(281),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(281),
    [anon_sym_sspreq] = ACTIONS(281),
    [anon_sym_strictfp] = ACTIONS(281),
    [anon_sym_uwtable] = ACTIONS(281),
    [anon_sym_nocf_check] = ACTIONS(281),
    [anon_sym_shadowcallstack] = ACTIONS(281),
    [anon_sym_mustprogress] = ACTIONS(281),
    [anon_sym_vscale_range] = ACTIONS(281),
    [anon_sym_preallocated] = ACTIONS(281),
    [anon_sym_zeroext] = ACTIONS(281),
    [anon_sym_signext] = ACTIONS(281),
    [anon_sym_inreg] = ACTIONS(281),
    [anon_sym_byval] = ACTIONS(281),
    [anon_sym_byref] = ACTIONS(281),
    [anon_sym_inalloca] = ACTIONS(281),
    [anon_sym_sret] = ACTIONS(281),
    [anon_sym_elementtype] = ACTIONS(281),
    [anon_sym_noalias] = ACTIONS(281),
    [anon_sym_nocapture] = ACTIONS(281),
    [anon_sym_nest] = ACTIONS(281),
    [anon_sym_returned] = ACTIONS(281),
    [anon_sym_nonnull] = ACTIONS(281),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(281),
    [anon_sym_swiftself] = ACTIONS(281),
    [anon_sym_swiftasync] = ACTIONS(281),
    [anon_sym_swifterror] = ACTIONS(281),
    [anon_sym_immarg] = ACTIONS(281),
    [anon_sym_noundef] = ACTIONS(281),
    [anon_sym_unreachable] = ACTIONS(281),
    [anon_sym_ret] = ACTIONS(281),
    [anon_sym_br] = ACTIONS(281),
    [anon_sym_resume] = ACTIONS(281),
    [anon_sym_freeze] = ACTIONS(281),
    [anon_sym_indirectbr] = ACTIONS(281),
    [anon_sym_extractelement] = ACTIONS(281),
    [anon_sym_insertelement] = ACTIONS(281),
    [anon_sym_select] = ACTIONS(281),
    [anon_sym_shufflevector] = ACTIONS(281),
    [anon_sym_fneg] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_invoke] = ACTIONS(281),
    [anon_sym_cleanupret] = ACTIONS(281),
    [anon_sym_catchret] = ACTIONS(281),
    [anon_sym_catchswitch] = ACTIONS(281),
    [anon_sym_catchpad] = ACTIONS(281),
    [anon_sym_cleanuppad] = ACTIONS(281),
    [anon_sym_callbr] = ACTIONS(281),
    [anon_sym_icmp] = ACTIONS(281),
    [anon_sym_fcmp] = ACTIONS(281),
    [anon_sym_va_arg] = ACTIONS(281),
    [anon_sym_phi] = ACTIONS(281),
    [anon_sym_landingpad] = ACTIONS(281),
    [anon_sym_tail] = ACTIONS(281),
    [anon_sym_musttail] = ACTIONS(281),
    [anon_sym_notail] = ACTIONS(281),
    [anon_sym_call] = ACTIONS(281),
    [anon_sym_alloca] = ACTIONS(281),
    [anon_sym_load] = ACTIONS(281),
    [anon_sym_store] = ACTIONS(281),
    [anon_sym_cmpxchg] = ACTIONS(281),
    [anon_sym_atomicrmw] = ACTIONS(281),
    [anon_sym_fence] = ACTIONS(281),
    [anon_sym_getelementptr] = ACTIONS(281),
    [anon_sym_extractvalue] = ACTIONS(281),
    [anon_sym_insertvalue] = ACTIONS(281),
    [anon_sym_true] = ACTIONS(281),
    [anon_sym_false] = ACTIONS(281),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_none] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(281),
    [anon_sym_poison] = ACTIONS(281),
    [anon_sym_zeroinitializer] = ACTIONS(281),
    [anon_sym_blockaddress] = ACTIONS(281),
    [anon_sym_mul] = ACTIONS(281),
    [anon_sym_urem] = ACTIONS(281),
    [anon_sym_srem] = ACTIONS(281),
    [anon_sym_shl] = ACTIONS(281),
    [anon_sym_udiv] = ACTIONS(281),
    [anon_sym_sdiv] = ACTIONS(281),
    [anon_sym_lshr] = ACTIONS(281),
    [anon_sym_ashr] = ACTIONS(281),
    [anon_sym_fmul] = ACTIONS(281),
    [anon_sym_fdiv] = ACTIONS(281),
    [anon_sym_frem] = ACTIONS(281),
    [anon_sym_xchg] = ACTIONS(281),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(281),
    [anon_sym_nand] = ACTIONS(281),
    [anon_sym_or] = ACTIONS(281),
    [anon_sym_xor] = ACTIONS(281),
    [anon_sym_max] = ACTIONS(281),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(281),
    [anon_sym_umin] = ACTIONS(281),
    [anon_sym_fadd] = ACTIONS(281),
    [anon_sym_fsub] = ACTIONS(281),
    [anon_sym_bitcast] = ACTIONS(281),
    [anon_sym_trunc] = ACTIONS(281),
    [anon_sym_zext] = ACTIONS(281),
    [anon_sym_sext] = ACTIONS(281),
    [anon_sym_fptrunc] = ACTIONS(281),
    [anon_sym_fpext] = ACTIONS(281),
    [anon_sym_addrspacecast] = ACTIONS(281),
    [anon_sym_uitofp] = ACTIONS(281),
    [anon_sym_sitofp] = ACTIONS(281),
    [anon_sym_fptoui] = ACTIONS(281),
    [anon_sym_fptosi] = ACTIONS(281),
    [anon_sym_inttoptr] = ACTIONS(281),
    [anon_sym_ptrtoint] = ACTIONS(281),
    [anon_sym_uselistorder] = ACTIONS(281),
  },
  [42] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_label] = ACTIONS(116),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(122),
    [anon_sym_partition] = ACTIONS(122),
    [anon_sym_comdat] = ACTIONS(122),
    [anon_sym_gc] = ACTIONS(122),
    [anon_sym_prefix] = ACTIONS(122),
    [anon_sym_prologue] = ACTIONS(122),
    [anon_sym_personality] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(122),
    [anon_sym_allocsize] = ACTIONS(122),
    [anon_sym_alwaysinline] = ACTIONS(122),
    [anon_sym_builtin] = ACTIONS(122),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(122),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(122),
    [anon_sym_hot] = ACTIONS(122),
    [anon_sym_inaccessiblememonly] = ACTIONS(122),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(122),
    [anon_sym_inlinehint] = ACTIONS(122),
    [anon_sym_jumptable] = ACTIONS(122),
    [anon_sym_minsize] = ACTIONS(122),
    [anon_sym_naked] = ACTIONS(122),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(122),
    [anon_sym_nobuiltin] = ACTIONS(122),
    [anon_sym_noduplicate] = ACTIONS(122),
    [anon_sym_nofree] = ACTIONS(122),
    [anon_sym_noimplicitfloat] = ACTIONS(122),
    [anon_sym_noinline] = ACTIONS(122),
    [anon_sym_nomerge] = ACTIONS(122),
    [anon_sym_nonlazybind] = ACTIONS(122),
    [anon_sym_noprofile] = ACTIONS(122),
    [anon_sym_noredzone] = ACTIONS(122),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(122),
    [anon_sym_noreturn] = ACTIONS(122),
    [anon_sym_norecurse] = ACTIONS(122),
    [anon_sym_willreturn] = ACTIONS(122),
    [anon_sym_nosync] = ACTIONS(122),
    [anon_sym_nounwind] = ACTIONS(122),
    [anon_sym_nosanitize_coverage] = ACTIONS(122),
    [anon_sym_null_pointer_is_valid] = ACTIONS(122),
    [anon_sym_optforfuzzing] = ACTIONS(122),
    [anon_sym_optnone] = ACTIONS(122),
    [anon_sym_optsize] = ACTIONS(122),
    [anon_sym_readnone] = ACTIONS(122),
    [anon_sym_readonly] = ACTIONS(122),
    [anon_sym_writeonly] = ACTIONS(122),
    [anon_sym_argmemonly] = ACTIONS(122),
    [anon_sym_returns_twice] = ACTIONS(122),
    [anon_sym_safestack] = ACTIONS(122),
    [anon_sym_sanitize_address] = ACTIONS(122),
    [anon_sym_sanitize_memory] = ACTIONS(122),
    [anon_sym_sanitize_thread] = ACTIONS(122),
    [anon_sym_sanitize_hwaddress] = ACTIONS(122),
    [anon_sym_sanitize_memtag] = ACTIONS(122),
    [anon_sym_speculative_load_hardening] = ACTIONS(122),
    [anon_sym_speculatable] = ACTIONS(122),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(122),
    [anon_sym_sspreq] = ACTIONS(122),
    [anon_sym_strictfp] = ACTIONS(122),
    [anon_sym_uwtable] = ACTIONS(122),
    [anon_sym_nocf_check] = ACTIONS(122),
    [anon_sym_shadowcallstack] = ACTIONS(122),
    [anon_sym_mustprogress] = ACTIONS(122),
    [anon_sym_vscale_range] = ACTIONS(122),
    [anon_sym_preallocated] = ACTIONS(122),
    [anon_sym_zeroext] = ACTIONS(122),
    [anon_sym_signext] = ACTIONS(122),
    [anon_sym_inreg] = ACTIONS(122),
    [anon_sym_byval] = ACTIONS(122),
    [anon_sym_byref] = ACTIONS(122),
    [anon_sym_inalloca] = ACTIONS(122),
    [anon_sym_sret] = ACTIONS(122),
    [anon_sym_elementtype] = ACTIONS(122),
    [anon_sym_noalias] = ACTIONS(122),
    [anon_sym_nocapture] = ACTIONS(122),
    [anon_sym_nest] = ACTIONS(122),
    [anon_sym_returned] = ACTIONS(122),
    [anon_sym_nonnull] = ACTIONS(122),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(122),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(122),
    [anon_sym_noundef] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
  },
  [43] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(283),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [sym_label] = ACTIONS(283),
    [sym_string] = ACTIONS(285),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(285),
    [sym_float] = ACTIONS(285),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(285),
    [anon_sym_private] = ACTIONS(285),
    [anon_sym_internal] = ACTIONS(285),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(285),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(285),
    [anon_sym_available_externally] = ACTIONS(285),
    [anon_sym_appending] = ACTIONS(285),
    [anon_sym_common] = ACTIONS(285),
    [anon_sym_extern_weak] = ACTIONS(285),
    [anon_sym_external] = ACTIONS(285),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(285),
    [anon_sym_dso_preemptable] = ACTIONS(285),
    [anon_sym_default] = ACTIONS(285),
    [anon_sym_hidden] = ACTIONS(285),
    [anon_sym_protected] = ACTIONS(285),
    [anon_sym_dllimport] = ACTIONS(285),
    [anon_sym_dllexport] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_align] = ACTIONS(285),
    [anon_sym_section] = ACTIONS(285),
    [anon_sym_partition] = ACTIONS(285),
    [anon_sym_comdat] = ACTIONS(285),
    [anon_sym_gc] = ACTIONS(285),
    [anon_sym_prefix] = ACTIONS(285),
    [anon_sym_prologue] = ACTIONS(285),
    [anon_sym_personality] = ACTIONS(285),
    [anon_sym_alignstack] = ACTIONS(285),
    [anon_sym_allocsize] = ACTIONS(285),
    [anon_sym_alwaysinline] = ACTIONS(285),
    [anon_sym_builtin] = ACTIONS(285),
    [anon_sym_cold] = ACTIONS(285),
    [anon_sym_convergent] = ACTIONS(285),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(285),
    [anon_sym_hot] = ACTIONS(285),
    [anon_sym_inaccessiblememonly] = ACTIONS(285),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(285),
    [anon_sym_inlinehint] = ACTIONS(285),
    [anon_sym_jumptable] = ACTIONS(285),
    [anon_sym_minsize] = ACTIONS(285),
    [anon_sym_naked] = ACTIONS(285),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(285),
    [anon_sym_nobuiltin] = ACTIONS(285),
    [anon_sym_noduplicate] = ACTIONS(285),
    [anon_sym_nofree] = ACTIONS(285),
    [anon_sym_noimplicitfloat] = ACTIONS(285),
    [anon_sym_noinline] = ACTIONS(285),
    [anon_sym_nomerge] = ACTIONS(285),
    [anon_sym_nonlazybind] = ACTIONS(285),
    [anon_sym_noprofile] = ACTIONS(285),
    [anon_sym_noredzone] = ACTIONS(285),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(285),
    [anon_sym_noreturn] = ACTIONS(285),
    [anon_sym_norecurse] = ACTIONS(285),
    [anon_sym_willreturn] = ACTIONS(285),
    [anon_sym_nosync] = ACTIONS(285),
    [anon_sym_nounwind] = ACTIONS(285),
    [anon_sym_nosanitize_coverage] = ACTIONS(285),
    [anon_sym_null_pointer_is_valid] = ACTIONS(285),
    [anon_sym_optforfuzzing] = ACTIONS(285),
    [anon_sym_optnone] = ACTIONS(285),
    [anon_sym_optsize] = ACTIONS(285),
    [anon_sym_readnone] = ACTIONS(285),
    [anon_sym_readonly] = ACTIONS(285),
    [anon_sym_writeonly] = ACTIONS(285),
    [anon_sym_argmemonly] = ACTIONS(285),
    [anon_sym_returns_twice] = ACTIONS(285),
    [anon_sym_safestack] = ACTIONS(285),
    [anon_sym_sanitize_address] = ACTIONS(285),
    [anon_sym_sanitize_memory] = ACTIONS(285),
    [anon_sym_sanitize_thread] = ACTIONS(285),
    [anon_sym_sanitize_hwaddress] = ACTIONS(285),
    [anon_sym_sanitize_memtag] = ACTIONS(285),
    [anon_sym_speculative_load_hardening] = ACTIONS(285),
    [anon_sym_speculatable] = ACTIONS(285),
    [anon_sym_ssp] = ACTIONS(285),
    [anon_sym_sspstrong] = ACTIONS(285),
    [anon_sym_sspreq] = ACTIONS(285),
    [anon_sym_strictfp] = ACTIONS(285),
    [anon_sym_uwtable] = ACTIONS(285),
    [anon_sym_nocf_check] = ACTIONS(285),
    [anon_sym_shadowcallstack] = ACTIONS(285),
    [anon_sym_mustprogress] = ACTIONS(285),
    [anon_sym_vscale_range] = ACTIONS(285),
    [anon_sym_preallocated] = ACTIONS(285),
    [anon_sym_zeroext] = ACTIONS(285),
    [anon_sym_signext] = ACTIONS(285),
    [anon_sym_inreg] = ACTIONS(285),
    [anon_sym_byval] = ACTIONS(285),
    [anon_sym_byref] = ACTIONS(285),
    [anon_sym_inalloca] = ACTIONS(285),
    [anon_sym_sret] = ACTIONS(285),
    [anon_sym_elementtype] = ACTIONS(285),
    [anon_sym_noalias] = ACTIONS(285),
    [anon_sym_nocapture] = ACTIONS(285),
    [anon_sym_nest] = ACTIONS(285),
    [anon_sym_returned] = ACTIONS(285),
    [anon_sym_nonnull] = ACTIONS(285),
    [anon_sym_dereferenceable] = ACTIONS(285),
    [anon_sym_dereferenceable_or_null] = ACTIONS(285),
    [anon_sym_swiftself] = ACTIONS(285),
    [anon_sym_swiftasync] = ACTIONS(285),
    [anon_sym_swifterror] = ACTIONS(285),
    [anon_sym_immarg] = ACTIONS(285),
    [anon_sym_noundef] = ACTIONS(285),
    [anon_sym_unreachable] = ACTIONS(285),
    [anon_sym_ret] = ACTIONS(285),
    [anon_sym_br] = ACTIONS(285),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_freeze] = ACTIONS(285),
    [anon_sym_indirectbr] = ACTIONS(285),
    [anon_sym_extractelement] = ACTIONS(285),
    [anon_sym_insertelement] = ACTIONS(285),
    [anon_sym_select] = ACTIONS(285),
    [anon_sym_shufflevector] = ACTIONS(285),
    [anon_sym_fneg] = ACTIONS(285),
    [anon_sym_switch] = ACTIONS(285),
    [anon_sym_invoke] = ACTIONS(285),
    [anon_sym_cleanupret] = ACTIONS(285),
    [anon_sym_catchret] = ACTIONS(285),
    [anon_sym_catchswitch] = ACTIONS(285),
    [anon_sym_catchpad] = ACTIONS(285),
    [anon_sym_cleanuppad] = ACTIONS(285),
    [anon_sym_callbr] = ACTIONS(285),
    [anon_sym_icmp] = ACTIONS(285),
    [anon_sym_fcmp] = ACTIONS(285),
    [anon_sym_va_arg] = ACTIONS(285),
    [anon_sym_phi] = ACTIONS(285),
    [anon_sym_landingpad] = ACTIONS(285),
    [anon_sym_tail] = ACTIONS(285),
    [anon_sym_musttail] = ACTIONS(285),
    [anon_sym_notail] = ACTIONS(285),
    [anon_sym_call] = ACTIONS(285),
    [anon_sym_alloca] = ACTIONS(285),
    [anon_sym_load] = ACTIONS(285),
    [anon_sym_store] = ACTIONS(285),
    [anon_sym_cmpxchg] = ACTIONS(285),
    [anon_sym_atomicrmw] = ACTIONS(285),
    [anon_sym_fence] = ACTIONS(285),
    [anon_sym_getelementptr] = ACTIONS(285),
    [anon_sym_extractvalue] = ACTIONS(285),
    [anon_sym_insertvalue] = ACTIONS(285),
    [anon_sym_true] = ACTIONS(285),
    [anon_sym_false] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(285),
    [anon_sym_none] = ACTIONS(285),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_poison] = ACTIONS(285),
    [anon_sym_zeroinitializer] = ACTIONS(285),
    [anon_sym_blockaddress] = ACTIONS(285),
    [anon_sym_mul] = ACTIONS(285),
    [anon_sym_urem] = ACTIONS(285),
    [anon_sym_srem] = ACTIONS(285),
    [anon_sym_shl] = ACTIONS(285),
    [anon_sym_udiv] = ACTIONS(285),
    [anon_sym_sdiv] = ACTIONS(285),
    [anon_sym_lshr] = ACTIONS(285),
    [anon_sym_ashr] = ACTIONS(285),
    [anon_sym_fmul] = ACTIONS(285),
    [anon_sym_fdiv] = ACTIONS(285),
    [anon_sym_frem] = ACTIONS(285),
    [anon_sym_xchg] = ACTIONS(285),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(285),
    [anon_sym_and] = ACTIONS(285),
    [anon_sym_nand] = ACTIONS(285),
    [anon_sym_or] = ACTIONS(285),
    [anon_sym_xor] = ACTIONS(285),
    [anon_sym_max] = ACTIONS(285),
    [anon_sym_min] = ACTIONS(285),
    [anon_sym_umax] = ACTIONS(285),
    [anon_sym_umin] = ACTIONS(285),
    [anon_sym_fadd] = ACTIONS(285),
    [anon_sym_fsub] = ACTIONS(285),
    [anon_sym_bitcast] = ACTIONS(285),
    [anon_sym_trunc] = ACTIONS(285),
    [anon_sym_zext] = ACTIONS(285),
    [anon_sym_sext] = ACTIONS(285),
    [anon_sym_fptrunc] = ACTIONS(285),
    [anon_sym_fpext] = ACTIONS(285),
    [anon_sym_addrspacecast] = ACTIONS(285),
    [anon_sym_uitofp] = ACTIONS(285),
    [anon_sym_sitofp] = ACTIONS(285),
    [anon_sym_fptoui] = ACTIONS(285),
    [anon_sym_fptosi] = ACTIONS(285),
    [anon_sym_inttoptr] = ACTIONS(285),
    [anon_sym_ptrtoint] = ACTIONS(285),
    [anon_sym_uselistorder] = ACTIONS(285),
  },
  [44] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(303),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [sym_label] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(305),
    [sym_float] = ACTIONS(305),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(305),
    [anon_sym_private] = ACTIONS(305),
    [anon_sym_internal] = ACTIONS(305),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(305),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(305),
    [anon_sym_available_externally] = ACTIONS(305),
    [anon_sym_appending] = ACTIONS(305),
    [anon_sym_common] = ACTIONS(305),
    [anon_sym_extern_weak] = ACTIONS(305),
    [anon_sym_external] = ACTIONS(305),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(305),
    [anon_sym_dso_preemptable] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(305),
    [anon_sym_hidden] = ACTIONS(305),
    [anon_sym_protected] = ACTIONS(305),
    [anon_sym_dllimport] = ACTIONS(305),
    [anon_sym_dllexport] = ACTIONS(305),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_align] = ACTIONS(305),
    [anon_sym_section] = ACTIONS(305),
    [anon_sym_partition] = ACTIONS(305),
    [anon_sym_comdat] = ACTIONS(305),
    [anon_sym_gc] = ACTIONS(305),
    [anon_sym_prefix] = ACTIONS(305),
    [anon_sym_prologue] = ACTIONS(305),
    [anon_sym_personality] = ACTIONS(305),
    [anon_sym_alignstack] = ACTIONS(305),
    [anon_sym_allocsize] = ACTIONS(305),
    [anon_sym_alwaysinline] = ACTIONS(305),
    [anon_sym_builtin] = ACTIONS(305),
    [anon_sym_cold] = ACTIONS(305),
    [anon_sym_convergent] = ACTIONS(305),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(305),
    [anon_sym_hot] = ACTIONS(305),
    [anon_sym_inaccessiblememonly] = ACTIONS(305),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(305),
    [anon_sym_inlinehint] = ACTIONS(305),
    [anon_sym_jumptable] = ACTIONS(305),
    [anon_sym_minsize] = ACTIONS(305),
    [anon_sym_naked] = ACTIONS(305),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(305),
    [anon_sym_nobuiltin] = ACTIONS(305),
    [anon_sym_noduplicate] = ACTIONS(305),
    [anon_sym_nofree] = ACTIONS(305),
    [anon_sym_noimplicitfloat] = ACTIONS(305),
    [anon_sym_noinline] = ACTIONS(305),
    [anon_sym_nomerge] = ACTIONS(305),
    [anon_sym_nonlazybind] = ACTIONS(305),
    [anon_sym_noprofile] = ACTIONS(305),
    [anon_sym_noredzone] = ACTIONS(305),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(305),
    [anon_sym_noreturn] = ACTIONS(305),
    [anon_sym_norecurse] = ACTIONS(305),
    [anon_sym_willreturn] = ACTIONS(305),
    [anon_sym_nosync] = ACTIONS(305),
    [anon_sym_nounwind] = ACTIONS(305),
    [anon_sym_nosanitize_coverage] = ACTIONS(305),
    [anon_sym_null_pointer_is_valid] = ACTIONS(305),
    [anon_sym_optforfuzzing] = ACTIONS(305),
    [anon_sym_optnone] = ACTIONS(305),
    [anon_sym_optsize] = ACTIONS(305),
    [anon_sym_readnone] = ACTIONS(305),
    [anon_sym_readonly] = ACTIONS(305),
    [anon_sym_writeonly] = ACTIONS(305),
    [anon_sym_argmemonly] = ACTIONS(305),
    [anon_sym_returns_twice] = ACTIONS(305),
    [anon_sym_safestack] = ACTIONS(305),
    [anon_sym_sanitize_address] = ACTIONS(305),
    [anon_sym_sanitize_memory] = ACTIONS(305),
    [anon_sym_sanitize_thread] = ACTIONS(305),
    [anon_sym_sanitize_hwaddress] = ACTIONS(305),
    [anon_sym_sanitize_memtag] = ACTIONS(305),
    [anon_sym_speculative_load_hardening] = ACTIONS(305),
    [anon_sym_speculatable] = ACTIONS(305),
    [anon_sym_ssp] = ACTIONS(305),
    [anon_sym_sspstrong] = ACTIONS(305),
    [anon_sym_sspreq] = ACTIONS(305),
    [anon_sym_strictfp] = ACTIONS(305),
    [anon_sym_uwtable] = ACTIONS(305),
    [anon_sym_nocf_check] = ACTIONS(305),
    [anon_sym_shadowcallstack] = ACTIONS(305),
    [anon_sym_mustprogress] = ACTIONS(305),
    [anon_sym_vscale_range] = ACTIONS(305),
    [anon_sym_preallocated] = ACTIONS(305),
    [anon_sym_zeroext] = ACTIONS(305),
    [anon_sym_signext] = ACTIONS(305),
    [anon_sym_inreg] = ACTIONS(305),
    [anon_sym_byval] = ACTIONS(305),
    [anon_sym_byref] = ACTIONS(305),
    [anon_sym_inalloca] = ACTIONS(305),
    [anon_sym_sret] = ACTIONS(305),
    [anon_sym_elementtype] = ACTIONS(305),
    [anon_sym_noalias] = ACTIONS(305),
    [anon_sym_nocapture] = ACTIONS(305),
    [anon_sym_nest] = ACTIONS(305),
    [anon_sym_returned] = ACTIONS(305),
    [anon_sym_nonnull] = ACTIONS(305),
    [anon_sym_dereferenceable] = ACTIONS(305),
    [anon_sym_dereferenceable_or_null] = ACTIONS(305),
    [anon_sym_swiftself] = ACTIONS(305),
    [anon_sym_swiftasync] = ACTIONS(305),
    [anon_sym_swifterror] = ACTIONS(305),
    [anon_sym_immarg] = ACTIONS(305),
    [anon_sym_noundef] = ACTIONS(305),
    [anon_sym_unreachable] = ACTIONS(305),
    [anon_sym_ret] = ACTIONS(305),
    [anon_sym_br] = ACTIONS(305),
    [anon_sym_resume] = ACTIONS(305),
    [anon_sym_freeze] = ACTIONS(305),
    [anon_sym_indirectbr] = ACTIONS(305),
    [anon_sym_extractelement] = ACTIONS(305),
    [anon_sym_insertelement] = ACTIONS(305),
    [anon_sym_select] = ACTIONS(305),
    [anon_sym_shufflevector] = ACTIONS(305),
    [anon_sym_fneg] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(305),
    [anon_sym_invoke] = ACTIONS(305),
    [anon_sym_cleanupret] = ACTIONS(305),
    [anon_sym_catchret] = ACTIONS(305),
    [anon_sym_catchswitch] = ACTIONS(305),
    [anon_sym_catchpad] = ACTIONS(305),
    [anon_sym_cleanuppad] = ACTIONS(305),
    [anon_sym_callbr] = ACTIONS(305),
    [anon_sym_icmp] = ACTIONS(305),
    [anon_sym_fcmp] = ACTIONS(305),
    [anon_sym_va_arg] = ACTIONS(305),
    [anon_sym_phi] = ACTIONS(305),
    [anon_sym_landingpad] = ACTIONS(305),
    [anon_sym_tail] = ACTIONS(305),
    [anon_sym_musttail] = ACTIONS(305),
    [anon_sym_notail] = ACTIONS(305),
    [anon_sym_call] = ACTIONS(305),
    [anon_sym_alloca] = ACTIONS(305),
    [anon_sym_load] = ACTIONS(305),
    [anon_sym_store] = ACTIONS(305),
    [anon_sym_cmpxchg] = ACTIONS(305),
    [anon_sym_atomicrmw] = ACTIONS(305),
    [anon_sym_fence] = ACTIONS(305),
    [anon_sym_getelementptr] = ACTIONS(305),
    [anon_sym_extractvalue] = ACTIONS(305),
    [anon_sym_insertvalue] = ACTIONS(305),
    [anon_sym_true] = ACTIONS(305),
    [anon_sym_false] = ACTIONS(305),
    [anon_sym_null] = ACTIONS(305),
    [anon_sym_none] = ACTIONS(305),
    [anon_sym_undef] = ACTIONS(305),
    [anon_sym_poison] = ACTIONS(305),
    [anon_sym_zeroinitializer] = ACTIONS(305),
    [anon_sym_blockaddress] = ACTIONS(305),
    [anon_sym_mul] = ACTIONS(305),
    [anon_sym_urem] = ACTIONS(305),
    [anon_sym_srem] = ACTIONS(305),
    [anon_sym_shl] = ACTIONS(305),
    [anon_sym_udiv] = ACTIONS(305),
    [anon_sym_sdiv] = ACTIONS(305),
    [anon_sym_lshr] = ACTIONS(305),
    [anon_sym_ashr] = ACTIONS(305),
    [anon_sym_fmul] = ACTIONS(305),
    [anon_sym_fdiv] = ACTIONS(305),
    [anon_sym_frem] = ACTIONS(305),
    [anon_sym_xchg] = ACTIONS(305),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(305),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_nand] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_xor] = ACTIONS(305),
    [anon_sym_max] = ACTIONS(305),
    [anon_sym_min] = ACTIONS(305),
    [anon_sym_umax] = ACTIONS(305),
    [anon_sym_umin] = ACTIONS(305),
    [anon_sym_fadd] = ACTIONS(305),
    [anon_sym_fsub] = ACTIONS(305),
    [anon_sym_bitcast] = ACTIONS(305),
    [anon_sym_trunc] = ACTIONS(305),
    [anon_sym_zext] = ACTIONS(305),
    [anon_sym_sext] = ACTIONS(305),
    [anon_sym_fptrunc] = ACTIONS(305),
    [anon_sym_fpext] = ACTIONS(305),
    [anon_sym_addrspacecast] = ACTIONS(305),
    [anon_sym_uitofp] = ACTIONS(305),
    [anon_sym_sitofp] = ACTIONS(305),
    [anon_sym_fptoui] = ACTIONS(305),
    [anon_sym_fptosi] = ACTIONS(305),
    [anon_sym_inttoptr] = ACTIONS(305),
    [anon_sym_ptrtoint] = ACTIONS(305),
    [anon_sym_uselistorder] = ACTIONS(305),
  },
  [45] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(365),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [sym_label] = ACTIONS(365),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_align] = ACTIONS(367),
    [anon_sym_section] = ACTIONS(367),
    [anon_sym_partition] = ACTIONS(367),
    [anon_sym_comdat] = ACTIONS(367),
    [anon_sym_gc] = ACTIONS(367),
    [anon_sym_prefix] = ACTIONS(367),
    [anon_sym_prologue] = ACTIONS(367),
    [anon_sym_personality] = ACTIONS(367),
    [anon_sym_alignstack] = ACTIONS(367),
    [anon_sym_allocsize] = ACTIONS(367),
    [anon_sym_alwaysinline] = ACTIONS(367),
    [anon_sym_builtin] = ACTIONS(367),
    [anon_sym_cold] = ACTIONS(367),
    [anon_sym_convergent] = ACTIONS(367),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(367),
    [anon_sym_hot] = ACTIONS(367),
    [anon_sym_inaccessiblememonly] = ACTIONS(367),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(367),
    [anon_sym_inlinehint] = ACTIONS(367),
    [anon_sym_jumptable] = ACTIONS(367),
    [anon_sym_minsize] = ACTIONS(367),
    [anon_sym_naked] = ACTIONS(367),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(367),
    [anon_sym_nobuiltin] = ACTIONS(367),
    [anon_sym_noduplicate] = ACTIONS(367),
    [anon_sym_nofree] = ACTIONS(367),
    [anon_sym_noimplicitfloat] = ACTIONS(367),
    [anon_sym_noinline] = ACTIONS(367),
    [anon_sym_nomerge] = ACTIONS(367),
    [anon_sym_nonlazybind] = ACTIONS(367),
    [anon_sym_noprofile] = ACTIONS(367),
    [anon_sym_noredzone] = ACTIONS(367),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(367),
    [anon_sym_noreturn] = ACTIONS(367),
    [anon_sym_norecurse] = ACTIONS(367),
    [anon_sym_willreturn] = ACTIONS(367),
    [anon_sym_nosync] = ACTIONS(367),
    [anon_sym_nounwind] = ACTIONS(367),
    [anon_sym_nosanitize_coverage] = ACTIONS(367),
    [anon_sym_null_pointer_is_valid] = ACTIONS(367),
    [anon_sym_optforfuzzing] = ACTIONS(367),
    [anon_sym_optnone] = ACTIONS(367),
    [anon_sym_optsize] = ACTIONS(367),
    [anon_sym_readnone] = ACTIONS(367),
    [anon_sym_readonly] = ACTIONS(367),
    [anon_sym_writeonly] = ACTIONS(367),
    [anon_sym_argmemonly] = ACTIONS(367),
    [anon_sym_returns_twice] = ACTIONS(367),
    [anon_sym_safestack] = ACTIONS(367),
    [anon_sym_sanitize_address] = ACTIONS(367),
    [anon_sym_sanitize_memory] = ACTIONS(367),
    [anon_sym_sanitize_thread] = ACTIONS(367),
    [anon_sym_sanitize_hwaddress] = ACTIONS(367),
    [anon_sym_sanitize_memtag] = ACTIONS(367),
    [anon_sym_speculative_load_hardening] = ACTIONS(367),
    [anon_sym_speculatable] = ACTIONS(367),
    [anon_sym_ssp] = ACTIONS(367),
    [anon_sym_sspstrong] = ACTIONS(367),
    [anon_sym_sspreq] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_uwtable] = ACTIONS(367),
    [anon_sym_nocf_check] = ACTIONS(367),
    [anon_sym_shadowcallstack] = ACTIONS(367),
    [anon_sym_mustprogress] = ACTIONS(367),
    [anon_sym_vscale_range] = ACTIONS(367),
    [anon_sym_preallocated] = ACTIONS(367),
    [anon_sym_zeroext] = ACTIONS(367),
    [anon_sym_signext] = ACTIONS(367),
    [anon_sym_inreg] = ACTIONS(367),
    [anon_sym_byval] = ACTIONS(367),
    [anon_sym_byref] = ACTIONS(367),
    [anon_sym_inalloca] = ACTIONS(367),
    [anon_sym_sret] = ACTIONS(367),
    [anon_sym_elementtype] = ACTIONS(367),
    [anon_sym_noalias] = ACTIONS(367),
    [anon_sym_nocapture] = ACTIONS(367),
    [anon_sym_nest] = ACTIONS(367),
    [anon_sym_returned] = ACTIONS(367),
    [anon_sym_nonnull] = ACTIONS(367),
    [anon_sym_dereferenceable] = ACTIONS(367),
    [anon_sym_dereferenceable_or_null] = ACTIONS(367),
    [anon_sym_swiftself] = ACTIONS(367),
    [anon_sym_swiftasync] = ACTIONS(367),
    [anon_sym_swifterror] = ACTIONS(367),
    [anon_sym_immarg] = ACTIONS(367),
    [anon_sym_noundef] = ACTIONS(367),
    [anon_sym_unreachable] = ACTIONS(367),
    [anon_sym_ret] = ACTIONS(367),
    [anon_sym_br] = ACTIONS(367),
    [anon_sym_resume] = ACTIONS(367),
    [anon_sym_freeze] = ACTIONS(367),
    [anon_sym_indirectbr] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_switch] = ACTIONS(367),
    [anon_sym_invoke] = ACTIONS(367),
    [anon_sym_cleanupret] = ACTIONS(367),
    [anon_sym_catchret] = ACTIONS(367),
    [anon_sym_catchswitch] = ACTIONS(367),
    [anon_sym_catchpad] = ACTIONS(367),
    [anon_sym_cleanuppad] = ACTIONS(367),
    [anon_sym_callbr] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_va_arg] = ACTIONS(367),
    [anon_sym_phi] = ACTIONS(367),
    [anon_sym_landingpad] = ACTIONS(367),
    [anon_sym_tail] = ACTIONS(367),
    [anon_sym_musttail] = ACTIONS(367),
    [anon_sym_notail] = ACTIONS(367),
    [anon_sym_call] = ACTIONS(367),
    [anon_sym_alloca] = ACTIONS(367),
    [anon_sym_load] = ACTIONS(367),
    [anon_sym_store] = ACTIONS(367),
    [anon_sym_cmpxchg] = ACTIONS(367),
    [anon_sym_atomicrmw] = ACTIONS(367),
    [anon_sym_fence] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
    [anon_sym_uselistorder] = ACTIONS(367),
  },
  [46] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(252),
    [anon_sym_partition] = ACTIONS(252),
    [anon_sym_comdat] = ACTIONS(252),
    [anon_sym_gc] = ACTIONS(252),
    [anon_sym_prefix] = ACTIONS(252),
    [anon_sym_prologue] = ACTIONS(252),
    [anon_sym_personality] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(252),
    [anon_sym_allocsize] = ACTIONS(252),
    [anon_sym_alwaysinline] = ACTIONS(252),
    [anon_sym_builtin] = ACTIONS(252),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(252),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(252),
    [anon_sym_hot] = ACTIONS(252),
    [anon_sym_inaccessiblememonly] = ACTIONS(252),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(252),
    [anon_sym_inlinehint] = ACTIONS(252),
    [anon_sym_jumptable] = ACTIONS(252),
    [anon_sym_minsize] = ACTIONS(252),
    [anon_sym_naked] = ACTIONS(252),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(252),
    [anon_sym_nobuiltin] = ACTIONS(252),
    [anon_sym_noduplicate] = ACTIONS(252),
    [anon_sym_nofree] = ACTIONS(252),
    [anon_sym_noimplicitfloat] = ACTIONS(252),
    [anon_sym_noinline] = ACTIONS(252),
    [anon_sym_nomerge] = ACTIONS(252),
    [anon_sym_nonlazybind] = ACTIONS(252),
    [anon_sym_noprofile] = ACTIONS(252),
    [anon_sym_noredzone] = ACTIONS(252),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(252),
    [anon_sym_noreturn] = ACTIONS(252),
    [anon_sym_norecurse] = ACTIONS(252),
    [anon_sym_willreturn] = ACTIONS(252),
    [anon_sym_nosync] = ACTIONS(252),
    [anon_sym_nounwind] = ACTIONS(252),
    [anon_sym_nosanitize_coverage] = ACTIONS(252),
    [anon_sym_null_pointer_is_valid] = ACTIONS(252),
    [anon_sym_optforfuzzing] = ACTIONS(252),
    [anon_sym_optnone] = ACTIONS(252),
    [anon_sym_optsize] = ACTIONS(252),
    [anon_sym_readnone] = ACTIONS(252),
    [anon_sym_readonly] = ACTIONS(252),
    [anon_sym_writeonly] = ACTIONS(252),
    [anon_sym_argmemonly] = ACTIONS(252),
    [anon_sym_returns_twice] = ACTIONS(252),
    [anon_sym_safestack] = ACTIONS(252),
    [anon_sym_sanitize_address] = ACTIONS(252),
    [anon_sym_sanitize_memory] = ACTIONS(252),
    [anon_sym_sanitize_thread] = ACTIONS(252),
    [anon_sym_sanitize_hwaddress] = ACTIONS(252),
    [anon_sym_sanitize_memtag] = ACTIONS(252),
    [anon_sym_speculative_load_hardening] = ACTIONS(252),
    [anon_sym_speculatable] = ACTIONS(252),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(252),
    [anon_sym_sspreq] = ACTIONS(252),
    [anon_sym_strictfp] = ACTIONS(252),
    [anon_sym_uwtable] = ACTIONS(252),
    [anon_sym_nocf_check] = ACTIONS(252),
    [anon_sym_shadowcallstack] = ACTIONS(252),
    [anon_sym_mustprogress] = ACTIONS(252),
    [anon_sym_vscale_range] = ACTIONS(252),
    [anon_sym_preallocated] = ACTIONS(252),
    [anon_sym_zeroext] = ACTIONS(252),
    [anon_sym_signext] = ACTIONS(252),
    [anon_sym_inreg] = ACTIONS(252),
    [anon_sym_byval] = ACTIONS(252),
    [anon_sym_byref] = ACTIONS(252),
    [anon_sym_inalloca] = ACTIONS(252),
    [anon_sym_sret] = ACTIONS(252),
    [anon_sym_elementtype] = ACTIONS(252),
    [anon_sym_noalias] = ACTIONS(252),
    [anon_sym_nocapture] = ACTIONS(252),
    [anon_sym_nest] = ACTIONS(252),
    [anon_sym_returned] = ACTIONS(252),
    [anon_sym_nonnull] = ACTIONS(252),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(252),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(252),
    [anon_sym_noundef] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [47] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(307),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [sym_label] = ACTIONS(307),
    [sym_string] = ACTIONS(309),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(309),
    [sym_float] = ACTIONS(309),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(309),
    [anon_sym_private] = ACTIONS(309),
    [anon_sym_internal] = ACTIONS(309),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(309),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(309),
    [anon_sym_available_externally] = ACTIONS(309),
    [anon_sym_appending] = ACTIONS(309),
    [anon_sym_common] = ACTIONS(309),
    [anon_sym_extern_weak] = ACTIONS(309),
    [anon_sym_external] = ACTIONS(309),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(309),
    [anon_sym_dso_preemptable] = ACTIONS(309),
    [anon_sym_default] = ACTIONS(309),
    [anon_sym_hidden] = ACTIONS(309),
    [anon_sym_protected] = ACTIONS(309),
    [anon_sym_dllimport] = ACTIONS(309),
    [anon_sym_dllexport] = ACTIONS(309),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_align] = ACTIONS(309),
    [anon_sym_section] = ACTIONS(309),
    [anon_sym_partition] = ACTIONS(309),
    [anon_sym_comdat] = ACTIONS(309),
    [anon_sym_gc] = ACTIONS(309),
    [anon_sym_prefix] = ACTIONS(309),
    [anon_sym_prologue] = ACTIONS(309),
    [anon_sym_personality] = ACTIONS(309),
    [anon_sym_alignstack] = ACTIONS(309),
    [anon_sym_allocsize] = ACTIONS(309),
    [anon_sym_alwaysinline] = ACTIONS(309),
    [anon_sym_builtin] = ACTIONS(309),
    [anon_sym_cold] = ACTIONS(309),
    [anon_sym_convergent] = ACTIONS(309),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(309),
    [anon_sym_hot] = ACTIONS(309),
    [anon_sym_inaccessiblememonly] = ACTIONS(309),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(309),
    [anon_sym_inlinehint] = ACTIONS(309),
    [anon_sym_jumptable] = ACTIONS(309),
    [anon_sym_minsize] = ACTIONS(309),
    [anon_sym_naked] = ACTIONS(309),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(309),
    [anon_sym_nobuiltin] = ACTIONS(309),
    [anon_sym_noduplicate] = ACTIONS(309),
    [anon_sym_nofree] = ACTIONS(309),
    [anon_sym_noimplicitfloat] = ACTIONS(309),
    [anon_sym_noinline] = ACTIONS(309),
    [anon_sym_nomerge] = ACTIONS(309),
    [anon_sym_nonlazybind] = ACTIONS(309),
    [anon_sym_noprofile] = ACTIONS(309),
    [anon_sym_noredzone] = ACTIONS(309),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(309),
    [anon_sym_noreturn] = ACTIONS(309),
    [anon_sym_norecurse] = ACTIONS(309),
    [anon_sym_willreturn] = ACTIONS(309),
    [anon_sym_nosync] = ACTIONS(309),
    [anon_sym_nounwind] = ACTIONS(309),
    [anon_sym_nosanitize_coverage] = ACTIONS(309),
    [anon_sym_null_pointer_is_valid] = ACTIONS(309),
    [anon_sym_optforfuzzing] = ACTIONS(309),
    [anon_sym_optnone] = ACTIONS(309),
    [anon_sym_optsize] = ACTIONS(309),
    [anon_sym_readnone] = ACTIONS(309),
    [anon_sym_readonly] = ACTIONS(309),
    [anon_sym_writeonly] = ACTIONS(309),
    [anon_sym_argmemonly] = ACTIONS(309),
    [anon_sym_returns_twice] = ACTIONS(309),
    [anon_sym_safestack] = ACTIONS(309),
    [anon_sym_sanitize_address] = ACTIONS(309),
    [anon_sym_sanitize_memory] = ACTIONS(309),
    [anon_sym_sanitize_thread] = ACTIONS(309),
    [anon_sym_sanitize_hwaddress] = ACTIONS(309),
    [anon_sym_sanitize_memtag] = ACTIONS(309),
    [anon_sym_speculative_load_hardening] = ACTIONS(309),
    [anon_sym_speculatable] = ACTIONS(309),
    [anon_sym_ssp] = ACTIONS(309),
    [anon_sym_sspstrong] = ACTIONS(309),
    [anon_sym_sspreq] = ACTIONS(309),
    [anon_sym_strictfp] = ACTIONS(309),
    [anon_sym_uwtable] = ACTIONS(309),
    [anon_sym_nocf_check] = ACTIONS(309),
    [anon_sym_shadowcallstack] = ACTIONS(309),
    [anon_sym_mustprogress] = ACTIONS(309),
    [anon_sym_vscale_range] = ACTIONS(309),
    [anon_sym_preallocated] = ACTIONS(309),
    [anon_sym_zeroext] = ACTIONS(309),
    [anon_sym_signext] = ACTIONS(309),
    [anon_sym_inreg] = ACTIONS(309),
    [anon_sym_byval] = ACTIONS(309),
    [anon_sym_byref] = ACTIONS(309),
    [anon_sym_inalloca] = ACTIONS(309),
    [anon_sym_sret] = ACTIONS(309),
    [anon_sym_elementtype] = ACTIONS(309),
    [anon_sym_noalias] = ACTIONS(309),
    [anon_sym_nocapture] = ACTIONS(309),
    [anon_sym_nest] = ACTIONS(309),
    [anon_sym_returned] = ACTIONS(309),
    [anon_sym_nonnull] = ACTIONS(309),
    [anon_sym_dereferenceable] = ACTIONS(309),
    [anon_sym_dereferenceable_or_null] = ACTIONS(309),
    [anon_sym_swiftself] = ACTIONS(309),
    [anon_sym_swiftasync] = ACTIONS(309),
    [anon_sym_swifterror] = ACTIONS(309),
    [anon_sym_immarg] = ACTIONS(309),
    [anon_sym_noundef] = ACTIONS(309),
    [anon_sym_unreachable] = ACTIONS(309),
    [anon_sym_ret] = ACTIONS(309),
    [anon_sym_br] = ACTIONS(309),
    [anon_sym_resume] = ACTIONS(309),
    [anon_sym_freeze] = ACTIONS(309),
    [anon_sym_indirectbr] = ACTIONS(309),
    [anon_sym_extractelement] = ACTIONS(309),
    [anon_sym_insertelement] = ACTIONS(309),
    [anon_sym_select] = ACTIONS(309),
    [anon_sym_shufflevector] = ACTIONS(309),
    [anon_sym_fneg] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_invoke] = ACTIONS(309),
    [anon_sym_cleanupret] = ACTIONS(309),
    [anon_sym_catchret] = ACTIONS(309),
    [anon_sym_catchswitch] = ACTIONS(309),
    [anon_sym_catchpad] = ACTIONS(309),
    [anon_sym_cleanuppad] = ACTIONS(309),
    [anon_sym_callbr] = ACTIONS(309),
    [anon_sym_icmp] = ACTIONS(309),
    [anon_sym_fcmp] = ACTIONS(309),
    [anon_sym_va_arg] = ACTIONS(309),
    [anon_sym_phi] = ACTIONS(309),
    [anon_sym_landingpad] = ACTIONS(309),
    [anon_sym_tail] = ACTIONS(309),
    [anon_sym_musttail] = ACTIONS(309),
    [anon_sym_notail] = ACTIONS(309),
    [anon_sym_call] = ACTIONS(309),
    [anon_sym_alloca] = ACTIONS(309),
    [anon_sym_load] = ACTIONS(309),
    [anon_sym_store] = ACTIONS(309),
    [anon_sym_cmpxchg] = ACTIONS(309),
    [anon_sym_atomicrmw] = ACTIONS(309),
    [anon_sym_fence] = ACTIONS(309),
    [anon_sym_getelementptr] = ACTIONS(309),
    [anon_sym_extractvalue] = ACTIONS(309),
    [anon_sym_insertvalue] = ACTIONS(309),
    [anon_sym_true] = ACTIONS(309),
    [anon_sym_false] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(309),
    [anon_sym_none] = ACTIONS(309),
    [anon_sym_undef] = ACTIONS(309),
    [anon_sym_poison] = ACTIONS(309),
    [anon_sym_zeroinitializer] = ACTIONS(309),
    [anon_sym_blockaddress] = ACTIONS(309),
    [anon_sym_mul] = ACTIONS(309),
    [anon_sym_urem] = ACTIONS(309),
    [anon_sym_srem] = ACTIONS(309),
    [anon_sym_shl] = ACTIONS(309),
    [anon_sym_udiv] = ACTIONS(309),
    [anon_sym_sdiv] = ACTIONS(309),
    [anon_sym_lshr] = ACTIONS(309),
    [anon_sym_ashr] = ACTIONS(309),
    [anon_sym_fmul] = ACTIONS(309),
    [anon_sym_fdiv] = ACTIONS(309),
    [anon_sym_frem] = ACTIONS(309),
    [anon_sym_xchg] = ACTIONS(309),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(309),
    [anon_sym_nand] = ACTIONS(309),
    [anon_sym_or] = ACTIONS(309),
    [anon_sym_xor] = ACTIONS(309),
    [anon_sym_max] = ACTIONS(309),
    [anon_sym_min] = ACTIONS(309),
    [anon_sym_umax] = ACTIONS(309),
    [anon_sym_umin] = ACTIONS(309),
    [anon_sym_fadd] = ACTIONS(309),
    [anon_sym_fsub] = ACTIONS(309),
    [anon_sym_bitcast] = ACTIONS(309),
    [anon_sym_trunc] = ACTIONS(309),
    [anon_sym_zext] = ACTIONS(309),
    [anon_sym_sext] = ACTIONS(309),
    [anon_sym_fptrunc] = ACTIONS(309),
    [anon_sym_fpext] = ACTIONS(309),
    [anon_sym_addrspacecast] = ACTIONS(309),
    [anon_sym_uitofp] = ACTIONS(309),
    [anon_sym_sitofp] = ACTIONS(309),
    [anon_sym_fptoui] = ACTIONS(309),
    [anon_sym_fptosi] = ACTIONS(309),
    [anon_sym_inttoptr] = ACTIONS(309),
    [anon_sym_ptrtoint] = ACTIONS(309),
    [anon_sym_uselistorder] = ACTIONS(309),
  },
  [48] = {
    [sym_metadata_ref] = STATE(286),
    [sym_type] = STATE(57),
    [sym_type_keyword] = STATE(63),
    [sym_struct_type] = STATE(63),
    [sym_packed_struct_type] = STATE(63),
    [sym_array_type] = STATE(63),
    [sym_vector_type] = STATE(63),
    [sym_type_and_value] = STATE(300),
    [sym_metadata] = STATE(308),
    [sym_metadata_tuple] = STATE(300),
    [sym_specialized_md] = STATE(300),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(369),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(373),
    [anon_sym_half] = ACTIONS(373),
    [anon_sym_bfloat] = ACTIONS(373),
    [anon_sym_float] = ACTIONS(373),
    [anon_sym_double] = ACTIONS(373),
    [anon_sym_x86_fp80] = ACTIONS(373),
    [anon_sym_fp128] = ACTIONS(373),
    [anon_sym_ppc_fp128] = ACTIONS(373),
    [anon_sym_label] = ACTIONS(373),
    [anon_sym_metadata] = ACTIONS(420),
    [anon_sym_x86_mmx] = ACTIONS(373),
    [anon_sym_x86_amx] = ACTIONS(373),
    [anon_sym_token] = ACTIONS(373),
    [anon_sym_opaque] = ACTIONS(373),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(389),
  },
  [49] = {
    [sym_metadata_ref] = STATE(286),
    [sym_type] = STATE(55),
    [sym_type_keyword] = STATE(63),
    [sym_struct_type] = STATE(63),
    [sym_packed_struct_type] = STATE(63),
    [sym_array_type] = STATE(63),
    [sym_vector_type] = STATE(63),
    [sym_type_and_value] = STATE(300),
    [sym_metadata] = STATE(308),
    [sym_metadata_tuple] = STATE(300),
    [sym_specialized_md] = STATE(300),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(369),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(373),
    [anon_sym_half] = ACTIONS(373),
    [anon_sym_bfloat] = ACTIONS(373),
    [anon_sym_float] = ACTIONS(373),
    [anon_sym_double] = ACTIONS(373),
    [anon_sym_x86_fp80] = ACTIONS(373),
    [anon_sym_fp128] = ACTIONS(373),
    [anon_sym_ppc_fp128] = ACTIONS(373),
    [anon_sym_label] = ACTIONS(373),
    [anon_sym_metadata] = ACTIONS(422),
    [anon_sym_x86_mmx] = ACTIONS(373),
    [anon_sym_x86_amx] = ACTIONS(373),
    [anon_sym_token] = ACTIONS(373),
    [anon_sym_opaque] = ACTIONS(373),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(389),
  },
  [50] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(265),
    [anon_sym_partition] = ACTIONS(265),
    [anon_sym_comdat] = ACTIONS(265),
    [anon_sym_gc] = ACTIONS(265),
    [anon_sym_prefix] = ACTIONS(265),
    [anon_sym_prologue] = ACTIONS(265),
    [anon_sym_personality] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(265),
    [anon_sym_allocsize] = ACTIONS(265),
    [anon_sym_alwaysinline] = ACTIONS(265),
    [anon_sym_builtin] = ACTIONS(265),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(265),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(265),
    [anon_sym_hot] = ACTIONS(265),
    [anon_sym_inaccessiblememonly] = ACTIONS(265),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(265),
    [anon_sym_inlinehint] = ACTIONS(265),
    [anon_sym_jumptable] = ACTIONS(265),
    [anon_sym_minsize] = ACTIONS(265),
    [anon_sym_naked] = ACTIONS(265),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(265),
    [anon_sym_nobuiltin] = ACTIONS(265),
    [anon_sym_noduplicate] = ACTIONS(265),
    [anon_sym_nofree] = ACTIONS(265),
    [anon_sym_noimplicitfloat] = ACTIONS(265),
    [anon_sym_noinline] = ACTIONS(265),
    [anon_sym_nomerge] = ACTIONS(265),
    [anon_sym_nonlazybind] = ACTIONS(265),
    [anon_sym_noprofile] = ACTIONS(265),
    [anon_sym_noredzone] = ACTIONS(265),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(265),
    [anon_sym_noreturn] = ACTIONS(265),
    [anon_sym_norecurse] = ACTIONS(265),
    [anon_sym_willreturn] = ACTIONS(265),
    [anon_sym_nosync] = ACTIONS(265),
    [anon_sym_nounwind] = ACTIONS(265),
    [anon_sym_nosanitize_coverage] = ACTIONS(265),
    [anon_sym_null_pointer_is_valid] = ACTIONS(265),
    [anon_sym_optforfuzzing] = ACTIONS(265),
    [anon_sym_optnone] = ACTIONS(265),
    [anon_sym_optsize] = ACTIONS(265),
    [anon_sym_readnone] = ACTIONS(265),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_writeonly] = ACTIONS(265),
    [anon_sym_argmemonly] = ACTIONS(265),
    [anon_sym_returns_twice] = ACTIONS(265),
    [anon_sym_safestack] = ACTIONS(265),
    [anon_sym_sanitize_address] = ACTIONS(265),
    [anon_sym_sanitize_memory] = ACTIONS(265),
    [anon_sym_sanitize_thread] = ACTIONS(265),
    [anon_sym_sanitize_hwaddress] = ACTIONS(265),
    [anon_sym_sanitize_memtag] = ACTIONS(265),
    [anon_sym_speculative_load_hardening] = ACTIONS(265),
    [anon_sym_speculatable] = ACTIONS(265),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(265),
    [anon_sym_sspreq] = ACTIONS(265),
    [anon_sym_strictfp] = ACTIONS(265),
    [anon_sym_uwtable] = ACTIONS(265),
    [anon_sym_nocf_check] = ACTIONS(265),
    [anon_sym_shadowcallstack] = ACTIONS(265),
    [anon_sym_mustprogress] = ACTIONS(265),
    [anon_sym_vscale_range] = ACTIONS(265),
    [anon_sym_preallocated] = ACTIONS(265),
    [anon_sym_zeroext] = ACTIONS(265),
    [anon_sym_signext] = ACTIONS(265),
    [anon_sym_inreg] = ACTIONS(265),
    [anon_sym_byval] = ACTIONS(265),
    [anon_sym_byref] = ACTIONS(265),
    [anon_sym_inalloca] = ACTIONS(265),
    [anon_sym_sret] = ACTIONS(265),
    [anon_sym_elementtype] = ACTIONS(265),
    [anon_sym_noalias] = ACTIONS(265),
    [anon_sym_nocapture] = ACTIONS(265),
    [anon_sym_nest] = ACTIONS(265),
    [anon_sym_returned] = ACTIONS(265),
    [anon_sym_nonnull] = ACTIONS(265),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(265),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(265),
    [anon_sym_noundef] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [51] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(397),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [sym_label] = ACTIONS(397),
    [sym_string] = ACTIONS(399),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(399),
    [sym_float] = ACTIONS(399),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(399),
    [anon_sym_private] = ACTIONS(399),
    [anon_sym_internal] = ACTIONS(399),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(399),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(399),
    [anon_sym_available_externally] = ACTIONS(399),
    [anon_sym_appending] = ACTIONS(399),
    [anon_sym_common] = ACTIONS(399),
    [anon_sym_extern_weak] = ACTIONS(399),
    [anon_sym_external] = ACTIONS(399),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(399),
    [anon_sym_dso_preemptable] = ACTIONS(399),
    [anon_sym_default] = ACTIONS(399),
    [anon_sym_hidden] = ACTIONS(399),
    [anon_sym_protected] = ACTIONS(399),
    [anon_sym_dllimport] = ACTIONS(399),
    [anon_sym_dllexport] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_align] = ACTIONS(399),
    [anon_sym_section] = ACTIONS(399),
    [anon_sym_partition] = ACTIONS(399),
    [anon_sym_comdat] = ACTIONS(399),
    [anon_sym_gc] = ACTIONS(399),
    [anon_sym_prefix] = ACTIONS(399),
    [anon_sym_prologue] = ACTIONS(399),
    [anon_sym_personality] = ACTIONS(399),
    [anon_sym_alignstack] = ACTIONS(399),
    [anon_sym_allocsize] = ACTIONS(399),
    [anon_sym_alwaysinline] = ACTIONS(399),
    [anon_sym_builtin] = ACTIONS(399),
    [anon_sym_cold] = ACTIONS(399),
    [anon_sym_convergent] = ACTIONS(399),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(399),
    [anon_sym_hot] = ACTIONS(399),
    [anon_sym_inaccessiblememonly] = ACTIONS(399),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(399),
    [anon_sym_inlinehint] = ACTIONS(399),
    [anon_sym_jumptable] = ACTIONS(399),
    [anon_sym_minsize] = ACTIONS(399),
    [anon_sym_naked] = ACTIONS(399),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(399),
    [anon_sym_nobuiltin] = ACTIONS(399),
    [anon_sym_noduplicate] = ACTIONS(399),
    [anon_sym_nofree] = ACTIONS(399),
    [anon_sym_noimplicitfloat] = ACTIONS(399),
    [anon_sym_noinline] = ACTIONS(399),
    [anon_sym_nomerge] = ACTIONS(399),
    [anon_sym_nonlazybind] = ACTIONS(399),
    [anon_sym_noprofile] = ACTIONS(399),
    [anon_sym_noredzone] = ACTIONS(399),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(399),
    [anon_sym_noreturn] = ACTIONS(399),
    [anon_sym_norecurse] = ACTIONS(399),
    [anon_sym_willreturn] = ACTIONS(399),
    [anon_sym_nosync] = ACTIONS(399),
    [anon_sym_nounwind] = ACTIONS(399),
    [anon_sym_nosanitize_coverage] = ACTIONS(399),
    [anon_sym_null_pointer_is_valid] = ACTIONS(399),
    [anon_sym_optforfuzzing] = ACTIONS(399),
    [anon_sym_optnone] = ACTIONS(399),
    [anon_sym_optsize] = ACTIONS(399),
    [anon_sym_readnone] = ACTIONS(399),
    [anon_sym_readonly] = ACTIONS(399),
    [anon_sym_writeonly] = ACTIONS(399),
    [anon_sym_argmemonly] = ACTIONS(399),
    [anon_sym_returns_twice] = ACTIONS(399),
    [anon_sym_safestack] = ACTIONS(399),
    [anon_sym_sanitize_address] = ACTIONS(399),
    [anon_sym_sanitize_memory] = ACTIONS(399),
    [anon_sym_sanitize_thread] = ACTIONS(399),
    [anon_sym_sanitize_hwaddress] = ACTIONS(399),
    [anon_sym_sanitize_memtag] = ACTIONS(399),
    [anon_sym_speculative_load_hardening] = ACTIONS(399),
    [anon_sym_speculatable] = ACTIONS(399),
    [anon_sym_ssp] = ACTIONS(399),
    [anon_sym_sspstrong] = ACTIONS(399),
    [anon_sym_sspreq] = ACTIONS(399),
    [anon_sym_strictfp] = ACTIONS(399),
    [anon_sym_uwtable] = ACTIONS(399),
    [anon_sym_nocf_check] = ACTIONS(399),
    [anon_sym_shadowcallstack] = ACTIONS(399),
    [anon_sym_mustprogress] = ACTIONS(399),
    [anon_sym_vscale_range] = ACTIONS(399),
    [anon_sym_preallocated] = ACTIONS(399),
    [anon_sym_zeroext] = ACTIONS(399),
    [anon_sym_signext] = ACTIONS(399),
    [anon_sym_inreg] = ACTIONS(399),
    [anon_sym_byval] = ACTIONS(399),
    [anon_sym_byref] = ACTIONS(399),
    [anon_sym_inalloca] = ACTIONS(399),
    [anon_sym_sret] = ACTIONS(399),
    [anon_sym_elementtype] = ACTIONS(399),
    [anon_sym_noalias] = ACTIONS(399),
    [anon_sym_nocapture] = ACTIONS(399),
    [anon_sym_nest] = ACTIONS(399),
    [anon_sym_returned] = ACTIONS(399),
    [anon_sym_nonnull] = ACTIONS(399),
    [anon_sym_dereferenceable] = ACTIONS(399),
    [anon_sym_dereferenceable_or_null] = ACTIONS(399),
    [anon_sym_swiftself] = ACTIONS(399),
    [anon_sym_swiftasync] = ACTIONS(399),
    [anon_sym_swifterror] = ACTIONS(399),
    [anon_sym_immarg] = ACTIONS(399),
    [anon_sym_noundef] = ACTIONS(399),
    [anon_sym_unreachable] = ACTIONS(399),
    [anon_sym_ret] = ACTIONS(399),
    [anon_sym_br] = ACTIONS(399),
    [anon_sym_resume] = ACTIONS(399),
    [anon_sym_freeze] = ACTIONS(399),
    [anon_sym_indirectbr] = ACTIONS(399),
    [anon_sym_extractelement] = ACTIONS(399),
    [anon_sym_insertelement] = ACTIONS(399),
    [anon_sym_select] = ACTIONS(399),
    [anon_sym_shufflevector] = ACTIONS(399),
    [anon_sym_fneg] = ACTIONS(399),
    [anon_sym_switch] = ACTIONS(399),
    [anon_sym_invoke] = ACTIONS(399),
    [anon_sym_cleanupret] = ACTIONS(399),
    [anon_sym_catchret] = ACTIONS(399),
    [anon_sym_catchswitch] = ACTIONS(399),
    [anon_sym_catchpad] = ACTIONS(399),
    [anon_sym_cleanuppad] = ACTIONS(399),
    [anon_sym_callbr] = ACTIONS(399),
    [anon_sym_icmp] = ACTIONS(399),
    [anon_sym_fcmp] = ACTIONS(399),
    [anon_sym_va_arg] = ACTIONS(399),
    [anon_sym_phi] = ACTIONS(399),
    [anon_sym_landingpad] = ACTIONS(399),
    [anon_sym_tail] = ACTIONS(399),
    [anon_sym_musttail] = ACTIONS(399),
    [anon_sym_notail] = ACTIONS(399),
    [anon_sym_call] = ACTIONS(399),
    [anon_sym_alloca] = ACTIONS(399),
    [anon_sym_load] = ACTIONS(399),
    [anon_sym_store] = ACTIONS(399),
    [anon_sym_cmpxchg] = ACTIONS(399),
    [anon_sym_atomicrmw] = ACTIONS(399),
    [anon_sym_fence] = ACTIONS(399),
    [anon_sym_getelementptr] = ACTIONS(399),
    [anon_sym_extractvalue] = ACTIONS(399),
    [anon_sym_insertvalue] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(399),
    [anon_sym_false] = ACTIONS(399),
    [anon_sym_null] = ACTIONS(399),
    [anon_sym_none] = ACTIONS(399),
    [anon_sym_undef] = ACTIONS(399),
    [anon_sym_poison] = ACTIONS(399),
    [anon_sym_zeroinitializer] = ACTIONS(399),
    [anon_sym_blockaddress] = ACTIONS(399),
    [anon_sym_mul] = ACTIONS(399),
    [anon_sym_urem] = ACTIONS(399),
    [anon_sym_srem] = ACTIONS(399),
    [anon_sym_shl] = ACTIONS(399),
    [anon_sym_udiv] = ACTIONS(399),
    [anon_sym_sdiv] = ACTIONS(399),
    [anon_sym_lshr] = ACTIONS(399),
    [anon_sym_ashr] = ACTIONS(399),
    [anon_sym_fmul] = ACTIONS(399),
    [anon_sym_fdiv] = ACTIONS(399),
    [anon_sym_frem] = ACTIONS(399),
    [anon_sym_xchg] = ACTIONS(399),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(399),
    [anon_sym_nand] = ACTIONS(399),
    [anon_sym_or] = ACTIONS(399),
    [anon_sym_xor] = ACTIONS(399),
    [anon_sym_max] = ACTIONS(399),
    [anon_sym_min] = ACTIONS(399),
    [anon_sym_umax] = ACTIONS(399),
    [anon_sym_umin] = ACTIONS(399),
    [anon_sym_fadd] = ACTIONS(399),
    [anon_sym_fsub] = ACTIONS(399),
    [anon_sym_bitcast] = ACTIONS(399),
    [anon_sym_trunc] = ACTIONS(399),
    [anon_sym_zext] = ACTIONS(399),
    [anon_sym_sext] = ACTIONS(399),
    [anon_sym_fptrunc] = ACTIONS(399),
    [anon_sym_fpext] = ACTIONS(399),
    [anon_sym_addrspacecast] = ACTIONS(399),
    [anon_sym_uitofp] = ACTIONS(399),
    [anon_sym_sitofp] = ACTIONS(399),
    [anon_sym_fptoui] = ACTIONS(399),
    [anon_sym_fptosi] = ACTIONS(399),
    [anon_sym_inttoptr] = ACTIONS(399),
    [anon_sym_ptrtoint] = ACTIONS(399),
    [anon_sym_uselistorder] = ACTIONS(399),
  },
  [52] = {
    [sym_metadata_ref] = STATE(286),
    [sym_type] = STATE(56),
    [sym_type_keyword] = STATE(63),
    [sym_struct_type] = STATE(63),
    [sym_packed_struct_type] = STATE(63),
    [sym_array_type] = STATE(63),
    [sym_vector_type] = STATE(63),
    [sym_type_and_value] = STATE(300),
    [sym_metadata] = STATE(308),
    [sym_metadata_tuple] = STATE(300),
    [sym_specialized_md] = STATE(300),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(369),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(373),
    [anon_sym_half] = ACTIONS(373),
    [anon_sym_bfloat] = ACTIONS(373),
    [anon_sym_float] = ACTIONS(373),
    [anon_sym_double] = ACTIONS(373),
    [anon_sym_x86_fp80] = ACTIONS(373),
    [anon_sym_fp128] = ACTIONS(373),
    [anon_sym_ppc_fp128] = ACTIONS(373),
    [anon_sym_label] = ACTIONS(373),
    [anon_sym_metadata] = ACTIONS(426),
    [anon_sym_x86_mmx] = ACTIONS(373),
    [anon_sym_x86_amx] = ACTIONS(373),
    [anon_sym_token] = ACTIONS(373),
    [anon_sym_opaque] = ACTIONS(373),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(389),
  },
  [53] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [54] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(393),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [sym_label] = ACTIONS(393),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_align] = ACTIONS(395),
    [anon_sym_section] = ACTIONS(395),
    [anon_sym_partition] = ACTIONS(395),
    [anon_sym_comdat] = ACTIONS(395),
    [anon_sym_gc] = ACTIONS(395),
    [anon_sym_prefix] = ACTIONS(395),
    [anon_sym_prologue] = ACTIONS(395),
    [anon_sym_personality] = ACTIONS(395),
    [anon_sym_alignstack] = ACTIONS(395),
    [anon_sym_allocsize] = ACTIONS(395),
    [anon_sym_alwaysinline] = ACTIONS(395),
    [anon_sym_builtin] = ACTIONS(395),
    [anon_sym_cold] = ACTIONS(395),
    [anon_sym_convergent] = ACTIONS(395),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(395),
    [anon_sym_hot] = ACTIONS(395),
    [anon_sym_inaccessiblememonly] = ACTIONS(395),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(395),
    [anon_sym_inlinehint] = ACTIONS(395),
    [anon_sym_jumptable] = ACTIONS(395),
    [anon_sym_minsize] = ACTIONS(395),
    [anon_sym_naked] = ACTIONS(395),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(395),
    [anon_sym_nobuiltin] = ACTIONS(395),
    [anon_sym_noduplicate] = ACTIONS(395),
    [anon_sym_nofree] = ACTIONS(395),
    [anon_sym_noimplicitfloat] = ACTIONS(395),
    [anon_sym_noinline] = ACTIONS(395),
    [anon_sym_nomerge] = ACTIONS(395),
    [anon_sym_nonlazybind] = ACTIONS(395),
    [anon_sym_noprofile] = ACTIONS(395),
    [anon_sym_noredzone] = ACTIONS(395),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(395),
    [anon_sym_noreturn] = ACTIONS(395),
    [anon_sym_norecurse] = ACTIONS(395),
    [anon_sym_willreturn] = ACTIONS(395),
    [anon_sym_nosync] = ACTIONS(395),
    [anon_sym_nounwind] = ACTIONS(395),
    [anon_sym_nosanitize_coverage] = ACTIONS(395),
    [anon_sym_null_pointer_is_valid] = ACTIONS(395),
    [anon_sym_optforfuzzing] = ACTIONS(395),
    [anon_sym_optnone] = ACTIONS(395),
    [anon_sym_optsize] = ACTIONS(395),
    [anon_sym_readnone] = ACTIONS(395),
    [anon_sym_readonly] = ACTIONS(395),
    [anon_sym_writeonly] = ACTIONS(395),
    [anon_sym_argmemonly] = ACTIONS(395),
    [anon_sym_returns_twice] = ACTIONS(395),
    [anon_sym_safestack] = ACTIONS(395),
    [anon_sym_sanitize_address] = ACTIONS(395),
    [anon_sym_sanitize_memory] = ACTIONS(395),
    [anon_sym_sanitize_thread] = ACTIONS(395),
    [anon_sym_sanitize_hwaddress] = ACTIONS(395),
    [anon_sym_sanitize_memtag] = ACTIONS(395),
    [anon_sym_speculative_load_hardening] = ACTIONS(395),
    [anon_sym_speculatable] = ACTIONS(395),
    [anon_sym_ssp] = ACTIONS(395),
    [anon_sym_sspstrong] = ACTIONS(395),
    [anon_sym_sspreq] = ACTIONS(395),
    [anon_sym_strictfp] = ACTIONS(395),
    [anon_sym_uwtable] = ACTIONS(395),
    [anon_sym_nocf_check] = ACTIONS(395),
    [anon_sym_shadowcallstack] = ACTIONS(395),
    [anon_sym_mustprogress] = ACTIONS(395),
    [anon_sym_vscale_range] = ACTIONS(395),
    [anon_sym_preallocated] = ACTIONS(395),
    [anon_sym_zeroext] = ACTIONS(395),
    [anon_sym_signext] = ACTIONS(395),
    [anon_sym_inreg] = ACTIONS(395),
    [anon_sym_byval] = ACTIONS(395),
    [anon_sym_byref] = ACTIONS(395),
    [anon_sym_inalloca] = ACTIONS(395),
    [anon_sym_sret] = ACTIONS(395),
    [anon_sym_elementtype] = ACTIONS(395),
    [anon_sym_noalias] = ACTIONS(395),
    [anon_sym_nocapture] = ACTIONS(395),
    [anon_sym_nest] = ACTIONS(395),
    [anon_sym_returned] = ACTIONS(395),
    [anon_sym_nonnull] = ACTIONS(395),
    [anon_sym_dereferenceable] = ACTIONS(395),
    [anon_sym_dereferenceable_or_null] = ACTIONS(395),
    [anon_sym_swiftself] = ACTIONS(395),
    [anon_sym_swiftasync] = ACTIONS(395),
    [anon_sym_swifterror] = ACTIONS(395),
    [anon_sym_immarg] = ACTIONS(395),
    [anon_sym_noundef] = ACTIONS(395),
    [anon_sym_unreachable] = ACTIONS(395),
    [anon_sym_ret] = ACTIONS(395),
    [anon_sym_br] = ACTIONS(395),
    [anon_sym_resume] = ACTIONS(395),
    [anon_sym_freeze] = ACTIONS(395),
    [anon_sym_indirectbr] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_switch] = ACTIONS(395),
    [anon_sym_invoke] = ACTIONS(395),
    [anon_sym_cleanupret] = ACTIONS(395),
    [anon_sym_catchret] = ACTIONS(395),
    [anon_sym_catchswitch] = ACTIONS(395),
    [anon_sym_catchpad] = ACTIONS(395),
    [anon_sym_cleanuppad] = ACTIONS(395),
    [anon_sym_callbr] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_va_arg] = ACTIONS(395),
    [anon_sym_phi] = ACTIONS(395),
    [anon_sym_landingpad] = ACTIONS(395),
    [anon_sym_tail] = ACTIONS(395),
    [anon_sym_musttail] = ACTIONS(395),
    [anon_sym_notail] = ACTIONS(395),
    [anon_sym_call] = ACTIONS(395),
    [anon_sym_alloca] = ACTIONS(395),
    [anon_sym_load] = ACTIONS(395),
    [anon_sym_store] = ACTIONS(395),
    [anon_sym_cmpxchg] = ACTIONS(395),
    [anon_sym_atomicrmw] = ACTIONS(395),
    [anon_sym_fence] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
    [anon_sym_uselistorder] = ACTIONS(395),
  },
  [55] = {
    [sym_number] = STATE(317),
    [sym_var] = STATE(317),
    [sym_linkage] = STATE(750),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(321),
    [sym__primitive_value] = STATE(317),
    [sym_struct_value] = STATE(317),
    [sym_packed_struct_value] = STATE(317),
    [sym_array_value] = STATE(317),
    [sym_vector_value] = STATE(317),
    [sym_blockaddress] = STATE(317),
    [sym_constant_expr] = STATE(317),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [aux_sym_function_header_repeat1] = STATE(750),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(428),
    [sym_local_var] = ACTIONS(428),
    [sym_string] = ACTIONS(314),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(321),
    [sym_cstring] = ACTIONS(321),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LT_LBRACE] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(430),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_to] = ACTIONS(38),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_none] = ACTIONS(321),
    [anon_sym_undef] = ACTIONS(321),
    [anon_sym_poison] = ACTIONS(321),
    [anon_sym_zeroinitializer] = ACTIONS(321),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [56] = {
    [sym_number] = STATE(317),
    [sym_var] = STATE(317),
    [sym_linkage] = STATE(750),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(321),
    [sym__primitive_value] = STATE(317),
    [sym_struct_value] = STATE(317),
    [sym_packed_struct_value] = STATE(317),
    [sym_array_value] = STATE(317),
    [sym_vector_value] = STATE(317),
    [sym_blockaddress] = STATE(317),
    [sym_constant_expr] = STATE(317),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [aux_sym_function_header_repeat1] = STATE(750),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(428),
    [sym_local_var] = ACTIONS(428),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(314),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(321),
    [sym_cstring] = ACTIONS(321),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(433),
    [anon_sym_LT_LBRACE] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_none] = ACTIONS(321),
    [anon_sym_undef] = ACTIONS(321),
    [anon_sym_poison] = ACTIONS(321),
    [anon_sym_zeroinitializer] = ACTIONS(321),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [57] = {
    [sym_number] = STATE(317),
    [sym_var] = STATE(317),
    [sym_linkage] = STATE(750),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(321),
    [sym__primitive_value] = STATE(317),
    [sym_struct_value] = STATE(317),
    [sym_packed_struct_value] = STATE(317),
    [sym_array_value] = STATE(317),
    [sym_vector_value] = STATE(317),
    [sym_blockaddress] = STATE(317),
    [sym_constant_expr] = STATE(317),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [aux_sym_function_header_repeat1] = STATE(750),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(428),
    [sym_local_var] = ACTIONS(428),
    [sym_string] = ACTIONS(314),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(321),
    [sym_cstring] = ACTIONS(321),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_none] = ACTIONS(321),
    [anon_sym_undef] = ACTIONS(321),
    [anon_sym_poison] = ACTIONS(321),
    [anon_sym_zeroinitializer] = ACTIONS(321),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [58] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(266),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_param_or_return_attrs] = STATE(340),
    [sym_attribute_name] = STATE(389),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(1425),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [aux_sym_function_header_repeat2] = STATE(340),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [59] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_param_or_return_attrs] = STATE(60),
    [sym_attribute_name] = STATE(209),
    [sym_value] = STATE(1411),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [aux_sym_function_header_repeat2] = STATE(60),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_align] = ACTIONS(468),
    [anon_sym_alignstack] = ACTIONS(470),
    [anon_sym_allocsize] = ACTIONS(470),
    [anon_sym_alwaysinline] = ACTIONS(470),
    [anon_sym_builtin] = ACTIONS(470),
    [anon_sym_cold] = ACTIONS(470),
    [anon_sym_convergent] = ACTIONS(470),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(470),
    [anon_sym_hot] = ACTIONS(470),
    [anon_sym_inaccessiblememonly] = ACTIONS(470),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(470),
    [anon_sym_inlinehint] = ACTIONS(470),
    [anon_sym_jumptable] = ACTIONS(470),
    [anon_sym_minsize] = ACTIONS(470),
    [anon_sym_naked] = ACTIONS(470),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(470),
    [anon_sym_nobuiltin] = ACTIONS(470),
    [anon_sym_noduplicate] = ACTIONS(470),
    [anon_sym_nofree] = ACTIONS(470),
    [anon_sym_noimplicitfloat] = ACTIONS(470),
    [anon_sym_noinline] = ACTIONS(470),
    [anon_sym_nomerge] = ACTIONS(470),
    [anon_sym_nonlazybind] = ACTIONS(470),
    [anon_sym_noprofile] = ACTIONS(470),
    [anon_sym_noredzone] = ACTIONS(470),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(470),
    [anon_sym_noreturn] = ACTIONS(470),
    [anon_sym_norecurse] = ACTIONS(470),
    [anon_sym_willreturn] = ACTIONS(470),
    [anon_sym_nosync] = ACTIONS(470),
    [anon_sym_nounwind] = ACTIONS(470),
    [anon_sym_nosanitize_coverage] = ACTIONS(470),
    [anon_sym_null_pointer_is_valid] = ACTIONS(470),
    [anon_sym_optforfuzzing] = ACTIONS(470),
    [anon_sym_optnone] = ACTIONS(470),
    [anon_sym_optsize] = ACTIONS(470),
    [anon_sym_readnone] = ACTIONS(470),
    [anon_sym_readonly] = ACTIONS(470),
    [anon_sym_writeonly] = ACTIONS(470),
    [anon_sym_argmemonly] = ACTIONS(470),
    [anon_sym_returns_twice] = ACTIONS(470),
    [anon_sym_safestack] = ACTIONS(470),
    [anon_sym_sanitize_address] = ACTIONS(470),
    [anon_sym_sanitize_memory] = ACTIONS(470),
    [anon_sym_sanitize_thread] = ACTIONS(470),
    [anon_sym_sanitize_hwaddress] = ACTIONS(470),
    [anon_sym_sanitize_memtag] = ACTIONS(470),
    [anon_sym_speculative_load_hardening] = ACTIONS(470),
    [anon_sym_speculatable] = ACTIONS(470),
    [anon_sym_ssp] = ACTIONS(472),
    [anon_sym_sspstrong] = ACTIONS(470),
    [anon_sym_sspreq] = ACTIONS(470),
    [anon_sym_strictfp] = ACTIONS(470),
    [anon_sym_uwtable] = ACTIONS(470),
    [anon_sym_nocf_check] = ACTIONS(470),
    [anon_sym_shadowcallstack] = ACTIONS(470),
    [anon_sym_mustprogress] = ACTIONS(470),
    [anon_sym_vscale_range] = ACTIONS(470),
    [anon_sym_preallocated] = ACTIONS(470),
    [anon_sym_zeroext] = ACTIONS(470),
    [anon_sym_signext] = ACTIONS(470),
    [anon_sym_inreg] = ACTIONS(470),
    [anon_sym_byval] = ACTIONS(470),
    [anon_sym_byref] = ACTIONS(470),
    [anon_sym_inalloca] = ACTIONS(470),
    [anon_sym_sret] = ACTIONS(470),
    [anon_sym_elementtype] = ACTIONS(470),
    [anon_sym_noalias] = ACTIONS(470),
    [anon_sym_nocapture] = ACTIONS(470),
    [anon_sym_nest] = ACTIONS(470),
    [anon_sym_returned] = ACTIONS(470),
    [anon_sym_nonnull] = ACTIONS(470),
    [anon_sym_dereferenceable] = ACTIONS(472),
    [anon_sym_dereferenceable_or_null] = ACTIONS(470),
    [anon_sym_swiftself] = ACTIONS(470),
    [anon_sym_swiftasync] = ACTIONS(470),
    [anon_sym_swifterror] = ACTIONS(470),
    [anon_sym_immarg] = ACTIONS(470),
    [anon_sym_noundef] = ACTIONS(470),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [60] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_param_or_return_attrs] = STATE(192),
    [sym_attribute_name] = STATE(209),
    [sym_value] = STATE(1358),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [aux_sym_function_header_repeat2] = STATE(192),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_align] = ACTIONS(468),
    [anon_sym_alignstack] = ACTIONS(470),
    [anon_sym_allocsize] = ACTIONS(470),
    [anon_sym_alwaysinline] = ACTIONS(470),
    [anon_sym_builtin] = ACTIONS(470),
    [anon_sym_cold] = ACTIONS(470),
    [anon_sym_convergent] = ACTIONS(470),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(470),
    [anon_sym_hot] = ACTIONS(470),
    [anon_sym_inaccessiblememonly] = ACTIONS(470),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(470),
    [anon_sym_inlinehint] = ACTIONS(470),
    [anon_sym_jumptable] = ACTIONS(470),
    [anon_sym_minsize] = ACTIONS(470),
    [anon_sym_naked] = ACTIONS(470),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(470),
    [anon_sym_nobuiltin] = ACTIONS(470),
    [anon_sym_noduplicate] = ACTIONS(470),
    [anon_sym_nofree] = ACTIONS(470),
    [anon_sym_noimplicitfloat] = ACTIONS(470),
    [anon_sym_noinline] = ACTIONS(470),
    [anon_sym_nomerge] = ACTIONS(470),
    [anon_sym_nonlazybind] = ACTIONS(470),
    [anon_sym_noprofile] = ACTIONS(470),
    [anon_sym_noredzone] = ACTIONS(470),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(470),
    [anon_sym_noreturn] = ACTIONS(470),
    [anon_sym_norecurse] = ACTIONS(470),
    [anon_sym_willreturn] = ACTIONS(470),
    [anon_sym_nosync] = ACTIONS(470),
    [anon_sym_nounwind] = ACTIONS(470),
    [anon_sym_nosanitize_coverage] = ACTIONS(470),
    [anon_sym_null_pointer_is_valid] = ACTIONS(470),
    [anon_sym_optforfuzzing] = ACTIONS(470),
    [anon_sym_optnone] = ACTIONS(470),
    [anon_sym_optsize] = ACTIONS(470),
    [anon_sym_readnone] = ACTIONS(470),
    [anon_sym_readonly] = ACTIONS(470),
    [anon_sym_writeonly] = ACTIONS(470),
    [anon_sym_argmemonly] = ACTIONS(470),
    [anon_sym_returns_twice] = ACTIONS(470),
    [anon_sym_safestack] = ACTIONS(470),
    [anon_sym_sanitize_address] = ACTIONS(470),
    [anon_sym_sanitize_memory] = ACTIONS(470),
    [anon_sym_sanitize_thread] = ACTIONS(470),
    [anon_sym_sanitize_hwaddress] = ACTIONS(470),
    [anon_sym_sanitize_memtag] = ACTIONS(470),
    [anon_sym_speculative_load_hardening] = ACTIONS(470),
    [anon_sym_speculatable] = ACTIONS(470),
    [anon_sym_ssp] = ACTIONS(472),
    [anon_sym_sspstrong] = ACTIONS(470),
    [anon_sym_sspreq] = ACTIONS(470),
    [anon_sym_strictfp] = ACTIONS(470),
    [anon_sym_uwtable] = ACTIONS(470),
    [anon_sym_nocf_check] = ACTIONS(470),
    [anon_sym_shadowcallstack] = ACTIONS(470),
    [anon_sym_mustprogress] = ACTIONS(470),
    [anon_sym_vscale_range] = ACTIONS(470),
    [anon_sym_preallocated] = ACTIONS(470),
    [anon_sym_zeroext] = ACTIONS(470),
    [anon_sym_signext] = ACTIONS(470),
    [anon_sym_inreg] = ACTIONS(470),
    [anon_sym_byval] = ACTIONS(470),
    [anon_sym_byref] = ACTIONS(470),
    [anon_sym_inalloca] = ACTIONS(470),
    [anon_sym_sret] = ACTIONS(470),
    [anon_sym_elementtype] = ACTIONS(470),
    [anon_sym_noalias] = ACTIONS(470),
    [anon_sym_nocapture] = ACTIONS(470),
    [anon_sym_nest] = ACTIONS(470),
    [anon_sym_returned] = ACTIONS(470),
    [anon_sym_nonnull] = ACTIONS(470),
    [anon_sym_dereferenceable] = ACTIONS(472),
    [anon_sym_dereferenceable_or_null] = ACTIONS(470),
    [anon_sym_swiftself] = ACTIONS(470),
    [anon_sym_swiftasync] = ACTIONS(470),
    [anon_sym_swifterror] = ACTIONS(470),
    [anon_sym_immarg] = ACTIONS(470),
    [anon_sym_noundef] = ACTIONS(470),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [61] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(61),
    [aux_sym_type_repeat1] = STATE(1119),
    [aux_sym_type_repeat2] = STATE(61),
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(476),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(250),
    [anon_sym_partition] = ACTIONS(250),
    [anon_sym_comdat] = ACTIONS(250),
    [anon_sym_gc] = ACTIONS(250),
    [anon_sym_prefix] = ACTIONS(250),
    [anon_sym_prologue] = ACTIONS(250),
    [anon_sym_personality] = ACTIONS(250),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(250),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(250),
    [anon_sym_swiftasync] = ACTIONS(250),
    [anon_sym_swifterror] = ACTIONS(250),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [62] = {
    [sym_addrspace] = STATE(81),
    [sym_argument_list] = STATE(61),
    [aux_sym_type_repeat1] = STATE(65),
    [aux_sym_type_repeat2] = STATE(61),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [63] = {
    [sym_addrspace] = STATE(82),
    [sym_argument_list] = STATE(62),
    [aux_sym_type_repeat1] = STATE(64),
    [aux_sym_type_repeat2] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(234),
    [sym_comdat_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_summary_ref] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_target] = ACTIONS(234),
    [anon_sym_source_filename] = ACTIONS(234),
    [anon_sym_declare] = ACTIONS(234),
    [anon_sym_define] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_section] = ACTIONS(234),
    [anon_sym_partition] = ACTIONS(234),
    [anon_sym_comdat] = ACTIONS(234),
    [anon_sym_gc] = ACTIONS(234),
    [anon_sym_prefix] = ACTIONS(234),
    [anon_sym_prologue] = ACTIONS(234),
    [anon_sym_personality] = ACTIONS(234),
    [anon_sym_alignstack] = ACTIONS(234),
    [anon_sym_allocsize] = ACTIONS(234),
    [anon_sym_alwaysinline] = ACTIONS(234),
    [anon_sym_builtin] = ACTIONS(234),
    [anon_sym_cold] = ACTIONS(234),
    [anon_sym_convergent] = ACTIONS(234),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(234),
    [anon_sym_hot] = ACTIONS(234),
    [anon_sym_inaccessiblememonly] = ACTIONS(234),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(234),
    [anon_sym_inlinehint] = ACTIONS(234),
    [anon_sym_jumptable] = ACTIONS(234),
    [anon_sym_minsize] = ACTIONS(234),
    [anon_sym_naked] = ACTIONS(234),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(234),
    [anon_sym_nobuiltin] = ACTIONS(234),
    [anon_sym_noduplicate] = ACTIONS(234),
    [anon_sym_nofree] = ACTIONS(234),
    [anon_sym_noimplicitfloat] = ACTIONS(234),
    [anon_sym_noinline] = ACTIONS(234),
    [anon_sym_nomerge] = ACTIONS(234),
    [anon_sym_nonlazybind] = ACTIONS(234),
    [anon_sym_noprofile] = ACTIONS(234),
    [anon_sym_noredzone] = ACTIONS(234),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(234),
    [anon_sym_noreturn] = ACTIONS(234),
    [anon_sym_norecurse] = ACTIONS(234),
    [anon_sym_willreturn] = ACTIONS(234),
    [anon_sym_nosync] = ACTIONS(234),
    [anon_sym_nounwind] = ACTIONS(234),
    [anon_sym_nosanitize_coverage] = ACTIONS(234),
    [anon_sym_null_pointer_is_valid] = ACTIONS(234),
    [anon_sym_optforfuzzing] = ACTIONS(234),
    [anon_sym_optnone] = ACTIONS(234),
    [anon_sym_optsize] = ACTIONS(234),
    [anon_sym_readnone] = ACTIONS(234),
    [anon_sym_readonly] = ACTIONS(234),
    [anon_sym_writeonly] = ACTIONS(234),
    [anon_sym_argmemonly] = ACTIONS(234),
    [anon_sym_returns_twice] = ACTIONS(234),
    [anon_sym_safestack] = ACTIONS(234),
    [anon_sym_sanitize_address] = ACTIONS(234),
    [anon_sym_sanitize_memory] = ACTIONS(234),
    [anon_sym_sanitize_thread] = ACTIONS(234),
    [anon_sym_sanitize_hwaddress] = ACTIONS(234),
    [anon_sym_sanitize_memtag] = ACTIONS(234),
    [anon_sym_speculative_load_hardening] = ACTIONS(234),
    [anon_sym_speculatable] = ACTIONS(234),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(234),
    [anon_sym_sspreq] = ACTIONS(234),
    [anon_sym_strictfp] = ACTIONS(234),
    [anon_sym_uwtable] = ACTIONS(234),
    [anon_sym_nocf_check] = ACTIONS(234),
    [anon_sym_shadowcallstack] = ACTIONS(234),
    [anon_sym_mustprogress] = ACTIONS(234),
    [anon_sym_vscale_range] = ACTIONS(234),
    [anon_sym_preallocated] = ACTIONS(234),
    [anon_sym_zeroext] = ACTIONS(234),
    [anon_sym_signext] = ACTIONS(234),
    [anon_sym_inreg] = ACTIONS(234),
    [anon_sym_byval] = ACTIONS(234),
    [anon_sym_byref] = ACTIONS(234),
    [anon_sym_inalloca] = ACTIONS(234),
    [anon_sym_sret] = ACTIONS(234),
    [anon_sym_elementtype] = ACTIONS(234),
    [anon_sym_noalias] = ACTIONS(234),
    [anon_sym_nocapture] = ACTIONS(234),
    [anon_sym_nest] = ACTIONS(234),
    [anon_sym_returned] = ACTIONS(234),
    [anon_sym_nonnull] = ACTIONS(234),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(234),
    [anon_sym_swiftself] = ACTIONS(234),
    [anon_sym_swiftasync] = ACTIONS(234),
    [anon_sym_swifterror] = ACTIONS(234),
    [anon_sym_immarg] = ACTIONS(234),
    [anon_sym_noundef] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_to] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
    [anon_sym_uselistorder] = ACTIONS(236),
    [anon_sym_uselistorder_bb] = ACTIONS(234),
    [anon_sym_module] = ACTIONS(234),
    [anon_sym_attributes] = ACTIONS(234),
  },
  [64] = {
    [sym_addrspace] = STATE(81),
    [sym_argument_list] = STATE(74),
    [aux_sym_type_repeat1] = STATE(69),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [65] = {
    [sym_addrspace] = STATE(80),
    [sym_argument_list] = STATE(74),
    [aux_sym_type_repeat1] = STATE(69),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(263),
    [anon_sym_partition] = ACTIONS(263),
    [anon_sym_comdat] = ACTIONS(263),
    [anon_sym_gc] = ACTIONS(263),
    [anon_sym_prefix] = ACTIONS(263),
    [anon_sym_prologue] = ACTIONS(263),
    [anon_sym_personality] = ACTIONS(263),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(263),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(263),
    [anon_sym_swiftasync] = ACTIONS(263),
    [anon_sym_swifterror] = ACTIONS(263),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(279),
    [sym_comdat_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_summary_ref] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_target] = ACTIONS(279),
    [anon_sym_source_filename] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_define] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_unnamed_addr] = ACTIONS(279),
    [anon_sym_local_unnamed_addr] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_section] = ACTIONS(279),
    [anon_sym_partition] = ACTIONS(279),
    [anon_sym_comdat] = ACTIONS(279),
    [anon_sym_gc] = ACTIONS(279),
    [anon_sym_prefix] = ACTIONS(279),
    [anon_sym_prologue] = ACTIONS(279),
    [anon_sym_personality] = ACTIONS(279),
    [anon_sym_alignstack] = ACTIONS(279),
    [anon_sym_allocsize] = ACTIONS(279),
    [anon_sym_alwaysinline] = ACTIONS(279),
    [anon_sym_builtin] = ACTIONS(279),
    [anon_sym_cold] = ACTIONS(279),
    [anon_sym_convergent] = ACTIONS(279),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(279),
    [anon_sym_hot] = ACTIONS(279),
    [anon_sym_inaccessiblememonly] = ACTIONS(279),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(279),
    [anon_sym_inlinehint] = ACTIONS(279),
    [anon_sym_jumptable] = ACTIONS(279),
    [anon_sym_minsize] = ACTIONS(279),
    [anon_sym_naked] = ACTIONS(279),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(279),
    [anon_sym_nobuiltin] = ACTIONS(279),
    [anon_sym_noduplicate] = ACTIONS(279),
    [anon_sym_nofree] = ACTIONS(279),
    [anon_sym_noimplicitfloat] = ACTIONS(279),
    [anon_sym_noinline] = ACTIONS(279),
    [anon_sym_nomerge] = ACTIONS(279),
    [anon_sym_nonlazybind] = ACTIONS(279),
    [anon_sym_noprofile] = ACTIONS(279),
    [anon_sym_noredzone] = ACTIONS(279),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(279),
    [anon_sym_noreturn] = ACTIONS(279),
    [anon_sym_norecurse] = ACTIONS(279),
    [anon_sym_willreturn] = ACTIONS(279),
    [anon_sym_nosync] = ACTIONS(279),
    [anon_sym_nounwind] = ACTIONS(279),
    [anon_sym_nosanitize_coverage] = ACTIONS(279),
    [anon_sym_null_pointer_is_valid] = ACTIONS(279),
    [anon_sym_optforfuzzing] = ACTIONS(279),
    [anon_sym_optnone] = ACTIONS(279),
    [anon_sym_optsize] = ACTIONS(279),
    [anon_sym_readnone] = ACTIONS(279),
    [anon_sym_readonly] = ACTIONS(279),
    [anon_sym_writeonly] = ACTIONS(279),
    [anon_sym_argmemonly] = ACTIONS(279),
    [anon_sym_returns_twice] = ACTIONS(279),
    [anon_sym_safestack] = ACTIONS(279),
    [anon_sym_sanitize_address] = ACTIONS(279),
    [anon_sym_sanitize_memory] = ACTIONS(279),
    [anon_sym_sanitize_thread] = ACTIONS(279),
    [anon_sym_sanitize_hwaddress] = ACTIONS(279),
    [anon_sym_sanitize_memtag] = ACTIONS(279),
    [anon_sym_speculative_load_hardening] = ACTIONS(279),
    [anon_sym_speculatable] = ACTIONS(279),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(279),
    [anon_sym_sspreq] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_uwtable] = ACTIONS(279),
    [anon_sym_nocf_check] = ACTIONS(279),
    [anon_sym_shadowcallstack] = ACTIONS(279),
    [anon_sym_mustprogress] = ACTIONS(279),
    [anon_sym_vscale_range] = ACTIONS(279),
    [anon_sym_preallocated] = ACTIONS(279),
    [anon_sym_zeroext] = ACTIONS(279),
    [anon_sym_signext] = ACTIONS(279),
    [anon_sym_inreg] = ACTIONS(279),
    [anon_sym_byval] = ACTIONS(279),
    [anon_sym_byref] = ACTIONS(279),
    [anon_sym_inalloca] = ACTIONS(279),
    [anon_sym_sret] = ACTIONS(279),
    [anon_sym_elementtype] = ACTIONS(279),
    [anon_sym_noalias] = ACTIONS(279),
    [anon_sym_nocapture] = ACTIONS(279),
    [anon_sym_nest] = ACTIONS(279),
    [anon_sym_returned] = ACTIONS(279),
    [anon_sym_nonnull] = ACTIONS(279),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(279),
    [anon_sym_swiftself] = ACTIONS(279),
    [anon_sym_swiftasync] = ACTIONS(279),
    [anon_sym_swifterror] = ACTIONS(279),
    [anon_sym_immarg] = ACTIONS(279),
    [anon_sym_noundef] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_to] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
    [anon_sym_uselistorder] = ACTIONS(281),
    [anon_sym_uselistorder_bb] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_attributes] = ACTIONS(279),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(303),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(303),
    [sym_comdat_ref] = ACTIONS(303),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [aux_sym_metadata_ref_token1] = ACTIONS(303),
    [sym_summary_ref] = ACTIONS(303),
    [sym_string] = ACTIONS(303),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(303),
    [sym_float] = ACTIONS(303),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_target] = ACTIONS(303),
    [anon_sym_source_filename] = ACTIONS(303),
    [anon_sym_declare] = ACTIONS(303),
    [anon_sym_define] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(303),
    [anon_sym_private] = ACTIONS(303),
    [anon_sym_internal] = ACTIONS(303),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(303),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(303),
    [anon_sym_available_externally] = ACTIONS(303),
    [anon_sym_appending] = ACTIONS(303),
    [anon_sym_common] = ACTIONS(303),
    [anon_sym_extern_weak] = ACTIONS(303),
    [anon_sym_external] = ACTIONS(303),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(303),
    [anon_sym_dso_preemptable] = ACTIONS(303),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_hidden] = ACTIONS(303),
    [anon_sym_protected] = ACTIONS(303),
    [anon_sym_dllimport] = ACTIONS(303),
    [anon_sym_dllexport] = ACTIONS(303),
    [anon_sym_unnamed_addr] = ACTIONS(303),
    [anon_sym_local_unnamed_addr] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_align] = ACTIONS(305),
    [anon_sym_section] = ACTIONS(303),
    [anon_sym_partition] = ACTIONS(303),
    [anon_sym_comdat] = ACTIONS(303),
    [anon_sym_gc] = ACTIONS(303),
    [anon_sym_prefix] = ACTIONS(303),
    [anon_sym_prologue] = ACTIONS(303),
    [anon_sym_personality] = ACTIONS(303),
    [anon_sym_alignstack] = ACTIONS(303),
    [anon_sym_allocsize] = ACTIONS(303),
    [anon_sym_alwaysinline] = ACTIONS(303),
    [anon_sym_builtin] = ACTIONS(303),
    [anon_sym_cold] = ACTIONS(303),
    [anon_sym_convergent] = ACTIONS(303),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(303),
    [anon_sym_hot] = ACTIONS(303),
    [anon_sym_inaccessiblememonly] = ACTIONS(303),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(303),
    [anon_sym_inlinehint] = ACTIONS(303),
    [anon_sym_jumptable] = ACTIONS(303),
    [anon_sym_minsize] = ACTIONS(303),
    [anon_sym_naked] = ACTIONS(303),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(303),
    [anon_sym_nobuiltin] = ACTIONS(303),
    [anon_sym_noduplicate] = ACTIONS(303),
    [anon_sym_nofree] = ACTIONS(303),
    [anon_sym_noimplicitfloat] = ACTIONS(303),
    [anon_sym_noinline] = ACTIONS(303),
    [anon_sym_nomerge] = ACTIONS(303),
    [anon_sym_nonlazybind] = ACTIONS(303),
    [anon_sym_noprofile] = ACTIONS(303),
    [anon_sym_noredzone] = ACTIONS(303),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(303),
    [anon_sym_noreturn] = ACTIONS(303),
    [anon_sym_norecurse] = ACTIONS(303),
    [anon_sym_willreturn] = ACTIONS(303),
    [anon_sym_nosync] = ACTIONS(303),
    [anon_sym_nounwind] = ACTIONS(303),
    [anon_sym_nosanitize_coverage] = ACTIONS(303),
    [anon_sym_null_pointer_is_valid] = ACTIONS(303),
    [anon_sym_optforfuzzing] = ACTIONS(303),
    [anon_sym_optnone] = ACTIONS(303),
    [anon_sym_optsize] = ACTIONS(303),
    [anon_sym_readnone] = ACTIONS(303),
    [anon_sym_readonly] = ACTIONS(303),
    [anon_sym_writeonly] = ACTIONS(303),
    [anon_sym_argmemonly] = ACTIONS(303),
    [anon_sym_returns_twice] = ACTIONS(303),
    [anon_sym_safestack] = ACTIONS(303),
    [anon_sym_sanitize_address] = ACTIONS(303),
    [anon_sym_sanitize_memory] = ACTIONS(303),
    [anon_sym_sanitize_thread] = ACTIONS(303),
    [anon_sym_sanitize_hwaddress] = ACTIONS(303),
    [anon_sym_sanitize_memtag] = ACTIONS(303),
    [anon_sym_speculative_load_hardening] = ACTIONS(303),
    [anon_sym_speculatable] = ACTIONS(303),
    [anon_sym_ssp] = ACTIONS(305),
    [anon_sym_sspstrong] = ACTIONS(303),
    [anon_sym_sspreq] = ACTIONS(303),
    [anon_sym_strictfp] = ACTIONS(303),
    [anon_sym_uwtable] = ACTIONS(303),
    [anon_sym_nocf_check] = ACTIONS(303),
    [anon_sym_shadowcallstack] = ACTIONS(303),
    [anon_sym_mustprogress] = ACTIONS(303),
    [anon_sym_vscale_range] = ACTIONS(303),
    [anon_sym_preallocated] = ACTIONS(303),
    [anon_sym_zeroext] = ACTIONS(303),
    [anon_sym_signext] = ACTIONS(303),
    [anon_sym_inreg] = ACTIONS(303),
    [anon_sym_byval] = ACTIONS(303),
    [anon_sym_byref] = ACTIONS(303),
    [anon_sym_inalloca] = ACTIONS(303),
    [anon_sym_sret] = ACTIONS(303),
    [anon_sym_elementtype] = ACTIONS(303),
    [anon_sym_noalias] = ACTIONS(303),
    [anon_sym_nocapture] = ACTIONS(303),
    [anon_sym_nest] = ACTIONS(303),
    [anon_sym_returned] = ACTIONS(303),
    [anon_sym_nonnull] = ACTIONS(303),
    [anon_sym_dereferenceable] = ACTIONS(305),
    [anon_sym_dereferenceable_or_null] = ACTIONS(303),
    [anon_sym_swiftself] = ACTIONS(303),
    [anon_sym_swiftasync] = ACTIONS(303),
    [anon_sym_swifterror] = ACTIONS(303),
    [anon_sym_immarg] = ACTIONS(303),
    [anon_sym_noundef] = ACTIONS(303),
    [anon_sym_extractelement] = ACTIONS(303),
    [anon_sym_insertelement] = ACTIONS(303),
    [anon_sym_select] = ACTIONS(303),
    [anon_sym_shufflevector] = ACTIONS(303),
    [anon_sym_fneg] = ACTIONS(303),
    [anon_sym_to] = ACTIONS(303),
    [anon_sym_icmp] = ACTIONS(303),
    [anon_sym_fcmp] = ACTIONS(303),
    [anon_sym_getelementptr] = ACTIONS(303),
    [anon_sym_extractvalue] = ACTIONS(303),
    [anon_sym_insertvalue] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_null] = ACTIONS(305),
    [anon_sym_none] = ACTIONS(303),
    [anon_sym_undef] = ACTIONS(303),
    [anon_sym_poison] = ACTIONS(303),
    [anon_sym_zeroinitializer] = ACTIONS(303),
    [anon_sym_blockaddress] = ACTIONS(303),
    [anon_sym_mul] = ACTIONS(303),
    [anon_sym_urem] = ACTIONS(303),
    [anon_sym_srem] = ACTIONS(303),
    [anon_sym_shl] = ACTIONS(303),
    [anon_sym_udiv] = ACTIONS(303),
    [anon_sym_sdiv] = ACTIONS(303),
    [anon_sym_lshr] = ACTIONS(303),
    [anon_sym_ashr] = ACTIONS(303),
    [anon_sym_fmul] = ACTIONS(303),
    [anon_sym_fdiv] = ACTIONS(303),
    [anon_sym_frem] = ACTIONS(303),
    [anon_sym_xchg] = ACTIONS(303),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_nand] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_xor] = ACTIONS(303),
    [anon_sym_max] = ACTIONS(303),
    [anon_sym_min] = ACTIONS(305),
    [anon_sym_umax] = ACTIONS(303),
    [anon_sym_umin] = ACTIONS(303),
    [anon_sym_fadd] = ACTIONS(303),
    [anon_sym_fsub] = ACTIONS(303),
    [anon_sym_bitcast] = ACTIONS(303),
    [anon_sym_trunc] = ACTIONS(303),
    [anon_sym_zext] = ACTIONS(303),
    [anon_sym_sext] = ACTIONS(303),
    [anon_sym_fptrunc] = ACTIONS(303),
    [anon_sym_fpext] = ACTIONS(303),
    [anon_sym_addrspacecast] = ACTIONS(303),
    [anon_sym_uitofp] = ACTIONS(303),
    [anon_sym_sitofp] = ACTIONS(303),
    [anon_sym_fptoui] = ACTIONS(303),
    [anon_sym_fptosi] = ACTIONS(303),
    [anon_sym_inttoptr] = ACTIONS(303),
    [anon_sym_ptrtoint] = ACTIONS(303),
    [anon_sym_uselistorder] = ACTIONS(305),
    [anon_sym_uselistorder_bb] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_attributes] = ACTIONS(303),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(307),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(307),
    [sym_comdat_ref] = ACTIONS(307),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [aux_sym_metadata_ref_token1] = ACTIONS(307),
    [sym_summary_ref] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(307),
    [sym_float] = ACTIONS(307),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_target] = ACTIONS(307),
    [anon_sym_source_filename] = ACTIONS(307),
    [anon_sym_declare] = ACTIONS(307),
    [anon_sym_define] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(307),
    [anon_sym_private] = ACTIONS(307),
    [anon_sym_internal] = ACTIONS(307),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(307),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(307),
    [anon_sym_available_externally] = ACTIONS(307),
    [anon_sym_appending] = ACTIONS(307),
    [anon_sym_common] = ACTIONS(307),
    [anon_sym_extern_weak] = ACTIONS(307),
    [anon_sym_external] = ACTIONS(307),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(307),
    [anon_sym_dso_preemptable] = ACTIONS(307),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_hidden] = ACTIONS(307),
    [anon_sym_protected] = ACTIONS(307),
    [anon_sym_dllimport] = ACTIONS(307),
    [anon_sym_dllexport] = ACTIONS(307),
    [anon_sym_unnamed_addr] = ACTIONS(307),
    [anon_sym_local_unnamed_addr] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_align] = ACTIONS(309),
    [anon_sym_section] = ACTIONS(307),
    [anon_sym_partition] = ACTIONS(307),
    [anon_sym_comdat] = ACTIONS(307),
    [anon_sym_gc] = ACTIONS(307),
    [anon_sym_prefix] = ACTIONS(307),
    [anon_sym_prologue] = ACTIONS(307),
    [anon_sym_personality] = ACTIONS(307),
    [anon_sym_alignstack] = ACTIONS(307),
    [anon_sym_allocsize] = ACTIONS(307),
    [anon_sym_alwaysinline] = ACTIONS(307),
    [anon_sym_builtin] = ACTIONS(307),
    [anon_sym_cold] = ACTIONS(307),
    [anon_sym_convergent] = ACTIONS(307),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(307),
    [anon_sym_hot] = ACTIONS(307),
    [anon_sym_inaccessiblememonly] = ACTIONS(307),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(307),
    [anon_sym_inlinehint] = ACTIONS(307),
    [anon_sym_jumptable] = ACTIONS(307),
    [anon_sym_minsize] = ACTIONS(307),
    [anon_sym_naked] = ACTIONS(307),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(307),
    [anon_sym_nobuiltin] = ACTIONS(307),
    [anon_sym_noduplicate] = ACTIONS(307),
    [anon_sym_nofree] = ACTIONS(307),
    [anon_sym_noimplicitfloat] = ACTIONS(307),
    [anon_sym_noinline] = ACTIONS(307),
    [anon_sym_nomerge] = ACTIONS(307),
    [anon_sym_nonlazybind] = ACTIONS(307),
    [anon_sym_noprofile] = ACTIONS(307),
    [anon_sym_noredzone] = ACTIONS(307),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(307),
    [anon_sym_noreturn] = ACTIONS(307),
    [anon_sym_norecurse] = ACTIONS(307),
    [anon_sym_willreturn] = ACTIONS(307),
    [anon_sym_nosync] = ACTIONS(307),
    [anon_sym_nounwind] = ACTIONS(307),
    [anon_sym_nosanitize_coverage] = ACTIONS(307),
    [anon_sym_null_pointer_is_valid] = ACTIONS(307),
    [anon_sym_optforfuzzing] = ACTIONS(307),
    [anon_sym_optnone] = ACTIONS(307),
    [anon_sym_optsize] = ACTIONS(307),
    [anon_sym_readnone] = ACTIONS(307),
    [anon_sym_readonly] = ACTIONS(307),
    [anon_sym_writeonly] = ACTIONS(307),
    [anon_sym_argmemonly] = ACTIONS(307),
    [anon_sym_returns_twice] = ACTIONS(307),
    [anon_sym_safestack] = ACTIONS(307),
    [anon_sym_sanitize_address] = ACTIONS(307),
    [anon_sym_sanitize_memory] = ACTIONS(307),
    [anon_sym_sanitize_thread] = ACTIONS(307),
    [anon_sym_sanitize_hwaddress] = ACTIONS(307),
    [anon_sym_sanitize_memtag] = ACTIONS(307),
    [anon_sym_speculative_load_hardening] = ACTIONS(307),
    [anon_sym_speculatable] = ACTIONS(307),
    [anon_sym_ssp] = ACTIONS(309),
    [anon_sym_sspstrong] = ACTIONS(307),
    [anon_sym_sspreq] = ACTIONS(307),
    [anon_sym_strictfp] = ACTIONS(307),
    [anon_sym_uwtable] = ACTIONS(307),
    [anon_sym_nocf_check] = ACTIONS(307),
    [anon_sym_shadowcallstack] = ACTIONS(307),
    [anon_sym_mustprogress] = ACTIONS(307),
    [anon_sym_vscale_range] = ACTIONS(307),
    [anon_sym_preallocated] = ACTIONS(307),
    [anon_sym_zeroext] = ACTIONS(307),
    [anon_sym_signext] = ACTIONS(307),
    [anon_sym_inreg] = ACTIONS(307),
    [anon_sym_byval] = ACTIONS(307),
    [anon_sym_byref] = ACTIONS(307),
    [anon_sym_inalloca] = ACTIONS(307),
    [anon_sym_sret] = ACTIONS(307),
    [anon_sym_elementtype] = ACTIONS(307),
    [anon_sym_noalias] = ACTIONS(307),
    [anon_sym_nocapture] = ACTIONS(307),
    [anon_sym_nest] = ACTIONS(307),
    [anon_sym_returned] = ACTIONS(307),
    [anon_sym_nonnull] = ACTIONS(307),
    [anon_sym_dereferenceable] = ACTIONS(309),
    [anon_sym_dereferenceable_or_null] = ACTIONS(307),
    [anon_sym_swiftself] = ACTIONS(307),
    [anon_sym_swiftasync] = ACTIONS(307),
    [anon_sym_swifterror] = ACTIONS(307),
    [anon_sym_immarg] = ACTIONS(307),
    [anon_sym_noundef] = ACTIONS(307),
    [anon_sym_extractelement] = ACTIONS(307),
    [anon_sym_insertelement] = ACTIONS(307),
    [anon_sym_select] = ACTIONS(307),
    [anon_sym_shufflevector] = ACTIONS(307),
    [anon_sym_fneg] = ACTIONS(307),
    [anon_sym_to] = ACTIONS(307),
    [anon_sym_icmp] = ACTIONS(307),
    [anon_sym_fcmp] = ACTIONS(307),
    [anon_sym_getelementptr] = ACTIONS(307),
    [anon_sym_extractvalue] = ACTIONS(307),
    [anon_sym_insertvalue] = ACTIONS(307),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [anon_sym_null] = ACTIONS(309),
    [anon_sym_none] = ACTIONS(307),
    [anon_sym_undef] = ACTIONS(307),
    [anon_sym_poison] = ACTIONS(307),
    [anon_sym_zeroinitializer] = ACTIONS(307),
    [anon_sym_blockaddress] = ACTIONS(307),
    [anon_sym_mul] = ACTIONS(307),
    [anon_sym_urem] = ACTIONS(307),
    [anon_sym_srem] = ACTIONS(307),
    [anon_sym_shl] = ACTIONS(307),
    [anon_sym_udiv] = ACTIONS(307),
    [anon_sym_sdiv] = ACTIONS(307),
    [anon_sym_lshr] = ACTIONS(307),
    [anon_sym_ashr] = ACTIONS(307),
    [anon_sym_fmul] = ACTIONS(307),
    [anon_sym_fdiv] = ACTIONS(307),
    [anon_sym_frem] = ACTIONS(307),
    [anon_sym_xchg] = ACTIONS(307),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(307),
    [anon_sym_and] = ACTIONS(307),
    [anon_sym_nand] = ACTIONS(307),
    [anon_sym_or] = ACTIONS(307),
    [anon_sym_xor] = ACTIONS(307),
    [anon_sym_max] = ACTIONS(307),
    [anon_sym_min] = ACTIONS(309),
    [anon_sym_umax] = ACTIONS(307),
    [anon_sym_umin] = ACTIONS(307),
    [anon_sym_fadd] = ACTIONS(307),
    [anon_sym_fsub] = ACTIONS(307),
    [anon_sym_bitcast] = ACTIONS(307),
    [anon_sym_trunc] = ACTIONS(307),
    [anon_sym_zext] = ACTIONS(307),
    [anon_sym_sext] = ACTIONS(307),
    [anon_sym_fptrunc] = ACTIONS(307),
    [anon_sym_fpext] = ACTIONS(307),
    [anon_sym_addrspacecast] = ACTIONS(307),
    [anon_sym_uitofp] = ACTIONS(307),
    [anon_sym_sitofp] = ACTIONS(307),
    [anon_sym_fptoui] = ACTIONS(307),
    [anon_sym_fptosi] = ACTIONS(307),
    [anon_sym_inttoptr] = ACTIONS(307),
    [anon_sym_ptrtoint] = ACTIONS(307),
    [anon_sym_uselistorder] = ACTIONS(309),
    [anon_sym_uselistorder_bb] = ACTIONS(307),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_attributes] = ACTIONS(307),
  },
  [69] = {
    [sym_addrspace] = STATE(1489),
    [aux_sym_type_repeat1] = STATE(69),
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(269),
    [anon_sym_partition] = ACTIONS(269),
    [anon_sym_comdat] = ACTIONS(269),
    [anon_sym_gc] = ACTIONS(269),
    [anon_sym_prefix] = ACTIONS(269),
    [anon_sym_prologue] = ACTIONS(269),
    [anon_sym_personality] = ACTIONS(269),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(269),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(269),
    [anon_sym_swiftasync] = ACTIONS(269),
    [anon_sym_swifterror] = ACTIONS(269),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(299),
    [sym_comdat_ref] = ACTIONS(299),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [aux_sym_metadata_ref_token1] = ACTIONS(299),
    [sym_summary_ref] = ACTIONS(299),
    [sym_string] = ACTIONS(299),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(299),
    [sym_float] = ACTIONS(299),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_target] = ACTIONS(299),
    [anon_sym_source_filename] = ACTIONS(299),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_define] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_internal] = ACTIONS(299),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(299),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(299),
    [anon_sym_available_externally] = ACTIONS(299),
    [anon_sym_appending] = ACTIONS(299),
    [anon_sym_common] = ACTIONS(299),
    [anon_sym_extern_weak] = ACTIONS(299),
    [anon_sym_external] = ACTIONS(299),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(299),
    [anon_sym_dso_preemptable] = ACTIONS(299),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_hidden] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_dllimport] = ACTIONS(299),
    [anon_sym_dllexport] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_align] = ACTIONS(301),
    [anon_sym_section] = ACTIONS(299),
    [anon_sym_partition] = ACTIONS(299),
    [anon_sym_comdat] = ACTIONS(299),
    [anon_sym_gc] = ACTIONS(299),
    [anon_sym_prefix] = ACTIONS(299),
    [anon_sym_prologue] = ACTIONS(299),
    [anon_sym_personality] = ACTIONS(299),
    [anon_sym_alignstack] = ACTIONS(299),
    [anon_sym_allocsize] = ACTIONS(299),
    [anon_sym_alwaysinline] = ACTIONS(299),
    [anon_sym_builtin] = ACTIONS(299),
    [anon_sym_cold] = ACTIONS(299),
    [anon_sym_convergent] = ACTIONS(299),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(299),
    [anon_sym_hot] = ACTIONS(299),
    [anon_sym_inaccessiblememonly] = ACTIONS(299),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(299),
    [anon_sym_inlinehint] = ACTIONS(299),
    [anon_sym_jumptable] = ACTIONS(299),
    [anon_sym_minsize] = ACTIONS(299),
    [anon_sym_naked] = ACTIONS(299),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(299),
    [anon_sym_nobuiltin] = ACTIONS(299),
    [anon_sym_noduplicate] = ACTIONS(299),
    [anon_sym_nofree] = ACTIONS(299),
    [anon_sym_noimplicitfloat] = ACTIONS(299),
    [anon_sym_noinline] = ACTIONS(299),
    [anon_sym_nomerge] = ACTIONS(299),
    [anon_sym_nonlazybind] = ACTIONS(299),
    [anon_sym_noprofile] = ACTIONS(299),
    [anon_sym_noredzone] = ACTIONS(299),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(299),
    [anon_sym_noreturn] = ACTIONS(299),
    [anon_sym_norecurse] = ACTIONS(299),
    [anon_sym_willreturn] = ACTIONS(299),
    [anon_sym_nosync] = ACTIONS(299),
    [anon_sym_nounwind] = ACTIONS(299),
    [anon_sym_nosanitize_coverage] = ACTIONS(299),
    [anon_sym_null_pointer_is_valid] = ACTIONS(299),
    [anon_sym_optforfuzzing] = ACTIONS(299),
    [anon_sym_optnone] = ACTIONS(299),
    [anon_sym_optsize] = ACTIONS(299),
    [anon_sym_readnone] = ACTIONS(299),
    [anon_sym_readonly] = ACTIONS(299),
    [anon_sym_writeonly] = ACTIONS(299),
    [anon_sym_argmemonly] = ACTIONS(299),
    [anon_sym_returns_twice] = ACTIONS(299),
    [anon_sym_safestack] = ACTIONS(299),
    [anon_sym_sanitize_address] = ACTIONS(299),
    [anon_sym_sanitize_memory] = ACTIONS(299),
    [anon_sym_sanitize_thread] = ACTIONS(299),
    [anon_sym_sanitize_hwaddress] = ACTIONS(299),
    [anon_sym_sanitize_memtag] = ACTIONS(299),
    [anon_sym_speculative_load_hardening] = ACTIONS(299),
    [anon_sym_speculatable] = ACTIONS(299),
    [anon_sym_ssp] = ACTIONS(301),
    [anon_sym_sspstrong] = ACTIONS(299),
    [anon_sym_sspreq] = ACTIONS(299),
    [anon_sym_strictfp] = ACTIONS(299),
    [anon_sym_uwtable] = ACTIONS(299),
    [anon_sym_nocf_check] = ACTIONS(299),
    [anon_sym_shadowcallstack] = ACTIONS(299),
    [anon_sym_mustprogress] = ACTIONS(299),
    [anon_sym_vscale_range] = ACTIONS(299),
    [anon_sym_preallocated] = ACTIONS(299),
    [anon_sym_zeroext] = ACTIONS(299),
    [anon_sym_signext] = ACTIONS(299),
    [anon_sym_inreg] = ACTIONS(299),
    [anon_sym_byval] = ACTIONS(299),
    [anon_sym_byref] = ACTIONS(299),
    [anon_sym_inalloca] = ACTIONS(299),
    [anon_sym_sret] = ACTIONS(299),
    [anon_sym_elementtype] = ACTIONS(299),
    [anon_sym_noalias] = ACTIONS(299),
    [anon_sym_nocapture] = ACTIONS(299),
    [anon_sym_nest] = ACTIONS(299),
    [anon_sym_returned] = ACTIONS(299),
    [anon_sym_nonnull] = ACTIONS(299),
    [anon_sym_dereferenceable] = ACTIONS(301),
    [anon_sym_dereferenceable_or_null] = ACTIONS(299),
    [anon_sym_swiftself] = ACTIONS(299),
    [anon_sym_swiftasync] = ACTIONS(299),
    [anon_sym_swifterror] = ACTIONS(299),
    [anon_sym_immarg] = ACTIONS(299),
    [anon_sym_noundef] = ACTIONS(299),
    [anon_sym_extractelement] = ACTIONS(299),
    [anon_sym_insertelement] = ACTIONS(299),
    [anon_sym_select] = ACTIONS(299),
    [anon_sym_shufflevector] = ACTIONS(299),
    [anon_sym_fneg] = ACTIONS(299),
    [anon_sym_to] = ACTIONS(299),
    [anon_sym_icmp] = ACTIONS(299),
    [anon_sym_fcmp] = ACTIONS(299),
    [anon_sym_getelementptr] = ACTIONS(299),
    [anon_sym_extractvalue] = ACTIONS(299),
    [anon_sym_insertvalue] = ACTIONS(299),
    [anon_sym_true] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_none] = ACTIONS(299),
    [anon_sym_undef] = ACTIONS(299),
    [anon_sym_poison] = ACTIONS(299),
    [anon_sym_zeroinitializer] = ACTIONS(299),
    [anon_sym_blockaddress] = ACTIONS(299),
    [anon_sym_mul] = ACTIONS(299),
    [anon_sym_urem] = ACTIONS(299),
    [anon_sym_srem] = ACTIONS(299),
    [anon_sym_shl] = ACTIONS(299),
    [anon_sym_udiv] = ACTIONS(299),
    [anon_sym_sdiv] = ACTIONS(299),
    [anon_sym_lshr] = ACTIONS(299),
    [anon_sym_ashr] = ACTIONS(299),
    [anon_sym_fmul] = ACTIONS(299),
    [anon_sym_fdiv] = ACTIONS(299),
    [anon_sym_frem] = ACTIONS(299),
    [anon_sym_xchg] = ACTIONS(299),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(299),
    [anon_sym_nand] = ACTIONS(299),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_xor] = ACTIONS(299),
    [anon_sym_max] = ACTIONS(299),
    [anon_sym_min] = ACTIONS(301),
    [anon_sym_umax] = ACTIONS(299),
    [anon_sym_umin] = ACTIONS(299),
    [anon_sym_fadd] = ACTIONS(299),
    [anon_sym_fsub] = ACTIONS(299),
    [anon_sym_bitcast] = ACTIONS(299),
    [anon_sym_trunc] = ACTIONS(299),
    [anon_sym_zext] = ACTIONS(299),
    [anon_sym_sext] = ACTIONS(299),
    [anon_sym_fptrunc] = ACTIONS(299),
    [anon_sym_fpext] = ACTIONS(299),
    [anon_sym_addrspacecast] = ACTIONS(299),
    [anon_sym_uitofp] = ACTIONS(299),
    [anon_sym_sitofp] = ACTIONS(299),
    [anon_sym_fptoui] = ACTIONS(299),
    [anon_sym_fptosi] = ACTIONS(299),
    [anon_sym_inttoptr] = ACTIONS(299),
    [anon_sym_ptrtoint] = ACTIONS(299),
    [anon_sym_uselistorder] = ACTIONS(301),
    [anon_sym_uselistorder_bb] = ACTIONS(299),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_attributes] = ACTIONS(299),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(295),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(295),
    [sym_comdat_ref] = ACTIONS(295),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [aux_sym_metadata_ref_token1] = ACTIONS(295),
    [sym_summary_ref] = ACTIONS(295),
    [sym_string] = ACTIONS(295),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(295),
    [sym_float] = ACTIONS(295),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_target] = ACTIONS(295),
    [anon_sym_source_filename] = ACTIONS(295),
    [anon_sym_declare] = ACTIONS(295),
    [anon_sym_define] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(295),
    [anon_sym_private] = ACTIONS(295),
    [anon_sym_internal] = ACTIONS(295),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(295),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(295),
    [anon_sym_available_externally] = ACTIONS(295),
    [anon_sym_appending] = ACTIONS(295),
    [anon_sym_common] = ACTIONS(295),
    [anon_sym_extern_weak] = ACTIONS(295),
    [anon_sym_external] = ACTIONS(295),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(295),
    [anon_sym_dso_preemptable] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(295),
    [anon_sym_hidden] = ACTIONS(295),
    [anon_sym_protected] = ACTIONS(295),
    [anon_sym_dllimport] = ACTIONS(295),
    [anon_sym_dllexport] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_align] = ACTIONS(297),
    [anon_sym_section] = ACTIONS(295),
    [anon_sym_partition] = ACTIONS(295),
    [anon_sym_comdat] = ACTIONS(295),
    [anon_sym_gc] = ACTIONS(295),
    [anon_sym_prefix] = ACTIONS(295),
    [anon_sym_prologue] = ACTIONS(295),
    [anon_sym_personality] = ACTIONS(295),
    [anon_sym_alignstack] = ACTIONS(295),
    [anon_sym_allocsize] = ACTIONS(295),
    [anon_sym_alwaysinline] = ACTIONS(295),
    [anon_sym_builtin] = ACTIONS(295),
    [anon_sym_cold] = ACTIONS(295),
    [anon_sym_convergent] = ACTIONS(295),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(295),
    [anon_sym_hot] = ACTIONS(295),
    [anon_sym_inaccessiblememonly] = ACTIONS(295),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(295),
    [anon_sym_inlinehint] = ACTIONS(295),
    [anon_sym_jumptable] = ACTIONS(295),
    [anon_sym_minsize] = ACTIONS(295),
    [anon_sym_naked] = ACTIONS(295),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(295),
    [anon_sym_nobuiltin] = ACTIONS(295),
    [anon_sym_noduplicate] = ACTIONS(295),
    [anon_sym_nofree] = ACTIONS(295),
    [anon_sym_noimplicitfloat] = ACTIONS(295),
    [anon_sym_noinline] = ACTIONS(295),
    [anon_sym_nomerge] = ACTIONS(295),
    [anon_sym_nonlazybind] = ACTIONS(295),
    [anon_sym_noprofile] = ACTIONS(295),
    [anon_sym_noredzone] = ACTIONS(295),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(295),
    [anon_sym_noreturn] = ACTIONS(295),
    [anon_sym_norecurse] = ACTIONS(295),
    [anon_sym_willreturn] = ACTIONS(295),
    [anon_sym_nosync] = ACTIONS(295),
    [anon_sym_nounwind] = ACTIONS(295),
    [anon_sym_nosanitize_coverage] = ACTIONS(295),
    [anon_sym_null_pointer_is_valid] = ACTIONS(295),
    [anon_sym_optforfuzzing] = ACTIONS(295),
    [anon_sym_optnone] = ACTIONS(295),
    [anon_sym_optsize] = ACTIONS(295),
    [anon_sym_readnone] = ACTIONS(295),
    [anon_sym_readonly] = ACTIONS(295),
    [anon_sym_writeonly] = ACTIONS(295),
    [anon_sym_argmemonly] = ACTIONS(295),
    [anon_sym_returns_twice] = ACTIONS(295),
    [anon_sym_safestack] = ACTIONS(295),
    [anon_sym_sanitize_address] = ACTIONS(295),
    [anon_sym_sanitize_memory] = ACTIONS(295),
    [anon_sym_sanitize_thread] = ACTIONS(295),
    [anon_sym_sanitize_hwaddress] = ACTIONS(295),
    [anon_sym_sanitize_memtag] = ACTIONS(295),
    [anon_sym_speculative_load_hardening] = ACTIONS(295),
    [anon_sym_speculatable] = ACTIONS(295),
    [anon_sym_ssp] = ACTIONS(297),
    [anon_sym_sspstrong] = ACTIONS(295),
    [anon_sym_sspreq] = ACTIONS(295),
    [anon_sym_strictfp] = ACTIONS(295),
    [anon_sym_uwtable] = ACTIONS(295),
    [anon_sym_nocf_check] = ACTIONS(295),
    [anon_sym_shadowcallstack] = ACTIONS(295),
    [anon_sym_mustprogress] = ACTIONS(295),
    [anon_sym_vscale_range] = ACTIONS(295),
    [anon_sym_preallocated] = ACTIONS(295),
    [anon_sym_zeroext] = ACTIONS(295),
    [anon_sym_signext] = ACTIONS(295),
    [anon_sym_inreg] = ACTIONS(295),
    [anon_sym_byval] = ACTIONS(295),
    [anon_sym_byref] = ACTIONS(295),
    [anon_sym_inalloca] = ACTIONS(295),
    [anon_sym_sret] = ACTIONS(295),
    [anon_sym_elementtype] = ACTIONS(295),
    [anon_sym_noalias] = ACTIONS(295),
    [anon_sym_nocapture] = ACTIONS(295),
    [anon_sym_nest] = ACTIONS(295),
    [anon_sym_returned] = ACTIONS(295),
    [anon_sym_nonnull] = ACTIONS(295),
    [anon_sym_dereferenceable] = ACTIONS(297),
    [anon_sym_dereferenceable_or_null] = ACTIONS(295),
    [anon_sym_swiftself] = ACTIONS(295),
    [anon_sym_swiftasync] = ACTIONS(295),
    [anon_sym_swifterror] = ACTIONS(295),
    [anon_sym_immarg] = ACTIONS(295),
    [anon_sym_noundef] = ACTIONS(295),
    [anon_sym_extractelement] = ACTIONS(295),
    [anon_sym_insertelement] = ACTIONS(295),
    [anon_sym_select] = ACTIONS(295),
    [anon_sym_shufflevector] = ACTIONS(295),
    [anon_sym_fneg] = ACTIONS(295),
    [anon_sym_to] = ACTIONS(295),
    [anon_sym_icmp] = ACTIONS(295),
    [anon_sym_fcmp] = ACTIONS(295),
    [anon_sym_getelementptr] = ACTIONS(295),
    [anon_sym_extractvalue] = ACTIONS(295),
    [anon_sym_insertvalue] = ACTIONS(295),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(297),
    [anon_sym_none] = ACTIONS(295),
    [anon_sym_undef] = ACTIONS(295),
    [anon_sym_poison] = ACTIONS(295),
    [anon_sym_zeroinitializer] = ACTIONS(295),
    [anon_sym_blockaddress] = ACTIONS(295),
    [anon_sym_mul] = ACTIONS(295),
    [anon_sym_urem] = ACTIONS(295),
    [anon_sym_srem] = ACTIONS(295),
    [anon_sym_shl] = ACTIONS(295),
    [anon_sym_udiv] = ACTIONS(295),
    [anon_sym_sdiv] = ACTIONS(295),
    [anon_sym_lshr] = ACTIONS(295),
    [anon_sym_ashr] = ACTIONS(295),
    [anon_sym_fmul] = ACTIONS(295),
    [anon_sym_fdiv] = ACTIONS(295),
    [anon_sym_frem] = ACTIONS(295),
    [anon_sym_xchg] = ACTIONS(295),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(295),
    [anon_sym_nand] = ACTIONS(295),
    [anon_sym_or] = ACTIONS(295),
    [anon_sym_xor] = ACTIONS(295),
    [anon_sym_max] = ACTIONS(295),
    [anon_sym_min] = ACTIONS(297),
    [anon_sym_umax] = ACTIONS(295),
    [anon_sym_umin] = ACTIONS(295),
    [anon_sym_fadd] = ACTIONS(295),
    [anon_sym_fsub] = ACTIONS(295),
    [anon_sym_bitcast] = ACTIONS(295),
    [anon_sym_trunc] = ACTIONS(295),
    [anon_sym_zext] = ACTIONS(295),
    [anon_sym_sext] = ACTIONS(295),
    [anon_sym_fptrunc] = ACTIONS(295),
    [anon_sym_fpext] = ACTIONS(295),
    [anon_sym_addrspacecast] = ACTIONS(295),
    [anon_sym_uitofp] = ACTIONS(295),
    [anon_sym_sitofp] = ACTIONS(295),
    [anon_sym_fptoui] = ACTIONS(295),
    [anon_sym_fptosi] = ACTIONS(295),
    [anon_sym_inttoptr] = ACTIONS(295),
    [anon_sym_ptrtoint] = ACTIONS(295),
    [anon_sym_uselistorder] = ACTIONS(297),
    [anon_sym_uselistorder_bb] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_attributes] = ACTIONS(295),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(291),
    [sym_comdat_ref] = ACTIONS(291),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [aux_sym_metadata_ref_token1] = ACTIONS(291),
    [sym_summary_ref] = ACTIONS(291),
    [sym_string] = ACTIONS(291),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_target] = ACTIONS(291),
    [anon_sym_source_filename] = ACTIONS(291),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_define] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_internal] = ACTIONS(291),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(291),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(291),
    [anon_sym_available_externally] = ACTIONS(291),
    [anon_sym_appending] = ACTIONS(291),
    [anon_sym_common] = ACTIONS(291),
    [anon_sym_extern_weak] = ACTIONS(291),
    [anon_sym_external] = ACTIONS(291),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(291),
    [anon_sym_dso_preemptable] = ACTIONS(291),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_hidden] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_dllimport] = ACTIONS(291),
    [anon_sym_dllexport] = ACTIONS(291),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_align] = ACTIONS(293),
    [anon_sym_section] = ACTIONS(291),
    [anon_sym_partition] = ACTIONS(291),
    [anon_sym_comdat] = ACTIONS(291),
    [anon_sym_gc] = ACTIONS(291),
    [anon_sym_prefix] = ACTIONS(291),
    [anon_sym_prologue] = ACTIONS(291),
    [anon_sym_personality] = ACTIONS(291),
    [anon_sym_alignstack] = ACTIONS(291),
    [anon_sym_allocsize] = ACTIONS(291),
    [anon_sym_alwaysinline] = ACTIONS(291),
    [anon_sym_builtin] = ACTIONS(291),
    [anon_sym_cold] = ACTIONS(291),
    [anon_sym_convergent] = ACTIONS(291),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(291),
    [anon_sym_hot] = ACTIONS(291),
    [anon_sym_inaccessiblememonly] = ACTIONS(291),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(291),
    [anon_sym_inlinehint] = ACTIONS(291),
    [anon_sym_jumptable] = ACTIONS(291),
    [anon_sym_minsize] = ACTIONS(291),
    [anon_sym_naked] = ACTIONS(291),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(291),
    [anon_sym_nobuiltin] = ACTIONS(291),
    [anon_sym_noduplicate] = ACTIONS(291),
    [anon_sym_nofree] = ACTIONS(291),
    [anon_sym_noimplicitfloat] = ACTIONS(291),
    [anon_sym_noinline] = ACTIONS(291),
    [anon_sym_nomerge] = ACTIONS(291),
    [anon_sym_nonlazybind] = ACTIONS(291),
    [anon_sym_noprofile] = ACTIONS(291),
    [anon_sym_noredzone] = ACTIONS(291),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(291),
    [anon_sym_noreturn] = ACTIONS(291),
    [anon_sym_norecurse] = ACTIONS(291),
    [anon_sym_willreturn] = ACTIONS(291),
    [anon_sym_nosync] = ACTIONS(291),
    [anon_sym_nounwind] = ACTIONS(291),
    [anon_sym_nosanitize_coverage] = ACTIONS(291),
    [anon_sym_null_pointer_is_valid] = ACTIONS(291),
    [anon_sym_optforfuzzing] = ACTIONS(291),
    [anon_sym_optnone] = ACTIONS(291),
    [anon_sym_optsize] = ACTIONS(291),
    [anon_sym_readnone] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(291),
    [anon_sym_writeonly] = ACTIONS(291),
    [anon_sym_argmemonly] = ACTIONS(291),
    [anon_sym_returns_twice] = ACTIONS(291),
    [anon_sym_safestack] = ACTIONS(291),
    [anon_sym_sanitize_address] = ACTIONS(291),
    [anon_sym_sanitize_memory] = ACTIONS(291),
    [anon_sym_sanitize_thread] = ACTIONS(291),
    [anon_sym_sanitize_hwaddress] = ACTIONS(291),
    [anon_sym_sanitize_memtag] = ACTIONS(291),
    [anon_sym_speculative_load_hardening] = ACTIONS(291),
    [anon_sym_speculatable] = ACTIONS(291),
    [anon_sym_ssp] = ACTIONS(293),
    [anon_sym_sspstrong] = ACTIONS(291),
    [anon_sym_sspreq] = ACTIONS(291),
    [anon_sym_strictfp] = ACTIONS(291),
    [anon_sym_uwtable] = ACTIONS(291),
    [anon_sym_nocf_check] = ACTIONS(291),
    [anon_sym_shadowcallstack] = ACTIONS(291),
    [anon_sym_mustprogress] = ACTIONS(291),
    [anon_sym_vscale_range] = ACTIONS(291),
    [anon_sym_preallocated] = ACTIONS(291),
    [anon_sym_zeroext] = ACTIONS(291),
    [anon_sym_signext] = ACTIONS(291),
    [anon_sym_inreg] = ACTIONS(291),
    [anon_sym_byval] = ACTIONS(291),
    [anon_sym_byref] = ACTIONS(291),
    [anon_sym_inalloca] = ACTIONS(291),
    [anon_sym_sret] = ACTIONS(291),
    [anon_sym_elementtype] = ACTIONS(291),
    [anon_sym_noalias] = ACTIONS(291),
    [anon_sym_nocapture] = ACTIONS(291),
    [anon_sym_nest] = ACTIONS(291),
    [anon_sym_returned] = ACTIONS(291),
    [anon_sym_nonnull] = ACTIONS(291),
    [anon_sym_dereferenceable] = ACTIONS(293),
    [anon_sym_dereferenceable_or_null] = ACTIONS(291),
    [anon_sym_swiftself] = ACTIONS(291),
    [anon_sym_swiftasync] = ACTIONS(291),
    [anon_sym_swifterror] = ACTIONS(291),
    [anon_sym_immarg] = ACTIONS(291),
    [anon_sym_noundef] = ACTIONS(291),
    [anon_sym_extractelement] = ACTIONS(291),
    [anon_sym_insertelement] = ACTIONS(291),
    [anon_sym_select] = ACTIONS(291),
    [anon_sym_shufflevector] = ACTIONS(291),
    [anon_sym_fneg] = ACTIONS(291),
    [anon_sym_to] = ACTIONS(291),
    [anon_sym_icmp] = ACTIONS(291),
    [anon_sym_fcmp] = ACTIONS(291),
    [anon_sym_getelementptr] = ACTIONS(291),
    [anon_sym_extractvalue] = ACTIONS(291),
    [anon_sym_insertvalue] = ACTIONS(291),
    [anon_sym_true] = ACTIONS(291),
    [anon_sym_false] = ACTIONS(291),
    [anon_sym_null] = ACTIONS(293),
    [anon_sym_none] = ACTIONS(291),
    [anon_sym_undef] = ACTIONS(291),
    [anon_sym_poison] = ACTIONS(291),
    [anon_sym_zeroinitializer] = ACTIONS(291),
    [anon_sym_blockaddress] = ACTIONS(291),
    [anon_sym_mul] = ACTIONS(291),
    [anon_sym_urem] = ACTIONS(291),
    [anon_sym_srem] = ACTIONS(291),
    [anon_sym_shl] = ACTIONS(291),
    [anon_sym_udiv] = ACTIONS(291),
    [anon_sym_sdiv] = ACTIONS(291),
    [anon_sym_lshr] = ACTIONS(291),
    [anon_sym_ashr] = ACTIONS(291),
    [anon_sym_fmul] = ACTIONS(291),
    [anon_sym_fdiv] = ACTIONS(291),
    [anon_sym_frem] = ACTIONS(291),
    [anon_sym_xchg] = ACTIONS(291),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(291),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_nand] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_xor] = ACTIONS(291),
    [anon_sym_max] = ACTIONS(291),
    [anon_sym_min] = ACTIONS(293),
    [anon_sym_umax] = ACTIONS(291),
    [anon_sym_umin] = ACTIONS(291),
    [anon_sym_fadd] = ACTIONS(291),
    [anon_sym_fsub] = ACTIONS(291),
    [anon_sym_bitcast] = ACTIONS(291),
    [anon_sym_trunc] = ACTIONS(291),
    [anon_sym_zext] = ACTIONS(291),
    [anon_sym_sext] = ACTIONS(291),
    [anon_sym_fptrunc] = ACTIONS(291),
    [anon_sym_fpext] = ACTIONS(291),
    [anon_sym_addrspacecast] = ACTIONS(291),
    [anon_sym_uitofp] = ACTIONS(291),
    [anon_sym_sitofp] = ACTIONS(291),
    [anon_sym_fptoui] = ACTIONS(291),
    [anon_sym_fptosi] = ACTIONS(291),
    [anon_sym_inttoptr] = ACTIONS(291),
    [anon_sym_ptrtoint] = ACTIONS(291),
    [anon_sym_uselistorder] = ACTIONS(293),
    [anon_sym_uselistorder_bb] = ACTIONS(291),
    [anon_sym_module] = ACTIONS(291),
    [anon_sym_attributes] = ACTIONS(291),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(287),
    [sym_comdat_ref] = ACTIONS(287),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [aux_sym_metadata_ref_token1] = ACTIONS(287),
    [sym_summary_ref] = ACTIONS(287),
    [sym_string] = ACTIONS(287),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(287),
    [sym_float] = ACTIONS(287),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_target] = ACTIONS(287),
    [anon_sym_source_filename] = ACTIONS(287),
    [anon_sym_declare] = ACTIONS(287),
    [anon_sym_define] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_internal] = ACTIONS(287),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(287),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(287),
    [anon_sym_available_externally] = ACTIONS(287),
    [anon_sym_appending] = ACTIONS(287),
    [anon_sym_common] = ACTIONS(287),
    [anon_sym_extern_weak] = ACTIONS(287),
    [anon_sym_external] = ACTIONS(287),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(287),
    [anon_sym_dso_preemptable] = ACTIONS(287),
    [anon_sym_default] = ACTIONS(287),
    [anon_sym_hidden] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_dllimport] = ACTIONS(287),
    [anon_sym_dllexport] = ACTIONS(287),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_align] = ACTIONS(289),
    [anon_sym_section] = ACTIONS(287),
    [anon_sym_partition] = ACTIONS(287),
    [anon_sym_comdat] = ACTIONS(287),
    [anon_sym_gc] = ACTIONS(287),
    [anon_sym_prefix] = ACTIONS(287),
    [anon_sym_prologue] = ACTIONS(287),
    [anon_sym_personality] = ACTIONS(287),
    [anon_sym_alignstack] = ACTIONS(287),
    [anon_sym_allocsize] = ACTIONS(287),
    [anon_sym_alwaysinline] = ACTIONS(287),
    [anon_sym_builtin] = ACTIONS(287),
    [anon_sym_cold] = ACTIONS(287),
    [anon_sym_convergent] = ACTIONS(287),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(287),
    [anon_sym_hot] = ACTIONS(287),
    [anon_sym_inaccessiblememonly] = ACTIONS(287),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(287),
    [anon_sym_inlinehint] = ACTIONS(287),
    [anon_sym_jumptable] = ACTIONS(287),
    [anon_sym_minsize] = ACTIONS(287),
    [anon_sym_naked] = ACTIONS(287),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(287),
    [anon_sym_nobuiltin] = ACTIONS(287),
    [anon_sym_noduplicate] = ACTIONS(287),
    [anon_sym_nofree] = ACTIONS(287),
    [anon_sym_noimplicitfloat] = ACTIONS(287),
    [anon_sym_noinline] = ACTIONS(287),
    [anon_sym_nomerge] = ACTIONS(287),
    [anon_sym_nonlazybind] = ACTIONS(287),
    [anon_sym_noprofile] = ACTIONS(287),
    [anon_sym_noredzone] = ACTIONS(287),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(287),
    [anon_sym_noreturn] = ACTIONS(287),
    [anon_sym_norecurse] = ACTIONS(287),
    [anon_sym_willreturn] = ACTIONS(287),
    [anon_sym_nosync] = ACTIONS(287),
    [anon_sym_nounwind] = ACTIONS(287),
    [anon_sym_nosanitize_coverage] = ACTIONS(287),
    [anon_sym_null_pointer_is_valid] = ACTIONS(287),
    [anon_sym_optforfuzzing] = ACTIONS(287),
    [anon_sym_optnone] = ACTIONS(287),
    [anon_sym_optsize] = ACTIONS(287),
    [anon_sym_readnone] = ACTIONS(287),
    [anon_sym_readonly] = ACTIONS(287),
    [anon_sym_writeonly] = ACTIONS(287),
    [anon_sym_argmemonly] = ACTIONS(287),
    [anon_sym_returns_twice] = ACTIONS(287),
    [anon_sym_safestack] = ACTIONS(287),
    [anon_sym_sanitize_address] = ACTIONS(287),
    [anon_sym_sanitize_memory] = ACTIONS(287),
    [anon_sym_sanitize_thread] = ACTIONS(287),
    [anon_sym_sanitize_hwaddress] = ACTIONS(287),
    [anon_sym_sanitize_memtag] = ACTIONS(287),
    [anon_sym_speculative_load_hardening] = ACTIONS(287),
    [anon_sym_speculatable] = ACTIONS(287),
    [anon_sym_ssp] = ACTIONS(289),
    [anon_sym_sspstrong] = ACTIONS(287),
    [anon_sym_sspreq] = ACTIONS(287),
    [anon_sym_strictfp] = ACTIONS(287),
    [anon_sym_uwtable] = ACTIONS(287),
    [anon_sym_nocf_check] = ACTIONS(287),
    [anon_sym_shadowcallstack] = ACTIONS(287),
    [anon_sym_mustprogress] = ACTIONS(287),
    [anon_sym_vscale_range] = ACTIONS(287),
    [anon_sym_preallocated] = ACTIONS(287),
    [anon_sym_zeroext] = ACTIONS(287),
    [anon_sym_signext] = ACTIONS(287),
    [anon_sym_inreg] = ACTIONS(287),
    [anon_sym_byval] = ACTIONS(287),
    [anon_sym_byref] = ACTIONS(287),
    [anon_sym_inalloca] = ACTIONS(287),
    [anon_sym_sret] = ACTIONS(287),
    [anon_sym_elementtype] = ACTIONS(287),
    [anon_sym_noalias] = ACTIONS(287),
    [anon_sym_nocapture] = ACTIONS(287),
    [anon_sym_nest] = ACTIONS(287),
    [anon_sym_returned] = ACTIONS(287),
    [anon_sym_nonnull] = ACTIONS(287),
    [anon_sym_dereferenceable] = ACTIONS(289),
    [anon_sym_dereferenceable_or_null] = ACTIONS(287),
    [anon_sym_swiftself] = ACTIONS(287),
    [anon_sym_swiftasync] = ACTIONS(287),
    [anon_sym_swifterror] = ACTIONS(287),
    [anon_sym_immarg] = ACTIONS(287),
    [anon_sym_noundef] = ACTIONS(287),
    [anon_sym_extractelement] = ACTIONS(287),
    [anon_sym_insertelement] = ACTIONS(287),
    [anon_sym_select] = ACTIONS(287),
    [anon_sym_shufflevector] = ACTIONS(287),
    [anon_sym_fneg] = ACTIONS(287),
    [anon_sym_to] = ACTIONS(287),
    [anon_sym_icmp] = ACTIONS(287),
    [anon_sym_fcmp] = ACTIONS(287),
    [anon_sym_getelementptr] = ACTIONS(287),
    [anon_sym_extractvalue] = ACTIONS(287),
    [anon_sym_insertvalue] = ACTIONS(287),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_none] = ACTIONS(287),
    [anon_sym_undef] = ACTIONS(287),
    [anon_sym_poison] = ACTIONS(287),
    [anon_sym_zeroinitializer] = ACTIONS(287),
    [anon_sym_blockaddress] = ACTIONS(287),
    [anon_sym_mul] = ACTIONS(287),
    [anon_sym_urem] = ACTIONS(287),
    [anon_sym_srem] = ACTIONS(287),
    [anon_sym_shl] = ACTIONS(287),
    [anon_sym_udiv] = ACTIONS(287),
    [anon_sym_sdiv] = ACTIONS(287),
    [anon_sym_lshr] = ACTIONS(287),
    [anon_sym_ashr] = ACTIONS(287),
    [anon_sym_fmul] = ACTIONS(287),
    [anon_sym_fdiv] = ACTIONS(287),
    [anon_sym_frem] = ACTIONS(287),
    [anon_sym_xchg] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(287),
    [anon_sym_and] = ACTIONS(287),
    [anon_sym_nand] = ACTIONS(287),
    [anon_sym_or] = ACTIONS(287),
    [anon_sym_xor] = ACTIONS(287),
    [anon_sym_max] = ACTIONS(287),
    [anon_sym_min] = ACTIONS(289),
    [anon_sym_umax] = ACTIONS(287),
    [anon_sym_umin] = ACTIONS(287),
    [anon_sym_fadd] = ACTIONS(287),
    [anon_sym_fsub] = ACTIONS(287),
    [anon_sym_bitcast] = ACTIONS(287),
    [anon_sym_trunc] = ACTIONS(287),
    [anon_sym_zext] = ACTIONS(287),
    [anon_sym_sext] = ACTIONS(287),
    [anon_sym_fptrunc] = ACTIONS(287),
    [anon_sym_fpext] = ACTIONS(287),
    [anon_sym_addrspacecast] = ACTIONS(287),
    [anon_sym_uitofp] = ACTIONS(287),
    [anon_sym_sitofp] = ACTIONS(287),
    [anon_sym_fptoui] = ACTIONS(287),
    [anon_sym_fptosi] = ACTIONS(287),
    [anon_sym_inttoptr] = ACTIONS(287),
    [anon_sym_ptrtoint] = ACTIONS(287),
    [anon_sym_uselistorder] = ACTIONS(289),
    [anon_sym_uselistorder_bb] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(287),
    [anon_sym_attributes] = ACTIONS(287),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(250),
    [anon_sym_partition] = ACTIONS(250),
    [anon_sym_comdat] = ACTIONS(250),
    [anon_sym_gc] = ACTIONS(250),
    [anon_sym_prefix] = ACTIONS(250),
    [anon_sym_prologue] = ACTIONS(250),
    [anon_sym_personality] = ACTIONS(250),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(250),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(250),
    [anon_sym_swiftasync] = ACTIONS(250),
    [anon_sym_swifterror] = ACTIONS(250),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(269),
    [anon_sym_partition] = ACTIONS(269),
    [anon_sym_comdat] = ACTIONS(269),
    [anon_sym_gc] = ACTIONS(269),
    [anon_sym_prefix] = ACTIONS(269),
    [anon_sym_prologue] = ACTIONS(269),
    [anon_sym_personality] = ACTIONS(269),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(269),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(269),
    [anon_sym_swiftasync] = ACTIONS(269),
    [anon_sym_swifterror] = ACTIONS(269),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(365),
    [sym_comdat_ref] = ACTIONS(365),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [aux_sym_metadata_ref_token1] = ACTIONS(365),
    [sym_summary_ref] = ACTIONS(365),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_target] = ACTIONS(365),
    [anon_sym_source_filename] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(365),
    [anon_sym_define] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_align] = ACTIONS(367),
    [anon_sym_section] = ACTIONS(365),
    [anon_sym_partition] = ACTIONS(365),
    [anon_sym_comdat] = ACTIONS(365),
    [anon_sym_gc] = ACTIONS(365),
    [anon_sym_prefix] = ACTIONS(365),
    [anon_sym_prologue] = ACTIONS(365),
    [anon_sym_personality] = ACTIONS(365),
    [anon_sym_alignstack] = ACTIONS(365),
    [anon_sym_allocsize] = ACTIONS(365),
    [anon_sym_alwaysinline] = ACTIONS(365),
    [anon_sym_builtin] = ACTIONS(365),
    [anon_sym_cold] = ACTIONS(365),
    [anon_sym_convergent] = ACTIONS(365),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(365),
    [anon_sym_hot] = ACTIONS(365),
    [anon_sym_inaccessiblememonly] = ACTIONS(365),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(365),
    [anon_sym_inlinehint] = ACTIONS(365),
    [anon_sym_jumptable] = ACTIONS(365),
    [anon_sym_minsize] = ACTIONS(365),
    [anon_sym_naked] = ACTIONS(365),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(365),
    [anon_sym_nobuiltin] = ACTIONS(365),
    [anon_sym_noduplicate] = ACTIONS(365),
    [anon_sym_nofree] = ACTIONS(365),
    [anon_sym_noimplicitfloat] = ACTIONS(365),
    [anon_sym_noinline] = ACTIONS(365),
    [anon_sym_nomerge] = ACTIONS(365),
    [anon_sym_nonlazybind] = ACTIONS(365),
    [anon_sym_noprofile] = ACTIONS(365),
    [anon_sym_noredzone] = ACTIONS(365),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(365),
    [anon_sym_noreturn] = ACTIONS(365),
    [anon_sym_norecurse] = ACTIONS(365),
    [anon_sym_willreturn] = ACTIONS(365),
    [anon_sym_nosync] = ACTIONS(365),
    [anon_sym_nounwind] = ACTIONS(365),
    [anon_sym_nosanitize_coverage] = ACTIONS(365),
    [anon_sym_null_pointer_is_valid] = ACTIONS(365),
    [anon_sym_optforfuzzing] = ACTIONS(365),
    [anon_sym_optnone] = ACTIONS(365),
    [anon_sym_optsize] = ACTIONS(365),
    [anon_sym_readnone] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_writeonly] = ACTIONS(365),
    [anon_sym_argmemonly] = ACTIONS(365),
    [anon_sym_returns_twice] = ACTIONS(365),
    [anon_sym_safestack] = ACTIONS(365),
    [anon_sym_sanitize_address] = ACTIONS(365),
    [anon_sym_sanitize_memory] = ACTIONS(365),
    [anon_sym_sanitize_thread] = ACTIONS(365),
    [anon_sym_sanitize_hwaddress] = ACTIONS(365),
    [anon_sym_sanitize_memtag] = ACTIONS(365),
    [anon_sym_speculative_load_hardening] = ACTIONS(365),
    [anon_sym_speculatable] = ACTIONS(365),
    [anon_sym_ssp] = ACTIONS(367),
    [anon_sym_sspstrong] = ACTIONS(365),
    [anon_sym_sspreq] = ACTIONS(365),
    [anon_sym_strictfp] = ACTIONS(365),
    [anon_sym_uwtable] = ACTIONS(365),
    [anon_sym_nocf_check] = ACTIONS(365),
    [anon_sym_shadowcallstack] = ACTIONS(365),
    [anon_sym_mustprogress] = ACTIONS(365),
    [anon_sym_vscale_range] = ACTIONS(365),
    [anon_sym_preallocated] = ACTIONS(365),
    [anon_sym_zeroext] = ACTIONS(365),
    [anon_sym_signext] = ACTIONS(365),
    [anon_sym_inreg] = ACTIONS(365),
    [anon_sym_byval] = ACTIONS(365),
    [anon_sym_byref] = ACTIONS(365),
    [anon_sym_inalloca] = ACTIONS(365),
    [anon_sym_sret] = ACTIONS(365),
    [anon_sym_elementtype] = ACTIONS(365),
    [anon_sym_noalias] = ACTIONS(365),
    [anon_sym_nocapture] = ACTIONS(365),
    [anon_sym_nest] = ACTIONS(365),
    [anon_sym_returned] = ACTIONS(365),
    [anon_sym_nonnull] = ACTIONS(365),
    [anon_sym_dereferenceable] = ACTIONS(367),
    [anon_sym_dereferenceable_or_null] = ACTIONS(365),
    [anon_sym_swiftself] = ACTIONS(365),
    [anon_sym_swiftasync] = ACTIONS(365),
    [anon_sym_swifterror] = ACTIONS(365),
    [anon_sym_immarg] = ACTIONS(365),
    [anon_sym_noundef] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_to] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
    [anon_sym_uselistorder] = ACTIONS(367),
    [anon_sym_uselistorder_bb] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(365),
    [anon_sym_attributes] = ACTIONS(365),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(283),
    [sym_comdat_ref] = ACTIONS(283),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(283),
    [sym_summary_ref] = ACTIONS(283),
    [sym_string] = ACTIONS(283),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(283),
    [sym_float] = ACTIONS(283),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_target] = ACTIONS(283),
    [anon_sym_source_filename] = ACTIONS(283),
    [anon_sym_declare] = ACTIONS(283),
    [anon_sym_define] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_internal] = ACTIONS(283),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(283),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(283),
    [anon_sym_available_externally] = ACTIONS(283),
    [anon_sym_appending] = ACTIONS(283),
    [anon_sym_common] = ACTIONS(283),
    [anon_sym_extern_weak] = ACTIONS(283),
    [anon_sym_external] = ACTIONS(283),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(283),
    [anon_sym_dso_preemptable] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_hidden] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_dllimport] = ACTIONS(283),
    [anon_sym_dllexport] = ACTIONS(283),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_align] = ACTIONS(285),
    [anon_sym_section] = ACTIONS(283),
    [anon_sym_partition] = ACTIONS(283),
    [anon_sym_comdat] = ACTIONS(283),
    [anon_sym_gc] = ACTIONS(283),
    [anon_sym_prefix] = ACTIONS(283),
    [anon_sym_prologue] = ACTIONS(283),
    [anon_sym_personality] = ACTIONS(283),
    [anon_sym_alignstack] = ACTIONS(283),
    [anon_sym_allocsize] = ACTIONS(283),
    [anon_sym_alwaysinline] = ACTIONS(283),
    [anon_sym_builtin] = ACTIONS(283),
    [anon_sym_cold] = ACTIONS(283),
    [anon_sym_convergent] = ACTIONS(283),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(283),
    [anon_sym_hot] = ACTIONS(283),
    [anon_sym_inaccessiblememonly] = ACTIONS(283),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(283),
    [anon_sym_inlinehint] = ACTIONS(283),
    [anon_sym_jumptable] = ACTIONS(283),
    [anon_sym_minsize] = ACTIONS(283),
    [anon_sym_naked] = ACTIONS(283),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(283),
    [anon_sym_nobuiltin] = ACTIONS(283),
    [anon_sym_noduplicate] = ACTIONS(283),
    [anon_sym_nofree] = ACTIONS(283),
    [anon_sym_noimplicitfloat] = ACTIONS(283),
    [anon_sym_noinline] = ACTIONS(283),
    [anon_sym_nomerge] = ACTIONS(283),
    [anon_sym_nonlazybind] = ACTIONS(283),
    [anon_sym_noprofile] = ACTIONS(283),
    [anon_sym_noredzone] = ACTIONS(283),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(283),
    [anon_sym_noreturn] = ACTIONS(283),
    [anon_sym_norecurse] = ACTIONS(283),
    [anon_sym_willreturn] = ACTIONS(283),
    [anon_sym_nosync] = ACTIONS(283),
    [anon_sym_nounwind] = ACTIONS(283),
    [anon_sym_nosanitize_coverage] = ACTIONS(283),
    [anon_sym_null_pointer_is_valid] = ACTIONS(283),
    [anon_sym_optforfuzzing] = ACTIONS(283),
    [anon_sym_optnone] = ACTIONS(283),
    [anon_sym_optsize] = ACTIONS(283),
    [anon_sym_readnone] = ACTIONS(283),
    [anon_sym_readonly] = ACTIONS(283),
    [anon_sym_writeonly] = ACTIONS(283),
    [anon_sym_argmemonly] = ACTIONS(283),
    [anon_sym_returns_twice] = ACTIONS(283),
    [anon_sym_safestack] = ACTIONS(283),
    [anon_sym_sanitize_address] = ACTIONS(283),
    [anon_sym_sanitize_memory] = ACTIONS(283),
    [anon_sym_sanitize_thread] = ACTIONS(283),
    [anon_sym_sanitize_hwaddress] = ACTIONS(283),
    [anon_sym_sanitize_memtag] = ACTIONS(283),
    [anon_sym_speculative_load_hardening] = ACTIONS(283),
    [anon_sym_speculatable] = ACTIONS(283),
    [anon_sym_ssp] = ACTIONS(285),
    [anon_sym_sspstrong] = ACTIONS(283),
    [anon_sym_sspreq] = ACTIONS(283),
    [anon_sym_strictfp] = ACTIONS(283),
    [anon_sym_uwtable] = ACTIONS(283),
    [anon_sym_nocf_check] = ACTIONS(283),
    [anon_sym_shadowcallstack] = ACTIONS(283),
    [anon_sym_mustprogress] = ACTIONS(283),
    [anon_sym_vscale_range] = ACTIONS(283),
    [anon_sym_preallocated] = ACTIONS(283),
    [anon_sym_zeroext] = ACTIONS(283),
    [anon_sym_signext] = ACTIONS(283),
    [anon_sym_inreg] = ACTIONS(283),
    [anon_sym_byval] = ACTIONS(283),
    [anon_sym_byref] = ACTIONS(283),
    [anon_sym_inalloca] = ACTIONS(283),
    [anon_sym_sret] = ACTIONS(283),
    [anon_sym_elementtype] = ACTIONS(283),
    [anon_sym_noalias] = ACTIONS(283),
    [anon_sym_nocapture] = ACTIONS(283),
    [anon_sym_nest] = ACTIONS(283),
    [anon_sym_returned] = ACTIONS(283),
    [anon_sym_nonnull] = ACTIONS(283),
    [anon_sym_dereferenceable] = ACTIONS(285),
    [anon_sym_dereferenceable_or_null] = ACTIONS(283),
    [anon_sym_swiftself] = ACTIONS(283),
    [anon_sym_swiftasync] = ACTIONS(283),
    [anon_sym_swifterror] = ACTIONS(283),
    [anon_sym_immarg] = ACTIONS(283),
    [anon_sym_noundef] = ACTIONS(283),
    [anon_sym_extractelement] = ACTIONS(283),
    [anon_sym_insertelement] = ACTIONS(283),
    [anon_sym_select] = ACTIONS(283),
    [anon_sym_shufflevector] = ACTIONS(283),
    [anon_sym_fneg] = ACTIONS(283),
    [anon_sym_to] = ACTIONS(283),
    [anon_sym_icmp] = ACTIONS(283),
    [anon_sym_fcmp] = ACTIONS(283),
    [anon_sym_getelementptr] = ACTIONS(283),
    [anon_sym_extractvalue] = ACTIONS(283),
    [anon_sym_insertvalue] = ACTIONS(283),
    [anon_sym_true] = ACTIONS(283),
    [anon_sym_false] = ACTIONS(283),
    [anon_sym_null] = ACTIONS(285),
    [anon_sym_none] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(283),
    [anon_sym_poison] = ACTIONS(283),
    [anon_sym_zeroinitializer] = ACTIONS(283),
    [anon_sym_blockaddress] = ACTIONS(283),
    [anon_sym_mul] = ACTIONS(283),
    [anon_sym_urem] = ACTIONS(283),
    [anon_sym_srem] = ACTIONS(283),
    [anon_sym_shl] = ACTIONS(283),
    [anon_sym_udiv] = ACTIONS(283),
    [anon_sym_sdiv] = ACTIONS(283),
    [anon_sym_lshr] = ACTIONS(283),
    [anon_sym_ashr] = ACTIONS(283),
    [anon_sym_fmul] = ACTIONS(283),
    [anon_sym_fdiv] = ACTIONS(283),
    [anon_sym_frem] = ACTIONS(283),
    [anon_sym_xchg] = ACTIONS(283),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(283),
    [anon_sym_nand] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(283),
    [anon_sym_xor] = ACTIONS(283),
    [anon_sym_max] = ACTIONS(283),
    [anon_sym_min] = ACTIONS(285),
    [anon_sym_umax] = ACTIONS(283),
    [anon_sym_umin] = ACTIONS(283),
    [anon_sym_fadd] = ACTIONS(283),
    [anon_sym_fsub] = ACTIONS(283),
    [anon_sym_bitcast] = ACTIONS(283),
    [anon_sym_trunc] = ACTIONS(283),
    [anon_sym_zext] = ACTIONS(283),
    [anon_sym_sext] = ACTIONS(283),
    [anon_sym_fptrunc] = ACTIONS(283),
    [anon_sym_fpext] = ACTIONS(283),
    [anon_sym_addrspacecast] = ACTIONS(283),
    [anon_sym_uitofp] = ACTIONS(283),
    [anon_sym_sitofp] = ACTIONS(283),
    [anon_sym_fptoui] = ACTIONS(283),
    [anon_sym_fptosi] = ACTIONS(283),
    [anon_sym_inttoptr] = ACTIONS(283),
    [anon_sym_ptrtoint] = ACTIONS(283),
    [anon_sym_uselistorder] = ACTIONS(285),
    [anon_sym_uselistorder_bb] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(283),
    [anon_sym_attributes] = ACTIONS(283),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(397),
    [sym_comdat_ref] = ACTIONS(397),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [aux_sym_metadata_ref_token1] = ACTIONS(397),
    [sym_summary_ref] = ACTIONS(397),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_target] = ACTIONS(397),
    [anon_sym_source_filename] = ACTIONS(397),
    [anon_sym_declare] = ACTIONS(397),
    [anon_sym_define] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_align] = ACTIONS(399),
    [anon_sym_section] = ACTIONS(397),
    [anon_sym_partition] = ACTIONS(397),
    [anon_sym_comdat] = ACTIONS(397),
    [anon_sym_gc] = ACTIONS(397),
    [anon_sym_prefix] = ACTIONS(397),
    [anon_sym_prologue] = ACTIONS(397),
    [anon_sym_personality] = ACTIONS(397),
    [anon_sym_alignstack] = ACTIONS(397),
    [anon_sym_allocsize] = ACTIONS(397),
    [anon_sym_alwaysinline] = ACTIONS(397),
    [anon_sym_builtin] = ACTIONS(397),
    [anon_sym_cold] = ACTIONS(397),
    [anon_sym_convergent] = ACTIONS(397),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(397),
    [anon_sym_hot] = ACTIONS(397),
    [anon_sym_inaccessiblememonly] = ACTIONS(397),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(397),
    [anon_sym_inlinehint] = ACTIONS(397),
    [anon_sym_jumptable] = ACTIONS(397),
    [anon_sym_minsize] = ACTIONS(397),
    [anon_sym_naked] = ACTIONS(397),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(397),
    [anon_sym_nobuiltin] = ACTIONS(397),
    [anon_sym_noduplicate] = ACTIONS(397),
    [anon_sym_nofree] = ACTIONS(397),
    [anon_sym_noimplicitfloat] = ACTIONS(397),
    [anon_sym_noinline] = ACTIONS(397),
    [anon_sym_nomerge] = ACTIONS(397),
    [anon_sym_nonlazybind] = ACTIONS(397),
    [anon_sym_noprofile] = ACTIONS(397),
    [anon_sym_noredzone] = ACTIONS(397),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(397),
    [anon_sym_noreturn] = ACTIONS(397),
    [anon_sym_norecurse] = ACTIONS(397),
    [anon_sym_willreturn] = ACTIONS(397),
    [anon_sym_nosync] = ACTIONS(397),
    [anon_sym_nounwind] = ACTIONS(397),
    [anon_sym_nosanitize_coverage] = ACTIONS(397),
    [anon_sym_null_pointer_is_valid] = ACTIONS(397),
    [anon_sym_optforfuzzing] = ACTIONS(397),
    [anon_sym_optnone] = ACTIONS(397),
    [anon_sym_optsize] = ACTIONS(397),
    [anon_sym_readnone] = ACTIONS(397),
    [anon_sym_readonly] = ACTIONS(397),
    [anon_sym_writeonly] = ACTIONS(397),
    [anon_sym_argmemonly] = ACTIONS(397),
    [anon_sym_returns_twice] = ACTIONS(397),
    [anon_sym_safestack] = ACTIONS(397),
    [anon_sym_sanitize_address] = ACTIONS(397),
    [anon_sym_sanitize_memory] = ACTIONS(397),
    [anon_sym_sanitize_thread] = ACTIONS(397),
    [anon_sym_sanitize_hwaddress] = ACTIONS(397),
    [anon_sym_sanitize_memtag] = ACTIONS(397),
    [anon_sym_speculative_load_hardening] = ACTIONS(397),
    [anon_sym_speculatable] = ACTIONS(397),
    [anon_sym_ssp] = ACTIONS(399),
    [anon_sym_sspstrong] = ACTIONS(397),
    [anon_sym_sspreq] = ACTIONS(397),
    [anon_sym_strictfp] = ACTIONS(397),
    [anon_sym_uwtable] = ACTIONS(397),
    [anon_sym_nocf_check] = ACTIONS(397),
    [anon_sym_shadowcallstack] = ACTIONS(397),
    [anon_sym_mustprogress] = ACTIONS(397),
    [anon_sym_vscale_range] = ACTIONS(397),
    [anon_sym_preallocated] = ACTIONS(397),
    [anon_sym_zeroext] = ACTIONS(397),
    [anon_sym_signext] = ACTIONS(397),
    [anon_sym_inreg] = ACTIONS(397),
    [anon_sym_byval] = ACTIONS(397),
    [anon_sym_byref] = ACTIONS(397),
    [anon_sym_inalloca] = ACTIONS(397),
    [anon_sym_sret] = ACTIONS(397),
    [anon_sym_elementtype] = ACTIONS(397),
    [anon_sym_noalias] = ACTIONS(397),
    [anon_sym_nocapture] = ACTIONS(397),
    [anon_sym_nest] = ACTIONS(397),
    [anon_sym_returned] = ACTIONS(397),
    [anon_sym_nonnull] = ACTIONS(397),
    [anon_sym_dereferenceable] = ACTIONS(399),
    [anon_sym_dereferenceable_or_null] = ACTIONS(397),
    [anon_sym_swiftself] = ACTIONS(397),
    [anon_sym_swiftasync] = ACTIONS(397),
    [anon_sym_swifterror] = ACTIONS(397),
    [anon_sym_immarg] = ACTIONS(397),
    [anon_sym_noundef] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_to] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(399),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(399),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
    [anon_sym_uselistorder] = ACTIONS(399),
    [anon_sym_uselistorder_bb] = ACTIONS(397),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_attributes] = ACTIONS(397),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(393),
    [sym_comdat_ref] = ACTIONS(393),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [aux_sym_metadata_ref_token1] = ACTIONS(393),
    [sym_summary_ref] = ACTIONS(393),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_target] = ACTIONS(393),
    [anon_sym_source_filename] = ACTIONS(393),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_define] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_align] = ACTIONS(395),
    [anon_sym_section] = ACTIONS(393),
    [anon_sym_partition] = ACTIONS(393),
    [anon_sym_comdat] = ACTIONS(393),
    [anon_sym_gc] = ACTIONS(393),
    [anon_sym_prefix] = ACTIONS(393),
    [anon_sym_prologue] = ACTIONS(393),
    [anon_sym_personality] = ACTIONS(393),
    [anon_sym_alignstack] = ACTIONS(393),
    [anon_sym_allocsize] = ACTIONS(393),
    [anon_sym_alwaysinline] = ACTIONS(393),
    [anon_sym_builtin] = ACTIONS(393),
    [anon_sym_cold] = ACTIONS(393),
    [anon_sym_convergent] = ACTIONS(393),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(393),
    [anon_sym_hot] = ACTIONS(393),
    [anon_sym_inaccessiblememonly] = ACTIONS(393),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(393),
    [anon_sym_inlinehint] = ACTIONS(393),
    [anon_sym_jumptable] = ACTIONS(393),
    [anon_sym_minsize] = ACTIONS(393),
    [anon_sym_naked] = ACTIONS(393),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(393),
    [anon_sym_nobuiltin] = ACTIONS(393),
    [anon_sym_noduplicate] = ACTIONS(393),
    [anon_sym_nofree] = ACTIONS(393),
    [anon_sym_noimplicitfloat] = ACTIONS(393),
    [anon_sym_noinline] = ACTIONS(393),
    [anon_sym_nomerge] = ACTIONS(393),
    [anon_sym_nonlazybind] = ACTIONS(393),
    [anon_sym_noprofile] = ACTIONS(393),
    [anon_sym_noredzone] = ACTIONS(393),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(393),
    [anon_sym_noreturn] = ACTIONS(393),
    [anon_sym_norecurse] = ACTIONS(393),
    [anon_sym_willreturn] = ACTIONS(393),
    [anon_sym_nosync] = ACTIONS(393),
    [anon_sym_nounwind] = ACTIONS(393),
    [anon_sym_nosanitize_coverage] = ACTIONS(393),
    [anon_sym_null_pointer_is_valid] = ACTIONS(393),
    [anon_sym_optforfuzzing] = ACTIONS(393),
    [anon_sym_optnone] = ACTIONS(393),
    [anon_sym_optsize] = ACTIONS(393),
    [anon_sym_readnone] = ACTIONS(393),
    [anon_sym_readonly] = ACTIONS(393),
    [anon_sym_writeonly] = ACTIONS(393),
    [anon_sym_argmemonly] = ACTIONS(393),
    [anon_sym_returns_twice] = ACTIONS(393),
    [anon_sym_safestack] = ACTIONS(393),
    [anon_sym_sanitize_address] = ACTIONS(393),
    [anon_sym_sanitize_memory] = ACTIONS(393),
    [anon_sym_sanitize_thread] = ACTIONS(393),
    [anon_sym_sanitize_hwaddress] = ACTIONS(393),
    [anon_sym_sanitize_memtag] = ACTIONS(393),
    [anon_sym_speculative_load_hardening] = ACTIONS(393),
    [anon_sym_speculatable] = ACTIONS(393),
    [anon_sym_ssp] = ACTIONS(395),
    [anon_sym_sspstrong] = ACTIONS(393),
    [anon_sym_sspreq] = ACTIONS(393),
    [anon_sym_strictfp] = ACTIONS(393),
    [anon_sym_uwtable] = ACTIONS(393),
    [anon_sym_nocf_check] = ACTIONS(393),
    [anon_sym_shadowcallstack] = ACTIONS(393),
    [anon_sym_mustprogress] = ACTIONS(393),
    [anon_sym_vscale_range] = ACTIONS(393),
    [anon_sym_preallocated] = ACTIONS(393),
    [anon_sym_zeroext] = ACTIONS(393),
    [anon_sym_signext] = ACTIONS(393),
    [anon_sym_inreg] = ACTIONS(393),
    [anon_sym_byval] = ACTIONS(393),
    [anon_sym_byref] = ACTIONS(393),
    [anon_sym_inalloca] = ACTIONS(393),
    [anon_sym_sret] = ACTIONS(393),
    [anon_sym_elementtype] = ACTIONS(393),
    [anon_sym_noalias] = ACTIONS(393),
    [anon_sym_nocapture] = ACTIONS(393),
    [anon_sym_nest] = ACTIONS(393),
    [anon_sym_returned] = ACTIONS(393),
    [anon_sym_nonnull] = ACTIONS(393),
    [anon_sym_dereferenceable] = ACTIONS(395),
    [anon_sym_dereferenceable_or_null] = ACTIONS(393),
    [anon_sym_swiftself] = ACTIONS(393),
    [anon_sym_swiftasync] = ACTIONS(393),
    [anon_sym_swifterror] = ACTIONS(393),
    [anon_sym_immarg] = ACTIONS(393),
    [anon_sym_noundef] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_to] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
    [anon_sym_uselistorder] = ACTIONS(395),
    [anon_sym_uselistorder_bb] = ACTIONS(393),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_attributes] = ACTIONS(393),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(263),
    [anon_sym_partition] = ACTIONS(263),
    [anon_sym_comdat] = ACTIONS(263),
    [anon_sym_gc] = ACTIONS(263),
    [anon_sym_prefix] = ACTIONS(263),
    [anon_sym_prologue] = ACTIONS(263),
    [anon_sym_personality] = ACTIONS(263),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(263),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(263),
    [anon_sym_swiftasync] = ACTIONS(263),
    [anon_sym_swifterror] = ACTIONS(263),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(497),
    [sym_global_var] = ACTIONS(497),
    [sym_local_var] = ACTIONS(497),
    [aux_sym_metadata_ref_token1] = ACTIONS(497),
    [sym_summary_ref] = ACTIONS(497),
    [sym_string] = ACTIONS(497),
    [anon_sym_target] = ACTIONS(497),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_source_filename] = ACTIONS(497),
    [anon_sym_declare] = ACTIONS(497),
    [anon_sym_define] = ACTIONS(497),
    [anon_sym_no_cfi] = ACTIONS(497),
    [anon_sym_private] = ACTIONS(497),
    [anon_sym_internal] = ACTIONS(497),
    [anon_sym_weak] = ACTIONS(499),
    [anon_sym_weak_odr] = ACTIONS(497),
    [anon_sym_linkonce] = ACTIONS(499),
    [anon_sym_linkonce_odr] = ACTIONS(497),
    [anon_sym_available_externally] = ACTIONS(497),
    [anon_sym_appending] = ACTIONS(497),
    [anon_sym_common] = ACTIONS(497),
    [anon_sym_extern_weak] = ACTIONS(497),
    [anon_sym_external] = ACTIONS(497),
    [anon_sym_dso_local] = ACTIONS(499),
    [anon_sym_dso_local_equivalent] = ACTIONS(497),
    [anon_sym_dso_preemptable] = ACTIONS(497),
    [anon_sym_default] = ACTIONS(497),
    [anon_sym_hidden] = ACTIONS(497),
    [anon_sym_protected] = ACTIONS(497),
    [anon_sym_dllimport] = ACTIONS(497),
    [anon_sym_dllexport] = ACTIONS(497),
    [anon_sym_ccc] = ACTIONS(497),
    [anon_sym_fastcc] = ACTIONS(497),
    [anon_sym_coldcc] = ACTIONS(497),
    [anon_sym_webkit_jscc] = ACTIONS(499),
    [anon_sym_anyregcc] = ACTIONS(497),
    [anon_sym_preserve_mostcc] = ACTIONS(497),
    [anon_sym_preserve_allcc] = ACTIONS(497),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(499),
    [anon_sym_tailcc] = ACTIONS(497),
    [anon_sym_swiftcc] = ACTIONS(499),
    [anon_sym_swifttailcc] = ACTIONS(499),
    [anon_sym_cfguard_checkcc] = ACTIONS(497),
    [aux_sym_calling_conv_token1] = ACTIONS(499),
    [aux_sym_calling_conv_token2] = ACTIONS(497),
    [aux_sym_calling_conv_token3] = ACTIONS(497),
    [aux_sym_calling_conv_token4] = ACTIONS(497),
    [aux_sym_calling_conv_token5] = ACTIONS(497),
    [aux_sym_calling_conv_token6] = ACTIONS(497),
    [aux_sym_calling_conv_token7] = ACTIONS(497),
    [aux_sym_calling_conv_token8] = ACTIONS(497),
    [aux_sym_calling_conv_token9] = ACTIONS(497),
    [aux_sym_calling_conv_token10] = ACTIONS(499),
    [anon_sym_ghccc] = ACTIONS(497),
    [aux_sym_calling_conv_token11] = ACTIONS(499),
    [aux_sym_calling_conv_token12] = ACTIONS(497),
    [aux_sym_calling_conv_token13] = ACTIONS(499),
    [aux_sym_calling_conv_token14] = ACTIONS(497),
    [anon_sym_cc] = ACTIONS(499),
    [anon_sym_unnamed_addr] = ACTIONS(497),
    [anon_sym_local_unnamed_addr] = ACTIONS(497),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_half] = ACTIONS(497),
    [anon_sym_bfloat] = ACTIONS(497),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_double] = ACTIONS(497),
    [anon_sym_x86_fp80] = ACTIONS(499),
    [anon_sym_fp128] = ACTIONS(497),
    [anon_sym_ppc_fp128] = ACTIONS(497),
    [anon_sym_label] = ACTIONS(497),
    [anon_sym_metadata] = ACTIONS(497),
    [anon_sym_x86_mmx] = ACTIONS(499),
    [anon_sym_x86_amx] = ACTIONS(499),
    [anon_sym_token] = ACTIONS(497),
    [anon_sym_opaque] = ACTIONS(497),
    [anon_sym_ptr] = ACTIONS(497),
    [aux_sym_type_keyword_token1] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LT_LBRACE] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_RPAREN] = ACTIONS(497),
    [anon_sym_align] = ACTIONS(499),
    [anon_sym_alignstack] = ACTIONS(497),
    [anon_sym_allocsize] = ACTIONS(497),
    [anon_sym_alwaysinline] = ACTIONS(497),
    [anon_sym_builtin] = ACTIONS(497),
    [anon_sym_cold] = ACTIONS(499),
    [anon_sym_convergent] = ACTIONS(497),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(497),
    [anon_sym_hot] = ACTIONS(497),
    [anon_sym_inaccessiblememonly] = ACTIONS(497),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(497),
    [anon_sym_inlinehint] = ACTIONS(497),
    [anon_sym_jumptable] = ACTIONS(497),
    [anon_sym_minsize] = ACTIONS(497),
    [anon_sym_naked] = ACTIONS(497),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(497),
    [anon_sym_nobuiltin] = ACTIONS(497),
    [anon_sym_noduplicate] = ACTIONS(497),
    [anon_sym_nofree] = ACTIONS(497),
    [anon_sym_noimplicitfloat] = ACTIONS(497),
    [anon_sym_noinline] = ACTIONS(497),
    [anon_sym_nomerge] = ACTIONS(497),
    [anon_sym_nonlazybind] = ACTIONS(497),
    [anon_sym_noprofile] = ACTIONS(497),
    [anon_sym_noredzone] = ACTIONS(497),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(497),
    [anon_sym_noreturn] = ACTIONS(497),
    [anon_sym_norecurse] = ACTIONS(497),
    [anon_sym_willreturn] = ACTIONS(497),
    [anon_sym_nosync] = ACTIONS(497),
    [anon_sym_nounwind] = ACTIONS(497),
    [anon_sym_nosanitize_coverage] = ACTIONS(497),
    [anon_sym_null_pointer_is_valid] = ACTIONS(497),
    [anon_sym_optforfuzzing] = ACTIONS(497),
    [anon_sym_optnone] = ACTIONS(497),
    [anon_sym_optsize] = ACTIONS(497),
    [anon_sym_readnone] = ACTIONS(497),
    [anon_sym_readonly] = ACTIONS(497),
    [anon_sym_writeonly] = ACTIONS(497),
    [anon_sym_argmemonly] = ACTIONS(497),
    [anon_sym_returns_twice] = ACTIONS(497),
    [anon_sym_safestack] = ACTIONS(497),
    [anon_sym_sanitize_address] = ACTIONS(497),
    [anon_sym_sanitize_memory] = ACTIONS(497),
    [anon_sym_sanitize_thread] = ACTIONS(497),
    [anon_sym_sanitize_hwaddress] = ACTIONS(497),
    [anon_sym_sanitize_memtag] = ACTIONS(497),
    [anon_sym_speculative_load_hardening] = ACTIONS(497),
    [anon_sym_speculatable] = ACTIONS(497),
    [anon_sym_ssp] = ACTIONS(499),
    [anon_sym_sspstrong] = ACTIONS(497),
    [anon_sym_sspreq] = ACTIONS(497),
    [anon_sym_strictfp] = ACTIONS(497),
    [anon_sym_uwtable] = ACTIONS(497),
    [anon_sym_nocf_check] = ACTIONS(497),
    [anon_sym_shadowcallstack] = ACTIONS(497),
    [anon_sym_mustprogress] = ACTIONS(497),
    [anon_sym_vscale_range] = ACTIONS(497),
    [anon_sym_preallocated] = ACTIONS(497),
    [anon_sym_zeroext] = ACTIONS(497),
    [anon_sym_signext] = ACTIONS(497),
    [anon_sym_inreg] = ACTIONS(497),
    [anon_sym_byval] = ACTIONS(497),
    [anon_sym_byref] = ACTIONS(497),
    [anon_sym_inalloca] = ACTIONS(497),
    [anon_sym_sret] = ACTIONS(497),
    [anon_sym_elementtype] = ACTIONS(497),
    [anon_sym_noalias] = ACTIONS(497),
    [anon_sym_nocapture] = ACTIONS(497),
    [anon_sym_nest] = ACTIONS(497),
    [anon_sym_returned] = ACTIONS(497),
    [anon_sym_nonnull] = ACTIONS(497),
    [anon_sym_dereferenceable] = ACTIONS(499),
    [anon_sym_dereferenceable_or_null] = ACTIONS(497),
    [anon_sym_swiftself] = ACTIONS(499),
    [anon_sym_swiftasync] = ACTIONS(499),
    [anon_sym_swifterror] = ACTIONS(499),
    [anon_sym_immarg] = ACTIONS(497),
    [anon_sym_noundef] = ACTIONS(497),
    [anon_sym_to] = ACTIONS(499),
    [anon_sym_unwind] = ACTIONS(497),
    [anon_sym_unordered] = ACTIONS(497),
    [anon_sym_monotonic] = ACTIONS(497),
    [anon_sym_acquire] = ACTIONS(497),
    [anon_sym_release] = ACTIONS(497),
    [anon_sym_acq_rel] = ACTIONS(497),
    [anon_sym_seq_cst] = ACTIONS(497),
    [anon_sym_syncscope] = ACTIONS(497),
    [anon_sym_uselistorder] = ACTIONS(499),
    [anon_sym_uselistorder_bb] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_LPAREN2] = ACTIONS(497),
    [anon_sym_attributes] = ACTIONS(497),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(501),
    [sym_global_var] = ACTIONS(501),
    [sym_local_var] = ACTIONS(501),
    [aux_sym_metadata_ref_token1] = ACTIONS(501),
    [sym_summary_ref] = ACTIONS(501),
    [sym_string] = ACTIONS(501),
    [anon_sym_target] = ACTIONS(501),
    [anon_sym_source_filename] = ACTIONS(501),
    [anon_sym_declare] = ACTIONS(501),
    [anon_sym_define] = ACTIONS(501),
    [anon_sym_no_cfi] = ACTIONS(501),
    [anon_sym_private] = ACTIONS(501),
    [anon_sym_internal] = ACTIONS(501),
    [anon_sym_weak] = ACTIONS(503),
    [anon_sym_weak_odr] = ACTIONS(501),
    [anon_sym_linkonce] = ACTIONS(503),
    [anon_sym_linkonce_odr] = ACTIONS(501),
    [anon_sym_available_externally] = ACTIONS(501),
    [anon_sym_appending] = ACTIONS(501),
    [anon_sym_common] = ACTIONS(501),
    [anon_sym_extern_weak] = ACTIONS(501),
    [anon_sym_external] = ACTIONS(501),
    [anon_sym_dso_local] = ACTIONS(503),
    [anon_sym_dso_local_equivalent] = ACTIONS(501),
    [anon_sym_dso_preemptable] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(501),
    [anon_sym_hidden] = ACTIONS(501),
    [anon_sym_protected] = ACTIONS(501),
    [anon_sym_dllimport] = ACTIONS(501),
    [anon_sym_dllexport] = ACTIONS(501),
    [anon_sym_ccc] = ACTIONS(501),
    [anon_sym_fastcc] = ACTIONS(501),
    [anon_sym_coldcc] = ACTIONS(501),
    [anon_sym_webkit_jscc] = ACTIONS(503),
    [anon_sym_anyregcc] = ACTIONS(501),
    [anon_sym_preserve_mostcc] = ACTIONS(501),
    [anon_sym_preserve_allcc] = ACTIONS(501),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(503),
    [anon_sym_tailcc] = ACTIONS(501),
    [anon_sym_swiftcc] = ACTIONS(503),
    [anon_sym_swifttailcc] = ACTIONS(503),
    [anon_sym_cfguard_checkcc] = ACTIONS(501),
    [aux_sym_calling_conv_token1] = ACTIONS(503),
    [aux_sym_calling_conv_token2] = ACTIONS(501),
    [aux_sym_calling_conv_token3] = ACTIONS(501),
    [aux_sym_calling_conv_token4] = ACTIONS(501),
    [aux_sym_calling_conv_token5] = ACTIONS(501),
    [aux_sym_calling_conv_token6] = ACTIONS(501),
    [aux_sym_calling_conv_token7] = ACTIONS(501),
    [aux_sym_calling_conv_token8] = ACTIONS(501),
    [aux_sym_calling_conv_token9] = ACTIONS(501),
    [aux_sym_calling_conv_token10] = ACTIONS(503),
    [anon_sym_ghccc] = ACTIONS(501),
    [aux_sym_calling_conv_token11] = ACTIONS(503),
    [aux_sym_calling_conv_token12] = ACTIONS(501),
    [aux_sym_calling_conv_token13] = ACTIONS(503),
    [aux_sym_calling_conv_token14] = ACTIONS(501),
    [anon_sym_cc] = ACTIONS(503),
    [anon_sym_unnamed_addr] = ACTIONS(501),
    [anon_sym_local_unnamed_addr] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(501),
    [anon_sym_half] = ACTIONS(501),
    [anon_sym_bfloat] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(501),
    [anon_sym_double] = ACTIONS(501),
    [anon_sym_x86_fp80] = ACTIONS(503),
    [anon_sym_fp128] = ACTIONS(501),
    [anon_sym_ppc_fp128] = ACTIONS(501),
    [anon_sym_label] = ACTIONS(501),
    [anon_sym_metadata] = ACTIONS(501),
    [anon_sym_x86_mmx] = ACTIONS(503),
    [anon_sym_x86_amx] = ACTIONS(503),
    [anon_sym_token] = ACTIONS(501),
    [anon_sym_opaque] = ACTIONS(501),
    [anon_sym_ptr] = ACTIONS(501),
    [aux_sym_type_keyword_token1] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LT_LBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_align] = ACTIONS(503),
    [anon_sym_alignstack] = ACTIONS(501),
    [anon_sym_allocsize] = ACTIONS(501),
    [anon_sym_alwaysinline] = ACTIONS(501),
    [anon_sym_builtin] = ACTIONS(501),
    [anon_sym_cold] = ACTIONS(503),
    [anon_sym_convergent] = ACTIONS(501),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(501),
    [anon_sym_hot] = ACTIONS(501),
    [anon_sym_inaccessiblememonly] = ACTIONS(501),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(501),
    [anon_sym_inlinehint] = ACTIONS(501),
    [anon_sym_jumptable] = ACTIONS(501),
    [anon_sym_minsize] = ACTIONS(501),
    [anon_sym_naked] = ACTIONS(501),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(501),
    [anon_sym_nobuiltin] = ACTIONS(501),
    [anon_sym_noduplicate] = ACTIONS(501),
    [anon_sym_nofree] = ACTIONS(501),
    [anon_sym_noimplicitfloat] = ACTIONS(501),
    [anon_sym_noinline] = ACTIONS(501),
    [anon_sym_nomerge] = ACTIONS(501),
    [anon_sym_nonlazybind] = ACTIONS(501),
    [anon_sym_noprofile] = ACTIONS(501),
    [anon_sym_noredzone] = ACTIONS(501),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(501),
    [anon_sym_noreturn] = ACTIONS(501),
    [anon_sym_norecurse] = ACTIONS(501),
    [anon_sym_willreturn] = ACTIONS(501),
    [anon_sym_nosync] = ACTIONS(501),
    [anon_sym_nounwind] = ACTIONS(501),
    [anon_sym_nosanitize_coverage] = ACTIONS(501),
    [anon_sym_null_pointer_is_valid] = ACTIONS(501),
    [anon_sym_optforfuzzing] = ACTIONS(501),
    [anon_sym_optnone] = ACTIONS(501),
    [anon_sym_optsize] = ACTIONS(501),
    [anon_sym_readnone] = ACTIONS(501),
    [anon_sym_readonly] = ACTIONS(501),
    [anon_sym_writeonly] = ACTIONS(501),
    [anon_sym_argmemonly] = ACTIONS(501),
    [anon_sym_returns_twice] = ACTIONS(501),
    [anon_sym_safestack] = ACTIONS(501),
    [anon_sym_sanitize_address] = ACTIONS(501),
    [anon_sym_sanitize_memory] = ACTIONS(501),
    [anon_sym_sanitize_thread] = ACTIONS(501),
    [anon_sym_sanitize_hwaddress] = ACTIONS(501),
    [anon_sym_sanitize_memtag] = ACTIONS(501),
    [anon_sym_speculative_load_hardening] = ACTIONS(501),
    [anon_sym_speculatable] = ACTIONS(501),
    [anon_sym_ssp] = ACTIONS(503),
    [anon_sym_sspstrong] = ACTIONS(501),
    [anon_sym_sspreq] = ACTIONS(501),
    [anon_sym_strictfp] = ACTIONS(501),
    [anon_sym_uwtable] = ACTIONS(501),
    [anon_sym_nocf_check] = ACTIONS(501),
    [anon_sym_shadowcallstack] = ACTIONS(501),
    [anon_sym_mustprogress] = ACTIONS(501),
    [anon_sym_vscale_range] = ACTIONS(501),
    [anon_sym_preallocated] = ACTIONS(501),
    [anon_sym_zeroext] = ACTIONS(501),
    [anon_sym_signext] = ACTIONS(501),
    [anon_sym_inreg] = ACTIONS(501),
    [anon_sym_byval] = ACTIONS(501),
    [anon_sym_byref] = ACTIONS(501),
    [anon_sym_inalloca] = ACTIONS(501),
    [anon_sym_sret] = ACTIONS(501),
    [anon_sym_elementtype] = ACTIONS(501),
    [anon_sym_noalias] = ACTIONS(501),
    [anon_sym_nocapture] = ACTIONS(501),
    [anon_sym_nest] = ACTIONS(501),
    [anon_sym_returned] = ACTIONS(501),
    [anon_sym_nonnull] = ACTIONS(501),
    [anon_sym_dereferenceable] = ACTIONS(503),
    [anon_sym_dereferenceable_or_null] = ACTIONS(501),
    [anon_sym_swiftself] = ACTIONS(503),
    [anon_sym_swiftasync] = ACTIONS(503),
    [anon_sym_swifterror] = ACTIONS(503),
    [anon_sym_immarg] = ACTIONS(501),
    [anon_sym_noundef] = ACTIONS(501),
    [anon_sym_to] = ACTIONS(503),
    [anon_sym_unwind] = ACTIONS(501),
    [anon_sym_unordered] = ACTIONS(501),
    [anon_sym_monotonic] = ACTIONS(501),
    [anon_sym_acquire] = ACTIONS(501),
    [anon_sym_release] = ACTIONS(501),
    [anon_sym_acq_rel] = ACTIONS(501),
    [anon_sym_seq_cst] = ACTIONS(501),
    [anon_sym_syncscope] = ACTIONS(501),
    [anon_sym_uselistorder] = ACTIONS(503),
    [anon_sym_uselistorder_bb] = ACTIONS(501),
    [anon_sym_module] = ACTIONS(501),
    [anon_sym_attributes] = ACTIONS(501),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(505),
    [sym_global_var] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [aux_sym_metadata_ref_token1] = ACTIONS(505),
    [sym_summary_ref] = ACTIONS(505),
    [sym_string] = ACTIONS(505),
    [anon_sym_target] = ACTIONS(505),
    [anon_sym_source_filename] = ACTIONS(505),
    [anon_sym_declare] = ACTIONS(505),
    [anon_sym_define] = ACTIONS(505),
    [anon_sym_no_cfi] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(505),
    [anon_sym_internal] = ACTIONS(505),
    [anon_sym_weak] = ACTIONS(507),
    [anon_sym_weak_odr] = ACTIONS(505),
    [anon_sym_linkonce] = ACTIONS(507),
    [anon_sym_linkonce_odr] = ACTIONS(505),
    [anon_sym_available_externally] = ACTIONS(505),
    [anon_sym_appending] = ACTIONS(505),
    [anon_sym_common] = ACTIONS(505),
    [anon_sym_extern_weak] = ACTIONS(505),
    [anon_sym_external] = ACTIONS(505),
    [anon_sym_dso_local] = ACTIONS(507),
    [anon_sym_dso_local_equivalent] = ACTIONS(505),
    [anon_sym_dso_preemptable] = ACTIONS(505),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_hidden] = ACTIONS(505),
    [anon_sym_protected] = ACTIONS(505),
    [anon_sym_dllimport] = ACTIONS(505),
    [anon_sym_dllexport] = ACTIONS(505),
    [anon_sym_ccc] = ACTIONS(505),
    [anon_sym_fastcc] = ACTIONS(505),
    [anon_sym_coldcc] = ACTIONS(505),
    [anon_sym_webkit_jscc] = ACTIONS(507),
    [anon_sym_anyregcc] = ACTIONS(505),
    [anon_sym_preserve_mostcc] = ACTIONS(505),
    [anon_sym_preserve_allcc] = ACTIONS(505),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(507),
    [anon_sym_tailcc] = ACTIONS(505),
    [anon_sym_swiftcc] = ACTIONS(507),
    [anon_sym_swifttailcc] = ACTIONS(507),
    [anon_sym_cfguard_checkcc] = ACTIONS(505),
    [aux_sym_calling_conv_token1] = ACTIONS(507),
    [aux_sym_calling_conv_token2] = ACTIONS(505),
    [aux_sym_calling_conv_token3] = ACTIONS(505),
    [aux_sym_calling_conv_token4] = ACTIONS(505),
    [aux_sym_calling_conv_token5] = ACTIONS(505),
    [aux_sym_calling_conv_token6] = ACTIONS(505),
    [aux_sym_calling_conv_token7] = ACTIONS(505),
    [aux_sym_calling_conv_token8] = ACTIONS(505),
    [aux_sym_calling_conv_token9] = ACTIONS(505),
    [aux_sym_calling_conv_token10] = ACTIONS(507),
    [anon_sym_ghccc] = ACTIONS(505),
    [aux_sym_calling_conv_token11] = ACTIONS(507),
    [aux_sym_calling_conv_token12] = ACTIONS(505),
    [aux_sym_calling_conv_token13] = ACTIONS(507),
    [aux_sym_calling_conv_token14] = ACTIONS(505),
    [anon_sym_cc] = ACTIONS(507),
    [anon_sym_unnamed_addr] = ACTIONS(505),
    [anon_sym_local_unnamed_addr] = ACTIONS(505),
    [anon_sym_void] = ACTIONS(505),
    [anon_sym_half] = ACTIONS(505),
    [anon_sym_bfloat] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(505),
    [anon_sym_double] = ACTIONS(505),
    [anon_sym_x86_fp80] = ACTIONS(507),
    [anon_sym_fp128] = ACTIONS(505),
    [anon_sym_ppc_fp128] = ACTIONS(505),
    [anon_sym_label] = ACTIONS(505),
    [anon_sym_metadata] = ACTIONS(505),
    [anon_sym_x86_mmx] = ACTIONS(507),
    [anon_sym_x86_amx] = ACTIONS(507),
    [anon_sym_token] = ACTIONS(505),
    [anon_sym_opaque] = ACTIONS(505),
    [anon_sym_ptr] = ACTIONS(505),
    [aux_sym_type_keyword_token1] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LT_LBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_alignstack] = ACTIONS(505),
    [anon_sym_allocsize] = ACTIONS(505),
    [anon_sym_alwaysinline] = ACTIONS(505),
    [anon_sym_builtin] = ACTIONS(505),
    [anon_sym_cold] = ACTIONS(507),
    [anon_sym_convergent] = ACTIONS(505),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(505),
    [anon_sym_hot] = ACTIONS(505),
    [anon_sym_inaccessiblememonly] = ACTIONS(505),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(505),
    [anon_sym_inlinehint] = ACTIONS(505),
    [anon_sym_jumptable] = ACTIONS(505),
    [anon_sym_minsize] = ACTIONS(505),
    [anon_sym_naked] = ACTIONS(505),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(505),
    [anon_sym_nobuiltin] = ACTIONS(505),
    [anon_sym_noduplicate] = ACTIONS(505),
    [anon_sym_nofree] = ACTIONS(505),
    [anon_sym_noimplicitfloat] = ACTIONS(505),
    [anon_sym_noinline] = ACTIONS(505),
    [anon_sym_nomerge] = ACTIONS(505),
    [anon_sym_nonlazybind] = ACTIONS(505),
    [anon_sym_noprofile] = ACTIONS(505),
    [anon_sym_noredzone] = ACTIONS(505),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(505),
    [anon_sym_noreturn] = ACTIONS(505),
    [anon_sym_norecurse] = ACTIONS(505),
    [anon_sym_willreturn] = ACTIONS(505),
    [anon_sym_nosync] = ACTIONS(505),
    [anon_sym_nounwind] = ACTIONS(505),
    [anon_sym_nosanitize_coverage] = ACTIONS(505),
    [anon_sym_null_pointer_is_valid] = ACTIONS(505),
    [anon_sym_optforfuzzing] = ACTIONS(505),
    [anon_sym_optnone] = ACTIONS(505),
    [anon_sym_optsize] = ACTIONS(505),
    [anon_sym_readnone] = ACTIONS(505),
    [anon_sym_readonly] = ACTIONS(505),
    [anon_sym_writeonly] = ACTIONS(505),
    [anon_sym_argmemonly] = ACTIONS(505),
    [anon_sym_returns_twice] = ACTIONS(505),
    [anon_sym_safestack] = ACTIONS(505),
    [anon_sym_sanitize_address] = ACTIONS(505),
    [anon_sym_sanitize_memory] = ACTIONS(505),
    [anon_sym_sanitize_thread] = ACTIONS(505),
    [anon_sym_sanitize_hwaddress] = ACTIONS(505),
    [anon_sym_sanitize_memtag] = ACTIONS(505),
    [anon_sym_speculative_load_hardening] = ACTIONS(505),
    [anon_sym_speculatable] = ACTIONS(505),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(505),
    [anon_sym_sspreq] = ACTIONS(505),
    [anon_sym_strictfp] = ACTIONS(505),
    [anon_sym_uwtable] = ACTIONS(505),
    [anon_sym_nocf_check] = ACTIONS(505),
    [anon_sym_shadowcallstack] = ACTIONS(505),
    [anon_sym_mustprogress] = ACTIONS(505),
    [anon_sym_vscale_range] = ACTIONS(505),
    [anon_sym_preallocated] = ACTIONS(505),
    [anon_sym_zeroext] = ACTIONS(505),
    [anon_sym_signext] = ACTIONS(505),
    [anon_sym_inreg] = ACTIONS(505),
    [anon_sym_byval] = ACTIONS(505),
    [anon_sym_byref] = ACTIONS(505),
    [anon_sym_inalloca] = ACTIONS(505),
    [anon_sym_sret] = ACTIONS(505),
    [anon_sym_elementtype] = ACTIONS(505),
    [anon_sym_noalias] = ACTIONS(505),
    [anon_sym_nocapture] = ACTIONS(505),
    [anon_sym_nest] = ACTIONS(505),
    [anon_sym_returned] = ACTIONS(505),
    [anon_sym_nonnull] = ACTIONS(505),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(505),
    [anon_sym_swiftself] = ACTIONS(507),
    [anon_sym_swiftasync] = ACTIONS(507),
    [anon_sym_swifterror] = ACTIONS(507),
    [anon_sym_immarg] = ACTIONS(505),
    [anon_sym_noundef] = ACTIONS(505),
    [anon_sym_to] = ACTIONS(507),
    [anon_sym_unwind] = ACTIONS(505),
    [anon_sym_unordered] = ACTIONS(505),
    [anon_sym_monotonic] = ACTIONS(505),
    [anon_sym_acquire] = ACTIONS(505),
    [anon_sym_release] = ACTIONS(505),
    [anon_sym_acq_rel] = ACTIONS(505),
    [anon_sym_seq_cst] = ACTIONS(505),
    [anon_sym_syncscope] = ACTIONS(505),
    [anon_sym_uselistorder] = ACTIONS(507),
    [anon_sym_uselistorder_bb] = ACTIONS(505),
    [anon_sym_module] = ACTIONS(505),
    [anon_sym_attributes] = ACTIONS(505),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(509),
    [sym_global_var] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [aux_sym_metadata_ref_token1] = ACTIONS(509),
    [sym_summary_ref] = ACTIONS(509),
    [sym_string] = ACTIONS(509),
    [anon_sym_target] = ACTIONS(509),
    [anon_sym_source_filename] = ACTIONS(509),
    [anon_sym_declare] = ACTIONS(509),
    [anon_sym_define] = ACTIONS(509),
    [anon_sym_no_cfi] = ACTIONS(509),
    [anon_sym_private] = ACTIONS(509),
    [anon_sym_internal] = ACTIONS(509),
    [anon_sym_weak] = ACTIONS(511),
    [anon_sym_weak_odr] = ACTIONS(509),
    [anon_sym_linkonce] = ACTIONS(511),
    [anon_sym_linkonce_odr] = ACTIONS(509),
    [anon_sym_available_externally] = ACTIONS(509),
    [anon_sym_appending] = ACTIONS(509),
    [anon_sym_common] = ACTIONS(509),
    [anon_sym_extern_weak] = ACTIONS(509),
    [anon_sym_external] = ACTIONS(509),
    [anon_sym_dso_local] = ACTIONS(511),
    [anon_sym_dso_local_equivalent] = ACTIONS(509),
    [anon_sym_dso_preemptable] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_hidden] = ACTIONS(509),
    [anon_sym_protected] = ACTIONS(509),
    [anon_sym_dllimport] = ACTIONS(509),
    [anon_sym_dllexport] = ACTIONS(509),
    [anon_sym_ccc] = ACTIONS(509),
    [anon_sym_fastcc] = ACTIONS(509),
    [anon_sym_coldcc] = ACTIONS(509),
    [anon_sym_webkit_jscc] = ACTIONS(511),
    [anon_sym_anyregcc] = ACTIONS(509),
    [anon_sym_preserve_mostcc] = ACTIONS(509),
    [anon_sym_preserve_allcc] = ACTIONS(509),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(511),
    [anon_sym_tailcc] = ACTIONS(509),
    [anon_sym_swiftcc] = ACTIONS(511),
    [anon_sym_swifttailcc] = ACTIONS(511),
    [anon_sym_cfguard_checkcc] = ACTIONS(509),
    [aux_sym_calling_conv_token1] = ACTIONS(511),
    [aux_sym_calling_conv_token2] = ACTIONS(509),
    [aux_sym_calling_conv_token3] = ACTIONS(509),
    [aux_sym_calling_conv_token4] = ACTIONS(509),
    [aux_sym_calling_conv_token5] = ACTIONS(509),
    [aux_sym_calling_conv_token6] = ACTIONS(509),
    [aux_sym_calling_conv_token7] = ACTIONS(509),
    [aux_sym_calling_conv_token8] = ACTIONS(509),
    [aux_sym_calling_conv_token9] = ACTIONS(509),
    [aux_sym_calling_conv_token10] = ACTIONS(511),
    [anon_sym_ghccc] = ACTIONS(509),
    [aux_sym_calling_conv_token11] = ACTIONS(511),
    [aux_sym_calling_conv_token12] = ACTIONS(509),
    [aux_sym_calling_conv_token13] = ACTIONS(511),
    [aux_sym_calling_conv_token14] = ACTIONS(509),
    [anon_sym_cc] = ACTIONS(511),
    [anon_sym_unnamed_addr] = ACTIONS(509),
    [anon_sym_local_unnamed_addr] = ACTIONS(509),
    [anon_sym_void] = ACTIONS(509),
    [anon_sym_half] = ACTIONS(509),
    [anon_sym_bfloat] = ACTIONS(509),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_double] = ACTIONS(509),
    [anon_sym_x86_fp80] = ACTIONS(511),
    [anon_sym_fp128] = ACTIONS(509),
    [anon_sym_ppc_fp128] = ACTIONS(509),
    [anon_sym_label] = ACTIONS(509),
    [anon_sym_metadata] = ACTIONS(509),
    [anon_sym_x86_mmx] = ACTIONS(511),
    [anon_sym_x86_amx] = ACTIONS(511),
    [anon_sym_token] = ACTIONS(509),
    [anon_sym_opaque] = ACTIONS(509),
    [anon_sym_ptr] = ACTIONS(509),
    [aux_sym_type_keyword_token1] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LT_LBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_alignstack] = ACTIONS(509),
    [anon_sym_allocsize] = ACTIONS(509),
    [anon_sym_alwaysinline] = ACTIONS(509),
    [anon_sym_builtin] = ACTIONS(509),
    [anon_sym_cold] = ACTIONS(511),
    [anon_sym_convergent] = ACTIONS(509),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(509),
    [anon_sym_hot] = ACTIONS(509),
    [anon_sym_inaccessiblememonly] = ACTIONS(509),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(509),
    [anon_sym_inlinehint] = ACTIONS(509),
    [anon_sym_jumptable] = ACTIONS(509),
    [anon_sym_minsize] = ACTIONS(509),
    [anon_sym_naked] = ACTIONS(509),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(509),
    [anon_sym_nobuiltin] = ACTIONS(509),
    [anon_sym_noduplicate] = ACTIONS(509),
    [anon_sym_nofree] = ACTIONS(509),
    [anon_sym_noimplicitfloat] = ACTIONS(509),
    [anon_sym_noinline] = ACTIONS(509),
    [anon_sym_nomerge] = ACTIONS(509),
    [anon_sym_nonlazybind] = ACTIONS(509),
    [anon_sym_noprofile] = ACTIONS(509),
    [anon_sym_noredzone] = ACTIONS(509),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(509),
    [anon_sym_noreturn] = ACTIONS(509),
    [anon_sym_norecurse] = ACTIONS(509),
    [anon_sym_willreturn] = ACTIONS(509),
    [anon_sym_nosync] = ACTIONS(509),
    [anon_sym_nounwind] = ACTIONS(509),
    [anon_sym_nosanitize_coverage] = ACTIONS(509),
    [anon_sym_null_pointer_is_valid] = ACTIONS(509),
    [anon_sym_optforfuzzing] = ACTIONS(509),
    [anon_sym_optnone] = ACTIONS(509),
    [anon_sym_optsize] = ACTIONS(509),
    [anon_sym_readnone] = ACTIONS(509),
    [anon_sym_readonly] = ACTIONS(509),
    [anon_sym_writeonly] = ACTIONS(509),
    [anon_sym_argmemonly] = ACTIONS(509),
    [anon_sym_returns_twice] = ACTIONS(509),
    [anon_sym_safestack] = ACTIONS(509),
    [anon_sym_sanitize_address] = ACTIONS(509),
    [anon_sym_sanitize_memory] = ACTIONS(509),
    [anon_sym_sanitize_thread] = ACTIONS(509),
    [anon_sym_sanitize_hwaddress] = ACTIONS(509),
    [anon_sym_sanitize_memtag] = ACTIONS(509),
    [anon_sym_speculative_load_hardening] = ACTIONS(509),
    [anon_sym_speculatable] = ACTIONS(509),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(509),
    [anon_sym_sspreq] = ACTIONS(509),
    [anon_sym_strictfp] = ACTIONS(509),
    [anon_sym_uwtable] = ACTIONS(509),
    [anon_sym_nocf_check] = ACTIONS(509),
    [anon_sym_shadowcallstack] = ACTIONS(509),
    [anon_sym_mustprogress] = ACTIONS(509),
    [anon_sym_vscale_range] = ACTIONS(509),
    [anon_sym_preallocated] = ACTIONS(509),
    [anon_sym_zeroext] = ACTIONS(509),
    [anon_sym_signext] = ACTIONS(509),
    [anon_sym_inreg] = ACTIONS(509),
    [anon_sym_byval] = ACTIONS(509),
    [anon_sym_byref] = ACTIONS(509),
    [anon_sym_inalloca] = ACTIONS(509),
    [anon_sym_sret] = ACTIONS(509),
    [anon_sym_elementtype] = ACTIONS(509),
    [anon_sym_noalias] = ACTIONS(509),
    [anon_sym_nocapture] = ACTIONS(509),
    [anon_sym_nest] = ACTIONS(509),
    [anon_sym_returned] = ACTIONS(509),
    [anon_sym_nonnull] = ACTIONS(509),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(509),
    [anon_sym_swiftself] = ACTIONS(511),
    [anon_sym_swiftasync] = ACTIONS(511),
    [anon_sym_swifterror] = ACTIONS(511),
    [anon_sym_immarg] = ACTIONS(509),
    [anon_sym_noundef] = ACTIONS(509),
    [anon_sym_to] = ACTIONS(511),
    [anon_sym_unwind] = ACTIONS(509),
    [anon_sym_unordered] = ACTIONS(509),
    [anon_sym_monotonic] = ACTIONS(509),
    [anon_sym_acquire] = ACTIONS(509),
    [anon_sym_release] = ACTIONS(509),
    [anon_sym_acq_rel] = ACTIONS(509),
    [anon_sym_seq_cst] = ACTIONS(509),
    [anon_sym_syncscope] = ACTIONS(509),
    [anon_sym_uselistorder] = ACTIONS(511),
    [anon_sym_uselistorder_bb] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_attributes] = ACTIONS(509),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(513),
    [sym_global_var] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [aux_sym_metadata_ref_token1] = ACTIONS(513),
    [sym_summary_ref] = ACTIONS(513),
    [sym_string] = ACTIONS(513),
    [anon_sym_target] = ACTIONS(513),
    [anon_sym_source_filename] = ACTIONS(513),
    [anon_sym_declare] = ACTIONS(513),
    [anon_sym_define] = ACTIONS(513),
    [anon_sym_no_cfi] = ACTIONS(513),
    [anon_sym_private] = ACTIONS(513),
    [anon_sym_internal] = ACTIONS(513),
    [anon_sym_weak] = ACTIONS(515),
    [anon_sym_weak_odr] = ACTIONS(513),
    [anon_sym_linkonce] = ACTIONS(515),
    [anon_sym_linkonce_odr] = ACTIONS(513),
    [anon_sym_available_externally] = ACTIONS(513),
    [anon_sym_appending] = ACTIONS(513),
    [anon_sym_common] = ACTIONS(513),
    [anon_sym_extern_weak] = ACTIONS(513),
    [anon_sym_external] = ACTIONS(513),
    [anon_sym_dso_local] = ACTIONS(515),
    [anon_sym_dso_local_equivalent] = ACTIONS(513),
    [anon_sym_dso_preemptable] = ACTIONS(513),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_hidden] = ACTIONS(513),
    [anon_sym_protected] = ACTIONS(513),
    [anon_sym_dllimport] = ACTIONS(513),
    [anon_sym_dllexport] = ACTIONS(513),
    [anon_sym_ccc] = ACTIONS(513),
    [anon_sym_fastcc] = ACTIONS(513),
    [anon_sym_coldcc] = ACTIONS(513),
    [anon_sym_webkit_jscc] = ACTIONS(515),
    [anon_sym_anyregcc] = ACTIONS(513),
    [anon_sym_preserve_mostcc] = ACTIONS(513),
    [anon_sym_preserve_allcc] = ACTIONS(513),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(515),
    [anon_sym_tailcc] = ACTIONS(513),
    [anon_sym_swiftcc] = ACTIONS(515),
    [anon_sym_swifttailcc] = ACTIONS(515),
    [anon_sym_cfguard_checkcc] = ACTIONS(513),
    [aux_sym_calling_conv_token1] = ACTIONS(515),
    [aux_sym_calling_conv_token2] = ACTIONS(513),
    [aux_sym_calling_conv_token3] = ACTIONS(513),
    [aux_sym_calling_conv_token4] = ACTIONS(513),
    [aux_sym_calling_conv_token5] = ACTIONS(513),
    [aux_sym_calling_conv_token6] = ACTIONS(513),
    [aux_sym_calling_conv_token7] = ACTIONS(513),
    [aux_sym_calling_conv_token8] = ACTIONS(513),
    [aux_sym_calling_conv_token9] = ACTIONS(513),
    [aux_sym_calling_conv_token10] = ACTIONS(515),
    [anon_sym_ghccc] = ACTIONS(513),
    [aux_sym_calling_conv_token11] = ACTIONS(515),
    [aux_sym_calling_conv_token12] = ACTIONS(513),
    [aux_sym_calling_conv_token13] = ACTIONS(515),
    [aux_sym_calling_conv_token14] = ACTIONS(513),
    [anon_sym_cc] = ACTIONS(515),
    [anon_sym_unnamed_addr] = ACTIONS(513),
    [anon_sym_local_unnamed_addr] = ACTIONS(513),
    [anon_sym_void] = ACTIONS(513),
    [anon_sym_half] = ACTIONS(513),
    [anon_sym_bfloat] = ACTIONS(513),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_double] = ACTIONS(513),
    [anon_sym_x86_fp80] = ACTIONS(515),
    [anon_sym_fp128] = ACTIONS(513),
    [anon_sym_ppc_fp128] = ACTIONS(513),
    [anon_sym_label] = ACTIONS(513),
    [anon_sym_metadata] = ACTIONS(513),
    [anon_sym_x86_mmx] = ACTIONS(515),
    [anon_sym_x86_amx] = ACTIONS(515),
    [anon_sym_token] = ACTIONS(513),
    [anon_sym_opaque] = ACTIONS(513),
    [anon_sym_ptr] = ACTIONS(513),
    [aux_sym_type_keyword_token1] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LT_LBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(513),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_alignstack] = ACTIONS(513),
    [anon_sym_allocsize] = ACTIONS(513),
    [anon_sym_alwaysinline] = ACTIONS(513),
    [anon_sym_builtin] = ACTIONS(513),
    [anon_sym_cold] = ACTIONS(515),
    [anon_sym_convergent] = ACTIONS(513),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(513),
    [anon_sym_hot] = ACTIONS(513),
    [anon_sym_inaccessiblememonly] = ACTIONS(513),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(513),
    [anon_sym_inlinehint] = ACTIONS(513),
    [anon_sym_jumptable] = ACTIONS(513),
    [anon_sym_minsize] = ACTIONS(513),
    [anon_sym_naked] = ACTIONS(513),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(513),
    [anon_sym_nobuiltin] = ACTIONS(513),
    [anon_sym_noduplicate] = ACTIONS(513),
    [anon_sym_nofree] = ACTIONS(513),
    [anon_sym_noimplicitfloat] = ACTIONS(513),
    [anon_sym_noinline] = ACTIONS(513),
    [anon_sym_nomerge] = ACTIONS(513),
    [anon_sym_nonlazybind] = ACTIONS(513),
    [anon_sym_noprofile] = ACTIONS(513),
    [anon_sym_noredzone] = ACTIONS(513),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(513),
    [anon_sym_noreturn] = ACTIONS(513),
    [anon_sym_norecurse] = ACTIONS(513),
    [anon_sym_willreturn] = ACTIONS(513),
    [anon_sym_nosync] = ACTIONS(513),
    [anon_sym_nounwind] = ACTIONS(513),
    [anon_sym_nosanitize_coverage] = ACTIONS(513),
    [anon_sym_null_pointer_is_valid] = ACTIONS(513),
    [anon_sym_optforfuzzing] = ACTIONS(513),
    [anon_sym_optnone] = ACTIONS(513),
    [anon_sym_optsize] = ACTIONS(513),
    [anon_sym_readnone] = ACTIONS(513),
    [anon_sym_readonly] = ACTIONS(513),
    [anon_sym_writeonly] = ACTIONS(513),
    [anon_sym_argmemonly] = ACTIONS(513),
    [anon_sym_returns_twice] = ACTIONS(513),
    [anon_sym_safestack] = ACTIONS(513),
    [anon_sym_sanitize_address] = ACTIONS(513),
    [anon_sym_sanitize_memory] = ACTIONS(513),
    [anon_sym_sanitize_thread] = ACTIONS(513),
    [anon_sym_sanitize_hwaddress] = ACTIONS(513),
    [anon_sym_sanitize_memtag] = ACTIONS(513),
    [anon_sym_speculative_load_hardening] = ACTIONS(513),
    [anon_sym_speculatable] = ACTIONS(513),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(513),
    [anon_sym_sspreq] = ACTIONS(513),
    [anon_sym_strictfp] = ACTIONS(513),
    [anon_sym_uwtable] = ACTIONS(513),
    [anon_sym_nocf_check] = ACTIONS(513),
    [anon_sym_shadowcallstack] = ACTIONS(513),
    [anon_sym_mustprogress] = ACTIONS(513),
    [anon_sym_vscale_range] = ACTIONS(513),
    [anon_sym_preallocated] = ACTIONS(513),
    [anon_sym_zeroext] = ACTIONS(513),
    [anon_sym_signext] = ACTIONS(513),
    [anon_sym_inreg] = ACTIONS(513),
    [anon_sym_byval] = ACTIONS(513),
    [anon_sym_byref] = ACTIONS(513),
    [anon_sym_inalloca] = ACTIONS(513),
    [anon_sym_sret] = ACTIONS(513),
    [anon_sym_elementtype] = ACTIONS(513),
    [anon_sym_noalias] = ACTIONS(513),
    [anon_sym_nocapture] = ACTIONS(513),
    [anon_sym_nest] = ACTIONS(513),
    [anon_sym_returned] = ACTIONS(513),
    [anon_sym_nonnull] = ACTIONS(513),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(513),
    [anon_sym_swiftself] = ACTIONS(515),
    [anon_sym_swiftasync] = ACTIONS(515),
    [anon_sym_swifterror] = ACTIONS(515),
    [anon_sym_immarg] = ACTIONS(513),
    [anon_sym_noundef] = ACTIONS(513),
    [anon_sym_to] = ACTIONS(515),
    [anon_sym_unwind] = ACTIONS(513),
    [anon_sym_unordered] = ACTIONS(513),
    [anon_sym_monotonic] = ACTIONS(513),
    [anon_sym_acquire] = ACTIONS(513),
    [anon_sym_release] = ACTIONS(513),
    [anon_sym_acq_rel] = ACTIONS(513),
    [anon_sym_seq_cst] = ACTIONS(513),
    [anon_sym_syncscope] = ACTIONS(513),
    [anon_sym_uselistorder] = ACTIONS(515),
    [anon_sym_uselistorder_bb] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_attributes] = ACTIONS(513),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(517),
    [sym_global_var] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [aux_sym_metadata_ref_token1] = ACTIONS(517),
    [sym_summary_ref] = ACTIONS(517),
    [sym_string] = ACTIONS(517),
    [anon_sym_target] = ACTIONS(517),
    [anon_sym_source_filename] = ACTIONS(517),
    [anon_sym_declare] = ACTIONS(517),
    [anon_sym_define] = ACTIONS(517),
    [anon_sym_no_cfi] = ACTIONS(517),
    [anon_sym_private] = ACTIONS(517),
    [anon_sym_internal] = ACTIONS(517),
    [anon_sym_weak] = ACTIONS(519),
    [anon_sym_weak_odr] = ACTIONS(517),
    [anon_sym_linkonce] = ACTIONS(519),
    [anon_sym_linkonce_odr] = ACTIONS(517),
    [anon_sym_available_externally] = ACTIONS(517),
    [anon_sym_appending] = ACTIONS(517),
    [anon_sym_common] = ACTIONS(517),
    [anon_sym_extern_weak] = ACTIONS(517),
    [anon_sym_external] = ACTIONS(517),
    [anon_sym_dso_local] = ACTIONS(519),
    [anon_sym_dso_local_equivalent] = ACTIONS(517),
    [anon_sym_dso_preemptable] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_hidden] = ACTIONS(517),
    [anon_sym_protected] = ACTIONS(517),
    [anon_sym_dllimport] = ACTIONS(517),
    [anon_sym_dllexport] = ACTIONS(517),
    [anon_sym_ccc] = ACTIONS(517),
    [anon_sym_fastcc] = ACTIONS(517),
    [anon_sym_coldcc] = ACTIONS(517),
    [anon_sym_webkit_jscc] = ACTIONS(519),
    [anon_sym_anyregcc] = ACTIONS(517),
    [anon_sym_preserve_mostcc] = ACTIONS(517),
    [anon_sym_preserve_allcc] = ACTIONS(517),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(519),
    [anon_sym_tailcc] = ACTIONS(517),
    [anon_sym_swiftcc] = ACTIONS(519),
    [anon_sym_swifttailcc] = ACTIONS(519),
    [anon_sym_cfguard_checkcc] = ACTIONS(517),
    [aux_sym_calling_conv_token1] = ACTIONS(519),
    [aux_sym_calling_conv_token2] = ACTIONS(517),
    [aux_sym_calling_conv_token3] = ACTIONS(517),
    [aux_sym_calling_conv_token4] = ACTIONS(517),
    [aux_sym_calling_conv_token5] = ACTIONS(517),
    [aux_sym_calling_conv_token6] = ACTIONS(517),
    [aux_sym_calling_conv_token7] = ACTIONS(517),
    [aux_sym_calling_conv_token8] = ACTIONS(517),
    [aux_sym_calling_conv_token9] = ACTIONS(517),
    [aux_sym_calling_conv_token10] = ACTIONS(519),
    [anon_sym_ghccc] = ACTIONS(517),
    [aux_sym_calling_conv_token11] = ACTIONS(519),
    [aux_sym_calling_conv_token12] = ACTIONS(517),
    [aux_sym_calling_conv_token13] = ACTIONS(519),
    [aux_sym_calling_conv_token14] = ACTIONS(517),
    [anon_sym_cc] = ACTIONS(519),
    [anon_sym_unnamed_addr] = ACTIONS(517),
    [anon_sym_local_unnamed_addr] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_half] = ACTIONS(517),
    [anon_sym_bfloat] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(517),
    [anon_sym_double] = ACTIONS(517),
    [anon_sym_x86_fp80] = ACTIONS(519),
    [anon_sym_fp128] = ACTIONS(517),
    [anon_sym_ppc_fp128] = ACTIONS(517),
    [anon_sym_label] = ACTIONS(517),
    [anon_sym_metadata] = ACTIONS(517),
    [anon_sym_x86_mmx] = ACTIONS(519),
    [anon_sym_x86_amx] = ACTIONS(519),
    [anon_sym_token] = ACTIONS(517),
    [anon_sym_opaque] = ACTIONS(517),
    [anon_sym_ptr] = ACTIONS(517),
    [aux_sym_type_keyword_token1] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LT_LBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_alignstack] = ACTIONS(517),
    [anon_sym_allocsize] = ACTIONS(517),
    [anon_sym_alwaysinline] = ACTIONS(517),
    [anon_sym_builtin] = ACTIONS(517),
    [anon_sym_cold] = ACTIONS(519),
    [anon_sym_convergent] = ACTIONS(517),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(517),
    [anon_sym_hot] = ACTIONS(517),
    [anon_sym_inaccessiblememonly] = ACTIONS(517),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(517),
    [anon_sym_inlinehint] = ACTIONS(517),
    [anon_sym_jumptable] = ACTIONS(517),
    [anon_sym_minsize] = ACTIONS(517),
    [anon_sym_naked] = ACTIONS(517),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(517),
    [anon_sym_nobuiltin] = ACTIONS(517),
    [anon_sym_noduplicate] = ACTIONS(517),
    [anon_sym_nofree] = ACTIONS(517),
    [anon_sym_noimplicitfloat] = ACTIONS(517),
    [anon_sym_noinline] = ACTIONS(517),
    [anon_sym_nomerge] = ACTIONS(517),
    [anon_sym_nonlazybind] = ACTIONS(517),
    [anon_sym_noprofile] = ACTIONS(517),
    [anon_sym_noredzone] = ACTIONS(517),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(517),
    [anon_sym_noreturn] = ACTIONS(517),
    [anon_sym_norecurse] = ACTIONS(517),
    [anon_sym_willreturn] = ACTIONS(517),
    [anon_sym_nosync] = ACTIONS(517),
    [anon_sym_nounwind] = ACTIONS(517),
    [anon_sym_nosanitize_coverage] = ACTIONS(517),
    [anon_sym_null_pointer_is_valid] = ACTIONS(517),
    [anon_sym_optforfuzzing] = ACTIONS(517),
    [anon_sym_optnone] = ACTIONS(517),
    [anon_sym_optsize] = ACTIONS(517),
    [anon_sym_readnone] = ACTIONS(517),
    [anon_sym_readonly] = ACTIONS(517),
    [anon_sym_writeonly] = ACTIONS(517),
    [anon_sym_argmemonly] = ACTIONS(517),
    [anon_sym_returns_twice] = ACTIONS(517),
    [anon_sym_safestack] = ACTIONS(517),
    [anon_sym_sanitize_address] = ACTIONS(517),
    [anon_sym_sanitize_memory] = ACTIONS(517),
    [anon_sym_sanitize_thread] = ACTIONS(517),
    [anon_sym_sanitize_hwaddress] = ACTIONS(517),
    [anon_sym_sanitize_memtag] = ACTIONS(517),
    [anon_sym_speculative_load_hardening] = ACTIONS(517),
    [anon_sym_speculatable] = ACTIONS(517),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(517),
    [anon_sym_sspreq] = ACTIONS(517),
    [anon_sym_strictfp] = ACTIONS(517),
    [anon_sym_uwtable] = ACTIONS(517),
    [anon_sym_nocf_check] = ACTIONS(517),
    [anon_sym_shadowcallstack] = ACTIONS(517),
    [anon_sym_mustprogress] = ACTIONS(517),
    [anon_sym_vscale_range] = ACTIONS(517),
    [anon_sym_preallocated] = ACTIONS(517),
    [anon_sym_zeroext] = ACTIONS(517),
    [anon_sym_signext] = ACTIONS(517),
    [anon_sym_inreg] = ACTIONS(517),
    [anon_sym_byval] = ACTIONS(517),
    [anon_sym_byref] = ACTIONS(517),
    [anon_sym_inalloca] = ACTIONS(517),
    [anon_sym_sret] = ACTIONS(517),
    [anon_sym_elementtype] = ACTIONS(517),
    [anon_sym_noalias] = ACTIONS(517),
    [anon_sym_nocapture] = ACTIONS(517),
    [anon_sym_nest] = ACTIONS(517),
    [anon_sym_returned] = ACTIONS(517),
    [anon_sym_nonnull] = ACTIONS(517),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(517),
    [anon_sym_swiftself] = ACTIONS(519),
    [anon_sym_swiftasync] = ACTIONS(519),
    [anon_sym_swifterror] = ACTIONS(519),
    [anon_sym_immarg] = ACTIONS(517),
    [anon_sym_noundef] = ACTIONS(517),
    [anon_sym_to] = ACTIONS(519),
    [anon_sym_unwind] = ACTIONS(517),
    [anon_sym_unordered] = ACTIONS(517),
    [anon_sym_monotonic] = ACTIONS(517),
    [anon_sym_acquire] = ACTIONS(517),
    [anon_sym_release] = ACTIONS(517),
    [anon_sym_acq_rel] = ACTIONS(517),
    [anon_sym_seq_cst] = ACTIONS(517),
    [anon_sym_syncscope] = ACTIONS(517),
    [anon_sym_uselistorder] = ACTIONS(519),
    [anon_sym_uselistorder_bb] = ACTIONS(517),
    [anon_sym_module] = ACTIONS(517),
    [anon_sym_attributes] = ACTIONS(517),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(521),
    [sym_global_var] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [aux_sym_metadata_ref_token1] = ACTIONS(521),
    [sym_summary_ref] = ACTIONS(521),
    [sym_string] = ACTIONS(521),
    [anon_sym_target] = ACTIONS(521),
    [anon_sym_source_filename] = ACTIONS(521),
    [anon_sym_declare] = ACTIONS(521),
    [anon_sym_define] = ACTIONS(521),
    [anon_sym_no_cfi] = ACTIONS(521),
    [anon_sym_private] = ACTIONS(521),
    [anon_sym_internal] = ACTIONS(521),
    [anon_sym_weak] = ACTIONS(523),
    [anon_sym_weak_odr] = ACTIONS(521),
    [anon_sym_linkonce] = ACTIONS(523),
    [anon_sym_linkonce_odr] = ACTIONS(521),
    [anon_sym_available_externally] = ACTIONS(521),
    [anon_sym_appending] = ACTIONS(521),
    [anon_sym_common] = ACTIONS(521),
    [anon_sym_extern_weak] = ACTIONS(521),
    [anon_sym_external] = ACTIONS(521),
    [anon_sym_dso_local] = ACTIONS(523),
    [anon_sym_dso_local_equivalent] = ACTIONS(521),
    [anon_sym_dso_preemptable] = ACTIONS(521),
    [anon_sym_default] = ACTIONS(521),
    [anon_sym_hidden] = ACTIONS(521),
    [anon_sym_protected] = ACTIONS(521),
    [anon_sym_dllimport] = ACTIONS(521),
    [anon_sym_dllexport] = ACTIONS(521),
    [anon_sym_ccc] = ACTIONS(521),
    [anon_sym_fastcc] = ACTIONS(521),
    [anon_sym_coldcc] = ACTIONS(521),
    [anon_sym_webkit_jscc] = ACTIONS(523),
    [anon_sym_anyregcc] = ACTIONS(521),
    [anon_sym_preserve_mostcc] = ACTIONS(521),
    [anon_sym_preserve_allcc] = ACTIONS(521),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(523),
    [anon_sym_tailcc] = ACTIONS(521),
    [anon_sym_swiftcc] = ACTIONS(523),
    [anon_sym_swifttailcc] = ACTIONS(523),
    [anon_sym_cfguard_checkcc] = ACTIONS(521),
    [aux_sym_calling_conv_token1] = ACTIONS(523),
    [aux_sym_calling_conv_token2] = ACTIONS(521),
    [aux_sym_calling_conv_token3] = ACTIONS(521),
    [aux_sym_calling_conv_token4] = ACTIONS(521),
    [aux_sym_calling_conv_token5] = ACTIONS(521),
    [aux_sym_calling_conv_token6] = ACTIONS(521),
    [aux_sym_calling_conv_token7] = ACTIONS(521),
    [aux_sym_calling_conv_token8] = ACTIONS(521),
    [aux_sym_calling_conv_token9] = ACTIONS(521),
    [aux_sym_calling_conv_token10] = ACTIONS(523),
    [anon_sym_ghccc] = ACTIONS(521),
    [aux_sym_calling_conv_token11] = ACTIONS(523),
    [aux_sym_calling_conv_token12] = ACTIONS(521),
    [aux_sym_calling_conv_token13] = ACTIONS(523),
    [aux_sym_calling_conv_token14] = ACTIONS(521),
    [anon_sym_cc] = ACTIONS(523),
    [anon_sym_unnamed_addr] = ACTIONS(521),
    [anon_sym_local_unnamed_addr] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(521),
    [anon_sym_half] = ACTIONS(521),
    [anon_sym_bfloat] = ACTIONS(521),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_double] = ACTIONS(521),
    [anon_sym_x86_fp80] = ACTIONS(523),
    [anon_sym_fp128] = ACTIONS(521),
    [anon_sym_ppc_fp128] = ACTIONS(521),
    [anon_sym_label] = ACTIONS(521),
    [anon_sym_metadata] = ACTIONS(521),
    [anon_sym_x86_mmx] = ACTIONS(523),
    [anon_sym_x86_amx] = ACTIONS(523),
    [anon_sym_token] = ACTIONS(521),
    [anon_sym_opaque] = ACTIONS(521),
    [anon_sym_ptr] = ACTIONS(521),
    [aux_sym_type_keyword_token1] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LT_LBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(521),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_alignstack] = ACTIONS(521),
    [anon_sym_allocsize] = ACTIONS(521),
    [anon_sym_alwaysinline] = ACTIONS(521),
    [anon_sym_builtin] = ACTIONS(521),
    [anon_sym_cold] = ACTIONS(523),
    [anon_sym_convergent] = ACTIONS(521),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(521),
    [anon_sym_hot] = ACTIONS(521),
    [anon_sym_inaccessiblememonly] = ACTIONS(521),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(521),
    [anon_sym_inlinehint] = ACTIONS(521),
    [anon_sym_jumptable] = ACTIONS(521),
    [anon_sym_minsize] = ACTIONS(521),
    [anon_sym_naked] = ACTIONS(521),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(521),
    [anon_sym_nobuiltin] = ACTIONS(521),
    [anon_sym_noduplicate] = ACTIONS(521),
    [anon_sym_nofree] = ACTIONS(521),
    [anon_sym_noimplicitfloat] = ACTIONS(521),
    [anon_sym_noinline] = ACTIONS(521),
    [anon_sym_nomerge] = ACTIONS(521),
    [anon_sym_nonlazybind] = ACTIONS(521),
    [anon_sym_noprofile] = ACTIONS(521),
    [anon_sym_noredzone] = ACTIONS(521),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(521),
    [anon_sym_noreturn] = ACTIONS(521),
    [anon_sym_norecurse] = ACTIONS(521),
    [anon_sym_willreturn] = ACTIONS(521),
    [anon_sym_nosync] = ACTIONS(521),
    [anon_sym_nounwind] = ACTIONS(521),
    [anon_sym_nosanitize_coverage] = ACTIONS(521),
    [anon_sym_null_pointer_is_valid] = ACTIONS(521),
    [anon_sym_optforfuzzing] = ACTIONS(521),
    [anon_sym_optnone] = ACTIONS(521),
    [anon_sym_optsize] = ACTIONS(521),
    [anon_sym_readnone] = ACTIONS(521),
    [anon_sym_readonly] = ACTIONS(521),
    [anon_sym_writeonly] = ACTIONS(521),
    [anon_sym_argmemonly] = ACTIONS(521),
    [anon_sym_returns_twice] = ACTIONS(521),
    [anon_sym_safestack] = ACTIONS(521),
    [anon_sym_sanitize_address] = ACTIONS(521),
    [anon_sym_sanitize_memory] = ACTIONS(521),
    [anon_sym_sanitize_thread] = ACTIONS(521),
    [anon_sym_sanitize_hwaddress] = ACTIONS(521),
    [anon_sym_sanitize_memtag] = ACTIONS(521),
    [anon_sym_speculative_load_hardening] = ACTIONS(521),
    [anon_sym_speculatable] = ACTIONS(521),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(521),
    [anon_sym_sspreq] = ACTIONS(521),
    [anon_sym_strictfp] = ACTIONS(521),
    [anon_sym_uwtable] = ACTIONS(521),
    [anon_sym_nocf_check] = ACTIONS(521),
    [anon_sym_shadowcallstack] = ACTIONS(521),
    [anon_sym_mustprogress] = ACTIONS(521),
    [anon_sym_vscale_range] = ACTIONS(521),
    [anon_sym_preallocated] = ACTIONS(521),
    [anon_sym_zeroext] = ACTIONS(521),
    [anon_sym_signext] = ACTIONS(521),
    [anon_sym_inreg] = ACTIONS(521),
    [anon_sym_byval] = ACTIONS(521),
    [anon_sym_byref] = ACTIONS(521),
    [anon_sym_inalloca] = ACTIONS(521),
    [anon_sym_sret] = ACTIONS(521),
    [anon_sym_elementtype] = ACTIONS(521),
    [anon_sym_noalias] = ACTIONS(521),
    [anon_sym_nocapture] = ACTIONS(521),
    [anon_sym_nest] = ACTIONS(521),
    [anon_sym_returned] = ACTIONS(521),
    [anon_sym_nonnull] = ACTIONS(521),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(521),
    [anon_sym_swiftself] = ACTIONS(523),
    [anon_sym_swiftasync] = ACTIONS(523),
    [anon_sym_swifterror] = ACTIONS(523),
    [anon_sym_immarg] = ACTIONS(521),
    [anon_sym_noundef] = ACTIONS(521),
    [anon_sym_to] = ACTIONS(523),
    [anon_sym_unwind] = ACTIONS(521),
    [anon_sym_unordered] = ACTIONS(521),
    [anon_sym_monotonic] = ACTIONS(521),
    [anon_sym_acquire] = ACTIONS(521),
    [anon_sym_release] = ACTIONS(521),
    [anon_sym_acq_rel] = ACTIONS(521),
    [anon_sym_seq_cst] = ACTIONS(521),
    [anon_sym_syncscope] = ACTIONS(521),
    [anon_sym_uselistorder] = ACTIONS(523),
    [anon_sym_uselistorder_bb] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_attributes] = ACTIONS(521),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(525),
    [sym_global_var] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [aux_sym_metadata_ref_token1] = ACTIONS(525),
    [sym_summary_ref] = ACTIONS(525),
    [sym_string] = ACTIONS(525),
    [anon_sym_target] = ACTIONS(525),
    [anon_sym_source_filename] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(525),
    [anon_sym_define] = ACTIONS(525),
    [anon_sym_no_cfi] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_internal] = ACTIONS(525),
    [anon_sym_weak] = ACTIONS(527),
    [anon_sym_weak_odr] = ACTIONS(525),
    [anon_sym_linkonce] = ACTIONS(527),
    [anon_sym_linkonce_odr] = ACTIONS(525),
    [anon_sym_available_externally] = ACTIONS(525),
    [anon_sym_appending] = ACTIONS(525),
    [anon_sym_common] = ACTIONS(525),
    [anon_sym_extern_weak] = ACTIONS(525),
    [anon_sym_external] = ACTIONS(525),
    [anon_sym_dso_local] = ACTIONS(527),
    [anon_sym_dso_local_equivalent] = ACTIONS(525),
    [anon_sym_dso_preemptable] = ACTIONS(525),
    [anon_sym_default] = ACTIONS(525),
    [anon_sym_hidden] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_dllimport] = ACTIONS(525),
    [anon_sym_dllexport] = ACTIONS(525),
    [anon_sym_ccc] = ACTIONS(525),
    [anon_sym_fastcc] = ACTIONS(525),
    [anon_sym_coldcc] = ACTIONS(525),
    [anon_sym_webkit_jscc] = ACTIONS(527),
    [anon_sym_anyregcc] = ACTIONS(525),
    [anon_sym_preserve_mostcc] = ACTIONS(525),
    [anon_sym_preserve_allcc] = ACTIONS(525),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(527),
    [anon_sym_tailcc] = ACTIONS(525),
    [anon_sym_swiftcc] = ACTIONS(527),
    [anon_sym_swifttailcc] = ACTIONS(527),
    [anon_sym_cfguard_checkcc] = ACTIONS(525),
    [aux_sym_calling_conv_token1] = ACTIONS(527),
    [aux_sym_calling_conv_token2] = ACTIONS(525),
    [aux_sym_calling_conv_token3] = ACTIONS(525),
    [aux_sym_calling_conv_token4] = ACTIONS(525),
    [aux_sym_calling_conv_token5] = ACTIONS(525),
    [aux_sym_calling_conv_token6] = ACTIONS(525),
    [aux_sym_calling_conv_token7] = ACTIONS(525),
    [aux_sym_calling_conv_token8] = ACTIONS(525),
    [aux_sym_calling_conv_token9] = ACTIONS(525),
    [aux_sym_calling_conv_token10] = ACTIONS(527),
    [anon_sym_ghccc] = ACTIONS(525),
    [aux_sym_calling_conv_token11] = ACTIONS(527),
    [aux_sym_calling_conv_token12] = ACTIONS(525),
    [aux_sym_calling_conv_token13] = ACTIONS(527),
    [aux_sym_calling_conv_token14] = ACTIONS(525),
    [anon_sym_cc] = ACTIONS(527),
    [anon_sym_unnamed_addr] = ACTIONS(525),
    [anon_sym_local_unnamed_addr] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_half] = ACTIONS(525),
    [anon_sym_bfloat] = ACTIONS(525),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_double] = ACTIONS(525),
    [anon_sym_x86_fp80] = ACTIONS(527),
    [anon_sym_fp128] = ACTIONS(525),
    [anon_sym_ppc_fp128] = ACTIONS(525),
    [anon_sym_label] = ACTIONS(525),
    [anon_sym_metadata] = ACTIONS(525),
    [anon_sym_x86_mmx] = ACTIONS(527),
    [anon_sym_x86_amx] = ACTIONS(527),
    [anon_sym_token] = ACTIONS(525),
    [anon_sym_opaque] = ACTIONS(525),
    [anon_sym_ptr] = ACTIONS(525),
    [aux_sym_type_keyword_token1] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LT_LBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_alignstack] = ACTIONS(525),
    [anon_sym_allocsize] = ACTIONS(525),
    [anon_sym_alwaysinline] = ACTIONS(525),
    [anon_sym_builtin] = ACTIONS(525),
    [anon_sym_cold] = ACTIONS(527),
    [anon_sym_convergent] = ACTIONS(525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(525),
    [anon_sym_hot] = ACTIONS(525),
    [anon_sym_inaccessiblememonly] = ACTIONS(525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(525),
    [anon_sym_inlinehint] = ACTIONS(525),
    [anon_sym_jumptable] = ACTIONS(525),
    [anon_sym_minsize] = ACTIONS(525),
    [anon_sym_naked] = ACTIONS(525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(525),
    [anon_sym_nobuiltin] = ACTIONS(525),
    [anon_sym_noduplicate] = ACTIONS(525),
    [anon_sym_nofree] = ACTIONS(525),
    [anon_sym_noimplicitfloat] = ACTIONS(525),
    [anon_sym_noinline] = ACTIONS(525),
    [anon_sym_nomerge] = ACTIONS(525),
    [anon_sym_nonlazybind] = ACTIONS(525),
    [anon_sym_noprofile] = ACTIONS(525),
    [anon_sym_noredzone] = ACTIONS(525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_norecurse] = ACTIONS(525),
    [anon_sym_willreturn] = ACTIONS(525),
    [anon_sym_nosync] = ACTIONS(525),
    [anon_sym_nounwind] = ACTIONS(525),
    [anon_sym_nosanitize_coverage] = ACTIONS(525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(525),
    [anon_sym_optforfuzzing] = ACTIONS(525),
    [anon_sym_optnone] = ACTIONS(525),
    [anon_sym_optsize] = ACTIONS(525),
    [anon_sym_readnone] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_writeonly] = ACTIONS(525),
    [anon_sym_argmemonly] = ACTIONS(525),
    [anon_sym_returns_twice] = ACTIONS(525),
    [anon_sym_safestack] = ACTIONS(525),
    [anon_sym_sanitize_address] = ACTIONS(525),
    [anon_sym_sanitize_memory] = ACTIONS(525),
    [anon_sym_sanitize_thread] = ACTIONS(525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(525),
    [anon_sym_sanitize_memtag] = ACTIONS(525),
    [anon_sym_speculative_load_hardening] = ACTIONS(525),
    [anon_sym_speculatable] = ACTIONS(525),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(525),
    [anon_sym_sspreq] = ACTIONS(525),
    [anon_sym_strictfp] = ACTIONS(525),
    [anon_sym_uwtable] = ACTIONS(525),
    [anon_sym_nocf_check] = ACTIONS(525),
    [anon_sym_shadowcallstack] = ACTIONS(525),
    [anon_sym_mustprogress] = ACTIONS(525),
    [anon_sym_vscale_range] = ACTIONS(525),
    [anon_sym_preallocated] = ACTIONS(525),
    [anon_sym_zeroext] = ACTIONS(525),
    [anon_sym_signext] = ACTIONS(525),
    [anon_sym_inreg] = ACTIONS(525),
    [anon_sym_byval] = ACTIONS(525),
    [anon_sym_byref] = ACTIONS(525),
    [anon_sym_inalloca] = ACTIONS(525),
    [anon_sym_sret] = ACTIONS(525),
    [anon_sym_elementtype] = ACTIONS(525),
    [anon_sym_noalias] = ACTIONS(525),
    [anon_sym_nocapture] = ACTIONS(525),
    [anon_sym_nest] = ACTIONS(525),
    [anon_sym_returned] = ACTIONS(525),
    [anon_sym_nonnull] = ACTIONS(525),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(525),
    [anon_sym_swiftself] = ACTIONS(527),
    [anon_sym_swiftasync] = ACTIONS(527),
    [anon_sym_swifterror] = ACTIONS(527),
    [anon_sym_immarg] = ACTIONS(525),
    [anon_sym_noundef] = ACTIONS(525),
    [anon_sym_to] = ACTIONS(527),
    [anon_sym_unwind] = ACTIONS(525),
    [anon_sym_unordered] = ACTIONS(525),
    [anon_sym_monotonic] = ACTIONS(525),
    [anon_sym_acquire] = ACTIONS(525),
    [anon_sym_release] = ACTIONS(525),
    [anon_sym_acq_rel] = ACTIONS(525),
    [anon_sym_seq_cst] = ACTIONS(525),
    [anon_sym_syncscope] = ACTIONS(525),
    [anon_sym_uselistorder] = ACTIONS(527),
    [anon_sym_uselistorder_bb] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_attributes] = ACTIONS(525),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(529),
    [sym_global_var] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [aux_sym_metadata_ref_token1] = ACTIONS(529),
    [sym_summary_ref] = ACTIONS(529),
    [sym_string] = ACTIONS(529),
    [anon_sym_target] = ACTIONS(529),
    [anon_sym_source_filename] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_define] = ACTIONS(529),
    [anon_sym_no_cfi] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_internal] = ACTIONS(529),
    [anon_sym_weak] = ACTIONS(531),
    [anon_sym_weak_odr] = ACTIONS(529),
    [anon_sym_linkonce] = ACTIONS(531),
    [anon_sym_linkonce_odr] = ACTIONS(529),
    [anon_sym_available_externally] = ACTIONS(529),
    [anon_sym_appending] = ACTIONS(529),
    [anon_sym_common] = ACTIONS(529),
    [anon_sym_extern_weak] = ACTIONS(529),
    [anon_sym_external] = ACTIONS(529),
    [anon_sym_dso_local] = ACTIONS(531),
    [anon_sym_dso_local_equivalent] = ACTIONS(529),
    [anon_sym_dso_preemptable] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_hidden] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_dllimport] = ACTIONS(529),
    [anon_sym_dllexport] = ACTIONS(529),
    [anon_sym_ccc] = ACTIONS(529),
    [anon_sym_fastcc] = ACTIONS(529),
    [anon_sym_coldcc] = ACTIONS(529),
    [anon_sym_webkit_jscc] = ACTIONS(531),
    [anon_sym_anyregcc] = ACTIONS(529),
    [anon_sym_preserve_mostcc] = ACTIONS(529),
    [anon_sym_preserve_allcc] = ACTIONS(529),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(531),
    [anon_sym_tailcc] = ACTIONS(529),
    [anon_sym_swiftcc] = ACTIONS(531),
    [anon_sym_swifttailcc] = ACTIONS(531),
    [anon_sym_cfguard_checkcc] = ACTIONS(529),
    [aux_sym_calling_conv_token1] = ACTIONS(531),
    [aux_sym_calling_conv_token2] = ACTIONS(529),
    [aux_sym_calling_conv_token3] = ACTIONS(529),
    [aux_sym_calling_conv_token4] = ACTIONS(529),
    [aux_sym_calling_conv_token5] = ACTIONS(529),
    [aux_sym_calling_conv_token6] = ACTIONS(529),
    [aux_sym_calling_conv_token7] = ACTIONS(529),
    [aux_sym_calling_conv_token8] = ACTIONS(529),
    [aux_sym_calling_conv_token9] = ACTIONS(529),
    [aux_sym_calling_conv_token10] = ACTIONS(531),
    [anon_sym_ghccc] = ACTIONS(529),
    [aux_sym_calling_conv_token11] = ACTIONS(531),
    [aux_sym_calling_conv_token12] = ACTIONS(529),
    [aux_sym_calling_conv_token13] = ACTIONS(531),
    [aux_sym_calling_conv_token14] = ACTIONS(529),
    [anon_sym_cc] = ACTIONS(531),
    [anon_sym_unnamed_addr] = ACTIONS(529),
    [anon_sym_local_unnamed_addr] = ACTIONS(529),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_half] = ACTIONS(529),
    [anon_sym_bfloat] = ACTIONS(529),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_double] = ACTIONS(529),
    [anon_sym_x86_fp80] = ACTIONS(531),
    [anon_sym_fp128] = ACTIONS(529),
    [anon_sym_ppc_fp128] = ACTIONS(529),
    [anon_sym_label] = ACTIONS(529),
    [anon_sym_metadata] = ACTIONS(529),
    [anon_sym_x86_mmx] = ACTIONS(531),
    [anon_sym_x86_amx] = ACTIONS(531),
    [anon_sym_token] = ACTIONS(529),
    [anon_sym_opaque] = ACTIONS(529),
    [anon_sym_ptr] = ACTIONS(529),
    [aux_sym_type_keyword_token1] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LT_LBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_alignstack] = ACTIONS(529),
    [anon_sym_allocsize] = ACTIONS(529),
    [anon_sym_alwaysinline] = ACTIONS(529),
    [anon_sym_builtin] = ACTIONS(529),
    [anon_sym_cold] = ACTIONS(531),
    [anon_sym_convergent] = ACTIONS(529),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(529),
    [anon_sym_hot] = ACTIONS(529),
    [anon_sym_inaccessiblememonly] = ACTIONS(529),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(529),
    [anon_sym_inlinehint] = ACTIONS(529),
    [anon_sym_jumptable] = ACTIONS(529),
    [anon_sym_minsize] = ACTIONS(529),
    [anon_sym_naked] = ACTIONS(529),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(529),
    [anon_sym_nobuiltin] = ACTIONS(529),
    [anon_sym_noduplicate] = ACTIONS(529),
    [anon_sym_nofree] = ACTIONS(529),
    [anon_sym_noimplicitfloat] = ACTIONS(529),
    [anon_sym_noinline] = ACTIONS(529),
    [anon_sym_nomerge] = ACTIONS(529),
    [anon_sym_nonlazybind] = ACTIONS(529),
    [anon_sym_noprofile] = ACTIONS(529),
    [anon_sym_noredzone] = ACTIONS(529),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(529),
    [anon_sym_noreturn] = ACTIONS(529),
    [anon_sym_norecurse] = ACTIONS(529),
    [anon_sym_willreturn] = ACTIONS(529),
    [anon_sym_nosync] = ACTIONS(529),
    [anon_sym_nounwind] = ACTIONS(529),
    [anon_sym_nosanitize_coverage] = ACTIONS(529),
    [anon_sym_null_pointer_is_valid] = ACTIONS(529),
    [anon_sym_optforfuzzing] = ACTIONS(529),
    [anon_sym_optnone] = ACTIONS(529),
    [anon_sym_optsize] = ACTIONS(529),
    [anon_sym_readnone] = ACTIONS(529),
    [anon_sym_readonly] = ACTIONS(529),
    [anon_sym_writeonly] = ACTIONS(529),
    [anon_sym_argmemonly] = ACTIONS(529),
    [anon_sym_returns_twice] = ACTIONS(529),
    [anon_sym_safestack] = ACTIONS(529),
    [anon_sym_sanitize_address] = ACTIONS(529),
    [anon_sym_sanitize_memory] = ACTIONS(529),
    [anon_sym_sanitize_thread] = ACTIONS(529),
    [anon_sym_sanitize_hwaddress] = ACTIONS(529),
    [anon_sym_sanitize_memtag] = ACTIONS(529),
    [anon_sym_speculative_load_hardening] = ACTIONS(529),
    [anon_sym_speculatable] = ACTIONS(529),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(529),
    [anon_sym_sspreq] = ACTIONS(529),
    [anon_sym_strictfp] = ACTIONS(529),
    [anon_sym_uwtable] = ACTIONS(529),
    [anon_sym_nocf_check] = ACTIONS(529),
    [anon_sym_shadowcallstack] = ACTIONS(529),
    [anon_sym_mustprogress] = ACTIONS(529),
    [anon_sym_vscale_range] = ACTIONS(529),
    [anon_sym_preallocated] = ACTIONS(529),
    [anon_sym_zeroext] = ACTIONS(529),
    [anon_sym_signext] = ACTIONS(529),
    [anon_sym_inreg] = ACTIONS(529),
    [anon_sym_byval] = ACTIONS(529),
    [anon_sym_byref] = ACTIONS(529),
    [anon_sym_inalloca] = ACTIONS(529),
    [anon_sym_sret] = ACTIONS(529),
    [anon_sym_elementtype] = ACTIONS(529),
    [anon_sym_noalias] = ACTIONS(529),
    [anon_sym_nocapture] = ACTIONS(529),
    [anon_sym_nest] = ACTIONS(529),
    [anon_sym_returned] = ACTIONS(529),
    [anon_sym_nonnull] = ACTIONS(529),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(529),
    [anon_sym_swiftself] = ACTIONS(531),
    [anon_sym_swiftasync] = ACTIONS(531),
    [anon_sym_swifterror] = ACTIONS(531),
    [anon_sym_immarg] = ACTIONS(529),
    [anon_sym_noundef] = ACTIONS(529),
    [anon_sym_to] = ACTIONS(531),
    [anon_sym_unwind] = ACTIONS(529),
    [anon_sym_unordered] = ACTIONS(529),
    [anon_sym_monotonic] = ACTIONS(529),
    [anon_sym_acquire] = ACTIONS(529),
    [anon_sym_release] = ACTIONS(529),
    [anon_sym_acq_rel] = ACTIONS(529),
    [anon_sym_seq_cst] = ACTIONS(529),
    [anon_sym_syncscope] = ACTIONS(529),
    [anon_sym_uselistorder] = ACTIONS(531),
    [anon_sym_uselistorder_bb] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_attributes] = ACTIONS(529),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(533),
    [sym_global_var] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [aux_sym_metadata_ref_token1] = ACTIONS(533),
    [sym_summary_ref] = ACTIONS(533),
    [sym_string] = ACTIONS(533),
    [anon_sym_target] = ACTIONS(533),
    [anon_sym_source_filename] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_define] = ACTIONS(533),
    [anon_sym_no_cfi] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_internal] = ACTIONS(533),
    [anon_sym_weak] = ACTIONS(535),
    [anon_sym_weak_odr] = ACTIONS(533),
    [anon_sym_linkonce] = ACTIONS(535),
    [anon_sym_linkonce_odr] = ACTIONS(533),
    [anon_sym_available_externally] = ACTIONS(533),
    [anon_sym_appending] = ACTIONS(533),
    [anon_sym_common] = ACTIONS(533),
    [anon_sym_extern_weak] = ACTIONS(533),
    [anon_sym_external] = ACTIONS(533),
    [anon_sym_dso_local] = ACTIONS(535),
    [anon_sym_dso_local_equivalent] = ACTIONS(533),
    [anon_sym_dso_preemptable] = ACTIONS(533),
    [anon_sym_default] = ACTIONS(533),
    [anon_sym_hidden] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_dllimport] = ACTIONS(533),
    [anon_sym_dllexport] = ACTIONS(533),
    [anon_sym_ccc] = ACTIONS(533),
    [anon_sym_fastcc] = ACTIONS(533),
    [anon_sym_coldcc] = ACTIONS(533),
    [anon_sym_webkit_jscc] = ACTIONS(535),
    [anon_sym_anyregcc] = ACTIONS(533),
    [anon_sym_preserve_mostcc] = ACTIONS(533),
    [anon_sym_preserve_allcc] = ACTIONS(533),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(535),
    [anon_sym_tailcc] = ACTIONS(533),
    [anon_sym_swiftcc] = ACTIONS(535),
    [anon_sym_swifttailcc] = ACTIONS(535),
    [anon_sym_cfguard_checkcc] = ACTIONS(533),
    [aux_sym_calling_conv_token1] = ACTIONS(535),
    [aux_sym_calling_conv_token2] = ACTIONS(533),
    [aux_sym_calling_conv_token3] = ACTIONS(533),
    [aux_sym_calling_conv_token4] = ACTIONS(533),
    [aux_sym_calling_conv_token5] = ACTIONS(533),
    [aux_sym_calling_conv_token6] = ACTIONS(533),
    [aux_sym_calling_conv_token7] = ACTIONS(533),
    [aux_sym_calling_conv_token8] = ACTIONS(533),
    [aux_sym_calling_conv_token9] = ACTIONS(533),
    [aux_sym_calling_conv_token10] = ACTIONS(535),
    [anon_sym_ghccc] = ACTIONS(533),
    [aux_sym_calling_conv_token11] = ACTIONS(535),
    [aux_sym_calling_conv_token12] = ACTIONS(533),
    [aux_sym_calling_conv_token13] = ACTIONS(535),
    [aux_sym_calling_conv_token14] = ACTIONS(533),
    [anon_sym_cc] = ACTIONS(535),
    [anon_sym_unnamed_addr] = ACTIONS(533),
    [anon_sym_local_unnamed_addr] = ACTIONS(533),
    [anon_sym_void] = ACTIONS(533),
    [anon_sym_half] = ACTIONS(533),
    [anon_sym_bfloat] = ACTIONS(533),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_double] = ACTIONS(533),
    [anon_sym_x86_fp80] = ACTIONS(535),
    [anon_sym_fp128] = ACTIONS(533),
    [anon_sym_ppc_fp128] = ACTIONS(533),
    [anon_sym_label] = ACTIONS(533),
    [anon_sym_metadata] = ACTIONS(533),
    [anon_sym_x86_mmx] = ACTIONS(535),
    [anon_sym_x86_amx] = ACTIONS(535),
    [anon_sym_token] = ACTIONS(533),
    [anon_sym_opaque] = ACTIONS(533),
    [anon_sym_ptr] = ACTIONS(533),
    [aux_sym_type_keyword_token1] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LT_LBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_RBRACK] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_alignstack] = ACTIONS(533),
    [anon_sym_allocsize] = ACTIONS(533),
    [anon_sym_alwaysinline] = ACTIONS(533),
    [anon_sym_builtin] = ACTIONS(533),
    [anon_sym_cold] = ACTIONS(535),
    [anon_sym_convergent] = ACTIONS(533),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(533),
    [anon_sym_hot] = ACTIONS(533),
    [anon_sym_inaccessiblememonly] = ACTIONS(533),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(533),
    [anon_sym_inlinehint] = ACTIONS(533),
    [anon_sym_jumptable] = ACTIONS(533),
    [anon_sym_minsize] = ACTIONS(533),
    [anon_sym_naked] = ACTIONS(533),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(533),
    [anon_sym_nobuiltin] = ACTIONS(533),
    [anon_sym_noduplicate] = ACTIONS(533),
    [anon_sym_nofree] = ACTIONS(533),
    [anon_sym_noimplicitfloat] = ACTIONS(533),
    [anon_sym_noinline] = ACTIONS(533),
    [anon_sym_nomerge] = ACTIONS(533),
    [anon_sym_nonlazybind] = ACTIONS(533),
    [anon_sym_noprofile] = ACTIONS(533),
    [anon_sym_noredzone] = ACTIONS(533),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(533),
    [anon_sym_noreturn] = ACTIONS(533),
    [anon_sym_norecurse] = ACTIONS(533),
    [anon_sym_willreturn] = ACTIONS(533),
    [anon_sym_nosync] = ACTIONS(533),
    [anon_sym_nounwind] = ACTIONS(533),
    [anon_sym_nosanitize_coverage] = ACTIONS(533),
    [anon_sym_null_pointer_is_valid] = ACTIONS(533),
    [anon_sym_optforfuzzing] = ACTIONS(533),
    [anon_sym_optnone] = ACTIONS(533),
    [anon_sym_optsize] = ACTIONS(533),
    [anon_sym_readnone] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_writeonly] = ACTIONS(533),
    [anon_sym_argmemonly] = ACTIONS(533),
    [anon_sym_returns_twice] = ACTIONS(533),
    [anon_sym_safestack] = ACTIONS(533),
    [anon_sym_sanitize_address] = ACTIONS(533),
    [anon_sym_sanitize_memory] = ACTIONS(533),
    [anon_sym_sanitize_thread] = ACTIONS(533),
    [anon_sym_sanitize_hwaddress] = ACTIONS(533),
    [anon_sym_sanitize_memtag] = ACTIONS(533),
    [anon_sym_speculative_load_hardening] = ACTIONS(533),
    [anon_sym_speculatable] = ACTIONS(533),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(533),
    [anon_sym_sspreq] = ACTIONS(533),
    [anon_sym_strictfp] = ACTIONS(533),
    [anon_sym_uwtable] = ACTIONS(533),
    [anon_sym_nocf_check] = ACTIONS(533),
    [anon_sym_shadowcallstack] = ACTIONS(533),
    [anon_sym_mustprogress] = ACTIONS(533),
    [anon_sym_vscale_range] = ACTIONS(533),
    [anon_sym_preallocated] = ACTIONS(533),
    [anon_sym_zeroext] = ACTIONS(533),
    [anon_sym_signext] = ACTIONS(533),
    [anon_sym_inreg] = ACTIONS(533),
    [anon_sym_byval] = ACTIONS(533),
    [anon_sym_byref] = ACTIONS(533),
    [anon_sym_inalloca] = ACTIONS(533),
    [anon_sym_sret] = ACTIONS(533),
    [anon_sym_elementtype] = ACTIONS(533),
    [anon_sym_noalias] = ACTIONS(533),
    [anon_sym_nocapture] = ACTIONS(533),
    [anon_sym_nest] = ACTIONS(533),
    [anon_sym_returned] = ACTIONS(533),
    [anon_sym_nonnull] = ACTIONS(533),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(533),
    [anon_sym_swiftself] = ACTIONS(535),
    [anon_sym_swiftasync] = ACTIONS(535),
    [anon_sym_swifterror] = ACTIONS(535),
    [anon_sym_immarg] = ACTIONS(533),
    [anon_sym_noundef] = ACTIONS(533),
    [anon_sym_to] = ACTIONS(535),
    [anon_sym_unwind] = ACTIONS(533),
    [anon_sym_unordered] = ACTIONS(533),
    [anon_sym_monotonic] = ACTIONS(533),
    [anon_sym_acquire] = ACTIONS(533),
    [anon_sym_release] = ACTIONS(533),
    [anon_sym_acq_rel] = ACTIONS(533),
    [anon_sym_seq_cst] = ACTIONS(533),
    [anon_sym_syncscope] = ACTIONS(533),
    [anon_sym_uselistorder] = ACTIONS(535),
    [anon_sym_uselistorder_bb] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_attributes] = ACTIONS(533),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(537),
    [sym_global_var] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [aux_sym_metadata_ref_token1] = ACTIONS(537),
    [sym_summary_ref] = ACTIONS(537),
    [sym_string] = ACTIONS(537),
    [anon_sym_target] = ACTIONS(537),
    [anon_sym_source_filename] = ACTIONS(537),
    [anon_sym_declare] = ACTIONS(537),
    [anon_sym_define] = ACTIONS(537),
    [anon_sym_no_cfi] = ACTIONS(537),
    [anon_sym_private] = ACTIONS(537),
    [anon_sym_internal] = ACTIONS(537),
    [anon_sym_weak] = ACTIONS(539),
    [anon_sym_weak_odr] = ACTIONS(537),
    [anon_sym_linkonce] = ACTIONS(539),
    [anon_sym_linkonce_odr] = ACTIONS(537),
    [anon_sym_available_externally] = ACTIONS(537),
    [anon_sym_appending] = ACTIONS(537),
    [anon_sym_common] = ACTIONS(537),
    [anon_sym_extern_weak] = ACTIONS(537),
    [anon_sym_external] = ACTIONS(537),
    [anon_sym_dso_local] = ACTIONS(539),
    [anon_sym_dso_local_equivalent] = ACTIONS(537),
    [anon_sym_dso_preemptable] = ACTIONS(537),
    [anon_sym_default] = ACTIONS(537),
    [anon_sym_hidden] = ACTIONS(537),
    [anon_sym_protected] = ACTIONS(537),
    [anon_sym_dllimport] = ACTIONS(537),
    [anon_sym_dllexport] = ACTIONS(537),
    [anon_sym_ccc] = ACTIONS(537),
    [anon_sym_fastcc] = ACTIONS(537),
    [anon_sym_coldcc] = ACTIONS(537),
    [anon_sym_webkit_jscc] = ACTIONS(539),
    [anon_sym_anyregcc] = ACTIONS(537),
    [anon_sym_preserve_mostcc] = ACTIONS(537),
    [anon_sym_preserve_allcc] = ACTIONS(537),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(539),
    [anon_sym_tailcc] = ACTIONS(537),
    [anon_sym_swiftcc] = ACTIONS(539),
    [anon_sym_swifttailcc] = ACTIONS(539),
    [anon_sym_cfguard_checkcc] = ACTIONS(537),
    [aux_sym_calling_conv_token1] = ACTIONS(539),
    [aux_sym_calling_conv_token2] = ACTIONS(537),
    [aux_sym_calling_conv_token3] = ACTIONS(537),
    [aux_sym_calling_conv_token4] = ACTIONS(537),
    [aux_sym_calling_conv_token5] = ACTIONS(537),
    [aux_sym_calling_conv_token6] = ACTIONS(537),
    [aux_sym_calling_conv_token7] = ACTIONS(537),
    [aux_sym_calling_conv_token8] = ACTIONS(537),
    [aux_sym_calling_conv_token9] = ACTIONS(537),
    [aux_sym_calling_conv_token10] = ACTIONS(539),
    [anon_sym_ghccc] = ACTIONS(537),
    [aux_sym_calling_conv_token11] = ACTIONS(539),
    [aux_sym_calling_conv_token12] = ACTIONS(537),
    [aux_sym_calling_conv_token13] = ACTIONS(539),
    [aux_sym_calling_conv_token14] = ACTIONS(537),
    [anon_sym_cc] = ACTIONS(539),
    [anon_sym_unnamed_addr] = ACTIONS(537),
    [anon_sym_local_unnamed_addr] = ACTIONS(537),
    [anon_sym_void] = ACTIONS(537),
    [anon_sym_half] = ACTIONS(537),
    [anon_sym_bfloat] = ACTIONS(537),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_double] = ACTIONS(537),
    [anon_sym_x86_fp80] = ACTIONS(539),
    [anon_sym_fp128] = ACTIONS(537),
    [anon_sym_ppc_fp128] = ACTIONS(537),
    [anon_sym_label] = ACTIONS(537),
    [anon_sym_metadata] = ACTIONS(537),
    [anon_sym_x86_mmx] = ACTIONS(539),
    [anon_sym_x86_amx] = ACTIONS(539),
    [anon_sym_token] = ACTIONS(537),
    [anon_sym_opaque] = ACTIONS(537),
    [anon_sym_ptr] = ACTIONS(537),
    [aux_sym_type_keyword_token1] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LT_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_RBRACK] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(537),
    [anon_sym_RPAREN] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_alignstack] = ACTIONS(537),
    [anon_sym_allocsize] = ACTIONS(537),
    [anon_sym_alwaysinline] = ACTIONS(537),
    [anon_sym_builtin] = ACTIONS(537),
    [anon_sym_cold] = ACTIONS(539),
    [anon_sym_convergent] = ACTIONS(537),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(537),
    [anon_sym_hot] = ACTIONS(537),
    [anon_sym_inaccessiblememonly] = ACTIONS(537),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(537),
    [anon_sym_inlinehint] = ACTIONS(537),
    [anon_sym_jumptable] = ACTIONS(537),
    [anon_sym_minsize] = ACTIONS(537),
    [anon_sym_naked] = ACTIONS(537),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(537),
    [anon_sym_nobuiltin] = ACTIONS(537),
    [anon_sym_noduplicate] = ACTIONS(537),
    [anon_sym_nofree] = ACTIONS(537),
    [anon_sym_noimplicitfloat] = ACTIONS(537),
    [anon_sym_noinline] = ACTIONS(537),
    [anon_sym_nomerge] = ACTIONS(537),
    [anon_sym_nonlazybind] = ACTIONS(537),
    [anon_sym_noprofile] = ACTIONS(537),
    [anon_sym_noredzone] = ACTIONS(537),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(537),
    [anon_sym_noreturn] = ACTIONS(537),
    [anon_sym_norecurse] = ACTIONS(537),
    [anon_sym_willreturn] = ACTIONS(537),
    [anon_sym_nosync] = ACTIONS(537),
    [anon_sym_nounwind] = ACTIONS(537),
    [anon_sym_nosanitize_coverage] = ACTIONS(537),
    [anon_sym_null_pointer_is_valid] = ACTIONS(537),
    [anon_sym_optforfuzzing] = ACTIONS(537),
    [anon_sym_optnone] = ACTIONS(537),
    [anon_sym_optsize] = ACTIONS(537),
    [anon_sym_readnone] = ACTIONS(537),
    [anon_sym_readonly] = ACTIONS(537),
    [anon_sym_writeonly] = ACTIONS(537),
    [anon_sym_argmemonly] = ACTIONS(537),
    [anon_sym_returns_twice] = ACTIONS(537),
    [anon_sym_safestack] = ACTIONS(537),
    [anon_sym_sanitize_address] = ACTIONS(537),
    [anon_sym_sanitize_memory] = ACTIONS(537),
    [anon_sym_sanitize_thread] = ACTIONS(537),
    [anon_sym_sanitize_hwaddress] = ACTIONS(537),
    [anon_sym_sanitize_memtag] = ACTIONS(537),
    [anon_sym_speculative_load_hardening] = ACTIONS(537),
    [anon_sym_speculatable] = ACTIONS(537),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(537),
    [anon_sym_sspreq] = ACTIONS(537),
    [anon_sym_strictfp] = ACTIONS(537),
    [anon_sym_uwtable] = ACTIONS(537),
    [anon_sym_nocf_check] = ACTIONS(537),
    [anon_sym_shadowcallstack] = ACTIONS(537),
    [anon_sym_mustprogress] = ACTIONS(537),
    [anon_sym_vscale_range] = ACTIONS(537),
    [anon_sym_preallocated] = ACTIONS(537),
    [anon_sym_zeroext] = ACTIONS(537),
    [anon_sym_signext] = ACTIONS(537),
    [anon_sym_inreg] = ACTIONS(537),
    [anon_sym_byval] = ACTIONS(537),
    [anon_sym_byref] = ACTIONS(537),
    [anon_sym_inalloca] = ACTIONS(537),
    [anon_sym_sret] = ACTIONS(537),
    [anon_sym_elementtype] = ACTIONS(537),
    [anon_sym_noalias] = ACTIONS(537),
    [anon_sym_nocapture] = ACTIONS(537),
    [anon_sym_nest] = ACTIONS(537),
    [anon_sym_returned] = ACTIONS(537),
    [anon_sym_nonnull] = ACTIONS(537),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(537),
    [anon_sym_swiftself] = ACTIONS(539),
    [anon_sym_swiftasync] = ACTIONS(539),
    [anon_sym_swifterror] = ACTIONS(539),
    [anon_sym_immarg] = ACTIONS(537),
    [anon_sym_noundef] = ACTIONS(537),
    [anon_sym_to] = ACTIONS(539),
    [anon_sym_unwind] = ACTIONS(537),
    [anon_sym_unordered] = ACTIONS(537),
    [anon_sym_monotonic] = ACTIONS(537),
    [anon_sym_acquire] = ACTIONS(537),
    [anon_sym_release] = ACTIONS(537),
    [anon_sym_acq_rel] = ACTIONS(537),
    [anon_sym_seq_cst] = ACTIONS(537),
    [anon_sym_syncscope] = ACTIONS(537),
    [anon_sym_uselistorder] = ACTIONS(539),
    [anon_sym_uselistorder_bb] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_attributes] = ACTIONS(537),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(541),
    [sym_global_var] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [aux_sym_metadata_ref_token1] = ACTIONS(541),
    [sym_summary_ref] = ACTIONS(541),
    [sym_string] = ACTIONS(541),
    [anon_sym_target] = ACTIONS(541),
    [anon_sym_source_filename] = ACTIONS(541),
    [anon_sym_declare] = ACTIONS(541),
    [anon_sym_define] = ACTIONS(541),
    [anon_sym_no_cfi] = ACTIONS(541),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_internal] = ACTIONS(541),
    [anon_sym_weak] = ACTIONS(543),
    [anon_sym_weak_odr] = ACTIONS(541),
    [anon_sym_linkonce] = ACTIONS(543),
    [anon_sym_linkonce_odr] = ACTIONS(541),
    [anon_sym_available_externally] = ACTIONS(541),
    [anon_sym_appending] = ACTIONS(541),
    [anon_sym_common] = ACTIONS(541),
    [anon_sym_extern_weak] = ACTIONS(541),
    [anon_sym_external] = ACTIONS(541),
    [anon_sym_dso_local] = ACTIONS(543),
    [anon_sym_dso_local_equivalent] = ACTIONS(541),
    [anon_sym_dso_preemptable] = ACTIONS(541),
    [anon_sym_default] = ACTIONS(541),
    [anon_sym_hidden] = ACTIONS(541),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_dllimport] = ACTIONS(541),
    [anon_sym_dllexport] = ACTIONS(541),
    [anon_sym_ccc] = ACTIONS(541),
    [anon_sym_fastcc] = ACTIONS(541),
    [anon_sym_coldcc] = ACTIONS(541),
    [anon_sym_webkit_jscc] = ACTIONS(543),
    [anon_sym_anyregcc] = ACTIONS(541),
    [anon_sym_preserve_mostcc] = ACTIONS(541),
    [anon_sym_preserve_allcc] = ACTIONS(541),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(543),
    [anon_sym_tailcc] = ACTIONS(541),
    [anon_sym_swiftcc] = ACTIONS(543),
    [anon_sym_swifttailcc] = ACTIONS(543),
    [anon_sym_cfguard_checkcc] = ACTIONS(541),
    [aux_sym_calling_conv_token1] = ACTIONS(543),
    [aux_sym_calling_conv_token2] = ACTIONS(541),
    [aux_sym_calling_conv_token3] = ACTIONS(541),
    [aux_sym_calling_conv_token4] = ACTIONS(541),
    [aux_sym_calling_conv_token5] = ACTIONS(541),
    [aux_sym_calling_conv_token6] = ACTIONS(541),
    [aux_sym_calling_conv_token7] = ACTIONS(541),
    [aux_sym_calling_conv_token8] = ACTIONS(541),
    [aux_sym_calling_conv_token9] = ACTIONS(541),
    [aux_sym_calling_conv_token10] = ACTIONS(543),
    [anon_sym_ghccc] = ACTIONS(541),
    [aux_sym_calling_conv_token11] = ACTIONS(543),
    [aux_sym_calling_conv_token12] = ACTIONS(541),
    [aux_sym_calling_conv_token13] = ACTIONS(543),
    [aux_sym_calling_conv_token14] = ACTIONS(541),
    [anon_sym_cc] = ACTIONS(543),
    [anon_sym_unnamed_addr] = ACTIONS(541),
    [anon_sym_local_unnamed_addr] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_half] = ACTIONS(541),
    [anon_sym_bfloat] = ACTIONS(541),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_double] = ACTIONS(541),
    [anon_sym_x86_fp80] = ACTIONS(543),
    [anon_sym_fp128] = ACTIONS(541),
    [anon_sym_ppc_fp128] = ACTIONS(541),
    [anon_sym_label] = ACTIONS(541),
    [anon_sym_metadata] = ACTIONS(541),
    [anon_sym_x86_mmx] = ACTIONS(543),
    [anon_sym_x86_amx] = ACTIONS(543),
    [anon_sym_token] = ACTIONS(541),
    [anon_sym_opaque] = ACTIONS(541),
    [anon_sym_ptr] = ACTIONS(541),
    [aux_sym_type_keyword_token1] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LT_LBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_alignstack] = ACTIONS(541),
    [anon_sym_allocsize] = ACTIONS(541),
    [anon_sym_alwaysinline] = ACTIONS(541),
    [anon_sym_builtin] = ACTIONS(541),
    [anon_sym_cold] = ACTIONS(543),
    [anon_sym_convergent] = ACTIONS(541),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(541),
    [anon_sym_hot] = ACTIONS(541),
    [anon_sym_inaccessiblememonly] = ACTIONS(541),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(541),
    [anon_sym_inlinehint] = ACTIONS(541),
    [anon_sym_jumptable] = ACTIONS(541),
    [anon_sym_minsize] = ACTIONS(541),
    [anon_sym_naked] = ACTIONS(541),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(541),
    [anon_sym_nobuiltin] = ACTIONS(541),
    [anon_sym_noduplicate] = ACTIONS(541),
    [anon_sym_nofree] = ACTIONS(541),
    [anon_sym_noimplicitfloat] = ACTIONS(541),
    [anon_sym_noinline] = ACTIONS(541),
    [anon_sym_nomerge] = ACTIONS(541),
    [anon_sym_nonlazybind] = ACTIONS(541),
    [anon_sym_noprofile] = ACTIONS(541),
    [anon_sym_noredzone] = ACTIONS(541),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(541),
    [anon_sym_noreturn] = ACTIONS(541),
    [anon_sym_norecurse] = ACTIONS(541),
    [anon_sym_willreturn] = ACTIONS(541),
    [anon_sym_nosync] = ACTIONS(541),
    [anon_sym_nounwind] = ACTIONS(541),
    [anon_sym_nosanitize_coverage] = ACTIONS(541),
    [anon_sym_null_pointer_is_valid] = ACTIONS(541),
    [anon_sym_optforfuzzing] = ACTIONS(541),
    [anon_sym_optnone] = ACTIONS(541),
    [anon_sym_optsize] = ACTIONS(541),
    [anon_sym_readnone] = ACTIONS(541),
    [anon_sym_readonly] = ACTIONS(541),
    [anon_sym_writeonly] = ACTIONS(541),
    [anon_sym_argmemonly] = ACTIONS(541),
    [anon_sym_returns_twice] = ACTIONS(541),
    [anon_sym_safestack] = ACTIONS(541),
    [anon_sym_sanitize_address] = ACTIONS(541),
    [anon_sym_sanitize_memory] = ACTIONS(541),
    [anon_sym_sanitize_thread] = ACTIONS(541),
    [anon_sym_sanitize_hwaddress] = ACTIONS(541),
    [anon_sym_sanitize_memtag] = ACTIONS(541),
    [anon_sym_speculative_load_hardening] = ACTIONS(541),
    [anon_sym_speculatable] = ACTIONS(541),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(541),
    [anon_sym_sspreq] = ACTIONS(541),
    [anon_sym_strictfp] = ACTIONS(541),
    [anon_sym_uwtable] = ACTIONS(541),
    [anon_sym_nocf_check] = ACTIONS(541),
    [anon_sym_shadowcallstack] = ACTIONS(541),
    [anon_sym_mustprogress] = ACTIONS(541),
    [anon_sym_vscale_range] = ACTIONS(541),
    [anon_sym_preallocated] = ACTIONS(541),
    [anon_sym_zeroext] = ACTIONS(541),
    [anon_sym_signext] = ACTIONS(541),
    [anon_sym_inreg] = ACTIONS(541),
    [anon_sym_byval] = ACTIONS(541),
    [anon_sym_byref] = ACTIONS(541),
    [anon_sym_inalloca] = ACTIONS(541),
    [anon_sym_sret] = ACTIONS(541),
    [anon_sym_elementtype] = ACTIONS(541),
    [anon_sym_noalias] = ACTIONS(541),
    [anon_sym_nocapture] = ACTIONS(541),
    [anon_sym_nest] = ACTIONS(541),
    [anon_sym_returned] = ACTIONS(541),
    [anon_sym_nonnull] = ACTIONS(541),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(541),
    [anon_sym_swiftself] = ACTIONS(543),
    [anon_sym_swiftasync] = ACTIONS(543),
    [anon_sym_swifterror] = ACTIONS(543),
    [anon_sym_immarg] = ACTIONS(541),
    [anon_sym_noundef] = ACTIONS(541),
    [anon_sym_to] = ACTIONS(543),
    [anon_sym_unwind] = ACTIONS(541),
    [anon_sym_unordered] = ACTIONS(541),
    [anon_sym_monotonic] = ACTIONS(541),
    [anon_sym_acquire] = ACTIONS(541),
    [anon_sym_release] = ACTIONS(541),
    [anon_sym_acq_rel] = ACTIONS(541),
    [anon_sym_seq_cst] = ACTIONS(541),
    [anon_sym_syncscope] = ACTIONS(541),
    [anon_sym_uselistorder] = ACTIONS(543),
    [anon_sym_uselistorder_bb] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_attributes] = ACTIONS(541),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(545),
    [sym_global_var] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [aux_sym_metadata_ref_token1] = ACTIONS(545),
    [sym_summary_ref] = ACTIONS(545),
    [sym_string] = ACTIONS(545),
    [anon_sym_target] = ACTIONS(545),
    [anon_sym_source_filename] = ACTIONS(545),
    [anon_sym_declare] = ACTIONS(545),
    [anon_sym_define] = ACTIONS(545),
    [anon_sym_no_cfi] = ACTIONS(545),
    [anon_sym_private] = ACTIONS(545),
    [anon_sym_internal] = ACTIONS(545),
    [anon_sym_weak] = ACTIONS(547),
    [anon_sym_weak_odr] = ACTIONS(545),
    [anon_sym_linkonce] = ACTIONS(547),
    [anon_sym_linkonce_odr] = ACTIONS(545),
    [anon_sym_available_externally] = ACTIONS(545),
    [anon_sym_appending] = ACTIONS(545),
    [anon_sym_common] = ACTIONS(545),
    [anon_sym_extern_weak] = ACTIONS(545),
    [anon_sym_external] = ACTIONS(545),
    [anon_sym_dso_local] = ACTIONS(547),
    [anon_sym_dso_local_equivalent] = ACTIONS(545),
    [anon_sym_dso_preemptable] = ACTIONS(545),
    [anon_sym_default] = ACTIONS(545),
    [anon_sym_hidden] = ACTIONS(545),
    [anon_sym_protected] = ACTIONS(545),
    [anon_sym_dllimport] = ACTIONS(545),
    [anon_sym_dllexport] = ACTIONS(545),
    [anon_sym_ccc] = ACTIONS(545),
    [anon_sym_fastcc] = ACTIONS(545),
    [anon_sym_coldcc] = ACTIONS(545),
    [anon_sym_webkit_jscc] = ACTIONS(547),
    [anon_sym_anyregcc] = ACTIONS(545),
    [anon_sym_preserve_mostcc] = ACTIONS(545),
    [anon_sym_preserve_allcc] = ACTIONS(545),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(547),
    [anon_sym_tailcc] = ACTIONS(545),
    [anon_sym_swiftcc] = ACTIONS(547),
    [anon_sym_swifttailcc] = ACTIONS(547),
    [anon_sym_cfguard_checkcc] = ACTIONS(545),
    [aux_sym_calling_conv_token1] = ACTIONS(547),
    [aux_sym_calling_conv_token2] = ACTIONS(545),
    [aux_sym_calling_conv_token3] = ACTIONS(545),
    [aux_sym_calling_conv_token4] = ACTIONS(545),
    [aux_sym_calling_conv_token5] = ACTIONS(545),
    [aux_sym_calling_conv_token6] = ACTIONS(545),
    [aux_sym_calling_conv_token7] = ACTIONS(545),
    [aux_sym_calling_conv_token8] = ACTIONS(545),
    [aux_sym_calling_conv_token9] = ACTIONS(545),
    [aux_sym_calling_conv_token10] = ACTIONS(547),
    [anon_sym_ghccc] = ACTIONS(545),
    [aux_sym_calling_conv_token11] = ACTIONS(547),
    [aux_sym_calling_conv_token12] = ACTIONS(545),
    [aux_sym_calling_conv_token13] = ACTIONS(547),
    [aux_sym_calling_conv_token14] = ACTIONS(545),
    [anon_sym_cc] = ACTIONS(547),
    [anon_sym_unnamed_addr] = ACTIONS(545),
    [anon_sym_local_unnamed_addr] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(545),
    [anon_sym_half] = ACTIONS(545),
    [anon_sym_bfloat] = ACTIONS(545),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_double] = ACTIONS(545),
    [anon_sym_x86_fp80] = ACTIONS(547),
    [anon_sym_fp128] = ACTIONS(545),
    [anon_sym_ppc_fp128] = ACTIONS(545),
    [anon_sym_label] = ACTIONS(545),
    [anon_sym_metadata] = ACTIONS(545),
    [anon_sym_x86_mmx] = ACTIONS(547),
    [anon_sym_x86_amx] = ACTIONS(547),
    [anon_sym_token] = ACTIONS(545),
    [anon_sym_opaque] = ACTIONS(545),
    [anon_sym_ptr] = ACTIONS(545),
    [aux_sym_type_keyword_token1] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LT_LBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(545),
    [anon_sym_RPAREN] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_alignstack] = ACTIONS(545),
    [anon_sym_allocsize] = ACTIONS(545),
    [anon_sym_alwaysinline] = ACTIONS(545),
    [anon_sym_builtin] = ACTIONS(545),
    [anon_sym_cold] = ACTIONS(547),
    [anon_sym_convergent] = ACTIONS(545),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(545),
    [anon_sym_hot] = ACTIONS(545),
    [anon_sym_inaccessiblememonly] = ACTIONS(545),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(545),
    [anon_sym_inlinehint] = ACTIONS(545),
    [anon_sym_jumptable] = ACTIONS(545),
    [anon_sym_minsize] = ACTIONS(545),
    [anon_sym_naked] = ACTIONS(545),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(545),
    [anon_sym_nobuiltin] = ACTIONS(545),
    [anon_sym_noduplicate] = ACTIONS(545),
    [anon_sym_nofree] = ACTIONS(545),
    [anon_sym_noimplicitfloat] = ACTIONS(545),
    [anon_sym_noinline] = ACTIONS(545),
    [anon_sym_nomerge] = ACTIONS(545),
    [anon_sym_nonlazybind] = ACTIONS(545),
    [anon_sym_noprofile] = ACTIONS(545),
    [anon_sym_noredzone] = ACTIONS(545),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(545),
    [anon_sym_noreturn] = ACTIONS(545),
    [anon_sym_norecurse] = ACTIONS(545),
    [anon_sym_willreturn] = ACTIONS(545),
    [anon_sym_nosync] = ACTIONS(545),
    [anon_sym_nounwind] = ACTIONS(545),
    [anon_sym_nosanitize_coverage] = ACTIONS(545),
    [anon_sym_null_pointer_is_valid] = ACTIONS(545),
    [anon_sym_optforfuzzing] = ACTIONS(545),
    [anon_sym_optnone] = ACTIONS(545),
    [anon_sym_optsize] = ACTIONS(545),
    [anon_sym_readnone] = ACTIONS(545),
    [anon_sym_readonly] = ACTIONS(545),
    [anon_sym_writeonly] = ACTIONS(545),
    [anon_sym_argmemonly] = ACTIONS(545),
    [anon_sym_returns_twice] = ACTIONS(545),
    [anon_sym_safestack] = ACTIONS(545),
    [anon_sym_sanitize_address] = ACTIONS(545),
    [anon_sym_sanitize_memory] = ACTIONS(545),
    [anon_sym_sanitize_thread] = ACTIONS(545),
    [anon_sym_sanitize_hwaddress] = ACTIONS(545),
    [anon_sym_sanitize_memtag] = ACTIONS(545),
    [anon_sym_speculative_load_hardening] = ACTIONS(545),
    [anon_sym_speculatable] = ACTIONS(545),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(545),
    [anon_sym_sspreq] = ACTIONS(545),
    [anon_sym_strictfp] = ACTIONS(545),
    [anon_sym_uwtable] = ACTIONS(545),
    [anon_sym_nocf_check] = ACTIONS(545),
    [anon_sym_shadowcallstack] = ACTIONS(545),
    [anon_sym_mustprogress] = ACTIONS(545),
    [anon_sym_vscale_range] = ACTIONS(545),
    [anon_sym_preallocated] = ACTIONS(545),
    [anon_sym_zeroext] = ACTIONS(545),
    [anon_sym_signext] = ACTIONS(545),
    [anon_sym_inreg] = ACTIONS(545),
    [anon_sym_byval] = ACTIONS(545),
    [anon_sym_byref] = ACTIONS(545),
    [anon_sym_inalloca] = ACTIONS(545),
    [anon_sym_sret] = ACTIONS(545),
    [anon_sym_elementtype] = ACTIONS(545),
    [anon_sym_noalias] = ACTIONS(545),
    [anon_sym_nocapture] = ACTIONS(545),
    [anon_sym_nest] = ACTIONS(545),
    [anon_sym_returned] = ACTIONS(545),
    [anon_sym_nonnull] = ACTIONS(545),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(545),
    [anon_sym_swiftself] = ACTIONS(547),
    [anon_sym_swiftasync] = ACTIONS(547),
    [anon_sym_swifterror] = ACTIONS(547),
    [anon_sym_immarg] = ACTIONS(545),
    [anon_sym_noundef] = ACTIONS(545),
    [anon_sym_to] = ACTIONS(547),
    [anon_sym_unwind] = ACTIONS(545),
    [anon_sym_unordered] = ACTIONS(545),
    [anon_sym_monotonic] = ACTIONS(545),
    [anon_sym_acquire] = ACTIONS(545),
    [anon_sym_release] = ACTIONS(545),
    [anon_sym_acq_rel] = ACTIONS(545),
    [anon_sym_seq_cst] = ACTIONS(545),
    [anon_sym_syncscope] = ACTIONS(545),
    [anon_sym_uselistorder] = ACTIONS(547),
    [anon_sym_uselistorder_bb] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_attributes] = ACTIONS(545),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(549),
    [sym_global_var] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [aux_sym_metadata_ref_token1] = ACTIONS(549),
    [sym_summary_ref] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [anon_sym_target] = ACTIONS(549),
    [anon_sym_source_filename] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(549),
    [anon_sym_define] = ACTIONS(549),
    [anon_sym_no_cfi] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_internal] = ACTIONS(549),
    [anon_sym_weak] = ACTIONS(551),
    [anon_sym_weak_odr] = ACTIONS(549),
    [anon_sym_linkonce] = ACTIONS(551),
    [anon_sym_linkonce_odr] = ACTIONS(549),
    [anon_sym_available_externally] = ACTIONS(549),
    [anon_sym_appending] = ACTIONS(549),
    [anon_sym_common] = ACTIONS(549),
    [anon_sym_extern_weak] = ACTIONS(549),
    [anon_sym_external] = ACTIONS(549),
    [anon_sym_dso_local] = ACTIONS(551),
    [anon_sym_dso_local_equivalent] = ACTIONS(549),
    [anon_sym_dso_preemptable] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(549),
    [anon_sym_hidden] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_dllimport] = ACTIONS(549),
    [anon_sym_dllexport] = ACTIONS(549),
    [anon_sym_ccc] = ACTIONS(549),
    [anon_sym_fastcc] = ACTIONS(549),
    [anon_sym_coldcc] = ACTIONS(549),
    [anon_sym_webkit_jscc] = ACTIONS(551),
    [anon_sym_anyregcc] = ACTIONS(549),
    [anon_sym_preserve_mostcc] = ACTIONS(549),
    [anon_sym_preserve_allcc] = ACTIONS(549),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(551),
    [anon_sym_tailcc] = ACTIONS(549),
    [anon_sym_swiftcc] = ACTIONS(551),
    [anon_sym_swifttailcc] = ACTIONS(551),
    [anon_sym_cfguard_checkcc] = ACTIONS(549),
    [aux_sym_calling_conv_token1] = ACTIONS(551),
    [aux_sym_calling_conv_token2] = ACTIONS(549),
    [aux_sym_calling_conv_token3] = ACTIONS(549),
    [aux_sym_calling_conv_token4] = ACTIONS(549),
    [aux_sym_calling_conv_token5] = ACTIONS(549),
    [aux_sym_calling_conv_token6] = ACTIONS(549),
    [aux_sym_calling_conv_token7] = ACTIONS(549),
    [aux_sym_calling_conv_token8] = ACTIONS(549),
    [aux_sym_calling_conv_token9] = ACTIONS(549),
    [aux_sym_calling_conv_token10] = ACTIONS(551),
    [anon_sym_ghccc] = ACTIONS(549),
    [aux_sym_calling_conv_token11] = ACTIONS(551),
    [aux_sym_calling_conv_token12] = ACTIONS(549),
    [aux_sym_calling_conv_token13] = ACTIONS(551),
    [aux_sym_calling_conv_token14] = ACTIONS(549),
    [anon_sym_cc] = ACTIONS(551),
    [anon_sym_unnamed_addr] = ACTIONS(549),
    [anon_sym_local_unnamed_addr] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(549),
    [anon_sym_half] = ACTIONS(549),
    [anon_sym_bfloat] = ACTIONS(549),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_double] = ACTIONS(549),
    [anon_sym_x86_fp80] = ACTIONS(551),
    [anon_sym_fp128] = ACTIONS(549),
    [anon_sym_ppc_fp128] = ACTIONS(549),
    [anon_sym_label] = ACTIONS(549),
    [anon_sym_metadata] = ACTIONS(549),
    [anon_sym_x86_mmx] = ACTIONS(551),
    [anon_sym_x86_amx] = ACTIONS(551),
    [anon_sym_token] = ACTIONS(549),
    [anon_sym_opaque] = ACTIONS(549),
    [anon_sym_ptr] = ACTIONS(549),
    [aux_sym_type_keyword_token1] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LT_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_alignstack] = ACTIONS(549),
    [anon_sym_allocsize] = ACTIONS(549),
    [anon_sym_alwaysinline] = ACTIONS(549),
    [anon_sym_builtin] = ACTIONS(549),
    [anon_sym_cold] = ACTIONS(551),
    [anon_sym_convergent] = ACTIONS(549),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(549),
    [anon_sym_hot] = ACTIONS(549),
    [anon_sym_inaccessiblememonly] = ACTIONS(549),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(549),
    [anon_sym_inlinehint] = ACTIONS(549),
    [anon_sym_jumptable] = ACTIONS(549),
    [anon_sym_minsize] = ACTIONS(549),
    [anon_sym_naked] = ACTIONS(549),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(549),
    [anon_sym_nobuiltin] = ACTIONS(549),
    [anon_sym_noduplicate] = ACTIONS(549),
    [anon_sym_nofree] = ACTIONS(549),
    [anon_sym_noimplicitfloat] = ACTIONS(549),
    [anon_sym_noinline] = ACTIONS(549),
    [anon_sym_nomerge] = ACTIONS(549),
    [anon_sym_nonlazybind] = ACTIONS(549),
    [anon_sym_noprofile] = ACTIONS(549),
    [anon_sym_noredzone] = ACTIONS(549),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(549),
    [anon_sym_noreturn] = ACTIONS(549),
    [anon_sym_norecurse] = ACTIONS(549),
    [anon_sym_willreturn] = ACTIONS(549),
    [anon_sym_nosync] = ACTIONS(549),
    [anon_sym_nounwind] = ACTIONS(549),
    [anon_sym_nosanitize_coverage] = ACTIONS(549),
    [anon_sym_null_pointer_is_valid] = ACTIONS(549),
    [anon_sym_optforfuzzing] = ACTIONS(549),
    [anon_sym_optnone] = ACTIONS(549),
    [anon_sym_optsize] = ACTIONS(549),
    [anon_sym_readnone] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_writeonly] = ACTIONS(549),
    [anon_sym_argmemonly] = ACTIONS(549),
    [anon_sym_returns_twice] = ACTIONS(549),
    [anon_sym_safestack] = ACTIONS(549),
    [anon_sym_sanitize_address] = ACTIONS(549),
    [anon_sym_sanitize_memory] = ACTIONS(549),
    [anon_sym_sanitize_thread] = ACTIONS(549),
    [anon_sym_sanitize_hwaddress] = ACTIONS(549),
    [anon_sym_sanitize_memtag] = ACTIONS(549),
    [anon_sym_speculative_load_hardening] = ACTIONS(549),
    [anon_sym_speculatable] = ACTIONS(549),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(549),
    [anon_sym_sspreq] = ACTIONS(549),
    [anon_sym_strictfp] = ACTIONS(549),
    [anon_sym_uwtable] = ACTIONS(549),
    [anon_sym_nocf_check] = ACTIONS(549),
    [anon_sym_shadowcallstack] = ACTIONS(549),
    [anon_sym_mustprogress] = ACTIONS(549),
    [anon_sym_vscale_range] = ACTIONS(549),
    [anon_sym_preallocated] = ACTIONS(549),
    [anon_sym_zeroext] = ACTIONS(549),
    [anon_sym_signext] = ACTIONS(549),
    [anon_sym_inreg] = ACTIONS(549),
    [anon_sym_byval] = ACTIONS(549),
    [anon_sym_byref] = ACTIONS(549),
    [anon_sym_inalloca] = ACTIONS(549),
    [anon_sym_sret] = ACTIONS(549),
    [anon_sym_elementtype] = ACTIONS(549),
    [anon_sym_noalias] = ACTIONS(549),
    [anon_sym_nocapture] = ACTIONS(549),
    [anon_sym_nest] = ACTIONS(549),
    [anon_sym_returned] = ACTIONS(549),
    [anon_sym_nonnull] = ACTIONS(549),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(549),
    [anon_sym_swiftself] = ACTIONS(551),
    [anon_sym_swiftasync] = ACTIONS(551),
    [anon_sym_swifterror] = ACTIONS(551),
    [anon_sym_immarg] = ACTIONS(549),
    [anon_sym_noundef] = ACTIONS(549),
    [anon_sym_to] = ACTIONS(551),
    [anon_sym_unwind] = ACTIONS(549),
    [anon_sym_unordered] = ACTIONS(549),
    [anon_sym_monotonic] = ACTIONS(549),
    [anon_sym_acquire] = ACTIONS(549),
    [anon_sym_release] = ACTIONS(549),
    [anon_sym_acq_rel] = ACTIONS(549),
    [anon_sym_seq_cst] = ACTIONS(549),
    [anon_sym_syncscope] = ACTIONS(549),
    [anon_sym_uselistorder] = ACTIONS(551),
    [anon_sym_uselistorder_bb] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_attributes] = ACTIONS(549),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(553),
    [sym_global_var] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [aux_sym_metadata_ref_token1] = ACTIONS(553),
    [sym_summary_ref] = ACTIONS(553),
    [sym_string] = ACTIONS(553),
    [anon_sym_target] = ACTIONS(553),
    [anon_sym_source_filename] = ACTIONS(553),
    [anon_sym_declare] = ACTIONS(553),
    [anon_sym_define] = ACTIONS(553),
    [anon_sym_no_cfi] = ACTIONS(553),
    [anon_sym_private] = ACTIONS(553),
    [anon_sym_internal] = ACTIONS(553),
    [anon_sym_weak] = ACTIONS(555),
    [anon_sym_weak_odr] = ACTIONS(553),
    [anon_sym_linkonce] = ACTIONS(555),
    [anon_sym_linkonce_odr] = ACTIONS(553),
    [anon_sym_available_externally] = ACTIONS(553),
    [anon_sym_appending] = ACTIONS(553),
    [anon_sym_common] = ACTIONS(553),
    [anon_sym_extern_weak] = ACTIONS(553),
    [anon_sym_external] = ACTIONS(553),
    [anon_sym_dso_local] = ACTIONS(555),
    [anon_sym_dso_local_equivalent] = ACTIONS(553),
    [anon_sym_dso_preemptable] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(553),
    [anon_sym_hidden] = ACTIONS(553),
    [anon_sym_protected] = ACTIONS(553),
    [anon_sym_dllimport] = ACTIONS(553),
    [anon_sym_dllexport] = ACTIONS(553),
    [anon_sym_ccc] = ACTIONS(553),
    [anon_sym_fastcc] = ACTIONS(553),
    [anon_sym_coldcc] = ACTIONS(553),
    [anon_sym_webkit_jscc] = ACTIONS(555),
    [anon_sym_anyregcc] = ACTIONS(553),
    [anon_sym_preserve_mostcc] = ACTIONS(553),
    [anon_sym_preserve_allcc] = ACTIONS(553),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(555),
    [anon_sym_tailcc] = ACTIONS(553),
    [anon_sym_swiftcc] = ACTIONS(555),
    [anon_sym_swifttailcc] = ACTIONS(555),
    [anon_sym_cfguard_checkcc] = ACTIONS(553),
    [aux_sym_calling_conv_token1] = ACTIONS(555),
    [aux_sym_calling_conv_token2] = ACTIONS(553),
    [aux_sym_calling_conv_token3] = ACTIONS(553),
    [aux_sym_calling_conv_token4] = ACTIONS(553),
    [aux_sym_calling_conv_token5] = ACTIONS(553),
    [aux_sym_calling_conv_token6] = ACTIONS(553),
    [aux_sym_calling_conv_token7] = ACTIONS(553),
    [aux_sym_calling_conv_token8] = ACTIONS(553),
    [aux_sym_calling_conv_token9] = ACTIONS(553),
    [aux_sym_calling_conv_token10] = ACTIONS(555),
    [anon_sym_ghccc] = ACTIONS(553),
    [aux_sym_calling_conv_token11] = ACTIONS(555),
    [aux_sym_calling_conv_token12] = ACTIONS(553),
    [aux_sym_calling_conv_token13] = ACTIONS(555),
    [aux_sym_calling_conv_token14] = ACTIONS(553),
    [anon_sym_cc] = ACTIONS(555),
    [anon_sym_unnamed_addr] = ACTIONS(553),
    [anon_sym_local_unnamed_addr] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(553),
    [anon_sym_half] = ACTIONS(553),
    [anon_sym_bfloat] = ACTIONS(553),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_double] = ACTIONS(553),
    [anon_sym_x86_fp80] = ACTIONS(555),
    [anon_sym_fp128] = ACTIONS(553),
    [anon_sym_ppc_fp128] = ACTIONS(553),
    [anon_sym_label] = ACTIONS(553),
    [anon_sym_metadata] = ACTIONS(553),
    [anon_sym_x86_mmx] = ACTIONS(555),
    [anon_sym_x86_amx] = ACTIONS(555),
    [anon_sym_token] = ACTIONS(553),
    [anon_sym_opaque] = ACTIONS(553),
    [anon_sym_ptr] = ACTIONS(553),
    [aux_sym_type_keyword_token1] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LT_LBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_alignstack] = ACTIONS(553),
    [anon_sym_allocsize] = ACTIONS(553),
    [anon_sym_alwaysinline] = ACTIONS(553),
    [anon_sym_builtin] = ACTIONS(553),
    [anon_sym_cold] = ACTIONS(555),
    [anon_sym_convergent] = ACTIONS(553),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(553),
    [anon_sym_hot] = ACTIONS(553),
    [anon_sym_inaccessiblememonly] = ACTIONS(553),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(553),
    [anon_sym_inlinehint] = ACTIONS(553),
    [anon_sym_jumptable] = ACTIONS(553),
    [anon_sym_minsize] = ACTIONS(553),
    [anon_sym_naked] = ACTIONS(553),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(553),
    [anon_sym_nobuiltin] = ACTIONS(553),
    [anon_sym_noduplicate] = ACTIONS(553),
    [anon_sym_nofree] = ACTIONS(553),
    [anon_sym_noimplicitfloat] = ACTIONS(553),
    [anon_sym_noinline] = ACTIONS(553),
    [anon_sym_nomerge] = ACTIONS(553),
    [anon_sym_nonlazybind] = ACTIONS(553),
    [anon_sym_noprofile] = ACTIONS(553),
    [anon_sym_noredzone] = ACTIONS(553),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(553),
    [anon_sym_noreturn] = ACTIONS(553),
    [anon_sym_norecurse] = ACTIONS(553),
    [anon_sym_willreturn] = ACTIONS(553),
    [anon_sym_nosync] = ACTIONS(553),
    [anon_sym_nounwind] = ACTIONS(553),
    [anon_sym_nosanitize_coverage] = ACTIONS(553),
    [anon_sym_null_pointer_is_valid] = ACTIONS(553),
    [anon_sym_optforfuzzing] = ACTIONS(553),
    [anon_sym_optnone] = ACTIONS(553),
    [anon_sym_optsize] = ACTIONS(553),
    [anon_sym_readnone] = ACTIONS(553),
    [anon_sym_readonly] = ACTIONS(553),
    [anon_sym_writeonly] = ACTIONS(553),
    [anon_sym_argmemonly] = ACTIONS(553),
    [anon_sym_returns_twice] = ACTIONS(553),
    [anon_sym_safestack] = ACTIONS(553),
    [anon_sym_sanitize_address] = ACTIONS(553),
    [anon_sym_sanitize_memory] = ACTIONS(553),
    [anon_sym_sanitize_thread] = ACTIONS(553),
    [anon_sym_sanitize_hwaddress] = ACTIONS(553),
    [anon_sym_sanitize_memtag] = ACTIONS(553),
    [anon_sym_speculative_load_hardening] = ACTIONS(553),
    [anon_sym_speculatable] = ACTIONS(553),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(553),
    [anon_sym_sspreq] = ACTIONS(553),
    [anon_sym_strictfp] = ACTIONS(553),
    [anon_sym_uwtable] = ACTIONS(553),
    [anon_sym_nocf_check] = ACTIONS(553),
    [anon_sym_shadowcallstack] = ACTIONS(553),
    [anon_sym_mustprogress] = ACTIONS(553),
    [anon_sym_vscale_range] = ACTIONS(553),
    [anon_sym_preallocated] = ACTIONS(553),
    [anon_sym_zeroext] = ACTIONS(553),
    [anon_sym_signext] = ACTIONS(553),
    [anon_sym_inreg] = ACTIONS(553),
    [anon_sym_byval] = ACTIONS(553),
    [anon_sym_byref] = ACTIONS(553),
    [anon_sym_inalloca] = ACTIONS(553),
    [anon_sym_sret] = ACTIONS(553),
    [anon_sym_elementtype] = ACTIONS(553),
    [anon_sym_noalias] = ACTIONS(553),
    [anon_sym_nocapture] = ACTIONS(553),
    [anon_sym_nest] = ACTIONS(553),
    [anon_sym_returned] = ACTIONS(553),
    [anon_sym_nonnull] = ACTIONS(553),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(553),
    [anon_sym_swiftself] = ACTIONS(555),
    [anon_sym_swiftasync] = ACTIONS(555),
    [anon_sym_swifterror] = ACTIONS(555),
    [anon_sym_immarg] = ACTIONS(553),
    [anon_sym_noundef] = ACTIONS(553),
    [anon_sym_to] = ACTIONS(555),
    [anon_sym_unwind] = ACTIONS(553),
    [anon_sym_unordered] = ACTIONS(553),
    [anon_sym_monotonic] = ACTIONS(553),
    [anon_sym_acquire] = ACTIONS(553),
    [anon_sym_release] = ACTIONS(553),
    [anon_sym_acq_rel] = ACTIONS(553),
    [anon_sym_seq_cst] = ACTIONS(553),
    [anon_sym_syncscope] = ACTIONS(553),
    [anon_sym_uselistorder] = ACTIONS(555),
    [anon_sym_uselistorder_bb] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_attributes] = ACTIONS(553),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(557),
    [sym_global_var] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [aux_sym_metadata_ref_token1] = ACTIONS(557),
    [sym_summary_ref] = ACTIONS(557),
    [sym_string] = ACTIONS(557),
    [anon_sym_target] = ACTIONS(557),
    [anon_sym_source_filename] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_define] = ACTIONS(557),
    [anon_sym_no_cfi] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_internal] = ACTIONS(557),
    [anon_sym_weak] = ACTIONS(559),
    [anon_sym_weak_odr] = ACTIONS(557),
    [anon_sym_linkonce] = ACTIONS(559),
    [anon_sym_linkonce_odr] = ACTIONS(557),
    [anon_sym_available_externally] = ACTIONS(557),
    [anon_sym_appending] = ACTIONS(557),
    [anon_sym_common] = ACTIONS(557),
    [anon_sym_extern_weak] = ACTIONS(557),
    [anon_sym_external] = ACTIONS(557),
    [anon_sym_dso_local] = ACTIONS(559),
    [anon_sym_dso_local_equivalent] = ACTIONS(557),
    [anon_sym_dso_preemptable] = ACTIONS(557),
    [anon_sym_default] = ACTIONS(557),
    [anon_sym_hidden] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_dllimport] = ACTIONS(557),
    [anon_sym_dllexport] = ACTIONS(557),
    [anon_sym_ccc] = ACTIONS(557),
    [anon_sym_fastcc] = ACTIONS(557),
    [anon_sym_coldcc] = ACTIONS(557),
    [anon_sym_webkit_jscc] = ACTIONS(559),
    [anon_sym_anyregcc] = ACTIONS(557),
    [anon_sym_preserve_mostcc] = ACTIONS(557),
    [anon_sym_preserve_allcc] = ACTIONS(557),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(559),
    [anon_sym_tailcc] = ACTIONS(557),
    [anon_sym_swiftcc] = ACTIONS(559),
    [anon_sym_swifttailcc] = ACTIONS(559),
    [anon_sym_cfguard_checkcc] = ACTIONS(557),
    [aux_sym_calling_conv_token1] = ACTIONS(559),
    [aux_sym_calling_conv_token2] = ACTIONS(557),
    [aux_sym_calling_conv_token3] = ACTIONS(557),
    [aux_sym_calling_conv_token4] = ACTIONS(557),
    [aux_sym_calling_conv_token5] = ACTIONS(557),
    [aux_sym_calling_conv_token6] = ACTIONS(557),
    [aux_sym_calling_conv_token7] = ACTIONS(557),
    [aux_sym_calling_conv_token8] = ACTIONS(557),
    [aux_sym_calling_conv_token9] = ACTIONS(557),
    [aux_sym_calling_conv_token10] = ACTIONS(559),
    [anon_sym_ghccc] = ACTIONS(557),
    [aux_sym_calling_conv_token11] = ACTIONS(559),
    [aux_sym_calling_conv_token12] = ACTIONS(557),
    [aux_sym_calling_conv_token13] = ACTIONS(559),
    [aux_sym_calling_conv_token14] = ACTIONS(557),
    [anon_sym_cc] = ACTIONS(559),
    [anon_sym_unnamed_addr] = ACTIONS(557),
    [anon_sym_local_unnamed_addr] = ACTIONS(557),
    [anon_sym_void] = ACTIONS(557),
    [anon_sym_half] = ACTIONS(557),
    [anon_sym_bfloat] = ACTIONS(557),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_double] = ACTIONS(557),
    [anon_sym_x86_fp80] = ACTIONS(559),
    [anon_sym_fp128] = ACTIONS(557),
    [anon_sym_ppc_fp128] = ACTIONS(557),
    [anon_sym_label] = ACTIONS(557),
    [anon_sym_metadata] = ACTIONS(557),
    [anon_sym_x86_mmx] = ACTIONS(559),
    [anon_sym_x86_amx] = ACTIONS(559),
    [anon_sym_token] = ACTIONS(557),
    [anon_sym_opaque] = ACTIONS(557),
    [anon_sym_ptr] = ACTIONS(557),
    [aux_sym_type_keyword_token1] = ACTIONS(557),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LT_LBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_alignstack] = ACTIONS(557),
    [anon_sym_allocsize] = ACTIONS(557),
    [anon_sym_alwaysinline] = ACTIONS(557),
    [anon_sym_builtin] = ACTIONS(557),
    [anon_sym_cold] = ACTIONS(559),
    [anon_sym_convergent] = ACTIONS(557),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(557),
    [anon_sym_hot] = ACTIONS(557),
    [anon_sym_inaccessiblememonly] = ACTIONS(557),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(557),
    [anon_sym_inlinehint] = ACTIONS(557),
    [anon_sym_jumptable] = ACTIONS(557),
    [anon_sym_minsize] = ACTIONS(557),
    [anon_sym_naked] = ACTIONS(557),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(557),
    [anon_sym_nobuiltin] = ACTIONS(557),
    [anon_sym_noduplicate] = ACTIONS(557),
    [anon_sym_nofree] = ACTIONS(557),
    [anon_sym_noimplicitfloat] = ACTIONS(557),
    [anon_sym_noinline] = ACTIONS(557),
    [anon_sym_nomerge] = ACTIONS(557),
    [anon_sym_nonlazybind] = ACTIONS(557),
    [anon_sym_noprofile] = ACTIONS(557),
    [anon_sym_noredzone] = ACTIONS(557),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(557),
    [anon_sym_noreturn] = ACTIONS(557),
    [anon_sym_norecurse] = ACTIONS(557),
    [anon_sym_willreturn] = ACTIONS(557),
    [anon_sym_nosync] = ACTIONS(557),
    [anon_sym_nounwind] = ACTIONS(557),
    [anon_sym_nosanitize_coverage] = ACTIONS(557),
    [anon_sym_null_pointer_is_valid] = ACTIONS(557),
    [anon_sym_optforfuzzing] = ACTIONS(557),
    [anon_sym_optnone] = ACTIONS(557),
    [anon_sym_optsize] = ACTIONS(557),
    [anon_sym_readnone] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_writeonly] = ACTIONS(557),
    [anon_sym_argmemonly] = ACTIONS(557),
    [anon_sym_returns_twice] = ACTIONS(557),
    [anon_sym_safestack] = ACTIONS(557),
    [anon_sym_sanitize_address] = ACTIONS(557),
    [anon_sym_sanitize_memory] = ACTIONS(557),
    [anon_sym_sanitize_thread] = ACTIONS(557),
    [anon_sym_sanitize_hwaddress] = ACTIONS(557),
    [anon_sym_sanitize_memtag] = ACTIONS(557),
    [anon_sym_speculative_load_hardening] = ACTIONS(557),
    [anon_sym_speculatable] = ACTIONS(557),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(557),
    [anon_sym_sspreq] = ACTIONS(557),
    [anon_sym_strictfp] = ACTIONS(557),
    [anon_sym_uwtable] = ACTIONS(557),
    [anon_sym_nocf_check] = ACTIONS(557),
    [anon_sym_shadowcallstack] = ACTIONS(557),
    [anon_sym_mustprogress] = ACTIONS(557),
    [anon_sym_vscale_range] = ACTIONS(557),
    [anon_sym_preallocated] = ACTIONS(557),
    [anon_sym_zeroext] = ACTIONS(557),
    [anon_sym_signext] = ACTIONS(557),
    [anon_sym_inreg] = ACTIONS(557),
    [anon_sym_byval] = ACTIONS(557),
    [anon_sym_byref] = ACTIONS(557),
    [anon_sym_inalloca] = ACTIONS(557),
    [anon_sym_sret] = ACTIONS(557),
    [anon_sym_elementtype] = ACTIONS(557),
    [anon_sym_noalias] = ACTIONS(557),
    [anon_sym_nocapture] = ACTIONS(557),
    [anon_sym_nest] = ACTIONS(557),
    [anon_sym_returned] = ACTIONS(557),
    [anon_sym_nonnull] = ACTIONS(557),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(557),
    [anon_sym_swiftself] = ACTIONS(559),
    [anon_sym_swiftasync] = ACTIONS(559),
    [anon_sym_swifterror] = ACTIONS(559),
    [anon_sym_immarg] = ACTIONS(557),
    [anon_sym_noundef] = ACTIONS(557),
    [anon_sym_to] = ACTIONS(559),
    [anon_sym_unwind] = ACTIONS(557),
    [anon_sym_unordered] = ACTIONS(557),
    [anon_sym_monotonic] = ACTIONS(557),
    [anon_sym_acquire] = ACTIONS(557),
    [anon_sym_release] = ACTIONS(557),
    [anon_sym_acq_rel] = ACTIONS(557),
    [anon_sym_seq_cst] = ACTIONS(557),
    [anon_sym_syncscope] = ACTIONS(557),
    [anon_sym_uselistorder] = ACTIONS(559),
    [anon_sym_uselistorder_bb] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_attributes] = ACTIONS(557),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(561),
    [sym_global_var] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [aux_sym_metadata_ref_token1] = ACTIONS(561),
    [sym_summary_ref] = ACTIONS(561),
    [sym_string] = ACTIONS(561),
    [anon_sym_target] = ACTIONS(561),
    [anon_sym_source_filename] = ACTIONS(561),
    [anon_sym_declare] = ACTIONS(561),
    [anon_sym_define] = ACTIONS(561),
    [anon_sym_no_cfi] = ACTIONS(561),
    [anon_sym_private] = ACTIONS(561),
    [anon_sym_internal] = ACTIONS(561),
    [anon_sym_weak] = ACTIONS(563),
    [anon_sym_weak_odr] = ACTIONS(561),
    [anon_sym_linkonce] = ACTIONS(563),
    [anon_sym_linkonce_odr] = ACTIONS(561),
    [anon_sym_available_externally] = ACTIONS(561),
    [anon_sym_appending] = ACTIONS(561),
    [anon_sym_common] = ACTIONS(561),
    [anon_sym_extern_weak] = ACTIONS(561),
    [anon_sym_external] = ACTIONS(561),
    [anon_sym_dso_local] = ACTIONS(563),
    [anon_sym_dso_local_equivalent] = ACTIONS(561),
    [anon_sym_dso_preemptable] = ACTIONS(561),
    [anon_sym_default] = ACTIONS(561),
    [anon_sym_hidden] = ACTIONS(561),
    [anon_sym_protected] = ACTIONS(561),
    [anon_sym_dllimport] = ACTIONS(561),
    [anon_sym_dllexport] = ACTIONS(561),
    [anon_sym_ccc] = ACTIONS(561),
    [anon_sym_fastcc] = ACTIONS(561),
    [anon_sym_coldcc] = ACTIONS(561),
    [anon_sym_webkit_jscc] = ACTIONS(563),
    [anon_sym_anyregcc] = ACTIONS(561),
    [anon_sym_preserve_mostcc] = ACTIONS(561),
    [anon_sym_preserve_allcc] = ACTIONS(561),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(563),
    [anon_sym_tailcc] = ACTIONS(561),
    [anon_sym_swiftcc] = ACTIONS(563),
    [anon_sym_swifttailcc] = ACTIONS(563),
    [anon_sym_cfguard_checkcc] = ACTIONS(561),
    [aux_sym_calling_conv_token1] = ACTIONS(563),
    [aux_sym_calling_conv_token2] = ACTIONS(561),
    [aux_sym_calling_conv_token3] = ACTIONS(561),
    [aux_sym_calling_conv_token4] = ACTIONS(561),
    [aux_sym_calling_conv_token5] = ACTIONS(561),
    [aux_sym_calling_conv_token6] = ACTIONS(561),
    [aux_sym_calling_conv_token7] = ACTIONS(561),
    [aux_sym_calling_conv_token8] = ACTIONS(561),
    [aux_sym_calling_conv_token9] = ACTIONS(561),
    [aux_sym_calling_conv_token10] = ACTIONS(563),
    [anon_sym_ghccc] = ACTIONS(561),
    [aux_sym_calling_conv_token11] = ACTIONS(563),
    [aux_sym_calling_conv_token12] = ACTIONS(561),
    [aux_sym_calling_conv_token13] = ACTIONS(563),
    [aux_sym_calling_conv_token14] = ACTIONS(561),
    [anon_sym_cc] = ACTIONS(563),
    [anon_sym_unnamed_addr] = ACTIONS(561),
    [anon_sym_local_unnamed_addr] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_half] = ACTIONS(561),
    [anon_sym_bfloat] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_x86_fp80] = ACTIONS(563),
    [anon_sym_fp128] = ACTIONS(561),
    [anon_sym_ppc_fp128] = ACTIONS(561),
    [anon_sym_label] = ACTIONS(561),
    [anon_sym_metadata] = ACTIONS(561),
    [anon_sym_x86_mmx] = ACTIONS(563),
    [anon_sym_x86_amx] = ACTIONS(563),
    [anon_sym_token] = ACTIONS(561),
    [anon_sym_opaque] = ACTIONS(561),
    [anon_sym_ptr] = ACTIONS(561),
    [aux_sym_type_keyword_token1] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LT_LBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_alignstack] = ACTIONS(561),
    [anon_sym_allocsize] = ACTIONS(561),
    [anon_sym_alwaysinline] = ACTIONS(561),
    [anon_sym_builtin] = ACTIONS(561),
    [anon_sym_cold] = ACTIONS(563),
    [anon_sym_convergent] = ACTIONS(561),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(561),
    [anon_sym_hot] = ACTIONS(561),
    [anon_sym_inaccessiblememonly] = ACTIONS(561),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(561),
    [anon_sym_inlinehint] = ACTIONS(561),
    [anon_sym_jumptable] = ACTIONS(561),
    [anon_sym_minsize] = ACTIONS(561),
    [anon_sym_naked] = ACTIONS(561),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(561),
    [anon_sym_nobuiltin] = ACTIONS(561),
    [anon_sym_noduplicate] = ACTIONS(561),
    [anon_sym_nofree] = ACTIONS(561),
    [anon_sym_noimplicitfloat] = ACTIONS(561),
    [anon_sym_noinline] = ACTIONS(561),
    [anon_sym_nomerge] = ACTIONS(561),
    [anon_sym_nonlazybind] = ACTIONS(561),
    [anon_sym_noprofile] = ACTIONS(561),
    [anon_sym_noredzone] = ACTIONS(561),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(561),
    [anon_sym_noreturn] = ACTIONS(561),
    [anon_sym_norecurse] = ACTIONS(561),
    [anon_sym_willreturn] = ACTIONS(561),
    [anon_sym_nosync] = ACTIONS(561),
    [anon_sym_nounwind] = ACTIONS(561),
    [anon_sym_nosanitize_coverage] = ACTIONS(561),
    [anon_sym_null_pointer_is_valid] = ACTIONS(561),
    [anon_sym_optforfuzzing] = ACTIONS(561),
    [anon_sym_optnone] = ACTIONS(561),
    [anon_sym_optsize] = ACTIONS(561),
    [anon_sym_readnone] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_writeonly] = ACTIONS(561),
    [anon_sym_argmemonly] = ACTIONS(561),
    [anon_sym_returns_twice] = ACTIONS(561),
    [anon_sym_safestack] = ACTIONS(561),
    [anon_sym_sanitize_address] = ACTIONS(561),
    [anon_sym_sanitize_memory] = ACTIONS(561),
    [anon_sym_sanitize_thread] = ACTIONS(561),
    [anon_sym_sanitize_hwaddress] = ACTIONS(561),
    [anon_sym_sanitize_memtag] = ACTIONS(561),
    [anon_sym_speculative_load_hardening] = ACTIONS(561),
    [anon_sym_speculatable] = ACTIONS(561),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(561),
    [anon_sym_sspreq] = ACTIONS(561),
    [anon_sym_strictfp] = ACTIONS(561),
    [anon_sym_uwtable] = ACTIONS(561),
    [anon_sym_nocf_check] = ACTIONS(561),
    [anon_sym_shadowcallstack] = ACTIONS(561),
    [anon_sym_mustprogress] = ACTIONS(561),
    [anon_sym_vscale_range] = ACTIONS(561),
    [anon_sym_preallocated] = ACTIONS(561),
    [anon_sym_zeroext] = ACTIONS(561),
    [anon_sym_signext] = ACTIONS(561),
    [anon_sym_inreg] = ACTIONS(561),
    [anon_sym_byval] = ACTIONS(561),
    [anon_sym_byref] = ACTIONS(561),
    [anon_sym_inalloca] = ACTIONS(561),
    [anon_sym_sret] = ACTIONS(561),
    [anon_sym_elementtype] = ACTIONS(561),
    [anon_sym_noalias] = ACTIONS(561),
    [anon_sym_nocapture] = ACTIONS(561),
    [anon_sym_nest] = ACTIONS(561),
    [anon_sym_returned] = ACTIONS(561),
    [anon_sym_nonnull] = ACTIONS(561),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(561),
    [anon_sym_swiftself] = ACTIONS(563),
    [anon_sym_swiftasync] = ACTIONS(563),
    [anon_sym_swifterror] = ACTIONS(563),
    [anon_sym_immarg] = ACTIONS(561),
    [anon_sym_noundef] = ACTIONS(561),
    [anon_sym_to] = ACTIONS(563),
    [anon_sym_unwind] = ACTIONS(561),
    [anon_sym_unordered] = ACTIONS(561),
    [anon_sym_monotonic] = ACTIONS(561),
    [anon_sym_acquire] = ACTIONS(561),
    [anon_sym_release] = ACTIONS(561),
    [anon_sym_acq_rel] = ACTIONS(561),
    [anon_sym_seq_cst] = ACTIONS(561),
    [anon_sym_syncscope] = ACTIONS(561),
    [anon_sym_uselistorder] = ACTIONS(563),
    [anon_sym_uselistorder_bb] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_attributes] = ACTIONS(561),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(565),
    [sym_global_var] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [aux_sym_metadata_ref_token1] = ACTIONS(565),
    [sym_summary_ref] = ACTIONS(565),
    [sym_string] = ACTIONS(565),
    [anon_sym_target] = ACTIONS(565),
    [anon_sym_source_filename] = ACTIONS(565),
    [anon_sym_declare] = ACTIONS(565),
    [anon_sym_define] = ACTIONS(565),
    [anon_sym_no_cfi] = ACTIONS(565),
    [anon_sym_private] = ACTIONS(565),
    [anon_sym_internal] = ACTIONS(565),
    [anon_sym_weak] = ACTIONS(567),
    [anon_sym_weak_odr] = ACTIONS(565),
    [anon_sym_linkonce] = ACTIONS(567),
    [anon_sym_linkonce_odr] = ACTIONS(565),
    [anon_sym_available_externally] = ACTIONS(565),
    [anon_sym_appending] = ACTIONS(565),
    [anon_sym_common] = ACTIONS(565),
    [anon_sym_extern_weak] = ACTIONS(565),
    [anon_sym_external] = ACTIONS(565),
    [anon_sym_dso_local] = ACTIONS(567),
    [anon_sym_dso_local_equivalent] = ACTIONS(565),
    [anon_sym_dso_preemptable] = ACTIONS(565),
    [anon_sym_default] = ACTIONS(565),
    [anon_sym_hidden] = ACTIONS(565),
    [anon_sym_protected] = ACTIONS(565),
    [anon_sym_dllimport] = ACTIONS(565),
    [anon_sym_dllexport] = ACTIONS(565),
    [anon_sym_ccc] = ACTIONS(565),
    [anon_sym_fastcc] = ACTIONS(565),
    [anon_sym_coldcc] = ACTIONS(565),
    [anon_sym_webkit_jscc] = ACTIONS(567),
    [anon_sym_anyregcc] = ACTIONS(565),
    [anon_sym_preserve_mostcc] = ACTIONS(565),
    [anon_sym_preserve_allcc] = ACTIONS(565),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(567),
    [anon_sym_tailcc] = ACTIONS(565),
    [anon_sym_swiftcc] = ACTIONS(567),
    [anon_sym_swifttailcc] = ACTIONS(567),
    [anon_sym_cfguard_checkcc] = ACTIONS(565),
    [aux_sym_calling_conv_token1] = ACTIONS(567),
    [aux_sym_calling_conv_token2] = ACTIONS(565),
    [aux_sym_calling_conv_token3] = ACTIONS(565),
    [aux_sym_calling_conv_token4] = ACTIONS(565),
    [aux_sym_calling_conv_token5] = ACTIONS(565),
    [aux_sym_calling_conv_token6] = ACTIONS(565),
    [aux_sym_calling_conv_token7] = ACTIONS(565),
    [aux_sym_calling_conv_token8] = ACTIONS(565),
    [aux_sym_calling_conv_token9] = ACTIONS(565),
    [aux_sym_calling_conv_token10] = ACTIONS(567),
    [anon_sym_ghccc] = ACTIONS(565),
    [aux_sym_calling_conv_token11] = ACTIONS(567),
    [aux_sym_calling_conv_token12] = ACTIONS(565),
    [aux_sym_calling_conv_token13] = ACTIONS(567),
    [aux_sym_calling_conv_token14] = ACTIONS(565),
    [anon_sym_cc] = ACTIONS(567),
    [anon_sym_unnamed_addr] = ACTIONS(565),
    [anon_sym_local_unnamed_addr] = ACTIONS(565),
    [anon_sym_void] = ACTIONS(565),
    [anon_sym_half] = ACTIONS(565),
    [anon_sym_bfloat] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_double] = ACTIONS(565),
    [anon_sym_x86_fp80] = ACTIONS(567),
    [anon_sym_fp128] = ACTIONS(565),
    [anon_sym_ppc_fp128] = ACTIONS(565),
    [anon_sym_label] = ACTIONS(565),
    [anon_sym_metadata] = ACTIONS(565),
    [anon_sym_x86_mmx] = ACTIONS(567),
    [anon_sym_x86_amx] = ACTIONS(567),
    [anon_sym_token] = ACTIONS(565),
    [anon_sym_opaque] = ACTIONS(565),
    [anon_sym_ptr] = ACTIONS(565),
    [aux_sym_type_keyword_token1] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LT_LBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_alignstack] = ACTIONS(565),
    [anon_sym_allocsize] = ACTIONS(565),
    [anon_sym_alwaysinline] = ACTIONS(565),
    [anon_sym_builtin] = ACTIONS(565),
    [anon_sym_cold] = ACTIONS(567),
    [anon_sym_convergent] = ACTIONS(565),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(565),
    [anon_sym_hot] = ACTIONS(565),
    [anon_sym_inaccessiblememonly] = ACTIONS(565),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(565),
    [anon_sym_inlinehint] = ACTIONS(565),
    [anon_sym_jumptable] = ACTIONS(565),
    [anon_sym_minsize] = ACTIONS(565),
    [anon_sym_naked] = ACTIONS(565),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(565),
    [anon_sym_nobuiltin] = ACTIONS(565),
    [anon_sym_noduplicate] = ACTIONS(565),
    [anon_sym_nofree] = ACTIONS(565),
    [anon_sym_noimplicitfloat] = ACTIONS(565),
    [anon_sym_noinline] = ACTIONS(565),
    [anon_sym_nomerge] = ACTIONS(565),
    [anon_sym_nonlazybind] = ACTIONS(565),
    [anon_sym_noprofile] = ACTIONS(565),
    [anon_sym_noredzone] = ACTIONS(565),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(565),
    [anon_sym_noreturn] = ACTIONS(565),
    [anon_sym_norecurse] = ACTIONS(565),
    [anon_sym_willreturn] = ACTIONS(565),
    [anon_sym_nosync] = ACTIONS(565),
    [anon_sym_nounwind] = ACTIONS(565),
    [anon_sym_nosanitize_coverage] = ACTIONS(565),
    [anon_sym_null_pointer_is_valid] = ACTIONS(565),
    [anon_sym_optforfuzzing] = ACTIONS(565),
    [anon_sym_optnone] = ACTIONS(565),
    [anon_sym_optsize] = ACTIONS(565),
    [anon_sym_readnone] = ACTIONS(565),
    [anon_sym_readonly] = ACTIONS(565),
    [anon_sym_writeonly] = ACTIONS(565),
    [anon_sym_argmemonly] = ACTIONS(565),
    [anon_sym_returns_twice] = ACTIONS(565),
    [anon_sym_safestack] = ACTIONS(565),
    [anon_sym_sanitize_address] = ACTIONS(565),
    [anon_sym_sanitize_memory] = ACTIONS(565),
    [anon_sym_sanitize_thread] = ACTIONS(565),
    [anon_sym_sanitize_hwaddress] = ACTIONS(565),
    [anon_sym_sanitize_memtag] = ACTIONS(565),
    [anon_sym_speculative_load_hardening] = ACTIONS(565),
    [anon_sym_speculatable] = ACTIONS(565),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(565),
    [anon_sym_sspreq] = ACTIONS(565),
    [anon_sym_strictfp] = ACTIONS(565),
    [anon_sym_uwtable] = ACTIONS(565),
    [anon_sym_nocf_check] = ACTIONS(565),
    [anon_sym_shadowcallstack] = ACTIONS(565),
    [anon_sym_mustprogress] = ACTIONS(565),
    [anon_sym_vscale_range] = ACTIONS(565),
    [anon_sym_preallocated] = ACTIONS(565),
    [anon_sym_zeroext] = ACTIONS(565),
    [anon_sym_signext] = ACTIONS(565),
    [anon_sym_inreg] = ACTIONS(565),
    [anon_sym_byval] = ACTIONS(565),
    [anon_sym_byref] = ACTIONS(565),
    [anon_sym_inalloca] = ACTIONS(565),
    [anon_sym_sret] = ACTIONS(565),
    [anon_sym_elementtype] = ACTIONS(565),
    [anon_sym_noalias] = ACTIONS(565),
    [anon_sym_nocapture] = ACTIONS(565),
    [anon_sym_nest] = ACTIONS(565),
    [anon_sym_returned] = ACTIONS(565),
    [anon_sym_nonnull] = ACTIONS(565),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(565),
    [anon_sym_swiftself] = ACTIONS(567),
    [anon_sym_swiftasync] = ACTIONS(567),
    [anon_sym_swifterror] = ACTIONS(567),
    [anon_sym_immarg] = ACTIONS(565),
    [anon_sym_noundef] = ACTIONS(565),
    [anon_sym_to] = ACTIONS(567),
    [anon_sym_unwind] = ACTIONS(565),
    [anon_sym_unordered] = ACTIONS(565),
    [anon_sym_monotonic] = ACTIONS(565),
    [anon_sym_acquire] = ACTIONS(565),
    [anon_sym_release] = ACTIONS(565),
    [anon_sym_acq_rel] = ACTIONS(565),
    [anon_sym_seq_cst] = ACTIONS(565),
    [anon_sym_syncscope] = ACTIONS(565),
    [anon_sym_uselistorder] = ACTIONS(567),
    [anon_sym_uselistorder_bb] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_attributes] = ACTIONS(565),
  },
  [101] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(569),
    [sym_global_var] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [aux_sym_metadata_ref_token1] = ACTIONS(569),
    [sym_summary_ref] = ACTIONS(569),
    [sym_string] = ACTIONS(569),
    [anon_sym_target] = ACTIONS(569),
    [anon_sym_source_filename] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_define] = ACTIONS(569),
    [anon_sym_no_cfi] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_internal] = ACTIONS(569),
    [anon_sym_weak] = ACTIONS(571),
    [anon_sym_weak_odr] = ACTIONS(569),
    [anon_sym_linkonce] = ACTIONS(571),
    [anon_sym_linkonce_odr] = ACTIONS(569),
    [anon_sym_available_externally] = ACTIONS(569),
    [anon_sym_appending] = ACTIONS(569),
    [anon_sym_common] = ACTIONS(569),
    [anon_sym_extern_weak] = ACTIONS(569),
    [anon_sym_external] = ACTIONS(569),
    [anon_sym_dso_local] = ACTIONS(571),
    [anon_sym_dso_local_equivalent] = ACTIONS(569),
    [anon_sym_dso_preemptable] = ACTIONS(569),
    [anon_sym_default] = ACTIONS(569),
    [anon_sym_hidden] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_dllimport] = ACTIONS(569),
    [anon_sym_dllexport] = ACTIONS(569),
    [anon_sym_ccc] = ACTIONS(569),
    [anon_sym_fastcc] = ACTIONS(569),
    [anon_sym_coldcc] = ACTIONS(569),
    [anon_sym_webkit_jscc] = ACTIONS(571),
    [anon_sym_anyregcc] = ACTIONS(569),
    [anon_sym_preserve_mostcc] = ACTIONS(569),
    [anon_sym_preserve_allcc] = ACTIONS(569),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(571),
    [anon_sym_tailcc] = ACTIONS(569),
    [anon_sym_swiftcc] = ACTIONS(571),
    [anon_sym_swifttailcc] = ACTIONS(571),
    [anon_sym_cfguard_checkcc] = ACTIONS(569),
    [aux_sym_calling_conv_token1] = ACTIONS(571),
    [aux_sym_calling_conv_token2] = ACTIONS(569),
    [aux_sym_calling_conv_token3] = ACTIONS(569),
    [aux_sym_calling_conv_token4] = ACTIONS(569),
    [aux_sym_calling_conv_token5] = ACTIONS(569),
    [aux_sym_calling_conv_token6] = ACTIONS(569),
    [aux_sym_calling_conv_token7] = ACTIONS(569),
    [aux_sym_calling_conv_token8] = ACTIONS(569),
    [aux_sym_calling_conv_token9] = ACTIONS(569),
    [aux_sym_calling_conv_token10] = ACTIONS(571),
    [anon_sym_ghccc] = ACTIONS(569),
    [aux_sym_calling_conv_token11] = ACTIONS(571),
    [aux_sym_calling_conv_token12] = ACTIONS(569),
    [aux_sym_calling_conv_token13] = ACTIONS(571),
    [aux_sym_calling_conv_token14] = ACTIONS(569),
    [anon_sym_cc] = ACTIONS(571),
    [anon_sym_unnamed_addr] = ACTIONS(569),
    [anon_sym_local_unnamed_addr] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_half] = ACTIONS(569),
    [anon_sym_bfloat] = ACTIONS(569),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_double] = ACTIONS(569),
    [anon_sym_x86_fp80] = ACTIONS(571),
    [anon_sym_fp128] = ACTIONS(569),
    [anon_sym_ppc_fp128] = ACTIONS(569),
    [anon_sym_label] = ACTIONS(569),
    [anon_sym_metadata] = ACTIONS(569),
    [anon_sym_x86_mmx] = ACTIONS(571),
    [anon_sym_x86_amx] = ACTIONS(571),
    [anon_sym_token] = ACTIONS(569),
    [anon_sym_opaque] = ACTIONS(569),
    [anon_sym_ptr] = ACTIONS(569),
    [aux_sym_type_keyword_token1] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LT_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_alignstack] = ACTIONS(569),
    [anon_sym_allocsize] = ACTIONS(569),
    [anon_sym_alwaysinline] = ACTIONS(569),
    [anon_sym_builtin] = ACTIONS(569),
    [anon_sym_cold] = ACTIONS(571),
    [anon_sym_convergent] = ACTIONS(569),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(569),
    [anon_sym_hot] = ACTIONS(569),
    [anon_sym_inaccessiblememonly] = ACTIONS(569),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(569),
    [anon_sym_inlinehint] = ACTIONS(569),
    [anon_sym_jumptable] = ACTIONS(569),
    [anon_sym_minsize] = ACTIONS(569),
    [anon_sym_naked] = ACTIONS(569),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(569),
    [anon_sym_nobuiltin] = ACTIONS(569),
    [anon_sym_noduplicate] = ACTIONS(569),
    [anon_sym_nofree] = ACTIONS(569),
    [anon_sym_noimplicitfloat] = ACTIONS(569),
    [anon_sym_noinline] = ACTIONS(569),
    [anon_sym_nomerge] = ACTIONS(569),
    [anon_sym_nonlazybind] = ACTIONS(569),
    [anon_sym_noprofile] = ACTIONS(569),
    [anon_sym_noredzone] = ACTIONS(569),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(569),
    [anon_sym_noreturn] = ACTIONS(569),
    [anon_sym_norecurse] = ACTIONS(569),
    [anon_sym_willreturn] = ACTIONS(569),
    [anon_sym_nosync] = ACTIONS(569),
    [anon_sym_nounwind] = ACTIONS(569),
    [anon_sym_nosanitize_coverage] = ACTIONS(569),
    [anon_sym_null_pointer_is_valid] = ACTIONS(569),
    [anon_sym_optforfuzzing] = ACTIONS(569),
    [anon_sym_optnone] = ACTIONS(569),
    [anon_sym_optsize] = ACTIONS(569),
    [anon_sym_readnone] = ACTIONS(569),
    [anon_sym_readonly] = ACTIONS(569),
    [anon_sym_writeonly] = ACTIONS(569),
    [anon_sym_argmemonly] = ACTIONS(569),
    [anon_sym_returns_twice] = ACTIONS(569),
    [anon_sym_safestack] = ACTIONS(569),
    [anon_sym_sanitize_address] = ACTIONS(569),
    [anon_sym_sanitize_memory] = ACTIONS(569),
    [anon_sym_sanitize_thread] = ACTIONS(569),
    [anon_sym_sanitize_hwaddress] = ACTIONS(569),
    [anon_sym_sanitize_memtag] = ACTIONS(569),
    [anon_sym_speculative_load_hardening] = ACTIONS(569),
    [anon_sym_speculatable] = ACTIONS(569),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(569),
    [anon_sym_sspreq] = ACTIONS(569),
    [anon_sym_strictfp] = ACTIONS(569),
    [anon_sym_uwtable] = ACTIONS(569),
    [anon_sym_nocf_check] = ACTIONS(569),
    [anon_sym_shadowcallstack] = ACTIONS(569),
    [anon_sym_mustprogress] = ACTIONS(569),
    [anon_sym_vscale_range] = ACTIONS(569),
    [anon_sym_preallocated] = ACTIONS(569),
    [anon_sym_zeroext] = ACTIONS(569),
    [anon_sym_signext] = ACTIONS(569),
    [anon_sym_inreg] = ACTIONS(569),
    [anon_sym_byval] = ACTIONS(569),
    [anon_sym_byref] = ACTIONS(569),
    [anon_sym_inalloca] = ACTIONS(569),
    [anon_sym_sret] = ACTIONS(569),
    [anon_sym_elementtype] = ACTIONS(569),
    [anon_sym_noalias] = ACTIONS(569),
    [anon_sym_nocapture] = ACTIONS(569),
    [anon_sym_nest] = ACTIONS(569),
    [anon_sym_returned] = ACTIONS(569),
    [anon_sym_nonnull] = ACTIONS(569),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(569),
    [anon_sym_swiftself] = ACTIONS(571),
    [anon_sym_swiftasync] = ACTIONS(571),
    [anon_sym_swifterror] = ACTIONS(571),
    [anon_sym_immarg] = ACTIONS(569),
    [anon_sym_noundef] = ACTIONS(569),
    [anon_sym_to] = ACTIONS(571),
    [anon_sym_unwind] = ACTIONS(569),
    [anon_sym_unordered] = ACTIONS(569),
    [anon_sym_monotonic] = ACTIONS(569),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_release] = ACTIONS(569),
    [anon_sym_acq_rel] = ACTIONS(569),
    [anon_sym_seq_cst] = ACTIONS(569),
    [anon_sym_syncscope] = ACTIONS(569),
    [anon_sym_uselistorder] = ACTIONS(571),
    [anon_sym_uselistorder_bb] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_attributes] = ACTIONS(569),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(573),
    [sym_global_var] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [aux_sym_metadata_ref_token1] = ACTIONS(573),
    [sym_summary_ref] = ACTIONS(573),
    [sym_string] = ACTIONS(573),
    [anon_sym_target] = ACTIONS(573),
    [anon_sym_source_filename] = ACTIONS(573),
    [anon_sym_declare] = ACTIONS(573),
    [anon_sym_define] = ACTIONS(573),
    [anon_sym_no_cfi] = ACTIONS(573),
    [anon_sym_private] = ACTIONS(573),
    [anon_sym_internal] = ACTIONS(573),
    [anon_sym_weak] = ACTIONS(575),
    [anon_sym_weak_odr] = ACTIONS(573),
    [anon_sym_linkonce] = ACTIONS(575),
    [anon_sym_linkonce_odr] = ACTIONS(573),
    [anon_sym_available_externally] = ACTIONS(573),
    [anon_sym_appending] = ACTIONS(573),
    [anon_sym_common] = ACTIONS(573),
    [anon_sym_extern_weak] = ACTIONS(573),
    [anon_sym_external] = ACTIONS(573),
    [anon_sym_dso_local] = ACTIONS(575),
    [anon_sym_dso_local_equivalent] = ACTIONS(573),
    [anon_sym_dso_preemptable] = ACTIONS(573),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_hidden] = ACTIONS(573),
    [anon_sym_protected] = ACTIONS(573),
    [anon_sym_dllimport] = ACTIONS(573),
    [anon_sym_dllexport] = ACTIONS(573),
    [anon_sym_ccc] = ACTIONS(573),
    [anon_sym_fastcc] = ACTIONS(573),
    [anon_sym_coldcc] = ACTIONS(573),
    [anon_sym_webkit_jscc] = ACTIONS(575),
    [anon_sym_anyregcc] = ACTIONS(573),
    [anon_sym_preserve_mostcc] = ACTIONS(573),
    [anon_sym_preserve_allcc] = ACTIONS(573),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(575),
    [anon_sym_tailcc] = ACTIONS(573),
    [anon_sym_swiftcc] = ACTIONS(575),
    [anon_sym_swifttailcc] = ACTIONS(575),
    [anon_sym_cfguard_checkcc] = ACTIONS(573),
    [aux_sym_calling_conv_token1] = ACTIONS(575),
    [aux_sym_calling_conv_token2] = ACTIONS(573),
    [aux_sym_calling_conv_token3] = ACTIONS(573),
    [aux_sym_calling_conv_token4] = ACTIONS(573),
    [aux_sym_calling_conv_token5] = ACTIONS(573),
    [aux_sym_calling_conv_token6] = ACTIONS(573),
    [aux_sym_calling_conv_token7] = ACTIONS(573),
    [aux_sym_calling_conv_token8] = ACTIONS(573),
    [aux_sym_calling_conv_token9] = ACTIONS(573),
    [aux_sym_calling_conv_token10] = ACTIONS(575),
    [anon_sym_ghccc] = ACTIONS(573),
    [aux_sym_calling_conv_token11] = ACTIONS(575),
    [aux_sym_calling_conv_token12] = ACTIONS(573),
    [aux_sym_calling_conv_token13] = ACTIONS(575),
    [aux_sym_calling_conv_token14] = ACTIONS(573),
    [anon_sym_cc] = ACTIONS(575),
    [anon_sym_unnamed_addr] = ACTIONS(573),
    [anon_sym_local_unnamed_addr] = ACTIONS(573),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_half] = ACTIONS(573),
    [anon_sym_bfloat] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_double] = ACTIONS(573),
    [anon_sym_x86_fp80] = ACTIONS(575),
    [anon_sym_fp128] = ACTIONS(573),
    [anon_sym_ppc_fp128] = ACTIONS(573),
    [anon_sym_label] = ACTIONS(573),
    [anon_sym_metadata] = ACTIONS(573),
    [anon_sym_x86_mmx] = ACTIONS(575),
    [anon_sym_x86_amx] = ACTIONS(575),
    [anon_sym_token] = ACTIONS(573),
    [anon_sym_opaque] = ACTIONS(573),
    [anon_sym_ptr] = ACTIONS(573),
    [aux_sym_type_keyword_token1] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LT_LBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_alignstack] = ACTIONS(573),
    [anon_sym_allocsize] = ACTIONS(573),
    [anon_sym_alwaysinline] = ACTIONS(573),
    [anon_sym_builtin] = ACTIONS(573),
    [anon_sym_cold] = ACTIONS(575),
    [anon_sym_convergent] = ACTIONS(573),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(573),
    [anon_sym_hot] = ACTIONS(573),
    [anon_sym_inaccessiblememonly] = ACTIONS(573),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(573),
    [anon_sym_inlinehint] = ACTIONS(573),
    [anon_sym_jumptable] = ACTIONS(573),
    [anon_sym_minsize] = ACTIONS(573),
    [anon_sym_naked] = ACTIONS(573),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(573),
    [anon_sym_nobuiltin] = ACTIONS(573),
    [anon_sym_noduplicate] = ACTIONS(573),
    [anon_sym_nofree] = ACTIONS(573),
    [anon_sym_noimplicitfloat] = ACTIONS(573),
    [anon_sym_noinline] = ACTIONS(573),
    [anon_sym_nomerge] = ACTIONS(573),
    [anon_sym_nonlazybind] = ACTIONS(573),
    [anon_sym_noprofile] = ACTIONS(573),
    [anon_sym_noredzone] = ACTIONS(573),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(573),
    [anon_sym_noreturn] = ACTIONS(573),
    [anon_sym_norecurse] = ACTIONS(573),
    [anon_sym_willreturn] = ACTIONS(573),
    [anon_sym_nosync] = ACTIONS(573),
    [anon_sym_nounwind] = ACTIONS(573),
    [anon_sym_nosanitize_coverage] = ACTIONS(573),
    [anon_sym_null_pointer_is_valid] = ACTIONS(573),
    [anon_sym_optforfuzzing] = ACTIONS(573),
    [anon_sym_optnone] = ACTIONS(573),
    [anon_sym_optsize] = ACTIONS(573),
    [anon_sym_readnone] = ACTIONS(573),
    [anon_sym_readonly] = ACTIONS(573),
    [anon_sym_writeonly] = ACTIONS(573),
    [anon_sym_argmemonly] = ACTIONS(573),
    [anon_sym_returns_twice] = ACTIONS(573),
    [anon_sym_safestack] = ACTIONS(573),
    [anon_sym_sanitize_address] = ACTIONS(573),
    [anon_sym_sanitize_memory] = ACTIONS(573),
    [anon_sym_sanitize_thread] = ACTIONS(573),
    [anon_sym_sanitize_hwaddress] = ACTIONS(573),
    [anon_sym_sanitize_memtag] = ACTIONS(573),
    [anon_sym_speculative_load_hardening] = ACTIONS(573),
    [anon_sym_speculatable] = ACTIONS(573),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(573),
    [anon_sym_sspreq] = ACTIONS(573),
    [anon_sym_strictfp] = ACTIONS(573),
    [anon_sym_uwtable] = ACTIONS(573),
    [anon_sym_nocf_check] = ACTIONS(573),
    [anon_sym_shadowcallstack] = ACTIONS(573),
    [anon_sym_mustprogress] = ACTIONS(573),
    [anon_sym_vscale_range] = ACTIONS(573),
    [anon_sym_preallocated] = ACTIONS(573),
    [anon_sym_zeroext] = ACTIONS(573),
    [anon_sym_signext] = ACTIONS(573),
    [anon_sym_inreg] = ACTIONS(573),
    [anon_sym_byval] = ACTIONS(573),
    [anon_sym_byref] = ACTIONS(573),
    [anon_sym_inalloca] = ACTIONS(573),
    [anon_sym_sret] = ACTIONS(573),
    [anon_sym_elementtype] = ACTIONS(573),
    [anon_sym_noalias] = ACTIONS(573),
    [anon_sym_nocapture] = ACTIONS(573),
    [anon_sym_nest] = ACTIONS(573),
    [anon_sym_returned] = ACTIONS(573),
    [anon_sym_nonnull] = ACTIONS(573),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(573),
    [anon_sym_swiftself] = ACTIONS(575),
    [anon_sym_swiftasync] = ACTIONS(575),
    [anon_sym_swifterror] = ACTIONS(575),
    [anon_sym_immarg] = ACTIONS(573),
    [anon_sym_noundef] = ACTIONS(573),
    [anon_sym_to] = ACTIONS(575),
    [anon_sym_unwind] = ACTIONS(573),
    [anon_sym_unordered] = ACTIONS(573),
    [anon_sym_monotonic] = ACTIONS(573),
    [anon_sym_acquire] = ACTIONS(573),
    [anon_sym_release] = ACTIONS(573),
    [anon_sym_acq_rel] = ACTIONS(573),
    [anon_sym_seq_cst] = ACTIONS(573),
    [anon_sym_syncscope] = ACTIONS(573),
    [anon_sym_uselistorder] = ACTIONS(575),
    [anon_sym_uselistorder_bb] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_attributes] = ACTIONS(573),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(577),
    [sym_global_var] = ACTIONS(577),
    [sym_local_var] = ACTIONS(577),
    [aux_sym_metadata_ref_token1] = ACTIONS(577),
    [sym_summary_ref] = ACTIONS(577),
    [sym_string] = ACTIONS(577),
    [anon_sym_target] = ACTIONS(577),
    [anon_sym_source_filename] = ACTIONS(577),
    [anon_sym_declare] = ACTIONS(577),
    [anon_sym_define] = ACTIONS(577),
    [anon_sym_no_cfi] = ACTIONS(577),
    [anon_sym_private] = ACTIONS(577),
    [anon_sym_internal] = ACTIONS(577),
    [anon_sym_weak] = ACTIONS(579),
    [anon_sym_weak_odr] = ACTIONS(577),
    [anon_sym_linkonce] = ACTIONS(579),
    [anon_sym_linkonce_odr] = ACTIONS(577),
    [anon_sym_available_externally] = ACTIONS(577),
    [anon_sym_appending] = ACTIONS(577),
    [anon_sym_common] = ACTIONS(577),
    [anon_sym_extern_weak] = ACTIONS(577),
    [anon_sym_external] = ACTIONS(577),
    [anon_sym_dso_local] = ACTIONS(579),
    [anon_sym_dso_local_equivalent] = ACTIONS(577),
    [anon_sym_dso_preemptable] = ACTIONS(577),
    [anon_sym_default] = ACTIONS(577),
    [anon_sym_hidden] = ACTIONS(577),
    [anon_sym_protected] = ACTIONS(577),
    [anon_sym_dllimport] = ACTIONS(577),
    [anon_sym_dllexport] = ACTIONS(577),
    [anon_sym_ccc] = ACTIONS(577),
    [anon_sym_fastcc] = ACTIONS(577),
    [anon_sym_coldcc] = ACTIONS(577),
    [anon_sym_webkit_jscc] = ACTIONS(579),
    [anon_sym_anyregcc] = ACTIONS(577),
    [anon_sym_preserve_mostcc] = ACTIONS(577),
    [anon_sym_preserve_allcc] = ACTIONS(577),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(579),
    [anon_sym_tailcc] = ACTIONS(577),
    [anon_sym_swiftcc] = ACTIONS(579),
    [anon_sym_swifttailcc] = ACTIONS(579),
    [anon_sym_cfguard_checkcc] = ACTIONS(577),
    [aux_sym_calling_conv_token1] = ACTIONS(579),
    [aux_sym_calling_conv_token2] = ACTIONS(577),
    [aux_sym_calling_conv_token3] = ACTIONS(577),
    [aux_sym_calling_conv_token4] = ACTIONS(577),
    [aux_sym_calling_conv_token5] = ACTIONS(577),
    [aux_sym_calling_conv_token6] = ACTIONS(577),
    [aux_sym_calling_conv_token7] = ACTIONS(577),
    [aux_sym_calling_conv_token8] = ACTIONS(577),
    [aux_sym_calling_conv_token9] = ACTIONS(577),
    [aux_sym_calling_conv_token10] = ACTIONS(579),
    [anon_sym_ghccc] = ACTIONS(577),
    [aux_sym_calling_conv_token11] = ACTIONS(579),
    [aux_sym_calling_conv_token12] = ACTIONS(577),
    [aux_sym_calling_conv_token13] = ACTIONS(579),
    [aux_sym_calling_conv_token14] = ACTIONS(577),
    [anon_sym_cc] = ACTIONS(579),
    [anon_sym_unnamed_addr] = ACTIONS(577),
    [anon_sym_local_unnamed_addr] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_half] = ACTIONS(577),
    [anon_sym_bfloat] = ACTIONS(577),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_double] = ACTIONS(577),
    [anon_sym_x86_fp80] = ACTIONS(579),
    [anon_sym_fp128] = ACTIONS(577),
    [anon_sym_ppc_fp128] = ACTIONS(577),
    [anon_sym_label] = ACTIONS(577),
    [anon_sym_metadata] = ACTIONS(577),
    [anon_sym_x86_mmx] = ACTIONS(579),
    [anon_sym_x86_amx] = ACTIONS(579),
    [anon_sym_token] = ACTIONS(577),
    [anon_sym_opaque] = ACTIONS(577),
    [anon_sym_ptr] = ACTIONS(577),
    [aux_sym_type_keyword_token1] = ACTIONS(577),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_LT_LBRACE] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(577),
    [anon_sym_align] = ACTIONS(579),
    [anon_sym_alignstack] = ACTIONS(577),
    [anon_sym_allocsize] = ACTIONS(577),
    [anon_sym_alwaysinline] = ACTIONS(577),
    [anon_sym_builtin] = ACTIONS(577),
    [anon_sym_cold] = ACTIONS(579),
    [anon_sym_convergent] = ACTIONS(577),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(577),
    [anon_sym_hot] = ACTIONS(577),
    [anon_sym_inaccessiblememonly] = ACTIONS(577),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(577),
    [anon_sym_inlinehint] = ACTIONS(577),
    [anon_sym_jumptable] = ACTIONS(577),
    [anon_sym_minsize] = ACTIONS(577),
    [anon_sym_naked] = ACTIONS(577),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(577),
    [anon_sym_nobuiltin] = ACTIONS(577),
    [anon_sym_noduplicate] = ACTIONS(577),
    [anon_sym_nofree] = ACTIONS(577),
    [anon_sym_noimplicitfloat] = ACTIONS(577),
    [anon_sym_noinline] = ACTIONS(577),
    [anon_sym_nomerge] = ACTIONS(577),
    [anon_sym_nonlazybind] = ACTIONS(577),
    [anon_sym_noprofile] = ACTIONS(577),
    [anon_sym_noredzone] = ACTIONS(577),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(577),
    [anon_sym_noreturn] = ACTIONS(577),
    [anon_sym_norecurse] = ACTIONS(577),
    [anon_sym_willreturn] = ACTIONS(577),
    [anon_sym_nosync] = ACTIONS(577),
    [anon_sym_nounwind] = ACTIONS(577),
    [anon_sym_nosanitize_coverage] = ACTIONS(577),
    [anon_sym_null_pointer_is_valid] = ACTIONS(577),
    [anon_sym_optforfuzzing] = ACTIONS(577),
    [anon_sym_optnone] = ACTIONS(577),
    [anon_sym_optsize] = ACTIONS(577),
    [anon_sym_readnone] = ACTIONS(577),
    [anon_sym_readonly] = ACTIONS(577),
    [anon_sym_writeonly] = ACTIONS(577),
    [anon_sym_argmemonly] = ACTIONS(577),
    [anon_sym_returns_twice] = ACTIONS(577),
    [anon_sym_safestack] = ACTIONS(577),
    [anon_sym_sanitize_address] = ACTIONS(577),
    [anon_sym_sanitize_memory] = ACTIONS(577),
    [anon_sym_sanitize_thread] = ACTIONS(577),
    [anon_sym_sanitize_hwaddress] = ACTIONS(577),
    [anon_sym_sanitize_memtag] = ACTIONS(577),
    [anon_sym_speculative_load_hardening] = ACTIONS(577),
    [anon_sym_speculatable] = ACTIONS(577),
    [anon_sym_ssp] = ACTIONS(579),
    [anon_sym_sspstrong] = ACTIONS(577),
    [anon_sym_sspreq] = ACTIONS(577),
    [anon_sym_strictfp] = ACTIONS(577),
    [anon_sym_uwtable] = ACTIONS(577),
    [anon_sym_nocf_check] = ACTIONS(577),
    [anon_sym_shadowcallstack] = ACTIONS(577),
    [anon_sym_mustprogress] = ACTIONS(577),
    [anon_sym_vscale_range] = ACTIONS(577),
    [anon_sym_preallocated] = ACTIONS(577),
    [anon_sym_zeroext] = ACTIONS(577),
    [anon_sym_signext] = ACTIONS(577),
    [anon_sym_inreg] = ACTIONS(577),
    [anon_sym_byval] = ACTIONS(577),
    [anon_sym_byref] = ACTIONS(577),
    [anon_sym_inalloca] = ACTIONS(577),
    [anon_sym_sret] = ACTIONS(577),
    [anon_sym_elementtype] = ACTIONS(577),
    [anon_sym_noalias] = ACTIONS(577),
    [anon_sym_nocapture] = ACTIONS(577),
    [anon_sym_nest] = ACTIONS(577),
    [anon_sym_returned] = ACTIONS(577),
    [anon_sym_nonnull] = ACTIONS(577),
    [anon_sym_dereferenceable] = ACTIONS(579),
    [anon_sym_dereferenceable_or_null] = ACTIONS(577),
    [anon_sym_swiftself] = ACTIONS(579),
    [anon_sym_swiftasync] = ACTIONS(579),
    [anon_sym_swifterror] = ACTIONS(579),
    [anon_sym_immarg] = ACTIONS(577),
    [anon_sym_noundef] = ACTIONS(577),
    [anon_sym_to] = ACTIONS(579),
    [anon_sym_unwind] = ACTIONS(577),
    [anon_sym_unordered] = ACTIONS(577),
    [anon_sym_monotonic] = ACTIONS(577),
    [anon_sym_acquire] = ACTIONS(577),
    [anon_sym_release] = ACTIONS(577),
    [anon_sym_acq_rel] = ACTIONS(577),
    [anon_sym_seq_cst] = ACTIONS(577),
    [anon_sym_syncscope] = ACTIONS(577),
    [anon_sym_uselistorder] = ACTIONS(579),
    [anon_sym_uselistorder_bb] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_attributes] = ACTIONS(577),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(581),
    [sym_global_var] = ACTIONS(581),
    [sym_local_var] = ACTIONS(581),
    [aux_sym_metadata_ref_token1] = ACTIONS(581),
    [sym_summary_ref] = ACTIONS(581),
    [sym_string] = ACTIONS(581),
    [anon_sym_target] = ACTIONS(581),
    [anon_sym_source_filename] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(581),
    [anon_sym_define] = ACTIONS(581),
    [anon_sym_no_cfi] = ACTIONS(581),
    [anon_sym_private] = ACTIONS(581),
    [anon_sym_internal] = ACTIONS(581),
    [anon_sym_weak] = ACTIONS(583),
    [anon_sym_weak_odr] = ACTIONS(581),
    [anon_sym_linkonce] = ACTIONS(583),
    [anon_sym_linkonce_odr] = ACTIONS(581),
    [anon_sym_available_externally] = ACTIONS(581),
    [anon_sym_appending] = ACTIONS(581),
    [anon_sym_common] = ACTIONS(581),
    [anon_sym_extern_weak] = ACTIONS(581),
    [anon_sym_external] = ACTIONS(581),
    [anon_sym_dso_local] = ACTIONS(583),
    [anon_sym_dso_local_equivalent] = ACTIONS(581),
    [anon_sym_dso_preemptable] = ACTIONS(581),
    [anon_sym_default] = ACTIONS(581),
    [anon_sym_hidden] = ACTIONS(581),
    [anon_sym_protected] = ACTIONS(581),
    [anon_sym_dllimport] = ACTIONS(581),
    [anon_sym_dllexport] = ACTIONS(581),
    [anon_sym_ccc] = ACTIONS(581),
    [anon_sym_fastcc] = ACTIONS(581),
    [anon_sym_coldcc] = ACTIONS(581),
    [anon_sym_webkit_jscc] = ACTIONS(583),
    [anon_sym_anyregcc] = ACTIONS(581),
    [anon_sym_preserve_mostcc] = ACTIONS(581),
    [anon_sym_preserve_allcc] = ACTIONS(581),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(583),
    [anon_sym_tailcc] = ACTIONS(581),
    [anon_sym_swiftcc] = ACTIONS(583),
    [anon_sym_swifttailcc] = ACTIONS(583),
    [anon_sym_cfguard_checkcc] = ACTIONS(581),
    [aux_sym_calling_conv_token1] = ACTIONS(583),
    [aux_sym_calling_conv_token2] = ACTIONS(581),
    [aux_sym_calling_conv_token3] = ACTIONS(581),
    [aux_sym_calling_conv_token4] = ACTIONS(581),
    [aux_sym_calling_conv_token5] = ACTIONS(581),
    [aux_sym_calling_conv_token6] = ACTIONS(581),
    [aux_sym_calling_conv_token7] = ACTIONS(581),
    [aux_sym_calling_conv_token8] = ACTIONS(581),
    [aux_sym_calling_conv_token9] = ACTIONS(581),
    [aux_sym_calling_conv_token10] = ACTIONS(583),
    [anon_sym_ghccc] = ACTIONS(581),
    [aux_sym_calling_conv_token11] = ACTIONS(583),
    [aux_sym_calling_conv_token12] = ACTIONS(581),
    [aux_sym_calling_conv_token13] = ACTIONS(583),
    [aux_sym_calling_conv_token14] = ACTIONS(581),
    [anon_sym_cc] = ACTIONS(583),
    [anon_sym_unnamed_addr] = ACTIONS(581),
    [anon_sym_local_unnamed_addr] = ACTIONS(581),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_half] = ACTIONS(581),
    [anon_sym_bfloat] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_double] = ACTIONS(581),
    [anon_sym_x86_fp80] = ACTIONS(583),
    [anon_sym_fp128] = ACTIONS(581),
    [anon_sym_ppc_fp128] = ACTIONS(581),
    [anon_sym_label] = ACTIONS(581),
    [anon_sym_metadata] = ACTIONS(581),
    [anon_sym_x86_mmx] = ACTIONS(583),
    [anon_sym_x86_amx] = ACTIONS(583),
    [anon_sym_token] = ACTIONS(581),
    [anon_sym_opaque] = ACTIONS(581),
    [anon_sym_ptr] = ACTIONS(581),
    [aux_sym_type_keyword_token1] = ACTIONS(581),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_LT_LBRACE] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_RBRACK] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(581),
    [anon_sym_LPAREN] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(581),
    [anon_sym_align] = ACTIONS(583),
    [anon_sym_alignstack] = ACTIONS(581),
    [anon_sym_allocsize] = ACTIONS(581),
    [anon_sym_alwaysinline] = ACTIONS(581),
    [anon_sym_builtin] = ACTIONS(581),
    [anon_sym_cold] = ACTIONS(583),
    [anon_sym_convergent] = ACTIONS(581),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(581),
    [anon_sym_hot] = ACTIONS(581),
    [anon_sym_inaccessiblememonly] = ACTIONS(581),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(581),
    [anon_sym_inlinehint] = ACTIONS(581),
    [anon_sym_jumptable] = ACTIONS(581),
    [anon_sym_minsize] = ACTIONS(581),
    [anon_sym_naked] = ACTIONS(581),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(581),
    [anon_sym_nobuiltin] = ACTIONS(581),
    [anon_sym_noduplicate] = ACTIONS(581),
    [anon_sym_nofree] = ACTIONS(581),
    [anon_sym_noimplicitfloat] = ACTIONS(581),
    [anon_sym_noinline] = ACTIONS(581),
    [anon_sym_nomerge] = ACTIONS(581),
    [anon_sym_nonlazybind] = ACTIONS(581),
    [anon_sym_noprofile] = ACTIONS(581),
    [anon_sym_noredzone] = ACTIONS(581),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(581),
    [anon_sym_noreturn] = ACTIONS(581),
    [anon_sym_norecurse] = ACTIONS(581),
    [anon_sym_willreturn] = ACTIONS(581),
    [anon_sym_nosync] = ACTIONS(581),
    [anon_sym_nounwind] = ACTIONS(581),
    [anon_sym_nosanitize_coverage] = ACTIONS(581),
    [anon_sym_null_pointer_is_valid] = ACTIONS(581),
    [anon_sym_optforfuzzing] = ACTIONS(581),
    [anon_sym_optnone] = ACTIONS(581),
    [anon_sym_optsize] = ACTIONS(581),
    [anon_sym_readnone] = ACTIONS(581),
    [anon_sym_readonly] = ACTIONS(581),
    [anon_sym_writeonly] = ACTIONS(581),
    [anon_sym_argmemonly] = ACTIONS(581),
    [anon_sym_returns_twice] = ACTIONS(581),
    [anon_sym_safestack] = ACTIONS(581),
    [anon_sym_sanitize_address] = ACTIONS(581),
    [anon_sym_sanitize_memory] = ACTIONS(581),
    [anon_sym_sanitize_thread] = ACTIONS(581),
    [anon_sym_sanitize_hwaddress] = ACTIONS(581),
    [anon_sym_sanitize_memtag] = ACTIONS(581),
    [anon_sym_speculative_load_hardening] = ACTIONS(581),
    [anon_sym_speculatable] = ACTIONS(581),
    [anon_sym_ssp] = ACTIONS(583),
    [anon_sym_sspstrong] = ACTIONS(581),
    [anon_sym_sspreq] = ACTIONS(581),
    [anon_sym_strictfp] = ACTIONS(581),
    [anon_sym_uwtable] = ACTIONS(581),
    [anon_sym_nocf_check] = ACTIONS(581),
    [anon_sym_shadowcallstack] = ACTIONS(581),
    [anon_sym_mustprogress] = ACTIONS(581),
    [anon_sym_vscale_range] = ACTIONS(581),
    [anon_sym_preallocated] = ACTIONS(581),
    [anon_sym_zeroext] = ACTIONS(581),
    [anon_sym_signext] = ACTIONS(581),
    [anon_sym_inreg] = ACTIONS(581),
    [anon_sym_byval] = ACTIONS(581),
    [anon_sym_byref] = ACTIONS(581),
    [anon_sym_inalloca] = ACTIONS(581),
    [anon_sym_sret] = ACTIONS(581),
    [anon_sym_elementtype] = ACTIONS(581),
    [anon_sym_noalias] = ACTIONS(581),
    [anon_sym_nocapture] = ACTIONS(581),
    [anon_sym_nest] = ACTIONS(581),
    [anon_sym_returned] = ACTIONS(581),
    [anon_sym_nonnull] = ACTIONS(581),
    [anon_sym_dereferenceable] = ACTIONS(583),
    [anon_sym_dereferenceable_or_null] = ACTIONS(581),
    [anon_sym_swiftself] = ACTIONS(583),
    [anon_sym_swiftasync] = ACTIONS(583),
    [anon_sym_swifterror] = ACTIONS(583),
    [anon_sym_immarg] = ACTIONS(581),
    [anon_sym_noundef] = ACTIONS(581),
    [anon_sym_to] = ACTIONS(583),
    [anon_sym_unwind] = ACTIONS(581),
    [anon_sym_unordered] = ACTIONS(581),
    [anon_sym_monotonic] = ACTIONS(581),
    [anon_sym_acquire] = ACTIONS(581),
    [anon_sym_release] = ACTIONS(581),
    [anon_sym_acq_rel] = ACTIONS(581),
    [anon_sym_seq_cst] = ACTIONS(581),
    [anon_sym_syncscope] = ACTIONS(581),
    [anon_sym_uselistorder] = ACTIONS(583),
    [anon_sym_uselistorder_bb] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_attributes] = ACTIONS(581),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(585),
    [sym_global_var] = ACTIONS(585),
    [sym_local_var] = ACTIONS(585),
    [aux_sym_metadata_ref_token1] = ACTIONS(585),
    [sym_summary_ref] = ACTIONS(585),
    [sym_string] = ACTIONS(585),
    [anon_sym_target] = ACTIONS(585),
    [anon_sym_source_filename] = ACTIONS(585),
    [anon_sym_declare] = ACTIONS(585),
    [anon_sym_define] = ACTIONS(585),
    [anon_sym_no_cfi] = ACTIONS(585),
    [anon_sym_private] = ACTIONS(585),
    [anon_sym_internal] = ACTIONS(585),
    [anon_sym_weak] = ACTIONS(587),
    [anon_sym_weak_odr] = ACTIONS(585),
    [anon_sym_linkonce] = ACTIONS(587),
    [anon_sym_linkonce_odr] = ACTIONS(585),
    [anon_sym_available_externally] = ACTIONS(585),
    [anon_sym_appending] = ACTIONS(585),
    [anon_sym_common] = ACTIONS(585),
    [anon_sym_extern_weak] = ACTIONS(585),
    [anon_sym_external] = ACTIONS(585),
    [anon_sym_dso_local] = ACTIONS(587),
    [anon_sym_dso_local_equivalent] = ACTIONS(585),
    [anon_sym_dso_preemptable] = ACTIONS(585),
    [anon_sym_default] = ACTIONS(585),
    [anon_sym_hidden] = ACTIONS(585),
    [anon_sym_protected] = ACTIONS(585),
    [anon_sym_dllimport] = ACTIONS(585),
    [anon_sym_dllexport] = ACTIONS(585),
    [anon_sym_ccc] = ACTIONS(585),
    [anon_sym_fastcc] = ACTIONS(585),
    [anon_sym_coldcc] = ACTIONS(585),
    [anon_sym_webkit_jscc] = ACTIONS(587),
    [anon_sym_anyregcc] = ACTIONS(585),
    [anon_sym_preserve_mostcc] = ACTIONS(585),
    [anon_sym_preserve_allcc] = ACTIONS(585),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(587),
    [anon_sym_tailcc] = ACTIONS(585),
    [anon_sym_swiftcc] = ACTIONS(587),
    [anon_sym_swifttailcc] = ACTIONS(587),
    [anon_sym_cfguard_checkcc] = ACTIONS(585),
    [aux_sym_calling_conv_token1] = ACTIONS(587),
    [aux_sym_calling_conv_token2] = ACTIONS(585),
    [aux_sym_calling_conv_token3] = ACTIONS(585),
    [aux_sym_calling_conv_token4] = ACTIONS(585),
    [aux_sym_calling_conv_token5] = ACTIONS(585),
    [aux_sym_calling_conv_token6] = ACTIONS(585),
    [aux_sym_calling_conv_token7] = ACTIONS(585),
    [aux_sym_calling_conv_token8] = ACTIONS(585),
    [aux_sym_calling_conv_token9] = ACTIONS(585),
    [aux_sym_calling_conv_token10] = ACTIONS(587),
    [anon_sym_ghccc] = ACTIONS(585),
    [aux_sym_calling_conv_token11] = ACTIONS(587),
    [aux_sym_calling_conv_token12] = ACTIONS(585),
    [aux_sym_calling_conv_token13] = ACTIONS(587),
    [aux_sym_calling_conv_token14] = ACTIONS(585),
    [anon_sym_cc] = ACTIONS(587),
    [anon_sym_unnamed_addr] = ACTIONS(585),
    [anon_sym_local_unnamed_addr] = ACTIONS(585),
    [anon_sym_void] = ACTIONS(585),
    [anon_sym_half] = ACTIONS(585),
    [anon_sym_bfloat] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(585),
    [anon_sym_double] = ACTIONS(585),
    [anon_sym_x86_fp80] = ACTIONS(587),
    [anon_sym_fp128] = ACTIONS(585),
    [anon_sym_ppc_fp128] = ACTIONS(585),
    [anon_sym_label] = ACTIONS(585),
    [anon_sym_metadata] = ACTIONS(585),
    [anon_sym_x86_mmx] = ACTIONS(587),
    [anon_sym_x86_amx] = ACTIONS(587),
    [anon_sym_token] = ACTIONS(585),
    [anon_sym_opaque] = ACTIONS(585),
    [anon_sym_ptr] = ACTIONS(585),
    [aux_sym_type_keyword_token1] = ACTIONS(585),
    [anon_sym_LBRACE] = ACTIONS(585),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LT_LBRACE] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(587),
    [anon_sym_GT] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_align] = ACTIONS(587),
    [anon_sym_alignstack] = ACTIONS(585),
    [anon_sym_allocsize] = ACTIONS(585),
    [anon_sym_alwaysinline] = ACTIONS(585),
    [anon_sym_builtin] = ACTIONS(585),
    [anon_sym_cold] = ACTIONS(587),
    [anon_sym_convergent] = ACTIONS(585),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(585),
    [anon_sym_hot] = ACTIONS(585),
    [anon_sym_inaccessiblememonly] = ACTIONS(585),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(585),
    [anon_sym_inlinehint] = ACTIONS(585),
    [anon_sym_jumptable] = ACTIONS(585),
    [anon_sym_minsize] = ACTIONS(585),
    [anon_sym_naked] = ACTIONS(585),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(585),
    [anon_sym_nobuiltin] = ACTIONS(585),
    [anon_sym_noduplicate] = ACTIONS(585),
    [anon_sym_nofree] = ACTIONS(585),
    [anon_sym_noimplicitfloat] = ACTIONS(585),
    [anon_sym_noinline] = ACTIONS(585),
    [anon_sym_nomerge] = ACTIONS(585),
    [anon_sym_nonlazybind] = ACTIONS(585),
    [anon_sym_noprofile] = ACTIONS(585),
    [anon_sym_noredzone] = ACTIONS(585),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(585),
    [anon_sym_noreturn] = ACTIONS(585),
    [anon_sym_norecurse] = ACTIONS(585),
    [anon_sym_willreturn] = ACTIONS(585),
    [anon_sym_nosync] = ACTIONS(585),
    [anon_sym_nounwind] = ACTIONS(585),
    [anon_sym_nosanitize_coverage] = ACTIONS(585),
    [anon_sym_null_pointer_is_valid] = ACTIONS(585),
    [anon_sym_optforfuzzing] = ACTIONS(585),
    [anon_sym_optnone] = ACTIONS(585),
    [anon_sym_optsize] = ACTIONS(585),
    [anon_sym_readnone] = ACTIONS(585),
    [anon_sym_readonly] = ACTIONS(585),
    [anon_sym_writeonly] = ACTIONS(585),
    [anon_sym_argmemonly] = ACTIONS(585),
    [anon_sym_returns_twice] = ACTIONS(585),
    [anon_sym_safestack] = ACTIONS(585),
    [anon_sym_sanitize_address] = ACTIONS(585),
    [anon_sym_sanitize_memory] = ACTIONS(585),
    [anon_sym_sanitize_thread] = ACTIONS(585),
    [anon_sym_sanitize_hwaddress] = ACTIONS(585),
    [anon_sym_sanitize_memtag] = ACTIONS(585),
    [anon_sym_speculative_load_hardening] = ACTIONS(585),
    [anon_sym_speculatable] = ACTIONS(585),
    [anon_sym_ssp] = ACTIONS(587),
    [anon_sym_sspstrong] = ACTIONS(585),
    [anon_sym_sspreq] = ACTIONS(585),
    [anon_sym_strictfp] = ACTIONS(585),
    [anon_sym_uwtable] = ACTIONS(585),
    [anon_sym_nocf_check] = ACTIONS(585),
    [anon_sym_shadowcallstack] = ACTIONS(585),
    [anon_sym_mustprogress] = ACTIONS(585),
    [anon_sym_vscale_range] = ACTIONS(585),
    [anon_sym_preallocated] = ACTIONS(585),
    [anon_sym_zeroext] = ACTIONS(585),
    [anon_sym_signext] = ACTIONS(585),
    [anon_sym_inreg] = ACTIONS(585),
    [anon_sym_byval] = ACTIONS(585),
    [anon_sym_byref] = ACTIONS(585),
    [anon_sym_inalloca] = ACTIONS(585),
    [anon_sym_sret] = ACTIONS(585),
    [anon_sym_elementtype] = ACTIONS(585),
    [anon_sym_noalias] = ACTIONS(585),
    [anon_sym_nocapture] = ACTIONS(585),
    [anon_sym_nest] = ACTIONS(585),
    [anon_sym_returned] = ACTIONS(585),
    [anon_sym_nonnull] = ACTIONS(585),
    [anon_sym_dereferenceable] = ACTIONS(587),
    [anon_sym_dereferenceable_or_null] = ACTIONS(585),
    [anon_sym_swiftself] = ACTIONS(587),
    [anon_sym_swiftasync] = ACTIONS(587),
    [anon_sym_swifterror] = ACTIONS(587),
    [anon_sym_immarg] = ACTIONS(585),
    [anon_sym_noundef] = ACTIONS(585),
    [anon_sym_to] = ACTIONS(587),
    [anon_sym_unwind] = ACTIONS(585),
    [anon_sym_unordered] = ACTIONS(585),
    [anon_sym_monotonic] = ACTIONS(585),
    [anon_sym_acquire] = ACTIONS(585),
    [anon_sym_release] = ACTIONS(585),
    [anon_sym_acq_rel] = ACTIONS(585),
    [anon_sym_seq_cst] = ACTIONS(585),
    [anon_sym_syncscope] = ACTIONS(585),
    [anon_sym_uselistorder] = ACTIONS(587),
    [anon_sym_uselistorder_bb] = ACTIONS(585),
    [anon_sym_module] = ACTIONS(585),
    [anon_sym_LPAREN2] = ACTIONS(589),
    [anon_sym_attributes] = ACTIONS(585),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(591),
    [sym_global_var] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [aux_sym_metadata_ref_token1] = ACTIONS(591),
    [sym_summary_ref] = ACTIONS(591),
    [sym_string] = ACTIONS(591),
    [anon_sym_target] = ACTIONS(591),
    [anon_sym_source_filename] = ACTIONS(591),
    [anon_sym_declare] = ACTIONS(591),
    [anon_sym_define] = ACTIONS(591),
    [anon_sym_no_cfi] = ACTIONS(591),
    [anon_sym_private] = ACTIONS(591),
    [anon_sym_internal] = ACTIONS(591),
    [anon_sym_weak] = ACTIONS(593),
    [anon_sym_weak_odr] = ACTIONS(591),
    [anon_sym_linkonce] = ACTIONS(593),
    [anon_sym_linkonce_odr] = ACTIONS(591),
    [anon_sym_available_externally] = ACTIONS(591),
    [anon_sym_appending] = ACTIONS(591),
    [anon_sym_common] = ACTIONS(591),
    [anon_sym_extern_weak] = ACTIONS(591),
    [anon_sym_external] = ACTIONS(591),
    [anon_sym_dso_local] = ACTIONS(593),
    [anon_sym_dso_local_equivalent] = ACTIONS(591),
    [anon_sym_dso_preemptable] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_hidden] = ACTIONS(591),
    [anon_sym_protected] = ACTIONS(591),
    [anon_sym_dllimport] = ACTIONS(591),
    [anon_sym_dllexport] = ACTIONS(591),
    [anon_sym_ccc] = ACTIONS(591),
    [anon_sym_fastcc] = ACTIONS(591),
    [anon_sym_coldcc] = ACTIONS(591),
    [anon_sym_webkit_jscc] = ACTIONS(593),
    [anon_sym_anyregcc] = ACTIONS(591),
    [anon_sym_preserve_mostcc] = ACTIONS(591),
    [anon_sym_preserve_allcc] = ACTIONS(591),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(593),
    [anon_sym_tailcc] = ACTIONS(591),
    [anon_sym_swiftcc] = ACTIONS(593),
    [anon_sym_swifttailcc] = ACTIONS(593),
    [anon_sym_cfguard_checkcc] = ACTIONS(591),
    [aux_sym_calling_conv_token1] = ACTIONS(593),
    [aux_sym_calling_conv_token2] = ACTIONS(591),
    [aux_sym_calling_conv_token3] = ACTIONS(591),
    [aux_sym_calling_conv_token4] = ACTIONS(591),
    [aux_sym_calling_conv_token5] = ACTIONS(591),
    [aux_sym_calling_conv_token6] = ACTIONS(591),
    [aux_sym_calling_conv_token7] = ACTIONS(591),
    [aux_sym_calling_conv_token8] = ACTIONS(591),
    [aux_sym_calling_conv_token9] = ACTIONS(591),
    [aux_sym_calling_conv_token10] = ACTIONS(593),
    [anon_sym_ghccc] = ACTIONS(591),
    [aux_sym_calling_conv_token11] = ACTIONS(593),
    [aux_sym_calling_conv_token12] = ACTIONS(591),
    [aux_sym_calling_conv_token13] = ACTIONS(593),
    [aux_sym_calling_conv_token14] = ACTIONS(591),
    [anon_sym_cc] = ACTIONS(593),
    [anon_sym_unnamed_addr] = ACTIONS(591),
    [anon_sym_local_unnamed_addr] = ACTIONS(591),
    [anon_sym_void] = ACTIONS(591),
    [anon_sym_half] = ACTIONS(591),
    [anon_sym_bfloat] = ACTIONS(591),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_double] = ACTIONS(591),
    [anon_sym_x86_fp80] = ACTIONS(593),
    [anon_sym_fp128] = ACTIONS(591),
    [anon_sym_ppc_fp128] = ACTIONS(591),
    [anon_sym_label] = ACTIONS(591),
    [anon_sym_metadata] = ACTIONS(591),
    [anon_sym_x86_mmx] = ACTIONS(593),
    [anon_sym_x86_amx] = ACTIONS(593),
    [anon_sym_token] = ACTIONS(591),
    [anon_sym_opaque] = ACTIONS(591),
    [anon_sym_ptr] = ACTIONS(591),
    [aux_sym_type_keyword_token1] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LT_LBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_GT] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(591),
    [anon_sym_RPAREN] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_alignstack] = ACTIONS(591),
    [anon_sym_allocsize] = ACTIONS(591),
    [anon_sym_alwaysinline] = ACTIONS(591),
    [anon_sym_builtin] = ACTIONS(591),
    [anon_sym_cold] = ACTIONS(593),
    [anon_sym_convergent] = ACTIONS(591),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(591),
    [anon_sym_hot] = ACTIONS(591),
    [anon_sym_inaccessiblememonly] = ACTIONS(591),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(591),
    [anon_sym_inlinehint] = ACTIONS(591),
    [anon_sym_jumptable] = ACTIONS(591),
    [anon_sym_minsize] = ACTIONS(591),
    [anon_sym_naked] = ACTIONS(591),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(591),
    [anon_sym_nobuiltin] = ACTIONS(591),
    [anon_sym_noduplicate] = ACTIONS(591),
    [anon_sym_nofree] = ACTIONS(591),
    [anon_sym_noimplicitfloat] = ACTIONS(591),
    [anon_sym_noinline] = ACTIONS(591),
    [anon_sym_nomerge] = ACTIONS(591),
    [anon_sym_nonlazybind] = ACTIONS(591),
    [anon_sym_noprofile] = ACTIONS(591),
    [anon_sym_noredzone] = ACTIONS(591),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(591),
    [anon_sym_noreturn] = ACTIONS(591),
    [anon_sym_norecurse] = ACTIONS(591),
    [anon_sym_willreturn] = ACTIONS(591),
    [anon_sym_nosync] = ACTIONS(591),
    [anon_sym_nounwind] = ACTIONS(591),
    [anon_sym_nosanitize_coverage] = ACTIONS(591),
    [anon_sym_null_pointer_is_valid] = ACTIONS(591),
    [anon_sym_optforfuzzing] = ACTIONS(591),
    [anon_sym_optnone] = ACTIONS(591),
    [anon_sym_optsize] = ACTIONS(591),
    [anon_sym_readnone] = ACTIONS(591),
    [anon_sym_readonly] = ACTIONS(591),
    [anon_sym_writeonly] = ACTIONS(591),
    [anon_sym_argmemonly] = ACTIONS(591),
    [anon_sym_returns_twice] = ACTIONS(591),
    [anon_sym_safestack] = ACTIONS(591),
    [anon_sym_sanitize_address] = ACTIONS(591),
    [anon_sym_sanitize_memory] = ACTIONS(591),
    [anon_sym_sanitize_thread] = ACTIONS(591),
    [anon_sym_sanitize_hwaddress] = ACTIONS(591),
    [anon_sym_sanitize_memtag] = ACTIONS(591),
    [anon_sym_speculative_load_hardening] = ACTIONS(591),
    [anon_sym_speculatable] = ACTIONS(591),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(591),
    [anon_sym_sspreq] = ACTIONS(591),
    [anon_sym_strictfp] = ACTIONS(591),
    [anon_sym_uwtable] = ACTIONS(591),
    [anon_sym_nocf_check] = ACTIONS(591),
    [anon_sym_shadowcallstack] = ACTIONS(591),
    [anon_sym_mustprogress] = ACTIONS(591),
    [anon_sym_vscale_range] = ACTIONS(591),
    [anon_sym_preallocated] = ACTIONS(591),
    [anon_sym_zeroext] = ACTIONS(591),
    [anon_sym_signext] = ACTIONS(591),
    [anon_sym_inreg] = ACTIONS(591),
    [anon_sym_byval] = ACTIONS(591),
    [anon_sym_byref] = ACTIONS(591),
    [anon_sym_inalloca] = ACTIONS(591),
    [anon_sym_sret] = ACTIONS(591),
    [anon_sym_elementtype] = ACTIONS(591),
    [anon_sym_noalias] = ACTIONS(591),
    [anon_sym_nocapture] = ACTIONS(591),
    [anon_sym_nest] = ACTIONS(591),
    [anon_sym_returned] = ACTIONS(591),
    [anon_sym_nonnull] = ACTIONS(591),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(591),
    [anon_sym_swiftself] = ACTIONS(593),
    [anon_sym_swiftasync] = ACTIONS(593),
    [anon_sym_swifterror] = ACTIONS(593),
    [anon_sym_immarg] = ACTIONS(591),
    [anon_sym_noundef] = ACTIONS(591),
    [anon_sym_to] = ACTIONS(593),
    [anon_sym_unwind] = ACTIONS(591),
    [anon_sym_unordered] = ACTIONS(591),
    [anon_sym_monotonic] = ACTIONS(591),
    [anon_sym_acquire] = ACTIONS(591),
    [anon_sym_release] = ACTIONS(591),
    [anon_sym_acq_rel] = ACTIONS(591),
    [anon_sym_seq_cst] = ACTIONS(591),
    [anon_sym_syncscope] = ACTIONS(591),
    [anon_sym_uselistorder] = ACTIONS(593),
    [anon_sym_uselistorder_bb] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_attributes] = ACTIONS(591),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(595),
    [sym_global_var] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [aux_sym_metadata_ref_token1] = ACTIONS(595),
    [sym_summary_ref] = ACTIONS(595),
    [sym_string] = ACTIONS(595),
    [anon_sym_target] = ACTIONS(595),
    [anon_sym_source_filename] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_define] = ACTIONS(595),
    [anon_sym_no_cfi] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_internal] = ACTIONS(595),
    [anon_sym_weak] = ACTIONS(597),
    [anon_sym_weak_odr] = ACTIONS(595),
    [anon_sym_linkonce] = ACTIONS(597),
    [anon_sym_linkonce_odr] = ACTIONS(595),
    [anon_sym_available_externally] = ACTIONS(595),
    [anon_sym_appending] = ACTIONS(595),
    [anon_sym_common] = ACTIONS(595),
    [anon_sym_extern_weak] = ACTIONS(595),
    [anon_sym_external] = ACTIONS(595),
    [anon_sym_dso_local] = ACTIONS(597),
    [anon_sym_dso_local_equivalent] = ACTIONS(595),
    [anon_sym_dso_preemptable] = ACTIONS(595),
    [anon_sym_default] = ACTIONS(595),
    [anon_sym_hidden] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_dllimport] = ACTIONS(595),
    [anon_sym_dllexport] = ACTIONS(595),
    [anon_sym_ccc] = ACTIONS(595),
    [anon_sym_fastcc] = ACTIONS(595),
    [anon_sym_coldcc] = ACTIONS(595),
    [anon_sym_webkit_jscc] = ACTIONS(597),
    [anon_sym_anyregcc] = ACTIONS(595),
    [anon_sym_preserve_mostcc] = ACTIONS(595),
    [anon_sym_preserve_allcc] = ACTIONS(595),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(597),
    [anon_sym_tailcc] = ACTIONS(595),
    [anon_sym_swiftcc] = ACTIONS(597),
    [anon_sym_swifttailcc] = ACTIONS(597),
    [anon_sym_cfguard_checkcc] = ACTIONS(595),
    [aux_sym_calling_conv_token1] = ACTIONS(597),
    [aux_sym_calling_conv_token2] = ACTIONS(595),
    [aux_sym_calling_conv_token3] = ACTIONS(595),
    [aux_sym_calling_conv_token4] = ACTIONS(595),
    [aux_sym_calling_conv_token5] = ACTIONS(595),
    [aux_sym_calling_conv_token6] = ACTIONS(595),
    [aux_sym_calling_conv_token7] = ACTIONS(595),
    [aux_sym_calling_conv_token8] = ACTIONS(595),
    [aux_sym_calling_conv_token9] = ACTIONS(595),
    [aux_sym_calling_conv_token10] = ACTIONS(597),
    [anon_sym_ghccc] = ACTIONS(595),
    [aux_sym_calling_conv_token11] = ACTIONS(597),
    [aux_sym_calling_conv_token12] = ACTIONS(595),
    [aux_sym_calling_conv_token13] = ACTIONS(597),
    [aux_sym_calling_conv_token14] = ACTIONS(595),
    [anon_sym_cc] = ACTIONS(597),
    [anon_sym_unnamed_addr] = ACTIONS(595),
    [anon_sym_local_unnamed_addr] = ACTIONS(595),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_half] = ACTIONS(595),
    [anon_sym_bfloat] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(595),
    [anon_sym_double] = ACTIONS(595),
    [anon_sym_x86_fp80] = ACTIONS(597),
    [anon_sym_fp128] = ACTIONS(595),
    [anon_sym_ppc_fp128] = ACTIONS(595),
    [anon_sym_label] = ACTIONS(595),
    [anon_sym_metadata] = ACTIONS(595),
    [anon_sym_x86_mmx] = ACTIONS(597),
    [anon_sym_x86_amx] = ACTIONS(597),
    [anon_sym_token] = ACTIONS(595),
    [anon_sym_opaque] = ACTIONS(595),
    [anon_sym_ptr] = ACTIONS(595),
    [aux_sym_type_keyword_token1] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LT_LBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_alignstack] = ACTIONS(595),
    [anon_sym_allocsize] = ACTIONS(595),
    [anon_sym_alwaysinline] = ACTIONS(595),
    [anon_sym_builtin] = ACTIONS(595),
    [anon_sym_cold] = ACTIONS(597),
    [anon_sym_convergent] = ACTIONS(595),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(595),
    [anon_sym_hot] = ACTIONS(595),
    [anon_sym_inaccessiblememonly] = ACTIONS(595),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(595),
    [anon_sym_inlinehint] = ACTIONS(595),
    [anon_sym_jumptable] = ACTIONS(595),
    [anon_sym_minsize] = ACTIONS(595),
    [anon_sym_naked] = ACTIONS(595),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(595),
    [anon_sym_nobuiltin] = ACTIONS(595),
    [anon_sym_noduplicate] = ACTIONS(595),
    [anon_sym_nofree] = ACTIONS(595),
    [anon_sym_noimplicitfloat] = ACTIONS(595),
    [anon_sym_noinline] = ACTIONS(595),
    [anon_sym_nomerge] = ACTIONS(595),
    [anon_sym_nonlazybind] = ACTIONS(595),
    [anon_sym_noprofile] = ACTIONS(595),
    [anon_sym_noredzone] = ACTIONS(595),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(595),
    [anon_sym_noreturn] = ACTIONS(595),
    [anon_sym_norecurse] = ACTIONS(595),
    [anon_sym_willreturn] = ACTIONS(595),
    [anon_sym_nosync] = ACTIONS(595),
    [anon_sym_nounwind] = ACTIONS(595),
    [anon_sym_nosanitize_coverage] = ACTIONS(595),
    [anon_sym_null_pointer_is_valid] = ACTIONS(595),
    [anon_sym_optforfuzzing] = ACTIONS(595),
    [anon_sym_optnone] = ACTIONS(595),
    [anon_sym_optsize] = ACTIONS(595),
    [anon_sym_readnone] = ACTIONS(595),
    [anon_sym_readonly] = ACTIONS(595),
    [anon_sym_writeonly] = ACTIONS(595),
    [anon_sym_argmemonly] = ACTIONS(595),
    [anon_sym_returns_twice] = ACTIONS(595),
    [anon_sym_safestack] = ACTIONS(595),
    [anon_sym_sanitize_address] = ACTIONS(595),
    [anon_sym_sanitize_memory] = ACTIONS(595),
    [anon_sym_sanitize_thread] = ACTIONS(595),
    [anon_sym_sanitize_hwaddress] = ACTIONS(595),
    [anon_sym_sanitize_memtag] = ACTIONS(595),
    [anon_sym_speculative_load_hardening] = ACTIONS(595),
    [anon_sym_speculatable] = ACTIONS(595),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(595),
    [anon_sym_sspreq] = ACTIONS(595),
    [anon_sym_strictfp] = ACTIONS(595),
    [anon_sym_uwtable] = ACTIONS(595),
    [anon_sym_nocf_check] = ACTIONS(595),
    [anon_sym_shadowcallstack] = ACTIONS(595),
    [anon_sym_mustprogress] = ACTIONS(595),
    [anon_sym_vscale_range] = ACTIONS(595),
    [anon_sym_preallocated] = ACTIONS(595),
    [anon_sym_zeroext] = ACTIONS(595),
    [anon_sym_signext] = ACTIONS(595),
    [anon_sym_inreg] = ACTIONS(595),
    [anon_sym_byval] = ACTIONS(595),
    [anon_sym_byref] = ACTIONS(595),
    [anon_sym_inalloca] = ACTIONS(595),
    [anon_sym_sret] = ACTIONS(595),
    [anon_sym_elementtype] = ACTIONS(595),
    [anon_sym_noalias] = ACTIONS(595),
    [anon_sym_nocapture] = ACTIONS(595),
    [anon_sym_nest] = ACTIONS(595),
    [anon_sym_returned] = ACTIONS(595),
    [anon_sym_nonnull] = ACTIONS(595),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(595),
    [anon_sym_swiftself] = ACTIONS(597),
    [anon_sym_swiftasync] = ACTIONS(597),
    [anon_sym_swifterror] = ACTIONS(597),
    [anon_sym_immarg] = ACTIONS(595),
    [anon_sym_noundef] = ACTIONS(595),
    [anon_sym_to] = ACTIONS(597),
    [anon_sym_unwind] = ACTIONS(595),
    [anon_sym_unordered] = ACTIONS(595),
    [anon_sym_monotonic] = ACTIONS(595),
    [anon_sym_acquire] = ACTIONS(595),
    [anon_sym_release] = ACTIONS(595),
    [anon_sym_acq_rel] = ACTIONS(595),
    [anon_sym_seq_cst] = ACTIONS(595),
    [anon_sym_syncscope] = ACTIONS(595),
    [anon_sym_uselistorder] = ACTIONS(597),
    [anon_sym_uselistorder_bb] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_attributes] = ACTIONS(595),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(599),
    [sym_global_var] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [aux_sym_metadata_ref_token1] = ACTIONS(599),
    [sym_summary_ref] = ACTIONS(599),
    [sym_string] = ACTIONS(599),
    [anon_sym_target] = ACTIONS(599),
    [anon_sym_source_filename] = ACTIONS(599),
    [anon_sym_declare] = ACTIONS(599),
    [anon_sym_define] = ACTIONS(599),
    [anon_sym_no_cfi] = ACTIONS(599),
    [anon_sym_private] = ACTIONS(599),
    [anon_sym_internal] = ACTIONS(599),
    [anon_sym_weak] = ACTIONS(601),
    [anon_sym_weak_odr] = ACTIONS(599),
    [anon_sym_linkonce] = ACTIONS(601),
    [anon_sym_linkonce_odr] = ACTIONS(599),
    [anon_sym_available_externally] = ACTIONS(599),
    [anon_sym_appending] = ACTIONS(599),
    [anon_sym_common] = ACTIONS(599),
    [anon_sym_extern_weak] = ACTIONS(599),
    [anon_sym_external] = ACTIONS(599),
    [anon_sym_dso_local] = ACTIONS(601),
    [anon_sym_dso_local_equivalent] = ACTIONS(599),
    [anon_sym_dso_preemptable] = ACTIONS(599),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_hidden] = ACTIONS(599),
    [anon_sym_protected] = ACTIONS(599),
    [anon_sym_dllimport] = ACTIONS(599),
    [anon_sym_dllexport] = ACTIONS(599),
    [anon_sym_ccc] = ACTIONS(599),
    [anon_sym_fastcc] = ACTIONS(599),
    [anon_sym_coldcc] = ACTIONS(599),
    [anon_sym_webkit_jscc] = ACTIONS(601),
    [anon_sym_anyregcc] = ACTIONS(599),
    [anon_sym_preserve_mostcc] = ACTIONS(599),
    [anon_sym_preserve_allcc] = ACTIONS(599),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(601),
    [anon_sym_tailcc] = ACTIONS(599),
    [anon_sym_swiftcc] = ACTIONS(601),
    [anon_sym_swifttailcc] = ACTIONS(601),
    [anon_sym_cfguard_checkcc] = ACTIONS(599),
    [aux_sym_calling_conv_token1] = ACTIONS(601),
    [aux_sym_calling_conv_token2] = ACTIONS(599),
    [aux_sym_calling_conv_token3] = ACTIONS(599),
    [aux_sym_calling_conv_token4] = ACTIONS(599),
    [aux_sym_calling_conv_token5] = ACTIONS(599),
    [aux_sym_calling_conv_token6] = ACTIONS(599),
    [aux_sym_calling_conv_token7] = ACTIONS(599),
    [aux_sym_calling_conv_token8] = ACTIONS(599),
    [aux_sym_calling_conv_token9] = ACTIONS(599),
    [aux_sym_calling_conv_token10] = ACTIONS(601),
    [anon_sym_ghccc] = ACTIONS(599),
    [aux_sym_calling_conv_token11] = ACTIONS(601),
    [aux_sym_calling_conv_token12] = ACTIONS(599),
    [aux_sym_calling_conv_token13] = ACTIONS(601),
    [aux_sym_calling_conv_token14] = ACTIONS(599),
    [anon_sym_cc] = ACTIONS(601),
    [anon_sym_unnamed_addr] = ACTIONS(599),
    [anon_sym_local_unnamed_addr] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(599),
    [anon_sym_half] = ACTIONS(599),
    [anon_sym_bfloat] = ACTIONS(599),
    [anon_sym_float] = ACTIONS(599),
    [anon_sym_double] = ACTIONS(599),
    [anon_sym_x86_fp80] = ACTIONS(601),
    [anon_sym_fp128] = ACTIONS(599),
    [anon_sym_ppc_fp128] = ACTIONS(599),
    [anon_sym_label] = ACTIONS(599),
    [anon_sym_metadata] = ACTIONS(599),
    [anon_sym_x86_mmx] = ACTIONS(601),
    [anon_sym_x86_amx] = ACTIONS(601),
    [anon_sym_token] = ACTIONS(599),
    [anon_sym_opaque] = ACTIONS(599),
    [anon_sym_ptr] = ACTIONS(599),
    [aux_sym_type_keyword_token1] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LT_LBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(599),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_alignstack] = ACTIONS(599),
    [anon_sym_allocsize] = ACTIONS(599),
    [anon_sym_alwaysinline] = ACTIONS(599),
    [anon_sym_builtin] = ACTIONS(599),
    [anon_sym_cold] = ACTIONS(601),
    [anon_sym_convergent] = ACTIONS(599),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(599),
    [anon_sym_hot] = ACTIONS(599),
    [anon_sym_inaccessiblememonly] = ACTIONS(599),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(599),
    [anon_sym_inlinehint] = ACTIONS(599),
    [anon_sym_jumptable] = ACTIONS(599),
    [anon_sym_minsize] = ACTIONS(599),
    [anon_sym_naked] = ACTIONS(599),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(599),
    [anon_sym_nobuiltin] = ACTIONS(599),
    [anon_sym_noduplicate] = ACTIONS(599),
    [anon_sym_nofree] = ACTIONS(599),
    [anon_sym_noimplicitfloat] = ACTIONS(599),
    [anon_sym_noinline] = ACTIONS(599),
    [anon_sym_nomerge] = ACTIONS(599),
    [anon_sym_nonlazybind] = ACTIONS(599),
    [anon_sym_noprofile] = ACTIONS(599),
    [anon_sym_noredzone] = ACTIONS(599),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(599),
    [anon_sym_noreturn] = ACTIONS(599),
    [anon_sym_norecurse] = ACTIONS(599),
    [anon_sym_willreturn] = ACTIONS(599),
    [anon_sym_nosync] = ACTIONS(599),
    [anon_sym_nounwind] = ACTIONS(599),
    [anon_sym_nosanitize_coverage] = ACTIONS(599),
    [anon_sym_null_pointer_is_valid] = ACTIONS(599),
    [anon_sym_optforfuzzing] = ACTIONS(599),
    [anon_sym_optnone] = ACTIONS(599),
    [anon_sym_optsize] = ACTIONS(599),
    [anon_sym_readnone] = ACTIONS(599),
    [anon_sym_readonly] = ACTIONS(599),
    [anon_sym_writeonly] = ACTIONS(599),
    [anon_sym_argmemonly] = ACTIONS(599),
    [anon_sym_returns_twice] = ACTIONS(599),
    [anon_sym_safestack] = ACTIONS(599),
    [anon_sym_sanitize_address] = ACTIONS(599),
    [anon_sym_sanitize_memory] = ACTIONS(599),
    [anon_sym_sanitize_thread] = ACTIONS(599),
    [anon_sym_sanitize_hwaddress] = ACTIONS(599),
    [anon_sym_sanitize_memtag] = ACTIONS(599),
    [anon_sym_speculative_load_hardening] = ACTIONS(599),
    [anon_sym_speculatable] = ACTIONS(599),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(599),
    [anon_sym_sspreq] = ACTIONS(599),
    [anon_sym_strictfp] = ACTIONS(599),
    [anon_sym_uwtable] = ACTIONS(599),
    [anon_sym_nocf_check] = ACTIONS(599),
    [anon_sym_shadowcallstack] = ACTIONS(599),
    [anon_sym_mustprogress] = ACTIONS(599),
    [anon_sym_vscale_range] = ACTIONS(599),
    [anon_sym_preallocated] = ACTIONS(599),
    [anon_sym_zeroext] = ACTIONS(599),
    [anon_sym_signext] = ACTIONS(599),
    [anon_sym_inreg] = ACTIONS(599),
    [anon_sym_byval] = ACTIONS(599),
    [anon_sym_byref] = ACTIONS(599),
    [anon_sym_inalloca] = ACTIONS(599),
    [anon_sym_sret] = ACTIONS(599),
    [anon_sym_elementtype] = ACTIONS(599),
    [anon_sym_noalias] = ACTIONS(599),
    [anon_sym_nocapture] = ACTIONS(599),
    [anon_sym_nest] = ACTIONS(599),
    [anon_sym_returned] = ACTIONS(599),
    [anon_sym_nonnull] = ACTIONS(599),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(599),
    [anon_sym_swiftself] = ACTIONS(601),
    [anon_sym_swiftasync] = ACTIONS(601),
    [anon_sym_swifterror] = ACTIONS(601),
    [anon_sym_immarg] = ACTIONS(599),
    [anon_sym_noundef] = ACTIONS(599),
    [anon_sym_to] = ACTIONS(601),
    [anon_sym_unwind] = ACTIONS(599),
    [anon_sym_unordered] = ACTIONS(599),
    [anon_sym_monotonic] = ACTIONS(599),
    [anon_sym_acquire] = ACTIONS(599),
    [anon_sym_release] = ACTIONS(599),
    [anon_sym_acq_rel] = ACTIONS(599),
    [anon_sym_seq_cst] = ACTIONS(599),
    [anon_sym_syncscope] = ACTIONS(599),
    [anon_sym_uselistorder] = ACTIONS(601),
    [anon_sym_uselistorder_bb] = ACTIONS(599),
    [anon_sym_module] = ACTIONS(599),
    [anon_sym_attributes] = ACTIONS(599),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(603),
    [sym_global_var] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [aux_sym_metadata_ref_token1] = ACTIONS(603),
    [sym_summary_ref] = ACTIONS(603),
    [sym_string] = ACTIONS(603),
    [anon_sym_target] = ACTIONS(603),
    [anon_sym_source_filename] = ACTIONS(603),
    [anon_sym_declare] = ACTIONS(603),
    [anon_sym_define] = ACTIONS(603),
    [anon_sym_no_cfi] = ACTIONS(603),
    [anon_sym_private] = ACTIONS(603),
    [anon_sym_internal] = ACTIONS(603),
    [anon_sym_weak] = ACTIONS(605),
    [anon_sym_weak_odr] = ACTIONS(603),
    [anon_sym_linkonce] = ACTIONS(605),
    [anon_sym_linkonce_odr] = ACTIONS(603),
    [anon_sym_available_externally] = ACTIONS(603),
    [anon_sym_appending] = ACTIONS(603),
    [anon_sym_common] = ACTIONS(603),
    [anon_sym_extern_weak] = ACTIONS(603),
    [anon_sym_external] = ACTIONS(603),
    [anon_sym_dso_local] = ACTIONS(605),
    [anon_sym_dso_local_equivalent] = ACTIONS(603),
    [anon_sym_dso_preemptable] = ACTIONS(603),
    [anon_sym_default] = ACTIONS(603),
    [anon_sym_hidden] = ACTIONS(603),
    [anon_sym_protected] = ACTIONS(603),
    [anon_sym_dllimport] = ACTIONS(603),
    [anon_sym_dllexport] = ACTIONS(603),
    [anon_sym_ccc] = ACTIONS(603),
    [anon_sym_fastcc] = ACTIONS(603),
    [anon_sym_coldcc] = ACTIONS(603),
    [anon_sym_webkit_jscc] = ACTIONS(605),
    [anon_sym_anyregcc] = ACTIONS(603),
    [anon_sym_preserve_mostcc] = ACTIONS(603),
    [anon_sym_preserve_allcc] = ACTIONS(603),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(605),
    [anon_sym_tailcc] = ACTIONS(603),
    [anon_sym_swiftcc] = ACTIONS(605),
    [anon_sym_swifttailcc] = ACTIONS(605),
    [anon_sym_cfguard_checkcc] = ACTIONS(603),
    [aux_sym_calling_conv_token1] = ACTIONS(605),
    [aux_sym_calling_conv_token2] = ACTIONS(603),
    [aux_sym_calling_conv_token3] = ACTIONS(603),
    [aux_sym_calling_conv_token4] = ACTIONS(603),
    [aux_sym_calling_conv_token5] = ACTIONS(603),
    [aux_sym_calling_conv_token6] = ACTIONS(603),
    [aux_sym_calling_conv_token7] = ACTIONS(603),
    [aux_sym_calling_conv_token8] = ACTIONS(603),
    [aux_sym_calling_conv_token9] = ACTIONS(603),
    [aux_sym_calling_conv_token10] = ACTIONS(605),
    [anon_sym_ghccc] = ACTIONS(603),
    [aux_sym_calling_conv_token11] = ACTIONS(605),
    [aux_sym_calling_conv_token12] = ACTIONS(603),
    [aux_sym_calling_conv_token13] = ACTIONS(605),
    [aux_sym_calling_conv_token14] = ACTIONS(603),
    [anon_sym_cc] = ACTIONS(605),
    [anon_sym_unnamed_addr] = ACTIONS(603),
    [anon_sym_local_unnamed_addr] = ACTIONS(603),
    [anon_sym_void] = ACTIONS(603),
    [anon_sym_half] = ACTIONS(603),
    [anon_sym_bfloat] = ACTIONS(603),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_double] = ACTIONS(603),
    [anon_sym_x86_fp80] = ACTIONS(605),
    [anon_sym_fp128] = ACTIONS(603),
    [anon_sym_ppc_fp128] = ACTIONS(603),
    [anon_sym_label] = ACTIONS(603),
    [anon_sym_metadata] = ACTIONS(603),
    [anon_sym_x86_mmx] = ACTIONS(605),
    [anon_sym_x86_amx] = ACTIONS(605),
    [anon_sym_token] = ACTIONS(603),
    [anon_sym_opaque] = ACTIONS(603),
    [anon_sym_ptr] = ACTIONS(603),
    [aux_sym_type_keyword_token1] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LT_LBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_alignstack] = ACTIONS(603),
    [anon_sym_allocsize] = ACTIONS(603),
    [anon_sym_alwaysinline] = ACTIONS(603),
    [anon_sym_builtin] = ACTIONS(603),
    [anon_sym_cold] = ACTIONS(605),
    [anon_sym_convergent] = ACTIONS(603),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(603),
    [anon_sym_hot] = ACTIONS(603),
    [anon_sym_inaccessiblememonly] = ACTIONS(603),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(603),
    [anon_sym_inlinehint] = ACTIONS(603),
    [anon_sym_jumptable] = ACTIONS(603),
    [anon_sym_minsize] = ACTIONS(603),
    [anon_sym_naked] = ACTIONS(603),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(603),
    [anon_sym_nobuiltin] = ACTIONS(603),
    [anon_sym_noduplicate] = ACTIONS(603),
    [anon_sym_nofree] = ACTIONS(603),
    [anon_sym_noimplicitfloat] = ACTIONS(603),
    [anon_sym_noinline] = ACTIONS(603),
    [anon_sym_nomerge] = ACTIONS(603),
    [anon_sym_nonlazybind] = ACTIONS(603),
    [anon_sym_noprofile] = ACTIONS(603),
    [anon_sym_noredzone] = ACTIONS(603),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(603),
    [anon_sym_noreturn] = ACTIONS(603),
    [anon_sym_norecurse] = ACTIONS(603),
    [anon_sym_willreturn] = ACTIONS(603),
    [anon_sym_nosync] = ACTIONS(603),
    [anon_sym_nounwind] = ACTIONS(603),
    [anon_sym_nosanitize_coverage] = ACTIONS(603),
    [anon_sym_null_pointer_is_valid] = ACTIONS(603),
    [anon_sym_optforfuzzing] = ACTIONS(603),
    [anon_sym_optnone] = ACTIONS(603),
    [anon_sym_optsize] = ACTIONS(603),
    [anon_sym_readnone] = ACTIONS(603),
    [anon_sym_readonly] = ACTIONS(603),
    [anon_sym_writeonly] = ACTIONS(603),
    [anon_sym_argmemonly] = ACTIONS(603),
    [anon_sym_returns_twice] = ACTIONS(603),
    [anon_sym_safestack] = ACTIONS(603),
    [anon_sym_sanitize_address] = ACTIONS(603),
    [anon_sym_sanitize_memory] = ACTIONS(603),
    [anon_sym_sanitize_thread] = ACTIONS(603),
    [anon_sym_sanitize_hwaddress] = ACTIONS(603),
    [anon_sym_sanitize_memtag] = ACTIONS(603),
    [anon_sym_speculative_load_hardening] = ACTIONS(603),
    [anon_sym_speculatable] = ACTIONS(603),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(603),
    [anon_sym_sspreq] = ACTIONS(603),
    [anon_sym_strictfp] = ACTIONS(603),
    [anon_sym_uwtable] = ACTIONS(603),
    [anon_sym_nocf_check] = ACTIONS(603),
    [anon_sym_shadowcallstack] = ACTIONS(603),
    [anon_sym_mustprogress] = ACTIONS(603),
    [anon_sym_vscale_range] = ACTIONS(603),
    [anon_sym_preallocated] = ACTIONS(603),
    [anon_sym_zeroext] = ACTIONS(603),
    [anon_sym_signext] = ACTIONS(603),
    [anon_sym_inreg] = ACTIONS(603),
    [anon_sym_byval] = ACTIONS(603),
    [anon_sym_byref] = ACTIONS(603),
    [anon_sym_inalloca] = ACTIONS(603),
    [anon_sym_sret] = ACTIONS(603),
    [anon_sym_elementtype] = ACTIONS(603),
    [anon_sym_noalias] = ACTIONS(603),
    [anon_sym_nocapture] = ACTIONS(603),
    [anon_sym_nest] = ACTIONS(603),
    [anon_sym_returned] = ACTIONS(603),
    [anon_sym_nonnull] = ACTIONS(603),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(603),
    [anon_sym_swiftself] = ACTIONS(605),
    [anon_sym_swiftasync] = ACTIONS(605),
    [anon_sym_swifterror] = ACTIONS(605),
    [anon_sym_immarg] = ACTIONS(603),
    [anon_sym_noundef] = ACTIONS(603),
    [anon_sym_to] = ACTIONS(605),
    [anon_sym_unwind] = ACTIONS(603),
    [anon_sym_unordered] = ACTIONS(603),
    [anon_sym_monotonic] = ACTIONS(603),
    [anon_sym_acquire] = ACTIONS(603),
    [anon_sym_release] = ACTIONS(603),
    [anon_sym_acq_rel] = ACTIONS(603),
    [anon_sym_seq_cst] = ACTIONS(603),
    [anon_sym_syncscope] = ACTIONS(603),
    [anon_sym_uselistorder] = ACTIONS(605),
    [anon_sym_uselistorder_bb] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_attributes] = ACTIONS(603),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(607),
    [sym_global_var] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [aux_sym_metadata_ref_token1] = ACTIONS(607),
    [sym_summary_ref] = ACTIONS(607),
    [sym_string] = ACTIONS(607),
    [anon_sym_target] = ACTIONS(607),
    [anon_sym_source_filename] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(607),
    [anon_sym_define] = ACTIONS(607),
    [anon_sym_no_cfi] = ACTIONS(607),
    [anon_sym_private] = ACTIONS(607),
    [anon_sym_internal] = ACTIONS(607),
    [anon_sym_weak] = ACTIONS(609),
    [anon_sym_weak_odr] = ACTIONS(607),
    [anon_sym_linkonce] = ACTIONS(609),
    [anon_sym_linkonce_odr] = ACTIONS(607),
    [anon_sym_available_externally] = ACTIONS(607),
    [anon_sym_appending] = ACTIONS(607),
    [anon_sym_common] = ACTIONS(607),
    [anon_sym_extern_weak] = ACTIONS(607),
    [anon_sym_external] = ACTIONS(607),
    [anon_sym_dso_local] = ACTIONS(609),
    [anon_sym_dso_local_equivalent] = ACTIONS(607),
    [anon_sym_dso_preemptable] = ACTIONS(607),
    [anon_sym_default] = ACTIONS(607),
    [anon_sym_hidden] = ACTIONS(607),
    [anon_sym_protected] = ACTIONS(607),
    [anon_sym_dllimport] = ACTIONS(607),
    [anon_sym_dllexport] = ACTIONS(607),
    [anon_sym_ccc] = ACTIONS(607),
    [anon_sym_fastcc] = ACTIONS(607),
    [anon_sym_coldcc] = ACTIONS(607),
    [anon_sym_webkit_jscc] = ACTIONS(609),
    [anon_sym_anyregcc] = ACTIONS(607),
    [anon_sym_preserve_mostcc] = ACTIONS(607),
    [anon_sym_preserve_allcc] = ACTIONS(607),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(609),
    [anon_sym_tailcc] = ACTIONS(607),
    [anon_sym_swiftcc] = ACTIONS(609),
    [anon_sym_swifttailcc] = ACTIONS(609),
    [anon_sym_cfguard_checkcc] = ACTIONS(607),
    [aux_sym_calling_conv_token1] = ACTIONS(609),
    [aux_sym_calling_conv_token2] = ACTIONS(607),
    [aux_sym_calling_conv_token3] = ACTIONS(607),
    [aux_sym_calling_conv_token4] = ACTIONS(607),
    [aux_sym_calling_conv_token5] = ACTIONS(607),
    [aux_sym_calling_conv_token6] = ACTIONS(607),
    [aux_sym_calling_conv_token7] = ACTIONS(607),
    [aux_sym_calling_conv_token8] = ACTIONS(607),
    [aux_sym_calling_conv_token9] = ACTIONS(607),
    [aux_sym_calling_conv_token10] = ACTIONS(609),
    [anon_sym_ghccc] = ACTIONS(607),
    [aux_sym_calling_conv_token11] = ACTIONS(609),
    [aux_sym_calling_conv_token12] = ACTIONS(607),
    [aux_sym_calling_conv_token13] = ACTIONS(609),
    [aux_sym_calling_conv_token14] = ACTIONS(607),
    [anon_sym_cc] = ACTIONS(609),
    [anon_sym_unnamed_addr] = ACTIONS(607),
    [anon_sym_local_unnamed_addr] = ACTIONS(607),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_half] = ACTIONS(607),
    [anon_sym_bfloat] = ACTIONS(607),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_double] = ACTIONS(607),
    [anon_sym_x86_fp80] = ACTIONS(609),
    [anon_sym_fp128] = ACTIONS(607),
    [anon_sym_ppc_fp128] = ACTIONS(607),
    [anon_sym_label] = ACTIONS(607),
    [anon_sym_metadata] = ACTIONS(607),
    [anon_sym_x86_mmx] = ACTIONS(609),
    [anon_sym_x86_amx] = ACTIONS(609),
    [anon_sym_token] = ACTIONS(607),
    [anon_sym_opaque] = ACTIONS(607),
    [anon_sym_ptr] = ACTIONS(607),
    [aux_sym_type_keyword_token1] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LT_LBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_GT] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_alignstack] = ACTIONS(607),
    [anon_sym_allocsize] = ACTIONS(607),
    [anon_sym_alwaysinline] = ACTIONS(607),
    [anon_sym_builtin] = ACTIONS(607),
    [anon_sym_cold] = ACTIONS(609),
    [anon_sym_convergent] = ACTIONS(607),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(607),
    [anon_sym_hot] = ACTIONS(607),
    [anon_sym_inaccessiblememonly] = ACTIONS(607),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(607),
    [anon_sym_inlinehint] = ACTIONS(607),
    [anon_sym_jumptable] = ACTIONS(607),
    [anon_sym_minsize] = ACTIONS(607),
    [anon_sym_naked] = ACTIONS(607),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(607),
    [anon_sym_nobuiltin] = ACTIONS(607),
    [anon_sym_noduplicate] = ACTIONS(607),
    [anon_sym_nofree] = ACTIONS(607),
    [anon_sym_noimplicitfloat] = ACTIONS(607),
    [anon_sym_noinline] = ACTIONS(607),
    [anon_sym_nomerge] = ACTIONS(607),
    [anon_sym_nonlazybind] = ACTIONS(607),
    [anon_sym_noprofile] = ACTIONS(607),
    [anon_sym_noredzone] = ACTIONS(607),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(607),
    [anon_sym_noreturn] = ACTIONS(607),
    [anon_sym_norecurse] = ACTIONS(607),
    [anon_sym_willreturn] = ACTIONS(607),
    [anon_sym_nosync] = ACTIONS(607),
    [anon_sym_nounwind] = ACTIONS(607),
    [anon_sym_nosanitize_coverage] = ACTIONS(607),
    [anon_sym_null_pointer_is_valid] = ACTIONS(607),
    [anon_sym_optforfuzzing] = ACTIONS(607),
    [anon_sym_optnone] = ACTIONS(607),
    [anon_sym_optsize] = ACTIONS(607),
    [anon_sym_readnone] = ACTIONS(607),
    [anon_sym_readonly] = ACTIONS(607),
    [anon_sym_writeonly] = ACTIONS(607),
    [anon_sym_argmemonly] = ACTIONS(607),
    [anon_sym_returns_twice] = ACTIONS(607),
    [anon_sym_safestack] = ACTIONS(607),
    [anon_sym_sanitize_address] = ACTIONS(607),
    [anon_sym_sanitize_memory] = ACTIONS(607),
    [anon_sym_sanitize_thread] = ACTIONS(607),
    [anon_sym_sanitize_hwaddress] = ACTIONS(607),
    [anon_sym_sanitize_memtag] = ACTIONS(607),
    [anon_sym_speculative_load_hardening] = ACTIONS(607),
    [anon_sym_speculatable] = ACTIONS(607),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(607),
    [anon_sym_sspreq] = ACTIONS(607),
    [anon_sym_strictfp] = ACTIONS(607),
    [anon_sym_uwtable] = ACTIONS(607),
    [anon_sym_nocf_check] = ACTIONS(607),
    [anon_sym_shadowcallstack] = ACTIONS(607),
    [anon_sym_mustprogress] = ACTIONS(607),
    [anon_sym_vscale_range] = ACTIONS(607),
    [anon_sym_preallocated] = ACTIONS(607),
    [anon_sym_zeroext] = ACTIONS(607),
    [anon_sym_signext] = ACTIONS(607),
    [anon_sym_inreg] = ACTIONS(607),
    [anon_sym_byval] = ACTIONS(607),
    [anon_sym_byref] = ACTIONS(607),
    [anon_sym_inalloca] = ACTIONS(607),
    [anon_sym_sret] = ACTIONS(607),
    [anon_sym_elementtype] = ACTIONS(607),
    [anon_sym_noalias] = ACTIONS(607),
    [anon_sym_nocapture] = ACTIONS(607),
    [anon_sym_nest] = ACTIONS(607),
    [anon_sym_returned] = ACTIONS(607),
    [anon_sym_nonnull] = ACTIONS(607),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(607),
    [anon_sym_swiftself] = ACTIONS(609),
    [anon_sym_swiftasync] = ACTIONS(609),
    [anon_sym_swifterror] = ACTIONS(609),
    [anon_sym_immarg] = ACTIONS(607),
    [anon_sym_noundef] = ACTIONS(607),
    [anon_sym_to] = ACTIONS(609),
    [anon_sym_unwind] = ACTIONS(607),
    [anon_sym_unordered] = ACTIONS(607),
    [anon_sym_monotonic] = ACTIONS(607),
    [anon_sym_acquire] = ACTIONS(607),
    [anon_sym_release] = ACTIONS(607),
    [anon_sym_acq_rel] = ACTIONS(607),
    [anon_sym_seq_cst] = ACTIONS(607),
    [anon_sym_syncscope] = ACTIONS(607),
    [anon_sym_uselistorder] = ACTIONS(609),
    [anon_sym_uselistorder_bb] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_attributes] = ACTIONS(607),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(611),
    [sym_global_var] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [aux_sym_metadata_ref_token1] = ACTIONS(611),
    [sym_summary_ref] = ACTIONS(611),
    [sym_string] = ACTIONS(611),
    [anon_sym_target] = ACTIONS(611),
    [anon_sym_source_filename] = ACTIONS(611),
    [anon_sym_declare] = ACTIONS(611),
    [anon_sym_define] = ACTIONS(611),
    [anon_sym_no_cfi] = ACTIONS(611),
    [anon_sym_private] = ACTIONS(611),
    [anon_sym_internal] = ACTIONS(611),
    [anon_sym_weak] = ACTIONS(613),
    [anon_sym_weak_odr] = ACTIONS(611),
    [anon_sym_linkonce] = ACTIONS(613),
    [anon_sym_linkonce_odr] = ACTIONS(611),
    [anon_sym_available_externally] = ACTIONS(611),
    [anon_sym_appending] = ACTIONS(611),
    [anon_sym_common] = ACTIONS(611),
    [anon_sym_extern_weak] = ACTIONS(611),
    [anon_sym_external] = ACTIONS(611),
    [anon_sym_dso_local] = ACTIONS(613),
    [anon_sym_dso_local_equivalent] = ACTIONS(611),
    [anon_sym_dso_preemptable] = ACTIONS(611),
    [anon_sym_default] = ACTIONS(611),
    [anon_sym_hidden] = ACTIONS(611),
    [anon_sym_protected] = ACTIONS(611),
    [anon_sym_dllimport] = ACTIONS(611),
    [anon_sym_dllexport] = ACTIONS(611),
    [anon_sym_ccc] = ACTIONS(611),
    [anon_sym_fastcc] = ACTIONS(611),
    [anon_sym_coldcc] = ACTIONS(611),
    [anon_sym_webkit_jscc] = ACTIONS(613),
    [anon_sym_anyregcc] = ACTIONS(611),
    [anon_sym_preserve_mostcc] = ACTIONS(611),
    [anon_sym_preserve_allcc] = ACTIONS(611),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(613),
    [anon_sym_tailcc] = ACTIONS(611),
    [anon_sym_swiftcc] = ACTIONS(613),
    [anon_sym_swifttailcc] = ACTIONS(613),
    [anon_sym_cfguard_checkcc] = ACTIONS(611),
    [aux_sym_calling_conv_token1] = ACTIONS(613),
    [aux_sym_calling_conv_token2] = ACTIONS(611),
    [aux_sym_calling_conv_token3] = ACTIONS(611),
    [aux_sym_calling_conv_token4] = ACTIONS(611),
    [aux_sym_calling_conv_token5] = ACTIONS(611),
    [aux_sym_calling_conv_token6] = ACTIONS(611),
    [aux_sym_calling_conv_token7] = ACTIONS(611),
    [aux_sym_calling_conv_token8] = ACTIONS(611),
    [aux_sym_calling_conv_token9] = ACTIONS(611),
    [aux_sym_calling_conv_token10] = ACTIONS(613),
    [anon_sym_ghccc] = ACTIONS(611),
    [aux_sym_calling_conv_token11] = ACTIONS(613),
    [aux_sym_calling_conv_token12] = ACTIONS(611),
    [aux_sym_calling_conv_token13] = ACTIONS(613),
    [aux_sym_calling_conv_token14] = ACTIONS(611),
    [anon_sym_cc] = ACTIONS(613),
    [anon_sym_unnamed_addr] = ACTIONS(611),
    [anon_sym_local_unnamed_addr] = ACTIONS(611),
    [anon_sym_void] = ACTIONS(611),
    [anon_sym_half] = ACTIONS(611),
    [anon_sym_bfloat] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(611),
    [anon_sym_double] = ACTIONS(611),
    [anon_sym_x86_fp80] = ACTIONS(613),
    [anon_sym_fp128] = ACTIONS(611),
    [anon_sym_ppc_fp128] = ACTIONS(611),
    [anon_sym_label] = ACTIONS(611),
    [anon_sym_metadata] = ACTIONS(611),
    [anon_sym_x86_mmx] = ACTIONS(613),
    [anon_sym_x86_amx] = ACTIONS(613),
    [anon_sym_token] = ACTIONS(611),
    [anon_sym_opaque] = ACTIONS(611),
    [anon_sym_ptr] = ACTIONS(611),
    [aux_sym_type_keyword_token1] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LT_LBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(611),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_alignstack] = ACTIONS(611),
    [anon_sym_allocsize] = ACTIONS(611),
    [anon_sym_alwaysinline] = ACTIONS(611),
    [anon_sym_builtin] = ACTIONS(611),
    [anon_sym_cold] = ACTIONS(613),
    [anon_sym_convergent] = ACTIONS(611),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(611),
    [anon_sym_hot] = ACTIONS(611),
    [anon_sym_inaccessiblememonly] = ACTIONS(611),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(611),
    [anon_sym_inlinehint] = ACTIONS(611),
    [anon_sym_jumptable] = ACTIONS(611),
    [anon_sym_minsize] = ACTIONS(611),
    [anon_sym_naked] = ACTIONS(611),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(611),
    [anon_sym_nobuiltin] = ACTIONS(611),
    [anon_sym_noduplicate] = ACTIONS(611),
    [anon_sym_nofree] = ACTIONS(611),
    [anon_sym_noimplicitfloat] = ACTIONS(611),
    [anon_sym_noinline] = ACTIONS(611),
    [anon_sym_nomerge] = ACTIONS(611),
    [anon_sym_nonlazybind] = ACTIONS(611),
    [anon_sym_noprofile] = ACTIONS(611),
    [anon_sym_noredzone] = ACTIONS(611),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(611),
    [anon_sym_noreturn] = ACTIONS(611),
    [anon_sym_norecurse] = ACTIONS(611),
    [anon_sym_willreturn] = ACTIONS(611),
    [anon_sym_nosync] = ACTIONS(611),
    [anon_sym_nounwind] = ACTIONS(611),
    [anon_sym_nosanitize_coverage] = ACTIONS(611),
    [anon_sym_null_pointer_is_valid] = ACTIONS(611),
    [anon_sym_optforfuzzing] = ACTIONS(611),
    [anon_sym_optnone] = ACTIONS(611),
    [anon_sym_optsize] = ACTIONS(611),
    [anon_sym_readnone] = ACTIONS(611),
    [anon_sym_readonly] = ACTIONS(611),
    [anon_sym_writeonly] = ACTIONS(611),
    [anon_sym_argmemonly] = ACTIONS(611),
    [anon_sym_returns_twice] = ACTIONS(611),
    [anon_sym_safestack] = ACTIONS(611),
    [anon_sym_sanitize_address] = ACTIONS(611),
    [anon_sym_sanitize_memory] = ACTIONS(611),
    [anon_sym_sanitize_thread] = ACTIONS(611),
    [anon_sym_sanitize_hwaddress] = ACTIONS(611),
    [anon_sym_sanitize_memtag] = ACTIONS(611),
    [anon_sym_speculative_load_hardening] = ACTIONS(611),
    [anon_sym_speculatable] = ACTIONS(611),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(611),
    [anon_sym_sspreq] = ACTIONS(611),
    [anon_sym_strictfp] = ACTIONS(611),
    [anon_sym_uwtable] = ACTIONS(611),
    [anon_sym_nocf_check] = ACTIONS(611),
    [anon_sym_shadowcallstack] = ACTIONS(611),
    [anon_sym_mustprogress] = ACTIONS(611),
    [anon_sym_vscale_range] = ACTIONS(611),
    [anon_sym_preallocated] = ACTIONS(611),
    [anon_sym_zeroext] = ACTIONS(611),
    [anon_sym_signext] = ACTIONS(611),
    [anon_sym_inreg] = ACTIONS(611),
    [anon_sym_byval] = ACTIONS(611),
    [anon_sym_byref] = ACTIONS(611),
    [anon_sym_inalloca] = ACTIONS(611),
    [anon_sym_sret] = ACTIONS(611),
    [anon_sym_elementtype] = ACTIONS(611),
    [anon_sym_noalias] = ACTIONS(611),
    [anon_sym_nocapture] = ACTIONS(611),
    [anon_sym_nest] = ACTIONS(611),
    [anon_sym_returned] = ACTIONS(611),
    [anon_sym_nonnull] = ACTIONS(611),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(611),
    [anon_sym_swiftself] = ACTIONS(613),
    [anon_sym_swiftasync] = ACTIONS(613),
    [anon_sym_swifterror] = ACTIONS(613),
    [anon_sym_immarg] = ACTIONS(611),
    [anon_sym_noundef] = ACTIONS(611),
    [anon_sym_to] = ACTIONS(613),
    [anon_sym_unwind] = ACTIONS(611),
    [anon_sym_unordered] = ACTIONS(611),
    [anon_sym_monotonic] = ACTIONS(611),
    [anon_sym_acquire] = ACTIONS(611),
    [anon_sym_release] = ACTIONS(611),
    [anon_sym_acq_rel] = ACTIONS(611),
    [anon_sym_seq_cst] = ACTIONS(611),
    [anon_sym_syncscope] = ACTIONS(611),
    [anon_sym_uselistorder] = ACTIONS(613),
    [anon_sym_uselistorder_bb] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(611),
    [anon_sym_attributes] = ACTIONS(611),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(615),
    [sym_global_var] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [aux_sym_metadata_ref_token1] = ACTIONS(615),
    [sym_summary_ref] = ACTIONS(615),
    [sym_string] = ACTIONS(615),
    [anon_sym_target] = ACTIONS(615),
    [anon_sym_source_filename] = ACTIONS(615),
    [anon_sym_declare] = ACTIONS(615),
    [anon_sym_define] = ACTIONS(615),
    [anon_sym_no_cfi] = ACTIONS(615),
    [anon_sym_private] = ACTIONS(615),
    [anon_sym_internal] = ACTIONS(615),
    [anon_sym_weak] = ACTIONS(617),
    [anon_sym_weak_odr] = ACTIONS(615),
    [anon_sym_linkonce] = ACTIONS(617),
    [anon_sym_linkonce_odr] = ACTIONS(615),
    [anon_sym_available_externally] = ACTIONS(615),
    [anon_sym_appending] = ACTIONS(615),
    [anon_sym_common] = ACTIONS(615),
    [anon_sym_extern_weak] = ACTIONS(615),
    [anon_sym_external] = ACTIONS(615),
    [anon_sym_dso_local] = ACTIONS(617),
    [anon_sym_dso_local_equivalent] = ACTIONS(615),
    [anon_sym_dso_preemptable] = ACTIONS(615),
    [anon_sym_default] = ACTIONS(615),
    [anon_sym_hidden] = ACTIONS(615),
    [anon_sym_protected] = ACTIONS(615),
    [anon_sym_dllimport] = ACTIONS(615),
    [anon_sym_dllexport] = ACTIONS(615),
    [anon_sym_ccc] = ACTIONS(615),
    [anon_sym_fastcc] = ACTIONS(615),
    [anon_sym_coldcc] = ACTIONS(615),
    [anon_sym_webkit_jscc] = ACTIONS(617),
    [anon_sym_anyregcc] = ACTIONS(615),
    [anon_sym_preserve_mostcc] = ACTIONS(615),
    [anon_sym_preserve_allcc] = ACTIONS(615),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(617),
    [anon_sym_tailcc] = ACTIONS(615),
    [anon_sym_swiftcc] = ACTIONS(617),
    [anon_sym_swifttailcc] = ACTIONS(617),
    [anon_sym_cfguard_checkcc] = ACTIONS(615),
    [aux_sym_calling_conv_token1] = ACTIONS(617),
    [aux_sym_calling_conv_token2] = ACTIONS(615),
    [aux_sym_calling_conv_token3] = ACTIONS(615),
    [aux_sym_calling_conv_token4] = ACTIONS(615),
    [aux_sym_calling_conv_token5] = ACTIONS(615),
    [aux_sym_calling_conv_token6] = ACTIONS(615),
    [aux_sym_calling_conv_token7] = ACTIONS(615),
    [aux_sym_calling_conv_token8] = ACTIONS(615),
    [aux_sym_calling_conv_token9] = ACTIONS(615),
    [aux_sym_calling_conv_token10] = ACTIONS(617),
    [anon_sym_ghccc] = ACTIONS(615),
    [aux_sym_calling_conv_token11] = ACTIONS(617),
    [aux_sym_calling_conv_token12] = ACTIONS(615),
    [aux_sym_calling_conv_token13] = ACTIONS(617),
    [aux_sym_calling_conv_token14] = ACTIONS(615),
    [anon_sym_cc] = ACTIONS(617),
    [anon_sym_unnamed_addr] = ACTIONS(615),
    [anon_sym_local_unnamed_addr] = ACTIONS(615),
    [anon_sym_void] = ACTIONS(615),
    [anon_sym_half] = ACTIONS(615),
    [anon_sym_bfloat] = ACTIONS(615),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_double] = ACTIONS(615),
    [anon_sym_x86_fp80] = ACTIONS(617),
    [anon_sym_fp128] = ACTIONS(615),
    [anon_sym_ppc_fp128] = ACTIONS(615),
    [anon_sym_label] = ACTIONS(615),
    [anon_sym_metadata] = ACTIONS(615),
    [anon_sym_x86_mmx] = ACTIONS(617),
    [anon_sym_x86_amx] = ACTIONS(617),
    [anon_sym_token] = ACTIONS(615),
    [anon_sym_opaque] = ACTIONS(615),
    [anon_sym_ptr] = ACTIONS(615),
    [aux_sym_type_keyword_token1] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LT_LBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_alignstack] = ACTIONS(615),
    [anon_sym_allocsize] = ACTIONS(615),
    [anon_sym_alwaysinline] = ACTIONS(615),
    [anon_sym_builtin] = ACTIONS(615),
    [anon_sym_cold] = ACTIONS(617),
    [anon_sym_convergent] = ACTIONS(615),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(615),
    [anon_sym_hot] = ACTIONS(615),
    [anon_sym_inaccessiblememonly] = ACTIONS(615),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(615),
    [anon_sym_inlinehint] = ACTIONS(615),
    [anon_sym_jumptable] = ACTIONS(615),
    [anon_sym_minsize] = ACTIONS(615),
    [anon_sym_naked] = ACTIONS(615),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(615),
    [anon_sym_nobuiltin] = ACTIONS(615),
    [anon_sym_noduplicate] = ACTIONS(615),
    [anon_sym_nofree] = ACTIONS(615),
    [anon_sym_noimplicitfloat] = ACTIONS(615),
    [anon_sym_noinline] = ACTIONS(615),
    [anon_sym_nomerge] = ACTIONS(615),
    [anon_sym_nonlazybind] = ACTIONS(615),
    [anon_sym_noprofile] = ACTIONS(615),
    [anon_sym_noredzone] = ACTIONS(615),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(615),
    [anon_sym_noreturn] = ACTIONS(615),
    [anon_sym_norecurse] = ACTIONS(615),
    [anon_sym_willreturn] = ACTIONS(615),
    [anon_sym_nosync] = ACTIONS(615),
    [anon_sym_nounwind] = ACTIONS(615),
    [anon_sym_nosanitize_coverage] = ACTIONS(615),
    [anon_sym_null_pointer_is_valid] = ACTIONS(615),
    [anon_sym_optforfuzzing] = ACTIONS(615),
    [anon_sym_optnone] = ACTIONS(615),
    [anon_sym_optsize] = ACTIONS(615),
    [anon_sym_readnone] = ACTIONS(615),
    [anon_sym_readonly] = ACTIONS(615),
    [anon_sym_writeonly] = ACTIONS(615),
    [anon_sym_argmemonly] = ACTIONS(615),
    [anon_sym_returns_twice] = ACTIONS(615),
    [anon_sym_safestack] = ACTIONS(615),
    [anon_sym_sanitize_address] = ACTIONS(615),
    [anon_sym_sanitize_memory] = ACTIONS(615),
    [anon_sym_sanitize_thread] = ACTIONS(615),
    [anon_sym_sanitize_hwaddress] = ACTIONS(615),
    [anon_sym_sanitize_memtag] = ACTIONS(615),
    [anon_sym_speculative_load_hardening] = ACTIONS(615),
    [anon_sym_speculatable] = ACTIONS(615),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(615),
    [anon_sym_sspreq] = ACTIONS(615),
    [anon_sym_strictfp] = ACTIONS(615),
    [anon_sym_uwtable] = ACTIONS(615),
    [anon_sym_nocf_check] = ACTIONS(615),
    [anon_sym_shadowcallstack] = ACTIONS(615),
    [anon_sym_mustprogress] = ACTIONS(615),
    [anon_sym_vscale_range] = ACTIONS(615),
    [anon_sym_preallocated] = ACTIONS(615),
    [anon_sym_zeroext] = ACTIONS(615),
    [anon_sym_signext] = ACTIONS(615),
    [anon_sym_inreg] = ACTIONS(615),
    [anon_sym_byval] = ACTIONS(615),
    [anon_sym_byref] = ACTIONS(615),
    [anon_sym_inalloca] = ACTIONS(615),
    [anon_sym_sret] = ACTIONS(615),
    [anon_sym_elementtype] = ACTIONS(615),
    [anon_sym_noalias] = ACTIONS(615),
    [anon_sym_nocapture] = ACTIONS(615),
    [anon_sym_nest] = ACTIONS(615),
    [anon_sym_returned] = ACTIONS(615),
    [anon_sym_nonnull] = ACTIONS(615),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(615),
    [anon_sym_swiftself] = ACTIONS(617),
    [anon_sym_swiftasync] = ACTIONS(617),
    [anon_sym_swifterror] = ACTIONS(617),
    [anon_sym_immarg] = ACTIONS(615),
    [anon_sym_noundef] = ACTIONS(615),
    [anon_sym_to] = ACTIONS(617),
    [anon_sym_unwind] = ACTIONS(615),
    [anon_sym_unordered] = ACTIONS(615),
    [anon_sym_monotonic] = ACTIONS(615),
    [anon_sym_acquire] = ACTIONS(615),
    [anon_sym_release] = ACTIONS(615),
    [anon_sym_acq_rel] = ACTIONS(615),
    [anon_sym_seq_cst] = ACTIONS(615),
    [anon_sym_syncscope] = ACTIONS(615),
    [anon_sym_uselistorder] = ACTIONS(617),
    [anon_sym_uselistorder_bb] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_attributes] = ACTIONS(615),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(619),
    [sym_global_var] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [aux_sym_metadata_ref_token1] = ACTIONS(619),
    [sym_summary_ref] = ACTIONS(619),
    [sym_string] = ACTIONS(619),
    [anon_sym_target] = ACTIONS(619),
    [anon_sym_source_filename] = ACTIONS(619),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_define] = ACTIONS(619),
    [anon_sym_no_cfi] = ACTIONS(619),
    [anon_sym_private] = ACTIONS(619),
    [anon_sym_internal] = ACTIONS(619),
    [anon_sym_weak] = ACTIONS(621),
    [anon_sym_weak_odr] = ACTIONS(619),
    [anon_sym_linkonce] = ACTIONS(621),
    [anon_sym_linkonce_odr] = ACTIONS(619),
    [anon_sym_available_externally] = ACTIONS(619),
    [anon_sym_appending] = ACTIONS(619),
    [anon_sym_common] = ACTIONS(619),
    [anon_sym_extern_weak] = ACTIONS(619),
    [anon_sym_external] = ACTIONS(619),
    [anon_sym_dso_local] = ACTIONS(621),
    [anon_sym_dso_local_equivalent] = ACTIONS(619),
    [anon_sym_dso_preemptable] = ACTIONS(619),
    [anon_sym_default] = ACTIONS(619),
    [anon_sym_hidden] = ACTIONS(619),
    [anon_sym_protected] = ACTIONS(619),
    [anon_sym_dllimport] = ACTIONS(619),
    [anon_sym_dllexport] = ACTIONS(619),
    [anon_sym_ccc] = ACTIONS(619),
    [anon_sym_fastcc] = ACTIONS(619),
    [anon_sym_coldcc] = ACTIONS(619),
    [anon_sym_webkit_jscc] = ACTIONS(621),
    [anon_sym_anyregcc] = ACTIONS(619),
    [anon_sym_preserve_mostcc] = ACTIONS(619),
    [anon_sym_preserve_allcc] = ACTIONS(619),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(621),
    [anon_sym_tailcc] = ACTIONS(619),
    [anon_sym_swiftcc] = ACTIONS(621),
    [anon_sym_swifttailcc] = ACTIONS(621),
    [anon_sym_cfguard_checkcc] = ACTIONS(619),
    [aux_sym_calling_conv_token1] = ACTIONS(621),
    [aux_sym_calling_conv_token2] = ACTIONS(619),
    [aux_sym_calling_conv_token3] = ACTIONS(619),
    [aux_sym_calling_conv_token4] = ACTIONS(619),
    [aux_sym_calling_conv_token5] = ACTIONS(619),
    [aux_sym_calling_conv_token6] = ACTIONS(619),
    [aux_sym_calling_conv_token7] = ACTIONS(619),
    [aux_sym_calling_conv_token8] = ACTIONS(619),
    [aux_sym_calling_conv_token9] = ACTIONS(619),
    [aux_sym_calling_conv_token10] = ACTIONS(621),
    [anon_sym_ghccc] = ACTIONS(619),
    [aux_sym_calling_conv_token11] = ACTIONS(621),
    [aux_sym_calling_conv_token12] = ACTIONS(619),
    [aux_sym_calling_conv_token13] = ACTIONS(621),
    [aux_sym_calling_conv_token14] = ACTIONS(619),
    [anon_sym_cc] = ACTIONS(621),
    [anon_sym_unnamed_addr] = ACTIONS(619),
    [anon_sym_local_unnamed_addr] = ACTIONS(619),
    [anon_sym_void] = ACTIONS(619),
    [anon_sym_half] = ACTIONS(619),
    [anon_sym_bfloat] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(619),
    [anon_sym_double] = ACTIONS(619),
    [anon_sym_x86_fp80] = ACTIONS(621),
    [anon_sym_fp128] = ACTIONS(619),
    [anon_sym_ppc_fp128] = ACTIONS(619),
    [anon_sym_label] = ACTIONS(619),
    [anon_sym_metadata] = ACTIONS(619),
    [anon_sym_x86_mmx] = ACTIONS(621),
    [anon_sym_x86_amx] = ACTIONS(621),
    [anon_sym_token] = ACTIONS(619),
    [anon_sym_opaque] = ACTIONS(619),
    [anon_sym_ptr] = ACTIONS(619),
    [aux_sym_type_keyword_token1] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LT_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(619),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_alignstack] = ACTIONS(619),
    [anon_sym_allocsize] = ACTIONS(619),
    [anon_sym_alwaysinline] = ACTIONS(619),
    [anon_sym_builtin] = ACTIONS(619),
    [anon_sym_cold] = ACTIONS(621),
    [anon_sym_convergent] = ACTIONS(619),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(619),
    [anon_sym_hot] = ACTIONS(619),
    [anon_sym_inaccessiblememonly] = ACTIONS(619),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(619),
    [anon_sym_inlinehint] = ACTIONS(619),
    [anon_sym_jumptable] = ACTIONS(619),
    [anon_sym_minsize] = ACTIONS(619),
    [anon_sym_naked] = ACTIONS(619),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(619),
    [anon_sym_nobuiltin] = ACTIONS(619),
    [anon_sym_noduplicate] = ACTIONS(619),
    [anon_sym_nofree] = ACTIONS(619),
    [anon_sym_noimplicitfloat] = ACTIONS(619),
    [anon_sym_noinline] = ACTIONS(619),
    [anon_sym_nomerge] = ACTIONS(619),
    [anon_sym_nonlazybind] = ACTIONS(619),
    [anon_sym_noprofile] = ACTIONS(619),
    [anon_sym_noredzone] = ACTIONS(619),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(619),
    [anon_sym_noreturn] = ACTIONS(619),
    [anon_sym_norecurse] = ACTIONS(619),
    [anon_sym_willreturn] = ACTIONS(619),
    [anon_sym_nosync] = ACTIONS(619),
    [anon_sym_nounwind] = ACTIONS(619),
    [anon_sym_nosanitize_coverage] = ACTIONS(619),
    [anon_sym_null_pointer_is_valid] = ACTIONS(619),
    [anon_sym_optforfuzzing] = ACTIONS(619),
    [anon_sym_optnone] = ACTIONS(619),
    [anon_sym_optsize] = ACTIONS(619),
    [anon_sym_readnone] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_writeonly] = ACTIONS(619),
    [anon_sym_argmemonly] = ACTIONS(619),
    [anon_sym_returns_twice] = ACTIONS(619),
    [anon_sym_safestack] = ACTIONS(619),
    [anon_sym_sanitize_address] = ACTIONS(619),
    [anon_sym_sanitize_memory] = ACTIONS(619),
    [anon_sym_sanitize_thread] = ACTIONS(619),
    [anon_sym_sanitize_hwaddress] = ACTIONS(619),
    [anon_sym_sanitize_memtag] = ACTIONS(619),
    [anon_sym_speculative_load_hardening] = ACTIONS(619),
    [anon_sym_speculatable] = ACTIONS(619),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(619),
    [anon_sym_sspreq] = ACTIONS(619),
    [anon_sym_strictfp] = ACTIONS(619),
    [anon_sym_uwtable] = ACTIONS(619),
    [anon_sym_nocf_check] = ACTIONS(619),
    [anon_sym_shadowcallstack] = ACTIONS(619),
    [anon_sym_mustprogress] = ACTIONS(619),
    [anon_sym_vscale_range] = ACTIONS(619),
    [anon_sym_preallocated] = ACTIONS(619),
    [anon_sym_zeroext] = ACTIONS(619),
    [anon_sym_signext] = ACTIONS(619),
    [anon_sym_inreg] = ACTIONS(619),
    [anon_sym_byval] = ACTIONS(619),
    [anon_sym_byref] = ACTIONS(619),
    [anon_sym_inalloca] = ACTIONS(619),
    [anon_sym_sret] = ACTIONS(619),
    [anon_sym_elementtype] = ACTIONS(619),
    [anon_sym_noalias] = ACTIONS(619),
    [anon_sym_nocapture] = ACTIONS(619),
    [anon_sym_nest] = ACTIONS(619),
    [anon_sym_returned] = ACTIONS(619),
    [anon_sym_nonnull] = ACTIONS(619),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(619),
    [anon_sym_swiftself] = ACTIONS(621),
    [anon_sym_swiftasync] = ACTIONS(621),
    [anon_sym_swifterror] = ACTIONS(621),
    [anon_sym_immarg] = ACTIONS(619),
    [anon_sym_noundef] = ACTIONS(619),
    [anon_sym_to] = ACTIONS(621),
    [anon_sym_unwind] = ACTIONS(619),
    [anon_sym_unordered] = ACTIONS(619),
    [anon_sym_monotonic] = ACTIONS(619),
    [anon_sym_acquire] = ACTIONS(619),
    [anon_sym_release] = ACTIONS(619),
    [anon_sym_acq_rel] = ACTIONS(619),
    [anon_sym_seq_cst] = ACTIONS(619),
    [anon_sym_syncscope] = ACTIONS(619),
    [anon_sym_uselistorder] = ACTIONS(621),
    [anon_sym_uselistorder_bb] = ACTIONS(619),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_attributes] = ACTIONS(619),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(623),
    [sym_global_var] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [aux_sym_metadata_ref_token1] = ACTIONS(623),
    [sym_summary_ref] = ACTIONS(623),
    [sym_string] = ACTIONS(623),
    [anon_sym_target] = ACTIONS(623),
    [anon_sym_source_filename] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_define] = ACTIONS(623),
    [anon_sym_no_cfi] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(623),
    [anon_sym_weak] = ACTIONS(625),
    [anon_sym_weak_odr] = ACTIONS(623),
    [anon_sym_linkonce] = ACTIONS(625),
    [anon_sym_linkonce_odr] = ACTIONS(623),
    [anon_sym_available_externally] = ACTIONS(623),
    [anon_sym_appending] = ACTIONS(623),
    [anon_sym_common] = ACTIONS(623),
    [anon_sym_extern_weak] = ACTIONS(623),
    [anon_sym_external] = ACTIONS(623),
    [anon_sym_dso_local] = ACTIONS(625),
    [anon_sym_dso_local_equivalent] = ACTIONS(623),
    [anon_sym_dso_preemptable] = ACTIONS(623),
    [anon_sym_default] = ACTIONS(623),
    [anon_sym_hidden] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_dllimport] = ACTIONS(623),
    [anon_sym_dllexport] = ACTIONS(623),
    [anon_sym_ccc] = ACTIONS(623),
    [anon_sym_fastcc] = ACTIONS(623),
    [anon_sym_coldcc] = ACTIONS(623),
    [anon_sym_webkit_jscc] = ACTIONS(625),
    [anon_sym_anyregcc] = ACTIONS(623),
    [anon_sym_preserve_mostcc] = ACTIONS(623),
    [anon_sym_preserve_allcc] = ACTIONS(623),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(625),
    [anon_sym_tailcc] = ACTIONS(623),
    [anon_sym_swiftcc] = ACTIONS(625),
    [anon_sym_swifttailcc] = ACTIONS(625),
    [anon_sym_cfguard_checkcc] = ACTIONS(623),
    [aux_sym_calling_conv_token1] = ACTIONS(625),
    [aux_sym_calling_conv_token2] = ACTIONS(623),
    [aux_sym_calling_conv_token3] = ACTIONS(623),
    [aux_sym_calling_conv_token4] = ACTIONS(623),
    [aux_sym_calling_conv_token5] = ACTIONS(623),
    [aux_sym_calling_conv_token6] = ACTIONS(623),
    [aux_sym_calling_conv_token7] = ACTIONS(623),
    [aux_sym_calling_conv_token8] = ACTIONS(623),
    [aux_sym_calling_conv_token9] = ACTIONS(623),
    [aux_sym_calling_conv_token10] = ACTIONS(625),
    [anon_sym_ghccc] = ACTIONS(623),
    [aux_sym_calling_conv_token11] = ACTIONS(625),
    [aux_sym_calling_conv_token12] = ACTIONS(623),
    [aux_sym_calling_conv_token13] = ACTIONS(625),
    [aux_sym_calling_conv_token14] = ACTIONS(623),
    [anon_sym_cc] = ACTIONS(625),
    [anon_sym_unnamed_addr] = ACTIONS(623),
    [anon_sym_local_unnamed_addr] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(623),
    [anon_sym_half] = ACTIONS(623),
    [anon_sym_bfloat] = ACTIONS(623),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_double] = ACTIONS(623),
    [anon_sym_x86_fp80] = ACTIONS(625),
    [anon_sym_fp128] = ACTIONS(623),
    [anon_sym_ppc_fp128] = ACTIONS(623),
    [anon_sym_label] = ACTIONS(623),
    [anon_sym_metadata] = ACTIONS(623),
    [anon_sym_x86_mmx] = ACTIONS(625),
    [anon_sym_x86_amx] = ACTIONS(625),
    [anon_sym_token] = ACTIONS(623),
    [anon_sym_opaque] = ACTIONS(623),
    [anon_sym_ptr] = ACTIONS(623),
    [aux_sym_type_keyword_token1] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LT_LBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_alignstack] = ACTIONS(623),
    [anon_sym_allocsize] = ACTIONS(623),
    [anon_sym_alwaysinline] = ACTIONS(623),
    [anon_sym_builtin] = ACTIONS(623),
    [anon_sym_cold] = ACTIONS(625),
    [anon_sym_convergent] = ACTIONS(623),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(623),
    [anon_sym_hot] = ACTIONS(623),
    [anon_sym_inaccessiblememonly] = ACTIONS(623),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(623),
    [anon_sym_inlinehint] = ACTIONS(623),
    [anon_sym_jumptable] = ACTIONS(623),
    [anon_sym_minsize] = ACTIONS(623),
    [anon_sym_naked] = ACTIONS(623),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(623),
    [anon_sym_nobuiltin] = ACTIONS(623),
    [anon_sym_noduplicate] = ACTIONS(623),
    [anon_sym_nofree] = ACTIONS(623),
    [anon_sym_noimplicitfloat] = ACTIONS(623),
    [anon_sym_noinline] = ACTIONS(623),
    [anon_sym_nomerge] = ACTIONS(623),
    [anon_sym_nonlazybind] = ACTIONS(623),
    [anon_sym_noprofile] = ACTIONS(623),
    [anon_sym_noredzone] = ACTIONS(623),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(623),
    [anon_sym_noreturn] = ACTIONS(623),
    [anon_sym_norecurse] = ACTIONS(623),
    [anon_sym_willreturn] = ACTIONS(623),
    [anon_sym_nosync] = ACTIONS(623),
    [anon_sym_nounwind] = ACTIONS(623),
    [anon_sym_nosanitize_coverage] = ACTIONS(623),
    [anon_sym_null_pointer_is_valid] = ACTIONS(623),
    [anon_sym_optforfuzzing] = ACTIONS(623),
    [anon_sym_optnone] = ACTIONS(623),
    [anon_sym_optsize] = ACTIONS(623),
    [anon_sym_readnone] = ACTIONS(623),
    [anon_sym_readonly] = ACTIONS(623),
    [anon_sym_writeonly] = ACTIONS(623),
    [anon_sym_argmemonly] = ACTIONS(623),
    [anon_sym_returns_twice] = ACTIONS(623),
    [anon_sym_safestack] = ACTIONS(623),
    [anon_sym_sanitize_address] = ACTIONS(623),
    [anon_sym_sanitize_memory] = ACTIONS(623),
    [anon_sym_sanitize_thread] = ACTIONS(623),
    [anon_sym_sanitize_hwaddress] = ACTIONS(623),
    [anon_sym_sanitize_memtag] = ACTIONS(623),
    [anon_sym_speculative_load_hardening] = ACTIONS(623),
    [anon_sym_speculatable] = ACTIONS(623),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(623),
    [anon_sym_sspreq] = ACTIONS(623),
    [anon_sym_strictfp] = ACTIONS(623),
    [anon_sym_uwtable] = ACTIONS(623),
    [anon_sym_nocf_check] = ACTIONS(623),
    [anon_sym_shadowcallstack] = ACTIONS(623),
    [anon_sym_mustprogress] = ACTIONS(623),
    [anon_sym_vscale_range] = ACTIONS(623),
    [anon_sym_preallocated] = ACTIONS(623),
    [anon_sym_zeroext] = ACTIONS(623),
    [anon_sym_signext] = ACTIONS(623),
    [anon_sym_inreg] = ACTIONS(623),
    [anon_sym_byval] = ACTIONS(623),
    [anon_sym_byref] = ACTIONS(623),
    [anon_sym_inalloca] = ACTIONS(623),
    [anon_sym_sret] = ACTIONS(623),
    [anon_sym_elementtype] = ACTIONS(623),
    [anon_sym_noalias] = ACTIONS(623),
    [anon_sym_nocapture] = ACTIONS(623),
    [anon_sym_nest] = ACTIONS(623),
    [anon_sym_returned] = ACTIONS(623),
    [anon_sym_nonnull] = ACTIONS(623),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(623),
    [anon_sym_swiftself] = ACTIONS(625),
    [anon_sym_swiftasync] = ACTIONS(625),
    [anon_sym_swifterror] = ACTIONS(625),
    [anon_sym_immarg] = ACTIONS(623),
    [anon_sym_noundef] = ACTIONS(623),
    [anon_sym_to] = ACTIONS(625),
    [anon_sym_unwind] = ACTIONS(623),
    [anon_sym_unordered] = ACTIONS(623),
    [anon_sym_monotonic] = ACTIONS(623),
    [anon_sym_acquire] = ACTIONS(623),
    [anon_sym_release] = ACTIONS(623),
    [anon_sym_acq_rel] = ACTIONS(623),
    [anon_sym_seq_cst] = ACTIONS(623),
    [anon_sym_syncscope] = ACTIONS(623),
    [anon_sym_uselistorder] = ACTIONS(625),
    [anon_sym_uselistorder_bb] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_attributes] = ACTIONS(623),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(627),
    [sym_global_var] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [aux_sym_metadata_ref_token1] = ACTIONS(627),
    [sym_summary_ref] = ACTIONS(627),
    [sym_string] = ACTIONS(627),
    [anon_sym_target] = ACTIONS(627),
    [anon_sym_source_filename] = ACTIONS(627),
    [anon_sym_declare] = ACTIONS(627),
    [anon_sym_define] = ACTIONS(627),
    [anon_sym_no_cfi] = ACTIONS(627),
    [anon_sym_private] = ACTIONS(627),
    [anon_sym_internal] = ACTIONS(627),
    [anon_sym_weak] = ACTIONS(629),
    [anon_sym_weak_odr] = ACTIONS(627),
    [anon_sym_linkonce] = ACTIONS(629),
    [anon_sym_linkonce_odr] = ACTIONS(627),
    [anon_sym_available_externally] = ACTIONS(627),
    [anon_sym_appending] = ACTIONS(627),
    [anon_sym_common] = ACTIONS(627),
    [anon_sym_extern_weak] = ACTIONS(627),
    [anon_sym_external] = ACTIONS(627),
    [anon_sym_dso_local] = ACTIONS(629),
    [anon_sym_dso_local_equivalent] = ACTIONS(627),
    [anon_sym_dso_preemptable] = ACTIONS(627),
    [anon_sym_default] = ACTIONS(627),
    [anon_sym_hidden] = ACTIONS(627),
    [anon_sym_protected] = ACTIONS(627),
    [anon_sym_dllimport] = ACTIONS(627),
    [anon_sym_dllexport] = ACTIONS(627),
    [anon_sym_ccc] = ACTIONS(627),
    [anon_sym_fastcc] = ACTIONS(627),
    [anon_sym_coldcc] = ACTIONS(627),
    [anon_sym_webkit_jscc] = ACTIONS(629),
    [anon_sym_anyregcc] = ACTIONS(627),
    [anon_sym_preserve_mostcc] = ACTIONS(627),
    [anon_sym_preserve_allcc] = ACTIONS(627),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(629),
    [anon_sym_tailcc] = ACTIONS(627),
    [anon_sym_swiftcc] = ACTIONS(629),
    [anon_sym_swifttailcc] = ACTIONS(629),
    [anon_sym_cfguard_checkcc] = ACTIONS(627),
    [aux_sym_calling_conv_token1] = ACTIONS(629),
    [aux_sym_calling_conv_token2] = ACTIONS(627),
    [aux_sym_calling_conv_token3] = ACTIONS(627),
    [aux_sym_calling_conv_token4] = ACTIONS(627),
    [aux_sym_calling_conv_token5] = ACTIONS(627),
    [aux_sym_calling_conv_token6] = ACTIONS(627),
    [aux_sym_calling_conv_token7] = ACTIONS(627),
    [aux_sym_calling_conv_token8] = ACTIONS(627),
    [aux_sym_calling_conv_token9] = ACTIONS(627),
    [aux_sym_calling_conv_token10] = ACTIONS(629),
    [anon_sym_ghccc] = ACTIONS(627),
    [aux_sym_calling_conv_token11] = ACTIONS(629),
    [aux_sym_calling_conv_token12] = ACTIONS(627),
    [aux_sym_calling_conv_token13] = ACTIONS(629),
    [aux_sym_calling_conv_token14] = ACTIONS(627),
    [anon_sym_cc] = ACTIONS(629),
    [anon_sym_unnamed_addr] = ACTIONS(627),
    [anon_sym_local_unnamed_addr] = ACTIONS(627),
    [anon_sym_void] = ACTIONS(627),
    [anon_sym_half] = ACTIONS(627),
    [anon_sym_bfloat] = ACTIONS(627),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_double] = ACTIONS(627),
    [anon_sym_x86_fp80] = ACTIONS(629),
    [anon_sym_fp128] = ACTIONS(627),
    [anon_sym_ppc_fp128] = ACTIONS(627),
    [anon_sym_label] = ACTIONS(627),
    [anon_sym_metadata] = ACTIONS(627),
    [anon_sym_x86_mmx] = ACTIONS(629),
    [anon_sym_x86_amx] = ACTIONS(629),
    [anon_sym_token] = ACTIONS(627),
    [anon_sym_opaque] = ACTIONS(627),
    [anon_sym_ptr] = ACTIONS(627),
    [aux_sym_type_keyword_token1] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LT_LBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_alignstack] = ACTIONS(627),
    [anon_sym_allocsize] = ACTIONS(627),
    [anon_sym_alwaysinline] = ACTIONS(627),
    [anon_sym_builtin] = ACTIONS(627),
    [anon_sym_cold] = ACTIONS(629),
    [anon_sym_convergent] = ACTIONS(627),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(627),
    [anon_sym_hot] = ACTIONS(627),
    [anon_sym_inaccessiblememonly] = ACTIONS(627),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(627),
    [anon_sym_inlinehint] = ACTIONS(627),
    [anon_sym_jumptable] = ACTIONS(627),
    [anon_sym_minsize] = ACTIONS(627),
    [anon_sym_naked] = ACTIONS(627),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(627),
    [anon_sym_nobuiltin] = ACTIONS(627),
    [anon_sym_noduplicate] = ACTIONS(627),
    [anon_sym_nofree] = ACTIONS(627),
    [anon_sym_noimplicitfloat] = ACTIONS(627),
    [anon_sym_noinline] = ACTIONS(627),
    [anon_sym_nomerge] = ACTIONS(627),
    [anon_sym_nonlazybind] = ACTIONS(627),
    [anon_sym_noprofile] = ACTIONS(627),
    [anon_sym_noredzone] = ACTIONS(627),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(627),
    [anon_sym_noreturn] = ACTIONS(627),
    [anon_sym_norecurse] = ACTIONS(627),
    [anon_sym_willreturn] = ACTIONS(627),
    [anon_sym_nosync] = ACTIONS(627),
    [anon_sym_nounwind] = ACTIONS(627),
    [anon_sym_nosanitize_coverage] = ACTIONS(627),
    [anon_sym_null_pointer_is_valid] = ACTIONS(627),
    [anon_sym_optforfuzzing] = ACTIONS(627),
    [anon_sym_optnone] = ACTIONS(627),
    [anon_sym_optsize] = ACTIONS(627),
    [anon_sym_readnone] = ACTIONS(627),
    [anon_sym_readonly] = ACTIONS(627),
    [anon_sym_writeonly] = ACTIONS(627),
    [anon_sym_argmemonly] = ACTIONS(627),
    [anon_sym_returns_twice] = ACTIONS(627),
    [anon_sym_safestack] = ACTIONS(627),
    [anon_sym_sanitize_address] = ACTIONS(627),
    [anon_sym_sanitize_memory] = ACTIONS(627),
    [anon_sym_sanitize_thread] = ACTIONS(627),
    [anon_sym_sanitize_hwaddress] = ACTIONS(627),
    [anon_sym_sanitize_memtag] = ACTIONS(627),
    [anon_sym_speculative_load_hardening] = ACTIONS(627),
    [anon_sym_speculatable] = ACTIONS(627),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(627),
    [anon_sym_sspreq] = ACTIONS(627),
    [anon_sym_strictfp] = ACTIONS(627),
    [anon_sym_uwtable] = ACTIONS(627),
    [anon_sym_nocf_check] = ACTIONS(627),
    [anon_sym_shadowcallstack] = ACTIONS(627),
    [anon_sym_mustprogress] = ACTIONS(627),
    [anon_sym_vscale_range] = ACTIONS(627),
    [anon_sym_preallocated] = ACTIONS(627),
    [anon_sym_zeroext] = ACTIONS(627),
    [anon_sym_signext] = ACTIONS(627),
    [anon_sym_inreg] = ACTIONS(627),
    [anon_sym_byval] = ACTIONS(627),
    [anon_sym_byref] = ACTIONS(627),
    [anon_sym_inalloca] = ACTIONS(627),
    [anon_sym_sret] = ACTIONS(627),
    [anon_sym_elementtype] = ACTIONS(627),
    [anon_sym_noalias] = ACTIONS(627),
    [anon_sym_nocapture] = ACTIONS(627),
    [anon_sym_nest] = ACTIONS(627),
    [anon_sym_returned] = ACTIONS(627),
    [anon_sym_nonnull] = ACTIONS(627),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(627),
    [anon_sym_swiftself] = ACTIONS(629),
    [anon_sym_swiftasync] = ACTIONS(629),
    [anon_sym_swifterror] = ACTIONS(629),
    [anon_sym_immarg] = ACTIONS(627),
    [anon_sym_noundef] = ACTIONS(627),
    [anon_sym_to] = ACTIONS(629),
    [anon_sym_unwind] = ACTIONS(627),
    [anon_sym_unordered] = ACTIONS(627),
    [anon_sym_monotonic] = ACTIONS(627),
    [anon_sym_acquire] = ACTIONS(627),
    [anon_sym_release] = ACTIONS(627),
    [anon_sym_acq_rel] = ACTIONS(627),
    [anon_sym_seq_cst] = ACTIONS(627),
    [anon_sym_syncscope] = ACTIONS(627),
    [anon_sym_uselistorder] = ACTIONS(629),
    [anon_sym_uselistorder_bb] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(627),
    [anon_sym_attributes] = ACTIONS(627),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(631),
    [sym_global_var] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [aux_sym_metadata_ref_token1] = ACTIONS(631),
    [sym_summary_ref] = ACTIONS(631),
    [sym_string] = ACTIONS(631),
    [anon_sym_target] = ACTIONS(631),
    [anon_sym_source_filename] = ACTIONS(631),
    [anon_sym_declare] = ACTIONS(631),
    [anon_sym_define] = ACTIONS(631),
    [anon_sym_no_cfi] = ACTIONS(631),
    [anon_sym_private] = ACTIONS(631),
    [anon_sym_internal] = ACTIONS(631),
    [anon_sym_weak] = ACTIONS(633),
    [anon_sym_weak_odr] = ACTIONS(631),
    [anon_sym_linkonce] = ACTIONS(633),
    [anon_sym_linkonce_odr] = ACTIONS(631),
    [anon_sym_available_externally] = ACTIONS(631),
    [anon_sym_appending] = ACTIONS(631),
    [anon_sym_common] = ACTIONS(631),
    [anon_sym_extern_weak] = ACTIONS(631),
    [anon_sym_external] = ACTIONS(631),
    [anon_sym_dso_local] = ACTIONS(633),
    [anon_sym_dso_local_equivalent] = ACTIONS(631),
    [anon_sym_dso_preemptable] = ACTIONS(631),
    [anon_sym_default] = ACTIONS(631),
    [anon_sym_hidden] = ACTIONS(631),
    [anon_sym_protected] = ACTIONS(631),
    [anon_sym_dllimport] = ACTIONS(631),
    [anon_sym_dllexport] = ACTIONS(631),
    [anon_sym_ccc] = ACTIONS(631),
    [anon_sym_fastcc] = ACTIONS(631),
    [anon_sym_coldcc] = ACTIONS(631),
    [anon_sym_webkit_jscc] = ACTIONS(633),
    [anon_sym_anyregcc] = ACTIONS(631),
    [anon_sym_preserve_mostcc] = ACTIONS(631),
    [anon_sym_preserve_allcc] = ACTIONS(631),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(633),
    [anon_sym_tailcc] = ACTIONS(631),
    [anon_sym_swiftcc] = ACTIONS(633),
    [anon_sym_swifttailcc] = ACTIONS(633),
    [anon_sym_cfguard_checkcc] = ACTIONS(631),
    [aux_sym_calling_conv_token1] = ACTIONS(633),
    [aux_sym_calling_conv_token2] = ACTIONS(631),
    [aux_sym_calling_conv_token3] = ACTIONS(631),
    [aux_sym_calling_conv_token4] = ACTIONS(631),
    [aux_sym_calling_conv_token5] = ACTIONS(631),
    [aux_sym_calling_conv_token6] = ACTIONS(631),
    [aux_sym_calling_conv_token7] = ACTIONS(631),
    [aux_sym_calling_conv_token8] = ACTIONS(631),
    [aux_sym_calling_conv_token9] = ACTIONS(631),
    [aux_sym_calling_conv_token10] = ACTIONS(633),
    [anon_sym_ghccc] = ACTIONS(631),
    [aux_sym_calling_conv_token11] = ACTIONS(633),
    [aux_sym_calling_conv_token12] = ACTIONS(631),
    [aux_sym_calling_conv_token13] = ACTIONS(633),
    [aux_sym_calling_conv_token14] = ACTIONS(631),
    [anon_sym_cc] = ACTIONS(633),
    [anon_sym_unnamed_addr] = ACTIONS(631),
    [anon_sym_local_unnamed_addr] = ACTIONS(631),
    [anon_sym_void] = ACTIONS(631),
    [anon_sym_half] = ACTIONS(631),
    [anon_sym_bfloat] = ACTIONS(631),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_double] = ACTIONS(631),
    [anon_sym_x86_fp80] = ACTIONS(633),
    [anon_sym_fp128] = ACTIONS(631),
    [anon_sym_ppc_fp128] = ACTIONS(631),
    [anon_sym_label] = ACTIONS(631),
    [anon_sym_metadata] = ACTIONS(631),
    [anon_sym_x86_mmx] = ACTIONS(633),
    [anon_sym_x86_amx] = ACTIONS(633),
    [anon_sym_token] = ACTIONS(631),
    [anon_sym_opaque] = ACTIONS(631),
    [anon_sym_ptr] = ACTIONS(631),
    [aux_sym_type_keyword_token1] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LT_LBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_alignstack] = ACTIONS(631),
    [anon_sym_allocsize] = ACTIONS(631),
    [anon_sym_alwaysinline] = ACTIONS(631),
    [anon_sym_builtin] = ACTIONS(631),
    [anon_sym_cold] = ACTIONS(633),
    [anon_sym_convergent] = ACTIONS(631),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(631),
    [anon_sym_hot] = ACTIONS(631),
    [anon_sym_inaccessiblememonly] = ACTIONS(631),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(631),
    [anon_sym_inlinehint] = ACTIONS(631),
    [anon_sym_jumptable] = ACTIONS(631),
    [anon_sym_minsize] = ACTIONS(631),
    [anon_sym_naked] = ACTIONS(631),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(631),
    [anon_sym_nobuiltin] = ACTIONS(631),
    [anon_sym_noduplicate] = ACTIONS(631),
    [anon_sym_nofree] = ACTIONS(631),
    [anon_sym_noimplicitfloat] = ACTIONS(631),
    [anon_sym_noinline] = ACTIONS(631),
    [anon_sym_nomerge] = ACTIONS(631),
    [anon_sym_nonlazybind] = ACTIONS(631),
    [anon_sym_noprofile] = ACTIONS(631),
    [anon_sym_noredzone] = ACTIONS(631),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(631),
    [anon_sym_noreturn] = ACTIONS(631),
    [anon_sym_norecurse] = ACTIONS(631),
    [anon_sym_willreturn] = ACTIONS(631),
    [anon_sym_nosync] = ACTIONS(631),
    [anon_sym_nounwind] = ACTIONS(631),
    [anon_sym_nosanitize_coverage] = ACTIONS(631),
    [anon_sym_null_pointer_is_valid] = ACTIONS(631),
    [anon_sym_optforfuzzing] = ACTIONS(631),
    [anon_sym_optnone] = ACTIONS(631),
    [anon_sym_optsize] = ACTIONS(631),
    [anon_sym_readnone] = ACTIONS(631),
    [anon_sym_readonly] = ACTIONS(631),
    [anon_sym_writeonly] = ACTIONS(631),
    [anon_sym_argmemonly] = ACTIONS(631),
    [anon_sym_returns_twice] = ACTIONS(631),
    [anon_sym_safestack] = ACTIONS(631),
    [anon_sym_sanitize_address] = ACTIONS(631),
    [anon_sym_sanitize_memory] = ACTIONS(631),
    [anon_sym_sanitize_thread] = ACTIONS(631),
    [anon_sym_sanitize_hwaddress] = ACTIONS(631),
    [anon_sym_sanitize_memtag] = ACTIONS(631),
    [anon_sym_speculative_load_hardening] = ACTIONS(631),
    [anon_sym_speculatable] = ACTIONS(631),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(631),
    [anon_sym_sspreq] = ACTIONS(631),
    [anon_sym_strictfp] = ACTIONS(631),
    [anon_sym_uwtable] = ACTIONS(631),
    [anon_sym_nocf_check] = ACTIONS(631),
    [anon_sym_shadowcallstack] = ACTIONS(631),
    [anon_sym_mustprogress] = ACTIONS(631),
    [anon_sym_vscale_range] = ACTIONS(631),
    [anon_sym_preallocated] = ACTIONS(631),
    [anon_sym_zeroext] = ACTIONS(631),
    [anon_sym_signext] = ACTIONS(631),
    [anon_sym_inreg] = ACTIONS(631),
    [anon_sym_byval] = ACTIONS(631),
    [anon_sym_byref] = ACTIONS(631),
    [anon_sym_inalloca] = ACTIONS(631),
    [anon_sym_sret] = ACTIONS(631),
    [anon_sym_elementtype] = ACTIONS(631),
    [anon_sym_noalias] = ACTIONS(631),
    [anon_sym_nocapture] = ACTIONS(631),
    [anon_sym_nest] = ACTIONS(631),
    [anon_sym_returned] = ACTIONS(631),
    [anon_sym_nonnull] = ACTIONS(631),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(631),
    [anon_sym_swiftself] = ACTIONS(633),
    [anon_sym_swiftasync] = ACTIONS(633),
    [anon_sym_swifterror] = ACTIONS(633),
    [anon_sym_immarg] = ACTIONS(631),
    [anon_sym_noundef] = ACTIONS(631),
    [anon_sym_to] = ACTIONS(633),
    [anon_sym_unwind] = ACTIONS(631),
    [anon_sym_unordered] = ACTIONS(631),
    [anon_sym_monotonic] = ACTIONS(631),
    [anon_sym_acquire] = ACTIONS(631),
    [anon_sym_release] = ACTIONS(631),
    [anon_sym_acq_rel] = ACTIONS(631),
    [anon_sym_seq_cst] = ACTIONS(631),
    [anon_sym_syncscope] = ACTIONS(631),
    [anon_sym_uselistorder] = ACTIONS(633),
    [anon_sym_uselistorder_bb] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_attributes] = ACTIONS(631),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(635),
    [sym_global_var] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [aux_sym_metadata_ref_token1] = ACTIONS(635),
    [sym_summary_ref] = ACTIONS(635),
    [sym_string] = ACTIONS(635),
    [anon_sym_target] = ACTIONS(635),
    [anon_sym_source_filename] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(635),
    [anon_sym_define] = ACTIONS(635),
    [anon_sym_no_cfi] = ACTIONS(635),
    [anon_sym_private] = ACTIONS(635),
    [anon_sym_internal] = ACTIONS(635),
    [anon_sym_weak] = ACTIONS(637),
    [anon_sym_weak_odr] = ACTIONS(635),
    [anon_sym_linkonce] = ACTIONS(637),
    [anon_sym_linkonce_odr] = ACTIONS(635),
    [anon_sym_available_externally] = ACTIONS(635),
    [anon_sym_appending] = ACTIONS(635),
    [anon_sym_common] = ACTIONS(635),
    [anon_sym_extern_weak] = ACTIONS(635),
    [anon_sym_external] = ACTIONS(635),
    [anon_sym_dso_local] = ACTIONS(637),
    [anon_sym_dso_local_equivalent] = ACTIONS(635),
    [anon_sym_dso_preemptable] = ACTIONS(635),
    [anon_sym_default] = ACTIONS(635),
    [anon_sym_hidden] = ACTIONS(635),
    [anon_sym_protected] = ACTIONS(635),
    [anon_sym_dllimport] = ACTIONS(635),
    [anon_sym_dllexport] = ACTIONS(635),
    [anon_sym_ccc] = ACTIONS(635),
    [anon_sym_fastcc] = ACTIONS(635),
    [anon_sym_coldcc] = ACTIONS(635),
    [anon_sym_webkit_jscc] = ACTIONS(637),
    [anon_sym_anyregcc] = ACTIONS(635),
    [anon_sym_preserve_mostcc] = ACTIONS(635),
    [anon_sym_preserve_allcc] = ACTIONS(635),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(637),
    [anon_sym_tailcc] = ACTIONS(635),
    [anon_sym_swiftcc] = ACTIONS(637),
    [anon_sym_swifttailcc] = ACTIONS(637),
    [anon_sym_cfguard_checkcc] = ACTIONS(635),
    [aux_sym_calling_conv_token1] = ACTIONS(637),
    [aux_sym_calling_conv_token2] = ACTIONS(635),
    [aux_sym_calling_conv_token3] = ACTIONS(635),
    [aux_sym_calling_conv_token4] = ACTIONS(635),
    [aux_sym_calling_conv_token5] = ACTIONS(635),
    [aux_sym_calling_conv_token6] = ACTIONS(635),
    [aux_sym_calling_conv_token7] = ACTIONS(635),
    [aux_sym_calling_conv_token8] = ACTIONS(635),
    [aux_sym_calling_conv_token9] = ACTIONS(635),
    [aux_sym_calling_conv_token10] = ACTIONS(637),
    [anon_sym_ghccc] = ACTIONS(635),
    [aux_sym_calling_conv_token11] = ACTIONS(637),
    [aux_sym_calling_conv_token12] = ACTIONS(635),
    [aux_sym_calling_conv_token13] = ACTIONS(637),
    [aux_sym_calling_conv_token14] = ACTIONS(635),
    [anon_sym_cc] = ACTIONS(637),
    [anon_sym_unnamed_addr] = ACTIONS(635),
    [anon_sym_local_unnamed_addr] = ACTIONS(635),
    [anon_sym_void] = ACTIONS(635),
    [anon_sym_half] = ACTIONS(635),
    [anon_sym_bfloat] = ACTIONS(635),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_double] = ACTIONS(635),
    [anon_sym_x86_fp80] = ACTIONS(637),
    [anon_sym_fp128] = ACTIONS(635),
    [anon_sym_ppc_fp128] = ACTIONS(635),
    [anon_sym_label] = ACTIONS(635),
    [anon_sym_metadata] = ACTIONS(635),
    [anon_sym_x86_mmx] = ACTIONS(637),
    [anon_sym_x86_amx] = ACTIONS(637),
    [anon_sym_token] = ACTIONS(635),
    [anon_sym_opaque] = ACTIONS(635),
    [anon_sym_ptr] = ACTIONS(635),
    [aux_sym_type_keyword_token1] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LT_LBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_alignstack] = ACTIONS(635),
    [anon_sym_allocsize] = ACTIONS(635),
    [anon_sym_alwaysinline] = ACTIONS(635),
    [anon_sym_builtin] = ACTIONS(635),
    [anon_sym_cold] = ACTIONS(637),
    [anon_sym_convergent] = ACTIONS(635),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(635),
    [anon_sym_hot] = ACTIONS(635),
    [anon_sym_inaccessiblememonly] = ACTIONS(635),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(635),
    [anon_sym_inlinehint] = ACTIONS(635),
    [anon_sym_jumptable] = ACTIONS(635),
    [anon_sym_minsize] = ACTIONS(635),
    [anon_sym_naked] = ACTIONS(635),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(635),
    [anon_sym_nobuiltin] = ACTIONS(635),
    [anon_sym_noduplicate] = ACTIONS(635),
    [anon_sym_nofree] = ACTIONS(635),
    [anon_sym_noimplicitfloat] = ACTIONS(635),
    [anon_sym_noinline] = ACTIONS(635),
    [anon_sym_nomerge] = ACTIONS(635),
    [anon_sym_nonlazybind] = ACTIONS(635),
    [anon_sym_noprofile] = ACTIONS(635),
    [anon_sym_noredzone] = ACTIONS(635),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(635),
    [anon_sym_noreturn] = ACTIONS(635),
    [anon_sym_norecurse] = ACTIONS(635),
    [anon_sym_willreturn] = ACTIONS(635),
    [anon_sym_nosync] = ACTIONS(635),
    [anon_sym_nounwind] = ACTIONS(635),
    [anon_sym_nosanitize_coverage] = ACTIONS(635),
    [anon_sym_null_pointer_is_valid] = ACTIONS(635),
    [anon_sym_optforfuzzing] = ACTIONS(635),
    [anon_sym_optnone] = ACTIONS(635),
    [anon_sym_optsize] = ACTIONS(635),
    [anon_sym_readnone] = ACTIONS(635),
    [anon_sym_readonly] = ACTIONS(635),
    [anon_sym_writeonly] = ACTIONS(635),
    [anon_sym_argmemonly] = ACTIONS(635),
    [anon_sym_returns_twice] = ACTIONS(635),
    [anon_sym_safestack] = ACTIONS(635),
    [anon_sym_sanitize_address] = ACTIONS(635),
    [anon_sym_sanitize_memory] = ACTIONS(635),
    [anon_sym_sanitize_thread] = ACTIONS(635),
    [anon_sym_sanitize_hwaddress] = ACTIONS(635),
    [anon_sym_sanitize_memtag] = ACTIONS(635),
    [anon_sym_speculative_load_hardening] = ACTIONS(635),
    [anon_sym_speculatable] = ACTIONS(635),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(635),
    [anon_sym_sspreq] = ACTIONS(635),
    [anon_sym_strictfp] = ACTIONS(635),
    [anon_sym_uwtable] = ACTIONS(635),
    [anon_sym_nocf_check] = ACTIONS(635),
    [anon_sym_shadowcallstack] = ACTIONS(635),
    [anon_sym_mustprogress] = ACTIONS(635),
    [anon_sym_vscale_range] = ACTIONS(635),
    [anon_sym_preallocated] = ACTIONS(635),
    [anon_sym_zeroext] = ACTIONS(635),
    [anon_sym_signext] = ACTIONS(635),
    [anon_sym_inreg] = ACTIONS(635),
    [anon_sym_byval] = ACTIONS(635),
    [anon_sym_byref] = ACTIONS(635),
    [anon_sym_inalloca] = ACTIONS(635),
    [anon_sym_sret] = ACTIONS(635),
    [anon_sym_elementtype] = ACTIONS(635),
    [anon_sym_noalias] = ACTIONS(635),
    [anon_sym_nocapture] = ACTIONS(635),
    [anon_sym_nest] = ACTIONS(635),
    [anon_sym_returned] = ACTIONS(635),
    [anon_sym_nonnull] = ACTIONS(635),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(635),
    [anon_sym_swiftself] = ACTIONS(637),
    [anon_sym_swiftasync] = ACTIONS(637),
    [anon_sym_swifterror] = ACTIONS(637),
    [anon_sym_immarg] = ACTIONS(635),
    [anon_sym_noundef] = ACTIONS(635),
    [anon_sym_to] = ACTIONS(637),
    [anon_sym_unwind] = ACTIONS(635),
    [anon_sym_unordered] = ACTIONS(635),
    [anon_sym_monotonic] = ACTIONS(635),
    [anon_sym_acquire] = ACTIONS(635),
    [anon_sym_release] = ACTIONS(635),
    [anon_sym_acq_rel] = ACTIONS(635),
    [anon_sym_seq_cst] = ACTIONS(635),
    [anon_sym_syncscope] = ACTIONS(635),
    [anon_sym_uselistorder] = ACTIONS(637),
    [anon_sym_uselistorder_bb] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_attributes] = ACTIONS(635),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(639),
    [sym_global_var] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [aux_sym_metadata_ref_token1] = ACTIONS(639),
    [sym_summary_ref] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [anon_sym_target] = ACTIONS(639),
    [anon_sym_source_filename] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(639),
    [anon_sym_define] = ACTIONS(639),
    [anon_sym_no_cfi] = ACTIONS(639),
    [anon_sym_private] = ACTIONS(639),
    [anon_sym_internal] = ACTIONS(639),
    [anon_sym_weak] = ACTIONS(641),
    [anon_sym_weak_odr] = ACTIONS(639),
    [anon_sym_linkonce] = ACTIONS(641),
    [anon_sym_linkonce_odr] = ACTIONS(639),
    [anon_sym_available_externally] = ACTIONS(639),
    [anon_sym_appending] = ACTIONS(639),
    [anon_sym_common] = ACTIONS(639),
    [anon_sym_extern_weak] = ACTIONS(639),
    [anon_sym_external] = ACTIONS(639),
    [anon_sym_dso_local] = ACTIONS(641),
    [anon_sym_dso_local_equivalent] = ACTIONS(639),
    [anon_sym_dso_preemptable] = ACTIONS(639),
    [anon_sym_default] = ACTIONS(639),
    [anon_sym_hidden] = ACTIONS(639),
    [anon_sym_protected] = ACTIONS(639),
    [anon_sym_dllimport] = ACTIONS(639),
    [anon_sym_dllexport] = ACTIONS(639),
    [anon_sym_ccc] = ACTIONS(639),
    [anon_sym_fastcc] = ACTIONS(639),
    [anon_sym_coldcc] = ACTIONS(639),
    [anon_sym_webkit_jscc] = ACTIONS(641),
    [anon_sym_anyregcc] = ACTIONS(639),
    [anon_sym_preserve_mostcc] = ACTIONS(639),
    [anon_sym_preserve_allcc] = ACTIONS(639),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(641),
    [anon_sym_tailcc] = ACTIONS(639),
    [anon_sym_swiftcc] = ACTIONS(641),
    [anon_sym_swifttailcc] = ACTIONS(641),
    [anon_sym_cfguard_checkcc] = ACTIONS(639),
    [aux_sym_calling_conv_token1] = ACTIONS(641),
    [aux_sym_calling_conv_token2] = ACTIONS(639),
    [aux_sym_calling_conv_token3] = ACTIONS(639),
    [aux_sym_calling_conv_token4] = ACTIONS(639),
    [aux_sym_calling_conv_token5] = ACTIONS(639),
    [aux_sym_calling_conv_token6] = ACTIONS(639),
    [aux_sym_calling_conv_token7] = ACTIONS(639),
    [aux_sym_calling_conv_token8] = ACTIONS(639),
    [aux_sym_calling_conv_token9] = ACTIONS(639),
    [aux_sym_calling_conv_token10] = ACTIONS(641),
    [anon_sym_ghccc] = ACTIONS(639),
    [aux_sym_calling_conv_token11] = ACTIONS(641),
    [aux_sym_calling_conv_token12] = ACTIONS(639),
    [aux_sym_calling_conv_token13] = ACTIONS(641),
    [aux_sym_calling_conv_token14] = ACTIONS(639),
    [anon_sym_cc] = ACTIONS(641),
    [anon_sym_unnamed_addr] = ACTIONS(639),
    [anon_sym_local_unnamed_addr] = ACTIONS(639),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_half] = ACTIONS(639),
    [anon_sym_bfloat] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(639),
    [anon_sym_double] = ACTIONS(639),
    [anon_sym_x86_fp80] = ACTIONS(641),
    [anon_sym_fp128] = ACTIONS(639),
    [anon_sym_ppc_fp128] = ACTIONS(639),
    [anon_sym_label] = ACTIONS(639),
    [anon_sym_metadata] = ACTIONS(639),
    [anon_sym_x86_mmx] = ACTIONS(641),
    [anon_sym_x86_amx] = ACTIONS(641),
    [anon_sym_token] = ACTIONS(639),
    [anon_sym_opaque] = ACTIONS(639),
    [anon_sym_ptr] = ACTIONS(639),
    [aux_sym_type_keyword_token1] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LT_LBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_alignstack] = ACTIONS(639),
    [anon_sym_allocsize] = ACTIONS(639),
    [anon_sym_alwaysinline] = ACTIONS(639),
    [anon_sym_builtin] = ACTIONS(639),
    [anon_sym_cold] = ACTIONS(641),
    [anon_sym_convergent] = ACTIONS(639),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(639),
    [anon_sym_hot] = ACTIONS(639),
    [anon_sym_inaccessiblememonly] = ACTIONS(639),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(639),
    [anon_sym_inlinehint] = ACTIONS(639),
    [anon_sym_jumptable] = ACTIONS(639),
    [anon_sym_minsize] = ACTIONS(639),
    [anon_sym_naked] = ACTIONS(639),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(639),
    [anon_sym_nobuiltin] = ACTIONS(639),
    [anon_sym_noduplicate] = ACTIONS(639),
    [anon_sym_nofree] = ACTIONS(639),
    [anon_sym_noimplicitfloat] = ACTIONS(639),
    [anon_sym_noinline] = ACTIONS(639),
    [anon_sym_nomerge] = ACTIONS(639),
    [anon_sym_nonlazybind] = ACTIONS(639),
    [anon_sym_noprofile] = ACTIONS(639),
    [anon_sym_noredzone] = ACTIONS(639),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(639),
    [anon_sym_noreturn] = ACTIONS(639),
    [anon_sym_norecurse] = ACTIONS(639),
    [anon_sym_willreturn] = ACTIONS(639),
    [anon_sym_nosync] = ACTIONS(639),
    [anon_sym_nounwind] = ACTIONS(639),
    [anon_sym_nosanitize_coverage] = ACTIONS(639),
    [anon_sym_null_pointer_is_valid] = ACTIONS(639),
    [anon_sym_optforfuzzing] = ACTIONS(639),
    [anon_sym_optnone] = ACTIONS(639),
    [anon_sym_optsize] = ACTIONS(639),
    [anon_sym_readnone] = ACTIONS(639),
    [anon_sym_readonly] = ACTIONS(639),
    [anon_sym_writeonly] = ACTIONS(639),
    [anon_sym_argmemonly] = ACTIONS(639),
    [anon_sym_returns_twice] = ACTIONS(639),
    [anon_sym_safestack] = ACTIONS(639),
    [anon_sym_sanitize_address] = ACTIONS(639),
    [anon_sym_sanitize_memory] = ACTIONS(639),
    [anon_sym_sanitize_thread] = ACTIONS(639),
    [anon_sym_sanitize_hwaddress] = ACTIONS(639),
    [anon_sym_sanitize_memtag] = ACTIONS(639),
    [anon_sym_speculative_load_hardening] = ACTIONS(639),
    [anon_sym_speculatable] = ACTIONS(639),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(639),
    [anon_sym_sspreq] = ACTIONS(639),
    [anon_sym_strictfp] = ACTIONS(639),
    [anon_sym_uwtable] = ACTIONS(639),
    [anon_sym_nocf_check] = ACTIONS(639),
    [anon_sym_shadowcallstack] = ACTIONS(639),
    [anon_sym_mustprogress] = ACTIONS(639),
    [anon_sym_vscale_range] = ACTIONS(639),
    [anon_sym_preallocated] = ACTIONS(639),
    [anon_sym_zeroext] = ACTIONS(639),
    [anon_sym_signext] = ACTIONS(639),
    [anon_sym_inreg] = ACTIONS(639),
    [anon_sym_byval] = ACTIONS(639),
    [anon_sym_byref] = ACTIONS(639),
    [anon_sym_inalloca] = ACTIONS(639),
    [anon_sym_sret] = ACTIONS(639),
    [anon_sym_elementtype] = ACTIONS(639),
    [anon_sym_noalias] = ACTIONS(639),
    [anon_sym_nocapture] = ACTIONS(639),
    [anon_sym_nest] = ACTIONS(639),
    [anon_sym_returned] = ACTIONS(639),
    [anon_sym_nonnull] = ACTIONS(639),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(639),
    [anon_sym_swiftself] = ACTIONS(641),
    [anon_sym_swiftasync] = ACTIONS(641),
    [anon_sym_swifterror] = ACTIONS(641),
    [anon_sym_immarg] = ACTIONS(639),
    [anon_sym_noundef] = ACTIONS(639),
    [anon_sym_to] = ACTIONS(641),
    [anon_sym_unwind] = ACTIONS(639),
    [anon_sym_unordered] = ACTIONS(639),
    [anon_sym_monotonic] = ACTIONS(639),
    [anon_sym_acquire] = ACTIONS(639),
    [anon_sym_release] = ACTIONS(639),
    [anon_sym_acq_rel] = ACTIONS(639),
    [anon_sym_seq_cst] = ACTIONS(639),
    [anon_sym_syncscope] = ACTIONS(639),
    [anon_sym_uselistorder] = ACTIONS(641),
    [anon_sym_uselistorder_bb] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(639),
    [anon_sym_attributes] = ACTIONS(639),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(643),
    [sym_global_var] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [aux_sym_metadata_ref_token1] = ACTIONS(643),
    [sym_summary_ref] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [anon_sym_target] = ACTIONS(643),
    [anon_sym_source_filename] = ACTIONS(643),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_define] = ACTIONS(643),
    [anon_sym_no_cfi] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_weak] = ACTIONS(645),
    [anon_sym_weak_odr] = ACTIONS(643),
    [anon_sym_linkonce] = ACTIONS(645),
    [anon_sym_linkonce_odr] = ACTIONS(643),
    [anon_sym_available_externally] = ACTIONS(643),
    [anon_sym_appending] = ACTIONS(643),
    [anon_sym_common] = ACTIONS(643),
    [anon_sym_extern_weak] = ACTIONS(643),
    [anon_sym_external] = ACTIONS(643),
    [anon_sym_dso_local] = ACTIONS(645),
    [anon_sym_dso_local_equivalent] = ACTIONS(643),
    [anon_sym_dso_preemptable] = ACTIONS(643),
    [anon_sym_default] = ACTIONS(643),
    [anon_sym_hidden] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_dllimport] = ACTIONS(643),
    [anon_sym_dllexport] = ACTIONS(643),
    [anon_sym_ccc] = ACTIONS(643),
    [anon_sym_fastcc] = ACTIONS(643),
    [anon_sym_coldcc] = ACTIONS(643),
    [anon_sym_webkit_jscc] = ACTIONS(645),
    [anon_sym_anyregcc] = ACTIONS(643),
    [anon_sym_preserve_mostcc] = ACTIONS(643),
    [anon_sym_preserve_allcc] = ACTIONS(643),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(645),
    [anon_sym_tailcc] = ACTIONS(643),
    [anon_sym_swiftcc] = ACTIONS(645),
    [anon_sym_swifttailcc] = ACTIONS(645),
    [anon_sym_cfguard_checkcc] = ACTIONS(643),
    [aux_sym_calling_conv_token1] = ACTIONS(645),
    [aux_sym_calling_conv_token2] = ACTIONS(643),
    [aux_sym_calling_conv_token3] = ACTIONS(643),
    [aux_sym_calling_conv_token4] = ACTIONS(643),
    [aux_sym_calling_conv_token5] = ACTIONS(643),
    [aux_sym_calling_conv_token6] = ACTIONS(643),
    [aux_sym_calling_conv_token7] = ACTIONS(643),
    [aux_sym_calling_conv_token8] = ACTIONS(643),
    [aux_sym_calling_conv_token9] = ACTIONS(643),
    [aux_sym_calling_conv_token10] = ACTIONS(645),
    [anon_sym_ghccc] = ACTIONS(643),
    [aux_sym_calling_conv_token11] = ACTIONS(645),
    [aux_sym_calling_conv_token12] = ACTIONS(643),
    [aux_sym_calling_conv_token13] = ACTIONS(645),
    [aux_sym_calling_conv_token14] = ACTIONS(643),
    [anon_sym_cc] = ACTIONS(645),
    [anon_sym_unnamed_addr] = ACTIONS(643),
    [anon_sym_local_unnamed_addr] = ACTIONS(643),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_half] = ACTIONS(643),
    [anon_sym_bfloat] = ACTIONS(643),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_double] = ACTIONS(643),
    [anon_sym_x86_fp80] = ACTIONS(645),
    [anon_sym_fp128] = ACTIONS(643),
    [anon_sym_ppc_fp128] = ACTIONS(643),
    [anon_sym_label] = ACTIONS(643),
    [anon_sym_metadata] = ACTIONS(643),
    [anon_sym_x86_mmx] = ACTIONS(645),
    [anon_sym_x86_amx] = ACTIONS(645),
    [anon_sym_token] = ACTIONS(643),
    [anon_sym_opaque] = ACTIONS(643),
    [anon_sym_ptr] = ACTIONS(643),
    [aux_sym_type_keyword_token1] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_LBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_alignstack] = ACTIONS(643),
    [anon_sym_allocsize] = ACTIONS(643),
    [anon_sym_alwaysinline] = ACTIONS(643),
    [anon_sym_builtin] = ACTIONS(643),
    [anon_sym_cold] = ACTIONS(645),
    [anon_sym_convergent] = ACTIONS(643),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(643),
    [anon_sym_hot] = ACTIONS(643),
    [anon_sym_inaccessiblememonly] = ACTIONS(643),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(643),
    [anon_sym_inlinehint] = ACTIONS(643),
    [anon_sym_jumptable] = ACTIONS(643),
    [anon_sym_minsize] = ACTIONS(643),
    [anon_sym_naked] = ACTIONS(643),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(643),
    [anon_sym_nobuiltin] = ACTIONS(643),
    [anon_sym_noduplicate] = ACTIONS(643),
    [anon_sym_nofree] = ACTIONS(643),
    [anon_sym_noimplicitfloat] = ACTIONS(643),
    [anon_sym_noinline] = ACTIONS(643),
    [anon_sym_nomerge] = ACTIONS(643),
    [anon_sym_nonlazybind] = ACTIONS(643),
    [anon_sym_noprofile] = ACTIONS(643),
    [anon_sym_noredzone] = ACTIONS(643),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(643),
    [anon_sym_noreturn] = ACTIONS(643),
    [anon_sym_norecurse] = ACTIONS(643),
    [anon_sym_willreturn] = ACTIONS(643),
    [anon_sym_nosync] = ACTIONS(643),
    [anon_sym_nounwind] = ACTIONS(643),
    [anon_sym_nosanitize_coverage] = ACTIONS(643),
    [anon_sym_null_pointer_is_valid] = ACTIONS(643),
    [anon_sym_optforfuzzing] = ACTIONS(643),
    [anon_sym_optnone] = ACTIONS(643),
    [anon_sym_optsize] = ACTIONS(643),
    [anon_sym_readnone] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_writeonly] = ACTIONS(643),
    [anon_sym_argmemonly] = ACTIONS(643),
    [anon_sym_returns_twice] = ACTIONS(643),
    [anon_sym_safestack] = ACTIONS(643),
    [anon_sym_sanitize_address] = ACTIONS(643),
    [anon_sym_sanitize_memory] = ACTIONS(643),
    [anon_sym_sanitize_thread] = ACTIONS(643),
    [anon_sym_sanitize_hwaddress] = ACTIONS(643),
    [anon_sym_sanitize_memtag] = ACTIONS(643),
    [anon_sym_speculative_load_hardening] = ACTIONS(643),
    [anon_sym_speculatable] = ACTIONS(643),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(643),
    [anon_sym_sspreq] = ACTIONS(643),
    [anon_sym_strictfp] = ACTIONS(643),
    [anon_sym_uwtable] = ACTIONS(643),
    [anon_sym_nocf_check] = ACTIONS(643),
    [anon_sym_shadowcallstack] = ACTIONS(643),
    [anon_sym_mustprogress] = ACTIONS(643),
    [anon_sym_vscale_range] = ACTIONS(643),
    [anon_sym_preallocated] = ACTIONS(643),
    [anon_sym_zeroext] = ACTIONS(643),
    [anon_sym_signext] = ACTIONS(643),
    [anon_sym_inreg] = ACTIONS(643),
    [anon_sym_byval] = ACTIONS(643),
    [anon_sym_byref] = ACTIONS(643),
    [anon_sym_inalloca] = ACTIONS(643),
    [anon_sym_sret] = ACTIONS(643),
    [anon_sym_elementtype] = ACTIONS(643),
    [anon_sym_noalias] = ACTIONS(643),
    [anon_sym_nocapture] = ACTIONS(643),
    [anon_sym_nest] = ACTIONS(643),
    [anon_sym_returned] = ACTIONS(643),
    [anon_sym_nonnull] = ACTIONS(643),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(643),
    [anon_sym_swiftself] = ACTIONS(645),
    [anon_sym_swiftasync] = ACTIONS(645),
    [anon_sym_swifterror] = ACTIONS(645),
    [anon_sym_immarg] = ACTIONS(643),
    [anon_sym_noundef] = ACTIONS(643),
    [anon_sym_to] = ACTIONS(645),
    [anon_sym_unwind] = ACTIONS(643),
    [anon_sym_unordered] = ACTIONS(643),
    [anon_sym_monotonic] = ACTIONS(643),
    [anon_sym_acquire] = ACTIONS(643),
    [anon_sym_release] = ACTIONS(643),
    [anon_sym_acq_rel] = ACTIONS(643),
    [anon_sym_seq_cst] = ACTIONS(643),
    [anon_sym_syncscope] = ACTIONS(643),
    [anon_sym_uselistorder] = ACTIONS(645),
    [anon_sym_uselistorder_bb] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_attributes] = ACTIONS(643),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(647),
    [sym_global_var] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [aux_sym_metadata_ref_token1] = ACTIONS(647),
    [sym_summary_ref] = ACTIONS(647),
    [sym_string] = ACTIONS(647),
    [anon_sym_target] = ACTIONS(647),
    [anon_sym_source_filename] = ACTIONS(647),
    [anon_sym_declare] = ACTIONS(647),
    [anon_sym_define] = ACTIONS(647),
    [anon_sym_no_cfi] = ACTIONS(647),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_internal] = ACTIONS(647),
    [anon_sym_weak] = ACTIONS(649),
    [anon_sym_weak_odr] = ACTIONS(647),
    [anon_sym_linkonce] = ACTIONS(649),
    [anon_sym_linkonce_odr] = ACTIONS(647),
    [anon_sym_available_externally] = ACTIONS(647),
    [anon_sym_appending] = ACTIONS(647),
    [anon_sym_common] = ACTIONS(647),
    [anon_sym_extern_weak] = ACTIONS(647),
    [anon_sym_external] = ACTIONS(647),
    [anon_sym_dso_local] = ACTIONS(649),
    [anon_sym_dso_local_equivalent] = ACTIONS(647),
    [anon_sym_dso_preemptable] = ACTIONS(647),
    [anon_sym_default] = ACTIONS(647),
    [anon_sym_hidden] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(647),
    [anon_sym_dllimport] = ACTIONS(647),
    [anon_sym_dllexport] = ACTIONS(647),
    [anon_sym_ccc] = ACTIONS(647),
    [anon_sym_fastcc] = ACTIONS(647),
    [anon_sym_coldcc] = ACTIONS(647),
    [anon_sym_webkit_jscc] = ACTIONS(649),
    [anon_sym_anyregcc] = ACTIONS(647),
    [anon_sym_preserve_mostcc] = ACTIONS(647),
    [anon_sym_preserve_allcc] = ACTIONS(647),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(649),
    [anon_sym_tailcc] = ACTIONS(647),
    [anon_sym_swiftcc] = ACTIONS(649),
    [anon_sym_swifttailcc] = ACTIONS(649),
    [anon_sym_cfguard_checkcc] = ACTIONS(647),
    [aux_sym_calling_conv_token1] = ACTIONS(649),
    [aux_sym_calling_conv_token2] = ACTIONS(647),
    [aux_sym_calling_conv_token3] = ACTIONS(647),
    [aux_sym_calling_conv_token4] = ACTIONS(647),
    [aux_sym_calling_conv_token5] = ACTIONS(647),
    [aux_sym_calling_conv_token6] = ACTIONS(647),
    [aux_sym_calling_conv_token7] = ACTIONS(647),
    [aux_sym_calling_conv_token8] = ACTIONS(647),
    [aux_sym_calling_conv_token9] = ACTIONS(647),
    [aux_sym_calling_conv_token10] = ACTIONS(649),
    [anon_sym_ghccc] = ACTIONS(647),
    [aux_sym_calling_conv_token11] = ACTIONS(649),
    [aux_sym_calling_conv_token12] = ACTIONS(647),
    [aux_sym_calling_conv_token13] = ACTIONS(649),
    [aux_sym_calling_conv_token14] = ACTIONS(647),
    [anon_sym_cc] = ACTIONS(649),
    [anon_sym_unnamed_addr] = ACTIONS(647),
    [anon_sym_local_unnamed_addr] = ACTIONS(647),
    [anon_sym_void] = ACTIONS(647),
    [anon_sym_half] = ACTIONS(647),
    [anon_sym_bfloat] = ACTIONS(647),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_double] = ACTIONS(647),
    [anon_sym_x86_fp80] = ACTIONS(649),
    [anon_sym_fp128] = ACTIONS(647),
    [anon_sym_ppc_fp128] = ACTIONS(647),
    [anon_sym_label] = ACTIONS(647),
    [anon_sym_metadata] = ACTIONS(647),
    [anon_sym_x86_mmx] = ACTIONS(649),
    [anon_sym_x86_amx] = ACTIONS(649),
    [anon_sym_token] = ACTIONS(647),
    [anon_sym_opaque] = ACTIONS(647),
    [anon_sym_ptr] = ACTIONS(647),
    [aux_sym_type_keyword_token1] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LT_LBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_alignstack] = ACTIONS(647),
    [anon_sym_allocsize] = ACTIONS(647),
    [anon_sym_alwaysinline] = ACTIONS(647),
    [anon_sym_builtin] = ACTIONS(647),
    [anon_sym_cold] = ACTIONS(649),
    [anon_sym_convergent] = ACTIONS(647),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(647),
    [anon_sym_hot] = ACTIONS(647),
    [anon_sym_inaccessiblememonly] = ACTIONS(647),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(647),
    [anon_sym_inlinehint] = ACTIONS(647),
    [anon_sym_jumptable] = ACTIONS(647),
    [anon_sym_minsize] = ACTIONS(647),
    [anon_sym_naked] = ACTIONS(647),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(647),
    [anon_sym_nobuiltin] = ACTIONS(647),
    [anon_sym_noduplicate] = ACTIONS(647),
    [anon_sym_nofree] = ACTIONS(647),
    [anon_sym_noimplicitfloat] = ACTIONS(647),
    [anon_sym_noinline] = ACTIONS(647),
    [anon_sym_nomerge] = ACTIONS(647),
    [anon_sym_nonlazybind] = ACTIONS(647),
    [anon_sym_noprofile] = ACTIONS(647),
    [anon_sym_noredzone] = ACTIONS(647),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(647),
    [anon_sym_noreturn] = ACTIONS(647),
    [anon_sym_norecurse] = ACTIONS(647),
    [anon_sym_willreturn] = ACTIONS(647),
    [anon_sym_nosync] = ACTIONS(647),
    [anon_sym_nounwind] = ACTIONS(647),
    [anon_sym_nosanitize_coverage] = ACTIONS(647),
    [anon_sym_null_pointer_is_valid] = ACTIONS(647),
    [anon_sym_optforfuzzing] = ACTIONS(647),
    [anon_sym_optnone] = ACTIONS(647),
    [anon_sym_optsize] = ACTIONS(647),
    [anon_sym_readnone] = ACTIONS(647),
    [anon_sym_readonly] = ACTIONS(647),
    [anon_sym_writeonly] = ACTIONS(647),
    [anon_sym_argmemonly] = ACTIONS(647),
    [anon_sym_returns_twice] = ACTIONS(647),
    [anon_sym_safestack] = ACTIONS(647),
    [anon_sym_sanitize_address] = ACTIONS(647),
    [anon_sym_sanitize_memory] = ACTIONS(647),
    [anon_sym_sanitize_thread] = ACTIONS(647),
    [anon_sym_sanitize_hwaddress] = ACTIONS(647),
    [anon_sym_sanitize_memtag] = ACTIONS(647),
    [anon_sym_speculative_load_hardening] = ACTIONS(647),
    [anon_sym_speculatable] = ACTIONS(647),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(647),
    [anon_sym_sspreq] = ACTIONS(647),
    [anon_sym_strictfp] = ACTIONS(647),
    [anon_sym_uwtable] = ACTIONS(647),
    [anon_sym_nocf_check] = ACTIONS(647),
    [anon_sym_shadowcallstack] = ACTIONS(647),
    [anon_sym_mustprogress] = ACTIONS(647),
    [anon_sym_vscale_range] = ACTIONS(647),
    [anon_sym_preallocated] = ACTIONS(647),
    [anon_sym_zeroext] = ACTIONS(647),
    [anon_sym_signext] = ACTIONS(647),
    [anon_sym_inreg] = ACTIONS(647),
    [anon_sym_byval] = ACTIONS(647),
    [anon_sym_byref] = ACTIONS(647),
    [anon_sym_inalloca] = ACTIONS(647),
    [anon_sym_sret] = ACTIONS(647),
    [anon_sym_elementtype] = ACTIONS(647),
    [anon_sym_noalias] = ACTIONS(647),
    [anon_sym_nocapture] = ACTIONS(647),
    [anon_sym_nest] = ACTIONS(647),
    [anon_sym_returned] = ACTIONS(647),
    [anon_sym_nonnull] = ACTIONS(647),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(647),
    [anon_sym_swiftself] = ACTIONS(649),
    [anon_sym_swiftasync] = ACTIONS(649),
    [anon_sym_swifterror] = ACTIONS(649),
    [anon_sym_immarg] = ACTIONS(647),
    [anon_sym_noundef] = ACTIONS(647),
    [anon_sym_to] = ACTIONS(649),
    [anon_sym_unwind] = ACTIONS(647),
    [anon_sym_unordered] = ACTIONS(647),
    [anon_sym_monotonic] = ACTIONS(647),
    [anon_sym_acquire] = ACTIONS(647),
    [anon_sym_release] = ACTIONS(647),
    [anon_sym_acq_rel] = ACTIONS(647),
    [anon_sym_seq_cst] = ACTIONS(647),
    [anon_sym_syncscope] = ACTIONS(647),
    [anon_sym_uselistorder] = ACTIONS(649),
    [anon_sym_uselistorder_bb] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_attributes] = ACTIONS(647),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(651),
    [sym_global_var] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [aux_sym_metadata_ref_token1] = ACTIONS(651),
    [sym_summary_ref] = ACTIONS(651),
    [sym_string] = ACTIONS(651),
    [anon_sym_target] = ACTIONS(651),
    [anon_sym_source_filename] = ACTIONS(651),
    [anon_sym_declare] = ACTIONS(651),
    [anon_sym_define] = ACTIONS(651),
    [anon_sym_no_cfi] = ACTIONS(651),
    [anon_sym_private] = ACTIONS(651),
    [anon_sym_internal] = ACTIONS(651),
    [anon_sym_weak] = ACTIONS(653),
    [anon_sym_weak_odr] = ACTIONS(651),
    [anon_sym_linkonce] = ACTIONS(653),
    [anon_sym_linkonce_odr] = ACTIONS(651),
    [anon_sym_available_externally] = ACTIONS(651),
    [anon_sym_appending] = ACTIONS(651),
    [anon_sym_common] = ACTIONS(651),
    [anon_sym_extern_weak] = ACTIONS(651),
    [anon_sym_external] = ACTIONS(651),
    [anon_sym_dso_local] = ACTIONS(653),
    [anon_sym_dso_local_equivalent] = ACTIONS(651),
    [anon_sym_dso_preemptable] = ACTIONS(651),
    [anon_sym_default] = ACTIONS(651),
    [anon_sym_hidden] = ACTIONS(651),
    [anon_sym_protected] = ACTIONS(651),
    [anon_sym_dllimport] = ACTIONS(651),
    [anon_sym_dllexport] = ACTIONS(651),
    [anon_sym_ccc] = ACTIONS(651),
    [anon_sym_fastcc] = ACTIONS(651),
    [anon_sym_coldcc] = ACTIONS(651),
    [anon_sym_webkit_jscc] = ACTIONS(653),
    [anon_sym_anyregcc] = ACTIONS(651),
    [anon_sym_preserve_mostcc] = ACTIONS(651),
    [anon_sym_preserve_allcc] = ACTIONS(651),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(653),
    [anon_sym_tailcc] = ACTIONS(651),
    [anon_sym_swiftcc] = ACTIONS(653),
    [anon_sym_swifttailcc] = ACTIONS(653),
    [anon_sym_cfguard_checkcc] = ACTIONS(651),
    [aux_sym_calling_conv_token1] = ACTIONS(653),
    [aux_sym_calling_conv_token2] = ACTIONS(651),
    [aux_sym_calling_conv_token3] = ACTIONS(651),
    [aux_sym_calling_conv_token4] = ACTIONS(651),
    [aux_sym_calling_conv_token5] = ACTIONS(651),
    [aux_sym_calling_conv_token6] = ACTIONS(651),
    [aux_sym_calling_conv_token7] = ACTIONS(651),
    [aux_sym_calling_conv_token8] = ACTIONS(651),
    [aux_sym_calling_conv_token9] = ACTIONS(651),
    [aux_sym_calling_conv_token10] = ACTIONS(653),
    [anon_sym_ghccc] = ACTIONS(651),
    [aux_sym_calling_conv_token11] = ACTIONS(653),
    [aux_sym_calling_conv_token12] = ACTIONS(651),
    [aux_sym_calling_conv_token13] = ACTIONS(653),
    [aux_sym_calling_conv_token14] = ACTIONS(651),
    [anon_sym_cc] = ACTIONS(653),
    [anon_sym_unnamed_addr] = ACTIONS(651),
    [anon_sym_local_unnamed_addr] = ACTIONS(651),
    [anon_sym_void] = ACTIONS(651),
    [anon_sym_half] = ACTIONS(651),
    [anon_sym_bfloat] = ACTIONS(651),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_double] = ACTIONS(651),
    [anon_sym_x86_fp80] = ACTIONS(653),
    [anon_sym_fp128] = ACTIONS(651),
    [anon_sym_ppc_fp128] = ACTIONS(651),
    [anon_sym_label] = ACTIONS(651),
    [anon_sym_metadata] = ACTIONS(651),
    [anon_sym_x86_mmx] = ACTIONS(653),
    [anon_sym_x86_amx] = ACTIONS(653),
    [anon_sym_token] = ACTIONS(651),
    [anon_sym_opaque] = ACTIONS(651),
    [anon_sym_ptr] = ACTIONS(651),
    [aux_sym_type_keyword_token1] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_LBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_alignstack] = ACTIONS(651),
    [anon_sym_allocsize] = ACTIONS(651),
    [anon_sym_alwaysinline] = ACTIONS(651),
    [anon_sym_builtin] = ACTIONS(651),
    [anon_sym_cold] = ACTIONS(653),
    [anon_sym_convergent] = ACTIONS(651),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(651),
    [anon_sym_hot] = ACTIONS(651),
    [anon_sym_inaccessiblememonly] = ACTIONS(651),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(651),
    [anon_sym_inlinehint] = ACTIONS(651),
    [anon_sym_jumptable] = ACTIONS(651),
    [anon_sym_minsize] = ACTIONS(651),
    [anon_sym_naked] = ACTIONS(651),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(651),
    [anon_sym_nobuiltin] = ACTIONS(651),
    [anon_sym_noduplicate] = ACTIONS(651),
    [anon_sym_nofree] = ACTIONS(651),
    [anon_sym_noimplicitfloat] = ACTIONS(651),
    [anon_sym_noinline] = ACTIONS(651),
    [anon_sym_nomerge] = ACTIONS(651),
    [anon_sym_nonlazybind] = ACTIONS(651),
    [anon_sym_noprofile] = ACTIONS(651),
    [anon_sym_noredzone] = ACTIONS(651),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(651),
    [anon_sym_noreturn] = ACTIONS(651),
    [anon_sym_norecurse] = ACTIONS(651),
    [anon_sym_willreturn] = ACTIONS(651),
    [anon_sym_nosync] = ACTIONS(651),
    [anon_sym_nounwind] = ACTIONS(651),
    [anon_sym_nosanitize_coverage] = ACTIONS(651),
    [anon_sym_null_pointer_is_valid] = ACTIONS(651),
    [anon_sym_optforfuzzing] = ACTIONS(651),
    [anon_sym_optnone] = ACTIONS(651),
    [anon_sym_optsize] = ACTIONS(651),
    [anon_sym_readnone] = ACTIONS(651),
    [anon_sym_readonly] = ACTIONS(651),
    [anon_sym_writeonly] = ACTIONS(651),
    [anon_sym_argmemonly] = ACTIONS(651),
    [anon_sym_returns_twice] = ACTIONS(651),
    [anon_sym_safestack] = ACTIONS(651),
    [anon_sym_sanitize_address] = ACTIONS(651),
    [anon_sym_sanitize_memory] = ACTIONS(651),
    [anon_sym_sanitize_thread] = ACTIONS(651),
    [anon_sym_sanitize_hwaddress] = ACTIONS(651),
    [anon_sym_sanitize_memtag] = ACTIONS(651),
    [anon_sym_speculative_load_hardening] = ACTIONS(651),
    [anon_sym_speculatable] = ACTIONS(651),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(651),
    [anon_sym_sspreq] = ACTIONS(651),
    [anon_sym_strictfp] = ACTIONS(651),
    [anon_sym_uwtable] = ACTIONS(651),
    [anon_sym_nocf_check] = ACTIONS(651),
    [anon_sym_shadowcallstack] = ACTIONS(651),
    [anon_sym_mustprogress] = ACTIONS(651),
    [anon_sym_vscale_range] = ACTIONS(651),
    [anon_sym_preallocated] = ACTIONS(651),
    [anon_sym_zeroext] = ACTIONS(651),
    [anon_sym_signext] = ACTIONS(651),
    [anon_sym_inreg] = ACTIONS(651),
    [anon_sym_byval] = ACTIONS(651),
    [anon_sym_byref] = ACTIONS(651),
    [anon_sym_inalloca] = ACTIONS(651),
    [anon_sym_sret] = ACTIONS(651),
    [anon_sym_elementtype] = ACTIONS(651),
    [anon_sym_noalias] = ACTIONS(651),
    [anon_sym_nocapture] = ACTIONS(651),
    [anon_sym_nest] = ACTIONS(651),
    [anon_sym_returned] = ACTIONS(651),
    [anon_sym_nonnull] = ACTIONS(651),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(651),
    [anon_sym_swiftself] = ACTIONS(653),
    [anon_sym_swiftasync] = ACTIONS(653),
    [anon_sym_swifterror] = ACTIONS(653),
    [anon_sym_immarg] = ACTIONS(651),
    [anon_sym_noundef] = ACTIONS(651),
    [anon_sym_to] = ACTIONS(653),
    [anon_sym_unwind] = ACTIONS(651),
    [anon_sym_unordered] = ACTIONS(651),
    [anon_sym_monotonic] = ACTIONS(651),
    [anon_sym_acquire] = ACTIONS(651),
    [anon_sym_release] = ACTIONS(651),
    [anon_sym_acq_rel] = ACTIONS(651),
    [anon_sym_seq_cst] = ACTIONS(651),
    [anon_sym_syncscope] = ACTIONS(651),
    [anon_sym_uselistorder] = ACTIONS(653),
    [anon_sym_uselistorder_bb] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_attributes] = ACTIONS(651),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(655),
    [sym_global_var] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [aux_sym_metadata_ref_token1] = ACTIONS(655),
    [sym_summary_ref] = ACTIONS(655),
    [sym_string] = ACTIONS(655),
    [anon_sym_target] = ACTIONS(655),
    [anon_sym_source_filename] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_define] = ACTIONS(655),
    [anon_sym_no_cfi] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_internal] = ACTIONS(655),
    [anon_sym_weak] = ACTIONS(657),
    [anon_sym_weak_odr] = ACTIONS(655),
    [anon_sym_linkonce] = ACTIONS(657),
    [anon_sym_linkonce_odr] = ACTIONS(655),
    [anon_sym_available_externally] = ACTIONS(655),
    [anon_sym_appending] = ACTIONS(655),
    [anon_sym_common] = ACTIONS(655),
    [anon_sym_extern_weak] = ACTIONS(655),
    [anon_sym_external] = ACTIONS(655),
    [anon_sym_dso_local] = ACTIONS(657),
    [anon_sym_dso_local_equivalent] = ACTIONS(655),
    [anon_sym_dso_preemptable] = ACTIONS(655),
    [anon_sym_default] = ACTIONS(655),
    [anon_sym_hidden] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_dllimport] = ACTIONS(655),
    [anon_sym_dllexport] = ACTIONS(655),
    [anon_sym_ccc] = ACTIONS(655),
    [anon_sym_fastcc] = ACTIONS(655),
    [anon_sym_coldcc] = ACTIONS(655),
    [anon_sym_webkit_jscc] = ACTIONS(657),
    [anon_sym_anyregcc] = ACTIONS(655),
    [anon_sym_preserve_mostcc] = ACTIONS(655),
    [anon_sym_preserve_allcc] = ACTIONS(655),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(657),
    [anon_sym_tailcc] = ACTIONS(655),
    [anon_sym_swiftcc] = ACTIONS(657),
    [anon_sym_swifttailcc] = ACTIONS(657),
    [anon_sym_cfguard_checkcc] = ACTIONS(655),
    [aux_sym_calling_conv_token1] = ACTIONS(657),
    [aux_sym_calling_conv_token2] = ACTIONS(655),
    [aux_sym_calling_conv_token3] = ACTIONS(655),
    [aux_sym_calling_conv_token4] = ACTIONS(655),
    [aux_sym_calling_conv_token5] = ACTIONS(655),
    [aux_sym_calling_conv_token6] = ACTIONS(655),
    [aux_sym_calling_conv_token7] = ACTIONS(655),
    [aux_sym_calling_conv_token8] = ACTIONS(655),
    [aux_sym_calling_conv_token9] = ACTIONS(655),
    [aux_sym_calling_conv_token10] = ACTIONS(657),
    [anon_sym_ghccc] = ACTIONS(655),
    [aux_sym_calling_conv_token11] = ACTIONS(657),
    [aux_sym_calling_conv_token12] = ACTIONS(655),
    [aux_sym_calling_conv_token13] = ACTIONS(657),
    [aux_sym_calling_conv_token14] = ACTIONS(655),
    [anon_sym_cc] = ACTIONS(657),
    [anon_sym_unnamed_addr] = ACTIONS(655),
    [anon_sym_local_unnamed_addr] = ACTIONS(655),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_half] = ACTIONS(655),
    [anon_sym_bfloat] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(655),
    [anon_sym_double] = ACTIONS(655),
    [anon_sym_x86_fp80] = ACTIONS(657),
    [anon_sym_fp128] = ACTIONS(655),
    [anon_sym_ppc_fp128] = ACTIONS(655),
    [anon_sym_label] = ACTIONS(655),
    [anon_sym_metadata] = ACTIONS(655),
    [anon_sym_x86_mmx] = ACTIONS(657),
    [anon_sym_x86_amx] = ACTIONS(657),
    [anon_sym_token] = ACTIONS(655),
    [anon_sym_opaque] = ACTIONS(655),
    [anon_sym_ptr] = ACTIONS(655),
    [aux_sym_type_keyword_token1] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_alignstack] = ACTIONS(655),
    [anon_sym_allocsize] = ACTIONS(655),
    [anon_sym_alwaysinline] = ACTIONS(655),
    [anon_sym_builtin] = ACTIONS(655),
    [anon_sym_cold] = ACTIONS(657),
    [anon_sym_convergent] = ACTIONS(655),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(655),
    [anon_sym_hot] = ACTIONS(655),
    [anon_sym_inaccessiblememonly] = ACTIONS(655),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(655),
    [anon_sym_inlinehint] = ACTIONS(655),
    [anon_sym_jumptable] = ACTIONS(655),
    [anon_sym_minsize] = ACTIONS(655),
    [anon_sym_naked] = ACTIONS(655),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(655),
    [anon_sym_nobuiltin] = ACTIONS(655),
    [anon_sym_noduplicate] = ACTIONS(655),
    [anon_sym_nofree] = ACTIONS(655),
    [anon_sym_noimplicitfloat] = ACTIONS(655),
    [anon_sym_noinline] = ACTIONS(655),
    [anon_sym_nomerge] = ACTIONS(655),
    [anon_sym_nonlazybind] = ACTIONS(655),
    [anon_sym_noprofile] = ACTIONS(655),
    [anon_sym_noredzone] = ACTIONS(655),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(655),
    [anon_sym_noreturn] = ACTIONS(655),
    [anon_sym_norecurse] = ACTIONS(655),
    [anon_sym_willreturn] = ACTIONS(655),
    [anon_sym_nosync] = ACTIONS(655),
    [anon_sym_nounwind] = ACTIONS(655),
    [anon_sym_nosanitize_coverage] = ACTIONS(655),
    [anon_sym_null_pointer_is_valid] = ACTIONS(655),
    [anon_sym_optforfuzzing] = ACTIONS(655),
    [anon_sym_optnone] = ACTIONS(655),
    [anon_sym_optsize] = ACTIONS(655),
    [anon_sym_readnone] = ACTIONS(655),
    [anon_sym_readonly] = ACTIONS(655),
    [anon_sym_writeonly] = ACTIONS(655),
    [anon_sym_argmemonly] = ACTIONS(655),
    [anon_sym_returns_twice] = ACTIONS(655),
    [anon_sym_safestack] = ACTIONS(655),
    [anon_sym_sanitize_address] = ACTIONS(655),
    [anon_sym_sanitize_memory] = ACTIONS(655),
    [anon_sym_sanitize_thread] = ACTIONS(655),
    [anon_sym_sanitize_hwaddress] = ACTIONS(655),
    [anon_sym_sanitize_memtag] = ACTIONS(655),
    [anon_sym_speculative_load_hardening] = ACTIONS(655),
    [anon_sym_speculatable] = ACTIONS(655),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(655),
    [anon_sym_sspreq] = ACTIONS(655),
    [anon_sym_strictfp] = ACTIONS(655),
    [anon_sym_uwtable] = ACTIONS(655),
    [anon_sym_nocf_check] = ACTIONS(655),
    [anon_sym_shadowcallstack] = ACTIONS(655),
    [anon_sym_mustprogress] = ACTIONS(655),
    [anon_sym_vscale_range] = ACTIONS(655),
    [anon_sym_preallocated] = ACTIONS(655),
    [anon_sym_zeroext] = ACTIONS(655),
    [anon_sym_signext] = ACTIONS(655),
    [anon_sym_inreg] = ACTIONS(655),
    [anon_sym_byval] = ACTIONS(655),
    [anon_sym_byref] = ACTIONS(655),
    [anon_sym_inalloca] = ACTIONS(655),
    [anon_sym_sret] = ACTIONS(655),
    [anon_sym_elementtype] = ACTIONS(655),
    [anon_sym_noalias] = ACTIONS(655),
    [anon_sym_nocapture] = ACTIONS(655),
    [anon_sym_nest] = ACTIONS(655),
    [anon_sym_returned] = ACTIONS(655),
    [anon_sym_nonnull] = ACTIONS(655),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(655),
    [anon_sym_swiftself] = ACTIONS(657),
    [anon_sym_swiftasync] = ACTIONS(657),
    [anon_sym_swifterror] = ACTIONS(657),
    [anon_sym_immarg] = ACTIONS(655),
    [anon_sym_noundef] = ACTIONS(655),
    [anon_sym_to] = ACTIONS(657),
    [anon_sym_unwind] = ACTIONS(655),
    [anon_sym_unordered] = ACTIONS(655),
    [anon_sym_monotonic] = ACTIONS(655),
    [anon_sym_acquire] = ACTIONS(655),
    [anon_sym_release] = ACTIONS(655),
    [anon_sym_acq_rel] = ACTIONS(655),
    [anon_sym_seq_cst] = ACTIONS(655),
    [anon_sym_syncscope] = ACTIONS(655),
    [anon_sym_uselistorder] = ACTIONS(657),
    [anon_sym_uselistorder_bb] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_attributes] = ACTIONS(655),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(659),
    [sym_global_var] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [aux_sym_metadata_ref_token1] = ACTIONS(659),
    [sym_summary_ref] = ACTIONS(659),
    [sym_string] = ACTIONS(659),
    [anon_sym_target] = ACTIONS(659),
    [anon_sym_source_filename] = ACTIONS(659),
    [anon_sym_declare] = ACTIONS(659),
    [anon_sym_define] = ACTIONS(659),
    [anon_sym_no_cfi] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_weak] = ACTIONS(661),
    [anon_sym_weak_odr] = ACTIONS(659),
    [anon_sym_linkonce] = ACTIONS(661),
    [anon_sym_linkonce_odr] = ACTIONS(659),
    [anon_sym_available_externally] = ACTIONS(659),
    [anon_sym_appending] = ACTIONS(659),
    [anon_sym_common] = ACTIONS(659),
    [anon_sym_extern_weak] = ACTIONS(659),
    [anon_sym_external] = ACTIONS(659),
    [anon_sym_dso_local] = ACTIONS(661),
    [anon_sym_dso_local_equivalent] = ACTIONS(659),
    [anon_sym_dso_preemptable] = ACTIONS(659),
    [anon_sym_default] = ACTIONS(659),
    [anon_sym_hidden] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_dllimport] = ACTIONS(659),
    [anon_sym_dllexport] = ACTIONS(659),
    [anon_sym_ccc] = ACTIONS(659),
    [anon_sym_fastcc] = ACTIONS(659),
    [anon_sym_coldcc] = ACTIONS(659),
    [anon_sym_webkit_jscc] = ACTIONS(661),
    [anon_sym_anyregcc] = ACTIONS(659),
    [anon_sym_preserve_mostcc] = ACTIONS(659),
    [anon_sym_preserve_allcc] = ACTIONS(659),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(661),
    [anon_sym_tailcc] = ACTIONS(659),
    [anon_sym_swiftcc] = ACTIONS(661),
    [anon_sym_swifttailcc] = ACTIONS(661),
    [anon_sym_cfguard_checkcc] = ACTIONS(659),
    [aux_sym_calling_conv_token1] = ACTIONS(661),
    [aux_sym_calling_conv_token2] = ACTIONS(659),
    [aux_sym_calling_conv_token3] = ACTIONS(659),
    [aux_sym_calling_conv_token4] = ACTIONS(659),
    [aux_sym_calling_conv_token5] = ACTIONS(659),
    [aux_sym_calling_conv_token6] = ACTIONS(659),
    [aux_sym_calling_conv_token7] = ACTIONS(659),
    [aux_sym_calling_conv_token8] = ACTIONS(659),
    [aux_sym_calling_conv_token9] = ACTIONS(659),
    [aux_sym_calling_conv_token10] = ACTIONS(661),
    [anon_sym_ghccc] = ACTIONS(659),
    [aux_sym_calling_conv_token11] = ACTIONS(661),
    [aux_sym_calling_conv_token12] = ACTIONS(659),
    [aux_sym_calling_conv_token13] = ACTIONS(661),
    [aux_sym_calling_conv_token14] = ACTIONS(659),
    [anon_sym_cc] = ACTIONS(661),
    [anon_sym_unnamed_addr] = ACTIONS(659),
    [anon_sym_local_unnamed_addr] = ACTIONS(659),
    [anon_sym_void] = ACTIONS(659),
    [anon_sym_half] = ACTIONS(659),
    [anon_sym_bfloat] = ACTIONS(659),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_double] = ACTIONS(659),
    [anon_sym_x86_fp80] = ACTIONS(661),
    [anon_sym_fp128] = ACTIONS(659),
    [anon_sym_ppc_fp128] = ACTIONS(659),
    [anon_sym_label] = ACTIONS(659),
    [anon_sym_metadata] = ACTIONS(659),
    [anon_sym_x86_mmx] = ACTIONS(661),
    [anon_sym_x86_amx] = ACTIONS(661),
    [anon_sym_token] = ACTIONS(659),
    [anon_sym_opaque] = ACTIONS(659),
    [anon_sym_ptr] = ACTIONS(659),
    [aux_sym_type_keyword_token1] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_alignstack] = ACTIONS(659),
    [anon_sym_allocsize] = ACTIONS(659),
    [anon_sym_alwaysinline] = ACTIONS(659),
    [anon_sym_builtin] = ACTIONS(659),
    [anon_sym_cold] = ACTIONS(661),
    [anon_sym_convergent] = ACTIONS(659),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(659),
    [anon_sym_hot] = ACTIONS(659),
    [anon_sym_inaccessiblememonly] = ACTIONS(659),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(659),
    [anon_sym_inlinehint] = ACTIONS(659),
    [anon_sym_jumptable] = ACTIONS(659),
    [anon_sym_minsize] = ACTIONS(659),
    [anon_sym_naked] = ACTIONS(659),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(659),
    [anon_sym_nobuiltin] = ACTIONS(659),
    [anon_sym_noduplicate] = ACTIONS(659),
    [anon_sym_nofree] = ACTIONS(659),
    [anon_sym_noimplicitfloat] = ACTIONS(659),
    [anon_sym_noinline] = ACTIONS(659),
    [anon_sym_nomerge] = ACTIONS(659),
    [anon_sym_nonlazybind] = ACTIONS(659),
    [anon_sym_noprofile] = ACTIONS(659),
    [anon_sym_noredzone] = ACTIONS(659),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(659),
    [anon_sym_noreturn] = ACTIONS(659),
    [anon_sym_norecurse] = ACTIONS(659),
    [anon_sym_willreturn] = ACTIONS(659),
    [anon_sym_nosync] = ACTIONS(659),
    [anon_sym_nounwind] = ACTIONS(659),
    [anon_sym_nosanitize_coverage] = ACTIONS(659),
    [anon_sym_null_pointer_is_valid] = ACTIONS(659),
    [anon_sym_optforfuzzing] = ACTIONS(659),
    [anon_sym_optnone] = ACTIONS(659),
    [anon_sym_optsize] = ACTIONS(659),
    [anon_sym_readnone] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_writeonly] = ACTIONS(659),
    [anon_sym_argmemonly] = ACTIONS(659),
    [anon_sym_returns_twice] = ACTIONS(659),
    [anon_sym_safestack] = ACTIONS(659),
    [anon_sym_sanitize_address] = ACTIONS(659),
    [anon_sym_sanitize_memory] = ACTIONS(659),
    [anon_sym_sanitize_thread] = ACTIONS(659),
    [anon_sym_sanitize_hwaddress] = ACTIONS(659),
    [anon_sym_sanitize_memtag] = ACTIONS(659),
    [anon_sym_speculative_load_hardening] = ACTIONS(659),
    [anon_sym_speculatable] = ACTIONS(659),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(659),
    [anon_sym_sspreq] = ACTIONS(659),
    [anon_sym_strictfp] = ACTIONS(659),
    [anon_sym_uwtable] = ACTIONS(659),
    [anon_sym_nocf_check] = ACTIONS(659),
    [anon_sym_shadowcallstack] = ACTIONS(659),
    [anon_sym_mustprogress] = ACTIONS(659),
    [anon_sym_vscale_range] = ACTIONS(659),
    [anon_sym_preallocated] = ACTIONS(659),
    [anon_sym_zeroext] = ACTIONS(659),
    [anon_sym_signext] = ACTIONS(659),
    [anon_sym_inreg] = ACTIONS(659),
    [anon_sym_byval] = ACTIONS(659),
    [anon_sym_byref] = ACTIONS(659),
    [anon_sym_inalloca] = ACTIONS(659),
    [anon_sym_sret] = ACTIONS(659),
    [anon_sym_elementtype] = ACTIONS(659),
    [anon_sym_noalias] = ACTIONS(659),
    [anon_sym_nocapture] = ACTIONS(659),
    [anon_sym_nest] = ACTIONS(659),
    [anon_sym_returned] = ACTIONS(659),
    [anon_sym_nonnull] = ACTIONS(659),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(659),
    [anon_sym_swiftself] = ACTIONS(661),
    [anon_sym_swiftasync] = ACTIONS(661),
    [anon_sym_swifterror] = ACTIONS(661),
    [anon_sym_immarg] = ACTIONS(659),
    [anon_sym_noundef] = ACTIONS(659),
    [anon_sym_to] = ACTIONS(661),
    [anon_sym_unwind] = ACTIONS(659),
    [anon_sym_unordered] = ACTIONS(659),
    [anon_sym_monotonic] = ACTIONS(659),
    [anon_sym_acquire] = ACTIONS(659),
    [anon_sym_release] = ACTIONS(659),
    [anon_sym_acq_rel] = ACTIONS(659),
    [anon_sym_seq_cst] = ACTIONS(659),
    [anon_sym_syncscope] = ACTIONS(659),
    [anon_sym_uselistorder] = ACTIONS(661),
    [anon_sym_uselistorder_bb] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_attributes] = ACTIONS(659),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(663),
    [sym_global_var] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [aux_sym_metadata_ref_token1] = ACTIONS(663),
    [sym_summary_ref] = ACTIONS(663),
    [sym_string] = ACTIONS(663),
    [anon_sym_target] = ACTIONS(663),
    [anon_sym_source_filename] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_define] = ACTIONS(663),
    [anon_sym_no_cfi] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_internal] = ACTIONS(663),
    [anon_sym_weak] = ACTIONS(665),
    [anon_sym_weak_odr] = ACTIONS(663),
    [anon_sym_linkonce] = ACTIONS(665),
    [anon_sym_linkonce_odr] = ACTIONS(663),
    [anon_sym_available_externally] = ACTIONS(663),
    [anon_sym_appending] = ACTIONS(663),
    [anon_sym_common] = ACTIONS(663),
    [anon_sym_extern_weak] = ACTIONS(663),
    [anon_sym_external] = ACTIONS(663),
    [anon_sym_dso_local] = ACTIONS(665),
    [anon_sym_dso_local_equivalent] = ACTIONS(663),
    [anon_sym_dso_preemptable] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_hidden] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_dllimport] = ACTIONS(663),
    [anon_sym_dllexport] = ACTIONS(663),
    [anon_sym_ccc] = ACTIONS(663),
    [anon_sym_fastcc] = ACTIONS(663),
    [anon_sym_coldcc] = ACTIONS(663),
    [anon_sym_webkit_jscc] = ACTIONS(665),
    [anon_sym_anyregcc] = ACTIONS(663),
    [anon_sym_preserve_mostcc] = ACTIONS(663),
    [anon_sym_preserve_allcc] = ACTIONS(663),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(665),
    [anon_sym_tailcc] = ACTIONS(663),
    [anon_sym_swiftcc] = ACTIONS(665),
    [anon_sym_swifttailcc] = ACTIONS(665),
    [anon_sym_cfguard_checkcc] = ACTIONS(663),
    [aux_sym_calling_conv_token1] = ACTIONS(665),
    [aux_sym_calling_conv_token2] = ACTIONS(663),
    [aux_sym_calling_conv_token3] = ACTIONS(663),
    [aux_sym_calling_conv_token4] = ACTIONS(663),
    [aux_sym_calling_conv_token5] = ACTIONS(663),
    [aux_sym_calling_conv_token6] = ACTIONS(663),
    [aux_sym_calling_conv_token7] = ACTIONS(663),
    [aux_sym_calling_conv_token8] = ACTIONS(663),
    [aux_sym_calling_conv_token9] = ACTIONS(663),
    [aux_sym_calling_conv_token10] = ACTIONS(665),
    [anon_sym_ghccc] = ACTIONS(663),
    [aux_sym_calling_conv_token11] = ACTIONS(665),
    [aux_sym_calling_conv_token12] = ACTIONS(663),
    [aux_sym_calling_conv_token13] = ACTIONS(665),
    [aux_sym_calling_conv_token14] = ACTIONS(663),
    [anon_sym_cc] = ACTIONS(665),
    [anon_sym_unnamed_addr] = ACTIONS(663),
    [anon_sym_local_unnamed_addr] = ACTIONS(663),
    [anon_sym_void] = ACTIONS(663),
    [anon_sym_half] = ACTIONS(663),
    [anon_sym_bfloat] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(663),
    [anon_sym_double] = ACTIONS(663),
    [anon_sym_x86_fp80] = ACTIONS(665),
    [anon_sym_fp128] = ACTIONS(663),
    [anon_sym_ppc_fp128] = ACTIONS(663),
    [anon_sym_label] = ACTIONS(663),
    [anon_sym_metadata] = ACTIONS(663),
    [anon_sym_x86_mmx] = ACTIONS(665),
    [anon_sym_x86_amx] = ACTIONS(665),
    [anon_sym_token] = ACTIONS(663),
    [anon_sym_opaque] = ACTIONS(663),
    [anon_sym_ptr] = ACTIONS(663),
    [aux_sym_type_keyword_token1] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LT_LBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_alignstack] = ACTIONS(663),
    [anon_sym_allocsize] = ACTIONS(663),
    [anon_sym_alwaysinline] = ACTIONS(663),
    [anon_sym_builtin] = ACTIONS(663),
    [anon_sym_cold] = ACTIONS(665),
    [anon_sym_convergent] = ACTIONS(663),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(663),
    [anon_sym_hot] = ACTIONS(663),
    [anon_sym_inaccessiblememonly] = ACTIONS(663),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(663),
    [anon_sym_inlinehint] = ACTIONS(663),
    [anon_sym_jumptable] = ACTIONS(663),
    [anon_sym_minsize] = ACTIONS(663),
    [anon_sym_naked] = ACTIONS(663),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(663),
    [anon_sym_nobuiltin] = ACTIONS(663),
    [anon_sym_noduplicate] = ACTIONS(663),
    [anon_sym_nofree] = ACTIONS(663),
    [anon_sym_noimplicitfloat] = ACTIONS(663),
    [anon_sym_noinline] = ACTIONS(663),
    [anon_sym_nomerge] = ACTIONS(663),
    [anon_sym_nonlazybind] = ACTIONS(663),
    [anon_sym_noprofile] = ACTIONS(663),
    [anon_sym_noredzone] = ACTIONS(663),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(663),
    [anon_sym_noreturn] = ACTIONS(663),
    [anon_sym_norecurse] = ACTIONS(663),
    [anon_sym_willreturn] = ACTIONS(663),
    [anon_sym_nosync] = ACTIONS(663),
    [anon_sym_nounwind] = ACTIONS(663),
    [anon_sym_nosanitize_coverage] = ACTIONS(663),
    [anon_sym_null_pointer_is_valid] = ACTIONS(663),
    [anon_sym_optforfuzzing] = ACTIONS(663),
    [anon_sym_optnone] = ACTIONS(663),
    [anon_sym_optsize] = ACTIONS(663),
    [anon_sym_readnone] = ACTIONS(663),
    [anon_sym_readonly] = ACTIONS(663),
    [anon_sym_writeonly] = ACTIONS(663),
    [anon_sym_argmemonly] = ACTIONS(663),
    [anon_sym_returns_twice] = ACTIONS(663),
    [anon_sym_safestack] = ACTIONS(663),
    [anon_sym_sanitize_address] = ACTIONS(663),
    [anon_sym_sanitize_memory] = ACTIONS(663),
    [anon_sym_sanitize_thread] = ACTIONS(663),
    [anon_sym_sanitize_hwaddress] = ACTIONS(663),
    [anon_sym_sanitize_memtag] = ACTIONS(663),
    [anon_sym_speculative_load_hardening] = ACTIONS(663),
    [anon_sym_speculatable] = ACTIONS(663),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(663),
    [anon_sym_sspreq] = ACTIONS(663),
    [anon_sym_strictfp] = ACTIONS(663),
    [anon_sym_uwtable] = ACTIONS(663),
    [anon_sym_nocf_check] = ACTIONS(663),
    [anon_sym_shadowcallstack] = ACTIONS(663),
    [anon_sym_mustprogress] = ACTIONS(663),
    [anon_sym_vscale_range] = ACTIONS(663),
    [anon_sym_preallocated] = ACTIONS(663),
    [anon_sym_zeroext] = ACTIONS(663),
    [anon_sym_signext] = ACTIONS(663),
    [anon_sym_inreg] = ACTIONS(663),
    [anon_sym_byval] = ACTIONS(663),
    [anon_sym_byref] = ACTIONS(663),
    [anon_sym_inalloca] = ACTIONS(663),
    [anon_sym_sret] = ACTIONS(663),
    [anon_sym_elementtype] = ACTIONS(663),
    [anon_sym_noalias] = ACTIONS(663),
    [anon_sym_nocapture] = ACTIONS(663),
    [anon_sym_nest] = ACTIONS(663),
    [anon_sym_returned] = ACTIONS(663),
    [anon_sym_nonnull] = ACTIONS(663),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(663),
    [anon_sym_swiftself] = ACTIONS(665),
    [anon_sym_swiftasync] = ACTIONS(665),
    [anon_sym_swifterror] = ACTIONS(665),
    [anon_sym_immarg] = ACTIONS(663),
    [anon_sym_noundef] = ACTIONS(663),
    [anon_sym_to] = ACTIONS(665),
    [anon_sym_unwind] = ACTIONS(663),
    [anon_sym_unordered] = ACTIONS(663),
    [anon_sym_monotonic] = ACTIONS(663),
    [anon_sym_acquire] = ACTIONS(663),
    [anon_sym_release] = ACTIONS(663),
    [anon_sym_acq_rel] = ACTIONS(663),
    [anon_sym_seq_cst] = ACTIONS(663),
    [anon_sym_syncscope] = ACTIONS(663),
    [anon_sym_uselistorder] = ACTIONS(665),
    [anon_sym_uselistorder_bb] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_attributes] = ACTIONS(663),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_no_cfi] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(667),
    [anon_sym_weak] = ACTIONS(669),
    [anon_sym_weak_odr] = ACTIONS(667),
    [anon_sym_linkonce] = ACTIONS(669),
    [anon_sym_linkonce_odr] = ACTIONS(667),
    [anon_sym_available_externally] = ACTIONS(667),
    [anon_sym_appending] = ACTIONS(667),
    [anon_sym_common] = ACTIONS(667),
    [anon_sym_extern_weak] = ACTIONS(667),
    [anon_sym_external] = ACTIONS(667),
    [anon_sym_dso_local] = ACTIONS(669),
    [anon_sym_dso_local_equivalent] = ACTIONS(667),
    [anon_sym_dso_preemptable] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(667),
    [anon_sym_hidden] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_dllimport] = ACTIONS(667),
    [anon_sym_dllexport] = ACTIONS(667),
    [anon_sym_ccc] = ACTIONS(667),
    [anon_sym_fastcc] = ACTIONS(667),
    [anon_sym_coldcc] = ACTIONS(667),
    [anon_sym_webkit_jscc] = ACTIONS(669),
    [anon_sym_anyregcc] = ACTIONS(667),
    [anon_sym_preserve_mostcc] = ACTIONS(667),
    [anon_sym_preserve_allcc] = ACTIONS(667),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(669),
    [anon_sym_tailcc] = ACTIONS(667),
    [anon_sym_swiftcc] = ACTIONS(669),
    [anon_sym_swifttailcc] = ACTIONS(669),
    [anon_sym_cfguard_checkcc] = ACTIONS(667),
    [aux_sym_calling_conv_token1] = ACTIONS(669),
    [aux_sym_calling_conv_token2] = ACTIONS(667),
    [aux_sym_calling_conv_token3] = ACTIONS(667),
    [aux_sym_calling_conv_token4] = ACTIONS(667),
    [aux_sym_calling_conv_token5] = ACTIONS(667),
    [aux_sym_calling_conv_token6] = ACTIONS(667),
    [aux_sym_calling_conv_token7] = ACTIONS(667),
    [aux_sym_calling_conv_token8] = ACTIONS(667),
    [aux_sym_calling_conv_token9] = ACTIONS(667),
    [aux_sym_calling_conv_token10] = ACTIONS(669),
    [anon_sym_ghccc] = ACTIONS(667),
    [aux_sym_calling_conv_token11] = ACTIONS(669),
    [aux_sym_calling_conv_token12] = ACTIONS(667),
    [aux_sym_calling_conv_token13] = ACTIONS(669),
    [aux_sym_calling_conv_token14] = ACTIONS(667),
    [anon_sym_cc] = ACTIONS(669),
    [anon_sym_unnamed_addr] = ACTIONS(667),
    [anon_sym_local_unnamed_addr] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(669),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(669),
    [anon_sym_x86_amx] = ACTIONS(669),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_unwind] = ACTIONS(667),
    [anon_sym_unordered] = ACTIONS(667),
    [anon_sym_monotonic] = ACTIONS(667),
    [anon_sym_acquire] = ACTIONS(667),
    [anon_sym_release] = ACTIONS(667),
    [anon_sym_acq_rel] = ACTIONS(667),
    [anon_sym_seq_cst] = ACTIONS(667),
    [anon_sym_syncscope] = ACTIONS(667),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [126] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(497),
    [sym_local_var] = ACTIONS(497),
    [sym_label] = ACTIONS(497),
    [sym_string] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_align] = ACTIONS(499),
    [anon_sym_section] = ACTIONS(499),
    [anon_sym_partition] = ACTIONS(499),
    [anon_sym_comdat] = ACTIONS(499),
    [anon_sym_gc] = ACTIONS(499),
    [anon_sym_prefix] = ACTIONS(499),
    [anon_sym_prologue] = ACTIONS(499),
    [anon_sym_personality] = ACTIONS(499),
    [anon_sym_alignstack] = ACTIONS(499),
    [anon_sym_allocsize] = ACTIONS(499),
    [anon_sym_alwaysinline] = ACTIONS(499),
    [anon_sym_builtin] = ACTIONS(499),
    [anon_sym_cold] = ACTIONS(499),
    [anon_sym_convergent] = ACTIONS(499),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(499),
    [anon_sym_hot] = ACTIONS(499),
    [anon_sym_inaccessiblememonly] = ACTIONS(499),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(499),
    [anon_sym_inlinehint] = ACTIONS(499),
    [anon_sym_jumptable] = ACTIONS(499),
    [anon_sym_minsize] = ACTIONS(499),
    [anon_sym_naked] = ACTIONS(499),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(499),
    [anon_sym_nobuiltin] = ACTIONS(499),
    [anon_sym_noduplicate] = ACTIONS(499),
    [anon_sym_nofree] = ACTIONS(499),
    [anon_sym_noimplicitfloat] = ACTIONS(499),
    [anon_sym_noinline] = ACTIONS(499),
    [anon_sym_nomerge] = ACTIONS(499),
    [anon_sym_nonlazybind] = ACTIONS(499),
    [anon_sym_noprofile] = ACTIONS(499),
    [anon_sym_noredzone] = ACTIONS(499),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(499),
    [anon_sym_noreturn] = ACTIONS(499),
    [anon_sym_norecurse] = ACTIONS(499),
    [anon_sym_willreturn] = ACTIONS(499),
    [anon_sym_nosync] = ACTIONS(499),
    [anon_sym_nounwind] = ACTIONS(499),
    [anon_sym_nosanitize_coverage] = ACTIONS(499),
    [anon_sym_null_pointer_is_valid] = ACTIONS(499),
    [anon_sym_optforfuzzing] = ACTIONS(499),
    [anon_sym_optnone] = ACTIONS(499),
    [anon_sym_optsize] = ACTIONS(499),
    [anon_sym_readnone] = ACTIONS(499),
    [anon_sym_readonly] = ACTIONS(499),
    [anon_sym_writeonly] = ACTIONS(499),
    [anon_sym_argmemonly] = ACTIONS(499),
    [anon_sym_returns_twice] = ACTIONS(499),
    [anon_sym_safestack] = ACTIONS(499),
    [anon_sym_sanitize_address] = ACTIONS(499),
    [anon_sym_sanitize_memory] = ACTIONS(499),
    [anon_sym_sanitize_thread] = ACTIONS(499),
    [anon_sym_sanitize_hwaddress] = ACTIONS(499),
    [anon_sym_sanitize_memtag] = ACTIONS(499),
    [anon_sym_speculative_load_hardening] = ACTIONS(499),
    [anon_sym_speculatable] = ACTIONS(499),
    [anon_sym_ssp] = ACTIONS(499),
    [anon_sym_sspstrong] = ACTIONS(499),
    [anon_sym_sspreq] = ACTIONS(499),
    [anon_sym_strictfp] = ACTIONS(499),
    [anon_sym_uwtable] = ACTIONS(499),
    [anon_sym_nocf_check] = ACTIONS(499),
    [anon_sym_shadowcallstack] = ACTIONS(499),
    [anon_sym_mustprogress] = ACTIONS(499),
    [anon_sym_vscale_range] = ACTIONS(499),
    [anon_sym_preallocated] = ACTIONS(499),
    [anon_sym_zeroext] = ACTIONS(499),
    [anon_sym_signext] = ACTIONS(499),
    [anon_sym_inreg] = ACTIONS(499),
    [anon_sym_byval] = ACTIONS(499),
    [anon_sym_byref] = ACTIONS(499),
    [anon_sym_inalloca] = ACTIONS(499),
    [anon_sym_sret] = ACTIONS(499),
    [anon_sym_elementtype] = ACTIONS(499),
    [anon_sym_noalias] = ACTIONS(499),
    [anon_sym_nocapture] = ACTIONS(499),
    [anon_sym_nest] = ACTIONS(499),
    [anon_sym_returned] = ACTIONS(499),
    [anon_sym_nonnull] = ACTIONS(499),
    [anon_sym_dereferenceable] = ACTIONS(499),
    [anon_sym_dereferenceable_or_null] = ACTIONS(499),
    [anon_sym_swiftself] = ACTIONS(499),
    [anon_sym_swiftasync] = ACTIONS(499),
    [anon_sym_swifterror] = ACTIONS(499),
    [anon_sym_immarg] = ACTIONS(499),
    [anon_sym_noundef] = ACTIONS(499),
    [anon_sym_unreachable] = ACTIONS(499),
    [anon_sym_ret] = ACTIONS(499),
    [anon_sym_br] = ACTIONS(499),
    [anon_sym_resume] = ACTIONS(499),
    [anon_sym_freeze] = ACTIONS(499),
    [anon_sym_indirectbr] = ACTIONS(499),
    [anon_sym_extractelement] = ACTIONS(499),
    [anon_sym_insertelement] = ACTIONS(499),
    [anon_sym_select] = ACTIONS(499),
    [anon_sym_shufflevector] = ACTIONS(499),
    [anon_sym_fneg] = ACTIONS(499),
    [anon_sym_switch] = ACTIONS(499),
    [anon_sym_invoke] = ACTIONS(499),
    [anon_sym_cleanupret] = ACTIONS(499),
    [anon_sym_catchret] = ACTIONS(499),
    [anon_sym_catchswitch] = ACTIONS(499),
    [anon_sym_catchpad] = ACTIONS(499),
    [anon_sym_cleanuppad] = ACTIONS(499),
    [anon_sym_callbr] = ACTIONS(499),
    [anon_sym_icmp] = ACTIONS(499),
    [anon_sym_fcmp] = ACTIONS(499),
    [anon_sym_va_arg] = ACTIONS(499),
    [anon_sym_phi] = ACTIONS(499),
    [anon_sym_landingpad] = ACTIONS(499),
    [anon_sym_tail] = ACTIONS(499),
    [anon_sym_musttail] = ACTIONS(499),
    [anon_sym_notail] = ACTIONS(499),
    [anon_sym_call] = ACTIONS(499),
    [anon_sym_alloca] = ACTIONS(499),
    [anon_sym_load] = ACTIONS(499),
    [anon_sym_store] = ACTIONS(499),
    [anon_sym_cmpxchg] = ACTIONS(499),
    [anon_sym_atomicrmw] = ACTIONS(499),
    [anon_sym_fence] = ACTIONS(499),
    [anon_sym_getelementptr] = ACTIONS(499),
    [anon_sym_extractvalue] = ACTIONS(499),
    [anon_sym_insertvalue] = ACTIONS(499),
    [anon_sym_catch] = ACTIONS(499),
    [anon_sym_filter] = ACTIONS(499),
    [anon_sym_mul] = ACTIONS(499),
    [anon_sym_urem] = ACTIONS(499),
    [anon_sym_srem] = ACTIONS(499),
    [anon_sym_shl] = ACTIONS(499),
    [anon_sym_udiv] = ACTIONS(499),
    [anon_sym_sdiv] = ACTIONS(499),
    [anon_sym_lshr] = ACTIONS(499),
    [anon_sym_ashr] = ACTIONS(499),
    [anon_sym_fmul] = ACTIONS(499),
    [anon_sym_fdiv] = ACTIONS(499),
    [anon_sym_frem] = ACTIONS(499),
    [anon_sym_xchg] = ACTIONS(499),
    [anon_sym_add] = ACTIONS(499),
    [anon_sym_sub] = ACTIONS(499),
    [anon_sym_and] = ACTIONS(499),
    [anon_sym_nand] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(499),
    [anon_sym_xor] = ACTIONS(499),
    [anon_sym_max] = ACTIONS(499),
    [anon_sym_min] = ACTIONS(499),
    [anon_sym_umax] = ACTIONS(499),
    [anon_sym_umin] = ACTIONS(499),
    [anon_sym_fadd] = ACTIONS(499),
    [anon_sym_fsub] = ACTIONS(499),
    [anon_sym_bitcast] = ACTIONS(499),
    [anon_sym_trunc] = ACTIONS(499),
    [anon_sym_zext] = ACTIONS(499),
    [anon_sym_sext] = ACTIONS(499),
    [anon_sym_fptrunc] = ACTIONS(499),
    [anon_sym_fpext] = ACTIONS(499),
    [anon_sym_addrspacecast] = ACTIONS(499),
    [anon_sym_uitofp] = ACTIONS(499),
    [anon_sym_sitofp] = ACTIONS(499),
    [anon_sym_fptoui] = ACTIONS(499),
    [anon_sym_fptosi] = ACTIONS(499),
    [anon_sym_inttoptr] = ACTIONS(499),
    [anon_sym_ptrtoint] = ACTIONS(499),
    [anon_sym_unordered] = ACTIONS(499),
    [anon_sym_monotonic] = ACTIONS(499),
    [anon_sym_acquire] = ACTIONS(499),
    [anon_sym_release] = ACTIONS(499),
    [anon_sym_acq_rel] = ACTIONS(499),
    [anon_sym_seq_cst] = ACTIONS(499),
    [anon_sym_syncscope] = ACTIONS(499),
    [anon_sym_uselistorder] = ACTIONS(499),
    [anon_sym_LPAREN2] = ACTIONS(497),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(671),
    [sym_global_var] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [aux_sym_metadata_ref_token1] = ACTIONS(671),
    [sym_summary_ref] = ACTIONS(671),
    [sym_string] = ACTIONS(671),
    [anon_sym_target] = ACTIONS(671),
    [anon_sym_source_filename] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_define] = ACTIONS(671),
    [anon_sym_no_cfi] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_internal] = ACTIONS(671),
    [anon_sym_weak] = ACTIONS(673),
    [anon_sym_weak_odr] = ACTIONS(671),
    [anon_sym_linkonce] = ACTIONS(673),
    [anon_sym_linkonce_odr] = ACTIONS(671),
    [anon_sym_available_externally] = ACTIONS(671),
    [anon_sym_appending] = ACTIONS(671),
    [anon_sym_common] = ACTIONS(671),
    [anon_sym_extern_weak] = ACTIONS(671),
    [anon_sym_external] = ACTIONS(671),
    [anon_sym_dso_local] = ACTIONS(673),
    [anon_sym_dso_local_equivalent] = ACTIONS(671),
    [anon_sym_dso_preemptable] = ACTIONS(671),
    [anon_sym_default] = ACTIONS(671),
    [anon_sym_hidden] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_dllimport] = ACTIONS(671),
    [anon_sym_dllexport] = ACTIONS(671),
    [anon_sym_ccc] = ACTIONS(671),
    [anon_sym_fastcc] = ACTIONS(671),
    [anon_sym_coldcc] = ACTIONS(671),
    [anon_sym_webkit_jscc] = ACTIONS(673),
    [anon_sym_anyregcc] = ACTIONS(671),
    [anon_sym_preserve_mostcc] = ACTIONS(671),
    [anon_sym_preserve_allcc] = ACTIONS(671),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(673),
    [anon_sym_tailcc] = ACTIONS(671),
    [anon_sym_swiftcc] = ACTIONS(673),
    [anon_sym_swifttailcc] = ACTIONS(673),
    [anon_sym_cfguard_checkcc] = ACTIONS(671),
    [aux_sym_calling_conv_token1] = ACTIONS(673),
    [aux_sym_calling_conv_token2] = ACTIONS(671),
    [aux_sym_calling_conv_token3] = ACTIONS(671),
    [aux_sym_calling_conv_token4] = ACTIONS(671),
    [aux_sym_calling_conv_token5] = ACTIONS(671),
    [aux_sym_calling_conv_token6] = ACTIONS(671),
    [aux_sym_calling_conv_token7] = ACTIONS(671),
    [aux_sym_calling_conv_token8] = ACTIONS(671),
    [aux_sym_calling_conv_token9] = ACTIONS(671),
    [aux_sym_calling_conv_token10] = ACTIONS(673),
    [anon_sym_ghccc] = ACTIONS(671),
    [aux_sym_calling_conv_token11] = ACTIONS(673),
    [aux_sym_calling_conv_token12] = ACTIONS(671),
    [aux_sym_calling_conv_token13] = ACTIONS(673),
    [aux_sym_calling_conv_token14] = ACTIONS(671),
    [anon_sym_cc] = ACTIONS(673),
    [anon_sym_unnamed_addr] = ACTIONS(671),
    [anon_sym_local_unnamed_addr] = ACTIONS(671),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_half] = ACTIONS(671),
    [anon_sym_bfloat] = ACTIONS(671),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_double] = ACTIONS(671),
    [anon_sym_x86_fp80] = ACTIONS(673),
    [anon_sym_fp128] = ACTIONS(671),
    [anon_sym_ppc_fp128] = ACTIONS(671),
    [anon_sym_label] = ACTIONS(671),
    [anon_sym_metadata] = ACTIONS(671),
    [anon_sym_x86_mmx] = ACTIONS(673),
    [anon_sym_x86_amx] = ACTIONS(673),
    [anon_sym_token] = ACTIONS(671),
    [anon_sym_opaque] = ACTIONS(671),
    [anon_sym_ptr] = ACTIONS(671),
    [aux_sym_type_keyword_token1] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LT_LBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_alignstack] = ACTIONS(671),
    [anon_sym_allocsize] = ACTIONS(671),
    [anon_sym_alwaysinline] = ACTIONS(671),
    [anon_sym_builtin] = ACTIONS(671),
    [anon_sym_cold] = ACTIONS(673),
    [anon_sym_convergent] = ACTIONS(671),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(671),
    [anon_sym_hot] = ACTIONS(671),
    [anon_sym_inaccessiblememonly] = ACTIONS(671),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(671),
    [anon_sym_inlinehint] = ACTIONS(671),
    [anon_sym_jumptable] = ACTIONS(671),
    [anon_sym_minsize] = ACTIONS(671),
    [anon_sym_naked] = ACTIONS(671),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(671),
    [anon_sym_nobuiltin] = ACTIONS(671),
    [anon_sym_noduplicate] = ACTIONS(671),
    [anon_sym_nofree] = ACTIONS(671),
    [anon_sym_noimplicitfloat] = ACTIONS(671),
    [anon_sym_noinline] = ACTIONS(671),
    [anon_sym_nomerge] = ACTIONS(671),
    [anon_sym_nonlazybind] = ACTIONS(671),
    [anon_sym_noprofile] = ACTIONS(671),
    [anon_sym_noredzone] = ACTIONS(671),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(671),
    [anon_sym_noreturn] = ACTIONS(671),
    [anon_sym_norecurse] = ACTIONS(671),
    [anon_sym_willreturn] = ACTIONS(671),
    [anon_sym_nosync] = ACTIONS(671),
    [anon_sym_nounwind] = ACTIONS(671),
    [anon_sym_nosanitize_coverage] = ACTIONS(671),
    [anon_sym_null_pointer_is_valid] = ACTIONS(671),
    [anon_sym_optforfuzzing] = ACTIONS(671),
    [anon_sym_optnone] = ACTIONS(671),
    [anon_sym_optsize] = ACTIONS(671),
    [anon_sym_readnone] = ACTIONS(671),
    [anon_sym_readonly] = ACTIONS(671),
    [anon_sym_writeonly] = ACTIONS(671),
    [anon_sym_argmemonly] = ACTIONS(671),
    [anon_sym_returns_twice] = ACTIONS(671),
    [anon_sym_safestack] = ACTIONS(671),
    [anon_sym_sanitize_address] = ACTIONS(671),
    [anon_sym_sanitize_memory] = ACTIONS(671),
    [anon_sym_sanitize_thread] = ACTIONS(671),
    [anon_sym_sanitize_hwaddress] = ACTIONS(671),
    [anon_sym_sanitize_memtag] = ACTIONS(671),
    [anon_sym_speculative_load_hardening] = ACTIONS(671),
    [anon_sym_speculatable] = ACTIONS(671),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(671),
    [anon_sym_sspreq] = ACTIONS(671),
    [anon_sym_strictfp] = ACTIONS(671),
    [anon_sym_uwtable] = ACTIONS(671),
    [anon_sym_nocf_check] = ACTIONS(671),
    [anon_sym_shadowcallstack] = ACTIONS(671),
    [anon_sym_mustprogress] = ACTIONS(671),
    [anon_sym_vscale_range] = ACTIONS(671),
    [anon_sym_preallocated] = ACTIONS(671),
    [anon_sym_zeroext] = ACTIONS(671),
    [anon_sym_signext] = ACTIONS(671),
    [anon_sym_inreg] = ACTIONS(671),
    [anon_sym_byval] = ACTIONS(671),
    [anon_sym_byref] = ACTIONS(671),
    [anon_sym_inalloca] = ACTIONS(671),
    [anon_sym_sret] = ACTIONS(671),
    [anon_sym_elementtype] = ACTIONS(671),
    [anon_sym_noalias] = ACTIONS(671),
    [anon_sym_nocapture] = ACTIONS(671),
    [anon_sym_nest] = ACTIONS(671),
    [anon_sym_returned] = ACTIONS(671),
    [anon_sym_nonnull] = ACTIONS(671),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(671),
    [anon_sym_swiftself] = ACTIONS(673),
    [anon_sym_swiftasync] = ACTIONS(673),
    [anon_sym_swifterror] = ACTIONS(673),
    [anon_sym_immarg] = ACTIONS(671),
    [anon_sym_noundef] = ACTIONS(671),
    [anon_sym_to] = ACTIONS(673),
    [anon_sym_unwind] = ACTIONS(671),
    [anon_sym_unordered] = ACTIONS(671),
    [anon_sym_monotonic] = ACTIONS(671),
    [anon_sym_acquire] = ACTIONS(671),
    [anon_sym_release] = ACTIONS(671),
    [anon_sym_acq_rel] = ACTIONS(671),
    [anon_sym_seq_cst] = ACTIONS(671),
    [anon_sym_syncscope] = ACTIONS(671),
    [anon_sym_uselistorder] = ACTIONS(673),
    [anon_sym_uselistorder_bb] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_attributes] = ACTIONS(671),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(675),
    [sym_global_var] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [aux_sym_metadata_ref_token1] = ACTIONS(675),
    [sym_summary_ref] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [anon_sym_target] = ACTIONS(675),
    [anon_sym_source_filename] = ACTIONS(675),
    [anon_sym_declare] = ACTIONS(675),
    [anon_sym_define] = ACTIONS(675),
    [anon_sym_no_cfi] = ACTIONS(675),
    [anon_sym_private] = ACTIONS(675),
    [anon_sym_internal] = ACTIONS(675),
    [anon_sym_weak] = ACTIONS(677),
    [anon_sym_weak_odr] = ACTIONS(675),
    [anon_sym_linkonce] = ACTIONS(677),
    [anon_sym_linkonce_odr] = ACTIONS(675),
    [anon_sym_available_externally] = ACTIONS(675),
    [anon_sym_appending] = ACTIONS(675),
    [anon_sym_common] = ACTIONS(675),
    [anon_sym_extern_weak] = ACTIONS(675),
    [anon_sym_external] = ACTIONS(675),
    [anon_sym_dso_local] = ACTIONS(677),
    [anon_sym_dso_local_equivalent] = ACTIONS(675),
    [anon_sym_dso_preemptable] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_hidden] = ACTIONS(675),
    [anon_sym_protected] = ACTIONS(675),
    [anon_sym_dllimport] = ACTIONS(675),
    [anon_sym_dllexport] = ACTIONS(675),
    [anon_sym_ccc] = ACTIONS(675),
    [anon_sym_fastcc] = ACTIONS(675),
    [anon_sym_coldcc] = ACTIONS(675),
    [anon_sym_webkit_jscc] = ACTIONS(677),
    [anon_sym_anyregcc] = ACTIONS(675),
    [anon_sym_preserve_mostcc] = ACTIONS(675),
    [anon_sym_preserve_allcc] = ACTIONS(675),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(677),
    [anon_sym_tailcc] = ACTIONS(675),
    [anon_sym_swiftcc] = ACTIONS(677),
    [anon_sym_swifttailcc] = ACTIONS(677),
    [anon_sym_cfguard_checkcc] = ACTIONS(675),
    [aux_sym_calling_conv_token1] = ACTIONS(677),
    [aux_sym_calling_conv_token2] = ACTIONS(675),
    [aux_sym_calling_conv_token3] = ACTIONS(675),
    [aux_sym_calling_conv_token4] = ACTIONS(675),
    [aux_sym_calling_conv_token5] = ACTIONS(675),
    [aux_sym_calling_conv_token6] = ACTIONS(675),
    [aux_sym_calling_conv_token7] = ACTIONS(675),
    [aux_sym_calling_conv_token8] = ACTIONS(675),
    [aux_sym_calling_conv_token9] = ACTIONS(675),
    [aux_sym_calling_conv_token10] = ACTIONS(677),
    [anon_sym_ghccc] = ACTIONS(675),
    [aux_sym_calling_conv_token11] = ACTIONS(677),
    [aux_sym_calling_conv_token12] = ACTIONS(675),
    [aux_sym_calling_conv_token13] = ACTIONS(677),
    [aux_sym_calling_conv_token14] = ACTIONS(675),
    [anon_sym_cc] = ACTIONS(677),
    [anon_sym_unnamed_addr] = ACTIONS(675),
    [anon_sym_local_unnamed_addr] = ACTIONS(675),
    [anon_sym_void] = ACTIONS(675),
    [anon_sym_half] = ACTIONS(675),
    [anon_sym_bfloat] = ACTIONS(675),
    [anon_sym_float] = ACTIONS(675),
    [anon_sym_double] = ACTIONS(675),
    [anon_sym_x86_fp80] = ACTIONS(677),
    [anon_sym_fp128] = ACTIONS(675),
    [anon_sym_ppc_fp128] = ACTIONS(675),
    [anon_sym_label] = ACTIONS(675),
    [anon_sym_metadata] = ACTIONS(675),
    [anon_sym_x86_mmx] = ACTIONS(677),
    [anon_sym_x86_amx] = ACTIONS(677),
    [anon_sym_token] = ACTIONS(675),
    [anon_sym_opaque] = ACTIONS(675),
    [anon_sym_ptr] = ACTIONS(675),
    [aux_sym_type_keyword_token1] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LT_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_alignstack] = ACTIONS(675),
    [anon_sym_allocsize] = ACTIONS(675),
    [anon_sym_alwaysinline] = ACTIONS(675),
    [anon_sym_builtin] = ACTIONS(675),
    [anon_sym_cold] = ACTIONS(677),
    [anon_sym_convergent] = ACTIONS(675),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(675),
    [anon_sym_hot] = ACTIONS(675),
    [anon_sym_inaccessiblememonly] = ACTIONS(675),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(675),
    [anon_sym_inlinehint] = ACTIONS(675),
    [anon_sym_jumptable] = ACTIONS(675),
    [anon_sym_minsize] = ACTIONS(675),
    [anon_sym_naked] = ACTIONS(675),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(675),
    [anon_sym_nobuiltin] = ACTIONS(675),
    [anon_sym_noduplicate] = ACTIONS(675),
    [anon_sym_nofree] = ACTIONS(675),
    [anon_sym_noimplicitfloat] = ACTIONS(675),
    [anon_sym_noinline] = ACTIONS(675),
    [anon_sym_nomerge] = ACTIONS(675),
    [anon_sym_nonlazybind] = ACTIONS(675),
    [anon_sym_noprofile] = ACTIONS(675),
    [anon_sym_noredzone] = ACTIONS(675),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(675),
    [anon_sym_noreturn] = ACTIONS(675),
    [anon_sym_norecurse] = ACTIONS(675),
    [anon_sym_willreturn] = ACTIONS(675),
    [anon_sym_nosync] = ACTIONS(675),
    [anon_sym_nounwind] = ACTIONS(675),
    [anon_sym_nosanitize_coverage] = ACTIONS(675),
    [anon_sym_null_pointer_is_valid] = ACTIONS(675),
    [anon_sym_optforfuzzing] = ACTIONS(675),
    [anon_sym_optnone] = ACTIONS(675),
    [anon_sym_optsize] = ACTIONS(675),
    [anon_sym_readnone] = ACTIONS(675),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_writeonly] = ACTIONS(675),
    [anon_sym_argmemonly] = ACTIONS(675),
    [anon_sym_returns_twice] = ACTIONS(675),
    [anon_sym_safestack] = ACTIONS(675),
    [anon_sym_sanitize_address] = ACTIONS(675),
    [anon_sym_sanitize_memory] = ACTIONS(675),
    [anon_sym_sanitize_thread] = ACTIONS(675),
    [anon_sym_sanitize_hwaddress] = ACTIONS(675),
    [anon_sym_sanitize_memtag] = ACTIONS(675),
    [anon_sym_speculative_load_hardening] = ACTIONS(675),
    [anon_sym_speculatable] = ACTIONS(675),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(675),
    [anon_sym_sspreq] = ACTIONS(675),
    [anon_sym_strictfp] = ACTIONS(675),
    [anon_sym_uwtable] = ACTIONS(675),
    [anon_sym_nocf_check] = ACTIONS(675),
    [anon_sym_shadowcallstack] = ACTIONS(675),
    [anon_sym_mustprogress] = ACTIONS(675),
    [anon_sym_vscale_range] = ACTIONS(675),
    [anon_sym_preallocated] = ACTIONS(675),
    [anon_sym_zeroext] = ACTIONS(675),
    [anon_sym_signext] = ACTIONS(675),
    [anon_sym_inreg] = ACTIONS(675),
    [anon_sym_byval] = ACTIONS(675),
    [anon_sym_byref] = ACTIONS(675),
    [anon_sym_inalloca] = ACTIONS(675),
    [anon_sym_sret] = ACTIONS(675),
    [anon_sym_elementtype] = ACTIONS(675),
    [anon_sym_noalias] = ACTIONS(675),
    [anon_sym_nocapture] = ACTIONS(675),
    [anon_sym_nest] = ACTIONS(675),
    [anon_sym_returned] = ACTIONS(675),
    [anon_sym_nonnull] = ACTIONS(675),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(675),
    [anon_sym_swiftself] = ACTIONS(677),
    [anon_sym_swiftasync] = ACTIONS(677),
    [anon_sym_swifterror] = ACTIONS(677),
    [anon_sym_immarg] = ACTIONS(675),
    [anon_sym_noundef] = ACTIONS(675),
    [anon_sym_to] = ACTIONS(677),
    [anon_sym_unwind] = ACTIONS(675),
    [anon_sym_unordered] = ACTIONS(675),
    [anon_sym_monotonic] = ACTIONS(675),
    [anon_sym_acquire] = ACTIONS(675),
    [anon_sym_release] = ACTIONS(675),
    [anon_sym_acq_rel] = ACTIONS(675),
    [anon_sym_seq_cst] = ACTIONS(675),
    [anon_sym_syncscope] = ACTIONS(675),
    [anon_sym_uselistorder] = ACTIONS(677),
    [anon_sym_uselistorder_bb] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_attributes] = ACTIONS(675),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_no_cfi] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_internal] = ACTIONS(679),
    [anon_sym_weak] = ACTIONS(681),
    [anon_sym_weak_odr] = ACTIONS(679),
    [anon_sym_linkonce] = ACTIONS(681),
    [anon_sym_linkonce_odr] = ACTIONS(679),
    [anon_sym_available_externally] = ACTIONS(679),
    [anon_sym_appending] = ACTIONS(679),
    [anon_sym_common] = ACTIONS(679),
    [anon_sym_extern_weak] = ACTIONS(679),
    [anon_sym_external] = ACTIONS(679),
    [anon_sym_dso_local] = ACTIONS(681),
    [anon_sym_dso_local_equivalent] = ACTIONS(679),
    [anon_sym_dso_preemptable] = ACTIONS(679),
    [anon_sym_default] = ACTIONS(679),
    [anon_sym_hidden] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_dllimport] = ACTIONS(679),
    [anon_sym_dllexport] = ACTIONS(679),
    [anon_sym_ccc] = ACTIONS(679),
    [anon_sym_fastcc] = ACTIONS(679),
    [anon_sym_coldcc] = ACTIONS(679),
    [anon_sym_webkit_jscc] = ACTIONS(681),
    [anon_sym_anyregcc] = ACTIONS(679),
    [anon_sym_preserve_mostcc] = ACTIONS(679),
    [anon_sym_preserve_allcc] = ACTIONS(679),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(681),
    [anon_sym_tailcc] = ACTIONS(679),
    [anon_sym_swiftcc] = ACTIONS(681),
    [anon_sym_swifttailcc] = ACTIONS(681),
    [anon_sym_cfguard_checkcc] = ACTIONS(679),
    [aux_sym_calling_conv_token1] = ACTIONS(681),
    [aux_sym_calling_conv_token2] = ACTIONS(679),
    [aux_sym_calling_conv_token3] = ACTIONS(679),
    [aux_sym_calling_conv_token4] = ACTIONS(679),
    [aux_sym_calling_conv_token5] = ACTIONS(679),
    [aux_sym_calling_conv_token6] = ACTIONS(679),
    [aux_sym_calling_conv_token7] = ACTIONS(679),
    [aux_sym_calling_conv_token8] = ACTIONS(679),
    [aux_sym_calling_conv_token9] = ACTIONS(679),
    [aux_sym_calling_conv_token10] = ACTIONS(681),
    [anon_sym_ghccc] = ACTIONS(679),
    [aux_sym_calling_conv_token11] = ACTIONS(681),
    [aux_sym_calling_conv_token12] = ACTIONS(679),
    [aux_sym_calling_conv_token13] = ACTIONS(681),
    [aux_sym_calling_conv_token14] = ACTIONS(679),
    [anon_sym_cc] = ACTIONS(681),
    [anon_sym_unnamed_addr] = ACTIONS(679),
    [anon_sym_local_unnamed_addr] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(681),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(681),
    [anon_sym_x86_amx] = ACTIONS(681),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_unwind] = ACTIONS(679),
    [anon_sym_unordered] = ACTIONS(679),
    [anon_sym_monotonic] = ACTIONS(679),
    [anon_sym_acquire] = ACTIONS(679),
    [anon_sym_release] = ACTIONS(679),
    [anon_sym_acq_rel] = ACTIONS(679),
    [anon_sym_seq_cst] = ACTIONS(679),
    [anon_sym_syncscope] = ACTIONS(679),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [130] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(585),
    [sym_local_var] = ACTIONS(585),
    [sym_label] = ACTIONS(585),
    [sym_string] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_align] = ACTIONS(587),
    [anon_sym_section] = ACTIONS(587),
    [anon_sym_partition] = ACTIONS(587),
    [anon_sym_comdat] = ACTIONS(587),
    [anon_sym_gc] = ACTIONS(587),
    [anon_sym_prefix] = ACTIONS(587),
    [anon_sym_prologue] = ACTIONS(587),
    [anon_sym_personality] = ACTIONS(587),
    [anon_sym_alignstack] = ACTIONS(587),
    [anon_sym_allocsize] = ACTIONS(587),
    [anon_sym_alwaysinline] = ACTIONS(587),
    [anon_sym_builtin] = ACTIONS(587),
    [anon_sym_cold] = ACTIONS(587),
    [anon_sym_convergent] = ACTIONS(587),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(587),
    [anon_sym_hot] = ACTIONS(587),
    [anon_sym_inaccessiblememonly] = ACTIONS(587),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(587),
    [anon_sym_inlinehint] = ACTIONS(587),
    [anon_sym_jumptable] = ACTIONS(587),
    [anon_sym_minsize] = ACTIONS(587),
    [anon_sym_naked] = ACTIONS(587),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(587),
    [anon_sym_nobuiltin] = ACTIONS(587),
    [anon_sym_noduplicate] = ACTIONS(587),
    [anon_sym_nofree] = ACTIONS(587),
    [anon_sym_noimplicitfloat] = ACTIONS(587),
    [anon_sym_noinline] = ACTIONS(587),
    [anon_sym_nomerge] = ACTIONS(587),
    [anon_sym_nonlazybind] = ACTIONS(587),
    [anon_sym_noprofile] = ACTIONS(587),
    [anon_sym_noredzone] = ACTIONS(587),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(587),
    [anon_sym_noreturn] = ACTIONS(587),
    [anon_sym_norecurse] = ACTIONS(587),
    [anon_sym_willreturn] = ACTIONS(587),
    [anon_sym_nosync] = ACTIONS(587),
    [anon_sym_nounwind] = ACTIONS(587),
    [anon_sym_nosanitize_coverage] = ACTIONS(587),
    [anon_sym_null_pointer_is_valid] = ACTIONS(587),
    [anon_sym_optforfuzzing] = ACTIONS(587),
    [anon_sym_optnone] = ACTIONS(587),
    [anon_sym_optsize] = ACTIONS(587),
    [anon_sym_readnone] = ACTIONS(587),
    [anon_sym_readonly] = ACTIONS(587),
    [anon_sym_writeonly] = ACTIONS(587),
    [anon_sym_argmemonly] = ACTIONS(587),
    [anon_sym_returns_twice] = ACTIONS(587),
    [anon_sym_safestack] = ACTIONS(587),
    [anon_sym_sanitize_address] = ACTIONS(587),
    [anon_sym_sanitize_memory] = ACTIONS(587),
    [anon_sym_sanitize_thread] = ACTIONS(587),
    [anon_sym_sanitize_hwaddress] = ACTIONS(587),
    [anon_sym_sanitize_memtag] = ACTIONS(587),
    [anon_sym_speculative_load_hardening] = ACTIONS(587),
    [anon_sym_speculatable] = ACTIONS(587),
    [anon_sym_ssp] = ACTIONS(587),
    [anon_sym_sspstrong] = ACTIONS(587),
    [anon_sym_sspreq] = ACTIONS(587),
    [anon_sym_strictfp] = ACTIONS(587),
    [anon_sym_uwtable] = ACTIONS(587),
    [anon_sym_nocf_check] = ACTIONS(587),
    [anon_sym_shadowcallstack] = ACTIONS(587),
    [anon_sym_mustprogress] = ACTIONS(587),
    [anon_sym_vscale_range] = ACTIONS(587),
    [anon_sym_preallocated] = ACTIONS(587),
    [anon_sym_zeroext] = ACTIONS(587),
    [anon_sym_signext] = ACTIONS(587),
    [anon_sym_inreg] = ACTIONS(587),
    [anon_sym_byval] = ACTIONS(587),
    [anon_sym_byref] = ACTIONS(587),
    [anon_sym_inalloca] = ACTIONS(587),
    [anon_sym_sret] = ACTIONS(587),
    [anon_sym_elementtype] = ACTIONS(587),
    [anon_sym_noalias] = ACTIONS(587),
    [anon_sym_nocapture] = ACTIONS(587),
    [anon_sym_nest] = ACTIONS(587),
    [anon_sym_returned] = ACTIONS(587),
    [anon_sym_nonnull] = ACTIONS(587),
    [anon_sym_dereferenceable] = ACTIONS(587),
    [anon_sym_dereferenceable_or_null] = ACTIONS(587),
    [anon_sym_swiftself] = ACTIONS(587),
    [anon_sym_swiftasync] = ACTIONS(587),
    [anon_sym_swifterror] = ACTIONS(587),
    [anon_sym_immarg] = ACTIONS(587),
    [anon_sym_noundef] = ACTIONS(587),
    [anon_sym_unreachable] = ACTIONS(587),
    [anon_sym_ret] = ACTIONS(587),
    [anon_sym_br] = ACTIONS(587),
    [anon_sym_resume] = ACTIONS(587),
    [anon_sym_freeze] = ACTIONS(587),
    [anon_sym_indirectbr] = ACTIONS(587),
    [anon_sym_extractelement] = ACTIONS(587),
    [anon_sym_insertelement] = ACTIONS(587),
    [anon_sym_select] = ACTIONS(587),
    [anon_sym_shufflevector] = ACTIONS(587),
    [anon_sym_fneg] = ACTIONS(587),
    [anon_sym_switch] = ACTIONS(587),
    [anon_sym_invoke] = ACTIONS(587),
    [anon_sym_cleanupret] = ACTIONS(587),
    [anon_sym_catchret] = ACTIONS(587),
    [anon_sym_catchswitch] = ACTIONS(587),
    [anon_sym_catchpad] = ACTIONS(587),
    [anon_sym_cleanuppad] = ACTIONS(587),
    [anon_sym_callbr] = ACTIONS(587),
    [anon_sym_icmp] = ACTIONS(587),
    [anon_sym_fcmp] = ACTIONS(587),
    [anon_sym_va_arg] = ACTIONS(587),
    [anon_sym_phi] = ACTIONS(587),
    [anon_sym_landingpad] = ACTIONS(587),
    [anon_sym_tail] = ACTIONS(587),
    [anon_sym_musttail] = ACTIONS(587),
    [anon_sym_notail] = ACTIONS(587),
    [anon_sym_call] = ACTIONS(587),
    [anon_sym_alloca] = ACTIONS(587),
    [anon_sym_load] = ACTIONS(587),
    [anon_sym_store] = ACTIONS(587),
    [anon_sym_cmpxchg] = ACTIONS(587),
    [anon_sym_atomicrmw] = ACTIONS(587),
    [anon_sym_fence] = ACTIONS(587),
    [anon_sym_getelementptr] = ACTIONS(587),
    [anon_sym_extractvalue] = ACTIONS(587),
    [anon_sym_insertvalue] = ACTIONS(587),
    [anon_sym_catch] = ACTIONS(587),
    [anon_sym_filter] = ACTIONS(587),
    [anon_sym_mul] = ACTIONS(587),
    [anon_sym_urem] = ACTIONS(587),
    [anon_sym_srem] = ACTIONS(587),
    [anon_sym_shl] = ACTIONS(587),
    [anon_sym_udiv] = ACTIONS(587),
    [anon_sym_sdiv] = ACTIONS(587),
    [anon_sym_lshr] = ACTIONS(587),
    [anon_sym_ashr] = ACTIONS(587),
    [anon_sym_fmul] = ACTIONS(587),
    [anon_sym_fdiv] = ACTIONS(587),
    [anon_sym_frem] = ACTIONS(587),
    [anon_sym_xchg] = ACTIONS(587),
    [anon_sym_add] = ACTIONS(587),
    [anon_sym_sub] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(587),
    [anon_sym_nand] = ACTIONS(587),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_xor] = ACTIONS(587),
    [anon_sym_max] = ACTIONS(587),
    [anon_sym_min] = ACTIONS(587),
    [anon_sym_umax] = ACTIONS(587),
    [anon_sym_umin] = ACTIONS(587),
    [anon_sym_fadd] = ACTIONS(587),
    [anon_sym_fsub] = ACTIONS(587),
    [anon_sym_bitcast] = ACTIONS(587),
    [anon_sym_trunc] = ACTIONS(587),
    [anon_sym_zext] = ACTIONS(587),
    [anon_sym_sext] = ACTIONS(587),
    [anon_sym_fptrunc] = ACTIONS(587),
    [anon_sym_fpext] = ACTIONS(587),
    [anon_sym_addrspacecast] = ACTIONS(587),
    [anon_sym_uitofp] = ACTIONS(587),
    [anon_sym_sitofp] = ACTIONS(587),
    [anon_sym_fptoui] = ACTIONS(587),
    [anon_sym_fptosi] = ACTIONS(587),
    [anon_sym_inttoptr] = ACTIONS(587),
    [anon_sym_ptrtoint] = ACTIONS(587),
    [anon_sym_unordered] = ACTIONS(587),
    [anon_sym_monotonic] = ACTIONS(587),
    [anon_sym_acquire] = ACTIONS(587),
    [anon_sym_release] = ACTIONS(587),
    [anon_sym_acq_rel] = ACTIONS(587),
    [anon_sym_seq_cst] = ACTIONS(587),
    [anon_sym_syncscope] = ACTIONS(587),
    [anon_sym_uselistorder] = ACTIONS(587),
    [anon_sym_LPAREN2] = ACTIONS(683),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(685),
    [sym_global_var] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [aux_sym_metadata_ref_token1] = ACTIONS(685),
    [sym_summary_ref] = ACTIONS(685),
    [sym_string] = ACTIONS(685),
    [anon_sym_target] = ACTIONS(685),
    [anon_sym_source_filename] = ACTIONS(685),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_define] = ACTIONS(685),
    [anon_sym_no_cfi] = ACTIONS(685),
    [anon_sym_private] = ACTIONS(685),
    [anon_sym_internal] = ACTIONS(685),
    [anon_sym_weak] = ACTIONS(687),
    [anon_sym_weak_odr] = ACTIONS(685),
    [anon_sym_linkonce] = ACTIONS(687),
    [anon_sym_linkonce_odr] = ACTIONS(685),
    [anon_sym_available_externally] = ACTIONS(685),
    [anon_sym_appending] = ACTIONS(685),
    [anon_sym_common] = ACTIONS(685),
    [anon_sym_extern_weak] = ACTIONS(685),
    [anon_sym_external] = ACTIONS(685),
    [anon_sym_dso_local] = ACTIONS(687),
    [anon_sym_dso_local_equivalent] = ACTIONS(685),
    [anon_sym_dso_preemptable] = ACTIONS(685),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_hidden] = ACTIONS(685),
    [anon_sym_protected] = ACTIONS(685),
    [anon_sym_dllimport] = ACTIONS(685),
    [anon_sym_dllexport] = ACTIONS(685),
    [anon_sym_ccc] = ACTIONS(685),
    [anon_sym_fastcc] = ACTIONS(685),
    [anon_sym_coldcc] = ACTIONS(685),
    [anon_sym_webkit_jscc] = ACTIONS(687),
    [anon_sym_anyregcc] = ACTIONS(685),
    [anon_sym_preserve_mostcc] = ACTIONS(685),
    [anon_sym_preserve_allcc] = ACTIONS(685),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(687),
    [anon_sym_tailcc] = ACTIONS(685),
    [anon_sym_swiftcc] = ACTIONS(687),
    [anon_sym_swifttailcc] = ACTIONS(687),
    [anon_sym_cfguard_checkcc] = ACTIONS(685),
    [aux_sym_calling_conv_token1] = ACTIONS(687),
    [aux_sym_calling_conv_token2] = ACTIONS(685),
    [aux_sym_calling_conv_token3] = ACTIONS(685),
    [aux_sym_calling_conv_token4] = ACTIONS(685),
    [aux_sym_calling_conv_token5] = ACTIONS(685),
    [aux_sym_calling_conv_token6] = ACTIONS(685),
    [aux_sym_calling_conv_token7] = ACTIONS(685),
    [aux_sym_calling_conv_token8] = ACTIONS(685),
    [aux_sym_calling_conv_token9] = ACTIONS(685),
    [aux_sym_calling_conv_token10] = ACTIONS(687),
    [anon_sym_ghccc] = ACTIONS(685),
    [aux_sym_calling_conv_token11] = ACTIONS(687),
    [aux_sym_calling_conv_token12] = ACTIONS(685),
    [aux_sym_calling_conv_token13] = ACTIONS(687),
    [aux_sym_calling_conv_token14] = ACTIONS(685),
    [anon_sym_cc] = ACTIONS(687),
    [anon_sym_unnamed_addr] = ACTIONS(685),
    [anon_sym_local_unnamed_addr] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(685),
    [anon_sym_half] = ACTIONS(685),
    [anon_sym_bfloat] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_double] = ACTIONS(685),
    [anon_sym_x86_fp80] = ACTIONS(687),
    [anon_sym_fp128] = ACTIONS(685),
    [anon_sym_ppc_fp128] = ACTIONS(685),
    [anon_sym_label] = ACTIONS(685),
    [anon_sym_metadata] = ACTIONS(685),
    [anon_sym_x86_mmx] = ACTIONS(687),
    [anon_sym_x86_amx] = ACTIONS(687),
    [anon_sym_token] = ACTIONS(685),
    [anon_sym_opaque] = ACTIONS(685),
    [anon_sym_ptr] = ACTIONS(685),
    [aux_sym_type_keyword_token1] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LT_LBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_alignstack] = ACTIONS(685),
    [anon_sym_allocsize] = ACTIONS(685),
    [anon_sym_alwaysinline] = ACTIONS(685),
    [anon_sym_builtin] = ACTIONS(685),
    [anon_sym_cold] = ACTIONS(687),
    [anon_sym_convergent] = ACTIONS(685),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(685),
    [anon_sym_hot] = ACTIONS(685),
    [anon_sym_inaccessiblememonly] = ACTIONS(685),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(685),
    [anon_sym_inlinehint] = ACTIONS(685),
    [anon_sym_jumptable] = ACTIONS(685),
    [anon_sym_minsize] = ACTIONS(685),
    [anon_sym_naked] = ACTIONS(685),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(685),
    [anon_sym_nobuiltin] = ACTIONS(685),
    [anon_sym_noduplicate] = ACTIONS(685),
    [anon_sym_nofree] = ACTIONS(685),
    [anon_sym_noimplicitfloat] = ACTIONS(685),
    [anon_sym_noinline] = ACTIONS(685),
    [anon_sym_nomerge] = ACTIONS(685),
    [anon_sym_nonlazybind] = ACTIONS(685),
    [anon_sym_noprofile] = ACTIONS(685),
    [anon_sym_noredzone] = ACTIONS(685),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(685),
    [anon_sym_noreturn] = ACTIONS(685),
    [anon_sym_norecurse] = ACTIONS(685),
    [anon_sym_willreturn] = ACTIONS(685),
    [anon_sym_nosync] = ACTIONS(685),
    [anon_sym_nounwind] = ACTIONS(685),
    [anon_sym_nosanitize_coverage] = ACTIONS(685),
    [anon_sym_null_pointer_is_valid] = ACTIONS(685),
    [anon_sym_optforfuzzing] = ACTIONS(685),
    [anon_sym_optnone] = ACTIONS(685),
    [anon_sym_optsize] = ACTIONS(685),
    [anon_sym_readnone] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(685),
    [anon_sym_writeonly] = ACTIONS(685),
    [anon_sym_argmemonly] = ACTIONS(685),
    [anon_sym_returns_twice] = ACTIONS(685),
    [anon_sym_safestack] = ACTIONS(685),
    [anon_sym_sanitize_address] = ACTIONS(685),
    [anon_sym_sanitize_memory] = ACTIONS(685),
    [anon_sym_sanitize_thread] = ACTIONS(685),
    [anon_sym_sanitize_hwaddress] = ACTIONS(685),
    [anon_sym_sanitize_memtag] = ACTIONS(685),
    [anon_sym_speculative_load_hardening] = ACTIONS(685),
    [anon_sym_speculatable] = ACTIONS(685),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(685),
    [anon_sym_sspreq] = ACTIONS(685),
    [anon_sym_strictfp] = ACTIONS(685),
    [anon_sym_uwtable] = ACTIONS(685),
    [anon_sym_nocf_check] = ACTIONS(685),
    [anon_sym_shadowcallstack] = ACTIONS(685),
    [anon_sym_mustprogress] = ACTIONS(685),
    [anon_sym_vscale_range] = ACTIONS(685),
    [anon_sym_preallocated] = ACTIONS(685),
    [anon_sym_zeroext] = ACTIONS(685),
    [anon_sym_signext] = ACTIONS(685),
    [anon_sym_inreg] = ACTIONS(685),
    [anon_sym_byval] = ACTIONS(685),
    [anon_sym_byref] = ACTIONS(685),
    [anon_sym_inalloca] = ACTIONS(685),
    [anon_sym_sret] = ACTIONS(685),
    [anon_sym_elementtype] = ACTIONS(685),
    [anon_sym_noalias] = ACTIONS(685),
    [anon_sym_nocapture] = ACTIONS(685),
    [anon_sym_nest] = ACTIONS(685),
    [anon_sym_returned] = ACTIONS(685),
    [anon_sym_nonnull] = ACTIONS(685),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(685),
    [anon_sym_swiftself] = ACTIONS(687),
    [anon_sym_swiftasync] = ACTIONS(687),
    [anon_sym_swifterror] = ACTIONS(687),
    [anon_sym_immarg] = ACTIONS(685),
    [anon_sym_noundef] = ACTIONS(685),
    [anon_sym_to] = ACTIONS(687),
    [anon_sym_unwind] = ACTIONS(685),
    [anon_sym_unordered] = ACTIONS(685),
    [anon_sym_monotonic] = ACTIONS(685),
    [anon_sym_acquire] = ACTIONS(685),
    [anon_sym_release] = ACTIONS(685),
    [anon_sym_acq_rel] = ACTIONS(685),
    [anon_sym_seq_cst] = ACTIONS(685),
    [anon_sym_syncscope] = ACTIONS(685),
    [anon_sym_uselistorder] = ACTIONS(687),
    [anon_sym_uselistorder_bb] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_attributes] = ACTIONS(685),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_no_cfi] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(667),
    [anon_sym_weak] = ACTIONS(669),
    [anon_sym_weak_odr] = ACTIONS(667),
    [anon_sym_linkonce] = ACTIONS(669),
    [anon_sym_linkonce_odr] = ACTIONS(667),
    [anon_sym_available_externally] = ACTIONS(667),
    [anon_sym_appending] = ACTIONS(667),
    [anon_sym_common] = ACTIONS(667),
    [anon_sym_extern_weak] = ACTIONS(667),
    [anon_sym_external] = ACTIONS(667),
    [anon_sym_dso_local] = ACTIONS(669),
    [anon_sym_dso_local_equivalent] = ACTIONS(667),
    [anon_sym_dso_preemptable] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(667),
    [anon_sym_hidden] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_dllimport] = ACTIONS(667),
    [anon_sym_dllexport] = ACTIONS(667),
    [anon_sym_ccc] = ACTIONS(667),
    [anon_sym_fastcc] = ACTIONS(667),
    [anon_sym_coldcc] = ACTIONS(667),
    [anon_sym_webkit_jscc] = ACTIONS(669),
    [anon_sym_anyregcc] = ACTIONS(667),
    [anon_sym_preserve_mostcc] = ACTIONS(667),
    [anon_sym_preserve_allcc] = ACTIONS(667),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(669),
    [anon_sym_tailcc] = ACTIONS(667),
    [anon_sym_swiftcc] = ACTIONS(669),
    [anon_sym_swifttailcc] = ACTIONS(669),
    [anon_sym_cfguard_checkcc] = ACTIONS(667),
    [aux_sym_calling_conv_token1] = ACTIONS(669),
    [aux_sym_calling_conv_token2] = ACTIONS(667),
    [aux_sym_calling_conv_token3] = ACTIONS(667),
    [aux_sym_calling_conv_token4] = ACTIONS(667),
    [aux_sym_calling_conv_token5] = ACTIONS(667),
    [aux_sym_calling_conv_token6] = ACTIONS(667),
    [aux_sym_calling_conv_token7] = ACTIONS(667),
    [aux_sym_calling_conv_token8] = ACTIONS(667),
    [aux_sym_calling_conv_token9] = ACTIONS(667),
    [aux_sym_calling_conv_token10] = ACTIONS(669),
    [anon_sym_ghccc] = ACTIONS(667),
    [aux_sym_calling_conv_token11] = ACTIONS(669),
    [aux_sym_calling_conv_token12] = ACTIONS(667),
    [aux_sym_calling_conv_token13] = ACTIONS(669),
    [aux_sym_calling_conv_token14] = ACTIONS(667),
    [anon_sym_cc] = ACTIONS(669),
    [anon_sym_unnamed_addr] = ACTIONS(667),
    [anon_sym_local_unnamed_addr] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(669),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(669),
    [anon_sym_x86_amx] = ACTIONS(669),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_unwind] = ACTIONS(667),
    [anon_sym_unordered] = ACTIONS(667),
    [anon_sym_monotonic] = ACTIONS(667),
    [anon_sym_acquire] = ACTIONS(667),
    [anon_sym_release] = ACTIONS(667),
    [anon_sym_acq_rel] = ACTIONS(667),
    [anon_sym_seq_cst] = ACTIONS(667),
    [anon_sym_syncscope] = ACTIONS(667),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [133] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [sym_label] = ACTIONS(533),
    [sym_string] = ACTIONS(535),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_section] = ACTIONS(535),
    [anon_sym_partition] = ACTIONS(535),
    [anon_sym_comdat] = ACTIONS(535),
    [anon_sym_gc] = ACTIONS(535),
    [anon_sym_prefix] = ACTIONS(535),
    [anon_sym_prologue] = ACTIONS(535),
    [anon_sym_personality] = ACTIONS(535),
    [anon_sym_alignstack] = ACTIONS(535),
    [anon_sym_allocsize] = ACTIONS(535),
    [anon_sym_alwaysinline] = ACTIONS(535),
    [anon_sym_builtin] = ACTIONS(535),
    [anon_sym_cold] = ACTIONS(535),
    [anon_sym_convergent] = ACTIONS(535),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(535),
    [anon_sym_hot] = ACTIONS(535),
    [anon_sym_inaccessiblememonly] = ACTIONS(535),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(535),
    [anon_sym_inlinehint] = ACTIONS(535),
    [anon_sym_jumptable] = ACTIONS(535),
    [anon_sym_minsize] = ACTIONS(535),
    [anon_sym_naked] = ACTIONS(535),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(535),
    [anon_sym_nobuiltin] = ACTIONS(535),
    [anon_sym_noduplicate] = ACTIONS(535),
    [anon_sym_nofree] = ACTIONS(535),
    [anon_sym_noimplicitfloat] = ACTIONS(535),
    [anon_sym_noinline] = ACTIONS(535),
    [anon_sym_nomerge] = ACTIONS(535),
    [anon_sym_nonlazybind] = ACTIONS(535),
    [anon_sym_noprofile] = ACTIONS(535),
    [anon_sym_noredzone] = ACTIONS(535),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(535),
    [anon_sym_noreturn] = ACTIONS(535),
    [anon_sym_norecurse] = ACTIONS(535),
    [anon_sym_willreturn] = ACTIONS(535),
    [anon_sym_nosync] = ACTIONS(535),
    [anon_sym_nounwind] = ACTIONS(535),
    [anon_sym_nosanitize_coverage] = ACTIONS(535),
    [anon_sym_null_pointer_is_valid] = ACTIONS(535),
    [anon_sym_optforfuzzing] = ACTIONS(535),
    [anon_sym_optnone] = ACTIONS(535),
    [anon_sym_optsize] = ACTIONS(535),
    [anon_sym_readnone] = ACTIONS(535),
    [anon_sym_readonly] = ACTIONS(535),
    [anon_sym_writeonly] = ACTIONS(535),
    [anon_sym_argmemonly] = ACTIONS(535),
    [anon_sym_returns_twice] = ACTIONS(535),
    [anon_sym_safestack] = ACTIONS(535),
    [anon_sym_sanitize_address] = ACTIONS(535),
    [anon_sym_sanitize_memory] = ACTIONS(535),
    [anon_sym_sanitize_thread] = ACTIONS(535),
    [anon_sym_sanitize_hwaddress] = ACTIONS(535),
    [anon_sym_sanitize_memtag] = ACTIONS(535),
    [anon_sym_speculative_load_hardening] = ACTIONS(535),
    [anon_sym_speculatable] = ACTIONS(535),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(535),
    [anon_sym_sspreq] = ACTIONS(535),
    [anon_sym_strictfp] = ACTIONS(535),
    [anon_sym_uwtable] = ACTIONS(535),
    [anon_sym_nocf_check] = ACTIONS(535),
    [anon_sym_shadowcallstack] = ACTIONS(535),
    [anon_sym_mustprogress] = ACTIONS(535),
    [anon_sym_vscale_range] = ACTIONS(535),
    [anon_sym_preallocated] = ACTIONS(535),
    [anon_sym_zeroext] = ACTIONS(535),
    [anon_sym_signext] = ACTIONS(535),
    [anon_sym_inreg] = ACTIONS(535),
    [anon_sym_byval] = ACTIONS(535),
    [anon_sym_byref] = ACTIONS(535),
    [anon_sym_inalloca] = ACTIONS(535),
    [anon_sym_sret] = ACTIONS(535),
    [anon_sym_elementtype] = ACTIONS(535),
    [anon_sym_noalias] = ACTIONS(535),
    [anon_sym_nocapture] = ACTIONS(535),
    [anon_sym_nest] = ACTIONS(535),
    [anon_sym_returned] = ACTIONS(535),
    [anon_sym_nonnull] = ACTIONS(535),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(535),
    [anon_sym_swiftself] = ACTIONS(535),
    [anon_sym_swiftasync] = ACTIONS(535),
    [anon_sym_swifterror] = ACTIONS(535),
    [anon_sym_immarg] = ACTIONS(535),
    [anon_sym_noundef] = ACTIONS(535),
    [anon_sym_unreachable] = ACTIONS(535),
    [anon_sym_ret] = ACTIONS(535),
    [anon_sym_br] = ACTIONS(535),
    [anon_sym_resume] = ACTIONS(535),
    [anon_sym_freeze] = ACTIONS(535),
    [anon_sym_indirectbr] = ACTIONS(535),
    [anon_sym_extractelement] = ACTIONS(535),
    [anon_sym_insertelement] = ACTIONS(535),
    [anon_sym_select] = ACTIONS(535),
    [anon_sym_shufflevector] = ACTIONS(535),
    [anon_sym_fneg] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(535),
    [anon_sym_invoke] = ACTIONS(535),
    [anon_sym_cleanupret] = ACTIONS(535),
    [anon_sym_catchret] = ACTIONS(535),
    [anon_sym_catchswitch] = ACTIONS(535),
    [anon_sym_catchpad] = ACTIONS(535),
    [anon_sym_cleanuppad] = ACTIONS(535),
    [anon_sym_callbr] = ACTIONS(535),
    [anon_sym_icmp] = ACTIONS(535),
    [anon_sym_fcmp] = ACTIONS(535),
    [anon_sym_va_arg] = ACTIONS(535),
    [anon_sym_phi] = ACTIONS(535),
    [anon_sym_landingpad] = ACTIONS(535),
    [anon_sym_tail] = ACTIONS(535),
    [anon_sym_musttail] = ACTIONS(535),
    [anon_sym_notail] = ACTIONS(535),
    [anon_sym_call] = ACTIONS(535),
    [anon_sym_alloca] = ACTIONS(535),
    [anon_sym_load] = ACTIONS(535),
    [anon_sym_store] = ACTIONS(535),
    [anon_sym_cmpxchg] = ACTIONS(535),
    [anon_sym_atomicrmw] = ACTIONS(535),
    [anon_sym_fence] = ACTIONS(535),
    [anon_sym_getelementptr] = ACTIONS(535),
    [anon_sym_extractvalue] = ACTIONS(535),
    [anon_sym_insertvalue] = ACTIONS(535),
    [anon_sym_catch] = ACTIONS(535),
    [anon_sym_filter] = ACTIONS(535),
    [anon_sym_mul] = ACTIONS(535),
    [anon_sym_urem] = ACTIONS(535),
    [anon_sym_srem] = ACTIONS(535),
    [anon_sym_shl] = ACTIONS(535),
    [anon_sym_udiv] = ACTIONS(535),
    [anon_sym_sdiv] = ACTIONS(535),
    [anon_sym_lshr] = ACTIONS(535),
    [anon_sym_ashr] = ACTIONS(535),
    [anon_sym_fmul] = ACTIONS(535),
    [anon_sym_fdiv] = ACTIONS(535),
    [anon_sym_frem] = ACTIONS(535),
    [anon_sym_xchg] = ACTIONS(535),
    [anon_sym_add] = ACTIONS(535),
    [anon_sym_sub] = ACTIONS(535),
    [anon_sym_and] = ACTIONS(535),
    [anon_sym_nand] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(535),
    [anon_sym_xor] = ACTIONS(535),
    [anon_sym_max] = ACTIONS(535),
    [anon_sym_min] = ACTIONS(535),
    [anon_sym_umax] = ACTIONS(535),
    [anon_sym_umin] = ACTIONS(535),
    [anon_sym_fadd] = ACTIONS(535),
    [anon_sym_fsub] = ACTIONS(535),
    [anon_sym_bitcast] = ACTIONS(535),
    [anon_sym_trunc] = ACTIONS(535),
    [anon_sym_zext] = ACTIONS(535),
    [anon_sym_sext] = ACTIONS(535),
    [anon_sym_fptrunc] = ACTIONS(535),
    [anon_sym_fpext] = ACTIONS(535),
    [anon_sym_addrspacecast] = ACTIONS(535),
    [anon_sym_uitofp] = ACTIONS(535),
    [anon_sym_sitofp] = ACTIONS(535),
    [anon_sym_fptoui] = ACTIONS(535),
    [anon_sym_fptosi] = ACTIONS(535),
    [anon_sym_inttoptr] = ACTIONS(535),
    [anon_sym_ptrtoint] = ACTIONS(535),
    [anon_sym_unordered] = ACTIONS(535),
    [anon_sym_monotonic] = ACTIONS(535),
    [anon_sym_acquire] = ACTIONS(535),
    [anon_sym_release] = ACTIONS(535),
    [anon_sym_acq_rel] = ACTIONS(535),
    [anon_sym_seq_cst] = ACTIONS(535),
    [anon_sym_syncscope] = ACTIONS(535),
    [anon_sym_uselistorder] = ACTIONS(535),
  },
  [134] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [sym_label] = ACTIONS(595),
    [sym_string] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_section] = ACTIONS(597),
    [anon_sym_partition] = ACTIONS(597),
    [anon_sym_comdat] = ACTIONS(597),
    [anon_sym_gc] = ACTIONS(597),
    [anon_sym_prefix] = ACTIONS(597),
    [anon_sym_prologue] = ACTIONS(597),
    [anon_sym_personality] = ACTIONS(597),
    [anon_sym_alignstack] = ACTIONS(597),
    [anon_sym_allocsize] = ACTIONS(597),
    [anon_sym_alwaysinline] = ACTIONS(597),
    [anon_sym_builtin] = ACTIONS(597),
    [anon_sym_cold] = ACTIONS(597),
    [anon_sym_convergent] = ACTIONS(597),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(597),
    [anon_sym_hot] = ACTIONS(597),
    [anon_sym_inaccessiblememonly] = ACTIONS(597),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(597),
    [anon_sym_inlinehint] = ACTIONS(597),
    [anon_sym_jumptable] = ACTIONS(597),
    [anon_sym_minsize] = ACTIONS(597),
    [anon_sym_naked] = ACTIONS(597),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(597),
    [anon_sym_nobuiltin] = ACTIONS(597),
    [anon_sym_noduplicate] = ACTIONS(597),
    [anon_sym_nofree] = ACTIONS(597),
    [anon_sym_noimplicitfloat] = ACTIONS(597),
    [anon_sym_noinline] = ACTIONS(597),
    [anon_sym_nomerge] = ACTIONS(597),
    [anon_sym_nonlazybind] = ACTIONS(597),
    [anon_sym_noprofile] = ACTIONS(597),
    [anon_sym_noredzone] = ACTIONS(597),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(597),
    [anon_sym_noreturn] = ACTIONS(597),
    [anon_sym_norecurse] = ACTIONS(597),
    [anon_sym_willreturn] = ACTIONS(597),
    [anon_sym_nosync] = ACTIONS(597),
    [anon_sym_nounwind] = ACTIONS(597),
    [anon_sym_nosanitize_coverage] = ACTIONS(597),
    [anon_sym_null_pointer_is_valid] = ACTIONS(597),
    [anon_sym_optforfuzzing] = ACTIONS(597),
    [anon_sym_optnone] = ACTIONS(597),
    [anon_sym_optsize] = ACTIONS(597),
    [anon_sym_readnone] = ACTIONS(597),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_writeonly] = ACTIONS(597),
    [anon_sym_argmemonly] = ACTIONS(597),
    [anon_sym_returns_twice] = ACTIONS(597),
    [anon_sym_safestack] = ACTIONS(597),
    [anon_sym_sanitize_address] = ACTIONS(597),
    [anon_sym_sanitize_memory] = ACTIONS(597),
    [anon_sym_sanitize_thread] = ACTIONS(597),
    [anon_sym_sanitize_hwaddress] = ACTIONS(597),
    [anon_sym_sanitize_memtag] = ACTIONS(597),
    [anon_sym_speculative_load_hardening] = ACTIONS(597),
    [anon_sym_speculatable] = ACTIONS(597),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(597),
    [anon_sym_sspreq] = ACTIONS(597),
    [anon_sym_strictfp] = ACTIONS(597),
    [anon_sym_uwtable] = ACTIONS(597),
    [anon_sym_nocf_check] = ACTIONS(597),
    [anon_sym_shadowcallstack] = ACTIONS(597),
    [anon_sym_mustprogress] = ACTIONS(597),
    [anon_sym_vscale_range] = ACTIONS(597),
    [anon_sym_preallocated] = ACTIONS(597),
    [anon_sym_zeroext] = ACTIONS(597),
    [anon_sym_signext] = ACTIONS(597),
    [anon_sym_inreg] = ACTIONS(597),
    [anon_sym_byval] = ACTIONS(597),
    [anon_sym_byref] = ACTIONS(597),
    [anon_sym_inalloca] = ACTIONS(597),
    [anon_sym_sret] = ACTIONS(597),
    [anon_sym_elementtype] = ACTIONS(597),
    [anon_sym_noalias] = ACTIONS(597),
    [anon_sym_nocapture] = ACTIONS(597),
    [anon_sym_nest] = ACTIONS(597),
    [anon_sym_returned] = ACTIONS(597),
    [anon_sym_nonnull] = ACTIONS(597),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(597),
    [anon_sym_swiftself] = ACTIONS(597),
    [anon_sym_swiftasync] = ACTIONS(597),
    [anon_sym_swifterror] = ACTIONS(597),
    [anon_sym_immarg] = ACTIONS(597),
    [anon_sym_noundef] = ACTIONS(597),
    [anon_sym_unreachable] = ACTIONS(597),
    [anon_sym_ret] = ACTIONS(597),
    [anon_sym_br] = ACTIONS(597),
    [anon_sym_resume] = ACTIONS(597),
    [anon_sym_freeze] = ACTIONS(597),
    [anon_sym_indirectbr] = ACTIONS(597),
    [anon_sym_extractelement] = ACTIONS(597),
    [anon_sym_insertelement] = ACTIONS(597),
    [anon_sym_select] = ACTIONS(597),
    [anon_sym_shufflevector] = ACTIONS(597),
    [anon_sym_fneg] = ACTIONS(597),
    [anon_sym_switch] = ACTIONS(597),
    [anon_sym_invoke] = ACTIONS(597),
    [anon_sym_cleanupret] = ACTIONS(597),
    [anon_sym_catchret] = ACTIONS(597),
    [anon_sym_catchswitch] = ACTIONS(597),
    [anon_sym_catchpad] = ACTIONS(597),
    [anon_sym_cleanuppad] = ACTIONS(597),
    [anon_sym_callbr] = ACTIONS(597),
    [anon_sym_icmp] = ACTIONS(597),
    [anon_sym_fcmp] = ACTIONS(597),
    [anon_sym_va_arg] = ACTIONS(597),
    [anon_sym_phi] = ACTIONS(597),
    [anon_sym_landingpad] = ACTIONS(597),
    [anon_sym_tail] = ACTIONS(597),
    [anon_sym_musttail] = ACTIONS(597),
    [anon_sym_notail] = ACTIONS(597),
    [anon_sym_call] = ACTIONS(597),
    [anon_sym_alloca] = ACTIONS(597),
    [anon_sym_load] = ACTIONS(597),
    [anon_sym_store] = ACTIONS(597),
    [anon_sym_cmpxchg] = ACTIONS(597),
    [anon_sym_atomicrmw] = ACTIONS(597),
    [anon_sym_fence] = ACTIONS(597),
    [anon_sym_getelementptr] = ACTIONS(597),
    [anon_sym_extractvalue] = ACTIONS(597),
    [anon_sym_insertvalue] = ACTIONS(597),
    [anon_sym_catch] = ACTIONS(597),
    [anon_sym_filter] = ACTIONS(597),
    [anon_sym_mul] = ACTIONS(597),
    [anon_sym_urem] = ACTIONS(597),
    [anon_sym_srem] = ACTIONS(597),
    [anon_sym_shl] = ACTIONS(597),
    [anon_sym_udiv] = ACTIONS(597),
    [anon_sym_sdiv] = ACTIONS(597),
    [anon_sym_lshr] = ACTIONS(597),
    [anon_sym_ashr] = ACTIONS(597),
    [anon_sym_fmul] = ACTIONS(597),
    [anon_sym_fdiv] = ACTIONS(597),
    [anon_sym_frem] = ACTIONS(597),
    [anon_sym_xchg] = ACTIONS(597),
    [anon_sym_add] = ACTIONS(597),
    [anon_sym_sub] = ACTIONS(597),
    [anon_sym_and] = ACTIONS(597),
    [anon_sym_nand] = ACTIONS(597),
    [anon_sym_or] = ACTIONS(597),
    [anon_sym_xor] = ACTIONS(597),
    [anon_sym_max] = ACTIONS(597),
    [anon_sym_min] = ACTIONS(597),
    [anon_sym_umax] = ACTIONS(597),
    [anon_sym_umin] = ACTIONS(597),
    [anon_sym_fadd] = ACTIONS(597),
    [anon_sym_fsub] = ACTIONS(597),
    [anon_sym_bitcast] = ACTIONS(597),
    [anon_sym_trunc] = ACTIONS(597),
    [anon_sym_zext] = ACTIONS(597),
    [anon_sym_sext] = ACTIONS(597),
    [anon_sym_fptrunc] = ACTIONS(597),
    [anon_sym_fpext] = ACTIONS(597),
    [anon_sym_addrspacecast] = ACTIONS(597),
    [anon_sym_uitofp] = ACTIONS(597),
    [anon_sym_sitofp] = ACTIONS(597),
    [anon_sym_fptoui] = ACTIONS(597),
    [anon_sym_fptosi] = ACTIONS(597),
    [anon_sym_inttoptr] = ACTIONS(597),
    [anon_sym_ptrtoint] = ACTIONS(597),
    [anon_sym_unordered] = ACTIONS(597),
    [anon_sym_monotonic] = ACTIONS(597),
    [anon_sym_acquire] = ACTIONS(597),
    [anon_sym_release] = ACTIONS(597),
    [anon_sym_acq_rel] = ACTIONS(597),
    [anon_sym_seq_cst] = ACTIONS(597),
    [anon_sym_syncscope] = ACTIONS(597),
    [anon_sym_uselistorder] = ACTIONS(597),
  },
  [135] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [sym_label] = ACTIONS(659),
    [sym_string] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_section] = ACTIONS(661),
    [anon_sym_partition] = ACTIONS(661),
    [anon_sym_comdat] = ACTIONS(661),
    [anon_sym_gc] = ACTIONS(661),
    [anon_sym_prefix] = ACTIONS(661),
    [anon_sym_prologue] = ACTIONS(661),
    [anon_sym_personality] = ACTIONS(661),
    [anon_sym_alignstack] = ACTIONS(661),
    [anon_sym_allocsize] = ACTIONS(661),
    [anon_sym_alwaysinline] = ACTIONS(661),
    [anon_sym_builtin] = ACTIONS(661),
    [anon_sym_cold] = ACTIONS(661),
    [anon_sym_convergent] = ACTIONS(661),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(661),
    [anon_sym_hot] = ACTIONS(661),
    [anon_sym_inaccessiblememonly] = ACTIONS(661),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(661),
    [anon_sym_inlinehint] = ACTIONS(661),
    [anon_sym_jumptable] = ACTIONS(661),
    [anon_sym_minsize] = ACTIONS(661),
    [anon_sym_naked] = ACTIONS(661),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(661),
    [anon_sym_nobuiltin] = ACTIONS(661),
    [anon_sym_noduplicate] = ACTIONS(661),
    [anon_sym_nofree] = ACTIONS(661),
    [anon_sym_noimplicitfloat] = ACTIONS(661),
    [anon_sym_noinline] = ACTIONS(661),
    [anon_sym_nomerge] = ACTIONS(661),
    [anon_sym_nonlazybind] = ACTIONS(661),
    [anon_sym_noprofile] = ACTIONS(661),
    [anon_sym_noredzone] = ACTIONS(661),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(661),
    [anon_sym_noreturn] = ACTIONS(661),
    [anon_sym_norecurse] = ACTIONS(661),
    [anon_sym_willreturn] = ACTIONS(661),
    [anon_sym_nosync] = ACTIONS(661),
    [anon_sym_nounwind] = ACTIONS(661),
    [anon_sym_nosanitize_coverage] = ACTIONS(661),
    [anon_sym_null_pointer_is_valid] = ACTIONS(661),
    [anon_sym_optforfuzzing] = ACTIONS(661),
    [anon_sym_optnone] = ACTIONS(661),
    [anon_sym_optsize] = ACTIONS(661),
    [anon_sym_readnone] = ACTIONS(661),
    [anon_sym_readonly] = ACTIONS(661),
    [anon_sym_writeonly] = ACTIONS(661),
    [anon_sym_argmemonly] = ACTIONS(661),
    [anon_sym_returns_twice] = ACTIONS(661),
    [anon_sym_safestack] = ACTIONS(661),
    [anon_sym_sanitize_address] = ACTIONS(661),
    [anon_sym_sanitize_memory] = ACTIONS(661),
    [anon_sym_sanitize_thread] = ACTIONS(661),
    [anon_sym_sanitize_hwaddress] = ACTIONS(661),
    [anon_sym_sanitize_memtag] = ACTIONS(661),
    [anon_sym_speculative_load_hardening] = ACTIONS(661),
    [anon_sym_speculatable] = ACTIONS(661),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(661),
    [anon_sym_sspreq] = ACTIONS(661),
    [anon_sym_strictfp] = ACTIONS(661),
    [anon_sym_uwtable] = ACTIONS(661),
    [anon_sym_nocf_check] = ACTIONS(661),
    [anon_sym_shadowcallstack] = ACTIONS(661),
    [anon_sym_mustprogress] = ACTIONS(661),
    [anon_sym_vscale_range] = ACTIONS(661),
    [anon_sym_preallocated] = ACTIONS(661),
    [anon_sym_zeroext] = ACTIONS(661),
    [anon_sym_signext] = ACTIONS(661),
    [anon_sym_inreg] = ACTIONS(661),
    [anon_sym_byval] = ACTIONS(661),
    [anon_sym_byref] = ACTIONS(661),
    [anon_sym_inalloca] = ACTIONS(661),
    [anon_sym_sret] = ACTIONS(661),
    [anon_sym_elementtype] = ACTIONS(661),
    [anon_sym_noalias] = ACTIONS(661),
    [anon_sym_nocapture] = ACTIONS(661),
    [anon_sym_nest] = ACTIONS(661),
    [anon_sym_returned] = ACTIONS(661),
    [anon_sym_nonnull] = ACTIONS(661),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(661),
    [anon_sym_swiftself] = ACTIONS(661),
    [anon_sym_swiftasync] = ACTIONS(661),
    [anon_sym_swifterror] = ACTIONS(661),
    [anon_sym_immarg] = ACTIONS(661),
    [anon_sym_noundef] = ACTIONS(661),
    [anon_sym_unreachable] = ACTIONS(661),
    [anon_sym_ret] = ACTIONS(661),
    [anon_sym_br] = ACTIONS(661),
    [anon_sym_resume] = ACTIONS(661),
    [anon_sym_freeze] = ACTIONS(661),
    [anon_sym_indirectbr] = ACTIONS(661),
    [anon_sym_extractelement] = ACTIONS(661),
    [anon_sym_insertelement] = ACTIONS(661),
    [anon_sym_select] = ACTIONS(661),
    [anon_sym_shufflevector] = ACTIONS(661),
    [anon_sym_fneg] = ACTIONS(661),
    [anon_sym_switch] = ACTIONS(661),
    [anon_sym_invoke] = ACTIONS(661),
    [anon_sym_cleanupret] = ACTIONS(661),
    [anon_sym_catchret] = ACTIONS(661),
    [anon_sym_catchswitch] = ACTIONS(661),
    [anon_sym_catchpad] = ACTIONS(661),
    [anon_sym_cleanuppad] = ACTIONS(661),
    [anon_sym_callbr] = ACTIONS(661),
    [anon_sym_icmp] = ACTIONS(661),
    [anon_sym_fcmp] = ACTIONS(661),
    [anon_sym_va_arg] = ACTIONS(661),
    [anon_sym_phi] = ACTIONS(661),
    [anon_sym_landingpad] = ACTIONS(661),
    [anon_sym_tail] = ACTIONS(661),
    [anon_sym_musttail] = ACTIONS(661),
    [anon_sym_notail] = ACTIONS(661),
    [anon_sym_call] = ACTIONS(661),
    [anon_sym_alloca] = ACTIONS(661),
    [anon_sym_load] = ACTIONS(661),
    [anon_sym_store] = ACTIONS(661),
    [anon_sym_cmpxchg] = ACTIONS(661),
    [anon_sym_atomicrmw] = ACTIONS(661),
    [anon_sym_fence] = ACTIONS(661),
    [anon_sym_getelementptr] = ACTIONS(661),
    [anon_sym_extractvalue] = ACTIONS(661),
    [anon_sym_insertvalue] = ACTIONS(661),
    [anon_sym_catch] = ACTIONS(661),
    [anon_sym_filter] = ACTIONS(661),
    [anon_sym_mul] = ACTIONS(661),
    [anon_sym_urem] = ACTIONS(661),
    [anon_sym_srem] = ACTIONS(661),
    [anon_sym_shl] = ACTIONS(661),
    [anon_sym_udiv] = ACTIONS(661),
    [anon_sym_sdiv] = ACTIONS(661),
    [anon_sym_lshr] = ACTIONS(661),
    [anon_sym_ashr] = ACTIONS(661),
    [anon_sym_fmul] = ACTIONS(661),
    [anon_sym_fdiv] = ACTIONS(661),
    [anon_sym_frem] = ACTIONS(661),
    [anon_sym_xchg] = ACTIONS(661),
    [anon_sym_add] = ACTIONS(661),
    [anon_sym_sub] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_nand] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(661),
    [anon_sym_xor] = ACTIONS(661),
    [anon_sym_max] = ACTIONS(661),
    [anon_sym_min] = ACTIONS(661),
    [anon_sym_umax] = ACTIONS(661),
    [anon_sym_umin] = ACTIONS(661),
    [anon_sym_fadd] = ACTIONS(661),
    [anon_sym_fsub] = ACTIONS(661),
    [anon_sym_bitcast] = ACTIONS(661),
    [anon_sym_trunc] = ACTIONS(661),
    [anon_sym_zext] = ACTIONS(661),
    [anon_sym_sext] = ACTIONS(661),
    [anon_sym_fptrunc] = ACTIONS(661),
    [anon_sym_fpext] = ACTIONS(661),
    [anon_sym_addrspacecast] = ACTIONS(661),
    [anon_sym_uitofp] = ACTIONS(661),
    [anon_sym_sitofp] = ACTIONS(661),
    [anon_sym_fptoui] = ACTIONS(661),
    [anon_sym_fptosi] = ACTIONS(661),
    [anon_sym_inttoptr] = ACTIONS(661),
    [anon_sym_ptrtoint] = ACTIONS(661),
    [anon_sym_unordered] = ACTIONS(661),
    [anon_sym_monotonic] = ACTIONS(661),
    [anon_sym_acquire] = ACTIONS(661),
    [anon_sym_release] = ACTIONS(661),
    [anon_sym_acq_rel] = ACTIONS(661),
    [anon_sym_seq_cst] = ACTIONS(661),
    [anon_sym_syncscope] = ACTIONS(661),
    [anon_sym_uselistorder] = ACTIONS(661),
  },
  [136] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [sym_label] = ACTIONS(655),
    [sym_string] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_section] = ACTIONS(657),
    [anon_sym_partition] = ACTIONS(657),
    [anon_sym_comdat] = ACTIONS(657),
    [anon_sym_gc] = ACTIONS(657),
    [anon_sym_prefix] = ACTIONS(657),
    [anon_sym_prologue] = ACTIONS(657),
    [anon_sym_personality] = ACTIONS(657),
    [anon_sym_alignstack] = ACTIONS(657),
    [anon_sym_allocsize] = ACTIONS(657),
    [anon_sym_alwaysinline] = ACTIONS(657),
    [anon_sym_builtin] = ACTIONS(657),
    [anon_sym_cold] = ACTIONS(657),
    [anon_sym_convergent] = ACTIONS(657),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(657),
    [anon_sym_hot] = ACTIONS(657),
    [anon_sym_inaccessiblememonly] = ACTIONS(657),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(657),
    [anon_sym_inlinehint] = ACTIONS(657),
    [anon_sym_jumptable] = ACTIONS(657),
    [anon_sym_minsize] = ACTIONS(657),
    [anon_sym_naked] = ACTIONS(657),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(657),
    [anon_sym_nobuiltin] = ACTIONS(657),
    [anon_sym_noduplicate] = ACTIONS(657),
    [anon_sym_nofree] = ACTIONS(657),
    [anon_sym_noimplicitfloat] = ACTIONS(657),
    [anon_sym_noinline] = ACTIONS(657),
    [anon_sym_nomerge] = ACTIONS(657),
    [anon_sym_nonlazybind] = ACTIONS(657),
    [anon_sym_noprofile] = ACTIONS(657),
    [anon_sym_noredzone] = ACTIONS(657),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(657),
    [anon_sym_noreturn] = ACTIONS(657),
    [anon_sym_norecurse] = ACTIONS(657),
    [anon_sym_willreturn] = ACTIONS(657),
    [anon_sym_nosync] = ACTIONS(657),
    [anon_sym_nounwind] = ACTIONS(657),
    [anon_sym_nosanitize_coverage] = ACTIONS(657),
    [anon_sym_null_pointer_is_valid] = ACTIONS(657),
    [anon_sym_optforfuzzing] = ACTIONS(657),
    [anon_sym_optnone] = ACTIONS(657),
    [anon_sym_optsize] = ACTIONS(657),
    [anon_sym_readnone] = ACTIONS(657),
    [anon_sym_readonly] = ACTIONS(657),
    [anon_sym_writeonly] = ACTIONS(657),
    [anon_sym_argmemonly] = ACTIONS(657),
    [anon_sym_returns_twice] = ACTIONS(657),
    [anon_sym_safestack] = ACTIONS(657),
    [anon_sym_sanitize_address] = ACTIONS(657),
    [anon_sym_sanitize_memory] = ACTIONS(657),
    [anon_sym_sanitize_thread] = ACTIONS(657),
    [anon_sym_sanitize_hwaddress] = ACTIONS(657),
    [anon_sym_sanitize_memtag] = ACTIONS(657),
    [anon_sym_speculative_load_hardening] = ACTIONS(657),
    [anon_sym_speculatable] = ACTIONS(657),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(657),
    [anon_sym_sspreq] = ACTIONS(657),
    [anon_sym_strictfp] = ACTIONS(657),
    [anon_sym_uwtable] = ACTIONS(657),
    [anon_sym_nocf_check] = ACTIONS(657),
    [anon_sym_shadowcallstack] = ACTIONS(657),
    [anon_sym_mustprogress] = ACTIONS(657),
    [anon_sym_vscale_range] = ACTIONS(657),
    [anon_sym_preallocated] = ACTIONS(657),
    [anon_sym_zeroext] = ACTIONS(657),
    [anon_sym_signext] = ACTIONS(657),
    [anon_sym_inreg] = ACTIONS(657),
    [anon_sym_byval] = ACTIONS(657),
    [anon_sym_byref] = ACTIONS(657),
    [anon_sym_inalloca] = ACTIONS(657),
    [anon_sym_sret] = ACTIONS(657),
    [anon_sym_elementtype] = ACTIONS(657),
    [anon_sym_noalias] = ACTIONS(657),
    [anon_sym_nocapture] = ACTIONS(657),
    [anon_sym_nest] = ACTIONS(657),
    [anon_sym_returned] = ACTIONS(657),
    [anon_sym_nonnull] = ACTIONS(657),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(657),
    [anon_sym_swiftself] = ACTIONS(657),
    [anon_sym_swiftasync] = ACTIONS(657),
    [anon_sym_swifterror] = ACTIONS(657),
    [anon_sym_immarg] = ACTIONS(657),
    [anon_sym_noundef] = ACTIONS(657),
    [anon_sym_unreachable] = ACTIONS(657),
    [anon_sym_ret] = ACTIONS(657),
    [anon_sym_br] = ACTIONS(657),
    [anon_sym_resume] = ACTIONS(657),
    [anon_sym_freeze] = ACTIONS(657),
    [anon_sym_indirectbr] = ACTIONS(657),
    [anon_sym_extractelement] = ACTIONS(657),
    [anon_sym_insertelement] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_shufflevector] = ACTIONS(657),
    [anon_sym_fneg] = ACTIONS(657),
    [anon_sym_switch] = ACTIONS(657),
    [anon_sym_invoke] = ACTIONS(657),
    [anon_sym_cleanupret] = ACTIONS(657),
    [anon_sym_catchret] = ACTIONS(657),
    [anon_sym_catchswitch] = ACTIONS(657),
    [anon_sym_catchpad] = ACTIONS(657),
    [anon_sym_cleanuppad] = ACTIONS(657),
    [anon_sym_callbr] = ACTIONS(657),
    [anon_sym_icmp] = ACTIONS(657),
    [anon_sym_fcmp] = ACTIONS(657),
    [anon_sym_va_arg] = ACTIONS(657),
    [anon_sym_phi] = ACTIONS(657),
    [anon_sym_landingpad] = ACTIONS(657),
    [anon_sym_tail] = ACTIONS(657),
    [anon_sym_musttail] = ACTIONS(657),
    [anon_sym_notail] = ACTIONS(657),
    [anon_sym_call] = ACTIONS(657),
    [anon_sym_alloca] = ACTIONS(657),
    [anon_sym_load] = ACTIONS(657),
    [anon_sym_store] = ACTIONS(657),
    [anon_sym_cmpxchg] = ACTIONS(657),
    [anon_sym_atomicrmw] = ACTIONS(657),
    [anon_sym_fence] = ACTIONS(657),
    [anon_sym_getelementptr] = ACTIONS(657),
    [anon_sym_extractvalue] = ACTIONS(657),
    [anon_sym_insertvalue] = ACTIONS(657),
    [anon_sym_catch] = ACTIONS(657),
    [anon_sym_filter] = ACTIONS(657),
    [anon_sym_mul] = ACTIONS(657),
    [anon_sym_urem] = ACTIONS(657),
    [anon_sym_srem] = ACTIONS(657),
    [anon_sym_shl] = ACTIONS(657),
    [anon_sym_udiv] = ACTIONS(657),
    [anon_sym_sdiv] = ACTIONS(657),
    [anon_sym_lshr] = ACTIONS(657),
    [anon_sym_ashr] = ACTIONS(657),
    [anon_sym_fmul] = ACTIONS(657),
    [anon_sym_fdiv] = ACTIONS(657),
    [anon_sym_frem] = ACTIONS(657),
    [anon_sym_xchg] = ACTIONS(657),
    [anon_sym_add] = ACTIONS(657),
    [anon_sym_sub] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_nand] = ACTIONS(657),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_xor] = ACTIONS(657),
    [anon_sym_max] = ACTIONS(657),
    [anon_sym_min] = ACTIONS(657),
    [anon_sym_umax] = ACTIONS(657),
    [anon_sym_umin] = ACTIONS(657),
    [anon_sym_fadd] = ACTIONS(657),
    [anon_sym_fsub] = ACTIONS(657),
    [anon_sym_bitcast] = ACTIONS(657),
    [anon_sym_trunc] = ACTIONS(657),
    [anon_sym_zext] = ACTIONS(657),
    [anon_sym_sext] = ACTIONS(657),
    [anon_sym_fptrunc] = ACTIONS(657),
    [anon_sym_fpext] = ACTIONS(657),
    [anon_sym_addrspacecast] = ACTIONS(657),
    [anon_sym_uitofp] = ACTIONS(657),
    [anon_sym_sitofp] = ACTIONS(657),
    [anon_sym_fptoui] = ACTIONS(657),
    [anon_sym_fptosi] = ACTIONS(657),
    [anon_sym_inttoptr] = ACTIONS(657),
    [anon_sym_ptrtoint] = ACTIONS(657),
    [anon_sym_unordered] = ACTIONS(657),
    [anon_sym_monotonic] = ACTIONS(657),
    [anon_sym_acquire] = ACTIONS(657),
    [anon_sym_release] = ACTIONS(657),
    [anon_sym_acq_rel] = ACTIONS(657),
    [anon_sym_seq_cst] = ACTIONS(657),
    [anon_sym_syncscope] = ACTIONS(657),
    [anon_sym_uselistorder] = ACTIONS(657),
  },
  [137] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [sym_label] = ACTIONS(663),
    [sym_string] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_section] = ACTIONS(665),
    [anon_sym_partition] = ACTIONS(665),
    [anon_sym_comdat] = ACTIONS(665),
    [anon_sym_gc] = ACTIONS(665),
    [anon_sym_prefix] = ACTIONS(665),
    [anon_sym_prologue] = ACTIONS(665),
    [anon_sym_personality] = ACTIONS(665),
    [anon_sym_alignstack] = ACTIONS(665),
    [anon_sym_allocsize] = ACTIONS(665),
    [anon_sym_alwaysinline] = ACTIONS(665),
    [anon_sym_builtin] = ACTIONS(665),
    [anon_sym_cold] = ACTIONS(665),
    [anon_sym_convergent] = ACTIONS(665),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(665),
    [anon_sym_hot] = ACTIONS(665),
    [anon_sym_inaccessiblememonly] = ACTIONS(665),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(665),
    [anon_sym_inlinehint] = ACTIONS(665),
    [anon_sym_jumptable] = ACTIONS(665),
    [anon_sym_minsize] = ACTIONS(665),
    [anon_sym_naked] = ACTIONS(665),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(665),
    [anon_sym_nobuiltin] = ACTIONS(665),
    [anon_sym_noduplicate] = ACTIONS(665),
    [anon_sym_nofree] = ACTIONS(665),
    [anon_sym_noimplicitfloat] = ACTIONS(665),
    [anon_sym_noinline] = ACTIONS(665),
    [anon_sym_nomerge] = ACTIONS(665),
    [anon_sym_nonlazybind] = ACTIONS(665),
    [anon_sym_noprofile] = ACTIONS(665),
    [anon_sym_noredzone] = ACTIONS(665),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(665),
    [anon_sym_noreturn] = ACTIONS(665),
    [anon_sym_norecurse] = ACTIONS(665),
    [anon_sym_willreturn] = ACTIONS(665),
    [anon_sym_nosync] = ACTIONS(665),
    [anon_sym_nounwind] = ACTIONS(665),
    [anon_sym_nosanitize_coverage] = ACTIONS(665),
    [anon_sym_null_pointer_is_valid] = ACTIONS(665),
    [anon_sym_optforfuzzing] = ACTIONS(665),
    [anon_sym_optnone] = ACTIONS(665),
    [anon_sym_optsize] = ACTIONS(665),
    [anon_sym_readnone] = ACTIONS(665),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_writeonly] = ACTIONS(665),
    [anon_sym_argmemonly] = ACTIONS(665),
    [anon_sym_returns_twice] = ACTIONS(665),
    [anon_sym_safestack] = ACTIONS(665),
    [anon_sym_sanitize_address] = ACTIONS(665),
    [anon_sym_sanitize_memory] = ACTIONS(665),
    [anon_sym_sanitize_thread] = ACTIONS(665),
    [anon_sym_sanitize_hwaddress] = ACTIONS(665),
    [anon_sym_sanitize_memtag] = ACTIONS(665),
    [anon_sym_speculative_load_hardening] = ACTIONS(665),
    [anon_sym_speculatable] = ACTIONS(665),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(665),
    [anon_sym_sspreq] = ACTIONS(665),
    [anon_sym_strictfp] = ACTIONS(665),
    [anon_sym_uwtable] = ACTIONS(665),
    [anon_sym_nocf_check] = ACTIONS(665),
    [anon_sym_shadowcallstack] = ACTIONS(665),
    [anon_sym_mustprogress] = ACTIONS(665),
    [anon_sym_vscale_range] = ACTIONS(665),
    [anon_sym_preallocated] = ACTIONS(665),
    [anon_sym_zeroext] = ACTIONS(665),
    [anon_sym_signext] = ACTIONS(665),
    [anon_sym_inreg] = ACTIONS(665),
    [anon_sym_byval] = ACTIONS(665),
    [anon_sym_byref] = ACTIONS(665),
    [anon_sym_inalloca] = ACTIONS(665),
    [anon_sym_sret] = ACTIONS(665),
    [anon_sym_elementtype] = ACTIONS(665),
    [anon_sym_noalias] = ACTIONS(665),
    [anon_sym_nocapture] = ACTIONS(665),
    [anon_sym_nest] = ACTIONS(665),
    [anon_sym_returned] = ACTIONS(665),
    [anon_sym_nonnull] = ACTIONS(665),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(665),
    [anon_sym_swiftself] = ACTIONS(665),
    [anon_sym_swiftasync] = ACTIONS(665),
    [anon_sym_swifterror] = ACTIONS(665),
    [anon_sym_immarg] = ACTIONS(665),
    [anon_sym_noundef] = ACTIONS(665),
    [anon_sym_unreachable] = ACTIONS(665),
    [anon_sym_ret] = ACTIONS(665),
    [anon_sym_br] = ACTIONS(665),
    [anon_sym_resume] = ACTIONS(665),
    [anon_sym_freeze] = ACTIONS(665),
    [anon_sym_indirectbr] = ACTIONS(665),
    [anon_sym_extractelement] = ACTIONS(665),
    [anon_sym_insertelement] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_shufflevector] = ACTIONS(665),
    [anon_sym_fneg] = ACTIONS(665),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_invoke] = ACTIONS(665),
    [anon_sym_cleanupret] = ACTIONS(665),
    [anon_sym_catchret] = ACTIONS(665),
    [anon_sym_catchswitch] = ACTIONS(665),
    [anon_sym_catchpad] = ACTIONS(665),
    [anon_sym_cleanuppad] = ACTIONS(665),
    [anon_sym_callbr] = ACTIONS(665),
    [anon_sym_icmp] = ACTIONS(665),
    [anon_sym_fcmp] = ACTIONS(665),
    [anon_sym_va_arg] = ACTIONS(665),
    [anon_sym_phi] = ACTIONS(665),
    [anon_sym_landingpad] = ACTIONS(665),
    [anon_sym_tail] = ACTIONS(665),
    [anon_sym_musttail] = ACTIONS(665),
    [anon_sym_notail] = ACTIONS(665),
    [anon_sym_call] = ACTIONS(665),
    [anon_sym_alloca] = ACTIONS(665),
    [anon_sym_load] = ACTIONS(665),
    [anon_sym_store] = ACTIONS(665),
    [anon_sym_cmpxchg] = ACTIONS(665),
    [anon_sym_atomicrmw] = ACTIONS(665),
    [anon_sym_fence] = ACTIONS(665),
    [anon_sym_getelementptr] = ACTIONS(665),
    [anon_sym_extractvalue] = ACTIONS(665),
    [anon_sym_insertvalue] = ACTIONS(665),
    [anon_sym_catch] = ACTIONS(665),
    [anon_sym_filter] = ACTIONS(665),
    [anon_sym_mul] = ACTIONS(665),
    [anon_sym_urem] = ACTIONS(665),
    [anon_sym_srem] = ACTIONS(665),
    [anon_sym_shl] = ACTIONS(665),
    [anon_sym_udiv] = ACTIONS(665),
    [anon_sym_sdiv] = ACTIONS(665),
    [anon_sym_lshr] = ACTIONS(665),
    [anon_sym_ashr] = ACTIONS(665),
    [anon_sym_fmul] = ACTIONS(665),
    [anon_sym_fdiv] = ACTIONS(665),
    [anon_sym_frem] = ACTIONS(665),
    [anon_sym_xchg] = ACTIONS(665),
    [anon_sym_add] = ACTIONS(665),
    [anon_sym_sub] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_nand] = ACTIONS(665),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_xor] = ACTIONS(665),
    [anon_sym_max] = ACTIONS(665),
    [anon_sym_min] = ACTIONS(665),
    [anon_sym_umax] = ACTIONS(665),
    [anon_sym_umin] = ACTIONS(665),
    [anon_sym_fadd] = ACTIONS(665),
    [anon_sym_fsub] = ACTIONS(665),
    [anon_sym_bitcast] = ACTIONS(665),
    [anon_sym_trunc] = ACTIONS(665),
    [anon_sym_zext] = ACTIONS(665),
    [anon_sym_sext] = ACTIONS(665),
    [anon_sym_fptrunc] = ACTIONS(665),
    [anon_sym_fpext] = ACTIONS(665),
    [anon_sym_addrspacecast] = ACTIONS(665),
    [anon_sym_uitofp] = ACTIONS(665),
    [anon_sym_sitofp] = ACTIONS(665),
    [anon_sym_fptoui] = ACTIONS(665),
    [anon_sym_fptosi] = ACTIONS(665),
    [anon_sym_inttoptr] = ACTIONS(665),
    [anon_sym_ptrtoint] = ACTIONS(665),
    [anon_sym_unordered] = ACTIONS(665),
    [anon_sym_monotonic] = ACTIONS(665),
    [anon_sym_acquire] = ACTIONS(665),
    [anon_sym_release] = ACTIONS(665),
    [anon_sym_acq_rel] = ACTIONS(665),
    [anon_sym_seq_cst] = ACTIONS(665),
    [anon_sym_syncscope] = ACTIONS(665),
    [anon_sym_uselistorder] = ACTIONS(665),
  },
  [138] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [sym_label] = ACTIONS(685),
    [sym_string] = ACTIONS(687),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_section] = ACTIONS(687),
    [anon_sym_partition] = ACTIONS(687),
    [anon_sym_comdat] = ACTIONS(687),
    [anon_sym_gc] = ACTIONS(687),
    [anon_sym_prefix] = ACTIONS(687),
    [anon_sym_prologue] = ACTIONS(687),
    [anon_sym_personality] = ACTIONS(687),
    [anon_sym_alignstack] = ACTIONS(687),
    [anon_sym_allocsize] = ACTIONS(687),
    [anon_sym_alwaysinline] = ACTIONS(687),
    [anon_sym_builtin] = ACTIONS(687),
    [anon_sym_cold] = ACTIONS(687),
    [anon_sym_convergent] = ACTIONS(687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(687),
    [anon_sym_hot] = ACTIONS(687),
    [anon_sym_inaccessiblememonly] = ACTIONS(687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(687),
    [anon_sym_inlinehint] = ACTIONS(687),
    [anon_sym_jumptable] = ACTIONS(687),
    [anon_sym_minsize] = ACTIONS(687),
    [anon_sym_naked] = ACTIONS(687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(687),
    [anon_sym_nobuiltin] = ACTIONS(687),
    [anon_sym_noduplicate] = ACTIONS(687),
    [anon_sym_nofree] = ACTIONS(687),
    [anon_sym_noimplicitfloat] = ACTIONS(687),
    [anon_sym_noinline] = ACTIONS(687),
    [anon_sym_nomerge] = ACTIONS(687),
    [anon_sym_nonlazybind] = ACTIONS(687),
    [anon_sym_noprofile] = ACTIONS(687),
    [anon_sym_noredzone] = ACTIONS(687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(687),
    [anon_sym_noreturn] = ACTIONS(687),
    [anon_sym_norecurse] = ACTIONS(687),
    [anon_sym_willreturn] = ACTIONS(687),
    [anon_sym_nosync] = ACTIONS(687),
    [anon_sym_nounwind] = ACTIONS(687),
    [anon_sym_nosanitize_coverage] = ACTIONS(687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(687),
    [anon_sym_optforfuzzing] = ACTIONS(687),
    [anon_sym_optnone] = ACTIONS(687),
    [anon_sym_optsize] = ACTIONS(687),
    [anon_sym_readnone] = ACTIONS(687),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_writeonly] = ACTIONS(687),
    [anon_sym_argmemonly] = ACTIONS(687),
    [anon_sym_returns_twice] = ACTIONS(687),
    [anon_sym_safestack] = ACTIONS(687),
    [anon_sym_sanitize_address] = ACTIONS(687),
    [anon_sym_sanitize_memory] = ACTIONS(687),
    [anon_sym_sanitize_thread] = ACTIONS(687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(687),
    [anon_sym_sanitize_memtag] = ACTIONS(687),
    [anon_sym_speculative_load_hardening] = ACTIONS(687),
    [anon_sym_speculatable] = ACTIONS(687),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(687),
    [anon_sym_sspreq] = ACTIONS(687),
    [anon_sym_strictfp] = ACTIONS(687),
    [anon_sym_uwtable] = ACTIONS(687),
    [anon_sym_nocf_check] = ACTIONS(687),
    [anon_sym_shadowcallstack] = ACTIONS(687),
    [anon_sym_mustprogress] = ACTIONS(687),
    [anon_sym_vscale_range] = ACTIONS(687),
    [anon_sym_preallocated] = ACTIONS(687),
    [anon_sym_zeroext] = ACTIONS(687),
    [anon_sym_signext] = ACTIONS(687),
    [anon_sym_inreg] = ACTIONS(687),
    [anon_sym_byval] = ACTIONS(687),
    [anon_sym_byref] = ACTIONS(687),
    [anon_sym_inalloca] = ACTIONS(687),
    [anon_sym_sret] = ACTIONS(687),
    [anon_sym_elementtype] = ACTIONS(687),
    [anon_sym_noalias] = ACTIONS(687),
    [anon_sym_nocapture] = ACTIONS(687),
    [anon_sym_nest] = ACTIONS(687),
    [anon_sym_returned] = ACTIONS(687),
    [anon_sym_nonnull] = ACTIONS(687),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(687),
    [anon_sym_swiftself] = ACTIONS(687),
    [anon_sym_swiftasync] = ACTIONS(687),
    [anon_sym_swifterror] = ACTIONS(687),
    [anon_sym_immarg] = ACTIONS(687),
    [anon_sym_noundef] = ACTIONS(687),
    [anon_sym_unreachable] = ACTIONS(687),
    [anon_sym_ret] = ACTIONS(687),
    [anon_sym_br] = ACTIONS(687),
    [anon_sym_resume] = ACTIONS(687),
    [anon_sym_freeze] = ACTIONS(687),
    [anon_sym_indirectbr] = ACTIONS(687),
    [anon_sym_extractelement] = ACTIONS(687),
    [anon_sym_insertelement] = ACTIONS(687),
    [anon_sym_select] = ACTIONS(687),
    [anon_sym_shufflevector] = ACTIONS(687),
    [anon_sym_fneg] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_invoke] = ACTIONS(687),
    [anon_sym_cleanupret] = ACTIONS(687),
    [anon_sym_catchret] = ACTIONS(687),
    [anon_sym_catchswitch] = ACTIONS(687),
    [anon_sym_catchpad] = ACTIONS(687),
    [anon_sym_cleanuppad] = ACTIONS(687),
    [anon_sym_callbr] = ACTIONS(687),
    [anon_sym_icmp] = ACTIONS(687),
    [anon_sym_fcmp] = ACTIONS(687),
    [anon_sym_va_arg] = ACTIONS(687),
    [anon_sym_phi] = ACTIONS(687),
    [anon_sym_landingpad] = ACTIONS(687),
    [anon_sym_tail] = ACTIONS(687),
    [anon_sym_musttail] = ACTIONS(687),
    [anon_sym_notail] = ACTIONS(687),
    [anon_sym_call] = ACTIONS(687),
    [anon_sym_alloca] = ACTIONS(687),
    [anon_sym_load] = ACTIONS(687),
    [anon_sym_store] = ACTIONS(687),
    [anon_sym_cmpxchg] = ACTIONS(687),
    [anon_sym_atomicrmw] = ACTIONS(687),
    [anon_sym_fence] = ACTIONS(687),
    [anon_sym_getelementptr] = ACTIONS(687),
    [anon_sym_extractvalue] = ACTIONS(687),
    [anon_sym_insertvalue] = ACTIONS(687),
    [anon_sym_catch] = ACTIONS(687),
    [anon_sym_filter] = ACTIONS(687),
    [anon_sym_mul] = ACTIONS(687),
    [anon_sym_urem] = ACTIONS(687),
    [anon_sym_srem] = ACTIONS(687),
    [anon_sym_shl] = ACTIONS(687),
    [anon_sym_udiv] = ACTIONS(687),
    [anon_sym_sdiv] = ACTIONS(687),
    [anon_sym_lshr] = ACTIONS(687),
    [anon_sym_ashr] = ACTIONS(687),
    [anon_sym_fmul] = ACTIONS(687),
    [anon_sym_fdiv] = ACTIONS(687),
    [anon_sym_frem] = ACTIONS(687),
    [anon_sym_xchg] = ACTIONS(687),
    [anon_sym_add] = ACTIONS(687),
    [anon_sym_sub] = ACTIONS(687),
    [anon_sym_and] = ACTIONS(687),
    [anon_sym_nand] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(687),
    [anon_sym_xor] = ACTIONS(687),
    [anon_sym_max] = ACTIONS(687),
    [anon_sym_min] = ACTIONS(687),
    [anon_sym_umax] = ACTIONS(687),
    [anon_sym_umin] = ACTIONS(687),
    [anon_sym_fadd] = ACTIONS(687),
    [anon_sym_fsub] = ACTIONS(687),
    [anon_sym_bitcast] = ACTIONS(687),
    [anon_sym_trunc] = ACTIONS(687),
    [anon_sym_zext] = ACTIONS(687),
    [anon_sym_sext] = ACTIONS(687),
    [anon_sym_fptrunc] = ACTIONS(687),
    [anon_sym_fpext] = ACTIONS(687),
    [anon_sym_addrspacecast] = ACTIONS(687),
    [anon_sym_uitofp] = ACTIONS(687),
    [anon_sym_sitofp] = ACTIONS(687),
    [anon_sym_fptoui] = ACTIONS(687),
    [anon_sym_fptosi] = ACTIONS(687),
    [anon_sym_inttoptr] = ACTIONS(687),
    [anon_sym_ptrtoint] = ACTIONS(687),
    [anon_sym_unordered] = ACTIONS(687),
    [anon_sym_monotonic] = ACTIONS(687),
    [anon_sym_acquire] = ACTIONS(687),
    [anon_sym_release] = ACTIONS(687),
    [anon_sym_acq_rel] = ACTIONS(687),
    [anon_sym_seq_cst] = ACTIONS(687),
    [anon_sym_syncscope] = ACTIONS(687),
    [anon_sym_uselistorder] = ACTIONS(687),
  },
  [139] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [sym_label] = ACTIONS(679),
    [sym_string] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(681),
    [anon_sym_partition] = ACTIONS(681),
    [anon_sym_comdat] = ACTIONS(681),
    [anon_sym_gc] = ACTIONS(681),
    [anon_sym_prefix] = ACTIONS(681),
    [anon_sym_prologue] = ACTIONS(681),
    [anon_sym_personality] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(681),
    [anon_sym_allocsize] = ACTIONS(681),
    [anon_sym_alwaysinline] = ACTIONS(681),
    [anon_sym_builtin] = ACTIONS(681),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(681),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(681),
    [anon_sym_hot] = ACTIONS(681),
    [anon_sym_inaccessiblememonly] = ACTIONS(681),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(681),
    [anon_sym_inlinehint] = ACTIONS(681),
    [anon_sym_jumptable] = ACTIONS(681),
    [anon_sym_minsize] = ACTIONS(681),
    [anon_sym_naked] = ACTIONS(681),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(681),
    [anon_sym_nobuiltin] = ACTIONS(681),
    [anon_sym_noduplicate] = ACTIONS(681),
    [anon_sym_nofree] = ACTIONS(681),
    [anon_sym_noimplicitfloat] = ACTIONS(681),
    [anon_sym_noinline] = ACTIONS(681),
    [anon_sym_nomerge] = ACTIONS(681),
    [anon_sym_nonlazybind] = ACTIONS(681),
    [anon_sym_noprofile] = ACTIONS(681),
    [anon_sym_noredzone] = ACTIONS(681),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(681),
    [anon_sym_noreturn] = ACTIONS(681),
    [anon_sym_norecurse] = ACTIONS(681),
    [anon_sym_willreturn] = ACTIONS(681),
    [anon_sym_nosync] = ACTIONS(681),
    [anon_sym_nounwind] = ACTIONS(681),
    [anon_sym_nosanitize_coverage] = ACTIONS(681),
    [anon_sym_null_pointer_is_valid] = ACTIONS(681),
    [anon_sym_optforfuzzing] = ACTIONS(681),
    [anon_sym_optnone] = ACTIONS(681),
    [anon_sym_optsize] = ACTIONS(681),
    [anon_sym_readnone] = ACTIONS(681),
    [anon_sym_readonly] = ACTIONS(681),
    [anon_sym_writeonly] = ACTIONS(681),
    [anon_sym_argmemonly] = ACTIONS(681),
    [anon_sym_returns_twice] = ACTIONS(681),
    [anon_sym_safestack] = ACTIONS(681),
    [anon_sym_sanitize_address] = ACTIONS(681),
    [anon_sym_sanitize_memory] = ACTIONS(681),
    [anon_sym_sanitize_thread] = ACTIONS(681),
    [anon_sym_sanitize_hwaddress] = ACTIONS(681),
    [anon_sym_sanitize_memtag] = ACTIONS(681),
    [anon_sym_speculative_load_hardening] = ACTIONS(681),
    [anon_sym_speculatable] = ACTIONS(681),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(681),
    [anon_sym_sspreq] = ACTIONS(681),
    [anon_sym_strictfp] = ACTIONS(681),
    [anon_sym_uwtable] = ACTIONS(681),
    [anon_sym_nocf_check] = ACTIONS(681),
    [anon_sym_shadowcallstack] = ACTIONS(681),
    [anon_sym_mustprogress] = ACTIONS(681),
    [anon_sym_vscale_range] = ACTIONS(681),
    [anon_sym_preallocated] = ACTIONS(681),
    [anon_sym_zeroext] = ACTIONS(681),
    [anon_sym_signext] = ACTIONS(681),
    [anon_sym_inreg] = ACTIONS(681),
    [anon_sym_byval] = ACTIONS(681),
    [anon_sym_byref] = ACTIONS(681),
    [anon_sym_inalloca] = ACTIONS(681),
    [anon_sym_sret] = ACTIONS(681),
    [anon_sym_elementtype] = ACTIONS(681),
    [anon_sym_noalias] = ACTIONS(681),
    [anon_sym_nocapture] = ACTIONS(681),
    [anon_sym_nest] = ACTIONS(681),
    [anon_sym_returned] = ACTIONS(681),
    [anon_sym_nonnull] = ACTIONS(681),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(681),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(681),
    [anon_sym_noundef] = ACTIONS(681),
    [anon_sym_unreachable] = ACTIONS(681),
    [anon_sym_ret] = ACTIONS(681),
    [anon_sym_br] = ACTIONS(681),
    [anon_sym_resume] = ACTIONS(681),
    [anon_sym_freeze] = ACTIONS(681),
    [anon_sym_indirectbr] = ACTIONS(681),
    [anon_sym_extractelement] = ACTIONS(681),
    [anon_sym_insertelement] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(681),
    [anon_sym_shufflevector] = ACTIONS(681),
    [anon_sym_fneg] = ACTIONS(681),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_invoke] = ACTIONS(681),
    [anon_sym_cleanupret] = ACTIONS(681),
    [anon_sym_catchret] = ACTIONS(681),
    [anon_sym_catchswitch] = ACTIONS(681),
    [anon_sym_catchpad] = ACTIONS(681),
    [anon_sym_cleanuppad] = ACTIONS(681),
    [anon_sym_callbr] = ACTIONS(681),
    [anon_sym_icmp] = ACTIONS(681),
    [anon_sym_fcmp] = ACTIONS(681),
    [anon_sym_va_arg] = ACTIONS(681),
    [anon_sym_phi] = ACTIONS(681),
    [anon_sym_landingpad] = ACTIONS(681),
    [anon_sym_tail] = ACTIONS(681),
    [anon_sym_musttail] = ACTIONS(681),
    [anon_sym_notail] = ACTIONS(681),
    [anon_sym_call] = ACTIONS(681),
    [anon_sym_alloca] = ACTIONS(681),
    [anon_sym_load] = ACTIONS(681),
    [anon_sym_store] = ACTIONS(681),
    [anon_sym_cmpxchg] = ACTIONS(681),
    [anon_sym_atomicrmw] = ACTIONS(681),
    [anon_sym_fence] = ACTIONS(681),
    [anon_sym_getelementptr] = ACTIONS(681),
    [anon_sym_extractvalue] = ACTIONS(681),
    [anon_sym_insertvalue] = ACTIONS(681),
    [anon_sym_catch] = ACTIONS(681),
    [anon_sym_filter] = ACTIONS(681),
    [anon_sym_mul] = ACTIONS(681),
    [anon_sym_urem] = ACTIONS(681),
    [anon_sym_srem] = ACTIONS(681),
    [anon_sym_shl] = ACTIONS(681),
    [anon_sym_udiv] = ACTIONS(681),
    [anon_sym_sdiv] = ACTIONS(681),
    [anon_sym_lshr] = ACTIONS(681),
    [anon_sym_ashr] = ACTIONS(681),
    [anon_sym_fmul] = ACTIONS(681),
    [anon_sym_fdiv] = ACTIONS(681),
    [anon_sym_frem] = ACTIONS(681),
    [anon_sym_xchg] = ACTIONS(681),
    [anon_sym_add] = ACTIONS(681),
    [anon_sym_sub] = ACTIONS(681),
    [anon_sym_and] = ACTIONS(681),
    [anon_sym_nand] = ACTIONS(681),
    [anon_sym_or] = ACTIONS(681),
    [anon_sym_xor] = ACTIONS(681),
    [anon_sym_max] = ACTIONS(681),
    [anon_sym_min] = ACTIONS(681),
    [anon_sym_umax] = ACTIONS(681),
    [anon_sym_umin] = ACTIONS(681),
    [anon_sym_fadd] = ACTIONS(681),
    [anon_sym_fsub] = ACTIONS(681),
    [anon_sym_bitcast] = ACTIONS(681),
    [anon_sym_trunc] = ACTIONS(681),
    [anon_sym_zext] = ACTIONS(681),
    [anon_sym_sext] = ACTIONS(681),
    [anon_sym_fptrunc] = ACTIONS(681),
    [anon_sym_fpext] = ACTIONS(681),
    [anon_sym_addrspacecast] = ACTIONS(681),
    [anon_sym_uitofp] = ACTIONS(681),
    [anon_sym_sitofp] = ACTIONS(681),
    [anon_sym_fptoui] = ACTIONS(681),
    [anon_sym_fptosi] = ACTIONS(681),
    [anon_sym_inttoptr] = ACTIONS(681),
    [anon_sym_ptrtoint] = ACTIONS(681),
    [anon_sym_unordered] = ACTIONS(681),
    [anon_sym_monotonic] = ACTIONS(681),
    [anon_sym_acquire] = ACTIONS(681),
    [anon_sym_release] = ACTIONS(681),
    [anon_sym_acq_rel] = ACTIONS(681),
    [anon_sym_seq_cst] = ACTIONS(681),
    [anon_sym_syncscope] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
  },
  [140] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [sym_label] = ACTIONS(689),
    [sym_string] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_section] = ACTIONS(691),
    [anon_sym_partition] = ACTIONS(691),
    [anon_sym_comdat] = ACTIONS(691),
    [anon_sym_gc] = ACTIONS(691),
    [anon_sym_prefix] = ACTIONS(691),
    [anon_sym_prologue] = ACTIONS(691),
    [anon_sym_personality] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(691),
    [anon_sym_allocsize] = ACTIONS(691),
    [anon_sym_alwaysinline] = ACTIONS(691),
    [anon_sym_builtin] = ACTIONS(691),
    [anon_sym_cold] = ACTIONS(691),
    [anon_sym_convergent] = ACTIONS(691),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(691),
    [anon_sym_hot] = ACTIONS(691),
    [anon_sym_inaccessiblememonly] = ACTIONS(691),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(691),
    [anon_sym_inlinehint] = ACTIONS(691),
    [anon_sym_jumptable] = ACTIONS(691),
    [anon_sym_minsize] = ACTIONS(691),
    [anon_sym_naked] = ACTIONS(691),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(691),
    [anon_sym_nobuiltin] = ACTIONS(691),
    [anon_sym_noduplicate] = ACTIONS(691),
    [anon_sym_nofree] = ACTIONS(691),
    [anon_sym_noimplicitfloat] = ACTIONS(691),
    [anon_sym_noinline] = ACTIONS(691),
    [anon_sym_nomerge] = ACTIONS(691),
    [anon_sym_nonlazybind] = ACTIONS(691),
    [anon_sym_noprofile] = ACTIONS(691),
    [anon_sym_noredzone] = ACTIONS(691),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(691),
    [anon_sym_noreturn] = ACTIONS(691),
    [anon_sym_norecurse] = ACTIONS(691),
    [anon_sym_willreturn] = ACTIONS(691),
    [anon_sym_nosync] = ACTIONS(691),
    [anon_sym_nounwind] = ACTIONS(691),
    [anon_sym_nosanitize_coverage] = ACTIONS(691),
    [anon_sym_null_pointer_is_valid] = ACTIONS(691),
    [anon_sym_optforfuzzing] = ACTIONS(691),
    [anon_sym_optnone] = ACTIONS(691),
    [anon_sym_optsize] = ACTIONS(691),
    [anon_sym_readnone] = ACTIONS(691),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_writeonly] = ACTIONS(691),
    [anon_sym_argmemonly] = ACTIONS(691),
    [anon_sym_returns_twice] = ACTIONS(691),
    [anon_sym_safestack] = ACTIONS(691),
    [anon_sym_sanitize_address] = ACTIONS(691),
    [anon_sym_sanitize_memory] = ACTIONS(691),
    [anon_sym_sanitize_thread] = ACTIONS(691),
    [anon_sym_sanitize_hwaddress] = ACTIONS(691),
    [anon_sym_sanitize_memtag] = ACTIONS(691),
    [anon_sym_speculative_load_hardening] = ACTIONS(691),
    [anon_sym_speculatable] = ACTIONS(691),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(691),
    [anon_sym_sspreq] = ACTIONS(691),
    [anon_sym_strictfp] = ACTIONS(691),
    [anon_sym_uwtable] = ACTIONS(691),
    [anon_sym_nocf_check] = ACTIONS(691),
    [anon_sym_shadowcallstack] = ACTIONS(691),
    [anon_sym_mustprogress] = ACTIONS(691),
    [anon_sym_vscale_range] = ACTIONS(691),
    [anon_sym_preallocated] = ACTIONS(691),
    [anon_sym_zeroext] = ACTIONS(691),
    [anon_sym_signext] = ACTIONS(691),
    [anon_sym_inreg] = ACTIONS(691),
    [anon_sym_byval] = ACTIONS(691),
    [anon_sym_byref] = ACTIONS(691),
    [anon_sym_inalloca] = ACTIONS(691),
    [anon_sym_sret] = ACTIONS(691),
    [anon_sym_elementtype] = ACTIONS(691),
    [anon_sym_noalias] = ACTIONS(691),
    [anon_sym_nocapture] = ACTIONS(691),
    [anon_sym_nest] = ACTIONS(691),
    [anon_sym_returned] = ACTIONS(691),
    [anon_sym_nonnull] = ACTIONS(691),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(691),
    [anon_sym_swiftself] = ACTIONS(691),
    [anon_sym_swiftasync] = ACTIONS(691),
    [anon_sym_swifterror] = ACTIONS(691),
    [anon_sym_immarg] = ACTIONS(691),
    [anon_sym_noundef] = ACTIONS(691),
    [anon_sym_unreachable] = ACTIONS(691),
    [anon_sym_ret] = ACTIONS(691),
    [anon_sym_br] = ACTIONS(691),
    [anon_sym_resume] = ACTIONS(691),
    [anon_sym_freeze] = ACTIONS(691),
    [anon_sym_indirectbr] = ACTIONS(691),
    [anon_sym_extractelement] = ACTIONS(691),
    [anon_sym_insertelement] = ACTIONS(691),
    [anon_sym_select] = ACTIONS(691),
    [anon_sym_shufflevector] = ACTIONS(691),
    [anon_sym_fneg] = ACTIONS(691),
    [anon_sym_switch] = ACTIONS(691),
    [anon_sym_invoke] = ACTIONS(691),
    [anon_sym_cleanupret] = ACTIONS(691),
    [anon_sym_catchret] = ACTIONS(691),
    [anon_sym_catchswitch] = ACTIONS(691),
    [anon_sym_catchpad] = ACTIONS(691),
    [anon_sym_cleanuppad] = ACTIONS(691),
    [anon_sym_callbr] = ACTIONS(691),
    [anon_sym_icmp] = ACTIONS(691),
    [anon_sym_fcmp] = ACTIONS(691),
    [anon_sym_va_arg] = ACTIONS(691),
    [anon_sym_phi] = ACTIONS(691),
    [anon_sym_landingpad] = ACTIONS(691),
    [anon_sym_tail] = ACTIONS(691),
    [anon_sym_musttail] = ACTIONS(691),
    [anon_sym_notail] = ACTIONS(691),
    [anon_sym_call] = ACTIONS(691),
    [anon_sym_alloca] = ACTIONS(691),
    [anon_sym_load] = ACTIONS(691),
    [anon_sym_store] = ACTIONS(691),
    [anon_sym_cmpxchg] = ACTIONS(691),
    [anon_sym_atomicrmw] = ACTIONS(691),
    [anon_sym_fence] = ACTIONS(691),
    [anon_sym_getelementptr] = ACTIONS(691),
    [anon_sym_extractvalue] = ACTIONS(691),
    [anon_sym_insertvalue] = ACTIONS(691),
    [anon_sym_catch] = ACTIONS(691),
    [anon_sym_filter] = ACTIONS(691),
    [anon_sym_mul] = ACTIONS(691),
    [anon_sym_urem] = ACTIONS(691),
    [anon_sym_srem] = ACTIONS(691),
    [anon_sym_shl] = ACTIONS(691),
    [anon_sym_udiv] = ACTIONS(691),
    [anon_sym_sdiv] = ACTIONS(691),
    [anon_sym_lshr] = ACTIONS(691),
    [anon_sym_ashr] = ACTIONS(691),
    [anon_sym_fmul] = ACTIONS(691),
    [anon_sym_fdiv] = ACTIONS(691),
    [anon_sym_frem] = ACTIONS(691),
    [anon_sym_xchg] = ACTIONS(691),
    [anon_sym_add] = ACTIONS(691),
    [anon_sym_sub] = ACTIONS(691),
    [anon_sym_and] = ACTIONS(691),
    [anon_sym_nand] = ACTIONS(691),
    [anon_sym_or] = ACTIONS(691),
    [anon_sym_xor] = ACTIONS(691),
    [anon_sym_max] = ACTIONS(691),
    [anon_sym_min] = ACTIONS(691),
    [anon_sym_umax] = ACTIONS(691),
    [anon_sym_umin] = ACTIONS(691),
    [anon_sym_fadd] = ACTIONS(691),
    [anon_sym_fsub] = ACTIONS(691),
    [anon_sym_bitcast] = ACTIONS(691),
    [anon_sym_trunc] = ACTIONS(691),
    [anon_sym_zext] = ACTIONS(691),
    [anon_sym_sext] = ACTIONS(691),
    [anon_sym_fptrunc] = ACTIONS(691),
    [anon_sym_fpext] = ACTIONS(691),
    [anon_sym_addrspacecast] = ACTIONS(691),
    [anon_sym_uitofp] = ACTIONS(691),
    [anon_sym_sitofp] = ACTIONS(691),
    [anon_sym_fptoui] = ACTIONS(691),
    [anon_sym_fptosi] = ACTIONS(691),
    [anon_sym_inttoptr] = ACTIONS(691),
    [anon_sym_ptrtoint] = ACTIONS(691),
    [anon_sym_unordered] = ACTIONS(691),
    [anon_sym_monotonic] = ACTIONS(691),
    [anon_sym_acquire] = ACTIONS(691),
    [anon_sym_release] = ACTIONS(691),
    [anon_sym_acq_rel] = ACTIONS(691),
    [anon_sym_seq_cst] = ACTIONS(691),
    [anon_sym_syncscope] = ACTIONS(691),
    [anon_sym_uselistorder] = ACTIONS(691),
  },
  [141] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [sym_label] = ACTIONS(505),
    [sym_string] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_section] = ACTIONS(507),
    [anon_sym_partition] = ACTIONS(507),
    [anon_sym_comdat] = ACTIONS(507),
    [anon_sym_gc] = ACTIONS(507),
    [anon_sym_prefix] = ACTIONS(507),
    [anon_sym_prologue] = ACTIONS(507),
    [anon_sym_personality] = ACTIONS(507),
    [anon_sym_alignstack] = ACTIONS(507),
    [anon_sym_allocsize] = ACTIONS(507),
    [anon_sym_alwaysinline] = ACTIONS(507),
    [anon_sym_builtin] = ACTIONS(507),
    [anon_sym_cold] = ACTIONS(507),
    [anon_sym_convergent] = ACTIONS(507),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(507),
    [anon_sym_hot] = ACTIONS(507),
    [anon_sym_inaccessiblememonly] = ACTIONS(507),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(507),
    [anon_sym_inlinehint] = ACTIONS(507),
    [anon_sym_jumptable] = ACTIONS(507),
    [anon_sym_minsize] = ACTIONS(507),
    [anon_sym_naked] = ACTIONS(507),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(507),
    [anon_sym_nobuiltin] = ACTIONS(507),
    [anon_sym_noduplicate] = ACTIONS(507),
    [anon_sym_nofree] = ACTIONS(507),
    [anon_sym_noimplicitfloat] = ACTIONS(507),
    [anon_sym_noinline] = ACTIONS(507),
    [anon_sym_nomerge] = ACTIONS(507),
    [anon_sym_nonlazybind] = ACTIONS(507),
    [anon_sym_noprofile] = ACTIONS(507),
    [anon_sym_noredzone] = ACTIONS(507),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(507),
    [anon_sym_noreturn] = ACTIONS(507),
    [anon_sym_norecurse] = ACTIONS(507),
    [anon_sym_willreturn] = ACTIONS(507),
    [anon_sym_nosync] = ACTIONS(507),
    [anon_sym_nounwind] = ACTIONS(507),
    [anon_sym_nosanitize_coverage] = ACTIONS(507),
    [anon_sym_null_pointer_is_valid] = ACTIONS(507),
    [anon_sym_optforfuzzing] = ACTIONS(507),
    [anon_sym_optnone] = ACTIONS(507),
    [anon_sym_optsize] = ACTIONS(507),
    [anon_sym_readnone] = ACTIONS(507),
    [anon_sym_readonly] = ACTIONS(507),
    [anon_sym_writeonly] = ACTIONS(507),
    [anon_sym_argmemonly] = ACTIONS(507),
    [anon_sym_returns_twice] = ACTIONS(507),
    [anon_sym_safestack] = ACTIONS(507),
    [anon_sym_sanitize_address] = ACTIONS(507),
    [anon_sym_sanitize_memory] = ACTIONS(507),
    [anon_sym_sanitize_thread] = ACTIONS(507),
    [anon_sym_sanitize_hwaddress] = ACTIONS(507),
    [anon_sym_sanitize_memtag] = ACTIONS(507),
    [anon_sym_speculative_load_hardening] = ACTIONS(507),
    [anon_sym_speculatable] = ACTIONS(507),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(507),
    [anon_sym_sspreq] = ACTIONS(507),
    [anon_sym_strictfp] = ACTIONS(507),
    [anon_sym_uwtable] = ACTIONS(507),
    [anon_sym_nocf_check] = ACTIONS(507),
    [anon_sym_shadowcallstack] = ACTIONS(507),
    [anon_sym_mustprogress] = ACTIONS(507),
    [anon_sym_vscale_range] = ACTIONS(507),
    [anon_sym_preallocated] = ACTIONS(507),
    [anon_sym_zeroext] = ACTIONS(507),
    [anon_sym_signext] = ACTIONS(507),
    [anon_sym_inreg] = ACTIONS(507),
    [anon_sym_byval] = ACTIONS(507),
    [anon_sym_byref] = ACTIONS(507),
    [anon_sym_inalloca] = ACTIONS(507),
    [anon_sym_sret] = ACTIONS(507),
    [anon_sym_elementtype] = ACTIONS(507),
    [anon_sym_noalias] = ACTIONS(507),
    [anon_sym_nocapture] = ACTIONS(507),
    [anon_sym_nest] = ACTIONS(507),
    [anon_sym_returned] = ACTIONS(507),
    [anon_sym_nonnull] = ACTIONS(507),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(507),
    [anon_sym_swiftself] = ACTIONS(507),
    [anon_sym_swiftasync] = ACTIONS(507),
    [anon_sym_swifterror] = ACTIONS(507),
    [anon_sym_immarg] = ACTIONS(507),
    [anon_sym_noundef] = ACTIONS(507),
    [anon_sym_unreachable] = ACTIONS(507),
    [anon_sym_ret] = ACTIONS(507),
    [anon_sym_br] = ACTIONS(507),
    [anon_sym_resume] = ACTIONS(507),
    [anon_sym_freeze] = ACTIONS(507),
    [anon_sym_indirectbr] = ACTIONS(507),
    [anon_sym_extractelement] = ACTIONS(507),
    [anon_sym_insertelement] = ACTIONS(507),
    [anon_sym_select] = ACTIONS(507),
    [anon_sym_shufflevector] = ACTIONS(507),
    [anon_sym_fneg] = ACTIONS(507),
    [anon_sym_switch] = ACTIONS(507),
    [anon_sym_invoke] = ACTIONS(507),
    [anon_sym_cleanupret] = ACTIONS(507),
    [anon_sym_catchret] = ACTIONS(507),
    [anon_sym_catchswitch] = ACTIONS(507),
    [anon_sym_catchpad] = ACTIONS(507),
    [anon_sym_cleanuppad] = ACTIONS(507),
    [anon_sym_callbr] = ACTIONS(507),
    [anon_sym_icmp] = ACTIONS(507),
    [anon_sym_fcmp] = ACTIONS(507),
    [anon_sym_va_arg] = ACTIONS(507),
    [anon_sym_phi] = ACTIONS(507),
    [anon_sym_landingpad] = ACTIONS(507),
    [anon_sym_tail] = ACTIONS(507),
    [anon_sym_musttail] = ACTIONS(507),
    [anon_sym_notail] = ACTIONS(507),
    [anon_sym_call] = ACTIONS(507),
    [anon_sym_alloca] = ACTIONS(507),
    [anon_sym_load] = ACTIONS(507),
    [anon_sym_store] = ACTIONS(507),
    [anon_sym_cmpxchg] = ACTIONS(507),
    [anon_sym_atomicrmw] = ACTIONS(507),
    [anon_sym_fence] = ACTIONS(507),
    [anon_sym_getelementptr] = ACTIONS(507),
    [anon_sym_extractvalue] = ACTIONS(507),
    [anon_sym_insertvalue] = ACTIONS(507),
    [anon_sym_catch] = ACTIONS(507),
    [anon_sym_filter] = ACTIONS(507),
    [anon_sym_mul] = ACTIONS(507),
    [anon_sym_urem] = ACTIONS(507),
    [anon_sym_srem] = ACTIONS(507),
    [anon_sym_shl] = ACTIONS(507),
    [anon_sym_udiv] = ACTIONS(507),
    [anon_sym_sdiv] = ACTIONS(507),
    [anon_sym_lshr] = ACTIONS(507),
    [anon_sym_ashr] = ACTIONS(507),
    [anon_sym_fmul] = ACTIONS(507),
    [anon_sym_fdiv] = ACTIONS(507),
    [anon_sym_frem] = ACTIONS(507),
    [anon_sym_xchg] = ACTIONS(507),
    [anon_sym_add] = ACTIONS(507),
    [anon_sym_sub] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(507),
    [anon_sym_nand] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(507),
    [anon_sym_xor] = ACTIONS(507),
    [anon_sym_max] = ACTIONS(507),
    [anon_sym_min] = ACTIONS(507),
    [anon_sym_umax] = ACTIONS(507),
    [anon_sym_umin] = ACTIONS(507),
    [anon_sym_fadd] = ACTIONS(507),
    [anon_sym_fsub] = ACTIONS(507),
    [anon_sym_bitcast] = ACTIONS(507),
    [anon_sym_trunc] = ACTIONS(507),
    [anon_sym_zext] = ACTIONS(507),
    [anon_sym_sext] = ACTIONS(507),
    [anon_sym_fptrunc] = ACTIONS(507),
    [anon_sym_fpext] = ACTIONS(507),
    [anon_sym_addrspacecast] = ACTIONS(507),
    [anon_sym_uitofp] = ACTIONS(507),
    [anon_sym_sitofp] = ACTIONS(507),
    [anon_sym_fptoui] = ACTIONS(507),
    [anon_sym_fptosi] = ACTIONS(507),
    [anon_sym_inttoptr] = ACTIONS(507),
    [anon_sym_ptrtoint] = ACTIONS(507),
    [anon_sym_unordered] = ACTIONS(507),
    [anon_sym_monotonic] = ACTIONS(507),
    [anon_sym_acquire] = ACTIONS(507),
    [anon_sym_release] = ACTIONS(507),
    [anon_sym_acq_rel] = ACTIONS(507),
    [anon_sym_seq_cst] = ACTIONS(507),
    [anon_sym_syncscope] = ACTIONS(507),
    [anon_sym_uselistorder] = ACTIONS(507),
  },
  [142] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [sym_label] = ACTIONS(615),
    [sym_string] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_section] = ACTIONS(617),
    [anon_sym_partition] = ACTIONS(617),
    [anon_sym_comdat] = ACTIONS(617),
    [anon_sym_gc] = ACTIONS(617),
    [anon_sym_prefix] = ACTIONS(617),
    [anon_sym_prologue] = ACTIONS(617),
    [anon_sym_personality] = ACTIONS(617),
    [anon_sym_alignstack] = ACTIONS(617),
    [anon_sym_allocsize] = ACTIONS(617),
    [anon_sym_alwaysinline] = ACTIONS(617),
    [anon_sym_builtin] = ACTIONS(617),
    [anon_sym_cold] = ACTIONS(617),
    [anon_sym_convergent] = ACTIONS(617),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(617),
    [anon_sym_hot] = ACTIONS(617),
    [anon_sym_inaccessiblememonly] = ACTIONS(617),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(617),
    [anon_sym_inlinehint] = ACTIONS(617),
    [anon_sym_jumptable] = ACTIONS(617),
    [anon_sym_minsize] = ACTIONS(617),
    [anon_sym_naked] = ACTIONS(617),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(617),
    [anon_sym_nobuiltin] = ACTIONS(617),
    [anon_sym_noduplicate] = ACTIONS(617),
    [anon_sym_nofree] = ACTIONS(617),
    [anon_sym_noimplicitfloat] = ACTIONS(617),
    [anon_sym_noinline] = ACTIONS(617),
    [anon_sym_nomerge] = ACTIONS(617),
    [anon_sym_nonlazybind] = ACTIONS(617),
    [anon_sym_noprofile] = ACTIONS(617),
    [anon_sym_noredzone] = ACTIONS(617),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(617),
    [anon_sym_noreturn] = ACTIONS(617),
    [anon_sym_norecurse] = ACTIONS(617),
    [anon_sym_willreturn] = ACTIONS(617),
    [anon_sym_nosync] = ACTIONS(617),
    [anon_sym_nounwind] = ACTIONS(617),
    [anon_sym_nosanitize_coverage] = ACTIONS(617),
    [anon_sym_null_pointer_is_valid] = ACTIONS(617),
    [anon_sym_optforfuzzing] = ACTIONS(617),
    [anon_sym_optnone] = ACTIONS(617),
    [anon_sym_optsize] = ACTIONS(617),
    [anon_sym_readnone] = ACTIONS(617),
    [anon_sym_readonly] = ACTIONS(617),
    [anon_sym_writeonly] = ACTIONS(617),
    [anon_sym_argmemonly] = ACTIONS(617),
    [anon_sym_returns_twice] = ACTIONS(617),
    [anon_sym_safestack] = ACTIONS(617),
    [anon_sym_sanitize_address] = ACTIONS(617),
    [anon_sym_sanitize_memory] = ACTIONS(617),
    [anon_sym_sanitize_thread] = ACTIONS(617),
    [anon_sym_sanitize_hwaddress] = ACTIONS(617),
    [anon_sym_sanitize_memtag] = ACTIONS(617),
    [anon_sym_speculative_load_hardening] = ACTIONS(617),
    [anon_sym_speculatable] = ACTIONS(617),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(617),
    [anon_sym_sspreq] = ACTIONS(617),
    [anon_sym_strictfp] = ACTIONS(617),
    [anon_sym_uwtable] = ACTIONS(617),
    [anon_sym_nocf_check] = ACTIONS(617),
    [anon_sym_shadowcallstack] = ACTIONS(617),
    [anon_sym_mustprogress] = ACTIONS(617),
    [anon_sym_vscale_range] = ACTIONS(617),
    [anon_sym_preallocated] = ACTIONS(617),
    [anon_sym_zeroext] = ACTIONS(617),
    [anon_sym_signext] = ACTIONS(617),
    [anon_sym_inreg] = ACTIONS(617),
    [anon_sym_byval] = ACTIONS(617),
    [anon_sym_byref] = ACTIONS(617),
    [anon_sym_inalloca] = ACTIONS(617),
    [anon_sym_sret] = ACTIONS(617),
    [anon_sym_elementtype] = ACTIONS(617),
    [anon_sym_noalias] = ACTIONS(617),
    [anon_sym_nocapture] = ACTIONS(617),
    [anon_sym_nest] = ACTIONS(617),
    [anon_sym_returned] = ACTIONS(617),
    [anon_sym_nonnull] = ACTIONS(617),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(617),
    [anon_sym_swiftself] = ACTIONS(617),
    [anon_sym_swiftasync] = ACTIONS(617),
    [anon_sym_swifterror] = ACTIONS(617),
    [anon_sym_immarg] = ACTIONS(617),
    [anon_sym_noundef] = ACTIONS(617),
    [anon_sym_unreachable] = ACTIONS(617),
    [anon_sym_ret] = ACTIONS(617),
    [anon_sym_br] = ACTIONS(617),
    [anon_sym_resume] = ACTIONS(617),
    [anon_sym_freeze] = ACTIONS(617),
    [anon_sym_indirectbr] = ACTIONS(617),
    [anon_sym_extractelement] = ACTIONS(617),
    [anon_sym_insertelement] = ACTIONS(617),
    [anon_sym_select] = ACTIONS(617),
    [anon_sym_shufflevector] = ACTIONS(617),
    [anon_sym_fneg] = ACTIONS(617),
    [anon_sym_switch] = ACTIONS(617),
    [anon_sym_invoke] = ACTIONS(617),
    [anon_sym_cleanupret] = ACTIONS(617),
    [anon_sym_catchret] = ACTIONS(617),
    [anon_sym_catchswitch] = ACTIONS(617),
    [anon_sym_catchpad] = ACTIONS(617),
    [anon_sym_cleanuppad] = ACTIONS(617),
    [anon_sym_callbr] = ACTIONS(617),
    [anon_sym_icmp] = ACTIONS(617),
    [anon_sym_fcmp] = ACTIONS(617),
    [anon_sym_va_arg] = ACTIONS(617),
    [anon_sym_phi] = ACTIONS(617),
    [anon_sym_landingpad] = ACTIONS(617),
    [anon_sym_tail] = ACTIONS(617),
    [anon_sym_musttail] = ACTIONS(617),
    [anon_sym_notail] = ACTIONS(617),
    [anon_sym_call] = ACTIONS(617),
    [anon_sym_alloca] = ACTIONS(617),
    [anon_sym_load] = ACTIONS(617),
    [anon_sym_store] = ACTIONS(617),
    [anon_sym_cmpxchg] = ACTIONS(617),
    [anon_sym_atomicrmw] = ACTIONS(617),
    [anon_sym_fence] = ACTIONS(617),
    [anon_sym_getelementptr] = ACTIONS(617),
    [anon_sym_extractvalue] = ACTIONS(617),
    [anon_sym_insertvalue] = ACTIONS(617),
    [anon_sym_catch] = ACTIONS(617),
    [anon_sym_filter] = ACTIONS(617),
    [anon_sym_mul] = ACTIONS(617),
    [anon_sym_urem] = ACTIONS(617),
    [anon_sym_srem] = ACTIONS(617),
    [anon_sym_shl] = ACTIONS(617),
    [anon_sym_udiv] = ACTIONS(617),
    [anon_sym_sdiv] = ACTIONS(617),
    [anon_sym_lshr] = ACTIONS(617),
    [anon_sym_ashr] = ACTIONS(617),
    [anon_sym_fmul] = ACTIONS(617),
    [anon_sym_fdiv] = ACTIONS(617),
    [anon_sym_frem] = ACTIONS(617),
    [anon_sym_xchg] = ACTIONS(617),
    [anon_sym_add] = ACTIONS(617),
    [anon_sym_sub] = ACTIONS(617),
    [anon_sym_and] = ACTIONS(617),
    [anon_sym_nand] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(617),
    [anon_sym_xor] = ACTIONS(617),
    [anon_sym_max] = ACTIONS(617),
    [anon_sym_min] = ACTIONS(617),
    [anon_sym_umax] = ACTIONS(617),
    [anon_sym_umin] = ACTIONS(617),
    [anon_sym_fadd] = ACTIONS(617),
    [anon_sym_fsub] = ACTIONS(617),
    [anon_sym_bitcast] = ACTIONS(617),
    [anon_sym_trunc] = ACTIONS(617),
    [anon_sym_zext] = ACTIONS(617),
    [anon_sym_sext] = ACTIONS(617),
    [anon_sym_fptrunc] = ACTIONS(617),
    [anon_sym_fpext] = ACTIONS(617),
    [anon_sym_addrspacecast] = ACTIONS(617),
    [anon_sym_uitofp] = ACTIONS(617),
    [anon_sym_sitofp] = ACTIONS(617),
    [anon_sym_fptoui] = ACTIONS(617),
    [anon_sym_fptosi] = ACTIONS(617),
    [anon_sym_inttoptr] = ACTIONS(617),
    [anon_sym_ptrtoint] = ACTIONS(617),
    [anon_sym_unordered] = ACTIONS(617),
    [anon_sym_monotonic] = ACTIONS(617),
    [anon_sym_acquire] = ACTIONS(617),
    [anon_sym_release] = ACTIONS(617),
    [anon_sym_acq_rel] = ACTIONS(617),
    [anon_sym_seq_cst] = ACTIONS(617),
    [anon_sym_syncscope] = ACTIONS(617),
    [anon_sym_uselistorder] = ACTIONS(617),
  },
  [143] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [sym_label] = ACTIONS(607),
    [sym_string] = ACTIONS(609),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_section] = ACTIONS(609),
    [anon_sym_partition] = ACTIONS(609),
    [anon_sym_comdat] = ACTIONS(609),
    [anon_sym_gc] = ACTIONS(609),
    [anon_sym_prefix] = ACTIONS(609),
    [anon_sym_prologue] = ACTIONS(609),
    [anon_sym_personality] = ACTIONS(609),
    [anon_sym_alignstack] = ACTIONS(609),
    [anon_sym_allocsize] = ACTIONS(609),
    [anon_sym_alwaysinline] = ACTIONS(609),
    [anon_sym_builtin] = ACTIONS(609),
    [anon_sym_cold] = ACTIONS(609),
    [anon_sym_convergent] = ACTIONS(609),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(609),
    [anon_sym_hot] = ACTIONS(609),
    [anon_sym_inaccessiblememonly] = ACTIONS(609),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(609),
    [anon_sym_inlinehint] = ACTIONS(609),
    [anon_sym_jumptable] = ACTIONS(609),
    [anon_sym_minsize] = ACTIONS(609),
    [anon_sym_naked] = ACTIONS(609),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(609),
    [anon_sym_nobuiltin] = ACTIONS(609),
    [anon_sym_noduplicate] = ACTIONS(609),
    [anon_sym_nofree] = ACTIONS(609),
    [anon_sym_noimplicitfloat] = ACTIONS(609),
    [anon_sym_noinline] = ACTIONS(609),
    [anon_sym_nomerge] = ACTIONS(609),
    [anon_sym_nonlazybind] = ACTIONS(609),
    [anon_sym_noprofile] = ACTIONS(609),
    [anon_sym_noredzone] = ACTIONS(609),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(609),
    [anon_sym_noreturn] = ACTIONS(609),
    [anon_sym_norecurse] = ACTIONS(609),
    [anon_sym_willreturn] = ACTIONS(609),
    [anon_sym_nosync] = ACTIONS(609),
    [anon_sym_nounwind] = ACTIONS(609),
    [anon_sym_nosanitize_coverage] = ACTIONS(609),
    [anon_sym_null_pointer_is_valid] = ACTIONS(609),
    [anon_sym_optforfuzzing] = ACTIONS(609),
    [anon_sym_optnone] = ACTIONS(609),
    [anon_sym_optsize] = ACTIONS(609),
    [anon_sym_readnone] = ACTIONS(609),
    [anon_sym_readonly] = ACTIONS(609),
    [anon_sym_writeonly] = ACTIONS(609),
    [anon_sym_argmemonly] = ACTIONS(609),
    [anon_sym_returns_twice] = ACTIONS(609),
    [anon_sym_safestack] = ACTIONS(609),
    [anon_sym_sanitize_address] = ACTIONS(609),
    [anon_sym_sanitize_memory] = ACTIONS(609),
    [anon_sym_sanitize_thread] = ACTIONS(609),
    [anon_sym_sanitize_hwaddress] = ACTIONS(609),
    [anon_sym_sanitize_memtag] = ACTIONS(609),
    [anon_sym_speculative_load_hardening] = ACTIONS(609),
    [anon_sym_speculatable] = ACTIONS(609),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(609),
    [anon_sym_sspreq] = ACTIONS(609),
    [anon_sym_strictfp] = ACTIONS(609),
    [anon_sym_uwtable] = ACTIONS(609),
    [anon_sym_nocf_check] = ACTIONS(609),
    [anon_sym_shadowcallstack] = ACTIONS(609),
    [anon_sym_mustprogress] = ACTIONS(609),
    [anon_sym_vscale_range] = ACTIONS(609),
    [anon_sym_preallocated] = ACTIONS(609),
    [anon_sym_zeroext] = ACTIONS(609),
    [anon_sym_signext] = ACTIONS(609),
    [anon_sym_inreg] = ACTIONS(609),
    [anon_sym_byval] = ACTIONS(609),
    [anon_sym_byref] = ACTIONS(609),
    [anon_sym_inalloca] = ACTIONS(609),
    [anon_sym_sret] = ACTIONS(609),
    [anon_sym_elementtype] = ACTIONS(609),
    [anon_sym_noalias] = ACTIONS(609),
    [anon_sym_nocapture] = ACTIONS(609),
    [anon_sym_nest] = ACTIONS(609),
    [anon_sym_returned] = ACTIONS(609),
    [anon_sym_nonnull] = ACTIONS(609),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(609),
    [anon_sym_swiftself] = ACTIONS(609),
    [anon_sym_swiftasync] = ACTIONS(609),
    [anon_sym_swifterror] = ACTIONS(609),
    [anon_sym_immarg] = ACTIONS(609),
    [anon_sym_noundef] = ACTIONS(609),
    [anon_sym_unreachable] = ACTIONS(609),
    [anon_sym_ret] = ACTIONS(609),
    [anon_sym_br] = ACTIONS(609),
    [anon_sym_resume] = ACTIONS(609),
    [anon_sym_freeze] = ACTIONS(609),
    [anon_sym_indirectbr] = ACTIONS(609),
    [anon_sym_extractelement] = ACTIONS(609),
    [anon_sym_insertelement] = ACTIONS(609),
    [anon_sym_select] = ACTIONS(609),
    [anon_sym_shufflevector] = ACTIONS(609),
    [anon_sym_fneg] = ACTIONS(609),
    [anon_sym_switch] = ACTIONS(609),
    [anon_sym_invoke] = ACTIONS(609),
    [anon_sym_cleanupret] = ACTIONS(609),
    [anon_sym_catchret] = ACTIONS(609),
    [anon_sym_catchswitch] = ACTIONS(609),
    [anon_sym_catchpad] = ACTIONS(609),
    [anon_sym_cleanuppad] = ACTIONS(609),
    [anon_sym_callbr] = ACTIONS(609),
    [anon_sym_icmp] = ACTIONS(609),
    [anon_sym_fcmp] = ACTIONS(609),
    [anon_sym_va_arg] = ACTIONS(609),
    [anon_sym_phi] = ACTIONS(609),
    [anon_sym_landingpad] = ACTIONS(609),
    [anon_sym_tail] = ACTIONS(609),
    [anon_sym_musttail] = ACTIONS(609),
    [anon_sym_notail] = ACTIONS(609),
    [anon_sym_call] = ACTIONS(609),
    [anon_sym_alloca] = ACTIONS(609),
    [anon_sym_load] = ACTIONS(609),
    [anon_sym_store] = ACTIONS(609),
    [anon_sym_cmpxchg] = ACTIONS(609),
    [anon_sym_atomicrmw] = ACTIONS(609),
    [anon_sym_fence] = ACTIONS(609),
    [anon_sym_getelementptr] = ACTIONS(609),
    [anon_sym_extractvalue] = ACTIONS(609),
    [anon_sym_insertvalue] = ACTIONS(609),
    [anon_sym_catch] = ACTIONS(609),
    [anon_sym_filter] = ACTIONS(609),
    [anon_sym_mul] = ACTIONS(609),
    [anon_sym_urem] = ACTIONS(609),
    [anon_sym_srem] = ACTIONS(609),
    [anon_sym_shl] = ACTIONS(609),
    [anon_sym_udiv] = ACTIONS(609),
    [anon_sym_sdiv] = ACTIONS(609),
    [anon_sym_lshr] = ACTIONS(609),
    [anon_sym_ashr] = ACTIONS(609),
    [anon_sym_fmul] = ACTIONS(609),
    [anon_sym_fdiv] = ACTIONS(609),
    [anon_sym_frem] = ACTIONS(609),
    [anon_sym_xchg] = ACTIONS(609),
    [anon_sym_add] = ACTIONS(609),
    [anon_sym_sub] = ACTIONS(609),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_nand] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(609),
    [anon_sym_xor] = ACTIONS(609),
    [anon_sym_max] = ACTIONS(609),
    [anon_sym_min] = ACTIONS(609),
    [anon_sym_umax] = ACTIONS(609),
    [anon_sym_umin] = ACTIONS(609),
    [anon_sym_fadd] = ACTIONS(609),
    [anon_sym_fsub] = ACTIONS(609),
    [anon_sym_bitcast] = ACTIONS(609),
    [anon_sym_trunc] = ACTIONS(609),
    [anon_sym_zext] = ACTIONS(609),
    [anon_sym_sext] = ACTIONS(609),
    [anon_sym_fptrunc] = ACTIONS(609),
    [anon_sym_fpext] = ACTIONS(609),
    [anon_sym_addrspacecast] = ACTIONS(609),
    [anon_sym_uitofp] = ACTIONS(609),
    [anon_sym_sitofp] = ACTIONS(609),
    [anon_sym_fptoui] = ACTIONS(609),
    [anon_sym_fptosi] = ACTIONS(609),
    [anon_sym_inttoptr] = ACTIONS(609),
    [anon_sym_ptrtoint] = ACTIONS(609),
    [anon_sym_unordered] = ACTIONS(609),
    [anon_sym_monotonic] = ACTIONS(609),
    [anon_sym_acquire] = ACTIONS(609),
    [anon_sym_release] = ACTIONS(609),
    [anon_sym_acq_rel] = ACTIONS(609),
    [anon_sym_seq_cst] = ACTIONS(609),
    [anon_sym_syncscope] = ACTIONS(609),
    [anon_sym_uselistorder] = ACTIONS(609),
  },
  [144] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [sym_label] = ACTIONS(619),
    [sym_string] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_section] = ACTIONS(621),
    [anon_sym_partition] = ACTIONS(621),
    [anon_sym_comdat] = ACTIONS(621),
    [anon_sym_gc] = ACTIONS(621),
    [anon_sym_prefix] = ACTIONS(621),
    [anon_sym_prologue] = ACTIONS(621),
    [anon_sym_personality] = ACTIONS(621),
    [anon_sym_alignstack] = ACTIONS(621),
    [anon_sym_allocsize] = ACTIONS(621),
    [anon_sym_alwaysinline] = ACTIONS(621),
    [anon_sym_builtin] = ACTIONS(621),
    [anon_sym_cold] = ACTIONS(621),
    [anon_sym_convergent] = ACTIONS(621),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(621),
    [anon_sym_hot] = ACTIONS(621),
    [anon_sym_inaccessiblememonly] = ACTIONS(621),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(621),
    [anon_sym_inlinehint] = ACTIONS(621),
    [anon_sym_jumptable] = ACTIONS(621),
    [anon_sym_minsize] = ACTIONS(621),
    [anon_sym_naked] = ACTIONS(621),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(621),
    [anon_sym_nobuiltin] = ACTIONS(621),
    [anon_sym_noduplicate] = ACTIONS(621),
    [anon_sym_nofree] = ACTIONS(621),
    [anon_sym_noimplicitfloat] = ACTIONS(621),
    [anon_sym_noinline] = ACTIONS(621),
    [anon_sym_nomerge] = ACTIONS(621),
    [anon_sym_nonlazybind] = ACTIONS(621),
    [anon_sym_noprofile] = ACTIONS(621),
    [anon_sym_noredzone] = ACTIONS(621),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(621),
    [anon_sym_noreturn] = ACTIONS(621),
    [anon_sym_norecurse] = ACTIONS(621),
    [anon_sym_willreturn] = ACTIONS(621),
    [anon_sym_nosync] = ACTIONS(621),
    [anon_sym_nounwind] = ACTIONS(621),
    [anon_sym_nosanitize_coverage] = ACTIONS(621),
    [anon_sym_null_pointer_is_valid] = ACTIONS(621),
    [anon_sym_optforfuzzing] = ACTIONS(621),
    [anon_sym_optnone] = ACTIONS(621),
    [anon_sym_optsize] = ACTIONS(621),
    [anon_sym_readnone] = ACTIONS(621),
    [anon_sym_readonly] = ACTIONS(621),
    [anon_sym_writeonly] = ACTIONS(621),
    [anon_sym_argmemonly] = ACTIONS(621),
    [anon_sym_returns_twice] = ACTIONS(621),
    [anon_sym_safestack] = ACTIONS(621),
    [anon_sym_sanitize_address] = ACTIONS(621),
    [anon_sym_sanitize_memory] = ACTIONS(621),
    [anon_sym_sanitize_thread] = ACTIONS(621),
    [anon_sym_sanitize_hwaddress] = ACTIONS(621),
    [anon_sym_sanitize_memtag] = ACTIONS(621),
    [anon_sym_speculative_load_hardening] = ACTIONS(621),
    [anon_sym_speculatable] = ACTIONS(621),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(621),
    [anon_sym_sspreq] = ACTIONS(621),
    [anon_sym_strictfp] = ACTIONS(621),
    [anon_sym_uwtable] = ACTIONS(621),
    [anon_sym_nocf_check] = ACTIONS(621),
    [anon_sym_shadowcallstack] = ACTIONS(621),
    [anon_sym_mustprogress] = ACTIONS(621),
    [anon_sym_vscale_range] = ACTIONS(621),
    [anon_sym_preallocated] = ACTIONS(621),
    [anon_sym_zeroext] = ACTIONS(621),
    [anon_sym_signext] = ACTIONS(621),
    [anon_sym_inreg] = ACTIONS(621),
    [anon_sym_byval] = ACTIONS(621),
    [anon_sym_byref] = ACTIONS(621),
    [anon_sym_inalloca] = ACTIONS(621),
    [anon_sym_sret] = ACTIONS(621),
    [anon_sym_elementtype] = ACTIONS(621),
    [anon_sym_noalias] = ACTIONS(621),
    [anon_sym_nocapture] = ACTIONS(621),
    [anon_sym_nest] = ACTIONS(621),
    [anon_sym_returned] = ACTIONS(621),
    [anon_sym_nonnull] = ACTIONS(621),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(621),
    [anon_sym_swiftself] = ACTIONS(621),
    [anon_sym_swiftasync] = ACTIONS(621),
    [anon_sym_swifterror] = ACTIONS(621),
    [anon_sym_immarg] = ACTIONS(621),
    [anon_sym_noundef] = ACTIONS(621),
    [anon_sym_unreachable] = ACTIONS(621),
    [anon_sym_ret] = ACTIONS(621),
    [anon_sym_br] = ACTIONS(621),
    [anon_sym_resume] = ACTIONS(621),
    [anon_sym_freeze] = ACTIONS(621),
    [anon_sym_indirectbr] = ACTIONS(621),
    [anon_sym_extractelement] = ACTIONS(621),
    [anon_sym_insertelement] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_shufflevector] = ACTIONS(621),
    [anon_sym_fneg] = ACTIONS(621),
    [anon_sym_switch] = ACTIONS(621),
    [anon_sym_invoke] = ACTIONS(621),
    [anon_sym_cleanupret] = ACTIONS(621),
    [anon_sym_catchret] = ACTIONS(621),
    [anon_sym_catchswitch] = ACTIONS(621),
    [anon_sym_catchpad] = ACTIONS(621),
    [anon_sym_cleanuppad] = ACTIONS(621),
    [anon_sym_callbr] = ACTIONS(621),
    [anon_sym_icmp] = ACTIONS(621),
    [anon_sym_fcmp] = ACTIONS(621),
    [anon_sym_va_arg] = ACTIONS(621),
    [anon_sym_phi] = ACTIONS(621),
    [anon_sym_landingpad] = ACTIONS(621),
    [anon_sym_tail] = ACTIONS(621),
    [anon_sym_musttail] = ACTIONS(621),
    [anon_sym_notail] = ACTIONS(621),
    [anon_sym_call] = ACTIONS(621),
    [anon_sym_alloca] = ACTIONS(621),
    [anon_sym_load] = ACTIONS(621),
    [anon_sym_store] = ACTIONS(621),
    [anon_sym_cmpxchg] = ACTIONS(621),
    [anon_sym_atomicrmw] = ACTIONS(621),
    [anon_sym_fence] = ACTIONS(621),
    [anon_sym_getelementptr] = ACTIONS(621),
    [anon_sym_extractvalue] = ACTIONS(621),
    [anon_sym_insertvalue] = ACTIONS(621),
    [anon_sym_catch] = ACTIONS(621),
    [anon_sym_filter] = ACTIONS(621),
    [anon_sym_mul] = ACTIONS(621),
    [anon_sym_urem] = ACTIONS(621),
    [anon_sym_srem] = ACTIONS(621),
    [anon_sym_shl] = ACTIONS(621),
    [anon_sym_udiv] = ACTIONS(621),
    [anon_sym_sdiv] = ACTIONS(621),
    [anon_sym_lshr] = ACTIONS(621),
    [anon_sym_ashr] = ACTIONS(621),
    [anon_sym_fmul] = ACTIONS(621),
    [anon_sym_fdiv] = ACTIONS(621),
    [anon_sym_frem] = ACTIONS(621),
    [anon_sym_xchg] = ACTIONS(621),
    [anon_sym_add] = ACTIONS(621),
    [anon_sym_sub] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_nand] = ACTIONS(621),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_xor] = ACTIONS(621),
    [anon_sym_max] = ACTIONS(621),
    [anon_sym_min] = ACTIONS(621),
    [anon_sym_umax] = ACTIONS(621),
    [anon_sym_umin] = ACTIONS(621),
    [anon_sym_fadd] = ACTIONS(621),
    [anon_sym_fsub] = ACTIONS(621),
    [anon_sym_bitcast] = ACTIONS(621),
    [anon_sym_trunc] = ACTIONS(621),
    [anon_sym_zext] = ACTIONS(621),
    [anon_sym_sext] = ACTIONS(621),
    [anon_sym_fptrunc] = ACTIONS(621),
    [anon_sym_fpext] = ACTIONS(621),
    [anon_sym_addrspacecast] = ACTIONS(621),
    [anon_sym_uitofp] = ACTIONS(621),
    [anon_sym_sitofp] = ACTIONS(621),
    [anon_sym_fptoui] = ACTIONS(621),
    [anon_sym_fptosi] = ACTIONS(621),
    [anon_sym_inttoptr] = ACTIONS(621),
    [anon_sym_ptrtoint] = ACTIONS(621),
    [anon_sym_unordered] = ACTIONS(621),
    [anon_sym_monotonic] = ACTIONS(621),
    [anon_sym_acquire] = ACTIONS(621),
    [anon_sym_release] = ACTIONS(621),
    [anon_sym_acq_rel] = ACTIONS(621),
    [anon_sym_seq_cst] = ACTIONS(621),
    [anon_sym_syncscope] = ACTIONS(621),
    [anon_sym_uselistorder] = ACTIONS(621),
  },
  [145] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [sym_label] = ACTIONS(611),
    [sym_string] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_section] = ACTIONS(613),
    [anon_sym_partition] = ACTIONS(613),
    [anon_sym_comdat] = ACTIONS(613),
    [anon_sym_gc] = ACTIONS(613),
    [anon_sym_prefix] = ACTIONS(613),
    [anon_sym_prologue] = ACTIONS(613),
    [anon_sym_personality] = ACTIONS(613),
    [anon_sym_alignstack] = ACTIONS(613),
    [anon_sym_allocsize] = ACTIONS(613),
    [anon_sym_alwaysinline] = ACTIONS(613),
    [anon_sym_builtin] = ACTIONS(613),
    [anon_sym_cold] = ACTIONS(613),
    [anon_sym_convergent] = ACTIONS(613),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(613),
    [anon_sym_hot] = ACTIONS(613),
    [anon_sym_inaccessiblememonly] = ACTIONS(613),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(613),
    [anon_sym_inlinehint] = ACTIONS(613),
    [anon_sym_jumptable] = ACTIONS(613),
    [anon_sym_minsize] = ACTIONS(613),
    [anon_sym_naked] = ACTIONS(613),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(613),
    [anon_sym_nobuiltin] = ACTIONS(613),
    [anon_sym_noduplicate] = ACTIONS(613),
    [anon_sym_nofree] = ACTIONS(613),
    [anon_sym_noimplicitfloat] = ACTIONS(613),
    [anon_sym_noinline] = ACTIONS(613),
    [anon_sym_nomerge] = ACTIONS(613),
    [anon_sym_nonlazybind] = ACTIONS(613),
    [anon_sym_noprofile] = ACTIONS(613),
    [anon_sym_noredzone] = ACTIONS(613),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(613),
    [anon_sym_noreturn] = ACTIONS(613),
    [anon_sym_norecurse] = ACTIONS(613),
    [anon_sym_willreturn] = ACTIONS(613),
    [anon_sym_nosync] = ACTIONS(613),
    [anon_sym_nounwind] = ACTIONS(613),
    [anon_sym_nosanitize_coverage] = ACTIONS(613),
    [anon_sym_null_pointer_is_valid] = ACTIONS(613),
    [anon_sym_optforfuzzing] = ACTIONS(613),
    [anon_sym_optnone] = ACTIONS(613),
    [anon_sym_optsize] = ACTIONS(613),
    [anon_sym_readnone] = ACTIONS(613),
    [anon_sym_readonly] = ACTIONS(613),
    [anon_sym_writeonly] = ACTIONS(613),
    [anon_sym_argmemonly] = ACTIONS(613),
    [anon_sym_returns_twice] = ACTIONS(613),
    [anon_sym_safestack] = ACTIONS(613),
    [anon_sym_sanitize_address] = ACTIONS(613),
    [anon_sym_sanitize_memory] = ACTIONS(613),
    [anon_sym_sanitize_thread] = ACTIONS(613),
    [anon_sym_sanitize_hwaddress] = ACTIONS(613),
    [anon_sym_sanitize_memtag] = ACTIONS(613),
    [anon_sym_speculative_load_hardening] = ACTIONS(613),
    [anon_sym_speculatable] = ACTIONS(613),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(613),
    [anon_sym_sspreq] = ACTIONS(613),
    [anon_sym_strictfp] = ACTIONS(613),
    [anon_sym_uwtable] = ACTIONS(613),
    [anon_sym_nocf_check] = ACTIONS(613),
    [anon_sym_shadowcallstack] = ACTIONS(613),
    [anon_sym_mustprogress] = ACTIONS(613),
    [anon_sym_vscale_range] = ACTIONS(613),
    [anon_sym_preallocated] = ACTIONS(613),
    [anon_sym_zeroext] = ACTIONS(613),
    [anon_sym_signext] = ACTIONS(613),
    [anon_sym_inreg] = ACTIONS(613),
    [anon_sym_byval] = ACTIONS(613),
    [anon_sym_byref] = ACTIONS(613),
    [anon_sym_inalloca] = ACTIONS(613),
    [anon_sym_sret] = ACTIONS(613),
    [anon_sym_elementtype] = ACTIONS(613),
    [anon_sym_noalias] = ACTIONS(613),
    [anon_sym_nocapture] = ACTIONS(613),
    [anon_sym_nest] = ACTIONS(613),
    [anon_sym_returned] = ACTIONS(613),
    [anon_sym_nonnull] = ACTIONS(613),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(613),
    [anon_sym_swiftself] = ACTIONS(613),
    [anon_sym_swiftasync] = ACTIONS(613),
    [anon_sym_swifterror] = ACTIONS(613),
    [anon_sym_immarg] = ACTIONS(613),
    [anon_sym_noundef] = ACTIONS(613),
    [anon_sym_unreachable] = ACTIONS(613),
    [anon_sym_ret] = ACTIONS(613),
    [anon_sym_br] = ACTIONS(613),
    [anon_sym_resume] = ACTIONS(613),
    [anon_sym_freeze] = ACTIONS(613),
    [anon_sym_indirectbr] = ACTIONS(613),
    [anon_sym_extractelement] = ACTIONS(613),
    [anon_sym_insertelement] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_shufflevector] = ACTIONS(613),
    [anon_sym_fneg] = ACTIONS(613),
    [anon_sym_switch] = ACTIONS(613),
    [anon_sym_invoke] = ACTIONS(613),
    [anon_sym_cleanupret] = ACTIONS(613),
    [anon_sym_catchret] = ACTIONS(613),
    [anon_sym_catchswitch] = ACTIONS(613),
    [anon_sym_catchpad] = ACTIONS(613),
    [anon_sym_cleanuppad] = ACTIONS(613),
    [anon_sym_callbr] = ACTIONS(613),
    [anon_sym_icmp] = ACTIONS(613),
    [anon_sym_fcmp] = ACTIONS(613),
    [anon_sym_va_arg] = ACTIONS(613),
    [anon_sym_phi] = ACTIONS(613),
    [anon_sym_landingpad] = ACTIONS(613),
    [anon_sym_tail] = ACTIONS(613),
    [anon_sym_musttail] = ACTIONS(613),
    [anon_sym_notail] = ACTIONS(613),
    [anon_sym_call] = ACTIONS(613),
    [anon_sym_alloca] = ACTIONS(613),
    [anon_sym_load] = ACTIONS(613),
    [anon_sym_store] = ACTIONS(613),
    [anon_sym_cmpxchg] = ACTIONS(613),
    [anon_sym_atomicrmw] = ACTIONS(613),
    [anon_sym_fence] = ACTIONS(613),
    [anon_sym_getelementptr] = ACTIONS(613),
    [anon_sym_extractvalue] = ACTIONS(613),
    [anon_sym_insertvalue] = ACTIONS(613),
    [anon_sym_catch] = ACTIONS(613),
    [anon_sym_filter] = ACTIONS(613),
    [anon_sym_mul] = ACTIONS(613),
    [anon_sym_urem] = ACTIONS(613),
    [anon_sym_srem] = ACTIONS(613),
    [anon_sym_shl] = ACTIONS(613),
    [anon_sym_udiv] = ACTIONS(613),
    [anon_sym_sdiv] = ACTIONS(613),
    [anon_sym_lshr] = ACTIONS(613),
    [anon_sym_ashr] = ACTIONS(613),
    [anon_sym_fmul] = ACTIONS(613),
    [anon_sym_fdiv] = ACTIONS(613),
    [anon_sym_frem] = ACTIONS(613),
    [anon_sym_xchg] = ACTIONS(613),
    [anon_sym_add] = ACTIONS(613),
    [anon_sym_sub] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_nand] = ACTIONS(613),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_xor] = ACTIONS(613),
    [anon_sym_max] = ACTIONS(613),
    [anon_sym_min] = ACTIONS(613),
    [anon_sym_umax] = ACTIONS(613),
    [anon_sym_umin] = ACTIONS(613),
    [anon_sym_fadd] = ACTIONS(613),
    [anon_sym_fsub] = ACTIONS(613),
    [anon_sym_bitcast] = ACTIONS(613),
    [anon_sym_trunc] = ACTIONS(613),
    [anon_sym_zext] = ACTIONS(613),
    [anon_sym_sext] = ACTIONS(613),
    [anon_sym_fptrunc] = ACTIONS(613),
    [anon_sym_fpext] = ACTIONS(613),
    [anon_sym_addrspacecast] = ACTIONS(613),
    [anon_sym_uitofp] = ACTIONS(613),
    [anon_sym_sitofp] = ACTIONS(613),
    [anon_sym_fptoui] = ACTIONS(613),
    [anon_sym_fptosi] = ACTIONS(613),
    [anon_sym_inttoptr] = ACTIONS(613),
    [anon_sym_ptrtoint] = ACTIONS(613),
    [anon_sym_unordered] = ACTIONS(613),
    [anon_sym_monotonic] = ACTIONS(613),
    [anon_sym_acquire] = ACTIONS(613),
    [anon_sym_release] = ACTIONS(613),
    [anon_sym_acq_rel] = ACTIONS(613),
    [anon_sym_seq_cst] = ACTIONS(613),
    [anon_sym_syncscope] = ACTIONS(613),
    [anon_sym_uselistorder] = ACTIONS(613),
  },
  [146] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [sym_label] = ACTIONS(623),
    [sym_string] = ACTIONS(625),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_section] = ACTIONS(625),
    [anon_sym_partition] = ACTIONS(625),
    [anon_sym_comdat] = ACTIONS(625),
    [anon_sym_gc] = ACTIONS(625),
    [anon_sym_prefix] = ACTIONS(625),
    [anon_sym_prologue] = ACTIONS(625),
    [anon_sym_personality] = ACTIONS(625),
    [anon_sym_alignstack] = ACTIONS(625),
    [anon_sym_allocsize] = ACTIONS(625),
    [anon_sym_alwaysinline] = ACTIONS(625),
    [anon_sym_builtin] = ACTIONS(625),
    [anon_sym_cold] = ACTIONS(625),
    [anon_sym_convergent] = ACTIONS(625),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(625),
    [anon_sym_hot] = ACTIONS(625),
    [anon_sym_inaccessiblememonly] = ACTIONS(625),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(625),
    [anon_sym_inlinehint] = ACTIONS(625),
    [anon_sym_jumptable] = ACTIONS(625),
    [anon_sym_minsize] = ACTIONS(625),
    [anon_sym_naked] = ACTIONS(625),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(625),
    [anon_sym_nobuiltin] = ACTIONS(625),
    [anon_sym_noduplicate] = ACTIONS(625),
    [anon_sym_nofree] = ACTIONS(625),
    [anon_sym_noimplicitfloat] = ACTIONS(625),
    [anon_sym_noinline] = ACTIONS(625),
    [anon_sym_nomerge] = ACTIONS(625),
    [anon_sym_nonlazybind] = ACTIONS(625),
    [anon_sym_noprofile] = ACTIONS(625),
    [anon_sym_noredzone] = ACTIONS(625),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(625),
    [anon_sym_noreturn] = ACTIONS(625),
    [anon_sym_norecurse] = ACTIONS(625),
    [anon_sym_willreturn] = ACTIONS(625),
    [anon_sym_nosync] = ACTIONS(625),
    [anon_sym_nounwind] = ACTIONS(625),
    [anon_sym_nosanitize_coverage] = ACTIONS(625),
    [anon_sym_null_pointer_is_valid] = ACTIONS(625),
    [anon_sym_optforfuzzing] = ACTIONS(625),
    [anon_sym_optnone] = ACTIONS(625),
    [anon_sym_optsize] = ACTIONS(625),
    [anon_sym_readnone] = ACTIONS(625),
    [anon_sym_readonly] = ACTIONS(625),
    [anon_sym_writeonly] = ACTIONS(625),
    [anon_sym_argmemonly] = ACTIONS(625),
    [anon_sym_returns_twice] = ACTIONS(625),
    [anon_sym_safestack] = ACTIONS(625),
    [anon_sym_sanitize_address] = ACTIONS(625),
    [anon_sym_sanitize_memory] = ACTIONS(625),
    [anon_sym_sanitize_thread] = ACTIONS(625),
    [anon_sym_sanitize_hwaddress] = ACTIONS(625),
    [anon_sym_sanitize_memtag] = ACTIONS(625),
    [anon_sym_speculative_load_hardening] = ACTIONS(625),
    [anon_sym_speculatable] = ACTIONS(625),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(625),
    [anon_sym_sspreq] = ACTIONS(625),
    [anon_sym_strictfp] = ACTIONS(625),
    [anon_sym_uwtable] = ACTIONS(625),
    [anon_sym_nocf_check] = ACTIONS(625),
    [anon_sym_shadowcallstack] = ACTIONS(625),
    [anon_sym_mustprogress] = ACTIONS(625),
    [anon_sym_vscale_range] = ACTIONS(625),
    [anon_sym_preallocated] = ACTIONS(625),
    [anon_sym_zeroext] = ACTIONS(625),
    [anon_sym_signext] = ACTIONS(625),
    [anon_sym_inreg] = ACTIONS(625),
    [anon_sym_byval] = ACTIONS(625),
    [anon_sym_byref] = ACTIONS(625),
    [anon_sym_inalloca] = ACTIONS(625),
    [anon_sym_sret] = ACTIONS(625),
    [anon_sym_elementtype] = ACTIONS(625),
    [anon_sym_noalias] = ACTIONS(625),
    [anon_sym_nocapture] = ACTIONS(625),
    [anon_sym_nest] = ACTIONS(625),
    [anon_sym_returned] = ACTIONS(625),
    [anon_sym_nonnull] = ACTIONS(625),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(625),
    [anon_sym_swiftself] = ACTIONS(625),
    [anon_sym_swiftasync] = ACTIONS(625),
    [anon_sym_swifterror] = ACTIONS(625),
    [anon_sym_immarg] = ACTIONS(625),
    [anon_sym_noundef] = ACTIONS(625),
    [anon_sym_unreachable] = ACTIONS(625),
    [anon_sym_ret] = ACTIONS(625),
    [anon_sym_br] = ACTIONS(625),
    [anon_sym_resume] = ACTIONS(625),
    [anon_sym_freeze] = ACTIONS(625),
    [anon_sym_indirectbr] = ACTIONS(625),
    [anon_sym_extractelement] = ACTIONS(625),
    [anon_sym_insertelement] = ACTIONS(625),
    [anon_sym_select] = ACTIONS(625),
    [anon_sym_shufflevector] = ACTIONS(625),
    [anon_sym_fneg] = ACTIONS(625),
    [anon_sym_switch] = ACTIONS(625),
    [anon_sym_invoke] = ACTIONS(625),
    [anon_sym_cleanupret] = ACTIONS(625),
    [anon_sym_catchret] = ACTIONS(625),
    [anon_sym_catchswitch] = ACTIONS(625),
    [anon_sym_catchpad] = ACTIONS(625),
    [anon_sym_cleanuppad] = ACTIONS(625),
    [anon_sym_callbr] = ACTIONS(625),
    [anon_sym_icmp] = ACTIONS(625),
    [anon_sym_fcmp] = ACTIONS(625),
    [anon_sym_va_arg] = ACTIONS(625),
    [anon_sym_phi] = ACTIONS(625),
    [anon_sym_landingpad] = ACTIONS(625),
    [anon_sym_tail] = ACTIONS(625),
    [anon_sym_musttail] = ACTIONS(625),
    [anon_sym_notail] = ACTIONS(625),
    [anon_sym_call] = ACTIONS(625),
    [anon_sym_alloca] = ACTIONS(625),
    [anon_sym_load] = ACTIONS(625),
    [anon_sym_store] = ACTIONS(625),
    [anon_sym_cmpxchg] = ACTIONS(625),
    [anon_sym_atomicrmw] = ACTIONS(625),
    [anon_sym_fence] = ACTIONS(625),
    [anon_sym_getelementptr] = ACTIONS(625),
    [anon_sym_extractvalue] = ACTIONS(625),
    [anon_sym_insertvalue] = ACTIONS(625),
    [anon_sym_catch] = ACTIONS(625),
    [anon_sym_filter] = ACTIONS(625),
    [anon_sym_mul] = ACTIONS(625),
    [anon_sym_urem] = ACTIONS(625),
    [anon_sym_srem] = ACTIONS(625),
    [anon_sym_shl] = ACTIONS(625),
    [anon_sym_udiv] = ACTIONS(625),
    [anon_sym_sdiv] = ACTIONS(625),
    [anon_sym_lshr] = ACTIONS(625),
    [anon_sym_ashr] = ACTIONS(625),
    [anon_sym_fmul] = ACTIONS(625),
    [anon_sym_fdiv] = ACTIONS(625),
    [anon_sym_frem] = ACTIONS(625),
    [anon_sym_xchg] = ACTIONS(625),
    [anon_sym_add] = ACTIONS(625),
    [anon_sym_sub] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_nand] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(625),
    [anon_sym_xor] = ACTIONS(625),
    [anon_sym_max] = ACTIONS(625),
    [anon_sym_min] = ACTIONS(625),
    [anon_sym_umax] = ACTIONS(625),
    [anon_sym_umin] = ACTIONS(625),
    [anon_sym_fadd] = ACTIONS(625),
    [anon_sym_fsub] = ACTIONS(625),
    [anon_sym_bitcast] = ACTIONS(625),
    [anon_sym_trunc] = ACTIONS(625),
    [anon_sym_zext] = ACTIONS(625),
    [anon_sym_sext] = ACTIONS(625),
    [anon_sym_fptrunc] = ACTIONS(625),
    [anon_sym_fpext] = ACTIONS(625),
    [anon_sym_addrspacecast] = ACTIONS(625),
    [anon_sym_uitofp] = ACTIONS(625),
    [anon_sym_sitofp] = ACTIONS(625),
    [anon_sym_fptoui] = ACTIONS(625),
    [anon_sym_fptosi] = ACTIONS(625),
    [anon_sym_inttoptr] = ACTIONS(625),
    [anon_sym_ptrtoint] = ACTIONS(625),
    [anon_sym_unordered] = ACTIONS(625),
    [anon_sym_monotonic] = ACTIONS(625),
    [anon_sym_acquire] = ACTIONS(625),
    [anon_sym_release] = ACTIONS(625),
    [anon_sym_acq_rel] = ACTIONS(625),
    [anon_sym_seq_cst] = ACTIONS(625),
    [anon_sym_syncscope] = ACTIONS(625),
    [anon_sym_uselistorder] = ACTIONS(625),
  },
  [147] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [sym_label] = ACTIONS(627),
    [sym_string] = ACTIONS(629),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_section] = ACTIONS(629),
    [anon_sym_partition] = ACTIONS(629),
    [anon_sym_comdat] = ACTIONS(629),
    [anon_sym_gc] = ACTIONS(629),
    [anon_sym_prefix] = ACTIONS(629),
    [anon_sym_prologue] = ACTIONS(629),
    [anon_sym_personality] = ACTIONS(629),
    [anon_sym_alignstack] = ACTIONS(629),
    [anon_sym_allocsize] = ACTIONS(629),
    [anon_sym_alwaysinline] = ACTIONS(629),
    [anon_sym_builtin] = ACTIONS(629),
    [anon_sym_cold] = ACTIONS(629),
    [anon_sym_convergent] = ACTIONS(629),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(629),
    [anon_sym_hot] = ACTIONS(629),
    [anon_sym_inaccessiblememonly] = ACTIONS(629),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(629),
    [anon_sym_inlinehint] = ACTIONS(629),
    [anon_sym_jumptable] = ACTIONS(629),
    [anon_sym_minsize] = ACTIONS(629),
    [anon_sym_naked] = ACTIONS(629),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(629),
    [anon_sym_nobuiltin] = ACTIONS(629),
    [anon_sym_noduplicate] = ACTIONS(629),
    [anon_sym_nofree] = ACTIONS(629),
    [anon_sym_noimplicitfloat] = ACTIONS(629),
    [anon_sym_noinline] = ACTIONS(629),
    [anon_sym_nomerge] = ACTIONS(629),
    [anon_sym_nonlazybind] = ACTIONS(629),
    [anon_sym_noprofile] = ACTIONS(629),
    [anon_sym_noredzone] = ACTIONS(629),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(629),
    [anon_sym_noreturn] = ACTIONS(629),
    [anon_sym_norecurse] = ACTIONS(629),
    [anon_sym_willreturn] = ACTIONS(629),
    [anon_sym_nosync] = ACTIONS(629),
    [anon_sym_nounwind] = ACTIONS(629),
    [anon_sym_nosanitize_coverage] = ACTIONS(629),
    [anon_sym_null_pointer_is_valid] = ACTIONS(629),
    [anon_sym_optforfuzzing] = ACTIONS(629),
    [anon_sym_optnone] = ACTIONS(629),
    [anon_sym_optsize] = ACTIONS(629),
    [anon_sym_readnone] = ACTIONS(629),
    [anon_sym_readonly] = ACTIONS(629),
    [anon_sym_writeonly] = ACTIONS(629),
    [anon_sym_argmemonly] = ACTIONS(629),
    [anon_sym_returns_twice] = ACTIONS(629),
    [anon_sym_safestack] = ACTIONS(629),
    [anon_sym_sanitize_address] = ACTIONS(629),
    [anon_sym_sanitize_memory] = ACTIONS(629),
    [anon_sym_sanitize_thread] = ACTIONS(629),
    [anon_sym_sanitize_hwaddress] = ACTIONS(629),
    [anon_sym_sanitize_memtag] = ACTIONS(629),
    [anon_sym_speculative_load_hardening] = ACTIONS(629),
    [anon_sym_speculatable] = ACTIONS(629),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(629),
    [anon_sym_sspreq] = ACTIONS(629),
    [anon_sym_strictfp] = ACTIONS(629),
    [anon_sym_uwtable] = ACTIONS(629),
    [anon_sym_nocf_check] = ACTIONS(629),
    [anon_sym_shadowcallstack] = ACTIONS(629),
    [anon_sym_mustprogress] = ACTIONS(629),
    [anon_sym_vscale_range] = ACTIONS(629),
    [anon_sym_preallocated] = ACTIONS(629),
    [anon_sym_zeroext] = ACTIONS(629),
    [anon_sym_signext] = ACTIONS(629),
    [anon_sym_inreg] = ACTIONS(629),
    [anon_sym_byval] = ACTIONS(629),
    [anon_sym_byref] = ACTIONS(629),
    [anon_sym_inalloca] = ACTIONS(629),
    [anon_sym_sret] = ACTIONS(629),
    [anon_sym_elementtype] = ACTIONS(629),
    [anon_sym_noalias] = ACTIONS(629),
    [anon_sym_nocapture] = ACTIONS(629),
    [anon_sym_nest] = ACTIONS(629),
    [anon_sym_returned] = ACTIONS(629),
    [anon_sym_nonnull] = ACTIONS(629),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(629),
    [anon_sym_swiftself] = ACTIONS(629),
    [anon_sym_swiftasync] = ACTIONS(629),
    [anon_sym_swifterror] = ACTIONS(629),
    [anon_sym_immarg] = ACTIONS(629),
    [anon_sym_noundef] = ACTIONS(629),
    [anon_sym_unreachable] = ACTIONS(629),
    [anon_sym_ret] = ACTIONS(629),
    [anon_sym_br] = ACTIONS(629),
    [anon_sym_resume] = ACTIONS(629),
    [anon_sym_freeze] = ACTIONS(629),
    [anon_sym_indirectbr] = ACTIONS(629),
    [anon_sym_extractelement] = ACTIONS(629),
    [anon_sym_insertelement] = ACTIONS(629),
    [anon_sym_select] = ACTIONS(629),
    [anon_sym_shufflevector] = ACTIONS(629),
    [anon_sym_fneg] = ACTIONS(629),
    [anon_sym_switch] = ACTIONS(629),
    [anon_sym_invoke] = ACTIONS(629),
    [anon_sym_cleanupret] = ACTIONS(629),
    [anon_sym_catchret] = ACTIONS(629),
    [anon_sym_catchswitch] = ACTIONS(629),
    [anon_sym_catchpad] = ACTIONS(629),
    [anon_sym_cleanuppad] = ACTIONS(629),
    [anon_sym_callbr] = ACTIONS(629),
    [anon_sym_icmp] = ACTIONS(629),
    [anon_sym_fcmp] = ACTIONS(629),
    [anon_sym_va_arg] = ACTIONS(629),
    [anon_sym_phi] = ACTIONS(629),
    [anon_sym_landingpad] = ACTIONS(629),
    [anon_sym_tail] = ACTIONS(629),
    [anon_sym_musttail] = ACTIONS(629),
    [anon_sym_notail] = ACTIONS(629),
    [anon_sym_call] = ACTIONS(629),
    [anon_sym_alloca] = ACTIONS(629),
    [anon_sym_load] = ACTIONS(629),
    [anon_sym_store] = ACTIONS(629),
    [anon_sym_cmpxchg] = ACTIONS(629),
    [anon_sym_atomicrmw] = ACTIONS(629),
    [anon_sym_fence] = ACTIONS(629),
    [anon_sym_getelementptr] = ACTIONS(629),
    [anon_sym_extractvalue] = ACTIONS(629),
    [anon_sym_insertvalue] = ACTIONS(629),
    [anon_sym_catch] = ACTIONS(629),
    [anon_sym_filter] = ACTIONS(629),
    [anon_sym_mul] = ACTIONS(629),
    [anon_sym_urem] = ACTIONS(629),
    [anon_sym_srem] = ACTIONS(629),
    [anon_sym_shl] = ACTIONS(629),
    [anon_sym_udiv] = ACTIONS(629),
    [anon_sym_sdiv] = ACTIONS(629),
    [anon_sym_lshr] = ACTIONS(629),
    [anon_sym_ashr] = ACTIONS(629),
    [anon_sym_fmul] = ACTIONS(629),
    [anon_sym_fdiv] = ACTIONS(629),
    [anon_sym_frem] = ACTIONS(629),
    [anon_sym_xchg] = ACTIONS(629),
    [anon_sym_add] = ACTIONS(629),
    [anon_sym_sub] = ACTIONS(629),
    [anon_sym_and] = ACTIONS(629),
    [anon_sym_nand] = ACTIONS(629),
    [anon_sym_or] = ACTIONS(629),
    [anon_sym_xor] = ACTIONS(629),
    [anon_sym_max] = ACTIONS(629),
    [anon_sym_min] = ACTIONS(629),
    [anon_sym_umax] = ACTIONS(629),
    [anon_sym_umin] = ACTIONS(629),
    [anon_sym_fadd] = ACTIONS(629),
    [anon_sym_fsub] = ACTIONS(629),
    [anon_sym_bitcast] = ACTIONS(629),
    [anon_sym_trunc] = ACTIONS(629),
    [anon_sym_zext] = ACTIONS(629),
    [anon_sym_sext] = ACTIONS(629),
    [anon_sym_fptrunc] = ACTIONS(629),
    [anon_sym_fpext] = ACTIONS(629),
    [anon_sym_addrspacecast] = ACTIONS(629),
    [anon_sym_uitofp] = ACTIONS(629),
    [anon_sym_sitofp] = ACTIONS(629),
    [anon_sym_fptoui] = ACTIONS(629),
    [anon_sym_fptosi] = ACTIONS(629),
    [anon_sym_inttoptr] = ACTIONS(629),
    [anon_sym_ptrtoint] = ACTIONS(629),
    [anon_sym_unordered] = ACTIONS(629),
    [anon_sym_monotonic] = ACTIONS(629),
    [anon_sym_acquire] = ACTIONS(629),
    [anon_sym_release] = ACTIONS(629),
    [anon_sym_acq_rel] = ACTIONS(629),
    [anon_sym_seq_cst] = ACTIONS(629),
    [anon_sym_syncscope] = ACTIONS(629),
    [anon_sym_uselistorder] = ACTIONS(629),
  },
  [148] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(501),
    [sym_local_var] = ACTIONS(501),
    [sym_label] = ACTIONS(501),
    [sym_string] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_align] = ACTIONS(503),
    [anon_sym_section] = ACTIONS(503),
    [anon_sym_partition] = ACTIONS(503),
    [anon_sym_comdat] = ACTIONS(503),
    [anon_sym_gc] = ACTIONS(503),
    [anon_sym_prefix] = ACTIONS(503),
    [anon_sym_prologue] = ACTIONS(503),
    [anon_sym_personality] = ACTIONS(503),
    [anon_sym_alignstack] = ACTIONS(503),
    [anon_sym_allocsize] = ACTIONS(503),
    [anon_sym_alwaysinline] = ACTIONS(503),
    [anon_sym_builtin] = ACTIONS(503),
    [anon_sym_cold] = ACTIONS(503),
    [anon_sym_convergent] = ACTIONS(503),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(503),
    [anon_sym_hot] = ACTIONS(503),
    [anon_sym_inaccessiblememonly] = ACTIONS(503),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(503),
    [anon_sym_inlinehint] = ACTIONS(503),
    [anon_sym_jumptable] = ACTIONS(503),
    [anon_sym_minsize] = ACTIONS(503),
    [anon_sym_naked] = ACTIONS(503),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(503),
    [anon_sym_nobuiltin] = ACTIONS(503),
    [anon_sym_noduplicate] = ACTIONS(503),
    [anon_sym_nofree] = ACTIONS(503),
    [anon_sym_noimplicitfloat] = ACTIONS(503),
    [anon_sym_noinline] = ACTIONS(503),
    [anon_sym_nomerge] = ACTIONS(503),
    [anon_sym_nonlazybind] = ACTIONS(503),
    [anon_sym_noprofile] = ACTIONS(503),
    [anon_sym_noredzone] = ACTIONS(503),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(503),
    [anon_sym_noreturn] = ACTIONS(503),
    [anon_sym_norecurse] = ACTIONS(503),
    [anon_sym_willreturn] = ACTIONS(503),
    [anon_sym_nosync] = ACTIONS(503),
    [anon_sym_nounwind] = ACTIONS(503),
    [anon_sym_nosanitize_coverage] = ACTIONS(503),
    [anon_sym_null_pointer_is_valid] = ACTIONS(503),
    [anon_sym_optforfuzzing] = ACTIONS(503),
    [anon_sym_optnone] = ACTIONS(503),
    [anon_sym_optsize] = ACTIONS(503),
    [anon_sym_readnone] = ACTIONS(503),
    [anon_sym_readonly] = ACTIONS(503),
    [anon_sym_writeonly] = ACTIONS(503),
    [anon_sym_argmemonly] = ACTIONS(503),
    [anon_sym_returns_twice] = ACTIONS(503),
    [anon_sym_safestack] = ACTIONS(503),
    [anon_sym_sanitize_address] = ACTIONS(503),
    [anon_sym_sanitize_memory] = ACTIONS(503),
    [anon_sym_sanitize_thread] = ACTIONS(503),
    [anon_sym_sanitize_hwaddress] = ACTIONS(503),
    [anon_sym_sanitize_memtag] = ACTIONS(503),
    [anon_sym_speculative_load_hardening] = ACTIONS(503),
    [anon_sym_speculatable] = ACTIONS(503),
    [anon_sym_ssp] = ACTIONS(503),
    [anon_sym_sspstrong] = ACTIONS(503),
    [anon_sym_sspreq] = ACTIONS(503),
    [anon_sym_strictfp] = ACTIONS(503),
    [anon_sym_uwtable] = ACTIONS(503),
    [anon_sym_nocf_check] = ACTIONS(503),
    [anon_sym_shadowcallstack] = ACTIONS(503),
    [anon_sym_mustprogress] = ACTIONS(503),
    [anon_sym_vscale_range] = ACTIONS(503),
    [anon_sym_preallocated] = ACTIONS(503),
    [anon_sym_zeroext] = ACTIONS(503),
    [anon_sym_signext] = ACTIONS(503),
    [anon_sym_inreg] = ACTIONS(503),
    [anon_sym_byval] = ACTIONS(503),
    [anon_sym_byref] = ACTIONS(503),
    [anon_sym_inalloca] = ACTIONS(503),
    [anon_sym_sret] = ACTIONS(503),
    [anon_sym_elementtype] = ACTIONS(503),
    [anon_sym_noalias] = ACTIONS(503),
    [anon_sym_nocapture] = ACTIONS(503),
    [anon_sym_nest] = ACTIONS(503),
    [anon_sym_returned] = ACTIONS(503),
    [anon_sym_nonnull] = ACTIONS(503),
    [anon_sym_dereferenceable] = ACTIONS(503),
    [anon_sym_dereferenceable_or_null] = ACTIONS(503),
    [anon_sym_swiftself] = ACTIONS(503),
    [anon_sym_swiftasync] = ACTIONS(503),
    [anon_sym_swifterror] = ACTIONS(503),
    [anon_sym_immarg] = ACTIONS(503),
    [anon_sym_noundef] = ACTIONS(503),
    [anon_sym_unreachable] = ACTIONS(503),
    [anon_sym_ret] = ACTIONS(503),
    [anon_sym_br] = ACTIONS(503),
    [anon_sym_resume] = ACTIONS(503),
    [anon_sym_freeze] = ACTIONS(503),
    [anon_sym_indirectbr] = ACTIONS(503),
    [anon_sym_extractelement] = ACTIONS(503),
    [anon_sym_insertelement] = ACTIONS(503),
    [anon_sym_select] = ACTIONS(503),
    [anon_sym_shufflevector] = ACTIONS(503),
    [anon_sym_fneg] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(503),
    [anon_sym_invoke] = ACTIONS(503),
    [anon_sym_cleanupret] = ACTIONS(503),
    [anon_sym_catchret] = ACTIONS(503),
    [anon_sym_catchswitch] = ACTIONS(503),
    [anon_sym_catchpad] = ACTIONS(503),
    [anon_sym_cleanuppad] = ACTIONS(503),
    [anon_sym_callbr] = ACTIONS(503),
    [anon_sym_icmp] = ACTIONS(503),
    [anon_sym_fcmp] = ACTIONS(503),
    [anon_sym_va_arg] = ACTIONS(503),
    [anon_sym_phi] = ACTIONS(503),
    [anon_sym_landingpad] = ACTIONS(503),
    [anon_sym_tail] = ACTIONS(503),
    [anon_sym_musttail] = ACTIONS(503),
    [anon_sym_notail] = ACTIONS(503),
    [anon_sym_call] = ACTIONS(503),
    [anon_sym_alloca] = ACTIONS(503),
    [anon_sym_load] = ACTIONS(503),
    [anon_sym_store] = ACTIONS(503),
    [anon_sym_cmpxchg] = ACTIONS(503),
    [anon_sym_atomicrmw] = ACTIONS(503),
    [anon_sym_fence] = ACTIONS(503),
    [anon_sym_getelementptr] = ACTIONS(503),
    [anon_sym_extractvalue] = ACTIONS(503),
    [anon_sym_insertvalue] = ACTIONS(503),
    [anon_sym_catch] = ACTIONS(503),
    [anon_sym_filter] = ACTIONS(503),
    [anon_sym_mul] = ACTIONS(503),
    [anon_sym_urem] = ACTIONS(503),
    [anon_sym_srem] = ACTIONS(503),
    [anon_sym_shl] = ACTIONS(503),
    [anon_sym_udiv] = ACTIONS(503),
    [anon_sym_sdiv] = ACTIONS(503),
    [anon_sym_lshr] = ACTIONS(503),
    [anon_sym_ashr] = ACTIONS(503),
    [anon_sym_fmul] = ACTIONS(503),
    [anon_sym_fdiv] = ACTIONS(503),
    [anon_sym_frem] = ACTIONS(503),
    [anon_sym_xchg] = ACTIONS(503),
    [anon_sym_add] = ACTIONS(503),
    [anon_sym_sub] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_nand] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_xor] = ACTIONS(503),
    [anon_sym_max] = ACTIONS(503),
    [anon_sym_min] = ACTIONS(503),
    [anon_sym_umax] = ACTIONS(503),
    [anon_sym_umin] = ACTIONS(503),
    [anon_sym_fadd] = ACTIONS(503),
    [anon_sym_fsub] = ACTIONS(503),
    [anon_sym_bitcast] = ACTIONS(503),
    [anon_sym_trunc] = ACTIONS(503),
    [anon_sym_zext] = ACTIONS(503),
    [anon_sym_sext] = ACTIONS(503),
    [anon_sym_fptrunc] = ACTIONS(503),
    [anon_sym_fpext] = ACTIONS(503),
    [anon_sym_addrspacecast] = ACTIONS(503),
    [anon_sym_uitofp] = ACTIONS(503),
    [anon_sym_sitofp] = ACTIONS(503),
    [anon_sym_fptoui] = ACTIONS(503),
    [anon_sym_fptosi] = ACTIONS(503),
    [anon_sym_inttoptr] = ACTIONS(503),
    [anon_sym_ptrtoint] = ACTIONS(503),
    [anon_sym_unordered] = ACTIONS(503),
    [anon_sym_monotonic] = ACTIONS(503),
    [anon_sym_acquire] = ACTIONS(503),
    [anon_sym_release] = ACTIONS(503),
    [anon_sym_acq_rel] = ACTIONS(503),
    [anon_sym_seq_cst] = ACTIONS(503),
    [anon_sym_syncscope] = ACTIONS(503),
    [anon_sym_uselistorder] = ACTIONS(503),
  },
  [149] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [sym_label] = ACTIONS(639),
    [sym_string] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_section] = ACTIONS(641),
    [anon_sym_partition] = ACTIONS(641),
    [anon_sym_comdat] = ACTIONS(641),
    [anon_sym_gc] = ACTIONS(641),
    [anon_sym_prefix] = ACTIONS(641),
    [anon_sym_prologue] = ACTIONS(641),
    [anon_sym_personality] = ACTIONS(641),
    [anon_sym_alignstack] = ACTIONS(641),
    [anon_sym_allocsize] = ACTIONS(641),
    [anon_sym_alwaysinline] = ACTIONS(641),
    [anon_sym_builtin] = ACTIONS(641),
    [anon_sym_cold] = ACTIONS(641),
    [anon_sym_convergent] = ACTIONS(641),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(641),
    [anon_sym_hot] = ACTIONS(641),
    [anon_sym_inaccessiblememonly] = ACTIONS(641),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(641),
    [anon_sym_inlinehint] = ACTIONS(641),
    [anon_sym_jumptable] = ACTIONS(641),
    [anon_sym_minsize] = ACTIONS(641),
    [anon_sym_naked] = ACTIONS(641),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(641),
    [anon_sym_nobuiltin] = ACTIONS(641),
    [anon_sym_noduplicate] = ACTIONS(641),
    [anon_sym_nofree] = ACTIONS(641),
    [anon_sym_noimplicitfloat] = ACTIONS(641),
    [anon_sym_noinline] = ACTIONS(641),
    [anon_sym_nomerge] = ACTIONS(641),
    [anon_sym_nonlazybind] = ACTIONS(641),
    [anon_sym_noprofile] = ACTIONS(641),
    [anon_sym_noredzone] = ACTIONS(641),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(641),
    [anon_sym_noreturn] = ACTIONS(641),
    [anon_sym_norecurse] = ACTIONS(641),
    [anon_sym_willreturn] = ACTIONS(641),
    [anon_sym_nosync] = ACTIONS(641),
    [anon_sym_nounwind] = ACTIONS(641),
    [anon_sym_nosanitize_coverage] = ACTIONS(641),
    [anon_sym_null_pointer_is_valid] = ACTIONS(641),
    [anon_sym_optforfuzzing] = ACTIONS(641),
    [anon_sym_optnone] = ACTIONS(641),
    [anon_sym_optsize] = ACTIONS(641),
    [anon_sym_readnone] = ACTIONS(641),
    [anon_sym_readonly] = ACTIONS(641),
    [anon_sym_writeonly] = ACTIONS(641),
    [anon_sym_argmemonly] = ACTIONS(641),
    [anon_sym_returns_twice] = ACTIONS(641),
    [anon_sym_safestack] = ACTIONS(641),
    [anon_sym_sanitize_address] = ACTIONS(641),
    [anon_sym_sanitize_memory] = ACTIONS(641),
    [anon_sym_sanitize_thread] = ACTIONS(641),
    [anon_sym_sanitize_hwaddress] = ACTIONS(641),
    [anon_sym_sanitize_memtag] = ACTIONS(641),
    [anon_sym_speculative_load_hardening] = ACTIONS(641),
    [anon_sym_speculatable] = ACTIONS(641),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(641),
    [anon_sym_sspreq] = ACTIONS(641),
    [anon_sym_strictfp] = ACTIONS(641),
    [anon_sym_uwtable] = ACTIONS(641),
    [anon_sym_nocf_check] = ACTIONS(641),
    [anon_sym_shadowcallstack] = ACTIONS(641),
    [anon_sym_mustprogress] = ACTIONS(641),
    [anon_sym_vscale_range] = ACTIONS(641),
    [anon_sym_preallocated] = ACTIONS(641),
    [anon_sym_zeroext] = ACTIONS(641),
    [anon_sym_signext] = ACTIONS(641),
    [anon_sym_inreg] = ACTIONS(641),
    [anon_sym_byval] = ACTIONS(641),
    [anon_sym_byref] = ACTIONS(641),
    [anon_sym_inalloca] = ACTIONS(641),
    [anon_sym_sret] = ACTIONS(641),
    [anon_sym_elementtype] = ACTIONS(641),
    [anon_sym_noalias] = ACTIONS(641),
    [anon_sym_nocapture] = ACTIONS(641),
    [anon_sym_nest] = ACTIONS(641),
    [anon_sym_returned] = ACTIONS(641),
    [anon_sym_nonnull] = ACTIONS(641),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(641),
    [anon_sym_swiftself] = ACTIONS(641),
    [anon_sym_swiftasync] = ACTIONS(641),
    [anon_sym_swifterror] = ACTIONS(641),
    [anon_sym_immarg] = ACTIONS(641),
    [anon_sym_noundef] = ACTIONS(641),
    [anon_sym_unreachable] = ACTIONS(641),
    [anon_sym_ret] = ACTIONS(641),
    [anon_sym_br] = ACTIONS(641),
    [anon_sym_resume] = ACTIONS(641),
    [anon_sym_freeze] = ACTIONS(641),
    [anon_sym_indirectbr] = ACTIONS(641),
    [anon_sym_extractelement] = ACTIONS(641),
    [anon_sym_insertelement] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_shufflevector] = ACTIONS(641),
    [anon_sym_fneg] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(641),
    [anon_sym_invoke] = ACTIONS(641),
    [anon_sym_cleanupret] = ACTIONS(641),
    [anon_sym_catchret] = ACTIONS(641),
    [anon_sym_catchswitch] = ACTIONS(641),
    [anon_sym_catchpad] = ACTIONS(641),
    [anon_sym_cleanuppad] = ACTIONS(641),
    [anon_sym_callbr] = ACTIONS(641),
    [anon_sym_icmp] = ACTIONS(641),
    [anon_sym_fcmp] = ACTIONS(641),
    [anon_sym_va_arg] = ACTIONS(641),
    [anon_sym_phi] = ACTIONS(641),
    [anon_sym_landingpad] = ACTIONS(641),
    [anon_sym_tail] = ACTIONS(641),
    [anon_sym_musttail] = ACTIONS(641),
    [anon_sym_notail] = ACTIONS(641),
    [anon_sym_call] = ACTIONS(641),
    [anon_sym_alloca] = ACTIONS(641),
    [anon_sym_load] = ACTIONS(641),
    [anon_sym_store] = ACTIONS(641),
    [anon_sym_cmpxchg] = ACTIONS(641),
    [anon_sym_atomicrmw] = ACTIONS(641),
    [anon_sym_fence] = ACTIONS(641),
    [anon_sym_getelementptr] = ACTIONS(641),
    [anon_sym_extractvalue] = ACTIONS(641),
    [anon_sym_insertvalue] = ACTIONS(641),
    [anon_sym_catch] = ACTIONS(641),
    [anon_sym_filter] = ACTIONS(641),
    [anon_sym_mul] = ACTIONS(641),
    [anon_sym_urem] = ACTIONS(641),
    [anon_sym_srem] = ACTIONS(641),
    [anon_sym_shl] = ACTIONS(641),
    [anon_sym_udiv] = ACTIONS(641),
    [anon_sym_sdiv] = ACTIONS(641),
    [anon_sym_lshr] = ACTIONS(641),
    [anon_sym_ashr] = ACTIONS(641),
    [anon_sym_fmul] = ACTIONS(641),
    [anon_sym_fdiv] = ACTIONS(641),
    [anon_sym_frem] = ACTIONS(641),
    [anon_sym_xchg] = ACTIONS(641),
    [anon_sym_add] = ACTIONS(641),
    [anon_sym_sub] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_nand] = ACTIONS(641),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_xor] = ACTIONS(641),
    [anon_sym_max] = ACTIONS(641),
    [anon_sym_min] = ACTIONS(641),
    [anon_sym_umax] = ACTIONS(641),
    [anon_sym_umin] = ACTIONS(641),
    [anon_sym_fadd] = ACTIONS(641),
    [anon_sym_fsub] = ACTIONS(641),
    [anon_sym_bitcast] = ACTIONS(641),
    [anon_sym_trunc] = ACTIONS(641),
    [anon_sym_zext] = ACTIONS(641),
    [anon_sym_sext] = ACTIONS(641),
    [anon_sym_fptrunc] = ACTIONS(641),
    [anon_sym_fpext] = ACTIONS(641),
    [anon_sym_addrspacecast] = ACTIONS(641),
    [anon_sym_uitofp] = ACTIONS(641),
    [anon_sym_sitofp] = ACTIONS(641),
    [anon_sym_fptoui] = ACTIONS(641),
    [anon_sym_fptosi] = ACTIONS(641),
    [anon_sym_inttoptr] = ACTIONS(641),
    [anon_sym_ptrtoint] = ACTIONS(641),
    [anon_sym_unordered] = ACTIONS(641),
    [anon_sym_monotonic] = ACTIONS(641),
    [anon_sym_acquire] = ACTIONS(641),
    [anon_sym_release] = ACTIONS(641),
    [anon_sym_acq_rel] = ACTIONS(641),
    [anon_sym_seq_cst] = ACTIONS(641),
    [anon_sym_syncscope] = ACTIONS(641),
    [anon_sym_uselistorder] = ACTIONS(641),
  },
  [150] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [sym_label] = ACTIONS(643),
    [sym_string] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_section] = ACTIONS(645),
    [anon_sym_partition] = ACTIONS(645),
    [anon_sym_comdat] = ACTIONS(645),
    [anon_sym_gc] = ACTIONS(645),
    [anon_sym_prefix] = ACTIONS(645),
    [anon_sym_prologue] = ACTIONS(645),
    [anon_sym_personality] = ACTIONS(645),
    [anon_sym_alignstack] = ACTIONS(645),
    [anon_sym_allocsize] = ACTIONS(645),
    [anon_sym_alwaysinline] = ACTIONS(645),
    [anon_sym_builtin] = ACTIONS(645),
    [anon_sym_cold] = ACTIONS(645),
    [anon_sym_convergent] = ACTIONS(645),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(645),
    [anon_sym_hot] = ACTIONS(645),
    [anon_sym_inaccessiblememonly] = ACTIONS(645),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(645),
    [anon_sym_inlinehint] = ACTIONS(645),
    [anon_sym_jumptable] = ACTIONS(645),
    [anon_sym_minsize] = ACTIONS(645),
    [anon_sym_naked] = ACTIONS(645),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(645),
    [anon_sym_nobuiltin] = ACTIONS(645),
    [anon_sym_noduplicate] = ACTIONS(645),
    [anon_sym_nofree] = ACTIONS(645),
    [anon_sym_noimplicitfloat] = ACTIONS(645),
    [anon_sym_noinline] = ACTIONS(645),
    [anon_sym_nomerge] = ACTIONS(645),
    [anon_sym_nonlazybind] = ACTIONS(645),
    [anon_sym_noprofile] = ACTIONS(645),
    [anon_sym_noredzone] = ACTIONS(645),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(645),
    [anon_sym_noreturn] = ACTIONS(645),
    [anon_sym_norecurse] = ACTIONS(645),
    [anon_sym_willreturn] = ACTIONS(645),
    [anon_sym_nosync] = ACTIONS(645),
    [anon_sym_nounwind] = ACTIONS(645),
    [anon_sym_nosanitize_coverage] = ACTIONS(645),
    [anon_sym_null_pointer_is_valid] = ACTIONS(645),
    [anon_sym_optforfuzzing] = ACTIONS(645),
    [anon_sym_optnone] = ACTIONS(645),
    [anon_sym_optsize] = ACTIONS(645),
    [anon_sym_readnone] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_writeonly] = ACTIONS(645),
    [anon_sym_argmemonly] = ACTIONS(645),
    [anon_sym_returns_twice] = ACTIONS(645),
    [anon_sym_safestack] = ACTIONS(645),
    [anon_sym_sanitize_address] = ACTIONS(645),
    [anon_sym_sanitize_memory] = ACTIONS(645),
    [anon_sym_sanitize_thread] = ACTIONS(645),
    [anon_sym_sanitize_hwaddress] = ACTIONS(645),
    [anon_sym_sanitize_memtag] = ACTIONS(645),
    [anon_sym_speculative_load_hardening] = ACTIONS(645),
    [anon_sym_speculatable] = ACTIONS(645),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(645),
    [anon_sym_sspreq] = ACTIONS(645),
    [anon_sym_strictfp] = ACTIONS(645),
    [anon_sym_uwtable] = ACTIONS(645),
    [anon_sym_nocf_check] = ACTIONS(645),
    [anon_sym_shadowcallstack] = ACTIONS(645),
    [anon_sym_mustprogress] = ACTIONS(645),
    [anon_sym_vscale_range] = ACTIONS(645),
    [anon_sym_preallocated] = ACTIONS(645),
    [anon_sym_zeroext] = ACTIONS(645),
    [anon_sym_signext] = ACTIONS(645),
    [anon_sym_inreg] = ACTIONS(645),
    [anon_sym_byval] = ACTIONS(645),
    [anon_sym_byref] = ACTIONS(645),
    [anon_sym_inalloca] = ACTIONS(645),
    [anon_sym_sret] = ACTIONS(645),
    [anon_sym_elementtype] = ACTIONS(645),
    [anon_sym_noalias] = ACTIONS(645),
    [anon_sym_nocapture] = ACTIONS(645),
    [anon_sym_nest] = ACTIONS(645),
    [anon_sym_returned] = ACTIONS(645),
    [anon_sym_nonnull] = ACTIONS(645),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(645),
    [anon_sym_swiftself] = ACTIONS(645),
    [anon_sym_swiftasync] = ACTIONS(645),
    [anon_sym_swifterror] = ACTIONS(645),
    [anon_sym_immarg] = ACTIONS(645),
    [anon_sym_noundef] = ACTIONS(645),
    [anon_sym_unreachable] = ACTIONS(645),
    [anon_sym_ret] = ACTIONS(645),
    [anon_sym_br] = ACTIONS(645),
    [anon_sym_resume] = ACTIONS(645),
    [anon_sym_freeze] = ACTIONS(645),
    [anon_sym_indirectbr] = ACTIONS(645),
    [anon_sym_extractelement] = ACTIONS(645),
    [anon_sym_insertelement] = ACTIONS(645),
    [anon_sym_select] = ACTIONS(645),
    [anon_sym_shufflevector] = ACTIONS(645),
    [anon_sym_fneg] = ACTIONS(645),
    [anon_sym_switch] = ACTIONS(645),
    [anon_sym_invoke] = ACTIONS(645),
    [anon_sym_cleanupret] = ACTIONS(645),
    [anon_sym_catchret] = ACTIONS(645),
    [anon_sym_catchswitch] = ACTIONS(645),
    [anon_sym_catchpad] = ACTIONS(645),
    [anon_sym_cleanuppad] = ACTIONS(645),
    [anon_sym_callbr] = ACTIONS(645),
    [anon_sym_icmp] = ACTIONS(645),
    [anon_sym_fcmp] = ACTIONS(645),
    [anon_sym_va_arg] = ACTIONS(645),
    [anon_sym_phi] = ACTIONS(645),
    [anon_sym_landingpad] = ACTIONS(645),
    [anon_sym_tail] = ACTIONS(645),
    [anon_sym_musttail] = ACTIONS(645),
    [anon_sym_notail] = ACTIONS(645),
    [anon_sym_call] = ACTIONS(645),
    [anon_sym_alloca] = ACTIONS(645),
    [anon_sym_load] = ACTIONS(645),
    [anon_sym_store] = ACTIONS(645),
    [anon_sym_cmpxchg] = ACTIONS(645),
    [anon_sym_atomicrmw] = ACTIONS(645),
    [anon_sym_fence] = ACTIONS(645),
    [anon_sym_getelementptr] = ACTIONS(645),
    [anon_sym_extractvalue] = ACTIONS(645),
    [anon_sym_insertvalue] = ACTIONS(645),
    [anon_sym_catch] = ACTIONS(645),
    [anon_sym_filter] = ACTIONS(645),
    [anon_sym_mul] = ACTIONS(645),
    [anon_sym_urem] = ACTIONS(645),
    [anon_sym_srem] = ACTIONS(645),
    [anon_sym_shl] = ACTIONS(645),
    [anon_sym_udiv] = ACTIONS(645),
    [anon_sym_sdiv] = ACTIONS(645),
    [anon_sym_lshr] = ACTIONS(645),
    [anon_sym_ashr] = ACTIONS(645),
    [anon_sym_fmul] = ACTIONS(645),
    [anon_sym_fdiv] = ACTIONS(645),
    [anon_sym_frem] = ACTIONS(645),
    [anon_sym_xchg] = ACTIONS(645),
    [anon_sym_add] = ACTIONS(645),
    [anon_sym_sub] = ACTIONS(645),
    [anon_sym_and] = ACTIONS(645),
    [anon_sym_nand] = ACTIONS(645),
    [anon_sym_or] = ACTIONS(645),
    [anon_sym_xor] = ACTIONS(645),
    [anon_sym_max] = ACTIONS(645),
    [anon_sym_min] = ACTIONS(645),
    [anon_sym_umax] = ACTIONS(645),
    [anon_sym_umin] = ACTIONS(645),
    [anon_sym_fadd] = ACTIONS(645),
    [anon_sym_fsub] = ACTIONS(645),
    [anon_sym_bitcast] = ACTIONS(645),
    [anon_sym_trunc] = ACTIONS(645),
    [anon_sym_zext] = ACTIONS(645),
    [anon_sym_sext] = ACTIONS(645),
    [anon_sym_fptrunc] = ACTIONS(645),
    [anon_sym_fpext] = ACTIONS(645),
    [anon_sym_addrspacecast] = ACTIONS(645),
    [anon_sym_uitofp] = ACTIONS(645),
    [anon_sym_sitofp] = ACTIONS(645),
    [anon_sym_fptoui] = ACTIONS(645),
    [anon_sym_fptosi] = ACTIONS(645),
    [anon_sym_inttoptr] = ACTIONS(645),
    [anon_sym_ptrtoint] = ACTIONS(645),
    [anon_sym_unordered] = ACTIONS(645),
    [anon_sym_monotonic] = ACTIONS(645),
    [anon_sym_acquire] = ACTIONS(645),
    [anon_sym_release] = ACTIONS(645),
    [anon_sym_acq_rel] = ACTIONS(645),
    [anon_sym_seq_cst] = ACTIONS(645),
    [anon_sym_syncscope] = ACTIONS(645),
    [anon_sym_uselistorder] = ACTIONS(645),
  },
  [151] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [sym_label] = ACTIONS(651),
    [sym_string] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_section] = ACTIONS(653),
    [anon_sym_partition] = ACTIONS(653),
    [anon_sym_comdat] = ACTIONS(653),
    [anon_sym_gc] = ACTIONS(653),
    [anon_sym_prefix] = ACTIONS(653),
    [anon_sym_prologue] = ACTIONS(653),
    [anon_sym_personality] = ACTIONS(653),
    [anon_sym_alignstack] = ACTIONS(653),
    [anon_sym_allocsize] = ACTIONS(653),
    [anon_sym_alwaysinline] = ACTIONS(653),
    [anon_sym_builtin] = ACTIONS(653),
    [anon_sym_cold] = ACTIONS(653),
    [anon_sym_convergent] = ACTIONS(653),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(653),
    [anon_sym_hot] = ACTIONS(653),
    [anon_sym_inaccessiblememonly] = ACTIONS(653),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(653),
    [anon_sym_inlinehint] = ACTIONS(653),
    [anon_sym_jumptable] = ACTIONS(653),
    [anon_sym_minsize] = ACTIONS(653),
    [anon_sym_naked] = ACTIONS(653),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(653),
    [anon_sym_nobuiltin] = ACTIONS(653),
    [anon_sym_noduplicate] = ACTIONS(653),
    [anon_sym_nofree] = ACTIONS(653),
    [anon_sym_noimplicitfloat] = ACTIONS(653),
    [anon_sym_noinline] = ACTIONS(653),
    [anon_sym_nomerge] = ACTIONS(653),
    [anon_sym_nonlazybind] = ACTIONS(653),
    [anon_sym_noprofile] = ACTIONS(653),
    [anon_sym_noredzone] = ACTIONS(653),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(653),
    [anon_sym_noreturn] = ACTIONS(653),
    [anon_sym_norecurse] = ACTIONS(653),
    [anon_sym_willreturn] = ACTIONS(653),
    [anon_sym_nosync] = ACTIONS(653),
    [anon_sym_nounwind] = ACTIONS(653),
    [anon_sym_nosanitize_coverage] = ACTIONS(653),
    [anon_sym_null_pointer_is_valid] = ACTIONS(653),
    [anon_sym_optforfuzzing] = ACTIONS(653),
    [anon_sym_optnone] = ACTIONS(653),
    [anon_sym_optsize] = ACTIONS(653),
    [anon_sym_readnone] = ACTIONS(653),
    [anon_sym_readonly] = ACTIONS(653),
    [anon_sym_writeonly] = ACTIONS(653),
    [anon_sym_argmemonly] = ACTIONS(653),
    [anon_sym_returns_twice] = ACTIONS(653),
    [anon_sym_safestack] = ACTIONS(653),
    [anon_sym_sanitize_address] = ACTIONS(653),
    [anon_sym_sanitize_memory] = ACTIONS(653),
    [anon_sym_sanitize_thread] = ACTIONS(653),
    [anon_sym_sanitize_hwaddress] = ACTIONS(653),
    [anon_sym_sanitize_memtag] = ACTIONS(653),
    [anon_sym_speculative_load_hardening] = ACTIONS(653),
    [anon_sym_speculatable] = ACTIONS(653),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(653),
    [anon_sym_sspreq] = ACTIONS(653),
    [anon_sym_strictfp] = ACTIONS(653),
    [anon_sym_uwtable] = ACTIONS(653),
    [anon_sym_nocf_check] = ACTIONS(653),
    [anon_sym_shadowcallstack] = ACTIONS(653),
    [anon_sym_mustprogress] = ACTIONS(653),
    [anon_sym_vscale_range] = ACTIONS(653),
    [anon_sym_preallocated] = ACTIONS(653),
    [anon_sym_zeroext] = ACTIONS(653),
    [anon_sym_signext] = ACTIONS(653),
    [anon_sym_inreg] = ACTIONS(653),
    [anon_sym_byval] = ACTIONS(653),
    [anon_sym_byref] = ACTIONS(653),
    [anon_sym_inalloca] = ACTIONS(653),
    [anon_sym_sret] = ACTIONS(653),
    [anon_sym_elementtype] = ACTIONS(653),
    [anon_sym_noalias] = ACTIONS(653),
    [anon_sym_nocapture] = ACTIONS(653),
    [anon_sym_nest] = ACTIONS(653),
    [anon_sym_returned] = ACTIONS(653),
    [anon_sym_nonnull] = ACTIONS(653),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(653),
    [anon_sym_swiftself] = ACTIONS(653),
    [anon_sym_swiftasync] = ACTIONS(653),
    [anon_sym_swifterror] = ACTIONS(653),
    [anon_sym_immarg] = ACTIONS(653),
    [anon_sym_noundef] = ACTIONS(653),
    [anon_sym_unreachable] = ACTIONS(653),
    [anon_sym_ret] = ACTIONS(653),
    [anon_sym_br] = ACTIONS(653),
    [anon_sym_resume] = ACTIONS(653),
    [anon_sym_freeze] = ACTIONS(653),
    [anon_sym_indirectbr] = ACTIONS(653),
    [anon_sym_extractelement] = ACTIONS(653),
    [anon_sym_insertelement] = ACTIONS(653),
    [anon_sym_select] = ACTIONS(653),
    [anon_sym_shufflevector] = ACTIONS(653),
    [anon_sym_fneg] = ACTIONS(653),
    [anon_sym_switch] = ACTIONS(653),
    [anon_sym_invoke] = ACTIONS(653),
    [anon_sym_cleanupret] = ACTIONS(653),
    [anon_sym_catchret] = ACTIONS(653),
    [anon_sym_catchswitch] = ACTIONS(653),
    [anon_sym_catchpad] = ACTIONS(653),
    [anon_sym_cleanuppad] = ACTIONS(653),
    [anon_sym_callbr] = ACTIONS(653),
    [anon_sym_icmp] = ACTIONS(653),
    [anon_sym_fcmp] = ACTIONS(653),
    [anon_sym_va_arg] = ACTIONS(653),
    [anon_sym_phi] = ACTIONS(653),
    [anon_sym_landingpad] = ACTIONS(653),
    [anon_sym_tail] = ACTIONS(653),
    [anon_sym_musttail] = ACTIONS(653),
    [anon_sym_notail] = ACTIONS(653),
    [anon_sym_call] = ACTIONS(653),
    [anon_sym_alloca] = ACTIONS(653),
    [anon_sym_load] = ACTIONS(653),
    [anon_sym_store] = ACTIONS(653),
    [anon_sym_cmpxchg] = ACTIONS(653),
    [anon_sym_atomicrmw] = ACTIONS(653),
    [anon_sym_fence] = ACTIONS(653),
    [anon_sym_getelementptr] = ACTIONS(653),
    [anon_sym_extractvalue] = ACTIONS(653),
    [anon_sym_insertvalue] = ACTIONS(653),
    [anon_sym_catch] = ACTIONS(653),
    [anon_sym_filter] = ACTIONS(653),
    [anon_sym_mul] = ACTIONS(653),
    [anon_sym_urem] = ACTIONS(653),
    [anon_sym_srem] = ACTIONS(653),
    [anon_sym_shl] = ACTIONS(653),
    [anon_sym_udiv] = ACTIONS(653),
    [anon_sym_sdiv] = ACTIONS(653),
    [anon_sym_lshr] = ACTIONS(653),
    [anon_sym_ashr] = ACTIONS(653),
    [anon_sym_fmul] = ACTIONS(653),
    [anon_sym_fdiv] = ACTIONS(653),
    [anon_sym_frem] = ACTIONS(653),
    [anon_sym_xchg] = ACTIONS(653),
    [anon_sym_add] = ACTIONS(653),
    [anon_sym_sub] = ACTIONS(653),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_nand] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(653),
    [anon_sym_xor] = ACTIONS(653),
    [anon_sym_max] = ACTIONS(653),
    [anon_sym_min] = ACTIONS(653),
    [anon_sym_umax] = ACTIONS(653),
    [anon_sym_umin] = ACTIONS(653),
    [anon_sym_fadd] = ACTIONS(653),
    [anon_sym_fsub] = ACTIONS(653),
    [anon_sym_bitcast] = ACTIONS(653),
    [anon_sym_trunc] = ACTIONS(653),
    [anon_sym_zext] = ACTIONS(653),
    [anon_sym_sext] = ACTIONS(653),
    [anon_sym_fptrunc] = ACTIONS(653),
    [anon_sym_fpext] = ACTIONS(653),
    [anon_sym_addrspacecast] = ACTIONS(653),
    [anon_sym_uitofp] = ACTIONS(653),
    [anon_sym_sitofp] = ACTIONS(653),
    [anon_sym_fptoui] = ACTIONS(653),
    [anon_sym_fptosi] = ACTIONS(653),
    [anon_sym_inttoptr] = ACTIONS(653),
    [anon_sym_ptrtoint] = ACTIONS(653),
    [anon_sym_unordered] = ACTIONS(653),
    [anon_sym_monotonic] = ACTIONS(653),
    [anon_sym_acquire] = ACTIONS(653),
    [anon_sym_release] = ACTIONS(653),
    [anon_sym_acq_rel] = ACTIONS(653),
    [anon_sym_seq_cst] = ACTIONS(653),
    [anon_sym_syncscope] = ACTIONS(653),
    [anon_sym_uselistorder] = ACTIONS(653),
  },
  [152] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [sym_label] = ACTIONS(647),
    [sym_string] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_section] = ACTIONS(649),
    [anon_sym_partition] = ACTIONS(649),
    [anon_sym_comdat] = ACTIONS(649),
    [anon_sym_gc] = ACTIONS(649),
    [anon_sym_prefix] = ACTIONS(649),
    [anon_sym_prologue] = ACTIONS(649),
    [anon_sym_personality] = ACTIONS(649),
    [anon_sym_alignstack] = ACTIONS(649),
    [anon_sym_allocsize] = ACTIONS(649),
    [anon_sym_alwaysinline] = ACTIONS(649),
    [anon_sym_builtin] = ACTIONS(649),
    [anon_sym_cold] = ACTIONS(649),
    [anon_sym_convergent] = ACTIONS(649),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(649),
    [anon_sym_hot] = ACTIONS(649),
    [anon_sym_inaccessiblememonly] = ACTIONS(649),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(649),
    [anon_sym_inlinehint] = ACTIONS(649),
    [anon_sym_jumptable] = ACTIONS(649),
    [anon_sym_minsize] = ACTIONS(649),
    [anon_sym_naked] = ACTIONS(649),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(649),
    [anon_sym_nobuiltin] = ACTIONS(649),
    [anon_sym_noduplicate] = ACTIONS(649),
    [anon_sym_nofree] = ACTIONS(649),
    [anon_sym_noimplicitfloat] = ACTIONS(649),
    [anon_sym_noinline] = ACTIONS(649),
    [anon_sym_nomerge] = ACTIONS(649),
    [anon_sym_nonlazybind] = ACTIONS(649),
    [anon_sym_noprofile] = ACTIONS(649),
    [anon_sym_noredzone] = ACTIONS(649),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(649),
    [anon_sym_noreturn] = ACTIONS(649),
    [anon_sym_norecurse] = ACTIONS(649),
    [anon_sym_willreturn] = ACTIONS(649),
    [anon_sym_nosync] = ACTIONS(649),
    [anon_sym_nounwind] = ACTIONS(649),
    [anon_sym_nosanitize_coverage] = ACTIONS(649),
    [anon_sym_null_pointer_is_valid] = ACTIONS(649),
    [anon_sym_optforfuzzing] = ACTIONS(649),
    [anon_sym_optnone] = ACTIONS(649),
    [anon_sym_optsize] = ACTIONS(649),
    [anon_sym_readnone] = ACTIONS(649),
    [anon_sym_readonly] = ACTIONS(649),
    [anon_sym_writeonly] = ACTIONS(649),
    [anon_sym_argmemonly] = ACTIONS(649),
    [anon_sym_returns_twice] = ACTIONS(649),
    [anon_sym_safestack] = ACTIONS(649),
    [anon_sym_sanitize_address] = ACTIONS(649),
    [anon_sym_sanitize_memory] = ACTIONS(649),
    [anon_sym_sanitize_thread] = ACTIONS(649),
    [anon_sym_sanitize_hwaddress] = ACTIONS(649),
    [anon_sym_sanitize_memtag] = ACTIONS(649),
    [anon_sym_speculative_load_hardening] = ACTIONS(649),
    [anon_sym_speculatable] = ACTIONS(649),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(649),
    [anon_sym_sspreq] = ACTIONS(649),
    [anon_sym_strictfp] = ACTIONS(649),
    [anon_sym_uwtable] = ACTIONS(649),
    [anon_sym_nocf_check] = ACTIONS(649),
    [anon_sym_shadowcallstack] = ACTIONS(649),
    [anon_sym_mustprogress] = ACTIONS(649),
    [anon_sym_vscale_range] = ACTIONS(649),
    [anon_sym_preallocated] = ACTIONS(649),
    [anon_sym_zeroext] = ACTIONS(649),
    [anon_sym_signext] = ACTIONS(649),
    [anon_sym_inreg] = ACTIONS(649),
    [anon_sym_byval] = ACTIONS(649),
    [anon_sym_byref] = ACTIONS(649),
    [anon_sym_inalloca] = ACTIONS(649),
    [anon_sym_sret] = ACTIONS(649),
    [anon_sym_elementtype] = ACTIONS(649),
    [anon_sym_noalias] = ACTIONS(649),
    [anon_sym_nocapture] = ACTIONS(649),
    [anon_sym_nest] = ACTIONS(649),
    [anon_sym_returned] = ACTIONS(649),
    [anon_sym_nonnull] = ACTIONS(649),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(649),
    [anon_sym_swiftself] = ACTIONS(649),
    [anon_sym_swiftasync] = ACTIONS(649),
    [anon_sym_swifterror] = ACTIONS(649),
    [anon_sym_immarg] = ACTIONS(649),
    [anon_sym_noundef] = ACTIONS(649),
    [anon_sym_unreachable] = ACTIONS(649),
    [anon_sym_ret] = ACTIONS(649),
    [anon_sym_br] = ACTIONS(649),
    [anon_sym_resume] = ACTIONS(649),
    [anon_sym_freeze] = ACTIONS(649),
    [anon_sym_indirectbr] = ACTIONS(649),
    [anon_sym_extractelement] = ACTIONS(649),
    [anon_sym_insertelement] = ACTIONS(649),
    [anon_sym_select] = ACTIONS(649),
    [anon_sym_shufflevector] = ACTIONS(649),
    [anon_sym_fneg] = ACTIONS(649),
    [anon_sym_switch] = ACTIONS(649),
    [anon_sym_invoke] = ACTIONS(649),
    [anon_sym_cleanupret] = ACTIONS(649),
    [anon_sym_catchret] = ACTIONS(649),
    [anon_sym_catchswitch] = ACTIONS(649),
    [anon_sym_catchpad] = ACTIONS(649),
    [anon_sym_cleanuppad] = ACTIONS(649),
    [anon_sym_callbr] = ACTIONS(649),
    [anon_sym_icmp] = ACTIONS(649),
    [anon_sym_fcmp] = ACTIONS(649),
    [anon_sym_va_arg] = ACTIONS(649),
    [anon_sym_phi] = ACTIONS(649),
    [anon_sym_landingpad] = ACTIONS(649),
    [anon_sym_tail] = ACTIONS(649),
    [anon_sym_musttail] = ACTIONS(649),
    [anon_sym_notail] = ACTIONS(649),
    [anon_sym_call] = ACTIONS(649),
    [anon_sym_alloca] = ACTIONS(649),
    [anon_sym_load] = ACTIONS(649),
    [anon_sym_store] = ACTIONS(649),
    [anon_sym_cmpxchg] = ACTIONS(649),
    [anon_sym_atomicrmw] = ACTIONS(649),
    [anon_sym_fence] = ACTIONS(649),
    [anon_sym_getelementptr] = ACTIONS(649),
    [anon_sym_extractvalue] = ACTIONS(649),
    [anon_sym_insertvalue] = ACTIONS(649),
    [anon_sym_catch] = ACTIONS(649),
    [anon_sym_filter] = ACTIONS(649),
    [anon_sym_mul] = ACTIONS(649),
    [anon_sym_urem] = ACTIONS(649),
    [anon_sym_srem] = ACTIONS(649),
    [anon_sym_shl] = ACTIONS(649),
    [anon_sym_udiv] = ACTIONS(649),
    [anon_sym_sdiv] = ACTIONS(649),
    [anon_sym_lshr] = ACTIONS(649),
    [anon_sym_ashr] = ACTIONS(649),
    [anon_sym_fmul] = ACTIONS(649),
    [anon_sym_fdiv] = ACTIONS(649),
    [anon_sym_frem] = ACTIONS(649),
    [anon_sym_xchg] = ACTIONS(649),
    [anon_sym_add] = ACTIONS(649),
    [anon_sym_sub] = ACTIONS(649),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_nand] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(649),
    [anon_sym_xor] = ACTIONS(649),
    [anon_sym_max] = ACTIONS(649),
    [anon_sym_min] = ACTIONS(649),
    [anon_sym_umax] = ACTIONS(649),
    [anon_sym_umin] = ACTIONS(649),
    [anon_sym_fadd] = ACTIONS(649),
    [anon_sym_fsub] = ACTIONS(649),
    [anon_sym_bitcast] = ACTIONS(649),
    [anon_sym_trunc] = ACTIONS(649),
    [anon_sym_zext] = ACTIONS(649),
    [anon_sym_sext] = ACTIONS(649),
    [anon_sym_fptrunc] = ACTIONS(649),
    [anon_sym_fpext] = ACTIONS(649),
    [anon_sym_addrspacecast] = ACTIONS(649),
    [anon_sym_uitofp] = ACTIONS(649),
    [anon_sym_sitofp] = ACTIONS(649),
    [anon_sym_fptoui] = ACTIONS(649),
    [anon_sym_fptosi] = ACTIONS(649),
    [anon_sym_inttoptr] = ACTIONS(649),
    [anon_sym_ptrtoint] = ACTIONS(649),
    [anon_sym_unordered] = ACTIONS(649),
    [anon_sym_monotonic] = ACTIONS(649),
    [anon_sym_acquire] = ACTIONS(649),
    [anon_sym_release] = ACTIONS(649),
    [anon_sym_acq_rel] = ACTIONS(649),
    [anon_sym_seq_cst] = ACTIONS(649),
    [anon_sym_syncscope] = ACTIONS(649),
    [anon_sym_uselistorder] = ACTIONS(649),
  },
  [153] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [sym_label] = ACTIONS(631),
    [sym_string] = ACTIONS(633),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_section] = ACTIONS(633),
    [anon_sym_partition] = ACTIONS(633),
    [anon_sym_comdat] = ACTIONS(633),
    [anon_sym_gc] = ACTIONS(633),
    [anon_sym_prefix] = ACTIONS(633),
    [anon_sym_prologue] = ACTIONS(633),
    [anon_sym_personality] = ACTIONS(633),
    [anon_sym_alignstack] = ACTIONS(633),
    [anon_sym_allocsize] = ACTIONS(633),
    [anon_sym_alwaysinline] = ACTIONS(633),
    [anon_sym_builtin] = ACTIONS(633),
    [anon_sym_cold] = ACTIONS(633),
    [anon_sym_convergent] = ACTIONS(633),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(633),
    [anon_sym_hot] = ACTIONS(633),
    [anon_sym_inaccessiblememonly] = ACTIONS(633),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(633),
    [anon_sym_inlinehint] = ACTIONS(633),
    [anon_sym_jumptable] = ACTIONS(633),
    [anon_sym_minsize] = ACTIONS(633),
    [anon_sym_naked] = ACTIONS(633),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(633),
    [anon_sym_nobuiltin] = ACTIONS(633),
    [anon_sym_noduplicate] = ACTIONS(633),
    [anon_sym_nofree] = ACTIONS(633),
    [anon_sym_noimplicitfloat] = ACTIONS(633),
    [anon_sym_noinline] = ACTIONS(633),
    [anon_sym_nomerge] = ACTIONS(633),
    [anon_sym_nonlazybind] = ACTIONS(633),
    [anon_sym_noprofile] = ACTIONS(633),
    [anon_sym_noredzone] = ACTIONS(633),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(633),
    [anon_sym_noreturn] = ACTIONS(633),
    [anon_sym_norecurse] = ACTIONS(633),
    [anon_sym_willreturn] = ACTIONS(633),
    [anon_sym_nosync] = ACTIONS(633),
    [anon_sym_nounwind] = ACTIONS(633),
    [anon_sym_nosanitize_coverage] = ACTIONS(633),
    [anon_sym_null_pointer_is_valid] = ACTIONS(633),
    [anon_sym_optforfuzzing] = ACTIONS(633),
    [anon_sym_optnone] = ACTIONS(633),
    [anon_sym_optsize] = ACTIONS(633),
    [anon_sym_readnone] = ACTIONS(633),
    [anon_sym_readonly] = ACTIONS(633),
    [anon_sym_writeonly] = ACTIONS(633),
    [anon_sym_argmemonly] = ACTIONS(633),
    [anon_sym_returns_twice] = ACTIONS(633),
    [anon_sym_safestack] = ACTIONS(633),
    [anon_sym_sanitize_address] = ACTIONS(633),
    [anon_sym_sanitize_memory] = ACTIONS(633),
    [anon_sym_sanitize_thread] = ACTIONS(633),
    [anon_sym_sanitize_hwaddress] = ACTIONS(633),
    [anon_sym_sanitize_memtag] = ACTIONS(633),
    [anon_sym_speculative_load_hardening] = ACTIONS(633),
    [anon_sym_speculatable] = ACTIONS(633),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(633),
    [anon_sym_sspreq] = ACTIONS(633),
    [anon_sym_strictfp] = ACTIONS(633),
    [anon_sym_uwtable] = ACTIONS(633),
    [anon_sym_nocf_check] = ACTIONS(633),
    [anon_sym_shadowcallstack] = ACTIONS(633),
    [anon_sym_mustprogress] = ACTIONS(633),
    [anon_sym_vscale_range] = ACTIONS(633),
    [anon_sym_preallocated] = ACTIONS(633),
    [anon_sym_zeroext] = ACTIONS(633),
    [anon_sym_signext] = ACTIONS(633),
    [anon_sym_inreg] = ACTIONS(633),
    [anon_sym_byval] = ACTIONS(633),
    [anon_sym_byref] = ACTIONS(633),
    [anon_sym_inalloca] = ACTIONS(633),
    [anon_sym_sret] = ACTIONS(633),
    [anon_sym_elementtype] = ACTIONS(633),
    [anon_sym_noalias] = ACTIONS(633),
    [anon_sym_nocapture] = ACTIONS(633),
    [anon_sym_nest] = ACTIONS(633),
    [anon_sym_returned] = ACTIONS(633),
    [anon_sym_nonnull] = ACTIONS(633),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(633),
    [anon_sym_swiftself] = ACTIONS(633),
    [anon_sym_swiftasync] = ACTIONS(633),
    [anon_sym_swifterror] = ACTIONS(633),
    [anon_sym_immarg] = ACTIONS(633),
    [anon_sym_noundef] = ACTIONS(633),
    [anon_sym_unreachable] = ACTIONS(633),
    [anon_sym_ret] = ACTIONS(633),
    [anon_sym_br] = ACTIONS(633),
    [anon_sym_resume] = ACTIONS(633),
    [anon_sym_freeze] = ACTIONS(633),
    [anon_sym_indirectbr] = ACTIONS(633),
    [anon_sym_extractelement] = ACTIONS(633),
    [anon_sym_insertelement] = ACTIONS(633),
    [anon_sym_select] = ACTIONS(633),
    [anon_sym_shufflevector] = ACTIONS(633),
    [anon_sym_fneg] = ACTIONS(633),
    [anon_sym_switch] = ACTIONS(633),
    [anon_sym_invoke] = ACTIONS(633),
    [anon_sym_cleanupret] = ACTIONS(633),
    [anon_sym_catchret] = ACTIONS(633),
    [anon_sym_catchswitch] = ACTIONS(633),
    [anon_sym_catchpad] = ACTIONS(633),
    [anon_sym_cleanuppad] = ACTIONS(633),
    [anon_sym_callbr] = ACTIONS(633),
    [anon_sym_icmp] = ACTIONS(633),
    [anon_sym_fcmp] = ACTIONS(633),
    [anon_sym_va_arg] = ACTIONS(633),
    [anon_sym_phi] = ACTIONS(633),
    [anon_sym_landingpad] = ACTIONS(633),
    [anon_sym_tail] = ACTIONS(633),
    [anon_sym_musttail] = ACTIONS(633),
    [anon_sym_notail] = ACTIONS(633),
    [anon_sym_call] = ACTIONS(633),
    [anon_sym_alloca] = ACTIONS(633),
    [anon_sym_load] = ACTIONS(633),
    [anon_sym_store] = ACTIONS(633),
    [anon_sym_cmpxchg] = ACTIONS(633),
    [anon_sym_atomicrmw] = ACTIONS(633),
    [anon_sym_fence] = ACTIONS(633),
    [anon_sym_getelementptr] = ACTIONS(633),
    [anon_sym_extractvalue] = ACTIONS(633),
    [anon_sym_insertvalue] = ACTIONS(633),
    [anon_sym_catch] = ACTIONS(633),
    [anon_sym_filter] = ACTIONS(633),
    [anon_sym_mul] = ACTIONS(633),
    [anon_sym_urem] = ACTIONS(633),
    [anon_sym_srem] = ACTIONS(633),
    [anon_sym_shl] = ACTIONS(633),
    [anon_sym_udiv] = ACTIONS(633),
    [anon_sym_sdiv] = ACTIONS(633),
    [anon_sym_lshr] = ACTIONS(633),
    [anon_sym_ashr] = ACTIONS(633),
    [anon_sym_fmul] = ACTIONS(633),
    [anon_sym_fdiv] = ACTIONS(633),
    [anon_sym_frem] = ACTIONS(633),
    [anon_sym_xchg] = ACTIONS(633),
    [anon_sym_add] = ACTIONS(633),
    [anon_sym_sub] = ACTIONS(633),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_nand] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(633),
    [anon_sym_xor] = ACTIONS(633),
    [anon_sym_max] = ACTIONS(633),
    [anon_sym_min] = ACTIONS(633),
    [anon_sym_umax] = ACTIONS(633),
    [anon_sym_umin] = ACTIONS(633),
    [anon_sym_fadd] = ACTIONS(633),
    [anon_sym_fsub] = ACTIONS(633),
    [anon_sym_bitcast] = ACTIONS(633),
    [anon_sym_trunc] = ACTIONS(633),
    [anon_sym_zext] = ACTIONS(633),
    [anon_sym_sext] = ACTIONS(633),
    [anon_sym_fptrunc] = ACTIONS(633),
    [anon_sym_fpext] = ACTIONS(633),
    [anon_sym_addrspacecast] = ACTIONS(633),
    [anon_sym_uitofp] = ACTIONS(633),
    [anon_sym_sitofp] = ACTIONS(633),
    [anon_sym_fptoui] = ACTIONS(633),
    [anon_sym_fptosi] = ACTIONS(633),
    [anon_sym_inttoptr] = ACTIONS(633),
    [anon_sym_ptrtoint] = ACTIONS(633),
    [anon_sym_unordered] = ACTIONS(633),
    [anon_sym_monotonic] = ACTIONS(633),
    [anon_sym_acquire] = ACTIONS(633),
    [anon_sym_release] = ACTIONS(633),
    [anon_sym_acq_rel] = ACTIONS(633),
    [anon_sym_seq_cst] = ACTIONS(633),
    [anon_sym_syncscope] = ACTIONS(633),
    [anon_sym_uselistorder] = ACTIONS(633),
  },
  [154] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(581),
    [sym_local_var] = ACTIONS(581),
    [sym_label] = ACTIONS(581),
    [sym_string] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(581),
    [anon_sym_align] = ACTIONS(583),
    [anon_sym_section] = ACTIONS(583),
    [anon_sym_partition] = ACTIONS(583),
    [anon_sym_comdat] = ACTIONS(583),
    [anon_sym_gc] = ACTIONS(583),
    [anon_sym_prefix] = ACTIONS(583),
    [anon_sym_prologue] = ACTIONS(583),
    [anon_sym_personality] = ACTIONS(583),
    [anon_sym_alignstack] = ACTIONS(583),
    [anon_sym_allocsize] = ACTIONS(583),
    [anon_sym_alwaysinline] = ACTIONS(583),
    [anon_sym_builtin] = ACTIONS(583),
    [anon_sym_cold] = ACTIONS(583),
    [anon_sym_convergent] = ACTIONS(583),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(583),
    [anon_sym_hot] = ACTIONS(583),
    [anon_sym_inaccessiblememonly] = ACTIONS(583),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(583),
    [anon_sym_inlinehint] = ACTIONS(583),
    [anon_sym_jumptable] = ACTIONS(583),
    [anon_sym_minsize] = ACTIONS(583),
    [anon_sym_naked] = ACTIONS(583),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(583),
    [anon_sym_nobuiltin] = ACTIONS(583),
    [anon_sym_noduplicate] = ACTIONS(583),
    [anon_sym_nofree] = ACTIONS(583),
    [anon_sym_noimplicitfloat] = ACTIONS(583),
    [anon_sym_noinline] = ACTIONS(583),
    [anon_sym_nomerge] = ACTIONS(583),
    [anon_sym_nonlazybind] = ACTIONS(583),
    [anon_sym_noprofile] = ACTIONS(583),
    [anon_sym_noredzone] = ACTIONS(583),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(583),
    [anon_sym_noreturn] = ACTIONS(583),
    [anon_sym_norecurse] = ACTIONS(583),
    [anon_sym_willreturn] = ACTIONS(583),
    [anon_sym_nosync] = ACTIONS(583),
    [anon_sym_nounwind] = ACTIONS(583),
    [anon_sym_nosanitize_coverage] = ACTIONS(583),
    [anon_sym_null_pointer_is_valid] = ACTIONS(583),
    [anon_sym_optforfuzzing] = ACTIONS(583),
    [anon_sym_optnone] = ACTIONS(583),
    [anon_sym_optsize] = ACTIONS(583),
    [anon_sym_readnone] = ACTIONS(583),
    [anon_sym_readonly] = ACTIONS(583),
    [anon_sym_writeonly] = ACTIONS(583),
    [anon_sym_argmemonly] = ACTIONS(583),
    [anon_sym_returns_twice] = ACTIONS(583),
    [anon_sym_safestack] = ACTIONS(583),
    [anon_sym_sanitize_address] = ACTIONS(583),
    [anon_sym_sanitize_memory] = ACTIONS(583),
    [anon_sym_sanitize_thread] = ACTIONS(583),
    [anon_sym_sanitize_hwaddress] = ACTIONS(583),
    [anon_sym_sanitize_memtag] = ACTIONS(583),
    [anon_sym_speculative_load_hardening] = ACTIONS(583),
    [anon_sym_speculatable] = ACTIONS(583),
    [anon_sym_ssp] = ACTIONS(583),
    [anon_sym_sspstrong] = ACTIONS(583),
    [anon_sym_sspreq] = ACTIONS(583),
    [anon_sym_strictfp] = ACTIONS(583),
    [anon_sym_uwtable] = ACTIONS(583),
    [anon_sym_nocf_check] = ACTIONS(583),
    [anon_sym_shadowcallstack] = ACTIONS(583),
    [anon_sym_mustprogress] = ACTIONS(583),
    [anon_sym_vscale_range] = ACTIONS(583),
    [anon_sym_preallocated] = ACTIONS(583),
    [anon_sym_zeroext] = ACTIONS(583),
    [anon_sym_signext] = ACTIONS(583),
    [anon_sym_inreg] = ACTIONS(583),
    [anon_sym_byval] = ACTIONS(583),
    [anon_sym_byref] = ACTIONS(583),
    [anon_sym_inalloca] = ACTIONS(583),
    [anon_sym_sret] = ACTIONS(583),
    [anon_sym_elementtype] = ACTIONS(583),
    [anon_sym_noalias] = ACTIONS(583),
    [anon_sym_nocapture] = ACTIONS(583),
    [anon_sym_nest] = ACTIONS(583),
    [anon_sym_returned] = ACTIONS(583),
    [anon_sym_nonnull] = ACTIONS(583),
    [anon_sym_dereferenceable] = ACTIONS(583),
    [anon_sym_dereferenceable_or_null] = ACTIONS(583),
    [anon_sym_swiftself] = ACTIONS(583),
    [anon_sym_swiftasync] = ACTIONS(583),
    [anon_sym_swifterror] = ACTIONS(583),
    [anon_sym_immarg] = ACTIONS(583),
    [anon_sym_noundef] = ACTIONS(583),
    [anon_sym_unreachable] = ACTIONS(583),
    [anon_sym_ret] = ACTIONS(583),
    [anon_sym_br] = ACTIONS(583),
    [anon_sym_resume] = ACTIONS(583),
    [anon_sym_freeze] = ACTIONS(583),
    [anon_sym_indirectbr] = ACTIONS(583),
    [anon_sym_extractelement] = ACTIONS(583),
    [anon_sym_insertelement] = ACTIONS(583),
    [anon_sym_select] = ACTIONS(583),
    [anon_sym_shufflevector] = ACTIONS(583),
    [anon_sym_fneg] = ACTIONS(583),
    [anon_sym_switch] = ACTIONS(583),
    [anon_sym_invoke] = ACTIONS(583),
    [anon_sym_cleanupret] = ACTIONS(583),
    [anon_sym_catchret] = ACTIONS(583),
    [anon_sym_catchswitch] = ACTIONS(583),
    [anon_sym_catchpad] = ACTIONS(583),
    [anon_sym_cleanuppad] = ACTIONS(583),
    [anon_sym_callbr] = ACTIONS(583),
    [anon_sym_icmp] = ACTIONS(583),
    [anon_sym_fcmp] = ACTIONS(583),
    [anon_sym_va_arg] = ACTIONS(583),
    [anon_sym_phi] = ACTIONS(583),
    [anon_sym_landingpad] = ACTIONS(583),
    [anon_sym_tail] = ACTIONS(583),
    [anon_sym_musttail] = ACTIONS(583),
    [anon_sym_notail] = ACTIONS(583),
    [anon_sym_call] = ACTIONS(583),
    [anon_sym_alloca] = ACTIONS(583),
    [anon_sym_load] = ACTIONS(583),
    [anon_sym_store] = ACTIONS(583),
    [anon_sym_cmpxchg] = ACTIONS(583),
    [anon_sym_atomicrmw] = ACTIONS(583),
    [anon_sym_fence] = ACTIONS(583),
    [anon_sym_getelementptr] = ACTIONS(583),
    [anon_sym_extractvalue] = ACTIONS(583),
    [anon_sym_insertvalue] = ACTIONS(583),
    [anon_sym_catch] = ACTIONS(583),
    [anon_sym_filter] = ACTIONS(583),
    [anon_sym_mul] = ACTIONS(583),
    [anon_sym_urem] = ACTIONS(583),
    [anon_sym_srem] = ACTIONS(583),
    [anon_sym_shl] = ACTIONS(583),
    [anon_sym_udiv] = ACTIONS(583),
    [anon_sym_sdiv] = ACTIONS(583),
    [anon_sym_lshr] = ACTIONS(583),
    [anon_sym_ashr] = ACTIONS(583),
    [anon_sym_fmul] = ACTIONS(583),
    [anon_sym_fdiv] = ACTIONS(583),
    [anon_sym_frem] = ACTIONS(583),
    [anon_sym_xchg] = ACTIONS(583),
    [anon_sym_add] = ACTIONS(583),
    [anon_sym_sub] = ACTIONS(583),
    [anon_sym_and] = ACTIONS(583),
    [anon_sym_nand] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(583),
    [anon_sym_xor] = ACTIONS(583),
    [anon_sym_max] = ACTIONS(583),
    [anon_sym_min] = ACTIONS(583),
    [anon_sym_umax] = ACTIONS(583),
    [anon_sym_umin] = ACTIONS(583),
    [anon_sym_fadd] = ACTIONS(583),
    [anon_sym_fsub] = ACTIONS(583),
    [anon_sym_bitcast] = ACTIONS(583),
    [anon_sym_trunc] = ACTIONS(583),
    [anon_sym_zext] = ACTIONS(583),
    [anon_sym_sext] = ACTIONS(583),
    [anon_sym_fptrunc] = ACTIONS(583),
    [anon_sym_fpext] = ACTIONS(583),
    [anon_sym_addrspacecast] = ACTIONS(583),
    [anon_sym_uitofp] = ACTIONS(583),
    [anon_sym_sitofp] = ACTIONS(583),
    [anon_sym_fptoui] = ACTIONS(583),
    [anon_sym_fptosi] = ACTIONS(583),
    [anon_sym_inttoptr] = ACTIONS(583),
    [anon_sym_ptrtoint] = ACTIONS(583),
    [anon_sym_unordered] = ACTIONS(583),
    [anon_sym_monotonic] = ACTIONS(583),
    [anon_sym_acquire] = ACTIONS(583),
    [anon_sym_release] = ACTIONS(583),
    [anon_sym_acq_rel] = ACTIONS(583),
    [anon_sym_seq_cst] = ACTIONS(583),
    [anon_sym_syncscope] = ACTIONS(583),
    [anon_sym_uselistorder] = ACTIONS(583),
  },
  [155] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [sym_label] = ACTIONS(565),
    [sym_string] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_section] = ACTIONS(567),
    [anon_sym_partition] = ACTIONS(567),
    [anon_sym_comdat] = ACTIONS(567),
    [anon_sym_gc] = ACTIONS(567),
    [anon_sym_prefix] = ACTIONS(567),
    [anon_sym_prologue] = ACTIONS(567),
    [anon_sym_personality] = ACTIONS(567),
    [anon_sym_alignstack] = ACTIONS(567),
    [anon_sym_allocsize] = ACTIONS(567),
    [anon_sym_alwaysinline] = ACTIONS(567),
    [anon_sym_builtin] = ACTIONS(567),
    [anon_sym_cold] = ACTIONS(567),
    [anon_sym_convergent] = ACTIONS(567),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(567),
    [anon_sym_hot] = ACTIONS(567),
    [anon_sym_inaccessiblememonly] = ACTIONS(567),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(567),
    [anon_sym_inlinehint] = ACTIONS(567),
    [anon_sym_jumptable] = ACTIONS(567),
    [anon_sym_minsize] = ACTIONS(567),
    [anon_sym_naked] = ACTIONS(567),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(567),
    [anon_sym_nobuiltin] = ACTIONS(567),
    [anon_sym_noduplicate] = ACTIONS(567),
    [anon_sym_nofree] = ACTIONS(567),
    [anon_sym_noimplicitfloat] = ACTIONS(567),
    [anon_sym_noinline] = ACTIONS(567),
    [anon_sym_nomerge] = ACTIONS(567),
    [anon_sym_nonlazybind] = ACTIONS(567),
    [anon_sym_noprofile] = ACTIONS(567),
    [anon_sym_noredzone] = ACTIONS(567),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(567),
    [anon_sym_noreturn] = ACTIONS(567),
    [anon_sym_norecurse] = ACTIONS(567),
    [anon_sym_willreturn] = ACTIONS(567),
    [anon_sym_nosync] = ACTIONS(567),
    [anon_sym_nounwind] = ACTIONS(567),
    [anon_sym_nosanitize_coverage] = ACTIONS(567),
    [anon_sym_null_pointer_is_valid] = ACTIONS(567),
    [anon_sym_optforfuzzing] = ACTIONS(567),
    [anon_sym_optnone] = ACTIONS(567),
    [anon_sym_optsize] = ACTIONS(567),
    [anon_sym_readnone] = ACTIONS(567),
    [anon_sym_readonly] = ACTIONS(567),
    [anon_sym_writeonly] = ACTIONS(567),
    [anon_sym_argmemonly] = ACTIONS(567),
    [anon_sym_returns_twice] = ACTIONS(567),
    [anon_sym_safestack] = ACTIONS(567),
    [anon_sym_sanitize_address] = ACTIONS(567),
    [anon_sym_sanitize_memory] = ACTIONS(567),
    [anon_sym_sanitize_thread] = ACTIONS(567),
    [anon_sym_sanitize_hwaddress] = ACTIONS(567),
    [anon_sym_sanitize_memtag] = ACTIONS(567),
    [anon_sym_speculative_load_hardening] = ACTIONS(567),
    [anon_sym_speculatable] = ACTIONS(567),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(567),
    [anon_sym_sspreq] = ACTIONS(567),
    [anon_sym_strictfp] = ACTIONS(567),
    [anon_sym_uwtable] = ACTIONS(567),
    [anon_sym_nocf_check] = ACTIONS(567),
    [anon_sym_shadowcallstack] = ACTIONS(567),
    [anon_sym_mustprogress] = ACTIONS(567),
    [anon_sym_vscale_range] = ACTIONS(567),
    [anon_sym_preallocated] = ACTIONS(567),
    [anon_sym_zeroext] = ACTIONS(567),
    [anon_sym_signext] = ACTIONS(567),
    [anon_sym_inreg] = ACTIONS(567),
    [anon_sym_byval] = ACTIONS(567),
    [anon_sym_byref] = ACTIONS(567),
    [anon_sym_inalloca] = ACTIONS(567),
    [anon_sym_sret] = ACTIONS(567),
    [anon_sym_elementtype] = ACTIONS(567),
    [anon_sym_noalias] = ACTIONS(567),
    [anon_sym_nocapture] = ACTIONS(567),
    [anon_sym_nest] = ACTIONS(567),
    [anon_sym_returned] = ACTIONS(567),
    [anon_sym_nonnull] = ACTIONS(567),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(567),
    [anon_sym_swiftself] = ACTIONS(567),
    [anon_sym_swiftasync] = ACTIONS(567),
    [anon_sym_swifterror] = ACTIONS(567),
    [anon_sym_immarg] = ACTIONS(567),
    [anon_sym_noundef] = ACTIONS(567),
    [anon_sym_unreachable] = ACTIONS(567),
    [anon_sym_ret] = ACTIONS(567),
    [anon_sym_br] = ACTIONS(567),
    [anon_sym_resume] = ACTIONS(567),
    [anon_sym_freeze] = ACTIONS(567),
    [anon_sym_indirectbr] = ACTIONS(567),
    [anon_sym_extractelement] = ACTIONS(567),
    [anon_sym_insertelement] = ACTIONS(567),
    [anon_sym_select] = ACTIONS(567),
    [anon_sym_shufflevector] = ACTIONS(567),
    [anon_sym_fneg] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_invoke] = ACTIONS(567),
    [anon_sym_cleanupret] = ACTIONS(567),
    [anon_sym_catchret] = ACTIONS(567),
    [anon_sym_catchswitch] = ACTIONS(567),
    [anon_sym_catchpad] = ACTIONS(567),
    [anon_sym_cleanuppad] = ACTIONS(567),
    [anon_sym_callbr] = ACTIONS(567),
    [anon_sym_icmp] = ACTIONS(567),
    [anon_sym_fcmp] = ACTIONS(567),
    [anon_sym_va_arg] = ACTIONS(567),
    [anon_sym_phi] = ACTIONS(567),
    [anon_sym_landingpad] = ACTIONS(567),
    [anon_sym_tail] = ACTIONS(567),
    [anon_sym_musttail] = ACTIONS(567),
    [anon_sym_notail] = ACTIONS(567),
    [anon_sym_call] = ACTIONS(567),
    [anon_sym_alloca] = ACTIONS(567),
    [anon_sym_load] = ACTIONS(567),
    [anon_sym_store] = ACTIONS(567),
    [anon_sym_cmpxchg] = ACTIONS(567),
    [anon_sym_atomicrmw] = ACTIONS(567),
    [anon_sym_fence] = ACTIONS(567),
    [anon_sym_getelementptr] = ACTIONS(567),
    [anon_sym_extractvalue] = ACTIONS(567),
    [anon_sym_insertvalue] = ACTIONS(567),
    [anon_sym_catch] = ACTIONS(567),
    [anon_sym_filter] = ACTIONS(567),
    [anon_sym_mul] = ACTIONS(567),
    [anon_sym_urem] = ACTIONS(567),
    [anon_sym_srem] = ACTIONS(567),
    [anon_sym_shl] = ACTIONS(567),
    [anon_sym_udiv] = ACTIONS(567),
    [anon_sym_sdiv] = ACTIONS(567),
    [anon_sym_lshr] = ACTIONS(567),
    [anon_sym_ashr] = ACTIONS(567),
    [anon_sym_fmul] = ACTIONS(567),
    [anon_sym_fdiv] = ACTIONS(567),
    [anon_sym_frem] = ACTIONS(567),
    [anon_sym_xchg] = ACTIONS(567),
    [anon_sym_add] = ACTIONS(567),
    [anon_sym_sub] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(567),
    [anon_sym_nand] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(567),
    [anon_sym_xor] = ACTIONS(567),
    [anon_sym_max] = ACTIONS(567),
    [anon_sym_min] = ACTIONS(567),
    [anon_sym_umax] = ACTIONS(567),
    [anon_sym_umin] = ACTIONS(567),
    [anon_sym_fadd] = ACTIONS(567),
    [anon_sym_fsub] = ACTIONS(567),
    [anon_sym_bitcast] = ACTIONS(567),
    [anon_sym_trunc] = ACTIONS(567),
    [anon_sym_zext] = ACTIONS(567),
    [anon_sym_sext] = ACTIONS(567),
    [anon_sym_fptrunc] = ACTIONS(567),
    [anon_sym_fpext] = ACTIONS(567),
    [anon_sym_addrspacecast] = ACTIONS(567),
    [anon_sym_uitofp] = ACTIONS(567),
    [anon_sym_sitofp] = ACTIONS(567),
    [anon_sym_fptoui] = ACTIONS(567),
    [anon_sym_fptosi] = ACTIONS(567),
    [anon_sym_inttoptr] = ACTIONS(567),
    [anon_sym_ptrtoint] = ACTIONS(567),
    [anon_sym_unordered] = ACTIONS(567),
    [anon_sym_monotonic] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(567),
    [anon_sym_release] = ACTIONS(567),
    [anon_sym_acq_rel] = ACTIONS(567),
    [anon_sym_seq_cst] = ACTIONS(567),
    [anon_sym_syncscope] = ACTIONS(567),
    [anon_sym_uselistorder] = ACTIONS(567),
  },
  [156] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [sym_label] = ACTIONS(557),
    [sym_string] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_section] = ACTIONS(559),
    [anon_sym_partition] = ACTIONS(559),
    [anon_sym_comdat] = ACTIONS(559),
    [anon_sym_gc] = ACTIONS(559),
    [anon_sym_prefix] = ACTIONS(559),
    [anon_sym_prologue] = ACTIONS(559),
    [anon_sym_personality] = ACTIONS(559),
    [anon_sym_alignstack] = ACTIONS(559),
    [anon_sym_allocsize] = ACTIONS(559),
    [anon_sym_alwaysinline] = ACTIONS(559),
    [anon_sym_builtin] = ACTIONS(559),
    [anon_sym_cold] = ACTIONS(559),
    [anon_sym_convergent] = ACTIONS(559),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(559),
    [anon_sym_hot] = ACTIONS(559),
    [anon_sym_inaccessiblememonly] = ACTIONS(559),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(559),
    [anon_sym_inlinehint] = ACTIONS(559),
    [anon_sym_jumptable] = ACTIONS(559),
    [anon_sym_minsize] = ACTIONS(559),
    [anon_sym_naked] = ACTIONS(559),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(559),
    [anon_sym_nobuiltin] = ACTIONS(559),
    [anon_sym_noduplicate] = ACTIONS(559),
    [anon_sym_nofree] = ACTIONS(559),
    [anon_sym_noimplicitfloat] = ACTIONS(559),
    [anon_sym_noinline] = ACTIONS(559),
    [anon_sym_nomerge] = ACTIONS(559),
    [anon_sym_nonlazybind] = ACTIONS(559),
    [anon_sym_noprofile] = ACTIONS(559),
    [anon_sym_noredzone] = ACTIONS(559),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(559),
    [anon_sym_noreturn] = ACTIONS(559),
    [anon_sym_norecurse] = ACTIONS(559),
    [anon_sym_willreturn] = ACTIONS(559),
    [anon_sym_nosync] = ACTIONS(559),
    [anon_sym_nounwind] = ACTIONS(559),
    [anon_sym_nosanitize_coverage] = ACTIONS(559),
    [anon_sym_null_pointer_is_valid] = ACTIONS(559),
    [anon_sym_optforfuzzing] = ACTIONS(559),
    [anon_sym_optnone] = ACTIONS(559),
    [anon_sym_optsize] = ACTIONS(559),
    [anon_sym_readnone] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_writeonly] = ACTIONS(559),
    [anon_sym_argmemonly] = ACTIONS(559),
    [anon_sym_returns_twice] = ACTIONS(559),
    [anon_sym_safestack] = ACTIONS(559),
    [anon_sym_sanitize_address] = ACTIONS(559),
    [anon_sym_sanitize_memory] = ACTIONS(559),
    [anon_sym_sanitize_thread] = ACTIONS(559),
    [anon_sym_sanitize_hwaddress] = ACTIONS(559),
    [anon_sym_sanitize_memtag] = ACTIONS(559),
    [anon_sym_speculative_load_hardening] = ACTIONS(559),
    [anon_sym_speculatable] = ACTIONS(559),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(559),
    [anon_sym_sspreq] = ACTIONS(559),
    [anon_sym_strictfp] = ACTIONS(559),
    [anon_sym_uwtable] = ACTIONS(559),
    [anon_sym_nocf_check] = ACTIONS(559),
    [anon_sym_shadowcallstack] = ACTIONS(559),
    [anon_sym_mustprogress] = ACTIONS(559),
    [anon_sym_vscale_range] = ACTIONS(559),
    [anon_sym_preallocated] = ACTIONS(559),
    [anon_sym_zeroext] = ACTIONS(559),
    [anon_sym_signext] = ACTIONS(559),
    [anon_sym_inreg] = ACTIONS(559),
    [anon_sym_byval] = ACTIONS(559),
    [anon_sym_byref] = ACTIONS(559),
    [anon_sym_inalloca] = ACTIONS(559),
    [anon_sym_sret] = ACTIONS(559),
    [anon_sym_elementtype] = ACTIONS(559),
    [anon_sym_noalias] = ACTIONS(559),
    [anon_sym_nocapture] = ACTIONS(559),
    [anon_sym_nest] = ACTIONS(559),
    [anon_sym_returned] = ACTIONS(559),
    [anon_sym_nonnull] = ACTIONS(559),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(559),
    [anon_sym_swiftself] = ACTIONS(559),
    [anon_sym_swiftasync] = ACTIONS(559),
    [anon_sym_swifterror] = ACTIONS(559),
    [anon_sym_immarg] = ACTIONS(559),
    [anon_sym_noundef] = ACTIONS(559),
    [anon_sym_unreachable] = ACTIONS(559),
    [anon_sym_ret] = ACTIONS(559),
    [anon_sym_br] = ACTIONS(559),
    [anon_sym_resume] = ACTIONS(559),
    [anon_sym_freeze] = ACTIONS(559),
    [anon_sym_indirectbr] = ACTIONS(559),
    [anon_sym_extractelement] = ACTIONS(559),
    [anon_sym_insertelement] = ACTIONS(559),
    [anon_sym_select] = ACTIONS(559),
    [anon_sym_shufflevector] = ACTIONS(559),
    [anon_sym_fneg] = ACTIONS(559),
    [anon_sym_switch] = ACTIONS(559),
    [anon_sym_invoke] = ACTIONS(559),
    [anon_sym_cleanupret] = ACTIONS(559),
    [anon_sym_catchret] = ACTIONS(559),
    [anon_sym_catchswitch] = ACTIONS(559),
    [anon_sym_catchpad] = ACTIONS(559),
    [anon_sym_cleanuppad] = ACTIONS(559),
    [anon_sym_callbr] = ACTIONS(559),
    [anon_sym_icmp] = ACTIONS(559),
    [anon_sym_fcmp] = ACTIONS(559),
    [anon_sym_va_arg] = ACTIONS(559),
    [anon_sym_phi] = ACTIONS(559),
    [anon_sym_landingpad] = ACTIONS(559),
    [anon_sym_tail] = ACTIONS(559),
    [anon_sym_musttail] = ACTIONS(559),
    [anon_sym_notail] = ACTIONS(559),
    [anon_sym_call] = ACTIONS(559),
    [anon_sym_alloca] = ACTIONS(559),
    [anon_sym_load] = ACTIONS(559),
    [anon_sym_store] = ACTIONS(559),
    [anon_sym_cmpxchg] = ACTIONS(559),
    [anon_sym_atomicrmw] = ACTIONS(559),
    [anon_sym_fence] = ACTIONS(559),
    [anon_sym_getelementptr] = ACTIONS(559),
    [anon_sym_extractvalue] = ACTIONS(559),
    [anon_sym_insertvalue] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(559),
    [anon_sym_filter] = ACTIONS(559),
    [anon_sym_mul] = ACTIONS(559),
    [anon_sym_urem] = ACTIONS(559),
    [anon_sym_srem] = ACTIONS(559),
    [anon_sym_shl] = ACTIONS(559),
    [anon_sym_udiv] = ACTIONS(559),
    [anon_sym_sdiv] = ACTIONS(559),
    [anon_sym_lshr] = ACTIONS(559),
    [anon_sym_ashr] = ACTIONS(559),
    [anon_sym_fmul] = ACTIONS(559),
    [anon_sym_fdiv] = ACTIONS(559),
    [anon_sym_frem] = ACTIONS(559),
    [anon_sym_xchg] = ACTIONS(559),
    [anon_sym_add] = ACTIONS(559),
    [anon_sym_sub] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_nand] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_xor] = ACTIONS(559),
    [anon_sym_max] = ACTIONS(559),
    [anon_sym_min] = ACTIONS(559),
    [anon_sym_umax] = ACTIONS(559),
    [anon_sym_umin] = ACTIONS(559),
    [anon_sym_fadd] = ACTIONS(559),
    [anon_sym_fsub] = ACTIONS(559),
    [anon_sym_bitcast] = ACTIONS(559),
    [anon_sym_trunc] = ACTIONS(559),
    [anon_sym_zext] = ACTIONS(559),
    [anon_sym_sext] = ACTIONS(559),
    [anon_sym_fptrunc] = ACTIONS(559),
    [anon_sym_fpext] = ACTIONS(559),
    [anon_sym_addrspacecast] = ACTIONS(559),
    [anon_sym_uitofp] = ACTIONS(559),
    [anon_sym_sitofp] = ACTIONS(559),
    [anon_sym_fptoui] = ACTIONS(559),
    [anon_sym_fptosi] = ACTIONS(559),
    [anon_sym_inttoptr] = ACTIONS(559),
    [anon_sym_ptrtoint] = ACTIONS(559),
    [anon_sym_unordered] = ACTIONS(559),
    [anon_sym_monotonic] = ACTIONS(559),
    [anon_sym_acquire] = ACTIONS(559),
    [anon_sym_release] = ACTIONS(559),
    [anon_sym_acq_rel] = ACTIONS(559),
    [anon_sym_seq_cst] = ACTIONS(559),
    [anon_sym_syncscope] = ACTIONS(559),
    [anon_sym_uselistorder] = ACTIONS(559),
  },
  [157] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [sym_label] = ACTIONS(553),
    [sym_string] = ACTIONS(555),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_section] = ACTIONS(555),
    [anon_sym_partition] = ACTIONS(555),
    [anon_sym_comdat] = ACTIONS(555),
    [anon_sym_gc] = ACTIONS(555),
    [anon_sym_prefix] = ACTIONS(555),
    [anon_sym_prologue] = ACTIONS(555),
    [anon_sym_personality] = ACTIONS(555),
    [anon_sym_alignstack] = ACTIONS(555),
    [anon_sym_allocsize] = ACTIONS(555),
    [anon_sym_alwaysinline] = ACTIONS(555),
    [anon_sym_builtin] = ACTIONS(555),
    [anon_sym_cold] = ACTIONS(555),
    [anon_sym_convergent] = ACTIONS(555),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(555),
    [anon_sym_hot] = ACTIONS(555),
    [anon_sym_inaccessiblememonly] = ACTIONS(555),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(555),
    [anon_sym_inlinehint] = ACTIONS(555),
    [anon_sym_jumptable] = ACTIONS(555),
    [anon_sym_minsize] = ACTIONS(555),
    [anon_sym_naked] = ACTIONS(555),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(555),
    [anon_sym_nobuiltin] = ACTIONS(555),
    [anon_sym_noduplicate] = ACTIONS(555),
    [anon_sym_nofree] = ACTIONS(555),
    [anon_sym_noimplicitfloat] = ACTIONS(555),
    [anon_sym_noinline] = ACTIONS(555),
    [anon_sym_nomerge] = ACTIONS(555),
    [anon_sym_nonlazybind] = ACTIONS(555),
    [anon_sym_noprofile] = ACTIONS(555),
    [anon_sym_noredzone] = ACTIONS(555),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(555),
    [anon_sym_noreturn] = ACTIONS(555),
    [anon_sym_norecurse] = ACTIONS(555),
    [anon_sym_willreturn] = ACTIONS(555),
    [anon_sym_nosync] = ACTIONS(555),
    [anon_sym_nounwind] = ACTIONS(555),
    [anon_sym_nosanitize_coverage] = ACTIONS(555),
    [anon_sym_null_pointer_is_valid] = ACTIONS(555),
    [anon_sym_optforfuzzing] = ACTIONS(555),
    [anon_sym_optnone] = ACTIONS(555),
    [anon_sym_optsize] = ACTIONS(555),
    [anon_sym_readnone] = ACTIONS(555),
    [anon_sym_readonly] = ACTIONS(555),
    [anon_sym_writeonly] = ACTIONS(555),
    [anon_sym_argmemonly] = ACTIONS(555),
    [anon_sym_returns_twice] = ACTIONS(555),
    [anon_sym_safestack] = ACTIONS(555),
    [anon_sym_sanitize_address] = ACTIONS(555),
    [anon_sym_sanitize_memory] = ACTIONS(555),
    [anon_sym_sanitize_thread] = ACTIONS(555),
    [anon_sym_sanitize_hwaddress] = ACTIONS(555),
    [anon_sym_sanitize_memtag] = ACTIONS(555),
    [anon_sym_speculative_load_hardening] = ACTIONS(555),
    [anon_sym_speculatable] = ACTIONS(555),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(555),
    [anon_sym_sspreq] = ACTIONS(555),
    [anon_sym_strictfp] = ACTIONS(555),
    [anon_sym_uwtable] = ACTIONS(555),
    [anon_sym_nocf_check] = ACTIONS(555),
    [anon_sym_shadowcallstack] = ACTIONS(555),
    [anon_sym_mustprogress] = ACTIONS(555),
    [anon_sym_vscale_range] = ACTIONS(555),
    [anon_sym_preallocated] = ACTIONS(555),
    [anon_sym_zeroext] = ACTIONS(555),
    [anon_sym_signext] = ACTIONS(555),
    [anon_sym_inreg] = ACTIONS(555),
    [anon_sym_byval] = ACTIONS(555),
    [anon_sym_byref] = ACTIONS(555),
    [anon_sym_inalloca] = ACTIONS(555),
    [anon_sym_sret] = ACTIONS(555),
    [anon_sym_elementtype] = ACTIONS(555),
    [anon_sym_noalias] = ACTIONS(555),
    [anon_sym_nocapture] = ACTIONS(555),
    [anon_sym_nest] = ACTIONS(555),
    [anon_sym_returned] = ACTIONS(555),
    [anon_sym_nonnull] = ACTIONS(555),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(555),
    [anon_sym_swiftself] = ACTIONS(555),
    [anon_sym_swiftasync] = ACTIONS(555),
    [anon_sym_swifterror] = ACTIONS(555),
    [anon_sym_immarg] = ACTIONS(555),
    [anon_sym_noundef] = ACTIONS(555),
    [anon_sym_unreachable] = ACTIONS(555),
    [anon_sym_ret] = ACTIONS(555),
    [anon_sym_br] = ACTIONS(555),
    [anon_sym_resume] = ACTIONS(555),
    [anon_sym_freeze] = ACTIONS(555),
    [anon_sym_indirectbr] = ACTIONS(555),
    [anon_sym_extractelement] = ACTIONS(555),
    [anon_sym_insertelement] = ACTIONS(555),
    [anon_sym_select] = ACTIONS(555),
    [anon_sym_shufflevector] = ACTIONS(555),
    [anon_sym_fneg] = ACTIONS(555),
    [anon_sym_switch] = ACTIONS(555),
    [anon_sym_invoke] = ACTIONS(555),
    [anon_sym_cleanupret] = ACTIONS(555),
    [anon_sym_catchret] = ACTIONS(555),
    [anon_sym_catchswitch] = ACTIONS(555),
    [anon_sym_catchpad] = ACTIONS(555),
    [anon_sym_cleanuppad] = ACTIONS(555),
    [anon_sym_callbr] = ACTIONS(555),
    [anon_sym_icmp] = ACTIONS(555),
    [anon_sym_fcmp] = ACTIONS(555),
    [anon_sym_va_arg] = ACTIONS(555),
    [anon_sym_phi] = ACTIONS(555),
    [anon_sym_landingpad] = ACTIONS(555),
    [anon_sym_tail] = ACTIONS(555),
    [anon_sym_musttail] = ACTIONS(555),
    [anon_sym_notail] = ACTIONS(555),
    [anon_sym_call] = ACTIONS(555),
    [anon_sym_alloca] = ACTIONS(555),
    [anon_sym_load] = ACTIONS(555),
    [anon_sym_store] = ACTIONS(555),
    [anon_sym_cmpxchg] = ACTIONS(555),
    [anon_sym_atomicrmw] = ACTIONS(555),
    [anon_sym_fence] = ACTIONS(555),
    [anon_sym_getelementptr] = ACTIONS(555),
    [anon_sym_extractvalue] = ACTIONS(555),
    [anon_sym_insertvalue] = ACTIONS(555),
    [anon_sym_catch] = ACTIONS(555),
    [anon_sym_filter] = ACTIONS(555),
    [anon_sym_mul] = ACTIONS(555),
    [anon_sym_urem] = ACTIONS(555),
    [anon_sym_srem] = ACTIONS(555),
    [anon_sym_shl] = ACTIONS(555),
    [anon_sym_udiv] = ACTIONS(555),
    [anon_sym_sdiv] = ACTIONS(555),
    [anon_sym_lshr] = ACTIONS(555),
    [anon_sym_ashr] = ACTIONS(555),
    [anon_sym_fmul] = ACTIONS(555),
    [anon_sym_fdiv] = ACTIONS(555),
    [anon_sym_frem] = ACTIONS(555),
    [anon_sym_xchg] = ACTIONS(555),
    [anon_sym_add] = ACTIONS(555),
    [anon_sym_sub] = ACTIONS(555),
    [anon_sym_and] = ACTIONS(555),
    [anon_sym_nand] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(555),
    [anon_sym_xor] = ACTIONS(555),
    [anon_sym_max] = ACTIONS(555),
    [anon_sym_min] = ACTIONS(555),
    [anon_sym_umax] = ACTIONS(555),
    [anon_sym_umin] = ACTIONS(555),
    [anon_sym_fadd] = ACTIONS(555),
    [anon_sym_fsub] = ACTIONS(555),
    [anon_sym_bitcast] = ACTIONS(555),
    [anon_sym_trunc] = ACTIONS(555),
    [anon_sym_zext] = ACTIONS(555),
    [anon_sym_sext] = ACTIONS(555),
    [anon_sym_fptrunc] = ACTIONS(555),
    [anon_sym_fpext] = ACTIONS(555),
    [anon_sym_addrspacecast] = ACTIONS(555),
    [anon_sym_uitofp] = ACTIONS(555),
    [anon_sym_sitofp] = ACTIONS(555),
    [anon_sym_fptoui] = ACTIONS(555),
    [anon_sym_fptosi] = ACTIONS(555),
    [anon_sym_inttoptr] = ACTIONS(555),
    [anon_sym_ptrtoint] = ACTIONS(555),
    [anon_sym_unordered] = ACTIONS(555),
    [anon_sym_monotonic] = ACTIONS(555),
    [anon_sym_acquire] = ACTIONS(555),
    [anon_sym_release] = ACTIONS(555),
    [anon_sym_acq_rel] = ACTIONS(555),
    [anon_sym_seq_cst] = ACTIONS(555),
    [anon_sym_syncscope] = ACTIONS(555),
    [anon_sym_uselistorder] = ACTIONS(555),
  },
  [158] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [sym_label] = ACTIONS(549),
    [sym_string] = ACTIONS(551),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_section] = ACTIONS(551),
    [anon_sym_partition] = ACTIONS(551),
    [anon_sym_comdat] = ACTIONS(551),
    [anon_sym_gc] = ACTIONS(551),
    [anon_sym_prefix] = ACTIONS(551),
    [anon_sym_prologue] = ACTIONS(551),
    [anon_sym_personality] = ACTIONS(551),
    [anon_sym_alignstack] = ACTIONS(551),
    [anon_sym_allocsize] = ACTIONS(551),
    [anon_sym_alwaysinline] = ACTIONS(551),
    [anon_sym_builtin] = ACTIONS(551),
    [anon_sym_cold] = ACTIONS(551),
    [anon_sym_convergent] = ACTIONS(551),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(551),
    [anon_sym_hot] = ACTIONS(551),
    [anon_sym_inaccessiblememonly] = ACTIONS(551),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(551),
    [anon_sym_inlinehint] = ACTIONS(551),
    [anon_sym_jumptable] = ACTIONS(551),
    [anon_sym_minsize] = ACTIONS(551),
    [anon_sym_naked] = ACTIONS(551),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(551),
    [anon_sym_nobuiltin] = ACTIONS(551),
    [anon_sym_noduplicate] = ACTIONS(551),
    [anon_sym_nofree] = ACTIONS(551),
    [anon_sym_noimplicitfloat] = ACTIONS(551),
    [anon_sym_noinline] = ACTIONS(551),
    [anon_sym_nomerge] = ACTIONS(551),
    [anon_sym_nonlazybind] = ACTIONS(551),
    [anon_sym_noprofile] = ACTIONS(551),
    [anon_sym_noredzone] = ACTIONS(551),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(551),
    [anon_sym_noreturn] = ACTIONS(551),
    [anon_sym_norecurse] = ACTIONS(551),
    [anon_sym_willreturn] = ACTIONS(551),
    [anon_sym_nosync] = ACTIONS(551),
    [anon_sym_nounwind] = ACTIONS(551),
    [anon_sym_nosanitize_coverage] = ACTIONS(551),
    [anon_sym_null_pointer_is_valid] = ACTIONS(551),
    [anon_sym_optforfuzzing] = ACTIONS(551),
    [anon_sym_optnone] = ACTIONS(551),
    [anon_sym_optsize] = ACTIONS(551),
    [anon_sym_readnone] = ACTIONS(551),
    [anon_sym_readonly] = ACTIONS(551),
    [anon_sym_writeonly] = ACTIONS(551),
    [anon_sym_argmemonly] = ACTIONS(551),
    [anon_sym_returns_twice] = ACTIONS(551),
    [anon_sym_safestack] = ACTIONS(551),
    [anon_sym_sanitize_address] = ACTIONS(551),
    [anon_sym_sanitize_memory] = ACTIONS(551),
    [anon_sym_sanitize_thread] = ACTIONS(551),
    [anon_sym_sanitize_hwaddress] = ACTIONS(551),
    [anon_sym_sanitize_memtag] = ACTIONS(551),
    [anon_sym_speculative_load_hardening] = ACTIONS(551),
    [anon_sym_speculatable] = ACTIONS(551),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(551),
    [anon_sym_sspreq] = ACTIONS(551),
    [anon_sym_strictfp] = ACTIONS(551),
    [anon_sym_uwtable] = ACTIONS(551),
    [anon_sym_nocf_check] = ACTIONS(551),
    [anon_sym_shadowcallstack] = ACTIONS(551),
    [anon_sym_mustprogress] = ACTIONS(551),
    [anon_sym_vscale_range] = ACTIONS(551),
    [anon_sym_preallocated] = ACTIONS(551),
    [anon_sym_zeroext] = ACTIONS(551),
    [anon_sym_signext] = ACTIONS(551),
    [anon_sym_inreg] = ACTIONS(551),
    [anon_sym_byval] = ACTIONS(551),
    [anon_sym_byref] = ACTIONS(551),
    [anon_sym_inalloca] = ACTIONS(551),
    [anon_sym_sret] = ACTIONS(551),
    [anon_sym_elementtype] = ACTIONS(551),
    [anon_sym_noalias] = ACTIONS(551),
    [anon_sym_nocapture] = ACTIONS(551),
    [anon_sym_nest] = ACTIONS(551),
    [anon_sym_returned] = ACTIONS(551),
    [anon_sym_nonnull] = ACTIONS(551),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(551),
    [anon_sym_swiftself] = ACTIONS(551),
    [anon_sym_swiftasync] = ACTIONS(551),
    [anon_sym_swifterror] = ACTIONS(551),
    [anon_sym_immarg] = ACTIONS(551),
    [anon_sym_noundef] = ACTIONS(551),
    [anon_sym_unreachable] = ACTIONS(551),
    [anon_sym_ret] = ACTIONS(551),
    [anon_sym_br] = ACTIONS(551),
    [anon_sym_resume] = ACTIONS(551),
    [anon_sym_freeze] = ACTIONS(551),
    [anon_sym_indirectbr] = ACTIONS(551),
    [anon_sym_extractelement] = ACTIONS(551),
    [anon_sym_insertelement] = ACTIONS(551),
    [anon_sym_select] = ACTIONS(551),
    [anon_sym_shufflevector] = ACTIONS(551),
    [anon_sym_fneg] = ACTIONS(551),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_invoke] = ACTIONS(551),
    [anon_sym_cleanupret] = ACTIONS(551),
    [anon_sym_catchret] = ACTIONS(551),
    [anon_sym_catchswitch] = ACTIONS(551),
    [anon_sym_catchpad] = ACTIONS(551),
    [anon_sym_cleanuppad] = ACTIONS(551),
    [anon_sym_callbr] = ACTIONS(551),
    [anon_sym_icmp] = ACTIONS(551),
    [anon_sym_fcmp] = ACTIONS(551),
    [anon_sym_va_arg] = ACTIONS(551),
    [anon_sym_phi] = ACTIONS(551),
    [anon_sym_landingpad] = ACTIONS(551),
    [anon_sym_tail] = ACTIONS(551),
    [anon_sym_musttail] = ACTIONS(551),
    [anon_sym_notail] = ACTIONS(551),
    [anon_sym_call] = ACTIONS(551),
    [anon_sym_alloca] = ACTIONS(551),
    [anon_sym_load] = ACTIONS(551),
    [anon_sym_store] = ACTIONS(551),
    [anon_sym_cmpxchg] = ACTIONS(551),
    [anon_sym_atomicrmw] = ACTIONS(551),
    [anon_sym_fence] = ACTIONS(551),
    [anon_sym_getelementptr] = ACTIONS(551),
    [anon_sym_extractvalue] = ACTIONS(551),
    [anon_sym_insertvalue] = ACTIONS(551),
    [anon_sym_catch] = ACTIONS(551),
    [anon_sym_filter] = ACTIONS(551),
    [anon_sym_mul] = ACTIONS(551),
    [anon_sym_urem] = ACTIONS(551),
    [anon_sym_srem] = ACTIONS(551),
    [anon_sym_shl] = ACTIONS(551),
    [anon_sym_udiv] = ACTIONS(551),
    [anon_sym_sdiv] = ACTIONS(551),
    [anon_sym_lshr] = ACTIONS(551),
    [anon_sym_ashr] = ACTIONS(551),
    [anon_sym_fmul] = ACTIONS(551),
    [anon_sym_fdiv] = ACTIONS(551),
    [anon_sym_frem] = ACTIONS(551),
    [anon_sym_xchg] = ACTIONS(551),
    [anon_sym_add] = ACTIONS(551),
    [anon_sym_sub] = ACTIONS(551),
    [anon_sym_and] = ACTIONS(551),
    [anon_sym_nand] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(551),
    [anon_sym_xor] = ACTIONS(551),
    [anon_sym_max] = ACTIONS(551),
    [anon_sym_min] = ACTIONS(551),
    [anon_sym_umax] = ACTIONS(551),
    [anon_sym_umin] = ACTIONS(551),
    [anon_sym_fadd] = ACTIONS(551),
    [anon_sym_fsub] = ACTIONS(551),
    [anon_sym_bitcast] = ACTIONS(551),
    [anon_sym_trunc] = ACTIONS(551),
    [anon_sym_zext] = ACTIONS(551),
    [anon_sym_sext] = ACTIONS(551),
    [anon_sym_fptrunc] = ACTIONS(551),
    [anon_sym_fpext] = ACTIONS(551),
    [anon_sym_addrspacecast] = ACTIONS(551),
    [anon_sym_uitofp] = ACTIONS(551),
    [anon_sym_sitofp] = ACTIONS(551),
    [anon_sym_fptoui] = ACTIONS(551),
    [anon_sym_fptosi] = ACTIONS(551),
    [anon_sym_inttoptr] = ACTIONS(551),
    [anon_sym_ptrtoint] = ACTIONS(551),
    [anon_sym_unordered] = ACTIONS(551),
    [anon_sym_monotonic] = ACTIONS(551),
    [anon_sym_acquire] = ACTIONS(551),
    [anon_sym_release] = ACTIONS(551),
    [anon_sym_acq_rel] = ACTIONS(551),
    [anon_sym_seq_cst] = ACTIONS(551),
    [anon_sym_syncscope] = ACTIONS(551),
    [anon_sym_uselistorder] = ACTIONS(551),
  },
  [159] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [sym_label] = ACTIONS(671),
    [sym_string] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_section] = ACTIONS(673),
    [anon_sym_partition] = ACTIONS(673),
    [anon_sym_comdat] = ACTIONS(673),
    [anon_sym_gc] = ACTIONS(673),
    [anon_sym_prefix] = ACTIONS(673),
    [anon_sym_prologue] = ACTIONS(673),
    [anon_sym_personality] = ACTIONS(673),
    [anon_sym_alignstack] = ACTIONS(673),
    [anon_sym_allocsize] = ACTIONS(673),
    [anon_sym_alwaysinline] = ACTIONS(673),
    [anon_sym_builtin] = ACTIONS(673),
    [anon_sym_cold] = ACTIONS(673),
    [anon_sym_convergent] = ACTIONS(673),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(673),
    [anon_sym_hot] = ACTIONS(673),
    [anon_sym_inaccessiblememonly] = ACTIONS(673),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(673),
    [anon_sym_inlinehint] = ACTIONS(673),
    [anon_sym_jumptable] = ACTIONS(673),
    [anon_sym_minsize] = ACTIONS(673),
    [anon_sym_naked] = ACTIONS(673),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(673),
    [anon_sym_nobuiltin] = ACTIONS(673),
    [anon_sym_noduplicate] = ACTIONS(673),
    [anon_sym_nofree] = ACTIONS(673),
    [anon_sym_noimplicitfloat] = ACTIONS(673),
    [anon_sym_noinline] = ACTIONS(673),
    [anon_sym_nomerge] = ACTIONS(673),
    [anon_sym_nonlazybind] = ACTIONS(673),
    [anon_sym_noprofile] = ACTIONS(673),
    [anon_sym_noredzone] = ACTIONS(673),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(673),
    [anon_sym_noreturn] = ACTIONS(673),
    [anon_sym_norecurse] = ACTIONS(673),
    [anon_sym_willreturn] = ACTIONS(673),
    [anon_sym_nosync] = ACTIONS(673),
    [anon_sym_nounwind] = ACTIONS(673),
    [anon_sym_nosanitize_coverage] = ACTIONS(673),
    [anon_sym_null_pointer_is_valid] = ACTIONS(673),
    [anon_sym_optforfuzzing] = ACTIONS(673),
    [anon_sym_optnone] = ACTIONS(673),
    [anon_sym_optsize] = ACTIONS(673),
    [anon_sym_readnone] = ACTIONS(673),
    [anon_sym_readonly] = ACTIONS(673),
    [anon_sym_writeonly] = ACTIONS(673),
    [anon_sym_argmemonly] = ACTIONS(673),
    [anon_sym_returns_twice] = ACTIONS(673),
    [anon_sym_safestack] = ACTIONS(673),
    [anon_sym_sanitize_address] = ACTIONS(673),
    [anon_sym_sanitize_memory] = ACTIONS(673),
    [anon_sym_sanitize_thread] = ACTIONS(673),
    [anon_sym_sanitize_hwaddress] = ACTIONS(673),
    [anon_sym_sanitize_memtag] = ACTIONS(673),
    [anon_sym_speculative_load_hardening] = ACTIONS(673),
    [anon_sym_speculatable] = ACTIONS(673),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(673),
    [anon_sym_sspreq] = ACTIONS(673),
    [anon_sym_strictfp] = ACTIONS(673),
    [anon_sym_uwtable] = ACTIONS(673),
    [anon_sym_nocf_check] = ACTIONS(673),
    [anon_sym_shadowcallstack] = ACTIONS(673),
    [anon_sym_mustprogress] = ACTIONS(673),
    [anon_sym_vscale_range] = ACTIONS(673),
    [anon_sym_preallocated] = ACTIONS(673),
    [anon_sym_zeroext] = ACTIONS(673),
    [anon_sym_signext] = ACTIONS(673),
    [anon_sym_inreg] = ACTIONS(673),
    [anon_sym_byval] = ACTIONS(673),
    [anon_sym_byref] = ACTIONS(673),
    [anon_sym_inalloca] = ACTIONS(673),
    [anon_sym_sret] = ACTIONS(673),
    [anon_sym_elementtype] = ACTIONS(673),
    [anon_sym_noalias] = ACTIONS(673),
    [anon_sym_nocapture] = ACTIONS(673),
    [anon_sym_nest] = ACTIONS(673),
    [anon_sym_returned] = ACTIONS(673),
    [anon_sym_nonnull] = ACTIONS(673),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(673),
    [anon_sym_swiftself] = ACTIONS(673),
    [anon_sym_swiftasync] = ACTIONS(673),
    [anon_sym_swifterror] = ACTIONS(673),
    [anon_sym_immarg] = ACTIONS(673),
    [anon_sym_noundef] = ACTIONS(673),
    [anon_sym_unreachable] = ACTIONS(673),
    [anon_sym_ret] = ACTIONS(673),
    [anon_sym_br] = ACTIONS(673),
    [anon_sym_resume] = ACTIONS(673),
    [anon_sym_freeze] = ACTIONS(673),
    [anon_sym_indirectbr] = ACTIONS(673),
    [anon_sym_extractelement] = ACTIONS(673),
    [anon_sym_insertelement] = ACTIONS(673),
    [anon_sym_select] = ACTIONS(673),
    [anon_sym_shufflevector] = ACTIONS(673),
    [anon_sym_fneg] = ACTIONS(673),
    [anon_sym_switch] = ACTIONS(673),
    [anon_sym_invoke] = ACTIONS(673),
    [anon_sym_cleanupret] = ACTIONS(673),
    [anon_sym_catchret] = ACTIONS(673),
    [anon_sym_catchswitch] = ACTIONS(673),
    [anon_sym_catchpad] = ACTIONS(673),
    [anon_sym_cleanuppad] = ACTIONS(673),
    [anon_sym_callbr] = ACTIONS(673),
    [anon_sym_icmp] = ACTIONS(673),
    [anon_sym_fcmp] = ACTIONS(673),
    [anon_sym_va_arg] = ACTIONS(673),
    [anon_sym_phi] = ACTIONS(673),
    [anon_sym_landingpad] = ACTIONS(673),
    [anon_sym_tail] = ACTIONS(673),
    [anon_sym_musttail] = ACTIONS(673),
    [anon_sym_notail] = ACTIONS(673),
    [anon_sym_call] = ACTIONS(673),
    [anon_sym_alloca] = ACTIONS(673),
    [anon_sym_load] = ACTIONS(673),
    [anon_sym_store] = ACTIONS(673),
    [anon_sym_cmpxchg] = ACTIONS(673),
    [anon_sym_atomicrmw] = ACTIONS(673),
    [anon_sym_fence] = ACTIONS(673),
    [anon_sym_getelementptr] = ACTIONS(673),
    [anon_sym_extractvalue] = ACTIONS(673),
    [anon_sym_insertvalue] = ACTIONS(673),
    [anon_sym_catch] = ACTIONS(673),
    [anon_sym_filter] = ACTIONS(673),
    [anon_sym_mul] = ACTIONS(673),
    [anon_sym_urem] = ACTIONS(673),
    [anon_sym_srem] = ACTIONS(673),
    [anon_sym_shl] = ACTIONS(673),
    [anon_sym_udiv] = ACTIONS(673),
    [anon_sym_sdiv] = ACTIONS(673),
    [anon_sym_lshr] = ACTIONS(673),
    [anon_sym_ashr] = ACTIONS(673),
    [anon_sym_fmul] = ACTIONS(673),
    [anon_sym_fdiv] = ACTIONS(673),
    [anon_sym_frem] = ACTIONS(673),
    [anon_sym_xchg] = ACTIONS(673),
    [anon_sym_add] = ACTIONS(673),
    [anon_sym_sub] = ACTIONS(673),
    [anon_sym_and] = ACTIONS(673),
    [anon_sym_nand] = ACTIONS(673),
    [anon_sym_or] = ACTIONS(673),
    [anon_sym_xor] = ACTIONS(673),
    [anon_sym_max] = ACTIONS(673),
    [anon_sym_min] = ACTIONS(673),
    [anon_sym_umax] = ACTIONS(673),
    [anon_sym_umin] = ACTIONS(673),
    [anon_sym_fadd] = ACTIONS(673),
    [anon_sym_fsub] = ACTIONS(673),
    [anon_sym_bitcast] = ACTIONS(673),
    [anon_sym_trunc] = ACTIONS(673),
    [anon_sym_zext] = ACTIONS(673),
    [anon_sym_sext] = ACTIONS(673),
    [anon_sym_fptrunc] = ACTIONS(673),
    [anon_sym_fpext] = ACTIONS(673),
    [anon_sym_addrspacecast] = ACTIONS(673),
    [anon_sym_uitofp] = ACTIONS(673),
    [anon_sym_sitofp] = ACTIONS(673),
    [anon_sym_fptoui] = ACTIONS(673),
    [anon_sym_fptosi] = ACTIONS(673),
    [anon_sym_inttoptr] = ACTIONS(673),
    [anon_sym_ptrtoint] = ACTIONS(673),
    [anon_sym_unordered] = ACTIONS(673),
    [anon_sym_monotonic] = ACTIONS(673),
    [anon_sym_acquire] = ACTIONS(673),
    [anon_sym_release] = ACTIONS(673),
    [anon_sym_acq_rel] = ACTIONS(673),
    [anon_sym_seq_cst] = ACTIONS(673),
    [anon_sym_syncscope] = ACTIONS(673),
    [anon_sym_uselistorder] = ACTIONS(673),
  },
  [160] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [sym_label] = ACTIONS(561),
    [sym_string] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_section] = ACTIONS(563),
    [anon_sym_partition] = ACTIONS(563),
    [anon_sym_comdat] = ACTIONS(563),
    [anon_sym_gc] = ACTIONS(563),
    [anon_sym_prefix] = ACTIONS(563),
    [anon_sym_prologue] = ACTIONS(563),
    [anon_sym_personality] = ACTIONS(563),
    [anon_sym_alignstack] = ACTIONS(563),
    [anon_sym_allocsize] = ACTIONS(563),
    [anon_sym_alwaysinline] = ACTIONS(563),
    [anon_sym_builtin] = ACTIONS(563),
    [anon_sym_cold] = ACTIONS(563),
    [anon_sym_convergent] = ACTIONS(563),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(563),
    [anon_sym_hot] = ACTIONS(563),
    [anon_sym_inaccessiblememonly] = ACTIONS(563),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(563),
    [anon_sym_inlinehint] = ACTIONS(563),
    [anon_sym_jumptable] = ACTIONS(563),
    [anon_sym_minsize] = ACTIONS(563),
    [anon_sym_naked] = ACTIONS(563),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(563),
    [anon_sym_nobuiltin] = ACTIONS(563),
    [anon_sym_noduplicate] = ACTIONS(563),
    [anon_sym_nofree] = ACTIONS(563),
    [anon_sym_noimplicitfloat] = ACTIONS(563),
    [anon_sym_noinline] = ACTIONS(563),
    [anon_sym_nomerge] = ACTIONS(563),
    [anon_sym_nonlazybind] = ACTIONS(563),
    [anon_sym_noprofile] = ACTIONS(563),
    [anon_sym_noredzone] = ACTIONS(563),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(563),
    [anon_sym_noreturn] = ACTIONS(563),
    [anon_sym_norecurse] = ACTIONS(563),
    [anon_sym_willreturn] = ACTIONS(563),
    [anon_sym_nosync] = ACTIONS(563),
    [anon_sym_nounwind] = ACTIONS(563),
    [anon_sym_nosanitize_coverage] = ACTIONS(563),
    [anon_sym_null_pointer_is_valid] = ACTIONS(563),
    [anon_sym_optforfuzzing] = ACTIONS(563),
    [anon_sym_optnone] = ACTIONS(563),
    [anon_sym_optsize] = ACTIONS(563),
    [anon_sym_readnone] = ACTIONS(563),
    [anon_sym_readonly] = ACTIONS(563),
    [anon_sym_writeonly] = ACTIONS(563),
    [anon_sym_argmemonly] = ACTIONS(563),
    [anon_sym_returns_twice] = ACTIONS(563),
    [anon_sym_safestack] = ACTIONS(563),
    [anon_sym_sanitize_address] = ACTIONS(563),
    [anon_sym_sanitize_memory] = ACTIONS(563),
    [anon_sym_sanitize_thread] = ACTIONS(563),
    [anon_sym_sanitize_hwaddress] = ACTIONS(563),
    [anon_sym_sanitize_memtag] = ACTIONS(563),
    [anon_sym_speculative_load_hardening] = ACTIONS(563),
    [anon_sym_speculatable] = ACTIONS(563),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(563),
    [anon_sym_sspreq] = ACTIONS(563),
    [anon_sym_strictfp] = ACTIONS(563),
    [anon_sym_uwtable] = ACTIONS(563),
    [anon_sym_nocf_check] = ACTIONS(563),
    [anon_sym_shadowcallstack] = ACTIONS(563),
    [anon_sym_mustprogress] = ACTIONS(563),
    [anon_sym_vscale_range] = ACTIONS(563),
    [anon_sym_preallocated] = ACTIONS(563),
    [anon_sym_zeroext] = ACTIONS(563),
    [anon_sym_signext] = ACTIONS(563),
    [anon_sym_inreg] = ACTIONS(563),
    [anon_sym_byval] = ACTIONS(563),
    [anon_sym_byref] = ACTIONS(563),
    [anon_sym_inalloca] = ACTIONS(563),
    [anon_sym_sret] = ACTIONS(563),
    [anon_sym_elementtype] = ACTIONS(563),
    [anon_sym_noalias] = ACTIONS(563),
    [anon_sym_nocapture] = ACTIONS(563),
    [anon_sym_nest] = ACTIONS(563),
    [anon_sym_returned] = ACTIONS(563),
    [anon_sym_nonnull] = ACTIONS(563),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(563),
    [anon_sym_swiftself] = ACTIONS(563),
    [anon_sym_swiftasync] = ACTIONS(563),
    [anon_sym_swifterror] = ACTIONS(563),
    [anon_sym_immarg] = ACTIONS(563),
    [anon_sym_noundef] = ACTIONS(563),
    [anon_sym_unreachable] = ACTIONS(563),
    [anon_sym_ret] = ACTIONS(563),
    [anon_sym_br] = ACTIONS(563),
    [anon_sym_resume] = ACTIONS(563),
    [anon_sym_freeze] = ACTIONS(563),
    [anon_sym_indirectbr] = ACTIONS(563),
    [anon_sym_extractelement] = ACTIONS(563),
    [anon_sym_insertelement] = ACTIONS(563),
    [anon_sym_select] = ACTIONS(563),
    [anon_sym_shufflevector] = ACTIONS(563),
    [anon_sym_fneg] = ACTIONS(563),
    [anon_sym_switch] = ACTIONS(563),
    [anon_sym_invoke] = ACTIONS(563),
    [anon_sym_cleanupret] = ACTIONS(563),
    [anon_sym_catchret] = ACTIONS(563),
    [anon_sym_catchswitch] = ACTIONS(563),
    [anon_sym_catchpad] = ACTIONS(563),
    [anon_sym_cleanuppad] = ACTIONS(563),
    [anon_sym_callbr] = ACTIONS(563),
    [anon_sym_icmp] = ACTIONS(563),
    [anon_sym_fcmp] = ACTIONS(563),
    [anon_sym_va_arg] = ACTIONS(563),
    [anon_sym_phi] = ACTIONS(563),
    [anon_sym_landingpad] = ACTIONS(563),
    [anon_sym_tail] = ACTIONS(563),
    [anon_sym_musttail] = ACTIONS(563),
    [anon_sym_notail] = ACTIONS(563),
    [anon_sym_call] = ACTIONS(563),
    [anon_sym_alloca] = ACTIONS(563),
    [anon_sym_load] = ACTIONS(563),
    [anon_sym_store] = ACTIONS(563),
    [anon_sym_cmpxchg] = ACTIONS(563),
    [anon_sym_atomicrmw] = ACTIONS(563),
    [anon_sym_fence] = ACTIONS(563),
    [anon_sym_getelementptr] = ACTIONS(563),
    [anon_sym_extractvalue] = ACTIONS(563),
    [anon_sym_insertvalue] = ACTIONS(563),
    [anon_sym_catch] = ACTIONS(563),
    [anon_sym_filter] = ACTIONS(563),
    [anon_sym_mul] = ACTIONS(563),
    [anon_sym_urem] = ACTIONS(563),
    [anon_sym_srem] = ACTIONS(563),
    [anon_sym_shl] = ACTIONS(563),
    [anon_sym_udiv] = ACTIONS(563),
    [anon_sym_sdiv] = ACTIONS(563),
    [anon_sym_lshr] = ACTIONS(563),
    [anon_sym_ashr] = ACTIONS(563),
    [anon_sym_fmul] = ACTIONS(563),
    [anon_sym_fdiv] = ACTIONS(563),
    [anon_sym_frem] = ACTIONS(563),
    [anon_sym_xchg] = ACTIONS(563),
    [anon_sym_add] = ACTIONS(563),
    [anon_sym_sub] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(563),
    [anon_sym_nand] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(563),
    [anon_sym_xor] = ACTIONS(563),
    [anon_sym_max] = ACTIONS(563),
    [anon_sym_min] = ACTIONS(563),
    [anon_sym_umax] = ACTIONS(563),
    [anon_sym_umin] = ACTIONS(563),
    [anon_sym_fadd] = ACTIONS(563),
    [anon_sym_fsub] = ACTIONS(563),
    [anon_sym_bitcast] = ACTIONS(563),
    [anon_sym_trunc] = ACTIONS(563),
    [anon_sym_zext] = ACTIONS(563),
    [anon_sym_sext] = ACTIONS(563),
    [anon_sym_fptrunc] = ACTIONS(563),
    [anon_sym_fpext] = ACTIONS(563),
    [anon_sym_addrspacecast] = ACTIONS(563),
    [anon_sym_uitofp] = ACTIONS(563),
    [anon_sym_sitofp] = ACTIONS(563),
    [anon_sym_fptoui] = ACTIONS(563),
    [anon_sym_fptosi] = ACTIONS(563),
    [anon_sym_inttoptr] = ACTIONS(563),
    [anon_sym_ptrtoint] = ACTIONS(563),
    [anon_sym_unordered] = ACTIONS(563),
    [anon_sym_monotonic] = ACTIONS(563),
    [anon_sym_acquire] = ACTIONS(563),
    [anon_sym_release] = ACTIONS(563),
    [anon_sym_acq_rel] = ACTIONS(563),
    [anon_sym_seq_cst] = ACTIONS(563),
    [anon_sym_syncscope] = ACTIONS(563),
    [anon_sym_uselistorder] = ACTIONS(563),
  },
  [161] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [sym_label] = ACTIONS(545),
    [sym_string] = ACTIONS(547),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_section] = ACTIONS(547),
    [anon_sym_partition] = ACTIONS(547),
    [anon_sym_comdat] = ACTIONS(547),
    [anon_sym_gc] = ACTIONS(547),
    [anon_sym_prefix] = ACTIONS(547),
    [anon_sym_prologue] = ACTIONS(547),
    [anon_sym_personality] = ACTIONS(547),
    [anon_sym_alignstack] = ACTIONS(547),
    [anon_sym_allocsize] = ACTIONS(547),
    [anon_sym_alwaysinline] = ACTIONS(547),
    [anon_sym_builtin] = ACTIONS(547),
    [anon_sym_cold] = ACTIONS(547),
    [anon_sym_convergent] = ACTIONS(547),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(547),
    [anon_sym_hot] = ACTIONS(547),
    [anon_sym_inaccessiblememonly] = ACTIONS(547),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(547),
    [anon_sym_inlinehint] = ACTIONS(547),
    [anon_sym_jumptable] = ACTIONS(547),
    [anon_sym_minsize] = ACTIONS(547),
    [anon_sym_naked] = ACTIONS(547),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(547),
    [anon_sym_nobuiltin] = ACTIONS(547),
    [anon_sym_noduplicate] = ACTIONS(547),
    [anon_sym_nofree] = ACTIONS(547),
    [anon_sym_noimplicitfloat] = ACTIONS(547),
    [anon_sym_noinline] = ACTIONS(547),
    [anon_sym_nomerge] = ACTIONS(547),
    [anon_sym_nonlazybind] = ACTIONS(547),
    [anon_sym_noprofile] = ACTIONS(547),
    [anon_sym_noredzone] = ACTIONS(547),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(547),
    [anon_sym_noreturn] = ACTIONS(547),
    [anon_sym_norecurse] = ACTIONS(547),
    [anon_sym_willreturn] = ACTIONS(547),
    [anon_sym_nosync] = ACTIONS(547),
    [anon_sym_nounwind] = ACTIONS(547),
    [anon_sym_nosanitize_coverage] = ACTIONS(547),
    [anon_sym_null_pointer_is_valid] = ACTIONS(547),
    [anon_sym_optforfuzzing] = ACTIONS(547),
    [anon_sym_optnone] = ACTIONS(547),
    [anon_sym_optsize] = ACTIONS(547),
    [anon_sym_readnone] = ACTIONS(547),
    [anon_sym_readonly] = ACTIONS(547),
    [anon_sym_writeonly] = ACTIONS(547),
    [anon_sym_argmemonly] = ACTIONS(547),
    [anon_sym_returns_twice] = ACTIONS(547),
    [anon_sym_safestack] = ACTIONS(547),
    [anon_sym_sanitize_address] = ACTIONS(547),
    [anon_sym_sanitize_memory] = ACTIONS(547),
    [anon_sym_sanitize_thread] = ACTIONS(547),
    [anon_sym_sanitize_hwaddress] = ACTIONS(547),
    [anon_sym_sanitize_memtag] = ACTIONS(547),
    [anon_sym_speculative_load_hardening] = ACTIONS(547),
    [anon_sym_speculatable] = ACTIONS(547),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(547),
    [anon_sym_sspreq] = ACTIONS(547),
    [anon_sym_strictfp] = ACTIONS(547),
    [anon_sym_uwtable] = ACTIONS(547),
    [anon_sym_nocf_check] = ACTIONS(547),
    [anon_sym_shadowcallstack] = ACTIONS(547),
    [anon_sym_mustprogress] = ACTIONS(547),
    [anon_sym_vscale_range] = ACTIONS(547),
    [anon_sym_preallocated] = ACTIONS(547),
    [anon_sym_zeroext] = ACTIONS(547),
    [anon_sym_signext] = ACTIONS(547),
    [anon_sym_inreg] = ACTIONS(547),
    [anon_sym_byval] = ACTIONS(547),
    [anon_sym_byref] = ACTIONS(547),
    [anon_sym_inalloca] = ACTIONS(547),
    [anon_sym_sret] = ACTIONS(547),
    [anon_sym_elementtype] = ACTIONS(547),
    [anon_sym_noalias] = ACTIONS(547),
    [anon_sym_nocapture] = ACTIONS(547),
    [anon_sym_nest] = ACTIONS(547),
    [anon_sym_returned] = ACTIONS(547),
    [anon_sym_nonnull] = ACTIONS(547),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(547),
    [anon_sym_swiftself] = ACTIONS(547),
    [anon_sym_swiftasync] = ACTIONS(547),
    [anon_sym_swifterror] = ACTIONS(547),
    [anon_sym_immarg] = ACTIONS(547),
    [anon_sym_noundef] = ACTIONS(547),
    [anon_sym_unreachable] = ACTIONS(547),
    [anon_sym_ret] = ACTIONS(547),
    [anon_sym_br] = ACTIONS(547),
    [anon_sym_resume] = ACTIONS(547),
    [anon_sym_freeze] = ACTIONS(547),
    [anon_sym_indirectbr] = ACTIONS(547),
    [anon_sym_extractelement] = ACTIONS(547),
    [anon_sym_insertelement] = ACTIONS(547),
    [anon_sym_select] = ACTIONS(547),
    [anon_sym_shufflevector] = ACTIONS(547),
    [anon_sym_fneg] = ACTIONS(547),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_invoke] = ACTIONS(547),
    [anon_sym_cleanupret] = ACTIONS(547),
    [anon_sym_catchret] = ACTIONS(547),
    [anon_sym_catchswitch] = ACTIONS(547),
    [anon_sym_catchpad] = ACTIONS(547),
    [anon_sym_cleanuppad] = ACTIONS(547),
    [anon_sym_callbr] = ACTIONS(547),
    [anon_sym_icmp] = ACTIONS(547),
    [anon_sym_fcmp] = ACTIONS(547),
    [anon_sym_va_arg] = ACTIONS(547),
    [anon_sym_phi] = ACTIONS(547),
    [anon_sym_landingpad] = ACTIONS(547),
    [anon_sym_tail] = ACTIONS(547),
    [anon_sym_musttail] = ACTIONS(547),
    [anon_sym_notail] = ACTIONS(547),
    [anon_sym_call] = ACTIONS(547),
    [anon_sym_alloca] = ACTIONS(547),
    [anon_sym_load] = ACTIONS(547),
    [anon_sym_store] = ACTIONS(547),
    [anon_sym_cmpxchg] = ACTIONS(547),
    [anon_sym_atomicrmw] = ACTIONS(547),
    [anon_sym_fence] = ACTIONS(547),
    [anon_sym_getelementptr] = ACTIONS(547),
    [anon_sym_extractvalue] = ACTIONS(547),
    [anon_sym_insertvalue] = ACTIONS(547),
    [anon_sym_catch] = ACTIONS(547),
    [anon_sym_filter] = ACTIONS(547),
    [anon_sym_mul] = ACTIONS(547),
    [anon_sym_urem] = ACTIONS(547),
    [anon_sym_srem] = ACTIONS(547),
    [anon_sym_shl] = ACTIONS(547),
    [anon_sym_udiv] = ACTIONS(547),
    [anon_sym_sdiv] = ACTIONS(547),
    [anon_sym_lshr] = ACTIONS(547),
    [anon_sym_ashr] = ACTIONS(547),
    [anon_sym_fmul] = ACTIONS(547),
    [anon_sym_fdiv] = ACTIONS(547),
    [anon_sym_frem] = ACTIONS(547),
    [anon_sym_xchg] = ACTIONS(547),
    [anon_sym_add] = ACTIONS(547),
    [anon_sym_sub] = ACTIONS(547),
    [anon_sym_and] = ACTIONS(547),
    [anon_sym_nand] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(547),
    [anon_sym_xor] = ACTIONS(547),
    [anon_sym_max] = ACTIONS(547),
    [anon_sym_min] = ACTIONS(547),
    [anon_sym_umax] = ACTIONS(547),
    [anon_sym_umin] = ACTIONS(547),
    [anon_sym_fadd] = ACTIONS(547),
    [anon_sym_fsub] = ACTIONS(547),
    [anon_sym_bitcast] = ACTIONS(547),
    [anon_sym_trunc] = ACTIONS(547),
    [anon_sym_zext] = ACTIONS(547),
    [anon_sym_sext] = ACTIONS(547),
    [anon_sym_fptrunc] = ACTIONS(547),
    [anon_sym_fpext] = ACTIONS(547),
    [anon_sym_addrspacecast] = ACTIONS(547),
    [anon_sym_uitofp] = ACTIONS(547),
    [anon_sym_sitofp] = ACTIONS(547),
    [anon_sym_fptoui] = ACTIONS(547),
    [anon_sym_fptosi] = ACTIONS(547),
    [anon_sym_inttoptr] = ACTIONS(547),
    [anon_sym_ptrtoint] = ACTIONS(547),
    [anon_sym_unordered] = ACTIONS(547),
    [anon_sym_monotonic] = ACTIONS(547),
    [anon_sym_acquire] = ACTIONS(547),
    [anon_sym_release] = ACTIONS(547),
    [anon_sym_acq_rel] = ACTIONS(547),
    [anon_sym_seq_cst] = ACTIONS(547),
    [anon_sym_syncscope] = ACTIONS(547),
    [anon_sym_uselistorder] = ACTIONS(547),
  },
  [162] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [sym_label] = ACTIONS(513),
    [sym_string] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_section] = ACTIONS(515),
    [anon_sym_partition] = ACTIONS(515),
    [anon_sym_comdat] = ACTIONS(515),
    [anon_sym_gc] = ACTIONS(515),
    [anon_sym_prefix] = ACTIONS(515),
    [anon_sym_prologue] = ACTIONS(515),
    [anon_sym_personality] = ACTIONS(515),
    [anon_sym_alignstack] = ACTIONS(515),
    [anon_sym_allocsize] = ACTIONS(515),
    [anon_sym_alwaysinline] = ACTIONS(515),
    [anon_sym_builtin] = ACTIONS(515),
    [anon_sym_cold] = ACTIONS(515),
    [anon_sym_convergent] = ACTIONS(515),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(515),
    [anon_sym_hot] = ACTIONS(515),
    [anon_sym_inaccessiblememonly] = ACTIONS(515),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(515),
    [anon_sym_inlinehint] = ACTIONS(515),
    [anon_sym_jumptable] = ACTIONS(515),
    [anon_sym_minsize] = ACTIONS(515),
    [anon_sym_naked] = ACTIONS(515),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(515),
    [anon_sym_nobuiltin] = ACTIONS(515),
    [anon_sym_noduplicate] = ACTIONS(515),
    [anon_sym_nofree] = ACTIONS(515),
    [anon_sym_noimplicitfloat] = ACTIONS(515),
    [anon_sym_noinline] = ACTIONS(515),
    [anon_sym_nomerge] = ACTIONS(515),
    [anon_sym_nonlazybind] = ACTIONS(515),
    [anon_sym_noprofile] = ACTIONS(515),
    [anon_sym_noredzone] = ACTIONS(515),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(515),
    [anon_sym_noreturn] = ACTIONS(515),
    [anon_sym_norecurse] = ACTIONS(515),
    [anon_sym_willreturn] = ACTIONS(515),
    [anon_sym_nosync] = ACTIONS(515),
    [anon_sym_nounwind] = ACTIONS(515),
    [anon_sym_nosanitize_coverage] = ACTIONS(515),
    [anon_sym_null_pointer_is_valid] = ACTIONS(515),
    [anon_sym_optforfuzzing] = ACTIONS(515),
    [anon_sym_optnone] = ACTIONS(515),
    [anon_sym_optsize] = ACTIONS(515),
    [anon_sym_readnone] = ACTIONS(515),
    [anon_sym_readonly] = ACTIONS(515),
    [anon_sym_writeonly] = ACTIONS(515),
    [anon_sym_argmemonly] = ACTIONS(515),
    [anon_sym_returns_twice] = ACTIONS(515),
    [anon_sym_safestack] = ACTIONS(515),
    [anon_sym_sanitize_address] = ACTIONS(515),
    [anon_sym_sanitize_memory] = ACTIONS(515),
    [anon_sym_sanitize_thread] = ACTIONS(515),
    [anon_sym_sanitize_hwaddress] = ACTIONS(515),
    [anon_sym_sanitize_memtag] = ACTIONS(515),
    [anon_sym_speculative_load_hardening] = ACTIONS(515),
    [anon_sym_speculatable] = ACTIONS(515),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(515),
    [anon_sym_sspreq] = ACTIONS(515),
    [anon_sym_strictfp] = ACTIONS(515),
    [anon_sym_uwtable] = ACTIONS(515),
    [anon_sym_nocf_check] = ACTIONS(515),
    [anon_sym_shadowcallstack] = ACTIONS(515),
    [anon_sym_mustprogress] = ACTIONS(515),
    [anon_sym_vscale_range] = ACTIONS(515),
    [anon_sym_preallocated] = ACTIONS(515),
    [anon_sym_zeroext] = ACTIONS(515),
    [anon_sym_signext] = ACTIONS(515),
    [anon_sym_inreg] = ACTIONS(515),
    [anon_sym_byval] = ACTIONS(515),
    [anon_sym_byref] = ACTIONS(515),
    [anon_sym_inalloca] = ACTIONS(515),
    [anon_sym_sret] = ACTIONS(515),
    [anon_sym_elementtype] = ACTIONS(515),
    [anon_sym_noalias] = ACTIONS(515),
    [anon_sym_nocapture] = ACTIONS(515),
    [anon_sym_nest] = ACTIONS(515),
    [anon_sym_returned] = ACTIONS(515),
    [anon_sym_nonnull] = ACTIONS(515),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(515),
    [anon_sym_swiftself] = ACTIONS(515),
    [anon_sym_swiftasync] = ACTIONS(515),
    [anon_sym_swifterror] = ACTIONS(515),
    [anon_sym_immarg] = ACTIONS(515),
    [anon_sym_noundef] = ACTIONS(515),
    [anon_sym_unreachable] = ACTIONS(515),
    [anon_sym_ret] = ACTIONS(515),
    [anon_sym_br] = ACTIONS(515),
    [anon_sym_resume] = ACTIONS(515),
    [anon_sym_freeze] = ACTIONS(515),
    [anon_sym_indirectbr] = ACTIONS(515),
    [anon_sym_extractelement] = ACTIONS(515),
    [anon_sym_insertelement] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_shufflevector] = ACTIONS(515),
    [anon_sym_fneg] = ACTIONS(515),
    [anon_sym_switch] = ACTIONS(515),
    [anon_sym_invoke] = ACTIONS(515),
    [anon_sym_cleanupret] = ACTIONS(515),
    [anon_sym_catchret] = ACTIONS(515),
    [anon_sym_catchswitch] = ACTIONS(515),
    [anon_sym_catchpad] = ACTIONS(515),
    [anon_sym_cleanuppad] = ACTIONS(515),
    [anon_sym_callbr] = ACTIONS(515),
    [anon_sym_icmp] = ACTIONS(515),
    [anon_sym_fcmp] = ACTIONS(515),
    [anon_sym_va_arg] = ACTIONS(515),
    [anon_sym_phi] = ACTIONS(515),
    [anon_sym_landingpad] = ACTIONS(515),
    [anon_sym_tail] = ACTIONS(515),
    [anon_sym_musttail] = ACTIONS(515),
    [anon_sym_notail] = ACTIONS(515),
    [anon_sym_call] = ACTIONS(515),
    [anon_sym_alloca] = ACTIONS(515),
    [anon_sym_load] = ACTIONS(515),
    [anon_sym_store] = ACTIONS(515),
    [anon_sym_cmpxchg] = ACTIONS(515),
    [anon_sym_atomicrmw] = ACTIONS(515),
    [anon_sym_fence] = ACTIONS(515),
    [anon_sym_getelementptr] = ACTIONS(515),
    [anon_sym_extractvalue] = ACTIONS(515),
    [anon_sym_insertvalue] = ACTIONS(515),
    [anon_sym_catch] = ACTIONS(515),
    [anon_sym_filter] = ACTIONS(515),
    [anon_sym_mul] = ACTIONS(515),
    [anon_sym_urem] = ACTIONS(515),
    [anon_sym_srem] = ACTIONS(515),
    [anon_sym_shl] = ACTIONS(515),
    [anon_sym_udiv] = ACTIONS(515),
    [anon_sym_sdiv] = ACTIONS(515),
    [anon_sym_lshr] = ACTIONS(515),
    [anon_sym_ashr] = ACTIONS(515),
    [anon_sym_fmul] = ACTIONS(515),
    [anon_sym_fdiv] = ACTIONS(515),
    [anon_sym_frem] = ACTIONS(515),
    [anon_sym_xchg] = ACTIONS(515),
    [anon_sym_add] = ACTIONS(515),
    [anon_sym_sub] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_nand] = ACTIONS(515),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_xor] = ACTIONS(515),
    [anon_sym_max] = ACTIONS(515),
    [anon_sym_min] = ACTIONS(515),
    [anon_sym_umax] = ACTIONS(515),
    [anon_sym_umin] = ACTIONS(515),
    [anon_sym_fadd] = ACTIONS(515),
    [anon_sym_fsub] = ACTIONS(515),
    [anon_sym_bitcast] = ACTIONS(515),
    [anon_sym_trunc] = ACTIONS(515),
    [anon_sym_zext] = ACTIONS(515),
    [anon_sym_sext] = ACTIONS(515),
    [anon_sym_fptrunc] = ACTIONS(515),
    [anon_sym_fpext] = ACTIONS(515),
    [anon_sym_addrspacecast] = ACTIONS(515),
    [anon_sym_uitofp] = ACTIONS(515),
    [anon_sym_sitofp] = ACTIONS(515),
    [anon_sym_fptoui] = ACTIONS(515),
    [anon_sym_fptosi] = ACTIONS(515),
    [anon_sym_inttoptr] = ACTIONS(515),
    [anon_sym_ptrtoint] = ACTIONS(515),
    [anon_sym_unordered] = ACTIONS(515),
    [anon_sym_monotonic] = ACTIONS(515),
    [anon_sym_acquire] = ACTIONS(515),
    [anon_sym_release] = ACTIONS(515),
    [anon_sym_acq_rel] = ACTIONS(515),
    [anon_sym_seq_cst] = ACTIONS(515),
    [anon_sym_syncscope] = ACTIONS(515),
    [anon_sym_uselistorder] = ACTIONS(515),
  },
  [163] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [sym_label] = ACTIONS(541),
    [sym_string] = ACTIONS(543),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_section] = ACTIONS(543),
    [anon_sym_partition] = ACTIONS(543),
    [anon_sym_comdat] = ACTIONS(543),
    [anon_sym_gc] = ACTIONS(543),
    [anon_sym_prefix] = ACTIONS(543),
    [anon_sym_prologue] = ACTIONS(543),
    [anon_sym_personality] = ACTIONS(543),
    [anon_sym_alignstack] = ACTIONS(543),
    [anon_sym_allocsize] = ACTIONS(543),
    [anon_sym_alwaysinline] = ACTIONS(543),
    [anon_sym_builtin] = ACTIONS(543),
    [anon_sym_cold] = ACTIONS(543),
    [anon_sym_convergent] = ACTIONS(543),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(543),
    [anon_sym_hot] = ACTIONS(543),
    [anon_sym_inaccessiblememonly] = ACTIONS(543),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(543),
    [anon_sym_inlinehint] = ACTIONS(543),
    [anon_sym_jumptable] = ACTIONS(543),
    [anon_sym_minsize] = ACTIONS(543),
    [anon_sym_naked] = ACTIONS(543),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(543),
    [anon_sym_nobuiltin] = ACTIONS(543),
    [anon_sym_noduplicate] = ACTIONS(543),
    [anon_sym_nofree] = ACTIONS(543),
    [anon_sym_noimplicitfloat] = ACTIONS(543),
    [anon_sym_noinline] = ACTIONS(543),
    [anon_sym_nomerge] = ACTIONS(543),
    [anon_sym_nonlazybind] = ACTIONS(543),
    [anon_sym_noprofile] = ACTIONS(543),
    [anon_sym_noredzone] = ACTIONS(543),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(543),
    [anon_sym_noreturn] = ACTIONS(543),
    [anon_sym_norecurse] = ACTIONS(543),
    [anon_sym_willreturn] = ACTIONS(543),
    [anon_sym_nosync] = ACTIONS(543),
    [anon_sym_nounwind] = ACTIONS(543),
    [anon_sym_nosanitize_coverage] = ACTIONS(543),
    [anon_sym_null_pointer_is_valid] = ACTIONS(543),
    [anon_sym_optforfuzzing] = ACTIONS(543),
    [anon_sym_optnone] = ACTIONS(543),
    [anon_sym_optsize] = ACTIONS(543),
    [anon_sym_readnone] = ACTIONS(543),
    [anon_sym_readonly] = ACTIONS(543),
    [anon_sym_writeonly] = ACTIONS(543),
    [anon_sym_argmemonly] = ACTIONS(543),
    [anon_sym_returns_twice] = ACTIONS(543),
    [anon_sym_safestack] = ACTIONS(543),
    [anon_sym_sanitize_address] = ACTIONS(543),
    [anon_sym_sanitize_memory] = ACTIONS(543),
    [anon_sym_sanitize_thread] = ACTIONS(543),
    [anon_sym_sanitize_hwaddress] = ACTIONS(543),
    [anon_sym_sanitize_memtag] = ACTIONS(543),
    [anon_sym_speculative_load_hardening] = ACTIONS(543),
    [anon_sym_speculatable] = ACTIONS(543),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(543),
    [anon_sym_sspreq] = ACTIONS(543),
    [anon_sym_strictfp] = ACTIONS(543),
    [anon_sym_uwtable] = ACTIONS(543),
    [anon_sym_nocf_check] = ACTIONS(543),
    [anon_sym_shadowcallstack] = ACTIONS(543),
    [anon_sym_mustprogress] = ACTIONS(543),
    [anon_sym_vscale_range] = ACTIONS(543),
    [anon_sym_preallocated] = ACTIONS(543),
    [anon_sym_zeroext] = ACTIONS(543),
    [anon_sym_signext] = ACTIONS(543),
    [anon_sym_inreg] = ACTIONS(543),
    [anon_sym_byval] = ACTIONS(543),
    [anon_sym_byref] = ACTIONS(543),
    [anon_sym_inalloca] = ACTIONS(543),
    [anon_sym_sret] = ACTIONS(543),
    [anon_sym_elementtype] = ACTIONS(543),
    [anon_sym_noalias] = ACTIONS(543),
    [anon_sym_nocapture] = ACTIONS(543),
    [anon_sym_nest] = ACTIONS(543),
    [anon_sym_returned] = ACTIONS(543),
    [anon_sym_nonnull] = ACTIONS(543),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(543),
    [anon_sym_swiftself] = ACTIONS(543),
    [anon_sym_swiftasync] = ACTIONS(543),
    [anon_sym_swifterror] = ACTIONS(543),
    [anon_sym_immarg] = ACTIONS(543),
    [anon_sym_noundef] = ACTIONS(543),
    [anon_sym_unreachable] = ACTIONS(543),
    [anon_sym_ret] = ACTIONS(543),
    [anon_sym_br] = ACTIONS(543),
    [anon_sym_resume] = ACTIONS(543),
    [anon_sym_freeze] = ACTIONS(543),
    [anon_sym_indirectbr] = ACTIONS(543),
    [anon_sym_extractelement] = ACTIONS(543),
    [anon_sym_insertelement] = ACTIONS(543),
    [anon_sym_select] = ACTIONS(543),
    [anon_sym_shufflevector] = ACTIONS(543),
    [anon_sym_fneg] = ACTIONS(543),
    [anon_sym_switch] = ACTIONS(543),
    [anon_sym_invoke] = ACTIONS(543),
    [anon_sym_cleanupret] = ACTIONS(543),
    [anon_sym_catchret] = ACTIONS(543),
    [anon_sym_catchswitch] = ACTIONS(543),
    [anon_sym_catchpad] = ACTIONS(543),
    [anon_sym_cleanuppad] = ACTIONS(543),
    [anon_sym_callbr] = ACTIONS(543),
    [anon_sym_icmp] = ACTIONS(543),
    [anon_sym_fcmp] = ACTIONS(543),
    [anon_sym_va_arg] = ACTIONS(543),
    [anon_sym_phi] = ACTIONS(543),
    [anon_sym_landingpad] = ACTIONS(543),
    [anon_sym_tail] = ACTIONS(543),
    [anon_sym_musttail] = ACTIONS(543),
    [anon_sym_notail] = ACTIONS(543),
    [anon_sym_call] = ACTIONS(543),
    [anon_sym_alloca] = ACTIONS(543),
    [anon_sym_load] = ACTIONS(543),
    [anon_sym_store] = ACTIONS(543),
    [anon_sym_cmpxchg] = ACTIONS(543),
    [anon_sym_atomicrmw] = ACTIONS(543),
    [anon_sym_fence] = ACTIONS(543),
    [anon_sym_getelementptr] = ACTIONS(543),
    [anon_sym_extractvalue] = ACTIONS(543),
    [anon_sym_insertvalue] = ACTIONS(543),
    [anon_sym_catch] = ACTIONS(543),
    [anon_sym_filter] = ACTIONS(543),
    [anon_sym_mul] = ACTIONS(543),
    [anon_sym_urem] = ACTIONS(543),
    [anon_sym_srem] = ACTIONS(543),
    [anon_sym_shl] = ACTIONS(543),
    [anon_sym_udiv] = ACTIONS(543),
    [anon_sym_sdiv] = ACTIONS(543),
    [anon_sym_lshr] = ACTIONS(543),
    [anon_sym_ashr] = ACTIONS(543),
    [anon_sym_fmul] = ACTIONS(543),
    [anon_sym_fdiv] = ACTIONS(543),
    [anon_sym_frem] = ACTIONS(543),
    [anon_sym_xchg] = ACTIONS(543),
    [anon_sym_add] = ACTIONS(543),
    [anon_sym_sub] = ACTIONS(543),
    [anon_sym_and] = ACTIONS(543),
    [anon_sym_nand] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(543),
    [anon_sym_xor] = ACTIONS(543),
    [anon_sym_max] = ACTIONS(543),
    [anon_sym_min] = ACTIONS(543),
    [anon_sym_umax] = ACTIONS(543),
    [anon_sym_umin] = ACTIONS(543),
    [anon_sym_fadd] = ACTIONS(543),
    [anon_sym_fsub] = ACTIONS(543),
    [anon_sym_bitcast] = ACTIONS(543),
    [anon_sym_trunc] = ACTIONS(543),
    [anon_sym_zext] = ACTIONS(543),
    [anon_sym_sext] = ACTIONS(543),
    [anon_sym_fptrunc] = ACTIONS(543),
    [anon_sym_fpext] = ACTIONS(543),
    [anon_sym_addrspacecast] = ACTIONS(543),
    [anon_sym_uitofp] = ACTIONS(543),
    [anon_sym_sitofp] = ACTIONS(543),
    [anon_sym_fptoui] = ACTIONS(543),
    [anon_sym_fptosi] = ACTIONS(543),
    [anon_sym_inttoptr] = ACTIONS(543),
    [anon_sym_ptrtoint] = ACTIONS(543),
    [anon_sym_unordered] = ACTIONS(543),
    [anon_sym_monotonic] = ACTIONS(543),
    [anon_sym_acquire] = ACTIONS(543),
    [anon_sym_release] = ACTIONS(543),
    [anon_sym_acq_rel] = ACTIONS(543),
    [anon_sym_seq_cst] = ACTIONS(543),
    [anon_sym_syncscope] = ACTIONS(543),
    [anon_sym_uselistorder] = ACTIONS(543),
  },
  [164] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [sym_label] = ACTIONS(521),
    [sym_string] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_section] = ACTIONS(523),
    [anon_sym_partition] = ACTIONS(523),
    [anon_sym_comdat] = ACTIONS(523),
    [anon_sym_gc] = ACTIONS(523),
    [anon_sym_prefix] = ACTIONS(523),
    [anon_sym_prologue] = ACTIONS(523),
    [anon_sym_personality] = ACTIONS(523),
    [anon_sym_alignstack] = ACTIONS(523),
    [anon_sym_allocsize] = ACTIONS(523),
    [anon_sym_alwaysinline] = ACTIONS(523),
    [anon_sym_builtin] = ACTIONS(523),
    [anon_sym_cold] = ACTIONS(523),
    [anon_sym_convergent] = ACTIONS(523),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(523),
    [anon_sym_hot] = ACTIONS(523),
    [anon_sym_inaccessiblememonly] = ACTIONS(523),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(523),
    [anon_sym_inlinehint] = ACTIONS(523),
    [anon_sym_jumptable] = ACTIONS(523),
    [anon_sym_minsize] = ACTIONS(523),
    [anon_sym_naked] = ACTIONS(523),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(523),
    [anon_sym_nobuiltin] = ACTIONS(523),
    [anon_sym_noduplicate] = ACTIONS(523),
    [anon_sym_nofree] = ACTIONS(523),
    [anon_sym_noimplicitfloat] = ACTIONS(523),
    [anon_sym_noinline] = ACTIONS(523),
    [anon_sym_nomerge] = ACTIONS(523),
    [anon_sym_nonlazybind] = ACTIONS(523),
    [anon_sym_noprofile] = ACTIONS(523),
    [anon_sym_noredzone] = ACTIONS(523),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(523),
    [anon_sym_noreturn] = ACTIONS(523),
    [anon_sym_norecurse] = ACTIONS(523),
    [anon_sym_willreturn] = ACTIONS(523),
    [anon_sym_nosync] = ACTIONS(523),
    [anon_sym_nounwind] = ACTIONS(523),
    [anon_sym_nosanitize_coverage] = ACTIONS(523),
    [anon_sym_null_pointer_is_valid] = ACTIONS(523),
    [anon_sym_optforfuzzing] = ACTIONS(523),
    [anon_sym_optnone] = ACTIONS(523),
    [anon_sym_optsize] = ACTIONS(523),
    [anon_sym_readnone] = ACTIONS(523),
    [anon_sym_readonly] = ACTIONS(523),
    [anon_sym_writeonly] = ACTIONS(523),
    [anon_sym_argmemonly] = ACTIONS(523),
    [anon_sym_returns_twice] = ACTIONS(523),
    [anon_sym_safestack] = ACTIONS(523),
    [anon_sym_sanitize_address] = ACTIONS(523),
    [anon_sym_sanitize_memory] = ACTIONS(523),
    [anon_sym_sanitize_thread] = ACTIONS(523),
    [anon_sym_sanitize_hwaddress] = ACTIONS(523),
    [anon_sym_sanitize_memtag] = ACTIONS(523),
    [anon_sym_speculative_load_hardening] = ACTIONS(523),
    [anon_sym_speculatable] = ACTIONS(523),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(523),
    [anon_sym_sspreq] = ACTIONS(523),
    [anon_sym_strictfp] = ACTIONS(523),
    [anon_sym_uwtable] = ACTIONS(523),
    [anon_sym_nocf_check] = ACTIONS(523),
    [anon_sym_shadowcallstack] = ACTIONS(523),
    [anon_sym_mustprogress] = ACTIONS(523),
    [anon_sym_vscale_range] = ACTIONS(523),
    [anon_sym_preallocated] = ACTIONS(523),
    [anon_sym_zeroext] = ACTIONS(523),
    [anon_sym_signext] = ACTIONS(523),
    [anon_sym_inreg] = ACTIONS(523),
    [anon_sym_byval] = ACTIONS(523),
    [anon_sym_byref] = ACTIONS(523),
    [anon_sym_inalloca] = ACTIONS(523),
    [anon_sym_sret] = ACTIONS(523),
    [anon_sym_elementtype] = ACTIONS(523),
    [anon_sym_noalias] = ACTIONS(523),
    [anon_sym_nocapture] = ACTIONS(523),
    [anon_sym_nest] = ACTIONS(523),
    [anon_sym_returned] = ACTIONS(523),
    [anon_sym_nonnull] = ACTIONS(523),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(523),
    [anon_sym_swiftself] = ACTIONS(523),
    [anon_sym_swiftasync] = ACTIONS(523),
    [anon_sym_swifterror] = ACTIONS(523),
    [anon_sym_immarg] = ACTIONS(523),
    [anon_sym_noundef] = ACTIONS(523),
    [anon_sym_unreachable] = ACTIONS(523),
    [anon_sym_ret] = ACTIONS(523),
    [anon_sym_br] = ACTIONS(523),
    [anon_sym_resume] = ACTIONS(523),
    [anon_sym_freeze] = ACTIONS(523),
    [anon_sym_indirectbr] = ACTIONS(523),
    [anon_sym_extractelement] = ACTIONS(523),
    [anon_sym_insertelement] = ACTIONS(523),
    [anon_sym_select] = ACTIONS(523),
    [anon_sym_shufflevector] = ACTIONS(523),
    [anon_sym_fneg] = ACTIONS(523),
    [anon_sym_switch] = ACTIONS(523),
    [anon_sym_invoke] = ACTIONS(523),
    [anon_sym_cleanupret] = ACTIONS(523),
    [anon_sym_catchret] = ACTIONS(523),
    [anon_sym_catchswitch] = ACTIONS(523),
    [anon_sym_catchpad] = ACTIONS(523),
    [anon_sym_cleanuppad] = ACTIONS(523),
    [anon_sym_callbr] = ACTIONS(523),
    [anon_sym_icmp] = ACTIONS(523),
    [anon_sym_fcmp] = ACTIONS(523),
    [anon_sym_va_arg] = ACTIONS(523),
    [anon_sym_phi] = ACTIONS(523),
    [anon_sym_landingpad] = ACTIONS(523),
    [anon_sym_tail] = ACTIONS(523),
    [anon_sym_musttail] = ACTIONS(523),
    [anon_sym_notail] = ACTIONS(523),
    [anon_sym_call] = ACTIONS(523),
    [anon_sym_alloca] = ACTIONS(523),
    [anon_sym_load] = ACTIONS(523),
    [anon_sym_store] = ACTIONS(523),
    [anon_sym_cmpxchg] = ACTIONS(523),
    [anon_sym_atomicrmw] = ACTIONS(523),
    [anon_sym_fence] = ACTIONS(523),
    [anon_sym_getelementptr] = ACTIONS(523),
    [anon_sym_extractvalue] = ACTIONS(523),
    [anon_sym_insertvalue] = ACTIONS(523),
    [anon_sym_catch] = ACTIONS(523),
    [anon_sym_filter] = ACTIONS(523),
    [anon_sym_mul] = ACTIONS(523),
    [anon_sym_urem] = ACTIONS(523),
    [anon_sym_srem] = ACTIONS(523),
    [anon_sym_shl] = ACTIONS(523),
    [anon_sym_udiv] = ACTIONS(523),
    [anon_sym_sdiv] = ACTIONS(523),
    [anon_sym_lshr] = ACTIONS(523),
    [anon_sym_ashr] = ACTIONS(523),
    [anon_sym_fmul] = ACTIONS(523),
    [anon_sym_fdiv] = ACTIONS(523),
    [anon_sym_frem] = ACTIONS(523),
    [anon_sym_xchg] = ACTIONS(523),
    [anon_sym_add] = ACTIONS(523),
    [anon_sym_sub] = ACTIONS(523),
    [anon_sym_and] = ACTIONS(523),
    [anon_sym_nand] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(523),
    [anon_sym_xor] = ACTIONS(523),
    [anon_sym_max] = ACTIONS(523),
    [anon_sym_min] = ACTIONS(523),
    [anon_sym_umax] = ACTIONS(523),
    [anon_sym_umin] = ACTIONS(523),
    [anon_sym_fadd] = ACTIONS(523),
    [anon_sym_fsub] = ACTIONS(523),
    [anon_sym_bitcast] = ACTIONS(523),
    [anon_sym_trunc] = ACTIONS(523),
    [anon_sym_zext] = ACTIONS(523),
    [anon_sym_sext] = ACTIONS(523),
    [anon_sym_fptrunc] = ACTIONS(523),
    [anon_sym_fpext] = ACTIONS(523),
    [anon_sym_addrspacecast] = ACTIONS(523),
    [anon_sym_uitofp] = ACTIONS(523),
    [anon_sym_sitofp] = ACTIONS(523),
    [anon_sym_fptoui] = ACTIONS(523),
    [anon_sym_fptosi] = ACTIONS(523),
    [anon_sym_inttoptr] = ACTIONS(523),
    [anon_sym_ptrtoint] = ACTIONS(523),
    [anon_sym_unordered] = ACTIONS(523),
    [anon_sym_monotonic] = ACTIONS(523),
    [anon_sym_acquire] = ACTIONS(523),
    [anon_sym_release] = ACTIONS(523),
    [anon_sym_acq_rel] = ACTIONS(523),
    [anon_sym_seq_cst] = ACTIONS(523),
    [anon_sym_syncscope] = ACTIONS(523),
    [anon_sym_uselistorder] = ACTIONS(523),
  },
  [165] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [sym_label] = ACTIONS(667),
    [sym_string] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(669),
    [anon_sym_partition] = ACTIONS(669),
    [anon_sym_comdat] = ACTIONS(669),
    [anon_sym_gc] = ACTIONS(669),
    [anon_sym_prefix] = ACTIONS(669),
    [anon_sym_prologue] = ACTIONS(669),
    [anon_sym_personality] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(669),
    [anon_sym_allocsize] = ACTIONS(669),
    [anon_sym_alwaysinline] = ACTIONS(669),
    [anon_sym_builtin] = ACTIONS(669),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(669),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(669),
    [anon_sym_hot] = ACTIONS(669),
    [anon_sym_inaccessiblememonly] = ACTIONS(669),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(669),
    [anon_sym_inlinehint] = ACTIONS(669),
    [anon_sym_jumptable] = ACTIONS(669),
    [anon_sym_minsize] = ACTIONS(669),
    [anon_sym_naked] = ACTIONS(669),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(669),
    [anon_sym_nobuiltin] = ACTIONS(669),
    [anon_sym_noduplicate] = ACTIONS(669),
    [anon_sym_nofree] = ACTIONS(669),
    [anon_sym_noimplicitfloat] = ACTIONS(669),
    [anon_sym_noinline] = ACTIONS(669),
    [anon_sym_nomerge] = ACTIONS(669),
    [anon_sym_nonlazybind] = ACTIONS(669),
    [anon_sym_noprofile] = ACTIONS(669),
    [anon_sym_noredzone] = ACTIONS(669),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(669),
    [anon_sym_noreturn] = ACTIONS(669),
    [anon_sym_norecurse] = ACTIONS(669),
    [anon_sym_willreturn] = ACTIONS(669),
    [anon_sym_nosync] = ACTIONS(669),
    [anon_sym_nounwind] = ACTIONS(669),
    [anon_sym_nosanitize_coverage] = ACTIONS(669),
    [anon_sym_null_pointer_is_valid] = ACTIONS(669),
    [anon_sym_optforfuzzing] = ACTIONS(669),
    [anon_sym_optnone] = ACTIONS(669),
    [anon_sym_optsize] = ACTIONS(669),
    [anon_sym_readnone] = ACTIONS(669),
    [anon_sym_readonly] = ACTIONS(669),
    [anon_sym_writeonly] = ACTIONS(669),
    [anon_sym_argmemonly] = ACTIONS(669),
    [anon_sym_returns_twice] = ACTIONS(669),
    [anon_sym_safestack] = ACTIONS(669),
    [anon_sym_sanitize_address] = ACTIONS(669),
    [anon_sym_sanitize_memory] = ACTIONS(669),
    [anon_sym_sanitize_thread] = ACTIONS(669),
    [anon_sym_sanitize_hwaddress] = ACTIONS(669),
    [anon_sym_sanitize_memtag] = ACTIONS(669),
    [anon_sym_speculative_load_hardening] = ACTIONS(669),
    [anon_sym_speculatable] = ACTIONS(669),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(669),
    [anon_sym_sspreq] = ACTIONS(669),
    [anon_sym_strictfp] = ACTIONS(669),
    [anon_sym_uwtable] = ACTIONS(669),
    [anon_sym_nocf_check] = ACTIONS(669),
    [anon_sym_shadowcallstack] = ACTIONS(669),
    [anon_sym_mustprogress] = ACTIONS(669),
    [anon_sym_vscale_range] = ACTIONS(669),
    [anon_sym_preallocated] = ACTIONS(669),
    [anon_sym_zeroext] = ACTIONS(669),
    [anon_sym_signext] = ACTIONS(669),
    [anon_sym_inreg] = ACTIONS(669),
    [anon_sym_byval] = ACTIONS(669),
    [anon_sym_byref] = ACTIONS(669),
    [anon_sym_inalloca] = ACTIONS(669),
    [anon_sym_sret] = ACTIONS(669),
    [anon_sym_elementtype] = ACTIONS(669),
    [anon_sym_noalias] = ACTIONS(669),
    [anon_sym_nocapture] = ACTIONS(669),
    [anon_sym_nest] = ACTIONS(669),
    [anon_sym_returned] = ACTIONS(669),
    [anon_sym_nonnull] = ACTIONS(669),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(669),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(669),
    [anon_sym_noundef] = ACTIONS(669),
    [anon_sym_unreachable] = ACTIONS(669),
    [anon_sym_ret] = ACTIONS(669),
    [anon_sym_br] = ACTIONS(669),
    [anon_sym_resume] = ACTIONS(669),
    [anon_sym_freeze] = ACTIONS(669),
    [anon_sym_indirectbr] = ACTIONS(669),
    [anon_sym_extractelement] = ACTIONS(669),
    [anon_sym_insertelement] = ACTIONS(669),
    [anon_sym_select] = ACTIONS(669),
    [anon_sym_shufflevector] = ACTIONS(669),
    [anon_sym_fneg] = ACTIONS(669),
    [anon_sym_switch] = ACTIONS(669),
    [anon_sym_invoke] = ACTIONS(669),
    [anon_sym_cleanupret] = ACTIONS(669),
    [anon_sym_catchret] = ACTIONS(669),
    [anon_sym_catchswitch] = ACTIONS(669),
    [anon_sym_catchpad] = ACTIONS(669),
    [anon_sym_cleanuppad] = ACTIONS(669),
    [anon_sym_callbr] = ACTIONS(669),
    [anon_sym_icmp] = ACTIONS(669),
    [anon_sym_fcmp] = ACTIONS(669),
    [anon_sym_va_arg] = ACTIONS(669),
    [anon_sym_phi] = ACTIONS(669),
    [anon_sym_landingpad] = ACTIONS(669),
    [anon_sym_tail] = ACTIONS(669),
    [anon_sym_musttail] = ACTIONS(669),
    [anon_sym_notail] = ACTIONS(669),
    [anon_sym_call] = ACTIONS(669),
    [anon_sym_alloca] = ACTIONS(669),
    [anon_sym_load] = ACTIONS(669),
    [anon_sym_store] = ACTIONS(669),
    [anon_sym_cmpxchg] = ACTIONS(669),
    [anon_sym_atomicrmw] = ACTIONS(669),
    [anon_sym_fence] = ACTIONS(669),
    [anon_sym_getelementptr] = ACTIONS(669),
    [anon_sym_extractvalue] = ACTIONS(669),
    [anon_sym_insertvalue] = ACTIONS(669),
    [anon_sym_catch] = ACTIONS(669),
    [anon_sym_filter] = ACTIONS(669),
    [anon_sym_mul] = ACTIONS(669),
    [anon_sym_urem] = ACTIONS(669),
    [anon_sym_srem] = ACTIONS(669),
    [anon_sym_shl] = ACTIONS(669),
    [anon_sym_udiv] = ACTIONS(669),
    [anon_sym_sdiv] = ACTIONS(669),
    [anon_sym_lshr] = ACTIONS(669),
    [anon_sym_ashr] = ACTIONS(669),
    [anon_sym_fmul] = ACTIONS(669),
    [anon_sym_fdiv] = ACTIONS(669),
    [anon_sym_frem] = ACTIONS(669),
    [anon_sym_xchg] = ACTIONS(669),
    [anon_sym_add] = ACTIONS(669),
    [anon_sym_sub] = ACTIONS(669),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_nand] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_xor] = ACTIONS(669),
    [anon_sym_max] = ACTIONS(669),
    [anon_sym_min] = ACTIONS(669),
    [anon_sym_umax] = ACTIONS(669),
    [anon_sym_umin] = ACTIONS(669),
    [anon_sym_fadd] = ACTIONS(669),
    [anon_sym_fsub] = ACTIONS(669),
    [anon_sym_bitcast] = ACTIONS(669),
    [anon_sym_trunc] = ACTIONS(669),
    [anon_sym_zext] = ACTIONS(669),
    [anon_sym_sext] = ACTIONS(669),
    [anon_sym_fptrunc] = ACTIONS(669),
    [anon_sym_fpext] = ACTIONS(669),
    [anon_sym_addrspacecast] = ACTIONS(669),
    [anon_sym_uitofp] = ACTIONS(669),
    [anon_sym_sitofp] = ACTIONS(669),
    [anon_sym_fptoui] = ACTIONS(669),
    [anon_sym_fptosi] = ACTIONS(669),
    [anon_sym_inttoptr] = ACTIONS(669),
    [anon_sym_ptrtoint] = ACTIONS(669),
    [anon_sym_unordered] = ACTIONS(669),
    [anon_sym_monotonic] = ACTIONS(669),
    [anon_sym_acquire] = ACTIONS(669),
    [anon_sym_release] = ACTIONS(669),
    [anon_sym_acq_rel] = ACTIONS(669),
    [anon_sym_seq_cst] = ACTIONS(669),
    [anon_sym_syncscope] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
  },
  [166] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [sym_label] = ACTIONS(525),
    [sym_string] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_section] = ACTIONS(527),
    [anon_sym_partition] = ACTIONS(527),
    [anon_sym_comdat] = ACTIONS(527),
    [anon_sym_gc] = ACTIONS(527),
    [anon_sym_prefix] = ACTIONS(527),
    [anon_sym_prologue] = ACTIONS(527),
    [anon_sym_personality] = ACTIONS(527),
    [anon_sym_alignstack] = ACTIONS(527),
    [anon_sym_allocsize] = ACTIONS(527),
    [anon_sym_alwaysinline] = ACTIONS(527),
    [anon_sym_builtin] = ACTIONS(527),
    [anon_sym_cold] = ACTIONS(527),
    [anon_sym_convergent] = ACTIONS(527),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(527),
    [anon_sym_hot] = ACTIONS(527),
    [anon_sym_inaccessiblememonly] = ACTIONS(527),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(527),
    [anon_sym_inlinehint] = ACTIONS(527),
    [anon_sym_jumptable] = ACTIONS(527),
    [anon_sym_minsize] = ACTIONS(527),
    [anon_sym_naked] = ACTIONS(527),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(527),
    [anon_sym_nobuiltin] = ACTIONS(527),
    [anon_sym_noduplicate] = ACTIONS(527),
    [anon_sym_nofree] = ACTIONS(527),
    [anon_sym_noimplicitfloat] = ACTIONS(527),
    [anon_sym_noinline] = ACTIONS(527),
    [anon_sym_nomerge] = ACTIONS(527),
    [anon_sym_nonlazybind] = ACTIONS(527),
    [anon_sym_noprofile] = ACTIONS(527),
    [anon_sym_noredzone] = ACTIONS(527),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(527),
    [anon_sym_noreturn] = ACTIONS(527),
    [anon_sym_norecurse] = ACTIONS(527),
    [anon_sym_willreturn] = ACTIONS(527),
    [anon_sym_nosync] = ACTIONS(527),
    [anon_sym_nounwind] = ACTIONS(527),
    [anon_sym_nosanitize_coverage] = ACTIONS(527),
    [anon_sym_null_pointer_is_valid] = ACTIONS(527),
    [anon_sym_optforfuzzing] = ACTIONS(527),
    [anon_sym_optnone] = ACTIONS(527),
    [anon_sym_optsize] = ACTIONS(527),
    [anon_sym_readnone] = ACTIONS(527),
    [anon_sym_readonly] = ACTIONS(527),
    [anon_sym_writeonly] = ACTIONS(527),
    [anon_sym_argmemonly] = ACTIONS(527),
    [anon_sym_returns_twice] = ACTIONS(527),
    [anon_sym_safestack] = ACTIONS(527),
    [anon_sym_sanitize_address] = ACTIONS(527),
    [anon_sym_sanitize_memory] = ACTIONS(527),
    [anon_sym_sanitize_thread] = ACTIONS(527),
    [anon_sym_sanitize_hwaddress] = ACTIONS(527),
    [anon_sym_sanitize_memtag] = ACTIONS(527),
    [anon_sym_speculative_load_hardening] = ACTIONS(527),
    [anon_sym_speculatable] = ACTIONS(527),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(527),
    [anon_sym_sspreq] = ACTIONS(527),
    [anon_sym_strictfp] = ACTIONS(527),
    [anon_sym_uwtable] = ACTIONS(527),
    [anon_sym_nocf_check] = ACTIONS(527),
    [anon_sym_shadowcallstack] = ACTIONS(527),
    [anon_sym_mustprogress] = ACTIONS(527),
    [anon_sym_vscale_range] = ACTIONS(527),
    [anon_sym_preallocated] = ACTIONS(527),
    [anon_sym_zeroext] = ACTIONS(527),
    [anon_sym_signext] = ACTIONS(527),
    [anon_sym_inreg] = ACTIONS(527),
    [anon_sym_byval] = ACTIONS(527),
    [anon_sym_byref] = ACTIONS(527),
    [anon_sym_inalloca] = ACTIONS(527),
    [anon_sym_sret] = ACTIONS(527),
    [anon_sym_elementtype] = ACTIONS(527),
    [anon_sym_noalias] = ACTIONS(527),
    [anon_sym_nocapture] = ACTIONS(527),
    [anon_sym_nest] = ACTIONS(527),
    [anon_sym_returned] = ACTIONS(527),
    [anon_sym_nonnull] = ACTIONS(527),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(527),
    [anon_sym_swiftself] = ACTIONS(527),
    [anon_sym_swiftasync] = ACTIONS(527),
    [anon_sym_swifterror] = ACTIONS(527),
    [anon_sym_immarg] = ACTIONS(527),
    [anon_sym_noundef] = ACTIONS(527),
    [anon_sym_unreachable] = ACTIONS(527),
    [anon_sym_ret] = ACTIONS(527),
    [anon_sym_br] = ACTIONS(527),
    [anon_sym_resume] = ACTIONS(527),
    [anon_sym_freeze] = ACTIONS(527),
    [anon_sym_indirectbr] = ACTIONS(527),
    [anon_sym_extractelement] = ACTIONS(527),
    [anon_sym_insertelement] = ACTIONS(527),
    [anon_sym_select] = ACTIONS(527),
    [anon_sym_shufflevector] = ACTIONS(527),
    [anon_sym_fneg] = ACTIONS(527),
    [anon_sym_switch] = ACTIONS(527),
    [anon_sym_invoke] = ACTIONS(527),
    [anon_sym_cleanupret] = ACTIONS(527),
    [anon_sym_catchret] = ACTIONS(527),
    [anon_sym_catchswitch] = ACTIONS(527),
    [anon_sym_catchpad] = ACTIONS(527),
    [anon_sym_cleanuppad] = ACTIONS(527),
    [anon_sym_callbr] = ACTIONS(527),
    [anon_sym_icmp] = ACTIONS(527),
    [anon_sym_fcmp] = ACTIONS(527),
    [anon_sym_va_arg] = ACTIONS(527),
    [anon_sym_phi] = ACTIONS(527),
    [anon_sym_landingpad] = ACTIONS(527),
    [anon_sym_tail] = ACTIONS(527),
    [anon_sym_musttail] = ACTIONS(527),
    [anon_sym_notail] = ACTIONS(527),
    [anon_sym_call] = ACTIONS(527),
    [anon_sym_alloca] = ACTIONS(527),
    [anon_sym_load] = ACTIONS(527),
    [anon_sym_store] = ACTIONS(527),
    [anon_sym_cmpxchg] = ACTIONS(527),
    [anon_sym_atomicrmw] = ACTIONS(527),
    [anon_sym_fence] = ACTIONS(527),
    [anon_sym_getelementptr] = ACTIONS(527),
    [anon_sym_extractvalue] = ACTIONS(527),
    [anon_sym_insertvalue] = ACTIONS(527),
    [anon_sym_catch] = ACTIONS(527),
    [anon_sym_filter] = ACTIONS(527),
    [anon_sym_mul] = ACTIONS(527),
    [anon_sym_urem] = ACTIONS(527),
    [anon_sym_srem] = ACTIONS(527),
    [anon_sym_shl] = ACTIONS(527),
    [anon_sym_udiv] = ACTIONS(527),
    [anon_sym_sdiv] = ACTIONS(527),
    [anon_sym_lshr] = ACTIONS(527),
    [anon_sym_ashr] = ACTIONS(527),
    [anon_sym_fmul] = ACTIONS(527),
    [anon_sym_fdiv] = ACTIONS(527),
    [anon_sym_frem] = ACTIONS(527),
    [anon_sym_xchg] = ACTIONS(527),
    [anon_sym_add] = ACTIONS(527),
    [anon_sym_sub] = ACTIONS(527),
    [anon_sym_and] = ACTIONS(527),
    [anon_sym_nand] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(527),
    [anon_sym_xor] = ACTIONS(527),
    [anon_sym_max] = ACTIONS(527),
    [anon_sym_min] = ACTIONS(527),
    [anon_sym_umax] = ACTIONS(527),
    [anon_sym_umin] = ACTIONS(527),
    [anon_sym_fadd] = ACTIONS(527),
    [anon_sym_fsub] = ACTIONS(527),
    [anon_sym_bitcast] = ACTIONS(527),
    [anon_sym_trunc] = ACTIONS(527),
    [anon_sym_zext] = ACTIONS(527),
    [anon_sym_sext] = ACTIONS(527),
    [anon_sym_fptrunc] = ACTIONS(527),
    [anon_sym_fpext] = ACTIONS(527),
    [anon_sym_addrspacecast] = ACTIONS(527),
    [anon_sym_uitofp] = ACTIONS(527),
    [anon_sym_sitofp] = ACTIONS(527),
    [anon_sym_fptoui] = ACTIONS(527),
    [anon_sym_fptosi] = ACTIONS(527),
    [anon_sym_inttoptr] = ACTIONS(527),
    [anon_sym_ptrtoint] = ACTIONS(527),
    [anon_sym_unordered] = ACTIONS(527),
    [anon_sym_monotonic] = ACTIONS(527),
    [anon_sym_acquire] = ACTIONS(527),
    [anon_sym_release] = ACTIONS(527),
    [anon_sym_acq_rel] = ACTIONS(527),
    [anon_sym_seq_cst] = ACTIONS(527),
    [anon_sym_syncscope] = ACTIONS(527),
    [anon_sym_uselistorder] = ACTIONS(527),
  },
  [167] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [sym_label] = ACTIONS(529),
    [sym_string] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_section] = ACTIONS(531),
    [anon_sym_partition] = ACTIONS(531),
    [anon_sym_comdat] = ACTIONS(531),
    [anon_sym_gc] = ACTIONS(531),
    [anon_sym_prefix] = ACTIONS(531),
    [anon_sym_prologue] = ACTIONS(531),
    [anon_sym_personality] = ACTIONS(531),
    [anon_sym_alignstack] = ACTIONS(531),
    [anon_sym_allocsize] = ACTIONS(531),
    [anon_sym_alwaysinline] = ACTIONS(531),
    [anon_sym_builtin] = ACTIONS(531),
    [anon_sym_cold] = ACTIONS(531),
    [anon_sym_convergent] = ACTIONS(531),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(531),
    [anon_sym_hot] = ACTIONS(531),
    [anon_sym_inaccessiblememonly] = ACTIONS(531),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(531),
    [anon_sym_inlinehint] = ACTIONS(531),
    [anon_sym_jumptable] = ACTIONS(531),
    [anon_sym_minsize] = ACTIONS(531),
    [anon_sym_naked] = ACTIONS(531),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(531),
    [anon_sym_nobuiltin] = ACTIONS(531),
    [anon_sym_noduplicate] = ACTIONS(531),
    [anon_sym_nofree] = ACTIONS(531),
    [anon_sym_noimplicitfloat] = ACTIONS(531),
    [anon_sym_noinline] = ACTIONS(531),
    [anon_sym_nomerge] = ACTIONS(531),
    [anon_sym_nonlazybind] = ACTIONS(531),
    [anon_sym_noprofile] = ACTIONS(531),
    [anon_sym_noredzone] = ACTIONS(531),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(531),
    [anon_sym_noreturn] = ACTIONS(531),
    [anon_sym_norecurse] = ACTIONS(531),
    [anon_sym_willreturn] = ACTIONS(531),
    [anon_sym_nosync] = ACTIONS(531),
    [anon_sym_nounwind] = ACTIONS(531),
    [anon_sym_nosanitize_coverage] = ACTIONS(531),
    [anon_sym_null_pointer_is_valid] = ACTIONS(531),
    [anon_sym_optforfuzzing] = ACTIONS(531),
    [anon_sym_optnone] = ACTIONS(531),
    [anon_sym_optsize] = ACTIONS(531),
    [anon_sym_readnone] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_writeonly] = ACTIONS(531),
    [anon_sym_argmemonly] = ACTIONS(531),
    [anon_sym_returns_twice] = ACTIONS(531),
    [anon_sym_safestack] = ACTIONS(531),
    [anon_sym_sanitize_address] = ACTIONS(531),
    [anon_sym_sanitize_memory] = ACTIONS(531),
    [anon_sym_sanitize_thread] = ACTIONS(531),
    [anon_sym_sanitize_hwaddress] = ACTIONS(531),
    [anon_sym_sanitize_memtag] = ACTIONS(531),
    [anon_sym_speculative_load_hardening] = ACTIONS(531),
    [anon_sym_speculatable] = ACTIONS(531),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(531),
    [anon_sym_sspreq] = ACTIONS(531),
    [anon_sym_strictfp] = ACTIONS(531),
    [anon_sym_uwtable] = ACTIONS(531),
    [anon_sym_nocf_check] = ACTIONS(531),
    [anon_sym_shadowcallstack] = ACTIONS(531),
    [anon_sym_mustprogress] = ACTIONS(531),
    [anon_sym_vscale_range] = ACTIONS(531),
    [anon_sym_preallocated] = ACTIONS(531),
    [anon_sym_zeroext] = ACTIONS(531),
    [anon_sym_signext] = ACTIONS(531),
    [anon_sym_inreg] = ACTIONS(531),
    [anon_sym_byval] = ACTIONS(531),
    [anon_sym_byref] = ACTIONS(531),
    [anon_sym_inalloca] = ACTIONS(531),
    [anon_sym_sret] = ACTIONS(531),
    [anon_sym_elementtype] = ACTIONS(531),
    [anon_sym_noalias] = ACTIONS(531),
    [anon_sym_nocapture] = ACTIONS(531),
    [anon_sym_nest] = ACTIONS(531),
    [anon_sym_returned] = ACTIONS(531),
    [anon_sym_nonnull] = ACTIONS(531),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(531),
    [anon_sym_swiftself] = ACTIONS(531),
    [anon_sym_swiftasync] = ACTIONS(531),
    [anon_sym_swifterror] = ACTIONS(531),
    [anon_sym_immarg] = ACTIONS(531),
    [anon_sym_noundef] = ACTIONS(531),
    [anon_sym_unreachable] = ACTIONS(531),
    [anon_sym_ret] = ACTIONS(531),
    [anon_sym_br] = ACTIONS(531),
    [anon_sym_resume] = ACTIONS(531),
    [anon_sym_freeze] = ACTIONS(531),
    [anon_sym_indirectbr] = ACTIONS(531),
    [anon_sym_extractelement] = ACTIONS(531),
    [anon_sym_insertelement] = ACTIONS(531),
    [anon_sym_select] = ACTIONS(531),
    [anon_sym_shufflevector] = ACTIONS(531),
    [anon_sym_fneg] = ACTIONS(531),
    [anon_sym_switch] = ACTIONS(531),
    [anon_sym_invoke] = ACTIONS(531),
    [anon_sym_cleanupret] = ACTIONS(531),
    [anon_sym_catchret] = ACTIONS(531),
    [anon_sym_catchswitch] = ACTIONS(531),
    [anon_sym_catchpad] = ACTIONS(531),
    [anon_sym_cleanuppad] = ACTIONS(531),
    [anon_sym_callbr] = ACTIONS(531),
    [anon_sym_icmp] = ACTIONS(531),
    [anon_sym_fcmp] = ACTIONS(531),
    [anon_sym_va_arg] = ACTIONS(531),
    [anon_sym_phi] = ACTIONS(531),
    [anon_sym_landingpad] = ACTIONS(531),
    [anon_sym_tail] = ACTIONS(531),
    [anon_sym_musttail] = ACTIONS(531),
    [anon_sym_notail] = ACTIONS(531),
    [anon_sym_call] = ACTIONS(531),
    [anon_sym_alloca] = ACTIONS(531),
    [anon_sym_load] = ACTIONS(531),
    [anon_sym_store] = ACTIONS(531),
    [anon_sym_cmpxchg] = ACTIONS(531),
    [anon_sym_atomicrmw] = ACTIONS(531),
    [anon_sym_fence] = ACTIONS(531),
    [anon_sym_getelementptr] = ACTIONS(531),
    [anon_sym_extractvalue] = ACTIONS(531),
    [anon_sym_insertvalue] = ACTIONS(531),
    [anon_sym_catch] = ACTIONS(531),
    [anon_sym_filter] = ACTIONS(531),
    [anon_sym_mul] = ACTIONS(531),
    [anon_sym_urem] = ACTIONS(531),
    [anon_sym_srem] = ACTIONS(531),
    [anon_sym_shl] = ACTIONS(531),
    [anon_sym_udiv] = ACTIONS(531),
    [anon_sym_sdiv] = ACTIONS(531),
    [anon_sym_lshr] = ACTIONS(531),
    [anon_sym_ashr] = ACTIONS(531),
    [anon_sym_fmul] = ACTIONS(531),
    [anon_sym_fdiv] = ACTIONS(531),
    [anon_sym_frem] = ACTIONS(531),
    [anon_sym_xchg] = ACTIONS(531),
    [anon_sym_add] = ACTIONS(531),
    [anon_sym_sub] = ACTIONS(531),
    [anon_sym_and] = ACTIONS(531),
    [anon_sym_nand] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(531),
    [anon_sym_xor] = ACTIONS(531),
    [anon_sym_max] = ACTIONS(531),
    [anon_sym_min] = ACTIONS(531),
    [anon_sym_umax] = ACTIONS(531),
    [anon_sym_umin] = ACTIONS(531),
    [anon_sym_fadd] = ACTIONS(531),
    [anon_sym_fsub] = ACTIONS(531),
    [anon_sym_bitcast] = ACTIONS(531),
    [anon_sym_trunc] = ACTIONS(531),
    [anon_sym_zext] = ACTIONS(531),
    [anon_sym_sext] = ACTIONS(531),
    [anon_sym_fptrunc] = ACTIONS(531),
    [anon_sym_fpext] = ACTIONS(531),
    [anon_sym_addrspacecast] = ACTIONS(531),
    [anon_sym_uitofp] = ACTIONS(531),
    [anon_sym_sitofp] = ACTIONS(531),
    [anon_sym_fptoui] = ACTIONS(531),
    [anon_sym_fptosi] = ACTIONS(531),
    [anon_sym_inttoptr] = ACTIONS(531),
    [anon_sym_ptrtoint] = ACTIONS(531),
    [anon_sym_unordered] = ACTIONS(531),
    [anon_sym_monotonic] = ACTIONS(531),
    [anon_sym_acquire] = ACTIONS(531),
    [anon_sym_release] = ACTIONS(531),
    [anon_sym_acq_rel] = ACTIONS(531),
    [anon_sym_seq_cst] = ACTIONS(531),
    [anon_sym_syncscope] = ACTIONS(531),
    [anon_sym_uselistorder] = ACTIONS(531),
  },
  [168] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [sym_label] = ACTIONS(537),
    [sym_string] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_section] = ACTIONS(539),
    [anon_sym_partition] = ACTIONS(539),
    [anon_sym_comdat] = ACTIONS(539),
    [anon_sym_gc] = ACTIONS(539),
    [anon_sym_prefix] = ACTIONS(539),
    [anon_sym_prologue] = ACTIONS(539),
    [anon_sym_personality] = ACTIONS(539),
    [anon_sym_alignstack] = ACTIONS(539),
    [anon_sym_allocsize] = ACTIONS(539),
    [anon_sym_alwaysinline] = ACTIONS(539),
    [anon_sym_builtin] = ACTIONS(539),
    [anon_sym_cold] = ACTIONS(539),
    [anon_sym_convergent] = ACTIONS(539),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(539),
    [anon_sym_hot] = ACTIONS(539),
    [anon_sym_inaccessiblememonly] = ACTIONS(539),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(539),
    [anon_sym_inlinehint] = ACTIONS(539),
    [anon_sym_jumptable] = ACTIONS(539),
    [anon_sym_minsize] = ACTIONS(539),
    [anon_sym_naked] = ACTIONS(539),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(539),
    [anon_sym_nobuiltin] = ACTIONS(539),
    [anon_sym_noduplicate] = ACTIONS(539),
    [anon_sym_nofree] = ACTIONS(539),
    [anon_sym_noimplicitfloat] = ACTIONS(539),
    [anon_sym_noinline] = ACTIONS(539),
    [anon_sym_nomerge] = ACTIONS(539),
    [anon_sym_nonlazybind] = ACTIONS(539),
    [anon_sym_noprofile] = ACTIONS(539),
    [anon_sym_noredzone] = ACTIONS(539),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(539),
    [anon_sym_noreturn] = ACTIONS(539),
    [anon_sym_norecurse] = ACTIONS(539),
    [anon_sym_willreturn] = ACTIONS(539),
    [anon_sym_nosync] = ACTIONS(539),
    [anon_sym_nounwind] = ACTIONS(539),
    [anon_sym_nosanitize_coverage] = ACTIONS(539),
    [anon_sym_null_pointer_is_valid] = ACTIONS(539),
    [anon_sym_optforfuzzing] = ACTIONS(539),
    [anon_sym_optnone] = ACTIONS(539),
    [anon_sym_optsize] = ACTIONS(539),
    [anon_sym_readnone] = ACTIONS(539),
    [anon_sym_readonly] = ACTIONS(539),
    [anon_sym_writeonly] = ACTIONS(539),
    [anon_sym_argmemonly] = ACTIONS(539),
    [anon_sym_returns_twice] = ACTIONS(539),
    [anon_sym_safestack] = ACTIONS(539),
    [anon_sym_sanitize_address] = ACTIONS(539),
    [anon_sym_sanitize_memory] = ACTIONS(539),
    [anon_sym_sanitize_thread] = ACTIONS(539),
    [anon_sym_sanitize_hwaddress] = ACTIONS(539),
    [anon_sym_sanitize_memtag] = ACTIONS(539),
    [anon_sym_speculative_load_hardening] = ACTIONS(539),
    [anon_sym_speculatable] = ACTIONS(539),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(539),
    [anon_sym_sspreq] = ACTIONS(539),
    [anon_sym_strictfp] = ACTIONS(539),
    [anon_sym_uwtable] = ACTIONS(539),
    [anon_sym_nocf_check] = ACTIONS(539),
    [anon_sym_shadowcallstack] = ACTIONS(539),
    [anon_sym_mustprogress] = ACTIONS(539),
    [anon_sym_vscale_range] = ACTIONS(539),
    [anon_sym_preallocated] = ACTIONS(539),
    [anon_sym_zeroext] = ACTIONS(539),
    [anon_sym_signext] = ACTIONS(539),
    [anon_sym_inreg] = ACTIONS(539),
    [anon_sym_byval] = ACTIONS(539),
    [anon_sym_byref] = ACTIONS(539),
    [anon_sym_inalloca] = ACTIONS(539),
    [anon_sym_sret] = ACTIONS(539),
    [anon_sym_elementtype] = ACTIONS(539),
    [anon_sym_noalias] = ACTIONS(539),
    [anon_sym_nocapture] = ACTIONS(539),
    [anon_sym_nest] = ACTIONS(539),
    [anon_sym_returned] = ACTIONS(539),
    [anon_sym_nonnull] = ACTIONS(539),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(539),
    [anon_sym_swiftself] = ACTIONS(539),
    [anon_sym_swiftasync] = ACTIONS(539),
    [anon_sym_swifterror] = ACTIONS(539),
    [anon_sym_immarg] = ACTIONS(539),
    [anon_sym_noundef] = ACTIONS(539),
    [anon_sym_unreachable] = ACTIONS(539),
    [anon_sym_ret] = ACTIONS(539),
    [anon_sym_br] = ACTIONS(539),
    [anon_sym_resume] = ACTIONS(539),
    [anon_sym_freeze] = ACTIONS(539),
    [anon_sym_indirectbr] = ACTIONS(539),
    [anon_sym_extractelement] = ACTIONS(539),
    [anon_sym_insertelement] = ACTIONS(539),
    [anon_sym_select] = ACTIONS(539),
    [anon_sym_shufflevector] = ACTIONS(539),
    [anon_sym_fneg] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(539),
    [anon_sym_invoke] = ACTIONS(539),
    [anon_sym_cleanupret] = ACTIONS(539),
    [anon_sym_catchret] = ACTIONS(539),
    [anon_sym_catchswitch] = ACTIONS(539),
    [anon_sym_catchpad] = ACTIONS(539),
    [anon_sym_cleanuppad] = ACTIONS(539),
    [anon_sym_callbr] = ACTIONS(539),
    [anon_sym_icmp] = ACTIONS(539),
    [anon_sym_fcmp] = ACTIONS(539),
    [anon_sym_va_arg] = ACTIONS(539),
    [anon_sym_phi] = ACTIONS(539),
    [anon_sym_landingpad] = ACTIONS(539),
    [anon_sym_tail] = ACTIONS(539),
    [anon_sym_musttail] = ACTIONS(539),
    [anon_sym_notail] = ACTIONS(539),
    [anon_sym_call] = ACTIONS(539),
    [anon_sym_alloca] = ACTIONS(539),
    [anon_sym_load] = ACTIONS(539),
    [anon_sym_store] = ACTIONS(539),
    [anon_sym_cmpxchg] = ACTIONS(539),
    [anon_sym_atomicrmw] = ACTIONS(539),
    [anon_sym_fence] = ACTIONS(539),
    [anon_sym_getelementptr] = ACTIONS(539),
    [anon_sym_extractvalue] = ACTIONS(539),
    [anon_sym_insertvalue] = ACTIONS(539),
    [anon_sym_catch] = ACTIONS(539),
    [anon_sym_filter] = ACTIONS(539),
    [anon_sym_mul] = ACTIONS(539),
    [anon_sym_urem] = ACTIONS(539),
    [anon_sym_srem] = ACTIONS(539),
    [anon_sym_shl] = ACTIONS(539),
    [anon_sym_udiv] = ACTIONS(539),
    [anon_sym_sdiv] = ACTIONS(539),
    [anon_sym_lshr] = ACTIONS(539),
    [anon_sym_ashr] = ACTIONS(539),
    [anon_sym_fmul] = ACTIONS(539),
    [anon_sym_fdiv] = ACTIONS(539),
    [anon_sym_frem] = ACTIONS(539),
    [anon_sym_xchg] = ACTIONS(539),
    [anon_sym_add] = ACTIONS(539),
    [anon_sym_sub] = ACTIONS(539),
    [anon_sym_and] = ACTIONS(539),
    [anon_sym_nand] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(539),
    [anon_sym_xor] = ACTIONS(539),
    [anon_sym_max] = ACTIONS(539),
    [anon_sym_min] = ACTIONS(539),
    [anon_sym_umax] = ACTIONS(539),
    [anon_sym_umin] = ACTIONS(539),
    [anon_sym_fadd] = ACTIONS(539),
    [anon_sym_fsub] = ACTIONS(539),
    [anon_sym_bitcast] = ACTIONS(539),
    [anon_sym_trunc] = ACTIONS(539),
    [anon_sym_zext] = ACTIONS(539),
    [anon_sym_sext] = ACTIONS(539),
    [anon_sym_fptrunc] = ACTIONS(539),
    [anon_sym_fpext] = ACTIONS(539),
    [anon_sym_addrspacecast] = ACTIONS(539),
    [anon_sym_uitofp] = ACTIONS(539),
    [anon_sym_sitofp] = ACTIONS(539),
    [anon_sym_fptoui] = ACTIONS(539),
    [anon_sym_fptosi] = ACTIONS(539),
    [anon_sym_inttoptr] = ACTIONS(539),
    [anon_sym_ptrtoint] = ACTIONS(539),
    [anon_sym_unordered] = ACTIONS(539),
    [anon_sym_monotonic] = ACTIONS(539),
    [anon_sym_acquire] = ACTIONS(539),
    [anon_sym_release] = ACTIONS(539),
    [anon_sym_acq_rel] = ACTIONS(539),
    [anon_sym_seq_cst] = ACTIONS(539),
    [anon_sym_syncscope] = ACTIONS(539),
    [anon_sym_uselistorder] = ACTIONS(539),
  },
  [169] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [sym_label] = ACTIONS(635),
    [sym_string] = ACTIONS(637),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_section] = ACTIONS(637),
    [anon_sym_partition] = ACTIONS(637),
    [anon_sym_comdat] = ACTIONS(637),
    [anon_sym_gc] = ACTIONS(637),
    [anon_sym_prefix] = ACTIONS(637),
    [anon_sym_prologue] = ACTIONS(637),
    [anon_sym_personality] = ACTIONS(637),
    [anon_sym_alignstack] = ACTIONS(637),
    [anon_sym_allocsize] = ACTIONS(637),
    [anon_sym_alwaysinline] = ACTIONS(637),
    [anon_sym_builtin] = ACTIONS(637),
    [anon_sym_cold] = ACTIONS(637),
    [anon_sym_convergent] = ACTIONS(637),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(637),
    [anon_sym_hot] = ACTIONS(637),
    [anon_sym_inaccessiblememonly] = ACTIONS(637),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(637),
    [anon_sym_inlinehint] = ACTIONS(637),
    [anon_sym_jumptable] = ACTIONS(637),
    [anon_sym_minsize] = ACTIONS(637),
    [anon_sym_naked] = ACTIONS(637),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(637),
    [anon_sym_nobuiltin] = ACTIONS(637),
    [anon_sym_noduplicate] = ACTIONS(637),
    [anon_sym_nofree] = ACTIONS(637),
    [anon_sym_noimplicitfloat] = ACTIONS(637),
    [anon_sym_noinline] = ACTIONS(637),
    [anon_sym_nomerge] = ACTIONS(637),
    [anon_sym_nonlazybind] = ACTIONS(637),
    [anon_sym_noprofile] = ACTIONS(637),
    [anon_sym_noredzone] = ACTIONS(637),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(637),
    [anon_sym_noreturn] = ACTIONS(637),
    [anon_sym_norecurse] = ACTIONS(637),
    [anon_sym_willreturn] = ACTIONS(637),
    [anon_sym_nosync] = ACTIONS(637),
    [anon_sym_nounwind] = ACTIONS(637),
    [anon_sym_nosanitize_coverage] = ACTIONS(637),
    [anon_sym_null_pointer_is_valid] = ACTIONS(637),
    [anon_sym_optforfuzzing] = ACTIONS(637),
    [anon_sym_optnone] = ACTIONS(637),
    [anon_sym_optsize] = ACTIONS(637),
    [anon_sym_readnone] = ACTIONS(637),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_writeonly] = ACTIONS(637),
    [anon_sym_argmemonly] = ACTIONS(637),
    [anon_sym_returns_twice] = ACTIONS(637),
    [anon_sym_safestack] = ACTIONS(637),
    [anon_sym_sanitize_address] = ACTIONS(637),
    [anon_sym_sanitize_memory] = ACTIONS(637),
    [anon_sym_sanitize_thread] = ACTIONS(637),
    [anon_sym_sanitize_hwaddress] = ACTIONS(637),
    [anon_sym_sanitize_memtag] = ACTIONS(637),
    [anon_sym_speculative_load_hardening] = ACTIONS(637),
    [anon_sym_speculatable] = ACTIONS(637),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(637),
    [anon_sym_sspreq] = ACTIONS(637),
    [anon_sym_strictfp] = ACTIONS(637),
    [anon_sym_uwtable] = ACTIONS(637),
    [anon_sym_nocf_check] = ACTIONS(637),
    [anon_sym_shadowcallstack] = ACTIONS(637),
    [anon_sym_mustprogress] = ACTIONS(637),
    [anon_sym_vscale_range] = ACTIONS(637),
    [anon_sym_preallocated] = ACTIONS(637),
    [anon_sym_zeroext] = ACTIONS(637),
    [anon_sym_signext] = ACTIONS(637),
    [anon_sym_inreg] = ACTIONS(637),
    [anon_sym_byval] = ACTIONS(637),
    [anon_sym_byref] = ACTIONS(637),
    [anon_sym_inalloca] = ACTIONS(637),
    [anon_sym_sret] = ACTIONS(637),
    [anon_sym_elementtype] = ACTIONS(637),
    [anon_sym_noalias] = ACTIONS(637),
    [anon_sym_nocapture] = ACTIONS(637),
    [anon_sym_nest] = ACTIONS(637),
    [anon_sym_returned] = ACTIONS(637),
    [anon_sym_nonnull] = ACTIONS(637),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(637),
    [anon_sym_swiftself] = ACTIONS(637),
    [anon_sym_swiftasync] = ACTIONS(637),
    [anon_sym_swifterror] = ACTIONS(637),
    [anon_sym_immarg] = ACTIONS(637),
    [anon_sym_noundef] = ACTIONS(637),
    [anon_sym_unreachable] = ACTIONS(637),
    [anon_sym_ret] = ACTIONS(637),
    [anon_sym_br] = ACTIONS(637),
    [anon_sym_resume] = ACTIONS(637),
    [anon_sym_freeze] = ACTIONS(637),
    [anon_sym_indirectbr] = ACTIONS(637),
    [anon_sym_extractelement] = ACTIONS(637),
    [anon_sym_insertelement] = ACTIONS(637),
    [anon_sym_select] = ACTIONS(637),
    [anon_sym_shufflevector] = ACTIONS(637),
    [anon_sym_fneg] = ACTIONS(637),
    [anon_sym_switch] = ACTIONS(637),
    [anon_sym_invoke] = ACTIONS(637),
    [anon_sym_cleanupret] = ACTIONS(637),
    [anon_sym_catchret] = ACTIONS(637),
    [anon_sym_catchswitch] = ACTIONS(637),
    [anon_sym_catchpad] = ACTIONS(637),
    [anon_sym_cleanuppad] = ACTIONS(637),
    [anon_sym_callbr] = ACTIONS(637),
    [anon_sym_icmp] = ACTIONS(637),
    [anon_sym_fcmp] = ACTIONS(637),
    [anon_sym_va_arg] = ACTIONS(637),
    [anon_sym_phi] = ACTIONS(637),
    [anon_sym_landingpad] = ACTIONS(637),
    [anon_sym_tail] = ACTIONS(637),
    [anon_sym_musttail] = ACTIONS(637),
    [anon_sym_notail] = ACTIONS(637),
    [anon_sym_call] = ACTIONS(637),
    [anon_sym_alloca] = ACTIONS(637),
    [anon_sym_load] = ACTIONS(637),
    [anon_sym_store] = ACTIONS(637),
    [anon_sym_cmpxchg] = ACTIONS(637),
    [anon_sym_atomicrmw] = ACTIONS(637),
    [anon_sym_fence] = ACTIONS(637),
    [anon_sym_getelementptr] = ACTIONS(637),
    [anon_sym_extractvalue] = ACTIONS(637),
    [anon_sym_insertvalue] = ACTIONS(637),
    [anon_sym_catch] = ACTIONS(637),
    [anon_sym_filter] = ACTIONS(637),
    [anon_sym_mul] = ACTIONS(637),
    [anon_sym_urem] = ACTIONS(637),
    [anon_sym_srem] = ACTIONS(637),
    [anon_sym_shl] = ACTIONS(637),
    [anon_sym_udiv] = ACTIONS(637),
    [anon_sym_sdiv] = ACTIONS(637),
    [anon_sym_lshr] = ACTIONS(637),
    [anon_sym_ashr] = ACTIONS(637),
    [anon_sym_fmul] = ACTIONS(637),
    [anon_sym_fdiv] = ACTIONS(637),
    [anon_sym_frem] = ACTIONS(637),
    [anon_sym_xchg] = ACTIONS(637),
    [anon_sym_add] = ACTIONS(637),
    [anon_sym_sub] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_nand] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(637),
    [anon_sym_xor] = ACTIONS(637),
    [anon_sym_max] = ACTIONS(637),
    [anon_sym_min] = ACTIONS(637),
    [anon_sym_umax] = ACTIONS(637),
    [anon_sym_umin] = ACTIONS(637),
    [anon_sym_fadd] = ACTIONS(637),
    [anon_sym_fsub] = ACTIONS(637),
    [anon_sym_bitcast] = ACTIONS(637),
    [anon_sym_trunc] = ACTIONS(637),
    [anon_sym_zext] = ACTIONS(637),
    [anon_sym_sext] = ACTIONS(637),
    [anon_sym_fptrunc] = ACTIONS(637),
    [anon_sym_fpext] = ACTIONS(637),
    [anon_sym_addrspacecast] = ACTIONS(637),
    [anon_sym_uitofp] = ACTIONS(637),
    [anon_sym_sitofp] = ACTIONS(637),
    [anon_sym_fptoui] = ACTIONS(637),
    [anon_sym_fptosi] = ACTIONS(637),
    [anon_sym_inttoptr] = ACTIONS(637),
    [anon_sym_ptrtoint] = ACTIONS(637),
    [anon_sym_unordered] = ACTIONS(637),
    [anon_sym_monotonic] = ACTIONS(637),
    [anon_sym_acquire] = ACTIONS(637),
    [anon_sym_release] = ACTIONS(637),
    [anon_sym_acq_rel] = ACTIONS(637),
    [anon_sym_seq_cst] = ACTIONS(637),
    [anon_sym_syncscope] = ACTIONS(637),
    [anon_sym_uselistorder] = ACTIONS(637),
  },
  [170] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [sym_label] = ACTIONS(667),
    [sym_string] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(669),
    [anon_sym_partition] = ACTIONS(669),
    [anon_sym_comdat] = ACTIONS(669),
    [anon_sym_gc] = ACTIONS(669),
    [anon_sym_prefix] = ACTIONS(669),
    [anon_sym_prologue] = ACTIONS(669),
    [anon_sym_personality] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(669),
    [anon_sym_allocsize] = ACTIONS(669),
    [anon_sym_alwaysinline] = ACTIONS(669),
    [anon_sym_builtin] = ACTIONS(669),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(669),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(669),
    [anon_sym_hot] = ACTIONS(669),
    [anon_sym_inaccessiblememonly] = ACTIONS(669),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(669),
    [anon_sym_inlinehint] = ACTIONS(669),
    [anon_sym_jumptable] = ACTIONS(669),
    [anon_sym_minsize] = ACTIONS(669),
    [anon_sym_naked] = ACTIONS(669),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(669),
    [anon_sym_nobuiltin] = ACTIONS(669),
    [anon_sym_noduplicate] = ACTIONS(669),
    [anon_sym_nofree] = ACTIONS(669),
    [anon_sym_noimplicitfloat] = ACTIONS(669),
    [anon_sym_noinline] = ACTIONS(669),
    [anon_sym_nomerge] = ACTIONS(669),
    [anon_sym_nonlazybind] = ACTIONS(669),
    [anon_sym_noprofile] = ACTIONS(669),
    [anon_sym_noredzone] = ACTIONS(669),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(669),
    [anon_sym_noreturn] = ACTIONS(669),
    [anon_sym_norecurse] = ACTIONS(669),
    [anon_sym_willreturn] = ACTIONS(669),
    [anon_sym_nosync] = ACTIONS(669),
    [anon_sym_nounwind] = ACTIONS(669),
    [anon_sym_nosanitize_coverage] = ACTIONS(669),
    [anon_sym_null_pointer_is_valid] = ACTIONS(669),
    [anon_sym_optforfuzzing] = ACTIONS(669),
    [anon_sym_optnone] = ACTIONS(669),
    [anon_sym_optsize] = ACTIONS(669),
    [anon_sym_readnone] = ACTIONS(669),
    [anon_sym_readonly] = ACTIONS(669),
    [anon_sym_writeonly] = ACTIONS(669),
    [anon_sym_argmemonly] = ACTIONS(669),
    [anon_sym_returns_twice] = ACTIONS(669),
    [anon_sym_safestack] = ACTIONS(669),
    [anon_sym_sanitize_address] = ACTIONS(669),
    [anon_sym_sanitize_memory] = ACTIONS(669),
    [anon_sym_sanitize_thread] = ACTIONS(669),
    [anon_sym_sanitize_hwaddress] = ACTIONS(669),
    [anon_sym_sanitize_memtag] = ACTIONS(669),
    [anon_sym_speculative_load_hardening] = ACTIONS(669),
    [anon_sym_speculatable] = ACTIONS(669),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(669),
    [anon_sym_sspreq] = ACTIONS(669),
    [anon_sym_strictfp] = ACTIONS(669),
    [anon_sym_uwtable] = ACTIONS(669),
    [anon_sym_nocf_check] = ACTIONS(669),
    [anon_sym_shadowcallstack] = ACTIONS(669),
    [anon_sym_mustprogress] = ACTIONS(669),
    [anon_sym_vscale_range] = ACTIONS(669),
    [anon_sym_preallocated] = ACTIONS(669),
    [anon_sym_zeroext] = ACTIONS(669),
    [anon_sym_signext] = ACTIONS(669),
    [anon_sym_inreg] = ACTIONS(669),
    [anon_sym_byval] = ACTIONS(669),
    [anon_sym_byref] = ACTIONS(669),
    [anon_sym_inalloca] = ACTIONS(669),
    [anon_sym_sret] = ACTIONS(669),
    [anon_sym_elementtype] = ACTIONS(669),
    [anon_sym_noalias] = ACTIONS(669),
    [anon_sym_nocapture] = ACTIONS(669),
    [anon_sym_nest] = ACTIONS(669),
    [anon_sym_returned] = ACTIONS(669),
    [anon_sym_nonnull] = ACTIONS(669),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(669),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(669),
    [anon_sym_noundef] = ACTIONS(669),
    [anon_sym_unreachable] = ACTIONS(669),
    [anon_sym_ret] = ACTIONS(669),
    [anon_sym_br] = ACTIONS(669),
    [anon_sym_resume] = ACTIONS(669),
    [anon_sym_freeze] = ACTIONS(669),
    [anon_sym_indirectbr] = ACTIONS(669),
    [anon_sym_extractelement] = ACTIONS(669),
    [anon_sym_insertelement] = ACTIONS(669),
    [anon_sym_select] = ACTIONS(669),
    [anon_sym_shufflevector] = ACTIONS(669),
    [anon_sym_fneg] = ACTIONS(669),
    [anon_sym_switch] = ACTIONS(669),
    [anon_sym_invoke] = ACTIONS(669),
    [anon_sym_cleanupret] = ACTIONS(669),
    [anon_sym_catchret] = ACTIONS(669),
    [anon_sym_catchswitch] = ACTIONS(669),
    [anon_sym_catchpad] = ACTIONS(669),
    [anon_sym_cleanuppad] = ACTIONS(669),
    [anon_sym_callbr] = ACTIONS(669),
    [anon_sym_icmp] = ACTIONS(669),
    [anon_sym_fcmp] = ACTIONS(669),
    [anon_sym_va_arg] = ACTIONS(669),
    [anon_sym_phi] = ACTIONS(669),
    [anon_sym_landingpad] = ACTIONS(669),
    [anon_sym_tail] = ACTIONS(669),
    [anon_sym_musttail] = ACTIONS(669),
    [anon_sym_notail] = ACTIONS(669),
    [anon_sym_call] = ACTIONS(669),
    [anon_sym_alloca] = ACTIONS(669),
    [anon_sym_load] = ACTIONS(669),
    [anon_sym_store] = ACTIONS(669),
    [anon_sym_cmpxchg] = ACTIONS(669),
    [anon_sym_atomicrmw] = ACTIONS(669),
    [anon_sym_fence] = ACTIONS(669),
    [anon_sym_getelementptr] = ACTIONS(669),
    [anon_sym_extractvalue] = ACTIONS(669),
    [anon_sym_insertvalue] = ACTIONS(669),
    [anon_sym_catch] = ACTIONS(669),
    [anon_sym_filter] = ACTIONS(669),
    [anon_sym_mul] = ACTIONS(669),
    [anon_sym_urem] = ACTIONS(669),
    [anon_sym_srem] = ACTIONS(669),
    [anon_sym_shl] = ACTIONS(669),
    [anon_sym_udiv] = ACTIONS(669),
    [anon_sym_sdiv] = ACTIONS(669),
    [anon_sym_lshr] = ACTIONS(669),
    [anon_sym_ashr] = ACTIONS(669),
    [anon_sym_fmul] = ACTIONS(669),
    [anon_sym_fdiv] = ACTIONS(669),
    [anon_sym_frem] = ACTIONS(669),
    [anon_sym_xchg] = ACTIONS(669),
    [anon_sym_add] = ACTIONS(669),
    [anon_sym_sub] = ACTIONS(669),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_nand] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_xor] = ACTIONS(669),
    [anon_sym_max] = ACTIONS(669),
    [anon_sym_min] = ACTIONS(669),
    [anon_sym_umax] = ACTIONS(669),
    [anon_sym_umin] = ACTIONS(669),
    [anon_sym_fadd] = ACTIONS(669),
    [anon_sym_fsub] = ACTIONS(669),
    [anon_sym_bitcast] = ACTIONS(669),
    [anon_sym_trunc] = ACTIONS(669),
    [anon_sym_zext] = ACTIONS(669),
    [anon_sym_sext] = ACTIONS(669),
    [anon_sym_fptrunc] = ACTIONS(669),
    [anon_sym_fpext] = ACTIONS(669),
    [anon_sym_addrspacecast] = ACTIONS(669),
    [anon_sym_uitofp] = ACTIONS(669),
    [anon_sym_sitofp] = ACTIONS(669),
    [anon_sym_fptoui] = ACTIONS(669),
    [anon_sym_fptosi] = ACTIONS(669),
    [anon_sym_inttoptr] = ACTIONS(669),
    [anon_sym_ptrtoint] = ACTIONS(669),
    [anon_sym_unordered] = ACTIONS(669),
    [anon_sym_monotonic] = ACTIONS(669),
    [anon_sym_acquire] = ACTIONS(669),
    [anon_sym_release] = ACTIONS(669),
    [anon_sym_acq_rel] = ACTIONS(669),
    [anon_sym_seq_cst] = ACTIONS(669),
    [anon_sym_syncscope] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
  },
  [171] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [sym_label] = ACTIONS(517),
    [sym_string] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_section] = ACTIONS(519),
    [anon_sym_partition] = ACTIONS(519),
    [anon_sym_comdat] = ACTIONS(519),
    [anon_sym_gc] = ACTIONS(519),
    [anon_sym_prefix] = ACTIONS(519),
    [anon_sym_prologue] = ACTIONS(519),
    [anon_sym_personality] = ACTIONS(519),
    [anon_sym_alignstack] = ACTIONS(519),
    [anon_sym_allocsize] = ACTIONS(519),
    [anon_sym_alwaysinline] = ACTIONS(519),
    [anon_sym_builtin] = ACTIONS(519),
    [anon_sym_cold] = ACTIONS(519),
    [anon_sym_convergent] = ACTIONS(519),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(519),
    [anon_sym_hot] = ACTIONS(519),
    [anon_sym_inaccessiblememonly] = ACTIONS(519),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(519),
    [anon_sym_inlinehint] = ACTIONS(519),
    [anon_sym_jumptable] = ACTIONS(519),
    [anon_sym_minsize] = ACTIONS(519),
    [anon_sym_naked] = ACTIONS(519),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(519),
    [anon_sym_nobuiltin] = ACTIONS(519),
    [anon_sym_noduplicate] = ACTIONS(519),
    [anon_sym_nofree] = ACTIONS(519),
    [anon_sym_noimplicitfloat] = ACTIONS(519),
    [anon_sym_noinline] = ACTIONS(519),
    [anon_sym_nomerge] = ACTIONS(519),
    [anon_sym_nonlazybind] = ACTIONS(519),
    [anon_sym_noprofile] = ACTIONS(519),
    [anon_sym_noredzone] = ACTIONS(519),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(519),
    [anon_sym_noreturn] = ACTIONS(519),
    [anon_sym_norecurse] = ACTIONS(519),
    [anon_sym_willreturn] = ACTIONS(519),
    [anon_sym_nosync] = ACTIONS(519),
    [anon_sym_nounwind] = ACTIONS(519),
    [anon_sym_nosanitize_coverage] = ACTIONS(519),
    [anon_sym_null_pointer_is_valid] = ACTIONS(519),
    [anon_sym_optforfuzzing] = ACTIONS(519),
    [anon_sym_optnone] = ACTIONS(519),
    [anon_sym_optsize] = ACTIONS(519),
    [anon_sym_readnone] = ACTIONS(519),
    [anon_sym_readonly] = ACTIONS(519),
    [anon_sym_writeonly] = ACTIONS(519),
    [anon_sym_argmemonly] = ACTIONS(519),
    [anon_sym_returns_twice] = ACTIONS(519),
    [anon_sym_safestack] = ACTIONS(519),
    [anon_sym_sanitize_address] = ACTIONS(519),
    [anon_sym_sanitize_memory] = ACTIONS(519),
    [anon_sym_sanitize_thread] = ACTIONS(519),
    [anon_sym_sanitize_hwaddress] = ACTIONS(519),
    [anon_sym_sanitize_memtag] = ACTIONS(519),
    [anon_sym_speculative_load_hardening] = ACTIONS(519),
    [anon_sym_speculatable] = ACTIONS(519),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(519),
    [anon_sym_sspreq] = ACTIONS(519),
    [anon_sym_strictfp] = ACTIONS(519),
    [anon_sym_uwtable] = ACTIONS(519),
    [anon_sym_nocf_check] = ACTIONS(519),
    [anon_sym_shadowcallstack] = ACTIONS(519),
    [anon_sym_mustprogress] = ACTIONS(519),
    [anon_sym_vscale_range] = ACTIONS(519),
    [anon_sym_preallocated] = ACTIONS(519),
    [anon_sym_zeroext] = ACTIONS(519),
    [anon_sym_signext] = ACTIONS(519),
    [anon_sym_inreg] = ACTIONS(519),
    [anon_sym_byval] = ACTIONS(519),
    [anon_sym_byref] = ACTIONS(519),
    [anon_sym_inalloca] = ACTIONS(519),
    [anon_sym_sret] = ACTIONS(519),
    [anon_sym_elementtype] = ACTIONS(519),
    [anon_sym_noalias] = ACTIONS(519),
    [anon_sym_nocapture] = ACTIONS(519),
    [anon_sym_nest] = ACTIONS(519),
    [anon_sym_returned] = ACTIONS(519),
    [anon_sym_nonnull] = ACTIONS(519),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(519),
    [anon_sym_swiftself] = ACTIONS(519),
    [anon_sym_swiftasync] = ACTIONS(519),
    [anon_sym_swifterror] = ACTIONS(519),
    [anon_sym_immarg] = ACTIONS(519),
    [anon_sym_noundef] = ACTIONS(519),
    [anon_sym_unreachable] = ACTIONS(519),
    [anon_sym_ret] = ACTIONS(519),
    [anon_sym_br] = ACTIONS(519),
    [anon_sym_resume] = ACTIONS(519),
    [anon_sym_freeze] = ACTIONS(519),
    [anon_sym_indirectbr] = ACTIONS(519),
    [anon_sym_extractelement] = ACTIONS(519),
    [anon_sym_insertelement] = ACTIONS(519),
    [anon_sym_select] = ACTIONS(519),
    [anon_sym_shufflevector] = ACTIONS(519),
    [anon_sym_fneg] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_invoke] = ACTIONS(519),
    [anon_sym_cleanupret] = ACTIONS(519),
    [anon_sym_catchret] = ACTIONS(519),
    [anon_sym_catchswitch] = ACTIONS(519),
    [anon_sym_catchpad] = ACTIONS(519),
    [anon_sym_cleanuppad] = ACTIONS(519),
    [anon_sym_callbr] = ACTIONS(519),
    [anon_sym_icmp] = ACTIONS(519),
    [anon_sym_fcmp] = ACTIONS(519),
    [anon_sym_va_arg] = ACTIONS(519),
    [anon_sym_phi] = ACTIONS(519),
    [anon_sym_landingpad] = ACTIONS(519),
    [anon_sym_tail] = ACTIONS(519),
    [anon_sym_musttail] = ACTIONS(519),
    [anon_sym_notail] = ACTIONS(519),
    [anon_sym_call] = ACTIONS(519),
    [anon_sym_alloca] = ACTIONS(519),
    [anon_sym_load] = ACTIONS(519),
    [anon_sym_store] = ACTIONS(519),
    [anon_sym_cmpxchg] = ACTIONS(519),
    [anon_sym_atomicrmw] = ACTIONS(519),
    [anon_sym_fence] = ACTIONS(519),
    [anon_sym_getelementptr] = ACTIONS(519),
    [anon_sym_extractvalue] = ACTIONS(519),
    [anon_sym_insertvalue] = ACTIONS(519),
    [anon_sym_catch] = ACTIONS(519),
    [anon_sym_filter] = ACTIONS(519),
    [anon_sym_mul] = ACTIONS(519),
    [anon_sym_urem] = ACTIONS(519),
    [anon_sym_srem] = ACTIONS(519),
    [anon_sym_shl] = ACTIONS(519),
    [anon_sym_udiv] = ACTIONS(519),
    [anon_sym_sdiv] = ACTIONS(519),
    [anon_sym_lshr] = ACTIONS(519),
    [anon_sym_ashr] = ACTIONS(519),
    [anon_sym_fmul] = ACTIONS(519),
    [anon_sym_fdiv] = ACTIONS(519),
    [anon_sym_frem] = ACTIONS(519),
    [anon_sym_xchg] = ACTIONS(519),
    [anon_sym_add] = ACTIONS(519),
    [anon_sym_sub] = ACTIONS(519),
    [anon_sym_and] = ACTIONS(519),
    [anon_sym_nand] = ACTIONS(519),
    [anon_sym_or] = ACTIONS(519),
    [anon_sym_xor] = ACTIONS(519),
    [anon_sym_max] = ACTIONS(519),
    [anon_sym_min] = ACTIONS(519),
    [anon_sym_umax] = ACTIONS(519),
    [anon_sym_umin] = ACTIONS(519),
    [anon_sym_fadd] = ACTIONS(519),
    [anon_sym_fsub] = ACTIONS(519),
    [anon_sym_bitcast] = ACTIONS(519),
    [anon_sym_trunc] = ACTIONS(519),
    [anon_sym_zext] = ACTIONS(519),
    [anon_sym_sext] = ACTIONS(519),
    [anon_sym_fptrunc] = ACTIONS(519),
    [anon_sym_fpext] = ACTIONS(519),
    [anon_sym_addrspacecast] = ACTIONS(519),
    [anon_sym_uitofp] = ACTIONS(519),
    [anon_sym_sitofp] = ACTIONS(519),
    [anon_sym_fptoui] = ACTIONS(519),
    [anon_sym_fptosi] = ACTIONS(519),
    [anon_sym_inttoptr] = ACTIONS(519),
    [anon_sym_ptrtoint] = ACTIONS(519),
    [anon_sym_unordered] = ACTIONS(519),
    [anon_sym_monotonic] = ACTIONS(519),
    [anon_sym_acquire] = ACTIONS(519),
    [anon_sym_release] = ACTIONS(519),
    [anon_sym_acq_rel] = ACTIONS(519),
    [anon_sym_seq_cst] = ACTIONS(519),
    [anon_sym_syncscope] = ACTIONS(519),
    [anon_sym_uselistorder] = ACTIONS(519),
  },
  [172] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [sym_label] = ACTIONS(569),
    [sym_string] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_section] = ACTIONS(571),
    [anon_sym_partition] = ACTIONS(571),
    [anon_sym_comdat] = ACTIONS(571),
    [anon_sym_gc] = ACTIONS(571),
    [anon_sym_prefix] = ACTIONS(571),
    [anon_sym_prologue] = ACTIONS(571),
    [anon_sym_personality] = ACTIONS(571),
    [anon_sym_alignstack] = ACTIONS(571),
    [anon_sym_allocsize] = ACTIONS(571),
    [anon_sym_alwaysinline] = ACTIONS(571),
    [anon_sym_builtin] = ACTIONS(571),
    [anon_sym_cold] = ACTIONS(571),
    [anon_sym_convergent] = ACTIONS(571),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(571),
    [anon_sym_hot] = ACTIONS(571),
    [anon_sym_inaccessiblememonly] = ACTIONS(571),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(571),
    [anon_sym_inlinehint] = ACTIONS(571),
    [anon_sym_jumptable] = ACTIONS(571),
    [anon_sym_minsize] = ACTIONS(571),
    [anon_sym_naked] = ACTIONS(571),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(571),
    [anon_sym_nobuiltin] = ACTIONS(571),
    [anon_sym_noduplicate] = ACTIONS(571),
    [anon_sym_nofree] = ACTIONS(571),
    [anon_sym_noimplicitfloat] = ACTIONS(571),
    [anon_sym_noinline] = ACTIONS(571),
    [anon_sym_nomerge] = ACTIONS(571),
    [anon_sym_nonlazybind] = ACTIONS(571),
    [anon_sym_noprofile] = ACTIONS(571),
    [anon_sym_noredzone] = ACTIONS(571),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(571),
    [anon_sym_noreturn] = ACTIONS(571),
    [anon_sym_norecurse] = ACTIONS(571),
    [anon_sym_willreturn] = ACTIONS(571),
    [anon_sym_nosync] = ACTIONS(571),
    [anon_sym_nounwind] = ACTIONS(571),
    [anon_sym_nosanitize_coverage] = ACTIONS(571),
    [anon_sym_null_pointer_is_valid] = ACTIONS(571),
    [anon_sym_optforfuzzing] = ACTIONS(571),
    [anon_sym_optnone] = ACTIONS(571),
    [anon_sym_optsize] = ACTIONS(571),
    [anon_sym_readnone] = ACTIONS(571),
    [anon_sym_readonly] = ACTIONS(571),
    [anon_sym_writeonly] = ACTIONS(571),
    [anon_sym_argmemonly] = ACTIONS(571),
    [anon_sym_returns_twice] = ACTIONS(571),
    [anon_sym_safestack] = ACTIONS(571),
    [anon_sym_sanitize_address] = ACTIONS(571),
    [anon_sym_sanitize_memory] = ACTIONS(571),
    [anon_sym_sanitize_thread] = ACTIONS(571),
    [anon_sym_sanitize_hwaddress] = ACTIONS(571),
    [anon_sym_sanitize_memtag] = ACTIONS(571),
    [anon_sym_speculative_load_hardening] = ACTIONS(571),
    [anon_sym_speculatable] = ACTIONS(571),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(571),
    [anon_sym_sspreq] = ACTIONS(571),
    [anon_sym_strictfp] = ACTIONS(571),
    [anon_sym_uwtable] = ACTIONS(571),
    [anon_sym_nocf_check] = ACTIONS(571),
    [anon_sym_shadowcallstack] = ACTIONS(571),
    [anon_sym_mustprogress] = ACTIONS(571),
    [anon_sym_vscale_range] = ACTIONS(571),
    [anon_sym_preallocated] = ACTIONS(571),
    [anon_sym_zeroext] = ACTIONS(571),
    [anon_sym_signext] = ACTIONS(571),
    [anon_sym_inreg] = ACTIONS(571),
    [anon_sym_byval] = ACTIONS(571),
    [anon_sym_byref] = ACTIONS(571),
    [anon_sym_inalloca] = ACTIONS(571),
    [anon_sym_sret] = ACTIONS(571),
    [anon_sym_elementtype] = ACTIONS(571),
    [anon_sym_noalias] = ACTIONS(571),
    [anon_sym_nocapture] = ACTIONS(571),
    [anon_sym_nest] = ACTIONS(571),
    [anon_sym_returned] = ACTIONS(571),
    [anon_sym_nonnull] = ACTIONS(571),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(571),
    [anon_sym_swiftself] = ACTIONS(571),
    [anon_sym_swiftasync] = ACTIONS(571),
    [anon_sym_swifterror] = ACTIONS(571),
    [anon_sym_immarg] = ACTIONS(571),
    [anon_sym_noundef] = ACTIONS(571),
    [anon_sym_unreachable] = ACTIONS(571),
    [anon_sym_ret] = ACTIONS(571),
    [anon_sym_br] = ACTIONS(571),
    [anon_sym_resume] = ACTIONS(571),
    [anon_sym_freeze] = ACTIONS(571),
    [anon_sym_indirectbr] = ACTIONS(571),
    [anon_sym_extractelement] = ACTIONS(571),
    [anon_sym_insertelement] = ACTIONS(571),
    [anon_sym_select] = ACTIONS(571),
    [anon_sym_shufflevector] = ACTIONS(571),
    [anon_sym_fneg] = ACTIONS(571),
    [anon_sym_switch] = ACTIONS(571),
    [anon_sym_invoke] = ACTIONS(571),
    [anon_sym_cleanupret] = ACTIONS(571),
    [anon_sym_catchret] = ACTIONS(571),
    [anon_sym_catchswitch] = ACTIONS(571),
    [anon_sym_catchpad] = ACTIONS(571),
    [anon_sym_cleanuppad] = ACTIONS(571),
    [anon_sym_callbr] = ACTIONS(571),
    [anon_sym_icmp] = ACTIONS(571),
    [anon_sym_fcmp] = ACTIONS(571),
    [anon_sym_va_arg] = ACTIONS(571),
    [anon_sym_phi] = ACTIONS(571),
    [anon_sym_landingpad] = ACTIONS(571),
    [anon_sym_tail] = ACTIONS(571),
    [anon_sym_musttail] = ACTIONS(571),
    [anon_sym_notail] = ACTIONS(571),
    [anon_sym_call] = ACTIONS(571),
    [anon_sym_alloca] = ACTIONS(571),
    [anon_sym_load] = ACTIONS(571),
    [anon_sym_store] = ACTIONS(571),
    [anon_sym_cmpxchg] = ACTIONS(571),
    [anon_sym_atomicrmw] = ACTIONS(571),
    [anon_sym_fence] = ACTIONS(571),
    [anon_sym_getelementptr] = ACTIONS(571),
    [anon_sym_extractvalue] = ACTIONS(571),
    [anon_sym_insertvalue] = ACTIONS(571),
    [anon_sym_catch] = ACTIONS(571),
    [anon_sym_filter] = ACTIONS(571),
    [anon_sym_mul] = ACTIONS(571),
    [anon_sym_urem] = ACTIONS(571),
    [anon_sym_srem] = ACTIONS(571),
    [anon_sym_shl] = ACTIONS(571),
    [anon_sym_udiv] = ACTIONS(571),
    [anon_sym_sdiv] = ACTIONS(571),
    [anon_sym_lshr] = ACTIONS(571),
    [anon_sym_ashr] = ACTIONS(571),
    [anon_sym_fmul] = ACTIONS(571),
    [anon_sym_fdiv] = ACTIONS(571),
    [anon_sym_frem] = ACTIONS(571),
    [anon_sym_xchg] = ACTIONS(571),
    [anon_sym_add] = ACTIONS(571),
    [anon_sym_sub] = ACTIONS(571),
    [anon_sym_and] = ACTIONS(571),
    [anon_sym_nand] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(571),
    [anon_sym_xor] = ACTIONS(571),
    [anon_sym_max] = ACTIONS(571),
    [anon_sym_min] = ACTIONS(571),
    [anon_sym_umax] = ACTIONS(571),
    [anon_sym_umin] = ACTIONS(571),
    [anon_sym_fadd] = ACTIONS(571),
    [anon_sym_fsub] = ACTIONS(571),
    [anon_sym_bitcast] = ACTIONS(571),
    [anon_sym_trunc] = ACTIONS(571),
    [anon_sym_zext] = ACTIONS(571),
    [anon_sym_sext] = ACTIONS(571),
    [anon_sym_fptrunc] = ACTIONS(571),
    [anon_sym_fpext] = ACTIONS(571),
    [anon_sym_addrspacecast] = ACTIONS(571),
    [anon_sym_uitofp] = ACTIONS(571),
    [anon_sym_sitofp] = ACTIONS(571),
    [anon_sym_fptoui] = ACTIONS(571),
    [anon_sym_fptosi] = ACTIONS(571),
    [anon_sym_inttoptr] = ACTIONS(571),
    [anon_sym_ptrtoint] = ACTIONS(571),
    [anon_sym_unordered] = ACTIONS(571),
    [anon_sym_monotonic] = ACTIONS(571),
    [anon_sym_acquire] = ACTIONS(571),
    [anon_sym_release] = ACTIONS(571),
    [anon_sym_acq_rel] = ACTIONS(571),
    [anon_sym_seq_cst] = ACTIONS(571),
    [anon_sym_syncscope] = ACTIONS(571),
    [anon_sym_uselistorder] = ACTIONS(571),
  },
  [173] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [sym_label] = ACTIONS(675),
    [sym_string] = ACTIONS(677),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_section] = ACTIONS(677),
    [anon_sym_partition] = ACTIONS(677),
    [anon_sym_comdat] = ACTIONS(677),
    [anon_sym_gc] = ACTIONS(677),
    [anon_sym_prefix] = ACTIONS(677),
    [anon_sym_prologue] = ACTIONS(677),
    [anon_sym_personality] = ACTIONS(677),
    [anon_sym_alignstack] = ACTIONS(677),
    [anon_sym_allocsize] = ACTIONS(677),
    [anon_sym_alwaysinline] = ACTIONS(677),
    [anon_sym_builtin] = ACTIONS(677),
    [anon_sym_cold] = ACTIONS(677),
    [anon_sym_convergent] = ACTIONS(677),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(677),
    [anon_sym_hot] = ACTIONS(677),
    [anon_sym_inaccessiblememonly] = ACTIONS(677),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(677),
    [anon_sym_inlinehint] = ACTIONS(677),
    [anon_sym_jumptable] = ACTIONS(677),
    [anon_sym_minsize] = ACTIONS(677),
    [anon_sym_naked] = ACTIONS(677),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(677),
    [anon_sym_nobuiltin] = ACTIONS(677),
    [anon_sym_noduplicate] = ACTIONS(677),
    [anon_sym_nofree] = ACTIONS(677),
    [anon_sym_noimplicitfloat] = ACTIONS(677),
    [anon_sym_noinline] = ACTIONS(677),
    [anon_sym_nomerge] = ACTIONS(677),
    [anon_sym_nonlazybind] = ACTIONS(677),
    [anon_sym_noprofile] = ACTIONS(677),
    [anon_sym_noredzone] = ACTIONS(677),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(677),
    [anon_sym_noreturn] = ACTIONS(677),
    [anon_sym_norecurse] = ACTIONS(677),
    [anon_sym_willreturn] = ACTIONS(677),
    [anon_sym_nosync] = ACTIONS(677),
    [anon_sym_nounwind] = ACTIONS(677),
    [anon_sym_nosanitize_coverage] = ACTIONS(677),
    [anon_sym_null_pointer_is_valid] = ACTIONS(677),
    [anon_sym_optforfuzzing] = ACTIONS(677),
    [anon_sym_optnone] = ACTIONS(677),
    [anon_sym_optsize] = ACTIONS(677),
    [anon_sym_readnone] = ACTIONS(677),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_writeonly] = ACTIONS(677),
    [anon_sym_argmemonly] = ACTIONS(677),
    [anon_sym_returns_twice] = ACTIONS(677),
    [anon_sym_safestack] = ACTIONS(677),
    [anon_sym_sanitize_address] = ACTIONS(677),
    [anon_sym_sanitize_memory] = ACTIONS(677),
    [anon_sym_sanitize_thread] = ACTIONS(677),
    [anon_sym_sanitize_hwaddress] = ACTIONS(677),
    [anon_sym_sanitize_memtag] = ACTIONS(677),
    [anon_sym_speculative_load_hardening] = ACTIONS(677),
    [anon_sym_speculatable] = ACTIONS(677),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(677),
    [anon_sym_sspreq] = ACTIONS(677),
    [anon_sym_strictfp] = ACTIONS(677),
    [anon_sym_uwtable] = ACTIONS(677),
    [anon_sym_nocf_check] = ACTIONS(677),
    [anon_sym_shadowcallstack] = ACTIONS(677),
    [anon_sym_mustprogress] = ACTIONS(677),
    [anon_sym_vscale_range] = ACTIONS(677),
    [anon_sym_preallocated] = ACTIONS(677),
    [anon_sym_zeroext] = ACTIONS(677),
    [anon_sym_signext] = ACTIONS(677),
    [anon_sym_inreg] = ACTIONS(677),
    [anon_sym_byval] = ACTIONS(677),
    [anon_sym_byref] = ACTIONS(677),
    [anon_sym_inalloca] = ACTIONS(677),
    [anon_sym_sret] = ACTIONS(677),
    [anon_sym_elementtype] = ACTIONS(677),
    [anon_sym_noalias] = ACTIONS(677),
    [anon_sym_nocapture] = ACTIONS(677),
    [anon_sym_nest] = ACTIONS(677),
    [anon_sym_returned] = ACTIONS(677),
    [anon_sym_nonnull] = ACTIONS(677),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(677),
    [anon_sym_swiftself] = ACTIONS(677),
    [anon_sym_swiftasync] = ACTIONS(677),
    [anon_sym_swifterror] = ACTIONS(677),
    [anon_sym_immarg] = ACTIONS(677),
    [anon_sym_noundef] = ACTIONS(677),
    [anon_sym_unreachable] = ACTIONS(677),
    [anon_sym_ret] = ACTIONS(677),
    [anon_sym_br] = ACTIONS(677),
    [anon_sym_resume] = ACTIONS(677),
    [anon_sym_freeze] = ACTIONS(677),
    [anon_sym_indirectbr] = ACTIONS(677),
    [anon_sym_extractelement] = ACTIONS(677),
    [anon_sym_insertelement] = ACTIONS(677),
    [anon_sym_select] = ACTIONS(677),
    [anon_sym_shufflevector] = ACTIONS(677),
    [anon_sym_fneg] = ACTIONS(677),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_invoke] = ACTIONS(677),
    [anon_sym_cleanupret] = ACTIONS(677),
    [anon_sym_catchret] = ACTIONS(677),
    [anon_sym_catchswitch] = ACTIONS(677),
    [anon_sym_catchpad] = ACTIONS(677),
    [anon_sym_cleanuppad] = ACTIONS(677),
    [anon_sym_callbr] = ACTIONS(677),
    [anon_sym_icmp] = ACTIONS(677),
    [anon_sym_fcmp] = ACTIONS(677),
    [anon_sym_va_arg] = ACTIONS(677),
    [anon_sym_phi] = ACTIONS(677),
    [anon_sym_landingpad] = ACTIONS(677),
    [anon_sym_tail] = ACTIONS(677),
    [anon_sym_musttail] = ACTIONS(677),
    [anon_sym_notail] = ACTIONS(677),
    [anon_sym_call] = ACTIONS(677),
    [anon_sym_alloca] = ACTIONS(677),
    [anon_sym_load] = ACTIONS(677),
    [anon_sym_store] = ACTIONS(677),
    [anon_sym_cmpxchg] = ACTIONS(677),
    [anon_sym_atomicrmw] = ACTIONS(677),
    [anon_sym_fence] = ACTIONS(677),
    [anon_sym_getelementptr] = ACTIONS(677),
    [anon_sym_extractvalue] = ACTIONS(677),
    [anon_sym_insertvalue] = ACTIONS(677),
    [anon_sym_catch] = ACTIONS(677),
    [anon_sym_filter] = ACTIONS(677),
    [anon_sym_mul] = ACTIONS(677),
    [anon_sym_urem] = ACTIONS(677),
    [anon_sym_srem] = ACTIONS(677),
    [anon_sym_shl] = ACTIONS(677),
    [anon_sym_udiv] = ACTIONS(677),
    [anon_sym_sdiv] = ACTIONS(677),
    [anon_sym_lshr] = ACTIONS(677),
    [anon_sym_ashr] = ACTIONS(677),
    [anon_sym_fmul] = ACTIONS(677),
    [anon_sym_fdiv] = ACTIONS(677),
    [anon_sym_frem] = ACTIONS(677),
    [anon_sym_xchg] = ACTIONS(677),
    [anon_sym_add] = ACTIONS(677),
    [anon_sym_sub] = ACTIONS(677),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_nand] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(677),
    [anon_sym_xor] = ACTIONS(677),
    [anon_sym_max] = ACTIONS(677),
    [anon_sym_min] = ACTIONS(677),
    [anon_sym_umax] = ACTIONS(677),
    [anon_sym_umin] = ACTIONS(677),
    [anon_sym_fadd] = ACTIONS(677),
    [anon_sym_fsub] = ACTIONS(677),
    [anon_sym_bitcast] = ACTIONS(677),
    [anon_sym_trunc] = ACTIONS(677),
    [anon_sym_zext] = ACTIONS(677),
    [anon_sym_sext] = ACTIONS(677),
    [anon_sym_fptrunc] = ACTIONS(677),
    [anon_sym_fpext] = ACTIONS(677),
    [anon_sym_addrspacecast] = ACTIONS(677),
    [anon_sym_uitofp] = ACTIONS(677),
    [anon_sym_sitofp] = ACTIONS(677),
    [anon_sym_fptoui] = ACTIONS(677),
    [anon_sym_fptosi] = ACTIONS(677),
    [anon_sym_inttoptr] = ACTIONS(677),
    [anon_sym_ptrtoint] = ACTIONS(677),
    [anon_sym_unordered] = ACTIONS(677),
    [anon_sym_monotonic] = ACTIONS(677),
    [anon_sym_acquire] = ACTIONS(677),
    [anon_sym_release] = ACTIONS(677),
    [anon_sym_acq_rel] = ACTIONS(677),
    [anon_sym_seq_cst] = ACTIONS(677),
    [anon_sym_syncscope] = ACTIONS(677),
    [anon_sym_uselistorder] = ACTIONS(677),
  },
  [174] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [sym_label] = ACTIONS(509),
    [sym_string] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_section] = ACTIONS(511),
    [anon_sym_partition] = ACTIONS(511),
    [anon_sym_comdat] = ACTIONS(511),
    [anon_sym_gc] = ACTIONS(511),
    [anon_sym_prefix] = ACTIONS(511),
    [anon_sym_prologue] = ACTIONS(511),
    [anon_sym_personality] = ACTIONS(511),
    [anon_sym_alignstack] = ACTIONS(511),
    [anon_sym_allocsize] = ACTIONS(511),
    [anon_sym_alwaysinline] = ACTIONS(511),
    [anon_sym_builtin] = ACTIONS(511),
    [anon_sym_cold] = ACTIONS(511),
    [anon_sym_convergent] = ACTIONS(511),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(511),
    [anon_sym_hot] = ACTIONS(511),
    [anon_sym_inaccessiblememonly] = ACTIONS(511),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(511),
    [anon_sym_inlinehint] = ACTIONS(511),
    [anon_sym_jumptable] = ACTIONS(511),
    [anon_sym_minsize] = ACTIONS(511),
    [anon_sym_naked] = ACTIONS(511),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(511),
    [anon_sym_nobuiltin] = ACTIONS(511),
    [anon_sym_noduplicate] = ACTIONS(511),
    [anon_sym_nofree] = ACTIONS(511),
    [anon_sym_noimplicitfloat] = ACTIONS(511),
    [anon_sym_noinline] = ACTIONS(511),
    [anon_sym_nomerge] = ACTIONS(511),
    [anon_sym_nonlazybind] = ACTIONS(511),
    [anon_sym_noprofile] = ACTIONS(511),
    [anon_sym_noredzone] = ACTIONS(511),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(511),
    [anon_sym_noreturn] = ACTIONS(511),
    [anon_sym_norecurse] = ACTIONS(511),
    [anon_sym_willreturn] = ACTIONS(511),
    [anon_sym_nosync] = ACTIONS(511),
    [anon_sym_nounwind] = ACTIONS(511),
    [anon_sym_nosanitize_coverage] = ACTIONS(511),
    [anon_sym_null_pointer_is_valid] = ACTIONS(511),
    [anon_sym_optforfuzzing] = ACTIONS(511),
    [anon_sym_optnone] = ACTIONS(511),
    [anon_sym_optsize] = ACTIONS(511),
    [anon_sym_readnone] = ACTIONS(511),
    [anon_sym_readonly] = ACTIONS(511),
    [anon_sym_writeonly] = ACTIONS(511),
    [anon_sym_argmemonly] = ACTIONS(511),
    [anon_sym_returns_twice] = ACTIONS(511),
    [anon_sym_safestack] = ACTIONS(511),
    [anon_sym_sanitize_address] = ACTIONS(511),
    [anon_sym_sanitize_memory] = ACTIONS(511),
    [anon_sym_sanitize_thread] = ACTIONS(511),
    [anon_sym_sanitize_hwaddress] = ACTIONS(511),
    [anon_sym_sanitize_memtag] = ACTIONS(511),
    [anon_sym_speculative_load_hardening] = ACTIONS(511),
    [anon_sym_speculatable] = ACTIONS(511),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(511),
    [anon_sym_sspreq] = ACTIONS(511),
    [anon_sym_strictfp] = ACTIONS(511),
    [anon_sym_uwtable] = ACTIONS(511),
    [anon_sym_nocf_check] = ACTIONS(511),
    [anon_sym_shadowcallstack] = ACTIONS(511),
    [anon_sym_mustprogress] = ACTIONS(511),
    [anon_sym_vscale_range] = ACTIONS(511),
    [anon_sym_preallocated] = ACTIONS(511),
    [anon_sym_zeroext] = ACTIONS(511),
    [anon_sym_signext] = ACTIONS(511),
    [anon_sym_inreg] = ACTIONS(511),
    [anon_sym_byval] = ACTIONS(511),
    [anon_sym_byref] = ACTIONS(511),
    [anon_sym_inalloca] = ACTIONS(511),
    [anon_sym_sret] = ACTIONS(511),
    [anon_sym_elementtype] = ACTIONS(511),
    [anon_sym_noalias] = ACTIONS(511),
    [anon_sym_nocapture] = ACTIONS(511),
    [anon_sym_nest] = ACTIONS(511),
    [anon_sym_returned] = ACTIONS(511),
    [anon_sym_nonnull] = ACTIONS(511),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(511),
    [anon_sym_swiftself] = ACTIONS(511),
    [anon_sym_swiftasync] = ACTIONS(511),
    [anon_sym_swifterror] = ACTIONS(511),
    [anon_sym_immarg] = ACTIONS(511),
    [anon_sym_noundef] = ACTIONS(511),
    [anon_sym_unreachable] = ACTIONS(511),
    [anon_sym_ret] = ACTIONS(511),
    [anon_sym_br] = ACTIONS(511),
    [anon_sym_resume] = ACTIONS(511),
    [anon_sym_freeze] = ACTIONS(511),
    [anon_sym_indirectbr] = ACTIONS(511),
    [anon_sym_extractelement] = ACTIONS(511),
    [anon_sym_insertelement] = ACTIONS(511),
    [anon_sym_select] = ACTIONS(511),
    [anon_sym_shufflevector] = ACTIONS(511),
    [anon_sym_fneg] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(511),
    [anon_sym_invoke] = ACTIONS(511),
    [anon_sym_cleanupret] = ACTIONS(511),
    [anon_sym_catchret] = ACTIONS(511),
    [anon_sym_catchswitch] = ACTIONS(511),
    [anon_sym_catchpad] = ACTIONS(511),
    [anon_sym_cleanuppad] = ACTIONS(511),
    [anon_sym_callbr] = ACTIONS(511),
    [anon_sym_icmp] = ACTIONS(511),
    [anon_sym_fcmp] = ACTIONS(511),
    [anon_sym_va_arg] = ACTIONS(511),
    [anon_sym_phi] = ACTIONS(511),
    [anon_sym_landingpad] = ACTIONS(511),
    [anon_sym_tail] = ACTIONS(511),
    [anon_sym_musttail] = ACTIONS(511),
    [anon_sym_notail] = ACTIONS(511),
    [anon_sym_call] = ACTIONS(511),
    [anon_sym_alloca] = ACTIONS(511),
    [anon_sym_load] = ACTIONS(511),
    [anon_sym_store] = ACTIONS(511),
    [anon_sym_cmpxchg] = ACTIONS(511),
    [anon_sym_atomicrmw] = ACTIONS(511),
    [anon_sym_fence] = ACTIONS(511),
    [anon_sym_getelementptr] = ACTIONS(511),
    [anon_sym_extractvalue] = ACTIONS(511),
    [anon_sym_insertvalue] = ACTIONS(511),
    [anon_sym_catch] = ACTIONS(511),
    [anon_sym_filter] = ACTIONS(511),
    [anon_sym_mul] = ACTIONS(511),
    [anon_sym_urem] = ACTIONS(511),
    [anon_sym_srem] = ACTIONS(511),
    [anon_sym_shl] = ACTIONS(511),
    [anon_sym_udiv] = ACTIONS(511),
    [anon_sym_sdiv] = ACTIONS(511),
    [anon_sym_lshr] = ACTIONS(511),
    [anon_sym_ashr] = ACTIONS(511),
    [anon_sym_fmul] = ACTIONS(511),
    [anon_sym_fdiv] = ACTIONS(511),
    [anon_sym_frem] = ACTIONS(511),
    [anon_sym_xchg] = ACTIONS(511),
    [anon_sym_add] = ACTIONS(511),
    [anon_sym_sub] = ACTIONS(511),
    [anon_sym_and] = ACTIONS(511),
    [anon_sym_nand] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(511),
    [anon_sym_xor] = ACTIONS(511),
    [anon_sym_max] = ACTIONS(511),
    [anon_sym_min] = ACTIONS(511),
    [anon_sym_umax] = ACTIONS(511),
    [anon_sym_umin] = ACTIONS(511),
    [anon_sym_fadd] = ACTIONS(511),
    [anon_sym_fsub] = ACTIONS(511),
    [anon_sym_bitcast] = ACTIONS(511),
    [anon_sym_trunc] = ACTIONS(511),
    [anon_sym_zext] = ACTIONS(511),
    [anon_sym_sext] = ACTIONS(511),
    [anon_sym_fptrunc] = ACTIONS(511),
    [anon_sym_fpext] = ACTIONS(511),
    [anon_sym_addrspacecast] = ACTIONS(511),
    [anon_sym_uitofp] = ACTIONS(511),
    [anon_sym_sitofp] = ACTIONS(511),
    [anon_sym_fptoui] = ACTIONS(511),
    [anon_sym_fptosi] = ACTIONS(511),
    [anon_sym_inttoptr] = ACTIONS(511),
    [anon_sym_ptrtoint] = ACTIONS(511),
    [anon_sym_unordered] = ACTIONS(511),
    [anon_sym_monotonic] = ACTIONS(511),
    [anon_sym_acquire] = ACTIONS(511),
    [anon_sym_release] = ACTIONS(511),
    [anon_sym_acq_rel] = ACTIONS(511),
    [anon_sym_seq_cst] = ACTIONS(511),
    [anon_sym_syncscope] = ACTIONS(511),
    [anon_sym_uselistorder] = ACTIONS(511),
  },
  [175] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [sym_label] = ACTIONS(603),
    [sym_string] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_section] = ACTIONS(605),
    [anon_sym_partition] = ACTIONS(605),
    [anon_sym_comdat] = ACTIONS(605),
    [anon_sym_gc] = ACTIONS(605),
    [anon_sym_prefix] = ACTIONS(605),
    [anon_sym_prologue] = ACTIONS(605),
    [anon_sym_personality] = ACTIONS(605),
    [anon_sym_alignstack] = ACTIONS(605),
    [anon_sym_allocsize] = ACTIONS(605),
    [anon_sym_alwaysinline] = ACTIONS(605),
    [anon_sym_builtin] = ACTIONS(605),
    [anon_sym_cold] = ACTIONS(605),
    [anon_sym_convergent] = ACTIONS(605),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(605),
    [anon_sym_hot] = ACTIONS(605),
    [anon_sym_inaccessiblememonly] = ACTIONS(605),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(605),
    [anon_sym_inlinehint] = ACTIONS(605),
    [anon_sym_jumptable] = ACTIONS(605),
    [anon_sym_minsize] = ACTIONS(605),
    [anon_sym_naked] = ACTIONS(605),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(605),
    [anon_sym_nobuiltin] = ACTIONS(605),
    [anon_sym_noduplicate] = ACTIONS(605),
    [anon_sym_nofree] = ACTIONS(605),
    [anon_sym_noimplicitfloat] = ACTIONS(605),
    [anon_sym_noinline] = ACTIONS(605),
    [anon_sym_nomerge] = ACTIONS(605),
    [anon_sym_nonlazybind] = ACTIONS(605),
    [anon_sym_noprofile] = ACTIONS(605),
    [anon_sym_noredzone] = ACTIONS(605),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(605),
    [anon_sym_noreturn] = ACTIONS(605),
    [anon_sym_norecurse] = ACTIONS(605),
    [anon_sym_willreturn] = ACTIONS(605),
    [anon_sym_nosync] = ACTIONS(605),
    [anon_sym_nounwind] = ACTIONS(605),
    [anon_sym_nosanitize_coverage] = ACTIONS(605),
    [anon_sym_null_pointer_is_valid] = ACTIONS(605),
    [anon_sym_optforfuzzing] = ACTIONS(605),
    [anon_sym_optnone] = ACTIONS(605),
    [anon_sym_optsize] = ACTIONS(605),
    [anon_sym_readnone] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_writeonly] = ACTIONS(605),
    [anon_sym_argmemonly] = ACTIONS(605),
    [anon_sym_returns_twice] = ACTIONS(605),
    [anon_sym_safestack] = ACTIONS(605),
    [anon_sym_sanitize_address] = ACTIONS(605),
    [anon_sym_sanitize_memory] = ACTIONS(605),
    [anon_sym_sanitize_thread] = ACTIONS(605),
    [anon_sym_sanitize_hwaddress] = ACTIONS(605),
    [anon_sym_sanitize_memtag] = ACTIONS(605),
    [anon_sym_speculative_load_hardening] = ACTIONS(605),
    [anon_sym_speculatable] = ACTIONS(605),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(605),
    [anon_sym_sspreq] = ACTIONS(605),
    [anon_sym_strictfp] = ACTIONS(605),
    [anon_sym_uwtable] = ACTIONS(605),
    [anon_sym_nocf_check] = ACTIONS(605),
    [anon_sym_shadowcallstack] = ACTIONS(605),
    [anon_sym_mustprogress] = ACTIONS(605),
    [anon_sym_vscale_range] = ACTIONS(605),
    [anon_sym_preallocated] = ACTIONS(605),
    [anon_sym_zeroext] = ACTIONS(605),
    [anon_sym_signext] = ACTIONS(605),
    [anon_sym_inreg] = ACTIONS(605),
    [anon_sym_byval] = ACTIONS(605),
    [anon_sym_byref] = ACTIONS(605),
    [anon_sym_inalloca] = ACTIONS(605),
    [anon_sym_sret] = ACTIONS(605),
    [anon_sym_elementtype] = ACTIONS(605),
    [anon_sym_noalias] = ACTIONS(605),
    [anon_sym_nocapture] = ACTIONS(605),
    [anon_sym_nest] = ACTIONS(605),
    [anon_sym_returned] = ACTIONS(605),
    [anon_sym_nonnull] = ACTIONS(605),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(605),
    [anon_sym_swiftself] = ACTIONS(605),
    [anon_sym_swiftasync] = ACTIONS(605),
    [anon_sym_swifterror] = ACTIONS(605),
    [anon_sym_immarg] = ACTIONS(605),
    [anon_sym_noundef] = ACTIONS(605),
    [anon_sym_unreachable] = ACTIONS(605),
    [anon_sym_ret] = ACTIONS(605),
    [anon_sym_br] = ACTIONS(605),
    [anon_sym_resume] = ACTIONS(605),
    [anon_sym_freeze] = ACTIONS(605),
    [anon_sym_indirectbr] = ACTIONS(605),
    [anon_sym_extractelement] = ACTIONS(605),
    [anon_sym_insertelement] = ACTIONS(605),
    [anon_sym_select] = ACTIONS(605),
    [anon_sym_shufflevector] = ACTIONS(605),
    [anon_sym_fneg] = ACTIONS(605),
    [anon_sym_switch] = ACTIONS(605),
    [anon_sym_invoke] = ACTIONS(605),
    [anon_sym_cleanupret] = ACTIONS(605),
    [anon_sym_catchret] = ACTIONS(605),
    [anon_sym_catchswitch] = ACTIONS(605),
    [anon_sym_catchpad] = ACTIONS(605),
    [anon_sym_cleanuppad] = ACTIONS(605),
    [anon_sym_callbr] = ACTIONS(605),
    [anon_sym_icmp] = ACTIONS(605),
    [anon_sym_fcmp] = ACTIONS(605),
    [anon_sym_va_arg] = ACTIONS(605),
    [anon_sym_phi] = ACTIONS(605),
    [anon_sym_landingpad] = ACTIONS(605),
    [anon_sym_tail] = ACTIONS(605),
    [anon_sym_musttail] = ACTIONS(605),
    [anon_sym_notail] = ACTIONS(605),
    [anon_sym_call] = ACTIONS(605),
    [anon_sym_alloca] = ACTIONS(605),
    [anon_sym_load] = ACTIONS(605),
    [anon_sym_store] = ACTIONS(605),
    [anon_sym_cmpxchg] = ACTIONS(605),
    [anon_sym_atomicrmw] = ACTIONS(605),
    [anon_sym_fence] = ACTIONS(605),
    [anon_sym_getelementptr] = ACTIONS(605),
    [anon_sym_extractvalue] = ACTIONS(605),
    [anon_sym_insertvalue] = ACTIONS(605),
    [anon_sym_catch] = ACTIONS(605),
    [anon_sym_filter] = ACTIONS(605),
    [anon_sym_mul] = ACTIONS(605),
    [anon_sym_urem] = ACTIONS(605),
    [anon_sym_srem] = ACTIONS(605),
    [anon_sym_shl] = ACTIONS(605),
    [anon_sym_udiv] = ACTIONS(605),
    [anon_sym_sdiv] = ACTIONS(605),
    [anon_sym_lshr] = ACTIONS(605),
    [anon_sym_ashr] = ACTIONS(605),
    [anon_sym_fmul] = ACTIONS(605),
    [anon_sym_fdiv] = ACTIONS(605),
    [anon_sym_frem] = ACTIONS(605),
    [anon_sym_xchg] = ACTIONS(605),
    [anon_sym_add] = ACTIONS(605),
    [anon_sym_sub] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_nand] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_xor] = ACTIONS(605),
    [anon_sym_max] = ACTIONS(605),
    [anon_sym_min] = ACTIONS(605),
    [anon_sym_umax] = ACTIONS(605),
    [anon_sym_umin] = ACTIONS(605),
    [anon_sym_fadd] = ACTIONS(605),
    [anon_sym_fsub] = ACTIONS(605),
    [anon_sym_bitcast] = ACTIONS(605),
    [anon_sym_trunc] = ACTIONS(605),
    [anon_sym_zext] = ACTIONS(605),
    [anon_sym_sext] = ACTIONS(605),
    [anon_sym_fptrunc] = ACTIONS(605),
    [anon_sym_fpext] = ACTIONS(605),
    [anon_sym_addrspacecast] = ACTIONS(605),
    [anon_sym_uitofp] = ACTIONS(605),
    [anon_sym_sitofp] = ACTIONS(605),
    [anon_sym_fptoui] = ACTIONS(605),
    [anon_sym_fptosi] = ACTIONS(605),
    [anon_sym_inttoptr] = ACTIONS(605),
    [anon_sym_ptrtoint] = ACTIONS(605),
    [anon_sym_unordered] = ACTIONS(605),
    [anon_sym_monotonic] = ACTIONS(605),
    [anon_sym_acquire] = ACTIONS(605),
    [anon_sym_release] = ACTIONS(605),
    [anon_sym_acq_rel] = ACTIONS(605),
    [anon_sym_seq_cst] = ACTIONS(605),
    [anon_sym_syncscope] = ACTIONS(605),
    [anon_sym_uselistorder] = ACTIONS(605),
  },
  [176] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [sym_label] = ACTIONS(591),
    [sym_string] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_section] = ACTIONS(593),
    [anon_sym_partition] = ACTIONS(593),
    [anon_sym_comdat] = ACTIONS(593),
    [anon_sym_gc] = ACTIONS(593),
    [anon_sym_prefix] = ACTIONS(593),
    [anon_sym_prologue] = ACTIONS(593),
    [anon_sym_personality] = ACTIONS(593),
    [anon_sym_alignstack] = ACTIONS(593),
    [anon_sym_allocsize] = ACTIONS(593),
    [anon_sym_alwaysinline] = ACTIONS(593),
    [anon_sym_builtin] = ACTIONS(593),
    [anon_sym_cold] = ACTIONS(593),
    [anon_sym_convergent] = ACTIONS(593),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(593),
    [anon_sym_hot] = ACTIONS(593),
    [anon_sym_inaccessiblememonly] = ACTIONS(593),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(593),
    [anon_sym_inlinehint] = ACTIONS(593),
    [anon_sym_jumptable] = ACTIONS(593),
    [anon_sym_minsize] = ACTIONS(593),
    [anon_sym_naked] = ACTIONS(593),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(593),
    [anon_sym_nobuiltin] = ACTIONS(593),
    [anon_sym_noduplicate] = ACTIONS(593),
    [anon_sym_nofree] = ACTIONS(593),
    [anon_sym_noimplicitfloat] = ACTIONS(593),
    [anon_sym_noinline] = ACTIONS(593),
    [anon_sym_nomerge] = ACTIONS(593),
    [anon_sym_nonlazybind] = ACTIONS(593),
    [anon_sym_noprofile] = ACTIONS(593),
    [anon_sym_noredzone] = ACTIONS(593),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(593),
    [anon_sym_noreturn] = ACTIONS(593),
    [anon_sym_norecurse] = ACTIONS(593),
    [anon_sym_willreturn] = ACTIONS(593),
    [anon_sym_nosync] = ACTIONS(593),
    [anon_sym_nounwind] = ACTIONS(593),
    [anon_sym_nosanitize_coverage] = ACTIONS(593),
    [anon_sym_null_pointer_is_valid] = ACTIONS(593),
    [anon_sym_optforfuzzing] = ACTIONS(593),
    [anon_sym_optnone] = ACTIONS(593),
    [anon_sym_optsize] = ACTIONS(593),
    [anon_sym_readnone] = ACTIONS(593),
    [anon_sym_readonly] = ACTIONS(593),
    [anon_sym_writeonly] = ACTIONS(593),
    [anon_sym_argmemonly] = ACTIONS(593),
    [anon_sym_returns_twice] = ACTIONS(593),
    [anon_sym_safestack] = ACTIONS(593),
    [anon_sym_sanitize_address] = ACTIONS(593),
    [anon_sym_sanitize_memory] = ACTIONS(593),
    [anon_sym_sanitize_thread] = ACTIONS(593),
    [anon_sym_sanitize_hwaddress] = ACTIONS(593),
    [anon_sym_sanitize_memtag] = ACTIONS(593),
    [anon_sym_speculative_load_hardening] = ACTIONS(593),
    [anon_sym_speculatable] = ACTIONS(593),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(593),
    [anon_sym_sspreq] = ACTIONS(593),
    [anon_sym_strictfp] = ACTIONS(593),
    [anon_sym_uwtable] = ACTIONS(593),
    [anon_sym_nocf_check] = ACTIONS(593),
    [anon_sym_shadowcallstack] = ACTIONS(593),
    [anon_sym_mustprogress] = ACTIONS(593),
    [anon_sym_vscale_range] = ACTIONS(593),
    [anon_sym_preallocated] = ACTIONS(593),
    [anon_sym_zeroext] = ACTIONS(593),
    [anon_sym_signext] = ACTIONS(593),
    [anon_sym_inreg] = ACTIONS(593),
    [anon_sym_byval] = ACTIONS(593),
    [anon_sym_byref] = ACTIONS(593),
    [anon_sym_inalloca] = ACTIONS(593),
    [anon_sym_sret] = ACTIONS(593),
    [anon_sym_elementtype] = ACTIONS(593),
    [anon_sym_noalias] = ACTIONS(593),
    [anon_sym_nocapture] = ACTIONS(593),
    [anon_sym_nest] = ACTIONS(593),
    [anon_sym_returned] = ACTIONS(593),
    [anon_sym_nonnull] = ACTIONS(593),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(593),
    [anon_sym_swiftself] = ACTIONS(593),
    [anon_sym_swiftasync] = ACTIONS(593),
    [anon_sym_swifterror] = ACTIONS(593),
    [anon_sym_immarg] = ACTIONS(593),
    [anon_sym_noundef] = ACTIONS(593),
    [anon_sym_unreachable] = ACTIONS(593),
    [anon_sym_ret] = ACTIONS(593),
    [anon_sym_br] = ACTIONS(593),
    [anon_sym_resume] = ACTIONS(593),
    [anon_sym_freeze] = ACTIONS(593),
    [anon_sym_indirectbr] = ACTIONS(593),
    [anon_sym_extractelement] = ACTIONS(593),
    [anon_sym_insertelement] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_shufflevector] = ACTIONS(593),
    [anon_sym_fneg] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(593),
    [anon_sym_invoke] = ACTIONS(593),
    [anon_sym_cleanupret] = ACTIONS(593),
    [anon_sym_catchret] = ACTIONS(593),
    [anon_sym_catchswitch] = ACTIONS(593),
    [anon_sym_catchpad] = ACTIONS(593),
    [anon_sym_cleanuppad] = ACTIONS(593),
    [anon_sym_callbr] = ACTIONS(593),
    [anon_sym_icmp] = ACTIONS(593),
    [anon_sym_fcmp] = ACTIONS(593),
    [anon_sym_va_arg] = ACTIONS(593),
    [anon_sym_phi] = ACTIONS(593),
    [anon_sym_landingpad] = ACTIONS(593),
    [anon_sym_tail] = ACTIONS(593),
    [anon_sym_musttail] = ACTIONS(593),
    [anon_sym_notail] = ACTIONS(593),
    [anon_sym_call] = ACTIONS(593),
    [anon_sym_alloca] = ACTIONS(593),
    [anon_sym_load] = ACTIONS(593),
    [anon_sym_store] = ACTIONS(593),
    [anon_sym_cmpxchg] = ACTIONS(593),
    [anon_sym_atomicrmw] = ACTIONS(593),
    [anon_sym_fence] = ACTIONS(593),
    [anon_sym_getelementptr] = ACTIONS(593),
    [anon_sym_extractvalue] = ACTIONS(593),
    [anon_sym_insertvalue] = ACTIONS(593),
    [anon_sym_catch] = ACTIONS(593),
    [anon_sym_filter] = ACTIONS(593),
    [anon_sym_mul] = ACTIONS(593),
    [anon_sym_urem] = ACTIONS(593),
    [anon_sym_srem] = ACTIONS(593),
    [anon_sym_shl] = ACTIONS(593),
    [anon_sym_udiv] = ACTIONS(593),
    [anon_sym_sdiv] = ACTIONS(593),
    [anon_sym_lshr] = ACTIONS(593),
    [anon_sym_ashr] = ACTIONS(593),
    [anon_sym_fmul] = ACTIONS(593),
    [anon_sym_fdiv] = ACTIONS(593),
    [anon_sym_frem] = ACTIONS(593),
    [anon_sym_xchg] = ACTIONS(593),
    [anon_sym_add] = ACTIONS(593),
    [anon_sym_sub] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_nand] = ACTIONS(593),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_xor] = ACTIONS(593),
    [anon_sym_max] = ACTIONS(593),
    [anon_sym_min] = ACTIONS(593),
    [anon_sym_umax] = ACTIONS(593),
    [anon_sym_umin] = ACTIONS(593),
    [anon_sym_fadd] = ACTIONS(593),
    [anon_sym_fsub] = ACTIONS(593),
    [anon_sym_bitcast] = ACTIONS(593),
    [anon_sym_trunc] = ACTIONS(593),
    [anon_sym_zext] = ACTIONS(593),
    [anon_sym_sext] = ACTIONS(593),
    [anon_sym_fptrunc] = ACTIONS(593),
    [anon_sym_fpext] = ACTIONS(593),
    [anon_sym_addrspacecast] = ACTIONS(593),
    [anon_sym_uitofp] = ACTIONS(593),
    [anon_sym_sitofp] = ACTIONS(593),
    [anon_sym_fptoui] = ACTIONS(593),
    [anon_sym_fptosi] = ACTIONS(593),
    [anon_sym_inttoptr] = ACTIONS(593),
    [anon_sym_ptrtoint] = ACTIONS(593),
    [anon_sym_unordered] = ACTIONS(593),
    [anon_sym_monotonic] = ACTIONS(593),
    [anon_sym_acquire] = ACTIONS(593),
    [anon_sym_release] = ACTIONS(593),
    [anon_sym_acq_rel] = ACTIONS(593),
    [anon_sym_seq_cst] = ACTIONS(593),
    [anon_sym_syncscope] = ACTIONS(593),
    [anon_sym_uselistorder] = ACTIONS(593),
  },
  [177] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [sym_label] = ACTIONS(599),
    [sym_string] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_section] = ACTIONS(601),
    [anon_sym_partition] = ACTIONS(601),
    [anon_sym_comdat] = ACTIONS(601),
    [anon_sym_gc] = ACTIONS(601),
    [anon_sym_prefix] = ACTIONS(601),
    [anon_sym_prologue] = ACTIONS(601),
    [anon_sym_personality] = ACTIONS(601),
    [anon_sym_alignstack] = ACTIONS(601),
    [anon_sym_allocsize] = ACTIONS(601),
    [anon_sym_alwaysinline] = ACTIONS(601),
    [anon_sym_builtin] = ACTIONS(601),
    [anon_sym_cold] = ACTIONS(601),
    [anon_sym_convergent] = ACTIONS(601),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(601),
    [anon_sym_hot] = ACTIONS(601),
    [anon_sym_inaccessiblememonly] = ACTIONS(601),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(601),
    [anon_sym_inlinehint] = ACTIONS(601),
    [anon_sym_jumptable] = ACTIONS(601),
    [anon_sym_minsize] = ACTIONS(601),
    [anon_sym_naked] = ACTIONS(601),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(601),
    [anon_sym_nobuiltin] = ACTIONS(601),
    [anon_sym_noduplicate] = ACTIONS(601),
    [anon_sym_nofree] = ACTIONS(601),
    [anon_sym_noimplicitfloat] = ACTIONS(601),
    [anon_sym_noinline] = ACTIONS(601),
    [anon_sym_nomerge] = ACTIONS(601),
    [anon_sym_nonlazybind] = ACTIONS(601),
    [anon_sym_noprofile] = ACTIONS(601),
    [anon_sym_noredzone] = ACTIONS(601),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(601),
    [anon_sym_noreturn] = ACTIONS(601),
    [anon_sym_norecurse] = ACTIONS(601),
    [anon_sym_willreturn] = ACTIONS(601),
    [anon_sym_nosync] = ACTIONS(601),
    [anon_sym_nounwind] = ACTIONS(601),
    [anon_sym_nosanitize_coverage] = ACTIONS(601),
    [anon_sym_null_pointer_is_valid] = ACTIONS(601),
    [anon_sym_optforfuzzing] = ACTIONS(601),
    [anon_sym_optnone] = ACTIONS(601),
    [anon_sym_optsize] = ACTIONS(601),
    [anon_sym_readnone] = ACTIONS(601),
    [anon_sym_readonly] = ACTIONS(601),
    [anon_sym_writeonly] = ACTIONS(601),
    [anon_sym_argmemonly] = ACTIONS(601),
    [anon_sym_returns_twice] = ACTIONS(601),
    [anon_sym_safestack] = ACTIONS(601),
    [anon_sym_sanitize_address] = ACTIONS(601),
    [anon_sym_sanitize_memory] = ACTIONS(601),
    [anon_sym_sanitize_thread] = ACTIONS(601),
    [anon_sym_sanitize_hwaddress] = ACTIONS(601),
    [anon_sym_sanitize_memtag] = ACTIONS(601),
    [anon_sym_speculative_load_hardening] = ACTIONS(601),
    [anon_sym_speculatable] = ACTIONS(601),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(601),
    [anon_sym_sspreq] = ACTIONS(601),
    [anon_sym_strictfp] = ACTIONS(601),
    [anon_sym_uwtable] = ACTIONS(601),
    [anon_sym_nocf_check] = ACTIONS(601),
    [anon_sym_shadowcallstack] = ACTIONS(601),
    [anon_sym_mustprogress] = ACTIONS(601),
    [anon_sym_vscale_range] = ACTIONS(601),
    [anon_sym_preallocated] = ACTIONS(601),
    [anon_sym_zeroext] = ACTIONS(601),
    [anon_sym_signext] = ACTIONS(601),
    [anon_sym_inreg] = ACTIONS(601),
    [anon_sym_byval] = ACTIONS(601),
    [anon_sym_byref] = ACTIONS(601),
    [anon_sym_inalloca] = ACTIONS(601),
    [anon_sym_sret] = ACTIONS(601),
    [anon_sym_elementtype] = ACTIONS(601),
    [anon_sym_noalias] = ACTIONS(601),
    [anon_sym_nocapture] = ACTIONS(601),
    [anon_sym_nest] = ACTIONS(601),
    [anon_sym_returned] = ACTIONS(601),
    [anon_sym_nonnull] = ACTIONS(601),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(601),
    [anon_sym_swiftself] = ACTIONS(601),
    [anon_sym_swiftasync] = ACTIONS(601),
    [anon_sym_swifterror] = ACTIONS(601),
    [anon_sym_immarg] = ACTIONS(601),
    [anon_sym_noundef] = ACTIONS(601),
    [anon_sym_unreachable] = ACTIONS(601),
    [anon_sym_ret] = ACTIONS(601),
    [anon_sym_br] = ACTIONS(601),
    [anon_sym_resume] = ACTIONS(601),
    [anon_sym_freeze] = ACTIONS(601),
    [anon_sym_indirectbr] = ACTIONS(601),
    [anon_sym_extractelement] = ACTIONS(601),
    [anon_sym_insertelement] = ACTIONS(601),
    [anon_sym_select] = ACTIONS(601),
    [anon_sym_shufflevector] = ACTIONS(601),
    [anon_sym_fneg] = ACTIONS(601),
    [anon_sym_switch] = ACTIONS(601),
    [anon_sym_invoke] = ACTIONS(601),
    [anon_sym_cleanupret] = ACTIONS(601),
    [anon_sym_catchret] = ACTIONS(601),
    [anon_sym_catchswitch] = ACTIONS(601),
    [anon_sym_catchpad] = ACTIONS(601),
    [anon_sym_cleanuppad] = ACTIONS(601),
    [anon_sym_callbr] = ACTIONS(601),
    [anon_sym_icmp] = ACTIONS(601),
    [anon_sym_fcmp] = ACTIONS(601),
    [anon_sym_va_arg] = ACTIONS(601),
    [anon_sym_phi] = ACTIONS(601),
    [anon_sym_landingpad] = ACTIONS(601),
    [anon_sym_tail] = ACTIONS(601),
    [anon_sym_musttail] = ACTIONS(601),
    [anon_sym_notail] = ACTIONS(601),
    [anon_sym_call] = ACTIONS(601),
    [anon_sym_alloca] = ACTIONS(601),
    [anon_sym_load] = ACTIONS(601),
    [anon_sym_store] = ACTIONS(601),
    [anon_sym_cmpxchg] = ACTIONS(601),
    [anon_sym_atomicrmw] = ACTIONS(601),
    [anon_sym_fence] = ACTIONS(601),
    [anon_sym_getelementptr] = ACTIONS(601),
    [anon_sym_extractvalue] = ACTIONS(601),
    [anon_sym_insertvalue] = ACTIONS(601),
    [anon_sym_catch] = ACTIONS(601),
    [anon_sym_filter] = ACTIONS(601),
    [anon_sym_mul] = ACTIONS(601),
    [anon_sym_urem] = ACTIONS(601),
    [anon_sym_srem] = ACTIONS(601),
    [anon_sym_shl] = ACTIONS(601),
    [anon_sym_udiv] = ACTIONS(601),
    [anon_sym_sdiv] = ACTIONS(601),
    [anon_sym_lshr] = ACTIONS(601),
    [anon_sym_ashr] = ACTIONS(601),
    [anon_sym_fmul] = ACTIONS(601),
    [anon_sym_fdiv] = ACTIONS(601),
    [anon_sym_frem] = ACTIONS(601),
    [anon_sym_xchg] = ACTIONS(601),
    [anon_sym_add] = ACTIONS(601),
    [anon_sym_sub] = ACTIONS(601),
    [anon_sym_and] = ACTIONS(601),
    [anon_sym_nand] = ACTIONS(601),
    [anon_sym_or] = ACTIONS(601),
    [anon_sym_xor] = ACTIONS(601),
    [anon_sym_max] = ACTIONS(601),
    [anon_sym_min] = ACTIONS(601),
    [anon_sym_umax] = ACTIONS(601),
    [anon_sym_umin] = ACTIONS(601),
    [anon_sym_fadd] = ACTIONS(601),
    [anon_sym_fsub] = ACTIONS(601),
    [anon_sym_bitcast] = ACTIONS(601),
    [anon_sym_trunc] = ACTIONS(601),
    [anon_sym_zext] = ACTIONS(601),
    [anon_sym_sext] = ACTIONS(601),
    [anon_sym_fptrunc] = ACTIONS(601),
    [anon_sym_fpext] = ACTIONS(601),
    [anon_sym_addrspacecast] = ACTIONS(601),
    [anon_sym_uitofp] = ACTIONS(601),
    [anon_sym_sitofp] = ACTIONS(601),
    [anon_sym_fptoui] = ACTIONS(601),
    [anon_sym_fptosi] = ACTIONS(601),
    [anon_sym_inttoptr] = ACTIONS(601),
    [anon_sym_ptrtoint] = ACTIONS(601),
    [anon_sym_unordered] = ACTIONS(601),
    [anon_sym_monotonic] = ACTIONS(601),
    [anon_sym_acquire] = ACTIONS(601),
    [anon_sym_release] = ACTIONS(601),
    [anon_sym_acq_rel] = ACTIONS(601),
    [anon_sym_seq_cst] = ACTIONS(601),
    [anon_sym_syncscope] = ACTIONS(601),
    [anon_sym_uselistorder] = ACTIONS(601),
  },
  [178] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [sym_label] = ACTIONS(573),
    [sym_string] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_section] = ACTIONS(575),
    [anon_sym_partition] = ACTIONS(575),
    [anon_sym_comdat] = ACTIONS(575),
    [anon_sym_gc] = ACTIONS(575),
    [anon_sym_prefix] = ACTIONS(575),
    [anon_sym_prologue] = ACTIONS(575),
    [anon_sym_personality] = ACTIONS(575),
    [anon_sym_alignstack] = ACTIONS(575),
    [anon_sym_allocsize] = ACTIONS(575),
    [anon_sym_alwaysinline] = ACTIONS(575),
    [anon_sym_builtin] = ACTIONS(575),
    [anon_sym_cold] = ACTIONS(575),
    [anon_sym_convergent] = ACTIONS(575),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(575),
    [anon_sym_hot] = ACTIONS(575),
    [anon_sym_inaccessiblememonly] = ACTIONS(575),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(575),
    [anon_sym_inlinehint] = ACTIONS(575),
    [anon_sym_jumptable] = ACTIONS(575),
    [anon_sym_minsize] = ACTIONS(575),
    [anon_sym_naked] = ACTIONS(575),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(575),
    [anon_sym_nobuiltin] = ACTIONS(575),
    [anon_sym_noduplicate] = ACTIONS(575),
    [anon_sym_nofree] = ACTIONS(575),
    [anon_sym_noimplicitfloat] = ACTIONS(575),
    [anon_sym_noinline] = ACTIONS(575),
    [anon_sym_nomerge] = ACTIONS(575),
    [anon_sym_nonlazybind] = ACTIONS(575),
    [anon_sym_noprofile] = ACTIONS(575),
    [anon_sym_noredzone] = ACTIONS(575),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(575),
    [anon_sym_noreturn] = ACTIONS(575),
    [anon_sym_norecurse] = ACTIONS(575),
    [anon_sym_willreturn] = ACTIONS(575),
    [anon_sym_nosync] = ACTIONS(575),
    [anon_sym_nounwind] = ACTIONS(575),
    [anon_sym_nosanitize_coverage] = ACTIONS(575),
    [anon_sym_null_pointer_is_valid] = ACTIONS(575),
    [anon_sym_optforfuzzing] = ACTIONS(575),
    [anon_sym_optnone] = ACTIONS(575),
    [anon_sym_optsize] = ACTIONS(575),
    [anon_sym_readnone] = ACTIONS(575),
    [anon_sym_readonly] = ACTIONS(575),
    [anon_sym_writeonly] = ACTIONS(575),
    [anon_sym_argmemonly] = ACTIONS(575),
    [anon_sym_returns_twice] = ACTIONS(575),
    [anon_sym_safestack] = ACTIONS(575),
    [anon_sym_sanitize_address] = ACTIONS(575),
    [anon_sym_sanitize_memory] = ACTIONS(575),
    [anon_sym_sanitize_thread] = ACTIONS(575),
    [anon_sym_sanitize_hwaddress] = ACTIONS(575),
    [anon_sym_sanitize_memtag] = ACTIONS(575),
    [anon_sym_speculative_load_hardening] = ACTIONS(575),
    [anon_sym_speculatable] = ACTIONS(575),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(575),
    [anon_sym_sspreq] = ACTIONS(575),
    [anon_sym_strictfp] = ACTIONS(575),
    [anon_sym_uwtable] = ACTIONS(575),
    [anon_sym_nocf_check] = ACTIONS(575),
    [anon_sym_shadowcallstack] = ACTIONS(575),
    [anon_sym_mustprogress] = ACTIONS(575),
    [anon_sym_vscale_range] = ACTIONS(575),
    [anon_sym_preallocated] = ACTIONS(575),
    [anon_sym_zeroext] = ACTIONS(575),
    [anon_sym_signext] = ACTIONS(575),
    [anon_sym_inreg] = ACTIONS(575),
    [anon_sym_byval] = ACTIONS(575),
    [anon_sym_byref] = ACTIONS(575),
    [anon_sym_inalloca] = ACTIONS(575),
    [anon_sym_sret] = ACTIONS(575),
    [anon_sym_elementtype] = ACTIONS(575),
    [anon_sym_noalias] = ACTIONS(575),
    [anon_sym_nocapture] = ACTIONS(575),
    [anon_sym_nest] = ACTIONS(575),
    [anon_sym_returned] = ACTIONS(575),
    [anon_sym_nonnull] = ACTIONS(575),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(575),
    [anon_sym_swiftself] = ACTIONS(575),
    [anon_sym_swiftasync] = ACTIONS(575),
    [anon_sym_swifterror] = ACTIONS(575),
    [anon_sym_immarg] = ACTIONS(575),
    [anon_sym_noundef] = ACTIONS(575),
    [anon_sym_unreachable] = ACTIONS(575),
    [anon_sym_ret] = ACTIONS(575),
    [anon_sym_br] = ACTIONS(575),
    [anon_sym_resume] = ACTIONS(575),
    [anon_sym_freeze] = ACTIONS(575),
    [anon_sym_indirectbr] = ACTIONS(575),
    [anon_sym_extractelement] = ACTIONS(575),
    [anon_sym_insertelement] = ACTIONS(575),
    [anon_sym_select] = ACTIONS(575),
    [anon_sym_shufflevector] = ACTIONS(575),
    [anon_sym_fneg] = ACTIONS(575),
    [anon_sym_switch] = ACTIONS(575),
    [anon_sym_invoke] = ACTIONS(575),
    [anon_sym_cleanupret] = ACTIONS(575),
    [anon_sym_catchret] = ACTIONS(575),
    [anon_sym_catchswitch] = ACTIONS(575),
    [anon_sym_catchpad] = ACTIONS(575),
    [anon_sym_cleanuppad] = ACTIONS(575),
    [anon_sym_callbr] = ACTIONS(575),
    [anon_sym_icmp] = ACTIONS(575),
    [anon_sym_fcmp] = ACTIONS(575),
    [anon_sym_va_arg] = ACTIONS(575),
    [anon_sym_phi] = ACTIONS(575),
    [anon_sym_landingpad] = ACTIONS(575),
    [anon_sym_tail] = ACTIONS(575),
    [anon_sym_musttail] = ACTIONS(575),
    [anon_sym_notail] = ACTIONS(575),
    [anon_sym_call] = ACTIONS(575),
    [anon_sym_alloca] = ACTIONS(575),
    [anon_sym_load] = ACTIONS(575),
    [anon_sym_store] = ACTIONS(575),
    [anon_sym_cmpxchg] = ACTIONS(575),
    [anon_sym_atomicrmw] = ACTIONS(575),
    [anon_sym_fence] = ACTIONS(575),
    [anon_sym_getelementptr] = ACTIONS(575),
    [anon_sym_extractvalue] = ACTIONS(575),
    [anon_sym_insertvalue] = ACTIONS(575),
    [anon_sym_catch] = ACTIONS(575),
    [anon_sym_filter] = ACTIONS(575),
    [anon_sym_mul] = ACTIONS(575),
    [anon_sym_urem] = ACTIONS(575),
    [anon_sym_srem] = ACTIONS(575),
    [anon_sym_shl] = ACTIONS(575),
    [anon_sym_udiv] = ACTIONS(575),
    [anon_sym_sdiv] = ACTIONS(575),
    [anon_sym_lshr] = ACTIONS(575),
    [anon_sym_ashr] = ACTIONS(575),
    [anon_sym_fmul] = ACTIONS(575),
    [anon_sym_fdiv] = ACTIONS(575),
    [anon_sym_frem] = ACTIONS(575),
    [anon_sym_xchg] = ACTIONS(575),
    [anon_sym_add] = ACTIONS(575),
    [anon_sym_sub] = ACTIONS(575),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_nand] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(575),
    [anon_sym_xor] = ACTIONS(575),
    [anon_sym_max] = ACTIONS(575),
    [anon_sym_min] = ACTIONS(575),
    [anon_sym_umax] = ACTIONS(575),
    [anon_sym_umin] = ACTIONS(575),
    [anon_sym_fadd] = ACTIONS(575),
    [anon_sym_fsub] = ACTIONS(575),
    [anon_sym_bitcast] = ACTIONS(575),
    [anon_sym_trunc] = ACTIONS(575),
    [anon_sym_zext] = ACTIONS(575),
    [anon_sym_sext] = ACTIONS(575),
    [anon_sym_fptrunc] = ACTIONS(575),
    [anon_sym_fpext] = ACTIONS(575),
    [anon_sym_addrspacecast] = ACTIONS(575),
    [anon_sym_uitofp] = ACTIONS(575),
    [anon_sym_sitofp] = ACTIONS(575),
    [anon_sym_fptoui] = ACTIONS(575),
    [anon_sym_fptosi] = ACTIONS(575),
    [anon_sym_inttoptr] = ACTIONS(575),
    [anon_sym_ptrtoint] = ACTIONS(575),
    [anon_sym_unordered] = ACTIONS(575),
    [anon_sym_monotonic] = ACTIONS(575),
    [anon_sym_acquire] = ACTIONS(575),
    [anon_sym_release] = ACTIONS(575),
    [anon_sym_acq_rel] = ACTIONS(575),
    [anon_sym_seq_cst] = ACTIONS(575),
    [anon_sym_syncscope] = ACTIONS(575),
    [anon_sym_uselistorder] = ACTIONS(575),
  },
  [179] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(577),
    [sym_local_var] = ACTIONS(577),
    [sym_label] = ACTIONS(577),
    [sym_string] = ACTIONS(579),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(577),
    [anon_sym_align] = ACTIONS(579),
    [anon_sym_section] = ACTIONS(579),
    [anon_sym_partition] = ACTIONS(579),
    [anon_sym_comdat] = ACTIONS(579),
    [anon_sym_gc] = ACTIONS(579),
    [anon_sym_prefix] = ACTIONS(579),
    [anon_sym_prologue] = ACTIONS(579),
    [anon_sym_personality] = ACTIONS(579),
    [anon_sym_alignstack] = ACTIONS(579),
    [anon_sym_allocsize] = ACTIONS(579),
    [anon_sym_alwaysinline] = ACTIONS(579),
    [anon_sym_builtin] = ACTIONS(579),
    [anon_sym_cold] = ACTIONS(579),
    [anon_sym_convergent] = ACTIONS(579),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(579),
    [anon_sym_hot] = ACTIONS(579),
    [anon_sym_inaccessiblememonly] = ACTIONS(579),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(579),
    [anon_sym_inlinehint] = ACTIONS(579),
    [anon_sym_jumptable] = ACTIONS(579),
    [anon_sym_minsize] = ACTIONS(579),
    [anon_sym_naked] = ACTIONS(579),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(579),
    [anon_sym_nobuiltin] = ACTIONS(579),
    [anon_sym_noduplicate] = ACTIONS(579),
    [anon_sym_nofree] = ACTIONS(579),
    [anon_sym_noimplicitfloat] = ACTIONS(579),
    [anon_sym_noinline] = ACTIONS(579),
    [anon_sym_nomerge] = ACTIONS(579),
    [anon_sym_nonlazybind] = ACTIONS(579),
    [anon_sym_noprofile] = ACTIONS(579),
    [anon_sym_noredzone] = ACTIONS(579),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(579),
    [anon_sym_noreturn] = ACTIONS(579),
    [anon_sym_norecurse] = ACTIONS(579),
    [anon_sym_willreturn] = ACTIONS(579),
    [anon_sym_nosync] = ACTIONS(579),
    [anon_sym_nounwind] = ACTIONS(579),
    [anon_sym_nosanitize_coverage] = ACTIONS(579),
    [anon_sym_null_pointer_is_valid] = ACTIONS(579),
    [anon_sym_optforfuzzing] = ACTIONS(579),
    [anon_sym_optnone] = ACTIONS(579),
    [anon_sym_optsize] = ACTIONS(579),
    [anon_sym_readnone] = ACTIONS(579),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_writeonly] = ACTIONS(579),
    [anon_sym_argmemonly] = ACTIONS(579),
    [anon_sym_returns_twice] = ACTIONS(579),
    [anon_sym_safestack] = ACTIONS(579),
    [anon_sym_sanitize_address] = ACTIONS(579),
    [anon_sym_sanitize_memory] = ACTIONS(579),
    [anon_sym_sanitize_thread] = ACTIONS(579),
    [anon_sym_sanitize_hwaddress] = ACTIONS(579),
    [anon_sym_sanitize_memtag] = ACTIONS(579),
    [anon_sym_speculative_load_hardening] = ACTIONS(579),
    [anon_sym_speculatable] = ACTIONS(579),
    [anon_sym_ssp] = ACTIONS(579),
    [anon_sym_sspstrong] = ACTIONS(579),
    [anon_sym_sspreq] = ACTIONS(579),
    [anon_sym_strictfp] = ACTIONS(579),
    [anon_sym_uwtable] = ACTIONS(579),
    [anon_sym_nocf_check] = ACTIONS(579),
    [anon_sym_shadowcallstack] = ACTIONS(579),
    [anon_sym_mustprogress] = ACTIONS(579),
    [anon_sym_vscale_range] = ACTIONS(579),
    [anon_sym_preallocated] = ACTIONS(579),
    [anon_sym_zeroext] = ACTIONS(579),
    [anon_sym_signext] = ACTIONS(579),
    [anon_sym_inreg] = ACTIONS(579),
    [anon_sym_byval] = ACTIONS(579),
    [anon_sym_byref] = ACTIONS(579),
    [anon_sym_inalloca] = ACTIONS(579),
    [anon_sym_sret] = ACTIONS(579),
    [anon_sym_elementtype] = ACTIONS(579),
    [anon_sym_noalias] = ACTIONS(579),
    [anon_sym_nocapture] = ACTIONS(579),
    [anon_sym_nest] = ACTIONS(579),
    [anon_sym_returned] = ACTIONS(579),
    [anon_sym_nonnull] = ACTIONS(579),
    [anon_sym_dereferenceable] = ACTIONS(579),
    [anon_sym_dereferenceable_or_null] = ACTIONS(579),
    [anon_sym_swiftself] = ACTIONS(579),
    [anon_sym_swiftasync] = ACTIONS(579),
    [anon_sym_swifterror] = ACTIONS(579),
    [anon_sym_immarg] = ACTIONS(579),
    [anon_sym_noundef] = ACTIONS(579),
    [anon_sym_unreachable] = ACTIONS(579),
    [anon_sym_ret] = ACTIONS(579),
    [anon_sym_br] = ACTIONS(579),
    [anon_sym_resume] = ACTIONS(579),
    [anon_sym_freeze] = ACTIONS(579),
    [anon_sym_indirectbr] = ACTIONS(579),
    [anon_sym_extractelement] = ACTIONS(579),
    [anon_sym_insertelement] = ACTIONS(579),
    [anon_sym_select] = ACTIONS(579),
    [anon_sym_shufflevector] = ACTIONS(579),
    [anon_sym_fneg] = ACTIONS(579),
    [anon_sym_switch] = ACTIONS(579),
    [anon_sym_invoke] = ACTIONS(579),
    [anon_sym_cleanupret] = ACTIONS(579),
    [anon_sym_catchret] = ACTIONS(579),
    [anon_sym_catchswitch] = ACTIONS(579),
    [anon_sym_catchpad] = ACTIONS(579),
    [anon_sym_cleanuppad] = ACTIONS(579),
    [anon_sym_callbr] = ACTIONS(579),
    [anon_sym_icmp] = ACTIONS(579),
    [anon_sym_fcmp] = ACTIONS(579),
    [anon_sym_va_arg] = ACTIONS(579),
    [anon_sym_phi] = ACTIONS(579),
    [anon_sym_landingpad] = ACTIONS(579),
    [anon_sym_tail] = ACTIONS(579),
    [anon_sym_musttail] = ACTIONS(579),
    [anon_sym_notail] = ACTIONS(579),
    [anon_sym_call] = ACTIONS(579),
    [anon_sym_alloca] = ACTIONS(579),
    [anon_sym_load] = ACTIONS(579),
    [anon_sym_store] = ACTIONS(579),
    [anon_sym_cmpxchg] = ACTIONS(579),
    [anon_sym_atomicrmw] = ACTIONS(579),
    [anon_sym_fence] = ACTIONS(579),
    [anon_sym_getelementptr] = ACTIONS(579),
    [anon_sym_extractvalue] = ACTIONS(579),
    [anon_sym_insertvalue] = ACTIONS(579),
    [anon_sym_catch] = ACTIONS(579),
    [anon_sym_filter] = ACTIONS(579),
    [anon_sym_mul] = ACTIONS(579),
    [anon_sym_urem] = ACTIONS(579),
    [anon_sym_srem] = ACTIONS(579),
    [anon_sym_shl] = ACTIONS(579),
    [anon_sym_udiv] = ACTIONS(579),
    [anon_sym_sdiv] = ACTIONS(579),
    [anon_sym_lshr] = ACTIONS(579),
    [anon_sym_ashr] = ACTIONS(579),
    [anon_sym_fmul] = ACTIONS(579),
    [anon_sym_fdiv] = ACTIONS(579),
    [anon_sym_frem] = ACTIONS(579),
    [anon_sym_xchg] = ACTIONS(579),
    [anon_sym_add] = ACTIONS(579),
    [anon_sym_sub] = ACTIONS(579),
    [anon_sym_and] = ACTIONS(579),
    [anon_sym_nand] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(579),
    [anon_sym_xor] = ACTIONS(579),
    [anon_sym_max] = ACTIONS(579),
    [anon_sym_min] = ACTIONS(579),
    [anon_sym_umax] = ACTIONS(579),
    [anon_sym_umin] = ACTIONS(579),
    [anon_sym_fadd] = ACTIONS(579),
    [anon_sym_fsub] = ACTIONS(579),
    [anon_sym_bitcast] = ACTIONS(579),
    [anon_sym_trunc] = ACTIONS(579),
    [anon_sym_zext] = ACTIONS(579),
    [anon_sym_sext] = ACTIONS(579),
    [anon_sym_fptrunc] = ACTIONS(579),
    [anon_sym_fpext] = ACTIONS(579),
    [anon_sym_addrspacecast] = ACTIONS(579),
    [anon_sym_uitofp] = ACTIONS(579),
    [anon_sym_sitofp] = ACTIONS(579),
    [anon_sym_fptoui] = ACTIONS(579),
    [anon_sym_fptosi] = ACTIONS(579),
    [anon_sym_inttoptr] = ACTIONS(579),
    [anon_sym_ptrtoint] = ACTIONS(579),
    [anon_sym_unordered] = ACTIONS(579),
    [anon_sym_monotonic] = ACTIONS(579),
    [anon_sym_acquire] = ACTIONS(579),
    [anon_sym_release] = ACTIONS(579),
    [anon_sym_acq_rel] = ACTIONS(579),
    [anon_sym_seq_cst] = ACTIONS(579),
    [anon_sym_syncscope] = ACTIONS(579),
    [anon_sym_uselistorder] = ACTIONS(579),
  },
  [180] = {
    [sym_attribute] = STATE(191),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(577),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(191),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(695),
    [sym_label] = ACTIONS(695),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(695),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(711),
    [anon_sym_ret] = ACTIONS(711),
    [anon_sym_br] = ACTIONS(711),
    [anon_sym_resume] = ACTIONS(711),
    [anon_sym_freeze] = ACTIONS(711),
    [anon_sym_indirectbr] = ACTIONS(711),
    [anon_sym_extractelement] = ACTIONS(711),
    [anon_sym_insertelement] = ACTIONS(711),
    [anon_sym_select] = ACTIONS(711),
    [anon_sym_shufflevector] = ACTIONS(711),
    [anon_sym_fneg] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_invoke] = ACTIONS(711),
    [anon_sym_cleanupret] = ACTIONS(711),
    [anon_sym_catchret] = ACTIONS(711),
    [anon_sym_catchswitch] = ACTIONS(711),
    [anon_sym_catchpad] = ACTIONS(711),
    [anon_sym_cleanuppad] = ACTIONS(711),
    [anon_sym_callbr] = ACTIONS(711),
    [anon_sym_icmp] = ACTIONS(711),
    [anon_sym_fcmp] = ACTIONS(711),
    [anon_sym_va_arg] = ACTIONS(711),
    [anon_sym_phi] = ACTIONS(711),
    [anon_sym_landingpad] = ACTIONS(711),
    [anon_sym_tail] = ACTIONS(711),
    [anon_sym_musttail] = ACTIONS(711),
    [anon_sym_notail] = ACTIONS(711),
    [anon_sym_call] = ACTIONS(711),
    [anon_sym_alloca] = ACTIONS(711),
    [anon_sym_load] = ACTIONS(711),
    [anon_sym_store] = ACTIONS(711),
    [anon_sym_cmpxchg] = ACTIONS(711),
    [anon_sym_atomicrmw] = ACTIONS(711),
    [anon_sym_fence] = ACTIONS(711),
    [anon_sym_getelementptr] = ACTIONS(711),
    [anon_sym_extractvalue] = ACTIONS(711),
    [anon_sym_insertvalue] = ACTIONS(711),
    [anon_sym_mul] = ACTIONS(711),
    [anon_sym_urem] = ACTIONS(711),
    [anon_sym_srem] = ACTIONS(711),
    [anon_sym_shl] = ACTIONS(711),
    [anon_sym_udiv] = ACTIONS(711),
    [anon_sym_sdiv] = ACTIONS(711),
    [anon_sym_lshr] = ACTIONS(711),
    [anon_sym_ashr] = ACTIONS(711),
    [anon_sym_fmul] = ACTIONS(711),
    [anon_sym_fdiv] = ACTIONS(711),
    [anon_sym_frem] = ACTIONS(711),
    [anon_sym_xchg] = ACTIONS(711),
    [anon_sym_add] = ACTIONS(711),
    [anon_sym_sub] = ACTIONS(711),
    [anon_sym_and] = ACTIONS(711),
    [anon_sym_nand] = ACTIONS(711),
    [anon_sym_or] = ACTIONS(711),
    [anon_sym_xor] = ACTIONS(711),
    [anon_sym_max] = ACTIONS(711),
    [anon_sym_min] = ACTIONS(711),
    [anon_sym_umax] = ACTIONS(711),
    [anon_sym_umin] = ACTIONS(711),
    [anon_sym_fadd] = ACTIONS(711),
    [anon_sym_fsub] = ACTIONS(711),
    [anon_sym_bitcast] = ACTIONS(711),
    [anon_sym_trunc] = ACTIONS(711),
    [anon_sym_zext] = ACTIONS(711),
    [anon_sym_sext] = ACTIONS(711),
    [anon_sym_fptrunc] = ACTIONS(711),
    [anon_sym_fpext] = ACTIONS(711),
    [anon_sym_addrspacecast] = ACTIONS(711),
    [anon_sym_uitofp] = ACTIONS(711),
    [anon_sym_sitofp] = ACTIONS(711),
    [anon_sym_fptoui] = ACTIONS(711),
    [anon_sym_fptosi] = ACTIONS(711),
    [anon_sym_inttoptr] = ACTIONS(711),
    [anon_sym_ptrtoint] = ACTIONS(711),
    [anon_sym_uselistorder] = ACTIONS(711),
  },
  [181] = {
    [sym_number] = STATE(203),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_label] = ACTIONS(713),
    [sym_string] = ACTIONS(715),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(715),
    [anon_sym_partition] = ACTIONS(715),
    [anon_sym_comdat] = ACTIONS(715),
    [anon_sym_gc] = ACTIONS(715),
    [anon_sym_prefix] = ACTIONS(715),
    [anon_sym_prologue] = ACTIONS(715),
    [anon_sym_personality] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(715),
    [anon_sym_allocsize] = ACTIONS(715),
    [anon_sym_alwaysinline] = ACTIONS(715),
    [anon_sym_builtin] = ACTIONS(715),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(715),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(715),
    [anon_sym_hot] = ACTIONS(715),
    [anon_sym_inaccessiblememonly] = ACTIONS(715),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(715),
    [anon_sym_inlinehint] = ACTIONS(715),
    [anon_sym_jumptable] = ACTIONS(715),
    [anon_sym_minsize] = ACTIONS(715),
    [anon_sym_naked] = ACTIONS(715),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(715),
    [anon_sym_nobuiltin] = ACTIONS(715),
    [anon_sym_noduplicate] = ACTIONS(715),
    [anon_sym_nofree] = ACTIONS(715),
    [anon_sym_noimplicitfloat] = ACTIONS(715),
    [anon_sym_noinline] = ACTIONS(715),
    [anon_sym_nomerge] = ACTIONS(715),
    [anon_sym_nonlazybind] = ACTIONS(715),
    [anon_sym_noprofile] = ACTIONS(715),
    [anon_sym_noredzone] = ACTIONS(715),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(715),
    [anon_sym_noreturn] = ACTIONS(715),
    [anon_sym_norecurse] = ACTIONS(715),
    [anon_sym_willreturn] = ACTIONS(715),
    [anon_sym_nosync] = ACTIONS(715),
    [anon_sym_nounwind] = ACTIONS(715),
    [anon_sym_nosanitize_coverage] = ACTIONS(715),
    [anon_sym_null_pointer_is_valid] = ACTIONS(715),
    [anon_sym_optforfuzzing] = ACTIONS(715),
    [anon_sym_optnone] = ACTIONS(715),
    [anon_sym_optsize] = ACTIONS(715),
    [anon_sym_readnone] = ACTIONS(715),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_writeonly] = ACTIONS(715),
    [anon_sym_argmemonly] = ACTIONS(715),
    [anon_sym_returns_twice] = ACTIONS(715),
    [anon_sym_safestack] = ACTIONS(715),
    [anon_sym_sanitize_address] = ACTIONS(715),
    [anon_sym_sanitize_memory] = ACTIONS(715),
    [anon_sym_sanitize_thread] = ACTIONS(715),
    [anon_sym_sanitize_hwaddress] = ACTIONS(715),
    [anon_sym_sanitize_memtag] = ACTIONS(715),
    [anon_sym_speculative_load_hardening] = ACTIONS(715),
    [anon_sym_speculatable] = ACTIONS(715),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(715),
    [anon_sym_sspreq] = ACTIONS(715),
    [anon_sym_strictfp] = ACTIONS(715),
    [anon_sym_uwtable] = ACTIONS(715),
    [anon_sym_nocf_check] = ACTIONS(715),
    [anon_sym_shadowcallstack] = ACTIONS(715),
    [anon_sym_mustprogress] = ACTIONS(715),
    [anon_sym_vscale_range] = ACTIONS(715),
    [anon_sym_preallocated] = ACTIONS(715),
    [anon_sym_zeroext] = ACTIONS(715),
    [anon_sym_signext] = ACTIONS(715),
    [anon_sym_inreg] = ACTIONS(715),
    [anon_sym_byval] = ACTIONS(715),
    [anon_sym_byref] = ACTIONS(715),
    [anon_sym_inalloca] = ACTIONS(715),
    [anon_sym_sret] = ACTIONS(715),
    [anon_sym_elementtype] = ACTIONS(715),
    [anon_sym_noalias] = ACTIONS(715),
    [anon_sym_nocapture] = ACTIONS(715),
    [anon_sym_nest] = ACTIONS(715),
    [anon_sym_returned] = ACTIONS(715),
    [anon_sym_nonnull] = ACTIONS(715),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(715),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(715),
    [anon_sym_noundef] = ACTIONS(715),
    [anon_sym_unreachable] = ACTIONS(715),
    [anon_sym_ret] = ACTIONS(715),
    [anon_sym_br] = ACTIONS(715),
    [anon_sym_resume] = ACTIONS(715),
    [anon_sym_freeze] = ACTIONS(715),
    [anon_sym_indirectbr] = ACTIONS(715),
    [anon_sym_extractelement] = ACTIONS(715),
    [anon_sym_insertelement] = ACTIONS(715),
    [anon_sym_select] = ACTIONS(715),
    [anon_sym_shufflevector] = ACTIONS(715),
    [anon_sym_fneg] = ACTIONS(715),
    [anon_sym_switch] = ACTIONS(715),
    [anon_sym_invoke] = ACTIONS(715),
    [anon_sym_cleanupret] = ACTIONS(715),
    [anon_sym_catchret] = ACTIONS(715),
    [anon_sym_catchswitch] = ACTIONS(715),
    [anon_sym_catchpad] = ACTIONS(715),
    [anon_sym_cleanuppad] = ACTIONS(715),
    [anon_sym_callbr] = ACTIONS(715),
    [anon_sym_icmp] = ACTIONS(715),
    [anon_sym_fcmp] = ACTIONS(715),
    [anon_sym_va_arg] = ACTIONS(715),
    [anon_sym_phi] = ACTIONS(715),
    [anon_sym_landingpad] = ACTIONS(715),
    [anon_sym_tail] = ACTIONS(715),
    [anon_sym_musttail] = ACTIONS(715),
    [anon_sym_notail] = ACTIONS(715),
    [anon_sym_call] = ACTIONS(715),
    [anon_sym_alloca] = ACTIONS(715),
    [anon_sym_load] = ACTIONS(715),
    [anon_sym_store] = ACTIONS(715),
    [anon_sym_cmpxchg] = ACTIONS(715),
    [anon_sym_atomicrmw] = ACTIONS(715),
    [anon_sym_fence] = ACTIONS(715),
    [anon_sym_getelementptr] = ACTIONS(715),
    [anon_sym_extractvalue] = ACTIONS(715),
    [anon_sym_insertvalue] = ACTIONS(715),
    [anon_sym_mul] = ACTIONS(715),
    [anon_sym_urem] = ACTIONS(715),
    [anon_sym_srem] = ACTIONS(715),
    [anon_sym_shl] = ACTIONS(715),
    [anon_sym_udiv] = ACTIONS(715),
    [anon_sym_sdiv] = ACTIONS(715),
    [anon_sym_lshr] = ACTIONS(715),
    [anon_sym_ashr] = ACTIONS(715),
    [anon_sym_fmul] = ACTIONS(715),
    [anon_sym_fdiv] = ACTIONS(715),
    [anon_sym_frem] = ACTIONS(715),
    [anon_sym_xchg] = ACTIONS(715),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(715),
    [anon_sym_and] = ACTIONS(715),
    [anon_sym_nand] = ACTIONS(715),
    [anon_sym_or] = ACTIONS(715),
    [anon_sym_xor] = ACTIONS(715),
    [anon_sym_max] = ACTIONS(715),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(715),
    [anon_sym_umin] = ACTIONS(715),
    [anon_sym_fadd] = ACTIONS(715),
    [anon_sym_fsub] = ACTIONS(715),
    [anon_sym_bitcast] = ACTIONS(715),
    [anon_sym_trunc] = ACTIONS(715),
    [anon_sym_zext] = ACTIONS(715),
    [anon_sym_sext] = ACTIONS(715),
    [anon_sym_fptrunc] = ACTIONS(715),
    [anon_sym_fpext] = ACTIONS(715),
    [anon_sym_addrspacecast] = ACTIONS(715),
    [anon_sym_uitofp] = ACTIONS(715),
    [anon_sym_sitofp] = ACTIONS(715),
    [anon_sym_fptoui] = ACTIONS(715),
    [anon_sym_fptosi] = ACTIONS(715),
    [anon_sym_inttoptr] = ACTIONS(715),
    [anon_sym_ptrtoint] = ACTIONS(715),
    [anon_sym_uselistorder] = ACTIONS(715),
  },
  [182] = {
    [sym_attribute] = STATE(191),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(595),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(191),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(717),
    [sym_label] = ACTIONS(717),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(719),
    [anon_sym_ret] = ACTIONS(719),
    [anon_sym_br] = ACTIONS(719),
    [anon_sym_resume] = ACTIONS(719),
    [anon_sym_freeze] = ACTIONS(719),
    [anon_sym_indirectbr] = ACTIONS(719),
    [anon_sym_extractelement] = ACTIONS(719),
    [anon_sym_insertelement] = ACTIONS(719),
    [anon_sym_select] = ACTIONS(719),
    [anon_sym_shufflevector] = ACTIONS(719),
    [anon_sym_fneg] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(719),
    [anon_sym_invoke] = ACTIONS(719),
    [anon_sym_cleanupret] = ACTIONS(719),
    [anon_sym_catchret] = ACTIONS(719),
    [anon_sym_catchswitch] = ACTIONS(719),
    [anon_sym_catchpad] = ACTIONS(719),
    [anon_sym_cleanuppad] = ACTIONS(719),
    [anon_sym_callbr] = ACTIONS(719),
    [anon_sym_icmp] = ACTIONS(719),
    [anon_sym_fcmp] = ACTIONS(719),
    [anon_sym_va_arg] = ACTIONS(719),
    [anon_sym_phi] = ACTIONS(719),
    [anon_sym_landingpad] = ACTIONS(719),
    [anon_sym_tail] = ACTIONS(719),
    [anon_sym_musttail] = ACTIONS(719),
    [anon_sym_notail] = ACTIONS(719),
    [anon_sym_call] = ACTIONS(719),
    [anon_sym_alloca] = ACTIONS(719),
    [anon_sym_load] = ACTIONS(719),
    [anon_sym_store] = ACTIONS(719),
    [anon_sym_cmpxchg] = ACTIONS(719),
    [anon_sym_atomicrmw] = ACTIONS(719),
    [anon_sym_fence] = ACTIONS(719),
    [anon_sym_getelementptr] = ACTIONS(719),
    [anon_sym_extractvalue] = ACTIONS(719),
    [anon_sym_insertvalue] = ACTIONS(719),
    [anon_sym_mul] = ACTIONS(719),
    [anon_sym_urem] = ACTIONS(719),
    [anon_sym_srem] = ACTIONS(719),
    [anon_sym_shl] = ACTIONS(719),
    [anon_sym_udiv] = ACTIONS(719),
    [anon_sym_sdiv] = ACTIONS(719),
    [anon_sym_lshr] = ACTIONS(719),
    [anon_sym_ashr] = ACTIONS(719),
    [anon_sym_fmul] = ACTIONS(719),
    [anon_sym_fdiv] = ACTIONS(719),
    [anon_sym_frem] = ACTIONS(719),
    [anon_sym_xchg] = ACTIONS(719),
    [anon_sym_add] = ACTIONS(719),
    [anon_sym_sub] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_nand] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_xor] = ACTIONS(719),
    [anon_sym_max] = ACTIONS(719),
    [anon_sym_min] = ACTIONS(719),
    [anon_sym_umax] = ACTIONS(719),
    [anon_sym_umin] = ACTIONS(719),
    [anon_sym_fadd] = ACTIONS(719),
    [anon_sym_fsub] = ACTIONS(719),
    [anon_sym_bitcast] = ACTIONS(719),
    [anon_sym_trunc] = ACTIONS(719),
    [anon_sym_zext] = ACTIONS(719),
    [anon_sym_sext] = ACTIONS(719),
    [anon_sym_fptrunc] = ACTIONS(719),
    [anon_sym_fpext] = ACTIONS(719),
    [anon_sym_addrspacecast] = ACTIONS(719),
    [anon_sym_uitofp] = ACTIONS(719),
    [anon_sym_sitofp] = ACTIONS(719),
    [anon_sym_fptoui] = ACTIONS(719),
    [anon_sym_fptosi] = ACTIONS(719),
    [anon_sym_inttoptr] = ACTIONS(719),
    [anon_sym_ptrtoint] = ACTIONS(719),
    [anon_sym_uselistorder] = ACTIONS(719),
  },
  [183] = {
    [sym_attribute] = STATE(191),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(588),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(191),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(721),
    [sym_label] = ACTIONS(721),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(723),
    [anon_sym_ret] = ACTIONS(723),
    [anon_sym_br] = ACTIONS(723),
    [anon_sym_resume] = ACTIONS(723),
    [anon_sym_freeze] = ACTIONS(723),
    [anon_sym_indirectbr] = ACTIONS(723),
    [anon_sym_extractelement] = ACTIONS(723),
    [anon_sym_insertelement] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_shufflevector] = ACTIONS(723),
    [anon_sym_fneg] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(723),
    [anon_sym_invoke] = ACTIONS(723),
    [anon_sym_cleanupret] = ACTIONS(723),
    [anon_sym_catchret] = ACTIONS(723),
    [anon_sym_catchswitch] = ACTIONS(723),
    [anon_sym_catchpad] = ACTIONS(723),
    [anon_sym_cleanuppad] = ACTIONS(723),
    [anon_sym_callbr] = ACTIONS(723),
    [anon_sym_icmp] = ACTIONS(723),
    [anon_sym_fcmp] = ACTIONS(723),
    [anon_sym_va_arg] = ACTIONS(723),
    [anon_sym_phi] = ACTIONS(723),
    [anon_sym_landingpad] = ACTIONS(723),
    [anon_sym_tail] = ACTIONS(723),
    [anon_sym_musttail] = ACTIONS(723),
    [anon_sym_notail] = ACTIONS(723),
    [anon_sym_call] = ACTIONS(723),
    [anon_sym_alloca] = ACTIONS(723),
    [anon_sym_load] = ACTIONS(723),
    [anon_sym_store] = ACTIONS(723),
    [anon_sym_cmpxchg] = ACTIONS(723),
    [anon_sym_atomicrmw] = ACTIONS(723),
    [anon_sym_fence] = ACTIONS(723),
    [anon_sym_getelementptr] = ACTIONS(723),
    [anon_sym_extractvalue] = ACTIONS(723),
    [anon_sym_insertvalue] = ACTIONS(723),
    [anon_sym_mul] = ACTIONS(723),
    [anon_sym_urem] = ACTIONS(723),
    [anon_sym_srem] = ACTIONS(723),
    [anon_sym_shl] = ACTIONS(723),
    [anon_sym_udiv] = ACTIONS(723),
    [anon_sym_sdiv] = ACTIONS(723),
    [anon_sym_lshr] = ACTIONS(723),
    [anon_sym_ashr] = ACTIONS(723),
    [anon_sym_fmul] = ACTIONS(723),
    [anon_sym_fdiv] = ACTIONS(723),
    [anon_sym_frem] = ACTIONS(723),
    [anon_sym_xchg] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_sub] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_nand] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_xor] = ACTIONS(723),
    [anon_sym_max] = ACTIONS(723),
    [anon_sym_min] = ACTIONS(723),
    [anon_sym_umax] = ACTIONS(723),
    [anon_sym_umin] = ACTIONS(723),
    [anon_sym_fadd] = ACTIONS(723),
    [anon_sym_fsub] = ACTIONS(723),
    [anon_sym_bitcast] = ACTIONS(723),
    [anon_sym_trunc] = ACTIONS(723),
    [anon_sym_zext] = ACTIONS(723),
    [anon_sym_sext] = ACTIONS(723),
    [anon_sym_fptrunc] = ACTIONS(723),
    [anon_sym_fpext] = ACTIONS(723),
    [anon_sym_addrspacecast] = ACTIONS(723),
    [anon_sym_uitofp] = ACTIONS(723),
    [anon_sym_sitofp] = ACTIONS(723),
    [anon_sym_fptoui] = ACTIONS(723),
    [anon_sym_fptosi] = ACTIONS(723),
    [anon_sym_inttoptr] = ACTIONS(723),
    [anon_sym_ptrtoint] = ACTIONS(723),
    [anon_sym_uselistorder] = ACTIONS(723),
  },
  [184] = {
    [sym_attribute] = STATE(180),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(620),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(180),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(725),
    [sym_label] = ACTIONS(725),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(727),
    [anon_sym_ret] = ACTIONS(727),
    [anon_sym_br] = ACTIONS(727),
    [anon_sym_resume] = ACTIONS(727),
    [anon_sym_freeze] = ACTIONS(727),
    [anon_sym_indirectbr] = ACTIONS(727),
    [anon_sym_extractelement] = ACTIONS(727),
    [anon_sym_insertelement] = ACTIONS(727),
    [anon_sym_select] = ACTIONS(727),
    [anon_sym_shufflevector] = ACTIONS(727),
    [anon_sym_fneg] = ACTIONS(727),
    [anon_sym_switch] = ACTIONS(727),
    [anon_sym_invoke] = ACTIONS(727),
    [anon_sym_cleanupret] = ACTIONS(727),
    [anon_sym_catchret] = ACTIONS(727),
    [anon_sym_catchswitch] = ACTIONS(727),
    [anon_sym_catchpad] = ACTIONS(727),
    [anon_sym_cleanuppad] = ACTIONS(727),
    [anon_sym_callbr] = ACTIONS(727),
    [anon_sym_icmp] = ACTIONS(727),
    [anon_sym_fcmp] = ACTIONS(727),
    [anon_sym_va_arg] = ACTIONS(727),
    [anon_sym_phi] = ACTIONS(727),
    [anon_sym_landingpad] = ACTIONS(727),
    [anon_sym_tail] = ACTIONS(727),
    [anon_sym_musttail] = ACTIONS(727),
    [anon_sym_notail] = ACTIONS(727),
    [anon_sym_call] = ACTIONS(727),
    [anon_sym_alloca] = ACTIONS(727),
    [anon_sym_load] = ACTIONS(727),
    [anon_sym_store] = ACTIONS(727),
    [anon_sym_cmpxchg] = ACTIONS(727),
    [anon_sym_atomicrmw] = ACTIONS(727),
    [anon_sym_fence] = ACTIONS(727),
    [anon_sym_getelementptr] = ACTIONS(727),
    [anon_sym_extractvalue] = ACTIONS(727),
    [anon_sym_insertvalue] = ACTIONS(727),
    [anon_sym_mul] = ACTIONS(727),
    [anon_sym_urem] = ACTIONS(727),
    [anon_sym_srem] = ACTIONS(727),
    [anon_sym_shl] = ACTIONS(727),
    [anon_sym_udiv] = ACTIONS(727),
    [anon_sym_sdiv] = ACTIONS(727),
    [anon_sym_lshr] = ACTIONS(727),
    [anon_sym_ashr] = ACTIONS(727),
    [anon_sym_fmul] = ACTIONS(727),
    [anon_sym_fdiv] = ACTIONS(727),
    [anon_sym_frem] = ACTIONS(727),
    [anon_sym_xchg] = ACTIONS(727),
    [anon_sym_add] = ACTIONS(727),
    [anon_sym_sub] = ACTIONS(727),
    [anon_sym_and] = ACTIONS(727),
    [anon_sym_nand] = ACTIONS(727),
    [anon_sym_or] = ACTIONS(727),
    [anon_sym_xor] = ACTIONS(727),
    [anon_sym_max] = ACTIONS(727),
    [anon_sym_min] = ACTIONS(727),
    [anon_sym_umax] = ACTIONS(727),
    [anon_sym_umin] = ACTIONS(727),
    [anon_sym_fadd] = ACTIONS(727),
    [anon_sym_fsub] = ACTIONS(727),
    [anon_sym_bitcast] = ACTIONS(727),
    [anon_sym_trunc] = ACTIONS(727),
    [anon_sym_zext] = ACTIONS(727),
    [anon_sym_sext] = ACTIONS(727),
    [anon_sym_fptrunc] = ACTIONS(727),
    [anon_sym_fpext] = ACTIONS(727),
    [anon_sym_addrspacecast] = ACTIONS(727),
    [anon_sym_uitofp] = ACTIONS(727),
    [anon_sym_sitofp] = ACTIONS(727),
    [anon_sym_fptoui] = ACTIONS(727),
    [anon_sym_fptosi] = ACTIONS(727),
    [anon_sym_inttoptr] = ACTIONS(727),
    [anon_sym_ptrtoint] = ACTIONS(727),
    [anon_sym_uselistorder] = ACTIONS(727),
  },
  [185] = {
    [sym_attribute] = STATE(183),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(585),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(183),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(729),
    [sym_label] = ACTIONS(729),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(731),
    [anon_sym_ret] = ACTIONS(731),
    [anon_sym_br] = ACTIONS(731),
    [anon_sym_resume] = ACTIONS(731),
    [anon_sym_freeze] = ACTIONS(731),
    [anon_sym_indirectbr] = ACTIONS(731),
    [anon_sym_extractelement] = ACTIONS(731),
    [anon_sym_insertelement] = ACTIONS(731),
    [anon_sym_select] = ACTIONS(731),
    [anon_sym_shufflevector] = ACTIONS(731),
    [anon_sym_fneg] = ACTIONS(731),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_invoke] = ACTIONS(731),
    [anon_sym_cleanupret] = ACTIONS(731),
    [anon_sym_catchret] = ACTIONS(731),
    [anon_sym_catchswitch] = ACTIONS(731),
    [anon_sym_catchpad] = ACTIONS(731),
    [anon_sym_cleanuppad] = ACTIONS(731),
    [anon_sym_callbr] = ACTIONS(731),
    [anon_sym_icmp] = ACTIONS(731),
    [anon_sym_fcmp] = ACTIONS(731),
    [anon_sym_va_arg] = ACTIONS(731),
    [anon_sym_phi] = ACTIONS(731),
    [anon_sym_landingpad] = ACTIONS(731),
    [anon_sym_tail] = ACTIONS(731),
    [anon_sym_musttail] = ACTIONS(731),
    [anon_sym_notail] = ACTIONS(731),
    [anon_sym_call] = ACTIONS(731),
    [anon_sym_alloca] = ACTIONS(731),
    [anon_sym_load] = ACTIONS(731),
    [anon_sym_store] = ACTIONS(731),
    [anon_sym_cmpxchg] = ACTIONS(731),
    [anon_sym_atomicrmw] = ACTIONS(731),
    [anon_sym_fence] = ACTIONS(731),
    [anon_sym_getelementptr] = ACTIONS(731),
    [anon_sym_extractvalue] = ACTIONS(731),
    [anon_sym_insertvalue] = ACTIONS(731),
    [anon_sym_mul] = ACTIONS(731),
    [anon_sym_urem] = ACTIONS(731),
    [anon_sym_srem] = ACTIONS(731),
    [anon_sym_shl] = ACTIONS(731),
    [anon_sym_udiv] = ACTIONS(731),
    [anon_sym_sdiv] = ACTIONS(731),
    [anon_sym_lshr] = ACTIONS(731),
    [anon_sym_ashr] = ACTIONS(731),
    [anon_sym_fmul] = ACTIONS(731),
    [anon_sym_fdiv] = ACTIONS(731),
    [anon_sym_frem] = ACTIONS(731),
    [anon_sym_xchg] = ACTIONS(731),
    [anon_sym_add] = ACTIONS(731),
    [anon_sym_sub] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_nand] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_xor] = ACTIONS(731),
    [anon_sym_max] = ACTIONS(731),
    [anon_sym_min] = ACTIONS(731),
    [anon_sym_umax] = ACTIONS(731),
    [anon_sym_umin] = ACTIONS(731),
    [anon_sym_fadd] = ACTIONS(731),
    [anon_sym_fsub] = ACTIONS(731),
    [anon_sym_bitcast] = ACTIONS(731),
    [anon_sym_trunc] = ACTIONS(731),
    [anon_sym_zext] = ACTIONS(731),
    [anon_sym_sext] = ACTIONS(731),
    [anon_sym_fptrunc] = ACTIONS(731),
    [anon_sym_fpext] = ACTIONS(731),
    [anon_sym_addrspacecast] = ACTIONS(731),
    [anon_sym_uitofp] = ACTIONS(731),
    [anon_sym_sitofp] = ACTIONS(731),
    [anon_sym_fptoui] = ACTIONS(731),
    [anon_sym_fptosi] = ACTIONS(731),
    [anon_sym_inttoptr] = ACTIONS(731),
    [anon_sym_ptrtoint] = ACTIONS(731),
    [anon_sym_uselistorder] = ACTIONS(731),
  },
  [186] = {
    [sym_attribute] = STATE(182),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(628),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(182),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(733),
    [sym_label] = ACTIONS(733),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(735),
    [anon_sym_ret] = ACTIONS(735),
    [anon_sym_br] = ACTIONS(735),
    [anon_sym_resume] = ACTIONS(735),
    [anon_sym_freeze] = ACTIONS(735),
    [anon_sym_indirectbr] = ACTIONS(735),
    [anon_sym_extractelement] = ACTIONS(735),
    [anon_sym_insertelement] = ACTIONS(735),
    [anon_sym_select] = ACTIONS(735),
    [anon_sym_shufflevector] = ACTIONS(735),
    [anon_sym_fneg] = ACTIONS(735),
    [anon_sym_switch] = ACTIONS(735),
    [anon_sym_invoke] = ACTIONS(735),
    [anon_sym_cleanupret] = ACTIONS(735),
    [anon_sym_catchret] = ACTIONS(735),
    [anon_sym_catchswitch] = ACTIONS(735),
    [anon_sym_catchpad] = ACTIONS(735),
    [anon_sym_cleanuppad] = ACTIONS(735),
    [anon_sym_callbr] = ACTIONS(735),
    [anon_sym_icmp] = ACTIONS(735),
    [anon_sym_fcmp] = ACTIONS(735),
    [anon_sym_va_arg] = ACTIONS(735),
    [anon_sym_phi] = ACTIONS(735),
    [anon_sym_landingpad] = ACTIONS(735),
    [anon_sym_tail] = ACTIONS(735),
    [anon_sym_musttail] = ACTIONS(735),
    [anon_sym_notail] = ACTIONS(735),
    [anon_sym_call] = ACTIONS(735),
    [anon_sym_alloca] = ACTIONS(735),
    [anon_sym_load] = ACTIONS(735),
    [anon_sym_store] = ACTIONS(735),
    [anon_sym_cmpxchg] = ACTIONS(735),
    [anon_sym_atomicrmw] = ACTIONS(735),
    [anon_sym_fence] = ACTIONS(735),
    [anon_sym_getelementptr] = ACTIONS(735),
    [anon_sym_extractvalue] = ACTIONS(735),
    [anon_sym_insertvalue] = ACTIONS(735),
    [anon_sym_mul] = ACTIONS(735),
    [anon_sym_urem] = ACTIONS(735),
    [anon_sym_srem] = ACTIONS(735),
    [anon_sym_shl] = ACTIONS(735),
    [anon_sym_udiv] = ACTIONS(735),
    [anon_sym_sdiv] = ACTIONS(735),
    [anon_sym_lshr] = ACTIONS(735),
    [anon_sym_ashr] = ACTIONS(735),
    [anon_sym_fmul] = ACTIONS(735),
    [anon_sym_fdiv] = ACTIONS(735),
    [anon_sym_frem] = ACTIONS(735),
    [anon_sym_xchg] = ACTIONS(735),
    [anon_sym_add] = ACTIONS(735),
    [anon_sym_sub] = ACTIONS(735),
    [anon_sym_and] = ACTIONS(735),
    [anon_sym_nand] = ACTIONS(735),
    [anon_sym_or] = ACTIONS(735),
    [anon_sym_xor] = ACTIONS(735),
    [anon_sym_max] = ACTIONS(735),
    [anon_sym_min] = ACTIONS(735),
    [anon_sym_umax] = ACTIONS(735),
    [anon_sym_umin] = ACTIONS(735),
    [anon_sym_fadd] = ACTIONS(735),
    [anon_sym_fsub] = ACTIONS(735),
    [anon_sym_bitcast] = ACTIONS(735),
    [anon_sym_trunc] = ACTIONS(735),
    [anon_sym_zext] = ACTIONS(735),
    [anon_sym_sext] = ACTIONS(735),
    [anon_sym_fptrunc] = ACTIONS(735),
    [anon_sym_fpext] = ACTIONS(735),
    [anon_sym_addrspacecast] = ACTIONS(735),
    [anon_sym_uitofp] = ACTIONS(735),
    [anon_sym_sitofp] = ACTIONS(735),
    [anon_sym_fptoui] = ACTIONS(735),
    [anon_sym_fptosi] = ACTIONS(735),
    [anon_sym_inttoptr] = ACTIONS(735),
    [anon_sym_ptrtoint] = ACTIONS(735),
    [anon_sym_uselistorder] = ACTIONS(735),
  },
  [187] = {
    [sym_metadata_name] = STATE(708),
    [sym_metadata_attachment] = STATE(217),
    [sym_function_header] = STATE(1080),
    [sym_linkage] = STATE(202),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_calling_conv] = STATE(372),
    [sym_unnamed_addr] = STATE(997),
    [sym_type] = STATE(1784),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(370),
    [sym_attribute_name] = STATE(389),
    [aux_sym_declare_repeat1] = STATE(217),
    [aux_sym_function_header_repeat1] = STATE(202),
    [aux_sym_function_header_repeat2] = STATE(370),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [aux_sym_metadata_ref_token1] = ACTIONS(739),
    [sym_string] = ACTIONS(741),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [188] = {
    [sym_metadata_name] = STATE(708),
    [sym_metadata_attachment] = STATE(187),
    [sym_function_header] = STATE(1076),
    [sym_linkage] = STATE(202),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_calling_conv] = STATE(372),
    [sym_unnamed_addr] = STATE(997),
    [sym_type] = STATE(1784),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(370),
    [sym_attribute_name] = STATE(389),
    [aux_sym_declare_repeat1] = STATE(187),
    [aux_sym_function_header_repeat1] = STATE(202),
    [aux_sym_function_header_repeat2] = STATE(370),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [aux_sym_metadata_ref_token1] = ACTIONS(739),
    [sym_string] = ACTIONS(741),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [189] = {
    [sym_attribute] = STATE(190),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(645),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(190),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(749),
    [sym_label] = ACTIONS(749),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(751),
    [anon_sym_ret] = ACTIONS(751),
    [anon_sym_br] = ACTIONS(751),
    [anon_sym_resume] = ACTIONS(751),
    [anon_sym_freeze] = ACTIONS(751),
    [anon_sym_indirectbr] = ACTIONS(751),
    [anon_sym_extractelement] = ACTIONS(751),
    [anon_sym_insertelement] = ACTIONS(751),
    [anon_sym_select] = ACTIONS(751),
    [anon_sym_shufflevector] = ACTIONS(751),
    [anon_sym_fneg] = ACTIONS(751),
    [anon_sym_switch] = ACTIONS(751),
    [anon_sym_invoke] = ACTIONS(751),
    [anon_sym_cleanupret] = ACTIONS(751),
    [anon_sym_catchret] = ACTIONS(751),
    [anon_sym_catchswitch] = ACTIONS(751),
    [anon_sym_catchpad] = ACTIONS(751),
    [anon_sym_cleanuppad] = ACTIONS(751),
    [anon_sym_callbr] = ACTIONS(751),
    [anon_sym_icmp] = ACTIONS(751),
    [anon_sym_fcmp] = ACTIONS(751),
    [anon_sym_va_arg] = ACTIONS(751),
    [anon_sym_phi] = ACTIONS(751),
    [anon_sym_landingpad] = ACTIONS(751),
    [anon_sym_tail] = ACTIONS(751),
    [anon_sym_musttail] = ACTIONS(751),
    [anon_sym_notail] = ACTIONS(751),
    [anon_sym_call] = ACTIONS(751),
    [anon_sym_alloca] = ACTIONS(751),
    [anon_sym_load] = ACTIONS(751),
    [anon_sym_store] = ACTIONS(751),
    [anon_sym_cmpxchg] = ACTIONS(751),
    [anon_sym_atomicrmw] = ACTIONS(751),
    [anon_sym_fence] = ACTIONS(751),
    [anon_sym_getelementptr] = ACTIONS(751),
    [anon_sym_extractvalue] = ACTIONS(751),
    [anon_sym_insertvalue] = ACTIONS(751),
    [anon_sym_mul] = ACTIONS(751),
    [anon_sym_urem] = ACTIONS(751),
    [anon_sym_srem] = ACTIONS(751),
    [anon_sym_shl] = ACTIONS(751),
    [anon_sym_udiv] = ACTIONS(751),
    [anon_sym_sdiv] = ACTIONS(751),
    [anon_sym_lshr] = ACTIONS(751),
    [anon_sym_ashr] = ACTIONS(751),
    [anon_sym_fmul] = ACTIONS(751),
    [anon_sym_fdiv] = ACTIONS(751),
    [anon_sym_frem] = ACTIONS(751),
    [anon_sym_xchg] = ACTIONS(751),
    [anon_sym_add] = ACTIONS(751),
    [anon_sym_sub] = ACTIONS(751),
    [anon_sym_and] = ACTIONS(751),
    [anon_sym_nand] = ACTIONS(751),
    [anon_sym_or] = ACTIONS(751),
    [anon_sym_xor] = ACTIONS(751),
    [anon_sym_max] = ACTIONS(751),
    [anon_sym_min] = ACTIONS(751),
    [anon_sym_umax] = ACTIONS(751),
    [anon_sym_umin] = ACTIONS(751),
    [anon_sym_fadd] = ACTIONS(751),
    [anon_sym_fsub] = ACTIONS(751),
    [anon_sym_bitcast] = ACTIONS(751),
    [anon_sym_trunc] = ACTIONS(751),
    [anon_sym_zext] = ACTIONS(751),
    [anon_sym_sext] = ACTIONS(751),
    [anon_sym_fptrunc] = ACTIONS(751),
    [anon_sym_fpext] = ACTIONS(751),
    [anon_sym_addrspacecast] = ACTIONS(751),
    [anon_sym_uitofp] = ACTIONS(751),
    [anon_sym_sitofp] = ACTIONS(751),
    [anon_sym_fptoui] = ACTIONS(751),
    [anon_sym_fptosi] = ACTIONS(751),
    [anon_sym_inttoptr] = ACTIONS(751),
    [anon_sym_ptrtoint] = ACTIONS(751),
    [anon_sym_uselistorder] = ACTIONS(751),
  },
  [190] = {
    [sym_attribute] = STATE(191),
    [sym_attribute_name] = STATE(193),
    [sym_operand_bundles] = STATE(616),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(191),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(753),
    [sym_label] = ACTIONS(753),
    [sym_string] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_align] = ACTIONS(701),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(709),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(709),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_unreachable] = ACTIONS(755),
    [anon_sym_ret] = ACTIONS(755),
    [anon_sym_br] = ACTIONS(755),
    [anon_sym_resume] = ACTIONS(755),
    [anon_sym_freeze] = ACTIONS(755),
    [anon_sym_indirectbr] = ACTIONS(755),
    [anon_sym_extractelement] = ACTIONS(755),
    [anon_sym_insertelement] = ACTIONS(755),
    [anon_sym_select] = ACTIONS(755),
    [anon_sym_shufflevector] = ACTIONS(755),
    [anon_sym_fneg] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(755),
    [anon_sym_invoke] = ACTIONS(755),
    [anon_sym_cleanupret] = ACTIONS(755),
    [anon_sym_catchret] = ACTIONS(755),
    [anon_sym_catchswitch] = ACTIONS(755),
    [anon_sym_catchpad] = ACTIONS(755),
    [anon_sym_cleanuppad] = ACTIONS(755),
    [anon_sym_callbr] = ACTIONS(755),
    [anon_sym_icmp] = ACTIONS(755),
    [anon_sym_fcmp] = ACTIONS(755),
    [anon_sym_va_arg] = ACTIONS(755),
    [anon_sym_phi] = ACTIONS(755),
    [anon_sym_landingpad] = ACTIONS(755),
    [anon_sym_tail] = ACTIONS(755),
    [anon_sym_musttail] = ACTIONS(755),
    [anon_sym_notail] = ACTIONS(755),
    [anon_sym_call] = ACTIONS(755),
    [anon_sym_alloca] = ACTIONS(755),
    [anon_sym_load] = ACTIONS(755),
    [anon_sym_store] = ACTIONS(755),
    [anon_sym_cmpxchg] = ACTIONS(755),
    [anon_sym_atomicrmw] = ACTIONS(755),
    [anon_sym_fence] = ACTIONS(755),
    [anon_sym_getelementptr] = ACTIONS(755),
    [anon_sym_extractvalue] = ACTIONS(755),
    [anon_sym_insertvalue] = ACTIONS(755),
    [anon_sym_mul] = ACTIONS(755),
    [anon_sym_urem] = ACTIONS(755),
    [anon_sym_srem] = ACTIONS(755),
    [anon_sym_shl] = ACTIONS(755),
    [anon_sym_udiv] = ACTIONS(755),
    [anon_sym_sdiv] = ACTIONS(755),
    [anon_sym_lshr] = ACTIONS(755),
    [anon_sym_ashr] = ACTIONS(755),
    [anon_sym_fmul] = ACTIONS(755),
    [anon_sym_fdiv] = ACTIONS(755),
    [anon_sym_frem] = ACTIONS(755),
    [anon_sym_xchg] = ACTIONS(755),
    [anon_sym_add] = ACTIONS(755),
    [anon_sym_sub] = ACTIONS(755),
    [anon_sym_and] = ACTIONS(755),
    [anon_sym_nand] = ACTIONS(755),
    [anon_sym_or] = ACTIONS(755),
    [anon_sym_xor] = ACTIONS(755),
    [anon_sym_max] = ACTIONS(755),
    [anon_sym_min] = ACTIONS(755),
    [anon_sym_umax] = ACTIONS(755),
    [anon_sym_umin] = ACTIONS(755),
    [anon_sym_fadd] = ACTIONS(755),
    [anon_sym_fsub] = ACTIONS(755),
    [anon_sym_bitcast] = ACTIONS(755),
    [anon_sym_trunc] = ACTIONS(755),
    [anon_sym_zext] = ACTIONS(755),
    [anon_sym_sext] = ACTIONS(755),
    [anon_sym_fptrunc] = ACTIONS(755),
    [anon_sym_fpext] = ACTIONS(755),
    [anon_sym_addrspacecast] = ACTIONS(755),
    [anon_sym_uitofp] = ACTIONS(755),
    [anon_sym_sitofp] = ACTIONS(755),
    [anon_sym_fptoui] = ACTIONS(755),
    [anon_sym_fptosi] = ACTIONS(755),
    [anon_sym_inttoptr] = ACTIONS(755),
    [anon_sym_ptrtoint] = ACTIONS(755),
    [anon_sym_uselistorder] = ACTIONS(755),
  },
  [191] = {
    [sym_attribute] = STATE(191),
    [sym_attribute_name] = STATE(193),
    [sym_alignment] = STATE(200),
    [aux_sym_function_header_repeat3] = STATE(191),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(757),
    [sym_local_var] = ACTIONS(760),
    [sym_label] = ACTIONS(760),
    [sym_string] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_COMMA] = ACTIONS(760),
    [anon_sym_align] = ACTIONS(765),
    [anon_sym_section] = ACTIONS(768),
    [anon_sym_partition] = ACTIONS(768),
    [anon_sym_comdat] = ACTIONS(771),
    [anon_sym_gc] = ACTIONS(768),
    [anon_sym_prefix] = ACTIONS(774),
    [anon_sym_prologue] = ACTIONS(774),
    [anon_sym_personality] = ACTIONS(774),
    [anon_sym_alignstack] = ACTIONS(777),
    [anon_sym_allocsize] = ACTIONS(777),
    [anon_sym_alwaysinline] = ACTIONS(777),
    [anon_sym_builtin] = ACTIONS(777),
    [anon_sym_cold] = ACTIONS(777),
    [anon_sym_convergent] = ACTIONS(777),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(777),
    [anon_sym_hot] = ACTIONS(777),
    [anon_sym_inaccessiblememonly] = ACTIONS(777),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(777),
    [anon_sym_inlinehint] = ACTIONS(777),
    [anon_sym_jumptable] = ACTIONS(777),
    [anon_sym_minsize] = ACTIONS(777),
    [anon_sym_naked] = ACTIONS(777),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(777),
    [anon_sym_nobuiltin] = ACTIONS(777),
    [anon_sym_noduplicate] = ACTIONS(777),
    [anon_sym_nofree] = ACTIONS(777),
    [anon_sym_noimplicitfloat] = ACTIONS(777),
    [anon_sym_noinline] = ACTIONS(777),
    [anon_sym_nomerge] = ACTIONS(777),
    [anon_sym_nonlazybind] = ACTIONS(777),
    [anon_sym_noprofile] = ACTIONS(777),
    [anon_sym_noredzone] = ACTIONS(777),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(777),
    [anon_sym_noreturn] = ACTIONS(777),
    [anon_sym_norecurse] = ACTIONS(777),
    [anon_sym_willreturn] = ACTIONS(777),
    [anon_sym_nosync] = ACTIONS(777),
    [anon_sym_nounwind] = ACTIONS(777),
    [anon_sym_nosanitize_coverage] = ACTIONS(777),
    [anon_sym_null_pointer_is_valid] = ACTIONS(777),
    [anon_sym_optforfuzzing] = ACTIONS(777),
    [anon_sym_optnone] = ACTIONS(777),
    [anon_sym_optsize] = ACTIONS(777),
    [anon_sym_readnone] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_writeonly] = ACTIONS(777),
    [anon_sym_argmemonly] = ACTIONS(777),
    [anon_sym_returns_twice] = ACTIONS(777),
    [anon_sym_safestack] = ACTIONS(777),
    [anon_sym_sanitize_address] = ACTIONS(777),
    [anon_sym_sanitize_memory] = ACTIONS(777),
    [anon_sym_sanitize_thread] = ACTIONS(777),
    [anon_sym_sanitize_hwaddress] = ACTIONS(777),
    [anon_sym_sanitize_memtag] = ACTIONS(777),
    [anon_sym_speculative_load_hardening] = ACTIONS(777),
    [anon_sym_speculatable] = ACTIONS(777),
    [anon_sym_ssp] = ACTIONS(777),
    [anon_sym_sspstrong] = ACTIONS(777),
    [anon_sym_sspreq] = ACTIONS(777),
    [anon_sym_strictfp] = ACTIONS(777),
    [anon_sym_uwtable] = ACTIONS(777),
    [anon_sym_nocf_check] = ACTIONS(777),
    [anon_sym_shadowcallstack] = ACTIONS(777),
    [anon_sym_mustprogress] = ACTIONS(777),
    [anon_sym_vscale_range] = ACTIONS(777),
    [anon_sym_preallocated] = ACTIONS(777),
    [anon_sym_zeroext] = ACTIONS(777),
    [anon_sym_signext] = ACTIONS(777),
    [anon_sym_inreg] = ACTIONS(777),
    [anon_sym_byval] = ACTIONS(777),
    [anon_sym_byref] = ACTIONS(777),
    [anon_sym_inalloca] = ACTIONS(777),
    [anon_sym_sret] = ACTIONS(777),
    [anon_sym_elementtype] = ACTIONS(777),
    [anon_sym_noalias] = ACTIONS(777),
    [anon_sym_nocapture] = ACTIONS(777),
    [anon_sym_nest] = ACTIONS(777),
    [anon_sym_returned] = ACTIONS(777),
    [anon_sym_nonnull] = ACTIONS(777),
    [anon_sym_dereferenceable] = ACTIONS(777),
    [anon_sym_dereferenceable_or_null] = ACTIONS(777),
    [anon_sym_swiftself] = ACTIONS(777),
    [anon_sym_swiftasync] = ACTIONS(777),
    [anon_sym_swifterror] = ACTIONS(777),
    [anon_sym_immarg] = ACTIONS(777),
    [anon_sym_noundef] = ACTIONS(777),
    [anon_sym_unreachable] = ACTIONS(780),
    [anon_sym_ret] = ACTIONS(780),
    [anon_sym_br] = ACTIONS(780),
    [anon_sym_resume] = ACTIONS(780),
    [anon_sym_freeze] = ACTIONS(780),
    [anon_sym_indirectbr] = ACTIONS(780),
    [anon_sym_extractelement] = ACTIONS(780),
    [anon_sym_insertelement] = ACTIONS(780),
    [anon_sym_select] = ACTIONS(780),
    [anon_sym_shufflevector] = ACTIONS(780),
    [anon_sym_fneg] = ACTIONS(780),
    [anon_sym_switch] = ACTIONS(780),
    [anon_sym_invoke] = ACTIONS(780),
    [anon_sym_cleanupret] = ACTIONS(780),
    [anon_sym_catchret] = ACTIONS(780),
    [anon_sym_catchswitch] = ACTIONS(780),
    [anon_sym_catchpad] = ACTIONS(780),
    [anon_sym_cleanuppad] = ACTIONS(780),
    [anon_sym_callbr] = ACTIONS(780),
    [anon_sym_icmp] = ACTIONS(780),
    [anon_sym_fcmp] = ACTIONS(780),
    [anon_sym_va_arg] = ACTIONS(780),
    [anon_sym_phi] = ACTIONS(780),
    [anon_sym_landingpad] = ACTIONS(780),
    [anon_sym_tail] = ACTIONS(780),
    [anon_sym_musttail] = ACTIONS(780),
    [anon_sym_notail] = ACTIONS(780),
    [anon_sym_call] = ACTIONS(780),
    [anon_sym_alloca] = ACTIONS(780),
    [anon_sym_load] = ACTIONS(780),
    [anon_sym_store] = ACTIONS(780),
    [anon_sym_cmpxchg] = ACTIONS(780),
    [anon_sym_atomicrmw] = ACTIONS(780),
    [anon_sym_fence] = ACTIONS(780),
    [anon_sym_getelementptr] = ACTIONS(780),
    [anon_sym_extractvalue] = ACTIONS(780),
    [anon_sym_insertvalue] = ACTIONS(780),
    [anon_sym_mul] = ACTIONS(780),
    [anon_sym_urem] = ACTIONS(780),
    [anon_sym_srem] = ACTIONS(780),
    [anon_sym_shl] = ACTIONS(780),
    [anon_sym_udiv] = ACTIONS(780),
    [anon_sym_sdiv] = ACTIONS(780),
    [anon_sym_lshr] = ACTIONS(780),
    [anon_sym_ashr] = ACTIONS(780),
    [anon_sym_fmul] = ACTIONS(780),
    [anon_sym_fdiv] = ACTIONS(780),
    [anon_sym_frem] = ACTIONS(780),
    [anon_sym_xchg] = ACTIONS(780),
    [anon_sym_add] = ACTIONS(780),
    [anon_sym_sub] = ACTIONS(780),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_nand] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_xor] = ACTIONS(780),
    [anon_sym_max] = ACTIONS(780),
    [anon_sym_min] = ACTIONS(780),
    [anon_sym_umax] = ACTIONS(780),
    [anon_sym_umin] = ACTIONS(780),
    [anon_sym_fadd] = ACTIONS(780),
    [anon_sym_fsub] = ACTIONS(780),
    [anon_sym_bitcast] = ACTIONS(780),
    [anon_sym_trunc] = ACTIONS(780),
    [anon_sym_zext] = ACTIONS(780),
    [anon_sym_sext] = ACTIONS(780),
    [anon_sym_fptrunc] = ACTIONS(780),
    [anon_sym_fpext] = ACTIONS(780),
    [anon_sym_addrspacecast] = ACTIONS(780),
    [anon_sym_uitofp] = ACTIONS(780),
    [anon_sym_sitofp] = ACTIONS(780),
    [anon_sym_fptoui] = ACTIONS(780),
    [anon_sym_fptosi] = ACTIONS(780),
    [anon_sym_inttoptr] = ACTIONS(780),
    [anon_sym_ptrtoint] = ACTIONS(780),
    [anon_sym_uselistorder] = ACTIONS(780),
  },
  [192] = {
    [sym_param_or_return_attrs] = STATE(192),
    [sym_attribute_name] = STATE(209),
    [aux_sym_function_header_repeat2] = STATE(192),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(782),
    [sym_local_var] = ACTIONS(782),
    [sym_string] = ACTIONS(782),
    [aux_sym_number_token1] = ACTIONS(784),
    [aux_sym_number_token2] = ACTIONS(782),
    [sym_float] = ACTIONS(782),
    [sym_cstring] = ACTIONS(782),
    [anon_sym_no_cfi] = ACTIONS(782),
    [anon_sym_private] = ACTIONS(782),
    [anon_sym_internal] = ACTIONS(782),
    [anon_sym_weak] = ACTIONS(784),
    [anon_sym_weak_odr] = ACTIONS(782),
    [anon_sym_linkonce] = ACTIONS(784),
    [anon_sym_linkonce_odr] = ACTIONS(782),
    [anon_sym_available_externally] = ACTIONS(782),
    [anon_sym_appending] = ACTIONS(782),
    [anon_sym_common] = ACTIONS(782),
    [anon_sym_extern_weak] = ACTIONS(782),
    [anon_sym_external] = ACTIONS(782),
    [anon_sym_dso_local] = ACTIONS(784),
    [anon_sym_dso_local_equivalent] = ACTIONS(782),
    [anon_sym_dso_preemptable] = ACTIONS(782),
    [anon_sym_default] = ACTIONS(782),
    [anon_sym_hidden] = ACTIONS(782),
    [anon_sym_protected] = ACTIONS(782),
    [anon_sym_dllimport] = ACTIONS(782),
    [anon_sym_dllexport] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_LT_LBRACE] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_RPAREN] = ACTIONS(782),
    [anon_sym_align] = ACTIONS(786),
    [anon_sym_alignstack] = ACTIONS(789),
    [anon_sym_allocsize] = ACTIONS(789),
    [anon_sym_alwaysinline] = ACTIONS(789),
    [anon_sym_builtin] = ACTIONS(789),
    [anon_sym_cold] = ACTIONS(789),
    [anon_sym_convergent] = ACTIONS(789),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(789),
    [anon_sym_hot] = ACTIONS(789),
    [anon_sym_inaccessiblememonly] = ACTIONS(789),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(789),
    [anon_sym_inlinehint] = ACTIONS(789),
    [anon_sym_jumptable] = ACTIONS(789),
    [anon_sym_minsize] = ACTIONS(789),
    [anon_sym_naked] = ACTIONS(789),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(789),
    [anon_sym_nobuiltin] = ACTIONS(789),
    [anon_sym_noduplicate] = ACTIONS(789),
    [anon_sym_nofree] = ACTIONS(789),
    [anon_sym_noimplicitfloat] = ACTIONS(789),
    [anon_sym_noinline] = ACTIONS(789),
    [anon_sym_nomerge] = ACTIONS(789),
    [anon_sym_nonlazybind] = ACTIONS(789),
    [anon_sym_noprofile] = ACTIONS(789),
    [anon_sym_noredzone] = ACTIONS(789),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(789),
    [anon_sym_noreturn] = ACTIONS(789),
    [anon_sym_norecurse] = ACTIONS(789),
    [anon_sym_willreturn] = ACTIONS(789),
    [anon_sym_nosync] = ACTIONS(789),
    [anon_sym_nounwind] = ACTIONS(789),
    [anon_sym_nosanitize_coverage] = ACTIONS(789),
    [anon_sym_null_pointer_is_valid] = ACTIONS(789),
    [anon_sym_optforfuzzing] = ACTIONS(789),
    [anon_sym_optnone] = ACTIONS(789),
    [anon_sym_optsize] = ACTIONS(789),
    [anon_sym_readnone] = ACTIONS(789),
    [anon_sym_readonly] = ACTIONS(789),
    [anon_sym_writeonly] = ACTIONS(789),
    [anon_sym_argmemonly] = ACTIONS(789),
    [anon_sym_returns_twice] = ACTIONS(789),
    [anon_sym_safestack] = ACTIONS(789),
    [anon_sym_sanitize_address] = ACTIONS(789),
    [anon_sym_sanitize_memory] = ACTIONS(789),
    [anon_sym_sanitize_thread] = ACTIONS(789),
    [anon_sym_sanitize_hwaddress] = ACTIONS(789),
    [anon_sym_sanitize_memtag] = ACTIONS(789),
    [anon_sym_speculative_load_hardening] = ACTIONS(789),
    [anon_sym_speculatable] = ACTIONS(789),
    [anon_sym_ssp] = ACTIONS(792),
    [anon_sym_sspstrong] = ACTIONS(789),
    [anon_sym_sspreq] = ACTIONS(789),
    [anon_sym_strictfp] = ACTIONS(789),
    [anon_sym_uwtable] = ACTIONS(789),
    [anon_sym_nocf_check] = ACTIONS(789),
    [anon_sym_shadowcallstack] = ACTIONS(789),
    [anon_sym_mustprogress] = ACTIONS(789),
    [anon_sym_vscale_range] = ACTIONS(789),
    [anon_sym_preallocated] = ACTIONS(789),
    [anon_sym_zeroext] = ACTIONS(789),
    [anon_sym_signext] = ACTIONS(789),
    [anon_sym_inreg] = ACTIONS(789),
    [anon_sym_byval] = ACTIONS(789),
    [anon_sym_byref] = ACTIONS(789),
    [anon_sym_inalloca] = ACTIONS(789),
    [anon_sym_sret] = ACTIONS(789),
    [anon_sym_elementtype] = ACTIONS(789),
    [anon_sym_noalias] = ACTIONS(789),
    [anon_sym_nocapture] = ACTIONS(789),
    [anon_sym_nest] = ACTIONS(789),
    [anon_sym_returned] = ACTIONS(789),
    [anon_sym_nonnull] = ACTIONS(789),
    [anon_sym_dereferenceable] = ACTIONS(792),
    [anon_sym_dereferenceable_or_null] = ACTIONS(789),
    [anon_sym_swiftself] = ACTIONS(789),
    [anon_sym_swiftasync] = ACTIONS(789),
    [anon_sym_swifterror] = ACTIONS(789),
    [anon_sym_immarg] = ACTIONS(789),
    [anon_sym_noundef] = ACTIONS(789),
    [anon_sym_extractelement] = ACTIONS(782),
    [anon_sym_insertelement] = ACTIONS(782),
    [anon_sym_select] = ACTIONS(782),
    [anon_sym_shufflevector] = ACTIONS(782),
    [anon_sym_fneg] = ACTIONS(782),
    [anon_sym_icmp] = ACTIONS(782),
    [anon_sym_fcmp] = ACTIONS(782),
    [anon_sym_getelementptr] = ACTIONS(782),
    [anon_sym_extractvalue] = ACTIONS(782),
    [anon_sym_insertvalue] = ACTIONS(782),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(782),
    [anon_sym_null] = ACTIONS(784),
    [anon_sym_none] = ACTIONS(782),
    [anon_sym_undef] = ACTIONS(782),
    [anon_sym_poison] = ACTIONS(782),
    [anon_sym_zeroinitializer] = ACTIONS(782),
    [anon_sym_blockaddress] = ACTIONS(782),
    [anon_sym_mul] = ACTIONS(782),
    [anon_sym_urem] = ACTIONS(782),
    [anon_sym_srem] = ACTIONS(782),
    [anon_sym_shl] = ACTIONS(782),
    [anon_sym_udiv] = ACTIONS(782),
    [anon_sym_sdiv] = ACTIONS(782),
    [anon_sym_lshr] = ACTIONS(782),
    [anon_sym_ashr] = ACTIONS(782),
    [anon_sym_fmul] = ACTIONS(782),
    [anon_sym_fdiv] = ACTIONS(782),
    [anon_sym_frem] = ACTIONS(782),
    [anon_sym_xchg] = ACTIONS(782),
    [anon_sym_add] = ACTIONS(784),
    [anon_sym_sub] = ACTIONS(782),
    [anon_sym_and] = ACTIONS(782),
    [anon_sym_nand] = ACTIONS(782),
    [anon_sym_or] = ACTIONS(782),
    [anon_sym_xor] = ACTIONS(782),
    [anon_sym_max] = ACTIONS(782),
    [anon_sym_min] = ACTIONS(784),
    [anon_sym_umax] = ACTIONS(782),
    [anon_sym_umin] = ACTIONS(782),
    [anon_sym_fadd] = ACTIONS(782),
    [anon_sym_fsub] = ACTIONS(782),
    [anon_sym_bitcast] = ACTIONS(782),
    [anon_sym_trunc] = ACTIONS(782),
    [anon_sym_zext] = ACTIONS(782),
    [anon_sym_sext] = ACTIONS(782),
    [anon_sym_fptrunc] = ACTIONS(782),
    [anon_sym_fpext] = ACTIONS(782),
    [anon_sym_addrspacecast] = ACTIONS(782),
    [anon_sym_uitofp] = ACTIONS(782),
    [anon_sym_sitofp] = ACTIONS(782),
    [anon_sym_fptoui] = ACTIONS(782),
    [anon_sym_fptosi] = ACTIONS(782),
    [anon_sym_inttoptr] = ACTIONS(782),
    [anon_sym_ptrtoint] = ACTIONS(782),
  },
  [193] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [sym_label] = ACTIONS(795),
    [sym_string] = ACTIONS(797),
    [anon_sym_EQ] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(801),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(797),
    [anon_sym_partition] = ACTIONS(797),
    [anon_sym_comdat] = ACTIONS(797),
    [anon_sym_gc] = ACTIONS(797),
    [anon_sym_prefix] = ACTIONS(797),
    [anon_sym_prologue] = ACTIONS(797),
    [anon_sym_personality] = ACTIONS(797),
    [anon_sym_alignstack] = ACTIONS(797),
    [anon_sym_allocsize] = ACTIONS(797),
    [anon_sym_alwaysinline] = ACTIONS(797),
    [anon_sym_builtin] = ACTIONS(797),
    [anon_sym_cold] = ACTIONS(797),
    [anon_sym_convergent] = ACTIONS(797),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(797),
    [anon_sym_hot] = ACTIONS(797),
    [anon_sym_inaccessiblememonly] = ACTIONS(797),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(797),
    [anon_sym_inlinehint] = ACTIONS(797),
    [anon_sym_jumptable] = ACTIONS(797),
    [anon_sym_minsize] = ACTIONS(797),
    [anon_sym_naked] = ACTIONS(797),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(797),
    [anon_sym_nobuiltin] = ACTIONS(797),
    [anon_sym_noduplicate] = ACTIONS(797),
    [anon_sym_nofree] = ACTIONS(797),
    [anon_sym_noimplicitfloat] = ACTIONS(797),
    [anon_sym_noinline] = ACTIONS(797),
    [anon_sym_nomerge] = ACTIONS(797),
    [anon_sym_nonlazybind] = ACTIONS(797),
    [anon_sym_noprofile] = ACTIONS(797),
    [anon_sym_noredzone] = ACTIONS(797),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(797),
    [anon_sym_noreturn] = ACTIONS(797),
    [anon_sym_norecurse] = ACTIONS(797),
    [anon_sym_willreturn] = ACTIONS(797),
    [anon_sym_nosync] = ACTIONS(797),
    [anon_sym_nounwind] = ACTIONS(797),
    [anon_sym_nosanitize_coverage] = ACTIONS(797),
    [anon_sym_null_pointer_is_valid] = ACTIONS(797),
    [anon_sym_optforfuzzing] = ACTIONS(797),
    [anon_sym_optnone] = ACTIONS(797),
    [anon_sym_optsize] = ACTIONS(797),
    [anon_sym_readnone] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_writeonly] = ACTIONS(797),
    [anon_sym_argmemonly] = ACTIONS(797),
    [anon_sym_returns_twice] = ACTIONS(797),
    [anon_sym_safestack] = ACTIONS(797),
    [anon_sym_sanitize_address] = ACTIONS(797),
    [anon_sym_sanitize_memory] = ACTIONS(797),
    [anon_sym_sanitize_thread] = ACTIONS(797),
    [anon_sym_sanitize_hwaddress] = ACTIONS(797),
    [anon_sym_sanitize_memtag] = ACTIONS(797),
    [anon_sym_speculative_load_hardening] = ACTIONS(797),
    [anon_sym_speculatable] = ACTIONS(797),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(797),
    [anon_sym_sspreq] = ACTIONS(797),
    [anon_sym_strictfp] = ACTIONS(797),
    [anon_sym_uwtable] = ACTIONS(797),
    [anon_sym_nocf_check] = ACTIONS(797),
    [anon_sym_shadowcallstack] = ACTIONS(797),
    [anon_sym_mustprogress] = ACTIONS(797),
    [anon_sym_vscale_range] = ACTIONS(797),
    [anon_sym_preallocated] = ACTIONS(797),
    [anon_sym_zeroext] = ACTIONS(797),
    [anon_sym_signext] = ACTIONS(797),
    [anon_sym_inreg] = ACTIONS(797),
    [anon_sym_byval] = ACTIONS(797),
    [anon_sym_byref] = ACTIONS(797),
    [anon_sym_inalloca] = ACTIONS(797),
    [anon_sym_sret] = ACTIONS(797),
    [anon_sym_elementtype] = ACTIONS(797),
    [anon_sym_noalias] = ACTIONS(797),
    [anon_sym_nocapture] = ACTIONS(797),
    [anon_sym_nest] = ACTIONS(797),
    [anon_sym_returned] = ACTIONS(797),
    [anon_sym_nonnull] = ACTIONS(797),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(797),
    [anon_sym_swiftself] = ACTIONS(797),
    [anon_sym_swiftasync] = ACTIONS(797),
    [anon_sym_swifterror] = ACTIONS(797),
    [anon_sym_immarg] = ACTIONS(797),
    [anon_sym_noundef] = ACTIONS(797),
    [anon_sym_unreachable] = ACTIONS(797),
    [anon_sym_ret] = ACTIONS(797),
    [anon_sym_br] = ACTIONS(797),
    [anon_sym_resume] = ACTIONS(797),
    [anon_sym_freeze] = ACTIONS(797),
    [anon_sym_indirectbr] = ACTIONS(797),
    [anon_sym_extractelement] = ACTIONS(797),
    [anon_sym_insertelement] = ACTIONS(797),
    [anon_sym_select] = ACTIONS(797),
    [anon_sym_shufflevector] = ACTIONS(797),
    [anon_sym_fneg] = ACTIONS(797),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_invoke] = ACTIONS(797),
    [anon_sym_cleanupret] = ACTIONS(797),
    [anon_sym_catchret] = ACTIONS(797),
    [anon_sym_catchswitch] = ACTIONS(797),
    [anon_sym_catchpad] = ACTIONS(797),
    [anon_sym_cleanuppad] = ACTIONS(797),
    [anon_sym_callbr] = ACTIONS(797),
    [anon_sym_icmp] = ACTIONS(797),
    [anon_sym_fcmp] = ACTIONS(797),
    [anon_sym_va_arg] = ACTIONS(797),
    [anon_sym_phi] = ACTIONS(797),
    [anon_sym_landingpad] = ACTIONS(797),
    [anon_sym_tail] = ACTIONS(797),
    [anon_sym_musttail] = ACTIONS(797),
    [anon_sym_notail] = ACTIONS(797),
    [anon_sym_call] = ACTIONS(797),
    [anon_sym_alloca] = ACTIONS(797),
    [anon_sym_load] = ACTIONS(797),
    [anon_sym_store] = ACTIONS(797),
    [anon_sym_cmpxchg] = ACTIONS(797),
    [anon_sym_atomicrmw] = ACTIONS(797),
    [anon_sym_fence] = ACTIONS(797),
    [anon_sym_getelementptr] = ACTIONS(797),
    [anon_sym_extractvalue] = ACTIONS(797),
    [anon_sym_insertvalue] = ACTIONS(797),
    [anon_sym_mul] = ACTIONS(797),
    [anon_sym_urem] = ACTIONS(797),
    [anon_sym_srem] = ACTIONS(797),
    [anon_sym_shl] = ACTIONS(797),
    [anon_sym_udiv] = ACTIONS(797),
    [anon_sym_sdiv] = ACTIONS(797),
    [anon_sym_lshr] = ACTIONS(797),
    [anon_sym_ashr] = ACTIONS(797),
    [anon_sym_fmul] = ACTIONS(797),
    [anon_sym_fdiv] = ACTIONS(797),
    [anon_sym_frem] = ACTIONS(797),
    [anon_sym_xchg] = ACTIONS(797),
    [anon_sym_add] = ACTIONS(797),
    [anon_sym_sub] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_nand] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_xor] = ACTIONS(797),
    [anon_sym_max] = ACTIONS(797),
    [anon_sym_min] = ACTIONS(797),
    [anon_sym_umax] = ACTIONS(797),
    [anon_sym_umin] = ACTIONS(797),
    [anon_sym_fadd] = ACTIONS(797),
    [anon_sym_fsub] = ACTIONS(797),
    [anon_sym_bitcast] = ACTIONS(797),
    [anon_sym_trunc] = ACTIONS(797),
    [anon_sym_zext] = ACTIONS(797),
    [anon_sym_sext] = ACTIONS(797),
    [anon_sym_fptrunc] = ACTIONS(797),
    [anon_sym_fpext] = ACTIONS(797),
    [anon_sym_addrspacecast] = ACTIONS(797),
    [anon_sym_uitofp] = ACTIONS(797),
    [anon_sym_sitofp] = ACTIONS(797),
    [anon_sym_fptoui] = ACTIONS(797),
    [anon_sym_fptosi] = ACTIONS(797),
    [anon_sym_inttoptr] = ACTIONS(797),
    [anon_sym_ptrtoint] = ACTIONS(797),
    [anon_sym_uselistorder] = ACTIONS(797),
  },
  [194] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_label] = ACTIONS(713),
    [sym_string] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(715),
    [anon_sym_partition] = ACTIONS(715),
    [anon_sym_comdat] = ACTIONS(715),
    [anon_sym_gc] = ACTIONS(715),
    [anon_sym_prefix] = ACTIONS(715),
    [anon_sym_prologue] = ACTIONS(715),
    [anon_sym_personality] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(715),
    [anon_sym_allocsize] = ACTIONS(715),
    [anon_sym_alwaysinline] = ACTIONS(715),
    [anon_sym_builtin] = ACTIONS(715),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(715),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(715),
    [anon_sym_hot] = ACTIONS(715),
    [anon_sym_inaccessiblememonly] = ACTIONS(715),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(715),
    [anon_sym_inlinehint] = ACTIONS(715),
    [anon_sym_jumptable] = ACTIONS(715),
    [anon_sym_minsize] = ACTIONS(715),
    [anon_sym_naked] = ACTIONS(715),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(715),
    [anon_sym_nobuiltin] = ACTIONS(715),
    [anon_sym_noduplicate] = ACTIONS(715),
    [anon_sym_nofree] = ACTIONS(715),
    [anon_sym_noimplicitfloat] = ACTIONS(715),
    [anon_sym_noinline] = ACTIONS(715),
    [anon_sym_nomerge] = ACTIONS(715),
    [anon_sym_nonlazybind] = ACTIONS(715),
    [anon_sym_noprofile] = ACTIONS(715),
    [anon_sym_noredzone] = ACTIONS(715),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(715),
    [anon_sym_noreturn] = ACTIONS(715),
    [anon_sym_norecurse] = ACTIONS(715),
    [anon_sym_willreturn] = ACTIONS(715),
    [anon_sym_nosync] = ACTIONS(715),
    [anon_sym_nounwind] = ACTIONS(715),
    [anon_sym_nosanitize_coverage] = ACTIONS(715),
    [anon_sym_null_pointer_is_valid] = ACTIONS(715),
    [anon_sym_optforfuzzing] = ACTIONS(715),
    [anon_sym_optnone] = ACTIONS(715),
    [anon_sym_optsize] = ACTIONS(715),
    [anon_sym_readnone] = ACTIONS(715),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_writeonly] = ACTIONS(715),
    [anon_sym_argmemonly] = ACTIONS(715),
    [anon_sym_returns_twice] = ACTIONS(715),
    [anon_sym_safestack] = ACTIONS(715),
    [anon_sym_sanitize_address] = ACTIONS(715),
    [anon_sym_sanitize_memory] = ACTIONS(715),
    [anon_sym_sanitize_thread] = ACTIONS(715),
    [anon_sym_sanitize_hwaddress] = ACTIONS(715),
    [anon_sym_sanitize_memtag] = ACTIONS(715),
    [anon_sym_speculative_load_hardening] = ACTIONS(715),
    [anon_sym_speculatable] = ACTIONS(715),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(715),
    [anon_sym_sspreq] = ACTIONS(715),
    [anon_sym_strictfp] = ACTIONS(715),
    [anon_sym_uwtable] = ACTIONS(715),
    [anon_sym_nocf_check] = ACTIONS(715),
    [anon_sym_shadowcallstack] = ACTIONS(715),
    [anon_sym_mustprogress] = ACTIONS(715),
    [anon_sym_vscale_range] = ACTIONS(715),
    [anon_sym_preallocated] = ACTIONS(715),
    [anon_sym_zeroext] = ACTIONS(715),
    [anon_sym_signext] = ACTIONS(715),
    [anon_sym_inreg] = ACTIONS(715),
    [anon_sym_byval] = ACTIONS(715),
    [anon_sym_byref] = ACTIONS(715),
    [anon_sym_inalloca] = ACTIONS(715),
    [anon_sym_sret] = ACTIONS(715),
    [anon_sym_elementtype] = ACTIONS(715),
    [anon_sym_noalias] = ACTIONS(715),
    [anon_sym_nocapture] = ACTIONS(715),
    [anon_sym_nest] = ACTIONS(715),
    [anon_sym_returned] = ACTIONS(715),
    [anon_sym_nonnull] = ACTIONS(715),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(715),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(715),
    [anon_sym_noundef] = ACTIONS(715),
    [anon_sym_unreachable] = ACTIONS(715),
    [anon_sym_ret] = ACTIONS(715),
    [anon_sym_br] = ACTIONS(715),
    [anon_sym_resume] = ACTIONS(715),
    [anon_sym_freeze] = ACTIONS(715),
    [anon_sym_indirectbr] = ACTIONS(715),
    [anon_sym_extractelement] = ACTIONS(715),
    [anon_sym_insertelement] = ACTIONS(715),
    [anon_sym_select] = ACTIONS(715),
    [anon_sym_shufflevector] = ACTIONS(715),
    [anon_sym_fneg] = ACTIONS(715),
    [anon_sym_switch] = ACTIONS(715),
    [anon_sym_invoke] = ACTIONS(715),
    [anon_sym_cleanupret] = ACTIONS(715),
    [anon_sym_catchret] = ACTIONS(715),
    [anon_sym_catchswitch] = ACTIONS(715),
    [anon_sym_catchpad] = ACTIONS(715),
    [anon_sym_cleanuppad] = ACTIONS(715),
    [anon_sym_callbr] = ACTIONS(715),
    [anon_sym_icmp] = ACTIONS(715),
    [anon_sym_fcmp] = ACTIONS(715),
    [anon_sym_va_arg] = ACTIONS(715),
    [anon_sym_phi] = ACTIONS(715),
    [anon_sym_landingpad] = ACTIONS(715),
    [anon_sym_tail] = ACTIONS(715),
    [anon_sym_musttail] = ACTIONS(715),
    [anon_sym_notail] = ACTIONS(715),
    [anon_sym_call] = ACTIONS(715),
    [anon_sym_alloca] = ACTIONS(715),
    [anon_sym_load] = ACTIONS(715),
    [anon_sym_store] = ACTIONS(715),
    [anon_sym_cmpxchg] = ACTIONS(715),
    [anon_sym_atomicrmw] = ACTIONS(715),
    [anon_sym_fence] = ACTIONS(715),
    [anon_sym_getelementptr] = ACTIONS(715),
    [anon_sym_extractvalue] = ACTIONS(715),
    [anon_sym_insertvalue] = ACTIONS(715),
    [anon_sym_mul] = ACTIONS(715),
    [anon_sym_urem] = ACTIONS(715),
    [anon_sym_srem] = ACTIONS(715),
    [anon_sym_shl] = ACTIONS(715),
    [anon_sym_udiv] = ACTIONS(715),
    [anon_sym_sdiv] = ACTIONS(715),
    [anon_sym_lshr] = ACTIONS(715),
    [anon_sym_ashr] = ACTIONS(715),
    [anon_sym_fmul] = ACTIONS(715),
    [anon_sym_fdiv] = ACTIONS(715),
    [anon_sym_frem] = ACTIONS(715),
    [anon_sym_xchg] = ACTIONS(715),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(715),
    [anon_sym_and] = ACTIONS(715),
    [anon_sym_nand] = ACTIONS(715),
    [anon_sym_or] = ACTIONS(715),
    [anon_sym_xor] = ACTIONS(715),
    [anon_sym_max] = ACTIONS(715),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(715),
    [anon_sym_umin] = ACTIONS(715),
    [anon_sym_fadd] = ACTIONS(715),
    [anon_sym_fsub] = ACTIONS(715),
    [anon_sym_bitcast] = ACTIONS(715),
    [anon_sym_trunc] = ACTIONS(715),
    [anon_sym_zext] = ACTIONS(715),
    [anon_sym_sext] = ACTIONS(715),
    [anon_sym_fptrunc] = ACTIONS(715),
    [anon_sym_fpext] = ACTIONS(715),
    [anon_sym_addrspacecast] = ACTIONS(715),
    [anon_sym_uitofp] = ACTIONS(715),
    [anon_sym_sitofp] = ACTIONS(715),
    [anon_sym_fptoui] = ACTIONS(715),
    [anon_sym_fptosi] = ACTIONS(715),
    [anon_sym_inttoptr] = ACTIONS(715),
    [anon_sym_ptrtoint] = ACTIONS(715),
    [anon_sym_uselistorder] = ACTIONS(715),
  },
  [195] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [sym_label] = ACTIONS(795),
    [sym_string] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(797),
    [anon_sym_partition] = ACTIONS(797),
    [anon_sym_comdat] = ACTIONS(797),
    [anon_sym_gc] = ACTIONS(797),
    [anon_sym_prefix] = ACTIONS(797),
    [anon_sym_prologue] = ACTIONS(797),
    [anon_sym_personality] = ACTIONS(797),
    [anon_sym_alignstack] = ACTIONS(797),
    [anon_sym_allocsize] = ACTIONS(797),
    [anon_sym_alwaysinline] = ACTIONS(797),
    [anon_sym_builtin] = ACTIONS(797),
    [anon_sym_cold] = ACTIONS(797),
    [anon_sym_convergent] = ACTIONS(797),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(797),
    [anon_sym_hot] = ACTIONS(797),
    [anon_sym_inaccessiblememonly] = ACTIONS(797),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(797),
    [anon_sym_inlinehint] = ACTIONS(797),
    [anon_sym_jumptable] = ACTIONS(797),
    [anon_sym_minsize] = ACTIONS(797),
    [anon_sym_naked] = ACTIONS(797),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(797),
    [anon_sym_nobuiltin] = ACTIONS(797),
    [anon_sym_noduplicate] = ACTIONS(797),
    [anon_sym_nofree] = ACTIONS(797),
    [anon_sym_noimplicitfloat] = ACTIONS(797),
    [anon_sym_noinline] = ACTIONS(797),
    [anon_sym_nomerge] = ACTIONS(797),
    [anon_sym_nonlazybind] = ACTIONS(797),
    [anon_sym_noprofile] = ACTIONS(797),
    [anon_sym_noredzone] = ACTIONS(797),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(797),
    [anon_sym_noreturn] = ACTIONS(797),
    [anon_sym_norecurse] = ACTIONS(797),
    [anon_sym_willreturn] = ACTIONS(797),
    [anon_sym_nosync] = ACTIONS(797),
    [anon_sym_nounwind] = ACTIONS(797),
    [anon_sym_nosanitize_coverage] = ACTIONS(797),
    [anon_sym_null_pointer_is_valid] = ACTIONS(797),
    [anon_sym_optforfuzzing] = ACTIONS(797),
    [anon_sym_optnone] = ACTIONS(797),
    [anon_sym_optsize] = ACTIONS(797),
    [anon_sym_readnone] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_writeonly] = ACTIONS(797),
    [anon_sym_argmemonly] = ACTIONS(797),
    [anon_sym_returns_twice] = ACTIONS(797),
    [anon_sym_safestack] = ACTIONS(797),
    [anon_sym_sanitize_address] = ACTIONS(797),
    [anon_sym_sanitize_memory] = ACTIONS(797),
    [anon_sym_sanitize_thread] = ACTIONS(797),
    [anon_sym_sanitize_hwaddress] = ACTIONS(797),
    [anon_sym_sanitize_memtag] = ACTIONS(797),
    [anon_sym_speculative_load_hardening] = ACTIONS(797),
    [anon_sym_speculatable] = ACTIONS(797),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(797),
    [anon_sym_sspreq] = ACTIONS(797),
    [anon_sym_strictfp] = ACTIONS(797),
    [anon_sym_uwtable] = ACTIONS(797),
    [anon_sym_nocf_check] = ACTIONS(797),
    [anon_sym_shadowcallstack] = ACTIONS(797),
    [anon_sym_mustprogress] = ACTIONS(797),
    [anon_sym_vscale_range] = ACTIONS(797),
    [anon_sym_preallocated] = ACTIONS(797),
    [anon_sym_zeroext] = ACTIONS(797),
    [anon_sym_signext] = ACTIONS(797),
    [anon_sym_inreg] = ACTIONS(797),
    [anon_sym_byval] = ACTIONS(797),
    [anon_sym_byref] = ACTIONS(797),
    [anon_sym_inalloca] = ACTIONS(797),
    [anon_sym_sret] = ACTIONS(797),
    [anon_sym_elementtype] = ACTIONS(797),
    [anon_sym_noalias] = ACTIONS(797),
    [anon_sym_nocapture] = ACTIONS(797),
    [anon_sym_nest] = ACTIONS(797),
    [anon_sym_returned] = ACTIONS(797),
    [anon_sym_nonnull] = ACTIONS(797),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(797),
    [anon_sym_swiftself] = ACTIONS(797),
    [anon_sym_swiftasync] = ACTIONS(797),
    [anon_sym_swifterror] = ACTIONS(797),
    [anon_sym_immarg] = ACTIONS(797),
    [anon_sym_noundef] = ACTIONS(797),
    [anon_sym_unreachable] = ACTIONS(797),
    [anon_sym_ret] = ACTIONS(797),
    [anon_sym_br] = ACTIONS(797),
    [anon_sym_resume] = ACTIONS(797),
    [anon_sym_freeze] = ACTIONS(797),
    [anon_sym_indirectbr] = ACTIONS(797),
    [anon_sym_extractelement] = ACTIONS(797),
    [anon_sym_insertelement] = ACTIONS(797),
    [anon_sym_select] = ACTIONS(797),
    [anon_sym_shufflevector] = ACTIONS(797),
    [anon_sym_fneg] = ACTIONS(797),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_invoke] = ACTIONS(797),
    [anon_sym_cleanupret] = ACTIONS(797),
    [anon_sym_catchret] = ACTIONS(797),
    [anon_sym_catchswitch] = ACTIONS(797),
    [anon_sym_catchpad] = ACTIONS(797),
    [anon_sym_cleanuppad] = ACTIONS(797),
    [anon_sym_callbr] = ACTIONS(797),
    [anon_sym_icmp] = ACTIONS(797),
    [anon_sym_fcmp] = ACTIONS(797),
    [anon_sym_va_arg] = ACTIONS(797),
    [anon_sym_phi] = ACTIONS(797),
    [anon_sym_landingpad] = ACTIONS(797),
    [anon_sym_tail] = ACTIONS(797),
    [anon_sym_musttail] = ACTIONS(797),
    [anon_sym_notail] = ACTIONS(797),
    [anon_sym_call] = ACTIONS(797),
    [anon_sym_alloca] = ACTIONS(797),
    [anon_sym_load] = ACTIONS(797),
    [anon_sym_store] = ACTIONS(797),
    [anon_sym_cmpxchg] = ACTIONS(797),
    [anon_sym_atomicrmw] = ACTIONS(797),
    [anon_sym_fence] = ACTIONS(797),
    [anon_sym_getelementptr] = ACTIONS(797),
    [anon_sym_extractvalue] = ACTIONS(797),
    [anon_sym_insertvalue] = ACTIONS(797),
    [anon_sym_mul] = ACTIONS(797),
    [anon_sym_urem] = ACTIONS(797),
    [anon_sym_srem] = ACTIONS(797),
    [anon_sym_shl] = ACTIONS(797),
    [anon_sym_udiv] = ACTIONS(797),
    [anon_sym_sdiv] = ACTIONS(797),
    [anon_sym_lshr] = ACTIONS(797),
    [anon_sym_ashr] = ACTIONS(797),
    [anon_sym_fmul] = ACTIONS(797),
    [anon_sym_fdiv] = ACTIONS(797),
    [anon_sym_frem] = ACTIONS(797),
    [anon_sym_xchg] = ACTIONS(797),
    [anon_sym_add] = ACTIONS(797),
    [anon_sym_sub] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_nand] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_xor] = ACTIONS(797),
    [anon_sym_max] = ACTIONS(797),
    [anon_sym_min] = ACTIONS(797),
    [anon_sym_umax] = ACTIONS(797),
    [anon_sym_umin] = ACTIONS(797),
    [anon_sym_fadd] = ACTIONS(797),
    [anon_sym_fsub] = ACTIONS(797),
    [anon_sym_bitcast] = ACTIONS(797),
    [anon_sym_trunc] = ACTIONS(797),
    [anon_sym_zext] = ACTIONS(797),
    [anon_sym_sext] = ACTIONS(797),
    [anon_sym_fptrunc] = ACTIONS(797),
    [anon_sym_fpext] = ACTIONS(797),
    [anon_sym_addrspacecast] = ACTIONS(797),
    [anon_sym_uitofp] = ACTIONS(797),
    [anon_sym_sitofp] = ACTIONS(797),
    [anon_sym_fptoui] = ACTIONS(797),
    [anon_sym_fptosi] = ACTIONS(797),
    [anon_sym_inttoptr] = ACTIONS(797),
    [anon_sym_ptrtoint] = ACTIONS(797),
    [anon_sym_uselistorder] = ACTIONS(797),
  },
  [196] = {
    [sym_function_header] = STATE(1127),
    [sym_linkage] = STATE(208),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_calling_conv] = STATE(373),
    [sym_unnamed_addr] = STATE(1029),
    [sym_type] = STATE(1715),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(371),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat1] = STATE(208),
    [aux_sym_function_header_repeat2] = STATE(371),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [sym_string] = ACTIONS(741),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [197] = {
    [sym_number] = STATE(211),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(805),
    [aux_sym_number_token2] = ACTIONS(807),
    [sym_float] = ACTIONS(713),
    [sym_cstring] = ACTIONS(713),
    [anon_sym_no_cfi] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_internal] = ACTIONS(713),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(713),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(713),
    [anon_sym_available_externally] = ACTIONS(713),
    [anon_sym_appending] = ACTIONS(713),
    [anon_sym_common] = ACTIONS(713),
    [anon_sym_extern_weak] = ACTIONS(713),
    [anon_sym_external] = ACTIONS(713),
    [anon_sym_dso_local] = ACTIONS(715),
    [anon_sym_dso_local_equivalent] = ACTIONS(713),
    [anon_sym_dso_preemptable] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_hidden] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_dllimport] = ACTIONS(713),
    [anon_sym_dllexport] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_extractelement] = ACTIONS(713),
    [anon_sym_insertelement] = ACTIONS(713),
    [anon_sym_select] = ACTIONS(713),
    [anon_sym_shufflevector] = ACTIONS(713),
    [anon_sym_fneg] = ACTIONS(713),
    [anon_sym_icmp] = ACTIONS(713),
    [anon_sym_fcmp] = ACTIONS(713),
    [anon_sym_getelementptr] = ACTIONS(713),
    [anon_sym_extractvalue] = ACTIONS(713),
    [anon_sym_insertvalue] = ACTIONS(713),
    [anon_sym_true] = ACTIONS(713),
    [anon_sym_false] = ACTIONS(713),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_none] = ACTIONS(713),
    [anon_sym_undef] = ACTIONS(713),
    [anon_sym_poison] = ACTIONS(713),
    [anon_sym_zeroinitializer] = ACTIONS(713),
    [anon_sym_blockaddress] = ACTIONS(713),
    [anon_sym_mul] = ACTIONS(713),
    [anon_sym_urem] = ACTIONS(713),
    [anon_sym_srem] = ACTIONS(713),
    [anon_sym_shl] = ACTIONS(713),
    [anon_sym_udiv] = ACTIONS(713),
    [anon_sym_sdiv] = ACTIONS(713),
    [anon_sym_lshr] = ACTIONS(713),
    [anon_sym_ashr] = ACTIONS(713),
    [anon_sym_fmul] = ACTIONS(713),
    [anon_sym_fdiv] = ACTIONS(713),
    [anon_sym_frem] = ACTIONS(713),
    [anon_sym_xchg] = ACTIONS(713),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(713),
    [anon_sym_and] = ACTIONS(713),
    [anon_sym_nand] = ACTIONS(713),
    [anon_sym_or] = ACTIONS(713),
    [anon_sym_xor] = ACTIONS(713),
    [anon_sym_max] = ACTIONS(713),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(713),
    [anon_sym_umin] = ACTIONS(713),
    [anon_sym_fadd] = ACTIONS(713),
    [anon_sym_fsub] = ACTIONS(713),
    [anon_sym_bitcast] = ACTIONS(713),
    [anon_sym_trunc] = ACTIONS(713),
    [anon_sym_zext] = ACTIONS(713),
    [anon_sym_sext] = ACTIONS(713),
    [anon_sym_fptrunc] = ACTIONS(713),
    [anon_sym_fpext] = ACTIONS(713),
    [anon_sym_addrspacecast] = ACTIONS(713),
    [anon_sym_uitofp] = ACTIONS(713),
    [anon_sym_sitofp] = ACTIONS(713),
    [anon_sym_fptoui] = ACTIONS(713),
    [anon_sym_fptosi] = ACTIONS(713),
    [anon_sym_inttoptr] = ACTIONS(713),
    [anon_sym_ptrtoint] = ACTIONS(713),
  },
  [198] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [sym_label] = ACTIONS(307),
    [sym_string] = ACTIONS(309),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_align] = ACTIONS(309),
    [anon_sym_section] = ACTIONS(309),
    [anon_sym_partition] = ACTIONS(309),
    [anon_sym_comdat] = ACTIONS(309),
    [anon_sym_gc] = ACTIONS(309),
    [anon_sym_prefix] = ACTIONS(309),
    [anon_sym_prologue] = ACTIONS(309),
    [anon_sym_personality] = ACTIONS(309),
    [anon_sym_alignstack] = ACTIONS(309),
    [anon_sym_allocsize] = ACTIONS(309),
    [anon_sym_alwaysinline] = ACTIONS(309),
    [anon_sym_builtin] = ACTIONS(309),
    [anon_sym_cold] = ACTIONS(309),
    [anon_sym_convergent] = ACTIONS(309),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(309),
    [anon_sym_hot] = ACTIONS(309),
    [anon_sym_inaccessiblememonly] = ACTIONS(309),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(309),
    [anon_sym_inlinehint] = ACTIONS(309),
    [anon_sym_jumptable] = ACTIONS(309),
    [anon_sym_minsize] = ACTIONS(309),
    [anon_sym_naked] = ACTIONS(309),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(309),
    [anon_sym_nobuiltin] = ACTIONS(309),
    [anon_sym_noduplicate] = ACTIONS(309),
    [anon_sym_nofree] = ACTIONS(309),
    [anon_sym_noimplicitfloat] = ACTIONS(309),
    [anon_sym_noinline] = ACTIONS(309),
    [anon_sym_nomerge] = ACTIONS(309),
    [anon_sym_nonlazybind] = ACTIONS(309),
    [anon_sym_noprofile] = ACTIONS(309),
    [anon_sym_noredzone] = ACTIONS(309),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(309),
    [anon_sym_noreturn] = ACTIONS(309),
    [anon_sym_norecurse] = ACTIONS(309),
    [anon_sym_willreturn] = ACTIONS(309),
    [anon_sym_nosync] = ACTIONS(309),
    [anon_sym_nounwind] = ACTIONS(309),
    [anon_sym_nosanitize_coverage] = ACTIONS(309),
    [anon_sym_null_pointer_is_valid] = ACTIONS(309),
    [anon_sym_optforfuzzing] = ACTIONS(309),
    [anon_sym_optnone] = ACTIONS(309),
    [anon_sym_optsize] = ACTIONS(309),
    [anon_sym_readnone] = ACTIONS(309),
    [anon_sym_readonly] = ACTIONS(309),
    [anon_sym_writeonly] = ACTIONS(309),
    [anon_sym_argmemonly] = ACTIONS(309),
    [anon_sym_returns_twice] = ACTIONS(309),
    [anon_sym_safestack] = ACTIONS(309),
    [anon_sym_sanitize_address] = ACTIONS(309),
    [anon_sym_sanitize_memory] = ACTIONS(309),
    [anon_sym_sanitize_thread] = ACTIONS(309),
    [anon_sym_sanitize_hwaddress] = ACTIONS(309),
    [anon_sym_sanitize_memtag] = ACTIONS(309),
    [anon_sym_speculative_load_hardening] = ACTIONS(309),
    [anon_sym_speculatable] = ACTIONS(309),
    [anon_sym_ssp] = ACTIONS(309),
    [anon_sym_sspstrong] = ACTIONS(309),
    [anon_sym_sspreq] = ACTIONS(309),
    [anon_sym_strictfp] = ACTIONS(309),
    [anon_sym_uwtable] = ACTIONS(309),
    [anon_sym_nocf_check] = ACTIONS(309),
    [anon_sym_shadowcallstack] = ACTIONS(309),
    [anon_sym_mustprogress] = ACTIONS(309),
    [anon_sym_vscale_range] = ACTIONS(309),
    [anon_sym_preallocated] = ACTIONS(309),
    [anon_sym_zeroext] = ACTIONS(309),
    [anon_sym_signext] = ACTIONS(309),
    [anon_sym_inreg] = ACTIONS(309),
    [anon_sym_byval] = ACTIONS(309),
    [anon_sym_byref] = ACTIONS(309),
    [anon_sym_inalloca] = ACTIONS(309),
    [anon_sym_sret] = ACTIONS(309),
    [anon_sym_elementtype] = ACTIONS(309),
    [anon_sym_noalias] = ACTIONS(309),
    [anon_sym_nocapture] = ACTIONS(309),
    [anon_sym_nest] = ACTIONS(309),
    [anon_sym_returned] = ACTIONS(309),
    [anon_sym_nonnull] = ACTIONS(309),
    [anon_sym_dereferenceable] = ACTIONS(309),
    [anon_sym_dereferenceable_or_null] = ACTIONS(309),
    [anon_sym_swiftself] = ACTIONS(309),
    [anon_sym_swiftasync] = ACTIONS(309),
    [anon_sym_swifterror] = ACTIONS(309),
    [anon_sym_immarg] = ACTIONS(309),
    [anon_sym_noundef] = ACTIONS(309),
    [anon_sym_unreachable] = ACTIONS(309),
    [anon_sym_ret] = ACTIONS(309),
    [anon_sym_br] = ACTIONS(309),
    [anon_sym_resume] = ACTIONS(309),
    [anon_sym_freeze] = ACTIONS(309),
    [anon_sym_indirectbr] = ACTIONS(309),
    [anon_sym_extractelement] = ACTIONS(309),
    [anon_sym_insertelement] = ACTIONS(309),
    [anon_sym_select] = ACTIONS(309),
    [anon_sym_shufflevector] = ACTIONS(309),
    [anon_sym_fneg] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_invoke] = ACTIONS(309),
    [anon_sym_cleanupret] = ACTIONS(309),
    [anon_sym_catchret] = ACTIONS(309),
    [anon_sym_catchswitch] = ACTIONS(309),
    [anon_sym_catchpad] = ACTIONS(309),
    [anon_sym_cleanuppad] = ACTIONS(309),
    [anon_sym_callbr] = ACTIONS(309),
    [anon_sym_icmp] = ACTIONS(309),
    [anon_sym_fcmp] = ACTIONS(309),
    [anon_sym_va_arg] = ACTIONS(309),
    [anon_sym_phi] = ACTIONS(309),
    [anon_sym_landingpad] = ACTIONS(309),
    [anon_sym_tail] = ACTIONS(309),
    [anon_sym_musttail] = ACTIONS(309),
    [anon_sym_notail] = ACTIONS(309),
    [anon_sym_call] = ACTIONS(309),
    [anon_sym_alloca] = ACTIONS(309),
    [anon_sym_load] = ACTIONS(309),
    [anon_sym_store] = ACTIONS(309),
    [anon_sym_cmpxchg] = ACTIONS(309),
    [anon_sym_atomicrmw] = ACTIONS(309),
    [anon_sym_fence] = ACTIONS(309),
    [anon_sym_getelementptr] = ACTIONS(309),
    [anon_sym_extractvalue] = ACTIONS(309),
    [anon_sym_insertvalue] = ACTIONS(309),
    [anon_sym_mul] = ACTIONS(309),
    [anon_sym_urem] = ACTIONS(309),
    [anon_sym_srem] = ACTIONS(309),
    [anon_sym_shl] = ACTIONS(309),
    [anon_sym_udiv] = ACTIONS(309),
    [anon_sym_sdiv] = ACTIONS(309),
    [anon_sym_lshr] = ACTIONS(309),
    [anon_sym_ashr] = ACTIONS(309),
    [anon_sym_fmul] = ACTIONS(309),
    [anon_sym_fdiv] = ACTIONS(309),
    [anon_sym_frem] = ACTIONS(309),
    [anon_sym_xchg] = ACTIONS(309),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(309),
    [anon_sym_nand] = ACTIONS(309),
    [anon_sym_or] = ACTIONS(309),
    [anon_sym_xor] = ACTIONS(309),
    [anon_sym_max] = ACTIONS(309),
    [anon_sym_min] = ACTIONS(309),
    [anon_sym_umax] = ACTIONS(309),
    [anon_sym_umin] = ACTIONS(309),
    [anon_sym_fadd] = ACTIONS(309),
    [anon_sym_fsub] = ACTIONS(309),
    [anon_sym_bitcast] = ACTIONS(309),
    [anon_sym_trunc] = ACTIONS(309),
    [anon_sym_zext] = ACTIONS(309),
    [anon_sym_sext] = ACTIONS(309),
    [anon_sym_fptrunc] = ACTIONS(309),
    [anon_sym_fpext] = ACTIONS(309),
    [anon_sym_addrspacecast] = ACTIONS(309),
    [anon_sym_uitofp] = ACTIONS(309),
    [anon_sym_sitofp] = ACTIONS(309),
    [anon_sym_fptoui] = ACTIONS(309),
    [anon_sym_fptosi] = ACTIONS(309),
    [anon_sym_inttoptr] = ACTIONS(309),
    [anon_sym_ptrtoint] = ACTIONS(309),
    [anon_sym_uselistorder] = ACTIONS(309),
  },
  [199] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(809),
    [sym_local_var] = ACTIONS(809),
    [sym_label] = ACTIONS(809),
    [sym_string] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(809),
    [anon_sym_COMMA] = ACTIONS(809),
    [anon_sym_align] = ACTIONS(811),
    [anon_sym_section] = ACTIONS(811),
    [anon_sym_partition] = ACTIONS(811),
    [anon_sym_comdat] = ACTIONS(811),
    [anon_sym_gc] = ACTIONS(811),
    [anon_sym_prefix] = ACTIONS(811),
    [anon_sym_prologue] = ACTIONS(811),
    [anon_sym_personality] = ACTIONS(811),
    [anon_sym_alignstack] = ACTIONS(811),
    [anon_sym_allocsize] = ACTIONS(811),
    [anon_sym_alwaysinline] = ACTIONS(811),
    [anon_sym_builtin] = ACTIONS(811),
    [anon_sym_cold] = ACTIONS(811),
    [anon_sym_convergent] = ACTIONS(811),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(811),
    [anon_sym_hot] = ACTIONS(811),
    [anon_sym_inaccessiblememonly] = ACTIONS(811),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(811),
    [anon_sym_inlinehint] = ACTIONS(811),
    [anon_sym_jumptable] = ACTIONS(811),
    [anon_sym_minsize] = ACTIONS(811),
    [anon_sym_naked] = ACTIONS(811),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(811),
    [anon_sym_nobuiltin] = ACTIONS(811),
    [anon_sym_noduplicate] = ACTIONS(811),
    [anon_sym_nofree] = ACTIONS(811),
    [anon_sym_noimplicitfloat] = ACTIONS(811),
    [anon_sym_noinline] = ACTIONS(811),
    [anon_sym_nomerge] = ACTIONS(811),
    [anon_sym_nonlazybind] = ACTIONS(811),
    [anon_sym_noprofile] = ACTIONS(811),
    [anon_sym_noredzone] = ACTIONS(811),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(811),
    [anon_sym_noreturn] = ACTIONS(811),
    [anon_sym_norecurse] = ACTIONS(811),
    [anon_sym_willreturn] = ACTIONS(811),
    [anon_sym_nosync] = ACTIONS(811),
    [anon_sym_nounwind] = ACTIONS(811),
    [anon_sym_nosanitize_coverage] = ACTIONS(811),
    [anon_sym_null_pointer_is_valid] = ACTIONS(811),
    [anon_sym_optforfuzzing] = ACTIONS(811),
    [anon_sym_optnone] = ACTIONS(811),
    [anon_sym_optsize] = ACTIONS(811),
    [anon_sym_readnone] = ACTIONS(811),
    [anon_sym_readonly] = ACTIONS(811),
    [anon_sym_writeonly] = ACTIONS(811),
    [anon_sym_argmemonly] = ACTIONS(811),
    [anon_sym_returns_twice] = ACTIONS(811),
    [anon_sym_safestack] = ACTIONS(811),
    [anon_sym_sanitize_address] = ACTIONS(811),
    [anon_sym_sanitize_memory] = ACTIONS(811),
    [anon_sym_sanitize_thread] = ACTIONS(811),
    [anon_sym_sanitize_hwaddress] = ACTIONS(811),
    [anon_sym_sanitize_memtag] = ACTIONS(811),
    [anon_sym_speculative_load_hardening] = ACTIONS(811),
    [anon_sym_speculatable] = ACTIONS(811),
    [anon_sym_ssp] = ACTIONS(811),
    [anon_sym_sspstrong] = ACTIONS(811),
    [anon_sym_sspreq] = ACTIONS(811),
    [anon_sym_strictfp] = ACTIONS(811),
    [anon_sym_uwtable] = ACTIONS(811),
    [anon_sym_nocf_check] = ACTIONS(811),
    [anon_sym_shadowcallstack] = ACTIONS(811),
    [anon_sym_mustprogress] = ACTIONS(811),
    [anon_sym_vscale_range] = ACTIONS(811),
    [anon_sym_preallocated] = ACTIONS(811),
    [anon_sym_zeroext] = ACTIONS(811),
    [anon_sym_signext] = ACTIONS(811),
    [anon_sym_inreg] = ACTIONS(811),
    [anon_sym_byval] = ACTIONS(811),
    [anon_sym_byref] = ACTIONS(811),
    [anon_sym_inalloca] = ACTIONS(811),
    [anon_sym_sret] = ACTIONS(811),
    [anon_sym_elementtype] = ACTIONS(811),
    [anon_sym_noalias] = ACTIONS(811),
    [anon_sym_nocapture] = ACTIONS(811),
    [anon_sym_nest] = ACTIONS(811),
    [anon_sym_returned] = ACTIONS(811),
    [anon_sym_nonnull] = ACTIONS(811),
    [anon_sym_dereferenceable] = ACTIONS(811),
    [anon_sym_dereferenceable_or_null] = ACTIONS(811),
    [anon_sym_swiftself] = ACTIONS(811),
    [anon_sym_swiftasync] = ACTIONS(811),
    [anon_sym_swifterror] = ACTIONS(811),
    [anon_sym_immarg] = ACTIONS(811),
    [anon_sym_noundef] = ACTIONS(811),
    [anon_sym_unreachable] = ACTIONS(811),
    [anon_sym_ret] = ACTIONS(811),
    [anon_sym_br] = ACTIONS(811),
    [anon_sym_resume] = ACTIONS(811),
    [anon_sym_freeze] = ACTIONS(811),
    [anon_sym_indirectbr] = ACTIONS(811),
    [anon_sym_extractelement] = ACTIONS(811),
    [anon_sym_insertelement] = ACTIONS(811),
    [anon_sym_select] = ACTIONS(811),
    [anon_sym_shufflevector] = ACTIONS(811),
    [anon_sym_fneg] = ACTIONS(811),
    [anon_sym_switch] = ACTIONS(811),
    [anon_sym_invoke] = ACTIONS(811),
    [anon_sym_cleanupret] = ACTIONS(811),
    [anon_sym_catchret] = ACTIONS(811),
    [anon_sym_catchswitch] = ACTIONS(811),
    [anon_sym_catchpad] = ACTIONS(811),
    [anon_sym_cleanuppad] = ACTIONS(811),
    [anon_sym_callbr] = ACTIONS(811),
    [anon_sym_icmp] = ACTIONS(811),
    [anon_sym_fcmp] = ACTIONS(811),
    [anon_sym_va_arg] = ACTIONS(811),
    [anon_sym_phi] = ACTIONS(811),
    [anon_sym_landingpad] = ACTIONS(811),
    [anon_sym_tail] = ACTIONS(811),
    [anon_sym_musttail] = ACTIONS(811),
    [anon_sym_notail] = ACTIONS(811),
    [anon_sym_call] = ACTIONS(811),
    [anon_sym_alloca] = ACTIONS(811),
    [anon_sym_load] = ACTIONS(811),
    [anon_sym_store] = ACTIONS(811),
    [anon_sym_cmpxchg] = ACTIONS(811),
    [anon_sym_atomicrmw] = ACTIONS(811),
    [anon_sym_fence] = ACTIONS(811),
    [anon_sym_getelementptr] = ACTIONS(811),
    [anon_sym_extractvalue] = ACTIONS(811),
    [anon_sym_insertvalue] = ACTIONS(811),
    [anon_sym_mul] = ACTIONS(811),
    [anon_sym_urem] = ACTIONS(811),
    [anon_sym_srem] = ACTIONS(811),
    [anon_sym_shl] = ACTIONS(811),
    [anon_sym_udiv] = ACTIONS(811),
    [anon_sym_sdiv] = ACTIONS(811),
    [anon_sym_lshr] = ACTIONS(811),
    [anon_sym_ashr] = ACTIONS(811),
    [anon_sym_fmul] = ACTIONS(811),
    [anon_sym_fdiv] = ACTIONS(811),
    [anon_sym_frem] = ACTIONS(811),
    [anon_sym_xchg] = ACTIONS(811),
    [anon_sym_add] = ACTIONS(811),
    [anon_sym_sub] = ACTIONS(811),
    [anon_sym_and] = ACTIONS(811),
    [anon_sym_nand] = ACTIONS(811),
    [anon_sym_or] = ACTIONS(811),
    [anon_sym_xor] = ACTIONS(811),
    [anon_sym_max] = ACTIONS(811),
    [anon_sym_min] = ACTIONS(811),
    [anon_sym_umax] = ACTIONS(811),
    [anon_sym_umin] = ACTIONS(811),
    [anon_sym_fadd] = ACTIONS(811),
    [anon_sym_fsub] = ACTIONS(811),
    [anon_sym_bitcast] = ACTIONS(811),
    [anon_sym_trunc] = ACTIONS(811),
    [anon_sym_zext] = ACTIONS(811),
    [anon_sym_sext] = ACTIONS(811),
    [anon_sym_fptrunc] = ACTIONS(811),
    [anon_sym_fpext] = ACTIONS(811),
    [anon_sym_addrspacecast] = ACTIONS(811),
    [anon_sym_uitofp] = ACTIONS(811),
    [anon_sym_sitofp] = ACTIONS(811),
    [anon_sym_fptoui] = ACTIONS(811),
    [anon_sym_fptosi] = ACTIONS(811),
    [anon_sym_inttoptr] = ACTIONS(811),
    [anon_sym_ptrtoint] = ACTIONS(811),
    [anon_sym_uselistorder] = ACTIONS(811),
  },
  [200] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [sym_label] = ACTIONS(795),
    [sym_string] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(797),
    [anon_sym_partition] = ACTIONS(797),
    [anon_sym_comdat] = ACTIONS(797),
    [anon_sym_gc] = ACTIONS(797),
    [anon_sym_prefix] = ACTIONS(797),
    [anon_sym_prologue] = ACTIONS(797),
    [anon_sym_personality] = ACTIONS(797),
    [anon_sym_alignstack] = ACTIONS(797),
    [anon_sym_allocsize] = ACTIONS(797),
    [anon_sym_alwaysinline] = ACTIONS(797),
    [anon_sym_builtin] = ACTIONS(797),
    [anon_sym_cold] = ACTIONS(797),
    [anon_sym_convergent] = ACTIONS(797),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(797),
    [anon_sym_hot] = ACTIONS(797),
    [anon_sym_inaccessiblememonly] = ACTIONS(797),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(797),
    [anon_sym_inlinehint] = ACTIONS(797),
    [anon_sym_jumptable] = ACTIONS(797),
    [anon_sym_minsize] = ACTIONS(797),
    [anon_sym_naked] = ACTIONS(797),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(797),
    [anon_sym_nobuiltin] = ACTIONS(797),
    [anon_sym_noduplicate] = ACTIONS(797),
    [anon_sym_nofree] = ACTIONS(797),
    [anon_sym_noimplicitfloat] = ACTIONS(797),
    [anon_sym_noinline] = ACTIONS(797),
    [anon_sym_nomerge] = ACTIONS(797),
    [anon_sym_nonlazybind] = ACTIONS(797),
    [anon_sym_noprofile] = ACTIONS(797),
    [anon_sym_noredzone] = ACTIONS(797),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(797),
    [anon_sym_noreturn] = ACTIONS(797),
    [anon_sym_norecurse] = ACTIONS(797),
    [anon_sym_willreturn] = ACTIONS(797),
    [anon_sym_nosync] = ACTIONS(797),
    [anon_sym_nounwind] = ACTIONS(797),
    [anon_sym_nosanitize_coverage] = ACTIONS(797),
    [anon_sym_null_pointer_is_valid] = ACTIONS(797),
    [anon_sym_optforfuzzing] = ACTIONS(797),
    [anon_sym_optnone] = ACTIONS(797),
    [anon_sym_optsize] = ACTIONS(797),
    [anon_sym_readnone] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_writeonly] = ACTIONS(797),
    [anon_sym_argmemonly] = ACTIONS(797),
    [anon_sym_returns_twice] = ACTIONS(797),
    [anon_sym_safestack] = ACTIONS(797),
    [anon_sym_sanitize_address] = ACTIONS(797),
    [anon_sym_sanitize_memory] = ACTIONS(797),
    [anon_sym_sanitize_thread] = ACTIONS(797),
    [anon_sym_sanitize_hwaddress] = ACTIONS(797),
    [anon_sym_sanitize_memtag] = ACTIONS(797),
    [anon_sym_speculative_load_hardening] = ACTIONS(797),
    [anon_sym_speculatable] = ACTIONS(797),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(797),
    [anon_sym_sspreq] = ACTIONS(797),
    [anon_sym_strictfp] = ACTIONS(797),
    [anon_sym_uwtable] = ACTIONS(797),
    [anon_sym_nocf_check] = ACTIONS(797),
    [anon_sym_shadowcallstack] = ACTIONS(797),
    [anon_sym_mustprogress] = ACTIONS(797),
    [anon_sym_vscale_range] = ACTIONS(797),
    [anon_sym_preallocated] = ACTIONS(797),
    [anon_sym_zeroext] = ACTIONS(797),
    [anon_sym_signext] = ACTIONS(797),
    [anon_sym_inreg] = ACTIONS(797),
    [anon_sym_byval] = ACTIONS(797),
    [anon_sym_byref] = ACTIONS(797),
    [anon_sym_inalloca] = ACTIONS(797),
    [anon_sym_sret] = ACTIONS(797),
    [anon_sym_elementtype] = ACTIONS(797),
    [anon_sym_noalias] = ACTIONS(797),
    [anon_sym_nocapture] = ACTIONS(797),
    [anon_sym_nest] = ACTIONS(797),
    [anon_sym_returned] = ACTIONS(797),
    [anon_sym_nonnull] = ACTIONS(797),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(797),
    [anon_sym_swiftself] = ACTIONS(797),
    [anon_sym_swiftasync] = ACTIONS(797),
    [anon_sym_swifterror] = ACTIONS(797),
    [anon_sym_immarg] = ACTIONS(797),
    [anon_sym_noundef] = ACTIONS(797),
    [anon_sym_unreachable] = ACTIONS(797),
    [anon_sym_ret] = ACTIONS(797),
    [anon_sym_br] = ACTIONS(797),
    [anon_sym_resume] = ACTIONS(797),
    [anon_sym_freeze] = ACTIONS(797),
    [anon_sym_indirectbr] = ACTIONS(797),
    [anon_sym_extractelement] = ACTIONS(797),
    [anon_sym_insertelement] = ACTIONS(797),
    [anon_sym_select] = ACTIONS(797),
    [anon_sym_shufflevector] = ACTIONS(797),
    [anon_sym_fneg] = ACTIONS(797),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_invoke] = ACTIONS(797),
    [anon_sym_cleanupret] = ACTIONS(797),
    [anon_sym_catchret] = ACTIONS(797),
    [anon_sym_catchswitch] = ACTIONS(797),
    [anon_sym_catchpad] = ACTIONS(797),
    [anon_sym_cleanuppad] = ACTIONS(797),
    [anon_sym_callbr] = ACTIONS(797),
    [anon_sym_icmp] = ACTIONS(797),
    [anon_sym_fcmp] = ACTIONS(797),
    [anon_sym_va_arg] = ACTIONS(797),
    [anon_sym_phi] = ACTIONS(797),
    [anon_sym_landingpad] = ACTIONS(797),
    [anon_sym_tail] = ACTIONS(797),
    [anon_sym_musttail] = ACTIONS(797),
    [anon_sym_notail] = ACTIONS(797),
    [anon_sym_call] = ACTIONS(797),
    [anon_sym_alloca] = ACTIONS(797),
    [anon_sym_load] = ACTIONS(797),
    [anon_sym_store] = ACTIONS(797),
    [anon_sym_cmpxchg] = ACTIONS(797),
    [anon_sym_atomicrmw] = ACTIONS(797),
    [anon_sym_fence] = ACTIONS(797),
    [anon_sym_getelementptr] = ACTIONS(797),
    [anon_sym_extractvalue] = ACTIONS(797),
    [anon_sym_insertvalue] = ACTIONS(797),
    [anon_sym_mul] = ACTIONS(797),
    [anon_sym_urem] = ACTIONS(797),
    [anon_sym_srem] = ACTIONS(797),
    [anon_sym_shl] = ACTIONS(797),
    [anon_sym_udiv] = ACTIONS(797),
    [anon_sym_sdiv] = ACTIONS(797),
    [anon_sym_lshr] = ACTIONS(797),
    [anon_sym_ashr] = ACTIONS(797),
    [anon_sym_fmul] = ACTIONS(797),
    [anon_sym_fdiv] = ACTIONS(797),
    [anon_sym_frem] = ACTIONS(797),
    [anon_sym_xchg] = ACTIONS(797),
    [anon_sym_add] = ACTIONS(797),
    [anon_sym_sub] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_nand] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_xor] = ACTIONS(797),
    [anon_sym_max] = ACTIONS(797),
    [anon_sym_min] = ACTIONS(797),
    [anon_sym_umax] = ACTIONS(797),
    [anon_sym_umin] = ACTIONS(797),
    [anon_sym_fadd] = ACTIONS(797),
    [anon_sym_fsub] = ACTIONS(797),
    [anon_sym_bitcast] = ACTIONS(797),
    [anon_sym_trunc] = ACTIONS(797),
    [anon_sym_zext] = ACTIONS(797),
    [anon_sym_sext] = ACTIONS(797),
    [anon_sym_fptrunc] = ACTIONS(797),
    [anon_sym_fpext] = ACTIONS(797),
    [anon_sym_addrspacecast] = ACTIONS(797),
    [anon_sym_uitofp] = ACTIONS(797),
    [anon_sym_sitofp] = ACTIONS(797),
    [anon_sym_fptoui] = ACTIONS(797),
    [anon_sym_fptosi] = ACTIONS(797),
    [anon_sym_inttoptr] = ACTIONS(797),
    [anon_sym_ptrtoint] = ACTIONS(797),
    [anon_sym_uselistorder] = ACTIONS(797),
  },
  [201] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [sym_label] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_align] = ACTIONS(305),
    [anon_sym_section] = ACTIONS(305),
    [anon_sym_partition] = ACTIONS(305),
    [anon_sym_comdat] = ACTIONS(305),
    [anon_sym_gc] = ACTIONS(305),
    [anon_sym_prefix] = ACTIONS(305),
    [anon_sym_prologue] = ACTIONS(305),
    [anon_sym_personality] = ACTIONS(305),
    [anon_sym_alignstack] = ACTIONS(305),
    [anon_sym_allocsize] = ACTIONS(305),
    [anon_sym_alwaysinline] = ACTIONS(305),
    [anon_sym_builtin] = ACTIONS(305),
    [anon_sym_cold] = ACTIONS(305),
    [anon_sym_convergent] = ACTIONS(305),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(305),
    [anon_sym_hot] = ACTIONS(305),
    [anon_sym_inaccessiblememonly] = ACTIONS(305),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(305),
    [anon_sym_inlinehint] = ACTIONS(305),
    [anon_sym_jumptable] = ACTIONS(305),
    [anon_sym_minsize] = ACTIONS(305),
    [anon_sym_naked] = ACTIONS(305),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(305),
    [anon_sym_nobuiltin] = ACTIONS(305),
    [anon_sym_noduplicate] = ACTIONS(305),
    [anon_sym_nofree] = ACTIONS(305),
    [anon_sym_noimplicitfloat] = ACTIONS(305),
    [anon_sym_noinline] = ACTIONS(305),
    [anon_sym_nomerge] = ACTIONS(305),
    [anon_sym_nonlazybind] = ACTIONS(305),
    [anon_sym_noprofile] = ACTIONS(305),
    [anon_sym_noredzone] = ACTIONS(305),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(305),
    [anon_sym_noreturn] = ACTIONS(305),
    [anon_sym_norecurse] = ACTIONS(305),
    [anon_sym_willreturn] = ACTIONS(305),
    [anon_sym_nosync] = ACTIONS(305),
    [anon_sym_nounwind] = ACTIONS(305),
    [anon_sym_nosanitize_coverage] = ACTIONS(305),
    [anon_sym_null_pointer_is_valid] = ACTIONS(305),
    [anon_sym_optforfuzzing] = ACTIONS(305),
    [anon_sym_optnone] = ACTIONS(305),
    [anon_sym_optsize] = ACTIONS(305),
    [anon_sym_readnone] = ACTIONS(305),
    [anon_sym_readonly] = ACTIONS(305),
    [anon_sym_writeonly] = ACTIONS(305),
    [anon_sym_argmemonly] = ACTIONS(305),
    [anon_sym_returns_twice] = ACTIONS(305),
    [anon_sym_safestack] = ACTIONS(305),
    [anon_sym_sanitize_address] = ACTIONS(305),
    [anon_sym_sanitize_memory] = ACTIONS(305),
    [anon_sym_sanitize_thread] = ACTIONS(305),
    [anon_sym_sanitize_hwaddress] = ACTIONS(305),
    [anon_sym_sanitize_memtag] = ACTIONS(305),
    [anon_sym_speculative_load_hardening] = ACTIONS(305),
    [anon_sym_speculatable] = ACTIONS(305),
    [anon_sym_ssp] = ACTIONS(305),
    [anon_sym_sspstrong] = ACTIONS(305),
    [anon_sym_sspreq] = ACTIONS(305),
    [anon_sym_strictfp] = ACTIONS(305),
    [anon_sym_uwtable] = ACTIONS(305),
    [anon_sym_nocf_check] = ACTIONS(305),
    [anon_sym_shadowcallstack] = ACTIONS(305),
    [anon_sym_mustprogress] = ACTIONS(305),
    [anon_sym_vscale_range] = ACTIONS(305),
    [anon_sym_preallocated] = ACTIONS(305),
    [anon_sym_zeroext] = ACTIONS(305),
    [anon_sym_signext] = ACTIONS(305),
    [anon_sym_inreg] = ACTIONS(305),
    [anon_sym_byval] = ACTIONS(305),
    [anon_sym_byref] = ACTIONS(305),
    [anon_sym_inalloca] = ACTIONS(305),
    [anon_sym_sret] = ACTIONS(305),
    [anon_sym_elementtype] = ACTIONS(305),
    [anon_sym_noalias] = ACTIONS(305),
    [anon_sym_nocapture] = ACTIONS(305),
    [anon_sym_nest] = ACTIONS(305),
    [anon_sym_returned] = ACTIONS(305),
    [anon_sym_nonnull] = ACTIONS(305),
    [anon_sym_dereferenceable] = ACTIONS(305),
    [anon_sym_dereferenceable_or_null] = ACTIONS(305),
    [anon_sym_swiftself] = ACTIONS(305),
    [anon_sym_swiftasync] = ACTIONS(305),
    [anon_sym_swifterror] = ACTIONS(305),
    [anon_sym_immarg] = ACTIONS(305),
    [anon_sym_noundef] = ACTIONS(305),
    [anon_sym_unreachable] = ACTIONS(305),
    [anon_sym_ret] = ACTIONS(305),
    [anon_sym_br] = ACTIONS(305),
    [anon_sym_resume] = ACTIONS(305),
    [anon_sym_freeze] = ACTIONS(305),
    [anon_sym_indirectbr] = ACTIONS(305),
    [anon_sym_extractelement] = ACTIONS(305),
    [anon_sym_insertelement] = ACTIONS(305),
    [anon_sym_select] = ACTIONS(305),
    [anon_sym_shufflevector] = ACTIONS(305),
    [anon_sym_fneg] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(305),
    [anon_sym_invoke] = ACTIONS(305),
    [anon_sym_cleanupret] = ACTIONS(305),
    [anon_sym_catchret] = ACTIONS(305),
    [anon_sym_catchswitch] = ACTIONS(305),
    [anon_sym_catchpad] = ACTIONS(305),
    [anon_sym_cleanuppad] = ACTIONS(305),
    [anon_sym_callbr] = ACTIONS(305),
    [anon_sym_icmp] = ACTIONS(305),
    [anon_sym_fcmp] = ACTIONS(305),
    [anon_sym_va_arg] = ACTIONS(305),
    [anon_sym_phi] = ACTIONS(305),
    [anon_sym_landingpad] = ACTIONS(305),
    [anon_sym_tail] = ACTIONS(305),
    [anon_sym_musttail] = ACTIONS(305),
    [anon_sym_notail] = ACTIONS(305),
    [anon_sym_call] = ACTIONS(305),
    [anon_sym_alloca] = ACTIONS(305),
    [anon_sym_load] = ACTIONS(305),
    [anon_sym_store] = ACTIONS(305),
    [anon_sym_cmpxchg] = ACTIONS(305),
    [anon_sym_atomicrmw] = ACTIONS(305),
    [anon_sym_fence] = ACTIONS(305),
    [anon_sym_getelementptr] = ACTIONS(305),
    [anon_sym_extractvalue] = ACTIONS(305),
    [anon_sym_insertvalue] = ACTIONS(305),
    [anon_sym_mul] = ACTIONS(305),
    [anon_sym_urem] = ACTIONS(305),
    [anon_sym_srem] = ACTIONS(305),
    [anon_sym_shl] = ACTIONS(305),
    [anon_sym_udiv] = ACTIONS(305),
    [anon_sym_sdiv] = ACTIONS(305),
    [anon_sym_lshr] = ACTIONS(305),
    [anon_sym_ashr] = ACTIONS(305),
    [anon_sym_fmul] = ACTIONS(305),
    [anon_sym_fdiv] = ACTIONS(305),
    [anon_sym_frem] = ACTIONS(305),
    [anon_sym_xchg] = ACTIONS(305),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(305),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_nand] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_xor] = ACTIONS(305),
    [anon_sym_max] = ACTIONS(305),
    [anon_sym_min] = ACTIONS(305),
    [anon_sym_umax] = ACTIONS(305),
    [anon_sym_umin] = ACTIONS(305),
    [anon_sym_fadd] = ACTIONS(305),
    [anon_sym_fsub] = ACTIONS(305),
    [anon_sym_bitcast] = ACTIONS(305),
    [anon_sym_trunc] = ACTIONS(305),
    [anon_sym_zext] = ACTIONS(305),
    [anon_sym_sext] = ACTIONS(305),
    [anon_sym_fptrunc] = ACTIONS(305),
    [anon_sym_fpext] = ACTIONS(305),
    [anon_sym_addrspacecast] = ACTIONS(305),
    [anon_sym_uitofp] = ACTIONS(305),
    [anon_sym_sitofp] = ACTIONS(305),
    [anon_sym_fptoui] = ACTIONS(305),
    [anon_sym_fptosi] = ACTIONS(305),
    [anon_sym_inttoptr] = ACTIONS(305),
    [anon_sym_ptrtoint] = ACTIONS(305),
    [anon_sym_uselistorder] = ACTIONS(305),
  },
  [202] = {
    [sym_linkage] = STATE(214),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_calling_conv] = STATE(368),
    [sym_unnamed_addr] = STATE(1019),
    [sym_type] = STATE(1553),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(366),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat1] = STATE(214),
    [aux_sym_function_header_repeat2] = STATE(366),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [sym_string] = ACTIONS(741),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [203] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(813),
    [sym_local_var] = ACTIONS(813),
    [sym_label] = ACTIONS(813),
    [sym_string] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_align] = ACTIONS(815),
    [anon_sym_section] = ACTIONS(815),
    [anon_sym_partition] = ACTIONS(815),
    [anon_sym_comdat] = ACTIONS(815),
    [anon_sym_gc] = ACTIONS(815),
    [anon_sym_prefix] = ACTIONS(815),
    [anon_sym_prologue] = ACTIONS(815),
    [anon_sym_personality] = ACTIONS(815),
    [anon_sym_alignstack] = ACTIONS(815),
    [anon_sym_allocsize] = ACTIONS(815),
    [anon_sym_alwaysinline] = ACTIONS(815),
    [anon_sym_builtin] = ACTIONS(815),
    [anon_sym_cold] = ACTIONS(815),
    [anon_sym_convergent] = ACTIONS(815),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(815),
    [anon_sym_hot] = ACTIONS(815),
    [anon_sym_inaccessiblememonly] = ACTIONS(815),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(815),
    [anon_sym_inlinehint] = ACTIONS(815),
    [anon_sym_jumptable] = ACTIONS(815),
    [anon_sym_minsize] = ACTIONS(815),
    [anon_sym_naked] = ACTIONS(815),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(815),
    [anon_sym_nobuiltin] = ACTIONS(815),
    [anon_sym_noduplicate] = ACTIONS(815),
    [anon_sym_nofree] = ACTIONS(815),
    [anon_sym_noimplicitfloat] = ACTIONS(815),
    [anon_sym_noinline] = ACTIONS(815),
    [anon_sym_nomerge] = ACTIONS(815),
    [anon_sym_nonlazybind] = ACTIONS(815),
    [anon_sym_noprofile] = ACTIONS(815),
    [anon_sym_noredzone] = ACTIONS(815),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(815),
    [anon_sym_noreturn] = ACTIONS(815),
    [anon_sym_norecurse] = ACTIONS(815),
    [anon_sym_willreturn] = ACTIONS(815),
    [anon_sym_nosync] = ACTIONS(815),
    [anon_sym_nounwind] = ACTIONS(815),
    [anon_sym_nosanitize_coverage] = ACTIONS(815),
    [anon_sym_null_pointer_is_valid] = ACTIONS(815),
    [anon_sym_optforfuzzing] = ACTIONS(815),
    [anon_sym_optnone] = ACTIONS(815),
    [anon_sym_optsize] = ACTIONS(815),
    [anon_sym_readnone] = ACTIONS(815),
    [anon_sym_readonly] = ACTIONS(815),
    [anon_sym_writeonly] = ACTIONS(815),
    [anon_sym_argmemonly] = ACTIONS(815),
    [anon_sym_returns_twice] = ACTIONS(815),
    [anon_sym_safestack] = ACTIONS(815),
    [anon_sym_sanitize_address] = ACTIONS(815),
    [anon_sym_sanitize_memory] = ACTIONS(815),
    [anon_sym_sanitize_thread] = ACTIONS(815),
    [anon_sym_sanitize_hwaddress] = ACTIONS(815),
    [anon_sym_sanitize_memtag] = ACTIONS(815),
    [anon_sym_speculative_load_hardening] = ACTIONS(815),
    [anon_sym_speculatable] = ACTIONS(815),
    [anon_sym_ssp] = ACTIONS(815),
    [anon_sym_sspstrong] = ACTIONS(815),
    [anon_sym_sspreq] = ACTIONS(815),
    [anon_sym_strictfp] = ACTIONS(815),
    [anon_sym_uwtable] = ACTIONS(815),
    [anon_sym_nocf_check] = ACTIONS(815),
    [anon_sym_shadowcallstack] = ACTIONS(815),
    [anon_sym_mustprogress] = ACTIONS(815),
    [anon_sym_vscale_range] = ACTIONS(815),
    [anon_sym_preallocated] = ACTIONS(815),
    [anon_sym_zeroext] = ACTIONS(815),
    [anon_sym_signext] = ACTIONS(815),
    [anon_sym_inreg] = ACTIONS(815),
    [anon_sym_byval] = ACTIONS(815),
    [anon_sym_byref] = ACTIONS(815),
    [anon_sym_inalloca] = ACTIONS(815),
    [anon_sym_sret] = ACTIONS(815),
    [anon_sym_elementtype] = ACTIONS(815),
    [anon_sym_noalias] = ACTIONS(815),
    [anon_sym_nocapture] = ACTIONS(815),
    [anon_sym_nest] = ACTIONS(815),
    [anon_sym_returned] = ACTIONS(815),
    [anon_sym_nonnull] = ACTIONS(815),
    [anon_sym_dereferenceable] = ACTIONS(815),
    [anon_sym_dereferenceable_or_null] = ACTIONS(815),
    [anon_sym_swiftself] = ACTIONS(815),
    [anon_sym_swiftasync] = ACTIONS(815),
    [anon_sym_swifterror] = ACTIONS(815),
    [anon_sym_immarg] = ACTIONS(815),
    [anon_sym_noundef] = ACTIONS(815),
    [anon_sym_unreachable] = ACTIONS(815),
    [anon_sym_ret] = ACTIONS(815),
    [anon_sym_br] = ACTIONS(815),
    [anon_sym_resume] = ACTIONS(815),
    [anon_sym_freeze] = ACTIONS(815),
    [anon_sym_indirectbr] = ACTIONS(815),
    [anon_sym_extractelement] = ACTIONS(815),
    [anon_sym_insertelement] = ACTIONS(815),
    [anon_sym_select] = ACTIONS(815),
    [anon_sym_shufflevector] = ACTIONS(815),
    [anon_sym_fneg] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_invoke] = ACTIONS(815),
    [anon_sym_cleanupret] = ACTIONS(815),
    [anon_sym_catchret] = ACTIONS(815),
    [anon_sym_catchswitch] = ACTIONS(815),
    [anon_sym_catchpad] = ACTIONS(815),
    [anon_sym_cleanuppad] = ACTIONS(815),
    [anon_sym_callbr] = ACTIONS(815),
    [anon_sym_icmp] = ACTIONS(815),
    [anon_sym_fcmp] = ACTIONS(815),
    [anon_sym_va_arg] = ACTIONS(815),
    [anon_sym_phi] = ACTIONS(815),
    [anon_sym_landingpad] = ACTIONS(815),
    [anon_sym_tail] = ACTIONS(815),
    [anon_sym_musttail] = ACTIONS(815),
    [anon_sym_notail] = ACTIONS(815),
    [anon_sym_call] = ACTIONS(815),
    [anon_sym_alloca] = ACTIONS(815),
    [anon_sym_load] = ACTIONS(815),
    [anon_sym_store] = ACTIONS(815),
    [anon_sym_cmpxchg] = ACTIONS(815),
    [anon_sym_atomicrmw] = ACTIONS(815),
    [anon_sym_fence] = ACTIONS(815),
    [anon_sym_getelementptr] = ACTIONS(815),
    [anon_sym_extractvalue] = ACTIONS(815),
    [anon_sym_insertvalue] = ACTIONS(815),
    [anon_sym_mul] = ACTIONS(815),
    [anon_sym_urem] = ACTIONS(815),
    [anon_sym_srem] = ACTIONS(815),
    [anon_sym_shl] = ACTIONS(815),
    [anon_sym_udiv] = ACTIONS(815),
    [anon_sym_sdiv] = ACTIONS(815),
    [anon_sym_lshr] = ACTIONS(815),
    [anon_sym_ashr] = ACTIONS(815),
    [anon_sym_fmul] = ACTIONS(815),
    [anon_sym_fdiv] = ACTIONS(815),
    [anon_sym_frem] = ACTIONS(815),
    [anon_sym_xchg] = ACTIONS(815),
    [anon_sym_add] = ACTIONS(815),
    [anon_sym_sub] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(815),
    [anon_sym_nand] = ACTIONS(815),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_xor] = ACTIONS(815),
    [anon_sym_max] = ACTIONS(815),
    [anon_sym_min] = ACTIONS(815),
    [anon_sym_umax] = ACTIONS(815),
    [anon_sym_umin] = ACTIONS(815),
    [anon_sym_fadd] = ACTIONS(815),
    [anon_sym_fsub] = ACTIONS(815),
    [anon_sym_bitcast] = ACTIONS(815),
    [anon_sym_trunc] = ACTIONS(815),
    [anon_sym_zext] = ACTIONS(815),
    [anon_sym_sext] = ACTIONS(815),
    [anon_sym_fptrunc] = ACTIONS(815),
    [anon_sym_fpext] = ACTIONS(815),
    [anon_sym_addrspacecast] = ACTIONS(815),
    [anon_sym_uitofp] = ACTIONS(815),
    [anon_sym_sitofp] = ACTIONS(815),
    [anon_sym_fptoui] = ACTIONS(815),
    [anon_sym_fptosi] = ACTIONS(815),
    [anon_sym_inttoptr] = ACTIONS(815),
    [anon_sym_ptrtoint] = ACTIONS(815),
    [anon_sym_uselistorder] = ACTIONS(815),
  },
  [204] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(817),
    [sym_local_var] = ACTIONS(817),
    [sym_label] = ACTIONS(817),
    [sym_string] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_align] = ACTIONS(819),
    [anon_sym_section] = ACTIONS(819),
    [anon_sym_partition] = ACTIONS(819),
    [anon_sym_comdat] = ACTIONS(819),
    [anon_sym_gc] = ACTIONS(819),
    [anon_sym_prefix] = ACTIONS(819),
    [anon_sym_prologue] = ACTIONS(819),
    [anon_sym_personality] = ACTIONS(819),
    [anon_sym_alignstack] = ACTIONS(819),
    [anon_sym_allocsize] = ACTIONS(819),
    [anon_sym_alwaysinline] = ACTIONS(819),
    [anon_sym_builtin] = ACTIONS(819),
    [anon_sym_cold] = ACTIONS(819),
    [anon_sym_convergent] = ACTIONS(819),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(819),
    [anon_sym_hot] = ACTIONS(819),
    [anon_sym_inaccessiblememonly] = ACTIONS(819),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(819),
    [anon_sym_inlinehint] = ACTIONS(819),
    [anon_sym_jumptable] = ACTIONS(819),
    [anon_sym_minsize] = ACTIONS(819),
    [anon_sym_naked] = ACTIONS(819),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(819),
    [anon_sym_nobuiltin] = ACTIONS(819),
    [anon_sym_noduplicate] = ACTIONS(819),
    [anon_sym_nofree] = ACTIONS(819),
    [anon_sym_noimplicitfloat] = ACTIONS(819),
    [anon_sym_noinline] = ACTIONS(819),
    [anon_sym_nomerge] = ACTIONS(819),
    [anon_sym_nonlazybind] = ACTIONS(819),
    [anon_sym_noprofile] = ACTIONS(819),
    [anon_sym_noredzone] = ACTIONS(819),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(819),
    [anon_sym_noreturn] = ACTIONS(819),
    [anon_sym_norecurse] = ACTIONS(819),
    [anon_sym_willreturn] = ACTIONS(819),
    [anon_sym_nosync] = ACTIONS(819),
    [anon_sym_nounwind] = ACTIONS(819),
    [anon_sym_nosanitize_coverage] = ACTIONS(819),
    [anon_sym_null_pointer_is_valid] = ACTIONS(819),
    [anon_sym_optforfuzzing] = ACTIONS(819),
    [anon_sym_optnone] = ACTIONS(819),
    [anon_sym_optsize] = ACTIONS(819),
    [anon_sym_readnone] = ACTIONS(819),
    [anon_sym_readonly] = ACTIONS(819),
    [anon_sym_writeonly] = ACTIONS(819),
    [anon_sym_argmemonly] = ACTIONS(819),
    [anon_sym_returns_twice] = ACTIONS(819),
    [anon_sym_safestack] = ACTIONS(819),
    [anon_sym_sanitize_address] = ACTIONS(819),
    [anon_sym_sanitize_memory] = ACTIONS(819),
    [anon_sym_sanitize_thread] = ACTIONS(819),
    [anon_sym_sanitize_hwaddress] = ACTIONS(819),
    [anon_sym_sanitize_memtag] = ACTIONS(819),
    [anon_sym_speculative_load_hardening] = ACTIONS(819),
    [anon_sym_speculatable] = ACTIONS(819),
    [anon_sym_ssp] = ACTIONS(819),
    [anon_sym_sspstrong] = ACTIONS(819),
    [anon_sym_sspreq] = ACTIONS(819),
    [anon_sym_strictfp] = ACTIONS(819),
    [anon_sym_uwtable] = ACTIONS(819),
    [anon_sym_nocf_check] = ACTIONS(819),
    [anon_sym_shadowcallstack] = ACTIONS(819),
    [anon_sym_mustprogress] = ACTIONS(819),
    [anon_sym_vscale_range] = ACTIONS(819),
    [anon_sym_preallocated] = ACTIONS(819),
    [anon_sym_zeroext] = ACTIONS(819),
    [anon_sym_signext] = ACTIONS(819),
    [anon_sym_inreg] = ACTIONS(819),
    [anon_sym_byval] = ACTIONS(819),
    [anon_sym_byref] = ACTIONS(819),
    [anon_sym_inalloca] = ACTIONS(819),
    [anon_sym_sret] = ACTIONS(819),
    [anon_sym_elementtype] = ACTIONS(819),
    [anon_sym_noalias] = ACTIONS(819),
    [anon_sym_nocapture] = ACTIONS(819),
    [anon_sym_nest] = ACTIONS(819),
    [anon_sym_returned] = ACTIONS(819),
    [anon_sym_nonnull] = ACTIONS(819),
    [anon_sym_dereferenceable] = ACTIONS(819),
    [anon_sym_dereferenceable_or_null] = ACTIONS(819),
    [anon_sym_swiftself] = ACTIONS(819),
    [anon_sym_swiftasync] = ACTIONS(819),
    [anon_sym_swifterror] = ACTIONS(819),
    [anon_sym_immarg] = ACTIONS(819),
    [anon_sym_noundef] = ACTIONS(819),
    [anon_sym_unreachable] = ACTIONS(819),
    [anon_sym_ret] = ACTIONS(819),
    [anon_sym_br] = ACTIONS(819),
    [anon_sym_resume] = ACTIONS(819),
    [anon_sym_freeze] = ACTIONS(819),
    [anon_sym_indirectbr] = ACTIONS(819),
    [anon_sym_extractelement] = ACTIONS(819),
    [anon_sym_insertelement] = ACTIONS(819),
    [anon_sym_select] = ACTIONS(819),
    [anon_sym_shufflevector] = ACTIONS(819),
    [anon_sym_fneg] = ACTIONS(819),
    [anon_sym_switch] = ACTIONS(819),
    [anon_sym_invoke] = ACTIONS(819),
    [anon_sym_cleanupret] = ACTIONS(819),
    [anon_sym_catchret] = ACTIONS(819),
    [anon_sym_catchswitch] = ACTIONS(819),
    [anon_sym_catchpad] = ACTIONS(819),
    [anon_sym_cleanuppad] = ACTIONS(819),
    [anon_sym_callbr] = ACTIONS(819),
    [anon_sym_icmp] = ACTIONS(819),
    [anon_sym_fcmp] = ACTIONS(819),
    [anon_sym_va_arg] = ACTIONS(819),
    [anon_sym_phi] = ACTIONS(819),
    [anon_sym_landingpad] = ACTIONS(819),
    [anon_sym_tail] = ACTIONS(819),
    [anon_sym_musttail] = ACTIONS(819),
    [anon_sym_notail] = ACTIONS(819),
    [anon_sym_call] = ACTIONS(819),
    [anon_sym_alloca] = ACTIONS(819),
    [anon_sym_load] = ACTIONS(819),
    [anon_sym_store] = ACTIONS(819),
    [anon_sym_cmpxchg] = ACTIONS(819),
    [anon_sym_atomicrmw] = ACTIONS(819),
    [anon_sym_fence] = ACTIONS(819),
    [anon_sym_getelementptr] = ACTIONS(819),
    [anon_sym_extractvalue] = ACTIONS(819),
    [anon_sym_insertvalue] = ACTIONS(819),
    [anon_sym_mul] = ACTIONS(819),
    [anon_sym_urem] = ACTIONS(819),
    [anon_sym_srem] = ACTIONS(819),
    [anon_sym_shl] = ACTIONS(819),
    [anon_sym_udiv] = ACTIONS(819),
    [anon_sym_sdiv] = ACTIONS(819),
    [anon_sym_lshr] = ACTIONS(819),
    [anon_sym_ashr] = ACTIONS(819),
    [anon_sym_fmul] = ACTIONS(819),
    [anon_sym_fdiv] = ACTIONS(819),
    [anon_sym_frem] = ACTIONS(819),
    [anon_sym_xchg] = ACTIONS(819),
    [anon_sym_add] = ACTIONS(819),
    [anon_sym_sub] = ACTIONS(819),
    [anon_sym_and] = ACTIONS(819),
    [anon_sym_nand] = ACTIONS(819),
    [anon_sym_or] = ACTIONS(819),
    [anon_sym_xor] = ACTIONS(819),
    [anon_sym_max] = ACTIONS(819),
    [anon_sym_min] = ACTIONS(819),
    [anon_sym_umax] = ACTIONS(819),
    [anon_sym_umin] = ACTIONS(819),
    [anon_sym_fadd] = ACTIONS(819),
    [anon_sym_fsub] = ACTIONS(819),
    [anon_sym_bitcast] = ACTIONS(819),
    [anon_sym_trunc] = ACTIONS(819),
    [anon_sym_zext] = ACTIONS(819),
    [anon_sym_sext] = ACTIONS(819),
    [anon_sym_fptrunc] = ACTIONS(819),
    [anon_sym_fpext] = ACTIONS(819),
    [anon_sym_addrspacecast] = ACTIONS(819),
    [anon_sym_uitofp] = ACTIONS(819),
    [anon_sym_sitofp] = ACTIONS(819),
    [anon_sym_fptoui] = ACTIONS(819),
    [anon_sym_fptosi] = ACTIONS(819),
    [anon_sym_inttoptr] = ACTIONS(819),
    [anon_sym_ptrtoint] = ACTIONS(819),
    [anon_sym_uselistorder] = ACTIONS(819),
  },
  [205] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_label] = ACTIONS(279),
    [sym_string] = ACTIONS(281),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_section] = ACTIONS(281),
    [anon_sym_partition] = ACTIONS(281),
    [anon_sym_comdat] = ACTIONS(281),
    [anon_sym_gc] = ACTIONS(281),
    [anon_sym_prefix] = ACTIONS(281),
    [anon_sym_prologue] = ACTIONS(281),
    [anon_sym_personality] = ACTIONS(281),
    [anon_sym_alignstack] = ACTIONS(281),
    [anon_sym_allocsize] = ACTIONS(281),
    [anon_sym_alwaysinline] = ACTIONS(281),
    [anon_sym_builtin] = ACTIONS(281),
    [anon_sym_cold] = ACTIONS(281),
    [anon_sym_convergent] = ACTIONS(281),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(281),
    [anon_sym_hot] = ACTIONS(281),
    [anon_sym_inaccessiblememonly] = ACTIONS(281),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(281),
    [anon_sym_inlinehint] = ACTIONS(281),
    [anon_sym_jumptable] = ACTIONS(281),
    [anon_sym_minsize] = ACTIONS(281),
    [anon_sym_naked] = ACTIONS(281),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(281),
    [anon_sym_nobuiltin] = ACTIONS(281),
    [anon_sym_noduplicate] = ACTIONS(281),
    [anon_sym_nofree] = ACTIONS(281),
    [anon_sym_noimplicitfloat] = ACTIONS(281),
    [anon_sym_noinline] = ACTIONS(281),
    [anon_sym_nomerge] = ACTIONS(281),
    [anon_sym_nonlazybind] = ACTIONS(281),
    [anon_sym_noprofile] = ACTIONS(281),
    [anon_sym_noredzone] = ACTIONS(281),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(281),
    [anon_sym_noreturn] = ACTIONS(281),
    [anon_sym_norecurse] = ACTIONS(281),
    [anon_sym_willreturn] = ACTIONS(281),
    [anon_sym_nosync] = ACTIONS(281),
    [anon_sym_nounwind] = ACTIONS(281),
    [anon_sym_nosanitize_coverage] = ACTIONS(281),
    [anon_sym_null_pointer_is_valid] = ACTIONS(281),
    [anon_sym_optforfuzzing] = ACTIONS(281),
    [anon_sym_optnone] = ACTIONS(281),
    [anon_sym_optsize] = ACTIONS(281),
    [anon_sym_readnone] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_writeonly] = ACTIONS(281),
    [anon_sym_argmemonly] = ACTIONS(281),
    [anon_sym_returns_twice] = ACTIONS(281),
    [anon_sym_safestack] = ACTIONS(281),
    [anon_sym_sanitize_address] = ACTIONS(281),
    [anon_sym_sanitize_memory] = ACTIONS(281),
    [anon_sym_sanitize_thread] = ACTIONS(281),
    [anon_sym_sanitize_hwaddress] = ACTIONS(281),
    [anon_sym_sanitize_memtag] = ACTIONS(281),
    [anon_sym_speculative_load_hardening] = ACTIONS(281),
    [anon_sym_speculatable] = ACTIONS(281),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(281),
    [anon_sym_sspreq] = ACTIONS(281),
    [anon_sym_strictfp] = ACTIONS(281),
    [anon_sym_uwtable] = ACTIONS(281),
    [anon_sym_nocf_check] = ACTIONS(281),
    [anon_sym_shadowcallstack] = ACTIONS(281),
    [anon_sym_mustprogress] = ACTIONS(281),
    [anon_sym_vscale_range] = ACTIONS(281),
    [anon_sym_preallocated] = ACTIONS(281),
    [anon_sym_zeroext] = ACTIONS(281),
    [anon_sym_signext] = ACTIONS(281),
    [anon_sym_inreg] = ACTIONS(281),
    [anon_sym_byval] = ACTIONS(281),
    [anon_sym_byref] = ACTIONS(281),
    [anon_sym_inalloca] = ACTIONS(281),
    [anon_sym_sret] = ACTIONS(281),
    [anon_sym_elementtype] = ACTIONS(281),
    [anon_sym_noalias] = ACTIONS(281),
    [anon_sym_nocapture] = ACTIONS(281),
    [anon_sym_nest] = ACTIONS(281),
    [anon_sym_returned] = ACTIONS(281),
    [anon_sym_nonnull] = ACTIONS(281),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(281),
    [anon_sym_swiftself] = ACTIONS(281),
    [anon_sym_swiftasync] = ACTIONS(281),
    [anon_sym_swifterror] = ACTIONS(281),
    [anon_sym_immarg] = ACTIONS(281),
    [anon_sym_noundef] = ACTIONS(281),
    [anon_sym_unreachable] = ACTIONS(281),
    [anon_sym_ret] = ACTIONS(281),
    [anon_sym_br] = ACTIONS(281),
    [anon_sym_resume] = ACTIONS(281),
    [anon_sym_freeze] = ACTIONS(281),
    [anon_sym_indirectbr] = ACTIONS(281),
    [anon_sym_extractelement] = ACTIONS(281),
    [anon_sym_insertelement] = ACTIONS(281),
    [anon_sym_select] = ACTIONS(281),
    [anon_sym_shufflevector] = ACTIONS(281),
    [anon_sym_fneg] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_invoke] = ACTIONS(281),
    [anon_sym_cleanupret] = ACTIONS(281),
    [anon_sym_catchret] = ACTIONS(281),
    [anon_sym_catchswitch] = ACTIONS(281),
    [anon_sym_catchpad] = ACTIONS(281),
    [anon_sym_cleanuppad] = ACTIONS(281),
    [anon_sym_callbr] = ACTIONS(281),
    [anon_sym_icmp] = ACTIONS(281),
    [anon_sym_fcmp] = ACTIONS(281),
    [anon_sym_va_arg] = ACTIONS(281),
    [anon_sym_phi] = ACTIONS(281),
    [anon_sym_landingpad] = ACTIONS(281),
    [anon_sym_tail] = ACTIONS(281),
    [anon_sym_musttail] = ACTIONS(281),
    [anon_sym_notail] = ACTIONS(281),
    [anon_sym_call] = ACTIONS(281),
    [anon_sym_alloca] = ACTIONS(281),
    [anon_sym_load] = ACTIONS(281),
    [anon_sym_store] = ACTIONS(281),
    [anon_sym_cmpxchg] = ACTIONS(281),
    [anon_sym_atomicrmw] = ACTIONS(281),
    [anon_sym_fence] = ACTIONS(281),
    [anon_sym_getelementptr] = ACTIONS(281),
    [anon_sym_extractvalue] = ACTIONS(281),
    [anon_sym_insertvalue] = ACTIONS(281),
    [anon_sym_mul] = ACTIONS(281),
    [anon_sym_urem] = ACTIONS(281),
    [anon_sym_srem] = ACTIONS(281),
    [anon_sym_shl] = ACTIONS(281),
    [anon_sym_udiv] = ACTIONS(281),
    [anon_sym_sdiv] = ACTIONS(281),
    [anon_sym_lshr] = ACTIONS(281),
    [anon_sym_ashr] = ACTIONS(281),
    [anon_sym_fmul] = ACTIONS(281),
    [anon_sym_fdiv] = ACTIONS(281),
    [anon_sym_frem] = ACTIONS(281),
    [anon_sym_xchg] = ACTIONS(281),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(281),
    [anon_sym_nand] = ACTIONS(281),
    [anon_sym_or] = ACTIONS(281),
    [anon_sym_xor] = ACTIONS(281),
    [anon_sym_max] = ACTIONS(281),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(281),
    [anon_sym_umin] = ACTIONS(281),
    [anon_sym_fadd] = ACTIONS(281),
    [anon_sym_fsub] = ACTIONS(281),
    [anon_sym_bitcast] = ACTIONS(281),
    [anon_sym_trunc] = ACTIONS(281),
    [anon_sym_zext] = ACTIONS(281),
    [anon_sym_sext] = ACTIONS(281),
    [anon_sym_fptrunc] = ACTIONS(281),
    [anon_sym_fpext] = ACTIONS(281),
    [anon_sym_addrspacecast] = ACTIONS(281),
    [anon_sym_uitofp] = ACTIONS(281),
    [anon_sym_sitofp] = ACTIONS(281),
    [anon_sym_fptoui] = ACTIONS(281),
    [anon_sym_fptosi] = ACTIONS(281),
    [anon_sym_inttoptr] = ACTIONS(281),
    [anon_sym_ptrtoint] = ACTIONS(281),
    [anon_sym_uselistorder] = ACTIONS(281),
  },
  [206] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(821),
    [sym_local_var] = ACTIONS(821),
    [sym_label] = ACTIONS(821),
    [sym_string] = ACTIONS(823),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_align] = ACTIONS(823),
    [anon_sym_section] = ACTIONS(823),
    [anon_sym_partition] = ACTIONS(823),
    [anon_sym_comdat] = ACTIONS(823),
    [anon_sym_gc] = ACTIONS(823),
    [anon_sym_prefix] = ACTIONS(823),
    [anon_sym_prologue] = ACTIONS(823),
    [anon_sym_personality] = ACTIONS(823),
    [anon_sym_alignstack] = ACTIONS(823),
    [anon_sym_allocsize] = ACTIONS(823),
    [anon_sym_alwaysinline] = ACTIONS(823),
    [anon_sym_builtin] = ACTIONS(823),
    [anon_sym_cold] = ACTIONS(823),
    [anon_sym_convergent] = ACTIONS(823),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(823),
    [anon_sym_hot] = ACTIONS(823),
    [anon_sym_inaccessiblememonly] = ACTIONS(823),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(823),
    [anon_sym_inlinehint] = ACTIONS(823),
    [anon_sym_jumptable] = ACTIONS(823),
    [anon_sym_minsize] = ACTIONS(823),
    [anon_sym_naked] = ACTIONS(823),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(823),
    [anon_sym_nobuiltin] = ACTIONS(823),
    [anon_sym_noduplicate] = ACTIONS(823),
    [anon_sym_nofree] = ACTIONS(823),
    [anon_sym_noimplicitfloat] = ACTIONS(823),
    [anon_sym_noinline] = ACTIONS(823),
    [anon_sym_nomerge] = ACTIONS(823),
    [anon_sym_nonlazybind] = ACTIONS(823),
    [anon_sym_noprofile] = ACTIONS(823),
    [anon_sym_noredzone] = ACTIONS(823),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(823),
    [anon_sym_noreturn] = ACTIONS(823),
    [anon_sym_norecurse] = ACTIONS(823),
    [anon_sym_willreturn] = ACTIONS(823),
    [anon_sym_nosync] = ACTIONS(823),
    [anon_sym_nounwind] = ACTIONS(823),
    [anon_sym_nosanitize_coverage] = ACTIONS(823),
    [anon_sym_null_pointer_is_valid] = ACTIONS(823),
    [anon_sym_optforfuzzing] = ACTIONS(823),
    [anon_sym_optnone] = ACTIONS(823),
    [anon_sym_optsize] = ACTIONS(823),
    [anon_sym_readnone] = ACTIONS(823),
    [anon_sym_readonly] = ACTIONS(823),
    [anon_sym_writeonly] = ACTIONS(823),
    [anon_sym_argmemonly] = ACTIONS(823),
    [anon_sym_returns_twice] = ACTIONS(823),
    [anon_sym_safestack] = ACTIONS(823),
    [anon_sym_sanitize_address] = ACTIONS(823),
    [anon_sym_sanitize_memory] = ACTIONS(823),
    [anon_sym_sanitize_thread] = ACTIONS(823),
    [anon_sym_sanitize_hwaddress] = ACTIONS(823),
    [anon_sym_sanitize_memtag] = ACTIONS(823),
    [anon_sym_speculative_load_hardening] = ACTIONS(823),
    [anon_sym_speculatable] = ACTIONS(823),
    [anon_sym_ssp] = ACTIONS(823),
    [anon_sym_sspstrong] = ACTIONS(823),
    [anon_sym_sspreq] = ACTIONS(823),
    [anon_sym_strictfp] = ACTIONS(823),
    [anon_sym_uwtable] = ACTIONS(823),
    [anon_sym_nocf_check] = ACTIONS(823),
    [anon_sym_shadowcallstack] = ACTIONS(823),
    [anon_sym_mustprogress] = ACTIONS(823),
    [anon_sym_vscale_range] = ACTIONS(823),
    [anon_sym_preallocated] = ACTIONS(823),
    [anon_sym_zeroext] = ACTIONS(823),
    [anon_sym_signext] = ACTIONS(823),
    [anon_sym_inreg] = ACTIONS(823),
    [anon_sym_byval] = ACTIONS(823),
    [anon_sym_byref] = ACTIONS(823),
    [anon_sym_inalloca] = ACTIONS(823),
    [anon_sym_sret] = ACTIONS(823),
    [anon_sym_elementtype] = ACTIONS(823),
    [anon_sym_noalias] = ACTIONS(823),
    [anon_sym_nocapture] = ACTIONS(823),
    [anon_sym_nest] = ACTIONS(823),
    [anon_sym_returned] = ACTIONS(823),
    [anon_sym_nonnull] = ACTIONS(823),
    [anon_sym_dereferenceable] = ACTIONS(823),
    [anon_sym_dereferenceable_or_null] = ACTIONS(823),
    [anon_sym_swiftself] = ACTIONS(823),
    [anon_sym_swiftasync] = ACTIONS(823),
    [anon_sym_swifterror] = ACTIONS(823),
    [anon_sym_immarg] = ACTIONS(823),
    [anon_sym_noundef] = ACTIONS(823),
    [anon_sym_unreachable] = ACTIONS(823),
    [anon_sym_ret] = ACTIONS(823),
    [anon_sym_br] = ACTIONS(823),
    [anon_sym_resume] = ACTIONS(823),
    [anon_sym_freeze] = ACTIONS(823),
    [anon_sym_indirectbr] = ACTIONS(823),
    [anon_sym_extractelement] = ACTIONS(823),
    [anon_sym_insertelement] = ACTIONS(823),
    [anon_sym_select] = ACTIONS(823),
    [anon_sym_shufflevector] = ACTIONS(823),
    [anon_sym_fneg] = ACTIONS(823),
    [anon_sym_switch] = ACTIONS(823),
    [anon_sym_invoke] = ACTIONS(823),
    [anon_sym_cleanupret] = ACTIONS(823),
    [anon_sym_catchret] = ACTIONS(823),
    [anon_sym_catchswitch] = ACTIONS(823),
    [anon_sym_catchpad] = ACTIONS(823),
    [anon_sym_cleanuppad] = ACTIONS(823),
    [anon_sym_callbr] = ACTIONS(823),
    [anon_sym_icmp] = ACTIONS(823),
    [anon_sym_fcmp] = ACTIONS(823),
    [anon_sym_va_arg] = ACTIONS(823),
    [anon_sym_phi] = ACTIONS(823),
    [anon_sym_landingpad] = ACTIONS(823),
    [anon_sym_tail] = ACTIONS(823),
    [anon_sym_musttail] = ACTIONS(823),
    [anon_sym_notail] = ACTIONS(823),
    [anon_sym_call] = ACTIONS(823),
    [anon_sym_alloca] = ACTIONS(823),
    [anon_sym_load] = ACTIONS(823),
    [anon_sym_store] = ACTIONS(823),
    [anon_sym_cmpxchg] = ACTIONS(823),
    [anon_sym_atomicrmw] = ACTIONS(823),
    [anon_sym_fence] = ACTIONS(823),
    [anon_sym_getelementptr] = ACTIONS(823),
    [anon_sym_extractvalue] = ACTIONS(823),
    [anon_sym_insertvalue] = ACTIONS(823),
    [anon_sym_mul] = ACTIONS(823),
    [anon_sym_urem] = ACTIONS(823),
    [anon_sym_srem] = ACTIONS(823),
    [anon_sym_shl] = ACTIONS(823),
    [anon_sym_udiv] = ACTIONS(823),
    [anon_sym_sdiv] = ACTIONS(823),
    [anon_sym_lshr] = ACTIONS(823),
    [anon_sym_ashr] = ACTIONS(823),
    [anon_sym_fmul] = ACTIONS(823),
    [anon_sym_fdiv] = ACTIONS(823),
    [anon_sym_frem] = ACTIONS(823),
    [anon_sym_xchg] = ACTIONS(823),
    [anon_sym_add] = ACTIONS(823),
    [anon_sym_sub] = ACTIONS(823),
    [anon_sym_and] = ACTIONS(823),
    [anon_sym_nand] = ACTIONS(823),
    [anon_sym_or] = ACTIONS(823),
    [anon_sym_xor] = ACTIONS(823),
    [anon_sym_max] = ACTIONS(823),
    [anon_sym_min] = ACTIONS(823),
    [anon_sym_umax] = ACTIONS(823),
    [anon_sym_umin] = ACTIONS(823),
    [anon_sym_fadd] = ACTIONS(823),
    [anon_sym_fsub] = ACTIONS(823),
    [anon_sym_bitcast] = ACTIONS(823),
    [anon_sym_trunc] = ACTIONS(823),
    [anon_sym_zext] = ACTIONS(823),
    [anon_sym_sext] = ACTIONS(823),
    [anon_sym_fptrunc] = ACTIONS(823),
    [anon_sym_fpext] = ACTIONS(823),
    [anon_sym_addrspacecast] = ACTIONS(823),
    [anon_sym_uitofp] = ACTIONS(823),
    [anon_sym_sitofp] = ACTIONS(823),
    [anon_sym_fptoui] = ACTIONS(823),
    [anon_sym_fptosi] = ACTIONS(823),
    [anon_sym_inttoptr] = ACTIONS(823),
    [anon_sym_ptrtoint] = ACTIONS(823),
    [anon_sym_uselistorder] = ACTIONS(823),
  },
  [207] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(825),
    [sym_local_var] = ACTIONS(825),
    [sym_label] = ACTIONS(825),
    [sym_string] = ACTIONS(827),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_align] = ACTIONS(827),
    [anon_sym_section] = ACTIONS(827),
    [anon_sym_partition] = ACTIONS(827),
    [anon_sym_comdat] = ACTIONS(827),
    [anon_sym_gc] = ACTIONS(827),
    [anon_sym_prefix] = ACTIONS(827),
    [anon_sym_prologue] = ACTIONS(827),
    [anon_sym_personality] = ACTIONS(827),
    [anon_sym_alignstack] = ACTIONS(827),
    [anon_sym_allocsize] = ACTIONS(827),
    [anon_sym_alwaysinline] = ACTIONS(827),
    [anon_sym_builtin] = ACTIONS(827),
    [anon_sym_cold] = ACTIONS(827),
    [anon_sym_convergent] = ACTIONS(827),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(827),
    [anon_sym_hot] = ACTIONS(827),
    [anon_sym_inaccessiblememonly] = ACTIONS(827),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(827),
    [anon_sym_inlinehint] = ACTIONS(827),
    [anon_sym_jumptable] = ACTIONS(827),
    [anon_sym_minsize] = ACTIONS(827),
    [anon_sym_naked] = ACTIONS(827),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(827),
    [anon_sym_nobuiltin] = ACTIONS(827),
    [anon_sym_noduplicate] = ACTIONS(827),
    [anon_sym_nofree] = ACTIONS(827),
    [anon_sym_noimplicitfloat] = ACTIONS(827),
    [anon_sym_noinline] = ACTIONS(827),
    [anon_sym_nomerge] = ACTIONS(827),
    [anon_sym_nonlazybind] = ACTIONS(827),
    [anon_sym_noprofile] = ACTIONS(827),
    [anon_sym_noredzone] = ACTIONS(827),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(827),
    [anon_sym_noreturn] = ACTIONS(827),
    [anon_sym_norecurse] = ACTIONS(827),
    [anon_sym_willreturn] = ACTIONS(827),
    [anon_sym_nosync] = ACTIONS(827),
    [anon_sym_nounwind] = ACTIONS(827),
    [anon_sym_nosanitize_coverage] = ACTIONS(827),
    [anon_sym_null_pointer_is_valid] = ACTIONS(827),
    [anon_sym_optforfuzzing] = ACTIONS(827),
    [anon_sym_optnone] = ACTIONS(827),
    [anon_sym_optsize] = ACTIONS(827),
    [anon_sym_readnone] = ACTIONS(827),
    [anon_sym_readonly] = ACTIONS(827),
    [anon_sym_writeonly] = ACTIONS(827),
    [anon_sym_argmemonly] = ACTIONS(827),
    [anon_sym_returns_twice] = ACTIONS(827),
    [anon_sym_safestack] = ACTIONS(827),
    [anon_sym_sanitize_address] = ACTIONS(827),
    [anon_sym_sanitize_memory] = ACTIONS(827),
    [anon_sym_sanitize_thread] = ACTIONS(827),
    [anon_sym_sanitize_hwaddress] = ACTIONS(827),
    [anon_sym_sanitize_memtag] = ACTIONS(827),
    [anon_sym_speculative_load_hardening] = ACTIONS(827),
    [anon_sym_speculatable] = ACTIONS(827),
    [anon_sym_ssp] = ACTIONS(827),
    [anon_sym_sspstrong] = ACTIONS(827),
    [anon_sym_sspreq] = ACTIONS(827),
    [anon_sym_strictfp] = ACTIONS(827),
    [anon_sym_uwtable] = ACTIONS(827),
    [anon_sym_nocf_check] = ACTIONS(827),
    [anon_sym_shadowcallstack] = ACTIONS(827),
    [anon_sym_mustprogress] = ACTIONS(827),
    [anon_sym_vscale_range] = ACTIONS(827),
    [anon_sym_preallocated] = ACTIONS(827),
    [anon_sym_zeroext] = ACTIONS(827),
    [anon_sym_signext] = ACTIONS(827),
    [anon_sym_inreg] = ACTIONS(827),
    [anon_sym_byval] = ACTIONS(827),
    [anon_sym_byref] = ACTIONS(827),
    [anon_sym_inalloca] = ACTIONS(827),
    [anon_sym_sret] = ACTIONS(827),
    [anon_sym_elementtype] = ACTIONS(827),
    [anon_sym_noalias] = ACTIONS(827),
    [anon_sym_nocapture] = ACTIONS(827),
    [anon_sym_nest] = ACTIONS(827),
    [anon_sym_returned] = ACTIONS(827),
    [anon_sym_nonnull] = ACTIONS(827),
    [anon_sym_dereferenceable] = ACTIONS(827),
    [anon_sym_dereferenceable_or_null] = ACTIONS(827),
    [anon_sym_swiftself] = ACTIONS(827),
    [anon_sym_swiftasync] = ACTIONS(827),
    [anon_sym_swifterror] = ACTIONS(827),
    [anon_sym_immarg] = ACTIONS(827),
    [anon_sym_noundef] = ACTIONS(827),
    [anon_sym_unreachable] = ACTIONS(827),
    [anon_sym_ret] = ACTIONS(827),
    [anon_sym_br] = ACTIONS(827),
    [anon_sym_resume] = ACTIONS(827),
    [anon_sym_freeze] = ACTIONS(827),
    [anon_sym_indirectbr] = ACTIONS(827),
    [anon_sym_extractelement] = ACTIONS(827),
    [anon_sym_insertelement] = ACTIONS(827),
    [anon_sym_select] = ACTIONS(827),
    [anon_sym_shufflevector] = ACTIONS(827),
    [anon_sym_fneg] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_invoke] = ACTIONS(827),
    [anon_sym_cleanupret] = ACTIONS(827),
    [anon_sym_catchret] = ACTIONS(827),
    [anon_sym_catchswitch] = ACTIONS(827),
    [anon_sym_catchpad] = ACTIONS(827),
    [anon_sym_cleanuppad] = ACTIONS(827),
    [anon_sym_callbr] = ACTIONS(827),
    [anon_sym_icmp] = ACTIONS(827),
    [anon_sym_fcmp] = ACTIONS(827),
    [anon_sym_va_arg] = ACTIONS(827),
    [anon_sym_phi] = ACTIONS(827),
    [anon_sym_landingpad] = ACTIONS(827),
    [anon_sym_tail] = ACTIONS(827),
    [anon_sym_musttail] = ACTIONS(827),
    [anon_sym_notail] = ACTIONS(827),
    [anon_sym_call] = ACTIONS(827),
    [anon_sym_alloca] = ACTIONS(827),
    [anon_sym_load] = ACTIONS(827),
    [anon_sym_store] = ACTIONS(827),
    [anon_sym_cmpxchg] = ACTIONS(827),
    [anon_sym_atomicrmw] = ACTIONS(827),
    [anon_sym_fence] = ACTIONS(827),
    [anon_sym_getelementptr] = ACTIONS(827),
    [anon_sym_extractvalue] = ACTIONS(827),
    [anon_sym_insertvalue] = ACTIONS(827),
    [anon_sym_mul] = ACTIONS(827),
    [anon_sym_urem] = ACTIONS(827),
    [anon_sym_srem] = ACTIONS(827),
    [anon_sym_shl] = ACTIONS(827),
    [anon_sym_udiv] = ACTIONS(827),
    [anon_sym_sdiv] = ACTIONS(827),
    [anon_sym_lshr] = ACTIONS(827),
    [anon_sym_ashr] = ACTIONS(827),
    [anon_sym_fmul] = ACTIONS(827),
    [anon_sym_fdiv] = ACTIONS(827),
    [anon_sym_frem] = ACTIONS(827),
    [anon_sym_xchg] = ACTIONS(827),
    [anon_sym_add] = ACTIONS(827),
    [anon_sym_sub] = ACTIONS(827),
    [anon_sym_and] = ACTIONS(827),
    [anon_sym_nand] = ACTIONS(827),
    [anon_sym_or] = ACTIONS(827),
    [anon_sym_xor] = ACTIONS(827),
    [anon_sym_max] = ACTIONS(827),
    [anon_sym_min] = ACTIONS(827),
    [anon_sym_umax] = ACTIONS(827),
    [anon_sym_umin] = ACTIONS(827),
    [anon_sym_fadd] = ACTIONS(827),
    [anon_sym_fsub] = ACTIONS(827),
    [anon_sym_bitcast] = ACTIONS(827),
    [anon_sym_trunc] = ACTIONS(827),
    [anon_sym_zext] = ACTIONS(827),
    [anon_sym_sext] = ACTIONS(827),
    [anon_sym_fptrunc] = ACTIONS(827),
    [anon_sym_fpext] = ACTIONS(827),
    [anon_sym_addrspacecast] = ACTIONS(827),
    [anon_sym_uitofp] = ACTIONS(827),
    [anon_sym_sitofp] = ACTIONS(827),
    [anon_sym_fptoui] = ACTIONS(827),
    [anon_sym_fptosi] = ACTIONS(827),
    [anon_sym_inttoptr] = ACTIONS(827),
    [anon_sym_ptrtoint] = ACTIONS(827),
    [anon_sym_uselistorder] = ACTIONS(827),
  },
  [208] = {
    [sym_linkage] = STATE(214),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_calling_conv] = STATE(365),
    [sym_unnamed_addr] = STATE(1028),
    [sym_type] = STATE(1641),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(369),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat1] = STATE(214),
    [aux_sym_function_header_repeat2] = STATE(369),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [sym_string] = ACTIONS(741),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [209] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(829),
    [sym_local_var] = ACTIONS(829),
    [sym_string] = ACTIONS(829),
    [aux_sym_number_token1] = ACTIONS(831),
    [aux_sym_number_token2] = ACTIONS(829),
    [sym_float] = ACTIONS(829),
    [sym_cstring] = ACTIONS(829),
    [anon_sym_no_cfi] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_internal] = ACTIONS(829),
    [anon_sym_weak] = ACTIONS(831),
    [anon_sym_weak_odr] = ACTIONS(829),
    [anon_sym_linkonce] = ACTIONS(831),
    [anon_sym_linkonce_odr] = ACTIONS(829),
    [anon_sym_available_externally] = ACTIONS(829),
    [anon_sym_appending] = ACTIONS(829),
    [anon_sym_common] = ACTIONS(829),
    [anon_sym_extern_weak] = ACTIONS(829),
    [anon_sym_external] = ACTIONS(829),
    [anon_sym_dso_local] = ACTIONS(831),
    [anon_sym_dso_local_equivalent] = ACTIONS(829),
    [anon_sym_dso_preemptable] = ACTIONS(829),
    [anon_sym_default] = ACTIONS(829),
    [anon_sym_hidden] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_dllimport] = ACTIONS(829),
    [anon_sym_dllexport] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_LT_LBRACE] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(829),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_align] = ACTIONS(831),
    [anon_sym_alignstack] = ACTIONS(829),
    [anon_sym_allocsize] = ACTIONS(829),
    [anon_sym_alwaysinline] = ACTIONS(829),
    [anon_sym_builtin] = ACTIONS(829),
    [anon_sym_cold] = ACTIONS(829),
    [anon_sym_convergent] = ACTIONS(829),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(829),
    [anon_sym_hot] = ACTIONS(829),
    [anon_sym_inaccessiblememonly] = ACTIONS(829),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(829),
    [anon_sym_inlinehint] = ACTIONS(829),
    [anon_sym_jumptable] = ACTIONS(829),
    [anon_sym_minsize] = ACTIONS(829),
    [anon_sym_naked] = ACTIONS(829),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(829),
    [anon_sym_nobuiltin] = ACTIONS(829),
    [anon_sym_noduplicate] = ACTIONS(829),
    [anon_sym_nofree] = ACTIONS(829),
    [anon_sym_noimplicitfloat] = ACTIONS(829),
    [anon_sym_noinline] = ACTIONS(829),
    [anon_sym_nomerge] = ACTIONS(829),
    [anon_sym_nonlazybind] = ACTIONS(829),
    [anon_sym_noprofile] = ACTIONS(829),
    [anon_sym_noredzone] = ACTIONS(829),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(829),
    [anon_sym_noreturn] = ACTIONS(829),
    [anon_sym_norecurse] = ACTIONS(829),
    [anon_sym_willreturn] = ACTIONS(829),
    [anon_sym_nosync] = ACTIONS(829),
    [anon_sym_nounwind] = ACTIONS(829),
    [anon_sym_nosanitize_coverage] = ACTIONS(829),
    [anon_sym_null_pointer_is_valid] = ACTIONS(829),
    [anon_sym_optforfuzzing] = ACTIONS(829),
    [anon_sym_optnone] = ACTIONS(829),
    [anon_sym_optsize] = ACTIONS(829),
    [anon_sym_readnone] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_writeonly] = ACTIONS(829),
    [anon_sym_argmemonly] = ACTIONS(829),
    [anon_sym_returns_twice] = ACTIONS(829),
    [anon_sym_safestack] = ACTIONS(829),
    [anon_sym_sanitize_address] = ACTIONS(829),
    [anon_sym_sanitize_memory] = ACTIONS(829),
    [anon_sym_sanitize_thread] = ACTIONS(829),
    [anon_sym_sanitize_hwaddress] = ACTIONS(829),
    [anon_sym_sanitize_memtag] = ACTIONS(829),
    [anon_sym_speculative_load_hardening] = ACTIONS(829),
    [anon_sym_speculatable] = ACTIONS(829),
    [anon_sym_ssp] = ACTIONS(831),
    [anon_sym_sspstrong] = ACTIONS(829),
    [anon_sym_sspreq] = ACTIONS(829),
    [anon_sym_strictfp] = ACTIONS(829),
    [anon_sym_uwtable] = ACTIONS(829),
    [anon_sym_nocf_check] = ACTIONS(829),
    [anon_sym_shadowcallstack] = ACTIONS(829),
    [anon_sym_mustprogress] = ACTIONS(829),
    [anon_sym_vscale_range] = ACTIONS(829),
    [anon_sym_preallocated] = ACTIONS(829),
    [anon_sym_zeroext] = ACTIONS(829),
    [anon_sym_signext] = ACTIONS(829),
    [anon_sym_inreg] = ACTIONS(829),
    [anon_sym_byval] = ACTIONS(829),
    [anon_sym_byref] = ACTIONS(829),
    [anon_sym_inalloca] = ACTIONS(829),
    [anon_sym_sret] = ACTIONS(829),
    [anon_sym_elementtype] = ACTIONS(829),
    [anon_sym_noalias] = ACTIONS(829),
    [anon_sym_nocapture] = ACTIONS(829),
    [anon_sym_nest] = ACTIONS(829),
    [anon_sym_returned] = ACTIONS(829),
    [anon_sym_nonnull] = ACTIONS(829),
    [anon_sym_dereferenceable] = ACTIONS(831),
    [anon_sym_dereferenceable_or_null] = ACTIONS(829),
    [anon_sym_swiftself] = ACTIONS(829),
    [anon_sym_swiftasync] = ACTIONS(829),
    [anon_sym_swifterror] = ACTIONS(829),
    [anon_sym_immarg] = ACTIONS(829),
    [anon_sym_noundef] = ACTIONS(829),
    [anon_sym_extractelement] = ACTIONS(829),
    [anon_sym_insertelement] = ACTIONS(829),
    [anon_sym_select] = ACTIONS(829),
    [anon_sym_shufflevector] = ACTIONS(829),
    [anon_sym_fneg] = ACTIONS(829),
    [anon_sym_icmp] = ACTIONS(829),
    [anon_sym_fcmp] = ACTIONS(829),
    [anon_sym_getelementptr] = ACTIONS(829),
    [anon_sym_extractvalue] = ACTIONS(829),
    [anon_sym_insertvalue] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(829),
    [anon_sym_false] = ACTIONS(829),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_none] = ACTIONS(829),
    [anon_sym_undef] = ACTIONS(829),
    [anon_sym_poison] = ACTIONS(829),
    [anon_sym_zeroinitializer] = ACTIONS(829),
    [anon_sym_blockaddress] = ACTIONS(829),
    [anon_sym_mul] = ACTIONS(829),
    [anon_sym_urem] = ACTIONS(829),
    [anon_sym_srem] = ACTIONS(829),
    [anon_sym_shl] = ACTIONS(829),
    [anon_sym_udiv] = ACTIONS(829),
    [anon_sym_sdiv] = ACTIONS(829),
    [anon_sym_lshr] = ACTIONS(829),
    [anon_sym_ashr] = ACTIONS(829),
    [anon_sym_fmul] = ACTIONS(829),
    [anon_sym_fdiv] = ACTIONS(829),
    [anon_sym_frem] = ACTIONS(829),
    [anon_sym_xchg] = ACTIONS(829),
    [anon_sym_add] = ACTIONS(831),
    [anon_sym_sub] = ACTIONS(829),
    [anon_sym_and] = ACTIONS(829),
    [anon_sym_nand] = ACTIONS(829),
    [anon_sym_or] = ACTIONS(829),
    [anon_sym_xor] = ACTIONS(829),
    [anon_sym_max] = ACTIONS(829),
    [anon_sym_min] = ACTIONS(831),
    [anon_sym_umax] = ACTIONS(829),
    [anon_sym_umin] = ACTIONS(829),
    [anon_sym_fadd] = ACTIONS(829),
    [anon_sym_fsub] = ACTIONS(829),
    [anon_sym_bitcast] = ACTIONS(829),
    [anon_sym_trunc] = ACTIONS(829),
    [anon_sym_zext] = ACTIONS(829),
    [anon_sym_sext] = ACTIONS(829),
    [anon_sym_fptrunc] = ACTIONS(829),
    [anon_sym_fpext] = ACTIONS(829),
    [anon_sym_addrspacecast] = ACTIONS(829),
    [anon_sym_uitofp] = ACTIONS(829),
    [anon_sym_sitofp] = ACTIONS(829),
    [anon_sym_fptoui] = ACTIONS(829),
    [anon_sym_fptosi] = ACTIONS(829),
    [anon_sym_inttoptr] = ACTIONS(829),
    [anon_sym_ptrtoint] = ACTIONS(829),
  },
  [210] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(715),
    [aux_sym_number_token2] = ACTIONS(713),
    [sym_float] = ACTIONS(713),
    [sym_cstring] = ACTIONS(713),
    [anon_sym_no_cfi] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_internal] = ACTIONS(713),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(713),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(713),
    [anon_sym_available_externally] = ACTIONS(713),
    [anon_sym_appending] = ACTIONS(713),
    [anon_sym_common] = ACTIONS(713),
    [anon_sym_extern_weak] = ACTIONS(713),
    [anon_sym_external] = ACTIONS(713),
    [anon_sym_dso_local] = ACTIONS(715),
    [anon_sym_dso_local_equivalent] = ACTIONS(713),
    [anon_sym_dso_preemptable] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_hidden] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_dllimport] = ACTIONS(713),
    [anon_sym_dllexport] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_extractelement] = ACTIONS(713),
    [anon_sym_insertelement] = ACTIONS(713),
    [anon_sym_select] = ACTIONS(713),
    [anon_sym_shufflevector] = ACTIONS(713),
    [anon_sym_fneg] = ACTIONS(713),
    [anon_sym_icmp] = ACTIONS(713),
    [anon_sym_fcmp] = ACTIONS(713),
    [anon_sym_getelementptr] = ACTIONS(713),
    [anon_sym_extractvalue] = ACTIONS(713),
    [anon_sym_insertvalue] = ACTIONS(713),
    [anon_sym_true] = ACTIONS(713),
    [anon_sym_false] = ACTIONS(713),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_none] = ACTIONS(713),
    [anon_sym_undef] = ACTIONS(713),
    [anon_sym_poison] = ACTIONS(713),
    [anon_sym_zeroinitializer] = ACTIONS(713),
    [anon_sym_blockaddress] = ACTIONS(713),
    [anon_sym_mul] = ACTIONS(713),
    [anon_sym_urem] = ACTIONS(713),
    [anon_sym_srem] = ACTIONS(713),
    [anon_sym_shl] = ACTIONS(713),
    [anon_sym_udiv] = ACTIONS(713),
    [anon_sym_sdiv] = ACTIONS(713),
    [anon_sym_lshr] = ACTIONS(713),
    [anon_sym_ashr] = ACTIONS(713),
    [anon_sym_fmul] = ACTIONS(713),
    [anon_sym_fdiv] = ACTIONS(713),
    [anon_sym_frem] = ACTIONS(713),
    [anon_sym_xchg] = ACTIONS(713),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(713),
    [anon_sym_and] = ACTIONS(713),
    [anon_sym_nand] = ACTIONS(713),
    [anon_sym_or] = ACTIONS(713),
    [anon_sym_xor] = ACTIONS(713),
    [anon_sym_max] = ACTIONS(713),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(713),
    [anon_sym_umin] = ACTIONS(713),
    [anon_sym_fadd] = ACTIONS(713),
    [anon_sym_fsub] = ACTIONS(713),
    [anon_sym_bitcast] = ACTIONS(713),
    [anon_sym_trunc] = ACTIONS(713),
    [anon_sym_zext] = ACTIONS(713),
    [anon_sym_sext] = ACTIONS(713),
    [anon_sym_fptrunc] = ACTIONS(713),
    [anon_sym_fpext] = ACTIONS(713),
    [anon_sym_addrspacecast] = ACTIONS(713),
    [anon_sym_uitofp] = ACTIONS(713),
    [anon_sym_sitofp] = ACTIONS(713),
    [anon_sym_fptoui] = ACTIONS(713),
    [anon_sym_fptosi] = ACTIONS(713),
    [anon_sym_inttoptr] = ACTIONS(713),
    [anon_sym_ptrtoint] = ACTIONS(713),
  },
  [211] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(835),
    [sym_local_var] = ACTIONS(835),
    [sym_string] = ACTIONS(835),
    [aux_sym_number_token1] = ACTIONS(837),
    [aux_sym_number_token2] = ACTIONS(835),
    [sym_float] = ACTIONS(835),
    [sym_cstring] = ACTIONS(835),
    [anon_sym_no_cfi] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_internal] = ACTIONS(835),
    [anon_sym_weak] = ACTIONS(837),
    [anon_sym_weak_odr] = ACTIONS(835),
    [anon_sym_linkonce] = ACTIONS(837),
    [anon_sym_linkonce_odr] = ACTIONS(835),
    [anon_sym_available_externally] = ACTIONS(835),
    [anon_sym_appending] = ACTIONS(835),
    [anon_sym_common] = ACTIONS(835),
    [anon_sym_extern_weak] = ACTIONS(835),
    [anon_sym_external] = ACTIONS(835),
    [anon_sym_dso_local] = ACTIONS(837),
    [anon_sym_dso_local_equivalent] = ACTIONS(835),
    [anon_sym_dso_preemptable] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_hidden] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(835),
    [anon_sym_dllimport] = ACTIONS(835),
    [anon_sym_dllexport] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_LT_LBRACE] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_alignstack] = ACTIONS(835),
    [anon_sym_allocsize] = ACTIONS(835),
    [anon_sym_alwaysinline] = ACTIONS(835),
    [anon_sym_builtin] = ACTIONS(835),
    [anon_sym_cold] = ACTIONS(835),
    [anon_sym_convergent] = ACTIONS(835),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(835),
    [anon_sym_hot] = ACTIONS(835),
    [anon_sym_inaccessiblememonly] = ACTIONS(835),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(835),
    [anon_sym_inlinehint] = ACTIONS(835),
    [anon_sym_jumptable] = ACTIONS(835),
    [anon_sym_minsize] = ACTIONS(835),
    [anon_sym_naked] = ACTIONS(835),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(835),
    [anon_sym_nobuiltin] = ACTIONS(835),
    [anon_sym_noduplicate] = ACTIONS(835),
    [anon_sym_nofree] = ACTIONS(835),
    [anon_sym_noimplicitfloat] = ACTIONS(835),
    [anon_sym_noinline] = ACTIONS(835),
    [anon_sym_nomerge] = ACTIONS(835),
    [anon_sym_nonlazybind] = ACTIONS(835),
    [anon_sym_noprofile] = ACTIONS(835),
    [anon_sym_noredzone] = ACTIONS(835),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(835),
    [anon_sym_noreturn] = ACTIONS(835),
    [anon_sym_norecurse] = ACTIONS(835),
    [anon_sym_willreturn] = ACTIONS(835),
    [anon_sym_nosync] = ACTIONS(835),
    [anon_sym_nounwind] = ACTIONS(835),
    [anon_sym_nosanitize_coverage] = ACTIONS(835),
    [anon_sym_null_pointer_is_valid] = ACTIONS(835),
    [anon_sym_optforfuzzing] = ACTIONS(835),
    [anon_sym_optnone] = ACTIONS(835),
    [anon_sym_optsize] = ACTIONS(835),
    [anon_sym_readnone] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_writeonly] = ACTIONS(835),
    [anon_sym_argmemonly] = ACTIONS(835),
    [anon_sym_returns_twice] = ACTIONS(835),
    [anon_sym_safestack] = ACTIONS(835),
    [anon_sym_sanitize_address] = ACTIONS(835),
    [anon_sym_sanitize_memory] = ACTIONS(835),
    [anon_sym_sanitize_thread] = ACTIONS(835),
    [anon_sym_sanitize_hwaddress] = ACTIONS(835),
    [anon_sym_sanitize_memtag] = ACTIONS(835),
    [anon_sym_speculative_load_hardening] = ACTIONS(835),
    [anon_sym_speculatable] = ACTIONS(835),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(835),
    [anon_sym_sspreq] = ACTIONS(835),
    [anon_sym_strictfp] = ACTIONS(835),
    [anon_sym_uwtable] = ACTIONS(835),
    [anon_sym_nocf_check] = ACTIONS(835),
    [anon_sym_shadowcallstack] = ACTIONS(835),
    [anon_sym_mustprogress] = ACTIONS(835),
    [anon_sym_vscale_range] = ACTIONS(835),
    [anon_sym_preallocated] = ACTIONS(835),
    [anon_sym_zeroext] = ACTIONS(835),
    [anon_sym_signext] = ACTIONS(835),
    [anon_sym_inreg] = ACTIONS(835),
    [anon_sym_byval] = ACTIONS(835),
    [anon_sym_byref] = ACTIONS(835),
    [anon_sym_inalloca] = ACTIONS(835),
    [anon_sym_sret] = ACTIONS(835),
    [anon_sym_elementtype] = ACTIONS(835),
    [anon_sym_noalias] = ACTIONS(835),
    [anon_sym_nocapture] = ACTIONS(835),
    [anon_sym_nest] = ACTIONS(835),
    [anon_sym_returned] = ACTIONS(835),
    [anon_sym_nonnull] = ACTIONS(835),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(835),
    [anon_sym_swiftself] = ACTIONS(835),
    [anon_sym_swiftasync] = ACTIONS(835),
    [anon_sym_swifterror] = ACTIONS(835),
    [anon_sym_immarg] = ACTIONS(835),
    [anon_sym_noundef] = ACTIONS(835),
    [anon_sym_extractelement] = ACTIONS(835),
    [anon_sym_insertelement] = ACTIONS(835),
    [anon_sym_select] = ACTIONS(835),
    [anon_sym_shufflevector] = ACTIONS(835),
    [anon_sym_fneg] = ACTIONS(835),
    [anon_sym_icmp] = ACTIONS(835),
    [anon_sym_fcmp] = ACTIONS(835),
    [anon_sym_getelementptr] = ACTIONS(835),
    [anon_sym_extractvalue] = ACTIONS(835),
    [anon_sym_insertvalue] = ACTIONS(835),
    [anon_sym_true] = ACTIONS(835),
    [anon_sym_false] = ACTIONS(835),
    [anon_sym_null] = ACTIONS(837),
    [anon_sym_none] = ACTIONS(835),
    [anon_sym_undef] = ACTIONS(835),
    [anon_sym_poison] = ACTIONS(835),
    [anon_sym_zeroinitializer] = ACTIONS(835),
    [anon_sym_blockaddress] = ACTIONS(835),
    [anon_sym_mul] = ACTIONS(835),
    [anon_sym_urem] = ACTIONS(835),
    [anon_sym_srem] = ACTIONS(835),
    [anon_sym_shl] = ACTIONS(835),
    [anon_sym_udiv] = ACTIONS(835),
    [anon_sym_sdiv] = ACTIONS(835),
    [anon_sym_lshr] = ACTIONS(835),
    [anon_sym_ashr] = ACTIONS(835),
    [anon_sym_fmul] = ACTIONS(835),
    [anon_sym_fdiv] = ACTIONS(835),
    [anon_sym_frem] = ACTIONS(835),
    [anon_sym_xchg] = ACTIONS(835),
    [anon_sym_add] = ACTIONS(837),
    [anon_sym_sub] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_nand] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_xor] = ACTIONS(835),
    [anon_sym_max] = ACTIONS(835),
    [anon_sym_min] = ACTIONS(837),
    [anon_sym_umax] = ACTIONS(835),
    [anon_sym_umin] = ACTIONS(835),
    [anon_sym_fadd] = ACTIONS(835),
    [anon_sym_fsub] = ACTIONS(835),
    [anon_sym_bitcast] = ACTIONS(835),
    [anon_sym_trunc] = ACTIONS(835),
    [anon_sym_zext] = ACTIONS(835),
    [anon_sym_sext] = ACTIONS(835),
    [anon_sym_fptrunc] = ACTIONS(835),
    [anon_sym_fpext] = ACTIONS(835),
    [anon_sym_addrspacecast] = ACTIONS(835),
    [anon_sym_uitofp] = ACTIONS(835),
    [anon_sym_sitofp] = ACTIONS(835),
    [anon_sym_fptoui] = ACTIONS(835),
    [anon_sym_fptosi] = ACTIONS(835),
    [anon_sym_inttoptr] = ACTIONS(835),
    [anon_sym_ptrtoint] = ACTIONS(835),
  },
  [212] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(839),
    [sym_local_var] = ACTIONS(839),
    [sym_string] = ACTIONS(839),
    [aux_sym_number_token1] = ACTIONS(841),
    [aux_sym_number_token2] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_cstring] = ACTIONS(839),
    [anon_sym_no_cfi] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_internal] = ACTIONS(839),
    [anon_sym_weak] = ACTIONS(841),
    [anon_sym_weak_odr] = ACTIONS(839),
    [anon_sym_linkonce] = ACTIONS(841),
    [anon_sym_linkonce_odr] = ACTIONS(839),
    [anon_sym_available_externally] = ACTIONS(839),
    [anon_sym_appending] = ACTIONS(839),
    [anon_sym_common] = ACTIONS(839),
    [anon_sym_extern_weak] = ACTIONS(839),
    [anon_sym_external] = ACTIONS(839),
    [anon_sym_dso_local] = ACTIONS(841),
    [anon_sym_dso_local_equivalent] = ACTIONS(839),
    [anon_sym_dso_preemptable] = ACTIONS(839),
    [anon_sym_default] = ACTIONS(839),
    [anon_sym_hidden] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_dllimport] = ACTIONS(839),
    [anon_sym_dllexport] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LT_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_alignstack] = ACTIONS(839),
    [anon_sym_allocsize] = ACTIONS(839),
    [anon_sym_alwaysinline] = ACTIONS(839),
    [anon_sym_builtin] = ACTIONS(839),
    [anon_sym_cold] = ACTIONS(839),
    [anon_sym_convergent] = ACTIONS(839),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(839),
    [anon_sym_hot] = ACTIONS(839),
    [anon_sym_inaccessiblememonly] = ACTIONS(839),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(839),
    [anon_sym_inlinehint] = ACTIONS(839),
    [anon_sym_jumptable] = ACTIONS(839),
    [anon_sym_minsize] = ACTIONS(839),
    [anon_sym_naked] = ACTIONS(839),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(839),
    [anon_sym_nobuiltin] = ACTIONS(839),
    [anon_sym_noduplicate] = ACTIONS(839),
    [anon_sym_nofree] = ACTIONS(839),
    [anon_sym_noimplicitfloat] = ACTIONS(839),
    [anon_sym_noinline] = ACTIONS(839),
    [anon_sym_nomerge] = ACTIONS(839),
    [anon_sym_nonlazybind] = ACTIONS(839),
    [anon_sym_noprofile] = ACTIONS(839),
    [anon_sym_noredzone] = ACTIONS(839),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(839),
    [anon_sym_noreturn] = ACTIONS(839),
    [anon_sym_norecurse] = ACTIONS(839),
    [anon_sym_willreturn] = ACTIONS(839),
    [anon_sym_nosync] = ACTIONS(839),
    [anon_sym_nounwind] = ACTIONS(839),
    [anon_sym_nosanitize_coverage] = ACTIONS(839),
    [anon_sym_null_pointer_is_valid] = ACTIONS(839),
    [anon_sym_optforfuzzing] = ACTIONS(839),
    [anon_sym_optnone] = ACTIONS(839),
    [anon_sym_optsize] = ACTIONS(839),
    [anon_sym_readnone] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_writeonly] = ACTIONS(839),
    [anon_sym_argmemonly] = ACTIONS(839),
    [anon_sym_returns_twice] = ACTIONS(839),
    [anon_sym_safestack] = ACTIONS(839),
    [anon_sym_sanitize_address] = ACTIONS(839),
    [anon_sym_sanitize_memory] = ACTIONS(839),
    [anon_sym_sanitize_thread] = ACTIONS(839),
    [anon_sym_sanitize_hwaddress] = ACTIONS(839),
    [anon_sym_sanitize_memtag] = ACTIONS(839),
    [anon_sym_speculative_load_hardening] = ACTIONS(839),
    [anon_sym_speculatable] = ACTIONS(839),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(839),
    [anon_sym_sspreq] = ACTIONS(839),
    [anon_sym_strictfp] = ACTIONS(839),
    [anon_sym_uwtable] = ACTIONS(839),
    [anon_sym_nocf_check] = ACTIONS(839),
    [anon_sym_shadowcallstack] = ACTIONS(839),
    [anon_sym_mustprogress] = ACTIONS(839),
    [anon_sym_vscale_range] = ACTIONS(839),
    [anon_sym_preallocated] = ACTIONS(839),
    [anon_sym_zeroext] = ACTIONS(839),
    [anon_sym_signext] = ACTIONS(839),
    [anon_sym_inreg] = ACTIONS(839),
    [anon_sym_byval] = ACTIONS(839),
    [anon_sym_byref] = ACTIONS(839),
    [anon_sym_inalloca] = ACTIONS(839),
    [anon_sym_sret] = ACTIONS(839),
    [anon_sym_elementtype] = ACTIONS(839),
    [anon_sym_noalias] = ACTIONS(839),
    [anon_sym_nocapture] = ACTIONS(839),
    [anon_sym_nest] = ACTIONS(839),
    [anon_sym_returned] = ACTIONS(839),
    [anon_sym_nonnull] = ACTIONS(839),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(839),
    [anon_sym_swiftself] = ACTIONS(839),
    [anon_sym_swiftasync] = ACTIONS(839),
    [anon_sym_swifterror] = ACTIONS(839),
    [anon_sym_immarg] = ACTIONS(839),
    [anon_sym_noundef] = ACTIONS(839),
    [anon_sym_extractelement] = ACTIONS(839),
    [anon_sym_insertelement] = ACTIONS(839),
    [anon_sym_select] = ACTIONS(839),
    [anon_sym_shufflevector] = ACTIONS(839),
    [anon_sym_fneg] = ACTIONS(839),
    [anon_sym_icmp] = ACTIONS(839),
    [anon_sym_fcmp] = ACTIONS(839),
    [anon_sym_getelementptr] = ACTIONS(839),
    [anon_sym_extractvalue] = ACTIONS(839),
    [anon_sym_insertvalue] = ACTIONS(839),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_null] = ACTIONS(841),
    [anon_sym_none] = ACTIONS(839),
    [anon_sym_undef] = ACTIONS(839),
    [anon_sym_poison] = ACTIONS(839),
    [anon_sym_zeroinitializer] = ACTIONS(839),
    [anon_sym_blockaddress] = ACTIONS(839),
    [anon_sym_mul] = ACTIONS(839),
    [anon_sym_urem] = ACTIONS(839),
    [anon_sym_srem] = ACTIONS(839),
    [anon_sym_shl] = ACTIONS(839),
    [anon_sym_udiv] = ACTIONS(839),
    [anon_sym_sdiv] = ACTIONS(839),
    [anon_sym_lshr] = ACTIONS(839),
    [anon_sym_ashr] = ACTIONS(839),
    [anon_sym_fmul] = ACTIONS(839),
    [anon_sym_fdiv] = ACTIONS(839),
    [anon_sym_frem] = ACTIONS(839),
    [anon_sym_xchg] = ACTIONS(839),
    [anon_sym_add] = ACTIONS(841),
    [anon_sym_sub] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(839),
    [anon_sym_nand] = ACTIONS(839),
    [anon_sym_or] = ACTIONS(839),
    [anon_sym_xor] = ACTIONS(839),
    [anon_sym_max] = ACTIONS(839),
    [anon_sym_min] = ACTIONS(841),
    [anon_sym_umax] = ACTIONS(839),
    [anon_sym_umin] = ACTIONS(839),
    [anon_sym_fadd] = ACTIONS(839),
    [anon_sym_fsub] = ACTIONS(839),
    [anon_sym_bitcast] = ACTIONS(839),
    [anon_sym_trunc] = ACTIONS(839),
    [anon_sym_zext] = ACTIONS(839),
    [anon_sym_sext] = ACTIONS(839),
    [anon_sym_fptrunc] = ACTIONS(839),
    [anon_sym_fpext] = ACTIONS(839),
    [anon_sym_addrspacecast] = ACTIONS(839),
    [anon_sym_uitofp] = ACTIONS(839),
    [anon_sym_sitofp] = ACTIONS(839),
    [anon_sym_fptoui] = ACTIONS(839),
    [anon_sym_fptosi] = ACTIONS(839),
    [anon_sym_inttoptr] = ACTIONS(839),
    [anon_sym_ptrtoint] = ACTIONS(839),
  },
  [213] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [aux_sym_number_token1] = ACTIONS(691),
    [aux_sym_number_token2] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [sym_cstring] = ACTIONS(689),
    [anon_sym_no_cfi] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_internal] = ACTIONS(689),
    [anon_sym_weak] = ACTIONS(691),
    [anon_sym_weak_odr] = ACTIONS(689),
    [anon_sym_linkonce] = ACTIONS(691),
    [anon_sym_linkonce_odr] = ACTIONS(689),
    [anon_sym_available_externally] = ACTIONS(689),
    [anon_sym_appending] = ACTIONS(689),
    [anon_sym_common] = ACTIONS(689),
    [anon_sym_extern_weak] = ACTIONS(689),
    [anon_sym_external] = ACTIONS(689),
    [anon_sym_dso_local] = ACTIONS(691),
    [anon_sym_dso_local_equivalent] = ACTIONS(689),
    [anon_sym_dso_preemptable] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_hidden] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_dllimport] = ACTIONS(689),
    [anon_sym_dllexport] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_LT_LBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(689),
    [anon_sym_allocsize] = ACTIONS(689),
    [anon_sym_alwaysinline] = ACTIONS(689),
    [anon_sym_builtin] = ACTIONS(689),
    [anon_sym_cold] = ACTIONS(689),
    [anon_sym_convergent] = ACTIONS(689),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(689),
    [anon_sym_hot] = ACTIONS(689),
    [anon_sym_inaccessiblememonly] = ACTIONS(689),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(689),
    [anon_sym_inlinehint] = ACTIONS(689),
    [anon_sym_jumptable] = ACTIONS(689),
    [anon_sym_minsize] = ACTIONS(689),
    [anon_sym_naked] = ACTIONS(689),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(689),
    [anon_sym_nobuiltin] = ACTIONS(689),
    [anon_sym_noduplicate] = ACTIONS(689),
    [anon_sym_nofree] = ACTIONS(689),
    [anon_sym_noimplicitfloat] = ACTIONS(689),
    [anon_sym_noinline] = ACTIONS(689),
    [anon_sym_nomerge] = ACTIONS(689),
    [anon_sym_nonlazybind] = ACTIONS(689),
    [anon_sym_noprofile] = ACTIONS(689),
    [anon_sym_noredzone] = ACTIONS(689),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(689),
    [anon_sym_noreturn] = ACTIONS(689),
    [anon_sym_norecurse] = ACTIONS(689),
    [anon_sym_willreturn] = ACTIONS(689),
    [anon_sym_nosync] = ACTIONS(689),
    [anon_sym_nounwind] = ACTIONS(689),
    [anon_sym_nosanitize_coverage] = ACTIONS(689),
    [anon_sym_null_pointer_is_valid] = ACTIONS(689),
    [anon_sym_optforfuzzing] = ACTIONS(689),
    [anon_sym_optnone] = ACTIONS(689),
    [anon_sym_optsize] = ACTIONS(689),
    [anon_sym_readnone] = ACTIONS(689),
    [anon_sym_readonly] = ACTIONS(689),
    [anon_sym_writeonly] = ACTIONS(689),
    [anon_sym_argmemonly] = ACTIONS(689),
    [anon_sym_returns_twice] = ACTIONS(689),
    [anon_sym_safestack] = ACTIONS(689),
    [anon_sym_sanitize_address] = ACTIONS(689),
    [anon_sym_sanitize_memory] = ACTIONS(689),
    [anon_sym_sanitize_thread] = ACTIONS(689),
    [anon_sym_sanitize_hwaddress] = ACTIONS(689),
    [anon_sym_sanitize_memtag] = ACTIONS(689),
    [anon_sym_speculative_load_hardening] = ACTIONS(689),
    [anon_sym_speculatable] = ACTIONS(689),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(689),
    [anon_sym_sspreq] = ACTIONS(689),
    [anon_sym_strictfp] = ACTIONS(689),
    [anon_sym_uwtable] = ACTIONS(689),
    [anon_sym_nocf_check] = ACTIONS(689),
    [anon_sym_shadowcallstack] = ACTIONS(689),
    [anon_sym_mustprogress] = ACTIONS(689),
    [anon_sym_vscale_range] = ACTIONS(689),
    [anon_sym_preallocated] = ACTIONS(689),
    [anon_sym_zeroext] = ACTIONS(689),
    [anon_sym_signext] = ACTIONS(689),
    [anon_sym_inreg] = ACTIONS(689),
    [anon_sym_byval] = ACTIONS(689),
    [anon_sym_byref] = ACTIONS(689),
    [anon_sym_inalloca] = ACTIONS(689),
    [anon_sym_sret] = ACTIONS(689),
    [anon_sym_elementtype] = ACTIONS(689),
    [anon_sym_noalias] = ACTIONS(689),
    [anon_sym_nocapture] = ACTIONS(689),
    [anon_sym_nest] = ACTIONS(689),
    [anon_sym_returned] = ACTIONS(689),
    [anon_sym_nonnull] = ACTIONS(689),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(689),
    [anon_sym_swiftself] = ACTIONS(689),
    [anon_sym_swiftasync] = ACTIONS(689),
    [anon_sym_swifterror] = ACTIONS(689),
    [anon_sym_immarg] = ACTIONS(689),
    [anon_sym_noundef] = ACTIONS(689),
    [anon_sym_extractelement] = ACTIONS(689),
    [anon_sym_insertelement] = ACTIONS(689),
    [anon_sym_select] = ACTIONS(689),
    [anon_sym_shufflevector] = ACTIONS(689),
    [anon_sym_fneg] = ACTIONS(689),
    [anon_sym_icmp] = ACTIONS(689),
    [anon_sym_fcmp] = ACTIONS(689),
    [anon_sym_getelementptr] = ACTIONS(689),
    [anon_sym_extractvalue] = ACTIONS(689),
    [anon_sym_insertvalue] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(689),
    [anon_sym_false] = ACTIONS(689),
    [anon_sym_null] = ACTIONS(691),
    [anon_sym_none] = ACTIONS(689),
    [anon_sym_undef] = ACTIONS(689),
    [anon_sym_poison] = ACTIONS(689),
    [anon_sym_zeroinitializer] = ACTIONS(689),
    [anon_sym_blockaddress] = ACTIONS(689),
    [anon_sym_mul] = ACTIONS(689),
    [anon_sym_urem] = ACTIONS(689),
    [anon_sym_srem] = ACTIONS(689),
    [anon_sym_shl] = ACTIONS(689),
    [anon_sym_udiv] = ACTIONS(689),
    [anon_sym_sdiv] = ACTIONS(689),
    [anon_sym_lshr] = ACTIONS(689),
    [anon_sym_ashr] = ACTIONS(689),
    [anon_sym_fmul] = ACTIONS(689),
    [anon_sym_fdiv] = ACTIONS(689),
    [anon_sym_frem] = ACTIONS(689),
    [anon_sym_xchg] = ACTIONS(689),
    [anon_sym_add] = ACTIONS(691),
    [anon_sym_sub] = ACTIONS(689),
    [anon_sym_and] = ACTIONS(689),
    [anon_sym_nand] = ACTIONS(689),
    [anon_sym_or] = ACTIONS(689),
    [anon_sym_xor] = ACTIONS(689),
    [anon_sym_max] = ACTIONS(689),
    [anon_sym_min] = ACTIONS(691),
    [anon_sym_umax] = ACTIONS(689),
    [anon_sym_umin] = ACTIONS(689),
    [anon_sym_fadd] = ACTIONS(689),
    [anon_sym_fsub] = ACTIONS(689),
    [anon_sym_bitcast] = ACTIONS(689),
    [anon_sym_trunc] = ACTIONS(689),
    [anon_sym_zext] = ACTIONS(689),
    [anon_sym_sext] = ACTIONS(689),
    [anon_sym_fptrunc] = ACTIONS(689),
    [anon_sym_fpext] = ACTIONS(689),
    [anon_sym_addrspacecast] = ACTIONS(689),
    [anon_sym_uitofp] = ACTIONS(689),
    [anon_sym_sitofp] = ACTIONS(689),
    [anon_sym_fptoui] = ACTIONS(689),
    [anon_sym_fptosi] = ACTIONS(689),
    [anon_sym_inttoptr] = ACTIONS(689),
    [anon_sym_ptrtoint] = ACTIONS(689),
  },
  [214] = {
    [sym_linkage] = STATE(214),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [aux_sym_function_header_repeat1] = STATE(214),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(843),
    [sym_local_var] = ACTIONS(843),
    [sym_string] = ACTIONS(843),
    [anon_sym_no_cfi] = ACTIONS(845),
    [anon_sym_private] = ACTIONS(848),
    [anon_sym_internal] = ACTIONS(848),
    [anon_sym_weak] = ACTIONS(851),
    [anon_sym_weak_odr] = ACTIONS(848),
    [anon_sym_linkonce] = ACTIONS(851),
    [anon_sym_linkonce_odr] = ACTIONS(848),
    [anon_sym_available_externally] = ACTIONS(848),
    [anon_sym_appending] = ACTIONS(848),
    [anon_sym_common] = ACTIONS(848),
    [anon_sym_extern_weak] = ACTIONS(848),
    [anon_sym_external] = ACTIONS(848),
    [anon_sym_dso_local] = ACTIONS(854),
    [anon_sym_dso_local_equivalent] = ACTIONS(857),
    [anon_sym_dso_preemptable] = ACTIONS(857),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_hidden] = ACTIONS(860),
    [anon_sym_protected] = ACTIONS(860),
    [anon_sym_dllimport] = ACTIONS(863),
    [anon_sym_dllexport] = ACTIONS(863),
    [anon_sym_ccc] = ACTIONS(843),
    [anon_sym_fastcc] = ACTIONS(843),
    [anon_sym_coldcc] = ACTIONS(843),
    [anon_sym_webkit_jscc] = ACTIONS(866),
    [anon_sym_anyregcc] = ACTIONS(843),
    [anon_sym_preserve_mostcc] = ACTIONS(843),
    [anon_sym_preserve_allcc] = ACTIONS(843),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(866),
    [anon_sym_tailcc] = ACTIONS(843),
    [anon_sym_swiftcc] = ACTIONS(866),
    [anon_sym_swifttailcc] = ACTIONS(866),
    [anon_sym_cfguard_checkcc] = ACTIONS(843),
    [aux_sym_calling_conv_token1] = ACTIONS(866),
    [aux_sym_calling_conv_token2] = ACTIONS(843),
    [aux_sym_calling_conv_token3] = ACTIONS(843),
    [aux_sym_calling_conv_token4] = ACTIONS(843),
    [aux_sym_calling_conv_token5] = ACTIONS(843),
    [aux_sym_calling_conv_token6] = ACTIONS(843),
    [aux_sym_calling_conv_token7] = ACTIONS(843),
    [aux_sym_calling_conv_token8] = ACTIONS(843),
    [aux_sym_calling_conv_token9] = ACTIONS(843),
    [aux_sym_calling_conv_token10] = ACTIONS(866),
    [anon_sym_ghccc] = ACTIONS(843),
    [aux_sym_calling_conv_token11] = ACTIONS(866),
    [aux_sym_calling_conv_token12] = ACTIONS(843),
    [aux_sym_calling_conv_token13] = ACTIONS(866),
    [aux_sym_calling_conv_token14] = ACTIONS(843),
    [anon_sym_cc] = ACTIONS(866),
    [anon_sym_unnamed_addr] = ACTIONS(843),
    [anon_sym_local_unnamed_addr] = ACTIONS(843),
    [anon_sym_void] = ACTIONS(843),
    [anon_sym_half] = ACTIONS(843),
    [anon_sym_bfloat] = ACTIONS(843),
    [anon_sym_float] = ACTIONS(843),
    [anon_sym_double] = ACTIONS(843),
    [anon_sym_x86_fp80] = ACTIONS(866),
    [anon_sym_fp128] = ACTIONS(843),
    [anon_sym_ppc_fp128] = ACTIONS(843),
    [anon_sym_label] = ACTIONS(843),
    [anon_sym_metadata] = ACTIONS(843),
    [anon_sym_x86_mmx] = ACTIONS(866),
    [anon_sym_x86_amx] = ACTIONS(866),
    [anon_sym_token] = ACTIONS(843),
    [anon_sym_opaque] = ACTIONS(843),
    [anon_sym_ptr] = ACTIONS(843),
    [aux_sym_type_keyword_token1] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_LT_LBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(866),
    [anon_sym_align] = ACTIONS(866),
    [anon_sym_alignstack] = ACTIONS(843),
    [anon_sym_allocsize] = ACTIONS(843),
    [anon_sym_alwaysinline] = ACTIONS(843),
    [anon_sym_builtin] = ACTIONS(843),
    [anon_sym_cold] = ACTIONS(866),
    [anon_sym_convergent] = ACTIONS(843),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(843),
    [anon_sym_hot] = ACTIONS(843),
    [anon_sym_inaccessiblememonly] = ACTIONS(843),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(843),
    [anon_sym_inlinehint] = ACTIONS(843),
    [anon_sym_jumptable] = ACTIONS(843),
    [anon_sym_minsize] = ACTIONS(843),
    [anon_sym_naked] = ACTIONS(843),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(843),
    [anon_sym_nobuiltin] = ACTIONS(843),
    [anon_sym_noduplicate] = ACTIONS(843),
    [anon_sym_nofree] = ACTIONS(843),
    [anon_sym_noimplicitfloat] = ACTIONS(843),
    [anon_sym_noinline] = ACTIONS(843),
    [anon_sym_nomerge] = ACTIONS(843),
    [anon_sym_nonlazybind] = ACTIONS(843),
    [anon_sym_noprofile] = ACTIONS(843),
    [anon_sym_noredzone] = ACTIONS(843),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(843),
    [anon_sym_noreturn] = ACTIONS(843),
    [anon_sym_norecurse] = ACTIONS(843),
    [anon_sym_willreturn] = ACTIONS(843),
    [anon_sym_nosync] = ACTIONS(843),
    [anon_sym_nounwind] = ACTIONS(843),
    [anon_sym_nosanitize_coverage] = ACTIONS(843),
    [anon_sym_null_pointer_is_valid] = ACTIONS(843),
    [anon_sym_optforfuzzing] = ACTIONS(843),
    [anon_sym_optnone] = ACTIONS(843),
    [anon_sym_optsize] = ACTIONS(843),
    [anon_sym_readnone] = ACTIONS(843),
    [anon_sym_readonly] = ACTIONS(843),
    [anon_sym_writeonly] = ACTIONS(843),
    [anon_sym_argmemonly] = ACTIONS(843),
    [anon_sym_returns_twice] = ACTIONS(843),
    [anon_sym_safestack] = ACTIONS(843),
    [anon_sym_sanitize_address] = ACTIONS(843),
    [anon_sym_sanitize_memory] = ACTIONS(843),
    [anon_sym_sanitize_thread] = ACTIONS(843),
    [anon_sym_sanitize_hwaddress] = ACTIONS(843),
    [anon_sym_sanitize_memtag] = ACTIONS(843),
    [anon_sym_speculative_load_hardening] = ACTIONS(843),
    [anon_sym_speculatable] = ACTIONS(843),
    [anon_sym_ssp] = ACTIONS(866),
    [anon_sym_sspstrong] = ACTIONS(843),
    [anon_sym_sspreq] = ACTIONS(843),
    [anon_sym_strictfp] = ACTIONS(843),
    [anon_sym_uwtable] = ACTIONS(843),
    [anon_sym_nocf_check] = ACTIONS(843),
    [anon_sym_shadowcallstack] = ACTIONS(843),
    [anon_sym_mustprogress] = ACTIONS(843),
    [anon_sym_vscale_range] = ACTIONS(843),
    [anon_sym_preallocated] = ACTIONS(843),
    [anon_sym_zeroext] = ACTIONS(843),
    [anon_sym_signext] = ACTIONS(843),
    [anon_sym_inreg] = ACTIONS(843),
    [anon_sym_byval] = ACTIONS(843),
    [anon_sym_byref] = ACTIONS(843),
    [anon_sym_inalloca] = ACTIONS(843),
    [anon_sym_sret] = ACTIONS(843),
    [anon_sym_elementtype] = ACTIONS(843),
    [anon_sym_noalias] = ACTIONS(843),
    [anon_sym_nocapture] = ACTIONS(843),
    [anon_sym_nest] = ACTIONS(843),
    [anon_sym_returned] = ACTIONS(843),
    [anon_sym_nonnull] = ACTIONS(843),
    [anon_sym_dereferenceable] = ACTIONS(866),
    [anon_sym_dereferenceable_or_null] = ACTIONS(843),
    [anon_sym_swiftself] = ACTIONS(866),
    [anon_sym_swiftasync] = ACTIONS(866),
    [anon_sym_swifterror] = ACTIONS(866),
    [anon_sym_immarg] = ACTIONS(843),
    [anon_sym_noundef] = ACTIONS(843),
  },
  [215] = {
    [sym_metadata_ref] = STATE(130),
    [sym_type] = STATE(216),
    [sym_type_keyword] = STATE(262),
    [sym_struct_type] = STATE(262),
    [sym_packed_struct_type] = STATE(262),
    [sym_array_type] = STATE(262),
    [sym_vector_type] = STATE(262),
    [sym_type_and_value] = STATE(173),
    [sym_metadata] = STATE(165),
    [sym_metadata_tuple] = STATE(173),
    [sym_specialized_md] = STATE(173),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(868),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(870),
    [anon_sym_half] = ACTIONS(870),
    [anon_sym_bfloat] = ACTIONS(870),
    [anon_sym_float] = ACTIONS(870),
    [anon_sym_double] = ACTIONS(870),
    [anon_sym_x86_fp80] = ACTIONS(870),
    [anon_sym_fp128] = ACTIONS(870),
    [anon_sym_ppc_fp128] = ACTIONS(870),
    [anon_sym_label] = ACTIONS(870),
    [anon_sym_metadata] = ACTIONS(872),
    [anon_sym_x86_mmx] = ACTIONS(870),
    [anon_sym_x86_amx] = ACTIONS(870),
    [anon_sym_token] = ACTIONS(870),
    [anon_sym_opaque] = ACTIONS(870),
    [anon_sym_ptr] = ACTIONS(870),
    [aux_sym_type_keyword_token1] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(874),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_catch] = ACTIONS(122),
    [anon_sym_filter] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_unordered] = ACTIONS(122),
    [anon_sym_monotonic] = ACTIONS(122),
    [anon_sym_acquire] = ACTIONS(122),
    [anon_sym_release] = ACTIONS(122),
    [anon_sym_acq_rel] = ACTIONS(122),
    [anon_sym_seq_cst] = ACTIONS(122),
    [anon_sym_syncscope] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [216] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(170),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(150),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_catch] = ACTIONS(70),
    [anon_sym_filter] = ACTIONS(70),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_unordered] = ACTIONS(70),
    [anon_sym_monotonic] = ACTIONS(70),
    [anon_sym_acquire] = ACTIONS(70),
    [anon_sym_release] = ACTIONS(70),
    [anon_sym_acq_rel] = ACTIONS(70),
    [anon_sym_seq_cst] = ACTIONS(70),
    [anon_sym_syncscope] = ACTIONS(70),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [217] = {
    [sym_metadata_name] = STATE(708),
    [sym_metadata_attachment] = STATE(217),
    [aux_sym_declare_repeat1] = STATE(217),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(884),
    [aux_sym_metadata_ref_token1] = ACTIONS(886),
    [sym_string] = ACTIONS(884),
    [anon_sym_no_cfi] = ACTIONS(884),
    [anon_sym_private] = ACTIONS(884),
    [anon_sym_internal] = ACTIONS(884),
    [anon_sym_weak] = ACTIONS(889),
    [anon_sym_weak_odr] = ACTIONS(884),
    [anon_sym_linkonce] = ACTIONS(889),
    [anon_sym_linkonce_odr] = ACTIONS(884),
    [anon_sym_available_externally] = ACTIONS(884),
    [anon_sym_appending] = ACTIONS(884),
    [anon_sym_common] = ACTIONS(884),
    [anon_sym_extern_weak] = ACTIONS(884),
    [anon_sym_external] = ACTIONS(884),
    [anon_sym_dso_local] = ACTIONS(889),
    [anon_sym_dso_local_equivalent] = ACTIONS(884),
    [anon_sym_dso_preemptable] = ACTIONS(884),
    [anon_sym_default] = ACTIONS(884),
    [anon_sym_hidden] = ACTIONS(884),
    [anon_sym_protected] = ACTIONS(884),
    [anon_sym_dllimport] = ACTIONS(884),
    [anon_sym_dllexport] = ACTIONS(884),
    [anon_sym_ccc] = ACTIONS(884),
    [anon_sym_fastcc] = ACTIONS(884),
    [anon_sym_coldcc] = ACTIONS(884),
    [anon_sym_webkit_jscc] = ACTIONS(889),
    [anon_sym_anyregcc] = ACTIONS(884),
    [anon_sym_preserve_mostcc] = ACTIONS(884),
    [anon_sym_preserve_allcc] = ACTIONS(884),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(889),
    [anon_sym_tailcc] = ACTIONS(884),
    [anon_sym_swiftcc] = ACTIONS(889),
    [anon_sym_swifttailcc] = ACTIONS(889),
    [anon_sym_cfguard_checkcc] = ACTIONS(884),
    [aux_sym_calling_conv_token1] = ACTIONS(889),
    [aux_sym_calling_conv_token2] = ACTIONS(884),
    [aux_sym_calling_conv_token3] = ACTIONS(884),
    [aux_sym_calling_conv_token4] = ACTIONS(884),
    [aux_sym_calling_conv_token5] = ACTIONS(884),
    [aux_sym_calling_conv_token6] = ACTIONS(884),
    [aux_sym_calling_conv_token7] = ACTIONS(884),
    [aux_sym_calling_conv_token8] = ACTIONS(884),
    [aux_sym_calling_conv_token9] = ACTIONS(884),
    [aux_sym_calling_conv_token10] = ACTIONS(889),
    [anon_sym_ghccc] = ACTIONS(884),
    [aux_sym_calling_conv_token11] = ACTIONS(889),
    [aux_sym_calling_conv_token12] = ACTIONS(884),
    [aux_sym_calling_conv_token13] = ACTIONS(889),
    [aux_sym_calling_conv_token14] = ACTIONS(884),
    [anon_sym_cc] = ACTIONS(889),
    [anon_sym_unnamed_addr] = ACTIONS(884),
    [anon_sym_local_unnamed_addr] = ACTIONS(884),
    [anon_sym_void] = ACTIONS(884),
    [anon_sym_half] = ACTIONS(884),
    [anon_sym_bfloat] = ACTIONS(884),
    [anon_sym_float] = ACTIONS(884),
    [anon_sym_double] = ACTIONS(884),
    [anon_sym_x86_fp80] = ACTIONS(889),
    [anon_sym_fp128] = ACTIONS(884),
    [anon_sym_ppc_fp128] = ACTIONS(884),
    [anon_sym_label] = ACTIONS(884),
    [anon_sym_metadata] = ACTIONS(884),
    [anon_sym_x86_mmx] = ACTIONS(889),
    [anon_sym_x86_amx] = ACTIONS(889),
    [anon_sym_token] = ACTIONS(884),
    [anon_sym_opaque] = ACTIONS(884),
    [anon_sym_ptr] = ACTIONS(884),
    [aux_sym_type_keyword_token1] = ACTIONS(884),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_LT_LBRACE] = ACTIONS(884),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_align] = ACTIONS(889),
    [anon_sym_alignstack] = ACTIONS(884),
    [anon_sym_allocsize] = ACTIONS(884),
    [anon_sym_alwaysinline] = ACTIONS(884),
    [anon_sym_builtin] = ACTIONS(884),
    [anon_sym_cold] = ACTIONS(889),
    [anon_sym_convergent] = ACTIONS(884),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(884),
    [anon_sym_hot] = ACTIONS(884),
    [anon_sym_inaccessiblememonly] = ACTIONS(884),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(884),
    [anon_sym_inlinehint] = ACTIONS(884),
    [anon_sym_jumptable] = ACTIONS(884),
    [anon_sym_minsize] = ACTIONS(884),
    [anon_sym_naked] = ACTIONS(884),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(884),
    [anon_sym_nobuiltin] = ACTIONS(884),
    [anon_sym_noduplicate] = ACTIONS(884),
    [anon_sym_nofree] = ACTIONS(884),
    [anon_sym_noimplicitfloat] = ACTIONS(884),
    [anon_sym_noinline] = ACTIONS(884),
    [anon_sym_nomerge] = ACTIONS(884),
    [anon_sym_nonlazybind] = ACTIONS(884),
    [anon_sym_noprofile] = ACTIONS(884),
    [anon_sym_noredzone] = ACTIONS(884),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(884),
    [anon_sym_noreturn] = ACTIONS(884),
    [anon_sym_norecurse] = ACTIONS(884),
    [anon_sym_willreturn] = ACTIONS(884),
    [anon_sym_nosync] = ACTIONS(884),
    [anon_sym_nounwind] = ACTIONS(884),
    [anon_sym_nosanitize_coverage] = ACTIONS(884),
    [anon_sym_null_pointer_is_valid] = ACTIONS(884),
    [anon_sym_optforfuzzing] = ACTIONS(884),
    [anon_sym_optnone] = ACTIONS(884),
    [anon_sym_optsize] = ACTIONS(884),
    [anon_sym_readnone] = ACTIONS(884),
    [anon_sym_readonly] = ACTIONS(884),
    [anon_sym_writeonly] = ACTIONS(884),
    [anon_sym_argmemonly] = ACTIONS(884),
    [anon_sym_returns_twice] = ACTIONS(884),
    [anon_sym_safestack] = ACTIONS(884),
    [anon_sym_sanitize_address] = ACTIONS(884),
    [anon_sym_sanitize_memory] = ACTIONS(884),
    [anon_sym_sanitize_thread] = ACTIONS(884),
    [anon_sym_sanitize_hwaddress] = ACTIONS(884),
    [anon_sym_sanitize_memtag] = ACTIONS(884),
    [anon_sym_speculative_load_hardening] = ACTIONS(884),
    [anon_sym_speculatable] = ACTIONS(884),
    [anon_sym_ssp] = ACTIONS(889),
    [anon_sym_sspstrong] = ACTIONS(884),
    [anon_sym_sspreq] = ACTIONS(884),
    [anon_sym_strictfp] = ACTIONS(884),
    [anon_sym_uwtable] = ACTIONS(884),
    [anon_sym_nocf_check] = ACTIONS(884),
    [anon_sym_shadowcallstack] = ACTIONS(884),
    [anon_sym_mustprogress] = ACTIONS(884),
    [anon_sym_vscale_range] = ACTIONS(884),
    [anon_sym_preallocated] = ACTIONS(884),
    [anon_sym_zeroext] = ACTIONS(884),
    [anon_sym_signext] = ACTIONS(884),
    [anon_sym_inreg] = ACTIONS(884),
    [anon_sym_byval] = ACTIONS(884),
    [anon_sym_byref] = ACTIONS(884),
    [anon_sym_inalloca] = ACTIONS(884),
    [anon_sym_sret] = ACTIONS(884),
    [anon_sym_elementtype] = ACTIONS(884),
    [anon_sym_noalias] = ACTIONS(884),
    [anon_sym_nocapture] = ACTIONS(884),
    [anon_sym_nest] = ACTIONS(884),
    [anon_sym_returned] = ACTIONS(884),
    [anon_sym_nonnull] = ACTIONS(884),
    [anon_sym_dereferenceable] = ACTIONS(889),
    [anon_sym_dereferenceable_or_null] = ACTIONS(884),
    [anon_sym_swiftself] = ACTIONS(889),
    [anon_sym_swiftasync] = ACTIONS(889),
    [anon_sym_swifterror] = ACTIONS(889),
    [anon_sym_immarg] = ACTIONS(884),
    [anon_sym_noundef] = ACTIONS(884),
  },
  [218] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(891),
    [sym_local_var] = ACTIONS(891),
    [sym_string] = ACTIONS(891),
    [anon_sym_no_cfi] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_internal] = ACTIONS(891),
    [anon_sym_weak] = ACTIONS(893),
    [anon_sym_weak_odr] = ACTIONS(891),
    [anon_sym_linkonce] = ACTIONS(893),
    [anon_sym_linkonce_odr] = ACTIONS(891),
    [anon_sym_available_externally] = ACTIONS(891),
    [anon_sym_appending] = ACTIONS(891),
    [anon_sym_common] = ACTIONS(891),
    [anon_sym_extern_weak] = ACTIONS(891),
    [anon_sym_external] = ACTIONS(891),
    [anon_sym_dso_local] = ACTIONS(893),
    [anon_sym_dso_local_equivalent] = ACTIONS(891),
    [anon_sym_dso_preemptable] = ACTIONS(891),
    [anon_sym_default] = ACTIONS(891),
    [anon_sym_hidden] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_dllimport] = ACTIONS(891),
    [anon_sym_dllexport] = ACTIONS(891),
    [anon_sym_ccc] = ACTIONS(891),
    [anon_sym_fastcc] = ACTIONS(891),
    [anon_sym_coldcc] = ACTIONS(891),
    [anon_sym_webkit_jscc] = ACTIONS(893),
    [anon_sym_anyregcc] = ACTIONS(891),
    [anon_sym_preserve_mostcc] = ACTIONS(891),
    [anon_sym_preserve_allcc] = ACTIONS(891),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(893),
    [anon_sym_tailcc] = ACTIONS(891),
    [anon_sym_swiftcc] = ACTIONS(893),
    [anon_sym_swifttailcc] = ACTIONS(893),
    [anon_sym_cfguard_checkcc] = ACTIONS(891),
    [aux_sym_calling_conv_token1] = ACTIONS(893),
    [aux_sym_calling_conv_token2] = ACTIONS(891),
    [aux_sym_calling_conv_token3] = ACTIONS(891),
    [aux_sym_calling_conv_token4] = ACTIONS(891),
    [aux_sym_calling_conv_token5] = ACTIONS(891),
    [aux_sym_calling_conv_token6] = ACTIONS(891),
    [aux_sym_calling_conv_token7] = ACTIONS(891),
    [aux_sym_calling_conv_token8] = ACTIONS(891),
    [aux_sym_calling_conv_token9] = ACTIONS(891),
    [aux_sym_calling_conv_token10] = ACTIONS(893),
    [anon_sym_ghccc] = ACTIONS(891),
    [aux_sym_calling_conv_token11] = ACTIONS(893),
    [aux_sym_calling_conv_token12] = ACTIONS(891),
    [aux_sym_calling_conv_token13] = ACTIONS(893),
    [aux_sym_calling_conv_token14] = ACTIONS(891),
    [anon_sym_cc] = ACTIONS(893),
    [anon_sym_unnamed_addr] = ACTIONS(891),
    [anon_sym_local_unnamed_addr] = ACTIONS(891),
    [anon_sym_void] = ACTIONS(891),
    [anon_sym_half] = ACTIONS(891),
    [anon_sym_bfloat] = ACTIONS(891),
    [anon_sym_float] = ACTIONS(891),
    [anon_sym_double] = ACTIONS(891),
    [anon_sym_x86_fp80] = ACTIONS(893),
    [anon_sym_fp128] = ACTIONS(891),
    [anon_sym_ppc_fp128] = ACTIONS(891),
    [anon_sym_label] = ACTIONS(891),
    [anon_sym_metadata] = ACTIONS(891),
    [anon_sym_x86_mmx] = ACTIONS(893),
    [anon_sym_x86_amx] = ACTIONS(893),
    [anon_sym_token] = ACTIONS(891),
    [anon_sym_opaque] = ACTIONS(891),
    [anon_sym_ptr] = ACTIONS(891),
    [aux_sym_type_keyword_token1] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_LT_LBRACE] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_align] = ACTIONS(893),
    [anon_sym_alignstack] = ACTIONS(891),
    [anon_sym_allocsize] = ACTIONS(891),
    [anon_sym_alwaysinline] = ACTIONS(891),
    [anon_sym_builtin] = ACTIONS(891),
    [anon_sym_cold] = ACTIONS(893),
    [anon_sym_convergent] = ACTIONS(891),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(891),
    [anon_sym_hot] = ACTIONS(891),
    [anon_sym_inaccessiblememonly] = ACTIONS(891),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(891),
    [anon_sym_inlinehint] = ACTIONS(891),
    [anon_sym_jumptable] = ACTIONS(891),
    [anon_sym_minsize] = ACTIONS(891),
    [anon_sym_naked] = ACTIONS(891),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(891),
    [anon_sym_nobuiltin] = ACTIONS(891),
    [anon_sym_noduplicate] = ACTIONS(891),
    [anon_sym_nofree] = ACTIONS(891),
    [anon_sym_noimplicitfloat] = ACTIONS(891),
    [anon_sym_noinline] = ACTIONS(891),
    [anon_sym_nomerge] = ACTIONS(891),
    [anon_sym_nonlazybind] = ACTIONS(891),
    [anon_sym_noprofile] = ACTIONS(891),
    [anon_sym_noredzone] = ACTIONS(891),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(891),
    [anon_sym_noreturn] = ACTIONS(891),
    [anon_sym_norecurse] = ACTIONS(891),
    [anon_sym_willreturn] = ACTIONS(891),
    [anon_sym_nosync] = ACTIONS(891),
    [anon_sym_nounwind] = ACTIONS(891),
    [anon_sym_nosanitize_coverage] = ACTIONS(891),
    [anon_sym_null_pointer_is_valid] = ACTIONS(891),
    [anon_sym_optforfuzzing] = ACTIONS(891),
    [anon_sym_optnone] = ACTIONS(891),
    [anon_sym_optsize] = ACTIONS(891),
    [anon_sym_readnone] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_writeonly] = ACTIONS(891),
    [anon_sym_argmemonly] = ACTIONS(891),
    [anon_sym_returns_twice] = ACTIONS(891),
    [anon_sym_safestack] = ACTIONS(891),
    [anon_sym_sanitize_address] = ACTIONS(891),
    [anon_sym_sanitize_memory] = ACTIONS(891),
    [anon_sym_sanitize_thread] = ACTIONS(891),
    [anon_sym_sanitize_hwaddress] = ACTIONS(891),
    [anon_sym_sanitize_memtag] = ACTIONS(891),
    [anon_sym_speculative_load_hardening] = ACTIONS(891),
    [anon_sym_speculatable] = ACTIONS(891),
    [anon_sym_ssp] = ACTIONS(893),
    [anon_sym_sspstrong] = ACTIONS(891),
    [anon_sym_sspreq] = ACTIONS(891),
    [anon_sym_strictfp] = ACTIONS(891),
    [anon_sym_uwtable] = ACTIONS(891),
    [anon_sym_nocf_check] = ACTIONS(891),
    [anon_sym_shadowcallstack] = ACTIONS(891),
    [anon_sym_mustprogress] = ACTIONS(891),
    [anon_sym_vscale_range] = ACTIONS(891),
    [anon_sym_preallocated] = ACTIONS(891),
    [anon_sym_zeroext] = ACTIONS(891),
    [anon_sym_signext] = ACTIONS(891),
    [anon_sym_inreg] = ACTIONS(891),
    [anon_sym_byval] = ACTIONS(891),
    [anon_sym_byref] = ACTIONS(891),
    [anon_sym_inalloca] = ACTIONS(891),
    [anon_sym_sret] = ACTIONS(891),
    [anon_sym_elementtype] = ACTIONS(891),
    [anon_sym_noalias] = ACTIONS(891),
    [anon_sym_nocapture] = ACTIONS(891),
    [anon_sym_nest] = ACTIONS(891),
    [anon_sym_returned] = ACTIONS(891),
    [anon_sym_nonnull] = ACTIONS(891),
    [anon_sym_dereferenceable] = ACTIONS(893),
    [anon_sym_dereferenceable_or_null] = ACTIONS(891),
    [anon_sym_swiftself] = ACTIONS(893),
    [anon_sym_swiftasync] = ACTIONS(893),
    [anon_sym_swifterror] = ACTIONS(893),
    [anon_sym_immarg] = ACTIONS(891),
    [anon_sym_noundef] = ACTIONS(891),
  },
  [219] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(895),
    [sym_local_var] = ACTIONS(895),
    [sym_string] = ACTIONS(895),
    [anon_sym_no_cfi] = ACTIONS(895),
    [anon_sym_private] = ACTIONS(895),
    [anon_sym_internal] = ACTIONS(895),
    [anon_sym_weak] = ACTIONS(897),
    [anon_sym_weak_odr] = ACTIONS(895),
    [anon_sym_linkonce] = ACTIONS(897),
    [anon_sym_linkonce_odr] = ACTIONS(895),
    [anon_sym_available_externally] = ACTIONS(895),
    [anon_sym_appending] = ACTIONS(895),
    [anon_sym_common] = ACTIONS(895),
    [anon_sym_extern_weak] = ACTIONS(895),
    [anon_sym_external] = ACTIONS(895),
    [anon_sym_dso_local] = ACTIONS(897),
    [anon_sym_dso_local_equivalent] = ACTIONS(895),
    [anon_sym_dso_preemptable] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(895),
    [anon_sym_hidden] = ACTIONS(895),
    [anon_sym_protected] = ACTIONS(895),
    [anon_sym_dllimport] = ACTIONS(895),
    [anon_sym_dllexport] = ACTIONS(895),
    [anon_sym_ccc] = ACTIONS(895),
    [anon_sym_fastcc] = ACTIONS(895),
    [anon_sym_coldcc] = ACTIONS(895),
    [anon_sym_webkit_jscc] = ACTIONS(897),
    [anon_sym_anyregcc] = ACTIONS(895),
    [anon_sym_preserve_mostcc] = ACTIONS(895),
    [anon_sym_preserve_allcc] = ACTIONS(895),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(897),
    [anon_sym_tailcc] = ACTIONS(895),
    [anon_sym_swiftcc] = ACTIONS(897),
    [anon_sym_swifttailcc] = ACTIONS(897),
    [anon_sym_cfguard_checkcc] = ACTIONS(895),
    [aux_sym_calling_conv_token1] = ACTIONS(897),
    [aux_sym_calling_conv_token2] = ACTIONS(895),
    [aux_sym_calling_conv_token3] = ACTIONS(895),
    [aux_sym_calling_conv_token4] = ACTIONS(895),
    [aux_sym_calling_conv_token5] = ACTIONS(895),
    [aux_sym_calling_conv_token6] = ACTIONS(895),
    [aux_sym_calling_conv_token7] = ACTIONS(895),
    [aux_sym_calling_conv_token8] = ACTIONS(895),
    [aux_sym_calling_conv_token9] = ACTIONS(895),
    [aux_sym_calling_conv_token10] = ACTIONS(897),
    [anon_sym_ghccc] = ACTIONS(895),
    [aux_sym_calling_conv_token11] = ACTIONS(897),
    [aux_sym_calling_conv_token12] = ACTIONS(895),
    [aux_sym_calling_conv_token13] = ACTIONS(897),
    [aux_sym_calling_conv_token14] = ACTIONS(895),
    [anon_sym_cc] = ACTIONS(897),
    [anon_sym_unnamed_addr] = ACTIONS(895),
    [anon_sym_local_unnamed_addr] = ACTIONS(895),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_half] = ACTIONS(895),
    [anon_sym_bfloat] = ACTIONS(895),
    [anon_sym_float] = ACTIONS(895),
    [anon_sym_double] = ACTIONS(895),
    [anon_sym_x86_fp80] = ACTIONS(897),
    [anon_sym_fp128] = ACTIONS(895),
    [anon_sym_ppc_fp128] = ACTIONS(895),
    [anon_sym_label] = ACTIONS(895),
    [anon_sym_metadata] = ACTIONS(895),
    [anon_sym_x86_mmx] = ACTIONS(897),
    [anon_sym_x86_amx] = ACTIONS(897),
    [anon_sym_token] = ACTIONS(895),
    [anon_sym_opaque] = ACTIONS(895),
    [anon_sym_ptr] = ACTIONS(895),
    [aux_sym_type_keyword_token1] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_LBRACE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_align] = ACTIONS(897),
    [anon_sym_alignstack] = ACTIONS(895),
    [anon_sym_allocsize] = ACTIONS(895),
    [anon_sym_alwaysinline] = ACTIONS(895),
    [anon_sym_builtin] = ACTIONS(895),
    [anon_sym_cold] = ACTIONS(897),
    [anon_sym_convergent] = ACTIONS(895),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(895),
    [anon_sym_hot] = ACTIONS(895),
    [anon_sym_inaccessiblememonly] = ACTIONS(895),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(895),
    [anon_sym_inlinehint] = ACTIONS(895),
    [anon_sym_jumptable] = ACTIONS(895),
    [anon_sym_minsize] = ACTIONS(895),
    [anon_sym_naked] = ACTIONS(895),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(895),
    [anon_sym_nobuiltin] = ACTIONS(895),
    [anon_sym_noduplicate] = ACTIONS(895),
    [anon_sym_nofree] = ACTIONS(895),
    [anon_sym_noimplicitfloat] = ACTIONS(895),
    [anon_sym_noinline] = ACTIONS(895),
    [anon_sym_nomerge] = ACTIONS(895),
    [anon_sym_nonlazybind] = ACTIONS(895),
    [anon_sym_noprofile] = ACTIONS(895),
    [anon_sym_noredzone] = ACTIONS(895),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(895),
    [anon_sym_noreturn] = ACTIONS(895),
    [anon_sym_norecurse] = ACTIONS(895),
    [anon_sym_willreturn] = ACTIONS(895),
    [anon_sym_nosync] = ACTIONS(895),
    [anon_sym_nounwind] = ACTIONS(895),
    [anon_sym_nosanitize_coverage] = ACTIONS(895),
    [anon_sym_null_pointer_is_valid] = ACTIONS(895),
    [anon_sym_optforfuzzing] = ACTIONS(895),
    [anon_sym_optnone] = ACTIONS(895),
    [anon_sym_optsize] = ACTIONS(895),
    [anon_sym_readnone] = ACTIONS(895),
    [anon_sym_readonly] = ACTIONS(895),
    [anon_sym_writeonly] = ACTIONS(895),
    [anon_sym_argmemonly] = ACTIONS(895),
    [anon_sym_returns_twice] = ACTIONS(895),
    [anon_sym_safestack] = ACTIONS(895),
    [anon_sym_sanitize_address] = ACTIONS(895),
    [anon_sym_sanitize_memory] = ACTIONS(895),
    [anon_sym_sanitize_thread] = ACTIONS(895),
    [anon_sym_sanitize_hwaddress] = ACTIONS(895),
    [anon_sym_sanitize_memtag] = ACTIONS(895),
    [anon_sym_speculative_load_hardening] = ACTIONS(895),
    [anon_sym_speculatable] = ACTIONS(895),
    [anon_sym_ssp] = ACTIONS(897),
    [anon_sym_sspstrong] = ACTIONS(895),
    [anon_sym_sspreq] = ACTIONS(895),
    [anon_sym_strictfp] = ACTIONS(895),
    [anon_sym_uwtable] = ACTIONS(895),
    [anon_sym_nocf_check] = ACTIONS(895),
    [anon_sym_shadowcallstack] = ACTIONS(895),
    [anon_sym_mustprogress] = ACTIONS(895),
    [anon_sym_vscale_range] = ACTIONS(895),
    [anon_sym_preallocated] = ACTIONS(895),
    [anon_sym_zeroext] = ACTIONS(895),
    [anon_sym_signext] = ACTIONS(895),
    [anon_sym_inreg] = ACTIONS(895),
    [anon_sym_byval] = ACTIONS(895),
    [anon_sym_byref] = ACTIONS(895),
    [anon_sym_inalloca] = ACTIONS(895),
    [anon_sym_sret] = ACTIONS(895),
    [anon_sym_elementtype] = ACTIONS(895),
    [anon_sym_noalias] = ACTIONS(895),
    [anon_sym_nocapture] = ACTIONS(895),
    [anon_sym_nest] = ACTIONS(895),
    [anon_sym_returned] = ACTIONS(895),
    [anon_sym_nonnull] = ACTIONS(895),
    [anon_sym_dereferenceable] = ACTIONS(897),
    [anon_sym_dereferenceable_or_null] = ACTIONS(895),
    [anon_sym_swiftself] = ACTIONS(897),
    [anon_sym_swiftasync] = ACTIONS(897),
    [anon_sym_swifterror] = ACTIONS(897),
    [anon_sym_immarg] = ACTIONS(895),
    [anon_sym_noundef] = ACTIONS(895),
  },
  [220] = {
    [sym_calling_conv] = STATE(384),
    [sym_type] = STATE(343),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1018),
    [sym_param_or_return_attrs] = STATE(383),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(602),
    [sym_fast_math] = STATE(223),
    [aux_sym_function_header_repeat2] = STATE(383),
    [aux_sym_instruction_select_repeat1] = STATE(223),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_nnan] = ACTIONS(901),
    [anon_sym_ninf] = ACTIONS(901),
    [anon_sym_nsz] = ACTIONS(901),
    [anon_sym_arcp] = ACTIONS(901),
    [anon_sym_contract] = ACTIONS(901),
    [anon_sym_afn] = ACTIONS(901),
    [anon_sym_reassoc] = ACTIONS(901),
    [anon_sym_fast] = ACTIONS(903),
  },
  [221] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(905),
    [sym_local_var] = ACTIONS(905),
    [sym_string] = ACTIONS(905),
    [anon_sym_no_cfi] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_internal] = ACTIONS(905),
    [anon_sym_weak] = ACTIONS(907),
    [anon_sym_weak_odr] = ACTIONS(905),
    [anon_sym_linkonce] = ACTIONS(907),
    [anon_sym_linkonce_odr] = ACTIONS(905),
    [anon_sym_available_externally] = ACTIONS(905),
    [anon_sym_appending] = ACTIONS(905),
    [anon_sym_common] = ACTIONS(905),
    [anon_sym_extern_weak] = ACTIONS(905),
    [anon_sym_external] = ACTIONS(905),
    [anon_sym_dso_local] = ACTIONS(907),
    [anon_sym_dso_local_equivalent] = ACTIONS(905),
    [anon_sym_dso_preemptable] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_hidden] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_dllimport] = ACTIONS(905),
    [anon_sym_dllexport] = ACTIONS(905),
    [anon_sym_ccc] = ACTIONS(905),
    [anon_sym_fastcc] = ACTIONS(905),
    [anon_sym_coldcc] = ACTIONS(905),
    [anon_sym_webkit_jscc] = ACTIONS(907),
    [anon_sym_anyregcc] = ACTIONS(905),
    [anon_sym_preserve_mostcc] = ACTIONS(905),
    [anon_sym_preserve_allcc] = ACTIONS(905),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(907),
    [anon_sym_tailcc] = ACTIONS(905),
    [anon_sym_swiftcc] = ACTIONS(907),
    [anon_sym_swifttailcc] = ACTIONS(907),
    [anon_sym_cfguard_checkcc] = ACTIONS(905),
    [aux_sym_calling_conv_token1] = ACTIONS(907),
    [aux_sym_calling_conv_token2] = ACTIONS(905),
    [aux_sym_calling_conv_token3] = ACTIONS(905),
    [aux_sym_calling_conv_token4] = ACTIONS(905),
    [aux_sym_calling_conv_token5] = ACTIONS(905),
    [aux_sym_calling_conv_token6] = ACTIONS(905),
    [aux_sym_calling_conv_token7] = ACTIONS(905),
    [aux_sym_calling_conv_token8] = ACTIONS(905),
    [aux_sym_calling_conv_token9] = ACTIONS(905),
    [aux_sym_calling_conv_token10] = ACTIONS(907),
    [anon_sym_ghccc] = ACTIONS(905),
    [aux_sym_calling_conv_token11] = ACTIONS(907),
    [aux_sym_calling_conv_token12] = ACTIONS(905),
    [aux_sym_calling_conv_token13] = ACTIONS(907),
    [aux_sym_calling_conv_token14] = ACTIONS(905),
    [anon_sym_cc] = ACTIONS(907),
    [anon_sym_unnamed_addr] = ACTIONS(905),
    [anon_sym_local_unnamed_addr] = ACTIONS(905),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_half] = ACTIONS(905),
    [anon_sym_bfloat] = ACTIONS(905),
    [anon_sym_float] = ACTIONS(905),
    [anon_sym_double] = ACTIONS(905),
    [anon_sym_x86_fp80] = ACTIONS(907),
    [anon_sym_fp128] = ACTIONS(905),
    [anon_sym_ppc_fp128] = ACTIONS(905),
    [anon_sym_label] = ACTIONS(905),
    [anon_sym_metadata] = ACTIONS(905),
    [anon_sym_x86_mmx] = ACTIONS(907),
    [anon_sym_x86_amx] = ACTIONS(907),
    [anon_sym_token] = ACTIONS(905),
    [anon_sym_opaque] = ACTIONS(905),
    [anon_sym_ptr] = ACTIONS(905),
    [aux_sym_type_keyword_token1] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_LT_LBRACE] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_align] = ACTIONS(907),
    [anon_sym_alignstack] = ACTIONS(905),
    [anon_sym_allocsize] = ACTIONS(905),
    [anon_sym_alwaysinline] = ACTIONS(905),
    [anon_sym_builtin] = ACTIONS(905),
    [anon_sym_cold] = ACTIONS(907),
    [anon_sym_convergent] = ACTIONS(905),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(905),
    [anon_sym_hot] = ACTIONS(905),
    [anon_sym_inaccessiblememonly] = ACTIONS(905),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(905),
    [anon_sym_inlinehint] = ACTIONS(905),
    [anon_sym_jumptable] = ACTIONS(905),
    [anon_sym_minsize] = ACTIONS(905),
    [anon_sym_naked] = ACTIONS(905),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(905),
    [anon_sym_nobuiltin] = ACTIONS(905),
    [anon_sym_noduplicate] = ACTIONS(905),
    [anon_sym_nofree] = ACTIONS(905),
    [anon_sym_noimplicitfloat] = ACTIONS(905),
    [anon_sym_noinline] = ACTIONS(905),
    [anon_sym_nomerge] = ACTIONS(905),
    [anon_sym_nonlazybind] = ACTIONS(905),
    [anon_sym_noprofile] = ACTIONS(905),
    [anon_sym_noredzone] = ACTIONS(905),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(905),
    [anon_sym_noreturn] = ACTIONS(905),
    [anon_sym_norecurse] = ACTIONS(905),
    [anon_sym_willreturn] = ACTIONS(905),
    [anon_sym_nosync] = ACTIONS(905),
    [anon_sym_nounwind] = ACTIONS(905),
    [anon_sym_nosanitize_coverage] = ACTIONS(905),
    [anon_sym_null_pointer_is_valid] = ACTIONS(905),
    [anon_sym_optforfuzzing] = ACTIONS(905),
    [anon_sym_optnone] = ACTIONS(905),
    [anon_sym_optsize] = ACTIONS(905),
    [anon_sym_readnone] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_writeonly] = ACTIONS(905),
    [anon_sym_argmemonly] = ACTIONS(905),
    [anon_sym_returns_twice] = ACTIONS(905),
    [anon_sym_safestack] = ACTIONS(905),
    [anon_sym_sanitize_address] = ACTIONS(905),
    [anon_sym_sanitize_memory] = ACTIONS(905),
    [anon_sym_sanitize_thread] = ACTIONS(905),
    [anon_sym_sanitize_hwaddress] = ACTIONS(905),
    [anon_sym_sanitize_memtag] = ACTIONS(905),
    [anon_sym_speculative_load_hardening] = ACTIONS(905),
    [anon_sym_speculatable] = ACTIONS(905),
    [anon_sym_ssp] = ACTIONS(907),
    [anon_sym_sspstrong] = ACTIONS(905),
    [anon_sym_sspreq] = ACTIONS(905),
    [anon_sym_strictfp] = ACTIONS(905),
    [anon_sym_uwtable] = ACTIONS(905),
    [anon_sym_nocf_check] = ACTIONS(905),
    [anon_sym_shadowcallstack] = ACTIONS(905),
    [anon_sym_mustprogress] = ACTIONS(905),
    [anon_sym_vscale_range] = ACTIONS(905),
    [anon_sym_preallocated] = ACTIONS(905),
    [anon_sym_zeroext] = ACTIONS(905),
    [anon_sym_signext] = ACTIONS(905),
    [anon_sym_inreg] = ACTIONS(905),
    [anon_sym_byval] = ACTIONS(905),
    [anon_sym_byref] = ACTIONS(905),
    [anon_sym_inalloca] = ACTIONS(905),
    [anon_sym_sret] = ACTIONS(905),
    [anon_sym_elementtype] = ACTIONS(905),
    [anon_sym_noalias] = ACTIONS(905),
    [anon_sym_nocapture] = ACTIONS(905),
    [anon_sym_nest] = ACTIONS(905),
    [anon_sym_returned] = ACTIONS(905),
    [anon_sym_nonnull] = ACTIONS(905),
    [anon_sym_dereferenceable] = ACTIONS(907),
    [anon_sym_dereferenceable_or_null] = ACTIONS(905),
    [anon_sym_swiftself] = ACTIONS(907),
    [anon_sym_swiftasync] = ACTIONS(907),
    [anon_sym_swifterror] = ACTIONS(907),
    [anon_sym_immarg] = ACTIONS(905),
    [anon_sym_noundef] = ACTIONS(905),
  },
  [222] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(909),
    [sym_local_var] = ACTIONS(909),
    [sym_string] = ACTIONS(909),
    [anon_sym_no_cfi] = ACTIONS(909),
    [anon_sym_private] = ACTIONS(909),
    [anon_sym_internal] = ACTIONS(909),
    [anon_sym_weak] = ACTIONS(911),
    [anon_sym_weak_odr] = ACTIONS(909),
    [anon_sym_linkonce] = ACTIONS(911),
    [anon_sym_linkonce_odr] = ACTIONS(909),
    [anon_sym_available_externally] = ACTIONS(909),
    [anon_sym_appending] = ACTIONS(909),
    [anon_sym_common] = ACTIONS(909),
    [anon_sym_extern_weak] = ACTIONS(909),
    [anon_sym_external] = ACTIONS(909),
    [anon_sym_dso_local] = ACTIONS(911),
    [anon_sym_dso_local_equivalent] = ACTIONS(909),
    [anon_sym_dso_preemptable] = ACTIONS(909),
    [anon_sym_default] = ACTIONS(909),
    [anon_sym_hidden] = ACTIONS(909),
    [anon_sym_protected] = ACTIONS(909),
    [anon_sym_dllimport] = ACTIONS(909),
    [anon_sym_dllexport] = ACTIONS(909),
    [anon_sym_ccc] = ACTIONS(909),
    [anon_sym_fastcc] = ACTIONS(909),
    [anon_sym_coldcc] = ACTIONS(909),
    [anon_sym_webkit_jscc] = ACTIONS(911),
    [anon_sym_anyregcc] = ACTIONS(909),
    [anon_sym_preserve_mostcc] = ACTIONS(909),
    [anon_sym_preserve_allcc] = ACTIONS(909),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(911),
    [anon_sym_tailcc] = ACTIONS(909),
    [anon_sym_swiftcc] = ACTIONS(911),
    [anon_sym_swifttailcc] = ACTIONS(911),
    [anon_sym_cfguard_checkcc] = ACTIONS(909),
    [aux_sym_calling_conv_token1] = ACTIONS(911),
    [aux_sym_calling_conv_token2] = ACTIONS(909),
    [aux_sym_calling_conv_token3] = ACTIONS(909),
    [aux_sym_calling_conv_token4] = ACTIONS(909),
    [aux_sym_calling_conv_token5] = ACTIONS(909),
    [aux_sym_calling_conv_token6] = ACTIONS(909),
    [aux_sym_calling_conv_token7] = ACTIONS(909),
    [aux_sym_calling_conv_token8] = ACTIONS(909),
    [aux_sym_calling_conv_token9] = ACTIONS(909),
    [aux_sym_calling_conv_token10] = ACTIONS(911),
    [anon_sym_ghccc] = ACTIONS(909),
    [aux_sym_calling_conv_token11] = ACTIONS(911),
    [aux_sym_calling_conv_token12] = ACTIONS(909),
    [aux_sym_calling_conv_token13] = ACTIONS(911),
    [aux_sym_calling_conv_token14] = ACTIONS(909),
    [anon_sym_cc] = ACTIONS(911),
    [anon_sym_unnamed_addr] = ACTIONS(909),
    [anon_sym_local_unnamed_addr] = ACTIONS(909),
    [anon_sym_void] = ACTIONS(909),
    [anon_sym_half] = ACTIONS(909),
    [anon_sym_bfloat] = ACTIONS(909),
    [anon_sym_float] = ACTIONS(909),
    [anon_sym_double] = ACTIONS(909),
    [anon_sym_x86_fp80] = ACTIONS(911),
    [anon_sym_fp128] = ACTIONS(909),
    [anon_sym_ppc_fp128] = ACTIONS(909),
    [anon_sym_label] = ACTIONS(909),
    [anon_sym_metadata] = ACTIONS(909),
    [anon_sym_x86_mmx] = ACTIONS(911),
    [anon_sym_x86_amx] = ACTIONS(911),
    [anon_sym_token] = ACTIONS(909),
    [anon_sym_opaque] = ACTIONS(909),
    [anon_sym_ptr] = ACTIONS(909),
    [aux_sym_type_keyword_token1] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_LT_LBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_align] = ACTIONS(911),
    [anon_sym_alignstack] = ACTIONS(909),
    [anon_sym_allocsize] = ACTIONS(909),
    [anon_sym_alwaysinline] = ACTIONS(909),
    [anon_sym_builtin] = ACTIONS(909),
    [anon_sym_cold] = ACTIONS(911),
    [anon_sym_convergent] = ACTIONS(909),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(909),
    [anon_sym_hot] = ACTIONS(909),
    [anon_sym_inaccessiblememonly] = ACTIONS(909),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(909),
    [anon_sym_inlinehint] = ACTIONS(909),
    [anon_sym_jumptable] = ACTIONS(909),
    [anon_sym_minsize] = ACTIONS(909),
    [anon_sym_naked] = ACTIONS(909),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(909),
    [anon_sym_nobuiltin] = ACTIONS(909),
    [anon_sym_noduplicate] = ACTIONS(909),
    [anon_sym_nofree] = ACTIONS(909),
    [anon_sym_noimplicitfloat] = ACTIONS(909),
    [anon_sym_noinline] = ACTIONS(909),
    [anon_sym_nomerge] = ACTIONS(909),
    [anon_sym_nonlazybind] = ACTIONS(909),
    [anon_sym_noprofile] = ACTIONS(909),
    [anon_sym_noredzone] = ACTIONS(909),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(909),
    [anon_sym_noreturn] = ACTIONS(909),
    [anon_sym_norecurse] = ACTIONS(909),
    [anon_sym_willreturn] = ACTIONS(909),
    [anon_sym_nosync] = ACTIONS(909),
    [anon_sym_nounwind] = ACTIONS(909),
    [anon_sym_nosanitize_coverage] = ACTIONS(909),
    [anon_sym_null_pointer_is_valid] = ACTIONS(909),
    [anon_sym_optforfuzzing] = ACTIONS(909),
    [anon_sym_optnone] = ACTIONS(909),
    [anon_sym_optsize] = ACTIONS(909),
    [anon_sym_readnone] = ACTIONS(909),
    [anon_sym_readonly] = ACTIONS(909),
    [anon_sym_writeonly] = ACTIONS(909),
    [anon_sym_argmemonly] = ACTIONS(909),
    [anon_sym_returns_twice] = ACTIONS(909),
    [anon_sym_safestack] = ACTIONS(909),
    [anon_sym_sanitize_address] = ACTIONS(909),
    [anon_sym_sanitize_memory] = ACTIONS(909),
    [anon_sym_sanitize_thread] = ACTIONS(909),
    [anon_sym_sanitize_hwaddress] = ACTIONS(909),
    [anon_sym_sanitize_memtag] = ACTIONS(909),
    [anon_sym_speculative_load_hardening] = ACTIONS(909),
    [anon_sym_speculatable] = ACTIONS(909),
    [anon_sym_ssp] = ACTIONS(911),
    [anon_sym_sspstrong] = ACTIONS(909),
    [anon_sym_sspreq] = ACTIONS(909),
    [anon_sym_strictfp] = ACTIONS(909),
    [anon_sym_uwtable] = ACTIONS(909),
    [anon_sym_nocf_check] = ACTIONS(909),
    [anon_sym_shadowcallstack] = ACTIONS(909),
    [anon_sym_mustprogress] = ACTIONS(909),
    [anon_sym_vscale_range] = ACTIONS(909),
    [anon_sym_preallocated] = ACTIONS(909),
    [anon_sym_zeroext] = ACTIONS(909),
    [anon_sym_signext] = ACTIONS(909),
    [anon_sym_inreg] = ACTIONS(909),
    [anon_sym_byval] = ACTIONS(909),
    [anon_sym_byref] = ACTIONS(909),
    [anon_sym_inalloca] = ACTIONS(909),
    [anon_sym_sret] = ACTIONS(909),
    [anon_sym_elementtype] = ACTIONS(909),
    [anon_sym_noalias] = ACTIONS(909),
    [anon_sym_nocapture] = ACTIONS(909),
    [anon_sym_nest] = ACTIONS(909),
    [anon_sym_returned] = ACTIONS(909),
    [anon_sym_nonnull] = ACTIONS(909),
    [anon_sym_dereferenceable] = ACTIONS(911),
    [anon_sym_dereferenceable_or_null] = ACTIONS(909),
    [anon_sym_swiftself] = ACTIONS(911),
    [anon_sym_swiftasync] = ACTIONS(911),
    [anon_sym_swifterror] = ACTIONS(911),
    [anon_sym_immarg] = ACTIONS(909),
    [anon_sym_noundef] = ACTIONS(909),
  },
  [223] = {
    [sym_calling_conv] = STATE(384),
    [sym_type] = STATE(343),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1018),
    [sym_param_or_return_attrs] = STATE(383),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(618),
    [sym_fast_math] = STATE(234),
    [aux_sym_function_header_repeat2] = STATE(383),
    [aux_sym_instruction_select_repeat1] = STATE(234),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_nnan] = ACTIONS(901),
    [anon_sym_ninf] = ACTIONS(901),
    [anon_sym_nsz] = ACTIONS(901),
    [anon_sym_arcp] = ACTIONS(901),
    [anon_sym_contract] = ACTIONS(901),
    [anon_sym_afn] = ACTIONS(901),
    [anon_sym_reassoc] = ACTIONS(901),
    [anon_sym_fast] = ACTIONS(903),
  },
  [224] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(913),
    [aux_sym_metadata_ref_token1] = ACTIONS(913),
    [sym_string] = ACTIONS(913),
    [anon_sym_no_cfi] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_internal] = ACTIONS(913),
    [anon_sym_weak] = ACTIONS(915),
    [anon_sym_weak_odr] = ACTIONS(913),
    [anon_sym_linkonce] = ACTIONS(915),
    [anon_sym_linkonce_odr] = ACTIONS(913),
    [anon_sym_available_externally] = ACTIONS(913),
    [anon_sym_appending] = ACTIONS(913),
    [anon_sym_common] = ACTIONS(913),
    [anon_sym_extern_weak] = ACTIONS(913),
    [anon_sym_external] = ACTIONS(913),
    [anon_sym_dso_local] = ACTIONS(915),
    [anon_sym_dso_local_equivalent] = ACTIONS(913),
    [anon_sym_dso_preemptable] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_hidden] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_dllimport] = ACTIONS(913),
    [anon_sym_dllexport] = ACTIONS(913),
    [anon_sym_ccc] = ACTIONS(913),
    [anon_sym_fastcc] = ACTIONS(913),
    [anon_sym_coldcc] = ACTIONS(913),
    [anon_sym_webkit_jscc] = ACTIONS(915),
    [anon_sym_anyregcc] = ACTIONS(913),
    [anon_sym_preserve_mostcc] = ACTIONS(913),
    [anon_sym_preserve_allcc] = ACTIONS(913),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(915),
    [anon_sym_tailcc] = ACTIONS(913),
    [anon_sym_swiftcc] = ACTIONS(915),
    [anon_sym_swifttailcc] = ACTIONS(915),
    [anon_sym_cfguard_checkcc] = ACTIONS(913),
    [aux_sym_calling_conv_token1] = ACTIONS(915),
    [aux_sym_calling_conv_token2] = ACTIONS(913),
    [aux_sym_calling_conv_token3] = ACTIONS(913),
    [aux_sym_calling_conv_token4] = ACTIONS(913),
    [aux_sym_calling_conv_token5] = ACTIONS(913),
    [aux_sym_calling_conv_token6] = ACTIONS(913),
    [aux_sym_calling_conv_token7] = ACTIONS(913),
    [aux_sym_calling_conv_token8] = ACTIONS(913),
    [aux_sym_calling_conv_token9] = ACTIONS(913),
    [aux_sym_calling_conv_token10] = ACTIONS(915),
    [anon_sym_ghccc] = ACTIONS(913),
    [aux_sym_calling_conv_token11] = ACTIONS(915),
    [aux_sym_calling_conv_token12] = ACTIONS(913),
    [aux_sym_calling_conv_token13] = ACTIONS(915),
    [aux_sym_calling_conv_token14] = ACTIONS(913),
    [anon_sym_cc] = ACTIONS(915),
    [anon_sym_unnamed_addr] = ACTIONS(913),
    [anon_sym_local_unnamed_addr] = ACTIONS(913),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_half] = ACTIONS(913),
    [anon_sym_bfloat] = ACTIONS(913),
    [anon_sym_float] = ACTIONS(913),
    [anon_sym_double] = ACTIONS(913),
    [anon_sym_x86_fp80] = ACTIONS(915),
    [anon_sym_fp128] = ACTIONS(913),
    [anon_sym_ppc_fp128] = ACTIONS(913),
    [anon_sym_label] = ACTIONS(913),
    [anon_sym_metadata] = ACTIONS(913),
    [anon_sym_x86_mmx] = ACTIONS(915),
    [anon_sym_x86_amx] = ACTIONS(915),
    [anon_sym_token] = ACTIONS(913),
    [anon_sym_opaque] = ACTIONS(913),
    [anon_sym_ptr] = ACTIONS(913),
    [aux_sym_type_keyword_token1] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_LT_LBRACE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_align] = ACTIONS(915),
    [anon_sym_alignstack] = ACTIONS(913),
    [anon_sym_allocsize] = ACTIONS(913),
    [anon_sym_alwaysinline] = ACTIONS(913),
    [anon_sym_builtin] = ACTIONS(913),
    [anon_sym_cold] = ACTIONS(915),
    [anon_sym_convergent] = ACTIONS(913),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(913),
    [anon_sym_hot] = ACTIONS(913),
    [anon_sym_inaccessiblememonly] = ACTIONS(913),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(913),
    [anon_sym_inlinehint] = ACTIONS(913),
    [anon_sym_jumptable] = ACTIONS(913),
    [anon_sym_minsize] = ACTIONS(913),
    [anon_sym_naked] = ACTIONS(913),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(913),
    [anon_sym_nobuiltin] = ACTIONS(913),
    [anon_sym_noduplicate] = ACTIONS(913),
    [anon_sym_nofree] = ACTIONS(913),
    [anon_sym_noimplicitfloat] = ACTIONS(913),
    [anon_sym_noinline] = ACTIONS(913),
    [anon_sym_nomerge] = ACTIONS(913),
    [anon_sym_nonlazybind] = ACTIONS(913),
    [anon_sym_noprofile] = ACTIONS(913),
    [anon_sym_noredzone] = ACTIONS(913),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(913),
    [anon_sym_noreturn] = ACTIONS(913),
    [anon_sym_norecurse] = ACTIONS(913),
    [anon_sym_willreturn] = ACTIONS(913),
    [anon_sym_nosync] = ACTIONS(913),
    [anon_sym_nounwind] = ACTIONS(913),
    [anon_sym_nosanitize_coverage] = ACTIONS(913),
    [anon_sym_null_pointer_is_valid] = ACTIONS(913),
    [anon_sym_optforfuzzing] = ACTIONS(913),
    [anon_sym_optnone] = ACTIONS(913),
    [anon_sym_optsize] = ACTIONS(913),
    [anon_sym_readnone] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_writeonly] = ACTIONS(913),
    [anon_sym_argmemonly] = ACTIONS(913),
    [anon_sym_returns_twice] = ACTIONS(913),
    [anon_sym_safestack] = ACTIONS(913),
    [anon_sym_sanitize_address] = ACTIONS(913),
    [anon_sym_sanitize_memory] = ACTIONS(913),
    [anon_sym_sanitize_thread] = ACTIONS(913),
    [anon_sym_sanitize_hwaddress] = ACTIONS(913),
    [anon_sym_sanitize_memtag] = ACTIONS(913),
    [anon_sym_speculative_load_hardening] = ACTIONS(913),
    [anon_sym_speculatable] = ACTIONS(913),
    [anon_sym_ssp] = ACTIONS(915),
    [anon_sym_sspstrong] = ACTIONS(913),
    [anon_sym_sspreq] = ACTIONS(913),
    [anon_sym_strictfp] = ACTIONS(913),
    [anon_sym_uwtable] = ACTIONS(913),
    [anon_sym_nocf_check] = ACTIONS(913),
    [anon_sym_shadowcallstack] = ACTIONS(913),
    [anon_sym_mustprogress] = ACTIONS(913),
    [anon_sym_vscale_range] = ACTIONS(913),
    [anon_sym_preallocated] = ACTIONS(913),
    [anon_sym_zeroext] = ACTIONS(913),
    [anon_sym_signext] = ACTIONS(913),
    [anon_sym_inreg] = ACTIONS(913),
    [anon_sym_byval] = ACTIONS(913),
    [anon_sym_byref] = ACTIONS(913),
    [anon_sym_inalloca] = ACTIONS(913),
    [anon_sym_sret] = ACTIONS(913),
    [anon_sym_elementtype] = ACTIONS(913),
    [anon_sym_noalias] = ACTIONS(913),
    [anon_sym_nocapture] = ACTIONS(913),
    [anon_sym_nest] = ACTIONS(913),
    [anon_sym_returned] = ACTIONS(913),
    [anon_sym_nonnull] = ACTIONS(913),
    [anon_sym_dereferenceable] = ACTIONS(915),
    [anon_sym_dereferenceable_or_null] = ACTIONS(913),
    [anon_sym_swiftself] = ACTIONS(915),
    [anon_sym_swiftasync] = ACTIONS(915),
    [anon_sym_swifterror] = ACTIONS(915),
    [anon_sym_immarg] = ACTIONS(913),
    [anon_sym_noundef] = ACTIONS(913),
  },
  [225] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(917),
    [sym_local_var] = ACTIONS(917),
    [sym_string] = ACTIONS(917),
    [anon_sym_no_cfi] = ACTIONS(917),
    [anon_sym_private] = ACTIONS(917),
    [anon_sym_internal] = ACTIONS(917),
    [anon_sym_weak] = ACTIONS(919),
    [anon_sym_weak_odr] = ACTIONS(917),
    [anon_sym_linkonce] = ACTIONS(919),
    [anon_sym_linkonce_odr] = ACTIONS(917),
    [anon_sym_available_externally] = ACTIONS(917),
    [anon_sym_appending] = ACTIONS(917),
    [anon_sym_common] = ACTIONS(917),
    [anon_sym_extern_weak] = ACTIONS(917),
    [anon_sym_external] = ACTIONS(917),
    [anon_sym_dso_local] = ACTIONS(919),
    [anon_sym_dso_local_equivalent] = ACTIONS(917),
    [anon_sym_dso_preemptable] = ACTIONS(917),
    [anon_sym_default] = ACTIONS(917),
    [anon_sym_hidden] = ACTIONS(917),
    [anon_sym_protected] = ACTIONS(917),
    [anon_sym_dllimport] = ACTIONS(917),
    [anon_sym_dllexport] = ACTIONS(917),
    [anon_sym_ccc] = ACTIONS(917),
    [anon_sym_fastcc] = ACTIONS(917),
    [anon_sym_coldcc] = ACTIONS(917),
    [anon_sym_webkit_jscc] = ACTIONS(919),
    [anon_sym_anyregcc] = ACTIONS(917),
    [anon_sym_preserve_mostcc] = ACTIONS(917),
    [anon_sym_preserve_allcc] = ACTIONS(917),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(919),
    [anon_sym_tailcc] = ACTIONS(917),
    [anon_sym_swiftcc] = ACTIONS(919),
    [anon_sym_swifttailcc] = ACTIONS(919),
    [anon_sym_cfguard_checkcc] = ACTIONS(917),
    [aux_sym_calling_conv_token1] = ACTIONS(919),
    [aux_sym_calling_conv_token2] = ACTIONS(917),
    [aux_sym_calling_conv_token3] = ACTIONS(917),
    [aux_sym_calling_conv_token4] = ACTIONS(917),
    [aux_sym_calling_conv_token5] = ACTIONS(917),
    [aux_sym_calling_conv_token6] = ACTIONS(917),
    [aux_sym_calling_conv_token7] = ACTIONS(917),
    [aux_sym_calling_conv_token8] = ACTIONS(917),
    [aux_sym_calling_conv_token9] = ACTIONS(917),
    [aux_sym_calling_conv_token10] = ACTIONS(919),
    [anon_sym_ghccc] = ACTIONS(917),
    [aux_sym_calling_conv_token11] = ACTIONS(919),
    [aux_sym_calling_conv_token12] = ACTIONS(917),
    [aux_sym_calling_conv_token13] = ACTIONS(919),
    [aux_sym_calling_conv_token14] = ACTIONS(917),
    [anon_sym_cc] = ACTIONS(919),
    [anon_sym_unnamed_addr] = ACTIONS(917),
    [anon_sym_local_unnamed_addr] = ACTIONS(917),
    [anon_sym_void] = ACTIONS(917),
    [anon_sym_half] = ACTIONS(917),
    [anon_sym_bfloat] = ACTIONS(917),
    [anon_sym_float] = ACTIONS(917),
    [anon_sym_double] = ACTIONS(917),
    [anon_sym_x86_fp80] = ACTIONS(919),
    [anon_sym_fp128] = ACTIONS(917),
    [anon_sym_ppc_fp128] = ACTIONS(917),
    [anon_sym_label] = ACTIONS(917),
    [anon_sym_metadata] = ACTIONS(917),
    [anon_sym_x86_mmx] = ACTIONS(919),
    [anon_sym_x86_amx] = ACTIONS(919),
    [anon_sym_token] = ACTIONS(917),
    [anon_sym_opaque] = ACTIONS(917),
    [anon_sym_ptr] = ACTIONS(917),
    [aux_sym_type_keyword_token1] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LT_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_align] = ACTIONS(919),
    [anon_sym_alignstack] = ACTIONS(917),
    [anon_sym_allocsize] = ACTIONS(917),
    [anon_sym_alwaysinline] = ACTIONS(917),
    [anon_sym_builtin] = ACTIONS(917),
    [anon_sym_cold] = ACTIONS(919),
    [anon_sym_convergent] = ACTIONS(917),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(917),
    [anon_sym_hot] = ACTIONS(917),
    [anon_sym_inaccessiblememonly] = ACTIONS(917),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(917),
    [anon_sym_inlinehint] = ACTIONS(917),
    [anon_sym_jumptable] = ACTIONS(917),
    [anon_sym_minsize] = ACTIONS(917),
    [anon_sym_naked] = ACTIONS(917),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(917),
    [anon_sym_nobuiltin] = ACTIONS(917),
    [anon_sym_noduplicate] = ACTIONS(917),
    [anon_sym_nofree] = ACTIONS(917),
    [anon_sym_noimplicitfloat] = ACTIONS(917),
    [anon_sym_noinline] = ACTIONS(917),
    [anon_sym_nomerge] = ACTIONS(917),
    [anon_sym_nonlazybind] = ACTIONS(917),
    [anon_sym_noprofile] = ACTIONS(917),
    [anon_sym_noredzone] = ACTIONS(917),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(917),
    [anon_sym_noreturn] = ACTIONS(917),
    [anon_sym_norecurse] = ACTIONS(917),
    [anon_sym_willreturn] = ACTIONS(917),
    [anon_sym_nosync] = ACTIONS(917),
    [anon_sym_nounwind] = ACTIONS(917),
    [anon_sym_nosanitize_coverage] = ACTIONS(917),
    [anon_sym_null_pointer_is_valid] = ACTIONS(917),
    [anon_sym_optforfuzzing] = ACTIONS(917),
    [anon_sym_optnone] = ACTIONS(917),
    [anon_sym_optsize] = ACTIONS(917),
    [anon_sym_readnone] = ACTIONS(917),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_writeonly] = ACTIONS(917),
    [anon_sym_argmemonly] = ACTIONS(917),
    [anon_sym_returns_twice] = ACTIONS(917),
    [anon_sym_safestack] = ACTIONS(917),
    [anon_sym_sanitize_address] = ACTIONS(917),
    [anon_sym_sanitize_memory] = ACTIONS(917),
    [anon_sym_sanitize_thread] = ACTIONS(917),
    [anon_sym_sanitize_hwaddress] = ACTIONS(917),
    [anon_sym_sanitize_memtag] = ACTIONS(917),
    [anon_sym_speculative_load_hardening] = ACTIONS(917),
    [anon_sym_speculatable] = ACTIONS(917),
    [anon_sym_ssp] = ACTIONS(919),
    [anon_sym_sspstrong] = ACTIONS(917),
    [anon_sym_sspreq] = ACTIONS(917),
    [anon_sym_strictfp] = ACTIONS(917),
    [anon_sym_uwtable] = ACTIONS(917),
    [anon_sym_nocf_check] = ACTIONS(917),
    [anon_sym_shadowcallstack] = ACTIONS(917),
    [anon_sym_mustprogress] = ACTIONS(917),
    [anon_sym_vscale_range] = ACTIONS(917),
    [anon_sym_preallocated] = ACTIONS(917),
    [anon_sym_zeroext] = ACTIONS(917),
    [anon_sym_signext] = ACTIONS(917),
    [anon_sym_inreg] = ACTIONS(917),
    [anon_sym_byval] = ACTIONS(917),
    [anon_sym_byref] = ACTIONS(917),
    [anon_sym_inalloca] = ACTIONS(917),
    [anon_sym_sret] = ACTIONS(917),
    [anon_sym_elementtype] = ACTIONS(917),
    [anon_sym_noalias] = ACTIONS(917),
    [anon_sym_nocapture] = ACTIONS(917),
    [anon_sym_nest] = ACTIONS(917),
    [anon_sym_returned] = ACTIONS(917),
    [anon_sym_nonnull] = ACTIONS(917),
    [anon_sym_dereferenceable] = ACTIONS(919),
    [anon_sym_dereferenceable_or_null] = ACTIONS(917),
    [anon_sym_swiftself] = ACTIONS(919),
    [anon_sym_swiftasync] = ACTIONS(919),
    [anon_sym_swifterror] = ACTIONS(919),
    [anon_sym_immarg] = ACTIONS(917),
    [anon_sym_noundef] = ACTIONS(917),
  },
  [226] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(689),
    [aux_sym_metadata_ref_token1] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [anon_sym_no_cfi] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_internal] = ACTIONS(689),
    [anon_sym_weak] = ACTIONS(691),
    [anon_sym_weak_odr] = ACTIONS(689),
    [anon_sym_linkonce] = ACTIONS(691),
    [anon_sym_linkonce_odr] = ACTIONS(689),
    [anon_sym_available_externally] = ACTIONS(689),
    [anon_sym_appending] = ACTIONS(689),
    [anon_sym_common] = ACTIONS(689),
    [anon_sym_extern_weak] = ACTIONS(689),
    [anon_sym_external] = ACTIONS(689),
    [anon_sym_dso_local] = ACTIONS(691),
    [anon_sym_dso_local_equivalent] = ACTIONS(689),
    [anon_sym_dso_preemptable] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_hidden] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_dllimport] = ACTIONS(689),
    [anon_sym_dllexport] = ACTIONS(689),
    [anon_sym_ccc] = ACTIONS(689),
    [anon_sym_fastcc] = ACTIONS(689),
    [anon_sym_coldcc] = ACTIONS(689),
    [anon_sym_webkit_jscc] = ACTIONS(691),
    [anon_sym_anyregcc] = ACTIONS(689),
    [anon_sym_preserve_mostcc] = ACTIONS(689),
    [anon_sym_preserve_allcc] = ACTIONS(689),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(691),
    [anon_sym_tailcc] = ACTIONS(689),
    [anon_sym_swiftcc] = ACTIONS(691),
    [anon_sym_swifttailcc] = ACTIONS(691),
    [anon_sym_cfguard_checkcc] = ACTIONS(689),
    [aux_sym_calling_conv_token1] = ACTIONS(691),
    [aux_sym_calling_conv_token2] = ACTIONS(689),
    [aux_sym_calling_conv_token3] = ACTIONS(689),
    [aux_sym_calling_conv_token4] = ACTIONS(689),
    [aux_sym_calling_conv_token5] = ACTIONS(689),
    [aux_sym_calling_conv_token6] = ACTIONS(689),
    [aux_sym_calling_conv_token7] = ACTIONS(689),
    [aux_sym_calling_conv_token8] = ACTIONS(689),
    [aux_sym_calling_conv_token9] = ACTIONS(689),
    [aux_sym_calling_conv_token10] = ACTIONS(691),
    [anon_sym_ghccc] = ACTIONS(689),
    [aux_sym_calling_conv_token11] = ACTIONS(691),
    [aux_sym_calling_conv_token12] = ACTIONS(689),
    [aux_sym_calling_conv_token13] = ACTIONS(691),
    [aux_sym_calling_conv_token14] = ACTIONS(689),
    [anon_sym_cc] = ACTIONS(691),
    [anon_sym_unnamed_addr] = ACTIONS(689),
    [anon_sym_local_unnamed_addr] = ACTIONS(689),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_half] = ACTIONS(689),
    [anon_sym_bfloat] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_double] = ACTIONS(689),
    [anon_sym_x86_fp80] = ACTIONS(691),
    [anon_sym_fp128] = ACTIONS(689),
    [anon_sym_ppc_fp128] = ACTIONS(689),
    [anon_sym_label] = ACTIONS(689),
    [anon_sym_metadata] = ACTIONS(689),
    [anon_sym_x86_mmx] = ACTIONS(691),
    [anon_sym_x86_amx] = ACTIONS(691),
    [anon_sym_token] = ACTIONS(689),
    [anon_sym_opaque] = ACTIONS(689),
    [anon_sym_ptr] = ACTIONS(689),
    [aux_sym_type_keyword_token1] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_LT_LBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(689),
    [anon_sym_allocsize] = ACTIONS(689),
    [anon_sym_alwaysinline] = ACTIONS(689),
    [anon_sym_builtin] = ACTIONS(689),
    [anon_sym_cold] = ACTIONS(691),
    [anon_sym_convergent] = ACTIONS(689),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(689),
    [anon_sym_hot] = ACTIONS(689),
    [anon_sym_inaccessiblememonly] = ACTIONS(689),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(689),
    [anon_sym_inlinehint] = ACTIONS(689),
    [anon_sym_jumptable] = ACTIONS(689),
    [anon_sym_minsize] = ACTIONS(689),
    [anon_sym_naked] = ACTIONS(689),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(689),
    [anon_sym_nobuiltin] = ACTIONS(689),
    [anon_sym_noduplicate] = ACTIONS(689),
    [anon_sym_nofree] = ACTIONS(689),
    [anon_sym_noimplicitfloat] = ACTIONS(689),
    [anon_sym_noinline] = ACTIONS(689),
    [anon_sym_nomerge] = ACTIONS(689),
    [anon_sym_nonlazybind] = ACTIONS(689),
    [anon_sym_noprofile] = ACTIONS(689),
    [anon_sym_noredzone] = ACTIONS(689),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(689),
    [anon_sym_noreturn] = ACTIONS(689),
    [anon_sym_norecurse] = ACTIONS(689),
    [anon_sym_willreturn] = ACTIONS(689),
    [anon_sym_nosync] = ACTIONS(689),
    [anon_sym_nounwind] = ACTIONS(689),
    [anon_sym_nosanitize_coverage] = ACTIONS(689),
    [anon_sym_null_pointer_is_valid] = ACTIONS(689),
    [anon_sym_optforfuzzing] = ACTIONS(689),
    [anon_sym_optnone] = ACTIONS(689),
    [anon_sym_optsize] = ACTIONS(689),
    [anon_sym_readnone] = ACTIONS(689),
    [anon_sym_readonly] = ACTIONS(689),
    [anon_sym_writeonly] = ACTIONS(689),
    [anon_sym_argmemonly] = ACTIONS(689),
    [anon_sym_returns_twice] = ACTIONS(689),
    [anon_sym_safestack] = ACTIONS(689),
    [anon_sym_sanitize_address] = ACTIONS(689),
    [anon_sym_sanitize_memory] = ACTIONS(689),
    [anon_sym_sanitize_thread] = ACTIONS(689),
    [anon_sym_sanitize_hwaddress] = ACTIONS(689),
    [anon_sym_sanitize_memtag] = ACTIONS(689),
    [anon_sym_speculative_load_hardening] = ACTIONS(689),
    [anon_sym_speculatable] = ACTIONS(689),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(689),
    [anon_sym_sspreq] = ACTIONS(689),
    [anon_sym_strictfp] = ACTIONS(689),
    [anon_sym_uwtable] = ACTIONS(689),
    [anon_sym_nocf_check] = ACTIONS(689),
    [anon_sym_shadowcallstack] = ACTIONS(689),
    [anon_sym_mustprogress] = ACTIONS(689),
    [anon_sym_vscale_range] = ACTIONS(689),
    [anon_sym_preallocated] = ACTIONS(689),
    [anon_sym_zeroext] = ACTIONS(689),
    [anon_sym_signext] = ACTIONS(689),
    [anon_sym_inreg] = ACTIONS(689),
    [anon_sym_byval] = ACTIONS(689),
    [anon_sym_byref] = ACTIONS(689),
    [anon_sym_inalloca] = ACTIONS(689),
    [anon_sym_sret] = ACTIONS(689),
    [anon_sym_elementtype] = ACTIONS(689),
    [anon_sym_noalias] = ACTIONS(689),
    [anon_sym_nocapture] = ACTIONS(689),
    [anon_sym_nest] = ACTIONS(689),
    [anon_sym_returned] = ACTIONS(689),
    [anon_sym_nonnull] = ACTIONS(689),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(689),
    [anon_sym_swiftself] = ACTIONS(691),
    [anon_sym_swiftasync] = ACTIONS(691),
    [anon_sym_swifterror] = ACTIONS(691),
    [anon_sym_immarg] = ACTIONS(689),
    [anon_sym_noundef] = ACTIONS(689),
  },
  [227] = {
    [sym_calling_conv] = STATE(384),
    [sym_type] = STATE(343),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1018),
    [sym_param_or_return_attrs] = STATE(383),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(651),
    [sym_fast_math] = STATE(228),
    [aux_sym_function_header_repeat2] = STATE(383),
    [aux_sym_instruction_select_repeat1] = STATE(228),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_nnan] = ACTIONS(901),
    [anon_sym_ninf] = ACTIONS(901),
    [anon_sym_nsz] = ACTIONS(901),
    [anon_sym_arcp] = ACTIONS(901),
    [anon_sym_contract] = ACTIONS(901),
    [anon_sym_afn] = ACTIONS(901),
    [anon_sym_reassoc] = ACTIONS(901),
    [anon_sym_fast] = ACTIONS(903),
  },
  [228] = {
    [sym_calling_conv] = STATE(384),
    [sym_type] = STATE(343),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1018),
    [sym_param_or_return_attrs] = STATE(383),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(605),
    [sym_fast_math] = STATE(234),
    [aux_sym_function_header_repeat2] = STATE(383),
    [aux_sym_instruction_select_repeat1] = STATE(234),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_nnan] = ACTIONS(901),
    [anon_sym_ninf] = ACTIONS(901),
    [anon_sym_nsz] = ACTIONS(901),
    [anon_sym_arcp] = ACTIONS(901),
    [anon_sym_contract] = ACTIONS(901),
    [anon_sym_afn] = ACTIONS(901),
    [anon_sym_reassoc] = ACTIONS(901),
    [anon_sym_fast] = ACTIONS(903),
  },
  [229] = {
    [sym_metadata_ref] = STATE(130),
    [sym_type] = STATE(230),
    [sym_type_keyword] = STATE(262),
    [sym_struct_type] = STATE(262),
    [sym_packed_struct_type] = STATE(262),
    [sym_array_type] = STATE(262),
    [sym_vector_type] = STATE(262),
    [sym_type_and_value] = STATE(173),
    [sym_metadata] = STATE(165),
    [sym_metadata_tuple] = STATE(173),
    [sym_specialized_md] = STATE(173),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(868),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(870),
    [anon_sym_half] = ACTIONS(870),
    [anon_sym_bfloat] = ACTIONS(870),
    [anon_sym_float] = ACTIONS(870),
    [anon_sym_double] = ACTIONS(870),
    [anon_sym_x86_fp80] = ACTIONS(870),
    [anon_sym_fp128] = ACTIONS(870),
    [anon_sym_ppc_fp128] = ACTIONS(870),
    [anon_sym_label] = ACTIONS(870),
    [anon_sym_metadata] = ACTIONS(921),
    [anon_sym_x86_mmx] = ACTIONS(870),
    [anon_sym_x86_amx] = ACTIONS(870),
    [anon_sym_token] = ACTIONS(870),
    [anon_sym_opaque] = ACTIONS(870),
    [anon_sym_ptr] = ACTIONS(870),
    [aux_sym_type_keyword_token1] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(874),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [230] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(170),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(150),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(689),
    [sym_comdat_ref] = ACTIONS(689),
    [sym_global_var] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [aux_sym_metadata_ref_token1] = ACTIONS(689),
    [sym_summary_ref] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [anon_sym_target] = ACTIONS(689),
    [anon_sym_source_filename] = ACTIONS(689),
    [anon_sym_declare] = ACTIONS(689),
    [anon_sym_define] = ACTIONS(689),
    [anon_sym_unnamed_addr] = ACTIONS(689),
    [anon_sym_local_unnamed_addr] = ACTIONS(689),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_half] = ACTIONS(689),
    [anon_sym_bfloat] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_double] = ACTIONS(689),
    [anon_sym_x86_fp80] = ACTIONS(689),
    [anon_sym_fp128] = ACTIONS(689),
    [anon_sym_ppc_fp128] = ACTIONS(689),
    [anon_sym_label] = ACTIONS(689),
    [anon_sym_metadata] = ACTIONS(689),
    [anon_sym_x86_mmx] = ACTIONS(689),
    [anon_sym_x86_amx] = ACTIONS(689),
    [anon_sym_token] = ACTIONS(689),
    [anon_sym_opaque] = ACTIONS(689),
    [anon_sym_ptr] = ACTIONS(689),
    [aux_sym_type_keyword_token1] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_LT_LBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_addrspace] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_section] = ACTIONS(689),
    [anon_sym_partition] = ACTIONS(689),
    [anon_sym_comdat] = ACTIONS(689),
    [anon_sym_gc] = ACTIONS(689),
    [anon_sym_prefix] = ACTIONS(689),
    [anon_sym_prologue] = ACTIONS(689),
    [anon_sym_personality] = ACTIONS(689),
    [anon_sym_alignstack] = ACTIONS(689),
    [anon_sym_allocsize] = ACTIONS(689),
    [anon_sym_alwaysinline] = ACTIONS(689),
    [anon_sym_builtin] = ACTIONS(689),
    [anon_sym_cold] = ACTIONS(689),
    [anon_sym_convergent] = ACTIONS(689),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(689),
    [anon_sym_hot] = ACTIONS(689),
    [anon_sym_inaccessiblememonly] = ACTIONS(689),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(689),
    [anon_sym_inlinehint] = ACTIONS(689),
    [anon_sym_jumptable] = ACTIONS(689),
    [anon_sym_minsize] = ACTIONS(689),
    [anon_sym_naked] = ACTIONS(689),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(689),
    [anon_sym_nobuiltin] = ACTIONS(689),
    [anon_sym_noduplicate] = ACTIONS(689),
    [anon_sym_nofree] = ACTIONS(689),
    [anon_sym_noimplicitfloat] = ACTIONS(689),
    [anon_sym_noinline] = ACTIONS(689),
    [anon_sym_nomerge] = ACTIONS(689),
    [anon_sym_nonlazybind] = ACTIONS(689),
    [anon_sym_noprofile] = ACTIONS(689),
    [anon_sym_noredzone] = ACTIONS(689),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(689),
    [anon_sym_noreturn] = ACTIONS(689),
    [anon_sym_norecurse] = ACTIONS(689),
    [anon_sym_willreturn] = ACTIONS(689),
    [anon_sym_nosync] = ACTIONS(689),
    [anon_sym_nounwind] = ACTIONS(689),
    [anon_sym_nosanitize_coverage] = ACTIONS(689),
    [anon_sym_null_pointer_is_valid] = ACTIONS(689),
    [anon_sym_optforfuzzing] = ACTIONS(689),
    [anon_sym_optnone] = ACTIONS(689),
    [anon_sym_optsize] = ACTIONS(689),
    [anon_sym_readnone] = ACTIONS(689),
    [anon_sym_readonly] = ACTIONS(689),
    [anon_sym_writeonly] = ACTIONS(689),
    [anon_sym_argmemonly] = ACTIONS(689),
    [anon_sym_returns_twice] = ACTIONS(689),
    [anon_sym_safestack] = ACTIONS(689),
    [anon_sym_sanitize_address] = ACTIONS(689),
    [anon_sym_sanitize_memory] = ACTIONS(689),
    [anon_sym_sanitize_thread] = ACTIONS(689),
    [anon_sym_sanitize_hwaddress] = ACTIONS(689),
    [anon_sym_sanitize_memtag] = ACTIONS(689),
    [anon_sym_speculative_load_hardening] = ACTIONS(689),
    [anon_sym_speculatable] = ACTIONS(689),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(689),
    [anon_sym_sspreq] = ACTIONS(689),
    [anon_sym_strictfp] = ACTIONS(689),
    [anon_sym_uwtable] = ACTIONS(689),
    [anon_sym_nocf_check] = ACTIONS(689),
    [anon_sym_shadowcallstack] = ACTIONS(689),
    [anon_sym_mustprogress] = ACTIONS(689),
    [anon_sym_vscale_range] = ACTIONS(689),
    [anon_sym_preallocated] = ACTIONS(689),
    [anon_sym_zeroext] = ACTIONS(689),
    [anon_sym_signext] = ACTIONS(689),
    [anon_sym_inreg] = ACTIONS(689),
    [anon_sym_byval] = ACTIONS(689),
    [anon_sym_byref] = ACTIONS(689),
    [anon_sym_inalloca] = ACTIONS(689),
    [anon_sym_sret] = ACTIONS(689),
    [anon_sym_elementtype] = ACTIONS(689),
    [anon_sym_noalias] = ACTIONS(689),
    [anon_sym_nocapture] = ACTIONS(689),
    [anon_sym_nest] = ACTIONS(689),
    [anon_sym_returned] = ACTIONS(689),
    [anon_sym_nonnull] = ACTIONS(689),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(689),
    [anon_sym_swiftself] = ACTIONS(689),
    [anon_sym_swiftasync] = ACTIONS(689),
    [anon_sym_swifterror] = ACTIONS(689),
    [anon_sym_immarg] = ACTIONS(689),
    [anon_sym_noundef] = ACTIONS(689),
    [anon_sym_to] = ACTIONS(691),
    [anon_sym_unwind] = ACTIONS(689),
    [anon_sym_null] = ACTIONS(691),
    [anon_sym_unordered] = ACTIONS(689),
    [anon_sym_monotonic] = ACTIONS(689),
    [anon_sym_acquire] = ACTIONS(689),
    [anon_sym_release] = ACTIONS(689),
    [anon_sym_acq_rel] = ACTIONS(689),
    [anon_sym_seq_cst] = ACTIONS(689),
    [anon_sym_syncscope] = ACTIONS(689),
    [anon_sym_uselistorder] = ACTIONS(691),
    [anon_sym_uselistorder_bb] = ACTIONS(689),
    [anon_sym_module] = ACTIONS(689),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_attributes] = ACTIONS(689),
  },
  [232] = {
    [sym_calling_conv] = STATE(387),
    [sym_type] = STATE(346),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1001),
    [sym_param_or_return_attrs] = STATE(385),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(1540),
    [aux_sym_function_header_repeat2] = STATE(385),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [233] = {
    [sym_calling_conv] = STATE(387),
    [sym_type] = STATE(346),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1001),
    [sym_param_or_return_attrs] = STATE(385),
    [sym_attribute_name] = STATE(389),
    [sym__call_part] = STATE(1550),
    [aux_sym_function_header_repeat2] = STATE(385),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(741),
    [anon_sym_ccc] = ACTIONS(741),
    [anon_sym_fastcc] = ACTIONS(741),
    [anon_sym_coldcc] = ACTIONS(741),
    [anon_sym_webkit_jscc] = ACTIONS(743),
    [anon_sym_anyregcc] = ACTIONS(741),
    [anon_sym_preserve_mostcc] = ACTIONS(741),
    [anon_sym_preserve_allcc] = ACTIONS(741),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(743),
    [anon_sym_tailcc] = ACTIONS(741),
    [anon_sym_swiftcc] = ACTIONS(743),
    [anon_sym_swifttailcc] = ACTIONS(743),
    [anon_sym_cfguard_checkcc] = ACTIONS(741),
    [aux_sym_calling_conv_token1] = ACTIONS(743),
    [aux_sym_calling_conv_token2] = ACTIONS(741),
    [aux_sym_calling_conv_token3] = ACTIONS(741),
    [aux_sym_calling_conv_token4] = ACTIONS(741),
    [aux_sym_calling_conv_token5] = ACTIONS(741),
    [aux_sym_calling_conv_token6] = ACTIONS(741),
    [aux_sym_calling_conv_token7] = ACTIONS(741),
    [aux_sym_calling_conv_token8] = ACTIONS(741),
    [aux_sym_calling_conv_token9] = ACTIONS(741),
    [aux_sym_calling_conv_token10] = ACTIONS(743),
    [anon_sym_ghccc] = ACTIONS(741),
    [aux_sym_calling_conv_token11] = ACTIONS(743),
    [aux_sym_calling_conv_token12] = ACTIONS(741),
    [aux_sym_calling_conv_token13] = ACTIONS(743),
    [aux_sym_calling_conv_token14] = ACTIONS(741),
    [anon_sym_cc] = ACTIONS(745),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [234] = {
    [sym_fast_math] = STATE(234),
    [aux_sym_instruction_select_repeat1] = STATE(234),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(923),
    [sym_string] = ACTIONS(923),
    [anon_sym_ccc] = ACTIONS(923),
    [anon_sym_fastcc] = ACTIONS(923),
    [anon_sym_coldcc] = ACTIONS(923),
    [anon_sym_webkit_jscc] = ACTIONS(925),
    [anon_sym_anyregcc] = ACTIONS(923),
    [anon_sym_preserve_mostcc] = ACTIONS(923),
    [anon_sym_preserve_allcc] = ACTIONS(923),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(925),
    [anon_sym_tailcc] = ACTIONS(923),
    [anon_sym_swiftcc] = ACTIONS(925),
    [anon_sym_swifttailcc] = ACTIONS(925),
    [anon_sym_cfguard_checkcc] = ACTIONS(923),
    [aux_sym_calling_conv_token1] = ACTIONS(925),
    [aux_sym_calling_conv_token2] = ACTIONS(923),
    [aux_sym_calling_conv_token3] = ACTIONS(923),
    [aux_sym_calling_conv_token4] = ACTIONS(923),
    [aux_sym_calling_conv_token5] = ACTIONS(923),
    [aux_sym_calling_conv_token6] = ACTIONS(923),
    [aux_sym_calling_conv_token7] = ACTIONS(923),
    [aux_sym_calling_conv_token8] = ACTIONS(923),
    [aux_sym_calling_conv_token9] = ACTIONS(923),
    [aux_sym_calling_conv_token10] = ACTIONS(925),
    [anon_sym_ghccc] = ACTIONS(923),
    [aux_sym_calling_conv_token11] = ACTIONS(925),
    [aux_sym_calling_conv_token12] = ACTIONS(923),
    [aux_sym_calling_conv_token13] = ACTIONS(925),
    [aux_sym_calling_conv_token14] = ACTIONS(923),
    [anon_sym_cc] = ACTIONS(925),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_half] = ACTIONS(923),
    [anon_sym_bfloat] = ACTIONS(923),
    [anon_sym_float] = ACTIONS(923),
    [anon_sym_double] = ACTIONS(923),
    [anon_sym_x86_fp80] = ACTIONS(925),
    [anon_sym_fp128] = ACTIONS(923),
    [anon_sym_ppc_fp128] = ACTIONS(923),
    [anon_sym_label] = ACTIONS(923),
    [anon_sym_metadata] = ACTIONS(923),
    [anon_sym_x86_mmx] = ACTIONS(925),
    [anon_sym_x86_amx] = ACTIONS(925),
    [anon_sym_token] = ACTIONS(923),
    [anon_sym_opaque] = ACTIONS(923),
    [anon_sym_ptr] = ACTIONS(923),
    [aux_sym_type_keyword_token1] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_LT_LBRACE] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_addrspace] = ACTIONS(923),
    [anon_sym_align] = ACTIONS(925),
    [anon_sym_alignstack] = ACTIONS(923),
    [anon_sym_allocsize] = ACTIONS(923),
    [anon_sym_alwaysinline] = ACTIONS(923),
    [anon_sym_builtin] = ACTIONS(923),
    [anon_sym_cold] = ACTIONS(925),
    [anon_sym_convergent] = ACTIONS(923),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(923),
    [anon_sym_hot] = ACTIONS(923),
    [anon_sym_inaccessiblememonly] = ACTIONS(923),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(923),
    [anon_sym_inlinehint] = ACTIONS(923),
    [anon_sym_jumptable] = ACTIONS(923),
    [anon_sym_minsize] = ACTIONS(923),
    [anon_sym_naked] = ACTIONS(923),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(923),
    [anon_sym_nobuiltin] = ACTIONS(923),
    [anon_sym_noduplicate] = ACTIONS(923),
    [anon_sym_nofree] = ACTIONS(923),
    [anon_sym_noimplicitfloat] = ACTIONS(923),
    [anon_sym_noinline] = ACTIONS(923),
    [anon_sym_nomerge] = ACTIONS(923),
    [anon_sym_nonlazybind] = ACTIONS(923),
    [anon_sym_noprofile] = ACTIONS(923),
    [anon_sym_noredzone] = ACTIONS(923),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(923),
    [anon_sym_noreturn] = ACTIONS(923),
    [anon_sym_norecurse] = ACTIONS(923),
    [anon_sym_willreturn] = ACTIONS(923),
    [anon_sym_nosync] = ACTIONS(923),
    [anon_sym_nounwind] = ACTIONS(923),
    [anon_sym_nosanitize_coverage] = ACTIONS(923),
    [anon_sym_null_pointer_is_valid] = ACTIONS(923),
    [anon_sym_optforfuzzing] = ACTIONS(923),
    [anon_sym_optnone] = ACTIONS(923),
    [anon_sym_optsize] = ACTIONS(923),
    [anon_sym_readnone] = ACTIONS(923),
    [anon_sym_readonly] = ACTIONS(923),
    [anon_sym_writeonly] = ACTIONS(923),
    [anon_sym_argmemonly] = ACTIONS(923),
    [anon_sym_returns_twice] = ACTIONS(923),
    [anon_sym_safestack] = ACTIONS(923),
    [anon_sym_sanitize_address] = ACTIONS(923),
    [anon_sym_sanitize_memory] = ACTIONS(923),
    [anon_sym_sanitize_thread] = ACTIONS(923),
    [anon_sym_sanitize_hwaddress] = ACTIONS(923),
    [anon_sym_sanitize_memtag] = ACTIONS(923),
    [anon_sym_speculative_load_hardening] = ACTIONS(923),
    [anon_sym_speculatable] = ACTIONS(923),
    [anon_sym_ssp] = ACTIONS(925),
    [anon_sym_sspstrong] = ACTIONS(923),
    [anon_sym_sspreq] = ACTIONS(923),
    [anon_sym_strictfp] = ACTIONS(923),
    [anon_sym_uwtable] = ACTIONS(923),
    [anon_sym_nocf_check] = ACTIONS(923),
    [anon_sym_shadowcallstack] = ACTIONS(923),
    [anon_sym_mustprogress] = ACTIONS(923),
    [anon_sym_vscale_range] = ACTIONS(923),
    [anon_sym_preallocated] = ACTIONS(923),
    [anon_sym_zeroext] = ACTIONS(923),
    [anon_sym_signext] = ACTIONS(923),
    [anon_sym_inreg] = ACTIONS(923),
    [anon_sym_byval] = ACTIONS(923),
    [anon_sym_byref] = ACTIONS(923),
    [anon_sym_inalloca] = ACTIONS(923),
    [anon_sym_sret] = ACTIONS(923),
    [anon_sym_elementtype] = ACTIONS(923),
    [anon_sym_noalias] = ACTIONS(923),
    [anon_sym_nocapture] = ACTIONS(923),
    [anon_sym_nest] = ACTIONS(923),
    [anon_sym_returned] = ACTIONS(923),
    [anon_sym_nonnull] = ACTIONS(923),
    [anon_sym_dereferenceable] = ACTIONS(925),
    [anon_sym_dereferenceable_or_null] = ACTIONS(923),
    [anon_sym_swiftself] = ACTIONS(925),
    [anon_sym_swiftasync] = ACTIONS(925),
    [anon_sym_swifterror] = ACTIONS(925),
    [anon_sym_immarg] = ACTIONS(923),
    [anon_sym_noundef] = ACTIONS(923),
    [anon_sym_nnan] = ACTIONS(927),
    [anon_sym_ninf] = ACTIONS(927),
    [anon_sym_nsz] = ACTIONS(927),
    [anon_sym_arcp] = ACTIONS(927),
    [anon_sym_contract] = ACTIONS(927),
    [anon_sym_afn] = ACTIONS(927),
    [anon_sym_reassoc] = ACTIONS(927),
    [anon_sym_fast] = ACTIONS(930),
  },
  [235] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(235),
    [aux_sym_type_repeat1] = STATE(1131),
    [aux_sym_type_repeat2] = STATE(235),
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(250),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(250),
    [anon_sym_x86_amx] = ACTIONS(250),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(252),
    [anon_sym_unwind] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_cleanup] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_catch] = ACTIONS(250),
    [anon_sym_filter] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_unordered] = ACTIONS(250),
    [anon_sym_monotonic] = ACTIONS(250),
    [anon_sym_acquire] = ACTIONS(250),
    [anon_sym_release] = ACTIONS(250),
    [anon_sym_acq_rel] = ACTIONS(250),
    [anon_sym_seq_cst] = ACTIONS(250),
    [anon_sym_syncscope] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_asm] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [236] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(939),
    [sym_string] = ACTIONS(939),
    [anon_sym_ccc] = ACTIONS(939),
    [anon_sym_fastcc] = ACTIONS(939),
    [anon_sym_coldcc] = ACTIONS(939),
    [anon_sym_webkit_jscc] = ACTIONS(941),
    [anon_sym_anyregcc] = ACTIONS(939),
    [anon_sym_preserve_mostcc] = ACTIONS(939),
    [anon_sym_preserve_allcc] = ACTIONS(939),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(941),
    [anon_sym_tailcc] = ACTIONS(939),
    [anon_sym_swiftcc] = ACTIONS(941),
    [anon_sym_swifttailcc] = ACTIONS(941),
    [anon_sym_cfguard_checkcc] = ACTIONS(939),
    [aux_sym_calling_conv_token1] = ACTIONS(941),
    [aux_sym_calling_conv_token2] = ACTIONS(939),
    [aux_sym_calling_conv_token3] = ACTIONS(939),
    [aux_sym_calling_conv_token4] = ACTIONS(939),
    [aux_sym_calling_conv_token5] = ACTIONS(939),
    [aux_sym_calling_conv_token6] = ACTIONS(939),
    [aux_sym_calling_conv_token7] = ACTIONS(939),
    [aux_sym_calling_conv_token8] = ACTIONS(939),
    [aux_sym_calling_conv_token9] = ACTIONS(939),
    [aux_sym_calling_conv_token10] = ACTIONS(941),
    [anon_sym_ghccc] = ACTIONS(939),
    [aux_sym_calling_conv_token11] = ACTIONS(941),
    [aux_sym_calling_conv_token12] = ACTIONS(939),
    [aux_sym_calling_conv_token13] = ACTIONS(941),
    [aux_sym_calling_conv_token14] = ACTIONS(939),
    [anon_sym_cc] = ACTIONS(941),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_half] = ACTIONS(939),
    [anon_sym_bfloat] = ACTIONS(939),
    [anon_sym_float] = ACTIONS(939),
    [anon_sym_double] = ACTIONS(939),
    [anon_sym_x86_fp80] = ACTIONS(941),
    [anon_sym_fp128] = ACTIONS(939),
    [anon_sym_ppc_fp128] = ACTIONS(939),
    [anon_sym_label] = ACTIONS(939),
    [anon_sym_metadata] = ACTIONS(939),
    [anon_sym_x86_mmx] = ACTIONS(941),
    [anon_sym_x86_amx] = ACTIONS(941),
    [anon_sym_token] = ACTIONS(939),
    [anon_sym_opaque] = ACTIONS(939),
    [anon_sym_ptr] = ACTIONS(939),
    [aux_sym_type_keyword_token1] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_LT_LBRACE] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(939),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_alignstack] = ACTIONS(939),
    [anon_sym_allocsize] = ACTIONS(939),
    [anon_sym_alwaysinline] = ACTIONS(939),
    [anon_sym_builtin] = ACTIONS(939),
    [anon_sym_cold] = ACTIONS(941),
    [anon_sym_convergent] = ACTIONS(939),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(939),
    [anon_sym_hot] = ACTIONS(939),
    [anon_sym_inaccessiblememonly] = ACTIONS(939),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(939),
    [anon_sym_inlinehint] = ACTIONS(939),
    [anon_sym_jumptable] = ACTIONS(939),
    [anon_sym_minsize] = ACTIONS(939),
    [anon_sym_naked] = ACTIONS(939),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(939),
    [anon_sym_nobuiltin] = ACTIONS(939),
    [anon_sym_noduplicate] = ACTIONS(939),
    [anon_sym_nofree] = ACTIONS(939),
    [anon_sym_noimplicitfloat] = ACTIONS(939),
    [anon_sym_noinline] = ACTIONS(939),
    [anon_sym_nomerge] = ACTIONS(939),
    [anon_sym_nonlazybind] = ACTIONS(939),
    [anon_sym_noprofile] = ACTIONS(939),
    [anon_sym_noredzone] = ACTIONS(939),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(939),
    [anon_sym_noreturn] = ACTIONS(939),
    [anon_sym_norecurse] = ACTIONS(939),
    [anon_sym_willreturn] = ACTIONS(939),
    [anon_sym_nosync] = ACTIONS(939),
    [anon_sym_nounwind] = ACTIONS(939),
    [anon_sym_nosanitize_coverage] = ACTIONS(939),
    [anon_sym_null_pointer_is_valid] = ACTIONS(939),
    [anon_sym_optforfuzzing] = ACTIONS(939),
    [anon_sym_optnone] = ACTIONS(939),
    [anon_sym_optsize] = ACTIONS(939),
    [anon_sym_readnone] = ACTIONS(939),
    [anon_sym_readonly] = ACTIONS(939),
    [anon_sym_writeonly] = ACTIONS(939),
    [anon_sym_argmemonly] = ACTIONS(939),
    [anon_sym_returns_twice] = ACTIONS(939),
    [anon_sym_safestack] = ACTIONS(939),
    [anon_sym_sanitize_address] = ACTIONS(939),
    [anon_sym_sanitize_memory] = ACTIONS(939),
    [anon_sym_sanitize_thread] = ACTIONS(939),
    [anon_sym_sanitize_hwaddress] = ACTIONS(939),
    [anon_sym_sanitize_memtag] = ACTIONS(939),
    [anon_sym_speculative_load_hardening] = ACTIONS(939),
    [anon_sym_speculatable] = ACTIONS(939),
    [anon_sym_ssp] = ACTIONS(941),
    [anon_sym_sspstrong] = ACTIONS(939),
    [anon_sym_sspreq] = ACTIONS(939),
    [anon_sym_strictfp] = ACTIONS(939),
    [anon_sym_uwtable] = ACTIONS(939),
    [anon_sym_nocf_check] = ACTIONS(939),
    [anon_sym_shadowcallstack] = ACTIONS(939),
    [anon_sym_mustprogress] = ACTIONS(939),
    [anon_sym_vscale_range] = ACTIONS(939),
    [anon_sym_preallocated] = ACTIONS(939),
    [anon_sym_zeroext] = ACTIONS(939),
    [anon_sym_signext] = ACTIONS(939),
    [anon_sym_inreg] = ACTIONS(939),
    [anon_sym_byval] = ACTIONS(939),
    [anon_sym_byref] = ACTIONS(939),
    [anon_sym_inalloca] = ACTIONS(939),
    [anon_sym_sret] = ACTIONS(939),
    [anon_sym_elementtype] = ACTIONS(939),
    [anon_sym_noalias] = ACTIONS(939),
    [anon_sym_nocapture] = ACTIONS(939),
    [anon_sym_nest] = ACTIONS(939),
    [anon_sym_returned] = ACTIONS(939),
    [anon_sym_nonnull] = ACTIONS(939),
    [anon_sym_dereferenceable] = ACTIONS(941),
    [anon_sym_dereferenceable_or_null] = ACTIONS(939),
    [anon_sym_swiftself] = ACTIONS(941),
    [anon_sym_swiftasync] = ACTIONS(941),
    [anon_sym_swifterror] = ACTIONS(941),
    [anon_sym_immarg] = ACTIONS(939),
    [anon_sym_noundef] = ACTIONS(939),
    [anon_sym_nnan] = ACTIONS(939),
    [anon_sym_ninf] = ACTIONS(939),
    [anon_sym_nsz] = ACTIONS(939),
    [anon_sym_arcp] = ACTIONS(939),
    [anon_sym_contract] = ACTIONS(939),
    [anon_sym_afn] = ACTIONS(939),
    [anon_sym_reassoc] = ACTIONS(939),
    [anon_sym_fast] = ACTIONS(941),
  },
  [237] = {
    [sym_addrspace] = STATE(1515),
    [aux_sym_type_repeat1] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(269),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(269),
    [anon_sym_x86_amx] = ACTIONS(269),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_RBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(271),
    [anon_sym_unwind] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_cleanup] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_filter] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_unordered] = ACTIONS(269),
    [anon_sym_monotonic] = ACTIONS(269),
    [anon_sym_acquire] = ACTIONS(269),
    [anon_sym_release] = ACTIONS(269),
    [anon_sym_acq_rel] = ACTIONS(269),
    [anon_sym_seq_cst] = ACTIONS(269),
    [anon_sym_syncscope] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_asm] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [238] = {
    [sym_addrspace] = STATE(259),
    [sym_argument_list] = STATE(239),
    [aux_sym_type_repeat1] = STATE(246),
    [aux_sym_type_repeat2] = STATE(239),
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_summary_ref] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_target] = ACTIONS(234),
    [anon_sym_source_filename] = ACTIONS(234),
    [anon_sym_declare] = ACTIONS(234),
    [anon_sym_define] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(234),
    [anon_sym_half] = ACTIONS(234),
    [anon_sym_bfloat] = ACTIONS(234),
    [anon_sym_float] = ACTIONS(234),
    [anon_sym_double] = ACTIONS(234),
    [anon_sym_x86_fp80] = ACTIONS(234),
    [anon_sym_fp128] = ACTIONS(234),
    [anon_sym_ppc_fp128] = ACTIONS(234),
    [anon_sym_label] = ACTIONS(234),
    [anon_sym_metadata] = ACTIONS(234),
    [anon_sym_x86_mmx] = ACTIONS(234),
    [anon_sym_x86_amx] = ACTIONS(234),
    [anon_sym_token] = ACTIONS(234),
    [anon_sym_opaque] = ACTIONS(234),
    [anon_sym_ptr] = ACTIONS(236),
    [aux_sym_type_keyword_token1] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_RBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(234),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_to] = ACTIONS(236),
    [anon_sym_unwind] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(234),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(234),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
    [anon_sym_unordered] = ACTIONS(234),
    [anon_sym_monotonic] = ACTIONS(234),
    [anon_sym_acquire] = ACTIONS(234),
    [anon_sym_release] = ACTIONS(234),
    [anon_sym_acq_rel] = ACTIONS(234),
    [anon_sym_seq_cst] = ACTIONS(234),
    [anon_sym_syncscope] = ACTIONS(234),
    [anon_sym_uselistorder] = ACTIONS(236),
    [anon_sym_uselistorder_bb] = ACTIONS(234),
    [anon_sym_module] = ACTIONS(234),
    [anon_sym_asm] = ACTIONS(234),
    [anon_sym_attributes] = ACTIONS(234),
  },
  [239] = {
    [sym_addrspace] = STATE(261),
    [sym_argument_list] = STATE(235),
    [aux_sym_type_repeat1] = STATE(250),
    [aux_sym_type_repeat2] = STATE(235),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(397),
    [sym_comdat_ref] = ACTIONS(397),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [aux_sym_metadata_ref_token1] = ACTIONS(397),
    [sym_summary_ref] = ACTIONS(397),
    [sym_string] = ACTIONS(397),
    [anon_sym_target] = ACTIONS(397),
    [anon_sym_source_filename] = ACTIONS(397),
    [anon_sym_declare] = ACTIONS(397),
    [anon_sym_define] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_void] = ACTIONS(397),
    [anon_sym_half] = ACTIONS(397),
    [anon_sym_bfloat] = ACTIONS(397),
    [anon_sym_float] = ACTIONS(397),
    [anon_sym_double] = ACTIONS(397),
    [anon_sym_x86_fp80] = ACTIONS(397),
    [anon_sym_fp128] = ACTIONS(397),
    [anon_sym_ppc_fp128] = ACTIONS(397),
    [anon_sym_label] = ACTIONS(397),
    [anon_sym_metadata] = ACTIONS(397),
    [anon_sym_x86_mmx] = ACTIONS(397),
    [anon_sym_x86_amx] = ACTIONS(397),
    [anon_sym_token] = ACTIONS(397),
    [anon_sym_opaque] = ACTIONS(397),
    [anon_sym_ptr] = ACTIONS(397),
    [aux_sym_type_keyword_token1] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_align] = ACTIONS(399),
    [anon_sym_section] = ACTIONS(397),
    [anon_sym_partition] = ACTIONS(397),
    [anon_sym_comdat] = ACTIONS(397),
    [anon_sym_gc] = ACTIONS(397),
    [anon_sym_prefix] = ACTIONS(397),
    [anon_sym_prologue] = ACTIONS(397),
    [anon_sym_personality] = ACTIONS(397),
    [anon_sym_alignstack] = ACTIONS(397),
    [anon_sym_allocsize] = ACTIONS(397),
    [anon_sym_alwaysinline] = ACTIONS(397),
    [anon_sym_builtin] = ACTIONS(397),
    [anon_sym_cold] = ACTIONS(397),
    [anon_sym_convergent] = ACTIONS(397),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(397),
    [anon_sym_hot] = ACTIONS(397),
    [anon_sym_inaccessiblememonly] = ACTIONS(397),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(397),
    [anon_sym_inlinehint] = ACTIONS(397),
    [anon_sym_jumptable] = ACTIONS(397),
    [anon_sym_minsize] = ACTIONS(397),
    [anon_sym_naked] = ACTIONS(397),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(397),
    [anon_sym_nobuiltin] = ACTIONS(397),
    [anon_sym_noduplicate] = ACTIONS(397),
    [anon_sym_nofree] = ACTIONS(397),
    [anon_sym_noimplicitfloat] = ACTIONS(397),
    [anon_sym_noinline] = ACTIONS(397),
    [anon_sym_nomerge] = ACTIONS(397),
    [anon_sym_nonlazybind] = ACTIONS(397),
    [anon_sym_noprofile] = ACTIONS(397),
    [anon_sym_noredzone] = ACTIONS(397),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(397),
    [anon_sym_noreturn] = ACTIONS(397),
    [anon_sym_norecurse] = ACTIONS(397),
    [anon_sym_willreturn] = ACTIONS(397),
    [anon_sym_nosync] = ACTIONS(397),
    [anon_sym_nounwind] = ACTIONS(397),
    [anon_sym_nosanitize_coverage] = ACTIONS(397),
    [anon_sym_null_pointer_is_valid] = ACTIONS(397),
    [anon_sym_optforfuzzing] = ACTIONS(397),
    [anon_sym_optnone] = ACTIONS(397),
    [anon_sym_optsize] = ACTIONS(397),
    [anon_sym_readnone] = ACTIONS(397),
    [anon_sym_readonly] = ACTIONS(397),
    [anon_sym_writeonly] = ACTIONS(397),
    [anon_sym_argmemonly] = ACTIONS(397),
    [anon_sym_returns_twice] = ACTIONS(397),
    [anon_sym_safestack] = ACTIONS(397),
    [anon_sym_sanitize_address] = ACTIONS(397),
    [anon_sym_sanitize_memory] = ACTIONS(397),
    [anon_sym_sanitize_thread] = ACTIONS(397),
    [anon_sym_sanitize_hwaddress] = ACTIONS(397),
    [anon_sym_sanitize_memtag] = ACTIONS(397),
    [anon_sym_speculative_load_hardening] = ACTIONS(397),
    [anon_sym_speculatable] = ACTIONS(397),
    [anon_sym_ssp] = ACTIONS(399),
    [anon_sym_sspstrong] = ACTIONS(397),
    [anon_sym_sspreq] = ACTIONS(397),
    [anon_sym_strictfp] = ACTIONS(397),
    [anon_sym_uwtable] = ACTIONS(397),
    [anon_sym_nocf_check] = ACTIONS(397),
    [anon_sym_shadowcallstack] = ACTIONS(397),
    [anon_sym_mustprogress] = ACTIONS(397),
    [anon_sym_vscale_range] = ACTIONS(397),
    [anon_sym_preallocated] = ACTIONS(397),
    [anon_sym_zeroext] = ACTIONS(397),
    [anon_sym_signext] = ACTIONS(397),
    [anon_sym_inreg] = ACTIONS(397),
    [anon_sym_byval] = ACTIONS(397),
    [anon_sym_byref] = ACTIONS(397),
    [anon_sym_inalloca] = ACTIONS(397),
    [anon_sym_sret] = ACTIONS(397),
    [anon_sym_elementtype] = ACTIONS(397),
    [anon_sym_noalias] = ACTIONS(397),
    [anon_sym_nocapture] = ACTIONS(397),
    [anon_sym_nest] = ACTIONS(397),
    [anon_sym_returned] = ACTIONS(397),
    [anon_sym_nonnull] = ACTIONS(397),
    [anon_sym_dereferenceable] = ACTIONS(399),
    [anon_sym_dereferenceable_or_null] = ACTIONS(397),
    [anon_sym_swiftself] = ACTIONS(397),
    [anon_sym_swiftasync] = ACTIONS(397),
    [anon_sym_swifterror] = ACTIONS(397),
    [anon_sym_immarg] = ACTIONS(397),
    [anon_sym_noundef] = ACTIONS(397),
    [anon_sym_cleanup] = ACTIONS(397),
    [anon_sym_catch] = ACTIONS(397),
    [anon_sym_filter] = ACTIONS(397),
    [anon_sym_uselistorder] = ACTIONS(399),
    [anon_sym_uselistorder_bb] = ACTIONS(397),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_externally_initialized] = ACTIONS(397),
    [anon_sym_global] = ACTIONS(397),
    [anon_sym_constant] = ACTIONS(397),
    [anon_sym_alias] = ACTIONS(397),
    [anon_sym_ifunc] = ACTIONS(397),
    [anon_sym_attributes] = ACTIONS(397),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(303),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(303),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [aux_sym_metadata_ref_token1] = ACTIONS(303),
    [sym_summary_ref] = ACTIONS(303),
    [sym_string] = ACTIONS(303),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(303),
    [sym_float] = ACTIONS(303),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_target] = ACTIONS(303),
    [anon_sym_source_filename] = ACTIONS(303),
    [anon_sym_declare] = ACTIONS(303),
    [anon_sym_define] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(303),
    [anon_sym_private] = ACTIONS(303),
    [anon_sym_internal] = ACTIONS(303),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(303),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(303),
    [anon_sym_available_externally] = ACTIONS(303),
    [anon_sym_appending] = ACTIONS(303),
    [anon_sym_common] = ACTIONS(303),
    [anon_sym_extern_weak] = ACTIONS(303),
    [anon_sym_external] = ACTIONS(303),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(303),
    [anon_sym_dso_preemptable] = ACTIONS(303),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_hidden] = ACTIONS(303),
    [anon_sym_protected] = ACTIONS(303),
    [anon_sym_dllimport] = ACTIONS(303),
    [anon_sym_dllexport] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_void] = ACTIONS(303),
    [anon_sym_half] = ACTIONS(303),
    [anon_sym_bfloat] = ACTIONS(303),
    [anon_sym_float] = ACTIONS(303),
    [anon_sym_double] = ACTIONS(303),
    [anon_sym_x86_fp80] = ACTIONS(303),
    [anon_sym_fp128] = ACTIONS(303),
    [anon_sym_ppc_fp128] = ACTIONS(303),
    [anon_sym_label] = ACTIONS(303),
    [anon_sym_metadata] = ACTIONS(303),
    [anon_sym_x86_mmx] = ACTIONS(303),
    [anon_sym_x86_amx] = ACTIONS(303),
    [anon_sym_token] = ACTIONS(303),
    [anon_sym_opaque] = ACTIONS(303),
    [anon_sym_ptr] = ACTIONS(305),
    [aux_sym_type_keyword_token1] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_extractelement] = ACTIONS(303),
    [anon_sym_insertelement] = ACTIONS(303),
    [anon_sym_select] = ACTIONS(303),
    [anon_sym_shufflevector] = ACTIONS(303),
    [anon_sym_fneg] = ACTIONS(303),
    [anon_sym_to] = ACTIONS(305),
    [anon_sym_unwind] = ACTIONS(303),
    [anon_sym_icmp] = ACTIONS(303),
    [anon_sym_fcmp] = ACTIONS(303),
    [anon_sym_cleanup] = ACTIONS(303),
    [anon_sym_getelementptr] = ACTIONS(303),
    [anon_sym_extractvalue] = ACTIONS(303),
    [anon_sym_insertvalue] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_null] = ACTIONS(303),
    [anon_sym_none] = ACTIONS(303),
    [anon_sym_undef] = ACTIONS(303),
    [anon_sym_poison] = ACTIONS(303),
    [anon_sym_zeroinitializer] = ACTIONS(303),
    [anon_sym_catch] = ACTIONS(303),
    [anon_sym_filter] = ACTIONS(303),
    [anon_sym_blockaddress] = ACTIONS(303),
    [anon_sym_mul] = ACTIONS(303),
    [anon_sym_urem] = ACTIONS(303),
    [anon_sym_srem] = ACTIONS(303),
    [anon_sym_shl] = ACTIONS(303),
    [anon_sym_udiv] = ACTIONS(303),
    [anon_sym_sdiv] = ACTIONS(303),
    [anon_sym_lshr] = ACTIONS(303),
    [anon_sym_ashr] = ACTIONS(303),
    [anon_sym_fmul] = ACTIONS(303),
    [anon_sym_fdiv] = ACTIONS(303),
    [anon_sym_frem] = ACTIONS(303),
    [anon_sym_xchg] = ACTIONS(303),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_nand] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_xor] = ACTIONS(303),
    [anon_sym_max] = ACTIONS(303),
    [anon_sym_min] = ACTIONS(303),
    [anon_sym_umax] = ACTIONS(303),
    [anon_sym_umin] = ACTIONS(303),
    [anon_sym_fadd] = ACTIONS(303),
    [anon_sym_fsub] = ACTIONS(303),
    [anon_sym_bitcast] = ACTIONS(303),
    [anon_sym_trunc] = ACTIONS(303),
    [anon_sym_zext] = ACTIONS(303),
    [anon_sym_sext] = ACTIONS(303),
    [anon_sym_fptrunc] = ACTIONS(303),
    [anon_sym_fpext] = ACTIONS(303),
    [anon_sym_addrspacecast] = ACTIONS(303),
    [anon_sym_uitofp] = ACTIONS(303),
    [anon_sym_sitofp] = ACTIONS(303),
    [anon_sym_fptoui] = ACTIONS(303),
    [anon_sym_fptosi] = ACTIONS(303),
    [anon_sym_inttoptr] = ACTIONS(303),
    [anon_sym_ptrtoint] = ACTIONS(303),
    [anon_sym_unordered] = ACTIONS(303),
    [anon_sym_monotonic] = ACTIONS(303),
    [anon_sym_acquire] = ACTIONS(303),
    [anon_sym_release] = ACTIONS(303),
    [anon_sym_acq_rel] = ACTIONS(303),
    [anon_sym_seq_cst] = ACTIONS(303),
    [anon_sym_syncscope] = ACTIONS(303),
    [anon_sym_uselistorder] = ACTIONS(305),
    [anon_sym_uselistorder_bb] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_asm] = ACTIONS(303),
    [anon_sym_attributes] = ACTIONS(303),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(269),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(269),
    [anon_sym_x86_amx] = ACTIONS(269),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_RBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(271),
    [anon_sym_unwind] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_cleanup] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_filter] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_unordered] = ACTIONS(269),
    [anon_sym_monotonic] = ACTIONS(269),
    [anon_sym_acquire] = ACTIONS(269),
    [anon_sym_release] = ACTIONS(269),
    [anon_sym_acq_rel] = ACTIONS(269),
    [anon_sym_seq_cst] = ACTIONS(269),
    [anon_sym_syncscope] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_asm] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(307),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(307),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [aux_sym_metadata_ref_token1] = ACTIONS(307),
    [sym_summary_ref] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(307),
    [sym_float] = ACTIONS(307),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_target] = ACTIONS(307),
    [anon_sym_source_filename] = ACTIONS(307),
    [anon_sym_declare] = ACTIONS(307),
    [anon_sym_define] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(307),
    [anon_sym_private] = ACTIONS(307),
    [anon_sym_internal] = ACTIONS(307),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(307),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(307),
    [anon_sym_available_externally] = ACTIONS(307),
    [anon_sym_appending] = ACTIONS(307),
    [anon_sym_common] = ACTIONS(307),
    [anon_sym_extern_weak] = ACTIONS(307),
    [anon_sym_external] = ACTIONS(307),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(307),
    [anon_sym_dso_preemptable] = ACTIONS(307),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_hidden] = ACTIONS(307),
    [anon_sym_protected] = ACTIONS(307),
    [anon_sym_dllimport] = ACTIONS(307),
    [anon_sym_dllexport] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_void] = ACTIONS(307),
    [anon_sym_half] = ACTIONS(307),
    [anon_sym_bfloat] = ACTIONS(307),
    [anon_sym_float] = ACTIONS(307),
    [anon_sym_double] = ACTIONS(307),
    [anon_sym_x86_fp80] = ACTIONS(307),
    [anon_sym_fp128] = ACTIONS(307),
    [anon_sym_ppc_fp128] = ACTIONS(307),
    [anon_sym_label] = ACTIONS(307),
    [anon_sym_metadata] = ACTIONS(307),
    [anon_sym_x86_mmx] = ACTIONS(307),
    [anon_sym_x86_amx] = ACTIONS(307),
    [anon_sym_token] = ACTIONS(307),
    [anon_sym_opaque] = ACTIONS(307),
    [anon_sym_ptr] = ACTIONS(309),
    [aux_sym_type_keyword_token1] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_RBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(307),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_RPAREN] = ACTIONS(307),
    [anon_sym_extractelement] = ACTIONS(307),
    [anon_sym_insertelement] = ACTIONS(307),
    [anon_sym_select] = ACTIONS(307),
    [anon_sym_shufflevector] = ACTIONS(307),
    [anon_sym_fneg] = ACTIONS(307),
    [anon_sym_to] = ACTIONS(309),
    [anon_sym_unwind] = ACTIONS(307),
    [anon_sym_icmp] = ACTIONS(307),
    [anon_sym_fcmp] = ACTIONS(307),
    [anon_sym_cleanup] = ACTIONS(307),
    [anon_sym_getelementptr] = ACTIONS(307),
    [anon_sym_extractvalue] = ACTIONS(307),
    [anon_sym_insertvalue] = ACTIONS(307),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [anon_sym_null] = ACTIONS(307),
    [anon_sym_none] = ACTIONS(307),
    [anon_sym_undef] = ACTIONS(307),
    [anon_sym_poison] = ACTIONS(307),
    [anon_sym_zeroinitializer] = ACTIONS(307),
    [anon_sym_catch] = ACTIONS(307),
    [anon_sym_filter] = ACTIONS(307),
    [anon_sym_blockaddress] = ACTIONS(307),
    [anon_sym_mul] = ACTIONS(307),
    [anon_sym_urem] = ACTIONS(307),
    [anon_sym_srem] = ACTIONS(307),
    [anon_sym_shl] = ACTIONS(307),
    [anon_sym_udiv] = ACTIONS(307),
    [anon_sym_sdiv] = ACTIONS(307),
    [anon_sym_lshr] = ACTIONS(307),
    [anon_sym_ashr] = ACTIONS(307),
    [anon_sym_fmul] = ACTIONS(307),
    [anon_sym_fdiv] = ACTIONS(307),
    [anon_sym_frem] = ACTIONS(307),
    [anon_sym_xchg] = ACTIONS(307),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(307),
    [anon_sym_and] = ACTIONS(307),
    [anon_sym_nand] = ACTIONS(307),
    [anon_sym_or] = ACTIONS(307),
    [anon_sym_xor] = ACTIONS(307),
    [anon_sym_max] = ACTIONS(307),
    [anon_sym_min] = ACTIONS(307),
    [anon_sym_umax] = ACTIONS(307),
    [anon_sym_umin] = ACTIONS(307),
    [anon_sym_fadd] = ACTIONS(307),
    [anon_sym_fsub] = ACTIONS(307),
    [anon_sym_bitcast] = ACTIONS(307),
    [anon_sym_trunc] = ACTIONS(307),
    [anon_sym_zext] = ACTIONS(307),
    [anon_sym_sext] = ACTIONS(307),
    [anon_sym_fptrunc] = ACTIONS(307),
    [anon_sym_fpext] = ACTIONS(307),
    [anon_sym_addrspacecast] = ACTIONS(307),
    [anon_sym_uitofp] = ACTIONS(307),
    [anon_sym_sitofp] = ACTIONS(307),
    [anon_sym_fptoui] = ACTIONS(307),
    [anon_sym_fptosi] = ACTIONS(307),
    [anon_sym_inttoptr] = ACTIONS(307),
    [anon_sym_ptrtoint] = ACTIONS(307),
    [anon_sym_unordered] = ACTIONS(307),
    [anon_sym_monotonic] = ACTIONS(307),
    [anon_sym_acquire] = ACTIONS(307),
    [anon_sym_release] = ACTIONS(307),
    [anon_sym_acq_rel] = ACTIONS(307),
    [anon_sym_seq_cst] = ACTIONS(307),
    [anon_sym_syncscope] = ACTIONS(307),
    [anon_sym_uselistorder] = ACTIONS(309),
    [anon_sym_uselistorder_bb] = ACTIONS(307),
    [anon_sym_module] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(307),
    [anon_sym_attributes] = ACTIONS(307),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(299),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [aux_sym_metadata_ref_token1] = ACTIONS(299),
    [sym_summary_ref] = ACTIONS(299),
    [sym_string] = ACTIONS(299),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(299),
    [sym_float] = ACTIONS(299),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_target] = ACTIONS(299),
    [anon_sym_source_filename] = ACTIONS(299),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_define] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_internal] = ACTIONS(299),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(299),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(299),
    [anon_sym_available_externally] = ACTIONS(299),
    [anon_sym_appending] = ACTIONS(299),
    [anon_sym_common] = ACTIONS(299),
    [anon_sym_extern_weak] = ACTIONS(299),
    [anon_sym_external] = ACTIONS(299),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(299),
    [anon_sym_dso_preemptable] = ACTIONS(299),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_hidden] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_dllimport] = ACTIONS(299),
    [anon_sym_dllexport] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_void] = ACTIONS(299),
    [anon_sym_half] = ACTIONS(299),
    [anon_sym_bfloat] = ACTIONS(299),
    [anon_sym_float] = ACTIONS(299),
    [anon_sym_double] = ACTIONS(299),
    [anon_sym_x86_fp80] = ACTIONS(299),
    [anon_sym_fp128] = ACTIONS(299),
    [anon_sym_ppc_fp128] = ACTIONS(299),
    [anon_sym_label] = ACTIONS(299),
    [anon_sym_metadata] = ACTIONS(299),
    [anon_sym_x86_mmx] = ACTIONS(299),
    [anon_sym_x86_amx] = ACTIONS(299),
    [anon_sym_token] = ACTIONS(299),
    [anon_sym_opaque] = ACTIONS(299),
    [anon_sym_ptr] = ACTIONS(301),
    [aux_sym_type_keyword_token1] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_RBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_RPAREN] = ACTIONS(299),
    [anon_sym_extractelement] = ACTIONS(299),
    [anon_sym_insertelement] = ACTIONS(299),
    [anon_sym_select] = ACTIONS(299),
    [anon_sym_shufflevector] = ACTIONS(299),
    [anon_sym_fneg] = ACTIONS(299),
    [anon_sym_to] = ACTIONS(301),
    [anon_sym_unwind] = ACTIONS(299),
    [anon_sym_icmp] = ACTIONS(299),
    [anon_sym_fcmp] = ACTIONS(299),
    [anon_sym_cleanup] = ACTIONS(299),
    [anon_sym_getelementptr] = ACTIONS(299),
    [anon_sym_extractvalue] = ACTIONS(299),
    [anon_sym_insertvalue] = ACTIONS(299),
    [anon_sym_true] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_none] = ACTIONS(299),
    [anon_sym_undef] = ACTIONS(299),
    [anon_sym_poison] = ACTIONS(299),
    [anon_sym_zeroinitializer] = ACTIONS(299),
    [anon_sym_catch] = ACTIONS(299),
    [anon_sym_filter] = ACTIONS(299),
    [anon_sym_blockaddress] = ACTIONS(299),
    [anon_sym_mul] = ACTIONS(299),
    [anon_sym_urem] = ACTIONS(299),
    [anon_sym_srem] = ACTIONS(299),
    [anon_sym_shl] = ACTIONS(299),
    [anon_sym_udiv] = ACTIONS(299),
    [anon_sym_sdiv] = ACTIONS(299),
    [anon_sym_lshr] = ACTIONS(299),
    [anon_sym_ashr] = ACTIONS(299),
    [anon_sym_fmul] = ACTIONS(299),
    [anon_sym_fdiv] = ACTIONS(299),
    [anon_sym_frem] = ACTIONS(299),
    [anon_sym_xchg] = ACTIONS(299),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(299),
    [anon_sym_nand] = ACTIONS(299),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_xor] = ACTIONS(299),
    [anon_sym_max] = ACTIONS(299),
    [anon_sym_min] = ACTIONS(299),
    [anon_sym_umax] = ACTIONS(299),
    [anon_sym_umin] = ACTIONS(299),
    [anon_sym_fadd] = ACTIONS(299),
    [anon_sym_fsub] = ACTIONS(299),
    [anon_sym_bitcast] = ACTIONS(299),
    [anon_sym_trunc] = ACTIONS(299),
    [anon_sym_zext] = ACTIONS(299),
    [anon_sym_sext] = ACTIONS(299),
    [anon_sym_fptrunc] = ACTIONS(299),
    [anon_sym_fpext] = ACTIONS(299),
    [anon_sym_addrspacecast] = ACTIONS(299),
    [anon_sym_uitofp] = ACTIONS(299),
    [anon_sym_sitofp] = ACTIONS(299),
    [anon_sym_fptoui] = ACTIONS(299),
    [anon_sym_fptosi] = ACTIONS(299),
    [anon_sym_inttoptr] = ACTIONS(299),
    [anon_sym_ptrtoint] = ACTIONS(299),
    [anon_sym_unordered] = ACTIONS(299),
    [anon_sym_monotonic] = ACTIONS(299),
    [anon_sym_acquire] = ACTIONS(299),
    [anon_sym_release] = ACTIONS(299),
    [anon_sym_acq_rel] = ACTIONS(299),
    [anon_sym_seq_cst] = ACTIONS(299),
    [anon_sym_syncscope] = ACTIONS(299),
    [anon_sym_uselistorder] = ACTIONS(301),
    [anon_sym_uselistorder_bb] = ACTIONS(299),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_asm] = ACTIONS(299),
    [anon_sym_attributes] = ACTIONS(299),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_summary_ref] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_target] = ACTIONS(279),
    [anon_sym_source_filename] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_define] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_void] = ACTIONS(279),
    [anon_sym_half] = ACTIONS(279),
    [anon_sym_bfloat] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [anon_sym_x86_fp80] = ACTIONS(279),
    [anon_sym_fp128] = ACTIONS(279),
    [anon_sym_ppc_fp128] = ACTIONS(279),
    [anon_sym_label] = ACTIONS(279),
    [anon_sym_metadata] = ACTIONS(279),
    [anon_sym_x86_mmx] = ACTIONS(279),
    [anon_sym_x86_amx] = ACTIONS(279),
    [anon_sym_token] = ACTIONS(279),
    [anon_sym_opaque] = ACTIONS(279),
    [anon_sym_ptr] = ACTIONS(281),
    [aux_sym_type_keyword_token1] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_to] = ACTIONS(281),
    [anon_sym_unwind] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_cleanup] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_catch] = ACTIONS(279),
    [anon_sym_filter] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(279),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
    [anon_sym_unordered] = ACTIONS(279),
    [anon_sym_monotonic] = ACTIONS(279),
    [anon_sym_acquire] = ACTIONS(279),
    [anon_sym_release] = ACTIONS(279),
    [anon_sym_acq_rel] = ACTIONS(279),
    [anon_sym_seq_cst] = ACTIONS(279),
    [anon_sym_syncscope] = ACTIONS(279),
    [anon_sym_uselistorder] = ACTIONS(281),
    [anon_sym_uselistorder_bb] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_asm] = ACTIONS(279),
    [anon_sym_attributes] = ACTIONS(279),
  },
  [246] = {
    [sym_addrspace] = STATE(261),
    [sym_argument_list] = STATE(247),
    [aux_sym_type_repeat1] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(250),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(250),
    [anon_sym_x86_amx] = ACTIONS(250),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(252),
    [anon_sym_unwind] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_cleanup] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_catch] = ACTIONS(250),
    [anon_sym_filter] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_unordered] = ACTIONS(250),
    [anon_sym_monotonic] = ACTIONS(250),
    [anon_sym_acquire] = ACTIONS(250),
    [anon_sym_release] = ACTIONS(250),
    [anon_sym_acq_rel] = ACTIONS(250),
    [anon_sym_seq_cst] = ACTIONS(250),
    [anon_sym_syncscope] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_asm] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(365),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [aux_sym_metadata_ref_token1] = ACTIONS(365),
    [sym_summary_ref] = ACTIONS(365),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_target] = ACTIONS(365),
    [anon_sym_source_filename] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(365),
    [anon_sym_define] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_void] = ACTIONS(365),
    [anon_sym_half] = ACTIONS(365),
    [anon_sym_bfloat] = ACTIONS(365),
    [anon_sym_float] = ACTIONS(365),
    [anon_sym_double] = ACTIONS(365),
    [anon_sym_x86_fp80] = ACTIONS(365),
    [anon_sym_fp128] = ACTIONS(365),
    [anon_sym_ppc_fp128] = ACTIONS(365),
    [anon_sym_label] = ACTIONS(365),
    [anon_sym_metadata] = ACTIONS(365),
    [anon_sym_x86_mmx] = ACTIONS(365),
    [anon_sym_x86_amx] = ACTIONS(365),
    [anon_sym_token] = ACTIONS(365),
    [anon_sym_opaque] = ACTIONS(365),
    [anon_sym_ptr] = ACTIONS(367),
    [aux_sym_type_keyword_token1] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_to] = ACTIONS(367),
    [anon_sym_unwind] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_cleanup] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_catch] = ACTIONS(365),
    [anon_sym_filter] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
    [anon_sym_unordered] = ACTIONS(365),
    [anon_sym_monotonic] = ACTIONS(365),
    [anon_sym_acquire] = ACTIONS(365),
    [anon_sym_release] = ACTIONS(365),
    [anon_sym_acq_rel] = ACTIONS(365),
    [anon_sym_seq_cst] = ACTIONS(365),
    [anon_sym_syncscope] = ACTIONS(365),
    [anon_sym_uselistorder] = ACTIONS(367),
    [anon_sym_uselistorder_bb] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(365),
    [anon_sym_asm] = ACTIONS(365),
    [anon_sym_attributes] = ACTIONS(365),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_half] = ACTIONS(116),
    [anon_sym_bfloat] = ACTIONS(116),
    [anon_sym_float] = ACTIONS(116),
    [anon_sym_double] = ACTIONS(116),
    [anon_sym_x86_fp80] = ACTIONS(116),
    [anon_sym_fp128] = ACTIONS(116),
    [anon_sym_ppc_fp128] = ACTIONS(116),
    [anon_sym_label] = ACTIONS(116),
    [anon_sym_metadata] = ACTIONS(116),
    [anon_sym_x86_mmx] = ACTIONS(116),
    [anon_sym_x86_amx] = ACTIONS(116),
    [anon_sym_token] = ACTIONS(116),
    [anon_sym_opaque] = ACTIONS(116),
    [anon_sym_ptr] = ACTIONS(122),
    [aux_sym_type_keyword_token1] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_unwind] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_cleanup] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_catch] = ACTIONS(116),
    [anon_sym_filter] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_unordered] = ACTIONS(116),
    [anon_sym_monotonic] = ACTIONS(116),
    [anon_sym_acquire] = ACTIONS(116),
    [anon_sym_release] = ACTIONS(116),
    [anon_sym_acq_rel] = ACTIONS(116),
    [anon_sym_seq_cst] = ACTIONS(116),
    [anon_sym_syncscope] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_asm] = ACTIONS(116),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [250] = {
    [sym_addrspace] = STATE(258),
    [sym_argument_list] = STATE(247),
    [aux_sym_type_repeat1] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(263),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(263),
    [anon_sym_x86_amx] = ACTIONS(263),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(265),
    [anon_sym_unwind] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_unordered] = ACTIONS(263),
    [anon_sym_monotonic] = ACTIONS(263),
    [anon_sym_acquire] = ACTIONS(263),
    [anon_sym_release] = ACTIONS(263),
    [anon_sym_acq_rel] = ACTIONS(263),
    [anon_sym_seq_cst] = ACTIONS(263),
    [anon_sym_syncscope] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_asm] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(283),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(283),
    [sym_summary_ref] = ACTIONS(283),
    [sym_string] = ACTIONS(283),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(283),
    [sym_float] = ACTIONS(283),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_target] = ACTIONS(283),
    [anon_sym_source_filename] = ACTIONS(283),
    [anon_sym_declare] = ACTIONS(283),
    [anon_sym_define] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_internal] = ACTIONS(283),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(283),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(283),
    [anon_sym_available_externally] = ACTIONS(283),
    [anon_sym_appending] = ACTIONS(283),
    [anon_sym_common] = ACTIONS(283),
    [anon_sym_extern_weak] = ACTIONS(283),
    [anon_sym_external] = ACTIONS(283),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(283),
    [anon_sym_dso_preemptable] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_hidden] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_dllimport] = ACTIONS(283),
    [anon_sym_dllexport] = ACTIONS(283),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_void] = ACTIONS(283),
    [anon_sym_half] = ACTIONS(283),
    [anon_sym_bfloat] = ACTIONS(283),
    [anon_sym_float] = ACTIONS(283),
    [anon_sym_double] = ACTIONS(283),
    [anon_sym_x86_fp80] = ACTIONS(283),
    [anon_sym_fp128] = ACTIONS(283),
    [anon_sym_ppc_fp128] = ACTIONS(283),
    [anon_sym_label] = ACTIONS(283),
    [anon_sym_metadata] = ACTIONS(283),
    [anon_sym_x86_mmx] = ACTIONS(283),
    [anon_sym_x86_amx] = ACTIONS(283),
    [anon_sym_token] = ACTIONS(283),
    [anon_sym_opaque] = ACTIONS(283),
    [anon_sym_ptr] = ACTIONS(285),
    [aux_sym_type_keyword_token1] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_RBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_GT] = ACTIONS(283),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_extractelement] = ACTIONS(283),
    [anon_sym_insertelement] = ACTIONS(283),
    [anon_sym_select] = ACTIONS(283),
    [anon_sym_shufflevector] = ACTIONS(283),
    [anon_sym_fneg] = ACTIONS(283),
    [anon_sym_to] = ACTIONS(285),
    [anon_sym_unwind] = ACTIONS(283),
    [anon_sym_icmp] = ACTIONS(283),
    [anon_sym_fcmp] = ACTIONS(283),
    [anon_sym_cleanup] = ACTIONS(283),
    [anon_sym_getelementptr] = ACTIONS(283),
    [anon_sym_extractvalue] = ACTIONS(283),
    [anon_sym_insertvalue] = ACTIONS(283),
    [anon_sym_true] = ACTIONS(283),
    [anon_sym_false] = ACTIONS(283),
    [anon_sym_null] = ACTIONS(283),
    [anon_sym_none] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(283),
    [anon_sym_poison] = ACTIONS(283),
    [anon_sym_zeroinitializer] = ACTIONS(283),
    [anon_sym_catch] = ACTIONS(283),
    [anon_sym_filter] = ACTIONS(283),
    [anon_sym_blockaddress] = ACTIONS(283),
    [anon_sym_mul] = ACTIONS(283),
    [anon_sym_urem] = ACTIONS(283),
    [anon_sym_srem] = ACTIONS(283),
    [anon_sym_shl] = ACTIONS(283),
    [anon_sym_udiv] = ACTIONS(283),
    [anon_sym_sdiv] = ACTIONS(283),
    [anon_sym_lshr] = ACTIONS(283),
    [anon_sym_ashr] = ACTIONS(283),
    [anon_sym_fmul] = ACTIONS(283),
    [anon_sym_fdiv] = ACTIONS(283),
    [anon_sym_frem] = ACTIONS(283),
    [anon_sym_xchg] = ACTIONS(283),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(283),
    [anon_sym_nand] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(283),
    [anon_sym_xor] = ACTIONS(283),
    [anon_sym_max] = ACTIONS(283),
    [anon_sym_min] = ACTIONS(283),
    [anon_sym_umax] = ACTIONS(283),
    [anon_sym_umin] = ACTIONS(283),
    [anon_sym_fadd] = ACTIONS(283),
    [anon_sym_fsub] = ACTIONS(283),
    [anon_sym_bitcast] = ACTIONS(283),
    [anon_sym_trunc] = ACTIONS(283),
    [anon_sym_zext] = ACTIONS(283),
    [anon_sym_sext] = ACTIONS(283),
    [anon_sym_fptrunc] = ACTIONS(283),
    [anon_sym_fpext] = ACTIONS(283),
    [anon_sym_addrspacecast] = ACTIONS(283),
    [anon_sym_uitofp] = ACTIONS(283),
    [anon_sym_sitofp] = ACTIONS(283),
    [anon_sym_fptoui] = ACTIONS(283),
    [anon_sym_fptosi] = ACTIONS(283),
    [anon_sym_inttoptr] = ACTIONS(283),
    [anon_sym_ptrtoint] = ACTIONS(283),
    [anon_sym_unordered] = ACTIONS(283),
    [anon_sym_monotonic] = ACTIONS(283),
    [anon_sym_acquire] = ACTIONS(283),
    [anon_sym_release] = ACTIONS(283),
    [anon_sym_acq_rel] = ACTIONS(283),
    [anon_sym_seq_cst] = ACTIONS(283),
    [anon_sym_syncscope] = ACTIONS(283),
    [anon_sym_uselistorder] = ACTIONS(285),
    [anon_sym_uselistorder_bb] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(283),
    [anon_sym_asm] = ACTIONS(283),
    [anon_sym_attributes] = ACTIONS(283),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(295),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(295),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [aux_sym_metadata_ref_token1] = ACTIONS(295),
    [sym_summary_ref] = ACTIONS(295),
    [sym_string] = ACTIONS(295),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(295),
    [sym_float] = ACTIONS(295),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_target] = ACTIONS(295),
    [anon_sym_source_filename] = ACTIONS(295),
    [anon_sym_declare] = ACTIONS(295),
    [anon_sym_define] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(295),
    [anon_sym_private] = ACTIONS(295),
    [anon_sym_internal] = ACTIONS(295),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(295),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(295),
    [anon_sym_available_externally] = ACTIONS(295),
    [anon_sym_appending] = ACTIONS(295),
    [anon_sym_common] = ACTIONS(295),
    [anon_sym_extern_weak] = ACTIONS(295),
    [anon_sym_external] = ACTIONS(295),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(295),
    [anon_sym_dso_preemptable] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(295),
    [anon_sym_hidden] = ACTIONS(295),
    [anon_sym_protected] = ACTIONS(295),
    [anon_sym_dllimport] = ACTIONS(295),
    [anon_sym_dllexport] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_void] = ACTIONS(295),
    [anon_sym_half] = ACTIONS(295),
    [anon_sym_bfloat] = ACTIONS(295),
    [anon_sym_float] = ACTIONS(295),
    [anon_sym_double] = ACTIONS(295),
    [anon_sym_x86_fp80] = ACTIONS(295),
    [anon_sym_fp128] = ACTIONS(295),
    [anon_sym_ppc_fp128] = ACTIONS(295),
    [anon_sym_label] = ACTIONS(295),
    [anon_sym_metadata] = ACTIONS(295),
    [anon_sym_x86_mmx] = ACTIONS(295),
    [anon_sym_x86_amx] = ACTIONS(295),
    [anon_sym_token] = ACTIONS(295),
    [anon_sym_opaque] = ACTIONS(295),
    [anon_sym_ptr] = ACTIONS(297),
    [aux_sym_type_keyword_token1] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_RBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_extractelement] = ACTIONS(295),
    [anon_sym_insertelement] = ACTIONS(295),
    [anon_sym_select] = ACTIONS(295),
    [anon_sym_shufflevector] = ACTIONS(295),
    [anon_sym_fneg] = ACTIONS(295),
    [anon_sym_to] = ACTIONS(297),
    [anon_sym_unwind] = ACTIONS(295),
    [anon_sym_icmp] = ACTIONS(295),
    [anon_sym_fcmp] = ACTIONS(295),
    [anon_sym_cleanup] = ACTIONS(295),
    [anon_sym_getelementptr] = ACTIONS(295),
    [anon_sym_extractvalue] = ACTIONS(295),
    [anon_sym_insertvalue] = ACTIONS(295),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(295),
    [anon_sym_none] = ACTIONS(295),
    [anon_sym_undef] = ACTIONS(295),
    [anon_sym_poison] = ACTIONS(295),
    [anon_sym_zeroinitializer] = ACTIONS(295),
    [anon_sym_catch] = ACTIONS(295),
    [anon_sym_filter] = ACTIONS(295),
    [anon_sym_blockaddress] = ACTIONS(295),
    [anon_sym_mul] = ACTIONS(295),
    [anon_sym_urem] = ACTIONS(295),
    [anon_sym_srem] = ACTIONS(295),
    [anon_sym_shl] = ACTIONS(295),
    [anon_sym_udiv] = ACTIONS(295),
    [anon_sym_sdiv] = ACTIONS(295),
    [anon_sym_lshr] = ACTIONS(295),
    [anon_sym_ashr] = ACTIONS(295),
    [anon_sym_fmul] = ACTIONS(295),
    [anon_sym_fdiv] = ACTIONS(295),
    [anon_sym_frem] = ACTIONS(295),
    [anon_sym_xchg] = ACTIONS(295),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(295),
    [anon_sym_nand] = ACTIONS(295),
    [anon_sym_or] = ACTIONS(295),
    [anon_sym_xor] = ACTIONS(295),
    [anon_sym_max] = ACTIONS(295),
    [anon_sym_min] = ACTIONS(295),
    [anon_sym_umax] = ACTIONS(295),
    [anon_sym_umin] = ACTIONS(295),
    [anon_sym_fadd] = ACTIONS(295),
    [anon_sym_fsub] = ACTIONS(295),
    [anon_sym_bitcast] = ACTIONS(295),
    [anon_sym_trunc] = ACTIONS(295),
    [anon_sym_zext] = ACTIONS(295),
    [anon_sym_sext] = ACTIONS(295),
    [anon_sym_fptrunc] = ACTIONS(295),
    [anon_sym_fpext] = ACTIONS(295),
    [anon_sym_addrspacecast] = ACTIONS(295),
    [anon_sym_uitofp] = ACTIONS(295),
    [anon_sym_sitofp] = ACTIONS(295),
    [anon_sym_fptoui] = ACTIONS(295),
    [anon_sym_fptosi] = ACTIONS(295),
    [anon_sym_inttoptr] = ACTIONS(295),
    [anon_sym_ptrtoint] = ACTIONS(295),
    [anon_sym_unordered] = ACTIONS(295),
    [anon_sym_monotonic] = ACTIONS(295),
    [anon_sym_acquire] = ACTIONS(295),
    [anon_sym_release] = ACTIONS(295),
    [anon_sym_acq_rel] = ACTIONS(295),
    [anon_sym_seq_cst] = ACTIONS(295),
    [anon_sym_syncscope] = ACTIONS(295),
    [anon_sym_uselistorder] = ACTIONS(297),
    [anon_sym_uselistorder_bb] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(295),
    [anon_sym_asm] = ACTIONS(295),
    [anon_sym_attributes] = ACTIONS(295),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(291),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [aux_sym_metadata_ref_token1] = ACTIONS(291),
    [sym_summary_ref] = ACTIONS(291),
    [sym_string] = ACTIONS(291),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_target] = ACTIONS(291),
    [anon_sym_source_filename] = ACTIONS(291),
    [anon_sym_declare] = ACTIONS(291),
    [anon_sym_define] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_internal] = ACTIONS(291),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(291),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(291),
    [anon_sym_available_externally] = ACTIONS(291),
    [anon_sym_appending] = ACTIONS(291),
    [anon_sym_common] = ACTIONS(291),
    [anon_sym_extern_weak] = ACTIONS(291),
    [anon_sym_external] = ACTIONS(291),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(291),
    [anon_sym_dso_preemptable] = ACTIONS(291),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_hidden] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_dllimport] = ACTIONS(291),
    [anon_sym_dllexport] = ACTIONS(291),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_void] = ACTIONS(291),
    [anon_sym_half] = ACTIONS(291),
    [anon_sym_bfloat] = ACTIONS(291),
    [anon_sym_float] = ACTIONS(291),
    [anon_sym_double] = ACTIONS(291),
    [anon_sym_x86_fp80] = ACTIONS(291),
    [anon_sym_fp128] = ACTIONS(291),
    [anon_sym_ppc_fp128] = ACTIONS(291),
    [anon_sym_label] = ACTIONS(291),
    [anon_sym_metadata] = ACTIONS(291),
    [anon_sym_x86_mmx] = ACTIONS(291),
    [anon_sym_x86_amx] = ACTIONS(291),
    [anon_sym_token] = ACTIONS(291),
    [anon_sym_opaque] = ACTIONS(291),
    [anon_sym_ptr] = ACTIONS(293),
    [aux_sym_type_keyword_token1] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_RBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_extractelement] = ACTIONS(291),
    [anon_sym_insertelement] = ACTIONS(291),
    [anon_sym_select] = ACTIONS(291),
    [anon_sym_shufflevector] = ACTIONS(291),
    [anon_sym_fneg] = ACTIONS(291),
    [anon_sym_to] = ACTIONS(293),
    [anon_sym_unwind] = ACTIONS(291),
    [anon_sym_icmp] = ACTIONS(291),
    [anon_sym_fcmp] = ACTIONS(291),
    [anon_sym_cleanup] = ACTIONS(291),
    [anon_sym_getelementptr] = ACTIONS(291),
    [anon_sym_extractvalue] = ACTIONS(291),
    [anon_sym_insertvalue] = ACTIONS(291),
    [anon_sym_true] = ACTIONS(291),
    [anon_sym_false] = ACTIONS(291),
    [anon_sym_null] = ACTIONS(291),
    [anon_sym_none] = ACTIONS(291),
    [anon_sym_undef] = ACTIONS(291),
    [anon_sym_poison] = ACTIONS(291),
    [anon_sym_zeroinitializer] = ACTIONS(291),
    [anon_sym_catch] = ACTIONS(291),
    [anon_sym_filter] = ACTIONS(291),
    [anon_sym_blockaddress] = ACTIONS(291),
    [anon_sym_mul] = ACTIONS(291),
    [anon_sym_urem] = ACTIONS(291),
    [anon_sym_srem] = ACTIONS(291),
    [anon_sym_shl] = ACTIONS(291),
    [anon_sym_udiv] = ACTIONS(291),
    [anon_sym_sdiv] = ACTIONS(291),
    [anon_sym_lshr] = ACTIONS(291),
    [anon_sym_ashr] = ACTIONS(291),
    [anon_sym_fmul] = ACTIONS(291),
    [anon_sym_fdiv] = ACTIONS(291),
    [anon_sym_frem] = ACTIONS(291),
    [anon_sym_xchg] = ACTIONS(291),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(291),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_nand] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_xor] = ACTIONS(291),
    [anon_sym_max] = ACTIONS(291),
    [anon_sym_min] = ACTIONS(291),
    [anon_sym_umax] = ACTIONS(291),
    [anon_sym_umin] = ACTIONS(291),
    [anon_sym_fadd] = ACTIONS(291),
    [anon_sym_fsub] = ACTIONS(291),
    [anon_sym_bitcast] = ACTIONS(291),
    [anon_sym_trunc] = ACTIONS(291),
    [anon_sym_zext] = ACTIONS(291),
    [anon_sym_sext] = ACTIONS(291),
    [anon_sym_fptrunc] = ACTIONS(291),
    [anon_sym_fpext] = ACTIONS(291),
    [anon_sym_addrspacecast] = ACTIONS(291),
    [anon_sym_uitofp] = ACTIONS(291),
    [anon_sym_sitofp] = ACTIONS(291),
    [anon_sym_fptoui] = ACTIONS(291),
    [anon_sym_fptosi] = ACTIONS(291),
    [anon_sym_inttoptr] = ACTIONS(291),
    [anon_sym_ptrtoint] = ACTIONS(291),
    [anon_sym_unordered] = ACTIONS(291),
    [anon_sym_monotonic] = ACTIONS(291),
    [anon_sym_acquire] = ACTIONS(291),
    [anon_sym_release] = ACTIONS(291),
    [anon_sym_acq_rel] = ACTIONS(291),
    [anon_sym_seq_cst] = ACTIONS(291),
    [anon_sym_syncscope] = ACTIONS(291),
    [anon_sym_uselistorder] = ACTIONS(293),
    [anon_sym_uselistorder_bb] = ACTIONS(291),
    [anon_sym_module] = ACTIONS(291),
    [anon_sym_asm] = ACTIONS(291),
    [anon_sym_attributes] = ACTIONS(291),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(287),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [aux_sym_metadata_ref_token1] = ACTIONS(287),
    [sym_summary_ref] = ACTIONS(287),
    [sym_string] = ACTIONS(287),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(287),
    [sym_float] = ACTIONS(287),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_target] = ACTIONS(287),
    [anon_sym_source_filename] = ACTIONS(287),
    [anon_sym_declare] = ACTIONS(287),
    [anon_sym_define] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_internal] = ACTIONS(287),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(287),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(287),
    [anon_sym_available_externally] = ACTIONS(287),
    [anon_sym_appending] = ACTIONS(287),
    [anon_sym_common] = ACTIONS(287),
    [anon_sym_extern_weak] = ACTIONS(287),
    [anon_sym_external] = ACTIONS(287),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(287),
    [anon_sym_dso_preemptable] = ACTIONS(287),
    [anon_sym_default] = ACTIONS(287),
    [anon_sym_hidden] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_dllimport] = ACTIONS(287),
    [anon_sym_dllexport] = ACTIONS(287),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(287),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(287),
    [anon_sym_x86_mmx] = ACTIONS(287),
    [anon_sym_x86_amx] = ACTIONS(287),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(289),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_RBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(287),
    [anon_sym_extractelement] = ACTIONS(287),
    [anon_sym_insertelement] = ACTIONS(287),
    [anon_sym_select] = ACTIONS(287),
    [anon_sym_shufflevector] = ACTIONS(287),
    [anon_sym_fneg] = ACTIONS(287),
    [anon_sym_to] = ACTIONS(289),
    [anon_sym_unwind] = ACTIONS(287),
    [anon_sym_icmp] = ACTIONS(287),
    [anon_sym_fcmp] = ACTIONS(287),
    [anon_sym_cleanup] = ACTIONS(287),
    [anon_sym_getelementptr] = ACTIONS(287),
    [anon_sym_extractvalue] = ACTIONS(287),
    [anon_sym_insertvalue] = ACTIONS(287),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(287),
    [anon_sym_none] = ACTIONS(287),
    [anon_sym_undef] = ACTIONS(287),
    [anon_sym_poison] = ACTIONS(287),
    [anon_sym_zeroinitializer] = ACTIONS(287),
    [anon_sym_catch] = ACTIONS(287),
    [anon_sym_filter] = ACTIONS(287),
    [anon_sym_blockaddress] = ACTIONS(287),
    [anon_sym_mul] = ACTIONS(287),
    [anon_sym_urem] = ACTIONS(287),
    [anon_sym_srem] = ACTIONS(287),
    [anon_sym_shl] = ACTIONS(287),
    [anon_sym_udiv] = ACTIONS(287),
    [anon_sym_sdiv] = ACTIONS(287),
    [anon_sym_lshr] = ACTIONS(287),
    [anon_sym_ashr] = ACTIONS(287),
    [anon_sym_fmul] = ACTIONS(287),
    [anon_sym_fdiv] = ACTIONS(287),
    [anon_sym_frem] = ACTIONS(287),
    [anon_sym_xchg] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(287),
    [anon_sym_and] = ACTIONS(287),
    [anon_sym_nand] = ACTIONS(287),
    [anon_sym_or] = ACTIONS(287),
    [anon_sym_xor] = ACTIONS(287),
    [anon_sym_max] = ACTIONS(287),
    [anon_sym_min] = ACTIONS(287),
    [anon_sym_umax] = ACTIONS(287),
    [anon_sym_umin] = ACTIONS(287),
    [anon_sym_fadd] = ACTIONS(287),
    [anon_sym_fsub] = ACTIONS(287),
    [anon_sym_bitcast] = ACTIONS(287),
    [anon_sym_trunc] = ACTIONS(287),
    [anon_sym_zext] = ACTIONS(287),
    [anon_sym_sext] = ACTIONS(287),
    [anon_sym_fptrunc] = ACTIONS(287),
    [anon_sym_fpext] = ACTIONS(287),
    [anon_sym_addrspacecast] = ACTIONS(287),
    [anon_sym_uitofp] = ACTIONS(287),
    [anon_sym_sitofp] = ACTIONS(287),
    [anon_sym_fptoui] = ACTIONS(287),
    [anon_sym_fptosi] = ACTIONS(287),
    [anon_sym_inttoptr] = ACTIONS(287),
    [anon_sym_ptrtoint] = ACTIONS(287),
    [anon_sym_unordered] = ACTIONS(287),
    [anon_sym_monotonic] = ACTIONS(287),
    [anon_sym_acquire] = ACTIONS(287),
    [anon_sym_release] = ACTIONS(287),
    [anon_sym_acq_rel] = ACTIONS(287),
    [anon_sym_seq_cst] = ACTIONS(287),
    [anon_sym_syncscope] = ACTIONS(287),
    [anon_sym_uselistorder] = ACTIONS(289),
    [anon_sym_uselistorder_bb] = ACTIONS(287),
    [anon_sym_module] = ACTIONS(287),
    [anon_sym_asm] = ACTIONS(287),
    [anon_sym_attributes] = ACTIONS(287),
  },
  [255] = {
    [sym_number] = STATE(317),
    [sym_var] = STATE(317),
    [sym_linkage] = STATE(750),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(321),
    [sym__primitive_value] = STATE(317),
    [sym_struct_value] = STATE(317),
    [sym_packed_struct_value] = STATE(317),
    [sym_array_value] = STATE(317),
    [sym_vector_value] = STATE(317),
    [sym_blockaddress] = STATE(317),
    [sym_constant_expr] = STATE(317),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [aux_sym_function_header_repeat1] = STATE(750),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(428),
    [sym_local_var] = ACTIONS(311),
    [sym_string] = ACTIONS(321),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(321),
    [sym_cstring] = ACTIONS(321),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_void] = ACTIONS(38),
    [anon_sym_half] = ACTIONS(38),
    [anon_sym_bfloat] = ACTIONS(38),
    [anon_sym_float] = ACTIONS(38),
    [anon_sym_double] = ACTIONS(38),
    [anon_sym_x86_fp80] = ACTIONS(38),
    [anon_sym_fp128] = ACTIONS(38),
    [anon_sym_ppc_fp128] = ACTIONS(38),
    [anon_sym_label] = ACTIONS(38),
    [anon_sym_metadata] = ACTIONS(38),
    [anon_sym_x86_mmx] = ACTIONS(38),
    [anon_sym_x86_amx] = ACTIONS(38),
    [anon_sym_token] = ACTIONS(38),
    [anon_sym_opaque] = ACTIONS(38),
    [anon_sym_ptr] = ACTIONS(70),
    [aux_sym_type_keyword_token1] = ACTIONS(38),
    [anon_sym_LBRACE] = ACTIONS(433),
    [anon_sym_LT_LBRACE] = ACTIONS(956),
    [anon_sym_LBRACK] = ACTIONS(430),
    [anon_sym_RBRACK] = ACTIONS(38),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [anon_sym_null] = ACTIONS(321),
    [anon_sym_none] = ACTIONS(321),
    [anon_sym_undef] = ACTIONS(321),
    [anon_sym_poison] = ACTIONS(321),
    [anon_sym_zeroinitializer] = ACTIONS(321),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [256] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(256),
    [aux_sym_type_repeat1] = STATE(1122),
    [aux_sym_type_repeat2] = STATE(256),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_catch] = ACTIONS(252),
    [anon_sym_filter] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_unordered] = ACTIONS(252),
    [anon_sym_monotonic] = ACTIONS(252),
    [anon_sym_acquire] = ACTIONS(252),
    [anon_sym_release] = ACTIONS(252),
    [anon_sym_acq_rel] = ACTIONS(252),
    [anon_sym_seq_cst] = ACTIONS(252),
    [anon_sym_syncscope] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [257] = {
    [sym_addrspace] = STATE(287),
    [sym_argument_list] = STATE(256),
    [aux_sym_type_repeat1] = STATE(265),
    [aux_sym_type_repeat2] = STATE(256),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(393),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [aux_sym_metadata_ref_token1] = ACTIONS(393),
    [sym_summary_ref] = ACTIONS(393),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_target] = ACTIONS(393),
    [anon_sym_source_filename] = ACTIONS(393),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_define] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_void] = ACTIONS(393),
    [anon_sym_half] = ACTIONS(393),
    [anon_sym_bfloat] = ACTIONS(393),
    [anon_sym_float] = ACTIONS(393),
    [anon_sym_double] = ACTIONS(393),
    [anon_sym_x86_fp80] = ACTIONS(393),
    [anon_sym_fp128] = ACTIONS(393),
    [anon_sym_ppc_fp128] = ACTIONS(393),
    [anon_sym_label] = ACTIONS(393),
    [anon_sym_metadata] = ACTIONS(393),
    [anon_sym_x86_mmx] = ACTIONS(393),
    [anon_sym_x86_amx] = ACTIONS(393),
    [anon_sym_token] = ACTIONS(393),
    [anon_sym_opaque] = ACTIONS(393),
    [anon_sym_ptr] = ACTIONS(395),
    [aux_sym_type_keyword_token1] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_RBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_GT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_to] = ACTIONS(395),
    [anon_sym_unwind] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_cleanup] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_catch] = ACTIONS(393),
    [anon_sym_filter] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
    [anon_sym_unordered] = ACTIONS(393),
    [anon_sym_monotonic] = ACTIONS(393),
    [anon_sym_acquire] = ACTIONS(393),
    [anon_sym_release] = ACTIONS(393),
    [anon_sym_acq_rel] = ACTIONS(393),
    [anon_sym_seq_cst] = ACTIONS(393),
    [anon_sym_syncscope] = ACTIONS(393),
    [anon_sym_uselistorder] = ACTIONS(395),
    [anon_sym_uselistorder_bb] = ACTIONS(393),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_asm] = ACTIONS(393),
    [anon_sym_attributes] = ACTIONS(393),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_cleanup] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_catch] = ACTIONS(244),
    [anon_sym_filter] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_comdat_ref] = ACTIONS(713),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [aux_sym_metadata_ref_token1] = ACTIONS(713),
    [sym_summary_ref] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [anon_sym_target] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_source_filename] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_define] = ACTIONS(713),
    [anon_sym_unnamed_addr] = ACTIONS(713),
    [anon_sym_local_unnamed_addr] = ACTIONS(713),
    [anon_sym_void] = ACTIONS(713),
    [anon_sym_half] = ACTIONS(713),
    [anon_sym_bfloat] = ACTIONS(713),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_double] = ACTIONS(713),
    [anon_sym_x86_fp80] = ACTIONS(713),
    [anon_sym_fp128] = ACTIONS(713),
    [anon_sym_ppc_fp128] = ACTIONS(713),
    [anon_sym_label] = ACTIONS(713),
    [anon_sym_metadata] = ACTIONS(713),
    [anon_sym_x86_mmx] = ACTIONS(713),
    [anon_sym_x86_amx] = ACTIONS(713),
    [anon_sym_token] = ACTIONS(713),
    [anon_sym_opaque] = ACTIONS(713),
    [anon_sym_ptr] = ACTIONS(713),
    [aux_sym_type_keyword_token1] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_addrspace] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(713),
    [anon_sym_partition] = ACTIONS(713),
    [anon_sym_comdat] = ACTIONS(713),
    [anon_sym_gc] = ACTIONS(713),
    [anon_sym_prefix] = ACTIONS(713),
    [anon_sym_prologue] = ACTIONS(713),
    [anon_sym_personality] = ACTIONS(713),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_to] = ACTIONS(715),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_uselistorder] = ACTIONS(715),
    [anon_sym_uselistorder_bb] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_attributes] = ACTIONS(713),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(263),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(263),
    [anon_sym_x86_amx] = ACTIONS(263),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(265),
    [anon_sym_unwind] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_cleanup] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_catch] = ACTIONS(263),
    [anon_sym_filter] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_unordered] = ACTIONS(263),
    [anon_sym_monotonic] = ACTIONS(263),
    [anon_sym_acquire] = ACTIONS(263),
    [anon_sym_release] = ACTIONS(263),
    [anon_sym_acq_rel] = ACTIONS(263),
    [anon_sym_seq_cst] = ACTIONS(263),
    [anon_sym_syncscope] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_asm] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [262] = {
    [sym_addrspace] = STATE(285),
    [sym_argument_list] = STATE(257),
    [aux_sym_type_repeat1] = STATE(264),
    [aux_sym_type_repeat2] = STATE(257),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_label] = ACTIONS(234),
    [sym_string] = ACTIONS(236),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(236),
    [sym_float] = ACTIONS(236),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(236),
    [anon_sym_private] = ACTIONS(236),
    [anon_sym_internal] = ACTIONS(236),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(236),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(236),
    [anon_sym_available_externally] = ACTIONS(236),
    [anon_sym_appending] = ACTIONS(236),
    [anon_sym_common] = ACTIONS(236),
    [anon_sym_extern_weak] = ACTIONS(236),
    [anon_sym_external] = ACTIONS(236),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(236),
    [anon_sym_dso_preemptable] = ACTIONS(236),
    [anon_sym_default] = ACTIONS(236),
    [anon_sym_hidden] = ACTIONS(236),
    [anon_sym_protected] = ACTIONS(236),
    [anon_sym_dllimport] = ACTIONS(236),
    [anon_sym_dllexport] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_unreachable] = ACTIONS(236),
    [anon_sym_ret] = ACTIONS(236),
    [anon_sym_br] = ACTIONS(236),
    [anon_sym_resume] = ACTIONS(236),
    [anon_sym_freeze] = ACTIONS(236),
    [anon_sym_indirectbr] = ACTIONS(236),
    [anon_sym_extractelement] = ACTIONS(236),
    [anon_sym_insertelement] = ACTIONS(236),
    [anon_sym_select] = ACTIONS(236),
    [anon_sym_shufflevector] = ACTIONS(236),
    [anon_sym_fneg] = ACTIONS(236),
    [anon_sym_switch] = ACTIONS(236),
    [anon_sym_invoke] = ACTIONS(236),
    [anon_sym_cleanupret] = ACTIONS(236),
    [anon_sym_catchret] = ACTIONS(236),
    [anon_sym_catchswitch] = ACTIONS(236),
    [anon_sym_catchpad] = ACTIONS(236),
    [anon_sym_cleanuppad] = ACTIONS(236),
    [anon_sym_callbr] = ACTIONS(236),
    [anon_sym_icmp] = ACTIONS(236),
    [anon_sym_fcmp] = ACTIONS(236),
    [anon_sym_va_arg] = ACTIONS(236),
    [anon_sym_phi] = ACTIONS(236),
    [anon_sym_landingpad] = ACTIONS(236),
    [anon_sym_tail] = ACTIONS(236),
    [anon_sym_musttail] = ACTIONS(236),
    [anon_sym_notail] = ACTIONS(236),
    [anon_sym_call] = ACTIONS(236),
    [anon_sym_alloca] = ACTIONS(236),
    [anon_sym_load] = ACTIONS(236),
    [anon_sym_store] = ACTIONS(236),
    [anon_sym_cmpxchg] = ACTIONS(236),
    [anon_sym_atomicrmw] = ACTIONS(236),
    [anon_sym_fence] = ACTIONS(236),
    [anon_sym_getelementptr] = ACTIONS(236),
    [anon_sym_extractvalue] = ACTIONS(236),
    [anon_sym_insertvalue] = ACTIONS(236),
    [anon_sym_true] = ACTIONS(236),
    [anon_sym_false] = ACTIONS(236),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_none] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(236),
    [anon_sym_poison] = ACTIONS(236),
    [anon_sym_zeroinitializer] = ACTIONS(236),
    [anon_sym_catch] = ACTIONS(236),
    [anon_sym_filter] = ACTIONS(236),
    [anon_sym_blockaddress] = ACTIONS(236),
    [anon_sym_mul] = ACTIONS(236),
    [anon_sym_urem] = ACTIONS(236),
    [anon_sym_srem] = ACTIONS(236),
    [anon_sym_shl] = ACTIONS(236),
    [anon_sym_udiv] = ACTIONS(236),
    [anon_sym_sdiv] = ACTIONS(236),
    [anon_sym_lshr] = ACTIONS(236),
    [anon_sym_ashr] = ACTIONS(236),
    [anon_sym_fmul] = ACTIONS(236),
    [anon_sym_fdiv] = ACTIONS(236),
    [anon_sym_frem] = ACTIONS(236),
    [anon_sym_xchg] = ACTIONS(236),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(236),
    [anon_sym_and] = ACTIONS(236),
    [anon_sym_nand] = ACTIONS(236),
    [anon_sym_or] = ACTIONS(236),
    [anon_sym_xor] = ACTIONS(236),
    [anon_sym_max] = ACTIONS(236),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(236),
    [anon_sym_umin] = ACTIONS(236),
    [anon_sym_fadd] = ACTIONS(236),
    [anon_sym_fsub] = ACTIONS(236),
    [anon_sym_bitcast] = ACTIONS(236),
    [anon_sym_trunc] = ACTIONS(236),
    [anon_sym_zext] = ACTIONS(236),
    [anon_sym_sext] = ACTIONS(236),
    [anon_sym_fptrunc] = ACTIONS(236),
    [anon_sym_fpext] = ACTIONS(236),
    [anon_sym_addrspacecast] = ACTIONS(236),
    [anon_sym_uitofp] = ACTIONS(236),
    [anon_sym_sitofp] = ACTIONS(236),
    [anon_sym_fptoui] = ACTIONS(236),
    [anon_sym_fptosi] = ACTIONS(236),
    [anon_sym_inttoptr] = ACTIONS(236),
    [anon_sym_ptrtoint] = ACTIONS(236),
    [anon_sym_unordered] = ACTIONS(236),
    [anon_sym_monotonic] = ACTIONS(236),
    [anon_sym_acquire] = ACTIONS(236),
    [anon_sym_release] = ACTIONS(236),
    [anon_sym_acq_rel] = ACTIONS(236),
    [anon_sym_seq_cst] = ACTIONS(236),
    [anon_sym_syncscope] = ACTIONS(236),
    [anon_sym_uselistorder] = ACTIONS(236),
  },
  [263] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(266),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(125),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_unwind] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(978),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_unordered] = ACTIONS(116),
    [anon_sym_monotonic] = ACTIONS(116),
    [anon_sym_acquire] = ACTIONS(116),
    [anon_sym_release] = ACTIONS(116),
    [anon_sym_acq_rel] = ACTIONS(116),
    [anon_sym_seq_cst] = ACTIONS(116),
    [anon_sym_syncscope] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [264] = {
    [sym_addrspace] = STATE(287),
    [sym_argument_list] = STATE(282),
    [aux_sym_type_repeat1] = STATE(267),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [265] = {
    [sym_addrspace] = STATE(288),
    [sym_argument_list] = STATE(282),
    [aux_sym_type_repeat1] = STATE(267),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(265),
    [anon_sym_filter] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_unordered] = ACTIONS(265),
    [anon_sym_monotonic] = ACTIONS(265),
    [anon_sym_acquire] = ACTIONS(265),
    [anon_sym_release] = ACTIONS(265),
    [anon_sym_acq_rel] = ACTIONS(265),
    [anon_sym_seq_cst] = ACTIONS(265),
    [anon_sym_syncscope] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [266] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(132),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_RBRACK] = ACTIONS(38),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_GT] = ACTIONS(38),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_RPAREN] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_to] = ACTIONS(38),
    [anon_sym_unwind] = ACTIONS(38),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_unordered] = ACTIONS(38),
    [anon_sym_monotonic] = ACTIONS(38),
    [anon_sym_acquire] = ACTIONS(38),
    [anon_sym_release] = ACTIONS(38),
    [anon_sym_acq_rel] = ACTIONS(38),
    [anon_sym_seq_cst] = ACTIONS(38),
    [anon_sym_syncscope] = ACTIONS(38),
  },
  [267] = {
    [sym_addrspace] = STATE(1560),
    [aux_sym_type_repeat1] = STATE(267),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_catch] = ACTIONS(271),
    [anon_sym_filter] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_unordered] = ACTIONS(271),
    [anon_sym_monotonic] = ACTIONS(271),
    [anon_sym_acquire] = ACTIONS(271),
    [anon_sym_release] = ACTIONS(271),
    [anon_sym_acq_rel] = ACTIONS(271),
    [anon_sym_seq_cst] = ACTIONS(271),
    [anon_sym_syncscope] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [268] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(132),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [ts_builtin_sym_end] = ACTIONS(38),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(35),
    [sym_local_var] = ACTIONS(35),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_summary_ref] = ACTIONS(38),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_target] = ACTIONS(38),
    [anon_sym_source_filename] = ACTIONS(38),
    [anon_sym_declare] = ACTIONS(38),
    [anon_sym_define] = ACTIONS(38),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_uselistorder] = ACTIONS(70),
    [anon_sym_uselistorder_bb] = ACTIONS(38),
    [anon_sym_module] = ACTIONS(38),
    [anon_sym_attributes] = ACTIONS(38),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(397),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [aux_sym_metadata_ref_token1] = ACTIONS(397),
    [sym_summary_ref] = ACTIONS(397),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_target] = ACTIONS(397),
    [anon_sym_source_filename] = ACTIONS(397),
    [anon_sym_declare] = ACTIONS(397),
    [anon_sym_define] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_void] = ACTIONS(397),
    [anon_sym_half] = ACTIONS(397),
    [anon_sym_bfloat] = ACTIONS(397),
    [anon_sym_float] = ACTIONS(397),
    [anon_sym_double] = ACTIONS(397),
    [anon_sym_x86_fp80] = ACTIONS(397),
    [anon_sym_fp128] = ACTIONS(397),
    [anon_sym_ppc_fp128] = ACTIONS(397),
    [anon_sym_label] = ACTIONS(397),
    [anon_sym_metadata] = ACTIONS(397),
    [anon_sym_x86_mmx] = ACTIONS(397),
    [anon_sym_x86_amx] = ACTIONS(397),
    [anon_sym_token] = ACTIONS(397),
    [anon_sym_opaque] = ACTIONS(397),
    [anon_sym_ptr] = ACTIONS(399),
    [aux_sym_type_keyword_token1] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_to] = ACTIONS(399),
    [anon_sym_unwind] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
    [anon_sym_unordered] = ACTIONS(397),
    [anon_sym_monotonic] = ACTIONS(397),
    [anon_sym_acquire] = ACTIONS(397),
    [anon_sym_release] = ACTIONS(397),
    [anon_sym_acq_rel] = ACTIONS(397),
    [anon_sym_seq_cst] = ACTIONS(397),
    [anon_sym_syncscope] = ACTIONS(397),
    [anon_sym_uselistorder] = ACTIONS(399),
    [anon_sym_uselistorder_bb] = ACTIONS(397),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_asm] = ACTIONS(397),
    [anon_sym_attributes] = ACTIONS(397),
  },
  [270] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(268),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(125),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(985),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(978),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [271] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [sym_label] = ACTIONS(295),
    [sym_string] = ACTIONS(297),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(297),
    [sym_float] = ACTIONS(297),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(297),
    [anon_sym_private] = ACTIONS(297),
    [anon_sym_internal] = ACTIONS(297),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(297),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(297),
    [anon_sym_available_externally] = ACTIONS(297),
    [anon_sym_appending] = ACTIONS(297),
    [anon_sym_common] = ACTIONS(297),
    [anon_sym_extern_weak] = ACTIONS(297),
    [anon_sym_external] = ACTIONS(297),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(297),
    [anon_sym_dso_preemptable] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_hidden] = ACTIONS(297),
    [anon_sym_protected] = ACTIONS(297),
    [anon_sym_dllimport] = ACTIONS(297),
    [anon_sym_dllexport] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_unreachable] = ACTIONS(297),
    [anon_sym_ret] = ACTIONS(297),
    [anon_sym_br] = ACTIONS(297),
    [anon_sym_resume] = ACTIONS(297),
    [anon_sym_freeze] = ACTIONS(297),
    [anon_sym_indirectbr] = ACTIONS(297),
    [anon_sym_extractelement] = ACTIONS(297),
    [anon_sym_insertelement] = ACTIONS(297),
    [anon_sym_select] = ACTIONS(297),
    [anon_sym_shufflevector] = ACTIONS(297),
    [anon_sym_fneg] = ACTIONS(297),
    [anon_sym_switch] = ACTIONS(297),
    [anon_sym_invoke] = ACTIONS(297),
    [anon_sym_cleanupret] = ACTIONS(297),
    [anon_sym_catchret] = ACTIONS(297),
    [anon_sym_catchswitch] = ACTIONS(297),
    [anon_sym_catchpad] = ACTIONS(297),
    [anon_sym_cleanuppad] = ACTIONS(297),
    [anon_sym_callbr] = ACTIONS(297),
    [anon_sym_icmp] = ACTIONS(297),
    [anon_sym_fcmp] = ACTIONS(297),
    [anon_sym_va_arg] = ACTIONS(297),
    [anon_sym_phi] = ACTIONS(297),
    [anon_sym_landingpad] = ACTIONS(297),
    [anon_sym_tail] = ACTIONS(297),
    [anon_sym_musttail] = ACTIONS(297),
    [anon_sym_notail] = ACTIONS(297),
    [anon_sym_call] = ACTIONS(297),
    [anon_sym_alloca] = ACTIONS(297),
    [anon_sym_load] = ACTIONS(297),
    [anon_sym_store] = ACTIONS(297),
    [anon_sym_cmpxchg] = ACTIONS(297),
    [anon_sym_atomicrmw] = ACTIONS(297),
    [anon_sym_fence] = ACTIONS(297),
    [anon_sym_getelementptr] = ACTIONS(297),
    [anon_sym_extractvalue] = ACTIONS(297),
    [anon_sym_insertvalue] = ACTIONS(297),
    [anon_sym_true] = ACTIONS(297),
    [anon_sym_false] = ACTIONS(297),
    [anon_sym_null] = ACTIONS(297),
    [anon_sym_none] = ACTIONS(297),
    [anon_sym_undef] = ACTIONS(297),
    [anon_sym_poison] = ACTIONS(297),
    [anon_sym_zeroinitializer] = ACTIONS(297),
    [anon_sym_catch] = ACTIONS(297),
    [anon_sym_filter] = ACTIONS(297),
    [anon_sym_blockaddress] = ACTIONS(297),
    [anon_sym_mul] = ACTIONS(297),
    [anon_sym_urem] = ACTIONS(297),
    [anon_sym_srem] = ACTIONS(297),
    [anon_sym_shl] = ACTIONS(297),
    [anon_sym_udiv] = ACTIONS(297),
    [anon_sym_sdiv] = ACTIONS(297),
    [anon_sym_lshr] = ACTIONS(297),
    [anon_sym_ashr] = ACTIONS(297),
    [anon_sym_fmul] = ACTIONS(297),
    [anon_sym_fdiv] = ACTIONS(297),
    [anon_sym_frem] = ACTIONS(297),
    [anon_sym_xchg] = ACTIONS(297),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(297),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_nand] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(297),
    [anon_sym_xor] = ACTIONS(297),
    [anon_sym_max] = ACTIONS(297),
    [anon_sym_min] = ACTIONS(297),
    [anon_sym_umax] = ACTIONS(297),
    [anon_sym_umin] = ACTIONS(297),
    [anon_sym_fadd] = ACTIONS(297),
    [anon_sym_fsub] = ACTIONS(297),
    [anon_sym_bitcast] = ACTIONS(297),
    [anon_sym_trunc] = ACTIONS(297),
    [anon_sym_zext] = ACTIONS(297),
    [anon_sym_sext] = ACTIONS(297),
    [anon_sym_fptrunc] = ACTIONS(297),
    [anon_sym_fpext] = ACTIONS(297),
    [anon_sym_addrspacecast] = ACTIONS(297),
    [anon_sym_uitofp] = ACTIONS(297),
    [anon_sym_sitofp] = ACTIONS(297),
    [anon_sym_fptoui] = ACTIONS(297),
    [anon_sym_fptosi] = ACTIONS(297),
    [anon_sym_inttoptr] = ACTIONS(297),
    [anon_sym_ptrtoint] = ACTIONS(297),
    [anon_sym_unordered] = ACTIONS(297),
    [anon_sym_monotonic] = ACTIONS(297),
    [anon_sym_acquire] = ACTIONS(297),
    [anon_sym_release] = ACTIONS(297),
    [anon_sym_acq_rel] = ACTIONS(297),
    [anon_sym_seq_cst] = ACTIONS(297),
    [anon_sym_syncscope] = ACTIONS(297),
    [anon_sym_uselistorder] = ACTIONS(297),
  },
  [272] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [sym_label] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(305),
    [sym_float] = ACTIONS(305),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(305),
    [anon_sym_private] = ACTIONS(305),
    [anon_sym_internal] = ACTIONS(305),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(305),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(305),
    [anon_sym_available_externally] = ACTIONS(305),
    [anon_sym_appending] = ACTIONS(305),
    [anon_sym_common] = ACTIONS(305),
    [anon_sym_extern_weak] = ACTIONS(305),
    [anon_sym_external] = ACTIONS(305),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(305),
    [anon_sym_dso_preemptable] = ACTIONS(305),
    [anon_sym_default] = ACTIONS(305),
    [anon_sym_hidden] = ACTIONS(305),
    [anon_sym_protected] = ACTIONS(305),
    [anon_sym_dllimport] = ACTIONS(305),
    [anon_sym_dllexport] = ACTIONS(305),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_unreachable] = ACTIONS(305),
    [anon_sym_ret] = ACTIONS(305),
    [anon_sym_br] = ACTIONS(305),
    [anon_sym_resume] = ACTIONS(305),
    [anon_sym_freeze] = ACTIONS(305),
    [anon_sym_indirectbr] = ACTIONS(305),
    [anon_sym_extractelement] = ACTIONS(305),
    [anon_sym_insertelement] = ACTIONS(305),
    [anon_sym_select] = ACTIONS(305),
    [anon_sym_shufflevector] = ACTIONS(305),
    [anon_sym_fneg] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(305),
    [anon_sym_invoke] = ACTIONS(305),
    [anon_sym_cleanupret] = ACTIONS(305),
    [anon_sym_catchret] = ACTIONS(305),
    [anon_sym_catchswitch] = ACTIONS(305),
    [anon_sym_catchpad] = ACTIONS(305),
    [anon_sym_cleanuppad] = ACTIONS(305),
    [anon_sym_callbr] = ACTIONS(305),
    [anon_sym_icmp] = ACTIONS(305),
    [anon_sym_fcmp] = ACTIONS(305),
    [anon_sym_va_arg] = ACTIONS(305),
    [anon_sym_phi] = ACTIONS(305),
    [anon_sym_landingpad] = ACTIONS(305),
    [anon_sym_tail] = ACTIONS(305),
    [anon_sym_musttail] = ACTIONS(305),
    [anon_sym_notail] = ACTIONS(305),
    [anon_sym_call] = ACTIONS(305),
    [anon_sym_alloca] = ACTIONS(305),
    [anon_sym_load] = ACTIONS(305),
    [anon_sym_store] = ACTIONS(305),
    [anon_sym_cmpxchg] = ACTIONS(305),
    [anon_sym_atomicrmw] = ACTIONS(305),
    [anon_sym_fence] = ACTIONS(305),
    [anon_sym_getelementptr] = ACTIONS(305),
    [anon_sym_extractvalue] = ACTIONS(305),
    [anon_sym_insertvalue] = ACTIONS(305),
    [anon_sym_true] = ACTIONS(305),
    [anon_sym_false] = ACTIONS(305),
    [anon_sym_null] = ACTIONS(305),
    [anon_sym_none] = ACTIONS(305),
    [anon_sym_undef] = ACTIONS(305),
    [anon_sym_poison] = ACTIONS(305),
    [anon_sym_zeroinitializer] = ACTIONS(305),
    [anon_sym_catch] = ACTIONS(305),
    [anon_sym_filter] = ACTIONS(305),
    [anon_sym_blockaddress] = ACTIONS(305),
    [anon_sym_mul] = ACTIONS(305),
    [anon_sym_urem] = ACTIONS(305),
    [anon_sym_srem] = ACTIONS(305),
    [anon_sym_shl] = ACTIONS(305),
    [anon_sym_udiv] = ACTIONS(305),
    [anon_sym_sdiv] = ACTIONS(305),
    [anon_sym_lshr] = ACTIONS(305),
    [anon_sym_ashr] = ACTIONS(305),
    [anon_sym_fmul] = ACTIONS(305),
    [anon_sym_fdiv] = ACTIONS(305),
    [anon_sym_frem] = ACTIONS(305),
    [anon_sym_xchg] = ACTIONS(305),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(305),
    [anon_sym_and] = ACTIONS(305),
    [anon_sym_nand] = ACTIONS(305),
    [anon_sym_or] = ACTIONS(305),
    [anon_sym_xor] = ACTIONS(305),
    [anon_sym_max] = ACTIONS(305),
    [anon_sym_min] = ACTIONS(305),
    [anon_sym_umax] = ACTIONS(305),
    [anon_sym_umin] = ACTIONS(305),
    [anon_sym_fadd] = ACTIONS(305),
    [anon_sym_fsub] = ACTIONS(305),
    [anon_sym_bitcast] = ACTIONS(305),
    [anon_sym_trunc] = ACTIONS(305),
    [anon_sym_zext] = ACTIONS(305),
    [anon_sym_sext] = ACTIONS(305),
    [anon_sym_fptrunc] = ACTIONS(305),
    [anon_sym_fpext] = ACTIONS(305),
    [anon_sym_addrspacecast] = ACTIONS(305),
    [anon_sym_uitofp] = ACTIONS(305),
    [anon_sym_sitofp] = ACTIONS(305),
    [anon_sym_fptoui] = ACTIONS(305),
    [anon_sym_fptosi] = ACTIONS(305),
    [anon_sym_inttoptr] = ACTIONS(305),
    [anon_sym_ptrtoint] = ACTIONS(305),
    [anon_sym_unordered] = ACTIONS(305),
    [anon_sym_monotonic] = ACTIONS(305),
    [anon_sym_acquire] = ACTIONS(305),
    [anon_sym_release] = ACTIONS(305),
    [anon_sym_acq_rel] = ACTIONS(305),
    [anon_sym_seq_cst] = ACTIONS(305),
    [anon_sym_syncscope] = ACTIONS(305),
    [anon_sym_uselistorder] = ACTIONS(305),
  },
  [273] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [sym_label] = ACTIONS(283),
    [sym_string] = ACTIONS(285),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(285),
    [sym_float] = ACTIONS(285),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(285),
    [anon_sym_private] = ACTIONS(285),
    [anon_sym_internal] = ACTIONS(285),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(285),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(285),
    [anon_sym_available_externally] = ACTIONS(285),
    [anon_sym_appending] = ACTIONS(285),
    [anon_sym_common] = ACTIONS(285),
    [anon_sym_extern_weak] = ACTIONS(285),
    [anon_sym_external] = ACTIONS(285),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(285),
    [anon_sym_dso_preemptable] = ACTIONS(285),
    [anon_sym_default] = ACTIONS(285),
    [anon_sym_hidden] = ACTIONS(285),
    [anon_sym_protected] = ACTIONS(285),
    [anon_sym_dllimport] = ACTIONS(285),
    [anon_sym_dllexport] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_unreachable] = ACTIONS(285),
    [anon_sym_ret] = ACTIONS(285),
    [anon_sym_br] = ACTIONS(285),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_freeze] = ACTIONS(285),
    [anon_sym_indirectbr] = ACTIONS(285),
    [anon_sym_extractelement] = ACTIONS(285),
    [anon_sym_insertelement] = ACTIONS(285),
    [anon_sym_select] = ACTIONS(285),
    [anon_sym_shufflevector] = ACTIONS(285),
    [anon_sym_fneg] = ACTIONS(285),
    [anon_sym_switch] = ACTIONS(285),
    [anon_sym_invoke] = ACTIONS(285),
    [anon_sym_cleanupret] = ACTIONS(285),
    [anon_sym_catchret] = ACTIONS(285),
    [anon_sym_catchswitch] = ACTIONS(285),
    [anon_sym_catchpad] = ACTIONS(285),
    [anon_sym_cleanuppad] = ACTIONS(285),
    [anon_sym_callbr] = ACTIONS(285),
    [anon_sym_icmp] = ACTIONS(285),
    [anon_sym_fcmp] = ACTIONS(285),
    [anon_sym_va_arg] = ACTIONS(285),
    [anon_sym_phi] = ACTIONS(285),
    [anon_sym_landingpad] = ACTIONS(285),
    [anon_sym_tail] = ACTIONS(285),
    [anon_sym_musttail] = ACTIONS(285),
    [anon_sym_notail] = ACTIONS(285),
    [anon_sym_call] = ACTIONS(285),
    [anon_sym_alloca] = ACTIONS(285),
    [anon_sym_load] = ACTIONS(285),
    [anon_sym_store] = ACTIONS(285),
    [anon_sym_cmpxchg] = ACTIONS(285),
    [anon_sym_atomicrmw] = ACTIONS(285),
    [anon_sym_fence] = ACTIONS(285),
    [anon_sym_getelementptr] = ACTIONS(285),
    [anon_sym_extractvalue] = ACTIONS(285),
    [anon_sym_insertvalue] = ACTIONS(285),
    [anon_sym_true] = ACTIONS(285),
    [anon_sym_false] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(285),
    [anon_sym_none] = ACTIONS(285),
    [anon_sym_undef] = ACTIONS(285),
    [anon_sym_poison] = ACTIONS(285),
    [anon_sym_zeroinitializer] = ACTIONS(285),
    [anon_sym_catch] = ACTIONS(285),
    [anon_sym_filter] = ACTIONS(285),
    [anon_sym_blockaddress] = ACTIONS(285),
    [anon_sym_mul] = ACTIONS(285),
    [anon_sym_urem] = ACTIONS(285),
    [anon_sym_srem] = ACTIONS(285),
    [anon_sym_shl] = ACTIONS(285),
    [anon_sym_udiv] = ACTIONS(285),
    [anon_sym_sdiv] = ACTIONS(285),
    [anon_sym_lshr] = ACTIONS(285),
    [anon_sym_ashr] = ACTIONS(285),
    [anon_sym_fmul] = ACTIONS(285),
    [anon_sym_fdiv] = ACTIONS(285),
    [anon_sym_frem] = ACTIONS(285),
    [anon_sym_xchg] = ACTIONS(285),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(285),
    [anon_sym_and] = ACTIONS(285),
    [anon_sym_nand] = ACTIONS(285),
    [anon_sym_or] = ACTIONS(285),
    [anon_sym_xor] = ACTIONS(285),
    [anon_sym_max] = ACTIONS(285),
    [anon_sym_min] = ACTIONS(285),
    [anon_sym_umax] = ACTIONS(285),
    [anon_sym_umin] = ACTIONS(285),
    [anon_sym_fadd] = ACTIONS(285),
    [anon_sym_fsub] = ACTIONS(285),
    [anon_sym_bitcast] = ACTIONS(285),
    [anon_sym_trunc] = ACTIONS(285),
    [anon_sym_zext] = ACTIONS(285),
    [anon_sym_sext] = ACTIONS(285),
    [anon_sym_fptrunc] = ACTIONS(285),
    [anon_sym_fpext] = ACTIONS(285),
    [anon_sym_addrspacecast] = ACTIONS(285),
    [anon_sym_uitofp] = ACTIONS(285),
    [anon_sym_sitofp] = ACTIONS(285),
    [anon_sym_fptoui] = ACTIONS(285),
    [anon_sym_fptosi] = ACTIONS(285),
    [anon_sym_inttoptr] = ACTIONS(285),
    [anon_sym_ptrtoint] = ACTIONS(285),
    [anon_sym_unordered] = ACTIONS(285),
    [anon_sym_monotonic] = ACTIONS(285),
    [anon_sym_acquire] = ACTIONS(285),
    [anon_sym_release] = ACTIONS(285),
    [anon_sym_acq_rel] = ACTIONS(285),
    [anon_sym_seq_cst] = ACTIONS(285),
    [anon_sym_syncscope] = ACTIONS(285),
    [anon_sym_uselistorder] = ACTIONS(285),
  },
  [274] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_label] = ACTIONS(116),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_catch] = ACTIONS(122),
    [anon_sym_filter] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_unordered] = ACTIONS(122),
    [anon_sym_monotonic] = ACTIONS(122),
    [anon_sym_acquire] = ACTIONS(122),
    [anon_sym_release] = ACTIONS(122),
    [anon_sym_acq_rel] = ACTIONS(122),
    [anon_sym_seq_cst] = ACTIONS(122),
    [anon_sym_syncscope] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
  },
  [275] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [sym_label] = ACTIONS(287),
    [sym_string] = ACTIONS(289),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(289),
    [sym_float] = ACTIONS(289),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(289),
    [anon_sym_private] = ACTIONS(289),
    [anon_sym_internal] = ACTIONS(289),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(289),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(289),
    [anon_sym_available_externally] = ACTIONS(289),
    [anon_sym_appending] = ACTIONS(289),
    [anon_sym_common] = ACTIONS(289),
    [anon_sym_extern_weak] = ACTIONS(289),
    [anon_sym_external] = ACTIONS(289),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(289),
    [anon_sym_dso_preemptable] = ACTIONS(289),
    [anon_sym_default] = ACTIONS(289),
    [anon_sym_hidden] = ACTIONS(289),
    [anon_sym_protected] = ACTIONS(289),
    [anon_sym_dllimport] = ACTIONS(289),
    [anon_sym_dllexport] = ACTIONS(289),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_unreachable] = ACTIONS(289),
    [anon_sym_ret] = ACTIONS(289),
    [anon_sym_br] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_freeze] = ACTIONS(289),
    [anon_sym_indirectbr] = ACTIONS(289),
    [anon_sym_extractelement] = ACTIONS(289),
    [anon_sym_insertelement] = ACTIONS(289),
    [anon_sym_select] = ACTIONS(289),
    [anon_sym_shufflevector] = ACTIONS(289),
    [anon_sym_fneg] = ACTIONS(289),
    [anon_sym_switch] = ACTIONS(289),
    [anon_sym_invoke] = ACTIONS(289),
    [anon_sym_cleanupret] = ACTIONS(289),
    [anon_sym_catchret] = ACTIONS(289),
    [anon_sym_catchswitch] = ACTIONS(289),
    [anon_sym_catchpad] = ACTIONS(289),
    [anon_sym_cleanuppad] = ACTIONS(289),
    [anon_sym_callbr] = ACTIONS(289),
    [anon_sym_icmp] = ACTIONS(289),
    [anon_sym_fcmp] = ACTIONS(289),
    [anon_sym_va_arg] = ACTIONS(289),
    [anon_sym_phi] = ACTIONS(289),
    [anon_sym_landingpad] = ACTIONS(289),
    [anon_sym_tail] = ACTIONS(289),
    [anon_sym_musttail] = ACTIONS(289),
    [anon_sym_notail] = ACTIONS(289),
    [anon_sym_call] = ACTIONS(289),
    [anon_sym_alloca] = ACTIONS(289),
    [anon_sym_load] = ACTIONS(289),
    [anon_sym_store] = ACTIONS(289),
    [anon_sym_cmpxchg] = ACTIONS(289),
    [anon_sym_atomicrmw] = ACTIONS(289),
    [anon_sym_fence] = ACTIONS(289),
    [anon_sym_getelementptr] = ACTIONS(289),
    [anon_sym_extractvalue] = ACTIONS(289),
    [anon_sym_insertvalue] = ACTIONS(289),
    [anon_sym_true] = ACTIONS(289),
    [anon_sym_false] = ACTIONS(289),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_none] = ACTIONS(289),
    [anon_sym_undef] = ACTIONS(289),
    [anon_sym_poison] = ACTIONS(289),
    [anon_sym_zeroinitializer] = ACTIONS(289),
    [anon_sym_catch] = ACTIONS(289),
    [anon_sym_filter] = ACTIONS(289),
    [anon_sym_blockaddress] = ACTIONS(289),
    [anon_sym_mul] = ACTIONS(289),
    [anon_sym_urem] = ACTIONS(289),
    [anon_sym_srem] = ACTIONS(289),
    [anon_sym_shl] = ACTIONS(289),
    [anon_sym_udiv] = ACTIONS(289),
    [anon_sym_sdiv] = ACTIONS(289),
    [anon_sym_lshr] = ACTIONS(289),
    [anon_sym_ashr] = ACTIONS(289),
    [anon_sym_fmul] = ACTIONS(289),
    [anon_sym_fdiv] = ACTIONS(289),
    [anon_sym_frem] = ACTIONS(289),
    [anon_sym_xchg] = ACTIONS(289),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(289),
    [anon_sym_and] = ACTIONS(289),
    [anon_sym_nand] = ACTIONS(289),
    [anon_sym_or] = ACTIONS(289),
    [anon_sym_xor] = ACTIONS(289),
    [anon_sym_max] = ACTIONS(289),
    [anon_sym_min] = ACTIONS(289),
    [anon_sym_umax] = ACTIONS(289),
    [anon_sym_umin] = ACTIONS(289),
    [anon_sym_fadd] = ACTIONS(289),
    [anon_sym_fsub] = ACTIONS(289),
    [anon_sym_bitcast] = ACTIONS(289),
    [anon_sym_trunc] = ACTIONS(289),
    [anon_sym_zext] = ACTIONS(289),
    [anon_sym_sext] = ACTIONS(289),
    [anon_sym_fptrunc] = ACTIONS(289),
    [anon_sym_fpext] = ACTIONS(289),
    [anon_sym_addrspacecast] = ACTIONS(289),
    [anon_sym_uitofp] = ACTIONS(289),
    [anon_sym_sitofp] = ACTIONS(289),
    [anon_sym_fptoui] = ACTIONS(289),
    [anon_sym_fptosi] = ACTIONS(289),
    [anon_sym_inttoptr] = ACTIONS(289),
    [anon_sym_ptrtoint] = ACTIONS(289),
    [anon_sym_unordered] = ACTIONS(289),
    [anon_sym_monotonic] = ACTIONS(289),
    [anon_sym_acquire] = ACTIONS(289),
    [anon_sym_release] = ACTIONS(289),
    [anon_sym_acq_rel] = ACTIONS(289),
    [anon_sym_seq_cst] = ACTIONS(289),
    [anon_sym_syncscope] = ACTIONS(289),
    [anon_sym_uselistorder] = ACTIONS(289),
  },
  [276] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [sym_label] = ACTIONS(307),
    [sym_string] = ACTIONS(309),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(309),
    [sym_float] = ACTIONS(309),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(309),
    [anon_sym_private] = ACTIONS(309),
    [anon_sym_internal] = ACTIONS(309),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(309),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(309),
    [anon_sym_available_externally] = ACTIONS(309),
    [anon_sym_appending] = ACTIONS(309),
    [anon_sym_common] = ACTIONS(309),
    [anon_sym_extern_weak] = ACTIONS(309),
    [anon_sym_external] = ACTIONS(309),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(309),
    [anon_sym_dso_preemptable] = ACTIONS(309),
    [anon_sym_default] = ACTIONS(309),
    [anon_sym_hidden] = ACTIONS(309),
    [anon_sym_protected] = ACTIONS(309),
    [anon_sym_dllimport] = ACTIONS(309),
    [anon_sym_dllexport] = ACTIONS(309),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_unreachable] = ACTIONS(309),
    [anon_sym_ret] = ACTIONS(309),
    [anon_sym_br] = ACTIONS(309),
    [anon_sym_resume] = ACTIONS(309),
    [anon_sym_freeze] = ACTIONS(309),
    [anon_sym_indirectbr] = ACTIONS(309),
    [anon_sym_extractelement] = ACTIONS(309),
    [anon_sym_insertelement] = ACTIONS(309),
    [anon_sym_select] = ACTIONS(309),
    [anon_sym_shufflevector] = ACTIONS(309),
    [anon_sym_fneg] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_invoke] = ACTIONS(309),
    [anon_sym_cleanupret] = ACTIONS(309),
    [anon_sym_catchret] = ACTIONS(309),
    [anon_sym_catchswitch] = ACTIONS(309),
    [anon_sym_catchpad] = ACTIONS(309),
    [anon_sym_cleanuppad] = ACTIONS(309),
    [anon_sym_callbr] = ACTIONS(309),
    [anon_sym_icmp] = ACTIONS(309),
    [anon_sym_fcmp] = ACTIONS(309),
    [anon_sym_va_arg] = ACTIONS(309),
    [anon_sym_phi] = ACTIONS(309),
    [anon_sym_landingpad] = ACTIONS(309),
    [anon_sym_tail] = ACTIONS(309),
    [anon_sym_musttail] = ACTIONS(309),
    [anon_sym_notail] = ACTIONS(309),
    [anon_sym_call] = ACTIONS(309),
    [anon_sym_alloca] = ACTIONS(309),
    [anon_sym_load] = ACTIONS(309),
    [anon_sym_store] = ACTIONS(309),
    [anon_sym_cmpxchg] = ACTIONS(309),
    [anon_sym_atomicrmw] = ACTIONS(309),
    [anon_sym_fence] = ACTIONS(309),
    [anon_sym_getelementptr] = ACTIONS(309),
    [anon_sym_extractvalue] = ACTIONS(309),
    [anon_sym_insertvalue] = ACTIONS(309),
    [anon_sym_true] = ACTIONS(309),
    [anon_sym_false] = ACTIONS(309),
    [anon_sym_null] = ACTIONS(309),
    [anon_sym_none] = ACTIONS(309),
    [anon_sym_undef] = ACTIONS(309),
    [anon_sym_poison] = ACTIONS(309),
    [anon_sym_zeroinitializer] = ACTIONS(309),
    [anon_sym_catch] = ACTIONS(309),
    [anon_sym_filter] = ACTIONS(309),
    [anon_sym_blockaddress] = ACTIONS(309),
    [anon_sym_mul] = ACTIONS(309),
    [anon_sym_urem] = ACTIONS(309),
    [anon_sym_srem] = ACTIONS(309),
    [anon_sym_shl] = ACTIONS(309),
    [anon_sym_udiv] = ACTIONS(309),
    [anon_sym_sdiv] = ACTIONS(309),
    [anon_sym_lshr] = ACTIONS(309),
    [anon_sym_ashr] = ACTIONS(309),
    [anon_sym_fmul] = ACTIONS(309),
    [anon_sym_fdiv] = ACTIONS(309),
    [anon_sym_frem] = ACTIONS(309),
    [anon_sym_xchg] = ACTIONS(309),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(309),
    [anon_sym_nand] = ACTIONS(309),
    [anon_sym_or] = ACTIONS(309),
    [anon_sym_xor] = ACTIONS(309),
    [anon_sym_max] = ACTIONS(309),
    [anon_sym_min] = ACTIONS(309),
    [anon_sym_umax] = ACTIONS(309),
    [anon_sym_umin] = ACTIONS(309),
    [anon_sym_fadd] = ACTIONS(309),
    [anon_sym_fsub] = ACTIONS(309),
    [anon_sym_bitcast] = ACTIONS(309),
    [anon_sym_trunc] = ACTIONS(309),
    [anon_sym_zext] = ACTIONS(309),
    [anon_sym_sext] = ACTIONS(309),
    [anon_sym_fptrunc] = ACTIONS(309),
    [anon_sym_fpext] = ACTIONS(309),
    [anon_sym_addrspacecast] = ACTIONS(309),
    [anon_sym_uitofp] = ACTIONS(309),
    [anon_sym_sitofp] = ACTIONS(309),
    [anon_sym_fptoui] = ACTIONS(309),
    [anon_sym_fptosi] = ACTIONS(309),
    [anon_sym_inttoptr] = ACTIONS(309),
    [anon_sym_ptrtoint] = ACTIONS(309),
    [anon_sym_unordered] = ACTIONS(309),
    [anon_sym_monotonic] = ACTIONS(309),
    [anon_sym_acquire] = ACTIONS(309),
    [anon_sym_release] = ACTIONS(309),
    [anon_sym_acq_rel] = ACTIONS(309),
    [anon_sym_seq_cst] = ACTIONS(309),
    [anon_sym_syncscope] = ACTIONS(309),
    [anon_sym_uselistorder] = ACTIONS(309),
  },
  [277] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_label] = ACTIONS(279),
    [sym_string] = ACTIONS(281),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(281),
    [sym_float] = ACTIONS(281),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_internal] = ACTIONS(281),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(281),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(281),
    [anon_sym_available_externally] = ACTIONS(281),
    [anon_sym_appending] = ACTIONS(281),
    [anon_sym_common] = ACTIONS(281),
    [anon_sym_extern_weak] = ACTIONS(281),
    [anon_sym_external] = ACTIONS(281),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(281),
    [anon_sym_dso_preemptable] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_hidden] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_dllimport] = ACTIONS(281),
    [anon_sym_dllexport] = ACTIONS(281),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_unreachable] = ACTIONS(281),
    [anon_sym_ret] = ACTIONS(281),
    [anon_sym_br] = ACTIONS(281),
    [anon_sym_resume] = ACTIONS(281),
    [anon_sym_freeze] = ACTIONS(281),
    [anon_sym_indirectbr] = ACTIONS(281),
    [anon_sym_extractelement] = ACTIONS(281),
    [anon_sym_insertelement] = ACTIONS(281),
    [anon_sym_select] = ACTIONS(281),
    [anon_sym_shufflevector] = ACTIONS(281),
    [anon_sym_fneg] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_invoke] = ACTIONS(281),
    [anon_sym_cleanupret] = ACTIONS(281),
    [anon_sym_catchret] = ACTIONS(281),
    [anon_sym_catchswitch] = ACTIONS(281),
    [anon_sym_catchpad] = ACTIONS(281),
    [anon_sym_cleanuppad] = ACTIONS(281),
    [anon_sym_callbr] = ACTIONS(281),
    [anon_sym_icmp] = ACTIONS(281),
    [anon_sym_fcmp] = ACTIONS(281),
    [anon_sym_va_arg] = ACTIONS(281),
    [anon_sym_phi] = ACTIONS(281),
    [anon_sym_landingpad] = ACTIONS(281),
    [anon_sym_tail] = ACTIONS(281),
    [anon_sym_musttail] = ACTIONS(281),
    [anon_sym_notail] = ACTIONS(281),
    [anon_sym_call] = ACTIONS(281),
    [anon_sym_alloca] = ACTIONS(281),
    [anon_sym_load] = ACTIONS(281),
    [anon_sym_store] = ACTIONS(281),
    [anon_sym_cmpxchg] = ACTIONS(281),
    [anon_sym_atomicrmw] = ACTIONS(281),
    [anon_sym_fence] = ACTIONS(281),
    [anon_sym_getelementptr] = ACTIONS(281),
    [anon_sym_extractvalue] = ACTIONS(281),
    [anon_sym_insertvalue] = ACTIONS(281),
    [anon_sym_true] = ACTIONS(281),
    [anon_sym_false] = ACTIONS(281),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_none] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(281),
    [anon_sym_poison] = ACTIONS(281),
    [anon_sym_zeroinitializer] = ACTIONS(281),
    [anon_sym_catch] = ACTIONS(281),
    [anon_sym_filter] = ACTIONS(281),
    [anon_sym_blockaddress] = ACTIONS(281),
    [anon_sym_mul] = ACTIONS(281),
    [anon_sym_urem] = ACTIONS(281),
    [anon_sym_srem] = ACTIONS(281),
    [anon_sym_shl] = ACTIONS(281),
    [anon_sym_udiv] = ACTIONS(281),
    [anon_sym_sdiv] = ACTIONS(281),
    [anon_sym_lshr] = ACTIONS(281),
    [anon_sym_ashr] = ACTIONS(281),
    [anon_sym_fmul] = ACTIONS(281),
    [anon_sym_fdiv] = ACTIONS(281),
    [anon_sym_frem] = ACTIONS(281),
    [anon_sym_xchg] = ACTIONS(281),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(281),
    [anon_sym_nand] = ACTIONS(281),
    [anon_sym_or] = ACTIONS(281),
    [anon_sym_xor] = ACTIONS(281),
    [anon_sym_max] = ACTIONS(281),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(281),
    [anon_sym_umin] = ACTIONS(281),
    [anon_sym_fadd] = ACTIONS(281),
    [anon_sym_fsub] = ACTIONS(281),
    [anon_sym_bitcast] = ACTIONS(281),
    [anon_sym_trunc] = ACTIONS(281),
    [anon_sym_zext] = ACTIONS(281),
    [anon_sym_sext] = ACTIONS(281),
    [anon_sym_fptrunc] = ACTIONS(281),
    [anon_sym_fpext] = ACTIONS(281),
    [anon_sym_addrspacecast] = ACTIONS(281),
    [anon_sym_uitofp] = ACTIONS(281),
    [anon_sym_sitofp] = ACTIONS(281),
    [anon_sym_fptoui] = ACTIONS(281),
    [anon_sym_fptosi] = ACTIONS(281),
    [anon_sym_inttoptr] = ACTIONS(281),
    [anon_sym_ptrtoint] = ACTIONS(281),
    [anon_sym_unordered] = ACTIONS(281),
    [anon_sym_monotonic] = ACTIONS(281),
    [anon_sym_acquire] = ACTIONS(281),
    [anon_sym_release] = ACTIONS(281),
    [anon_sym_acq_rel] = ACTIONS(281),
    [anon_sym_seq_cst] = ACTIONS(281),
    [anon_sym_syncscope] = ACTIONS(281),
    [anon_sym_uselistorder] = ACTIONS(281),
  },
  [278] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [sym_label] = ACTIONS(291),
    [sym_string] = ACTIONS(293),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(293),
    [sym_float] = ACTIONS(293),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(293),
    [anon_sym_private] = ACTIONS(293),
    [anon_sym_internal] = ACTIONS(293),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(293),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(293),
    [anon_sym_available_externally] = ACTIONS(293),
    [anon_sym_appending] = ACTIONS(293),
    [anon_sym_common] = ACTIONS(293),
    [anon_sym_extern_weak] = ACTIONS(293),
    [anon_sym_external] = ACTIONS(293),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(293),
    [anon_sym_dso_preemptable] = ACTIONS(293),
    [anon_sym_default] = ACTIONS(293),
    [anon_sym_hidden] = ACTIONS(293),
    [anon_sym_protected] = ACTIONS(293),
    [anon_sym_dllimport] = ACTIONS(293),
    [anon_sym_dllexport] = ACTIONS(293),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_unreachable] = ACTIONS(293),
    [anon_sym_ret] = ACTIONS(293),
    [anon_sym_br] = ACTIONS(293),
    [anon_sym_resume] = ACTIONS(293),
    [anon_sym_freeze] = ACTIONS(293),
    [anon_sym_indirectbr] = ACTIONS(293),
    [anon_sym_extractelement] = ACTIONS(293),
    [anon_sym_insertelement] = ACTIONS(293),
    [anon_sym_select] = ACTIONS(293),
    [anon_sym_shufflevector] = ACTIONS(293),
    [anon_sym_fneg] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_invoke] = ACTIONS(293),
    [anon_sym_cleanupret] = ACTIONS(293),
    [anon_sym_catchret] = ACTIONS(293),
    [anon_sym_catchswitch] = ACTIONS(293),
    [anon_sym_catchpad] = ACTIONS(293),
    [anon_sym_cleanuppad] = ACTIONS(293),
    [anon_sym_callbr] = ACTIONS(293),
    [anon_sym_icmp] = ACTIONS(293),
    [anon_sym_fcmp] = ACTIONS(293),
    [anon_sym_va_arg] = ACTIONS(293),
    [anon_sym_phi] = ACTIONS(293),
    [anon_sym_landingpad] = ACTIONS(293),
    [anon_sym_tail] = ACTIONS(293),
    [anon_sym_musttail] = ACTIONS(293),
    [anon_sym_notail] = ACTIONS(293),
    [anon_sym_call] = ACTIONS(293),
    [anon_sym_alloca] = ACTIONS(293),
    [anon_sym_load] = ACTIONS(293),
    [anon_sym_store] = ACTIONS(293),
    [anon_sym_cmpxchg] = ACTIONS(293),
    [anon_sym_atomicrmw] = ACTIONS(293),
    [anon_sym_fence] = ACTIONS(293),
    [anon_sym_getelementptr] = ACTIONS(293),
    [anon_sym_extractvalue] = ACTIONS(293),
    [anon_sym_insertvalue] = ACTIONS(293),
    [anon_sym_true] = ACTIONS(293),
    [anon_sym_false] = ACTIONS(293),
    [anon_sym_null] = ACTIONS(293),
    [anon_sym_none] = ACTIONS(293),
    [anon_sym_undef] = ACTIONS(293),
    [anon_sym_poison] = ACTIONS(293),
    [anon_sym_zeroinitializer] = ACTIONS(293),
    [anon_sym_catch] = ACTIONS(293),
    [anon_sym_filter] = ACTIONS(293),
    [anon_sym_blockaddress] = ACTIONS(293),
    [anon_sym_mul] = ACTIONS(293),
    [anon_sym_urem] = ACTIONS(293),
    [anon_sym_srem] = ACTIONS(293),
    [anon_sym_shl] = ACTIONS(293),
    [anon_sym_udiv] = ACTIONS(293),
    [anon_sym_sdiv] = ACTIONS(293),
    [anon_sym_lshr] = ACTIONS(293),
    [anon_sym_ashr] = ACTIONS(293),
    [anon_sym_fmul] = ACTIONS(293),
    [anon_sym_fdiv] = ACTIONS(293),
    [anon_sym_frem] = ACTIONS(293),
    [anon_sym_xchg] = ACTIONS(293),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(293),
    [anon_sym_and] = ACTIONS(293),
    [anon_sym_nand] = ACTIONS(293),
    [anon_sym_or] = ACTIONS(293),
    [anon_sym_xor] = ACTIONS(293),
    [anon_sym_max] = ACTIONS(293),
    [anon_sym_min] = ACTIONS(293),
    [anon_sym_umax] = ACTIONS(293),
    [anon_sym_umin] = ACTIONS(293),
    [anon_sym_fadd] = ACTIONS(293),
    [anon_sym_fsub] = ACTIONS(293),
    [anon_sym_bitcast] = ACTIONS(293),
    [anon_sym_trunc] = ACTIONS(293),
    [anon_sym_zext] = ACTIONS(293),
    [anon_sym_sext] = ACTIONS(293),
    [anon_sym_fptrunc] = ACTIONS(293),
    [anon_sym_fpext] = ACTIONS(293),
    [anon_sym_addrspacecast] = ACTIONS(293),
    [anon_sym_uitofp] = ACTIONS(293),
    [anon_sym_sitofp] = ACTIONS(293),
    [anon_sym_fptoui] = ACTIONS(293),
    [anon_sym_fptosi] = ACTIONS(293),
    [anon_sym_inttoptr] = ACTIONS(293),
    [anon_sym_ptrtoint] = ACTIONS(293),
    [anon_sym_unordered] = ACTIONS(293),
    [anon_sym_monotonic] = ACTIONS(293),
    [anon_sym_acquire] = ACTIONS(293),
    [anon_sym_release] = ACTIONS(293),
    [anon_sym_acq_rel] = ACTIONS(293),
    [anon_sym_seq_cst] = ACTIONS(293),
    [anon_sym_syncscope] = ACTIONS(293),
    [anon_sym_uselistorder] = ACTIONS(293),
  },
  [279] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_catch] = ACTIONS(271),
    [anon_sym_filter] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_unordered] = ACTIONS(271),
    [anon_sym_monotonic] = ACTIONS(271),
    [anon_sym_acquire] = ACTIONS(271),
    [anon_sym_release] = ACTIONS(271),
    [anon_sym_acq_rel] = ACTIONS(271),
    [anon_sym_seq_cst] = ACTIONS(271),
    [anon_sym_syncscope] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [280] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [sym_label] = ACTIONS(365),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_unreachable] = ACTIONS(367),
    [anon_sym_ret] = ACTIONS(367),
    [anon_sym_br] = ACTIONS(367),
    [anon_sym_resume] = ACTIONS(367),
    [anon_sym_freeze] = ACTIONS(367),
    [anon_sym_indirectbr] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_switch] = ACTIONS(367),
    [anon_sym_invoke] = ACTIONS(367),
    [anon_sym_cleanupret] = ACTIONS(367),
    [anon_sym_catchret] = ACTIONS(367),
    [anon_sym_catchswitch] = ACTIONS(367),
    [anon_sym_catchpad] = ACTIONS(367),
    [anon_sym_cleanuppad] = ACTIONS(367),
    [anon_sym_callbr] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_va_arg] = ACTIONS(367),
    [anon_sym_phi] = ACTIONS(367),
    [anon_sym_landingpad] = ACTIONS(367),
    [anon_sym_tail] = ACTIONS(367),
    [anon_sym_musttail] = ACTIONS(367),
    [anon_sym_notail] = ACTIONS(367),
    [anon_sym_call] = ACTIONS(367),
    [anon_sym_alloca] = ACTIONS(367),
    [anon_sym_load] = ACTIONS(367),
    [anon_sym_store] = ACTIONS(367),
    [anon_sym_cmpxchg] = ACTIONS(367),
    [anon_sym_atomicrmw] = ACTIONS(367),
    [anon_sym_fence] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_catch] = ACTIONS(367),
    [anon_sym_filter] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
    [anon_sym_unordered] = ACTIONS(367),
    [anon_sym_monotonic] = ACTIONS(367),
    [anon_sym_acquire] = ACTIONS(367),
    [anon_sym_release] = ACTIONS(367),
    [anon_sym_acq_rel] = ACTIONS(367),
    [anon_sym_seq_cst] = ACTIONS(367),
    [anon_sym_syncscope] = ACTIONS(367),
    [anon_sym_uselistorder] = ACTIONS(367),
  },
  [281] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [sym_label] = ACTIONS(299),
    [sym_string] = ACTIONS(301),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(301),
    [sym_float] = ACTIONS(301),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(301),
    [anon_sym_private] = ACTIONS(301),
    [anon_sym_internal] = ACTIONS(301),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(301),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(301),
    [anon_sym_available_externally] = ACTIONS(301),
    [anon_sym_appending] = ACTIONS(301),
    [anon_sym_common] = ACTIONS(301),
    [anon_sym_extern_weak] = ACTIONS(301),
    [anon_sym_external] = ACTIONS(301),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(301),
    [anon_sym_dso_preemptable] = ACTIONS(301),
    [anon_sym_default] = ACTIONS(301),
    [anon_sym_hidden] = ACTIONS(301),
    [anon_sym_protected] = ACTIONS(301),
    [anon_sym_dllimport] = ACTIONS(301),
    [anon_sym_dllexport] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_unreachable] = ACTIONS(301),
    [anon_sym_ret] = ACTIONS(301),
    [anon_sym_br] = ACTIONS(301),
    [anon_sym_resume] = ACTIONS(301),
    [anon_sym_freeze] = ACTIONS(301),
    [anon_sym_indirectbr] = ACTIONS(301),
    [anon_sym_extractelement] = ACTIONS(301),
    [anon_sym_insertelement] = ACTIONS(301),
    [anon_sym_select] = ACTIONS(301),
    [anon_sym_shufflevector] = ACTIONS(301),
    [anon_sym_fneg] = ACTIONS(301),
    [anon_sym_switch] = ACTIONS(301),
    [anon_sym_invoke] = ACTIONS(301),
    [anon_sym_cleanupret] = ACTIONS(301),
    [anon_sym_catchret] = ACTIONS(301),
    [anon_sym_catchswitch] = ACTIONS(301),
    [anon_sym_catchpad] = ACTIONS(301),
    [anon_sym_cleanuppad] = ACTIONS(301),
    [anon_sym_callbr] = ACTIONS(301),
    [anon_sym_icmp] = ACTIONS(301),
    [anon_sym_fcmp] = ACTIONS(301),
    [anon_sym_va_arg] = ACTIONS(301),
    [anon_sym_phi] = ACTIONS(301),
    [anon_sym_landingpad] = ACTIONS(301),
    [anon_sym_tail] = ACTIONS(301),
    [anon_sym_musttail] = ACTIONS(301),
    [anon_sym_notail] = ACTIONS(301),
    [anon_sym_call] = ACTIONS(301),
    [anon_sym_alloca] = ACTIONS(301),
    [anon_sym_load] = ACTIONS(301),
    [anon_sym_store] = ACTIONS(301),
    [anon_sym_cmpxchg] = ACTIONS(301),
    [anon_sym_atomicrmw] = ACTIONS(301),
    [anon_sym_fence] = ACTIONS(301),
    [anon_sym_getelementptr] = ACTIONS(301),
    [anon_sym_extractvalue] = ACTIONS(301),
    [anon_sym_insertvalue] = ACTIONS(301),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_none] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(301),
    [anon_sym_poison] = ACTIONS(301),
    [anon_sym_zeroinitializer] = ACTIONS(301),
    [anon_sym_catch] = ACTIONS(301),
    [anon_sym_filter] = ACTIONS(301),
    [anon_sym_blockaddress] = ACTIONS(301),
    [anon_sym_mul] = ACTIONS(301),
    [anon_sym_urem] = ACTIONS(301),
    [anon_sym_srem] = ACTIONS(301),
    [anon_sym_shl] = ACTIONS(301),
    [anon_sym_udiv] = ACTIONS(301),
    [anon_sym_sdiv] = ACTIONS(301),
    [anon_sym_lshr] = ACTIONS(301),
    [anon_sym_ashr] = ACTIONS(301),
    [anon_sym_fmul] = ACTIONS(301),
    [anon_sym_fdiv] = ACTIONS(301),
    [anon_sym_frem] = ACTIONS(301),
    [anon_sym_xchg] = ACTIONS(301),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(301),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_nand] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_xor] = ACTIONS(301),
    [anon_sym_max] = ACTIONS(301),
    [anon_sym_min] = ACTIONS(301),
    [anon_sym_umax] = ACTIONS(301),
    [anon_sym_umin] = ACTIONS(301),
    [anon_sym_fadd] = ACTIONS(301),
    [anon_sym_fsub] = ACTIONS(301),
    [anon_sym_bitcast] = ACTIONS(301),
    [anon_sym_trunc] = ACTIONS(301),
    [anon_sym_zext] = ACTIONS(301),
    [anon_sym_sext] = ACTIONS(301),
    [anon_sym_fptrunc] = ACTIONS(301),
    [anon_sym_fpext] = ACTIONS(301),
    [anon_sym_addrspacecast] = ACTIONS(301),
    [anon_sym_uitofp] = ACTIONS(301),
    [anon_sym_sitofp] = ACTIONS(301),
    [anon_sym_fptoui] = ACTIONS(301),
    [anon_sym_fptosi] = ACTIONS(301),
    [anon_sym_inttoptr] = ACTIONS(301),
    [anon_sym_ptrtoint] = ACTIONS(301),
    [anon_sym_unordered] = ACTIONS(301),
    [anon_sym_monotonic] = ACTIONS(301),
    [anon_sym_acquire] = ACTIONS(301),
    [anon_sym_release] = ACTIONS(301),
    [anon_sym_acq_rel] = ACTIONS(301),
    [anon_sym_seq_cst] = ACTIONS(301),
    [anon_sym_syncscope] = ACTIONS(301),
    [anon_sym_uselistorder] = ACTIONS(301),
  },
  [282] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_catch] = ACTIONS(252),
    [anon_sym_filter] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_unordered] = ACTIONS(252),
    [anon_sym_monotonic] = ACTIONS(252),
    [anon_sym_acquire] = ACTIONS(252),
    [anon_sym_release] = ACTIONS(252),
    [anon_sym_acq_rel] = ACTIONS(252),
    [anon_sym_seq_cst] = ACTIONS(252),
    [anon_sym_syncscope] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(987),
    [sym_comdat_ref] = ACTIONS(987),
    [sym_global_var] = ACTIONS(987),
    [sym_local_var] = ACTIONS(987),
    [aux_sym_metadata_ref_token1] = ACTIONS(987),
    [sym_summary_ref] = ACTIONS(987),
    [sym_string] = ACTIONS(987),
    [anon_sym_target] = ACTIONS(987),
    [anon_sym_source_filename] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(987),
    [anon_sym_define] = ACTIONS(987),
    [anon_sym_void] = ACTIONS(987),
    [anon_sym_half] = ACTIONS(987),
    [anon_sym_bfloat] = ACTIONS(987),
    [anon_sym_float] = ACTIONS(987),
    [anon_sym_double] = ACTIONS(987),
    [anon_sym_x86_fp80] = ACTIONS(987),
    [anon_sym_fp128] = ACTIONS(987),
    [anon_sym_ppc_fp128] = ACTIONS(987),
    [anon_sym_label] = ACTIONS(987),
    [anon_sym_metadata] = ACTIONS(987),
    [anon_sym_x86_mmx] = ACTIONS(987),
    [anon_sym_x86_amx] = ACTIONS(987),
    [anon_sym_token] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_ptr] = ACTIONS(987),
    [aux_sym_type_keyword_token1] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_LT_LBRACE] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_addrspace] = ACTIONS(987),
    [anon_sym_align] = ACTIONS(989),
    [anon_sym_section] = ACTIONS(987),
    [anon_sym_partition] = ACTIONS(987),
    [anon_sym_comdat] = ACTIONS(987),
    [anon_sym_gc] = ACTIONS(987),
    [anon_sym_prefix] = ACTIONS(987),
    [anon_sym_prologue] = ACTIONS(987),
    [anon_sym_personality] = ACTIONS(987),
    [anon_sym_alignstack] = ACTIONS(987),
    [anon_sym_allocsize] = ACTIONS(987),
    [anon_sym_alwaysinline] = ACTIONS(987),
    [anon_sym_builtin] = ACTIONS(987),
    [anon_sym_cold] = ACTIONS(987),
    [anon_sym_convergent] = ACTIONS(987),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(987),
    [anon_sym_hot] = ACTIONS(987),
    [anon_sym_inaccessiblememonly] = ACTIONS(987),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(987),
    [anon_sym_inlinehint] = ACTIONS(987),
    [anon_sym_jumptable] = ACTIONS(987),
    [anon_sym_minsize] = ACTIONS(987),
    [anon_sym_naked] = ACTIONS(987),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(987),
    [anon_sym_nobuiltin] = ACTIONS(987),
    [anon_sym_noduplicate] = ACTIONS(987),
    [anon_sym_nofree] = ACTIONS(987),
    [anon_sym_noimplicitfloat] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_nomerge] = ACTIONS(987),
    [anon_sym_nonlazybind] = ACTIONS(987),
    [anon_sym_noprofile] = ACTIONS(987),
    [anon_sym_noredzone] = ACTIONS(987),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(987),
    [anon_sym_noreturn] = ACTIONS(987),
    [anon_sym_norecurse] = ACTIONS(987),
    [anon_sym_willreturn] = ACTIONS(987),
    [anon_sym_nosync] = ACTIONS(987),
    [anon_sym_nounwind] = ACTIONS(987),
    [anon_sym_nosanitize_coverage] = ACTIONS(987),
    [anon_sym_null_pointer_is_valid] = ACTIONS(987),
    [anon_sym_optforfuzzing] = ACTIONS(987),
    [anon_sym_optnone] = ACTIONS(987),
    [anon_sym_optsize] = ACTIONS(987),
    [anon_sym_readnone] = ACTIONS(987),
    [anon_sym_readonly] = ACTIONS(987),
    [anon_sym_writeonly] = ACTIONS(987),
    [anon_sym_argmemonly] = ACTIONS(987),
    [anon_sym_returns_twice] = ACTIONS(987),
    [anon_sym_safestack] = ACTIONS(987),
    [anon_sym_sanitize_address] = ACTIONS(987),
    [anon_sym_sanitize_memory] = ACTIONS(987),
    [anon_sym_sanitize_thread] = ACTIONS(987),
    [anon_sym_sanitize_hwaddress] = ACTIONS(987),
    [anon_sym_sanitize_memtag] = ACTIONS(987),
    [anon_sym_speculative_load_hardening] = ACTIONS(987),
    [anon_sym_speculatable] = ACTIONS(987),
    [anon_sym_ssp] = ACTIONS(989),
    [anon_sym_sspstrong] = ACTIONS(987),
    [anon_sym_sspreq] = ACTIONS(987),
    [anon_sym_strictfp] = ACTIONS(987),
    [anon_sym_uwtable] = ACTIONS(987),
    [anon_sym_nocf_check] = ACTIONS(987),
    [anon_sym_shadowcallstack] = ACTIONS(987),
    [anon_sym_mustprogress] = ACTIONS(987),
    [anon_sym_vscale_range] = ACTIONS(987),
    [anon_sym_preallocated] = ACTIONS(987),
    [anon_sym_zeroext] = ACTIONS(987),
    [anon_sym_signext] = ACTIONS(987),
    [anon_sym_inreg] = ACTIONS(987),
    [anon_sym_byval] = ACTIONS(987),
    [anon_sym_byref] = ACTIONS(987),
    [anon_sym_inalloca] = ACTIONS(987),
    [anon_sym_sret] = ACTIONS(987),
    [anon_sym_elementtype] = ACTIONS(987),
    [anon_sym_noalias] = ACTIONS(987),
    [anon_sym_nocapture] = ACTIONS(987),
    [anon_sym_nest] = ACTIONS(987),
    [anon_sym_returned] = ACTIONS(987),
    [anon_sym_nonnull] = ACTIONS(987),
    [anon_sym_dereferenceable] = ACTIONS(989),
    [anon_sym_dereferenceable_or_null] = ACTIONS(987),
    [anon_sym_swiftself] = ACTIONS(987),
    [anon_sym_swiftasync] = ACTIONS(987),
    [anon_sym_swifterror] = ACTIONS(987),
    [anon_sym_immarg] = ACTIONS(987),
    [anon_sym_noundef] = ACTIONS(987),
    [anon_sym_uselistorder] = ACTIONS(989),
    [anon_sym_uselistorder_bb] = ACTIONS(987),
    [anon_sym_module] = ACTIONS(987),
    [anon_sym_externally_initialized] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(987),
    [anon_sym_constant] = ACTIONS(987),
    [anon_sym_alias] = ACTIONS(987),
    [anon_sym_ifunc] = ACTIONS(987),
    [anon_sym_attributes] = ACTIONS(987),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(497),
    [sym_comdat_ref] = ACTIONS(497),
    [sym_global_var] = ACTIONS(497),
    [sym_local_var] = ACTIONS(497),
    [aux_sym_metadata_ref_token1] = ACTIONS(497),
    [sym_summary_ref] = ACTIONS(497),
    [sym_string] = ACTIONS(497),
    [anon_sym_target] = ACTIONS(497),
    [anon_sym_source_filename] = ACTIONS(497),
    [anon_sym_declare] = ACTIONS(497),
    [anon_sym_define] = ACTIONS(497),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_half] = ACTIONS(497),
    [anon_sym_bfloat] = ACTIONS(497),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_double] = ACTIONS(497),
    [anon_sym_x86_fp80] = ACTIONS(497),
    [anon_sym_fp128] = ACTIONS(497),
    [anon_sym_ppc_fp128] = ACTIONS(497),
    [anon_sym_label] = ACTIONS(497),
    [anon_sym_metadata] = ACTIONS(497),
    [anon_sym_x86_mmx] = ACTIONS(497),
    [anon_sym_x86_amx] = ACTIONS(497),
    [anon_sym_token] = ACTIONS(497),
    [anon_sym_opaque] = ACTIONS(497),
    [anon_sym_ptr] = ACTIONS(497),
    [aux_sym_type_keyword_token1] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LT_LBRACE] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_align] = ACTIONS(499),
    [anon_sym_section] = ACTIONS(497),
    [anon_sym_partition] = ACTIONS(497),
    [anon_sym_comdat] = ACTIONS(497),
    [anon_sym_gc] = ACTIONS(497),
    [anon_sym_prefix] = ACTIONS(497),
    [anon_sym_prologue] = ACTIONS(497),
    [anon_sym_personality] = ACTIONS(497),
    [anon_sym_alignstack] = ACTIONS(497),
    [anon_sym_allocsize] = ACTIONS(497),
    [anon_sym_alwaysinline] = ACTIONS(497),
    [anon_sym_builtin] = ACTIONS(497),
    [anon_sym_cold] = ACTIONS(497),
    [anon_sym_convergent] = ACTIONS(497),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(497),
    [anon_sym_hot] = ACTIONS(497),
    [anon_sym_inaccessiblememonly] = ACTIONS(497),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(497),
    [anon_sym_inlinehint] = ACTIONS(497),
    [anon_sym_jumptable] = ACTIONS(497),
    [anon_sym_minsize] = ACTIONS(497),
    [anon_sym_naked] = ACTIONS(497),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(497),
    [anon_sym_nobuiltin] = ACTIONS(497),
    [anon_sym_noduplicate] = ACTIONS(497),
    [anon_sym_nofree] = ACTIONS(497),
    [anon_sym_noimplicitfloat] = ACTIONS(497),
    [anon_sym_noinline] = ACTIONS(497),
    [anon_sym_nomerge] = ACTIONS(497),
    [anon_sym_nonlazybind] = ACTIONS(497),
    [anon_sym_noprofile] = ACTIONS(497),
    [anon_sym_noredzone] = ACTIONS(497),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(497),
    [anon_sym_noreturn] = ACTIONS(497),
    [anon_sym_norecurse] = ACTIONS(497),
    [anon_sym_willreturn] = ACTIONS(497),
    [anon_sym_nosync] = ACTIONS(497),
    [anon_sym_nounwind] = ACTIONS(497),
    [anon_sym_nosanitize_coverage] = ACTIONS(497),
    [anon_sym_null_pointer_is_valid] = ACTIONS(497),
    [anon_sym_optforfuzzing] = ACTIONS(497),
    [anon_sym_optnone] = ACTIONS(497),
    [anon_sym_optsize] = ACTIONS(497),
    [anon_sym_readnone] = ACTIONS(497),
    [anon_sym_readonly] = ACTIONS(497),
    [anon_sym_writeonly] = ACTIONS(497),
    [anon_sym_argmemonly] = ACTIONS(497),
    [anon_sym_returns_twice] = ACTIONS(497),
    [anon_sym_safestack] = ACTIONS(497),
    [anon_sym_sanitize_address] = ACTIONS(497),
    [anon_sym_sanitize_memory] = ACTIONS(497),
    [anon_sym_sanitize_thread] = ACTIONS(497),
    [anon_sym_sanitize_hwaddress] = ACTIONS(497),
    [anon_sym_sanitize_memtag] = ACTIONS(497),
    [anon_sym_speculative_load_hardening] = ACTIONS(497),
    [anon_sym_speculatable] = ACTIONS(497),
    [anon_sym_ssp] = ACTIONS(499),
    [anon_sym_sspstrong] = ACTIONS(497),
    [anon_sym_sspreq] = ACTIONS(497),
    [anon_sym_strictfp] = ACTIONS(497),
    [anon_sym_uwtable] = ACTIONS(497),
    [anon_sym_nocf_check] = ACTIONS(497),
    [anon_sym_shadowcallstack] = ACTIONS(497),
    [anon_sym_mustprogress] = ACTIONS(497),
    [anon_sym_vscale_range] = ACTIONS(497),
    [anon_sym_preallocated] = ACTIONS(497),
    [anon_sym_zeroext] = ACTIONS(497),
    [anon_sym_signext] = ACTIONS(497),
    [anon_sym_inreg] = ACTIONS(497),
    [anon_sym_byval] = ACTIONS(497),
    [anon_sym_byref] = ACTIONS(497),
    [anon_sym_inalloca] = ACTIONS(497),
    [anon_sym_sret] = ACTIONS(497),
    [anon_sym_elementtype] = ACTIONS(497),
    [anon_sym_noalias] = ACTIONS(497),
    [anon_sym_nocapture] = ACTIONS(497),
    [anon_sym_nest] = ACTIONS(497),
    [anon_sym_returned] = ACTIONS(497),
    [anon_sym_nonnull] = ACTIONS(497),
    [anon_sym_dereferenceable] = ACTIONS(499),
    [anon_sym_dereferenceable_or_null] = ACTIONS(497),
    [anon_sym_swiftself] = ACTIONS(497),
    [anon_sym_swiftasync] = ACTIONS(497),
    [anon_sym_swifterror] = ACTIONS(497),
    [anon_sym_immarg] = ACTIONS(497),
    [anon_sym_noundef] = ACTIONS(497),
    [anon_sym_to] = ACTIONS(499),
    [anon_sym_uselistorder] = ACTIONS(499),
    [anon_sym_uselistorder_bb] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_LPAREN2] = ACTIONS(497),
    [anon_sym_attributes] = ACTIONS(497),
  },
  [285] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(585),
    [sym_comdat_ref] = ACTIONS(585),
    [sym_global_var] = ACTIONS(585),
    [sym_local_var] = ACTIONS(585),
    [aux_sym_metadata_ref_token1] = ACTIONS(585),
    [sym_summary_ref] = ACTIONS(585),
    [sym_string] = ACTIONS(585),
    [anon_sym_target] = ACTIONS(585),
    [anon_sym_source_filename] = ACTIONS(585),
    [anon_sym_declare] = ACTIONS(585),
    [anon_sym_define] = ACTIONS(585),
    [anon_sym_void] = ACTIONS(585),
    [anon_sym_half] = ACTIONS(585),
    [anon_sym_bfloat] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(585),
    [anon_sym_double] = ACTIONS(585),
    [anon_sym_x86_fp80] = ACTIONS(585),
    [anon_sym_fp128] = ACTIONS(585),
    [anon_sym_ppc_fp128] = ACTIONS(585),
    [anon_sym_label] = ACTIONS(585),
    [anon_sym_metadata] = ACTIONS(585),
    [anon_sym_x86_mmx] = ACTIONS(585),
    [anon_sym_x86_amx] = ACTIONS(585),
    [anon_sym_token] = ACTIONS(585),
    [anon_sym_opaque] = ACTIONS(585),
    [anon_sym_ptr] = ACTIONS(585),
    [aux_sym_type_keyword_token1] = ACTIONS(585),
    [anon_sym_LBRACE] = ACTIONS(585),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LT_LBRACE] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_align] = ACTIONS(587),
    [anon_sym_section] = ACTIONS(585),
    [anon_sym_partition] = ACTIONS(585),
    [anon_sym_comdat] = ACTIONS(585),
    [anon_sym_gc] = ACTIONS(585),
    [anon_sym_prefix] = ACTIONS(585),
    [anon_sym_prologue] = ACTIONS(585),
    [anon_sym_personality] = ACTIONS(585),
    [anon_sym_alignstack] = ACTIONS(585),
    [anon_sym_allocsize] = ACTIONS(585),
    [anon_sym_alwaysinline] = ACTIONS(585),
    [anon_sym_builtin] = ACTIONS(585),
    [anon_sym_cold] = ACTIONS(585),
    [anon_sym_convergent] = ACTIONS(585),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(585),
    [anon_sym_hot] = ACTIONS(585),
    [anon_sym_inaccessiblememonly] = ACTIONS(585),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(585),
    [anon_sym_inlinehint] = ACTIONS(585),
    [anon_sym_jumptable] = ACTIONS(585),
    [anon_sym_minsize] = ACTIONS(585),
    [anon_sym_naked] = ACTIONS(585),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(585),
    [anon_sym_nobuiltin] = ACTIONS(585),
    [anon_sym_noduplicate] = ACTIONS(585),
    [anon_sym_nofree] = ACTIONS(585),
    [anon_sym_noimplicitfloat] = ACTIONS(585),
    [anon_sym_noinline] = ACTIONS(585),
    [anon_sym_nomerge] = ACTIONS(585),
    [anon_sym_nonlazybind] = ACTIONS(585),
    [anon_sym_noprofile] = ACTIONS(585),
    [anon_sym_noredzone] = ACTIONS(585),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(585),
    [anon_sym_noreturn] = ACTIONS(585),
    [anon_sym_norecurse] = ACTIONS(585),
    [anon_sym_willreturn] = ACTIONS(585),
    [anon_sym_nosync] = ACTIONS(585),
    [anon_sym_nounwind] = ACTIONS(585),
    [anon_sym_nosanitize_coverage] = ACTIONS(585),
    [anon_sym_null_pointer_is_valid] = ACTIONS(585),
    [anon_sym_optforfuzzing] = ACTIONS(585),
    [anon_sym_optnone] = ACTIONS(585),
    [anon_sym_optsize] = ACTIONS(585),
    [anon_sym_readnone] = ACTIONS(585),
    [anon_sym_readonly] = ACTIONS(585),
    [anon_sym_writeonly] = ACTIONS(585),
    [anon_sym_argmemonly] = ACTIONS(585),
    [anon_sym_returns_twice] = ACTIONS(585),
    [anon_sym_safestack] = ACTIONS(585),
    [anon_sym_sanitize_address] = ACTIONS(585),
    [anon_sym_sanitize_memory] = ACTIONS(585),
    [anon_sym_sanitize_thread] = ACTIONS(585),
    [anon_sym_sanitize_hwaddress] = ACTIONS(585),
    [anon_sym_sanitize_memtag] = ACTIONS(585),
    [anon_sym_speculative_load_hardening] = ACTIONS(585),
    [anon_sym_speculatable] = ACTIONS(585),
    [anon_sym_ssp] = ACTIONS(587),
    [anon_sym_sspstrong] = ACTIONS(585),
    [anon_sym_sspreq] = ACTIONS(585),
    [anon_sym_strictfp] = ACTIONS(585),
    [anon_sym_uwtable] = ACTIONS(585),
    [anon_sym_nocf_check] = ACTIONS(585),
    [anon_sym_shadowcallstack] = ACTIONS(585),
    [anon_sym_mustprogress] = ACTIONS(585),
    [anon_sym_vscale_range] = ACTIONS(585),
    [anon_sym_preallocated] = ACTIONS(585),
    [anon_sym_zeroext] = ACTIONS(585),
    [anon_sym_signext] = ACTIONS(585),
    [anon_sym_inreg] = ACTIONS(585),
    [anon_sym_byval] = ACTIONS(585),
    [anon_sym_byref] = ACTIONS(585),
    [anon_sym_inalloca] = ACTIONS(585),
    [anon_sym_sret] = ACTIONS(585),
    [anon_sym_elementtype] = ACTIONS(585),
    [anon_sym_noalias] = ACTIONS(585),
    [anon_sym_nocapture] = ACTIONS(585),
    [anon_sym_nest] = ACTIONS(585),
    [anon_sym_returned] = ACTIONS(585),
    [anon_sym_nonnull] = ACTIONS(585),
    [anon_sym_dereferenceable] = ACTIONS(587),
    [anon_sym_dereferenceable_or_null] = ACTIONS(585),
    [anon_sym_swiftself] = ACTIONS(585),
    [anon_sym_swiftasync] = ACTIONS(585),
    [anon_sym_swifterror] = ACTIONS(585),
    [anon_sym_immarg] = ACTIONS(585),
    [anon_sym_noundef] = ACTIONS(585),
    [anon_sym_to] = ACTIONS(587),
    [anon_sym_uselistorder] = ACTIONS(587),
    [anon_sym_uselistorder_bb] = ACTIONS(585),
    [anon_sym_module] = ACTIONS(585),
    [anon_sym_LPAREN2] = ACTIONS(993),
    [anon_sym_attributes] = ACTIONS(585),
  },
  [287] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(265),
    [anon_sym_filter] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_unordered] = ACTIONS(265),
    [anon_sym_monotonic] = ACTIONS(265),
    [anon_sym_acquire] = ACTIONS(265),
    [anon_sym_release] = ACTIONS(265),
    [anon_sym_acq_rel] = ACTIONS(265),
    [anon_sym_seq_cst] = ACTIONS(265),
    [anon_sym_syncscope] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [288] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [sym_label] = ACTIONS(393),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_unreachable] = ACTIONS(395),
    [anon_sym_ret] = ACTIONS(395),
    [anon_sym_br] = ACTIONS(395),
    [anon_sym_resume] = ACTIONS(395),
    [anon_sym_freeze] = ACTIONS(395),
    [anon_sym_indirectbr] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_switch] = ACTIONS(395),
    [anon_sym_invoke] = ACTIONS(395),
    [anon_sym_cleanupret] = ACTIONS(395),
    [anon_sym_catchret] = ACTIONS(395),
    [anon_sym_catchswitch] = ACTIONS(395),
    [anon_sym_catchpad] = ACTIONS(395),
    [anon_sym_cleanuppad] = ACTIONS(395),
    [anon_sym_callbr] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_va_arg] = ACTIONS(395),
    [anon_sym_phi] = ACTIONS(395),
    [anon_sym_landingpad] = ACTIONS(395),
    [anon_sym_tail] = ACTIONS(395),
    [anon_sym_musttail] = ACTIONS(395),
    [anon_sym_notail] = ACTIONS(395),
    [anon_sym_call] = ACTIONS(395),
    [anon_sym_alloca] = ACTIONS(395),
    [anon_sym_load] = ACTIONS(395),
    [anon_sym_store] = ACTIONS(395),
    [anon_sym_cmpxchg] = ACTIONS(395),
    [anon_sym_atomicrmw] = ACTIONS(395),
    [anon_sym_fence] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_catch] = ACTIONS(395),
    [anon_sym_filter] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
    [anon_sym_unordered] = ACTIONS(395),
    [anon_sym_monotonic] = ACTIONS(395),
    [anon_sym_acquire] = ACTIONS(395),
    [anon_sym_release] = ACTIONS(395),
    [anon_sym_acq_rel] = ACTIONS(395),
    [anon_sym_seq_cst] = ACTIONS(395),
    [anon_sym_syncscope] = ACTIONS(395),
    [anon_sym_uselistorder] = ACTIONS(395),
  },
  [289] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [sym_label] = ACTIONS(397),
    [sym_string] = ACTIONS(399),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(399),
    [sym_float] = ACTIONS(399),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(399),
    [anon_sym_private] = ACTIONS(399),
    [anon_sym_internal] = ACTIONS(399),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(399),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(399),
    [anon_sym_available_externally] = ACTIONS(399),
    [anon_sym_appending] = ACTIONS(399),
    [anon_sym_common] = ACTIONS(399),
    [anon_sym_extern_weak] = ACTIONS(399),
    [anon_sym_external] = ACTIONS(399),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(399),
    [anon_sym_dso_preemptable] = ACTIONS(399),
    [anon_sym_default] = ACTIONS(399),
    [anon_sym_hidden] = ACTIONS(399),
    [anon_sym_protected] = ACTIONS(399),
    [anon_sym_dllimport] = ACTIONS(399),
    [anon_sym_dllexport] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_unreachable] = ACTIONS(399),
    [anon_sym_ret] = ACTIONS(399),
    [anon_sym_br] = ACTIONS(399),
    [anon_sym_resume] = ACTIONS(399),
    [anon_sym_freeze] = ACTIONS(399),
    [anon_sym_indirectbr] = ACTIONS(399),
    [anon_sym_extractelement] = ACTIONS(399),
    [anon_sym_insertelement] = ACTIONS(399),
    [anon_sym_select] = ACTIONS(399),
    [anon_sym_shufflevector] = ACTIONS(399),
    [anon_sym_fneg] = ACTIONS(399),
    [anon_sym_switch] = ACTIONS(399),
    [anon_sym_invoke] = ACTIONS(399),
    [anon_sym_cleanupret] = ACTIONS(399),
    [anon_sym_catchret] = ACTIONS(399),
    [anon_sym_catchswitch] = ACTIONS(399),
    [anon_sym_catchpad] = ACTIONS(399),
    [anon_sym_cleanuppad] = ACTIONS(399),
    [anon_sym_callbr] = ACTIONS(399),
    [anon_sym_icmp] = ACTIONS(399),
    [anon_sym_fcmp] = ACTIONS(399),
    [anon_sym_va_arg] = ACTIONS(399),
    [anon_sym_phi] = ACTIONS(399),
    [anon_sym_landingpad] = ACTIONS(399),
    [anon_sym_tail] = ACTIONS(399),
    [anon_sym_musttail] = ACTIONS(399),
    [anon_sym_notail] = ACTIONS(399),
    [anon_sym_call] = ACTIONS(399),
    [anon_sym_alloca] = ACTIONS(399),
    [anon_sym_load] = ACTIONS(399),
    [anon_sym_store] = ACTIONS(399),
    [anon_sym_cmpxchg] = ACTIONS(399),
    [anon_sym_atomicrmw] = ACTIONS(399),
    [anon_sym_fence] = ACTIONS(399),
    [anon_sym_getelementptr] = ACTIONS(399),
    [anon_sym_extractvalue] = ACTIONS(399),
    [anon_sym_insertvalue] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(399),
    [anon_sym_false] = ACTIONS(399),
    [anon_sym_null] = ACTIONS(399),
    [anon_sym_none] = ACTIONS(399),
    [anon_sym_undef] = ACTIONS(399),
    [anon_sym_poison] = ACTIONS(399),
    [anon_sym_zeroinitializer] = ACTIONS(399),
    [anon_sym_catch] = ACTIONS(399),
    [anon_sym_filter] = ACTIONS(399),
    [anon_sym_blockaddress] = ACTIONS(399),
    [anon_sym_mul] = ACTIONS(399),
    [anon_sym_urem] = ACTIONS(399),
    [anon_sym_srem] = ACTIONS(399),
    [anon_sym_shl] = ACTIONS(399),
    [anon_sym_udiv] = ACTIONS(399),
    [anon_sym_sdiv] = ACTIONS(399),
    [anon_sym_lshr] = ACTIONS(399),
    [anon_sym_ashr] = ACTIONS(399),
    [anon_sym_fmul] = ACTIONS(399),
    [anon_sym_fdiv] = ACTIONS(399),
    [anon_sym_frem] = ACTIONS(399),
    [anon_sym_xchg] = ACTIONS(399),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(399),
    [anon_sym_nand] = ACTIONS(399),
    [anon_sym_or] = ACTIONS(399),
    [anon_sym_xor] = ACTIONS(399),
    [anon_sym_max] = ACTIONS(399),
    [anon_sym_min] = ACTIONS(399),
    [anon_sym_umax] = ACTIONS(399),
    [anon_sym_umin] = ACTIONS(399),
    [anon_sym_fadd] = ACTIONS(399),
    [anon_sym_fsub] = ACTIONS(399),
    [anon_sym_bitcast] = ACTIONS(399),
    [anon_sym_trunc] = ACTIONS(399),
    [anon_sym_zext] = ACTIONS(399),
    [anon_sym_sext] = ACTIONS(399),
    [anon_sym_fptrunc] = ACTIONS(399),
    [anon_sym_fpext] = ACTIONS(399),
    [anon_sym_addrspacecast] = ACTIONS(399),
    [anon_sym_uitofp] = ACTIONS(399),
    [anon_sym_sitofp] = ACTIONS(399),
    [anon_sym_fptoui] = ACTIONS(399),
    [anon_sym_fptosi] = ACTIONS(399),
    [anon_sym_inttoptr] = ACTIONS(399),
    [anon_sym_ptrtoint] = ACTIONS(399),
    [anon_sym_unordered] = ACTIONS(399),
    [anon_sym_monotonic] = ACTIONS(399),
    [anon_sym_acquire] = ACTIONS(399),
    [anon_sym_release] = ACTIONS(399),
    [anon_sym_acq_rel] = ACTIONS(399),
    [anon_sym_seq_cst] = ACTIONS(399),
    [anon_sym_syncscope] = ACTIONS(399),
    [anon_sym_uselistorder] = ACTIONS(399),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(655),
    [sym_comdat_ref] = ACTIONS(655),
    [sym_global_var] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [aux_sym_metadata_ref_token1] = ACTIONS(655),
    [sym_summary_ref] = ACTIONS(655),
    [sym_string] = ACTIONS(655),
    [anon_sym_target] = ACTIONS(655),
    [anon_sym_source_filename] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_define] = ACTIONS(655),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_half] = ACTIONS(655),
    [anon_sym_bfloat] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(655),
    [anon_sym_double] = ACTIONS(655),
    [anon_sym_x86_fp80] = ACTIONS(655),
    [anon_sym_fp128] = ACTIONS(655),
    [anon_sym_ppc_fp128] = ACTIONS(655),
    [anon_sym_label] = ACTIONS(655),
    [anon_sym_metadata] = ACTIONS(655),
    [anon_sym_x86_mmx] = ACTIONS(655),
    [anon_sym_x86_amx] = ACTIONS(655),
    [anon_sym_token] = ACTIONS(655),
    [anon_sym_opaque] = ACTIONS(655),
    [anon_sym_ptr] = ACTIONS(655),
    [aux_sym_type_keyword_token1] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_section] = ACTIONS(655),
    [anon_sym_partition] = ACTIONS(655),
    [anon_sym_comdat] = ACTIONS(655),
    [anon_sym_gc] = ACTIONS(655),
    [anon_sym_prefix] = ACTIONS(655),
    [anon_sym_prologue] = ACTIONS(655),
    [anon_sym_personality] = ACTIONS(655),
    [anon_sym_alignstack] = ACTIONS(655),
    [anon_sym_allocsize] = ACTIONS(655),
    [anon_sym_alwaysinline] = ACTIONS(655),
    [anon_sym_builtin] = ACTIONS(655),
    [anon_sym_cold] = ACTIONS(655),
    [anon_sym_convergent] = ACTIONS(655),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(655),
    [anon_sym_hot] = ACTIONS(655),
    [anon_sym_inaccessiblememonly] = ACTIONS(655),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(655),
    [anon_sym_inlinehint] = ACTIONS(655),
    [anon_sym_jumptable] = ACTIONS(655),
    [anon_sym_minsize] = ACTIONS(655),
    [anon_sym_naked] = ACTIONS(655),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(655),
    [anon_sym_nobuiltin] = ACTIONS(655),
    [anon_sym_noduplicate] = ACTIONS(655),
    [anon_sym_nofree] = ACTIONS(655),
    [anon_sym_noimplicitfloat] = ACTIONS(655),
    [anon_sym_noinline] = ACTIONS(655),
    [anon_sym_nomerge] = ACTIONS(655),
    [anon_sym_nonlazybind] = ACTIONS(655),
    [anon_sym_noprofile] = ACTIONS(655),
    [anon_sym_noredzone] = ACTIONS(655),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(655),
    [anon_sym_noreturn] = ACTIONS(655),
    [anon_sym_norecurse] = ACTIONS(655),
    [anon_sym_willreturn] = ACTIONS(655),
    [anon_sym_nosync] = ACTIONS(655),
    [anon_sym_nounwind] = ACTIONS(655),
    [anon_sym_nosanitize_coverage] = ACTIONS(655),
    [anon_sym_null_pointer_is_valid] = ACTIONS(655),
    [anon_sym_optforfuzzing] = ACTIONS(655),
    [anon_sym_optnone] = ACTIONS(655),
    [anon_sym_optsize] = ACTIONS(655),
    [anon_sym_readnone] = ACTIONS(655),
    [anon_sym_readonly] = ACTIONS(655),
    [anon_sym_writeonly] = ACTIONS(655),
    [anon_sym_argmemonly] = ACTIONS(655),
    [anon_sym_returns_twice] = ACTIONS(655),
    [anon_sym_safestack] = ACTIONS(655),
    [anon_sym_sanitize_address] = ACTIONS(655),
    [anon_sym_sanitize_memory] = ACTIONS(655),
    [anon_sym_sanitize_thread] = ACTIONS(655),
    [anon_sym_sanitize_hwaddress] = ACTIONS(655),
    [anon_sym_sanitize_memtag] = ACTIONS(655),
    [anon_sym_speculative_load_hardening] = ACTIONS(655),
    [anon_sym_speculatable] = ACTIONS(655),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(655),
    [anon_sym_sspreq] = ACTIONS(655),
    [anon_sym_strictfp] = ACTIONS(655),
    [anon_sym_uwtable] = ACTIONS(655),
    [anon_sym_nocf_check] = ACTIONS(655),
    [anon_sym_shadowcallstack] = ACTIONS(655),
    [anon_sym_mustprogress] = ACTIONS(655),
    [anon_sym_vscale_range] = ACTIONS(655),
    [anon_sym_preallocated] = ACTIONS(655),
    [anon_sym_zeroext] = ACTIONS(655),
    [anon_sym_signext] = ACTIONS(655),
    [anon_sym_inreg] = ACTIONS(655),
    [anon_sym_byval] = ACTIONS(655),
    [anon_sym_byref] = ACTIONS(655),
    [anon_sym_inalloca] = ACTIONS(655),
    [anon_sym_sret] = ACTIONS(655),
    [anon_sym_elementtype] = ACTIONS(655),
    [anon_sym_noalias] = ACTIONS(655),
    [anon_sym_nocapture] = ACTIONS(655),
    [anon_sym_nest] = ACTIONS(655),
    [anon_sym_returned] = ACTIONS(655),
    [anon_sym_nonnull] = ACTIONS(655),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(655),
    [anon_sym_swiftself] = ACTIONS(655),
    [anon_sym_swiftasync] = ACTIONS(655),
    [anon_sym_swifterror] = ACTIONS(655),
    [anon_sym_immarg] = ACTIONS(655),
    [anon_sym_noundef] = ACTIONS(655),
    [anon_sym_to] = ACTIONS(657),
    [anon_sym_uselistorder] = ACTIONS(657),
    [anon_sym_uselistorder_bb] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_attributes] = ACTIONS(655),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(553),
    [sym_comdat_ref] = ACTIONS(553),
    [sym_global_var] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [aux_sym_metadata_ref_token1] = ACTIONS(553),
    [sym_summary_ref] = ACTIONS(553),
    [sym_string] = ACTIONS(553),
    [anon_sym_target] = ACTIONS(553),
    [anon_sym_source_filename] = ACTIONS(553),
    [anon_sym_declare] = ACTIONS(553),
    [anon_sym_define] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(553),
    [anon_sym_half] = ACTIONS(553),
    [anon_sym_bfloat] = ACTIONS(553),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_double] = ACTIONS(553),
    [anon_sym_x86_fp80] = ACTIONS(553),
    [anon_sym_fp128] = ACTIONS(553),
    [anon_sym_ppc_fp128] = ACTIONS(553),
    [anon_sym_label] = ACTIONS(553),
    [anon_sym_metadata] = ACTIONS(553),
    [anon_sym_x86_mmx] = ACTIONS(553),
    [anon_sym_x86_amx] = ACTIONS(553),
    [anon_sym_token] = ACTIONS(553),
    [anon_sym_opaque] = ACTIONS(553),
    [anon_sym_ptr] = ACTIONS(553),
    [aux_sym_type_keyword_token1] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LT_LBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_section] = ACTIONS(553),
    [anon_sym_partition] = ACTIONS(553),
    [anon_sym_comdat] = ACTIONS(553),
    [anon_sym_gc] = ACTIONS(553),
    [anon_sym_prefix] = ACTIONS(553),
    [anon_sym_prologue] = ACTIONS(553),
    [anon_sym_personality] = ACTIONS(553),
    [anon_sym_alignstack] = ACTIONS(553),
    [anon_sym_allocsize] = ACTIONS(553),
    [anon_sym_alwaysinline] = ACTIONS(553),
    [anon_sym_builtin] = ACTIONS(553),
    [anon_sym_cold] = ACTIONS(553),
    [anon_sym_convergent] = ACTIONS(553),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(553),
    [anon_sym_hot] = ACTIONS(553),
    [anon_sym_inaccessiblememonly] = ACTIONS(553),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(553),
    [anon_sym_inlinehint] = ACTIONS(553),
    [anon_sym_jumptable] = ACTIONS(553),
    [anon_sym_minsize] = ACTIONS(553),
    [anon_sym_naked] = ACTIONS(553),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(553),
    [anon_sym_nobuiltin] = ACTIONS(553),
    [anon_sym_noduplicate] = ACTIONS(553),
    [anon_sym_nofree] = ACTIONS(553),
    [anon_sym_noimplicitfloat] = ACTIONS(553),
    [anon_sym_noinline] = ACTIONS(553),
    [anon_sym_nomerge] = ACTIONS(553),
    [anon_sym_nonlazybind] = ACTIONS(553),
    [anon_sym_noprofile] = ACTIONS(553),
    [anon_sym_noredzone] = ACTIONS(553),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(553),
    [anon_sym_noreturn] = ACTIONS(553),
    [anon_sym_norecurse] = ACTIONS(553),
    [anon_sym_willreturn] = ACTIONS(553),
    [anon_sym_nosync] = ACTIONS(553),
    [anon_sym_nounwind] = ACTIONS(553),
    [anon_sym_nosanitize_coverage] = ACTIONS(553),
    [anon_sym_null_pointer_is_valid] = ACTIONS(553),
    [anon_sym_optforfuzzing] = ACTIONS(553),
    [anon_sym_optnone] = ACTIONS(553),
    [anon_sym_optsize] = ACTIONS(553),
    [anon_sym_readnone] = ACTIONS(553),
    [anon_sym_readonly] = ACTIONS(553),
    [anon_sym_writeonly] = ACTIONS(553),
    [anon_sym_argmemonly] = ACTIONS(553),
    [anon_sym_returns_twice] = ACTIONS(553),
    [anon_sym_safestack] = ACTIONS(553),
    [anon_sym_sanitize_address] = ACTIONS(553),
    [anon_sym_sanitize_memory] = ACTIONS(553),
    [anon_sym_sanitize_thread] = ACTIONS(553),
    [anon_sym_sanitize_hwaddress] = ACTIONS(553),
    [anon_sym_sanitize_memtag] = ACTIONS(553),
    [anon_sym_speculative_load_hardening] = ACTIONS(553),
    [anon_sym_speculatable] = ACTIONS(553),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(553),
    [anon_sym_sspreq] = ACTIONS(553),
    [anon_sym_strictfp] = ACTIONS(553),
    [anon_sym_uwtable] = ACTIONS(553),
    [anon_sym_nocf_check] = ACTIONS(553),
    [anon_sym_shadowcallstack] = ACTIONS(553),
    [anon_sym_mustprogress] = ACTIONS(553),
    [anon_sym_vscale_range] = ACTIONS(553),
    [anon_sym_preallocated] = ACTIONS(553),
    [anon_sym_zeroext] = ACTIONS(553),
    [anon_sym_signext] = ACTIONS(553),
    [anon_sym_inreg] = ACTIONS(553),
    [anon_sym_byval] = ACTIONS(553),
    [anon_sym_byref] = ACTIONS(553),
    [anon_sym_inalloca] = ACTIONS(553),
    [anon_sym_sret] = ACTIONS(553),
    [anon_sym_elementtype] = ACTIONS(553),
    [anon_sym_noalias] = ACTIONS(553),
    [anon_sym_nocapture] = ACTIONS(553),
    [anon_sym_nest] = ACTIONS(553),
    [anon_sym_returned] = ACTIONS(553),
    [anon_sym_nonnull] = ACTIONS(553),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(553),
    [anon_sym_swiftself] = ACTIONS(553),
    [anon_sym_swiftasync] = ACTIONS(553),
    [anon_sym_swifterror] = ACTIONS(553),
    [anon_sym_immarg] = ACTIONS(553),
    [anon_sym_noundef] = ACTIONS(553),
    [anon_sym_to] = ACTIONS(555),
    [anon_sym_uselistorder] = ACTIONS(555),
    [anon_sym_uselistorder_bb] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_attributes] = ACTIONS(553),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(647),
    [sym_comdat_ref] = ACTIONS(647),
    [sym_global_var] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [aux_sym_metadata_ref_token1] = ACTIONS(647),
    [sym_summary_ref] = ACTIONS(647),
    [sym_string] = ACTIONS(647),
    [anon_sym_target] = ACTIONS(647),
    [anon_sym_source_filename] = ACTIONS(647),
    [anon_sym_declare] = ACTIONS(647),
    [anon_sym_define] = ACTIONS(647),
    [anon_sym_void] = ACTIONS(647),
    [anon_sym_half] = ACTIONS(647),
    [anon_sym_bfloat] = ACTIONS(647),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_double] = ACTIONS(647),
    [anon_sym_x86_fp80] = ACTIONS(647),
    [anon_sym_fp128] = ACTIONS(647),
    [anon_sym_ppc_fp128] = ACTIONS(647),
    [anon_sym_label] = ACTIONS(647),
    [anon_sym_metadata] = ACTIONS(647),
    [anon_sym_x86_mmx] = ACTIONS(647),
    [anon_sym_x86_amx] = ACTIONS(647),
    [anon_sym_token] = ACTIONS(647),
    [anon_sym_opaque] = ACTIONS(647),
    [anon_sym_ptr] = ACTIONS(647),
    [aux_sym_type_keyword_token1] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LT_LBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_section] = ACTIONS(647),
    [anon_sym_partition] = ACTIONS(647),
    [anon_sym_comdat] = ACTIONS(647),
    [anon_sym_gc] = ACTIONS(647),
    [anon_sym_prefix] = ACTIONS(647),
    [anon_sym_prologue] = ACTIONS(647),
    [anon_sym_personality] = ACTIONS(647),
    [anon_sym_alignstack] = ACTIONS(647),
    [anon_sym_allocsize] = ACTIONS(647),
    [anon_sym_alwaysinline] = ACTIONS(647),
    [anon_sym_builtin] = ACTIONS(647),
    [anon_sym_cold] = ACTIONS(647),
    [anon_sym_convergent] = ACTIONS(647),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(647),
    [anon_sym_hot] = ACTIONS(647),
    [anon_sym_inaccessiblememonly] = ACTIONS(647),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(647),
    [anon_sym_inlinehint] = ACTIONS(647),
    [anon_sym_jumptable] = ACTIONS(647),
    [anon_sym_minsize] = ACTIONS(647),
    [anon_sym_naked] = ACTIONS(647),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(647),
    [anon_sym_nobuiltin] = ACTIONS(647),
    [anon_sym_noduplicate] = ACTIONS(647),
    [anon_sym_nofree] = ACTIONS(647),
    [anon_sym_noimplicitfloat] = ACTIONS(647),
    [anon_sym_noinline] = ACTIONS(647),
    [anon_sym_nomerge] = ACTIONS(647),
    [anon_sym_nonlazybind] = ACTIONS(647),
    [anon_sym_noprofile] = ACTIONS(647),
    [anon_sym_noredzone] = ACTIONS(647),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(647),
    [anon_sym_noreturn] = ACTIONS(647),
    [anon_sym_norecurse] = ACTIONS(647),
    [anon_sym_willreturn] = ACTIONS(647),
    [anon_sym_nosync] = ACTIONS(647),
    [anon_sym_nounwind] = ACTIONS(647),
    [anon_sym_nosanitize_coverage] = ACTIONS(647),
    [anon_sym_null_pointer_is_valid] = ACTIONS(647),
    [anon_sym_optforfuzzing] = ACTIONS(647),
    [anon_sym_optnone] = ACTIONS(647),
    [anon_sym_optsize] = ACTIONS(647),
    [anon_sym_readnone] = ACTIONS(647),
    [anon_sym_readonly] = ACTIONS(647),
    [anon_sym_writeonly] = ACTIONS(647),
    [anon_sym_argmemonly] = ACTIONS(647),
    [anon_sym_returns_twice] = ACTIONS(647),
    [anon_sym_safestack] = ACTIONS(647),
    [anon_sym_sanitize_address] = ACTIONS(647),
    [anon_sym_sanitize_memory] = ACTIONS(647),
    [anon_sym_sanitize_thread] = ACTIONS(647),
    [anon_sym_sanitize_hwaddress] = ACTIONS(647),
    [anon_sym_sanitize_memtag] = ACTIONS(647),
    [anon_sym_speculative_load_hardening] = ACTIONS(647),
    [anon_sym_speculatable] = ACTIONS(647),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(647),
    [anon_sym_sspreq] = ACTIONS(647),
    [anon_sym_strictfp] = ACTIONS(647),
    [anon_sym_uwtable] = ACTIONS(647),
    [anon_sym_nocf_check] = ACTIONS(647),
    [anon_sym_shadowcallstack] = ACTIONS(647),
    [anon_sym_mustprogress] = ACTIONS(647),
    [anon_sym_vscale_range] = ACTIONS(647),
    [anon_sym_preallocated] = ACTIONS(647),
    [anon_sym_zeroext] = ACTIONS(647),
    [anon_sym_signext] = ACTIONS(647),
    [anon_sym_inreg] = ACTIONS(647),
    [anon_sym_byval] = ACTIONS(647),
    [anon_sym_byref] = ACTIONS(647),
    [anon_sym_inalloca] = ACTIONS(647),
    [anon_sym_sret] = ACTIONS(647),
    [anon_sym_elementtype] = ACTIONS(647),
    [anon_sym_noalias] = ACTIONS(647),
    [anon_sym_nocapture] = ACTIONS(647),
    [anon_sym_nest] = ACTIONS(647),
    [anon_sym_returned] = ACTIONS(647),
    [anon_sym_nonnull] = ACTIONS(647),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(647),
    [anon_sym_swiftself] = ACTIONS(647),
    [anon_sym_swiftasync] = ACTIONS(647),
    [anon_sym_swifterror] = ACTIONS(647),
    [anon_sym_immarg] = ACTIONS(647),
    [anon_sym_noundef] = ACTIONS(647),
    [anon_sym_to] = ACTIONS(649),
    [anon_sym_uselistorder] = ACTIONS(649),
    [anon_sym_uselistorder_bb] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_attributes] = ACTIONS(647),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(631),
    [sym_comdat_ref] = ACTIONS(631),
    [sym_global_var] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [aux_sym_metadata_ref_token1] = ACTIONS(631),
    [sym_summary_ref] = ACTIONS(631),
    [sym_string] = ACTIONS(631),
    [anon_sym_target] = ACTIONS(631),
    [anon_sym_source_filename] = ACTIONS(631),
    [anon_sym_declare] = ACTIONS(631),
    [anon_sym_define] = ACTIONS(631),
    [anon_sym_void] = ACTIONS(631),
    [anon_sym_half] = ACTIONS(631),
    [anon_sym_bfloat] = ACTIONS(631),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_double] = ACTIONS(631),
    [anon_sym_x86_fp80] = ACTIONS(631),
    [anon_sym_fp128] = ACTIONS(631),
    [anon_sym_ppc_fp128] = ACTIONS(631),
    [anon_sym_label] = ACTIONS(631),
    [anon_sym_metadata] = ACTIONS(631),
    [anon_sym_x86_mmx] = ACTIONS(631),
    [anon_sym_x86_amx] = ACTIONS(631),
    [anon_sym_token] = ACTIONS(631),
    [anon_sym_opaque] = ACTIONS(631),
    [anon_sym_ptr] = ACTIONS(631),
    [aux_sym_type_keyword_token1] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LT_LBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_section] = ACTIONS(631),
    [anon_sym_partition] = ACTIONS(631),
    [anon_sym_comdat] = ACTIONS(631),
    [anon_sym_gc] = ACTIONS(631),
    [anon_sym_prefix] = ACTIONS(631),
    [anon_sym_prologue] = ACTIONS(631),
    [anon_sym_personality] = ACTIONS(631),
    [anon_sym_alignstack] = ACTIONS(631),
    [anon_sym_allocsize] = ACTIONS(631),
    [anon_sym_alwaysinline] = ACTIONS(631),
    [anon_sym_builtin] = ACTIONS(631),
    [anon_sym_cold] = ACTIONS(631),
    [anon_sym_convergent] = ACTIONS(631),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(631),
    [anon_sym_hot] = ACTIONS(631),
    [anon_sym_inaccessiblememonly] = ACTIONS(631),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(631),
    [anon_sym_inlinehint] = ACTIONS(631),
    [anon_sym_jumptable] = ACTIONS(631),
    [anon_sym_minsize] = ACTIONS(631),
    [anon_sym_naked] = ACTIONS(631),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(631),
    [anon_sym_nobuiltin] = ACTIONS(631),
    [anon_sym_noduplicate] = ACTIONS(631),
    [anon_sym_nofree] = ACTIONS(631),
    [anon_sym_noimplicitfloat] = ACTIONS(631),
    [anon_sym_noinline] = ACTIONS(631),
    [anon_sym_nomerge] = ACTIONS(631),
    [anon_sym_nonlazybind] = ACTIONS(631),
    [anon_sym_noprofile] = ACTIONS(631),
    [anon_sym_noredzone] = ACTIONS(631),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(631),
    [anon_sym_noreturn] = ACTIONS(631),
    [anon_sym_norecurse] = ACTIONS(631),
    [anon_sym_willreturn] = ACTIONS(631),
    [anon_sym_nosync] = ACTIONS(631),
    [anon_sym_nounwind] = ACTIONS(631),
    [anon_sym_nosanitize_coverage] = ACTIONS(631),
    [anon_sym_null_pointer_is_valid] = ACTIONS(631),
    [anon_sym_optforfuzzing] = ACTIONS(631),
    [anon_sym_optnone] = ACTIONS(631),
    [anon_sym_optsize] = ACTIONS(631),
    [anon_sym_readnone] = ACTIONS(631),
    [anon_sym_readonly] = ACTIONS(631),
    [anon_sym_writeonly] = ACTIONS(631),
    [anon_sym_argmemonly] = ACTIONS(631),
    [anon_sym_returns_twice] = ACTIONS(631),
    [anon_sym_safestack] = ACTIONS(631),
    [anon_sym_sanitize_address] = ACTIONS(631),
    [anon_sym_sanitize_memory] = ACTIONS(631),
    [anon_sym_sanitize_thread] = ACTIONS(631),
    [anon_sym_sanitize_hwaddress] = ACTIONS(631),
    [anon_sym_sanitize_memtag] = ACTIONS(631),
    [anon_sym_speculative_load_hardening] = ACTIONS(631),
    [anon_sym_speculatable] = ACTIONS(631),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(631),
    [anon_sym_sspreq] = ACTIONS(631),
    [anon_sym_strictfp] = ACTIONS(631),
    [anon_sym_uwtable] = ACTIONS(631),
    [anon_sym_nocf_check] = ACTIONS(631),
    [anon_sym_shadowcallstack] = ACTIONS(631),
    [anon_sym_mustprogress] = ACTIONS(631),
    [anon_sym_vscale_range] = ACTIONS(631),
    [anon_sym_preallocated] = ACTIONS(631),
    [anon_sym_zeroext] = ACTIONS(631),
    [anon_sym_signext] = ACTIONS(631),
    [anon_sym_inreg] = ACTIONS(631),
    [anon_sym_byval] = ACTIONS(631),
    [anon_sym_byref] = ACTIONS(631),
    [anon_sym_inalloca] = ACTIONS(631),
    [anon_sym_sret] = ACTIONS(631),
    [anon_sym_elementtype] = ACTIONS(631),
    [anon_sym_noalias] = ACTIONS(631),
    [anon_sym_nocapture] = ACTIONS(631),
    [anon_sym_nest] = ACTIONS(631),
    [anon_sym_returned] = ACTIONS(631),
    [anon_sym_nonnull] = ACTIONS(631),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(631),
    [anon_sym_swiftself] = ACTIONS(631),
    [anon_sym_swiftasync] = ACTIONS(631),
    [anon_sym_swifterror] = ACTIONS(631),
    [anon_sym_immarg] = ACTIONS(631),
    [anon_sym_noundef] = ACTIONS(631),
    [anon_sym_to] = ACTIONS(633),
    [anon_sym_uselistorder] = ACTIONS(633),
    [anon_sym_uselistorder_bb] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_attributes] = ACTIONS(631),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(581),
    [sym_comdat_ref] = ACTIONS(581),
    [sym_global_var] = ACTIONS(581),
    [sym_local_var] = ACTIONS(581),
    [aux_sym_metadata_ref_token1] = ACTIONS(581),
    [sym_summary_ref] = ACTIONS(581),
    [sym_string] = ACTIONS(581),
    [anon_sym_target] = ACTIONS(581),
    [anon_sym_source_filename] = ACTIONS(581),
    [anon_sym_declare] = ACTIONS(581),
    [anon_sym_define] = ACTIONS(581),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_half] = ACTIONS(581),
    [anon_sym_bfloat] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_double] = ACTIONS(581),
    [anon_sym_x86_fp80] = ACTIONS(581),
    [anon_sym_fp128] = ACTIONS(581),
    [anon_sym_ppc_fp128] = ACTIONS(581),
    [anon_sym_label] = ACTIONS(581),
    [anon_sym_metadata] = ACTIONS(581),
    [anon_sym_x86_mmx] = ACTIONS(581),
    [anon_sym_x86_amx] = ACTIONS(581),
    [anon_sym_token] = ACTIONS(581),
    [anon_sym_opaque] = ACTIONS(581),
    [anon_sym_ptr] = ACTIONS(581),
    [aux_sym_type_keyword_token1] = ACTIONS(581),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_LT_LBRACE] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_RBRACK] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(581),
    [anon_sym_align] = ACTIONS(583),
    [anon_sym_section] = ACTIONS(581),
    [anon_sym_partition] = ACTIONS(581),
    [anon_sym_comdat] = ACTIONS(581),
    [anon_sym_gc] = ACTIONS(581),
    [anon_sym_prefix] = ACTIONS(581),
    [anon_sym_prologue] = ACTIONS(581),
    [anon_sym_personality] = ACTIONS(581),
    [anon_sym_alignstack] = ACTIONS(581),
    [anon_sym_allocsize] = ACTIONS(581),
    [anon_sym_alwaysinline] = ACTIONS(581),
    [anon_sym_builtin] = ACTIONS(581),
    [anon_sym_cold] = ACTIONS(581),
    [anon_sym_convergent] = ACTIONS(581),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(581),
    [anon_sym_hot] = ACTIONS(581),
    [anon_sym_inaccessiblememonly] = ACTIONS(581),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(581),
    [anon_sym_inlinehint] = ACTIONS(581),
    [anon_sym_jumptable] = ACTIONS(581),
    [anon_sym_minsize] = ACTIONS(581),
    [anon_sym_naked] = ACTIONS(581),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(581),
    [anon_sym_nobuiltin] = ACTIONS(581),
    [anon_sym_noduplicate] = ACTIONS(581),
    [anon_sym_nofree] = ACTIONS(581),
    [anon_sym_noimplicitfloat] = ACTIONS(581),
    [anon_sym_noinline] = ACTIONS(581),
    [anon_sym_nomerge] = ACTIONS(581),
    [anon_sym_nonlazybind] = ACTIONS(581),
    [anon_sym_noprofile] = ACTIONS(581),
    [anon_sym_noredzone] = ACTIONS(581),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(581),
    [anon_sym_noreturn] = ACTIONS(581),
    [anon_sym_norecurse] = ACTIONS(581),
    [anon_sym_willreturn] = ACTIONS(581),
    [anon_sym_nosync] = ACTIONS(581),
    [anon_sym_nounwind] = ACTIONS(581),
    [anon_sym_nosanitize_coverage] = ACTIONS(581),
    [anon_sym_null_pointer_is_valid] = ACTIONS(581),
    [anon_sym_optforfuzzing] = ACTIONS(581),
    [anon_sym_optnone] = ACTIONS(581),
    [anon_sym_optsize] = ACTIONS(581),
    [anon_sym_readnone] = ACTIONS(581),
    [anon_sym_readonly] = ACTIONS(581),
    [anon_sym_writeonly] = ACTIONS(581),
    [anon_sym_argmemonly] = ACTIONS(581),
    [anon_sym_returns_twice] = ACTIONS(581),
    [anon_sym_safestack] = ACTIONS(581),
    [anon_sym_sanitize_address] = ACTIONS(581),
    [anon_sym_sanitize_memory] = ACTIONS(581),
    [anon_sym_sanitize_thread] = ACTIONS(581),
    [anon_sym_sanitize_hwaddress] = ACTIONS(581),
    [anon_sym_sanitize_memtag] = ACTIONS(581),
    [anon_sym_speculative_load_hardening] = ACTIONS(581),
    [anon_sym_speculatable] = ACTIONS(581),
    [anon_sym_ssp] = ACTIONS(583),
    [anon_sym_sspstrong] = ACTIONS(581),
    [anon_sym_sspreq] = ACTIONS(581),
    [anon_sym_strictfp] = ACTIONS(581),
    [anon_sym_uwtable] = ACTIONS(581),
    [anon_sym_nocf_check] = ACTIONS(581),
    [anon_sym_shadowcallstack] = ACTIONS(581),
    [anon_sym_mustprogress] = ACTIONS(581),
    [anon_sym_vscale_range] = ACTIONS(581),
    [anon_sym_preallocated] = ACTIONS(581),
    [anon_sym_zeroext] = ACTIONS(581),
    [anon_sym_signext] = ACTIONS(581),
    [anon_sym_inreg] = ACTIONS(581),
    [anon_sym_byval] = ACTIONS(581),
    [anon_sym_byref] = ACTIONS(581),
    [anon_sym_inalloca] = ACTIONS(581),
    [anon_sym_sret] = ACTIONS(581),
    [anon_sym_elementtype] = ACTIONS(581),
    [anon_sym_noalias] = ACTIONS(581),
    [anon_sym_nocapture] = ACTIONS(581),
    [anon_sym_nest] = ACTIONS(581),
    [anon_sym_returned] = ACTIONS(581),
    [anon_sym_nonnull] = ACTIONS(581),
    [anon_sym_dereferenceable] = ACTIONS(583),
    [anon_sym_dereferenceable_or_null] = ACTIONS(581),
    [anon_sym_swiftself] = ACTIONS(581),
    [anon_sym_swiftasync] = ACTIONS(581),
    [anon_sym_swifterror] = ACTIONS(581),
    [anon_sym_immarg] = ACTIONS(581),
    [anon_sym_noundef] = ACTIONS(581),
    [anon_sym_to] = ACTIONS(583),
    [anon_sym_uselistorder] = ACTIONS(583),
    [anon_sym_uselistorder_bb] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_attributes] = ACTIONS(581),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(565),
    [sym_comdat_ref] = ACTIONS(565),
    [sym_global_var] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [aux_sym_metadata_ref_token1] = ACTIONS(565),
    [sym_summary_ref] = ACTIONS(565),
    [sym_string] = ACTIONS(565),
    [anon_sym_target] = ACTIONS(565),
    [anon_sym_source_filename] = ACTIONS(565),
    [anon_sym_declare] = ACTIONS(565),
    [anon_sym_define] = ACTIONS(565),
    [anon_sym_void] = ACTIONS(565),
    [anon_sym_half] = ACTIONS(565),
    [anon_sym_bfloat] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_double] = ACTIONS(565),
    [anon_sym_x86_fp80] = ACTIONS(565),
    [anon_sym_fp128] = ACTIONS(565),
    [anon_sym_ppc_fp128] = ACTIONS(565),
    [anon_sym_label] = ACTIONS(565),
    [anon_sym_metadata] = ACTIONS(565),
    [anon_sym_x86_mmx] = ACTIONS(565),
    [anon_sym_x86_amx] = ACTIONS(565),
    [anon_sym_token] = ACTIONS(565),
    [anon_sym_opaque] = ACTIONS(565),
    [anon_sym_ptr] = ACTIONS(565),
    [aux_sym_type_keyword_token1] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LT_LBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_section] = ACTIONS(565),
    [anon_sym_partition] = ACTIONS(565),
    [anon_sym_comdat] = ACTIONS(565),
    [anon_sym_gc] = ACTIONS(565),
    [anon_sym_prefix] = ACTIONS(565),
    [anon_sym_prologue] = ACTIONS(565),
    [anon_sym_personality] = ACTIONS(565),
    [anon_sym_alignstack] = ACTIONS(565),
    [anon_sym_allocsize] = ACTIONS(565),
    [anon_sym_alwaysinline] = ACTIONS(565),
    [anon_sym_builtin] = ACTIONS(565),
    [anon_sym_cold] = ACTIONS(565),
    [anon_sym_convergent] = ACTIONS(565),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(565),
    [anon_sym_hot] = ACTIONS(565),
    [anon_sym_inaccessiblememonly] = ACTIONS(565),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(565),
    [anon_sym_inlinehint] = ACTIONS(565),
    [anon_sym_jumptable] = ACTIONS(565),
    [anon_sym_minsize] = ACTIONS(565),
    [anon_sym_naked] = ACTIONS(565),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(565),
    [anon_sym_nobuiltin] = ACTIONS(565),
    [anon_sym_noduplicate] = ACTIONS(565),
    [anon_sym_nofree] = ACTIONS(565),
    [anon_sym_noimplicitfloat] = ACTIONS(565),
    [anon_sym_noinline] = ACTIONS(565),
    [anon_sym_nomerge] = ACTIONS(565),
    [anon_sym_nonlazybind] = ACTIONS(565),
    [anon_sym_noprofile] = ACTIONS(565),
    [anon_sym_noredzone] = ACTIONS(565),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(565),
    [anon_sym_noreturn] = ACTIONS(565),
    [anon_sym_norecurse] = ACTIONS(565),
    [anon_sym_willreturn] = ACTIONS(565),
    [anon_sym_nosync] = ACTIONS(565),
    [anon_sym_nounwind] = ACTIONS(565),
    [anon_sym_nosanitize_coverage] = ACTIONS(565),
    [anon_sym_null_pointer_is_valid] = ACTIONS(565),
    [anon_sym_optforfuzzing] = ACTIONS(565),
    [anon_sym_optnone] = ACTIONS(565),
    [anon_sym_optsize] = ACTIONS(565),
    [anon_sym_readnone] = ACTIONS(565),
    [anon_sym_readonly] = ACTIONS(565),
    [anon_sym_writeonly] = ACTIONS(565),
    [anon_sym_argmemonly] = ACTIONS(565),
    [anon_sym_returns_twice] = ACTIONS(565),
    [anon_sym_safestack] = ACTIONS(565),
    [anon_sym_sanitize_address] = ACTIONS(565),
    [anon_sym_sanitize_memory] = ACTIONS(565),
    [anon_sym_sanitize_thread] = ACTIONS(565),
    [anon_sym_sanitize_hwaddress] = ACTIONS(565),
    [anon_sym_sanitize_memtag] = ACTIONS(565),
    [anon_sym_speculative_load_hardening] = ACTIONS(565),
    [anon_sym_speculatable] = ACTIONS(565),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(565),
    [anon_sym_sspreq] = ACTIONS(565),
    [anon_sym_strictfp] = ACTIONS(565),
    [anon_sym_uwtable] = ACTIONS(565),
    [anon_sym_nocf_check] = ACTIONS(565),
    [anon_sym_shadowcallstack] = ACTIONS(565),
    [anon_sym_mustprogress] = ACTIONS(565),
    [anon_sym_vscale_range] = ACTIONS(565),
    [anon_sym_preallocated] = ACTIONS(565),
    [anon_sym_zeroext] = ACTIONS(565),
    [anon_sym_signext] = ACTIONS(565),
    [anon_sym_inreg] = ACTIONS(565),
    [anon_sym_byval] = ACTIONS(565),
    [anon_sym_byref] = ACTIONS(565),
    [anon_sym_inalloca] = ACTIONS(565),
    [anon_sym_sret] = ACTIONS(565),
    [anon_sym_elementtype] = ACTIONS(565),
    [anon_sym_noalias] = ACTIONS(565),
    [anon_sym_nocapture] = ACTIONS(565),
    [anon_sym_nest] = ACTIONS(565),
    [anon_sym_returned] = ACTIONS(565),
    [anon_sym_nonnull] = ACTIONS(565),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(565),
    [anon_sym_swiftself] = ACTIONS(565),
    [anon_sym_swiftasync] = ACTIONS(565),
    [anon_sym_swifterror] = ACTIONS(565),
    [anon_sym_immarg] = ACTIONS(565),
    [anon_sym_noundef] = ACTIONS(565),
    [anon_sym_to] = ACTIONS(567),
    [anon_sym_uselistorder] = ACTIONS(567),
    [anon_sym_uselistorder_bb] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_attributes] = ACTIONS(565),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(557),
    [sym_comdat_ref] = ACTIONS(557),
    [sym_global_var] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [aux_sym_metadata_ref_token1] = ACTIONS(557),
    [sym_summary_ref] = ACTIONS(557),
    [sym_string] = ACTIONS(557),
    [anon_sym_target] = ACTIONS(557),
    [anon_sym_source_filename] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_define] = ACTIONS(557),
    [anon_sym_void] = ACTIONS(557),
    [anon_sym_half] = ACTIONS(557),
    [anon_sym_bfloat] = ACTIONS(557),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_double] = ACTIONS(557),
    [anon_sym_x86_fp80] = ACTIONS(557),
    [anon_sym_fp128] = ACTIONS(557),
    [anon_sym_ppc_fp128] = ACTIONS(557),
    [anon_sym_label] = ACTIONS(557),
    [anon_sym_metadata] = ACTIONS(557),
    [anon_sym_x86_mmx] = ACTIONS(557),
    [anon_sym_x86_amx] = ACTIONS(557),
    [anon_sym_token] = ACTIONS(557),
    [anon_sym_opaque] = ACTIONS(557),
    [anon_sym_ptr] = ACTIONS(557),
    [aux_sym_type_keyword_token1] = ACTIONS(557),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LT_LBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_section] = ACTIONS(557),
    [anon_sym_partition] = ACTIONS(557),
    [anon_sym_comdat] = ACTIONS(557),
    [anon_sym_gc] = ACTIONS(557),
    [anon_sym_prefix] = ACTIONS(557),
    [anon_sym_prologue] = ACTIONS(557),
    [anon_sym_personality] = ACTIONS(557),
    [anon_sym_alignstack] = ACTIONS(557),
    [anon_sym_allocsize] = ACTIONS(557),
    [anon_sym_alwaysinline] = ACTIONS(557),
    [anon_sym_builtin] = ACTIONS(557),
    [anon_sym_cold] = ACTIONS(557),
    [anon_sym_convergent] = ACTIONS(557),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(557),
    [anon_sym_hot] = ACTIONS(557),
    [anon_sym_inaccessiblememonly] = ACTIONS(557),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(557),
    [anon_sym_inlinehint] = ACTIONS(557),
    [anon_sym_jumptable] = ACTIONS(557),
    [anon_sym_minsize] = ACTIONS(557),
    [anon_sym_naked] = ACTIONS(557),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(557),
    [anon_sym_nobuiltin] = ACTIONS(557),
    [anon_sym_noduplicate] = ACTIONS(557),
    [anon_sym_nofree] = ACTIONS(557),
    [anon_sym_noimplicitfloat] = ACTIONS(557),
    [anon_sym_noinline] = ACTIONS(557),
    [anon_sym_nomerge] = ACTIONS(557),
    [anon_sym_nonlazybind] = ACTIONS(557),
    [anon_sym_noprofile] = ACTIONS(557),
    [anon_sym_noredzone] = ACTIONS(557),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(557),
    [anon_sym_noreturn] = ACTIONS(557),
    [anon_sym_norecurse] = ACTIONS(557),
    [anon_sym_willreturn] = ACTIONS(557),
    [anon_sym_nosync] = ACTIONS(557),
    [anon_sym_nounwind] = ACTIONS(557),
    [anon_sym_nosanitize_coverage] = ACTIONS(557),
    [anon_sym_null_pointer_is_valid] = ACTIONS(557),
    [anon_sym_optforfuzzing] = ACTIONS(557),
    [anon_sym_optnone] = ACTIONS(557),
    [anon_sym_optsize] = ACTIONS(557),
    [anon_sym_readnone] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_writeonly] = ACTIONS(557),
    [anon_sym_argmemonly] = ACTIONS(557),
    [anon_sym_returns_twice] = ACTIONS(557),
    [anon_sym_safestack] = ACTIONS(557),
    [anon_sym_sanitize_address] = ACTIONS(557),
    [anon_sym_sanitize_memory] = ACTIONS(557),
    [anon_sym_sanitize_thread] = ACTIONS(557),
    [anon_sym_sanitize_hwaddress] = ACTIONS(557),
    [anon_sym_sanitize_memtag] = ACTIONS(557),
    [anon_sym_speculative_load_hardening] = ACTIONS(557),
    [anon_sym_speculatable] = ACTIONS(557),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(557),
    [anon_sym_sspreq] = ACTIONS(557),
    [anon_sym_strictfp] = ACTIONS(557),
    [anon_sym_uwtable] = ACTIONS(557),
    [anon_sym_nocf_check] = ACTIONS(557),
    [anon_sym_shadowcallstack] = ACTIONS(557),
    [anon_sym_mustprogress] = ACTIONS(557),
    [anon_sym_vscale_range] = ACTIONS(557),
    [anon_sym_preallocated] = ACTIONS(557),
    [anon_sym_zeroext] = ACTIONS(557),
    [anon_sym_signext] = ACTIONS(557),
    [anon_sym_inreg] = ACTIONS(557),
    [anon_sym_byval] = ACTIONS(557),
    [anon_sym_byref] = ACTIONS(557),
    [anon_sym_inalloca] = ACTIONS(557),
    [anon_sym_sret] = ACTIONS(557),
    [anon_sym_elementtype] = ACTIONS(557),
    [anon_sym_noalias] = ACTIONS(557),
    [anon_sym_nocapture] = ACTIONS(557),
    [anon_sym_nest] = ACTIONS(557),
    [anon_sym_returned] = ACTIONS(557),
    [anon_sym_nonnull] = ACTIONS(557),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(557),
    [anon_sym_swiftself] = ACTIONS(557),
    [anon_sym_swiftasync] = ACTIONS(557),
    [anon_sym_swifterror] = ACTIONS(557),
    [anon_sym_immarg] = ACTIONS(557),
    [anon_sym_noundef] = ACTIONS(557),
    [anon_sym_to] = ACTIONS(559),
    [anon_sym_uselistorder] = ACTIONS(559),
    [anon_sym_uselistorder_bb] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_attributes] = ACTIONS(557),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(663),
    [sym_comdat_ref] = ACTIONS(663),
    [sym_global_var] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [aux_sym_metadata_ref_token1] = ACTIONS(663),
    [sym_summary_ref] = ACTIONS(663),
    [sym_string] = ACTIONS(663),
    [anon_sym_target] = ACTIONS(663),
    [anon_sym_source_filename] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_define] = ACTIONS(663),
    [anon_sym_void] = ACTIONS(663),
    [anon_sym_half] = ACTIONS(663),
    [anon_sym_bfloat] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(663),
    [anon_sym_double] = ACTIONS(663),
    [anon_sym_x86_fp80] = ACTIONS(663),
    [anon_sym_fp128] = ACTIONS(663),
    [anon_sym_ppc_fp128] = ACTIONS(663),
    [anon_sym_label] = ACTIONS(663),
    [anon_sym_metadata] = ACTIONS(663),
    [anon_sym_x86_mmx] = ACTIONS(663),
    [anon_sym_x86_amx] = ACTIONS(663),
    [anon_sym_token] = ACTIONS(663),
    [anon_sym_opaque] = ACTIONS(663),
    [anon_sym_ptr] = ACTIONS(663),
    [aux_sym_type_keyword_token1] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LT_LBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_section] = ACTIONS(663),
    [anon_sym_partition] = ACTIONS(663),
    [anon_sym_comdat] = ACTIONS(663),
    [anon_sym_gc] = ACTIONS(663),
    [anon_sym_prefix] = ACTIONS(663),
    [anon_sym_prologue] = ACTIONS(663),
    [anon_sym_personality] = ACTIONS(663),
    [anon_sym_alignstack] = ACTIONS(663),
    [anon_sym_allocsize] = ACTIONS(663),
    [anon_sym_alwaysinline] = ACTIONS(663),
    [anon_sym_builtin] = ACTIONS(663),
    [anon_sym_cold] = ACTIONS(663),
    [anon_sym_convergent] = ACTIONS(663),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(663),
    [anon_sym_hot] = ACTIONS(663),
    [anon_sym_inaccessiblememonly] = ACTIONS(663),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(663),
    [anon_sym_inlinehint] = ACTIONS(663),
    [anon_sym_jumptable] = ACTIONS(663),
    [anon_sym_minsize] = ACTIONS(663),
    [anon_sym_naked] = ACTIONS(663),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(663),
    [anon_sym_nobuiltin] = ACTIONS(663),
    [anon_sym_noduplicate] = ACTIONS(663),
    [anon_sym_nofree] = ACTIONS(663),
    [anon_sym_noimplicitfloat] = ACTIONS(663),
    [anon_sym_noinline] = ACTIONS(663),
    [anon_sym_nomerge] = ACTIONS(663),
    [anon_sym_nonlazybind] = ACTIONS(663),
    [anon_sym_noprofile] = ACTIONS(663),
    [anon_sym_noredzone] = ACTIONS(663),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(663),
    [anon_sym_noreturn] = ACTIONS(663),
    [anon_sym_norecurse] = ACTIONS(663),
    [anon_sym_willreturn] = ACTIONS(663),
    [anon_sym_nosync] = ACTIONS(663),
    [anon_sym_nounwind] = ACTIONS(663),
    [anon_sym_nosanitize_coverage] = ACTIONS(663),
    [anon_sym_null_pointer_is_valid] = ACTIONS(663),
    [anon_sym_optforfuzzing] = ACTIONS(663),
    [anon_sym_optnone] = ACTIONS(663),
    [anon_sym_optsize] = ACTIONS(663),
    [anon_sym_readnone] = ACTIONS(663),
    [anon_sym_readonly] = ACTIONS(663),
    [anon_sym_writeonly] = ACTIONS(663),
    [anon_sym_argmemonly] = ACTIONS(663),
    [anon_sym_returns_twice] = ACTIONS(663),
    [anon_sym_safestack] = ACTIONS(663),
    [anon_sym_sanitize_address] = ACTIONS(663),
    [anon_sym_sanitize_memory] = ACTIONS(663),
    [anon_sym_sanitize_thread] = ACTIONS(663),
    [anon_sym_sanitize_hwaddress] = ACTIONS(663),
    [anon_sym_sanitize_memtag] = ACTIONS(663),
    [anon_sym_speculative_load_hardening] = ACTIONS(663),
    [anon_sym_speculatable] = ACTIONS(663),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(663),
    [anon_sym_sspreq] = ACTIONS(663),
    [anon_sym_strictfp] = ACTIONS(663),
    [anon_sym_uwtable] = ACTIONS(663),
    [anon_sym_nocf_check] = ACTIONS(663),
    [anon_sym_shadowcallstack] = ACTIONS(663),
    [anon_sym_mustprogress] = ACTIONS(663),
    [anon_sym_vscale_range] = ACTIONS(663),
    [anon_sym_preallocated] = ACTIONS(663),
    [anon_sym_zeroext] = ACTIONS(663),
    [anon_sym_signext] = ACTIONS(663),
    [anon_sym_inreg] = ACTIONS(663),
    [anon_sym_byval] = ACTIONS(663),
    [anon_sym_byref] = ACTIONS(663),
    [anon_sym_inalloca] = ACTIONS(663),
    [anon_sym_sret] = ACTIONS(663),
    [anon_sym_elementtype] = ACTIONS(663),
    [anon_sym_noalias] = ACTIONS(663),
    [anon_sym_nocapture] = ACTIONS(663),
    [anon_sym_nest] = ACTIONS(663),
    [anon_sym_returned] = ACTIONS(663),
    [anon_sym_nonnull] = ACTIONS(663),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(663),
    [anon_sym_swiftself] = ACTIONS(663),
    [anon_sym_swiftasync] = ACTIONS(663),
    [anon_sym_swifterror] = ACTIONS(663),
    [anon_sym_immarg] = ACTIONS(663),
    [anon_sym_noundef] = ACTIONS(663),
    [anon_sym_to] = ACTIONS(665),
    [anon_sym_uselistorder] = ACTIONS(665),
    [anon_sym_uselistorder_bb] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_attributes] = ACTIONS(663),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(651),
    [sym_comdat_ref] = ACTIONS(651),
    [sym_global_var] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [aux_sym_metadata_ref_token1] = ACTIONS(651),
    [sym_summary_ref] = ACTIONS(651),
    [sym_string] = ACTIONS(651),
    [anon_sym_target] = ACTIONS(651),
    [anon_sym_source_filename] = ACTIONS(651),
    [anon_sym_declare] = ACTIONS(651),
    [anon_sym_define] = ACTIONS(651),
    [anon_sym_void] = ACTIONS(651),
    [anon_sym_half] = ACTIONS(651),
    [anon_sym_bfloat] = ACTIONS(651),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_double] = ACTIONS(651),
    [anon_sym_x86_fp80] = ACTIONS(651),
    [anon_sym_fp128] = ACTIONS(651),
    [anon_sym_ppc_fp128] = ACTIONS(651),
    [anon_sym_label] = ACTIONS(651),
    [anon_sym_metadata] = ACTIONS(651),
    [anon_sym_x86_mmx] = ACTIONS(651),
    [anon_sym_x86_amx] = ACTIONS(651),
    [anon_sym_token] = ACTIONS(651),
    [anon_sym_opaque] = ACTIONS(651),
    [anon_sym_ptr] = ACTIONS(651),
    [aux_sym_type_keyword_token1] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_LBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_section] = ACTIONS(651),
    [anon_sym_partition] = ACTIONS(651),
    [anon_sym_comdat] = ACTIONS(651),
    [anon_sym_gc] = ACTIONS(651),
    [anon_sym_prefix] = ACTIONS(651),
    [anon_sym_prologue] = ACTIONS(651),
    [anon_sym_personality] = ACTIONS(651),
    [anon_sym_alignstack] = ACTIONS(651),
    [anon_sym_allocsize] = ACTIONS(651),
    [anon_sym_alwaysinline] = ACTIONS(651),
    [anon_sym_builtin] = ACTIONS(651),
    [anon_sym_cold] = ACTIONS(651),
    [anon_sym_convergent] = ACTIONS(651),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(651),
    [anon_sym_hot] = ACTIONS(651),
    [anon_sym_inaccessiblememonly] = ACTIONS(651),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(651),
    [anon_sym_inlinehint] = ACTIONS(651),
    [anon_sym_jumptable] = ACTIONS(651),
    [anon_sym_minsize] = ACTIONS(651),
    [anon_sym_naked] = ACTIONS(651),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(651),
    [anon_sym_nobuiltin] = ACTIONS(651),
    [anon_sym_noduplicate] = ACTIONS(651),
    [anon_sym_nofree] = ACTIONS(651),
    [anon_sym_noimplicitfloat] = ACTIONS(651),
    [anon_sym_noinline] = ACTIONS(651),
    [anon_sym_nomerge] = ACTIONS(651),
    [anon_sym_nonlazybind] = ACTIONS(651),
    [anon_sym_noprofile] = ACTIONS(651),
    [anon_sym_noredzone] = ACTIONS(651),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(651),
    [anon_sym_noreturn] = ACTIONS(651),
    [anon_sym_norecurse] = ACTIONS(651),
    [anon_sym_willreturn] = ACTIONS(651),
    [anon_sym_nosync] = ACTIONS(651),
    [anon_sym_nounwind] = ACTIONS(651),
    [anon_sym_nosanitize_coverage] = ACTIONS(651),
    [anon_sym_null_pointer_is_valid] = ACTIONS(651),
    [anon_sym_optforfuzzing] = ACTIONS(651),
    [anon_sym_optnone] = ACTIONS(651),
    [anon_sym_optsize] = ACTIONS(651),
    [anon_sym_readnone] = ACTIONS(651),
    [anon_sym_readonly] = ACTIONS(651),
    [anon_sym_writeonly] = ACTIONS(651),
    [anon_sym_argmemonly] = ACTIONS(651),
    [anon_sym_returns_twice] = ACTIONS(651),
    [anon_sym_safestack] = ACTIONS(651),
    [anon_sym_sanitize_address] = ACTIONS(651),
    [anon_sym_sanitize_memory] = ACTIONS(651),
    [anon_sym_sanitize_thread] = ACTIONS(651),
    [anon_sym_sanitize_hwaddress] = ACTIONS(651),
    [anon_sym_sanitize_memtag] = ACTIONS(651),
    [anon_sym_speculative_load_hardening] = ACTIONS(651),
    [anon_sym_speculatable] = ACTIONS(651),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(651),
    [anon_sym_sspreq] = ACTIONS(651),
    [anon_sym_strictfp] = ACTIONS(651),
    [anon_sym_uwtable] = ACTIONS(651),
    [anon_sym_nocf_check] = ACTIONS(651),
    [anon_sym_shadowcallstack] = ACTIONS(651),
    [anon_sym_mustprogress] = ACTIONS(651),
    [anon_sym_vscale_range] = ACTIONS(651),
    [anon_sym_preallocated] = ACTIONS(651),
    [anon_sym_zeroext] = ACTIONS(651),
    [anon_sym_signext] = ACTIONS(651),
    [anon_sym_inreg] = ACTIONS(651),
    [anon_sym_byval] = ACTIONS(651),
    [anon_sym_byref] = ACTIONS(651),
    [anon_sym_inalloca] = ACTIONS(651),
    [anon_sym_sret] = ACTIONS(651),
    [anon_sym_elementtype] = ACTIONS(651),
    [anon_sym_noalias] = ACTIONS(651),
    [anon_sym_nocapture] = ACTIONS(651),
    [anon_sym_nest] = ACTIONS(651),
    [anon_sym_returned] = ACTIONS(651),
    [anon_sym_nonnull] = ACTIONS(651),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(651),
    [anon_sym_swiftself] = ACTIONS(651),
    [anon_sym_swiftasync] = ACTIONS(651),
    [anon_sym_swifterror] = ACTIONS(651),
    [anon_sym_immarg] = ACTIONS(651),
    [anon_sym_noundef] = ACTIONS(651),
    [anon_sym_to] = ACTIONS(653),
    [anon_sym_uselistorder] = ACTIONS(653),
    [anon_sym_uselistorder_bb] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_attributes] = ACTIONS(651),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(659),
    [sym_comdat_ref] = ACTIONS(659),
    [sym_global_var] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [aux_sym_metadata_ref_token1] = ACTIONS(659),
    [sym_summary_ref] = ACTIONS(659),
    [sym_string] = ACTIONS(659),
    [anon_sym_target] = ACTIONS(659),
    [anon_sym_source_filename] = ACTIONS(659),
    [anon_sym_declare] = ACTIONS(659),
    [anon_sym_define] = ACTIONS(659),
    [anon_sym_void] = ACTIONS(659),
    [anon_sym_half] = ACTIONS(659),
    [anon_sym_bfloat] = ACTIONS(659),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_double] = ACTIONS(659),
    [anon_sym_x86_fp80] = ACTIONS(659),
    [anon_sym_fp128] = ACTIONS(659),
    [anon_sym_ppc_fp128] = ACTIONS(659),
    [anon_sym_label] = ACTIONS(659),
    [anon_sym_metadata] = ACTIONS(659),
    [anon_sym_x86_mmx] = ACTIONS(659),
    [anon_sym_x86_amx] = ACTIONS(659),
    [anon_sym_token] = ACTIONS(659),
    [anon_sym_opaque] = ACTIONS(659),
    [anon_sym_ptr] = ACTIONS(659),
    [aux_sym_type_keyword_token1] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_section] = ACTIONS(659),
    [anon_sym_partition] = ACTIONS(659),
    [anon_sym_comdat] = ACTIONS(659),
    [anon_sym_gc] = ACTIONS(659),
    [anon_sym_prefix] = ACTIONS(659),
    [anon_sym_prologue] = ACTIONS(659),
    [anon_sym_personality] = ACTIONS(659),
    [anon_sym_alignstack] = ACTIONS(659),
    [anon_sym_allocsize] = ACTIONS(659),
    [anon_sym_alwaysinline] = ACTIONS(659),
    [anon_sym_builtin] = ACTIONS(659),
    [anon_sym_cold] = ACTIONS(659),
    [anon_sym_convergent] = ACTIONS(659),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(659),
    [anon_sym_hot] = ACTIONS(659),
    [anon_sym_inaccessiblememonly] = ACTIONS(659),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(659),
    [anon_sym_inlinehint] = ACTIONS(659),
    [anon_sym_jumptable] = ACTIONS(659),
    [anon_sym_minsize] = ACTIONS(659),
    [anon_sym_naked] = ACTIONS(659),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(659),
    [anon_sym_nobuiltin] = ACTIONS(659),
    [anon_sym_noduplicate] = ACTIONS(659),
    [anon_sym_nofree] = ACTIONS(659),
    [anon_sym_noimplicitfloat] = ACTIONS(659),
    [anon_sym_noinline] = ACTIONS(659),
    [anon_sym_nomerge] = ACTIONS(659),
    [anon_sym_nonlazybind] = ACTIONS(659),
    [anon_sym_noprofile] = ACTIONS(659),
    [anon_sym_noredzone] = ACTIONS(659),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(659),
    [anon_sym_noreturn] = ACTIONS(659),
    [anon_sym_norecurse] = ACTIONS(659),
    [anon_sym_willreturn] = ACTIONS(659),
    [anon_sym_nosync] = ACTIONS(659),
    [anon_sym_nounwind] = ACTIONS(659),
    [anon_sym_nosanitize_coverage] = ACTIONS(659),
    [anon_sym_null_pointer_is_valid] = ACTIONS(659),
    [anon_sym_optforfuzzing] = ACTIONS(659),
    [anon_sym_optnone] = ACTIONS(659),
    [anon_sym_optsize] = ACTIONS(659),
    [anon_sym_readnone] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_writeonly] = ACTIONS(659),
    [anon_sym_argmemonly] = ACTIONS(659),
    [anon_sym_returns_twice] = ACTIONS(659),
    [anon_sym_safestack] = ACTIONS(659),
    [anon_sym_sanitize_address] = ACTIONS(659),
    [anon_sym_sanitize_memory] = ACTIONS(659),
    [anon_sym_sanitize_thread] = ACTIONS(659),
    [anon_sym_sanitize_hwaddress] = ACTIONS(659),
    [anon_sym_sanitize_memtag] = ACTIONS(659),
    [anon_sym_speculative_load_hardening] = ACTIONS(659),
    [anon_sym_speculatable] = ACTIONS(659),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(659),
    [anon_sym_sspreq] = ACTIONS(659),
    [anon_sym_strictfp] = ACTIONS(659),
    [anon_sym_uwtable] = ACTIONS(659),
    [anon_sym_nocf_check] = ACTIONS(659),
    [anon_sym_shadowcallstack] = ACTIONS(659),
    [anon_sym_mustprogress] = ACTIONS(659),
    [anon_sym_vscale_range] = ACTIONS(659),
    [anon_sym_preallocated] = ACTIONS(659),
    [anon_sym_zeroext] = ACTIONS(659),
    [anon_sym_signext] = ACTIONS(659),
    [anon_sym_inreg] = ACTIONS(659),
    [anon_sym_byval] = ACTIONS(659),
    [anon_sym_byref] = ACTIONS(659),
    [anon_sym_inalloca] = ACTIONS(659),
    [anon_sym_sret] = ACTIONS(659),
    [anon_sym_elementtype] = ACTIONS(659),
    [anon_sym_noalias] = ACTIONS(659),
    [anon_sym_nocapture] = ACTIONS(659),
    [anon_sym_nest] = ACTIONS(659),
    [anon_sym_returned] = ACTIONS(659),
    [anon_sym_nonnull] = ACTIONS(659),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(659),
    [anon_sym_swiftself] = ACTIONS(659),
    [anon_sym_swiftasync] = ACTIONS(659),
    [anon_sym_swifterror] = ACTIONS(659),
    [anon_sym_immarg] = ACTIONS(659),
    [anon_sym_noundef] = ACTIONS(659),
    [anon_sym_to] = ACTIONS(661),
    [anon_sym_uselistorder] = ACTIONS(661),
    [anon_sym_uselistorder_bb] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_attributes] = ACTIONS(659),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(675),
    [sym_comdat_ref] = ACTIONS(675),
    [sym_global_var] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [aux_sym_metadata_ref_token1] = ACTIONS(675),
    [sym_summary_ref] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [anon_sym_target] = ACTIONS(675),
    [anon_sym_source_filename] = ACTIONS(675),
    [anon_sym_declare] = ACTIONS(675),
    [anon_sym_define] = ACTIONS(675),
    [anon_sym_void] = ACTIONS(675),
    [anon_sym_half] = ACTIONS(675),
    [anon_sym_bfloat] = ACTIONS(675),
    [anon_sym_float] = ACTIONS(675),
    [anon_sym_double] = ACTIONS(675),
    [anon_sym_x86_fp80] = ACTIONS(675),
    [anon_sym_fp128] = ACTIONS(675),
    [anon_sym_ppc_fp128] = ACTIONS(675),
    [anon_sym_label] = ACTIONS(675),
    [anon_sym_metadata] = ACTIONS(675),
    [anon_sym_x86_mmx] = ACTIONS(675),
    [anon_sym_x86_amx] = ACTIONS(675),
    [anon_sym_token] = ACTIONS(675),
    [anon_sym_opaque] = ACTIONS(675),
    [anon_sym_ptr] = ACTIONS(675),
    [aux_sym_type_keyword_token1] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LT_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_section] = ACTIONS(675),
    [anon_sym_partition] = ACTIONS(675),
    [anon_sym_comdat] = ACTIONS(675),
    [anon_sym_gc] = ACTIONS(675),
    [anon_sym_prefix] = ACTIONS(675),
    [anon_sym_prologue] = ACTIONS(675),
    [anon_sym_personality] = ACTIONS(675),
    [anon_sym_alignstack] = ACTIONS(675),
    [anon_sym_allocsize] = ACTIONS(675),
    [anon_sym_alwaysinline] = ACTIONS(675),
    [anon_sym_builtin] = ACTIONS(675),
    [anon_sym_cold] = ACTIONS(675),
    [anon_sym_convergent] = ACTIONS(675),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(675),
    [anon_sym_hot] = ACTIONS(675),
    [anon_sym_inaccessiblememonly] = ACTIONS(675),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(675),
    [anon_sym_inlinehint] = ACTIONS(675),
    [anon_sym_jumptable] = ACTIONS(675),
    [anon_sym_minsize] = ACTIONS(675),
    [anon_sym_naked] = ACTIONS(675),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(675),
    [anon_sym_nobuiltin] = ACTIONS(675),
    [anon_sym_noduplicate] = ACTIONS(675),
    [anon_sym_nofree] = ACTIONS(675),
    [anon_sym_noimplicitfloat] = ACTIONS(675),
    [anon_sym_noinline] = ACTIONS(675),
    [anon_sym_nomerge] = ACTIONS(675),
    [anon_sym_nonlazybind] = ACTIONS(675),
    [anon_sym_noprofile] = ACTIONS(675),
    [anon_sym_noredzone] = ACTIONS(675),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(675),
    [anon_sym_noreturn] = ACTIONS(675),
    [anon_sym_norecurse] = ACTIONS(675),
    [anon_sym_willreturn] = ACTIONS(675),
    [anon_sym_nosync] = ACTIONS(675),
    [anon_sym_nounwind] = ACTIONS(675),
    [anon_sym_nosanitize_coverage] = ACTIONS(675),
    [anon_sym_null_pointer_is_valid] = ACTIONS(675),
    [anon_sym_optforfuzzing] = ACTIONS(675),
    [anon_sym_optnone] = ACTIONS(675),
    [anon_sym_optsize] = ACTIONS(675),
    [anon_sym_readnone] = ACTIONS(675),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_writeonly] = ACTIONS(675),
    [anon_sym_argmemonly] = ACTIONS(675),
    [anon_sym_returns_twice] = ACTIONS(675),
    [anon_sym_safestack] = ACTIONS(675),
    [anon_sym_sanitize_address] = ACTIONS(675),
    [anon_sym_sanitize_memory] = ACTIONS(675),
    [anon_sym_sanitize_thread] = ACTIONS(675),
    [anon_sym_sanitize_hwaddress] = ACTIONS(675),
    [anon_sym_sanitize_memtag] = ACTIONS(675),
    [anon_sym_speculative_load_hardening] = ACTIONS(675),
    [anon_sym_speculatable] = ACTIONS(675),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(675),
    [anon_sym_sspreq] = ACTIONS(675),
    [anon_sym_strictfp] = ACTIONS(675),
    [anon_sym_uwtable] = ACTIONS(675),
    [anon_sym_nocf_check] = ACTIONS(675),
    [anon_sym_shadowcallstack] = ACTIONS(675),
    [anon_sym_mustprogress] = ACTIONS(675),
    [anon_sym_vscale_range] = ACTIONS(675),
    [anon_sym_preallocated] = ACTIONS(675),
    [anon_sym_zeroext] = ACTIONS(675),
    [anon_sym_signext] = ACTIONS(675),
    [anon_sym_inreg] = ACTIONS(675),
    [anon_sym_byval] = ACTIONS(675),
    [anon_sym_byref] = ACTIONS(675),
    [anon_sym_inalloca] = ACTIONS(675),
    [anon_sym_sret] = ACTIONS(675),
    [anon_sym_elementtype] = ACTIONS(675),
    [anon_sym_noalias] = ACTIONS(675),
    [anon_sym_nocapture] = ACTIONS(675),
    [anon_sym_nest] = ACTIONS(675),
    [anon_sym_returned] = ACTIONS(675),
    [anon_sym_nonnull] = ACTIONS(675),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(675),
    [anon_sym_swiftself] = ACTIONS(675),
    [anon_sym_swiftasync] = ACTIONS(675),
    [anon_sym_swifterror] = ACTIONS(675),
    [anon_sym_immarg] = ACTIONS(675),
    [anon_sym_noundef] = ACTIONS(675),
    [anon_sym_to] = ACTIONS(677),
    [anon_sym_uselistorder] = ACTIONS(677),
    [anon_sym_uselistorder_bb] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_attributes] = ACTIONS(675),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(549),
    [sym_comdat_ref] = ACTIONS(549),
    [sym_global_var] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [aux_sym_metadata_ref_token1] = ACTIONS(549),
    [sym_summary_ref] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [anon_sym_target] = ACTIONS(549),
    [anon_sym_source_filename] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(549),
    [anon_sym_define] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(549),
    [anon_sym_half] = ACTIONS(549),
    [anon_sym_bfloat] = ACTIONS(549),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_double] = ACTIONS(549),
    [anon_sym_x86_fp80] = ACTIONS(549),
    [anon_sym_fp128] = ACTIONS(549),
    [anon_sym_ppc_fp128] = ACTIONS(549),
    [anon_sym_label] = ACTIONS(549),
    [anon_sym_metadata] = ACTIONS(549),
    [anon_sym_x86_mmx] = ACTIONS(549),
    [anon_sym_x86_amx] = ACTIONS(549),
    [anon_sym_token] = ACTIONS(549),
    [anon_sym_opaque] = ACTIONS(549),
    [anon_sym_ptr] = ACTIONS(549),
    [aux_sym_type_keyword_token1] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LT_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_section] = ACTIONS(549),
    [anon_sym_partition] = ACTIONS(549),
    [anon_sym_comdat] = ACTIONS(549),
    [anon_sym_gc] = ACTIONS(549),
    [anon_sym_prefix] = ACTIONS(549),
    [anon_sym_prologue] = ACTIONS(549),
    [anon_sym_personality] = ACTIONS(549),
    [anon_sym_alignstack] = ACTIONS(549),
    [anon_sym_allocsize] = ACTIONS(549),
    [anon_sym_alwaysinline] = ACTIONS(549),
    [anon_sym_builtin] = ACTIONS(549),
    [anon_sym_cold] = ACTIONS(549),
    [anon_sym_convergent] = ACTIONS(549),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(549),
    [anon_sym_hot] = ACTIONS(549),
    [anon_sym_inaccessiblememonly] = ACTIONS(549),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(549),
    [anon_sym_inlinehint] = ACTIONS(549),
    [anon_sym_jumptable] = ACTIONS(549),
    [anon_sym_minsize] = ACTIONS(549),
    [anon_sym_naked] = ACTIONS(549),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(549),
    [anon_sym_nobuiltin] = ACTIONS(549),
    [anon_sym_noduplicate] = ACTIONS(549),
    [anon_sym_nofree] = ACTIONS(549),
    [anon_sym_noimplicitfloat] = ACTIONS(549),
    [anon_sym_noinline] = ACTIONS(549),
    [anon_sym_nomerge] = ACTIONS(549),
    [anon_sym_nonlazybind] = ACTIONS(549),
    [anon_sym_noprofile] = ACTIONS(549),
    [anon_sym_noredzone] = ACTIONS(549),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(549),
    [anon_sym_noreturn] = ACTIONS(549),
    [anon_sym_norecurse] = ACTIONS(549),
    [anon_sym_willreturn] = ACTIONS(549),
    [anon_sym_nosync] = ACTIONS(549),
    [anon_sym_nounwind] = ACTIONS(549),
    [anon_sym_nosanitize_coverage] = ACTIONS(549),
    [anon_sym_null_pointer_is_valid] = ACTIONS(549),
    [anon_sym_optforfuzzing] = ACTIONS(549),
    [anon_sym_optnone] = ACTIONS(549),
    [anon_sym_optsize] = ACTIONS(549),
    [anon_sym_readnone] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_writeonly] = ACTIONS(549),
    [anon_sym_argmemonly] = ACTIONS(549),
    [anon_sym_returns_twice] = ACTIONS(549),
    [anon_sym_safestack] = ACTIONS(549),
    [anon_sym_sanitize_address] = ACTIONS(549),
    [anon_sym_sanitize_memory] = ACTIONS(549),
    [anon_sym_sanitize_thread] = ACTIONS(549),
    [anon_sym_sanitize_hwaddress] = ACTIONS(549),
    [anon_sym_sanitize_memtag] = ACTIONS(549),
    [anon_sym_speculative_load_hardening] = ACTIONS(549),
    [anon_sym_speculatable] = ACTIONS(549),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(549),
    [anon_sym_sspreq] = ACTIONS(549),
    [anon_sym_strictfp] = ACTIONS(549),
    [anon_sym_uwtable] = ACTIONS(549),
    [anon_sym_nocf_check] = ACTIONS(549),
    [anon_sym_shadowcallstack] = ACTIONS(549),
    [anon_sym_mustprogress] = ACTIONS(549),
    [anon_sym_vscale_range] = ACTIONS(549),
    [anon_sym_preallocated] = ACTIONS(549),
    [anon_sym_zeroext] = ACTIONS(549),
    [anon_sym_signext] = ACTIONS(549),
    [anon_sym_inreg] = ACTIONS(549),
    [anon_sym_byval] = ACTIONS(549),
    [anon_sym_byref] = ACTIONS(549),
    [anon_sym_inalloca] = ACTIONS(549),
    [anon_sym_sret] = ACTIONS(549),
    [anon_sym_elementtype] = ACTIONS(549),
    [anon_sym_noalias] = ACTIONS(549),
    [anon_sym_nocapture] = ACTIONS(549),
    [anon_sym_nest] = ACTIONS(549),
    [anon_sym_returned] = ACTIONS(549),
    [anon_sym_nonnull] = ACTIONS(549),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(549),
    [anon_sym_swiftself] = ACTIONS(549),
    [anon_sym_swiftasync] = ACTIONS(549),
    [anon_sym_swifterror] = ACTIONS(549),
    [anon_sym_immarg] = ACTIONS(549),
    [anon_sym_noundef] = ACTIONS(549),
    [anon_sym_to] = ACTIONS(551),
    [anon_sym_uselistorder] = ACTIONS(551),
    [anon_sym_uselistorder_bb] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_attributes] = ACTIONS(549),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(643),
    [sym_comdat_ref] = ACTIONS(643),
    [sym_global_var] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [aux_sym_metadata_ref_token1] = ACTIONS(643),
    [sym_summary_ref] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [anon_sym_target] = ACTIONS(643),
    [anon_sym_source_filename] = ACTIONS(643),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_define] = ACTIONS(643),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_half] = ACTIONS(643),
    [anon_sym_bfloat] = ACTIONS(643),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_double] = ACTIONS(643),
    [anon_sym_x86_fp80] = ACTIONS(643),
    [anon_sym_fp128] = ACTIONS(643),
    [anon_sym_ppc_fp128] = ACTIONS(643),
    [anon_sym_label] = ACTIONS(643),
    [anon_sym_metadata] = ACTIONS(643),
    [anon_sym_x86_mmx] = ACTIONS(643),
    [anon_sym_x86_amx] = ACTIONS(643),
    [anon_sym_token] = ACTIONS(643),
    [anon_sym_opaque] = ACTIONS(643),
    [anon_sym_ptr] = ACTIONS(643),
    [aux_sym_type_keyword_token1] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_LBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_section] = ACTIONS(643),
    [anon_sym_partition] = ACTIONS(643),
    [anon_sym_comdat] = ACTIONS(643),
    [anon_sym_gc] = ACTIONS(643),
    [anon_sym_prefix] = ACTIONS(643),
    [anon_sym_prologue] = ACTIONS(643),
    [anon_sym_personality] = ACTIONS(643),
    [anon_sym_alignstack] = ACTIONS(643),
    [anon_sym_allocsize] = ACTIONS(643),
    [anon_sym_alwaysinline] = ACTIONS(643),
    [anon_sym_builtin] = ACTIONS(643),
    [anon_sym_cold] = ACTIONS(643),
    [anon_sym_convergent] = ACTIONS(643),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(643),
    [anon_sym_hot] = ACTIONS(643),
    [anon_sym_inaccessiblememonly] = ACTIONS(643),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(643),
    [anon_sym_inlinehint] = ACTIONS(643),
    [anon_sym_jumptable] = ACTIONS(643),
    [anon_sym_minsize] = ACTIONS(643),
    [anon_sym_naked] = ACTIONS(643),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(643),
    [anon_sym_nobuiltin] = ACTIONS(643),
    [anon_sym_noduplicate] = ACTIONS(643),
    [anon_sym_nofree] = ACTIONS(643),
    [anon_sym_noimplicitfloat] = ACTIONS(643),
    [anon_sym_noinline] = ACTIONS(643),
    [anon_sym_nomerge] = ACTIONS(643),
    [anon_sym_nonlazybind] = ACTIONS(643),
    [anon_sym_noprofile] = ACTIONS(643),
    [anon_sym_noredzone] = ACTIONS(643),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(643),
    [anon_sym_noreturn] = ACTIONS(643),
    [anon_sym_norecurse] = ACTIONS(643),
    [anon_sym_willreturn] = ACTIONS(643),
    [anon_sym_nosync] = ACTIONS(643),
    [anon_sym_nounwind] = ACTIONS(643),
    [anon_sym_nosanitize_coverage] = ACTIONS(643),
    [anon_sym_null_pointer_is_valid] = ACTIONS(643),
    [anon_sym_optforfuzzing] = ACTIONS(643),
    [anon_sym_optnone] = ACTIONS(643),
    [anon_sym_optsize] = ACTIONS(643),
    [anon_sym_readnone] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_writeonly] = ACTIONS(643),
    [anon_sym_argmemonly] = ACTIONS(643),
    [anon_sym_returns_twice] = ACTIONS(643),
    [anon_sym_safestack] = ACTIONS(643),
    [anon_sym_sanitize_address] = ACTIONS(643),
    [anon_sym_sanitize_memory] = ACTIONS(643),
    [anon_sym_sanitize_thread] = ACTIONS(643),
    [anon_sym_sanitize_hwaddress] = ACTIONS(643),
    [anon_sym_sanitize_memtag] = ACTIONS(643),
    [anon_sym_speculative_load_hardening] = ACTIONS(643),
    [anon_sym_speculatable] = ACTIONS(643),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(643),
    [anon_sym_sspreq] = ACTIONS(643),
    [anon_sym_strictfp] = ACTIONS(643),
    [anon_sym_uwtable] = ACTIONS(643),
    [anon_sym_nocf_check] = ACTIONS(643),
    [anon_sym_shadowcallstack] = ACTIONS(643),
    [anon_sym_mustprogress] = ACTIONS(643),
    [anon_sym_vscale_range] = ACTIONS(643),
    [anon_sym_preallocated] = ACTIONS(643),
    [anon_sym_zeroext] = ACTIONS(643),
    [anon_sym_signext] = ACTIONS(643),
    [anon_sym_inreg] = ACTIONS(643),
    [anon_sym_byval] = ACTIONS(643),
    [anon_sym_byref] = ACTIONS(643),
    [anon_sym_inalloca] = ACTIONS(643),
    [anon_sym_sret] = ACTIONS(643),
    [anon_sym_elementtype] = ACTIONS(643),
    [anon_sym_noalias] = ACTIONS(643),
    [anon_sym_nocapture] = ACTIONS(643),
    [anon_sym_nest] = ACTIONS(643),
    [anon_sym_returned] = ACTIONS(643),
    [anon_sym_nonnull] = ACTIONS(643),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(643),
    [anon_sym_swiftself] = ACTIONS(643),
    [anon_sym_swiftasync] = ACTIONS(643),
    [anon_sym_swifterror] = ACTIONS(643),
    [anon_sym_immarg] = ACTIONS(643),
    [anon_sym_noundef] = ACTIONS(643),
    [anon_sym_to] = ACTIONS(645),
    [anon_sym_uselistorder] = ACTIONS(645),
    [anon_sym_uselistorder_bb] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_attributes] = ACTIONS(643),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(545),
    [sym_comdat_ref] = ACTIONS(545),
    [sym_global_var] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [aux_sym_metadata_ref_token1] = ACTIONS(545),
    [sym_summary_ref] = ACTIONS(545),
    [sym_string] = ACTIONS(545),
    [anon_sym_target] = ACTIONS(545),
    [anon_sym_source_filename] = ACTIONS(545),
    [anon_sym_declare] = ACTIONS(545),
    [anon_sym_define] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(545),
    [anon_sym_half] = ACTIONS(545),
    [anon_sym_bfloat] = ACTIONS(545),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_double] = ACTIONS(545),
    [anon_sym_x86_fp80] = ACTIONS(545),
    [anon_sym_fp128] = ACTIONS(545),
    [anon_sym_ppc_fp128] = ACTIONS(545),
    [anon_sym_label] = ACTIONS(545),
    [anon_sym_metadata] = ACTIONS(545),
    [anon_sym_x86_mmx] = ACTIONS(545),
    [anon_sym_x86_amx] = ACTIONS(545),
    [anon_sym_token] = ACTIONS(545),
    [anon_sym_opaque] = ACTIONS(545),
    [anon_sym_ptr] = ACTIONS(545),
    [aux_sym_type_keyword_token1] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LT_LBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_section] = ACTIONS(545),
    [anon_sym_partition] = ACTIONS(545),
    [anon_sym_comdat] = ACTIONS(545),
    [anon_sym_gc] = ACTIONS(545),
    [anon_sym_prefix] = ACTIONS(545),
    [anon_sym_prologue] = ACTIONS(545),
    [anon_sym_personality] = ACTIONS(545),
    [anon_sym_alignstack] = ACTIONS(545),
    [anon_sym_allocsize] = ACTIONS(545),
    [anon_sym_alwaysinline] = ACTIONS(545),
    [anon_sym_builtin] = ACTIONS(545),
    [anon_sym_cold] = ACTIONS(545),
    [anon_sym_convergent] = ACTIONS(545),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(545),
    [anon_sym_hot] = ACTIONS(545),
    [anon_sym_inaccessiblememonly] = ACTIONS(545),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(545),
    [anon_sym_inlinehint] = ACTIONS(545),
    [anon_sym_jumptable] = ACTIONS(545),
    [anon_sym_minsize] = ACTIONS(545),
    [anon_sym_naked] = ACTIONS(545),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(545),
    [anon_sym_nobuiltin] = ACTIONS(545),
    [anon_sym_noduplicate] = ACTIONS(545),
    [anon_sym_nofree] = ACTIONS(545),
    [anon_sym_noimplicitfloat] = ACTIONS(545),
    [anon_sym_noinline] = ACTIONS(545),
    [anon_sym_nomerge] = ACTIONS(545),
    [anon_sym_nonlazybind] = ACTIONS(545),
    [anon_sym_noprofile] = ACTIONS(545),
    [anon_sym_noredzone] = ACTIONS(545),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(545),
    [anon_sym_noreturn] = ACTIONS(545),
    [anon_sym_norecurse] = ACTIONS(545),
    [anon_sym_willreturn] = ACTIONS(545),
    [anon_sym_nosync] = ACTIONS(545),
    [anon_sym_nounwind] = ACTIONS(545),
    [anon_sym_nosanitize_coverage] = ACTIONS(545),
    [anon_sym_null_pointer_is_valid] = ACTIONS(545),
    [anon_sym_optforfuzzing] = ACTIONS(545),
    [anon_sym_optnone] = ACTIONS(545),
    [anon_sym_optsize] = ACTIONS(545),
    [anon_sym_readnone] = ACTIONS(545),
    [anon_sym_readonly] = ACTIONS(545),
    [anon_sym_writeonly] = ACTIONS(545),
    [anon_sym_argmemonly] = ACTIONS(545),
    [anon_sym_returns_twice] = ACTIONS(545),
    [anon_sym_safestack] = ACTIONS(545),
    [anon_sym_sanitize_address] = ACTIONS(545),
    [anon_sym_sanitize_memory] = ACTIONS(545),
    [anon_sym_sanitize_thread] = ACTIONS(545),
    [anon_sym_sanitize_hwaddress] = ACTIONS(545),
    [anon_sym_sanitize_memtag] = ACTIONS(545),
    [anon_sym_speculative_load_hardening] = ACTIONS(545),
    [anon_sym_speculatable] = ACTIONS(545),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(545),
    [anon_sym_sspreq] = ACTIONS(545),
    [anon_sym_strictfp] = ACTIONS(545),
    [anon_sym_uwtable] = ACTIONS(545),
    [anon_sym_nocf_check] = ACTIONS(545),
    [anon_sym_shadowcallstack] = ACTIONS(545),
    [anon_sym_mustprogress] = ACTIONS(545),
    [anon_sym_vscale_range] = ACTIONS(545),
    [anon_sym_preallocated] = ACTIONS(545),
    [anon_sym_zeroext] = ACTIONS(545),
    [anon_sym_signext] = ACTIONS(545),
    [anon_sym_inreg] = ACTIONS(545),
    [anon_sym_byval] = ACTIONS(545),
    [anon_sym_byref] = ACTIONS(545),
    [anon_sym_inalloca] = ACTIONS(545),
    [anon_sym_sret] = ACTIONS(545),
    [anon_sym_elementtype] = ACTIONS(545),
    [anon_sym_noalias] = ACTIONS(545),
    [anon_sym_nocapture] = ACTIONS(545),
    [anon_sym_nest] = ACTIONS(545),
    [anon_sym_returned] = ACTIONS(545),
    [anon_sym_nonnull] = ACTIONS(545),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(545),
    [anon_sym_swiftself] = ACTIONS(545),
    [anon_sym_swiftasync] = ACTIONS(545),
    [anon_sym_swifterror] = ACTIONS(545),
    [anon_sym_immarg] = ACTIONS(545),
    [anon_sym_noundef] = ACTIONS(545),
    [anon_sym_to] = ACTIONS(547),
    [anon_sym_uselistorder] = ACTIONS(547),
    [anon_sym_uselistorder_bb] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_attributes] = ACTIONS(545),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(513),
    [sym_comdat_ref] = ACTIONS(513),
    [sym_global_var] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [aux_sym_metadata_ref_token1] = ACTIONS(513),
    [sym_summary_ref] = ACTIONS(513),
    [sym_string] = ACTIONS(513),
    [anon_sym_target] = ACTIONS(513),
    [anon_sym_source_filename] = ACTIONS(513),
    [anon_sym_declare] = ACTIONS(513),
    [anon_sym_define] = ACTIONS(513),
    [anon_sym_void] = ACTIONS(513),
    [anon_sym_half] = ACTIONS(513),
    [anon_sym_bfloat] = ACTIONS(513),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_double] = ACTIONS(513),
    [anon_sym_x86_fp80] = ACTIONS(513),
    [anon_sym_fp128] = ACTIONS(513),
    [anon_sym_ppc_fp128] = ACTIONS(513),
    [anon_sym_label] = ACTIONS(513),
    [anon_sym_metadata] = ACTIONS(513),
    [anon_sym_x86_mmx] = ACTIONS(513),
    [anon_sym_x86_amx] = ACTIONS(513),
    [anon_sym_token] = ACTIONS(513),
    [anon_sym_opaque] = ACTIONS(513),
    [anon_sym_ptr] = ACTIONS(513),
    [aux_sym_type_keyword_token1] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LT_LBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_section] = ACTIONS(513),
    [anon_sym_partition] = ACTIONS(513),
    [anon_sym_comdat] = ACTIONS(513),
    [anon_sym_gc] = ACTIONS(513),
    [anon_sym_prefix] = ACTIONS(513),
    [anon_sym_prologue] = ACTIONS(513),
    [anon_sym_personality] = ACTIONS(513),
    [anon_sym_alignstack] = ACTIONS(513),
    [anon_sym_allocsize] = ACTIONS(513),
    [anon_sym_alwaysinline] = ACTIONS(513),
    [anon_sym_builtin] = ACTIONS(513),
    [anon_sym_cold] = ACTIONS(513),
    [anon_sym_convergent] = ACTIONS(513),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(513),
    [anon_sym_hot] = ACTIONS(513),
    [anon_sym_inaccessiblememonly] = ACTIONS(513),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(513),
    [anon_sym_inlinehint] = ACTIONS(513),
    [anon_sym_jumptable] = ACTIONS(513),
    [anon_sym_minsize] = ACTIONS(513),
    [anon_sym_naked] = ACTIONS(513),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(513),
    [anon_sym_nobuiltin] = ACTIONS(513),
    [anon_sym_noduplicate] = ACTIONS(513),
    [anon_sym_nofree] = ACTIONS(513),
    [anon_sym_noimplicitfloat] = ACTIONS(513),
    [anon_sym_noinline] = ACTIONS(513),
    [anon_sym_nomerge] = ACTIONS(513),
    [anon_sym_nonlazybind] = ACTIONS(513),
    [anon_sym_noprofile] = ACTIONS(513),
    [anon_sym_noredzone] = ACTIONS(513),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(513),
    [anon_sym_noreturn] = ACTIONS(513),
    [anon_sym_norecurse] = ACTIONS(513),
    [anon_sym_willreturn] = ACTIONS(513),
    [anon_sym_nosync] = ACTIONS(513),
    [anon_sym_nounwind] = ACTIONS(513),
    [anon_sym_nosanitize_coverage] = ACTIONS(513),
    [anon_sym_null_pointer_is_valid] = ACTIONS(513),
    [anon_sym_optforfuzzing] = ACTIONS(513),
    [anon_sym_optnone] = ACTIONS(513),
    [anon_sym_optsize] = ACTIONS(513),
    [anon_sym_readnone] = ACTIONS(513),
    [anon_sym_readonly] = ACTIONS(513),
    [anon_sym_writeonly] = ACTIONS(513),
    [anon_sym_argmemonly] = ACTIONS(513),
    [anon_sym_returns_twice] = ACTIONS(513),
    [anon_sym_safestack] = ACTIONS(513),
    [anon_sym_sanitize_address] = ACTIONS(513),
    [anon_sym_sanitize_memory] = ACTIONS(513),
    [anon_sym_sanitize_thread] = ACTIONS(513),
    [anon_sym_sanitize_hwaddress] = ACTIONS(513),
    [anon_sym_sanitize_memtag] = ACTIONS(513),
    [anon_sym_speculative_load_hardening] = ACTIONS(513),
    [anon_sym_speculatable] = ACTIONS(513),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(513),
    [anon_sym_sspreq] = ACTIONS(513),
    [anon_sym_strictfp] = ACTIONS(513),
    [anon_sym_uwtable] = ACTIONS(513),
    [anon_sym_nocf_check] = ACTIONS(513),
    [anon_sym_shadowcallstack] = ACTIONS(513),
    [anon_sym_mustprogress] = ACTIONS(513),
    [anon_sym_vscale_range] = ACTIONS(513),
    [anon_sym_preallocated] = ACTIONS(513),
    [anon_sym_zeroext] = ACTIONS(513),
    [anon_sym_signext] = ACTIONS(513),
    [anon_sym_inreg] = ACTIONS(513),
    [anon_sym_byval] = ACTIONS(513),
    [anon_sym_byref] = ACTIONS(513),
    [anon_sym_inalloca] = ACTIONS(513),
    [anon_sym_sret] = ACTIONS(513),
    [anon_sym_elementtype] = ACTIONS(513),
    [anon_sym_noalias] = ACTIONS(513),
    [anon_sym_nocapture] = ACTIONS(513),
    [anon_sym_nest] = ACTIONS(513),
    [anon_sym_returned] = ACTIONS(513),
    [anon_sym_nonnull] = ACTIONS(513),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(513),
    [anon_sym_swiftself] = ACTIONS(513),
    [anon_sym_swiftasync] = ACTIONS(513),
    [anon_sym_swifterror] = ACTIONS(513),
    [anon_sym_immarg] = ACTIONS(513),
    [anon_sym_noundef] = ACTIONS(513),
    [anon_sym_to] = ACTIONS(515),
    [anon_sym_uselistorder] = ACTIONS(515),
    [anon_sym_uselistorder_bb] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_attributes] = ACTIONS(513),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(639),
    [sym_comdat_ref] = ACTIONS(639),
    [sym_global_var] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [aux_sym_metadata_ref_token1] = ACTIONS(639),
    [sym_summary_ref] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [anon_sym_target] = ACTIONS(639),
    [anon_sym_source_filename] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(639),
    [anon_sym_define] = ACTIONS(639),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_half] = ACTIONS(639),
    [anon_sym_bfloat] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(639),
    [anon_sym_double] = ACTIONS(639),
    [anon_sym_x86_fp80] = ACTIONS(639),
    [anon_sym_fp128] = ACTIONS(639),
    [anon_sym_ppc_fp128] = ACTIONS(639),
    [anon_sym_label] = ACTIONS(639),
    [anon_sym_metadata] = ACTIONS(639),
    [anon_sym_x86_mmx] = ACTIONS(639),
    [anon_sym_x86_amx] = ACTIONS(639),
    [anon_sym_token] = ACTIONS(639),
    [anon_sym_opaque] = ACTIONS(639),
    [anon_sym_ptr] = ACTIONS(639),
    [aux_sym_type_keyword_token1] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LT_LBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_section] = ACTIONS(639),
    [anon_sym_partition] = ACTIONS(639),
    [anon_sym_comdat] = ACTIONS(639),
    [anon_sym_gc] = ACTIONS(639),
    [anon_sym_prefix] = ACTIONS(639),
    [anon_sym_prologue] = ACTIONS(639),
    [anon_sym_personality] = ACTIONS(639),
    [anon_sym_alignstack] = ACTIONS(639),
    [anon_sym_allocsize] = ACTIONS(639),
    [anon_sym_alwaysinline] = ACTIONS(639),
    [anon_sym_builtin] = ACTIONS(639),
    [anon_sym_cold] = ACTIONS(639),
    [anon_sym_convergent] = ACTIONS(639),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(639),
    [anon_sym_hot] = ACTIONS(639),
    [anon_sym_inaccessiblememonly] = ACTIONS(639),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(639),
    [anon_sym_inlinehint] = ACTIONS(639),
    [anon_sym_jumptable] = ACTIONS(639),
    [anon_sym_minsize] = ACTIONS(639),
    [anon_sym_naked] = ACTIONS(639),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(639),
    [anon_sym_nobuiltin] = ACTIONS(639),
    [anon_sym_noduplicate] = ACTIONS(639),
    [anon_sym_nofree] = ACTIONS(639),
    [anon_sym_noimplicitfloat] = ACTIONS(639),
    [anon_sym_noinline] = ACTIONS(639),
    [anon_sym_nomerge] = ACTIONS(639),
    [anon_sym_nonlazybind] = ACTIONS(639),
    [anon_sym_noprofile] = ACTIONS(639),
    [anon_sym_noredzone] = ACTIONS(639),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(639),
    [anon_sym_noreturn] = ACTIONS(639),
    [anon_sym_norecurse] = ACTIONS(639),
    [anon_sym_willreturn] = ACTIONS(639),
    [anon_sym_nosync] = ACTIONS(639),
    [anon_sym_nounwind] = ACTIONS(639),
    [anon_sym_nosanitize_coverage] = ACTIONS(639),
    [anon_sym_null_pointer_is_valid] = ACTIONS(639),
    [anon_sym_optforfuzzing] = ACTIONS(639),
    [anon_sym_optnone] = ACTIONS(639),
    [anon_sym_optsize] = ACTIONS(639),
    [anon_sym_readnone] = ACTIONS(639),
    [anon_sym_readonly] = ACTIONS(639),
    [anon_sym_writeonly] = ACTIONS(639),
    [anon_sym_argmemonly] = ACTIONS(639),
    [anon_sym_returns_twice] = ACTIONS(639),
    [anon_sym_safestack] = ACTIONS(639),
    [anon_sym_sanitize_address] = ACTIONS(639),
    [anon_sym_sanitize_memory] = ACTIONS(639),
    [anon_sym_sanitize_thread] = ACTIONS(639),
    [anon_sym_sanitize_hwaddress] = ACTIONS(639),
    [anon_sym_sanitize_memtag] = ACTIONS(639),
    [anon_sym_speculative_load_hardening] = ACTIONS(639),
    [anon_sym_speculatable] = ACTIONS(639),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(639),
    [anon_sym_sspreq] = ACTIONS(639),
    [anon_sym_strictfp] = ACTIONS(639),
    [anon_sym_uwtable] = ACTIONS(639),
    [anon_sym_nocf_check] = ACTIONS(639),
    [anon_sym_shadowcallstack] = ACTIONS(639),
    [anon_sym_mustprogress] = ACTIONS(639),
    [anon_sym_vscale_range] = ACTIONS(639),
    [anon_sym_preallocated] = ACTIONS(639),
    [anon_sym_zeroext] = ACTIONS(639),
    [anon_sym_signext] = ACTIONS(639),
    [anon_sym_inreg] = ACTIONS(639),
    [anon_sym_byval] = ACTIONS(639),
    [anon_sym_byref] = ACTIONS(639),
    [anon_sym_inalloca] = ACTIONS(639),
    [anon_sym_sret] = ACTIONS(639),
    [anon_sym_elementtype] = ACTIONS(639),
    [anon_sym_noalias] = ACTIONS(639),
    [anon_sym_nocapture] = ACTIONS(639),
    [anon_sym_nest] = ACTIONS(639),
    [anon_sym_returned] = ACTIONS(639),
    [anon_sym_nonnull] = ACTIONS(639),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(639),
    [anon_sym_swiftself] = ACTIONS(639),
    [anon_sym_swiftasync] = ACTIONS(639),
    [anon_sym_swifterror] = ACTIONS(639),
    [anon_sym_immarg] = ACTIONS(639),
    [anon_sym_noundef] = ACTIONS(639),
    [anon_sym_to] = ACTIONS(641),
    [anon_sym_uselistorder] = ACTIONS(641),
    [anon_sym_uselistorder_bb] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(639),
    [anon_sym_attributes] = ACTIONS(639),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(521),
    [sym_comdat_ref] = ACTIONS(521),
    [sym_global_var] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [aux_sym_metadata_ref_token1] = ACTIONS(521),
    [sym_summary_ref] = ACTIONS(521),
    [sym_string] = ACTIONS(521),
    [anon_sym_target] = ACTIONS(521),
    [anon_sym_source_filename] = ACTIONS(521),
    [anon_sym_declare] = ACTIONS(521),
    [anon_sym_define] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(521),
    [anon_sym_half] = ACTIONS(521),
    [anon_sym_bfloat] = ACTIONS(521),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_double] = ACTIONS(521),
    [anon_sym_x86_fp80] = ACTIONS(521),
    [anon_sym_fp128] = ACTIONS(521),
    [anon_sym_ppc_fp128] = ACTIONS(521),
    [anon_sym_label] = ACTIONS(521),
    [anon_sym_metadata] = ACTIONS(521),
    [anon_sym_x86_mmx] = ACTIONS(521),
    [anon_sym_x86_amx] = ACTIONS(521),
    [anon_sym_token] = ACTIONS(521),
    [anon_sym_opaque] = ACTIONS(521),
    [anon_sym_ptr] = ACTIONS(521),
    [aux_sym_type_keyword_token1] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LT_LBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_section] = ACTIONS(521),
    [anon_sym_partition] = ACTIONS(521),
    [anon_sym_comdat] = ACTIONS(521),
    [anon_sym_gc] = ACTIONS(521),
    [anon_sym_prefix] = ACTIONS(521),
    [anon_sym_prologue] = ACTIONS(521),
    [anon_sym_personality] = ACTIONS(521),
    [anon_sym_alignstack] = ACTIONS(521),
    [anon_sym_allocsize] = ACTIONS(521),
    [anon_sym_alwaysinline] = ACTIONS(521),
    [anon_sym_builtin] = ACTIONS(521),
    [anon_sym_cold] = ACTIONS(521),
    [anon_sym_convergent] = ACTIONS(521),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(521),
    [anon_sym_hot] = ACTIONS(521),
    [anon_sym_inaccessiblememonly] = ACTIONS(521),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(521),
    [anon_sym_inlinehint] = ACTIONS(521),
    [anon_sym_jumptable] = ACTIONS(521),
    [anon_sym_minsize] = ACTIONS(521),
    [anon_sym_naked] = ACTIONS(521),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(521),
    [anon_sym_nobuiltin] = ACTIONS(521),
    [anon_sym_noduplicate] = ACTIONS(521),
    [anon_sym_nofree] = ACTIONS(521),
    [anon_sym_noimplicitfloat] = ACTIONS(521),
    [anon_sym_noinline] = ACTIONS(521),
    [anon_sym_nomerge] = ACTIONS(521),
    [anon_sym_nonlazybind] = ACTIONS(521),
    [anon_sym_noprofile] = ACTIONS(521),
    [anon_sym_noredzone] = ACTIONS(521),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(521),
    [anon_sym_noreturn] = ACTIONS(521),
    [anon_sym_norecurse] = ACTIONS(521),
    [anon_sym_willreturn] = ACTIONS(521),
    [anon_sym_nosync] = ACTIONS(521),
    [anon_sym_nounwind] = ACTIONS(521),
    [anon_sym_nosanitize_coverage] = ACTIONS(521),
    [anon_sym_null_pointer_is_valid] = ACTIONS(521),
    [anon_sym_optforfuzzing] = ACTIONS(521),
    [anon_sym_optnone] = ACTIONS(521),
    [anon_sym_optsize] = ACTIONS(521),
    [anon_sym_readnone] = ACTIONS(521),
    [anon_sym_readonly] = ACTIONS(521),
    [anon_sym_writeonly] = ACTIONS(521),
    [anon_sym_argmemonly] = ACTIONS(521),
    [anon_sym_returns_twice] = ACTIONS(521),
    [anon_sym_safestack] = ACTIONS(521),
    [anon_sym_sanitize_address] = ACTIONS(521),
    [anon_sym_sanitize_memory] = ACTIONS(521),
    [anon_sym_sanitize_thread] = ACTIONS(521),
    [anon_sym_sanitize_hwaddress] = ACTIONS(521),
    [anon_sym_sanitize_memtag] = ACTIONS(521),
    [anon_sym_speculative_load_hardening] = ACTIONS(521),
    [anon_sym_speculatable] = ACTIONS(521),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(521),
    [anon_sym_sspreq] = ACTIONS(521),
    [anon_sym_strictfp] = ACTIONS(521),
    [anon_sym_uwtable] = ACTIONS(521),
    [anon_sym_nocf_check] = ACTIONS(521),
    [anon_sym_shadowcallstack] = ACTIONS(521),
    [anon_sym_mustprogress] = ACTIONS(521),
    [anon_sym_vscale_range] = ACTIONS(521),
    [anon_sym_preallocated] = ACTIONS(521),
    [anon_sym_zeroext] = ACTIONS(521),
    [anon_sym_signext] = ACTIONS(521),
    [anon_sym_inreg] = ACTIONS(521),
    [anon_sym_byval] = ACTIONS(521),
    [anon_sym_byref] = ACTIONS(521),
    [anon_sym_inalloca] = ACTIONS(521),
    [anon_sym_sret] = ACTIONS(521),
    [anon_sym_elementtype] = ACTIONS(521),
    [anon_sym_noalias] = ACTIONS(521),
    [anon_sym_nocapture] = ACTIONS(521),
    [anon_sym_nest] = ACTIONS(521),
    [anon_sym_returned] = ACTIONS(521),
    [anon_sym_nonnull] = ACTIONS(521),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(521),
    [anon_sym_swiftself] = ACTIONS(521),
    [anon_sym_swiftasync] = ACTIONS(521),
    [anon_sym_swifterror] = ACTIONS(521),
    [anon_sym_immarg] = ACTIONS(521),
    [anon_sym_noundef] = ACTIONS(521),
    [anon_sym_to] = ACTIONS(523),
    [anon_sym_uselistorder] = ACTIONS(523),
    [anon_sym_uselistorder_bb] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_attributes] = ACTIONS(521),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(627),
    [sym_comdat_ref] = ACTIONS(627),
    [sym_global_var] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [aux_sym_metadata_ref_token1] = ACTIONS(627),
    [sym_summary_ref] = ACTIONS(627),
    [sym_string] = ACTIONS(627),
    [anon_sym_target] = ACTIONS(627),
    [anon_sym_source_filename] = ACTIONS(627),
    [anon_sym_declare] = ACTIONS(627),
    [anon_sym_define] = ACTIONS(627),
    [anon_sym_void] = ACTIONS(627),
    [anon_sym_half] = ACTIONS(627),
    [anon_sym_bfloat] = ACTIONS(627),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_double] = ACTIONS(627),
    [anon_sym_x86_fp80] = ACTIONS(627),
    [anon_sym_fp128] = ACTIONS(627),
    [anon_sym_ppc_fp128] = ACTIONS(627),
    [anon_sym_label] = ACTIONS(627),
    [anon_sym_metadata] = ACTIONS(627),
    [anon_sym_x86_mmx] = ACTIONS(627),
    [anon_sym_x86_amx] = ACTIONS(627),
    [anon_sym_token] = ACTIONS(627),
    [anon_sym_opaque] = ACTIONS(627),
    [anon_sym_ptr] = ACTIONS(627),
    [aux_sym_type_keyword_token1] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LT_LBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_section] = ACTIONS(627),
    [anon_sym_partition] = ACTIONS(627),
    [anon_sym_comdat] = ACTIONS(627),
    [anon_sym_gc] = ACTIONS(627),
    [anon_sym_prefix] = ACTIONS(627),
    [anon_sym_prologue] = ACTIONS(627),
    [anon_sym_personality] = ACTIONS(627),
    [anon_sym_alignstack] = ACTIONS(627),
    [anon_sym_allocsize] = ACTIONS(627),
    [anon_sym_alwaysinline] = ACTIONS(627),
    [anon_sym_builtin] = ACTIONS(627),
    [anon_sym_cold] = ACTIONS(627),
    [anon_sym_convergent] = ACTIONS(627),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(627),
    [anon_sym_hot] = ACTIONS(627),
    [anon_sym_inaccessiblememonly] = ACTIONS(627),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(627),
    [anon_sym_inlinehint] = ACTIONS(627),
    [anon_sym_jumptable] = ACTIONS(627),
    [anon_sym_minsize] = ACTIONS(627),
    [anon_sym_naked] = ACTIONS(627),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(627),
    [anon_sym_nobuiltin] = ACTIONS(627),
    [anon_sym_noduplicate] = ACTIONS(627),
    [anon_sym_nofree] = ACTIONS(627),
    [anon_sym_noimplicitfloat] = ACTIONS(627),
    [anon_sym_noinline] = ACTIONS(627),
    [anon_sym_nomerge] = ACTIONS(627),
    [anon_sym_nonlazybind] = ACTIONS(627),
    [anon_sym_noprofile] = ACTIONS(627),
    [anon_sym_noredzone] = ACTIONS(627),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(627),
    [anon_sym_noreturn] = ACTIONS(627),
    [anon_sym_norecurse] = ACTIONS(627),
    [anon_sym_willreturn] = ACTIONS(627),
    [anon_sym_nosync] = ACTIONS(627),
    [anon_sym_nounwind] = ACTIONS(627),
    [anon_sym_nosanitize_coverage] = ACTIONS(627),
    [anon_sym_null_pointer_is_valid] = ACTIONS(627),
    [anon_sym_optforfuzzing] = ACTIONS(627),
    [anon_sym_optnone] = ACTIONS(627),
    [anon_sym_optsize] = ACTIONS(627),
    [anon_sym_readnone] = ACTIONS(627),
    [anon_sym_readonly] = ACTIONS(627),
    [anon_sym_writeonly] = ACTIONS(627),
    [anon_sym_argmemonly] = ACTIONS(627),
    [anon_sym_returns_twice] = ACTIONS(627),
    [anon_sym_safestack] = ACTIONS(627),
    [anon_sym_sanitize_address] = ACTIONS(627),
    [anon_sym_sanitize_memory] = ACTIONS(627),
    [anon_sym_sanitize_thread] = ACTIONS(627),
    [anon_sym_sanitize_hwaddress] = ACTIONS(627),
    [anon_sym_sanitize_memtag] = ACTIONS(627),
    [anon_sym_speculative_load_hardening] = ACTIONS(627),
    [anon_sym_speculatable] = ACTIONS(627),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(627),
    [anon_sym_sspreq] = ACTIONS(627),
    [anon_sym_strictfp] = ACTIONS(627),
    [anon_sym_uwtable] = ACTIONS(627),
    [anon_sym_nocf_check] = ACTIONS(627),
    [anon_sym_shadowcallstack] = ACTIONS(627),
    [anon_sym_mustprogress] = ACTIONS(627),
    [anon_sym_vscale_range] = ACTIONS(627),
    [anon_sym_preallocated] = ACTIONS(627),
    [anon_sym_zeroext] = ACTIONS(627),
    [anon_sym_signext] = ACTIONS(627),
    [anon_sym_inreg] = ACTIONS(627),
    [anon_sym_byval] = ACTIONS(627),
    [anon_sym_byref] = ACTIONS(627),
    [anon_sym_inalloca] = ACTIONS(627),
    [anon_sym_sret] = ACTIONS(627),
    [anon_sym_elementtype] = ACTIONS(627),
    [anon_sym_noalias] = ACTIONS(627),
    [anon_sym_nocapture] = ACTIONS(627),
    [anon_sym_nest] = ACTIONS(627),
    [anon_sym_returned] = ACTIONS(627),
    [anon_sym_nonnull] = ACTIONS(627),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(627),
    [anon_sym_swiftself] = ACTIONS(627),
    [anon_sym_swiftasync] = ACTIONS(627),
    [anon_sym_swifterror] = ACTIONS(627),
    [anon_sym_immarg] = ACTIONS(627),
    [anon_sym_noundef] = ACTIONS(627),
    [anon_sym_to] = ACTIONS(629),
    [anon_sym_uselistorder] = ACTIONS(629),
    [anon_sym_uselistorder_bb] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(627),
    [anon_sym_attributes] = ACTIONS(627),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(667),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(667),
    [anon_sym_x86_amx] = ACTIONS(667),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(667),
    [anon_sym_partition] = ACTIONS(667),
    [anon_sym_comdat] = ACTIONS(667),
    [anon_sym_gc] = ACTIONS(667),
    [anon_sym_prefix] = ACTIONS(667),
    [anon_sym_prologue] = ACTIONS(667),
    [anon_sym_personality] = ACTIONS(667),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(667),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(667),
    [anon_sym_swiftasync] = ACTIONS(667),
    [anon_sym_swifterror] = ACTIONS(667),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(623),
    [sym_comdat_ref] = ACTIONS(623),
    [sym_global_var] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [aux_sym_metadata_ref_token1] = ACTIONS(623),
    [sym_summary_ref] = ACTIONS(623),
    [sym_string] = ACTIONS(623),
    [anon_sym_target] = ACTIONS(623),
    [anon_sym_source_filename] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_define] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(623),
    [anon_sym_half] = ACTIONS(623),
    [anon_sym_bfloat] = ACTIONS(623),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_double] = ACTIONS(623),
    [anon_sym_x86_fp80] = ACTIONS(623),
    [anon_sym_fp128] = ACTIONS(623),
    [anon_sym_ppc_fp128] = ACTIONS(623),
    [anon_sym_label] = ACTIONS(623),
    [anon_sym_metadata] = ACTIONS(623),
    [anon_sym_x86_mmx] = ACTIONS(623),
    [anon_sym_x86_amx] = ACTIONS(623),
    [anon_sym_token] = ACTIONS(623),
    [anon_sym_opaque] = ACTIONS(623),
    [anon_sym_ptr] = ACTIONS(623),
    [aux_sym_type_keyword_token1] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LT_LBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_section] = ACTIONS(623),
    [anon_sym_partition] = ACTIONS(623),
    [anon_sym_comdat] = ACTIONS(623),
    [anon_sym_gc] = ACTIONS(623),
    [anon_sym_prefix] = ACTIONS(623),
    [anon_sym_prologue] = ACTIONS(623),
    [anon_sym_personality] = ACTIONS(623),
    [anon_sym_alignstack] = ACTIONS(623),
    [anon_sym_allocsize] = ACTIONS(623),
    [anon_sym_alwaysinline] = ACTIONS(623),
    [anon_sym_builtin] = ACTIONS(623),
    [anon_sym_cold] = ACTIONS(623),
    [anon_sym_convergent] = ACTIONS(623),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(623),
    [anon_sym_hot] = ACTIONS(623),
    [anon_sym_inaccessiblememonly] = ACTIONS(623),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(623),
    [anon_sym_inlinehint] = ACTIONS(623),
    [anon_sym_jumptable] = ACTIONS(623),
    [anon_sym_minsize] = ACTIONS(623),
    [anon_sym_naked] = ACTIONS(623),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(623),
    [anon_sym_nobuiltin] = ACTIONS(623),
    [anon_sym_noduplicate] = ACTIONS(623),
    [anon_sym_nofree] = ACTIONS(623),
    [anon_sym_noimplicitfloat] = ACTIONS(623),
    [anon_sym_noinline] = ACTIONS(623),
    [anon_sym_nomerge] = ACTIONS(623),
    [anon_sym_nonlazybind] = ACTIONS(623),
    [anon_sym_noprofile] = ACTIONS(623),
    [anon_sym_noredzone] = ACTIONS(623),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(623),
    [anon_sym_noreturn] = ACTIONS(623),
    [anon_sym_norecurse] = ACTIONS(623),
    [anon_sym_willreturn] = ACTIONS(623),
    [anon_sym_nosync] = ACTIONS(623),
    [anon_sym_nounwind] = ACTIONS(623),
    [anon_sym_nosanitize_coverage] = ACTIONS(623),
    [anon_sym_null_pointer_is_valid] = ACTIONS(623),
    [anon_sym_optforfuzzing] = ACTIONS(623),
    [anon_sym_optnone] = ACTIONS(623),
    [anon_sym_optsize] = ACTIONS(623),
    [anon_sym_readnone] = ACTIONS(623),
    [anon_sym_readonly] = ACTIONS(623),
    [anon_sym_writeonly] = ACTIONS(623),
    [anon_sym_argmemonly] = ACTIONS(623),
    [anon_sym_returns_twice] = ACTIONS(623),
    [anon_sym_safestack] = ACTIONS(623),
    [anon_sym_sanitize_address] = ACTIONS(623),
    [anon_sym_sanitize_memory] = ACTIONS(623),
    [anon_sym_sanitize_thread] = ACTIONS(623),
    [anon_sym_sanitize_hwaddress] = ACTIONS(623),
    [anon_sym_sanitize_memtag] = ACTIONS(623),
    [anon_sym_speculative_load_hardening] = ACTIONS(623),
    [anon_sym_speculatable] = ACTIONS(623),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(623),
    [anon_sym_sspreq] = ACTIONS(623),
    [anon_sym_strictfp] = ACTIONS(623),
    [anon_sym_uwtable] = ACTIONS(623),
    [anon_sym_nocf_check] = ACTIONS(623),
    [anon_sym_shadowcallstack] = ACTIONS(623),
    [anon_sym_mustprogress] = ACTIONS(623),
    [anon_sym_vscale_range] = ACTIONS(623),
    [anon_sym_preallocated] = ACTIONS(623),
    [anon_sym_zeroext] = ACTIONS(623),
    [anon_sym_signext] = ACTIONS(623),
    [anon_sym_inreg] = ACTIONS(623),
    [anon_sym_byval] = ACTIONS(623),
    [anon_sym_byref] = ACTIONS(623),
    [anon_sym_inalloca] = ACTIONS(623),
    [anon_sym_sret] = ACTIONS(623),
    [anon_sym_elementtype] = ACTIONS(623),
    [anon_sym_noalias] = ACTIONS(623),
    [anon_sym_nocapture] = ACTIONS(623),
    [anon_sym_nest] = ACTIONS(623),
    [anon_sym_returned] = ACTIONS(623),
    [anon_sym_nonnull] = ACTIONS(623),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(623),
    [anon_sym_swiftself] = ACTIONS(623),
    [anon_sym_swiftasync] = ACTIONS(623),
    [anon_sym_swifterror] = ACTIONS(623),
    [anon_sym_immarg] = ACTIONS(623),
    [anon_sym_noundef] = ACTIONS(623),
    [anon_sym_to] = ACTIONS(625),
    [anon_sym_uselistorder] = ACTIONS(625),
    [anon_sym_uselistorder_bb] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_attributes] = ACTIONS(623),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(619),
    [sym_comdat_ref] = ACTIONS(619),
    [sym_global_var] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [aux_sym_metadata_ref_token1] = ACTIONS(619),
    [sym_summary_ref] = ACTIONS(619),
    [sym_string] = ACTIONS(619),
    [anon_sym_target] = ACTIONS(619),
    [anon_sym_source_filename] = ACTIONS(619),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_define] = ACTIONS(619),
    [anon_sym_void] = ACTIONS(619),
    [anon_sym_half] = ACTIONS(619),
    [anon_sym_bfloat] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(619),
    [anon_sym_double] = ACTIONS(619),
    [anon_sym_x86_fp80] = ACTIONS(619),
    [anon_sym_fp128] = ACTIONS(619),
    [anon_sym_ppc_fp128] = ACTIONS(619),
    [anon_sym_label] = ACTIONS(619),
    [anon_sym_metadata] = ACTIONS(619),
    [anon_sym_x86_mmx] = ACTIONS(619),
    [anon_sym_x86_amx] = ACTIONS(619),
    [anon_sym_token] = ACTIONS(619),
    [anon_sym_opaque] = ACTIONS(619),
    [anon_sym_ptr] = ACTIONS(619),
    [aux_sym_type_keyword_token1] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LT_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_section] = ACTIONS(619),
    [anon_sym_partition] = ACTIONS(619),
    [anon_sym_comdat] = ACTIONS(619),
    [anon_sym_gc] = ACTIONS(619),
    [anon_sym_prefix] = ACTIONS(619),
    [anon_sym_prologue] = ACTIONS(619),
    [anon_sym_personality] = ACTIONS(619),
    [anon_sym_alignstack] = ACTIONS(619),
    [anon_sym_allocsize] = ACTIONS(619),
    [anon_sym_alwaysinline] = ACTIONS(619),
    [anon_sym_builtin] = ACTIONS(619),
    [anon_sym_cold] = ACTIONS(619),
    [anon_sym_convergent] = ACTIONS(619),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(619),
    [anon_sym_hot] = ACTIONS(619),
    [anon_sym_inaccessiblememonly] = ACTIONS(619),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(619),
    [anon_sym_inlinehint] = ACTIONS(619),
    [anon_sym_jumptable] = ACTIONS(619),
    [anon_sym_minsize] = ACTIONS(619),
    [anon_sym_naked] = ACTIONS(619),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(619),
    [anon_sym_nobuiltin] = ACTIONS(619),
    [anon_sym_noduplicate] = ACTIONS(619),
    [anon_sym_nofree] = ACTIONS(619),
    [anon_sym_noimplicitfloat] = ACTIONS(619),
    [anon_sym_noinline] = ACTIONS(619),
    [anon_sym_nomerge] = ACTIONS(619),
    [anon_sym_nonlazybind] = ACTIONS(619),
    [anon_sym_noprofile] = ACTIONS(619),
    [anon_sym_noredzone] = ACTIONS(619),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(619),
    [anon_sym_noreturn] = ACTIONS(619),
    [anon_sym_norecurse] = ACTIONS(619),
    [anon_sym_willreturn] = ACTIONS(619),
    [anon_sym_nosync] = ACTIONS(619),
    [anon_sym_nounwind] = ACTIONS(619),
    [anon_sym_nosanitize_coverage] = ACTIONS(619),
    [anon_sym_null_pointer_is_valid] = ACTIONS(619),
    [anon_sym_optforfuzzing] = ACTIONS(619),
    [anon_sym_optnone] = ACTIONS(619),
    [anon_sym_optsize] = ACTIONS(619),
    [anon_sym_readnone] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_writeonly] = ACTIONS(619),
    [anon_sym_argmemonly] = ACTIONS(619),
    [anon_sym_returns_twice] = ACTIONS(619),
    [anon_sym_safestack] = ACTIONS(619),
    [anon_sym_sanitize_address] = ACTIONS(619),
    [anon_sym_sanitize_memory] = ACTIONS(619),
    [anon_sym_sanitize_thread] = ACTIONS(619),
    [anon_sym_sanitize_hwaddress] = ACTIONS(619),
    [anon_sym_sanitize_memtag] = ACTIONS(619),
    [anon_sym_speculative_load_hardening] = ACTIONS(619),
    [anon_sym_speculatable] = ACTIONS(619),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(619),
    [anon_sym_sspreq] = ACTIONS(619),
    [anon_sym_strictfp] = ACTIONS(619),
    [anon_sym_uwtable] = ACTIONS(619),
    [anon_sym_nocf_check] = ACTIONS(619),
    [anon_sym_shadowcallstack] = ACTIONS(619),
    [anon_sym_mustprogress] = ACTIONS(619),
    [anon_sym_vscale_range] = ACTIONS(619),
    [anon_sym_preallocated] = ACTIONS(619),
    [anon_sym_zeroext] = ACTIONS(619),
    [anon_sym_signext] = ACTIONS(619),
    [anon_sym_inreg] = ACTIONS(619),
    [anon_sym_byval] = ACTIONS(619),
    [anon_sym_byref] = ACTIONS(619),
    [anon_sym_inalloca] = ACTIONS(619),
    [anon_sym_sret] = ACTIONS(619),
    [anon_sym_elementtype] = ACTIONS(619),
    [anon_sym_noalias] = ACTIONS(619),
    [anon_sym_nocapture] = ACTIONS(619),
    [anon_sym_nest] = ACTIONS(619),
    [anon_sym_returned] = ACTIONS(619),
    [anon_sym_nonnull] = ACTIONS(619),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(619),
    [anon_sym_swiftself] = ACTIONS(619),
    [anon_sym_swiftasync] = ACTIONS(619),
    [anon_sym_swifterror] = ACTIONS(619),
    [anon_sym_immarg] = ACTIONS(619),
    [anon_sym_noundef] = ACTIONS(619),
    [anon_sym_to] = ACTIONS(621),
    [anon_sym_uselistorder] = ACTIONS(621),
    [anon_sym_uselistorder_bb] = ACTIONS(619),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_attributes] = ACTIONS(619),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(525),
    [sym_comdat_ref] = ACTIONS(525),
    [sym_global_var] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [aux_sym_metadata_ref_token1] = ACTIONS(525),
    [sym_summary_ref] = ACTIONS(525),
    [sym_string] = ACTIONS(525),
    [anon_sym_target] = ACTIONS(525),
    [anon_sym_source_filename] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(525),
    [anon_sym_define] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_half] = ACTIONS(525),
    [anon_sym_bfloat] = ACTIONS(525),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_double] = ACTIONS(525),
    [anon_sym_x86_fp80] = ACTIONS(525),
    [anon_sym_fp128] = ACTIONS(525),
    [anon_sym_ppc_fp128] = ACTIONS(525),
    [anon_sym_label] = ACTIONS(525),
    [anon_sym_metadata] = ACTIONS(525),
    [anon_sym_x86_mmx] = ACTIONS(525),
    [anon_sym_x86_amx] = ACTIONS(525),
    [anon_sym_token] = ACTIONS(525),
    [anon_sym_opaque] = ACTIONS(525),
    [anon_sym_ptr] = ACTIONS(525),
    [aux_sym_type_keyword_token1] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LT_LBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_section] = ACTIONS(525),
    [anon_sym_partition] = ACTIONS(525),
    [anon_sym_comdat] = ACTIONS(525),
    [anon_sym_gc] = ACTIONS(525),
    [anon_sym_prefix] = ACTIONS(525),
    [anon_sym_prologue] = ACTIONS(525),
    [anon_sym_personality] = ACTIONS(525),
    [anon_sym_alignstack] = ACTIONS(525),
    [anon_sym_allocsize] = ACTIONS(525),
    [anon_sym_alwaysinline] = ACTIONS(525),
    [anon_sym_builtin] = ACTIONS(525),
    [anon_sym_cold] = ACTIONS(525),
    [anon_sym_convergent] = ACTIONS(525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(525),
    [anon_sym_hot] = ACTIONS(525),
    [anon_sym_inaccessiblememonly] = ACTIONS(525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(525),
    [anon_sym_inlinehint] = ACTIONS(525),
    [anon_sym_jumptable] = ACTIONS(525),
    [anon_sym_minsize] = ACTIONS(525),
    [anon_sym_naked] = ACTIONS(525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(525),
    [anon_sym_nobuiltin] = ACTIONS(525),
    [anon_sym_noduplicate] = ACTIONS(525),
    [anon_sym_nofree] = ACTIONS(525),
    [anon_sym_noimplicitfloat] = ACTIONS(525),
    [anon_sym_noinline] = ACTIONS(525),
    [anon_sym_nomerge] = ACTIONS(525),
    [anon_sym_nonlazybind] = ACTIONS(525),
    [anon_sym_noprofile] = ACTIONS(525),
    [anon_sym_noredzone] = ACTIONS(525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_norecurse] = ACTIONS(525),
    [anon_sym_willreturn] = ACTIONS(525),
    [anon_sym_nosync] = ACTIONS(525),
    [anon_sym_nounwind] = ACTIONS(525),
    [anon_sym_nosanitize_coverage] = ACTIONS(525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(525),
    [anon_sym_optforfuzzing] = ACTIONS(525),
    [anon_sym_optnone] = ACTIONS(525),
    [anon_sym_optsize] = ACTIONS(525),
    [anon_sym_readnone] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_writeonly] = ACTIONS(525),
    [anon_sym_argmemonly] = ACTIONS(525),
    [anon_sym_returns_twice] = ACTIONS(525),
    [anon_sym_safestack] = ACTIONS(525),
    [anon_sym_sanitize_address] = ACTIONS(525),
    [anon_sym_sanitize_memory] = ACTIONS(525),
    [anon_sym_sanitize_thread] = ACTIONS(525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(525),
    [anon_sym_sanitize_memtag] = ACTIONS(525),
    [anon_sym_speculative_load_hardening] = ACTIONS(525),
    [anon_sym_speculatable] = ACTIONS(525),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(525),
    [anon_sym_sspreq] = ACTIONS(525),
    [anon_sym_strictfp] = ACTIONS(525),
    [anon_sym_uwtable] = ACTIONS(525),
    [anon_sym_nocf_check] = ACTIONS(525),
    [anon_sym_shadowcallstack] = ACTIONS(525),
    [anon_sym_mustprogress] = ACTIONS(525),
    [anon_sym_vscale_range] = ACTIONS(525),
    [anon_sym_preallocated] = ACTIONS(525),
    [anon_sym_zeroext] = ACTIONS(525),
    [anon_sym_signext] = ACTIONS(525),
    [anon_sym_inreg] = ACTIONS(525),
    [anon_sym_byval] = ACTIONS(525),
    [anon_sym_byref] = ACTIONS(525),
    [anon_sym_inalloca] = ACTIONS(525),
    [anon_sym_sret] = ACTIONS(525),
    [anon_sym_elementtype] = ACTIONS(525),
    [anon_sym_noalias] = ACTIONS(525),
    [anon_sym_nocapture] = ACTIONS(525),
    [anon_sym_nest] = ACTIONS(525),
    [anon_sym_returned] = ACTIONS(525),
    [anon_sym_nonnull] = ACTIONS(525),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(525),
    [anon_sym_swiftself] = ACTIONS(525),
    [anon_sym_swiftasync] = ACTIONS(525),
    [anon_sym_swifterror] = ACTIONS(525),
    [anon_sym_immarg] = ACTIONS(525),
    [anon_sym_noundef] = ACTIONS(525),
    [anon_sym_to] = ACTIONS(527),
    [anon_sym_uselistorder] = ACTIONS(527),
    [anon_sym_uselistorder_bb] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_attributes] = ACTIONS(525),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(501),
    [sym_comdat_ref] = ACTIONS(501),
    [sym_global_var] = ACTIONS(501),
    [sym_local_var] = ACTIONS(501),
    [aux_sym_metadata_ref_token1] = ACTIONS(501),
    [sym_summary_ref] = ACTIONS(501),
    [sym_string] = ACTIONS(501),
    [anon_sym_target] = ACTIONS(501),
    [anon_sym_source_filename] = ACTIONS(501),
    [anon_sym_declare] = ACTIONS(501),
    [anon_sym_define] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(501),
    [anon_sym_half] = ACTIONS(501),
    [anon_sym_bfloat] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(501),
    [anon_sym_double] = ACTIONS(501),
    [anon_sym_x86_fp80] = ACTIONS(501),
    [anon_sym_fp128] = ACTIONS(501),
    [anon_sym_ppc_fp128] = ACTIONS(501),
    [anon_sym_label] = ACTIONS(501),
    [anon_sym_metadata] = ACTIONS(501),
    [anon_sym_x86_mmx] = ACTIONS(501),
    [anon_sym_x86_amx] = ACTIONS(501),
    [anon_sym_token] = ACTIONS(501),
    [anon_sym_opaque] = ACTIONS(501),
    [anon_sym_ptr] = ACTIONS(501),
    [aux_sym_type_keyword_token1] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LT_LBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_align] = ACTIONS(503),
    [anon_sym_section] = ACTIONS(501),
    [anon_sym_partition] = ACTIONS(501),
    [anon_sym_comdat] = ACTIONS(501),
    [anon_sym_gc] = ACTIONS(501),
    [anon_sym_prefix] = ACTIONS(501),
    [anon_sym_prologue] = ACTIONS(501),
    [anon_sym_personality] = ACTIONS(501),
    [anon_sym_alignstack] = ACTIONS(501),
    [anon_sym_allocsize] = ACTIONS(501),
    [anon_sym_alwaysinline] = ACTIONS(501),
    [anon_sym_builtin] = ACTIONS(501),
    [anon_sym_cold] = ACTIONS(501),
    [anon_sym_convergent] = ACTIONS(501),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(501),
    [anon_sym_hot] = ACTIONS(501),
    [anon_sym_inaccessiblememonly] = ACTIONS(501),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(501),
    [anon_sym_inlinehint] = ACTIONS(501),
    [anon_sym_jumptable] = ACTIONS(501),
    [anon_sym_minsize] = ACTIONS(501),
    [anon_sym_naked] = ACTIONS(501),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(501),
    [anon_sym_nobuiltin] = ACTIONS(501),
    [anon_sym_noduplicate] = ACTIONS(501),
    [anon_sym_nofree] = ACTIONS(501),
    [anon_sym_noimplicitfloat] = ACTIONS(501),
    [anon_sym_noinline] = ACTIONS(501),
    [anon_sym_nomerge] = ACTIONS(501),
    [anon_sym_nonlazybind] = ACTIONS(501),
    [anon_sym_noprofile] = ACTIONS(501),
    [anon_sym_noredzone] = ACTIONS(501),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(501),
    [anon_sym_noreturn] = ACTIONS(501),
    [anon_sym_norecurse] = ACTIONS(501),
    [anon_sym_willreturn] = ACTIONS(501),
    [anon_sym_nosync] = ACTIONS(501),
    [anon_sym_nounwind] = ACTIONS(501),
    [anon_sym_nosanitize_coverage] = ACTIONS(501),
    [anon_sym_null_pointer_is_valid] = ACTIONS(501),
    [anon_sym_optforfuzzing] = ACTIONS(501),
    [anon_sym_optnone] = ACTIONS(501),
    [anon_sym_optsize] = ACTIONS(501),
    [anon_sym_readnone] = ACTIONS(501),
    [anon_sym_readonly] = ACTIONS(501),
    [anon_sym_writeonly] = ACTIONS(501),
    [anon_sym_argmemonly] = ACTIONS(501),
    [anon_sym_returns_twice] = ACTIONS(501),
    [anon_sym_safestack] = ACTIONS(501),
    [anon_sym_sanitize_address] = ACTIONS(501),
    [anon_sym_sanitize_memory] = ACTIONS(501),
    [anon_sym_sanitize_thread] = ACTIONS(501),
    [anon_sym_sanitize_hwaddress] = ACTIONS(501),
    [anon_sym_sanitize_memtag] = ACTIONS(501),
    [anon_sym_speculative_load_hardening] = ACTIONS(501),
    [anon_sym_speculatable] = ACTIONS(501),
    [anon_sym_ssp] = ACTIONS(503),
    [anon_sym_sspstrong] = ACTIONS(501),
    [anon_sym_sspreq] = ACTIONS(501),
    [anon_sym_strictfp] = ACTIONS(501),
    [anon_sym_uwtable] = ACTIONS(501),
    [anon_sym_nocf_check] = ACTIONS(501),
    [anon_sym_shadowcallstack] = ACTIONS(501),
    [anon_sym_mustprogress] = ACTIONS(501),
    [anon_sym_vscale_range] = ACTIONS(501),
    [anon_sym_preallocated] = ACTIONS(501),
    [anon_sym_zeroext] = ACTIONS(501),
    [anon_sym_signext] = ACTIONS(501),
    [anon_sym_inreg] = ACTIONS(501),
    [anon_sym_byval] = ACTIONS(501),
    [anon_sym_byref] = ACTIONS(501),
    [anon_sym_inalloca] = ACTIONS(501),
    [anon_sym_sret] = ACTIONS(501),
    [anon_sym_elementtype] = ACTIONS(501),
    [anon_sym_noalias] = ACTIONS(501),
    [anon_sym_nocapture] = ACTIONS(501),
    [anon_sym_nest] = ACTIONS(501),
    [anon_sym_returned] = ACTIONS(501),
    [anon_sym_nonnull] = ACTIONS(501),
    [anon_sym_dereferenceable] = ACTIONS(503),
    [anon_sym_dereferenceable_or_null] = ACTIONS(501),
    [anon_sym_swiftself] = ACTIONS(501),
    [anon_sym_swiftasync] = ACTIONS(501),
    [anon_sym_swifterror] = ACTIONS(501),
    [anon_sym_immarg] = ACTIONS(501),
    [anon_sym_noundef] = ACTIONS(501),
    [anon_sym_to] = ACTIONS(503),
    [anon_sym_uselistorder] = ACTIONS(503),
    [anon_sym_uselistorder_bb] = ACTIONS(501),
    [anon_sym_module] = ACTIONS(501),
    [anon_sym_attributes] = ACTIONS(501),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(529),
    [sym_comdat_ref] = ACTIONS(529),
    [sym_global_var] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [aux_sym_metadata_ref_token1] = ACTIONS(529),
    [sym_summary_ref] = ACTIONS(529),
    [sym_string] = ACTIONS(529),
    [anon_sym_target] = ACTIONS(529),
    [anon_sym_source_filename] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_define] = ACTIONS(529),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_half] = ACTIONS(529),
    [anon_sym_bfloat] = ACTIONS(529),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_double] = ACTIONS(529),
    [anon_sym_x86_fp80] = ACTIONS(529),
    [anon_sym_fp128] = ACTIONS(529),
    [anon_sym_ppc_fp128] = ACTIONS(529),
    [anon_sym_label] = ACTIONS(529),
    [anon_sym_metadata] = ACTIONS(529),
    [anon_sym_x86_mmx] = ACTIONS(529),
    [anon_sym_x86_amx] = ACTIONS(529),
    [anon_sym_token] = ACTIONS(529),
    [anon_sym_opaque] = ACTIONS(529),
    [anon_sym_ptr] = ACTIONS(529),
    [aux_sym_type_keyword_token1] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LT_LBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_section] = ACTIONS(529),
    [anon_sym_partition] = ACTIONS(529),
    [anon_sym_comdat] = ACTIONS(529),
    [anon_sym_gc] = ACTIONS(529),
    [anon_sym_prefix] = ACTIONS(529),
    [anon_sym_prologue] = ACTIONS(529),
    [anon_sym_personality] = ACTIONS(529),
    [anon_sym_alignstack] = ACTIONS(529),
    [anon_sym_allocsize] = ACTIONS(529),
    [anon_sym_alwaysinline] = ACTIONS(529),
    [anon_sym_builtin] = ACTIONS(529),
    [anon_sym_cold] = ACTIONS(529),
    [anon_sym_convergent] = ACTIONS(529),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(529),
    [anon_sym_hot] = ACTIONS(529),
    [anon_sym_inaccessiblememonly] = ACTIONS(529),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(529),
    [anon_sym_inlinehint] = ACTIONS(529),
    [anon_sym_jumptable] = ACTIONS(529),
    [anon_sym_minsize] = ACTIONS(529),
    [anon_sym_naked] = ACTIONS(529),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(529),
    [anon_sym_nobuiltin] = ACTIONS(529),
    [anon_sym_noduplicate] = ACTIONS(529),
    [anon_sym_nofree] = ACTIONS(529),
    [anon_sym_noimplicitfloat] = ACTIONS(529),
    [anon_sym_noinline] = ACTIONS(529),
    [anon_sym_nomerge] = ACTIONS(529),
    [anon_sym_nonlazybind] = ACTIONS(529),
    [anon_sym_noprofile] = ACTIONS(529),
    [anon_sym_noredzone] = ACTIONS(529),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(529),
    [anon_sym_noreturn] = ACTIONS(529),
    [anon_sym_norecurse] = ACTIONS(529),
    [anon_sym_willreturn] = ACTIONS(529),
    [anon_sym_nosync] = ACTIONS(529),
    [anon_sym_nounwind] = ACTIONS(529),
    [anon_sym_nosanitize_coverage] = ACTIONS(529),
    [anon_sym_null_pointer_is_valid] = ACTIONS(529),
    [anon_sym_optforfuzzing] = ACTIONS(529),
    [anon_sym_optnone] = ACTIONS(529),
    [anon_sym_optsize] = ACTIONS(529),
    [anon_sym_readnone] = ACTIONS(529),
    [anon_sym_readonly] = ACTIONS(529),
    [anon_sym_writeonly] = ACTIONS(529),
    [anon_sym_argmemonly] = ACTIONS(529),
    [anon_sym_returns_twice] = ACTIONS(529),
    [anon_sym_safestack] = ACTIONS(529),
    [anon_sym_sanitize_address] = ACTIONS(529),
    [anon_sym_sanitize_memory] = ACTIONS(529),
    [anon_sym_sanitize_thread] = ACTIONS(529),
    [anon_sym_sanitize_hwaddress] = ACTIONS(529),
    [anon_sym_sanitize_memtag] = ACTIONS(529),
    [anon_sym_speculative_load_hardening] = ACTIONS(529),
    [anon_sym_speculatable] = ACTIONS(529),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(529),
    [anon_sym_sspreq] = ACTIONS(529),
    [anon_sym_strictfp] = ACTIONS(529),
    [anon_sym_uwtable] = ACTIONS(529),
    [anon_sym_nocf_check] = ACTIONS(529),
    [anon_sym_shadowcallstack] = ACTIONS(529),
    [anon_sym_mustprogress] = ACTIONS(529),
    [anon_sym_vscale_range] = ACTIONS(529),
    [anon_sym_preallocated] = ACTIONS(529),
    [anon_sym_zeroext] = ACTIONS(529),
    [anon_sym_signext] = ACTIONS(529),
    [anon_sym_inreg] = ACTIONS(529),
    [anon_sym_byval] = ACTIONS(529),
    [anon_sym_byref] = ACTIONS(529),
    [anon_sym_inalloca] = ACTIONS(529),
    [anon_sym_sret] = ACTIONS(529),
    [anon_sym_elementtype] = ACTIONS(529),
    [anon_sym_noalias] = ACTIONS(529),
    [anon_sym_nocapture] = ACTIONS(529),
    [anon_sym_nest] = ACTIONS(529),
    [anon_sym_returned] = ACTIONS(529),
    [anon_sym_nonnull] = ACTIONS(529),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(529),
    [anon_sym_swiftself] = ACTIONS(529),
    [anon_sym_swiftasync] = ACTIONS(529),
    [anon_sym_swifterror] = ACTIONS(529),
    [anon_sym_immarg] = ACTIONS(529),
    [anon_sym_noundef] = ACTIONS(529),
    [anon_sym_to] = ACTIONS(531),
    [anon_sym_uselistorder] = ACTIONS(531),
    [anon_sym_uselistorder_bb] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_attributes] = ACTIONS(529),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(615),
    [sym_comdat_ref] = ACTIONS(615),
    [sym_global_var] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [aux_sym_metadata_ref_token1] = ACTIONS(615),
    [sym_summary_ref] = ACTIONS(615),
    [sym_string] = ACTIONS(615),
    [anon_sym_target] = ACTIONS(615),
    [anon_sym_source_filename] = ACTIONS(615),
    [anon_sym_declare] = ACTIONS(615),
    [anon_sym_define] = ACTIONS(615),
    [anon_sym_void] = ACTIONS(615),
    [anon_sym_half] = ACTIONS(615),
    [anon_sym_bfloat] = ACTIONS(615),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_double] = ACTIONS(615),
    [anon_sym_x86_fp80] = ACTIONS(615),
    [anon_sym_fp128] = ACTIONS(615),
    [anon_sym_ppc_fp128] = ACTIONS(615),
    [anon_sym_label] = ACTIONS(615),
    [anon_sym_metadata] = ACTIONS(615),
    [anon_sym_x86_mmx] = ACTIONS(615),
    [anon_sym_x86_amx] = ACTIONS(615),
    [anon_sym_token] = ACTIONS(615),
    [anon_sym_opaque] = ACTIONS(615),
    [anon_sym_ptr] = ACTIONS(615),
    [aux_sym_type_keyword_token1] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LT_LBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_section] = ACTIONS(615),
    [anon_sym_partition] = ACTIONS(615),
    [anon_sym_comdat] = ACTIONS(615),
    [anon_sym_gc] = ACTIONS(615),
    [anon_sym_prefix] = ACTIONS(615),
    [anon_sym_prologue] = ACTIONS(615),
    [anon_sym_personality] = ACTIONS(615),
    [anon_sym_alignstack] = ACTIONS(615),
    [anon_sym_allocsize] = ACTIONS(615),
    [anon_sym_alwaysinline] = ACTIONS(615),
    [anon_sym_builtin] = ACTIONS(615),
    [anon_sym_cold] = ACTIONS(615),
    [anon_sym_convergent] = ACTIONS(615),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(615),
    [anon_sym_hot] = ACTIONS(615),
    [anon_sym_inaccessiblememonly] = ACTIONS(615),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(615),
    [anon_sym_inlinehint] = ACTIONS(615),
    [anon_sym_jumptable] = ACTIONS(615),
    [anon_sym_minsize] = ACTIONS(615),
    [anon_sym_naked] = ACTIONS(615),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(615),
    [anon_sym_nobuiltin] = ACTIONS(615),
    [anon_sym_noduplicate] = ACTIONS(615),
    [anon_sym_nofree] = ACTIONS(615),
    [anon_sym_noimplicitfloat] = ACTIONS(615),
    [anon_sym_noinline] = ACTIONS(615),
    [anon_sym_nomerge] = ACTIONS(615),
    [anon_sym_nonlazybind] = ACTIONS(615),
    [anon_sym_noprofile] = ACTIONS(615),
    [anon_sym_noredzone] = ACTIONS(615),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(615),
    [anon_sym_noreturn] = ACTIONS(615),
    [anon_sym_norecurse] = ACTIONS(615),
    [anon_sym_willreturn] = ACTIONS(615),
    [anon_sym_nosync] = ACTIONS(615),
    [anon_sym_nounwind] = ACTIONS(615),
    [anon_sym_nosanitize_coverage] = ACTIONS(615),
    [anon_sym_null_pointer_is_valid] = ACTIONS(615),
    [anon_sym_optforfuzzing] = ACTIONS(615),
    [anon_sym_optnone] = ACTIONS(615),
    [anon_sym_optsize] = ACTIONS(615),
    [anon_sym_readnone] = ACTIONS(615),
    [anon_sym_readonly] = ACTIONS(615),
    [anon_sym_writeonly] = ACTIONS(615),
    [anon_sym_argmemonly] = ACTIONS(615),
    [anon_sym_returns_twice] = ACTIONS(615),
    [anon_sym_safestack] = ACTIONS(615),
    [anon_sym_sanitize_address] = ACTIONS(615),
    [anon_sym_sanitize_memory] = ACTIONS(615),
    [anon_sym_sanitize_thread] = ACTIONS(615),
    [anon_sym_sanitize_hwaddress] = ACTIONS(615),
    [anon_sym_sanitize_memtag] = ACTIONS(615),
    [anon_sym_speculative_load_hardening] = ACTIONS(615),
    [anon_sym_speculatable] = ACTIONS(615),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(615),
    [anon_sym_sspreq] = ACTIONS(615),
    [anon_sym_strictfp] = ACTIONS(615),
    [anon_sym_uwtable] = ACTIONS(615),
    [anon_sym_nocf_check] = ACTIONS(615),
    [anon_sym_shadowcallstack] = ACTIONS(615),
    [anon_sym_mustprogress] = ACTIONS(615),
    [anon_sym_vscale_range] = ACTIONS(615),
    [anon_sym_preallocated] = ACTIONS(615),
    [anon_sym_zeroext] = ACTIONS(615),
    [anon_sym_signext] = ACTIONS(615),
    [anon_sym_inreg] = ACTIONS(615),
    [anon_sym_byval] = ACTIONS(615),
    [anon_sym_byref] = ACTIONS(615),
    [anon_sym_inalloca] = ACTIONS(615),
    [anon_sym_sret] = ACTIONS(615),
    [anon_sym_elementtype] = ACTIONS(615),
    [anon_sym_noalias] = ACTIONS(615),
    [anon_sym_nocapture] = ACTIONS(615),
    [anon_sym_nest] = ACTIONS(615),
    [anon_sym_returned] = ACTIONS(615),
    [anon_sym_nonnull] = ACTIONS(615),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(615),
    [anon_sym_swiftself] = ACTIONS(615),
    [anon_sym_swiftasync] = ACTIONS(615),
    [anon_sym_swifterror] = ACTIONS(615),
    [anon_sym_immarg] = ACTIONS(615),
    [anon_sym_noundef] = ACTIONS(615),
    [anon_sym_to] = ACTIONS(617),
    [anon_sym_uselistorder] = ACTIONS(617),
    [anon_sym_uselistorder_bb] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_attributes] = ACTIONS(615),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(685),
    [sym_comdat_ref] = ACTIONS(685),
    [sym_global_var] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [aux_sym_metadata_ref_token1] = ACTIONS(685),
    [sym_summary_ref] = ACTIONS(685),
    [sym_string] = ACTIONS(685),
    [anon_sym_target] = ACTIONS(685),
    [anon_sym_source_filename] = ACTIONS(685),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_define] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(685),
    [anon_sym_half] = ACTIONS(685),
    [anon_sym_bfloat] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_double] = ACTIONS(685),
    [anon_sym_x86_fp80] = ACTIONS(685),
    [anon_sym_fp128] = ACTIONS(685),
    [anon_sym_ppc_fp128] = ACTIONS(685),
    [anon_sym_label] = ACTIONS(685),
    [anon_sym_metadata] = ACTIONS(685),
    [anon_sym_x86_mmx] = ACTIONS(685),
    [anon_sym_x86_amx] = ACTIONS(685),
    [anon_sym_token] = ACTIONS(685),
    [anon_sym_opaque] = ACTIONS(685),
    [anon_sym_ptr] = ACTIONS(685),
    [aux_sym_type_keyword_token1] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LT_LBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_section] = ACTIONS(685),
    [anon_sym_partition] = ACTIONS(685),
    [anon_sym_comdat] = ACTIONS(685),
    [anon_sym_gc] = ACTIONS(685),
    [anon_sym_prefix] = ACTIONS(685),
    [anon_sym_prologue] = ACTIONS(685),
    [anon_sym_personality] = ACTIONS(685),
    [anon_sym_alignstack] = ACTIONS(685),
    [anon_sym_allocsize] = ACTIONS(685),
    [anon_sym_alwaysinline] = ACTIONS(685),
    [anon_sym_builtin] = ACTIONS(685),
    [anon_sym_cold] = ACTIONS(685),
    [anon_sym_convergent] = ACTIONS(685),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(685),
    [anon_sym_hot] = ACTIONS(685),
    [anon_sym_inaccessiblememonly] = ACTIONS(685),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(685),
    [anon_sym_inlinehint] = ACTIONS(685),
    [anon_sym_jumptable] = ACTIONS(685),
    [anon_sym_minsize] = ACTIONS(685),
    [anon_sym_naked] = ACTIONS(685),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(685),
    [anon_sym_nobuiltin] = ACTIONS(685),
    [anon_sym_noduplicate] = ACTIONS(685),
    [anon_sym_nofree] = ACTIONS(685),
    [anon_sym_noimplicitfloat] = ACTIONS(685),
    [anon_sym_noinline] = ACTIONS(685),
    [anon_sym_nomerge] = ACTIONS(685),
    [anon_sym_nonlazybind] = ACTIONS(685),
    [anon_sym_noprofile] = ACTIONS(685),
    [anon_sym_noredzone] = ACTIONS(685),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(685),
    [anon_sym_noreturn] = ACTIONS(685),
    [anon_sym_norecurse] = ACTIONS(685),
    [anon_sym_willreturn] = ACTIONS(685),
    [anon_sym_nosync] = ACTIONS(685),
    [anon_sym_nounwind] = ACTIONS(685),
    [anon_sym_nosanitize_coverage] = ACTIONS(685),
    [anon_sym_null_pointer_is_valid] = ACTIONS(685),
    [anon_sym_optforfuzzing] = ACTIONS(685),
    [anon_sym_optnone] = ACTIONS(685),
    [anon_sym_optsize] = ACTIONS(685),
    [anon_sym_readnone] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(685),
    [anon_sym_writeonly] = ACTIONS(685),
    [anon_sym_argmemonly] = ACTIONS(685),
    [anon_sym_returns_twice] = ACTIONS(685),
    [anon_sym_safestack] = ACTIONS(685),
    [anon_sym_sanitize_address] = ACTIONS(685),
    [anon_sym_sanitize_memory] = ACTIONS(685),
    [anon_sym_sanitize_thread] = ACTIONS(685),
    [anon_sym_sanitize_hwaddress] = ACTIONS(685),
    [anon_sym_sanitize_memtag] = ACTIONS(685),
    [anon_sym_speculative_load_hardening] = ACTIONS(685),
    [anon_sym_speculatable] = ACTIONS(685),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(685),
    [anon_sym_sspreq] = ACTIONS(685),
    [anon_sym_strictfp] = ACTIONS(685),
    [anon_sym_uwtable] = ACTIONS(685),
    [anon_sym_nocf_check] = ACTIONS(685),
    [anon_sym_shadowcallstack] = ACTIONS(685),
    [anon_sym_mustprogress] = ACTIONS(685),
    [anon_sym_vscale_range] = ACTIONS(685),
    [anon_sym_preallocated] = ACTIONS(685),
    [anon_sym_zeroext] = ACTIONS(685),
    [anon_sym_signext] = ACTIONS(685),
    [anon_sym_inreg] = ACTIONS(685),
    [anon_sym_byval] = ACTIONS(685),
    [anon_sym_byref] = ACTIONS(685),
    [anon_sym_inalloca] = ACTIONS(685),
    [anon_sym_sret] = ACTIONS(685),
    [anon_sym_elementtype] = ACTIONS(685),
    [anon_sym_noalias] = ACTIONS(685),
    [anon_sym_nocapture] = ACTIONS(685),
    [anon_sym_nest] = ACTIONS(685),
    [anon_sym_returned] = ACTIONS(685),
    [anon_sym_nonnull] = ACTIONS(685),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(685),
    [anon_sym_swiftself] = ACTIONS(685),
    [anon_sym_swiftasync] = ACTIONS(685),
    [anon_sym_swifterror] = ACTIONS(685),
    [anon_sym_immarg] = ACTIONS(685),
    [anon_sym_noundef] = ACTIONS(685),
    [anon_sym_to] = ACTIONS(687),
    [anon_sym_uselistorder] = ACTIONS(687),
    [anon_sym_uselistorder_bb] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_attributes] = ACTIONS(685),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(679),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(679),
    [anon_sym_x86_amx] = ACTIONS(679),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(679),
    [anon_sym_partition] = ACTIONS(679),
    [anon_sym_comdat] = ACTIONS(679),
    [anon_sym_gc] = ACTIONS(679),
    [anon_sym_prefix] = ACTIONS(679),
    [anon_sym_prologue] = ACTIONS(679),
    [anon_sym_personality] = ACTIONS(679),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(679),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(679),
    [anon_sym_swiftasync] = ACTIONS(679),
    [anon_sym_swifterror] = ACTIONS(679),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(561),
    [sym_comdat_ref] = ACTIONS(561),
    [sym_global_var] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [aux_sym_metadata_ref_token1] = ACTIONS(561),
    [sym_summary_ref] = ACTIONS(561),
    [sym_string] = ACTIONS(561),
    [anon_sym_target] = ACTIONS(561),
    [anon_sym_source_filename] = ACTIONS(561),
    [anon_sym_declare] = ACTIONS(561),
    [anon_sym_define] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_half] = ACTIONS(561),
    [anon_sym_bfloat] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_x86_fp80] = ACTIONS(561),
    [anon_sym_fp128] = ACTIONS(561),
    [anon_sym_ppc_fp128] = ACTIONS(561),
    [anon_sym_label] = ACTIONS(561),
    [anon_sym_metadata] = ACTIONS(561),
    [anon_sym_x86_mmx] = ACTIONS(561),
    [anon_sym_x86_amx] = ACTIONS(561),
    [anon_sym_token] = ACTIONS(561),
    [anon_sym_opaque] = ACTIONS(561),
    [anon_sym_ptr] = ACTIONS(561),
    [aux_sym_type_keyword_token1] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LT_LBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_section] = ACTIONS(561),
    [anon_sym_partition] = ACTIONS(561),
    [anon_sym_comdat] = ACTIONS(561),
    [anon_sym_gc] = ACTIONS(561),
    [anon_sym_prefix] = ACTIONS(561),
    [anon_sym_prologue] = ACTIONS(561),
    [anon_sym_personality] = ACTIONS(561),
    [anon_sym_alignstack] = ACTIONS(561),
    [anon_sym_allocsize] = ACTIONS(561),
    [anon_sym_alwaysinline] = ACTIONS(561),
    [anon_sym_builtin] = ACTIONS(561),
    [anon_sym_cold] = ACTIONS(561),
    [anon_sym_convergent] = ACTIONS(561),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(561),
    [anon_sym_hot] = ACTIONS(561),
    [anon_sym_inaccessiblememonly] = ACTIONS(561),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(561),
    [anon_sym_inlinehint] = ACTIONS(561),
    [anon_sym_jumptable] = ACTIONS(561),
    [anon_sym_minsize] = ACTIONS(561),
    [anon_sym_naked] = ACTIONS(561),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(561),
    [anon_sym_nobuiltin] = ACTIONS(561),
    [anon_sym_noduplicate] = ACTIONS(561),
    [anon_sym_nofree] = ACTIONS(561),
    [anon_sym_noimplicitfloat] = ACTIONS(561),
    [anon_sym_noinline] = ACTIONS(561),
    [anon_sym_nomerge] = ACTIONS(561),
    [anon_sym_nonlazybind] = ACTIONS(561),
    [anon_sym_noprofile] = ACTIONS(561),
    [anon_sym_noredzone] = ACTIONS(561),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(561),
    [anon_sym_noreturn] = ACTIONS(561),
    [anon_sym_norecurse] = ACTIONS(561),
    [anon_sym_willreturn] = ACTIONS(561),
    [anon_sym_nosync] = ACTIONS(561),
    [anon_sym_nounwind] = ACTIONS(561),
    [anon_sym_nosanitize_coverage] = ACTIONS(561),
    [anon_sym_null_pointer_is_valid] = ACTIONS(561),
    [anon_sym_optforfuzzing] = ACTIONS(561),
    [anon_sym_optnone] = ACTIONS(561),
    [anon_sym_optsize] = ACTIONS(561),
    [anon_sym_readnone] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_writeonly] = ACTIONS(561),
    [anon_sym_argmemonly] = ACTIONS(561),
    [anon_sym_returns_twice] = ACTIONS(561),
    [anon_sym_safestack] = ACTIONS(561),
    [anon_sym_sanitize_address] = ACTIONS(561),
    [anon_sym_sanitize_memory] = ACTIONS(561),
    [anon_sym_sanitize_thread] = ACTIONS(561),
    [anon_sym_sanitize_hwaddress] = ACTIONS(561),
    [anon_sym_sanitize_memtag] = ACTIONS(561),
    [anon_sym_speculative_load_hardening] = ACTIONS(561),
    [anon_sym_speculatable] = ACTIONS(561),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(561),
    [anon_sym_sspreq] = ACTIONS(561),
    [anon_sym_strictfp] = ACTIONS(561),
    [anon_sym_uwtable] = ACTIONS(561),
    [anon_sym_nocf_check] = ACTIONS(561),
    [anon_sym_shadowcallstack] = ACTIONS(561),
    [anon_sym_mustprogress] = ACTIONS(561),
    [anon_sym_vscale_range] = ACTIONS(561),
    [anon_sym_preallocated] = ACTIONS(561),
    [anon_sym_zeroext] = ACTIONS(561),
    [anon_sym_signext] = ACTIONS(561),
    [anon_sym_inreg] = ACTIONS(561),
    [anon_sym_byval] = ACTIONS(561),
    [anon_sym_byref] = ACTIONS(561),
    [anon_sym_inalloca] = ACTIONS(561),
    [anon_sym_sret] = ACTIONS(561),
    [anon_sym_elementtype] = ACTIONS(561),
    [anon_sym_noalias] = ACTIONS(561),
    [anon_sym_nocapture] = ACTIONS(561),
    [anon_sym_nest] = ACTIONS(561),
    [anon_sym_returned] = ACTIONS(561),
    [anon_sym_nonnull] = ACTIONS(561),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(561),
    [anon_sym_swiftself] = ACTIONS(561),
    [anon_sym_swiftasync] = ACTIONS(561),
    [anon_sym_swifterror] = ACTIONS(561),
    [anon_sym_immarg] = ACTIONS(561),
    [anon_sym_noundef] = ACTIONS(561),
    [anon_sym_to] = ACTIONS(563),
    [anon_sym_uselistorder] = ACTIONS(563),
    [anon_sym_uselistorder_bb] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_attributes] = ACTIONS(561),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(505),
    [sym_comdat_ref] = ACTIONS(505),
    [sym_global_var] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [aux_sym_metadata_ref_token1] = ACTIONS(505),
    [sym_summary_ref] = ACTIONS(505),
    [sym_string] = ACTIONS(505),
    [anon_sym_target] = ACTIONS(505),
    [anon_sym_source_filename] = ACTIONS(505),
    [anon_sym_declare] = ACTIONS(505),
    [anon_sym_define] = ACTIONS(505),
    [anon_sym_void] = ACTIONS(505),
    [anon_sym_half] = ACTIONS(505),
    [anon_sym_bfloat] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(505),
    [anon_sym_double] = ACTIONS(505),
    [anon_sym_x86_fp80] = ACTIONS(505),
    [anon_sym_fp128] = ACTIONS(505),
    [anon_sym_ppc_fp128] = ACTIONS(505),
    [anon_sym_label] = ACTIONS(505),
    [anon_sym_metadata] = ACTIONS(505),
    [anon_sym_x86_mmx] = ACTIONS(505),
    [anon_sym_x86_amx] = ACTIONS(505),
    [anon_sym_token] = ACTIONS(505),
    [anon_sym_opaque] = ACTIONS(505),
    [anon_sym_ptr] = ACTIONS(505),
    [aux_sym_type_keyword_token1] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LT_LBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_section] = ACTIONS(505),
    [anon_sym_partition] = ACTIONS(505),
    [anon_sym_comdat] = ACTIONS(505),
    [anon_sym_gc] = ACTIONS(505),
    [anon_sym_prefix] = ACTIONS(505),
    [anon_sym_prologue] = ACTIONS(505),
    [anon_sym_personality] = ACTIONS(505),
    [anon_sym_alignstack] = ACTIONS(505),
    [anon_sym_allocsize] = ACTIONS(505),
    [anon_sym_alwaysinline] = ACTIONS(505),
    [anon_sym_builtin] = ACTIONS(505),
    [anon_sym_cold] = ACTIONS(505),
    [anon_sym_convergent] = ACTIONS(505),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(505),
    [anon_sym_hot] = ACTIONS(505),
    [anon_sym_inaccessiblememonly] = ACTIONS(505),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(505),
    [anon_sym_inlinehint] = ACTIONS(505),
    [anon_sym_jumptable] = ACTIONS(505),
    [anon_sym_minsize] = ACTIONS(505),
    [anon_sym_naked] = ACTIONS(505),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(505),
    [anon_sym_nobuiltin] = ACTIONS(505),
    [anon_sym_noduplicate] = ACTIONS(505),
    [anon_sym_nofree] = ACTIONS(505),
    [anon_sym_noimplicitfloat] = ACTIONS(505),
    [anon_sym_noinline] = ACTIONS(505),
    [anon_sym_nomerge] = ACTIONS(505),
    [anon_sym_nonlazybind] = ACTIONS(505),
    [anon_sym_noprofile] = ACTIONS(505),
    [anon_sym_noredzone] = ACTIONS(505),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(505),
    [anon_sym_noreturn] = ACTIONS(505),
    [anon_sym_norecurse] = ACTIONS(505),
    [anon_sym_willreturn] = ACTIONS(505),
    [anon_sym_nosync] = ACTIONS(505),
    [anon_sym_nounwind] = ACTIONS(505),
    [anon_sym_nosanitize_coverage] = ACTIONS(505),
    [anon_sym_null_pointer_is_valid] = ACTIONS(505),
    [anon_sym_optforfuzzing] = ACTIONS(505),
    [anon_sym_optnone] = ACTIONS(505),
    [anon_sym_optsize] = ACTIONS(505),
    [anon_sym_readnone] = ACTIONS(505),
    [anon_sym_readonly] = ACTIONS(505),
    [anon_sym_writeonly] = ACTIONS(505),
    [anon_sym_argmemonly] = ACTIONS(505),
    [anon_sym_returns_twice] = ACTIONS(505),
    [anon_sym_safestack] = ACTIONS(505),
    [anon_sym_sanitize_address] = ACTIONS(505),
    [anon_sym_sanitize_memory] = ACTIONS(505),
    [anon_sym_sanitize_thread] = ACTIONS(505),
    [anon_sym_sanitize_hwaddress] = ACTIONS(505),
    [anon_sym_sanitize_memtag] = ACTIONS(505),
    [anon_sym_speculative_load_hardening] = ACTIONS(505),
    [anon_sym_speculatable] = ACTIONS(505),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(505),
    [anon_sym_sspreq] = ACTIONS(505),
    [anon_sym_strictfp] = ACTIONS(505),
    [anon_sym_uwtable] = ACTIONS(505),
    [anon_sym_nocf_check] = ACTIONS(505),
    [anon_sym_shadowcallstack] = ACTIONS(505),
    [anon_sym_mustprogress] = ACTIONS(505),
    [anon_sym_vscale_range] = ACTIONS(505),
    [anon_sym_preallocated] = ACTIONS(505),
    [anon_sym_zeroext] = ACTIONS(505),
    [anon_sym_signext] = ACTIONS(505),
    [anon_sym_inreg] = ACTIONS(505),
    [anon_sym_byval] = ACTIONS(505),
    [anon_sym_byref] = ACTIONS(505),
    [anon_sym_inalloca] = ACTIONS(505),
    [anon_sym_sret] = ACTIONS(505),
    [anon_sym_elementtype] = ACTIONS(505),
    [anon_sym_noalias] = ACTIONS(505),
    [anon_sym_nocapture] = ACTIONS(505),
    [anon_sym_nest] = ACTIONS(505),
    [anon_sym_returned] = ACTIONS(505),
    [anon_sym_nonnull] = ACTIONS(505),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(505),
    [anon_sym_swiftself] = ACTIONS(505),
    [anon_sym_swiftasync] = ACTIONS(505),
    [anon_sym_swifterror] = ACTIONS(505),
    [anon_sym_immarg] = ACTIONS(505),
    [anon_sym_noundef] = ACTIONS(505),
    [anon_sym_to] = ACTIONS(507),
    [anon_sym_uselistorder] = ACTIONS(507),
    [anon_sym_uselistorder_bb] = ACTIONS(505),
    [anon_sym_module] = ACTIONS(505),
    [anon_sym_attributes] = ACTIONS(505),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(541),
    [sym_comdat_ref] = ACTIONS(541),
    [sym_global_var] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [aux_sym_metadata_ref_token1] = ACTIONS(541),
    [sym_summary_ref] = ACTIONS(541),
    [sym_string] = ACTIONS(541),
    [anon_sym_target] = ACTIONS(541),
    [anon_sym_source_filename] = ACTIONS(541),
    [anon_sym_declare] = ACTIONS(541),
    [anon_sym_define] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_half] = ACTIONS(541),
    [anon_sym_bfloat] = ACTIONS(541),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_double] = ACTIONS(541),
    [anon_sym_x86_fp80] = ACTIONS(541),
    [anon_sym_fp128] = ACTIONS(541),
    [anon_sym_ppc_fp128] = ACTIONS(541),
    [anon_sym_label] = ACTIONS(541),
    [anon_sym_metadata] = ACTIONS(541),
    [anon_sym_x86_mmx] = ACTIONS(541),
    [anon_sym_x86_amx] = ACTIONS(541),
    [anon_sym_token] = ACTIONS(541),
    [anon_sym_opaque] = ACTIONS(541),
    [anon_sym_ptr] = ACTIONS(541),
    [aux_sym_type_keyword_token1] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LT_LBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_section] = ACTIONS(541),
    [anon_sym_partition] = ACTIONS(541),
    [anon_sym_comdat] = ACTIONS(541),
    [anon_sym_gc] = ACTIONS(541),
    [anon_sym_prefix] = ACTIONS(541),
    [anon_sym_prologue] = ACTIONS(541),
    [anon_sym_personality] = ACTIONS(541),
    [anon_sym_alignstack] = ACTIONS(541),
    [anon_sym_allocsize] = ACTIONS(541),
    [anon_sym_alwaysinline] = ACTIONS(541),
    [anon_sym_builtin] = ACTIONS(541),
    [anon_sym_cold] = ACTIONS(541),
    [anon_sym_convergent] = ACTIONS(541),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(541),
    [anon_sym_hot] = ACTIONS(541),
    [anon_sym_inaccessiblememonly] = ACTIONS(541),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(541),
    [anon_sym_inlinehint] = ACTIONS(541),
    [anon_sym_jumptable] = ACTIONS(541),
    [anon_sym_minsize] = ACTIONS(541),
    [anon_sym_naked] = ACTIONS(541),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(541),
    [anon_sym_nobuiltin] = ACTIONS(541),
    [anon_sym_noduplicate] = ACTIONS(541),
    [anon_sym_nofree] = ACTIONS(541),
    [anon_sym_noimplicitfloat] = ACTIONS(541),
    [anon_sym_noinline] = ACTIONS(541),
    [anon_sym_nomerge] = ACTIONS(541),
    [anon_sym_nonlazybind] = ACTIONS(541),
    [anon_sym_noprofile] = ACTIONS(541),
    [anon_sym_noredzone] = ACTIONS(541),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(541),
    [anon_sym_noreturn] = ACTIONS(541),
    [anon_sym_norecurse] = ACTIONS(541),
    [anon_sym_willreturn] = ACTIONS(541),
    [anon_sym_nosync] = ACTIONS(541),
    [anon_sym_nounwind] = ACTIONS(541),
    [anon_sym_nosanitize_coverage] = ACTIONS(541),
    [anon_sym_null_pointer_is_valid] = ACTIONS(541),
    [anon_sym_optforfuzzing] = ACTIONS(541),
    [anon_sym_optnone] = ACTIONS(541),
    [anon_sym_optsize] = ACTIONS(541),
    [anon_sym_readnone] = ACTIONS(541),
    [anon_sym_readonly] = ACTIONS(541),
    [anon_sym_writeonly] = ACTIONS(541),
    [anon_sym_argmemonly] = ACTIONS(541),
    [anon_sym_returns_twice] = ACTIONS(541),
    [anon_sym_safestack] = ACTIONS(541),
    [anon_sym_sanitize_address] = ACTIONS(541),
    [anon_sym_sanitize_memory] = ACTIONS(541),
    [anon_sym_sanitize_thread] = ACTIONS(541),
    [anon_sym_sanitize_hwaddress] = ACTIONS(541),
    [anon_sym_sanitize_memtag] = ACTIONS(541),
    [anon_sym_speculative_load_hardening] = ACTIONS(541),
    [anon_sym_speculatable] = ACTIONS(541),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(541),
    [anon_sym_sspreq] = ACTIONS(541),
    [anon_sym_strictfp] = ACTIONS(541),
    [anon_sym_uwtable] = ACTIONS(541),
    [anon_sym_nocf_check] = ACTIONS(541),
    [anon_sym_shadowcallstack] = ACTIONS(541),
    [anon_sym_mustprogress] = ACTIONS(541),
    [anon_sym_vscale_range] = ACTIONS(541),
    [anon_sym_preallocated] = ACTIONS(541),
    [anon_sym_zeroext] = ACTIONS(541),
    [anon_sym_signext] = ACTIONS(541),
    [anon_sym_inreg] = ACTIONS(541),
    [anon_sym_byval] = ACTIONS(541),
    [anon_sym_byref] = ACTIONS(541),
    [anon_sym_inalloca] = ACTIONS(541),
    [anon_sym_sret] = ACTIONS(541),
    [anon_sym_elementtype] = ACTIONS(541),
    [anon_sym_noalias] = ACTIONS(541),
    [anon_sym_nocapture] = ACTIONS(541),
    [anon_sym_nest] = ACTIONS(541),
    [anon_sym_returned] = ACTIONS(541),
    [anon_sym_nonnull] = ACTIONS(541),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(541),
    [anon_sym_swiftself] = ACTIONS(541),
    [anon_sym_swiftasync] = ACTIONS(541),
    [anon_sym_swifterror] = ACTIONS(541),
    [anon_sym_immarg] = ACTIONS(541),
    [anon_sym_noundef] = ACTIONS(541),
    [anon_sym_to] = ACTIONS(543),
    [anon_sym_uselistorder] = ACTIONS(543),
    [anon_sym_uselistorder_bb] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_attributes] = ACTIONS(541),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(595),
    [sym_comdat_ref] = ACTIONS(595),
    [sym_global_var] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [aux_sym_metadata_ref_token1] = ACTIONS(595),
    [sym_summary_ref] = ACTIONS(595),
    [sym_string] = ACTIONS(595),
    [anon_sym_target] = ACTIONS(595),
    [anon_sym_source_filename] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_define] = ACTIONS(595),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_half] = ACTIONS(595),
    [anon_sym_bfloat] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(595),
    [anon_sym_double] = ACTIONS(595),
    [anon_sym_x86_fp80] = ACTIONS(595),
    [anon_sym_fp128] = ACTIONS(595),
    [anon_sym_ppc_fp128] = ACTIONS(595),
    [anon_sym_label] = ACTIONS(595),
    [anon_sym_metadata] = ACTIONS(595),
    [anon_sym_x86_mmx] = ACTIONS(595),
    [anon_sym_x86_amx] = ACTIONS(595),
    [anon_sym_token] = ACTIONS(595),
    [anon_sym_opaque] = ACTIONS(595),
    [anon_sym_ptr] = ACTIONS(595),
    [aux_sym_type_keyword_token1] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LT_LBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_section] = ACTIONS(595),
    [anon_sym_partition] = ACTIONS(595),
    [anon_sym_comdat] = ACTIONS(595),
    [anon_sym_gc] = ACTIONS(595),
    [anon_sym_prefix] = ACTIONS(595),
    [anon_sym_prologue] = ACTIONS(595),
    [anon_sym_personality] = ACTIONS(595),
    [anon_sym_alignstack] = ACTIONS(595),
    [anon_sym_allocsize] = ACTIONS(595),
    [anon_sym_alwaysinline] = ACTIONS(595),
    [anon_sym_builtin] = ACTIONS(595),
    [anon_sym_cold] = ACTIONS(595),
    [anon_sym_convergent] = ACTIONS(595),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(595),
    [anon_sym_hot] = ACTIONS(595),
    [anon_sym_inaccessiblememonly] = ACTIONS(595),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(595),
    [anon_sym_inlinehint] = ACTIONS(595),
    [anon_sym_jumptable] = ACTIONS(595),
    [anon_sym_minsize] = ACTIONS(595),
    [anon_sym_naked] = ACTIONS(595),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(595),
    [anon_sym_nobuiltin] = ACTIONS(595),
    [anon_sym_noduplicate] = ACTIONS(595),
    [anon_sym_nofree] = ACTIONS(595),
    [anon_sym_noimplicitfloat] = ACTIONS(595),
    [anon_sym_noinline] = ACTIONS(595),
    [anon_sym_nomerge] = ACTIONS(595),
    [anon_sym_nonlazybind] = ACTIONS(595),
    [anon_sym_noprofile] = ACTIONS(595),
    [anon_sym_noredzone] = ACTIONS(595),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(595),
    [anon_sym_noreturn] = ACTIONS(595),
    [anon_sym_norecurse] = ACTIONS(595),
    [anon_sym_willreturn] = ACTIONS(595),
    [anon_sym_nosync] = ACTIONS(595),
    [anon_sym_nounwind] = ACTIONS(595),
    [anon_sym_nosanitize_coverage] = ACTIONS(595),
    [anon_sym_null_pointer_is_valid] = ACTIONS(595),
    [anon_sym_optforfuzzing] = ACTIONS(595),
    [anon_sym_optnone] = ACTIONS(595),
    [anon_sym_optsize] = ACTIONS(595),
    [anon_sym_readnone] = ACTIONS(595),
    [anon_sym_readonly] = ACTIONS(595),
    [anon_sym_writeonly] = ACTIONS(595),
    [anon_sym_argmemonly] = ACTIONS(595),
    [anon_sym_returns_twice] = ACTIONS(595),
    [anon_sym_safestack] = ACTIONS(595),
    [anon_sym_sanitize_address] = ACTIONS(595),
    [anon_sym_sanitize_memory] = ACTIONS(595),
    [anon_sym_sanitize_thread] = ACTIONS(595),
    [anon_sym_sanitize_hwaddress] = ACTIONS(595),
    [anon_sym_sanitize_memtag] = ACTIONS(595),
    [anon_sym_speculative_load_hardening] = ACTIONS(595),
    [anon_sym_speculatable] = ACTIONS(595),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(595),
    [anon_sym_sspreq] = ACTIONS(595),
    [anon_sym_strictfp] = ACTIONS(595),
    [anon_sym_uwtable] = ACTIONS(595),
    [anon_sym_nocf_check] = ACTIONS(595),
    [anon_sym_shadowcallstack] = ACTIONS(595),
    [anon_sym_mustprogress] = ACTIONS(595),
    [anon_sym_vscale_range] = ACTIONS(595),
    [anon_sym_preallocated] = ACTIONS(595),
    [anon_sym_zeroext] = ACTIONS(595),
    [anon_sym_signext] = ACTIONS(595),
    [anon_sym_inreg] = ACTIONS(595),
    [anon_sym_byval] = ACTIONS(595),
    [anon_sym_byref] = ACTIONS(595),
    [anon_sym_inalloca] = ACTIONS(595),
    [anon_sym_sret] = ACTIONS(595),
    [anon_sym_elementtype] = ACTIONS(595),
    [anon_sym_noalias] = ACTIONS(595),
    [anon_sym_nocapture] = ACTIONS(595),
    [anon_sym_nest] = ACTIONS(595),
    [anon_sym_returned] = ACTIONS(595),
    [anon_sym_nonnull] = ACTIONS(595),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(595),
    [anon_sym_swiftself] = ACTIONS(595),
    [anon_sym_swiftasync] = ACTIONS(595),
    [anon_sym_swifterror] = ACTIONS(595),
    [anon_sym_immarg] = ACTIONS(595),
    [anon_sym_noundef] = ACTIONS(595),
    [anon_sym_to] = ACTIONS(597),
    [anon_sym_uselistorder] = ACTIONS(597),
    [anon_sym_uselistorder_bb] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_attributes] = ACTIONS(595),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(667),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(667),
    [anon_sym_x86_amx] = ACTIONS(667),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(667),
    [anon_sym_partition] = ACTIONS(667),
    [anon_sym_comdat] = ACTIONS(667),
    [anon_sym_gc] = ACTIONS(667),
    [anon_sym_prefix] = ACTIONS(667),
    [anon_sym_prologue] = ACTIONS(667),
    [anon_sym_personality] = ACTIONS(667),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(667),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(667),
    [anon_sym_swiftasync] = ACTIONS(667),
    [anon_sym_swifterror] = ACTIONS(667),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(537),
    [sym_comdat_ref] = ACTIONS(537),
    [sym_global_var] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [aux_sym_metadata_ref_token1] = ACTIONS(537),
    [sym_summary_ref] = ACTIONS(537),
    [sym_string] = ACTIONS(537),
    [anon_sym_target] = ACTIONS(537),
    [anon_sym_source_filename] = ACTIONS(537),
    [anon_sym_declare] = ACTIONS(537),
    [anon_sym_define] = ACTIONS(537),
    [anon_sym_void] = ACTIONS(537),
    [anon_sym_half] = ACTIONS(537),
    [anon_sym_bfloat] = ACTIONS(537),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_double] = ACTIONS(537),
    [anon_sym_x86_fp80] = ACTIONS(537),
    [anon_sym_fp128] = ACTIONS(537),
    [anon_sym_ppc_fp128] = ACTIONS(537),
    [anon_sym_label] = ACTIONS(537),
    [anon_sym_metadata] = ACTIONS(537),
    [anon_sym_x86_mmx] = ACTIONS(537),
    [anon_sym_x86_amx] = ACTIONS(537),
    [anon_sym_token] = ACTIONS(537),
    [anon_sym_opaque] = ACTIONS(537),
    [anon_sym_ptr] = ACTIONS(537),
    [aux_sym_type_keyword_token1] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LT_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_RBRACK] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_section] = ACTIONS(537),
    [anon_sym_partition] = ACTIONS(537),
    [anon_sym_comdat] = ACTIONS(537),
    [anon_sym_gc] = ACTIONS(537),
    [anon_sym_prefix] = ACTIONS(537),
    [anon_sym_prologue] = ACTIONS(537),
    [anon_sym_personality] = ACTIONS(537),
    [anon_sym_alignstack] = ACTIONS(537),
    [anon_sym_allocsize] = ACTIONS(537),
    [anon_sym_alwaysinline] = ACTIONS(537),
    [anon_sym_builtin] = ACTIONS(537),
    [anon_sym_cold] = ACTIONS(537),
    [anon_sym_convergent] = ACTIONS(537),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(537),
    [anon_sym_hot] = ACTIONS(537),
    [anon_sym_inaccessiblememonly] = ACTIONS(537),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(537),
    [anon_sym_inlinehint] = ACTIONS(537),
    [anon_sym_jumptable] = ACTIONS(537),
    [anon_sym_minsize] = ACTIONS(537),
    [anon_sym_naked] = ACTIONS(537),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(537),
    [anon_sym_nobuiltin] = ACTIONS(537),
    [anon_sym_noduplicate] = ACTIONS(537),
    [anon_sym_nofree] = ACTIONS(537),
    [anon_sym_noimplicitfloat] = ACTIONS(537),
    [anon_sym_noinline] = ACTIONS(537),
    [anon_sym_nomerge] = ACTIONS(537),
    [anon_sym_nonlazybind] = ACTIONS(537),
    [anon_sym_noprofile] = ACTIONS(537),
    [anon_sym_noredzone] = ACTIONS(537),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(537),
    [anon_sym_noreturn] = ACTIONS(537),
    [anon_sym_norecurse] = ACTIONS(537),
    [anon_sym_willreturn] = ACTIONS(537),
    [anon_sym_nosync] = ACTIONS(537),
    [anon_sym_nounwind] = ACTIONS(537),
    [anon_sym_nosanitize_coverage] = ACTIONS(537),
    [anon_sym_null_pointer_is_valid] = ACTIONS(537),
    [anon_sym_optforfuzzing] = ACTIONS(537),
    [anon_sym_optnone] = ACTIONS(537),
    [anon_sym_optsize] = ACTIONS(537),
    [anon_sym_readnone] = ACTIONS(537),
    [anon_sym_readonly] = ACTIONS(537),
    [anon_sym_writeonly] = ACTIONS(537),
    [anon_sym_argmemonly] = ACTIONS(537),
    [anon_sym_returns_twice] = ACTIONS(537),
    [anon_sym_safestack] = ACTIONS(537),
    [anon_sym_sanitize_address] = ACTIONS(537),
    [anon_sym_sanitize_memory] = ACTIONS(537),
    [anon_sym_sanitize_thread] = ACTIONS(537),
    [anon_sym_sanitize_hwaddress] = ACTIONS(537),
    [anon_sym_sanitize_memtag] = ACTIONS(537),
    [anon_sym_speculative_load_hardening] = ACTIONS(537),
    [anon_sym_speculatable] = ACTIONS(537),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(537),
    [anon_sym_sspreq] = ACTIONS(537),
    [anon_sym_strictfp] = ACTIONS(537),
    [anon_sym_uwtable] = ACTIONS(537),
    [anon_sym_nocf_check] = ACTIONS(537),
    [anon_sym_shadowcallstack] = ACTIONS(537),
    [anon_sym_mustprogress] = ACTIONS(537),
    [anon_sym_vscale_range] = ACTIONS(537),
    [anon_sym_preallocated] = ACTIONS(537),
    [anon_sym_zeroext] = ACTIONS(537),
    [anon_sym_signext] = ACTIONS(537),
    [anon_sym_inreg] = ACTIONS(537),
    [anon_sym_byval] = ACTIONS(537),
    [anon_sym_byref] = ACTIONS(537),
    [anon_sym_inalloca] = ACTIONS(537),
    [anon_sym_sret] = ACTIONS(537),
    [anon_sym_elementtype] = ACTIONS(537),
    [anon_sym_noalias] = ACTIONS(537),
    [anon_sym_nocapture] = ACTIONS(537),
    [anon_sym_nest] = ACTIONS(537),
    [anon_sym_returned] = ACTIONS(537),
    [anon_sym_nonnull] = ACTIONS(537),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(537),
    [anon_sym_swiftself] = ACTIONS(537),
    [anon_sym_swiftasync] = ACTIONS(537),
    [anon_sym_swifterror] = ACTIONS(537),
    [anon_sym_immarg] = ACTIONS(537),
    [anon_sym_noundef] = ACTIONS(537),
    [anon_sym_to] = ACTIONS(539),
    [anon_sym_uselistorder] = ACTIONS(539),
    [anon_sym_uselistorder_bb] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_attributes] = ACTIONS(537),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(569),
    [sym_comdat_ref] = ACTIONS(569),
    [sym_global_var] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [aux_sym_metadata_ref_token1] = ACTIONS(569),
    [sym_summary_ref] = ACTIONS(569),
    [sym_string] = ACTIONS(569),
    [anon_sym_target] = ACTIONS(569),
    [anon_sym_source_filename] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_define] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_half] = ACTIONS(569),
    [anon_sym_bfloat] = ACTIONS(569),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_double] = ACTIONS(569),
    [anon_sym_x86_fp80] = ACTIONS(569),
    [anon_sym_fp128] = ACTIONS(569),
    [anon_sym_ppc_fp128] = ACTIONS(569),
    [anon_sym_label] = ACTIONS(569),
    [anon_sym_metadata] = ACTIONS(569),
    [anon_sym_x86_mmx] = ACTIONS(569),
    [anon_sym_x86_amx] = ACTIONS(569),
    [anon_sym_token] = ACTIONS(569),
    [anon_sym_opaque] = ACTIONS(569),
    [anon_sym_ptr] = ACTIONS(569),
    [aux_sym_type_keyword_token1] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LT_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_section] = ACTIONS(569),
    [anon_sym_partition] = ACTIONS(569),
    [anon_sym_comdat] = ACTIONS(569),
    [anon_sym_gc] = ACTIONS(569),
    [anon_sym_prefix] = ACTIONS(569),
    [anon_sym_prologue] = ACTIONS(569),
    [anon_sym_personality] = ACTIONS(569),
    [anon_sym_alignstack] = ACTIONS(569),
    [anon_sym_allocsize] = ACTIONS(569),
    [anon_sym_alwaysinline] = ACTIONS(569),
    [anon_sym_builtin] = ACTIONS(569),
    [anon_sym_cold] = ACTIONS(569),
    [anon_sym_convergent] = ACTIONS(569),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(569),
    [anon_sym_hot] = ACTIONS(569),
    [anon_sym_inaccessiblememonly] = ACTIONS(569),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(569),
    [anon_sym_inlinehint] = ACTIONS(569),
    [anon_sym_jumptable] = ACTIONS(569),
    [anon_sym_minsize] = ACTIONS(569),
    [anon_sym_naked] = ACTIONS(569),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(569),
    [anon_sym_nobuiltin] = ACTIONS(569),
    [anon_sym_noduplicate] = ACTIONS(569),
    [anon_sym_nofree] = ACTIONS(569),
    [anon_sym_noimplicitfloat] = ACTIONS(569),
    [anon_sym_noinline] = ACTIONS(569),
    [anon_sym_nomerge] = ACTIONS(569),
    [anon_sym_nonlazybind] = ACTIONS(569),
    [anon_sym_noprofile] = ACTIONS(569),
    [anon_sym_noredzone] = ACTIONS(569),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(569),
    [anon_sym_noreturn] = ACTIONS(569),
    [anon_sym_norecurse] = ACTIONS(569),
    [anon_sym_willreturn] = ACTIONS(569),
    [anon_sym_nosync] = ACTIONS(569),
    [anon_sym_nounwind] = ACTIONS(569),
    [anon_sym_nosanitize_coverage] = ACTIONS(569),
    [anon_sym_null_pointer_is_valid] = ACTIONS(569),
    [anon_sym_optforfuzzing] = ACTIONS(569),
    [anon_sym_optnone] = ACTIONS(569),
    [anon_sym_optsize] = ACTIONS(569),
    [anon_sym_readnone] = ACTIONS(569),
    [anon_sym_readonly] = ACTIONS(569),
    [anon_sym_writeonly] = ACTIONS(569),
    [anon_sym_argmemonly] = ACTIONS(569),
    [anon_sym_returns_twice] = ACTIONS(569),
    [anon_sym_safestack] = ACTIONS(569),
    [anon_sym_sanitize_address] = ACTIONS(569),
    [anon_sym_sanitize_memory] = ACTIONS(569),
    [anon_sym_sanitize_thread] = ACTIONS(569),
    [anon_sym_sanitize_hwaddress] = ACTIONS(569),
    [anon_sym_sanitize_memtag] = ACTIONS(569),
    [anon_sym_speculative_load_hardening] = ACTIONS(569),
    [anon_sym_speculatable] = ACTIONS(569),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(569),
    [anon_sym_sspreq] = ACTIONS(569),
    [anon_sym_strictfp] = ACTIONS(569),
    [anon_sym_uwtable] = ACTIONS(569),
    [anon_sym_nocf_check] = ACTIONS(569),
    [anon_sym_shadowcallstack] = ACTIONS(569),
    [anon_sym_mustprogress] = ACTIONS(569),
    [anon_sym_vscale_range] = ACTIONS(569),
    [anon_sym_preallocated] = ACTIONS(569),
    [anon_sym_zeroext] = ACTIONS(569),
    [anon_sym_signext] = ACTIONS(569),
    [anon_sym_inreg] = ACTIONS(569),
    [anon_sym_byval] = ACTIONS(569),
    [anon_sym_byref] = ACTIONS(569),
    [anon_sym_inalloca] = ACTIONS(569),
    [anon_sym_sret] = ACTIONS(569),
    [anon_sym_elementtype] = ACTIONS(569),
    [anon_sym_noalias] = ACTIONS(569),
    [anon_sym_nocapture] = ACTIONS(569),
    [anon_sym_nest] = ACTIONS(569),
    [anon_sym_returned] = ACTIONS(569),
    [anon_sym_nonnull] = ACTIONS(569),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(569),
    [anon_sym_swiftself] = ACTIONS(569),
    [anon_sym_swiftasync] = ACTIONS(569),
    [anon_sym_swifterror] = ACTIONS(569),
    [anon_sym_immarg] = ACTIONS(569),
    [anon_sym_noundef] = ACTIONS(569),
    [anon_sym_to] = ACTIONS(571),
    [anon_sym_uselistorder] = ACTIONS(571),
    [anon_sym_uselistorder_bb] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_attributes] = ACTIONS(569),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(577),
    [sym_comdat_ref] = ACTIONS(577),
    [sym_global_var] = ACTIONS(577),
    [sym_local_var] = ACTIONS(577),
    [aux_sym_metadata_ref_token1] = ACTIONS(577),
    [sym_summary_ref] = ACTIONS(577),
    [sym_string] = ACTIONS(577),
    [anon_sym_target] = ACTIONS(577),
    [anon_sym_source_filename] = ACTIONS(577),
    [anon_sym_declare] = ACTIONS(577),
    [anon_sym_define] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(577),
    [anon_sym_half] = ACTIONS(577),
    [anon_sym_bfloat] = ACTIONS(577),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_double] = ACTIONS(577),
    [anon_sym_x86_fp80] = ACTIONS(577),
    [anon_sym_fp128] = ACTIONS(577),
    [anon_sym_ppc_fp128] = ACTIONS(577),
    [anon_sym_label] = ACTIONS(577),
    [anon_sym_metadata] = ACTIONS(577),
    [anon_sym_x86_mmx] = ACTIONS(577),
    [anon_sym_x86_amx] = ACTIONS(577),
    [anon_sym_token] = ACTIONS(577),
    [anon_sym_opaque] = ACTIONS(577),
    [anon_sym_ptr] = ACTIONS(577),
    [aux_sym_type_keyword_token1] = ACTIONS(577),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_LT_LBRACE] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(577),
    [anon_sym_align] = ACTIONS(579),
    [anon_sym_section] = ACTIONS(577),
    [anon_sym_partition] = ACTIONS(577),
    [anon_sym_comdat] = ACTIONS(577),
    [anon_sym_gc] = ACTIONS(577),
    [anon_sym_prefix] = ACTIONS(577),
    [anon_sym_prologue] = ACTIONS(577),
    [anon_sym_personality] = ACTIONS(577),
    [anon_sym_alignstack] = ACTIONS(577),
    [anon_sym_allocsize] = ACTIONS(577),
    [anon_sym_alwaysinline] = ACTIONS(577),
    [anon_sym_builtin] = ACTIONS(577),
    [anon_sym_cold] = ACTIONS(577),
    [anon_sym_convergent] = ACTIONS(577),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(577),
    [anon_sym_hot] = ACTIONS(577),
    [anon_sym_inaccessiblememonly] = ACTIONS(577),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(577),
    [anon_sym_inlinehint] = ACTIONS(577),
    [anon_sym_jumptable] = ACTIONS(577),
    [anon_sym_minsize] = ACTIONS(577),
    [anon_sym_naked] = ACTIONS(577),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(577),
    [anon_sym_nobuiltin] = ACTIONS(577),
    [anon_sym_noduplicate] = ACTIONS(577),
    [anon_sym_nofree] = ACTIONS(577),
    [anon_sym_noimplicitfloat] = ACTIONS(577),
    [anon_sym_noinline] = ACTIONS(577),
    [anon_sym_nomerge] = ACTIONS(577),
    [anon_sym_nonlazybind] = ACTIONS(577),
    [anon_sym_noprofile] = ACTIONS(577),
    [anon_sym_noredzone] = ACTIONS(577),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(577),
    [anon_sym_noreturn] = ACTIONS(577),
    [anon_sym_norecurse] = ACTIONS(577),
    [anon_sym_willreturn] = ACTIONS(577),
    [anon_sym_nosync] = ACTIONS(577),
    [anon_sym_nounwind] = ACTIONS(577),
    [anon_sym_nosanitize_coverage] = ACTIONS(577),
    [anon_sym_null_pointer_is_valid] = ACTIONS(577),
    [anon_sym_optforfuzzing] = ACTIONS(577),
    [anon_sym_optnone] = ACTIONS(577),
    [anon_sym_optsize] = ACTIONS(577),
    [anon_sym_readnone] = ACTIONS(577),
    [anon_sym_readonly] = ACTIONS(577),
    [anon_sym_writeonly] = ACTIONS(577),
    [anon_sym_argmemonly] = ACTIONS(577),
    [anon_sym_returns_twice] = ACTIONS(577),
    [anon_sym_safestack] = ACTIONS(577),
    [anon_sym_sanitize_address] = ACTIONS(577),
    [anon_sym_sanitize_memory] = ACTIONS(577),
    [anon_sym_sanitize_thread] = ACTIONS(577),
    [anon_sym_sanitize_hwaddress] = ACTIONS(577),
    [anon_sym_sanitize_memtag] = ACTIONS(577),
    [anon_sym_speculative_load_hardening] = ACTIONS(577),
    [anon_sym_speculatable] = ACTIONS(577),
    [anon_sym_ssp] = ACTIONS(579),
    [anon_sym_sspstrong] = ACTIONS(577),
    [anon_sym_sspreq] = ACTIONS(577),
    [anon_sym_strictfp] = ACTIONS(577),
    [anon_sym_uwtable] = ACTIONS(577),
    [anon_sym_nocf_check] = ACTIONS(577),
    [anon_sym_shadowcallstack] = ACTIONS(577),
    [anon_sym_mustprogress] = ACTIONS(577),
    [anon_sym_vscale_range] = ACTIONS(577),
    [anon_sym_preallocated] = ACTIONS(577),
    [anon_sym_zeroext] = ACTIONS(577),
    [anon_sym_signext] = ACTIONS(577),
    [anon_sym_inreg] = ACTIONS(577),
    [anon_sym_byval] = ACTIONS(577),
    [anon_sym_byref] = ACTIONS(577),
    [anon_sym_inalloca] = ACTIONS(577),
    [anon_sym_sret] = ACTIONS(577),
    [anon_sym_elementtype] = ACTIONS(577),
    [anon_sym_noalias] = ACTIONS(577),
    [anon_sym_nocapture] = ACTIONS(577),
    [anon_sym_nest] = ACTIONS(577),
    [anon_sym_returned] = ACTIONS(577),
    [anon_sym_nonnull] = ACTIONS(577),
    [anon_sym_dereferenceable] = ACTIONS(579),
    [anon_sym_dereferenceable_or_null] = ACTIONS(577),
    [anon_sym_swiftself] = ACTIONS(577),
    [anon_sym_swiftasync] = ACTIONS(577),
    [anon_sym_swifterror] = ACTIONS(577),
    [anon_sym_immarg] = ACTIONS(577),
    [anon_sym_noundef] = ACTIONS(577),
    [anon_sym_to] = ACTIONS(579),
    [anon_sym_uselistorder] = ACTIONS(579),
    [anon_sym_uselistorder_bb] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_attributes] = ACTIONS(577),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(591),
    [sym_comdat_ref] = ACTIONS(591),
    [sym_global_var] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [aux_sym_metadata_ref_token1] = ACTIONS(591),
    [sym_summary_ref] = ACTIONS(591),
    [sym_string] = ACTIONS(591),
    [anon_sym_target] = ACTIONS(591),
    [anon_sym_source_filename] = ACTIONS(591),
    [anon_sym_declare] = ACTIONS(591),
    [anon_sym_define] = ACTIONS(591),
    [anon_sym_void] = ACTIONS(591),
    [anon_sym_half] = ACTIONS(591),
    [anon_sym_bfloat] = ACTIONS(591),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_double] = ACTIONS(591),
    [anon_sym_x86_fp80] = ACTIONS(591),
    [anon_sym_fp128] = ACTIONS(591),
    [anon_sym_ppc_fp128] = ACTIONS(591),
    [anon_sym_label] = ACTIONS(591),
    [anon_sym_metadata] = ACTIONS(591),
    [anon_sym_x86_mmx] = ACTIONS(591),
    [anon_sym_x86_amx] = ACTIONS(591),
    [anon_sym_token] = ACTIONS(591),
    [anon_sym_opaque] = ACTIONS(591),
    [anon_sym_ptr] = ACTIONS(591),
    [aux_sym_type_keyword_token1] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LT_LBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_section] = ACTIONS(591),
    [anon_sym_partition] = ACTIONS(591),
    [anon_sym_comdat] = ACTIONS(591),
    [anon_sym_gc] = ACTIONS(591),
    [anon_sym_prefix] = ACTIONS(591),
    [anon_sym_prologue] = ACTIONS(591),
    [anon_sym_personality] = ACTIONS(591),
    [anon_sym_alignstack] = ACTIONS(591),
    [anon_sym_allocsize] = ACTIONS(591),
    [anon_sym_alwaysinline] = ACTIONS(591),
    [anon_sym_builtin] = ACTIONS(591),
    [anon_sym_cold] = ACTIONS(591),
    [anon_sym_convergent] = ACTIONS(591),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(591),
    [anon_sym_hot] = ACTIONS(591),
    [anon_sym_inaccessiblememonly] = ACTIONS(591),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(591),
    [anon_sym_inlinehint] = ACTIONS(591),
    [anon_sym_jumptable] = ACTIONS(591),
    [anon_sym_minsize] = ACTIONS(591),
    [anon_sym_naked] = ACTIONS(591),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(591),
    [anon_sym_nobuiltin] = ACTIONS(591),
    [anon_sym_noduplicate] = ACTIONS(591),
    [anon_sym_nofree] = ACTIONS(591),
    [anon_sym_noimplicitfloat] = ACTIONS(591),
    [anon_sym_noinline] = ACTIONS(591),
    [anon_sym_nomerge] = ACTIONS(591),
    [anon_sym_nonlazybind] = ACTIONS(591),
    [anon_sym_noprofile] = ACTIONS(591),
    [anon_sym_noredzone] = ACTIONS(591),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(591),
    [anon_sym_noreturn] = ACTIONS(591),
    [anon_sym_norecurse] = ACTIONS(591),
    [anon_sym_willreturn] = ACTIONS(591),
    [anon_sym_nosync] = ACTIONS(591),
    [anon_sym_nounwind] = ACTIONS(591),
    [anon_sym_nosanitize_coverage] = ACTIONS(591),
    [anon_sym_null_pointer_is_valid] = ACTIONS(591),
    [anon_sym_optforfuzzing] = ACTIONS(591),
    [anon_sym_optnone] = ACTIONS(591),
    [anon_sym_optsize] = ACTIONS(591),
    [anon_sym_readnone] = ACTIONS(591),
    [anon_sym_readonly] = ACTIONS(591),
    [anon_sym_writeonly] = ACTIONS(591),
    [anon_sym_argmemonly] = ACTIONS(591),
    [anon_sym_returns_twice] = ACTIONS(591),
    [anon_sym_safestack] = ACTIONS(591),
    [anon_sym_sanitize_address] = ACTIONS(591),
    [anon_sym_sanitize_memory] = ACTIONS(591),
    [anon_sym_sanitize_thread] = ACTIONS(591),
    [anon_sym_sanitize_hwaddress] = ACTIONS(591),
    [anon_sym_sanitize_memtag] = ACTIONS(591),
    [anon_sym_speculative_load_hardening] = ACTIONS(591),
    [anon_sym_speculatable] = ACTIONS(591),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(591),
    [anon_sym_sspreq] = ACTIONS(591),
    [anon_sym_strictfp] = ACTIONS(591),
    [anon_sym_uwtable] = ACTIONS(591),
    [anon_sym_nocf_check] = ACTIONS(591),
    [anon_sym_shadowcallstack] = ACTIONS(591),
    [anon_sym_mustprogress] = ACTIONS(591),
    [anon_sym_vscale_range] = ACTIONS(591),
    [anon_sym_preallocated] = ACTIONS(591),
    [anon_sym_zeroext] = ACTIONS(591),
    [anon_sym_signext] = ACTIONS(591),
    [anon_sym_inreg] = ACTIONS(591),
    [anon_sym_byval] = ACTIONS(591),
    [anon_sym_byref] = ACTIONS(591),
    [anon_sym_inalloca] = ACTIONS(591),
    [anon_sym_sret] = ACTIONS(591),
    [anon_sym_elementtype] = ACTIONS(591),
    [anon_sym_noalias] = ACTIONS(591),
    [anon_sym_nocapture] = ACTIONS(591),
    [anon_sym_nest] = ACTIONS(591),
    [anon_sym_returned] = ACTIONS(591),
    [anon_sym_nonnull] = ACTIONS(591),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(591),
    [anon_sym_swiftself] = ACTIONS(591),
    [anon_sym_swiftasync] = ACTIONS(591),
    [anon_sym_swifterror] = ACTIONS(591),
    [anon_sym_immarg] = ACTIONS(591),
    [anon_sym_noundef] = ACTIONS(591),
    [anon_sym_to] = ACTIONS(593),
    [anon_sym_uselistorder] = ACTIONS(593),
    [anon_sym_uselistorder_bb] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_attributes] = ACTIONS(591),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(635),
    [sym_comdat_ref] = ACTIONS(635),
    [sym_global_var] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [aux_sym_metadata_ref_token1] = ACTIONS(635),
    [sym_summary_ref] = ACTIONS(635),
    [sym_string] = ACTIONS(635),
    [anon_sym_target] = ACTIONS(635),
    [anon_sym_source_filename] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(635),
    [anon_sym_define] = ACTIONS(635),
    [anon_sym_void] = ACTIONS(635),
    [anon_sym_half] = ACTIONS(635),
    [anon_sym_bfloat] = ACTIONS(635),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_double] = ACTIONS(635),
    [anon_sym_x86_fp80] = ACTIONS(635),
    [anon_sym_fp128] = ACTIONS(635),
    [anon_sym_ppc_fp128] = ACTIONS(635),
    [anon_sym_label] = ACTIONS(635),
    [anon_sym_metadata] = ACTIONS(635),
    [anon_sym_x86_mmx] = ACTIONS(635),
    [anon_sym_x86_amx] = ACTIONS(635),
    [anon_sym_token] = ACTIONS(635),
    [anon_sym_opaque] = ACTIONS(635),
    [anon_sym_ptr] = ACTIONS(635),
    [aux_sym_type_keyword_token1] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LT_LBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_section] = ACTIONS(635),
    [anon_sym_partition] = ACTIONS(635),
    [anon_sym_comdat] = ACTIONS(635),
    [anon_sym_gc] = ACTIONS(635),
    [anon_sym_prefix] = ACTIONS(635),
    [anon_sym_prologue] = ACTIONS(635),
    [anon_sym_personality] = ACTIONS(635),
    [anon_sym_alignstack] = ACTIONS(635),
    [anon_sym_allocsize] = ACTIONS(635),
    [anon_sym_alwaysinline] = ACTIONS(635),
    [anon_sym_builtin] = ACTIONS(635),
    [anon_sym_cold] = ACTIONS(635),
    [anon_sym_convergent] = ACTIONS(635),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(635),
    [anon_sym_hot] = ACTIONS(635),
    [anon_sym_inaccessiblememonly] = ACTIONS(635),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(635),
    [anon_sym_inlinehint] = ACTIONS(635),
    [anon_sym_jumptable] = ACTIONS(635),
    [anon_sym_minsize] = ACTIONS(635),
    [anon_sym_naked] = ACTIONS(635),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(635),
    [anon_sym_nobuiltin] = ACTIONS(635),
    [anon_sym_noduplicate] = ACTIONS(635),
    [anon_sym_nofree] = ACTIONS(635),
    [anon_sym_noimplicitfloat] = ACTIONS(635),
    [anon_sym_noinline] = ACTIONS(635),
    [anon_sym_nomerge] = ACTIONS(635),
    [anon_sym_nonlazybind] = ACTIONS(635),
    [anon_sym_noprofile] = ACTIONS(635),
    [anon_sym_noredzone] = ACTIONS(635),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(635),
    [anon_sym_noreturn] = ACTIONS(635),
    [anon_sym_norecurse] = ACTIONS(635),
    [anon_sym_willreturn] = ACTIONS(635),
    [anon_sym_nosync] = ACTIONS(635),
    [anon_sym_nounwind] = ACTIONS(635),
    [anon_sym_nosanitize_coverage] = ACTIONS(635),
    [anon_sym_null_pointer_is_valid] = ACTIONS(635),
    [anon_sym_optforfuzzing] = ACTIONS(635),
    [anon_sym_optnone] = ACTIONS(635),
    [anon_sym_optsize] = ACTIONS(635),
    [anon_sym_readnone] = ACTIONS(635),
    [anon_sym_readonly] = ACTIONS(635),
    [anon_sym_writeonly] = ACTIONS(635),
    [anon_sym_argmemonly] = ACTIONS(635),
    [anon_sym_returns_twice] = ACTIONS(635),
    [anon_sym_safestack] = ACTIONS(635),
    [anon_sym_sanitize_address] = ACTIONS(635),
    [anon_sym_sanitize_memory] = ACTIONS(635),
    [anon_sym_sanitize_thread] = ACTIONS(635),
    [anon_sym_sanitize_hwaddress] = ACTIONS(635),
    [anon_sym_sanitize_memtag] = ACTIONS(635),
    [anon_sym_speculative_load_hardening] = ACTIONS(635),
    [anon_sym_speculatable] = ACTIONS(635),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(635),
    [anon_sym_sspreq] = ACTIONS(635),
    [anon_sym_strictfp] = ACTIONS(635),
    [anon_sym_uwtable] = ACTIONS(635),
    [anon_sym_nocf_check] = ACTIONS(635),
    [anon_sym_shadowcallstack] = ACTIONS(635),
    [anon_sym_mustprogress] = ACTIONS(635),
    [anon_sym_vscale_range] = ACTIONS(635),
    [anon_sym_preallocated] = ACTIONS(635),
    [anon_sym_zeroext] = ACTIONS(635),
    [anon_sym_signext] = ACTIONS(635),
    [anon_sym_inreg] = ACTIONS(635),
    [anon_sym_byval] = ACTIONS(635),
    [anon_sym_byref] = ACTIONS(635),
    [anon_sym_inalloca] = ACTIONS(635),
    [anon_sym_sret] = ACTIONS(635),
    [anon_sym_elementtype] = ACTIONS(635),
    [anon_sym_noalias] = ACTIONS(635),
    [anon_sym_nocapture] = ACTIONS(635),
    [anon_sym_nest] = ACTIONS(635),
    [anon_sym_returned] = ACTIONS(635),
    [anon_sym_nonnull] = ACTIONS(635),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(635),
    [anon_sym_swiftself] = ACTIONS(635),
    [anon_sym_swiftasync] = ACTIONS(635),
    [anon_sym_swifterror] = ACTIONS(635),
    [anon_sym_immarg] = ACTIONS(635),
    [anon_sym_noundef] = ACTIONS(635),
    [anon_sym_to] = ACTIONS(637),
    [anon_sym_uselistorder] = ACTIONS(637),
    [anon_sym_uselistorder_bb] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_attributes] = ACTIONS(635),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(533),
    [sym_comdat_ref] = ACTIONS(533),
    [sym_global_var] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [aux_sym_metadata_ref_token1] = ACTIONS(533),
    [sym_summary_ref] = ACTIONS(533),
    [sym_string] = ACTIONS(533),
    [anon_sym_target] = ACTIONS(533),
    [anon_sym_source_filename] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_define] = ACTIONS(533),
    [anon_sym_void] = ACTIONS(533),
    [anon_sym_half] = ACTIONS(533),
    [anon_sym_bfloat] = ACTIONS(533),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_double] = ACTIONS(533),
    [anon_sym_x86_fp80] = ACTIONS(533),
    [anon_sym_fp128] = ACTIONS(533),
    [anon_sym_ppc_fp128] = ACTIONS(533),
    [anon_sym_label] = ACTIONS(533),
    [anon_sym_metadata] = ACTIONS(533),
    [anon_sym_x86_mmx] = ACTIONS(533),
    [anon_sym_x86_amx] = ACTIONS(533),
    [anon_sym_token] = ACTIONS(533),
    [anon_sym_opaque] = ACTIONS(533),
    [anon_sym_ptr] = ACTIONS(533),
    [aux_sym_type_keyword_token1] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LT_LBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_RBRACK] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_section] = ACTIONS(533),
    [anon_sym_partition] = ACTIONS(533),
    [anon_sym_comdat] = ACTIONS(533),
    [anon_sym_gc] = ACTIONS(533),
    [anon_sym_prefix] = ACTIONS(533),
    [anon_sym_prologue] = ACTIONS(533),
    [anon_sym_personality] = ACTIONS(533),
    [anon_sym_alignstack] = ACTIONS(533),
    [anon_sym_allocsize] = ACTIONS(533),
    [anon_sym_alwaysinline] = ACTIONS(533),
    [anon_sym_builtin] = ACTIONS(533),
    [anon_sym_cold] = ACTIONS(533),
    [anon_sym_convergent] = ACTIONS(533),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(533),
    [anon_sym_hot] = ACTIONS(533),
    [anon_sym_inaccessiblememonly] = ACTIONS(533),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(533),
    [anon_sym_inlinehint] = ACTIONS(533),
    [anon_sym_jumptable] = ACTIONS(533),
    [anon_sym_minsize] = ACTIONS(533),
    [anon_sym_naked] = ACTIONS(533),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(533),
    [anon_sym_nobuiltin] = ACTIONS(533),
    [anon_sym_noduplicate] = ACTIONS(533),
    [anon_sym_nofree] = ACTIONS(533),
    [anon_sym_noimplicitfloat] = ACTIONS(533),
    [anon_sym_noinline] = ACTIONS(533),
    [anon_sym_nomerge] = ACTIONS(533),
    [anon_sym_nonlazybind] = ACTIONS(533),
    [anon_sym_noprofile] = ACTIONS(533),
    [anon_sym_noredzone] = ACTIONS(533),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(533),
    [anon_sym_noreturn] = ACTIONS(533),
    [anon_sym_norecurse] = ACTIONS(533),
    [anon_sym_willreturn] = ACTIONS(533),
    [anon_sym_nosync] = ACTIONS(533),
    [anon_sym_nounwind] = ACTIONS(533),
    [anon_sym_nosanitize_coverage] = ACTIONS(533),
    [anon_sym_null_pointer_is_valid] = ACTIONS(533),
    [anon_sym_optforfuzzing] = ACTIONS(533),
    [anon_sym_optnone] = ACTIONS(533),
    [anon_sym_optsize] = ACTIONS(533),
    [anon_sym_readnone] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_writeonly] = ACTIONS(533),
    [anon_sym_argmemonly] = ACTIONS(533),
    [anon_sym_returns_twice] = ACTIONS(533),
    [anon_sym_safestack] = ACTIONS(533),
    [anon_sym_sanitize_address] = ACTIONS(533),
    [anon_sym_sanitize_memory] = ACTIONS(533),
    [anon_sym_sanitize_thread] = ACTIONS(533),
    [anon_sym_sanitize_hwaddress] = ACTIONS(533),
    [anon_sym_sanitize_memtag] = ACTIONS(533),
    [anon_sym_speculative_load_hardening] = ACTIONS(533),
    [anon_sym_speculatable] = ACTIONS(533),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(533),
    [anon_sym_sspreq] = ACTIONS(533),
    [anon_sym_strictfp] = ACTIONS(533),
    [anon_sym_uwtable] = ACTIONS(533),
    [anon_sym_nocf_check] = ACTIONS(533),
    [anon_sym_shadowcallstack] = ACTIONS(533),
    [anon_sym_mustprogress] = ACTIONS(533),
    [anon_sym_vscale_range] = ACTIONS(533),
    [anon_sym_preallocated] = ACTIONS(533),
    [anon_sym_zeroext] = ACTIONS(533),
    [anon_sym_signext] = ACTIONS(533),
    [anon_sym_inreg] = ACTIONS(533),
    [anon_sym_byval] = ACTIONS(533),
    [anon_sym_byref] = ACTIONS(533),
    [anon_sym_inalloca] = ACTIONS(533),
    [anon_sym_sret] = ACTIONS(533),
    [anon_sym_elementtype] = ACTIONS(533),
    [anon_sym_noalias] = ACTIONS(533),
    [anon_sym_nocapture] = ACTIONS(533),
    [anon_sym_nest] = ACTIONS(533),
    [anon_sym_returned] = ACTIONS(533),
    [anon_sym_nonnull] = ACTIONS(533),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(533),
    [anon_sym_swiftself] = ACTIONS(533),
    [anon_sym_swiftasync] = ACTIONS(533),
    [anon_sym_swifterror] = ACTIONS(533),
    [anon_sym_immarg] = ACTIONS(533),
    [anon_sym_noundef] = ACTIONS(533),
    [anon_sym_to] = ACTIONS(535),
    [anon_sym_uselistorder] = ACTIONS(535),
    [anon_sym_uselistorder_bb] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_attributes] = ACTIONS(533),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(599),
    [sym_comdat_ref] = ACTIONS(599),
    [sym_global_var] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [aux_sym_metadata_ref_token1] = ACTIONS(599),
    [sym_summary_ref] = ACTIONS(599),
    [sym_string] = ACTIONS(599),
    [anon_sym_target] = ACTIONS(599),
    [anon_sym_source_filename] = ACTIONS(599),
    [anon_sym_declare] = ACTIONS(599),
    [anon_sym_define] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(599),
    [anon_sym_half] = ACTIONS(599),
    [anon_sym_bfloat] = ACTIONS(599),
    [anon_sym_float] = ACTIONS(599),
    [anon_sym_double] = ACTIONS(599),
    [anon_sym_x86_fp80] = ACTIONS(599),
    [anon_sym_fp128] = ACTIONS(599),
    [anon_sym_ppc_fp128] = ACTIONS(599),
    [anon_sym_label] = ACTIONS(599),
    [anon_sym_metadata] = ACTIONS(599),
    [anon_sym_x86_mmx] = ACTIONS(599),
    [anon_sym_x86_amx] = ACTIONS(599),
    [anon_sym_token] = ACTIONS(599),
    [anon_sym_opaque] = ACTIONS(599),
    [anon_sym_ptr] = ACTIONS(599),
    [aux_sym_type_keyword_token1] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LT_LBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_section] = ACTIONS(599),
    [anon_sym_partition] = ACTIONS(599),
    [anon_sym_comdat] = ACTIONS(599),
    [anon_sym_gc] = ACTIONS(599),
    [anon_sym_prefix] = ACTIONS(599),
    [anon_sym_prologue] = ACTIONS(599),
    [anon_sym_personality] = ACTIONS(599),
    [anon_sym_alignstack] = ACTIONS(599),
    [anon_sym_allocsize] = ACTIONS(599),
    [anon_sym_alwaysinline] = ACTIONS(599),
    [anon_sym_builtin] = ACTIONS(599),
    [anon_sym_cold] = ACTIONS(599),
    [anon_sym_convergent] = ACTIONS(599),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(599),
    [anon_sym_hot] = ACTIONS(599),
    [anon_sym_inaccessiblememonly] = ACTIONS(599),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(599),
    [anon_sym_inlinehint] = ACTIONS(599),
    [anon_sym_jumptable] = ACTIONS(599),
    [anon_sym_minsize] = ACTIONS(599),
    [anon_sym_naked] = ACTIONS(599),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(599),
    [anon_sym_nobuiltin] = ACTIONS(599),
    [anon_sym_noduplicate] = ACTIONS(599),
    [anon_sym_nofree] = ACTIONS(599),
    [anon_sym_noimplicitfloat] = ACTIONS(599),
    [anon_sym_noinline] = ACTIONS(599),
    [anon_sym_nomerge] = ACTIONS(599),
    [anon_sym_nonlazybind] = ACTIONS(599),
    [anon_sym_noprofile] = ACTIONS(599),
    [anon_sym_noredzone] = ACTIONS(599),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(599),
    [anon_sym_noreturn] = ACTIONS(599),
    [anon_sym_norecurse] = ACTIONS(599),
    [anon_sym_willreturn] = ACTIONS(599),
    [anon_sym_nosync] = ACTIONS(599),
    [anon_sym_nounwind] = ACTIONS(599),
    [anon_sym_nosanitize_coverage] = ACTIONS(599),
    [anon_sym_null_pointer_is_valid] = ACTIONS(599),
    [anon_sym_optforfuzzing] = ACTIONS(599),
    [anon_sym_optnone] = ACTIONS(599),
    [anon_sym_optsize] = ACTIONS(599),
    [anon_sym_readnone] = ACTIONS(599),
    [anon_sym_readonly] = ACTIONS(599),
    [anon_sym_writeonly] = ACTIONS(599),
    [anon_sym_argmemonly] = ACTIONS(599),
    [anon_sym_returns_twice] = ACTIONS(599),
    [anon_sym_safestack] = ACTIONS(599),
    [anon_sym_sanitize_address] = ACTIONS(599),
    [anon_sym_sanitize_memory] = ACTIONS(599),
    [anon_sym_sanitize_thread] = ACTIONS(599),
    [anon_sym_sanitize_hwaddress] = ACTIONS(599),
    [anon_sym_sanitize_memtag] = ACTIONS(599),
    [anon_sym_speculative_load_hardening] = ACTIONS(599),
    [anon_sym_speculatable] = ACTIONS(599),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(599),
    [anon_sym_sspreq] = ACTIONS(599),
    [anon_sym_strictfp] = ACTIONS(599),
    [anon_sym_uwtable] = ACTIONS(599),
    [anon_sym_nocf_check] = ACTIONS(599),
    [anon_sym_shadowcallstack] = ACTIONS(599),
    [anon_sym_mustprogress] = ACTIONS(599),
    [anon_sym_vscale_range] = ACTIONS(599),
    [anon_sym_preallocated] = ACTIONS(599),
    [anon_sym_zeroext] = ACTIONS(599),
    [anon_sym_signext] = ACTIONS(599),
    [anon_sym_inreg] = ACTIONS(599),
    [anon_sym_byval] = ACTIONS(599),
    [anon_sym_byref] = ACTIONS(599),
    [anon_sym_inalloca] = ACTIONS(599),
    [anon_sym_sret] = ACTIONS(599),
    [anon_sym_elementtype] = ACTIONS(599),
    [anon_sym_noalias] = ACTIONS(599),
    [anon_sym_nocapture] = ACTIONS(599),
    [anon_sym_nest] = ACTIONS(599),
    [anon_sym_returned] = ACTIONS(599),
    [anon_sym_nonnull] = ACTIONS(599),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(599),
    [anon_sym_swiftself] = ACTIONS(599),
    [anon_sym_swiftasync] = ACTIONS(599),
    [anon_sym_swifterror] = ACTIONS(599),
    [anon_sym_immarg] = ACTIONS(599),
    [anon_sym_noundef] = ACTIONS(599),
    [anon_sym_to] = ACTIONS(601),
    [anon_sym_uselistorder] = ACTIONS(601),
    [anon_sym_uselistorder_bb] = ACTIONS(599),
    [anon_sym_module] = ACTIONS(599),
    [anon_sym_attributes] = ACTIONS(599),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(607),
    [sym_comdat_ref] = ACTIONS(607),
    [sym_global_var] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [aux_sym_metadata_ref_token1] = ACTIONS(607),
    [sym_summary_ref] = ACTIONS(607),
    [sym_string] = ACTIONS(607),
    [anon_sym_target] = ACTIONS(607),
    [anon_sym_source_filename] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(607),
    [anon_sym_define] = ACTIONS(607),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_half] = ACTIONS(607),
    [anon_sym_bfloat] = ACTIONS(607),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_double] = ACTIONS(607),
    [anon_sym_x86_fp80] = ACTIONS(607),
    [anon_sym_fp128] = ACTIONS(607),
    [anon_sym_ppc_fp128] = ACTIONS(607),
    [anon_sym_label] = ACTIONS(607),
    [anon_sym_metadata] = ACTIONS(607),
    [anon_sym_x86_mmx] = ACTIONS(607),
    [anon_sym_x86_amx] = ACTIONS(607),
    [anon_sym_token] = ACTIONS(607),
    [anon_sym_opaque] = ACTIONS(607),
    [anon_sym_ptr] = ACTIONS(607),
    [aux_sym_type_keyword_token1] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LT_LBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_section] = ACTIONS(607),
    [anon_sym_partition] = ACTIONS(607),
    [anon_sym_comdat] = ACTIONS(607),
    [anon_sym_gc] = ACTIONS(607),
    [anon_sym_prefix] = ACTIONS(607),
    [anon_sym_prologue] = ACTIONS(607),
    [anon_sym_personality] = ACTIONS(607),
    [anon_sym_alignstack] = ACTIONS(607),
    [anon_sym_allocsize] = ACTIONS(607),
    [anon_sym_alwaysinline] = ACTIONS(607),
    [anon_sym_builtin] = ACTIONS(607),
    [anon_sym_cold] = ACTIONS(607),
    [anon_sym_convergent] = ACTIONS(607),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(607),
    [anon_sym_hot] = ACTIONS(607),
    [anon_sym_inaccessiblememonly] = ACTIONS(607),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(607),
    [anon_sym_inlinehint] = ACTIONS(607),
    [anon_sym_jumptable] = ACTIONS(607),
    [anon_sym_minsize] = ACTIONS(607),
    [anon_sym_naked] = ACTIONS(607),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(607),
    [anon_sym_nobuiltin] = ACTIONS(607),
    [anon_sym_noduplicate] = ACTIONS(607),
    [anon_sym_nofree] = ACTIONS(607),
    [anon_sym_noimplicitfloat] = ACTIONS(607),
    [anon_sym_noinline] = ACTIONS(607),
    [anon_sym_nomerge] = ACTIONS(607),
    [anon_sym_nonlazybind] = ACTIONS(607),
    [anon_sym_noprofile] = ACTIONS(607),
    [anon_sym_noredzone] = ACTIONS(607),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(607),
    [anon_sym_noreturn] = ACTIONS(607),
    [anon_sym_norecurse] = ACTIONS(607),
    [anon_sym_willreturn] = ACTIONS(607),
    [anon_sym_nosync] = ACTIONS(607),
    [anon_sym_nounwind] = ACTIONS(607),
    [anon_sym_nosanitize_coverage] = ACTIONS(607),
    [anon_sym_null_pointer_is_valid] = ACTIONS(607),
    [anon_sym_optforfuzzing] = ACTIONS(607),
    [anon_sym_optnone] = ACTIONS(607),
    [anon_sym_optsize] = ACTIONS(607),
    [anon_sym_readnone] = ACTIONS(607),
    [anon_sym_readonly] = ACTIONS(607),
    [anon_sym_writeonly] = ACTIONS(607),
    [anon_sym_argmemonly] = ACTIONS(607),
    [anon_sym_returns_twice] = ACTIONS(607),
    [anon_sym_safestack] = ACTIONS(607),
    [anon_sym_sanitize_address] = ACTIONS(607),
    [anon_sym_sanitize_memory] = ACTIONS(607),
    [anon_sym_sanitize_thread] = ACTIONS(607),
    [anon_sym_sanitize_hwaddress] = ACTIONS(607),
    [anon_sym_sanitize_memtag] = ACTIONS(607),
    [anon_sym_speculative_load_hardening] = ACTIONS(607),
    [anon_sym_speculatable] = ACTIONS(607),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(607),
    [anon_sym_sspreq] = ACTIONS(607),
    [anon_sym_strictfp] = ACTIONS(607),
    [anon_sym_uwtable] = ACTIONS(607),
    [anon_sym_nocf_check] = ACTIONS(607),
    [anon_sym_shadowcallstack] = ACTIONS(607),
    [anon_sym_mustprogress] = ACTIONS(607),
    [anon_sym_vscale_range] = ACTIONS(607),
    [anon_sym_preallocated] = ACTIONS(607),
    [anon_sym_zeroext] = ACTIONS(607),
    [anon_sym_signext] = ACTIONS(607),
    [anon_sym_inreg] = ACTIONS(607),
    [anon_sym_byval] = ACTIONS(607),
    [anon_sym_byref] = ACTIONS(607),
    [anon_sym_inalloca] = ACTIONS(607),
    [anon_sym_sret] = ACTIONS(607),
    [anon_sym_elementtype] = ACTIONS(607),
    [anon_sym_noalias] = ACTIONS(607),
    [anon_sym_nocapture] = ACTIONS(607),
    [anon_sym_nest] = ACTIONS(607),
    [anon_sym_returned] = ACTIONS(607),
    [anon_sym_nonnull] = ACTIONS(607),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(607),
    [anon_sym_swiftself] = ACTIONS(607),
    [anon_sym_swiftasync] = ACTIONS(607),
    [anon_sym_swifterror] = ACTIONS(607),
    [anon_sym_immarg] = ACTIONS(607),
    [anon_sym_noundef] = ACTIONS(607),
    [anon_sym_to] = ACTIONS(609),
    [anon_sym_uselistorder] = ACTIONS(609),
    [anon_sym_uselistorder_bb] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_attributes] = ACTIONS(607),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(573),
    [sym_comdat_ref] = ACTIONS(573),
    [sym_global_var] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [aux_sym_metadata_ref_token1] = ACTIONS(573),
    [sym_summary_ref] = ACTIONS(573),
    [sym_string] = ACTIONS(573),
    [anon_sym_target] = ACTIONS(573),
    [anon_sym_source_filename] = ACTIONS(573),
    [anon_sym_declare] = ACTIONS(573),
    [anon_sym_define] = ACTIONS(573),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_half] = ACTIONS(573),
    [anon_sym_bfloat] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_double] = ACTIONS(573),
    [anon_sym_x86_fp80] = ACTIONS(573),
    [anon_sym_fp128] = ACTIONS(573),
    [anon_sym_ppc_fp128] = ACTIONS(573),
    [anon_sym_label] = ACTIONS(573),
    [anon_sym_metadata] = ACTIONS(573),
    [anon_sym_x86_mmx] = ACTIONS(573),
    [anon_sym_x86_amx] = ACTIONS(573),
    [anon_sym_token] = ACTIONS(573),
    [anon_sym_opaque] = ACTIONS(573),
    [anon_sym_ptr] = ACTIONS(573),
    [aux_sym_type_keyword_token1] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LT_LBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_section] = ACTIONS(573),
    [anon_sym_partition] = ACTIONS(573),
    [anon_sym_comdat] = ACTIONS(573),
    [anon_sym_gc] = ACTIONS(573),
    [anon_sym_prefix] = ACTIONS(573),
    [anon_sym_prologue] = ACTIONS(573),
    [anon_sym_personality] = ACTIONS(573),
    [anon_sym_alignstack] = ACTIONS(573),
    [anon_sym_allocsize] = ACTIONS(573),
    [anon_sym_alwaysinline] = ACTIONS(573),
    [anon_sym_builtin] = ACTIONS(573),
    [anon_sym_cold] = ACTIONS(573),
    [anon_sym_convergent] = ACTIONS(573),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(573),
    [anon_sym_hot] = ACTIONS(573),
    [anon_sym_inaccessiblememonly] = ACTIONS(573),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(573),
    [anon_sym_inlinehint] = ACTIONS(573),
    [anon_sym_jumptable] = ACTIONS(573),
    [anon_sym_minsize] = ACTIONS(573),
    [anon_sym_naked] = ACTIONS(573),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(573),
    [anon_sym_nobuiltin] = ACTIONS(573),
    [anon_sym_noduplicate] = ACTIONS(573),
    [anon_sym_nofree] = ACTIONS(573),
    [anon_sym_noimplicitfloat] = ACTIONS(573),
    [anon_sym_noinline] = ACTIONS(573),
    [anon_sym_nomerge] = ACTIONS(573),
    [anon_sym_nonlazybind] = ACTIONS(573),
    [anon_sym_noprofile] = ACTIONS(573),
    [anon_sym_noredzone] = ACTIONS(573),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(573),
    [anon_sym_noreturn] = ACTIONS(573),
    [anon_sym_norecurse] = ACTIONS(573),
    [anon_sym_willreturn] = ACTIONS(573),
    [anon_sym_nosync] = ACTIONS(573),
    [anon_sym_nounwind] = ACTIONS(573),
    [anon_sym_nosanitize_coverage] = ACTIONS(573),
    [anon_sym_null_pointer_is_valid] = ACTIONS(573),
    [anon_sym_optforfuzzing] = ACTIONS(573),
    [anon_sym_optnone] = ACTIONS(573),
    [anon_sym_optsize] = ACTIONS(573),
    [anon_sym_readnone] = ACTIONS(573),
    [anon_sym_readonly] = ACTIONS(573),
    [anon_sym_writeonly] = ACTIONS(573),
    [anon_sym_argmemonly] = ACTIONS(573),
    [anon_sym_returns_twice] = ACTIONS(573),
    [anon_sym_safestack] = ACTIONS(573),
    [anon_sym_sanitize_address] = ACTIONS(573),
    [anon_sym_sanitize_memory] = ACTIONS(573),
    [anon_sym_sanitize_thread] = ACTIONS(573),
    [anon_sym_sanitize_hwaddress] = ACTIONS(573),
    [anon_sym_sanitize_memtag] = ACTIONS(573),
    [anon_sym_speculative_load_hardening] = ACTIONS(573),
    [anon_sym_speculatable] = ACTIONS(573),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(573),
    [anon_sym_sspreq] = ACTIONS(573),
    [anon_sym_strictfp] = ACTIONS(573),
    [anon_sym_uwtable] = ACTIONS(573),
    [anon_sym_nocf_check] = ACTIONS(573),
    [anon_sym_shadowcallstack] = ACTIONS(573),
    [anon_sym_mustprogress] = ACTIONS(573),
    [anon_sym_vscale_range] = ACTIONS(573),
    [anon_sym_preallocated] = ACTIONS(573),
    [anon_sym_zeroext] = ACTIONS(573),
    [anon_sym_signext] = ACTIONS(573),
    [anon_sym_inreg] = ACTIONS(573),
    [anon_sym_byval] = ACTIONS(573),
    [anon_sym_byref] = ACTIONS(573),
    [anon_sym_inalloca] = ACTIONS(573),
    [anon_sym_sret] = ACTIONS(573),
    [anon_sym_elementtype] = ACTIONS(573),
    [anon_sym_noalias] = ACTIONS(573),
    [anon_sym_nocapture] = ACTIONS(573),
    [anon_sym_nest] = ACTIONS(573),
    [anon_sym_returned] = ACTIONS(573),
    [anon_sym_nonnull] = ACTIONS(573),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(573),
    [anon_sym_swiftself] = ACTIONS(573),
    [anon_sym_swiftasync] = ACTIONS(573),
    [anon_sym_swifterror] = ACTIONS(573),
    [anon_sym_immarg] = ACTIONS(573),
    [anon_sym_noundef] = ACTIONS(573),
    [anon_sym_to] = ACTIONS(575),
    [anon_sym_uselistorder] = ACTIONS(575),
    [anon_sym_uselistorder_bb] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_attributes] = ACTIONS(573),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(611),
    [sym_comdat_ref] = ACTIONS(611),
    [sym_global_var] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [aux_sym_metadata_ref_token1] = ACTIONS(611),
    [sym_summary_ref] = ACTIONS(611),
    [sym_string] = ACTIONS(611),
    [anon_sym_target] = ACTIONS(611),
    [anon_sym_source_filename] = ACTIONS(611),
    [anon_sym_declare] = ACTIONS(611),
    [anon_sym_define] = ACTIONS(611),
    [anon_sym_void] = ACTIONS(611),
    [anon_sym_half] = ACTIONS(611),
    [anon_sym_bfloat] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(611),
    [anon_sym_double] = ACTIONS(611),
    [anon_sym_x86_fp80] = ACTIONS(611),
    [anon_sym_fp128] = ACTIONS(611),
    [anon_sym_ppc_fp128] = ACTIONS(611),
    [anon_sym_label] = ACTIONS(611),
    [anon_sym_metadata] = ACTIONS(611),
    [anon_sym_x86_mmx] = ACTIONS(611),
    [anon_sym_x86_amx] = ACTIONS(611),
    [anon_sym_token] = ACTIONS(611),
    [anon_sym_opaque] = ACTIONS(611),
    [anon_sym_ptr] = ACTIONS(611),
    [aux_sym_type_keyword_token1] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LT_LBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_section] = ACTIONS(611),
    [anon_sym_partition] = ACTIONS(611),
    [anon_sym_comdat] = ACTIONS(611),
    [anon_sym_gc] = ACTIONS(611),
    [anon_sym_prefix] = ACTIONS(611),
    [anon_sym_prologue] = ACTIONS(611),
    [anon_sym_personality] = ACTIONS(611),
    [anon_sym_alignstack] = ACTIONS(611),
    [anon_sym_allocsize] = ACTIONS(611),
    [anon_sym_alwaysinline] = ACTIONS(611),
    [anon_sym_builtin] = ACTIONS(611),
    [anon_sym_cold] = ACTIONS(611),
    [anon_sym_convergent] = ACTIONS(611),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(611),
    [anon_sym_hot] = ACTIONS(611),
    [anon_sym_inaccessiblememonly] = ACTIONS(611),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(611),
    [anon_sym_inlinehint] = ACTIONS(611),
    [anon_sym_jumptable] = ACTIONS(611),
    [anon_sym_minsize] = ACTIONS(611),
    [anon_sym_naked] = ACTIONS(611),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(611),
    [anon_sym_nobuiltin] = ACTIONS(611),
    [anon_sym_noduplicate] = ACTIONS(611),
    [anon_sym_nofree] = ACTIONS(611),
    [anon_sym_noimplicitfloat] = ACTIONS(611),
    [anon_sym_noinline] = ACTIONS(611),
    [anon_sym_nomerge] = ACTIONS(611),
    [anon_sym_nonlazybind] = ACTIONS(611),
    [anon_sym_noprofile] = ACTIONS(611),
    [anon_sym_noredzone] = ACTIONS(611),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(611),
    [anon_sym_noreturn] = ACTIONS(611),
    [anon_sym_norecurse] = ACTIONS(611),
    [anon_sym_willreturn] = ACTIONS(611),
    [anon_sym_nosync] = ACTIONS(611),
    [anon_sym_nounwind] = ACTIONS(611),
    [anon_sym_nosanitize_coverage] = ACTIONS(611),
    [anon_sym_null_pointer_is_valid] = ACTIONS(611),
    [anon_sym_optforfuzzing] = ACTIONS(611),
    [anon_sym_optnone] = ACTIONS(611),
    [anon_sym_optsize] = ACTIONS(611),
    [anon_sym_readnone] = ACTIONS(611),
    [anon_sym_readonly] = ACTIONS(611),
    [anon_sym_writeonly] = ACTIONS(611),
    [anon_sym_argmemonly] = ACTIONS(611),
    [anon_sym_returns_twice] = ACTIONS(611),
    [anon_sym_safestack] = ACTIONS(611),
    [anon_sym_sanitize_address] = ACTIONS(611),
    [anon_sym_sanitize_memory] = ACTIONS(611),
    [anon_sym_sanitize_thread] = ACTIONS(611),
    [anon_sym_sanitize_hwaddress] = ACTIONS(611),
    [anon_sym_sanitize_memtag] = ACTIONS(611),
    [anon_sym_speculative_load_hardening] = ACTIONS(611),
    [anon_sym_speculatable] = ACTIONS(611),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(611),
    [anon_sym_sspreq] = ACTIONS(611),
    [anon_sym_strictfp] = ACTIONS(611),
    [anon_sym_uwtable] = ACTIONS(611),
    [anon_sym_nocf_check] = ACTIONS(611),
    [anon_sym_shadowcallstack] = ACTIONS(611),
    [anon_sym_mustprogress] = ACTIONS(611),
    [anon_sym_vscale_range] = ACTIONS(611),
    [anon_sym_preallocated] = ACTIONS(611),
    [anon_sym_zeroext] = ACTIONS(611),
    [anon_sym_signext] = ACTIONS(611),
    [anon_sym_inreg] = ACTIONS(611),
    [anon_sym_byval] = ACTIONS(611),
    [anon_sym_byref] = ACTIONS(611),
    [anon_sym_inalloca] = ACTIONS(611),
    [anon_sym_sret] = ACTIONS(611),
    [anon_sym_elementtype] = ACTIONS(611),
    [anon_sym_noalias] = ACTIONS(611),
    [anon_sym_nocapture] = ACTIONS(611),
    [anon_sym_nest] = ACTIONS(611),
    [anon_sym_returned] = ACTIONS(611),
    [anon_sym_nonnull] = ACTIONS(611),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(611),
    [anon_sym_swiftself] = ACTIONS(611),
    [anon_sym_swiftasync] = ACTIONS(611),
    [anon_sym_swifterror] = ACTIONS(611),
    [anon_sym_immarg] = ACTIONS(611),
    [anon_sym_noundef] = ACTIONS(611),
    [anon_sym_to] = ACTIONS(613),
    [anon_sym_uselistorder] = ACTIONS(613),
    [anon_sym_uselistorder_bb] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(611),
    [anon_sym_attributes] = ACTIONS(611),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(671),
    [sym_comdat_ref] = ACTIONS(671),
    [sym_global_var] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [aux_sym_metadata_ref_token1] = ACTIONS(671),
    [sym_summary_ref] = ACTIONS(671),
    [sym_string] = ACTIONS(671),
    [anon_sym_target] = ACTIONS(671),
    [anon_sym_source_filename] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_define] = ACTIONS(671),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_half] = ACTIONS(671),
    [anon_sym_bfloat] = ACTIONS(671),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_double] = ACTIONS(671),
    [anon_sym_x86_fp80] = ACTIONS(671),
    [anon_sym_fp128] = ACTIONS(671),
    [anon_sym_ppc_fp128] = ACTIONS(671),
    [anon_sym_label] = ACTIONS(671),
    [anon_sym_metadata] = ACTIONS(671),
    [anon_sym_x86_mmx] = ACTIONS(671),
    [anon_sym_x86_amx] = ACTIONS(671),
    [anon_sym_token] = ACTIONS(671),
    [anon_sym_opaque] = ACTIONS(671),
    [anon_sym_ptr] = ACTIONS(671),
    [aux_sym_type_keyword_token1] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LT_LBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_section] = ACTIONS(671),
    [anon_sym_partition] = ACTIONS(671),
    [anon_sym_comdat] = ACTIONS(671),
    [anon_sym_gc] = ACTIONS(671),
    [anon_sym_prefix] = ACTIONS(671),
    [anon_sym_prologue] = ACTIONS(671),
    [anon_sym_personality] = ACTIONS(671),
    [anon_sym_alignstack] = ACTIONS(671),
    [anon_sym_allocsize] = ACTIONS(671),
    [anon_sym_alwaysinline] = ACTIONS(671),
    [anon_sym_builtin] = ACTIONS(671),
    [anon_sym_cold] = ACTIONS(671),
    [anon_sym_convergent] = ACTIONS(671),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(671),
    [anon_sym_hot] = ACTIONS(671),
    [anon_sym_inaccessiblememonly] = ACTIONS(671),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(671),
    [anon_sym_inlinehint] = ACTIONS(671),
    [anon_sym_jumptable] = ACTIONS(671),
    [anon_sym_minsize] = ACTIONS(671),
    [anon_sym_naked] = ACTIONS(671),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(671),
    [anon_sym_nobuiltin] = ACTIONS(671),
    [anon_sym_noduplicate] = ACTIONS(671),
    [anon_sym_nofree] = ACTIONS(671),
    [anon_sym_noimplicitfloat] = ACTIONS(671),
    [anon_sym_noinline] = ACTIONS(671),
    [anon_sym_nomerge] = ACTIONS(671),
    [anon_sym_nonlazybind] = ACTIONS(671),
    [anon_sym_noprofile] = ACTIONS(671),
    [anon_sym_noredzone] = ACTIONS(671),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(671),
    [anon_sym_noreturn] = ACTIONS(671),
    [anon_sym_norecurse] = ACTIONS(671),
    [anon_sym_willreturn] = ACTIONS(671),
    [anon_sym_nosync] = ACTIONS(671),
    [anon_sym_nounwind] = ACTIONS(671),
    [anon_sym_nosanitize_coverage] = ACTIONS(671),
    [anon_sym_null_pointer_is_valid] = ACTIONS(671),
    [anon_sym_optforfuzzing] = ACTIONS(671),
    [anon_sym_optnone] = ACTIONS(671),
    [anon_sym_optsize] = ACTIONS(671),
    [anon_sym_readnone] = ACTIONS(671),
    [anon_sym_readonly] = ACTIONS(671),
    [anon_sym_writeonly] = ACTIONS(671),
    [anon_sym_argmemonly] = ACTIONS(671),
    [anon_sym_returns_twice] = ACTIONS(671),
    [anon_sym_safestack] = ACTIONS(671),
    [anon_sym_sanitize_address] = ACTIONS(671),
    [anon_sym_sanitize_memory] = ACTIONS(671),
    [anon_sym_sanitize_thread] = ACTIONS(671),
    [anon_sym_sanitize_hwaddress] = ACTIONS(671),
    [anon_sym_sanitize_memtag] = ACTIONS(671),
    [anon_sym_speculative_load_hardening] = ACTIONS(671),
    [anon_sym_speculatable] = ACTIONS(671),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(671),
    [anon_sym_sspreq] = ACTIONS(671),
    [anon_sym_strictfp] = ACTIONS(671),
    [anon_sym_uwtable] = ACTIONS(671),
    [anon_sym_nocf_check] = ACTIONS(671),
    [anon_sym_shadowcallstack] = ACTIONS(671),
    [anon_sym_mustprogress] = ACTIONS(671),
    [anon_sym_vscale_range] = ACTIONS(671),
    [anon_sym_preallocated] = ACTIONS(671),
    [anon_sym_zeroext] = ACTIONS(671),
    [anon_sym_signext] = ACTIONS(671),
    [anon_sym_inreg] = ACTIONS(671),
    [anon_sym_byval] = ACTIONS(671),
    [anon_sym_byref] = ACTIONS(671),
    [anon_sym_inalloca] = ACTIONS(671),
    [anon_sym_sret] = ACTIONS(671),
    [anon_sym_elementtype] = ACTIONS(671),
    [anon_sym_noalias] = ACTIONS(671),
    [anon_sym_nocapture] = ACTIONS(671),
    [anon_sym_nest] = ACTIONS(671),
    [anon_sym_returned] = ACTIONS(671),
    [anon_sym_nonnull] = ACTIONS(671),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(671),
    [anon_sym_swiftself] = ACTIONS(671),
    [anon_sym_swiftasync] = ACTIONS(671),
    [anon_sym_swifterror] = ACTIONS(671),
    [anon_sym_immarg] = ACTIONS(671),
    [anon_sym_noundef] = ACTIONS(671),
    [anon_sym_to] = ACTIONS(673),
    [anon_sym_uselistorder] = ACTIONS(673),
    [anon_sym_uselistorder_bb] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_attributes] = ACTIONS(671),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(517),
    [sym_comdat_ref] = ACTIONS(517),
    [sym_global_var] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [aux_sym_metadata_ref_token1] = ACTIONS(517),
    [sym_summary_ref] = ACTIONS(517),
    [sym_string] = ACTIONS(517),
    [anon_sym_target] = ACTIONS(517),
    [anon_sym_source_filename] = ACTIONS(517),
    [anon_sym_declare] = ACTIONS(517),
    [anon_sym_define] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_half] = ACTIONS(517),
    [anon_sym_bfloat] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(517),
    [anon_sym_double] = ACTIONS(517),
    [anon_sym_x86_fp80] = ACTIONS(517),
    [anon_sym_fp128] = ACTIONS(517),
    [anon_sym_ppc_fp128] = ACTIONS(517),
    [anon_sym_label] = ACTIONS(517),
    [anon_sym_metadata] = ACTIONS(517),
    [anon_sym_x86_mmx] = ACTIONS(517),
    [anon_sym_x86_amx] = ACTIONS(517),
    [anon_sym_token] = ACTIONS(517),
    [anon_sym_opaque] = ACTIONS(517),
    [anon_sym_ptr] = ACTIONS(517),
    [aux_sym_type_keyword_token1] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LT_LBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_section] = ACTIONS(517),
    [anon_sym_partition] = ACTIONS(517),
    [anon_sym_comdat] = ACTIONS(517),
    [anon_sym_gc] = ACTIONS(517),
    [anon_sym_prefix] = ACTIONS(517),
    [anon_sym_prologue] = ACTIONS(517),
    [anon_sym_personality] = ACTIONS(517),
    [anon_sym_alignstack] = ACTIONS(517),
    [anon_sym_allocsize] = ACTIONS(517),
    [anon_sym_alwaysinline] = ACTIONS(517),
    [anon_sym_builtin] = ACTIONS(517),
    [anon_sym_cold] = ACTIONS(517),
    [anon_sym_convergent] = ACTIONS(517),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(517),
    [anon_sym_hot] = ACTIONS(517),
    [anon_sym_inaccessiblememonly] = ACTIONS(517),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(517),
    [anon_sym_inlinehint] = ACTIONS(517),
    [anon_sym_jumptable] = ACTIONS(517),
    [anon_sym_minsize] = ACTIONS(517),
    [anon_sym_naked] = ACTIONS(517),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(517),
    [anon_sym_nobuiltin] = ACTIONS(517),
    [anon_sym_noduplicate] = ACTIONS(517),
    [anon_sym_nofree] = ACTIONS(517),
    [anon_sym_noimplicitfloat] = ACTIONS(517),
    [anon_sym_noinline] = ACTIONS(517),
    [anon_sym_nomerge] = ACTIONS(517),
    [anon_sym_nonlazybind] = ACTIONS(517),
    [anon_sym_noprofile] = ACTIONS(517),
    [anon_sym_noredzone] = ACTIONS(517),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(517),
    [anon_sym_noreturn] = ACTIONS(517),
    [anon_sym_norecurse] = ACTIONS(517),
    [anon_sym_willreturn] = ACTIONS(517),
    [anon_sym_nosync] = ACTIONS(517),
    [anon_sym_nounwind] = ACTIONS(517),
    [anon_sym_nosanitize_coverage] = ACTIONS(517),
    [anon_sym_null_pointer_is_valid] = ACTIONS(517),
    [anon_sym_optforfuzzing] = ACTIONS(517),
    [anon_sym_optnone] = ACTIONS(517),
    [anon_sym_optsize] = ACTIONS(517),
    [anon_sym_readnone] = ACTIONS(517),
    [anon_sym_readonly] = ACTIONS(517),
    [anon_sym_writeonly] = ACTIONS(517),
    [anon_sym_argmemonly] = ACTIONS(517),
    [anon_sym_returns_twice] = ACTIONS(517),
    [anon_sym_safestack] = ACTIONS(517),
    [anon_sym_sanitize_address] = ACTIONS(517),
    [anon_sym_sanitize_memory] = ACTIONS(517),
    [anon_sym_sanitize_thread] = ACTIONS(517),
    [anon_sym_sanitize_hwaddress] = ACTIONS(517),
    [anon_sym_sanitize_memtag] = ACTIONS(517),
    [anon_sym_speculative_load_hardening] = ACTIONS(517),
    [anon_sym_speculatable] = ACTIONS(517),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(517),
    [anon_sym_sspreq] = ACTIONS(517),
    [anon_sym_strictfp] = ACTIONS(517),
    [anon_sym_uwtable] = ACTIONS(517),
    [anon_sym_nocf_check] = ACTIONS(517),
    [anon_sym_shadowcallstack] = ACTIONS(517),
    [anon_sym_mustprogress] = ACTIONS(517),
    [anon_sym_vscale_range] = ACTIONS(517),
    [anon_sym_preallocated] = ACTIONS(517),
    [anon_sym_zeroext] = ACTIONS(517),
    [anon_sym_signext] = ACTIONS(517),
    [anon_sym_inreg] = ACTIONS(517),
    [anon_sym_byval] = ACTIONS(517),
    [anon_sym_byref] = ACTIONS(517),
    [anon_sym_inalloca] = ACTIONS(517),
    [anon_sym_sret] = ACTIONS(517),
    [anon_sym_elementtype] = ACTIONS(517),
    [anon_sym_noalias] = ACTIONS(517),
    [anon_sym_nocapture] = ACTIONS(517),
    [anon_sym_nest] = ACTIONS(517),
    [anon_sym_returned] = ACTIONS(517),
    [anon_sym_nonnull] = ACTIONS(517),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(517),
    [anon_sym_swiftself] = ACTIONS(517),
    [anon_sym_swiftasync] = ACTIONS(517),
    [anon_sym_swifterror] = ACTIONS(517),
    [anon_sym_immarg] = ACTIONS(517),
    [anon_sym_noundef] = ACTIONS(517),
    [anon_sym_to] = ACTIONS(519),
    [anon_sym_uselistorder] = ACTIONS(519),
    [anon_sym_uselistorder_bb] = ACTIONS(517),
    [anon_sym_module] = ACTIONS(517),
    [anon_sym_attributes] = ACTIONS(517),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(509),
    [sym_comdat_ref] = ACTIONS(509),
    [sym_global_var] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [aux_sym_metadata_ref_token1] = ACTIONS(509),
    [sym_summary_ref] = ACTIONS(509),
    [sym_string] = ACTIONS(509),
    [anon_sym_target] = ACTIONS(509),
    [anon_sym_source_filename] = ACTIONS(509),
    [anon_sym_declare] = ACTIONS(509),
    [anon_sym_define] = ACTIONS(509),
    [anon_sym_void] = ACTIONS(509),
    [anon_sym_half] = ACTIONS(509),
    [anon_sym_bfloat] = ACTIONS(509),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_double] = ACTIONS(509),
    [anon_sym_x86_fp80] = ACTIONS(509),
    [anon_sym_fp128] = ACTIONS(509),
    [anon_sym_ppc_fp128] = ACTIONS(509),
    [anon_sym_label] = ACTIONS(509),
    [anon_sym_metadata] = ACTIONS(509),
    [anon_sym_x86_mmx] = ACTIONS(509),
    [anon_sym_x86_amx] = ACTIONS(509),
    [anon_sym_token] = ACTIONS(509),
    [anon_sym_opaque] = ACTIONS(509),
    [anon_sym_ptr] = ACTIONS(509),
    [aux_sym_type_keyword_token1] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LT_LBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_section] = ACTIONS(509),
    [anon_sym_partition] = ACTIONS(509),
    [anon_sym_comdat] = ACTIONS(509),
    [anon_sym_gc] = ACTIONS(509),
    [anon_sym_prefix] = ACTIONS(509),
    [anon_sym_prologue] = ACTIONS(509),
    [anon_sym_personality] = ACTIONS(509),
    [anon_sym_alignstack] = ACTIONS(509),
    [anon_sym_allocsize] = ACTIONS(509),
    [anon_sym_alwaysinline] = ACTIONS(509),
    [anon_sym_builtin] = ACTIONS(509),
    [anon_sym_cold] = ACTIONS(509),
    [anon_sym_convergent] = ACTIONS(509),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(509),
    [anon_sym_hot] = ACTIONS(509),
    [anon_sym_inaccessiblememonly] = ACTIONS(509),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(509),
    [anon_sym_inlinehint] = ACTIONS(509),
    [anon_sym_jumptable] = ACTIONS(509),
    [anon_sym_minsize] = ACTIONS(509),
    [anon_sym_naked] = ACTIONS(509),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(509),
    [anon_sym_nobuiltin] = ACTIONS(509),
    [anon_sym_noduplicate] = ACTIONS(509),
    [anon_sym_nofree] = ACTIONS(509),
    [anon_sym_noimplicitfloat] = ACTIONS(509),
    [anon_sym_noinline] = ACTIONS(509),
    [anon_sym_nomerge] = ACTIONS(509),
    [anon_sym_nonlazybind] = ACTIONS(509),
    [anon_sym_noprofile] = ACTIONS(509),
    [anon_sym_noredzone] = ACTIONS(509),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(509),
    [anon_sym_noreturn] = ACTIONS(509),
    [anon_sym_norecurse] = ACTIONS(509),
    [anon_sym_willreturn] = ACTIONS(509),
    [anon_sym_nosync] = ACTIONS(509),
    [anon_sym_nounwind] = ACTIONS(509),
    [anon_sym_nosanitize_coverage] = ACTIONS(509),
    [anon_sym_null_pointer_is_valid] = ACTIONS(509),
    [anon_sym_optforfuzzing] = ACTIONS(509),
    [anon_sym_optnone] = ACTIONS(509),
    [anon_sym_optsize] = ACTIONS(509),
    [anon_sym_readnone] = ACTIONS(509),
    [anon_sym_readonly] = ACTIONS(509),
    [anon_sym_writeonly] = ACTIONS(509),
    [anon_sym_argmemonly] = ACTIONS(509),
    [anon_sym_returns_twice] = ACTIONS(509),
    [anon_sym_safestack] = ACTIONS(509),
    [anon_sym_sanitize_address] = ACTIONS(509),
    [anon_sym_sanitize_memory] = ACTIONS(509),
    [anon_sym_sanitize_thread] = ACTIONS(509),
    [anon_sym_sanitize_hwaddress] = ACTIONS(509),
    [anon_sym_sanitize_memtag] = ACTIONS(509),
    [anon_sym_speculative_load_hardening] = ACTIONS(509),
    [anon_sym_speculatable] = ACTIONS(509),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(509),
    [anon_sym_sspreq] = ACTIONS(509),
    [anon_sym_strictfp] = ACTIONS(509),
    [anon_sym_uwtable] = ACTIONS(509),
    [anon_sym_nocf_check] = ACTIONS(509),
    [anon_sym_shadowcallstack] = ACTIONS(509),
    [anon_sym_mustprogress] = ACTIONS(509),
    [anon_sym_vscale_range] = ACTIONS(509),
    [anon_sym_preallocated] = ACTIONS(509),
    [anon_sym_zeroext] = ACTIONS(509),
    [anon_sym_signext] = ACTIONS(509),
    [anon_sym_inreg] = ACTIONS(509),
    [anon_sym_byval] = ACTIONS(509),
    [anon_sym_byref] = ACTIONS(509),
    [anon_sym_inalloca] = ACTIONS(509),
    [anon_sym_sret] = ACTIONS(509),
    [anon_sym_elementtype] = ACTIONS(509),
    [anon_sym_noalias] = ACTIONS(509),
    [anon_sym_nocapture] = ACTIONS(509),
    [anon_sym_nest] = ACTIONS(509),
    [anon_sym_returned] = ACTIONS(509),
    [anon_sym_nonnull] = ACTIONS(509),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(509),
    [anon_sym_swiftself] = ACTIONS(509),
    [anon_sym_swiftasync] = ACTIONS(509),
    [anon_sym_swifterror] = ACTIONS(509),
    [anon_sym_immarg] = ACTIONS(509),
    [anon_sym_noundef] = ACTIONS(509),
    [anon_sym_to] = ACTIONS(511),
    [anon_sym_uselistorder] = ACTIONS(511),
    [anon_sym_uselistorder_bb] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_attributes] = ACTIONS(509),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(603),
    [sym_comdat_ref] = ACTIONS(603),
    [sym_global_var] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [aux_sym_metadata_ref_token1] = ACTIONS(603),
    [sym_summary_ref] = ACTIONS(603),
    [sym_string] = ACTIONS(603),
    [anon_sym_target] = ACTIONS(603),
    [anon_sym_source_filename] = ACTIONS(603),
    [anon_sym_declare] = ACTIONS(603),
    [anon_sym_define] = ACTIONS(603),
    [anon_sym_void] = ACTIONS(603),
    [anon_sym_half] = ACTIONS(603),
    [anon_sym_bfloat] = ACTIONS(603),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_double] = ACTIONS(603),
    [anon_sym_x86_fp80] = ACTIONS(603),
    [anon_sym_fp128] = ACTIONS(603),
    [anon_sym_ppc_fp128] = ACTIONS(603),
    [anon_sym_label] = ACTIONS(603),
    [anon_sym_metadata] = ACTIONS(603),
    [anon_sym_x86_mmx] = ACTIONS(603),
    [anon_sym_x86_amx] = ACTIONS(603),
    [anon_sym_token] = ACTIONS(603),
    [anon_sym_opaque] = ACTIONS(603),
    [anon_sym_ptr] = ACTIONS(603),
    [aux_sym_type_keyword_token1] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LT_LBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_section] = ACTIONS(603),
    [anon_sym_partition] = ACTIONS(603),
    [anon_sym_comdat] = ACTIONS(603),
    [anon_sym_gc] = ACTIONS(603),
    [anon_sym_prefix] = ACTIONS(603),
    [anon_sym_prologue] = ACTIONS(603),
    [anon_sym_personality] = ACTIONS(603),
    [anon_sym_alignstack] = ACTIONS(603),
    [anon_sym_allocsize] = ACTIONS(603),
    [anon_sym_alwaysinline] = ACTIONS(603),
    [anon_sym_builtin] = ACTIONS(603),
    [anon_sym_cold] = ACTIONS(603),
    [anon_sym_convergent] = ACTIONS(603),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(603),
    [anon_sym_hot] = ACTIONS(603),
    [anon_sym_inaccessiblememonly] = ACTIONS(603),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(603),
    [anon_sym_inlinehint] = ACTIONS(603),
    [anon_sym_jumptable] = ACTIONS(603),
    [anon_sym_minsize] = ACTIONS(603),
    [anon_sym_naked] = ACTIONS(603),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(603),
    [anon_sym_nobuiltin] = ACTIONS(603),
    [anon_sym_noduplicate] = ACTIONS(603),
    [anon_sym_nofree] = ACTIONS(603),
    [anon_sym_noimplicitfloat] = ACTIONS(603),
    [anon_sym_noinline] = ACTIONS(603),
    [anon_sym_nomerge] = ACTIONS(603),
    [anon_sym_nonlazybind] = ACTIONS(603),
    [anon_sym_noprofile] = ACTIONS(603),
    [anon_sym_noredzone] = ACTIONS(603),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(603),
    [anon_sym_noreturn] = ACTIONS(603),
    [anon_sym_norecurse] = ACTIONS(603),
    [anon_sym_willreturn] = ACTIONS(603),
    [anon_sym_nosync] = ACTIONS(603),
    [anon_sym_nounwind] = ACTIONS(603),
    [anon_sym_nosanitize_coverage] = ACTIONS(603),
    [anon_sym_null_pointer_is_valid] = ACTIONS(603),
    [anon_sym_optforfuzzing] = ACTIONS(603),
    [anon_sym_optnone] = ACTIONS(603),
    [anon_sym_optsize] = ACTIONS(603),
    [anon_sym_readnone] = ACTIONS(603),
    [anon_sym_readonly] = ACTIONS(603),
    [anon_sym_writeonly] = ACTIONS(603),
    [anon_sym_argmemonly] = ACTIONS(603),
    [anon_sym_returns_twice] = ACTIONS(603),
    [anon_sym_safestack] = ACTIONS(603),
    [anon_sym_sanitize_address] = ACTIONS(603),
    [anon_sym_sanitize_memory] = ACTIONS(603),
    [anon_sym_sanitize_thread] = ACTIONS(603),
    [anon_sym_sanitize_hwaddress] = ACTIONS(603),
    [anon_sym_sanitize_memtag] = ACTIONS(603),
    [anon_sym_speculative_load_hardening] = ACTIONS(603),
    [anon_sym_speculatable] = ACTIONS(603),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(603),
    [anon_sym_sspreq] = ACTIONS(603),
    [anon_sym_strictfp] = ACTIONS(603),
    [anon_sym_uwtable] = ACTIONS(603),
    [anon_sym_nocf_check] = ACTIONS(603),
    [anon_sym_shadowcallstack] = ACTIONS(603),
    [anon_sym_mustprogress] = ACTIONS(603),
    [anon_sym_vscale_range] = ACTIONS(603),
    [anon_sym_preallocated] = ACTIONS(603),
    [anon_sym_zeroext] = ACTIONS(603),
    [anon_sym_signext] = ACTIONS(603),
    [anon_sym_inreg] = ACTIONS(603),
    [anon_sym_byval] = ACTIONS(603),
    [anon_sym_byref] = ACTIONS(603),
    [anon_sym_inalloca] = ACTIONS(603),
    [anon_sym_sret] = ACTIONS(603),
    [anon_sym_elementtype] = ACTIONS(603),
    [anon_sym_noalias] = ACTIONS(603),
    [anon_sym_nocapture] = ACTIONS(603),
    [anon_sym_nest] = ACTIONS(603),
    [anon_sym_returned] = ACTIONS(603),
    [anon_sym_nonnull] = ACTIONS(603),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(603),
    [anon_sym_swiftself] = ACTIONS(603),
    [anon_sym_swiftasync] = ACTIONS(603),
    [anon_sym_swifterror] = ACTIONS(603),
    [anon_sym_immarg] = ACTIONS(603),
    [anon_sym_noundef] = ACTIONS(603),
    [anon_sym_to] = ACTIONS(605),
    [anon_sym_uselistorder] = ACTIONS(605),
    [anon_sym_uselistorder_bb] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_attributes] = ACTIONS(603),
  },
  [336] = {
    [sym_instruction] = STATE(337),
    [sym__instruction_body] = STATE(539),
    [sym_instruction_unreachable] = STATE(539),
    [sym_instruction_ret] = STATE(539),
    [sym_instruction_br] = STATE(539),
    [sym_instruction_resume] = STATE(539),
    [sym_instruction_freeze] = STATE(539),
    [sym_instruction_indirectbr] = STATE(539),
    [sym_instruction_extractelement] = STATE(539),
    [sym_instruction_insertelement] = STATE(539),
    [sym_instruction_select] = STATE(539),
    [sym_instruction_shufflevector] = STATE(539),
    [sym_instruction_fneg] = STATE(539),
    [sym_instruction_bin_op] = STATE(539),
    [sym_instruction_switch] = STATE(539),
    [sym_instruction_invoke] = STATE(539),
    [sym_instruction_cleanupret] = STATE(539),
    [sym_instruction_catchret] = STATE(539),
    [sym_instruction_catchswitch] = STATE(539),
    [sym_instruction_catchpad] = STATE(539),
    [sym_instruction_cleanuppad] = STATE(539),
    [sym_instruction_callbr] = STATE(539),
    [sym_instruction_icmp] = STATE(539),
    [sym_instruction_fcmp] = STATE(539),
    [sym_instruction_cast] = STATE(539),
    [sym_instruction_va_arg] = STATE(539),
    [sym_instruction_phi] = STATE(539),
    [sym_instruction_landingpad] = STATE(539),
    [sym_instruction_call] = STATE(539),
    [sym_instruction_alloca] = STATE(539),
    [sym_instruction_load] = STATE(539),
    [sym_instruction_store] = STATE(539),
    [sym_instruction_cmpxchg] = STATE(539),
    [sym_instruction_atomicrmw] = STATE(539),
    [sym_instruction_fence] = STATE(539),
    [sym_instruction_getelementptr] = STATE(539),
    [sym_instruction_extractvalue] = STATE(539),
    [sym_instruction_insertvalue] = STATE(539),
    [sym_bin_op_keyword] = STATE(691),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(844),
    [sym_use_list_order] = STATE(1161),
    [aux_sym_function_body_repeat1] = STATE(337),
    [aux_sym_function_body_repeat2] = STATE(1161),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(995),
    [sym_label] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_unreachable] = ACTIONS(1001),
    [anon_sym_ret] = ACTIONS(1003),
    [anon_sym_br] = ACTIONS(1005),
    [anon_sym_resume] = ACTIONS(1007),
    [anon_sym_freeze] = ACTIONS(1009),
    [anon_sym_indirectbr] = ACTIONS(1011),
    [anon_sym_extractelement] = ACTIONS(1013),
    [anon_sym_insertelement] = ACTIONS(1015),
    [anon_sym_select] = ACTIONS(1017),
    [anon_sym_shufflevector] = ACTIONS(1019),
    [anon_sym_fneg] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1023),
    [anon_sym_invoke] = ACTIONS(1025),
    [anon_sym_cleanupret] = ACTIONS(1027),
    [anon_sym_catchret] = ACTIONS(1029),
    [anon_sym_catchswitch] = ACTIONS(1031),
    [anon_sym_catchpad] = ACTIONS(1033),
    [anon_sym_cleanuppad] = ACTIONS(1035),
    [anon_sym_callbr] = ACTIONS(1037),
    [anon_sym_icmp] = ACTIONS(1039),
    [anon_sym_fcmp] = ACTIONS(1041),
    [anon_sym_va_arg] = ACTIONS(1043),
    [anon_sym_phi] = ACTIONS(1045),
    [anon_sym_landingpad] = ACTIONS(1047),
    [anon_sym_tail] = ACTIONS(1049),
    [anon_sym_musttail] = ACTIONS(1049),
    [anon_sym_notail] = ACTIONS(1049),
    [anon_sym_call] = ACTIONS(1051),
    [anon_sym_alloca] = ACTIONS(1053),
    [anon_sym_load] = ACTIONS(1055),
    [anon_sym_store] = ACTIONS(1057),
    [anon_sym_cmpxchg] = ACTIONS(1059),
    [anon_sym_atomicrmw] = ACTIONS(1061),
    [anon_sym_fence] = ACTIONS(1063),
    [anon_sym_getelementptr] = ACTIONS(1065),
    [anon_sym_extractvalue] = ACTIONS(1067),
    [anon_sym_insertvalue] = ACTIONS(1069),
    [anon_sym_mul] = ACTIONS(1071),
    [anon_sym_urem] = ACTIONS(1071),
    [anon_sym_srem] = ACTIONS(1071),
    [anon_sym_shl] = ACTIONS(1071),
    [anon_sym_udiv] = ACTIONS(1071),
    [anon_sym_sdiv] = ACTIONS(1071),
    [anon_sym_lshr] = ACTIONS(1071),
    [anon_sym_ashr] = ACTIONS(1071),
    [anon_sym_fmul] = ACTIONS(1071),
    [anon_sym_fdiv] = ACTIONS(1071),
    [anon_sym_frem] = ACTIONS(1071),
    [anon_sym_xchg] = ACTIONS(112),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_nand] = ACTIONS(112),
    [anon_sym_or] = ACTIONS(112),
    [anon_sym_xor] = ACTIONS(112),
    [anon_sym_max] = ACTIONS(112),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(112),
    [anon_sym_umin] = ACTIONS(112),
    [anon_sym_fadd] = ACTIONS(112),
    [anon_sym_fsub] = ACTIONS(112),
    [anon_sym_bitcast] = ACTIONS(1073),
    [anon_sym_trunc] = ACTIONS(1073),
    [anon_sym_zext] = ACTIONS(1073),
    [anon_sym_sext] = ACTIONS(1073),
    [anon_sym_fptrunc] = ACTIONS(1073),
    [anon_sym_fpext] = ACTIONS(1073),
    [anon_sym_addrspacecast] = ACTIONS(1073),
    [anon_sym_uitofp] = ACTIONS(1073),
    [anon_sym_sitofp] = ACTIONS(1073),
    [anon_sym_fptoui] = ACTIONS(1073),
    [anon_sym_fptosi] = ACTIONS(1073),
    [anon_sym_inttoptr] = ACTIONS(1073),
    [anon_sym_ptrtoint] = ACTIONS(1073),
    [anon_sym_uselistorder] = ACTIONS(25),
  },
  [337] = {
    [sym_instruction] = STATE(339),
    [sym__instruction_body] = STATE(539),
    [sym_instruction_unreachable] = STATE(539),
    [sym_instruction_ret] = STATE(539),
    [sym_instruction_br] = STATE(539),
    [sym_instruction_resume] = STATE(539),
    [sym_instruction_freeze] = STATE(539),
    [sym_instruction_indirectbr] = STATE(539),
    [sym_instruction_extractelement] = STATE(539),
    [sym_instruction_insertelement] = STATE(539),
    [sym_instruction_select] = STATE(539),
    [sym_instruction_shufflevector] = STATE(539),
    [sym_instruction_fneg] = STATE(539),
    [sym_instruction_bin_op] = STATE(539),
    [sym_instruction_switch] = STATE(539),
    [sym_instruction_invoke] = STATE(539),
    [sym_instruction_cleanupret] = STATE(539),
    [sym_instruction_catchret] = STATE(539),
    [sym_instruction_catchswitch] = STATE(539),
    [sym_instruction_catchpad] = STATE(539),
    [sym_instruction_cleanuppad] = STATE(539),
    [sym_instruction_callbr] = STATE(539),
    [sym_instruction_icmp] = STATE(539),
    [sym_instruction_fcmp] = STATE(539),
    [sym_instruction_cast] = STATE(539),
    [sym_instruction_va_arg] = STATE(539),
    [sym_instruction_phi] = STATE(539),
    [sym_instruction_landingpad] = STATE(539),
    [sym_instruction_call] = STATE(539),
    [sym_instruction_alloca] = STATE(539),
    [sym_instruction_load] = STATE(539),
    [sym_instruction_store] = STATE(539),
    [sym_instruction_cmpxchg] = STATE(539),
    [sym_instruction_atomicrmw] = STATE(539),
    [sym_instruction_fence] = STATE(539),
    [sym_instruction_getelementptr] = STATE(539),
    [sym_instruction_extractvalue] = STATE(539),
    [sym_instruction_insertvalue] = STATE(539),
    [sym_bin_op_keyword] = STATE(691),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(844),
    [sym_use_list_order] = STATE(1165),
    [aux_sym_function_body_repeat1] = STATE(339),
    [aux_sym_function_body_repeat2] = STATE(1165),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(995),
    [sym_label] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_unreachable] = ACTIONS(1001),
    [anon_sym_ret] = ACTIONS(1003),
    [anon_sym_br] = ACTIONS(1005),
    [anon_sym_resume] = ACTIONS(1007),
    [anon_sym_freeze] = ACTIONS(1009),
    [anon_sym_indirectbr] = ACTIONS(1011),
    [anon_sym_extractelement] = ACTIONS(1013),
    [anon_sym_insertelement] = ACTIONS(1015),
    [anon_sym_select] = ACTIONS(1017),
    [anon_sym_shufflevector] = ACTIONS(1019),
    [anon_sym_fneg] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1023),
    [anon_sym_invoke] = ACTIONS(1025),
    [anon_sym_cleanupret] = ACTIONS(1027),
    [anon_sym_catchret] = ACTIONS(1029),
    [anon_sym_catchswitch] = ACTIONS(1031),
    [anon_sym_catchpad] = ACTIONS(1033),
    [anon_sym_cleanuppad] = ACTIONS(1035),
    [anon_sym_callbr] = ACTIONS(1037),
    [anon_sym_icmp] = ACTIONS(1039),
    [anon_sym_fcmp] = ACTIONS(1041),
    [anon_sym_va_arg] = ACTIONS(1043),
    [anon_sym_phi] = ACTIONS(1045),
    [anon_sym_landingpad] = ACTIONS(1047),
    [anon_sym_tail] = ACTIONS(1049),
    [anon_sym_musttail] = ACTIONS(1049),
    [anon_sym_notail] = ACTIONS(1049),
    [anon_sym_call] = ACTIONS(1051),
    [anon_sym_alloca] = ACTIONS(1053),
    [anon_sym_load] = ACTIONS(1055),
    [anon_sym_store] = ACTIONS(1057),
    [anon_sym_cmpxchg] = ACTIONS(1059),
    [anon_sym_atomicrmw] = ACTIONS(1061),
    [anon_sym_fence] = ACTIONS(1063),
    [anon_sym_getelementptr] = ACTIONS(1065),
    [anon_sym_extractvalue] = ACTIONS(1067),
    [anon_sym_insertvalue] = ACTIONS(1069),
    [anon_sym_mul] = ACTIONS(1071),
    [anon_sym_urem] = ACTIONS(1071),
    [anon_sym_srem] = ACTIONS(1071),
    [anon_sym_shl] = ACTIONS(1071),
    [anon_sym_udiv] = ACTIONS(1071),
    [anon_sym_sdiv] = ACTIONS(1071),
    [anon_sym_lshr] = ACTIONS(1071),
    [anon_sym_ashr] = ACTIONS(1071),
    [anon_sym_fmul] = ACTIONS(1071),
    [anon_sym_fdiv] = ACTIONS(1071),
    [anon_sym_frem] = ACTIONS(1071),
    [anon_sym_xchg] = ACTIONS(112),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_nand] = ACTIONS(112),
    [anon_sym_or] = ACTIONS(112),
    [anon_sym_xor] = ACTIONS(112),
    [anon_sym_max] = ACTIONS(112),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(112),
    [anon_sym_umin] = ACTIONS(112),
    [anon_sym_fadd] = ACTIONS(112),
    [anon_sym_fsub] = ACTIONS(112),
    [anon_sym_bitcast] = ACTIONS(1073),
    [anon_sym_trunc] = ACTIONS(1073),
    [anon_sym_zext] = ACTIONS(1073),
    [anon_sym_sext] = ACTIONS(1073),
    [anon_sym_fptrunc] = ACTIONS(1073),
    [anon_sym_fpext] = ACTIONS(1073),
    [anon_sym_addrspacecast] = ACTIONS(1073),
    [anon_sym_uitofp] = ACTIONS(1073),
    [anon_sym_sitofp] = ACTIONS(1073),
    [anon_sym_fptoui] = ACTIONS(1073),
    [anon_sym_fptosi] = ACTIONS(1073),
    [anon_sym_inttoptr] = ACTIONS(1073),
    [anon_sym_ptrtoint] = ACTIONS(1073),
    [anon_sym_uselistorder] = ACTIONS(25),
  },
  [338] = {
    [sym_metadata_ref] = STATE(1229),
    [sym_type] = STATE(347),
    [sym_type_keyword] = STATE(473),
    [sym_struct_type] = STATE(473),
    [sym_packed_struct_type] = STATE(473),
    [sym_array_type] = STATE(473),
    [sym_vector_type] = STATE(473),
    [sym_type_and_value] = STATE(1441),
    [sym_metadata] = STATE(1445),
    [sym_metadata_tuple] = STATE(1441),
    [sym_specialized_md] = STATE(1441),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(1079),
    [aux_sym_metadata_ref_token1] = ACTIONS(1081),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_half] = ACTIONS(1083),
    [anon_sym_bfloat] = ACTIONS(1083),
    [anon_sym_float] = ACTIONS(1083),
    [anon_sym_double] = ACTIONS(1083),
    [anon_sym_x86_fp80] = ACTIONS(1083),
    [anon_sym_fp128] = ACTIONS(1083),
    [anon_sym_ppc_fp128] = ACTIONS(1083),
    [anon_sym_label] = ACTIONS(1083),
    [anon_sym_metadata] = ACTIONS(1085),
    [anon_sym_x86_mmx] = ACTIONS(1083),
    [anon_sym_x86_amx] = ACTIONS(1083),
    [anon_sym_token] = ACTIONS(1083),
    [anon_sym_opaque] = ACTIONS(1083),
    [anon_sym_ptr] = ACTIONS(1087),
    [aux_sym_type_keyword_token1] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_LT_LBRACE] = ACTIONS(1091),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1097),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(1099),
  },
  [339] = {
    [sym_instruction] = STATE(339),
    [sym__instruction_body] = STATE(539),
    [sym_instruction_unreachable] = STATE(539),
    [sym_instruction_ret] = STATE(539),
    [sym_instruction_br] = STATE(539),
    [sym_instruction_resume] = STATE(539),
    [sym_instruction_freeze] = STATE(539),
    [sym_instruction_indirectbr] = STATE(539),
    [sym_instruction_extractelement] = STATE(539),
    [sym_instruction_insertelement] = STATE(539),
    [sym_instruction_select] = STATE(539),
    [sym_instruction_shufflevector] = STATE(539),
    [sym_instruction_fneg] = STATE(539),
    [sym_instruction_bin_op] = STATE(539),
    [sym_instruction_switch] = STATE(539),
    [sym_instruction_invoke] = STATE(539),
    [sym_instruction_cleanupret] = STATE(539),
    [sym_instruction_catchret] = STATE(539),
    [sym_instruction_catchswitch] = STATE(539),
    [sym_instruction_catchpad] = STATE(539),
    [sym_instruction_cleanuppad] = STATE(539),
    [sym_instruction_callbr] = STATE(539),
    [sym_instruction_icmp] = STATE(539),
    [sym_instruction_fcmp] = STATE(539),
    [sym_instruction_cast] = STATE(539),
    [sym_instruction_va_arg] = STATE(539),
    [sym_instruction_phi] = STATE(539),
    [sym_instruction_landingpad] = STATE(539),
    [sym_instruction_call] = STATE(539),
    [sym_instruction_alloca] = STATE(539),
    [sym_instruction_load] = STATE(539),
    [sym_instruction_store] = STATE(539),
    [sym_instruction_cmpxchg] = STATE(539),
    [sym_instruction_atomicrmw] = STATE(539),
    [sym_instruction_fence] = STATE(539),
    [sym_instruction_getelementptr] = STATE(539),
    [sym_instruction_extractvalue] = STATE(539),
    [sym_instruction_insertvalue] = STATE(539),
    [sym_bin_op_keyword] = STATE(691),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(844),
    [aux_sym_function_body_repeat1] = STATE(339),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1101),
    [sym_label] = ACTIONS(1104),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_unreachable] = ACTIONS(1109),
    [anon_sym_ret] = ACTIONS(1112),
    [anon_sym_br] = ACTIONS(1115),
    [anon_sym_resume] = ACTIONS(1118),
    [anon_sym_freeze] = ACTIONS(1121),
    [anon_sym_indirectbr] = ACTIONS(1124),
    [anon_sym_extractelement] = ACTIONS(1127),
    [anon_sym_insertelement] = ACTIONS(1130),
    [anon_sym_select] = ACTIONS(1133),
    [anon_sym_shufflevector] = ACTIONS(1136),
    [anon_sym_fneg] = ACTIONS(1139),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_invoke] = ACTIONS(1145),
    [anon_sym_cleanupret] = ACTIONS(1148),
    [anon_sym_catchret] = ACTIONS(1151),
    [anon_sym_catchswitch] = ACTIONS(1154),
    [anon_sym_catchpad] = ACTIONS(1157),
    [anon_sym_cleanuppad] = ACTIONS(1160),
    [anon_sym_callbr] = ACTIONS(1163),
    [anon_sym_icmp] = ACTIONS(1166),
    [anon_sym_fcmp] = ACTIONS(1169),
    [anon_sym_va_arg] = ACTIONS(1172),
    [anon_sym_phi] = ACTIONS(1175),
    [anon_sym_landingpad] = ACTIONS(1178),
    [anon_sym_tail] = ACTIONS(1181),
    [anon_sym_musttail] = ACTIONS(1181),
    [anon_sym_notail] = ACTIONS(1181),
    [anon_sym_call] = ACTIONS(1184),
    [anon_sym_alloca] = ACTIONS(1187),
    [anon_sym_load] = ACTIONS(1190),
    [anon_sym_store] = ACTIONS(1193),
    [anon_sym_cmpxchg] = ACTIONS(1196),
    [anon_sym_atomicrmw] = ACTIONS(1199),
    [anon_sym_fence] = ACTIONS(1202),
    [anon_sym_getelementptr] = ACTIONS(1205),
    [anon_sym_extractvalue] = ACTIONS(1208),
    [anon_sym_insertvalue] = ACTIONS(1211),
    [anon_sym_mul] = ACTIONS(1214),
    [anon_sym_urem] = ACTIONS(1214),
    [anon_sym_srem] = ACTIONS(1214),
    [anon_sym_shl] = ACTIONS(1214),
    [anon_sym_udiv] = ACTIONS(1214),
    [anon_sym_sdiv] = ACTIONS(1214),
    [anon_sym_lshr] = ACTIONS(1214),
    [anon_sym_ashr] = ACTIONS(1214),
    [anon_sym_fmul] = ACTIONS(1214),
    [anon_sym_fdiv] = ACTIONS(1214),
    [anon_sym_frem] = ACTIONS(1214),
    [anon_sym_xchg] = ACTIONS(1217),
    [anon_sym_add] = ACTIONS(1217),
    [anon_sym_sub] = ACTIONS(1217),
    [anon_sym_and] = ACTIONS(1217),
    [anon_sym_nand] = ACTIONS(1217),
    [anon_sym_or] = ACTIONS(1217),
    [anon_sym_xor] = ACTIONS(1217),
    [anon_sym_max] = ACTIONS(1217),
    [anon_sym_min] = ACTIONS(1217),
    [anon_sym_umax] = ACTIONS(1217),
    [anon_sym_umin] = ACTIONS(1217),
    [anon_sym_fadd] = ACTIONS(1217),
    [anon_sym_fsub] = ACTIONS(1217),
    [anon_sym_bitcast] = ACTIONS(1220),
    [anon_sym_trunc] = ACTIONS(1220),
    [anon_sym_zext] = ACTIONS(1220),
    [anon_sym_sext] = ACTIONS(1220),
    [anon_sym_fptrunc] = ACTIONS(1220),
    [anon_sym_fpext] = ACTIONS(1220),
    [anon_sym_addrspacecast] = ACTIONS(1220),
    [anon_sym_uitofp] = ACTIONS(1220),
    [anon_sym_sitofp] = ACTIONS(1220),
    [anon_sym_fptoui] = ACTIONS(1220),
    [anon_sym_fptosi] = ACTIONS(1220),
    [anon_sym_inttoptr] = ACTIONS(1220),
    [anon_sym_ptrtoint] = ACTIONS(1220),
    [anon_sym_uselistorder] = ACTIONS(1223),
  },
  [340] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(266),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(1359),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [341] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1370),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1370),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [342] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1352),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1352),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [343] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1347),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1347),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [344] = {
    [sym_metadata_ref] = STATE(286),
    [sym_type] = STATE(255),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_type_and_value] = STATE(300),
    [sym_metadata] = STATE(308),
    [sym_metadata_tuple] = STATE(300),
    [sym_specialized_md] = STATE(300),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1227),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1229),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(389),
  },
  [345] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1360),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1360),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [346] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1346),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1346),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [347] = {
    [sym_number] = STATE(1446),
    [sym_var] = STATE(1446),
    [sym_linkage] = STATE(795),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1447),
    [sym__primitive_value] = STATE(1446),
    [sym_struct_value] = STATE(1446),
    [sym_packed_struct_value] = STATE(1446),
    [sym_array_value] = STATE(1446),
    [sym_vector_value] = STATE(1446),
    [sym_blockaddress] = STATE(1446),
    [sym_constant_expr] = STATE(1446),
    [sym_constant_cast] = STATE(1343),
    [sym_constant_getelementptr] = STATE(1343),
    [sym_constant_select] = STATE(1343),
    [sym_constant_icmp] = STATE(1343),
    [sym_constant_fcmp] = STATE(1343),
    [sym_constant_extractelement] = STATE(1343),
    [sym_constant_insertelement] = STATE(1343),
    [sym_constant_shufflevector] = STATE(1343),
    [sym_constant_extractvalue] = STATE(1343),
    [sym_constant_insertvalue] = STATE(1343),
    [sym_constant_fneg] = STATE(1343),
    [sym_constant_bin_op] = STATE(1343),
    [sym_bin_op_keyword] = STATE(1065),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1781),
    [aux_sym_function_header_repeat1] = STATE(795),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1231),
    [sym_local_var] = ACTIONS(1231),
    [sym_string] = ACTIONS(1233),
    [aux_sym_number_token1] = ACTIONS(1235),
    [aux_sym_number_token2] = ACTIONS(1237),
    [sym_float] = ACTIONS(1233),
    [sym_cstring] = ACTIONS(1233),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_LT_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE_GT] = ACTIONS(38),
    [anon_sym_LBRACK] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_extractelement] = ACTIONS(1247),
    [anon_sym_insertelement] = ACTIONS(1249),
    [anon_sym_select] = ACTIONS(1251),
    [anon_sym_shufflevector] = ACTIONS(1253),
    [anon_sym_fneg] = ACTIONS(1255),
    [anon_sym_icmp] = ACTIONS(1257),
    [anon_sym_fcmp] = ACTIONS(1259),
    [anon_sym_getelementptr] = ACTIONS(1261),
    [anon_sym_extractvalue] = ACTIONS(1263),
    [anon_sym_insertvalue] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1233),
    [anon_sym_false] = ACTIONS(1233),
    [anon_sym_null] = ACTIONS(1233),
    [anon_sym_none] = ACTIONS(1233),
    [anon_sym_undef] = ACTIONS(1233),
    [anon_sym_poison] = ACTIONS(1233),
    [anon_sym_zeroinitializer] = ACTIONS(1233),
    [anon_sym_blockaddress] = ACTIONS(1267),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [348] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1383),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1383),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [349] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1355),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1355),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [350] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1371),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [sym_inline_asm] = STATE(1371),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1225),
  },
  [351] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(132),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(72),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [352] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(355),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(125),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1269),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(978),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [353] = {
    [sym_metadata_ref] = STATE(105),
    [sym_type] = STATE(351),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_type_and_value] = STATE(128),
    [sym_metadata] = STATE(125),
    [sym_metadata_tuple] = STATE(128),
    [sym_specialized_md] = STATE(128),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1271),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(978),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [354] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(648),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1273),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_extractelement] = ACTIONS(1275),
    [anon_sym_insertelement] = ACTIONS(1277),
    [anon_sym_select] = ACTIONS(1279),
    [anon_sym_shufflevector] = ACTIONS(1281),
    [anon_sym_fneg] = ACTIONS(1283),
    [anon_sym_icmp] = ACTIONS(1285),
    [anon_sym_fcmp] = ACTIONS(1287),
    [anon_sym_getelementptr] = ACTIONS(1289),
    [anon_sym_extractvalue] = ACTIONS(1291),
    [anon_sym_insertvalue] = ACTIONS(1293),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1295),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [355] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(132),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(78),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [356] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(644),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1273),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_extractelement] = ACTIONS(1275),
    [anon_sym_insertelement] = ACTIONS(1277),
    [anon_sym_select] = ACTIONS(1279),
    [anon_sym_shufflevector] = ACTIONS(1281),
    [anon_sym_fneg] = ACTIONS(1283),
    [anon_sym_icmp] = ACTIONS(1285),
    [anon_sym_fcmp] = ACTIONS(1287),
    [anon_sym_getelementptr] = ACTIONS(1289),
    [anon_sym_extractvalue] = ACTIONS(1291),
    [anon_sym_insertvalue] = ACTIONS(1293),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1295),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [357] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1691),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [358] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(583),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1273),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_extractelement] = ACTIONS(1275),
    [anon_sym_insertelement] = ACTIONS(1277),
    [anon_sym_select] = ACTIONS(1279),
    [anon_sym_shufflevector] = ACTIONS(1281),
    [anon_sym_fneg] = ACTIONS(1283),
    [anon_sym_icmp] = ACTIONS(1285),
    [anon_sym_fcmp] = ACTIONS(1287),
    [anon_sym_getelementptr] = ACTIONS(1289),
    [anon_sym_extractvalue] = ACTIONS(1291),
    [anon_sym_insertvalue] = ACTIONS(1293),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1295),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [359] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(594),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1273),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_extractelement] = ACTIONS(1275),
    [anon_sym_insertelement] = ACTIONS(1277),
    [anon_sym_select] = ACTIONS(1279),
    [anon_sym_shufflevector] = ACTIONS(1281),
    [anon_sym_fneg] = ACTIONS(1283),
    [anon_sym_icmp] = ACTIONS(1285),
    [anon_sym_fcmp] = ACTIONS(1287),
    [anon_sym_getelementptr] = ACTIONS(1289),
    [anon_sym_extractvalue] = ACTIONS(1291),
    [anon_sym_insertvalue] = ACTIONS(1293),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1295),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [360] = {
    [sym_number] = STATE(160),
    [sym_var] = STATE(160),
    [sym_linkage] = STATE(754),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(584),
    [sym__primitive_value] = STATE(160),
    [sym_struct_value] = STATE(160),
    [sym_packed_struct_value] = STATE(160),
    [sym_array_value] = STATE(160),
    [sym_vector_value] = STATE(160),
    [sym_blockaddress] = STATE(160),
    [sym_constant_expr] = STATE(160),
    [sym_constant_cast] = STATE(169),
    [sym_constant_getelementptr] = STATE(169),
    [sym_constant_select] = STATE(169),
    [sym_constant_icmp] = STATE(169),
    [sym_constant_fcmp] = STATE(169),
    [sym_constant_extractelement] = STATE(169),
    [sym_constant_insertelement] = STATE(169),
    [sym_constant_shufflevector] = STATE(169),
    [sym_constant_extractvalue] = STATE(169),
    [sym_constant_insertvalue] = STATE(169),
    [sym_constant_fneg] = STATE(169),
    [sym_constant_bin_op] = STATE(169),
    [sym_bin_op_keyword] = STATE(1061),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1794),
    [aux_sym_function_header_repeat1] = STATE(754),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1273),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_extractelement] = ACTIONS(1275),
    [anon_sym_insertelement] = ACTIONS(1277),
    [anon_sym_select] = ACTIONS(1279),
    [anon_sym_shufflevector] = ACTIONS(1281),
    [anon_sym_fneg] = ACTIONS(1283),
    [anon_sym_icmp] = ACTIONS(1285),
    [anon_sym_fcmp] = ACTIONS(1287),
    [anon_sym_getelementptr] = ACTIONS(1289),
    [anon_sym_extractvalue] = ACTIONS(1291),
    [anon_sym_insertvalue] = ACTIONS(1293),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1295),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [361] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1750),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [362] = {
    [sym_number] = STATE(99),
    [sym_var] = STATE(99),
    [sym_linkage] = STATE(765),
    [sym_linkage_aux] = STATE(218),
    [sym_dso_local] = STATE(218),
    [sym_visibility] = STATE(218),
    [sym_dll_storage_class] = STATE(218),
    [sym_value] = STATE(1576),
    [sym__primitive_value] = STATE(99),
    [sym_struct_value] = STATE(99),
    [sym_packed_struct_value] = STATE(99),
    [sym_array_value] = STATE(99),
    [sym_vector_value] = STATE(99),
    [sym_blockaddress] = STATE(99),
    [sym_constant_expr] = STATE(99),
    [sym_constant_cast] = STATE(117),
    [sym_constant_getelementptr] = STATE(117),
    [sym_constant_select] = STATE(117),
    [sym_constant_icmp] = STATE(117),
    [sym_constant_fcmp] = STATE(117),
    [sym_constant_extractelement] = STATE(117),
    [sym_constant_insertelement] = STATE(117),
    [sym_constant_shufflevector] = STATE(117),
    [sym_constant_extractvalue] = STATE(117),
    [sym_constant_insertvalue] = STATE(117),
    [sym_constant_fneg] = STATE(117),
    [sym_constant_bin_op] = STATE(117),
    [sym_bin_op_keyword] = STATE(1060),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1458),
    [aux_sym_function_header_repeat1] = STATE(765),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(325),
    [anon_sym_internal] = ACTIONS(325),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(325),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(325),
    [anon_sym_available_externally] = ACTIONS(325),
    [anon_sym_appending] = ACTIONS(325),
    [anon_sym_common] = ACTIONS(325),
    [anon_sym_extern_weak] = ACTIONS(325),
    [anon_sym_external] = ACTIONS(325),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(327),
    [anon_sym_dso_preemptable] = ACTIONS(327),
    [anon_sym_default] = ACTIONS(329),
    [anon_sym_hidden] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_dllimport] = ACTIONS(331),
    [anon_sym_dllexport] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_LT_LBRACE] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(464),
    [anon_sym_LT] = ACTIONS(466),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [363] = {
    [sym__instruction_body] = STATE(538),
    [sym_instruction_unreachable] = STATE(538),
    [sym_instruction_ret] = STATE(538),
    [sym_instruction_br] = STATE(538),
    [sym_instruction_resume] = STATE(538),
    [sym_instruction_freeze] = STATE(538),
    [sym_instruction_indirectbr] = STATE(538),
    [sym_instruction_extractelement] = STATE(538),
    [sym_instruction_insertelement] = STATE(538),
    [sym_instruction_select] = STATE(538),
    [sym_instruction_shufflevector] = STATE(538),
    [sym_instruction_fneg] = STATE(538),
    [sym_instruction_bin_op] = STATE(538),
    [sym_instruction_switch] = STATE(538),
    [sym_instruction_invoke] = STATE(538),
    [sym_instruction_cleanupret] = STATE(538),
    [sym_instruction_catchret] = STATE(538),
    [sym_instruction_catchswitch] = STATE(538),
    [sym_instruction_catchpad] = STATE(538),
    [sym_instruction_cleanuppad] = STATE(538),
    [sym_instruction_callbr] = STATE(538),
    [sym_instruction_icmp] = STATE(538),
    [sym_instruction_fcmp] = STATE(538),
    [sym_instruction_cast] = STATE(538),
    [sym_instruction_va_arg] = STATE(538),
    [sym_instruction_phi] = STATE(538),
    [sym_instruction_landingpad] = STATE(538),
    [sym_instruction_call] = STATE(538),
    [sym_instruction_alloca] = STATE(538),
    [sym_instruction_load] = STATE(538),
    [sym_instruction_store] = STATE(538),
    [sym_instruction_cmpxchg] = STATE(538),
    [sym_instruction_atomicrmw] = STATE(538),
    [sym_instruction_fence] = STATE(538),
    [sym_instruction_getelementptr] = STATE(538),
    [sym_instruction_extractvalue] = STATE(538),
    [sym_instruction_insertvalue] = STATE(538),
    [sym_bin_op_keyword] = STATE(691),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_unreachable] = ACTIONS(1297),
    [anon_sym_ret] = ACTIONS(1299),
    [anon_sym_br] = ACTIONS(1301),
    [anon_sym_resume] = ACTIONS(1303),
    [anon_sym_freeze] = ACTIONS(1305),
    [anon_sym_indirectbr] = ACTIONS(1307),
    [anon_sym_extractelement] = ACTIONS(1309),
    [anon_sym_insertelement] = ACTIONS(1311),
    [anon_sym_select] = ACTIONS(1313),
    [anon_sym_shufflevector] = ACTIONS(1315),
    [anon_sym_fneg] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1319),
    [anon_sym_invoke] = ACTIONS(1321),
    [anon_sym_cleanupret] = ACTIONS(1323),
    [anon_sym_catchret] = ACTIONS(1325),
    [anon_sym_catchswitch] = ACTIONS(1327),
    [anon_sym_catchpad] = ACTIONS(1329),
    [anon_sym_cleanuppad] = ACTIONS(1331),
    [anon_sym_callbr] = ACTIONS(1333),
    [anon_sym_icmp] = ACTIONS(1335),
    [anon_sym_fcmp] = ACTIONS(1337),
    [anon_sym_va_arg] = ACTIONS(1339),
    [anon_sym_phi] = ACTIONS(1341),
    [anon_sym_landingpad] = ACTIONS(1343),
    [anon_sym_tail] = ACTIONS(1345),
    [anon_sym_musttail] = ACTIONS(1345),
    [anon_sym_notail] = ACTIONS(1345),
    [anon_sym_call] = ACTIONS(1051),
    [anon_sym_alloca] = ACTIONS(1347),
    [anon_sym_load] = ACTIONS(1349),
    [anon_sym_store] = ACTIONS(1351),
    [anon_sym_cmpxchg] = ACTIONS(1353),
    [anon_sym_atomicrmw] = ACTIONS(1355),
    [anon_sym_fence] = ACTIONS(1357),
    [anon_sym_getelementptr] = ACTIONS(1359),
    [anon_sym_extractvalue] = ACTIONS(1361),
    [anon_sym_insertvalue] = ACTIONS(1363),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [364] = {
    [sym_number] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_comdat_ref] = ACTIONS(713),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [aux_sym_metadata_ref_token1] = ACTIONS(713),
    [sym_summary_ref] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [anon_sym_target] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_source_filename] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_define] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(713),
    [anon_sym_partition] = ACTIONS(713),
    [anon_sym_comdat] = ACTIONS(713),
    [anon_sym_gc] = ACTIONS(713),
    [anon_sym_prefix] = ACTIONS(713),
    [anon_sym_prologue] = ACTIONS(713),
    [anon_sym_personality] = ACTIONS(713),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_to] = ACTIONS(713),
    [anon_sym_uselistorder] = ACTIONS(715),
    [anon_sym_uselistorder_bb] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_attributes] = ACTIONS(713),
  },
  [365] = {
    [sym_unnamed_addr] = STATE(1027),
    [sym_type] = STATE(1456),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(367),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(367),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [366] = {
    [sym_unnamed_addr] = STATE(988),
    [sym_type] = STATE(1480),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [367] = {
    [sym_unnamed_addr] = STATE(1021),
    [sym_type] = STATE(1649),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [368] = {
    [sym_unnamed_addr] = STATE(988),
    [sym_type] = STATE(1480),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(375),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(375),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [369] = {
    [sym_unnamed_addr] = STATE(1027),
    [sym_type] = STATE(1456),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [370] = {
    [sym_unnamed_addr] = STATE(1019),
    [sym_type] = STATE(1553),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [371] = {
    [sym_unnamed_addr] = STATE(1028),
    [sym_type] = STATE(1641),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [372] = {
    [sym_unnamed_addr] = STATE(1019),
    [sym_type] = STATE(1553),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(366),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(366),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [373] = {
    [sym_unnamed_addr] = STATE(1028),
    [sym_type] = STATE(1641),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(369),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(369),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [374] = {
    [sym_number] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(713),
    [aux_sym_metadata_ref_token1] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(317),
    [aux_sym_number_token2] = ACTIONS(319),
    [anon_sym_unnamed_addr] = ACTIONS(713),
    [anon_sym_local_unnamed_addr] = ACTIONS(713),
    [anon_sym_void] = ACTIONS(713),
    [anon_sym_half] = ACTIONS(713),
    [anon_sym_bfloat] = ACTIONS(713),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_double] = ACTIONS(713),
    [anon_sym_x86_fp80] = ACTIONS(713),
    [anon_sym_fp128] = ACTIONS(713),
    [anon_sym_ppc_fp128] = ACTIONS(713),
    [anon_sym_label] = ACTIONS(713),
    [anon_sym_metadata] = ACTIONS(713),
    [anon_sym_x86_mmx] = ACTIONS(713),
    [anon_sym_x86_amx] = ACTIONS(713),
    [anon_sym_token] = ACTIONS(713),
    [anon_sym_opaque] = ACTIONS(713),
    [anon_sym_ptr] = ACTIONS(713),
    [aux_sym_type_keyword_token1] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_addrspace] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_BANG] = ACTIONS(715),
  },
  [375] = {
    [sym_unnamed_addr] = STATE(1012),
    [sym_type] = STATE(1526),
    [sym_type_keyword] = STATE(736),
    [sym_struct_type] = STATE(736),
    [sym_packed_struct_type] = STATE(736),
    [sym_array_type] = STATE(736),
    [sym_vector_type] = STATE(736),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(737),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [376] = {
    [sym_unnamed_addr] = STATE(400),
    [sym_addrspace] = STATE(415),
    [sym_attribute] = STATE(428),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1365),
    [sym_global_var] = ACTIONS(1365),
    [sym_local_var] = ACTIONS(1365),
    [aux_sym_metadata_ref_token1] = ACTIONS(1365),
    [sym_summary_ref] = ACTIONS(1365),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1365),
    [anon_sym_source_filename] = ACTIONS(1365),
    [anon_sym_declare] = ACTIONS(1365),
    [anon_sym_define] = ACTIONS(1365),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1377),
    [anon_sym_uselistorder_bb] = ACTIONS(1365),
    [anon_sym_module] = ACTIONS(1365),
    [anon_sym_attributes] = ACTIONS(1365),
  },
  [377] = {
    [sym_type] = STATE(341),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1024),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [378] = {
    [sym_type] = STATE(345),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(989),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [379] = {
    [sym_unnamed_addr] = STATE(403),
    [sym_addrspace] = STATE(417),
    [sym_attribute] = STATE(419),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(419),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1379),
    [sym_global_var] = ACTIONS(1379),
    [sym_local_var] = ACTIONS(1379),
    [aux_sym_metadata_ref_token1] = ACTIONS(1379),
    [sym_summary_ref] = ACTIONS(1379),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1379),
    [anon_sym_source_filename] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_define] = ACTIONS(1379),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1381),
    [anon_sym_uselistorder_bb] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_attributes] = ACTIONS(1379),
  },
  [380] = {
    [sym_unnamed_addr] = STATE(406),
    [sym_addrspace] = STATE(437),
    [sym_attribute] = STATE(439),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(439),
    [ts_builtin_sym_end] = ACTIONS(1383),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1383),
    [sym_global_var] = ACTIONS(1383),
    [sym_local_var] = ACTIONS(1383),
    [aux_sym_metadata_ref_token1] = ACTIONS(1383),
    [sym_summary_ref] = ACTIONS(1383),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1383),
    [anon_sym_source_filename] = ACTIONS(1383),
    [anon_sym_declare] = ACTIONS(1383),
    [anon_sym_define] = ACTIONS(1383),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1385),
    [anon_sym_uselistorder_bb] = ACTIONS(1383),
    [anon_sym_module] = ACTIONS(1383),
    [anon_sym_attributes] = ACTIONS(1383),
  },
  [381] = {
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(782),
    [aux_sym_metadata_ref_token1] = ACTIONS(782),
    [anon_sym_unnamed_addr] = ACTIONS(782),
    [anon_sym_local_unnamed_addr] = ACTIONS(782),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_half] = ACTIONS(782),
    [anon_sym_bfloat] = ACTIONS(782),
    [anon_sym_float] = ACTIONS(782),
    [anon_sym_double] = ACTIONS(782),
    [anon_sym_x86_fp80] = ACTIONS(782),
    [anon_sym_fp128] = ACTIONS(782),
    [anon_sym_ppc_fp128] = ACTIONS(782),
    [anon_sym_label] = ACTIONS(782),
    [anon_sym_metadata] = ACTIONS(782),
    [anon_sym_x86_mmx] = ACTIONS(782),
    [anon_sym_x86_amx] = ACTIONS(782),
    [anon_sym_token] = ACTIONS(782),
    [anon_sym_opaque] = ACTIONS(782),
    [anon_sym_ptr] = ACTIONS(782),
    [aux_sym_type_keyword_token1] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_LT_LBRACE] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_addrspace] = ACTIONS(782),
    [anon_sym_RPAREN] = ACTIONS(782),
    [anon_sym_align] = ACTIONS(1387),
    [anon_sym_alignstack] = ACTIONS(1390),
    [anon_sym_allocsize] = ACTIONS(1390),
    [anon_sym_alwaysinline] = ACTIONS(1390),
    [anon_sym_builtin] = ACTIONS(1390),
    [anon_sym_cold] = ACTIONS(1390),
    [anon_sym_convergent] = ACTIONS(1390),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1390),
    [anon_sym_hot] = ACTIONS(1390),
    [anon_sym_inaccessiblememonly] = ACTIONS(1390),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1390),
    [anon_sym_inlinehint] = ACTIONS(1390),
    [anon_sym_jumptable] = ACTIONS(1390),
    [anon_sym_minsize] = ACTIONS(1390),
    [anon_sym_naked] = ACTIONS(1390),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1390),
    [anon_sym_nobuiltin] = ACTIONS(1390),
    [anon_sym_noduplicate] = ACTIONS(1390),
    [anon_sym_nofree] = ACTIONS(1390),
    [anon_sym_noimplicitfloat] = ACTIONS(1390),
    [anon_sym_noinline] = ACTIONS(1390),
    [anon_sym_nomerge] = ACTIONS(1390),
    [anon_sym_nonlazybind] = ACTIONS(1390),
    [anon_sym_noprofile] = ACTIONS(1390),
    [anon_sym_noredzone] = ACTIONS(1390),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [anon_sym_norecurse] = ACTIONS(1390),
    [anon_sym_willreturn] = ACTIONS(1390),
    [anon_sym_nosync] = ACTIONS(1390),
    [anon_sym_nounwind] = ACTIONS(1390),
    [anon_sym_nosanitize_coverage] = ACTIONS(1390),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1390),
    [anon_sym_optforfuzzing] = ACTIONS(1390),
    [anon_sym_optnone] = ACTIONS(1390),
    [anon_sym_optsize] = ACTIONS(1390),
    [anon_sym_readnone] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_writeonly] = ACTIONS(1390),
    [anon_sym_argmemonly] = ACTIONS(1390),
    [anon_sym_returns_twice] = ACTIONS(1390),
    [anon_sym_safestack] = ACTIONS(1390),
    [anon_sym_sanitize_address] = ACTIONS(1390),
    [anon_sym_sanitize_memory] = ACTIONS(1390),
    [anon_sym_sanitize_thread] = ACTIONS(1390),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1390),
    [anon_sym_sanitize_memtag] = ACTIONS(1390),
    [anon_sym_speculative_load_hardening] = ACTIONS(1390),
    [anon_sym_speculatable] = ACTIONS(1390),
    [anon_sym_ssp] = ACTIONS(1393),
    [anon_sym_sspstrong] = ACTIONS(1390),
    [anon_sym_sspreq] = ACTIONS(1390),
    [anon_sym_strictfp] = ACTIONS(1390),
    [anon_sym_uwtable] = ACTIONS(1390),
    [anon_sym_nocf_check] = ACTIONS(1390),
    [anon_sym_shadowcallstack] = ACTIONS(1390),
    [anon_sym_mustprogress] = ACTIONS(1390),
    [anon_sym_vscale_range] = ACTIONS(1390),
    [anon_sym_preallocated] = ACTIONS(1390),
    [anon_sym_zeroext] = ACTIONS(1390),
    [anon_sym_signext] = ACTIONS(1390),
    [anon_sym_inreg] = ACTIONS(1390),
    [anon_sym_byval] = ACTIONS(1390),
    [anon_sym_byref] = ACTIONS(1390),
    [anon_sym_inalloca] = ACTIONS(1390),
    [anon_sym_sret] = ACTIONS(1390),
    [anon_sym_elementtype] = ACTIONS(1390),
    [anon_sym_noalias] = ACTIONS(1390),
    [anon_sym_nocapture] = ACTIONS(1390),
    [anon_sym_nest] = ACTIONS(1390),
    [anon_sym_returned] = ACTIONS(1390),
    [anon_sym_nonnull] = ACTIONS(1390),
    [anon_sym_dereferenceable] = ACTIONS(1393),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1390),
    [anon_sym_swiftself] = ACTIONS(1390),
    [anon_sym_swiftasync] = ACTIONS(1390),
    [anon_sym_swifterror] = ACTIONS(1390),
    [anon_sym_immarg] = ACTIONS(1390),
    [anon_sym_noundef] = ACTIONS(1390),
    [anon_sym_null] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(784),
  },
  [382] = {
    [sym_unnamed_addr] = STATE(407),
    [sym_addrspace] = STATE(421),
    [sym_attribute] = STATE(420),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(420),
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1396),
    [sym_global_var] = ACTIONS(1396),
    [sym_local_var] = ACTIONS(1396),
    [aux_sym_metadata_ref_token1] = ACTIONS(1396),
    [sym_summary_ref] = ACTIONS(1396),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1396),
    [anon_sym_source_filename] = ACTIONS(1396),
    [anon_sym_declare] = ACTIONS(1396),
    [anon_sym_define] = ACTIONS(1396),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1398),
    [anon_sym_uselistorder_bb] = ACTIONS(1396),
    [anon_sym_module] = ACTIONS(1396),
    [anon_sym_attributes] = ACTIONS(1396),
  },
  [383] = {
    [sym_type] = STATE(342),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1004),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [384] = {
    [sym_type] = STATE(342),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(1004),
    [sym_param_or_return_attrs] = STATE(377),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(377),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [385] = {
    [sym_type] = STATE(349),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(998),
    [sym_param_or_return_attrs] = STATE(381),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(381),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [386] = {
    [sym_unnamed_addr] = STATE(404),
    [sym_addrspace] = STATE(436),
    [sym_attribute] = STATE(430),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(430),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1400),
    [sym_global_var] = ACTIONS(1400),
    [sym_local_var] = ACTIONS(1400),
    [aux_sym_metadata_ref_token1] = ACTIONS(1400),
    [sym_summary_ref] = ACTIONS(1400),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1400),
    [anon_sym_source_filename] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_define] = ACTIONS(1400),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1402),
    [anon_sym_uselistorder_bb] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_attributes] = ACTIONS(1400),
  },
  [387] = {
    [sym_type] = STATE(349),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_addrspace] = STATE(998),
    [sym_param_or_return_attrs] = STATE(378),
    [sym_attribute_name] = STATE(389),
    [aux_sym_function_header_repeat2] = STATE(378),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [388] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1040),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1040),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1404),
    [sym_global_var] = ACTIONS(1404),
    [sym_local_var] = ACTIONS(1404),
    [aux_sym_metadata_ref_token1] = ACTIONS(1404),
    [sym_summary_ref] = ACTIONS(1404),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1404),
    [anon_sym_source_filename] = ACTIONS(1404),
    [anon_sym_declare] = ACTIONS(1404),
    [anon_sym_define] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1408),
    [anon_sym_uselistorder_bb] = ACTIONS(1404),
    [anon_sym_module] = ACTIONS(1404),
    [anon_sym_attributes] = ACTIONS(1404),
  },
  [389] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(829),
    [aux_sym_metadata_ref_token1] = ACTIONS(829),
    [anon_sym_unnamed_addr] = ACTIONS(829),
    [anon_sym_local_unnamed_addr] = ACTIONS(829),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_half] = ACTIONS(829),
    [anon_sym_bfloat] = ACTIONS(829),
    [anon_sym_float] = ACTIONS(829),
    [anon_sym_double] = ACTIONS(829),
    [anon_sym_x86_fp80] = ACTIONS(829),
    [anon_sym_fp128] = ACTIONS(829),
    [anon_sym_ppc_fp128] = ACTIONS(829),
    [anon_sym_label] = ACTIONS(829),
    [anon_sym_metadata] = ACTIONS(829),
    [anon_sym_x86_mmx] = ACTIONS(829),
    [anon_sym_x86_amx] = ACTIONS(829),
    [anon_sym_token] = ACTIONS(829),
    [anon_sym_opaque] = ACTIONS(829),
    [anon_sym_ptr] = ACTIONS(829),
    [aux_sym_type_keyword_token1] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_LT_LBRACE] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(829),
    [anon_sym_addrspace] = ACTIONS(829),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_align] = ACTIONS(831),
    [anon_sym_alignstack] = ACTIONS(829),
    [anon_sym_allocsize] = ACTIONS(829),
    [anon_sym_alwaysinline] = ACTIONS(829),
    [anon_sym_builtin] = ACTIONS(829),
    [anon_sym_cold] = ACTIONS(829),
    [anon_sym_convergent] = ACTIONS(829),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(829),
    [anon_sym_hot] = ACTIONS(829),
    [anon_sym_inaccessiblememonly] = ACTIONS(829),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(829),
    [anon_sym_inlinehint] = ACTIONS(829),
    [anon_sym_jumptable] = ACTIONS(829),
    [anon_sym_minsize] = ACTIONS(829),
    [anon_sym_naked] = ACTIONS(829),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(829),
    [anon_sym_nobuiltin] = ACTIONS(829),
    [anon_sym_noduplicate] = ACTIONS(829),
    [anon_sym_nofree] = ACTIONS(829),
    [anon_sym_noimplicitfloat] = ACTIONS(829),
    [anon_sym_noinline] = ACTIONS(829),
    [anon_sym_nomerge] = ACTIONS(829),
    [anon_sym_nonlazybind] = ACTIONS(829),
    [anon_sym_noprofile] = ACTIONS(829),
    [anon_sym_noredzone] = ACTIONS(829),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(829),
    [anon_sym_noreturn] = ACTIONS(829),
    [anon_sym_norecurse] = ACTIONS(829),
    [anon_sym_willreturn] = ACTIONS(829),
    [anon_sym_nosync] = ACTIONS(829),
    [anon_sym_nounwind] = ACTIONS(829),
    [anon_sym_nosanitize_coverage] = ACTIONS(829),
    [anon_sym_null_pointer_is_valid] = ACTIONS(829),
    [anon_sym_optforfuzzing] = ACTIONS(829),
    [anon_sym_optnone] = ACTIONS(829),
    [anon_sym_optsize] = ACTIONS(829),
    [anon_sym_readnone] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_writeonly] = ACTIONS(829),
    [anon_sym_argmemonly] = ACTIONS(829),
    [anon_sym_returns_twice] = ACTIONS(829),
    [anon_sym_safestack] = ACTIONS(829),
    [anon_sym_sanitize_address] = ACTIONS(829),
    [anon_sym_sanitize_memory] = ACTIONS(829),
    [anon_sym_sanitize_thread] = ACTIONS(829),
    [anon_sym_sanitize_hwaddress] = ACTIONS(829),
    [anon_sym_sanitize_memtag] = ACTIONS(829),
    [anon_sym_speculative_load_hardening] = ACTIONS(829),
    [anon_sym_speculatable] = ACTIONS(829),
    [anon_sym_ssp] = ACTIONS(831),
    [anon_sym_sspstrong] = ACTIONS(829),
    [anon_sym_sspreq] = ACTIONS(829),
    [anon_sym_strictfp] = ACTIONS(829),
    [anon_sym_uwtable] = ACTIONS(829),
    [anon_sym_nocf_check] = ACTIONS(829),
    [anon_sym_shadowcallstack] = ACTIONS(829),
    [anon_sym_mustprogress] = ACTIONS(829),
    [anon_sym_vscale_range] = ACTIONS(829),
    [anon_sym_preallocated] = ACTIONS(829),
    [anon_sym_zeroext] = ACTIONS(829),
    [anon_sym_signext] = ACTIONS(829),
    [anon_sym_inreg] = ACTIONS(829),
    [anon_sym_byval] = ACTIONS(829),
    [anon_sym_byref] = ACTIONS(829),
    [anon_sym_inalloca] = ACTIONS(829),
    [anon_sym_sret] = ACTIONS(829),
    [anon_sym_elementtype] = ACTIONS(829),
    [anon_sym_noalias] = ACTIONS(829),
    [anon_sym_nocapture] = ACTIONS(829),
    [anon_sym_nest] = ACTIONS(829),
    [anon_sym_returned] = ACTIONS(829),
    [anon_sym_nonnull] = ACTIONS(829),
    [anon_sym_dereferenceable] = ACTIONS(831),
    [anon_sym_dereferenceable_or_null] = ACTIONS(829),
    [anon_sym_swiftself] = ACTIONS(829),
    [anon_sym_swiftasync] = ACTIONS(829),
    [anon_sym_swifterror] = ACTIONS(829),
    [anon_sym_immarg] = ACTIONS(829),
    [anon_sym_noundef] = ACTIONS(829),
    [anon_sym_null] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(831),
  },
  [390] = {
    [sym_attribute] = STATE(393),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1042),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1042),
    [aux_sym_global_global_repeat1] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1412),
    [sym_global_var] = ACTIONS(1412),
    [sym_local_var] = ACTIONS(1412),
    [aux_sym_metadata_ref_token1] = ACTIONS(1412),
    [sym_summary_ref] = ACTIONS(1412),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1412),
    [anon_sym_source_filename] = ACTIONS(1412),
    [anon_sym_declare] = ACTIONS(1412),
    [anon_sym_define] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1414),
    [anon_sym_uselistorder_bb] = ACTIONS(1412),
    [anon_sym_module] = ACTIONS(1412),
    [anon_sym_attributes] = ACTIONS(1412),
  },
  [391] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1035),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1035),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1416),
    [sym_global_var] = ACTIONS(1416),
    [sym_local_var] = ACTIONS(1416),
    [aux_sym_metadata_ref_token1] = ACTIONS(1416),
    [sym_summary_ref] = ACTIONS(1416),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1416),
    [anon_sym_source_filename] = ACTIONS(1416),
    [anon_sym_declare] = ACTIONS(1416),
    [anon_sym_define] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1418),
    [anon_sym_uselistorder_bb] = ACTIONS(1416),
    [anon_sym_module] = ACTIONS(1416),
    [anon_sym_attributes] = ACTIONS(1416),
  },
  [392] = {
    [sym_attribute] = STATE(396),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1035),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1035),
    [aux_sym_global_global_repeat1] = STATE(396),
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1416),
    [sym_global_var] = ACTIONS(1416),
    [sym_local_var] = ACTIONS(1416),
    [aux_sym_metadata_ref_token1] = ACTIONS(1416),
    [sym_summary_ref] = ACTIONS(1416),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1416),
    [anon_sym_source_filename] = ACTIONS(1416),
    [anon_sym_declare] = ACTIONS(1416),
    [anon_sym_define] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1418),
    [anon_sym_uselistorder_bb] = ACTIONS(1416),
    [anon_sym_module] = ACTIONS(1416),
    [anon_sym_attributes] = ACTIONS(1416),
  },
  [393] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1041),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1041),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1420),
    [sym_global_var] = ACTIONS(1420),
    [sym_local_var] = ACTIONS(1420),
    [aux_sym_metadata_ref_token1] = ACTIONS(1420),
    [sym_summary_ref] = ACTIONS(1420),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1420),
    [anon_sym_source_filename] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_define] = ACTIONS(1420),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1422),
    [anon_sym_uselistorder_bb] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_attributes] = ACTIONS(1420),
  },
  [394] = {
    [sym_attribute] = STATE(395),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1041),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1041),
    [aux_sym_global_global_repeat1] = STATE(395),
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1420),
    [sym_global_var] = ACTIONS(1420),
    [sym_local_var] = ACTIONS(1420),
    [aux_sym_metadata_ref_token1] = ACTIONS(1420),
    [sym_summary_ref] = ACTIONS(1420),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1420),
    [anon_sym_source_filename] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_define] = ACTIONS(1420),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1422),
    [anon_sym_uselistorder_bb] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_attributes] = ACTIONS(1420),
  },
  [395] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1036),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1036),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1424),
    [sym_global_var] = ACTIONS(1424),
    [sym_local_var] = ACTIONS(1424),
    [aux_sym_metadata_ref_token1] = ACTIONS(1424),
    [sym_summary_ref] = ACTIONS(1424),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1424),
    [anon_sym_source_filename] = ACTIONS(1424),
    [anon_sym_declare] = ACTIONS(1424),
    [anon_sym_define] = ACTIONS(1424),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1426),
    [anon_sym_uselistorder_bb] = ACTIONS(1424),
    [anon_sym_module] = ACTIONS(1424),
    [anon_sym_attributes] = ACTIONS(1424),
  },
  [396] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1038),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1038),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1428),
    [sym_global_var] = ACTIONS(1428),
    [sym_local_var] = ACTIONS(1428),
    [aux_sym_metadata_ref_token1] = ACTIONS(1428),
    [sym_summary_ref] = ACTIONS(1428),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1428),
    [anon_sym_source_filename] = ACTIONS(1428),
    [anon_sym_declare] = ACTIONS(1428),
    [anon_sym_define] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1430),
    [anon_sym_uselistorder_bb] = ACTIONS(1428),
    [anon_sym_module] = ACTIONS(1428),
    [anon_sym_attributes] = ACTIONS(1428),
  },
  [397] = {
    [sym_attribute] = STATE(388),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1037),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1037),
    [aux_sym_global_global_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1432),
    [sym_global_var] = ACTIONS(1432),
    [sym_local_var] = ACTIONS(1432),
    [aux_sym_metadata_ref_token1] = ACTIONS(1432),
    [sym_summary_ref] = ACTIONS(1432),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1432),
    [anon_sym_source_filename] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1432),
    [anon_sym_define] = ACTIONS(1432),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1434),
    [anon_sym_uselistorder_bb] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [anon_sym_attributes] = ACTIONS(1432),
  },
  [398] = {
    [sym_attribute] = STATE(391),
    [sym_attribute_name] = STATE(399),
    [sym_metadata_refs] = STATE(1043),
    [sym_alignment] = STATE(410),
    [aux_sym_instruction_repeat1] = STATE(1043),
    [aux_sym_global_global_repeat1] = STATE(391),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1436),
    [sym_global_var] = ACTIONS(1436),
    [sym_local_var] = ACTIONS(1436),
    [aux_sym_metadata_ref_token1] = ACTIONS(1436),
    [sym_summary_ref] = ACTIONS(1436),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1436),
    [anon_sym_source_filename] = ACTIONS(1436),
    [anon_sym_declare] = ACTIONS(1436),
    [anon_sym_define] = ACTIONS(1436),
    [anon_sym_COMMA] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1438),
    [anon_sym_uselistorder_bb] = ACTIONS(1436),
    [anon_sym_module] = ACTIONS(1436),
    [anon_sym_attributes] = ACTIONS(1436),
  },
  [399] = {
    [ts_builtin_sym_end] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_comdat_ref] = ACTIONS(795),
    [sym_global_var] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [aux_sym_metadata_ref_token1] = ACTIONS(795),
    [sym_summary_ref] = ACTIONS(795),
    [sym_string] = ACTIONS(795),
    [anon_sym_target] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_source_filename] = ACTIONS(795),
    [anon_sym_declare] = ACTIONS(795),
    [anon_sym_define] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(795),
    [anon_sym_partition] = ACTIONS(795),
    [anon_sym_comdat] = ACTIONS(795),
    [anon_sym_gc] = ACTIONS(795),
    [anon_sym_prefix] = ACTIONS(795),
    [anon_sym_prologue] = ACTIONS(795),
    [anon_sym_personality] = ACTIONS(795),
    [anon_sym_alignstack] = ACTIONS(795),
    [anon_sym_allocsize] = ACTIONS(795),
    [anon_sym_alwaysinline] = ACTIONS(795),
    [anon_sym_builtin] = ACTIONS(795),
    [anon_sym_cold] = ACTIONS(795),
    [anon_sym_convergent] = ACTIONS(795),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(795),
    [anon_sym_hot] = ACTIONS(795),
    [anon_sym_inaccessiblememonly] = ACTIONS(795),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(795),
    [anon_sym_inlinehint] = ACTIONS(795),
    [anon_sym_jumptable] = ACTIONS(795),
    [anon_sym_minsize] = ACTIONS(795),
    [anon_sym_naked] = ACTIONS(795),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(795),
    [anon_sym_nobuiltin] = ACTIONS(795),
    [anon_sym_noduplicate] = ACTIONS(795),
    [anon_sym_nofree] = ACTIONS(795),
    [anon_sym_noimplicitfloat] = ACTIONS(795),
    [anon_sym_noinline] = ACTIONS(795),
    [anon_sym_nomerge] = ACTIONS(795),
    [anon_sym_nonlazybind] = ACTIONS(795),
    [anon_sym_noprofile] = ACTIONS(795),
    [anon_sym_noredzone] = ACTIONS(795),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(795),
    [anon_sym_noreturn] = ACTIONS(795),
    [anon_sym_norecurse] = ACTIONS(795),
    [anon_sym_willreturn] = ACTIONS(795),
    [anon_sym_nosync] = ACTIONS(795),
    [anon_sym_nounwind] = ACTIONS(795),
    [anon_sym_nosanitize_coverage] = ACTIONS(795),
    [anon_sym_null_pointer_is_valid] = ACTIONS(795),
    [anon_sym_optforfuzzing] = ACTIONS(795),
    [anon_sym_optnone] = ACTIONS(795),
    [anon_sym_optsize] = ACTIONS(795),
    [anon_sym_readnone] = ACTIONS(795),
    [anon_sym_readonly] = ACTIONS(795),
    [anon_sym_writeonly] = ACTIONS(795),
    [anon_sym_argmemonly] = ACTIONS(795),
    [anon_sym_returns_twice] = ACTIONS(795),
    [anon_sym_safestack] = ACTIONS(795),
    [anon_sym_sanitize_address] = ACTIONS(795),
    [anon_sym_sanitize_memory] = ACTIONS(795),
    [anon_sym_sanitize_thread] = ACTIONS(795),
    [anon_sym_sanitize_hwaddress] = ACTIONS(795),
    [anon_sym_sanitize_memtag] = ACTIONS(795),
    [anon_sym_speculative_load_hardening] = ACTIONS(795),
    [anon_sym_speculatable] = ACTIONS(795),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(795),
    [anon_sym_sspreq] = ACTIONS(795),
    [anon_sym_strictfp] = ACTIONS(795),
    [anon_sym_uwtable] = ACTIONS(795),
    [anon_sym_nocf_check] = ACTIONS(795),
    [anon_sym_shadowcallstack] = ACTIONS(795),
    [anon_sym_mustprogress] = ACTIONS(795),
    [anon_sym_vscale_range] = ACTIONS(795),
    [anon_sym_preallocated] = ACTIONS(795),
    [anon_sym_zeroext] = ACTIONS(795),
    [anon_sym_signext] = ACTIONS(795),
    [anon_sym_inreg] = ACTIONS(795),
    [anon_sym_byval] = ACTIONS(795),
    [anon_sym_byref] = ACTIONS(795),
    [anon_sym_inalloca] = ACTIONS(795),
    [anon_sym_sret] = ACTIONS(795),
    [anon_sym_elementtype] = ACTIONS(795),
    [anon_sym_noalias] = ACTIONS(795),
    [anon_sym_nocapture] = ACTIONS(795),
    [anon_sym_nest] = ACTIONS(795),
    [anon_sym_returned] = ACTIONS(795),
    [anon_sym_nonnull] = ACTIONS(795),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(795),
    [anon_sym_swiftself] = ACTIONS(795),
    [anon_sym_swiftasync] = ACTIONS(795),
    [anon_sym_swifterror] = ACTIONS(795),
    [anon_sym_immarg] = ACTIONS(795),
    [anon_sym_noundef] = ACTIONS(795),
    [anon_sym_to] = ACTIONS(795),
    [anon_sym_uselistorder] = ACTIONS(797),
    [anon_sym_uselistorder_bb] = ACTIONS(795),
    [anon_sym_module] = ACTIONS(795),
    [anon_sym_attributes] = ACTIONS(795),
  },
  [400] = {
    [sym_addrspace] = STATE(440),
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1444),
    [sym_global_var] = ACTIONS(1444),
    [sym_local_var] = ACTIONS(1444),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_summary_ref] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1444),
    [anon_sym_source_filename] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_define] = ACTIONS(1444),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1446),
    [anon_sym_uselistorder_bb] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_attributes] = ACTIONS(1444),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_comdat_ref] = ACTIONS(795),
    [sym_global_var] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [aux_sym_metadata_ref_token1] = ACTIONS(795),
    [sym_summary_ref] = ACTIONS(795),
    [sym_string] = ACTIONS(795),
    [anon_sym_target] = ACTIONS(795),
    [anon_sym_source_filename] = ACTIONS(795),
    [anon_sym_declare] = ACTIONS(795),
    [anon_sym_define] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(795),
    [anon_sym_partition] = ACTIONS(795),
    [anon_sym_comdat] = ACTIONS(795),
    [anon_sym_gc] = ACTIONS(795),
    [anon_sym_prefix] = ACTIONS(795),
    [anon_sym_prologue] = ACTIONS(795),
    [anon_sym_personality] = ACTIONS(795),
    [anon_sym_alignstack] = ACTIONS(795),
    [anon_sym_allocsize] = ACTIONS(795),
    [anon_sym_alwaysinline] = ACTIONS(795),
    [anon_sym_builtin] = ACTIONS(795),
    [anon_sym_cold] = ACTIONS(795),
    [anon_sym_convergent] = ACTIONS(795),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(795),
    [anon_sym_hot] = ACTIONS(795),
    [anon_sym_inaccessiblememonly] = ACTIONS(795),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(795),
    [anon_sym_inlinehint] = ACTIONS(795),
    [anon_sym_jumptable] = ACTIONS(795),
    [anon_sym_minsize] = ACTIONS(795),
    [anon_sym_naked] = ACTIONS(795),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(795),
    [anon_sym_nobuiltin] = ACTIONS(795),
    [anon_sym_noduplicate] = ACTIONS(795),
    [anon_sym_nofree] = ACTIONS(795),
    [anon_sym_noimplicitfloat] = ACTIONS(795),
    [anon_sym_noinline] = ACTIONS(795),
    [anon_sym_nomerge] = ACTIONS(795),
    [anon_sym_nonlazybind] = ACTIONS(795),
    [anon_sym_noprofile] = ACTIONS(795),
    [anon_sym_noredzone] = ACTIONS(795),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(795),
    [anon_sym_noreturn] = ACTIONS(795),
    [anon_sym_norecurse] = ACTIONS(795),
    [anon_sym_willreturn] = ACTIONS(795),
    [anon_sym_nosync] = ACTIONS(795),
    [anon_sym_nounwind] = ACTIONS(795),
    [anon_sym_nosanitize_coverage] = ACTIONS(795),
    [anon_sym_null_pointer_is_valid] = ACTIONS(795),
    [anon_sym_optforfuzzing] = ACTIONS(795),
    [anon_sym_optnone] = ACTIONS(795),
    [anon_sym_optsize] = ACTIONS(795),
    [anon_sym_readnone] = ACTIONS(795),
    [anon_sym_readonly] = ACTIONS(795),
    [anon_sym_writeonly] = ACTIONS(795),
    [anon_sym_argmemonly] = ACTIONS(795),
    [anon_sym_returns_twice] = ACTIONS(795),
    [anon_sym_safestack] = ACTIONS(795),
    [anon_sym_sanitize_address] = ACTIONS(795),
    [anon_sym_sanitize_memory] = ACTIONS(795),
    [anon_sym_sanitize_thread] = ACTIONS(795),
    [anon_sym_sanitize_hwaddress] = ACTIONS(795),
    [anon_sym_sanitize_memtag] = ACTIONS(795),
    [anon_sym_speculative_load_hardening] = ACTIONS(795),
    [anon_sym_speculatable] = ACTIONS(795),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(795),
    [anon_sym_sspreq] = ACTIONS(795),
    [anon_sym_strictfp] = ACTIONS(795),
    [anon_sym_uwtable] = ACTIONS(795),
    [anon_sym_nocf_check] = ACTIONS(795),
    [anon_sym_shadowcallstack] = ACTIONS(795),
    [anon_sym_mustprogress] = ACTIONS(795),
    [anon_sym_vscale_range] = ACTIONS(795),
    [anon_sym_preallocated] = ACTIONS(795),
    [anon_sym_zeroext] = ACTIONS(795),
    [anon_sym_signext] = ACTIONS(795),
    [anon_sym_inreg] = ACTIONS(795),
    [anon_sym_byval] = ACTIONS(795),
    [anon_sym_byref] = ACTIONS(795),
    [anon_sym_inalloca] = ACTIONS(795),
    [anon_sym_sret] = ACTIONS(795),
    [anon_sym_elementtype] = ACTIONS(795),
    [anon_sym_noalias] = ACTIONS(795),
    [anon_sym_nocapture] = ACTIONS(795),
    [anon_sym_nest] = ACTIONS(795),
    [anon_sym_returned] = ACTIONS(795),
    [anon_sym_nonnull] = ACTIONS(795),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(795),
    [anon_sym_swiftself] = ACTIONS(795),
    [anon_sym_swiftasync] = ACTIONS(795),
    [anon_sym_swifterror] = ACTIONS(795),
    [anon_sym_immarg] = ACTIONS(795),
    [anon_sym_noundef] = ACTIONS(795),
    [anon_sym_to] = ACTIONS(795),
    [anon_sym_uselistorder] = ACTIONS(797),
    [anon_sym_uselistorder_bb] = ACTIONS(795),
    [anon_sym_module] = ACTIONS(795),
    [anon_sym_attributes] = ACTIONS(795),
  },
  [402] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(839),
    [aux_sym_metadata_ref_token1] = ACTIONS(839),
    [anon_sym_unnamed_addr] = ACTIONS(839),
    [anon_sym_local_unnamed_addr] = ACTIONS(839),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_half] = ACTIONS(839),
    [anon_sym_bfloat] = ACTIONS(839),
    [anon_sym_float] = ACTIONS(839),
    [anon_sym_double] = ACTIONS(839),
    [anon_sym_x86_fp80] = ACTIONS(839),
    [anon_sym_fp128] = ACTIONS(839),
    [anon_sym_ppc_fp128] = ACTIONS(839),
    [anon_sym_label] = ACTIONS(839),
    [anon_sym_metadata] = ACTIONS(839),
    [anon_sym_x86_mmx] = ACTIONS(839),
    [anon_sym_x86_amx] = ACTIONS(839),
    [anon_sym_token] = ACTIONS(839),
    [anon_sym_opaque] = ACTIONS(839),
    [anon_sym_ptr] = ACTIONS(839),
    [aux_sym_type_keyword_token1] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LT_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_addrspace] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_alignstack] = ACTIONS(839),
    [anon_sym_allocsize] = ACTIONS(839),
    [anon_sym_alwaysinline] = ACTIONS(839),
    [anon_sym_builtin] = ACTIONS(839),
    [anon_sym_cold] = ACTIONS(839),
    [anon_sym_convergent] = ACTIONS(839),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(839),
    [anon_sym_hot] = ACTIONS(839),
    [anon_sym_inaccessiblememonly] = ACTIONS(839),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(839),
    [anon_sym_inlinehint] = ACTIONS(839),
    [anon_sym_jumptable] = ACTIONS(839),
    [anon_sym_minsize] = ACTIONS(839),
    [anon_sym_naked] = ACTIONS(839),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(839),
    [anon_sym_nobuiltin] = ACTIONS(839),
    [anon_sym_noduplicate] = ACTIONS(839),
    [anon_sym_nofree] = ACTIONS(839),
    [anon_sym_noimplicitfloat] = ACTIONS(839),
    [anon_sym_noinline] = ACTIONS(839),
    [anon_sym_nomerge] = ACTIONS(839),
    [anon_sym_nonlazybind] = ACTIONS(839),
    [anon_sym_noprofile] = ACTIONS(839),
    [anon_sym_noredzone] = ACTIONS(839),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(839),
    [anon_sym_noreturn] = ACTIONS(839),
    [anon_sym_norecurse] = ACTIONS(839),
    [anon_sym_willreturn] = ACTIONS(839),
    [anon_sym_nosync] = ACTIONS(839),
    [anon_sym_nounwind] = ACTIONS(839),
    [anon_sym_nosanitize_coverage] = ACTIONS(839),
    [anon_sym_null_pointer_is_valid] = ACTIONS(839),
    [anon_sym_optforfuzzing] = ACTIONS(839),
    [anon_sym_optnone] = ACTIONS(839),
    [anon_sym_optsize] = ACTIONS(839),
    [anon_sym_readnone] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_writeonly] = ACTIONS(839),
    [anon_sym_argmemonly] = ACTIONS(839),
    [anon_sym_returns_twice] = ACTIONS(839),
    [anon_sym_safestack] = ACTIONS(839),
    [anon_sym_sanitize_address] = ACTIONS(839),
    [anon_sym_sanitize_memory] = ACTIONS(839),
    [anon_sym_sanitize_thread] = ACTIONS(839),
    [anon_sym_sanitize_hwaddress] = ACTIONS(839),
    [anon_sym_sanitize_memtag] = ACTIONS(839),
    [anon_sym_speculative_load_hardening] = ACTIONS(839),
    [anon_sym_speculatable] = ACTIONS(839),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(839),
    [anon_sym_sspreq] = ACTIONS(839),
    [anon_sym_strictfp] = ACTIONS(839),
    [anon_sym_uwtable] = ACTIONS(839),
    [anon_sym_nocf_check] = ACTIONS(839),
    [anon_sym_shadowcallstack] = ACTIONS(839),
    [anon_sym_mustprogress] = ACTIONS(839),
    [anon_sym_vscale_range] = ACTIONS(839),
    [anon_sym_preallocated] = ACTIONS(839),
    [anon_sym_zeroext] = ACTIONS(839),
    [anon_sym_signext] = ACTIONS(839),
    [anon_sym_inreg] = ACTIONS(839),
    [anon_sym_byval] = ACTIONS(839),
    [anon_sym_byref] = ACTIONS(839),
    [anon_sym_inalloca] = ACTIONS(839),
    [anon_sym_sret] = ACTIONS(839),
    [anon_sym_elementtype] = ACTIONS(839),
    [anon_sym_noalias] = ACTIONS(839),
    [anon_sym_nocapture] = ACTIONS(839),
    [anon_sym_nest] = ACTIONS(839),
    [anon_sym_returned] = ACTIONS(839),
    [anon_sym_nonnull] = ACTIONS(839),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(839),
    [anon_sym_swiftself] = ACTIONS(839),
    [anon_sym_swiftasync] = ACTIONS(839),
    [anon_sym_swifterror] = ACTIONS(839),
    [anon_sym_immarg] = ACTIONS(839),
    [anon_sym_noundef] = ACTIONS(839),
    [anon_sym_null] = ACTIONS(841),
    [anon_sym_BANG] = ACTIONS(841),
  },
  [403] = {
    [sym_addrspace] = STATE(427),
    [sym_attribute] = STATE(426),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1450),
    [sym_global_var] = ACTIONS(1450),
    [sym_local_var] = ACTIONS(1450),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_summary_ref] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1450),
    [anon_sym_source_filename] = ACTIONS(1450),
    [anon_sym_declare] = ACTIONS(1450),
    [anon_sym_define] = ACTIONS(1450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1452),
    [anon_sym_uselistorder_bb] = ACTIONS(1450),
    [anon_sym_module] = ACTIONS(1450),
    [anon_sym_attributes] = ACTIONS(1450),
  },
  [404] = {
    [sym_addrspace] = STATE(434),
    [sym_attribute] = STATE(431),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(431),
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1454),
    [sym_global_var] = ACTIONS(1454),
    [sym_local_var] = ACTIONS(1454),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_summary_ref] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1454),
    [anon_sym_source_filename] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_define] = ACTIONS(1454),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1456),
    [anon_sym_uselistorder_bb] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_attributes] = ACTIONS(1454),
  },
  [405] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(835),
    [aux_sym_metadata_ref_token1] = ACTIONS(835),
    [anon_sym_unnamed_addr] = ACTIONS(835),
    [anon_sym_local_unnamed_addr] = ACTIONS(835),
    [anon_sym_void] = ACTIONS(835),
    [anon_sym_half] = ACTIONS(835),
    [anon_sym_bfloat] = ACTIONS(835),
    [anon_sym_float] = ACTIONS(835),
    [anon_sym_double] = ACTIONS(835),
    [anon_sym_x86_fp80] = ACTIONS(835),
    [anon_sym_fp128] = ACTIONS(835),
    [anon_sym_ppc_fp128] = ACTIONS(835),
    [anon_sym_label] = ACTIONS(835),
    [anon_sym_metadata] = ACTIONS(835),
    [anon_sym_x86_mmx] = ACTIONS(835),
    [anon_sym_x86_amx] = ACTIONS(835),
    [anon_sym_token] = ACTIONS(835),
    [anon_sym_opaque] = ACTIONS(835),
    [anon_sym_ptr] = ACTIONS(835),
    [aux_sym_type_keyword_token1] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_LT_LBRACE] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_addrspace] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_alignstack] = ACTIONS(835),
    [anon_sym_allocsize] = ACTIONS(835),
    [anon_sym_alwaysinline] = ACTIONS(835),
    [anon_sym_builtin] = ACTIONS(835),
    [anon_sym_cold] = ACTIONS(835),
    [anon_sym_convergent] = ACTIONS(835),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(835),
    [anon_sym_hot] = ACTIONS(835),
    [anon_sym_inaccessiblememonly] = ACTIONS(835),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(835),
    [anon_sym_inlinehint] = ACTIONS(835),
    [anon_sym_jumptable] = ACTIONS(835),
    [anon_sym_minsize] = ACTIONS(835),
    [anon_sym_naked] = ACTIONS(835),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(835),
    [anon_sym_nobuiltin] = ACTIONS(835),
    [anon_sym_noduplicate] = ACTIONS(835),
    [anon_sym_nofree] = ACTIONS(835),
    [anon_sym_noimplicitfloat] = ACTIONS(835),
    [anon_sym_noinline] = ACTIONS(835),
    [anon_sym_nomerge] = ACTIONS(835),
    [anon_sym_nonlazybind] = ACTIONS(835),
    [anon_sym_noprofile] = ACTIONS(835),
    [anon_sym_noredzone] = ACTIONS(835),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(835),
    [anon_sym_noreturn] = ACTIONS(835),
    [anon_sym_norecurse] = ACTIONS(835),
    [anon_sym_willreturn] = ACTIONS(835),
    [anon_sym_nosync] = ACTIONS(835),
    [anon_sym_nounwind] = ACTIONS(835),
    [anon_sym_nosanitize_coverage] = ACTIONS(835),
    [anon_sym_null_pointer_is_valid] = ACTIONS(835),
    [anon_sym_optforfuzzing] = ACTIONS(835),
    [anon_sym_optnone] = ACTIONS(835),
    [anon_sym_optsize] = ACTIONS(835),
    [anon_sym_readnone] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_writeonly] = ACTIONS(835),
    [anon_sym_argmemonly] = ACTIONS(835),
    [anon_sym_returns_twice] = ACTIONS(835),
    [anon_sym_safestack] = ACTIONS(835),
    [anon_sym_sanitize_address] = ACTIONS(835),
    [anon_sym_sanitize_memory] = ACTIONS(835),
    [anon_sym_sanitize_thread] = ACTIONS(835),
    [anon_sym_sanitize_hwaddress] = ACTIONS(835),
    [anon_sym_sanitize_memtag] = ACTIONS(835),
    [anon_sym_speculative_load_hardening] = ACTIONS(835),
    [anon_sym_speculatable] = ACTIONS(835),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(835),
    [anon_sym_sspreq] = ACTIONS(835),
    [anon_sym_strictfp] = ACTIONS(835),
    [anon_sym_uwtable] = ACTIONS(835),
    [anon_sym_nocf_check] = ACTIONS(835),
    [anon_sym_shadowcallstack] = ACTIONS(835),
    [anon_sym_mustprogress] = ACTIONS(835),
    [anon_sym_vscale_range] = ACTIONS(835),
    [anon_sym_preallocated] = ACTIONS(835),
    [anon_sym_zeroext] = ACTIONS(835),
    [anon_sym_signext] = ACTIONS(835),
    [anon_sym_inreg] = ACTIONS(835),
    [anon_sym_byval] = ACTIONS(835),
    [anon_sym_byref] = ACTIONS(835),
    [anon_sym_inalloca] = ACTIONS(835),
    [anon_sym_sret] = ACTIONS(835),
    [anon_sym_elementtype] = ACTIONS(835),
    [anon_sym_noalias] = ACTIONS(835),
    [anon_sym_nocapture] = ACTIONS(835),
    [anon_sym_nest] = ACTIONS(835),
    [anon_sym_returned] = ACTIONS(835),
    [anon_sym_nonnull] = ACTIONS(835),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(835),
    [anon_sym_swiftself] = ACTIONS(835),
    [anon_sym_swiftasync] = ACTIONS(835),
    [anon_sym_swifterror] = ACTIONS(835),
    [anon_sym_immarg] = ACTIONS(835),
    [anon_sym_noundef] = ACTIONS(835),
    [anon_sym_null] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(837),
  },
  [406] = {
    [sym_addrspace] = STATE(425),
    [sym_attribute] = STATE(423),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1458),
    [sym_global_var] = ACTIONS(1458),
    [sym_local_var] = ACTIONS(1458),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_summary_ref] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1458),
    [anon_sym_source_filename] = ACTIONS(1458),
    [anon_sym_declare] = ACTIONS(1458),
    [anon_sym_define] = ACTIONS(1458),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1460),
    [anon_sym_uselistorder_bb] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_attributes] = ACTIONS(1458),
  },
  [407] = {
    [sym_addrspace] = STATE(435),
    [sym_attribute] = STATE(438),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1462),
    [sym_global_var] = ACTIONS(1462),
    [sym_local_var] = ACTIONS(1462),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_summary_ref] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1462),
    [anon_sym_source_filename] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_define] = ACTIONS(1462),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1464),
    [anon_sym_uselistorder_bb] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_attributes] = ACTIONS(1462),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(825),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(825),
    [sym_comdat_ref] = ACTIONS(825),
    [sym_global_var] = ACTIONS(825),
    [sym_local_var] = ACTIONS(825),
    [aux_sym_metadata_ref_token1] = ACTIONS(825),
    [sym_summary_ref] = ACTIONS(825),
    [sym_string] = ACTIONS(825),
    [anon_sym_target] = ACTIONS(825),
    [anon_sym_source_filename] = ACTIONS(825),
    [anon_sym_declare] = ACTIONS(825),
    [anon_sym_define] = ACTIONS(825),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym_align] = ACTIONS(827),
    [anon_sym_section] = ACTIONS(825),
    [anon_sym_partition] = ACTIONS(825),
    [anon_sym_comdat] = ACTIONS(825),
    [anon_sym_gc] = ACTIONS(825),
    [anon_sym_prefix] = ACTIONS(825),
    [anon_sym_prologue] = ACTIONS(825),
    [anon_sym_personality] = ACTIONS(825),
    [anon_sym_alignstack] = ACTIONS(825),
    [anon_sym_allocsize] = ACTIONS(825),
    [anon_sym_alwaysinline] = ACTIONS(825),
    [anon_sym_builtin] = ACTIONS(825),
    [anon_sym_cold] = ACTIONS(825),
    [anon_sym_convergent] = ACTIONS(825),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(825),
    [anon_sym_hot] = ACTIONS(825),
    [anon_sym_inaccessiblememonly] = ACTIONS(825),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(825),
    [anon_sym_inlinehint] = ACTIONS(825),
    [anon_sym_jumptable] = ACTIONS(825),
    [anon_sym_minsize] = ACTIONS(825),
    [anon_sym_naked] = ACTIONS(825),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(825),
    [anon_sym_nobuiltin] = ACTIONS(825),
    [anon_sym_noduplicate] = ACTIONS(825),
    [anon_sym_nofree] = ACTIONS(825),
    [anon_sym_noimplicitfloat] = ACTIONS(825),
    [anon_sym_noinline] = ACTIONS(825),
    [anon_sym_nomerge] = ACTIONS(825),
    [anon_sym_nonlazybind] = ACTIONS(825),
    [anon_sym_noprofile] = ACTIONS(825),
    [anon_sym_noredzone] = ACTIONS(825),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(825),
    [anon_sym_noreturn] = ACTIONS(825),
    [anon_sym_norecurse] = ACTIONS(825),
    [anon_sym_willreturn] = ACTIONS(825),
    [anon_sym_nosync] = ACTIONS(825),
    [anon_sym_nounwind] = ACTIONS(825),
    [anon_sym_nosanitize_coverage] = ACTIONS(825),
    [anon_sym_null_pointer_is_valid] = ACTIONS(825),
    [anon_sym_optforfuzzing] = ACTIONS(825),
    [anon_sym_optnone] = ACTIONS(825),
    [anon_sym_optsize] = ACTIONS(825),
    [anon_sym_readnone] = ACTIONS(825),
    [anon_sym_readonly] = ACTIONS(825),
    [anon_sym_writeonly] = ACTIONS(825),
    [anon_sym_argmemonly] = ACTIONS(825),
    [anon_sym_returns_twice] = ACTIONS(825),
    [anon_sym_safestack] = ACTIONS(825),
    [anon_sym_sanitize_address] = ACTIONS(825),
    [anon_sym_sanitize_memory] = ACTIONS(825),
    [anon_sym_sanitize_thread] = ACTIONS(825),
    [anon_sym_sanitize_hwaddress] = ACTIONS(825),
    [anon_sym_sanitize_memtag] = ACTIONS(825),
    [anon_sym_speculative_load_hardening] = ACTIONS(825),
    [anon_sym_speculatable] = ACTIONS(825),
    [anon_sym_ssp] = ACTIONS(827),
    [anon_sym_sspstrong] = ACTIONS(825),
    [anon_sym_sspreq] = ACTIONS(825),
    [anon_sym_strictfp] = ACTIONS(825),
    [anon_sym_uwtable] = ACTIONS(825),
    [anon_sym_nocf_check] = ACTIONS(825),
    [anon_sym_shadowcallstack] = ACTIONS(825),
    [anon_sym_mustprogress] = ACTIONS(825),
    [anon_sym_vscale_range] = ACTIONS(825),
    [anon_sym_preallocated] = ACTIONS(825),
    [anon_sym_zeroext] = ACTIONS(825),
    [anon_sym_signext] = ACTIONS(825),
    [anon_sym_inreg] = ACTIONS(825),
    [anon_sym_byval] = ACTIONS(825),
    [anon_sym_byref] = ACTIONS(825),
    [anon_sym_inalloca] = ACTIONS(825),
    [anon_sym_sret] = ACTIONS(825),
    [anon_sym_elementtype] = ACTIONS(825),
    [anon_sym_noalias] = ACTIONS(825),
    [anon_sym_nocapture] = ACTIONS(825),
    [anon_sym_nest] = ACTIONS(825),
    [anon_sym_returned] = ACTIONS(825),
    [anon_sym_nonnull] = ACTIONS(825),
    [anon_sym_dereferenceable] = ACTIONS(827),
    [anon_sym_dereferenceable_or_null] = ACTIONS(825),
    [anon_sym_swiftself] = ACTIONS(825),
    [anon_sym_swiftasync] = ACTIONS(825),
    [anon_sym_swifterror] = ACTIONS(825),
    [anon_sym_immarg] = ACTIONS(825),
    [anon_sym_noundef] = ACTIONS(825),
    [anon_sym_to] = ACTIONS(825),
    [anon_sym_uselistorder] = ACTIONS(827),
    [anon_sym_uselistorder_bb] = ACTIONS(825),
    [anon_sym_module] = ACTIONS(825),
    [anon_sym_attributes] = ACTIONS(825),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(821),
    [sym_comdat_ref] = ACTIONS(821),
    [sym_global_var] = ACTIONS(821),
    [sym_local_var] = ACTIONS(821),
    [aux_sym_metadata_ref_token1] = ACTIONS(821),
    [sym_summary_ref] = ACTIONS(821),
    [sym_string] = ACTIONS(821),
    [anon_sym_target] = ACTIONS(821),
    [anon_sym_source_filename] = ACTIONS(821),
    [anon_sym_declare] = ACTIONS(821),
    [anon_sym_define] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(821),
    [anon_sym_align] = ACTIONS(823),
    [anon_sym_section] = ACTIONS(821),
    [anon_sym_partition] = ACTIONS(821),
    [anon_sym_comdat] = ACTIONS(821),
    [anon_sym_gc] = ACTIONS(821),
    [anon_sym_prefix] = ACTIONS(821),
    [anon_sym_prologue] = ACTIONS(821),
    [anon_sym_personality] = ACTIONS(821),
    [anon_sym_alignstack] = ACTIONS(821),
    [anon_sym_allocsize] = ACTIONS(821),
    [anon_sym_alwaysinline] = ACTIONS(821),
    [anon_sym_builtin] = ACTIONS(821),
    [anon_sym_cold] = ACTIONS(821),
    [anon_sym_convergent] = ACTIONS(821),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(821),
    [anon_sym_hot] = ACTIONS(821),
    [anon_sym_inaccessiblememonly] = ACTIONS(821),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(821),
    [anon_sym_inlinehint] = ACTIONS(821),
    [anon_sym_jumptable] = ACTIONS(821),
    [anon_sym_minsize] = ACTIONS(821),
    [anon_sym_naked] = ACTIONS(821),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(821),
    [anon_sym_nobuiltin] = ACTIONS(821),
    [anon_sym_noduplicate] = ACTIONS(821),
    [anon_sym_nofree] = ACTIONS(821),
    [anon_sym_noimplicitfloat] = ACTIONS(821),
    [anon_sym_noinline] = ACTIONS(821),
    [anon_sym_nomerge] = ACTIONS(821),
    [anon_sym_nonlazybind] = ACTIONS(821),
    [anon_sym_noprofile] = ACTIONS(821),
    [anon_sym_noredzone] = ACTIONS(821),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(821),
    [anon_sym_noreturn] = ACTIONS(821),
    [anon_sym_norecurse] = ACTIONS(821),
    [anon_sym_willreturn] = ACTIONS(821),
    [anon_sym_nosync] = ACTIONS(821),
    [anon_sym_nounwind] = ACTIONS(821),
    [anon_sym_nosanitize_coverage] = ACTIONS(821),
    [anon_sym_null_pointer_is_valid] = ACTIONS(821),
    [anon_sym_optforfuzzing] = ACTIONS(821),
    [anon_sym_optnone] = ACTIONS(821),
    [anon_sym_optsize] = ACTIONS(821),
    [anon_sym_readnone] = ACTIONS(821),
    [anon_sym_readonly] = ACTIONS(821),
    [anon_sym_writeonly] = ACTIONS(821),
    [anon_sym_argmemonly] = ACTIONS(821),
    [anon_sym_returns_twice] = ACTIONS(821),
    [anon_sym_safestack] = ACTIONS(821),
    [anon_sym_sanitize_address] = ACTIONS(821),
    [anon_sym_sanitize_memory] = ACTIONS(821),
    [anon_sym_sanitize_thread] = ACTIONS(821),
    [anon_sym_sanitize_hwaddress] = ACTIONS(821),
    [anon_sym_sanitize_memtag] = ACTIONS(821),
    [anon_sym_speculative_load_hardening] = ACTIONS(821),
    [anon_sym_speculatable] = ACTIONS(821),
    [anon_sym_ssp] = ACTIONS(823),
    [anon_sym_sspstrong] = ACTIONS(821),
    [anon_sym_sspreq] = ACTIONS(821),
    [anon_sym_strictfp] = ACTIONS(821),
    [anon_sym_uwtable] = ACTIONS(821),
    [anon_sym_nocf_check] = ACTIONS(821),
    [anon_sym_shadowcallstack] = ACTIONS(821),
    [anon_sym_mustprogress] = ACTIONS(821),
    [anon_sym_vscale_range] = ACTIONS(821),
    [anon_sym_preallocated] = ACTIONS(821),
    [anon_sym_zeroext] = ACTIONS(821),
    [anon_sym_signext] = ACTIONS(821),
    [anon_sym_inreg] = ACTIONS(821),
    [anon_sym_byval] = ACTIONS(821),
    [anon_sym_byref] = ACTIONS(821),
    [anon_sym_inalloca] = ACTIONS(821),
    [anon_sym_sret] = ACTIONS(821),
    [anon_sym_elementtype] = ACTIONS(821),
    [anon_sym_noalias] = ACTIONS(821),
    [anon_sym_nocapture] = ACTIONS(821),
    [anon_sym_nest] = ACTIONS(821),
    [anon_sym_returned] = ACTIONS(821),
    [anon_sym_nonnull] = ACTIONS(821),
    [anon_sym_dereferenceable] = ACTIONS(823),
    [anon_sym_dereferenceable_or_null] = ACTIONS(821),
    [anon_sym_swiftself] = ACTIONS(821),
    [anon_sym_swiftasync] = ACTIONS(821),
    [anon_sym_swifterror] = ACTIONS(821),
    [anon_sym_immarg] = ACTIONS(821),
    [anon_sym_noundef] = ACTIONS(821),
    [anon_sym_to] = ACTIONS(821),
    [anon_sym_uselistorder] = ACTIONS(823),
    [anon_sym_uselistorder_bb] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_attributes] = ACTIONS(821),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(795),
    [sym_comdat_ref] = ACTIONS(795),
    [sym_global_var] = ACTIONS(795),
    [sym_local_var] = ACTIONS(795),
    [aux_sym_metadata_ref_token1] = ACTIONS(795),
    [sym_summary_ref] = ACTIONS(795),
    [sym_string] = ACTIONS(795),
    [anon_sym_target] = ACTIONS(795),
    [anon_sym_source_filename] = ACTIONS(795),
    [anon_sym_declare] = ACTIONS(795),
    [anon_sym_define] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_align] = ACTIONS(797),
    [anon_sym_section] = ACTIONS(795),
    [anon_sym_partition] = ACTIONS(795),
    [anon_sym_comdat] = ACTIONS(795),
    [anon_sym_gc] = ACTIONS(795),
    [anon_sym_prefix] = ACTIONS(795),
    [anon_sym_prologue] = ACTIONS(795),
    [anon_sym_personality] = ACTIONS(795),
    [anon_sym_alignstack] = ACTIONS(795),
    [anon_sym_allocsize] = ACTIONS(795),
    [anon_sym_alwaysinline] = ACTIONS(795),
    [anon_sym_builtin] = ACTIONS(795),
    [anon_sym_cold] = ACTIONS(795),
    [anon_sym_convergent] = ACTIONS(795),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(795),
    [anon_sym_hot] = ACTIONS(795),
    [anon_sym_inaccessiblememonly] = ACTIONS(795),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(795),
    [anon_sym_inlinehint] = ACTIONS(795),
    [anon_sym_jumptable] = ACTIONS(795),
    [anon_sym_minsize] = ACTIONS(795),
    [anon_sym_naked] = ACTIONS(795),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(795),
    [anon_sym_nobuiltin] = ACTIONS(795),
    [anon_sym_noduplicate] = ACTIONS(795),
    [anon_sym_nofree] = ACTIONS(795),
    [anon_sym_noimplicitfloat] = ACTIONS(795),
    [anon_sym_noinline] = ACTIONS(795),
    [anon_sym_nomerge] = ACTIONS(795),
    [anon_sym_nonlazybind] = ACTIONS(795),
    [anon_sym_noprofile] = ACTIONS(795),
    [anon_sym_noredzone] = ACTIONS(795),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(795),
    [anon_sym_noreturn] = ACTIONS(795),
    [anon_sym_norecurse] = ACTIONS(795),
    [anon_sym_willreturn] = ACTIONS(795),
    [anon_sym_nosync] = ACTIONS(795),
    [anon_sym_nounwind] = ACTIONS(795),
    [anon_sym_nosanitize_coverage] = ACTIONS(795),
    [anon_sym_null_pointer_is_valid] = ACTIONS(795),
    [anon_sym_optforfuzzing] = ACTIONS(795),
    [anon_sym_optnone] = ACTIONS(795),
    [anon_sym_optsize] = ACTIONS(795),
    [anon_sym_readnone] = ACTIONS(795),
    [anon_sym_readonly] = ACTIONS(795),
    [anon_sym_writeonly] = ACTIONS(795),
    [anon_sym_argmemonly] = ACTIONS(795),
    [anon_sym_returns_twice] = ACTIONS(795),
    [anon_sym_safestack] = ACTIONS(795),
    [anon_sym_sanitize_address] = ACTIONS(795),
    [anon_sym_sanitize_memory] = ACTIONS(795),
    [anon_sym_sanitize_thread] = ACTIONS(795),
    [anon_sym_sanitize_hwaddress] = ACTIONS(795),
    [anon_sym_sanitize_memtag] = ACTIONS(795),
    [anon_sym_speculative_load_hardening] = ACTIONS(795),
    [anon_sym_speculatable] = ACTIONS(795),
    [anon_sym_ssp] = ACTIONS(797),
    [anon_sym_sspstrong] = ACTIONS(795),
    [anon_sym_sspreq] = ACTIONS(795),
    [anon_sym_strictfp] = ACTIONS(795),
    [anon_sym_uwtable] = ACTIONS(795),
    [anon_sym_nocf_check] = ACTIONS(795),
    [anon_sym_shadowcallstack] = ACTIONS(795),
    [anon_sym_mustprogress] = ACTIONS(795),
    [anon_sym_vscale_range] = ACTIONS(795),
    [anon_sym_preallocated] = ACTIONS(795),
    [anon_sym_zeroext] = ACTIONS(795),
    [anon_sym_signext] = ACTIONS(795),
    [anon_sym_inreg] = ACTIONS(795),
    [anon_sym_byval] = ACTIONS(795),
    [anon_sym_byref] = ACTIONS(795),
    [anon_sym_inalloca] = ACTIONS(795),
    [anon_sym_sret] = ACTIONS(795),
    [anon_sym_elementtype] = ACTIONS(795),
    [anon_sym_noalias] = ACTIONS(795),
    [anon_sym_nocapture] = ACTIONS(795),
    [anon_sym_nest] = ACTIONS(795),
    [anon_sym_returned] = ACTIONS(795),
    [anon_sym_nonnull] = ACTIONS(795),
    [anon_sym_dereferenceable] = ACTIONS(797),
    [anon_sym_dereferenceable_or_null] = ACTIONS(795),
    [anon_sym_swiftself] = ACTIONS(795),
    [anon_sym_swiftasync] = ACTIONS(795),
    [anon_sym_swifterror] = ACTIONS(795),
    [anon_sym_immarg] = ACTIONS(795),
    [anon_sym_noundef] = ACTIONS(795),
    [anon_sym_to] = ACTIONS(795),
    [anon_sym_uselistorder] = ACTIONS(797),
    [anon_sym_uselistorder_bb] = ACTIONS(795),
    [anon_sym_module] = ACTIONS(795),
    [anon_sym_attributes] = ACTIONS(795),
  },
  [411] = {
    [sym_attribute] = STATE(411),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_global_global_repeat1] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1468),
    [sym_comdat_ref] = ACTIONS(1466),
    [sym_global_var] = ACTIONS(1466),
    [sym_local_var] = ACTIONS(1466),
    [aux_sym_metadata_ref_token1] = ACTIONS(1466),
    [sym_summary_ref] = ACTIONS(1466),
    [sym_string] = ACTIONS(1468),
    [anon_sym_target] = ACTIONS(1466),
    [anon_sym_source_filename] = ACTIONS(1466),
    [anon_sym_declare] = ACTIONS(1466),
    [anon_sym_define] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_align] = ACTIONS(1474),
    [anon_sym_section] = ACTIONS(1477),
    [anon_sym_partition] = ACTIONS(1477),
    [anon_sym_comdat] = ACTIONS(1480),
    [anon_sym_gc] = ACTIONS(1477),
    [anon_sym_prefix] = ACTIONS(1483),
    [anon_sym_prologue] = ACTIONS(1483),
    [anon_sym_personality] = ACTIONS(1483),
    [anon_sym_alignstack] = ACTIONS(1486),
    [anon_sym_allocsize] = ACTIONS(1486),
    [anon_sym_alwaysinline] = ACTIONS(1486),
    [anon_sym_builtin] = ACTIONS(1486),
    [anon_sym_cold] = ACTIONS(1486),
    [anon_sym_convergent] = ACTIONS(1486),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1486),
    [anon_sym_hot] = ACTIONS(1486),
    [anon_sym_inaccessiblememonly] = ACTIONS(1486),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1486),
    [anon_sym_inlinehint] = ACTIONS(1486),
    [anon_sym_jumptable] = ACTIONS(1486),
    [anon_sym_minsize] = ACTIONS(1486),
    [anon_sym_naked] = ACTIONS(1486),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1486),
    [anon_sym_nobuiltin] = ACTIONS(1486),
    [anon_sym_noduplicate] = ACTIONS(1486),
    [anon_sym_nofree] = ACTIONS(1486),
    [anon_sym_noimplicitfloat] = ACTIONS(1486),
    [anon_sym_noinline] = ACTIONS(1486),
    [anon_sym_nomerge] = ACTIONS(1486),
    [anon_sym_nonlazybind] = ACTIONS(1486),
    [anon_sym_noprofile] = ACTIONS(1486),
    [anon_sym_noredzone] = ACTIONS(1486),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [anon_sym_norecurse] = ACTIONS(1486),
    [anon_sym_willreturn] = ACTIONS(1486),
    [anon_sym_nosync] = ACTIONS(1486),
    [anon_sym_nounwind] = ACTIONS(1486),
    [anon_sym_nosanitize_coverage] = ACTIONS(1486),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1486),
    [anon_sym_optforfuzzing] = ACTIONS(1486),
    [anon_sym_optnone] = ACTIONS(1486),
    [anon_sym_optsize] = ACTIONS(1486),
    [anon_sym_readnone] = ACTIONS(1486),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_writeonly] = ACTIONS(1486),
    [anon_sym_argmemonly] = ACTIONS(1486),
    [anon_sym_returns_twice] = ACTIONS(1486),
    [anon_sym_safestack] = ACTIONS(1486),
    [anon_sym_sanitize_address] = ACTIONS(1486),
    [anon_sym_sanitize_memory] = ACTIONS(1486),
    [anon_sym_sanitize_thread] = ACTIONS(1486),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1486),
    [anon_sym_sanitize_memtag] = ACTIONS(1486),
    [anon_sym_speculative_load_hardening] = ACTIONS(1486),
    [anon_sym_speculatable] = ACTIONS(1486),
    [anon_sym_ssp] = ACTIONS(1489),
    [anon_sym_sspstrong] = ACTIONS(1486),
    [anon_sym_sspreq] = ACTIONS(1486),
    [anon_sym_strictfp] = ACTIONS(1486),
    [anon_sym_uwtable] = ACTIONS(1486),
    [anon_sym_nocf_check] = ACTIONS(1486),
    [anon_sym_shadowcallstack] = ACTIONS(1486),
    [anon_sym_mustprogress] = ACTIONS(1486),
    [anon_sym_vscale_range] = ACTIONS(1486),
    [anon_sym_preallocated] = ACTIONS(1486),
    [anon_sym_zeroext] = ACTIONS(1486),
    [anon_sym_signext] = ACTIONS(1486),
    [anon_sym_inreg] = ACTIONS(1486),
    [anon_sym_byval] = ACTIONS(1486),
    [anon_sym_byref] = ACTIONS(1486),
    [anon_sym_inalloca] = ACTIONS(1486),
    [anon_sym_sret] = ACTIONS(1486),
    [anon_sym_elementtype] = ACTIONS(1486),
    [anon_sym_noalias] = ACTIONS(1486),
    [anon_sym_nocapture] = ACTIONS(1486),
    [anon_sym_nest] = ACTIONS(1486),
    [anon_sym_returned] = ACTIONS(1486),
    [anon_sym_nonnull] = ACTIONS(1486),
    [anon_sym_dereferenceable] = ACTIONS(1489),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1486),
    [anon_sym_swiftself] = ACTIONS(1486),
    [anon_sym_swiftasync] = ACTIONS(1486),
    [anon_sym_swifterror] = ACTIONS(1486),
    [anon_sym_immarg] = ACTIONS(1486),
    [anon_sym_noundef] = ACTIONS(1486),
    [anon_sym_uselistorder] = ACTIONS(1492),
    [anon_sym_uselistorder_bb] = ACTIONS(1466),
    [anon_sym_module] = ACTIONS(1466),
    [anon_sym_attributes] = ACTIONS(1466),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(809),
    [sym_comdat_ref] = ACTIONS(809),
    [sym_global_var] = ACTIONS(809),
    [sym_local_var] = ACTIONS(809),
    [aux_sym_metadata_ref_token1] = ACTIONS(809),
    [sym_summary_ref] = ACTIONS(809),
    [sym_string] = ACTIONS(809),
    [anon_sym_target] = ACTIONS(809),
    [anon_sym_source_filename] = ACTIONS(809),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_define] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(809),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(809),
    [anon_sym_COMMA] = ACTIONS(809),
    [anon_sym_align] = ACTIONS(811),
    [anon_sym_section] = ACTIONS(809),
    [anon_sym_partition] = ACTIONS(809),
    [anon_sym_comdat] = ACTIONS(809),
    [anon_sym_gc] = ACTIONS(809),
    [anon_sym_prefix] = ACTIONS(809),
    [anon_sym_prologue] = ACTIONS(809),
    [anon_sym_personality] = ACTIONS(809),
    [anon_sym_alignstack] = ACTIONS(809),
    [anon_sym_allocsize] = ACTIONS(809),
    [anon_sym_alwaysinline] = ACTIONS(809),
    [anon_sym_builtin] = ACTIONS(809),
    [anon_sym_cold] = ACTIONS(809),
    [anon_sym_convergent] = ACTIONS(809),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(809),
    [anon_sym_hot] = ACTIONS(809),
    [anon_sym_inaccessiblememonly] = ACTIONS(809),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(809),
    [anon_sym_inlinehint] = ACTIONS(809),
    [anon_sym_jumptable] = ACTIONS(809),
    [anon_sym_minsize] = ACTIONS(809),
    [anon_sym_naked] = ACTIONS(809),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(809),
    [anon_sym_nobuiltin] = ACTIONS(809),
    [anon_sym_noduplicate] = ACTIONS(809),
    [anon_sym_nofree] = ACTIONS(809),
    [anon_sym_noimplicitfloat] = ACTIONS(809),
    [anon_sym_noinline] = ACTIONS(809),
    [anon_sym_nomerge] = ACTIONS(809),
    [anon_sym_nonlazybind] = ACTIONS(809),
    [anon_sym_noprofile] = ACTIONS(809),
    [anon_sym_noredzone] = ACTIONS(809),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(809),
    [anon_sym_noreturn] = ACTIONS(809),
    [anon_sym_norecurse] = ACTIONS(809),
    [anon_sym_willreturn] = ACTIONS(809),
    [anon_sym_nosync] = ACTIONS(809),
    [anon_sym_nounwind] = ACTIONS(809),
    [anon_sym_nosanitize_coverage] = ACTIONS(809),
    [anon_sym_null_pointer_is_valid] = ACTIONS(809),
    [anon_sym_optforfuzzing] = ACTIONS(809),
    [anon_sym_optnone] = ACTIONS(809),
    [anon_sym_optsize] = ACTIONS(809),
    [anon_sym_readnone] = ACTIONS(809),
    [anon_sym_readonly] = ACTIONS(809),
    [anon_sym_writeonly] = ACTIONS(809),
    [anon_sym_argmemonly] = ACTIONS(809),
    [anon_sym_returns_twice] = ACTIONS(809),
    [anon_sym_safestack] = ACTIONS(809),
    [anon_sym_sanitize_address] = ACTIONS(809),
    [anon_sym_sanitize_memory] = ACTIONS(809),
    [anon_sym_sanitize_thread] = ACTIONS(809),
    [anon_sym_sanitize_hwaddress] = ACTIONS(809),
    [anon_sym_sanitize_memtag] = ACTIONS(809),
    [anon_sym_speculative_load_hardening] = ACTIONS(809),
    [anon_sym_speculatable] = ACTIONS(809),
    [anon_sym_ssp] = ACTIONS(811),
    [anon_sym_sspstrong] = ACTIONS(809),
    [anon_sym_sspreq] = ACTIONS(809),
    [anon_sym_strictfp] = ACTIONS(809),
    [anon_sym_uwtable] = ACTIONS(809),
    [anon_sym_nocf_check] = ACTIONS(809),
    [anon_sym_shadowcallstack] = ACTIONS(809),
    [anon_sym_mustprogress] = ACTIONS(809),
    [anon_sym_vscale_range] = ACTIONS(809),
    [anon_sym_preallocated] = ACTIONS(809),
    [anon_sym_zeroext] = ACTIONS(809),
    [anon_sym_signext] = ACTIONS(809),
    [anon_sym_inreg] = ACTIONS(809),
    [anon_sym_byval] = ACTIONS(809),
    [anon_sym_byref] = ACTIONS(809),
    [anon_sym_inalloca] = ACTIONS(809),
    [anon_sym_sret] = ACTIONS(809),
    [anon_sym_elementtype] = ACTIONS(809),
    [anon_sym_noalias] = ACTIONS(809),
    [anon_sym_nocapture] = ACTIONS(809),
    [anon_sym_nest] = ACTIONS(809),
    [anon_sym_returned] = ACTIONS(809),
    [anon_sym_nonnull] = ACTIONS(809),
    [anon_sym_dereferenceable] = ACTIONS(811),
    [anon_sym_dereferenceable_or_null] = ACTIONS(809),
    [anon_sym_swiftself] = ACTIONS(809),
    [anon_sym_swiftasync] = ACTIONS(809),
    [anon_sym_swifterror] = ACTIONS(809),
    [anon_sym_immarg] = ACTIONS(809),
    [anon_sym_noundef] = ACTIONS(809),
    [anon_sym_to] = ACTIONS(809),
    [anon_sym_uselistorder] = ACTIONS(811),
    [anon_sym_uselistorder_bb] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_attributes] = ACTIONS(809),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(813),
    [sym_comdat_ref] = ACTIONS(813),
    [sym_global_var] = ACTIONS(813),
    [sym_local_var] = ACTIONS(813),
    [aux_sym_metadata_ref_token1] = ACTIONS(813),
    [sym_summary_ref] = ACTIONS(813),
    [sym_string] = ACTIONS(813),
    [anon_sym_target] = ACTIONS(813),
    [anon_sym_source_filename] = ACTIONS(813),
    [anon_sym_declare] = ACTIONS(813),
    [anon_sym_define] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_align] = ACTIONS(815),
    [anon_sym_section] = ACTIONS(813),
    [anon_sym_partition] = ACTIONS(813),
    [anon_sym_comdat] = ACTIONS(813),
    [anon_sym_gc] = ACTIONS(813),
    [anon_sym_prefix] = ACTIONS(813),
    [anon_sym_prologue] = ACTIONS(813),
    [anon_sym_personality] = ACTIONS(813),
    [anon_sym_alignstack] = ACTIONS(813),
    [anon_sym_allocsize] = ACTIONS(813),
    [anon_sym_alwaysinline] = ACTIONS(813),
    [anon_sym_builtin] = ACTIONS(813),
    [anon_sym_cold] = ACTIONS(813),
    [anon_sym_convergent] = ACTIONS(813),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(813),
    [anon_sym_hot] = ACTIONS(813),
    [anon_sym_inaccessiblememonly] = ACTIONS(813),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(813),
    [anon_sym_inlinehint] = ACTIONS(813),
    [anon_sym_jumptable] = ACTIONS(813),
    [anon_sym_minsize] = ACTIONS(813),
    [anon_sym_naked] = ACTIONS(813),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(813),
    [anon_sym_nobuiltin] = ACTIONS(813),
    [anon_sym_noduplicate] = ACTIONS(813),
    [anon_sym_nofree] = ACTIONS(813),
    [anon_sym_noimplicitfloat] = ACTIONS(813),
    [anon_sym_noinline] = ACTIONS(813),
    [anon_sym_nomerge] = ACTIONS(813),
    [anon_sym_nonlazybind] = ACTIONS(813),
    [anon_sym_noprofile] = ACTIONS(813),
    [anon_sym_noredzone] = ACTIONS(813),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(813),
    [anon_sym_noreturn] = ACTIONS(813),
    [anon_sym_norecurse] = ACTIONS(813),
    [anon_sym_willreturn] = ACTIONS(813),
    [anon_sym_nosync] = ACTIONS(813),
    [anon_sym_nounwind] = ACTIONS(813),
    [anon_sym_nosanitize_coverage] = ACTIONS(813),
    [anon_sym_null_pointer_is_valid] = ACTIONS(813),
    [anon_sym_optforfuzzing] = ACTIONS(813),
    [anon_sym_optnone] = ACTIONS(813),
    [anon_sym_optsize] = ACTIONS(813),
    [anon_sym_readnone] = ACTIONS(813),
    [anon_sym_readonly] = ACTIONS(813),
    [anon_sym_writeonly] = ACTIONS(813),
    [anon_sym_argmemonly] = ACTIONS(813),
    [anon_sym_returns_twice] = ACTIONS(813),
    [anon_sym_safestack] = ACTIONS(813),
    [anon_sym_sanitize_address] = ACTIONS(813),
    [anon_sym_sanitize_memory] = ACTIONS(813),
    [anon_sym_sanitize_thread] = ACTIONS(813),
    [anon_sym_sanitize_hwaddress] = ACTIONS(813),
    [anon_sym_sanitize_memtag] = ACTIONS(813),
    [anon_sym_speculative_load_hardening] = ACTIONS(813),
    [anon_sym_speculatable] = ACTIONS(813),
    [anon_sym_ssp] = ACTIONS(815),
    [anon_sym_sspstrong] = ACTIONS(813),
    [anon_sym_sspreq] = ACTIONS(813),
    [anon_sym_strictfp] = ACTIONS(813),
    [anon_sym_uwtable] = ACTIONS(813),
    [anon_sym_nocf_check] = ACTIONS(813),
    [anon_sym_shadowcallstack] = ACTIONS(813),
    [anon_sym_mustprogress] = ACTIONS(813),
    [anon_sym_vscale_range] = ACTIONS(813),
    [anon_sym_preallocated] = ACTIONS(813),
    [anon_sym_zeroext] = ACTIONS(813),
    [anon_sym_signext] = ACTIONS(813),
    [anon_sym_inreg] = ACTIONS(813),
    [anon_sym_byval] = ACTIONS(813),
    [anon_sym_byref] = ACTIONS(813),
    [anon_sym_inalloca] = ACTIONS(813),
    [anon_sym_sret] = ACTIONS(813),
    [anon_sym_elementtype] = ACTIONS(813),
    [anon_sym_noalias] = ACTIONS(813),
    [anon_sym_nocapture] = ACTIONS(813),
    [anon_sym_nest] = ACTIONS(813),
    [anon_sym_returned] = ACTIONS(813),
    [anon_sym_nonnull] = ACTIONS(813),
    [anon_sym_dereferenceable] = ACTIONS(815),
    [anon_sym_dereferenceable_or_null] = ACTIONS(813),
    [anon_sym_swiftself] = ACTIONS(813),
    [anon_sym_swiftasync] = ACTIONS(813),
    [anon_sym_swifterror] = ACTIONS(813),
    [anon_sym_immarg] = ACTIONS(813),
    [anon_sym_noundef] = ACTIONS(813),
    [anon_sym_to] = ACTIONS(813),
    [anon_sym_uselistorder] = ACTIONS(815),
    [anon_sym_uselistorder_bb] = ACTIONS(813),
    [anon_sym_module] = ACTIONS(813),
    [anon_sym_attributes] = ACTIONS(813),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(817),
    [sym_comdat_ref] = ACTIONS(817),
    [sym_global_var] = ACTIONS(817),
    [sym_local_var] = ACTIONS(817),
    [aux_sym_metadata_ref_token1] = ACTIONS(817),
    [sym_summary_ref] = ACTIONS(817),
    [sym_string] = ACTIONS(817),
    [anon_sym_target] = ACTIONS(817),
    [anon_sym_source_filename] = ACTIONS(817),
    [anon_sym_declare] = ACTIONS(817),
    [anon_sym_define] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_align] = ACTIONS(819),
    [anon_sym_section] = ACTIONS(817),
    [anon_sym_partition] = ACTIONS(817),
    [anon_sym_comdat] = ACTIONS(817),
    [anon_sym_gc] = ACTIONS(817),
    [anon_sym_prefix] = ACTIONS(817),
    [anon_sym_prologue] = ACTIONS(817),
    [anon_sym_personality] = ACTIONS(817),
    [anon_sym_alignstack] = ACTIONS(817),
    [anon_sym_allocsize] = ACTIONS(817),
    [anon_sym_alwaysinline] = ACTIONS(817),
    [anon_sym_builtin] = ACTIONS(817),
    [anon_sym_cold] = ACTIONS(817),
    [anon_sym_convergent] = ACTIONS(817),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(817),
    [anon_sym_hot] = ACTIONS(817),
    [anon_sym_inaccessiblememonly] = ACTIONS(817),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(817),
    [anon_sym_inlinehint] = ACTIONS(817),
    [anon_sym_jumptable] = ACTIONS(817),
    [anon_sym_minsize] = ACTIONS(817),
    [anon_sym_naked] = ACTIONS(817),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(817),
    [anon_sym_nobuiltin] = ACTIONS(817),
    [anon_sym_noduplicate] = ACTIONS(817),
    [anon_sym_nofree] = ACTIONS(817),
    [anon_sym_noimplicitfloat] = ACTIONS(817),
    [anon_sym_noinline] = ACTIONS(817),
    [anon_sym_nomerge] = ACTIONS(817),
    [anon_sym_nonlazybind] = ACTIONS(817),
    [anon_sym_noprofile] = ACTIONS(817),
    [anon_sym_noredzone] = ACTIONS(817),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(817),
    [anon_sym_noreturn] = ACTIONS(817),
    [anon_sym_norecurse] = ACTIONS(817),
    [anon_sym_willreturn] = ACTIONS(817),
    [anon_sym_nosync] = ACTIONS(817),
    [anon_sym_nounwind] = ACTIONS(817),
    [anon_sym_nosanitize_coverage] = ACTIONS(817),
    [anon_sym_null_pointer_is_valid] = ACTIONS(817),
    [anon_sym_optforfuzzing] = ACTIONS(817),
    [anon_sym_optnone] = ACTIONS(817),
    [anon_sym_optsize] = ACTIONS(817),
    [anon_sym_readnone] = ACTIONS(817),
    [anon_sym_readonly] = ACTIONS(817),
    [anon_sym_writeonly] = ACTIONS(817),
    [anon_sym_argmemonly] = ACTIONS(817),
    [anon_sym_returns_twice] = ACTIONS(817),
    [anon_sym_safestack] = ACTIONS(817),
    [anon_sym_sanitize_address] = ACTIONS(817),
    [anon_sym_sanitize_memory] = ACTIONS(817),
    [anon_sym_sanitize_thread] = ACTIONS(817),
    [anon_sym_sanitize_hwaddress] = ACTIONS(817),
    [anon_sym_sanitize_memtag] = ACTIONS(817),
    [anon_sym_speculative_load_hardening] = ACTIONS(817),
    [anon_sym_speculatable] = ACTIONS(817),
    [anon_sym_ssp] = ACTIONS(819),
    [anon_sym_sspstrong] = ACTIONS(817),
    [anon_sym_sspreq] = ACTIONS(817),
    [anon_sym_strictfp] = ACTIONS(817),
    [anon_sym_uwtable] = ACTIONS(817),
    [anon_sym_nocf_check] = ACTIONS(817),
    [anon_sym_shadowcallstack] = ACTIONS(817),
    [anon_sym_mustprogress] = ACTIONS(817),
    [anon_sym_vscale_range] = ACTIONS(817),
    [anon_sym_preallocated] = ACTIONS(817),
    [anon_sym_zeroext] = ACTIONS(817),
    [anon_sym_signext] = ACTIONS(817),
    [anon_sym_inreg] = ACTIONS(817),
    [anon_sym_byval] = ACTIONS(817),
    [anon_sym_byref] = ACTIONS(817),
    [anon_sym_inalloca] = ACTIONS(817),
    [anon_sym_sret] = ACTIONS(817),
    [anon_sym_elementtype] = ACTIONS(817),
    [anon_sym_noalias] = ACTIONS(817),
    [anon_sym_nocapture] = ACTIONS(817),
    [anon_sym_nest] = ACTIONS(817),
    [anon_sym_returned] = ACTIONS(817),
    [anon_sym_nonnull] = ACTIONS(817),
    [anon_sym_dereferenceable] = ACTIONS(819),
    [anon_sym_dereferenceable_or_null] = ACTIONS(817),
    [anon_sym_swiftself] = ACTIONS(817),
    [anon_sym_swiftasync] = ACTIONS(817),
    [anon_sym_swifterror] = ACTIONS(817),
    [anon_sym_immarg] = ACTIONS(817),
    [anon_sym_noundef] = ACTIONS(817),
    [anon_sym_to] = ACTIONS(817),
    [anon_sym_uselistorder] = ACTIONS(819),
    [anon_sym_uselistorder_bb] = ACTIONS(817),
    [anon_sym_module] = ACTIONS(817),
    [anon_sym_attributes] = ACTIONS(817),
  },
  [415] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1444),
    [sym_global_var] = ACTIONS(1444),
    [sym_local_var] = ACTIONS(1444),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_summary_ref] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1444),
    [anon_sym_source_filename] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_define] = ACTIONS(1444),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1446),
    [anon_sym_uselistorder_bb] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_attributes] = ACTIONS(1444),
  },
  [416] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1494),
    [sym_global_var] = ACTIONS(1494),
    [sym_local_var] = ACTIONS(1494),
    [aux_sym_metadata_ref_token1] = ACTIONS(1494),
    [sym_summary_ref] = ACTIONS(1494),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1494),
    [anon_sym_source_filename] = ACTIONS(1494),
    [anon_sym_declare] = ACTIONS(1494),
    [anon_sym_define] = ACTIONS(1494),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1496),
    [anon_sym_uselistorder_bb] = ACTIONS(1494),
    [anon_sym_module] = ACTIONS(1494),
    [anon_sym_attributes] = ACTIONS(1494),
  },
  [417] = {
    [sym_attribute] = STATE(426),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1450),
    [sym_global_var] = ACTIONS(1450),
    [sym_local_var] = ACTIONS(1450),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_summary_ref] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1450),
    [anon_sym_source_filename] = ACTIONS(1450),
    [anon_sym_declare] = ACTIONS(1450),
    [anon_sym_define] = ACTIONS(1450),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1452),
    [anon_sym_uselistorder_bb] = ACTIONS(1450),
    [anon_sym_module] = ACTIONS(1450),
    [anon_sym_attributes] = ACTIONS(1450),
  },
  [418] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1498),
    [sym_global_var] = ACTIONS(1498),
    [sym_local_var] = ACTIONS(1498),
    [aux_sym_metadata_ref_token1] = ACTIONS(1498),
    [sym_summary_ref] = ACTIONS(1498),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1498),
    [anon_sym_source_filename] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_define] = ACTIONS(1498),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1500),
    [anon_sym_uselistorder_bb] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_attributes] = ACTIONS(1498),
  },
  [419] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1450),
    [sym_global_var] = ACTIONS(1450),
    [sym_local_var] = ACTIONS(1450),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_summary_ref] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1450),
    [anon_sym_source_filename] = ACTIONS(1450),
    [anon_sym_declare] = ACTIONS(1450),
    [anon_sym_define] = ACTIONS(1450),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1452),
    [anon_sym_uselistorder_bb] = ACTIONS(1450),
    [anon_sym_module] = ACTIONS(1450),
    [anon_sym_attributes] = ACTIONS(1450),
  },
  [420] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1462),
    [sym_global_var] = ACTIONS(1462),
    [sym_local_var] = ACTIONS(1462),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_summary_ref] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1462),
    [anon_sym_source_filename] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_define] = ACTIONS(1462),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1464),
    [anon_sym_uselistorder_bb] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_attributes] = ACTIONS(1462),
  },
  [421] = {
    [sym_attribute] = STATE(438),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1462),
    [sym_global_var] = ACTIONS(1462),
    [sym_local_var] = ACTIONS(1462),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_summary_ref] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1462),
    [anon_sym_source_filename] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_define] = ACTIONS(1462),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1464),
    [anon_sym_uselistorder_bb] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_attributes] = ACTIONS(1462),
  },
  [422] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1502),
    [sym_global_var] = ACTIONS(1502),
    [sym_local_var] = ACTIONS(1502),
    [aux_sym_metadata_ref_token1] = ACTIONS(1502),
    [sym_summary_ref] = ACTIONS(1502),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1502),
    [anon_sym_source_filename] = ACTIONS(1502),
    [anon_sym_declare] = ACTIONS(1502),
    [anon_sym_define] = ACTIONS(1502),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1504),
    [anon_sym_uselistorder_bb] = ACTIONS(1502),
    [anon_sym_module] = ACTIONS(1502),
    [anon_sym_attributes] = ACTIONS(1502),
  },
  [423] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1506),
    [sym_global_var] = ACTIONS(1506),
    [sym_local_var] = ACTIONS(1506),
    [aux_sym_metadata_ref_token1] = ACTIONS(1506),
    [sym_summary_ref] = ACTIONS(1506),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1506),
    [anon_sym_source_filename] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_define] = ACTIONS(1506),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1508),
    [anon_sym_uselistorder_bb] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_attributes] = ACTIONS(1506),
  },
  [424] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1510),
    [sym_comdat_ref] = ACTIONS(760),
    [sym_global_var] = ACTIONS(760),
    [sym_local_var] = ACTIONS(760),
    [aux_sym_metadata_ref_token1] = ACTIONS(760),
    [sym_summary_ref] = ACTIONS(760),
    [sym_string] = ACTIONS(1510),
    [anon_sym_target] = ACTIONS(760),
    [anon_sym_source_filename] = ACTIONS(760),
    [anon_sym_declare] = ACTIONS(760),
    [anon_sym_define] = ACTIONS(760),
    [anon_sym_align] = ACTIONS(1513),
    [anon_sym_section] = ACTIONS(1516),
    [anon_sym_partition] = ACTIONS(1516),
    [anon_sym_comdat] = ACTIONS(1519),
    [anon_sym_gc] = ACTIONS(1516),
    [anon_sym_prefix] = ACTIONS(1522),
    [anon_sym_prologue] = ACTIONS(1522),
    [anon_sym_personality] = ACTIONS(1522),
    [anon_sym_alignstack] = ACTIONS(1525),
    [anon_sym_allocsize] = ACTIONS(1525),
    [anon_sym_alwaysinline] = ACTIONS(1525),
    [anon_sym_builtin] = ACTIONS(1525),
    [anon_sym_cold] = ACTIONS(1525),
    [anon_sym_convergent] = ACTIONS(1525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1525),
    [anon_sym_hot] = ACTIONS(1525),
    [anon_sym_inaccessiblememonly] = ACTIONS(1525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1525),
    [anon_sym_inlinehint] = ACTIONS(1525),
    [anon_sym_jumptable] = ACTIONS(1525),
    [anon_sym_minsize] = ACTIONS(1525),
    [anon_sym_naked] = ACTIONS(1525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1525),
    [anon_sym_nobuiltin] = ACTIONS(1525),
    [anon_sym_noduplicate] = ACTIONS(1525),
    [anon_sym_nofree] = ACTIONS(1525),
    [anon_sym_noimplicitfloat] = ACTIONS(1525),
    [anon_sym_noinline] = ACTIONS(1525),
    [anon_sym_nomerge] = ACTIONS(1525),
    [anon_sym_nonlazybind] = ACTIONS(1525),
    [anon_sym_noprofile] = ACTIONS(1525),
    [anon_sym_noredzone] = ACTIONS(1525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [anon_sym_norecurse] = ACTIONS(1525),
    [anon_sym_willreturn] = ACTIONS(1525),
    [anon_sym_nosync] = ACTIONS(1525),
    [anon_sym_nounwind] = ACTIONS(1525),
    [anon_sym_nosanitize_coverage] = ACTIONS(1525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1525),
    [anon_sym_optforfuzzing] = ACTIONS(1525),
    [anon_sym_optnone] = ACTIONS(1525),
    [anon_sym_optsize] = ACTIONS(1525),
    [anon_sym_readnone] = ACTIONS(1525),
    [anon_sym_readonly] = ACTIONS(1525),
    [anon_sym_writeonly] = ACTIONS(1525),
    [anon_sym_argmemonly] = ACTIONS(1525),
    [anon_sym_returns_twice] = ACTIONS(1525),
    [anon_sym_safestack] = ACTIONS(1525),
    [anon_sym_sanitize_address] = ACTIONS(1525),
    [anon_sym_sanitize_memory] = ACTIONS(1525),
    [anon_sym_sanitize_thread] = ACTIONS(1525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1525),
    [anon_sym_sanitize_memtag] = ACTIONS(1525),
    [anon_sym_speculative_load_hardening] = ACTIONS(1525),
    [anon_sym_speculatable] = ACTIONS(1525),
    [anon_sym_ssp] = ACTIONS(1528),
    [anon_sym_sspstrong] = ACTIONS(1525),
    [anon_sym_sspreq] = ACTIONS(1525),
    [anon_sym_strictfp] = ACTIONS(1525),
    [anon_sym_uwtable] = ACTIONS(1525),
    [anon_sym_nocf_check] = ACTIONS(1525),
    [anon_sym_shadowcallstack] = ACTIONS(1525),
    [anon_sym_mustprogress] = ACTIONS(1525),
    [anon_sym_vscale_range] = ACTIONS(1525),
    [anon_sym_preallocated] = ACTIONS(1525),
    [anon_sym_zeroext] = ACTIONS(1525),
    [anon_sym_signext] = ACTIONS(1525),
    [anon_sym_inreg] = ACTIONS(1525),
    [anon_sym_byval] = ACTIONS(1525),
    [anon_sym_byref] = ACTIONS(1525),
    [anon_sym_inalloca] = ACTIONS(1525),
    [anon_sym_sret] = ACTIONS(1525),
    [anon_sym_elementtype] = ACTIONS(1525),
    [anon_sym_noalias] = ACTIONS(1525),
    [anon_sym_nocapture] = ACTIONS(1525),
    [anon_sym_nest] = ACTIONS(1525),
    [anon_sym_returned] = ACTIONS(1525),
    [anon_sym_nonnull] = ACTIONS(1525),
    [anon_sym_dereferenceable] = ACTIONS(1528),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1525),
    [anon_sym_swiftself] = ACTIONS(1525),
    [anon_sym_swiftasync] = ACTIONS(1525),
    [anon_sym_swifterror] = ACTIONS(1525),
    [anon_sym_immarg] = ACTIONS(1525),
    [anon_sym_noundef] = ACTIONS(1525),
    [anon_sym_uselistorder] = ACTIONS(780),
    [anon_sym_uselistorder_bb] = ACTIONS(760),
    [anon_sym_module] = ACTIONS(760),
    [anon_sym_attributes] = ACTIONS(760),
  },
  [425] = {
    [sym_attribute] = STATE(433),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1506),
    [sym_global_var] = ACTIONS(1506),
    [sym_local_var] = ACTIONS(1506),
    [aux_sym_metadata_ref_token1] = ACTIONS(1506),
    [sym_summary_ref] = ACTIONS(1506),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1506),
    [anon_sym_source_filename] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_define] = ACTIONS(1506),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1508),
    [anon_sym_uselistorder_bb] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_attributes] = ACTIONS(1506),
  },
  [426] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1531),
    [sym_global_var] = ACTIONS(1531),
    [sym_local_var] = ACTIONS(1531),
    [aux_sym_metadata_ref_token1] = ACTIONS(1531),
    [sym_summary_ref] = ACTIONS(1531),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1531),
    [anon_sym_source_filename] = ACTIONS(1531),
    [anon_sym_declare] = ACTIONS(1531),
    [anon_sym_define] = ACTIONS(1531),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1533),
    [anon_sym_uselistorder_bb] = ACTIONS(1531),
    [anon_sym_module] = ACTIONS(1531),
    [anon_sym_attributes] = ACTIONS(1531),
  },
  [427] = {
    [sym_attribute] = STATE(416),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1531),
    [sym_global_var] = ACTIONS(1531),
    [sym_local_var] = ACTIONS(1531),
    [aux_sym_metadata_ref_token1] = ACTIONS(1531),
    [sym_summary_ref] = ACTIONS(1531),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1531),
    [anon_sym_source_filename] = ACTIONS(1531),
    [anon_sym_declare] = ACTIONS(1531),
    [anon_sym_define] = ACTIONS(1531),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1533),
    [anon_sym_uselistorder_bb] = ACTIONS(1531),
    [anon_sym_module] = ACTIONS(1531),
    [anon_sym_attributes] = ACTIONS(1531),
  },
  [428] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1444),
    [sym_global_var] = ACTIONS(1444),
    [sym_local_var] = ACTIONS(1444),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_summary_ref] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1444),
    [anon_sym_source_filename] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_define] = ACTIONS(1444),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1446),
    [anon_sym_uselistorder_bb] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_attributes] = ACTIONS(1444),
  },
  [429] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1535),
    [sym_global_var] = ACTIONS(1535),
    [sym_local_var] = ACTIONS(1535),
    [aux_sym_metadata_ref_token1] = ACTIONS(1535),
    [sym_summary_ref] = ACTIONS(1535),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1535),
    [anon_sym_source_filename] = ACTIONS(1535),
    [anon_sym_declare] = ACTIONS(1535),
    [anon_sym_define] = ACTIONS(1535),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1537),
    [anon_sym_uselistorder_bb] = ACTIONS(1535),
    [anon_sym_module] = ACTIONS(1535),
    [anon_sym_attributes] = ACTIONS(1535),
  },
  [430] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1454),
    [sym_global_var] = ACTIONS(1454),
    [sym_local_var] = ACTIONS(1454),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_summary_ref] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1454),
    [anon_sym_source_filename] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_define] = ACTIONS(1454),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1456),
    [anon_sym_uselistorder_bb] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_attributes] = ACTIONS(1454),
  },
  [431] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1539),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1539),
    [sym_global_var] = ACTIONS(1539),
    [sym_local_var] = ACTIONS(1539),
    [aux_sym_metadata_ref_token1] = ACTIONS(1539),
    [sym_summary_ref] = ACTIONS(1539),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1539),
    [anon_sym_source_filename] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_define] = ACTIONS(1539),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1541),
    [anon_sym_uselistorder_bb] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_attributes] = ACTIONS(1539),
  },
  [432] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(432),
    [aux_sym_summary_entry_repeat1] = STATE(432),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1543),
    [sym_string] = ACTIONS(1543),
    [aux_sym_number_token1] = ACTIONS(1546),
    [aux_sym_number_token2] = ACTIONS(1546),
    [anon_sym_private] = ACTIONS(1549),
    [anon_sym_internal] = ACTIONS(1549),
    [anon_sym_weak] = ACTIONS(1549),
    [anon_sym_weak_odr] = ACTIONS(1549),
    [anon_sym_linkonce] = ACTIONS(1549),
    [anon_sym_linkonce_odr] = ACTIONS(1549),
    [anon_sym_available_externally] = ACTIONS(1549),
    [anon_sym_appending] = ACTIONS(1549),
    [anon_sym_common] = ACTIONS(1549),
    [anon_sym_extern_weak] = ACTIONS(1549),
    [anon_sym_external] = ACTIONS(1549),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_RBRACK] = ACTIONS(1555),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_LPAREN] = ACTIONS(1557),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_align] = ACTIONS(1560),
    [anon_sym_alignstack] = ACTIONS(1560),
    [anon_sym_allocsize] = ACTIONS(1560),
    [anon_sym_alwaysinline] = ACTIONS(1560),
    [anon_sym_builtin] = ACTIONS(1560),
    [anon_sym_cold] = ACTIONS(1560),
    [anon_sym_convergent] = ACTIONS(1560),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1560),
    [anon_sym_hot] = ACTIONS(1560),
    [anon_sym_inaccessiblememonly] = ACTIONS(1560),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1560),
    [anon_sym_inlinehint] = ACTIONS(1560),
    [anon_sym_jumptable] = ACTIONS(1560),
    [anon_sym_minsize] = ACTIONS(1560),
    [anon_sym_naked] = ACTIONS(1560),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1560),
    [anon_sym_nobuiltin] = ACTIONS(1560),
    [anon_sym_noduplicate] = ACTIONS(1560),
    [anon_sym_nofree] = ACTIONS(1560),
    [anon_sym_noimplicitfloat] = ACTIONS(1560),
    [anon_sym_noinline] = ACTIONS(1560),
    [anon_sym_nomerge] = ACTIONS(1560),
    [anon_sym_nonlazybind] = ACTIONS(1560),
    [anon_sym_noprofile] = ACTIONS(1560),
    [anon_sym_noredzone] = ACTIONS(1560),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1560),
    [anon_sym_noreturn] = ACTIONS(1560),
    [anon_sym_norecurse] = ACTIONS(1560),
    [anon_sym_willreturn] = ACTIONS(1560),
    [anon_sym_nosync] = ACTIONS(1560),
    [anon_sym_nounwind] = ACTIONS(1560),
    [anon_sym_nosanitize_coverage] = ACTIONS(1560),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1560),
    [anon_sym_optforfuzzing] = ACTIONS(1560),
    [anon_sym_optnone] = ACTIONS(1560),
    [anon_sym_optsize] = ACTIONS(1560),
    [anon_sym_readnone] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_writeonly] = ACTIONS(1560),
    [anon_sym_argmemonly] = ACTIONS(1560),
    [anon_sym_returns_twice] = ACTIONS(1560),
    [anon_sym_safestack] = ACTIONS(1560),
    [anon_sym_sanitize_address] = ACTIONS(1560),
    [anon_sym_sanitize_memory] = ACTIONS(1560),
    [anon_sym_sanitize_thread] = ACTIONS(1560),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1560),
    [anon_sym_sanitize_memtag] = ACTIONS(1560),
    [anon_sym_speculative_load_hardening] = ACTIONS(1560),
    [anon_sym_speculatable] = ACTIONS(1560),
    [anon_sym_ssp] = ACTIONS(1560),
    [anon_sym_sspstrong] = ACTIONS(1560),
    [anon_sym_sspreq] = ACTIONS(1560),
    [anon_sym_strictfp] = ACTIONS(1560),
    [anon_sym_uwtable] = ACTIONS(1560),
    [anon_sym_nocf_check] = ACTIONS(1560),
    [anon_sym_shadowcallstack] = ACTIONS(1560),
    [anon_sym_mustprogress] = ACTIONS(1560),
    [anon_sym_vscale_range] = ACTIONS(1560),
    [anon_sym_preallocated] = ACTIONS(1560),
    [anon_sym_zeroext] = ACTIONS(1560),
    [anon_sym_signext] = ACTIONS(1560),
    [anon_sym_inreg] = ACTIONS(1560),
    [anon_sym_byval] = ACTIONS(1560),
    [anon_sym_byref] = ACTIONS(1560),
    [anon_sym_inalloca] = ACTIONS(1560),
    [anon_sym_sret] = ACTIONS(1560),
    [anon_sym_elementtype] = ACTIONS(1560),
    [anon_sym_noalias] = ACTIONS(1560),
    [anon_sym_nocapture] = ACTIONS(1560),
    [anon_sym_nest] = ACTIONS(1560),
    [anon_sym_returned] = ACTIONS(1560),
    [anon_sym_nonnull] = ACTIONS(1560),
    [anon_sym_dereferenceable] = ACTIONS(1560),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1560),
    [anon_sym_swiftself] = ACTIONS(1560),
    [anon_sym_swiftasync] = ACTIONS(1560),
    [anon_sym_swifterror] = ACTIONS(1560),
    [anon_sym_immarg] = ACTIONS(1560),
    [anon_sym_noundef] = ACTIONS(1560),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1563),
    [anon_sym_COLON] = ACTIONS(1543),
  },
  [433] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1566),
    [sym_global_var] = ACTIONS(1566),
    [sym_local_var] = ACTIONS(1566),
    [aux_sym_metadata_ref_token1] = ACTIONS(1566),
    [sym_summary_ref] = ACTIONS(1566),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1566),
    [anon_sym_source_filename] = ACTIONS(1566),
    [anon_sym_declare] = ACTIONS(1566),
    [anon_sym_define] = ACTIONS(1566),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1568),
    [anon_sym_uselistorder_bb] = ACTIONS(1566),
    [anon_sym_module] = ACTIONS(1566),
    [anon_sym_attributes] = ACTIONS(1566),
  },
  [434] = {
    [sym_attribute] = STATE(418),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(1539),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1539),
    [sym_global_var] = ACTIONS(1539),
    [sym_local_var] = ACTIONS(1539),
    [aux_sym_metadata_ref_token1] = ACTIONS(1539),
    [sym_summary_ref] = ACTIONS(1539),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1539),
    [anon_sym_source_filename] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_define] = ACTIONS(1539),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1541),
    [anon_sym_uselistorder_bb] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_attributes] = ACTIONS(1539),
  },
  [435] = {
    [sym_attribute] = STATE(429),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(429),
    [ts_builtin_sym_end] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1570),
    [sym_global_var] = ACTIONS(1570),
    [sym_local_var] = ACTIONS(1570),
    [aux_sym_metadata_ref_token1] = ACTIONS(1570),
    [sym_summary_ref] = ACTIONS(1570),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1570),
    [anon_sym_source_filename] = ACTIONS(1570),
    [anon_sym_declare] = ACTIONS(1570),
    [anon_sym_define] = ACTIONS(1570),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1572),
    [anon_sym_uselistorder_bb] = ACTIONS(1570),
    [anon_sym_module] = ACTIONS(1570),
    [anon_sym_attributes] = ACTIONS(1570),
  },
  [436] = {
    [sym_attribute] = STATE(431),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(431),
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1454),
    [sym_global_var] = ACTIONS(1454),
    [sym_local_var] = ACTIONS(1454),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_summary_ref] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1454),
    [anon_sym_source_filename] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_define] = ACTIONS(1454),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1456),
    [anon_sym_uselistorder_bb] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_attributes] = ACTIONS(1454),
  },
  [437] = {
    [sym_attribute] = STATE(423),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1458),
    [sym_global_var] = ACTIONS(1458),
    [sym_local_var] = ACTIONS(1458),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_summary_ref] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1458),
    [anon_sym_source_filename] = ACTIONS(1458),
    [anon_sym_declare] = ACTIONS(1458),
    [anon_sym_define] = ACTIONS(1458),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1460),
    [anon_sym_uselistorder_bb] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_attributes] = ACTIONS(1458),
  },
  [438] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1570),
    [sym_global_var] = ACTIONS(1570),
    [sym_local_var] = ACTIONS(1570),
    [aux_sym_metadata_ref_token1] = ACTIONS(1570),
    [sym_summary_ref] = ACTIONS(1570),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1570),
    [anon_sym_source_filename] = ACTIONS(1570),
    [anon_sym_declare] = ACTIONS(1570),
    [anon_sym_define] = ACTIONS(1570),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1572),
    [anon_sym_uselistorder_bb] = ACTIONS(1570),
    [anon_sym_module] = ACTIONS(1570),
    [anon_sym_attributes] = ACTIONS(1570),
  },
  [439] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1458),
    [sym_global_var] = ACTIONS(1458),
    [sym_local_var] = ACTIONS(1458),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_summary_ref] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1458),
    [anon_sym_source_filename] = ACTIONS(1458),
    [anon_sym_declare] = ACTIONS(1458),
    [anon_sym_define] = ACTIONS(1458),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1460),
    [anon_sym_uselistorder_bb] = ACTIONS(1458),
    [anon_sym_module] = ACTIONS(1458),
    [anon_sym_attributes] = ACTIONS(1458),
  },
  [440] = {
    [sym_attribute] = STATE(422),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(422),
    [ts_builtin_sym_end] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1574),
    [sym_global_var] = ACTIONS(1574),
    [sym_local_var] = ACTIONS(1574),
    [aux_sym_metadata_ref_token1] = ACTIONS(1574),
    [sym_summary_ref] = ACTIONS(1574),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1574),
    [anon_sym_source_filename] = ACTIONS(1574),
    [anon_sym_declare] = ACTIONS(1574),
    [anon_sym_define] = ACTIONS(1574),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1576),
    [anon_sym_uselistorder_bb] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [anon_sym_attributes] = ACTIONS(1574),
  },
  [441] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_comdat_ref] = ACTIONS(1574),
    [sym_global_var] = ACTIONS(1574),
    [sym_local_var] = ACTIONS(1574),
    [aux_sym_metadata_ref_token1] = ACTIONS(1574),
    [sym_summary_ref] = ACTIONS(1574),
    [sym_string] = ACTIONS(1367),
    [anon_sym_target] = ACTIONS(1574),
    [anon_sym_source_filename] = ACTIONS(1574),
    [anon_sym_declare] = ACTIONS(1574),
    [anon_sym_define] = ACTIONS(1574),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uselistorder] = ACTIONS(1576),
    [anon_sym_uselistorder_bb] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [anon_sym_attributes] = ACTIONS(1574),
  },
  [442] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(432),
    [aux_sym_summary_entry_repeat1] = STATE(432),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_RBRACK] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [443] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(442),
    [aux_sym_summary_entry_repeat1] = STATE(442),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_RBRACK] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [444] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(447),
    [aux_sym_summary_entry_repeat1] = STATE(447),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1596),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [445] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(446),
    [aux_sym_summary_entry_repeat1] = STATE(446),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [446] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(432),
    [aux_sym_summary_entry_repeat1] = STATE(432),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [447] = {
    [sym_number] = STATE(455),
    [sym_linkage_aux] = STATE(455),
    [sym_attribute_name] = STATE(455),
    [sym_summary_value] = STATE(432),
    [aux_sym_summary_entry_repeat1] = STATE(432),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1578),
    [sym_string] = ACTIONS(1578),
    [aux_sym_number_token1] = ACTIONS(1580),
    [aux_sym_number_token2] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1582),
    [anon_sym_internal] = ACTIONS(1582),
    [anon_sym_weak] = ACTIONS(1582),
    [anon_sym_weak_odr] = ACTIONS(1582),
    [anon_sym_linkonce] = ACTIONS(1582),
    [anon_sym_linkonce_odr] = ACTIONS(1582),
    [anon_sym_available_externally] = ACTIONS(1582),
    [anon_sym_appending] = ACTIONS(1582),
    [anon_sym_common] = ACTIONS(1582),
    [anon_sym_extern_weak] = ACTIONS(1582),
    [anon_sym_external] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_align] = ACTIONS(1590),
    [anon_sym_alignstack] = ACTIONS(1590),
    [anon_sym_allocsize] = ACTIONS(1590),
    [anon_sym_alwaysinline] = ACTIONS(1590),
    [anon_sym_builtin] = ACTIONS(1590),
    [anon_sym_cold] = ACTIONS(1590),
    [anon_sym_convergent] = ACTIONS(1590),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1590),
    [anon_sym_hot] = ACTIONS(1590),
    [anon_sym_inaccessiblememonly] = ACTIONS(1590),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1590),
    [anon_sym_inlinehint] = ACTIONS(1590),
    [anon_sym_jumptable] = ACTIONS(1590),
    [anon_sym_minsize] = ACTIONS(1590),
    [anon_sym_naked] = ACTIONS(1590),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1590),
    [anon_sym_nobuiltin] = ACTIONS(1590),
    [anon_sym_noduplicate] = ACTIONS(1590),
    [anon_sym_nofree] = ACTIONS(1590),
    [anon_sym_noimplicitfloat] = ACTIONS(1590),
    [anon_sym_noinline] = ACTIONS(1590),
    [anon_sym_nomerge] = ACTIONS(1590),
    [anon_sym_nonlazybind] = ACTIONS(1590),
    [anon_sym_noprofile] = ACTIONS(1590),
    [anon_sym_noredzone] = ACTIONS(1590),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1590),
    [anon_sym_noreturn] = ACTIONS(1590),
    [anon_sym_norecurse] = ACTIONS(1590),
    [anon_sym_willreturn] = ACTIONS(1590),
    [anon_sym_nosync] = ACTIONS(1590),
    [anon_sym_nounwind] = ACTIONS(1590),
    [anon_sym_nosanitize_coverage] = ACTIONS(1590),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1590),
    [anon_sym_optforfuzzing] = ACTIONS(1590),
    [anon_sym_optnone] = ACTIONS(1590),
    [anon_sym_optsize] = ACTIONS(1590),
    [anon_sym_readnone] = ACTIONS(1590),
    [anon_sym_readonly] = ACTIONS(1590),
    [anon_sym_writeonly] = ACTIONS(1590),
    [anon_sym_argmemonly] = ACTIONS(1590),
    [anon_sym_returns_twice] = ACTIONS(1590),
    [anon_sym_safestack] = ACTIONS(1590),
    [anon_sym_sanitize_address] = ACTIONS(1590),
    [anon_sym_sanitize_memory] = ACTIONS(1590),
    [anon_sym_sanitize_thread] = ACTIONS(1590),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1590),
    [anon_sym_sanitize_memtag] = ACTIONS(1590),
    [anon_sym_speculative_load_hardening] = ACTIONS(1590),
    [anon_sym_speculatable] = ACTIONS(1590),
    [anon_sym_ssp] = ACTIONS(1590),
    [anon_sym_sspstrong] = ACTIONS(1590),
    [anon_sym_sspreq] = ACTIONS(1590),
    [anon_sym_strictfp] = ACTIONS(1590),
    [anon_sym_uwtable] = ACTIONS(1590),
    [anon_sym_nocf_check] = ACTIONS(1590),
    [anon_sym_shadowcallstack] = ACTIONS(1590),
    [anon_sym_mustprogress] = ACTIONS(1590),
    [anon_sym_vscale_range] = ACTIONS(1590),
    [anon_sym_preallocated] = ACTIONS(1590),
    [anon_sym_zeroext] = ACTIONS(1590),
    [anon_sym_signext] = ACTIONS(1590),
    [anon_sym_inreg] = ACTIONS(1590),
    [anon_sym_byval] = ACTIONS(1590),
    [anon_sym_byref] = ACTIONS(1590),
    [anon_sym_inalloca] = ACTIONS(1590),
    [anon_sym_sret] = ACTIONS(1590),
    [anon_sym_elementtype] = ACTIONS(1590),
    [anon_sym_noalias] = ACTIONS(1590),
    [anon_sym_nocapture] = ACTIONS(1590),
    [anon_sym_nest] = ACTIONS(1590),
    [anon_sym_returned] = ACTIONS(1590),
    [anon_sym_nonnull] = ACTIONS(1590),
    [anon_sym_dereferenceable] = ACTIONS(1590),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1590),
    [anon_sym_swiftself] = ACTIONS(1590),
    [anon_sym_swiftasync] = ACTIONS(1590),
    [anon_sym_swifterror] = ACTIONS(1590),
    [anon_sym_immarg] = ACTIONS(1590),
    [anon_sym_noundef] = ACTIONS(1590),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1578),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1466),
    [sym_comdat_ref] = ACTIONS(1466),
    [sym_global_var] = ACTIONS(1466),
    [sym_local_var] = ACTIONS(1466),
    [aux_sym_metadata_ref_token1] = ACTIONS(1466),
    [sym_summary_ref] = ACTIONS(1466),
    [sym_string] = ACTIONS(1466),
    [anon_sym_target] = ACTIONS(1466),
    [anon_sym_source_filename] = ACTIONS(1466),
    [anon_sym_declare] = ACTIONS(1466),
    [anon_sym_define] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1466),
    [anon_sym_align] = ACTIONS(1492),
    [anon_sym_section] = ACTIONS(1466),
    [anon_sym_partition] = ACTIONS(1466),
    [anon_sym_comdat] = ACTIONS(1466),
    [anon_sym_gc] = ACTIONS(1466),
    [anon_sym_prefix] = ACTIONS(1466),
    [anon_sym_prologue] = ACTIONS(1466),
    [anon_sym_personality] = ACTIONS(1466),
    [anon_sym_alignstack] = ACTIONS(1466),
    [anon_sym_allocsize] = ACTIONS(1466),
    [anon_sym_alwaysinline] = ACTIONS(1466),
    [anon_sym_builtin] = ACTIONS(1466),
    [anon_sym_cold] = ACTIONS(1466),
    [anon_sym_convergent] = ACTIONS(1466),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1466),
    [anon_sym_hot] = ACTIONS(1466),
    [anon_sym_inaccessiblememonly] = ACTIONS(1466),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1466),
    [anon_sym_inlinehint] = ACTIONS(1466),
    [anon_sym_jumptable] = ACTIONS(1466),
    [anon_sym_minsize] = ACTIONS(1466),
    [anon_sym_naked] = ACTIONS(1466),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1466),
    [anon_sym_nobuiltin] = ACTIONS(1466),
    [anon_sym_noduplicate] = ACTIONS(1466),
    [anon_sym_nofree] = ACTIONS(1466),
    [anon_sym_noimplicitfloat] = ACTIONS(1466),
    [anon_sym_noinline] = ACTIONS(1466),
    [anon_sym_nomerge] = ACTIONS(1466),
    [anon_sym_nonlazybind] = ACTIONS(1466),
    [anon_sym_noprofile] = ACTIONS(1466),
    [anon_sym_noredzone] = ACTIONS(1466),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [anon_sym_norecurse] = ACTIONS(1466),
    [anon_sym_willreturn] = ACTIONS(1466),
    [anon_sym_nosync] = ACTIONS(1466),
    [anon_sym_nounwind] = ACTIONS(1466),
    [anon_sym_nosanitize_coverage] = ACTIONS(1466),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1466),
    [anon_sym_optforfuzzing] = ACTIONS(1466),
    [anon_sym_optnone] = ACTIONS(1466),
    [anon_sym_optsize] = ACTIONS(1466),
    [anon_sym_readnone] = ACTIONS(1466),
    [anon_sym_readonly] = ACTIONS(1466),
    [anon_sym_writeonly] = ACTIONS(1466),
    [anon_sym_argmemonly] = ACTIONS(1466),
    [anon_sym_returns_twice] = ACTIONS(1466),
    [anon_sym_safestack] = ACTIONS(1466),
    [anon_sym_sanitize_address] = ACTIONS(1466),
    [anon_sym_sanitize_memory] = ACTIONS(1466),
    [anon_sym_sanitize_thread] = ACTIONS(1466),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1466),
    [anon_sym_sanitize_memtag] = ACTIONS(1466),
    [anon_sym_speculative_load_hardening] = ACTIONS(1466),
    [anon_sym_speculatable] = ACTIONS(1466),
    [anon_sym_ssp] = ACTIONS(1492),
    [anon_sym_sspstrong] = ACTIONS(1466),
    [anon_sym_sspreq] = ACTIONS(1466),
    [anon_sym_strictfp] = ACTIONS(1466),
    [anon_sym_uwtable] = ACTIONS(1466),
    [anon_sym_nocf_check] = ACTIONS(1466),
    [anon_sym_shadowcallstack] = ACTIONS(1466),
    [anon_sym_mustprogress] = ACTIONS(1466),
    [anon_sym_vscale_range] = ACTIONS(1466),
    [anon_sym_preallocated] = ACTIONS(1466),
    [anon_sym_zeroext] = ACTIONS(1466),
    [anon_sym_signext] = ACTIONS(1466),
    [anon_sym_inreg] = ACTIONS(1466),
    [anon_sym_byval] = ACTIONS(1466),
    [anon_sym_byref] = ACTIONS(1466),
    [anon_sym_inalloca] = ACTIONS(1466),
    [anon_sym_sret] = ACTIONS(1466),
    [anon_sym_elementtype] = ACTIONS(1466),
    [anon_sym_noalias] = ACTIONS(1466),
    [anon_sym_nocapture] = ACTIONS(1466),
    [anon_sym_nest] = ACTIONS(1466),
    [anon_sym_returned] = ACTIONS(1466),
    [anon_sym_nonnull] = ACTIONS(1466),
    [anon_sym_dereferenceable] = ACTIONS(1492),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1466),
    [anon_sym_swiftself] = ACTIONS(1466),
    [anon_sym_swiftasync] = ACTIONS(1466),
    [anon_sym_swifterror] = ACTIONS(1466),
    [anon_sym_immarg] = ACTIONS(1466),
    [anon_sym_noundef] = ACTIONS(1466),
    [anon_sym_uselistorder] = ACTIONS(1492),
    [anon_sym_uselistorder_bb] = ACTIONS(1466),
    [anon_sym_module] = ACTIONS(1466),
    [anon_sym_attributes] = ACTIONS(1466),
  },
  [449] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1600),
    [anon_sym_unnamed_addr] = ACTIONS(1600),
    [anon_sym_local_unnamed_addr] = ACTIONS(1600),
    [anon_sym_void] = ACTIONS(1600),
    [anon_sym_half] = ACTIONS(1600),
    [anon_sym_bfloat] = ACTIONS(1600),
    [anon_sym_float] = ACTIONS(1600),
    [anon_sym_double] = ACTIONS(1600),
    [anon_sym_x86_fp80] = ACTIONS(1600),
    [anon_sym_fp128] = ACTIONS(1600),
    [anon_sym_ppc_fp128] = ACTIONS(1600),
    [anon_sym_label] = ACTIONS(1600),
    [anon_sym_metadata] = ACTIONS(1600),
    [anon_sym_x86_mmx] = ACTIONS(1600),
    [anon_sym_x86_amx] = ACTIONS(1600),
    [anon_sym_token] = ACTIONS(1600),
    [anon_sym_opaque] = ACTIONS(1600),
    [anon_sym_ptr] = ACTIONS(1600),
    [aux_sym_type_keyword_token1] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1600),
    [anon_sym_LT_LBRACE] = ACTIONS(1600),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_addrspace] = ACTIONS(1600),
    [anon_sym_align] = ACTIONS(1602),
    [anon_sym_alignstack] = ACTIONS(1600),
    [anon_sym_allocsize] = ACTIONS(1600),
    [anon_sym_alwaysinline] = ACTIONS(1600),
    [anon_sym_builtin] = ACTIONS(1600),
    [anon_sym_cold] = ACTIONS(1600),
    [anon_sym_convergent] = ACTIONS(1600),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1600),
    [anon_sym_hot] = ACTIONS(1600),
    [anon_sym_inaccessiblememonly] = ACTIONS(1600),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1600),
    [anon_sym_inlinehint] = ACTIONS(1600),
    [anon_sym_jumptable] = ACTIONS(1600),
    [anon_sym_minsize] = ACTIONS(1600),
    [anon_sym_naked] = ACTIONS(1600),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1600),
    [anon_sym_nobuiltin] = ACTIONS(1600),
    [anon_sym_noduplicate] = ACTIONS(1600),
    [anon_sym_nofree] = ACTIONS(1600),
    [anon_sym_noimplicitfloat] = ACTIONS(1600),
    [anon_sym_noinline] = ACTIONS(1600),
    [anon_sym_nomerge] = ACTIONS(1600),
    [anon_sym_nonlazybind] = ACTIONS(1600),
    [anon_sym_noprofile] = ACTIONS(1600),
    [anon_sym_noredzone] = ACTIONS(1600),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1600),
    [anon_sym_noreturn] = ACTIONS(1600),
    [anon_sym_norecurse] = ACTIONS(1600),
    [anon_sym_willreturn] = ACTIONS(1600),
    [anon_sym_nosync] = ACTIONS(1600),
    [anon_sym_nounwind] = ACTIONS(1600),
    [anon_sym_nosanitize_coverage] = ACTIONS(1600),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1600),
    [anon_sym_optforfuzzing] = ACTIONS(1600),
    [anon_sym_optnone] = ACTIONS(1600),
    [anon_sym_optsize] = ACTIONS(1600),
    [anon_sym_readnone] = ACTIONS(1600),
    [anon_sym_readonly] = ACTIONS(1600),
    [anon_sym_writeonly] = ACTIONS(1600),
    [anon_sym_argmemonly] = ACTIONS(1600),
    [anon_sym_returns_twice] = ACTIONS(1600),
    [anon_sym_safestack] = ACTIONS(1600),
    [anon_sym_sanitize_address] = ACTIONS(1600),
    [anon_sym_sanitize_memory] = ACTIONS(1600),
    [anon_sym_sanitize_thread] = ACTIONS(1600),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1600),
    [anon_sym_sanitize_memtag] = ACTIONS(1600),
    [anon_sym_speculative_load_hardening] = ACTIONS(1600),
    [anon_sym_speculatable] = ACTIONS(1600),
    [anon_sym_ssp] = ACTIONS(1602),
    [anon_sym_sspstrong] = ACTIONS(1600),
    [anon_sym_sspreq] = ACTIONS(1600),
    [anon_sym_strictfp] = ACTIONS(1600),
    [anon_sym_uwtable] = ACTIONS(1600),
    [anon_sym_nocf_check] = ACTIONS(1600),
    [anon_sym_shadowcallstack] = ACTIONS(1600),
    [anon_sym_mustprogress] = ACTIONS(1600),
    [anon_sym_vscale_range] = ACTIONS(1600),
    [anon_sym_preallocated] = ACTIONS(1600),
    [anon_sym_zeroext] = ACTIONS(1600),
    [anon_sym_signext] = ACTIONS(1600),
    [anon_sym_inreg] = ACTIONS(1600),
    [anon_sym_byval] = ACTIONS(1600),
    [anon_sym_byref] = ACTIONS(1600),
    [anon_sym_inalloca] = ACTIONS(1600),
    [anon_sym_sret] = ACTIONS(1600),
    [anon_sym_elementtype] = ACTIONS(1600),
    [anon_sym_noalias] = ACTIONS(1600),
    [anon_sym_nocapture] = ACTIONS(1600),
    [anon_sym_nest] = ACTIONS(1600),
    [anon_sym_returned] = ACTIONS(1600),
    [anon_sym_nonnull] = ACTIONS(1600),
    [anon_sym_dereferenceable] = ACTIONS(1602),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1600),
    [anon_sym_swiftself] = ACTIONS(1600),
    [anon_sym_swiftasync] = ACTIONS(1600),
    [anon_sym_swifterror] = ACTIONS(1600),
    [anon_sym_immarg] = ACTIONS(1600),
    [anon_sym_noundef] = ACTIONS(1600),
  },
  [450] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1604),
    [anon_sym_unnamed_addr] = ACTIONS(1604),
    [anon_sym_local_unnamed_addr] = ACTIONS(1604),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_half] = ACTIONS(1604),
    [anon_sym_bfloat] = ACTIONS(1604),
    [anon_sym_float] = ACTIONS(1604),
    [anon_sym_double] = ACTIONS(1604),
    [anon_sym_x86_fp80] = ACTIONS(1604),
    [anon_sym_fp128] = ACTIONS(1604),
    [anon_sym_ppc_fp128] = ACTIONS(1604),
    [anon_sym_label] = ACTIONS(1604),
    [anon_sym_metadata] = ACTIONS(1604),
    [anon_sym_x86_mmx] = ACTIONS(1604),
    [anon_sym_x86_amx] = ACTIONS(1604),
    [anon_sym_token] = ACTIONS(1604),
    [anon_sym_opaque] = ACTIONS(1604),
    [anon_sym_ptr] = ACTIONS(1604),
    [aux_sym_type_keyword_token1] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1604),
    [anon_sym_LT_LBRACE] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(1606),
    [anon_sym_addrspace] = ACTIONS(1604),
    [anon_sym_align] = ACTIONS(1606),
    [anon_sym_alignstack] = ACTIONS(1604),
    [anon_sym_allocsize] = ACTIONS(1604),
    [anon_sym_alwaysinline] = ACTIONS(1604),
    [anon_sym_builtin] = ACTIONS(1604),
    [anon_sym_cold] = ACTIONS(1604),
    [anon_sym_convergent] = ACTIONS(1604),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1604),
    [anon_sym_hot] = ACTIONS(1604),
    [anon_sym_inaccessiblememonly] = ACTIONS(1604),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1604),
    [anon_sym_inlinehint] = ACTIONS(1604),
    [anon_sym_jumptable] = ACTIONS(1604),
    [anon_sym_minsize] = ACTIONS(1604),
    [anon_sym_naked] = ACTIONS(1604),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1604),
    [anon_sym_nobuiltin] = ACTIONS(1604),
    [anon_sym_noduplicate] = ACTIONS(1604),
    [anon_sym_nofree] = ACTIONS(1604),
    [anon_sym_noimplicitfloat] = ACTIONS(1604),
    [anon_sym_noinline] = ACTIONS(1604),
    [anon_sym_nomerge] = ACTIONS(1604),
    [anon_sym_nonlazybind] = ACTIONS(1604),
    [anon_sym_noprofile] = ACTIONS(1604),
    [anon_sym_noredzone] = ACTIONS(1604),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1604),
    [anon_sym_noreturn] = ACTIONS(1604),
    [anon_sym_norecurse] = ACTIONS(1604),
    [anon_sym_willreturn] = ACTIONS(1604),
    [anon_sym_nosync] = ACTIONS(1604),
    [anon_sym_nounwind] = ACTIONS(1604),
    [anon_sym_nosanitize_coverage] = ACTIONS(1604),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1604),
    [anon_sym_optforfuzzing] = ACTIONS(1604),
    [anon_sym_optnone] = ACTIONS(1604),
    [anon_sym_optsize] = ACTIONS(1604),
    [anon_sym_readnone] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_writeonly] = ACTIONS(1604),
    [anon_sym_argmemonly] = ACTIONS(1604),
    [anon_sym_returns_twice] = ACTIONS(1604),
    [anon_sym_safestack] = ACTIONS(1604),
    [anon_sym_sanitize_address] = ACTIONS(1604),
    [anon_sym_sanitize_memory] = ACTIONS(1604),
    [anon_sym_sanitize_thread] = ACTIONS(1604),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1604),
    [anon_sym_sanitize_memtag] = ACTIONS(1604),
    [anon_sym_speculative_load_hardening] = ACTIONS(1604),
    [anon_sym_speculatable] = ACTIONS(1604),
    [anon_sym_ssp] = ACTIONS(1606),
    [anon_sym_sspstrong] = ACTIONS(1604),
    [anon_sym_sspreq] = ACTIONS(1604),
    [anon_sym_strictfp] = ACTIONS(1604),
    [anon_sym_uwtable] = ACTIONS(1604),
    [anon_sym_nocf_check] = ACTIONS(1604),
    [anon_sym_shadowcallstack] = ACTIONS(1604),
    [anon_sym_mustprogress] = ACTIONS(1604),
    [anon_sym_vscale_range] = ACTIONS(1604),
    [anon_sym_preallocated] = ACTIONS(1604),
    [anon_sym_zeroext] = ACTIONS(1604),
    [anon_sym_signext] = ACTIONS(1604),
    [anon_sym_inreg] = ACTIONS(1604),
    [anon_sym_byval] = ACTIONS(1604),
    [anon_sym_byref] = ACTIONS(1604),
    [anon_sym_inalloca] = ACTIONS(1604),
    [anon_sym_sret] = ACTIONS(1604),
    [anon_sym_elementtype] = ACTIONS(1604),
    [anon_sym_noalias] = ACTIONS(1604),
    [anon_sym_nocapture] = ACTIONS(1604),
    [anon_sym_nest] = ACTIONS(1604),
    [anon_sym_returned] = ACTIONS(1604),
    [anon_sym_nonnull] = ACTIONS(1604),
    [anon_sym_dereferenceable] = ACTIONS(1606),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1604),
    [anon_sym_swiftself] = ACTIONS(1604),
    [anon_sym_swiftasync] = ACTIONS(1604),
    [anon_sym_swifterror] = ACTIONS(1604),
    [anon_sym_immarg] = ACTIONS(1604),
    [anon_sym_noundef] = ACTIONS(1604),
  },
  [451] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1608),
    [sym_string] = ACTIONS(1608),
    [aux_sym_number_token1] = ACTIONS(1610),
    [aux_sym_number_token2] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_internal] = ACTIONS(1610),
    [anon_sym_weak] = ACTIONS(1610),
    [anon_sym_weak_odr] = ACTIONS(1610),
    [anon_sym_linkonce] = ACTIONS(1610),
    [anon_sym_linkonce_odr] = ACTIONS(1610),
    [anon_sym_available_externally] = ACTIONS(1610),
    [anon_sym_appending] = ACTIONS(1610),
    [anon_sym_common] = ACTIONS(1610),
    [anon_sym_extern_weak] = ACTIONS(1610),
    [anon_sym_external] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_RPAREN] = ACTIONS(1608),
    [anon_sym_align] = ACTIONS(1610),
    [anon_sym_alignstack] = ACTIONS(1610),
    [anon_sym_allocsize] = ACTIONS(1610),
    [anon_sym_alwaysinline] = ACTIONS(1610),
    [anon_sym_builtin] = ACTIONS(1610),
    [anon_sym_cold] = ACTIONS(1610),
    [anon_sym_convergent] = ACTIONS(1610),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1610),
    [anon_sym_hot] = ACTIONS(1610),
    [anon_sym_inaccessiblememonly] = ACTIONS(1610),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1610),
    [anon_sym_inlinehint] = ACTIONS(1610),
    [anon_sym_jumptable] = ACTIONS(1610),
    [anon_sym_minsize] = ACTIONS(1610),
    [anon_sym_naked] = ACTIONS(1610),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1610),
    [anon_sym_nobuiltin] = ACTIONS(1610),
    [anon_sym_noduplicate] = ACTIONS(1610),
    [anon_sym_nofree] = ACTIONS(1610),
    [anon_sym_noimplicitfloat] = ACTIONS(1610),
    [anon_sym_noinline] = ACTIONS(1610),
    [anon_sym_nomerge] = ACTIONS(1610),
    [anon_sym_nonlazybind] = ACTIONS(1610),
    [anon_sym_noprofile] = ACTIONS(1610),
    [anon_sym_noredzone] = ACTIONS(1610),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1610),
    [anon_sym_noreturn] = ACTIONS(1610),
    [anon_sym_norecurse] = ACTIONS(1610),
    [anon_sym_willreturn] = ACTIONS(1610),
    [anon_sym_nosync] = ACTIONS(1610),
    [anon_sym_nounwind] = ACTIONS(1610),
    [anon_sym_nosanitize_coverage] = ACTIONS(1610),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1610),
    [anon_sym_optforfuzzing] = ACTIONS(1610),
    [anon_sym_optnone] = ACTIONS(1610),
    [anon_sym_optsize] = ACTIONS(1610),
    [anon_sym_readnone] = ACTIONS(1610),
    [anon_sym_readonly] = ACTIONS(1610),
    [anon_sym_writeonly] = ACTIONS(1610),
    [anon_sym_argmemonly] = ACTIONS(1610),
    [anon_sym_returns_twice] = ACTIONS(1610),
    [anon_sym_safestack] = ACTIONS(1610),
    [anon_sym_sanitize_address] = ACTIONS(1610),
    [anon_sym_sanitize_memory] = ACTIONS(1610),
    [anon_sym_sanitize_thread] = ACTIONS(1610),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1610),
    [anon_sym_sanitize_memtag] = ACTIONS(1610),
    [anon_sym_speculative_load_hardening] = ACTIONS(1610),
    [anon_sym_speculatable] = ACTIONS(1610),
    [anon_sym_ssp] = ACTIONS(1610),
    [anon_sym_sspstrong] = ACTIONS(1610),
    [anon_sym_sspreq] = ACTIONS(1610),
    [anon_sym_strictfp] = ACTIONS(1610),
    [anon_sym_uwtable] = ACTIONS(1610),
    [anon_sym_nocf_check] = ACTIONS(1610),
    [anon_sym_shadowcallstack] = ACTIONS(1610),
    [anon_sym_mustprogress] = ACTIONS(1610),
    [anon_sym_vscale_range] = ACTIONS(1610),
    [anon_sym_preallocated] = ACTIONS(1610),
    [anon_sym_zeroext] = ACTIONS(1610),
    [anon_sym_signext] = ACTIONS(1610),
    [anon_sym_inreg] = ACTIONS(1610),
    [anon_sym_byval] = ACTIONS(1610),
    [anon_sym_byref] = ACTIONS(1610),
    [anon_sym_inalloca] = ACTIONS(1610),
    [anon_sym_sret] = ACTIONS(1610),
    [anon_sym_elementtype] = ACTIONS(1610),
    [anon_sym_noalias] = ACTIONS(1610),
    [anon_sym_nocapture] = ACTIONS(1610),
    [anon_sym_nest] = ACTIONS(1610),
    [anon_sym_returned] = ACTIONS(1610),
    [anon_sym_nonnull] = ACTIONS(1610),
    [anon_sym_dereferenceable] = ACTIONS(1610),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1610),
    [anon_sym_swiftself] = ACTIONS(1610),
    [anon_sym_swiftasync] = ACTIONS(1610),
    [anon_sym_swifterror] = ACTIONS(1610),
    [anon_sym_immarg] = ACTIONS(1610),
    [anon_sym_noundef] = ACTIONS(1610),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1608),
  },
  [452] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(895),
    [sym_string] = ACTIONS(895),
    [aux_sym_number_token1] = ACTIONS(897),
    [aux_sym_number_token2] = ACTIONS(897),
    [anon_sym_private] = ACTIONS(897),
    [anon_sym_internal] = ACTIONS(897),
    [anon_sym_weak] = ACTIONS(897),
    [anon_sym_weak_odr] = ACTIONS(897),
    [anon_sym_linkonce] = ACTIONS(897),
    [anon_sym_linkonce_odr] = ACTIONS(897),
    [anon_sym_available_externally] = ACTIONS(897),
    [anon_sym_appending] = ACTIONS(897),
    [anon_sym_common] = ACTIONS(897),
    [anon_sym_extern_weak] = ACTIONS(897),
    [anon_sym_external] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_RBRACK] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_align] = ACTIONS(897),
    [anon_sym_alignstack] = ACTIONS(897),
    [anon_sym_allocsize] = ACTIONS(897),
    [anon_sym_alwaysinline] = ACTIONS(897),
    [anon_sym_builtin] = ACTIONS(897),
    [anon_sym_cold] = ACTIONS(897),
    [anon_sym_convergent] = ACTIONS(897),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(897),
    [anon_sym_hot] = ACTIONS(897),
    [anon_sym_inaccessiblememonly] = ACTIONS(897),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(897),
    [anon_sym_inlinehint] = ACTIONS(897),
    [anon_sym_jumptable] = ACTIONS(897),
    [anon_sym_minsize] = ACTIONS(897),
    [anon_sym_naked] = ACTIONS(897),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(897),
    [anon_sym_nobuiltin] = ACTIONS(897),
    [anon_sym_noduplicate] = ACTIONS(897),
    [anon_sym_nofree] = ACTIONS(897),
    [anon_sym_noimplicitfloat] = ACTIONS(897),
    [anon_sym_noinline] = ACTIONS(897),
    [anon_sym_nomerge] = ACTIONS(897),
    [anon_sym_nonlazybind] = ACTIONS(897),
    [anon_sym_noprofile] = ACTIONS(897),
    [anon_sym_noredzone] = ACTIONS(897),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(897),
    [anon_sym_noreturn] = ACTIONS(897),
    [anon_sym_norecurse] = ACTIONS(897),
    [anon_sym_willreturn] = ACTIONS(897),
    [anon_sym_nosync] = ACTIONS(897),
    [anon_sym_nounwind] = ACTIONS(897),
    [anon_sym_nosanitize_coverage] = ACTIONS(897),
    [anon_sym_null_pointer_is_valid] = ACTIONS(897),
    [anon_sym_optforfuzzing] = ACTIONS(897),
    [anon_sym_optnone] = ACTIONS(897),
    [anon_sym_optsize] = ACTIONS(897),
    [anon_sym_readnone] = ACTIONS(897),
    [anon_sym_readonly] = ACTIONS(897),
    [anon_sym_writeonly] = ACTIONS(897),
    [anon_sym_argmemonly] = ACTIONS(897),
    [anon_sym_returns_twice] = ACTIONS(897),
    [anon_sym_safestack] = ACTIONS(897),
    [anon_sym_sanitize_address] = ACTIONS(897),
    [anon_sym_sanitize_memory] = ACTIONS(897),
    [anon_sym_sanitize_thread] = ACTIONS(897),
    [anon_sym_sanitize_hwaddress] = ACTIONS(897),
    [anon_sym_sanitize_memtag] = ACTIONS(897),
    [anon_sym_speculative_load_hardening] = ACTIONS(897),
    [anon_sym_speculatable] = ACTIONS(897),
    [anon_sym_ssp] = ACTIONS(897),
    [anon_sym_sspstrong] = ACTIONS(897),
    [anon_sym_sspreq] = ACTIONS(897),
    [anon_sym_strictfp] = ACTIONS(897),
    [anon_sym_uwtable] = ACTIONS(897),
    [anon_sym_nocf_check] = ACTIONS(897),
    [anon_sym_shadowcallstack] = ACTIONS(897),
    [anon_sym_mustprogress] = ACTIONS(897),
    [anon_sym_vscale_range] = ACTIONS(897),
    [anon_sym_preallocated] = ACTIONS(897),
    [anon_sym_zeroext] = ACTIONS(897),
    [anon_sym_signext] = ACTIONS(897),
    [anon_sym_inreg] = ACTIONS(897),
    [anon_sym_byval] = ACTIONS(897),
    [anon_sym_byref] = ACTIONS(897),
    [anon_sym_inalloca] = ACTIONS(897),
    [anon_sym_sret] = ACTIONS(897),
    [anon_sym_elementtype] = ACTIONS(897),
    [anon_sym_noalias] = ACTIONS(897),
    [anon_sym_nocapture] = ACTIONS(897),
    [anon_sym_nest] = ACTIONS(897),
    [anon_sym_returned] = ACTIONS(897),
    [anon_sym_nonnull] = ACTIONS(897),
    [anon_sym_dereferenceable] = ACTIONS(897),
    [anon_sym_dereferenceable_or_null] = ACTIONS(897),
    [anon_sym_swiftself] = ACTIONS(897),
    [anon_sym_swiftasync] = ACTIONS(897),
    [anon_sym_swifterror] = ACTIONS(897),
    [anon_sym_immarg] = ACTIONS(897),
    [anon_sym_noundef] = ACTIONS(897),
    [aux_sym_specialized_md_value_token1] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(895),
  },
  [453] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(715),
    [aux_sym_number_token2] = ACTIONS(715),
    [anon_sym_private] = ACTIONS(715),
    [anon_sym_internal] = ACTIONS(715),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(715),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(715),
    [anon_sym_available_externally] = ACTIONS(715),
    [anon_sym_appending] = ACTIONS(715),
    [anon_sym_common] = ACTIONS(715),
    [anon_sym_extern_weak] = ACTIONS(715),
    [anon_sym_external] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(715),
    [anon_sym_allocsize] = ACTIONS(715),
    [anon_sym_alwaysinline] = ACTIONS(715),
    [anon_sym_builtin] = ACTIONS(715),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(715),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(715),
    [anon_sym_hot] = ACTIONS(715),
    [anon_sym_inaccessiblememonly] = ACTIONS(715),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(715),
    [anon_sym_inlinehint] = ACTIONS(715),
    [anon_sym_jumptable] = ACTIONS(715),
    [anon_sym_minsize] = ACTIONS(715),
    [anon_sym_naked] = ACTIONS(715),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(715),
    [anon_sym_nobuiltin] = ACTIONS(715),
    [anon_sym_noduplicate] = ACTIONS(715),
    [anon_sym_nofree] = ACTIONS(715),
    [anon_sym_noimplicitfloat] = ACTIONS(715),
    [anon_sym_noinline] = ACTIONS(715),
    [anon_sym_nomerge] = ACTIONS(715),
    [anon_sym_nonlazybind] = ACTIONS(715),
    [anon_sym_noprofile] = ACTIONS(715),
    [anon_sym_noredzone] = ACTIONS(715),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(715),
    [anon_sym_noreturn] = ACTIONS(715),
    [anon_sym_norecurse] = ACTIONS(715),
    [anon_sym_willreturn] = ACTIONS(715),
    [anon_sym_nosync] = ACTIONS(715),
    [anon_sym_nounwind] = ACTIONS(715),
    [anon_sym_nosanitize_coverage] = ACTIONS(715),
    [anon_sym_null_pointer_is_valid] = ACTIONS(715),
    [anon_sym_optforfuzzing] = ACTIONS(715),
    [anon_sym_optnone] = ACTIONS(715),
    [anon_sym_optsize] = ACTIONS(715),
    [anon_sym_readnone] = ACTIONS(715),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_writeonly] = ACTIONS(715),
    [anon_sym_argmemonly] = ACTIONS(715),
    [anon_sym_returns_twice] = ACTIONS(715),
    [anon_sym_safestack] = ACTIONS(715),
    [anon_sym_sanitize_address] = ACTIONS(715),
    [anon_sym_sanitize_memory] = ACTIONS(715),
    [anon_sym_sanitize_thread] = ACTIONS(715),
    [anon_sym_sanitize_hwaddress] = ACTIONS(715),
    [anon_sym_sanitize_memtag] = ACTIONS(715),
    [anon_sym_speculative_load_hardening] = ACTIONS(715),
    [anon_sym_speculatable] = ACTIONS(715),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(715),
    [anon_sym_sspreq] = ACTIONS(715),
    [anon_sym_strictfp] = ACTIONS(715),
    [anon_sym_uwtable] = ACTIONS(715),
    [anon_sym_nocf_check] = ACTIONS(715),
    [anon_sym_shadowcallstack] = ACTIONS(715),
    [anon_sym_mustprogress] = ACTIONS(715),
    [anon_sym_vscale_range] = ACTIONS(715),
    [anon_sym_preallocated] = ACTIONS(715),
    [anon_sym_zeroext] = ACTIONS(715),
    [anon_sym_signext] = ACTIONS(715),
    [anon_sym_inreg] = ACTIONS(715),
    [anon_sym_byval] = ACTIONS(715),
    [anon_sym_byref] = ACTIONS(715),
    [anon_sym_inalloca] = ACTIONS(715),
    [anon_sym_sret] = ACTIONS(715),
    [anon_sym_elementtype] = ACTIONS(715),
    [anon_sym_noalias] = ACTIONS(715),
    [anon_sym_nocapture] = ACTIONS(715),
    [anon_sym_nest] = ACTIONS(715),
    [anon_sym_returned] = ACTIONS(715),
    [anon_sym_nonnull] = ACTIONS(715),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(715),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(715),
    [anon_sym_noundef] = ACTIONS(715),
    [aux_sym_specialized_md_value_token1] = ACTIONS(715),
    [anon_sym_COLON] = ACTIONS(713),
  },
  [454] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [aux_sym_number_token1] = ACTIONS(691),
    [aux_sym_number_token2] = ACTIONS(691),
    [anon_sym_private] = ACTIONS(691),
    [anon_sym_internal] = ACTIONS(691),
    [anon_sym_weak] = ACTIONS(691),
    [anon_sym_weak_odr] = ACTIONS(691),
    [anon_sym_linkonce] = ACTIONS(691),
    [anon_sym_linkonce_odr] = ACTIONS(691),
    [anon_sym_available_externally] = ACTIONS(691),
    [anon_sym_appending] = ACTIONS(691),
    [anon_sym_common] = ACTIONS(691),
    [anon_sym_extern_weak] = ACTIONS(691),
    [anon_sym_external] = ACTIONS(691),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(691),
    [anon_sym_allocsize] = ACTIONS(691),
    [anon_sym_alwaysinline] = ACTIONS(691),
    [anon_sym_builtin] = ACTIONS(691),
    [anon_sym_cold] = ACTIONS(691),
    [anon_sym_convergent] = ACTIONS(691),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(691),
    [anon_sym_hot] = ACTIONS(691),
    [anon_sym_inaccessiblememonly] = ACTIONS(691),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(691),
    [anon_sym_inlinehint] = ACTIONS(691),
    [anon_sym_jumptable] = ACTIONS(691),
    [anon_sym_minsize] = ACTIONS(691),
    [anon_sym_naked] = ACTIONS(691),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(691),
    [anon_sym_nobuiltin] = ACTIONS(691),
    [anon_sym_noduplicate] = ACTIONS(691),
    [anon_sym_nofree] = ACTIONS(691),
    [anon_sym_noimplicitfloat] = ACTIONS(691),
    [anon_sym_noinline] = ACTIONS(691),
    [anon_sym_nomerge] = ACTIONS(691),
    [anon_sym_nonlazybind] = ACTIONS(691),
    [anon_sym_noprofile] = ACTIONS(691),
    [anon_sym_noredzone] = ACTIONS(691),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(691),
    [anon_sym_noreturn] = ACTIONS(691),
    [anon_sym_norecurse] = ACTIONS(691),
    [anon_sym_willreturn] = ACTIONS(691),
    [anon_sym_nosync] = ACTIONS(691),
    [anon_sym_nounwind] = ACTIONS(691),
    [anon_sym_nosanitize_coverage] = ACTIONS(691),
    [anon_sym_null_pointer_is_valid] = ACTIONS(691),
    [anon_sym_optforfuzzing] = ACTIONS(691),
    [anon_sym_optnone] = ACTIONS(691),
    [anon_sym_optsize] = ACTIONS(691),
    [anon_sym_readnone] = ACTIONS(691),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_writeonly] = ACTIONS(691),
    [anon_sym_argmemonly] = ACTIONS(691),
    [anon_sym_returns_twice] = ACTIONS(691),
    [anon_sym_safestack] = ACTIONS(691),
    [anon_sym_sanitize_address] = ACTIONS(691),
    [anon_sym_sanitize_memory] = ACTIONS(691),
    [anon_sym_sanitize_thread] = ACTIONS(691),
    [anon_sym_sanitize_hwaddress] = ACTIONS(691),
    [anon_sym_sanitize_memtag] = ACTIONS(691),
    [anon_sym_speculative_load_hardening] = ACTIONS(691),
    [anon_sym_speculatable] = ACTIONS(691),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(691),
    [anon_sym_sspreq] = ACTIONS(691),
    [anon_sym_strictfp] = ACTIONS(691),
    [anon_sym_uwtable] = ACTIONS(691),
    [anon_sym_nocf_check] = ACTIONS(691),
    [anon_sym_shadowcallstack] = ACTIONS(691),
    [anon_sym_mustprogress] = ACTIONS(691),
    [anon_sym_vscale_range] = ACTIONS(691),
    [anon_sym_preallocated] = ACTIONS(691),
    [anon_sym_zeroext] = ACTIONS(691),
    [anon_sym_signext] = ACTIONS(691),
    [anon_sym_inreg] = ACTIONS(691),
    [anon_sym_byval] = ACTIONS(691),
    [anon_sym_byref] = ACTIONS(691),
    [anon_sym_inalloca] = ACTIONS(691),
    [anon_sym_sret] = ACTIONS(691),
    [anon_sym_elementtype] = ACTIONS(691),
    [anon_sym_noalias] = ACTIONS(691),
    [anon_sym_nocapture] = ACTIONS(691),
    [anon_sym_nest] = ACTIONS(691),
    [anon_sym_returned] = ACTIONS(691),
    [anon_sym_nonnull] = ACTIONS(691),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(691),
    [anon_sym_swiftself] = ACTIONS(691),
    [anon_sym_swiftasync] = ACTIONS(691),
    [anon_sym_swifterror] = ACTIONS(691),
    [anon_sym_immarg] = ACTIONS(691),
    [anon_sym_noundef] = ACTIONS(691),
    [aux_sym_specialized_md_value_token1] = ACTIONS(691),
    [anon_sym_COLON] = ACTIONS(689),
  },
  [455] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1612),
    [sym_string] = ACTIONS(1612),
    [aux_sym_number_token1] = ACTIONS(1614),
    [aux_sym_number_token2] = ACTIONS(1614),
    [anon_sym_private] = ACTIONS(1614),
    [anon_sym_internal] = ACTIONS(1614),
    [anon_sym_weak] = ACTIONS(1614),
    [anon_sym_weak_odr] = ACTIONS(1614),
    [anon_sym_linkonce] = ACTIONS(1614),
    [anon_sym_linkonce_odr] = ACTIONS(1614),
    [anon_sym_available_externally] = ACTIONS(1614),
    [anon_sym_appending] = ACTIONS(1614),
    [anon_sym_common] = ACTIONS(1614),
    [anon_sym_extern_weak] = ACTIONS(1614),
    [anon_sym_external] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1612),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [anon_sym_COMMA] = ACTIONS(1612),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_RPAREN] = ACTIONS(1612),
    [anon_sym_align] = ACTIONS(1614),
    [anon_sym_alignstack] = ACTIONS(1614),
    [anon_sym_allocsize] = ACTIONS(1614),
    [anon_sym_alwaysinline] = ACTIONS(1614),
    [anon_sym_builtin] = ACTIONS(1614),
    [anon_sym_cold] = ACTIONS(1614),
    [anon_sym_convergent] = ACTIONS(1614),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1614),
    [anon_sym_hot] = ACTIONS(1614),
    [anon_sym_inaccessiblememonly] = ACTIONS(1614),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1614),
    [anon_sym_inlinehint] = ACTIONS(1614),
    [anon_sym_jumptable] = ACTIONS(1614),
    [anon_sym_minsize] = ACTIONS(1614),
    [anon_sym_naked] = ACTIONS(1614),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1614),
    [anon_sym_nobuiltin] = ACTIONS(1614),
    [anon_sym_noduplicate] = ACTIONS(1614),
    [anon_sym_nofree] = ACTIONS(1614),
    [anon_sym_noimplicitfloat] = ACTIONS(1614),
    [anon_sym_noinline] = ACTIONS(1614),
    [anon_sym_nomerge] = ACTIONS(1614),
    [anon_sym_nonlazybind] = ACTIONS(1614),
    [anon_sym_noprofile] = ACTIONS(1614),
    [anon_sym_noredzone] = ACTIONS(1614),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1614),
    [anon_sym_noreturn] = ACTIONS(1614),
    [anon_sym_norecurse] = ACTIONS(1614),
    [anon_sym_willreturn] = ACTIONS(1614),
    [anon_sym_nosync] = ACTIONS(1614),
    [anon_sym_nounwind] = ACTIONS(1614),
    [anon_sym_nosanitize_coverage] = ACTIONS(1614),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1614),
    [anon_sym_optforfuzzing] = ACTIONS(1614),
    [anon_sym_optnone] = ACTIONS(1614),
    [anon_sym_optsize] = ACTIONS(1614),
    [anon_sym_readnone] = ACTIONS(1614),
    [anon_sym_readonly] = ACTIONS(1614),
    [anon_sym_writeonly] = ACTIONS(1614),
    [anon_sym_argmemonly] = ACTIONS(1614),
    [anon_sym_returns_twice] = ACTIONS(1614),
    [anon_sym_safestack] = ACTIONS(1614),
    [anon_sym_sanitize_address] = ACTIONS(1614),
    [anon_sym_sanitize_memory] = ACTIONS(1614),
    [anon_sym_sanitize_thread] = ACTIONS(1614),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1614),
    [anon_sym_sanitize_memtag] = ACTIONS(1614),
    [anon_sym_speculative_load_hardening] = ACTIONS(1614),
    [anon_sym_speculatable] = ACTIONS(1614),
    [anon_sym_ssp] = ACTIONS(1614),
    [anon_sym_sspstrong] = ACTIONS(1614),
    [anon_sym_sspreq] = ACTIONS(1614),
    [anon_sym_strictfp] = ACTIONS(1614),
    [anon_sym_uwtable] = ACTIONS(1614),
    [anon_sym_nocf_check] = ACTIONS(1614),
    [anon_sym_shadowcallstack] = ACTIONS(1614),
    [anon_sym_mustprogress] = ACTIONS(1614),
    [anon_sym_vscale_range] = ACTIONS(1614),
    [anon_sym_preallocated] = ACTIONS(1614),
    [anon_sym_zeroext] = ACTIONS(1614),
    [anon_sym_signext] = ACTIONS(1614),
    [anon_sym_inreg] = ACTIONS(1614),
    [anon_sym_byval] = ACTIONS(1614),
    [anon_sym_byref] = ACTIONS(1614),
    [anon_sym_inalloca] = ACTIONS(1614),
    [anon_sym_sret] = ACTIONS(1614),
    [anon_sym_elementtype] = ACTIONS(1614),
    [anon_sym_noalias] = ACTIONS(1614),
    [anon_sym_nocapture] = ACTIONS(1614),
    [anon_sym_nest] = ACTIONS(1614),
    [anon_sym_returned] = ACTIONS(1614),
    [anon_sym_nonnull] = ACTIONS(1614),
    [anon_sym_dereferenceable] = ACTIONS(1614),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1614),
    [anon_sym_swiftself] = ACTIONS(1614),
    [anon_sym_swiftasync] = ACTIONS(1614),
    [anon_sym_swifterror] = ACTIONS(1614),
    [anon_sym_immarg] = ACTIONS(1614),
    [anon_sym_noundef] = ACTIONS(1614),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1614),
    [anon_sym_COLON] = ACTIONS(1612),
  },
  [456] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1616),
    [sym_string] = ACTIONS(1616),
    [aux_sym_number_token1] = ACTIONS(1618),
    [aux_sym_number_token2] = ACTIONS(1618),
    [anon_sym_private] = ACTIONS(1618),
    [anon_sym_internal] = ACTIONS(1618),
    [anon_sym_weak] = ACTIONS(1618),
    [anon_sym_weak_odr] = ACTIONS(1618),
    [anon_sym_linkonce] = ACTIONS(1618),
    [anon_sym_linkonce_odr] = ACTIONS(1618),
    [anon_sym_available_externally] = ACTIONS(1618),
    [anon_sym_appending] = ACTIONS(1618),
    [anon_sym_common] = ACTIONS(1618),
    [anon_sym_extern_weak] = ACTIONS(1618),
    [anon_sym_external] = ACTIONS(1618),
    [anon_sym_LBRACK] = ACTIONS(1616),
    [anon_sym_RBRACK] = ACTIONS(1616),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1618),
    [anon_sym_alignstack] = ACTIONS(1618),
    [anon_sym_allocsize] = ACTIONS(1618),
    [anon_sym_alwaysinline] = ACTIONS(1618),
    [anon_sym_builtin] = ACTIONS(1618),
    [anon_sym_cold] = ACTIONS(1618),
    [anon_sym_convergent] = ACTIONS(1618),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1618),
    [anon_sym_hot] = ACTIONS(1618),
    [anon_sym_inaccessiblememonly] = ACTIONS(1618),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1618),
    [anon_sym_inlinehint] = ACTIONS(1618),
    [anon_sym_jumptable] = ACTIONS(1618),
    [anon_sym_minsize] = ACTIONS(1618),
    [anon_sym_naked] = ACTIONS(1618),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1618),
    [anon_sym_nobuiltin] = ACTIONS(1618),
    [anon_sym_noduplicate] = ACTIONS(1618),
    [anon_sym_nofree] = ACTIONS(1618),
    [anon_sym_noimplicitfloat] = ACTIONS(1618),
    [anon_sym_noinline] = ACTIONS(1618),
    [anon_sym_nomerge] = ACTIONS(1618),
    [anon_sym_nonlazybind] = ACTIONS(1618),
    [anon_sym_noprofile] = ACTIONS(1618),
    [anon_sym_noredzone] = ACTIONS(1618),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1618),
    [anon_sym_noreturn] = ACTIONS(1618),
    [anon_sym_norecurse] = ACTIONS(1618),
    [anon_sym_willreturn] = ACTIONS(1618),
    [anon_sym_nosync] = ACTIONS(1618),
    [anon_sym_nounwind] = ACTIONS(1618),
    [anon_sym_nosanitize_coverage] = ACTIONS(1618),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1618),
    [anon_sym_optforfuzzing] = ACTIONS(1618),
    [anon_sym_optnone] = ACTIONS(1618),
    [anon_sym_optsize] = ACTIONS(1618),
    [anon_sym_readnone] = ACTIONS(1618),
    [anon_sym_readonly] = ACTIONS(1618),
    [anon_sym_writeonly] = ACTIONS(1618),
    [anon_sym_argmemonly] = ACTIONS(1618),
    [anon_sym_returns_twice] = ACTIONS(1618),
    [anon_sym_safestack] = ACTIONS(1618),
    [anon_sym_sanitize_address] = ACTIONS(1618),
    [anon_sym_sanitize_memory] = ACTIONS(1618),
    [anon_sym_sanitize_thread] = ACTIONS(1618),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1618),
    [anon_sym_sanitize_memtag] = ACTIONS(1618),
    [anon_sym_speculative_load_hardening] = ACTIONS(1618),
    [anon_sym_speculatable] = ACTIONS(1618),
    [anon_sym_ssp] = ACTIONS(1618),
    [anon_sym_sspstrong] = ACTIONS(1618),
    [anon_sym_sspreq] = ACTIONS(1618),
    [anon_sym_strictfp] = ACTIONS(1618),
    [anon_sym_uwtable] = ACTIONS(1618),
    [anon_sym_nocf_check] = ACTIONS(1618),
    [anon_sym_shadowcallstack] = ACTIONS(1618),
    [anon_sym_mustprogress] = ACTIONS(1618),
    [anon_sym_vscale_range] = ACTIONS(1618),
    [anon_sym_preallocated] = ACTIONS(1618),
    [anon_sym_zeroext] = ACTIONS(1618),
    [anon_sym_signext] = ACTIONS(1618),
    [anon_sym_inreg] = ACTIONS(1618),
    [anon_sym_byval] = ACTIONS(1618),
    [anon_sym_byref] = ACTIONS(1618),
    [anon_sym_inalloca] = ACTIONS(1618),
    [anon_sym_sret] = ACTIONS(1618),
    [anon_sym_elementtype] = ACTIONS(1618),
    [anon_sym_noalias] = ACTIONS(1618),
    [anon_sym_nocapture] = ACTIONS(1618),
    [anon_sym_nest] = ACTIONS(1618),
    [anon_sym_returned] = ACTIONS(1618),
    [anon_sym_nonnull] = ACTIONS(1618),
    [anon_sym_dereferenceable] = ACTIONS(1618),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1618),
    [anon_sym_swiftself] = ACTIONS(1618),
    [anon_sym_swiftasync] = ACTIONS(1618),
    [anon_sym_swifterror] = ACTIONS(1618),
    [anon_sym_immarg] = ACTIONS(1618),
    [anon_sym_noundef] = ACTIONS(1618),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1618),
    [anon_sym_COLON] = ACTIONS(1616),
  },
  [457] = {
    [sym_unnamed_addr] = STATE(462),
    [sym_addrspace] = STATE(501),
    [sym_attribute] = STATE(497),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(497),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1383),
    [sym_string] = ACTIONS(1367),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [458] = {
    [sym_unnamed_addr] = STATE(465),
    [sym_addrspace] = STATE(483),
    [sym_attribute] = STATE(482),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(482),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1396),
    [sym_string] = ACTIONS(1367),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [459] = {
    [sym_unnamed_addr] = STATE(464),
    [sym_addrspace] = STATE(487),
    [sym_attribute] = STATE(479),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(479),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1379),
    [sym_string] = ACTIONS(1367),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [460] = {
    [sym_unnamed_addr] = STATE(463),
    [sym_addrspace] = STATE(488),
    [sym_attribute] = STATE(489),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(489),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1365),
    [sym_string] = ACTIONS(1367),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [461] = {
    [sym_unnamed_addr] = STATE(466),
    [sym_addrspace] = STATE(500),
    [sym_attribute] = STATE(506),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(506),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1400),
    [sym_string] = ACTIONS(1367),
    [anon_sym_unnamed_addr] = ACTIONS(747),
    [anon_sym_local_unnamed_addr] = ACTIONS(747),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [462] = {
    [sym_addrspace] = STATE(486),
    [sym_attribute] = STATE(485),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(485),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [463] = {
    [sym_addrspace] = STATE(492),
    [sym_attribute] = STATE(491),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(491),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [464] = {
    [sym_addrspace] = STATE(493),
    [sym_attribute] = STATE(494),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(494),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [465] = {
    [sym_addrspace] = STATE(478),
    [sym_attribute] = STATE(498),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(498),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [466] = {
    [sym_addrspace] = STATE(504),
    [sym_attribute] = STATE(503),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(503),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_addrspace] = ACTIONS(899),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [467] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1610),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(480),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(717),
  },
  [468] = {
    [sym_attribute] = STATE(476),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1609),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(476),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(725),
  },
  [469] = {
    [sym_attribute] = STATE(474),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1596),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(474),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(729),
  },
  [470] = {
    [sym_attribute] = STATE(467),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1633),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(467),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(733),
  },
  [471] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1625),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(480),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(753),
  },
  [472] = {
    [sym_attribute] = STATE(471),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1718),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(471),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(749),
  },
  [473] = {
    [sym_addrspace] = STATE(527),
    [sym_argument_list] = STATE(477),
    [aux_sym_type_repeat1] = STATE(499),
    [aux_sym_type_repeat2] = STATE(477),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE_GT] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(234),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(234),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
  },
  [474] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1588),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(480),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(721),
  },
  [475] = {
    [sym_addrspace] = STATE(1515),
    [sym_argument_list] = STATE(475),
    [aux_sym_type_repeat1] = STATE(1120),
    [aux_sym_type_repeat2] = STATE(475),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [476] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(399),
    [sym_operand_bundles] = STATE(1598),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(480),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1624),
    [anon_sym_prologue] = ACTIONS(1624),
    [anon_sym_personality] = ACTIONS(1624),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_to] = ACTIONS(695),
  },
  [477] = {
    [sym_addrspace] = STATE(530),
    [sym_argument_list] = STATE(475),
    [aux_sym_type_repeat1] = STATE(490),
    [aux_sym_type_repeat2] = STATE(475),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [478] = {
    [sym_attribute] = STATE(505),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(505),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1570),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [479] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [480] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(480),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1510),
    [sym_string] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_align] = ACTIONS(1513),
    [anon_sym_section] = ACTIONS(1516),
    [anon_sym_partition] = ACTIONS(1516),
    [anon_sym_comdat] = ACTIONS(1519),
    [anon_sym_gc] = ACTIONS(1516),
    [anon_sym_prefix] = ACTIONS(1640),
    [anon_sym_prologue] = ACTIONS(1640),
    [anon_sym_personality] = ACTIONS(1640),
    [anon_sym_alignstack] = ACTIONS(1525),
    [anon_sym_allocsize] = ACTIONS(1525),
    [anon_sym_alwaysinline] = ACTIONS(1525),
    [anon_sym_builtin] = ACTIONS(1525),
    [anon_sym_cold] = ACTIONS(1525),
    [anon_sym_convergent] = ACTIONS(1525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1525),
    [anon_sym_hot] = ACTIONS(1525),
    [anon_sym_inaccessiblememonly] = ACTIONS(1525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1525),
    [anon_sym_inlinehint] = ACTIONS(1525),
    [anon_sym_jumptable] = ACTIONS(1525),
    [anon_sym_minsize] = ACTIONS(1525),
    [anon_sym_naked] = ACTIONS(1525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1525),
    [anon_sym_nobuiltin] = ACTIONS(1525),
    [anon_sym_noduplicate] = ACTIONS(1525),
    [anon_sym_nofree] = ACTIONS(1525),
    [anon_sym_noimplicitfloat] = ACTIONS(1525),
    [anon_sym_noinline] = ACTIONS(1525),
    [anon_sym_nomerge] = ACTIONS(1525),
    [anon_sym_nonlazybind] = ACTIONS(1525),
    [anon_sym_noprofile] = ACTIONS(1525),
    [anon_sym_noredzone] = ACTIONS(1525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [anon_sym_norecurse] = ACTIONS(1525),
    [anon_sym_willreturn] = ACTIONS(1525),
    [anon_sym_nosync] = ACTIONS(1525),
    [anon_sym_nounwind] = ACTIONS(1525),
    [anon_sym_nosanitize_coverage] = ACTIONS(1525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1525),
    [anon_sym_optforfuzzing] = ACTIONS(1525),
    [anon_sym_optnone] = ACTIONS(1525),
    [anon_sym_optsize] = ACTIONS(1525),
    [anon_sym_readnone] = ACTIONS(1525),
    [anon_sym_readonly] = ACTIONS(1525),
    [anon_sym_writeonly] = ACTIONS(1525),
    [anon_sym_argmemonly] = ACTIONS(1525),
    [anon_sym_returns_twice] = ACTIONS(1525),
    [anon_sym_safestack] = ACTIONS(1525),
    [anon_sym_sanitize_address] = ACTIONS(1525),
    [anon_sym_sanitize_memory] = ACTIONS(1525),
    [anon_sym_sanitize_thread] = ACTIONS(1525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1525),
    [anon_sym_sanitize_memtag] = ACTIONS(1525),
    [anon_sym_speculative_load_hardening] = ACTIONS(1525),
    [anon_sym_speculatable] = ACTIONS(1525),
    [anon_sym_ssp] = ACTIONS(1528),
    [anon_sym_sspstrong] = ACTIONS(1525),
    [anon_sym_sspreq] = ACTIONS(1525),
    [anon_sym_strictfp] = ACTIONS(1525),
    [anon_sym_uwtable] = ACTIONS(1525),
    [anon_sym_nocf_check] = ACTIONS(1525),
    [anon_sym_shadowcallstack] = ACTIONS(1525),
    [anon_sym_mustprogress] = ACTIONS(1525),
    [anon_sym_vscale_range] = ACTIONS(1525),
    [anon_sym_preallocated] = ACTIONS(1525),
    [anon_sym_zeroext] = ACTIONS(1525),
    [anon_sym_signext] = ACTIONS(1525),
    [anon_sym_inreg] = ACTIONS(1525),
    [anon_sym_byval] = ACTIONS(1525),
    [anon_sym_byref] = ACTIONS(1525),
    [anon_sym_inalloca] = ACTIONS(1525),
    [anon_sym_sret] = ACTIONS(1525),
    [anon_sym_elementtype] = ACTIONS(1525),
    [anon_sym_noalias] = ACTIONS(1525),
    [anon_sym_nocapture] = ACTIONS(1525),
    [anon_sym_nest] = ACTIONS(1525),
    [anon_sym_returned] = ACTIONS(1525),
    [anon_sym_nonnull] = ACTIONS(1525),
    [anon_sym_dereferenceable] = ACTIONS(1528),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1525),
    [anon_sym_swiftself] = ACTIONS(1525),
    [anon_sym_swiftasync] = ACTIONS(1525),
    [anon_sym_swifterror] = ACTIONS(1525),
    [anon_sym_immarg] = ACTIONS(1525),
    [anon_sym_noundef] = ACTIONS(1525),
    [anon_sym_to] = ACTIONS(760),
  },
  [481] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1494),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [482] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [483] = {
    [sym_attribute] = STATE(498),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(498),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1462),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [484] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1502),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [485] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1506),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [486] = {
    [sym_attribute] = STATE(496),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(496),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1506),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [487] = {
    [sym_attribute] = STATE(494),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(494),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1450),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [488] = {
    [sym_attribute] = STATE(491),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(491),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [489] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1444),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [490] = {
    [sym_addrspace] = STATE(528),
    [sym_argument_list] = STATE(523),
    [aux_sym_type_repeat1] = STATE(510),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [491] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1574),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [492] = {
    [sym_attribute] = STATE(484),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(484),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1574),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [493] = {
    [sym_attribute] = STATE(481),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(481),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1531),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [494] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1531),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [495] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1510),
    [aux_sym_metadata_ref_token1] = ACTIONS(760),
    [sym_string] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_align] = ACTIONS(1513),
    [anon_sym_section] = ACTIONS(1516),
    [anon_sym_partition] = ACTIONS(1516),
    [anon_sym_comdat] = ACTIONS(1519),
    [anon_sym_gc] = ACTIONS(1516),
    [anon_sym_prefix] = ACTIONS(1645),
    [anon_sym_prologue] = ACTIONS(1645),
    [anon_sym_personality] = ACTIONS(1645),
    [anon_sym_alignstack] = ACTIONS(1525),
    [anon_sym_allocsize] = ACTIONS(1525),
    [anon_sym_alwaysinline] = ACTIONS(1525),
    [anon_sym_builtin] = ACTIONS(1525),
    [anon_sym_cold] = ACTIONS(1525),
    [anon_sym_convergent] = ACTIONS(1525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1525),
    [anon_sym_hot] = ACTIONS(1525),
    [anon_sym_inaccessiblememonly] = ACTIONS(1525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1525),
    [anon_sym_inlinehint] = ACTIONS(1525),
    [anon_sym_jumptable] = ACTIONS(1525),
    [anon_sym_minsize] = ACTIONS(1525),
    [anon_sym_naked] = ACTIONS(1525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1525),
    [anon_sym_nobuiltin] = ACTIONS(1525),
    [anon_sym_noduplicate] = ACTIONS(1525),
    [anon_sym_nofree] = ACTIONS(1525),
    [anon_sym_noimplicitfloat] = ACTIONS(1525),
    [anon_sym_noinline] = ACTIONS(1525),
    [anon_sym_nomerge] = ACTIONS(1525),
    [anon_sym_nonlazybind] = ACTIONS(1525),
    [anon_sym_noprofile] = ACTIONS(1525),
    [anon_sym_noredzone] = ACTIONS(1525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [anon_sym_norecurse] = ACTIONS(1525),
    [anon_sym_willreturn] = ACTIONS(1525),
    [anon_sym_nosync] = ACTIONS(1525),
    [anon_sym_nounwind] = ACTIONS(1525),
    [anon_sym_nosanitize_coverage] = ACTIONS(1525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1525),
    [anon_sym_optforfuzzing] = ACTIONS(1525),
    [anon_sym_optnone] = ACTIONS(1525),
    [anon_sym_optsize] = ACTIONS(1525),
    [anon_sym_readnone] = ACTIONS(1525),
    [anon_sym_readonly] = ACTIONS(1525),
    [anon_sym_writeonly] = ACTIONS(1525),
    [anon_sym_argmemonly] = ACTIONS(1525),
    [anon_sym_returns_twice] = ACTIONS(1525),
    [anon_sym_safestack] = ACTIONS(1525),
    [anon_sym_sanitize_address] = ACTIONS(1525),
    [anon_sym_sanitize_memory] = ACTIONS(1525),
    [anon_sym_sanitize_thread] = ACTIONS(1525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1525),
    [anon_sym_sanitize_memtag] = ACTIONS(1525),
    [anon_sym_speculative_load_hardening] = ACTIONS(1525),
    [anon_sym_speculatable] = ACTIONS(1525),
    [anon_sym_ssp] = ACTIONS(1528),
    [anon_sym_sspstrong] = ACTIONS(1525),
    [anon_sym_sspreq] = ACTIONS(1525),
    [anon_sym_strictfp] = ACTIONS(1525),
    [anon_sym_uwtable] = ACTIONS(1525),
    [anon_sym_nocf_check] = ACTIONS(1525),
    [anon_sym_shadowcallstack] = ACTIONS(1525),
    [anon_sym_mustprogress] = ACTIONS(1525),
    [anon_sym_vscale_range] = ACTIONS(1525),
    [anon_sym_preallocated] = ACTIONS(1525),
    [anon_sym_zeroext] = ACTIONS(1525),
    [anon_sym_signext] = ACTIONS(1525),
    [anon_sym_inreg] = ACTIONS(1525),
    [anon_sym_byval] = ACTIONS(1525),
    [anon_sym_byref] = ACTIONS(1525),
    [anon_sym_inalloca] = ACTIONS(1525),
    [anon_sym_sret] = ACTIONS(1525),
    [anon_sym_elementtype] = ACTIONS(1525),
    [anon_sym_noalias] = ACTIONS(1525),
    [anon_sym_nocapture] = ACTIONS(1525),
    [anon_sym_nest] = ACTIONS(1525),
    [anon_sym_returned] = ACTIONS(1525),
    [anon_sym_nonnull] = ACTIONS(1525),
    [anon_sym_dereferenceable] = ACTIONS(1528),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1525),
    [anon_sym_swiftself] = ACTIONS(1525),
    [anon_sym_swiftasync] = ACTIONS(1525),
    [anon_sym_swifterror] = ACTIONS(1525),
    [anon_sym_immarg] = ACTIONS(1525),
    [anon_sym_noundef] = ACTIONS(1525),
  },
  [496] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1566),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [497] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [498] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1570),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [499] = {
    [sym_addrspace] = STATE(530),
    [sym_argument_list] = STATE(523),
    [aux_sym_type_repeat1] = STATE(510),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [500] = {
    [sym_attribute] = STATE(503),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(503),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [501] = {
    [sym_attribute] = STATE(485),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(485),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1458),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [502] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1498),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [503] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1539),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [504] = {
    [sym_attribute] = STATE(502),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(502),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1539),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [505] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1535),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [506] = {
    [sym_attribute] = STATE(495),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(495),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(1454),
    [sym_string] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1620),
    [anon_sym_prologue] = ACTIONS(1620),
    [anon_sym_personality] = ACTIONS(1620),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [507] = {
    [sym_attribute] = STATE(511),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(511),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1650),
    [anon_sym_prologue] = ACTIONS(1650),
    [anon_sym_personality] = ACTIONS(1650),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [508] = {
    [sym_attribute] = STATE(507),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(507),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1650),
    [anon_sym_prologue] = ACTIONS(1650),
    [anon_sym_personality] = ACTIONS(1650),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [509] = {
    [sym_metadata_name] = STATE(711),
    [sym_attribute] = STATE(448),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [aux_sym_metadata_ref_token1] = ACTIONS(739),
    [sym_string] = ACTIONS(1367),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [510] = {
    [sym_addrspace] = STATE(1464),
    [aux_sym_type_repeat1] = STATE(510),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(1654),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [511] = {
    [sym_attribute] = STATE(511),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [aux_sym_function_header_repeat3] = STATE(511),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1510),
    [sym_string] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_align] = ACTIONS(1513),
    [anon_sym_section] = ACTIONS(1516),
    [anon_sym_partition] = ACTIONS(1516),
    [anon_sym_comdat] = ACTIONS(1519),
    [anon_sym_gc] = ACTIONS(1516),
    [anon_sym_prefix] = ACTIONS(1657),
    [anon_sym_prologue] = ACTIONS(1657),
    [anon_sym_personality] = ACTIONS(1657),
    [anon_sym_alignstack] = ACTIONS(1525),
    [anon_sym_allocsize] = ACTIONS(1525),
    [anon_sym_alwaysinline] = ACTIONS(1525),
    [anon_sym_builtin] = ACTIONS(1525),
    [anon_sym_cold] = ACTIONS(1525),
    [anon_sym_convergent] = ACTIONS(1525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1525),
    [anon_sym_hot] = ACTIONS(1525),
    [anon_sym_inaccessiblememonly] = ACTIONS(1525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1525),
    [anon_sym_inlinehint] = ACTIONS(1525),
    [anon_sym_jumptable] = ACTIONS(1525),
    [anon_sym_minsize] = ACTIONS(1525),
    [anon_sym_naked] = ACTIONS(1525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1525),
    [anon_sym_nobuiltin] = ACTIONS(1525),
    [anon_sym_noduplicate] = ACTIONS(1525),
    [anon_sym_nofree] = ACTIONS(1525),
    [anon_sym_noimplicitfloat] = ACTIONS(1525),
    [anon_sym_noinline] = ACTIONS(1525),
    [anon_sym_nomerge] = ACTIONS(1525),
    [anon_sym_nonlazybind] = ACTIONS(1525),
    [anon_sym_noprofile] = ACTIONS(1525),
    [anon_sym_noredzone] = ACTIONS(1525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1525),
    [anon_sym_noreturn] = ACTIONS(1525),
    [anon_sym_norecurse] = ACTIONS(1525),
    [anon_sym_willreturn] = ACTIONS(1525),
    [anon_sym_nosync] = ACTIONS(1525),
    [anon_sym_nounwind] = ACTIONS(1525),
    [anon_sym_nosanitize_coverage] = ACTIONS(1525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1525),
    [anon_sym_optforfuzzing] = ACTIONS(1525),
    [anon_sym_optnone] = ACTIONS(1525),
    [anon_sym_optsize] = ACTIONS(1525),
    [anon_sym_readnone] = ACTIONS(1525),
    [anon_sym_readonly] = ACTIONS(1525),
    [anon_sym_writeonly] = ACTIONS(1525),
    [anon_sym_argmemonly] = ACTIONS(1525),
    [anon_sym_returns_twice] = ACTIONS(1525),
    [anon_sym_safestack] = ACTIONS(1525),
    [anon_sym_sanitize_address] = ACTIONS(1525),
    [anon_sym_sanitize_memory] = ACTIONS(1525),
    [anon_sym_sanitize_thread] = ACTIONS(1525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1525),
    [anon_sym_sanitize_memtag] = ACTIONS(1525),
    [anon_sym_speculative_load_hardening] = ACTIONS(1525),
    [anon_sym_speculatable] = ACTIONS(1525),
    [anon_sym_ssp] = ACTIONS(1528),
    [anon_sym_sspstrong] = ACTIONS(1525),
    [anon_sym_sspreq] = ACTIONS(1525),
    [anon_sym_strictfp] = ACTIONS(1525),
    [anon_sym_uwtable] = ACTIONS(1525),
    [anon_sym_nocf_check] = ACTIONS(1525),
    [anon_sym_shadowcallstack] = ACTIONS(1525),
    [anon_sym_mustprogress] = ACTIONS(1525),
    [anon_sym_vscale_range] = ACTIONS(1525),
    [anon_sym_preallocated] = ACTIONS(1525),
    [anon_sym_zeroext] = ACTIONS(1525),
    [anon_sym_signext] = ACTIONS(1525),
    [anon_sym_inreg] = ACTIONS(1525),
    [anon_sym_byval] = ACTIONS(1525),
    [anon_sym_byref] = ACTIONS(1525),
    [anon_sym_inalloca] = ACTIONS(1525),
    [anon_sym_sret] = ACTIONS(1525),
    [anon_sym_elementtype] = ACTIONS(1525),
    [anon_sym_noalias] = ACTIONS(1525),
    [anon_sym_nocapture] = ACTIONS(1525),
    [anon_sym_nest] = ACTIONS(1525),
    [anon_sym_returned] = ACTIONS(1525),
    [anon_sym_nonnull] = ACTIONS(1525),
    [anon_sym_dereferenceable] = ACTIONS(1528),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1525),
    [anon_sym_swiftself] = ACTIONS(1525),
    [anon_sym_swiftasync] = ACTIONS(1525),
    [anon_sym_swifterror] = ACTIONS(1525),
    [anon_sym_immarg] = ACTIONS(1525),
    [anon_sym_noundef] = ACTIONS(1525),
  },
  [512] = {
    [sym_type] = STATE(655),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_constant_expr] = STATE(390),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1660),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [513] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(303),
    [sym_local_var] = ACTIONS(303),
    [sym_string] = ACTIONS(303),
    [aux_sym_number_token1] = ACTIONS(305),
    [aux_sym_number_token2] = ACTIONS(303),
    [sym_float] = ACTIONS(303),
    [sym_cstring] = ACTIONS(303),
    [anon_sym_no_cfi] = ACTIONS(303),
    [anon_sym_private] = ACTIONS(303),
    [anon_sym_internal] = ACTIONS(303),
    [anon_sym_weak] = ACTIONS(305),
    [anon_sym_weak_odr] = ACTIONS(303),
    [anon_sym_linkonce] = ACTIONS(305),
    [anon_sym_linkonce_odr] = ACTIONS(303),
    [anon_sym_available_externally] = ACTIONS(303),
    [anon_sym_appending] = ACTIONS(303),
    [anon_sym_common] = ACTIONS(303),
    [anon_sym_extern_weak] = ACTIONS(303),
    [anon_sym_external] = ACTIONS(303),
    [anon_sym_dso_local] = ACTIONS(305),
    [anon_sym_dso_local_equivalent] = ACTIONS(303),
    [anon_sym_dso_preemptable] = ACTIONS(303),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_hidden] = ACTIONS(303),
    [anon_sym_protected] = ACTIONS(303),
    [anon_sym_dllimport] = ACTIONS(303),
    [anon_sym_dllexport] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LT_LBRACE] = ACTIONS(303),
    [anon_sym_RBRACE_GT] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_addrspace] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_extractelement] = ACTIONS(303),
    [anon_sym_insertelement] = ACTIONS(303),
    [anon_sym_select] = ACTIONS(303),
    [anon_sym_shufflevector] = ACTIONS(303),
    [anon_sym_fneg] = ACTIONS(303),
    [anon_sym_icmp] = ACTIONS(303),
    [anon_sym_fcmp] = ACTIONS(303),
    [anon_sym_getelementptr] = ACTIONS(303),
    [anon_sym_extractvalue] = ACTIONS(303),
    [anon_sym_insertvalue] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_null] = ACTIONS(303),
    [anon_sym_none] = ACTIONS(303),
    [anon_sym_undef] = ACTIONS(303),
    [anon_sym_poison] = ACTIONS(303),
    [anon_sym_zeroinitializer] = ACTIONS(303),
    [anon_sym_blockaddress] = ACTIONS(303),
    [anon_sym_mul] = ACTIONS(303),
    [anon_sym_urem] = ACTIONS(303),
    [anon_sym_srem] = ACTIONS(303),
    [anon_sym_shl] = ACTIONS(303),
    [anon_sym_udiv] = ACTIONS(303),
    [anon_sym_sdiv] = ACTIONS(303),
    [anon_sym_lshr] = ACTIONS(303),
    [anon_sym_ashr] = ACTIONS(303),
    [anon_sym_fmul] = ACTIONS(303),
    [anon_sym_fdiv] = ACTIONS(303),
    [anon_sym_frem] = ACTIONS(303),
    [anon_sym_xchg] = ACTIONS(303),
    [anon_sym_add] = ACTIONS(305),
    [anon_sym_sub] = ACTIONS(303),
    [anon_sym_and] = ACTIONS(303),
    [anon_sym_nand] = ACTIONS(303),
    [anon_sym_or] = ACTIONS(303),
    [anon_sym_xor] = ACTIONS(303),
    [anon_sym_max] = ACTIONS(303),
    [anon_sym_min] = ACTIONS(303),
    [anon_sym_umax] = ACTIONS(303),
    [anon_sym_umin] = ACTIONS(303),
    [anon_sym_fadd] = ACTIONS(303),
    [anon_sym_fsub] = ACTIONS(303),
    [anon_sym_bitcast] = ACTIONS(303),
    [anon_sym_trunc] = ACTIONS(303),
    [anon_sym_zext] = ACTIONS(303),
    [anon_sym_sext] = ACTIONS(303),
    [anon_sym_fptrunc] = ACTIONS(303),
    [anon_sym_fpext] = ACTIONS(303),
    [anon_sym_addrspacecast] = ACTIONS(303),
    [anon_sym_uitofp] = ACTIONS(303),
    [anon_sym_sitofp] = ACTIONS(303),
    [anon_sym_fptoui] = ACTIONS(303),
    [anon_sym_fptosi] = ACTIONS(303),
    [anon_sym_inttoptr] = ACTIONS(303),
    [anon_sym_ptrtoint] = ACTIONS(303),
  },
  [514] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE_GT] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(279),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
  },
  [515] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(295),
    [sym_local_var] = ACTIONS(295),
    [sym_string] = ACTIONS(295),
    [aux_sym_number_token1] = ACTIONS(297),
    [aux_sym_number_token2] = ACTIONS(295),
    [sym_float] = ACTIONS(295),
    [sym_cstring] = ACTIONS(295),
    [anon_sym_no_cfi] = ACTIONS(295),
    [anon_sym_private] = ACTIONS(295),
    [anon_sym_internal] = ACTIONS(295),
    [anon_sym_weak] = ACTIONS(297),
    [anon_sym_weak_odr] = ACTIONS(295),
    [anon_sym_linkonce] = ACTIONS(297),
    [anon_sym_linkonce_odr] = ACTIONS(295),
    [anon_sym_available_externally] = ACTIONS(295),
    [anon_sym_appending] = ACTIONS(295),
    [anon_sym_common] = ACTIONS(295),
    [anon_sym_extern_weak] = ACTIONS(295),
    [anon_sym_external] = ACTIONS(295),
    [anon_sym_dso_local] = ACTIONS(297),
    [anon_sym_dso_local_equivalent] = ACTIONS(295),
    [anon_sym_dso_preemptable] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(295),
    [anon_sym_hidden] = ACTIONS(295),
    [anon_sym_protected] = ACTIONS(295),
    [anon_sym_dllimport] = ACTIONS(295),
    [anon_sym_dllexport] = ACTIONS(295),
    [anon_sym_STAR] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE_GT] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(295),
    [anon_sym_addrspace] = ACTIONS(297),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_extractelement] = ACTIONS(295),
    [anon_sym_insertelement] = ACTIONS(295),
    [anon_sym_select] = ACTIONS(295),
    [anon_sym_shufflevector] = ACTIONS(295),
    [anon_sym_fneg] = ACTIONS(295),
    [anon_sym_icmp] = ACTIONS(295),
    [anon_sym_fcmp] = ACTIONS(295),
    [anon_sym_getelementptr] = ACTIONS(295),
    [anon_sym_extractvalue] = ACTIONS(295),
    [anon_sym_insertvalue] = ACTIONS(295),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [anon_sym_null] = ACTIONS(295),
    [anon_sym_none] = ACTIONS(295),
    [anon_sym_undef] = ACTIONS(295),
    [anon_sym_poison] = ACTIONS(295),
    [anon_sym_zeroinitializer] = ACTIONS(295),
    [anon_sym_blockaddress] = ACTIONS(295),
    [anon_sym_mul] = ACTIONS(295),
    [anon_sym_urem] = ACTIONS(295),
    [anon_sym_srem] = ACTIONS(295),
    [anon_sym_shl] = ACTIONS(295),
    [anon_sym_udiv] = ACTIONS(295),
    [anon_sym_sdiv] = ACTIONS(295),
    [anon_sym_lshr] = ACTIONS(295),
    [anon_sym_ashr] = ACTIONS(295),
    [anon_sym_fmul] = ACTIONS(295),
    [anon_sym_fdiv] = ACTIONS(295),
    [anon_sym_frem] = ACTIONS(295),
    [anon_sym_xchg] = ACTIONS(295),
    [anon_sym_add] = ACTIONS(297),
    [anon_sym_sub] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(295),
    [anon_sym_nand] = ACTIONS(295),
    [anon_sym_or] = ACTIONS(295),
    [anon_sym_xor] = ACTIONS(295),
    [anon_sym_max] = ACTIONS(295),
    [anon_sym_min] = ACTIONS(295),
    [anon_sym_umax] = ACTIONS(295),
    [anon_sym_umin] = ACTIONS(295),
    [anon_sym_fadd] = ACTIONS(295),
    [anon_sym_fsub] = ACTIONS(295),
    [anon_sym_bitcast] = ACTIONS(295),
    [anon_sym_trunc] = ACTIONS(295),
    [anon_sym_zext] = ACTIONS(295),
    [anon_sym_sext] = ACTIONS(295),
    [anon_sym_fptrunc] = ACTIONS(295),
    [anon_sym_fpext] = ACTIONS(295),
    [anon_sym_addrspacecast] = ACTIONS(295),
    [anon_sym_uitofp] = ACTIONS(295),
    [anon_sym_sitofp] = ACTIONS(295),
    [anon_sym_fptoui] = ACTIONS(295),
    [anon_sym_fptosi] = ACTIONS(295),
    [anon_sym_inttoptr] = ACTIONS(295),
    [anon_sym_ptrtoint] = ACTIONS(295),
  },
  [516] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(291),
    [sym_local_var] = ACTIONS(291),
    [sym_string] = ACTIONS(291),
    [aux_sym_number_token1] = ACTIONS(293),
    [aux_sym_number_token2] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_cstring] = ACTIONS(291),
    [anon_sym_no_cfi] = ACTIONS(291),
    [anon_sym_private] = ACTIONS(291),
    [anon_sym_internal] = ACTIONS(291),
    [anon_sym_weak] = ACTIONS(293),
    [anon_sym_weak_odr] = ACTIONS(291),
    [anon_sym_linkonce] = ACTIONS(293),
    [anon_sym_linkonce_odr] = ACTIONS(291),
    [anon_sym_available_externally] = ACTIONS(291),
    [anon_sym_appending] = ACTIONS(291),
    [anon_sym_common] = ACTIONS(291),
    [anon_sym_extern_weak] = ACTIONS(291),
    [anon_sym_external] = ACTIONS(291),
    [anon_sym_dso_local] = ACTIONS(293),
    [anon_sym_dso_local_equivalent] = ACTIONS(291),
    [anon_sym_dso_preemptable] = ACTIONS(291),
    [anon_sym_default] = ACTIONS(291),
    [anon_sym_hidden] = ACTIONS(291),
    [anon_sym_protected] = ACTIONS(291),
    [anon_sym_dllimport] = ACTIONS(291),
    [anon_sym_dllexport] = ACTIONS(291),
    [anon_sym_STAR] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_LT_LBRACE] = ACTIONS(291),
    [anon_sym_RBRACE_GT] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_addrspace] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(291),
    [anon_sym_extractelement] = ACTIONS(291),
    [anon_sym_insertelement] = ACTIONS(291),
    [anon_sym_select] = ACTIONS(291),
    [anon_sym_shufflevector] = ACTIONS(291),
    [anon_sym_fneg] = ACTIONS(291),
    [anon_sym_icmp] = ACTIONS(291),
    [anon_sym_fcmp] = ACTIONS(291),
    [anon_sym_getelementptr] = ACTIONS(291),
    [anon_sym_extractvalue] = ACTIONS(291),
    [anon_sym_insertvalue] = ACTIONS(291),
    [anon_sym_true] = ACTIONS(291),
    [anon_sym_false] = ACTIONS(291),
    [anon_sym_null] = ACTIONS(291),
    [anon_sym_none] = ACTIONS(291),
    [anon_sym_undef] = ACTIONS(291),
    [anon_sym_poison] = ACTIONS(291),
    [anon_sym_zeroinitializer] = ACTIONS(291),
    [anon_sym_blockaddress] = ACTIONS(291),
    [anon_sym_mul] = ACTIONS(291),
    [anon_sym_urem] = ACTIONS(291),
    [anon_sym_srem] = ACTIONS(291),
    [anon_sym_shl] = ACTIONS(291),
    [anon_sym_udiv] = ACTIONS(291),
    [anon_sym_sdiv] = ACTIONS(291),
    [anon_sym_lshr] = ACTIONS(291),
    [anon_sym_ashr] = ACTIONS(291),
    [anon_sym_fmul] = ACTIONS(291),
    [anon_sym_fdiv] = ACTIONS(291),
    [anon_sym_frem] = ACTIONS(291),
    [anon_sym_xchg] = ACTIONS(291),
    [anon_sym_add] = ACTIONS(293),
    [anon_sym_sub] = ACTIONS(291),
    [anon_sym_and] = ACTIONS(291),
    [anon_sym_nand] = ACTIONS(291),
    [anon_sym_or] = ACTIONS(291),
    [anon_sym_xor] = ACTIONS(291),
    [anon_sym_max] = ACTIONS(291),
    [anon_sym_min] = ACTIONS(291),
    [anon_sym_umax] = ACTIONS(291),
    [anon_sym_umin] = ACTIONS(291),
    [anon_sym_fadd] = ACTIONS(291),
    [anon_sym_fsub] = ACTIONS(291),
    [anon_sym_bitcast] = ACTIONS(291),
    [anon_sym_trunc] = ACTIONS(291),
    [anon_sym_zext] = ACTIONS(291),
    [anon_sym_sext] = ACTIONS(291),
    [anon_sym_fptrunc] = ACTIONS(291),
    [anon_sym_fpext] = ACTIONS(291),
    [anon_sym_addrspacecast] = ACTIONS(291),
    [anon_sym_uitofp] = ACTIONS(291),
    [anon_sym_sitofp] = ACTIONS(291),
    [anon_sym_fptoui] = ACTIONS(291),
    [anon_sym_fptosi] = ACTIONS(291),
    [anon_sym_inttoptr] = ACTIONS(291),
    [anon_sym_ptrtoint] = ACTIONS(291),
  },
  [517] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(299),
    [sym_local_var] = ACTIONS(299),
    [sym_string] = ACTIONS(299),
    [aux_sym_number_token1] = ACTIONS(301),
    [aux_sym_number_token2] = ACTIONS(299),
    [sym_float] = ACTIONS(299),
    [sym_cstring] = ACTIONS(299),
    [anon_sym_no_cfi] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_internal] = ACTIONS(299),
    [anon_sym_weak] = ACTIONS(301),
    [anon_sym_weak_odr] = ACTIONS(299),
    [anon_sym_linkonce] = ACTIONS(301),
    [anon_sym_linkonce_odr] = ACTIONS(299),
    [anon_sym_available_externally] = ACTIONS(299),
    [anon_sym_appending] = ACTIONS(299),
    [anon_sym_common] = ACTIONS(299),
    [anon_sym_extern_weak] = ACTIONS(299),
    [anon_sym_external] = ACTIONS(299),
    [anon_sym_dso_local] = ACTIONS(301),
    [anon_sym_dso_local_equivalent] = ACTIONS(299),
    [anon_sym_dso_preemptable] = ACTIONS(299),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_hidden] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_dllimport] = ACTIONS(299),
    [anon_sym_dllexport] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_LT_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE_GT] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(299),
    [anon_sym_extractelement] = ACTIONS(299),
    [anon_sym_insertelement] = ACTIONS(299),
    [anon_sym_select] = ACTIONS(299),
    [anon_sym_shufflevector] = ACTIONS(299),
    [anon_sym_fneg] = ACTIONS(299),
    [anon_sym_icmp] = ACTIONS(299),
    [anon_sym_fcmp] = ACTIONS(299),
    [anon_sym_getelementptr] = ACTIONS(299),
    [anon_sym_extractvalue] = ACTIONS(299),
    [anon_sym_insertvalue] = ACTIONS(299),
    [anon_sym_true] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_none] = ACTIONS(299),
    [anon_sym_undef] = ACTIONS(299),
    [anon_sym_poison] = ACTIONS(299),
    [anon_sym_zeroinitializer] = ACTIONS(299),
    [anon_sym_blockaddress] = ACTIONS(299),
    [anon_sym_mul] = ACTIONS(299),
    [anon_sym_urem] = ACTIONS(299),
    [anon_sym_srem] = ACTIONS(299),
    [anon_sym_shl] = ACTIONS(299),
    [anon_sym_udiv] = ACTIONS(299),
    [anon_sym_sdiv] = ACTIONS(299),
    [anon_sym_lshr] = ACTIONS(299),
    [anon_sym_ashr] = ACTIONS(299),
    [anon_sym_fmul] = ACTIONS(299),
    [anon_sym_fdiv] = ACTIONS(299),
    [anon_sym_frem] = ACTIONS(299),
    [anon_sym_xchg] = ACTIONS(299),
    [anon_sym_add] = ACTIONS(301),
    [anon_sym_sub] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(299),
    [anon_sym_nand] = ACTIONS(299),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_xor] = ACTIONS(299),
    [anon_sym_max] = ACTIONS(299),
    [anon_sym_min] = ACTIONS(299),
    [anon_sym_umax] = ACTIONS(299),
    [anon_sym_umin] = ACTIONS(299),
    [anon_sym_fadd] = ACTIONS(299),
    [anon_sym_fsub] = ACTIONS(299),
    [anon_sym_bitcast] = ACTIONS(299),
    [anon_sym_trunc] = ACTIONS(299),
    [anon_sym_zext] = ACTIONS(299),
    [anon_sym_sext] = ACTIONS(299),
    [anon_sym_fptrunc] = ACTIONS(299),
    [anon_sym_fpext] = ACTIONS(299),
    [anon_sym_addrspacecast] = ACTIONS(299),
    [anon_sym_uitofp] = ACTIONS(299),
    [anon_sym_sitofp] = ACTIONS(299),
    [anon_sym_fptoui] = ACTIONS(299),
    [anon_sym_fptosi] = ACTIONS(299),
    [anon_sym_inttoptr] = ACTIONS(299),
    [anon_sym_ptrtoint] = ACTIONS(299),
  },
  [518] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(283),
    [sym_local_var] = ACTIONS(283),
    [sym_string] = ACTIONS(283),
    [aux_sym_number_token1] = ACTIONS(285),
    [aux_sym_number_token2] = ACTIONS(283),
    [sym_float] = ACTIONS(283),
    [sym_cstring] = ACTIONS(283),
    [anon_sym_no_cfi] = ACTIONS(283),
    [anon_sym_private] = ACTIONS(283),
    [anon_sym_internal] = ACTIONS(283),
    [anon_sym_weak] = ACTIONS(285),
    [anon_sym_weak_odr] = ACTIONS(283),
    [anon_sym_linkonce] = ACTIONS(285),
    [anon_sym_linkonce_odr] = ACTIONS(283),
    [anon_sym_available_externally] = ACTIONS(283),
    [anon_sym_appending] = ACTIONS(283),
    [anon_sym_common] = ACTIONS(283),
    [anon_sym_extern_weak] = ACTIONS(283),
    [anon_sym_external] = ACTIONS(283),
    [anon_sym_dso_local] = ACTIONS(285),
    [anon_sym_dso_local_equivalent] = ACTIONS(283),
    [anon_sym_dso_preemptable] = ACTIONS(283),
    [anon_sym_default] = ACTIONS(283),
    [anon_sym_hidden] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(283),
    [anon_sym_dllimport] = ACTIONS(283),
    [anon_sym_dllexport] = ACTIONS(283),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LT_LBRACE] = ACTIONS(283),
    [anon_sym_RBRACE_GT] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(283),
    [anon_sym_addrspace] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(283),
    [anon_sym_extractelement] = ACTIONS(283),
    [anon_sym_insertelement] = ACTIONS(283),
    [anon_sym_select] = ACTIONS(283),
    [anon_sym_shufflevector] = ACTIONS(283),
    [anon_sym_fneg] = ACTIONS(283),
    [anon_sym_icmp] = ACTIONS(283),
    [anon_sym_fcmp] = ACTIONS(283),
    [anon_sym_getelementptr] = ACTIONS(283),
    [anon_sym_extractvalue] = ACTIONS(283),
    [anon_sym_insertvalue] = ACTIONS(283),
    [anon_sym_true] = ACTIONS(283),
    [anon_sym_false] = ACTIONS(283),
    [anon_sym_null] = ACTIONS(283),
    [anon_sym_none] = ACTIONS(283),
    [anon_sym_undef] = ACTIONS(283),
    [anon_sym_poison] = ACTIONS(283),
    [anon_sym_zeroinitializer] = ACTIONS(283),
    [anon_sym_blockaddress] = ACTIONS(283),
    [anon_sym_mul] = ACTIONS(283),
    [anon_sym_urem] = ACTIONS(283),
    [anon_sym_srem] = ACTIONS(283),
    [anon_sym_shl] = ACTIONS(283),
    [anon_sym_udiv] = ACTIONS(283),
    [anon_sym_sdiv] = ACTIONS(283),
    [anon_sym_lshr] = ACTIONS(283),
    [anon_sym_ashr] = ACTIONS(283),
    [anon_sym_fmul] = ACTIONS(283),
    [anon_sym_fdiv] = ACTIONS(283),
    [anon_sym_frem] = ACTIONS(283),
    [anon_sym_xchg] = ACTIONS(283),
    [anon_sym_add] = ACTIONS(285),
    [anon_sym_sub] = ACTIONS(283),
    [anon_sym_and] = ACTIONS(283),
    [anon_sym_nand] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(283),
    [anon_sym_xor] = ACTIONS(283),
    [anon_sym_max] = ACTIONS(283),
    [anon_sym_min] = ACTIONS(283),
    [anon_sym_umax] = ACTIONS(283),
    [anon_sym_umin] = ACTIONS(283),
    [anon_sym_fadd] = ACTIONS(283),
    [anon_sym_fsub] = ACTIONS(283),
    [anon_sym_bitcast] = ACTIONS(283),
    [anon_sym_trunc] = ACTIONS(283),
    [anon_sym_zext] = ACTIONS(283),
    [anon_sym_sext] = ACTIONS(283),
    [anon_sym_fptrunc] = ACTIONS(283),
    [anon_sym_fpext] = ACTIONS(283),
    [anon_sym_addrspacecast] = ACTIONS(283),
    [anon_sym_uitofp] = ACTIONS(283),
    [anon_sym_sitofp] = ACTIONS(283),
    [anon_sym_fptoui] = ACTIONS(283),
    [anon_sym_fptosi] = ACTIONS(283),
    [anon_sym_inttoptr] = ACTIONS(283),
    [anon_sym_ptrtoint] = ACTIONS(283),
  },
  [519] = {
    [sym_attribute] = STATE(448),
    [sym_attribute_name] = STATE(399),
    [sym_alignment] = STATE(410),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1367),
    [sym_string] = ACTIONS(1367),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_section] = ACTIONS(1371),
    [anon_sym_partition] = ACTIONS(1371),
    [anon_sym_comdat] = ACTIONS(1373),
    [anon_sym_gc] = ACTIONS(1371),
    [anon_sym_prefix] = ACTIONS(1375),
    [anon_sym_prologue] = ACTIONS(1375),
    [anon_sym_personality] = ACTIONS(1375),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
  },
  [520] = {
    [sym_type] = STATE(654),
    [sym_type_keyword] = STATE(238),
    [sym_struct_type] = STATE(238),
    [sym_packed_struct_type] = STATE(238),
    [sym_array_type] = STATE(238),
    [sym_vector_type] = STATE(238),
    [sym_constant_expr] = STATE(398),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1662),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [521] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
  },
  [522] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(287),
    [sym_local_var] = ACTIONS(287),
    [sym_string] = ACTIONS(287),
    [aux_sym_number_token1] = ACTIONS(289),
    [aux_sym_number_token2] = ACTIONS(287),
    [sym_float] = ACTIONS(287),
    [sym_cstring] = ACTIONS(287),
    [anon_sym_no_cfi] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_internal] = ACTIONS(287),
    [anon_sym_weak] = ACTIONS(289),
    [anon_sym_weak_odr] = ACTIONS(287),
    [anon_sym_linkonce] = ACTIONS(289),
    [anon_sym_linkonce_odr] = ACTIONS(287),
    [anon_sym_available_externally] = ACTIONS(287),
    [anon_sym_appending] = ACTIONS(287),
    [anon_sym_common] = ACTIONS(287),
    [anon_sym_extern_weak] = ACTIONS(287),
    [anon_sym_external] = ACTIONS(287),
    [anon_sym_dso_local] = ACTIONS(289),
    [anon_sym_dso_local_equivalent] = ACTIONS(287),
    [anon_sym_dso_preemptable] = ACTIONS(287),
    [anon_sym_default] = ACTIONS(287),
    [anon_sym_hidden] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_dllimport] = ACTIONS(287),
    [anon_sym_dllexport] = ACTIONS(287),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LT_LBRACE] = ACTIONS(287),
    [anon_sym_RBRACE_GT] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_addrspace] = ACTIONS(289),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_extractelement] = ACTIONS(287),
    [anon_sym_insertelement] = ACTIONS(287),
    [anon_sym_select] = ACTIONS(287),
    [anon_sym_shufflevector] = ACTIONS(287),
    [anon_sym_fneg] = ACTIONS(287),
    [anon_sym_icmp] = ACTIONS(287),
    [anon_sym_fcmp] = ACTIONS(287),
    [anon_sym_getelementptr] = ACTIONS(287),
    [anon_sym_extractvalue] = ACTIONS(287),
    [anon_sym_insertvalue] = ACTIONS(287),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(287),
    [anon_sym_none] = ACTIONS(287),
    [anon_sym_undef] = ACTIONS(287),
    [anon_sym_poison] = ACTIONS(287),
    [anon_sym_zeroinitializer] = ACTIONS(287),
    [anon_sym_blockaddress] = ACTIONS(287),
    [anon_sym_mul] = ACTIONS(287),
    [anon_sym_urem] = ACTIONS(287),
    [anon_sym_srem] = ACTIONS(287),
    [anon_sym_shl] = ACTIONS(287),
    [anon_sym_udiv] = ACTIONS(287),
    [anon_sym_sdiv] = ACTIONS(287),
    [anon_sym_lshr] = ACTIONS(287),
    [anon_sym_ashr] = ACTIONS(287),
    [anon_sym_fmul] = ACTIONS(287),
    [anon_sym_fdiv] = ACTIONS(287),
    [anon_sym_frem] = ACTIONS(287),
    [anon_sym_xchg] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(289),
    [anon_sym_sub] = ACTIONS(287),
    [anon_sym_and] = ACTIONS(287),
    [anon_sym_nand] = ACTIONS(287),
    [anon_sym_or] = ACTIONS(287),
    [anon_sym_xor] = ACTIONS(287),
    [anon_sym_max] = ACTIONS(287),
    [anon_sym_min] = ACTIONS(287),
    [anon_sym_umax] = ACTIONS(287),
    [anon_sym_umin] = ACTIONS(287),
    [anon_sym_fadd] = ACTIONS(287),
    [anon_sym_fsub] = ACTIONS(287),
    [anon_sym_bitcast] = ACTIONS(287),
    [anon_sym_trunc] = ACTIONS(287),
    [anon_sym_zext] = ACTIONS(287),
    [anon_sym_sext] = ACTIONS(287),
    [anon_sym_fptrunc] = ACTIONS(287),
    [anon_sym_fpext] = ACTIONS(287),
    [anon_sym_addrspacecast] = ACTIONS(287),
    [anon_sym_uitofp] = ACTIONS(287),
    [anon_sym_sitofp] = ACTIONS(287),
    [anon_sym_fptoui] = ACTIONS(287),
    [anon_sym_fptosi] = ACTIONS(287),
    [anon_sym_inttoptr] = ACTIONS(287),
    [anon_sym_ptrtoint] = ACTIONS(287),
  },
  [523] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [524] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [525] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(307),
    [sym_local_var] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [aux_sym_number_token1] = ACTIONS(309),
    [aux_sym_number_token2] = ACTIONS(307),
    [sym_float] = ACTIONS(307),
    [sym_cstring] = ACTIONS(307),
    [anon_sym_no_cfi] = ACTIONS(307),
    [anon_sym_private] = ACTIONS(307),
    [anon_sym_internal] = ACTIONS(307),
    [anon_sym_weak] = ACTIONS(309),
    [anon_sym_weak_odr] = ACTIONS(307),
    [anon_sym_linkonce] = ACTIONS(309),
    [anon_sym_linkonce_odr] = ACTIONS(307),
    [anon_sym_available_externally] = ACTIONS(307),
    [anon_sym_appending] = ACTIONS(307),
    [anon_sym_common] = ACTIONS(307),
    [anon_sym_extern_weak] = ACTIONS(307),
    [anon_sym_external] = ACTIONS(307),
    [anon_sym_dso_local] = ACTIONS(309),
    [anon_sym_dso_local_equivalent] = ACTIONS(307),
    [anon_sym_dso_preemptable] = ACTIONS(307),
    [anon_sym_default] = ACTIONS(307),
    [anon_sym_hidden] = ACTIONS(307),
    [anon_sym_protected] = ACTIONS(307),
    [anon_sym_dllimport] = ACTIONS(307),
    [anon_sym_dllexport] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_LT_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE_GT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(307),
    [anon_sym_addrspace] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_extractelement] = ACTIONS(307),
    [anon_sym_insertelement] = ACTIONS(307),
    [anon_sym_select] = ACTIONS(307),
    [anon_sym_shufflevector] = ACTIONS(307),
    [anon_sym_fneg] = ACTIONS(307),
    [anon_sym_icmp] = ACTIONS(307),
    [anon_sym_fcmp] = ACTIONS(307),
    [anon_sym_getelementptr] = ACTIONS(307),
    [anon_sym_extractvalue] = ACTIONS(307),
    [anon_sym_insertvalue] = ACTIONS(307),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [anon_sym_null] = ACTIONS(307),
    [anon_sym_none] = ACTIONS(307),
    [anon_sym_undef] = ACTIONS(307),
    [anon_sym_poison] = ACTIONS(307),
    [anon_sym_zeroinitializer] = ACTIONS(307),
    [anon_sym_blockaddress] = ACTIONS(307),
    [anon_sym_mul] = ACTIONS(307),
    [anon_sym_urem] = ACTIONS(307),
    [anon_sym_srem] = ACTIONS(307),
    [anon_sym_shl] = ACTIONS(307),
    [anon_sym_udiv] = ACTIONS(307),
    [anon_sym_sdiv] = ACTIONS(307),
    [anon_sym_lshr] = ACTIONS(307),
    [anon_sym_ashr] = ACTIONS(307),
    [anon_sym_fmul] = ACTIONS(307),
    [anon_sym_fdiv] = ACTIONS(307),
    [anon_sym_frem] = ACTIONS(307),
    [anon_sym_xchg] = ACTIONS(307),
    [anon_sym_add] = ACTIONS(309),
    [anon_sym_sub] = ACTIONS(307),
    [anon_sym_and] = ACTIONS(307),
    [anon_sym_nand] = ACTIONS(307),
    [anon_sym_or] = ACTIONS(307),
    [anon_sym_xor] = ACTIONS(307),
    [anon_sym_max] = ACTIONS(307),
    [anon_sym_min] = ACTIONS(307),
    [anon_sym_umax] = ACTIONS(307),
    [anon_sym_umin] = ACTIONS(307),
    [anon_sym_fadd] = ACTIONS(307),
    [anon_sym_fsub] = ACTIONS(307),
    [anon_sym_bitcast] = ACTIONS(307),
    [anon_sym_trunc] = ACTIONS(307),
    [anon_sym_zext] = ACTIONS(307),
    [anon_sym_sext] = ACTIONS(307),
    [anon_sym_fptrunc] = ACTIONS(307),
    [anon_sym_fpext] = ACTIONS(307),
    [anon_sym_addrspacecast] = ACTIONS(307),
    [anon_sym_uitofp] = ACTIONS(307),
    [anon_sym_sitofp] = ACTIONS(307),
    [anon_sym_fptoui] = ACTIONS(307),
    [anon_sym_fptosi] = ACTIONS(307),
    [anon_sym_inttoptr] = ACTIONS(307),
    [anon_sym_ptrtoint] = ACTIONS(307),
  },
  [526] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(365),
    [sym_local_var] = ACTIONS(365),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(367),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(365),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(367),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(367),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(367),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_LT_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE_GT] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_addrspace] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(367),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
  },
  [527] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [528] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(393),
    [sym_local_var] = ACTIONS(393),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(395),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(393),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(395),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(395),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(395),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_LT_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE_GT] = ACTIONS(393),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(395),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
  },
  [529] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(397),
    [sym_local_var] = ACTIONS(397),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(399),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(397),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(399),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(399),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(399),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_LT_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE_GT] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(399),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
  },
  [530] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [531] = {
    [sym_atomic_ordering] = STATE(579),
    [sym_syncscope] = STATE(532),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1666),
    [sym_label] = ACTIONS(1666),
    [anon_sym_RBRACE] = ACTIONS(1666),
    [anon_sym_COMMA] = ACTIONS(1668),
    [anon_sym_unreachable] = ACTIONS(1671),
    [anon_sym_ret] = ACTIONS(1671),
    [anon_sym_br] = ACTIONS(1671),
    [anon_sym_resume] = ACTIONS(1671),
    [anon_sym_freeze] = ACTIONS(1671),
    [anon_sym_indirectbr] = ACTIONS(1671),
    [anon_sym_extractelement] = ACTIONS(1671),
    [anon_sym_insertelement] = ACTIONS(1671),
    [anon_sym_select] = ACTIONS(1671),
    [anon_sym_shufflevector] = ACTIONS(1671),
    [anon_sym_fneg] = ACTIONS(1671),
    [anon_sym_switch] = ACTIONS(1671),
    [anon_sym_invoke] = ACTIONS(1671),
    [anon_sym_cleanupret] = ACTIONS(1671),
    [anon_sym_catchret] = ACTIONS(1671),
    [anon_sym_catchswitch] = ACTIONS(1671),
    [anon_sym_catchpad] = ACTIONS(1671),
    [anon_sym_cleanuppad] = ACTIONS(1671),
    [anon_sym_callbr] = ACTIONS(1671),
    [anon_sym_icmp] = ACTIONS(1671),
    [anon_sym_fcmp] = ACTIONS(1671),
    [anon_sym_va_arg] = ACTIONS(1671),
    [anon_sym_phi] = ACTIONS(1671),
    [anon_sym_landingpad] = ACTIONS(1671),
    [anon_sym_tail] = ACTIONS(1671),
    [anon_sym_musttail] = ACTIONS(1671),
    [anon_sym_notail] = ACTIONS(1671),
    [anon_sym_call] = ACTIONS(1671),
    [anon_sym_alloca] = ACTIONS(1671),
    [anon_sym_load] = ACTIONS(1671),
    [anon_sym_store] = ACTIONS(1671),
    [anon_sym_cmpxchg] = ACTIONS(1671),
    [anon_sym_atomicrmw] = ACTIONS(1671),
    [anon_sym_fence] = ACTIONS(1671),
    [anon_sym_getelementptr] = ACTIONS(1671),
    [anon_sym_extractvalue] = ACTIONS(1671),
    [anon_sym_insertvalue] = ACTIONS(1671),
    [anon_sym_mul] = ACTIONS(1671),
    [anon_sym_urem] = ACTIONS(1671),
    [anon_sym_srem] = ACTIONS(1671),
    [anon_sym_shl] = ACTIONS(1671),
    [anon_sym_udiv] = ACTIONS(1671),
    [anon_sym_sdiv] = ACTIONS(1671),
    [anon_sym_lshr] = ACTIONS(1671),
    [anon_sym_ashr] = ACTIONS(1671),
    [anon_sym_fmul] = ACTIONS(1671),
    [anon_sym_fdiv] = ACTIONS(1671),
    [anon_sym_frem] = ACTIONS(1671),
    [anon_sym_xchg] = ACTIONS(1671),
    [anon_sym_add] = ACTIONS(1671),
    [anon_sym_sub] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1671),
    [anon_sym_nand] = ACTIONS(1671),
    [anon_sym_or] = ACTIONS(1671),
    [anon_sym_xor] = ACTIONS(1671),
    [anon_sym_max] = ACTIONS(1671),
    [anon_sym_min] = ACTIONS(1671),
    [anon_sym_umax] = ACTIONS(1671),
    [anon_sym_umin] = ACTIONS(1671),
    [anon_sym_fadd] = ACTIONS(1671),
    [anon_sym_fsub] = ACTIONS(1671),
    [anon_sym_bitcast] = ACTIONS(1671),
    [anon_sym_trunc] = ACTIONS(1671),
    [anon_sym_zext] = ACTIONS(1671),
    [anon_sym_sext] = ACTIONS(1671),
    [anon_sym_fptrunc] = ACTIONS(1671),
    [anon_sym_fpext] = ACTIONS(1671),
    [anon_sym_addrspacecast] = ACTIONS(1671),
    [anon_sym_uitofp] = ACTIONS(1671),
    [anon_sym_sitofp] = ACTIONS(1671),
    [anon_sym_fptoui] = ACTIONS(1671),
    [anon_sym_fptosi] = ACTIONS(1671),
    [anon_sym_inttoptr] = ACTIONS(1671),
    [anon_sym_ptrtoint] = ACTIONS(1671),
    [anon_sym_unordered] = ACTIONS(1673),
    [anon_sym_monotonic] = ACTIONS(1673),
    [anon_sym_acquire] = ACTIONS(1673),
    [anon_sym_release] = ACTIONS(1673),
    [anon_sym_acq_rel] = ACTIONS(1673),
    [anon_sym_seq_cst] = ACTIONS(1673),
    [anon_sym_syncscope] = ACTIONS(1675),
    [anon_sym_uselistorder] = ACTIONS(1671),
  },
  [532] = {
    [sym_atomic_ordering] = STATE(653),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1677),
    [sym_label] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_unreachable] = ACTIONS(1682),
    [anon_sym_ret] = ACTIONS(1682),
    [anon_sym_br] = ACTIONS(1682),
    [anon_sym_resume] = ACTIONS(1682),
    [anon_sym_freeze] = ACTIONS(1682),
    [anon_sym_indirectbr] = ACTIONS(1682),
    [anon_sym_extractelement] = ACTIONS(1682),
    [anon_sym_insertelement] = ACTIONS(1682),
    [anon_sym_select] = ACTIONS(1682),
    [anon_sym_shufflevector] = ACTIONS(1682),
    [anon_sym_fneg] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_invoke] = ACTIONS(1682),
    [anon_sym_cleanupret] = ACTIONS(1682),
    [anon_sym_catchret] = ACTIONS(1682),
    [anon_sym_catchswitch] = ACTIONS(1682),
    [anon_sym_catchpad] = ACTIONS(1682),
    [anon_sym_cleanuppad] = ACTIONS(1682),
    [anon_sym_callbr] = ACTIONS(1682),
    [anon_sym_icmp] = ACTIONS(1682),
    [anon_sym_fcmp] = ACTIONS(1682),
    [anon_sym_va_arg] = ACTIONS(1682),
    [anon_sym_phi] = ACTIONS(1682),
    [anon_sym_landingpad] = ACTIONS(1682),
    [anon_sym_tail] = ACTIONS(1682),
    [anon_sym_musttail] = ACTIONS(1682),
    [anon_sym_notail] = ACTIONS(1682),
    [anon_sym_call] = ACTIONS(1682),
    [anon_sym_alloca] = ACTIONS(1682),
    [anon_sym_load] = ACTIONS(1682),
    [anon_sym_store] = ACTIONS(1682),
    [anon_sym_cmpxchg] = ACTIONS(1682),
    [anon_sym_atomicrmw] = ACTIONS(1682),
    [anon_sym_fence] = ACTIONS(1682),
    [anon_sym_getelementptr] = ACTIONS(1682),
    [anon_sym_extractvalue] = ACTIONS(1682),
    [anon_sym_insertvalue] = ACTIONS(1682),
    [anon_sym_mul] = ACTIONS(1682),
    [anon_sym_urem] = ACTIONS(1682),
    [anon_sym_srem] = ACTIONS(1682),
    [anon_sym_shl] = ACTIONS(1682),
    [anon_sym_udiv] = ACTIONS(1682),
    [anon_sym_sdiv] = ACTIONS(1682),
    [anon_sym_lshr] = ACTIONS(1682),
    [anon_sym_ashr] = ACTIONS(1682),
    [anon_sym_fmul] = ACTIONS(1682),
    [anon_sym_fdiv] = ACTIONS(1682),
    [anon_sym_frem] = ACTIONS(1682),
    [anon_sym_xchg] = ACTIONS(1682),
    [anon_sym_add] = ACTIONS(1682),
    [anon_sym_sub] = ACTIONS(1682),
    [anon_sym_and] = ACTIONS(1682),
    [anon_sym_nand] = ACTIONS(1682),
    [anon_sym_or] = ACTIONS(1682),
    [anon_sym_xor] = ACTIONS(1682),
    [anon_sym_max] = ACTIONS(1682),
    [anon_sym_min] = ACTIONS(1682),
    [anon_sym_umax] = ACTIONS(1682),
    [anon_sym_umin] = ACTIONS(1682),
    [anon_sym_fadd] = ACTIONS(1682),
    [anon_sym_fsub] = ACTIONS(1682),
    [anon_sym_bitcast] = ACTIONS(1682),
    [anon_sym_trunc] = ACTIONS(1682),
    [anon_sym_zext] = ACTIONS(1682),
    [anon_sym_sext] = ACTIONS(1682),
    [anon_sym_fptrunc] = ACTIONS(1682),
    [anon_sym_fpext] = ACTIONS(1682),
    [anon_sym_addrspacecast] = ACTIONS(1682),
    [anon_sym_uitofp] = ACTIONS(1682),
    [anon_sym_sitofp] = ACTIONS(1682),
    [anon_sym_fptoui] = ACTIONS(1682),
    [anon_sym_fptosi] = ACTIONS(1682),
    [anon_sym_inttoptr] = ACTIONS(1682),
    [anon_sym_ptrtoint] = ACTIONS(1682),
    [anon_sym_unordered] = ACTIONS(1673),
    [anon_sym_monotonic] = ACTIONS(1673),
    [anon_sym_acquire] = ACTIONS(1673),
    [anon_sym_release] = ACTIONS(1673),
    [anon_sym_acq_rel] = ACTIONS(1673),
    [anon_sym_seq_cst] = ACTIONS(1673),
    [anon_sym_uselistorder] = ACTIONS(1682),
  },
  [533] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1684),
    [sym_label] = ACTIONS(1684),
    [anon_sym_RBRACE] = ACTIONS(1684),
    [anon_sym_COMMA] = ACTIONS(1684),
    [anon_sym_unreachable] = ACTIONS(1686),
    [anon_sym_ret] = ACTIONS(1686),
    [anon_sym_br] = ACTIONS(1686),
    [anon_sym_resume] = ACTIONS(1686),
    [anon_sym_freeze] = ACTIONS(1686),
    [anon_sym_indirectbr] = ACTIONS(1686),
    [anon_sym_extractelement] = ACTIONS(1686),
    [anon_sym_insertelement] = ACTIONS(1686),
    [anon_sym_select] = ACTIONS(1686),
    [anon_sym_shufflevector] = ACTIONS(1686),
    [anon_sym_fneg] = ACTIONS(1686),
    [anon_sym_switch] = ACTIONS(1686),
    [anon_sym_invoke] = ACTIONS(1686),
    [anon_sym_cleanupret] = ACTIONS(1686),
    [anon_sym_catchret] = ACTIONS(1686),
    [anon_sym_catchswitch] = ACTIONS(1686),
    [anon_sym_catchpad] = ACTIONS(1686),
    [anon_sym_cleanuppad] = ACTIONS(1686),
    [anon_sym_callbr] = ACTIONS(1686),
    [anon_sym_icmp] = ACTIONS(1686),
    [anon_sym_fcmp] = ACTIONS(1686),
    [anon_sym_va_arg] = ACTIONS(1686),
    [anon_sym_phi] = ACTIONS(1686),
    [anon_sym_landingpad] = ACTIONS(1686),
    [anon_sym_tail] = ACTIONS(1686),
    [anon_sym_musttail] = ACTIONS(1686),
    [anon_sym_notail] = ACTIONS(1686),
    [anon_sym_call] = ACTIONS(1686),
    [anon_sym_alloca] = ACTIONS(1686),
    [anon_sym_load] = ACTIONS(1686),
    [anon_sym_store] = ACTIONS(1686),
    [anon_sym_cmpxchg] = ACTIONS(1686),
    [anon_sym_atomicrmw] = ACTIONS(1686),
    [anon_sym_fence] = ACTIONS(1686),
    [anon_sym_getelementptr] = ACTIONS(1686),
    [anon_sym_extractvalue] = ACTIONS(1686),
    [anon_sym_insertvalue] = ACTIONS(1686),
    [anon_sym_mul] = ACTIONS(1686),
    [anon_sym_urem] = ACTIONS(1686),
    [anon_sym_srem] = ACTIONS(1686),
    [anon_sym_shl] = ACTIONS(1686),
    [anon_sym_udiv] = ACTIONS(1686),
    [anon_sym_sdiv] = ACTIONS(1686),
    [anon_sym_lshr] = ACTIONS(1686),
    [anon_sym_ashr] = ACTIONS(1686),
    [anon_sym_fmul] = ACTIONS(1686),
    [anon_sym_fdiv] = ACTIONS(1686),
    [anon_sym_frem] = ACTIONS(1686),
    [anon_sym_xchg] = ACTIONS(1686),
    [anon_sym_add] = ACTIONS(1686),
    [anon_sym_sub] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1686),
    [anon_sym_nand] = ACTIONS(1686),
    [anon_sym_or] = ACTIONS(1686),
    [anon_sym_xor] = ACTIONS(1686),
    [anon_sym_max] = ACTIONS(1686),
    [anon_sym_min] = ACTIONS(1686),
    [anon_sym_umax] = ACTIONS(1686),
    [anon_sym_umin] = ACTIONS(1686),
    [anon_sym_fadd] = ACTIONS(1686),
    [anon_sym_fsub] = ACTIONS(1686),
    [anon_sym_bitcast] = ACTIONS(1686),
    [anon_sym_trunc] = ACTIONS(1686),
    [anon_sym_zext] = ACTIONS(1686),
    [anon_sym_sext] = ACTIONS(1686),
    [anon_sym_fptrunc] = ACTIONS(1686),
    [anon_sym_fpext] = ACTIONS(1686),
    [anon_sym_addrspacecast] = ACTIONS(1686),
    [anon_sym_uitofp] = ACTIONS(1686),
    [anon_sym_sitofp] = ACTIONS(1686),
    [anon_sym_fptoui] = ACTIONS(1686),
    [anon_sym_fptosi] = ACTIONS(1686),
    [anon_sym_inttoptr] = ACTIONS(1686),
    [anon_sym_ptrtoint] = ACTIONS(1686),
    [anon_sym_unordered] = ACTIONS(1686),
    [anon_sym_monotonic] = ACTIONS(1686),
    [anon_sym_acquire] = ACTIONS(1686),
    [anon_sym_release] = ACTIONS(1686),
    [anon_sym_acq_rel] = ACTIONS(1686),
    [anon_sym_seq_cst] = ACTIONS(1686),
    [anon_sym_uselistorder] = ACTIONS(1686),
  },
  [534] = {
    [sym_landingpad_clause] = STATE(535),
    [aux_sym_instruction_landingpad_repeat1] = STATE(535),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1688),
    [sym_label] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_unreachable] = ACTIONS(1690),
    [anon_sym_ret] = ACTIONS(1690),
    [anon_sym_br] = ACTIONS(1690),
    [anon_sym_resume] = ACTIONS(1690),
    [anon_sym_freeze] = ACTIONS(1690),
    [anon_sym_indirectbr] = ACTIONS(1690),
    [anon_sym_extractelement] = ACTIONS(1690),
    [anon_sym_insertelement] = ACTIONS(1690),
    [anon_sym_select] = ACTIONS(1690),
    [anon_sym_shufflevector] = ACTIONS(1690),
    [anon_sym_fneg] = ACTIONS(1690),
    [anon_sym_switch] = ACTIONS(1690),
    [anon_sym_invoke] = ACTIONS(1690),
    [anon_sym_cleanupret] = ACTIONS(1690),
    [anon_sym_catchret] = ACTIONS(1690),
    [anon_sym_catchswitch] = ACTIONS(1690),
    [anon_sym_catchpad] = ACTIONS(1690),
    [anon_sym_cleanuppad] = ACTIONS(1690),
    [anon_sym_callbr] = ACTIONS(1690),
    [anon_sym_icmp] = ACTIONS(1690),
    [anon_sym_fcmp] = ACTIONS(1690),
    [anon_sym_va_arg] = ACTIONS(1690),
    [anon_sym_phi] = ACTIONS(1690),
    [anon_sym_landingpad] = ACTIONS(1690),
    [anon_sym_tail] = ACTIONS(1690),
    [anon_sym_musttail] = ACTIONS(1690),
    [anon_sym_notail] = ACTIONS(1690),
    [anon_sym_call] = ACTIONS(1690),
    [anon_sym_alloca] = ACTIONS(1690),
    [anon_sym_load] = ACTIONS(1690),
    [anon_sym_store] = ACTIONS(1690),
    [anon_sym_cmpxchg] = ACTIONS(1690),
    [anon_sym_atomicrmw] = ACTIONS(1690),
    [anon_sym_fence] = ACTIONS(1690),
    [anon_sym_getelementptr] = ACTIONS(1690),
    [anon_sym_extractvalue] = ACTIONS(1690),
    [anon_sym_insertvalue] = ACTIONS(1690),
    [anon_sym_catch] = ACTIONS(1692),
    [anon_sym_filter] = ACTIONS(1692),
    [anon_sym_mul] = ACTIONS(1690),
    [anon_sym_urem] = ACTIONS(1690),
    [anon_sym_srem] = ACTIONS(1690),
    [anon_sym_shl] = ACTIONS(1690),
    [anon_sym_udiv] = ACTIONS(1690),
    [anon_sym_sdiv] = ACTIONS(1690),
    [anon_sym_lshr] = ACTIONS(1690),
    [anon_sym_ashr] = ACTIONS(1690),
    [anon_sym_fmul] = ACTIONS(1690),
    [anon_sym_fdiv] = ACTIONS(1690),
    [anon_sym_frem] = ACTIONS(1690),
    [anon_sym_xchg] = ACTIONS(1690),
    [anon_sym_add] = ACTIONS(1690),
    [anon_sym_sub] = ACTIONS(1690),
    [anon_sym_and] = ACTIONS(1690),
    [anon_sym_nand] = ACTIONS(1690),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_xor] = ACTIONS(1690),
    [anon_sym_max] = ACTIONS(1690),
    [anon_sym_min] = ACTIONS(1690),
    [anon_sym_umax] = ACTIONS(1690),
    [anon_sym_umin] = ACTIONS(1690),
    [anon_sym_fadd] = ACTIONS(1690),
    [anon_sym_fsub] = ACTIONS(1690),
    [anon_sym_bitcast] = ACTIONS(1690),
    [anon_sym_trunc] = ACTIONS(1690),
    [anon_sym_zext] = ACTIONS(1690),
    [anon_sym_sext] = ACTIONS(1690),
    [anon_sym_fptrunc] = ACTIONS(1690),
    [anon_sym_fpext] = ACTIONS(1690),
    [anon_sym_addrspacecast] = ACTIONS(1690),
    [anon_sym_uitofp] = ACTIONS(1690),
    [anon_sym_sitofp] = ACTIONS(1690),
    [anon_sym_fptoui] = ACTIONS(1690),
    [anon_sym_fptosi] = ACTIONS(1690),
    [anon_sym_inttoptr] = ACTIONS(1690),
    [anon_sym_ptrtoint] = ACTIONS(1690),
    [anon_sym_uselistorder] = ACTIONS(1690),
  },
  [535] = {
    [sym_landingpad_clause] = STATE(536),
    [aux_sym_instruction_landingpad_repeat1] = STATE(536),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1694),
    [sym_label] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_COMMA] = ACTIONS(1694),
    [anon_sym_unreachable] = ACTIONS(1696),
    [anon_sym_ret] = ACTIONS(1696),
    [anon_sym_br] = ACTIONS(1696),
    [anon_sym_resume] = ACTIONS(1696),
    [anon_sym_freeze] = ACTIONS(1696),
    [anon_sym_indirectbr] = ACTIONS(1696),
    [anon_sym_extractelement] = ACTIONS(1696),
    [anon_sym_insertelement] = ACTIONS(1696),
    [anon_sym_select] = ACTIONS(1696),
    [anon_sym_shufflevector] = ACTIONS(1696),
    [anon_sym_fneg] = ACTIONS(1696),
    [anon_sym_switch] = ACTIONS(1696),
    [anon_sym_invoke] = ACTIONS(1696),
    [anon_sym_cleanupret] = ACTIONS(1696),
    [anon_sym_catchret] = ACTIONS(1696),
    [anon_sym_catchswitch] = ACTIONS(1696),
    [anon_sym_catchpad] = ACTIONS(1696),
    [anon_sym_cleanuppad] = ACTIONS(1696),
    [anon_sym_callbr] = ACTIONS(1696),
    [anon_sym_icmp] = ACTIONS(1696),
    [anon_sym_fcmp] = ACTIONS(1696),
    [anon_sym_va_arg] = ACTIONS(1696),
    [anon_sym_phi] = ACTIONS(1696),
    [anon_sym_landingpad] = ACTIONS(1696),
    [anon_sym_tail] = ACTIONS(1696),
    [anon_sym_musttail] = ACTIONS(1696),
    [anon_sym_notail] = ACTIONS(1696),
    [anon_sym_call] = ACTIONS(1696),
    [anon_sym_alloca] = ACTIONS(1696),
    [anon_sym_load] = ACTIONS(1696),
    [anon_sym_store] = ACTIONS(1696),
    [anon_sym_cmpxchg] = ACTIONS(1696),
    [anon_sym_atomicrmw] = ACTIONS(1696),
    [anon_sym_fence] = ACTIONS(1696),
    [anon_sym_getelementptr] = ACTIONS(1696),
    [anon_sym_extractvalue] = ACTIONS(1696),
    [anon_sym_insertvalue] = ACTIONS(1696),
    [anon_sym_catch] = ACTIONS(1692),
    [anon_sym_filter] = ACTIONS(1692),
    [anon_sym_mul] = ACTIONS(1696),
    [anon_sym_urem] = ACTIONS(1696),
    [anon_sym_srem] = ACTIONS(1696),
    [anon_sym_shl] = ACTIONS(1696),
    [anon_sym_udiv] = ACTIONS(1696),
    [anon_sym_sdiv] = ACTIONS(1696),
    [anon_sym_lshr] = ACTIONS(1696),
    [anon_sym_ashr] = ACTIONS(1696),
    [anon_sym_fmul] = ACTIONS(1696),
    [anon_sym_fdiv] = ACTIONS(1696),
    [anon_sym_frem] = ACTIONS(1696),
    [anon_sym_xchg] = ACTIONS(1696),
    [anon_sym_add] = ACTIONS(1696),
    [anon_sym_sub] = ACTIONS(1696),
    [anon_sym_and] = ACTIONS(1696),
    [anon_sym_nand] = ACTIONS(1696),
    [anon_sym_or] = ACTIONS(1696),
    [anon_sym_xor] = ACTIONS(1696),
    [anon_sym_max] = ACTIONS(1696),
    [anon_sym_min] = ACTIONS(1696),
    [anon_sym_umax] = ACTIONS(1696),
    [anon_sym_umin] = ACTIONS(1696),
    [anon_sym_fadd] = ACTIONS(1696),
    [anon_sym_fsub] = ACTIONS(1696),
    [anon_sym_bitcast] = ACTIONS(1696),
    [anon_sym_trunc] = ACTIONS(1696),
    [anon_sym_zext] = ACTIONS(1696),
    [anon_sym_sext] = ACTIONS(1696),
    [anon_sym_fptrunc] = ACTIONS(1696),
    [anon_sym_fpext] = ACTIONS(1696),
    [anon_sym_addrspacecast] = ACTIONS(1696),
    [anon_sym_uitofp] = ACTIONS(1696),
    [anon_sym_sitofp] = ACTIONS(1696),
    [anon_sym_fptoui] = ACTIONS(1696),
    [anon_sym_fptosi] = ACTIONS(1696),
    [anon_sym_inttoptr] = ACTIONS(1696),
    [anon_sym_ptrtoint] = ACTIONS(1696),
    [anon_sym_uselistorder] = ACTIONS(1696),
  },
  [536] = {
    [sym_landingpad_clause] = STATE(536),
    [aux_sym_instruction_landingpad_repeat1] = STATE(536),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1698),
    [sym_label] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_COMMA] = ACTIONS(1698),
    [anon_sym_unreachable] = ACTIONS(1700),
    [anon_sym_ret] = ACTIONS(1700),
    [anon_sym_br] = ACTIONS(1700),
    [anon_sym_resume] = ACTIONS(1700),
    [anon_sym_freeze] = ACTIONS(1700),
    [anon_sym_indirectbr] = ACTIONS(1700),
    [anon_sym_extractelement] = ACTIONS(1700),
    [anon_sym_insertelement] = ACTIONS(1700),
    [anon_sym_select] = ACTIONS(1700),
    [anon_sym_shufflevector] = ACTIONS(1700),
    [anon_sym_fneg] = ACTIONS(1700),
    [anon_sym_switch] = ACTIONS(1700),
    [anon_sym_invoke] = ACTIONS(1700),
    [anon_sym_cleanupret] = ACTIONS(1700),
    [anon_sym_catchret] = ACTIONS(1700),
    [anon_sym_catchswitch] = ACTIONS(1700),
    [anon_sym_catchpad] = ACTIONS(1700),
    [anon_sym_cleanuppad] = ACTIONS(1700),
    [anon_sym_callbr] = ACTIONS(1700),
    [anon_sym_icmp] = ACTIONS(1700),
    [anon_sym_fcmp] = ACTIONS(1700),
    [anon_sym_va_arg] = ACTIONS(1700),
    [anon_sym_phi] = ACTIONS(1700),
    [anon_sym_landingpad] = ACTIONS(1700),
    [anon_sym_tail] = ACTIONS(1700),
    [anon_sym_musttail] = ACTIONS(1700),
    [anon_sym_notail] = ACTIONS(1700),
    [anon_sym_call] = ACTIONS(1700),
    [anon_sym_alloca] = ACTIONS(1700),
    [anon_sym_load] = ACTIONS(1700),
    [anon_sym_store] = ACTIONS(1700),
    [anon_sym_cmpxchg] = ACTIONS(1700),
    [anon_sym_atomicrmw] = ACTIONS(1700),
    [anon_sym_fence] = ACTIONS(1700),
    [anon_sym_getelementptr] = ACTIONS(1700),
    [anon_sym_extractvalue] = ACTIONS(1700),
    [anon_sym_insertvalue] = ACTIONS(1700),
    [anon_sym_catch] = ACTIONS(1702),
    [anon_sym_filter] = ACTIONS(1702),
    [anon_sym_mul] = ACTIONS(1700),
    [anon_sym_urem] = ACTIONS(1700),
    [anon_sym_srem] = ACTIONS(1700),
    [anon_sym_shl] = ACTIONS(1700),
    [anon_sym_udiv] = ACTIONS(1700),
    [anon_sym_sdiv] = ACTIONS(1700),
    [anon_sym_lshr] = ACTIONS(1700),
    [anon_sym_ashr] = ACTIONS(1700),
    [anon_sym_fmul] = ACTIONS(1700),
    [anon_sym_fdiv] = ACTIONS(1700),
    [anon_sym_frem] = ACTIONS(1700),
    [anon_sym_xchg] = ACTIONS(1700),
    [anon_sym_add] = ACTIONS(1700),
    [anon_sym_sub] = ACTIONS(1700),
    [anon_sym_and] = ACTIONS(1700),
    [anon_sym_nand] = ACTIONS(1700),
    [anon_sym_or] = ACTIONS(1700),
    [anon_sym_xor] = ACTIONS(1700),
    [anon_sym_max] = ACTIONS(1700),
    [anon_sym_min] = ACTIONS(1700),
    [anon_sym_umax] = ACTIONS(1700),
    [anon_sym_umin] = ACTIONS(1700),
    [anon_sym_fadd] = ACTIONS(1700),
    [anon_sym_fsub] = ACTIONS(1700),
    [anon_sym_bitcast] = ACTIONS(1700),
    [anon_sym_trunc] = ACTIONS(1700),
    [anon_sym_zext] = ACTIONS(1700),
    [anon_sym_sext] = ACTIONS(1700),
    [anon_sym_fptrunc] = ACTIONS(1700),
    [anon_sym_fpext] = ACTIONS(1700),
    [anon_sym_addrspacecast] = ACTIONS(1700),
    [anon_sym_uitofp] = ACTIONS(1700),
    [anon_sym_sitofp] = ACTIONS(1700),
    [anon_sym_fptoui] = ACTIONS(1700),
    [anon_sym_fptosi] = ACTIONS(1700),
    [anon_sym_inttoptr] = ACTIONS(1700),
    [anon_sym_ptrtoint] = ACTIONS(1700),
    [anon_sym_uselistorder] = ACTIONS(1700),
  },
  [537] = {
    [sym_metadata_refs] = STATE(541),
    [aux_sym_instruction_repeat1] = STATE(541),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1705),
    [sym_label] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_unreachable] = ACTIONS(1709),
    [anon_sym_ret] = ACTIONS(1709),
    [anon_sym_br] = ACTIONS(1709),
    [anon_sym_resume] = ACTIONS(1709),
    [anon_sym_freeze] = ACTIONS(1709),
    [anon_sym_indirectbr] = ACTIONS(1709),
    [anon_sym_extractelement] = ACTIONS(1709),
    [anon_sym_insertelement] = ACTIONS(1709),
    [anon_sym_select] = ACTIONS(1709),
    [anon_sym_shufflevector] = ACTIONS(1709),
    [anon_sym_fneg] = ACTIONS(1709),
    [anon_sym_switch] = ACTIONS(1709),
    [anon_sym_invoke] = ACTIONS(1709),
    [anon_sym_cleanupret] = ACTIONS(1709),
    [anon_sym_catchret] = ACTIONS(1709),
    [anon_sym_catchswitch] = ACTIONS(1709),
    [anon_sym_catchpad] = ACTIONS(1709),
    [anon_sym_cleanuppad] = ACTIONS(1709),
    [anon_sym_callbr] = ACTIONS(1709),
    [anon_sym_icmp] = ACTIONS(1709),
    [anon_sym_fcmp] = ACTIONS(1709),
    [anon_sym_va_arg] = ACTIONS(1709),
    [anon_sym_phi] = ACTIONS(1709),
    [anon_sym_landingpad] = ACTIONS(1709),
    [anon_sym_tail] = ACTIONS(1709),
    [anon_sym_musttail] = ACTIONS(1709),
    [anon_sym_notail] = ACTIONS(1709),
    [anon_sym_call] = ACTIONS(1709),
    [anon_sym_alloca] = ACTIONS(1709),
    [anon_sym_load] = ACTIONS(1709),
    [anon_sym_store] = ACTIONS(1709),
    [anon_sym_cmpxchg] = ACTIONS(1709),
    [anon_sym_atomicrmw] = ACTIONS(1709),
    [anon_sym_fence] = ACTIONS(1709),
    [anon_sym_getelementptr] = ACTIONS(1709),
    [anon_sym_extractvalue] = ACTIONS(1709),
    [anon_sym_insertvalue] = ACTIONS(1709),
    [anon_sym_mul] = ACTIONS(1709),
    [anon_sym_urem] = ACTIONS(1709),
    [anon_sym_srem] = ACTIONS(1709),
    [anon_sym_shl] = ACTIONS(1709),
    [anon_sym_udiv] = ACTIONS(1709),
    [anon_sym_sdiv] = ACTIONS(1709),
    [anon_sym_lshr] = ACTIONS(1709),
    [anon_sym_ashr] = ACTIONS(1709),
    [anon_sym_fmul] = ACTIONS(1709),
    [anon_sym_fdiv] = ACTIONS(1709),
    [anon_sym_frem] = ACTIONS(1709),
    [anon_sym_xchg] = ACTIONS(1709),
    [anon_sym_add] = ACTIONS(1709),
    [anon_sym_sub] = ACTIONS(1709),
    [anon_sym_and] = ACTIONS(1709),
    [anon_sym_nand] = ACTIONS(1709),
    [anon_sym_or] = ACTIONS(1709),
    [anon_sym_xor] = ACTIONS(1709),
    [anon_sym_max] = ACTIONS(1709),
    [anon_sym_min] = ACTIONS(1709),
    [anon_sym_umax] = ACTIONS(1709),
    [anon_sym_umin] = ACTIONS(1709),
    [anon_sym_fadd] = ACTIONS(1709),
    [anon_sym_fsub] = ACTIONS(1709),
    [anon_sym_bitcast] = ACTIONS(1709),
    [anon_sym_trunc] = ACTIONS(1709),
    [anon_sym_zext] = ACTIONS(1709),
    [anon_sym_sext] = ACTIONS(1709),
    [anon_sym_fptrunc] = ACTIONS(1709),
    [anon_sym_fpext] = ACTIONS(1709),
    [anon_sym_addrspacecast] = ACTIONS(1709),
    [anon_sym_uitofp] = ACTIONS(1709),
    [anon_sym_sitofp] = ACTIONS(1709),
    [anon_sym_fptoui] = ACTIONS(1709),
    [anon_sym_fptosi] = ACTIONS(1709),
    [anon_sym_inttoptr] = ACTIONS(1709),
    [anon_sym_ptrtoint] = ACTIONS(1709),
    [anon_sym_uselistorder] = ACTIONS(1709),
  },
  [538] = {
    [sym_metadata_refs] = STATE(540),
    [aux_sym_instruction_repeat1] = STATE(540),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1711),
    [sym_label] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_unreachable] = ACTIONS(1713),
    [anon_sym_ret] = ACTIONS(1713),
    [anon_sym_br] = ACTIONS(1713),
    [anon_sym_resume] = ACTIONS(1713),
    [anon_sym_freeze] = ACTIONS(1713),
    [anon_sym_indirectbr] = ACTIONS(1713),
    [anon_sym_extractelement] = ACTIONS(1713),
    [anon_sym_insertelement] = ACTIONS(1713),
    [anon_sym_select] = ACTIONS(1713),
    [anon_sym_shufflevector] = ACTIONS(1713),
    [anon_sym_fneg] = ACTIONS(1713),
    [anon_sym_switch] = ACTIONS(1713),
    [anon_sym_invoke] = ACTIONS(1713),
    [anon_sym_cleanupret] = ACTIONS(1713),
    [anon_sym_catchret] = ACTIONS(1713),
    [anon_sym_catchswitch] = ACTIONS(1713),
    [anon_sym_catchpad] = ACTIONS(1713),
    [anon_sym_cleanuppad] = ACTIONS(1713),
    [anon_sym_callbr] = ACTIONS(1713),
    [anon_sym_icmp] = ACTIONS(1713),
    [anon_sym_fcmp] = ACTIONS(1713),
    [anon_sym_va_arg] = ACTIONS(1713),
    [anon_sym_phi] = ACTIONS(1713),
    [anon_sym_landingpad] = ACTIONS(1713),
    [anon_sym_tail] = ACTIONS(1713),
    [anon_sym_musttail] = ACTIONS(1713),
    [anon_sym_notail] = ACTIONS(1713),
    [anon_sym_call] = ACTIONS(1713),
    [anon_sym_alloca] = ACTIONS(1713),
    [anon_sym_load] = ACTIONS(1713),
    [anon_sym_store] = ACTIONS(1713),
    [anon_sym_cmpxchg] = ACTIONS(1713),
    [anon_sym_atomicrmw] = ACTIONS(1713),
    [anon_sym_fence] = ACTIONS(1713),
    [anon_sym_getelementptr] = ACTIONS(1713),
    [anon_sym_extractvalue] = ACTIONS(1713),
    [anon_sym_insertvalue] = ACTIONS(1713),
    [anon_sym_mul] = ACTIONS(1713),
    [anon_sym_urem] = ACTIONS(1713),
    [anon_sym_srem] = ACTIONS(1713),
    [anon_sym_shl] = ACTIONS(1713),
    [anon_sym_udiv] = ACTIONS(1713),
    [anon_sym_sdiv] = ACTIONS(1713),
    [anon_sym_lshr] = ACTIONS(1713),
    [anon_sym_ashr] = ACTIONS(1713),
    [anon_sym_fmul] = ACTIONS(1713),
    [anon_sym_fdiv] = ACTIONS(1713),
    [anon_sym_frem] = ACTIONS(1713),
    [anon_sym_xchg] = ACTIONS(1713),
    [anon_sym_add] = ACTIONS(1713),
    [anon_sym_sub] = ACTIONS(1713),
    [anon_sym_and] = ACTIONS(1713),
    [anon_sym_nand] = ACTIONS(1713),
    [anon_sym_or] = ACTIONS(1713),
    [anon_sym_xor] = ACTIONS(1713),
    [anon_sym_max] = ACTIONS(1713),
    [anon_sym_min] = ACTIONS(1713),
    [anon_sym_umax] = ACTIONS(1713),
    [anon_sym_umin] = ACTIONS(1713),
    [anon_sym_fadd] = ACTIONS(1713),
    [anon_sym_fsub] = ACTIONS(1713),
    [anon_sym_bitcast] = ACTIONS(1713),
    [anon_sym_trunc] = ACTIONS(1713),
    [anon_sym_zext] = ACTIONS(1713),
    [anon_sym_sext] = ACTIONS(1713),
    [anon_sym_fptrunc] = ACTIONS(1713),
    [anon_sym_fpext] = ACTIONS(1713),
    [anon_sym_addrspacecast] = ACTIONS(1713),
    [anon_sym_uitofp] = ACTIONS(1713),
    [anon_sym_sitofp] = ACTIONS(1713),
    [anon_sym_fptoui] = ACTIONS(1713),
    [anon_sym_fptosi] = ACTIONS(1713),
    [anon_sym_inttoptr] = ACTIONS(1713),
    [anon_sym_ptrtoint] = ACTIONS(1713),
    [anon_sym_uselistorder] = ACTIONS(1713),
  },
  [539] = {
    [sym_metadata_refs] = STATE(537),
    [aux_sym_instruction_repeat1] = STATE(537),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1715),
    [sym_label] = ACTIONS(1715),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_unreachable] = ACTIONS(1717),
    [anon_sym_ret] = ACTIONS(1717),
    [anon_sym_br] = ACTIONS(1717),
    [anon_sym_resume] = ACTIONS(1717),
    [anon_sym_freeze] = ACTIONS(1717),
    [anon_sym_indirectbr] = ACTIONS(1717),
    [anon_sym_extractelement] = ACTIONS(1717),
    [anon_sym_insertelement] = ACTIONS(1717),
    [anon_sym_select] = ACTIONS(1717),
    [anon_sym_shufflevector] = ACTIONS(1717),
    [anon_sym_fneg] = ACTIONS(1717),
    [anon_sym_switch] = ACTIONS(1717),
    [anon_sym_invoke] = ACTIONS(1717),
    [anon_sym_cleanupret] = ACTIONS(1717),
    [anon_sym_catchret] = ACTIONS(1717),
    [anon_sym_catchswitch] = ACTIONS(1717),
    [anon_sym_catchpad] = ACTIONS(1717),
    [anon_sym_cleanuppad] = ACTIONS(1717),
    [anon_sym_callbr] = ACTIONS(1717),
    [anon_sym_icmp] = ACTIONS(1717),
    [anon_sym_fcmp] = ACTIONS(1717),
    [anon_sym_va_arg] = ACTIONS(1717),
    [anon_sym_phi] = ACTIONS(1717),
    [anon_sym_landingpad] = ACTIONS(1717),
    [anon_sym_tail] = ACTIONS(1717),
    [anon_sym_musttail] = ACTIONS(1717),
    [anon_sym_notail] = ACTIONS(1717),
    [anon_sym_call] = ACTIONS(1717),
    [anon_sym_alloca] = ACTIONS(1717),
    [anon_sym_load] = ACTIONS(1717),
    [anon_sym_store] = ACTIONS(1717),
    [anon_sym_cmpxchg] = ACTIONS(1717),
    [anon_sym_atomicrmw] = ACTIONS(1717),
    [anon_sym_fence] = ACTIONS(1717),
    [anon_sym_getelementptr] = ACTIONS(1717),
    [anon_sym_extractvalue] = ACTIONS(1717),
    [anon_sym_insertvalue] = ACTIONS(1717),
    [anon_sym_mul] = ACTIONS(1717),
    [anon_sym_urem] = ACTIONS(1717),
    [anon_sym_srem] = ACTIONS(1717),
    [anon_sym_shl] = ACTIONS(1717),
    [anon_sym_udiv] = ACTIONS(1717),
    [anon_sym_sdiv] = ACTIONS(1717),
    [anon_sym_lshr] = ACTIONS(1717),
    [anon_sym_ashr] = ACTIONS(1717),
    [anon_sym_fmul] = ACTIONS(1717),
    [anon_sym_fdiv] = ACTIONS(1717),
    [anon_sym_frem] = ACTIONS(1717),
    [anon_sym_xchg] = ACTIONS(1717),
    [anon_sym_add] = ACTIONS(1717),
    [anon_sym_sub] = ACTIONS(1717),
    [anon_sym_and] = ACTIONS(1717),
    [anon_sym_nand] = ACTIONS(1717),
    [anon_sym_or] = ACTIONS(1717),
    [anon_sym_xor] = ACTIONS(1717),
    [anon_sym_max] = ACTIONS(1717),
    [anon_sym_min] = ACTIONS(1717),
    [anon_sym_umax] = ACTIONS(1717),
    [anon_sym_umin] = ACTIONS(1717),
    [anon_sym_fadd] = ACTIONS(1717),
    [anon_sym_fsub] = ACTIONS(1717),
    [anon_sym_bitcast] = ACTIONS(1717),
    [anon_sym_trunc] = ACTIONS(1717),
    [anon_sym_zext] = ACTIONS(1717),
    [anon_sym_sext] = ACTIONS(1717),
    [anon_sym_fptrunc] = ACTIONS(1717),
    [anon_sym_fpext] = ACTIONS(1717),
    [anon_sym_addrspacecast] = ACTIONS(1717),
    [anon_sym_uitofp] = ACTIONS(1717),
    [anon_sym_sitofp] = ACTIONS(1717),
    [anon_sym_fptoui] = ACTIONS(1717),
    [anon_sym_fptosi] = ACTIONS(1717),
    [anon_sym_inttoptr] = ACTIONS(1717),
    [anon_sym_ptrtoint] = ACTIONS(1717),
    [anon_sym_uselistorder] = ACTIONS(1717),
  },
  [540] = {
    [sym_metadata_refs] = STATE(541),
    [aux_sym_instruction_repeat1] = STATE(541),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1719),
    [sym_label] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_unreachable] = ACTIONS(1721),
    [anon_sym_ret] = ACTIONS(1721),
    [anon_sym_br] = ACTIONS(1721),
    [anon_sym_resume] = ACTIONS(1721),
    [anon_sym_freeze] = ACTIONS(1721),
    [anon_sym_indirectbr] = ACTIONS(1721),
    [anon_sym_extractelement] = ACTIONS(1721),
    [anon_sym_insertelement] = ACTIONS(1721),
    [anon_sym_select] = ACTIONS(1721),
    [anon_sym_shufflevector] = ACTIONS(1721),
    [anon_sym_fneg] = ACTIONS(1721),
    [anon_sym_switch] = ACTIONS(1721),
    [anon_sym_invoke] = ACTIONS(1721),
    [anon_sym_cleanupret] = ACTIONS(1721),
    [anon_sym_catchret] = ACTIONS(1721),
    [anon_sym_catchswitch] = ACTIONS(1721),
    [anon_sym_catchpad] = ACTIONS(1721),
    [anon_sym_cleanuppad] = ACTIONS(1721),
    [anon_sym_callbr] = ACTIONS(1721),
    [anon_sym_icmp] = ACTIONS(1721),
    [anon_sym_fcmp] = ACTIONS(1721),
    [anon_sym_va_arg] = ACTIONS(1721),
    [anon_sym_phi] = ACTIONS(1721),
    [anon_sym_landingpad] = ACTIONS(1721),
    [anon_sym_tail] = ACTIONS(1721),
    [anon_sym_musttail] = ACTIONS(1721),
    [anon_sym_notail] = ACTIONS(1721),
    [anon_sym_call] = ACTIONS(1721),
    [anon_sym_alloca] = ACTIONS(1721),
    [anon_sym_load] = ACTIONS(1721),
    [anon_sym_store] = ACTIONS(1721),
    [anon_sym_cmpxchg] = ACTIONS(1721),
    [anon_sym_atomicrmw] = ACTIONS(1721),
    [anon_sym_fence] = ACTIONS(1721),
    [anon_sym_getelementptr] = ACTIONS(1721),
    [anon_sym_extractvalue] = ACTIONS(1721),
    [anon_sym_insertvalue] = ACTIONS(1721),
    [anon_sym_mul] = ACTIONS(1721),
    [anon_sym_urem] = ACTIONS(1721),
    [anon_sym_srem] = ACTIONS(1721),
    [anon_sym_shl] = ACTIONS(1721),
    [anon_sym_udiv] = ACTIONS(1721),
    [anon_sym_sdiv] = ACTIONS(1721),
    [anon_sym_lshr] = ACTIONS(1721),
    [anon_sym_ashr] = ACTIONS(1721),
    [anon_sym_fmul] = ACTIONS(1721),
    [anon_sym_fdiv] = ACTIONS(1721),
    [anon_sym_frem] = ACTIONS(1721),
    [anon_sym_xchg] = ACTIONS(1721),
    [anon_sym_add] = ACTIONS(1721),
    [anon_sym_sub] = ACTIONS(1721),
    [anon_sym_and] = ACTIONS(1721),
    [anon_sym_nand] = ACTIONS(1721),
    [anon_sym_or] = ACTIONS(1721),
    [anon_sym_xor] = ACTIONS(1721),
    [anon_sym_max] = ACTIONS(1721),
    [anon_sym_min] = ACTIONS(1721),
    [anon_sym_umax] = ACTIONS(1721),
    [anon_sym_umin] = ACTIONS(1721),
    [anon_sym_fadd] = ACTIONS(1721),
    [anon_sym_fsub] = ACTIONS(1721),
    [anon_sym_bitcast] = ACTIONS(1721),
    [anon_sym_trunc] = ACTIONS(1721),
    [anon_sym_zext] = ACTIONS(1721),
    [anon_sym_sext] = ACTIONS(1721),
    [anon_sym_fptrunc] = ACTIONS(1721),
    [anon_sym_fpext] = ACTIONS(1721),
    [anon_sym_addrspacecast] = ACTIONS(1721),
    [anon_sym_uitofp] = ACTIONS(1721),
    [anon_sym_sitofp] = ACTIONS(1721),
    [anon_sym_fptoui] = ACTIONS(1721),
    [anon_sym_fptosi] = ACTIONS(1721),
    [anon_sym_inttoptr] = ACTIONS(1721),
    [anon_sym_ptrtoint] = ACTIONS(1721),
    [anon_sym_uselistorder] = ACTIONS(1721),
  },
  [541] = {
    [sym_metadata_refs] = STATE(541),
    [aux_sym_instruction_repeat1] = STATE(541),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1723),
    [sym_label] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_COMMA] = ACTIONS(1725),
    [anon_sym_unreachable] = ACTIONS(1728),
    [anon_sym_ret] = ACTIONS(1728),
    [anon_sym_br] = ACTIONS(1728),
    [anon_sym_resume] = ACTIONS(1728),
    [anon_sym_freeze] = ACTIONS(1728),
    [anon_sym_indirectbr] = ACTIONS(1728),
    [anon_sym_extractelement] = ACTIONS(1728),
    [anon_sym_insertelement] = ACTIONS(1728),
    [anon_sym_select] = ACTIONS(1728),
    [anon_sym_shufflevector] = ACTIONS(1728),
    [anon_sym_fneg] = ACTIONS(1728),
    [anon_sym_switch] = ACTIONS(1728),
    [anon_sym_invoke] = ACTIONS(1728),
    [anon_sym_cleanupret] = ACTIONS(1728),
    [anon_sym_catchret] = ACTIONS(1728),
    [anon_sym_catchswitch] = ACTIONS(1728),
    [anon_sym_catchpad] = ACTIONS(1728),
    [anon_sym_cleanuppad] = ACTIONS(1728),
    [anon_sym_callbr] = ACTIONS(1728),
    [anon_sym_icmp] = ACTIONS(1728),
    [anon_sym_fcmp] = ACTIONS(1728),
    [anon_sym_va_arg] = ACTIONS(1728),
    [anon_sym_phi] = ACTIONS(1728),
    [anon_sym_landingpad] = ACTIONS(1728),
    [anon_sym_tail] = ACTIONS(1728),
    [anon_sym_musttail] = ACTIONS(1728),
    [anon_sym_notail] = ACTIONS(1728),
    [anon_sym_call] = ACTIONS(1728),
    [anon_sym_alloca] = ACTIONS(1728),
    [anon_sym_load] = ACTIONS(1728),
    [anon_sym_store] = ACTIONS(1728),
    [anon_sym_cmpxchg] = ACTIONS(1728),
    [anon_sym_atomicrmw] = ACTIONS(1728),
    [anon_sym_fence] = ACTIONS(1728),
    [anon_sym_getelementptr] = ACTIONS(1728),
    [anon_sym_extractvalue] = ACTIONS(1728),
    [anon_sym_insertvalue] = ACTIONS(1728),
    [anon_sym_mul] = ACTIONS(1728),
    [anon_sym_urem] = ACTIONS(1728),
    [anon_sym_srem] = ACTIONS(1728),
    [anon_sym_shl] = ACTIONS(1728),
    [anon_sym_udiv] = ACTIONS(1728),
    [anon_sym_sdiv] = ACTIONS(1728),
    [anon_sym_lshr] = ACTIONS(1728),
    [anon_sym_ashr] = ACTIONS(1728),
    [anon_sym_fmul] = ACTIONS(1728),
    [anon_sym_fdiv] = ACTIONS(1728),
    [anon_sym_frem] = ACTIONS(1728),
    [anon_sym_xchg] = ACTIONS(1728),
    [anon_sym_add] = ACTIONS(1728),
    [anon_sym_sub] = ACTIONS(1728),
    [anon_sym_and] = ACTIONS(1728),
    [anon_sym_nand] = ACTIONS(1728),
    [anon_sym_or] = ACTIONS(1728),
    [anon_sym_xor] = ACTIONS(1728),
    [anon_sym_max] = ACTIONS(1728),
    [anon_sym_min] = ACTIONS(1728),
    [anon_sym_umax] = ACTIONS(1728),
    [anon_sym_umin] = ACTIONS(1728),
    [anon_sym_fadd] = ACTIONS(1728),
    [anon_sym_fsub] = ACTIONS(1728),
    [anon_sym_bitcast] = ACTIONS(1728),
    [anon_sym_trunc] = ACTIONS(1728),
    [anon_sym_zext] = ACTIONS(1728),
    [anon_sym_sext] = ACTIONS(1728),
    [anon_sym_fptrunc] = ACTIONS(1728),
    [anon_sym_fpext] = ACTIONS(1728),
    [anon_sym_addrspacecast] = ACTIONS(1728),
    [anon_sym_uitofp] = ACTIONS(1728),
    [anon_sym_sitofp] = ACTIONS(1728),
    [anon_sym_fptoui] = ACTIONS(1728),
    [anon_sym_fptosi] = ACTIONS(1728),
    [anon_sym_inttoptr] = ACTIONS(1728),
    [anon_sym_ptrtoint] = ACTIONS(1728),
    [anon_sym_uselistorder] = ACTIONS(1728),
  },
  [542] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1730),
    [sym_label] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1730),
    [anon_sym_unreachable] = ACTIONS(1732),
    [anon_sym_ret] = ACTIONS(1732),
    [anon_sym_br] = ACTIONS(1732),
    [anon_sym_resume] = ACTIONS(1732),
    [anon_sym_freeze] = ACTIONS(1732),
    [anon_sym_indirectbr] = ACTIONS(1732),
    [anon_sym_extractelement] = ACTIONS(1732),
    [anon_sym_insertelement] = ACTIONS(1732),
    [anon_sym_select] = ACTIONS(1732),
    [anon_sym_shufflevector] = ACTIONS(1732),
    [anon_sym_fneg] = ACTIONS(1732),
    [anon_sym_switch] = ACTIONS(1732),
    [anon_sym_invoke] = ACTIONS(1732),
    [anon_sym_cleanupret] = ACTIONS(1732),
    [anon_sym_catchret] = ACTIONS(1732),
    [anon_sym_catchswitch] = ACTIONS(1732),
    [anon_sym_catchpad] = ACTIONS(1732),
    [anon_sym_cleanuppad] = ACTIONS(1732),
    [anon_sym_callbr] = ACTIONS(1732),
    [anon_sym_icmp] = ACTIONS(1732),
    [anon_sym_fcmp] = ACTIONS(1732),
    [anon_sym_va_arg] = ACTIONS(1732),
    [anon_sym_phi] = ACTIONS(1732),
    [anon_sym_landingpad] = ACTIONS(1732),
    [anon_sym_tail] = ACTIONS(1732),
    [anon_sym_musttail] = ACTIONS(1732),
    [anon_sym_notail] = ACTIONS(1732),
    [anon_sym_call] = ACTIONS(1732),
    [anon_sym_alloca] = ACTIONS(1732),
    [anon_sym_load] = ACTIONS(1732),
    [anon_sym_store] = ACTIONS(1732),
    [anon_sym_cmpxchg] = ACTIONS(1732),
    [anon_sym_atomicrmw] = ACTIONS(1732),
    [anon_sym_fence] = ACTIONS(1732),
    [anon_sym_getelementptr] = ACTIONS(1732),
    [anon_sym_extractvalue] = ACTIONS(1732),
    [anon_sym_insertvalue] = ACTIONS(1732),
    [anon_sym_catch] = ACTIONS(1732),
    [anon_sym_filter] = ACTIONS(1732),
    [anon_sym_mul] = ACTIONS(1732),
    [anon_sym_urem] = ACTIONS(1732),
    [anon_sym_srem] = ACTIONS(1732),
    [anon_sym_shl] = ACTIONS(1732),
    [anon_sym_udiv] = ACTIONS(1732),
    [anon_sym_sdiv] = ACTIONS(1732),
    [anon_sym_lshr] = ACTIONS(1732),
    [anon_sym_ashr] = ACTIONS(1732),
    [anon_sym_fmul] = ACTIONS(1732),
    [anon_sym_fdiv] = ACTIONS(1732),
    [anon_sym_frem] = ACTIONS(1732),
    [anon_sym_xchg] = ACTIONS(1732),
    [anon_sym_add] = ACTIONS(1732),
    [anon_sym_sub] = ACTIONS(1732),
    [anon_sym_and] = ACTIONS(1732),
    [anon_sym_nand] = ACTIONS(1732),
    [anon_sym_or] = ACTIONS(1732),
    [anon_sym_xor] = ACTIONS(1732),
    [anon_sym_max] = ACTIONS(1732),
    [anon_sym_min] = ACTIONS(1732),
    [anon_sym_umax] = ACTIONS(1732),
    [anon_sym_umin] = ACTIONS(1732),
    [anon_sym_fadd] = ACTIONS(1732),
    [anon_sym_fsub] = ACTIONS(1732),
    [anon_sym_bitcast] = ACTIONS(1732),
    [anon_sym_trunc] = ACTIONS(1732),
    [anon_sym_zext] = ACTIONS(1732),
    [anon_sym_sext] = ACTIONS(1732),
    [anon_sym_fptrunc] = ACTIONS(1732),
    [anon_sym_fpext] = ACTIONS(1732),
    [anon_sym_addrspacecast] = ACTIONS(1732),
    [anon_sym_uitofp] = ACTIONS(1732),
    [anon_sym_sitofp] = ACTIONS(1732),
    [anon_sym_fptoui] = ACTIONS(1732),
    [anon_sym_fptosi] = ACTIONS(1732),
    [anon_sym_inttoptr] = ACTIONS(1732),
    [anon_sym_ptrtoint] = ACTIONS(1732),
    [anon_sym_uselistorder] = ACTIONS(1732),
  },
  [543] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(569),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1734),
    [sym_label] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1736),
    [anon_sym_unreachable] = ACTIONS(1739),
    [anon_sym_ret] = ACTIONS(1739),
    [anon_sym_br] = ACTIONS(1739),
    [anon_sym_resume] = ACTIONS(1739),
    [anon_sym_freeze] = ACTIONS(1739),
    [anon_sym_indirectbr] = ACTIONS(1739),
    [anon_sym_extractelement] = ACTIONS(1739),
    [anon_sym_insertelement] = ACTIONS(1739),
    [anon_sym_select] = ACTIONS(1739),
    [anon_sym_shufflevector] = ACTIONS(1739),
    [anon_sym_fneg] = ACTIONS(1739),
    [anon_sym_switch] = ACTIONS(1739),
    [anon_sym_invoke] = ACTIONS(1739),
    [anon_sym_cleanupret] = ACTIONS(1739),
    [anon_sym_catchret] = ACTIONS(1739),
    [anon_sym_catchswitch] = ACTIONS(1739),
    [anon_sym_catchpad] = ACTIONS(1739),
    [anon_sym_cleanuppad] = ACTIONS(1739),
    [anon_sym_callbr] = ACTIONS(1739),
    [anon_sym_icmp] = ACTIONS(1739),
    [anon_sym_fcmp] = ACTIONS(1739),
    [anon_sym_va_arg] = ACTIONS(1739),
    [anon_sym_phi] = ACTIONS(1739),
    [anon_sym_landingpad] = ACTIONS(1739),
    [anon_sym_tail] = ACTIONS(1739),
    [anon_sym_musttail] = ACTIONS(1739),
    [anon_sym_notail] = ACTIONS(1739),
    [anon_sym_call] = ACTIONS(1739),
    [anon_sym_alloca] = ACTIONS(1739),
    [anon_sym_load] = ACTIONS(1739),
    [anon_sym_store] = ACTIONS(1739),
    [anon_sym_cmpxchg] = ACTIONS(1739),
    [anon_sym_atomicrmw] = ACTIONS(1739),
    [anon_sym_fence] = ACTIONS(1739),
    [anon_sym_getelementptr] = ACTIONS(1739),
    [anon_sym_extractvalue] = ACTIONS(1739),
    [anon_sym_insertvalue] = ACTIONS(1739),
    [anon_sym_mul] = ACTIONS(1739),
    [anon_sym_urem] = ACTIONS(1739),
    [anon_sym_srem] = ACTIONS(1739),
    [anon_sym_shl] = ACTIONS(1739),
    [anon_sym_udiv] = ACTIONS(1739),
    [anon_sym_sdiv] = ACTIONS(1739),
    [anon_sym_lshr] = ACTIONS(1739),
    [anon_sym_ashr] = ACTIONS(1739),
    [anon_sym_fmul] = ACTIONS(1739),
    [anon_sym_fdiv] = ACTIONS(1739),
    [anon_sym_frem] = ACTIONS(1739),
    [anon_sym_xchg] = ACTIONS(1739),
    [anon_sym_add] = ACTIONS(1739),
    [anon_sym_sub] = ACTIONS(1739),
    [anon_sym_and] = ACTIONS(1739),
    [anon_sym_nand] = ACTIONS(1739),
    [anon_sym_or] = ACTIONS(1739),
    [anon_sym_xor] = ACTIONS(1739),
    [anon_sym_max] = ACTIONS(1739),
    [anon_sym_min] = ACTIONS(1739),
    [anon_sym_umax] = ACTIONS(1739),
    [anon_sym_umin] = ACTIONS(1739),
    [anon_sym_fadd] = ACTIONS(1739),
    [anon_sym_fsub] = ACTIONS(1739),
    [anon_sym_bitcast] = ACTIONS(1739),
    [anon_sym_trunc] = ACTIONS(1739),
    [anon_sym_zext] = ACTIONS(1739),
    [anon_sym_sext] = ACTIONS(1739),
    [anon_sym_fptrunc] = ACTIONS(1739),
    [anon_sym_fpext] = ACTIONS(1739),
    [anon_sym_addrspacecast] = ACTIONS(1739),
    [anon_sym_uitofp] = ACTIONS(1739),
    [anon_sym_sitofp] = ACTIONS(1739),
    [anon_sym_fptoui] = ACTIONS(1739),
    [anon_sym_fptosi] = ACTIONS(1739),
    [anon_sym_inttoptr] = ACTIONS(1739),
    [anon_sym_ptrtoint] = ACTIONS(1739),
    [anon_sym_uselistorder] = ACTIONS(1739),
  },
  [544] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1741),
    [sym_label] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1741),
    [anon_sym_unreachable] = ACTIONS(1743),
    [anon_sym_ret] = ACTIONS(1743),
    [anon_sym_br] = ACTIONS(1743),
    [anon_sym_resume] = ACTIONS(1743),
    [anon_sym_freeze] = ACTIONS(1743),
    [anon_sym_indirectbr] = ACTIONS(1743),
    [anon_sym_extractelement] = ACTIONS(1743),
    [anon_sym_insertelement] = ACTIONS(1743),
    [anon_sym_select] = ACTIONS(1743),
    [anon_sym_shufflevector] = ACTIONS(1743),
    [anon_sym_fneg] = ACTIONS(1743),
    [anon_sym_switch] = ACTIONS(1743),
    [anon_sym_invoke] = ACTIONS(1743),
    [anon_sym_cleanupret] = ACTIONS(1743),
    [anon_sym_catchret] = ACTIONS(1743),
    [anon_sym_catchswitch] = ACTIONS(1743),
    [anon_sym_catchpad] = ACTIONS(1743),
    [anon_sym_cleanuppad] = ACTIONS(1743),
    [anon_sym_callbr] = ACTIONS(1743),
    [anon_sym_icmp] = ACTIONS(1743),
    [anon_sym_fcmp] = ACTIONS(1743),
    [anon_sym_va_arg] = ACTIONS(1743),
    [anon_sym_phi] = ACTIONS(1743),
    [anon_sym_landingpad] = ACTIONS(1743),
    [anon_sym_tail] = ACTIONS(1743),
    [anon_sym_musttail] = ACTIONS(1743),
    [anon_sym_notail] = ACTIONS(1743),
    [anon_sym_call] = ACTIONS(1743),
    [anon_sym_alloca] = ACTIONS(1743),
    [anon_sym_load] = ACTIONS(1743),
    [anon_sym_store] = ACTIONS(1743),
    [anon_sym_cmpxchg] = ACTIONS(1743),
    [anon_sym_atomicrmw] = ACTIONS(1743),
    [anon_sym_fence] = ACTIONS(1743),
    [anon_sym_getelementptr] = ACTIONS(1743),
    [anon_sym_extractvalue] = ACTIONS(1743),
    [anon_sym_insertvalue] = ACTIONS(1743),
    [anon_sym_mul] = ACTIONS(1743),
    [anon_sym_urem] = ACTIONS(1743),
    [anon_sym_srem] = ACTIONS(1743),
    [anon_sym_shl] = ACTIONS(1743),
    [anon_sym_udiv] = ACTIONS(1743),
    [anon_sym_sdiv] = ACTIONS(1743),
    [anon_sym_lshr] = ACTIONS(1743),
    [anon_sym_ashr] = ACTIONS(1743),
    [anon_sym_fmul] = ACTIONS(1743),
    [anon_sym_fdiv] = ACTIONS(1743),
    [anon_sym_frem] = ACTIONS(1743),
    [anon_sym_xchg] = ACTIONS(1743),
    [anon_sym_add] = ACTIONS(1743),
    [anon_sym_sub] = ACTIONS(1743),
    [anon_sym_and] = ACTIONS(1743),
    [anon_sym_nand] = ACTIONS(1743),
    [anon_sym_or] = ACTIONS(1743),
    [anon_sym_xor] = ACTIONS(1743),
    [anon_sym_max] = ACTIONS(1743),
    [anon_sym_min] = ACTIONS(1743),
    [anon_sym_umax] = ACTIONS(1743),
    [anon_sym_umin] = ACTIONS(1743),
    [anon_sym_fadd] = ACTIONS(1743),
    [anon_sym_fsub] = ACTIONS(1743),
    [anon_sym_bitcast] = ACTIONS(1743),
    [anon_sym_trunc] = ACTIONS(1743),
    [anon_sym_zext] = ACTIONS(1743),
    [anon_sym_sext] = ACTIONS(1743),
    [anon_sym_fptrunc] = ACTIONS(1743),
    [anon_sym_fpext] = ACTIONS(1743),
    [anon_sym_addrspacecast] = ACTIONS(1743),
    [anon_sym_uitofp] = ACTIONS(1743),
    [anon_sym_sitofp] = ACTIONS(1743),
    [anon_sym_fptoui] = ACTIONS(1743),
    [anon_sym_fptosi] = ACTIONS(1743),
    [anon_sym_inttoptr] = ACTIONS(1743),
    [anon_sym_ptrtoint] = ACTIONS(1743),
    [anon_sym_uselistorder] = ACTIONS(1743),
  },
  [545] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1745),
    [sym_label] = ACTIONS(1745),
    [anon_sym_RBRACE] = ACTIONS(1745),
    [anon_sym_LBRACK] = ACTIONS(1747),
    [anon_sym_COMMA] = ACTIONS(1745),
    [anon_sym_unreachable] = ACTIONS(1749),
    [anon_sym_ret] = ACTIONS(1749),
    [anon_sym_br] = ACTIONS(1749),
    [anon_sym_resume] = ACTIONS(1749),
    [anon_sym_freeze] = ACTIONS(1749),
    [anon_sym_indirectbr] = ACTIONS(1749),
    [anon_sym_extractelement] = ACTIONS(1749),
    [anon_sym_insertelement] = ACTIONS(1749),
    [anon_sym_select] = ACTIONS(1749),
    [anon_sym_shufflevector] = ACTIONS(1749),
    [anon_sym_fneg] = ACTIONS(1749),
    [anon_sym_switch] = ACTIONS(1749),
    [anon_sym_invoke] = ACTIONS(1749),
    [anon_sym_cleanupret] = ACTIONS(1749),
    [anon_sym_catchret] = ACTIONS(1749),
    [anon_sym_catchswitch] = ACTIONS(1749),
    [anon_sym_catchpad] = ACTIONS(1749),
    [anon_sym_cleanuppad] = ACTIONS(1749),
    [anon_sym_callbr] = ACTIONS(1749),
    [anon_sym_icmp] = ACTIONS(1749),
    [anon_sym_fcmp] = ACTIONS(1749),
    [anon_sym_va_arg] = ACTIONS(1749),
    [anon_sym_phi] = ACTIONS(1749),
    [anon_sym_landingpad] = ACTIONS(1749),
    [anon_sym_tail] = ACTIONS(1749),
    [anon_sym_musttail] = ACTIONS(1749),
    [anon_sym_notail] = ACTIONS(1749),
    [anon_sym_call] = ACTIONS(1749),
    [anon_sym_alloca] = ACTIONS(1749),
    [anon_sym_load] = ACTIONS(1749),
    [anon_sym_store] = ACTIONS(1749),
    [anon_sym_cmpxchg] = ACTIONS(1749),
    [anon_sym_atomicrmw] = ACTIONS(1749),
    [anon_sym_fence] = ACTIONS(1749),
    [anon_sym_getelementptr] = ACTIONS(1749),
    [anon_sym_extractvalue] = ACTIONS(1749),
    [anon_sym_insertvalue] = ACTIONS(1749),
    [anon_sym_mul] = ACTIONS(1749),
    [anon_sym_urem] = ACTIONS(1749),
    [anon_sym_srem] = ACTIONS(1749),
    [anon_sym_shl] = ACTIONS(1749),
    [anon_sym_udiv] = ACTIONS(1749),
    [anon_sym_sdiv] = ACTIONS(1749),
    [anon_sym_lshr] = ACTIONS(1749),
    [anon_sym_ashr] = ACTIONS(1749),
    [anon_sym_fmul] = ACTIONS(1749),
    [anon_sym_fdiv] = ACTIONS(1749),
    [anon_sym_frem] = ACTIONS(1749),
    [anon_sym_xchg] = ACTIONS(1749),
    [anon_sym_add] = ACTIONS(1749),
    [anon_sym_sub] = ACTIONS(1749),
    [anon_sym_and] = ACTIONS(1749),
    [anon_sym_nand] = ACTIONS(1749),
    [anon_sym_or] = ACTIONS(1749),
    [anon_sym_xor] = ACTIONS(1749),
    [anon_sym_max] = ACTIONS(1749),
    [anon_sym_min] = ACTIONS(1749),
    [anon_sym_umax] = ACTIONS(1749),
    [anon_sym_umin] = ACTIONS(1749),
    [anon_sym_fadd] = ACTIONS(1749),
    [anon_sym_fsub] = ACTIONS(1749),
    [anon_sym_bitcast] = ACTIONS(1749),
    [anon_sym_trunc] = ACTIONS(1749),
    [anon_sym_zext] = ACTIONS(1749),
    [anon_sym_sext] = ACTIONS(1749),
    [anon_sym_fptrunc] = ACTIONS(1749),
    [anon_sym_fpext] = ACTIONS(1749),
    [anon_sym_addrspacecast] = ACTIONS(1749),
    [anon_sym_uitofp] = ACTIONS(1749),
    [anon_sym_sitofp] = ACTIONS(1749),
    [anon_sym_fptoui] = ACTIONS(1749),
    [anon_sym_fptosi] = ACTIONS(1749),
    [anon_sym_inttoptr] = ACTIONS(1749),
    [anon_sym_ptrtoint] = ACTIONS(1749),
    [anon_sym_uselistorder] = ACTIONS(1749),
  },
  [546] = {
    [aux_sym_instruction_phi_repeat1] = STATE(566),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1751),
    [sym_label] = ACTIONS(1751),
    [anon_sym_RBRACE] = ACTIONS(1751),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_unreachable] = ACTIONS(1756),
    [anon_sym_ret] = ACTIONS(1756),
    [anon_sym_br] = ACTIONS(1756),
    [anon_sym_resume] = ACTIONS(1756),
    [anon_sym_freeze] = ACTIONS(1756),
    [anon_sym_indirectbr] = ACTIONS(1756),
    [anon_sym_extractelement] = ACTIONS(1756),
    [anon_sym_insertelement] = ACTIONS(1756),
    [anon_sym_select] = ACTIONS(1756),
    [anon_sym_shufflevector] = ACTIONS(1756),
    [anon_sym_fneg] = ACTIONS(1756),
    [anon_sym_switch] = ACTIONS(1756),
    [anon_sym_invoke] = ACTIONS(1756),
    [anon_sym_cleanupret] = ACTIONS(1756),
    [anon_sym_catchret] = ACTIONS(1756),
    [anon_sym_catchswitch] = ACTIONS(1756),
    [anon_sym_catchpad] = ACTIONS(1756),
    [anon_sym_cleanuppad] = ACTIONS(1756),
    [anon_sym_callbr] = ACTIONS(1756),
    [anon_sym_icmp] = ACTIONS(1756),
    [anon_sym_fcmp] = ACTIONS(1756),
    [anon_sym_va_arg] = ACTIONS(1756),
    [anon_sym_phi] = ACTIONS(1756),
    [anon_sym_landingpad] = ACTIONS(1756),
    [anon_sym_tail] = ACTIONS(1756),
    [anon_sym_musttail] = ACTIONS(1756),
    [anon_sym_notail] = ACTIONS(1756),
    [anon_sym_call] = ACTIONS(1756),
    [anon_sym_alloca] = ACTIONS(1756),
    [anon_sym_load] = ACTIONS(1756),
    [anon_sym_store] = ACTIONS(1756),
    [anon_sym_cmpxchg] = ACTIONS(1756),
    [anon_sym_atomicrmw] = ACTIONS(1756),
    [anon_sym_fence] = ACTIONS(1756),
    [anon_sym_getelementptr] = ACTIONS(1756),
    [anon_sym_extractvalue] = ACTIONS(1756),
    [anon_sym_insertvalue] = ACTIONS(1756),
    [anon_sym_mul] = ACTIONS(1756),
    [anon_sym_urem] = ACTIONS(1756),
    [anon_sym_srem] = ACTIONS(1756),
    [anon_sym_shl] = ACTIONS(1756),
    [anon_sym_udiv] = ACTIONS(1756),
    [anon_sym_sdiv] = ACTIONS(1756),
    [anon_sym_lshr] = ACTIONS(1756),
    [anon_sym_ashr] = ACTIONS(1756),
    [anon_sym_fmul] = ACTIONS(1756),
    [anon_sym_fdiv] = ACTIONS(1756),
    [anon_sym_frem] = ACTIONS(1756),
    [anon_sym_xchg] = ACTIONS(1756),
    [anon_sym_add] = ACTIONS(1756),
    [anon_sym_sub] = ACTIONS(1756),
    [anon_sym_and] = ACTIONS(1756),
    [anon_sym_nand] = ACTIONS(1756),
    [anon_sym_or] = ACTIONS(1756),
    [anon_sym_xor] = ACTIONS(1756),
    [anon_sym_max] = ACTIONS(1756),
    [anon_sym_min] = ACTIONS(1756),
    [anon_sym_umax] = ACTIONS(1756),
    [anon_sym_umin] = ACTIONS(1756),
    [anon_sym_fadd] = ACTIONS(1756),
    [anon_sym_fsub] = ACTIONS(1756),
    [anon_sym_bitcast] = ACTIONS(1756),
    [anon_sym_trunc] = ACTIONS(1756),
    [anon_sym_zext] = ACTIONS(1756),
    [anon_sym_sext] = ACTIONS(1756),
    [anon_sym_fptrunc] = ACTIONS(1756),
    [anon_sym_fpext] = ACTIONS(1756),
    [anon_sym_addrspacecast] = ACTIONS(1756),
    [anon_sym_uitofp] = ACTIONS(1756),
    [anon_sym_sitofp] = ACTIONS(1756),
    [anon_sym_fptoui] = ACTIONS(1756),
    [anon_sym_fptosi] = ACTIONS(1756),
    [anon_sym_inttoptr] = ACTIONS(1756),
    [anon_sym_ptrtoint] = ACTIONS(1756),
    [anon_sym_uselistorder] = ACTIONS(1756),
  },
  [547] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(553),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1758),
    [sym_label] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_unreachable] = ACTIONS(1763),
    [anon_sym_ret] = ACTIONS(1763),
    [anon_sym_br] = ACTIONS(1763),
    [anon_sym_resume] = ACTIONS(1763),
    [anon_sym_freeze] = ACTIONS(1763),
    [anon_sym_indirectbr] = ACTIONS(1763),
    [anon_sym_extractelement] = ACTIONS(1763),
    [anon_sym_insertelement] = ACTIONS(1763),
    [anon_sym_select] = ACTIONS(1763),
    [anon_sym_shufflevector] = ACTIONS(1763),
    [anon_sym_fneg] = ACTIONS(1763),
    [anon_sym_switch] = ACTIONS(1763),
    [anon_sym_invoke] = ACTIONS(1763),
    [anon_sym_cleanupret] = ACTIONS(1763),
    [anon_sym_catchret] = ACTIONS(1763),
    [anon_sym_catchswitch] = ACTIONS(1763),
    [anon_sym_catchpad] = ACTIONS(1763),
    [anon_sym_cleanuppad] = ACTIONS(1763),
    [anon_sym_callbr] = ACTIONS(1763),
    [anon_sym_icmp] = ACTIONS(1763),
    [anon_sym_fcmp] = ACTIONS(1763),
    [anon_sym_va_arg] = ACTIONS(1763),
    [anon_sym_phi] = ACTIONS(1763),
    [anon_sym_landingpad] = ACTIONS(1763),
    [anon_sym_tail] = ACTIONS(1763),
    [anon_sym_musttail] = ACTIONS(1763),
    [anon_sym_notail] = ACTIONS(1763),
    [anon_sym_call] = ACTIONS(1763),
    [anon_sym_alloca] = ACTIONS(1763),
    [anon_sym_load] = ACTIONS(1763),
    [anon_sym_store] = ACTIONS(1763),
    [anon_sym_cmpxchg] = ACTIONS(1763),
    [anon_sym_atomicrmw] = ACTIONS(1763),
    [anon_sym_fence] = ACTIONS(1763),
    [anon_sym_getelementptr] = ACTIONS(1763),
    [anon_sym_extractvalue] = ACTIONS(1763),
    [anon_sym_insertvalue] = ACTIONS(1763),
    [anon_sym_mul] = ACTIONS(1763),
    [anon_sym_urem] = ACTIONS(1763),
    [anon_sym_srem] = ACTIONS(1763),
    [anon_sym_shl] = ACTIONS(1763),
    [anon_sym_udiv] = ACTIONS(1763),
    [anon_sym_sdiv] = ACTIONS(1763),
    [anon_sym_lshr] = ACTIONS(1763),
    [anon_sym_ashr] = ACTIONS(1763),
    [anon_sym_fmul] = ACTIONS(1763),
    [anon_sym_fdiv] = ACTIONS(1763),
    [anon_sym_frem] = ACTIONS(1763),
    [anon_sym_xchg] = ACTIONS(1763),
    [anon_sym_add] = ACTIONS(1763),
    [anon_sym_sub] = ACTIONS(1763),
    [anon_sym_and] = ACTIONS(1763),
    [anon_sym_nand] = ACTIONS(1763),
    [anon_sym_or] = ACTIONS(1763),
    [anon_sym_xor] = ACTIONS(1763),
    [anon_sym_max] = ACTIONS(1763),
    [anon_sym_min] = ACTIONS(1763),
    [anon_sym_umax] = ACTIONS(1763),
    [anon_sym_umin] = ACTIONS(1763),
    [anon_sym_fadd] = ACTIONS(1763),
    [anon_sym_fsub] = ACTIONS(1763),
    [anon_sym_bitcast] = ACTIONS(1763),
    [anon_sym_trunc] = ACTIONS(1763),
    [anon_sym_zext] = ACTIONS(1763),
    [anon_sym_sext] = ACTIONS(1763),
    [anon_sym_fptrunc] = ACTIONS(1763),
    [anon_sym_fpext] = ACTIONS(1763),
    [anon_sym_addrspacecast] = ACTIONS(1763),
    [anon_sym_uitofp] = ACTIONS(1763),
    [anon_sym_sitofp] = ACTIONS(1763),
    [anon_sym_fptoui] = ACTIONS(1763),
    [anon_sym_fptosi] = ACTIONS(1763),
    [anon_sym_inttoptr] = ACTIONS(1763),
    [anon_sym_ptrtoint] = ACTIONS(1763),
    [anon_sym_uselistorder] = ACTIONS(1763),
  },
  [548] = {
    [aux_sym_instruction_phi_repeat1] = STATE(564),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1751),
    [sym_label] = ACTIONS(1751),
    [anon_sym_RBRACE] = ACTIONS(1751),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_unreachable] = ACTIONS(1756),
    [anon_sym_ret] = ACTIONS(1756),
    [anon_sym_br] = ACTIONS(1756),
    [anon_sym_resume] = ACTIONS(1756),
    [anon_sym_freeze] = ACTIONS(1756),
    [anon_sym_indirectbr] = ACTIONS(1756),
    [anon_sym_extractelement] = ACTIONS(1756),
    [anon_sym_insertelement] = ACTIONS(1756),
    [anon_sym_select] = ACTIONS(1756),
    [anon_sym_shufflevector] = ACTIONS(1756),
    [anon_sym_fneg] = ACTIONS(1756),
    [anon_sym_switch] = ACTIONS(1756),
    [anon_sym_invoke] = ACTIONS(1756),
    [anon_sym_cleanupret] = ACTIONS(1756),
    [anon_sym_catchret] = ACTIONS(1756),
    [anon_sym_catchswitch] = ACTIONS(1756),
    [anon_sym_catchpad] = ACTIONS(1756),
    [anon_sym_cleanuppad] = ACTIONS(1756),
    [anon_sym_callbr] = ACTIONS(1756),
    [anon_sym_icmp] = ACTIONS(1756),
    [anon_sym_fcmp] = ACTIONS(1756),
    [anon_sym_va_arg] = ACTIONS(1756),
    [anon_sym_phi] = ACTIONS(1756),
    [anon_sym_landingpad] = ACTIONS(1756),
    [anon_sym_tail] = ACTIONS(1756),
    [anon_sym_musttail] = ACTIONS(1756),
    [anon_sym_notail] = ACTIONS(1756),
    [anon_sym_call] = ACTIONS(1756),
    [anon_sym_alloca] = ACTIONS(1756),
    [anon_sym_load] = ACTIONS(1756),
    [anon_sym_store] = ACTIONS(1756),
    [anon_sym_cmpxchg] = ACTIONS(1756),
    [anon_sym_atomicrmw] = ACTIONS(1756),
    [anon_sym_fence] = ACTIONS(1756),
    [anon_sym_getelementptr] = ACTIONS(1756),
    [anon_sym_extractvalue] = ACTIONS(1756),
    [anon_sym_insertvalue] = ACTIONS(1756),
    [anon_sym_mul] = ACTIONS(1756),
    [anon_sym_urem] = ACTIONS(1756),
    [anon_sym_srem] = ACTIONS(1756),
    [anon_sym_shl] = ACTIONS(1756),
    [anon_sym_udiv] = ACTIONS(1756),
    [anon_sym_sdiv] = ACTIONS(1756),
    [anon_sym_lshr] = ACTIONS(1756),
    [anon_sym_ashr] = ACTIONS(1756),
    [anon_sym_fmul] = ACTIONS(1756),
    [anon_sym_fdiv] = ACTIONS(1756),
    [anon_sym_frem] = ACTIONS(1756),
    [anon_sym_xchg] = ACTIONS(1756),
    [anon_sym_add] = ACTIONS(1756),
    [anon_sym_sub] = ACTIONS(1756),
    [anon_sym_and] = ACTIONS(1756),
    [anon_sym_nand] = ACTIONS(1756),
    [anon_sym_or] = ACTIONS(1756),
    [anon_sym_xor] = ACTIONS(1756),
    [anon_sym_max] = ACTIONS(1756),
    [anon_sym_min] = ACTIONS(1756),
    [anon_sym_umax] = ACTIONS(1756),
    [anon_sym_umin] = ACTIONS(1756),
    [anon_sym_fadd] = ACTIONS(1756),
    [anon_sym_fsub] = ACTIONS(1756),
    [anon_sym_bitcast] = ACTIONS(1756),
    [anon_sym_trunc] = ACTIONS(1756),
    [anon_sym_zext] = ACTIONS(1756),
    [anon_sym_sext] = ACTIONS(1756),
    [anon_sym_fptrunc] = ACTIONS(1756),
    [anon_sym_fpext] = ACTIONS(1756),
    [anon_sym_addrspacecast] = ACTIONS(1756),
    [anon_sym_uitofp] = ACTIONS(1756),
    [anon_sym_sitofp] = ACTIONS(1756),
    [anon_sym_fptoui] = ACTIONS(1756),
    [anon_sym_fptosi] = ACTIONS(1756),
    [anon_sym_inttoptr] = ACTIONS(1756),
    [anon_sym_ptrtoint] = ACTIONS(1756),
    [anon_sym_uselistorder] = ACTIONS(1756),
  },
  [549] = {
    [aux_sym_instruction_phi_repeat1] = STATE(546),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1765),
    [sym_label] = ACTIONS(1765),
    [anon_sym_RBRACE] = ACTIONS(1765),
    [anon_sym_COMMA] = ACTIONS(1767),
    [anon_sym_unreachable] = ACTIONS(1770),
    [anon_sym_ret] = ACTIONS(1770),
    [anon_sym_br] = ACTIONS(1770),
    [anon_sym_resume] = ACTIONS(1770),
    [anon_sym_freeze] = ACTIONS(1770),
    [anon_sym_indirectbr] = ACTIONS(1770),
    [anon_sym_extractelement] = ACTIONS(1770),
    [anon_sym_insertelement] = ACTIONS(1770),
    [anon_sym_select] = ACTIONS(1770),
    [anon_sym_shufflevector] = ACTIONS(1770),
    [anon_sym_fneg] = ACTIONS(1770),
    [anon_sym_switch] = ACTIONS(1770),
    [anon_sym_invoke] = ACTIONS(1770),
    [anon_sym_cleanupret] = ACTIONS(1770),
    [anon_sym_catchret] = ACTIONS(1770),
    [anon_sym_catchswitch] = ACTIONS(1770),
    [anon_sym_catchpad] = ACTIONS(1770),
    [anon_sym_cleanuppad] = ACTIONS(1770),
    [anon_sym_callbr] = ACTIONS(1770),
    [anon_sym_icmp] = ACTIONS(1770),
    [anon_sym_fcmp] = ACTIONS(1770),
    [anon_sym_va_arg] = ACTIONS(1770),
    [anon_sym_phi] = ACTIONS(1770),
    [anon_sym_landingpad] = ACTIONS(1770),
    [anon_sym_tail] = ACTIONS(1770),
    [anon_sym_musttail] = ACTIONS(1770),
    [anon_sym_notail] = ACTIONS(1770),
    [anon_sym_call] = ACTIONS(1770),
    [anon_sym_alloca] = ACTIONS(1770),
    [anon_sym_load] = ACTIONS(1770),
    [anon_sym_store] = ACTIONS(1770),
    [anon_sym_cmpxchg] = ACTIONS(1770),
    [anon_sym_atomicrmw] = ACTIONS(1770),
    [anon_sym_fence] = ACTIONS(1770),
    [anon_sym_getelementptr] = ACTIONS(1770),
    [anon_sym_extractvalue] = ACTIONS(1770),
    [anon_sym_insertvalue] = ACTIONS(1770),
    [anon_sym_mul] = ACTIONS(1770),
    [anon_sym_urem] = ACTIONS(1770),
    [anon_sym_srem] = ACTIONS(1770),
    [anon_sym_shl] = ACTIONS(1770),
    [anon_sym_udiv] = ACTIONS(1770),
    [anon_sym_sdiv] = ACTIONS(1770),
    [anon_sym_lshr] = ACTIONS(1770),
    [anon_sym_ashr] = ACTIONS(1770),
    [anon_sym_fmul] = ACTIONS(1770),
    [anon_sym_fdiv] = ACTIONS(1770),
    [anon_sym_frem] = ACTIONS(1770),
    [anon_sym_xchg] = ACTIONS(1770),
    [anon_sym_add] = ACTIONS(1770),
    [anon_sym_sub] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1770),
    [anon_sym_nand] = ACTIONS(1770),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_xor] = ACTIONS(1770),
    [anon_sym_max] = ACTIONS(1770),
    [anon_sym_min] = ACTIONS(1770),
    [anon_sym_umax] = ACTIONS(1770),
    [anon_sym_umin] = ACTIONS(1770),
    [anon_sym_fadd] = ACTIONS(1770),
    [anon_sym_fsub] = ACTIONS(1770),
    [anon_sym_bitcast] = ACTIONS(1770),
    [anon_sym_trunc] = ACTIONS(1770),
    [anon_sym_zext] = ACTIONS(1770),
    [anon_sym_sext] = ACTIONS(1770),
    [anon_sym_fptrunc] = ACTIONS(1770),
    [anon_sym_fpext] = ACTIONS(1770),
    [anon_sym_addrspacecast] = ACTIONS(1770),
    [anon_sym_uitofp] = ACTIONS(1770),
    [anon_sym_sitofp] = ACTIONS(1770),
    [anon_sym_fptoui] = ACTIONS(1770),
    [anon_sym_fptosi] = ACTIONS(1770),
    [anon_sym_inttoptr] = ACTIONS(1770),
    [anon_sym_ptrtoint] = ACTIONS(1770),
    [anon_sym_uselistorder] = ACTIONS(1770),
  },
  [550] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(557),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1772),
    [sym_label] = ACTIONS(1772),
    [anon_sym_RBRACE] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_unreachable] = ACTIONS(1777),
    [anon_sym_ret] = ACTIONS(1777),
    [anon_sym_br] = ACTIONS(1777),
    [anon_sym_resume] = ACTIONS(1777),
    [anon_sym_freeze] = ACTIONS(1777),
    [anon_sym_indirectbr] = ACTIONS(1777),
    [anon_sym_extractelement] = ACTIONS(1777),
    [anon_sym_insertelement] = ACTIONS(1777),
    [anon_sym_select] = ACTIONS(1777),
    [anon_sym_shufflevector] = ACTIONS(1777),
    [anon_sym_fneg] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(1777),
    [anon_sym_invoke] = ACTIONS(1777),
    [anon_sym_cleanupret] = ACTIONS(1777),
    [anon_sym_catchret] = ACTIONS(1777),
    [anon_sym_catchswitch] = ACTIONS(1777),
    [anon_sym_catchpad] = ACTIONS(1777),
    [anon_sym_cleanuppad] = ACTIONS(1777),
    [anon_sym_callbr] = ACTIONS(1777),
    [anon_sym_icmp] = ACTIONS(1777),
    [anon_sym_fcmp] = ACTIONS(1777),
    [anon_sym_va_arg] = ACTIONS(1777),
    [anon_sym_phi] = ACTIONS(1777),
    [anon_sym_landingpad] = ACTIONS(1777),
    [anon_sym_tail] = ACTIONS(1777),
    [anon_sym_musttail] = ACTIONS(1777),
    [anon_sym_notail] = ACTIONS(1777),
    [anon_sym_call] = ACTIONS(1777),
    [anon_sym_alloca] = ACTIONS(1777),
    [anon_sym_load] = ACTIONS(1777),
    [anon_sym_store] = ACTIONS(1777),
    [anon_sym_cmpxchg] = ACTIONS(1777),
    [anon_sym_atomicrmw] = ACTIONS(1777),
    [anon_sym_fence] = ACTIONS(1777),
    [anon_sym_getelementptr] = ACTIONS(1777),
    [anon_sym_extractvalue] = ACTIONS(1777),
    [anon_sym_insertvalue] = ACTIONS(1777),
    [anon_sym_mul] = ACTIONS(1777),
    [anon_sym_urem] = ACTIONS(1777),
    [anon_sym_srem] = ACTIONS(1777),
    [anon_sym_shl] = ACTIONS(1777),
    [anon_sym_udiv] = ACTIONS(1777),
    [anon_sym_sdiv] = ACTIONS(1777),
    [anon_sym_lshr] = ACTIONS(1777),
    [anon_sym_ashr] = ACTIONS(1777),
    [anon_sym_fmul] = ACTIONS(1777),
    [anon_sym_fdiv] = ACTIONS(1777),
    [anon_sym_frem] = ACTIONS(1777),
    [anon_sym_xchg] = ACTIONS(1777),
    [anon_sym_add] = ACTIONS(1777),
    [anon_sym_sub] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1777),
    [anon_sym_nand] = ACTIONS(1777),
    [anon_sym_or] = ACTIONS(1777),
    [anon_sym_xor] = ACTIONS(1777),
    [anon_sym_max] = ACTIONS(1777),
    [anon_sym_min] = ACTIONS(1777),
    [anon_sym_umax] = ACTIONS(1777),
    [anon_sym_umin] = ACTIONS(1777),
    [anon_sym_fadd] = ACTIONS(1777),
    [anon_sym_fsub] = ACTIONS(1777),
    [anon_sym_bitcast] = ACTIONS(1777),
    [anon_sym_trunc] = ACTIONS(1777),
    [anon_sym_zext] = ACTIONS(1777),
    [anon_sym_sext] = ACTIONS(1777),
    [anon_sym_fptrunc] = ACTIONS(1777),
    [anon_sym_fpext] = ACTIONS(1777),
    [anon_sym_addrspacecast] = ACTIONS(1777),
    [anon_sym_uitofp] = ACTIONS(1777),
    [anon_sym_sitofp] = ACTIONS(1777),
    [anon_sym_fptoui] = ACTIONS(1777),
    [anon_sym_fptosi] = ACTIONS(1777),
    [anon_sym_inttoptr] = ACTIONS(1777),
    [anon_sym_ptrtoint] = ACTIONS(1777),
    [anon_sym_uselistorder] = ACTIONS(1777),
  },
  [551] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(558),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1772),
    [sym_label] = ACTIONS(1772),
    [anon_sym_RBRACE] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_unreachable] = ACTIONS(1777),
    [anon_sym_ret] = ACTIONS(1777),
    [anon_sym_br] = ACTIONS(1777),
    [anon_sym_resume] = ACTIONS(1777),
    [anon_sym_freeze] = ACTIONS(1777),
    [anon_sym_indirectbr] = ACTIONS(1777),
    [anon_sym_extractelement] = ACTIONS(1777),
    [anon_sym_insertelement] = ACTIONS(1777),
    [anon_sym_select] = ACTIONS(1777),
    [anon_sym_shufflevector] = ACTIONS(1777),
    [anon_sym_fneg] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(1777),
    [anon_sym_invoke] = ACTIONS(1777),
    [anon_sym_cleanupret] = ACTIONS(1777),
    [anon_sym_catchret] = ACTIONS(1777),
    [anon_sym_catchswitch] = ACTIONS(1777),
    [anon_sym_catchpad] = ACTIONS(1777),
    [anon_sym_cleanuppad] = ACTIONS(1777),
    [anon_sym_callbr] = ACTIONS(1777),
    [anon_sym_icmp] = ACTIONS(1777),
    [anon_sym_fcmp] = ACTIONS(1777),
    [anon_sym_va_arg] = ACTIONS(1777),
    [anon_sym_phi] = ACTIONS(1777),
    [anon_sym_landingpad] = ACTIONS(1777),
    [anon_sym_tail] = ACTIONS(1777),
    [anon_sym_musttail] = ACTIONS(1777),
    [anon_sym_notail] = ACTIONS(1777),
    [anon_sym_call] = ACTIONS(1777),
    [anon_sym_alloca] = ACTIONS(1777),
    [anon_sym_load] = ACTIONS(1777),
    [anon_sym_store] = ACTIONS(1777),
    [anon_sym_cmpxchg] = ACTIONS(1777),
    [anon_sym_atomicrmw] = ACTIONS(1777),
    [anon_sym_fence] = ACTIONS(1777),
    [anon_sym_getelementptr] = ACTIONS(1777),
    [anon_sym_extractvalue] = ACTIONS(1777),
    [anon_sym_insertvalue] = ACTIONS(1777),
    [anon_sym_mul] = ACTIONS(1777),
    [anon_sym_urem] = ACTIONS(1777),
    [anon_sym_srem] = ACTIONS(1777),
    [anon_sym_shl] = ACTIONS(1777),
    [anon_sym_udiv] = ACTIONS(1777),
    [anon_sym_sdiv] = ACTIONS(1777),
    [anon_sym_lshr] = ACTIONS(1777),
    [anon_sym_ashr] = ACTIONS(1777),
    [anon_sym_fmul] = ACTIONS(1777),
    [anon_sym_fdiv] = ACTIONS(1777),
    [anon_sym_frem] = ACTIONS(1777),
    [anon_sym_xchg] = ACTIONS(1777),
    [anon_sym_add] = ACTIONS(1777),
    [anon_sym_sub] = ACTIONS(1777),
    [anon_sym_and] = ACTIONS(1777),
    [anon_sym_nand] = ACTIONS(1777),
    [anon_sym_or] = ACTIONS(1777),
    [anon_sym_xor] = ACTIONS(1777),
    [anon_sym_max] = ACTIONS(1777),
    [anon_sym_min] = ACTIONS(1777),
    [anon_sym_umax] = ACTIONS(1777),
    [anon_sym_umin] = ACTIONS(1777),
    [anon_sym_fadd] = ACTIONS(1777),
    [anon_sym_fsub] = ACTIONS(1777),
    [anon_sym_bitcast] = ACTIONS(1777),
    [anon_sym_trunc] = ACTIONS(1777),
    [anon_sym_zext] = ACTIONS(1777),
    [anon_sym_sext] = ACTIONS(1777),
    [anon_sym_fptrunc] = ACTIONS(1777),
    [anon_sym_fpext] = ACTIONS(1777),
    [anon_sym_addrspacecast] = ACTIONS(1777),
    [anon_sym_uitofp] = ACTIONS(1777),
    [anon_sym_sitofp] = ACTIONS(1777),
    [anon_sym_fptoui] = ACTIONS(1777),
    [anon_sym_fptosi] = ACTIONS(1777),
    [anon_sym_inttoptr] = ACTIONS(1777),
    [anon_sym_ptrtoint] = ACTIONS(1777),
    [anon_sym_uselistorder] = ACTIONS(1777),
  },
  [552] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(553),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1779),
    [sym_label] = ACTIONS(1779),
    [anon_sym_RBRACE] = ACTIONS(1779),
    [anon_sym_COMMA] = ACTIONS(1781),
    [anon_sym_unreachable] = ACTIONS(1784),
    [anon_sym_ret] = ACTIONS(1784),
    [anon_sym_br] = ACTIONS(1784),
    [anon_sym_resume] = ACTIONS(1784),
    [anon_sym_freeze] = ACTIONS(1784),
    [anon_sym_indirectbr] = ACTIONS(1784),
    [anon_sym_extractelement] = ACTIONS(1784),
    [anon_sym_insertelement] = ACTIONS(1784),
    [anon_sym_select] = ACTIONS(1784),
    [anon_sym_shufflevector] = ACTIONS(1784),
    [anon_sym_fneg] = ACTIONS(1784),
    [anon_sym_switch] = ACTIONS(1784),
    [anon_sym_invoke] = ACTIONS(1784),
    [anon_sym_cleanupret] = ACTIONS(1784),
    [anon_sym_catchret] = ACTIONS(1784),
    [anon_sym_catchswitch] = ACTIONS(1784),
    [anon_sym_catchpad] = ACTIONS(1784),
    [anon_sym_cleanuppad] = ACTIONS(1784),
    [anon_sym_callbr] = ACTIONS(1784),
    [anon_sym_icmp] = ACTIONS(1784),
    [anon_sym_fcmp] = ACTIONS(1784),
    [anon_sym_va_arg] = ACTIONS(1784),
    [anon_sym_phi] = ACTIONS(1784),
    [anon_sym_landingpad] = ACTIONS(1784),
    [anon_sym_tail] = ACTIONS(1784),
    [anon_sym_musttail] = ACTIONS(1784),
    [anon_sym_notail] = ACTIONS(1784),
    [anon_sym_call] = ACTIONS(1784),
    [anon_sym_alloca] = ACTIONS(1784),
    [anon_sym_load] = ACTIONS(1784),
    [anon_sym_store] = ACTIONS(1784),
    [anon_sym_cmpxchg] = ACTIONS(1784),
    [anon_sym_atomicrmw] = ACTIONS(1784),
    [anon_sym_fence] = ACTIONS(1784),
    [anon_sym_getelementptr] = ACTIONS(1784),
    [anon_sym_extractvalue] = ACTIONS(1784),
    [anon_sym_insertvalue] = ACTIONS(1784),
    [anon_sym_mul] = ACTIONS(1784),
    [anon_sym_urem] = ACTIONS(1784),
    [anon_sym_srem] = ACTIONS(1784),
    [anon_sym_shl] = ACTIONS(1784),
    [anon_sym_udiv] = ACTIONS(1784),
    [anon_sym_sdiv] = ACTIONS(1784),
    [anon_sym_lshr] = ACTIONS(1784),
    [anon_sym_ashr] = ACTIONS(1784),
    [anon_sym_fmul] = ACTIONS(1784),
    [anon_sym_fdiv] = ACTIONS(1784),
    [anon_sym_frem] = ACTIONS(1784),
    [anon_sym_xchg] = ACTIONS(1784),
    [anon_sym_add] = ACTIONS(1784),
    [anon_sym_sub] = ACTIONS(1784),
    [anon_sym_and] = ACTIONS(1784),
    [anon_sym_nand] = ACTIONS(1784),
    [anon_sym_or] = ACTIONS(1784),
    [anon_sym_xor] = ACTIONS(1784),
    [anon_sym_max] = ACTIONS(1784),
    [anon_sym_min] = ACTIONS(1784),
    [anon_sym_umax] = ACTIONS(1784),
    [anon_sym_umin] = ACTIONS(1784),
    [anon_sym_fadd] = ACTIONS(1784),
    [anon_sym_fsub] = ACTIONS(1784),
    [anon_sym_bitcast] = ACTIONS(1784),
    [anon_sym_trunc] = ACTIONS(1784),
    [anon_sym_zext] = ACTIONS(1784),
    [anon_sym_sext] = ACTIONS(1784),
    [anon_sym_fptrunc] = ACTIONS(1784),
    [anon_sym_fpext] = ACTIONS(1784),
    [anon_sym_addrspacecast] = ACTIONS(1784),
    [anon_sym_uitofp] = ACTIONS(1784),
    [anon_sym_sitofp] = ACTIONS(1784),
    [anon_sym_fptoui] = ACTIONS(1784),
    [anon_sym_fptosi] = ACTIONS(1784),
    [anon_sym_inttoptr] = ACTIONS(1784),
    [anon_sym_ptrtoint] = ACTIONS(1784),
    [anon_sym_uselistorder] = ACTIONS(1784),
  },
  [553] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(553),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1786),
    [sym_label] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_COMMA] = ACTIONS(1788),
    [anon_sym_unreachable] = ACTIONS(1791),
    [anon_sym_ret] = ACTIONS(1791),
    [anon_sym_br] = ACTIONS(1791),
    [anon_sym_resume] = ACTIONS(1791),
    [anon_sym_freeze] = ACTIONS(1791),
    [anon_sym_indirectbr] = ACTIONS(1791),
    [anon_sym_extractelement] = ACTIONS(1791),
    [anon_sym_insertelement] = ACTIONS(1791),
    [anon_sym_select] = ACTIONS(1791),
    [anon_sym_shufflevector] = ACTIONS(1791),
    [anon_sym_fneg] = ACTIONS(1791),
    [anon_sym_switch] = ACTIONS(1791),
    [anon_sym_invoke] = ACTIONS(1791),
    [anon_sym_cleanupret] = ACTIONS(1791),
    [anon_sym_catchret] = ACTIONS(1791),
    [anon_sym_catchswitch] = ACTIONS(1791),
    [anon_sym_catchpad] = ACTIONS(1791),
    [anon_sym_cleanuppad] = ACTIONS(1791),
    [anon_sym_callbr] = ACTIONS(1791),
    [anon_sym_icmp] = ACTIONS(1791),
    [anon_sym_fcmp] = ACTIONS(1791),
    [anon_sym_va_arg] = ACTIONS(1791),
    [anon_sym_phi] = ACTIONS(1791),
    [anon_sym_landingpad] = ACTIONS(1791),
    [anon_sym_tail] = ACTIONS(1791),
    [anon_sym_musttail] = ACTIONS(1791),
    [anon_sym_notail] = ACTIONS(1791),
    [anon_sym_call] = ACTIONS(1791),
    [anon_sym_alloca] = ACTIONS(1791),
    [anon_sym_load] = ACTIONS(1791),
    [anon_sym_store] = ACTIONS(1791),
    [anon_sym_cmpxchg] = ACTIONS(1791),
    [anon_sym_atomicrmw] = ACTIONS(1791),
    [anon_sym_fence] = ACTIONS(1791),
    [anon_sym_getelementptr] = ACTIONS(1791),
    [anon_sym_extractvalue] = ACTIONS(1791),
    [anon_sym_insertvalue] = ACTIONS(1791),
    [anon_sym_mul] = ACTIONS(1791),
    [anon_sym_urem] = ACTIONS(1791),
    [anon_sym_srem] = ACTIONS(1791),
    [anon_sym_shl] = ACTIONS(1791),
    [anon_sym_udiv] = ACTIONS(1791),
    [anon_sym_sdiv] = ACTIONS(1791),
    [anon_sym_lshr] = ACTIONS(1791),
    [anon_sym_ashr] = ACTIONS(1791),
    [anon_sym_fmul] = ACTIONS(1791),
    [anon_sym_fdiv] = ACTIONS(1791),
    [anon_sym_frem] = ACTIONS(1791),
    [anon_sym_xchg] = ACTIONS(1791),
    [anon_sym_add] = ACTIONS(1791),
    [anon_sym_sub] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(1791),
    [anon_sym_nand] = ACTIONS(1791),
    [anon_sym_or] = ACTIONS(1791),
    [anon_sym_xor] = ACTIONS(1791),
    [anon_sym_max] = ACTIONS(1791),
    [anon_sym_min] = ACTIONS(1791),
    [anon_sym_umax] = ACTIONS(1791),
    [anon_sym_umin] = ACTIONS(1791),
    [anon_sym_fadd] = ACTIONS(1791),
    [anon_sym_fsub] = ACTIONS(1791),
    [anon_sym_bitcast] = ACTIONS(1791),
    [anon_sym_trunc] = ACTIONS(1791),
    [anon_sym_zext] = ACTIONS(1791),
    [anon_sym_sext] = ACTIONS(1791),
    [anon_sym_fptrunc] = ACTIONS(1791),
    [anon_sym_fpext] = ACTIONS(1791),
    [anon_sym_addrspacecast] = ACTIONS(1791),
    [anon_sym_uitofp] = ACTIONS(1791),
    [anon_sym_sitofp] = ACTIONS(1791),
    [anon_sym_fptoui] = ACTIONS(1791),
    [anon_sym_fptosi] = ACTIONS(1791),
    [anon_sym_inttoptr] = ACTIONS(1791),
    [anon_sym_ptrtoint] = ACTIONS(1791),
    [anon_sym_uselistorder] = ACTIONS(1791),
  },
  [554] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(559),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1793),
    [sym_label] = ACTIONS(1793),
    [anon_sym_RBRACE] = ACTIONS(1793),
    [anon_sym_COMMA] = ACTIONS(1795),
    [anon_sym_unreachable] = ACTIONS(1798),
    [anon_sym_ret] = ACTIONS(1798),
    [anon_sym_br] = ACTIONS(1798),
    [anon_sym_resume] = ACTIONS(1798),
    [anon_sym_freeze] = ACTIONS(1798),
    [anon_sym_indirectbr] = ACTIONS(1798),
    [anon_sym_extractelement] = ACTIONS(1798),
    [anon_sym_insertelement] = ACTIONS(1798),
    [anon_sym_select] = ACTIONS(1798),
    [anon_sym_shufflevector] = ACTIONS(1798),
    [anon_sym_fneg] = ACTIONS(1798),
    [anon_sym_switch] = ACTIONS(1798),
    [anon_sym_invoke] = ACTIONS(1798),
    [anon_sym_cleanupret] = ACTIONS(1798),
    [anon_sym_catchret] = ACTIONS(1798),
    [anon_sym_catchswitch] = ACTIONS(1798),
    [anon_sym_catchpad] = ACTIONS(1798),
    [anon_sym_cleanuppad] = ACTIONS(1798),
    [anon_sym_callbr] = ACTIONS(1798),
    [anon_sym_icmp] = ACTIONS(1798),
    [anon_sym_fcmp] = ACTIONS(1798),
    [anon_sym_va_arg] = ACTIONS(1798),
    [anon_sym_phi] = ACTIONS(1798),
    [anon_sym_landingpad] = ACTIONS(1798),
    [anon_sym_tail] = ACTIONS(1798),
    [anon_sym_musttail] = ACTIONS(1798),
    [anon_sym_notail] = ACTIONS(1798),
    [anon_sym_call] = ACTIONS(1798),
    [anon_sym_alloca] = ACTIONS(1798),
    [anon_sym_load] = ACTIONS(1798),
    [anon_sym_store] = ACTIONS(1798),
    [anon_sym_cmpxchg] = ACTIONS(1798),
    [anon_sym_atomicrmw] = ACTIONS(1798),
    [anon_sym_fence] = ACTIONS(1798),
    [anon_sym_getelementptr] = ACTIONS(1798),
    [anon_sym_extractvalue] = ACTIONS(1798),
    [anon_sym_insertvalue] = ACTIONS(1798),
    [anon_sym_mul] = ACTIONS(1798),
    [anon_sym_urem] = ACTIONS(1798),
    [anon_sym_srem] = ACTIONS(1798),
    [anon_sym_shl] = ACTIONS(1798),
    [anon_sym_udiv] = ACTIONS(1798),
    [anon_sym_sdiv] = ACTIONS(1798),
    [anon_sym_lshr] = ACTIONS(1798),
    [anon_sym_ashr] = ACTIONS(1798),
    [anon_sym_fmul] = ACTIONS(1798),
    [anon_sym_fdiv] = ACTIONS(1798),
    [anon_sym_frem] = ACTIONS(1798),
    [anon_sym_xchg] = ACTIONS(1798),
    [anon_sym_add] = ACTIONS(1798),
    [anon_sym_sub] = ACTIONS(1798),
    [anon_sym_and] = ACTIONS(1798),
    [anon_sym_nand] = ACTIONS(1798),
    [anon_sym_or] = ACTIONS(1798),
    [anon_sym_xor] = ACTIONS(1798),
    [anon_sym_max] = ACTIONS(1798),
    [anon_sym_min] = ACTIONS(1798),
    [anon_sym_umax] = ACTIONS(1798),
    [anon_sym_umin] = ACTIONS(1798),
    [anon_sym_fadd] = ACTIONS(1798),
    [anon_sym_fsub] = ACTIONS(1798),
    [anon_sym_bitcast] = ACTIONS(1798),
    [anon_sym_trunc] = ACTIONS(1798),
    [anon_sym_zext] = ACTIONS(1798),
    [anon_sym_sext] = ACTIONS(1798),
    [anon_sym_fptrunc] = ACTIONS(1798),
    [anon_sym_fpext] = ACTIONS(1798),
    [anon_sym_addrspacecast] = ACTIONS(1798),
    [anon_sym_uitofp] = ACTIONS(1798),
    [anon_sym_sitofp] = ACTIONS(1798),
    [anon_sym_fptoui] = ACTIONS(1798),
    [anon_sym_fptosi] = ACTIONS(1798),
    [anon_sym_inttoptr] = ACTIONS(1798),
    [anon_sym_ptrtoint] = ACTIONS(1798),
    [anon_sym_uselistorder] = ACTIONS(1798),
  },
  [555] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1800),
    [sym_label] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_unreachable] = ACTIONS(1802),
    [anon_sym_ret] = ACTIONS(1802),
    [anon_sym_br] = ACTIONS(1802),
    [anon_sym_resume] = ACTIONS(1802),
    [anon_sym_freeze] = ACTIONS(1802),
    [anon_sym_indirectbr] = ACTIONS(1802),
    [anon_sym_extractelement] = ACTIONS(1802),
    [anon_sym_insertelement] = ACTIONS(1802),
    [anon_sym_select] = ACTIONS(1802),
    [anon_sym_shufflevector] = ACTIONS(1802),
    [anon_sym_fneg] = ACTIONS(1802),
    [anon_sym_switch] = ACTIONS(1802),
    [anon_sym_invoke] = ACTIONS(1802),
    [anon_sym_cleanupret] = ACTIONS(1802),
    [anon_sym_catchret] = ACTIONS(1802),
    [anon_sym_catchswitch] = ACTIONS(1802),
    [anon_sym_catchpad] = ACTIONS(1802),
    [anon_sym_cleanuppad] = ACTIONS(1802),
    [anon_sym_callbr] = ACTIONS(1802),
    [anon_sym_icmp] = ACTIONS(1802),
    [anon_sym_fcmp] = ACTIONS(1802),
    [anon_sym_va_arg] = ACTIONS(1802),
    [anon_sym_phi] = ACTIONS(1802),
    [anon_sym_landingpad] = ACTIONS(1802),
    [anon_sym_tail] = ACTIONS(1802),
    [anon_sym_musttail] = ACTIONS(1802),
    [anon_sym_notail] = ACTIONS(1802),
    [anon_sym_call] = ACTIONS(1802),
    [anon_sym_alloca] = ACTIONS(1802),
    [anon_sym_load] = ACTIONS(1802),
    [anon_sym_store] = ACTIONS(1802),
    [anon_sym_cmpxchg] = ACTIONS(1802),
    [anon_sym_atomicrmw] = ACTIONS(1802),
    [anon_sym_fence] = ACTIONS(1802),
    [anon_sym_getelementptr] = ACTIONS(1802),
    [anon_sym_extractvalue] = ACTIONS(1802),
    [anon_sym_insertvalue] = ACTIONS(1802),
    [anon_sym_mul] = ACTIONS(1802),
    [anon_sym_urem] = ACTIONS(1802),
    [anon_sym_srem] = ACTIONS(1802),
    [anon_sym_shl] = ACTIONS(1802),
    [anon_sym_udiv] = ACTIONS(1802),
    [anon_sym_sdiv] = ACTIONS(1802),
    [anon_sym_lshr] = ACTIONS(1802),
    [anon_sym_ashr] = ACTIONS(1802),
    [anon_sym_fmul] = ACTIONS(1802),
    [anon_sym_fdiv] = ACTIONS(1802),
    [anon_sym_frem] = ACTIONS(1802),
    [anon_sym_xchg] = ACTIONS(1802),
    [anon_sym_add] = ACTIONS(1802),
    [anon_sym_sub] = ACTIONS(1802),
    [anon_sym_and] = ACTIONS(1802),
    [anon_sym_nand] = ACTIONS(1802),
    [anon_sym_or] = ACTIONS(1802),
    [anon_sym_xor] = ACTIONS(1802),
    [anon_sym_max] = ACTIONS(1802),
    [anon_sym_min] = ACTIONS(1802),
    [anon_sym_umax] = ACTIONS(1802),
    [anon_sym_umin] = ACTIONS(1802),
    [anon_sym_fadd] = ACTIONS(1802),
    [anon_sym_fsub] = ACTIONS(1802),
    [anon_sym_bitcast] = ACTIONS(1802),
    [anon_sym_trunc] = ACTIONS(1802),
    [anon_sym_zext] = ACTIONS(1802),
    [anon_sym_sext] = ACTIONS(1802),
    [anon_sym_fptrunc] = ACTIONS(1802),
    [anon_sym_fpext] = ACTIONS(1802),
    [anon_sym_addrspacecast] = ACTIONS(1802),
    [anon_sym_uitofp] = ACTIONS(1802),
    [anon_sym_sitofp] = ACTIONS(1802),
    [anon_sym_fptoui] = ACTIONS(1802),
    [anon_sym_fptosi] = ACTIONS(1802),
    [anon_sym_inttoptr] = ACTIONS(1802),
    [anon_sym_ptrtoint] = ACTIONS(1802),
    [anon_sym_uselistorder] = ACTIONS(1802),
  },
  [556] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(569),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1804),
    [sym_label] = ACTIONS(1804),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(1806),
    [anon_sym_unreachable] = ACTIONS(1809),
    [anon_sym_ret] = ACTIONS(1809),
    [anon_sym_br] = ACTIONS(1809),
    [anon_sym_resume] = ACTIONS(1809),
    [anon_sym_freeze] = ACTIONS(1809),
    [anon_sym_indirectbr] = ACTIONS(1809),
    [anon_sym_extractelement] = ACTIONS(1809),
    [anon_sym_insertelement] = ACTIONS(1809),
    [anon_sym_select] = ACTIONS(1809),
    [anon_sym_shufflevector] = ACTIONS(1809),
    [anon_sym_fneg] = ACTIONS(1809),
    [anon_sym_switch] = ACTIONS(1809),
    [anon_sym_invoke] = ACTIONS(1809),
    [anon_sym_cleanupret] = ACTIONS(1809),
    [anon_sym_catchret] = ACTIONS(1809),
    [anon_sym_catchswitch] = ACTIONS(1809),
    [anon_sym_catchpad] = ACTIONS(1809),
    [anon_sym_cleanuppad] = ACTIONS(1809),
    [anon_sym_callbr] = ACTIONS(1809),
    [anon_sym_icmp] = ACTIONS(1809),
    [anon_sym_fcmp] = ACTIONS(1809),
    [anon_sym_va_arg] = ACTIONS(1809),
    [anon_sym_phi] = ACTIONS(1809),
    [anon_sym_landingpad] = ACTIONS(1809),
    [anon_sym_tail] = ACTIONS(1809),
    [anon_sym_musttail] = ACTIONS(1809),
    [anon_sym_notail] = ACTIONS(1809),
    [anon_sym_call] = ACTIONS(1809),
    [anon_sym_alloca] = ACTIONS(1809),
    [anon_sym_load] = ACTIONS(1809),
    [anon_sym_store] = ACTIONS(1809),
    [anon_sym_cmpxchg] = ACTIONS(1809),
    [anon_sym_atomicrmw] = ACTIONS(1809),
    [anon_sym_fence] = ACTIONS(1809),
    [anon_sym_getelementptr] = ACTIONS(1809),
    [anon_sym_extractvalue] = ACTIONS(1809),
    [anon_sym_insertvalue] = ACTIONS(1809),
    [anon_sym_mul] = ACTIONS(1809),
    [anon_sym_urem] = ACTIONS(1809),
    [anon_sym_srem] = ACTIONS(1809),
    [anon_sym_shl] = ACTIONS(1809),
    [anon_sym_udiv] = ACTIONS(1809),
    [anon_sym_sdiv] = ACTIONS(1809),
    [anon_sym_lshr] = ACTIONS(1809),
    [anon_sym_ashr] = ACTIONS(1809),
    [anon_sym_fmul] = ACTIONS(1809),
    [anon_sym_fdiv] = ACTIONS(1809),
    [anon_sym_frem] = ACTIONS(1809),
    [anon_sym_xchg] = ACTIONS(1809),
    [anon_sym_add] = ACTIONS(1809),
    [anon_sym_sub] = ACTIONS(1809),
    [anon_sym_and] = ACTIONS(1809),
    [anon_sym_nand] = ACTIONS(1809),
    [anon_sym_or] = ACTIONS(1809),
    [anon_sym_xor] = ACTIONS(1809),
    [anon_sym_max] = ACTIONS(1809),
    [anon_sym_min] = ACTIONS(1809),
    [anon_sym_umax] = ACTIONS(1809),
    [anon_sym_umin] = ACTIONS(1809),
    [anon_sym_fadd] = ACTIONS(1809),
    [anon_sym_fsub] = ACTIONS(1809),
    [anon_sym_bitcast] = ACTIONS(1809),
    [anon_sym_trunc] = ACTIONS(1809),
    [anon_sym_zext] = ACTIONS(1809),
    [anon_sym_sext] = ACTIONS(1809),
    [anon_sym_fptrunc] = ACTIONS(1809),
    [anon_sym_fpext] = ACTIONS(1809),
    [anon_sym_addrspacecast] = ACTIONS(1809),
    [anon_sym_uitofp] = ACTIONS(1809),
    [anon_sym_sitofp] = ACTIONS(1809),
    [anon_sym_fptoui] = ACTIONS(1809),
    [anon_sym_fptosi] = ACTIONS(1809),
    [anon_sym_inttoptr] = ACTIONS(1809),
    [anon_sym_ptrtoint] = ACTIONS(1809),
    [anon_sym_uselistorder] = ACTIONS(1809),
  },
  [557] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(558),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1811),
    [sym_label] = ACTIONS(1811),
    [anon_sym_RBRACE] = ACTIONS(1811),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_unreachable] = ACTIONS(1816),
    [anon_sym_ret] = ACTIONS(1816),
    [anon_sym_br] = ACTIONS(1816),
    [anon_sym_resume] = ACTIONS(1816),
    [anon_sym_freeze] = ACTIONS(1816),
    [anon_sym_indirectbr] = ACTIONS(1816),
    [anon_sym_extractelement] = ACTIONS(1816),
    [anon_sym_insertelement] = ACTIONS(1816),
    [anon_sym_select] = ACTIONS(1816),
    [anon_sym_shufflevector] = ACTIONS(1816),
    [anon_sym_fneg] = ACTIONS(1816),
    [anon_sym_switch] = ACTIONS(1816),
    [anon_sym_invoke] = ACTIONS(1816),
    [anon_sym_cleanupret] = ACTIONS(1816),
    [anon_sym_catchret] = ACTIONS(1816),
    [anon_sym_catchswitch] = ACTIONS(1816),
    [anon_sym_catchpad] = ACTIONS(1816),
    [anon_sym_cleanuppad] = ACTIONS(1816),
    [anon_sym_callbr] = ACTIONS(1816),
    [anon_sym_icmp] = ACTIONS(1816),
    [anon_sym_fcmp] = ACTIONS(1816),
    [anon_sym_va_arg] = ACTIONS(1816),
    [anon_sym_phi] = ACTIONS(1816),
    [anon_sym_landingpad] = ACTIONS(1816),
    [anon_sym_tail] = ACTIONS(1816),
    [anon_sym_musttail] = ACTIONS(1816),
    [anon_sym_notail] = ACTIONS(1816),
    [anon_sym_call] = ACTIONS(1816),
    [anon_sym_alloca] = ACTIONS(1816),
    [anon_sym_load] = ACTIONS(1816),
    [anon_sym_store] = ACTIONS(1816),
    [anon_sym_cmpxchg] = ACTIONS(1816),
    [anon_sym_atomicrmw] = ACTIONS(1816),
    [anon_sym_fence] = ACTIONS(1816),
    [anon_sym_getelementptr] = ACTIONS(1816),
    [anon_sym_extractvalue] = ACTIONS(1816),
    [anon_sym_insertvalue] = ACTIONS(1816),
    [anon_sym_mul] = ACTIONS(1816),
    [anon_sym_urem] = ACTIONS(1816),
    [anon_sym_srem] = ACTIONS(1816),
    [anon_sym_shl] = ACTIONS(1816),
    [anon_sym_udiv] = ACTIONS(1816),
    [anon_sym_sdiv] = ACTIONS(1816),
    [anon_sym_lshr] = ACTIONS(1816),
    [anon_sym_ashr] = ACTIONS(1816),
    [anon_sym_fmul] = ACTIONS(1816),
    [anon_sym_fdiv] = ACTIONS(1816),
    [anon_sym_frem] = ACTIONS(1816),
    [anon_sym_xchg] = ACTIONS(1816),
    [anon_sym_add] = ACTIONS(1816),
    [anon_sym_sub] = ACTIONS(1816),
    [anon_sym_and] = ACTIONS(1816),
    [anon_sym_nand] = ACTIONS(1816),
    [anon_sym_or] = ACTIONS(1816),
    [anon_sym_xor] = ACTIONS(1816),
    [anon_sym_max] = ACTIONS(1816),
    [anon_sym_min] = ACTIONS(1816),
    [anon_sym_umax] = ACTIONS(1816),
    [anon_sym_umin] = ACTIONS(1816),
    [anon_sym_fadd] = ACTIONS(1816),
    [anon_sym_fsub] = ACTIONS(1816),
    [anon_sym_bitcast] = ACTIONS(1816),
    [anon_sym_trunc] = ACTIONS(1816),
    [anon_sym_zext] = ACTIONS(1816),
    [anon_sym_sext] = ACTIONS(1816),
    [anon_sym_fptrunc] = ACTIONS(1816),
    [anon_sym_fpext] = ACTIONS(1816),
    [anon_sym_addrspacecast] = ACTIONS(1816),
    [anon_sym_uitofp] = ACTIONS(1816),
    [anon_sym_sitofp] = ACTIONS(1816),
    [anon_sym_fptoui] = ACTIONS(1816),
    [anon_sym_fptosi] = ACTIONS(1816),
    [anon_sym_inttoptr] = ACTIONS(1816),
    [anon_sym_ptrtoint] = ACTIONS(1816),
    [anon_sym_uselistorder] = ACTIONS(1816),
  },
  [558] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(558),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1741),
    [sym_label] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_COMMA] = ACTIONS(1818),
    [anon_sym_unreachable] = ACTIONS(1743),
    [anon_sym_ret] = ACTIONS(1743),
    [anon_sym_br] = ACTIONS(1743),
    [anon_sym_resume] = ACTIONS(1743),
    [anon_sym_freeze] = ACTIONS(1743),
    [anon_sym_indirectbr] = ACTIONS(1743),
    [anon_sym_extractelement] = ACTIONS(1743),
    [anon_sym_insertelement] = ACTIONS(1743),
    [anon_sym_select] = ACTIONS(1743),
    [anon_sym_shufflevector] = ACTIONS(1743),
    [anon_sym_fneg] = ACTIONS(1743),
    [anon_sym_switch] = ACTIONS(1743),
    [anon_sym_invoke] = ACTIONS(1743),
    [anon_sym_cleanupret] = ACTIONS(1743),
    [anon_sym_catchret] = ACTIONS(1743),
    [anon_sym_catchswitch] = ACTIONS(1743),
    [anon_sym_catchpad] = ACTIONS(1743),
    [anon_sym_cleanuppad] = ACTIONS(1743),
    [anon_sym_callbr] = ACTIONS(1743),
    [anon_sym_icmp] = ACTIONS(1743),
    [anon_sym_fcmp] = ACTIONS(1743),
    [anon_sym_va_arg] = ACTIONS(1743),
    [anon_sym_phi] = ACTIONS(1743),
    [anon_sym_landingpad] = ACTIONS(1743),
    [anon_sym_tail] = ACTIONS(1743),
    [anon_sym_musttail] = ACTIONS(1743),
    [anon_sym_notail] = ACTIONS(1743),
    [anon_sym_call] = ACTIONS(1743),
    [anon_sym_alloca] = ACTIONS(1743),
    [anon_sym_load] = ACTIONS(1743),
    [anon_sym_store] = ACTIONS(1743),
    [anon_sym_cmpxchg] = ACTIONS(1743),
    [anon_sym_atomicrmw] = ACTIONS(1743),
    [anon_sym_fence] = ACTIONS(1743),
    [anon_sym_getelementptr] = ACTIONS(1743),
    [anon_sym_extractvalue] = ACTIONS(1743),
    [anon_sym_insertvalue] = ACTIONS(1743),
    [anon_sym_mul] = ACTIONS(1743),
    [anon_sym_urem] = ACTIONS(1743),
    [anon_sym_srem] = ACTIONS(1743),
    [anon_sym_shl] = ACTIONS(1743),
    [anon_sym_udiv] = ACTIONS(1743),
    [anon_sym_sdiv] = ACTIONS(1743),
    [anon_sym_lshr] = ACTIONS(1743),
    [anon_sym_ashr] = ACTIONS(1743),
    [anon_sym_fmul] = ACTIONS(1743),
    [anon_sym_fdiv] = ACTIONS(1743),
    [anon_sym_frem] = ACTIONS(1743),
    [anon_sym_xchg] = ACTIONS(1743),
    [anon_sym_add] = ACTIONS(1743),
    [anon_sym_sub] = ACTIONS(1743),
    [anon_sym_and] = ACTIONS(1743),
    [anon_sym_nand] = ACTIONS(1743),
    [anon_sym_or] = ACTIONS(1743),
    [anon_sym_xor] = ACTIONS(1743),
    [anon_sym_max] = ACTIONS(1743),
    [anon_sym_min] = ACTIONS(1743),
    [anon_sym_umax] = ACTIONS(1743),
    [anon_sym_umin] = ACTIONS(1743),
    [anon_sym_fadd] = ACTIONS(1743),
    [anon_sym_fsub] = ACTIONS(1743),
    [anon_sym_bitcast] = ACTIONS(1743),
    [anon_sym_trunc] = ACTIONS(1743),
    [anon_sym_zext] = ACTIONS(1743),
    [anon_sym_sext] = ACTIONS(1743),
    [anon_sym_fptrunc] = ACTIONS(1743),
    [anon_sym_fpext] = ACTIONS(1743),
    [anon_sym_addrspacecast] = ACTIONS(1743),
    [anon_sym_uitofp] = ACTIONS(1743),
    [anon_sym_sitofp] = ACTIONS(1743),
    [anon_sym_fptoui] = ACTIONS(1743),
    [anon_sym_fptosi] = ACTIONS(1743),
    [anon_sym_inttoptr] = ACTIONS(1743),
    [anon_sym_ptrtoint] = ACTIONS(1743),
    [anon_sym_uselistorder] = ACTIONS(1743),
  },
  [559] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(558),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1821),
    [sym_label] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_COMMA] = ACTIONS(1823),
    [anon_sym_unreachable] = ACTIONS(1826),
    [anon_sym_ret] = ACTIONS(1826),
    [anon_sym_br] = ACTIONS(1826),
    [anon_sym_resume] = ACTIONS(1826),
    [anon_sym_freeze] = ACTIONS(1826),
    [anon_sym_indirectbr] = ACTIONS(1826),
    [anon_sym_extractelement] = ACTIONS(1826),
    [anon_sym_insertelement] = ACTIONS(1826),
    [anon_sym_select] = ACTIONS(1826),
    [anon_sym_shufflevector] = ACTIONS(1826),
    [anon_sym_fneg] = ACTIONS(1826),
    [anon_sym_switch] = ACTIONS(1826),
    [anon_sym_invoke] = ACTIONS(1826),
    [anon_sym_cleanupret] = ACTIONS(1826),
    [anon_sym_catchret] = ACTIONS(1826),
    [anon_sym_catchswitch] = ACTIONS(1826),
    [anon_sym_catchpad] = ACTIONS(1826),
    [anon_sym_cleanuppad] = ACTIONS(1826),
    [anon_sym_callbr] = ACTIONS(1826),
    [anon_sym_icmp] = ACTIONS(1826),
    [anon_sym_fcmp] = ACTIONS(1826),
    [anon_sym_va_arg] = ACTIONS(1826),
    [anon_sym_phi] = ACTIONS(1826),
    [anon_sym_landingpad] = ACTIONS(1826),
    [anon_sym_tail] = ACTIONS(1826),
    [anon_sym_musttail] = ACTIONS(1826),
    [anon_sym_notail] = ACTIONS(1826),
    [anon_sym_call] = ACTIONS(1826),
    [anon_sym_alloca] = ACTIONS(1826),
    [anon_sym_load] = ACTIONS(1826),
    [anon_sym_store] = ACTIONS(1826),
    [anon_sym_cmpxchg] = ACTIONS(1826),
    [anon_sym_atomicrmw] = ACTIONS(1826),
    [anon_sym_fence] = ACTIONS(1826),
    [anon_sym_getelementptr] = ACTIONS(1826),
    [anon_sym_extractvalue] = ACTIONS(1826),
    [anon_sym_insertvalue] = ACTIONS(1826),
    [anon_sym_mul] = ACTIONS(1826),
    [anon_sym_urem] = ACTIONS(1826),
    [anon_sym_srem] = ACTIONS(1826),
    [anon_sym_shl] = ACTIONS(1826),
    [anon_sym_udiv] = ACTIONS(1826),
    [anon_sym_sdiv] = ACTIONS(1826),
    [anon_sym_lshr] = ACTIONS(1826),
    [anon_sym_ashr] = ACTIONS(1826),
    [anon_sym_fmul] = ACTIONS(1826),
    [anon_sym_fdiv] = ACTIONS(1826),
    [anon_sym_frem] = ACTIONS(1826),
    [anon_sym_xchg] = ACTIONS(1826),
    [anon_sym_add] = ACTIONS(1826),
    [anon_sym_sub] = ACTIONS(1826),
    [anon_sym_and] = ACTIONS(1826),
    [anon_sym_nand] = ACTIONS(1826),
    [anon_sym_or] = ACTIONS(1826),
    [anon_sym_xor] = ACTIONS(1826),
    [anon_sym_max] = ACTIONS(1826),
    [anon_sym_min] = ACTIONS(1826),
    [anon_sym_umax] = ACTIONS(1826),
    [anon_sym_umin] = ACTIONS(1826),
    [anon_sym_fadd] = ACTIONS(1826),
    [anon_sym_fsub] = ACTIONS(1826),
    [anon_sym_bitcast] = ACTIONS(1826),
    [anon_sym_trunc] = ACTIONS(1826),
    [anon_sym_zext] = ACTIONS(1826),
    [anon_sym_sext] = ACTIONS(1826),
    [anon_sym_fptrunc] = ACTIONS(1826),
    [anon_sym_fpext] = ACTIONS(1826),
    [anon_sym_addrspacecast] = ACTIONS(1826),
    [anon_sym_uitofp] = ACTIONS(1826),
    [anon_sym_sitofp] = ACTIONS(1826),
    [anon_sym_fptoui] = ACTIONS(1826),
    [anon_sym_fptosi] = ACTIONS(1826),
    [anon_sym_inttoptr] = ACTIONS(1826),
    [anon_sym_ptrtoint] = ACTIONS(1826),
    [anon_sym_uselistorder] = ACTIONS(1826),
  },
  [560] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1828),
    [sym_label] = ACTIONS(1828),
    [anon_sym_RBRACE] = ACTIONS(1828),
    [anon_sym_COMMA] = ACTIONS(1828),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [anon_sym_unreachable] = ACTIONS(1830),
    [anon_sym_ret] = ACTIONS(1830),
    [anon_sym_br] = ACTIONS(1830),
    [anon_sym_resume] = ACTIONS(1830),
    [anon_sym_freeze] = ACTIONS(1830),
    [anon_sym_indirectbr] = ACTIONS(1830),
    [anon_sym_extractelement] = ACTIONS(1830),
    [anon_sym_insertelement] = ACTIONS(1830),
    [anon_sym_select] = ACTIONS(1830),
    [anon_sym_shufflevector] = ACTIONS(1830),
    [anon_sym_fneg] = ACTIONS(1830),
    [anon_sym_switch] = ACTIONS(1830),
    [anon_sym_invoke] = ACTIONS(1830),
    [anon_sym_cleanupret] = ACTIONS(1830),
    [anon_sym_catchret] = ACTIONS(1830),
    [anon_sym_catchswitch] = ACTIONS(1830),
    [anon_sym_catchpad] = ACTIONS(1830),
    [anon_sym_cleanuppad] = ACTIONS(1830),
    [anon_sym_callbr] = ACTIONS(1830),
    [anon_sym_icmp] = ACTIONS(1830),
    [anon_sym_fcmp] = ACTIONS(1830),
    [anon_sym_va_arg] = ACTIONS(1830),
    [anon_sym_phi] = ACTIONS(1830),
    [anon_sym_landingpad] = ACTIONS(1830),
    [anon_sym_tail] = ACTIONS(1830),
    [anon_sym_musttail] = ACTIONS(1830),
    [anon_sym_notail] = ACTIONS(1830),
    [anon_sym_call] = ACTIONS(1830),
    [anon_sym_alloca] = ACTIONS(1830),
    [anon_sym_load] = ACTIONS(1830),
    [anon_sym_store] = ACTIONS(1830),
    [anon_sym_cmpxchg] = ACTIONS(1830),
    [anon_sym_atomicrmw] = ACTIONS(1830),
    [anon_sym_fence] = ACTIONS(1830),
    [anon_sym_getelementptr] = ACTIONS(1830),
    [anon_sym_extractvalue] = ACTIONS(1830),
    [anon_sym_insertvalue] = ACTIONS(1830),
    [anon_sym_mul] = ACTIONS(1830),
    [anon_sym_urem] = ACTIONS(1830),
    [anon_sym_srem] = ACTIONS(1830),
    [anon_sym_shl] = ACTIONS(1830),
    [anon_sym_udiv] = ACTIONS(1830),
    [anon_sym_sdiv] = ACTIONS(1830),
    [anon_sym_lshr] = ACTIONS(1830),
    [anon_sym_ashr] = ACTIONS(1830),
    [anon_sym_fmul] = ACTIONS(1830),
    [anon_sym_fdiv] = ACTIONS(1830),
    [anon_sym_frem] = ACTIONS(1830),
    [anon_sym_xchg] = ACTIONS(1830),
    [anon_sym_add] = ACTIONS(1830),
    [anon_sym_sub] = ACTIONS(1830),
    [anon_sym_and] = ACTIONS(1830),
    [anon_sym_nand] = ACTIONS(1830),
    [anon_sym_or] = ACTIONS(1830),
    [anon_sym_xor] = ACTIONS(1830),
    [anon_sym_max] = ACTIONS(1830),
    [anon_sym_min] = ACTIONS(1830),
    [anon_sym_umax] = ACTIONS(1830),
    [anon_sym_umin] = ACTIONS(1830),
    [anon_sym_fadd] = ACTIONS(1830),
    [anon_sym_fsub] = ACTIONS(1830),
    [anon_sym_bitcast] = ACTIONS(1830),
    [anon_sym_trunc] = ACTIONS(1830),
    [anon_sym_zext] = ACTIONS(1830),
    [anon_sym_sext] = ACTIONS(1830),
    [anon_sym_fptrunc] = ACTIONS(1830),
    [anon_sym_fpext] = ACTIONS(1830),
    [anon_sym_addrspacecast] = ACTIONS(1830),
    [anon_sym_uitofp] = ACTIONS(1830),
    [anon_sym_sitofp] = ACTIONS(1830),
    [anon_sym_fptoui] = ACTIONS(1830),
    [anon_sym_fptosi] = ACTIONS(1830),
    [anon_sym_inttoptr] = ACTIONS(1830),
    [anon_sym_ptrtoint] = ACTIONS(1830),
    [anon_sym_uselistorder] = ACTIONS(1830),
  },
  [561] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(547),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1832),
    [sym_label] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_unreachable] = ACTIONS(1837),
    [anon_sym_ret] = ACTIONS(1837),
    [anon_sym_br] = ACTIONS(1837),
    [anon_sym_resume] = ACTIONS(1837),
    [anon_sym_freeze] = ACTIONS(1837),
    [anon_sym_indirectbr] = ACTIONS(1837),
    [anon_sym_extractelement] = ACTIONS(1837),
    [anon_sym_insertelement] = ACTIONS(1837),
    [anon_sym_select] = ACTIONS(1837),
    [anon_sym_shufflevector] = ACTIONS(1837),
    [anon_sym_fneg] = ACTIONS(1837),
    [anon_sym_switch] = ACTIONS(1837),
    [anon_sym_invoke] = ACTIONS(1837),
    [anon_sym_cleanupret] = ACTIONS(1837),
    [anon_sym_catchret] = ACTIONS(1837),
    [anon_sym_catchswitch] = ACTIONS(1837),
    [anon_sym_catchpad] = ACTIONS(1837),
    [anon_sym_cleanuppad] = ACTIONS(1837),
    [anon_sym_callbr] = ACTIONS(1837),
    [anon_sym_icmp] = ACTIONS(1837),
    [anon_sym_fcmp] = ACTIONS(1837),
    [anon_sym_va_arg] = ACTIONS(1837),
    [anon_sym_phi] = ACTIONS(1837),
    [anon_sym_landingpad] = ACTIONS(1837),
    [anon_sym_tail] = ACTIONS(1837),
    [anon_sym_musttail] = ACTIONS(1837),
    [anon_sym_notail] = ACTIONS(1837),
    [anon_sym_call] = ACTIONS(1837),
    [anon_sym_alloca] = ACTIONS(1837),
    [anon_sym_load] = ACTIONS(1837),
    [anon_sym_store] = ACTIONS(1837),
    [anon_sym_cmpxchg] = ACTIONS(1837),
    [anon_sym_atomicrmw] = ACTIONS(1837),
    [anon_sym_fence] = ACTIONS(1837),
    [anon_sym_getelementptr] = ACTIONS(1837),
    [anon_sym_extractvalue] = ACTIONS(1837),
    [anon_sym_insertvalue] = ACTIONS(1837),
    [anon_sym_mul] = ACTIONS(1837),
    [anon_sym_urem] = ACTIONS(1837),
    [anon_sym_srem] = ACTIONS(1837),
    [anon_sym_shl] = ACTIONS(1837),
    [anon_sym_udiv] = ACTIONS(1837),
    [anon_sym_sdiv] = ACTIONS(1837),
    [anon_sym_lshr] = ACTIONS(1837),
    [anon_sym_ashr] = ACTIONS(1837),
    [anon_sym_fmul] = ACTIONS(1837),
    [anon_sym_fdiv] = ACTIONS(1837),
    [anon_sym_frem] = ACTIONS(1837),
    [anon_sym_xchg] = ACTIONS(1837),
    [anon_sym_add] = ACTIONS(1837),
    [anon_sym_sub] = ACTIONS(1837),
    [anon_sym_and] = ACTIONS(1837),
    [anon_sym_nand] = ACTIONS(1837),
    [anon_sym_or] = ACTIONS(1837),
    [anon_sym_xor] = ACTIONS(1837),
    [anon_sym_max] = ACTIONS(1837),
    [anon_sym_min] = ACTIONS(1837),
    [anon_sym_umax] = ACTIONS(1837),
    [anon_sym_umin] = ACTIONS(1837),
    [anon_sym_fadd] = ACTIONS(1837),
    [anon_sym_fsub] = ACTIONS(1837),
    [anon_sym_bitcast] = ACTIONS(1837),
    [anon_sym_trunc] = ACTIONS(1837),
    [anon_sym_zext] = ACTIONS(1837),
    [anon_sym_sext] = ACTIONS(1837),
    [anon_sym_fptrunc] = ACTIONS(1837),
    [anon_sym_fpext] = ACTIONS(1837),
    [anon_sym_addrspacecast] = ACTIONS(1837),
    [anon_sym_uitofp] = ACTIONS(1837),
    [anon_sym_sitofp] = ACTIONS(1837),
    [anon_sym_fptoui] = ACTIONS(1837),
    [anon_sym_fptosi] = ACTIONS(1837),
    [anon_sym_inttoptr] = ACTIONS(1837),
    [anon_sym_ptrtoint] = ACTIONS(1837),
    [anon_sym_uselistorder] = ACTIONS(1837),
  },
  [562] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(551),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1821),
    [sym_label] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1821),
    [anon_sym_COMMA] = ACTIONS(1823),
    [anon_sym_unreachable] = ACTIONS(1826),
    [anon_sym_ret] = ACTIONS(1826),
    [anon_sym_br] = ACTIONS(1826),
    [anon_sym_resume] = ACTIONS(1826),
    [anon_sym_freeze] = ACTIONS(1826),
    [anon_sym_indirectbr] = ACTIONS(1826),
    [anon_sym_extractelement] = ACTIONS(1826),
    [anon_sym_insertelement] = ACTIONS(1826),
    [anon_sym_select] = ACTIONS(1826),
    [anon_sym_shufflevector] = ACTIONS(1826),
    [anon_sym_fneg] = ACTIONS(1826),
    [anon_sym_switch] = ACTIONS(1826),
    [anon_sym_invoke] = ACTIONS(1826),
    [anon_sym_cleanupret] = ACTIONS(1826),
    [anon_sym_catchret] = ACTIONS(1826),
    [anon_sym_catchswitch] = ACTIONS(1826),
    [anon_sym_catchpad] = ACTIONS(1826),
    [anon_sym_cleanuppad] = ACTIONS(1826),
    [anon_sym_callbr] = ACTIONS(1826),
    [anon_sym_icmp] = ACTIONS(1826),
    [anon_sym_fcmp] = ACTIONS(1826),
    [anon_sym_va_arg] = ACTIONS(1826),
    [anon_sym_phi] = ACTIONS(1826),
    [anon_sym_landingpad] = ACTIONS(1826),
    [anon_sym_tail] = ACTIONS(1826),
    [anon_sym_musttail] = ACTIONS(1826),
    [anon_sym_notail] = ACTIONS(1826),
    [anon_sym_call] = ACTIONS(1826),
    [anon_sym_alloca] = ACTIONS(1826),
    [anon_sym_load] = ACTIONS(1826),
    [anon_sym_store] = ACTIONS(1826),
    [anon_sym_cmpxchg] = ACTIONS(1826),
    [anon_sym_atomicrmw] = ACTIONS(1826),
    [anon_sym_fence] = ACTIONS(1826),
    [anon_sym_getelementptr] = ACTIONS(1826),
    [anon_sym_extractvalue] = ACTIONS(1826),
    [anon_sym_insertvalue] = ACTIONS(1826),
    [anon_sym_mul] = ACTIONS(1826),
    [anon_sym_urem] = ACTIONS(1826),
    [anon_sym_srem] = ACTIONS(1826),
    [anon_sym_shl] = ACTIONS(1826),
    [anon_sym_udiv] = ACTIONS(1826),
    [anon_sym_sdiv] = ACTIONS(1826),
    [anon_sym_lshr] = ACTIONS(1826),
    [anon_sym_ashr] = ACTIONS(1826),
    [anon_sym_fmul] = ACTIONS(1826),
    [anon_sym_fdiv] = ACTIONS(1826),
    [anon_sym_frem] = ACTIONS(1826),
    [anon_sym_xchg] = ACTIONS(1826),
    [anon_sym_add] = ACTIONS(1826),
    [anon_sym_sub] = ACTIONS(1826),
    [anon_sym_and] = ACTIONS(1826),
    [anon_sym_nand] = ACTIONS(1826),
    [anon_sym_or] = ACTIONS(1826),
    [anon_sym_xor] = ACTIONS(1826),
    [anon_sym_max] = ACTIONS(1826),
    [anon_sym_min] = ACTIONS(1826),
    [anon_sym_umax] = ACTIONS(1826),
    [anon_sym_umin] = ACTIONS(1826),
    [anon_sym_fadd] = ACTIONS(1826),
    [anon_sym_fsub] = ACTIONS(1826),
    [anon_sym_bitcast] = ACTIONS(1826),
    [anon_sym_trunc] = ACTIONS(1826),
    [anon_sym_zext] = ACTIONS(1826),
    [anon_sym_sext] = ACTIONS(1826),
    [anon_sym_fptrunc] = ACTIONS(1826),
    [anon_sym_fpext] = ACTIONS(1826),
    [anon_sym_addrspacecast] = ACTIONS(1826),
    [anon_sym_uitofp] = ACTIONS(1826),
    [anon_sym_sitofp] = ACTIONS(1826),
    [anon_sym_fptoui] = ACTIONS(1826),
    [anon_sym_fptosi] = ACTIONS(1826),
    [anon_sym_inttoptr] = ACTIONS(1826),
    [anon_sym_ptrtoint] = ACTIONS(1826),
    [anon_sym_uselistorder] = ACTIONS(1826),
  },
  [563] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(552),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1839),
    [sym_label] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1839),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_unreachable] = ACTIONS(1844),
    [anon_sym_ret] = ACTIONS(1844),
    [anon_sym_br] = ACTIONS(1844),
    [anon_sym_resume] = ACTIONS(1844),
    [anon_sym_freeze] = ACTIONS(1844),
    [anon_sym_indirectbr] = ACTIONS(1844),
    [anon_sym_extractelement] = ACTIONS(1844),
    [anon_sym_insertelement] = ACTIONS(1844),
    [anon_sym_select] = ACTIONS(1844),
    [anon_sym_shufflevector] = ACTIONS(1844),
    [anon_sym_fneg] = ACTIONS(1844),
    [anon_sym_switch] = ACTIONS(1844),
    [anon_sym_invoke] = ACTIONS(1844),
    [anon_sym_cleanupret] = ACTIONS(1844),
    [anon_sym_catchret] = ACTIONS(1844),
    [anon_sym_catchswitch] = ACTIONS(1844),
    [anon_sym_catchpad] = ACTIONS(1844),
    [anon_sym_cleanuppad] = ACTIONS(1844),
    [anon_sym_callbr] = ACTIONS(1844),
    [anon_sym_icmp] = ACTIONS(1844),
    [anon_sym_fcmp] = ACTIONS(1844),
    [anon_sym_va_arg] = ACTIONS(1844),
    [anon_sym_phi] = ACTIONS(1844),
    [anon_sym_landingpad] = ACTIONS(1844),
    [anon_sym_tail] = ACTIONS(1844),
    [anon_sym_musttail] = ACTIONS(1844),
    [anon_sym_notail] = ACTIONS(1844),
    [anon_sym_call] = ACTIONS(1844),
    [anon_sym_alloca] = ACTIONS(1844),
    [anon_sym_load] = ACTIONS(1844),
    [anon_sym_store] = ACTIONS(1844),
    [anon_sym_cmpxchg] = ACTIONS(1844),
    [anon_sym_atomicrmw] = ACTIONS(1844),
    [anon_sym_fence] = ACTIONS(1844),
    [anon_sym_getelementptr] = ACTIONS(1844),
    [anon_sym_extractvalue] = ACTIONS(1844),
    [anon_sym_insertvalue] = ACTIONS(1844),
    [anon_sym_mul] = ACTIONS(1844),
    [anon_sym_urem] = ACTIONS(1844),
    [anon_sym_srem] = ACTIONS(1844),
    [anon_sym_shl] = ACTIONS(1844),
    [anon_sym_udiv] = ACTIONS(1844),
    [anon_sym_sdiv] = ACTIONS(1844),
    [anon_sym_lshr] = ACTIONS(1844),
    [anon_sym_ashr] = ACTIONS(1844),
    [anon_sym_fmul] = ACTIONS(1844),
    [anon_sym_fdiv] = ACTIONS(1844),
    [anon_sym_frem] = ACTIONS(1844),
    [anon_sym_xchg] = ACTIONS(1844),
    [anon_sym_add] = ACTIONS(1844),
    [anon_sym_sub] = ACTIONS(1844),
    [anon_sym_and] = ACTIONS(1844),
    [anon_sym_nand] = ACTIONS(1844),
    [anon_sym_or] = ACTIONS(1844),
    [anon_sym_xor] = ACTIONS(1844),
    [anon_sym_max] = ACTIONS(1844),
    [anon_sym_min] = ACTIONS(1844),
    [anon_sym_umax] = ACTIONS(1844),
    [anon_sym_umin] = ACTIONS(1844),
    [anon_sym_fadd] = ACTIONS(1844),
    [anon_sym_fsub] = ACTIONS(1844),
    [anon_sym_bitcast] = ACTIONS(1844),
    [anon_sym_trunc] = ACTIONS(1844),
    [anon_sym_zext] = ACTIONS(1844),
    [anon_sym_sext] = ACTIONS(1844),
    [anon_sym_fptrunc] = ACTIONS(1844),
    [anon_sym_fpext] = ACTIONS(1844),
    [anon_sym_addrspacecast] = ACTIONS(1844),
    [anon_sym_uitofp] = ACTIONS(1844),
    [anon_sym_sitofp] = ACTIONS(1844),
    [anon_sym_fptoui] = ACTIONS(1844),
    [anon_sym_fptosi] = ACTIONS(1844),
    [anon_sym_inttoptr] = ACTIONS(1844),
    [anon_sym_ptrtoint] = ACTIONS(1844),
    [anon_sym_uselistorder] = ACTIONS(1844),
  },
  [564] = {
    [aux_sym_instruction_phi_repeat1] = STATE(566),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1846),
    [sym_label] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_COMMA] = ACTIONS(1848),
    [anon_sym_unreachable] = ACTIONS(1851),
    [anon_sym_ret] = ACTIONS(1851),
    [anon_sym_br] = ACTIONS(1851),
    [anon_sym_resume] = ACTIONS(1851),
    [anon_sym_freeze] = ACTIONS(1851),
    [anon_sym_indirectbr] = ACTIONS(1851),
    [anon_sym_extractelement] = ACTIONS(1851),
    [anon_sym_insertelement] = ACTIONS(1851),
    [anon_sym_select] = ACTIONS(1851),
    [anon_sym_shufflevector] = ACTIONS(1851),
    [anon_sym_fneg] = ACTIONS(1851),
    [anon_sym_switch] = ACTIONS(1851),
    [anon_sym_invoke] = ACTIONS(1851),
    [anon_sym_cleanupret] = ACTIONS(1851),
    [anon_sym_catchret] = ACTIONS(1851),
    [anon_sym_catchswitch] = ACTIONS(1851),
    [anon_sym_catchpad] = ACTIONS(1851),
    [anon_sym_cleanuppad] = ACTIONS(1851),
    [anon_sym_callbr] = ACTIONS(1851),
    [anon_sym_icmp] = ACTIONS(1851),
    [anon_sym_fcmp] = ACTIONS(1851),
    [anon_sym_va_arg] = ACTIONS(1851),
    [anon_sym_phi] = ACTIONS(1851),
    [anon_sym_landingpad] = ACTIONS(1851),
    [anon_sym_tail] = ACTIONS(1851),
    [anon_sym_musttail] = ACTIONS(1851),
    [anon_sym_notail] = ACTIONS(1851),
    [anon_sym_call] = ACTIONS(1851),
    [anon_sym_alloca] = ACTIONS(1851),
    [anon_sym_load] = ACTIONS(1851),
    [anon_sym_store] = ACTIONS(1851),
    [anon_sym_cmpxchg] = ACTIONS(1851),
    [anon_sym_atomicrmw] = ACTIONS(1851),
    [anon_sym_fence] = ACTIONS(1851),
    [anon_sym_getelementptr] = ACTIONS(1851),
    [anon_sym_extractvalue] = ACTIONS(1851),
    [anon_sym_insertvalue] = ACTIONS(1851),
    [anon_sym_mul] = ACTIONS(1851),
    [anon_sym_urem] = ACTIONS(1851),
    [anon_sym_srem] = ACTIONS(1851),
    [anon_sym_shl] = ACTIONS(1851),
    [anon_sym_udiv] = ACTIONS(1851),
    [anon_sym_sdiv] = ACTIONS(1851),
    [anon_sym_lshr] = ACTIONS(1851),
    [anon_sym_ashr] = ACTIONS(1851),
    [anon_sym_fmul] = ACTIONS(1851),
    [anon_sym_fdiv] = ACTIONS(1851),
    [anon_sym_frem] = ACTIONS(1851),
    [anon_sym_xchg] = ACTIONS(1851),
    [anon_sym_add] = ACTIONS(1851),
    [anon_sym_sub] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1851),
    [anon_sym_nand] = ACTIONS(1851),
    [anon_sym_or] = ACTIONS(1851),
    [anon_sym_xor] = ACTIONS(1851),
    [anon_sym_max] = ACTIONS(1851),
    [anon_sym_min] = ACTIONS(1851),
    [anon_sym_umax] = ACTIONS(1851),
    [anon_sym_umin] = ACTIONS(1851),
    [anon_sym_fadd] = ACTIONS(1851),
    [anon_sym_fsub] = ACTIONS(1851),
    [anon_sym_bitcast] = ACTIONS(1851),
    [anon_sym_trunc] = ACTIONS(1851),
    [anon_sym_zext] = ACTIONS(1851),
    [anon_sym_sext] = ACTIONS(1851),
    [anon_sym_fptrunc] = ACTIONS(1851),
    [anon_sym_fpext] = ACTIONS(1851),
    [anon_sym_addrspacecast] = ACTIONS(1851),
    [anon_sym_uitofp] = ACTIONS(1851),
    [anon_sym_sitofp] = ACTIONS(1851),
    [anon_sym_fptoui] = ACTIONS(1851),
    [anon_sym_fptosi] = ACTIONS(1851),
    [anon_sym_inttoptr] = ACTIONS(1851),
    [anon_sym_ptrtoint] = ACTIONS(1851),
    [anon_sym_uselistorder] = ACTIONS(1851),
  },
  [565] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(543),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1853),
    [sym_label] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1855),
    [anon_sym_unreachable] = ACTIONS(1858),
    [anon_sym_ret] = ACTIONS(1858),
    [anon_sym_br] = ACTIONS(1858),
    [anon_sym_resume] = ACTIONS(1858),
    [anon_sym_freeze] = ACTIONS(1858),
    [anon_sym_indirectbr] = ACTIONS(1858),
    [anon_sym_extractelement] = ACTIONS(1858),
    [anon_sym_insertelement] = ACTIONS(1858),
    [anon_sym_select] = ACTIONS(1858),
    [anon_sym_shufflevector] = ACTIONS(1858),
    [anon_sym_fneg] = ACTIONS(1858),
    [anon_sym_switch] = ACTIONS(1858),
    [anon_sym_invoke] = ACTIONS(1858),
    [anon_sym_cleanupret] = ACTIONS(1858),
    [anon_sym_catchret] = ACTIONS(1858),
    [anon_sym_catchswitch] = ACTIONS(1858),
    [anon_sym_catchpad] = ACTIONS(1858),
    [anon_sym_cleanuppad] = ACTIONS(1858),
    [anon_sym_callbr] = ACTIONS(1858),
    [anon_sym_icmp] = ACTIONS(1858),
    [anon_sym_fcmp] = ACTIONS(1858),
    [anon_sym_va_arg] = ACTIONS(1858),
    [anon_sym_phi] = ACTIONS(1858),
    [anon_sym_landingpad] = ACTIONS(1858),
    [anon_sym_tail] = ACTIONS(1858),
    [anon_sym_musttail] = ACTIONS(1858),
    [anon_sym_notail] = ACTIONS(1858),
    [anon_sym_call] = ACTIONS(1858),
    [anon_sym_alloca] = ACTIONS(1858),
    [anon_sym_load] = ACTIONS(1858),
    [anon_sym_store] = ACTIONS(1858),
    [anon_sym_cmpxchg] = ACTIONS(1858),
    [anon_sym_atomicrmw] = ACTIONS(1858),
    [anon_sym_fence] = ACTIONS(1858),
    [anon_sym_getelementptr] = ACTIONS(1858),
    [anon_sym_extractvalue] = ACTIONS(1858),
    [anon_sym_insertvalue] = ACTIONS(1858),
    [anon_sym_mul] = ACTIONS(1858),
    [anon_sym_urem] = ACTIONS(1858),
    [anon_sym_srem] = ACTIONS(1858),
    [anon_sym_shl] = ACTIONS(1858),
    [anon_sym_udiv] = ACTIONS(1858),
    [anon_sym_sdiv] = ACTIONS(1858),
    [anon_sym_lshr] = ACTIONS(1858),
    [anon_sym_ashr] = ACTIONS(1858),
    [anon_sym_fmul] = ACTIONS(1858),
    [anon_sym_fdiv] = ACTIONS(1858),
    [anon_sym_frem] = ACTIONS(1858),
    [anon_sym_xchg] = ACTIONS(1858),
    [anon_sym_add] = ACTIONS(1858),
    [anon_sym_sub] = ACTIONS(1858),
    [anon_sym_and] = ACTIONS(1858),
    [anon_sym_nand] = ACTIONS(1858),
    [anon_sym_or] = ACTIONS(1858),
    [anon_sym_xor] = ACTIONS(1858),
    [anon_sym_max] = ACTIONS(1858),
    [anon_sym_min] = ACTIONS(1858),
    [anon_sym_umax] = ACTIONS(1858),
    [anon_sym_umin] = ACTIONS(1858),
    [anon_sym_fadd] = ACTIONS(1858),
    [anon_sym_fsub] = ACTIONS(1858),
    [anon_sym_bitcast] = ACTIONS(1858),
    [anon_sym_trunc] = ACTIONS(1858),
    [anon_sym_zext] = ACTIONS(1858),
    [anon_sym_sext] = ACTIONS(1858),
    [anon_sym_fptrunc] = ACTIONS(1858),
    [anon_sym_fpext] = ACTIONS(1858),
    [anon_sym_addrspacecast] = ACTIONS(1858),
    [anon_sym_uitofp] = ACTIONS(1858),
    [anon_sym_sitofp] = ACTIONS(1858),
    [anon_sym_fptoui] = ACTIONS(1858),
    [anon_sym_fptosi] = ACTIONS(1858),
    [anon_sym_inttoptr] = ACTIONS(1858),
    [anon_sym_ptrtoint] = ACTIONS(1858),
    [anon_sym_uselistorder] = ACTIONS(1858),
  },
  [566] = {
    [aux_sym_instruction_phi_repeat1] = STATE(566),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1860),
    [sym_label] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_unreachable] = ACTIONS(1865),
    [anon_sym_ret] = ACTIONS(1865),
    [anon_sym_br] = ACTIONS(1865),
    [anon_sym_resume] = ACTIONS(1865),
    [anon_sym_freeze] = ACTIONS(1865),
    [anon_sym_indirectbr] = ACTIONS(1865),
    [anon_sym_extractelement] = ACTIONS(1865),
    [anon_sym_insertelement] = ACTIONS(1865),
    [anon_sym_select] = ACTIONS(1865),
    [anon_sym_shufflevector] = ACTIONS(1865),
    [anon_sym_fneg] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1865),
    [anon_sym_invoke] = ACTIONS(1865),
    [anon_sym_cleanupret] = ACTIONS(1865),
    [anon_sym_catchret] = ACTIONS(1865),
    [anon_sym_catchswitch] = ACTIONS(1865),
    [anon_sym_catchpad] = ACTIONS(1865),
    [anon_sym_cleanuppad] = ACTIONS(1865),
    [anon_sym_callbr] = ACTIONS(1865),
    [anon_sym_icmp] = ACTIONS(1865),
    [anon_sym_fcmp] = ACTIONS(1865),
    [anon_sym_va_arg] = ACTIONS(1865),
    [anon_sym_phi] = ACTIONS(1865),
    [anon_sym_landingpad] = ACTIONS(1865),
    [anon_sym_tail] = ACTIONS(1865),
    [anon_sym_musttail] = ACTIONS(1865),
    [anon_sym_notail] = ACTIONS(1865),
    [anon_sym_call] = ACTIONS(1865),
    [anon_sym_alloca] = ACTIONS(1865),
    [anon_sym_load] = ACTIONS(1865),
    [anon_sym_store] = ACTIONS(1865),
    [anon_sym_cmpxchg] = ACTIONS(1865),
    [anon_sym_atomicrmw] = ACTIONS(1865),
    [anon_sym_fence] = ACTIONS(1865),
    [anon_sym_getelementptr] = ACTIONS(1865),
    [anon_sym_extractvalue] = ACTIONS(1865),
    [anon_sym_insertvalue] = ACTIONS(1865),
    [anon_sym_mul] = ACTIONS(1865),
    [anon_sym_urem] = ACTIONS(1865),
    [anon_sym_srem] = ACTIONS(1865),
    [anon_sym_shl] = ACTIONS(1865),
    [anon_sym_udiv] = ACTIONS(1865),
    [anon_sym_sdiv] = ACTIONS(1865),
    [anon_sym_lshr] = ACTIONS(1865),
    [anon_sym_ashr] = ACTIONS(1865),
    [anon_sym_fmul] = ACTIONS(1865),
    [anon_sym_fdiv] = ACTIONS(1865),
    [anon_sym_frem] = ACTIONS(1865),
    [anon_sym_xchg] = ACTIONS(1865),
    [anon_sym_add] = ACTIONS(1865),
    [anon_sym_sub] = ACTIONS(1865),
    [anon_sym_and] = ACTIONS(1865),
    [anon_sym_nand] = ACTIONS(1865),
    [anon_sym_or] = ACTIONS(1865),
    [anon_sym_xor] = ACTIONS(1865),
    [anon_sym_max] = ACTIONS(1865),
    [anon_sym_min] = ACTIONS(1865),
    [anon_sym_umax] = ACTIONS(1865),
    [anon_sym_umin] = ACTIONS(1865),
    [anon_sym_fadd] = ACTIONS(1865),
    [anon_sym_fsub] = ACTIONS(1865),
    [anon_sym_bitcast] = ACTIONS(1865),
    [anon_sym_trunc] = ACTIONS(1865),
    [anon_sym_zext] = ACTIONS(1865),
    [anon_sym_sext] = ACTIONS(1865),
    [anon_sym_fptrunc] = ACTIONS(1865),
    [anon_sym_fpext] = ACTIONS(1865),
    [anon_sym_addrspacecast] = ACTIONS(1865),
    [anon_sym_uitofp] = ACTIONS(1865),
    [anon_sym_sitofp] = ACTIONS(1865),
    [anon_sym_fptoui] = ACTIONS(1865),
    [anon_sym_fptosi] = ACTIONS(1865),
    [anon_sym_inttoptr] = ACTIONS(1865),
    [anon_sym_ptrtoint] = ACTIONS(1865),
    [anon_sym_uselistorder] = ACTIONS(1865),
  },
  [567] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(553),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1839),
    [sym_label] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1839),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_unreachable] = ACTIONS(1844),
    [anon_sym_ret] = ACTIONS(1844),
    [anon_sym_br] = ACTIONS(1844),
    [anon_sym_resume] = ACTIONS(1844),
    [anon_sym_freeze] = ACTIONS(1844),
    [anon_sym_indirectbr] = ACTIONS(1844),
    [anon_sym_extractelement] = ACTIONS(1844),
    [anon_sym_insertelement] = ACTIONS(1844),
    [anon_sym_select] = ACTIONS(1844),
    [anon_sym_shufflevector] = ACTIONS(1844),
    [anon_sym_fneg] = ACTIONS(1844),
    [anon_sym_switch] = ACTIONS(1844),
    [anon_sym_invoke] = ACTIONS(1844),
    [anon_sym_cleanupret] = ACTIONS(1844),
    [anon_sym_catchret] = ACTIONS(1844),
    [anon_sym_catchswitch] = ACTIONS(1844),
    [anon_sym_catchpad] = ACTIONS(1844),
    [anon_sym_cleanuppad] = ACTIONS(1844),
    [anon_sym_callbr] = ACTIONS(1844),
    [anon_sym_icmp] = ACTIONS(1844),
    [anon_sym_fcmp] = ACTIONS(1844),
    [anon_sym_va_arg] = ACTIONS(1844),
    [anon_sym_phi] = ACTIONS(1844),
    [anon_sym_landingpad] = ACTIONS(1844),
    [anon_sym_tail] = ACTIONS(1844),
    [anon_sym_musttail] = ACTIONS(1844),
    [anon_sym_notail] = ACTIONS(1844),
    [anon_sym_call] = ACTIONS(1844),
    [anon_sym_alloca] = ACTIONS(1844),
    [anon_sym_load] = ACTIONS(1844),
    [anon_sym_store] = ACTIONS(1844),
    [anon_sym_cmpxchg] = ACTIONS(1844),
    [anon_sym_atomicrmw] = ACTIONS(1844),
    [anon_sym_fence] = ACTIONS(1844),
    [anon_sym_getelementptr] = ACTIONS(1844),
    [anon_sym_extractvalue] = ACTIONS(1844),
    [anon_sym_insertvalue] = ACTIONS(1844),
    [anon_sym_mul] = ACTIONS(1844),
    [anon_sym_urem] = ACTIONS(1844),
    [anon_sym_srem] = ACTIONS(1844),
    [anon_sym_shl] = ACTIONS(1844),
    [anon_sym_udiv] = ACTIONS(1844),
    [anon_sym_sdiv] = ACTIONS(1844),
    [anon_sym_lshr] = ACTIONS(1844),
    [anon_sym_ashr] = ACTIONS(1844),
    [anon_sym_fmul] = ACTIONS(1844),
    [anon_sym_fdiv] = ACTIONS(1844),
    [anon_sym_frem] = ACTIONS(1844),
    [anon_sym_xchg] = ACTIONS(1844),
    [anon_sym_add] = ACTIONS(1844),
    [anon_sym_sub] = ACTIONS(1844),
    [anon_sym_and] = ACTIONS(1844),
    [anon_sym_nand] = ACTIONS(1844),
    [anon_sym_or] = ACTIONS(1844),
    [anon_sym_xor] = ACTIONS(1844),
    [anon_sym_max] = ACTIONS(1844),
    [anon_sym_min] = ACTIONS(1844),
    [anon_sym_umax] = ACTIONS(1844),
    [anon_sym_umin] = ACTIONS(1844),
    [anon_sym_fadd] = ACTIONS(1844),
    [anon_sym_fsub] = ACTIONS(1844),
    [anon_sym_bitcast] = ACTIONS(1844),
    [anon_sym_trunc] = ACTIONS(1844),
    [anon_sym_zext] = ACTIONS(1844),
    [anon_sym_sext] = ACTIONS(1844),
    [anon_sym_fptrunc] = ACTIONS(1844),
    [anon_sym_fpext] = ACTIONS(1844),
    [anon_sym_addrspacecast] = ACTIONS(1844),
    [anon_sym_uitofp] = ACTIONS(1844),
    [anon_sym_sitofp] = ACTIONS(1844),
    [anon_sym_fptoui] = ACTIONS(1844),
    [anon_sym_fptosi] = ACTIONS(1844),
    [anon_sym_inttoptr] = ACTIONS(1844),
    [anon_sym_ptrtoint] = ACTIONS(1844),
    [anon_sym_uselistorder] = ACTIONS(1844),
  },
  [568] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(556),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1867),
    [sym_label] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_unreachable] = ACTIONS(1872),
    [anon_sym_ret] = ACTIONS(1872),
    [anon_sym_br] = ACTIONS(1872),
    [anon_sym_resume] = ACTIONS(1872),
    [anon_sym_freeze] = ACTIONS(1872),
    [anon_sym_indirectbr] = ACTIONS(1872),
    [anon_sym_extractelement] = ACTIONS(1872),
    [anon_sym_insertelement] = ACTIONS(1872),
    [anon_sym_select] = ACTIONS(1872),
    [anon_sym_shufflevector] = ACTIONS(1872),
    [anon_sym_fneg] = ACTIONS(1872),
    [anon_sym_switch] = ACTIONS(1872),
    [anon_sym_invoke] = ACTIONS(1872),
    [anon_sym_cleanupret] = ACTIONS(1872),
    [anon_sym_catchret] = ACTIONS(1872),
    [anon_sym_catchswitch] = ACTIONS(1872),
    [anon_sym_catchpad] = ACTIONS(1872),
    [anon_sym_cleanuppad] = ACTIONS(1872),
    [anon_sym_callbr] = ACTIONS(1872),
    [anon_sym_icmp] = ACTIONS(1872),
    [anon_sym_fcmp] = ACTIONS(1872),
    [anon_sym_va_arg] = ACTIONS(1872),
    [anon_sym_phi] = ACTIONS(1872),
    [anon_sym_landingpad] = ACTIONS(1872),
    [anon_sym_tail] = ACTIONS(1872),
    [anon_sym_musttail] = ACTIONS(1872),
    [anon_sym_notail] = ACTIONS(1872),
    [anon_sym_call] = ACTIONS(1872),
    [anon_sym_alloca] = ACTIONS(1872),
    [anon_sym_load] = ACTIONS(1872),
    [anon_sym_store] = ACTIONS(1872),
    [anon_sym_cmpxchg] = ACTIONS(1872),
    [anon_sym_atomicrmw] = ACTIONS(1872),
    [anon_sym_fence] = ACTIONS(1872),
    [anon_sym_getelementptr] = ACTIONS(1872),
    [anon_sym_extractvalue] = ACTIONS(1872),
    [anon_sym_insertvalue] = ACTIONS(1872),
    [anon_sym_mul] = ACTIONS(1872),
    [anon_sym_urem] = ACTIONS(1872),
    [anon_sym_srem] = ACTIONS(1872),
    [anon_sym_shl] = ACTIONS(1872),
    [anon_sym_udiv] = ACTIONS(1872),
    [anon_sym_sdiv] = ACTIONS(1872),
    [anon_sym_lshr] = ACTIONS(1872),
    [anon_sym_ashr] = ACTIONS(1872),
    [anon_sym_fmul] = ACTIONS(1872),
    [anon_sym_fdiv] = ACTIONS(1872),
    [anon_sym_frem] = ACTIONS(1872),
    [anon_sym_xchg] = ACTIONS(1872),
    [anon_sym_add] = ACTIONS(1872),
    [anon_sym_sub] = ACTIONS(1872),
    [anon_sym_and] = ACTIONS(1872),
    [anon_sym_nand] = ACTIONS(1872),
    [anon_sym_or] = ACTIONS(1872),
    [anon_sym_xor] = ACTIONS(1872),
    [anon_sym_max] = ACTIONS(1872),
    [anon_sym_min] = ACTIONS(1872),
    [anon_sym_umax] = ACTIONS(1872),
    [anon_sym_umin] = ACTIONS(1872),
    [anon_sym_fadd] = ACTIONS(1872),
    [anon_sym_fsub] = ACTIONS(1872),
    [anon_sym_bitcast] = ACTIONS(1872),
    [anon_sym_trunc] = ACTIONS(1872),
    [anon_sym_zext] = ACTIONS(1872),
    [anon_sym_sext] = ACTIONS(1872),
    [anon_sym_fptrunc] = ACTIONS(1872),
    [anon_sym_fpext] = ACTIONS(1872),
    [anon_sym_addrspacecast] = ACTIONS(1872),
    [anon_sym_uitofp] = ACTIONS(1872),
    [anon_sym_sitofp] = ACTIONS(1872),
    [anon_sym_fptoui] = ACTIONS(1872),
    [anon_sym_fptosi] = ACTIONS(1872),
    [anon_sym_inttoptr] = ACTIONS(1872),
    [anon_sym_ptrtoint] = ACTIONS(1872),
    [anon_sym_uselistorder] = ACTIONS(1872),
  },
  [569] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(569),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1800),
    [sym_label] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(1874),
    [anon_sym_unreachable] = ACTIONS(1802),
    [anon_sym_ret] = ACTIONS(1802),
    [anon_sym_br] = ACTIONS(1802),
    [anon_sym_resume] = ACTIONS(1802),
    [anon_sym_freeze] = ACTIONS(1802),
    [anon_sym_indirectbr] = ACTIONS(1802),
    [anon_sym_extractelement] = ACTIONS(1802),
    [anon_sym_insertelement] = ACTIONS(1802),
    [anon_sym_select] = ACTIONS(1802),
    [anon_sym_shufflevector] = ACTIONS(1802),
    [anon_sym_fneg] = ACTIONS(1802),
    [anon_sym_switch] = ACTIONS(1802),
    [anon_sym_invoke] = ACTIONS(1802),
    [anon_sym_cleanupret] = ACTIONS(1802),
    [anon_sym_catchret] = ACTIONS(1802),
    [anon_sym_catchswitch] = ACTIONS(1802),
    [anon_sym_catchpad] = ACTIONS(1802),
    [anon_sym_cleanuppad] = ACTIONS(1802),
    [anon_sym_callbr] = ACTIONS(1802),
    [anon_sym_icmp] = ACTIONS(1802),
    [anon_sym_fcmp] = ACTIONS(1802),
    [anon_sym_va_arg] = ACTIONS(1802),
    [anon_sym_phi] = ACTIONS(1802),
    [anon_sym_landingpad] = ACTIONS(1802),
    [anon_sym_tail] = ACTIONS(1802),
    [anon_sym_musttail] = ACTIONS(1802),
    [anon_sym_notail] = ACTIONS(1802),
    [anon_sym_call] = ACTIONS(1802),
    [anon_sym_alloca] = ACTIONS(1802),
    [anon_sym_load] = ACTIONS(1802),
    [anon_sym_store] = ACTIONS(1802),
    [anon_sym_cmpxchg] = ACTIONS(1802),
    [anon_sym_atomicrmw] = ACTIONS(1802),
    [anon_sym_fence] = ACTIONS(1802),
    [anon_sym_getelementptr] = ACTIONS(1802),
    [anon_sym_extractvalue] = ACTIONS(1802),
    [anon_sym_insertvalue] = ACTIONS(1802),
    [anon_sym_mul] = ACTIONS(1802),
    [anon_sym_urem] = ACTIONS(1802),
    [anon_sym_srem] = ACTIONS(1802),
    [anon_sym_shl] = ACTIONS(1802),
    [anon_sym_udiv] = ACTIONS(1802),
    [anon_sym_sdiv] = ACTIONS(1802),
    [anon_sym_lshr] = ACTIONS(1802),
    [anon_sym_ashr] = ACTIONS(1802),
    [anon_sym_fmul] = ACTIONS(1802),
    [anon_sym_fdiv] = ACTIONS(1802),
    [anon_sym_frem] = ACTIONS(1802),
    [anon_sym_xchg] = ACTIONS(1802),
    [anon_sym_add] = ACTIONS(1802),
    [anon_sym_sub] = ACTIONS(1802),
    [anon_sym_and] = ACTIONS(1802),
    [anon_sym_nand] = ACTIONS(1802),
    [anon_sym_or] = ACTIONS(1802),
    [anon_sym_xor] = ACTIONS(1802),
    [anon_sym_max] = ACTIONS(1802),
    [anon_sym_min] = ACTIONS(1802),
    [anon_sym_umax] = ACTIONS(1802),
    [anon_sym_umin] = ACTIONS(1802),
    [anon_sym_fadd] = ACTIONS(1802),
    [anon_sym_fsub] = ACTIONS(1802),
    [anon_sym_bitcast] = ACTIONS(1802),
    [anon_sym_trunc] = ACTIONS(1802),
    [anon_sym_zext] = ACTIONS(1802),
    [anon_sym_sext] = ACTIONS(1802),
    [anon_sym_fptrunc] = ACTIONS(1802),
    [anon_sym_fpext] = ACTIONS(1802),
    [anon_sym_addrspacecast] = ACTIONS(1802),
    [anon_sym_uitofp] = ACTIONS(1802),
    [anon_sym_sitofp] = ACTIONS(1802),
    [anon_sym_fptoui] = ACTIONS(1802),
    [anon_sym_fptosi] = ACTIONS(1802),
    [anon_sym_inttoptr] = ACTIONS(1802),
    [anon_sym_ptrtoint] = ACTIONS(1802),
    [anon_sym_uselistorder] = ACTIONS(1802),
  },
  [570] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(567),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1758),
    [sym_label] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_unreachable] = ACTIONS(1763),
    [anon_sym_ret] = ACTIONS(1763),
    [anon_sym_br] = ACTIONS(1763),
    [anon_sym_resume] = ACTIONS(1763),
    [anon_sym_freeze] = ACTIONS(1763),
    [anon_sym_indirectbr] = ACTIONS(1763),
    [anon_sym_extractelement] = ACTIONS(1763),
    [anon_sym_insertelement] = ACTIONS(1763),
    [anon_sym_select] = ACTIONS(1763),
    [anon_sym_shufflevector] = ACTIONS(1763),
    [anon_sym_fneg] = ACTIONS(1763),
    [anon_sym_switch] = ACTIONS(1763),
    [anon_sym_invoke] = ACTIONS(1763),
    [anon_sym_cleanupret] = ACTIONS(1763),
    [anon_sym_catchret] = ACTIONS(1763),
    [anon_sym_catchswitch] = ACTIONS(1763),
    [anon_sym_catchpad] = ACTIONS(1763),
    [anon_sym_cleanuppad] = ACTIONS(1763),
    [anon_sym_callbr] = ACTIONS(1763),
    [anon_sym_icmp] = ACTIONS(1763),
    [anon_sym_fcmp] = ACTIONS(1763),
    [anon_sym_va_arg] = ACTIONS(1763),
    [anon_sym_phi] = ACTIONS(1763),
    [anon_sym_landingpad] = ACTIONS(1763),
    [anon_sym_tail] = ACTIONS(1763),
    [anon_sym_musttail] = ACTIONS(1763),
    [anon_sym_notail] = ACTIONS(1763),
    [anon_sym_call] = ACTIONS(1763),
    [anon_sym_alloca] = ACTIONS(1763),
    [anon_sym_load] = ACTIONS(1763),
    [anon_sym_store] = ACTIONS(1763),
    [anon_sym_cmpxchg] = ACTIONS(1763),
    [anon_sym_atomicrmw] = ACTIONS(1763),
    [anon_sym_fence] = ACTIONS(1763),
    [anon_sym_getelementptr] = ACTIONS(1763),
    [anon_sym_extractvalue] = ACTIONS(1763),
    [anon_sym_insertvalue] = ACTIONS(1763),
    [anon_sym_mul] = ACTIONS(1763),
    [anon_sym_urem] = ACTIONS(1763),
    [anon_sym_srem] = ACTIONS(1763),
    [anon_sym_shl] = ACTIONS(1763),
    [anon_sym_udiv] = ACTIONS(1763),
    [anon_sym_sdiv] = ACTIONS(1763),
    [anon_sym_lshr] = ACTIONS(1763),
    [anon_sym_ashr] = ACTIONS(1763),
    [anon_sym_fmul] = ACTIONS(1763),
    [anon_sym_fdiv] = ACTIONS(1763),
    [anon_sym_frem] = ACTIONS(1763),
    [anon_sym_xchg] = ACTIONS(1763),
    [anon_sym_add] = ACTIONS(1763),
    [anon_sym_sub] = ACTIONS(1763),
    [anon_sym_and] = ACTIONS(1763),
    [anon_sym_nand] = ACTIONS(1763),
    [anon_sym_or] = ACTIONS(1763),
    [anon_sym_xor] = ACTIONS(1763),
    [anon_sym_max] = ACTIONS(1763),
    [anon_sym_min] = ACTIONS(1763),
    [anon_sym_umax] = ACTIONS(1763),
    [anon_sym_umin] = ACTIONS(1763),
    [anon_sym_fadd] = ACTIONS(1763),
    [anon_sym_fsub] = ACTIONS(1763),
    [anon_sym_bitcast] = ACTIONS(1763),
    [anon_sym_trunc] = ACTIONS(1763),
    [anon_sym_zext] = ACTIONS(1763),
    [anon_sym_sext] = ACTIONS(1763),
    [anon_sym_fptrunc] = ACTIONS(1763),
    [anon_sym_fpext] = ACTIONS(1763),
    [anon_sym_addrspacecast] = ACTIONS(1763),
    [anon_sym_uitofp] = ACTIONS(1763),
    [anon_sym_sitofp] = ACTIONS(1763),
    [anon_sym_fptoui] = ACTIONS(1763),
    [anon_sym_fptosi] = ACTIONS(1763),
    [anon_sym_inttoptr] = ACTIONS(1763),
    [anon_sym_ptrtoint] = ACTIONS(1763),
    [anon_sym_uselistorder] = ACTIONS(1763),
  },
  [571] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1877),
    [sym_label] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_unreachable] = ACTIONS(1879),
    [anon_sym_ret] = ACTIONS(1879),
    [anon_sym_br] = ACTIONS(1879),
    [anon_sym_resume] = ACTIONS(1879),
    [anon_sym_freeze] = ACTIONS(1879),
    [anon_sym_indirectbr] = ACTIONS(1879),
    [anon_sym_extractelement] = ACTIONS(1879),
    [anon_sym_insertelement] = ACTIONS(1879),
    [anon_sym_select] = ACTIONS(1879),
    [anon_sym_shufflevector] = ACTIONS(1879),
    [anon_sym_fneg] = ACTIONS(1879),
    [anon_sym_switch] = ACTIONS(1879),
    [anon_sym_invoke] = ACTIONS(1879),
    [anon_sym_cleanupret] = ACTIONS(1879),
    [anon_sym_catchret] = ACTIONS(1879),
    [anon_sym_catchswitch] = ACTIONS(1879),
    [anon_sym_catchpad] = ACTIONS(1879),
    [anon_sym_cleanuppad] = ACTIONS(1879),
    [anon_sym_callbr] = ACTIONS(1879),
    [anon_sym_icmp] = ACTIONS(1879),
    [anon_sym_fcmp] = ACTIONS(1879),
    [anon_sym_va_arg] = ACTIONS(1879),
    [anon_sym_phi] = ACTIONS(1879),
    [anon_sym_landingpad] = ACTIONS(1879),
    [anon_sym_tail] = ACTIONS(1879),
    [anon_sym_musttail] = ACTIONS(1879),
    [anon_sym_notail] = ACTIONS(1879),
    [anon_sym_call] = ACTIONS(1879),
    [anon_sym_alloca] = ACTIONS(1879),
    [anon_sym_load] = ACTIONS(1879),
    [anon_sym_store] = ACTIONS(1879),
    [anon_sym_cmpxchg] = ACTIONS(1879),
    [anon_sym_atomicrmw] = ACTIONS(1879),
    [anon_sym_fence] = ACTIONS(1879),
    [anon_sym_getelementptr] = ACTIONS(1879),
    [anon_sym_extractvalue] = ACTIONS(1879),
    [anon_sym_insertvalue] = ACTIONS(1879),
    [anon_sym_mul] = ACTIONS(1879),
    [anon_sym_urem] = ACTIONS(1879),
    [anon_sym_srem] = ACTIONS(1879),
    [anon_sym_shl] = ACTIONS(1879),
    [anon_sym_udiv] = ACTIONS(1879),
    [anon_sym_sdiv] = ACTIONS(1879),
    [anon_sym_lshr] = ACTIONS(1879),
    [anon_sym_ashr] = ACTIONS(1879),
    [anon_sym_fmul] = ACTIONS(1879),
    [anon_sym_fdiv] = ACTIONS(1879),
    [anon_sym_frem] = ACTIONS(1879),
    [anon_sym_xchg] = ACTIONS(1879),
    [anon_sym_add] = ACTIONS(1879),
    [anon_sym_sub] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(1879),
    [anon_sym_nand] = ACTIONS(1879),
    [anon_sym_or] = ACTIONS(1879),
    [anon_sym_xor] = ACTIONS(1879),
    [anon_sym_max] = ACTIONS(1879),
    [anon_sym_min] = ACTIONS(1879),
    [anon_sym_umax] = ACTIONS(1879),
    [anon_sym_umin] = ACTIONS(1879),
    [anon_sym_fadd] = ACTIONS(1879),
    [anon_sym_fsub] = ACTIONS(1879),
    [anon_sym_bitcast] = ACTIONS(1879),
    [anon_sym_trunc] = ACTIONS(1879),
    [anon_sym_zext] = ACTIONS(1879),
    [anon_sym_sext] = ACTIONS(1879),
    [anon_sym_fptrunc] = ACTIONS(1879),
    [anon_sym_fpext] = ACTIONS(1879),
    [anon_sym_addrspacecast] = ACTIONS(1879),
    [anon_sym_uitofp] = ACTIONS(1879),
    [anon_sym_sitofp] = ACTIONS(1879),
    [anon_sym_fptoui] = ACTIONS(1879),
    [anon_sym_fptosi] = ACTIONS(1879),
    [anon_sym_inttoptr] = ACTIONS(1879),
    [anon_sym_ptrtoint] = ACTIONS(1879),
    [anon_sym_uselistorder] = ACTIONS(1879),
  },
  [572] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1881),
    [sym_label] = ACTIONS(1881),
    [anon_sym_RBRACE] = ACTIONS(1881),
    [anon_sym_COMMA] = ACTIONS(1881),
    [anon_sym_unreachable] = ACTIONS(1883),
    [anon_sym_ret] = ACTIONS(1883),
    [anon_sym_br] = ACTIONS(1883),
    [anon_sym_resume] = ACTIONS(1883),
    [anon_sym_freeze] = ACTIONS(1883),
    [anon_sym_indirectbr] = ACTIONS(1883),
    [anon_sym_extractelement] = ACTIONS(1883),
    [anon_sym_insertelement] = ACTIONS(1883),
    [anon_sym_select] = ACTIONS(1883),
    [anon_sym_shufflevector] = ACTIONS(1883),
    [anon_sym_fneg] = ACTIONS(1883),
    [anon_sym_switch] = ACTIONS(1883),
    [anon_sym_invoke] = ACTIONS(1883),
    [anon_sym_cleanupret] = ACTIONS(1883),
    [anon_sym_catchret] = ACTIONS(1883),
    [anon_sym_catchswitch] = ACTIONS(1883),
    [anon_sym_catchpad] = ACTIONS(1883),
    [anon_sym_cleanuppad] = ACTIONS(1883),
    [anon_sym_callbr] = ACTIONS(1883),
    [anon_sym_icmp] = ACTIONS(1883),
    [anon_sym_fcmp] = ACTIONS(1883),
    [anon_sym_va_arg] = ACTIONS(1883),
    [anon_sym_phi] = ACTIONS(1883),
    [anon_sym_landingpad] = ACTIONS(1883),
    [anon_sym_tail] = ACTIONS(1883),
    [anon_sym_musttail] = ACTIONS(1883),
    [anon_sym_notail] = ACTIONS(1883),
    [anon_sym_call] = ACTIONS(1883),
    [anon_sym_alloca] = ACTIONS(1883),
    [anon_sym_load] = ACTIONS(1883),
    [anon_sym_store] = ACTIONS(1883),
    [anon_sym_cmpxchg] = ACTIONS(1883),
    [anon_sym_atomicrmw] = ACTIONS(1883),
    [anon_sym_fence] = ACTIONS(1883),
    [anon_sym_getelementptr] = ACTIONS(1883),
    [anon_sym_extractvalue] = ACTIONS(1883),
    [anon_sym_insertvalue] = ACTIONS(1883),
    [anon_sym_mul] = ACTIONS(1883),
    [anon_sym_urem] = ACTIONS(1883),
    [anon_sym_srem] = ACTIONS(1883),
    [anon_sym_shl] = ACTIONS(1883),
    [anon_sym_udiv] = ACTIONS(1883),
    [anon_sym_sdiv] = ACTIONS(1883),
    [anon_sym_lshr] = ACTIONS(1883),
    [anon_sym_ashr] = ACTIONS(1883),
    [anon_sym_fmul] = ACTIONS(1883),
    [anon_sym_fdiv] = ACTIONS(1883),
    [anon_sym_frem] = ACTIONS(1883),
    [anon_sym_xchg] = ACTIONS(1883),
    [anon_sym_add] = ACTIONS(1883),
    [anon_sym_sub] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_nand] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_max] = ACTIONS(1883),
    [anon_sym_min] = ACTIONS(1883),
    [anon_sym_umax] = ACTIONS(1883),
    [anon_sym_umin] = ACTIONS(1883),
    [anon_sym_fadd] = ACTIONS(1883),
    [anon_sym_fsub] = ACTIONS(1883),
    [anon_sym_bitcast] = ACTIONS(1883),
    [anon_sym_trunc] = ACTIONS(1883),
    [anon_sym_zext] = ACTIONS(1883),
    [anon_sym_sext] = ACTIONS(1883),
    [anon_sym_fptrunc] = ACTIONS(1883),
    [anon_sym_fpext] = ACTIONS(1883),
    [anon_sym_addrspacecast] = ACTIONS(1883),
    [anon_sym_uitofp] = ACTIONS(1883),
    [anon_sym_sitofp] = ACTIONS(1883),
    [anon_sym_fptoui] = ACTIONS(1883),
    [anon_sym_fptosi] = ACTIONS(1883),
    [anon_sym_inttoptr] = ACTIONS(1883),
    [anon_sym_ptrtoint] = ACTIONS(1883),
    [anon_sym_uselistorder] = ACTIONS(1883),
  },
  [573] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1885),
    [sym_label] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_unreachable] = ACTIONS(1887),
    [anon_sym_ret] = ACTIONS(1887),
    [anon_sym_br] = ACTIONS(1887),
    [anon_sym_resume] = ACTIONS(1887),
    [anon_sym_freeze] = ACTIONS(1887),
    [anon_sym_indirectbr] = ACTIONS(1887),
    [anon_sym_extractelement] = ACTIONS(1887),
    [anon_sym_insertelement] = ACTIONS(1887),
    [anon_sym_select] = ACTIONS(1887),
    [anon_sym_shufflevector] = ACTIONS(1887),
    [anon_sym_fneg] = ACTIONS(1887),
    [anon_sym_switch] = ACTIONS(1887),
    [anon_sym_invoke] = ACTIONS(1887),
    [anon_sym_cleanupret] = ACTIONS(1887),
    [anon_sym_catchret] = ACTIONS(1887),
    [anon_sym_catchswitch] = ACTIONS(1887),
    [anon_sym_catchpad] = ACTIONS(1887),
    [anon_sym_cleanuppad] = ACTIONS(1887),
    [anon_sym_callbr] = ACTIONS(1887),
    [anon_sym_icmp] = ACTIONS(1887),
    [anon_sym_fcmp] = ACTIONS(1887),
    [anon_sym_va_arg] = ACTIONS(1887),
    [anon_sym_phi] = ACTIONS(1887),
    [anon_sym_landingpad] = ACTIONS(1887),
    [anon_sym_tail] = ACTIONS(1887),
    [anon_sym_musttail] = ACTIONS(1887),
    [anon_sym_notail] = ACTIONS(1887),
    [anon_sym_call] = ACTIONS(1887),
    [anon_sym_alloca] = ACTIONS(1887),
    [anon_sym_load] = ACTIONS(1887),
    [anon_sym_store] = ACTIONS(1887),
    [anon_sym_cmpxchg] = ACTIONS(1887),
    [anon_sym_atomicrmw] = ACTIONS(1887),
    [anon_sym_fence] = ACTIONS(1887),
    [anon_sym_getelementptr] = ACTIONS(1887),
    [anon_sym_extractvalue] = ACTIONS(1887),
    [anon_sym_insertvalue] = ACTIONS(1887),
    [anon_sym_mul] = ACTIONS(1887),
    [anon_sym_urem] = ACTIONS(1887),
    [anon_sym_srem] = ACTIONS(1887),
    [anon_sym_shl] = ACTIONS(1887),
    [anon_sym_udiv] = ACTIONS(1887),
    [anon_sym_sdiv] = ACTIONS(1887),
    [anon_sym_lshr] = ACTIONS(1887),
    [anon_sym_ashr] = ACTIONS(1887),
    [anon_sym_fmul] = ACTIONS(1887),
    [anon_sym_fdiv] = ACTIONS(1887),
    [anon_sym_frem] = ACTIONS(1887),
    [anon_sym_xchg] = ACTIONS(1887),
    [anon_sym_add] = ACTIONS(1887),
    [anon_sym_sub] = ACTIONS(1887),
    [anon_sym_and] = ACTIONS(1887),
    [anon_sym_nand] = ACTIONS(1887),
    [anon_sym_or] = ACTIONS(1887),
    [anon_sym_xor] = ACTIONS(1887),
    [anon_sym_max] = ACTIONS(1887),
    [anon_sym_min] = ACTIONS(1887),
    [anon_sym_umax] = ACTIONS(1887),
    [anon_sym_umin] = ACTIONS(1887),
    [anon_sym_fadd] = ACTIONS(1887),
    [anon_sym_fsub] = ACTIONS(1887),
    [anon_sym_bitcast] = ACTIONS(1887),
    [anon_sym_trunc] = ACTIONS(1887),
    [anon_sym_zext] = ACTIONS(1887),
    [anon_sym_sext] = ACTIONS(1887),
    [anon_sym_fptrunc] = ACTIONS(1887),
    [anon_sym_fpext] = ACTIONS(1887),
    [anon_sym_addrspacecast] = ACTIONS(1887),
    [anon_sym_uitofp] = ACTIONS(1887),
    [anon_sym_sitofp] = ACTIONS(1887),
    [anon_sym_fptoui] = ACTIONS(1887),
    [anon_sym_fptosi] = ACTIONS(1887),
    [anon_sym_inttoptr] = ACTIONS(1887),
    [anon_sym_ptrtoint] = ACTIONS(1887),
    [anon_sym_uselistorder] = ACTIONS(1887),
  },
  [574] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1889),
    [sym_label] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_COMMA] = ACTIONS(1891),
    [anon_sym_unreachable] = ACTIONS(1894),
    [anon_sym_ret] = ACTIONS(1894),
    [anon_sym_br] = ACTIONS(1894),
    [anon_sym_resume] = ACTIONS(1894),
    [anon_sym_freeze] = ACTIONS(1894),
    [anon_sym_indirectbr] = ACTIONS(1894),
    [anon_sym_extractelement] = ACTIONS(1894),
    [anon_sym_insertelement] = ACTIONS(1894),
    [anon_sym_select] = ACTIONS(1894),
    [anon_sym_shufflevector] = ACTIONS(1894),
    [anon_sym_fneg] = ACTIONS(1894),
    [anon_sym_switch] = ACTIONS(1894),
    [anon_sym_invoke] = ACTIONS(1894),
    [anon_sym_cleanupret] = ACTIONS(1894),
    [anon_sym_catchret] = ACTIONS(1894),
    [anon_sym_catchswitch] = ACTIONS(1894),
    [anon_sym_catchpad] = ACTIONS(1894),
    [anon_sym_cleanuppad] = ACTIONS(1894),
    [anon_sym_callbr] = ACTIONS(1894),
    [anon_sym_icmp] = ACTIONS(1894),
    [anon_sym_fcmp] = ACTIONS(1894),
    [anon_sym_va_arg] = ACTIONS(1894),
    [anon_sym_phi] = ACTIONS(1894),
    [anon_sym_landingpad] = ACTIONS(1894),
    [anon_sym_tail] = ACTIONS(1894),
    [anon_sym_musttail] = ACTIONS(1894),
    [anon_sym_notail] = ACTIONS(1894),
    [anon_sym_call] = ACTIONS(1894),
    [anon_sym_alloca] = ACTIONS(1894),
    [anon_sym_load] = ACTIONS(1894),
    [anon_sym_store] = ACTIONS(1894),
    [anon_sym_cmpxchg] = ACTIONS(1894),
    [anon_sym_atomicrmw] = ACTIONS(1894),
    [anon_sym_fence] = ACTIONS(1894),
    [anon_sym_getelementptr] = ACTIONS(1894),
    [anon_sym_extractvalue] = ACTIONS(1894),
    [anon_sym_insertvalue] = ACTIONS(1894),
    [anon_sym_mul] = ACTIONS(1894),
    [anon_sym_urem] = ACTIONS(1894),
    [anon_sym_srem] = ACTIONS(1894),
    [anon_sym_shl] = ACTIONS(1894),
    [anon_sym_udiv] = ACTIONS(1894),
    [anon_sym_sdiv] = ACTIONS(1894),
    [anon_sym_lshr] = ACTIONS(1894),
    [anon_sym_ashr] = ACTIONS(1894),
    [anon_sym_fmul] = ACTIONS(1894),
    [anon_sym_fdiv] = ACTIONS(1894),
    [anon_sym_frem] = ACTIONS(1894),
    [anon_sym_xchg] = ACTIONS(1894),
    [anon_sym_add] = ACTIONS(1894),
    [anon_sym_sub] = ACTIONS(1894),
    [anon_sym_and] = ACTIONS(1894),
    [anon_sym_nand] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1894),
    [anon_sym_xor] = ACTIONS(1894),
    [anon_sym_max] = ACTIONS(1894),
    [anon_sym_min] = ACTIONS(1894),
    [anon_sym_umax] = ACTIONS(1894),
    [anon_sym_umin] = ACTIONS(1894),
    [anon_sym_fadd] = ACTIONS(1894),
    [anon_sym_fsub] = ACTIONS(1894),
    [anon_sym_bitcast] = ACTIONS(1894),
    [anon_sym_trunc] = ACTIONS(1894),
    [anon_sym_zext] = ACTIONS(1894),
    [anon_sym_sext] = ACTIONS(1894),
    [anon_sym_fptrunc] = ACTIONS(1894),
    [anon_sym_fpext] = ACTIONS(1894),
    [anon_sym_addrspacecast] = ACTIONS(1894),
    [anon_sym_uitofp] = ACTIONS(1894),
    [anon_sym_sitofp] = ACTIONS(1894),
    [anon_sym_fptoui] = ACTIONS(1894),
    [anon_sym_fptosi] = ACTIONS(1894),
    [anon_sym_inttoptr] = ACTIONS(1894),
    [anon_sym_ptrtoint] = ACTIONS(1894),
    [anon_sym_uselistorder] = ACTIONS(1894),
  },
  [575] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1896),
    [sym_label] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_COMMA] = ACTIONS(1896),
    [anon_sym_unreachable] = ACTIONS(1898),
    [anon_sym_ret] = ACTIONS(1898),
    [anon_sym_br] = ACTIONS(1898),
    [anon_sym_resume] = ACTIONS(1898),
    [anon_sym_freeze] = ACTIONS(1898),
    [anon_sym_indirectbr] = ACTIONS(1898),
    [anon_sym_extractelement] = ACTIONS(1898),
    [anon_sym_insertelement] = ACTIONS(1898),
    [anon_sym_select] = ACTIONS(1898),
    [anon_sym_shufflevector] = ACTIONS(1898),
    [anon_sym_fneg] = ACTIONS(1898),
    [anon_sym_switch] = ACTIONS(1898),
    [anon_sym_invoke] = ACTIONS(1898),
    [anon_sym_cleanupret] = ACTIONS(1898),
    [anon_sym_catchret] = ACTIONS(1898),
    [anon_sym_catchswitch] = ACTIONS(1898),
    [anon_sym_catchpad] = ACTIONS(1898),
    [anon_sym_cleanuppad] = ACTIONS(1898),
    [anon_sym_callbr] = ACTIONS(1898),
    [anon_sym_icmp] = ACTIONS(1898),
    [anon_sym_fcmp] = ACTIONS(1898),
    [anon_sym_va_arg] = ACTIONS(1898),
    [anon_sym_phi] = ACTIONS(1898),
    [anon_sym_landingpad] = ACTIONS(1898),
    [anon_sym_tail] = ACTIONS(1898),
    [anon_sym_musttail] = ACTIONS(1898),
    [anon_sym_notail] = ACTIONS(1898),
    [anon_sym_call] = ACTIONS(1898),
    [anon_sym_alloca] = ACTIONS(1898),
    [anon_sym_load] = ACTIONS(1898),
    [anon_sym_store] = ACTIONS(1898),
    [anon_sym_cmpxchg] = ACTIONS(1898),
    [anon_sym_atomicrmw] = ACTIONS(1898),
    [anon_sym_fence] = ACTIONS(1898),
    [anon_sym_getelementptr] = ACTIONS(1898),
    [anon_sym_extractvalue] = ACTIONS(1898),
    [anon_sym_insertvalue] = ACTIONS(1898),
    [anon_sym_mul] = ACTIONS(1898),
    [anon_sym_urem] = ACTIONS(1898),
    [anon_sym_srem] = ACTIONS(1898),
    [anon_sym_shl] = ACTIONS(1898),
    [anon_sym_udiv] = ACTIONS(1898),
    [anon_sym_sdiv] = ACTIONS(1898),
    [anon_sym_lshr] = ACTIONS(1898),
    [anon_sym_ashr] = ACTIONS(1898),
    [anon_sym_fmul] = ACTIONS(1898),
    [anon_sym_fdiv] = ACTIONS(1898),
    [anon_sym_frem] = ACTIONS(1898),
    [anon_sym_xchg] = ACTIONS(1898),
    [anon_sym_add] = ACTIONS(1898),
    [anon_sym_sub] = ACTIONS(1898),
    [anon_sym_and] = ACTIONS(1898),
    [anon_sym_nand] = ACTIONS(1898),
    [anon_sym_or] = ACTIONS(1898),
    [anon_sym_xor] = ACTIONS(1898),
    [anon_sym_max] = ACTIONS(1898),
    [anon_sym_min] = ACTIONS(1898),
    [anon_sym_umax] = ACTIONS(1898),
    [anon_sym_umin] = ACTIONS(1898),
    [anon_sym_fadd] = ACTIONS(1898),
    [anon_sym_fsub] = ACTIONS(1898),
    [anon_sym_bitcast] = ACTIONS(1898),
    [anon_sym_trunc] = ACTIONS(1898),
    [anon_sym_zext] = ACTIONS(1898),
    [anon_sym_sext] = ACTIONS(1898),
    [anon_sym_fptrunc] = ACTIONS(1898),
    [anon_sym_fpext] = ACTIONS(1898),
    [anon_sym_addrspacecast] = ACTIONS(1898),
    [anon_sym_uitofp] = ACTIONS(1898),
    [anon_sym_sitofp] = ACTIONS(1898),
    [anon_sym_fptoui] = ACTIONS(1898),
    [anon_sym_fptosi] = ACTIONS(1898),
    [anon_sym_inttoptr] = ACTIONS(1898),
    [anon_sym_ptrtoint] = ACTIONS(1898),
    [anon_sym_uselistorder] = ACTIONS(1898),
  },
  [576] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1900),
    [sym_label] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(1900),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_unreachable] = ACTIONS(1902),
    [anon_sym_ret] = ACTIONS(1902),
    [anon_sym_br] = ACTIONS(1902),
    [anon_sym_resume] = ACTIONS(1902),
    [anon_sym_freeze] = ACTIONS(1902),
    [anon_sym_indirectbr] = ACTIONS(1902),
    [anon_sym_extractelement] = ACTIONS(1902),
    [anon_sym_insertelement] = ACTIONS(1902),
    [anon_sym_select] = ACTIONS(1902),
    [anon_sym_shufflevector] = ACTIONS(1902),
    [anon_sym_fneg] = ACTIONS(1902),
    [anon_sym_switch] = ACTIONS(1902),
    [anon_sym_invoke] = ACTIONS(1902),
    [anon_sym_cleanupret] = ACTIONS(1902),
    [anon_sym_catchret] = ACTIONS(1902),
    [anon_sym_catchswitch] = ACTIONS(1902),
    [anon_sym_catchpad] = ACTIONS(1902),
    [anon_sym_cleanuppad] = ACTIONS(1902),
    [anon_sym_callbr] = ACTIONS(1902),
    [anon_sym_icmp] = ACTIONS(1902),
    [anon_sym_fcmp] = ACTIONS(1902),
    [anon_sym_va_arg] = ACTIONS(1902),
    [anon_sym_phi] = ACTIONS(1902),
    [anon_sym_landingpad] = ACTIONS(1902),
    [anon_sym_tail] = ACTIONS(1902),
    [anon_sym_musttail] = ACTIONS(1902),
    [anon_sym_notail] = ACTIONS(1902),
    [anon_sym_call] = ACTIONS(1902),
    [anon_sym_alloca] = ACTIONS(1902),
    [anon_sym_load] = ACTIONS(1902),
    [anon_sym_store] = ACTIONS(1902),
    [anon_sym_cmpxchg] = ACTIONS(1902),
    [anon_sym_atomicrmw] = ACTIONS(1902),
    [anon_sym_fence] = ACTIONS(1902),
    [anon_sym_getelementptr] = ACTIONS(1902),
    [anon_sym_extractvalue] = ACTIONS(1902),
    [anon_sym_insertvalue] = ACTIONS(1902),
    [anon_sym_mul] = ACTIONS(1902),
    [anon_sym_urem] = ACTIONS(1902),
    [anon_sym_srem] = ACTIONS(1902),
    [anon_sym_shl] = ACTIONS(1902),
    [anon_sym_udiv] = ACTIONS(1902),
    [anon_sym_sdiv] = ACTIONS(1902),
    [anon_sym_lshr] = ACTIONS(1902),
    [anon_sym_ashr] = ACTIONS(1902),
    [anon_sym_fmul] = ACTIONS(1902),
    [anon_sym_fdiv] = ACTIONS(1902),
    [anon_sym_frem] = ACTIONS(1902),
    [anon_sym_xchg] = ACTIONS(1902),
    [anon_sym_add] = ACTIONS(1902),
    [anon_sym_sub] = ACTIONS(1902),
    [anon_sym_and] = ACTIONS(1902),
    [anon_sym_nand] = ACTIONS(1902),
    [anon_sym_or] = ACTIONS(1902),
    [anon_sym_xor] = ACTIONS(1902),
    [anon_sym_max] = ACTIONS(1902),
    [anon_sym_min] = ACTIONS(1902),
    [anon_sym_umax] = ACTIONS(1902),
    [anon_sym_umin] = ACTIONS(1902),
    [anon_sym_fadd] = ACTIONS(1902),
    [anon_sym_fsub] = ACTIONS(1902),
    [anon_sym_bitcast] = ACTIONS(1902),
    [anon_sym_trunc] = ACTIONS(1902),
    [anon_sym_zext] = ACTIONS(1902),
    [anon_sym_sext] = ACTIONS(1902),
    [anon_sym_fptrunc] = ACTIONS(1902),
    [anon_sym_fpext] = ACTIONS(1902),
    [anon_sym_addrspacecast] = ACTIONS(1902),
    [anon_sym_uitofp] = ACTIONS(1902),
    [anon_sym_sitofp] = ACTIONS(1902),
    [anon_sym_fptoui] = ACTIONS(1902),
    [anon_sym_fptosi] = ACTIONS(1902),
    [anon_sym_inttoptr] = ACTIONS(1902),
    [anon_sym_ptrtoint] = ACTIONS(1902),
    [anon_sym_uselistorder] = ACTIONS(1902),
  },
  [577] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1904),
    [sym_label] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_COMMA] = ACTIONS(1904),
    [anon_sym_unreachable] = ACTIONS(1906),
    [anon_sym_ret] = ACTIONS(1906),
    [anon_sym_br] = ACTIONS(1906),
    [anon_sym_resume] = ACTIONS(1906),
    [anon_sym_freeze] = ACTIONS(1906),
    [anon_sym_indirectbr] = ACTIONS(1906),
    [anon_sym_extractelement] = ACTIONS(1906),
    [anon_sym_insertelement] = ACTIONS(1906),
    [anon_sym_select] = ACTIONS(1906),
    [anon_sym_shufflevector] = ACTIONS(1906),
    [anon_sym_fneg] = ACTIONS(1906),
    [anon_sym_switch] = ACTIONS(1906),
    [anon_sym_invoke] = ACTIONS(1906),
    [anon_sym_cleanupret] = ACTIONS(1906),
    [anon_sym_catchret] = ACTIONS(1906),
    [anon_sym_catchswitch] = ACTIONS(1906),
    [anon_sym_catchpad] = ACTIONS(1906),
    [anon_sym_cleanuppad] = ACTIONS(1906),
    [anon_sym_callbr] = ACTIONS(1906),
    [anon_sym_icmp] = ACTIONS(1906),
    [anon_sym_fcmp] = ACTIONS(1906),
    [anon_sym_va_arg] = ACTIONS(1906),
    [anon_sym_phi] = ACTIONS(1906),
    [anon_sym_landingpad] = ACTIONS(1906),
    [anon_sym_tail] = ACTIONS(1906),
    [anon_sym_musttail] = ACTIONS(1906),
    [anon_sym_notail] = ACTIONS(1906),
    [anon_sym_call] = ACTIONS(1906),
    [anon_sym_alloca] = ACTIONS(1906),
    [anon_sym_load] = ACTIONS(1906),
    [anon_sym_store] = ACTIONS(1906),
    [anon_sym_cmpxchg] = ACTIONS(1906),
    [anon_sym_atomicrmw] = ACTIONS(1906),
    [anon_sym_fence] = ACTIONS(1906),
    [anon_sym_getelementptr] = ACTIONS(1906),
    [anon_sym_extractvalue] = ACTIONS(1906),
    [anon_sym_insertvalue] = ACTIONS(1906),
    [anon_sym_mul] = ACTIONS(1906),
    [anon_sym_urem] = ACTIONS(1906),
    [anon_sym_srem] = ACTIONS(1906),
    [anon_sym_shl] = ACTIONS(1906),
    [anon_sym_udiv] = ACTIONS(1906),
    [anon_sym_sdiv] = ACTIONS(1906),
    [anon_sym_lshr] = ACTIONS(1906),
    [anon_sym_ashr] = ACTIONS(1906),
    [anon_sym_fmul] = ACTIONS(1906),
    [anon_sym_fdiv] = ACTIONS(1906),
    [anon_sym_frem] = ACTIONS(1906),
    [anon_sym_xchg] = ACTIONS(1906),
    [anon_sym_add] = ACTIONS(1906),
    [anon_sym_sub] = ACTIONS(1906),
    [anon_sym_and] = ACTIONS(1906),
    [anon_sym_nand] = ACTIONS(1906),
    [anon_sym_or] = ACTIONS(1906),
    [anon_sym_xor] = ACTIONS(1906),
    [anon_sym_max] = ACTIONS(1906),
    [anon_sym_min] = ACTIONS(1906),
    [anon_sym_umax] = ACTIONS(1906),
    [anon_sym_umin] = ACTIONS(1906),
    [anon_sym_fadd] = ACTIONS(1906),
    [anon_sym_fsub] = ACTIONS(1906),
    [anon_sym_bitcast] = ACTIONS(1906),
    [anon_sym_trunc] = ACTIONS(1906),
    [anon_sym_zext] = ACTIONS(1906),
    [anon_sym_sext] = ACTIONS(1906),
    [anon_sym_fptrunc] = ACTIONS(1906),
    [anon_sym_fpext] = ACTIONS(1906),
    [anon_sym_addrspacecast] = ACTIONS(1906),
    [anon_sym_uitofp] = ACTIONS(1906),
    [anon_sym_sitofp] = ACTIONS(1906),
    [anon_sym_fptoui] = ACTIONS(1906),
    [anon_sym_fptosi] = ACTIONS(1906),
    [anon_sym_inttoptr] = ACTIONS(1906),
    [anon_sym_ptrtoint] = ACTIONS(1906),
    [anon_sym_uselistorder] = ACTIONS(1906),
  },
  [578] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1908),
    [sym_label] = ACTIONS(1908),
    [anon_sym_RBRACE] = ACTIONS(1908),
    [anon_sym_COMMA] = ACTIONS(1908),
    [anon_sym_unreachable] = ACTIONS(1910),
    [anon_sym_ret] = ACTIONS(1910),
    [anon_sym_br] = ACTIONS(1910),
    [anon_sym_resume] = ACTIONS(1910),
    [anon_sym_freeze] = ACTIONS(1910),
    [anon_sym_indirectbr] = ACTIONS(1910),
    [anon_sym_extractelement] = ACTIONS(1910),
    [anon_sym_insertelement] = ACTIONS(1910),
    [anon_sym_select] = ACTIONS(1910),
    [anon_sym_shufflevector] = ACTIONS(1910),
    [anon_sym_fneg] = ACTIONS(1910),
    [anon_sym_switch] = ACTIONS(1910),
    [anon_sym_invoke] = ACTIONS(1910),
    [anon_sym_cleanupret] = ACTIONS(1910),
    [anon_sym_catchret] = ACTIONS(1910),
    [anon_sym_catchswitch] = ACTIONS(1910),
    [anon_sym_catchpad] = ACTIONS(1910),
    [anon_sym_cleanuppad] = ACTIONS(1910),
    [anon_sym_callbr] = ACTIONS(1910),
    [anon_sym_icmp] = ACTIONS(1910),
    [anon_sym_fcmp] = ACTIONS(1910),
    [anon_sym_va_arg] = ACTIONS(1910),
    [anon_sym_phi] = ACTIONS(1910),
    [anon_sym_landingpad] = ACTIONS(1910),
    [anon_sym_tail] = ACTIONS(1910),
    [anon_sym_musttail] = ACTIONS(1910),
    [anon_sym_notail] = ACTIONS(1910),
    [anon_sym_call] = ACTIONS(1910),
    [anon_sym_alloca] = ACTIONS(1910),
    [anon_sym_load] = ACTIONS(1910),
    [anon_sym_store] = ACTIONS(1910),
    [anon_sym_cmpxchg] = ACTIONS(1910),
    [anon_sym_atomicrmw] = ACTIONS(1910),
    [anon_sym_fence] = ACTIONS(1910),
    [anon_sym_getelementptr] = ACTIONS(1910),
    [anon_sym_extractvalue] = ACTIONS(1910),
    [anon_sym_insertvalue] = ACTIONS(1910),
    [anon_sym_mul] = ACTIONS(1910),
    [anon_sym_urem] = ACTIONS(1910),
    [anon_sym_srem] = ACTIONS(1910),
    [anon_sym_shl] = ACTIONS(1910),
    [anon_sym_udiv] = ACTIONS(1910),
    [anon_sym_sdiv] = ACTIONS(1910),
    [anon_sym_lshr] = ACTIONS(1910),
    [anon_sym_ashr] = ACTIONS(1910),
    [anon_sym_fmul] = ACTIONS(1910),
    [anon_sym_fdiv] = ACTIONS(1910),
    [anon_sym_frem] = ACTIONS(1910),
    [anon_sym_xchg] = ACTIONS(1910),
    [anon_sym_add] = ACTIONS(1910),
    [anon_sym_sub] = ACTIONS(1910),
    [anon_sym_and] = ACTIONS(1910),
    [anon_sym_nand] = ACTIONS(1910),
    [anon_sym_or] = ACTIONS(1910),
    [anon_sym_xor] = ACTIONS(1910),
    [anon_sym_max] = ACTIONS(1910),
    [anon_sym_min] = ACTIONS(1910),
    [anon_sym_umax] = ACTIONS(1910),
    [anon_sym_umin] = ACTIONS(1910),
    [anon_sym_fadd] = ACTIONS(1910),
    [anon_sym_fsub] = ACTIONS(1910),
    [anon_sym_bitcast] = ACTIONS(1910),
    [anon_sym_trunc] = ACTIONS(1910),
    [anon_sym_zext] = ACTIONS(1910),
    [anon_sym_sext] = ACTIONS(1910),
    [anon_sym_fptrunc] = ACTIONS(1910),
    [anon_sym_fpext] = ACTIONS(1910),
    [anon_sym_addrspacecast] = ACTIONS(1910),
    [anon_sym_uitofp] = ACTIONS(1910),
    [anon_sym_sitofp] = ACTIONS(1910),
    [anon_sym_fptoui] = ACTIONS(1910),
    [anon_sym_fptosi] = ACTIONS(1910),
    [anon_sym_inttoptr] = ACTIONS(1910),
    [anon_sym_ptrtoint] = ACTIONS(1910),
    [anon_sym_uselistorder] = ACTIONS(1910),
  },
  [579] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1677),
    [sym_label] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_unreachable] = ACTIONS(1682),
    [anon_sym_ret] = ACTIONS(1682),
    [anon_sym_br] = ACTIONS(1682),
    [anon_sym_resume] = ACTIONS(1682),
    [anon_sym_freeze] = ACTIONS(1682),
    [anon_sym_indirectbr] = ACTIONS(1682),
    [anon_sym_extractelement] = ACTIONS(1682),
    [anon_sym_insertelement] = ACTIONS(1682),
    [anon_sym_select] = ACTIONS(1682),
    [anon_sym_shufflevector] = ACTIONS(1682),
    [anon_sym_fneg] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_invoke] = ACTIONS(1682),
    [anon_sym_cleanupret] = ACTIONS(1682),
    [anon_sym_catchret] = ACTIONS(1682),
    [anon_sym_catchswitch] = ACTIONS(1682),
    [anon_sym_catchpad] = ACTIONS(1682),
    [anon_sym_cleanuppad] = ACTIONS(1682),
    [anon_sym_callbr] = ACTIONS(1682),
    [anon_sym_icmp] = ACTIONS(1682),
    [anon_sym_fcmp] = ACTIONS(1682),
    [anon_sym_va_arg] = ACTIONS(1682),
    [anon_sym_phi] = ACTIONS(1682),
    [anon_sym_landingpad] = ACTIONS(1682),
    [anon_sym_tail] = ACTIONS(1682),
    [anon_sym_musttail] = ACTIONS(1682),
    [anon_sym_notail] = ACTIONS(1682),
    [anon_sym_call] = ACTIONS(1682),
    [anon_sym_alloca] = ACTIONS(1682),
    [anon_sym_load] = ACTIONS(1682),
    [anon_sym_store] = ACTIONS(1682),
    [anon_sym_cmpxchg] = ACTIONS(1682),
    [anon_sym_atomicrmw] = ACTIONS(1682),
    [anon_sym_fence] = ACTIONS(1682),
    [anon_sym_getelementptr] = ACTIONS(1682),
    [anon_sym_extractvalue] = ACTIONS(1682),
    [anon_sym_insertvalue] = ACTIONS(1682),
    [anon_sym_mul] = ACTIONS(1682),
    [anon_sym_urem] = ACTIONS(1682),
    [anon_sym_srem] = ACTIONS(1682),
    [anon_sym_shl] = ACTIONS(1682),
    [anon_sym_udiv] = ACTIONS(1682),
    [anon_sym_sdiv] = ACTIONS(1682),
    [anon_sym_lshr] = ACTIONS(1682),
    [anon_sym_ashr] = ACTIONS(1682),
    [anon_sym_fmul] = ACTIONS(1682),
    [anon_sym_fdiv] = ACTIONS(1682),
    [anon_sym_frem] = ACTIONS(1682),
    [anon_sym_xchg] = ACTIONS(1682),
    [anon_sym_add] = ACTIONS(1682),
    [anon_sym_sub] = ACTIONS(1682),
    [anon_sym_and] = ACTIONS(1682),
    [anon_sym_nand] = ACTIONS(1682),
    [anon_sym_or] = ACTIONS(1682),
    [anon_sym_xor] = ACTIONS(1682),
    [anon_sym_max] = ACTIONS(1682),
    [anon_sym_min] = ACTIONS(1682),
    [anon_sym_umax] = ACTIONS(1682),
    [anon_sym_umin] = ACTIONS(1682),
    [anon_sym_fadd] = ACTIONS(1682),
    [anon_sym_fsub] = ACTIONS(1682),
    [anon_sym_bitcast] = ACTIONS(1682),
    [anon_sym_trunc] = ACTIONS(1682),
    [anon_sym_zext] = ACTIONS(1682),
    [anon_sym_sext] = ACTIONS(1682),
    [anon_sym_fptrunc] = ACTIONS(1682),
    [anon_sym_fpext] = ACTIONS(1682),
    [anon_sym_addrspacecast] = ACTIONS(1682),
    [anon_sym_uitofp] = ACTIONS(1682),
    [anon_sym_sitofp] = ACTIONS(1682),
    [anon_sym_fptoui] = ACTIONS(1682),
    [anon_sym_fptosi] = ACTIONS(1682),
    [anon_sym_inttoptr] = ACTIONS(1682),
    [anon_sym_ptrtoint] = ACTIONS(1682),
    [anon_sym_uselistorder] = ACTIONS(1682),
  },
  [580] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1912),
    [sym_label] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1912),
    [anon_sym_COMMA] = ACTIONS(1912),
    [anon_sym_unreachable] = ACTIONS(1914),
    [anon_sym_ret] = ACTIONS(1914),
    [anon_sym_br] = ACTIONS(1914),
    [anon_sym_resume] = ACTIONS(1914),
    [anon_sym_freeze] = ACTIONS(1914),
    [anon_sym_indirectbr] = ACTIONS(1914),
    [anon_sym_extractelement] = ACTIONS(1914),
    [anon_sym_insertelement] = ACTIONS(1914),
    [anon_sym_select] = ACTIONS(1914),
    [anon_sym_shufflevector] = ACTIONS(1914),
    [anon_sym_fneg] = ACTIONS(1914),
    [anon_sym_switch] = ACTIONS(1914),
    [anon_sym_invoke] = ACTIONS(1914),
    [anon_sym_cleanupret] = ACTIONS(1914),
    [anon_sym_catchret] = ACTIONS(1914),
    [anon_sym_catchswitch] = ACTIONS(1914),
    [anon_sym_catchpad] = ACTIONS(1914),
    [anon_sym_cleanuppad] = ACTIONS(1914),
    [anon_sym_callbr] = ACTIONS(1914),
    [anon_sym_icmp] = ACTIONS(1914),
    [anon_sym_fcmp] = ACTIONS(1914),
    [anon_sym_va_arg] = ACTIONS(1914),
    [anon_sym_phi] = ACTIONS(1914),
    [anon_sym_landingpad] = ACTIONS(1914),
    [anon_sym_tail] = ACTIONS(1914),
    [anon_sym_musttail] = ACTIONS(1914),
    [anon_sym_notail] = ACTIONS(1914),
    [anon_sym_call] = ACTIONS(1914),
    [anon_sym_alloca] = ACTIONS(1914),
    [anon_sym_load] = ACTIONS(1914),
    [anon_sym_store] = ACTIONS(1914),
    [anon_sym_cmpxchg] = ACTIONS(1914),
    [anon_sym_atomicrmw] = ACTIONS(1914),
    [anon_sym_fence] = ACTIONS(1914),
    [anon_sym_getelementptr] = ACTIONS(1914),
    [anon_sym_extractvalue] = ACTIONS(1914),
    [anon_sym_insertvalue] = ACTIONS(1914),
    [anon_sym_mul] = ACTIONS(1914),
    [anon_sym_urem] = ACTIONS(1914),
    [anon_sym_srem] = ACTIONS(1914),
    [anon_sym_shl] = ACTIONS(1914),
    [anon_sym_udiv] = ACTIONS(1914),
    [anon_sym_sdiv] = ACTIONS(1914),
    [anon_sym_lshr] = ACTIONS(1914),
    [anon_sym_ashr] = ACTIONS(1914),
    [anon_sym_fmul] = ACTIONS(1914),
    [anon_sym_fdiv] = ACTIONS(1914),
    [anon_sym_frem] = ACTIONS(1914),
    [anon_sym_xchg] = ACTIONS(1914),
    [anon_sym_add] = ACTIONS(1914),
    [anon_sym_sub] = ACTIONS(1914),
    [anon_sym_and] = ACTIONS(1914),
    [anon_sym_nand] = ACTIONS(1914),
    [anon_sym_or] = ACTIONS(1914),
    [anon_sym_xor] = ACTIONS(1914),
    [anon_sym_max] = ACTIONS(1914),
    [anon_sym_min] = ACTIONS(1914),
    [anon_sym_umax] = ACTIONS(1914),
    [anon_sym_umin] = ACTIONS(1914),
    [anon_sym_fadd] = ACTIONS(1914),
    [anon_sym_fsub] = ACTIONS(1914),
    [anon_sym_bitcast] = ACTIONS(1914),
    [anon_sym_trunc] = ACTIONS(1914),
    [anon_sym_zext] = ACTIONS(1914),
    [anon_sym_sext] = ACTIONS(1914),
    [anon_sym_fptrunc] = ACTIONS(1914),
    [anon_sym_fpext] = ACTIONS(1914),
    [anon_sym_addrspacecast] = ACTIONS(1914),
    [anon_sym_uitofp] = ACTIONS(1914),
    [anon_sym_sitofp] = ACTIONS(1914),
    [anon_sym_fptoui] = ACTIONS(1914),
    [anon_sym_fptosi] = ACTIONS(1914),
    [anon_sym_inttoptr] = ACTIONS(1914),
    [anon_sym_ptrtoint] = ACTIONS(1914),
    [anon_sym_uselistorder] = ACTIONS(1914),
  },
  [581] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1916),
    [sym_label] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1916),
    [anon_sym_COMMA] = ACTIONS(1916),
    [anon_sym_unreachable] = ACTIONS(1918),
    [anon_sym_ret] = ACTIONS(1918),
    [anon_sym_br] = ACTIONS(1918),
    [anon_sym_resume] = ACTIONS(1918),
    [anon_sym_freeze] = ACTIONS(1918),
    [anon_sym_indirectbr] = ACTIONS(1918),
    [anon_sym_extractelement] = ACTIONS(1918),
    [anon_sym_insertelement] = ACTIONS(1918),
    [anon_sym_select] = ACTIONS(1918),
    [anon_sym_shufflevector] = ACTIONS(1918),
    [anon_sym_fneg] = ACTIONS(1918),
    [anon_sym_switch] = ACTIONS(1918),
    [anon_sym_invoke] = ACTIONS(1918),
    [anon_sym_cleanupret] = ACTIONS(1918),
    [anon_sym_catchret] = ACTIONS(1918),
    [anon_sym_catchswitch] = ACTIONS(1918),
    [anon_sym_catchpad] = ACTIONS(1918),
    [anon_sym_cleanuppad] = ACTIONS(1918),
    [anon_sym_callbr] = ACTIONS(1918),
    [anon_sym_icmp] = ACTIONS(1918),
    [anon_sym_fcmp] = ACTIONS(1918),
    [anon_sym_va_arg] = ACTIONS(1918),
    [anon_sym_phi] = ACTIONS(1918),
    [anon_sym_landingpad] = ACTIONS(1918),
    [anon_sym_tail] = ACTIONS(1918),
    [anon_sym_musttail] = ACTIONS(1918),
    [anon_sym_notail] = ACTIONS(1918),
    [anon_sym_call] = ACTIONS(1918),
    [anon_sym_alloca] = ACTIONS(1918),
    [anon_sym_load] = ACTIONS(1918),
    [anon_sym_store] = ACTIONS(1918),
    [anon_sym_cmpxchg] = ACTIONS(1918),
    [anon_sym_atomicrmw] = ACTIONS(1918),
    [anon_sym_fence] = ACTIONS(1918),
    [anon_sym_getelementptr] = ACTIONS(1918),
    [anon_sym_extractvalue] = ACTIONS(1918),
    [anon_sym_insertvalue] = ACTIONS(1918),
    [anon_sym_mul] = ACTIONS(1918),
    [anon_sym_urem] = ACTIONS(1918),
    [anon_sym_srem] = ACTIONS(1918),
    [anon_sym_shl] = ACTIONS(1918),
    [anon_sym_udiv] = ACTIONS(1918),
    [anon_sym_sdiv] = ACTIONS(1918),
    [anon_sym_lshr] = ACTIONS(1918),
    [anon_sym_ashr] = ACTIONS(1918),
    [anon_sym_fmul] = ACTIONS(1918),
    [anon_sym_fdiv] = ACTIONS(1918),
    [anon_sym_frem] = ACTIONS(1918),
    [anon_sym_xchg] = ACTIONS(1918),
    [anon_sym_add] = ACTIONS(1918),
    [anon_sym_sub] = ACTIONS(1918),
    [anon_sym_and] = ACTIONS(1918),
    [anon_sym_nand] = ACTIONS(1918),
    [anon_sym_or] = ACTIONS(1918),
    [anon_sym_xor] = ACTIONS(1918),
    [anon_sym_max] = ACTIONS(1918),
    [anon_sym_min] = ACTIONS(1918),
    [anon_sym_umax] = ACTIONS(1918),
    [anon_sym_umin] = ACTIONS(1918),
    [anon_sym_fadd] = ACTIONS(1918),
    [anon_sym_fsub] = ACTIONS(1918),
    [anon_sym_bitcast] = ACTIONS(1918),
    [anon_sym_trunc] = ACTIONS(1918),
    [anon_sym_zext] = ACTIONS(1918),
    [anon_sym_sext] = ACTIONS(1918),
    [anon_sym_fptrunc] = ACTIONS(1918),
    [anon_sym_fpext] = ACTIONS(1918),
    [anon_sym_addrspacecast] = ACTIONS(1918),
    [anon_sym_uitofp] = ACTIONS(1918),
    [anon_sym_sitofp] = ACTIONS(1918),
    [anon_sym_fptoui] = ACTIONS(1918),
    [anon_sym_fptosi] = ACTIONS(1918),
    [anon_sym_inttoptr] = ACTIONS(1918),
    [anon_sym_ptrtoint] = ACTIONS(1918),
    [anon_sym_uselistorder] = ACTIONS(1918),
  },
  [582] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1920),
    [sym_label] = ACTIONS(1920),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_COMMA] = ACTIONS(1920),
    [anon_sym_unreachable] = ACTIONS(1922),
    [anon_sym_ret] = ACTIONS(1922),
    [anon_sym_br] = ACTIONS(1922),
    [anon_sym_resume] = ACTIONS(1922),
    [anon_sym_freeze] = ACTIONS(1922),
    [anon_sym_indirectbr] = ACTIONS(1922),
    [anon_sym_extractelement] = ACTIONS(1922),
    [anon_sym_insertelement] = ACTIONS(1922),
    [anon_sym_select] = ACTIONS(1922),
    [anon_sym_shufflevector] = ACTIONS(1922),
    [anon_sym_fneg] = ACTIONS(1922),
    [anon_sym_switch] = ACTIONS(1922),
    [anon_sym_invoke] = ACTIONS(1922),
    [anon_sym_cleanupret] = ACTIONS(1922),
    [anon_sym_catchret] = ACTIONS(1922),
    [anon_sym_catchswitch] = ACTIONS(1922),
    [anon_sym_catchpad] = ACTIONS(1922),
    [anon_sym_cleanuppad] = ACTIONS(1922),
    [anon_sym_callbr] = ACTIONS(1922),
    [anon_sym_icmp] = ACTIONS(1922),
    [anon_sym_fcmp] = ACTIONS(1922),
    [anon_sym_va_arg] = ACTIONS(1922),
    [anon_sym_phi] = ACTIONS(1922),
    [anon_sym_landingpad] = ACTIONS(1922),
    [anon_sym_tail] = ACTIONS(1922),
    [anon_sym_musttail] = ACTIONS(1922),
    [anon_sym_notail] = ACTIONS(1922),
    [anon_sym_call] = ACTIONS(1922),
    [anon_sym_alloca] = ACTIONS(1922),
    [anon_sym_load] = ACTIONS(1922),
    [anon_sym_store] = ACTIONS(1922),
    [anon_sym_cmpxchg] = ACTIONS(1922),
    [anon_sym_atomicrmw] = ACTIONS(1922),
    [anon_sym_fence] = ACTIONS(1922),
    [anon_sym_getelementptr] = ACTIONS(1922),
    [anon_sym_extractvalue] = ACTIONS(1922),
    [anon_sym_insertvalue] = ACTIONS(1922),
    [anon_sym_mul] = ACTIONS(1922),
    [anon_sym_urem] = ACTIONS(1922),
    [anon_sym_srem] = ACTIONS(1922),
    [anon_sym_shl] = ACTIONS(1922),
    [anon_sym_udiv] = ACTIONS(1922),
    [anon_sym_sdiv] = ACTIONS(1922),
    [anon_sym_lshr] = ACTIONS(1922),
    [anon_sym_ashr] = ACTIONS(1922),
    [anon_sym_fmul] = ACTIONS(1922),
    [anon_sym_fdiv] = ACTIONS(1922),
    [anon_sym_frem] = ACTIONS(1922),
    [anon_sym_xchg] = ACTIONS(1922),
    [anon_sym_add] = ACTIONS(1922),
    [anon_sym_sub] = ACTIONS(1922),
    [anon_sym_and] = ACTIONS(1922),
    [anon_sym_nand] = ACTIONS(1922),
    [anon_sym_or] = ACTIONS(1922),
    [anon_sym_xor] = ACTIONS(1922),
    [anon_sym_max] = ACTIONS(1922),
    [anon_sym_min] = ACTIONS(1922),
    [anon_sym_umax] = ACTIONS(1922),
    [anon_sym_umin] = ACTIONS(1922),
    [anon_sym_fadd] = ACTIONS(1922),
    [anon_sym_fsub] = ACTIONS(1922),
    [anon_sym_bitcast] = ACTIONS(1922),
    [anon_sym_trunc] = ACTIONS(1922),
    [anon_sym_zext] = ACTIONS(1922),
    [anon_sym_sext] = ACTIONS(1922),
    [anon_sym_fptrunc] = ACTIONS(1922),
    [anon_sym_fpext] = ACTIONS(1922),
    [anon_sym_addrspacecast] = ACTIONS(1922),
    [anon_sym_uitofp] = ACTIONS(1922),
    [anon_sym_sitofp] = ACTIONS(1922),
    [anon_sym_fptoui] = ACTIONS(1922),
    [anon_sym_fptosi] = ACTIONS(1922),
    [anon_sym_inttoptr] = ACTIONS(1922),
    [anon_sym_ptrtoint] = ACTIONS(1922),
    [anon_sym_uselistorder] = ACTIONS(1922),
  },
  [583] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1924),
    [sym_label] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_COMMA] = ACTIONS(1924),
    [anon_sym_unreachable] = ACTIONS(1926),
    [anon_sym_ret] = ACTIONS(1926),
    [anon_sym_br] = ACTIONS(1926),
    [anon_sym_resume] = ACTIONS(1926),
    [anon_sym_freeze] = ACTIONS(1926),
    [anon_sym_indirectbr] = ACTIONS(1926),
    [anon_sym_extractelement] = ACTIONS(1926),
    [anon_sym_insertelement] = ACTIONS(1926),
    [anon_sym_select] = ACTIONS(1926),
    [anon_sym_shufflevector] = ACTIONS(1926),
    [anon_sym_fneg] = ACTIONS(1926),
    [anon_sym_switch] = ACTIONS(1926),
    [anon_sym_invoke] = ACTIONS(1926),
    [anon_sym_cleanupret] = ACTIONS(1926),
    [anon_sym_catchret] = ACTIONS(1926),
    [anon_sym_catchswitch] = ACTIONS(1926),
    [anon_sym_catchpad] = ACTIONS(1926),
    [anon_sym_cleanuppad] = ACTIONS(1926),
    [anon_sym_callbr] = ACTIONS(1926),
    [anon_sym_icmp] = ACTIONS(1926),
    [anon_sym_fcmp] = ACTIONS(1926),
    [anon_sym_va_arg] = ACTIONS(1926),
    [anon_sym_phi] = ACTIONS(1926),
    [anon_sym_landingpad] = ACTIONS(1926),
    [anon_sym_tail] = ACTIONS(1926),
    [anon_sym_musttail] = ACTIONS(1926),
    [anon_sym_notail] = ACTIONS(1926),
    [anon_sym_call] = ACTIONS(1926),
    [anon_sym_alloca] = ACTIONS(1926),
    [anon_sym_load] = ACTIONS(1926),
    [anon_sym_store] = ACTIONS(1926),
    [anon_sym_cmpxchg] = ACTIONS(1926),
    [anon_sym_atomicrmw] = ACTIONS(1926),
    [anon_sym_fence] = ACTIONS(1926),
    [anon_sym_getelementptr] = ACTIONS(1926),
    [anon_sym_extractvalue] = ACTIONS(1926),
    [anon_sym_insertvalue] = ACTIONS(1926),
    [anon_sym_mul] = ACTIONS(1926),
    [anon_sym_urem] = ACTIONS(1926),
    [anon_sym_srem] = ACTIONS(1926),
    [anon_sym_shl] = ACTIONS(1926),
    [anon_sym_udiv] = ACTIONS(1926),
    [anon_sym_sdiv] = ACTIONS(1926),
    [anon_sym_lshr] = ACTIONS(1926),
    [anon_sym_ashr] = ACTIONS(1926),
    [anon_sym_fmul] = ACTIONS(1926),
    [anon_sym_fdiv] = ACTIONS(1926),
    [anon_sym_frem] = ACTIONS(1926),
    [anon_sym_xchg] = ACTIONS(1926),
    [anon_sym_add] = ACTIONS(1926),
    [anon_sym_sub] = ACTIONS(1926),
    [anon_sym_and] = ACTIONS(1926),
    [anon_sym_nand] = ACTIONS(1926),
    [anon_sym_or] = ACTIONS(1926),
    [anon_sym_xor] = ACTIONS(1926),
    [anon_sym_max] = ACTIONS(1926),
    [anon_sym_min] = ACTIONS(1926),
    [anon_sym_umax] = ACTIONS(1926),
    [anon_sym_umin] = ACTIONS(1926),
    [anon_sym_fadd] = ACTIONS(1926),
    [anon_sym_fsub] = ACTIONS(1926),
    [anon_sym_bitcast] = ACTIONS(1926),
    [anon_sym_trunc] = ACTIONS(1926),
    [anon_sym_zext] = ACTIONS(1926),
    [anon_sym_sext] = ACTIONS(1926),
    [anon_sym_fptrunc] = ACTIONS(1926),
    [anon_sym_fpext] = ACTIONS(1926),
    [anon_sym_addrspacecast] = ACTIONS(1926),
    [anon_sym_uitofp] = ACTIONS(1926),
    [anon_sym_sitofp] = ACTIONS(1926),
    [anon_sym_fptoui] = ACTIONS(1926),
    [anon_sym_fptosi] = ACTIONS(1926),
    [anon_sym_inttoptr] = ACTIONS(1926),
    [anon_sym_ptrtoint] = ACTIONS(1926),
    [anon_sym_uselistorder] = ACTIONS(1926),
  },
  [584] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1928),
    [sym_label] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_unreachable] = ACTIONS(1930),
    [anon_sym_ret] = ACTIONS(1930),
    [anon_sym_br] = ACTIONS(1930),
    [anon_sym_resume] = ACTIONS(1930),
    [anon_sym_freeze] = ACTIONS(1930),
    [anon_sym_indirectbr] = ACTIONS(1930),
    [anon_sym_extractelement] = ACTIONS(1930),
    [anon_sym_insertelement] = ACTIONS(1930),
    [anon_sym_select] = ACTIONS(1930),
    [anon_sym_shufflevector] = ACTIONS(1930),
    [anon_sym_fneg] = ACTIONS(1930),
    [anon_sym_switch] = ACTIONS(1930),
    [anon_sym_invoke] = ACTIONS(1930),
    [anon_sym_cleanupret] = ACTIONS(1930),
    [anon_sym_catchret] = ACTIONS(1930),
    [anon_sym_catchswitch] = ACTIONS(1930),
    [anon_sym_catchpad] = ACTIONS(1930),
    [anon_sym_cleanuppad] = ACTIONS(1930),
    [anon_sym_callbr] = ACTIONS(1930),
    [anon_sym_icmp] = ACTIONS(1930),
    [anon_sym_fcmp] = ACTIONS(1930),
    [anon_sym_va_arg] = ACTIONS(1930),
    [anon_sym_phi] = ACTIONS(1930),
    [anon_sym_landingpad] = ACTIONS(1930),
    [anon_sym_tail] = ACTIONS(1930),
    [anon_sym_musttail] = ACTIONS(1930),
    [anon_sym_notail] = ACTIONS(1930),
    [anon_sym_call] = ACTIONS(1930),
    [anon_sym_alloca] = ACTIONS(1930),
    [anon_sym_load] = ACTIONS(1930),
    [anon_sym_store] = ACTIONS(1930),
    [anon_sym_cmpxchg] = ACTIONS(1930),
    [anon_sym_atomicrmw] = ACTIONS(1930),
    [anon_sym_fence] = ACTIONS(1930),
    [anon_sym_getelementptr] = ACTIONS(1930),
    [anon_sym_extractvalue] = ACTIONS(1930),
    [anon_sym_insertvalue] = ACTIONS(1930),
    [anon_sym_mul] = ACTIONS(1930),
    [anon_sym_urem] = ACTIONS(1930),
    [anon_sym_srem] = ACTIONS(1930),
    [anon_sym_shl] = ACTIONS(1930),
    [anon_sym_udiv] = ACTIONS(1930),
    [anon_sym_sdiv] = ACTIONS(1930),
    [anon_sym_lshr] = ACTIONS(1930),
    [anon_sym_ashr] = ACTIONS(1930),
    [anon_sym_fmul] = ACTIONS(1930),
    [anon_sym_fdiv] = ACTIONS(1930),
    [anon_sym_frem] = ACTIONS(1930),
    [anon_sym_xchg] = ACTIONS(1930),
    [anon_sym_add] = ACTIONS(1930),
    [anon_sym_sub] = ACTIONS(1930),
    [anon_sym_and] = ACTIONS(1930),
    [anon_sym_nand] = ACTIONS(1930),
    [anon_sym_or] = ACTIONS(1930),
    [anon_sym_xor] = ACTIONS(1930),
    [anon_sym_max] = ACTIONS(1930),
    [anon_sym_min] = ACTIONS(1930),
    [anon_sym_umax] = ACTIONS(1930),
    [anon_sym_umin] = ACTIONS(1930),
    [anon_sym_fadd] = ACTIONS(1930),
    [anon_sym_fsub] = ACTIONS(1930),
    [anon_sym_bitcast] = ACTIONS(1930),
    [anon_sym_trunc] = ACTIONS(1930),
    [anon_sym_zext] = ACTIONS(1930),
    [anon_sym_sext] = ACTIONS(1930),
    [anon_sym_fptrunc] = ACTIONS(1930),
    [anon_sym_fpext] = ACTIONS(1930),
    [anon_sym_addrspacecast] = ACTIONS(1930),
    [anon_sym_uitofp] = ACTIONS(1930),
    [anon_sym_sitofp] = ACTIONS(1930),
    [anon_sym_fptoui] = ACTIONS(1930),
    [anon_sym_fptosi] = ACTIONS(1930),
    [anon_sym_inttoptr] = ACTIONS(1930),
    [anon_sym_ptrtoint] = ACTIONS(1930),
    [anon_sym_uselistorder] = ACTIONS(1930),
  },
  [585] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(721),
    [sym_label] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_unreachable] = ACTIONS(723),
    [anon_sym_ret] = ACTIONS(723),
    [anon_sym_br] = ACTIONS(723),
    [anon_sym_resume] = ACTIONS(723),
    [anon_sym_freeze] = ACTIONS(723),
    [anon_sym_indirectbr] = ACTIONS(723),
    [anon_sym_extractelement] = ACTIONS(723),
    [anon_sym_insertelement] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_shufflevector] = ACTIONS(723),
    [anon_sym_fneg] = ACTIONS(723),
    [anon_sym_switch] = ACTIONS(723),
    [anon_sym_invoke] = ACTIONS(723),
    [anon_sym_cleanupret] = ACTIONS(723),
    [anon_sym_catchret] = ACTIONS(723),
    [anon_sym_catchswitch] = ACTIONS(723),
    [anon_sym_catchpad] = ACTIONS(723),
    [anon_sym_cleanuppad] = ACTIONS(723),
    [anon_sym_callbr] = ACTIONS(723),
    [anon_sym_icmp] = ACTIONS(723),
    [anon_sym_fcmp] = ACTIONS(723),
    [anon_sym_va_arg] = ACTIONS(723),
    [anon_sym_phi] = ACTIONS(723),
    [anon_sym_landingpad] = ACTIONS(723),
    [anon_sym_tail] = ACTIONS(723),
    [anon_sym_musttail] = ACTIONS(723),
    [anon_sym_notail] = ACTIONS(723),
    [anon_sym_call] = ACTIONS(723),
    [anon_sym_alloca] = ACTIONS(723),
    [anon_sym_load] = ACTIONS(723),
    [anon_sym_store] = ACTIONS(723),
    [anon_sym_cmpxchg] = ACTIONS(723),
    [anon_sym_atomicrmw] = ACTIONS(723),
    [anon_sym_fence] = ACTIONS(723),
    [anon_sym_getelementptr] = ACTIONS(723),
    [anon_sym_extractvalue] = ACTIONS(723),
    [anon_sym_insertvalue] = ACTIONS(723),
    [anon_sym_mul] = ACTIONS(723),
    [anon_sym_urem] = ACTIONS(723),
    [anon_sym_srem] = ACTIONS(723),
    [anon_sym_shl] = ACTIONS(723),
    [anon_sym_udiv] = ACTIONS(723),
    [anon_sym_sdiv] = ACTIONS(723),
    [anon_sym_lshr] = ACTIONS(723),
    [anon_sym_ashr] = ACTIONS(723),
    [anon_sym_fmul] = ACTIONS(723),
    [anon_sym_fdiv] = ACTIONS(723),
    [anon_sym_frem] = ACTIONS(723),
    [anon_sym_xchg] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_sub] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_nand] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_xor] = ACTIONS(723),
    [anon_sym_max] = ACTIONS(723),
    [anon_sym_min] = ACTIONS(723),
    [anon_sym_umax] = ACTIONS(723),
    [anon_sym_umin] = ACTIONS(723),
    [anon_sym_fadd] = ACTIONS(723),
    [anon_sym_fsub] = ACTIONS(723),
    [anon_sym_bitcast] = ACTIONS(723),
    [anon_sym_trunc] = ACTIONS(723),
    [anon_sym_zext] = ACTIONS(723),
    [anon_sym_sext] = ACTIONS(723),
    [anon_sym_fptrunc] = ACTIONS(723),
    [anon_sym_fpext] = ACTIONS(723),
    [anon_sym_addrspacecast] = ACTIONS(723),
    [anon_sym_uitofp] = ACTIONS(723),
    [anon_sym_sitofp] = ACTIONS(723),
    [anon_sym_fptoui] = ACTIONS(723),
    [anon_sym_fptosi] = ACTIONS(723),
    [anon_sym_inttoptr] = ACTIONS(723),
    [anon_sym_ptrtoint] = ACTIONS(723),
    [anon_sym_uselistorder] = ACTIONS(723),
  },
  [586] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1932),
    [sym_label] = ACTIONS(1932),
    [anon_sym_RBRACE] = ACTIONS(1932),
    [anon_sym_COMMA] = ACTIONS(1932),
    [anon_sym_unreachable] = ACTIONS(1934),
    [anon_sym_ret] = ACTIONS(1934),
    [anon_sym_br] = ACTIONS(1934),
    [anon_sym_resume] = ACTIONS(1934),
    [anon_sym_freeze] = ACTIONS(1934),
    [anon_sym_indirectbr] = ACTIONS(1934),
    [anon_sym_extractelement] = ACTIONS(1934),
    [anon_sym_insertelement] = ACTIONS(1934),
    [anon_sym_select] = ACTIONS(1934),
    [anon_sym_shufflevector] = ACTIONS(1934),
    [anon_sym_fneg] = ACTIONS(1934),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_invoke] = ACTIONS(1934),
    [anon_sym_cleanupret] = ACTIONS(1934),
    [anon_sym_catchret] = ACTIONS(1934),
    [anon_sym_catchswitch] = ACTIONS(1934),
    [anon_sym_catchpad] = ACTIONS(1934),
    [anon_sym_cleanuppad] = ACTIONS(1934),
    [anon_sym_callbr] = ACTIONS(1934),
    [anon_sym_icmp] = ACTIONS(1934),
    [anon_sym_fcmp] = ACTIONS(1934),
    [anon_sym_va_arg] = ACTIONS(1934),
    [anon_sym_phi] = ACTIONS(1934),
    [anon_sym_landingpad] = ACTIONS(1934),
    [anon_sym_tail] = ACTIONS(1934),
    [anon_sym_musttail] = ACTIONS(1934),
    [anon_sym_notail] = ACTIONS(1934),
    [anon_sym_call] = ACTIONS(1934),
    [anon_sym_alloca] = ACTIONS(1934),
    [anon_sym_load] = ACTIONS(1934),
    [anon_sym_store] = ACTIONS(1934),
    [anon_sym_cmpxchg] = ACTIONS(1934),
    [anon_sym_atomicrmw] = ACTIONS(1934),
    [anon_sym_fence] = ACTIONS(1934),
    [anon_sym_getelementptr] = ACTIONS(1934),
    [anon_sym_extractvalue] = ACTIONS(1934),
    [anon_sym_insertvalue] = ACTIONS(1934),
    [anon_sym_mul] = ACTIONS(1934),
    [anon_sym_urem] = ACTIONS(1934),
    [anon_sym_srem] = ACTIONS(1934),
    [anon_sym_shl] = ACTIONS(1934),
    [anon_sym_udiv] = ACTIONS(1934),
    [anon_sym_sdiv] = ACTIONS(1934),
    [anon_sym_lshr] = ACTIONS(1934),
    [anon_sym_ashr] = ACTIONS(1934),
    [anon_sym_fmul] = ACTIONS(1934),
    [anon_sym_fdiv] = ACTIONS(1934),
    [anon_sym_frem] = ACTIONS(1934),
    [anon_sym_xchg] = ACTIONS(1934),
    [anon_sym_add] = ACTIONS(1934),
    [anon_sym_sub] = ACTIONS(1934),
    [anon_sym_and] = ACTIONS(1934),
    [anon_sym_nand] = ACTIONS(1934),
    [anon_sym_or] = ACTIONS(1934),
    [anon_sym_xor] = ACTIONS(1934),
    [anon_sym_max] = ACTIONS(1934),
    [anon_sym_min] = ACTIONS(1934),
    [anon_sym_umax] = ACTIONS(1934),
    [anon_sym_umin] = ACTIONS(1934),
    [anon_sym_fadd] = ACTIONS(1934),
    [anon_sym_fsub] = ACTIONS(1934),
    [anon_sym_bitcast] = ACTIONS(1934),
    [anon_sym_trunc] = ACTIONS(1934),
    [anon_sym_zext] = ACTIONS(1934),
    [anon_sym_sext] = ACTIONS(1934),
    [anon_sym_fptrunc] = ACTIONS(1934),
    [anon_sym_fpext] = ACTIONS(1934),
    [anon_sym_addrspacecast] = ACTIONS(1934),
    [anon_sym_uitofp] = ACTIONS(1934),
    [anon_sym_sitofp] = ACTIONS(1934),
    [anon_sym_fptoui] = ACTIONS(1934),
    [anon_sym_fptosi] = ACTIONS(1934),
    [anon_sym_inttoptr] = ACTIONS(1934),
    [anon_sym_ptrtoint] = ACTIONS(1934),
    [anon_sym_uselistorder] = ACTIONS(1934),
  },
  [587] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1936),
    [sym_label] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1936),
    [anon_sym_COMMA] = ACTIONS(1936),
    [anon_sym_unreachable] = ACTIONS(1938),
    [anon_sym_ret] = ACTIONS(1938),
    [anon_sym_br] = ACTIONS(1938),
    [anon_sym_resume] = ACTIONS(1938),
    [anon_sym_freeze] = ACTIONS(1938),
    [anon_sym_indirectbr] = ACTIONS(1938),
    [anon_sym_extractelement] = ACTIONS(1938),
    [anon_sym_insertelement] = ACTIONS(1938),
    [anon_sym_select] = ACTIONS(1938),
    [anon_sym_shufflevector] = ACTIONS(1938),
    [anon_sym_fneg] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_invoke] = ACTIONS(1938),
    [anon_sym_cleanupret] = ACTIONS(1938),
    [anon_sym_catchret] = ACTIONS(1938),
    [anon_sym_catchswitch] = ACTIONS(1938),
    [anon_sym_catchpad] = ACTIONS(1938),
    [anon_sym_cleanuppad] = ACTIONS(1938),
    [anon_sym_callbr] = ACTIONS(1938),
    [anon_sym_icmp] = ACTIONS(1938),
    [anon_sym_fcmp] = ACTIONS(1938),
    [anon_sym_va_arg] = ACTIONS(1938),
    [anon_sym_phi] = ACTIONS(1938),
    [anon_sym_landingpad] = ACTIONS(1938),
    [anon_sym_tail] = ACTIONS(1938),
    [anon_sym_musttail] = ACTIONS(1938),
    [anon_sym_notail] = ACTIONS(1938),
    [anon_sym_call] = ACTIONS(1938),
    [anon_sym_alloca] = ACTIONS(1938),
    [anon_sym_load] = ACTIONS(1938),
    [anon_sym_store] = ACTIONS(1938),
    [anon_sym_cmpxchg] = ACTIONS(1938),
    [anon_sym_atomicrmw] = ACTIONS(1938),
    [anon_sym_fence] = ACTIONS(1938),
    [anon_sym_getelementptr] = ACTIONS(1938),
    [anon_sym_extractvalue] = ACTIONS(1938),
    [anon_sym_insertvalue] = ACTIONS(1938),
    [anon_sym_mul] = ACTIONS(1938),
    [anon_sym_urem] = ACTIONS(1938),
    [anon_sym_srem] = ACTIONS(1938),
    [anon_sym_shl] = ACTIONS(1938),
    [anon_sym_udiv] = ACTIONS(1938),
    [anon_sym_sdiv] = ACTIONS(1938),
    [anon_sym_lshr] = ACTIONS(1938),
    [anon_sym_ashr] = ACTIONS(1938),
    [anon_sym_fmul] = ACTIONS(1938),
    [anon_sym_fdiv] = ACTIONS(1938),
    [anon_sym_frem] = ACTIONS(1938),
    [anon_sym_xchg] = ACTIONS(1938),
    [anon_sym_add] = ACTIONS(1938),
    [anon_sym_sub] = ACTIONS(1938),
    [anon_sym_and] = ACTIONS(1938),
    [anon_sym_nand] = ACTIONS(1938),
    [anon_sym_or] = ACTIONS(1938),
    [anon_sym_xor] = ACTIONS(1938),
    [anon_sym_max] = ACTIONS(1938),
    [anon_sym_min] = ACTIONS(1938),
    [anon_sym_umax] = ACTIONS(1938),
    [anon_sym_umin] = ACTIONS(1938),
    [anon_sym_fadd] = ACTIONS(1938),
    [anon_sym_fsub] = ACTIONS(1938),
    [anon_sym_bitcast] = ACTIONS(1938),
    [anon_sym_trunc] = ACTIONS(1938),
    [anon_sym_zext] = ACTIONS(1938),
    [anon_sym_sext] = ACTIONS(1938),
    [anon_sym_fptrunc] = ACTIONS(1938),
    [anon_sym_fpext] = ACTIONS(1938),
    [anon_sym_addrspacecast] = ACTIONS(1938),
    [anon_sym_uitofp] = ACTIONS(1938),
    [anon_sym_sitofp] = ACTIONS(1938),
    [anon_sym_fptoui] = ACTIONS(1938),
    [anon_sym_fptosi] = ACTIONS(1938),
    [anon_sym_inttoptr] = ACTIONS(1938),
    [anon_sym_ptrtoint] = ACTIONS(1938),
    [anon_sym_uselistorder] = ACTIONS(1938),
  },
  [588] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1940),
    [sym_label] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(1940),
    [anon_sym_unreachable] = ACTIONS(1942),
    [anon_sym_ret] = ACTIONS(1942),
    [anon_sym_br] = ACTIONS(1942),
    [anon_sym_resume] = ACTIONS(1942),
    [anon_sym_freeze] = ACTIONS(1942),
    [anon_sym_indirectbr] = ACTIONS(1942),
    [anon_sym_extractelement] = ACTIONS(1942),
    [anon_sym_insertelement] = ACTIONS(1942),
    [anon_sym_select] = ACTIONS(1942),
    [anon_sym_shufflevector] = ACTIONS(1942),
    [anon_sym_fneg] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_invoke] = ACTIONS(1942),
    [anon_sym_cleanupret] = ACTIONS(1942),
    [anon_sym_catchret] = ACTIONS(1942),
    [anon_sym_catchswitch] = ACTIONS(1942),
    [anon_sym_catchpad] = ACTIONS(1942),
    [anon_sym_cleanuppad] = ACTIONS(1942),
    [anon_sym_callbr] = ACTIONS(1942),
    [anon_sym_icmp] = ACTIONS(1942),
    [anon_sym_fcmp] = ACTIONS(1942),
    [anon_sym_va_arg] = ACTIONS(1942),
    [anon_sym_phi] = ACTIONS(1942),
    [anon_sym_landingpad] = ACTIONS(1942),
    [anon_sym_tail] = ACTIONS(1942),
    [anon_sym_musttail] = ACTIONS(1942),
    [anon_sym_notail] = ACTIONS(1942),
    [anon_sym_call] = ACTIONS(1942),
    [anon_sym_alloca] = ACTIONS(1942),
    [anon_sym_load] = ACTIONS(1942),
    [anon_sym_store] = ACTIONS(1942),
    [anon_sym_cmpxchg] = ACTIONS(1942),
    [anon_sym_atomicrmw] = ACTIONS(1942),
    [anon_sym_fence] = ACTIONS(1942),
    [anon_sym_getelementptr] = ACTIONS(1942),
    [anon_sym_extractvalue] = ACTIONS(1942),
    [anon_sym_insertvalue] = ACTIONS(1942),
    [anon_sym_mul] = ACTIONS(1942),
    [anon_sym_urem] = ACTIONS(1942),
    [anon_sym_srem] = ACTIONS(1942),
    [anon_sym_shl] = ACTIONS(1942),
    [anon_sym_udiv] = ACTIONS(1942),
    [anon_sym_sdiv] = ACTIONS(1942),
    [anon_sym_lshr] = ACTIONS(1942),
    [anon_sym_ashr] = ACTIONS(1942),
    [anon_sym_fmul] = ACTIONS(1942),
    [anon_sym_fdiv] = ACTIONS(1942),
    [anon_sym_frem] = ACTIONS(1942),
    [anon_sym_xchg] = ACTIONS(1942),
    [anon_sym_add] = ACTIONS(1942),
    [anon_sym_sub] = ACTIONS(1942),
    [anon_sym_and] = ACTIONS(1942),
    [anon_sym_nand] = ACTIONS(1942),
    [anon_sym_or] = ACTIONS(1942),
    [anon_sym_xor] = ACTIONS(1942),
    [anon_sym_max] = ACTIONS(1942),
    [anon_sym_min] = ACTIONS(1942),
    [anon_sym_umax] = ACTIONS(1942),
    [anon_sym_umin] = ACTIONS(1942),
    [anon_sym_fadd] = ACTIONS(1942),
    [anon_sym_fsub] = ACTIONS(1942),
    [anon_sym_bitcast] = ACTIONS(1942),
    [anon_sym_trunc] = ACTIONS(1942),
    [anon_sym_zext] = ACTIONS(1942),
    [anon_sym_sext] = ACTIONS(1942),
    [anon_sym_fptrunc] = ACTIONS(1942),
    [anon_sym_fpext] = ACTIONS(1942),
    [anon_sym_addrspacecast] = ACTIONS(1942),
    [anon_sym_uitofp] = ACTIONS(1942),
    [anon_sym_sitofp] = ACTIONS(1942),
    [anon_sym_fptoui] = ACTIONS(1942),
    [anon_sym_fptosi] = ACTIONS(1942),
    [anon_sym_inttoptr] = ACTIONS(1942),
    [anon_sym_ptrtoint] = ACTIONS(1942),
    [anon_sym_uselistorder] = ACTIONS(1942),
  },
  [589] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1944),
    [sym_label] = ACTIONS(1944),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1944),
    [anon_sym_unreachable] = ACTIONS(1946),
    [anon_sym_ret] = ACTIONS(1946),
    [anon_sym_br] = ACTIONS(1946),
    [anon_sym_resume] = ACTIONS(1946),
    [anon_sym_freeze] = ACTIONS(1946),
    [anon_sym_indirectbr] = ACTIONS(1946),
    [anon_sym_extractelement] = ACTIONS(1946),
    [anon_sym_insertelement] = ACTIONS(1946),
    [anon_sym_select] = ACTIONS(1946),
    [anon_sym_shufflevector] = ACTIONS(1946),
    [anon_sym_fneg] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_invoke] = ACTIONS(1946),
    [anon_sym_cleanupret] = ACTIONS(1946),
    [anon_sym_catchret] = ACTIONS(1946),
    [anon_sym_catchswitch] = ACTIONS(1946),
    [anon_sym_catchpad] = ACTIONS(1946),
    [anon_sym_cleanuppad] = ACTIONS(1946),
    [anon_sym_callbr] = ACTIONS(1946),
    [anon_sym_icmp] = ACTIONS(1946),
    [anon_sym_fcmp] = ACTIONS(1946),
    [anon_sym_va_arg] = ACTIONS(1946),
    [anon_sym_phi] = ACTIONS(1946),
    [anon_sym_landingpad] = ACTIONS(1946),
    [anon_sym_tail] = ACTIONS(1946),
    [anon_sym_musttail] = ACTIONS(1946),
    [anon_sym_notail] = ACTIONS(1946),
    [anon_sym_call] = ACTIONS(1946),
    [anon_sym_alloca] = ACTIONS(1946),
    [anon_sym_load] = ACTIONS(1946),
    [anon_sym_store] = ACTIONS(1946),
    [anon_sym_cmpxchg] = ACTIONS(1946),
    [anon_sym_atomicrmw] = ACTIONS(1946),
    [anon_sym_fence] = ACTIONS(1946),
    [anon_sym_getelementptr] = ACTIONS(1946),
    [anon_sym_extractvalue] = ACTIONS(1946),
    [anon_sym_insertvalue] = ACTIONS(1946),
    [anon_sym_mul] = ACTIONS(1946),
    [anon_sym_urem] = ACTIONS(1946),
    [anon_sym_srem] = ACTIONS(1946),
    [anon_sym_shl] = ACTIONS(1946),
    [anon_sym_udiv] = ACTIONS(1946),
    [anon_sym_sdiv] = ACTIONS(1946),
    [anon_sym_lshr] = ACTIONS(1946),
    [anon_sym_ashr] = ACTIONS(1946),
    [anon_sym_fmul] = ACTIONS(1946),
    [anon_sym_fdiv] = ACTIONS(1946),
    [anon_sym_frem] = ACTIONS(1946),
    [anon_sym_xchg] = ACTIONS(1946),
    [anon_sym_add] = ACTIONS(1946),
    [anon_sym_sub] = ACTIONS(1946),
    [anon_sym_and] = ACTIONS(1946),
    [anon_sym_nand] = ACTIONS(1946),
    [anon_sym_or] = ACTIONS(1946),
    [anon_sym_xor] = ACTIONS(1946),
    [anon_sym_max] = ACTIONS(1946),
    [anon_sym_min] = ACTIONS(1946),
    [anon_sym_umax] = ACTIONS(1946),
    [anon_sym_umin] = ACTIONS(1946),
    [anon_sym_fadd] = ACTIONS(1946),
    [anon_sym_fsub] = ACTIONS(1946),
    [anon_sym_bitcast] = ACTIONS(1946),
    [anon_sym_trunc] = ACTIONS(1946),
    [anon_sym_zext] = ACTIONS(1946),
    [anon_sym_sext] = ACTIONS(1946),
    [anon_sym_fptrunc] = ACTIONS(1946),
    [anon_sym_fpext] = ACTIONS(1946),
    [anon_sym_addrspacecast] = ACTIONS(1946),
    [anon_sym_uitofp] = ACTIONS(1946),
    [anon_sym_sitofp] = ACTIONS(1946),
    [anon_sym_fptoui] = ACTIONS(1946),
    [anon_sym_fptosi] = ACTIONS(1946),
    [anon_sym_inttoptr] = ACTIONS(1946),
    [anon_sym_ptrtoint] = ACTIONS(1946),
    [anon_sym_uselistorder] = ACTIONS(1946),
  },
  [590] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1948),
    [sym_label] = ACTIONS(1948),
    [anon_sym_RBRACE] = ACTIONS(1948),
    [anon_sym_COMMA] = ACTIONS(1948),
    [anon_sym_unreachable] = ACTIONS(1950),
    [anon_sym_ret] = ACTIONS(1950),
    [anon_sym_br] = ACTIONS(1950),
    [anon_sym_resume] = ACTIONS(1950),
    [anon_sym_freeze] = ACTIONS(1950),
    [anon_sym_indirectbr] = ACTIONS(1950),
    [anon_sym_extractelement] = ACTIONS(1950),
    [anon_sym_insertelement] = ACTIONS(1950),
    [anon_sym_select] = ACTIONS(1950),
    [anon_sym_shufflevector] = ACTIONS(1950),
    [anon_sym_fneg] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_invoke] = ACTIONS(1950),
    [anon_sym_cleanupret] = ACTIONS(1950),
    [anon_sym_catchret] = ACTIONS(1950),
    [anon_sym_catchswitch] = ACTIONS(1950),
    [anon_sym_catchpad] = ACTIONS(1950),
    [anon_sym_cleanuppad] = ACTIONS(1950),
    [anon_sym_callbr] = ACTIONS(1950),
    [anon_sym_icmp] = ACTIONS(1950),
    [anon_sym_fcmp] = ACTIONS(1950),
    [anon_sym_va_arg] = ACTIONS(1950),
    [anon_sym_phi] = ACTIONS(1950),
    [anon_sym_landingpad] = ACTIONS(1950),
    [anon_sym_tail] = ACTIONS(1950),
    [anon_sym_musttail] = ACTIONS(1950),
    [anon_sym_notail] = ACTIONS(1950),
    [anon_sym_call] = ACTIONS(1950),
    [anon_sym_alloca] = ACTIONS(1950),
    [anon_sym_load] = ACTIONS(1950),
    [anon_sym_store] = ACTIONS(1950),
    [anon_sym_cmpxchg] = ACTIONS(1950),
    [anon_sym_atomicrmw] = ACTIONS(1950),
    [anon_sym_fence] = ACTIONS(1950),
    [anon_sym_getelementptr] = ACTIONS(1950),
    [anon_sym_extractvalue] = ACTIONS(1950),
    [anon_sym_insertvalue] = ACTIONS(1950),
    [anon_sym_mul] = ACTIONS(1950),
    [anon_sym_urem] = ACTIONS(1950),
    [anon_sym_srem] = ACTIONS(1950),
    [anon_sym_shl] = ACTIONS(1950),
    [anon_sym_udiv] = ACTIONS(1950),
    [anon_sym_sdiv] = ACTIONS(1950),
    [anon_sym_lshr] = ACTIONS(1950),
    [anon_sym_ashr] = ACTIONS(1950),
    [anon_sym_fmul] = ACTIONS(1950),
    [anon_sym_fdiv] = ACTIONS(1950),
    [anon_sym_frem] = ACTIONS(1950),
    [anon_sym_xchg] = ACTIONS(1950),
    [anon_sym_add] = ACTIONS(1950),
    [anon_sym_sub] = ACTIONS(1950),
    [anon_sym_and] = ACTIONS(1950),
    [anon_sym_nand] = ACTIONS(1950),
    [anon_sym_or] = ACTIONS(1950),
    [anon_sym_xor] = ACTIONS(1950),
    [anon_sym_max] = ACTIONS(1950),
    [anon_sym_min] = ACTIONS(1950),
    [anon_sym_umax] = ACTIONS(1950),
    [anon_sym_umin] = ACTIONS(1950),
    [anon_sym_fadd] = ACTIONS(1950),
    [anon_sym_fsub] = ACTIONS(1950),
    [anon_sym_bitcast] = ACTIONS(1950),
    [anon_sym_trunc] = ACTIONS(1950),
    [anon_sym_zext] = ACTIONS(1950),
    [anon_sym_sext] = ACTIONS(1950),
    [anon_sym_fptrunc] = ACTIONS(1950),
    [anon_sym_fpext] = ACTIONS(1950),
    [anon_sym_addrspacecast] = ACTIONS(1950),
    [anon_sym_uitofp] = ACTIONS(1950),
    [anon_sym_sitofp] = ACTIONS(1950),
    [anon_sym_fptoui] = ACTIONS(1950),
    [anon_sym_fptosi] = ACTIONS(1950),
    [anon_sym_inttoptr] = ACTIONS(1950),
    [anon_sym_ptrtoint] = ACTIONS(1950),
    [anon_sym_uselistorder] = ACTIONS(1950),
  },
  [591] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1952),
    [sym_label] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(1952),
    [anon_sym_unreachable] = ACTIONS(1954),
    [anon_sym_ret] = ACTIONS(1954),
    [anon_sym_br] = ACTIONS(1954),
    [anon_sym_resume] = ACTIONS(1954),
    [anon_sym_freeze] = ACTIONS(1954),
    [anon_sym_indirectbr] = ACTIONS(1954),
    [anon_sym_extractelement] = ACTIONS(1954),
    [anon_sym_insertelement] = ACTIONS(1954),
    [anon_sym_select] = ACTIONS(1954),
    [anon_sym_shufflevector] = ACTIONS(1954),
    [anon_sym_fneg] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_invoke] = ACTIONS(1954),
    [anon_sym_cleanupret] = ACTIONS(1954),
    [anon_sym_catchret] = ACTIONS(1954),
    [anon_sym_catchswitch] = ACTIONS(1954),
    [anon_sym_catchpad] = ACTIONS(1954),
    [anon_sym_cleanuppad] = ACTIONS(1954),
    [anon_sym_callbr] = ACTIONS(1954),
    [anon_sym_icmp] = ACTIONS(1954),
    [anon_sym_fcmp] = ACTIONS(1954),
    [anon_sym_va_arg] = ACTIONS(1954),
    [anon_sym_phi] = ACTIONS(1954),
    [anon_sym_landingpad] = ACTIONS(1954),
    [anon_sym_tail] = ACTIONS(1954),
    [anon_sym_musttail] = ACTIONS(1954),
    [anon_sym_notail] = ACTIONS(1954),
    [anon_sym_call] = ACTIONS(1954),
    [anon_sym_alloca] = ACTIONS(1954),
    [anon_sym_load] = ACTIONS(1954),
    [anon_sym_store] = ACTIONS(1954),
    [anon_sym_cmpxchg] = ACTIONS(1954),
    [anon_sym_atomicrmw] = ACTIONS(1954),
    [anon_sym_fence] = ACTIONS(1954),
    [anon_sym_getelementptr] = ACTIONS(1954),
    [anon_sym_extractvalue] = ACTIONS(1954),
    [anon_sym_insertvalue] = ACTIONS(1954),
    [anon_sym_mul] = ACTIONS(1954),
    [anon_sym_urem] = ACTIONS(1954),
    [anon_sym_srem] = ACTIONS(1954),
    [anon_sym_shl] = ACTIONS(1954),
    [anon_sym_udiv] = ACTIONS(1954),
    [anon_sym_sdiv] = ACTIONS(1954),
    [anon_sym_lshr] = ACTIONS(1954),
    [anon_sym_ashr] = ACTIONS(1954),
    [anon_sym_fmul] = ACTIONS(1954),
    [anon_sym_fdiv] = ACTIONS(1954),
    [anon_sym_frem] = ACTIONS(1954),
    [anon_sym_xchg] = ACTIONS(1954),
    [anon_sym_add] = ACTIONS(1954),
    [anon_sym_sub] = ACTIONS(1954),
    [anon_sym_and] = ACTIONS(1954),
    [anon_sym_nand] = ACTIONS(1954),
    [anon_sym_or] = ACTIONS(1954),
    [anon_sym_xor] = ACTIONS(1954),
    [anon_sym_max] = ACTIONS(1954),
    [anon_sym_min] = ACTIONS(1954),
    [anon_sym_umax] = ACTIONS(1954),
    [anon_sym_umin] = ACTIONS(1954),
    [anon_sym_fadd] = ACTIONS(1954),
    [anon_sym_fsub] = ACTIONS(1954),
    [anon_sym_bitcast] = ACTIONS(1954),
    [anon_sym_trunc] = ACTIONS(1954),
    [anon_sym_zext] = ACTIONS(1954),
    [anon_sym_sext] = ACTIONS(1954),
    [anon_sym_fptrunc] = ACTIONS(1954),
    [anon_sym_fpext] = ACTIONS(1954),
    [anon_sym_addrspacecast] = ACTIONS(1954),
    [anon_sym_uitofp] = ACTIONS(1954),
    [anon_sym_sitofp] = ACTIONS(1954),
    [anon_sym_fptoui] = ACTIONS(1954),
    [anon_sym_fptosi] = ACTIONS(1954),
    [anon_sym_inttoptr] = ACTIONS(1954),
    [anon_sym_ptrtoint] = ACTIONS(1954),
    [anon_sym_uselistorder] = ACTIONS(1954),
  },
  [592] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1956),
    [sym_label] = ACTIONS(1956),
    [anon_sym_RBRACE] = ACTIONS(1956),
    [anon_sym_COMMA] = ACTIONS(1956),
    [anon_sym_unreachable] = ACTIONS(1958),
    [anon_sym_ret] = ACTIONS(1958),
    [anon_sym_br] = ACTIONS(1958),
    [anon_sym_resume] = ACTIONS(1958),
    [anon_sym_freeze] = ACTIONS(1958),
    [anon_sym_indirectbr] = ACTIONS(1958),
    [anon_sym_extractelement] = ACTIONS(1958),
    [anon_sym_insertelement] = ACTIONS(1958),
    [anon_sym_select] = ACTIONS(1958),
    [anon_sym_shufflevector] = ACTIONS(1958),
    [anon_sym_fneg] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_invoke] = ACTIONS(1958),
    [anon_sym_cleanupret] = ACTIONS(1958),
    [anon_sym_catchret] = ACTIONS(1958),
    [anon_sym_catchswitch] = ACTIONS(1958),
    [anon_sym_catchpad] = ACTIONS(1958),
    [anon_sym_cleanuppad] = ACTIONS(1958),
    [anon_sym_callbr] = ACTIONS(1958),
    [anon_sym_icmp] = ACTIONS(1958),
    [anon_sym_fcmp] = ACTIONS(1958),
    [anon_sym_va_arg] = ACTIONS(1958),
    [anon_sym_phi] = ACTIONS(1958),
    [anon_sym_landingpad] = ACTIONS(1958),
    [anon_sym_tail] = ACTIONS(1958),
    [anon_sym_musttail] = ACTIONS(1958),
    [anon_sym_notail] = ACTIONS(1958),
    [anon_sym_call] = ACTIONS(1958),
    [anon_sym_alloca] = ACTIONS(1958),
    [anon_sym_load] = ACTIONS(1958),
    [anon_sym_store] = ACTIONS(1958),
    [anon_sym_cmpxchg] = ACTIONS(1958),
    [anon_sym_atomicrmw] = ACTIONS(1958),
    [anon_sym_fence] = ACTIONS(1958),
    [anon_sym_getelementptr] = ACTIONS(1958),
    [anon_sym_extractvalue] = ACTIONS(1958),
    [anon_sym_insertvalue] = ACTIONS(1958),
    [anon_sym_mul] = ACTIONS(1958),
    [anon_sym_urem] = ACTIONS(1958),
    [anon_sym_srem] = ACTIONS(1958),
    [anon_sym_shl] = ACTIONS(1958),
    [anon_sym_udiv] = ACTIONS(1958),
    [anon_sym_sdiv] = ACTIONS(1958),
    [anon_sym_lshr] = ACTIONS(1958),
    [anon_sym_ashr] = ACTIONS(1958),
    [anon_sym_fmul] = ACTIONS(1958),
    [anon_sym_fdiv] = ACTIONS(1958),
    [anon_sym_frem] = ACTIONS(1958),
    [anon_sym_xchg] = ACTIONS(1958),
    [anon_sym_add] = ACTIONS(1958),
    [anon_sym_sub] = ACTIONS(1958),
    [anon_sym_and] = ACTIONS(1958),
    [anon_sym_nand] = ACTIONS(1958),
    [anon_sym_or] = ACTIONS(1958),
    [anon_sym_xor] = ACTIONS(1958),
    [anon_sym_max] = ACTIONS(1958),
    [anon_sym_min] = ACTIONS(1958),
    [anon_sym_umax] = ACTIONS(1958),
    [anon_sym_umin] = ACTIONS(1958),
    [anon_sym_fadd] = ACTIONS(1958),
    [anon_sym_fsub] = ACTIONS(1958),
    [anon_sym_bitcast] = ACTIONS(1958),
    [anon_sym_trunc] = ACTIONS(1958),
    [anon_sym_zext] = ACTIONS(1958),
    [anon_sym_sext] = ACTIONS(1958),
    [anon_sym_fptrunc] = ACTIONS(1958),
    [anon_sym_fpext] = ACTIONS(1958),
    [anon_sym_addrspacecast] = ACTIONS(1958),
    [anon_sym_uitofp] = ACTIONS(1958),
    [anon_sym_sitofp] = ACTIONS(1958),
    [anon_sym_fptoui] = ACTIONS(1958),
    [anon_sym_fptosi] = ACTIONS(1958),
    [anon_sym_inttoptr] = ACTIONS(1958),
    [anon_sym_ptrtoint] = ACTIONS(1958),
    [anon_sym_uselistorder] = ACTIONS(1958),
  },
  [593] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1960),
    [sym_label] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1960),
    [anon_sym_unreachable] = ACTIONS(1962),
    [anon_sym_ret] = ACTIONS(1962),
    [anon_sym_br] = ACTIONS(1962),
    [anon_sym_resume] = ACTIONS(1962),
    [anon_sym_freeze] = ACTIONS(1962),
    [anon_sym_indirectbr] = ACTIONS(1962),
    [anon_sym_extractelement] = ACTIONS(1962),
    [anon_sym_insertelement] = ACTIONS(1962),
    [anon_sym_select] = ACTIONS(1962),
    [anon_sym_shufflevector] = ACTIONS(1962),
    [anon_sym_fneg] = ACTIONS(1962),
    [anon_sym_switch] = ACTIONS(1962),
    [anon_sym_invoke] = ACTIONS(1962),
    [anon_sym_cleanupret] = ACTIONS(1962),
    [anon_sym_catchret] = ACTIONS(1962),
    [anon_sym_catchswitch] = ACTIONS(1962),
    [anon_sym_catchpad] = ACTIONS(1962),
    [anon_sym_cleanuppad] = ACTIONS(1962),
    [anon_sym_callbr] = ACTIONS(1962),
    [anon_sym_icmp] = ACTIONS(1962),
    [anon_sym_fcmp] = ACTIONS(1962),
    [anon_sym_va_arg] = ACTIONS(1962),
    [anon_sym_phi] = ACTIONS(1962),
    [anon_sym_landingpad] = ACTIONS(1962),
    [anon_sym_tail] = ACTIONS(1962),
    [anon_sym_musttail] = ACTIONS(1962),
    [anon_sym_notail] = ACTIONS(1962),
    [anon_sym_call] = ACTIONS(1962),
    [anon_sym_alloca] = ACTIONS(1962),
    [anon_sym_load] = ACTIONS(1962),
    [anon_sym_store] = ACTIONS(1962),
    [anon_sym_cmpxchg] = ACTIONS(1962),
    [anon_sym_atomicrmw] = ACTIONS(1962),
    [anon_sym_fence] = ACTIONS(1962),
    [anon_sym_getelementptr] = ACTIONS(1962),
    [anon_sym_extractvalue] = ACTIONS(1962),
    [anon_sym_insertvalue] = ACTIONS(1962),
    [anon_sym_mul] = ACTIONS(1962),
    [anon_sym_urem] = ACTIONS(1962),
    [anon_sym_srem] = ACTIONS(1962),
    [anon_sym_shl] = ACTIONS(1962),
    [anon_sym_udiv] = ACTIONS(1962),
    [anon_sym_sdiv] = ACTIONS(1962),
    [anon_sym_lshr] = ACTIONS(1962),
    [anon_sym_ashr] = ACTIONS(1962),
    [anon_sym_fmul] = ACTIONS(1962),
    [anon_sym_fdiv] = ACTIONS(1962),
    [anon_sym_frem] = ACTIONS(1962),
    [anon_sym_xchg] = ACTIONS(1962),
    [anon_sym_add] = ACTIONS(1962),
    [anon_sym_sub] = ACTIONS(1962),
    [anon_sym_and] = ACTIONS(1962),
    [anon_sym_nand] = ACTIONS(1962),
    [anon_sym_or] = ACTIONS(1962),
    [anon_sym_xor] = ACTIONS(1962),
    [anon_sym_max] = ACTIONS(1962),
    [anon_sym_min] = ACTIONS(1962),
    [anon_sym_umax] = ACTIONS(1962),
    [anon_sym_umin] = ACTIONS(1962),
    [anon_sym_fadd] = ACTIONS(1962),
    [anon_sym_fsub] = ACTIONS(1962),
    [anon_sym_bitcast] = ACTIONS(1962),
    [anon_sym_trunc] = ACTIONS(1962),
    [anon_sym_zext] = ACTIONS(1962),
    [anon_sym_sext] = ACTIONS(1962),
    [anon_sym_fptrunc] = ACTIONS(1962),
    [anon_sym_fpext] = ACTIONS(1962),
    [anon_sym_addrspacecast] = ACTIONS(1962),
    [anon_sym_uitofp] = ACTIONS(1962),
    [anon_sym_sitofp] = ACTIONS(1962),
    [anon_sym_fptoui] = ACTIONS(1962),
    [anon_sym_fptosi] = ACTIONS(1962),
    [anon_sym_inttoptr] = ACTIONS(1962),
    [anon_sym_ptrtoint] = ACTIONS(1962),
    [anon_sym_uselistorder] = ACTIONS(1962),
  },
  [594] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1964),
    [sym_label] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(1964),
    [anon_sym_unreachable] = ACTIONS(1966),
    [anon_sym_ret] = ACTIONS(1966),
    [anon_sym_br] = ACTIONS(1966),
    [anon_sym_resume] = ACTIONS(1966),
    [anon_sym_freeze] = ACTIONS(1966),
    [anon_sym_indirectbr] = ACTIONS(1966),
    [anon_sym_extractelement] = ACTIONS(1966),
    [anon_sym_insertelement] = ACTIONS(1966),
    [anon_sym_select] = ACTIONS(1966),
    [anon_sym_shufflevector] = ACTIONS(1966),
    [anon_sym_fneg] = ACTIONS(1966),
    [anon_sym_switch] = ACTIONS(1966),
    [anon_sym_invoke] = ACTIONS(1966),
    [anon_sym_cleanupret] = ACTIONS(1966),
    [anon_sym_catchret] = ACTIONS(1966),
    [anon_sym_catchswitch] = ACTIONS(1966),
    [anon_sym_catchpad] = ACTIONS(1966),
    [anon_sym_cleanuppad] = ACTIONS(1966),
    [anon_sym_callbr] = ACTIONS(1966),
    [anon_sym_icmp] = ACTIONS(1966),
    [anon_sym_fcmp] = ACTIONS(1966),
    [anon_sym_va_arg] = ACTIONS(1966),
    [anon_sym_phi] = ACTIONS(1966),
    [anon_sym_landingpad] = ACTIONS(1966),
    [anon_sym_tail] = ACTIONS(1966),
    [anon_sym_musttail] = ACTIONS(1966),
    [anon_sym_notail] = ACTIONS(1966),
    [anon_sym_call] = ACTIONS(1966),
    [anon_sym_alloca] = ACTIONS(1966),
    [anon_sym_load] = ACTIONS(1966),
    [anon_sym_store] = ACTIONS(1966),
    [anon_sym_cmpxchg] = ACTIONS(1966),
    [anon_sym_atomicrmw] = ACTIONS(1966),
    [anon_sym_fence] = ACTIONS(1966),
    [anon_sym_getelementptr] = ACTIONS(1966),
    [anon_sym_extractvalue] = ACTIONS(1966),
    [anon_sym_insertvalue] = ACTIONS(1966),
    [anon_sym_mul] = ACTIONS(1966),
    [anon_sym_urem] = ACTIONS(1966),
    [anon_sym_srem] = ACTIONS(1966),
    [anon_sym_shl] = ACTIONS(1966),
    [anon_sym_udiv] = ACTIONS(1966),
    [anon_sym_sdiv] = ACTIONS(1966),
    [anon_sym_lshr] = ACTIONS(1966),
    [anon_sym_ashr] = ACTIONS(1966),
    [anon_sym_fmul] = ACTIONS(1966),
    [anon_sym_fdiv] = ACTIONS(1966),
    [anon_sym_frem] = ACTIONS(1966),
    [anon_sym_xchg] = ACTIONS(1966),
    [anon_sym_add] = ACTIONS(1966),
    [anon_sym_sub] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_nand] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_xor] = ACTIONS(1966),
    [anon_sym_max] = ACTIONS(1966),
    [anon_sym_min] = ACTIONS(1966),
    [anon_sym_umax] = ACTIONS(1966),
    [anon_sym_umin] = ACTIONS(1966),
    [anon_sym_fadd] = ACTIONS(1966),
    [anon_sym_fsub] = ACTIONS(1966),
    [anon_sym_bitcast] = ACTIONS(1966),
    [anon_sym_trunc] = ACTIONS(1966),
    [anon_sym_zext] = ACTIONS(1966),
    [anon_sym_sext] = ACTIONS(1966),
    [anon_sym_fptrunc] = ACTIONS(1966),
    [anon_sym_fpext] = ACTIONS(1966),
    [anon_sym_addrspacecast] = ACTIONS(1966),
    [anon_sym_uitofp] = ACTIONS(1966),
    [anon_sym_sitofp] = ACTIONS(1966),
    [anon_sym_fptoui] = ACTIONS(1966),
    [anon_sym_fptosi] = ACTIONS(1966),
    [anon_sym_inttoptr] = ACTIONS(1966),
    [anon_sym_ptrtoint] = ACTIONS(1966),
    [anon_sym_uselistorder] = ACTIONS(1966),
  },
  [595] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1968),
    [sym_label] = ACTIONS(1968),
    [anon_sym_RBRACE] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_unreachable] = ACTIONS(1970),
    [anon_sym_ret] = ACTIONS(1970),
    [anon_sym_br] = ACTIONS(1970),
    [anon_sym_resume] = ACTIONS(1970),
    [anon_sym_freeze] = ACTIONS(1970),
    [anon_sym_indirectbr] = ACTIONS(1970),
    [anon_sym_extractelement] = ACTIONS(1970),
    [anon_sym_insertelement] = ACTIONS(1970),
    [anon_sym_select] = ACTIONS(1970),
    [anon_sym_shufflevector] = ACTIONS(1970),
    [anon_sym_fneg] = ACTIONS(1970),
    [anon_sym_switch] = ACTIONS(1970),
    [anon_sym_invoke] = ACTIONS(1970),
    [anon_sym_cleanupret] = ACTIONS(1970),
    [anon_sym_catchret] = ACTIONS(1970),
    [anon_sym_catchswitch] = ACTIONS(1970),
    [anon_sym_catchpad] = ACTIONS(1970),
    [anon_sym_cleanuppad] = ACTIONS(1970),
    [anon_sym_callbr] = ACTIONS(1970),
    [anon_sym_icmp] = ACTIONS(1970),
    [anon_sym_fcmp] = ACTIONS(1970),
    [anon_sym_va_arg] = ACTIONS(1970),
    [anon_sym_phi] = ACTIONS(1970),
    [anon_sym_landingpad] = ACTIONS(1970),
    [anon_sym_tail] = ACTIONS(1970),
    [anon_sym_musttail] = ACTIONS(1970),
    [anon_sym_notail] = ACTIONS(1970),
    [anon_sym_call] = ACTIONS(1970),
    [anon_sym_alloca] = ACTIONS(1970),
    [anon_sym_load] = ACTIONS(1970),
    [anon_sym_store] = ACTIONS(1970),
    [anon_sym_cmpxchg] = ACTIONS(1970),
    [anon_sym_atomicrmw] = ACTIONS(1970),
    [anon_sym_fence] = ACTIONS(1970),
    [anon_sym_getelementptr] = ACTIONS(1970),
    [anon_sym_extractvalue] = ACTIONS(1970),
    [anon_sym_insertvalue] = ACTIONS(1970),
    [anon_sym_mul] = ACTIONS(1970),
    [anon_sym_urem] = ACTIONS(1970),
    [anon_sym_srem] = ACTIONS(1970),
    [anon_sym_shl] = ACTIONS(1970),
    [anon_sym_udiv] = ACTIONS(1970),
    [anon_sym_sdiv] = ACTIONS(1970),
    [anon_sym_lshr] = ACTIONS(1970),
    [anon_sym_ashr] = ACTIONS(1970),
    [anon_sym_fmul] = ACTIONS(1970),
    [anon_sym_fdiv] = ACTIONS(1970),
    [anon_sym_frem] = ACTIONS(1970),
    [anon_sym_xchg] = ACTIONS(1970),
    [anon_sym_add] = ACTIONS(1970),
    [anon_sym_sub] = ACTIONS(1970),
    [anon_sym_and] = ACTIONS(1970),
    [anon_sym_nand] = ACTIONS(1970),
    [anon_sym_or] = ACTIONS(1970),
    [anon_sym_xor] = ACTIONS(1970),
    [anon_sym_max] = ACTIONS(1970),
    [anon_sym_min] = ACTIONS(1970),
    [anon_sym_umax] = ACTIONS(1970),
    [anon_sym_umin] = ACTIONS(1970),
    [anon_sym_fadd] = ACTIONS(1970),
    [anon_sym_fsub] = ACTIONS(1970),
    [anon_sym_bitcast] = ACTIONS(1970),
    [anon_sym_trunc] = ACTIONS(1970),
    [anon_sym_zext] = ACTIONS(1970),
    [anon_sym_sext] = ACTIONS(1970),
    [anon_sym_fptrunc] = ACTIONS(1970),
    [anon_sym_fpext] = ACTIONS(1970),
    [anon_sym_addrspacecast] = ACTIONS(1970),
    [anon_sym_uitofp] = ACTIONS(1970),
    [anon_sym_sitofp] = ACTIONS(1970),
    [anon_sym_fptoui] = ACTIONS(1970),
    [anon_sym_fptosi] = ACTIONS(1970),
    [anon_sym_inttoptr] = ACTIONS(1970),
    [anon_sym_ptrtoint] = ACTIONS(1970),
    [anon_sym_uselistorder] = ACTIONS(1970),
  },
  [596] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1972),
    [sym_label] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_COMMA] = ACTIONS(1974),
    [anon_sym_unreachable] = ACTIONS(1977),
    [anon_sym_ret] = ACTIONS(1977),
    [anon_sym_br] = ACTIONS(1977),
    [anon_sym_resume] = ACTIONS(1977),
    [anon_sym_freeze] = ACTIONS(1977),
    [anon_sym_indirectbr] = ACTIONS(1977),
    [anon_sym_extractelement] = ACTIONS(1977),
    [anon_sym_insertelement] = ACTIONS(1977),
    [anon_sym_select] = ACTIONS(1977),
    [anon_sym_shufflevector] = ACTIONS(1977),
    [anon_sym_fneg] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_invoke] = ACTIONS(1977),
    [anon_sym_cleanupret] = ACTIONS(1977),
    [anon_sym_catchret] = ACTIONS(1977),
    [anon_sym_catchswitch] = ACTIONS(1977),
    [anon_sym_catchpad] = ACTIONS(1977),
    [anon_sym_cleanuppad] = ACTIONS(1977),
    [anon_sym_callbr] = ACTIONS(1977),
    [anon_sym_icmp] = ACTIONS(1977),
    [anon_sym_fcmp] = ACTIONS(1977),
    [anon_sym_va_arg] = ACTIONS(1977),
    [anon_sym_phi] = ACTIONS(1977),
    [anon_sym_landingpad] = ACTIONS(1977),
    [anon_sym_tail] = ACTIONS(1977),
    [anon_sym_musttail] = ACTIONS(1977),
    [anon_sym_notail] = ACTIONS(1977),
    [anon_sym_call] = ACTIONS(1977),
    [anon_sym_alloca] = ACTIONS(1977),
    [anon_sym_load] = ACTIONS(1977),
    [anon_sym_store] = ACTIONS(1977),
    [anon_sym_cmpxchg] = ACTIONS(1977),
    [anon_sym_atomicrmw] = ACTIONS(1977),
    [anon_sym_fence] = ACTIONS(1977),
    [anon_sym_getelementptr] = ACTIONS(1977),
    [anon_sym_extractvalue] = ACTIONS(1977),
    [anon_sym_insertvalue] = ACTIONS(1977),
    [anon_sym_mul] = ACTIONS(1977),
    [anon_sym_urem] = ACTIONS(1977),
    [anon_sym_srem] = ACTIONS(1977),
    [anon_sym_shl] = ACTIONS(1977),
    [anon_sym_udiv] = ACTIONS(1977),
    [anon_sym_sdiv] = ACTIONS(1977),
    [anon_sym_lshr] = ACTIONS(1977),
    [anon_sym_ashr] = ACTIONS(1977),
    [anon_sym_fmul] = ACTIONS(1977),
    [anon_sym_fdiv] = ACTIONS(1977),
    [anon_sym_frem] = ACTIONS(1977),
    [anon_sym_xchg] = ACTIONS(1977),
    [anon_sym_add] = ACTIONS(1977),
    [anon_sym_sub] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_nand] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1977),
    [anon_sym_xor] = ACTIONS(1977),
    [anon_sym_max] = ACTIONS(1977),
    [anon_sym_min] = ACTIONS(1977),
    [anon_sym_umax] = ACTIONS(1977),
    [anon_sym_umin] = ACTIONS(1977),
    [anon_sym_fadd] = ACTIONS(1977),
    [anon_sym_fsub] = ACTIONS(1977),
    [anon_sym_bitcast] = ACTIONS(1977),
    [anon_sym_trunc] = ACTIONS(1977),
    [anon_sym_zext] = ACTIONS(1977),
    [anon_sym_sext] = ACTIONS(1977),
    [anon_sym_fptrunc] = ACTIONS(1977),
    [anon_sym_fpext] = ACTIONS(1977),
    [anon_sym_addrspacecast] = ACTIONS(1977),
    [anon_sym_uitofp] = ACTIONS(1977),
    [anon_sym_sitofp] = ACTIONS(1977),
    [anon_sym_fptoui] = ACTIONS(1977),
    [anon_sym_fptosi] = ACTIONS(1977),
    [anon_sym_inttoptr] = ACTIONS(1977),
    [anon_sym_ptrtoint] = ACTIONS(1977),
    [anon_sym_uselistorder] = ACTIONS(1977),
  },
  [597] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1960),
    [sym_label] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1979),
    [anon_sym_unreachable] = ACTIONS(1962),
    [anon_sym_ret] = ACTIONS(1962),
    [anon_sym_br] = ACTIONS(1962),
    [anon_sym_resume] = ACTIONS(1962),
    [anon_sym_freeze] = ACTIONS(1962),
    [anon_sym_indirectbr] = ACTIONS(1962),
    [anon_sym_extractelement] = ACTIONS(1962),
    [anon_sym_insertelement] = ACTIONS(1962),
    [anon_sym_select] = ACTIONS(1962),
    [anon_sym_shufflevector] = ACTIONS(1962),
    [anon_sym_fneg] = ACTIONS(1962),
    [anon_sym_switch] = ACTIONS(1962),
    [anon_sym_invoke] = ACTIONS(1962),
    [anon_sym_cleanupret] = ACTIONS(1962),
    [anon_sym_catchret] = ACTIONS(1962),
    [anon_sym_catchswitch] = ACTIONS(1962),
    [anon_sym_catchpad] = ACTIONS(1962),
    [anon_sym_cleanuppad] = ACTIONS(1962),
    [anon_sym_callbr] = ACTIONS(1962),
    [anon_sym_icmp] = ACTIONS(1962),
    [anon_sym_fcmp] = ACTIONS(1962),
    [anon_sym_va_arg] = ACTIONS(1962),
    [anon_sym_phi] = ACTIONS(1962),
    [anon_sym_landingpad] = ACTIONS(1962),
    [anon_sym_tail] = ACTIONS(1962),
    [anon_sym_musttail] = ACTIONS(1962),
    [anon_sym_notail] = ACTIONS(1962),
    [anon_sym_call] = ACTIONS(1962),
    [anon_sym_alloca] = ACTIONS(1962),
    [anon_sym_load] = ACTIONS(1962),
    [anon_sym_store] = ACTIONS(1962),
    [anon_sym_cmpxchg] = ACTIONS(1962),
    [anon_sym_atomicrmw] = ACTIONS(1962),
    [anon_sym_fence] = ACTIONS(1962),
    [anon_sym_getelementptr] = ACTIONS(1962),
    [anon_sym_extractvalue] = ACTIONS(1962),
    [anon_sym_insertvalue] = ACTIONS(1962),
    [anon_sym_mul] = ACTIONS(1962),
    [anon_sym_urem] = ACTIONS(1962),
    [anon_sym_srem] = ACTIONS(1962),
    [anon_sym_shl] = ACTIONS(1962),
    [anon_sym_udiv] = ACTIONS(1962),
    [anon_sym_sdiv] = ACTIONS(1962),
    [anon_sym_lshr] = ACTIONS(1962),
    [anon_sym_ashr] = ACTIONS(1962),
    [anon_sym_fmul] = ACTIONS(1962),
    [anon_sym_fdiv] = ACTIONS(1962),
    [anon_sym_frem] = ACTIONS(1962),
    [anon_sym_xchg] = ACTIONS(1962),
    [anon_sym_add] = ACTIONS(1962),
    [anon_sym_sub] = ACTIONS(1962),
    [anon_sym_and] = ACTIONS(1962),
    [anon_sym_nand] = ACTIONS(1962),
    [anon_sym_or] = ACTIONS(1962),
    [anon_sym_xor] = ACTIONS(1962),
    [anon_sym_max] = ACTIONS(1962),
    [anon_sym_min] = ACTIONS(1962),
    [anon_sym_umax] = ACTIONS(1962),
    [anon_sym_umin] = ACTIONS(1962),
    [anon_sym_fadd] = ACTIONS(1962),
    [anon_sym_fsub] = ACTIONS(1962),
    [anon_sym_bitcast] = ACTIONS(1962),
    [anon_sym_trunc] = ACTIONS(1962),
    [anon_sym_zext] = ACTIONS(1962),
    [anon_sym_sext] = ACTIONS(1962),
    [anon_sym_fptrunc] = ACTIONS(1962),
    [anon_sym_fpext] = ACTIONS(1962),
    [anon_sym_addrspacecast] = ACTIONS(1962),
    [anon_sym_uitofp] = ACTIONS(1962),
    [anon_sym_sitofp] = ACTIONS(1962),
    [anon_sym_fptoui] = ACTIONS(1962),
    [anon_sym_fptosi] = ACTIONS(1962),
    [anon_sym_inttoptr] = ACTIONS(1962),
    [anon_sym_ptrtoint] = ACTIONS(1962),
    [anon_sym_uselistorder] = ACTIONS(1962),
  },
  [598] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1972),
    [sym_label] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_unreachable] = ACTIONS(1977),
    [anon_sym_ret] = ACTIONS(1977),
    [anon_sym_br] = ACTIONS(1977),
    [anon_sym_resume] = ACTIONS(1977),
    [anon_sym_freeze] = ACTIONS(1977),
    [anon_sym_indirectbr] = ACTIONS(1977),
    [anon_sym_extractelement] = ACTIONS(1977),
    [anon_sym_insertelement] = ACTIONS(1977),
    [anon_sym_select] = ACTIONS(1977),
    [anon_sym_shufflevector] = ACTIONS(1977),
    [anon_sym_fneg] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_invoke] = ACTIONS(1977),
    [anon_sym_cleanupret] = ACTIONS(1977),
    [anon_sym_catchret] = ACTIONS(1977),
    [anon_sym_catchswitch] = ACTIONS(1977),
    [anon_sym_catchpad] = ACTIONS(1977),
    [anon_sym_cleanuppad] = ACTIONS(1977),
    [anon_sym_callbr] = ACTIONS(1977),
    [anon_sym_icmp] = ACTIONS(1977),
    [anon_sym_fcmp] = ACTIONS(1977),
    [anon_sym_va_arg] = ACTIONS(1977),
    [anon_sym_phi] = ACTIONS(1977),
    [anon_sym_landingpad] = ACTIONS(1977),
    [anon_sym_tail] = ACTIONS(1977),
    [anon_sym_musttail] = ACTIONS(1977),
    [anon_sym_notail] = ACTIONS(1977),
    [anon_sym_call] = ACTIONS(1977),
    [anon_sym_alloca] = ACTIONS(1977),
    [anon_sym_load] = ACTIONS(1977),
    [anon_sym_store] = ACTIONS(1977),
    [anon_sym_cmpxchg] = ACTIONS(1977),
    [anon_sym_atomicrmw] = ACTIONS(1977),
    [anon_sym_fence] = ACTIONS(1977),
    [anon_sym_getelementptr] = ACTIONS(1977),
    [anon_sym_extractvalue] = ACTIONS(1977),
    [anon_sym_insertvalue] = ACTIONS(1977),
    [anon_sym_mul] = ACTIONS(1977),
    [anon_sym_urem] = ACTIONS(1977),
    [anon_sym_srem] = ACTIONS(1977),
    [anon_sym_shl] = ACTIONS(1977),
    [anon_sym_udiv] = ACTIONS(1977),
    [anon_sym_sdiv] = ACTIONS(1977),
    [anon_sym_lshr] = ACTIONS(1977),
    [anon_sym_ashr] = ACTIONS(1977),
    [anon_sym_fmul] = ACTIONS(1977),
    [anon_sym_fdiv] = ACTIONS(1977),
    [anon_sym_frem] = ACTIONS(1977),
    [anon_sym_xchg] = ACTIONS(1977),
    [anon_sym_add] = ACTIONS(1977),
    [anon_sym_sub] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_nand] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1977),
    [anon_sym_xor] = ACTIONS(1977),
    [anon_sym_max] = ACTIONS(1977),
    [anon_sym_min] = ACTIONS(1977),
    [anon_sym_umax] = ACTIONS(1977),
    [anon_sym_umin] = ACTIONS(1977),
    [anon_sym_fadd] = ACTIONS(1977),
    [anon_sym_fsub] = ACTIONS(1977),
    [anon_sym_bitcast] = ACTIONS(1977),
    [anon_sym_trunc] = ACTIONS(1977),
    [anon_sym_zext] = ACTIONS(1977),
    [anon_sym_sext] = ACTIONS(1977),
    [anon_sym_fptrunc] = ACTIONS(1977),
    [anon_sym_fpext] = ACTIONS(1977),
    [anon_sym_addrspacecast] = ACTIONS(1977),
    [anon_sym_uitofp] = ACTIONS(1977),
    [anon_sym_sitofp] = ACTIONS(1977),
    [anon_sym_fptoui] = ACTIONS(1977),
    [anon_sym_fptosi] = ACTIONS(1977),
    [anon_sym_inttoptr] = ACTIONS(1977),
    [anon_sym_ptrtoint] = ACTIONS(1977),
    [anon_sym_uselistorder] = ACTIONS(1977),
  },
  [599] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1982),
    [sym_label] = ACTIONS(1982),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_COMMA] = ACTIONS(1982),
    [anon_sym_unreachable] = ACTIONS(1984),
    [anon_sym_ret] = ACTIONS(1984),
    [anon_sym_br] = ACTIONS(1984),
    [anon_sym_resume] = ACTIONS(1984),
    [anon_sym_freeze] = ACTIONS(1984),
    [anon_sym_indirectbr] = ACTIONS(1984),
    [anon_sym_extractelement] = ACTIONS(1984),
    [anon_sym_insertelement] = ACTIONS(1984),
    [anon_sym_select] = ACTIONS(1984),
    [anon_sym_shufflevector] = ACTIONS(1984),
    [anon_sym_fneg] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_invoke] = ACTIONS(1984),
    [anon_sym_cleanupret] = ACTIONS(1984),
    [anon_sym_catchret] = ACTIONS(1984),
    [anon_sym_catchswitch] = ACTIONS(1984),
    [anon_sym_catchpad] = ACTIONS(1984),
    [anon_sym_cleanuppad] = ACTIONS(1984),
    [anon_sym_callbr] = ACTIONS(1984),
    [anon_sym_icmp] = ACTIONS(1984),
    [anon_sym_fcmp] = ACTIONS(1984),
    [anon_sym_va_arg] = ACTIONS(1984),
    [anon_sym_phi] = ACTIONS(1984),
    [anon_sym_landingpad] = ACTIONS(1984),
    [anon_sym_tail] = ACTIONS(1984),
    [anon_sym_musttail] = ACTIONS(1984),
    [anon_sym_notail] = ACTIONS(1984),
    [anon_sym_call] = ACTIONS(1984),
    [anon_sym_alloca] = ACTIONS(1984),
    [anon_sym_load] = ACTIONS(1984),
    [anon_sym_store] = ACTIONS(1984),
    [anon_sym_cmpxchg] = ACTIONS(1984),
    [anon_sym_atomicrmw] = ACTIONS(1984),
    [anon_sym_fence] = ACTIONS(1984),
    [anon_sym_getelementptr] = ACTIONS(1984),
    [anon_sym_extractvalue] = ACTIONS(1984),
    [anon_sym_insertvalue] = ACTIONS(1984),
    [anon_sym_mul] = ACTIONS(1984),
    [anon_sym_urem] = ACTIONS(1984),
    [anon_sym_srem] = ACTIONS(1984),
    [anon_sym_shl] = ACTIONS(1984),
    [anon_sym_udiv] = ACTIONS(1984),
    [anon_sym_sdiv] = ACTIONS(1984),
    [anon_sym_lshr] = ACTIONS(1984),
    [anon_sym_ashr] = ACTIONS(1984),
    [anon_sym_fmul] = ACTIONS(1984),
    [anon_sym_fdiv] = ACTIONS(1984),
    [anon_sym_frem] = ACTIONS(1984),
    [anon_sym_xchg] = ACTIONS(1984),
    [anon_sym_add] = ACTIONS(1984),
    [anon_sym_sub] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_nand] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_xor] = ACTIONS(1984),
    [anon_sym_max] = ACTIONS(1984),
    [anon_sym_min] = ACTIONS(1984),
    [anon_sym_umax] = ACTIONS(1984),
    [anon_sym_umin] = ACTIONS(1984),
    [anon_sym_fadd] = ACTIONS(1984),
    [anon_sym_fsub] = ACTIONS(1984),
    [anon_sym_bitcast] = ACTIONS(1984),
    [anon_sym_trunc] = ACTIONS(1984),
    [anon_sym_zext] = ACTIONS(1984),
    [anon_sym_sext] = ACTIONS(1984),
    [anon_sym_fptrunc] = ACTIONS(1984),
    [anon_sym_fpext] = ACTIONS(1984),
    [anon_sym_addrspacecast] = ACTIONS(1984),
    [anon_sym_uitofp] = ACTIONS(1984),
    [anon_sym_sitofp] = ACTIONS(1984),
    [anon_sym_fptoui] = ACTIONS(1984),
    [anon_sym_fptosi] = ACTIONS(1984),
    [anon_sym_inttoptr] = ACTIONS(1984),
    [anon_sym_ptrtoint] = ACTIONS(1984),
    [anon_sym_uselistorder] = ACTIONS(1984),
  },
  [600] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1986),
    [sym_label] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_unreachable] = ACTIONS(1991),
    [anon_sym_ret] = ACTIONS(1991),
    [anon_sym_br] = ACTIONS(1991),
    [anon_sym_resume] = ACTIONS(1991),
    [anon_sym_freeze] = ACTIONS(1991),
    [anon_sym_indirectbr] = ACTIONS(1991),
    [anon_sym_extractelement] = ACTIONS(1991),
    [anon_sym_insertelement] = ACTIONS(1991),
    [anon_sym_select] = ACTIONS(1991),
    [anon_sym_shufflevector] = ACTIONS(1991),
    [anon_sym_fneg] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_invoke] = ACTIONS(1991),
    [anon_sym_cleanupret] = ACTIONS(1991),
    [anon_sym_catchret] = ACTIONS(1991),
    [anon_sym_catchswitch] = ACTIONS(1991),
    [anon_sym_catchpad] = ACTIONS(1991),
    [anon_sym_cleanuppad] = ACTIONS(1991),
    [anon_sym_callbr] = ACTIONS(1991),
    [anon_sym_icmp] = ACTIONS(1991),
    [anon_sym_fcmp] = ACTIONS(1991),
    [anon_sym_va_arg] = ACTIONS(1991),
    [anon_sym_phi] = ACTIONS(1991),
    [anon_sym_landingpad] = ACTIONS(1991),
    [anon_sym_tail] = ACTIONS(1991),
    [anon_sym_musttail] = ACTIONS(1991),
    [anon_sym_notail] = ACTIONS(1991),
    [anon_sym_call] = ACTIONS(1991),
    [anon_sym_alloca] = ACTIONS(1991),
    [anon_sym_load] = ACTIONS(1991),
    [anon_sym_store] = ACTIONS(1991),
    [anon_sym_cmpxchg] = ACTIONS(1991),
    [anon_sym_atomicrmw] = ACTIONS(1991),
    [anon_sym_fence] = ACTIONS(1991),
    [anon_sym_getelementptr] = ACTIONS(1991),
    [anon_sym_extractvalue] = ACTIONS(1991),
    [anon_sym_insertvalue] = ACTIONS(1991),
    [anon_sym_mul] = ACTIONS(1991),
    [anon_sym_urem] = ACTIONS(1991),
    [anon_sym_srem] = ACTIONS(1991),
    [anon_sym_shl] = ACTIONS(1991),
    [anon_sym_udiv] = ACTIONS(1991),
    [anon_sym_sdiv] = ACTIONS(1991),
    [anon_sym_lshr] = ACTIONS(1991),
    [anon_sym_ashr] = ACTIONS(1991),
    [anon_sym_fmul] = ACTIONS(1991),
    [anon_sym_fdiv] = ACTIONS(1991),
    [anon_sym_frem] = ACTIONS(1991),
    [anon_sym_xchg] = ACTIONS(1991),
    [anon_sym_add] = ACTIONS(1991),
    [anon_sym_sub] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_nand] = ACTIONS(1991),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_max] = ACTIONS(1991),
    [anon_sym_min] = ACTIONS(1991),
    [anon_sym_umax] = ACTIONS(1991),
    [anon_sym_umin] = ACTIONS(1991),
    [anon_sym_fadd] = ACTIONS(1991),
    [anon_sym_fsub] = ACTIONS(1991),
    [anon_sym_bitcast] = ACTIONS(1991),
    [anon_sym_trunc] = ACTIONS(1991),
    [anon_sym_zext] = ACTIONS(1991),
    [anon_sym_sext] = ACTIONS(1991),
    [anon_sym_fptrunc] = ACTIONS(1991),
    [anon_sym_fpext] = ACTIONS(1991),
    [anon_sym_addrspacecast] = ACTIONS(1991),
    [anon_sym_uitofp] = ACTIONS(1991),
    [anon_sym_sitofp] = ACTIONS(1991),
    [anon_sym_fptoui] = ACTIONS(1991),
    [anon_sym_fptosi] = ACTIONS(1991),
    [anon_sym_inttoptr] = ACTIONS(1991),
    [anon_sym_ptrtoint] = ACTIONS(1991),
    [anon_sym_uselistorder] = ACTIONS(1991),
  },
  [601] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1993),
    [sym_label] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_unreachable] = ACTIONS(1995),
    [anon_sym_ret] = ACTIONS(1995),
    [anon_sym_br] = ACTIONS(1995),
    [anon_sym_resume] = ACTIONS(1995),
    [anon_sym_freeze] = ACTIONS(1995),
    [anon_sym_indirectbr] = ACTIONS(1995),
    [anon_sym_extractelement] = ACTIONS(1995),
    [anon_sym_insertelement] = ACTIONS(1995),
    [anon_sym_select] = ACTIONS(1995),
    [anon_sym_shufflevector] = ACTIONS(1995),
    [anon_sym_fneg] = ACTIONS(1995),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_invoke] = ACTIONS(1995),
    [anon_sym_cleanupret] = ACTIONS(1995),
    [anon_sym_catchret] = ACTIONS(1995),
    [anon_sym_catchswitch] = ACTIONS(1995),
    [anon_sym_catchpad] = ACTIONS(1995),
    [anon_sym_cleanuppad] = ACTIONS(1995),
    [anon_sym_callbr] = ACTIONS(1995),
    [anon_sym_icmp] = ACTIONS(1995),
    [anon_sym_fcmp] = ACTIONS(1995),
    [anon_sym_va_arg] = ACTIONS(1995),
    [anon_sym_phi] = ACTIONS(1995),
    [anon_sym_landingpad] = ACTIONS(1995),
    [anon_sym_tail] = ACTIONS(1995),
    [anon_sym_musttail] = ACTIONS(1995),
    [anon_sym_notail] = ACTIONS(1995),
    [anon_sym_call] = ACTIONS(1995),
    [anon_sym_alloca] = ACTIONS(1995),
    [anon_sym_load] = ACTIONS(1995),
    [anon_sym_store] = ACTIONS(1995),
    [anon_sym_cmpxchg] = ACTIONS(1995),
    [anon_sym_atomicrmw] = ACTIONS(1995),
    [anon_sym_fence] = ACTIONS(1995),
    [anon_sym_getelementptr] = ACTIONS(1995),
    [anon_sym_extractvalue] = ACTIONS(1995),
    [anon_sym_insertvalue] = ACTIONS(1995),
    [anon_sym_mul] = ACTIONS(1995),
    [anon_sym_urem] = ACTIONS(1995),
    [anon_sym_srem] = ACTIONS(1995),
    [anon_sym_shl] = ACTIONS(1995),
    [anon_sym_udiv] = ACTIONS(1995),
    [anon_sym_sdiv] = ACTIONS(1995),
    [anon_sym_lshr] = ACTIONS(1995),
    [anon_sym_ashr] = ACTIONS(1995),
    [anon_sym_fmul] = ACTIONS(1995),
    [anon_sym_fdiv] = ACTIONS(1995),
    [anon_sym_frem] = ACTIONS(1995),
    [anon_sym_xchg] = ACTIONS(1995),
    [anon_sym_add] = ACTIONS(1995),
    [anon_sym_sub] = ACTIONS(1995),
    [anon_sym_and] = ACTIONS(1995),
    [anon_sym_nand] = ACTIONS(1995),
    [anon_sym_or] = ACTIONS(1995),
    [anon_sym_xor] = ACTIONS(1995),
    [anon_sym_max] = ACTIONS(1995),
    [anon_sym_min] = ACTIONS(1995),
    [anon_sym_umax] = ACTIONS(1995),
    [anon_sym_umin] = ACTIONS(1995),
    [anon_sym_fadd] = ACTIONS(1995),
    [anon_sym_fsub] = ACTIONS(1995),
    [anon_sym_bitcast] = ACTIONS(1995),
    [anon_sym_trunc] = ACTIONS(1995),
    [anon_sym_zext] = ACTIONS(1995),
    [anon_sym_sext] = ACTIONS(1995),
    [anon_sym_fptrunc] = ACTIONS(1995),
    [anon_sym_fpext] = ACTIONS(1995),
    [anon_sym_addrspacecast] = ACTIONS(1995),
    [anon_sym_uitofp] = ACTIONS(1995),
    [anon_sym_sitofp] = ACTIONS(1995),
    [anon_sym_fptoui] = ACTIONS(1995),
    [anon_sym_fptosi] = ACTIONS(1995),
    [anon_sym_inttoptr] = ACTIONS(1995),
    [anon_sym_ptrtoint] = ACTIONS(1995),
    [anon_sym_uselistorder] = ACTIONS(1995),
  },
  [602] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1997),
    [sym_label] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_unreachable] = ACTIONS(1999),
    [anon_sym_ret] = ACTIONS(1999),
    [anon_sym_br] = ACTIONS(1999),
    [anon_sym_resume] = ACTIONS(1999),
    [anon_sym_freeze] = ACTIONS(1999),
    [anon_sym_indirectbr] = ACTIONS(1999),
    [anon_sym_extractelement] = ACTIONS(1999),
    [anon_sym_insertelement] = ACTIONS(1999),
    [anon_sym_select] = ACTIONS(1999),
    [anon_sym_shufflevector] = ACTIONS(1999),
    [anon_sym_fneg] = ACTIONS(1999),
    [anon_sym_switch] = ACTIONS(1999),
    [anon_sym_invoke] = ACTIONS(1999),
    [anon_sym_cleanupret] = ACTIONS(1999),
    [anon_sym_catchret] = ACTIONS(1999),
    [anon_sym_catchswitch] = ACTIONS(1999),
    [anon_sym_catchpad] = ACTIONS(1999),
    [anon_sym_cleanuppad] = ACTIONS(1999),
    [anon_sym_callbr] = ACTIONS(1999),
    [anon_sym_icmp] = ACTIONS(1999),
    [anon_sym_fcmp] = ACTIONS(1999),
    [anon_sym_va_arg] = ACTIONS(1999),
    [anon_sym_phi] = ACTIONS(1999),
    [anon_sym_landingpad] = ACTIONS(1999),
    [anon_sym_tail] = ACTIONS(1999),
    [anon_sym_musttail] = ACTIONS(1999),
    [anon_sym_notail] = ACTIONS(1999),
    [anon_sym_call] = ACTIONS(1999),
    [anon_sym_alloca] = ACTIONS(1999),
    [anon_sym_load] = ACTIONS(1999),
    [anon_sym_store] = ACTIONS(1999),
    [anon_sym_cmpxchg] = ACTIONS(1999),
    [anon_sym_atomicrmw] = ACTIONS(1999),
    [anon_sym_fence] = ACTIONS(1999),
    [anon_sym_getelementptr] = ACTIONS(1999),
    [anon_sym_extractvalue] = ACTIONS(1999),
    [anon_sym_insertvalue] = ACTIONS(1999),
    [anon_sym_mul] = ACTIONS(1999),
    [anon_sym_urem] = ACTIONS(1999),
    [anon_sym_srem] = ACTIONS(1999),
    [anon_sym_shl] = ACTIONS(1999),
    [anon_sym_udiv] = ACTIONS(1999),
    [anon_sym_sdiv] = ACTIONS(1999),
    [anon_sym_lshr] = ACTIONS(1999),
    [anon_sym_ashr] = ACTIONS(1999),
    [anon_sym_fmul] = ACTIONS(1999),
    [anon_sym_fdiv] = ACTIONS(1999),
    [anon_sym_frem] = ACTIONS(1999),
    [anon_sym_xchg] = ACTIONS(1999),
    [anon_sym_add] = ACTIONS(1999),
    [anon_sym_sub] = ACTIONS(1999),
    [anon_sym_and] = ACTIONS(1999),
    [anon_sym_nand] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1999),
    [anon_sym_xor] = ACTIONS(1999),
    [anon_sym_max] = ACTIONS(1999),
    [anon_sym_min] = ACTIONS(1999),
    [anon_sym_umax] = ACTIONS(1999),
    [anon_sym_umin] = ACTIONS(1999),
    [anon_sym_fadd] = ACTIONS(1999),
    [anon_sym_fsub] = ACTIONS(1999),
    [anon_sym_bitcast] = ACTIONS(1999),
    [anon_sym_trunc] = ACTIONS(1999),
    [anon_sym_zext] = ACTIONS(1999),
    [anon_sym_sext] = ACTIONS(1999),
    [anon_sym_fptrunc] = ACTIONS(1999),
    [anon_sym_fpext] = ACTIONS(1999),
    [anon_sym_addrspacecast] = ACTIONS(1999),
    [anon_sym_uitofp] = ACTIONS(1999),
    [anon_sym_sitofp] = ACTIONS(1999),
    [anon_sym_fptoui] = ACTIONS(1999),
    [anon_sym_fptosi] = ACTIONS(1999),
    [anon_sym_inttoptr] = ACTIONS(1999),
    [anon_sym_ptrtoint] = ACTIONS(1999),
    [anon_sym_uselistorder] = ACTIONS(1999),
  },
  [603] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2001),
    [sym_label] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_unreachable] = ACTIONS(2003),
    [anon_sym_ret] = ACTIONS(2003),
    [anon_sym_br] = ACTIONS(2003),
    [anon_sym_resume] = ACTIONS(2003),
    [anon_sym_freeze] = ACTIONS(2003),
    [anon_sym_indirectbr] = ACTIONS(2003),
    [anon_sym_extractelement] = ACTIONS(2003),
    [anon_sym_insertelement] = ACTIONS(2003),
    [anon_sym_select] = ACTIONS(2003),
    [anon_sym_shufflevector] = ACTIONS(2003),
    [anon_sym_fneg] = ACTIONS(2003),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_invoke] = ACTIONS(2003),
    [anon_sym_cleanupret] = ACTIONS(2003),
    [anon_sym_catchret] = ACTIONS(2003),
    [anon_sym_catchswitch] = ACTIONS(2003),
    [anon_sym_catchpad] = ACTIONS(2003),
    [anon_sym_cleanuppad] = ACTIONS(2003),
    [anon_sym_callbr] = ACTIONS(2003),
    [anon_sym_icmp] = ACTIONS(2003),
    [anon_sym_fcmp] = ACTIONS(2003),
    [anon_sym_va_arg] = ACTIONS(2003),
    [anon_sym_phi] = ACTIONS(2003),
    [anon_sym_landingpad] = ACTIONS(2003),
    [anon_sym_tail] = ACTIONS(2003),
    [anon_sym_musttail] = ACTIONS(2003),
    [anon_sym_notail] = ACTIONS(2003),
    [anon_sym_call] = ACTIONS(2003),
    [anon_sym_alloca] = ACTIONS(2003),
    [anon_sym_load] = ACTIONS(2003),
    [anon_sym_store] = ACTIONS(2003),
    [anon_sym_cmpxchg] = ACTIONS(2003),
    [anon_sym_atomicrmw] = ACTIONS(2003),
    [anon_sym_fence] = ACTIONS(2003),
    [anon_sym_getelementptr] = ACTIONS(2003),
    [anon_sym_extractvalue] = ACTIONS(2003),
    [anon_sym_insertvalue] = ACTIONS(2003),
    [anon_sym_mul] = ACTIONS(2003),
    [anon_sym_urem] = ACTIONS(2003),
    [anon_sym_srem] = ACTIONS(2003),
    [anon_sym_shl] = ACTIONS(2003),
    [anon_sym_udiv] = ACTIONS(2003),
    [anon_sym_sdiv] = ACTIONS(2003),
    [anon_sym_lshr] = ACTIONS(2003),
    [anon_sym_ashr] = ACTIONS(2003),
    [anon_sym_fmul] = ACTIONS(2003),
    [anon_sym_fdiv] = ACTIONS(2003),
    [anon_sym_frem] = ACTIONS(2003),
    [anon_sym_xchg] = ACTIONS(2003),
    [anon_sym_add] = ACTIONS(2003),
    [anon_sym_sub] = ACTIONS(2003),
    [anon_sym_and] = ACTIONS(2003),
    [anon_sym_nand] = ACTIONS(2003),
    [anon_sym_or] = ACTIONS(2003),
    [anon_sym_xor] = ACTIONS(2003),
    [anon_sym_max] = ACTIONS(2003),
    [anon_sym_min] = ACTIONS(2003),
    [anon_sym_umax] = ACTIONS(2003),
    [anon_sym_umin] = ACTIONS(2003),
    [anon_sym_fadd] = ACTIONS(2003),
    [anon_sym_fsub] = ACTIONS(2003),
    [anon_sym_bitcast] = ACTIONS(2003),
    [anon_sym_trunc] = ACTIONS(2003),
    [anon_sym_zext] = ACTIONS(2003),
    [anon_sym_sext] = ACTIONS(2003),
    [anon_sym_fptrunc] = ACTIONS(2003),
    [anon_sym_fpext] = ACTIONS(2003),
    [anon_sym_addrspacecast] = ACTIONS(2003),
    [anon_sym_uitofp] = ACTIONS(2003),
    [anon_sym_sitofp] = ACTIONS(2003),
    [anon_sym_fptoui] = ACTIONS(2003),
    [anon_sym_fptosi] = ACTIONS(2003),
    [anon_sym_inttoptr] = ACTIONS(2003),
    [anon_sym_ptrtoint] = ACTIONS(2003),
    [anon_sym_uselistorder] = ACTIONS(2003),
  },
  [604] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2005),
    [sym_label] = ACTIONS(2005),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_unreachable] = ACTIONS(2007),
    [anon_sym_ret] = ACTIONS(2007),
    [anon_sym_br] = ACTIONS(2007),
    [anon_sym_resume] = ACTIONS(2007),
    [anon_sym_freeze] = ACTIONS(2007),
    [anon_sym_indirectbr] = ACTIONS(2007),
    [anon_sym_extractelement] = ACTIONS(2007),
    [anon_sym_insertelement] = ACTIONS(2007),
    [anon_sym_select] = ACTIONS(2007),
    [anon_sym_shufflevector] = ACTIONS(2007),
    [anon_sym_fneg] = ACTIONS(2007),
    [anon_sym_switch] = ACTIONS(2007),
    [anon_sym_invoke] = ACTIONS(2007),
    [anon_sym_cleanupret] = ACTIONS(2007),
    [anon_sym_catchret] = ACTIONS(2007),
    [anon_sym_catchswitch] = ACTIONS(2007),
    [anon_sym_catchpad] = ACTIONS(2007),
    [anon_sym_cleanuppad] = ACTIONS(2007),
    [anon_sym_callbr] = ACTIONS(2007),
    [anon_sym_icmp] = ACTIONS(2007),
    [anon_sym_fcmp] = ACTIONS(2007),
    [anon_sym_va_arg] = ACTIONS(2007),
    [anon_sym_phi] = ACTIONS(2007),
    [anon_sym_landingpad] = ACTIONS(2007),
    [anon_sym_tail] = ACTIONS(2007),
    [anon_sym_musttail] = ACTIONS(2007),
    [anon_sym_notail] = ACTIONS(2007),
    [anon_sym_call] = ACTIONS(2007),
    [anon_sym_alloca] = ACTIONS(2007),
    [anon_sym_load] = ACTIONS(2007),
    [anon_sym_store] = ACTIONS(2007),
    [anon_sym_cmpxchg] = ACTIONS(2007),
    [anon_sym_atomicrmw] = ACTIONS(2007),
    [anon_sym_fence] = ACTIONS(2007),
    [anon_sym_getelementptr] = ACTIONS(2007),
    [anon_sym_extractvalue] = ACTIONS(2007),
    [anon_sym_insertvalue] = ACTIONS(2007),
    [anon_sym_mul] = ACTIONS(2007),
    [anon_sym_urem] = ACTIONS(2007),
    [anon_sym_srem] = ACTIONS(2007),
    [anon_sym_shl] = ACTIONS(2007),
    [anon_sym_udiv] = ACTIONS(2007),
    [anon_sym_sdiv] = ACTIONS(2007),
    [anon_sym_lshr] = ACTIONS(2007),
    [anon_sym_ashr] = ACTIONS(2007),
    [anon_sym_fmul] = ACTIONS(2007),
    [anon_sym_fdiv] = ACTIONS(2007),
    [anon_sym_frem] = ACTIONS(2007),
    [anon_sym_xchg] = ACTIONS(2007),
    [anon_sym_add] = ACTIONS(2007),
    [anon_sym_sub] = ACTIONS(2007),
    [anon_sym_and] = ACTIONS(2007),
    [anon_sym_nand] = ACTIONS(2007),
    [anon_sym_or] = ACTIONS(2007),
    [anon_sym_xor] = ACTIONS(2007),
    [anon_sym_max] = ACTIONS(2007),
    [anon_sym_min] = ACTIONS(2007),
    [anon_sym_umax] = ACTIONS(2007),
    [anon_sym_umin] = ACTIONS(2007),
    [anon_sym_fadd] = ACTIONS(2007),
    [anon_sym_fsub] = ACTIONS(2007),
    [anon_sym_bitcast] = ACTIONS(2007),
    [anon_sym_trunc] = ACTIONS(2007),
    [anon_sym_zext] = ACTIONS(2007),
    [anon_sym_sext] = ACTIONS(2007),
    [anon_sym_fptrunc] = ACTIONS(2007),
    [anon_sym_fpext] = ACTIONS(2007),
    [anon_sym_addrspacecast] = ACTIONS(2007),
    [anon_sym_uitofp] = ACTIONS(2007),
    [anon_sym_sitofp] = ACTIONS(2007),
    [anon_sym_fptoui] = ACTIONS(2007),
    [anon_sym_fptosi] = ACTIONS(2007),
    [anon_sym_inttoptr] = ACTIONS(2007),
    [anon_sym_ptrtoint] = ACTIONS(2007),
    [anon_sym_uselistorder] = ACTIONS(2007),
  },
  [605] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2009),
    [sym_label] = ACTIONS(2009),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_unreachable] = ACTIONS(2011),
    [anon_sym_ret] = ACTIONS(2011),
    [anon_sym_br] = ACTIONS(2011),
    [anon_sym_resume] = ACTIONS(2011),
    [anon_sym_freeze] = ACTIONS(2011),
    [anon_sym_indirectbr] = ACTIONS(2011),
    [anon_sym_extractelement] = ACTIONS(2011),
    [anon_sym_insertelement] = ACTIONS(2011),
    [anon_sym_select] = ACTIONS(2011),
    [anon_sym_shufflevector] = ACTIONS(2011),
    [anon_sym_fneg] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_invoke] = ACTIONS(2011),
    [anon_sym_cleanupret] = ACTIONS(2011),
    [anon_sym_catchret] = ACTIONS(2011),
    [anon_sym_catchswitch] = ACTIONS(2011),
    [anon_sym_catchpad] = ACTIONS(2011),
    [anon_sym_cleanuppad] = ACTIONS(2011),
    [anon_sym_callbr] = ACTIONS(2011),
    [anon_sym_icmp] = ACTIONS(2011),
    [anon_sym_fcmp] = ACTIONS(2011),
    [anon_sym_va_arg] = ACTIONS(2011),
    [anon_sym_phi] = ACTIONS(2011),
    [anon_sym_landingpad] = ACTIONS(2011),
    [anon_sym_tail] = ACTIONS(2011),
    [anon_sym_musttail] = ACTIONS(2011),
    [anon_sym_notail] = ACTIONS(2011),
    [anon_sym_call] = ACTIONS(2011),
    [anon_sym_alloca] = ACTIONS(2011),
    [anon_sym_load] = ACTIONS(2011),
    [anon_sym_store] = ACTIONS(2011),
    [anon_sym_cmpxchg] = ACTIONS(2011),
    [anon_sym_atomicrmw] = ACTIONS(2011),
    [anon_sym_fence] = ACTIONS(2011),
    [anon_sym_getelementptr] = ACTIONS(2011),
    [anon_sym_extractvalue] = ACTIONS(2011),
    [anon_sym_insertvalue] = ACTIONS(2011),
    [anon_sym_mul] = ACTIONS(2011),
    [anon_sym_urem] = ACTIONS(2011),
    [anon_sym_srem] = ACTIONS(2011),
    [anon_sym_shl] = ACTIONS(2011),
    [anon_sym_udiv] = ACTIONS(2011),
    [anon_sym_sdiv] = ACTIONS(2011),
    [anon_sym_lshr] = ACTIONS(2011),
    [anon_sym_ashr] = ACTIONS(2011),
    [anon_sym_fmul] = ACTIONS(2011),
    [anon_sym_fdiv] = ACTIONS(2011),
    [anon_sym_frem] = ACTIONS(2011),
    [anon_sym_xchg] = ACTIONS(2011),
    [anon_sym_add] = ACTIONS(2011),
    [anon_sym_sub] = ACTIONS(2011),
    [anon_sym_and] = ACTIONS(2011),
    [anon_sym_nand] = ACTIONS(2011),
    [anon_sym_or] = ACTIONS(2011),
    [anon_sym_xor] = ACTIONS(2011),
    [anon_sym_max] = ACTIONS(2011),
    [anon_sym_min] = ACTIONS(2011),
    [anon_sym_umax] = ACTIONS(2011),
    [anon_sym_umin] = ACTIONS(2011),
    [anon_sym_fadd] = ACTIONS(2011),
    [anon_sym_fsub] = ACTIONS(2011),
    [anon_sym_bitcast] = ACTIONS(2011),
    [anon_sym_trunc] = ACTIONS(2011),
    [anon_sym_zext] = ACTIONS(2011),
    [anon_sym_sext] = ACTIONS(2011),
    [anon_sym_fptrunc] = ACTIONS(2011),
    [anon_sym_fpext] = ACTIONS(2011),
    [anon_sym_addrspacecast] = ACTIONS(2011),
    [anon_sym_uitofp] = ACTIONS(2011),
    [anon_sym_sitofp] = ACTIONS(2011),
    [anon_sym_fptoui] = ACTIONS(2011),
    [anon_sym_fptosi] = ACTIONS(2011),
    [anon_sym_inttoptr] = ACTIONS(2011),
    [anon_sym_ptrtoint] = ACTIONS(2011),
    [anon_sym_uselistorder] = ACTIONS(2011),
  },
  [606] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2013),
    [sym_label] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_unreachable] = ACTIONS(2015),
    [anon_sym_ret] = ACTIONS(2015),
    [anon_sym_br] = ACTIONS(2015),
    [anon_sym_resume] = ACTIONS(2015),
    [anon_sym_freeze] = ACTIONS(2015),
    [anon_sym_indirectbr] = ACTIONS(2015),
    [anon_sym_extractelement] = ACTIONS(2015),
    [anon_sym_insertelement] = ACTIONS(2015),
    [anon_sym_select] = ACTIONS(2015),
    [anon_sym_shufflevector] = ACTIONS(2015),
    [anon_sym_fneg] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2015),
    [anon_sym_invoke] = ACTIONS(2015),
    [anon_sym_cleanupret] = ACTIONS(2015),
    [anon_sym_catchret] = ACTIONS(2015),
    [anon_sym_catchswitch] = ACTIONS(2015),
    [anon_sym_catchpad] = ACTIONS(2015),
    [anon_sym_cleanuppad] = ACTIONS(2015),
    [anon_sym_callbr] = ACTIONS(2015),
    [anon_sym_icmp] = ACTIONS(2015),
    [anon_sym_fcmp] = ACTIONS(2015),
    [anon_sym_va_arg] = ACTIONS(2015),
    [anon_sym_phi] = ACTIONS(2015),
    [anon_sym_landingpad] = ACTIONS(2015),
    [anon_sym_tail] = ACTIONS(2015),
    [anon_sym_musttail] = ACTIONS(2015),
    [anon_sym_notail] = ACTIONS(2015),
    [anon_sym_call] = ACTIONS(2015),
    [anon_sym_alloca] = ACTIONS(2015),
    [anon_sym_load] = ACTIONS(2015),
    [anon_sym_store] = ACTIONS(2015),
    [anon_sym_cmpxchg] = ACTIONS(2015),
    [anon_sym_atomicrmw] = ACTIONS(2015),
    [anon_sym_fence] = ACTIONS(2015),
    [anon_sym_getelementptr] = ACTIONS(2015),
    [anon_sym_extractvalue] = ACTIONS(2015),
    [anon_sym_insertvalue] = ACTIONS(2015),
    [anon_sym_mul] = ACTIONS(2015),
    [anon_sym_urem] = ACTIONS(2015),
    [anon_sym_srem] = ACTIONS(2015),
    [anon_sym_shl] = ACTIONS(2015),
    [anon_sym_udiv] = ACTIONS(2015),
    [anon_sym_sdiv] = ACTIONS(2015),
    [anon_sym_lshr] = ACTIONS(2015),
    [anon_sym_ashr] = ACTIONS(2015),
    [anon_sym_fmul] = ACTIONS(2015),
    [anon_sym_fdiv] = ACTIONS(2015),
    [anon_sym_frem] = ACTIONS(2015),
    [anon_sym_xchg] = ACTIONS(2015),
    [anon_sym_add] = ACTIONS(2015),
    [anon_sym_sub] = ACTIONS(2015),
    [anon_sym_and] = ACTIONS(2015),
    [anon_sym_nand] = ACTIONS(2015),
    [anon_sym_or] = ACTIONS(2015),
    [anon_sym_xor] = ACTIONS(2015),
    [anon_sym_max] = ACTIONS(2015),
    [anon_sym_min] = ACTIONS(2015),
    [anon_sym_umax] = ACTIONS(2015),
    [anon_sym_umin] = ACTIONS(2015),
    [anon_sym_fadd] = ACTIONS(2015),
    [anon_sym_fsub] = ACTIONS(2015),
    [anon_sym_bitcast] = ACTIONS(2015),
    [anon_sym_trunc] = ACTIONS(2015),
    [anon_sym_zext] = ACTIONS(2015),
    [anon_sym_sext] = ACTIONS(2015),
    [anon_sym_fptrunc] = ACTIONS(2015),
    [anon_sym_fpext] = ACTIONS(2015),
    [anon_sym_addrspacecast] = ACTIONS(2015),
    [anon_sym_uitofp] = ACTIONS(2015),
    [anon_sym_sitofp] = ACTIONS(2015),
    [anon_sym_fptoui] = ACTIONS(2015),
    [anon_sym_fptosi] = ACTIONS(2015),
    [anon_sym_inttoptr] = ACTIONS(2015),
    [anon_sym_ptrtoint] = ACTIONS(2015),
    [anon_sym_uselistorder] = ACTIONS(2015),
  },
  [607] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2017),
    [sym_label] = ACTIONS(2017),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_unreachable] = ACTIONS(2019),
    [anon_sym_ret] = ACTIONS(2019),
    [anon_sym_br] = ACTIONS(2019),
    [anon_sym_resume] = ACTIONS(2019),
    [anon_sym_freeze] = ACTIONS(2019),
    [anon_sym_indirectbr] = ACTIONS(2019),
    [anon_sym_extractelement] = ACTIONS(2019),
    [anon_sym_insertelement] = ACTIONS(2019),
    [anon_sym_select] = ACTIONS(2019),
    [anon_sym_shufflevector] = ACTIONS(2019),
    [anon_sym_fneg] = ACTIONS(2019),
    [anon_sym_switch] = ACTIONS(2019),
    [anon_sym_invoke] = ACTIONS(2019),
    [anon_sym_cleanupret] = ACTIONS(2019),
    [anon_sym_catchret] = ACTIONS(2019),
    [anon_sym_catchswitch] = ACTIONS(2019),
    [anon_sym_catchpad] = ACTIONS(2019),
    [anon_sym_cleanuppad] = ACTIONS(2019),
    [anon_sym_callbr] = ACTIONS(2019),
    [anon_sym_icmp] = ACTIONS(2019),
    [anon_sym_fcmp] = ACTIONS(2019),
    [anon_sym_va_arg] = ACTIONS(2019),
    [anon_sym_phi] = ACTIONS(2019),
    [anon_sym_landingpad] = ACTIONS(2019),
    [anon_sym_tail] = ACTIONS(2019),
    [anon_sym_musttail] = ACTIONS(2019),
    [anon_sym_notail] = ACTIONS(2019),
    [anon_sym_call] = ACTIONS(2019),
    [anon_sym_alloca] = ACTIONS(2019),
    [anon_sym_load] = ACTIONS(2019),
    [anon_sym_store] = ACTIONS(2019),
    [anon_sym_cmpxchg] = ACTIONS(2019),
    [anon_sym_atomicrmw] = ACTIONS(2019),
    [anon_sym_fence] = ACTIONS(2019),
    [anon_sym_getelementptr] = ACTIONS(2019),
    [anon_sym_extractvalue] = ACTIONS(2019),
    [anon_sym_insertvalue] = ACTIONS(2019),
    [anon_sym_mul] = ACTIONS(2019),
    [anon_sym_urem] = ACTIONS(2019),
    [anon_sym_srem] = ACTIONS(2019),
    [anon_sym_shl] = ACTIONS(2019),
    [anon_sym_udiv] = ACTIONS(2019),
    [anon_sym_sdiv] = ACTIONS(2019),
    [anon_sym_lshr] = ACTIONS(2019),
    [anon_sym_ashr] = ACTIONS(2019),
    [anon_sym_fmul] = ACTIONS(2019),
    [anon_sym_fdiv] = ACTIONS(2019),
    [anon_sym_frem] = ACTIONS(2019),
    [anon_sym_xchg] = ACTIONS(2019),
    [anon_sym_add] = ACTIONS(2019),
    [anon_sym_sub] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2019),
    [anon_sym_nand] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2019),
    [anon_sym_xor] = ACTIONS(2019),
    [anon_sym_max] = ACTIONS(2019),
    [anon_sym_min] = ACTIONS(2019),
    [anon_sym_umax] = ACTIONS(2019),
    [anon_sym_umin] = ACTIONS(2019),
    [anon_sym_fadd] = ACTIONS(2019),
    [anon_sym_fsub] = ACTIONS(2019),
    [anon_sym_bitcast] = ACTIONS(2019),
    [anon_sym_trunc] = ACTIONS(2019),
    [anon_sym_zext] = ACTIONS(2019),
    [anon_sym_sext] = ACTIONS(2019),
    [anon_sym_fptrunc] = ACTIONS(2019),
    [anon_sym_fpext] = ACTIONS(2019),
    [anon_sym_addrspacecast] = ACTIONS(2019),
    [anon_sym_uitofp] = ACTIONS(2019),
    [anon_sym_sitofp] = ACTIONS(2019),
    [anon_sym_fptoui] = ACTIONS(2019),
    [anon_sym_fptosi] = ACTIONS(2019),
    [anon_sym_inttoptr] = ACTIONS(2019),
    [anon_sym_ptrtoint] = ACTIONS(2019),
    [anon_sym_uselistorder] = ACTIONS(2019),
  },
  [608] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2021),
    [sym_label] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2021),
    [anon_sym_COMMA] = ACTIONS(2021),
    [anon_sym_unreachable] = ACTIONS(2023),
    [anon_sym_ret] = ACTIONS(2023),
    [anon_sym_br] = ACTIONS(2023),
    [anon_sym_resume] = ACTIONS(2023),
    [anon_sym_freeze] = ACTIONS(2023),
    [anon_sym_indirectbr] = ACTIONS(2023),
    [anon_sym_extractelement] = ACTIONS(2023),
    [anon_sym_insertelement] = ACTIONS(2023),
    [anon_sym_select] = ACTIONS(2023),
    [anon_sym_shufflevector] = ACTIONS(2023),
    [anon_sym_fneg] = ACTIONS(2023),
    [anon_sym_switch] = ACTIONS(2023),
    [anon_sym_invoke] = ACTIONS(2023),
    [anon_sym_cleanupret] = ACTIONS(2023),
    [anon_sym_catchret] = ACTIONS(2023),
    [anon_sym_catchswitch] = ACTIONS(2023),
    [anon_sym_catchpad] = ACTIONS(2023),
    [anon_sym_cleanuppad] = ACTIONS(2023),
    [anon_sym_callbr] = ACTIONS(2023),
    [anon_sym_icmp] = ACTIONS(2023),
    [anon_sym_fcmp] = ACTIONS(2023),
    [anon_sym_va_arg] = ACTIONS(2023),
    [anon_sym_phi] = ACTIONS(2023),
    [anon_sym_landingpad] = ACTIONS(2023),
    [anon_sym_tail] = ACTIONS(2023),
    [anon_sym_musttail] = ACTIONS(2023),
    [anon_sym_notail] = ACTIONS(2023),
    [anon_sym_call] = ACTIONS(2023),
    [anon_sym_alloca] = ACTIONS(2023),
    [anon_sym_load] = ACTIONS(2023),
    [anon_sym_store] = ACTIONS(2023),
    [anon_sym_cmpxchg] = ACTIONS(2023),
    [anon_sym_atomicrmw] = ACTIONS(2023),
    [anon_sym_fence] = ACTIONS(2023),
    [anon_sym_getelementptr] = ACTIONS(2023),
    [anon_sym_extractvalue] = ACTIONS(2023),
    [anon_sym_insertvalue] = ACTIONS(2023),
    [anon_sym_mul] = ACTIONS(2023),
    [anon_sym_urem] = ACTIONS(2023),
    [anon_sym_srem] = ACTIONS(2023),
    [anon_sym_shl] = ACTIONS(2023),
    [anon_sym_udiv] = ACTIONS(2023),
    [anon_sym_sdiv] = ACTIONS(2023),
    [anon_sym_lshr] = ACTIONS(2023),
    [anon_sym_ashr] = ACTIONS(2023),
    [anon_sym_fmul] = ACTIONS(2023),
    [anon_sym_fdiv] = ACTIONS(2023),
    [anon_sym_frem] = ACTIONS(2023),
    [anon_sym_xchg] = ACTIONS(2023),
    [anon_sym_add] = ACTIONS(2023),
    [anon_sym_sub] = ACTIONS(2023),
    [anon_sym_and] = ACTIONS(2023),
    [anon_sym_nand] = ACTIONS(2023),
    [anon_sym_or] = ACTIONS(2023),
    [anon_sym_xor] = ACTIONS(2023),
    [anon_sym_max] = ACTIONS(2023),
    [anon_sym_min] = ACTIONS(2023),
    [anon_sym_umax] = ACTIONS(2023),
    [anon_sym_umin] = ACTIONS(2023),
    [anon_sym_fadd] = ACTIONS(2023),
    [anon_sym_fsub] = ACTIONS(2023),
    [anon_sym_bitcast] = ACTIONS(2023),
    [anon_sym_trunc] = ACTIONS(2023),
    [anon_sym_zext] = ACTIONS(2023),
    [anon_sym_sext] = ACTIONS(2023),
    [anon_sym_fptrunc] = ACTIONS(2023),
    [anon_sym_fpext] = ACTIONS(2023),
    [anon_sym_addrspacecast] = ACTIONS(2023),
    [anon_sym_uitofp] = ACTIONS(2023),
    [anon_sym_sitofp] = ACTIONS(2023),
    [anon_sym_fptoui] = ACTIONS(2023),
    [anon_sym_fptosi] = ACTIONS(2023),
    [anon_sym_inttoptr] = ACTIONS(2023),
    [anon_sym_ptrtoint] = ACTIONS(2023),
    [anon_sym_uselistorder] = ACTIONS(2023),
  },
  [609] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2025),
    [sym_label] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_COMMA] = ACTIONS(2027),
    [anon_sym_unreachable] = ACTIONS(2030),
    [anon_sym_ret] = ACTIONS(2030),
    [anon_sym_br] = ACTIONS(2030),
    [anon_sym_resume] = ACTIONS(2030),
    [anon_sym_freeze] = ACTIONS(2030),
    [anon_sym_indirectbr] = ACTIONS(2030),
    [anon_sym_extractelement] = ACTIONS(2030),
    [anon_sym_insertelement] = ACTIONS(2030),
    [anon_sym_select] = ACTIONS(2030),
    [anon_sym_shufflevector] = ACTIONS(2030),
    [anon_sym_fneg] = ACTIONS(2030),
    [anon_sym_switch] = ACTIONS(2030),
    [anon_sym_invoke] = ACTIONS(2030),
    [anon_sym_cleanupret] = ACTIONS(2030),
    [anon_sym_catchret] = ACTIONS(2030),
    [anon_sym_catchswitch] = ACTIONS(2030),
    [anon_sym_catchpad] = ACTIONS(2030),
    [anon_sym_cleanuppad] = ACTIONS(2030),
    [anon_sym_callbr] = ACTIONS(2030),
    [anon_sym_icmp] = ACTIONS(2030),
    [anon_sym_fcmp] = ACTIONS(2030),
    [anon_sym_va_arg] = ACTIONS(2030),
    [anon_sym_phi] = ACTIONS(2030),
    [anon_sym_landingpad] = ACTIONS(2030),
    [anon_sym_tail] = ACTIONS(2030),
    [anon_sym_musttail] = ACTIONS(2030),
    [anon_sym_notail] = ACTIONS(2030),
    [anon_sym_call] = ACTIONS(2030),
    [anon_sym_alloca] = ACTIONS(2030),
    [anon_sym_load] = ACTIONS(2030),
    [anon_sym_store] = ACTIONS(2030),
    [anon_sym_cmpxchg] = ACTIONS(2030),
    [anon_sym_atomicrmw] = ACTIONS(2030),
    [anon_sym_fence] = ACTIONS(2030),
    [anon_sym_getelementptr] = ACTIONS(2030),
    [anon_sym_extractvalue] = ACTIONS(2030),
    [anon_sym_insertvalue] = ACTIONS(2030),
    [anon_sym_mul] = ACTIONS(2030),
    [anon_sym_urem] = ACTIONS(2030),
    [anon_sym_srem] = ACTIONS(2030),
    [anon_sym_shl] = ACTIONS(2030),
    [anon_sym_udiv] = ACTIONS(2030),
    [anon_sym_sdiv] = ACTIONS(2030),
    [anon_sym_lshr] = ACTIONS(2030),
    [anon_sym_ashr] = ACTIONS(2030),
    [anon_sym_fmul] = ACTIONS(2030),
    [anon_sym_fdiv] = ACTIONS(2030),
    [anon_sym_frem] = ACTIONS(2030),
    [anon_sym_xchg] = ACTIONS(2030),
    [anon_sym_add] = ACTIONS(2030),
    [anon_sym_sub] = ACTIONS(2030),
    [anon_sym_and] = ACTIONS(2030),
    [anon_sym_nand] = ACTIONS(2030),
    [anon_sym_or] = ACTIONS(2030),
    [anon_sym_xor] = ACTIONS(2030),
    [anon_sym_max] = ACTIONS(2030),
    [anon_sym_min] = ACTIONS(2030),
    [anon_sym_umax] = ACTIONS(2030),
    [anon_sym_umin] = ACTIONS(2030),
    [anon_sym_fadd] = ACTIONS(2030),
    [anon_sym_fsub] = ACTIONS(2030),
    [anon_sym_bitcast] = ACTIONS(2030),
    [anon_sym_trunc] = ACTIONS(2030),
    [anon_sym_zext] = ACTIONS(2030),
    [anon_sym_sext] = ACTIONS(2030),
    [anon_sym_fptrunc] = ACTIONS(2030),
    [anon_sym_fpext] = ACTIONS(2030),
    [anon_sym_addrspacecast] = ACTIONS(2030),
    [anon_sym_uitofp] = ACTIONS(2030),
    [anon_sym_sitofp] = ACTIONS(2030),
    [anon_sym_fptoui] = ACTIONS(2030),
    [anon_sym_fptosi] = ACTIONS(2030),
    [anon_sym_inttoptr] = ACTIONS(2030),
    [anon_sym_ptrtoint] = ACTIONS(2030),
    [anon_sym_uselistorder] = ACTIONS(2030),
  },
  [610] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2032),
    [sym_label] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2034),
    [anon_sym_unreachable] = ACTIONS(2037),
    [anon_sym_ret] = ACTIONS(2037),
    [anon_sym_br] = ACTIONS(2037),
    [anon_sym_resume] = ACTIONS(2037),
    [anon_sym_freeze] = ACTIONS(2037),
    [anon_sym_indirectbr] = ACTIONS(2037),
    [anon_sym_extractelement] = ACTIONS(2037),
    [anon_sym_insertelement] = ACTIONS(2037),
    [anon_sym_select] = ACTIONS(2037),
    [anon_sym_shufflevector] = ACTIONS(2037),
    [anon_sym_fneg] = ACTIONS(2037),
    [anon_sym_switch] = ACTIONS(2037),
    [anon_sym_invoke] = ACTIONS(2037),
    [anon_sym_cleanupret] = ACTIONS(2037),
    [anon_sym_catchret] = ACTIONS(2037),
    [anon_sym_catchswitch] = ACTIONS(2037),
    [anon_sym_catchpad] = ACTIONS(2037),
    [anon_sym_cleanuppad] = ACTIONS(2037),
    [anon_sym_callbr] = ACTIONS(2037),
    [anon_sym_icmp] = ACTIONS(2037),
    [anon_sym_fcmp] = ACTIONS(2037),
    [anon_sym_va_arg] = ACTIONS(2037),
    [anon_sym_phi] = ACTIONS(2037),
    [anon_sym_landingpad] = ACTIONS(2037),
    [anon_sym_tail] = ACTIONS(2037),
    [anon_sym_musttail] = ACTIONS(2037),
    [anon_sym_notail] = ACTIONS(2037),
    [anon_sym_call] = ACTIONS(2037),
    [anon_sym_alloca] = ACTIONS(2037),
    [anon_sym_load] = ACTIONS(2037),
    [anon_sym_store] = ACTIONS(2037),
    [anon_sym_cmpxchg] = ACTIONS(2037),
    [anon_sym_atomicrmw] = ACTIONS(2037),
    [anon_sym_fence] = ACTIONS(2037),
    [anon_sym_getelementptr] = ACTIONS(2037),
    [anon_sym_extractvalue] = ACTIONS(2037),
    [anon_sym_insertvalue] = ACTIONS(2037),
    [anon_sym_mul] = ACTIONS(2037),
    [anon_sym_urem] = ACTIONS(2037),
    [anon_sym_srem] = ACTIONS(2037),
    [anon_sym_shl] = ACTIONS(2037),
    [anon_sym_udiv] = ACTIONS(2037),
    [anon_sym_sdiv] = ACTIONS(2037),
    [anon_sym_lshr] = ACTIONS(2037),
    [anon_sym_ashr] = ACTIONS(2037),
    [anon_sym_fmul] = ACTIONS(2037),
    [anon_sym_fdiv] = ACTIONS(2037),
    [anon_sym_frem] = ACTIONS(2037),
    [anon_sym_xchg] = ACTIONS(2037),
    [anon_sym_add] = ACTIONS(2037),
    [anon_sym_sub] = ACTIONS(2037),
    [anon_sym_and] = ACTIONS(2037),
    [anon_sym_nand] = ACTIONS(2037),
    [anon_sym_or] = ACTIONS(2037),
    [anon_sym_xor] = ACTIONS(2037),
    [anon_sym_max] = ACTIONS(2037),
    [anon_sym_min] = ACTIONS(2037),
    [anon_sym_umax] = ACTIONS(2037),
    [anon_sym_umin] = ACTIONS(2037),
    [anon_sym_fadd] = ACTIONS(2037),
    [anon_sym_fsub] = ACTIONS(2037),
    [anon_sym_bitcast] = ACTIONS(2037),
    [anon_sym_trunc] = ACTIONS(2037),
    [anon_sym_zext] = ACTIONS(2037),
    [anon_sym_sext] = ACTIONS(2037),
    [anon_sym_fptrunc] = ACTIONS(2037),
    [anon_sym_fpext] = ACTIONS(2037),
    [anon_sym_addrspacecast] = ACTIONS(2037),
    [anon_sym_uitofp] = ACTIONS(2037),
    [anon_sym_sitofp] = ACTIONS(2037),
    [anon_sym_fptoui] = ACTIONS(2037),
    [anon_sym_fptosi] = ACTIONS(2037),
    [anon_sym_inttoptr] = ACTIONS(2037),
    [anon_sym_ptrtoint] = ACTIONS(2037),
    [anon_sym_uselistorder] = ACTIONS(2037),
  },
  [611] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2025),
    [sym_label] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_COMMA] = ACTIONS(2025),
    [anon_sym_unreachable] = ACTIONS(2030),
    [anon_sym_ret] = ACTIONS(2030),
    [anon_sym_br] = ACTIONS(2030),
    [anon_sym_resume] = ACTIONS(2030),
    [anon_sym_freeze] = ACTIONS(2030),
    [anon_sym_indirectbr] = ACTIONS(2030),
    [anon_sym_extractelement] = ACTIONS(2030),
    [anon_sym_insertelement] = ACTIONS(2030),
    [anon_sym_select] = ACTIONS(2030),
    [anon_sym_shufflevector] = ACTIONS(2030),
    [anon_sym_fneg] = ACTIONS(2030),
    [anon_sym_switch] = ACTIONS(2030),
    [anon_sym_invoke] = ACTIONS(2030),
    [anon_sym_cleanupret] = ACTIONS(2030),
    [anon_sym_catchret] = ACTIONS(2030),
    [anon_sym_catchswitch] = ACTIONS(2030),
    [anon_sym_catchpad] = ACTIONS(2030),
    [anon_sym_cleanuppad] = ACTIONS(2030),
    [anon_sym_callbr] = ACTIONS(2030),
    [anon_sym_icmp] = ACTIONS(2030),
    [anon_sym_fcmp] = ACTIONS(2030),
    [anon_sym_va_arg] = ACTIONS(2030),
    [anon_sym_phi] = ACTIONS(2030),
    [anon_sym_landingpad] = ACTIONS(2030),
    [anon_sym_tail] = ACTIONS(2030),
    [anon_sym_musttail] = ACTIONS(2030),
    [anon_sym_notail] = ACTIONS(2030),
    [anon_sym_call] = ACTIONS(2030),
    [anon_sym_alloca] = ACTIONS(2030),
    [anon_sym_load] = ACTIONS(2030),
    [anon_sym_store] = ACTIONS(2030),
    [anon_sym_cmpxchg] = ACTIONS(2030),
    [anon_sym_atomicrmw] = ACTIONS(2030),
    [anon_sym_fence] = ACTIONS(2030),
    [anon_sym_getelementptr] = ACTIONS(2030),
    [anon_sym_extractvalue] = ACTIONS(2030),
    [anon_sym_insertvalue] = ACTIONS(2030),
    [anon_sym_mul] = ACTIONS(2030),
    [anon_sym_urem] = ACTIONS(2030),
    [anon_sym_srem] = ACTIONS(2030),
    [anon_sym_shl] = ACTIONS(2030),
    [anon_sym_udiv] = ACTIONS(2030),
    [anon_sym_sdiv] = ACTIONS(2030),
    [anon_sym_lshr] = ACTIONS(2030),
    [anon_sym_ashr] = ACTIONS(2030),
    [anon_sym_fmul] = ACTIONS(2030),
    [anon_sym_fdiv] = ACTIONS(2030),
    [anon_sym_frem] = ACTIONS(2030),
    [anon_sym_xchg] = ACTIONS(2030),
    [anon_sym_add] = ACTIONS(2030),
    [anon_sym_sub] = ACTIONS(2030),
    [anon_sym_and] = ACTIONS(2030),
    [anon_sym_nand] = ACTIONS(2030),
    [anon_sym_or] = ACTIONS(2030),
    [anon_sym_xor] = ACTIONS(2030),
    [anon_sym_max] = ACTIONS(2030),
    [anon_sym_min] = ACTIONS(2030),
    [anon_sym_umax] = ACTIONS(2030),
    [anon_sym_umin] = ACTIONS(2030),
    [anon_sym_fadd] = ACTIONS(2030),
    [anon_sym_fsub] = ACTIONS(2030),
    [anon_sym_bitcast] = ACTIONS(2030),
    [anon_sym_trunc] = ACTIONS(2030),
    [anon_sym_zext] = ACTIONS(2030),
    [anon_sym_sext] = ACTIONS(2030),
    [anon_sym_fptrunc] = ACTIONS(2030),
    [anon_sym_fpext] = ACTIONS(2030),
    [anon_sym_addrspacecast] = ACTIONS(2030),
    [anon_sym_uitofp] = ACTIONS(2030),
    [anon_sym_sitofp] = ACTIONS(2030),
    [anon_sym_fptoui] = ACTIONS(2030),
    [anon_sym_fptosi] = ACTIONS(2030),
    [anon_sym_inttoptr] = ACTIONS(2030),
    [anon_sym_ptrtoint] = ACTIONS(2030),
    [anon_sym_uselistorder] = ACTIONS(2030),
  },
  [612] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2039),
    [sym_label] = ACTIONS(2039),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2039),
    [anon_sym_unreachable] = ACTIONS(2041),
    [anon_sym_ret] = ACTIONS(2041),
    [anon_sym_br] = ACTIONS(2041),
    [anon_sym_resume] = ACTIONS(2041),
    [anon_sym_freeze] = ACTIONS(2041),
    [anon_sym_indirectbr] = ACTIONS(2041),
    [anon_sym_extractelement] = ACTIONS(2041),
    [anon_sym_insertelement] = ACTIONS(2041),
    [anon_sym_select] = ACTIONS(2041),
    [anon_sym_shufflevector] = ACTIONS(2041),
    [anon_sym_fneg] = ACTIONS(2041),
    [anon_sym_switch] = ACTIONS(2041),
    [anon_sym_invoke] = ACTIONS(2041),
    [anon_sym_cleanupret] = ACTIONS(2041),
    [anon_sym_catchret] = ACTIONS(2041),
    [anon_sym_catchswitch] = ACTIONS(2041),
    [anon_sym_catchpad] = ACTIONS(2041),
    [anon_sym_cleanuppad] = ACTIONS(2041),
    [anon_sym_callbr] = ACTIONS(2041),
    [anon_sym_icmp] = ACTIONS(2041),
    [anon_sym_fcmp] = ACTIONS(2041),
    [anon_sym_va_arg] = ACTIONS(2041),
    [anon_sym_phi] = ACTIONS(2041),
    [anon_sym_landingpad] = ACTIONS(2041),
    [anon_sym_tail] = ACTIONS(2041),
    [anon_sym_musttail] = ACTIONS(2041),
    [anon_sym_notail] = ACTIONS(2041),
    [anon_sym_call] = ACTIONS(2041),
    [anon_sym_alloca] = ACTIONS(2041),
    [anon_sym_load] = ACTIONS(2041),
    [anon_sym_store] = ACTIONS(2041),
    [anon_sym_cmpxchg] = ACTIONS(2041),
    [anon_sym_atomicrmw] = ACTIONS(2041),
    [anon_sym_fence] = ACTIONS(2041),
    [anon_sym_getelementptr] = ACTIONS(2041),
    [anon_sym_extractvalue] = ACTIONS(2041),
    [anon_sym_insertvalue] = ACTIONS(2041),
    [anon_sym_mul] = ACTIONS(2041),
    [anon_sym_urem] = ACTIONS(2041),
    [anon_sym_srem] = ACTIONS(2041),
    [anon_sym_shl] = ACTIONS(2041),
    [anon_sym_udiv] = ACTIONS(2041),
    [anon_sym_sdiv] = ACTIONS(2041),
    [anon_sym_lshr] = ACTIONS(2041),
    [anon_sym_ashr] = ACTIONS(2041),
    [anon_sym_fmul] = ACTIONS(2041),
    [anon_sym_fdiv] = ACTIONS(2041),
    [anon_sym_frem] = ACTIONS(2041),
    [anon_sym_xchg] = ACTIONS(2041),
    [anon_sym_add] = ACTIONS(2041),
    [anon_sym_sub] = ACTIONS(2041),
    [anon_sym_and] = ACTIONS(2041),
    [anon_sym_nand] = ACTIONS(2041),
    [anon_sym_or] = ACTIONS(2041),
    [anon_sym_xor] = ACTIONS(2041),
    [anon_sym_max] = ACTIONS(2041),
    [anon_sym_min] = ACTIONS(2041),
    [anon_sym_umax] = ACTIONS(2041),
    [anon_sym_umin] = ACTIONS(2041),
    [anon_sym_fadd] = ACTIONS(2041),
    [anon_sym_fsub] = ACTIONS(2041),
    [anon_sym_bitcast] = ACTIONS(2041),
    [anon_sym_trunc] = ACTIONS(2041),
    [anon_sym_zext] = ACTIONS(2041),
    [anon_sym_sext] = ACTIONS(2041),
    [anon_sym_fptrunc] = ACTIONS(2041),
    [anon_sym_fpext] = ACTIONS(2041),
    [anon_sym_addrspacecast] = ACTIONS(2041),
    [anon_sym_uitofp] = ACTIONS(2041),
    [anon_sym_sitofp] = ACTIONS(2041),
    [anon_sym_fptoui] = ACTIONS(2041),
    [anon_sym_fptosi] = ACTIONS(2041),
    [anon_sym_inttoptr] = ACTIONS(2041),
    [anon_sym_ptrtoint] = ACTIONS(2041),
    [anon_sym_uselistorder] = ACTIONS(2041),
  },
  [613] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2043),
    [sym_label] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_COMMA] = ACTIONS(2043),
    [anon_sym_unreachable] = ACTIONS(2045),
    [anon_sym_ret] = ACTIONS(2045),
    [anon_sym_br] = ACTIONS(2045),
    [anon_sym_resume] = ACTIONS(2045),
    [anon_sym_freeze] = ACTIONS(2045),
    [anon_sym_indirectbr] = ACTIONS(2045),
    [anon_sym_extractelement] = ACTIONS(2045),
    [anon_sym_insertelement] = ACTIONS(2045),
    [anon_sym_select] = ACTIONS(2045),
    [anon_sym_shufflevector] = ACTIONS(2045),
    [anon_sym_fneg] = ACTIONS(2045),
    [anon_sym_switch] = ACTIONS(2045),
    [anon_sym_invoke] = ACTIONS(2045),
    [anon_sym_cleanupret] = ACTIONS(2045),
    [anon_sym_catchret] = ACTIONS(2045),
    [anon_sym_catchswitch] = ACTIONS(2045),
    [anon_sym_catchpad] = ACTIONS(2045),
    [anon_sym_cleanuppad] = ACTIONS(2045),
    [anon_sym_callbr] = ACTIONS(2045),
    [anon_sym_icmp] = ACTIONS(2045),
    [anon_sym_fcmp] = ACTIONS(2045),
    [anon_sym_va_arg] = ACTIONS(2045),
    [anon_sym_phi] = ACTIONS(2045),
    [anon_sym_landingpad] = ACTIONS(2045),
    [anon_sym_tail] = ACTIONS(2045),
    [anon_sym_musttail] = ACTIONS(2045),
    [anon_sym_notail] = ACTIONS(2045),
    [anon_sym_call] = ACTIONS(2045),
    [anon_sym_alloca] = ACTIONS(2045),
    [anon_sym_load] = ACTIONS(2045),
    [anon_sym_store] = ACTIONS(2045),
    [anon_sym_cmpxchg] = ACTIONS(2045),
    [anon_sym_atomicrmw] = ACTIONS(2045),
    [anon_sym_fence] = ACTIONS(2045),
    [anon_sym_getelementptr] = ACTIONS(2045),
    [anon_sym_extractvalue] = ACTIONS(2045),
    [anon_sym_insertvalue] = ACTIONS(2045),
    [anon_sym_mul] = ACTIONS(2045),
    [anon_sym_urem] = ACTIONS(2045),
    [anon_sym_srem] = ACTIONS(2045),
    [anon_sym_shl] = ACTIONS(2045),
    [anon_sym_udiv] = ACTIONS(2045),
    [anon_sym_sdiv] = ACTIONS(2045),
    [anon_sym_lshr] = ACTIONS(2045),
    [anon_sym_ashr] = ACTIONS(2045),
    [anon_sym_fmul] = ACTIONS(2045),
    [anon_sym_fdiv] = ACTIONS(2045),
    [anon_sym_frem] = ACTIONS(2045),
    [anon_sym_xchg] = ACTIONS(2045),
    [anon_sym_add] = ACTIONS(2045),
    [anon_sym_sub] = ACTIONS(2045),
    [anon_sym_and] = ACTIONS(2045),
    [anon_sym_nand] = ACTIONS(2045),
    [anon_sym_or] = ACTIONS(2045),
    [anon_sym_xor] = ACTIONS(2045),
    [anon_sym_max] = ACTIONS(2045),
    [anon_sym_min] = ACTIONS(2045),
    [anon_sym_umax] = ACTIONS(2045),
    [anon_sym_umin] = ACTIONS(2045),
    [anon_sym_fadd] = ACTIONS(2045),
    [anon_sym_fsub] = ACTIONS(2045),
    [anon_sym_bitcast] = ACTIONS(2045),
    [anon_sym_trunc] = ACTIONS(2045),
    [anon_sym_zext] = ACTIONS(2045),
    [anon_sym_sext] = ACTIONS(2045),
    [anon_sym_fptrunc] = ACTIONS(2045),
    [anon_sym_fpext] = ACTIONS(2045),
    [anon_sym_addrspacecast] = ACTIONS(2045),
    [anon_sym_uitofp] = ACTIONS(2045),
    [anon_sym_sitofp] = ACTIONS(2045),
    [anon_sym_fptoui] = ACTIONS(2045),
    [anon_sym_fptosi] = ACTIONS(2045),
    [anon_sym_inttoptr] = ACTIONS(2045),
    [anon_sym_ptrtoint] = ACTIONS(2045),
    [anon_sym_uselistorder] = ACTIONS(2045),
  },
  [614] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2047),
    [sym_label] = ACTIONS(2047),
    [anon_sym_RBRACE] = ACTIONS(2047),
    [anon_sym_COMMA] = ACTIONS(2047),
    [anon_sym_unreachable] = ACTIONS(2049),
    [anon_sym_ret] = ACTIONS(2049),
    [anon_sym_br] = ACTIONS(2049),
    [anon_sym_resume] = ACTIONS(2049),
    [anon_sym_freeze] = ACTIONS(2049),
    [anon_sym_indirectbr] = ACTIONS(2049),
    [anon_sym_extractelement] = ACTIONS(2049),
    [anon_sym_insertelement] = ACTIONS(2049),
    [anon_sym_select] = ACTIONS(2049),
    [anon_sym_shufflevector] = ACTIONS(2049),
    [anon_sym_fneg] = ACTIONS(2049),
    [anon_sym_switch] = ACTIONS(2049),
    [anon_sym_invoke] = ACTIONS(2049),
    [anon_sym_cleanupret] = ACTIONS(2049),
    [anon_sym_catchret] = ACTIONS(2049),
    [anon_sym_catchswitch] = ACTIONS(2049),
    [anon_sym_catchpad] = ACTIONS(2049),
    [anon_sym_cleanuppad] = ACTIONS(2049),
    [anon_sym_callbr] = ACTIONS(2049),
    [anon_sym_icmp] = ACTIONS(2049),
    [anon_sym_fcmp] = ACTIONS(2049),
    [anon_sym_va_arg] = ACTIONS(2049),
    [anon_sym_phi] = ACTIONS(2049),
    [anon_sym_landingpad] = ACTIONS(2049),
    [anon_sym_tail] = ACTIONS(2049),
    [anon_sym_musttail] = ACTIONS(2049),
    [anon_sym_notail] = ACTIONS(2049),
    [anon_sym_call] = ACTIONS(2049),
    [anon_sym_alloca] = ACTIONS(2049),
    [anon_sym_load] = ACTIONS(2049),
    [anon_sym_store] = ACTIONS(2049),
    [anon_sym_cmpxchg] = ACTIONS(2049),
    [anon_sym_atomicrmw] = ACTIONS(2049),
    [anon_sym_fence] = ACTIONS(2049),
    [anon_sym_getelementptr] = ACTIONS(2049),
    [anon_sym_extractvalue] = ACTIONS(2049),
    [anon_sym_insertvalue] = ACTIONS(2049),
    [anon_sym_mul] = ACTIONS(2049),
    [anon_sym_urem] = ACTIONS(2049),
    [anon_sym_srem] = ACTIONS(2049),
    [anon_sym_shl] = ACTIONS(2049),
    [anon_sym_udiv] = ACTIONS(2049),
    [anon_sym_sdiv] = ACTIONS(2049),
    [anon_sym_lshr] = ACTIONS(2049),
    [anon_sym_ashr] = ACTIONS(2049),
    [anon_sym_fmul] = ACTIONS(2049),
    [anon_sym_fdiv] = ACTIONS(2049),
    [anon_sym_frem] = ACTIONS(2049),
    [anon_sym_xchg] = ACTIONS(2049),
    [anon_sym_add] = ACTIONS(2049),
    [anon_sym_sub] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2049),
    [anon_sym_nand] = ACTIONS(2049),
    [anon_sym_or] = ACTIONS(2049),
    [anon_sym_xor] = ACTIONS(2049),
    [anon_sym_max] = ACTIONS(2049),
    [anon_sym_min] = ACTIONS(2049),
    [anon_sym_umax] = ACTIONS(2049),
    [anon_sym_umin] = ACTIONS(2049),
    [anon_sym_fadd] = ACTIONS(2049),
    [anon_sym_fsub] = ACTIONS(2049),
    [anon_sym_bitcast] = ACTIONS(2049),
    [anon_sym_trunc] = ACTIONS(2049),
    [anon_sym_zext] = ACTIONS(2049),
    [anon_sym_sext] = ACTIONS(2049),
    [anon_sym_fptrunc] = ACTIONS(2049),
    [anon_sym_fpext] = ACTIONS(2049),
    [anon_sym_addrspacecast] = ACTIONS(2049),
    [anon_sym_uitofp] = ACTIONS(2049),
    [anon_sym_sitofp] = ACTIONS(2049),
    [anon_sym_fptoui] = ACTIONS(2049),
    [anon_sym_fptosi] = ACTIONS(2049),
    [anon_sym_inttoptr] = ACTIONS(2049),
    [anon_sym_ptrtoint] = ACTIONS(2049),
    [anon_sym_uselistorder] = ACTIONS(2049),
  },
  [615] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2051),
    [sym_label] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(2051),
    [anon_sym_unreachable] = ACTIONS(2053),
    [anon_sym_ret] = ACTIONS(2053),
    [anon_sym_br] = ACTIONS(2053),
    [anon_sym_resume] = ACTIONS(2053),
    [anon_sym_freeze] = ACTIONS(2053),
    [anon_sym_indirectbr] = ACTIONS(2053),
    [anon_sym_extractelement] = ACTIONS(2053),
    [anon_sym_insertelement] = ACTIONS(2053),
    [anon_sym_select] = ACTIONS(2053),
    [anon_sym_shufflevector] = ACTIONS(2053),
    [anon_sym_fneg] = ACTIONS(2053),
    [anon_sym_switch] = ACTIONS(2053),
    [anon_sym_invoke] = ACTIONS(2053),
    [anon_sym_cleanupret] = ACTIONS(2053),
    [anon_sym_catchret] = ACTIONS(2053),
    [anon_sym_catchswitch] = ACTIONS(2053),
    [anon_sym_catchpad] = ACTIONS(2053),
    [anon_sym_cleanuppad] = ACTIONS(2053),
    [anon_sym_callbr] = ACTIONS(2053),
    [anon_sym_icmp] = ACTIONS(2053),
    [anon_sym_fcmp] = ACTIONS(2053),
    [anon_sym_va_arg] = ACTIONS(2053),
    [anon_sym_phi] = ACTIONS(2053),
    [anon_sym_landingpad] = ACTIONS(2053),
    [anon_sym_tail] = ACTIONS(2053),
    [anon_sym_musttail] = ACTIONS(2053),
    [anon_sym_notail] = ACTIONS(2053),
    [anon_sym_call] = ACTIONS(2053),
    [anon_sym_alloca] = ACTIONS(2053),
    [anon_sym_load] = ACTIONS(2053),
    [anon_sym_store] = ACTIONS(2053),
    [anon_sym_cmpxchg] = ACTIONS(2053),
    [anon_sym_atomicrmw] = ACTIONS(2053),
    [anon_sym_fence] = ACTIONS(2053),
    [anon_sym_getelementptr] = ACTIONS(2053),
    [anon_sym_extractvalue] = ACTIONS(2053),
    [anon_sym_insertvalue] = ACTIONS(2053),
    [anon_sym_mul] = ACTIONS(2053),
    [anon_sym_urem] = ACTIONS(2053),
    [anon_sym_srem] = ACTIONS(2053),
    [anon_sym_shl] = ACTIONS(2053),
    [anon_sym_udiv] = ACTIONS(2053),
    [anon_sym_sdiv] = ACTIONS(2053),
    [anon_sym_lshr] = ACTIONS(2053),
    [anon_sym_ashr] = ACTIONS(2053),
    [anon_sym_fmul] = ACTIONS(2053),
    [anon_sym_fdiv] = ACTIONS(2053),
    [anon_sym_frem] = ACTIONS(2053),
    [anon_sym_xchg] = ACTIONS(2053),
    [anon_sym_add] = ACTIONS(2053),
    [anon_sym_sub] = ACTIONS(2053),
    [anon_sym_and] = ACTIONS(2053),
    [anon_sym_nand] = ACTIONS(2053),
    [anon_sym_or] = ACTIONS(2053),
    [anon_sym_xor] = ACTIONS(2053),
    [anon_sym_max] = ACTIONS(2053),
    [anon_sym_min] = ACTIONS(2053),
    [anon_sym_umax] = ACTIONS(2053),
    [anon_sym_umin] = ACTIONS(2053),
    [anon_sym_fadd] = ACTIONS(2053),
    [anon_sym_fsub] = ACTIONS(2053),
    [anon_sym_bitcast] = ACTIONS(2053),
    [anon_sym_trunc] = ACTIONS(2053),
    [anon_sym_zext] = ACTIONS(2053),
    [anon_sym_sext] = ACTIONS(2053),
    [anon_sym_fptrunc] = ACTIONS(2053),
    [anon_sym_fpext] = ACTIONS(2053),
    [anon_sym_addrspacecast] = ACTIONS(2053),
    [anon_sym_uitofp] = ACTIONS(2053),
    [anon_sym_sitofp] = ACTIONS(2053),
    [anon_sym_fptoui] = ACTIONS(2053),
    [anon_sym_fptosi] = ACTIONS(2053),
    [anon_sym_inttoptr] = ACTIONS(2053),
    [anon_sym_ptrtoint] = ACTIONS(2053),
    [anon_sym_uselistorder] = ACTIONS(2053),
  },
  [616] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2055),
    [sym_label] = ACTIONS(2055),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_unreachable] = ACTIONS(2057),
    [anon_sym_ret] = ACTIONS(2057),
    [anon_sym_br] = ACTIONS(2057),
    [anon_sym_resume] = ACTIONS(2057),
    [anon_sym_freeze] = ACTIONS(2057),
    [anon_sym_indirectbr] = ACTIONS(2057),
    [anon_sym_extractelement] = ACTIONS(2057),
    [anon_sym_insertelement] = ACTIONS(2057),
    [anon_sym_select] = ACTIONS(2057),
    [anon_sym_shufflevector] = ACTIONS(2057),
    [anon_sym_fneg] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_invoke] = ACTIONS(2057),
    [anon_sym_cleanupret] = ACTIONS(2057),
    [anon_sym_catchret] = ACTIONS(2057),
    [anon_sym_catchswitch] = ACTIONS(2057),
    [anon_sym_catchpad] = ACTIONS(2057),
    [anon_sym_cleanuppad] = ACTIONS(2057),
    [anon_sym_callbr] = ACTIONS(2057),
    [anon_sym_icmp] = ACTIONS(2057),
    [anon_sym_fcmp] = ACTIONS(2057),
    [anon_sym_va_arg] = ACTIONS(2057),
    [anon_sym_phi] = ACTIONS(2057),
    [anon_sym_landingpad] = ACTIONS(2057),
    [anon_sym_tail] = ACTIONS(2057),
    [anon_sym_musttail] = ACTIONS(2057),
    [anon_sym_notail] = ACTIONS(2057),
    [anon_sym_call] = ACTIONS(2057),
    [anon_sym_alloca] = ACTIONS(2057),
    [anon_sym_load] = ACTIONS(2057),
    [anon_sym_store] = ACTIONS(2057),
    [anon_sym_cmpxchg] = ACTIONS(2057),
    [anon_sym_atomicrmw] = ACTIONS(2057),
    [anon_sym_fence] = ACTIONS(2057),
    [anon_sym_getelementptr] = ACTIONS(2057),
    [anon_sym_extractvalue] = ACTIONS(2057),
    [anon_sym_insertvalue] = ACTIONS(2057),
    [anon_sym_mul] = ACTIONS(2057),
    [anon_sym_urem] = ACTIONS(2057),
    [anon_sym_srem] = ACTIONS(2057),
    [anon_sym_shl] = ACTIONS(2057),
    [anon_sym_udiv] = ACTIONS(2057),
    [anon_sym_sdiv] = ACTIONS(2057),
    [anon_sym_lshr] = ACTIONS(2057),
    [anon_sym_ashr] = ACTIONS(2057),
    [anon_sym_fmul] = ACTIONS(2057),
    [anon_sym_fdiv] = ACTIONS(2057),
    [anon_sym_frem] = ACTIONS(2057),
    [anon_sym_xchg] = ACTIONS(2057),
    [anon_sym_add] = ACTIONS(2057),
    [anon_sym_sub] = ACTIONS(2057),
    [anon_sym_and] = ACTIONS(2057),
    [anon_sym_nand] = ACTIONS(2057),
    [anon_sym_or] = ACTIONS(2057),
    [anon_sym_xor] = ACTIONS(2057),
    [anon_sym_max] = ACTIONS(2057),
    [anon_sym_min] = ACTIONS(2057),
    [anon_sym_umax] = ACTIONS(2057),
    [anon_sym_umin] = ACTIONS(2057),
    [anon_sym_fadd] = ACTIONS(2057),
    [anon_sym_fsub] = ACTIONS(2057),
    [anon_sym_bitcast] = ACTIONS(2057),
    [anon_sym_trunc] = ACTIONS(2057),
    [anon_sym_zext] = ACTIONS(2057),
    [anon_sym_sext] = ACTIONS(2057),
    [anon_sym_fptrunc] = ACTIONS(2057),
    [anon_sym_fpext] = ACTIONS(2057),
    [anon_sym_addrspacecast] = ACTIONS(2057),
    [anon_sym_uitofp] = ACTIONS(2057),
    [anon_sym_sitofp] = ACTIONS(2057),
    [anon_sym_fptoui] = ACTIONS(2057),
    [anon_sym_fptosi] = ACTIONS(2057),
    [anon_sym_inttoptr] = ACTIONS(2057),
    [anon_sym_ptrtoint] = ACTIONS(2057),
    [anon_sym_uselistorder] = ACTIONS(2057),
  },
  [617] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2059),
    [sym_label] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_COMMA] = ACTIONS(2059),
    [anon_sym_unreachable] = ACTIONS(2061),
    [anon_sym_ret] = ACTIONS(2061),
    [anon_sym_br] = ACTIONS(2061),
    [anon_sym_resume] = ACTIONS(2061),
    [anon_sym_freeze] = ACTIONS(2061),
    [anon_sym_indirectbr] = ACTIONS(2061),
    [anon_sym_extractelement] = ACTIONS(2061),
    [anon_sym_insertelement] = ACTIONS(2061),
    [anon_sym_select] = ACTIONS(2061),
    [anon_sym_shufflevector] = ACTIONS(2061),
    [anon_sym_fneg] = ACTIONS(2061),
    [anon_sym_switch] = ACTIONS(2061),
    [anon_sym_invoke] = ACTIONS(2061),
    [anon_sym_cleanupret] = ACTIONS(2061),
    [anon_sym_catchret] = ACTIONS(2061),
    [anon_sym_catchswitch] = ACTIONS(2061),
    [anon_sym_catchpad] = ACTIONS(2061),
    [anon_sym_cleanuppad] = ACTIONS(2061),
    [anon_sym_callbr] = ACTIONS(2061),
    [anon_sym_icmp] = ACTIONS(2061),
    [anon_sym_fcmp] = ACTIONS(2061),
    [anon_sym_va_arg] = ACTIONS(2061),
    [anon_sym_phi] = ACTIONS(2061),
    [anon_sym_landingpad] = ACTIONS(2061),
    [anon_sym_tail] = ACTIONS(2061),
    [anon_sym_musttail] = ACTIONS(2061),
    [anon_sym_notail] = ACTIONS(2061),
    [anon_sym_call] = ACTIONS(2061),
    [anon_sym_alloca] = ACTIONS(2061),
    [anon_sym_load] = ACTIONS(2061),
    [anon_sym_store] = ACTIONS(2061),
    [anon_sym_cmpxchg] = ACTIONS(2061),
    [anon_sym_atomicrmw] = ACTIONS(2061),
    [anon_sym_fence] = ACTIONS(2061),
    [anon_sym_getelementptr] = ACTIONS(2061),
    [anon_sym_extractvalue] = ACTIONS(2061),
    [anon_sym_insertvalue] = ACTIONS(2061),
    [anon_sym_mul] = ACTIONS(2061),
    [anon_sym_urem] = ACTIONS(2061),
    [anon_sym_srem] = ACTIONS(2061),
    [anon_sym_shl] = ACTIONS(2061),
    [anon_sym_udiv] = ACTIONS(2061),
    [anon_sym_sdiv] = ACTIONS(2061),
    [anon_sym_lshr] = ACTIONS(2061),
    [anon_sym_ashr] = ACTIONS(2061),
    [anon_sym_fmul] = ACTIONS(2061),
    [anon_sym_fdiv] = ACTIONS(2061),
    [anon_sym_frem] = ACTIONS(2061),
    [anon_sym_xchg] = ACTIONS(2061),
    [anon_sym_add] = ACTIONS(2061),
    [anon_sym_sub] = ACTIONS(2061),
    [anon_sym_and] = ACTIONS(2061),
    [anon_sym_nand] = ACTIONS(2061),
    [anon_sym_or] = ACTIONS(2061),
    [anon_sym_xor] = ACTIONS(2061),
    [anon_sym_max] = ACTIONS(2061),
    [anon_sym_min] = ACTIONS(2061),
    [anon_sym_umax] = ACTIONS(2061),
    [anon_sym_umin] = ACTIONS(2061),
    [anon_sym_fadd] = ACTIONS(2061),
    [anon_sym_fsub] = ACTIONS(2061),
    [anon_sym_bitcast] = ACTIONS(2061),
    [anon_sym_trunc] = ACTIONS(2061),
    [anon_sym_zext] = ACTIONS(2061),
    [anon_sym_sext] = ACTIONS(2061),
    [anon_sym_fptrunc] = ACTIONS(2061),
    [anon_sym_fpext] = ACTIONS(2061),
    [anon_sym_addrspacecast] = ACTIONS(2061),
    [anon_sym_uitofp] = ACTIONS(2061),
    [anon_sym_sitofp] = ACTIONS(2061),
    [anon_sym_fptoui] = ACTIONS(2061),
    [anon_sym_fptosi] = ACTIONS(2061),
    [anon_sym_inttoptr] = ACTIONS(2061),
    [anon_sym_ptrtoint] = ACTIONS(2061),
    [anon_sym_uselistorder] = ACTIONS(2061),
  },
  [618] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2063),
    [sym_label] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2063),
    [anon_sym_unreachable] = ACTIONS(2065),
    [anon_sym_ret] = ACTIONS(2065),
    [anon_sym_br] = ACTIONS(2065),
    [anon_sym_resume] = ACTIONS(2065),
    [anon_sym_freeze] = ACTIONS(2065),
    [anon_sym_indirectbr] = ACTIONS(2065),
    [anon_sym_extractelement] = ACTIONS(2065),
    [anon_sym_insertelement] = ACTIONS(2065),
    [anon_sym_select] = ACTIONS(2065),
    [anon_sym_shufflevector] = ACTIONS(2065),
    [anon_sym_fneg] = ACTIONS(2065),
    [anon_sym_switch] = ACTIONS(2065),
    [anon_sym_invoke] = ACTIONS(2065),
    [anon_sym_cleanupret] = ACTIONS(2065),
    [anon_sym_catchret] = ACTIONS(2065),
    [anon_sym_catchswitch] = ACTIONS(2065),
    [anon_sym_catchpad] = ACTIONS(2065),
    [anon_sym_cleanuppad] = ACTIONS(2065),
    [anon_sym_callbr] = ACTIONS(2065),
    [anon_sym_icmp] = ACTIONS(2065),
    [anon_sym_fcmp] = ACTIONS(2065),
    [anon_sym_va_arg] = ACTIONS(2065),
    [anon_sym_phi] = ACTIONS(2065),
    [anon_sym_landingpad] = ACTIONS(2065),
    [anon_sym_tail] = ACTIONS(2065),
    [anon_sym_musttail] = ACTIONS(2065),
    [anon_sym_notail] = ACTIONS(2065),
    [anon_sym_call] = ACTIONS(2065),
    [anon_sym_alloca] = ACTIONS(2065),
    [anon_sym_load] = ACTIONS(2065),
    [anon_sym_store] = ACTIONS(2065),
    [anon_sym_cmpxchg] = ACTIONS(2065),
    [anon_sym_atomicrmw] = ACTIONS(2065),
    [anon_sym_fence] = ACTIONS(2065),
    [anon_sym_getelementptr] = ACTIONS(2065),
    [anon_sym_extractvalue] = ACTIONS(2065),
    [anon_sym_insertvalue] = ACTIONS(2065),
    [anon_sym_mul] = ACTIONS(2065),
    [anon_sym_urem] = ACTIONS(2065),
    [anon_sym_srem] = ACTIONS(2065),
    [anon_sym_shl] = ACTIONS(2065),
    [anon_sym_udiv] = ACTIONS(2065),
    [anon_sym_sdiv] = ACTIONS(2065),
    [anon_sym_lshr] = ACTIONS(2065),
    [anon_sym_ashr] = ACTIONS(2065),
    [anon_sym_fmul] = ACTIONS(2065),
    [anon_sym_fdiv] = ACTIONS(2065),
    [anon_sym_frem] = ACTIONS(2065),
    [anon_sym_xchg] = ACTIONS(2065),
    [anon_sym_add] = ACTIONS(2065),
    [anon_sym_sub] = ACTIONS(2065),
    [anon_sym_and] = ACTIONS(2065),
    [anon_sym_nand] = ACTIONS(2065),
    [anon_sym_or] = ACTIONS(2065),
    [anon_sym_xor] = ACTIONS(2065),
    [anon_sym_max] = ACTIONS(2065),
    [anon_sym_min] = ACTIONS(2065),
    [anon_sym_umax] = ACTIONS(2065),
    [anon_sym_umin] = ACTIONS(2065),
    [anon_sym_fadd] = ACTIONS(2065),
    [anon_sym_fsub] = ACTIONS(2065),
    [anon_sym_bitcast] = ACTIONS(2065),
    [anon_sym_trunc] = ACTIONS(2065),
    [anon_sym_zext] = ACTIONS(2065),
    [anon_sym_sext] = ACTIONS(2065),
    [anon_sym_fptrunc] = ACTIONS(2065),
    [anon_sym_fpext] = ACTIONS(2065),
    [anon_sym_addrspacecast] = ACTIONS(2065),
    [anon_sym_uitofp] = ACTIONS(2065),
    [anon_sym_sitofp] = ACTIONS(2065),
    [anon_sym_fptoui] = ACTIONS(2065),
    [anon_sym_fptosi] = ACTIONS(2065),
    [anon_sym_inttoptr] = ACTIONS(2065),
    [anon_sym_ptrtoint] = ACTIONS(2065),
    [anon_sym_uselistorder] = ACTIONS(2065),
  },
  [619] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2067),
    [sym_label] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_unreachable] = ACTIONS(2069),
    [anon_sym_ret] = ACTIONS(2069),
    [anon_sym_br] = ACTIONS(2069),
    [anon_sym_resume] = ACTIONS(2069),
    [anon_sym_freeze] = ACTIONS(2069),
    [anon_sym_indirectbr] = ACTIONS(2069),
    [anon_sym_extractelement] = ACTIONS(2069),
    [anon_sym_insertelement] = ACTIONS(2069),
    [anon_sym_select] = ACTIONS(2069),
    [anon_sym_shufflevector] = ACTIONS(2069),
    [anon_sym_fneg] = ACTIONS(2069),
    [anon_sym_switch] = ACTIONS(2069),
    [anon_sym_invoke] = ACTIONS(2069),
    [anon_sym_cleanupret] = ACTIONS(2069),
    [anon_sym_catchret] = ACTIONS(2069),
    [anon_sym_catchswitch] = ACTIONS(2069),
    [anon_sym_catchpad] = ACTIONS(2069),
    [anon_sym_cleanuppad] = ACTIONS(2069),
    [anon_sym_callbr] = ACTIONS(2069),
    [anon_sym_icmp] = ACTIONS(2069),
    [anon_sym_fcmp] = ACTIONS(2069),
    [anon_sym_va_arg] = ACTIONS(2069),
    [anon_sym_phi] = ACTIONS(2069),
    [anon_sym_landingpad] = ACTIONS(2069),
    [anon_sym_tail] = ACTIONS(2069),
    [anon_sym_musttail] = ACTIONS(2069),
    [anon_sym_notail] = ACTIONS(2069),
    [anon_sym_call] = ACTIONS(2069),
    [anon_sym_alloca] = ACTIONS(2069),
    [anon_sym_load] = ACTIONS(2069),
    [anon_sym_store] = ACTIONS(2069),
    [anon_sym_cmpxchg] = ACTIONS(2069),
    [anon_sym_atomicrmw] = ACTIONS(2069),
    [anon_sym_fence] = ACTIONS(2069),
    [anon_sym_getelementptr] = ACTIONS(2069),
    [anon_sym_extractvalue] = ACTIONS(2069),
    [anon_sym_insertvalue] = ACTIONS(2069),
    [anon_sym_mul] = ACTIONS(2069),
    [anon_sym_urem] = ACTIONS(2069),
    [anon_sym_srem] = ACTIONS(2069),
    [anon_sym_shl] = ACTIONS(2069),
    [anon_sym_udiv] = ACTIONS(2069),
    [anon_sym_sdiv] = ACTIONS(2069),
    [anon_sym_lshr] = ACTIONS(2069),
    [anon_sym_ashr] = ACTIONS(2069),
    [anon_sym_fmul] = ACTIONS(2069),
    [anon_sym_fdiv] = ACTIONS(2069),
    [anon_sym_frem] = ACTIONS(2069),
    [anon_sym_xchg] = ACTIONS(2069),
    [anon_sym_add] = ACTIONS(2069),
    [anon_sym_sub] = ACTIONS(2069),
    [anon_sym_and] = ACTIONS(2069),
    [anon_sym_nand] = ACTIONS(2069),
    [anon_sym_or] = ACTIONS(2069),
    [anon_sym_xor] = ACTIONS(2069),
    [anon_sym_max] = ACTIONS(2069),
    [anon_sym_min] = ACTIONS(2069),
    [anon_sym_umax] = ACTIONS(2069),
    [anon_sym_umin] = ACTIONS(2069),
    [anon_sym_fadd] = ACTIONS(2069),
    [anon_sym_fsub] = ACTIONS(2069),
    [anon_sym_bitcast] = ACTIONS(2069),
    [anon_sym_trunc] = ACTIONS(2069),
    [anon_sym_zext] = ACTIONS(2069),
    [anon_sym_sext] = ACTIONS(2069),
    [anon_sym_fptrunc] = ACTIONS(2069),
    [anon_sym_fpext] = ACTIONS(2069),
    [anon_sym_addrspacecast] = ACTIONS(2069),
    [anon_sym_uitofp] = ACTIONS(2069),
    [anon_sym_sitofp] = ACTIONS(2069),
    [anon_sym_fptoui] = ACTIONS(2069),
    [anon_sym_fptosi] = ACTIONS(2069),
    [anon_sym_inttoptr] = ACTIONS(2069),
    [anon_sym_ptrtoint] = ACTIONS(2069),
    [anon_sym_uselistorder] = ACTIONS(2069),
  },
  [620] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(695),
    [sym_label] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_COMMA] = ACTIONS(695),
    [anon_sym_unreachable] = ACTIONS(711),
    [anon_sym_ret] = ACTIONS(711),
    [anon_sym_br] = ACTIONS(711),
    [anon_sym_resume] = ACTIONS(711),
    [anon_sym_freeze] = ACTIONS(711),
    [anon_sym_indirectbr] = ACTIONS(711),
    [anon_sym_extractelement] = ACTIONS(711),
    [anon_sym_insertelement] = ACTIONS(711),
    [anon_sym_select] = ACTIONS(711),
    [anon_sym_shufflevector] = ACTIONS(711),
    [anon_sym_fneg] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_invoke] = ACTIONS(711),
    [anon_sym_cleanupret] = ACTIONS(711),
    [anon_sym_catchret] = ACTIONS(711),
    [anon_sym_catchswitch] = ACTIONS(711),
    [anon_sym_catchpad] = ACTIONS(711),
    [anon_sym_cleanuppad] = ACTIONS(711),
    [anon_sym_callbr] = ACTIONS(711),
    [anon_sym_icmp] = ACTIONS(711),
    [anon_sym_fcmp] = ACTIONS(711),
    [anon_sym_va_arg] = ACTIONS(711),
    [anon_sym_phi] = ACTIONS(711),
    [anon_sym_landingpad] = ACTIONS(711),
    [anon_sym_tail] = ACTIONS(711),
    [anon_sym_musttail] = ACTIONS(711),
    [anon_sym_notail] = ACTIONS(711),
    [anon_sym_call] = ACTIONS(711),
    [anon_sym_alloca] = ACTIONS(711),
    [anon_sym_load] = ACTIONS(711),
    [anon_sym_store] = ACTIONS(711),
    [anon_sym_cmpxchg] = ACTIONS(711),
    [anon_sym_atomicrmw] = ACTIONS(711),
    [anon_sym_fence] = ACTIONS(711),
    [anon_sym_getelementptr] = ACTIONS(711),
    [anon_sym_extractvalue] = ACTIONS(711),
    [anon_sym_insertvalue] = ACTIONS(711),
    [anon_sym_mul] = ACTIONS(711),
    [anon_sym_urem] = ACTIONS(711),
    [anon_sym_srem] = ACTIONS(711),
    [anon_sym_shl] = ACTIONS(711),
    [anon_sym_udiv] = ACTIONS(711),
    [anon_sym_sdiv] = ACTIONS(711),
    [anon_sym_lshr] = ACTIONS(711),
    [anon_sym_ashr] = ACTIONS(711),
    [anon_sym_fmul] = ACTIONS(711),
    [anon_sym_fdiv] = ACTIONS(711),
    [anon_sym_frem] = ACTIONS(711),
    [anon_sym_xchg] = ACTIONS(711),
    [anon_sym_add] = ACTIONS(711),
    [anon_sym_sub] = ACTIONS(711),
    [anon_sym_and] = ACTIONS(711),
    [anon_sym_nand] = ACTIONS(711),
    [anon_sym_or] = ACTIONS(711),
    [anon_sym_xor] = ACTIONS(711),
    [anon_sym_max] = ACTIONS(711),
    [anon_sym_min] = ACTIONS(711),
    [anon_sym_umax] = ACTIONS(711),
    [anon_sym_umin] = ACTIONS(711),
    [anon_sym_fadd] = ACTIONS(711),
    [anon_sym_fsub] = ACTIONS(711),
    [anon_sym_bitcast] = ACTIONS(711),
    [anon_sym_trunc] = ACTIONS(711),
    [anon_sym_zext] = ACTIONS(711),
    [anon_sym_sext] = ACTIONS(711),
    [anon_sym_fptrunc] = ACTIONS(711),
    [anon_sym_fpext] = ACTIONS(711),
    [anon_sym_addrspacecast] = ACTIONS(711),
    [anon_sym_uitofp] = ACTIONS(711),
    [anon_sym_sitofp] = ACTIONS(711),
    [anon_sym_fptoui] = ACTIONS(711),
    [anon_sym_fptosi] = ACTIONS(711),
    [anon_sym_inttoptr] = ACTIONS(711),
    [anon_sym_ptrtoint] = ACTIONS(711),
    [anon_sym_uselistorder] = ACTIONS(711),
  },
  [621] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2071),
    [sym_label] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2071),
    [anon_sym_COMMA] = ACTIONS(2071),
    [anon_sym_unreachable] = ACTIONS(2073),
    [anon_sym_ret] = ACTIONS(2073),
    [anon_sym_br] = ACTIONS(2073),
    [anon_sym_resume] = ACTIONS(2073),
    [anon_sym_freeze] = ACTIONS(2073),
    [anon_sym_indirectbr] = ACTIONS(2073),
    [anon_sym_extractelement] = ACTIONS(2073),
    [anon_sym_insertelement] = ACTIONS(2073),
    [anon_sym_select] = ACTIONS(2073),
    [anon_sym_shufflevector] = ACTIONS(2073),
    [anon_sym_fneg] = ACTIONS(2073),
    [anon_sym_switch] = ACTIONS(2073),
    [anon_sym_invoke] = ACTIONS(2073),
    [anon_sym_cleanupret] = ACTIONS(2073),
    [anon_sym_catchret] = ACTIONS(2073),
    [anon_sym_catchswitch] = ACTIONS(2073),
    [anon_sym_catchpad] = ACTIONS(2073),
    [anon_sym_cleanuppad] = ACTIONS(2073),
    [anon_sym_callbr] = ACTIONS(2073),
    [anon_sym_icmp] = ACTIONS(2073),
    [anon_sym_fcmp] = ACTIONS(2073),
    [anon_sym_va_arg] = ACTIONS(2073),
    [anon_sym_phi] = ACTIONS(2073),
    [anon_sym_landingpad] = ACTIONS(2073),
    [anon_sym_tail] = ACTIONS(2073),
    [anon_sym_musttail] = ACTIONS(2073),
    [anon_sym_notail] = ACTIONS(2073),
    [anon_sym_call] = ACTIONS(2073),
    [anon_sym_alloca] = ACTIONS(2073),
    [anon_sym_load] = ACTIONS(2073),
    [anon_sym_store] = ACTIONS(2073),
    [anon_sym_cmpxchg] = ACTIONS(2073),
    [anon_sym_atomicrmw] = ACTIONS(2073),
    [anon_sym_fence] = ACTIONS(2073),
    [anon_sym_getelementptr] = ACTIONS(2073),
    [anon_sym_extractvalue] = ACTIONS(2073),
    [anon_sym_insertvalue] = ACTIONS(2073),
    [anon_sym_mul] = ACTIONS(2073),
    [anon_sym_urem] = ACTIONS(2073),
    [anon_sym_srem] = ACTIONS(2073),
    [anon_sym_shl] = ACTIONS(2073),
    [anon_sym_udiv] = ACTIONS(2073),
    [anon_sym_sdiv] = ACTIONS(2073),
    [anon_sym_lshr] = ACTIONS(2073),
    [anon_sym_ashr] = ACTIONS(2073),
    [anon_sym_fmul] = ACTIONS(2073),
    [anon_sym_fdiv] = ACTIONS(2073),
    [anon_sym_frem] = ACTIONS(2073),
    [anon_sym_xchg] = ACTIONS(2073),
    [anon_sym_add] = ACTIONS(2073),
    [anon_sym_sub] = ACTIONS(2073),
    [anon_sym_and] = ACTIONS(2073),
    [anon_sym_nand] = ACTIONS(2073),
    [anon_sym_or] = ACTIONS(2073),
    [anon_sym_xor] = ACTIONS(2073),
    [anon_sym_max] = ACTIONS(2073),
    [anon_sym_min] = ACTIONS(2073),
    [anon_sym_umax] = ACTIONS(2073),
    [anon_sym_umin] = ACTIONS(2073),
    [anon_sym_fadd] = ACTIONS(2073),
    [anon_sym_fsub] = ACTIONS(2073),
    [anon_sym_bitcast] = ACTIONS(2073),
    [anon_sym_trunc] = ACTIONS(2073),
    [anon_sym_zext] = ACTIONS(2073),
    [anon_sym_sext] = ACTIONS(2073),
    [anon_sym_fptrunc] = ACTIONS(2073),
    [anon_sym_fpext] = ACTIONS(2073),
    [anon_sym_addrspacecast] = ACTIONS(2073),
    [anon_sym_uitofp] = ACTIONS(2073),
    [anon_sym_sitofp] = ACTIONS(2073),
    [anon_sym_fptoui] = ACTIONS(2073),
    [anon_sym_fptosi] = ACTIONS(2073),
    [anon_sym_inttoptr] = ACTIONS(2073),
    [anon_sym_ptrtoint] = ACTIONS(2073),
    [anon_sym_uselistorder] = ACTIONS(2073),
  },
  [622] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1786),
    [sym_label] = ACTIONS(1786),
    [anon_sym_RBRACE] = ACTIONS(1786),
    [anon_sym_COMMA] = ACTIONS(1786),
    [anon_sym_unreachable] = ACTIONS(1791),
    [anon_sym_ret] = ACTIONS(1791),
    [anon_sym_br] = ACTIONS(1791),
    [anon_sym_resume] = ACTIONS(1791),
    [anon_sym_freeze] = ACTIONS(1791),
    [anon_sym_indirectbr] = ACTIONS(1791),
    [anon_sym_extractelement] = ACTIONS(1791),
    [anon_sym_insertelement] = ACTIONS(1791),
    [anon_sym_select] = ACTIONS(1791),
    [anon_sym_shufflevector] = ACTIONS(1791),
    [anon_sym_fneg] = ACTIONS(1791),
    [anon_sym_switch] = ACTIONS(1791),
    [anon_sym_invoke] = ACTIONS(1791),
    [anon_sym_cleanupret] = ACTIONS(1791),
    [anon_sym_catchret] = ACTIONS(1791),
    [anon_sym_catchswitch] = ACTIONS(1791),
    [anon_sym_catchpad] = ACTIONS(1791),
    [anon_sym_cleanuppad] = ACTIONS(1791),
    [anon_sym_callbr] = ACTIONS(1791),
    [anon_sym_icmp] = ACTIONS(1791),
    [anon_sym_fcmp] = ACTIONS(1791),
    [anon_sym_va_arg] = ACTIONS(1791),
    [anon_sym_phi] = ACTIONS(1791),
    [anon_sym_landingpad] = ACTIONS(1791),
    [anon_sym_tail] = ACTIONS(1791),
    [anon_sym_musttail] = ACTIONS(1791),
    [anon_sym_notail] = ACTIONS(1791),
    [anon_sym_call] = ACTIONS(1791),
    [anon_sym_alloca] = ACTIONS(1791),
    [anon_sym_load] = ACTIONS(1791),
    [anon_sym_store] = ACTIONS(1791),
    [anon_sym_cmpxchg] = ACTIONS(1791),
    [anon_sym_atomicrmw] = ACTIONS(1791),
    [anon_sym_fence] = ACTIONS(1791),
    [anon_sym_getelementptr] = ACTIONS(1791),
    [anon_sym_extractvalue] = ACTIONS(1791),
    [anon_sym_insertvalue] = ACTIONS(1791),
    [anon_sym_mul] = ACTIONS(1791),
    [anon_sym_urem] = ACTIONS(1791),
    [anon_sym_srem] = ACTIONS(1791),
    [anon_sym_shl] = ACTIONS(1791),
    [anon_sym_udiv] = ACTIONS(1791),
    [anon_sym_sdiv] = ACTIONS(1791),
    [anon_sym_lshr] = ACTIONS(1791),
    [anon_sym_ashr] = ACTIONS(1791),
    [anon_sym_fmul] = ACTIONS(1791),
    [anon_sym_fdiv] = ACTIONS(1791),
    [anon_sym_frem] = ACTIONS(1791),
    [anon_sym_xchg] = ACTIONS(1791),
    [anon_sym_add] = ACTIONS(1791),
    [anon_sym_sub] = ACTIONS(1791),
    [anon_sym_and] = ACTIONS(1791),
    [anon_sym_nand] = ACTIONS(1791),
    [anon_sym_or] = ACTIONS(1791),
    [anon_sym_xor] = ACTIONS(1791),
    [anon_sym_max] = ACTIONS(1791),
    [anon_sym_min] = ACTIONS(1791),
    [anon_sym_umax] = ACTIONS(1791),
    [anon_sym_umin] = ACTIONS(1791),
    [anon_sym_fadd] = ACTIONS(1791),
    [anon_sym_fsub] = ACTIONS(1791),
    [anon_sym_bitcast] = ACTIONS(1791),
    [anon_sym_trunc] = ACTIONS(1791),
    [anon_sym_zext] = ACTIONS(1791),
    [anon_sym_sext] = ACTIONS(1791),
    [anon_sym_fptrunc] = ACTIONS(1791),
    [anon_sym_fpext] = ACTIONS(1791),
    [anon_sym_addrspacecast] = ACTIONS(1791),
    [anon_sym_uitofp] = ACTIONS(1791),
    [anon_sym_sitofp] = ACTIONS(1791),
    [anon_sym_fptoui] = ACTIONS(1791),
    [anon_sym_fptosi] = ACTIONS(1791),
    [anon_sym_inttoptr] = ACTIONS(1791),
    [anon_sym_ptrtoint] = ACTIONS(1791),
    [anon_sym_uselistorder] = ACTIONS(1791),
  },
  [623] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2075),
    [sym_label] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_unreachable] = ACTIONS(2077),
    [anon_sym_ret] = ACTIONS(2077),
    [anon_sym_br] = ACTIONS(2077),
    [anon_sym_resume] = ACTIONS(2077),
    [anon_sym_freeze] = ACTIONS(2077),
    [anon_sym_indirectbr] = ACTIONS(2077),
    [anon_sym_extractelement] = ACTIONS(2077),
    [anon_sym_insertelement] = ACTIONS(2077),
    [anon_sym_select] = ACTIONS(2077),
    [anon_sym_shufflevector] = ACTIONS(2077),
    [anon_sym_fneg] = ACTIONS(2077),
    [anon_sym_switch] = ACTIONS(2077),
    [anon_sym_invoke] = ACTIONS(2077),
    [anon_sym_cleanupret] = ACTIONS(2077),
    [anon_sym_catchret] = ACTIONS(2077),
    [anon_sym_catchswitch] = ACTIONS(2077),
    [anon_sym_catchpad] = ACTIONS(2077),
    [anon_sym_cleanuppad] = ACTIONS(2077),
    [anon_sym_callbr] = ACTIONS(2077),
    [anon_sym_icmp] = ACTIONS(2077),
    [anon_sym_fcmp] = ACTIONS(2077),
    [anon_sym_va_arg] = ACTIONS(2077),
    [anon_sym_phi] = ACTIONS(2077),
    [anon_sym_landingpad] = ACTIONS(2077),
    [anon_sym_tail] = ACTIONS(2077),
    [anon_sym_musttail] = ACTIONS(2077),
    [anon_sym_notail] = ACTIONS(2077),
    [anon_sym_call] = ACTIONS(2077),
    [anon_sym_alloca] = ACTIONS(2077),
    [anon_sym_load] = ACTIONS(2077),
    [anon_sym_store] = ACTIONS(2077),
    [anon_sym_cmpxchg] = ACTIONS(2077),
    [anon_sym_atomicrmw] = ACTIONS(2077),
    [anon_sym_fence] = ACTIONS(2077),
    [anon_sym_getelementptr] = ACTIONS(2077),
    [anon_sym_extractvalue] = ACTIONS(2077),
    [anon_sym_insertvalue] = ACTIONS(2077),
    [anon_sym_mul] = ACTIONS(2077),
    [anon_sym_urem] = ACTIONS(2077),
    [anon_sym_srem] = ACTIONS(2077),
    [anon_sym_shl] = ACTIONS(2077),
    [anon_sym_udiv] = ACTIONS(2077),
    [anon_sym_sdiv] = ACTIONS(2077),
    [anon_sym_lshr] = ACTIONS(2077),
    [anon_sym_ashr] = ACTIONS(2077),
    [anon_sym_fmul] = ACTIONS(2077),
    [anon_sym_fdiv] = ACTIONS(2077),
    [anon_sym_frem] = ACTIONS(2077),
    [anon_sym_xchg] = ACTIONS(2077),
    [anon_sym_add] = ACTIONS(2077),
    [anon_sym_sub] = ACTIONS(2077),
    [anon_sym_and] = ACTIONS(2077),
    [anon_sym_nand] = ACTIONS(2077),
    [anon_sym_or] = ACTIONS(2077),
    [anon_sym_xor] = ACTIONS(2077),
    [anon_sym_max] = ACTIONS(2077),
    [anon_sym_min] = ACTIONS(2077),
    [anon_sym_umax] = ACTIONS(2077),
    [anon_sym_umin] = ACTIONS(2077),
    [anon_sym_fadd] = ACTIONS(2077),
    [anon_sym_fsub] = ACTIONS(2077),
    [anon_sym_bitcast] = ACTIONS(2077),
    [anon_sym_trunc] = ACTIONS(2077),
    [anon_sym_zext] = ACTIONS(2077),
    [anon_sym_sext] = ACTIONS(2077),
    [anon_sym_fptrunc] = ACTIONS(2077),
    [anon_sym_fpext] = ACTIONS(2077),
    [anon_sym_addrspacecast] = ACTIONS(2077),
    [anon_sym_uitofp] = ACTIONS(2077),
    [anon_sym_sitofp] = ACTIONS(2077),
    [anon_sym_fptoui] = ACTIONS(2077),
    [anon_sym_fptosi] = ACTIONS(2077),
    [anon_sym_inttoptr] = ACTIONS(2077),
    [anon_sym_ptrtoint] = ACTIONS(2077),
    [anon_sym_uselistorder] = ACTIONS(2077),
  },
  [624] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2079),
    [sym_label] = ACTIONS(2079),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_unreachable] = ACTIONS(2084),
    [anon_sym_ret] = ACTIONS(2084),
    [anon_sym_br] = ACTIONS(2084),
    [anon_sym_resume] = ACTIONS(2084),
    [anon_sym_freeze] = ACTIONS(2084),
    [anon_sym_indirectbr] = ACTIONS(2084),
    [anon_sym_extractelement] = ACTIONS(2084),
    [anon_sym_insertelement] = ACTIONS(2084),
    [anon_sym_select] = ACTIONS(2084),
    [anon_sym_shufflevector] = ACTIONS(2084),
    [anon_sym_fneg] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_invoke] = ACTIONS(2084),
    [anon_sym_cleanupret] = ACTIONS(2084),
    [anon_sym_catchret] = ACTIONS(2084),
    [anon_sym_catchswitch] = ACTIONS(2084),
    [anon_sym_catchpad] = ACTIONS(2084),
    [anon_sym_cleanuppad] = ACTIONS(2084),
    [anon_sym_callbr] = ACTIONS(2084),
    [anon_sym_icmp] = ACTIONS(2084),
    [anon_sym_fcmp] = ACTIONS(2084),
    [anon_sym_va_arg] = ACTIONS(2084),
    [anon_sym_phi] = ACTIONS(2084),
    [anon_sym_landingpad] = ACTIONS(2084),
    [anon_sym_tail] = ACTIONS(2084),
    [anon_sym_musttail] = ACTIONS(2084),
    [anon_sym_notail] = ACTIONS(2084),
    [anon_sym_call] = ACTIONS(2084),
    [anon_sym_alloca] = ACTIONS(2084),
    [anon_sym_load] = ACTIONS(2084),
    [anon_sym_store] = ACTIONS(2084),
    [anon_sym_cmpxchg] = ACTIONS(2084),
    [anon_sym_atomicrmw] = ACTIONS(2084),
    [anon_sym_fence] = ACTIONS(2084),
    [anon_sym_getelementptr] = ACTIONS(2084),
    [anon_sym_extractvalue] = ACTIONS(2084),
    [anon_sym_insertvalue] = ACTIONS(2084),
    [anon_sym_mul] = ACTIONS(2084),
    [anon_sym_urem] = ACTIONS(2084),
    [anon_sym_srem] = ACTIONS(2084),
    [anon_sym_shl] = ACTIONS(2084),
    [anon_sym_udiv] = ACTIONS(2084),
    [anon_sym_sdiv] = ACTIONS(2084),
    [anon_sym_lshr] = ACTIONS(2084),
    [anon_sym_ashr] = ACTIONS(2084),
    [anon_sym_fmul] = ACTIONS(2084),
    [anon_sym_fdiv] = ACTIONS(2084),
    [anon_sym_frem] = ACTIONS(2084),
    [anon_sym_xchg] = ACTIONS(2084),
    [anon_sym_add] = ACTIONS(2084),
    [anon_sym_sub] = ACTIONS(2084),
    [anon_sym_and] = ACTIONS(2084),
    [anon_sym_nand] = ACTIONS(2084),
    [anon_sym_or] = ACTIONS(2084),
    [anon_sym_xor] = ACTIONS(2084),
    [anon_sym_max] = ACTIONS(2084),
    [anon_sym_min] = ACTIONS(2084),
    [anon_sym_umax] = ACTIONS(2084),
    [anon_sym_umin] = ACTIONS(2084),
    [anon_sym_fadd] = ACTIONS(2084),
    [anon_sym_fsub] = ACTIONS(2084),
    [anon_sym_bitcast] = ACTIONS(2084),
    [anon_sym_trunc] = ACTIONS(2084),
    [anon_sym_zext] = ACTIONS(2084),
    [anon_sym_sext] = ACTIONS(2084),
    [anon_sym_fptrunc] = ACTIONS(2084),
    [anon_sym_fpext] = ACTIONS(2084),
    [anon_sym_addrspacecast] = ACTIONS(2084),
    [anon_sym_uitofp] = ACTIONS(2084),
    [anon_sym_sitofp] = ACTIONS(2084),
    [anon_sym_fptoui] = ACTIONS(2084),
    [anon_sym_fptosi] = ACTIONS(2084),
    [anon_sym_inttoptr] = ACTIONS(2084),
    [anon_sym_ptrtoint] = ACTIONS(2084),
    [anon_sym_uselistorder] = ACTIONS(2084),
  },
  [625] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2086),
    [sym_label] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_COMMA] = ACTIONS(2086),
    [anon_sym_unreachable] = ACTIONS(2088),
    [anon_sym_ret] = ACTIONS(2088),
    [anon_sym_br] = ACTIONS(2088),
    [anon_sym_resume] = ACTIONS(2088),
    [anon_sym_freeze] = ACTIONS(2088),
    [anon_sym_indirectbr] = ACTIONS(2088),
    [anon_sym_extractelement] = ACTIONS(2088),
    [anon_sym_insertelement] = ACTIONS(2088),
    [anon_sym_select] = ACTIONS(2088),
    [anon_sym_shufflevector] = ACTIONS(2088),
    [anon_sym_fneg] = ACTIONS(2088),
    [anon_sym_switch] = ACTIONS(2088),
    [anon_sym_invoke] = ACTIONS(2088),
    [anon_sym_cleanupret] = ACTIONS(2088),
    [anon_sym_catchret] = ACTIONS(2088),
    [anon_sym_catchswitch] = ACTIONS(2088),
    [anon_sym_catchpad] = ACTIONS(2088),
    [anon_sym_cleanuppad] = ACTIONS(2088),
    [anon_sym_callbr] = ACTIONS(2088),
    [anon_sym_icmp] = ACTIONS(2088),
    [anon_sym_fcmp] = ACTIONS(2088),
    [anon_sym_va_arg] = ACTIONS(2088),
    [anon_sym_phi] = ACTIONS(2088),
    [anon_sym_landingpad] = ACTIONS(2088),
    [anon_sym_tail] = ACTIONS(2088),
    [anon_sym_musttail] = ACTIONS(2088),
    [anon_sym_notail] = ACTIONS(2088),
    [anon_sym_call] = ACTIONS(2088),
    [anon_sym_alloca] = ACTIONS(2088),
    [anon_sym_load] = ACTIONS(2088),
    [anon_sym_store] = ACTIONS(2088),
    [anon_sym_cmpxchg] = ACTIONS(2088),
    [anon_sym_atomicrmw] = ACTIONS(2088),
    [anon_sym_fence] = ACTIONS(2088),
    [anon_sym_getelementptr] = ACTIONS(2088),
    [anon_sym_extractvalue] = ACTIONS(2088),
    [anon_sym_insertvalue] = ACTIONS(2088),
    [anon_sym_mul] = ACTIONS(2088),
    [anon_sym_urem] = ACTIONS(2088),
    [anon_sym_srem] = ACTIONS(2088),
    [anon_sym_shl] = ACTIONS(2088),
    [anon_sym_udiv] = ACTIONS(2088),
    [anon_sym_sdiv] = ACTIONS(2088),
    [anon_sym_lshr] = ACTIONS(2088),
    [anon_sym_ashr] = ACTIONS(2088),
    [anon_sym_fmul] = ACTIONS(2088),
    [anon_sym_fdiv] = ACTIONS(2088),
    [anon_sym_frem] = ACTIONS(2088),
    [anon_sym_xchg] = ACTIONS(2088),
    [anon_sym_add] = ACTIONS(2088),
    [anon_sym_sub] = ACTIONS(2088),
    [anon_sym_and] = ACTIONS(2088),
    [anon_sym_nand] = ACTIONS(2088),
    [anon_sym_or] = ACTIONS(2088),
    [anon_sym_xor] = ACTIONS(2088),
    [anon_sym_max] = ACTIONS(2088),
    [anon_sym_min] = ACTIONS(2088),
    [anon_sym_umax] = ACTIONS(2088),
    [anon_sym_umin] = ACTIONS(2088),
    [anon_sym_fadd] = ACTIONS(2088),
    [anon_sym_fsub] = ACTIONS(2088),
    [anon_sym_bitcast] = ACTIONS(2088),
    [anon_sym_trunc] = ACTIONS(2088),
    [anon_sym_zext] = ACTIONS(2088),
    [anon_sym_sext] = ACTIONS(2088),
    [anon_sym_fptrunc] = ACTIONS(2088),
    [anon_sym_fpext] = ACTIONS(2088),
    [anon_sym_addrspacecast] = ACTIONS(2088),
    [anon_sym_uitofp] = ACTIONS(2088),
    [anon_sym_sitofp] = ACTIONS(2088),
    [anon_sym_fptoui] = ACTIONS(2088),
    [anon_sym_fptosi] = ACTIONS(2088),
    [anon_sym_inttoptr] = ACTIONS(2088),
    [anon_sym_ptrtoint] = ACTIONS(2088),
    [anon_sym_uselistorder] = ACTIONS(2088),
  },
  [626] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2090),
    [sym_label] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_COMMA] = ACTIONS(2090),
    [anon_sym_unreachable] = ACTIONS(2092),
    [anon_sym_ret] = ACTIONS(2092),
    [anon_sym_br] = ACTIONS(2092),
    [anon_sym_resume] = ACTIONS(2092),
    [anon_sym_freeze] = ACTIONS(2092),
    [anon_sym_indirectbr] = ACTIONS(2092),
    [anon_sym_extractelement] = ACTIONS(2092),
    [anon_sym_insertelement] = ACTIONS(2092),
    [anon_sym_select] = ACTIONS(2092),
    [anon_sym_shufflevector] = ACTIONS(2092),
    [anon_sym_fneg] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(2092),
    [anon_sym_invoke] = ACTIONS(2092),
    [anon_sym_cleanupret] = ACTIONS(2092),
    [anon_sym_catchret] = ACTIONS(2092),
    [anon_sym_catchswitch] = ACTIONS(2092),
    [anon_sym_catchpad] = ACTIONS(2092),
    [anon_sym_cleanuppad] = ACTIONS(2092),
    [anon_sym_callbr] = ACTIONS(2092),
    [anon_sym_icmp] = ACTIONS(2092),
    [anon_sym_fcmp] = ACTIONS(2092),
    [anon_sym_va_arg] = ACTIONS(2092),
    [anon_sym_phi] = ACTIONS(2092),
    [anon_sym_landingpad] = ACTIONS(2092),
    [anon_sym_tail] = ACTIONS(2092),
    [anon_sym_musttail] = ACTIONS(2092),
    [anon_sym_notail] = ACTIONS(2092),
    [anon_sym_call] = ACTIONS(2092),
    [anon_sym_alloca] = ACTIONS(2092),
    [anon_sym_load] = ACTIONS(2092),
    [anon_sym_store] = ACTIONS(2092),
    [anon_sym_cmpxchg] = ACTIONS(2092),
    [anon_sym_atomicrmw] = ACTIONS(2092),
    [anon_sym_fence] = ACTIONS(2092),
    [anon_sym_getelementptr] = ACTIONS(2092),
    [anon_sym_extractvalue] = ACTIONS(2092),
    [anon_sym_insertvalue] = ACTIONS(2092),
    [anon_sym_mul] = ACTIONS(2092),
    [anon_sym_urem] = ACTIONS(2092),
    [anon_sym_srem] = ACTIONS(2092),
    [anon_sym_shl] = ACTIONS(2092),
    [anon_sym_udiv] = ACTIONS(2092),
    [anon_sym_sdiv] = ACTIONS(2092),
    [anon_sym_lshr] = ACTIONS(2092),
    [anon_sym_ashr] = ACTIONS(2092),
    [anon_sym_fmul] = ACTIONS(2092),
    [anon_sym_fdiv] = ACTIONS(2092),
    [anon_sym_frem] = ACTIONS(2092),
    [anon_sym_xchg] = ACTIONS(2092),
    [anon_sym_add] = ACTIONS(2092),
    [anon_sym_sub] = ACTIONS(2092),
    [anon_sym_and] = ACTIONS(2092),
    [anon_sym_nand] = ACTIONS(2092),
    [anon_sym_or] = ACTIONS(2092),
    [anon_sym_xor] = ACTIONS(2092),
    [anon_sym_max] = ACTIONS(2092),
    [anon_sym_min] = ACTIONS(2092),
    [anon_sym_umax] = ACTIONS(2092),
    [anon_sym_umin] = ACTIONS(2092),
    [anon_sym_fadd] = ACTIONS(2092),
    [anon_sym_fsub] = ACTIONS(2092),
    [anon_sym_bitcast] = ACTIONS(2092),
    [anon_sym_trunc] = ACTIONS(2092),
    [anon_sym_zext] = ACTIONS(2092),
    [anon_sym_sext] = ACTIONS(2092),
    [anon_sym_fptrunc] = ACTIONS(2092),
    [anon_sym_fpext] = ACTIONS(2092),
    [anon_sym_addrspacecast] = ACTIONS(2092),
    [anon_sym_uitofp] = ACTIONS(2092),
    [anon_sym_sitofp] = ACTIONS(2092),
    [anon_sym_fptoui] = ACTIONS(2092),
    [anon_sym_fptosi] = ACTIONS(2092),
    [anon_sym_inttoptr] = ACTIONS(2092),
    [anon_sym_ptrtoint] = ACTIONS(2092),
    [anon_sym_uselistorder] = ACTIONS(2092),
  },
  [627] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2094),
    [sym_label] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_COMMA] = ACTIONS(2094),
    [anon_sym_unreachable] = ACTIONS(2096),
    [anon_sym_ret] = ACTIONS(2096),
    [anon_sym_br] = ACTIONS(2096),
    [anon_sym_resume] = ACTIONS(2096),
    [anon_sym_freeze] = ACTIONS(2096),
    [anon_sym_indirectbr] = ACTIONS(2096),
    [anon_sym_extractelement] = ACTIONS(2096),
    [anon_sym_insertelement] = ACTIONS(2096),
    [anon_sym_select] = ACTIONS(2096),
    [anon_sym_shufflevector] = ACTIONS(2096),
    [anon_sym_fneg] = ACTIONS(2096),
    [anon_sym_switch] = ACTIONS(2096),
    [anon_sym_invoke] = ACTIONS(2096),
    [anon_sym_cleanupret] = ACTIONS(2096),
    [anon_sym_catchret] = ACTIONS(2096),
    [anon_sym_catchswitch] = ACTIONS(2096),
    [anon_sym_catchpad] = ACTIONS(2096),
    [anon_sym_cleanuppad] = ACTIONS(2096),
    [anon_sym_callbr] = ACTIONS(2096),
    [anon_sym_icmp] = ACTIONS(2096),
    [anon_sym_fcmp] = ACTIONS(2096),
    [anon_sym_va_arg] = ACTIONS(2096),
    [anon_sym_phi] = ACTIONS(2096),
    [anon_sym_landingpad] = ACTIONS(2096),
    [anon_sym_tail] = ACTIONS(2096),
    [anon_sym_musttail] = ACTIONS(2096),
    [anon_sym_notail] = ACTIONS(2096),
    [anon_sym_call] = ACTIONS(2096),
    [anon_sym_alloca] = ACTIONS(2096),
    [anon_sym_load] = ACTIONS(2096),
    [anon_sym_store] = ACTIONS(2096),
    [anon_sym_cmpxchg] = ACTIONS(2096),
    [anon_sym_atomicrmw] = ACTIONS(2096),
    [anon_sym_fence] = ACTIONS(2096),
    [anon_sym_getelementptr] = ACTIONS(2096),
    [anon_sym_extractvalue] = ACTIONS(2096),
    [anon_sym_insertvalue] = ACTIONS(2096),
    [anon_sym_mul] = ACTIONS(2096),
    [anon_sym_urem] = ACTIONS(2096),
    [anon_sym_srem] = ACTIONS(2096),
    [anon_sym_shl] = ACTIONS(2096),
    [anon_sym_udiv] = ACTIONS(2096),
    [anon_sym_sdiv] = ACTIONS(2096),
    [anon_sym_lshr] = ACTIONS(2096),
    [anon_sym_ashr] = ACTIONS(2096),
    [anon_sym_fmul] = ACTIONS(2096),
    [anon_sym_fdiv] = ACTIONS(2096),
    [anon_sym_frem] = ACTIONS(2096),
    [anon_sym_xchg] = ACTIONS(2096),
    [anon_sym_add] = ACTIONS(2096),
    [anon_sym_sub] = ACTIONS(2096),
    [anon_sym_and] = ACTIONS(2096),
    [anon_sym_nand] = ACTIONS(2096),
    [anon_sym_or] = ACTIONS(2096),
    [anon_sym_xor] = ACTIONS(2096),
    [anon_sym_max] = ACTIONS(2096),
    [anon_sym_min] = ACTIONS(2096),
    [anon_sym_umax] = ACTIONS(2096),
    [anon_sym_umin] = ACTIONS(2096),
    [anon_sym_fadd] = ACTIONS(2096),
    [anon_sym_fsub] = ACTIONS(2096),
    [anon_sym_bitcast] = ACTIONS(2096),
    [anon_sym_trunc] = ACTIONS(2096),
    [anon_sym_zext] = ACTIONS(2096),
    [anon_sym_sext] = ACTIONS(2096),
    [anon_sym_fptrunc] = ACTIONS(2096),
    [anon_sym_fpext] = ACTIONS(2096),
    [anon_sym_addrspacecast] = ACTIONS(2096),
    [anon_sym_uitofp] = ACTIONS(2096),
    [anon_sym_sitofp] = ACTIONS(2096),
    [anon_sym_fptoui] = ACTIONS(2096),
    [anon_sym_fptosi] = ACTIONS(2096),
    [anon_sym_inttoptr] = ACTIONS(2096),
    [anon_sym_ptrtoint] = ACTIONS(2096),
    [anon_sym_uselistorder] = ACTIONS(2096),
  },
  [628] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [sym_label] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_unreachable] = ACTIONS(719),
    [anon_sym_ret] = ACTIONS(719),
    [anon_sym_br] = ACTIONS(719),
    [anon_sym_resume] = ACTIONS(719),
    [anon_sym_freeze] = ACTIONS(719),
    [anon_sym_indirectbr] = ACTIONS(719),
    [anon_sym_extractelement] = ACTIONS(719),
    [anon_sym_insertelement] = ACTIONS(719),
    [anon_sym_select] = ACTIONS(719),
    [anon_sym_shufflevector] = ACTIONS(719),
    [anon_sym_fneg] = ACTIONS(719),
    [anon_sym_switch] = ACTIONS(719),
    [anon_sym_invoke] = ACTIONS(719),
    [anon_sym_cleanupret] = ACTIONS(719),
    [anon_sym_catchret] = ACTIONS(719),
    [anon_sym_catchswitch] = ACTIONS(719),
    [anon_sym_catchpad] = ACTIONS(719),
    [anon_sym_cleanuppad] = ACTIONS(719),
    [anon_sym_callbr] = ACTIONS(719),
    [anon_sym_icmp] = ACTIONS(719),
    [anon_sym_fcmp] = ACTIONS(719),
    [anon_sym_va_arg] = ACTIONS(719),
    [anon_sym_phi] = ACTIONS(719),
    [anon_sym_landingpad] = ACTIONS(719),
    [anon_sym_tail] = ACTIONS(719),
    [anon_sym_musttail] = ACTIONS(719),
    [anon_sym_notail] = ACTIONS(719),
    [anon_sym_call] = ACTIONS(719),
    [anon_sym_alloca] = ACTIONS(719),
    [anon_sym_load] = ACTIONS(719),
    [anon_sym_store] = ACTIONS(719),
    [anon_sym_cmpxchg] = ACTIONS(719),
    [anon_sym_atomicrmw] = ACTIONS(719),
    [anon_sym_fence] = ACTIONS(719),
    [anon_sym_getelementptr] = ACTIONS(719),
    [anon_sym_extractvalue] = ACTIONS(719),
    [anon_sym_insertvalue] = ACTIONS(719),
    [anon_sym_mul] = ACTIONS(719),
    [anon_sym_urem] = ACTIONS(719),
    [anon_sym_srem] = ACTIONS(719),
    [anon_sym_shl] = ACTIONS(719),
    [anon_sym_udiv] = ACTIONS(719),
    [anon_sym_sdiv] = ACTIONS(719),
    [anon_sym_lshr] = ACTIONS(719),
    [anon_sym_ashr] = ACTIONS(719),
    [anon_sym_fmul] = ACTIONS(719),
    [anon_sym_fdiv] = ACTIONS(719),
    [anon_sym_frem] = ACTIONS(719),
    [anon_sym_xchg] = ACTIONS(719),
    [anon_sym_add] = ACTIONS(719),
    [anon_sym_sub] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(719),
    [anon_sym_nand] = ACTIONS(719),
    [anon_sym_or] = ACTIONS(719),
    [anon_sym_xor] = ACTIONS(719),
    [anon_sym_max] = ACTIONS(719),
    [anon_sym_min] = ACTIONS(719),
    [anon_sym_umax] = ACTIONS(719),
    [anon_sym_umin] = ACTIONS(719),
    [anon_sym_fadd] = ACTIONS(719),
    [anon_sym_fsub] = ACTIONS(719),
    [anon_sym_bitcast] = ACTIONS(719),
    [anon_sym_trunc] = ACTIONS(719),
    [anon_sym_zext] = ACTIONS(719),
    [anon_sym_sext] = ACTIONS(719),
    [anon_sym_fptrunc] = ACTIONS(719),
    [anon_sym_fpext] = ACTIONS(719),
    [anon_sym_addrspacecast] = ACTIONS(719),
    [anon_sym_uitofp] = ACTIONS(719),
    [anon_sym_sitofp] = ACTIONS(719),
    [anon_sym_fptoui] = ACTIONS(719),
    [anon_sym_fptosi] = ACTIONS(719),
    [anon_sym_inttoptr] = ACTIONS(719),
    [anon_sym_ptrtoint] = ACTIONS(719),
    [anon_sym_uselistorder] = ACTIONS(719),
  },
  [629] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2098),
    [sym_label] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(2098),
    [anon_sym_unreachable] = ACTIONS(2100),
    [anon_sym_ret] = ACTIONS(2100),
    [anon_sym_br] = ACTIONS(2100),
    [anon_sym_resume] = ACTIONS(2100),
    [anon_sym_freeze] = ACTIONS(2100),
    [anon_sym_indirectbr] = ACTIONS(2100),
    [anon_sym_extractelement] = ACTIONS(2100),
    [anon_sym_insertelement] = ACTIONS(2100),
    [anon_sym_select] = ACTIONS(2100),
    [anon_sym_shufflevector] = ACTIONS(2100),
    [anon_sym_fneg] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_invoke] = ACTIONS(2100),
    [anon_sym_cleanupret] = ACTIONS(2100),
    [anon_sym_catchret] = ACTIONS(2100),
    [anon_sym_catchswitch] = ACTIONS(2100),
    [anon_sym_catchpad] = ACTIONS(2100),
    [anon_sym_cleanuppad] = ACTIONS(2100),
    [anon_sym_callbr] = ACTIONS(2100),
    [anon_sym_icmp] = ACTIONS(2100),
    [anon_sym_fcmp] = ACTIONS(2100),
    [anon_sym_va_arg] = ACTIONS(2100),
    [anon_sym_phi] = ACTIONS(2100),
    [anon_sym_landingpad] = ACTIONS(2100),
    [anon_sym_tail] = ACTIONS(2100),
    [anon_sym_musttail] = ACTIONS(2100),
    [anon_sym_notail] = ACTIONS(2100),
    [anon_sym_call] = ACTIONS(2100),
    [anon_sym_alloca] = ACTIONS(2100),
    [anon_sym_load] = ACTIONS(2100),
    [anon_sym_store] = ACTIONS(2100),
    [anon_sym_cmpxchg] = ACTIONS(2100),
    [anon_sym_atomicrmw] = ACTIONS(2100),
    [anon_sym_fence] = ACTIONS(2100),
    [anon_sym_getelementptr] = ACTIONS(2100),
    [anon_sym_extractvalue] = ACTIONS(2100),
    [anon_sym_insertvalue] = ACTIONS(2100),
    [anon_sym_mul] = ACTIONS(2100),
    [anon_sym_urem] = ACTIONS(2100),
    [anon_sym_srem] = ACTIONS(2100),
    [anon_sym_shl] = ACTIONS(2100),
    [anon_sym_udiv] = ACTIONS(2100),
    [anon_sym_sdiv] = ACTIONS(2100),
    [anon_sym_lshr] = ACTIONS(2100),
    [anon_sym_ashr] = ACTIONS(2100),
    [anon_sym_fmul] = ACTIONS(2100),
    [anon_sym_fdiv] = ACTIONS(2100),
    [anon_sym_frem] = ACTIONS(2100),
    [anon_sym_xchg] = ACTIONS(2100),
    [anon_sym_add] = ACTIONS(2100),
    [anon_sym_sub] = ACTIONS(2100),
    [anon_sym_and] = ACTIONS(2100),
    [anon_sym_nand] = ACTIONS(2100),
    [anon_sym_or] = ACTIONS(2100),
    [anon_sym_xor] = ACTIONS(2100),
    [anon_sym_max] = ACTIONS(2100),
    [anon_sym_min] = ACTIONS(2100),
    [anon_sym_umax] = ACTIONS(2100),
    [anon_sym_umin] = ACTIONS(2100),
    [anon_sym_fadd] = ACTIONS(2100),
    [anon_sym_fsub] = ACTIONS(2100),
    [anon_sym_bitcast] = ACTIONS(2100),
    [anon_sym_trunc] = ACTIONS(2100),
    [anon_sym_zext] = ACTIONS(2100),
    [anon_sym_sext] = ACTIONS(2100),
    [anon_sym_fptrunc] = ACTIONS(2100),
    [anon_sym_fpext] = ACTIONS(2100),
    [anon_sym_addrspacecast] = ACTIONS(2100),
    [anon_sym_uitofp] = ACTIONS(2100),
    [anon_sym_sitofp] = ACTIONS(2100),
    [anon_sym_fptoui] = ACTIONS(2100),
    [anon_sym_fptosi] = ACTIONS(2100),
    [anon_sym_inttoptr] = ACTIONS(2100),
    [anon_sym_ptrtoint] = ACTIONS(2100),
    [anon_sym_uselistorder] = ACTIONS(2100),
  },
  [630] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2102),
    [sym_label] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2102),
    [anon_sym_unreachable] = ACTIONS(2104),
    [anon_sym_ret] = ACTIONS(2104),
    [anon_sym_br] = ACTIONS(2104),
    [anon_sym_resume] = ACTIONS(2104),
    [anon_sym_freeze] = ACTIONS(2104),
    [anon_sym_indirectbr] = ACTIONS(2104),
    [anon_sym_extractelement] = ACTIONS(2104),
    [anon_sym_insertelement] = ACTIONS(2104),
    [anon_sym_select] = ACTIONS(2104),
    [anon_sym_shufflevector] = ACTIONS(2104),
    [anon_sym_fneg] = ACTIONS(2104),
    [anon_sym_switch] = ACTIONS(2104),
    [anon_sym_invoke] = ACTIONS(2104),
    [anon_sym_cleanupret] = ACTIONS(2104),
    [anon_sym_catchret] = ACTIONS(2104),
    [anon_sym_catchswitch] = ACTIONS(2104),
    [anon_sym_catchpad] = ACTIONS(2104),
    [anon_sym_cleanuppad] = ACTIONS(2104),
    [anon_sym_callbr] = ACTIONS(2104),
    [anon_sym_icmp] = ACTIONS(2104),
    [anon_sym_fcmp] = ACTIONS(2104),
    [anon_sym_va_arg] = ACTIONS(2104),
    [anon_sym_phi] = ACTIONS(2104),
    [anon_sym_landingpad] = ACTIONS(2104),
    [anon_sym_tail] = ACTIONS(2104),
    [anon_sym_musttail] = ACTIONS(2104),
    [anon_sym_notail] = ACTIONS(2104),
    [anon_sym_call] = ACTIONS(2104),
    [anon_sym_alloca] = ACTIONS(2104),
    [anon_sym_load] = ACTIONS(2104),
    [anon_sym_store] = ACTIONS(2104),
    [anon_sym_cmpxchg] = ACTIONS(2104),
    [anon_sym_atomicrmw] = ACTIONS(2104),
    [anon_sym_fence] = ACTIONS(2104),
    [anon_sym_getelementptr] = ACTIONS(2104),
    [anon_sym_extractvalue] = ACTIONS(2104),
    [anon_sym_insertvalue] = ACTIONS(2104),
    [anon_sym_mul] = ACTIONS(2104),
    [anon_sym_urem] = ACTIONS(2104),
    [anon_sym_srem] = ACTIONS(2104),
    [anon_sym_shl] = ACTIONS(2104),
    [anon_sym_udiv] = ACTIONS(2104),
    [anon_sym_sdiv] = ACTIONS(2104),
    [anon_sym_lshr] = ACTIONS(2104),
    [anon_sym_ashr] = ACTIONS(2104),
    [anon_sym_fmul] = ACTIONS(2104),
    [anon_sym_fdiv] = ACTIONS(2104),
    [anon_sym_frem] = ACTIONS(2104),
    [anon_sym_xchg] = ACTIONS(2104),
    [anon_sym_add] = ACTIONS(2104),
    [anon_sym_sub] = ACTIONS(2104),
    [anon_sym_and] = ACTIONS(2104),
    [anon_sym_nand] = ACTIONS(2104),
    [anon_sym_or] = ACTIONS(2104),
    [anon_sym_xor] = ACTIONS(2104),
    [anon_sym_max] = ACTIONS(2104),
    [anon_sym_min] = ACTIONS(2104),
    [anon_sym_umax] = ACTIONS(2104),
    [anon_sym_umin] = ACTIONS(2104),
    [anon_sym_fadd] = ACTIONS(2104),
    [anon_sym_fsub] = ACTIONS(2104),
    [anon_sym_bitcast] = ACTIONS(2104),
    [anon_sym_trunc] = ACTIONS(2104),
    [anon_sym_zext] = ACTIONS(2104),
    [anon_sym_sext] = ACTIONS(2104),
    [anon_sym_fptrunc] = ACTIONS(2104),
    [anon_sym_fpext] = ACTIONS(2104),
    [anon_sym_addrspacecast] = ACTIONS(2104),
    [anon_sym_uitofp] = ACTIONS(2104),
    [anon_sym_sitofp] = ACTIONS(2104),
    [anon_sym_fptoui] = ACTIONS(2104),
    [anon_sym_fptosi] = ACTIONS(2104),
    [anon_sym_inttoptr] = ACTIONS(2104),
    [anon_sym_ptrtoint] = ACTIONS(2104),
    [anon_sym_uselistorder] = ACTIONS(2104),
  },
  [631] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2106),
    [sym_label] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_COMMA] = ACTIONS(2106),
    [anon_sym_unreachable] = ACTIONS(2108),
    [anon_sym_ret] = ACTIONS(2108),
    [anon_sym_br] = ACTIONS(2108),
    [anon_sym_resume] = ACTIONS(2108),
    [anon_sym_freeze] = ACTIONS(2108),
    [anon_sym_indirectbr] = ACTIONS(2108),
    [anon_sym_extractelement] = ACTIONS(2108),
    [anon_sym_insertelement] = ACTIONS(2108),
    [anon_sym_select] = ACTIONS(2108),
    [anon_sym_shufflevector] = ACTIONS(2108),
    [anon_sym_fneg] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_invoke] = ACTIONS(2108),
    [anon_sym_cleanupret] = ACTIONS(2108),
    [anon_sym_catchret] = ACTIONS(2108),
    [anon_sym_catchswitch] = ACTIONS(2108),
    [anon_sym_catchpad] = ACTIONS(2108),
    [anon_sym_cleanuppad] = ACTIONS(2108),
    [anon_sym_callbr] = ACTIONS(2108),
    [anon_sym_icmp] = ACTIONS(2108),
    [anon_sym_fcmp] = ACTIONS(2108),
    [anon_sym_va_arg] = ACTIONS(2108),
    [anon_sym_phi] = ACTIONS(2108),
    [anon_sym_landingpad] = ACTIONS(2108),
    [anon_sym_tail] = ACTIONS(2108),
    [anon_sym_musttail] = ACTIONS(2108),
    [anon_sym_notail] = ACTIONS(2108),
    [anon_sym_call] = ACTIONS(2108),
    [anon_sym_alloca] = ACTIONS(2108),
    [anon_sym_load] = ACTIONS(2108),
    [anon_sym_store] = ACTIONS(2108),
    [anon_sym_cmpxchg] = ACTIONS(2108),
    [anon_sym_atomicrmw] = ACTIONS(2108),
    [anon_sym_fence] = ACTIONS(2108),
    [anon_sym_getelementptr] = ACTIONS(2108),
    [anon_sym_extractvalue] = ACTIONS(2108),
    [anon_sym_insertvalue] = ACTIONS(2108),
    [anon_sym_mul] = ACTIONS(2108),
    [anon_sym_urem] = ACTIONS(2108),
    [anon_sym_srem] = ACTIONS(2108),
    [anon_sym_shl] = ACTIONS(2108),
    [anon_sym_udiv] = ACTIONS(2108),
    [anon_sym_sdiv] = ACTIONS(2108),
    [anon_sym_lshr] = ACTIONS(2108),
    [anon_sym_ashr] = ACTIONS(2108),
    [anon_sym_fmul] = ACTIONS(2108),
    [anon_sym_fdiv] = ACTIONS(2108),
    [anon_sym_frem] = ACTIONS(2108),
    [anon_sym_xchg] = ACTIONS(2108),
    [anon_sym_add] = ACTIONS(2108),
    [anon_sym_sub] = ACTIONS(2108),
    [anon_sym_and] = ACTIONS(2108),
    [anon_sym_nand] = ACTIONS(2108),
    [anon_sym_or] = ACTIONS(2108),
    [anon_sym_xor] = ACTIONS(2108),
    [anon_sym_max] = ACTIONS(2108),
    [anon_sym_min] = ACTIONS(2108),
    [anon_sym_umax] = ACTIONS(2108),
    [anon_sym_umin] = ACTIONS(2108),
    [anon_sym_fadd] = ACTIONS(2108),
    [anon_sym_fsub] = ACTIONS(2108),
    [anon_sym_bitcast] = ACTIONS(2108),
    [anon_sym_trunc] = ACTIONS(2108),
    [anon_sym_zext] = ACTIONS(2108),
    [anon_sym_sext] = ACTIONS(2108),
    [anon_sym_fptrunc] = ACTIONS(2108),
    [anon_sym_fpext] = ACTIONS(2108),
    [anon_sym_addrspacecast] = ACTIONS(2108),
    [anon_sym_uitofp] = ACTIONS(2108),
    [anon_sym_sitofp] = ACTIONS(2108),
    [anon_sym_fptoui] = ACTIONS(2108),
    [anon_sym_fptosi] = ACTIONS(2108),
    [anon_sym_inttoptr] = ACTIONS(2108),
    [anon_sym_ptrtoint] = ACTIONS(2108),
    [anon_sym_uselistorder] = ACTIONS(2108),
  },
  [632] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2110),
    [sym_label] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_COMMA] = ACTIONS(2110),
    [anon_sym_unreachable] = ACTIONS(2112),
    [anon_sym_ret] = ACTIONS(2112),
    [anon_sym_br] = ACTIONS(2112),
    [anon_sym_resume] = ACTIONS(2112),
    [anon_sym_freeze] = ACTIONS(2112),
    [anon_sym_indirectbr] = ACTIONS(2112),
    [anon_sym_extractelement] = ACTIONS(2112),
    [anon_sym_insertelement] = ACTIONS(2112),
    [anon_sym_select] = ACTIONS(2112),
    [anon_sym_shufflevector] = ACTIONS(2112),
    [anon_sym_fneg] = ACTIONS(2112),
    [anon_sym_switch] = ACTIONS(2112),
    [anon_sym_invoke] = ACTIONS(2112),
    [anon_sym_cleanupret] = ACTIONS(2112),
    [anon_sym_catchret] = ACTIONS(2112),
    [anon_sym_catchswitch] = ACTIONS(2112),
    [anon_sym_catchpad] = ACTIONS(2112),
    [anon_sym_cleanuppad] = ACTIONS(2112),
    [anon_sym_callbr] = ACTIONS(2112),
    [anon_sym_icmp] = ACTIONS(2112),
    [anon_sym_fcmp] = ACTIONS(2112),
    [anon_sym_va_arg] = ACTIONS(2112),
    [anon_sym_phi] = ACTIONS(2112),
    [anon_sym_landingpad] = ACTIONS(2112),
    [anon_sym_tail] = ACTIONS(2112),
    [anon_sym_musttail] = ACTIONS(2112),
    [anon_sym_notail] = ACTIONS(2112),
    [anon_sym_call] = ACTIONS(2112),
    [anon_sym_alloca] = ACTIONS(2112),
    [anon_sym_load] = ACTIONS(2112),
    [anon_sym_store] = ACTIONS(2112),
    [anon_sym_cmpxchg] = ACTIONS(2112),
    [anon_sym_atomicrmw] = ACTIONS(2112),
    [anon_sym_fence] = ACTIONS(2112),
    [anon_sym_getelementptr] = ACTIONS(2112),
    [anon_sym_extractvalue] = ACTIONS(2112),
    [anon_sym_insertvalue] = ACTIONS(2112),
    [anon_sym_mul] = ACTIONS(2112),
    [anon_sym_urem] = ACTIONS(2112),
    [anon_sym_srem] = ACTIONS(2112),
    [anon_sym_shl] = ACTIONS(2112),
    [anon_sym_udiv] = ACTIONS(2112),
    [anon_sym_sdiv] = ACTIONS(2112),
    [anon_sym_lshr] = ACTIONS(2112),
    [anon_sym_ashr] = ACTIONS(2112),
    [anon_sym_fmul] = ACTIONS(2112),
    [anon_sym_fdiv] = ACTIONS(2112),
    [anon_sym_frem] = ACTIONS(2112),
    [anon_sym_xchg] = ACTIONS(2112),
    [anon_sym_add] = ACTIONS(2112),
    [anon_sym_sub] = ACTIONS(2112),
    [anon_sym_and] = ACTIONS(2112),
    [anon_sym_nand] = ACTIONS(2112),
    [anon_sym_or] = ACTIONS(2112),
    [anon_sym_xor] = ACTIONS(2112),
    [anon_sym_max] = ACTIONS(2112),
    [anon_sym_min] = ACTIONS(2112),
    [anon_sym_umax] = ACTIONS(2112),
    [anon_sym_umin] = ACTIONS(2112),
    [anon_sym_fadd] = ACTIONS(2112),
    [anon_sym_fsub] = ACTIONS(2112),
    [anon_sym_bitcast] = ACTIONS(2112),
    [anon_sym_trunc] = ACTIONS(2112),
    [anon_sym_zext] = ACTIONS(2112),
    [anon_sym_sext] = ACTIONS(2112),
    [anon_sym_fptrunc] = ACTIONS(2112),
    [anon_sym_fpext] = ACTIONS(2112),
    [anon_sym_addrspacecast] = ACTIONS(2112),
    [anon_sym_uitofp] = ACTIONS(2112),
    [anon_sym_sitofp] = ACTIONS(2112),
    [anon_sym_fptoui] = ACTIONS(2112),
    [anon_sym_fptosi] = ACTIONS(2112),
    [anon_sym_inttoptr] = ACTIONS(2112),
    [anon_sym_ptrtoint] = ACTIONS(2112),
    [anon_sym_uselistorder] = ACTIONS(2112),
  },
  [633] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2114),
    [sym_label] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_COMMA] = ACTIONS(2114),
    [anon_sym_unreachable] = ACTIONS(2116),
    [anon_sym_ret] = ACTIONS(2116),
    [anon_sym_br] = ACTIONS(2116),
    [anon_sym_resume] = ACTIONS(2116),
    [anon_sym_freeze] = ACTIONS(2116),
    [anon_sym_indirectbr] = ACTIONS(2116),
    [anon_sym_extractelement] = ACTIONS(2116),
    [anon_sym_insertelement] = ACTIONS(2116),
    [anon_sym_select] = ACTIONS(2116),
    [anon_sym_shufflevector] = ACTIONS(2116),
    [anon_sym_fneg] = ACTIONS(2116),
    [anon_sym_switch] = ACTIONS(2116),
    [anon_sym_invoke] = ACTIONS(2116),
    [anon_sym_cleanupret] = ACTIONS(2116),
    [anon_sym_catchret] = ACTIONS(2116),
    [anon_sym_catchswitch] = ACTIONS(2116),
    [anon_sym_catchpad] = ACTIONS(2116),
    [anon_sym_cleanuppad] = ACTIONS(2116),
    [anon_sym_callbr] = ACTIONS(2116),
    [anon_sym_icmp] = ACTIONS(2116),
    [anon_sym_fcmp] = ACTIONS(2116),
    [anon_sym_va_arg] = ACTIONS(2116),
    [anon_sym_phi] = ACTIONS(2116),
    [anon_sym_landingpad] = ACTIONS(2116),
    [anon_sym_tail] = ACTIONS(2116),
    [anon_sym_musttail] = ACTIONS(2116),
    [anon_sym_notail] = ACTIONS(2116),
    [anon_sym_call] = ACTIONS(2116),
    [anon_sym_alloca] = ACTIONS(2116),
    [anon_sym_load] = ACTIONS(2116),
    [anon_sym_store] = ACTIONS(2116),
    [anon_sym_cmpxchg] = ACTIONS(2116),
    [anon_sym_atomicrmw] = ACTIONS(2116),
    [anon_sym_fence] = ACTIONS(2116),
    [anon_sym_getelementptr] = ACTIONS(2116),
    [anon_sym_extractvalue] = ACTIONS(2116),
    [anon_sym_insertvalue] = ACTIONS(2116),
    [anon_sym_mul] = ACTIONS(2116),
    [anon_sym_urem] = ACTIONS(2116),
    [anon_sym_srem] = ACTIONS(2116),
    [anon_sym_shl] = ACTIONS(2116),
    [anon_sym_udiv] = ACTIONS(2116),
    [anon_sym_sdiv] = ACTIONS(2116),
    [anon_sym_lshr] = ACTIONS(2116),
    [anon_sym_ashr] = ACTIONS(2116),
    [anon_sym_fmul] = ACTIONS(2116),
    [anon_sym_fdiv] = ACTIONS(2116),
    [anon_sym_frem] = ACTIONS(2116),
    [anon_sym_xchg] = ACTIONS(2116),
    [anon_sym_add] = ACTIONS(2116),
    [anon_sym_sub] = ACTIONS(2116),
    [anon_sym_and] = ACTIONS(2116),
    [anon_sym_nand] = ACTIONS(2116),
    [anon_sym_or] = ACTIONS(2116),
    [anon_sym_xor] = ACTIONS(2116),
    [anon_sym_max] = ACTIONS(2116),
    [anon_sym_min] = ACTIONS(2116),
    [anon_sym_umax] = ACTIONS(2116),
    [anon_sym_umin] = ACTIONS(2116),
    [anon_sym_fadd] = ACTIONS(2116),
    [anon_sym_fsub] = ACTIONS(2116),
    [anon_sym_bitcast] = ACTIONS(2116),
    [anon_sym_trunc] = ACTIONS(2116),
    [anon_sym_zext] = ACTIONS(2116),
    [anon_sym_sext] = ACTIONS(2116),
    [anon_sym_fptrunc] = ACTIONS(2116),
    [anon_sym_fpext] = ACTIONS(2116),
    [anon_sym_addrspacecast] = ACTIONS(2116),
    [anon_sym_uitofp] = ACTIONS(2116),
    [anon_sym_sitofp] = ACTIONS(2116),
    [anon_sym_fptoui] = ACTIONS(2116),
    [anon_sym_fptosi] = ACTIONS(2116),
    [anon_sym_inttoptr] = ACTIONS(2116),
    [anon_sym_ptrtoint] = ACTIONS(2116),
    [anon_sym_uselistorder] = ACTIONS(2116),
  },
  [634] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2118),
    [sym_label] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_COMMA] = ACTIONS(2118),
    [anon_sym_unreachable] = ACTIONS(2120),
    [anon_sym_ret] = ACTIONS(2120),
    [anon_sym_br] = ACTIONS(2120),
    [anon_sym_resume] = ACTIONS(2120),
    [anon_sym_freeze] = ACTIONS(2120),
    [anon_sym_indirectbr] = ACTIONS(2120),
    [anon_sym_extractelement] = ACTIONS(2120),
    [anon_sym_insertelement] = ACTIONS(2120),
    [anon_sym_select] = ACTIONS(2120),
    [anon_sym_shufflevector] = ACTIONS(2120),
    [anon_sym_fneg] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_invoke] = ACTIONS(2120),
    [anon_sym_cleanupret] = ACTIONS(2120),
    [anon_sym_catchret] = ACTIONS(2120),
    [anon_sym_catchswitch] = ACTIONS(2120),
    [anon_sym_catchpad] = ACTIONS(2120),
    [anon_sym_cleanuppad] = ACTIONS(2120),
    [anon_sym_callbr] = ACTIONS(2120),
    [anon_sym_icmp] = ACTIONS(2120),
    [anon_sym_fcmp] = ACTIONS(2120),
    [anon_sym_va_arg] = ACTIONS(2120),
    [anon_sym_phi] = ACTIONS(2120),
    [anon_sym_landingpad] = ACTIONS(2120),
    [anon_sym_tail] = ACTIONS(2120),
    [anon_sym_musttail] = ACTIONS(2120),
    [anon_sym_notail] = ACTIONS(2120),
    [anon_sym_call] = ACTIONS(2120),
    [anon_sym_alloca] = ACTIONS(2120),
    [anon_sym_load] = ACTIONS(2120),
    [anon_sym_store] = ACTIONS(2120),
    [anon_sym_cmpxchg] = ACTIONS(2120),
    [anon_sym_atomicrmw] = ACTIONS(2120),
    [anon_sym_fence] = ACTIONS(2120),
    [anon_sym_getelementptr] = ACTIONS(2120),
    [anon_sym_extractvalue] = ACTIONS(2120),
    [anon_sym_insertvalue] = ACTIONS(2120),
    [anon_sym_mul] = ACTIONS(2120),
    [anon_sym_urem] = ACTIONS(2120),
    [anon_sym_srem] = ACTIONS(2120),
    [anon_sym_shl] = ACTIONS(2120),
    [anon_sym_udiv] = ACTIONS(2120),
    [anon_sym_sdiv] = ACTIONS(2120),
    [anon_sym_lshr] = ACTIONS(2120),
    [anon_sym_ashr] = ACTIONS(2120),
    [anon_sym_fmul] = ACTIONS(2120),
    [anon_sym_fdiv] = ACTIONS(2120),
    [anon_sym_frem] = ACTIONS(2120),
    [anon_sym_xchg] = ACTIONS(2120),
    [anon_sym_add] = ACTIONS(2120),
    [anon_sym_sub] = ACTIONS(2120),
    [anon_sym_and] = ACTIONS(2120),
    [anon_sym_nand] = ACTIONS(2120),
    [anon_sym_or] = ACTIONS(2120),
    [anon_sym_xor] = ACTIONS(2120),
    [anon_sym_max] = ACTIONS(2120),
    [anon_sym_min] = ACTIONS(2120),
    [anon_sym_umax] = ACTIONS(2120),
    [anon_sym_umin] = ACTIONS(2120),
    [anon_sym_fadd] = ACTIONS(2120),
    [anon_sym_fsub] = ACTIONS(2120),
    [anon_sym_bitcast] = ACTIONS(2120),
    [anon_sym_trunc] = ACTIONS(2120),
    [anon_sym_zext] = ACTIONS(2120),
    [anon_sym_sext] = ACTIONS(2120),
    [anon_sym_fptrunc] = ACTIONS(2120),
    [anon_sym_fpext] = ACTIONS(2120),
    [anon_sym_addrspacecast] = ACTIONS(2120),
    [anon_sym_uitofp] = ACTIONS(2120),
    [anon_sym_sitofp] = ACTIONS(2120),
    [anon_sym_fptoui] = ACTIONS(2120),
    [anon_sym_fptosi] = ACTIONS(2120),
    [anon_sym_inttoptr] = ACTIONS(2120),
    [anon_sym_ptrtoint] = ACTIONS(2120),
    [anon_sym_uselistorder] = ACTIONS(2120),
  },
  [635] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2122),
    [sym_label] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_COMMA] = ACTIONS(2122),
    [anon_sym_unreachable] = ACTIONS(2124),
    [anon_sym_ret] = ACTIONS(2124),
    [anon_sym_br] = ACTIONS(2124),
    [anon_sym_resume] = ACTIONS(2124),
    [anon_sym_freeze] = ACTIONS(2124),
    [anon_sym_indirectbr] = ACTIONS(2124),
    [anon_sym_extractelement] = ACTIONS(2124),
    [anon_sym_insertelement] = ACTIONS(2124),
    [anon_sym_select] = ACTIONS(2124),
    [anon_sym_shufflevector] = ACTIONS(2124),
    [anon_sym_fneg] = ACTIONS(2124),
    [anon_sym_switch] = ACTIONS(2124),
    [anon_sym_invoke] = ACTIONS(2124),
    [anon_sym_cleanupret] = ACTIONS(2124),
    [anon_sym_catchret] = ACTIONS(2124),
    [anon_sym_catchswitch] = ACTIONS(2124),
    [anon_sym_catchpad] = ACTIONS(2124),
    [anon_sym_cleanuppad] = ACTIONS(2124),
    [anon_sym_callbr] = ACTIONS(2124),
    [anon_sym_icmp] = ACTIONS(2124),
    [anon_sym_fcmp] = ACTIONS(2124),
    [anon_sym_va_arg] = ACTIONS(2124),
    [anon_sym_phi] = ACTIONS(2124),
    [anon_sym_landingpad] = ACTIONS(2124),
    [anon_sym_tail] = ACTIONS(2124),
    [anon_sym_musttail] = ACTIONS(2124),
    [anon_sym_notail] = ACTIONS(2124),
    [anon_sym_call] = ACTIONS(2124),
    [anon_sym_alloca] = ACTIONS(2124),
    [anon_sym_load] = ACTIONS(2124),
    [anon_sym_store] = ACTIONS(2124),
    [anon_sym_cmpxchg] = ACTIONS(2124),
    [anon_sym_atomicrmw] = ACTIONS(2124),
    [anon_sym_fence] = ACTIONS(2124),
    [anon_sym_getelementptr] = ACTIONS(2124),
    [anon_sym_extractvalue] = ACTIONS(2124),
    [anon_sym_insertvalue] = ACTIONS(2124),
    [anon_sym_mul] = ACTIONS(2124),
    [anon_sym_urem] = ACTIONS(2124),
    [anon_sym_srem] = ACTIONS(2124),
    [anon_sym_shl] = ACTIONS(2124),
    [anon_sym_udiv] = ACTIONS(2124),
    [anon_sym_sdiv] = ACTIONS(2124),
    [anon_sym_lshr] = ACTIONS(2124),
    [anon_sym_ashr] = ACTIONS(2124),
    [anon_sym_fmul] = ACTIONS(2124),
    [anon_sym_fdiv] = ACTIONS(2124),
    [anon_sym_frem] = ACTIONS(2124),
    [anon_sym_xchg] = ACTIONS(2124),
    [anon_sym_add] = ACTIONS(2124),
    [anon_sym_sub] = ACTIONS(2124),
    [anon_sym_and] = ACTIONS(2124),
    [anon_sym_nand] = ACTIONS(2124),
    [anon_sym_or] = ACTIONS(2124),
    [anon_sym_xor] = ACTIONS(2124),
    [anon_sym_max] = ACTIONS(2124),
    [anon_sym_min] = ACTIONS(2124),
    [anon_sym_umax] = ACTIONS(2124),
    [anon_sym_umin] = ACTIONS(2124),
    [anon_sym_fadd] = ACTIONS(2124),
    [anon_sym_fsub] = ACTIONS(2124),
    [anon_sym_bitcast] = ACTIONS(2124),
    [anon_sym_trunc] = ACTIONS(2124),
    [anon_sym_zext] = ACTIONS(2124),
    [anon_sym_sext] = ACTIONS(2124),
    [anon_sym_fptrunc] = ACTIONS(2124),
    [anon_sym_fpext] = ACTIONS(2124),
    [anon_sym_addrspacecast] = ACTIONS(2124),
    [anon_sym_uitofp] = ACTIONS(2124),
    [anon_sym_sitofp] = ACTIONS(2124),
    [anon_sym_fptoui] = ACTIONS(2124),
    [anon_sym_fptosi] = ACTIONS(2124),
    [anon_sym_inttoptr] = ACTIONS(2124),
    [anon_sym_ptrtoint] = ACTIONS(2124),
    [anon_sym_uselistorder] = ACTIONS(2124),
  },
  [636] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2126),
    [sym_label] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_unreachable] = ACTIONS(2128),
    [anon_sym_ret] = ACTIONS(2128),
    [anon_sym_br] = ACTIONS(2128),
    [anon_sym_resume] = ACTIONS(2128),
    [anon_sym_freeze] = ACTIONS(2128),
    [anon_sym_indirectbr] = ACTIONS(2128),
    [anon_sym_extractelement] = ACTIONS(2128),
    [anon_sym_insertelement] = ACTIONS(2128),
    [anon_sym_select] = ACTIONS(2128),
    [anon_sym_shufflevector] = ACTIONS(2128),
    [anon_sym_fneg] = ACTIONS(2128),
    [anon_sym_switch] = ACTIONS(2128),
    [anon_sym_invoke] = ACTIONS(2128),
    [anon_sym_cleanupret] = ACTIONS(2128),
    [anon_sym_catchret] = ACTIONS(2128),
    [anon_sym_catchswitch] = ACTIONS(2128),
    [anon_sym_catchpad] = ACTIONS(2128),
    [anon_sym_cleanuppad] = ACTIONS(2128),
    [anon_sym_callbr] = ACTIONS(2128),
    [anon_sym_icmp] = ACTIONS(2128),
    [anon_sym_fcmp] = ACTIONS(2128),
    [anon_sym_va_arg] = ACTIONS(2128),
    [anon_sym_phi] = ACTIONS(2128),
    [anon_sym_landingpad] = ACTIONS(2128),
    [anon_sym_tail] = ACTIONS(2128),
    [anon_sym_musttail] = ACTIONS(2128),
    [anon_sym_notail] = ACTIONS(2128),
    [anon_sym_call] = ACTIONS(2128),
    [anon_sym_alloca] = ACTIONS(2128),
    [anon_sym_load] = ACTIONS(2128),
    [anon_sym_store] = ACTIONS(2128),
    [anon_sym_cmpxchg] = ACTIONS(2128),
    [anon_sym_atomicrmw] = ACTIONS(2128),
    [anon_sym_fence] = ACTIONS(2128),
    [anon_sym_getelementptr] = ACTIONS(2128),
    [anon_sym_extractvalue] = ACTIONS(2128),
    [anon_sym_insertvalue] = ACTIONS(2128),
    [anon_sym_mul] = ACTIONS(2128),
    [anon_sym_urem] = ACTIONS(2128),
    [anon_sym_srem] = ACTIONS(2128),
    [anon_sym_shl] = ACTIONS(2128),
    [anon_sym_udiv] = ACTIONS(2128),
    [anon_sym_sdiv] = ACTIONS(2128),
    [anon_sym_lshr] = ACTIONS(2128),
    [anon_sym_ashr] = ACTIONS(2128),
    [anon_sym_fmul] = ACTIONS(2128),
    [anon_sym_fdiv] = ACTIONS(2128),
    [anon_sym_frem] = ACTIONS(2128),
    [anon_sym_xchg] = ACTIONS(2128),
    [anon_sym_add] = ACTIONS(2128),
    [anon_sym_sub] = ACTIONS(2128),
    [anon_sym_and] = ACTIONS(2128),
    [anon_sym_nand] = ACTIONS(2128),
    [anon_sym_or] = ACTIONS(2128),
    [anon_sym_xor] = ACTIONS(2128),
    [anon_sym_max] = ACTIONS(2128),
    [anon_sym_min] = ACTIONS(2128),
    [anon_sym_umax] = ACTIONS(2128),
    [anon_sym_umin] = ACTIONS(2128),
    [anon_sym_fadd] = ACTIONS(2128),
    [anon_sym_fsub] = ACTIONS(2128),
    [anon_sym_bitcast] = ACTIONS(2128),
    [anon_sym_trunc] = ACTIONS(2128),
    [anon_sym_zext] = ACTIONS(2128),
    [anon_sym_sext] = ACTIONS(2128),
    [anon_sym_fptrunc] = ACTIONS(2128),
    [anon_sym_fpext] = ACTIONS(2128),
    [anon_sym_addrspacecast] = ACTIONS(2128),
    [anon_sym_uitofp] = ACTIONS(2128),
    [anon_sym_sitofp] = ACTIONS(2128),
    [anon_sym_fptoui] = ACTIONS(2128),
    [anon_sym_fptosi] = ACTIONS(2128),
    [anon_sym_inttoptr] = ACTIONS(2128),
    [anon_sym_ptrtoint] = ACTIONS(2128),
    [anon_sym_uselistorder] = ACTIONS(2128),
  },
  [637] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2130),
    [sym_label] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_unreachable] = ACTIONS(2132),
    [anon_sym_ret] = ACTIONS(2132),
    [anon_sym_br] = ACTIONS(2132),
    [anon_sym_resume] = ACTIONS(2132),
    [anon_sym_freeze] = ACTIONS(2132),
    [anon_sym_indirectbr] = ACTIONS(2132),
    [anon_sym_extractelement] = ACTIONS(2132),
    [anon_sym_insertelement] = ACTIONS(2132),
    [anon_sym_select] = ACTIONS(2132),
    [anon_sym_shufflevector] = ACTIONS(2132),
    [anon_sym_fneg] = ACTIONS(2132),
    [anon_sym_switch] = ACTIONS(2132),
    [anon_sym_invoke] = ACTIONS(2132),
    [anon_sym_cleanupret] = ACTIONS(2132),
    [anon_sym_catchret] = ACTIONS(2132),
    [anon_sym_catchswitch] = ACTIONS(2132),
    [anon_sym_catchpad] = ACTIONS(2132),
    [anon_sym_cleanuppad] = ACTIONS(2132),
    [anon_sym_callbr] = ACTIONS(2132),
    [anon_sym_icmp] = ACTIONS(2132),
    [anon_sym_fcmp] = ACTIONS(2132),
    [anon_sym_va_arg] = ACTIONS(2132),
    [anon_sym_phi] = ACTIONS(2132),
    [anon_sym_landingpad] = ACTIONS(2132),
    [anon_sym_tail] = ACTIONS(2132),
    [anon_sym_musttail] = ACTIONS(2132),
    [anon_sym_notail] = ACTIONS(2132),
    [anon_sym_call] = ACTIONS(2132),
    [anon_sym_alloca] = ACTIONS(2132),
    [anon_sym_load] = ACTIONS(2132),
    [anon_sym_store] = ACTIONS(2132),
    [anon_sym_cmpxchg] = ACTIONS(2132),
    [anon_sym_atomicrmw] = ACTIONS(2132),
    [anon_sym_fence] = ACTIONS(2132),
    [anon_sym_getelementptr] = ACTIONS(2132),
    [anon_sym_extractvalue] = ACTIONS(2132),
    [anon_sym_insertvalue] = ACTIONS(2132),
    [anon_sym_mul] = ACTIONS(2132),
    [anon_sym_urem] = ACTIONS(2132),
    [anon_sym_srem] = ACTIONS(2132),
    [anon_sym_shl] = ACTIONS(2132),
    [anon_sym_udiv] = ACTIONS(2132),
    [anon_sym_sdiv] = ACTIONS(2132),
    [anon_sym_lshr] = ACTIONS(2132),
    [anon_sym_ashr] = ACTIONS(2132),
    [anon_sym_fmul] = ACTIONS(2132),
    [anon_sym_fdiv] = ACTIONS(2132),
    [anon_sym_frem] = ACTIONS(2132),
    [anon_sym_xchg] = ACTIONS(2132),
    [anon_sym_add] = ACTIONS(2132),
    [anon_sym_sub] = ACTIONS(2132),
    [anon_sym_and] = ACTIONS(2132),
    [anon_sym_nand] = ACTIONS(2132),
    [anon_sym_or] = ACTIONS(2132),
    [anon_sym_xor] = ACTIONS(2132),
    [anon_sym_max] = ACTIONS(2132),
    [anon_sym_min] = ACTIONS(2132),
    [anon_sym_umax] = ACTIONS(2132),
    [anon_sym_umin] = ACTIONS(2132),
    [anon_sym_fadd] = ACTIONS(2132),
    [anon_sym_fsub] = ACTIONS(2132),
    [anon_sym_bitcast] = ACTIONS(2132),
    [anon_sym_trunc] = ACTIONS(2132),
    [anon_sym_zext] = ACTIONS(2132),
    [anon_sym_sext] = ACTIONS(2132),
    [anon_sym_fptrunc] = ACTIONS(2132),
    [anon_sym_fpext] = ACTIONS(2132),
    [anon_sym_addrspacecast] = ACTIONS(2132),
    [anon_sym_uitofp] = ACTIONS(2132),
    [anon_sym_sitofp] = ACTIONS(2132),
    [anon_sym_fptoui] = ACTIONS(2132),
    [anon_sym_fptosi] = ACTIONS(2132),
    [anon_sym_inttoptr] = ACTIONS(2132),
    [anon_sym_ptrtoint] = ACTIONS(2132),
    [anon_sym_uselistorder] = ACTIONS(2132),
  },
  [638] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2134),
    [sym_label] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_unreachable] = ACTIONS(2136),
    [anon_sym_ret] = ACTIONS(2136),
    [anon_sym_br] = ACTIONS(2136),
    [anon_sym_resume] = ACTIONS(2136),
    [anon_sym_freeze] = ACTIONS(2136),
    [anon_sym_indirectbr] = ACTIONS(2136),
    [anon_sym_extractelement] = ACTIONS(2136),
    [anon_sym_insertelement] = ACTIONS(2136),
    [anon_sym_select] = ACTIONS(2136),
    [anon_sym_shufflevector] = ACTIONS(2136),
    [anon_sym_fneg] = ACTIONS(2136),
    [anon_sym_switch] = ACTIONS(2136),
    [anon_sym_invoke] = ACTIONS(2136),
    [anon_sym_cleanupret] = ACTIONS(2136),
    [anon_sym_catchret] = ACTIONS(2136),
    [anon_sym_catchswitch] = ACTIONS(2136),
    [anon_sym_catchpad] = ACTIONS(2136),
    [anon_sym_cleanuppad] = ACTIONS(2136),
    [anon_sym_callbr] = ACTIONS(2136),
    [anon_sym_icmp] = ACTIONS(2136),
    [anon_sym_fcmp] = ACTIONS(2136),
    [anon_sym_va_arg] = ACTIONS(2136),
    [anon_sym_phi] = ACTIONS(2136),
    [anon_sym_landingpad] = ACTIONS(2136),
    [anon_sym_tail] = ACTIONS(2136),
    [anon_sym_musttail] = ACTIONS(2136),
    [anon_sym_notail] = ACTIONS(2136),
    [anon_sym_call] = ACTIONS(2136),
    [anon_sym_alloca] = ACTIONS(2136),
    [anon_sym_load] = ACTIONS(2136),
    [anon_sym_store] = ACTIONS(2136),
    [anon_sym_cmpxchg] = ACTIONS(2136),
    [anon_sym_atomicrmw] = ACTIONS(2136),
    [anon_sym_fence] = ACTIONS(2136),
    [anon_sym_getelementptr] = ACTIONS(2136),
    [anon_sym_extractvalue] = ACTIONS(2136),
    [anon_sym_insertvalue] = ACTIONS(2136),
    [anon_sym_mul] = ACTIONS(2136),
    [anon_sym_urem] = ACTIONS(2136),
    [anon_sym_srem] = ACTIONS(2136),
    [anon_sym_shl] = ACTIONS(2136),
    [anon_sym_udiv] = ACTIONS(2136),
    [anon_sym_sdiv] = ACTIONS(2136),
    [anon_sym_lshr] = ACTIONS(2136),
    [anon_sym_ashr] = ACTIONS(2136),
    [anon_sym_fmul] = ACTIONS(2136),
    [anon_sym_fdiv] = ACTIONS(2136),
    [anon_sym_frem] = ACTIONS(2136),
    [anon_sym_xchg] = ACTIONS(2136),
    [anon_sym_add] = ACTIONS(2136),
    [anon_sym_sub] = ACTIONS(2136),
    [anon_sym_and] = ACTIONS(2136),
    [anon_sym_nand] = ACTIONS(2136),
    [anon_sym_or] = ACTIONS(2136),
    [anon_sym_xor] = ACTIONS(2136),
    [anon_sym_max] = ACTIONS(2136),
    [anon_sym_min] = ACTIONS(2136),
    [anon_sym_umax] = ACTIONS(2136),
    [anon_sym_umin] = ACTIONS(2136),
    [anon_sym_fadd] = ACTIONS(2136),
    [anon_sym_fsub] = ACTIONS(2136),
    [anon_sym_bitcast] = ACTIONS(2136),
    [anon_sym_trunc] = ACTIONS(2136),
    [anon_sym_zext] = ACTIONS(2136),
    [anon_sym_sext] = ACTIONS(2136),
    [anon_sym_fptrunc] = ACTIONS(2136),
    [anon_sym_fpext] = ACTIONS(2136),
    [anon_sym_addrspacecast] = ACTIONS(2136),
    [anon_sym_uitofp] = ACTIONS(2136),
    [anon_sym_sitofp] = ACTIONS(2136),
    [anon_sym_fptoui] = ACTIONS(2136),
    [anon_sym_fptosi] = ACTIONS(2136),
    [anon_sym_inttoptr] = ACTIONS(2136),
    [anon_sym_ptrtoint] = ACTIONS(2136),
    [anon_sym_uselistorder] = ACTIONS(2136),
  },
  [639] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2138),
    [sym_label] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_COMMA] = ACTIONS(2138),
    [anon_sym_unreachable] = ACTIONS(2140),
    [anon_sym_ret] = ACTIONS(2140),
    [anon_sym_br] = ACTIONS(2140),
    [anon_sym_resume] = ACTIONS(2140),
    [anon_sym_freeze] = ACTIONS(2140),
    [anon_sym_indirectbr] = ACTIONS(2140),
    [anon_sym_extractelement] = ACTIONS(2140),
    [anon_sym_insertelement] = ACTIONS(2140),
    [anon_sym_select] = ACTIONS(2140),
    [anon_sym_shufflevector] = ACTIONS(2140),
    [anon_sym_fneg] = ACTIONS(2140),
    [anon_sym_switch] = ACTIONS(2140),
    [anon_sym_invoke] = ACTIONS(2140),
    [anon_sym_cleanupret] = ACTIONS(2140),
    [anon_sym_catchret] = ACTIONS(2140),
    [anon_sym_catchswitch] = ACTIONS(2140),
    [anon_sym_catchpad] = ACTIONS(2140),
    [anon_sym_cleanuppad] = ACTIONS(2140),
    [anon_sym_callbr] = ACTIONS(2140),
    [anon_sym_icmp] = ACTIONS(2140),
    [anon_sym_fcmp] = ACTIONS(2140),
    [anon_sym_va_arg] = ACTIONS(2140),
    [anon_sym_phi] = ACTIONS(2140),
    [anon_sym_landingpad] = ACTIONS(2140),
    [anon_sym_tail] = ACTIONS(2140),
    [anon_sym_musttail] = ACTIONS(2140),
    [anon_sym_notail] = ACTIONS(2140),
    [anon_sym_call] = ACTIONS(2140),
    [anon_sym_alloca] = ACTIONS(2140),
    [anon_sym_load] = ACTIONS(2140),
    [anon_sym_store] = ACTIONS(2140),
    [anon_sym_cmpxchg] = ACTIONS(2140),
    [anon_sym_atomicrmw] = ACTIONS(2140),
    [anon_sym_fence] = ACTIONS(2140),
    [anon_sym_getelementptr] = ACTIONS(2140),
    [anon_sym_extractvalue] = ACTIONS(2140),
    [anon_sym_insertvalue] = ACTIONS(2140),
    [anon_sym_mul] = ACTIONS(2140),
    [anon_sym_urem] = ACTIONS(2140),
    [anon_sym_srem] = ACTIONS(2140),
    [anon_sym_shl] = ACTIONS(2140),
    [anon_sym_udiv] = ACTIONS(2140),
    [anon_sym_sdiv] = ACTIONS(2140),
    [anon_sym_lshr] = ACTIONS(2140),
    [anon_sym_ashr] = ACTIONS(2140),
    [anon_sym_fmul] = ACTIONS(2140),
    [anon_sym_fdiv] = ACTIONS(2140),
    [anon_sym_frem] = ACTIONS(2140),
    [anon_sym_xchg] = ACTIONS(2140),
    [anon_sym_add] = ACTIONS(2140),
    [anon_sym_sub] = ACTIONS(2140),
    [anon_sym_and] = ACTIONS(2140),
    [anon_sym_nand] = ACTIONS(2140),
    [anon_sym_or] = ACTIONS(2140),
    [anon_sym_xor] = ACTIONS(2140),
    [anon_sym_max] = ACTIONS(2140),
    [anon_sym_min] = ACTIONS(2140),
    [anon_sym_umax] = ACTIONS(2140),
    [anon_sym_umin] = ACTIONS(2140),
    [anon_sym_fadd] = ACTIONS(2140),
    [anon_sym_fsub] = ACTIONS(2140),
    [anon_sym_bitcast] = ACTIONS(2140),
    [anon_sym_trunc] = ACTIONS(2140),
    [anon_sym_zext] = ACTIONS(2140),
    [anon_sym_sext] = ACTIONS(2140),
    [anon_sym_fptrunc] = ACTIONS(2140),
    [anon_sym_fpext] = ACTIONS(2140),
    [anon_sym_addrspacecast] = ACTIONS(2140),
    [anon_sym_uitofp] = ACTIONS(2140),
    [anon_sym_sitofp] = ACTIONS(2140),
    [anon_sym_fptoui] = ACTIONS(2140),
    [anon_sym_fptosi] = ACTIONS(2140),
    [anon_sym_inttoptr] = ACTIONS(2140),
    [anon_sym_ptrtoint] = ACTIONS(2140),
    [anon_sym_uselistorder] = ACTIONS(2140),
  },
  [640] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2142),
    [sym_label] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_unreachable] = ACTIONS(2144),
    [anon_sym_ret] = ACTIONS(2144),
    [anon_sym_br] = ACTIONS(2144),
    [anon_sym_resume] = ACTIONS(2144),
    [anon_sym_freeze] = ACTIONS(2144),
    [anon_sym_indirectbr] = ACTIONS(2144),
    [anon_sym_extractelement] = ACTIONS(2144),
    [anon_sym_insertelement] = ACTIONS(2144),
    [anon_sym_select] = ACTIONS(2144),
    [anon_sym_shufflevector] = ACTIONS(2144),
    [anon_sym_fneg] = ACTIONS(2144),
    [anon_sym_switch] = ACTIONS(2144),
    [anon_sym_invoke] = ACTIONS(2144),
    [anon_sym_cleanupret] = ACTIONS(2144),
    [anon_sym_catchret] = ACTIONS(2144),
    [anon_sym_catchswitch] = ACTIONS(2144),
    [anon_sym_catchpad] = ACTIONS(2144),
    [anon_sym_cleanuppad] = ACTIONS(2144),
    [anon_sym_callbr] = ACTIONS(2144),
    [anon_sym_icmp] = ACTIONS(2144),
    [anon_sym_fcmp] = ACTIONS(2144),
    [anon_sym_va_arg] = ACTIONS(2144),
    [anon_sym_phi] = ACTIONS(2144),
    [anon_sym_landingpad] = ACTIONS(2144),
    [anon_sym_tail] = ACTIONS(2144),
    [anon_sym_musttail] = ACTIONS(2144),
    [anon_sym_notail] = ACTIONS(2144),
    [anon_sym_call] = ACTIONS(2144),
    [anon_sym_alloca] = ACTIONS(2144),
    [anon_sym_load] = ACTIONS(2144),
    [anon_sym_store] = ACTIONS(2144),
    [anon_sym_cmpxchg] = ACTIONS(2144),
    [anon_sym_atomicrmw] = ACTIONS(2144),
    [anon_sym_fence] = ACTIONS(2144),
    [anon_sym_getelementptr] = ACTIONS(2144),
    [anon_sym_extractvalue] = ACTIONS(2144),
    [anon_sym_insertvalue] = ACTIONS(2144),
    [anon_sym_mul] = ACTIONS(2144),
    [anon_sym_urem] = ACTIONS(2144),
    [anon_sym_srem] = ACTIONS(2144),
    [anon_sym_shl] = ACTIONS(2144),
    [anon_sym_udiv] = ACTIONS(2144),
    [anon_sym_sdiv] = ACTIONS(2144),
    [anon_sym_lshr] = ACTIONS(2144),
    [anon_sym_ashr] = ACTIONS(2144),
    [anon_sym_fmul] = ACTIONS(2144),
    [anon_sym_fdiv] = ACTIONS(2144),
    [anon_sym_frem] = ACTIONS(2144),
    [anon_sym_xchg] = ACTIONS(2144),
    [anon_sym_add] = ACTIONS(2144),
    [anon_sym_sub] = ACTIONS(2144),
    [anon_sym_and] = ACTIONS(2144),
    [anon_sym_nand] = ACTIONS(2144),
    [anon_sym_or] = ACTIONS(2144),
    [anon_sym_xor] = ACTIONS(2144),
    [anon_sym_max] = ACTIONS(2144),
    [anon_sym_min] = ACTIONS(2144),
    [anon_sym_umax] = ACTIONS(2144),
    [anon_sym_umin] = ACTIONS(2144),
    [anon_sym_fadd] = ACTIONS(2144),
    [anon_sym_fsub] = ACTIONS(2144),
    [anon_sym_bitcast] = ACTIONS(2144),
    [anon_sym_trunc] = ACTIONS(2144),
    [anon_sym_zext] = ACTIONS(2144),
    [anon_sym_sext] = ACTIONS(2144),
    [anon_sym_fptrunc] = ACTIONS(2144),
    [anon_sym_fpext] = ACTIONS(2144),
    [anon_sym_addrspacecast] = ACTIONS(2144),
    [anon_sym_uitofp] = ACTIONS(2144),
    [anon_sym_sitofp] = ACTIONS(2144),
    [anon_sym_fptoui] = ACTIONS(2144),
    [anon_sym_fptosi] = ACTIONS(2144),
    [anon_sym_inttoptr] = ACTIONS(2144),
    [anon_sym_ptrtoint] = ACTIONS(2144),
    [anon_sym_uselistorder] = ACTIONS(2144),
  },
  [641] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2146),
    [sym_label] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_unreachable] = ACTIONS(2148),
    [anon_sym_ret] = ACTIONS(2148),
    [anon_sym_br] = ACTIONS(2148),
    [anon_sym_resume] = ACTIONS(2148),
    [anon_sym_freeze] = ACTIONS(2148),
    [anon_sym_indirectbr] = ACTIONS(2148),
    [anon_sym_extractelement] = ACTIONS(2148),
    [anon_sym_insertelement] = ACTIONS(2148),
    [anon_sym_select] = ACTIONS(2148),
    [anon_sym_shufflevector] = ACTIONS(2148),
    [anon_sym_fneg] = ACTIONS(2148),
    [anon_sym_switch] = ACTIONS(2148),
    [anon_sym_invoke] = ACTIONS(2148),
    [anon_sym_cleanupret] = ACTIONS(2148),
    [anon_sym_catchret] = ACTIONS(2148),
    [anon_sym_catchswitch] = ACTIONS(2148),
    [anon_sym_catchpad] = ACTIONS(2148),
    [anon_sym_cleanuppad] = ACTIONS(2148),
    [anon_sym_callbr] = ACTIONS(2148),
    [anon_sym_icmp] = ACTIONS(2148),
    [anon_sym_fcmp] = ACTIONS(2148),
    [anon_sym_va_arg] = ACTIONS(2148),
    [anon_sym_phi] = ACTIONS(2148),
    [anon_sym_landingpad] = ACTIONS(2148),
    [anon_sym_tail] = ACTIONS(2148),
    [anon_sym_musttail] = ACTIONS(2148),
    [anon_sym_notail] = ACTIONS(2148),
    [anon_sym_call] = ACTIONS(2148),
    [anon_sym_alloca] = ACTIONS(2148),
    [anon_sym_load] = ACTIONS(2148),
    [anon_sym_store] = ACTIONS(2148),
    [anon_sym_cmpxchg] = ACTIONS(2148),
    [anon_sym_atomicrmw] = ACTIONS(2148),
    [anon_sym_fence] = ACTIONS(2148),
    [anon_sym_getelementptr] = ACTIONS(2148),
    [anon_sym_extractvalue] = ACTIONS(2148),
    [anon_sym_insertvalue] = ACTIONS(2148),
    [anon_sym_mul] = ACTIONS(2148),
    [anon_sym_urem] = ACTIONS(2148),
    [anon_sym_srem] = ACTIONS(2148),
    [anon_sym_shl] = ACTIONS(2148),
    [anon_sym_udiv] = ACTIONS(2148),
    [anon_sym_sdiv] = ACTIONS(2148),
    [anon_sym_lshr] = ACTIONS(2148),
    [anon_sym_ashr] = ACTIONS(2148),
    [anon_sym_fmul] = ACTIONS(2148),
    [anon_sym_fdiv] = ACTIONS(2148),
    [anon_sym_frem] = ACTIONS(2148),
    [anon_sym_xchg] = ACTIONS(2148),
    [anon_sym_add] = ACTIONS(2148),
    [anon_sym_sub] = ACTIONS(2148),
    [anon_sym_and] = ACTIONS(2148),
    [anon_sym_nand] = ACTIONS(2148),
    [anon_sym_or] = ACTIONS(2148),
    [anon_sym_xor] = ACTIONS(2148),
    [anon_sym_max] = ACTIONS(2148),
    [anon_sym_min] = ACTIONS(2148),
    [anon_sym_umax] = ACTIONS(2148),
    [anon_sym_umin] = ACTIONS(2148),
    [anon_sym_fadd] = ACTIONS(2148),
    [anon_sym_fsub] = ACTIONS(2148),
    [anon_sym_bitcast] = ACTIONS(2148),
    [anon_sym_trunc] = ACTIONS(2148),
    [anon_sym_zext] = ACTIONS(2148),
    [anon_sym_sext] = ACTIONS(2148),
    [anon_sym_fptrunc] = ACTIONS(2148),
    [anon_sym_fpext] = ACTIONS(2148),
    [anon_sym_addrspacecast] = ACTIONS(2148),
    [anon_sym_uitofp] = ACTIONS(2148),
    [anon_sym_sitofp] = ACTIONS(2148),
    [anon_sym_fptoui] = ACTIONS(2148),
    [anon_sym_fptosi] = ACTIONS(2148),
    [anon_sym_inttoptr] = ACTIONS(2148),
    [anon_sym_ptrtoint] = ACTIONS(2148),
    [anon_sym_uselistorder] = ACTIONS(2148),
  },
  [642] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2150),
    [sym_label] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_COMMA] = ACTIONS(2150),
    [anon_sym_unreachable] = ACTIONS(2152),
    [anon_sym_ret] = ACTIONS(2152),
    [anon_sym_br] = ACTIONS(2152),
    [anon_sym_resume] = ACTIONS(2152),
    [anon_sym_freeze] = ACTIONS(2152),
    [anon_sym_indirectbr] = ACTIONS(2152),
    [anon_sym_extractelement] = ACTIONS(2152),
    [anon_sym_insertelement] = ACTIONS(2152),
    [anon_sym_select] = ACTIONS(2152),
    [anon_sym_shufflevector] = ACTIONS(2152),
    [anon_sym_fneg] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_invoke] = ACTIONS(2152),
    [anon_sym_cleanupret] = ACTIONS(2152),
    [anon_sym_catchret] = ACTIONS(2152),
    [anon_sym_catchswitch] = ACTIONS(2152),
    [anon_sym_catchpad] = ACTIONS(2152),
    [anon_sym_cleanuppad] = ACTIONS(2152),
    [anon_sym_callbr] = ACTIONS(2152),
    [anon_sym_icmp] = ACTIONS(2152),
    [anon_sym_fcmp] = ACTIONS(2152),
    [anon_sym_va_arg] = ACTIONS(2152),
    [anon_sym_phi] = ACTIONS(2152),
    [anon_sym_landingpad] = ACTIONS(2152),
    [anon_sym_tail] = ACTIONS(2152),
    [anon_sym_musttail] = ACTIONS(2152),
    [anon_sym_notail] = ACTIONS(2152),
    [anon_sym_call] = ACTIONS(2152),
    [anon_sym_alloca] = ACTIONS(2152),
    [anon_sym_load] = ACTIONS(2152),
    [anon_sym_store] = ACTIONS(2152),
    [anon_sym_cmpxchg] = ACTIONS(2152),
    [anon_sym_atomicrmw] = ACTIONS(2152),
    [anon_sym_fence] = ACTIONS(2152),
    [anon_sym_getelementptr] = ACTIONS(2152),
    [anon_sym_extractvalue] = ACTIONS(2152),
    [anon_sym_insertvalue] = ACTIONS(2152),
    [anon_sym_mul] = ACTIONS(2152),
    [anon_sym_urem] = ACTIONS(2152),
    [anon_sym_srem] = ACTIONS(2152),
    [anon_sym_shl] = ACTIONS(2152),
    [anon_sym_udiv] = ACTIONS(2152),
    [anon_sym_sdiv] = ACTIONS(2152),
    [anon_sym_lshr] = ACTIONS(2152),
    [anon_sym_ashr] = ACTIONS(2152),
    [anon_sym_fmul] = ACTIONS(2152),
    [anon_sym_fdiv] = ACTIONS(2152),
    [anon_sym_frem] = ACTIONS(2152),
    [anon_sym_xchg] = ACTIONS(2152),
    [anon_sym_add] = ACTIONS(2152),
    [anon_sym_sub] = ACTIONS(2152),
    [anon_sym_and] = ACTIONS(2152),
    [anon_sym_nand] = ACTIONS(2152),
    [anon_sym_or] = ACTIONS(2152),
    [anon_sym_xor] = ACTIONS(2152),
    [anon_sym_max] = ACTIONS(2152),
    [anon_sym_min] = ACTIONS(2152),
    [anon_sym_umax] = ACTIONS(2152),
    [anon_sym_umin] = ACTIONS(2152),
    [anon_sym_fadd] = ACTIONS(2152),
    [anon_sym_fsub] = ACTIONS(2152),
    [anon_sym_bitcast] = ACTIONS(2152),
    [anon_sym_trunc] = ACTIONS(2152),
    [anon_sym_zext] = ACTIONS(2152),
    [anon_sym_sext] = ACTIONS(2152),
    [anon_sym_fptrunc] = ACTIONS(2152),
    [anon_sym_fpext] = ACTIONS(2152),
    [anon_sym_addrspacecast] = ACTIONS(2152),
    [anon_sym_uitofp] = ACTIONS(2152),
    [anon_sym_sitofp] = ACTIONS(2152),
    [anon_sym_fptoui] = ACTIONS(2152),
    [anon_sym_fptosi] = ACTIONS(2152),
    [anon_sym_inttoptr] = ACTIONS(2152),
    [anon_sym_ptrtoint] = ACTIONS(2152),
    [anon_sym_uselistorder] = ACTIONS(2152),
  },
  [643] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2154),
    [sym_label] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_unreachable] = ACTIONS(2156),
    [anon_sym_ret] = ACTIONS(2156),
    [anon_sym_br] = ACTIONS(2156),
    [anon_sym_resume] = ACTIONS(2156),
    [anon_sym_freeze] = ACTIONS(2156),
    [anon_sym_indirectbr] = ACTIONS(2156),
    [anon_sym_extractelement] = ACTIONS(2156),
    [anon_sym_insertelement] = ACTIONS(2156),
    [anon_sym_select] = ACTIONS(2156),
    [anon_sym_shufflevector] = ACTIONS(2156),
    [anon_sym_fneg] = ACTIONS(2156),
    [anon_sym_switch] = ACTIONS(2156),
    [anon_sym_invoke] = ACTIONS(2156),
    [anon_sym_cleanupret] = ACTIONS(2156),
    [anon_sym_catchret] = ACTIONS(2156),
    [anon_sym_catchswitch] = ACTIONS(2156),
    [anon_sym_catchpad] = ACTIONS(2156),
    [anon_sym_cleanuppad] = ACTIONS(2156),
    [anon_sym_callbr] = ACTIONS(2156),
    [anon_sym_icmp] = ACTIONS(2156),
    [anon_sym_fcmp] = ACTIONS(2156),
    [anon_sym_va_arg] = ACTIONS(2156),
    [anon_sym_phi] = ACTIONS(2156),
    [anon_sym_landingpad] = ACTIONS(2156),
    [anon_sym_tail] = ACTIONS(2156),
    [anon_sym_musttail] = ACTIONS(2156),
    [anon_sym_notail] = ACTIONS(2156),
    [anon_sym_call] = ACTIONS(2156),
    [anon_sym_alloca] = ACTIONS(2156),
    [anon_sym_load] = ACTIONS(2156),
    [anon_sym_store] = ACTIONS(2156),
    [anon_sym_cmpxchg] = ACTIONS(2156),
    [anon_sym_atomicrmw] = ACTIONS(2156),
    [anon_sym_fence] = ACTIONS(2156),
    [anon_sym_getelementptr] = ACTIONS(2156),
    [anon_sym_extractvalue] = ACTIONS(2156),
    [anon_sym_insertvalue] = ACTIONS(2156),
    [anon_sym_mul] = ACTIONS(2156),
    [anon_sym_urem] = ACTIONS(2156),
    [anon_sym_srem] = ACTIONS(2156),
    [anon_sym_shl] = ACTIONS(2156),
    [anon_sym_udiv] = ACTIONS(2156),
    [anon_sym_sdiv] = ACTIONS(2156),
    [anon_sym_lshr] = ACTIONS(2156),
    [anon_sym_ashr] = ACTIONS(2156),
    [anon_sym_fmul] = ACTIONS(2156),
    [anon_sym_fdiv] = ACTIONS(2156),
    [anon_sym_frem] = ACTIONS(2156),
    [anon_sym_xchg] = ACTIONS(2156),
    [anon_sym_add] = ACTIONS(2156),
    [anon_sym_sub] = ACTIONS(2156),
    [anon_sym_and] = ACTIONS(2156),
    [anon_sym_nand] = ACTIONS(2156),
    [anon_sym_or] = ACTIONS(2156),
    [anon_sym_xor] = ACTIONS(2156),
    [anon_sym_max] = ACTIONS(2156),
    [anon_sym_min] = ACTIONS(2156),
    [anon_sym_umax] = ACTIONS(2156),
    [anon_sym_umin] = ACTIONS(2156),
    [anon_sym_fadd] = ACTIONS(2156),
    [anon_sym_fsub] = ACTIONS(2156),
    [anon_sym_bitcast] = ACTIONS(2156),
    [anon_sym_trunc] = ACTIONS(2156),
    [anon_sym_zext] = ACTIONS(2156),
    [anon_sym_sext] = ACTIONS(2156),
    [anon_sym_fptrunc] = ACTIONS(2156),
    [anon_sym_fpext] = ACTIONS(2156),
    [anon_sym_addrspacecast] = ACTIONS(2156),
    [anon_sym_uitofp] = ACTIONS(2156),
    [anon_sym_sitofp] = ACTIONS(2156),
    [anon_sym_fptoui] = ACTIONS(2156),
    [anon_sym_fptosi] = ACTIONS(2156),
    [anon_sym_inttoptr] = ACTIONS(2156),
    [anon_sym_ptrtoint] = ACTIONS(2156),
    [anon_sym_uselistorder] = ACTIONS(2156),
  },
  [644] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2158),
    [sym_label] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_unreachable] = ACTIONS(2160),
    [anon_sym_ret] = ACTIONS(2160),
    [anon_sym_br] = ACTIONS(2160),
    [anon_sym_resume] = ACTIONS(2160),
    [anon_sym_freeze] = ACTIONS(2160),
    [anon_sym_indirectbr] = ACTIONS(2160),
    [anon_sym_extractelement] = ACTIONS(2160),
    [anon_sym_insertelement] = ACTIONS(2160),
    [anon_sym_select] = ACTIONS(2160),
    [anon_sym_shufflevector] = ACTIONS(2160),
    [anon_sym_fneg] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_invoke] = ACTIONS(2160),
    [anon_sym_cleanupret] = ACTIONS(2160),
    [anon_sym_catchret] = ACTIONS(2160),
    [anon_sym_catchswitch] = ACTIONS(2160),
    [anon_sym_catchpad] = ACTIONS(2160),
    [anon_sym_cleanuppad] = ACTIONS(2160),
    [anon_sym_callbr] = ACTIONS(2160),
    [anon_sym_icmp] = ACTIONS(2160),
    [anon_sym_fcmp] = ACTIONS(2160),
    [anon_sym_va_arg] = ACTIONS(2160),
    [anon_sym_phi] = ACTIONS(2160),
    [anon_sym_landingpad] = ACTIONS(2160),
    [anon_sym_tail] = ACTIONS(2160),
    [anon_sym_musttail] = ACTIONS(2160),
    [anon_sym_notail] = ACTIONS(2160),
    [anon_sym_call] = ACTIONS(2160),
    [anon_sym_alloca] = ACTIONS(2160),
    [anon_sym_load] = ACTIONS(2160),
    [anon_sym_store] = ACTIONS(2160),
    [anon_sym_cmpxchg] = ACTIONS(2160),
    [anon_sym_atomicrmw] = ACTIONS(2160),
    [anon_sym_fence] = ACTIONS(2160),
    [anon_sym_getelementptr] = ACTIONS(2160),
    [anon_sym_extractvalue] = ACTIONS(2160),
    [anon_sym_insertvalue] = ACTIONS(2160),
    [anon_sym_mul] = ACTIONS(2160),
    [anon_sym_urem] = ACTIONS(2160),
    [anon_sym_srem] = ACTIONS(2160),
    [anon_sym_shl] = ACTIONS(2160),
    [anon_sym_udiv] = ACTIONS(2160),
    [anon_sym_sdiv] = ACTIONS(2160),
    [anon_sym_lshr] = ACTIONS(2160),
    [anon_sym_ashr] = ACTIONS(2160),
    [anon_sym_fmul] = ACTIONS(2160),
    [anon_sym_fdiv] = ACTIONS(2160),
    [anon_sym_frem] = ACTIONS(2160),
    [anon_sym_xchg] = ACTIONS(2160),
    [anon_sym_add] = ACTIONS(2160),
    [anon_sym_sub] = ACTIONS(2160),
    [anon_sym_and] = ACTIONS(2160),
    [anon_sym_nand] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2160),
    [anon_sym_xor] = ACTIONS(2160),
    [anon_sym_max] = ACTIONS(2160),
    [anon_sym_min] = ACTIONS(2160),
    [anon_sym_umax] = ACTIONS(2160),
    [anon_sym_umin] = ACTIONS(2160),
    [anon_sym_fadd] = ACTIONS(2160),
    [anon_sym_fsub] = ACTIONS(2160),
    [anon_sym_bitcast] = ACTIONS(2160),
    [anon_sym_trunc] = ACTIONS(2160),
    [anon_sym_zext] = ACTIONS(2160),
    [anon_sym_sext] = ACTIONS(2160),
    [anon_sym_fptrunc] = ACTIONS(2160),
    [anon_sym_fpext] = ACTIONS(2160),
    [anon_sym_addrspacecast] = ACTIONS(2160),
    [anon_sym_uitofp] = ACTIONS(2160),
    [anon_sym_sitofp] = ACTIONS(2160),
    [anon_sym_fptoui] = ACTIONS(2160),
    [anon_sym_fptosi] = ACTIONS(2160),
    [anon_sym_inttoptr] = ACTIONS(2160),
    [anon_sym_ptrtoint] = ACTIONS(2160),
    [anon_sym_uselistorder] = ACTIONS(2160),
  },
  [645] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(753),
    [sym_label] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_unreachable] = ACTIONS(755),
    [anon_sym_ret] = ACTIONS(755),
    [anon_sym_br] = ACTIONS(755),
    [anon_sym_resume] = ACTIONS(755),
    [anon_sym_freeze] = ACTIONS(755),
    [anon_sym_indirectbr] = ACTIONS(755),
    [anon_sym_extractelement] = ACTIONS(755),
    [anon_sym_insertelement] = ACTIONS(755),
    [anon_sym_select] = ACTIONS(755),
    [anon_sym_shufflevector] = ACTIONS(755),
    [anon_sym_fneg] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(755),
    [anon_sym_invoke] = ACTIONS(755),
    [anon_sym_cleanupret] = ACTIONS(755),
    [anon_sym_catchret] = ACTIONS(755),
    [anon_sym_catchswitch] = ACTIONS(755),
    [anon_sym_catchpad] = ACTIONS(755),
    [anon_sym_cleanuppad] = ACTIONS(755),
    [anon_sym_callbr] = ACTIONS(755),
    [anon_sym_icmp] = ACTIONS(755),
    [anon_sym_fcmp] = ACTIONS(755),
    [anon_sym_va_arg] = ACTIONS(755),
    [anon_sym_phi] = ACTIONS(755),
    [anon_sym_landingpad] = ACTIONS(755),
    [anon_sym_tail] = ACTIONS(755),
    [anon_sym_musttail] = ACTIONS(755),
    [anon_sym_notail] = ACTIONS(755),
    [anon_sym_call] = ACTIONS(755),
    [anon_sym_alloca] = ACTIONS(755),
    [anon_sym_load] = ACTIONS(755),
    [anon_sym_store] = ACTIONS(755),
    [anon_sym_cmpxchg] = ACTIONS(755),
    [anon_sym_atomicrmw] = ACTIONS(755),
    [anon_sym_fence] = ACTIONS(755),
    [anon_sym_getelementptr] = ACTIONS(755),
    [anon_sym_extractvalue] = ACTIONS(755),
    [anon_sym_insertvalue] = ACTIONS(755),
    [anon_sym_mul] = ACTIONS(755),
    [anon_sym_urem] = ACTIONS(755),
    [anon_sym_srem] = ACTIONS(755),
    [anon_sym_shl] = ACTIONS(755),
    [anon_sym_udiv] = ACTIONS(755),
    [anon_sym_sdiv] = ACTIONS(755),
    [anon_sym_lshr] = ACTIONS(755),
    [anon_sym_ashr] = ACTIONS(755),
    [anon_sym_fmul] = ACTIONS(755),
    [anon_sym_fdiv] = ACTIONS(755),
    [anon_sym_frem] = ACTIONS(755),
    [anon_sym_xchg] = ACTIONS(755),
    [anon_sym_add] = ACTIONS(755),
    [anon_sym_sub] = ACTIONS(755),
    [anon_sym_and] = ACTIONS(755),
    [anon_sym_nand] = ACTIONS(755),
    [anon_sym_or] = ACTIONS(755),
    [anon_sym_xor] = ACTIONS(755),
    [anon_sym_max] = ACTIONS(755),
    [anon_sym_min] = ACTIONS(755),
    [anon_sym_umax] = ACTIONS(755),
    [anon_sym_umin] = ACTIONS(755),
    [anon_sym_fadd] = ACTIONS(755),
    [anon_sym_fsub] = ACTIONS(755),
    [anon_sym_bitcast] = ACTIONS(755),
    [anon_sym_trunc] = ACTIONS(755),
    [anon_sym_zext] = ACTIONS(755),
    [anon_sym_sext] = ACTIONS(755),
    [anon_sym_fptrunc] = ACTIONS(755),
    [anon_sym_fpext] = ACTIONS(755),
    [anon_sym_addrspacecast] = ACTIONS(755),
    [anon_sym_uitofp] = ACTIONS(755),
    [anon_sym_sitofp] = ACTIONS(755),
    [anon_sym_fptoui] = ACTIONS(755),
    [anon_sym_fptosi] = ACTIONS(755),
    [anon_sym_inttoptr] = ACTIONS(755),
    [anon_sym_ptrtoint] = ACTIONS(755),
    [anon_sym_uselistorder] = ACTIONS(755),
  },
  [646] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2162),
    [sym_label] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_COMMA] = ACTIONS(2162),
    [anon_sym_unreachable] = ACTIONS(2164),
    [anon_sym_ret] = ACTIONS(2164),
    [anon_sym_br] = ACTIONS(2164),
    [anon_sym_resume] = ACTIONS(2164),
    [anon_sym_freeze] = ACTIONS(2164),
    [anon_sym_indirectbr] = ACTIONS(2164),
    [anon_sym_extractelement] = ACTIONS(2164),
    [anon_sym_insertelement] = ACTIONS(2164),
    [anon_sym_select] = ACTIONS(2164),
    [anon_sym_shufflevector] = ACTIONS(2164),
    [anon_sym_fneg] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_invoke] = ACTIONS(2164),
    [anon_sym_cleanupret] = ACTIONS(2164),
    [anon_sym_catchret] = ACTIONS(2164),
    [anon_sym_catchswitch] = ACTIONS(2164),
    [anon_sym_catchpad] = ACTIONS(2164),
    [anon_sym_cleanuppad] = ACTIONS(2164),
    [anon_sym_callbr] = ACTIONS(2164),
    [anon_sym_icmp] = ACTIONS(2164),
    [anon_sym_fcmp] = ACTIONS(2164),
    [anon_sym_va_arg] = ACTIONS(2164),
    [anon_sym_phi] = ACTIONS(2164),
    [anon_sym_landingpad] = ACTIONS(2164),
    [anon_sym_tail] = ACTIONS(2164),
    [anon_sym_musttail] = ACTIONS(2164),
    [anon_sym_notail] = ACTIONS(2164),
    [anon_sym_call] = ACTIONS(2164),
    [anon_sym_alloca] = ACTIONS(2164),
    [anon_sym_load] = ACTIONS(2164),
    [anon_sym_store] = ACTIONS(2164),
    [anon_sym_cmpxchg] = ACTIONS(2164),
    [anon_sym_atomicrmw] = ACTIONS(2164),
    [anon_sym_fence] = ACTIONS(2164),
    [anon_sym_getelementptr] = ACTIONS(2164),
    [anon_sym_extractvalue] = ACTIONS(2164),
    [anon_sym_insertvalue] = ACTIONS(2164),
    [anon_sym_mul] = ACTIONS(2164),
    [anon_sym_urem] = ACTIONS(2164),
    [anon_sym_srem] = ACTIONS(2164),
    [anon_sym_shl] = ACTIONS(2164),
    [anon_sym_udiv] = ACTIONS(2164),
    [anon_sym_sdiv] = ACTIONS(2164),
    [anon_sym_lshr] = ACTIONS(2164),
    [anon_sym_ashr] = ACTIONS(2164),
    [anon_sym_fmul] = ACTIONS(2164),
    [anon_sym_fdiv] = ACTIONS(2164),
    [anon_sym_frem] = ACTIONS(2164),
    [anon_sym_xchg] = ACTIONS(2164),
    [anon_sym_add] = ACTIONS(2164),
    [anon_sym_sub] = ACTIONS(2164),
    [anon_sym_and] = ACTIONS(2164),
    [anon_sym_nand] = ACTIONS(2164),
    [anon_sym_or] = ACTIONS(2164),
    [anon_sym_xor] = ACTIONS(2164),
    [anon_sym_max] = ACTIONS(2164),
    [anon_sym_min] = ACTIONS(2164),
    [anon_sym_umax] = ACTIONS(2164),
    [anon_sym_umin] = ACTIONS(2164),
    [anon_sym_fadd] = ACTIONS(2164),
    [anon_sym_fsub] = ACTIONS(2164),
    [anon_sym_bitcast] = ACTIONS(2164),
    [anon_sym_trunc] = ACTIONS(2164),
    [anon_sym_zext] = ACTIONS(2164),
    [anon_sym_sext] = ACTIONS(2164),
    [anon_sym_fptrunc] = ACTIONS(2164),
    [anon_sym_fpext] = ACTIONS(2164),
    [anon_sym_addrspacecast] = ACTIONS(2164),
    [anon_sym_uitofp] = ACTIONS(2164),
    [anon_sym_sitofp] = ACTIONS(2164),
    [anon_sym_fptoui] = ACTIONS(2164),
    [anon_sym_fptosi] = ACTIONS(2164),
    [anon_sym_inttoptr] = ACTIONS(2164),
    [anon_sym_ptrtoint] = ACTIONS(2164),
    [anon_sym_uselistorder] = ACTIONS(2164),
  },
  [647] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2166),
    [sym_label] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_unreachable] = ACTIONS(2168),
    [anon_sym_ret] = ACTIONS(2168),
    [anon_sym_br] = ACTIONS(2168),
    [anon_sym_resume] = ACTIONS(2168),
    [anon_sym_freeze] = ACTIONS(2168),
    [anon_sym_indirectbr] = ACTIONS(2168),
    [anon_sym_extractelement] = ACTIONS(2168),
    [anon_sym_insertelement] = ACTIONS(2168),
    [anon_sym_select] = ACTIONS(2168),
    [anon_sym_shufflevector] = ACTIONS(2168),
    [anon_sym_fneg] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_invoke] = ACTIONS(2168),
    [anon_sym_cleanupret] = ACTIONS(2168),
    [anon_sym_catchret] = ACTIONS(2168),
    [anon_sym_catchswitch] = ACTIONS(2168),
    [anon_sym_catchpad] = ACTIONS(2168),
    [anon_sym_cleanuppad] = ACTIONS(2168),
    [anon_sym_callbr] = ACTIONS(2168),
    [anon_sym_icmp] = ACTIONS(2168),
    [anon_sym_fcmp] = ACTIONS(2168),
    [anon_sym_va_arg] = ACTIONS(2168),
    [anon_sym_phi] = ACTIONS(2168),
    [anon_sym_landingpad] = ACTIONS(2168),
    [anon_sym_tail] = ACTIONS(2168),
    [anon_sym_musttail] = ACTIONS(2168),
    [anon_sym_notail] = ACTIONS(2168),
    [anon_sym_call] = ACTIONS(2168),
    [anon_sym_alloca] = ACTIONS(2168),
    [anon_sym_load] = ACTIONS(2168),
    [anon_sym_store] = ACTIONS(2168),
    [anon_sym_cmpxchg] = ACTIONS(2168),
    [anon_sym_atomicrmw] = ACTIONS(2168),
    [anon_sym_fence] = ACTIONS(2168),
    [anon_sym_getelementptr] = ACTIONS(2168),
    [anon_sym_extractvalue] = ACTIONS(2168),
    [anon_sym_insertvalue] = ACTIONS(2168),
    [anon_sym_mul] = ACTIONS(2168),
    [anon_sym_urem] = ACTIONS(2168),
    [anon_sym_srem] = ACTIONS(2168),
    [anon_sym_shl] = ACTIONS(2168),
    [anon_sym_udiv] = ACTIONS(2168),
    [anon_sym_sdiv] = ACTIONS(2168),
    [anon_sym_lshr] = ACTIONS(2168),
    [anon_sym_ashr] = ACTIONS(2168),
    [anon_sym_fmul] = ACTIONS(2168),
    [anon_sym_fdiv] = ACTIONS(2168),
    [anon_sym_frem] = ACTIONS(2168),
    [anon_sym_xchg] = ACTIONS(2168),
    [anon_sym_add] = ACTIONS(2168),
    [anon_sym_sub] = ACTIONS(2168),
    [anon_sym_and] = ACTIONS(2168),
    [anon_sym_nand] = ACTIONS(2168),
    [anon_sym_or] = ACTIONS(2168),
    [anon_sym_xor] = ACTIONS(2168),
    [anon_sym_max] = ACTIONS(2168),
    [anon_sym_min] = ACTIONS(2168),
    [anon_sym_umax] = ACTIONS(2168),
    [anon_sym_umin] = ACTIONS(2168),
    [anon_sym_fadd] = ACTIONS(2168),
    [anon_sym_fsub] = ACTIONS(2168),
    [anon_sym_bitcast] = ACTIONS(2168),
    [anon_sym_trunc] = ACTIONS(2168),
    [anon_sym_zext] = ACTIONS(2168),
    [anon_sym_sext] = ACTIONS(2168),
    [anon_sym_fptrunc] = ACTIONS(2168),
    [anon_sym_fpext] = ACTIONS(2168),
    [anon_sym_addrspacecast] = ACTIONS(2168),
    [anon_sym_uitofp] = ACTIONS(2168),
    [anon_sym_sitofp] = ACTIONS(2168),
    [anon_sym_fptoui] = ACTIONS(2168),
    [anon_sym_fptosi] = ACTIONS(2168),
    [anon_sym_inttoptr] = ACTIONS(2168),
    [anon_sym_ptrtoint] = ACTIONS(2168),
    [anon_sym_uselistorder] = ACTIONS(2168),
  },
  [648] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2170),
    [sym_label] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_unreachable] = ACTIONS(2172),
    [anon_sym_ret] = ACTIONS(2172),
    [anon_sym_br] = ACTIONS(2172),
    [anon_sym_resume] = ACTIONS(2172),
    [anon_sym_freeze] = ACTIONS(2172),
    [anon_sym_indirectbr] = ACTIONS(2172),
    [anon_sym_extractelement] = ACTIONS(2172),
    [anon_sym_insertelement] = ACTIONS(2172),
    [anon_sym_select] = ACTIONS(2172),
    [anon_sym_shufflevector] = ACTIONS(2172),
    [anon_sym_fneg] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_invoke] = ACTIONS(2172),
    [anon_sym_cleanupret] = ACTIONS(2172),
    [anon_sym_catchret] = ACTIONS(2172),
    [anon_sym_catchswitch] = ACTIONS(2172),
    [anon_sym_catchpad] = ACTIONS(2172),
    [anon_sym_cleanuppad] = ACTIONS(2172),
    [anon_sym_callbr] = ACTIONS(2172),
    [anon_sym_icmp] = ACTIONS(2172),
    [anon_sym_fcmp] = ACTIONS(2172),
    [anon_sym_va_arg] = ACTIONS(2172),
    [anon_sym_phi] = ACTIONS(2172),
    [anon_sym_landingpad] = ACTIONS(2172),
    [anon_sym_tail] = ACTIONS(2172),
    [anon_sym_musttail] = ACTIONS(2172),
    [anon_sym_notail] = ACTIONS(2172),
    [anon_sym_call] = ACTIONS(2172),
    [anon_sym_alloca] = ACTIONS(2172),
    [anon_sym_load] = ACTIONS(2172),
    [anon_sym_store] = ACTIONS(2172),
    [anon_sym_cmpxchg] = ACTIONS(2172),
    [anon_sym_atomicrmw] = ACTIONS(2172),
    [anon_sym_fence] = ACTIONS(2172),
    [anon_sym_getelementptr] = ACTIONS(2172),
    [anon_sym_extractvalue] = ACTIONS(2172),
    [anon_sym_insertvalue] = ACTIONS(2172),
    [anon_sym_mul] = ACTIONS(2172),
    [anon_sym_urem] = ACTIONS(2172),
    [anon_sym_srem] = ACTIONS(2172),
    [anon_sym_shl] = ACTIONS(2172),
    [anon_sym_udiv] = ACTIONS(2172),
    [anon_sym_sdiv] = ACTIONS(2172),
    [anon_sym_lshr] = ACTIONS(2172),
    [anon_sym_ashr] = ACTIONS(2172),
    [anon_sym_fmul] = ACTIONS(2172),
    [anon_sym_fdiv] = ACTIONS(2172),
    [anon_sym_frem] = ACTIONS(2172),
    [anon_sym_xchg] = ACTIONS(2172),
    [anon_sym_add] = ACTIONS(2172),
    [anon_sym_sub] = ACTIONS(2172),
    [anon_sym_and] = ACTIONS(2172),
    [anon_sym_nand] = ACTIONS(2172),
    [anon_sym_or] = ACTIONS(2172),
    [anon_sym_xor] = ACTIONS(2172),
    [anon_sym_max] = ACTIONS(2172),
    [anon_sym_min] = ACTIONS(2172),
    [anon_sym_umax] = ACTIONS(2172),
    [anon_sym_umin] = ACTIONS(2172),
    [anon_sym_fadd] = ACTIONS(2172),
    [anon_sym_fsub] = ACTIONS(2172),
    [anon_sym_bitcast] = ACTIONS(2172),
    [anon_sym_trunc] = ACTIONS(2172),
    [anon_sym_zext] = ACTIONS(2172),
    [anon_sym_sext] = ACTIONS(2172),
    [anon_sym_fptrunc] = ACTIONS(2172),
    [anon_sym_fpext] = ACTIONS(2172),
    [anon_sym_addrspacecast] = ACTIONS(2172),
    [anon_sym_uitofp] = ACTIONS(2172),
    [anon_sym_sitofp] = ACTIONS(2172),
    [anon_sym_fptoui] = ACTIONS(2172),
    [anon_sym_fptosi] = ACTIONS(2172),
    [anon_sym_inttoptr] = ACTIONS(2172),
    [anon_sym_ptrtoint] = ACTIONS(2172),
    [anon_sym_uselistorder] = ACTIONS(2172),
  },
  [649] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2174),
    [sym_label] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_unreachable] = ACTIONS(2179),
    [anon_sym_ret] = ACTIONS(2179),
    [anon_sym_br] = ACTIONS(2179),
    [anon_sym_resume] = ACTIONS(2179),
    [anon_sym_freeze] = ACTIONS(2179),
    [anon_sym_indirectbr] = ACTIONS(2179),
    [anon_sym_extractelement] = ACTIONS(2179),
    [anon_sym_insertelement] = ACTIONS(2179),
    [anon_sym_select] = ACTIONS(2179),
    [anon_sym_shufflevector] = ACTIONS(2179),
    [anon_sym_fneg] = ACTIONS(2179),
    [anon_sym_switch] = ACTIONS(2179),
    [anon_sym_invoke] = ACTIONS(2179),
    [anon_sym_cleanupret] = ACTIONS(2179),
    [anon_sym_catchret] = ACTIONS(2179),
    [anon_sym_catchswitch] = ACTIONS(2179),
    [anon_sym_catchpad] = ACTIONS(2179),
    [anon_sym_cleanuppad] = ACTIONS(2179),
    [anon_sym_callbr] = ACTIONS(2179),
    [anon_sym_icmp] = ACTIONS(2179),
    [anon_sym_fcmp] = ACTIONS(2179),
    [anon_sym_va_arg] = ACTIONS(2179),
    [anon_sym_phi] = ACTIONS(2179),
    [anon_sym_landingpad] = ACTIONS(2179),
    [anon_sym_tail] = ACTIONS(2179),
    [anon_sym_musttail] = ACTIONS(2179),
    [anon_sym_notail] = ACTIONS(2179),
    [anon_sym_call] = ACTIONS(2179),
    [anon_sym_alloca] = ACTIONS(2179),
    [anon_sym_load] = ACTIONS(2179),
    [anon_sym_store] = ACTIONS(2179),
    [anon_sym_cmpxchg] = ACTIONS(2179),
    [anon_sym_atomicrmw] = ACTIONS(2179),
    [anon_sym_fence] = ACTIONS(2179),
    [anon_sym_getelementptr] = ACTIONS(2179),
    [anon_sym_extractvalue] = ACTIONS(2179),
    [anon_sym_insertvalue] = ACTIONS(2179),
    [anon_sym_mul] = ACTIONS(2179),
    [anon_sym_urem] = ACTIONS(2179),
    [anon_sym_srem] = ACTIONS(2179),
    [anon_sym_shl] = ACTIONS(2179),
    [anon_sym_udiv] = ACTIONS(2179),
    [anon_sym_sdiv] = ACTIONS(2179),
    [anon_sym_lshr] = ACTIONS(2179),
    [anon_sym_ashr] = ACTIONS(2179),
    [anon_sym_fmul] = ACTIONS(2179),
    [anon_sym_fdiv] = ACTIONS(2179),
    [anon_sym_frem] = ACTIONS(2179),
    [anon_sym_xchg] = ACTIONS(2179),
    [anon_sym_add] = ACTIONS(2179),
    [anon_sym_sub] = ACTIONS(2179),
    [anon_sym_and] = ACTIONS(2179),
    [anon_sym_nand] = ACTIONS(2179),
    [anon_sym_or] = ACTIONS(2179),
    [anon_sym_xor] = ACTIONS(2179),
    [anon_sym_max] = ACTIONS(2179),
    [anon_sym_min] = ACTIONS(2179),
    [anon_sym_umax] = ACTIONS(2179),
    [anon_sym_umin] = ACTIONS(2179),
    [anon_sym_fadd] = ACTIONS(2179),
    [anon_sym_fsub] = ACTIONS(2179),
    [anon_sym_bitcast] = ACTIONS(2179),
    [anon_sym_trunc] = ACTIONS(2179),
    [anon_sym_zext] = ACTIONS(2179),
    [anon_sym_sext] = ACTIONS(2179),
    [anon_sym_fptrunc] = ACTIONS(2179),
    [anon_sym_fpext] = ACTIONS(2179),
    [anon_sym_addrspacecast] = ACTIONS(2179),
    [anon_sym_uitofp] = ACTIONS(2179),
    [anon_sym_sitofp] = ACTIONS(2179),
    [anon_sym_fptoui] = ACTIONS(2179),
    [anon_sym_fptosi] = ACTIONS(2179),
    [anon_sym_inttoptr] = ACTIONS(2179),
    [anon_sym_ptrtoint] = ACTIONS(2179),
    [anon_sym_uselistorder] = ACTIONS(2179),
  },
  [650] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2181),
    [sym_label] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_unreachable] = ACTIONS(2183),
    [anon_sym_ret] = ACTIONS(2183),
    [anon_sym_br] = ACTIONS(2183),
    [anon_sym_resume] = ACTIONS(2183),
    [anon_sym_freeze] = ACTIONS(2183),
    [anon_sym_indirectbr] = ACTIONS(2183),
    [anon_sym_extractelement] = ACTIONS(2183),
    [anon_sym_insertelement] = ACTIONS(2183),
    [anon_sym_select] = ACTIONS(2183),
    [anon_sym_shufflevector] = ACTIONS(2183),
    [anon_sym_fneg] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_invoke] = ACTIONS(2183),
    [anon_sym_cleanupret] = ACTIONS(2183),
    [anon_sym_catchret] = ACTIONS(2183),
    [anon_sym_catchswitch] = ACTIONS(2183),
    [anon_sym_catchpad] = ACTIONS(2183),
    [anon_sym_cleanuppad] = ACTIONS(2183),
    [anon_sym_callbr] = ACTIONS(2183),
    [anon_sym_icmp] = ACTIONS(2183),
    [anon_sym_fcmp] = ACTIONS(2183),
    [anon_sym_va_arg] = ACTIONS(2183),
    [anon_sym_phi] = ACTIONS(2183),
    [anon_sym_landingpad] = ACTIONS(2183),
    [anon_sym_tail] = ACTIONS(2183),
    [anon_sym_musttail] = ACTIONS(2183),
    [anon_sym_notail] = ACTIONS(2183),
    [anon_sym_call] = ACTIONS(2183),
    [anon_sym_alloca] = ACTIONS(2183),
    [anon_sym_load] = ACTIONS(2183),
    [anon_sym_store] = ACTIONS(2183),
    [anon_sym_cmpxchg] = ACTIONS(2183),
    [anon_sym_atomicrmw] = ACTIONS(2183),
    [anon_sym_fence] = ACTIONS(2183),
    [anon_sym_getelementptr] = ACTIONS(2183),
    [anon_sym_extractvalue] = ACTIONS(2183),
    [anon_sym_insertvalue] = ACTIONS(2183),
    [anon_sym_mul] = ACTIONS(2183),
    [anon_sym_urem] = ACTIONS(2183),
    [anon_sym_srem] = ACTIONS(2183),
    [anon_sym_shl] = ACTIONS(2183),
    [anon_sym_udiv] = ACTIONS(2183),
    [anon_sym_sdiv] = ACTIONS(2183),
    [anon_sym_lshr] = ACTIONS(2183),
    [anon_sym_ashr] = ACTIONS(2183),
    [anon_sym_fmul] = ACTIONS(2183),
    [anon_sym_fdiv] = ACTIONS(2183),
    [anon_sym_frem] = ACTIONS(2183),
    [anon_sym_xchg] = ACTIONS(2183),
    [anon_sym_add] = ACTIONS(2183),
    [anon_sym_sub] = ACTIONS(2183),
    [anon_sym_and] = ACTIONS(2183),
    [anon_sym_nand] = ACTIONS(2183),
    [anon_sym_or] = ACTIONS(2183),
    [anon_sym_xor] = ACTIONS(2183),
    [anon_sym_max] = ACTIONS(2183),
    [anon_sym_min] = ACTIONS(2183),
    [anon_sym_umax] = ACTIONS(2183),
    [anon_sym_umin] = ACTIONS(2183),
    [anon_sym_fadd] = ACTIONS(2183),
    [anon_sym_fsub] = ACTIONS(2183),
    [anon_sym_bitcast] = ACTIONS(2183),
    [anon_sym_trunc] = ACTIONS(2183),
    [anon_sym_zext] = ACTIONS(2183),
    [anon_sym_sext] = ACTIONS(2183),
    [anon_sym_fptrunc] = ACTIONS(2183),
    [anon_sym_fpext] = ACTIONS(2183),
    [anon_sym_addrspacecast] = ACTIONS(2183),
    [anon_sym_uitofp] = ACTIONS(2183),
    [anon_sym_sitofp] = ACTIONS(2183),
    [anon_sym_fptoui] = ACTIONS(2183),
    [anon_sym_fptosi] = ACTIONS(2183),
    [anon_sym_inttoptr] = ACTIONS(2183),
    [anon_sym_ptrtoint] = ACTIONS(2183),
    [anon_sym_uselistorder] = ACTIONS(2183),
  },
  [651] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2185),
    [sym_label] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_unreachable] = ACTIONS(2187),
    [anon_sym_ret] = ACTIONS(2187),
    [anon_sym_br] = ACTIONS(2187),
    [anon_sym_resume] = ACTIONS(2187),
    [anon_sym_freeze] = ACTIONS(2187),
    [anon_sym_indirectbr] = ACTIONS(2187),
    [anon_sym_extractelement] = ACTIONS(2187),
    [anon_sym_insertelement] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_shufflevector] = ACTIONS(2187),
    [anon_sym_fneg] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_invoke] = ACTIONS(2187),
    [anon_sym_cleanupret] = ACTIONS(2187),
    [anon_sym_catchret] = ACTIONS(2187),
    [anon_sym_catchswitch] = ACTIONS(2187),
    [anon_sym_catchpad] = ACTIONS(2187),
    [anon_sym_cleanuppad] = ACTIONS(2187),
    [anon_sym_callbr] = ACTIONS(2187),
    [anon_sym_icmp] = ACTIONS(2187),
    [anon_sym_fcmp] = ACTIONS(2187),
    [anon_sym_va_arg] = ACTIONS(2187),
    [anon_sym_phi] = ACTIONS(2187),
    [anon_sym_landingpad] = ACTIONS(2187),
    [anon_sym_tail] = ACTIONS(2187),
    [anon_sym_musttail] = ACTIONS(2187),
    [anon_sym_notail] = ACTIONS(2187),
    [anon_sym_call] = ACTIONS(2187),
    [anon_sym_alloca] = ACTIONS(2187),
    [anon_sym_load] = ACTIONS(2187),
    [anon_sym_store] = ACTIONS(2187),
    [anon_sym_cmpxchg] = ACTIONS(2187),
    [anon_sym_atomicrmw] = ACTIONS(2187),
    [anon_sym_fence] = ACTIONS(2187),
    [anon_sym_getelementptr] = ACTIONS(2187),
    [anon_sym_extractvalue] = ACTIONS(2187),
    [anon_sym_insertvalue] = ACTIONS(2187),
    [anon_sym_mul] = ACTIONS(2187),
    [anon_sym_urem] = ACTIONS(2187),
    [anon_sym_srem] = ACTIONS(2187),
    [anon_sym_shl] = ACTIONS(2187),
    [anon_sym_udiv] = ACTIONS(2187),
    [anon_sym_sdiv] = ACTIONS(2187),
    [anon_sym_lshr] = ACTIONS(2187),
    [anon_sym_ashr] = ACTIONS(2187),
    [anon_sym_fmul] = ACTIONS(2187),
    [anon_sym_fdiv] = ACTIONS(2187),
    [anon_sym_frem] = ACTIONS(2187),
    [anon_sym_xchg] = ACTIONS(2187),
    [anon_sym_add] = ACTIONS(2187),
    [anon_sym_sub] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_nand] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_xor] = ACTIONS(2187),
    [anon_sym_max] = ACTIONS(2187),
    [anon_sym_min] = ACTIONS(2187),
    [anon_sym_umax] = ACTIONS(2187),
    [anon_sym_umin] = ACTIONS(2187),
    [anon_sym_fadd] = ACTIONS(2187),
    [anon_sym_fsub] = ACTIONS(2187),
    [anon_sym_bitcast] = ACTIONS(2187),
    [anon_sym_trunc] = ACTIONS(2187),
    [anon_sym_zext] = ACTIONS(2187),
    [anon_sym_sext] = ACTIONS(2187),
    [anon_sym_fptrunc] = ACTIONS(2187),
    [anon_sym_fpext] = ACTIONS(2187),
    [anon_sym_addrspacecast] = ACTIONS(2187),
    [anon_sym_uitofp] = ACTIONS(2187),
    [anon_sym_sitofp] = ACTIONS(2187),
    [anon_sym_fptoui] = ACTIONS(2187),
    [anon_sym_fptosi] = ACTIONS(2187),
    [anon_sym_inttoptr] = ACTIONS(2187),
    [anon_sym_ptrtoint] = ACTIONS(2187),
    [anon_sym_uselistorder] = ACTIONS(2187),
  },
  [652] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2189),
    [sym_label] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2189),
    [anon_sym_unreachable] = ACTIONS(2191),
    [anon_sym_ret] = ACTIONS(2191),
    [anon_sym_br] = ACTIONS(2191),
    [anon_sym_resume] = ACTIONS(2191),
    [anon_sym_freeze] = ACTIONS(2191),
    [anon_sym_indirectbr] = ACTIONS(2191),
    [anon_sym_extractelement] = ACTIONS(2191),
    [anon_sym_insertelement] = ACTIONS(2191),
    [anon_sym_select] = ACTIONS(2191),
    [anon_sym_shufflevector] = ACTIONS(2191),
    [anon_sym_fneg] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_invoke] = ACTIONS(2191),
    [anon_sym_cleanupret] = ACTIONS(2191),
    [anon_sym_catchret] = ACTIONS(2191),
    [anon_sym_catchswitch] = ACTIONS(2191),
    [anon_sym_catchpad] = ACTIONS(2191),
    [anon_sym_cleanuppad] = ACTIONS(2191),
    [anon_sym_callbr] = ACTIONS(2191),
    [anon_sym_icmp] = ACTIONS(2191),
    [anon_sym_fcmp] = ACTIONS(2191),
    [anon_sym_va_arg] = ACTIONS(2191),
    [anon_sym_phi] = ACTIONS(2191),
    [anon_sym_landingpad] = ACTIONS(2191),
    [anon_sym_tail] = ACTIONS(2191),
    [anon_sym_musttail] = ACTIONS(2191),
    [anon_sym_notail] = ACTIONS(2191),
    [anon_sym_call] = ACTIONS(2191),
    [anon_sym_alloca] = ACTIONS(2191),
    [anon_sym_load] = ACTIONS(2191),
    [anon_sym_store] = ACTIONS(2191),
    [anon_sym_cmpxchg] = ACTIONS(2191),
    [anon_sym_atomicrmw] = ACTIONS(2191),
    [anon_sym_fence] = ACTIONS(2191),
    [anon_sym_getelementptr] = ACTIONS(2191),
    [anon_sym_extractvalue] = ACTIONS(2191),
    [anon_sym_insertvalue] = ACTIONS(2191),
    [anon_sym_mul] = ACTIONS(2191),
    [anon_sym_urem] = ACTIONS(2191),
    [anon_sym_srem] = ACTIONS(2191),
    [anon_sym_shl] = ACTIONS(2191),
    [anon_sym_udiv] = ACTIONS(2191),
    [anon_sym_sdiv] = ACTIONS(2191),
    [anon_sym_lshr] = ACTIONS(2191),
    [anon_sym_ashr] = ACTIONS(2191),
    [anon_sym_fmul] = ACTIONS(2191),
    [anon_sym_fdiv] = ACTIONS(2191),
    [anon_sym_frem] = ACTIONS(2191),
    [anon_sym_xchg] = ACTIONS(2191),
    [anon_sym_add] = ACTIONS(2191),
    [anon_sym_sub] = ACTIONS(2191),
    [anon_sym_and] = ACTIONS(2191),
    [anon_sym_nand] = ACTIONS(2191),
    [anon_sym_or] = ACTIONS(2191),
    [anon_sym_xor] = ACTIONS(2191),
    [anon_sym_max] = ACTIONS(2191),
    [anon_sym_min] = ACTIONS(2191),
    [anon_sym_umax] = ACTIONS(2191),
    [anon_sym_umin] = ACTIONS(2191),
    [anon_sym_fadd] = ACTIONS(2191),
    [anon_sym_fsub] = ACTIONS(2191),
    [anon_sym_bitcast] = ACTIONS(2191),
    [anon_sym_trunc] = ACTIONS(2191),
    [anon_sym_zext] = ACTIONS(2191),
    [anon_sym_sext] = ACTIONS(2191),
    [anon_sym_fptrunc] = ACTIONS(2191),
    [anon_sym_fpext] = ACTIONS(2191),
    [anon_sym_addrspacecast] = ACTIONS(2191),
    [anon_sym_uitofp] = ACTIONS(2191),
    [anon_sym_sitofp] = ACTIONS(2191),
    [anon_sym_fptoui] = ACTIONS(2191),
    [anon_sym_fptosi] = ACTIONS(2191),
    [anon_sym_inttoptr] = ACTIONS(2191),
    [anon_sym_ptrtoint] = ACTIONS(2191),
    [anon_sym_uselistorder] = ACTIONS(2191),
  },
  [653] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2193),
    [sym_label] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_unreachable] = ACTIONS(2198),
    [anon_sym_ret] = ACTIONS(2198),
    [anon_sym_br] = ACTIONS(2198),
    [anon_sym_resume] = ACTIONS(2198),
    [anon_sym_freeze] = ACTIONS(2198),
    [anon_sym_indirectbr] = ACTIONS(2198),
    [anon_sym_extractelement] = ACTIONS(2198),
    [anon_sym_insertelement] = ACTIONS(2198),
    [anon_sym_select] = ACTIONS(2198),
    [anon_sym_shufflevector] = ACTIONS(2198),
    [anon_sym_fneg] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_invoke] = ACTIONS(2198),
    [anon_sym_cleanupret] = ACTIONS(2198),
    [anon_sym_catchret] = ACTIONS(2198),
    [anon_sym_catchswitch] = ACTIONS(2198),
    [anon_sym_catchpad] = ACTIONS(2198),
    [anon_sym_cleanuppad] = ACTIONS(2198),
    [anon_sym_callbr] = ACTIONS(2198),
    [anon_sym_icmp] = ACTIONS(2198),
    [anon_sym_fcmp] = ACTIONS(2198),
    [anon_sym_va_arg] = ACTIONS(2198),
    [anon_sym_phi] = ACTIONS(2198),
    [anon_sym_landingpad] = ACTIONS(2198),
    [anon_sym_tail] = ACTIONS(2198),
    [anon_sym_musttail] = ACTIONS(2198),
    [anon_sym_notail] = ACTIONS(2198),
    [anon_sym_call] = ACTIONS(2198),
    [anon_sym_alloca] = ACTIONS(2198),
    [anon_sym_load] = ACTIONS(2198),
    [anon_sym_store] = ACTIONS(2198),
    [anon_sym_cmpxchg] = ACTIONS(2198),
    [anon_sym_atomicrmw] = ACTIONS(2198),
    [anon_sym_fence] = ACTIONS(2198),
    [anon_sym_getelementptr] = ACTIONS(2198),
    [anon_sym_extractvalue] = ACTIONS(2198),
    [anon_sym_insertvalue] = ACTIONS(2198),
    [anon_sym_mul] = ACTIONS(2198),
    [anon_sym_urem] = ACTIONS(2198),
    [anon_sym_srem] = ACTIONS(2198),
    [anon_sym_shl] = ACTIONS(2198),
    [anon_sym_udiv] = ACTIONS(2198),
    [anon_sym_sdiv] = ACTIONS(2198),
    [anon_sym_lshr] = ACTIONS(2198),
    [anon_sym_ashr] = ACTIONS(2198),
    [anon_sym_fmul] = ACTIONS(2198),
    [anon_sym_fdiv] = ACTIONS(2198),
    [anon_sym_frem] = ACTIONS(2198),
    [anon_sym_xchg] = ACTIONS(2198),
    [anon_sym_add] = ACTIONS(2198),
    [anon_sym_sub] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_nand] = ACTIONS(2198),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_max] = ACTIONS(2198),
    [anon_sym_min] = ACTIONS(2198),
    [anon_sym_umax] = ACTIONS(2198),
    [anon_sym_umin] = ACTIONS(2198),
    [anon_sym_fadd] = ACTIONS(2198),
    [anon_sym_fsub] = ACTIONS(2198),
    [anon_sym_bitcast] = ACTIONS(2198),
    [anon_sym_trunc] = ACTIONS(2198),
    [anon_sym_zext] = ACTIONS(2198),
    [anon_sym_sext] = ACTIONS(2198),
    [anon_sym_fptrunc] = ACTIONS(2198),
    [anon_sym_fpext] = ACTIONS(2198),
    [anon_sym_addrspacecast] = ACTIONS(2198),
    [anon_sym_uitofp] = ACTIONS(2198),
    [anon_sym_sitofp] = ACTIONS(2198),
    [anon_sym_fptoui] = ACTIONS(2198),
    [anon_sym_fptosi] = ACTIONS(2198),
    [anon_sym_inttoptr] = ACTIONS(2198),
    [anon_sym_ptrtoint] = ACTIONS(2198),
    [anon_sym_uselistorder] = ACTIONS(2198),
  },
  [654] = {
    [sym_constant_expr] = STATE(392),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(2200),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [655] = {
    [sym_constant_expr] = STATE(394),
    [sym_constant_cast] = STATE(326),
    [sym_constant_getelementptr] = STATE(326),
    [sym_constant_select] = STATE(326),
    [sym_constant_icmp] = STATE(326),
    [sym_constant_fcmp] = STATE(326),
    [sym_constant_extractelement] = STATE(326),
    [sym_constant_insertelement] = STATE(326),
    [sym_constant_shufflevector] = STATE(326),
    [sym_constant_extractvalue] = STATE(326),
    [sym_constant_insertvalue] = STATE(326),
    [sym_constant_fneg] = STATE(326),
    [sym_constant_bin_op] = STATE(326),
    [sym_bin_op_keyword] = STATE(1070),
    [sym_atomic_bin_op_keyword] = STATE(716),
    [sym_cast_inst] = STATE(1768),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(2202),
    [anon_sym_extractelement] = ACTIONS(341),
    [anon_sym_insertelement] = ACTIONS(343),
    [anon_sym_select] = ACTIONS(345),
    [anon_sym_shufflevector] = ACTIONS(347),
    [anon_sym_fneg] = ACTIONS(349),
    [anon_sym_icmp] = ACTIONS(351),
    [anon_sym_fcmp] = ACTIONS(353),
    [anon_sym_getelementptr] = ACTIONS(355),
    [anon_sym_extractvalue] = ACTIONS(357),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2222), 1,
      anon_sym_LBRACE,
    ACTIONS(2227), 1,
      anon_sym_LBRACK,
    ACTIONS(2230), 1,
      anon_sym_LT,
    ACTIONS(2233), 1,
      anon_sym_addrspace,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
    ACTIONS(2239), 1,
      anon_sym_BANG,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2204), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2213), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2225), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_RPAREN,
    ACTIONS(2210), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2216), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2219), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [92] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2264), 1,
      anon_sym_RPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(661), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [181] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2268), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [270] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2270), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [359] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2264), 1,
      anon_sym_GT,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(664), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [448] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2272), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [537] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(667), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [626] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2276), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [715] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2272), 1,
      anon_sym_GT,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [804] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2272), 1,
      anon_sym_RBRACK,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [893] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2278), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(663), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [982] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2280), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1071] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2264), 1,
      anon_sym_RBRACK,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(665), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1160] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1249] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2272), 1,
      anon_sym_RBRACE,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(656), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1338] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(659), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1427] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2264), 1,
      anon_sym_RBRACE,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(670), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1516] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2286), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(669), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1605] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2254), 1,
      anon_sym_LBRACE,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2258), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      anon_sym_addrspace,
    ACTIONS(2262), 1,
      anon_sym_LPAREN,
    ACTIONS(2266), 1,
      anon_sym_BANG,
    ACTIONS(2288), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_metadata_ref,
    ACTIONS(2242), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2248), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(658), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2246), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(687), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2250), 9,
      sym_float,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2252), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 1,
      anon_sym_LT,
    ACTIONS(939), 48,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [1751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(925), 1,
      anon_sym_LT,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2290), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(923), 37,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [1811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(499), 30,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_LPAREN,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 1,
      anon_sym_LPAREN2,
    ACTIONS(585), 16,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(587), 30,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_LPAREN,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(397), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(399), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(687), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(691), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(657), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(2297), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(661), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(116), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(122), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(503), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(2301), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(2305), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(665), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_COLON,
    ACTIONS(681), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_none,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2571] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1599), 1,
      sym_type_and_value,
    STATE(692), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2307), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2642] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1812), 1,
      sym_type_and_value,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2311), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2713] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2313), 1,
      anon_sym_no_cfi,
    ACTIONS(2319), 1,
      anon_sym_dso_local,
    ACTIONS(2327), 1,
      anon_sym_externally_initialized,
    ACTIONS(2331), 1,
      anon_sym_thread_local,
    STATE(1097), 1,
      sym_thread_local,
    STATE(1110), 1,
      sym_unnamed_addr,
    STATE(1145), 1,
      sym_addrspace,
    ACTIONS(747), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(694), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2317), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    ACTIONS(2329), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
    STATE(774), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2315), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
  [2789] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2313), 1,
      anon_sym_no_cfi,
    ACTIONS(2319), 1,
      anon_sym_dso_local,
    ACTIONS(2331), 1,
      anon_sym_thread_local,
    ACTIONS(2333), 1,
      anon_sym_externally_initialized,
    STATE(1096), 1,
      sym_thread_local,
    STATE(1111), 1,
      sym_unnamed_addr,
    STATE(1148), 1,
      sym_addrspace,
    ACTIONS(747), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(709), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2317), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    ACTIONS(2335), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
    STATE(774), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2315), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
  [2865] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1805), 1,
      sym_type_and_value,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2931] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1533), 1,
      sym_type_and_value,
    STATE(695), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2997] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(626), 1,
      sym_type_and_value,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3063] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(635), 1,
      sym_type_and_value,
    STATE(697), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3129] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1551), 1,
      sym_type,
    STATE(700), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3190] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1818), 1,
      sym_type,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3251] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(2341), 1,
      anon_sym_RBRACE,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1301), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3323] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(2343), 1,
      anon_sym_RBRACE,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1204), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3395] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(2345), 1,
      anon_sym_RBRACE,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1317), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3467] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(985), 1,
      anon_sym_metadata,
    ACTIONS(2347), 1,
      anon_sym_distinct,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(268), 1,
      sym_type,
    STATE(1052), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3539] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(2349), 1,
      anon_sym_RBRACE,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1337), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3611] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(2351), 1,
      anon_sym_RBRACE,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1315), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_LT,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2357), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2360), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2353), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3732] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(220), 1,
      anon_sym_metadata,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(978), 1,
      anon_sym_null,
    STATE(2), 1,
      sym_type,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(224), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_no_cfi,
    ACTIONS(2372), 1,
      anon_sym_dso_local,
    ACTIONS(2375), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2381), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(709), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2369), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2378), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(774), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2366), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
    ACTIONS(843), 9,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [3860] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(985), 1,
      anon_sym_metadata,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(268), 1,
      sym_type,
    STATE(1058), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3929] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(985), 1,
      anon_sym_metadata,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(268), 1,
      sym_type,
    STATE(1049), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3998] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    ACTIONS(1271), 1,
      anon_sym_metadata,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(224), 1,
      sym_metadata,
    STATE(351), 1,
      sym_type,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4067] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(978), 1,
      anon_sym_null,
    STATE(105), 1,
      sym_metadata_ref,
    STATE(266), 1,
      sym_type,
    STATE(1353), 1,
      sym_metadata,
    STATE(128), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4136] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(138), 1,
      anon_sym_BANG,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2384), 1,
      anon_sym_null,
    STATE(130), 1,
      sym_metadata_ref,
    STATE(216), 1,
      sym_type,
    STATE(601), 1,
      sym_metadata,
    STATE(173), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      anon_sym_LT,
    ACTIONS(2386), 32,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [4246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      anon_sym_LT,
    ACTIONS(2390), 32,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [4287] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_comdat_ref,
    ACTIONS(9), 1,
      sym_global_var,
    ACTIONS(11), 1,
      sym_local_var,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(15), 1,
      sym_summary_ref,
    ACTIONS(17), 1,
      anon_sym_target,
    ACTIONS(19), 1,
      anon_sym_source_filename,
    ACTIONS(21), 1,
      anon_sym_declare,
    ACTIONS(23), 1,
      anon_sym_define,
    ACTIONS(25), 1,
      anon_sym_uselistorder,
    ACTIONS(27), 1,
      anon_sym_uselistorder_bb,
    ACTIONS(29), 1,
      anon_sym_module,
    ACTIONS(31), 1,
      anon_sym_attributes,
    ACTIONS(2394), 1,
      ts_builtin_sym_end,
    STATE(1168), 1,
      sym__global_prefix,
    STATE(1645), 1,
      sym_metadata_ref,
    STATE(719), 16,
      sym_target_definition,
      sym_source_file_name,
      sym_declare,
      sym_define,
      sym_use_list_order,
      sym_use_list_order_bb,
      sym_module_asm,
      sym_global_type,
      sym_global_global,
      sym_alias,
      sym_ifunc,
      sym_comdat,
      sym_global_metadata,
      sym_summary_entry,
      sym_unnamed_attr_grp,
      aux_sym_module_repeat1,
  [4357] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2396), 1,
      anon_sym_addrspace,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(216), 1,
      sym_type,
    STATE(622), 3,
      sym_addrspace,
      sym_type_and_value,
      sym_alignment,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4417] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      ts_builtin_sym_end,
    ACTIONS(2402), 1,
      sym_comdat_ref,
    ACTIONS(2405), 1,
      sym_global_var,
    ACTIONS(2408), 1,
      sym_local_var,
    ACTIONS(2411), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2414), 1,
      sym_summary_ref,
    ACTIONS(2417), 1,
      anon_sym_target,
    ACTIONS(2420), 1,
      anon_sym_source_filename,
    ACTIONS(2423), 1,
      anon_sym_declare,
    ACTIONS(2426), 1,
      anon_sym_define,
    ACTIONS(2429), 1,
      anon_sym_uselistorder,
    ACTIONS(2432), 1,
      anon_sym_uselistorder_bb,
    ACTIONS(2435), 1,
      anon_sym_module,
    ACTIONS(2438), 1,
      anon_sym_attributes,
    STATE(1168), 1,
      sym__global_prefix,
    STATE(1645), 1,
      sym_metadata_ref,
    STATE(719), 16,
      sym_target_definition,
      sym_source_file_name,
      sym_declare,
      sym_define,
      sym_use_list_order,
      sym_use_list_order_bb,
      sym_module_asm,
      sym_global_type,
      sym_global_global,
      sym_alias,
      sym_ifunc,
      sym_comdat,
      sym_global_metadata,
      sym_summary_entry,
      sym_unnamed_attr_grp,
      aux_sym_module_repeat1,
  [4487] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2441), 1,
      anon_sym_RPAREN,
    STATE(1336), 2,
      sym_number,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2443), 1,
      anon_sym_RPAREN,
    STATE(1292), 2,
      sym_number,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4601] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2447), 1,
      anon_sym_RPAREN,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(59), 1,
      sym_type,
    STATE(1259), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4659] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1369), 2,
      sym_number,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4713] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2451), 1,
      anon_sym_inbounds,
    ACTIONS(2453), 1,
      anon_sym_inrange,
    STATE(216), 1,
      sym_type,
    STATE(554), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4771] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1483), 2,
      sym_number,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4825] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2455), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(735), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1634), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4883] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2457), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1303), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4941] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2459), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1338), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4999] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2461), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1284), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(246), 1,
      anon_sym_uselistorder,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(950), 1,
      anon_sym_LPAREN,
    ACTIONS(2463), 1,
      anon_sym_STAR,
    STATE(261), 1,
      sym_addrspace,
    STATE(756), 1,
      aux_sym_type_repeat1,
    STATE(235), 2,
      sym_argument_list,
      aux_sym_type_repeat2,
    ACTIONS(244), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [5107] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2465), 1,
      anon_sym_atomic,
    ACTIONS(2467), 1,
      anon_sym_volatile,
    STATE(266), 1,
      sym_type,
    STATE(1555), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5165] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1754), 2,
      sym_number,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5219] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2469), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(726), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1634), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5277] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2471), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1214), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5335] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      sym_local_var,
    ACTIONS(2479), 1,
      anon_sym_metadata,
    ACTIONS(2482), 1,
      anon_sym_LBRACE,
    ACTIONS(2485), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    ACTIONS(2491), 1,
      anon_sym_RBRACK,
    ACTIONS(2493), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(735), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1634), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2476), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5393] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(236), 1,
      anon_sym_uselistorder,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(950), 1,
      anon_sym_LPAREN,
    ACTIONS(2496), 1,
      anon_sym_STAR,
    STATE(259), 1,
      sym_addrspace,
    STATE(792), 1,
      aux_sym_type_repeat1,
    STATE(730), 2,
      sym_argument_list,
      aux_sym_type_repeat2,
    ACTIONS(234), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [5443] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2498), 1,
      anon_sym_weak,
    ACTIONS(2500), 1,
      anon_sym_volatile,
    STATE(266), 1,
      sym_type,
    STATE(1556), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5501] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2502), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1176), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5559] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2504), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1318), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5617] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2506), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1466), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(895), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [5707] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2508), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1536), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2510), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1537), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5813] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2512), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1467), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5866] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2514), 1,
      anon_sym_RBRACE,
    STATE(266), 1,
      sym_type,
    STATE(1173), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      sym_local_var,
    ACTIONS(1085), 1,
      anon_sym_metadata,
    ACTIONS(1089), 1,
      anon_sym_LBRACE,
    ACTIONS(1091), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_LT,
    ACTIONS(2516), 1,
      anon_sym_RBRACE_GT,
    STATE(347), 1,
      sym_type,
    STATE(1172), 1,
      sym_type_and_value,
    STATE(473), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1083), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5976] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2518), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1254), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6031] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(2445), 1,
      anon_sym_metadata,
    ACTIONS(2449), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(59), 1,
      sym_type,
    STATE(1363), 1,
      sym_argument,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6086] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2520), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1525), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6139] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(323), 1,
      anon_sym_no_cfi,
    STATE(323), 1,
      sym_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(327), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(331), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    ACTIONS(428), 2,
      sym_global_var,
      sym_local_var,
    STATE(214), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(329), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(218), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(325), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [6194] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2522), 1,
      anon_sym_GT,
    STATE(266), 1,
      sym_type,
    STATE(1275), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6249] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2524), 1,
      anon_sym_inrange,
    STATE(216), 1,
      sym_type,
    STATE(544), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6304] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2526), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1312), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6359] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(323), 1,
      anon_sym_no_cfi,
    STATE(172), 1,
      sym_var,
    ACTIONS(140), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(327), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(331), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(214), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(329), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(218), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(325), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [6414] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2528), 1,
      anon_sym_GT,
    STATE(266), 1,
      sym_type,
    STATE(1233), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6469] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_uselistorder,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(950), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(247), 1,
      sym_argument_list,
    STATE(258), 1,
      sym_addrspace,
    ACTIONS(263), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [6518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2530), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1523), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6571] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2532), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1276), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6626] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2534), 1,
      anon_sym_volatile,
    STATE(266), 1,
      sym_type,
    STATE(1816), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6681] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2536), 1,
      anon_sym_volatile,
    STATE(266), 1,
      sym_type,
    STATE(1815), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6736] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2538), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1324), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6791] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2540), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1232), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6846] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      sym_local_var,
    ACTIONS(1085), 1,
      anon_sym_metadata,
    ACTIONS(1089), 1,
      anon_sym_LBRACE,
    ACTIONS(1091), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_RBRACE_GT,
    STATE(347), 1,
      sym_type,
    STATE(1231), 1,
      sym_type_and_value,
    STATE(473), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1083), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6901] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2544), 1,
      anon_sym_RBRACE,
    STATE(266), 1,
      sym_type,
    STATE(1228), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6956] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(323), 1,
      anon_sym_no_cfi,
    STATE(101), 1,
      sym_var,
    ACTIONS(33), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(327), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(331), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(214), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(329), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(218), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(325), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [7011] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(627), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7066] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(652), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7121] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2546), 1,
      anon_sym_inrange,
    STATE(216), 1,
      sym_type,
    STATE(562), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7176] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(650), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(907), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(905), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [7268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(911), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(909), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [7305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(917), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [7342] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(630), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(891), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [7434] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2548), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1334), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7489] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2550), 1,
      anon_sym_GT,
    STATE(266), 1,
      sym_type,
    STATE(1310), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2552), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1309), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7599] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      sym_local_var,
    ACTIONS(1085), 1,
      anon_sym_metadata,
    ACTIONS(1089), 1,
      anon_sym_LBRACE,
    ACTIONS(1091), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      anon_sym_RBRACE_GT,
    STATE(347), 1,
      sym_type,
    STATE(1308), 1,
      sym_type_and_value,
    STATE(473), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1083), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7654] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2556), 1,
      anon_sym_RPAREN,
    STATE(266), 1,
      sym_type,
    STATE(1261), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7709] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2558), 1,
      anon_sym_RBRACE,
    STATE(266), 1,
      sym_type,
    STATE(1307), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7764] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1255), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7819] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2562), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1692), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7872] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2564), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1674), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7925] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(544), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7980] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2568), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1581), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8033] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2570), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1252), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8088] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      anon_sym_GT,
    STATE(266), 1,
      sym_type,
    STATE(1208), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8143] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2574), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1575), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8196] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    STATE(266), 1,
      sym_type,
    STATE(1277), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8251] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2578), 1,
      anon_sym_RBRACK,
    STATE(266), 1,
      sym_type,
    STATE(1209), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8306] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    ACTIONS(2580), 1,
      anon_sym_to,
    STATE(216), 1,
      sym_type,
    STATE(578), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8361] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(246), 1,
      anon_sym_uselistorder,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(950), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(247), 1,
      sym_argument_list,
    STATE(261), 1,
      sym_addrspace,
    ACTIONS(244), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [8410] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2582), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1198), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8465] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2584), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1194), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8520] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(323), 1,
      anon_sym_no_cfi,
    STATE(1451), 1,
      sym_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(327), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(331), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    ACTIONS(1231), 2,
      sym_global_var,
      sym_local_var,
    STATE(214), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(329), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(218), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(325), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [8575] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      sym_local_var,
    ACTIONS(1085), 1,
      anon_sym_metadata,
    ACTIONS(1089), 1,
      anon_sym_LBRACE,
    ACTIONS(1091), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_LT,
    ACTIONS(2586), 1,
      anon_sym_RBRACE_GT,
    STATE(347), 1,
      sym_type,
    STATE(1210), 1,
      sym_type_and_value,
    STATE(473), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1083), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8630] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(580), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8685] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(531), 1,
      sym_type_and_value,
    STATE(592), 1,
      sym__load_store_suffix,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2588), 1,
      anon_sym_RBRACE,
    STATE(266), 1,
      sym_type,
    STATE(1211), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8795] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2590), 1,
      anon_sym_RBRACE_GT,
    STATE(1196), 1,
      sym_type,
    STATE(1520), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8848] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2592), 1,
      anon_sym_RPAREN,
    STATE(266), 1,
      sym_type,
    STATE(1243), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8903] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2594), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1286), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8958] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2596), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_type,
    STATE(1519), 1,
      sym_struct_body,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9011] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2598), 1,
      anon_sym_inalloca,
    ACTIONS(2600), 1,
      anon_sym_swifterror,
    STATE(561), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9064] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_inrange,
    STATE(266), 1,
      sym_type,
    STATE(1203), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2604), 1,
      anon_sym_atomic,
    ACTIONS(2606), 1,
      anon_sym_volatile,
    STATE(1552), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9172] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1689), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9224] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1665), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1677), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9328] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1181), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9380] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1497), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9432] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1286), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9484] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1494), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9536] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1490), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9588] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1678), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9640] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1534), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9692] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1680), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9744] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1535), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9796] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(560), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9848] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1681), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9900] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1099), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9952] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1682), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10004] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1227), 1,
      anon_sym_metadata,
    STATE(255), 1,
      sym_type,
    STATE(1031), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10056] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1683), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10108] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1601), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1673), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1134), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10264] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1463), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10316] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1462), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10368] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1461), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10420] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1684), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10472] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1460), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1685), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10576] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1459), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10628] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1104), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10680] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1583), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10732] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1589), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10784] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1530), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1686), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1457), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1669), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10992] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1646), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11044] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1455), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11096] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1600), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1687), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11200] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1477), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11252] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1688), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1658), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11356] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1695), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11408] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1611), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11460] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1191), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11512] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1479), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1532), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11616] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1194), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11668] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1488), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11720] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1612), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11772] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1614), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11824] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1802), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11876] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1098), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1657), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11980] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1698), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12032] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(575), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12084] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1615), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12136] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1632), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12188] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1660), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12240] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1699), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12292] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1668), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12344] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1491), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12396] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1700), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12448] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1701), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12500] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1702), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12552] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1703), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12604] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1704), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12656] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1729), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1705), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1502), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12812] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1706), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12864] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1707), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12916] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1528), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12968] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(631), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13020] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1504), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1767), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13124] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(375), 1,
      anon_sym_metadata,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    STATE(23), 1,
      sym_type,
    STATE(397), 1,
      sym_type_and_value,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13176] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1637), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1643), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13280] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(587), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13332] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1474), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1763), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13436] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1568), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1570), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1571), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1595), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1651), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1762), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(572), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13800] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1629), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13852] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1505), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1670), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1631), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14008] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1667), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14060] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1666), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14112] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1508), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14164] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1509), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14216] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1510), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14268] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1772), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14320] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1749), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14372] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1732), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1773), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1734), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1664), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1306), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14632] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1771), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14684] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1248), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14736] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1511), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14788] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1334), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14840] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1761), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14892] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1735), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14944] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1774), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14996] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1803), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15048] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(426), 1,
      anon_sym_metadata,
    STATE(56), 1,
      sym_type,
    STATE(414), 1,
      sym_type_and_value,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15100] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(562), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1512), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15204] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(610), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15256] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(606), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15308] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1640), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15360] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1810), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15412] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(422), 1,
      anon_sym_metadata,
    STATE(55), 1,
      sym_type,
    STATE(414), 1,
      sym_type_and_value,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15464] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1776), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15516] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1736), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1663), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15620] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(633), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1738), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15724] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1814), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15776] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(375), 1,
      anon_sym_metadata,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    STATE(23), 1,
      sym_type,
    STATE(414), 1,
      sym_type_and_value,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15828] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1821), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1815), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1739), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15984] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1662), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16036] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1741), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16088] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1269), 1,
      anon_sym_metadata,
    STATE(355), 1,
      sym_type,
    STATE(1760), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16140] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1816), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16192] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1809), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16244] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1808), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16296] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1312), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(612), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16400] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    ACTIONS(2608), 1,
      anon_sym_volatile,
    STATE(1817), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1742), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16502] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(614), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16554] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2610), 1,
      anon_sym_swifterror,
    STATE(570), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16604] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(550), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16656] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1756), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1785), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1786), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16812] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(560), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16864] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1744), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16916] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(617), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16968] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1819), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17020] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1820), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(634), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17124] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1806), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17176] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1613), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1745), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17280] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1787), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17332] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1616), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1746), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17436] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1617), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      sym_local_var,
    ACTIONS(128), 1,
      anon_sym_LBRACE,
    ACTIONS(130), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(132), 1,
      anon_sym_LBRACK,
    ACTIONS(134), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      anon_sym_metadata,
    STATE(4), 1,
      sym_type,
    STATE(204), 1,
      sym_type_and_value,
    STATE(31), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2612), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1618), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1747), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1696), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      sym_local_var,
    ACTIONS(1085), 1,
      anon_sym_metadata,
    ACTIONS(1089), 1,
      anon_sym_LBRACE,
    ACTIONS(1091), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1093), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_LT,
    STATE(347), 1,
      sym_type,
    STATE(1408), 1,
      sym_type_and_value,
    STATE(473), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1083), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1789), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17800] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1102), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17852] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(542), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17904] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1103), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1751), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18008] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1620), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18060] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1798), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18112] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2616), 1,
      anon_sym_metadata,
    STATE(230), 1,
      sym_type,
    STATE(545), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18164] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1799), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18216] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(369), 1,
      sym_local_var,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(381), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(383), 1,
      anon_sym_LBRACK,
    ACTIONS(385), 1,
      anon_sym_LT,
    ACTIONS(420), 1,
      anon_sym_metadata,
    STATE(57), 1,
      sym_type,
    STATE(414), 1,
      sym_type_and_value,
    STATE(63), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(373), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18268] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1800), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18320] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1290), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18372] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1793), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    ACTIONS(2339), 1,
      anon_sym_metadata,
    STATE(216), 1,
      sym_type,
    STATE(640), 1,
      sym_type_and_value,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1654), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(266), 1,
      sym_type,
    STATE(1655), 1,
      sym_type_and_value,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18580] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1526), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18627] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(350), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1796), 1,
      sym_fcmp_cond,
    STATE(1014), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [18713] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    STATE(613), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18760] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    STATE(563), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1748), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1788), 1,
      sym_fcmp_cond,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [18893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1783), 1,
      sym_fcmp_cond,
    STATE(994), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [18932] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    STATE(646), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1553), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(345), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1775), 1,
      sym_fcmp_cond,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1731), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19159] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(349), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19206] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1475), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1770), 1,
      sym_fcmp_cond,
    STATE(999), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19292] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(341), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(957), 1,
      sym_fcmp_cond,
    STATE(1015), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19378] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1409), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19425] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1473), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1476), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1635), 1,
      sym_fcmp_cond,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19558] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1351), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1503), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1797), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1067), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1801), 1,
      sym_fcmp_cond,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(976), 1,
      sym_fcmp_cond,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    STATE(1402), 1,
      sym_type,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19871] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1410), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19918] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(342), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1480), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20012] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1727), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1659), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1162), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1495), 1,
      sym_fcmp_cond,
    STATE(1009), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2618), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20192] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(348), 1,
      sym_type,
    STATE(238), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20239] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      sym_local_var,
    ACTIONS(874), 1,
      anon_sym_LBRACE,
    ACTIONS(876), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(878), 1,
      anon_sym_LBRACK,
    ACTIONS(880), 1,
      anon_sym_LT,
    STATE(570), 1,
      sym_type,
    STATE(262), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2337), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1817), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20333] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1649), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20380] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1456), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20427] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(737), 1,
      sym_local_var,
    STATE(1641), 1,
      sym_type,
    STATE(736), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 2,
      anon_sym_LT,
      anon_sym_BANG,
    ACTIONS(2620), 22,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_null,
  [20506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      anon_sym_LT,
    ACTIONS(2624), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [20536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_LT,
    ACTIONS(2628), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [20566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      anon_sym_LT,
    ACTIONS(2632), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [20596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      anon_sym_LT,
    ACTIONS(2636), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [20626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      anon_sym_uselistorder,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1428), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_uselistorder,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2642), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 1,
      anon_sym_uselistorder,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1404), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2648), 1,
      anon_sym_uselistorder,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2646), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_uselistorder,
    ACTIONS(2650), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1723), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2655), 1,
      anon_sym_uselistorder,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2653), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_uselistorder,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1424), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 1,
      anon_sym_uselistorder,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1420), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_uselistorder,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1039), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1416), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym_uselistorder,
    ACTIONS(2657), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_COMMA,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_uselistorder,
    ACTIONS(2661), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_volatile,
    STATE(933), 1,
      sym_atomic_bin_op_keyword,
    ACTIONS(110), 13,
      anon_sym_xchg,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_and,
      anon_sym_nand,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_max,
      anon_sym_min,
      anon_sym_umax,
      anon_sym_umin,
      anon_sym_fadd,
      anon_sym_fsub,
  [20958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_uselistorder,
    ACTIONS(2667), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [20981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_uselistorder,
    ACTIONS(2671), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_uselistorder,
    ACTIONS(1993), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_COMMA,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 1,
      anon_sym_uselistorder,
    ACTIONS(2675), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_uselistorder,
    ACTIONS(2679), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_uselistorder,
    ACTIONS(2683), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_uselistorder,
    ACTIONS(2687), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_uselistorder,
    ACTIONS(2691), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_uselistorder,
    ACTIONS(2695), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_LPAREN,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2311), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_uselistorder,
    ACTIONS(2701), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2707), 1,
      anon_sym_uselistorder,
    ACTIONS(2705), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_LPAREN,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2311), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    STATE(1056), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2713), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 1,
      anon_sym_LPAREN,
    STATE(1059), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2717), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_uselistorder,
    ACTIONS(2719), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 1,
      anon_sym_uselistorder,
    ACTIONS(2723), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_LPAREN,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2311), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_LPAREN,
    STATE(1064), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2731), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_LPAREN,
    STATE(707), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2311), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 1,
      anon_sym_uselistorder,
    ACTIONS(2735), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(955), 1,
      sym_atomic_bin_op_keyword,
    ACTIONS(110), 13,
      anon_sym_xchg,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_and,
      anon_sym_nand,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_max,
      anon_sym_min,
      anon_sym_umax,
      anon_sym_umin,
      anon_sym_fadd,
      anon_sym_fsub,
  [21473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_uselistorder,
    ACTIONS(2739), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2743), 1,
      anon_sym_LPAREN,
    STATE(1066), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2745), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 1,
      anon_sym_uselistorder,
    ACTIONS(2747), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_uselistorder,
    ACTIONS(2751), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_uselistorder,
    ACTIONS(2755), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 1,
      anon_sym_uselistorder,
    ACTIONS(2759), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2765), 1,
      anon_sym_uselistorder,
    ACTIONS(2763), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_uselistorder,
    ACTIONS(2767), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_uselistorder,
    ACTIONS(2771), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2777), 1,
      anon_sym_uselistorder,
    ACTIONS(2775), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_uselistorder,
    ACTIONS(2779), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_uselistorder,
    ACTIONS(2783), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2789), 1,
      anon_sym_uselistorder,
    ACTIONS(2787), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2793), 1,
      anon_sym_uselistorder,
    ACTIONS(2791), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_LPAREN,
    STATE(1084), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_LPAREN,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1795), 1,
      sym_icmp_cond,
    ACTIONS(2799), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [21846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1493), 1,
      sym_icmp_cond,
    ACTIONS(2799), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [21865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1782), 1,
      sym_icmp_cond,
    ACTIONS(2799), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [21884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1769), 1,
      sym_icmp_cond,
    ACTIONS(2799), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [21903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_LPAREN,
    STATE(1090), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_LPAREN,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_LPAREN,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LPAREN,
    STATE(1091), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [21987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_LPAREN,
    STATE(676), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_LPAREN,
    STATE(1093), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2309), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(958), 1,
      sym_icmp_cond,
    ACTIONS(2799), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [22048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2813), 1,
      anon_sym_externally_initialized,
    STATE(1109), 1,
      sym_unnamed_addr,
    STATE(1144), 1,
      sym_addrspace,
    ACTIONS(747), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2815), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2333), 1,
      anon_sym_externally_initialized,
    STATE(1111), 1,
      sym_unnamed_addr,
    STATE(1148), 1,
      sym_addrspace,
    ACTIONS(747), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2335), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(1107), 1,
      sym_syncscope,
    STATE(1108), 1,
      sym_atomic_ordering,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(649), 1,
      sym_atomic_ordering,
    STATE(1116), 1,
      sym_syncscope,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(637), 1,
      sym_atomic_ordering,
    STATE(1117), 1,
      sym_syncscope,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2825), 1,
      anon_sym_LPAREN,
    ACTIONS(2823), 8,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(624), 1,
      sym_atomic_ordering,
    STATE(1115), 1,
      sym_syncscope,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(1106), 1,
      sym_atomic_ordering,
    STATE(1112), 1,
      sym_syncscope,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_syncscope,
    STATE(1113), 1,
      sym_atomic_ordering,
    STATE(1114), 1,
      sym_syncscope,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 8,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(600), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1113), 1,
      sym_atomic_ordering,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(574), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2829), 1,
      anon_sym_externally_initialized,
    STATE(1133), 1,
      sym_addrspace,
    ACTIONS(2831), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2333), 1,
      anon_sym_externally_initialized,
    STATE(1148), 1,
      sym_addrspace,
    ACTIONS(2335), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(2813), 1,
      anon_sym_externally_initialized,
    STATE(1144), 1,
      sym_addrspace,
    ACTIONS(2815), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1108), 1,
      sym_atomic_ordering,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(596), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1118), 1,
      sym_atomic_ordering,
    ACTIONS(2817), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(597), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(624), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(647), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(609), 1,
      sym_atomic_ordering,
    ACTIONS(2821), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22464] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(74), 1,
      sym_argument_list,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(1515), 1,
      sym_addrspace,
  [22486] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(954), 1,
      anon_sym_STAR,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(523), 1,
      sym_argument_list,
    STATE(1515), 1,
      sym_addrspace,
  [22508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_LPAREN,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(46), 1,
      sym_argument_list,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(1515), 1,
      sym_addrspace,
  [22530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(954), 1,
      anon_sym_STAR,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(282), 1,
      sym_argument_list,
    STATE(1515), 1,
      sym_addrspace,
  [22552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22564] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2833), 1,
      anon_sym_LBRACE,
    STATE(712), 1,
      sym_metadata_name,
    STATE(1078), 1,
      sym_function_body,
    STATE(1151), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [22584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
    ACTIONS(2835), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_RPAREN,
  [22600] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2842), 1,
      anon_sym_alignstack,
    ACTIONS(2844), 1,
      anon_sym_unwind,
    ACTIONS(2846), 1,
      anon_sym_sideeffect,
    ACTIONS(2848), 1,
      anon_sym_inteldialect,
    STATE(1757), 1,
      sym_asm,
  [22622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2833), 1,
      anon_sym_LBRACE,
    STATE(712), 1,
      sym_metadata_name,
    STATE(1081), 1,
      sym_function_body,
    STATE(1124), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [22642] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(242), 1,
      anon_sym_LPAREN,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(16), 1,
      sym_argument_list,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(1515), 1,
      sym_addrspace,
  [22664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(2852), 1,
      anon_sym_LPAREN,
    STATE(1079), 1,
      sym_number,
    ACTIONS(2850), 2,
      sym_summary_ref,
      sym_string,
  [22684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [22696] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_addrspace,
    ACTIONS(950), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_STAR,
    STATE(237), 1,
      aux_sym_type_repeat1,
    STATE(247), 1,
      sym_argument_list,
    STATE(1515), 1,
      sym_addrspace,
  [22718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1518), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_externally_initialized,
    ACTIONS(2858), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 5,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1557), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1563), 1,
      sym_number,
    STATE(1566), 1,
      sym_array_vector_body,
  [22799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1469), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1468), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 5,
      anon_sym_any,
      anon_sym_exactmatch,
      anon_sym_largest,
      anon_sym_nodeduplicate,
      anon_sym_samesize,
  [22848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1521), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1561), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1563), 1,
      sym_number,
    STATE(1726), 1,
      sym_array_vector_body,
  [22905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1522), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 1,
      anon_sym_externally_initialized,
    ACTIONS(2831), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2333), 1,
      anon_sym_externally_initialized,
    ACTIONS(2335), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [22950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1538), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22969] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1516), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [22988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_externally_initialized,
    ACTIONS(2815), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2862), 1,
      anon_sym_alignstack,
    ACTIONS(2864), 1,
      anon_sym_unwind,
    ACTIONS(2866), 1,
      anon_sym_inteldialect,
    STATE(1724), 1,
      sym_asm,
  [23020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    ACTIONS(2854), 1,
      anon_sym_vscale,
    STATE(1539), 1,
      sym_array_vector_body,
    STATE(1563), 1,
      sym_number,
  [23039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      aux_sym_metadata_ref_token1,
    STATE(712), 1,
      sym_metadata_name,
    STATE(1151), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [23056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(2868), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_number,
  [23072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    ACTIONS(2441), 1,
      sym_string,
    STATE(206), 1,
      sym_number,
  [23088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(2870), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      sym_number,
  [23114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_COMMA,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
    ACTIONS(1800), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [23128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2864), 1,
      anon_sym_unwind,
    ACTIONS(2866), 1,
      anon_sym_inteldialect,
    STATE(1724), 1,
      sym_asm,
  [23154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    ACTIONS(2443), 1,
      sym_string,
    STATE(409), 1,
      sym_number,
  [23170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2875), 1,
      anon_sym_unwind,
    ACTIONS(2877), 1,
      anon_sym_inteldialect,
    STATE(1630), 1,
      sym_asm,
  [23186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 1,
      anon_sym_RBRACE,
    ACTIONS(2879), 1,
      anon_sym_uselistorder,
    STATE(1164), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [23200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 1,
      anon_sym_cleanup,
    STATE(534), 1,
      sym_landingpad_clause,
    ACTIONS(2883), 2,
      anon_sym_catch,
      anon_sym_filter,
  [23214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_RBRACE,
    ACTIONS(2887), 1,
      anon_sym_uselistorder,
    STATE(1164), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [23238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 1,
      anon_sym_uselistorder,
    ACTIONS(2890), 1,
      anon_sym_RBRACE,
    STATE(1164), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [23252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2831), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      anon_sym_alias,
    ACTIONS(2898), 1,
      anon_sym_ifunc,
    ACTIONS(2894), 2,
      anon_sym_global,
      anon_sym_constant,
  [23286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 1,
      anon_sym_triple,
    ACTIONS(2902), 1,
      anon_sym_datalayout,
    STATE(1082), 2,
      sym_target_triple,
      sym_data_layout,
  [23300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1190), 1,
      sym_number,
  [23313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2864), 1,
      anon_sym_unwind,
    STATE(1724), 1,
      sym_asm,
  [23326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    STATE(1332), 1,
      aux_sym_instruction_callbr_repeat1,
  [23339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_RBRACE,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    STATE(1325), 1,
      aux_sym_instruction_callbr_repeat1,
  [23352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 1,
      anon_sym_COMMA,
    ACTIONS(2915), 1,
      anon_sym_RPAREN,
    STATE(1174), 1,
      aux_sym_attribute_repeat1,
  [23365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1541), 1,
      sym_number,
  [23378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(2919), 1,
      anon_sym_RPAREN,
    STATE(1279), 1,
      aux_sym_argument_list_repeat1,
  [23391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_RBRACE,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1546), 1,
      sym_number,
  [23417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1548), 1,
      sym_number,
  [23430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1302), 1,
      sym_number,
  [23443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2927), 1,
      anon_sym_RPAREN,
    STATE(1218), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2929), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2931), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 3,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
      anon_sym_x,
  [23491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2933), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2935), 1,
      anon_sym_RPAREN,
    STATE(1185), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(568), 1,
      sym_number,
  [23530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2937), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2939), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2941), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2943), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2943), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2945), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2945), 1,
      anon_sym_RPAREN,
    STATE(1192), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(603), 1,
      sym_number,
  [23634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(2949), 1,
      anon_sym_COMMA,
    STATE(1316), 1,
      aux_sym_struct_body_repeat1,
  [23647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_RBRACE,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [23660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2955), 1,
      anon_sym_RPAREN,
    STATE(1193), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2957), 1,
      anon_sym_GT,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2959), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(2961), 1,
      anon_sym_RBRACE_GT,
    STATE(1293), 1,
      aux_sym_instruction_callbr_repeat1,
  [23712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2963), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2965), 1,
      anon_sym_RPAREN,
    STATE(1294), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(2967), 1,
      anon_sym_RBRACE,
    STATE(1197), 1,
      aux_sym_metadata_tuple_repeat1,
  [23751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1297), 1,
      sym_number,
  [23764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(2969), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [23777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1186), 1,
      sym_number,
  [23790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2971), 1,
      anon_sym_GT,
    STATE(1199), 1,
      aux_sym_instruction_callbr_repeat1,
  [23803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2973), 1,
      anon_sym_RBRACK,
    STATE(1200), 1,
      aux_sym_instruction_callbr_repeat1,
  [23816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(2975), 1,
      anon_sym_RBRACE_GT,
    STATE(1201), 1,
      aux_sym_instruction_callbr_repeat1,
  [23829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2977), 1,
      anon_sym_RBRACE,
    STATE(1202), 1,
      aux_sym_instruction_callbr_repeat1,
  [23842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2979), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2981), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(2983), 1,
      anon_sym_RPAREN,
    STATE(1206), 1,
      aux_sym_argument_list_repeat1,
  [23881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1811), 1,
      sym_number,
  [23894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [23907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2987), 1,
      anon_sym_RPAREN,
    STATE(1238), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2989), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(2875), 1,
      anon_sym_unwind,
    STATE(1630), 1,
      sym_asm,
  [23946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_RBRACE,
    STATE(1299), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 3,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
  [23968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(2927), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [23981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(2993), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [23994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(203), 1,
      sym_number,
  [24007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(450), 1,
      sym_number,
  [24020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [24033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_RBRACK,
    STATE(1226), 1,
      aux_sym_operand_bundles_repeat1,
  [24046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    STATE(1329), 1,
      aux_sym_instruction_callbr_repeat1,
  [24059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_LPAREN2,
    ACTIONS(585), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [24070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_RBRACK,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [24083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(3005), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      aux_sym_instruction_callbr_repeat1,
  [24096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3007), 1,
      anon_sym_RBRACK,
    STATE(1216), 1,
      aux_sym_instruction_callbr_repeat1,
  [24109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3009), 1,
      anon_sym_GT,
    STATE(1314), 1,
      aux_sym_instruction_callbr_repeat1,
  [24122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3011), 1,
      anon_sym_RBRACK,
    STATE(1230), 1,
      aux_sym_operand_bundles_repeat1,
  [24135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3011), 1,
      anon_sym_RBRACK,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [24148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3013), 1,
      anon_sym_GT,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [24161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3015), 1,
      anon_sym_RBRACK,
    STATE(1235), 1,
      aux_sym_operand_bundles_repeat1,
  [24174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3017), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_COMMA,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    STATE(1174), 1,
      aux_sym_attribute_repeat1,
  [24213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3025), 1,
      anon_sym_RBRACK,
    STATE(1278), 1,
      aux_sym_operand_bundles_repeat1,
  [24226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3027), 1,
      anon_sym_RBRACE,
    STATE(1177), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3029), 1,
      anon_sym_RPAREN,
    STATE(1281), 1,
      aux_sym_instruction_callbr_repeat1,
  [24252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3031), 1,
      anon_sym_RPAREN,
    STATE(1239), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 3,
      anon_sym_localdynamic,
      anon_sym_initialexec,
      anon_sym_localexec,
  [24274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3035), 1,
      anon_sym_RPAREN,
    STATE(1266), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3037), 1,
      anon_sym_RPAREN,
    STATE(1182), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3039), 1,
      anon_sym_RPAREN,
    STATE(1183), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3039), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3041), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [24339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_RBRACE,
    ACTIONS(3043), 1,
      anon_sym_COMMA,
    STATE(1270), 1,
      aux_sym_struct_body_repeat1,
  [24352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3045), 1,
      anon_sym_RPAREN,
    STATE(1305), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      anon_sym_RPAREN,
    ACTIONS(3047), 1,
      anon_sym_COMMA,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3050), 1,
      anon_sym_RBRACK,
    STATE(1342), 1,
      aux_sym_instruction_callbr_repeat1,
  [24391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_RBRACK,
    STATE(1213), 1,
      aux_sym_instruction_callbr_repeat1,
  [24404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_COMMA,
    ACTIONS(3057), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [24417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1506), 1,
      sym_number,
  [24430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(576), 1,
      sym_number,
  [24443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RPAREN,
    STATE(1265), 1,
      aux_sym_argument_list_repeat1,
  [24456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3061), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
    STATE(1250), 1,
      aux_sym_instruction_callbr_repeat1,
  [24482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3065), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [24508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3069), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [24521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3071), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [24534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3073), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1514), 1,
      sym_number,
  [24560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3075), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [24573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_RBRACE,
    ACTIONS(3079), 1,
      anon_sym_COMMA,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [24586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_RBRACE,
    STATE(1287), 1,
      aux_sym_struct_body_repeat1,
  [24599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      aux_sym_number_token1,
    ACTIONS(1237), 1,
      aux_sym_number_token2,
    STATE(1517), 1,
      sym_number,
  [24612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1527), 1,
      sym_number,
  [24625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(555), 1,
      sym_number,
  [24638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3084), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [24651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3086), 1,
      anon_sym_GT,
    STATE(1236), 1,
      aux_sym_instruction_callbr_repeat1,
  [24664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3088), 1,
      anon_sym_RBRACK,
    STATE(1263), 1,
      aux_sym_instruction_callbr_repeat1,
  [24677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3090), 1,
      anon_sym_RPAREN,
    STATE(1274), 1,
      aux_sym_instruction_callbr_repeat1,
  [24690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3092), 1,
      anon_sym_RBRACK,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [24703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3094), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [24716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3092), 1,
      anon_sym_RBRACK,
    STATE(1328), 1,
      aux_sym_operand_bundles_repeat1,
  [24729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3096), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [24742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1244), 1,
      sym_number,
  [24755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1246), 1,
      sym_number,
  [24768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3098), 1,
      anon_sym_RPAREN,
    STATE(1288), 1,
      aux_sym_argument_list_repeat1,
  [24781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    ACTIONS(3100), 1,
      anon_sym_unwind,
    STATE(1607), 1,
      sym_asm,
  [24794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3102), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_RBRACE,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    STATE(1287), 1,
      aux_sym_struct_body_repeat1,
  [24820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3109), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [24833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_RBRACK,
    ACTIONS(3113), 1,
      anon_sym_COMMA,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [24846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3116), 1,
      anon_sym_RBRACK,
    STATE(1212), 1,
      aux_sym_instruction_callbr_repeat1,
  [24859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(625), 1,
      sym_number,
  [24872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_COMMA,
    ACTIONS(3118), 1,
      anon_sym_RPAREN,
    STATE(1240), 1,
      aux_sym_attribute_repeat1,
  [24885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3120), 1,
      anon_sym_COMMA,
    STATE(1293), 1,
      aux_sym_instruction_callbr_repeat1,
  [24898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3102), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1217), 1,
      sym_number,
  [24924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_COMMA,
    ACTIONS(3123), 1,
      anon_sym_RPAREN,
    STATE(1174), 1,
      aux_sym_attribute_repeat1,
  [24937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3125), 1,
      anon_sym_RPAREN,
    STATE(1260), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1481), 1,
      sym_number,
  [24963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3127), 1,
      anon_sym_RBRACE,
    STATE(1156), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(555), 1,
      sym_number,
  [24989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3129), 1,
      anon_sym_RBRACE,
    STATE(1268), 1,
      aux_sym_metadata_tuple_repeat1,
  [25002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    STATE(1223), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [25015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3133), 1,
      anon_sym_RPAREN,
    STATE(1313), 1,
      aux_sym_argument_list_repeat1,
  [25028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      aux_sym_number_token1,
    ACTIONS(319), 1,
      aux_sym_number_token2,
    STATE(1247), 1,
      sym_number,
  [25041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3135), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    STATE(1262), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    STATE(1320), 1,
      aux_sym_instruction_callbr_repeat1,
  [25080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(3141), 1,
      anon_sym_RBRACE_GT,
    STATE(1321), 1,
      aux_sym_instruction_callbr_repeat1,
  [25093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3143), 1,
      anon_sym_RBRACK,
    STATE(1322), 1,
      aux_sym_instruction_callbr_repeat1,
  [25106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_GT,
    STATE(1323), 1,
      aux_sym_instruction_callbr_repeat1,
  [25119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3135), 1,
      anon_sym_RPAREN,
    STATE(1249), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3147), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [25158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3149), 1,
      anon_sym_GT,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3151), 1,
      anon_sym_RBRACE,
    STATE(1326), 1,
      aux_sym_metadata_tuple_repeat1,
  [25184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_RBRACE_GT,
    STATE(1327), 1,
      aux_sym_struct_body_repeat1,
  [25197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3153), 1,
      anon_sym_RBRACE,
    STATE(1264), 1,
      aux_sym_metadata_tuple_repeat1,
  [25210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      aux_sym_argument_list_repeat1,
  [25223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(3157), 1,
      anon_sym_RBRACE_GT,
    STATE(1293), 1,
      aux_sym_instruction_callbr_repeat1,
  [25236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 1,
      anon_sym_RBRACE_GT,
    STATE(1293), 1,
      aux_sym_instruction_callbr_repeat1,
  [25262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_GT,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    STATE(1335), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3169), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [25327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3173), 1,
      anon_sym_COMMA,
    STATE(1327), 1,
      aux_sym_struct_body_repeat1,
  [25340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACK,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [25353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3178), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACK,
    STATE(1340), 1,
      aux_sym_operand_bundles_repeat1,
  [25379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3180), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [25392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE_GT,
    STATE(1293), 1,
      aux_sym_instruction_callbr_repeat1,
  [25405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1273), 1,
      aux_sym_number_token2,
    STATE(565), 1,
      sym_number,
  [25418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_RPAREN,
    STATE(1311), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_COMMA,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
    STATE(1296), 1,
      aux_sym_attribute_repeat1,
  [25457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3188), 1,
      anon_sym_RBRACE,
    STATE(1341), 1,
      aux_sym_metadata_tuple_repeat1,
  [25470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3190), 1,
      anon_sym_RPAREN,
    STATE(1331), 1,
      aux_sym_argument_list_repeat1,
  [25483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
    STATE(1256), 1,
      aux_sym_argument_list_repeat1,
  [25496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3194), 1,
      anon_sym_RBRACK,
    STATE(1289), 1,
      aux_sym_operand_bundles_repeat1,
  [25509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    ACTIONS(3196), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      aux_sym_metadata_tuple_repeat1,
  [25522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACK,
    STATE(1125), 1,
      aux_sym_instruction_callbr_repeat1,
  [25535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(607), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_unwind,
    STATE(608), 1,
      sym__unwind_label,
  [25561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(472), 1,
      sym_argument_list,
  [25571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LPAREN,
    STATE(189), 1,
      sym_argument_list,
  [25581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_LBRACK,
    STATE(586), 1,
      sym__value_array,
  [25591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(382), 1,
      sym_argument_list,
  [25601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      aux_sym_metadata_ref_token1,
    STATE(711), 1,
      sym_metadata_name,
  [25611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
  [25619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LPAREN,
    STATE(186), 1,
      sym_argument_list,
  [25629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [25637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(386), 1,
      sym_argument_list,
  [25647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(470), 1,
      sym_argument_list,
  [25657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    STATE(1724), 1,
      sym_asm,
  [25667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_unwind,
    STATE(604), 1,
      sym__unwind_label,
  [25677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(468), 1,
      sym_argument_list,
  [25703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    STATE(1630), 1,
      sym_asm,
  [25713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      sym_string,
    ACTIONS(3212), 1,
      anon_sym_LBRACE2,
  [25723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_LPAREN,
    ACTIONS(3216), 1,
      anon_sym_inbounds,
  [25741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_LPAREN,
    ACTIONS(3220), 1,
      anon_sym_inbounds,
  [25751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3224), 1,
      anon_sym_inbounds,
  [25761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(459), 1,
      sym_argument_list,
  [25771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    STATE(1055), 1,
      sym_asm,
  [25781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [25789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LPAREN,
    STATE(184), 1,
      sym_argument_list,
  [25799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(469), 1,
      sym_argument_list,
  [25809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    STATE(1607), 1,
      sym_asm,
  [25819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      sym_string,
    STATE(1592), 1,
      sym_asm,
  [25829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(593), 1,
      sym_alignment,
  [25839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      aux_sym_metadata_ref_token1,
    STATE(714), 1,
      sym_metadata_name,
  [25849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(598), 1,
      sym_alignment,
  [25859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(599), 1,
      sym_alignment,
  [25869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(611), 1,
      sym_alignment,
  [25879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(461), 1,
      sym_argument_list,
  [25889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(619), 1,
      sym_alignment,
  [25899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LPAREN,
    STATE(185), 1,
      sym_argument_list,
  [25925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [25933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(573), 1,
      sym_alignment,
  [25943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_align,
    STATE(623), 1,
      sym_alignment,
  [25953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(458), 1,
      sym_argument_list,
  [25963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [25979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3230), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [26003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(457), 1,
      sym_argument_list,
  [26013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(460), 1,
      sym_argument_list,
  [26023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 1,
      sym_string,
    ACTIONS(3234), 1,
      anon_sym_LBRACE2,
  [26033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_LBRACK,
    STATE(582), 1,
      sym__value_array,
  [26043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(379), 1,
      sym_argument_list,
  [26053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_LBRACK,
    STATE(581), 1,
      sym__value_array,
  [26071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_LBRACK,
    STATE(1345), 1,
      sym__value_array,
  [26081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3238), 2,
      sym_local_var,
      anon_sym_none,
  [26089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(380), 1,
      sym_argument_list,
  [26107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3242), 1,
      anon_sym_inbounds,
  [26117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(545), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
  [26157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [26165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [26173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 1,
      sym_string,
    ACTIONS(3248), 1,
      anon_sym_LBRACE2,
  [26183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(573), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [26287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_within,
    STATE(1396), 1,
      sym__within,
  [26329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(631), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_within,
    STATE(1399), 1,
      sym__within,
  [26363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(581), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 1,
      anon_sym_within,
    STATE(1400), 1,
      sym__within,
  [26397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    STATE(376), 1,
      sym_argument_list,
  [26407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [26415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(561), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      sym_string,
    ACTIONS(3254), 1,
      anon_sym_LBRACE2,
  [26489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(569), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(591), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [26529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
  [26536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 1,
      sym_global_var,
  [26543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
  [26550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_LPAREN,
  [26557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_RPAREN,
  [26564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      anon_sym_RPAREN,
  [26571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 1,
      anon_sym_RPAREN,
  [26578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_RPAREN,
  [26585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 1,
      anon_sym_RPAREN,
  [26592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_STAR,
  [26599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 1,
      sym_string,
  [26606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 1,
      anon_sym_RBRACE,
  [26613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 1,
      anon_sym_RBRACE_GT,
  [26620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_RBRACK,
  [26627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_GT,
  [26634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_LBRACE,
  [26641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3286), 1,
      sym_local_var,
  [26648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_LBRACE,
  [26655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_COMMA,
  [26662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_RPAREN,
  [26669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_RPAREN,
  [26676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 1,
      anon_sym_COMMA,
  [26683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_RPAREN,
  [26690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 1,
      anon_sym_RPAREN,
  [26697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_RPAREN,
  [26704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 1,
      sym_global_var,
  [26711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 1,
      anon_sym_RPAREN,
  [26718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3308), 1,
      anon_sym_EQ,
  [26725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 1,
      anon_sym_RPAREN,
  [26732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3312), 1,
      anon_sym_LBRACE2,
  [26739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3314), 1,
      anon_sym_from,
  [26746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3316), 1,
      anon_sym_from,
  [26753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3318), 1,
      anon_sym_LPAREN,
  [26760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_RPAREN,
  [26767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_STAR,
  [26774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 1,
      anon_sym_RPAREN,
  [26781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3324), 1,
      anon_sym_RPAREN,
  [26788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3326), 1,
      anon_sym_call,
  [26795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 1,
      anon_sym_LPAREN,
  [26802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3330), 1,
      anon_sym_RPAREN,
  [26809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3332), 1,
      anon_sym_LPAREN,
  [26816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3334), 1,
      anon_sym_LPAREN,
  [26823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_RPAREN,
  [26830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      sym_global_var,
  [26837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_COMMA,
  [26844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_string,
  [26851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3344), 1,
      anon_sym_RPAREN,
  [26858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3346), 1,
      anon_sym_RPAREN,
  [26865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3348), 1,
      anon_sym_RPAREN,
  [26872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3350), 1,
      anon_sym_RPAREN,
  [26879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 1,
      anon_sym_RPAREN,
  [26886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_RPAREN,
  [26893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3356), 1,
      anon_sym_RPAREN,
  [26900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_RPAREN,
  [26907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 1,
      anon_sym_RPAREN,
  [26914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 1,
      anon_sym_RPAREN,
  [26921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
  [26928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_RPAREN,
  [26935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      anon_sym_LPAREN,
  [26942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3370), 1,
      anon_sym_RPAREN,
  [26949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_STAR,
  [26956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 1,
      anon_sym_GT,
  [26963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 1,
      anon_sym_x,
  [26970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      anon_sym_RBRACK,
  [26977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
  [26984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_RBRACE_GT,
  [26991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_RBRACK,
  [26998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_GT,
  [27005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_RBRACE_GT,
  [27012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 1,
      anon_sym_to,
  [27019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_RBRACE,
  [27026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3390), 1,
      sym_global_var,
  [27033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_RPAREN,
  [27040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_COMMA,
  [27047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_LPAREN,
  [27054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3398), 1,
      anon_sym_COMMA,
  [27061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(391), 1,
      anon_sym_STAR,
  [27068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 1,
      anon_sym_COMMA,
  [27075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 1,
      anon_sym_COMMA,
  [27082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 1,
      anon_sym_COMMA,
  [27089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3406), 1,
      anon_sym_COMMA,
  [27096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3408), 1,
      anon_sym_RBRACE,
  [27103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_RBRACE_GT,
  [27110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3412), 1,
      anon_sym_RBRACK,
  [27117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_GT,
  [27124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3416), 1,
      anon_sym_to,
  [27131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
  [27138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3420), 1,
      sym_local_var,
  [27145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      sym_local_var,
  [27152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_STAR,
  [27159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      anon_sym_LPAREN,
  [27166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_RPAREN,
  [27173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3428), 1,
      anon_sym_LPAREN,
  [27180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_RPAREN,
  [27187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3432), 1,
      anon_sym_LPAREN,
  [27194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_to,
  [27201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_LBRACK,
  [27208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_COMMA,
  [27215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3440), 1,
      sym_global_var,
  [27222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_EQ,
  [27229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3444), 1,
      anon_sym_COMMA,
  [27236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 1,
      anon_sym_COMMA,
  [27243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym_GT,
  [27250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 1,
      aux_sym_specialized_md_value_token1,
  [27257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
  [27264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_STAR,
  [27271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_RBRACK,
  [27278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3456), 1,
      sym_comdat_ref,
  [27285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_x,
  [27292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_type,
  [27299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3462), 1,
      sym_string,
  [27306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_RBRACK,
  [27313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_RBRACK,
  [27320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_RPAREN,
  [27327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      sym_local_var,
  [27334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_RPAREN,
  [27341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_RPAREN,
  [27348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3476), 1,
      anon_sym_LPAREN,
  [27355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      sym_local_var,
  [27362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_to,
  [27369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_RBRACE_GT,
  [27376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_COMMA,
  [27383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_comdat,
  [27390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 1,
      anon_sym_to,
  [27397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_LPAREN,
  [27404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
  [27411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_RBRACE,
  [27418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3492), 1,
      sym_string,
  [27425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 1,
      anon_sym_COMMA,
  [27432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3496), 1,
      sym_string,
  [27439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_to,
  [27446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      sym_string,
  [27453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_LPAREN,
  [27460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_to,
  [27467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_COMMA,
  [27474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
  [27481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 1,
      anon_sym_LBRACK,
  [27488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_COMMA,
  [27495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      sym_string,
  [27502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_LPAREN,
  [27509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_RPAREN,
  [27516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_to,
  [27523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 1,
      sym_local_var,
  [27530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1904), 1,
      anon_sym_to,
  [27537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
  [27544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 1,
      anon_sym_to,
  [27551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_COMMA,
  [27558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 1,
      sym_string,
  [27565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_align,
  [27572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_RBRACK,
  [27579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_COLON,
  [27586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 1,
      anon_sym_LPAREN,
  [27593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_COMMA,
  [27600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 1,
      sym_string,
  [27607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 1,
      anon_sym_to,
  [27614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1968), 1,
      anon_sym_to,
  [27621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_COMMA,
  [27628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 1,
      anon_sym_COMMA,
  [27635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_RPAREN,
  [27642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3542), 1,
      anon_sym_COMMA,
  [27649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_COMMA,
  [27656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3546), 1,
      anon_sym_RPAREN,
  [27663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_RPAREN,
  [27670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3550), 1,
      anon_sym_RPAREN,
  [27677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3552), 1,
      sym_local_var,
  [27684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_COMMA,
  [27691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_align,
  [27698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 1,
      sym_local_var,
  [27705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 1,
      anon_sym_RBRACK,
  [27712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_unwind,
  [27719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 1,
      anon_sym_to,
  [27726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 1,
      anon_sym_LPAREN,
  [27733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
  [27740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      sym_string,
  [27747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 1,
      anon_sym_RPAREN,
  [27754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_COMMA,
  [27761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3572), 1,
      anon_sym_RPAREN,
  [27768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_RPAREN,
  [27775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_to,
  [27782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COMMA,
  [27789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3578), 1,
      anon_sym_LPAREN,
  [27796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3580), 1,
      anon_sym_LPAREN,
  [27803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_COMMA,
  [27810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3584), 1,
      anon_sym_LPAREN,
  [27817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_EQ,
  [27824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
  [27831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3590), 1,
      sym_global_var,
  [27838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_EQ,
  [27845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_COMMA,
  [27852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3596), 1,
      anon_sym_COMMA,
  [27859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_EQ,
  [27866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 1,
      anon_sym_RPAREN,
  [27873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_COMMA,
  [27880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_LPAREN,
  [27887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 1,
      sym_global_var,
  [27894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3608), 1,
      ts_builtin_sym_end,
  [27901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_COMMA,
  [27908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 1,
      sym_attr_ref,
  [27915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 1,
      anon_sym_LPAREN,
  [27922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_COMMA,
  [27929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3618), 1,
      anon_sym_COMMA,
  [27936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      anon_sym_COMMA,
  [27943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
  [27950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3624), 1,
      anon_sym_to,
  [27957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 1,
      sym_global_var,
  [27964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3628), 1,
      anon_sym_RPAREN,
  [27971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_asm,
  [27978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      anon_sym_COMMA,
  [27985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      anon_sym_COMMA,
  [27992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
  [27999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_to,
  [28006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 1,
      anon_sym_COMMA,
  [28013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
  [28020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 1,
      anon_sym_COMMA,
  [28027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_COMMA,
  [28034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 1,
      anon_sym_COMMA,
  [28041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_LPAREN,
  [28048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 1,
      anon_sym_LPAREN,
  [28055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 1,
      anon_sym_COMMA,
  [28062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 1,
      anon_sym_RBRACE,
  [28069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_align,
  [28076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3660), 1,
      anon_sym_LPAREN,
  [28083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_COMMA,
  [28090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 1,
      anon_sym_COMMA,
  [28097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_COMMA,
  [28104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 1,
      anon_sym_COMMA,
  [28111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 1,
      anon_sym_to,
  [28118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 1,
      anon_sym_COMMA,
  [28125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_COMMA,
  [28132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_COMMA,
  [28139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_COMMA,
  [28146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_COMMA,
  [28153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_COMMA,
  [28160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      anon_sym_COMMA,
  [28167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3686), 1,
      anon_sym_COMMA,
  [28174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_LPAREN,
  [28181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 1,
      anon_sym_COMMA,
  [28188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 1,
      anon_sym_RBRACE_GT,
  [28195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym_local_var,
  [28202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
  [28209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3698), 1,
      anon_sym_COMMA,
  [28216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_COMMA,
  [28223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3702), 1,
      anon_sym_COMMA,
  [28230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_COMMA,
  [28237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_to,
  [28244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 1,
      anon_sym_COMMA,
  [28251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_COMMA,
  [28258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 1,
      anon_sym_COMMA,
  [28265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3714), 1,
      anon_sym_COMMA,
  [28272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_COMMA,
  [28279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3718), 1,
      anon_sym_COMMA,
  [28286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3720), 1,
      anon_sym_COMMA,
  [28293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COMMA,
  [28300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3724), 1,
      anon_sym_LPAREN,
  [28307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_LPAREN,
  [28314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_LPAREN,
  [28321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LPAREN,
  [28328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      sym_global_var,
  [28335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_EQ,
  [28342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      anon_sym_unwind,
  [28349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      sym_global_var,
  [28356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3738), 1,
      anon_sym_EQ,
  [28363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_caller,
  [28370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_to,
  [28377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 1,
      anon_sym_EQ,
  [28384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_EQ,
  [28391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 1,
      sym_string,
  [28398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_EQ,
  [28405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 1,
      sym_string,
  [28412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_COMMA,
  [28419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 1,
      sym_global_var,
  [28426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      anon_sym_GT,
  [28433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 1,
      anon_sym_RPAREN,
  [28440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 1,
      anon_sym_LBRACE,
  [28447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
  [28454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3764), 1,
      sym_comdat_ref,
  [28461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 1,
      anon_sym_RPAREN,
  [28468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_RPAREN,
  [28475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_RPAREN,
  [28482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_COMMA,
  [28489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 1,
      anon_sym_COMMA,
  [28496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 1,
      anon_sym_COMMA,
  [28503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 1,
      sym_string,
  [28510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COMMA,
  [28517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3782), 1,
      anon_sym_COMMA,
  [28524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 1,
      sym_global_var,
  [28531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3786), 1,
      anon_sym_RPAREN,
  [28538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3788), 1,
      anon_sym_COMMA,
  [28545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_RPAREN,
  [28552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3792), 1,
      anon_sym_COMMA,
  [28559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3794), 1,
      anon_sym_COMMA,
  [28566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
  [28573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
  [28580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_COMMA,
  [28587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_RPAREN,
  [28594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_COMMA,
  [28601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
  [28608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_RPAREN,
  [28615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3810), 1,
      sym_global_var,
  [28622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_RPAREN,
  [28629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_unwind,
  [28636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_unwind,
  [28643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_COMMA,
  [28650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 1,
      sym_string,
  [28657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 1,
      anon_sym_x,
  [28664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_LBRACK,
  [28671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 1,
      anon_sym_COMMA,
  [28678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_COMMA,
  [28685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_COMMA,
  [28692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 1,
      anon_sym_LPAREN,
  [28699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      anon_sym_LPAREN,
  [28706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 1,
      anon_sym_LPAREN,
  [28713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
  [28720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 1,
      anon_sym_LPAREN,
  [28727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_LPAREN,
  [28734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 1,
      anon_sym_LPAREN,
  [28741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      anon_sym_RPAREN,
  [28748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_COMMA,
  [28755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 1,
      anon_sym_COMMA,
  [28762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3850), 1,
      anon_sym_COMMA,
  [28769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 1,
      anon_sym_LPAREN,
  [28776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 1,
      anon_sym_COMMA,
  [28783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_LPAREN,
  [28790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_LPAREN,
  [28797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 1,
      anon_sym_LPAREN,
  [28804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 1,
      anon_sym_RPAREN,
  [28811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LPAREN,
  [28818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_LPAREN,
  [28825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 1,
      anon_sym_LPAREN,
  [28832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3870), 1,
      sym_global_var,
  [28839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3872), 1,
      anon_sym_COMMA,
  [28846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_COMMA,
  [28853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 1,
      anon_sym_COMMA,
  [28860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_LPAREN,
  [28867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_COMMA,
  [28874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
  [28881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3884), 1,
      anon_sym_LPAREN,
  [28888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
  [28895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 1,
      anon_sym_COMMA,
  [28902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3890), 1,
      anon_sym_LPAREN,
  [28909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_LPAREN,
  [28916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_LPAREN,
  [28923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      sym_global_var,
  [28930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3898), 1,
      anon_sym_COMMA,
  [28937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3900), 1,
      anon_sym_COMMA,
  [28944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
  [28951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3904), 1,
      anon_sym_LPAREN,
  [28958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_COMMA,
  [28965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3908), 1,
      anon_sym_RPAREN,
  [28972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 1,
      anon_sym_RPAREN,
  [28979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3910), 1,
      anon_sym_COMMA,
  [28986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COMMA,
  [28993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 1,
      sym_local_var,
  [29000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3916), 1,
      anon_sym_COMMA,
  [29007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3918), 1,
      anon_sym_COMMA,
  [29014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 1,
      anon_sym_RPAREN,
  [29021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 1,
      anon_sym_RPAREN,
  [29028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 1,
      anon_sym_COMMA,
  [29035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 1,
      sym_string,
  [29042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
  [29049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3930), 1,
      anon_sym_COMMA,
  [29056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3932), 1,
      anon_sym_COMMA,
  [29063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3934), 1,
      anon_sym_COMMA,
  [29070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_LBRACK,
  [29077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3938), 1,
      anon_sym_COMMA,
  [29084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
  [29091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_RPAREN,
  [29098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
  [29105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_to,
  [29112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_LPAREN,
  [29119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3950), 1,
      anon_sym_LPAREN,
  [29126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      anon_sym_LPAREN,
  [29133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LPAREN,
  [29140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_LPAREN,
  [29147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 1,
      anon_sym_LPAREN,
  [29154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_LPAREN,
  [29161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3962), 1,
      anon_sym_LPAREN,
  [29168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 1,
      anon_sym_LPAREN,
  [29175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3966), 1,
      anon_sym_LPAREN,
  [29182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
  [29189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3970), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(656)] = 0,
  [SMALL_STATE(657)] = 92,
  [SMALL_STATE(658)] = 181,
  [SMALL_STATE(659)] = 270,
  [SMALL_STATE(660)] = 359,
  [SMALL_STATE(661)] = 448,
  [SMALL_STATE(662)] = 537,
  [SMALL_STATE(663)] = 626,
  [SMALL_STATE(664)] = 715,
  [SMALL_STATE(665)] = 804,
  [SMALL_STATE(666)] = 893,
  [SMALL_STATE(667)] = 982,
  [SMALL_STATE(668)] = 1071,
  [SMALL_STATE(669)] = 1160,
  [SMALL_STATE(670)] = 1249,
  [SMALL_STATE(671)] = 1338,
  [SMALL_STATE(672)] = 1427,
  [SMALL_STATE(673)] = 1516,
  [SMALL_STATE(674)] = 1605,
  [SMALL_STATE(675)] = 1694,
  [SMALL_STATE(676)] = 1751,
  [SMALL_STATE(677)] = 1811,
  [SMALL_STATE(678)] = 1866,
  [SMALL_STATE(679)] = 1923,
  [SMALL_STATE(680)] = 1977,
  [SMALL_STATE(681)] = 2031,
  [SMALL_STATE(682)] = 2085,
  [SMALL_STATE(683)] = 2139,
  [SMALL_STATE(684)] = 2193,
  [SMALL_STATE(685)] = 2247,
  [SMALL_STATE(686)] = 2301,
  [SMALL_STATE(687)] = 2355,
  [SMALL_STATE(688)] = 2409,
  [SMALL_STATE(689)] = 2463,
  [SMALL_STATE(690)] = 2517,
  [SMALL_STATE(691)] = 2571,
  [SMALL_STATE(692)] = 2642,
  [SMALL_STATE(693)] = 2713,
  [SMALL_STATE(694)] = 2789,
  [SMALL_STATE(695)] = 2865,
  [SMALL_STATE(696)] = 2931,
  [SMALL_STATE(697)] = 2997,
  [SMALL_STATE(698)] = 3063,
  [SMALL_STATE(699)] = 3129,
  [SMALL_STATE(700)] = 3190,
  [SMALL_STATE(701)] = 3251,
  [SMALL_STATE(702)] = 3323,
  [SMALL_STATE(703)] = 3395,
  [SMALL_STATE(704)] = 3467,
  [SMALL_STATE(705)] = 3539,
  [SMALL_STATE(706)] = 3611,
  [SMALL_STATE(707)] = 3683,
  [SMALL_STATE(708)] = 3732,
  [SMALL_STATE(709)] = 3801,
  [SMALL_STATE(710)] = 3860,
  [SMALL_STATE(711)] = 3929,
  [SMALL_STATE(712)] = 3998,
  [SMALL_STATE(713)] = 4067,
  [SMALL_STATE(714)] = 4136,
  [SMALL_STATE(715)] = 4205,
  [SMALL_STATE(716)] = 4246,
  [SMALL_STATE(717)] = 4287,
  [SMALL_STATE(718)] = 4357,
  [SMALL_STATE(719)] = 4417,
  [SMALL_STATE(720)] = 4487,
  [SMALL_STATE(721)] = 4544,
  [SMALL_STATE(722)] = 4601,
  [SMALL_STATE(723)] = 4659,
  [SMALL_STATE(724)] = 4713,
  [SMALL_STATE(725)] = 4771,
  [SMALL_STATE(726)] = 4825,
  [SMALL_STATE(727)] = 4883,
  [SMALL_STATE(728)] = 4941,
  [SMALL_STATE(729)] = 4999,
  [SMALL_STATE(730)] = 5057,
  [SMALL_STATE(731)] = 5107,
  [SMALL_STATE(732)] = 5165,
  [SMALL_STATE(733)] = 5219,
  [SMALL_STATE(734)] = 5277,
  [SMALL_STATE(735)] = 5335,
  [SMALL_STATE(736)] = 5393,
  [SMALL_STATE(737)] = 5443,
  [SMALL_STATE(738)] = 5501,
  [SMALL_STATE(739)] = 5559,
  [SMALL_STATE(740)] = 5617,
  [SMALL_STATE(741)] = 5670,
  [SMALL_STATE(742)] = 5707,
  [SMALL_STATE(743)] = 5760,
  [SMALL_STATE(744)] = 5813,
  [SMALL_STATE(745)] = 5866,
  [SMALL_STATE(746)] = 5921,
  [SMALL_STATE(747)] = 5976,
  [SMALL_STATE(748)] = 6031,
  [SMALL_STATE(749)] = 6086,
  [SMALL_STATE(750)] = 6139,
  [SMALL_STATE(751)] = 6194,
  [SMALL_STATE(752)] = 6249,
  [SMALL_STATE(753)] = 6304,
  [SMALL_STATE(754)] = 6359,
  [SMALL_STATE(755)] = 6414,
  [SMALL_STATE(756)] = 6469,
  [SMALL_STATE(757)] = 6518,
  [SMALL_STATE(758)] = 6571,
  [SMALL_STATE(759)] = 6626,
  [SMALL_STATE(760)] = 6681,
  [SMALL_STATE(761)] = 6736,
  [SMALL_STATE(762)] = 6791,
  [SMALL_STATE(763)] = 6846,
  [SMALL_STATE(764)] = 6901,
  [SMALL_STATE(765)] = 6956,
  [SMALL_STATE(766)] = 7011,
  [SMALL_STATE(767)] = 7066,
  [SMALL_STATE(768)] = 7121,
  [SMALL_STATE(769)] = 7176,
  [SMALL_STATE(770)] = 7231,
  [SMALL_STATE(771)] = 7268,
  [SMALL_STATE(772)] = 7305,
  [SMALL_STATE(773)] = 7342,
  [SMALL_STATE(774)] = 7397,
  [SMALL_STATE(775)] = 7434,
  [SMALL_STATE(776)] = 7489,
  [SMALL_STATE(777)] = 7544,
  [SMALL_STATE(778)] = 7599,
  [SMALL_STATE(779)] = 7654,
  [SMALL_STATE(780)] = 7709,
  [SMALL_STATE(781)] = 7764,
  [SMALL_STATE(782)] = 7819,
  [SMALL_STATE(783)] = 7872,
  [SMALL_STATE(784)] = 7925,
  [SMALL_STATE(785)] = 7980,
  [SMALL_STATE(786)] = 8033,
  [SMALL_STATE(787)] = 8088,
  [SMALL_STATE(788)] = 8143,
  [SMALL_STATE(789)] = 8196,
  [SMALL_STATE(790)] = 8251,
  [SMALL_STATE(791)] = 8306,
  [SMALL_STATE(792)] = 8361,
  [SMALL_STATE(793)] = 8410,
  [SMALL_STATE(794)] = 8465,
  [SMALL_STATE(795)] = 8520,
  [SMALL_STATE(796)] = 8575,
  [SMALL_STATE(797)] = 8630,
  [SMALL_STATE(798)] = 8685,
  [SMALL_STATE(799)] = 8740,
  [SMALL_STATE(800)] = 8795,
  [SMALL_STATE(801)] = 8848,
  [SMALL_STATE(802)] = 8903,
  [SMALL_STATE(803)] = 8958,
  [SMALL_STATE(804)] = 9011,
  [SMALL_STATE(805)] = 9064,
  [SMALL_STATE(806)] = 9119,
  [SMALL_STATE(807)] = 9172,
  [SMALL_STATE(808)] = 9224,
  [SMALL_STATE(809)] = 9276,
  [SMALL_STATE(810)] = 9328,
  [SMALL_STATE(811)] = 9380,
  [SMALL_STATE(812)] = 9432,
  [SMALL_STATE(813)] = 9484,
  [SMALL_STATE(814)] = 9536,
  [SMALL_STATE(815)] = 9588,
  [SMALL_STATE(816)] = 9640,
  [SMALL_STATE(817)] = 9692,
  [SMALL_STATE(818)] = 9744,
  [SMALL_STATE(819)] = 9796,
  [SMALL_STATE(820)] = 9848,
  [SMALL_STATE(821)] = 9900,
  [SMALL_STATE(822)] = 9952,
  [SMALL_STATE(823)] = 10004,
  [SMALL_STATE(824)] = 10056,
  [SMALL_STATE(825)] = 10108,
  [SMALL_STATE(826)] = 10160,
  [SMALL_STATE(827)] = 10212,
  [SMALL_STATE(828)] = 10264,
  [SMALL_STATE(829)] = 10316,
  [SMALL_STATE(830)] = 10368,
  [SMALL_STATE(831)] = 10420,
  [SMALL_STATE(832)] = 10472,
  [SMALL_STATE(833)] = 10524,
  [SMALL_STATE(834)] = 10576,
  [SMALL_STATE(835)] = 10628,
  [SMALL_STATE(836)] = 10680,
  [SMALL_STATE(837)] = 10732,
  [SMALL_STATE(838)] = 10784,
  [SMALL_STATE(839)] = 10836,
  [SMALL_STATE(840)] = 10888,
  [SMALL_STATE(841)] = 10940,
  [SMALL_STATE(842)] = 10992,
  [SMALL_STATE(843)] = 11044,
  [SMALL_STATE(844)] = 11096,
  [SMALL_STATE(845)] = 11148,
  [SMALL_STATE(846)] = 11200,
  [SMALL_STATE(847)] = 11252,
  [SMALL_STATE(848)] = 11304,
  [SMALL_STATE(849)] = 11356,
  [SMALL_STATE(850)] = 11408,
  [SMALL_STATE(851)] = 11460,
  [SMALL_STATE(852)] = 11512,
  [SMALL_STATE(853)] = 11564,
  [SMALL_STATE(854)] = 11616,
  [SMALL_STATE(855)] = 11668,
  [SMALL_STATE(856)] = 11720,
  [SMALL_STATE(857)] = 11772,
  [SMALL_STATE(858)] = 11824,
  [SMALL_STATE(859)] = 11876,
  [SMALL_STATE(860)] = 11928,
  [SMALL_STATE(861)] = 11980,
  [SMALL_STATE(862)] = 12032,
  [SMALL_STATE(863)] = 12084,
  [SMALL_STATE(864)] = 12136,
  [SMALL_STATE(865)] = 12188,
  [SMALL_STATE(866)] = 12240,
  [SMALL_STATE(867)] = 12292,
  [SMALL_STATE(868)] = 12344,
  [SMALL_STATE(869)] = 12396,
  [SMALL_STATE(870)] = 12448,
  [SMALL_STATE(871)] = 12500,
  [SMALL_STATE(872)] = 12552,
  [SMALL_STATE(873)] = 12604,
  [SMALL_STATE(874)] = 12656,
  [SMALL_STATE(875)] = 12708,
  [SMALL_STATE(876)] = 12760,
  [SMALL_STATE(877)] = 12812,
  [SMALL_STATE(878)] = 12864,
  [SMALL_STATE(879)] = 12916,
  [SMALL_STATE(880)] = 12968,
  [SMALL_STATE(881)] = 13020,
  [SMALL_STATE(882)] = 13072,
  [SMALL_STATE(883)] = 13124,
  [SMALL_STATE(884)] = 13176,
  [SMALL_STATE(885)] = 13228,
  [SMALL_STATE(886)] = 13280,
  [SMALL_STATE(887)] = 13332,
  [SMALL_STATE(888)] = 13384,
  [SMALL_STATE(889)] = 13436,
  [SMALL_STATE(890)] = 13488,
  [SMALL_STATE(891)] = 13540,
  [SMALL_STATE(892)] = 13592,
  [SMALL_STATE(893)] = 13644,
  [SMALL_STATE(894)] = 13696,
  [SMALL_STATE(895)] = 13748,
  [SMALL_STATE(896)] = 13800,
  [SMALL_STATE(897)] = 13852,
  [SMALL_STATE(898)] = 13904,
  [SMALL_STATE(899)] = 13956,
  [SMALL_STATE(900)] = 14008,
  [SMALL_STATE(901)] = 14060,
  [SMALL_STATE(902)] = 14112,
  [SMALL_STATE(903)] = 14164,
  [SMALL_STATE(904)] = 14216,
  [SMALL_STATE(905)] = 14268,
  [SMALL_STATE(906)] = 14320,
  [SMALL_STATE(907)] = 14372,
  [SMALL_STATE(908)] = 14424,
  [SMALL_STATE(909)] = 14476,
  [SMALL_STATE(910)] = 14528,
  [SMALL_STATE(911)] = 14580,
  [SMALL_STATE(912)] = 14632,
  [SMALL_STATE(913)] = 14684,
  [SMALL_STATE(914)] = 14736,
  [SMALL_STATE(915)] = 14788,
  [SMALL_STATE(916)] = 14840,
  [SMALL_STATE(917)] = 14892,
  [SMALL_STATE(918)] = 14944,
  [SMALL_STATE(919)] = 14996,
  [SMALL_STATE(920)] = 15048,
  [SMALL_STATE(921)] = 15100,
  [SMALL_STATE(922)] = 15152,
  [SMALL_STATE(923)] = 15204,
  [SMALL_STATE(924)] = 15256,
  [SMALL_STATE(925)] = 15308,
  [SMALL_STATE(926)] = 15360,
  [SMALL_STATE(927)] = 15412,
  [SMALL_STATE(928)] = 15464,
  [SMALL_STATE(929)] = 15516,
  [SMALL_STATE(930)] = 15568,
  [SMALL_STATE(931)] = 15620,
  [SMALL_STATE(932)] = 15672,
  [SMALL_STATE(933)] = 15724,
  [SMALL_STATE(934)] = 15776,
  [SMALL_STATE(935)] = 15828,
  [SMALL_STATE(936)] = 15880,
  [SMALL_STATE(937)] = 15932,
  [SMALL_STATE(938)] = 15984,
  [SMALL_STATE(939)] = 16036,
  [SMALL_STATE(940)] = 16088,
  [SMALL_STATE(941)] = 16140,
  [SMALL_STATE(942)] = 16192,
  [SMALL_STATE(943)] = 16244,
  [SMALL_STATE(944)] = 16296,
  [SMALL_STATE(945)] = 16348,
  [SMALL_STATE(946)] = 16400,
  [SMALL_STATE(947)] = 16450,
  [SMALL_STATE(948)] = 16502,
  [SMALL_STATE(949)] = 16554,
  [SMALL_STATE(950)] = 16604,
  [SMALL_STATE(951)] = 16656,
  [SMALL_STATE(952)] = 16708,
  [SMALL_STATE(953)] = 16760,
  [SMALL_STATE(954)] = 16812,
  [SMALL_STATE(955)] = 16864,
  [SMALL_STATE(956)] = 16916,
  [SMALL_STATE(957)] = 16968,
  [SMALL_STATE(958)] = 17020,
  [SMALL_STATE(959)] = 17072,
  [SMALL_STATE(960)] = 17124,
  [SMALL_STATE(961)] = 17176,
  [SMALL_STATE(962)] = 17228,
  [SMALL_STATE(963)] = 17280,
  [SMALL_STATE(964)] = 17332,
  [SMALL_STATE(965)] = 17384,
  [SMALL_STATE(966)] = 17436,
  [SMALL_STATE(967)] = 17488,
  [SMALL_STATE(968)] = 17540,
  [SMALL_STATE(969)] = 17592,
  [SMALL_STATE(970)] = 17644,
  [SMALL_STATE(971)] = 17696,
  [SMALL_STATE(972)] = 17748,
  [SMALL_STATE(973)] = 17800,
  [SMALL_STATE(974)] = 17852,
  [SMALL_STATE(975)] = 17904,
  [SMALL_STATE(976)] = 17956,
  [SMALL_STATE(977)] = 18008,
  [SMALL_STATE(978)] = 18060,
  [SMALL_STATE(979)] = 18112,
  [SMALL_STATE(980)] = 18164,
  [SMALL_STATE(981)] = 18216,
  [SMALL_STATE(982)] = 18268,
  [SMALL_STATE(983)] = 18320,
  [SMALL_STATE(984)] = 18372,
  [SMALL_STATE(985)] = 18424,
  [SMALL_STATE(986)] = 18476,
  [SMALL_STATE(987)] = 18528,
  [SMALL_STATE(988)] = 18580,
  [SMALL_STATE(989)] = 18627,
  [SMALL_STATE(990)] = 18674,
  [SMALL_STATE(991)] = 18713,
  [SMALL_STATE(992)] = 18760,
  [SMALL_STATE(993)] = 18807,
  [SMALL_STATE(994)] = 18854,
  [SMALL_STATE(995)] = 18893,
  [SMALL_STATE(996)] = 18932,
  [SMALL_STATE(997)] = 18979,
  [SMALL_STATE(998)] = 19026,
  [SMALL_STATE(999)] = 19073,
  [SMALL_STATE(1000)] = 19112,
  [SMALL_STATE(1001)] = 19159,
  [SMALL_STATE(1002)] = 19206,
  [SMALL_STATE(1003)] = 19253,
  [SMALL_STATE(1004)] = 19292,
  [SMALL_STATE(1005)] = 19339,
  [SMALL_STATE(1006)] = 19378,
  [SMALL_STATE(1007)] = 19425,
  [SMALL_STATE(1008)] = 19472,
  [SMALL_STATE(1009)] = 19519,
  [SMALL_STATE(1010)] = 19558,
  [SMALL_STATE(1011)] = 19605,
  [SMALL_STATE(1012)] = 19652,
  [SMALL_STATE(1013)] = 19699,
  [SMALL_STATE(1014)] = 19746,
  [SMALL_STATE(1015)] = 19785,
  [SMALL_STATE(1016)] = 19824,
  [SMALL_STATE(1017)] = 19871,
  [SMALL_STATE(1018)] = 19918,
  [SMALL_STATE(1019)] = 19965,
  [SMALL_STATE(1020)] = 20012,
  [SMALL_STATE(1021)] = 20059,
  [SMALL_STATE(1022)] = 20106,
  [SMALL_STATE(1023)] = 20153,
  [SMALL_STATE(1024)] = 20192,
  [SMALL_STATE(1025)] = 20239,
  [SMALL_STATE(1026)] = 20286,
  [SMALL_STATE(1027)] = 20333,
  [SMALL_STATE(1028)] = 20380,
  [SMALL_STATE(1029)] = 20427,
  [SMALL_STATE(1030)] = 20474,
  [SMALL_STATE(1031)] = 20506,
  [SMALL_STATE(1032)] = 20536,
  [SMALL_STATE(1033)] = 20566,
  [SMALL_STATE(1034)] = 20596,
  [SMALL_STATE(1035)] = 20626,
  [SMALL_STATE(1036)] = 20655,
  [SMALL_STATE(1037)] = 20684,
  [SMALL_STATE(1038)] = 20713,
  [SMALL_STATE(1039)] = 20742,
  [SMALL_STATE(1040)] = 20771,
  [SMALL_STATE(1041)] = 20800,
  [SMALL_STATE(1042)] = 20829,
  [SMALL_STATE(1043)] = 20858,
  [SMALL_STATE(1044)] = 20887,
  [SMALL_STATE(1045)] = 20910,
  [SMALL_STATE(1046)] = 20933,
  [SMALL_STATE(1047)] = 20958,
  [SMALL_STATE(1048)] = 20981,
  [SMALL_STATE(1049)] = 21004,
  [SMALL_STATE(1050)] = 21027,
  [SMALL_STATE(1051)] = 21049,
  [SMALL_STATE(1052)] = 21071,
  [SMALL_STATE(1053)] = 21093,
  [SMALL_STATE(1054)] = 21115,
  [SMALL_STATE(1055)] = 21137,
  [SMALL_STATE(1056)] = 21159,
  [SMALL_STATE(1057)] = 21185,
  [SMALL_STATE(1058)] = 21207,
  [SMALL_STATE(1059)] = 21229,
  [SMALL_STATE(1060)] = 21255,
  [SMALL_STATE(1061)] = 21281,
  [SMALL_STATE(1062)] = 21307,
  [SMALL_STATE(1063)] = 21329,
  [SMALL_STATE(1064)] = 21351,
  [SMALL_STATE(1065)] = 21377,
  [SMALL_STATE(1066)] = 21403,
  [SMALL_STATE(1067)] = 21429,
  [SMALL_STATE(1068)] = 21451,
  [SMALL_STATE(1069)] = 21473,
  [SMALL_STATE(1070)] = 21495,
  [SMALL_STATE(1071)] = 21521,
  [SMALL_STATE(1072)] = 21543,
  [SMALL_STATE(1073)] = 21565,
  [SMALL_STATE(1074)] = 21587,
  [SMALL_STATE(1075)] = 21609,
  [SMALL_STATE(1076)] = 21631,
  [SMALL_STATE(1077)] = 21653,
  [SMALL_STATE(1078)] = 21675,
  [SMALL_STATE(1079)] = 21697,
  [SMALL_STATE(1080)] = 21719,
  [SMALL_STATE(1081)] = 21741,
  [SMALL_STATE(1082)] = 21763,
  [SMALL_STATE(1083)] = 21785,
  [SMALL_STATE(1084)] = 21806,
  [SMALL_STATE(1085)] = 21827,
  [SMALL_STATE(1086)] = 21846,
  [SMALL_STATE(1087)] = 21865,
  [SMALL_STATE(1088)] = 21884,
  [SMALL_STATE(1089)] = 21903,
  [SMALL_STATE(1090)] = 21924,
  [SMALL_STATE(1091)] = 21945,
  [SMALL_STATE(1092)] = 21966,
  [SMALL_STATE(1093)] = 21987,
  [SMALL_STATE(1094)] = 22008,
  [SMALL_STATE(1095)] = 22029,
  [SMALL_STATE(1096)] = 22048,
  [SMALL_STATE(1097)] = 22074,
  [SMALL_STATE(1098)] = 22100,
  [SMALL_STATE(1099)] = 22121,
  [SMALL_STATE(1100)] = 22142,
  [SMALL_STATE(1101)] = 22163,
  [SMALL_STATE(1102)] = 22180,
  [SMALL_STATE(1103)] = 22201,
  [SMALL_STATE(1104)] = 22222,
  [SMALL_STATE(1105)] = 22243,
  [SMALL_STATE(1106)] = 22257,
  [SMALL_STATE(1107)] = 22272,
  [SMALL_STATE(1108)] = 22287,
  [SMALL_STATE(1109)] = 22302,
  [SMALL_STATE(1110)] = 22321,
  [SMALL_STATE(1111)] = 22340,
  [SMALL_STATE(1112)] = 22359,
  [SMALL_STATE(1113)] = 22374,
  [SMALL_STATE(1114)] = 22389,
  [SMALL_STATE(1115)] = 22404,
  [SMALL_STATE(1116)] = 22419,
  [SMALL_STATE(1117)] = 22434,
  [SMALL_STATE(1118)] = 22449,
  [SMALL_STATE(1119)] = 22464,
  [SMALL_STATE(1120)] = 22486,
  [SMALL_STATE(1121)] = 22508,
  [SMALL_STATE(1122)] = 22530,
  [SMALL_STATE(1123)] = 22552,
  [SMALL_STATE(1124)] = 22564,
  [SMALL_STATE(1125)] = 22584,
  [SMALL_STATE(1126)] = 22600,
  [SMALL_STATE(1127)] = 22622,
  [SMALL_STATE(1128)] = 22642,
  [SMALL_STATE(1129)] = 22664,
  [SMALL_STATE(1130)] = 22684,
  [SMALL_STATE(1131)] = 22696,
  [SMALL_STATE(1132)] = 22718,
  [SMALL_STATE(1133)] = 22737,
  [SMALL_STATE(1134)] = 22750,
  [SMALL_STATE(1135)] = 22761,
  [SMALL_STATE(1136)] = 22780,
  [SMALL_STATE(1137)] = 22799,
  [SMALL_STATE(1138)] = 22818,
  [SMALL_STATE(1139)] = 22837,
  [SMALL_STATE(1140)] = 22848,
  [SMALL_STATE(1141)] = 22867,
  [SMALL_STATE(1142)] = 22886,
  [SMALL_STATE(1143)] = 22905,
  [SMALL_STATE(1144)] = 22924,
  [SMALL_STATE(1145)] = 22937,
  [SMALL_STATE(1146)] = 22950,
  [SMALL_STATE(1147)] = 22969,
  [SMALL_STATE(1148)] = 22988,
  [SMALL_STATE(1149)] = 23001,
  [SMALL_STATE(1150)] = 23020,
  [SMALL_STATE(1151)] = 23039,
  [SMALL_STATE(1152)] = 23056,
  [SMALL_STATE(1153)] = 23072,
  [SMALL_STATE(1154)] = 23088,
  [SMALL_STATE(1155)] = 23098,
  [SMALL_STATE(1156)] = 23114,
  [SMALL_STATE(1157)] = 23128,
  [SMALL_STATE(1158)] = 23138,
  [SMALL_STATE(1159)] = 23154,
  [SMALL_STATE(1160)] = 23170,
  [SMALL_STATE(1161)] = 23186,
  [SMALL_STATE(1162)] = 23200,
  [SMALL_STATE(1163)] = 23214,
  [SMALL_STATE(1164)] = 23224,
  [SMALL_STATE(1165)] = 23238,
  [SMALL_STATE(1166)] = 23252,
  [SMALL_STATE(1167)] = 23262,
  [SMALL_STATE(1168)] = 23272,
  [SMALL_STATE(1169)] = 23286,
  [SMALL_STATE(1170)] = 23300,
  [SMALL_STATE(1171)] = 23313,
  [SMALL_STATE(1172)] = 23326,
  [SMALL_STATE(1173)] = 23339,
  [SMALL_STATE(1174)] = 23352,
  [SMALL_STATE(1175)] = 23365,
  [SMALL_STATE(1176)] = 23378,
  [SMALL_STATE(1177)] = 23391,
  [SMALL_STATE(1178)] = 23404,
  [SMALL_STATE(1179)] = 23417,
  [SMALL_STATE(1180)] = 23430,
  [SMALL_STATE(1181)] = 23443,
  [SMALL_STATE(1182)] = 23456,
  [SMALL_STATE(1183)] = 23469,
  [SMALL_STATE(1184)] = 23482,
  [SMALL_STATE(1185)] = 23491,
  [SMALL_STATE(1186)] = 23504,
  [SMALL_STATE(1187)] = 23517,
  [SMALL_STATE(1188)] = 23530,
  [SMALL_STATE(1189)] = 23543,
  [SMALL_STATE(1190)] = 23556,
  [SMALL_STATE(1191)] = 23569,
  [SMALL_STATE(1192)] = 23582,
  [SMALL_STATE(1193)] = 23595,
  [SMALL_STATE(1194)] = 23608,
  [SMALL_STATE(1195)] = 23621,
  [SMALL_STATE(1196)] = 23634,
  [SMALL_STATE(1197)] = 23647,
  [SMALL_STATE(1198)] = 23660,
  [SMALL_STATE(1199)] = 23673,
  [SMALL_STATE(1200)] = 23686,
  [SMALL_STATE(1201)] = 23699,
  [SMALL_STATE(1202)] = 23712,
  [SMALL_STATE(1203)] = 23725,
  [SMALL_STATE(1204)] = 23738,
  [SMALL_STATE(1205)] = 23751,
  [SMALL_STATE(1206)] = 23764,
  [SMALL_STATE(1207)] = 23777,
  [SMALL_STATE(1208)] = 23790,
  [SMALL_STATE(1209)] = 23803,
  [SMALL_STATE(1210)] = 23816,
  [SMALL_STATE(1211)] = 23829,
  [SMALL_STATE(1212)] = 23842,
  [SMALL_STATE(1213)] = 23855,
  [SMALL_STATE(1214)] = 23868,
  [SMALL_STATE(1215)] = 23881,
  [SMALL_STATE(1216)] = 23894,
  [SMALL_STATE(1217)] = 23907,
  [SMALL_STATE(1218)] = 23920,
  [SMALL_STATE(1219)] = 23933,
  [SMALL_STATE(1220)] = 23946,
  [SMALL_STATE(1221)] = 23959,
  [SMALL_STATE(1222)] = 23968,
  [SMALL_STATE(1223)] = 23981,
  [SMALL_STATE(1224)] = 23994,
  [SMALL_STATE(1225)] = 24007,
  [SMALL_STATE(1226)] = 24020,
  [SMALL_STATE(1227)] = 24033,
  [SMALL_STATE(1228)] = 24046,
  [SMALL_STATE(1229)] = 24059,
  [SMALL_STATE(1230)] = 24070,
  [SMALL_STATE(1231)] = 24083,
  [SMALL_STATE(1232)] = 24096,
  [SMALL_STATE(1233)] = 24109,
  [SMALL_STATE(1234)] = 24122,
  [SMALL_STATE(1235)] = 24135,
  [SMALL_STATE(1236)] = 24148,
  [SMALL_STATE(1237)] = 24161,
  [SMALL_STATE(1238)] = 24174,
  [SMALL_STATE(1239)] = 24187,
  [SMALL_STATE(1240)] = 24200,
  [SMALL_STATE(1241)] = 24213,
  [SMALL_STATE(1242)] = 24226,
  [SMALL_STATE(1243)] = 24239,
  [SMALL_STATE(1244)] = 24252,
  [SMALL_STATE(1245)] = 24265,
  [SMALL_STATE(1246)] = 24274,
  [SMALL_STATE(1247)] = 24287,
  [SMALL_STATE(1248)] = 24300,
  [SMALL_STATE(1249)] = 24313,
  [SMALL_STATE(1250)] = 24326,
  [SMALL_STATE(1251)] = 24339,
  [SMALL_STATE(1252)] = 24352,
  [SMALL_STATE(1253)] = 24365,
  [SMALL_STATE(1254)] = 24378,
  [SMALL_STATE(1255)] = 24391,
  [SMALL_STATE(1256)] = 24404,
  [SMALL_STATE(1257)] = 24417,
  [SMALL_STATE(1258)] = 24430,
  [SMALL_STATE(1259)] = 24443,
  [SMALL_STATE(1260)] = 24456,
  [SMALL_STATE(1261)] = 24469,
  [SMALL_STATE(1262)] = 24482,
  [SMALL_STATE(1263)] = 24495,
  [SMALL_STATE(1264)] = 24508,
  [SMALL_STATE(1265)] = 24521,
  [SMALL_STATE(1266)] = 24534,
  [SMALL_STATE(1267)] = 24547,
  [SMALL_STATE(1268)] = 24560,
  [SMALL_STATE(1269)] = 24573,
  [SMALL_STATE(1270)] = 24586,
  [SMALL_STATE(1271)] = 24599,
  [SMALL_STATE(1272)] = 24612,
  [SMALL_STATE(1273)] = 24625,
  [SMALL_STATE(1274)] = 24638,
  [SMALL_STATE(1275)] = 24651,
  [SMALL_STATE(1276)] = 24664,
  [SMALL_STATE(1277)] = 24677,
  [SMALL_STATE(1278)] = 24690,
  [SMALL_STATE(1279)] = 24703,
  [SMALL_STATE(1280)] = 24716,
  [SMALL_STATE(1281)] = 24729,
  [SMALL_STATE(1282)] = 24742,
  [SMALL_STATE(1283)] = 24755,
  [SMALL_STATE(1284)] = 24768,
  [SMALL_STATE(1285)] = 24781,
  [SMALL_STATE(1286)] = 24794,
  [SMALL_STATE(1287)] = 24807,
  [SMALL_STATE(1288)] = 24820,
  [SMALL_STATE(1289)] = 24833,
  [SMALL_STATE(1290)] = 24846,
  [SMALL_STATE(1291)] = 24859,
  [SMALL_STATE(1292)] = 24872,
  [SMALL_STATE(1293)] = 24885,
  [SMALL_STATE(1294)] = 24898,
  [SMALL_STATE(1295)] = 24911,
  [SMALL_STATE(1296)] = 24924,
  [SMALL_STATE(1297)] = 24937,
  [SMALL_STATE(1298)] = 24950,
  [SMALL_STATE(1299)] = 24963,
  [SMALL_STATE(1300)] = 24976,
  [SMALL_STATE(1301)] = 24989,
  [SMALL_STATE(1302)] = 25002,
  [SMALL_STATE(1303)] = 25015,
  [SMALL_STATE(1304)] = 25028,
  [SMALL_STATE(1305)] = 25041,
  [SMALL_STATE(1306)] = 25054,
  [SMALL_STATE(1307)] = 25067,
  [SMALL_STATE(1308)] = 25080,
  [SMALL_STATE(1309)] = 25093,
  [SMALL_STATE(1310)] = 25106,
  [SMALL_STATE(1311)] = 25119,
  [SMALL_STATE(1312)] = 25132,
  [SMALL_STATE(1313)] = 25145,
  [SMALL_STATE(1314)] = 25158,
  [SMALL_STATE(1315)] = 25171,
  [SMALL_STATE(1316)] = 25184,
  [SMALL_STATE(1317)] = 25197,
  [SMALL_STATE(1318)] = 25210,
  [SMALL_STATE(1319)] = 25223,
  [SMALL_STATE(1320)] = 25236,
  [SMALL_STATE(1321)] = 25249,
  [SMALL_STATE(1322)] = 25262,
  [SMALL_STATE(1323)] = 25275,
  [SMALL_STATE(1324)] = 25288,
  [SMALL_STATE(1325)] = 25301,
  [SMALL_STATE(1326)] = 25314,
  [SMALL_STATE(1327)] = 25327,
  [SMALL_STATE(1328)] = 25340,
  [SMALL_STATE(1329)] = 25353,
  [SMALL_STATE(1330)] = 25366,
  [SMALL_STATE(1331)] = 25379,
  [SMALL_STATE(1332)] = 25392,
  [SMALL_STATE(1333)] = 25405,
  [SMALL_STATE(1334)] = 25418,
  [SMALL_STATE(1335)] = 25431,
  [SMALL_STATE(1336)] = 25444,
  [SMALL_STATE(1337)] = 25457,
  [SMALL_STATE(1338)] = 25470,
  [SMALL_STATE(1339)] = 25483,
  [SMALL_STATE(1340)] = 25496,
  [SMALL_STATE(1341)] = 25509,
  [SMALL_STATE(1342)] = 25522,
  [SMALL_STATE(1343)] = 25535,
  [SMALL_STATE(1344)] = 25543,
  [SMALL_STATE(1345)] = 25551,
  [SMALL_STATE(1346)] = 25561,
  [SMALL_STATE(1347)] = 25571,
  [SMALL_STATE(1348)] = 25581,
  [SMALL_STATE(1349)] = 25591,
  [SMALL_STATE(1350)] = 25601,
  [SMALL_STATE(1351)] = 25611,
  [SMALL_STATE(1352)] = 25619,
  [SMALL_STATE(1353)] = 25629,
  [SMALL_STATE(1354)] = 25637,
  [SMALL_STATE(1355)] = 25647,
  [SMALL_STATE(1356)] = 25657,
  [SMALL_STATE(1357)] = 25667,
  [SMALL_STATE(1358)] = 25677,
  [SMALL_STATE(1359)] = 25685,
  [SMALL_STATE(1360)] = 25693,
  [SMALL_STATE(1361)] = 25703,
  [SMALL_STATE(1362)] = 25713,
  [SMALL_STATE(1363)] = 25723,
  [SMALL_STATE(1364)] = 25731,
  [SMALL_STATE(1365)] = 25741,
  [SMALL_STATE(1366)] = 25751,
  [SMALL_STATE(1367)] = 25761,
  [SMALL_STATE(1368)] = 25771,
  [SMALL_STATE(1369)] = 25781,
  [SMALL_STATE(1370)] = 25789,
  [SMALL_STATE(1371)] = 25799,
  [SMALL_STATE(1372)] = 25809,
  [SMALL_STATE(1373)] = 25819,
  [SMALL_STATE(1374)] = 25829,
  [SMALL_STATE(1375)] = 25839,
  [SMALL_STATE(1376)] = 25849,
  [SMALL_STATE(1377)] = 25859,
  [SMALL_STATE(1378)] = 25869,
  [SMALL_STATE(1379)] = 25879,
  [SMALL_STATE(1380)] = 25889,
  [SMALL_STATE(1381)] = 25899,
  [SMALL_STATE(1382)] = 25907,
  [SMALL_STATE(1383)] = 25915,
  [SMALL_STATE(1384)] = 25925,
  [SMALL_STATE(1385)] = 25933,
  [SMALL_STATE(1386)] = 25943,
  [SMALL_STATE(1387)] = 25953,
  [SMALL_STATE(1388)] = 25963,
  [SMALL_STATE(1389)] = 25971,
  [SMALL_STATE(1390)] = 25979,
  [SMALL_STATE(1391)] = 25987,
  [SMALL_STATE(1392)] = 25995,
  [SMALL_STATE(1393)] = 26003,
  [SMALL_STATE(1394)] = 26013,
  [SMALL_STATE(1395)] = 26023,
  [SMALL_STATE(1396)] = 26033,
  [SMALL_STATE(1397)] = 26043,
  [SMALL_STATE(1398)] = 26053,
  [SMALL_STATE(1399)] = 26061,
  [SMALL_STATE(1400)] = 26071,
  [SMALL_STATE(1401)] = 26081,
  [SMALL_STATE(1402)] = 26089,
  [SMALL_STATE(1403)] = 26097,
  [SMALL_STATE(1404)] = 26107,
  [SMALL_STATE(1405)] = 26117,
  [SMALL_STATE(1406)] = 26125,
  [SMALL_STATE(1407)] = 26133,
  [SMALL_STATE(1408)] = 26141,
  [SMALL_STATE(1409)] = 26149,
  [SMALL_STATE(1410)] = 26157,
  [SMALL_STATE(1411)] = 26165,
  [SMALL_STATE(1412)] = 26173,
  [SMALL_STATE(1413)] = 26183,
  [SMALL_STATE(1414)] = 26191,
  [SMALL_STATE(1415)] = 26199,
  [SMALL_STATE(1416)] = 26207,
  [SMALL_STATE(1417)] = 26215,
  [SMALL_STATE(1418)] = 26223,
  [SMALL_STATE(1419)] = 26231,
  [SMALL_STATE(1420)] = 26239,
  [SMALL_STATE(1421)] = 26247,
  [SMALL_STATE(1422)] = 26255,
  [SMALL_STATE(1423)] = 26263,
  [SMALL_STATE(1424)] = 26271,
  [SMALL_STATE(1425)] = 26279,
  [SMALL_STATE(1426)] = 26287,
  [SMALL_STATE(1427)] = 26295,
  [SMALL_STATE(1428)] = 26303,
  [SMALL_STATE(1429)] = 26311,
  [SMALL_STATE(1430)] = 26319,
  [SMALL_STATE(1431)] = 26329,
  [SMALL_STATE(1432)] = 26337,
  [SMALL_STATE(1433)] = 26345,
  [SMALL_STATE(1434)] = 26353,
  [SMALL_STATE(1435)] = 26363,
  [SMALL_STATE(1436)] = 26371,
  [SMALL_STATE(1437)] = 26379,
  [SMALL_STATE(1438)] = 26387,
  [SMALL_STATE(1439)] = 26397,
  [SMALL_STATE(1440)] = 26407,
  [SMALL_STATE(1441)] = 26415,
  [SMALL_STATE(1442)] = 26423,
  [SMALL_STATE(1443)] = 26431,
  [SMALL_STATE(1444)] = 26439,
  [SMALL_STATE(1445)] = 26447,
  [SMALL_STATE(1446)] = 26455,
  [SMALL_STATE(1447)] = 26463,
  [SMALL_STATE(1448)] = 26471,
  [SMALL_STATE(1449)] = 26479,
  [SMALL_STATE(1450)] = 26489,
  [SMALL_STATE(1451)] = 26497,
  [SMALL_STATE(1452)] = 26505,
  [SMALL_STATE(1453)] = 26513,
  [SMALL_STATE(1454)] = 26521,
  [SMALL_STATE(1455)] = 26529,
  [SMALL_STATE(1456)] = 26536,
  [SMALL_STATE(1457)] = 26543,
  [SMALL_STATE(1458)] = 26550,
  [SMALL_STATE(1459)] = 26557,
  [SMALL_STATE(1460)] = 26564,
  [SMALL_STATE(1461)] = 26571,
  [SMALL_STATE(1462)] = 26578,
  [SMALL_STATE(1463)] = 26585,
  [SMALL_STATE(1464)] = 26592,
  [SMALL_STATE(1465)] = 26599,
  [SMALL_STATE(1466)] = 26606,
  [SMALL_STATE(1467)] = 26613,
  [SMALL_STATE(1468)] = 26620,
  [SMALL_STATE(1469)] = 26627,
  [SMALL_STATE(1470)] = 26634,
  [SMALL_STATE(1471)] = 26641,
  [SMALL_STATE(1472)] = 26648,
  [SMALL_STATE(1473)] = 26655,
  [SMALL_STATE(1474)] = 26662,
  [SMALL_STATE(1475)] = 26669,
  [SMALL_STATE(1476)] = 26676,
  [SMALL_STATE(1477)] = 26683,
  [SMALL_STATE(1478)] = 26690,
  [SMALL_STATE(1479)] = 26697,
  [SMALL_STATE(1480)] = 26704,
  [SMALL_STATE(1481)] = 26711,
  [SMALL_STATE(1482)] = 26718,
  [SMALL_STATE(1483)] = 26725,
  [SMALL_STATE(1484)] = 26732,
  [SMALL_STATE(1485)] = 26739,
  [SMALL_STATE(1486)] = 26746,
  [SMALL_STATE(1487)] = 26753,
  [SMALL_STATE(1488)] = 26760,
  [SMALL_STATE(1489)] = 26767,
  [SMALL_STATE(1490)] = 26774,
  [SMALL_STATE(1491)] = 26781,
  [SMALL_STATE(1492)] = 26788,
  [SMALL_STATE(1493)] = 26795,
  [SMALL_STATE(1494)] = 26802,
  [SMALL_STATE(1495)] = 26809,
  [SMALL_STATE(1496)] = 26816,
  [SMALL_STATE(1497)] = 26823,
  [SMALL_STATE(1498)] = 26830,
  [SMALL_STATE(1499)] = 26837,
  [SMALL_STATE(1500)] = 26844,
  [SMALL_STATE(1501)] = 26851,
  [SMALL_STATE(1502)] = 26858,
  [SMALL_STATE(1503)] = 26865,
  [SMALL_STATE(1504)] = 26872,
  [SMALL_STATE(1505)] = 26879,
  [SMALL_STATE(1506)] = 26886,
  [SMALL_STATE(1507)] = 26893,
  [SMALL_STATE(1508)] = 26900,
  [SMALL_STATE(1509)] = 26907,
  [SMALL_STATE(1510)] = 26914,
  [SMALL_STATE(1511)] = 26921,
  [SMALL_STATE(1512)] = 26928,
  [SMALL_STATE(1513)] = 26935,
  [SMALL_STATE(1514)] = 26942,
  [SMALL_STATE(1515)] = 26949,
  [SMALL_STATE(1516)] = 26956,
  [SMALL_STATE(1517)] = 26963,
  [SMALL_STATE(1518)] = 26970,
  [SMALL_STATE(1519)] = 26977,
  [SMALL_STATE(1520)] = 26984,
  [SMALL_STATE(1521)] = 26991,
  [SMALL_STATE(1522)] = 26998,
  [SMALL_STATE(1523)] = 27005,
  [SMALL_STATE(1524)] = 27012,
  [SMALL_STATE(1525)] = 27019,
  [SMALL_STATE(1526)] = 27026,
  [SMALL_STATE(1527)] = 27033,
  [SMALL_STATE(1528)] = 27040,
  [SMALL_STATE(1529)] = 27047,
  [SMALL_STATE(1530)] = 27054,
  [SMALL_STATE(1531)] = 27061,
  [SMALL_STATE(1532)] = 27068,
  [SMALL_STATE(1533)] = 27075,
  [SMALL_STATE(1534)] = 27082,
  [SMALL_STATE(1535)] = 27089,
  [SMALL_STATE(1536)] = 27096,
  [SMALL_STATE(1537)] = 27103,
  [SMALL_STATE(1538)] = 27110,
  [SMALL_STATE(1539)] = 27117,
  [SMALL_STATE(1540)] = 27124,
  [SMALL_STATE(1541)] = 27131,
  [SMALL_STATE(1542)] = 27138,
  [SMALL_STATE(1543)] = 27145,
  [SMALL_STATE(1544)] = 27152,
  [SMALL_STATE(1545)] = 27159,
  [SMALL_STATE(1546)] = 27166,
  [SMALL_STATE(1547)] = 27173,
  [SMALL_STATE(1548)] = 27180,
  [SMALL_STATE(1549)] = 27187,
  [SMALL_STATE(1550)] = 27194,
  [SMALL_STATE(1551)] = 27201,
  [SMALL_STATE(1552)] = 27208,
  [SMALL_STATE(1553)] = 27215,
  [SMALL_STATE(1554)] = 27222,
  [SMALL_STATE(1555)] = 27229,
  [SMALL_STATE(1556)] = 27236,
  [SMALL_STATE(1557)] = 27243,
  [SMALL_STATE(1558)] = 27250,
  [SMALL_STATE(1559)] = 27257,
  [SMALL_STATE(1560)] = 27264,
  [SMALL_STATE(1561)] = 27271,
  [SMALL_STATE(1562)] = 27278,
  [SMALL_STATE(1563)] = 27285,
  [SMALL_STATE(1564)] = 27292,
  [SMALL_STATE(1565)] = 27299,
  [SMALL_STATE(1566)] = 27306,
  [SMALL_STATE(1567)] = 27313,
  [SMALL_STATE(1568)] = 27320,
  [SMALL_STATE(1569)] = 27327,
  [SMALL_STATE(1570)] = 27334,
  [SMALL_STATE(1571)] = 27341,
  [SMALL_STATE(1572)] = 27348,
  [SMALL_STATE(1573)] = 27355,
  [SMALL_STATE(1574)] = 27362,
  [SMALL_STATE(1575)] = 27369,
  [SMALL_STATE(1576)] = 27376,
  [SMALL_STATE(1577)] = 27383,
  [SMALL_STATE(1578)] = 27390,
  [SMALL_STATE(1579)] = 27397,
  [SMALL_STATE(1580)] = 27404,
  [SMALL_STATE(1581)] = 27411,
  [SMALL_STATE(1582)] = 27418,
  [SMALL_STATE(1583)] = 27425,
  [SMALL_STATE(1584)] = 27432,
  [SMALL_STATE(1585)] = 27439,
  [SMALL_STATE(1586)] = 27446,
  [SMALL_STATE(1587)] = 27453,
  [SMALL_STATE(1588)] = 27460,
  [SMALL_STATE(1589)] = 27467,
  [SMALL_STATE(1590)] = 27474,
  [SMALL_STATE(1591)] = 27481,
  [SMALL_STATE(1592)] = 27488,
  [SMALL_STATE(1593)] = 27495,
  [SMALL_STATE(1594)] = 27502,
  [SMALL_STATE(1595)] = 27509,
  [SMALL_STATE(1596)] = 27516,
  [SMALL_STATE(1597)] = 27523,
  [SMALL_STATE(1598)] = 27530,
  [SMALL_STATE(1599)] = 27537,
  [SMALL_STATE(1600)] = 27544,
  [SMALL_STATE(1601)] = 27551,
  [SMALL_STATE(1602)] = 27558,
  [SMALL_STATE(1603)] = 27565,
  [SMALL_STATE(1604)] = 27572,
  [SMALL_STATE(1605)] = 27579,
  [SMALL_STATE(1606)] = 27586,
  [SMALL_STATE(1607)] = 27593,
  [SMALL_STATE(1608)] = 27600,
  [SMALL_STATE(1609)] = 27607,
  [SMALL_STATE(1610)] = 27614,
  [SMALL_STATE(1611)] = 27621,
  [SMALL_STATE(1612)] = 27628,
  [SMALL_STATE(1613)] = 27635,
  [SMALL_STATE(1614)] = 27642,
  [SMALL_STATE(1615)] = 27649,
  [SMALL_STATE(1616)] = 27656,
  [SMALL_STATE(1617)] = 27663,
  [SMALL_STATE(1618)] = 27670,
  [SMALL_STATE(1619)] = 27677,
  [SMALL_STATE(1620)] = 27684,
  [SMALL_STATE(1621)] = 27691,
  [SMALL_STATE(1622)] = 27698,
  [SMALL_STATE(1623)] = 27705,
  [SMALL_STATE(1624)] = 27712,
  [SMALL_STATE(1625)] = 27719,
  [SMALL_STATE(1626)] = 27726,
  [SMALL_STATE(1627)] = 27733,
  [SMALL_STATE(1628)] = 27740,
  [SMALL_STATE(1629)] = 27747,
  [SMALL_STATE(1630)] = 27754,
  [SMALL_STATE(1631)] = 27761,
  [SMALL_STATE(1632)] = 27768,
  [SMALL_STATE(1633)] = 27775,
  [SMALL_STATE(1634)] = 27782,
  [SMALL_STATE(1635)] = 27789,
  [SMALL_STATE(1636)] = 27796,
  [SMALL_STATE(1637)] = 27803,
  [SMALL_STATE(1638)] = 27810,
  [SMALL_STATE(1639)] = 27817,
  [SMALL_STATE(1640)] = 27824,
  [SMALL_STATE(1641)] = 27831,
  [SMALL_STATE(1642)] = 27838,
  [SMALL_STATE(1643)] = 27845,
  [SMALL_STATE(1644)] = 27852,
  [SMALL_STATE(1645)] = 27859,
  [SMALL_STATE(1646)] = 27866,
  [SMALL_STATE(1647)] = 27873,
  [SMALL_STATE(1648)] = 27880,
  [SMALL_STATE(1649)] = 27887,
  [SMALL_STATE(1650)] = 27894,
  [SMALL_STATE(1651)] = 27901,
  [SMALL_STATE(1652)] = 27908,
  [SMALL_STATE(1653)] = 27915,
  [SMALL_STATE(1654)] = 27922,
  [SMALL_STATE(1655)] = 27929,
  [SMALL_STATE(1656)] = 27936,
  [SMALL_STATE(1657)] = 27943,
  [SMALL_STATE(1658)] = 27950,
  [SMALL_STATE(1659)] = 27957,
  [SMALL_STATE(1660)] = 27964,
  [SMALL_STATE(1661)] = 27971,
  [SMALL_STATE(1662)] = 27978,
  [SMALL_STATE(1663)] = 27985,
  [SMALL_STATE(1664)] = 27992,
  [SMALL_STATE(1665)] = 27999,
  [SMALL_STATE(1666)] = 28006,
  [SMALL_STATE(1667)] = 28013,
  [SMALL_STATE(1668)] = 28020,
  [SMALL_STATE(1669)] = 28027,
  [SMALL_STATE(1670)] = 28034,
  [SMALL_STATE(1671)] = 28041,
  [SMALL_STATE(1672)] = 28048,
  [SMALL_STATE(1673)] = 28055,
  [SMALL_STATE(1674)] = 28062,
  [SMALL_STATE(1675)] = 28069,
  [SMALL_STATE(1676)] = 28076,
  [SMALL_STATE(1677)] = 28083,
  [SMALL_STATE(1678)] = 28090,
  [SMALL_STATE(1679)] = 28097,
  [SMALL_STATE(1680)] = 28104,
  [SMALL_STATE(1681)] = 28111,
  [SMALL_STATE(1682)] = 28118,
  [SMALL_STATE(1683)] = 28125,
  [SMALL_STATE(1684)] = 28132,
  [SMALL_STATE(1685)] = 28139,
  [SMALL_STATE(1686)] = 28146,
  [SMALL_STATE(1687)] = 28153,
  [SMALL_STATE(1688)] = 28160,
  [SMALL_STATE(1689)] = 28167,
  [SMALL_STATE(1690)] = 28174,
  [SMALL_STATE(1691)] = 28181,
  [SMALL_STATE(1692)] = 28188,
  [SMALL_STATE(1693)] = 28195,
  [SMALL_STATE(1694)] = 28202,
  [SMALL_STATE(1695)] = 28209,
  [SMALL_STATE(1696)] = 28216,
  [SMALL_STATE(1697)] = 28223,
  [SMALL_STATE(1698)] = 28230,
  [SMALL_STATE(1699)] = 28237,
  [SMALL_STATE(1700)] = 28244,
  [SMALL_STATE(1701)] = 28251,
  [SMALL_STATE(1702)] = 28258,
  [SMALL_STATE(1703)] = 28265,
  [SMALL_STATE(1704)] = 28272,
  [SMALL_STATE(1705)] = 28279,
  [SMALL_STATE(1706)] = 28286,
  [SMALL_STATE(1707)] = 28293,
  [SMALL_STATE(1708)] = 28300,
  [SMALL_STATE(1709)] = 28307,
  [SMALL_STATE(1710)] = 28314,
  [SMALL_STATE(1711)] = 28321,
  [SMALL_STATE(1712)] = 28328,
  [SMALL_STATE(1713)] = 28335,
  [SMALL_STATE(1714)] = 28342,
  [SMALL_STATE(1715)] = 28349,
  [SMALL_STATE(1716)] = 28356,
  [SMALL_STATE(1717)] = 28363,
  [SMALL_STATE(1718)] = 28370,
  [SMALL_STATE(1719)] = 28377,
  [SMALL_STATE(1720)] = 28384,
  [SMALL_STATE(1721)] = 28391,
  [SMALL_STATE(1722)] = 28398,
  [SMALL_STATE(1723)] = 28405,
  [SMALL_STATE(1724)] = 28412,
  [SMALL_STATE(1725)] = 28419,
  [SMALL_STATE(1726)] = 28426,
  [SMALL_STATE(1727)] = 28433,
  [SMALL_STATE(1728)] = 28440,
  [SMALL_STATE(1729)] = 28447,
  [SMALL_STATE(1730)] = 28454,
  [SMALL_STATE(1731)] = 28461,
  [SMALL_STATE(1732)] = 28468,
  [SMALL_STATE(1733)] = 28475,
  [SMALL_STATE(1734)] = 28482,
  [SMALL_STATE(1735)] = 28489,
  [SMALL_STATE(1736)] = 28496,
  [SMALL_STATE(1737)] = 28503,
  [SMALL_STATE(1738)] = 28510,
  [SMALL_STATE(1739)] = 28517,
  [SMALL_STATE(1740)] = 28524,
  [SMALL_STATE(1741)] = 28531,
  [SMALL_STATE(1742)] = 28538,
  [SMALL_STATE(1743)] = 28545,
  [SMALL_STATE(1744)] = 28552,
  [SMALL_STATE(1745)] = 28559,
  [SMALL_STATE(1746)] = 28566,
  [SMALL_STATE(1747)] = 28573,
  [SMALL_STATE(1748)] = 28580,
  [SMALL_STATE(1749)] = 28587,
  [SMALL_STATE(1750)] = 28594,
  [SMALL_STATE(1751)] = 28601,
  [SMALL_STATE(1752)] = 28608,
  [SMALL_STATE(1753)] = 28615,
  [SMALL_STATE(1754)] = 28622,
  [SMALL_STATE(1755)] = 28629,
  [SMALL_STATE(1756)] = 28636,
  [SMALL_STATE(1757)] = 28643,
  [SMALL_STATE(1758)] = 28650,
  [SMALL_STATE(1759)] = 28657,
  [SMALL_STATE(1760)] = 28664,
  [SMALL_STATE(1761)] = 28671,
  [SMALL_STATE(1762)] = 28678,
  [SMALL_STATE(1763)] = 28685,
  [SMALL_STATE(1764)] = 28692,
  [SMALL_STATE(1765)] = 28699,
  [SMALL_STATE(1766)] = 28706,
  [SMALL_STATE(1767)] = 28713,
  [SMALL_STATE(1768)] = 28720,
  [SMALL_STATE(1769)] = 28727,
  [SMALL_STATE(1770)] = 28734,
  [SMALL_STATE(1771)] = 28741,
  [SMALL_STATE(1772)] = 28748,
  [SMALL_STATE(1773)] = 28755,
  [SMALL_STATE(1774)] = 28762,
  [SMALL_STATE(1775)] = 28769,
  [SMALL_STATE(1776)] = 28776,
  [SMALL_STATE(1777)] = 28783,
  [SMALL_STATE(1778)] = 28790,
  [SMALL_STATE(1779)] = 28797,
  [SMALL_STATE(1780)] = 28804,
  [SMALL_STATE(1781)] = 28811,
  [SMALL_STATE(1782)] = 28818,
  [SMALL_STATE(1783)] = 28825,
  [SMALL_STATE(1784)] = 28832,
  [SMALL_STATE(1785)] = 28839,
  [SMALL_STATE(1786)] = 28846,
  [SMALL_STATE(1787)] = 28853,
  [SMALL_STATE(1788)] = 28860,
  [SMALL_STATE(1789)] = 28867,
  [SMALL_STATE(1790)] = 28874,
  [SMALL_STATE(1791)] = 28881,
  [SMALL_STATE(1792)] = 28888,
  [SMALL_STATE(1793)] = 28895,
  [SMALL_STATE(1794)] = 28902,
  [SMALL_STATE(1795)] = 28909,
  [SMALL_STATE(1796)] = 28916,
  [SMALL_STATE(1797)] = 28923,
  [SMALL_STATE(1798)] = 28930,
  [SMALL_STATE(1799)] = 28937,
  [SMALL_STATE(1800)] = 28944,
  [SMALL_STATE(1801)] = 28951,
  [SMALL_STATE(1802)] = 28958,
  [SMALL_STATE(1803)] = 28965,
  [SMALL_STATE(1804)] = 28972,
  [SMALL_STATE(1805)] = 28979,
  [SMALL_STATE(1806)] = 28986,
  [SMALL_STATE(1807)] = 28993,
  [SMALL_STATE(1808)] = 29000,
  [SMALL_STATE(1809)] = 29007,
  [SMALL_STATE(1810)] = 29014,
  [SMALL_STATE(1811)] = 29021,
  [SMALL_STATE(1812)] = 29028,
  [SMALL_STATE(1813)] = 29035,
  [SMALL_STATE(1814)] = 29042,
  [SMALL_STATE(1815)] = 29049,
  [SMALL_STATE(1816)] = 29056,
  [SMALL_STATE(1817)] = 29063,
  [SMALL_STATE(1818)] = 29070,
  [SMALL_STATE(1819)] = 29077,
  [SMALL_STATE(1820)] = 29084,
  [SMALL_STATE(1821)] = 29091,
  [SMALL_STATE(1822)] = 29098,
  [SMALL_STATE(1823)] = 29105,
  [SMALL_STATE(1824)] = 29112,
  [SMALL_STATE(1825)] = 29119,
  [SMALL_STATE(1826)] = 29126,
  [SMALL_STATE(1827)] = 29133,
  [SMALL_STATE(1828)] = 29140,
  [SMALL_STATE(1829)] = 29147,
  [SMALL_STATE(1830)] = 29154,
  [SMALL_STATE(1831)] = 29161,
  [SMALL_STATE(1832)] = 29168,
  [SMALL_STATE(1833)] = 29175,
  [SMALL_STATE(1834)] = 29182,
  [SMALL_STATE(1835)] = 29189,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [35] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(84),
  [38] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_and_value, 1),
  [40] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(99),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [49] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(218),
  [52] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(219),
  [55] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(219),
  [58] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(225),
  [61] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(225),
  [64] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(222),
  [67] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(221),
  [70] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_and_value, 1),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(764),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(763),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(762),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(755),
  [84] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [86] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [88] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [90] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [92] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [94] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [96] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [98] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_keyword, 1),
  [118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_keyword, 1),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(148),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(160),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(747),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1790),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1832),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1833),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1834),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1092),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1085),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(990),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1364),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1791),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1835),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(716),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(715),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(1032),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1128),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1636),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(727),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(11),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(1636),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 3),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 3),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_type, 3),
  [293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_type, 3),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_type, 3),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_type, 3),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(312),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(317),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_type, 2),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_type, 2),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 4),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 4),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addrspace, 4),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addrspace, 4),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1121),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(729),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(35),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(777),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(780),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2),
  [476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1119),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(734),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(69),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_ref, 1),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_ref, 1),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 1),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 1),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bin_op, 6, .production_id = 3),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_bin_op, 6, .production_id = 3),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractvalue, 7, .production_id = 3),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractvalue, 7, .production_id = 3),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 3),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 3),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bin_op, 7, .production_id = 3),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_bin_op, 7, .production_id = 3),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 3),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 3),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 3),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 3),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 3),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 3),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertelement, 8, .production_id = 3),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertelement, 8, .production_id = 3),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_select, 8, .production_id = 3),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_select, 8, .production_id = 3),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_shufflevector, 8, .production_id = 3),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_shufflevector, 8, .production_id = 3),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fcmp, 8, .production_id = 3),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fcmp, 8, .production_id = 3),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertvalue, 8, .production_id = 3),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertvalue, 8, .production_id = 3),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertvalue, 9, .production_id = 3),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertvalue, 9, .production_id = 3),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 4),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 4),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 4),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 4),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 2),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 2),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fcmp, 7, .production_id = 3),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fcmp, 7, .production_id = 3),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_icmp, 7, .production_id = 3),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_icmp, 7, .production_id = 3),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 4),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 4),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 1),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 1),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 2),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 2),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_cast, 6, .production_id = 3),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_cast, 6, .production_id = 3),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 2),
  [601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 2),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 7, .production_id = 3),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 7, .production_id = 3),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 2),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 2),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 2),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 2),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_blockaddress, 6),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_blockaddress, 6),
  [619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractvalue, 6, .production_id = 3),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractvalue, 6, .production_id = 3),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 6, .production_id = 3),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 6, .production_id = 3),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractelement, 6, .production_id = 3),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractelement, 6, .production_id = 3),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 4),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 4),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_expr, 1),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_expr, 1),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 5, .production_id = 3),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 5, .production_id = 3),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fneg, 5, .production_id = 3),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fneg, 5, .production_id = 3),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fneg, 4, .production_id = 3),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fneg, 4, .production_id = 3),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 4, .production_id = 3),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 4, .production_id = 3),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 4),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 4),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 5),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 5),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 4),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 4),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_and_value, 2),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_and_value, 2),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 2),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 2),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 3),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 3),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 3),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 3),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number, 1),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number, 1),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, .production_id = 16),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, .production_id = 16),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_name, 1),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, .production_id = 15),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, .production_id = 15),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 7, .production_id = 17),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 7, .production_id = 17),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, .production_id = 16),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, .production_id = 16),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, .production_id = 17),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, .production_id = 17),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 4, .production_id = 15),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 4, .production_id = 15),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 3, .production_id = 12),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 3, .production_id = 12),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 4, .production_id = 12),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 4, .production_id = 12),
  [757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(193),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2),
  [762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(193),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(181),
  [768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(1758),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(195),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(967),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(194),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(197),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(210),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(210),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 4),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignment, 2),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignment, 2),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 1),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 1),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 2),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 2),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 4),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 4),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2),
  [845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(218),
  [848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(219),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(219),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(225),
  [857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(225),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(222),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(221),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declare_repeat1, 2),
  [886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declare_repeat1, 2), SHIFT_REPEAT(1030),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declare_repeat1, 2),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage, 1),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage, 1),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_aux, 1),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_aux, 1),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dll_storage_class, 1),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dll_storage_class, 1),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility, 1),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility, 1),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_attachment, 2),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_attachment, 2),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dso_local, 1),
  [919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dso_local, 1),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_select_repeat1, 2),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2), SHIFT_REPEAT(236),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_select_repeat1, 2), SHIFT_REPEAT(236),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1131),
  [936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(722),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fast_math, 1),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fast_math, 1),
  [943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(237),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1), SHIFT(778),
  [959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1), SHIFT(776),
  [962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1122),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(728),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(267),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_addr, 1),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_addr, 1),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1482),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(339),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2),
  [1109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(639),
  [1112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(924),
  [1115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(923),
  [1118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(895),
  [1121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(880),
  [1124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(879),
  [1127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(838),
  [1130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(853),
  [1133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(696),
  [1136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(816),
  [1139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(698),
  [1142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(818),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(232),
  [1148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1485),
  [1151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1486),
  [1154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1438),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1434),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1430),
  [1163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(233),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1095),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1005),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(825),
  [1175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(699),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1022),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1492),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(227),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(804),
  [1190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(806),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(731),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(737),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1046),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1100),
  [1205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(724),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(836),
  [1211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(837),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(716),
  [1217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(715),
  [1220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(1032),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 4, .production_id = 6),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 4, .production_id = 6),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 3, .production_id = 2),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 3, .production_id = 2),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, .production_id = 8),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, .production_id = 8),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(374),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(260),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2), SHIFT_REPEAT(260),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, .production_id = 11),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, .production_id = 11),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, .production_id = 14),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, .production_id = 14),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 4),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 4),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 5),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 5),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 6),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 6),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 6),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 6),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 7),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 7),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 7),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 7),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 3),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 3),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 5),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 5),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, .production_id = 6),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, .production_id = 6),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 4, .production_id = 2),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 4, .production_id = 2),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, .production_id = 14),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, .production_id = 14),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, .production_id = 8),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, .production_id = 8),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, .production_id = 11),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, .production_id = 11),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2),
  [1468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(399),
  [1471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(519),
  [1474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(364),
  [1477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(1500),
  [1480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(401),
  [1483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(934),
  [1486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(260),
  [1489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2), SHIFT_REPEAT(260),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, .production_id = 2),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, .production_id = 2),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 10, .production_id = 14),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 10, .production_id = 14),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, .production_id = 6),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, .production_id = 6),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, .production_id = 8),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, .production_id = 8),
  [1510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(399),
  [1513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(364),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(1500),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(401),
  [1522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(934),
  [1525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(260),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(260),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, .production_id = 2),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, .production_id = 2),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 9, .production_id = 11),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 9, .production_id = 11),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 9, .production_id = 14),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 9, .production_id = 14),
  [1543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(455),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(454),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(452),
  [1552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(443),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2),
  [1557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(445),
  [1560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(453),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2), SHIFT_REPEAT(455),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, .production_id = 8),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, .production_id = 8),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, .production_id = 11),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, .production_id = 11),
  [1574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, .production_id = 6),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, .production_id = 6),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_conv, 1),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_conv, 1),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_conv, 2),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_conv, 2),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 2),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 2),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 1),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 1),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 3),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 3),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(1120),
  [1635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(738),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(927),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(920),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(510),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2), SHIFT_REPEAT(981),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 1),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 1), SHIFT(1675),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 1),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 2),
  [1679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 2), SHIFT(1621),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 2),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_syncscope, 4),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_syncscope, 4),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_landingpad, 3, .production_id = 3),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_landingpad, 3, .production_id = 3),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_landingpad, 4, .production_id = 3),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_landingpad, 4, .production_id = 3),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2),
  [1702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2), SHIFT_REPEAT(974),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 2),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 2),
  [1711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 3),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 3),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 1),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 1),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 4),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 4),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2),
  [1725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2), SHIFT_REPEAT(1375),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_repeat1, 2),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_landingpad_clause, 2),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_landingpad_clause, 2),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 5, .production_id = 3),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 5, .production_id = 3), SHIFT(1273),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractvalue, 5, .production_id = 3),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 4, .production_id = 7),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 4, .production_id = 7),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 8, .production_id = 3),
  [1753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 8, .production_id = 3), SHIFT(1591),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 8, .production_id = 3),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 3, .production_id = 3),
  [1760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 3, .production_id = 3), SHIFT(718),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 3, .production_id = 3),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 7, .production_id = 3),
  [1767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 7, .production_id = 3), SHIFT(1591),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 7, .production_id = 3),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 4, .production_id = 3),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 4, .production_id = 3), SHIFT(752),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 4, .production_id = 3),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 5, .production_id = 3),
  [1781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 5, .production_id = 3), SHIFT(718),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 5, .production_id = 3),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2),
  [1788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2), SHIFT_REPEAT(718),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 2, .production_id = 3),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 2, .production_id = 3), SHIFT(752),
  [1798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 2, .production_id = 3),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2),
  [1802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 7, .production_id = 3),
  [1806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 7, .production_id = 3), SHIFT(1273),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertvalue, 7, .production_id = 3),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 5, .production_id = 3),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 5, .production_id = 3), SHIFT(752),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 5, .production_id = 3),
  [1818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2), SHIFT_REPEAT(752),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 3, .production_id = 3),
  [1823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 3, .production_id = 3), SHIFT(752),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 3, .production_id = 3),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 3),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 3),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 2, .production_id = 3),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 2, .production_id = 3), SHIFT(718),
  [1837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 2, .production_id = 3),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 4, .production_id = 3),
  [1841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 4, .production_id = 3), SHIFT(718),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 4, .production_id = 3),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 9, .production_id = 3),
  [1848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 9, .production_id = 3), SHIFT(1591),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 9, .production_id = 3),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 4, .production_id = 3),
  [1855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 4, .production_id = 3), SHIFT(1273),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractvalue, 4, .production_id = 3),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 2),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 2), SHIFT_REPEAT(1591),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_phi_repeat1, 2),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 6, .production_id = 3),
  [1869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 6, .production_id = 3), SHIFT(1273),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertvalue, 6, .production_id = 3),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2), SHIFT_REPEAT(1273),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 8),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 8),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_resume, 2, .production_id = 3),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_resume, 2, .production_id = 3),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 9, .production_id = 3),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 9, .production_id = 3),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 9, .production_id = 3),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 9, .production_id = 3), SHIFT(1378),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 9, .production_id = 3),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchret, 5, .production_id = 3),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchret, 5, .production_id = 3),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 6),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 6),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 7, .production_id = 16),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 7, .production_id = 16),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unwind_label, 2),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unwind_label, 2),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 5, .production_id = 3),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 5, .production_id = 3),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchpad, 3, .production_id = 3),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchpad, 3, .production_id = 3),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cleanuppad, 3, .production_id = 3),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cleanuppad, 3, .production_id = 3),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fcmp, 5, .production_id = 3),
  [1926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fcmp, 5, .production_id = 3),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_icmp, 5, .production_id = 3),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_icmp, 5, .production_id = 3),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_indirectbr, 4, .production_id = 3),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_indirectbr, 4, .production_id = 3),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractelement, 4, .production_id = 3),
  [1938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractelement, 4, .production_id = 3),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 8, .production_id = 17),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 8, .production_id = 17),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 5),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 5),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 6),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 6),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 7),
  [1954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 7),
  [1956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 5, .production_id = 3),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 5, .production_id = 3),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 8, .production_id = 3),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 8, .production_id = 3),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_bin_op, 5, .production_id = 3),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_bin_op, 5, .production_id = 3),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, .production_id = 15),
  [1970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, .production_id = 15),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 10, .production_id = 3),
  [1974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 10, .production_id = 3), SHIFT(1380),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 10, .production_id = 3),
  [1979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 8, .production_id = 3), SHIFT(1377),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 10, .production_id = 3),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 10, .production_id = 3),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 8, .production_id = 3),
  [1988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 8, .production_id = 3), SHIFT(1376),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 8, .production_id = 3),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_refs, 3),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_refs, 3),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 3, .production_id = 9),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 3, .production_id = 9),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 5),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 5),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cleanupret, 4, .production_id = 3),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cleanupret, 4, .production_id = 3),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 3, .production_id = 10),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 3, .production_id = 10),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_ret, 2, .production_id = 3),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_ret, 2, .production_id = 3),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 8, .production_id = 7),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 8, .production_id = 7),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchswitch, 4, .production_id = 3),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchswitch, 4, .production_id = 3),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 11, .production_id = 3),
  [2027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 11, .production_id = 3), SHIFT(1386),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 11, .production_id = 3),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_br, 2, .production_id = 3),
  [2034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_br, 2, .production_id = 3), SHIFT(882),
  [2037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_br, 2, .production_id = 3),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_br, 6, .production_id = 3),
  [2041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_br, 6, .production_id = 3),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_va_arg, 4, .production_id = 3),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_va_arg, 4, .production_id = 3),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertelement, 6, .production_id = 3),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertelement, 6, .production_id = 3),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 4),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 4),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, .production_id = 12),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, .production_id = 12),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_select, 6, .production_id = 3),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_select, 6, .production_id = 3),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 4, .production_id = 13),
  [2065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 4, .production_id = 13),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 12, .production_id = 3),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 12, .production_id = 3),
  [2071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 6),
  [2073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_phi_repeat1, 6),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 13, .production_id = 3),
  [2077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 13, .production_id = 3),
  [2079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 7, .production_id = 3),
  [2081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 7, .production_id = 3), SHIFT(1385),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 7, .production_id = 3),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 4),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 4),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fneg, 3, .production_id = 3),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fneg, 3, .production_id = 3),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 4, .production_id = 3),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 4, .production_id = 3),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 7, .production_id = 7),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 7, .production_id = 7),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 4, .production_id = 3),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 4, .production_id = 3),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_freeze, 2, .production_id = 3),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_freeze, 2, .production_id = 3),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_switch, 7, .production_id = 3),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_switch, 7, .production_id = 3),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_select, 7, .production_id = 3),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_select, 7, .production_id = 3),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_shufflevector, 6, .production_id = 3),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_shufflevector, 6, .production_id = 3),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fneg, 2, .production_id = 3),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fneg, 2, .production_id = 3),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_switch, 6, .production_id = 3),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_switch, 6, .production_id = 3),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fence, 2, .production_id = 3),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fence, 2, .production_id = 3),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_ordering, 1),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_ordering, 1),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_unreachable, 1, .production_id = 3),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_unreachable, 1, .production_id = 3),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_invoke, 6, .production_id = 7),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_invoke, 6, .production_id = 7),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 2),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 2),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 3),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 3),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unwind_label, 3),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unwind_label, 3),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_bin_op, 4, .production_id = 3),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_bin_op, 4, .production_id = 3),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cast, 4, .production_id = 3),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cast, 4, .production_id = 3),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fence, 3, .production_id = 3),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fence, 3, .production_id = 3),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fcmp, 6, .production_id = 3),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fcmp, 6, .production_id = 3),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 6, .production_id = 3),
  [2176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 6, .production_id = 3), SHIFT(1374),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 6, .production_id = 3),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 6, .production_id = 3),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 6, .production_id = 3),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 2, .production_id = 7),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 2, .production_id = 7),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 6, .production_id = 3),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 6, .production_id = 3),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 3),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 3), SHIFT(1603),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 3),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(686),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(677),
  [2210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(687),
  [2213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(681),
  [2216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(687),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(685),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(672),
  [2225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2),
  [2227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(668),
  [2230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(660),
  [2233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(1708),
  [2236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(657),
  [2239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2), SHIFT_REPEAT(1484),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2), SHIFT_REPEAT(675),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 3),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 3),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 1),
  [2301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 1),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 2),
  [2305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 2),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 2),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 3),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2),
  [2355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2),
  [2357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2), SHIFT_REPEAT(707),
  [2360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2), SHIFT_REPEAT(675),
  [2363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(774),
  [2366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(741),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(741),
  [2372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(772),
  [2375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(772),
  [2378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(771),
  [2381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2), SHIFT_REPEAT(770),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_bin_op_keyword, 1),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_bin_op_keyword, 1),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bin_op_keyword, 1),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bin_op_keyword, 1),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [2402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1639),
  [2405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1722),
  [2408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1720),
  [2411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(83),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1719),
  [2417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1169),
  [2420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1716),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(188),
  [2426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(196),
  [2429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(984),
  [2432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1712),
  [2435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1661),
  [2438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1652),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(238),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(249),
  [2479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(263),
  [2482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(785),
  [2485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(788),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(1141),
  [2491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_switch_repeat1, 2), SHIFT_REPEAT(1135),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_name, 1),
  [2622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_name, 1),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 3),
  [2626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_switch_repeat1, 3),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_inst, 1),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_inst, 1),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fcmp_cond, 1),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fcmp_cond, 1),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_icmp_cond, 1),
  [2638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_icmp_cond, 1),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 8),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 8),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 8),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 8),
  [2650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2), SHIFT_REPEAT(1350),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 5),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 5),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm, 1),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm, 1),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 6),
  [2663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 6),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 7),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 7),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 5),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 5),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 6, .production_id = 5),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 6, .production_id = 5),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_attr_grp, 5),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_attr_grp, 5),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_metadata, 3),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_metadata, 3),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 4),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 8),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 8),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_asm, 3),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_asm, 3),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_attr_grp, 6),
  [2703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_attr_grp, 6),
  [2705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_metadata, 4),
  [2707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_metadata, 4),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 9),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 9),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 7, .production_id = 5),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 7, .production_id = 5),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_type, 4),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_type, 4),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_triple, 3),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_triple, 3),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file_name, 3),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_file_name, 3),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_layout, 3),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_layout, 3),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comdat, 4),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comdat, 4),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare, 2),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare, 2),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 7),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 7),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define, 4, .production_id = 4),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_define, 4, .production_id = 4),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 5, .production_id = 5),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 5, .production_id = 5),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare, 3),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare, 3),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define, 3, .production_id = 1),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_define, 3, .production_id = 1),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_definition, 2),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_definition, 2),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 4),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thread_local, 1),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thread_local, 4),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 5),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2),
  [2837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2), SHIFT_REPEAT(827),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 6),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2), SHIFT_REPEAT(1300),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat2, 2),
  [2887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat2, 2), SHIFT_REPEAT(984),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 7),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2), SHIFT_REPEAT(723),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 1),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2), SHIFT_REPEAT(784),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [3054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(748),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_metadata_tuple_repeat1, 2),
  [3079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_metadata_tuple_repeat1, 2), SHIFT_REPEAT(713),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 2),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2),
  [3106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(1017),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 2),
  [3113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 2), SHIFT_REPEAT(1584),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2), SHIFT_REPEAT(971),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(1016),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_vector_body, 5),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 4),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 5),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 6),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_vector_body, 3),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 8),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 7),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 6),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 5),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 4),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [3608] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__within, 2),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_llvm(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
