#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 920
#define LARGE_STATE_COUNT 351
#define SYMBOL_COUNT 203
#define ALIAS_COUNT 4
#define TOKEN_COUNT 91
#define EXTERNAL_TOKEN_COUNT 47
#define FIELD_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 13
#define PRODUCTION_ID_COUNT 11

enum {
  sym__backslash_escape = 1,
  sym_entity_reference = 2,
  sym_numeric_character_reference = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_LT = 6,
  anon_sym_GT = 7,
  anon_sym_BANG = 8,
  anon_sym_DQUOTE = 9,
  anon_sym_POUND = 10,
  anon_sym_DOLLAR = 11,
  anon_sym_PERCENT = 12,
  anon_sym_AMP = 13,
  anon_sym_SQUOTE = 14,
  anon_sym_STAR = 15,
  anon_sym_PLUS = 16,
  anon_sym_COMMA = 17,
  anon_sym_DASH = 18,
  anon_sym_DOT = 19,
  anon_sym_SLASH = 20,
  anon_sym_COLON = 21,
  anon_sym_SEMI = 22,
  anon_sym_EQ = 23,
  anon_sym_QMARK = 24,
  anon_sym_AT = 25,
  anon_sym_BSLASH = 26,
  anon_sym_CARET = 27,
  anon_sym__ = 28,
  anon_sym_BQUOTE = 29,
  anon_sym_LBRACE = 30,
  anon_sym_PIPE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_TILDE = 33,
  anon_sym_LPAREN = 34,
  anon_sym_RPAREN = 35,
  sym__newline_token = 36,
  anon_sym_DASH_DASH_GT = 37,
  anon_sym_QMARK_GT = 38,
  anon_sym_RBRACK_RBRACK_GT = 39,
  aux_sym__word_token1 = 40,
  anon_sym_LBRACKx_RBRACK = 41,
  aux_sym__word_token2 = 42,
  sym__whitespace = 43,
  sym__line_ending = 44,
  sym__soft_line_ending = 45,
  sym__block_close = 46,
  sym_block_continuation = 47,
  sym__block_quote_start = 48,
  sym__indented_chunk_start = 49,
  sym_atx_h1_marker = 50,
  sym_atx_h2_marker = 51,
  sym_atx_h3_marker = 52,
  sym_atx_h4_marker = 53,
  sym_atx_h5_marker = 54,
  sym_atx_h6_marker = 55,
  sym_setext_h1_underline = 56,
  sym_setext_h2_underline = 57,
  sym__thematic_break = 58,
  sym__list_marker_minus = 59,
  sym__list_marker_plus = 60,
  sym__list_marker_star = 61,
  sym__list_marker_parenthesis = 62,
  sym__list_marker_dot = 63,
  sym__list_marker_minus_dont_interrupt = 64,
  sym__list_marker_plus_dont_interrupt = 65,
  sym__list_marker_star_dont_interrupt = 66,
  sym__list_marker_parenthesis_dont_interrupt = 67,
  sym__list_marker_dot_dont_interrupt = 68,
  sym__fenced_code_block_start_backtick = 69,
  sym__fenced_code_block_start_tilde = 70,
  sym__blank_line_start = 71,
  sym__fenced_code_block_end_backtick = 72,
  sym__fenced_code_block_end_tilde = 73,
  sym__html_block_1_start = 74,
  sym__html_block_1_end = 75,
  sym__html_block_2_start = 76,
  sym__html_block_3_start = 77,
  sym__html_block_4_start = 78,
  sym__html_block_5_start = 79,
  sym__html_block_6_start = 80,
  sym__html_block_7_start = 81,
  sym__close_block = 82,
  sym__no_indented_chunk = 83,
  sym__error = 84,
  sym__trigger_error = 85,
  sym__eof = 86,
  sym_minus_metadata = 87,
  sym_plus_metadata = 88,
  sym__pipe_table_start = 89,
  sym__pipe_table_line_ending = 90,
  sym_document = 91,
  sym_backslash_escape = 92,
  sym_link_label = 93,
  sym_link_destination = 94,
  sym__link_destination_parenthesis = 95,
  sym__text_no_angle = 96,
  sym_link_title = 97,
  sym__last_token_punctuation = 98,
  sym__block = 99,
  sym__block_not_section = 100,
  sym_section = 101,
  sym__section1 = 102,
  sym__section2 = 103,
  sym__section3 = 104,
  sym__section4 = 105,
  sym__section5 = 106,
  sym__section6 = 107,
  sym_thematic_break = 108,
  sym__atx_heading1 = 109,
  sym__atx_heading2 = 110,
  sym__atx_heading3 = 111,
  sym__atx_heading4 = 112,
  sym__atx_heading5 = 113,
  sym__atx_heading6 = 114,
  sym__setext_heading1 = 115,
  sym__setext_heading2 = 116,
  sym_indented_code_block = 117,
  sym__indented_chunk = 118,
  sym_fenced_code_block = 119,
  sym_code_fence_content = 120,
  sym_info_string = 121,
  sym_language = 122,
  sym_html_block = 123,
  sym__html_block_1 = 124,
  sym__html_block_2 = 125,
  sym__html_block_3 = 126,
  sym__html_block_4 = 127,
  sym__html_block_5 = 128,
  sym__html_block_6 = 129,
  sym__html_block_7 = 130,
  sym_link_reference_definition = 131,
  sym__text_inline_no_link = 132,
  sym_paragraph = 133,
  sym__blank_line = 134,
  sym_block_quote = 135,
  sym_list = 136,
  sym__list_plus = 137,
  sym__list_minus = 138,
  sym__list_star = 139,
  sym__list_dot = 140,
  sym__list_parenthesis = 141,
  sym_list_marker_plus = 142,
  sym_list_marker_minus = 143,
  sym_list_marker_star = 144,
  sym_list_marker_dot = 145,
  sym_list_marker_parenthesis = 146,
  sym__list_item_plus = 147,
  sym__list_item_minus = 148,
  sym__list_item_star = 149,
  sym__list_item_dot = 150,
  sym__list_item_parenthesis = 151,
  sym__list_item_content = 152,
  sym__newline = 153,
  sym__soft_line_break = 154,
  sym__line = 155,
  sym__word = 156,
  sym_task_list_marker_checked = 157,
  sym_task_list_marker_unchecked = 158,
  sym_pipe_table = 159,
  sym__pipe_table_newline = 160,
  sym_pipe_table_delimiter_row = 161,
  sym_pipe_table_delimiter_cell = 162,
  sym_pipe_table_row = 163,
  sym_pipe_table_cell = 164,
  aux_sym_document_repeat1 = 165,
  aux_sym_document_repeat2 = 166,
  aux_sym_link_label_repeat1 = 167,
  aux_sym_link_destination_repeat1 = 168,
  aux_sym_link_destination_repeat2 = 169,
  aux_sym_link_title_repeat1 = 170,
  aux_sym_link_title_repeat2 = 171,
  aux_sym_link_title_repeat3 = 172,
  aux_sym__section1_repeat1 = 173,
  aux_sym__section2_repeat1 = 174,
  aux_sym__section3_repeat1 = 175,
  aux_sym__section4_repeat1 = 176,
  aux_sym__section5_repeat1 = 177,
  aux_sym_indented_code_block_repeat1 = 178,
  aux_sym__indented_chunk_repeat1 = 179,
  aux_sym_code_fence_content_repeat1 = 180,
  aux_sym_info_string_repeat1 = 181,
  aux_sym_info_string_repeat2 = 182,
  aux_sym_language_repeat1 = 183,
  aux_sym__html_block_1_repeat1 = 184,
  aux_sym__html_block_2_repeat1 = 185,
  aux_sym__html_block_3_repeat1 = 186,
  aux_sym__html_block_4_repeat1 = 187,
  aux_sym__html_block_5_repeat1 = 188,
  aux_sym__html_block_6_repeat1 = 189,
  aux_sym_paragraph_repeat1 = 190,
  aux_sym_block_quote_repeat1 = 191,
  aux_sym__list_plus_repeat1 = 192,
  aux_sym__list_minus_repeat1 = 193,
  aux_sym__list_star_repeat1 = 194,
  aux_sym__list_dot_repeat1 = 195,
  aux_sym__list_parenthesis_repeat1 = 196,
  aux_sym__line_repeat1 = 197,
  aux_sym_pipe_table_repeat1 = 198,
  aux_sym_pipe_table_delimiter_row_repeat1 = 199,
  aux_sym_pipe_table_delimiter_cell_repeat1 = 200,
  aux_sym_pipe_table_row_repeat1 = 201,
  aux_sym_pipe_table_cell_repeat1 = 202,
  alias_sym_inline = 203,
  alias_sym_pipe_table_align_left = 204,
  alias_sym_pipe_table_align_right = 205,
  alias_sym_pipe_table_header = 206,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__backslash_escape] = "_backslash_escape",
  [sym_entity_reference] = "entity_reference",
  [sym_numeric_character_reference] = "numeric_character_reference",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_BANG] = "!",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP] = "&",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_COMMA] = ",",
  [anon_sym_DASH] = "-",
  [anon_sym_DOT] = ".",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AT] = "@",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_CARET] = "^",
  [anon_sym__] = "_",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LBRACE] = "{",
  [anon_sym_PIPE] = "|",
  [anon_sym_RBRACE] = "}",
  [anon_sym_TILDE] = "~",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym__newline_token] = "_newline_token",
  [anon_sym_DASH_DASH_GT] = "-->",
  [anon_sym_QMARK_GT] = "\?>",
  [anon_sym_RBRACK_RBRACK_GT] = "]]>",
  [aux_sym__word_token1] = "_word_token1",
  [anon_sym_LBRACKx_RBRACK] = "[x]",
  [aux_sym__word_token2] = "_word_token2",
  [sym__whitespace] = "_whitespace",
  [sym__line_ending] = "_line_ending",
  [sym__soft_line_ending] = "_soft_line_ending",
  [sym__block_close] = "_block_close",
  [sym_block_continuation] = "block_continuation",
  [sym__block_quote_start] = "block_quote_marker",
  [sym__indented_chunk_start] = "_indented_chunk_start",
  [sym_atx_h1_marker] = "atx_h1_marker",
  [sym_atx_h2_marker] = "atx_h2_marker",
  [sym_atx_h3_marker] = "atx_h3_marker",
  [sym_atx_h4_marker] = "atx_h4_marker",
  [sym_atx_h5_marker] = "atx_h5_marker",
  [sym_atx_h6_marker] = "atx_h6_marker",
  [sym_setext_h1_underline] = "setext_h1_underline",
  [sym_setext_h2_underline] = "setext_h2_underline",
  [sym__thematic_break] = "_thematic_break",
  [sym__list_marker_minus] = "_list_marker_minus",
  [sym__list_marker_plus] = "_list_marker_plus",
  [sym__list_marker_star] = "_list_marker_star",
  [sym__list_marker_parenthesis] = "_list_marker_parenthesis",
  [sym__list_marker_dot] = "_list_marker_dot",
  [sym__list_marker_minus_dont_interrupt] = "_list_marker_minus_dont_interrupt",
  [sym__list_marker_plus_dont_interrupt] = "_list_marker_plus_dont_interrupt",
  [sym__list_marker_star_dont_interrupt] = "_list_marker_star_dont_interrupt",
  [sym__list_marker_parenthesis_dont_interrupt] = "_list_marker_parenthesis_dont_interrupt",
  [sym__list_marker_dot_dont_interrupt] = "_list_marker_dot_dont_interrupt",
  [sym__fenced_code_block_start_backtick] = "fenced_code_block_delimiter",
  [sym__fenced_code_block_start_tilde] = "fenced_code_block_delimiter",
  [sym__blank_line_start] = "_blank_line_start",
  [sym__fenced_code_block_end_backtick] = "fenced_code_block_delimiter",
  [sym__fenced_code_block_end_tilde] = "fenced_code_block_delimiter",
  [sym__html_block_1_start] = "_html_block_1_start",
  [sym__html_block_1_end] = "_html_block_1_end",
  [sym__html_block_2_start] = "_html_block_2_start",
  [sym__html_block_3_start] = "_html_block_3_start",
  [sym__html_block_4_start] = "_html_block_4_start",
  [sym__html_block_5_start] = "_html_block_5_start",
  [sym__html_block_6_start] = "_html_block_6_start",
  [sym__html_block_7_start] = "_html_block_7_start",
  [sym__close_block] = "_close_block",
  [sym__no_indented_chunk] = "_no_indented_chunk",
  [sym__error] = "_error",
  [sym__trigger_error] = "_trigger_error",
  [sym__eof] = "_eof",
  [sym_minus_metadata] = "minus_metadata",
  [sym_plus_metadata] = "plus_metadata",
  [sym__pipe_table_start] = "_pipe_table_start",
  [sym__pipe_table_line_ending] = "_pipe_table_line_ending",
  [sym_document] = "document",
  [sym_backslash_escape] = "backslash_escape",
  [sym_link_label] = "link_label",
  [sym_link_destination] = "link_destination",
  [sym__link_destination_parenthesis] = "_link_destination_parenthesis",
  [sym__text_no_angle] = "_text_no_angle",
  [sym_link_title] = "link_title",
  [sym__last_token_punctuation] = "_last_token_punctuation",
  [sym__block] = "_block",
  [sym__block_not_section] = "_block_not_section",
  [sym_section] = "section",
  [sym__section1] = "_section1",
  [sym__section2] = "_section2",
  [sym__section3] = "_section3",
  [sym__section4] = "_section4",
  [sym__section5] = "_section5",
  [sym__section6] = "_section6",
  [sym_thematic_break] = "thematic_break",
  [sym__atx_heading1] = "atx_heading",
  [sym__atx_heading2] = "atx_heading",
  [sym__atx_heading3] = "atx_heading",
  [sym__atx_heading4] = "atx_heading",
  [sym__atx_heading5] = "atx_heading",
  [sym__atx_heading6] = "atx_heading",
  [sym__setext_heading1] = "setext_heading",
  [sym__setext_heading2] = "setext_heading",
  [sym_indented_code_block] = "indented_code_block",
  [sym__indented_chunk] = "_indented_chunk",
  [sym_fenced_code_block] = "fenced_code_block",
  [sym_code_fence_content] = "code_fence_content",
  [sym_info_string] = "info_string",
  [sym_language] = "language",
  [sym_html_block] = "html_block",
  [sym__html_block_1] = "_html_block_1",
  [sym__html_block_2] = "_html_block_2",
  [sym__html_block_3] = "_html_block_3",
  [sym__html_block_4] = "_html_block_4",
  [sym__html_block_5] = "_html_block_5",
  [sym__html_block_6] = "_html_block_6",
  [sym__html_block_7] = "_html_block_7",
  [sym_link_reference_definition] = "link_reference_definition",
  [sym__text_inline_no_link] = "_text_inline_no_link",
  [sym_paragraph] = "paragraph",
  [sym__blank_line] = "_blank_line",
  [sym_block_quote] = "block_quote",
  [sym_list] = "list",
  [sym__list_plus] = "_list_plus",
  [sym__list_minus] = "_list_minus",
  [sym__list_star] = "_list_star",
  [sym__list_dot] = "_list_dot",
  [sym__list_parenthesis] = "_list_parenthesis",
  [sym_list_marker_plus] = "list_marker_plus",
  [sym_list_marker_minus] = "list_marker_minus",
  [sym_list_marker_star] = "list_marker_star",
  [sym_list_marker_dot] = "list_marker_dot",
  [sym_list_marker_parenthesis] = "list_marker_parenthesis",
  [sym__list_item_plus] = "list_item",
  [sym__list_item_minus] = "list_item",
  [sym__list_item_star] = "list_item",
  [sym__list_item_dot] = "list_item",
  [sym__list_item_parenthesis] = "list_item",
  [sym__list_item_content] = "_list_item_content",
  [sym__newline] = "_newline",
  [sym__soft_line_break] = "_soft_line_break",
  [sym__line] = "_line",
  [sym__word] = "_word",
  [sym_task_list_marker_checked] = "task_list_marker_checked",
  [sym_task_list_marker_unchecked] = "task_list_marker_unchecked",
  [sym_pipe_table] = "pipe_table",
  [sym__pipe_table_newline] = "_pipe_table_newline",
  [sym_pipe_table_delimiter_row] = "pipe_table_delimiter_row",
  [sym_pipe_table_delimiter_cell] = "pipe_table_delimiter_cell",
  [sym_pipe_table_row] = "pipe_table_row",
  [sym_pipe_table_cell] = "pipe_table_cell",
  [aux_sym_document_repeat1] = "document_repeat1",
  [aux_sym_document_repeat2] = "document_repeat2",
  [aux_sym_link_label_repeat1] = "link_label_repeat1",
  [aux_sym_link_destination_repeat1] = "link_destination_repeat1",
  [aux_sym_link_destination_repeat2] = "link_destination_repeat2",
  [aux_sym_link_title_repeat1] = "link_title_repeat1",
  [aux_sym_link_title_repeat2] = "link_title_repeat2",
  [aux_sym_link_title_repeat3] = "link_title_repeat3",
  [aux_sym__section1_repeat1] = "_section1_repeat1",
  [aux_sym__section2_repeat1] = "_section2_repeat1",
  [aux_sym__section3_repeat1] = "_section3_repeat1",
  [aux_sym__section4_repeat1] = "_section4_repeat1",
  [aux_sym__section5_repeat1] = "_section5_repeat1",
  [aux_sym_indented_code_block_repeat1] = "indented_code_block_repeat1",
  [aux_sym__indented_chunk_repeat1] = "_indented_chunk_repeat1",
  [aux_sym_code_fence_content_repeat1] = "code_fence_content_repeat1",
  [aux_sym_info_string_repeat1] = "info_string_repeat1",
  [aux_sym_info_string_repeat2] = "info_string_repeat2",
  [aux_sym_language_repeat1] = "language_repeat1",
  [aux_sym__html_block_1_repeat1] = "_html_block_1_repeat1",
  [aux_sym__html_block_2_repeat1] = "_html_block_2_repeat1",
  [aux_sym__html_block_3_repeat1] = "_html_block_3_repeat1",
  [aux_sym__html_block_4_repeat1] = "_html_block_4_repeat1",
  [aux_sym__html_block_5_repeat1] = "_html_block_5_repeat1",
  [aux_sym__html_block_6_repeat1] = "_html_block_6_repeat1",
  [aux_sym_paragraph_repeat1] = "paragraph_repeat1",
  [aux_sym_block_quote_repeat1] = "block_quote_repeat1",
  [aux_sym__list_plus_repeat1] = "_list_plus_repeat1",
  [aux_sym__list_minus_repeat1] = "_list_minus_repeat1",
  [aux_sym__list_star_repeat1] = "_list_star_repeat1",
  [aux_sym__list_dot_repeat1] = "_list_dot_repeat1",
  [aux_sym__list_parenthesis_repeat1] = "_list_parenthesis_repeat1",
  [aux_sym__line_repeat1] = "_line_repeat1",
  [aux_sym_pipe_table_repeat1] = "pipe_table_repeat1",
  [aux_sym_pipe_table_delimiter_row_repeat1] = "pipe_table_delimiter_row_repeat1",
  [aux_sym_pipe_table_delimiter_cell_repeat1] = "pipe_table_delimiter_cell_repeat1",
  [aux_sym_pipe_table_row_repeat1] = "pipe_table_row_repeat1",
  [aux_sym_pipe_table_cell_repeat1] = "pipe_table_cell_repeat1",
  [alias_sym_inline] = "inline",
  [alias_sym_pipe_table_align_left] = "pipe_table_align_left",
  [alias_sym_pipe_table_align_right] = "pipe_table_align_right",
  [alias_sym_pipe_table_header] = "pipe_table_header",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__backslash_escape] = sym__backslash_escape,
  [sym_entity_reference] = sym_entity_reference,
  [sym_numeric_character_reference] = sym_numeric_character_reference,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym__] = anon_sym__,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym__newline_token] = sym__newline_token,
  [anon_sym_DASH_DASH_GT] = anon_sym_DASH_DASH_GT,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [anon_sym_RBRACK_RBRACK_GT] = anon_sym_RBRACK_RBRACK_GT,
  [aux_sym__word_token1] = aux_sym__word_token1,
  [anon_sym_LBRACKx_RBRACK] = anon_sym_LBRACKx_RBRACK,
  [aux_sym__word_token2] = aux_sym__word_token2,
  [sym__whitespace] = sym__whitespace,
  [sym__line_ending] = sym__line_ending,
  [sym__soft_line_ending] = sym__soft_line_ending,
  [sym__block_close] = sym__block_close,
  [sym_block_continuation] = sym_block_continuation,
  [sym__block_quote_start] = sym__block_quote_start,
  [sym__indented_chunk_start] = sym__indented_chunk_start,
  [sym_atx_h1_marker] = sym_atx_h1_marker,
  [sym_atx_h2_marker] = sym_atx_h2_marker,
  [sym_atx_h3_marker] = sym_atx_h3_marker,
  [sym_atx_h4_marker] = sym_atx_h4_marker,
  [sym_atx_h5_marker] = sym_atx_h5_marker,
  [sym_atx_h6_marker] = sym_atx_h6_marker,
  [sym_setext_h1_underline] = sym_setext_h1_underline,
  [sym_setext_h2_underline] = sym_setext_h2_underline,
  [sym__thematic_break] = sym__thematic_break,
  [sym__list_marker_minus] = sym__list_marker_minus,
  [sym__list_marker_plus] = sym__list_marker_plus,
  [sym__list_marker_star] = sym__list_marker_star,
  [sym__list_marker_parenthesis] = sym__list_marker_parenthesis,
  [sym__list_marker_dot] = sym__list_marker_dot,
  [sym__list_marker_minus_dont_interrupt] = sym__list_marker_minus_dont_interrupt,
  [sym__list_marker_plus_dont_interrupt] = sym__list_marker_plus_dont_interrupt,
  [sym__list_marker_star_dont_interrupt] = sym__list_marker_star_dont_interrupt,
  [sym__list_marker_parenthesis_dont_interrupt] = sym__list_marker_parenthesis_dont_interrupt,
  [sym__list_marker_dot_dont_interrupt] = sym__list_marker_dot_dont_interrupt,
  [sym__fenced_code_block_start_backtick] = sym__fenced_code_block_start_backtick,
  [sym__fenced_code_block_start_tilde] = sym__fenced_code_block_start_backtick,
  [sym__blank_line_start] = sym__blank_line_start,
  [sym__fenced_code_block_end_backtick] = sym__fenced_code_block_start_backtick,
  [sym__fenced_code_block_end_tilde] = sym__fenced_code_block_start_backtick,
  [sym__html_block_1_start] = sym__html_block_1_start,
  [sym__html_block_1_end] = sym__html_block_1_end,
  [sym__html_block_2_start] = sym__html_block_2_start,
  [sym__html_block_3_start] = sym__html_block_3_start,
  [sym__html_block_4_start] = sym__html_block_4_start,
  [sym__html_block_5_start] = sym__html_block_5_start,
  [sym__html_block_6_start] = sym__html_block_6_start,
  [sym__html_block_7_start] = sym__html_block_7_start,
  [sym__close_block] = sym__close_block,
  [sym__no_indented_chunk] = sym__no_indented_chunk,
  [sym__error] = sym__error,
  [sym__trigger_error] = sym__trigger_error,
  [sym__eof] = sym__eof,
  [sym_minus_metadata] = sym_minus_metadata,
  [sym_plus_metadata] = sym_plus_metadata,
  [sym__pipe_table_start] = sym__pipe_table_start,
  [sym__pipe_table_line_ending] = sym__pipe_table_line_ending,
  [sym_document] = sym_document,
  [sym_backslash_escape] = sym_backslash_escape,
  [sym_link_label] = sym_link_label,
  [sym_link_destination] = sym_link_destination,
  [sym__link_destination_parenthesis] = sym__link_destination_parenthesis,
  [sym__text_no_angle] = sym__text_no_angle,
  [sym_link_title] = sym_link_title,
  [sym__last_token_punctuation] = sym__last_token_punctuation,
  [sym__block] = sym__block,
  [sym__block_not_section] = sym__block_not_section,
  [sym_section] = sym_section,
  [sym__section1] = sym__section1,
  [sym__section2] = sym__section2,
  [sym__section3] = sym__section3,
  [sym__section4] = sym__section4,
  [sym__section5] = sym__section5,
  [sym__section6] = sym__section6,
  [sym_thematic_break] = sym_thematic_break,
  [sym__atx_heading1] = sym__atx_heading1,
  [sym__atx_heading2] = sym__atx_heading1,
  [sym__atx_heading3] = sym__atx_heading1,
  [sym__atx_heading4] = sym__atx_heading1,
  [sym__atx_heading5] = sym__atx_heading1,
  [sym__atx_heading6] = sym__atx_heading1,
  [sym__setext_heading1] = sym__setext_heading1,
  [sym__setext_heading2] = sym__setext_heading1,
  [sym_indented_code_block] = sym_indented_code_block,
  [sym__indented_chunk] = sym__indented_chunk,
  [sym_fenced_code_block] = sym_fenced_code_block,
  [sym_code_fence_content] = sym_code_fence_content,
  [sym_info_string] = sym_info_string,
  [sym_language] = sym_language,
  [sym_html_block] = sym_html_block,
  [sym__html_block_1] = sym__html_block_1,
  [sym__html_block_2] = sym__html_block_2,
  [sym__html_block_3] = sym__html_block_3,
  [sym__html_block_4] = sym__html_block_4,
  [sym__html_block_5] = sym__html_block_5,
  [sym__html_block_6] = sym__html_block_6,
  [sym__html_block_7] = sym__html_block_7,
  [sym_link_reference_definition] = sym_link_reference_definition,
  [sym__text_inline_no_link] = sym__text_inline_no_link,
  [sym_paragraph] = sym_paragraph,
  [sym__blank_line] = sym__blank_line,
  [sym_block_quote] = sym_block_quote,
  [sym_list] = sym_list,
  [sym__list_plus] = sym__list_plus,
  [sym__list_minus] = sym__list_minus,
  [sym__list_star] = sym__list_star,
  [sym__list_dot] = sym__list_dot,
  [sym__list_parenthesis] = sym__list_parenthesis,
  [sym_list_marker_plus] = sym_list_marker_plus,
  [sym_list_marker_minus] = sym_list_marker_minus,
  [sym_list_marker_star] = sym_list_marker_star,
  [sym_list_marker_dot] = sym_list_marker_dot,
  [sym_list_marker_parenthesis] = sym_list_marker_parenthesis,
  [sym__list_item_plus] = sym__list_item_plus,
  [sym__list_item_minus] = sym__list_item_plus,
  [sym__list_item_star] = sym__list_item_plus,
  [sym__list_item_dot] = sym__list_item_plus,
  [sym__list_item_parenthesis] = sym__list_item_plus,
  [sym__list_item_content] = sym__list_item_content,
  [sym__newline] = sym__newline,
  [sym__soft_line_break] = sym__soft_line_break,
  [sym__line] = sym__line,
  [sym__word] = sym__word,
  [sym_task_list_marker_checked] = sym_task_list_marker_checked,
  [sym_task_list_marker_unchecked] = sym_task_list_marker_unchecked,
  [sym_pipe_table] = sym_pipe_table,
  [sym__pipe_table_newline] = sym__pipe_table_newline,
  [sym_pipe_table_delimiter_row] = sym_pipe_table_delimiter_row,
  [sym_pipe_table_delimiter_cell] = sym_pipe_table_delimiter_cell,
  [sym_pipe_table_row] = sym_pipe_table_row,
  [sym_pipe_table_cell] = sym_pipe_table_cell,
  [aux_sym_document_repeat1] = aux_sym_document_repeat1,
  [aux_sym_document_repeat2] = aux_sym_document_repeat2,
  [aux_sym_link_label_repeat1] = aux_sym_link_label_repeat1,
  [aux_sym_link_destination_repeat1] = aux_sym_link_destination_repeat1,
  [aux_sym_link_destination_repeat2] = aux_sym_link_destination_repeat2,
  [aux_sym_link_title_repeat1] = aux_sym_link_title_repeat1,
  [aux_sym_link_title_repeat2] = aux_sym_link_title_repeat2,
  [aux_sym_link_title_repeat3] = aux_sym_link_title_repeat3,
  [aux_sym__section1_repeat1] = aux_sym__section1_repeat1,
  [aux_sym__section2_repeat1] = aux_sym__section2_repeat1,
  [aux_sym__section3_repeat1] = aux_sym__section3_repeat1,
  [aux_sym__section4_repeat1] = aux_sym__section4_repeat1,
  [aux_sym__section5_repeat1] = aux_sym__section5_repeat1,
  [aux_sym_indented_code_block_repeat1] = aux_sym_indented_code_block_repeat1,
  [aux_sym__indented_chunk_repeat1] = aux_sym__indented_chunk_repeat1,
  [aux_sym_code_fence_content_repeat1] = aux_sym_code_fence_content_repeat1,
  [aux_sym_info_string_repeat1] = aux_sym_info_string_repeat1,
  [aux_sym_info_string_repeat2] = aux_sym_info_string_repeat2,
  [aux_sym_language_repeat1] = aux_sym_language_repeat1,
  [aux_sym__html_block_1_repeat1] = aux_sym__html_block_1_repeat1,
  [aux_sym__html_block_2_repeat1] = aux_sym__html_block_2_repeat1,
  [aux_sym__html_block_3_repeat1] = aux_sym__html_block_3_repeat1,
  [aux_sym__html_block_4_repeat1] = aux_sym__html_block_4_repeat1,
  [aux_sym__html_block_5_repeat1] = aux_sym__html_block_5_repeat1,
  [aux_sym__html_block_6_repeat1] = aux_sym__html_block_6_repeat1,
  [aux_sym_paragraph_repeat1] = aux_sym_paragraph_repeat1,
  [aux_sym_block_quote_repeat1] = aux_sym_block_quote_repeat1,
  [aux_sym__list_plus_repeat1] = aux_sym__list_plus_repeat1,
  [aux_sym__list_minus_repeat1] = aux_sym__list_minus_repeat1,
  [aux_sym__list_star_repeat1] = aux_sym__list_star_repeat1,
  [aux_sym__list_dot_repeat1] = aux_sym__list_dot_repeat1,
  [aux_sym__list_parenthesis_repeat1] = aux_sym__list_parenthesis_repeat1,
  [aux_sym__line_repeat1] = aux_sym__line_repeat1,
  [aux_sym_pipe_table_repeat1] = aux_sym_pipe_table_repeat1,
  [aux_sym_pipe_table_delimiter_row_repeat1] = aux_sym_pipe_table_delimiter_row_repeat1,
  [aux_sym_pipe_table_delimiter_cell_repeat1] = aux_sym_pipe_table_delimiter_cell_repeat1,
  [aux_sym_pipe_table_row_repeat1] = aux_sym_pipe_table_row_repeat1,
  [aux_sym_pipe_table_cell_repeat1] = aux_sym_pipe_table_cell_repeat1,
  [alias_sym_inline] = alias_sym_inline,
  [alias_sym_pipe_table_align_left] = alias_sym_pipe_table_align_left,
  [alias_sym_pipe_table_align_right] = alias_sym_pipe_table_align_right,
  [alias_sym_pipe_table_header] = alias_sym_pipe_table_header,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__backslash_escape] = {
    .visible = false,
    .named = true,
  },
  [sym_entity_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric_character_reference] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym__newline_token] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DASH_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__word_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACKx_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__word_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__line_ending] = {
    .visible = false,
    .named = true,
  },
  [sym__soft_line_ending] = {
    .visible = false,
    .named = true,
  },
  [sym__block_close] = {
    .visible = false,
    .named = true,
  },
  [sym_block_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym__block_quote_start] = {
    .visible = true,
    .named = true,
  },
  [sym__indented_chunk_start] = {
    .visible = false,
    .named = true,
  },
  [sym_atx_h1_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_atx_h2_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_atx_h3_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_atx_h4_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_atx_h5_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_atx_h6_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_setext_h1_underline] = {
    .visible = true,
    .named = true,
  },
  [sym_setext_h2_underline] = {
    .visible = true,
    .named = true,
  },
  [sym__thematic_break] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_minus] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_plus] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_star] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_minus_dont_interrupt] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_plus_dont_interrupt] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_star_dont_interrupt] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_parenthesis_dont_interrupt] = {
    .visible = false,
    .named = true,
  },
  [sym__list_marker_dot_dont_interrupt] = {
    .visible = false,
    .named = true,
  },
  [sym__fenced_code_block_start_backtick] = {
    .visible = true,
    .named = true,
  },
  [sym__fenced_code_block_start_tilde] = {
    .visible = true,
    .named = true,
  },
  [sym__blank_line_start] = {
    .visible = false,
    .named = true,
  },
  [sym__fenced_code_block_end_backtick] = {
    .visible = true,
    .named = true,
  },
  [sym__fenced_code_block_end_tilde] = {
    .visible = true,
    .named = true,
  },
  [sym__html_block_1_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_1_end] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_2_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_3_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_4_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_5_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_6_start] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_7_start] = {
    .visible = false,
    .named = true,
  },
  [sym__close_block] = {
    .visible = false,
    .named = true,
  },
  [sym__no_indented_chunk] = {
    .visible = false,
    .named = true,
  },
  [sym__error] = {
    .visible = false,
    .named = true,
  },
  [sym__trigger_error] = {
    .visible = false,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_minus_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_plus_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__pipe_table_start] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_table_line_ending] = {
    .visible = false,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym_backslash_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_link_label] = {
    .visible = true,
    .named = true,
  },
  [sym_link_destination] = {
    .visible = true,
    .named = true,
  },
  [sym__link_destination_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__text_no_angle] = {
    .visible = false,
    .named = true,
  },
  [sym_link_title] = {
    .visible = true,
    .named = true,
  },
  [sym__last_token_punctuation] = {
    .visible = false,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym__block_not_section] = {
    .visible = false,
    .named = true,
  },
  [sym_section] = {
    .visible = true,
    .named = true,
  },
  [sym__section1] = {
    .visible = false,
    .named = true,
  },
  [sym__section2] = {
    .visible = false,
    .named = true,
  },
  [sym__section3] = {
    .visible = false,
    .named = true,
  },
  [sym__section4] = {
    .visible = false,
    .named = true,
  },
  [sym__section5] = {
    .visible = false,
    .named = true,
  },
  [sym__section6] = {
    .visible = false,
    .named = true,
  },
  [sym_thematic_break] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading1] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading2] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading3] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading4] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading5] = {
    .visible = true,
    .named = true,
  },
  [sym__atx_heading6] = {
    .visible = true,
    .named = true,
  },
  [sym__setext_heading1] = {
    .visible = true,
    .named = true,
  },
  [sym__setext_heading2] = {
    .visible = true,
    .named = true,
  },
  [sym_indented_code_block] = {
    .visible = true,
    .named = true,
  },
  [sym__indented_chunk] = {
    .visible = false,
    .named = true,
  },
  [sym_fenced_code_block] = {
    .visible = true,
    .named = true,
  },
  [sym_code_fence_content] = {
    .visible = true,
    .named = true,
  },
  [sym_info_string] = {
    .visible = true,
    .named = true,
  },
  [sym_language] = {
    .visible = true,
    .named = true,
  },
  [sym_html_block] = {
    .visible = true,
    .named = true,
  },
  [sym__html_block_1] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_2] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_3] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_4] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_5] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_6] = {
    .visible = false,
    .named = true,
  },
  [sym__html_block_7] = {
    .visible = false,
    .named = true,
  },
  [sym_link_reference_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__text_inline_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym_paragraph] = {
    .visible = true,
    .named = true,
  },
  [sym__blank_line] = {
    .visible = false,
    .named = true,
  },
  [sym_block_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__list_plus] = {
    .visible = false,
    .named = true,
  },
  [sym__list_minus] = {
    .visible = false,
    .named = true,
  },
  [sym__list_star] = {
    .visible = false,
    .named = true,
  },
  [sym__list_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__list_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym_list_marker_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_minus] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_star] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_list_marker_parenthesis] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_plus] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_minus] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_star] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_dot] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_parenthesis] = {
    .visible = true,
    .named = true,
  },
  [sym__list_item_content] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__soft_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__line] = {
    .visible = false,
    .named = true,
  },
  [sym__word] = {
    .visible = false,
    .named = true,
  },
  [sym_task_list_marker_checked] = {
    .visible = true,
    .named = true,
  },
  [sym_task_list_marker_unchecked] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_table] = {
    .visible = true,
    .named = true,
  },
  [sym__pipe_table_newline] = {
    .visible = false,
    .named = true,
  },
  [sym_pipe_table_delimiter_row] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_table_delimiter_cell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_table_row] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_table_cell] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_document_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_document_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_label_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section1_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section2_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section3_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section4_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section5_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_indented_code_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__indented_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_code_fence_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_info_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_info_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_language_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_1_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_2_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_3_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_4_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_5_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_block_6_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_paragraph_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_quote_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_plus_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_minus_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_star_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_dot_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_parenthesis_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__line_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pipe_table_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pipe_table_delimiter_row_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pipe_table_delimiter_cell_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pipe_table_row_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pipe_table_cell_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_inline] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pipe_table_align_left] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pipe_table_align_right] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pipe_table_header] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_heading_content = 1,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_heading_content] = "heading_content",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_heading_content, 0, .inherited = true},
  [1] =
    {field_heading_content, 1},
  [2] =
    {field_heading_content, 0},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_section,
  },
  [3] = {
    [1] = sym_section,
  },
  [4] = {
    [0] = alias_sym_inline,
  },
  [5] = {
    [1] = alias_sym_inline,
  },
  [7] = {
    [0] = alias_sym_pipe_table_align_left,
  },
  [8] = {
    [1] = alias_sym_pipe_table_header,
  },
  [9] = {
    [1] = alias_sym_pipe_table_align_right,
  },
  [10] = {
    [0] = alias_sym_pipe_table_align_left,
    [2] = alias_sym_pipe_table_align_right,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__section2, 2,
    sym__section2,
    sym_section,
  sym__section3, 2,
    sym__section3,
    sym_section,
  sym__section4, 2,
    sym__section4,
    sym_section,
  sym__section5, 2,
    sym__section5,
    sym_section,
  sym__section6, 2,
    sym__section6,
    sym_section,
  sym__line, 2,
    sym__line,
    alias_sym_inline,
  sym_pipe_table_row, 2,
    sym_pipe_table_row,
    alias_sym_pipe_table_header,
  aux_sym_document_repeat1, 2,
    aux_sym_document_repeat1,
    sym_section,
  aux_sym_paragraph_repeat1, 2,
    aux_sym_paragraph_repeat1,
    alias_sym_inline,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(2031);
      if (lookahead == '\n') ADVANCE(2072);
      if (lookahead == '\r') ADVANCE(2073);
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2046);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2052);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2059);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2062);
      if (lookahead == ']') ADVANCE(2037);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0) ADVANCE(2077);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2046);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2051);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2058);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2062);
      if (lookahead == ']') ADVANCE(2036);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2045);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2052);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2058);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2061);
      if (lookahead == ']') ADVANCE(2036);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2045);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2051);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2059);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2061);
      if (lookahead == ']') ADVANCE(2036);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2045);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2051);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2058);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2062);
      if (lookahead == ']') ADVANCE(2036);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2045);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2051);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2058);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2061);
      if (lookahead == ']') ADVANCE(2037);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 6:
      if (lookahead == '1') ADVANCE(2005);
      if (lookahead == '3') ADVANCE(9);
      END_STATE();
    case 7:
      if (lookahead == '1') ADVANCE(2020);
      if (lookahead == ';') ADVANCE(2033);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(2027);
      if (lookahead == '2') ADVANCE(2006);
      if (lookahead == '3') ADVANCE(2023);
      if (lookahead == '4') ADVANCE(11);
      if (lookahead == '5') ADVANCE(2007);
      if (lookahead == '7') ADVANCE(12);
      END_STATE();
    case 9:
      if (lookahead == '4') ADVANCE(13);
      END_STATE();
    case 10:
      if (lookahead == '4') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(1517);
      END_STATE();
    case 11:
      if (lookahead == '5') ADVANCE(13);
      END_STATE();
    case 12:
      if (lookahead == '8') ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == ';') ADVANCE(2033);
      END_STATE();
    case 14:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'A') ADVANCE(443);
      if (lookahead == 'B') ADVANCE(433);
      if (lookahead == 'E') ADVANCE(136);
      if (lookahead == 'H') ADVANCE(396);
      if (lookahead == 'a') ADVANCE(668);
      if (lookahead == 'b') ADVANCE(434);
      if (lookahead == 'c') ADVANCE(460);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(133);
      if (lookahead == 'f') ADVANCE(1110);
      if (lookahead == 'g') ADVANCE(28);
      if (lookahead == 'h') ADVANCE(478);
      if (lookahead == 'j') ADVANCE(603);
      if (lookahead == 'l') ADVANCE(62);
      if (lookahead == 'm') ADVANCE(1093);
      if (lookahead == 'n') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(404);
      if (lookahead == 'p') ADVANCE(482);
      if (lookahead == 'r') ADVANCE(437);
      if (lookahead == 's') ADVANCE(384);
      if (lookahead == 't') ADVANCE(88);
      if (lookahead == 'u') ADVANCE(1627);
      if (lookahead == 'v') ADVANCE(920);
      END_STATE();
    case 15:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1611);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'q') ADVANCE(1928);
      if (lookahead == 's') ADVANCE(827);
      if (lookahead == 'x') ADVANCE(1152);
      END_STATE();
    case 16:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'A') ADVANCE(1730);
      END_STATE();
    case 17:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'V') ADVANCE(921);
      END_STATE();
    case 18:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      END_STATE();
    case 19:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'D') ADVANCE(1501);
      END_STATE();
    case 20:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'E') ADVANCE(1589);
      END_STATE();
    case 21:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'L') ADVANCE(923);
      END_STATE();
    case 22:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'R') ADVANCE(1174);
      END_STATE();
    case 23:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'U') ADVANCE(1545);
      END_STATE();
    case 24:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'C') ADVANCE(1512);
      if (lookahead == 'D') ADVANCE(1486);
      if (lookahead == 'E') ADVANCE(1221);
      if (lookahead == 'G') ADVANCE(1746);
      if (lookahead == 'H') ADVANCE(1939);
      if (lookahead == 'L') ADVANCE(895);
      if (lookahead == 'N') ADVANCE(862);
      if (lookahead == 'P') ADVANCE(1707);
      if (lookahead == 'R') ADVANCE(896);
      if (lookahead == 'S') ADVANCE(1590);
      if (lookahead == 'T') ADVANCE(1099);
      if (lookahead == 'V') ADVANCE(935);
      END_STATE();
    case 25:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'C') ADVANCE(422);
      END_STATE();
    case 26:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'D') ADVANCE(1447);
      if (lookahead == 'E') ADVANCE(1589);
      END_STATE();
    case 27:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'D') ADVANCE(297);
      END_STATE();
    case 28:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      END_STATE();
    case 29:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'c') ADVANCE(1917);
      if (lookahead == 'e') ADVANCE(87);
      if (lookahead == 'i') ADVANCE(1348);
      if (lookahead == 'n') ADVANCE(314);
      if (lookahead == 'o') ADVANCE(731);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 'u') ADVANCE(1658);
      END_STATE();
    case 30:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(98);
      if (lookahead == 'm') ADVANCE(1924);
      if (lookahead == 'n') ADVANCE(2008);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 'r') ADVANCE(433);
      if (lookahead == 's') ADVANCE(875);
      END_STATE();
    case 31:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'v') ADVANCE(2024);
      END_STATE();
    case 32:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 33:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(730);
      if (lookahead == 'o') ADVANCE(1752);
      if (lookahead == 'p') ADVANCE(1678);
      END_STATE();
    case 34:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(152);
      if (lookahead == 'a') ADVANCE(670);
      if (lookahead == 'b') ADVANCE(1598);
      if (lookahead == 'c') ADVANCE(1140);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(136);
      if (lookahead == 'i') ADVANCE(1333);
      if (lookahead == 'j') ADVANCE(603);
      if (lookahead == 'l') ADVANCE(228);
      if (lookahead == 'n') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'r') ADVANCE(387);
      if (lookahead == 's') ADVANCE(638);
      if (lookahead == 't') ADVANCE(89);
      if (lookahead == 'v') ADVANCE(920);
      END_STATE();
    case 35:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      END_STATE();
    case 36:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      if (lookahead == 'F') ADVANCE(1946);
      if (lookahead == 'G') ADVANCE(1739);
      if (lookahead == 'L') ADVANCE(821);
      if (lookahead == 'S') ADVANCE(1307);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 37:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      if (lookahead == 'F') ADVANCE(1946);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 38:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      if (lookahead == 'G') ADVANCE(1739);
      if (lookahead == 'L') ADVANCE(821);
      if (lookahead == 'S') ADVANCE(1307);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 39:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      if (lookahead == 'S') ADVANCE(1307);
      END_STATE();
    case 40:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E') ADVANCE(1589);
      if (lookahead == 'S') ADVANCE(1307);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 41:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'G') ADVANCE(13);
      END_STATE();
    case 42:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'H') ADVANCE(13);
      END_STATE();
    case 43:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'I') ADVANCE(1429);
      if (lookahead == 'S') ADVANCE(1910);
      if (lookahead == 'U') ADVANCE(1410);
      END_STATE();
    case 44:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'J') ADVANCE(603);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(669);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == 'e') ADVANCE(952);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(113);
      if (lookahead == 'm') ADVANCE(1092);
      if (lookahead == 'o') ADVANCE(1377);
      if (lookahead == 's') ADVANCE(635);
      END_STATE();
    case 45:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'J') ADVANCE(603);
      if (lookahead == 'T' ||
          lookahead == 'g' ||
          lookahead == 't') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1349);
      if (lookahead == 'b') ADVANCE(1598);
      if (lookahead == 'c') ADVANCE(831);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'r') ADVANCE(847);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 46:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'L') ADVANCE(821);
      END_STATE();
    case 47:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'N') ADVANCE(13);
      END_STATE();
    case 48:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'P') ADVANCE(13);
      END_STATE();
    case 49:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'P') ADVANCE(1297);
      END_STATE();
    case 50:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'T') ADVANCE(13);
      END_STATE();
    case 51:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 52:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'Y') ADVANCE(13);
      END_STATE();
    case 53:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(633);
      if (lookahead == 'p') ADVANCE(1263);
      END_STATE();
    case 54:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(984);
      if (lookahead == 'o') ADVANCE(1862);
      END_STATE();
    case 55:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(2028);
      END_STATE();
    case 56:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(627);
      if (lookahead == 'l') ADVANCE(13);
      END_STATE();
    case 57:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1599);
      END_STATE();
    case 58:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(641);
      if (lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 59:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(158);
      if (lookahead == 's') ADVANCE(1105);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 60:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'b') ADVANCE(132);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(1752);
      if (lookahead == 'h') ADVANCE(1188);
      if (lookahead == 'l') ADVANCE(1526);
      if (lookahead == 'p') ADVANCE(1207);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 't') ADVANCE(1207);
      END_STATE();
    case 61:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(699);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(13);
      if (lookahead == 'c') ADVANCE(1082);
      if (lookahead == 'd') ADVANCE(2018);
      if (lookahead == 'm') ADVANCE(162);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 't') ADVANCE(1970);
      END_STATE();
    case 62:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'c') ADVANCE(1498);
      if (lookahead == 'h') ADVANCE(497);
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 63:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'd') ADVANCE(128);
      if (lookahead == 'i') ADVANCE(986);
      if (lookahead == 'o') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(1262);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 64:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1752);
      END_STATE();
    case 65:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1082);
      if (lookahead == 'd') ADVANCE(1454);
      END_STATE();
    case 66:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1207);
      END_STATE();
    case 67:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'e') ADVANCE(770);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 68:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1212);
      if (lookahead == 'c') ADVANCE(1807);
      if (lookahead == 'g') ADVANCE(13);
      END_STATE();
    case 69:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1352);
      if (lookahead == 'b') ADVANCE(1721);
      if (lookahead == 'c') ADVANCE(426);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 70:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1352);
      if (lookahead == 'd' ||
          lookahead == 'v') ADVANCE(13);
      if (lookahead == 's') ADVANCE(1262);
      END_STATE();
    case 71:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(692);
      END_STATE();
    case 72:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1647);
      if (lookahead == 'c') ADVANCE(1039);
      if (lookahead == 'o') ADVANCE(1686);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 73:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1232);
      END_STATE();
    case 74:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1615);
      if (lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 75:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1561);
      if (lookahead == 'c') ADVANCE(1937);
      if (lookahead == 'e') ADVANCE(1581);
      if (lookahead == 'n') ADVANCE(519);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 76:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1112);
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 77:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a') ADVANCE(1306);
      if (lookahead == 's') ADVANCE(1207);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 78:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(1447);
      if (lookahead == 'c') ADVANCE(1082);
      if (lookahead == 'f') ADVANCE(171);
      END_STATE();
    case 79:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(13);
      if (lookahead == 'd') ADVANCE(208);
      END_STATE();
    case 80:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(13);
      if (lookahead == 'h') ADVANCE(1799);
      END_STATE();
    case 81:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(57);
      END_STATE();
    case 82:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(57);
      if (lookahead == 'd') ADVANCE(13);
      END_STATE();
    case 83:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(132);
      if (lookahead == 'f') ADVANCE(1752);
      if (lookahead == 'h') ADVANCE(1188);
      if (lookahead == 'l') ADVANCE(1526);
      if (lookahead == 'p') ADVANCE(1207);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 't') ADVANCE(1207);
      END_STATE();
    case 84:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 'e') ADVANCE(1581);
      END_STATE();
    case 85:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b') ADVANCE(1674);
      if (lookahead == 'c') ADVANCE(426);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'o') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 86:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(13);
      END_STATE();
    case 87:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(75);
      END_STATE();
    case 88:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(612);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'h') ADVANCE(1648);
      if (lookahead == 'i') ADVANCE(1346);
      if (lookahead == 'l') ADVANCE(433);
      if (lookahead == 'q') ADVANCE(1929);
      if (lookahead == 'r') ADVANCE(356);
      END_STATE();
    case 89:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(612);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'l') ADVANCE(355);
      if (lookahead == 'q') ADVANCE(1929);
      if (lookahead == 'r') ADVANCE(421);
      END_STATE();
    case 90:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(115);
      END_STATE();
    case 91:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(611);
      if (lookahead == 'd') ADVANCE(1491);
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 92:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(611);
      if (lookahead == 'd') ADVANCE(1492);
      if (lookahead == 'g') ADVANCE(123);
      if (lookahead == 's') ADVANCE(518);
      END_STATE();
    case 93:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(449);
      if (lookahead == 'e') ADVANCE(1017);
      if (lookahead == 'l') ADVANCE(504);
      if (lookahead == 'p') ADVANCE(1659);
      END_STATE();
    case 94:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(1082);
      if (lookahead == 'w') ADVANCE(13);
      END_STATE();
    case 95:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(1917);
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 96:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(1917);
      if (lookahead == 'e' ||
          lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 97:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c') ADVANCE(539);
      if (lookahead == 'f') ADVANCE(1127);
      if (lookahead == 'o') ADVANCE(725);
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 98:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1447);
      END_STATE();
    case 99:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(178);
      if (lookahead == 'g') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(775);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 'r') ADVANCE(433);
      END_STATE();
    case 100:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(13);
      END_STATE();
    case 101:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(775);
      END_STATE();
    case 102:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1440);
      if (lookahead == 'l') ADVANCE(835);
      if (lookahead == 'r') ADVANCE(1135);
      END_STATE();
    case 103:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1440);
      if (lookahead == 'l') ADVANCE(835);
      if (lookahead == 'u') ADVANCE(1526);
      END_STATE();
    case 104:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1440);
      if (lookahead == 'l') ADVANCE(928);
      if (lookahead == 'q') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(1178);
      END_STATE();
    case 105:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1112);
      END_STATE();
    case 106:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(13);
      END_STATE();
    case 107:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(775);
      if (lookahead == 'm') ADVANCE(1782);
      if (lookahead == 'r') ADVANCE(1836);
      if (lookahead == 's') ADVANCE(1549);
      if (lookahead == 'z') ADVANCE(433);
      END_STATE();
    case 108:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 's') ADVANCE(863);
      END_STATE();
    case 109:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1599);
      END_STATE();
    case 110:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1582);
      if (lookahead == 'm') ADVANCE(1164);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 's') ADVANCE(1596);
      END_STATE();
    case 111:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1807);
      END_STATE();
    case 112:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1010);
      END_STATE();
    case 113:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(955);
      END_STATE();
    case 114:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 115:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1581);
      END_STATE();
    case 116:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1581);
      if (lookahead == 'l') ADVANCE(796);
      END_STATE();
    case 117:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 118:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(701);
      if (lookahead == 'i') ADVANCE(1336);
      if (lookahead == 'o') ADVANCE(754);
      END_STATE();
    case 119:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1586);
      END_STATE();
    case 121:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1586);
      if (lookahead == 'n') ADVANCE(840);
      END_STATE();
    case 122:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(448);
      END_STATE();
    case 123:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1752);
      END_STATE();
    case 124:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1783);
      END_STATE();
    case 125:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1407);
      if (lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 126:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1684);
      if (lookahead == 's') ADVANCE(811);
      END_STATE();
    case 127:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1640);
      if (lookahead == 's') ADVANCE(1526);
      END_STATE();
    case 128:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1650);
      if (lookahead == 'f' ||
          lookahead == 'm') ADVANCE(13);
      END_STATE();
    case 129:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e') ADVANCE(1639);
      END_STATE();
    case 130:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 131:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(1436);
      if (lookahead == 'y') ADVANCE(188);
      END_STATE();
    case 132:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(1752);
      END_STATE();
    case 133:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(1812);
      if (lookahead == 'g') ADVANCE(13);
      if (lookahead == 'q') ADVANCE(179);
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 134:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(1353);
      if (lookahead == 'l') ADVANCE(797);
      END_STATE();
    case 135:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f') ADVANCE(1838);
      if (lookahead == 'q') ADVANCE(179);
      if (lookahead == 's') ADVANCE(187);
      END_STATE();
    case 136:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'g') ADVANCE(13);
      END_STATE();
    case 137:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'g') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1828);
      if (lookahead == 'm') ADVANCE(1560);
      END_STATE();
    case 138:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'g') ADVANCE(1807);
      END_STATE();
    case 139:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'g') ADVANCE(775);
      END_STATE();
    case 140:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 141:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1478);
      END_STATE();
    case 142:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'h') ADVANCE(1437);
      END_STATE();
    case 143:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1085);
      if (lookahead == 'n') ADVANCE(967);
      if (lookahead == 'o') ADVANCE(1828);
      END_STATE();
    case 144:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(749);
      if (lookahead == 'o') ADVANCE(1370);
      END_STATE();
    case 145:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1629);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 146:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1387);
      if (lookahead == 'p') ADVANCE(501);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 147:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1866);
      END_STATE();
    case 148:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(714);
      END_STATE();
    case 149:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1362);
      if (lookahead == 'n') ADVANCE(1095);
      END_STATE();
    case 150:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1289);
      END_STATE();
    case 151:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'i') ADVANCE(1426);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 's') ADVANCE(98);
      END_STATE();
    case 152:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(13);
      END_STATE();
    case 153:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'q') ADVANCE(179);
      if (lookahead == 's') ADVANCE(91);
      END_STATE();
    case 154:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(1807);
      END_STATE();
    case 155:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(1478);
      END_STATE();
    case 156:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(1478);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 157:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(1869);
      if (lookahead == 'm') ADVANCE(422);
      END_STATE();
    case 158:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'l') ADVANCE(1248);
      END_STATE();
    case 159:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'm') ADVANCE(13);
      END_STATE();
    case 160:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'm') ADVANCE(127);
      END_STATE();
    case 161:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'm') ADVANCE(455);
      END_STATE();
    case 162:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 163:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'n') ADVANCE(474);
      END_STATE();
    case 164:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(13);
      END_STATE();
    case 165:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 166:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(152);
      END_STATE();
    case 167:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(945);
      END_STATE();
    case 168:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1975);
      END_STATE();
    case 169:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1965);
      END_STATE();
    case 170:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(699);
      END_STATE();
    case 171:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1653);
      END_STATE();
    case 172:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1882);
      END_STATE();
    case 173:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1392);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 174:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'o') ADVANCE(1417);
      END_STATE();
    case 175:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 176:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 177:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'p') ADVANCE(1678);
      END_STATE();
    case 178:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'q') ADVANCE(13);
      END_STATE();
    case 179:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'q') ADVANCE(13);
      if (lookahead == 's') ADVANCE(1292);
      END_STATE();
    case 180:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'q') ADVANCE(179);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 181:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'q') ADVANCE(178);
      END_STATE();
    case 182:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'q') ADVANCE(1928);
      END_STATE();
    case 183:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 184:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'r') ADVANCE(414);
      if (lookahead == 's') ADVANCE(98);
      END_STATE();
    case 185:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'r') ADVANCE(1120);
      END_STATE();
    case 186:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'r') ADVANCE(1098);
      END_STATE();
    case 187:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 188:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1599);
      END_STATE();
    case 189:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 190:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 191:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1997);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 192:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1312);
      END_STATE();
    case 193:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1207);
      END_STATE();
    case 194:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1870);
      END_STATE();
    case 195:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(811);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 196:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(865);
      END_STATE();
    case 197:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 's') ADVANCE(1932);
      END_STATE();
    case 198:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 199:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 200:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(1437);
      END_STATE();
    case 201:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 202:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(583);
      END_STATE();
    case 203:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(1207);
      END_STATE();
    case 204:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(681);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 205:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 206:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(1461);
      END_STATE();
    case 207:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 't') ADVANCE(1120);
      END_STATE();
    case 208:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 209:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'u') ADVANCE(1090);
      END_STATE();
    case 210:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 211:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'v') ADVANCE(2024);
      END_STATE();
    case 212:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'v') ADVANCE(572);
      END_STATE();
    case 213:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'v') ADVANCE(877);
      END_STATE();
    case 214:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(699);
      if (lookahead == 'i') ADVANCE(730);
      if (lookahead == 'o') ADVANCE(1752);
      if (lookahead == 'p') ADVANCE(1672);
      END_STATE();
    case 215:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(13);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'f') ADVANCE(1415);
      if (lookahead == 'm') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(699);
      END_STATE();
    case 216:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(13);
      if (lookahead == 's') ADVANCE(878);
      END_STATE();
    case 217:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'v') ADVANCE(13);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 's') ADVANCE(210);
      END_STATE();
    case 218:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'y') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1527);
      if (lookahead == 'c') ADVANCE(1917);
      if (lookahead == 'e') ADVANCE(105);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'n') ADVANCE(314);
      if (lookahead == 'p') ADVANCE(1522);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 219:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 220:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(13);
      END_STATE();
    case 221:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(13);
      END_STATE();
    case 222:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e' ||
          lookahead == 'g') ADVANCE(13);
      END_STATE();
    case 223:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e' ||
          lookahead == 'l') ADVANCE(13);
      END_STATE();
    case 224:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'f' ||
          lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 225:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd' ||
          lookahead == 'e') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(775);
      END_STATE();
    case 226:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 227:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1865);
      END_STATE();
    case 228:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'a' ||
          lookahead == 'j') ADVANCE(13);
      END_STATE();
    case 229:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'E' ||
          lookahead == 'd' ||
          lookahead == 'y') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(1629);
      if (lookahead == 'u') ADVANCE(1844);
      END_STATE();
    case 230:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'D' ||
          lookahead == 'U' ||
          lookahead == 'd' ||
          lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 231:
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'H' ||
          lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'h' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 232:
      if (lookahead == ';') ADVANCE(2034);
      END_STATE();
    case 233:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(234);
      END_STATE();
    case 234:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 235:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 236:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 237:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(236);
      END_STATE();
    case 238:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 239:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(232);
      END_STATE();
    case 240:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(239);
      END_STATE();
    case 241:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(240);
      END_STATE();
    case 242:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(241);
      END_STATE();
    case 243:
      if (lookahead == ';') ADVANCE(2034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(242);
      END_STATE();
    case 244:
      if (lookahead == '>') ADVANCE(2074);
      END_STATE();
    case 245:
      if (lookahead == '>') ADVANCE(2076);
      END_STATE();
    case 246:
      if (lookahead == 'A') ADVANCE(360);
      if (lookahead == 'a') ADVANCE(674);
      if (lookahead == 'c') ADVANCE(1138);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1227);
      if (lookahead == 'o') ADVANCE(1532);
      if (lookahead == 's') ADVANCE(648);
      if (lookahead == 'u') ADVANCE(1325);
      END_STATE();
    case 247:
      if (lookahead == 'A') ADVANCE(443);
      if (lookahead == 'B') ADVANCE(433);
      if (lookahead == 'H') ADVANCE(396);
      if (lookahead == 'a') ADVANCE(621);
      if (lookahead == 'b') ADVANCE(434);
      if (lookahead == 'c') ADVANCE(460);
      if (lookahead == 'd') ADVANCE(651);
      if (lookahead == 'e') ADVANCE(68);
      if (lookahead == 'f') ADVANCE(1110);
      if (lookahead == 'h') ADVANCE(479);
      if (lookahead == 'i') ADVANCE(1000);
      if (lookahead == 'l') ADVANCE(439);
      if (lookahead == 'm') ADVANCE(1510);
      if (lookahead == 'n') ADVANCE(1326);
      if (lookahead == 'o') ADVANCE(405);
      if (lookahead == 'p') ADVANCE(486);
      if (lookahead == 'r') ADVANCE(433);
      if (lookahead == 's') ADVANCE(385);
      if (lookahead == 't') ADVANCE(1066);
      if (lookahead == 'u') ADVANCE(1252);
      if (lookahead == 'x') ADVANCE(13);
      END_STATE();
    case 248:
      if (lookahead == 'A') ADVANCE(603);
      if (lookahead == 'I') ADVANCE(603);
      if (lookahead == 'U') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'c') ADVANCE(1140);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(1334);
      END_STATE();
    case 249:
      if (lookahead == 'A') ADVANCE(300);
      END_STATE();
    case 250:
      if (lookahead == 'A') ADVANCE(1424);
      if (lookahead == 'C') ADVANCE(937);
      if (lookahead == 'D') ADVANCE(1442);
      if (lookahead == 'F') ADVANCE(1251);
      if (lookahead == 'R') ADVANCE(1173);
      if (lookahead == 'T') ADVANCE(882);
      if (lookahead == 'U') ADVANCE(1540);
      if (lookahead == 'V') ADVANCE(916);
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'r') ADVANCE(1166);
      END_STATE();
    case 251:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'B') ADVANCE(489);
      if (lookahead == 'D') ADVANCE(429);
      if (lookahead == 'a') ADVANCE(1384);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(788);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(1865);
      if (lookahead == 'n') ADVANCE(1781);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(1668);
      if (lookahead == 'r') ADVANCE(1865);
      if (lookahead == 's') ADVANCE(650);
      if (lookahead == 'z') ADVANCE(1113);
      END_STATE();
    case 252:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'd') ADVANCE(1599);
      if (lookahead == 'e') ADVANCE(135);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 253:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'H') ADVANCE(396);
      if (lookahead == 'a') ADVANCE(983);
      if (lookahead == 'b') ADVANCE(1204);
      if (lookahead == 'c') ADVANCE(465);
      if (lookahead == 'd') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(137);
      if (lookahead == 'f') ADVANCE(1111);
      if (lookahead == 'h') ADVANCE(472);
      if (lookahead == 'i') ADVANCE(444);
      if (lookahead == 'j') ADVANCE(603);
      if (lookahead == 'l') ADVANCE(617);
      if (lookahead == 'o') ADVANCE(1255);
      if (lookahead == 'r') ADVANCE(579);
      if (lookahead == 's') ADVANCE(619);
      if (lookahead == 't') ADVANCE(729);
      if (lookahead == 'u') ADVANCE(438);
      if (lookahead == 'w') ADVANCE(447);
      if (lookahead == 'z') ADVANCE(608);
      END_STATE();
    case 254:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'H') ADVANCE(396);
      if (lookahead == 'a') ADVANCE(662);
      if (lookahead == 'b') ADVANCE(1621);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'd') ADVANCE(435);
      if (lookahead == 'f') ADVANCE(1111);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'h') ADVANCE(473);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 'm') ADVANCE(56);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(544);
      if (lookahead == 'r') ADVANCE(709);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 't') ADVANCE(726);
      if (lookahead == 'u') ADVANCE(440);
      if (lookahead == 'w') ADVANCE(447);
      END_STATE();
    case 255:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1126);
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 'c') ADVANCE(1138);
      if (lookahead == 'e') ADVANCE(526);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'k') ADVANCE(1753);
      if (lookahead == 'o') ADVANCE(441);
      if (lookahead == 's') ADVANCE(640);
      if (lookahead == 'y') ADVANCE(581);
      END_STATE();
    case 256:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1618);
      END_STATE();
    case 257:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'p') ADVANCE(396);
      END_STATE();
    case 258:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1611);
      if (lookahead == 'c') ADVANCE(198);
      if (lookahead == 'm') ADVANCE(1072);
      if (lookahead == 's') ADVANCE(1971);
      if (lookahead == 't') ADVANCE(1320);
      if (lookahead == 'x') ADVANCE(1807);
      END_STATE();
    case 259:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1611);
      if (lookahead == 'n') ADVANCE(1971);
      END_STATE();
    case 260:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1611);
      if (lookahead == 'n') ADVANCE(826);
      END_STATE();
    case 261:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'i') ADVANCE(1003);
      if (lookahead == 't') ADVANCE(1693);
      END_STATE();
    case 262:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 263:
      if (lookahead == 'A') ADVANCE(1618);
      if (lookahead == 't') ADVANCE(1688);
      END_STATE();
    case 264:
      if (lookahead == 'A') ADVANCE(1733);
      if (lookahead == 'D') ADVANCE(1501);
      if (lookahead == 'E') ADVANCE(1592);
      if (lookahead == 'T') ADVANCE(867);
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'd') ADVANCE(1508);
      if (lookahead == 'p') ADVANCE(876);
      if (lookahead == 's') ADVANCE(1089);
      END_STATE();
    case 265:
      if (lookahead == 'A') ADVANCE(667);
      END_STATE();
    case 266:
      if (lookahead == 'A') ADVANCE(667);
      if (lookahead == 'D') ADVANCE(1445);
      if (lookahead == 'G') ADVANCE(1651);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 267:
      if (lookahead == 'A') ADVANCE(1249);
      END_STATE();
    case 268:
      if (lookahead == 'A') ADVANCE(1425);
      if (lookahead == 'C') ADVANCE(937);
      if (lookahead == 'D') ADVANCE(1442);
      if (lookahead == 'F') ADVANCE(1251);
      if (lookahead == 'T') ADVANCE(882);
      if (lookahead == 'U') ADVANCE(1540);
      if (lookahead == 'V') ADVANCE(916);
      if (lookahead == 'a') ADVANCE(1730);
      END_STATE();
    case 269:
      if (lookahead == 'A') ADVANCE(1730);
      END_STATE();
    case 270:
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'D') ADVANCE(1501);
      END_STATE();
    case 271:
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'R') ADVANCE(1174);
      END_STATE();
    case 272:
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'R') ADVANCE(1174);
      if (lookahead == 'T') ADVANCE(852);
      END_STATE();
    case 273:
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'T') ADVANCE(852);
      END_STATE();
    case 274:
      if (lookahead == 'A') ADVANCE(1730);
      if (lookahead == 'V') ADVANCE(921);
      END_STATE();
    case 275:
      if (lookahead == 'A') ADVANCE(1734);
      if (lookahead == 'B') ADVANCE(1598);
      if (lookahead == 'L') ADVANCE(914);
      if (lookahead == 'R') ADVANCE(1172);
      if (lookahead == 'T') ADVANCE(867);
      if (lookahead == 'a') ADVANCE(1730);
      END_STATE();
    case 276:
      if (lookahead == 'B') ADVANCE(399);
      if (lookahead == 'P') ADVANCE(547);
      END_STATE();
    case 277:
      if (lookahead == 'B') ADVANCE(433);
      if (lookahead == 'E') ADVANCE(41);
      if (lookahead == 'a') ADVANCE(671);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == 'e') ADVANCE(213);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1437);
      if (lookahead == 'i') ADVANCE(981);
      if (lookahead == 'o') ADVANCE(1535);
      if (lookahead == 'r') ADVANCE(1166);
      if (lookahead == 's') ADVANCE(634);
      if (lookahead == 'u') ADVANCE(1242);
      END_STATE();
    case 278:
      if (lookahead == 'B') ADVANCE(396);
      END_STATE();
    case 279:
      if (lookahead == 'B') ADVANCE(396);
      if (lookahead == 'L') ADVANCE(1121);
      if (lookahead == 'S') ADVANCE(909);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 280:
      if (lookahead == 'B') ADVANCE(1731);
      END_STATE();
    case 281:
      if (lookahead == 'B') ADVANCE(1723);
      if (lookahead == 'n') ADVANCE(282);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(24);
      END_STATE();
    case 282:
      if (lookahead == 'B') ADVANCE(1728);
      END_STATE();
    case 283:
      if (lookahead == 'C') ADVANCE(333);
      if (lookahead == 'c') ADVANCE(1987);
      END_STATE();
    case 284:
      if (lookahead == 'C') ADVANCE(422);
      END_STATE();
    case 285:
      if (lookahead == 'C') ADVANCE(1502);
      if (lookahead == 'T') ADVANCE(1153);
      END_STATE();
    case 286:
      if (lookahead == 'C') ADVANCE(1179);
      END_STATE();
    case 287:
      if (lookahead == 'C') ADVANCE(1274);
      END_STATE();
    case 288:
      if (lookahead == 'C') ADVANCE(1936);
      END_STATE();
    case 289:
      if (lookahead == 'C') ADVANCE(1518);
      END_STATE();
    case 290:
      if (lookahead == 'C') ADVANCE(1518);
      if (lookahead == 'D') ADVANCE(1444);
      if (lookahead == 'L') ADVANCE(926);
      if (lookahead == 'R') ADVANCE(1176);
      if (lookahead == 'U') ADVANCE(1541);
      if (lookahead == 'V') ADVANCE(935);
      END_STATE();
    case 291:
      if (lookahead == 'D') ADVANCE(1447);
      END_STATE();
    case 292:
      if (lookahead == 'D') ADVANCE(1447);
      if (lookahead == 'M') ADVANCE(1164);
      if (lookahead == 'P') ADVANCE(1297);
      if (lookahead == 'T') ADVANCE(1153);
      END_STATE();
    case 293:
      if (lookahead == 'D') ADVANCE(1447);
      if (lookahead == 'a') ADVANCE(1618);
      END_STATE();
    case 294:
      if (lookahead == 'D') ADVANCE(1447);
      if (lookahead == 'o') ADVANCE(1807);
      END_STATE();
    case 295:
      if (lookahead == 'D') ADVANCE(1447);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 296:
      if (lookahead == 'D') ADVANCE(172);
      if (lookahead == 'J') ADVANCE(603);
      if (lookahead == 'S') ADVANCE(603);
      if (lookahead == 'Z') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(985);
      if (lookahead == 'c') ADVANCE(465);
      if (lookahead == 'e') ADVANCE(1208);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(408);
      if (lookahead == 'o') ADVANCE(1533);
      if (lookahead == 's') ADVANCE(648);
      END_STATE();
    case 297:
      if (lookahead == 'D') ADVANCE(13);
      END_STATE();
    case 298:
      if (lookahead == 'D') ADVANCE(294);
      if (lookahead == 'a') ADVANCE(665);
      if (lookahead == 'c') ADVANCE(463);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(295);
      if (lookahead == 'g') ADVANCE(184);
      if (lookahead == 'l') ADVANCE(151);
      if (lookahead == 'm') ADVANCE(395);
      if (lookahead == 'n') ADVANCE(970);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(476);
      if (lookahead == 'q') ADVANCE(658);
      if (lookahead == 'r') ADVANCE(293);
      if (lookahead == 's') ADVANCE(628);
      if (lookahead == 't') ADVANCE(219);
      if (lookahead == 'u') ADVANCE(1314);
      if (lookahead == 'x') ADVANCE(686);
      END_STATE();
    case 299:
      if (lookahead == 'D') ADVANCE(291);
      if (lookahead == 'a') ADVANCE(613);
      if (lookahead == 'c') ADVANCE(1503);
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(511);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1437);
      if (lookahead == 'i') ADVANCE(702);
      if (lookahead == 'l') ADVANCE(666);
      if (lookahead == 'n') ADVANCE(1557);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 's') ADVANCE(647);
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 300:
      if (lookahead == 'D') ADVANCE(313);
      END_STATE();
    case 301:
      if (lookahead == 'D') ADVANCE(2025);
      if (lookahead == 'H') ADVANCE(230);
      if (lookahead == 'U') ADVANCE(2025);
      if (lookahead == 'V') ADVANCE(231);
      if (lookahead == 'b') ADVANCE(1452);
      if (lookahead == 'd') ADVANCE(2025);
      if (lookahead == 'h') ADVANCE(230);
      if (lookahead == 'm') ADVANCE(1164);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 't') ADVANCE(1153);
      if (lookahead == 'u') ADVANCE(2025);
      if (lookahead == 'v') ADVANCE(231);
      END_STATE();
    case 302:
      if (lookahead == 'D') ADVANCE(603);
      END_STATE();
    case 303:
      if (lookahead == 'D') ADVANCE(429);
      if (lookahead == 'H') ADVANCE(433);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'g') ADVANCE(2015);
      if (lookahead == 'i') ADVANCE(1371);
      if (lookahead == 'l') ADVANCE(262);
      if (lookahead == 'r') ADVANCE(263);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 304:
      if (lookahead == 'D') ADVANCE(429);
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'd') ADVANCE(432);
      if (lookahead == 'e') ADVANCE(778);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'v') ADVANCE(746);
      END_STATE();
    case 305:
      if (lookahead == 'D') ADVANCE(429);
      if (lookahead == 'd') ADVANCE(429);
      END_STATE();
    case 306:
      if (lookahead == 'D') ADVANCE(1501);
      if (lookahead == 'L') ADVANCE(923);
      if (lookahead == 'R') ADVANCE(1174);
      if (lookahead == 'U') ADVANCE(1545);
      END_STATE();
    case 307:
      if (lookahead == 'D') ADVANCE(1103);
      END_STATE();
    case 308:
      if (lookahead == 'D') ADVANCE(869);
      END_STATE();
    case 309:
      if (lookahead == 'D') ADVANCE(1509);
      if (lookahead == 'E') ADVANCE(1589);
      END_STATE();
    case 310:
      if (lookahead == 'D') ADVANCE(1513);
      if (lookahead == 'T') ADVANCE(888);
      if (lookahead == 'V') ADVANCE(916);
      END_STATE();
    case 311:
      if (lookahead == 'D') ADVANCE(1523);
      if (lookahead == 'Q') ADVANCE(1947);
      END_STATE();
    case 312:
      if (lookahead == 'E') ADVANCE(1247);
      if (lookahead == 'M') ADVANCE(48);
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'b') ADVANCE(1598);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'l') ADVANCE(1528);
      if (lookahead == 'm') ADVANCE(391);
      if (lookahead == 'n') ADVANCE(730);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(1553);
      if (lookahead == 'r') ADVANCE(1094);
      if (lookahead == 's') ADVANCE(645);
      if (lookahead == 't') ADVANCE(1141);
      if (lookahead == 'u') ADVANCE(1313);
      END_STATE();
    case 313:
      if (lookahead == 'E') ADVANCE(13);
      END_STATE();
    case 314:
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 315:
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1544);
      if (lookahead == 'e') ADVANCE(181);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 316:
      if (lookahead == 'E') ADVANCE(13);
      if (lookahead == 'e') ADVANCE(180);
      if (lookahead == 's') ADVANCE(1104);
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 317:
      if (lookahead == 'E') ADVANCE(1220);
      if (lookahead == 'U') ADVANCE(1576);
      END_STATE();
    case 318:
      if (lookahead == 'E') ADVANCE(603);
      if (lookahead == 'J') ADVANCE(1253);
      if (lookahead == 'O') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'm') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(1835);
      if (lookahead == 'o') ADVANCE(988);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 't') ADVANCE(1167);
      if (lookahead == 'u') ADVANCE(1196);
      END_STATE();
    case 319:
      if (lookahead == 'E') ADVANCE(1219);
      END_STATE();
    case 320:
      if (lookahead == 'E') ADVANCE(1253);
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'd') ADVANCE(601);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'm') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(839);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(642);
      if (lookahead == 't') ADVANCE(1088);
      if (lookahead == 'u') ADVANCE(1313);
      if (lookahead == 'v') ADVANCE(854);
      END_STATE();
    case 321:
      if (lookahead == 'E') ADVANCE(1592);
      END_STATE();
    case 322:
      if (lookahead == 'E') ADVANCE(1589);
      END_STATE();
    case 323:
      if (lookahead == 'E') ADVANCE(1594);
      if (lookahead == 'F') ADVANCE(1946);
      if (lookahead == 'G') ADVANCE(1739);
      if (lookahead == 'L') ADVANCE(821);
      if (lookahead == 'S') ADVANCE(1307);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 324:
      if (lookahead == 'E') ADVANCE(1595);
      if (lookahead == 'F') ADVANCE(1946);
      if (lookahead == 'G') ADVANCE(1739);
      if (lookahead == 'L') ADVANCE(821);
      if (lookahead == 'S') ADVANCE(1307);
      if (lookahead == 'T') ADVANCE(1167);
      END_STATE();
    case 325:
      if (lookahead == 'F') ADVANCE(368);
      END_STATE();
    case 326:
      if (lookahead == 'F') ADVANCE(1940);
      END_STATE();
    case 327:
      if (lookahead == 'G') ADVANCE(13);
      END_STATE();
    case 328:
      if (lookahead == 'G') ADVANCE(971);
      if (lookahead == 'L') ADVANCE(902);
      if (lookahead == 'R') ADVANCE(1166);
      if (lookahead == 'V') ADVANCE(305);
      if (lookahead == 'a') ADVANCE(585);
      if (lookahead == 'b') ADVANCE(1754);
      if (lookahead == 'c') ADVANCE(416);
      if (lookahead == 'd') ADVANCE(429);
      if (lookahead == 'e') ADVANCE(15);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(316);
      if (lookahead == 'h') ADVANCE(257);
      if (lookahead == 'i') ADVANCE(189);
      if (lookahead == 'j') ADVANCE(603);
      if (lookahead == 'l') ADVANCE(252);
      if (lookahead == 'm') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(176);
      if (lookahead == 'p') ADVANCE(484);
      if (lookahead == 'r') ADVANCE(261);
      if (lookahead == 's') ADVANCE(620);
      if (lookahead == 't') ADVANCE(991);
      if (lookahead == 'u') ADVANCE(160);
      if (lookahead == 'v') ADVANCE(303);
      if (lookahead == 'w') ADVANCE(260);
      END_STATE();
    case 329:
      if (lookahead == 'G') ADVANCE(1739);
      END_STATE();
    case 330:
      if (lookahead == 'G') ADVANCE(1748);
      if (lookahead == 'L') ADVANCE(904);
      END_STATE();
    case 331:
      if (lookahead == 'H') ADVANCE(283);
      if (lookahead == 'O') ADVANCE(325);
      if (lookahead == 'a') ADVANCE(667);
      if (lookahead == 'c') ADVANCE(67);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1504);
      if (lookahead == 'i') ADVANCE(989);
      if (lookahead == 'm') ADVANCE(509);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'q') ADVANCE(1625);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 't') ADVANCE(396);
      if (lookahead == 'u') ADVANCE(569);
      END_STATE();
    case 332:
      if (lookahead == 'H') ADVANCE(353);
      if (lookahead == 'R') ADVANCE(249);
      if (lookahead == 'S') ADVANCE(337);
      if (lookahead == 'a') ADVANCE(2012);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(810);
      if (lookahead == 'i') ADVANCE(1236);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'r') ADVANCE(1146);
      if (lookahead == 's') ADVANCE(648);
      END_STATE();
    case 333:
      if (lookahead == 'H') ADVANCE(603);
      END_STATE();
    case 334:
      if (lookahead == 'H') ADVANCE(603);
      if (lookahead == 'J') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(1550);
      if (lookahead == 'c') ADVANCE(832);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 335:
      if (lookahead == 'H') ADVANCE(603);
      if (lookahead == 'O') ADVANCE(354);
      if (lookahead == 'a') ADVANCE(673);
      if (lookahead == 'c') ADVANCE(461);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(763);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1072);
      if (lookahead == 'i') ADVANCE(1646);
      if (lookahead == 'l') ADVANCE(1451);
      if (lookahead == 'o') ADVANCE(1291);
      if (lookahead == 'r') ADVANCE(1453);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(1536);
      END_STATE();
    case 336:
      if (lookahead == 'H') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(667);
      if (lookahead == 'c') ADVANCE(465);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(1656);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 337:
      if (lookahead == 'H') ADVANCE(603);
      if (lookahead == 'c') ADVANCE(1987);
      END_STATE();
    case 338:
      if (lookahead == 'H') ADVANCE(1948);
      END_STATE();
    case 339:
      if (lookahead == 'I') ADVANCE(13);
      END_STATE();
    case 340:
      if (lookahead == 'I') ADVANCE(1347);
      END_STATE();
    case 341:
      if (lookahead == 'I') ADVANCE(1414);
      END_STATE();
    case 342:
      if (lookahead == 'J') ADVANCE(603);
      if (lookahead == 'a') ADVANCE(667);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == 'e') ADVANCE(992);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(281);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 't') ADVANCE(1141);
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 343:
      if (lookahead == 'L') ADVANCE(821);
      END_STATE();
    case 344:
      if (lookahead == 'L') ADVANCE(1121);
      END_STATE();
    case 345:
      if (lookahead == 'L') ADVANCE(919);
      if (lookahead == 'R') ADVANCE(1174);
      END_STATE();
    case 346:
      if (lookahead == 'L') ADVANCE(919);
      if (lookahead == 'R') ADVANCE(1174);
      if (lookahead == 'l') ADVANCE(901);
      if (lookahead == 'r') ADVANCE(1166);
      END_STATE();
    case 347:
      if (lookahead == 'L') ADVANCE(923);
      if (lookahead == 'R') ADVANCE(1174);
      END_STATE();
    case 348:
      if (lookahead == 'M') ADVANCE(905);
      if (lookahead == 'T') ADVANCE(1054);
      if (lookahead == 'V') ADVANCE(893);
      END_STATE();
    case 349:
      if (lookahead == 'M') ADVANCE(1164);
      END_STATE();
    case 350:
      if (lookahead == 'N') ADVANCE(1447);
      if (lookahead == 'a') ADVANCE(657);
      if (lookahead == 'b') ADVANCE(1642);
      if (lookahead == 'c') ADVANCE(1468);
      if (lookahead == 'd') ADVANCE(1588);
      if (lookahead == 'e') ADVANCE(722);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(972);
      if (lookahead == 'k') ADVANCE(527);
      if (lookahead == 'l') ADVANCE(409);
      if (lookahead == 'n') ADVANCE(787);
      if (lookahead == 'o') ADVANCE(1534);
      if (lookahead == 'p') ADVANCE(1669);
      if (lookahead == 'r') ADVANCE(785);
      if (lookahead == 's') ADVANCE(629);
      if (lookahead == 'u') ADVANCE(1254);
      END_STATE();
    case 351:
      if (lookahead == 'N') ADVANCE(327);
      if (lookahead == 'T') ADVANCE(42);
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'c') ADVANCE(464);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'l') ADVANCE(906);
      if (lookahead == 'm') ADVANCE(394);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(1803);
      if (lookahead == 'q') ADVANCE(1900);
      if (lookahead == 's') ADVANCE(637);
      if (lookahead == 't') ADVANCE(382);
      if (lookahead == 'u') ADVANCE(1313);
      if (lookahead == 'x') ADVANCE(1097);
      END_STATE();
    case 352:
      if (lookahead == 'O') ADVANCE(50);
      END_STATE();
    case 353:
      if (lookahead == 'O') ADVANCE(359);
      END_STATE();
    case 354:
      if (lookahead == 'P') ADVANCE(52);
      END_STATE();
    case 355:
      if (lookahead == 'P') ADVANCE(396);
      END_STATE();
    case 356:
      if (lookahead == 'P') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 357:
      if (lookahead == 'P') ADVANCE(1297);
      END_STATE();
    case 358:
      if (lookahead == 'Q') ADVANCE(1947);
      END_STATE();
    case 359:
      if (lookahead == 'R') ADVANCE(47);
      END_STATE();
    case 360:
      if (lookahead == 'R') ADVANCE(302);
      END_STATE();
    case 361:
      if (lookahead == 'R') ADVANCE(1177);
      if (lookahead == 'T') ADVANCE(888);
      if (lookahead == 'V') ADVANCE(916);
      END_STATE();
    case 362:
      if (lookahead == 'S') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(664);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'd') ADVANCE(430);
      if (lookahead == 'e') ADVANCE(1253);
      if (lookahead == 'f') ADVANCE(700);
      if (lookahead == 'g') ADVANCE(1479);
      if (lookahead == 'h') ADVANCE(576);
      if (lookahead == 'i') ADVANCE(1366);
      if (lookahead == 'l') ADVANCE(436);
      if (lookahead == 'm') ADVANCE(392);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(397);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 's') ADVANCE(643);
      if (lookahead == 't') ADVANCE(1136);
      if (lookahead == 'u') ADVANCE(1313);
      if (lookahead == 'v') ADVANCE(574);
      END_STATE();
    case 363:
      if (lookahead == 'S') ADVANCE(1351);
      END_STATE();
    case 364:
      if (lookahead == 'S') ADVANCE(1351);
      if (lookahead == 'V') ADVANCE(891);
      END_STATE();
    case 365:
      if (lookahead == 'S') ADVANCE(1569);
      END_STATE();
    case 366:
      if (lookahead == 'S') ADVANCE(1910);
      END_STATE();
    case 367:
      if (lookahead == 'S') ADVANCE(1596);
      END_STATE();
    case 368:
      if (lookahead == 'T') ADVANCE(603);
      END_STATE();
    case 369:
      if (lookahead == 'T') ADVANCE(1068);
      END_STATE();
    case 370:
      if (lookahead == 'T') ADVANCE(1049);
      END_STATE();
    case 371:
      if (lookahead == 'T') ADVANCE(888);
      if (lookahead == 'V') ADVANCE(916);
      END_STATE();
    case 372:
      if (lookahead == 'T') ADVANCE(1750);
      END_STATE();
    case 373:
      if (lookahead == 'U') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 374:
      if (lookahead == 'V') ADVANCE(935);
      END_STATE();
    case 375:
      if (lookahead == 'V') ADVANCE(921);
      END_STATE();
    case 376:
      if (lookahead == 'W') ADVANCE(1123);
      END_STATE();
    case 377:
      if (lookahead == ']') ADVANCE(2078);
      END_STATE();
    case 378:
      if (lookahead == ']') ADVANCE(2079);
      END_STATE();
    case 379:
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'b') ADVANCE(1598);
      if (lookahead == 'c') ADVANCE(229);
      if (lookahead == 'e') ADVANCE(1247);
      if (lookahead == 'f') ADVANCE(183);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'l') ADVANCE(786);
      if (lookahead == 'm') ADVANCE(58);
      if (lookahead == 'n') ADVANCE(734);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(214);
      if (lookahead == 'r') ADVANCE(1094);
      if (lookahead == 's') ADVANCE(646);
      if (lookahead == 't') ADVANCE(1141);
      if (lookahead == 'u') ADVANCE(1313);
      if (lookahead == 'w') ADVANCE(682);
      END_STATE();
    case 380:
      if (lookahead == 'a') ADVANCE(661);
      if (lookahead == 'c') ADVANCE(145);
      if (lookahead == 'e') ADVANCE(610);
      if (lookahead == 'f') ADVANCE(2016);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'i') ADVANCE(143);
      if (lookahead == 'j') ADVANCE(1253);
      if (lookahead == 'm') ADVANCE(388);
      if (lookahead == 'n') ADVANCE(97);
      if (lookahead == 'o') ADVANCE(607);
      if (lookahead == 'p') ADVANCE(1659);
      if (lookahead == 'q') ADVANCE(1915);
      if (lookahead == 's') ADVANCE(639);
      if (lookahead == 't') ADVANCE(150);
      if (lookahead == 'u') ADVANCE(1196);
      END_STATE();
    case 381:
      if (lookahead == 'a') ADVANCE(653);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(688);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'r') ADVANCE(784);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(1324);
      END_STATE();
    case 382:
      if (lookahead == 'a') ADVANCE(13);
      END_STATE();
    case 383:
      if (lookahead == 'a') ADVANCE(183);
      END_STATE();
    case 384:
      if (lookahead == 'a') ADVANCE(1588);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(1318);
      if (lookahead == 'q') ADVANCE(568);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 385:
      if (lookahead == 'a') ADVANCE(1588);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'q') ADVANCE(568);
      END_STATE();
    case 386:
      if (lookahead == 'a') ADVANCE(672);
      if (lookahead == 'c') ADVANCE(411);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(756);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(605);
      if (lookahead == 'i') ADVANCE(1603);
      if (lookahead == 'l') ADVANCE(1905);
      if (lookahead == 'o') ADVANCE(1301);
      if (lookahead == 'r') ADVANCE(442);
      if (lookahead == 's') ADVANCE(649);
      if (lookahead == 't') ADVANCE(725);
      if (lookahead == 'u') ADVANCE(773);
      if (lookahead == 'w') ADVANCE(682);
      if (lookahead == 'y') ADVANCE(1244);
      END_STATE();
    case 387:
      if (lookahead == 'a') ADVANCE(1962);
      END_STATE();
    case 388:
      if (lookahead == 'a') ADVANCE(632);
      if (lookahead == 'o') ADVANCE(945);
      if (lookahead == 'p') ADVANCE(774);
      END_STATE();
    case 389:
      if (lookahead == 'a') ADVANCE(1261);
      if (lookahead == 'e') ADVANCE(1574);
      if (lookahead == 'i') ADVANCE(732);
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 390:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 391:
      if (lookahead == 'a') ADVANCE(627);
      END_STATE();
    case 392:
      if (lookahead == 'a') ADVANCE(627);
      if (lookahead == 'e') ADVANCE(980);
      if (lookahead == 'i') ADVANCE(694);
      END_STATE();
    case 393:
      if (lookahead == 'a') ADVANCE(627);
      if (lookahead == 'e') ADVANCE(980);
      if (lookahead == 'i') ADVANCE(693);
      END_STATE();
    case 394:
      if (lookahead == 'a') ADVANCE(627);
      if (lookahead == 'p') ADVANCE(1834);
      END_STATE();
    case 395:
      if (lookahead == 'a') ADVANCE(627);
      if (lookahead == 'p') ADVANCE(1843);
      if (lookahead == 's') ADVANCE(1539);
      END_STATE();
    case 396:
      if (lookahead == 'a') ADVANCE(1599);
      END_STATE();
    case 397:
      if (lookahead == 'a') ADVANCE(1599);
      if (lookahead == 'e') ADVANCE(1647);
      if (lookahead == 'l') ADVANCE(1914);
      END_STATE();
    case 398:
      if (lookahead == 'a') ADVANCE(1599);
      if (lookahead == 'f') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1914);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(1599);
      if (lookahead == 'r') ADVANCE(477);
      END_STATE();
    case 400:
      if (lookahead == 'a') ADVANCE(663);
      if (lookahead == 'b') ADVANCE(1621);
      if (lookahead == 'c') ADVANCE(1119);
      if (lookahead == 'd') ADVANCE(601);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1660);
      if (lookahead == 'm') ADVANCE(391);
      if (lookahead == 'n') ADVANCE(744);
      if (lookahead == 'o') ADVANCE(987);
      if (lookahead == 'p') ADVANCE(264);
      if (lookahead == 'r') ADVANCE(1109);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 't') ADVANCE(1167);
      if (lookahead == 'u') ADVANCE(1313);
      END_STATE();
    case 401:
      if (lookahead == 'a') ADVANCE(1366);
      END_STATE();
    case 402:
      if (lookahead == 'a') ADVANCE(210);
      END_STATE();
    case 403:
      if (lookahead == 'a') ADVANCE(1724);
      if (lookahead == 'b') ADVANCE(1653);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(1302);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(816);
      if (lookahead == 'i') ADVANCE(1290);
      if (lookahead == 'o') ADVANCE(808);
      if (lookahead == 'p') ADVANCE(1669);
      if (lookahead == 'r') ADVANCE(514);
      if (lookahead == 's') ADVANCE(618);
      if (lookahead == 'w') ADVANCE(1076);
      END_STATE();
    case 404:
      if (lookahead == 'a') ADVANCE(1375);
      if (lookahead == 'b') ADVANCE(1653);
      if (lookahead == 'n') ADVANCE(978);
      if (lookahead == 'o') ADVANCE(1575);
      if (lookahead == 'p') ADVANCE(398);
      if (lookahead == 't') ADVANCE(1153);
      if (lookahead == 'w') ADVANCE(446);
      if (lookahead == 'z') ADVANCE(125);
      END_STATE();
    case 405:
      if (lookahead == 'a') ADVANCE(1375);
      if (lookahead == 'b') ADVANCE(1653);
      if (lookahead == 'p') ADVANCE(398);
      if (lookahead == 't') ADVANCE(1153);
      END_STATE();
    case 406:
      if (lookahead == 'a') ADVANCE(1807);
      END_STATE();
    case 407:
      if (lookahead == 'a') ADVANCE(1807);
      if (lookahead == 'l') ADVANCE(1101);
      if (lookahead == 't') ADVANCE(1381);
      END_STATE();
    case 408:
      if (lookahead == 'a') ADVANCE(716);
      if (lookahead == 'f') ADVANCE(956);
      END_STATE();
    case 409:
      if (lookahead == 'a') ADVANCE(683);
      if (lookahead == 'k') ADVANCE(6);
      if (lookahead == 'o') ADVANCE(676);
      END_STATE();
    case 410:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 411:
      if (lookahead == 'a') ADVANCE(1551);
      if (lookahead == 'e') ADVANCE(755);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'u') ADVANCE(1559);
      END_STATE();
    case 412:
      if (lookahead == 'a') ADVANCE(767);
      END_STATE();
    case 413:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 414:
      if (lookahead == 'a') ADVANCE(1960);
      END_STATE();
    case 415:
      if (lookahead == 'a') ADVANCE(623);
      if (lookahead == 'o') ADVANCE(1975);
      END_STATE();
    case 416:
      if (lookahead == 'a') ADVANCE(1527);
      if (lookahead == 'e') ADVANCE(770);
      if (lookahead == 'o') ADVANCE(1388);
      if (lookahead == 'u') ADVANCE(1526);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 417:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 418:
      if (lookahead == 'a') ADVANCE(622);
      if (lookahead == 'c') ADVANCE(1140);
      if (lookahead == 'e') ADVANCE(162);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(603);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(609);
      END_STATE();
    case 419:
      if (lookahead == 'a') ADVANCE(1649);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1072);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1909);
      if (lookahead == 'o') ADVANCE(1137);
      if (lookahead == 'r') ADVANCE(118);
      if (lookahead == 's') ADVANCE(636);
      END_STATE();
    case 420:
      if (lookahead == 'a') ADVANCE(1550);
      END_STATE();
    case 421:
      if (lookahead == 'a') ADVANCE(1562);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(1583);
      if (lookahead == 'l') ADVANCE(821);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 422:
      if (lookahead == 'a') ADVANCE(1526);
      END_STATE();
    case 423:
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(751);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1405);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 424:
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'u') ADVANCE(1526);
      END_STATE();
    case 425:
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 426:
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'u') ADVANCE(1526);
      END_STATE();
    case 427:
      if (lookahead == 'a') ADVANCE(969);
      END_STATE();
    case 428:
      if (lookahead == 'a') ADVANCE(1309);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(1339);
      if (lookahead == 'f') ADVANCE(1134);
      if (lookahead == 'i') ADVANCE(1253);
      if (lookahead == 'j') ADVANCE(1253);
      if (lookahead == 'l') ADVANCE(407);
      if (lookahead == 'n') ADVANCE(1439);
      if (lookahead == 'o') ADVANCE(1530);
      if (lookahead == 'p') ADVANCE(517);
      if (lookahead == 'r') ADVANCE(415);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 429:
      if (lookahead == 'a') ADVANCE(1773);
      END_STATE();
    case 430:
      if (lookahead == 'a') ADVANCE(1773);
      if (lookahead == 'b') ADVANCE(1287);
      if (lookahead == 'i') ADVANCE(1957);
      if (lookahead == 'o') ADVANCE(1807);
      if (lookahead == 's') ADVANCE(1489);
      END_STATE();
    case 431:
      if (lookahead == 'a') ADVANCE(1188);
      END_STATE();
    case 432:
      if (lookahead == 'a') ADVANCE(1776);
      END_STATE();
    case 433:
      if (lookahead == 'a') ADVANCE(1618);
      END_STATE();
    case 434:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'b') ADVANCE(1653);
      if (lookahead == 'r') ADVANCE(467);
      END_STATE();
    case 435:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'b') ADVANCE(1287);
      if (lookahead == 'h') ADVANCE(396);
      END_STATE();
    case 436:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'c') ADVANCE(1083);
      if (lookahead == 'i') ADVANCE(1387);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 437:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'c') ADVANCE(1498);
      if (lookahead == 'h') ADVANCE(498);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 438:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'h') ADVANCE(396);
      END_STATE();
    case 439:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'h') ADVANCE(396);
      if (lookahead == 'm') ADVANCE(13);
      END_STATE();
    case 440:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 441:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'm') ADVANCE(1849);
      if (lookahead == 'o') ADVANCE(1191);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'r') ADVANCE(574);
      END_STATE();
    case 442:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'o') ADVANCE(1778);
      END_STATE();
    case 443:
      if (lookahead == 'a') ADVANCE(1618);
      if (lookahead == 'r') ADVANCE(1599);
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 444:
      if (lookahead == 'a') ADVANCE(1316);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'g') ADVANCE(510);
      if (lookahead == 's') ADVANCE(1116);
      if (lookahead == 'v') ADVANCE(144);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(1998);
      END_STATE();
    case 446:
      if (lookahead == 'a') ADVANCE(1763);
      if (lookahead == 'b') ADVANCE(396);
      END_STATE();
    case 447:
      if (lookahead == 'a') ADVANCE(1386);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(1846);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(1207);
      END_STATE();
    case 450:
      if (lookahead == 'a') ADVANCE(1605);
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(1606);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(1086);
      if (lookahead == 'i') ADVANCE(204);
      if (lookahead == 'l') ADVANCE(466);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(1147);
      if (lookahead == 'r') ADVANCE(29);
      if (lookahead == 's') ADVANCE(636);
      if (lookahead == 'u') ADVANCE(1385);
      END_STATE();
    case 451:
      if (lookahead == 'a') ADVANCE(1840);
      if (lookahead == 'e') ADVANCE(1787);
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 452:
      if (lookahead == 'a') ADVANCE(1031);
      END_STATE();
    case 453:
      if (lookahead == 'a') ADVANCE(1205);
      END_STATE();
    case 454:
      if (lookahead == 'a') ADVANCE(1230);
      if (lookahead == 'l') ADVANCE(1121);
      if (lookahead == 's') ADVANCE(1934);
      END_STATE();
    case 455:
      if (lookahead == 'a') ADVANCE(1653);
      END_STATE();
    case 456:
      if (lookahead == 'a') ADVANCE(1766);
      END_STATE();
    case 457:
      if (lookahead == 'a') ADVANCE(1353);
      END_STATE();
    case 458:
      if (lookahead == 'a') ADVANCE(611);
      END_STATE();
    case 459:
      if (lookahead == 'a') ADVANCE(1387);
      END_STATE();
    case 460:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'e') ADVANCE(771);
      if (lookahead == 'u') ADVANCE(567);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 461:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'e') ADVANCE(755);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'o') ADVANCE(1415);
      END_STATE();
    case 462:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'e') ADVANCE(770);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 463:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'i') ADVANCE(1629);
      if (lookahead == 'o') ADVANCE(1237);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 464:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'i') ADVANCE(1629);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 465:
      if (lookahead == 'a') ADVANCE(1652);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 466:
      if (lookahead == 'a') ADVANCE(1360);
      if (lookahead == 'u') ADVANCE(1757);
      END_STATE();
    case 467:
      if (lookahead == 'a') ADVANCE(625);
      if (lookahead == 'k') ADVANCE(779);
      END_STATE();
    case 468:
      if (lookahead == 'a') ADVANCE(1548);
      if (lookahead == 'u') ADVANCE(1548);
      END_STATE();
    case 469:
      if (lookahead == 'a') ADVANCE(736);
      END_STATE();
    case 470:
      if (lookahead == 'a') ADVANCE(1224);
      END_STATE();
    case 471:
      if (lookahead == 'a') ADVANCE(1224);
      if (lookahead == 'i') ADVANCE(1269);
      END_STATE();
    case 472:
      if (lookahead == 'a') ADVANCE(1608);
      END_STATE();
    case 473:
      if (lookahead == 'a') ADVANCE(1608);
      if (lookahead == 'b') ADVANCE(1238);
      END_STATE();
    case 474:
      if (lookahead == 'a') ADVANCE(1243);
      END_STATE();
    case 475:
      if (lookahead == 'a') ADVANCE(1243);
      if (lookahead == 'e') ADVANCE(1763);
      if (lookahead == 'i') ADVANCE(1959);
      END_STATE();
    case 476:
      if (lookahead == 'a') ADVANCE(1643);
      if (lookahead == 'l') ADVANCE(1914);
      if (lookahead == 's') ADVANCE(1079);
      END_STATE();
    case 477:
      if (lookahead == 'a') ADVANCE(626);
      END_STATE();
    case 478:
      if (lookahead == 'a') ADVANCE(1638);
      if (lookahead == 'b') ADVANCE(1238);
      END_STATE();
    case 479:
      if (lookahead == 'a') ADVANCE(1638);
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 480:
      if (lookahead == 'a') ADVANCE(1570);
      END_STATE();
    case 481:
      if (lookahead == 'a') ADVANCE(711);
      END_STATE();
    case 482:
      if (lookahead == 'a') ADVANCE(1636);
      END_STATE();
    case 483:
      if (lookahead == 'a') ADVANCE(1235);
      END_STATE();
    case 484:
      if (lookahead == 'a') ADVANCE(1628);
      if (lookahead == 'o') ADVANCE(1303);
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 485:
      if (lookahead == 'a') ADVANCE(1231);
      END_STATE();
    case 486:
      if (lookahead == 'a') ADVANCE(1623);
      if (lookahead == 'p') ADVANCE(1522);
      END_STATE();
    case 487:
      if (lookahead == 'a') ADVANCE(1609);
      if (lookahead == 'r') ADVANCE(558);
      END_STATE();
    case 488:
      if (lookahead == 'a') ADVANCE(1214);
      END_STATE();
    case 489:
      if (lookahead == 'a') ADVANCE(1622);
      END_STATE();
    case 490:
      if (lookahead == 'a') ADVANCE(1222);
      END_STATE();
    case 491:
      if (lookahead == 'a') ADVANCE(1209);
      END_STATE();
    case 492:
      if (lookahead == 'a') ADVANCE(1215);
      END_STATE();
    case 493:
      if (lookahead == 'a') ADVANCE(1210);
      END_STATE();
    case 494:
      if (lookahead == 'a') ADVANCE(1676);
      END_STATE();
    case 495:
      if (lookahead == 'a') ADVANCE(1228);
      END_STATE();
    case 496:
      if (lookahead == 'a') ADVANCE(1216);
      END_STATE();
    case 497:
      if (lookahead == 'a') ADVANCE(1597);
      END_STATE();
    case 498:
      if (lookahead == 'a') ADVANCE(1626);
      END_STATE();
    case 499:
      if (lookahead == 'a') ADVANCE(1602);
      END_STATE();
    case 500:
      if (lookahead == 'a') ADVANCE(1680);
      END_STATE();
    case 501:
      if (lookahead == 'a') ADVANCE(1624);
      END_STATE();
    case 502:
      if (lookahead == 'a') ADVANCE(1864);
      END_STATE();
    case 503:
      if (lookahead == 'a') ADVANCE(1691);
      END_STATE();
    case 504:
      if (lookahead == 'a') ADVANCE(1664);
      END_STATE();
    case 505:
      if (lookahead == 'a') ADVANCE(1655);
      END_STATE();
    case 506:
      if (lookahead == 'a') ADVANCE(1661);
      END_STATE();
    case 507:
      if (lookahead == 'a') ADVANCE(667);
      if (lookahead == 'b') ADVANCE(1588);
      if (lookahead == 'c') ADVANCE(218);
      if (lookahead == 'd') ADVANCE(1476);
      if (lookahead == 'e') ADVANCE(258);
      if (lookahead == 'f') ADVANCE(1619);
      if (lookahead == 'h') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(1008);
      if (lookahead == 'l') ADVANCE(433);
      if (lookahead == 'm') ADVANCE(389);
      if (lookahead == 'o') ADVANCE(953);
      if (lookahead == 'p') ADVANCE(412);
      if (lookahead == 'q') ADVANCE(655);
      if (lookahead == 'r') ADVANCE(433);
      if (lookahead == 's') ADVANCE(630);
      if (lookahead == 't') ADVANCE(487);
      if (lookahead == 'u') ADVANCE(570);
      if (lookahead == 'w') ADVANCE(259);
      if (lookahead == 'z') ADVANCE(1247);
      END_STATE();
    case 508:
      if (lookahead == 'a') ADVANCE(667);
      if (lookahead == 'c') ADVANCE(465);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(603);
      if (lookahead == 'i') ADVANCE(1002);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'w') ADVANCE(1187);
      END_STATE();
    case 509:
      if (lookahead == 'a') ADVANCE(1259);
      END_STATE();
    case 510:
      if (lookahead == 'a') ADVANCE(1328);
      END_STATE();
    case 511:
      if (lookahead == 'a') ADVANCE(1785);
      END_STATE();
    case 512:
      if (lookahead == 'a') ADVANCE(1554);
      if (lookahead == 'c') ADVANCE(832);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1663);
      if (lookahead == 'h') ADVANCE(603);
      if (lookahead == 'j') ADVANCE(603);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 513:
      if (lookahead == 'a') ADVANCE(705);
      END_STATE();
    case 514:
      if (lookahead == 'a') ADVANCE(752);
      if (lookahead == 'i') ADVANCE(559);
      if (lookahead == 'p') ADVANCE(814);
      END_STATE();
    case 515:
      if (lookahead == 'a') ADVANCE(1712);
      END_STATE();
    case 516:
      if (lookahead == 'a') ADVANCE(1861);
      END_STATE();
    case 517:
      if (lookahead == 'a') ADVANCE(1679);
      END_STATE();
    case 518:
      if (lookahead == 'a') ADVANCE(1561);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(1584);
      if (lookahead == 'g') ADVANCE(1827);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 519:
      if (lookahead == 'a') ADVANCE(1561);
      if (lookahead == 'e') ADVANCE(1587);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 520:
      if (lookahead == 'a') ADVANCE(1561);
      if (lookahead == 's') ADVANCE(1104);
      END_STATE();
    case 521:
      if (lookahead == 'a') ADVANCE(691);
      END_STATE();
    case 522:
      if (lookahead == 'a') ADVANCE(1713);
      if (lookahead == 'l') ADVANCE(1989);
      if (lookahead == 'r') ADVANCE(783);
      if (lookahead == 'v') ADVANCE(932);
      END_STATE();
    case 523:
      if (lookahead == 'a') ADVANCE(1398);
      END_STATE();
    case 524:
      if (lookahead == 'a') ADVANCE(1249);
      if (lookahead == 'k') ADVANCE(210);
      END_STATE();
    case 525:
      if (lookahead == 'a') ADVANCE(1871);
      END_STATE();
    case 526:
      if (lookahead == 'a') ADVANCE(1725);
      if (lookahead == 'l') ADVANCE(1264);
      if (lookahead == 'r') ADVANCE(675);
      END_STATE();
    case 527:
      if (lookahead == 'a') ADVANCE(1675);
      END_STATE();
    case 528:
      if (lookahead == 'a') ADVANCE(1112);
      END_STATE();
    case 529:
      if (lookahead == 'a') ADVANCE(1112);
      if (lookahead == 'i') ADVANCE(1449);
      END_STATE();
    case 530:
      if (lookahead == 'a') ADVANCE(1925);
      END_STATE();
    case 531:
      if (lookahead == 'a') ADVANCE(1271);
      END_STATE();
    case 532:
      if (lookahead == 'a') ADVANCE(1716);
      END_STATE();
    case 533:
      if (lookahead == 'a') ADVANCE(1927);
      END_STATE();
    case 534:
      if (lookahead == 'a') ADVANCE(1879);
      END_STATE();
    case 535:
      if (lookahead == 'a') ADVANCE(1399);
      END_STATE();
    case 536:
      if (lookahead == 'a') ADVANCE(1718);
      END_STATE();
    case 537:
      if (lookahead == 'a') ADVANCE(1256);
      END_STATE();
    case 538:
      if (lookahead == 'a') ADVANCE(1708);
      END_STATE();
    case 539:
      if (lookahead == 'a') ADVANCE(1667);
      END_STATE();
    case 540:
      if (lookahead == 'a') ADVANCE(1714);
      END_STATE();
    case 541:
      if (lookahead == 'a') ADVANCE(1715);
      END_STATE();
    case 542:
      if (lookahead == 'a') ADVANCE(1306);
      END_STATE();
    case 543:
      if (lookahead == 'a') ADVANCE(1730);
      END_STATE();
    case 544:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'd') ADVANCE(1508);
      if (lookahead == 'h') ADVANCE(500);
      if (lookahead == 'l') ADVANCE(1914);
      if (lookahead == 's') ADVANCE(1081);
      if (lookahead == 'u') ADVANCE(1580);
      END_STATE();
    case 545:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'd') ADVANCE(1524);
      if (lookahead == 'h') ADVANCE(500);
      END_STATE();
    case 546:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'r') ADVANCE(1166);
      END_STATE();
    case 547:
      if (lookahead == 'a') ADVANCE(1741);
      END_STATE();
    case 548:
      if (lookahead == 'a') ADVANCE(1887);
      END_STATE();
    case 549:
      if (lookahead == 'a') ADVANCE(1735);
      if (lookahead == 'h') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(924);
      if (lookahead == 'r') ADVANCE(1181);
      if (lookahead == 's') ADVANCE(1591);
      if (lookahead == 't') ADVANCE(1069);
      END_STATE();
    case 550:
      if (lookahead == 'a') ADVANCE(1735);
      if (lookahead == 'h') ADVANCE(560);
      if (lookahead == 'l') ADVANCE(944);
      if (lookahead == 'r') ADVANCE(1175);
      if (lookahead == 't') ADVANCE(1069);
      END_STATE();
    case 551:
      if (lookahead == 'a') ADVANCE(1889);
      END_STATE();
    case 552:
      if (lookahead == 'a') ADVANCE(1736);
      END_STATE();
    case 553:
      if (lookahead == 'a') ADVANCE(1736);
      if (lookahead == 'd') ADVANCE(2021);
      END_STATE();
    case 554:
      if (lookahead == 'a') ADVANCE(1737);
      END_STATE();
    case 555:
      if (lookahead == 'a') ADVANCE(1737);
      if (lookahead == 'h') ADVANCE(562);
      END_STATE();
    case 556:
      if (lookahead == 'a') ADVANCE(1891);
      END_STATE();
    case 557:
      if (lookahead == 'a') ADVANCE(1738);
      if (lookahead == 'h') ADVANCE(562);
      if (lookahead == 's') ADVANCE(1591);
      END_STATE();
    case 558:
      if (lookahead == 'a') ADVANCE(1171);
      if (lookahead == 'n') ADVANCE(1752);
      END_STATE();
    case 559:
      if (lookahead == 'a') ADVANCE(1420);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(1164);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 's') ADVANCE(567);
      if (lookahead == 't') ADVANCE(1149);
      END_STATE();
    case 560:
      if (lookahead == 'a') ADVANCE(1743);
      END_STATE();
    case 561:
      if (lookahead == 'a') ADVANCE(1427);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(1745);
      END_STATE();
    case 563:
      if (lookahead == 'a') ADVANCE(1428);
      END_STATE();
    case 564:
      if (lookahead == 'a') ADVANCE(1430);
      END_STATE();
    case 565:
      if (lookahead == 'a') ADVANCE(1431);
      END_STATE();
    case 566:
      if (lookahead == 'a') ADVANCE(1432);
      END_STATE();
    case 567:
      if (lookahead == 'b') ADVANCE(13);
      END_STATE();
    case 568:
      if (lookahead == 'b') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(1438);
      END_STATE();
    case 569:
      if (lookahead == 'b') ADVANCE(196);
      if (lookahead == 'c') ADVANCE(713);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(126);
      END_STATE();
    case 570:
      if (lookahead == 'b') ADVANCE(30);
      if (lookahead == 'c') ADVANCE(624);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 'p') ADVANCE(2026);
      END_STATE();
    case 571:
      if (lookahead == 'b') ADVANCE(216);
      if (lookahead == 'c') ADVANCE(680);
      if (lookahead == 'p') ADVANCE(216);
      END_STATE();
    case 572:
      if (lookahead == 'b') ADVANCE(100);
      END_STATE();
    case 573:
      if (lookahead == 'b') ADVANCE(108);
      if (lookahead == 'p') ADVANCE(108);
      END_STATE();
    case 574:
      if (lookahead == 'b') ADVANCE(396);
      END_STATE();
    case 575:
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 'g') ADVANCE(818);
      END_STATE();
    case 576:
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 'm') ADVANCE(13);
      END_STATE();
    case 577:
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 578:
      if (lookahead == 'b') ADVANCE(396);
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'y') ADVANCE(369);
      END_STATE();
    case 579:
      if (lookahead == 'b') ADVANCE(1203);
      if (lookahead == 'c') ADVANCE(1497);
      END_STATE();
    case 580:
      if (lookahead == 'b') ADVANCE(106);
      if (lookahead == 'p') ADVANCE(106);
      END_STATE();
    case 581:
      if (lookahead == 'b') ADVANCE(1943);
      if (lookahead == 'p') ADVANCE(1064);
      END_STATE();
    case 582:
      if (lookahead == 'b') ADVANCE(740);
      END_STATE();
    case 583:
      if (lookahead == 'b') ADVANCE(1653);
      END_STATE();
    case 584:
      if (lookahead == 'b') ADVANCE(775);
      if (lookahead == 'p') ADVANCE(775);
      END_STATE();
    case 585:
      if (lookahead == 'b') ADVANCE(1217);
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 'p') ADVANCE(33);
      if (lookahead == 't') ADVANCE(1933);
      END_STATE();
    case 586:
      if (lookahead == 'b') ADVANCE(1758);
      END_STATE();
    case 587:
      if (lookahead == 'b') ADVANCE(383);
      END_STATE();
    case 588:
      if (lookahead == 'b') ADVANCE(927);
      END_STATE();
    case 589:
      if (lookahead == 'b') ADVANCE(1361);
      if (lookahead == 'p') ADVANCE(1361);
      END_STATE();
    case 590:
      if (lookahead == 'b') ADVANCE(1802);
      if (lookahead == 'c') ADVANCE(712);
      if (lookahead == 'p') ADVANCE(879);
      END_STATE();
    case 591:
      if (lookahead == 'b') ADVANCE(1802);
      if (lookahead == 'p') ADVANCE(879);
      END_STATE();
    case 592:
      if (lookahead == 'b') ADVANCE(1273);
      END_STATE();
    case 593:
      if (lookahead == 'b') ADVANCE(1276);
      END_STATE();
    case 594:
      if (lookahead == 'b') ADVANCE(1719);
      END_STATE();
    case 595:
      if (lookahead == 'b') ADVANCE(1279);
      END_STATE();
    case 596:
      if (lookahead == 'b') ADVANCE(1280);
      END_STATE();
    case 597:
      if (lookahead == 'b') ADVANCE(1294);
      END_STATE();
    case 598:
      if (lookahead == 'b') ADVANCE(506);
      END_STATE();
    case 599:
      if (lookahead == 'b') ADVANCE(1285);
      END_STATE();
    case 600:
      if (lookahead == 'b') ADVANCE(1286);
      END_STATE();
    case 601:
      if (lookahead == 'b') ADVANCE(1287);
      END_STATE();
    case 602:
      if (lookahead == 'b') ADVANCE(1805);
      if (lookahead == 'p') ADVANCE(1805);
      END_STATE();
    case 603:
      if (lookahead == 'c') ADVANCE(1987);
      END_STATE();
    case 604:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(1962);
      END_STATE();
    case 605:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'e') ADVANCE(685);
      if (lookahead == 'i') ADVANCE(13);
      END_STATE();
    case 606:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1298);
      if (lookahead == 'o') ADVANCE(1531);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 607:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'g') ADVANCE(1478);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 608:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'i') ADVANCE(1002);
      END_STATE();
    case 609:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 610:
      if (lookahead == 'c') ADVANCE(1987);
      if (lookahead == 'x') ADVANCE(614);
      END_STATE();
    case 611:
      if (lookahead == 'c') ADVANCE(13);
      END_STATE();
    case 612:
      if (lookahead == 'c') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(1599);
      END_STATE();
    case 613:
      if (lookahead == 'c') ADVANCE(183);
      if (lookahead == 'l') ADVANCE(780);
      if (lookahead == 'p') ADVANCE(194);
      if (lookahead == 'r') ADVANCE(1200);
      END_STATE();
    case 614:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 615:
      if (lookahead == 'c') ADVANCE(424);
      if (lookahead == 'd') ADVANCE(1865);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(256);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(256);
      if (lookahead == 'm') ADVANCE(422);
      if (lookahead == 'n') ADVANCE(1108);
      if (lookahead == 'o') ADVANCE(727);
      if (lookahead == 'r') ADVANCE(256);
      if (lookahead == 's') ADVANCE(644);
      if (lookahead == 'u') ADVANCE(1558);
      if (lookahead == 'v') ADVANCE(852);
      if (lookahead == 'w') ADVANCE(815);
      END_STATE();
    case 616:
      if (lookahead == 'c') ADVANCE(424);
      if (lookahead == 'o') ADVANCE(728);
      if (lookahead == 's') ADVANCE(1593);
      if (lookahead == 't') ADVANCE(1749);
      if (lookahead == 'u') ADVANCE(1557);
      if (lookahead == 'v') ADVANCE(852);
      if (lookahead == 'w') ADVANCE(815);
      END_STATE();
    case 617:
      if (lookahead == 'c') ADVANCE(1497);
      END_STATE();
    case 618:
      if (lookahead == 'c') ADVANCE(2019);
      if (lookahead == 'h') ADVANCE(603);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 619:
      if (lookahead == 'c') ADVANCE(2019);
      if (lookahead == 'o') ADVANCE(1207);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 620:
      if (lookahead == 'c') ADVANCE(96);
      if (lookahead == 'h') ADVANCE(1515);
      if (lookahead == 'i') ADVANCE(1329);
      if (lookahead == 'm') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(396);
      if (lookahead == 'q') ADVANCE(1786);
      if (lookahead == 'u') ADVANCE(571);
      END_STATE();
    case 621:
      if (lookahead == 'c') ADVANCE(781);
      if (lookahead == 'd') ADVANCE(1118);
      if (lookahead == 'e') ADVANCE(1330);
      if (lookahead == 'n') ADVANCE(979);
      if (lookahead == 'q') ADVANCE(1903);
      if (lookahead == 'r') ADVANCE(1612);
      if (lookahead == 't') ADVANCE(529);
      END_STATE();
    case 622:
      if (lookahead == 'c') ADVANCE(1912);
      END_STATE();
    case 623:
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 's') ADVANCE(1207);
      END_STATE();
    case 624:
      if (lookahead == 'c') ADVANCE(75);
      END_STATE();
    case 625:
      if (lookahead == 'c') ADVANCE(2014);
      END_STATE();
    case 626:
      if (lookahead == 'c') ADVANCE(776);
      END_STATE();
    case 627:
      if (lookahead == 'c') ADVANCE(1599);
      END_STATE();
    case 628:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'i') ADVANCE(1312);
      END_STATE();
    case 629:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'e') ADVANCE(1321);
      if (lookahead == 'i') ADVANCE(1322);
      if (lookahead == 'o') ADVANCE(1211);
      END_STATE();
    case 630:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'e') ADVANCE(1855);
      if (lookahead == 'm') ADVANCE(1161);
      if (lookahead == 't') ADVANCE(499);
      END_STATE();
    case 631:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'e') ADVANCE(1632);
      END_STATE();
    case 632:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(777);
      if (lookahead == 't') ADVANCE(1032);
      END_STATE();
    case 633:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'g') ADVANCE(1131);
      END_STATE();
    case 634:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 635:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 636:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(13);
      END_STATE();
    case 637:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1312);
      END_STATE();
    case 638:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1317);
      END_STATE();
    case 639:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1359);
      END_STATE();
    case 640:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(429);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 641:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(969);
      END_STATE();
    case 642:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(456);
      END_STATE();
    case 643:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'l') ADVANCE(456);
      if (lookahead == 'o') ADVANCE(1207);
      END_STATE();
    case 644:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'q') ADVANCE(696);
      END_STATE();
    case 645:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(1114);
      END_STATE();
    case 646:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 't') ADVANCE(13);
      if (lookahead == 'y') ADVANCE(1337);
      END_STATE();
    case 647:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 't') ADVANCE(1567);
      END_STATE();
    case 648:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 't') ADVANCE(1670);
      END_STATE();
    case 649:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'u') ADVANCE(580);
      END_STATE();
    case 650:
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'u') ADVANCE(589);
      END_STATE();
    case 651:
      if (lookahead == 'c') ADVANCE(382);
      if (lookahead == 'l') ADVANCE(761);
      if (lookahead == 'q') ADVANCE(1923);
      if (lookahead == 's') ADVANCE(1032);
      END_STATE();
    case 652:
      if (lookahead == 'c') ADVANCE(382);
      if (lookahead == 'q') ADVANCE(1923);
      if (lookahead == 'r') ADVANCE(762);
      if (lookahead == 's') ADVANCE(1032);
      END_STATE();
    case 653:
      if (lookahead == 'c') ADVANCE(1199);
      if (lookahead == 'r') ADVANCE(1958);
      END_STATE();
    case 654:
      if (lookahead == 'c') ADVANCE(1366);
      if (lookahead == 'i') ADVANCE(1436);
      if (lookahead == 'm') ADVANCE(1112);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 't') ADVANCE(868);
      END_STATE();
    case 655:
      if (lookahead == 'c') ADVANCE(468);
      if (lookahead == 's') ADVANCE(1904);
      if (lookahead == 'u') ADVANCE(74);
      END_STATE();
    case 656:
      if (lookahead == 'c') ADVANCE(1807);
      END_STATE();
    case 657:
      if (lookahead == 'c') ADVANCE(1190);
      if (lookahead == 'r') ADVANCE(1961);
      END_STATE();
    case 658:
      if (lookahead == 'c') ADVANCE(1139);
      if (lookahead == 's') ADVANCE(1106);
      if (lookahead == 'u') ADVANCE(475);
      if (lookahead == 'v') ADVANCE(1574);
      END_STATE();
    case 659:
      if (lookahead == 'c') ADVANCE(1138);
      if (lookahead == 'e') ADVANCE(735);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(122);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 660:
      if (lookahead == 'c') ADVANCE(1138);
      if (lookahead == 'e') ADVANCE(764);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 661:
      if (lookahead == 'c') ADVANCE(1911);
      END_STATE();
    case 662:
      if (lookahead == 'c') ADVANCE(1911);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 663:
      if (lookahead == 'c') ADVANCE(1911);
      if (lookahead == 'r') ADVANCE(1635);
      END_STATE();
    case 664:
      if (lookahead == 'c') ADVANCE(1911);
      if (lookahead == 's') ADVANCE(1807);
      END_STATE();
    case 665:
      if (lookahead == 'c') ADVANCE(1911);
      if (lookahead == 's') ADVANCE(1861);
      END_STATE();
    case 666:
      if (lookahead == 'c') ADVANCE(1526);
      if (lookahead == 'd') ADVANCE(1599);
      END_STATE();
    case 667:
      if (lookahead == 'c') ADVANCE(1944);
      END_STATE();
    case 668:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'e') ADVANCE(1330);
      if (lookahead == 'g') ADVANCE(1717);
      if (lookahead == 'm') ADVANCE(582);
      if (lookahead == 'n') ADVANCE(977);
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 'q') ADVANCE(1903);
      if (lookahead == 'r') ADVANCE(1610);
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 669:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'm') ADVANCE(582);
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 'p') ADVANCE(1296);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 670:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'm') ADVANCE(1340);
      if (lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 671:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 'r') ADVANCE(1645);
      END_STATE();
    case 672:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'p') ADVANCE(69);
      if (lookahead == 'r') ADVANCE(812);
      END_STATE();
    case 673:
      if (lookahead == 'c') ADVANCE(1944);
      if (lookahead == 'p') ADVANCE(147);
      if (lookahead == 'y') ADVANCE(1257);
      END_STATE();
    case 674:
      if (lookahead == 'c') ADVANCE(838);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 675:
      if (lookahead == 'c') ADVANCE(1478);
      END_STATE();
    case 676:
      if (lookahead == 'c') ADVANCE(1188);
      END_STATE();
    case 677:
      if (lookahead == 'c') ADVANCE(1197);
      END_STATE();
    case 678:
      if (lookahead == 'c') ADVANCE(1197);
      if (lookahead == 's') ADVANCE(789);
      END_STATE();
    case 679:
      if (lookahead == 'c') ADVANCE(1189);
      if (lookahead == 'n') ADVANCE(365);
      END_STATE();
    case 680:
      if (lookahead == 'c') ADVANCE(115);
      END_STATE();
    case 681:
      if (lookahead == 'c') ADVANCE(1065);
      END_STATE();
    case 682:
      if (lookahead == 'c') ADVANCE(1458);
      if (lookahead == 'i') ADVANCE(1366);
      END_STATE();
    case 683:
      if (lookahead == 'c') ADVANCE(1192);
      if (lookahead == 'n') ADVANCE(1188);
      END_STATE();
    case 684:
      if (lookahead == 'c') ADVANCE(422);
      END_STATE();
    case 685:
      if (lookahead == 'c') ADVANCE(1193);
      END_STATE();
    case 686:
      if (lookahead == 'c') ADVANCE(1207);
      if (lookahead == 'i') ADVANCE(1763);
      if (lookahead == 'p') ADVANCE(907);
      END_STATE();
    case 687:
      if (lookahead == 'c') ADVANCE(1202);
      if (lookahead == 'n') ADVANCE(1772);
      END_STATE();
    case 688:
      if (lookahead == 'c') ADVANCE(530);
      if (lookahead == 'r') ADVANCE(1390);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 689:
      if (lookahead == 'c') ADVANCE(1194);
      if (lookahead == 'k') ADVANCE(1957);
      END_STATE();
    case 690:
      if (lookahead == 'c') ADVANCE(611);
      END_STATE();
    case 691:
      if (lookahead == 'c') ADVANCE(775);
      END_STATE();
    case 692:
      if (lookahead == 'c') ADVANCE(1046);
      END_STATE();
    case 693:
      if (lookahead == 'c') ADVANCE(1652);
      END_STATE();
    case 694:
      if (lookahead == 'c') ADVANCE(1652);
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(1914);
      END_STATE();
    case 695:
      if (lookahead == 'c') ADVANCE(1772);
      END_STATE();
    case 696:
      if (lookahead == 'c') ADVANCE(1907);
      END_STATE();
    case 697:
      if (lookahead == 'c') ADVANCE(1806);
      END_STATE();
    case 698:
      if (lookahead == 'c') ADVANCE(449);
      END_STATE();
    case 699:
      if (lookahead == 'c') ADVANCE(1082);
      END_STATE();
    case 700:
      if (lookahead == 'c') ADVANCE(1082);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 701:
      if (lookahead == 'c') ADVANCE(915);
      END_STATE();
    case 702:
      if (lookahead == 'c') ADVANCE(1641);
      if (lookahead == 'd') ADVANCE(65);
      if (lookahead == 'n') ADVANCE(1922);
      END_STATE();
    case 703:
      if (lookahead == 'c') ADVANCE(1893);
      END_STATE();
    case 704:
      if (lookahead == 'c') ADVANCE(1880);
      END_STATE();
    case 705:
      if (lookahead == 'c') ADVANCE(911);
      END_STATE();
    case 706:
      if (lookahead == 'c') ADVANCE(1864);
      END_STATE();
    case 707:
      if (lookahead == 'c') ADVANCE(1140);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'm') ADVANCE(448);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(631);
      if (lookahead == 'u') ADVANCE(1195);
      END_STATE();
    case 708:
      if (lookahead == 'c') ADVANCE(1140);
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(631);
      if (lookahead == 'u') ADVANCE(1195);
      END_STATE();
    case 709:
      if (lookahead == 'c') ADVANCE(1499);
      if (lookahead == 'i') ADVANCE(1374);
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 710:
      if (lookahead == 'c') ADVANCE(1499);
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 711:
      if (lookahead == 'c') ADVANCE(1201);
      END_STATE();
    case 712:
      if (lookahead == 'c') ADVANCE(881);
      END_STATE();
    case 713:
      if (lookahead == 'c') ADVANCE(881);
      if (lookahead == 'h') ADVANCE(370);
      END_STATE();
    case 714:
      if (lookahead == 'c') ADVANCE(488);
      END_STATE();
    case 715:
      if (lookahead == 'c') ADVANCE(1272);
      END_STATE();
    case 716:
      if (lookahead == 'c') ADVANCE(1696);
      if (lookahead == 'm') ADVANCE(1484);
      END_STATE();
    case 717:
      if (lookahead == 'c') ADVANCE(492);
      END_STATE();
    case 718:
      if (lookahead == 'c') ADVANCE(1879);
      END_STATE();
    case 719:
      if (lookahead == 'c') ADVANCE(1467);
      if (lookahead == 'e') ADVANCE(1525);
      if (lookahead == 'p') ADVANCE(1669);
      if (lookahead == 's') ADVANCE(1124);
      END_STATE();
    case 720:
      if (lookahead == 'c') ADVANCE(1256);
      END_STATE();
    case 721:
      if (lookahead == 'c') ADVANCE(495);
      END_STATE();
    case 722:
      if (lookahead == 'c') ADVANCE(533);
      if (lookahead == 'm') ADVANCE(1560);
      if (lookahead == 'p') ADVANCE(1767);
      if (lookahead == 'r') ADVANCE(1413);
      if (lookahead == 't') ADVANCE(2010);
      END_STATE();
    case 723:
      if (lookahead == 'c') ADVANCE(540);
      END_STATE();
    case 724:
      if (lookahead == 'c') ADVANCE(939);
      END_STATE();
    case 725:
      if (lookahead == 'd') ADVANCE(1447);
      END_STATE();
    case 726:
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'i') ADVANCE(1289);
      if (lookahead == 'r') ADVANCE(1078);
      END_STATE();
    case 727:
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'p') ADVANCE(946);
      if (lookahead == 't') ADVANCE(1149);
      END_STATE();
    case 728:
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 't') ADVANCE(1153);
      END_STATE();
    case 729:
      if (lookahead == 'd') ADVANCE(1447);
      if (lookahead == 'r') ADVANCE(1078);
      END_STATE();
    case 730:
      if (lookahead == 'd') ADVANCE(13);
      END_STATE();
    case 731:
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'f') ADVANCE(454);
      if (lookahead == 'p') ADVANCE(200);
      END_STATE();
    case 732:
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(775);
      END_STATE();
    case 733:
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 734:
      if (lookahead == 'd') ADVANCE(70);
      if (lookahead == 'g') ADVANCE(107);
      END_STATE();
    case 735:
      if (lookahead == 'd') ADVANCE(575);
      if (lookahead == 'i') ADVANCE(870);
      END_STATE();
    case 736:
      if (lookahead == 'd') ADVANCE(1293);
      END_STATE();
    case 737:
      if (lookahead == 'd') ADVANCE(364);
      END_STATE();
    case 738:
      if (lookahead == 'd') ADVANCE(340);
      END_STATE();
    case 739:
      if (lookahead == 'd') ADVANCE(330);
      END_STATE();
    case 740:
      if (lookahead == 'd') ADVANCE(382);
      END_STATE();
    case 741:
      if (lookahead == 'd') ADVANCE(603);
      if (lookahead == 'r') ADVANCE(94);
      END_STATE();
    case 742:
      if (lookahead == 'd') ADVANCE(139);
      END_STATE();
    case 743:
      if (lookahead == 'd') ADVANCE(55);
      END_STATE();
    case 744:
      if (lookahead == 'd') ADVANCE(854);
      if (lookahead == 'i') ADVANCE(1482);
      END_STATE();
    case 745:
      if (lookahead == 'd') ADVANCE(106);
      END_STATE();
    case 746:
      if (lookahead == 'd') ADVANCE(429);
      END_STATE();
    case 747:
      if (lookahead == 'd') ADVANCE(447);
      END_STATE();
    case 748:
      if (lookahead == 'd') ADVANCE(197);
      END_STATE();
    case 749:
      if (lookahead == 'd') ADVANCE(119);
      END_STATE();
    case 750:
      if (lookahead == 'd') ADVANCE(1115);
      END_STATE();
    case 751:
      if (lookahead == 'd') ADVANCE(1115);
      if (lookahead == 'l') ADVANCE(1305);
      END_STATE();
    case 752:
      if (lookahead == 'd') ADVANCE(775);
      END_STATE();
    case 753:
      if (lookahead == 'd') ADVANCE(1919);
      END_STATE();
    case 754:
      if (lookahead == 'd') ADVANCE(1919);
      if (lookahead == 'p') ADVANCE(1521);
      END_STATE();
    case 755:
      if (lookahead == 'd') ADVANCE(1073);
      END_STATE();
    case 756:
      if (lookahead == 'd') ADVANCE(1073);
      if (lookahead == 'm') ADVANCE(1560);
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 757:
      if (lookahead == 'd') ADVANCE(1798);
      if (lookahead == 'u') ADVANCE(1042);
      END_STATE();
    case 758:
      if (lookahead == 'd') ADVANCE(790);
      END_STATE();
    case 759:
      if (lookahead == 'd') ADVANCE(1761);
      END_STATE();
    case 760:
      if (lookahead == 'd') ADVANCE(1854);
      END_STATE();
    case 761:
      if (lookahead == 'd') ADVANCE(1042);
      END_STATE();
    case 762:
      if (lookahead == 'd') ADVANCE(1042);
      if (lookahead == 'u') ADVANCE(1798);
      END_STATE();
    case 763:
      if (lookahead == 'd') ADVANCE(1148);
      if (lookahead == 'n') ADVANCE(1883);
      END_STATE();
    case 764:
      if (lookahead == 'd') ADVANCE(994);
      END_STATE();
    case 765:
      if (lookahead == 'd') ADVANCE(1440);
      if (lookahead == 'u') ADVANCE(1526);
      END_STATE();
    case 766:
      if (lookahead == 'd') ADVANCE(859);
      if (lookahead == 'p') ADVANCE(945);
      END_STATE();
    case 767:
      if (lookahead == 'd') ADVANCE(855);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 768:
      if (lookahead == 'd') ADVANCE(872);
      END_STATE();
    case 769:
      if (lookahead == 'd') ADVANCE(1463);
      END_STATE();
    case 770:
      if (lookahead == 'd') ADVANCE(1112);
      END_STATE();
    case 771:
      if (lookahead == 'd') ADVANCE(1112);
      if (lookahead == 'i') ADVANCE(1207);
      END_STATE();
    case 772:
      if (lookahead == 'd') ADVANCE(874);
      END_STATE();
    case 773:
      if (lookahead == 'd') ADVANCE(494);
      if (lookahead == 'e') ADVANCE(1542);
      if (lookahead == 'l') ADVANCE(515);
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 'r') ADVANCE(522);
      if (lookahead == 'v') ADVANCE(852);
      if (lookahead == 'w') ADVANCE(774);
      END_STATE();
    case 774:
      if (lookahead == 'e') ADVANCE(730);
      END_STATE();
    case 775:
      if (lookahead == 'e') ADVANCE(13);
      END_STATE();
    case 776:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'k') ADVANCE(811);
      END_STATE();
    case 777:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1121);
      if (lookahead == 'p') ADVANCE(501);
      END_STATE();
    case 778:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(578);
      END_STATE();
    case 779:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 's') ADVANCE(1213);
      END_STATE();
    case 780:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 781:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(1856);
      END_STATE();
    case 782:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 783:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 784:
      if (lookahead == 'e') ADVANCE(1962);
      END_STATE();
    case 785:
      if (lookahead == 'e') ADVANCE(1962);
      if (lookahead == 'v') ADVANCE(587);
      END_STATE();
    case 786:
      if (lookahead == 'e') ADVANCE(954);
      if (lookahead == 'p') ADVANCE(1035);
      END_STATE();
    case 787:
      if (lookahead == 'e') ADVANCE(182);
      if (lookahead == 'o') ADVANCE(1807);
      END_STATE();
    case 788:
      if (lookahead == 'e') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(1264);
      if (lookahead == 'r') ADVANCE(577);
      END_STATE();
    case 789:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 790:
      if (lookahead == 'e') ADVANCE(37);
      END_STATE();
    case 791:
      if (lookahead == 'e') ADVANCE(16);
      END_STATE();
    case 792:
      if (lookahead == 'e') ADVANCE(10);
      END_STATE();
    case 793:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 794:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 795:
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 796:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 797:
      if (lookahead == 'e') ADVANCE(1343);
      END_STATE();
    case 798:
      if (lookahead == 'e') ADVANCE(17);
      END_STATE();
    case 799:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 800:
      if (lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 801:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 802:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 803:
      if (lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 804:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 805:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 806:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 807:
      if (lookahead == 'e') ADVANCE(1599);
      END_STATE();
    case 808:
      if (lookahead == 'e') ADVANCE(382);
      if (lookahead == 'p') ADVANCE(78);
      if (lookahead == 's') ADVANCE(382);
      END_STATE();
    case 809:
      if (lookahead == 'e') ADVANCE(1366);
      END_STATE();
    case 810:
      if (lookahead == 'e') ADVANCE(1685);
      if (lookahead == 'i') ADVANCE(679);
      END_STATE();
    case 811:
      if (lookahead == 'e') ADVANCE(1807);
      END_STATE();
    case 812:
      if (lookahead == 'e') ADVANCE(1807);
      if (lookahead == 'o') ADVANCE(1353);
      END_STATE();
    case 813:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 814:
      if (lookahead == 'e') ADVANCE(2003);
      END_STATE();
    case 815:
      if (lookahead == 'e') ADVANCE(764);
      END_STATE();
    case 816:
      if (lookahead == 'e') ADVANCE(1701);
      if (lookahead == 'i') ADVANCE(687);
      if (lookahead == 'k') ADVANCE(425);
      if (lookahead == 'o') ADVANCE(1601);
      END_STATE();
    case 817:
      if (lookahead == 'e') ADVANCE(955);
      END_STATE();
    case 818:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 819:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 820:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 821:
      if (lookahead == 'e') ADVANCE(1778);
      END_STATE();
    case 822:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 823:
      if (lookahead == 'e') ADVANCE(1581);
      END_STATE();
    case 824:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 825:
      if (lookahead == 'e') ADVANCE(765);
      END_STATE();
    case 826:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 827:
      if (lookahead == 'e') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(1312);
      END_STATE();
    case 828:
      if (lookahead == 'e') ADVANCE(959);
      END_STATE();
    case 829:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 830:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 831:
      if (lookahead == 'e') ADVANCE(770);
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 832:
      if (lookahead == 'e') ADVANCE(770);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 833:
      if (lookahead == 'e') ADVANCE(1999);
      END_STATE();
    case 834:
      if (lookahead == 'e') ADVANCE(1585);
      if (lookahead == 'v') ADVANCE(852);
      if (lookahead == 'w') ADVANCE(815);
      END_STATE();
    case 835:
      if (lookahead == 'e') ADVANCE(950);
      END_STATE();
    case 836:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 837:
      if (lookahead == 'e') ADVANCE(1587);
      END_STATE();
    case 838:
      if (lookahead == 'e') ADVANCE(1188);
      END_STATE();
    case 839:
      if (lookahead == 'e') ADVANCE(1356);
      END_STATE();
    case 840:
      if (lookahead == 'e') ADVANCE(1586);
      END_STATE();
    case 841:
      if (lookahead == 'e') ADVANCE(1828);
      END_STATE();
    case 842:
      if (lookahead == 'e') ADVANCE(1752);
      END_STATE();
    case 843:
      if (lookahead == 'e') ADVANCE(1763);
      END_STATE();
    case 844:
      if (lookahead == 'e') ADVANCE(1846);
      END_STATE();
    case 845:
      if (lookahead == 'e') ADVANCE(1207);
      END_STATE();
    case 846:
      if (lookahead == 'e') ADVANCE(737);
      END_STATE();
    case 847:
      if (lookahead == 'e') ADVANCE(548);
      END_STATE();
    case 848:
      if (lookahead == 'e') ADVANCE(739);
      END_STATE();
    case 849:
      if (lookahead == 'e') ADVANCE(1353);
      END_STATE();
    case 850:
      if (lookahead == 'e') ADVANCE(611);
      END_STATE();
    case 851:
      if (lookahead == 'e') ADVANCE(742);
      END_STATE();
    case 852:
      if (lookahead == 'e') ADVANCE(775);
      END_STATE();
    case 853:
      if (lookahead == 'e') ADVANCE(759);
      END_STATE();
    case 854:
      if (lookahead == 'e') ADVANCE(1607);
      END_STATE();
    case 855:
      if (lookahead == 'e') ADVANCE(1758);
      END_STATE();
    case 856:
      if (lookahead == 'e') ADVANCE(1525);
      if (lookahead == 'k') ADVANCE(420);
      if (lookahead == 'n') ADVANCE(1493);
      if (lookahead == 'p') ADVANCE(1041);
      if (lookahead == 'r') ADVANCE(142);
      if (lookahead == 's') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(1058);
      END_STATE();
    case 857:
      if (lookahead == 'e') ADVANCE(1525);
      if (lookahead == 'p') ADVANCE(1040);
      END_STATE();
    case 858:
      if (lookahead == 'e') ADVANCE(1769);
      END_STATE();
    case 859:
      if (lookahead == 'e') ADVANCE(1243);
      END_STATE();
    case 860:
      if (lookahead == 'e') ADVANCE(718);
      END_STATE();
    case 861:
      if (lookahead == 'e') ADVANCE(1407);
      END_STATE();
    case 862:
      if (lookahead == 'e') ADVANCE(1800);
      END_STATE();
    case 863:
      if (lookahead == 'e') ADVANCE(1852);
      END_STATE();
    case 864:
      if (lookahead == 'e') ADVANCE(1771);
      END_STATE();
    case 865:
      if (lookahead == 'e') ADVANCE(1830);
      END_STATE();
    case 866:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 867:
      if (lookahead == 'e') ADVANCE(791);
      END_STATE();
    case 868:
      if (lookahead == 'e') ADVANCE(1379);
      END_STATE();
    case 869:
      if (lookahead == 'e') ADVANCE(1270);
      END_STATE();
    case 870:
      if (lookahead == 'e') ADVANCE(1647);
      END_STATE();
    case 871:
      if (lookahead == 'e') ADVANCE(469);
      END_STATE();
    case 872:
      if (lookahead == 'e') ADVANCE(1761);
      END_STATE();
    case 873:
      if (lookahead == 'e') ADVANCE(453);
      END_STATE();
    case 874:
      if (lookahead == 'e') ADVANCE(1762);
      END_STATE();
    case 875:
      if (lookahead == 'e') ADVANCE(1817);
      if (lookahead == 'i') ADVANCE(1312);
      if (lookahead == 'u') ADVANCE(2011);
      END_STATE();
    case 876:
      if (lookahead == 'e') ADVANCE(1613);
      END_STATE();
    case 877:
      if (lookahead == 'e') ADVANCE(1720);
      END_STATE();
    case 878:
      if (lookahead == 'e') ADVANCE(1853);
      END_STATE();
    case 879:
      if (lookahead == 'e') ADVANCE(1684);
      END_STATE();
    case 880:
      if (lookahead == 'e') ADVANCE(1860);
      END_STATE();
    case 881:
      if (lookahead == 'e') ADVANCE(853);
      END_STATE();
    case 882:
      if (lookahead == 'e') ADVANCE(798);
      if (lookahead == 'r') ADVANCE(1184);
      END_STATE();
    case 883:
      if (lookahead == 'e') ADVANCE(1600);
      END_STATE();
    case 884:
      if (lookahead == 'e') ADVANCE(1694);
      if (lookahead == 'i') ADVANCE(1366);
      END_STATE();
    case 885:
      if (lookahead == 'e') ADVANCE(1644);
      END_STATE();
    case 886:
      if (lookahead == 'e') ADVANCE(1722);
      END_STATE();
    case 887:
      if (lookahead == 'e') ADVANCE(1742);
      END_STATE();
    case 888:
      if (lookahead == 'e') ADVANCE(803);
      END_STATE();
    case 889:
      if (lookahead == 'e') ADVANCE(1657);
      END_STATE();
    case 890:
      if (lookahead == 'e') ADVANCE(929);
      END_STATE();
    case 891:
      if (lookahead == 'e') ADVANCE(1654);
      END_STATE();
    case 892:
      if (lookahead == 'e') ADVANCE(1617);
      END_STATE();
    case 893:
      if (lookahead == 'e') ADVANCE(1662);
      END_STATE();
    case 894:
      if (lookahead == 'e') ADVANCE(1620);
      END_STATE();
    case 895:
      if (lookahead == 'e') ADVANCE(960);
      END_STATE();
    case 896:
      if (lookahead == 'e') ADVANCE(1964);
      if (lookahead == 'i') ADVANCE(1007);
      END_STATE();
    case 897:
      if (lookahead == 'e') ADVANCE(1277);
      END_STATE();
    case 898:
      if (lookahead == 'e') ADVANCE(374);
      END_STATE();
    case 899:
      if (lookahead == 'e') ADVANCE(747);
      END_STATE();
    case 900:
      if (lookahead == 'e') ADVANCE(527);
      if (lookahead == 'w') ADVANCE(527);
      END_STATE();
    case 901:
      if (lookahead == 'e') ADVANCE(957);
      END_STATE();
    case 902:
      if (lookahead == 'e') ADVANCE(957);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 903:
      if (lookahead == 'e') ADVANCE(849);
      END_STATE();
    case 904:
      if (lookahead == 'e') ADVANCE(1789);
      END_STATE();
    case 905:
      if (lookahead == 'e') ADVANCE(750);
      END_STATE();
    case 906:
      if (lookahead == 'e') ADVANCE(1342);
      END_STATE();
    case 907:
      if (lookahead == 'e') ADVANCE(703);
      if (lookahead == 'o') ADVANCE(1423);
      END_STATE();
    case 908:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 909:
      if (lookahead == 'e') ADVANCE(1578);
      END_STATE();
    case 910:
      if (lookahead == 'e') ADVANCE(1682);
      END_STATE();
    case 911:
      if (lookahead == 'e') ADVANCE(1875);
      END_STATE();
    case 912:
      if (lookahead == 'e') ADVANCE(1875);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 913:
      if (lookahead == 'e') ADVANCE(598);
      END_STATE();
    case 914:
      if (lookahead == 'e') ADVANCE(961);
      END_STATE();
    case 915:
      if (lookahead == 'e') ADVANCE(768);
      END_STATE();
    case 916:
      if (lookahead == 'e') ADVANCE(704);
      END_STATE();
    case 917:
      if (lookahead == 'e') ADVANCE(1779);
      END_STATE();
    case 918:
      if (lookahead == 'e') ADVANCE(1565);
      END_STATE();
    case 919:
      if (lookahead == 'e') ADVANCE(962);
      END_STATE();
    case 920:
      if (lookahead == 'e') ADVANCE(1681);
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 921:
      if (lookahead == 'e') ADVANCE(706);
      END_STATE();
    case 922:
      if (lookahead == 'e') ADVANCE(1433);
      END_STATE();
    case 923:
      if (lookahead == 'e') ADVANCE(963);
      END_STATE();
    case 924:
      if (lookahead == 'e') ADVANCE(964);
      END_STATE();
    case 925:
      if (lookahead == 'e') ADVANCE(1416);
      END_STATE();
    case 926:
      if (lookahead == 'e') ADVANCE(965);
      if (lookahead == 'o') ADVANCE(1393);
      END_STATE();
    case 927:
      if (lookahead == 'e') ADVANCE(1700);
      END_STATE();
    case 928:
      if (lookahead == 'e') ADVANCE(958);
      END_STATE();
    case 929:
      if (lookahead == 'e') ADVANCE(1894);
      END_STATE();
    case 930:
      if (lookahead == 'e') ADVANCE(1747);
      END_STATE();
    case 931:
      if (lookahead == 'e') ADVANCE(1401);
      END_STATE();
    case 932:
      if (lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 933:
      if (lookahead == 'e') ADVANCE(1311);
      END_STATE();
    case 934:
      if (lookahead == 'e') ADVANCE(1009);
      END_STATE();
    case 935:
      if (lookahead == 'e') ADVANCE(1744);
      END_STATE();
    case 936:
      if (lookahead == 'e') ADVANCE(1881);
      END_STATE();
    case 937:
      if (lookahead == 'e') ADVANCE(1160);
      END_STATE();
    case 938:
      if (lookahead == 'e') ADVANCE(1727);
      END_STATE();
    case 939:
      if (lookahead == 'e') ADVANCE(772);
      END_STATE();
    case 940:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 941:
      if (lookahead == 'e') ADVANCE(1376);
      END_STATE();
    case 942:
      if (lookahead == 'e') ADVANCE(556);
      END_STATE();
    case 943:
      if (lookahead == 'e') ADVANCE(724);
      END_STATE();
    case 944:
      if (lookahead == 'e') ADVANCE(968);
      END_STATE();
    case 945:
      if (lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 946:
      if (lookahead == 'f') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(1914);
      END_STATE();
    case 947:
      if (lookahead == 'f') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(1473);
      END_STATE();
    case 948:
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 's') ADVANCE(627);
      END_STATE();
    case 949:
      if (lookahead == 'f') ADVANCE(1599);
      if (lookahead == 'i') ADVANCE(1366);
      if (lookahead == 'o') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(1669);
      if (lookahead == 's') ADVANCE(627);
      if (lookahead == 'u') ADVANCE(451);
      END_STATE();
    case 950:
      if (lookahead == 'f') ADVANCE(1807);
      END_STATE();
    case 951:
      if (lookahead == 'f') ADVANCE(956);
      END_STATE();
    case 952:
      if (lookahead == 'f') ADVANCE(1810);
      if (lookahead == 's') ADVANCE(1755);
      END_STATE();
    case 953:
      if (lookahead == 'f') ADVANCE(1833);
      if (lookahead == 'l') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(945);
      END_STATE();
    case 954:
      if (lookahead == 'f') ADVANCE(1774);
      if (lookahead == 'p') ADVANCE(1032);
      END_STATE();
    case 955:
      if (lookahead == 'f') ADVANCE(1898);
      END_STATE();
    case 956:
      if (lookahead == 'f') ADVANCE(930);
      END_STATE();
    case 957:
      if (lookahead == 'f') ADVANCE(1838);
      END_STATE();
    case 958:
      if (lookahead == 'f') ADVANCE(1852);
      END_STATE();
    case 959:
      if (lookahead == 'f') ADVANCE(1517);
      END_STATE();
    case 960:
      if (lookahead == 'f') ADVANCE(1841);
      if (lookahead == 's') ADVANCE(1760);
      END_STATE();
    case 961:
      if (lookahead == 'f') ADVANCE(1819);
      END_STATE();
    case 962:
      if (lookahead == 'f') ADVANCE(1821);
      END_STATE();
    case 963:
      if (lookahead == 'f') ADVANCE(1837);
      END_STATE();
    case 964:
      if (lookahead == 'f') ADVANCE(1877);
      END_STATE();
    case 965:
      if (lookahead == 'f') ADVANCE(1825);
      END_STATE();
    case 966:
      if (lookahead == 'f') ADVANCE(1477);
      END_STATE();
    case 967:
      if (lookahead == 'f') ADVANCE(1116);
      END_STATE();
    case 968:
      if (lookahead == 'f') ADVANCE(1897);
      END_STATE();
    case 969:
      if (lookahead == 'g') ADVANCE(13);
      END_STATE();
    case 970:
      if (lookahead == 'g') ADVANCE(13);
      if (lookahead == 's') ADVANCE(1526);
      END_STATE();
    case 971:
      if (lookahead == 'g') ADVANCE(13);
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 972:
      if (lookahead == 'g') ADVANCE(616);
      END_STATE();
    case 973:
      if (lookahead == 'g') ADVANCE(98);
      END_STATE();
    case 974:
      if (lookahead == 'g') ADVANCE(98);
      if (lookahead == 'i') ADVANCE(1366);
      END_STATE();
    case 975:
      if (lookahead == 'g') ADVANCE(346);
      END_STATE();
    case 976:
      if (lookahead == 'g') ADVANCE(365);
      END_STATE();
    case 977:
      if (lookahead == 'g') ADVANCE(101);
      END_STATE();
    case 978:
      if (lookahead == 'g') ADVANCE(1310);
      END_STATE();
    case 979:
      if (lookahead == 'g') ADVANCE(225);
      END_STATE();
    case 980:
      if (lookahead == 'g') ADVANCE(382);
      END_STATE();
    case 981:
      if (lookahead == 'g') ADVANCE(1048);
      END_STATE();
    case 982:
      if (lookahead == 'g') ADVANCE(2002);
      END_STATE();
    case 983:
      if (lookahead == 'g') ADVANCE(995);
      if (lookahead == 'l') ADVANCE(844);
      if (lookahead == 'r') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(1036);
      END_STATE();
    case 984:
      if (lookahead == 'g') ADVANCE(995);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 985:
      if (lookahead == 'g') ADVANCE(995);
      if (lookahead == 'r') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(1038);
      END_STATE();
    case 986:
      if (lookahead == 'g') ADVANCE(1439);
      END_STATE();
    case 987:
      if (lookahead == 'g') ADVANCE(1478);
      if (lookahead == 'p') ADVANCE(945);
      END_STATE();
    case 988:
      if (lookahead == 'g') ADVANCE(1478);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 989:
      if (lookahead == 'g') ADVANCE(1319);
      END_STATE();
    case 990:
      if (lookahead == 'g') ADVANCE(1037);
      END_STATE();
    case 991:
      if (lookahead == 'g') ADVANCE(1207);
      if (lookahead == 'i') ADVANCE(1239);
      if (lookahead == 'l') ADVANCE(969);
      if (lookahead == 'r') ADVANCE(1180);
      END_STATE();
    case 992:
      if (lookahead == 'g') ADVANCE(525);
      if (lookahead == 's') ADVANCE(1863);
      if (lookahead == 'w') ADVANCE(344);
      END_STATE();
    case 993:
      if (lookahead == 'g') ADVANCE(1353);
      END_STATE();
    case 994:
      if (lookahead == 'g') ADVANCE(775);
      END_STATE();
    case 995:
      if (lookahead == 'g') ADVANCE(807);
      END_STATE();
    case 996:
      if (lookahead == 'g') ADVANCE(811);
      END_STATE();
    case 997:
      if (lookahead == 'g') ADVANCE(1726);
      END_STATE();
    case 998:
      if (lookahead == 'g') ADVANCE(1726);
      if (lookahead == 'i') ADVANCE(1366);
      if (lookahead == 't') ADVANCE(1507);
      END_STATE();
    case 999:
      if (lookahead == 'g') ADVANCE(1624);
      END_STATE();
    case 1000:
      if (lookahead == 'g') ADVANCE(1051);
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 's') ADVANCE(1150);
      END_STATE();
    case 1001:
      if (lookahead == 'g') ADVANCE(769);
      END_STATE();
    case 1002:
      if (lookahead == 'g') ADVANCE(1633);
      END_STATE();
    case 1003:
      if (lookahead == 'g') ADVANCE(1047);
      END_STATE();
    case 1004:
      if (lookahead == 'g') ADVANCE(1827);
      END_STATE();
    case 1005:
      if (lookahead == 'g') ADVANCE(1827);
      if (lookahead == 'l') ADVANCE(821);
      END_STATE();
    case 1006:
      if (lookahead == 'g') ADVANCE(1827);
      if (lookahead == 'q') ADVANCE(1004);
      END_STATE();
    case 1007:
      if (lookahead == 'g') ADVANCE(1052);
      END_STATE();
    case 1008:
      if (lookahead == 'g') ADVANCE(1345);
      if (lookahead == 'm') ADVANCE(99);
      END_STATE();
    case 1009:
      if (lookahead == 'g') ADVANCE(1677);
      END_STATE();
    case 1010:
      if (lookahead == 'g') ADVANCE(1677);
      if (lookahead == 'r') ADVANCE(1794);
      END_STATE();
    case 1011:
      if (lookahead == 'g') ADVANCE(1053);
      END_STATE();
    case 1012:
      if (lookahead == 'g') ADVANCE(1055);
      END_STATE();
    case 1013:
      if (lookahead == 'g') ADVANCE(1056);
      END_STATE();
    case 1014:
      if (lookahead == 'g') ADVANCE(1057);
      END_STATE();
    case 1015:
      if (lookahead == 'g') ADVANCE(1256);
      END_STATE();
    case 1016:
      if (lookahead == 'g') ADVANCE(1059);
      END_STATE();
    case 1017:
      if (lookahead == 'g') ADVANCE(889);
      if (lookahead == 'r') ADVANCE(698);
      END_STATE();
    case 1018:
      if (lookahead == 'g') ADVANCE(1060);
      END_STATE();
    case 1019:
      if (lookahead == 'g') ADVANCE(1061);
      END_STATE();
    case 1020:
      if (lookahead == 'g') ADVANCE(1278);
      END_STATE();
    case 1021:
      if (lookahead == 'g') ADVANCE(1050);
      END_STATE();
    case 1022:
      if (lookahead == 'g') ADVANCE(1280);
      END_STATE();
    case 1023:
      if (lookahead == 'g') ADVANCE(1281);
      END_STATE();
    case 1024:
      if (lookahead == 'g') ADVANCE(1282);
      END_STATE();
    case 1025:
      if (lookahead == 'g') ADVANCE(1295);
      END_STATE();
    case 1026:
      if (lookahead == 'g') ADVANCE(1283);
      END_STATE();
    case 1027:
      if (lookahead == 'g') ADVANCE(1284);
      END_STATE();
    case 1028:
      if (lookahead == 'g') ADVANCE(345);
      END_STATE();
    case 1029:
      if (lookahead == 'g') ADVANCE(543);
      END_STATE();
    case 1030:
      if (lookahead == 'g') ADVANCE(1070);
      END_STATE();
    case 1031:
      if (lookahead == 'h') ADVANCE(730);
      END_STATE();
    case 1032:
      if (lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 1033:
      if (lookahead == 'h') ADVANCE(152);
      END_STATE();
    case 1034:
      if (lookahead == 'h') ADVANCE(365);
      END_STATE();
    case 1035:
      if (lookahead == 'h') ADVANCE(382);
      END_STATE();
    case 1036:
      if (lookahead == 'h') ADVANCE(210);
      END_STATE();
    case 1037:
      if (lookahead == 'h') ADVANCE(1807);
      END_STATE();
    case 1038:
      if (lookahead == 'h') ADVANCE(1957);
      END_STATE();
    case 1039:
      if (lookahead == 'h') ADVANCE(603);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1040:
      if (lookahead == 'h') ADVANCE(1072);
      END_STATE();
    case 1041:
      if (lookahead == 'h') ADVANCE(1072);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(1506);
      END_STATE();
    case 1042:
      if (lookahead == 'h') ADVANCE(396);
      END_STATE();
    case 1043:
      if (lookahead == 'h') ADVANCE(1526);
      END_STATE();
    case 1044:
      if (lookahead == 'h') ADVANCE(1188);
      END_STATE();
    case 1045:
      if (lookahead == 'h') ADVANCE(1188);
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 1046:
      if (lookahead == 'h') ADVANCE(775);
      END_STATE();
    case 1047:
      if (lookahead == 'h') ADVANCE(1898);
      END_STATE();
    case 1048:
      if (lookahead == 'h') ADVANCE(1814);
      END_STATE();
    case 1049:
      if (lookahead == 'h') ADVANCE(406);
      END_STATE();
    case 1050:
      if (lookahead == 'h') ADVANCE(1852);
      END_STATE();
    case 1051:
      if (lookahead == 'h') ADVANCE(1816);
      END_STATE();
    case 1052:
      if (lookahead == 'h') ADVANCE(1841);
      END_STATE();
    case 1053:
      if (lookahead == 'h') ADVANCE(1829);
      END_STATE();
    case 1054:
      if (lookahead == 'h') ADVANCE(1075);
      END_STATE();
    case 1055:
      if (lookahead == 'h') ADVANCE(1820);
      END_STATE();
    case 1056:
      if (lookahead == 'h') ADVANCE(1822);
      END_STATE();
    case 1057:
      if (lookahead == 'h') ADVANCE(1837);
      END_STATE();
    case 1058:
      if (lookahead == 'h') ADVANCE(841);
      if (lookahead == 'r') ADVANCE(1183);
      END_STATE();
    case 1059:
      if (lookahead == 'h') ADVANCE(1824);
      END_STATE();
    case 1060:
      if (lookahead == 'h') ADVANCE(1826);
      END_STATE();
    case 1061:
      if (lookahead == 'h') ADVANCE(1823);
      END_STATE();
    case 1062:
      if (lookahead == 'h') ADVANCE(917);
      END_STATE();
    case 1063:
      if (lookahead == 'h') ADVANCE(1109);
      END_STATE();
    case 1064:
      if (lookahead == 'h') ADVANCE(849);
      END_STATE();
    case 1065:
      if (lookahead == 'h') ADVANCE(966);
      END_STATE();
    case 1066:
      if (lookahead == 'h') ADVANCE(1648);
      if (lookahead == 'i') ADVANCE(1346);
      if (lookahead == 'r') ADVANCE(1080);
      END_STATE();
    case 1067:
      if (lookahead == 'h') ADVANCE(871);
      END_STATE();
    case 1068:
      if (lookahead == 'h') ADVANCE(1133);
      END_STATE();
    case 1069:
      if (lookahead == 'h') ADVANCE(1729);
      END_STATE();
    case 1070:
      if (lookahead == 'h') ADVANCE(1897);
      END_STATE();
    case 1071:
      if (lookahead == 'i') ADVANCE(730);
      END_STATE();
    case 1072:
      if (lookahead == 'i') ADVANCE(13);
      END_STATE();
    case 1073:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 1074:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 1075:
      if (lookahead == 'i') ADVANCE(679);
      END_STATE();
    case 1076:
      if (lookahead == 'i') ADVANCE(1985);
      if (lookahead == 'o') ADVANCE(1067);
      END_STATE();
    case 1077:
      if (lookahead == 'i') ADVANCE(2001);
      END_STATE();
    case 1078:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 1079:
      if (lookahead == 'i') ADVANCE(156);
      END_STATE();
    case 1080:
      if (lookahead == 'i') ADVANCE(227);
      END_STATE();
    case 1081:
      if (lookahead == 'i') ADVANCE(141);
      END_STATE();
    case 1082:
      if (lookahead == 'i') ADVANCE(1599);
      END_STATE();
    case 1083:
      if (lookahead == 'i') ADVANCE(1599);
      if (lookahead == 'r') ADVANCE(1453);
      END_STATE();
    case 1084:
      if (lookahead == 'i') ADVANCE(1366);
      END_STATE();
    case 1085:
      if (lookahead == 'i') ADVANCE(1366);
      if (lookahead == 'n') ADVANCE(1807);
      END_STATE();
    case 1086:
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 'm') ADVANCE(1344);
      if (lookahead == 'o') ADVANCE(1387);
      END_STATE();
    case 1087:
      if (lookahead == 'i') ADVANCE(989);
      if (lookahead == 'u') ADVANCE(602);
      END_STATE();
    case 1088:
      if (lookahead == 'i') ADVANCE(1240);
      END_STATE();
    case 1089:
      if (lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 1090:
      if (lookahead == 'i') ADVANCE(1807);
      END_STATE();
    case 1091:
      if (lookahead == 'i') ADVANCE(1957);
      END_STATE();
    case 1092:
      if (lookahead == 'i') ADVANCE(725);
      END_STATE();
    case 1093:
      if (lookahead == 'i') ADVANCE(725);
      if (lookahead == 'o') ADVANCE(1941);
      END_STATE();
    case 1094:
      if (lookahead == 'i') ADVANCE(1354);
      END_STATE();
    case 1095:
      if (lookahead == 'i') ADVANCE(211);
      END_STATE();
    case 1096:
      if (lookahead == 'i') ADVANCE(1801);
      END_STATE();
    case 1097:
      if (lookahead == 'i') ADVANCE(1801);
      if (lookahead == 'p') ADVANCE(1481);
      END_STATE();
    case 1098:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 1099:
      if (lookahead == 'i') ADVANCE(1236);
      END_STATE();
    case 1100:
      if (lookahead == 'i') ADVANCE(1526);
      END_STATE();
    case 1101:
      if (lookahead == 'i') ADVANCE(969);
      END_STATE();
    case 1102:
      if (lookahead == 'i') ADVANCE(969);
      if (lookahead == 'l') ADVANCE(1101);
      END_STATE();
    case 1103:
      if (lookahead == 'i') ADVANCE(951);
      END_STATE();
    case 1104:
      if (lookahead == 'i') ADVANCE(1312);
      END_STATE();
    case 1105:
      if (lookahead == 'i') ADVANCE(1312);
      if (lookahead == 'l') ADVANCE(13);
      END_STATE();
    case 1106:
      if (lookahead == 'i') ADVANCE(1312);
      if (lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 1107:
      if (lookahead == 'i') ADVANCE(1478);
      END_STATE();
    case 1108:
      if (lookahead == 'i') ADVANCE(1752);
      END_STATE();
    case 1109:
      if (lookahead == 'i') ADVANCE(1374);
      END_STATE();
    case 1110:
      if (lookahead == 'i') ADVANCE(1777);
      if (lookahead == 'l') ADVANCE(1487);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 1111:
      if (lookahead == 'i') ADVANCE(1777);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 1112:
      if (lookahead == 'i') ADVANCE(1207);
      END_STATE();
    case 1113:
      if (lookahead == 'i') ADVANCE(982);
      END_STATE();
    case 1114:
      if (lookahead == 'i') ADVANCE(993);
      END_STATE();
    case 1115:
      if (lookahead == 'i') ADVANCE(1918);
      END_STATE();
    case 1116:
      if (lookahead == 'i') ADVANCE(1353);
      END_STATE();
    case 1117:
      if (lookahead == 'i') ADVANCE(1237);
      END_STATE();
    case 1118:
      if (lookahead == 'i') ADVANCE(611);
      END_STATE();
    case 1119:
      if (lookahead == 'i') ADVANCE(1629);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1120:
      if (lookahead == 'i') ADVANCE(775);
      END_STATE();
    case 1121:
      if (lookahead == 'i') ADVANCE(1387);
      END_STATE();
    case 1122:
      if (lookahead == 'i') ADVANCE(537);
      END_STATE();
    case 1123:
      if (lookahead == 'i') ADVANCE(760);
      END_STATE();
    case 1124:
      if (lookahead == 'i') ADVANCE(1331);
      END_STATE();
    case 1125:
      if (lookahead == 'i') ADVANCE(1029);
      END_STATE();
    case 1126:
      if (lookahead == 'i') ADVANCE(1673);
      if (lookahead == 'l') ADVANCE(945);
      if (lookahead == 'm') ADVANCE(1128);
      if (lookahead == 'r') ADVANCE(741);
      END_STATE();
    case 1127:
      if (lookahead == 'i') ADVANCE(1378);
      END_STATE();
    case 1128:
      if (lookahead == 'i') ADVANCE(1223);
      END_STATE();
    case 1129:
      if (lookahead == 'i') ADVANCE(842);
      END_STATE();
    case 1130:
      if (lookahead == 'i') ADVANCE(1913);
      END_STATE();
    case 1131:
      if (lookahead == 'i') ADVANCE(1418);
      END_STATE();
    case 1132:
      if (lookahead == 'i') ADVANCE(1411);
      END_STATE();
    case 1133:
      if (lookahead == 'i') ADVANCE(1357);
      END_STATE();
    case 1134:
      if (lookahead == 'i') ADVANCE(1253);
      if (lookahead == 'l') ADVANCE(1102);
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 1135:
      if (lookahead == 'i') ADVANCE(990);
      END_STATE();
    case 1136:
      if (lookahead == 'i') ADVANCE(1241);
      END_STATE();
    case 1137:
      if (lookahead == 'i') ADVANCE(1389);
      if (lookahead == 'p') ADVANCE(945);
      END_STATE();
    case 1138:
      if (lookahead == 'i') ADVANCE(1666);
      END_STATE();
    case 1139:
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'o') ADVANCE(1237);
      END_STATE();
    case 1140:
      if (lookahead == 'i') ADVANCE(1666);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1141:
      if (lookahead == 'i') ADVANCE(1239);
      END_STATE();
    case 1142:
      if (lookahead == 'i') ADVANCE(594);
      END_STATE();
    case 1143:
      if (lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 1144:
      if (lookahead == 'i') ADVANCE(1792);
      END_STATE();
    case 1145:
      if (lookahead == 'i') ADVANCE(1963);
      END_STATE();
    case 1146:
      if (lookahead == 'i') ADVANCE(1572);
      END_STATE();
    case 1147:
      if (lookahead == 'i') ADVANCE(1397);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'u') ADVANCE(1368);
      END_STATE();
    case 1148:
      if (lookahead == 'i') ADVANCE(1258);
      END_STATE();
    case 1149:
      if (lookahead == 'i') ADVANCE(1336);
      END_STATE();
    case 1150:
      if (lookahead == 'i') ADVANCE(1391);
      END_STATE();
    case 1151:
      if (lookahead == 'i') ADVANCE(1796);
      END_STATE();
    case 1152:
      if (lookahead == 'i') ADVANCE(1791);
      END_STATE();
    case 1153:
      if (lookahead == 'i') ADVANCE(1346);
      END_STATE();
    case 1154:
      if (lookahead == 'i') ADVANCE(1332);
      END_STATE();
    case 1155:
      if (lookahead == 'i') ADVANCE(1872);
      END_STATE();
    case 1156:
      if (lookahead == 'i') ADVANCE(1269);
      END_STATE();
    case 1157:
      if (lookahead == 'i') ADVANCE(1395);
      END_STATE();
    case 1158:
      if (lookahead == 'i') ADVANCE(886);
      END_STATE();
    case 1159:
      if (lookahead == 'i') ADVANCE(493);
      END_STATE();
    case 1160:
      if (lookahead == 'i') ADVANCE(1288);
      END_STATE();
    case 1161:
      if (lookahead == 'i') ADVANCE(1256);
      END_STATE();
    case 1162:
      if (lookahead == 'i') ADVANCE(1495);
      END_STATE();
    case 1163:
      if (lookahead == 'i') ADVANCE(1474);
      END_STATE();
    case 1164:
      if (lookahead == 'i') ADVANCE(1412);
      END_STATE();
    case 1165:
      if (lookahead == 'i') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 1166:
      if (lookahead == 'i') ADVANCE(1003);
      END_STATE();
    case 1167:
      if (lookahead == 'i') ADVANCE(1289);
      END_STATE();
    case 1168:
      if (lookahead == 'i') ADVANCE(717);
      END_STATE();
    case 1169:
      if (lookahead == 'i') ADVANCE(721);
      END_STATE();
    case 1170:
      if (lookahead == 'i') ADVANCE(595);
      END_STATE();
    case 1171:
      if (lookahead == 'i') ADVANCE(1011);
      END_STATE();
    case 1172:
      if (lookahead == 'i') ADVANCE(1012);
      END_STATE();
    case 1173:
      if (lookahead == 'i') ADVANCE(1013);
      END_STATE();
    case 1174:
      if (lookahead == 'i') ADVANCE(1014);
      END_STATE();
    case 1175:
      if (lookahead == 'i') ADVANCE(1016);
      END_STATE();
    case 1176:
      if (lookahead == 'i') ADVANCE(1018);
      END_STATE();
    case 1177:
      if (lookahead == 'i') ADVANCE(1019);
      END_STATE();
    case 1178:
      if (lookahead == 'i') ADVANCE(1021);
      END_STATE();
    case 1179:
      if (lookahead == 'i') ADVANCE(1740);
      END_STATE();
    case 1180:
      if (lookahead == 'i') ADVANCE(561);
      END_STATE();
    case 1181:
      if (lookahead == 'i') ADVANCE(1030);
      END_STATE();
    case 1182:
      if (lookahead == 'i') ADVANCE(563);
      END_STATE();
    case 1183:
      if (lookahead == 'i') ADVANCE(564);
      END_STATE();
    case 1184:
      if (lookahead == 'i') ADVANCE(565);
      END_STATE();
    case 1185:
      if (lookahead == 'i') ADVANCE(566);
      END_STATE();
    case 1186:
      if (lookahead == 'j') ADVANCE(13);
      END_STATE();
    case 1187:
      if (lookahead == 'j') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(1186);
      END_STATE();
    case 1188:
      if (lookahead == 'k') ADVANCE(13);
      END_STATE();
    case 1189:
      if (lookahead == 'k') ADVANCE(365);
      END_STATE();
    case 1190:
      if (lookahead == 'k') ADVANCE(719);
      END_STATE();
    case 1191:
      if (lookahead == 'k') ADVANCE(1293);
      END_STATE();
    case 1192:
      if (lookahead == 'k') ADVANCE(1266);
      END_STATE();
    case 1193:
      if (lookahead == 'k') ADVANCE(161);
      END_STATE();
    case 1194:
      if (lookahead == 'k') ADVANCE(140);
      END_STATE();
    case 1195:
      if (lookahead == 'k') ADVANCE(603);
      END_STATE();
    case 1196:
      if (lookahead == 'k') ADVANCE(603);
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 1197:
      if (lookahead == 'k') ADVANCE(1979);
      END_STATE();
    case 1198:
      if (lookahead == 'k') ADVANCE(202);
      END_STATE();
    case 1199:
      if (lookahead == 'k') ADVANCE(1788);
      END_STATE();
    case 1200:
      if (lookahead == 'k') ADVANCE(807);
      END_STATE();
    case 1201:
      if (lookahead == 'k') ADVANCE(811);
      END_STATE();
    case 1202:
      if (lookahead == 'k') ADVANCE(520);
      END_STATE();
    case 1203:
      if (lookahead == 'k') ADVANCE(527);
      END_STATE();
    case 1204:
      if (lookahead == 'k') ADVANCE(527);
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 1205:
      if (lookahead == 'k') ADVANCE(1157);
      END_STATE();
    case 1206:
      if (lookahead == 'l') ADVANCE(730);
      END_STATE();
    case 1207:
      if (lookahead == 'l') ADVANCE(13);
      END_STATE();
    case 1208:
      if (lookahead == 'l') ADVANCE(199);
      END_STATE();
    case 1209:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 1210:
      if (lookahead == 'l') ADVANCE(313);
      END_STATE();
    case 1211:
      if (lookahead == 'l') ADVANCE(80);
      END_STATE();
    case 1212:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 1213:
      if (lookahead == 'l') ADVANCE(2013);
      END_STATE();
    case 1214:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 1215:
      if (lookahead == 'l') ADVANCE(266);
      END_STATE();
    case 1216:
      if (lookahead == 'l') ADVANCE(46);
      END_STATE();
    case 1217:
      if (lookahead == 'l') ADVANCE(382);
      END_STATE();
    case 1218:
      if (lookahead == 'l') ADVANCE(1991);
      END_STATE();
    case 1219:
      if (lookahead == 'l') ADVANCE(906);
      END_STATE();
    case 1220:
      if (lookahead == 'l') ADVANCE(906);
      if (lookahead == 'q') ADVANCE(1931);
      END_STATE();
    case 1221:
      if (lookahead == 'l') ADVANCE(906);
      if (lookahead == 'q') ADVANCE(1930);
      if (lookahead == 'x') ADVANCE(1096);
      END_STATE();
    case 1222:
      if (lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 1223:
      if (lookahead == 'l') ADVANCE(1807);
      END_STATE();
    case 1224:
      if (lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 1225:
      if (lookahead == 'l') ADVANCE(322);
      END_STATE();
    case 1226:
      if (lookahead == 'l') ADVANCE(286);
      END_STATE();
    case 1227:
      if (lookahead == 'l') ADVANCE(588);
      END_STATE();
    case 1228:
      if (lookahead == 'l') ADVANCE(278);
      END_STATE();
    case 1229:
      if (lookahead == 'l') ADVANCE(367);
      END_STATE();
    case 1230:
      if (lookahead == 'l') ADVANCE(396);
      END_STATE();
    case 1231:
      if (lookahead == 'l') ADVANCE(297);
      END_STATE();
    case 1232:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 1233:
      if (lookahead == 'l') ADVANCE(429);
      END_STATE();
    case 1234:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 1235:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 1236:
      if (lookahead == 'l') ADVANCE(758);
      END_STATE();
    case 1237:
      if (lookahead == 'l') ADVANCE(1478);
      END_STATE();
    case 1238:
      if (lookahead == 'l') ADVANCE(1188);
      END_STATE();
    case 1239:
      if (lookahead == 'l') ADVANCE(745);
      END_STATE();
    case 1240:
      if (lookahead == 'l') ADVANCE(745);
      if (lookahead == 'm') ADVANCE(842);
      END_STATE();
    case 1241:
      if (lookahead == 'l') ADVANCE(745);
      if (lookahead == 'm') ADVANCE(864);
      END_STATE();
    case 1242:
      if (lookahead == 'l') ADVANCE(824);
      END_STATE();
    case 1243:
      if (lookahead == 'l') ADVANCE(1752);
      END_STATE();
    case 1244:
      if (lookahead == 'l') ADVANCE(697);
      END_STATE();
    case 1245:
      if (lookahead == 'l') ADVANCE(1108);
      END_STATE();
    case 1246:
      if (lookahead == 'l') ADVANCE(1990);
      END_STATE();
    case 1247:
      if (lookahead == 'l') ADVANCE(1074);
      END_STATE();
    case 1248:
      if (lookahead == 'l') ADVANCE(845);
      END_STATE();
    case 1249:
      if (lookahead == 'l') ADVANCE(1207);
      END_STATE();
    case 1250:
      if (lookahead == 'l') ADVANCE(2000);
      END_STATE();
    case 1251:
      if (lookahead == 'l') ADVANCE(1487);
      END_STATE();
    case 1252:
      if (lookahead == 'l') ADVANCE(1938);
      END_STATE();
    case 1253:
      if (lookahead == 'l') ADVANCE(1101);
      END_STATE();
    case 1254:
      if (lookahead == 'l') ADVANCE(1234);
      if (lookahead == 'm') ADVANCE(1538);
      END_STATE();
    case 1255:
      if (lookahead == 'l') ADVANCE(1230);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(110);
      if (lookahead == 'u') ADVANCE(593);
      if (lookahead == 'w') ADVANCE(1358);
      END_STATE();
    case 1256:
      if (lookahead == 'l') ADVANCE(775);
      END_STATE();
    case 1257:
      if (lookahead == 'l') ADVANCE(833);
      END_STATE();
    case 1258:
      if (lookahead == 'l') ADVANCE(1217);
      END_STATE();
    case 1259:
      if (lookahead == 'l') ADVANCE(1226);
      END_STATE();
    case 1260:
      if (lookahead == 'l') ADVANCE(846);
      END_STATE();
    case 1261:
      if (lookahead == 'l') ADVANCE(1308);
      if (lookahead == 's') ADVANCE(1043);
      END_STATE();
    case 1262:
      if (lookahead == 'l') ADVANCE(1505);
      END_STATE();
    case 1263:
      if (lookahead == 'l') ADVANCE(1129);
      END_STATE();
    case 1264:
      if (lookahead == 'l') ADVANCE(1100);
      END_STATE();
    case 1265:
      if (lookahead == 'l') ADVANCE(1225);
      END_STATE();
    case 1266:
      if (lookahead == 'l') ADVANCE(1456);
      if (lookahead == 's') ADVANCE(1596);
      if (lookahead == 't') ADVANCE(1751);
      END_STATE();
    case 1267:
      if (lookahead == 'l') ADVANCE(821);
      END_STATE();
    case 1268:
      if (lookahead == 'l') ADVANCE(821);
      if (lookahead == 'q') ADVANCE(1267);
      END_STATE();
    case 1269:
      if (lookahead == 'l') ADVANCE(1142);
      END_STATE();
    case 1270:
      if (lookahead == 'l') ADVANCE(445);
      END_STATE();
    case 1271:
      if (lookahead == 'l') ADVANCE(1229);
      END_STATE();
    case 1272:
      if (lookahead == 'l') ADVANCE(793);
      END_STATE();
    case 1273:
      if (lookahead == 'l') ADVANCE(794);
      END_STATE();
    case 1274:
      if (lookahead == 'l') ADVANCE(1490);
      END_STATE();
    case 1275:
      if (lookahead == 'l') ADVANCE(782);
      END_STATE();
    case 1276:
      if (lookahead == 'l') ADVANCE(913);
      END_STATE();
    case 1277:
      if (lookahead == 'l') ADVANCE(835);
      if (lookahead == 'r') ADVANCE(1135);
      END_STATE();
    case 1278:
      if (lookahead == 'l') ADVANCE(801);
      END_STATE();
    case 1279:
      if (lookahead == 'l') ADVANCE(802);
      END_STATE();
    case 1280:
      if (lookahead == 'l') ADVANCE(813);
      END_STATE();
    case 1281:
      if (lookahead == 'l') ADVANCE(933);
      END_STATE();
    case 1282:
      if (lookahead == 'l') ADVANCE(825);
      END_STATE();
    case 1283:
      if (lookahead == 'l') ADVANCE(804);
      END_STATE();
    case 1284:
      if (lookahead == 'l') ADVANCE(805);
      END_STATE();
    case 1285:
      if (lookahead == 'l') ADVANCE(806);
      END_STATE();
    case 1286:
      if (lookahead == 'l') ADVANCE(822);
      END_STATE();
    case 1287:
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 1288:
      if (lookahead == 'l') ADVANCE(1109);
      END_STATE();
    case 1289:
      if (lookahead == 'l') ADVANCE(752);
      END_STATE();
    case 1290:
      if (lookahead == 'l') ADVANCE(752);
      if (lookahead == 'm') ADVANCE(836);
      if (lookahead == 'n') ADVANCE(1807);
      END_STATE();
    case 1291:
      if (lookahead == 'l') ADVANCE(1480);
      if (lookahead == 'n') ADVANCE(998);
      if (lookahead == 'p') ADVANCE(947);
      if (lookahead == 'u') ADVANCE(1419);
      END_STATE();
    case 1292:
      if (lookahead == 'l') ADVANCE(401);
      END_STATE();
    case 1293:
      if (lookahead == 'l') ADVANCE(817);
      if (lookahead == 'r') ADVANCE(1166);
      END_STATE();
    case 1294:
      if (lookahead == 'l') ADVANCE(898);
      END_STATE();
    case 1295:
      if (lookahead == 'l') ADVANCE(897);
      END_STATE();
    case 1296:
      if (lookahead == 'l') ADVANCE(513);
      END_STATE();
    case 1297:
      if (lookahead == 'l') ADVANCE(1914);
      END_STATE();
    case 1298:
      if (lookahead == 'l') ADVANCE(1260);
      END_STATE();
    case 1299:
      if (lookahead == 'l') ADVANCE(459);
      END_STATE();
    case 1300:
      if (lookahead == 'l') ADVANCE(1150);
      END_STATE();
    case 1301:
      if (lookahead == 'l') ADVANCE(1485);
      if (lookahead == 'm') ADVANCE(1341);
      if (lookahead == 'n') ADVANCE(974);
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 1302:
      if (lookahead == 'l') ADVANCE(1698);
      END_STATE();
    case 1303:
      if (lookahead == 'l') ADVANCE(1084);
      END_STATE();
    case 1304:
      if (lookahead == 'l') ADVANCE(1245);
      END_STATE();
    case 1305:
      if (lookahead == 'l') ADVANCE(1132);
      END_STATE();
    case 1306:
      if (lookahead == 'l') ADVANCE(1248);
      END_STATE();
    case 1307:
      if (lookahead == 'l') ADVANCE(535);
      END_STATE();
    case 1308:
      if (lookahead == 'l') ADVANCE(1804);
      END_STATE();
    case 1309:
      if (lookahead == 'l') ADVANCE(1300);
      END_STATE();
    case 1310:
      if (lookahead == 'l') ADVANCE(901);
      if (lookahead == 'm') ADVANCE(480);
      if (lookahead == 'r') ADVANCE(1166);
      END_STATE();
    case 1311:
      if (lookahead == 'l') ADVANCE(928);
      if (lookahead == 'r') ADVANCE(1178);
      END_STATE();
    case 1312:
      if (lookahead == 'm') ADVANCE(13);
      END_STATE();
    case 1313:
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 1314:
      if (lookahead == 'm') ADVANCE(152);
      if (lookahead == 'r') ADVANCE(1437);
      END_STATE();
    case 1315:
      if (lookahead == 'm') ADVANCE(365);
      END_STATE();
    case 1316:
      if (lookahead == 'm') ADVANCE(173);
      END_STATE();
    case 1317:
      if (lookahead == 'm') ADVANCE(223);
      END_STATE();
    case 1318:
      if (lookahead == 'm') ADVANCE(222);
      END_STATE();
    case 1319:
      if (lookahead == 'm') ADVANCE(382);
      END_STATE();
    case 1320:
      if (lookahead == 'm') ADVANCE(1165);
      END_STATE();
    case 1321:
      if (lookahead == 'm') ADVANCE(1072);
      END_STATE();
    case 1322:
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 1323:
      if (lookahead == 'm') ADVANCE(1526);
      END_STATE();
    case 1324:
      if (lookahead == 'm') ADVANCE(1556);
      END_STATE();
    case 1325:
      if (lookahead == 'm') ADVANCE(1537);
      END_STATE();
    case 1326:
      if (lookahead == 'm') ADVANCE(1071);
      END_STATE();
    case 1327:
      if (lookahead == 'm') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(532);
      END_STATE();
    case 1328:
      if (lookahead == 'm') ADVANCE(1319);
      END_STATE();
    case 1329:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 1330:
      if (lookahead == 'm') ADVANCE(1560);
      END_STATE();
    case 1331:
      if (lookahead == 'm') ADVANCE(115);
      END_STATE();
    case 1332:
      if (lookahead == 'm') ADVANCE(422);
      END_STATE();
    case 1333:
      if (lookahead == 'm') ADVANCE(845);
      END_STATE();
    case 1334:
      if (lookahead == 'm') ADVANCE(1207);
      END_STATE();
    case 1335:
      if (lookahead == 'm') ADVANCE(1353);
      END_STATE();
    case 1336:
      if (lookahead == 'm') ADVANCE(775);
      END_STATE();
    case 1337:
      if (lookahead == 'm') ADVANCE(1552);
      END_STATE();
    case 1338:
      if (lookahead == 'm') ADVANCE(1547);
      END_STATE();
    case 1339:
      if (lookahead == 'm') ADVANCE(537);
      END_STATE();
    case 1340:
      if (lookahead == 'm') ADVANCE(410);
      END_STATE();
    case 1341:
      if (lookahead == 'm') ADVANCE(417);
      if (lookahead == 'p') ADVANCE(134);
      END_STATE();
    case 1342:
      if (lookahead == 'm') ADVANCE(809);
      END_STATE();
    case 1343:
      if (lookahead == 'm') ADVANCE(809);
      if (lookahead == 'x') ADVANCE(842);
      END_STATE();
    case 1344:
      if (lookahead == 'm') ADVANCE(406);
      END_STATE();
    case 1345:
      if (lookahead == 'm') ADVANCE(390);
      END_STATE();
    case 1346:
      if (lookahead == 'm') ADVANCE(842);
      END_STATE();
    case 1347:
      if (lookahead == 'm') ADVANCE(1568);
      END_STATE();
    case 1348:
      if (lookahead == 'm') ADVANCE(829);
      END_STATE();
    case 1349:
      if (lookahead == 'm') ADVANCE(1340);
      END_STATE();
    case 1350:
      if (lookahead == 'm') ADVANCE(1164);
      END_STATE();
    case 1351:
      if (lookahead == 'm') ADVANCE(531);
      END_STATE();
    case 1352:
      if (lookahead == 'n') ADVANCE(730);
      END_STATE();
    case 1353:
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 1354:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 1355:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 1356:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 1357:
      if (lookahead == 'n') ADVANCE(365);
      END_STATE();
    case 1358:
      if (lookahead == 'n') ADVANCE(545);
      END_STATE();
    case 1359:
      if (lookahead == 'n') ADVANCE(217);
      END_STATE();
    case 1360:
      if (lookahead == 'n') ADVANCE(689);
      END_STATE();
    case 1361:
      if (lookahead == 'n') ADVANCE(2008);
      END_STATE();
    case 1362:
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 1363:
      if (lookahead == 'n') ADVANCE(371);
      END_STATE();
    case 1364:
      if (lookahead == 'n') ADVANCE(375);
      END_STATE();
    case 1365:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 1366:
      if (lookahead == 'n') ADVANCE(1807);
      END_STATE();
    case 1367:
      if (lookahead == 'n') ADVANCE(338);
      END_STATE();
    case 1368:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 1369:
      if (lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 1370:
      if (lookahead == 'n') ADVANCE(1984);
      END_STATE();
    case 1371:
      if (lookahead == 'n') ADVANCE(967);
      END_STATE();
    case 1372:
      if (lookahead == 'n') ADVANCE(765);
      END_STATE();
    case 1373:
      if (lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 1374:
      if (lookahead == 'n') ADVANCE(969);
      END_STATE();
    case 1375:
      if (lookahead == 'n') ADVANCE(969);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1376:
      if (lookahead == 'n') ADVANCE(1867);
      END_STATE();
    case 1377:
      if (lookahead == 'n') ADVANCE(975);
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'w') ADVANCE(876);
      END_STATE();
    case 1378:
      if (lookahead == 'n') ADVANCE(207);
      END_STATE();
    case 1379:
      if (lookahead == 'n') ADVANCE(1188);
      END_STATE();
    case 1380:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 1381:
      if (lookahead == 'n') ADVANCE(1752);
      END_STATE();
    case 1382:
      if (lookahead == 'n') ADVANCE(738);
      END_STATE();
    case 1383:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 1384:
      if (lookahead == 'n') ADVANCE(999);
      if (lookahead == 'r') ADVANCE(856);
      END_STATE();
    case 1385:
      if (lookahead == 'n') ADVANCE(695);
      END_STATE();
    case 1386:
      if (lookahead == 'n') ADVANCE(1015);
      END_STATE();
    case 1387:
      if (lookahead == 'n') ADVANCE(775);
      END_STATE();
    case 1388:
      if (lookahead == 'n') ADVANCE(973);
      END_STATE();
    case 1389:
      if (lookahead == 'n') ADVANCE(723);
      END_STATE();
    case 1390:
      if (lookahead == 'n') ADVANCE(1483);
      END_STATE();
    case 1391:
      if (lookahead == 'n') ADVANCE(1001);
      END_STATE();
    case 1392:
      if (lookahead == 'n') ADVANCE(748);
      END_STATE();
    case 1393:
      if (lookahead == 'n') ADVANCE(1028);
      END_STATE();
    case 1394:
      if (lookahead == 'n') ADVANCE(807);
      END_STATE();
    case 1395:
      if (lookahead == 'n') ADVANCE(976);
      END_STATE();
    case 1396:
      if (lookahead == 'n') ADVANCE(718);
      END_STATE();
    case 1397:
      if (lookahead == 'n') ADVANCE(1885);
      END_STATE();
    case 1398:
      if (lookahead == 'n') ADVANCE(1818);
      END_STATE();
    case 1399:
      if (lookahead == 'n') ADVANCE(1832);
      END_STATE();
    case 1400:
      if (lookahead == 'n') ADVANCE(1857);
      END_STATE();
    case 1401:
      if (lookahead == 'n') ADVANCE(1859);
      END_STATE();
    case 1402:
      if (lookahead == 'n') ADVANCE(837);
      END_STATE();
    case 1403:
      if (lookahead == 'n') ADVANCE(840);
      END_STATE();
    case 1404:
      if (lookahead == 'n') ADVANCE(1277);
      END_STATE();
    case 1405:
      if (lookahead == 'n') ADVANCE(1916);
      END_STATE();
    case 1406:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 1407:
      if (lookahead == 'n') ADVANCE(994);
      END_STATE();
    case 1408:
      if (lookahead == 'n') ADVANCE(997);
      END_STATE();
    case 1409:
      if (lookahead == 'n') ADVANCE(922);
      END_STATE();
    case 1410:
      if (lookahead == 'n') ADVANCE(1107);
      END_STATE();
    case 1411:
      if (lookahead == 'n') ADVANCE(1875);
      END_STATE();
    case 1412:
      if (lookahead == 'n') ADVANCE(1914);
      END_STATE();
    case 1413:
      if (lookahead == 'n') ADVANCE(1488);
      END_STATE();
    case 1414:
      if (lookahead == 'n') ADVANCE(1876);
      END_STATE();
    case 1415:
      if (lookahead == 'n') ADVANCE(1084);
      END_STATE();
    case 1416:
      if (lookahead == 'n') ADVANCE(1874);
      END_STATE();
    case 1417:
      if (lookahead == 'n') ADVANCE(1894);
      END_STATE();
    case 1418:
      if (lookahead == 'n') ADVANCE(505);
      END_STATE();
    case 1419:
      if (lookahead == 'n') ADVANCE(1886);
      END_STATE();
    case 1420:
      if (lookahead == 'n') ADVANCE(1020);
      END_STATE();
    case 1421:
      if (lookahead == 'n') ADVANCE(1884);
      END_STATE();
    case 1422:
      if (lookahead == 'n') ADVANCE(1163);
      END_STATE();
    case 1423:
      if (lookahead == 'n') ADVANCE(925);
      END_STATE();
    case 1424:
      if (lookahead == 'n') ADVANCE(1022);
      if (lookahead == 'r') ADVANCE(1702);
      END_STATE();
    case 1425:
      if (lookahead == 'n') ADVANCE(1022);
      if (lookahead == 'r') ADVANCE(1706);
      END_STATE();
    case 1426:
      if (lookahead == 'n') ADVANCE(1888);
      END_STATE();
    case 1427:
      if (lookahead == 'n') ADVANCE(1023);
      END_STATE();
    case 1428:
      if (lookahead == 'n') ADVANCE(1024);
      END_STATE();
    case 1429:
      if (lookahead == 'n') ADVANCE(1890);
      END_STATE();
    case 1430:
      if (lookahead == 'n') ADVANCE(1025);
      END_STATE();
    case 1431:
      if (lookahead == 'n') ADVANCE(1026);
      END_STATE();
    case 1432:
      if (lookahead == 'n') ADVANCE(1027);
      END_STATE();
    case 1433:
      if (lookahead == 'n') ADVANCE(1895);
      END_STATE();
    case 1434:
      if (lookahead == 'n') ADVANCE(554);
      END_STATE();
    case 1435:
      if (lookahead == 'n') ADVANCE(543);
      END_STATE();
    case 1436:
      if (lookahead == 'o') ADVANCE(730);
      END_STATE();
    case 1437:
      if (lookahead == 'o') ADVANCE(13);
      END_STATE();
    case 1438:
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 1439:
      if (lookahead == 'o') ADVANCE(945);
      END_STATE();
    case 1440:
      if (lookahead == 'o') ADVANCE(1975);
      END_STATE();
    case 1441:
      if (lookahead == 'o') ADVANCE(376);
      END_STATE();
    case 1442:
      if (lookahead == 'o') ADVANCE(1955);
      END_STATE();
    case 1443:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 1444:
      if (lookahead == 'o') ADVANCE(1809);
      END_STATE();
    case 1445:
      if (lookahead == 'o') ADVANCE(1808);
      END_STATE();
    case 1446:
      if (lookahead == 'o') ADVANCE(1599);
      END_STATE();
    case 1447:
      if (lookahead == 'o') ADVANCE(1807);
      END_STATE();
    case 1448:
      if (lookahead == 'o') ADVANCE(1807);
      if (lookahead == 's') ADVANCE(1908);
      END_STATE();
    case 1449:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 1450:
      if (lookahead == 'o') ADVANCE(1986);
      END_STATE();
    case 1451:
      if (lookahead == 'o') ADVANCE(678);
      END_STATE();
    case 1452:
      if (lookahead == 'o') ADVANCE(1984);
      END_STATE();
    case 1453:
      if (lookahead == 'o') ADVANCE(1778);
      END_STATE();
    case 1454:
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 1455:
      if (lookahead == 'o') ADVANCE(1965);
      END_STATE();
    case 1456:
      if (lookahead == 'o') ADVANCE(2004);
      END_STATE();
    case 1457:
      if (lookahead == 'o') ADVANCE(1526);
      END_STATE();
    case 1458:
      if (lookahead == 'o') ADVANCE(1415);
      END_STATE();
    case 1459:
      if (lookahead == 'o') ADVANCE(1966);
      END_STATE();
    case 1460:
      if (lookahead == 'o') ADVANCE(1967);
      END_STATE();
    case 1461:
      if (lookahead == 'o') ADVANCE(1312);
      END_STATE();
    case 1462:
      if (lookahead == 'o') ADVANCE(1188);
      END_STATE();
    case 1463:
      if (lookahead == 'o') ADVANCE(1862);
      END_STATE();
    case 1464:
      if (lookahead == 'o') ADVANCE(1968);
      END_STATE();
    case 1465:
      if (lookahead == 'o') ADVANCE(1980);
      END_STATE();
    case 1466:
      if (lookahead == 'o') ADVANCE(1752);
      END_STATE();
    case 1467:
      if (lookahead == 'o') ADVANCE(1374);
      END_STATE();
    case 1468:
      if (lookahead == 'o') ADVANCE(1374);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1469:
      if (lookahead == 'o') ADVANCE(1981);
      END_STATE();
    case 1470:
      if (lookahead == 'o') ADVANCE(1974);
      END_STATE();
    case 1471:
      if (lookahead == 'o') ADVANCE(1969);
      END_STATE();
    case 1472:
      if (lookahead == 'o') ADVANCE(1207);
      if (lookahead == 'u') ADVANCE(567);
      END_STATE();
    case 1473:
      if (lookahead == 'o') ADVANCE(753);
      END_STATE();
    case 1474:
      if (lookahead == 'o') ADVANCE(1381);
      END_STATE();
    case 1475:
      if (lookahead == 'o') ADVANCE(1972);
      END_STATE();
    case 1476:
      if (lookahead == 'o') ADVANCE(1813);
      END_STATE();
    case 1477:
      if (lookahead == 'o') ADVANCE(1653);
      END_STATE();
    case 1478:
      if (lookahead == 'o') ADVANCE(1353);
      END_STATE();
    case 1479:
      if (lookahead == 'o') ADVANCE(1353);
      if (lookahead == 'r') ADVANCE(414);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 1480:
      if (lookahead == 'o') ADVANCE(1373);
      END_STATE();
    case 1481:
      if (lookahead == 'o') ADVANCE(1409);
      END_STATE();
    case 1482:
      if (lookahead == 'o') ADVANCE(1365);
      END_STATE();
    case 1483:
      if (lookahead == 'o') ADVANCE(1951);
      END_STATE();
    case 1484:
      if (lookahead == 'o') ADVANCE(1352);
      END_STATE();
    case 1485:
      if (lookahead == 'o') ADVANCE(1380);
      END_STATE();
    case 1486:
      if (lookahead == 'o') ADVANCE(1953);
      END_STATE();
    case 1487:
      if (lookahead == 'o') ADVANCE(1446);
      END_STATE();
    case 1488:
      if (lookahead == 'o') ADVANCE(1899);
      END_STATE();
    case 1489:
      if (lookahead == 'o') ADVANCE(1206);
      END_STATE();
    case 1490:
      if (lookahead == 'o') ADVANCE(677);
      END_STATE();
    case 1491:
      if (lookahead == 'o') ADVANCE(1848);
      END_STATE();
    case 1492:
      if (lookahead == 'o') ADVANCE(1850);
      END_STATE();
    case 1493:
      if (lookahead == 'o') ADVANCE(1892);
      END_STATE();
    case 1494:
      if (lookahead == 'o') ADVANCE(1404);
      END_STATE();
    case 1495:
      if (lookahead == 'o') ADVANCE(1406);
      END_STATE();
    case 1496:
      if (lookahead == 'o') ADVANCE(1372);
      END_STATE();
    case 1497:
      if (lookahead == 'o') ADVANCE(1665);
      if (lookahead == 'r') ADVANCE(1457);
      END_STATE();
    case 1498:
      if (lookahead == 'o') ADVANCE(1690);
      END_STATE();
    case 1499:
      if (lookahead == 'o') ADVANCE(1692);
      if (lookahead == 'r') ADVANCE(1457);
      END_STATE();
    case 1500:
      if (lookahead == 'o') ADVANCE(1616);
      END_STATE();
    case 1501:
      if (lookahead == 'o') ADVANCE(1976);
      END_STATE();
    case 1502:
      if (lookahead == 'o') ADVANCE(1328);
      END_STATE();
    case 1503:
      if (lookahead == 'o') ADVANCE(1328);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1504:
      if (lookahead == 'o') ADVANCE(1671);
      END_STATE();
    case 1505:
      if (lookahead == 'o') ADVANCE(1555);
      END_STATE();
    case 1506:
      if (lookahead == 'o') ADVANCE(1566);
      END_STATE();
    case 1507:
      if (lookahead == 'o') ADVANCE(1935);
      END_STATE();
    case 1508:
      if (lookahead == 'o') ADVANCE(1982);
      END_STATE();
    case 1509:
      if (lookahead == 'o') ADVANCE(1977);
      END_STATE();
    case 1510:
      if (lookahead == 'o') ADVANCE(1941);
      END_STATE();
    case 1511:
      if (lookahead == 'o') ADVANCE(1856);
      END_STATE();
    case 1512:
      if (lookahead == 'o') ADVANCE(1408);
      if (lookahead == 'u') ADVANCE(1546);
      END_STATE();
    case 1513:
      if (lookahead == 'o') ADVANCE(1978);
      END_STATE();
    case 1514:
      if (lookahead == 'o') ADVANCE(1421);
      END_STATE();
    case 1515:
      if (lookahead == 'o') ADVANCE(1686);
      END_STATE();
    case 1516:
      if (lookahead == 'o') ADVANCE(1494);
      END_STATE();
    case 1517:
      if (lookahead == 'o') ADVANCE(1667);
      END_STATE();
    case 1518:
      if (lookahead == 'o') ADVANCE(1400);
      END_STATE();
    case 1519:
      if (lookahead == 'o') ADVANCE(1474);
      END_STATE();
    case 1520:
      if (lookahead == 'o') ADVANCE(1496);
      END_STATE();
    case 1521:
      if (lookahead == 'o') ADVANCE(1732);
      END_STATE();
    case 1522:
      if (lookahead == 'o') ADVANCE(1303);
      END_STATE();
    case 1523:
      if (lookahead == 'o') ADVANCE(1956);
      END_STATE();
    case 1524:
      if (lookahead == 'o') ADVANCE(1983);
      END_STATE();
    case 1525:
      if (lookahead == 'p') ADVANCE(1803);
      END_STATE();
    case 1526:
      if (lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 1527:
      if (lookahead == 'p') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(1478);
      END_STATE();
    case 1528:
      if (lookahead == 'p') ADVANCE(1035);
      END_STATE();
    case 1529:
      if (lookahead == 'p') ADVANCE(945);
      END_STATE();
    case 1530:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'r') ADVANCE(524);
      END_STATE();
    case 1531:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'r') ADVANCE(267);
      if (lookahead == 'u') ADVANCE(1683);
      END_STATE();
    case 1532:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'r') ADVANCE(1077);
      END_STATE();
    case 1533:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(26);
      if (lookahead == 'u') ADVANCE(592);
      if (lookahead == 'w') ADVANCE(1355);
      END_STATE();
    case 1534:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 't') ADVANCE(206);
      if (lookahead == 'w') ADVANCE(1868);
      if (lookahead == 'x') ADVANCE(301);
      END_STATE();
    case 1535:
      if (lookahead == 'p') ADVANCE(945);
      if (lookahead == 'u') ADVANCE(1382);
      END_STATE();
    case 1536:
      if (lookahead == 'p') ADVANCE(25);
      END_STATE();
    case 1537:
      if (lookahead == 'p') ADVANCE(309);
      END_STATE();
    case 1538:
      if (lookahead == 'p') ADVANCE(32);
      END_STATE();
    case 1539:
      if (lookahead == 'p') ADVANCE(7);
      END_STATE();
    case 1540:
      if (lookahead == 'p') ADVANCE(310);
      END_STATE();
    case 1541:
      if (lookahead == 'p') ADVANCE(270);
      END_STATE();
    case 1542:
      if (lookahead == 'p') ADVANCE(1599);
      if (lookahead == 's') ADVANCE(611);
      END_STATE();
    case 1543:
      if (lookahead == 'p') ADVANCE(382);
      END_STATE();
    case 1544:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 1545:
      if (lookahead == 'p') ADVANCE(269);
      END_STATE();
    case 1546:
      if (lookahead == 'p') ADVANCE(284);
      END_STATE();
    case 1547:
      if (lookahead == 'p') ADVANCE(106);
      END_STATE();
    case 1548:
      if (lookahead == 'p') ADVANCE(187);
      END_STATE();
    case 1549:
      if (lookahead == 'p') ADVANCE(1032);
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 1550:
      if (lookahead == 'p') ADVANCE(1543);
      END_STATE();
    case 1551:
      if (lookahead == 'p') ADVANCE(1752);
      if (lookahead == 'r') ADVANCE(1478);
      END_STATE();
    case 1552:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 1553:
      if (lookahead == 'p') ADVANCE(1218);
      END_STATE();
    case 1554:
      if (lookahead == 'p') ADVANCE(1563);
      END_STATE();
    case 1555:
      if (lookahead == 'p') ADVANCE(775);
      END_STATE();
    case 1556:
      if (lookahead == 'p') ADVANCE(823);
      END_STATE();
    case 1557:
      if (lookahead == 'p') ADVANCE(1297);
      END_STATE();
    case 1558:
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 1559:
      if (lookahead == 'p') ADVANCE(1775);
      END_STATE();
    case 1560:
      if (lookahead == 'p') ADVANCE(1847);
      END_STATE();
    case 1561:
      if (lookahead == 'p') ADVANCE(1573);
      END_STATE();
    case 1562:
      if (lookahead == 'p') ADVANCE(1573);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1563:
      if (lookahead == 'p') ADVANCE(402);
      END_STATE();
    case 1564:
      if (lookahead == 'p') ADVANCE(1516);
      END_STATE();
    case 1565:
      if (lookahead == 'p') ADVANCE(1299);
      END_STATE();
    case 1566:
      if (lookahead == 'p') ADVANCE(1839);
      END_STATE();
    case 1567:
      if (lookahead == 'p') ADVANCE(1466);
      END_STATE();
    case 1568:
      if (lookahead == 'p') ADVANCE(1263);
      END_STATE();
    case 1569:
      if (lookahead == 'p') ADVANCE(521);
      END_STATE();
    case 1570:
      if (lookahead == 'p') ADVANCE(1793);
      END_STATE();
    case 1571:
      if (lookahead == 'p') ADVANCE(1698);
      if (lookahead == 's') ADVANCE(1926);
      END_STATE();
    case 1572:
      if (lookahead == 'p') ADVANCE(1275);
      END_STATE();
    case 1573:
      if (lookahead == 'p') ADVANCE(1678);
      END_STATE();
    case 1574:
      if (lookahead == 'p') ADVANCE(503);
      END_STATE();
    case 1575:
      if (lookahead == 'p') ADVANCE(552);
      END_STATE();
    case 1576:
      if (lookahead == 'p') ADVANCE(321);
      END_STATE();
    case 1577:
      if (lookahead == 'p') ADVANCE(1520);
      END_STATE();
    case 1578:
      if (lookahead == 'p') ADVANCE(536);
      END_STATE();
    case 1579:
      if (lookahead == 'p') ADVANCE(1519);
      END_STATE();
    case 1580:
      if (lookahead == 'p') ADVANCE(554);
      END_STATE();
    case 1581:
      if (lookahead == 'q') ADVANCE(13);
      END_STATE();
    case 1582:
      if (lookahead == 'q') ADVANCE(98);
      END_STATE();
    case 1583:
      if (lookahead == 'q') ADVANCE(1268);
      END_STATE();
    case 1584:
      if (lookahead == 'q') ADVANCE(1006);
      END_STATE();
    case 1585:
      if (lookahead == 'q') ADVANCE(1571);
      END_STATE();
    case 1586:
      if (lookahead == 'q') ADVANCE(178);
      END_STATE();
    case 1587:
      if (lookahead == 'q') ADVANCE(1581);
      END_STATE();
    case 1588:
      if (lookahead == 'q') ADVANCE(1902);
      END_STATE();
    case 1589:
      if (lookahead == 'q') ADVANCE(1921);
      END_STATE();
    case 1590:
      if (lookahead == 'q') ADVANCE(1954);
      if (lookahead == 'u') ADVANCE(590);
      END_STATE();
    case 1591:
      if (lookahead == 'q') ADVANCE(1942);
      END_STATE();
    case 1592:
      if (lookahead == 'q') ADVANCE(1931);
      END_STATE();
    case 1593:
      if (lookahead == 'q') ADVANCE(696);
      if (lookahead == 't') ADVANCE(396);
      END_STATE();
    case 1594:
      if (lookahead == 'q') ADVANCE(1945);
      END_STATE();
    case 1595:
      if (lookahead == 'q') ADVANCE(1949);
      END_STATE();
    case 1596:
      if (lookahead == 'q') ADVANCE(1952);
      END_STATE();
    case 1597:
      if (lookahead == 'r') ADVANCE(730);
      END_STATE();
    case 1598:
      if (lookahead == 'r') ADVANCE(784);
      END_STATE();
    case 1599:
      if (lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 1600:
      if (lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 1601:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 1602:
      if (lookahead == 'r') ADVANCE(945);
      END_STATE();
    case 1603:
      if (lookahead == 'r') ADVANCE(215);
      END_STATE();
    case 1604:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 1605:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 1606:
      if (lookahead == 'r') ADVANCE(654);
      END_STATE();
    case 1607:
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 1608:
      if (lookahead == 'r') ADVANCE(2017);
      END_STATE();
    case 1609:
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 1610:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 1611:
      if (lookahead == 'r') ADVANCE(1045);
      END_STATE();
    case 1612:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 1613:
      if (lookahead == 'r') ADVANCE(347);
      END_STATE();
    case 1614:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 1615:
      if (lookahead == 'r') ADVANCE(2022);
      END_STATE();
    case 1616:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 1617:
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 1618:
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1619:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 1620:
      if (lookahead == 'r') ADVANCE(329);
      END_STATE();
    case 1621:
      if (lookahead == 'r') ADVANCE(604);
      END_STATE();
    case 1622:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 1623:
      if (lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 1624:
      if (lookahead == 'r') ADVANCE(1807);
      END_STATE();
    case 1625:
      if (lookahead == 'r') ADVANCE(1807);
      if (lookahead == 'u') ADVANCE(538);
      END_STATE();
    case 1626:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 1627:
      if (lookahead == 'r') ADVANCE(757);
      END_STATE();
    case 1628:
      if (lookahead == 'r') ADVANCE(77);
      END_STATE();
    case 1629:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 1630:
      if (lookahead == 'r') ADVANCE(73);
      END_STATE();
    case 1631:
      if (lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 1632:
      if (lookahead == 'r') ADVANCE(603);
      END_STATE();
    case 1633:
      if (lookahead == 'r') ADVANCE(433);
      END_STATE();
    case 1634:
      if (lookahead == 'r') ADVANCE(1072);
      END_STATE();
    case 1635:
      if (lookahead == 'r') ADVANCE(170);
      END_STATE();
    case 1636:
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 1637:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 1638:
      if (lookahead == 'r') ADVANCE(733);
      END_STATE();
    case 1639:
      if (lookahead == 'r') ADVANCE(725);
      END_STATE();
    case 1640:
      if (lookahead == 'r') ADVANCE(1437);
      END_STATE();
    case 1641:
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 1642:
      if (lookahead == 'r') ADVANCE(1198);
      END_STATE();
    case 1643:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 1644:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 1645:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 1646:
      if (lookahead == 'r') ADVANCE(715);
      END_STATE();
    case 1647:
      if (lookahead == 'r') ADVANCE(1526);
      END_STATE();
    case 1648:
      if (lookahead == 'r') ADVANCE(852);
      END_STATE();
    case 1649:
      if (lookahead == 'r') ADVANCE(1867);
      END_STATE();
    case 1650:
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 1651:
      if (lookahead == 'r') ADVANCE(387);
      END_STATE();
    case 1652:
      if (lookahead == 'r') ADVANCE(1478);
      END_STATE();
    case 1653:
      if (lookahead == 'r') ADVANCE(1188);
      END_STATE();
    case 1654:
      if (lookahead == 'r') ADVANCE(1994);
      END_STATE();
    case 1655:
      if (lookahead == 'r') ADVANCE(1996);
      END_STATE();
    case 1656:
      if (lookahead == 'r') ADVANCE(1441);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 1657:
      if (lookahead == 'r') ADVANCE(1752);
      END_STATE();
    case 1658:
      if (lookahead == 'r') ADVANCE(845);
      END_STATE();
    case 1659:
      if (lookahead == 'r') ADVANCE(1436);
      END_STATE();
    case 1660:
      if (lookahead == 'r') ADVANCE(414);
      END_STATE();
    case 1661:
      if (lookahead == 'r') ADVANCE(1973);
      END_STATE();
    case 1662:
      if (lookahead == 'r') ADVANCE(1995);
      END_STATE();
    case 1663:
      if (lookahead == 'r') ADVANCE(903);
      END_STATE();
    case 1664:
      if (lookahead == 'r') ADVANCE(1044);
      END_STATE();
    case 1665:
      if (lookahead == 'r') ADVANCE(1353);
      END_STATE();
    case 1666:
      if (lookahead == 'r') ADVANCE(611);
      END_STATE();
    case 1667:
      if (lookahead == 'r') ADVANCE(775);
      END_STATE();
    case 1668:
      if (lookahead == 'r') ADVANCE(1457);
      END_STATE();
    case 1669:
      if (lookahead == 'r') ADVANCE(1149);
      END_STATE();
    case 1670:
      if (lookahead == 'r') ADVANCE(1462);
      END_STATE();
    case 1671:
      if (lookahead == 'r') ADVANCE(1815);
      END_STATE();
    case 1672:
      if (lookahead == 'r') ADVANCE(1450);
      END_STATE();
    case 1673:
      if (lookahead == 'r') ADVANCE(1772);
      END_STATE();
    case 1674:
      if (lookahead == 'r') ADVANCE(684);
      END_STATE();
    case 1675:
      if (lookahead == 'r') ADVANCE(1455);
      END_STATE();
    case 1676:
      if (lookahead == 'r') ADVANCE(1608);
      END_STATE();
    case 1677:
      if (lookahead == 'r') ADVANCE(449);
      END_STATE();
    case 1678:
      if (lookahead == 'r') ADVANCE(1452);
      END_STATE();
    case 1679:
      if (lookahead == 'r') ADVANCE(1885);
      END_STATE();
    case 1680:
      if (lookahead == 'r') ADVANCE(1564);
      END_STATE();
    case 1681:
      if (lookahead == 'r') ADVANCE(1878);
      END_STATE();
    case 1682:
      if (lookahead == 'r') ADVANCE(1794);
      END_STATE();
    case 1683:
      if (lookahead == 'r') ADVANCE(1158);
      END_STATE();
    case 1684:
      if (lookahead == 'r') ADVANCE(1802);
      END_STATE();
    case 1685:
      if (lookahead == 'r') ADVANCE(828);
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 1686:
      if (lookahead == 'r') ADVANCE(1831);
      END_STATE();
    case 1687:
      if (lookahead == 'r') ADVANCE(452);
      END_STATE();
    case 1688:
      if (lookahead == 'r') ADVANCE(1120);
      END_STATE();
    case 1689:
      if (lookahead == 'r') ADVANCE(1459);
      END_STATE();
    case 1690:
      if (lookahead == 'r') ADVANCE(1394);
      END_STATE();
    case 1691:
      if (lookahead == 'r') ADVANCE(1780);
      END_STATE();
    case 1692:
      if (lookahead == 'r') ADVANCE(1383);
      END_STATE();
    case 1693:
      if (lookahead == 'r') ADVANCE(1098);
      END_STATE();
    case 1694:
      if (lookahead == 'r') ADVANCE(1422);
      END_STATE();
    case 1695:
      if (lookahead == 'r') ADVANCE(1246);
      END_STATE();
    case 1696:
      if (lookahead == 'r') ADVANCE(1155);
      END_STATE();
    case 1697:
      if (lookahead == 'r') ADVANCE(1250);
      END_STATE();
    case 1698:
      if (lookahead == 'r') ADVANCE(850);
      END_STATE();
    case 1699:
      if (lookahead == 'r') ADVANCE(1460);
      END_STATE();
    case 1700:
      if (lookahead == 'r') ADVANCE(1811);
      END_STATE();
    case 1701:
      if (lookahead == 'r') ADVANCE(792);
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 1702:
      if (lookahead == 'r') ADVANCE(1464);
      END_STATE();
    case 1703:
      if (lookahead == 'r') ADVANCE(1465);
      END_STATE();
    case 1704:
      if (lookahead == 'r') ADVANCE(1469);
      END_STATE();
    case 1705:
      if (lookahead == 'r') ADVANCE(1470);
      END_STATE();
    case 1706:
      if (lookahead == 'r') ADVANCE(1471);
      END_STATE();
    case 1707:
      if (lookahead == 'r') ADVANCE(943);
      END_STATE();
    case 1708:
      if (lookahead == 'r') ADVANCE(795);
      END_STATE();
    case 1709:
      if (lookahead == 'r') ADVANCE(1475);
      END_STATE();
    case 1710:
      if (lookahead == 'r') ADVANCE(1614);
      END_STATE();
    case 1711:
      if (lookahead == 'r') ADVANCE(899);
      END_STATE();
    case 1712:
      if (lookahead == 'r') ADVANCE(1604);
      END_STATE();
    case 1713:
      if (lookahead == 'r') ADVANCE(1637);
      END_STATE();
    case 1714:
      if (lookahead == 'r') ADVANCE(918);
      END_STATE();
    case 1715:
      if (lookahead == 'r') ADVANCE(820);
      END_STATE();
    case 1716:
      if (lookahead == 'r') ADVANCE(542);
      END_STATE();
    case 1717:
      if (lookahead == 'r') ADVANCE(457);
      END_STATE();
    case 1718:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 1719:
      if (lookahead == 'r') ADVANCE(1130);
      END_STATE();
    case 1720:
      if (lookahead == 'r') ADVANCE(1795);
      END_STATE();
    case 1721:
      if (lookahead == 'r') ADVANCE(696);
      END_STATE();
    case 1722:
      if (lookahead == 'r') ADVANCE(1875);
      END_STATE();
    case 1723:
      if (lookahead == 'r') ADVANCE(866);
      END_STATE();
    case 1724:
      if (lookahead == 'r') ADVANCE(996);
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 1725:
      if (lookahead == 'r') ADVANCE(1858);
      END_STATE();
    case 1726:
      if (lookahead == 'r') ADVANCE(1920);
      END_STATE();
    case 1727:
      if (lookahead == 'r') ADVANCE(1797);
      END_STATE();
    case 1728:
      if (lookahead == 'r') ADVANCE(873);
      END_STATE();
    case 1729:
      if (lookahead == 'r') ADVANCE(890);
      END_STATE();
    case 1730:
      if (lookahead == 'r') ADVANCE(1675);
      END_STATE();
    case 1731:
      if (lookahead == 'r') ADVANCE(481);
      END_STATE();
    case 1732:
      if (lookahead == 'r') ADVANCE(1873);
      END_STATE();
    case 1733:
      if (lookahead == 'r') ADVANCE(1689);
      END_STATE();
    case 1734:
      if (lookahead == 'r') ADVANCE(1699);
      END_STATE();
    case 1735:
      if (lookahead == 'r') ADVANCE(1703);
      END_STATE();
    case 1736:
      if (lookahead == 'r') ADVANCE(1704);
      END_STATE();
    case 1737:
      if (lookahead == 'r') ADVANCE(1705);
      END_STATE();
    case 1738:
      if (lookahead == 'r') ADVANCE(1709);
      END_STATE();
    case 1739:
      if (lookahead == 'r') ADVANCE(908);
      END_STATE();
    case 1740:
      if (lookahead == 'r') ADVANCE(720);
      END_STATE();
    case 1741:
      if (lookahead == 'r') ADVANCE(931);
      END_STATE();
    case 1742:
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 1743:
      if (lookahead == 'r') ADVANCE(1577);
      END_STATE();
    case 1744:
      if (lookahead == 'r') ADVANCE(1896);
      END_STATE();
    case 1745:
      if (lookahead == 'r') ADVANCE(1579);
      END_STATE();
    case 1746:
      if (lookahead == 'r') ADVANCE(940);
      END_STATE();
    case 1747:
      if (lookahead == 'r') ADVANCE(941);
      END_STATE();
    case 1748:
      if (lookahead == 'r') ADVANCE(942);
      END_STATE();
    case 1749:
      if (lookahead == 'r') ADVANCE(1182);
      END_STATE();
    case 1750:
      if (lookahead == 'r') ADVANCE(1184);
      END_STATE();
    case 1751:
      if (lookahead == 'r') ADVANCE(1185);
      END_STATE();
    case 1752:
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 1753:
      if (lookahead == 's') ADVANCE(900);
      END_STATE();
    case 1754:
      if (lookahead == 's') ADVANCE(175);
      if (lookahead == 'u') ADVANCE(1338);
      END_STATE();
    case 1755:
      if (lookahead == 's') ADVANCE(323);
      END_STATE();
    case 1756:
      if (lookahead == 's') ADVANCE(349);
      END_STATE();
    case 1757:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 1758:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 1759:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 1760:
      if (lookahead == 's') ADVANCE(38);
      END_STATE();
    case 1761:
      if (lookahead == 's') ADVANCE(40);
      END_STATE();
    case 1762:
      if (lookahead == 's') ADVANCE(39);
      END_STATE();
    case 1763:
      if (lookahead == 's') ADVANCE(1807);
      END_STATE();
    case 1764:
      if (lookahead == 's') ADVANCE(343);
      END_STATE();
    case 1765:
      if (lookahead == 's') ADVANCE(1472);
      END_STATE();
    case 1766:
      if (lookahead == 's') ADVANCE(140);
      END_STATE();
    case 1767:
      if (lookahead == 's') ADVANCE(1072);
      END_STATE();
    case 1768:
      if (lookahead == 's') ADVANCE(357);
      END_STATE();
    case 1769:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 1770:
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 1771:
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 1772:
      if (lookahead == 's') ADVANCE(1526);
      END_STATE();
    case 1773:
      if (lookahead == 's') ADVANCE(1032);
      END_STATE();
    case 1774:
      if (lookahead == 's') ADVANCE(1997);
      END_STATE();
    case 1775:
      if (lookahead == 's') ADVANCE(192);
      END_STATE();
    case 1776:
      if (lookahead == 's') ADVANCE(1033);
      END_STATE();
    case 1777:
      if (lookahead == 's') ADVANCE(1037);
      END_STATE();
    case 1778:
      if (lookahead == 's') ADVANCE(1752);
      END_STATE();
    case 1779:
      if (lookahead == 's') ADVANCE(1108);
      END_STATE();
    case 1780:
      if (lookahead == 's') ADVANCE(1207);
      END_STATE();
    case 1781:
      if (lookahead == 's') ADVANCE(1901);
      END_STATE();
    case 1782:
      if (lookahead == 's') ADVANCE(743);
      END_STATE();
    case 1783:
      if (lookahead == 's') ADVANCE(775);
      END_STATE();
    case 1784:
      if (lookahead == 's') ADVANCE(823);
      END_STATE();
    case 1785:
      if (lookahead == 's') ADVANCE(1950);
      END_STATE();
    case 1786:
      if (lookahead == 's') ADVANCE(1906);
      END_STATE();
    case 1787:
      if (lookahead == 's') ADVANCE(1852);
      END_STATE();
    case 1788:
      if (lookahead == 's') ADVANCE(1233);
      END_STATE();
    case 1789:
      if (lookahead == 's') ADVANCE(1764);
      END_STATE();
    case 1790:
      if (lookahead == 's') ADVANCE(1842);
      END_STATE();
    case 1791:
      if (lookahead == 's') ADVANCE(1845);
      END_STATE();
    case 1792:
      if (lookahead == 's') ADVANCE(1170);
      END_STATE();
    case 1793:
      if (lookahead == 's') ADVANCE(1839);
      END_STATE();
    case 1794:
      if (lookahead == 's') ADVANCE(860);
      END_STATE();
    case 1795:
      if (lookahead == 's') ADVANCE(799);
      END_STATE();
    case 1796:
      if (lookahead == 's') ADVANCE(830);
      END_STATE();
    case 1797:
      if (lookahead == 's') ADVANCE(819);
      END_STATE();
    case 1798:
      if (lookahead == 's') ADVANCE(1042);
      END_STATE();
    case 1799:
      if (lookahead == 's') ADVANCE(1908);
      END_STATE();
    case 1800:
      if (lookahead == 's') ADVANCE(1863);
      END_STATE();
    case 1801:
      if (lookahead == 's') ADVANCE(1851);
      END_STATE();
    case 1802:
      if (lookahead == 's') ADVANCE(865);
      END_STATE();
    case 1803:
      if (lookahead == 's') ADVANCE(1117);
      END_STATE();
    case 1804:
      if (lookahead == 's') ADVANCE(880);
      END_STATE();
    case 1805:
      if (lookahead == 's') ADVANCE(936);
      END_STATE();
    case 1806:
      if (lookahead == 't') ADVANCE(1987);
      END_STATE();
    case 1807:
      if (lookahead == 't') ADVANCE(13);
      END_STATE();
    case 1808:
      if (lookahead == 't') ADVANCE(13);
      if (lookahead == 'u') ADVANCE(600);
      END_STATE();
    case 1809:
      if (lookahead == 't') ADVANCE(13);
      if (lookahead == 'w') ADVANCE(1369);
      END_STATE();
    case 1810:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 1811:
      if (lookahead == 't') ADVANCE(365);
      END_STATE();
    case 1812:
      if (lookahead == 't') ADVANCE(550);
      END_STATE();
    case 1813:
      if (lookahead == 't') ADVANCE(220);
      END_STATE();
    case 1814:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 1815:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 1816:
      if (lookahead == 't') ADVANCE(549);
      END_STATE();
    case 1817:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 1818:
      if (lookahead == 't') ADVANCE(1005);
      END_STATE();
    case 1819:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 1820:
      if (lookahead == 't') ADVANCE(371);
      END_STATE();
    case 1821:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 1822:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 1823:
      if (lookahead == 't') ADVANCE(375);
      END_STATE();
    case 1824:
      if (lookahead == 't') ADVANCE(557);
      END_STATE();
    case 1825:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 1826:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 1827:
      if (lookahead == 't') ADVANCE(1599);
      END_STATE();
    case 1828:
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 1829:
      if (lookahead == 't') ADVANCE(857);
      END_STATE();
    case 1830:
      if (lookahead == 't') ADVANCE(35);
      END_STATE();
    case 1831:
      if (lookahead == 't') ADVANCE(1327);
      END_STATE();
    case 1832:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 1833:
      if (lookahead == 't') ADVANCE(603);
      END_STATE();
    case 1834:
      if (lookahead == 't') ADVANCE(1988);
      END_STATE();
    case 1835:
      if (lookahead == 't') ADVANCE(112);
      if (lookahead == 'v') ADVANCE(1144);
      END_STATE();
    case 1836:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 1837:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 1838:
      if (lookahead == 't') ADVANCE(546);
      END_STATE();
    case 1839:
      if (lookahead == 't') ADVANCE(1437);
      END_STATE();
    case 1840:
      if (lookahead == 't') ADVANCE(884);
      END_STATE();
    case 1841:
      if (lookahead == 't') ADVANCE(372);
      END_STATE();
    case 1842:
      if (lookahead == 't') ADVANCE(71);
      END_STATE();
    case 1843:
      if (lookahead == 't') ADVANCE(1992);
      END_STATE();
    case 1844:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 1845:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 1846:
      if (lookahead == 't') ADVANCE(1032);
      END_STATE();
    case 1847:
      if (lookahead == 't') ADVANCE(1993);
      END_STATE();
    case 1848:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 1849:
      if (lookahead == 't') ADVANCE(1037);
      END_STATE();
    case 1850:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 1851:
      if (lookahead == 't') ADVANCE(1752);
      END_STATE();
    case 1852:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 1853:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 1854:
      if (lookahead == 't') ADVANCE(1034);
      END_STATE();
    case 1855:
      if (lookahead == 't') ADVANCE(1335);
      END_STATE();
    case 1856:
      if (lookahead == 't') ADVANCE(775);
      END_STATE();
    case 1857:
      if (lookahead == 't') ADVANCE(1507);
      END_STATE();
    case 1858:
      if (lookahead == 't') ADVANCE(1758);
      END_STATE();
    case 1859:
      if (lookahead == 't') ADVANCE(1062);
      END_STATE();
    case 1860:
      if (lookahead == 't') ADVANCE(1350);
      END_STATE();
    case 1861:
      if (lookahead == 't') ADVANCE(807);
      END_STATE();
    case 1862:
      if (lookahead == 't') ADVANCE(1784);
      END_STATE();
    case 1863:
      if (lookahead == 't') ADVANCE(848);
      END_STATE();
    case 1864:
      if (lookahead == 't') ADVANCE(1446);
      END_STATE();
    case 1865:
      if (lookahead == 't') ADVANCE(1634);
      END_STATE();
    case 1866:
      if (lookahead == 't') ADVANCE(483);
      END_STATE();
    case 1867:
      if (lookahead == 't') ADVANCE(1143);
      END_STATE();
    case 1868:
      if (lookahead == 't') ADVANCE(1120);
      END_STATE();
    case 1869:
      if (lookahead == 't') ADVANCE(1154);
      END_STATE();
    case 1870:
      if (lookahead == 't') ADVANCE(1443);
      END_STATE();
    case 1871:
      if (lookahead == 't') ADVANCE(1145);
      END_STATE();
    case 1872:
      if (lookahead == 't') ADVANCE(1168);
      END_STATE();
    case 1873:
      if (lookahead == 't') ADVANCE(1162);
      END_STATE();
    case 1874:
      if (lookahead == 't') ADVANCE(1122);
      END_STATE();
    case 1875:
      if (lookahead == 't') ADVANCE(1602);
      END_STATE();
    case 1876:
      if (lookahead == 't') ADVANCE(934);
      END_STATE();
    case 1877:
      if (lookahead == 't') ADVANCE(555);
      END_STATE();
    case 1878:
      if (lookahead == 't') ADVANCE(1402);
      END_STATE();
    case 1879:
      if (lookahead == 't') ADVANCE(1107);
      END_STATE();
    case 1880:
      if (lookahead == 't') ADVANCE(1500);
      END_STATE();
    case 1881:
      if (lookahead == 't') ADVANCE(1403);
      END_STATE();
    case 1882:
      if (lookahead == 't') ADVANCE(1687);
      END_STATE();
    case 1883:
      if (lookahead == 't') ADVANCE(883);
      END_STATE();
    case 1884:
      if (lookahead == 't') ADVANCE(491);
      END_STATE();
    case 1885:
      if (lookahead == 't') ADVANCE(1084);
      END_STATE();
    case 1886:
      if (lookahead == 't') ADVANCE(885);
      END_STATE();
    case 1887:
      if (lookahead == 't') ADVANCE(887);
      END_STATE();
    case 1888:
      if (lookahead == 't') ADVANCE(889);
      END_STATE();
    case 1889:
      if (lookahead == 't') ADVANCE(892);
      END_STATE();
    case 1890:
      if (lookahead == 't') ADVANCE(910);
      END_STATE();
    case 1891:
      if (lookahead == 't') ADVANCE(894);
      END_STATE();
    case 1892:
      if (lookahead == 't') ADVANCE(1063);
      END_STATE();
    case 1893:
      if (lookahead == 't') ADVANCE(534);
      END_STATE();
    case 1894:
      if (lookahead == 't') ADVANCE(1153);
      END_STATE();
    case 1895:
      if (lookahead == 't') ADVANCE(1159);
      END_STATE();
    case 1896:
      if (lookahead == 't') ADVANCE(1169);
      END_STATE();
    case 1897:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 1898:
      if (lookahead == 't') ADVANCE(543);
      END_STATE();
    case 1899:
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 1900:
      if (lookahead == 'u') ADVANCE(471);
      END_STATE();
    case 1901:
      if (lookahead == 'u') ADVANCE(2011);
      END_STATE();
    case 1902:
      if (lookahead == 'u') ADVANCE(1437);
      END_STATE();
    case 1903:
      if (lookahead == 'u') ADVANCE(164);
      END_STATE();
    case 1904:
      if (lookahead == 'u') ADVANCE(573);
      END_STATE();
    case 1905:
      if (lookahead == 'u') ADVANCE(586);
      END_STATE();
    case 1906:
      if (lookahead == 'u') ADVANCE(584);
      END_STATE();
    case 1907:
      if (lookahead == 'u') ADVANCE(1526);
      END_STATE();
    case 1908:
      if (lookahead == 'u') ADVANCE(567);
      END_STATE();
    case 1909:
      if (lookahead == 'u') ADVANCE(1756);
      END_STATE();
    case 1910:
      if (lookahead == 'u') ADVANCE(591);
      END_STATE();
    case 1911:
      if (lookahead == 'u') ADVANCE(1844);
      END_STATE();
    case 1912:
      if (lookahead == 'u') ADVANCE(1844);
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1913:
      if (lookahead == 'u') ADVANCE(1312);
      END_STATE();
    case 1914:
      if (lookahead == 'u') ADVANCE(1752);
      END_STATE();
    case 1915:
      if (lookahead == 'u') ADVANCE(858);
      END_STATE();
    case 1916:
      if (lookahead == 'u') ADVANCE(1768);
      END_STATE();
    case 1917:
      if (lookahead == 'u') ADVANCE(775);
      END_STATE();
    case 1918:
      if (lookahead == 'u') ADVANCE(1315);
      END_STATE();
    case 1919:
      if (lookahead == 'u') ADVANCE(656);
      END_STATE();
    case 1920:
      if (lookahead == 'u') ADVANCE(809);
      END_STATE();
    case 1921:
      if (lookahead == 'u') ADVANCE(449);
      END_STATE();
    case 1922:
      if (lookahead == 'u') ADVANCE(1759);
      END_STATE();
    case 1923:
      if (lookahead == 'u') ADVANCE(1438);
      END_STATE();
    case 1924:
      if (lookahead == 'u') ADVANCE(1223);
      END_STATE();
    case 1925:
      if (lookahead == 'u') ADVANCE(1783);
      END_STATE();
    case 1926:
      if (lookahead == 'u') ADVANCE(690);
      END_STATE();
    case 1927:
      if (lookahead == 'u') ADVANCE(1770);
      END_STATE();
    case 1928:
      if (lookahead == 'u') ADVANCE(1091);
      END_STATE();
    case 1929:
      if (lookahead == 'u') ADVANCE(843);
      END_STATE();
    case 1930:
      if (lookahead == 'u') ADVANCE(470);
      END_STATE();
    case 1931:
      if (lookahead == 'u') ADVANCE(1156);
      END_STATE();
    case 1932:
      if (lookahead == 'u') ADVANCE(1090);
      END_STATE();
    case 1933:
      if (lookahead == 'u') ADVANCE(1630);
      END_STATE();
    case 1934:
      if (lookahead == 'u') ADVANCE(1602);
      END_STATE();
    case 1935:
      if (lookahead == 'u') ADVANCE(1631);
      END_STATE();
    case 1936:
      if (lookahead == 'u') ADVANCE(1695);
      END_STATE();
    case 1937:
      if (lookahead == 'u') ADVANCE(1697);
      END_STATE();
    case 1938:
      if (lookahead == 'u') ADVANCE(1042);
      END_STATE();
    case 1939:
      if (lookahead == 'u') ADVANCE(1325);
      END_STATE();
    case 1940:
      if (lookahead == 'u') ADVANCE(1396);
      END_STATE();
    case 1941:
      if (lookahead == 'u') ADVANCE(1790);
      END_STATE();
    case 1942:
      if (lookahead == 'u') ADVANCE(1125);
      END_STATE();
    case 1943:
      if (lookahead == 'u') ADVANCE(1249);
      END_STATE();
    case 1944:
      if (lookahead == 'u') ADVANCE(1856);
      END_STATE();
    case 1945:
      if (lookahead == 'u') ADVANCE(490);
      END_STATE();
    case 1946:
      if (lookahead == 'u') ADVANCE(1265);
      END_STATE();
    case 1947:
      if (lookahead == 'u') ADVANCE(1511);
      END_STATE();
    case 1948:
      if (lookahead == 'u') ADVANCE(1323);
      END_STATE();
    case 1949:
      if (lookahead == 'u') ADVANCE(496);
      END_STATE();
    case 1950:
      if (lookahead == 'u') ADVANCE(1711);
      END_STATE();
    case 1951:
      if (lookahead == 'u') ADVANCE(1304);
      END_STATE();
    case 1952:
      if (lookahead == 'u') ADVANCE(539);
      END_STATE();
    case 1953:
      if (lookahead == 'u') ADVANCE(597);
      END_STATE();
    case 1954:
      if (lookahead == 'u') ADVANCE(541);
      END_STATE();
    case 1955:
      if (lookahead == 'u') ADVANCE(596);
      if (lookahead == 'w') ADVANCE(1363);
      END_STATE();
    case 1956:
      if (lookahead == 'u') ADVANCE(599);
      END_STATE();
    case 1957:
      if (lookahead == 'v') ADVANCE(13);
      END_STATE();
    case 1958:
      if (lookahead == 'v') ADVANCE(13);
      if (lookahead == 'w') ADVANCE(774);
      END_STATE();
    case 1959:
      if (lookahead == 'v') ADVANCE(27);
      END_STATE();
    case 1960:
      if (lookahead == 'v') ADVANCE(106);
      END_STATE();
    case 1961:
      if (lookahead == 'v') ADVANCE(852);
      if (lookahead == 'w') ADVANCE(851);
      END_STATE();
    case 1962:
      if (lookahead == 'v') ADVANCE(775);
      END_STATE();
    case 1963:
      if (lookahead == 'v') ADVANCE(800);
      END_STATE();
    case 1964:
      if (lookahead == 'v') ADVANCE(938);
      END_STATE();
    case 1965:
      if (lookahead == 'w') ADVANCE(13);
      END_STATE();
    case 1966:
      if (lookahead == 'w') ADVANCE(19);
      END_STATE();
    case 1967:
      if (lookahead == 'w') ADVANCE(23);
      END_STATE();
    case 1968:
      if (lookahead == 'w') ADVANCE(22);
      END_STATE();
    case 1969:
      if (lookahead == 'w') ADVANCE(21);
      END_STATE();
    case 1970:
      if (lookahead == 'w') ADVANCE(1437);
      END_STATE();
    case 1971:
      if (lookahead == 'w') ADVANCE(396);
      END_STATE();
    case 1972:
      if (lookahead == 'w') ADVANCE(187);
      END_STATE();
    case 1973:
      if (lookahead == 'w') ADVANCE(815);
      END_STATE();
    case 1974:
      if (lookahead == 'w') ADVANCE(1752);
      END_STATE();
    case 1975:
      if (lookahead == 'w') ADVANCE(1353);
      END_STATE();
    case 1976:
      if (lookahead == 'w') ADVANCE(1369);
      END_STATE();
    case 1977:
      if (lookahead == 'w') ADVANCE(1367);
      END_STATE();
    case 1978:
      if (lookahead == 'w') ADVANCE(1364);
      END_STATE();
    case 1979:
      if (lookahead == 'w') ADVANCE(1151);
      END_STATE();
    case 1980:
      if (lookahead == 'w') ADVANCE(205);
      END_STATE();
    case 1981:
      if (lookahead == 'w') ADVANCE(1277);
      END_STATE();
    case 1982:
      if (lookahead == 'w') ADVANCE(1435);
      END_STATE();
    case 1983:
      if (lookahead == 'w') ADVANCE(1434);
      END_STATE();
    case 1984:
      if (lookahead == 'x') ADVANCE(13);
      END_STATE();
    case 1985:
      if (lookahead == 'x') ADVANCE(1807);
      END_STATE();
    case 1986:
      if (lookahead == 'x') ADVANCE(115);
      END_STATE();
    case 1987:
      if (lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 1988:
      if (lookahead == 'y') ADVANCE(364);
      END_STATE();
    case 1989:
      if (lookahead == 'y') ADVANCE(834);
      END_STATE();
    case 1990:
      if (lookahead == 'y') ADVANCE(311);
      END_STATE();
    case 1991:
      if (lookahead == 'y') ADVANCE(326);
      END_STATE();
    case 1992:
      if (lookahead == 'y') ADVANCE(195);
      END_STATE();
    case 1993:
      if (lookahead == 'y') ADVANCE(1957);
      END_STATE();
    case 1994:
      if (lookahead == 'y') ADVANCE(363);
      END_STATE();
    case 1995:
      if (lookahead == 'y') ADVANCE(369);
      END_STATE();
    case 1996:
      if (lookahead == 'y') ADVANCE(339);
      END_STATE();
    case 1997:
      if (lookahead == 'y') ADVANCE(1312);
      END_STATE();
    case 1998:
      if (lookahead == 'y') ADVANCE(774);
      END_STATE();
    case 1999:
      if (lookahead == 'y') ADVANCE(1752);
      END_STATE();
    case 2000:
      if (lookahead == 'y') ADVANCE(823);
      END_STATE();
    case 2001:
      if (lookahead == 'z') ADVANCE(1514);
      END_STATE();
    case 2002:
      if (lookahead == 'z') ADVANCE(427);
      END_STATE();
    case 2003:
      if (lookahead == 'z') ADVANCE(1130);
      END_STATE();
    case 2004:
      if (lookahead == 'z') ADVANCE(861);
      END_STATE();
    case 2005:
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(13);
      END_STATE();
    case 2006:
      if (lookahead == '3' ||
          lookahead == '5') ADVANCE(13);
      END_STATE();
    case 2007:
      if (lookahead == '6' ||
          lookahead == '8') ADVANCE(13);
      END_STATE();
    case 2008:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(13);
      END_STATE();
    case 2009:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(2029);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(238);
      END_STATE();
    case 2010:
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(13);
      if (lookahead == 'w') ADVANCE(903);
      END_STATE();
    case 2011:
      if (lookahead == 'b' ||
          lookahead == 'p') ADVANCE(13);
      END_STATE();
    case 2012:
      if (lookahead == 'b' ||
          lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 2013:
      if (lookahead == 'd' ||
          lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 2014:
      if (lookahead == 'e' ||
          lookahead == 'k') ADVANCE(13);
      END_STATE();
    case 2015:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(13);
      END_STATE();
    case 2016:
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 2017:
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 2018:
      if (lookahead == 'o' ||
          lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 2019:
      if (lookahead == 'r' ||
          lookahead == 'y') ADVANCE(13);
      END_STATE();
    case 2020:
      if (lookahead == '3' ||
          lookahead == '4') ADVANCE(13);
      END_STATE();
    case 2021:
      if (lookahead == 'R' ||
          lookahead == 'S') ADVANCE(13);
      if (lookahead == 'a') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1138);
      if (lookahead == 'd') ADVANCE(429);
      END_STATE();
    case 2022:
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(13);
      END_STATE();
    case 2023:
      if (lookahead == '4' ||
          lookahead == '5' ||
          lookahead == '8') ADVANCE(13);
      if (lookahead == ';') ADVANCE(2033);
      END_STATE();
    case 2024:
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(13);
      END_STATE();
    case 2025:
      if (lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(13);
      END_STATE();
    case 2026:
      if (('1' <= lookahead && lookahead <= '3') ||
          lookahead == 'E') ADVANCE(13);
      if (lookahead == ';') ADVANCE(2033);
      if (lookahead == 'd') ADVANCE(1448);
      if (lookahead == 'e') ADVANCE(98);
      if (lookahead == 'h') ADVANCE(1765);
      if (lookahead == 'l') ADVANCE(433);
      if (lookahead == 'm') ADVANCE(1924);
      if (lookahead == 'n') ADVANCE(2008);
      if (lookahead == 'p') ADVANCE(1297);
      if (lookahead == 's') ADVANCE(875);
      END_STATE();
    case 2027:
      if (('2' <= lookahead && lookahead <= '6') ||
          lookahead == '8') ADVANCE(13);
      if (lookahead == ';') ADVANCE(2033);
      END_STATE();
    case 2028:
      if (('a' <= lookahead && lookahead <= 'h')) ADVANCE(13);
      END_STATE();
    case 2029:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(243);
      END_STATE();
    case 2030:
      if (eof) ADVANCE(2031);
      if (lookahead == '!') ADVANCE(2040);
      if (lookahead == '"') ADVANCE(2041);
      if (lookahead == '#') ADVANCE(2042);
      if (lookahead == '$') ADVANCE(2043);
      if (lookahead == '%') ADVANCE(2044);
      if (lookahead == '&') ADVANCE(2045);
      if (lookahead == '\'') ADVANCE(2047);
      if (lookahead == '(') ADVANCE(2070);
      if (lookahead == ')') ADVANCE(2071);
      if (lookahead == '*') ADVANCE(2048);
      if (lookahead == '+') ADVANCE(2049);
      if (lookahead == ',') ADVANCE(2050);
      if (lookahead == '-') ADVANCE(2051);
      if (lookahead == '.') ADVANCE(2053);
      if (lookahead == '/') ADVANCE(2054);
      if (lookahead == ':') ADVANCE(2055);
      if (lookahead == ';') ADVANCE(2056);
      if (lookahead == '<') ADVANCE(2038);
      if (lookahead == '=') ADVANCE(2057);
      if (lookahead == '>') ADVANCE(2039);
      if (lookahead == '?') ADVANCE(2058);
      if (lookahead == '@') ADVANCE(2060);
      if (lookahead == '[') ADVANCE(2035);
      if (lookahead == '\\') ADVANCE(2061);
      if (lookahead == ']') ADVANCE(2036);
      if (lookahead == '^') ADVANCE(2063);
      if (lookahead == '_') ADVANCE(2064);
      if (lookahead == '`') ADVANCE(2065);
      if (lookahead == '{') ADVANCE(2066);
      if (lookahead == '|') ADVANCE(2067);
      if (lookahead == '}') ADVANCE(2068);
      if (lookahead == '~') ADVANCE(2069);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(2077);
      END_STATE();
    case 2031:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2032:
      ACCEPT_TOKEN(sym__backslash_escape);
      END_STATE();
    case 2033:
      ACCEPT_TOKEN(sym_entity_reference);
      END_STATE();
    case 2034:
      ACCEPT_TOKEN(sym_numeric_character_reference);
      END_STATE();
    case 2035:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == 'x') ADVANCE(377);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(378);
      END_STATE();
    case 2036:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 2037:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']') ADVANCE(245);
      END_STATE();
    case 2038:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 2039:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 2040:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 2041:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 2042:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 2043:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 2044:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 2045:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 2046:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '#') ADVANCE(2009);
      if (lookahead == 'A') ADVANCE(312);
      if (lookahead == 'B') ADVANCE(381);
      if (lookahead == 'C') ADVANCE(335);
      if (lookahead == 'D') ADVANCE(296);
      if (lookahead == 'E') ADVANCE(351);
      if (lookahead == 'F') ADVANCE(606);
      if (lookahead == 'G') ADVANCE(45);
      if (lookahead == 'H') ADVANCE(246);
      if (lookahead == 'I') ADVANCE(318);
      if (lookahead == 'J') ADVANCE(708);
      if (lookahead == 'K') ADVANCE(334);
      if (lookahead == 'L') ADVANCE(44);
      if (lookahead == 'M') ADVANCE(423);
      if (lookahead == 'N') ADVANCE(342);
      if (lookahead == 'O') ADVANCE(320);
      if (lookahead == 'P') ADVANCE(419);
      if (lookahead == 'Q') ADVANCE(373);
      if (lookahead == 'R') ADVANCE(277);
      if (lookahead == 'S') ADVANCE(331);
      if (lookahead == 'T') ADVANCE(332);
      if (lookahead == 'U') ADVANCE(400);
      if (lookahead == 'V') ADVANCE(304);
      if (lookahead == 'W') ADVANCE(660);
      if (lookahead == 'X') ADVANCE(948);
      if (lookahead == 'Y') ADVANCE(248);
      if (lookahead == 'Z') ADVANCE(336);
      if (lookahead == 'a') ADVANCE(379);
      if (lookahead == 'b') ADVANCE(350);
      if (lookahead == 'c') ADVANCE(386);
      if (lookahead == 'd') ADVANCE(253);
      if (lookahead == 'e') ADVANCE(298);
      if (lookahead == 'f') ADVANCE(428);
      if (lookahead == 'g') ADVANCE(34);
      if (lookahead == 'h') ADVANCE(255);
      if (lookahead == 'i') ADVANCE(380);
      if (lookahead == 'j') ADVANCE(707);
      if (lookahead == 'k') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(328);
      if (lookahead == 'o') ADVANCE(362);
      if (lookahead == 'p') ADVANCE(450);
      if (lookahead == 'q') ADVANCE(949);
      if (lookahead == 'r') ADVANCE(247);
      if (lookahead == 's') ADVANCE(507);
      if (lookahead == 't') ADVANCE(403);
      if (lookahead == 'u') ADVANCE(254);
      if (lookahead == 'v') ADVANCE(251);
      if (lookahead == 'w') ADVANCE(659);
      if (lookahead == 'x') ADVANCE(615);
      if (lookahead == 'y') ADVANCE(418);
      if (lookahead == 'z') ADVANCE(508);
      END_STATE();
    case 2047:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 2048:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 2049:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 2050:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 2051:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 2052:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(244);
      END_STATE();
    case 2053:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 2054:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 2055:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 2056:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 2057:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 2058:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 2059:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(2075);
      END_STATE();
    case 2060:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 2061:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 2062:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (('!' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          ('[' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(2032);
      END_STATE();
    case 2063:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 2064:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2065:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 2066:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 2067:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 2068:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 2069:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 2070:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 2071:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 2072:
      ACCEPT_TOKEN(sym__newline_token);
      END_STATE();
    case 2073:
      ACCEPT_TOKEN(sym__newline_token);
      if (lookahead == '\n') ADVANCE(2072);
      END_STATE();
    case 2074:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_GT);
      END_STATE();
    case 2075:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 2076:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK_GT);
      END_STATE();
    case 2077:
      ACCEPT_TOKEN(aux_sym__word_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(2077);
      END_STATE();
    case 2078:
      ACCEPT_TOKEN(anon_sym_LBRACKx_RBRACK);
      END_STATE();
    case 2079:
      ACCEPT_TOKEN(aux_sym__word_token2);
      END_STATE();
    case 2080:
      ACCEPT_TOKEN(sym__whitespace);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2080);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 2030, .external_lex_state = 2},
  [2] = {.lex_state = 2030, .external_lex_state = 3},
  [3] = {.lex_state = 2030, .external_lex_state = 3},
  [4] = {.lex_state = 2030, .external_lex_state = 3},
  [5] = {.lex_state = 2030, .external_lex_state = 3},
  [6] = {.lex_state = 2030, .external_lex_state = 3},
  [7] = {.lex_state = 2030, .external_lex_state = 3},
  [8] = {.lex_state = 2030, .external_lex_state = 3},
  [9] = {.lex_state = 2030, .external_lex_state = 3},
  [10] = {.lex_state = 2030, .external_lex_state = 3},
  [11] = {.lex_state = 2030, .external_lex_state = 3},
  [12] = {.lex_state = 2030, .external_lex_state = 4},
  [13] = {.lex_state = 2030, .external_lex_state = 4},
  [14] = {.lex_state = 2030, .external_lex_state = 4},
  [15] = {.lex_state = 2030, .external_lex_state = 4},
  [16] = {.lex_state = 2030, .external_lex_state = 4},
  [17] = {.lex_state = 2030, .external_lex_state = 4},
  [18] = {.lex_state = 2030, .external_lex_state = 4},
  [19] = {.lex_state = 2030, .external_lex_state = 4},
  [20] = {.lex_state = 2030, .external_lex_state = 4},
  [21] = {.lex_state = 2030, .external_lex_state = 4},
  [22] = {.lex_state = 2030, .external_lex_state = 5},
  [23] = {.lex_state = 2030, .external_lex_state = 5},
  [24] = {.lex_state = 2030, .external_lex_state = 4},
  [25] = {.lex_state = 2030, .external_lex_state = 6},
  [26] = {.lex_state = 2030, .external_lex_state = 6},
  [27] = {.lex_state = 2030, .external_lex_state = 6},
  [28] = {.lex_state = 2030, .external_lex_state = 4},
  [29] = {.lex_state = 2030, .external_lex_state = 6},
  [30] = {.lex_state = 2030, .external_lex_state = 4},
  [31] = {.lex_state = 2030, .external_lex_state = 6},
  [32] = {.lex_state = 2030, .external_lex_state = 6},
  [33] = {.lex_state = 2030, .external_lex_state = 6},
  [34] = {.lex_state = 2030, .external_lex_state = 6},
  [35] = {.lex_state = 2030, .external_lex_state = 6},
  [36] = {.lex_state = 2030, .external_lex_state = 6},
  [37] = {.lex_state = 2030, .external_lex_state = 4},
  [38] = {.lex_state = 2030, .external_lex_state = 6},
  [39] = {.lex_state = 2030, .external_lex_state = 6},
  [40] = {.lex_state = 2030, .external_lex_state = 4},
  [41] = {.lex_state = 2030, .external_lex_state = 4},
  [42] = {.lex_state = 2030, .external_lex_state = 6},
  [43] = {.lex_state = 2030, .external_lex_state = 6},
  [44] = {.lex_state = 2030, .external_lex_state = 6},
  [45] = {.lex_state = 2030, .external_lex_state = 4},
  [46] = {.lex_state = 2030, .external_lex_state = 4},
  [47] = {.lex_state = 2030, .external_lex_state = 6},
  [48] = {.lex_state = 2030, .external_lex_state = 4},
  [49] = {.lex_state = 2030, .external_lex_state = 4},
  [50] = {.lex_state = 2030, .external_lex_state = 6},
  [51] = {.lex_state = 2030, .external_lex_state = 4},
  [52] = {.lex_state = 2030, .external_lex_state = 6},
  [53] = {.lex_state = 2030, .external_lex_state = 6},
  [54] = {.lex_state = 2030, .external_lex_state = 4},
  [55] = {.lex_state = 2030, .external_lex_state = 6},
  [56] = {.lex_state = 2030, .external_lex_state = 6},
  [57] = {.lex_state = 2030, .external_lex_state = 4},
  [58] = {.lex_state = 2030, .external_lex_state = 4},
  [59] = {.lex_state = 2030, .external_lex_state = 6},
  [60] = {.lex_state = 2030, .external_lex_state = 4},
  [61] = {.lex_state = 2030, .external_lex_state = 4},
  [62] = {.lex_state = 2030, .external_lex_state = 6},
  [63] = {.lex_state = 2030, .external_lex_state = 4},
  [64] = {.lex_state = 2030, .external_lex_state = 6},
  [65] = {.lex_state = 2030, .external_lex_state = 4},
  [66] = {.lex_state = 2030, .external_lex_state = 6},
  [67] = {.lex_state = 2030, .external_lex_state = 4},
  [68] = {.lex_state = 2030, .external_lex_state = 4},
  [69] = {.lex_state = 2030, .external_lex_state = 6},
  [70] = {.lex_state = 2030, .external_lex_state = 4},
  [71] = {.lex_state = 2030, .external_lex_state = 6},
  [72] = {.lex_state = 2030, .external_lex_state = 6},
  [73] = {.lex_state = 2030, .external_lex_state = 6},
  [74] = {.lex_state = 2030, .external_lex_state = 4},
  [75] = {.lex_state = 2030, .external_lex_state = 4},
  [76] = {.lex_state = 2030, .external_lex_state = 4},
  [77] = {.lex_state = 2030, .external_lex_state = 4},
  [78] = {.lex_state = 2030, .external_lex_state = 4},
  [79] = {.lex_state = 2030, .external_lex_state = 4},
  [80] = {.lex_state = 2030, .external_lex_state = 4},
  [81] = {.lex_state = 2030, .external_lex_state = 4},
  [82] = {.lex_state = 2030, .external_lex_state = 7},
  [83] = {.lex_state = 2030, .external_lex_state = 4},
  [84] = {.lex_state = 2030, .external_lex_state = 6},
  [85] = {.lex_state = 2030, .external_lex_state = 6},
  [86] = {.lex_state = 2030, .external_lex_state = 6},
  [87] = {.lex_state = 2030, .external_lex_state = 6},
  [88] = {.lex_state = 2030, .external_lex_state = 6},
  [89] = {.lex_state = 2030, .external_lex_state = 6},
  [90] = {.lex_state = 2030, .external_lex_state = 6},
  [91] = {.lex_state = 2030, .external_lex_state = 4},
  [92] = {.lex_state = 2030, .external_lex_state = 8},
  [93] = {.lex_state = 2030, .external_lex_state = 6},
  [94] = {.lex_state = 2030, .external_lex_state = 4},
  [95] = {.lex_state = 2030, .external_lex_state = 6},
  [96] = {.lex_state = 2030, .external_lex_state = 6},
  [97] = {.lex_state = 2030, .external_lex_state = 4},
  [98] = {.lex_state = 2030, .external_lex_state = 4},
  [99] = {.lex_state = 2030, .external_lex_state = 6},
  [100] = {.lex_state = 2030, .external_lex_state = 6},
  [101] = {.lex_state = 2030, .external_lex_state = 9},
  [102] = {.lex_state = 2030, .external_lex_state = 10},
  [103] = {.lex_state = 2030, .external_lex_state = 9},
  [104] = {.lex_state = 2030, .external_lex_state = 11},
  [105] = {.lex_state = 2030, .external_lex_state = 9},
  [106] = {.lex_state = 2030, .external_lex_state = 9},
  [107] = {.lex_state = 2030, .external_lex_state = 11},
  [108] = {.lex_state = 2030, .external_lex_state = 12},
  [109] = {.lex_state = 2030, .external_lex_state = 13},
  [110] = {.lex_state = 2030, .external_lex_state = 9},
  [111] = {.lex_state = 2030, .external_lex_state = 14},
  [112] = {.lex_state = 2030, .external_lex_state = 11},
  [113] = {.lex_state = 2030, .external_lex_state = 13},
  [114] = {.lex_state = 2030, .external_lex_state = 14},
  [115] = {.lex_state = 2030, .external_lex_state = 14},
  [116] = {.lex_state = 2030, .external_lex_state = 11},
  [117] = {.lex_state = 2030, .external_lex_state = 11},
  [118] = {.lex_state = 2030, .external_lex_state = 13},
  [119] = {.lex_state = 2030, .external_lex_state = 3},
  [120] = {.lex_state = 2030, .external_lex_state = 5},
  [121] = {.lex_state = 2030, .external_lex_state = 5},
  [122] = {.lex_state = 2030, .external_lex_state = 3},
  [123] = {.lex_state = 2030, .external_lex_state = 5},
  [124] = {.lex_state = 2030, .external_lex_state = 3},
  [125] = {.lex_state = 2030, .external_lex_state = 3},
  [126] = {.lex_state = 2030, .external_lex_state = 3},
  [127] = {.lex_state = 2030, .external_lex_state = 3},
  [128] = {.lex_state = 2030, .external_lex_state = 3},
  [129] = {.lex_state = 2030, .external_lex_state = 3},
  [130] = {.lex_state = 2030, .external_lex_state = 3},
  [131] = {.lex_state = 2030, .external_lex_state = 11},
  [132] = {.lex_state = 2030, .external_lex_state = 3},
  [133] = {.lex_state = 2030, .external_lex_state = 3},
  [134] = {.lex_state = 2030, .external_lex_state = 3},
  [135] = {.lex_state = 2030, .external_lex_state = 5},
  [136] = {.lex_state = 2030, .external_lex_state = 3},
  [137] = {.lex_state = 2030, .external_lex_state = 5},
  [138] = {.lex_state = 2030, .external_lex_state = 5},
  [139] = {.lex_state = 2030, .external_lex_state = 9},
  [140] = {.lex_state = 2030, .external_lex_state = 3},
  [141] = {.lex_state = 2030, .external_lex_state = 3},
  [142] = {.lex_state = 2030, .external_lex_state = 5},
  [143] = {.lex_state = 2030, .external_lex_state = 3},
  [144] = {.lex_state = 2030, .external_lex_state = 3},
  [145] = {.lex_state = 2030, .external_lex_state = 6},
  [146] = {.lex_state = 2030, .external_lex_state = 5},
  [147] = {.lex_state = 2030, .external_lex_state = 5},
  [148] = {.lex_state = 2030, .external_lex_state = 5},
  [149] = {.lex_state = 2030, .external_lex_state = 5},
  [150] = {.lex_state = 2030, .external_lex_state = 5},
  [151] = {.lex_state = 2030, .external_lex_state = 3},
  [152] = {.lex_state = 2030, .external_lex_state = 3},
  [153] = {.lex_state = 2030, .external_lex_state = 5},
  [154] = {.lex_state = 2030, .external_lex_state = 5},
  [155] = {.lex_state = 2030, .external_lex_state = 5},
  [156] = {.lex_state = 2030, .external_lex_state = 5},
  [157] = {.lex_state = 2030, .external_lex_state = 3},
  [158] = {.lex_state = 2030, .external_lex_state = 3},
  [159] = {.lex_state = 2030, .external_lex_state = 5},
  [160] = {.lex_state = 2030, .external_lex_state = 5},
  [161] = {.lex_state = 2030, .external_lex_state = 3},
  [162] = {.lex_state = 2030, .external_lex_state = 5},
  [163] = {.lex_state = 2030, .external_lex_state = 5},
  [164] = {.lex_state = 2030, .external_lex_state = 5},
  [165] = {.lex_state = 2030, .external_lex_state = 5},
  [166] = {.lex_state = 2030, .external_lex_state = 5},
  [167] = {.lex_state = 2030, .external_lex_state = 3},
  [168] = {.lex_state = 2030, .external_lex_state = 5},
  [169] = {.lex_state = 2030, .external_lex_state = 3},
  [170] = {.lex_state = 2030, .external_lex_state = 5},
  [171] = {.lex_state = 2030, .external_lex_state = 5},
  [172] = {.lex_state = 2030, .external_lex_state = 3},
  [173] = {.lex_state = 2030, .external_lex_state = 5},
  [174] = {.lex_state = 2030, .external_lex_state = 3},
  [175] = {.lex_state = 2030, .external_lex_state = 5},
  [176] = {.lex_state = 2030, .external_lex_state = 5},
  [177] = {.lex_state = 2030, .external_lex_state = 3},
  [178] = {.lex_state = 2030, .external_lex_state = 5},
  [179] = {.lex_state = 2030, .external_lex_state = 3},
  [180] = {.lex_state = 2030, .external_lex_state = 3},
  [181] = {.lex_state = 2030, .external_lex_state = 5},
  [182] = {.lex_state = 2030, .external_lex_state = 3},
  [183] = {.lex_state = 2030, .external_lex_state = 3},
  [184] = {.lex_state = 2030, .external_lex_state = 6},
  [185] = {.lex_state = 2030, .external_lex_state = 6},
  [186] = {.lex_state = 2030, .external_lex_state = 6},
  [187] = {.lex_state = 2030, .external_lex_state = 6},
  [188] = {.lex_state = 2030, .external_lex_state = 6},
  [189] = {.lex_state = 2030, .external_lex_state = 6},
  [190] = {.lex_state = 2030, .external_lex_state = 6},
  [191] = {.lex_state = 2030, .external_lex_state = 4},
  [192] = {.lex_state = 2030, .external_lex_state = 6},
  [193] = {.lex_state = 2030, .external_lex_state = 4},
  [194] = {.lex_state = 2030, .external_lex_state = 6},
  [195] = {.lex_state = 2030, .external_lex_state = 4},
  [196] = {.lex_state = 2030, .external_lex_state = 4},
  [197] = {.lex_state = 2030, .external_lex_state = 4},
  [198] = {.lex_state = 2030, .external_lex_state = 4},
  [199] = {.lex_state = 2030, .external_lex_state = 4},
  [200] = {.lex_state = 2030, .external_lex_state = 4},
  [201] = {.lex_state = 2030, .external_lex_state = 6},
  [202] = {.lex_state = 2030, .external_lex_state = 6},
  [203] = {.lex_state = 2030, .external_lex_state = 6},
  [204] = {.lex_state = 2030, .external_lex_state = 6},
  [205] = {.lex_state = 2030, .external_lex_state = 4},
  [206] = {.lex_state = 2030, .external_lex_state = 6},
  [207] = {.lex_state = 2030, .external_lex_state = 6},
  [208] = {.lex_state = 2030, .external_lex_state = 6},
  [209] = {.lex_state = 2030, .external_lex_state = 6},
  [210] = {.lex_state = 2030, .external_lex_state = 6},
  [211] = {.lex_state = 2030, .external_lex_state = 6},
  [212] = {.lex_state = 2030, .external_lex_state = 4},
  [213] = {.lex_state = 2030, .external_lex_state = 6},
  [214] = {.lex_state = 2030, .external_lex_state = 6},
  [215] = {.lex_state = 2030, .external_lex_state = 4},
  [216] = {.lex_state = 2030, .external_lex_state = 6},
  [217] = {.lex_state = 2030, .external_lex_state = 6},
  [218] = {.lex_state = 2030, .external_lex_state = 4},
  [219] = {.lex_state = 2030, .external_lex_state = 6},
  [220] = {.lex_state = 2030, .external_lex_state = 6},
  [221] = {.lex_state = 2030, .external_lex_state = 4},
  [222] = {.lex_state = 2030, .external_lex_state = 6},
  [223] = {.lex_state = 2030, .external_lex_state = 6},
  [224] = {.lex_state = 2030, .external_lex_state = 4},
  [225] = {.lex_state = 2030, .external_lex_state = 6},
  [226] = {.lex_state = 2030, .external_lex_state = 6},
  [227] = {.lex_state = 2030, .external_lex_state = 4},
  [228] = {.lex_state = 2030, .external_lex_state = 6},
  [229] = {.lex_state = 2030, .external_lex_state = 4},
  [230] = {.lex_state = 2030, .external_lex_state = 6},
  [231] = {.lex_state = 2030, .external_lex_state = 3},
  [232] = {.lex_state = 2030, .external_lex_state = 3},
  [233] = {.lex_state = 2030, .external_lex_state = 6},
  [234] = {.lex_state = 2030, .external_lex_state = 6},
  [235] = {.lex_state = 2030, .external_lex_state = 6},
  [236] = {.lex_state = 2030, .external_lex_state = 6},
  [237] = {.lex_state = 2030, .external_lex_state = 6},
  [238] = {.lex_state = 2030, .external_lex_state = 6},
  [239] = {.lex_state = 2030, .external_lex_state = 6},
  [240] = {.lex_state = 2030, .external_lex_state = 6},
  [241] = {.lex_state = 2030, .external_lex_state = 6},
  [242] = {.lex_state = 2030, .external_lex_state = 6},
  [243] = {.lex_state = 2030, .external_lex_state = 6},
  [244] = {.lex_state = 2030, .external_lex_state = 3},
  [245] = {.lex_state = 2030, .external_lex_state = 6},
  [246] = {.lex_state = 2030, .external_lex_state = 3},
  [247] = {.lex_state = 2030, .external_lex_state = 3},
  [248] = {.lex_state = 2030, .external_lex_state = 6},
  [249] = {.lex_state = 2030, .external_lex_state = 6},
  [250] = {.lex_state = 2030, .external_lex_state = 6},
  [251] = {.lex_state = 2030, .external_lex_state = 6},
  [252] = {.lex_state = 2030, .external_lex_state = 6},
  [253] = {.lex_state = 2030, .external_lex_state = 6},
  [254] = {.lex_state = 2030, .external_lex_state = 4},
  [255] = {.lex_state = 2030, .external_lex_state = 4},
  [256] = {.lex_state = 2030, .external_lex_state = 6},
  [257] = {.lex_state = 2030, .external_lex_state = 6},
  [258] = {.lex_state = 2030, .external_lex_state = 4},
  [259] = {.lex_state = 2030, .external_lex_state = 6},
  [260] = {.lex_state = 2030, .external_lex_state = 4},
  [261] = {.lex_state = 2030, .external_lex_state = 6},
  [262] = {.lex_state = 2030, .external_lex_state = 6},
  [263] = {.lex_state = 2030, .external_lex_state = 6},
  [264] = {.lex_state = 2030, .external_lex_state = 6},
  [265] = {.lex_state = 2030, .external_lex_state = 6},
  [266] = {.lex_state = 2030, .external_lex_state = 6},
  [267] = {.lex_state = 2030, .external_lex_state = 4},
  [268] = {.lex_state = 2030, .external_lex_state = 4},
  [269] = {.lex_state = 2030, .external_lex_state = 4},
  [270] = {.lex_state = 2030, .external_lex_state = 6},
  [271] = {.lex_state = 2030, .external_lex_state = 4},
  [272] = {.lex_state = 2030, .external_lex_state = 4},
  [273] = {.lex_state = 2030, .external_lex_state = 6},
  [274] = {.lex_state = 2030, .external_lex_state = 4},
  [275] = {.lex_state = 2030, .external_lex_state = 4},
  [276] = {.lex_state = 2030, .external_lex_state = 4},
  [277] = {.lex_state = 2030, .external_lex_state = 6},
  [278] = {.lex_state = 2030, .external_lex_state = 4},
  [279] = {.lex_state = 2030, .external_lex_state = 6},
  [280] = {.lex_state = 2030, .external_lex_state = 4},
  [281] = {.lex_state = 2030, .external_lex_state = 4},
  [282] = {.lex_state = 2030, .external_lex_state = 4},
  [283] = {.lex_state = 2030, .external_lex_state = 4},
  [284] = {.lex_state = 2030, .external_lex_state = 4},
  [285] = {.lex_state = 2030, .external_lex_state = 6},
  [286] = {.lex_state = 2030, .external_lex_state = 4},
  [287] = {.lex_state = 2030, .external_lex_state = 4},
  [288] = {.lex_state = 2030, .external_lex_state = 4},
  [289] = {.lex_state = 2030, .external_lex_state = 6},
  [290] = {.lex_state = 2030, .external_lex_state = 6},
  [291] = {.lex_state = 2030, .external_lex_state = 6},
  [292] = {.lex_state = 2030, .external_lex_state = 4},
  [293] = {.lex_state = 2030, .external_lex_state = 4},
  [294] = {.lex_state = 2030, .external_lex_state = 4},
  [295] = {.lex_state = 2030, .external_lex_state = 4},
  [296] = {.lex_state = 2030, .external_lex_state = 4},
  [297] = {.lex_state = 2030, .external_lex_state = 6},
  [298] = {.lex_state = 2030, .external_lex_state = 6},
  [299] = {.lex_state = 2030, .external_lex_state = 6},
  [300] = {.lex_state = 2030, .external_lex_state = 6},
  [301] = {.lex_state = 2030, .external_lex_state = 6},
  [302] = {.lex_state = 2030, .external_lex_state = 6},
  [303] = {.lex_state = 2030, .external_lex_state = 6},
  [304] = {.lex_state = 2030, .external_lex_state = 6},
  [305] = {.lex_state = 2030, .external_lex_state = 4},
  [306] = {.lex_state = 2030, .external_lex_state = 6},
  [307] = {.lex_state = 2030, .external_lex_state = 6},
  [308] = {.lex_state = 2030, .external_lex_state = 6},
  [309] = {.lex_state = 2030, .external_lex_state = 6},
  [310] = {.lex_state = 2030, .external_lex_state = 4},
  [311] = {.lex_state = 2030, .external_lex_state = 6},
  [312] = {.lex_state = 2030, .external_lex_state = 6},
  [313] = {.lex_state = 2030, .external_lex_state = 4},
  [314] = {.lex_state = 2030, .external_lex_state = 4},
  [315] = {.lex_state = 2030, .external_lex_state = 4},
  [316] = {.lex_state = 2030, .external_lex_state = 4},
  [317] = {.lex_state = 2030, .external_lex_state = 4},
  [318] = {.lex_state = 2030, .external_lex_state = 4},
  [319] = {.lex_state = 2030, .external_lex_state = 4},
  [320] = {.lex_state = 2030, .external_lex_state = 4},
  [321] = {.lex_state = 2030, .external_lex_state = 4},
  [322] = {.lex_state = 2030, .external_lex_state = 4},
  [323] = {.lex_state = 2030, .external_lex_state = 4},
  [324] = {.lex_state = 2030, .external_lex_state = 4},
  [325] = {.lex_state = 2030, .external_lex_state = 4},
  [326] = {.lex_state = 2030, .external_lex_state = 4},
  [327] = {.lex_state = 2030, .external_lex_state = 4},
  [328] = {.lex_state = 2030, .external_lex_state = 4},
  [329] = {.lex_state = 2030, .external_lex_state = 4},
  [330] = {.lex_state = 2030, .external_lex_state = 4},
  [331] = {.lex_state = 2030, .external_lex_state = 4},
  [332] = {.lex_state = 2030, .external_lex_state = 4},
  [333] = {.lex_state = 2030, .external_lex_state = 4},
  [334] = {.lex_state = 2030, .external_lex_state = 4},
  [335] = {.lex_state = 2030, .external_lex_state = 4},
  [336] = {.lex_state = 2030, .external_lex_state = 4},
  [337] = {.lex_state = 2030, .external_lex_state = 4},
  [338] = {.lex_state = 2030, .external_lex_state = 4},
  [339] = {.lex_state = 2030, .external_lex_state = 6},
  [340] = {.lex_state = 2030, .external_lex_state = 4},
  [341] = {.lex_state = 2030, .external_lex_state = 4},
  [342] = {.lex_state = 2030, .external_lex_state = 6},
  [343] = {.lex_state = 2030, .external_lex_state = 4},
  [344] = {.lex_state = 2030, .external_lex_state = 4},
  [345] = {.lex_state = 2030, .external_lex_state = 4},
  [346] = {.lex_state = 2030, .external_lex_state = 4},
  [347] = {.lex_state = 2030, .external_lex_state = 4},
  [348] = {.lex_state = 2030, .external_lex_state = 4},
  [349] = {.lex_state = 2030, .external_lex_state = 4},
  [350] = {.lex_state = 2030, .external_lex_state = 4},
  [351] = {.lex_state = 2030, .external_lex_state = 15},
  [352] = {.lex_state = 2030, .external_lex_state = 15},
  [353] = {.lex_state = 1, .external_lex_state = 16},
  [354] = {.lex_state = 1, .external_lex_state = 17},
  [355] = {.lex_state = 1, .external_lex_state = 16},
  [356] = {.lex_state = 1, .external_lex_state = 17},
  [357] = {.lex_state = 1, .external_lex_state = 17},
  [358] = {.lex_state = 1, .external_lex_state = 17},
  [359] = {.lex_state = 1, .external_lex_state = 16},
  [360] = {.lex_state = 2030, .external_lex_state = 18},
  [361] = {.lex_state = 1, .external_lex_state = 17},
  [362] = {.lex_state = 1, .external_lex_state = 17},
  [363] = {.lex_state = 2030, .external_lex_state = 18},
  [364] = {.lex_state = 1, .external_lex_state = 17},
  [365] = {.lex_state = 2030, .external_lex_state = 19},
  [366] = {.lex_state = 2030, .external_lex_state = 19},
  [367] = {.lex_state = 2030, .external_lex_state = 19},
  [368] = {.lex_state = 1, .external_lex_state = 17},
  [369] = {.lex_state = 2030, .external_lex_state = 16},
  [370] = {.lex_state = 2030, .external_lex_state = 16},
  [371] = {.lex_state = 1, .external_lex_state = 16},
  [372] = {.lex_state = 1, .external_lex_state = 17},
  [373] = {.lex_state = 1, .external_lex_state = 17},
  [374] = {.lex_state = 1, .external_lex_state = 16},
  [375] = {.lex_state = 1, .external_lex_state = 16},
  [376] = {.lex_state = 2030, .external_lex_state = 19},
  [377] = {.lex_state = 2030, .external_lex_state = 19},
  [378] = {.lex_state = 2030, .external_lex_state = 18},
  [379] = {.lex_state = 2030, .external_lex_state = 18},
  [380] = {.lex_state = 2030, .external_lex_state = 19},
  [381] = {.lex_state = 1, .external_lex_state = 17},
  [382] = {.lex_state = 2030, .external_lex_state = 16},
  [383] = {.lex_state = 1, .external_lex_state = 17},
  [384] = {.lex_state = 2030, .external_lex_state = 18},
  [385] = {.lex_state = 2030, .external_lex_state = 18},
  [386] = {.lex_state = 1, .external_lex_state = 16},
  [387] = {.lex_state = 1, .external_lex_state = 17},
  [388] = {.lex_state = 2030, .external_lex_state = 20},
  [389] = {.lex_state = 1, .external_lex_state = 21},
  [390] = {.lex_state = 3, .external_lex_state = 22},
  [391] = {.lex_state = 1, .external_lex_state = 21},
  [392] = {.lex_state = 5, .external_lex_state = 22},
  [393] = {.lex_state = 5, .external_lex_state = 22},
  [394] = {.lex_state = 2030, .external_lex_state = 20},
  [395] = {.lex_state = 2, .external_lex_state = 22},
  [396] = {.lex_state = 2030, .external_lex_state = 20},
  [397] = {.lex_state = 2, .external_lex_state = 22},
  [398] = {.lex_state = 3, .external_lex_state = 22},
  [399] = {.lex_state = 1, .external_lex_state = 21},
  [400] = {.lex_state = 5, .external_lex_state = 22},
  [401] = {.lex_state = 1, .external_lex_state = 17},
  [402] = {.lex_state = 2030, .external_lex_state = 18},
  [403] = {.lex_state = 5, .external_lex_state = 22},
  [404] = {.lex_state = 1, .external_lex_state = 21},
  [405] = {.lex_state = 2030, .external_lex_state = 19},
  [406] = {.lex_state = 3, .external_lex_state = 22},
  [407] = {.lex_state = 1, .external_lex_state = 21},
  [408] = {.lex_state = 3, .external_lex_state = 22},
  [409] = {.lex_state = 2030, .external_lex_state = 16},
  [410] = {.lex_state = 4, .external_lex_state = 23},
  [411] = {.lex_state = 2030, .external_lex_state = 19},
  [412] = {.lex_state = 1, .external_lex_state = 21},
  [413] = {.lex_state = 1, .external_lex_state = 21},
  [414] = {.lex_state = 1, .external_lex_state = 21},
  [415] = {.lex_state = 1, .external_lex_state = 21},
  [416] = {.lex_state = 2, .external_lex_state = 22},
  [417] = {.lex_state = 5, .external_lex_state = 22},
  [418] = {.lex_state = 2030, .external_lex_state = 18},
  [419] = {.lex_state = 1, .external_lex_state = 21},
  [420] = {.lex_state = 2030, .external_lex_state = 20},
  [421] = {.lex_state = 1, .external_lex_state = 21},
  [422] = {.lex_state = 3, .external_lex_state = 22},
  [423] = {.lex_state = 2, .external_lex_state = 22},
  [424] = {.lex_state = 1, .external_lex_state = 21},
  [425] = {.lex_state = 2030, .external_lex_state = 20},
  [426] = {.lex_state = 2, .external_lex_state = 22},
  [427] = {.lex_state = 2030, .external_lex_state = 22},
  [428] = {.lex_state = 2030, .external_lex_state = 22},
  [429] = {.lex_state = 2030, .external_lex_state = 22},
  [430] = {.lex_state = 1, .external_lex_state = 21},
  [431] = {.lex_state = 4, .external_lex_state = 23},
  [432] = {.lex_state = 4, .external_lex_state = 23},
  [433] = {.lex_state = 2030, .external_lex_state = 22},
  [434] = {.lex_state = 2030, .external_lex_state = 22},
  [435] = {.lex_state = 2030, .external_lex_state = 22},
  [436] = {.lex_state = 2030, .external_lex_state = 22},
  [437] = {.lex_state = 2030, .external_lex_state = 21},
  [438] = {.lex_state = 2030, .external_lex_state = 22},
  [439] = {.lex_state = 2030, .external_lex_state = 22},
  [440] = {.lex_state = 1, .external_lex_state = 21},
  [441] = {.lex_state = 2030, .external_lex_state = 22},
  [442] = {.lex_state = 1, .external_lex_state = 21},
  [443] = {.lex_state = 2030, .external_lex_state = 22},
  [444] = {.lex_state = 4, .external_lex_state = 23},
  [445] = {.lex_state = 1, .external_lex_state = 21},
  [446] = {.lex_state = 4, .external_lex_state = 23},
  [447] = {.lex_state = 4, .external_lex_state = 23},
  [448] = {.lex_state = 1, .external_lex_state = 17},
  [449] = {.lex_state = 2030, .external_lex_state = 22},
  [450] = {.lex_state = 2030, .external_lex_state = 22},
  [451] = {.lex_state = 2030, .external_lex_state = 22},
  [452] = {.lex_state = 2030, .external_lex_state = 22},
  [453] = {.lex_state = 1, .external_lex_state = 21},
  [454] = {.lex_state = 1, .external_lex_state = 21},
  [455] = {.lex_state = 1, .external_lex_state = 21},
  [456] = {.lex_state = 2030, .external_lex_state = 22},
  [457] = {.lex_state = 1, .external_lex_state = 21},
  [458] = {.lex_state = 4, .external_lex_state = 23},
  [459] = {.lex_state = 4, .external_lex_state = 23},
  [460] = {.lex_state = 2030, .external_lex_state = 22},
  [461] = {.lex_state = 2030, .external_lex_state = 22},
  [462] = {.lex_state = 1, .external_lex_state = 17},
  [463] = {.lex_state = 2030, .external_lex_state = 22},
  [464] = {.lex_state = 1},
  [465] = {.lex_state = 1},
  [466] = {.lex_state = 1, .external_lex_state = 17},
  [467] = {.lex_state = 1},
  [468] = {.lex_state = 4, .external_lex_state = 23},
  [469] = {.lex_state = 1},
  [470] = {.lex_state = 4, .external_lex_state = 23},
  [471] = {.lex_state = 4, .external_lex_state = 23},
  [472] = {.lex_state = 1},
  [473] = {.lex_state = 1},
  [474] = {.lex_state = 1},
  [475] = {.lex_state = 1},
  [476] = {.lex_state = 1},
  [477] = {.lex_state = 4, .external_lex_state = 23},
  [478] = {.lex_state = 4, .external_lex_state = 23},
  [479] = {.lex_state = 1},
  [480] = {.lex_state = 4, .external_lex_state = 23},
  [481] = {.lex_state = 4, .external_lex_state = 23},
  [482] = {.lex_state = 1},
  [483] = {.lex_state = 4, .external_lex_state = 23},
  [484] = {.lex_state = 1},
  [485] = {.lex_state = 1},
  [486] = {.lex_state = 1},
  [487] = {.lex_state = 1, .external_lex_state = 17},
  [488] = {.lex_state = 2030, .external_lex_state = 19},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 2030, .external_lex_state = 20},
  [491] = {.lex_state = 1, .external_lex_state = 24},
  [492] = {.lex_state = 4, .external_lex_state = 17},
  [493] = {.lex_state = 2, .external_lex_state = 22},
  [494] = {.lex_state = 1},
  [495] = {.lex_state = 4, .external_lex_state = 17},
  [496] = {.lex_state = 2030, .external_lex_state = 17},
  [497] = {.lex_state = 2030, .external_lex_state = 17},
  [498] = {.lex_state = 2030, .external_lex_state = 17},
  [499] = {.lex_state = 3, .external_lex_state = 22},
  [500] = {.lex_state = 4, .external_lex_state = 17},
  [501] = {.lex_state = 5, .external_lex_state = 22},
  [502] = {.lex_state = 2030, .external_lex_state = 19},
  [503] = {.lex_state = 2030, .external_lex_state = 17},
  [504] = {.lex_state = 1, .external_lex_state = 16},
  [505] = {.lex_state = 3, .external_lex_state = 22},
  [506] = {.lex_state = 2030, .external_lex_state = 17},
  [507] = {.lex_state = 1},
  [508] = {.lex_state = 2030, .external_lex_state = 17},
  [509] = {.lex_state = 2030, .external_lex_state = 18},
  [510] = {.lex_state = 4, .external_lex_state = 17},
  [511] = {.lex_state = 2030, .external_lex_state = 20},
  [512] = {.lex_state = 2030, .external_lex_state = 17},
  [513] = {.lex_state = 2030, .external_lex_state = 17},
  [514] = {.lex_state = 2030, .external_lex_state = 18},
  [515] = {.lex_state = 2030, .external_lex_state = 17},
  [516] = {.lex_state = 4, .external_lex_state = 17},
  [517] = {.lex_state = 2030, .external_lex_state = 17},
  [518] = {.lex_state = 1},
  [519] = {.lex_state = 5, .external_lex_state = 22},
  [520] = {.lex_state = 2, .external_lex_state = 22},
  [521] = {.lex_state = 1, .external_lex_state = 16},
  [522] = {.lex_state = 1},
  [523] = {.lex_state = 4, .external_lex_state = 17},
  [524] = {.lex_state = 4, .external_lex_state = 17},
  [525] = {.lex_state = 1, .external_lex_state = 16},
  [526] = {.lex_state = 1},
  [527] = {.lex_state = 4, .external_lex_state = 25},
  [528] = {.lex_state = 2030, .external_lex_state = 17},
  [529] = {.lex_state = 1, .external_lex_state = 16},
  [530] = {.lex_state = 1, .external_lex_state = 21},
  [531] = {.lex_state = 1, .external_lex_state = 21},
  [532] = {.lex_state = 1},
  [533] = {.lex_state = 2030, .external_lex_state = 16},
  [534] = {.lex_state = 4},
  [535] = {.lex_state = 2030, .external_lex_state = 17},
  [536] = {.lex_state = 2030, .external_lex_state = 16},
  [537] = {.lex_state = 4, .external_lex_state = 23},
  [538] = {.lex_state = 1, .external_lex_state = 17},
  [539] = {.lex_state = 2030, .external_lex_state = 26},
  [540] = {.lex_state = 4, .external_lex_state = 17},
  [541] = {.lex_state = 1, .external_lex_state = 21},
  [542] = {.lex_state = 4, .external_lex_state = 17},
  [543] = {.lex_state = 1, .external_lex_state = 21},
  [544] = {.lex_state = 4, .external_lex_state = 17},
  [545] = {.lex_state = 4, .external_lex_state = 17},
  [546] = {.lex_state = 2030, .external_lex_state = 27},
  [547] = {.lex_state = 4, .external_lex_state = 23},
  [548] = {.lex_state = 1, .external_lex_state = 17},
  [549] = {.lex_state = 2030, .external_lex_state = 28},
  [550] = {.lex_state = 2030, .external_lex_state = 29},
  [551] = {.lex_state = 1, .external_lex_state = 21},
  [552] = {.lex_state = 4, .external_lex_state = 17},
  [553] = {.lex_state = 4, .external_lex_state = 17},
  [554] = {.lex_state = 2, .external_lex_state = 30},
  [555] = {.lex_state = 4, .external_lex_state = 23},
  [556] = {.lex_state = 4},
  [557] = {.lex_state = 2030, .external_lex_state = 22},
  [558] = {.lex_state = 5, .external_lex_state = 30},
  [559] = {.lex_state = 2030, .external_lex_state = 31},
  [560] = {.lex_state = 4, .external_lex_state = 17},
  [561] = {.lex_state = 1, .external_lex_state = 17},
  [562] = {.lex_state = 1, .external_lex_state = 21},
  [563] = {.lex_state = 3, .external_lex_state = 30},
  [564] = {.lex_state = 4, .external_lex_state = 23},
  [565] = {.lex_state = 2030, .external_lex_state = 32},
  [566] = {.lex_state = 4, .external_lex_state = 17},
  [567] = {.lex_state = 1, .external_lex_state = 21},
  [568] = {.lex_state = 4, .external_lex_state = 23},
  [569] = {.lex_state = 2030, .external_lex_state = 22},
  [570] = {.lex_state = 1, .external_lex_state = 21},
  [571] = {.lex_state = 1, .external_lex_state = 17},
  [572] = {.lex_state = 1, .external_lex_state = 21},
  [573] = {.lex_state = 2030, .external_lex_state = 33},
  [574] = {.lex_state = 4},
  [575] = {.lex_state = 2030, .external_lex_state = 17},
  [576] = {.lex_state = 1, .external_lex_state = 34},
  [577] = {.lex_state = 5, .external_lex_state = 22},
  [578] = {.lex_state = 2, .external_lex_state = 22},
  [579] = {.lex_state = 5, .external_lex_state = 22},
  [580] = {.lex_state = 2, .external_lex_state = 22},
  [581] = {.lex_state = 2030, .external_lex_state = 20},
  [582] = {.lex_state = 4},
  [583] = {.lex_state = 5, .external_lex_state = 22},
  [584] = {.lex_state = 4},
  [585] = {.lex_state = 2030, .external_lex_state = 17},
  [586] = {.lex_state = 2030, .external_lex_state = 18},
  [587] = {.lex_state = 3, .external_lex_state = 22},
  [588] = {.lex_state = 4},
  [589] = {.lex_state = 1, .external_lex_state = 21},
  [590] = {.lex_state = 2030, .external_lex_state = 16},
  [591] = {.lex_state = 3, .external_lex_state = 22},
  [592] = {.lex_state = 4},
  [593] = {.lex_state = 2030, .external_lex_state = 29},
  [594] = {.lex_state = 4},
  [595] = {.lex_state = 2030, .external_lex_state = 19},
  [596] = {.lex_state = 2030, .external_lex_state = 16},
  [597] = {.lex_state = 4},
  [598] = {.lex_state = 4},
  [599] = {.lex_state = 4},
  [600] = {.lex_state = 1, .external_lex_state = 21},
  [601] = {.lex_state = 2030, .external_lex_state = 16},
  [602] = {.lex_state = 1, .external_lex_state = 21},
  [603] = {.lex_state = 2030, .external_lex_state = 20},
  [604] = {.lex_state = 4},
  [605] = {.lex_state = 2030, .external_lex_state = 16},
  [606] = {.lex_state = 2030, .external_lex_state = 19},
  [607] = {.lex_state = 2, .external_lex_state = 22},
  [608] = {.lex_state = 3, .external_lex_state = 22},
  [609] = {.lex_state = 4},
  [610] = {.lex_state = 4},
  [611] = {.lex_state = 1},
  [612] = {.lex_state = 2030, .external_lex_state = 18},
  [613] = {.lex_state = 2030, .external_lex_state = 20},
  [614] = {.lex_state = 2030, .external_lex_state = 30},
  [615] = {.lex_state = 4},
  [616] = {.lex_state = 2030, .external_lex_state = 16},
  [617] = {.lex_state = 1},
  [618] = {.lex_state = 4, .external_lex_state = 17},
  [619] = {.lex_state = 4, .external_lex_state = 17},
  [620] = {.lex_state = 1},
  [621] = {.lex_state = 1},
  [622] = {.lex_state = 1},
  [623] = {.lex_state = 4, .external_lex_state = 17},
  [624] = {.lex_state = 2030, .external_lex_state = 22},
  [625] = {.lex_state = 2030, .external_lex_state = 22},
  [626] = {.lex_state = 2030, .external_lex_state = 22},
  [627] = {.lex_state = 4, .external_lex_state = 17},
  [628] = {.lex_state = 2030, .external_lex_state = 22},
  [629] = {.lex_state = 1},
  [630] = {.lex_state = 2030, .external_lex_state = 17},
  [631] = {.lex_state = 4},
  [632] = {.lex_state = 0, .external_lex_state = 35},
  [633] = {.lex_state = 0, .external_lex_state = 35},
  [634] = {.lex_state = 0, .external_lex_state = 35},
  [635] = {.lex_state = 0, .external_lex_state = 35},
  [636] = {.lex_state = 0, .external_lex_state = 35},
  [637] = {.lex_state = 2030, .external_lex_state = 23},
  [638] = {.lex_state = 2030, .external_lex_state = 23},
  [639] = {.lex_state = 2030, .external_lex_state = 23},
  [640] = {.lex_state = 2030, .external_lex_state = 23},
  [641] = {.lex_state = 2030, .external_lex_state = 23},
  [642] = {.lex_state = 2030},
  [643] = {.lex_state = 2030, .external_lex_state = 23},
  [644] = {.lex_state = 2030, .external_lex_state = 23},
  [645] = {.lex_state = 2030},
  [646] = {.lex_state = 0, .external_lex_state = 36},
  [647] = {.lex_state = 0, .external_lex_state = 36},
  [648] = {.lex_state = 0, .external_lex_state = 36},
  [649] = {.lex_state = 2030, .external_lex_state = 23},
  [650] = {.lex_state = 2030, .external_lex_state = 23},
  [651] = {.lex_state = 0, .external_lex_state = 36},
  [652] = {.lex_state = 0, .external_lex_state = 36},
  [653] = {.lex_state = 0, .external_lex_state = 36},
  [654] = {.lex_state = 0, .external_lex_state = 36},
  [655] = {.lex_state = 0, .external_lex_state = 36},
  [656] = {.lex_state = 0, .external_lex_state = 36},
  [657] = {.lex_state = 0, .external_lex_state = 35},
  [658] = {.lex_state = 0, .external_lex_state = 36},
  [659] = {.lex_state = 2030, .external_lex_state = 23},
  [660] = {.lex_state = 0, .external_lex_state = 37},
  [661] = {.lex_state = 0, .external_lex_state = 16},
  [662] = {.lex_state = 0, .external_lex_state = 37},
  [663] = {.lex_state = 0, .external_lex_state = 16},
  [664] = {.lex_state = 0, .external_lex_state = 16},
  [665] = {.lex_state = 2030},
  [666] = {.lex_state = 0, .external_lex_state = 37},
  [667] = {.lex_state = 0, .external_lex_state = 37},
  [668] = {.lex_state = 0, .external_lex_state = 37},
  [669] = {.lex_state = 0, .external_lex_state = 23},
  [670] = {.lex_state = 2030, .external_lex_state = 23},
  [671] = {.lex_state = 2030},
  [672] = {.lex_state = 0, .external_lex_state = 37},
  [673] = {.lex_state = 0, .external_lex_state = 37},
  [674] = {.lex_state = 0, .external_lex_state = 16},
  [675] = {.lex_state = 0, .external_lex_state = 23},
  [676] = {.lex_state = 0, .external_lex_state = 16},
  [677] = {.lex_state = 0, .external_lex_state = 16},
  [678] = {.lex_state = 0, .external_lex_state = 37},
  [679] = {.lex_state = 0, .external_lex_state = 38},
  [680] = {.lex_state = 0, .external_lex_state = 16},
  [681] = {.lex_state = 0, .external_lex_state = 16},
  [682] = {.lex_state = 0, .external_lex_state = 37},
  [683] = {.lex_state = 0, .external_lex_state = 23},
  [684] = {.lex_state = 0, .external_lex_state = 16},
  [685] = {.lex_state = 0, .external_lex_state = 37},
  [686] = {.lex_state = 2030, .external_lex_state = 23},
  [687] = {.lex_state = 0, .external_lex_state = 16},
  [688] = {.lex_state = 2030, .external_lex_state = 23},
  [689] = {.lex_state = 0, .external_lex_state = 23},
  [690] = {.lex_state = 0, .external_lex_state = 16},
  [691] = {.lex_state = 0, .external_lex_state = 23},
  [692] = {.lex_state = 0, .external_lex_state = 23},
  [693] = {.lex_state = 0, .external_lex_state = 23},
  [694] = {.lex_state = 2030},
  [695] = {.lex_state = 2030},
  [696] = {.lex_state = 0, .external_lex_state = 23},
  [697] = {.lex_state = 2030},
  [698] = {.lex_state = 0, .external_lex_state = 16},
  [699] = {.lex_state = 0, .external_lex_state = 23},
  [700] = {.lex_state = 0, .external_lex_state = 23},
  [701] = {.lex_state = 0, .external_lex_state = 37},
  [702] = {.lex_state = 0, .external_lex_state = 37},
  [703] = {.lex_state = 0, .external_lex_state = 23},
  [704] = {.lex_state = 0, .external_lex_state = 23},
  [705] = {.lex_state = 0, .external_lex_state = 16},
  [706] = {.lex_state = 0, .external_lex_state = 37},
  [707] = {.lex_state = 0, .external_lex_state = 16},
  [708] = {.lex_state = 0, .external_lex_state = 23},
  [709] = {.lex_state = 0, .external_lex_state = 16},
  [710] = {.lex_state = 0, .external_lex_state = 23},
  [711] = {.lex_state = 0, .external_lex_state = 16},
  [712] = {.lex_state = 0, .external_lex_state = 23},
  [713] = {.lex_state = 0, .external_lex_state = 23},
  [714] = {.lex_state = 0, .external_lex_state = 16},
  [715] = {.lex_state = 0, .external_lex_state = 16},
  [716] = {.lex_state = 2030, .external_lex_state = 34},
  [717] = {.lex_state = 0, .external_lex_state = 16},
  [718] = {.lex_state = 0, .external_lex_state = 37},
  [719] = {.lex_state = 0, .external_lex_state = 16},
  [720] = {.lex_state = 0, .external_lex_state = 16},
  [721] = {.lex_state = 0, .external_lex_state = 37},
  [722] = {.lex_state = 0, .external_lex_state = 16},
  [723] = {.lex_state = 0, .external_lex_state = 16},
  [724] = {.lex_state = 0, .external_lex_state = 16},
  [725] = {.lex_state = 0, .external_lex_state = 37},
  [726] = {.lex_state = 0, .external_lex_state = 23},
  [727] = {.lex_state = 0, .external_lex_state = 23},
  [728] = {.lex_state = 0, .external_lex_state = 23},
  [729] = {.lex_state = 0, .external_lex_state = 23},
  [730] = {.lex_state = 0, .external_lex_state = 37},
  [731] = {.lex_state = 0, .external_lex_state = 37},
  [732] = {.lex_state = 0, .external_lex_state = 37},
  [733] = {.lex_state = 0, .external_lex_state = 16},
  [734] = {.lex_state = 0, .external_lex_state = 37},
  [735] = {.lex_state = 0, .external_lex_state = 37},
  [736] = {.lex_state = 0, .external_lex_state = 37},
  [737] = {.lex_state = 0, .external_lex_state = 16},
  [738] = {.lex_state = 0, .external_lex_state = 37},
  [739] = {.lex_state = 2030},
  [740] = {.lex_state = 0, .external_lex_state = 23},
  [741] = {.lex_state = 2030},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0, .external_lex_state = 23},
  [751] = {.lex_state = 0, .external_lex_state = 23},
  [752] = {.lex_state = 0, .external_lex_state = 23},
  [753] = {.lex_state = 0, .external_lex_state = 23},
  [754] = {.lex_state = 0, .external_lex_state = 16},
  [755] = {.lex_state = 0, .external_lex_state = 23},
  [756] = {.lex_state = 0, .external_lex_state = 23},
  [757] = {.lex_state = 0, .external_lex_state = 23},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0, .external_lex_state = 23},
  [760] = {.lex_state = 2030},
  [761] = {.lex_state = 0, .external_lex_state = 23},
  [762] = {.lex_state = 0, .external_lex_state = 16},
  [763] = {.lex_state = 0, .external_lex_state = 23},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0, .external_lex_state = 23},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0, .external_lex_state = 23},
  [770] = {.lex_state = 0, .external_lex_state = 23},
  [771] = {.lex_state = 0, .external_lex_state = 23},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0, .external_lex_state = 17},
  [774] = {.lex_state = 0, .external_lex_state = 16},
  [775] = {.lex_state = 0, .external_lex_state = 17},
  [776] = {.lex_state = 0, .external_lex_state = 39},
  [777] = {.lex_state = 0, .external_lex_state = 39},
  [778] = {.lex_state = 0, .external_lex_state = 39},
  [779] = {.lex_state = 0, .external_lex_state = 17},
  [780] = {.lex_state = 0, .external_lex_state = 39},
  [781] = {.lex_state = 0, .external_lex_state = 39},
  [782] = {.lex_state = 0, .external_lex_state = 39},
  [783] = {.lex_state = 0, .external_lex_state = 17},
  [784] = {.lex_state = 0, .external_lex_state = 39},
  [785] = {.lex_state = 0, .external_lex_state = 17},
  [786] = {.lex_state = 0, .external_lex_state = 17},
  [787] = {.lex_state = 0, .external_lex_state = 17},
  [788] = {.lex_state = 0, .external_lex_state = 39},
  [789] = {.lex_state = 0, .external_lex_state = 39},
  [790] = {.lex_state = 0, .external_lex_state = 23},
  [791] = {.lex_state = 0, .external_lex_state = 17},
  [792] = {.lex_state = 0, .external_lex_state = 16},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0, .external_lex_state = 17},
  [795] = {.lex_state = 0, .external_lex_state = 40},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 0, .external_lex_state = 17},
  [798] = {.lex_state = 0, .external_lex_state = 17},
  [799] = {.lex_state = 0, .external_lex_state = 17},
  [800] = {.lex_state = 0, .external_lex_state = 17},
  [801] = {.lex_state = 0, .external_lex_state = 17},
  [802] = {.lex_state = 0, .external_lex_state = 17},
  [803] = {.lex_state = 0, .external_lex_state = 17},
  [804] = {.lex_state = 0, .external_lex_state = 41},
  [805] = {.lex_state = 0, .external_lex_state = 17},
  [806] = {.lex_state = 0, .external_lex_state = 42},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 2030},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0, .external_lex_state = 17},
  [811] = {.lex_state = 2030},
  [812] = {.lex_state = 0, .external_lex_state = 17},
  [813] = {.lex_state = 0, .external_lex_state = 17},
  [814] = {.lex_state = 0, .external_lex_state = 17},
  [815] = {.lex_state = 0, .external_lex_state = 17},
  [816] = {.lex_state = 0, .external_lex_state = 17},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0, .external_lex_state = 41},
  [819] = {.lex_state = 0, .external_lex_state = 17},
  [820] = {.lex_state = 0, .external_lex_state = 40},
  [821] = {.lex_state = 0, .external_lex_state = 17},
  [822] = {.lex_state = 0, .external_lex_state = 17},
  [823] = {.lex_state = 0, .external_lex_state = 40},
  [824] = {.lex_state = 0, .external_lex_state = 17},
  [825] = {.lex_state = 0, .external_lex_state = 17},
  [826] = {.lex_state = 0, .external_lex_state = 43},
  [827] = {.lex_state = 0, .external_lex_state = 17},
  [828] = {.lex_state = 0, .external_lex_state = 17},
  [829] = {.lex_state = 0, .external_lex_state = 17},
  [830] = {.lex_state = 0, .external_lex_state = 41},
  [831] = {.lex_state = 0, .external_lex_state = 41},
  [832] = {.lex_state = 0, .external_lex_state = 40},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0, .external_lex_state = 17},
  [835] = {.lex_state = 0, .external_lex_state = 17},
  [836] = {.lex_state = 0, .external_lex_state = 41},
  [837] = {.lex_state = 0, .external_lex_state = 17},
  [838] = {.lex_state = 0, .external_lex_state = 40},
  [839] = {.lex_state = 0, .external_lex_state = 17},
  [840] = {.lex_state = 0, .external_lex_state = 17},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0, .external_lex_state = 17},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 0, .external_lex_state = 17},
  [845] = {.lex_state = 0, .external_lex_state = 17},
  [846] = {.lex_state = 0, .external_lex_state = 17},
  [847] = {.lex_state = 0, .external_lex_state = 17},
  [848] = {.lex_state = 0, .external_lex_state = 17},
  [849] = {.lex_state = 0, .external_lex_state = 42},
  [850] = {.lex_state = 0, .external_lex_state = 17},
  [851] = {.lex_state = 0, .external_lex_state = 44},
  [852] = {.lex_state = 0, .external_lex_state = 17},
  [853] = {.lex_state = 0, .external_lex_state = 41},
  [854] = {.lex_state = 0, .external_lex_state = 17},
  [855] = {.lex_state = 0, .external_lex_state = 40},
  [856] = {.lex_state = 0, .external_lex_state = 17},
  [857] = {.lex_state = 0, .external_lex_state = 45},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0, .external_lex_state = 45},
  [860] = {.lex_state = 0, .external_lex_state = 46},
  [861] = {.lex_state = 0, .external_lex_state = 46},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0, .external_lex_state = 45},
  [864] = {.lex_state = 0, .external_lex_state = 46},
  [865] = {.lex_state = 0, .external_lex_state = 46},
  [866] = {.lex_state = 0, .external_lex_state = 46},
  [867] = {.lex_state = 0, .external_lex_state = 45},
  [868] = {.lex_state = 0, .external_lex_state = 45},
  [869] = {.lex_state = 0, .external_lex_state = 45},
  [870] = {.lex_state = 0, .external_lex_state = 45},
  [871] = {.lex_state = 0, .external_lex_state = 45},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0, .external_lex_state = 45},
  [874] = {.lex_state = 0, .external_lex_state = 45},
  [875] = {.lex_state = 0, .external_lex_state = 45},
  [876] = {.lex_state = 0, .external_lex_state = 45},
  [877] = {.lex_state = 0, .external_lex_state = 45},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 0, .external_lex_state = 46},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 0, .external_lex_state = 45},
  [882] = {.lex_state = 0, .external_lex_state = 46},
  [883] = {.lex_state = 0, .external_lex_state = 46},
  [884] = {.lex_state = 0, .external_lex_state = 45},
  [885] = {.lex_state = 0, .external_lex_state = 46},
  [886] = {.lex_state = 0, .external_lex_state = 46},
  [887] = {.lex_state = 0, .external_lex_state = 45},
  [888] = {.lex_state = 0, .external_lex_state = 47},
  [889] = {.lex_state = 0, .external_lex_state = 45},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0, .external_lex_state = 45},
  [892] = {.lex_state = 0, .external_lex_state = 45},
  [893] = {.lex_state = 0, .external_lex_state = 45},
  [894] = {.lex_state = 0, .external_lex_state = 45},
  [895] = {.lex_state = 0, .external_lex_state = 45},
  [896] = {.lex_state = 0, .external_lex_state = 45},
  [897] = {.lex_state = 0, .external_lex_state = 45},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 0, .external_lex_state = 45},
  [901] = {.lex_state = 0, .external_lex_state = 45},
  [902] = {.lex_state = 0, .external_lex_state = 47},
  [903] = {.lex_state = 0, .external_lex_state = 47},
  [904] = {.lex_state = 0, .external_lex_state = 45},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 0, .external_lex_state = 47},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0, .external_lex_state = 45},
  [909] = {.lex_state = 0, .external_lex_state = 45},
  [910] = {.lex_state = 0, .external_lex_state = 45},
  [911] = {.lex_state = 0, .external_lex_state = 46},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0, .external_lex_state = 46},
  [916] = {.lex_state = 0, .external_lex_state = 46},
  [917] = {.lex_state = 0, .external_lex_state = 46},
  [918] = {.lex_state = 0, .external_lex_state = 46},
  [919] = {.lex_state = 0, .external_lex_state = 46},
};

enum {
  ts_external_token__line_ending = 0,
  ts_external_token__soft_line_ending = 1,
  ts_external_token__block_close = 2,
  ts_external_token_block_continuation = 3,
  ts_external_token__block_quote_start = 4,
  ts_external_token__indented_chunk_start = 5,
  ts_external_token_atx_h1_marker = 6,
  ts_external_token_atx_h2_marker = 7,
  ts_external_token_atx_h3_marker = 8,
  ts_external_token_atx_h4_marker = 9,
  ts_external_token_atx_h5_marker = 10,
  ts_external_token_atx_h6_marker = 11,
  ts_external_token_setext_h1_underline = 12,
  ts_external_token_setext_h2_underline = 13,
  ts_external_token__thematic_break = 14,
  ts_external_token__list_marker_minus = 15,
  ts_external_token__list_marker_plus = 16,
  ts_external_token__list_marker_star = 17,
  ts_external_token__list_marker_parenthesis = 18,
  ts_external_token__list_marker_dot = 19,
  ts_external_token__list_marker_minus_dont_interrupt = 20,
  ts_external_token__list_marker_plus_dont_interrupt = 21,
  ts_external_token__list_marker_star_dont_interrupt = 22,
  ts_external_token__list_marker_parenthesis_dont_interrupt = 23,
  ts_external_token__list_marker_dot_dont_interrupt = 24,
  ts_external_token__fenced_code_block_start_backtick = 25,
  ts_external_token__fenced_code_block_start_tilde = 26,
  ts_external_token__blank_line_start = 27,
  ts_external_token__fenced_code_block_end_backtick = 28,
  ts_external_token__fenced_code_block_end_tilde = 29,
  ts_external_token__html_block_1_start = 30,
  ts_external_token__html_block_1_end = 31,
  ts_external_token__html_block_2_start = 32,
  ts_external_token__html_block_3_start = 33,
  ts_external_token__html_block_4_start = 34,
  ts_external_token__html_block_5_start = 35,
  ts_external_token__html_block_6_start = 36,
  ts_external_token__html_block_7_start = 37,
  ts_external_token__close_block = 38,
  ts_external_token__no_indented_chunk = 39,
  ts_external_token__error = 40,
  ts_external_token__trigger_error = 41,
  ts_external_token__eof = 42,
  ts_external_token_minus_metadata = 43,
  ts_external_token_plus_metadata = 44,
  ts_external_token__pipe_table_start = 45,
  ts_external_token__pipe_table_line_ending = 46,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_ending] = sym__line_ending,
  [ts_external_token__soft_line_ending] = sym__soft_line_ending,
  [ts_external_token__block_close] = sym__block_close,
  [ts_external_token_block_continuation] = sym_block_continuation,
  [ts_external_token__block_quote_start] = sym__block_quote_start,
  [ts_external_token__indented_chunk_start] = sym__indented_chunk_start,
  [ts_external_token_atx_h1_marker] = sym_atx_h1_marker,
  [ts_external_token_atx_h2_marker] = sym_atx_h2_marker,
  [ts_external_token_atx_h3_marker] = sym_atx_h3_marker,
  [ts_external_token_atx_h4_marker] = sym_atx_h4_marker,
  [ts_external_token_atx_h5_marker] = sym_atx_h5_marker,
  [ts_external_token_atx_h6_marker] = sym_atx_h6_marker,
  [ts_external_token_setext_h1_underline] = sym_setext_h1_underline,
  [ts_external_token_setext_h2_underline] = sym_setext_h2_underline,
  [ts_external_token__thematic_break] = sym__thematic_break,
  [ts_external_token__list_marker_minus] = sym__list_marker_minus,
  [ts_external_token__list_marker_plus] = sym__list_marker_plus,
  [ts_external_token__list_marker_star] = sym__list_marker_star,
  [ts_external_token__list_marker_parenthesis] = sym__list_marker_parenthesis,
  [ts_external_token__list_marker_dot] = sym__list_marker_dot,
  [ts_external_token__list_marker_minus_dont_interrupt] = sym__list_marker_minus_dont_interrupt,
  [ts_external_token__list_marker_plus_dont_interrupt] = sym__list_marker_plus_dont_interrupt,
  [ts_external_token__list_marker_star_dont_interrupt] = sym__list_marker_star_dont_interrupt,
  [ts_external_token__list_marker_parenthesis_dont_interrupt] = sym__list_marker_parenthesis_dont_interrupt,
  [ts_external_token__list_marker_dot_dont_interrupt] = sym__list_marker_dot_dont_interrupt,
  [ts_external_token__fenced_code_block_start_backtick] = sym__fenced_code_block_start_backtick,
  [ts_external_token__fenced_code_block_start_tilde] = sym__fenced_code_block_start_tilde,
  [ts_external_token__blank_line_start] = sym__blank_line_start,
  [ts_external_token__fenced_code_block_end_backtick] = sym__fenced_code_block_end_backtick,
  [ts_external_token__fenced_code_block_end_tilde] = sym__fenced_code_block_end_tilde,
  [ts_external_token__html_block_1_start] = sym__html_block_1_start,
  [ts_external_token__html_block_1_end] = sym__html_block_1_end,
  [ts_external_token__html_block_2_start] = sym__html_block_2_start,
  [ts_external_token__html_block_3_start] = sym__html_block_3_start,
  [ts_external_token__html_block_4_start] = sym__html_block_4_start,
  [ts_external_token__html_block_5_start] = sym__html_block_5_start,
  [ts_external_token__html_block_6_start] = sym__html_block_6_start,
  [ts_external_token__html_block_7_start] = sym__html_block_7_start,
  [ts_external_token__close_block] = sym__close_block,
  [ts_external_token__no_indented_chunk] = sym__no_indented_chunk,
  [ts_external_token__error] = sym__error,
  [ts_external_token__trigger_error] = sym__trigger_error,
  [ts_external_token__eof] = sym__eof,
  [ts_external_token_minus_metadata] = sym_minus_metadata,
  [ts_external_token_plus_metadata] = sym_plus_metadata,
  [ts_external_token__pipe_table_start] = sym__pipe_table_start,
  [ts_external_token__pipe_table_line_ending] = sym__pipe_table_line_ending,
};

static const bool ts_external_scanner_states[48][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token_setext_h1_underline] = true,
    [ts_external_token_setext_h2_underline] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__fenced_code_block_end_backtick] = true,
    [ts_external_token__fenced_code_block_end_tilde] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_1_end] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__close_block] = true,
    [ts_external_token__no_indented_chunk] = true,
    [ts_external_token__error] = true,
    [ts_external_token__trigger_error] = true,
    [ts_external_token__eof] = true,
    [ts_external_token_minus_metadata] = true,
    [ts_external_token_plus_metadata] = true,
    [ts_external_token__pipe_table_start] = true,
    [ts_external_token__pipe_table_line_ending] = true,
  },
  [2] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token_minus_metadata] = true,
    [ts_external_token_plus_metadata] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [3] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [4] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [5] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [6] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [7] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token_setext_h1_underline] = true,
    [ts_external_token_setext_h2_underline] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [8] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token_setext_h1_underline] = true,
    [ts_external_token_setext_h2_underline] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [9] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__no_indented_chunk] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [10] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__no_indented_chunk] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [11] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__no_indented_chunk] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [12] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__no_indented_chunk] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [13] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token_setext_h1_underline] = true,
    [ts_external_token_setext_h2_underline] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [14] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__block_quote_start] = true,
    [ts_external_token__indented_chunk_start] = true,
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
    [ts_external_token_setext_h1_underline] = true,
    [ts_external_token_setext_h2_underline] = true,
    [ts_external_token__thematic_break] = true,
    [ts_external_token__list_marker_minus] = true,
    [ts_external_token__list_marker_plus] = true,
    [ts_external_token__list_marker_star] = true,
    [ts_external_token__list_marker_parenthesis] = true,
    [ts_external_token__list_marker_dot] = true,
    [ts_external_token__list_marker_minus_dont_interrupt] = true,
    [ts_external_token__list_marker_plus_dont_interrupt] = true,
    [ts_external_token__list_marker_star_dont_interrupt] = true,
    [ts_external_token__list_marker_parenthesis_dont_interrupt] = true,
    [ts_external_token__list_marker_dot_dont_interrupt] = true,
    [ts_external_token__fenced_code_block_start_backtick] = true,
    [ts_external_token__fenced_code_block_start_tilde] = true,
    [ts_external_token__blank_line_start] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__pipe_table_start] = true,
  },
  [15] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__html_block_1_start] = true,
    [ts_external_token__html_block_2_start] = true,
    [ts_external_token__html_block_3_start] = true,
    [ts_external_token__html_block_4_start] = true,
    [ts_external_token__html_block_5_start] = true,
    [ts_external_token__html_block_6_start] = true,
    [ts_external_token__html_block_7_start] = true,
    [ts_external_token__eof] = true,
  },
  [16] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__eof] = true,
  },
  [17] = {
    [ts_external_token__line_ending] = true,
  },
  [18] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__fenced_code_block_end_backtick] = true,
  },
  [19] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__fenced_code_block_end_tilde] = true,
  },
  [20] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__html_block_1_end] = true,
  },
  [21] = {
    [ts_external_token__soft_line_ending] = true,
  },
  [22] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
  },
  [23] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__eof] = true,
    [ts_external_token__pipe_table_line_ending] = true,
  },
  [24] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token_block_continuation] = true,
  },
  [25] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__eof] = true,
    [ts_external_token__pipe_table_line_ending] = true,
  },
  [26] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__close_block] = true,
  },
  [27] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__html_block_1_end] = true,
  },
  [28] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__fenced_code_block_end_tilde] = true,
  },
  [29] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token__blank_line_start] = true,
  },
  [30] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
  },
  [31] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__eof] = true,
  },
  [32] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__fenced_code_block_end_backtick] = true,
  },
  [33] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
    [ts_external_token__blank_line_start] = true,
  },
  [34] = {
    [ts_external_token_block_continuation] = true,
  },
  [35] = {
    [ts_external_token_atx_h1_marker] = true,
    [ts_external_token_atx_h2_marker] = true,
    [ts_external_token_atx_h3_marker] = true,
    [ts_external_token_atx_h4_marker] = true,
    [ts_external_token_atx_h5_marker] = true,
    [ts_external_token_atx_h6_marker] = true,
  },
  [36] = {
    [ts_external_token__soft_line_ending] = true,
    [ts_external_token__no_indented_chunk] = true,
  },
  [37] = {
    [ts_external_token__no_indented_chunk] = true,
  },
  [38] = {
    [ts_external_token_block_continuation] = true,
    [ts_external_token__no_indented_chunk] = true,
  },
  [39] = {
    [ts_external_token__line_ending] = true,
    [ts_external_token__eof] = true,
  },
  [40] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__fenced_code_block_end_tilde] = true,
  },
  [41] = {
    [ts_external_token__block_close] = true,
    [ts_external_token__fenced_code_block_end_backtick] = true,
  },
  [42] = {
    [ts_external_token__block_close] = true,
    [ts_external_token_block_continuation] = true,
  },
  [43] = {
    [ts_external_token_block_continuation] = true,
    [ts_external_token__trigger_error] = true,
  },
  [44] = {
    [ts_external_token_block_continuation] = true,
    [ts_external_token__close_block] = true,
  },
  [45] = {
    [ts_external_token__block_close] = true,
  },
  [46] = {
    [ts_external_token__close_block] = true,
  },
  [47] = {
    [ts_external_token__trigger_error] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__backslash_escape] = ACTIONS(1),
    [sym_entity_reference] = ACTIONS(1),
    [sym_numeric_character_reference] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__newline_token] = ACTIONS(1),
    [anon_sym_DASH_DASH_GT] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK_GT] = ACTIONS(1),
    [aux_sym__word_token1] = ACTIONS(1),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1),
    [aux_sym__word_token2] = ACTIONS(1),
    [sym__whitespace] = ACTIONS(1),
    [sym__line_ending] = ACTIONS(1),
    [sym__soft_line_ending] = ACTIONS(1),
    [sym__block_close] = ACTIONS(1),
    [sym_block_continuation] = ACTIONS(1),
    [sym__block_quote_start] = ACTIONS(1),
    [sym__indented_chunk_start] = ACTIONS(1),
    [sym_atx_h1_marker] = ACTIONS(1),
    [sym_atx_h2_marker] = ACTIONS(1),
    [sym_atx_h3_marker] = ACTIONS(1),
    [sym_atx_h4_marker] = ACTIONS(1),
    [sym_atx_h5_marker] = ACTIONS(1),
    [sym_atx_h6_marker] = ACTIONS(1),
    [sym_setext_h1_underline] = ACTIONS(1),
    [sym_setext_h2_underline] = ACTIONS(1),
    [sym__thematic_break] = ACTIONS(1),
    [sym__list_marker_minus] = ACTIONS(1),
    [sym__list_marker_plus] = ACTIONS(1),
    [sym__list_marker_star] = ACTIONS(1),
    [sym__list_marker_parenthesis] = ACTIONS(1),
    [sym__list_marker_dot] = ACTIONS(1),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1),
    [sym__blank_line_start] = ACTIONS(1),
    [sym__fenced_code_block_end_backtick] = ACTIONS(1),
    [sym__fenced_code_block_end_tilde] = ACTIONS(1),
    [sym__html_block_1_start] = ACTIONS(1),
    [sym__html_block_1_end] = ACTIONS(1),
    [sym__html_block_2_start] = ACTIONS(1),
    [sym__html_block_3_start] = ACTIONS(1),
    [sym__html_block_4_start] = ACTIONS(1),
    [sym__html_block_5_start] = ACTIONS(1),
    [sym__html_block_6_start] = ACTIONS(1),
    [sym__html_block_7_start] = ACTIONS(1),
    [sym__close_block] = ACTIONS(1),
    [sym__no_indented_chunk] = ACTIONS(1),
    [sym__error] = ACTIONS(1),
    [sym__trigger_error] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
    [sym_minus_metadata] = ACTIONS(1),
    [sym_plus_metadata] = ACTIONS(1),
    [sym__pipe_table_start] = ACTIONS(1),
    [sym__pipe_table_line_ending] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(907),
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_section] = STATE(635),
    [sym__section1] = STATE(657),
    [sym__section2] = STATE(657),
    [sym__section3] = STATE(657),
    [sym__section4] = STATE(657),
    [sym__section5] = STATE(657),
    [sym__section6] = STATE(657),
    [sym_thematic_break] = STATE(258),
    [sym__atx_heading1] = STATE(37),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(24),
    [aux_sym_document_repeat2] = STATE(635),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(17),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym_minus_metadata] = ACTIONS(61),
    [sym_plus_metadata] = ACTIONS(61),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [2] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(900),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(71),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [3] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(868),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(113),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [4] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(910),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(115),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [5] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(869),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(117),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [6] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(904),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(119),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [7] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(901),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(121),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [8] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(870),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(123),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [9] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(871),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(125),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [10] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(875),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(127),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [11] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(909),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym_block_continuation] = ACTIONS(129),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [12] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(891),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [13] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(894),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [14] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(892),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [15] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(897),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [16] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(857),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [17] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(887),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [18] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(895),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [19] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(884),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [20] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(893),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [21] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(29),
    [sym__block_not_section] = STATE(29),
    [sym_section] = STATE(29),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(29),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(29),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(29),
    [sym_html_block] = STATE(29),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(29),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(145),
    [sym_block_quote] = STATE(29),
    [sym_list] = STATE(29),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__list_item_content] = STATE(873),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_task_list_marker_checked] = STATE(872),
    [sym_task_list_marker_unchecked] = STATE(872),
    [sym_pipe_table] = STATE(29),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(29),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(65),
    [aux_sym__word_token2] = ACTIONS(67),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [22] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(26),
    [sym__block_not_section] = STATE(26),
    [sym_section] = STATE(26),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(26),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(26),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(26),
    [sym_html_block] = STATE(26),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(26),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(26),
    [sym_block_quote] = STATE(26),
    [sym_list] = STATE(26),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(26),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(26),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(131),
    [sym_block_continuation] = ACTIONS(133),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [23] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(25),
    [sym__block_not_section] = STATE(25),
    [sym_section] = STATE(25),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(25),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(25),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(25),
    [sym_html_block] = STATE(25),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(25),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(25),
    [sym_block_quote] = STATE(25),
    [sym_list] = STATE(25),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(25),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(25),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(135),
    [sym_block_continuation] = ACTIONS(137),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [24] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_section] = STATE(632),
    [sym__section1] = STATE(657),
    [sym__section2] = STATE(657),
    [sym__section3] = STATE(657),
    [sym__section4] = STATE(657),
    [sym__section5] = STATE(657),
    [sym__section6] = STATE(657),
    [sym_thematic_break] = STATE(258),
    [sym__atx_heading1] = STATE(37),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(68),
    [aux_sym_document_repeat2] = STATE(632),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(17),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [25] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(141),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [26] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(143),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [27] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(33),
    [sym__block_not_section] = STATE(33),
    [sym_section] = STATE(33),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(33),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(33),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(33),
    [sym_html_block] = STATE(33),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(33),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(33),
    [sym_block_quote] = STATE(33),
    [sym_list] = STATE(33),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(33),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(33),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(143),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [28] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_section] = STATE(636),
    [sym__section1] = STATE(657),
    [sym__section2] = STATE(657),
    [sym__section3] = STATE(657),
    [sym__section4] = STATE(657),
    [sym__section5] = STATE(657),
    [sym__section6] = STATE(657),
    [sym_thematic_break] = STATE(258),
    [sym__atx_heading1] = STATE(37),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(68),
    [aux_sym_document_repeat2] = STATE(636),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(17),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [29] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(147),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [30] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_section] = STATE(634),
    [sym__section1] = STATE(657),
    [sym__section2] = STATE(657),
    [sym__section3] = STATE(657),
    [sym__section4] = STATE(657),
    [sym__section5] = STATE(657),
    [sym__section6] = STATE(657),
    [sym_thematic_break] = STATE(258),
    [sym__atx_heading1] = STATE(37),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(28),
    [aux_sym_document_repeat2] = STATE(634),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(17),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [31] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(151),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [32] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_BANG] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [anon_sym_POUND] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_PERCENT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
    [anon_sym_SQUOTE] = ACTIONS(156),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(156),
    [anon_sym_DASH] = ACTIONS(156),
    [anon_sym_DOT] = ACTIONS(156),
    [anon_sym_SLASH] = ACTIONS(156),
    [anon_sym_COLON] = ACTIONS(156),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_EQ] = ACTIONS(156),
    [anon_sym_QMARK] = ACTIONS(156),
    [anon_sym_AT] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(156),
    [anon_sym_CARET] = ACTIONS(156),
    [anon_sym__] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_RBRACE] = ACTIONS(156),
    [anon_sym_TILDE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(156),
    [anon_sym_RPAREN] = ACTIONS(156),
    [aux_sym__word_token1] = ACTIONS(156),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(156),
    [aux_sym__word_token2] = ACTIONS(156),
    [sym__whitespace] = ACTIONS(159),
    [sym__soft_line_ending] = ACTIONS(162),
    [sym__block_close] = ACTIONS(165),
    [sym__block_quote_start] = ACTIONS(167),
    [sym__indented_chunk_start] = ACTIONS(170),
    [sym_atx_h1_marker] = ACTIONS(173),
    [sym_atx_h2_marker] = ACTIONS(176),
    [sym_atx_h3_marker] = ACTIONS(179),
    [sym_atx_h4_marker] = ACTIONS(182),
    [sym_atx_h5_marker] = ACTIONS(185),
    [sym_atx_h6_marker] = ACTIONS(188),
    [sym__thematic_break] = ACTIONS(191),
    [sym__list_marker_minus] = ACTIONS(194),
    [sym__list_marker_plus] = ACTIONS(197),
    [sym__list_marker_star] = ACTIONS(200),
    [sym__list_marker_parenthesis] = ACTIONS(203),
    [sym__list_marker_dot] = ACTIONS(206),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(194),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(197),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(200),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(203),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(206),
    [sym__fenced_code_block_start_backtick] = ACTIONS(209),
    [sym__fenced_code_block_start_tilde] = ACTIONS(212),
    [sym__blank_line_start] = ACTIONS(215),
    [sym__html_block_1_start] = ACTIONS(218),
    [sym__html_block_2_start] = ACTIONS(221),
    [sym__html_block_3_start] = ACTIONS(224),
    [sym__html_block_4_start] = ACTIONS(227),
    [sym__html_block_5_start] = ACTIONS(230),
    [sym__html_block_6_start] = ACTIONS(233),
    [sym__html_block_7_start] = ACTIONS(236),
    [sym__pipe_table_start] = ACTIONS(239),
  },
  [33] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(242),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [34] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(36),
    [sym__block_not_section] = STATE(36),
    [sym_section] = STATE(36),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(36),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(36),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(36),
    [sym_html_block] = STATE(36),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(36),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(36),
    [sym_block_quote] = STATE(36),
    [sym_list] = STATE(36),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(36),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(36),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(141),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [35] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(31),
    [sym__block_not_section] = STATE(31),
    [sym_section] = STATE(31),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(31),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(31),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(31),
    [sym_html_block] = STATE(31),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(31),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(31),
    [sym_block_quote] = STATE(31),
    [sym_list] = STATE(31),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(31),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(31),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(244),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [36] = {
    [sym_link_label] = STATE(912),
    [sym__block] = STATE(32),
    [sym__block_not_section] = STATE(32),
    [sym_section] = STATE(32),
    [sym__section1] = STATE(311),
    [sym__section2] = STATE(311),
    [sym__section3] = STATE(311),
    [sym__section4] = STATE(311),
    [sym__section5] = STATE(311),
    [sym__section6] = STATE(311),
    [sym_thematic_break] = STATE(32),
    [sym__atx_heading1] = STATE(42),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(32),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(32),
    [sym_html_block] = STATE(32),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(32),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(32),
    [sym_block_quote] = STATE(32),
    [sym_list] = STATE(32),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(32),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym_block_quote_repeat1] = STATE(32),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(246),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(77),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [37] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(40),
    [sym__section2] = STATE(324),
    [sym__section3] = STATE(324),
    [sym__section4] = STATE(324),
    [sym__section5] = STATE(324),
    [sym__section6] = STATE(324),
    [sym_thematic_break] = STATE(40),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(40),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(40),
    [sym_html_block] = STATE(40),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(40),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(40),
    [sym_block_quote] = STATE(40),
    [sym_list] = STATE(40),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(40),
    [aux_sym__section1_repeat1] = STATE(40),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(248),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [38] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(38),
    [sym__section2] = STATE(290),
    [sym__section3] = STATE(290),
    [sym__section4] = STATE(290),
    [sym__section5] = STATE(290),
    [sym__section6] = STATE(290),
    [sym_thematic_break] = STATE(38),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(38),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(38),
    [sym_html_block] = STATE(38),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(38),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(38),
    [sym_block_quote] = STATE(38),
    [sym_list] = STATE(38),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(38),
    [aux_sym__section1_repeat1] = STATE(38),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_LT] = ACTIONS(253),
    [anon_sym_GT] = ACTIONS(253),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_POUND] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_SQUOTE] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DOT] = ACTIONS(253),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(253),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(253),
    [anon_sym_AT] = ACTIONS(253),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_CARET] = ACTIONS(253),
    [anon_sym__] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PIPE] = ACTIONS(253),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(253),
    [aux_sym__word_token1] = ACTIONS(253),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(253),
    [aux_sym__word_token2] = ACTIONS(253),
    [sym__whitespace] = ACTIONS(256),
    [sym__soft_line_ending] = ACTIONS(259),
    [sym__block_close] = ACTIONS(262),
    [sym__block_quote_start] = ACTIONS(264),
    [sym__indented_chunk_start] = ACTIONS(267),
    [sym_atx_h1_marker] = ACTIONS(262),
    [sym_atx_h2_marker] = ACTIONS(270),
    [sym_atx_h3_marker] = ACTIONS(273),
    [sym_atx_h4_marker] = ACTIONS(276),
    [sym_atx_h5_marker] = ACTIONS(279),
    [sym_atx_h6_marker] = ACTIONS(282),
    [sym__thematic_break] = ACTIONS(285),
    [sym__list_marker_minus] = ACTIONS(288),
    [sym__list_marker_plus] = ACTIONS(291),
    [sym__list_marker_star] = ACTIONS(294),
    [sym__list_marker_parenthesis] = ACTIONS(297),
    [sym__list_marker_dot] = ACTIONS(300),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(291),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(294),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(297),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(300),
    [sym__fenced_code_block_start_backtick] = ACTIONS(303),
    [sym__fenced_code_block_start_tilde] = ACTIONS(306),
    [sym__blank_line_start] = ACTIONS(309),
    [sym__html_block_1_start] = ACTIONS(312),
    [sym__html_block_2_start] = ACTIONS(315),
    [sym__html_block_3_start] = ACTIONS(318),
    [sym__html_block_4_start] = ACTIONS(321),
    [sym__html_block_5_start] = ACTIONS(324),
    [sym__html_block_6_start] = ACTIONS(327),
    [sym__html_block_7_start] = ACTIONS(330),
    [sym__pipe_table_start] = ACTIONS(333),
  },
  [39] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(38),
    [sym__section2] = STATE(290),
    [sym__section3] = STATE(290),
    [sym__section4] = STATE(290),
    [sym__section5] = STATE(290),
    [sym__section6] = STATE(290),
    [sym_thematic_break] = STATE(38),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(38),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(38),
    [sym_html_block] = STATE(38),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(38),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(38),
    [sym_block_quote] = STATE(38),
    [sym_list] = STATE(38),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(38),
    [aux_sym__section1_repeat1] = STATE(38),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(336),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(336),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [40] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(41),
    [sym__section2] = STATE(324),
    [sym__section3] = STATE(324),
    [sym__section4] = STATE(324),
    [sym__section5] = STATE(324),
    [sym__section6] = STATE(324),
    [sym_thematic_break] = STATE(41),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(41),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(41),
    [sym_html_block] = STATE(41),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(41),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(41),
    [sym_block_quote] = STATE(41),
    [sym_list] = STATE(41),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(41),
    [aux_sym__section1_repeat1] = STATE(41),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(336),
    [sym_atx_h2_marker] = ACTIONS(19),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [41] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(41),
    [sym__section2] = STATE(324),
    [sym__section3] = STATE(324),
    [sym__section4] = STATE(324),
    [sym__section5] = STATE(324),
    [sym__section6] = STATE(324),
    [sym_thematic_break] = STATE(41),
    [sym__atx_heading2] = STATE(45),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(41),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(41),
    [sym_html_block] = STATE(41),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(41),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(41),
    [sym_block_quote] = STATE(41),
    [sym_list] = STATE(41),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(41),
    [aux_sym__section1_repeat1] = STATE(41),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_LT] = ACTIONS(253),
    [anon_sym_GT] = ACTIONS(253),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [anon_sym_POUND] = ACTIONS(253),
    [anon_sym_DOLLAR] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_SQUOTE] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DOT] = ACTIONS(253),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(253),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(253),
    [anon_sym_QMARK] = ACTIONS(253),
    [anon_sym_AT] = ACTIONS(253),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_CARET] = ACTIONS(253),
    [anon_sym__] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PIPE] = ACTIONS(253),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(253),
    [aux_sym__word_token1] = ACTIONS(253),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(253),
    [aux_sym__word_token2] = ACTIONS(253),
    [sym__whitespace] = ACTIONS(338),
    [sym__soft_line_ending] = ACTIONS(259),
    [sym__block_quote_start] = ACTIONS(341),
    [sym__indented_chunk_start] = ACTIONS(344),
    [sym_atx_h1_marker] = ACTIONS(262),
    [sym_atx_h2_marker] = ACTIONS(347),
    [sym_atx_h3_marker] = ACTIONS(350),
    [sym_atx_h4_marker] = ACTIONS(353),
    [sym_atx_h5_marker] = ACTIONS(356),
    [sym_atx_h6_marker] = ACTIONS(359),
    [sym__thematic_break] = ACTIONS(362),
    [sym__list_marker_minus] = ACTIONS(288),
    [sym__list_marker_plus] = ACTIONS(291),
    [sym__list_marker_star] = ACTIONS(294),
    [sym__list_marker_parenthesis] = ACTIONS(297),
    [sym__list_marker_dot] = ACTIONS(300),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(291),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(294),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(297),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(300),
    [sym__fenced_code_block_start_backtick] = ACTIONS(365),
    [sym__fenced_code_block_start_tilde] = ACTIONS(368),
    [sym__blank_line_start] = ACTIONS(371),
    [sym__html_block_1_start] = ACTIONS(374),
    [sym__html_block_2_start] = ACTIONS(377),
    [sym__html_block_3_start] = ACTIONS(380),
    [sym__html_block_4_start] = ACTIONS(383),
    [sym__html_block_5_start] = ACTIONS(386),
    [sym__html_block_6_start] = ACTIONS(389),
    [sym__html_block_7_start] = ACTIONS(392),
    [sym__pipe_table_start] = ACTIONS(395),
  },
  [42] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(39),
    [sym__section2] = STATE(290),
    [sym__section3] = STATE(290),
    [sym__section4] = STATE(290),
    [sym__section5] = STATE(290),
    [sym__section6] = STATE(290),
    [sym_thematic_break] = STATE(39),
    [sym__atx_heading2] = STATE(43),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(39),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(39),
    [sym_html_block] = STATE(39),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(39),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(39),
    [sym_block_quote] = STATE(39),
    [sym_list] = STATE(39),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(39),
    [aux_sym__section1_repeat1] = STATE(39),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(248),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(248),
    [sym_atx_h2_marker] = ACTIONS(79),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [43] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(47),
    [sym__section3] = STATE(289),
    [sym__section4] = STATE(289),
    [sym__section5] = STATE(289),
    [sym__section6] = STATE(289),
    [sym_thematic_break] = STATE(47),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(47),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(47),
    [sym_html_block] = STATE(47),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(47),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(47),
    [sym_block_quote] = STATE(47),
    [sym_list] = STATE(47),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(47),
    [aux_sym__section2_repeat1] = STATE(47),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(398),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(398),
    [sym_atx_h2_marker] = ACTIONS(398),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [44] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(44),
    [sym__section3] = STATE(289),
    [sym__section4] = STATE(289),
    [sym__section5] = STATE(289),
    [sym__section6] = STATE(289),
    [sym_thematic_break] = STATE(44),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(44),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(44),
    [sym_html_block] = STATE(44),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(44),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(44),
    [sym_block_quote] = STATE(44),
    [sym_list] = STATE(44),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(44),
    [aux_sym__section2_repeat1] = STATE(44),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [anon_sym_POUND] = ACTIONS(403),
    [anon_sym_DOLLAR] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_COLON] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(403),
    [anon_sym__] = ACTIONS(403),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(403),
    [aux_sym__word_token1] = ACTIONS(403),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(403),
    [aux_sym__word_token2] = ACTIONS(403),
    [sym__whitespace] = ACTIONS(406),
    [sym__soft_line_ending] = ACTIONS(409),
    [sym__block_close] = ACTIONS(412),
    [sym__block_quote_start] = ACTIONS(414),
    [sym__indented_chunk_start] = ACTIONS(417),
    [sym_atx_h1_marker] = ACTIONS(412),
    [sym_atx_h2_marker] = ACTIONS(412),
    [sym_atx_h3_marker] = ACTIONS(420),
    [sym_atx_h4_marker] = ACTIONS(423),
    [sym_atx_h5_marker] = ACTIONS(426),
    [sym_atx_h6_marker] = ACTIONS(429),
    [sym__thematic_break] = ACTIONS(432),
    [sym__list_marker_minus] = ACTIONS(435),
    [sym__list_marker_plus] = ACTIONS(438),
    [sym__list_marker_star] = ACTIONS(441),
    [sym__list_marker_parenthesis] = ACTIONS(444),
    [sym__list_marker_dot] = ACTIONS(447),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(435),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(438),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(441),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(444),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(447),
    [sym__fenced_code_block_start_backtick] = ACTIONS(450),
    [sym__fenced_code_block_start_tilde] = ACTIONS(453),
    [sym__blank_line_start] = ACTIONS(456),
    [sym__html_block_1_start] = ACTIONS(459),
    [sym__html_block_2_start] = ACTIONS(462),
    [sym__html_block_3_start] = ACTIONS(465),
    [sym__html_block_4_start] = ACTIONS(468),
    [sym__html_block_5_start] = ACTIONS(471),
    [sym__html_block_6_start] = ACTIONS(474),
    [sym__html_block_7_start] = ACTIONS(477),
    [sym__pipe_table_start] = ACTIONS(480),
  },
  [45] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(46),
    [sym__section3] = STATE(319),
    [sym__section4] = STATE(319),
    [sym__section5] = STATE(319),
    [sym__section6] = STATE(319),
    [sym_thematic_break] = STATE(46),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(46),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(46),
    [sym_html_block] = STATE(46),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(46),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(46),
    [sym_block_quote] = STATE(46),
    [sym_list] = STATE(46),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(46),
    [aux_sym__section2_repeat1] = STATE(46),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(398),
    [sym_atx_h2_marker] = ACTIONS(398),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [46] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(48),
    [sym__section3] = STATE(319),
    [sym__section4] = STATE(319),
    [sym__section5] = STATE(319),
    [sym__section6] = STATE(319),
    [sym_thematic_break] = STATE(48),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(48),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(48),
    [sym_html_block] = STATE(48),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(48),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(48),
    [sym_block_quote] = STATE(48),
    [sym_list] = STATE(48),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(48),
    [aux_sym__section2_repeat1] = STATE(48),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(483),
    [sym_atx_h2_marker] = ACTIONS(483),
    [sym_atx_h3_marker] = ACTIONS(21),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [47] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(44),
    [sym__section3] = STATE(289),
    [sym__section4] = STATE(289),
    [sym__section5] = STATE(289),
    [sym__section6] = STATE(289),
    [sym_thematic_break] = STATE(44),
    [sym__atx_heading3] = STATE(53),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(44),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(44),
    [sym_html_block] = STATE(44),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(44),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(44),
    [sym_block_quote] = STATE(44),
    [sym_list] = STATE(44),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(44),
    [aux_sym__section2_repeat1] = STATE(44),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(483),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(483),
    [sym_atx_h2_marker] = ACTIONS(483),
    [sym_atx_h3_marker] = ACTIONS(81),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [48] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(48),
    [sym__section3] = STATE(319),
    [sym__section4] = STATE(319),
    [sym__section5] = STATE(319),
    [sym__section6] = STATE(319),
    [sym_thematic_break] = STATE(48),
    [sym__atx_heading3] = STATE(49),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(48),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(48),
    [sym_html_block] = STATE(48),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(48),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(48),
    [sym_block_quote] = STATE(48),
    [sym_list] = STATE(48),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(48),
    [aux_sym__section2_repeat1] = STATE(48),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [anon_sym_POUND] = ACTIONS(403),
    [anon_sym_DOLLAR] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_DOT] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(403),
    [anon_sym_COLON] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(403),
    [anon_sym__] = ACTIONS(403),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(403),
    [aux_sym__word_token1] = ACTIONS(403),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(403),
    [aux_sym__word_token2] = ACTIONS(403),
    [sym__whitespace] = ACTIONS(485),
    [sym__soft_line_ending] = ACTIONS(409),
    [sym__block_quote_start] = ACTIONS(488),
    [sym__indented_chunk_start] = ACTIONS(491),
    [sym_atx_h1_marker] = ACTIONS(412),
    [sym_atx_h2_marker] = ACTIONS(412),
    [sym_atx_h3_marker] = ACTIONS(494),
    [sym_atx_h4_marker] = ACTIONS(497),
    [sym_atx_h5_marker] = ACTIONS(500),
    [sym_atx_h6_marker] = ACTIONS(503),
    [sym__thematic_break] = ACTIONS(506),
    [sym__list_marker_minus] = ACTIONS(435),
    [sym__list_marker_plus] = ACTIONS(438),
    [sym__list_marker_star] = ACTIONS(441),
    [sym__list_marker_parenthesis] = ACTIONS(444),
    [sym__list_marker_dot] = ACTIONS(447),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(435),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(438),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(441),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(444),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(447),
    [sym__fenced_code_block_start_backtick] = ACTIONS(509),
    [sym__fenced_code_block_start_tilde] = ACTIONS(512),
    [sym__blank_line_start] = ACTIONS(515),
    [sym__html_block_1_start] = ACTIONS(518),
    [sym__html_block_2_start] = ACTIONS(521),
    [sym__html_block_3_start] = ACTIONS(524),
    [sym__html_block_4_start] = ACTIONS(527),
    [sym__html_block_5_start] = ACTIONS(530),
    [sym__html_block_6_start] = ACTIONS(533),
    [sym__html_block_7_start] = ACTIONS(536),
    [sym__pipe_table_start] = ACTIONS(539),
  },
  [49] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(51),
    [sym__section4] = STATE(260),
    [sym__section5] = STATE(260),
    [sym__section6] = STATE(260),
    [sym_thematic_break] = STATE(51),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(51),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(51),
    [sym_html_block] = STATE(51),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(51),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(51),
    [sym_block_quote] = STATE(51),
    [sym_list] = STATE(51),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(51),
    [aux_sym__section3_repeat1] = STATE(51),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(542),
    [sym_atx_h2_marker] = ACTIONS(542),
    [sym_atx_h3_marker] = ACTIONS(542),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [50] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(52),
    [sym__section4] = STATE(285),
    [sym__section5] = STATE(285),
    [sym__section6] = STATE(285),
    [sym_thematic_break] = STATE(52),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(52),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(52),
    [sym_html_block] = STATE(52),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(52),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(52),
    [sym_block_quote] = STATE(52),
    [sym_list] = STATE(52),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(52),
    [aux_sym__section3_repeat1] = STATE(52),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(544),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(544),
    [sym_atx_h2_marker] = ACTIONS(544),
    [sym_atx_h3_marker] = ACTIONS(544),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [51] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(54),
    [sym__section4] = STATE(260),
    [sym__section5] = STATE(260),
    [sym__section6] = STATE(260),
    [sym_thematic_break] = STATE(54),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(54),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(54),
    [sym_html_block] = STATE(54),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(54),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(54),
    [sym_block_quote] = STATE(54),
    [sym_list] = STATE(54),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(54),
    [aux_sym__section3_repeat1] = STATE(54),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(544),
    [sym_atx_h2_marker] = ACTIONS(544),
    [sym_atx_h3_marker] = ACTIONS(544),
    [sym_atx_h4_marker] = ACTIONS(23),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [52] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(52),
    [sym__section4] = STATE(285),
    [sym__section5] = STATE(285),
    [sym__section6] = STATE(285),
    [sym_thematic_break] = STATE(52),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(52),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(52),
    [sym_html_block] = STATE(52),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(52),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(52),
    [sym_block_quote] = STATE(52),
    [sym_list] = STATE(52),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(52),
    [aux_sym__section3_repeat1] = STATE(52),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DQUOTE] = ACTIONS(549),
    [anon_sym_POUND] = ACTIONS(549),
    [anon_sym_DOLLAR] = ACTIONS(549),
    [anon_sym_PERCENT] = ACTIONS(549),
    [anon_sym_AMP] = ACTIONS(549),
    [anon_sym_SQUOTE] = ACTIONS(549),
    [anon_sym_STAR] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(549),
    [anon_sym_COLON] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(549),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(549),
    [anon_sym_AT] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(549),
    [anon_sym_CARET] = ACTIONS(549),
    [anon_sym__] = ACTIONS(549),
    [anon_sym_BQUOTE] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(549),
    [aux_sym__word_token1] = ACTIONS(549),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(549),
    [aux_sym__word_token2] = ACTIONS(549),
    [sym__whitespace] = ACTIONS(552),
    [sym__soft_line_ending] = ACTIONS(555),
    [sym__block_close] = ACTIONS(558),
    [sym__block_quote_start] = ACTIONS(560),
    [sym__indented_chunk_start] = ACTIONS(563),
    [sym_atx_h1_marker] = ACTIONS(558),
    [sym_atx_h2_marker] = ACTIONS(558),
    [sym_atx_h3_marker] = ACTIONS(558),
    [sym_atx_h4_marker] = ACTIONS(566),
    [sym_atx_h5_marker] = ACTIONS(569),
    [sym_atx_h6_marker] = ACTIONS(572),
    [sym__thematic_break] = ACTIONS(575),
    [sym__list_marker_minus] = ACTIONS(578),
    [sym__list_marker_plus] = ACTIONS(581),
    [sym__list_marker_star] = ACTIONS(584),
    [sym__list_marker_parenthesis] = ACTIONS(587),
    [sym__list_marker_dot] = ACTIONS(590),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(578),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(581),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(584),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(587),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(590),
    [sym__fenced_code_block_start_backtick] = ACTIONS(593),
    [sym__fenced_code_block_start_tilde] = ACTIONS(596),
    [sym__blank_line_start] = ACTIONS(599),
    [sym__html_block_1_start] = ACTIONS(602),
    [sym__html_block_2_start] = ACTIONS(605),
    [sym__html_block_3_start] = ACTIONS(608),
    [sym__html_block_4_start] = ACTIONS(611),
    [sym__html_block_5_start] = ACTIONS(614),
    [sym__html_block_6_start] = ACTIONS(617),
    [sym__html_block_7_start] = ACTIONS(620),
    [sym__pipe_table_start] = ACTIONS(623),
  },
  [53] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(50),
    [sym__section4] = STATE(285),
    [sym__section5] = STATE(285),
    [sym__section6] = STATE(285),
    [sym_thematic_break] = STATE(50),
    [sym__atx_heading4] = STATE(59),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(50),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(50),
    [sym_html_block] = STATE(50),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(50),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(50),
    [sym_block_quote] = STATE(50),
    [sym_list] = STATE(50),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(50),
    [aux_sym__section3_repeat1] = STATE(50),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(542),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(542),
    [sym_atx_h2_marker] = ACTIONS(542),
    [sym_atx_h3_marker] = ACTIONS(542),
    [sym_atx_h4_marker] = ACTIONS(83),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [54] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(54),
    [sym__section4] = STATE(260),
    [sym__section5] = STATE(260),
    [sym__section6] = STATE(260),
    [sym_thematic_break] = STATE(54),
    [sym__atx_heading4] = STATE(60),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(54),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(54),
    [sym_html_block] = STATE(54),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(54),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(54),
    [sym_block_quote] = STATE(54),
    [sym_list] = STATE(54),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(54),
    [aux_sym__section3_repeat1] = STATE(54),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DQUOTE] = ACTIONS(549),
    [anon_sym_POUND] = ACTIONS(549),
    [anon_sym_DOLLAR] = ACTIONS(549),
    [anon_sym_PERCENT] = ACTIONS(549),
    [anon_sym_AMP] = ACTIONS(549),
    [anon_sym_SQUOTE] = ACTIONS(549),
    [anon_sym_STAR] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(549),
    [anon_sym_COLON] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(549),
    [anon_sym_EQ] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(549),
    [anon_sym_AT] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(549),
    [anon_sym_CARET] = ACTIONS(549),
    [anon_sym__] = ACTIONS(549),
    [anon_sym_BQUOTE] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(549),
    [aux_sym__word_token1] = ACTIONS(549),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(549),
    [aux_sym__word_token2] = ACTIONS(549),
    [sym__whitespace] = ACTIONS(626),
    [sym__soft_line_ending] = ACTIONS(555),
    [sym__block_quote_start] = ACTIONS(629),
    [sym__indented_chunk_start] = ACTIONS(632),
    [sym_atx_h1_marker] = ACTIONS(558),
    [sym_atx_h2_marker] = ACTIONS(558),
    [sym_atx_h3_marker] = ACTIONS(558),
    [sym_atx_h4_marker] = ACTIONS(635),
    [sym_atx_h5_marker] = ACTIONS(638),
    [sym_atx_h6_marker] = ACTIONS(641),
    [sym__thematic_break] = ACTIONS(644),
    [sym__list_marker_minus] = ACTIONS(578),
    [sym__list_marker_plus] = ACTIONS(581),
    [sym__list_marker_star] = ACTIONS(584),
    [sym__list_marker_parenthesis] = ACTIONS(587),
    [sym__list_marker_dot] = ACTIONS(590),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(578),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(581),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(584),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(587),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(590),
    [sym__fenced_code_block_start_backtick] = ACTIONS(647),
    [sym__fenced_code_block_start_tilde] = ACTIONS(650),
    [sym__blank_line_start] = ACTIONS(653),
    [sym__html_block_1_start] = ACTIONS(656),
    [sym__html_block_2_start] = ACTIONS(659),
    [sym__html_block_3_start] = ACTIONS(662),
    [sym__html_block_4_start] = ACTIONS(665),
    [sym__html_block_5_start] = ACTIONS(668),
    [sym__html_block_6_start] = ACTIONS(671),
    [sym__html_block_7_start] = ACTIONS(674),
    [sym__pipe_table_start] = ACTIONS(677),
  },
  [55] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(56),
    [sym__section5] = STATE(279),
    [sym__section6] = STATE(279),
    [sym_thematic_break] = STATE(56),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(56),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(56),
    [sym_html_block] = STATE(56),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(56),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(56),
    [sym_block_quote] = STATE(56),
    [sym_list] = STATE(56),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(56),
    [aux_sym__section4_repeat1] = STATE(56),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(680),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(680),
    [sym_atx_h2_marker] = ACTIONS(680),
    [sym_atx_h3_marker] = ACTIONS(680),
    [sym_atx_h4_marker] = ACTIONS(680),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [56] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(56),
    [sym__section5] = STATE(279),
    [sym__section6] = STATE(279),
    [sym_thematic_break] = STATE(56),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(56),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(56),
    [sym_html_block] = STATE(56),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(56),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(56),
    [sym_block_quote] = STATE(56),
    [sym_list] = STATE(56),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(56),
    [aux_sym__section4_repeat1] = STATE(56),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_POUND] = ACTIONS(685),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_PERCENT] = ACTIONS(685),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_DOT] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(685),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_EQ] = ACTIONS(685),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym__] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(685),
    [anon_sym_RPAREN] = ACTIONS(685),
    [aux_sym__word_token1] = ACTIONS(685),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(685),
    [aux_sym__word_token2] = ACTIONS(685),
    [sym__whitespace] = ACTIONS(688),
    [sym__soft_line_ending] = ACTIONS(691),
    [sym__block_close] = ACTIONS(694),
    [sym__block_quote_start] = ACTIONS(696),
    [sym__indented_chunk_start] = ACTIONS(699),
    [sym_atx_h1_marker] = ACTIONS(694),
    [sym_atx_h2_marker] = ACTIONS(694),
    [sym_atx_h3_marker] = ACTIONS(694),
    [sym_atx_h4_marker] = ACTIONS(694),
    [sym_atx_h5_marker] = ACTIONS(702),
    [sym_atx_h6_marker] = ACTIONS(705),
    [sym__thematic_break] = ACTIONS(708),
    [sym__list_marker_minus] = ACTIONS(711),
    [sym__list_marker_plus] = ACTIONS(714),
    [sym__list_marker_star] = ACTIONS(717),
    [sym__list_marker_parenthesis] = ACTIONS(720),
    [sym__list_marker_dot] = ACTIONS(723),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(711),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(714),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(717),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(720),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(723),
    [sym__fenced_code_block_start_backtick] = ACTIONS(726),
    [sym__fenced_code_block_start_tilde] = ACTIONS(729),
    [sym__blank_line_start] = ACTIONS(732),
    [sym__html_block_1_start] = ACTIONS(735),
    [sym__html_block_2_start] = ACTIONS(738),
    [sym__html_block_3_start] = ACTIONS(741),
    [sym__html_block_4_start] = ACTIONS(744),
    [sym__html_block_5_start] = ACTIONS(747),
    [sym__html_block_6_start] = ACTIONS(750),
    [sym__html_block_7_start] = ACTIONS(753),
    [sym__pipe_table_start] = ACTIONS(756),
  },
  [57] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(58),
    [sym__section5] = STATE(294),
    [sym__section6] = STATE(294),
    [sym_thematic_break] = STATE(58),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(58),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(58),
    [sym_html_block] = STATE(58),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(58),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(58),
    [sym_block_quote] = STATE(58),
    [sym_list] = STATE(58),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(58),
    [aux_sym__section4_repeat1] = STATE(58),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(680),
    [sym_atx_h2_marker] = ACTIONS(680),
    [sym_atx_h3_marker] = ACTIONS(680),
    [sym_atx_h4_marker] = ACTIONS(680),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [58] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(58),
    [sym__section5] = STATE(294),
    [sym__section6] = STATE(294),
    [sym_thematic_break] = STATE(58),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(58),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(58),
    [sym_html_block] = STATE(58),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(58),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(58),
    [sym_block_quote] = STATE(58),
    [sym_list] = STATE(58),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(58),
    [aux_sym__section4_repeat1] = STATE(58),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(694),
    [anon_sym_LBRACK] = ACTIONS(682),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_POUND] = ACTIONS(685),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_PERCENT] = ACTIONS(685),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_SQUOTE] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_DOT] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_COLON] = ACTIONS(685),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_EQ] = ACTIONS(685),
    [anon_sym_QMARK] = ACTIONS(685),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym__] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(685),
    [anon_sym_RPAREN] = ACTIONS(685),
    [aux_sym__word_token1] = ACTIONS(685),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(685),
    [aux_sym__word_token2] = ACTIONS(685),
    [sym__whitespace] = ACTIONS(759),
    [sym__soft_line_ending] = ACTIONS(691),
    [sym__block_quote_start] = ACTIONS(762),
    [sym__indented_chunk_start] = ACTIONS(765),
    [sym_atx_h1_marker] = ACTIONS(694),
    [sym_atx_h2_marker] = ACTIONS(694),
    [sym_atx_h3_marker] = ACTIONS(694),
    [sym_atx_h4_marker] = ACTIONS(694),
    [sym_atx_h5_marker] = ACTIONS(768),
    [sym_atx_h6_marker] = ACTIONS(771),
    [sym__thematic_break] = ACTIONS(774),
    [sym__list_marker_minus] = ACTIONS(711),
    [sym__list_marker_plus] = ACTIONS(714),
    [sym__list_marker_star] = ACTIONS(717),
    [sym__list_marker_parenthesis] = ACTIONS(720),
    [sym__list_marker_dot] = ACTIONS(723),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(711),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(714),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(717),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(720),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(723),
    [sym__fenced_code_block_start_backtick] = ACTIONS(777),
    [sym__fenced_code_block_start_tilde] = ACTIONS(780),
    [sym__blank_line_start] = ACTIONS(783),
    [sym__html_block_1_start] = ACTIONS(786),
    [sym__html_block_2_start] = ACTIONS(789),
    [sym__html_block_3_start] = ACTIONS(792),
    [sym__html_block_4_start] = ACTIONS(795),
    [sym__html_block_5_start] = ACTIONS(798),
    [sym__html_block_6_start] = ACTIONS(801),
    [sym__html_block_7_start] = ACTIONS(804),
    [sym__pipe_table_start] = ACTIONS(807),
  },
  [59] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(55),
    [sym__section5] = STATE(279),
    [sym__section6] = STATE(279),
    [sym_thematic_break] = STATE(55),
    [sym__atx_heading5] = STATE(64),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(55),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(55),
    [sym_html_block] = STATE(55),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(55),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(55),
    [sym_block_quote] = STATE(55),
    [sym_list] = STATE(55),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(55),
    [aux_sym__section4_repeat1] = STATE(55),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(810),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(810),
    [sym_atx_h2_marker] = ACTIONS(810),
    [sym_atx_h3_marker] = ACTIONS(810),
    [sym_atx_h4_marker] = ACTIONS(810),
    [sym_atx_h5_marker] = ACTIONS(85),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [60] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(57),
    [sym__section5] = STATE(294),
    [sym__section6] = STATE(294),
    [sym_thematic_break] = STATE(57),
    [sym__atx_heading5] = STATE(65),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(57),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(57),
    [sym_html_block] = STATE(57),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(57),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(57),
    [sym_block_quote] = STATE(57),
    [sym_list] = STATE(57),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(57),
    [aux_sym__section4_repeat1] = STATE(57),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(810),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(810),
    [sym_atx_h2_marker] = ACTIONS(810),
    [sym_atx_h3_marker] = ACTIONS(810),
    [sym_atx_h4_marker] = ACTIONS(810),
    [sym_atx_h5_marker] = ACTIONS(25),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [61] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(63),
    [sym__section6] = STATE(268),
    [sym_thematic_break] = STATE(63),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(63),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(63),
    [sym_html_block] = STATE(63),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(63),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(63),
    [sym_block_quote] = STATE(63),
    [sym_list] = STATE(63),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(63),
    [aux_sym__section5_repeat1] = STATE(63),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(812),
    [sym_atx_h2_marker] = ACTIONS(812),
    [sym_atx_h3_marker] = ACTIONS(812),
    [sym_atx_h4_marker] = ACTIONS(812),
    [sym_atx_h5_marker] = ACTIONS(812),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [62] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(62),
    [sym__section6] = STATE(277),
    [sym_thematic_break] = STATE(62),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(62),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(62),
    [sym_html_block] = STATE(62),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(62),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(62),
    [sym_block_quote] = STATE(62),
    [sym_list] = STATE(62),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(62),
    [aux_sym__section5_repeat1] = STATE(62),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_POUND] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_STAR] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_BSLASH] = ACTIONS(817),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym__] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_RPAREN] = ACTIONS(817),
    [aux_sym__word_token1] = ACTIONS(817),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(817),
    [aux_sym__word_token2] = ACTIONS(817),
    [sym__whitespace] = ACTIONS(820),
    [sym__soft_line_ending] = ACTIONS(823),
    [sym__block_close] = ACTIONS(826),
    [sym__block_quote_start] = ACTIONS(828),
    [sym__indented_chunk_start] = ACTIONS(831),
    [sym_atx_h1_marker] = ACTIONS(826),
    [sym_atx_h2_marker] = ACTIONS(826),
    [sym_atx_h3_marker] = ACTIONS(826),
    [sym_atx_h4_marker] = ACTIONS(826),
    [sym_atx_h5_marker] = ACTIONS(826),
    [sym_atx_h6_marker] = ACTIONS(834),
    [sym__thematic_break] = ACTIONS(837),
    [sym__list_marker_minus] = ACTIONS(840),
    [sym__list_marker_plus] = ACTIONS(843),
    [sym__list_marker_star] = ACTIONS(846),
    [sym__list_marker_parenthesis] = ACTIONS(849),
    [sym__list_marker_dot] = ACTIONS(852),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(840),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(843),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(846),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(849),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(852),
    [sym__fenced_code_block_start_backtick] = ACTIONS(855),
    [sym__fenced_code_block_start_tilde] = ACTIONS(858),
    [sym__blank_line_start] = ACTIONS(861),
    [sym__html_block_1_start] = ACTIONS(864),
    [sym__html_block_2_start] = ACTIONS(867),
    [sym__html_block_3_start] = ACTIONS(870),
    [sym__html_block_4_start] = ACTIONS(873),
    [sym__html_block_5_start] = ACTIONS(876),
    [sym__html_block_6_start] = ACTIONS(879),
    [sym__html_block_7_start] = ACTIONS(882),
    [sym__pipe_table_start] = ACTIONS(885),
  },
  [63] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(63),
    [sym__section6] = STATE(268),
    [sym_thematic_break] = STATE(63),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(63),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(63),
    [sym_html_block] = STATE(63),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(63),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(63),
    [sym_block_quote] = STATE(63),
    [sym_list] = STATE(63),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(63),
    [aux_sym__section5_repeat1] = STATE(63),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(817),
    [anon_sym_POUND] = ACTIONS(817),
    [anon_sym_DOLLAR] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(817),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_STAR] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(817),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_BSLASH] = ACTIONS(817),
    [anon_sym_CARET] = ACTIONS(817),
    [anon_sym__] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_RPAREN] = ACTIONS(817),
    [aux_sym__word_token1] = ACTIONS(817),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(817),
    [aux_sym__word_token2] = ACTIONS(817),
    [sym__whitespace] = ACTIONS(888),
    [sym__soft_line_ending] = ACTIONS(823),
    [sym__block_quote_start] = ACTIONS(891),
    [sym__indented_chunk_start] = ACTIONS(894),
    [sym_atx_h1_marker] = ACTIONS(826),
    [sym_atx_h2_marker] = ACTIONS(826),
    [sym_atx_h3_marker] = ACTIONS(826),
    [sym_atx_h4_marker] = ACTIONS(826),
    [sym_atx_h5_marker] = ACTIONS(826),
    [sym_atx_h6_marker] = ACTIONS(897),
    [sym__thematic_break] = ACTIONS(900),
    [sym__list_marker_minus] = ACTIONS(840),
    [sym__list_marker_plus] = ACTIONS(843),
    [sym__list_marker_star] = ACTIONS(846),
    [sym__list_marker_parenthesis] = ACTIONS(849),
    [sym__list_marker_dot] = ACTIONS(852),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(840),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(843),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(846),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(849),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(852),
    [sym__fenced_code_block_start_backtick] = ACTIONS(903),
    [sym__fenced_code_block_start_tilde] = ACTIONS(906),
    [sym__blank_line_start] = ACTIONS(909),
    [sym__html_block_1_start] = ACTIONS(912),
    [sym__html_block_2_start] = ACTIONS(915),
    [sym__html_block_3_start] = ACTIONS(918),
    [sym__html_block_4_start] = ACTIONS(921),
    [sym__html_block_5_start] = ACTIONS(924),
    [sym__html_block_6_start] = ACTIONS(927),
    [sym__html_block_7_start] = ACTIONS(930),
    [sym__pipe_table_start] = ACTIONS(933),
  },
  [64] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(66),
    [sym__section6] = STATE(277),
    [sym_thematic_break] = STATE(66),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(66),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(66),
    [sym_html_block] = STATE(66),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(66),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(66),
    [sym_block_quote] = STATE(66),
    [sym_list] = STATE(66),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(66),
    [aux_sym__section5_repeat1] = STATE(66),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(936),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(936),
    [sym_atx_h2_marker] = ACTIONS(936),
    [sym_atx_h3_marker] = ACTIONS(936),
    [sym_atx_h4_marker] = ACTIONS(936),
    [sym_atx_h5_marker] = ACTIONS(936),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [65] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(61),
    [sym__section6] = STATE(268),
    [sym_thematic_break] = STATE(61),
    [sym__atx_heading6] = STATE(70),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(61),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(61),
    [sym_html_block] = STATE(61),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(61),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(61),
    [sym_block_quote] = STATE(61),
    [sym_list] = STATE(61),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(61),
    [aux_sym__section5_repeat1] = STATE(61),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(936),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(936),
    [sym_atx_h2_marker] = ACTIONS(936),
    [sym_atx_h3_marker] = ACTIONS(936),
    [sym_atx_h4_marker] = ACTIONS(936),
    [sym_atx_h5_marker] = ACTIONS(936),
    [sym_atx_h6_marker] = ACTIONS(27),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [66] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(62),
    [sym__section6] = STATE(277),
    [sym_thematic_break] = STATE(62),
    [sym__atx_heading6] = STATE(72),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(62),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(62),
    [sym_html_block] = STATE(62),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(62),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(62),
    [sym_block_quote] = STATE(62),
    [sym_list] = STATE(62),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(62),
    [aux_sym__section5_repeat1] = STATE(62),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(812),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(812),
    [sym_atx_h2_marker] = ACTIONS(812),
    [sym_atx_h3_marker] = ACTIONS(812),
    [sym_atx_h4_marker] = ACTIONS(812),
    [sym_atx_h5_marker] = ACTIONS(812),
    [sym_atx_h6_marker] = ACTIONS(87),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [67] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_thematic_break] = STATE(258),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(68),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(938),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(938),
    [sym_atx_h2_marker] = ACTIONS(938),
    [sym_atx_h3_marker] = ACTIONS(938),
    [sym_atx_h4_marker] = ACTIONS(938),
    [sym_atx_h5_marker] = ACTIONS(938),
    [sym_atx_h6_marker] = ACTIONS(938),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [68] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_thematic_break] = STATE(258),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(68),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(942),
    [anon_sym_RBRACK] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_POUND] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_COMMA] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_COLON] = ACTIONS(945),
    [anon_sym_SEMI] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_QMARK] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(945),
    [anon_sym__] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_RPAREN] = ACTIONS(945),
    [aux_sym__word_token1] = ACTIONS(945),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(945),
    [aux_sym__word_token2] = ACTIONS(945),
    [sym__whitespace] = ACTIONS(948),
    [sym__soft_line_ending] = ACTIONS(951),
    [sym__block_quote_start] = ACTIONS(954),
    [sym__indented_chunk_start] = ACTIONS(957),
    [sym_atx_h1_marker] = ACTIONS(940),
    [sym_atx_h2_marker] = ACTIONS(940),
    [sym_atx_h3_marker] = ACTIONS(940),
    [sym_atx_h4_marker] = ACTIONS(940),
    [sym_atx_h5_marker] = ACTIONS(940),
    [sym_atx_h6_marker] = ACTIONS(940),
    [sym__thematic_break] = ACTIONS(960),
    [sym__list_marker_minus] = ACTIONS(963),
    [sym__list_marker_plus] = ACTIONS(966),
    [sym__list_marker_star] = ACTIONS(969),
    [sym__list_marker_parenthesis] = ACTIONS(972),
    [sym__list_marker_dot] = ACTIONS(975),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(963),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(966),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(969),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(972),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(975),
    [sym__fenced_code_block_start_backtick] = ACTIONS(978),
    [sym__fenced_code_block_start_tilde] = ACTIONS(981),
    [sym__blank_line_start] = ACTIONS(984),
    [sym__html_block_1_start] = ACTIONS(987),
    [sym__html_block_2_start] = ACTIONS(990),
    [sym__html_block_3_start] = ACTIONS(993),
    [sym__html_block_4_start] = ACTIONS(996),
    [sym__html_block_5_start] = ACTIONS(999),
    [sym__html_block_6_start] = ACTIONS(1002),
    [sym__html_block_7_start] = ACTIONS(1005),
    [sym__pipe_table_start] = ACTIONS(1008),
  },
  [69] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(312),
    [sym_thematic_break] = STATE(312),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(312),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(312),
    [sym_html_block] = STATE(312),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(312),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(312),
    [sym_block_quote] = STATE(312),
    [sym_list] = STATE(312),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(312),
    [aux_sym_document_repeat1] = STATE(69),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(942),
    [anon_sym_RBRACK] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_POUND] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_COMMA] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_COLON] = ACTIONS(945),
    [anon_sym_SEMI] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_QMARK] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(945),
    [anon_sym__] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_PIPE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_RPAREN] = ACTIONS(945),
    [aux_sym__word_token1] = ACTIONS(945),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(945),
    [aux_sym__word_token2] = ACTIONS(945),
    [sym__whitespace] = ACTIONS(1011),
    [sym__soft_line_ending] = ACTIONS(951),
    [sym__block_close] = ACTIONS(940),
    [sym__block_quote_start] = ACTIONS(1014),
    [sym__indented_chunk_start] = ACTIONS(1017),
    [sym_atx_h1_marker] = ACTIONS(940),
    [sym_atx_h2_marker] = ACTIONS(940),
    [sym_atx_h3_marker] = ACTIONS(940),
    [sym_atx_h4_marker] = ACTIONS(940),
    [sym_atx_h5_marker] = ACTIONS(940),
    [sym_atx_h6_marker] = ACTIONS(940),
    [sym__thematic_break] = ACTIONS(1020),
    [sym__list_marker_minus] = ACTIONS(963),
    [sym__list_marker_plus] = ACTIONS(966),
    [sym__list_marker_star] = ACTIONS(969),
    [sym__list_marker_parenthesis] = ACTIONS(972),
    [sym__list_marker_dot] = ACTIONS(975),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(963),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(966),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(969),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(972),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(975),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1023),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1026),
    [sym__blank_line_start] = ACTIONS(1029),
    [sym__html_block_1_start] = ACTIONS(1032),
    [sym__html_block_2_start] = ACTIONS(1035),
    [sym__html_block_3_start] = ACTIONS(1038),
    [sym__html_block_4_start] = ACTIONS(1041),
    [sym__html_block_5_start] = ACTIONS(1044),
    [sym__html_block_6_start] = ACTIONS(1047),
    [sym__html_block_7_start] = ACTIONS(1050),
    [sym__pipe_table_start] = ACTIONS(1053),
  },
  [70] = {
    [sym_link_label] = STATE(905),
    [sym__block_not_section] = STATE(258),
    [sym_thematic_break] = STATE(258),
    [sym__setext_heading1] = STATE(335),
    [sym__setext_heading2] = STATE(274),
    [sym_indented_code_block] = STATE(258),
    [sym__indented_chunk] = STATE(97),
    [sym_fenced_code_block] = STATE(258),
    [sym_html_block] = STATE(258),
    [sym__html_block_1] = STATE(275),
    [sym__html_block_2] = STATE(275),
    [sym__html_block_3] = STATE(275),
    [sym__html_block_4] = STATE(275),
    [sym__html_block_5] = STATE(275),
    [sym__html_block_6] = STATE(275),
    [sym__html_block_7] = STATE(275),
    [sym_link_reference_definition] = STATE(258),
    [sym_paragraph] = STATE(111),
    [sym__blank_line] = STATE(258),
    [sym_block_quote] = STATE(258),
    [sym_list] = STATE(258),
    [sym__list_plus] = STATE(276),
    [sym__list_minus] = STATE(276),
    [sym__list_star] = STATE(276),
    [sym__list_dot] = STATE(276),
    [sym__list_parenthesis] = STATE(276),
    [sym_list_marker_plus] = STATE(10),
    [sym_list_marker_minus] = STATE(9),
    [sym_list_marker_star] = STATE(8),
    [sym_list_marker_dot] = STATE(5),
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_plus] = STATE(98),
    [sym__list_item_minus] = STATE(75),
    [sym__list_item_star] = STATE(94),
    [sym__list_item_dot] = STATE(83),
    [sym__list_item_parenthesis] = STATE(91),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(258),
    [aux_sym_document_repeat1] = STATE(67),
    [aux_sym_paragraph_repeat1] = STATE(369),
    [aux_sym__list_plus_repeat1] = STATE(98),
    [aux_sym__list_minus_repeat1] = STATE(75),
    [aux_sym__list_star_repeat1] = STATE(94),
    [aux_sym__list_dot_repeat1] = STATE(83),
    [aux_sym__list_parenthesis_repeat1] = STATE(91),
    [aux_sym__line_repeat1] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(9),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_quote_start] = ACTIONS(13),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(1056),
    [sym_atx_h2_marker] = ACTIONS(1056),
    [sym_atx_h3_marker] = ACTIONS(1056),
    [sym_atx_h4_marker] = ACTIONS(1056),
    [sym_atx_h5_marker] = ACTIONS(1056),
    [sym_atx_h6_marker] = ACTIONS(1056),
    [sym__thematic_break] = ACTIONS(29),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(41),
    [sym__fenced_code_block_start_tilde] = ACTIONS(43),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(47),
    [sym__html_block_2_start] = ACTIONS(49),
    [sym__html_block_3_start] = ACTIONS(51),
    [sym__html_block_4_start] = ACTIONS(53),
    [sym__html_block_5_start] = ACTIONS(55),
    [sym__html_block_6_start] = ACTIONS(57),
    [sym__html_block_7_start] = ACTIONS(59),
    [sym__pipe_table_start] = ACTIONS(63),
  },
  [71] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(312),
    [sym_thematic_break] = STATE(312),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(312),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(312),
    [sym_html_block] = STATE(312),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(312),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(312),
    [sym_block_quote] = STATE(312),
    [sym_list] = STATE(312),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(312),
    [aux_sym_document_repeat1] = STATE(69),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(938),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(938),
    [sym_atx_h2_marker] = ACTIONS(938),
    [sym_atx_h3_marker] = ACTIONS(938),
    [sym_atx_h4_marker] = ACTIONS(938),
    [sym_atx_h5_marker] = ACTIONS(938),
    [sym_atx_h6_marker] = ACTIONS(938),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [72] = {
    [sym_link_label] = STATE(912),
    [sym__block_not_section] = STATE(312),
    [sym_thematic_break] = STATE(312),
    [sym__setext_heading1] = STATE(309),
    [sym__setext_heading2] = STATE(308),
    [sym_indented_code_block] = STATE(312),
    [sym__indented_chunk] = STATE(90),
    [sym_fenced_code_block] = STATE(312),
    [sym_html_block] = STATE(312),
    [sym__html_block_1] = STATE(307),
    [sym__html_block_2] = STATE(307),
    [sym__html_block_3] = STATE(307),
    [sym__html_block_4] = STATE(307),
    [sym__html_block_5] = STATE(307),
    [sym__html_block_6] = STATE(307),
    [sym__html_block_7] = STATE(307),
    [sym_link_reference_definition] = STATE(312),
    [sym_paragraph] = STATE(113),
    [sym__blank_line] = STATE(312),
    [sym_block_quote] = STATE(312),
    [sym_list] = STATE(312),
    [sym__list_plus] = STATE(306),
    [sym__list_minus] = STATE(306),
    [sym__list_star] = STATE(306),
    [sym__list_dot] = STATE(306),
    [sym__list_parenthesis] = STATE(306),
    [sym_list_marker_plus] = STATE(4),
    [sym_list_marker_minus] = STATE(11),
    [sym_list_marker_star] = STATE(6),
    [sym_list_marker_dot] = STATE(7),
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_plus] = STATE(88),
    [sym__list_item_minus] = STATE(87),
    [sym__list_item_star] = STATE(86),
    [sym__list_item_dot] = STATE(85),
    [sym__list_item_parenthesis] = STATE(84),
    [sym__soft_line_break] = STATE(605),
    [sym__line] = STATE(605),
    [sym__word] = STATE(533),
    [sym_pipe_table] = STATE(312),
    [aux_sym_document_repeat1] = STATE(71),
    [aux_sym_paragraph_repeat1] = STATE(370),
    [aux_sym__list_plus_repeat1] = STATE(88),
    [aux_sym__list_minus_repeat1] = STATE(87),
    [aux_sym__list_star_repeat1] = STATE(86),
    [aux_sym__list_dot_repeat1] = STATE(85),
    [aux_sym__list_parenthesis_repeat1] = STATE(84),
    [aux_sym__line_repeat1] = STATE(533),
    [anon_sym_LBRACK] = ACTIONS(5),
    [anon_sym_RBRACK] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(7),
    [anon_sym_PERCENT] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7),
    [anon_sym_DASH] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(7),
    [anon_sym_SLASH] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7),
    [anon_sym_QMARK] = ACTIONS(7),
    [anon_sym_AT] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(7),
    [anon_sym_CARET] = ACTIONS(7),
    [anon_sym__] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7),
    [aux_sym__word_token1] = ACTIONS(7),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(7),
    [aux_sym__word_token2] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(69),
    [sym__soft_line_ending] = ACTIONS(11),
    [sym__block_close] = ACTIONS(1056),
    [sym__block_quote_start] = ACTIONS(73),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(1056),
    [sym_atx_h2_marker] = ACTIONS(1056),
    [sym_atx_h3_marker] = ACTIONS(1056),
    [sym_atx_h4_marker] = ACTIONS(1056),
    [sym_atx_h5_marker] = ACTIONS(1056),
    [sym_atx_h6_marker] = ACTIONS(1056),
    [sym__thematic_break] = ACTIONS(89),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(91),
    [sym__fenced_code_block_start_tilde] = ACTIONS(93),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(97),
    [sym__html_block_2_start] = ACTIONS(99),
    [sym__html_block_3_start] = ACTIONS(101),
    [sym__html_block_4_start] = ACTIONS(103),
    [sym__html_block_5_start] = ACTIONS(105),
    [sym__html_block_6_start] = ACTIONS(107),
    [sym__html_block_7_start] = ACTIONS(109),
    [sym__pipe_table_start] = ACTIONS(111),
  },
  [73] = {
    [sym__indented_chunk] = STATE(73),
    [sym__blank_line] = STATE(73),
    [aux_sym_indented_code_block_repeat1] = STATE(73),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_RBRACK] = ACTIONS(1060),
    [anon_sym_LT] = ACTIONS(1060),
    [anon_sym_GT] = ACTIONS(1060),
    [anon_sym_BANG] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [anon_sym_POUND] = ACTIONS(1060),
    [anon_sym_DOLLAR] = ACTIONS(1060),
    [anon_sym_PERCENT] = ACTIONS(1060),
    [anon_sym_AMP] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_DOT] = ACTIONS(1060),
    [anon_sym_SLASH] = ACTIONS(1060),
    [anon_sym_COLON] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1060),
    [anon_sym_EQ] = ACTIONS(1060),
    [anon_sym_QMARK] = ACTIONS(1060),
    [anon_sym_AT] = ACTIONS(1060),
    [anon_sym_BSLASH] = ACTIONS(1060),
    [anon_sym_CARET] = ACTIONS(1060),
    [anon_sym__] = ACTIONS(1060),
    [anon_sym_BQUOTE] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_PIPE] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [aux_sym__word_token1] = ACTIONS(1060),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1060),
    [aux_sym__word_token2] = ACTIONS(1060),
    [sym__whitespace] = ACTIONS(1060),
    [sym__soft_line_ending] = ACTIONS(1060),
    [sym__block_close] = ACTIONS(1060),
    [sym__block_quote_start] = ACTIONS(1060),
    [sym__indented_chunk_start] = ACTIONS(1062),
    [sym_atx_h1_marker] = ACTIONS(1060),
    [sym_atx_h2_marker] = ACTIONS(1060),
    [sym_atx_h3_marker] = ACTIONS(1060),
    [sym_atx_h4_marker] = ACTIONS(1060),
    [sym_atx_h5_marker] = ACTIONS(1060),
    [sym_atx_h6_marker] = ACTIONS(1060),
    [sym__thematic_break] = ACTIONS(1060),
    [sym__list_marker_minus] = ACTIONS(1060),
    [sym__list_marker_plus] = ACTIONS(1060),
    [sym__list_marker_star] = ACTIONS(1060),
    [sym__list_marker_parenthesis] = ACTIONS(1060),
    [sym__list_marker_dot] = ACTIONS(1060),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1060),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1060),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1060),
    [sym__blank_line_start] = ACTIONS(1065),
    [sym__html_block_1_start] = ACTIONS(1060),
    [sym__html_block_2_start] = ACTIONS(1060),
    [sym__html_block_3_start] = ACTIONS(1060),
    [sym__html_block_4_start] = ACTIONS(1060),
    [sym__html_block_5_start] = ACTIONS(1060),
    [sym__html_block_6_start] = ACTIONS(1060),
    [sym__html_block_7_start] = ACTIONS(1060),
    [sym__pipe_table_start] = ACTIONS(1060),
  },
  [74] = {
    [sym_list_marker_star] = STATE(8),
    [sym__list_item_star] = STATE(74),
    [aux_sym__list_star_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_RBRACK] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [anon_sym_POUND] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
    [anon_sym_SQUOTE] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_COMMA] = ACTIONS(1068),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1068),
    [anon_sym_COLON] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_EQ] = ACTIONS(1068),
    [anon_sym_QMARK] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1068),
    [anon_sym_BSLASH] = ACTIONS(1068),
    [anon_sym_CARET] = ACTIONS(1068),
    [anon_sym__] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [aux_sym__word_token1] = ACTIONS(1068),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1068),
    [aux_sym__word_token2] = ACTIONS(1068),
    [sym__whitespace] = ACTIONS(1068),
    [sym__soft_line_ending] = ACTIONS(1068),
    [sym__block_quote_start] = ACTIONS(1068),
    [sym__indented_chunk_start] = ACTIONS(1068),
    [sym_atx_h1_marker] = ACTIONS(1068),
    [sym_atx_h2_marker] = ACTIONS(1068),
    [sym_atx_h3_marker] = ACTIONS(1068),
    [sym_atx_h4_marker] = ACTIONS(1068),
    [sym_atx_h5_marker] = ACTIONS(1068),
    [sym_atx_h6_marker] = ACTIONS(1068),
    [sym__thematic_break] = ACTIONS(1068),
    [sym__list_marker_minus] = ACTIONS(1068),
    [sym__list_marker_plus] = ACTIONS(1068),
    [sym__list_marker_star] = ACTIONS(1072),
    [sym__list_marker_parenthesis] = ACTIONS(1068),
    [sym__list_marker_dot] = ACTIONS(1068),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1072),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1068),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1068),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1068),
    [sym__blank_line_start] = ACTIONS(1068),
    [sym__html_block_1_start] = ACTIONS(1068),
    [sym__html_block_2_start] = ACTIONS(1068),
    [sym__html_block_3_start] = ACTIONS(1068),
    [sym__html_block_4_start] = ACTIONS(1068),
    [sym__html_block_5_start] = ACTIONS(1068),
    [sym__html_block_6_start] = ACTIONS(1068),
    [sym__html_block_7_start] = ACTIONS(1068),
    [sym__pipe_table_start] = ACTIONS(1068),
  },
  [75] = {
    [sym_list_marker_minus] = STATE(9),
    [sym__list_item_minus] = STATE(80),
    [aux_sym__list_minus_repeat1] = STATE(80),
    [ts_builtin_sym_end] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1075),
    [anon_sym_POUND] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_COLON] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_BSLASH] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
    [anon_sym_BQUOTE] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [aux_sym__word_token1] = ACTIONS(1075),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1075),
    [aux_sym__word_token2] = ACTIONS(1075),
    [sym__whitespace] = ACTIONS(1075),
    [sym__soft_line_ending] = ACTIONS(1075),
    [sym__block_quote_start] = ACTIONS(1075),
    [sym__indented_chunk_start] = ACTIONS(1075),
    [sym_atx_h1_marker] = ACTIONS(1075),
    [sym_atx_h2_marker] = ACTIONS(1075),
    [sym_atx_h3_marker] = ACTIONS(1075),
    [sym_atx_h4_marker] = ACTIONS(1075),
    [sym_atx_h5_marker] = ACTIONS(1075),
    [sym_atx_h6_marker] = ACTIONS(1075),
    [sym__thematic_break] = ACTIONS(1075),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(1075),
    [sym__list_marker_star] = ACTIONS(1075),
    [sym__list_marker_parenthesis] = ACTIONS(1075),
    [sym__list_marker_dot] = ACTIONS(1075),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1075),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1075),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1075),
    [sym__blank_line_start] = ACTIONS(1075),
    [sym__html_block_1_start] = ACTIONS(1075),
    [sym__html_block_2_start] = ACTIONS(1075),
    [sym__html_block_3_start] = ACTIONS(1075),
    [sym__html_block_4_start] = ACTIONS(1075),
    [sym__html_block_5_start] = ACTIONS(1075),
    [sym__html_block_6_start] = ACTIONS(1075),
    [sym__html_block_7_start] = ACTIONS(1075),
    [sym__pipe_table_start] = ACTIONS(1075),
  },
  [76] = {
    [sym__indented_chunk] = STATE(76),
    [sym__blank_line] = STATE(76),
    [aux_sym_indented_code_block_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_RBRACK] = ACTIONS(1060),
    [anon_sym_LT] = ACTIONS(1060),
    [anon_sym_GT] = ACTIONS(1060),
    [anon_sym_BANG] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [anon_sym_POUND] = ACTIONS(1060),
    [anon_sym_DOLLAR] = ACTIONS(1060),
    [anon_sym_PERCENT] = ACTIONS(1060),
    [anon_sym_AMP] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_DOT] = ACTIONS(1060),
    [anon_sym_SLASH] = ACTIONS(1060),
    [anon_sym_COLON] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1060),
    [anon_sym_EQ] = ACTIONS(1060),
    [anon_sym_QMARK] = ACTIONS(1060),
    [anon_sym_AT] = ACTIONS(1060),
    [anon_sym_BSLASH] = ACTIONS(1060),
    [anon_sym_CARET] = ACTIONS(1060),
    [anon_sym__] = ACTIONS(1060),
    [anon_sym_BQUOTE] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_PIPE] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [aux_sym__word_token1] = ACTIONS(1060),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1060),
    [aux_sym__word_token2] = ACTIONS(1060),
    [sym__whitespace] = ACTIONS(1060),
    [sym__soft_line_ending] = ACTIONS(1060),
    [sym__block_quote_start] = ACTIONS(1060),
    [sym__indented_chunk_start] = ACTIONS(1079),
    [sym_atx_h1_marker] = ACTIONS(1060),
    [sym_atx_h2_marker] = ACTIONS(1060),
    [sym_atx_h3_marker] = ACTIONS(1060),
    [sym_atx_h4_marker] = ACTIONS(1060),
    [sym_atx_h5_marker] = ACTIONS(1060),
    [sym_atx_h6_marker] = ACTIONS(1060),
    [sym__thematic_break] = ACTIONS(1060),
    [sym__list_marker_minus] = ACTIONS(1060),
    [sym__list_marker_plus] = ACTIONS(1060),
    [sym__list_marker_star] = ACTIONS(1060),
    [sym__list_marker_parenthesis] = ACTIONS(1060),
    [sym__list_marker_dot] = ACTIONS(1060),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1060),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1060),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1060),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1060),
    [sym__blank_line_start] = ACTIONS(1082),
    [sym__html_block_1_start] = ACTIONS(1060),
    [sym__html_block_2_start] = ACTIONS(1060),
    [sym__html_block_3_start] = ACTIONS(1060),
    [sym__html_block_4_start] = ACTIONS(1060),
    [sym__html_block_5_start] = ACTIONS(1060),
    [sym__html_block_6_start] = ACTIONS(1060),
    [sym__html_block_7_start] = ACTIONS(1060),
    [sym__pipe_table_start] = ACTIONS(1060),
  },
  [77] = {
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_parenthesis] = STATE(77),
    [aux_sym__list_parenthesis_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_POUND] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1085),
    [anon_sym_PERCENT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_COMMA] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_DOT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [anon_sym_COLON] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_BSLASH] = ACTIONS(1085),
    [anon_sym_CARET] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [aux_sym__word_token1] = ACTIONS(1085),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1085),
    [aux_sym__word_token2] = ACTIONS(1085),
    [sym__whitespace] = ACTIONS(1085),
    [sym__soft_line_ending] = ACTIONS(1085),
    [sym__block_quote_start] = ACTIONS(1085),
    [sym__indented_chunk_start] = ACTIONS(1085),
    [sym_atx_h1_marker] = ACTIONS(1085),
    [sym_atx_h2_marker] = ACTIONS(1085),
    [sym_atx_h3_marker] = ACTIONS(1085),
    [sym_atx_h4_marker] = ACTIONS(1085),
    [sym_atx_h5_marker] = ACTIONS(1085),
    [sym_atx_h6_marker] = ACTIONS(1085),
    [sym__thematic_break] = ACTIONS(1085),
    [sym__list_marker_minus] = ACTIONS(1085),
    [sym__list_marker_plus] = ACTIONS(1085),
    [sym__list_marker_star] = ACTIONS(1085),
    [sym__list_marker_parenthesis] = ACTIONS(1089),
    [sym__list_marker_dot] = ACTIONS(1085),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1089),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1085),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1085),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1085),
    [sym__blank_line_start] = ACTIONS(1085),
    [sym__html_block_1_start] = ACTIONS(1085),
    [sym__html_block_2_start] = ACTIONS(1085),
    [sym__html_block_3_start] = ACTIONS(1085),
    [sym__html_block_4_start] = ACTIONS(1085),
    [sym__html_block_5_start] = ACTIONS(1085),
    [sym__html_block_6_start] = ACTIONS(1085),
    [sym__html_block_7_start] = ACTIONS(1085),
    [sym__pipe_table_start] = ACTIONS(1085),
  },
  [78] = {
    [sym_list_marker_dot] = STATE(5),
    [sym__list_item_dot] = STATE(78),
    [aux_sym__list_dot_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_RBRACK] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1092),
    [anon_sym_BANG] = ACTIONS(1092),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [anon_sym_POUND] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1092),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_COMMA] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_DOT] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_COLON] = ACTIONS(1092),
    [anon_sym_SEMI] = ACTIONS(1092),
    [anon_sym_EQ] = ACTIONS(1092),
    [anon_sym_QMARK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_BSLASH] = ACTIONS(1092),
    [anon_sym_CARET] = ACTIONS(1092),
    [anon_sym__] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1092),
    [anon_sym_RBRACE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_RPAREN] = ACTIONS(1092),
    [aux_sym__word_token1] = ACTIONS(1092),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1092),
    [aux_sym__word_token2] = ACTIONS(1092),
    [sym__whitespace] = ACTIONS(1092),
    [sym__soft_line_ending] = ACTIONS(1092),
    [sym__block_quote_start] = ACTIONS(1092),
    [sym__indented_chunk_start] = ACTIONS(1092),
    [sym_atx_h1_marker] = ACTIONS(1092),
    [sym_atx_h2_marker] = ACTIONS(1092),
    [sym_atx_h3_marker] = ACTIONS(1092),
    [sym_atx_h4_marker] = ACTIONS(1092),
    [sym_atx_h5_marker] = ACTIONS(1092),
    [sym_atx_h6_marker] = ACTIONS(1092),
    [sym__thematic_break] = ACTIONS(1092),
    [sym__list_marker_minus] = ACTIONS(1092),
    [sym__list_marker_plus] = ACTIONS(1092),
    [sym__list_marker_star] = ACTIONS(1092),
    [sym__list_marker_parenthesis] = ACTIONS(1092),
    [sym__list_marker_dot] = ACTIONS(1096),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1096),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1092),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1092),
    [sym__blank_line_start] = ACTIONS(1092),
    [sym__html_block_1_start] = ACTIONS(1092),
    [sym__html_block_2_start] = ACTIONS(1092),
    [sym__html_block_3_start] = ACTIONS(1092),
    [sym__html_block_4_start] = ACTIONS(1092),
    [sym__html_block_5_start] = ACTIONS(1092),
    [sym__html_block_6_start] = ACTIONS(1092),
    [sym__html_block_7_start] = ACTIONS(1092),
    [sym__pipe_table_start] = ACTIONS(1092),
  },
  [79] = {
    [sym__indented_chunk] = STATE(76),
    [sym__blank_line] = STATE(76),
    [aux_sym_indented_code_block_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_POUND] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_COLON] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_BSLASH] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym__] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [aux_sym__word_token1] = ACTIONS(1099),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1099),
    [aux_sym__word_token2] = ACTIONS(1099),
    [sym__whitespace] = ACTIONS(1099),
    [sym__soft_line_ending] = ACTIONS(1099),
    [sym__block_quote_start] = ACTIONS(1099),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(1099),
    [sym_atx_h2_marker] = ACTIONS(1099),
    [sym_atx_h3_marker] = ACTIONS(1099),
    [sym_atx_h4_marker] = ACTIONS(1099),
    [sym_atx_h5_marker] = ACTIONS(1099),
    [sym_atx_h6_marker] = ACTIONS(1099),
    [sym__thematic_break] = ACTIONS(1099),
    [sym__list_marker_minus] = ACTIONS(1099),
    [sym__list_marker_plus] = ACTIONS(1099),
    [sym__list_marker_star] = ACTIONS(1099),
    [sym__list_marker_parenthesis] = ACTIONS(1099),
    [sym__list_marker_dot] = ACTIONS(1099),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1099),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1099),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1099),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(1099),
    [sym__html_block_2_start] = ACTIONS(1099),
    [sym__html_block_3_start] = ACTIONS(1099),
    [sym__html_block_4_start] = ACTIONS(1099),
    [sym__html_block_5_start] = ACTIONS(1099),
    [sym__html_block_6_start] = ACTIONS(1099),
    [sym__html_block_7_start] = ACTIONS(1099),
    [sym__pipe_table_start] = ACTIONS(1099),
  },
  [80] = {
    [sym_list_marker_minus] = STATE(9),
    [sym__list_item_minus] = STATE(80),
    [aux_sym__list_minus_repeat1] = STATE(80),
    [ts_builtin_sym_end] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_POUND] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_BSLASH] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym__] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [aux_sym__word_token1] = ACTIONS(1103),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1103),
    [aux_sym__word_token2] = ACTIONS(1103),
    [sym__whitespace] = ACTIONS(1103),
    [sym__soft_line_ending] = ACTIONS(1103),
    [sym__block_quote_start] = ACTIONS(1103),
    [sym__indented_chunk_start] = ACTIONS(1103),
    [sym_atx_h1_marker] = ACTIONS(1103),
    [sym_atx_h2_marker] = ACTIONS(1103),
    [sym_atx_h3_marker] = ACTIONS(1103),
    [sym_atx_h4_marker] = ACTIONS(1103),
    [sym_atx_h5_marker] = ACTIONS(1103),
    [sym_atx_h6_marker] = ACTIONS(1103),
    [sym__thematic_break] = ACTIONS(1103),
    [sym__list_marker_minus] = ACTIONS(1107),
    [sym__list_marker_plus] = ACTIONS(1103),
    [sym__list_marker_star] = ACTIONS(1103),
    [sym__list_marker_parenthesis] = ACTIONS(1103),
    [sym__list_marker_dot] = ACTIONS(1103),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1107),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1103),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1103),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1103),
    [sym__blank_line_start] = ACTIONS(1103),
    [sym__html_block_1_start] = ACTIONS(1103),
    [sym__html_block_2_start] = ACTIONS(1103),
    [sym__html_block_3_start] = ACTIONS(1103),
    [sym__html_block_4_start] = ACTIONS(1103),
    [sym__html_block_5_start] = ACTIONS(1103),
    [sym__html_block_6_start] = ACTIONS(1103),
    [sym__html_block_7_start] = ACTIONS(1103),
    [sym__pipe_table_start] = ACTIONS(1103),
  },
  [81] = {
    [sym_list_marker_plus] = STATE(10),
    [sym__list_item_plus] = STATE(81),
    [aux_sym__list_plus_repeat1] = STATE(81),
    [ts_builtin_sym_end] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1112),
    [anon_sym_RBRACK] = ACTIONS(1110),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [anon_sym_POUND] = ACTIONS(1110),
    [anon_sym_DOLLAR] = ACTIONS(1110),
    [anon_sym_PERCENT] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_EQ] = ACTIONS(1110),
    [anon_sym_QMARK] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_BSLASH] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym__] = ACTIONS(1110),
    [anon_sym_BQUOTE] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [aux_sym__word_token1] = ACTIONS(1110),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1110),
    [aux_sym__word_token2] = ACTIONS(1110),
    [sym__whitespace] = ACTIONS(1110),
    [sym__soft_line_ending] = ACTIONS(1110),
    [sym__block_quote_start] = ACTIONS(1110),
    [sym__indented_chunk_start] = ACTIONS(1110),
    [sym_atx_h1_marker] = ACTIONS(1110),
    [sym_atx_h2_marker] = ACTIONS(1110),
    [sym_atx_h3_marker] = ACTIONS(1110),
    [sym_atx_h4_marker] = ACTIONS(1110),
    [sym_atx_h5_marker] = ACTIONS(1110),
    [sym_atx_h6_marker] = ACTIONS(1110),
    [sym__thematic_break] = ACTIONS(1110),
    [sym__list_marker_minus] = ACTIONS(1110),
    [sym__list_marker_plus] = ACTIONS(1114),
    [sym__list_marker_star] = ACTIONS(1110),
    [sym__list_marker_parenthesis] = ACTIONS(1110),
    [sym__list_marker_dot] = ACTIONS(1110),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1114),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1110),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1110),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1110),
    [sym__blank_line_start] = ACTIONS(1110),
    [sym__html_block_1_start] = ACTIONS(1110),
    [sym__html_block_2_start] = ACTIONS(1110),
    [sym__html_block_3_start] = ACTIONS(1110),
    [sym__html_block_4_start] = ACTIONS(1110),
    [sym__html_block_5_start] = ACTIONS(1110),
    [sym__html_block_6_start] = ACTIONS(1110),
    [sym__html_block_7_start] = ACTIONS(1110),
    [sym__pipe_table_start] = ACTIONS(1110),
  },
  [82] = {
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [aux_sym__word_token1] = ACTIONS(1119),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1119),
    [aux_sym__word_token2] = ACTIONS(1119),
    [sym__whitespace] = ACTIONS(1119),
    [sym__soft_line_ending] = ACTIONS(1119),
    [sym__block_close] = ACTIONS(1119),
    [sym_block_continuation] = ACTIONS(1121),
    [sym__block_quote_start] = ACTIONS(1119),
    [sym__indented_chunk_start] = ACTIONS(1119),
    [sym_atx_h1_marker] = ACTIONS(1119),
    [sym_atx_h2_marker] = ACTIONS(1119),
    [sym_atx_h3_marker] = ACTIONS(1119),
    [sym_atx_h4_marker] = ACTIONS(1119),
    [sym_atx_h5_marker] = ACTIONS(1119),
    [sym_atx_h6_marker] = ACTIONS(1119),
    [sym_setext_h1_underline] = ACTIONS(1119),
    [sym_setext_h2_underline] = ACTIONS(1119),
    [sym__thematic_break] = ACTIONS(1119),
    [sym__list_marker_minus] = ACTIONS(1119),
    [sym__list_marker_plus] = ACTIONS(1119),
    [sym__list_marker_star] = ACTIONS(1119),
    [sym__list_marker_parenthesis] = ACTIONS(1119),
    [sym__list_marker_dot] = ACTIONS(1119),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1119),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1119),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1119),
    [sym__blank_line_start] = ACTIONS(1119),
    [sym__html_block_1_start] = ACTIONS(1119),
    [sym__html_block_2_start] = ACTIONS(1119),
    [sym__html_block_3_start] = ACTIONS(1119),
    [sym__html_block_4_start] = ACTIONS(1119),
    [sym__html_block_5_start] = ACTIONS(1119),
    [sym__html_block_6_start] = ACTIONS(1119),
    [sym__html_block_7_start] = ACTIONS(1119),
    [sym__pipe_table_start] = ACTIONS(1119),
  },
  [83] = {
    [sym_list_marker_dot] = STATE(5),
    [sym__list_item_dot] = STATE(78),
    [aux_sym__list_dot_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_POUND] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [aux_sym__word_token1] = ACTIONS(1123),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1123),
    [aux_sym__word_token2] = ACTIONS(1123),
    [sym__whitespace] = ACTIONS(1123),
    [sym__soft_line_ending] = ACTIONS(1123),
    [sym__block_quote_start] = ACTIONS(1123),
    [sym__indented_chunk_start] = ACTIONS(1123),
    [sym_atx_h1_marker] = ACTIONS(1123),
    [sym_atx_h2_marker] = ACTIONS(1123),
    [sym_atx_h3_marker] = ACTIONS(1123),
    [sym_atx_h4_marker] = ACTIONS(1123),
    [sym_atx_h5_marker] = ACTIONS(1123),
    [sym_atx_h6_marker] = ACTIONS(1123),
    [sym__thematic_break] = ACTIONS(1123),
    [sym__list_marker_minus] = ACTIONS(1123),
    [sym__list_marker_plus] = ACTIONS(1123),
    [sym__list_marker_star] = ACTIONS(1123),
    [sym__list_marker_parenthesis] = ACTIONS(1123),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1123),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1123),
    [sym__blank_line_start] = ACTIONS(1123),
    [sym__html_block_1_start] = ACTIONS(1123),
    [sym__html_block_2_start] = ACTIONS(1123),
    [sym__html_block_3_start] = ACTIONS(1123),
    [sym__html_block_4_start] = ACTIONS(1123),
    [sym__html_block_5_start] = ACTIONS(1123),
    [sym__html_block_6_start] = ACTIONS(1123),
    [sym__html_block_7_start] = ACTIONS(1123),
    [sym__pipe_table_start] = ACTIONS(1123),
  },
  [84] = {
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_parenthesis] = STATE(99),
    [aux_sym__list_parenthesis_repeat1] = STATE(99),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_POUND] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1129),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(1129),
    [anon_sym_BSLASH] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym__] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [aux_sym__word_token1] = ACTIONS(1129),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1129),
    [aux_sym__word_token2] = ACTIONS(1129),
    [sym__whitespace] = ACTIONS(1129),
    [sym__soft_line_ending] = ACTIONS(1129),
    [sym__block_close] = ACTIONS(1129),
    [sym__block_quote_start] = ACTIONS(1129),
    [sym__indented_chunk_start] = ACTIONS(1129),
    [sym_atx_h1_marker] = ACTIONS(1129),
    [sym_atx_h2_marker] = ACTIONS(1129),
    [sym_atx_h3_marker] = ACTIONS(1129),
    [sym_atx_h4_marker] = ACTIONS(1129),
    [sym_atx_h5_marker] = ACTIONS(1129),
    [sym_atx_h6_marker] = ACTIONS(1129),
    [sym__thematic_break] = ACTIONS(1129),
    [sym__list_marker_minus] = ACTIONS(1129),
    [sym__list_marker_plus] = ACTIONS(1129),
    [sym__list_marker_star] = ACTIONS(1129),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(1129),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1129),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1129),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1129),
    [sym__blank_line_start] = ACTIONS(1129),
    [sym__html_block_1_start] = ACTIONS(1129),
    [sym__html_block_2_start] = ACTIONS(1129),
    [sym__html_block_3_start] = ACTIONS(1129),
    [sym__html_block_4_start] = ACTIONS(1129),
    [sym__html_block_5_start] = ACTIONS(1129),
    [sym__html_block_6_start] = ACTIONS(1129),
    [sym__html_block_7_start] = ACTIONS(1129),
    [sym__pipe_table_start] = ACTIONS(1129),
  },
  [85] = {
    [sym_list_marker_dot] = STATE(7),
    [sym__list_item_dot] = STATE(100),
    [aux_sym__list_dot_repeat1] = STATE(100),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_POUND] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [aux_sym__word_token1] = ACTIONS(1123),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1123),
    [aux_sym__word_token2] = ACTIONS(1123),
    [sym__whitespace] = ACTIONS(1123),
    [sym__soft_line_ending] = ACTIONS(1123),
    [sym__block_close] = ACTIONS(1123),
    [sym__block_quote_start] = ACTIONS(1123),
    [sym__indented_chunk_start] = ACTIONS(1123),
    [sym_atx_h1_marker] = ACTIONS(1123),
    [sym_atx_h2_marker] = ACTIONS(1123),
    [sym_atx_h3_marker] = ACTIONS(1123),
    [sym_atx_h4_marker] = ACTIONS(1123),
    [sym_atx_h5_marker] = ACTIONS(1123),
    [sym_atx_h6_marker] = ACTIONS(1123),
    [sym__thematic_break] = ACTIONS(1123),
    [sym__list_marker_minus] = ACTIONS(1123),
    [sym__list_marker_plus] = ACTIONS(1123),
    [sym__list_marker_star] = ACTIONS(1123),
    [sym__list_marker_parenthesis] = ACTIONS(1123),
    [sym__list_marker_dot] = ACTIONS(39),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1123),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(39),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1123),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1123),
    [sym__blank_line_start] = ACTIONS(1123),
    [sym__html_block_1_start] = ACTIONS(1123),
    [sym__html_block_2_start] = ACTIONS(1123),
    [sym__html_block_3_start] = ACTIONS(1123),
    [sym__html_block_4_start] = ACTIONS(1123),
    [sym__html_block_5_start] = ACTIONS(1123),
    [sym__html_block_6_start] = ACTIONS(1123),
    [sym__html_block_7_start] = ACTIONS(1123),
    [sym__pipe_table_start] = ACTIONS(1123),
  },
  [86] = {
    [sym_list_marker_star] = STATE(6),
    [sym__list_item_star] = STATE(96),
    [aux_sym__list_star_repeat1] = STATE(96),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_BSLASH] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym__] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [aux_sym__word_token1] = ACTIONS(1133),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1133),
    [aux_sym__word_token2] = ACTIONS(1133),
    [sym__whitespace] = ACTIONS(1133),
    [sym__soft_line_ending] = ACTIONS(1133),
    [sym__block_close] = ACTIONS(1133),
    [sym__block_quote_start] = ACTIONS(1133),
    [sym__indented_chunk_start] = ACTIONS(1133),
    [sym_atx_h1_marker] = ACTIONS(1133),
    [sym_atx_h2_marker] = ACTIONS(1133),
    [sym_atx_h3_marker] = ACTIONS(1133),
    [sym_atx_h4_marker] = ACTIONS(1133),
    [sym_atx_h5_marker] = ACTIONS(1133),
    [sym_atx_h6_marker] = ACTIONS(1133),
    [sym__thematic_break] = ACTIONS(1133),
    [sym__list_marker_minus] = ACTIONS(1133),
    [sym__list_marker_plus] = ACTIONS(1133),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(1133),
    [sym__list_marker_dot] = ACTIONS(1133),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1133),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1133),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1133),
    [sym__blank_line_start] = ACTIONS(1133),
    [sym__html_block_1_start] = ACTIONS(1133),
    [sym__html_block_2_start] = ACTIONS(1133),
    [sym__html_block_3_start] = ACTIONS(1133),
    [sym__html_block_4_start] = ACTIONS(1133),
    [sym__html_block_5_start] = ACTIONS(1133),
    [sym__html_block_6_start] = ACTIONS(1133),
    [sym__html_block_7_start] = ACTIONS(1133),
    [sym__pipe_table_start] = ACTIONS(1133),
  },
  [87] = {
    [sym_list_marker_minus] = STATE(11),
    [sym__list_item_minus] = STATE(95),
    [aux_sym__list_minus_repeat1] = STATE(95),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1075),
    [anon_sym_POUND] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_COLON] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_BSLASH] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
    [anon_sym_BQUOTE] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1075),
    [aux_sym__word_token1] = ACTIONS(1075),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1075),
    [aux_sym__word_token2] = ACTIONS(1075),
    [sym__whitespace] = ACTIONS(1075),
    [sym__soft_line_ending] = ACTIONS(1075),
    [sym__block_close] = ACTIONS(1075),
    [sym__block_quote_start] = ACTIONS(1075),
    [sym__indented_chunk_start] = ACTIONS(1075),
    [sym_atx_h1_marker] = ACTIONS(1075),
    [sym_atx_h2_marker] = ACTIONS(1075),
    [sym_atx_h3_marker] = ACTIONS(1075),
    [sym_atx_h4_marker] = ACTIONS(1075),
    [sym_atx_h5_marker] = ACTIONS(1075),
    [sym_atx_h6_marker] = ACTIONS(1075),
    [sym__thematic_break] = ACTIONS(1075),
    [sym__list_marker_minus] = ACTIONS(31),
    [sym__list_marker_plus] = ACTIONS(1075),
    [sym__list_marker_star] = ACTIONS(1075),
    [sym__list_marker_parenthesis] = ACTIONS(1075),
    [sym__list_marker_dot] = ACTIONS(1075),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(31),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1075),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1075),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1075),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1075),
    [sym__blank_line_start] = ACTIONS(1075),
    [sym__html_block_1_start] = ACTIONS(1075),
    [sym__html_block_2_start] = ACTIONS(1075),
    [sym__html_block_3_start] = ACTIONS(1075),
    [sym__html_block_4_start] = ACTIONS(1075),
    [sym__html_block_5_start] = ACTIONS(1075),
    [sym__html_block_6_start] = ACTIONS(1075),
    [sym__html_block_7_start] = ACTIONS(1075),
    [sym__pipe_table_start] = ACTIONS(1075),
  },
  [88] = {
    [sym_list_marker_plus] = STATE(4),
    [sym__list_item_plus] = STATE(93),
    [aux_sym__list_plus_repeat1] = STATE(93),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_RBRACK] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1137),
    [anon_sym_POUND] = ACTIONS(1137),
    [anon_sym_DOLLAR] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_SQUOTE] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_BSLASH] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym__] = ACTIONS(1137),
    [anon_sym_BQUOTE] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_RBRACE] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [aux_sym__word_token1] = ACTIONS(1137),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1137),
    [aux_sym__word_token2] = ACTIONS(1137),
    [sym__whitespace] = ACTIONS(1137),
    [sym__soft_line_ending] = ACTIONS(1137),
    [sym__block_close] = ACTIONS(1137),
    [sym__block_quote_start] = ACTIONS(1137),
    [sym__indented_chunk_start] = ACTIONS(1137),
    [sym_atx_h1_marker] = ACTIONS(1137),
    [sym_atx_h2_marker] = ACTIONS(1137),
    [sym_atx_h3_marker] = ACTIONS(1137),
    [sym_atx_h4_marker] = ACTIONS(1137),
    [sym_atx_h5_marker] = ACTIONS(1137),
    [sym_atx_h6_marker] = ACTIONS(1137),
    [sym__thematic_break] = ACTIONS(1137),
    [sym__list_marker_minus] = ACTIONS(1137),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(1137),
    [sym__list_marker_parenthesis] = ACTIONS(1137),
    [sym__list_marker_dot] = ACTIONS(1137),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1137),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1137),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1137),
    [sym__blank_line_start] = ACTIONS(1137),
    [sym__html_block_1_start] = ACTIONS(1137),
    [sym__html_block_2_start] = ACTIONS(1137),
    [sym__html_block_3_start] = ACTIONS(1137),
    [sym__html_block_4_start] = ACTIONS(1137),
    [sym__html_block_5_start] = ACTIONS(1137),
    [sym__html_block_6_start] = ACTIONS(1137),
    [sym__html_block_7_start] = ACTIONS(1137),
    [sym__pipe_table_start] = ACTIONS(1137),
  },
  [89] = {
    [sym__indented_chunk] = STATE(73),
    [sym__blank_line] = STATE(73),
    [aux_sym_indented_code_block_repeat1] = STATE(73),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_POUND] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_COLON] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_BSLASH] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym__] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [aux_sym__word_token1] = ACTIONS(1099),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1099),
    [aux_sym__word_token2] = ACTIONS(1099),
    [sym__whitespace] = ACTIONS(1099),
    [sym__soft_line_ending] = ACTIONS(1099),
    [sym__block_close] = ACTIONS(1099),
    [sym__block_quote_start] = ACTIONS(1099),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(1099),
    [sym_atx_h2_marker] = ACTIONS(1099),
    [sym_atx_h3_marker] = ACTIONS(1099),
    [sym_atx_h4_marker] = ACTIONS(1099),
    [sym_atx_h5_marker] = ACTIONS(1099),
    [sym_atx_h6_marker] = ACTIONS(1099),
    [sym__thematic_break] = ACTIONS(1099),
    [sym__list_marker_minus] = ACTIONS(1099),
    [sym__list_marker_plus] = ACTIONS(1099),
    [sym__list_marker_star] = ACTIONS(1099),
    [sym__list_marker_parenthesis] = ACTIONS(1099),
    [sym__list_marker_dot] = ACTIONS(1099),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1099),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1099),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1099),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1099),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(1099),
    [sym__html_block_2_start] = ACTIONS(1099),
    [sym__html_block_3_start] = ACTIONS(1099),
    [sym__html_block_4_start] = ACTIONS(1099),
    [sym__html_block_5_start] = ACTIONS(1099),
    [sym__html_block_6_start] = ACTIONS(1099),
    [sym__html_block_7_start] = ACTIONS(1099),
    [sym__pipe_table_start] = ACTIONS(1099),
  },
  [90] = {
    [sym__indented_chunk] = STATE(89),
    [sym__blank_line] = STATE(89),
    [aux_sym_indented_code_block_repeat1] = STATE(89),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_RBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_GT] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_POUND] = ACTIONS(1141),
    [anon_sym_DOLLAR] = ACTIONS(1141),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_EQ] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_BSLASH] = ACTIONS(1141),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym__] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [aux_sym__word_token1] = ACTIONS(1141),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1141),
    [aux_sym__word_token2] = ACTIONS(1141),
    [sym__whitespace] = ACTIONS(1141),
    [sym__soft_line_ending] = ACTIONS(1141),
    [sym__block_close] = ACTIONS(1141),
    [sym__block_quote_start] = ACTIONS(1141),
    [sym__indented_chunk_start] = ACTIONS(75),
    [sym_atx_h1_marker] = ACTIONS(1141),
    [sym_atx_h2_marker] = ACTIONS(1141),
    [sym_atx_h3_marker] = ACTIONS(1141),
    [sym_atx_h4_marker] = ACTIONS(1141),
    [sym_atx_h5_marker] = ACTIONS(1141),
    [sym_atx_h6_marker] = ACTIONS(1141),
    [sym__thematic_break] = ACTIONS(1141),
    [sym__list_marker_minus] = ACTIONS(1141),
    [sym__list_marker_plus] = ACTIONS(1141),
    [sym__list_marker_star] = ACTIONS(1141),
    [sym__list_marker_parenthesis] = ACTIONS(1141),
    [sym__list_marker_dot] = ACTIONS(1141),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1141),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1141),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1141),
    [sym__blank_line_start] = ACTIONS(95),
    [sym__html_block_1_start] = ACTIONS(1141),
    [sym__html_block_2_start] = ACTIONS(1141),
    [sym__html_block_3_start] = ACTIONS(1141),
    [sym__html_block_4_start] = ACTIONS(1141),
    [sym__html_block_5_start] = ACTIONS(1141),
    [sym__html_block_6_start] = ACTIONS(1141),
    [sym__html_block_7_start] = ACTIONS(1141),
    [sym__pipe_table_start] = ACTIONS(1141),
  },
  [91] = {
    [sym_list_marker_parenthesis] = STATE(3),
    [sym__list_item_parenthesis] = STATE(77),
    [aux_sym__list_parenthesis_repeat1] = STATE(77),
    [ts_builtin_sym_end] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_RBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1129),
    [anon_sym_POUND] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1129),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_EQ] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(1129),
    [anon_sym_BSLASH] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym__] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [aux_sym__word_token1] = ACTIONS(1129),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1129),
    [aux_sym__word_token2] = ACTIONS(1129),
    [sym__whitespace] = ACTIONS(1129),
    [sym__soft_line_ending] = ACTIONS(1129),
    [sym__block_quote_start] = ACTIONS(1129),
    [sym__indented_chunk_start] = ACTIONS(1129),
    [sym_atx_h1_marker] = ACTIONS(1129),
    [sym_atx_h2_marker] = ACTIONS(1129),
    [sym_atx_h3_marker] = ACTIONS(1129),
    [sym_atx_h4_marker] = ACTIONS(1129),
    [sym_atx_h5_marker] = ACTIONS(1129),
    [sym_atx_h6_marker] = ACTIONS(1129),
    [sym__thematic_break] = ACTIONS(1129),
    [sym__list_marker_minus] = ACTIONS(1129),
    [sym__list_marker_plus] = ACTIONS(1129),
    [sym__list_marker_star] = ACTIONS(1129),
    [sym__list_marker_parenthesis] = ACTIONS(37),
    [sym__list_marker_dot] = ACTIONS(1129),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1129),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(37),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1129),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1129),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1129),
    [sym__blank_line_start] = ACTIONS(1129),
    [sym__html_block_1_start] = ACTIONS(1129),
    [sym__html_block_2_start] = ACTIONS(1129),
    [sym__html_block_3_start] = ACTIONS(1129),
    [sym__html_block_4_start] = ACTIONS(1129),
    [sym__html_block_5_start] = ACTIONS(1129),
    [sym__html_block_6_start] = ACTIONS(1129),
    [sym__html_block_7_start] = ACTIONS(1129),
    [sym__pipe_table_start] = ACTIONS(1129),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [aux_sym__word_token1] = ACTIONS(1119),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1119),
    [aux_sym__word_token2] = ACTIONS(1119),
    [sym__whitespace] = ACTIONS(1119),
    [sym__soft_line_ending] = ACTIONS(1119),
    [sym_block_continuation] = ACTIONS(1143),
    [sym__block_quote_start] = ACTIONS(1119),
    [sym__indented_chunk_start] = ACTIONS(1119),
    [sym_atx_h1_marker] = ACTIONS(1119),
    [sym_atx_h2_marker] = ACTIONS(1119),
    [sym_atx_h3_marker] = ACTIONS(1119),
    [sym_atx_h4_marker] = ACTIONS(1119),
    [sym_atx_h5_marker] = ACTIONS(1119),
    [sym_atx_h6_marker] = ACTIONS(1119),
    [sym_setext_h1_underline] = ACTIONS(1119),
    [sym_setext_h2_underline] = ACTIONS(1119),
    [sym__thematic_break] = ACTIONS(1119),
    [sym__list_marker_minus] = ACTIONS(1119),
    [sym__list_marker_plus] = ACTIONS(1119),
    [sym__list_marker_star] = ACTIONS(1119),
    [sym__list_marker_parenthesis] = ACTIONS(1119),
    [sym__list_marker_dot] = ACTIONS(1119),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1119),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1119),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1119),
    [sym__blank_line_start] = ACTIONS(1119),
    [sym__html_block_1_start] = ACTIONS(1119),
    [sym__html_block_2_start] = ACTIONS(1119),
    [sym__html_block_3_start] = ACTIONS(1119),
    [sym__html_block_4_start] = ACTIONS(1119),
    [sym__html_block_5_start] = ACTIONS(1119),
    [sym__html_block_6_start] = ACTIONS(1119),
    [sym__html_block_7_start] = ACTIONS(1119),
    [sym__pipe_table_start] = ACTIONS(1119),
  },
  [93] = {
    [sym_list_marker_plus] = STATE(4),
    [sym__list_item_plus] = STATE(93),
    [aux_sym__list_plus_repeat1] = STATE(93),
    [anon_sym_LBRACK] = ACTIONS(1112),
    [anon_sym_RBRACK] = ACTIONS(1110),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [anon_sym_POUND] = ACTIONS(1110),
    [anon_sym_DOLLAR] = ACTIONS(1110),
    [anon_sym_PERCENT] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1110),
    [anon_sym_COLON] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_EQ] = ACTIONS(1110),
    [anon_sym_QMARK] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_BSLASH] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym__] = ACTIONS(1110),
    [anon_sym_BQUOTE] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [aux_sym__word_token1] = ACTIONS(1110),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1110),
    [aux_sym__word_token2] = ACTIONS(1110),
    [sym__whitespace] = ACTIONS(1110),
    [sym__soft_line_ending] = ACTIONS(1110),
    [sym__block_close] = ACTIONS(1110),
    [sym__block_quote_start] = ACTIONS(1110),
    [sym__indented_chunk_start] = ACTIONS(1110),
    [sym_atx_h1_marker] = ACTIONS(1110),
    [sym_atx_h2_marker] = ACTIONS(1110),
    [sym_atx_h3_marker] = ACTIONS(1110),
    [sym_atx_h4_marker] = ACTIONS(1110),
    [sym_atx_h5_marker] = ACTIONS(1110),
    [sym_atx_h6_marker] = ACTIONS(1110),
    [sym__thematic_break] = ACTIONS(1110),
    [sym__list_marker_minus] = ACTIONS(1110),
    [sym__list_marker_plus] = ACTIONS(1114),
    [sym__list_marker_star] = ACTIONS(1110),
    [sym__list_marker_parenthesis] = ACTIONS(1110),
    [sym__list_marker_dot] = ACTIONS(1110),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1114),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1110),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1110),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1110),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1110),
    [sym__blank_line_start] = ACTIONS(1110),
    [sym__html_block_1_start] = ACTIONS(1110),
    [sym__html_block_2_start] = ACTIONS(1110),
    [sym__html_block_3_start] = ACTIONS(1110),
    [sym__html_block_4_start] = ACTIONS(1110),
    [sym__html_block_5_start] = ACTIONS(1110),
    [sym__html_block_6_start] = ACTIONS(1110),
    [sym__html_block_7_start] = ACTIONS(1110),
    [sym__pipe_table_start] = ACTIONS(1110),
  },
  [94] = {
    [sym_list_marker_star] = STATE(8),
    [sym__list_item_star] = STATE(74),
    [aux_sym__list_star_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOLLAR] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_BSLASH] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym__] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [aux_sym__word_token1] = ACTIONS(1133),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1133),
    [aux_sym__word_token2] = ACTIONS(1133),
    [sym__whitespace] = ACTIONS(1133),
    [sym__soft_line_ending] = ACTIONS(1133),
    [sym__block_quote_start] = ACTIONS(1133),
    [sym__indented_chunk_start] = ACTIONS(1133),
    [sym_atx_h1_marker] = ACTIONS(1133),
    [sym_atx_h2_marker] = ACTIONS(1133),
    [sym_atx_h3_marker] = ACTIONS(1133),
    [sym_atx_h4_marker] = ACTIONS(1133),
    [sym_atx_h5_marker] = ACTIONS(1133),
    [sym_atx_h6_marker] = ACTIONS(1133),
    [sym__thematic_break] = ACTIONS(1133),
    [sym__list_marker_minus] = ACTIONS(1133),
    [sym__list_marker_plus] = ACTIONS(1133),
    [sym__list_marker_star] = ACTIONS(35),
    [sym__list_marker_parenthesis] = ACTIONS(1133),
    [sym__list_marker_dot] = ACTIONS(1133),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(35),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1133),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1133),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1133),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1133),
    [sym__blank_line_start] = ACTIONS(1133),
    [sym__html_block_1_start] = ACTIONS(1133),
    [sym__html_block_2_start] = ACTIONS(1133),
    [sym__html_block_3_start] = ACTIONS(1133),
    [sym__html_block_4_start] = ACTIONS(1133),
    [sym__html_block_5_start] = ACTIONS(1133),
    [sym__html_block_6_start] = ACTIONS(1133),
    [sym__html_block_7_start] = ACTIONS(1133),
    [sym__pipe_table_start] = ACTIONS(1133),
  },
  [95] = {
    [sym_list_marker_minus] = STATE(11),
    [sym__list_item_minus] = STATE(95),
    [aux_sym__list_minus_repeat1] = STATE(95),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_POUND] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_BSLASH] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym__] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [aux_sym__word_token1] = ACTIONS(1103),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1103),
    [aux_sym__word_token2] = ACTIONS(1103),
    [sym__whitespace] = ACTIONS(1103),
    [sym__soft_line_ending] = ACTIONS(1103),
    [sym__block_close] = ACTIONS(1103),
    [sym__block_quote_start] = ACTIONS(1103),
    [sym__indented_chunk_start] = ACTIONS(1103),
    [sym_atx_h1_marker] = ACTIONS(1103),
    [sym_atx_h2_marker] = ACTIONS(1103),
    [sym_atx_h3_marker] = ACTIONS(1103),
    [sym_atx_h4_marker] = ACTIONS(1103),
    [sym_atx_h5_marker] = ACTIONS(1103),
    [sym_atx_h6_marker] = ACTIONS(1103),
    [sym__thematic_break] = ACTIONS(1103),
    [sym__list_marker_minus] = ACTIONS(1107),
    [sym__list_marker_plus] = ACTIONS(1103),
    [sym__list_marker_star] = ACTIONS(1103),
    [sym__list_marker_parenthesis] = ACTIONS(1103),
    [sym__list_marker_dot] = ACTIONS(1103),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1107),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1103),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1103),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1103),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1103),
    [sym__blank_line_start] = ACTIONS(1103),
    [sym__html_block_1_start] = ACTIONS(1103),
    [sym__html_block_2_start] = ACTIONS(1103),
    [sym__html_block_3_start] = ACTIONS(1103),
    [sym__html_block_4_start] = ACTIONS(1103),
    [sym__html_block_5_start] = ACTIONS(1103),
    [sym__html_block_6_start] = ACTIONS(1103),
    [sym__html_block_7_start] = ACTIONS(1103),
    [sym__pipe_table_start] = ACTIONS(1103),
  },
  [96] = {
    [sym_list_marker_star] = STATE(6),
    [sym__list_item_star] = STATE(96),
    [aux_sym__list_star_repeat1] = STATE(96),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_RBRACK] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [anon_sym_POUND] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1068),
    [anon_sym_SQUOTE] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_COMMA] = ACTIONS(1068),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1068),
    [anon_sym_COLON] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1068),
    [anon_sym_EQ] = ACTIONS(1068),
    [anon_sym_QMARK] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1068),
    [anon_sym_BSLASH] = ACTIONS(1068),
    [anon_sym_CARET] = ACTIONS(1068),
    [anon_sym__] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1068),
    [aux_sym__word_token1] = ACTIONS(1068),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1068),
    [aux_sym__word_token2] = ACTIONS(1068),
    [sym__whitespace] = ACTIONS(1068),
    [sym__soft_line_ending] = ACTIONS(1068),
    [sym__block_close] = ACTIONS(1068),
    [sym__block_quote_start] = ACTIONS(1068),
    [sym__indented_chunk_start] = ACTIONS(1068),
    [sym_atx_h1_marker] = ACTIONS(1068),
    [sym_atx_h2_marker] = ACTIONS(1068),
    [sym_atx_h3_marker] = ACTIONS(1068),
    [sym_atx_h4_marker] = ACTIONS(1068),
    [sym_atx_h5_marker] = ACTIONS(1068),
    [sym_atx_h6_marker] = ACTIONS(1068),
    [sym__thematic_break] = ACTIONS(1068),
    [sym__list_marker_minus] = ACTIONS(1068),
    [sym__list_marker_plus] = ACTIONS(1068),
    [sym__list_marker_star] = ACTIONS(1072),
    [sym__list_marker_parenthesis] = ACTIONS(1068),
    [sym__list_marker_dot] = ACTIONS(1068),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1072),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1068),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1068),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1068),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1068),
    [sym__blank_line_start] = ACTIONS(1068),
    [sym__html_block_1_start] = ACTIONS(1068),
    [sym__html_block_2_start] = ACTIONS(1068),
    [sym__html_block_3_start] = ACTIONS(1068),
    [sym__html_block_4_start] = ACTIONS(1068),
    [sym__html_block_5_start] = ACTIONS(1068),
    [sym__html_block_6_start] = ACTIONS(1068),
    [sym__html_block_7_start] = ACTIONS(1068),
    [sym__pipe_table_start] = ACTIONS(1068),
  },
  [97] = {
    [sym__indented_chunk] = STATE(79),
    [sym__blank_line] = STATE(79),
    [aux_sym_indented_code_block_repeat1] = STATE(79),
    [ts_builtin_sym_end] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_RBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_GT] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_POUND] = ACTIONS(1141),
    [anon_sym_DOLLAR] = ACTIONS(1141),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_EQ] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_BSLASH] = ACTIONS(1141),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym__] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [aux_sym__word_token1] = ACTIONS(1141),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1141),
    [aux_sym__word_token2] = ACTIONS(1141),
    [sym__whitespace] = ACTIONS(1141),
    [sym__soft_line_ending] = ACTIONS(1141),
    [sym__block_quote_start] = ACTIONS(1141),
    [sym__indented_chunk_start] = ACTIONS(15),
    [sym_atx_h1_marker] = ACTIONS(1141),
    [sym_atx_h2_marker] = ACTIONS(1141),
    [sym_atx_h3_marker] = ACTIONS(1141),
    [sym_atx_h4_marker] = ACTIONS(1141),
    [sym_atx_h5_marker] = ACTIONS(1141),
    [sym_atx_h6_marker] = ACTIONS(1141),
    [sym__thematic_break] = ACTIONS(1141),
    [sym__list_marker_minus] = ACTIONS(1141),
    [sym__list_marker_plus] = ACTIONS(1141),
    [sym__list_marker_star] = ACTIONS(1141),
    [sym__list_marker_parenthesis] = ACTIONS(1141),
    [sym__list_marker_dot] = ACTIONS(1141),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1141),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1141),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1141),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1141),
    [sym__blank_line_start] = ACTIONS(45),
    [sym__html_block_1_start] = ACTIONS(1141),
    [sym__html_block_2_start] = ACTIONS(1141),
    [sym__html_block_3_start] = ACTIONS(1141),
    [sym__html_block_4_start] = ACTIONS(1141),
    [sym__html_block_5_start] = ACTIONS(1141),
    [sym__html_block_6_start] = ACTIONS(1141),
    [sym__html_block_7_start] = ACTIONS(1141),
    [sym__pipe_table_start] = ACTIONS(1141),
  },
  [98] = {
    [sym_list_marker_plus] = STATE(10),
    [sym__list_item_plus] = STATE(81),
    [aux_sym__list_plus_repeat1] = STATE(81),
    [ts_builtin_sym_end] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_RBRACK] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1137),
    [anon_sym_POUND] = ACTIONS(1137),
    [anon_sym_DOLLAR] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_SQUOTE] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1137),
    [anon_sym_BSLASH] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym__] = ACTIONS(1137),
    [anon_sym_BQUOTE] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_RBRACE] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [aux_sym__word_token1] = ACTIONS(1137),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1137),
    [aux_sym__word_token2] = ACTIONS(1137),
    [sym__whitespace] = ACTIONS(1137),
    [sym__soft_line_ending] = ACTIONS(1137),
    [sym__block_quote_start] = ACTIONS(1137),
    [sym__indented_chunk_start] = ACTIONS(1137),
    [sym_atx_h1_marker] = ACTIONS(1137),
    [sym_atx_h2_marker] = ACTIONS(1137),
    [sym_atx_h3_marker] = ACTIONS(1137),
    [sym_atx_h4_marker] = ACTIONS(1137),
    [sym_atx_h5_marker] = ACTIONS(1137),
    [sym_atx_h6_marker] = ACTIONS(1137),
    [sym__thematic_break] = ACTIONS(1137),
    [sym__list_marker_minus] = ACTIONS(1137),
    [sym__list_marker_plus] = ACTIONS(33),
    [sym__list_marker_star] = ACTIONS(1137),
    [sym__list_marker_parenthesis] = ACTIONS(1137),
    [sym__list_marker_dot] = ACTIONS(1137),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(33),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1137),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1137),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1137),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1137),
    [sym__blank_line_start] = ACTIONS(1137),
    [sym__html_block_1_start] = ACTIONS(1137),
    [sym__html_block_2_start] = ACTIONS(1137),
    [sym__html_block_3_start] = ACTIONS(1137),
    [sym__html_block_4_start] = ACTIONS(1137),
    [sym__html_block_5_start] = ACTIONS(1137),
    [sym__html_block_6_start] = ACTIONS(1137),
    [sym__html_block_7_start] = ACTIONS(1137),
    [sym__pipe_table_start] = ACTIONS(1137),
  },
  [99] = {
    [sym_list_marker_parenthesis] = STATE(2),
    [sym__list_item_parenthesis] = STATE(99),
    [aux_sym__list_parenthesis_repeat1] = STATE(99),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_RBRACK] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_POUND] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(1085),
    [anon_sym_PERCENT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_COMMA] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_DOT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [anon_sym_COLON] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_BSLASH] = ACTIONS(1085),
    [anon_sym_CARET] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1085),
    [aux_sym__word_token1] = ACTIONS(1085),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1085),
    [aux_sym__word_token2] = ACTIONS(1085),
    [sym__whitespace] = ACTIONS(1085),
    [sym__soft_line_ending] = ACTIONS(1085),
    [sym__block_close] = ACTIONS(1085),
    [sym__block_quote_start] = ACTIONS(1085),
    [sym__indented_chunk_start] = ACTIONS(1085),
    [sym_atx_h1_marker] = ACTIONS(1085),
    [sym_atx_h2_marker] = ACTIONS(1085),
    [sym_atx_h3_marker] = ACTIONS(1085),
    [sym_atx_h4_marker] = ACTIONS(1085),
    [sym_atx_h5_marker] = ACTIONS(1085),
    [sym_atx_h6_marker] = ACTIONS(1085),
    [sym__thematic_break] = ACTIONS(1085),
    [sym__list_marker_minus] = ACTIONS(1085),
    [sym__list_marker_plus] = ACTIONS(1085),
    [sym__list_marker_star] = ACTIONS(1085),
    [sym__list_marker_parenthesis] = ACTIONS(1089),
    [sym__list_marker_dot] = ACTIONS(1085),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1085),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1089),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1085),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1085),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1085),
    [sym__blank_line_start] = ACTIONS(1085),
    [sym__html_block_1_start] = ACTIONS(1085),
    [sym__html_block_2_start] = ACTIONS(1085),
    [sym__html_block_3_start] = ACTIONS(1085),
    [sym__html_block_4_start] = ACTIONS(1085),
    [sym__html_block_5_start] = ACTIONS(1085),
    [sym__html_block_6_start] = ACTIONS(1085),
    [sym__html_block_7_start] = ACTIONS(1085),
    [sym__pipe_table_start] = ACTIONS(1085),
  },
  [100] = {
    [sym_list_marker_dot] = STATE(7),
    [sym__list_item_dot] = STATE(100),
    [aux_sym__list_dot_repeat1] = STATE(100),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_RBRACK] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1092),
    [anon_sym_BANG] = ACTIONS(1092),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [anon_sym_POUND] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(1092),
    [anon_sym_SQUOTE] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_COMMA] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_DOT] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_COLON] = ACTIONS(1092),
    [anon_sym_SEMI] = ACTIONS(1092),
    [anon_sym_EQ] = ACTIONS(1092),
    [anon_sym_QMARK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_BSLASH] = ACTIONS(1092),
    [anon_sym_CARET] = ACTIONS(1092),
    [anon_sym__] = ACTIONS(1092),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1092),
    [anon_sym_RBRACE] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_RPAREN] = ACTIONS(1092),
    [aux_sym__word_token1] = ACTIONS(1092),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1092),
    [aux_sym__word_token2] = ACTIONS(1092),
    [sym__whitespace] = ACTIONS(1092),
    [sym__soft_line_ending] = ACTIONS(1092),
    [sym__block_close] = ACTIONS(1092),
    [sym__block_quote_start] = ACTIONS(1092),
    [sym__indented_chunk_start] = ACTIONS(1092),
    [sym_atx_h1_marker] = ACTIONS(1092),
    [sym_atx_h2_marker] = ACTIONS(1092),
    [sym_atx_h3_marker] = ACTIONS(1092),
    [sym_atx_h4_marker] = ACTIONS(1092),
    [sym_atx_h5_marker] = ACTIONS(1092),
    [sym_atx_h6_marker] = ACTIONS(1092),
    [sym__thematic_break] = ACTIONS(1092),
    [sym__list_marker_minus] = ACTIONS(1092),
    [sym__list_marker_plus] = ACTIONS(1092),
    [sym__list_marker_star] = ACTIONS(1092),
    [sym__list_marker_parenthesis] = ACTIONS(1092),
    [sym__list_marker_dot] = ACTIONS(1096),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1092),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1096),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1092),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1092),
    [sym__blank_line_start] = ACTIONS(1092),
    [sym__html_block_1_start] = ACTIONS(1092),
    [sym__html_block_2_start] = ACTIONS(1092),
    [sym__html_block_3_start] = ACTIONS(1092),
    [sym__html_block_4_start] = ACTIONS(1092),
    [sym__html_block_5_start] = ACTIONS(1092),
    [sym__html_block_6_start] = ACTIONS(1092),
    [sym__html_block_7_start] = ACTIONS(1092),
    [sym__pipe_table_start] = ACTIONS(1092),
  },
  [101] = {
    [sym_link_title] = STATE(723),
    [ts_builtin_sym_end] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_POUND] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym__] = ACTIONS(1145),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [aux_sym__word_token1] = ACTIONS(1145),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1145),
    [aux_sym__word_token2] = ACTIONS(1145),
    [sym__whitespace] = ACTIONS(1158),
    [sym__soft_line_ending] = ACTIONS(1145),
    [sym__block_quote_start] = ACTIONS(1145),
    [sym__indented_chunk_start] = ACTIONS(1145),
    [sym_atx_h1_marker] = ACTIONS(1145),
    [sym_atx_h2_marker] = ACTIONS(1145),
    [sym_atx_h3_marker] = ACTIONS(1145),
    [sym_atx_h4_marker] = ACTIONS(1145),
    [sym_atx_h5_marker] = ACTIONS(1145),
    [sym_atx_h6_marker] = ACTIONS(1145),
    [sym__thematic_break] = ACTIONS(1145),
    [sym__list_marker_minus] = ACTIONS(1145),
    [sym__list_marker_plus] = ACTIONS(1145),
    [sym__list_marker_star] = ACTIONS(1145),
    [sym__list_marker_parenthesis] = ACTIONS(1145),
    [sym__list_marker_dot] = ACTIONS(1145),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1145),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1145),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1145),
    [sym__blank_line_start] = ACTIONS(1145),
    [sym__html_block_1_start] = ACTIONS(1145),
    [sym__html_block_2_start] = ACTIONS(1145),
    [sym__html_block_3_start] = ACTIONS(1145),
    [sym__html_block_4_start] = ACTIONS(1145),
    [sym__html_block_5_start] = ACTIONS(1145),
    [sym__html_block_6_start] = ACTIONS(1145),
    [sym__html_block_7_start] = ACTIONS(1145),
    [sym__no_indented_chunk] = ACTIONS(1161),
    [sym__pipe_table_start] = ACTIONS(1145),
  },
  [102] = {
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1165),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1165),
    [anon_sym_BSLASH] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym__] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [aux_sym__word_token1] = ACTIONS(1165),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1165),
    [aux_sym__word_token2] = ACTIONS(1165),
    [sym__whitespace] = ACTIONS(1165),
    [sym__soft_line_ending] = ACTIONS(1165),
    [sym__block_close] = ACTIONS(1165),
    [sym_block_continuation] = ACTIONS(1167),
    [sym__block_quote_start] = ACTIONS(1165),
    [sym__indented_chunk_start] = ACTIONS(1165),
    [sym_atx_h1_marker] = ACTIONS(1165),
    [sym_atx_h2_marker] = ACTIONS(1165),
    [sym_atx_h3_marker] = ACTIONS(1165),
    [sym_atx_h4_marker] = ACTIONS(1165),
    [sym_atx_h5_marker] = ACTIONS(1165),
    [sym_atx_h6_marker] = ACTIONS(1165),
    [sym__thematic_break] = ACTIONS(1165),
    [sym__list_marker_minus] = ACTIONS(1165),
    [sym__list_marker_plus] = ACTIONS(1165),
    [sym__list_marker_star] = ACTIONS(1165),
    [sym__list_marker_parenthesis] = ACTIONS(1165),
    [sym__list_marker_dot] = ACTIONS(1165),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1165),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1165),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1165),
    [sym__blank_line_start] = ACTIONS(1165),
    [sym__html_block_1_start] = ACTIONS(1165),
    [sym__html_block_2_start] = ACTIONS(1165),
    [sym__html_block_3_start] = ACTIONS(1165),
    [sym__html_block_4_start] = ACTIONS(1165),
    [sym__html_block_5_start] = ACTIONS(1165),
    [sym__html_block_6_start] = ACTIONS(1165),
    [sym__html_block_7_start] = ACTIONS(1165),
    [sym__no_indented_chunk] = ACTIONS(1165),
    [sym__pipe_table_start] = ACTIONS(1165),
  },
  [103] = {
    [sym_link_title] = STATE(698),
    [ts_builtin_sym_end] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_POUND] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_BSLASH] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym__] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [aux_sym__word_token1] = ACTIONS(1169),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1169),
    [aux_sym__word_token2] = ACTIONS(1169),
    [sym__whitespace] = ACTIONS(1182),
    [sym__soft_line_ending] = ACTIONS(1169),
    [sym__block_quote_start] = ACTIONS(1169),
    [sym__indented_chunk_start] = ACTIONS(1169),
    [sym_atx_h1_marker] = ACTIONS(1169),
    [sym_atx_h2_marker] = ACTIONS(1169),
    [sym_atx_h3_marker] = ACTIONS(1169),
    [sym_atx_h4_marker] = ACTIONS(1169),
    [sym_atx_h5_marker] = ACTIONS(1169),
    [sym_atx_h6_marker] = ACTIONS(1169),
    [sym__thematic_break] = ACTIONS(1169),
    [sym__list_marker_minus] = ACTIONS(1169),
    [sym__list_marker_plus] = ACTIONS(1169),
    [sym__list_marker_star] = ACTIONS(1169),
    [sym__list_marker_parenthesis] = ACTIONS(1169),
    [sym__list_marker_dot] = ACTIONS(1169),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1169),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1169),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1169),
    [sym__blank_line_start] = ACTIONS(1169),
    [sym__html_block_1_start] = ACTIONS(1169),
    [sym__html_block_2_start] = ACTIONS(1169),
    [sym__html_block_3_start] = ACTIONS(1169),
    [sym__html_block_4_start] = ACTIONS(1169),
    [sym__html_block_5_start] = ACTIONS(1169),
    [sym__html_block_6_start] = ACTIONS(1169),
    [sym__html_block_7_start] = ACTIONS(1169),
    [sym__no_indented_chunk] = ACTIONS(1185),
    [sym__pipe_table_start] = ACTIONS(1169),
  },
  [104] = {
    [sym_link_title] = STATE(711),
    [anon_sym_LBRACK] = ACTIONS(1187),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [anon_sym_POUND] = ACTIONS(1189),
    [anon_sym_DOLLAR] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_BSLASH] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym__] = ACTIONS(1189),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [aux_sym__word_token1] = ACTIONS(1189),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1189),
    [aux_sym__word_token2] = ACTIONS(1189),
    [sym__whitespace] = ACTIONS(1200),
    [sym__soft_line_ending] = ACTIONS(1189),
    [sym__block_close] = ACTIONS(1189),
    [sym__block_quote_start] = ACTIONS(1189),
    [sym__indented_chunk_start] = ACTIONS(1189),
    [sym_atx_h1_marker] = ACTIONS(1189),
    [sym_atx_h2_marker] = ACTIONS(1189),
    [sym_atx_h3_marker] = ACTIONS(1189),
    [sym_atx_h4_marker] = ACTIONS(1189),
    [sym_atx_h5_marker] = ACTIONS(1189),
    [sym_atx_h6_marker] = ACTIONS(1189),
    [sym__thematic_break] = ACTIONS(1189),
    [sym__list_marker_minus] = ACTIONS(1189),
    [sym__list_marker_plus] = ACTIONS(1189),
    [sym__list_marker_star] = ACTIONS(1189),
    [sym__list_marker_parenthesis] = ACTIONS(1189),
    [sym__list_marker_dot] = ACTIONS(1189),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1189),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1189),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1189),
    [sym__blank_line_start] = ACTIONS(1189),
    [sym__html_block_1_start] = ACTIONS(1189),
    [sym__html_block_2_start] = ACTIONS(1189),
    [sym__html_block_3_start] = ACTIONS(1189),
    [sym__html_block_4_start] = ACTIONS(1189),
    [sym__html_block_5_start] = ACTIONS(1189),
    [sym__html_block_6_start] = ACTIONS(1189),
    [sym__html_block_7_start] = ACTIONS(1189),
    [sym__no_indented_chunk] = ACTIONS(1203),
    [sym__pipe_table_start] = ACTIONS(1189),
  },
  [105] = {
    [sym_link_title] = STATE(733),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1207),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_GT] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_POUND] = ACTIONS(1205),
    [anon_sym_DOLLAR] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1205),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_BSLASH] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym__] = ACTIONS(1205),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [aux_sym__word_token1] = ACTIONS(1205),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1205),
    [aux_sym__word_token2] = ACTIONS(1205),
    [sym__whitespace] = ACTIONS(1218),
    [sym__soft_line_ending] = ACTIONS(1205),
    [sym__block_quote_start] = ACTIONS(1205),
    [sym__indented_chunk_start] = ACTIONS(1205),
    [sym_atx_h1_marker] = ACTIONS(1205),
    [sym_atx_h2_marker] = ACTIONS(1205),
    [sym_atx_h3_marker] = ACTIONS(1205),
    [sym_atx_h4_marker] = ACTIONS(1205),
    [sym_atx_h5_marker] = ACTIONS(1205),
    [sym_atx_h6_marker] = ACTIONS(1205),
    [sym__thematic_break] = ACTIONS(1205),
    [sym__list_marker_minus] = ACTIONS(1205),
    [sym__list_marker_plus] = ACTIONS(1205),
    [sym__list_marker_star] = ACTIONS(1205),
    [sym__list_marker_parenthesis] = ACTIONS(1205),
    [sym__list_marker_dot] = ACTIONS(1205),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1205),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1205),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1205),
    [sym__blank_line_start] = ACTIONS(1205),
    [sym__html_block_1_start] = ACTIONS(1205),
    [sym__html_block_2_start] = ACTIONS(1205),
    [sym__html_block_3_start] = ACTIONS(1205),
    [sym__html_block_4_start] = ACTIONS(1205),
    [sym__html_block_5_start] = ACTIONS(1205),
    [sym__html_block_6_start] = ACTIONS(1205),
    [sym__html_block_7_start] = ACTIONS(1205),
    [sym__no_indented_chunk] = ACTIONS(1221),
    [sym__pipe_table_start] = ACTIONS(1205),
  },
  [106] = {
    [sym_link_title] = STATE(690),
    [ts_builtin_sym_end] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1187),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [anon_sym_POUND] = ACTIONS(1189),
    [anon_sym_DOLLAR] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_BSLASH] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym__] = ACTIONS(1189),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [aux_sym__word_token1] = ACTIONS(1189),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1189),
    [aux_sym__word_token2] = ACTIONS(1189),
    [sym__whitespace] = ACTIONS(1223),
    [sym__soft_line_ending] = ACTIONS(1189),
    [sym__block_quote_start] = ACTIONS(1189),
    [sym__indented_chunk_start] = ACTIONS(1189),
    [sym_atx_h1_marker] = ACTIONS(1189),
    [sym_atx_h2_marker] = ACTIONS(1189),
    [sym_atx_h3_marker] = ACTIONS(1189),
    [sym_atx_h4_marker] = ACTIONS(1189),
    [sym_atx_h5_marker] = ACTIONS(1189),
    [sym_atx_h6_marker] = ACTIONS(1189),
    [sym__thematic_break] = ACTIONS(1189),
    [sym__list_marker_minus] = ACTIONS(1189),
    [sym__list_marker_plus] = ACTIONS(1189),
    [sym__list_marker_star] = ACTIONS(1189),
    [sym__list_marker_parenthesis] = ACTIONS(1189),
    [sym__list_marker_dot] = ACTIONS(1189),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1189),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1189),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1189),
    [sym__blank_line_start] = ACTIONS(1189),
    [sym__html_block_1_start] = ACTIONS(1189),
    [sym__html_block_2_start] = ACTIONS(1189),
    [sym__html_block_3_start] = ACTIONS(1189),
    [sym__html_block_4_start] = ACTIONS(1189),
    [sym__html_block_5_start] = ACTIONS(1189),
    [sym__html_block_6_start] = ACTIONS(1189),
    [sym__html_block_7_start] = ACTIONS(1189),
    [sym__no_indented_chunk] = ACTIONS(1226),
    [sym__pipe_table_start] = ACTIONS(1189),
  },
  [107] = {
    [sym_link_title] = STATE(709),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym__] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [aux_sym__word_token1] = ACTIONS(1230),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1230),
    [aux_sym__word_token2] = ACTIONS(1230),
    [sym__whitespace] = ACTIONS(1241),
    [sym__soft_line_ending] = ACTIONS(1230),
    [sym__block_close] = ACTIONS(1230),
    [sym__block_quote_start] = ACTIONS(1230),
    [sym__indented_chunk_start] = ACTIONS(1230),
    [sym_atx_h1_marker] = ACTIONS(1230),
    [sym_atx_h2_marker] = ACTIONS(1230),
    [sym_atx_h3_marker] = ACTIONS(1230),
    [sym_atx_h4_marker] = ACTIONS(1230),
    [sym_atx_h5_marker] = ACTIONS(1230),
    [sym_atx_h6_marker] = ACTIONS(1230),
    [sym__thematic_break] = ACTIONS(1230),
    [sym__list_marker_minus] = ACTIONS(1230),
    [sym__list_marker_plus] = ACTIONS(1230),
    [sym__list_marker_star] = ACTIONS(1230),
    [sym__list_marker_parenthesis] = ACTIONS(1230),
    [sym__list_marker_dot] = ACTIONS(1230),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1230),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1230),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1230),
    [sym__blank_line_start] = ACTIONS(1230),
    [sym__html_block_1_start] = ACTIONS(1230),
    [sym__html_block_2_start] = ACTIONS(1230),
    [sym__html_block_3_start] = ACTIONS(1230),
    [sym__html_block_4_start] = ACTIONS(1230),
    [sym__html_block_5_start] = ACTIONS(1230),
    [sym__html_block_6_start] = ACTIONS(1230),
    [sym__html_block_7_start] = ACTIONS(1230),
    [sym__no_indented_chunk] = ACTIONS(1244),
    [sym__pipe_table_start] = ACTIONS(1230),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1165),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1165),
    [anon_sym_BSLASH] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym__] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [aux_sym__word_token1] = ACTIONS(1165),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1165),
    [aux_sym__word_token2] = ACTIONS(1165),
    [sym__whitespace] = ACTIONS(1165),
    [sym__soft_line_ending] = ACTIONS(1165),
    [sym_block_continuation] = ACTIONS(1246),
    [sym__block_quote_start] = ACTIONS(1165),
    [sym__indented_chunk_start] = ACTIONS(1165),
    [sym_atx_h1_marker] = ACTIONS(1165),
    [sym_atx_h2_marker] = ACTIONS(1165),
    [sym_atx_h3_marker] = ACTIONS(1165),
    [sym_atx_h4_marker] = ACTIONS(1165),
    [sym_atx_h5_marker] = ACTIONS(1165),
    [sym_atx_h6_marker] = ACTIONS(1165),
    [sym__thematic_break] = ACTIONS(1165),
    [sym__list_marker_minus] = ACTIONS(1165),
    [sym__list_marker_plus] = ACTIONS(1165),
    [sym__list_marker_star] = ACTIONS(1165),
    [sym__list_marker_parenthesis] = ACTIONS(1165),
    [sym__list_marker_dot] = ACTIONS(1165),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1165),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1165),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1165),
    [sym__blank_line_start] = ACTIONS(1165),
    [sym__html_block_1_start] = ACTIONS(1165),
    [sym__html_block_2_start] = ACTIONS(1165),
    [sym__html_block_3_start] = ACTIONS(1165),
    [sym__html_block_4_start] = ACTIONS(1165),
    [sym__html_block_5_start] = ACTIONS(1165),
    [sym__html_block_6_start] = ACTIONS(1165),
    [sym__html_block_7_start] = ACTIONS(1165),
    [sym__no_indented_chunk] = ACTIONS(1165),
    [sym__pipe_table_start] = ACTIONS(1165),
  },
  [109] = {
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_POUND] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_COLON] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1250),
    [aux_sym__word_token1] = ACTIONS(1250),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1250),
    [aux_sym__word_token2] = ACTIONS(1250),
    [sym__whitespace] = ACTIONS(1250),
    [sym__soft_line_ending] = ACTIONS(1250),
    [sym__block_close] = ACTIONS(1250),
    [sym__block_quote_start] = ACTIONS(1250),
    [sym__indented_chunk_start] = ACTIONS(1250),
    [sym_atx_h1_marker] = ACTIONS(1250),
    [sym_atx_h2_marker] = ACTIONS(1250),
    [sym_atx_h3_marker] = ACTIONS(1250),
    [sym_atx_h4_marker] = ACTIONS(1250),
    [sym_atx_h5_marker] = ACTIONS(1250),
    [sym_atx_h6_marker] = ACTIONS(1250),
    [sym_setext_h1_underline] = ACTIONS(1250),
    [sym_setext_h2_underline] = ACTIONS(1250),
    [sym__thematic_break] = ACTIONS(1250),
    [sym__list_marker_minus] = ACTIONS(1250),
    [sym__list_marker_plus] = ACTIONS(1250),
    [sym__list_marker_star] = ACTIONS(1250),
    [sym__list_marker_parenthesis] = ACTIONS(1250),
    [sym__list_marker_dot] = ACTIONS(1250),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1250),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1250),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1250),
    [sym__blank_line_start] = ACTIONS(1250),
    [sym__html_block_1_start] = ACTIONS(1250),
    [sym__html_block_2_start] = ACTIONS(1250),
    [sym__html_block_3_start] = ACTIONS(1250),
    [sym__html_block_4_start] = ACTIONS(1250),
    [sym__html_block_5_start] = ACTIONS(1250),
    [sym__html_block_6_start] = ACTIONS(1250),
    [sym__html_block_7_start] = ACTIONS(1250),
    [sym__pipe_table_start] = ACTIONS(1250),
  },
  [110] = {
    [sym_link_title] = STATE(737),
    [ts_builtin_sym_end] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym__] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [aux_sym__word_token1] = ACTIONS(1230),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1230),
    [aux_sym__word_token2] = ACTIONS(1230),
    [sym__whitespace] = ACTIONS(1252),
    [sym__soft_line_ending] = ACTIONS(1230),
    [sym__block_quote_start] = ACTIONS(1230),
    [sym__indented_chunk_start] = ACTIONS(1230),
    [sym_atx_h1_marker] = ACTIONS(1230),
    [sym_atx_h2_marker] = ACTIONS(1230),
    [sym_atx_h3_marker] = ACTIONS(1230),
    [sym_atx_h4_marker] = ACTIONS(1230),
    [sym_atx_h5_marker] = ACTIONS(1230),
    [sym_atx_h6_marker] = ACTIONS(1230),
    [sym__thematic_break] = ACTIONS(1230),
    [sym__list_marker_minus] = ACTIONS(1230),
    [sym__list_marker_plus] = ACTIONS(1230),
    [sym__list_marker_star] = ACTIONS(1230),
    [sym__list_marker_parenthesis] = ACTIONS(1230),
    [sym__list_marker_dot] = ACTIONS(1230),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1230),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1230),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1230),
    [sym__blank_line_start] = ACTIONS(1230),
    [sym__html_block_1_start] = ACTIONS(1230),
    [sym__html_block_2_start] = ACTIONS(1230),
    [sym__html_block_3_start] = ACTIONS(1230),
    [sym__html_block_4_start] = ACTIONS(1230),
    [sym__html_block_5_start] = ACTIONS(1230),
    [sym__html_block_6_start] = ACTIONS(1230),
    [sym__html_block_7_start] = ACTIONS(1230),
    [sym__no_indented_chunk] = ACTIONS(1255),
    [sym__pipe_table_start] = ACTIONS(1230),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_POUND] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_SQUOTE] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1257),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AT] = ACTIONS(1257),
    [anon_sym_BSLASH] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym__] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [aux_sym__word_token1] = ACTIONS(1257),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1257),
    [aux_sym__word_token2] = ACTIONS(1257),
    [sym__whitespace] = ACTIONS(1257),
    [sym__soft_line_ending] = ACTIONS(1257),
    [sym__block_quote_start] = ACTIONS(1257),
    [sym__indented_chunk_start] = ACTIONS(1257),
    [sym_atx_h1_marker] = ACTIONS(1257),
    [sym_atx_h2_marker] = ACTIONS(1257),
    [sym_atx_h3_marker] = ACTIONS(1257),
    [sym_atx_h4_marker] = ACTIONS(1257),
    [sym_atx_h5_marker] = ACTIONS(1257),
    [sym_atx_h6_marker] = ACTIONS(1257),
    [sym_setext_h1_underline] = ACTIONS(1261),
    [sym_setext_h2_underline] = ACTIONS(1263),
    [sym__thematic_break] = ACTIONS(1257),
    [sym__list_marker_minus] = ACTIONS(1257),
    [sym__list_marker_plus] = ACTIONS(1257),
    [sym__list_marker_star] = ACTIONS(1257),
    [sym__list_marker_parenthesis] = ACTIONS(1257),
    [sym__list_marker_dot] = ACTIONS(1257),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1257),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1257),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1257),
    [sym__blank_line_start] = ACTIONS(1257),
    [sym__html_block_1_start] = ACTIONS(1257),
    [sym__html_block_2_start] = ACTIONS(1257),
    [sym__html_block_3_start] = ACTIONS(1257),
    [sym__html_block_4_start] = ACTIONS(1257),
    [sym__html_block_5_start] = ACTIONS(1257),
    [sym__html_block_6_start] = ACTIONS(1257),
    [sym__html_block_7_start] = ACTIONS(1257),
    [sym__pipe_table_start] = ACTIONS(1257),
  },
  [112] = {
    [sym_link_title] = STATE(714),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_POUND] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym__] = ACTIONS(1145),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [aux_sym__word_token1] = ACTIONS(1145),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1145),
    [aux_sym__word_token2] = ACTIONS(1145),
    [sym__whitespace] = ACTIONS(1265),
    [sym__soft_line_ending] = ACTIONS(1145),
    [sym__block_close] = ACTIONS(1145),
    [sym__block_quote_start] = ACTIONS(1145),
    [sym__indented_chunk_start] = ACTIONS(1145),
    [sym_atx_h1_marker] = ACTIONS(1145),
    [sym_atx_h2_marker] = ACTIONS(1145),
    [sym_atx_h3_marker] = ACTIONS(1145),
    [sym_atx_h4_marker] = ACTIONS(1145),
    [sym_atx_h5_marker] = ACTIONS(1145),
    [sym_atx_h6_marker] = ACTIONS(1145),
    [sym__thematic_break] = ACTIONS(1145),
    [sym__list_marker_minus] = ACTIONS(1145),
    [sym__list_marker_plus] = ACTIONS(1145),
    [sym__list_marker_star] = ACTIONS(1145),
    [sym__list_marker_parenthesis] = ACTIONS(1145),
    [sym__list_marker_dot] = ACTIONS(1145),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1145),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1145),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1145),
    [sym__blank_line_start] = ACTIONS(1145),
    [sym__html_block_1_start] = ACTIONS(1145),
    [sym__html_block_2_start] = ACTIONS(1145),
    [sym__html_block_3_start] = ACTIONS(1145),
    [sym__html_block_4_start] = ACTIONS(1145),
    [sym__html_block_5_start] = ACTIONS(1145),
    [sym__html_block_6_start] = ACTIONS(1145),
    [sym__html_block_7_start] = ACTIONS(1145),
    [sym__no_indented_chunk] = ACTIONS(1268),
    [sym__pipe_table_start] = ACTIONS(1145),
  },
  [113] = {
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_POUND] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_SQUOTE] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1257),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AT] = ACTIONS(1257),
    [anon_sym_BSLASH] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym__] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [aux_sym__word_token1] = ACTIONS(1257),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1257),
    [aux_sym__word_token2] = ACTIONS(1257),
    [sym__whitespace] = ACTIONS(1257),
    [sym__soft_line_ending] = ACTIONS(1257),
    [sym__block_close] = ACTIONS(1257),
    [sym__block_quote_start] = ACTIONS(1257),
    [sym__indented_chunk_start] = ACTIONS(1257),
    [sym_atx_h1_marker] = ACTIONS(1257),
    [sym_atx_h2_marker] = ACTIONS(1257),
    [sym_atx_h3_marker] = ACTIONS(1257),
    [sym_atx_h4_marker] = ACTIONS(1257),
    [sym_atx_h5_marker] = ACTIONS(1257),
    [sym_atx_h6_marker] = ACTIONS(1257),
    [sym_setext_h1_underline] = ACTIONS(1270),
    [sym_setext_h2_underline] = ACTIONS(1272),
    [sym__thematic_break] = ACTIONS(1257),
    [sym__list_marker_minus] = ACTIONS(1257),
    [sym__list_marker_plus] = ACTIONS(1257),
    [sym__list_marker_star] = ACTIONS(1257),
    [sym__list_marker_parenthesis] = ACTIONS(1257),
    [sym__list_marker_dot] = ACTIONS(1257),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1257),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1257),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1257),
    [sym__blank_line_start] = ACTIONS(1257),
    [sym__html_block_1_start] = ACTIONS(1257),
    [sym__html_block_2_start] = ACTIONS(1257),
    [sym__html_block_3_start] = ACTIONS(1257),
    [sym__html_block_4_start] = ACTIONS(1257),
    [sym__html_block_5_start] = ACTIONS(1257),
    [sym__html_block_6_start] = ACTIONS(1257),
    [sym__html_block_7_start] = ACTIONS(1257),
    [sym__pipe_table_start] = ACTIONS(1257),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_POUND] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_COMMA] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [aux_sym__word_token1] = ACTIONS(1274),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1274),
    [aux_sym__word_token2] = ACTIONS(1274),
    [sym__whitespace] = ACTIONS(1274),
    [sym__soft_line_ending] = ACTIONS(1274),
    [sym__block_quote_start] = ACTIONS(1274),
    [sym__indented_chunk_start] = ACTIONS(1274),
    [sym_atx_h1_marker] = ACTIONS(1274),
    [sym_atx_h2_marker] = ACTIONS(1274),
    [sym_atx_h3_marker] = ACTIONS(1274),
    [sym_atx_h4_marker] = ACTIONS(1274),
    [sym_atx_h5_marker] = ACTIONS(1274),
    [sym_atx_h6_marker] = ACTIONS(1274),
    [sym_setext_h1_underline] = ACTIONS(1274),
    [sym_setext_h2_underline] = ACTIONS(1274),
    [sym__thematic_break] = ACTIONS(1274),
    [sym__list_marker_minus] = ACTIONS(1274),
    [sym__list_marker_plus] = ACTIONS(1274),
    [sym__list_marker_star] = ACTIONS(1274),
    [sym__list_marker_parenthesis] = ACTIONS(1274),
    [sym__list_marker_dot] = ACTIONS(1274),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1274),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1274),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1274),
    [sym__blank_line_start] = ACTIONS(1274),
    [sym__html_block_1_start] = ACTIONS(1274),
    [sym__html_block_2_start] = ACTIONS(1274),
    [sym__html_block_3_start] = ACTIONS(1274),
    [sym__html_block_4_start] = ACTIONS(1274),
    [sym__html_block_5_start] = ACTIONS(1274),
    [sym__html_block_6_start] = ACTIONS(1274),
    [sym__html_block_7_start] = ACTIONS(1274),
    [sym__pipe_table_start] = ACTIONS(1274),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_POUND] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_COLON] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1250),
    [aux_sym__word_token1] = ACTIONS(1250),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1250),
    [aux_sym__word_token2] = ACTIONS(1250),
    [sym__whitespace] = ACTIONS(1250),
    [sym__soft_line_ending] = ACTIONS(1250),
    [sym__block_quote_start] = ACTIONS(1250),
    [sym__indented_chunk_start] = ACTIONS(1250),
    [sym_atx_h1_marker] = ACTIONS(1250),
    [sym_atx_h2_marker] = ACTIONS(1250),
    [sym_atx_h3_marker] = ACTIONS(1250),
    [sym_atx_h4_marker] = ACTIONS(1250),
    [sym_atx_h5_marker] = ACTIONS(1250),
    [sym_atx_h6_marker] = ACTIONS(1250),
    [sym_setext_h1_underline] = ACTIONS(1250),
    [sym_setext_h2_underline] = ACTIONS(1250),
    [sym__thematic_break] = ACTIONS(1250),
    [sym__list_marker_minus] = ACTIONS(1250),
    [sym__list_marker_plus] = ACTIONS(1250),
    [sym__list_marker_star] = ACTIONS(1250),
    [sym__list_marker_parenthesis] = ACTIONS(1250),
    [sym__list_marker_dot] = ACTIONS(1250),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1250),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1250),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1250),
    [sym__blank_line_start] = ACTIONS(1250),
    [sym__html_block_1_start] = ACTIONS(1250),
    [sym__html_block_2_start] = ACTIONS(1250),
    [sym__html_block_3_start] = ACTIONS(1250),
    [sym__html_block_4_start] = ACTIONS(1250),
    [sym__html_block_5_start] = ACTIONS(1250),
    [sym__html_block_6_start] = ACTIONS(1250),
    [sym__html_block_7_start] = ACTIONS(1250),
    [sym__pipe_table_start] = ACTIONS(1250),
  },
  [116] = {
    [sym_link_title] = STATE(705),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_POUND] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_BSLASH] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym__] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [aux_sym__word_token1] = ACTIONS(1169),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1169),
    [aux_sym__word_token2] = ACTIONS(1169),
    [sym__whitespace] = ACTIONS(1278),
    [sym__soft_line_ending] = ACTIONS(1169),
    [sym__block_close] = ACTIONS(1169),
    [sym__block_quote_start] = ACTIONS(1169),
    [sym__indented_chunk_start] = ACTIONS(1169),
    [sym_atx_h1_marker] = ACTIONS(1169),
    [sym_atx_h2_marker] = ACTIONS(1169),
    [sym_atx_h3_marker] = ACTIONS(1169),
    [sym_atx_h4_marker] = ACTIONS(1169),
    [sym_atx_h5_marker] = ACTIONS(1169),
    [sym_atx_h6_marker] = ACTIONS(1169),
    [sym__thematic_break] = ACTIONS(1169),
    [sym__list_marker_minus] = ACTIONS(1169),
    [sym__list_marker_plus] = ACTIONS(1169),
    [sym__list_marker_star] = ACTIONS(1169),
    [sym__list_marker_parenthesis] = ACTIONS(1169),
    [sym__list_marker_dot] = ACTIONS(1169),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1169),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1169),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1169),
    [sym__blank_line_start] = ACTIONS(1169),
    [sym__html_block_1_start] = ACTIONS(1169),
    [sym__html_block_2_start] = ACTIONS(1169),
    [sym__html_block_3_start] = ACTIONS(1169),
    [sym__html_block_4_start] = ACTIONS(1169),
    [sym__html_block_5_start] = ACTIONS(1169),
    [sym__html_block_6_start] = ACTIONS(1169),
    [sym__html_block_7_start] = ACTIONS(1169),
    [sym__no_indented_chunk] = ACTIONS(1281),
    [sym__pipe_table_start] = ACTIONS(1169),
  },
  [117] = {
    [sym_link_title] = STATE(707),
    [anon_sym_LBRACK] = ACTIONS(1207),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_GT] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_POUND] = ACTIONS(1205),
    [anon_sym_DOLLAR] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1212),
    [anon_sym_STAR] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1205),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_BSLASH] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym__] = ACTIONS(1205),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [aux_sym__word_token1] = ACTIONS(1205),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1205),
    [aux_sym__word_token2] = ACTIONS(1205),
    [sym__whitespace] = ACTIONS(1283),
    [sym__soft_line_ending] = ACTIONS(1205),
    [sym__block_close] = ACTIONS(1205),
    [sym__block_quote_start] = ACTIONS(1205),
    [sym__indented_chunk_start] = ACTIONS(1205),
    [sym_atx_h1_marker] = ACTIONS(1205),
    [sym_atx_h2_marker] = ACTIONS(1205),
    [sym_atx_h3_marker] = ACTIONS(1205),
    [sym_atx_h4_marker] = ACTIONS(1205),
    [sym_atx_h5_marker] = ACTIONS(1205),
    [sym_atx_h6_marker] = ACTIONS(1205),
    [sym__thematic_break] = ACTIONS(1205),
    [sym__list_marker_minus] = ACTIONS(1205),
    [sym__list_marker_plus] = ACTIONS(1205),
    [sym__list_marker_star] = ACTIONS(1205),
    [sym__list_marker_parenthesis] = ACTIONS(1205),
    [sym__list_marker_dot] = ACTIONS(1205),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1205),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1205),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1205),
    [sym__blank_line_start] = ACTIONS(1205),
    [sym__html_block_1_start] = ACTIONS(1205),
    [sym__html_block_2_start] = ACTIONS(1205),
    [sym__html_block_3_start] = ACTIONS(1205),
    [sym__html_block_4_start] = ACTIONS(1205),
    [sym__html_block_5_start] = ACTIONS(1205),
    [sym__html_block_6_start] = ACTIONS(1205),
    [sym__html_block_7_start] = ACTIONS(1205),
    [sym__no_indented_chunk] = ACTIONS(1286),
    [sym__pipe_table_start] = ACTIONS(1205),
  },
  [118] = {
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_POUND] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_COMMA] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [aux_sym__word_token1] = ACTIONS(1274),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1274),
    [aux_sym__word_token2] = ACTIONS(1274),
    [sym__whitespace] = ACTIONS(1274),
    [sym__soft_line_ending] = ACTIONS(1274),
    [sym__block_close] = ACTIONS(1274),
    [sym__block_quote_start] = ACTIONS(1274),
    [sym__indented_chunk_start] = ACTIONS(1274),
    [sym_atx_h1_marker] = ACTIONS(1274),
    [sym_atx_h2_marker] = ACTIONS(1274),
    [sym_atx_h3_marker] = ACTIONS(1274),
    [sym_atx_h4_marker] = ACTIONS(1274),
    [sym_atx_h5_marker] = ACTIONS(1274),
    [sym_atx_h6_marker] = ACTIONS(1274),
    [sym_setext_h1_underline] = ACTIONS(1274),
    [sym_setext_h2_underline] = ACTIONS(1274),
    [sym__thematic_break] = ACTIONS(1274),
    [sym__list_marker_minus] = ACTIONS(1274),
    [sym__list_marker_plus] = ACTIONS(1274),
    [sym__list_marker_star] = ACTIONS(1274),
    [sym__list_marker_parenthesis] = ACTIONS(1274),
    [sym__list_marker_dot] = ACTIONS(1274),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1274),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1274),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1274),
    [sym__blank_line_start] = ACTIONS(1274),
    [sym__html_block_1_start] = ACTIONS(1274),
    [sym__html_block_2_start] = ACTIONS(1274),
    [sym__html_block_3_start] = ACTIONS(1274),
    [sym__html_block_4_start] = ACTIONS(1274),
    [sym__html_block_5_start] = ACTIONS(1274),
    [sym__html_block_6_start] = ACTIONS(1274),
    [sym__html_block_7_start] = ACTIONS(1274),
    [sym__pipe_table_start] = ACTIONS(1274),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_POUND] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1288),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_QMARK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1288),
    [anon_sym__] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [aux_sym__word_token1] = ACTIONS(1288),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1288),
    [aux_sym__word_token2] = ACTIONS(1288),
    [sym__whitespace] = ACTIONS(1288),
    [sym__soft_line_ending] = ACTIONS(1288),
    [sym_block_continuation] = ACTIONS(1292),
    [sym__block_quote_start] = ACTIONS(1288),
    [sym__indented_chunk_start] = ACTIONS(1288),
    [sym_atx_h1_marker] = ACTIONS(1288),
    [sym_atx_h2_marker] = ACTIONS(1288),
    [sym_atx_h3_marker] = ACTIONS(1288),
    [sym_atx_h4_marker] = ACTIONS(1288),
    [sym_atx_h5_marker] = ACTIONS(1288),
    [sym_atx_h6_marker] = ACTIONS(1288),
    [sym__thematic_break] = ACTIONS(1288),
    [sym__list_marker_minus] = ACTIONS(1288),
    [sym__list_marker_plus] = ACTIONS(1288),
    [sym__list_marker_star] = ACTIONS(1288),
    [sym__list_marker_parenthesis] = ACTIONS(1288),
    [sym__list_marker_dot] = ACTIONS(1288),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1288),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1288),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1288),
    [sym__blank_line_start] = ACTIONS(1288),
    [sym__html_block_1_start] = ACTIONS(1288),
    [sym__html_block_2_start] = ACTIONS(1288),
    [sym__html_block_3_start] = ACTIONS(1288),
    [sym__html_block_4_start] = ACTIONS(1288),
    [sym__html_block_5_start] = ACTIONS(1288),
    [sym__html_block_6_start] = ACTIONS(1288),
    [sym__html_block_7_start] = ACTIONS(1288),
    [sym__pipe_table_start] = ACTIONS(1288),
  },
  [120] = {
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_DOLLAR] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_COLON] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_QMARK] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_BSLASH] = ACTIONS(1296),
    [anon_sym_CARET] = ACTIONS(1296),
    [anon_sym__] = ACTIONS(1296),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [aux_sym__word_token1] = ACTIONS(1296),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1296),
    [aux_sym__word_token2] = ACTIONS(1296),
    [sym__whitespace] = ACTIONS(1296),
    [sym__soft_line_ending] = ACTIONS(1296),
    [sym__block_close] = ACTIONS(1296),
    [sym_block_continuation] = ACTIONS(1298),
    [sym__block_quote_start] = ACTIONS(1296),
    [sym__indented_chunk_start] = ACTIONS(1296),
    [sym_atx_h1_marker] = ACTIONS(1296),
    [sym_atx_h2_marker] = ACTIONS(1296),
    [sym_atx_h3_marker] = ACTIONS(1296),
    [sym_atx_h4_marker] = ACTIONS(1296),
    [sym_atx_h5_marker] = ACTIONS(1296),
    [sym_atx_h6_marker] = ACTIONS(1296),
    [sym__thematic_break] = ACTIONS(1296),
    [sym__list_marker_minus] = ACTIONS(1296),
    [sym__list_marker_plus] = ACTIONS(1296),
    [sym__list_marker_star] = ACTIONS(1296),
    [sym__list_marker_parenthesis] = ACTIONS(1296),
    [sym__list_marker_dot] = ACTIONS(1296),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1296),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1296),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1296),
    [sym__blank_line_start] = ACTIONS(1296),
    [sym__html_block_1_start] = ACTIONS(1296),
    [sym__html_block_2_start] = ACTIONS(1296),
    [sym__html_block_3_start] = ACTIONS(1296),
    [sym__html_block_4_start] = ACTIONS(1296),
    [sym__html_block_5_start] = ACTIONS(1296),
    [sym__html_block_6_start] = ACTIONS(1296),
    [sym__html_block_7_start] = ACTIONS(1296),
    [sym__pipe_table_start] = ACTIONS(1296),
  },
  [121] = {
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1165),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1165),
    [anon_sym_BSLASH] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym__] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [aux_sym__word_token1] = ACTIONS(1165),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1165),
    [aux_sym__word_token2] = ACTIONS(1165),
    [sym__whitespace] = ACTIONS(1165),
    [sym__soft_line_ending] = ACTIONS(1165),
    [sym__block_close] = ACTIONS(1165),
    [sym_block_continuation] = ACTIONS(1300),
    [sym__block_quote_start] = ACTIONS(1165),
    [sym__indented_chunk_start] = ACTIONS(1165),
    [sym_atx_h1_marker] = ACTIONS(1165),
    [sym_atx_h2_marker] = ACTIONS(1165),
    [sym_atx_h3_marker] = ACTIONS(1165),
    [sym_atx_h4_marker] = ACTIONS(1165),
    [sym_atx_h5_marker] = ACTIONS(1165),
    [sym_atx_h6_marker] = ACTIONS(1165),
    [sym__thematic_break] = ACTIONS(1165),
    [sym__list_marker_minus] = ACTIONS(1165),
    [sym__list_marker_plus] = ACTIONS(1165),
    [sym__list_marker_star] = ACTIONS(1165),
    [sym__list_marker_parenthesis] = ACTIONS(1165),
    [sym__list_marker_dot] = ACTIONS(1165),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1165),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1165),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1165),
    [sym__blank_line_start] = ACTIONS(1165),
    [sym__html_block_1_start] = ACTIONS(1165),
    [sym__html_block_2_start] = ACTIONS(1165),
    [sym__html_block_3_start] = ACTIONS(1165),
    [sym__html_block_4_start] = ACTIONS(1165),
    [sym__html_block_5_start] = ACTIONS(1165),
    [sym__html_block_6_start] = ACTIONS(1165),
    [sym__html_block_7_start] = ACTIONS(1165),
    [sym__pipe_table_start] = ACTIONS(1165),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_BANG] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [anon_sym_POUND] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_AMP] = ACTIONS(1302),
    [anon_sym_SQUOTE] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_COMMA] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_COLON] = ACTIONS(1302),
    [anon_sym_SEMI] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_QMARK] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [anon_sym_BSLASH] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1302),
    [anon_sym__] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [aux_sym__word_token1] = ACTIONS(1302),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1302),
    [aux_sym__word_token2] = ACTIONS(1302),
    [sym__whitespace] = ACTIONS(1302),
    [sym__soft_line_ending] = ACTIONS(1302),
    [sym_block_continuation] = ACTIONS(1306),
    [sym__block_quote_start] = ACTIONS(1302),
    [sym__indented_chunk_start] = ACTIONS(1302),
    [sym_atx_h1_marker] = ACTIONS(1302),
    [sym_atx_h2_marker] = ACTIONS(1302),
    [sym_atx_h3_marker] = ACTIONS(1302),
    [sym_atx_h4_marker] = ACTIONS(1302),
    [sym_atx_h5_marker] = ACTIONS(1302),
    [sym_atx_h6_marker] = ACTIONS(1302),
    [sym__thematic_break] = ACTIONS(1302),
    [sym__list_marker_minus] = ACTIONS(1302),
    [sym__list_marker_plus] = ACTIONS(1302),
    [sym__list_marker_star] = ACTIONS(1302),
    [sym__list_marker_parenthesis] = ACTIONS(1302),
    [sym__list_marker_dot] = ACTIONS(1302),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1302),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1302),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1302),
    [sym__blank_line_start] = ACTIONS(1302),
    [sym__html_block_1_start] = ACTIONS(1302),
    [sym__html_block_2_start] = ACTIONS(1302),
    [sym__html_block_3_start] = ACTIONS(1302),
    [sym__html_block_4_start] = ACTIONS(1302),
    [sym__html_block_5_start] = ACTIONS(1302),
    [sym__html_block_6_start] = ACTIONS(1302),
    [sym__html_block_7_start] = ACTIONS(1302),
    [sym__pipe_table_start] = ACTIONS(1302),
  },
  [123] = {
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [aux_sym__word_token1] = ACTIONS(1119),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1119),
    [aux_sym__word_token2] = ACTIONS(1119),
    [sym__whitespace] = ACTIONS(1119),
    [sym__soft_line_ending] = ACTIONS(1119),
    [sym__block_close] = ACTIONS(1119),
    [sym_block_continuation] = ACTIONS(1308),
    [sym__block_quote_start] = ACTIONS(1119),
    [sym__indented_chunk_start] = ACTIONS(1119),
    [sym_atx_h1_marker] = ACTIONS(1119),
    [sym_atx_h2_marker] = ACTIONS(1119),
    [sym_atx_h3_marker] = ACTIONS(1119),
    [sym_atx_h4_marker] = ACTIONS(1119),
    [sym_atx_h5_marker] = ACTIONS(1119),
    [sym_atx_h6_marker] = ACTIONS(1119),
    [sym__thematic_break] = ACTIONS(1119),
    [sym__list_marker_minus] = ACTIONS(1119),
    [sym__list_marker_plus] = ACTIONS(1119),
    [sym__list_marker_star] = ACTIONS(1119),
    [sym__list_marker_parenthesis] = ACTIONS(1119),
    [sym__list_marker_dot] = ACTIONS(1119),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1119),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1119),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1119),
    [sym__blank_line_start] = ACTIONS(1119),
    [sym__html_block_1_start] = ACTIONS(1119),
    [sym__html_block_2_start] = ACTIONS(1119),
    [sym__html_block_3_start] = ACTIONS(1119),
    [sym__html_block_4_start] = ACTIONS(1119),
    [sym__html_block_5_start] = ACTIONS(1119),
    [sym__html_block_6_start] = ACTIONS(1119),
    [sym__html_block_7_start] = ACTIONS(1119),
    [sym__pipe_table_start] = ACTIONS(1119),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym__] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(1310),
    [aux_sym__word_token1] = ACTIONS(1310),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1310),
    [aux_sym__word_token2] = ACTIONS(1310),
    [sym__whitespace] = ACTIONS(1310),
    [sym__soft_line_ending] = ACTIONS(1310),
    [sym_block_continuation] = ACTIONS(1314),
    [sym__block_quote_start] = ACTIONS(1310),
    [sym__indented_chunk_start] = ACTIONS(1310),
    [sym_atx_h1_marker] = ACTIONS(1310),
    [sym_atx_h2_marker] = ACTIONS(1310),
    [sym_atx_h3_marker] = ACTIONS(1310),
    [sym_atx_h4_marker] = ACTIONS(1310),
    [sym_atx_h5_marker] = ACTIONS(1310),
    [sym_atx_h6_marker] = ACTIONS(1310),
    [sym__thematic_break] = ACTIONS(1310),
    [sym__list_marker_minus] = ACTIONS(1310),
    [sym__list_marker_plus] = ACTIONS(1310),
    [sym__list_marker_star] = ACTIONS(1310),
    [sym__list_marker_parenthesis] = ACTIONS(1310),
    [sym__list_marker_dot] = ACTIONS(1310),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1310),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1310),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1310),
    [sym__blank_line_start] = ACTIONS(1310),
    [sym__html_block_1_start] = ACTIONS(1310),
    [sym__html_block_2_start] = ACTIONS(1310),
    [sym__html_block_3_start] = ACTIONS(1310),
    [sym__html_block_4_start] = ACTIONS(1310),
    [sym__html_block_5_start] = ACTIONS(1310),
    [sym__html_block_6_start] = ACTIONS(1310),
    [sym__html_block_7_start] = ACTIONS(1310),
    [sym__pipe_table_start] = ACTIONS(1310),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1316),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym__] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [aux_sym__word_token1] = ACTIONS(1316),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1316),
    [aux_sym__word_token2] = ACTIONS(1316),
    [sym__whitespace] = ACTIONS(1316),
    [sym__soft_line_ending] = ACTIONS(1316),
    [sym_block_continuation] = ACTIONS(1320),
    [sym__block_quote_start] = ACTIONS(1316),
    [sym__indented_chunk_start] = ACTIONS(1316),
    [sym_atx_h1_marker] = ACTIONS(1316),
    [sym_atx_h2_marker] = ACTIONS(1316),
    [sym_atx_h3_marker] = ACTIONS(1316),
    [sym_atx_h4_marker] = ACTIONS(1316),
    [sym_atx_h5_marker] = ACTIONS(1316),
    [sym_atx_h6_marker] = ACTIONS(1316),
    [sym__thematic_break] = ACTIONS(1316),
    [sym__list_marker_minus] = ACTIONS(1316),
    [sym__list_marker_plus] = ACTIONS(1316),
    [sym__list_marker_star] = ACTIONS(1316),
    [sym__list_marker_parenthesis] = ACTIONS(1316),
    [sym__list_marker_dot] = ACTIONS(1316),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1316),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1316),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1316),
    [sym__blank_line_start] = ACTIONS(1316),
    [sym__html_block_1_start] = ACTIONS(1316),
    [sym__html_block_2_start] = ACTIONS(1316),
    [sym__html_block_3_start] = ACTIONS(1316),
    [sym__html_block_4_start] = ACTIONS(1316),
    [sym__html_block_5_start] = ACTIONS(1316),
    [sym__html_block_6_start] = ACTIONS(1316),
    [sym__html_block_7_start] = ACTIONS(1316),
    [sym__pipe_table_start] = ACTIONS(1316),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_POUND] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(1322),
    [aux_sym__word_token1] = ACTIONS(1322),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1322),
    [aux_sym__word_token2] = ACTIONS(1322),
    [sym__whitespace] = ACTIONS(1322),
    [sym__soft_line_ending] = ACTIONS(1322),
    [sym_block_continuation] = ACTIONS(1326),
    [sym__block_quote_start] = ACTIONS(1322),
    [sym__indented_chunk_start] = ACTIONS(1322),
    [sym_atx_h1_marker] = ACTIONS(1322),
    [sym_atx_h2_marker] = ACTIONS(1322),
    [sym_atx_h3_marker] = ACTIONS(1322),
    [sym_atx_h4_marker] = ACTIONS(1322),
    [sym_atx_h5_marker] = ACTIONS(1322),
    [sym_atx_h6_marker] = ACTIONS(1322),
    [sym__thematic_break] = ACTIONS(1322),
    [sym__list_marker_minus] = ACTIONS(1322),
    [sym__list_marker_plus] = ACTIONS(1322),
    [sym__list_marker_star] = ACTIONS(1322),
    [sym__list_marker_parenthesis] = ACTIONS(1322),
    [sym__list_marker_dot] = ACTIONS(1322),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1322),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1322),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1322),
    [sym__blank_line_start] = ACTIONS(1322),
    [sym__html_block_1_start] = ACTIONS(1322),
    [sym__html_block_2_start] = ACTIONS(1322),
    [sym__html_block_3_start] = ACTIONS(1322),
    [sym__html_block_4_start] = ACTIONS(1322),
    [sym__html_block_5_start] = ACTIONS(1322),
    [sym__html_block_6_start] = ACTIONS(1322),
    [sym__html_block_7_start] = ACTIONS(1322),
    [sym__pipe_table_start] = ACTIONS(1322),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_RBRACK] = ACTIONS(1328),
    [anon_sym_LT] = ACTIONS(1328),
    [anon_sym_GT] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [anon_sym_POUND] = ACTIONS(1328),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(1328),
    [anon_sym_SLASH] = ACTIONS(1328),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_BSLASH] = ACTIONS(1328),
    [anon_sym_CARET] = ACTIONS(1328),
    [anon_sym__] = ACTIONS(1328),
    [anon_sym_BQUOTE] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_PIPE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [aux_sym__word_token1] = ACTIONS(1328),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1328),
    [aux_sym__word_token2] = ACTIONS(1328),
    [sym__whitespace] = ACTIONS(1328),
    [sym__soft_line_ending] = ACTIONS(1328),
    [sym_block_continuation] = ACTIONS(1332),
    [sym__block_quote_start] = ACTIONS(1328),
    [sym__indented_chunk_start] = ACTIONS(1328),
    [sym_atx_h1_marker] = ACTIONS(1328),
    [sym_atx_h2_marker] = ACTIONS(1328),
    [sym_atx_h3_marker] = ACTIONS(1328),
    [sym_atx_h4_marker] = ACTIONS(1328),
    [sym_atx_h5_marker] = ACTIONS(1328),
    [sym_atx_h6_marker] = ACTIONS(1328),
    [sym__thematic_break] = ACTIONS(1328),
    [sym__list_marker_minus] = ACTIONS(1328),
    [sym__list_marker_plus] = ACTIONS(1328),
    [sym__list_marker_star] = ACTIONS(1328),
    [sym__list_marker_parenthesis] = ACTIONS(1328),
    [sym__list_marker_dot] = ACTIONS(1328),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1328),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1328),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1328),
    [sym__blank_line_start] = ACTIONS(1328),
    [sym__html_block_1_start] = ACTIONS(1328),
    [sym__html_block_2_start] = ACTIONS(1328),
    [sym__html_block_3_start] = ACTIONS(1328),
    [sym__html_block_4_start] = ACTIONS(1328),
    [sym__html_block_5_start] = ACTIONS(1328),
    [sym__html_block_6_start] = ACTIONS(1328),
    [sym__html_block_7_start] = ACTIONS(1328),
    [sym__pipe_table_start] = ACTIONS(1328),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_POUND] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_QMARK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym__] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [aux_sym__word_token1] = ACTIONS(1334),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1334),
    [aux_sym__word_token2] = ACTIONS(1334),
    [sym__whitespace] = ACTIONS(1334),
    [sym__soft_line_ending] = ACTIONS(1334),
    [sym_block_continuation] = ACTIONS(1338),
    [sym__block_quote_start] = ACTIONS(1334),
    [sym__indented_chunk_start] = ACTIONS(1334),
    [sym_atx_h1_marker] = ACTIONS(1334),
    [sym_atx_h2_marker] = ACTIONS(1334),
    [sym_atx_h3_marker] = ACTIONS(1334),
    [sym_atx_h4_marker] = ACTIONS(1334),
    [sym_atx_h5_marker] = ACTIONS(1334),
    [sym_atx_h6_marker] = ACTIONS(1334),
    [sym__thematic_break] = ACTIONS(1334),
    [sym__list_marker_minus] = ACTIONS(1334),
    [sym__list_marker_plus] = ACTIONS(1334),
    [sym__list_marker_star] = ACTIONS(1334),
    [sym__list_marker_parenthesis] = ACTIONS(1334),
    [sym__list_marker_dot] = ACTIONS(1334),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1334),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1334),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1334),
    [sym__blank_line_start] = ACTIONS(1334),
    [sym__html_block_1_start] = ACTIONS(1334),
    [sym__html_block_2_start] = ACTIONS(1334),
    [sym__html_block_3_start] = ACTIONS(1334),
    [sym__html_block_4_start] = ACTIONS(1334),
    [sym__html_block_5_start] = ACTIONS(1334),
    [sym__html_block_6_start] = ACTIONS(1334),
    [sym__html_block_7_start] = ACTIONS(1334),
    [sym__pipe_table_start] = ACTIONS(1334),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1165),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1165),
    [anon_sym_BSLASH] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym__] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [aux_sym__word_token1] = ACTIONS(1165),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1165),
    [aux_sym__word_token2] = ACTIONS(1165),
    [sym__whitespace] = ACTIONS(1165),
    [sym__soft_line_ending] = ACTIONS(1165),
    [sym_block_continuation] = ACTIONS(1340),
    [sym__block_quote_start] = ACTIONS(1165),
    [sym__indented_chunk_start] = ACTIONS(1165),
    [sym_atx_h1_marker] = ACTIONS(1165),
    [sym_atx_h2_marker] = ACTIONS(1165),
    [sym_atx_h3_marker] = ACTIONS(1165),
    [sym_atx_h4_marker] = ACTIONS(1165),
    [sym_atx_h5_marker] = ACTIONS(1165),
    [sym_atx_h6_marker] = ACTIONS(1165),
    [sym__thematic_break] = ACTIONS(1165),
    [sym__list_marker_minus] = ACTIONS(1165),
    [sym__list_marker_plus] = ACTIONS(1165),
    [sym__list_marker_star] = ACTIONS(1165),
    [sym__list_marker_parenthesis] = ACTIONS(1165),
    [sym__list_marker_dot] = ACTIONS(1165),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1165),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1165),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1165),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1165),
    [sym__blank_line_start] = ACTIONS(1165),
    [sym__html_block_1_start] = ACTIONS(1165),
    [sym__html_block_2_start] = ACTIONS(1165),
    [sym__html_block_3_start] = ACTIONS(1165),
    [sym__html_block_4_start] = ACTIONS(1165),
    [sym__html_block_5_start] = ACTIONS(1165),
    [sym__html_block_6_start] = ACTIONS(1165),
    [sym__html_block_7_start] = ACTIONS(1165),
    [sym__pipe_table_start] = ACTIONS(1165),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1342),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_RBRACK] = ACTIONS(1342),
    [anon_sym_LT] = ACTIONS(1342),
    [anon_sym_GT] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_DQUOTE] = ACTIONS(1342),
    [anon_sym_POUND] = ACTIONS(1342),
    [anon_sym_DOLLAR] = ACTIONS(1342),
    [anon_sym_PERCENT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_DOT] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1342),
    [anon_sym_COLON] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1342),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_QMARK] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [anon_sym_BSLASH] = ACTIONS(1342),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_BQUOTE] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_PIPE] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_RPAREN] = ACTIONS(1342),
    [aux_sym__word_token1] = ACTIONS(1342),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1342),
    [aux_sym__word_token2] = ACTIONS(1342),
    [sym__whitespace] = ACTIONS(1342),
    [sym__soft_line_ending] = ACTIONS(1342),
    [sym_block_continuation] = ACTIONS(1346),
    [sym__block_quote_start] = ACTIONS(1342),
    [sym__indented_chunk_start] = ACTIONS(1342),
    [sym_atx_h1_marker] = ACTIONS(1342),
    [sym_atx_h2_marker] = ACTIONS(1342),
    [sym_atx_h3_marker] = ACTIONS(1342),
    [sym_atx_h4_marker] = ACTIONS(1342),
    [sym_atx_h5_marker] = ACTIONS(1342),
    [sym_atx_h6_marker] = ACTIONS(1342),
    [sym__thematic_break] = ACTIONS(1342),
    [sym__list_marker_minus] = ACTIONS(1342),
    [sym__list_marker_plus] = ACTIONS(1342),
    [sym__list_marker_star] = ACTIONS(1342),
    [sym__list_marker_parenthesis] = ACTIONS(1342),
    [sym__list_marker_dot] = ACTIONS(1342),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1342),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1342),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1342),
    [sym__blank_line_start] = ACTIONS(1342),
    [sym__html_block_1_start] = ACTIONS(1342),
    [sym__html_block_2_start] = ACTIONS(1342),
    [sym__html_block_3_start] = ACTIONS(1342),
    [sym__html_block_4_start] = ACTIONS(1342),
    [sym__html_block_5_start] = ACTIONS(1342),
    [sym__html_block_6_start] = ACTIONS(1342),
    [sym__html_block_7_start] = ACTIONS(1342),
    [sym__pipe_table_start] = ACTIONS(1342),
  },
  [131] = {
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_POUND] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [aux_sym__word_token1] = ACTIONS(1350),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1350),
    [aux_sym__word_token2] = ACTIONS(1350),
    [sym__whitespace] = ACTIONS(1350),
    [sym__soft_line_ending] = ACTIONS(1350),
    [sym__block_close] = ACTIONS(1350),
    [sym__block_quote_start] = ACTIONS(1350),
    [sym__indented_chunk_start] = ACTIONS(1350),
    [sym_atx_h1_marker] = ACTIONS(1350),
    [sym_atx_h2_marker] = ACTIONS(1350),
    [sym_atx_h3_marker] = ACTIONS(1350),
    [sym_atx_h4_marker] = ACTIONS(1350),
    [sym_atx_h5_marker] = ACTIONS(1350),
    [sym_atx_h6_marker] = ACTIONS(1350),
    [sym__thematic_break] = ACTIONS(1350),
    [sym__list_marker_minus] = ACTIONS(1350),
    [sym__list_marker_plus] = ACTIONS(1350),
    [sym__list_marker_star] = ACTIONS(1350),
    [sym__list_marker_parenthesis] = ACTIONS(1350),
    [sym__list_marker_dot] = ACTIONS(1350),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1350),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1350),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1350),
    [sym__blank_line_start] = ACTIONS(1350),
    [sym__html_block_1_start] = ACTIONS(1350),
    [sym__html_block_2_start] = ACTIONS(1350),
    [sym__html_block_3_start] = ACTIONS(1350),
    [sym__html_block_4_start] = ACTIONS(1350),
    [sym__html_block_5_start] = ACTIONS(1350),
    [sym__html_block_6_start] = ACTIONS(1350),
    [sym__html_block_7_start] = ACTIONS(1350),
    [sym__no_indented_chunk] = ACTIONS(1350),
    [sym__pipe_table_start] = ACTIONS(1350),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [anon_sym_POUND] = ACTIONS(1352),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_COLON] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_QMARK] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1352),
    [anon_sym_BSLASH] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym__] = ACTIONS(1352),
    [anon_sym_BQUOTE] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_RPAREN] = ACTIONS(1352),
    [aux_sym__word_token1] = ACTIONS(1352),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1352),
    [aux_sym__word_token2] = ACTIONS(1352),
    [sym__whitespace] = ACTIONS(1352),
    [sym__soft_line_ending] = ACTIONS(1352),
    [sym_block_continuation] = ACTIONS(1356),
    [sym__block_quote_start] = ACTIONS(1352),
    [sym__indented_chunk_start] = ACTIONS(1352),
    [sym_atx_h1_marker] = ACTIONS(1352),
    [sym_atx_h2_marker] = ACTIONS(1352),
    [sym_atx_h3_marker] = ACTIONS(1352),
    [sym_atx_h4_marker] = ACTIONS(1352),
    [sym_atx_h5_marker] = ACTIONS(1352),
    [sym_atx_h6_marker] = ACTIONS(1352),
    [sym__thematic_break] = ACTIONS(1352),
    [sym__list_marker_minus] = ACTIONS(1352),
    [sym__list_marker_plus] = ACTIONS(1352),
    [sym__list_marker_star] = ACTIONS(1352),
    [sym__list_marker_parenthesis] = ACTIONS(1352),
    [sym__list_marker_dot] = ACTIONS(1352),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1352),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1352),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1352),
    [sym__blank_line_start] = ACTIONS(1352),
    [sym__html_block_1_start] = ACTIONS(1352),
    [sym__html_block_2_start] = ACTIONS(1352),
    [sym__html_block_3_start] = ACTIONS(1352),
    [sym__html_block_4_start] = ACTIONS(1352),
    [sym__html_block_5_start] = ACTIONS(1352),
    [sym__html_block_6_start] = ACTIONS(1352),
    [sym__html_block_7_start] = ACTIONS(1352),
    [sym__pipe_table_start] = ACTIONS(1352),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_DOLLAR] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_DOT] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1358),
    [anon_sym_BSLASH] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym__] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1358),
    [aux_sym__word_token1] = ACTIONS(1358),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1358),
    [aux_sym__word_token2] = ACTIONS(1358),
    [sym__whitespace] = ACTIONS(1358),
    [sym__soft_line_ending] = ACTIONS(1358),
    [sym_block_continuation] = ACTIONS(1362),
    [sym__block_quote_start] = ACTIONS(1358),
    [sym__indented_chunk_start] = ACTIONS(1358),
    [sym_atx_h1_marker] = ACTIONS(1358),
    [sym_atx_h2_marker] = ACTIONS(1358),
    [sym_atx_h3_marker] = ACTIONS(1358),
    [sym_atx_h4_marker] = ACTIONS(1358),
    [sym_atx_h5_marker] = ACTIONS(1358),
    [sym_atx_h6_marker] = ACTIONS(1358),
    [sym__thematic_break] = ACTIONS(1358),
    [sym__list_marker_minus] = ACTIONS(1358),
    [sym__list_marker_plus] = ACTIONS(1358),
    [sym__list_marker_star] = ACTIONS(1358),
    [sym__list_marker_parenthesis] = ACTIONS(1358),
    [sym__list_marker_dot] = ACTIONS(1358),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1358),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1358),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1358),
    [sym__blank_line_start] = ACTIONS(1358),
    [sym__html_block_1_start] = ACTIONS(1358),
    [sym__html_block_2_start] = ACTIONS(1358),
    [sym__html_block_3_start] = ACTIONS(1358),
    [sym__html_block_4_start] = ACTIONS(1358),
    [sym__html_block_5_start] = ACTIONS(1358),
    [sym__html_block_6_start] = ACTIONS(1358),
    [sym__html_block_7_start] = ACTIONS(1358),
    [sym__pipe_table_start] = ACTIONS(1358),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [anon_sym_POUND] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [aux_sym__word_token1] = ACTIONS(1364),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1364),
    [aux_sym__word_token2] = ACTIONS(1364),
    [sym__whitespace] = ACTIONS(1364),
    [sym__soft_line_ending] = ACTIONS(1364),
    [sym_block_continuation] = ACTIONS(1368),
    [sym__block_quote_start] = ACTIONS(1364),
    [sym__indented_chunk_start] = ACTIONS(1364),
    [sym_atx_h1_marker] = ACTIONS(1364),
    [sym_atx_h2_marker] = ACTIONS(1364),
    [sym_atx_h3_marker] = ACTIONS(1364),
    [sym_atx_h4_marker] = ACTIONS(1364),
    [sym_atx_h5_marker] = ACTIONS(1364),
    [sym_atx_h6_marker] = ACTIONS(1364),
    [sym__thematic_break] = ACTIONS(1364),
    [sym__list_marker_minus] = ACTIONS(1364),
    [sym__list_marker_plus] = ACTIONS(1364),
    [sym__list_marker_star] = ACTIONS(1364),
    [sym__list_marker_parenthesis] = ACTIONS(1364),
    [sym__list_marker_dot] = ACTIONS(1364),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1364),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1364),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1364),
    [sym__blank_line_start] = ACTIONS(1364),
    [sym__html_block_1_start] = ACTIONS(1364),
    [sym__html_block_2_start] = ACTIONS(1364),
    [sym__html_block_3_start] = ACTIONS(1364),
    [sym__html_block_4_start] = ACTIONS(1364),
    [sym__html_block_5_start] = ACTIONS(1364),
    [sym__html_block_6_start] = ACTIONS(1364),
    [sym__html_block_7_start] = ACTIONS(1364),
    [sym__pipe_table_start] = ACTIONS(1364),
  },
  [135] = {
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_POUND] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [aux_sym__word_token1] = ACTIONS(1372),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1372),
    [aux_sym__word_token2] = ACTIONS(1372),
    [sym__whitespace] = ACTIONS(1372),
    [sym__soft_line_ending] = ACTIONS(1372),
    [sym__block_close] = ACTIONS(1372),
    [sym_block_continuation] = ACTIONS(1374),
    [sym__block_quote_start] = ACTIONS(1372),
    [sym__indented_chunk_start] = ACTIONS(1372),
    [sym_atx_h1_marker] = ACTIONS(1372),
    [sym_atx_h2_marker] = ACTIONS(1372),
    [sym_atx_h3_marker] = ACTIONS(1372),
    [sym_atx_h4_marker] = ACTIONS(1372),
    [sym_atx_h5_marker] = ACTIONS(1372),
    [sym_atx_h6_marker] = ACTIONS(1372),
    [sym__thematic_break] = ACTIONS(1372),
    [sym__list_marker_minus] = ACTIONS(1372),
    [sym__list_marker_plus] = ACTIONS(1372),
    [sym__list_marker_star] = ACTIONS(1372),
    [sym__list_marker_parenthesis] = ACTIONS(1372),
    [sym__list_marker_dot] = ACTIONS(1372),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1372),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1372),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1372),
    [sym__blank_line_start] = ACTIONS(1372),
    [sym__html_block_1_start] = ACTIONS(1372),
    [sym__html_block_2_start] = ACTIONS(1372),
    [sym__html_block_3_start] = ACTIONS(1372),
    [sym__html_block_4_start] = ACTIONS(1372),
    [sym__html_block_5_start] = ACTIONS(1372),
    [sym__html_block_6_start] = ACTIONS(1372),
    [sym__html_block_7_start] = ACTIONS(1372),
    [sym__pipe_table_start] = ACTIONS(1372),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_RBRACK] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [anon_sym_POUND] = ACTIONS(1376),
    [anon_sym_DOLLAR] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_COLON] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_BSLASH] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym__] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [aux_sym__word_token1] = ACTIONS(1376),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1376),
    [aux_sym__word_token2] = ACTIONS(1376),
    [sym__whitespace] = ACTIONS(1376),
    [sym__soft_line_ending] = ACTIONS(1376),
    [sym_block_continuation] = ACTIONS(1380),
    [sym__block_quote_start] = ACTIONS(1376),
    [sym__indented_chunk_start] = ACTIONS(1376),
    [sym_atx_h1_marker] = ACTIONS(1376),
    [sym_atx_h2_marker] = ACTIONS(1376),
    [sym_atx_h3_marker] = ACTIONS(1376),
    [sym_atx_h4_marker] = ACTIONS(1376),
    [sym_atx_h5_marker] = ACTIONS(1376),
    [sym_atx_h6_marker] = ACTIONS(1376),
    [sym__thematic_break] = ACTIONS(1376),
    [sym__list_marker_minus] = ACTIONS(1376),
    [sym__list_marker_plus] = ACTIONS(1376),
    [sym__list_marker_star] = ACTIONS(1376),
    [sym__list_marker_parenthesis] = ACTIONS(1376),
    [sym__list_marker_dot] = ACTIONS(1376),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1376),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1376),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1376),
    [sym__blank_line_start] = ACTIONS(1376),
    [sym__html_block_1_start] = ACTIONS(1376),
    [sym__html_block_2_start] = ACTIONS(1376),
    [sym__html_block_3_start] = ACTIONS(1376),
    [sym__html_block_4_start] = ACTIONS(1376),
    [sym__html_block_5_start] = ACTIONS(1376),
    [sym__html_block_6_start] = ACTIONS(1376),
    [sym__html_block_7_start] = ACTIONS(1376),
    [sym__pipe_table_start] = ACTIONS(1376),
  },
  [137] = {
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym__] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [aux_sym__word_token1] = ACTIONS(1384),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1384),
    [aux_sym__word_token2] = ACTIONS(1384),
    [sym__whitespace] = ACTIONS(1384),
    [sym__soft_line_ending] = ACTIONS(1384),
    [sym__block_close] = ACTIONS(1384),
    [sym_block_continuation] = ACTIONS(1386),
    [sym__block_quote_start] = ACTIONS(1384),
    [sym__indented_chunk_start] = ACTIONS(1384),
    [sym_atx_h1_marker] = ACTIONS(1384),
    [sym_atx_h2_marker] = ACTIONS(1384),
    [sym_atx_h3_marker] = ACTIONS(1384),
    [sym_atx_h4_marker] = ACTIONS(1384),
    [sym_atx_h5_marker] = ACTIONS(1384),
    [sym_atx_h6_marker] = ACTIONS(1384),
    [sym__thematic_break] = ACTIONS(1384),
    [sym__list_marker_minus] = ACTIONS(1384),
    [sym__list_marker_plus] = ACTIONS(1384),
    [sym__list_marker_star] = ACTIONS(1384),
    [sym__list_marker_parenthesis] = ACTIONS(1384),
    [sym__list_marker_dot] = ACTIONS(1384),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1384),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1384),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1384),
    [sym__blank_line_start] = ACTIONS(1384),
    [sym__html_block_1_start] = ACTIONS(1384),
    [sym__html_block_2_start] = ACTIONS(1384),
    [sym__html_block_3_start] = ACTIONS(1384),
    [sym__html_block_4_start] = ACTIONS(1384),
    [sym__html_block_5_start] = ACTIONS(1384),
    [sym__html_block_6_start] = ACTIONS(1384),
    [sym__html_block_7_start] = ACTIONS(1384),
    [sym__pipe_table_start] = ACTIONS(1384),
  },
  [138] = {
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym__] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [aux_sym__word_token1] = ACTIONS(1390),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1390),
    [aux_sym__word_token2] = ACTIONS(1390),
    [sym__whitespace] = ACTIONS(1390),
    [sym__soft_line_ending] = ACTIONS(1390),
    [sym__block_close] = ACTIONS(1390),
    [sym_block_continuation] = ACTIONS(1392),
    [sym__block_quote_start] = ACTIONS(1390),
    [sym__indented_chunk_start] = ACTIONS(1390),
    [sym_atx_h1_marker] = ACTIONS(1390),
    [sym_atx_h2_marker] = ACTIONS(1390),
    [sym_atx_h3_marker] = ACTIONS(1390),
    [sym_atx_h4_marker] = ACTIONS(1390),
    [sym_atx_h5_marker] = ACTIONS(1390),
    [sym_atx_h6_marker] = ACTIONS(1390),
    [sym__thematic_break] = ACTIONS(1390),
    [sym__list_marker_minus] = ACTIONS(1390),
    [sym__list_marker_plus] = ACTIONS(1390),
    [sym__list_marker_star] = ACTIONS(1390),
    [sym__list_marker_parenthesis] = ACTIONS(1390),
    [sym__list_marker_dot] = ACTIONS(1390),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1390),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1390),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1390),
    [sym__blank_line_start] = ACTIONS(1390),
    [sym__html_block_1_start] = ACTIONS(1390),
    [sym__html_block_2_start] = ACTIONS(1390),
    [sym__html_block_3_start] = ACTIONS(1390),
    [sym__html_block_4_start] = ACTIONS(1390),
    [sym__html_block_5_start] = ACTIONS(1390),
    [sym__html_block_6_start] = ACTIONS(1390),
    [sym__html_block_7_start] = ACTIONS(1390),
    [sym__pipe_table_start] = ACTIONS(1390),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_POUND] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [aux_sym__word_token1] = ACTIONS(1350),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1350),
    [aux_sym__word_token2] = ACTIONS(1350),
    [sym__whitespace] = ACTIONS(1350),
    [sym__soft_line_ending] = ACTIONS(1350),
    [sym__block_quote_start] = ACTIONS(1350),
    [sym__indented_chunk_start] = ACTIONS(1350),
    [sym_atx_h1_marker] = ACTIONS(1350),
    [sym_atx_h2_marker] = ACTIONS(1350),
    [sym_atx_h3_marker] = ACTIONS(1350),
    [sym_atx_h4_marker] = ACTIONS(1350),
    [sym_atx_h5_marker] = ACTIONS(1350),
    [sym_atx_h6_marker] = ACTIONS(1350),
    [sym__thematic_break] = ACTIONS(1350),
    [sym__list_marker_minus] = ACTIONS(1350),
    [sym__list_marker_plus] = ACTIONS(1350),
    [sym__list_marker_star] = ACTIONS(1350),
    [sym__list_marker_parenthesis] = ACTIONS(1350),
    [sym__list_marker_dot] = ACTIONS(1350),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1350),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1350),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1350),
    [sym__blank_line_start] = ACTIONS(1350),
    [sym__html_block_1_start] = ACTIONS(1350),
    [sym__html_block_2_start] = ACTIONS(1350),
    [sym__html_block_3_start] = ACTIONS(1350),
    [sym__html_block_4_start] = ACTIONS(1350),
    [sym__html_block_5_start] = ACTIONS(1350),
    [sym__html_block_6_start] = ACTIONS(1350),
    [sym__html_block_7_start] = ACTIONS(1350),
    [sym__no_indented_chunk] = ACTIONS(1350),
    [sym__pipe_table_start] = ACTIONS(1350),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_RBRACK] = ACTIONS(1394),
    [anon_sym_LT] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_DOLLAR] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_AMP] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_COLON] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [anon_sym_BSLASH] = ACTIONS(1394),
    [anon_sym_CARET] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1394),
    [anon_sym_BQUOTE] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_RPAREN] = ACTIONS(1394),
    [aux_sym__word_token1] = ACTIONS(1394),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1394),
    [aux_sym__word_token2] = ACTIONS(1394),
    [sym__whitespace] = ACTIONS(1394),
    [sym__soft_line_ending] = ACTIONS(1394),
    [sym_block_continuation] = ACTIONS(1398),
    [sym__block_quote_start] = ACTIONS(1394),
    [sym__indented_chunk_start] = ACTIONS(1394),
    [sym_atx_h1_marker] = ACTIONS(1394),
    [sym_atx_h2_marker] = ACTIONS(1394),
    [sym_atx_h3_marker] = ACTIONS(1394),
    [sym_atx_h4_marker] = ACTIONS(1394),
    [sym_atx_h5_marker] = ACTIONS(1394),
    [sym_atx_h6_marker] = ACTIONS(1394),
    [sym__thematic_break] = ACTIONS(1394),
    [sym__list_marker_minus] = ACTIONS(1394),
    [sym__list_marker_plus] = ACTIONS(1394),
    [sym__list_marker_star] = ACTIONS(1394),
    [sym__list_marker_parenthesis] = ACTIONS(1394),
    [sym__list_marker_dot] = ACTIONS(1394),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1394),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1394),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1394),
    [sym__blank_line_start] = ACTIONS(1394),
    [sym__html_block_1_start] = ACTIONS(1394),
    [sym__html_block_2_start] = ACTIONS(1394),
    [sym__html_block_3_start] = ACTIONS(1394),
    [sym__html_block_4_start] = ACTIONS(1394),
    [sym__html_block_5_start] = ACTIONS(1394),
    [sym__html_block_6_start] = ACTIONS(1394),
    [sym__html_block_7_start] = ACTIONS(1394),
    [sym__pipe_table_start] = ACTIONS(1394),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_RBRACK] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [anon_sym_POUND] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_COLON] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_BSLASH] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym__] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [aux_sym__word_token1] = ACTIONS(1400),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1400),
    [aux_sym__word_token2] = ACTIONS(1400),
    [sym__whitespace] = ACTIONS(1400),
    [sym__soft_line_ending] = ACTIONS(1400),
    [sym_block_continuation] = ACTIONS(1404),
    [sym__block_quote_start] = ACTIONS(1400),
    [sym__indented_chunk_start] = ACTIONS(1400),
    [sym_atx_h1_marker] = ACTIONS(1400),
    [sym_atx_h2_marker] = ACTIONS(1400),
    [sym_atx_h3_marker] = ACTIONS(1400),
    [sym_atx_h4_marker] = ACTIONS(1400),
    [sym_atx_h5_marker] = ACTIONS(1400),
    [sym_atx_h6_marker] = ACTIONS(1400),
    [sym__thematic_break] = ACTIONS(1400),
    [sym__list_marker_minus] = ACTIONS(1400),
    [sym__list_marker_plus] = ACTIONS(1400),
    [sym__list_marker_star] = ACTIONS(1400),
    [sym__list_marker_parenthesis] = ACTIONS(1400),
    [sym__list_marker_dot] = ACTIONS(1400),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1400),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1400),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1400),
    [sym__blank_line_start] = ACTIONS(1400),
    [sym__html_block_1_start] = ACTIONS(1400),
    [sym__html_block_2_start] = ACTIONS(1400),
    [sym__html_block_3_start] = ACTIONS(1400),
    [sym__html_block_4_start] = ACTIONS(1400),
    [sym__html_block_5_start] = ACTIONS(1400),
    [sym__html_block_6_start] = ACTIONS(1400),
    [sym__html_block_7_start] = ACTIONS(1400),
    [sym__pipe_table_start] = ACTIONS(1400),
  },
  [142] = {
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_POUND] = ACTIONS(1408),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_COLON] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1408),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(1408),
    [aux_sym__word_token1] = ACTIONS(1408),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1408),
    [aux_sym__word_token2] = ACTIONS(1408),
    [sym__whitespace] = ACTIONS(1408),
    [sym__soft_line_ending] = ACTIONS(1408),
    [sym__block_close] = ACTIONS(1408),
    [sym_block_continuation] = ACTIONS(1410),
    [sym__block_quote_start] = ACTIONS(1408),
    [sym__indented_chunk_start] = ACTIONS(1408),
    [sym_atx_h1_marker] = ACTIONS(1408),
    [sym_atx_h2_marker] = ACTIONS(1408),
    [sym_atx_h3_marker] = ACTIONS(1408),
    [sym_atx_h4_marker] = ACTIONS(1408),
    [sym_atx_h5_marker] = ACTIONS(1408),
    [sym_atx_h6_marker] = ACTIONS(1408),
    [sym__thematic_break] = ACTIONS(1408),
    [sym__list_marker_minus] = ACTIONS(1408),
    [sym__list_marker_plus] = ACTIONS(1408),
    [sym__list_marker_star] = ACTIONS(1408),
    [sym__list_marker_parenthesis] = ACTIONS(1408),
    [sym__list_marker_dot] = ACTIONS(1408),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1408),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1408),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1408),
    [sym__blank_line_start] = ACTIONS(1408),
    [sym__html_block_1_start] = ACTIONS(1408),
    [sym__html_block_2_start] = ACTIONS(1408),
    [sym__html_block_3_start] = ACTIONS(1408),
    [sym__html_block_4_start] = ACTIONS(1408),
    [sym__html_block_5_start] = ACTIONS(1408),
    [sym__html_block_6_start] = ACTIONS(1408),
    [sym__html_block_7_start] = ACTIONS(1408),
    [sym__pipe_table_start] = ACTIONS(1408),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_RBRACK] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [anon_sym_POUND] = ACTIONS(1412),
    [anon_sym_DOLLAR] = ACTIONS(1412),
    [anon_sym_PERCENT] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_COLON] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym_EQ] = ACTIONS(1412),
    [anon_sym_QMARK] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1412),
    [anon_sym__] = ACTIONS(1412),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [anon_sym_RPAREN] = ACTIONS(1412),
    [aux_sym__word_token1] = ACTIONS(1412),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1412),
    [aux_sym__word_token2] = ACTIONS(1412),
    [sym__whitespace] = ACTIONS(1412),
    [sym__soft_line_ending] = ACTIONS(1412),
    [sym_block_continuation] = ACTIONS(1416),
    [sym__block_quote_start] = ACTIONS(1412),
    [sym__indented_chunk_start] = ACTIONS(1412),
    [sym_atx_h1_marker] = ACTIONS(1412),
    [sym_atx_h2_marker] = ACTIONS(1412),
    [sym_atx_h3_marker] = ACTIONS(1412),
    [sym_atx_h4_marker] = ACTIONS(1412),
    [sym_atx_h5_marker] = ACTIONS(1412),
    [sym_atx_h6_marker] = ACTIONS(1412),
    [sym__thematic_break] = ACTIONS(1412),
    [sym__list_marker_minus] = ACTIONS(1412),
    [sym__list_marker_plus] = ACTIONS(1412),
    [sym__list_marker_star] = ACTIONS(1412),
    [sym__list_marker_parenthesis] = ACTIONS(1412),
    [sym__list_marker_dot] = ACTIONS(1412),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1412),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1412),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1412),
    [sym__blank_line_start] = ACTIONS(1412),
    [sym__html_block_1_start] = ACTIONS(1412),
    [sym__html_block_2_start] = ACTIONS(1412),
    [sym__html_block_3_start] = ACTIONS(1412),
    [sym__html_block_4_start] = ACTIONS(1412),
    [sym__html_block_5_start] = ACTIONS(1412),
    [sym__html_block_6_start] = ACTIONS(1412),
    [sym__html_block_7_start] = ACTIONS(1412),
    [sym__pipe_table_start] = ACTIONS(1412),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [aux_sym__word_token1] = ACTIONS(1418),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1418),
    [aux_sym__word_token2] = ACTIONS(1418),
    [sym__whitespace] = ACTIONS(1418),
    [sym__soft_line_ending] = ACTIONS(1418),
    [sym_block_continuation] = ACTIONS(1422),
    [sym__block_quote_start] = ACTIONS(1418),
    [sym__indented_chunk_start] = ACTIONS(1418),
    [sym_atx_h1_marker] = ACTIONS(1418),
    [sym_atx_h2_marker] = ACTIONS(1418),
    [sym_atx_h3_marker] = ACTIONS(1418),
    [sym_atx_h4_marker] = ACTIONS(1418),
    [sym_atx_h5_marker] = ACTIONS(1418),
    [sym_atx_h6_marker] = ACTIONS(1418),
    [sym__thematic_break] = ACTIONS(1418),
    [sym__list_marker_minus] = ACTIONS(1418),
    [sym__list_marker_plus] = ACTIONS(1418),
    [sym__list_marker_star] = ACTIONS(1418),
    [sym__list_marker_parenthesis] = ACTIONS(1418),
    [sym__list_marker_dot] = ACTIONS(1418),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1418),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1418),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1418),
    [sym__blank_line_start] = ACTIONS(1418),
    [sym__html_block_1_start] = ACTIONS(1418),
    [sym__html_block_2_start] = ACTIONS(1418),
    [sym__html_block_3_start] = ACTIONS(1418),
    [sym__html_block_4_start] = ACTIONS(1418),
    [sym__html_block_5_start] = ACTIONS(1418),
    [sym__html_block_6_start] = ACTIONS(1418),
    [sym__html_block_7_start] = ACTIONS(1418),
    [sym__pipe_table_start] = ACTIONS(1418),
  },
  [145] = {
    [sym__blank_line] = STATE(879),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_POUND] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_SQUOTE] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1257),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AT] = ACTIONS(1257),
    [anon_sym_BSLASH] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym__] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [aux_sym__word_token1] = ACTIONS(1257),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1257),
    [aux_sym__word_token2] = ACTIONS(1257),
    [sym__whitespace] = ACTIONS(1257),
    [sym__soft_line_ending] = ACTIONS(1257),
    [sym__block_close] = ACTIONS(1257),
    [sym__block_quote_start] = ACTIONS(1257),
    [sym__indented_chunk_start] = ACTIONS(1257),
    [sym_atx_h1_marker] = ACTIONS(1257),
    [sym_atx_h2_marker] = ACTIONS(1257),
    [sym_atx_h3_marker] = ACTIONS(1257),
    [sym_atx_h4_marker] = ACTIONS(1257),
    [sym_atx_h5_marker] = ACTIONS(1257),
    [sym_atx_h6_marker] = ACTIONS(1257),
    [sym__thematic_break] = ACTIONS(1257),
    [sym__list_marker_minus] = ACTIONS(1257),
    [sym__list_marker_plus] = ACTIONS(1257),
    [sym__list_marker_star] = ACTIONS(1257),
    [sym__list_marker_parenthesis] = ACTIONS(1257),
    [sym__list_marker_dot] = ACTIONS(1257),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1257),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1257),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1257),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1257),
    [sym__blank_line_start] = ACTIONS(1424),
    [sym__html_block_1_start] = ACTIONS(1257),
    [sym__html_block_2_start] = ACTIONS(1257),
    [sym__html_block_3_start] = ACTIONS(1257),
    [sym__html_block_4_start] = ACTIONS(1257),
    [sym__html_block_5_start] = ACTIONS(1257),
    [sym__html_block_6_start] = ACTIONS(1257),
    [sym__html_block_7_start] = ACTIONS(1257),
    [sym__pipe_table_start] = ACTIONS(1257),
  },
  [146] = {
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [aux_sym__word_token1] = ACTIONS(1428),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1428),
    [aux_sym__word_token2] = ACTIONS(1428),
    [sym__whitespace] = ACTIONS(1428),
    [sym__soft_line_ending] = ACTIONS(1428),
    [sym__block_close] = ACTIONS(1428),
    [sym_block_continuation] = ACTIONS(1430),
    [sym__block_quote_start] = ACTIONS(1428),
    [sym__indented_chunk_start] = ACTIONS(1428),
    [sym_atx_h1_marker] = ACTIONS(1428),
    [sym_atx_h2_marker] = ACTIONS(1428),
    [sym_atx_h3_marker] = ACTIONS(1428),
    [sym_atx_h4_marker] = ACTIONS(1428),
    [sym_atx_h5_marker] = ACTIONS(1428),
    [sym_atx_h6_marker] = ACTIONS(1428),
    [sym__thematic_break] = ACTIONS(1428),
    [sym__list_marker_minus] = ACTIONS(1428),
    [sym__list_marker_plus] = ACTIONS(1428),
    [sym__list_marker_star] = ACTIONS(1428),
    [sym__list_marker_parenthesis] = ACTIONS(1428),
    [sym__list_marker_dot] = ACTIONS(1428),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1428),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1428),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1428),
    [sym__blank_line_start] = ACTIONS(1428),
    [sym__html_block_1_start] = ACTIONS(1428),
    [sym__html_block_2_start] = ACTIONS(1428),
    [sym__html_block_3_start] = ACTIONS(1428),
    [sym__html_block_4_start] = ACTIONS(1428),
    [sym__html_block_5_start] = ACTIONS(1428),
    [sym__html_block_6_start] = ACTIONS(1428),
    [sym__html_block_7_start] = ACTIONS(1428),
    [sym__pipe_table_start] = ACTIONS(1428),
  },
  [147] = {
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [aux_sym__word_token1] = ACTIONS(1434),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1434),
    [aux_sym__word_token2] = ACTIONS(1434),
    [sym__whitespace] = ACTIONS(1434),
    [sym__soft_line_ending] = ACTIONS(1434),
    [sym__block_close] = ACTIONS(1434),
    [sym_block_continuation] = ACTIONS(1436),
    [sym__block_quote_start] = ACTIONS(1434),
    [sym__indented_chunk_start] = ACTIONS(1434),
    [sym_atx_h1_marker] = ACTIONS(1434),
    [sym_atx_h2_marker] = ACTIONS(1434),
    [sym_atx_h3_marker] = ACTIONS(1434),
    [sym_atx_h4_marker] = ACTIONS(1434),
    [sym_atx_h5_marker] = ACTIONS(1434),
    [sym_atx_h6_marker] = ACTIONS(1434),
    [sym__thematic_break] = ACTIONS(1434),
    [sym__list_marker_minus] = ACTIONS(1434),
    [sym__list_marker_plus] = ACTIONS(1434),
    [sym__list_marker_star] = ACTIONS(1434),
    [sym__list_marker_parenthesis] = ACTIONS(1434),
    [sym__list_marker_dot] = ACTIONS(1434),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1434),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1434),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1434),
    [sym__blank_line_start] = ACTIONS(1434),
    [sym__html_block_1_start] = ACTIONS(1434),
    [sym__html_block_2_start] = ACTIONS(1434),
    [sym__html_block_3_start] = ACTIONS(1434),
    [sym__html_block_4_start] = ACTIONS(1434),
    [sym__html_block_5_start] = ACTIONS(1434),
    [sym__html_block_6_start] = ACTIONS(1434),
    [sym__html_block_7_start] = ACTIONS(1434),
    [sym__pipe_table_start] = ACTIONS(1434),
  },
  [148] = {
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [aux_sym__word_token1] = ACTIONS(1440),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1440),
    [aux_sym__word_token2] = ACTIONS(1440),
    [sym__whitespace] = ACTIONS(1440),
    [sym__soft_line_ending] = ACTIONS(1440),
    [sym__block_close] = ACTIONS(1440),
    [sym_block_continuation] = ACTIONS(1442),
    [sym__block_quote_start] = ACTIONS(1440),
    [sym__indented_chunk_start] = ACTIONS(1440),
    [sym_atx_h1_marker] = ACTIONS(1440),
    [sym_atx_h2_marker] = ACTIONS(1440),
    [sym_atx_h3_marker] = ACTIONS(1440),
    [sym_atx_h4_marker] = ACTIONS(1440),
    [sym_atx_h5_marker] = ACTIONS(1440),
    [sym_atx_h6_marker] = ACTIONS(1440),
    [sym__thematic_break] = ACTIONS(1440),
    [sym__list_marker_minus] = ACTIONS(1440),
    [sym__list_marker_plus] = ACTIONS(1440),
    [sym__list_marker_star] = ACTIONS(1440),
    [sym__list_marker_parenthesis] = ACTIONS(1440),
    [sym__list_marker_dot] = ACTIONS(1440),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1440),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1440),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1440),
    [sym__blank_line_start] = ACTIONS(1440),
    [sym__html_block_1_start] = ACTIONS(1440),
    [sym__html_block_2_start] = ACTIONS(1440),
    [sym__html_block_3_start] = ACTIONS(1440),
    [sym__html_block_4_start] = ACTIONS(1440),
    [sym__html_block_5_start] = ACTIONS(1440),
    [sym__html_block_6_start] = ACTIONS(1440),
    [sym__html_block_7_start] = ACTIONS(1440),
    [sym__pipe_table_start] = ACTIONS(1440),
  },
  [149] = {
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [aux_sym__word_token1] = ACTIONS(1418),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1418),
    [aux_sym__word_token2] = ACTIONS(1418),
    [sym__whitespace] = ACTIONS(1418),
    [sym__soft_line_ending] = ACTIONS(1418),
    [sym__block_close] = ACTIONS(1418),
    [sym_block_continuation] = ACTIONS(1444),
    [sym__block_quote_start] = ACTIONS(1418),
    [sym__indented_chunk_start] = ACTIONS(1418),
    [sym_atx_h1_marker] = ACTIONS(1418),
    [sym_atx_h2_marker] = ACTIONS(1418),
    [sym_atx_h3_marker] = ACTIONS(1418),
    [sym_atx_h4_marker] = ACTIONS(1418),
    [sym_atx_h5_marker] = ACTIONS(1418),
    [sym_atx_h6_marker] = ACTIONS(1418),
    [sym__thematic_break] = ACTIONS(1418),
    [sym__list_marker_minus] = ACTIONS(1418),
    [sym__list_marker_plus] = ACTIONS(1418),
    [sym__list_marker_star] = ACTIONS(1418),
    [sym__list_marker_parenthesis] = ACTIONS(1418),
    [sym__list_marker_dot] = ACTIONS(1418),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1418),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1418),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1418),
    [sym__blank_line_start] = ACTIONS(1418),
    [sym__html_block_1_start] = ACTIONS(1418),
    [sym__html_block_2_start] = ACTIONS(1418),
    [sym__html_block_3_start] = ACTIONS(1418),
    [sym__html_block_4_start] = ACTIONS(1418),
    [sym__html_block_5_start] = ACTIONS(1418),
    [sym__html_block_6_start] = ACTIONS(1418),
    [sym__html_block_7_start] = ACTIONS(1418),
    [sym__pipe_table_start] = ACTIONS(1418),
  },
  [150] = {
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [aux_sym__word_token1] = ACTIONS(1448),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1448),
    [aux_sym__word_token2] = ACTIONS(1448),
    [sym__whitespace] = ACTIONS(1448),
    [sym__soft_line_ending] = ACTIONS(1448),
    [sym__block_close] = ACTIONS(1448),
    [sym_block_continuation] = ACTIONS(1450),
    [sym__block_quote_start] = ACTIONS(1448),
    [sym__indented_chunk_start] = ACTIONS(1448),
    [sym_atx_h1_marker] = ACTIONS(1448),
    [sym_atx_h2_marker] = ACTIONS(1448),
    [sym_atx_h3_marker] = ACTIONS(1448),
    [sym_atx_h4_marker] = ACTIONS(1448),
    [sym_atx_h5_marker] = ACTIONS(1448),
    [sym_atx_h6_marker] = ACTIONS(1448),
    [sym__thematic_break] = ACTIONS(1448),
    [sym__list_marker_minus] = ACTIONS(1448),
    [sym__list_marker_plus] = ACTIONS(1448),
    [sym__list_marker_star] = ACTIONS(1448),
    [sym__list_marker_parenthesis] = ACTIONS(1448),
    [sym__list_marker_dot] = ACTIONS(1448),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1448),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1448),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1448),
    [sym__blank_line_start] = ACTIONS(1448),
    [sym__html_block_1_start] = ACTIONS(1448),
    [sym__html_block_2_start] = ACTIONS(1448),
    [sym__html_block_3_start] = ACTIONS(1448),
    [sym__html_block_4_start] = ACTIONS(1448),
    [sym__html_block_5_start] = ACTIONS(1448),
    [sym__html_block_6_start] = ACTIONS(1448),
    [sym__html_block_7_start] = ACTIONS(1448),
    [sym__pipe_table_start] = ACTIONS(1448),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_RBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1452),
    [anon_sym_DOLLAR] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_RPAREN] = ACTIONS(1452),
    [aux_sym__word_token1] = ACTIONS(1452),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1452),
    [aux_sym__word_token2] = ACTIONS(1452),
    [sym__whitespace] = ACTIONS(1452),
    [sym__soft_line_ending] = ACTIONS(1452),
    [sym_block_continuation] = ACTIONS(1456),
    [sym__block_quote_start] = ACTIONS(1452),
    [sym__indented_chunk_start] = ACTIONS(1452),
    [sym_atx_h1_marker] = ACTIONS(1452),
    [sym_atx_h2_marker] = ACTIONS(1452),
    [sym_atx_h3_marker] = ACTIONS(1452),
    [sym_atx_h4_marker] = ACTIONS(1452),
    [sym_atx_h5_marker] = ACTIONS(1452),
    [sym_atx_h6_marker] = ACTIONS(1452),
    [sym__thematic_break] = ACTIONS(1452),
    [sym__list_marker_minus] = ACTIONS(1452),
    [sym__list_marker_plus] = ACTIONS(1452),
    [sym__list_marker_star] = ACTIONS(1452),
    [sym__list_marker_parenthesis] = ACTIONS(1452),
    [sym__list_marker_dot] = ACTIONS(1452),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1452),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1452),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1452),
    [sym__blank_line_start] = ACTIONS(1452),
    [sym__html_block_1_start] = ACTIONS(1452),
    [sym__html_block_2_start] = ACTIONS(1452),
    [sym__html_block_3_start] = ACTIONS(1452),
    [sym__html_block_4_start] = ACTIONS(1452),
    [sym__html_block_5_start] = ACTIONS(1452),
    [sym__html_block_6_start] = ACTIONS(1452),
    [sym__html_block_7_start] = ACTIONS(1452),
    [sym__pipe_table_start] = ACTIONS(1452),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_RBRACK] = ACTIONS(1458),
    [anon_sym_LT] = ACTIONS(1458),
    [anon_sym_GT] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_DQUOTE] = ACTIONS(1458),
    [anon_sym_POUND] = ACTIONS(1458),
    [anon_sym_DOLLAR] = ACTIONS(1458),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1458),
    [anon_sym_SQUOTE] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_COMMA] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_DOT] = ACTIONS(1458),
    [anon_sym_SLASH] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1458),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_QMARK] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_BSLASH] = ACTIONS(1458),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym__] = ACTIONS(1458),
    [anon_sym_BQUOTE] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_PIPE] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [aux_sym__word_token1] = ACTIONS(1458),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1458),
    [aux_sym__word_token2] = ACTIONS(1458),
    [sym__whitespace] = ACTIONS(1458),
    [sym__soft_line_ending] = ACTIONS(1458),
    [sym_block_continuation] = ACTIONS(1462),
    [sym__block_quote_start] = ACTIONS(1458),
    [sym__indented_chunk_start] = ACTIONS(1458),
    [sym_atx_h1_marker] = ACTIONS(1458),
    [sym_atx_h2_marker] = ACTIONS(1458),
    [sym_atx_h3_marker] = ACTIONS(1458),
    [sym_atx_h4_marker] = ACTIONS(1458),
    [sym_atx_h5_marker] = ACTIONS(1458),
    [sym_atx_h6_marker] = ACTIONS(1458),
    [sym__thematic_break] = ACTIONS(1458),
    [sym__list_marker_minus] = ACTIONS(1458),
    [sym__list_marker_plus] = ACTIONS(1458),
    [sym__list_marker_star] = ACTIONS(1458),
    [sym__list_marker_parenthesis] = ACTIONS(1458),
    [sym__list_marker_dot] = ACTIONS(1458),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1458),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1458),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1458),
    [sym__blank_line_start] = ACTIONS(1458),
    [sym__html_block_1_start] = ACTIONS(1458),
    [sym__html_block_2_start] = ACTIONS(1458),
    [sym__html_block_3_start] = ACTIONS(1458),
    [sym__html_block_4_start] = ACTIONS(1458),
    [sym__html_block_5_start] = ACTIONS(1458),
    [sym__html_block_6_start] = ACTIONS(1458),
    [sym__html_block_7_start] = ACTIONS(1458),
    [sym__pipe_table_start] = ACTIONS(1458),
  },
  [153] = {
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_RBRACK] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [anon_sym_POUND] = ACTIONS(1412),
    [anon_sym_DOLLAR] = ACTIONS(1412),
    [anon_sym_PERCENT] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_COLON] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym_EQ] = ACTIONS(1412),
    [anon_sym_QMARK] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1412),
    [anon_sym__] = ACTIONS(1412),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [anon_sym_RPAREN] = ACTIONS(1412),
    [aux_sym__word_token1] = ACTIONS(1412),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1412),
    [aux_sym__word_token2] = ACTIONS(1412),
    [sym__whitespace] = ACTIONS(1412),
    [sym__soft_line_ending] = ACTIONS(1412),
    [sym__block_close] = ACTIONS(1412),
    [sym_block_continuation] = ACTIONS(1464),
    [sym__block_quote_start] = ACTIONS(1412),
    [sym__indented_chunk_start] = ACTIONS(1412),
    [sym_atx_h1_marker] = ACTIONS(1412),
    [sym_atx_h2_marker] = ACTIONS(1412),
    [sym_atx_h3_marker] = ACTIONS(1412),
    [sym_atx_h4_marker] = ACTIONS(1412),
    [sym_atx_h5_marker] = ACTIONS(1412),
    [sym_atx_h6_marker] = ACTIONS(1412),
    [sym__thematic_break] = ACTIONS(1412),
    [sym__list_marker_minus] = ACTIONS(1412),
    [sym__list_marker_plus] = ACTIONS(1412),
    [sym__list_marker_star] = ACTIONS(1412),
    [sym__list_marker_parenthesis] = ACTIONS(1412),
    [sym__list_marker_dot] = ACTIONS(1412),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1412),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1412),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1412),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1412),
    [sym__blank_line_start] = ACTIONS(1412),
    [sym__html_block_1_start] = ACTIONS(1412),
    [sym__html_block_2_start] = ACTIONS(1412),
    [sym__html_block_3_start] = ACTIONS(1412),
    [sym__html_block_4_start] = ACTIONS(1412),
    [sym__html_block_5_start] = ACTIONS(1412),
    [sym__html_block_6_start] = ACTIONS(1412),
    [sym__html_block_7_start] = ACTIONS(1412),
    [sym__pipe_table_start] = ACTIONS(1412),
  },
  [154] = {
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_RBRACK] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [anon_sym_POUND] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_COLON] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_EQ] = ACTIONS(1400),
    [anon_sym_QMARK] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_BSLASH] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1400),
    [anon_sym__] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [aux_sym__word_token1] = ACTIONS(1400),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1400),
    [aux_sym__word_token2] = ACTIONS(1400),
    [sym__whitespace] = ACTIONS(1400),
    [sym__soft_line_ending] = ACTIONS(1400),
    [sym__block_close] = ACTIONS(1400),
    [sym_block_continuation] = ACTIONS(1466),
    [sym__block_quote_start] = ACTIONS(1400),
    [sym__indented_chunk_start] = ACTIONS(1400),
    [sym_atx_h1_marker] = ACTIONS(1400),
    [sym_atx_h2_marker] = ACTIONS(1400),
    [sym_atx_h3_marker] = ACTIONS(1400),
    [sym_atx_h4_marker] = ACTIONS(1400),
    [sym_atx_h5_marker] = ACTIONS(1400),
    [sym_atx_h6_marker] = ACTIONS(1400),
    [sym__thematic_break] = ACTIONS(1400),
    [sym__list_marker_minus] = ACTIONS(1400),
    [sym__list_marker_plus] = ACTIONS(1400),
    [sym__list_marker_star] = ACTIONS(1400),
    [sym__list_marker_parenthesis] = ACTIONS(1400),
    [sym__list_marker_dot] = ACTIONS(1400),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1400),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1400),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1400),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1400),
    [sym__blank_line_start] = ACTIONS(1400),
    [sym__html_block_1_start] = ACTIONS(1400),
    [sym__html_block_2_start] = ACTIONS(1400),
    [sym__html_block_3_start] = ACTIONS(1400),
    [sym__html_block_4_start] = ACTIONS(1400),
    [sym__html_block_5_start] = ACTIONS(1400),
    [sym__html_block_6_start] = ACTIONS(1400),
    [sym__html_block_7_start] = ACTIONS(1400),
    [sym__pipe_table_start] = ACTIONS(1400),
  },
  [155] = {
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_RBRACK] = ACTIONS(1394),
    [anon_sym_LT] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_DOLLAR] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_AMP] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_COLON] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [anon_sym_BSLASH] = ACTIONS(1394),
    [anon_sym_CARET] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1394),
    [anon_sym_BQUOTE] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_RPAREN] = ACTIONS(1394),
    [aux_sym__word_token1] = ACTIONS(1394),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1394),
    [aux_sym__word_token2] = ACTIONS(1394),
    [sym__whitespace] = ACTIONS(1394),
    [sym__soft_line_ending] = ACTIONS(1394),
    [sym__block_close] = ACTIONS(1394),
    [sym_block_continuation] = ACTIONS(1468),
    [sym__block_quote_start] = ACTIONS(1394),
    [sym__indented_chunk_start] = ACTIONS(1394),
    [sym_atx_h1_marker] = ACTIONS(1394),
    [sym_atx_h2_marker] = ACTIONS(1394),
    [sym_atx_h3_marker] = ACTIONS(1394),
    [sym_atx_h4_marker] = ACTIONS(1394),
    [sym_atx_h5_marker] = ACTIONS(1394),
    [sym_atx_h6_marker] = ACTIONS(1394),
    [sym__thematic_break] = ACTIONS(1394),
    [sym__list_marker_minus] = ACTIONS(1394),
    [sym__list_marker_plus] = ACTIONS(1394),
    [sym__list_marker_star] = ACTIONS(1394),
    [sym__list_marker_parenthesis] = ACTIONS(1394),
    [sym__list_marker_dot] = ACTIONS(1394),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1394),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1394),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1394),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1394),
    [sym__blank_line_start] = ACTIONS(1394),
    [sym__html_block_1_start] = ACTIONS(1394),
    [sym__html_block_2_start] = ACTIONS(1394),
    [sym__html_block_3_start] = ACTIONS(1394),
    [sym__html_block_4_start] = ACTIONS(1394),
    [sym__html_block_5_start] = ACTIONS(1394),
    [sym__html_block_6_start] = ACTIONS(1394),
    [sym__html_block_7_start] = ACTIONS(1394),
    [sym__pipe_table_start] = ACTIONS(1394),
  },
  [156] = {
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_RBRACK] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [anon_sym_POUND] = ACTIONS(1376),
    [anon_sym_DOLLAR] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_COLON] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_QMARK] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_BSLASH] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1376),
    [anon_sym__] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [aux_sym__word_token1] = ACTIONS(1376),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1376),
    [aux_sym__word_token2] = ACTIONS(1376),
    [sym__whitespace] = ACTIONS(1376),
    [sym__soft_line_ending] = ACTIONS(1376),
    [sym__block_close] = ACTIONS(1376),
    [sym_block_continuation] = ACTIONS(1470),
    [sym__block_quote_start] = ACTIONS(1376),
    [sym__indented_chunk_start] = ACTIONS(1376),
    [sym_atx_h1_marker] = ACTIONS(1376),
    [sym_atx_h2_marker] = ACTIONS(1376),
    [sym_atx_h3_marker] = ACTIONS(1376),
    [sym_atx_h4_marker] = ACTIONS(1376),
    [sym_atx_h5_marker] = ACTIONS(1376),
    [sym_atx_h6_marker] = ACTIONS(1376),
    [sym__thematic_break] = ACTIONS(1376),
    [sym__list_marker_minus] = ACTIONS(1376),
    [sym__list_marker_plus] = ACTIONS(1376),
    [sym__list_marker_star] = ACTIONS(1376),
    [sym__list_marker_parenthesis] = ACTIONS(1376),
    [sym__list_marker_dot] = ACTIONS(1376),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1376),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1376),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1376),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1376),
    [sym__blank_line_start] = ACTIONS(1376),
    [sym__html_block_1_start] = ACTIONS(1376),
    [sym__html_block_2_start] = ACTIONS(1376),
    [sym__html_block_3_start] = ACTIONS(1376),
    [sym__html_block_4_start] = ACTIONS(1376),
    [sym__html_block_5_start] = ACTIONS(1376),
    [sym__html_block_6_start] = ACTIONS(1376),
    [sym__html_block_7_start] = ACTIONS(1376),
    [sym__pipe_table_start] = ACTIONS(1376),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [anon_sym_POUND] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_CARET] = ACTIONS(1472),
    [anon_sym__] = ACTIONS(1472),
    [anon_sym_BQUOTE] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [aux_sym__word_token1] = ACTIONS(1472),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1472),
    [aux_sym__word_token2] = ACTIONS(1472),
    [sym__whitespace] = ACTIONS(1472),
    [sym__soft_line_ending] = ACTIONS(1472),
    [sym_block_continuation] = ACTIONS(1476),
    [sym__block_quote_start] = ACTIONS(1472),
    [sym__indented_chunk_start] = ACTIONS(1472),
    [sym_atx_h1_marker] = ACTIONS(1472),
    [sym_atx_h2_marker] = ACTIONS(1472),
    [sym_atx_h3_marker] = ACTIONS(1472),
    [sym_atx_h4_marker] = ACTIONS(1472),
    [sym_atx_h5_marker] = ACTIONS(1472),
    [sym_atx_h6_marker] = ACTIONS(1472),
    [sym__thematic_break] = ACTIONS(1472),
    [sym__list_marker_minus] = ACTIONS(1472),
    [sym__list_marker_plus] = ACTIONS(1472),
    [sym__list_marker_star] = ACTIONS(1472),
    [sym__list_marker_parenthesis] = ACTIONS(1472),
    [sym__list_marker_dot] = ACTIONS(1472),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1472),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1472),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1472),
    [sym__blank_line_start] = ACTIONS(1472),
    [sym__html_block_1_start] = ACTIONS(1472),
    [sym__html_block_2_start] = ACTIONS(1472),
    [sym__html_block_3_start] = ACTIONS(1472),
    [sym__html_block_4_start] = ACTIONS(1472),
    [sym__html_block_5_start] = ACTIONS(1472),
    [sym__html_block_6_start] = ACTIONS(1472),
    [sym__html_block_7_start] = ACTIONS(1472),
    [sym__pipe_table_start] = ACTIONS(1472),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [aux_sym__word_token1] = ACTIONS(1428),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1428),
    [aux_sym__word_token2] = ACTIONS(1428),
    [sym__whitespace] = ACTIONS(1428),
    [sym__soft_line_ending] = ACTIONS(1428),
    [sym_block_continuation] = ACTIONS(1478),
    [sym__block_quote_start] = ACTIONS(1428),
    [sym__indented_chunk_start] = ACTIONS(1428),
    [sym_atx_h1_marker] = ACTIONS(1428),
    [sym_atx_h2_marker] = ACTIONS(1428),
    [sym_atx_h3_marker] = ACTIONS(1428),
    [sym_atx_h4_marker] = ACTIONS(1428),
    [sym_atx_h5_marker] = ACTIONS(1428),
    [sym_atx_h6_marker] = ACTIONS(1428),
    [sym__thematic_break] = ACTIONS(1428),
    [sym__list_marker_minus] = ACTIONS(1428),
    [sym__list_marker_plus] = ACTIONS(1428),
    [sym__list_marker_star] = ACTIONS(1428),
    [sym__list_marker_parenthesis] = ACTIONS(1428),
    [sym__list_marker_dot] = ACTIONS(1428),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1428),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1428),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1428),
    [sym__blank_line_start] = ACTIONS(1428),
    [sym__html_block_1_start] = ACTIONS(1428),
    [sym__html_block_2_start] = ACTIONS(1428),
    [sym__html_block_3_start] = ACTIONS(1428),
    [sym__html_block_4_start] = ACTIONS(1428),
    [sym__html_block_5_start] = ACTIONS(1428),
    [sym__html_block_6_start] = ACTIONS(1428),
    [sym__html_block_7_start] = ACTIONS(1428),
    [sym__pipe_table_start] = ACTIONS(1428),
  },
  [159] = {
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [anon_sym_POUND] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [aux_sym__word_token1] = ACTIONS(1364),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1364),
    [aux_sym__word_token2] = ACTIONS(1364),
    [sym__whitespace] = ACTIONS(1364),
    [sym__soft_line_ending] = ACTIONS(1364),
    [sym__block_close] = ACTIONS(1364),
    [sym_block_continuation] = ACTIONS(1480),
    [sym__block_quote_start] = ACTIONS(1364),
    [sym__indented_chunk_start] = ACTIONS(1364),
    [sym_atx_h1_marker] = ACTIONS(1364),
    [sym_atx_h2_marker] = ACTIONS(1364),
    [sym_atx_h3_marker] = ACTIONS(1364),
    [sym_atx_h4_marker] = ACTIONS(1364),
    [sym_atx_h5_marker] = ACTIONS(1364),
    [sym_atx_h6_marker] = ACTIONS(1364),
    [sym__thematic_break] = ACTIONS(1364),
    [sym__list_marker_minus] = ACTIONS(1364),
    [sym__list_marker_plus] = ACTIONS(1364),
    [sym__list_marker_star] = ACTIONS(1364),
    [sym__list_marker_parenthesis] = ACTIONS(1364),
    [sym__list_marker_dot] = ACTIONS(1364),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1364),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1364),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1364),
    [sym__blank_line_start] = ACTIONS(1364),
    [sym__html_block_1_start] = ACTIONS(1364),
    [sym__html_block_2_start] = ACTIONS(1364),
    [sym__html_block_3_start] = ACTIONS(1364),
    [sym__html_block_4_start] = ACTIONS(1364),
    [sym__html_block_5_start] = ACTIONS(1364),
    [sym__html_block_6_start] = ACTIONS(1364),
    [sym__html_block_7_start] = ACTIONS(1364),
    [sym__pipe_table_start] = ACTIONS(1364),
  },
  [160] = {
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_RBRACK] = ACTIONS(1328),
    [anon_sym_LT] = ACTIONS(1328),
    [anon_sym_GT] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [anon_sym_POUND] = ACTIONS(1328),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(1328),
    [anon_sym_SLASH] = ACTIONS(1328),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_BSLASH] = ACTIONS(1328),
    [anon_sym_CARET] = ACTIONS(1328),
    [anon_sym__] = ACTIONS(1328),
    [anon_sym_BQUOTE] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_PIPE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [aux_sym__word_token1] = ACTIONS(1328),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1328),
    [aux_sym__word_token2] = ACTIONS(1328),
    [sym__whitespace] = ACTIONS(1328),
    [sym__soft_line_ending] = ACTIONS(1328),
    [sym__block_close] = ACTIONS(1328),
    [sym_block_continuation] = ACTIONS(1482),
    [sym__block_quote_start] = ACTIONS(1328),
    [sym__indented_chunk_start] = ACTIONS(1328),
    [sym_atx_h1_marker] = ACTIONS(1328),
    [sym_atx_h2_marker] = ACTIONS(1328),
    [sym_atx_h3_marker] = ACTIONS(1328),
    [sym_atx_h4_marker] = ACTIONS(1328),
    [sym_atx_h5_marker] = ACTIONS(1328),
    [sym_atx_h6_marker] = ACTIONS(1328),
    [sym__thematic_break] = ACTIONS(1328),
    [sym__list_marker_minus] = ACTIONS(1328),
    [sym__list_marker_plus] = ACTIONS(1328),
    [sym__list_marker_star] = ACTIONS(1328),
    [sym__list_marker_parenthesis] = ACTIONS(1328),
    [sym__list_marker_dot] = ACTIONS(1328),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1328),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1328),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1328),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1328),
    [sym__blank_line_start] = ACTIONS(1328),
    [sym__html_block_1_start] = ACTIONS(1328),
    [sym__html_block_2_start] = ACTIONS(1328),
    [sym__html_block_3_start] = ACTIONS(1328),
    [sym__html_block_4_start] = ACTIONS(1328),
    [sym__html_block_5_start] = ACTIONS(1328),
    [sym__html_block_6_start] = ACTIONS(1328),
    [sym__html_block_7_start] = ACTIONS(1328),
    [sym__pipe_table_start] = ACTIONS(1328),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [aux_sym__word_token1] = ACTIONS(1119),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1119),
    [aux_sym__word_token2] = ACTIONS(1119),
    [sym__whitespace] = ACTIONS(1119),
    [sym__soft_line_ending] = ACTIONS(1119),
    [sym_block_continuation] = ACTIONS(1484),
    [sym__block_quote_start] = ACTIONS(1119),
    [sym__indented_chunk_start] = ACTIONS(1119),
    [sym_atx_h1_marker] = ACTIONS(1119),
    [sym_atx_h2_marker] = ACTIONS(1119),
    [sym_atx_h3_marker] = ACTIONS(1119),
    [sym_atx_h4_marker] = ACTIONS(1119),
    [sym_atx_h5_marker] = ACTIONS(1119),
    [sym_atx_h6_marker] = ACTIONS(1119),
    [sym__thematic_break] = ACTIONS(1119),
    [sym__list_marker_minus] = ACTIONS(1119),
    [sym__list_marker_plus] = ACTIONS(1119),
    [sym__list_marker_star] = ACTIONS(1119),
    [sym__list_marker_parenthesis] = ACTIONS(1119),
    [sym__list_marker_dot] = ACTIONS(1119),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1119),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1119),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1119),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1119),
    [sym__blank_line_start] = ACTIONS(1119),
    [sym__html_block_1_start] = ACTIONS(1119),
    [sym__html_block_2_start] = ACTIONS(1119),
    [sym__html_block_3_start] = ACTIONS(1119),
    [sym__html_block_4_start] = ACTIONS(1119),
    [sym__html_block_5_start] = ACTIONS(1119),
    [sym__html_block_6_start] = ACTIONS(1119),
    [sym__html_block_7_start] = ACTIONS(1119),
    [sym__pipe_table_start] = ACTIONS(1119),
  },
  [162] = {
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [anon_sym_POUND] = ACTIONS(1488),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1488),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_COLON] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_QMARK] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_BSLASH] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1488),
    [anon_sym__] = ACTIONS(1488),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [aux_sym__word_token1] = ACTIONS(1488),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1488),
    [aux_sym__word_token2] = ACTIONS(1488),
    [sym__whitespace] = ACTIONS(1488),
    [sym__soft_line_ending] = ACTIONS(1488),
    [sym__block_close] = ACTIONS(1488),
    [sym_block_continuation] = ACTIONS(1490),
    [sym__block_quote_start] = ACTIONS(1488),
    [sym__indented_chunk_start] = ACTIONS(1488),
    [sym_atx_h1_marker] = ACTIONS(1488),
    [sym_atx_h2_marker] = ACTIONS(1488),
    [sym_atx_h3_marker] = ACTIONS(1488),
    [sym_atx_h4_marker] = ACTIONS(1488),
    [sym_atx_h5_marker] = ACTIONS(1488),
    [sym_atx_h6_marker] = ACTIONS(1488),
    [sym__thematic_break] = ACTIONS(1488),
    [sym__list_marker_minus] = ACTIONS(1488),
    [sym__list_marker_plus] = ACTIONS(1488),
    [sym__list_marker_star] = ACTIONS(1488),
    [sym__list_marker_parenthesis] = ACTIONS(1488),
    [sym__list_marker_dot] = ACTIONS(1488),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1488),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1488),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1488),
    [sym__blank_line_start] = ACTIONS(1488),
    [sym__html_block_1_start] = ACTIONS(1488),
    [sym__html_block_2_start] = ACTIONS(1488),
    [sym__html_block_3_start] = ACTIONS(1488),
    [sym__html_block_4_start] = ACTIONS(1488),
    [sym__html_block_5_start] = ACTIONS(1488),
    [sym__html_block_6_start] = ACTIONS(1488),
    [sym__html_block_7_start] = ACTIONS(1488),
    [sym__pipe_table_start] = ACTIONS(1488),
  },
  [163] = {
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [anon_sym_POUND] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_CARET] = ACTIONS(1472),
    [anon_sym__] = ACTIONS(1472),
    [anon_sym_BQUOTE] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [aux_sym__word_token1] = ACTIONS(1472),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1472),
    [aux_sym__word_token2] = ACTIONS(1472),
    [sym__whitespace] = ACTIONS(1472),
    [sym__soft_line_ending] = ACTIONS(1472),
    [sym__block_close] = ACTIONS(1472),
    [sym_block_continuation] = ACTIONS(1492),
    [sym__block_quote_start] = ACTIONS(1472),
    [sym__indented_chunk_start] = ACTIONS(1472),
    [sym_atx_h1_marker] = ACTIONS(1472),
    [sym_atx_h2_marker] = ACTIONS(1472),
    [sym_atx_h3_marker] = ACTIONS(1472),
    [sym_atx_h4_marker] = ACTIONS(1472),
    [sym_atx_h5_marker] = ACTIONS(1472),
    [sym_atx_h6_marker] = ACTIONS(1472),
    [sym__thematic_break] = ACTIONS(1472),
    [sym__list_marker_minus] = ACTIONS(1472),
    [sym__list_marker_plus] = ACTIONS(1472),
    [sym__list_marker_star] = ACTIONS(1472),
    [sym__list_marker_parenthesis] = ACTIONS(1472),
    [sym__list_marker_dot] = ACTIONS(1472),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1472),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1472),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1472),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1472),
    [sym__blank_line_start] = ACTIONS(1472),
    [sym__html_block_1_start] = ACTIONS(1472),
    [sym__html_block_2_start] = ACTIONS(1472),
    [sym__html_block_3_start] = ACTIONS(1472),
    [sym__html_block_4_start] = ACTIONS(1472),
    [sym__html_block_5_start] = ACTIONS(1472),
    [sym__html_block_6_start] = ACTIONS(1472),
    [sym__html_block_7_start] = ACTIONS(1472),
    [sym__pipe_table_start] = ACTIONS(1472),
  },
  [164] = {
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_RBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1452),
    [anon_sym_DOLLAR] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1452),
    [anon_sym__] = ACTIONS(1452),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_RPAREN] = ACTIONS(1452),
    [aux_sym__word_token1] = ACTIONS(1452),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1452),
    [aux_sym__word_token2] = ACTIONS(1452),
    [sym__whitespace] = ACTIONS(1452),
    [sym__soft_line_ending] = ACTIONS(1452),
    [sym__block_close] = ACTIONS(1452),
    [sym_block_continuation] = ACTIONS(1494),
    [sym__block_quote_start] = ACTIONS(1452),
    [sym__indented_chunk_start] = ACTIONS(1452),
    [sym_atx_h1_marker] = ACTIONS(1452),
    [sym_atx_h2_marker] = ACTIONS(1452),
    [sym_atx_h3_marker] = ACTIONS(1452),
    [sym_atx_h4_marker] = ACTIONS(1452),
    [sym_atx_h5_marker] = ACTIONS(1452),
    [sym_atx_h6_marker] = ACTIONS(1452),
    [sym__thematic_break] = ACTIONS(1452),
    [sym__list_marker_minus] = ACTIONS(1452),
    [sym__list_marker_plus] = ACTIONS(1452),
    [sym__list_marker_star] = ACTIONS(1452),
    [sym__list_marker_parenthesis] = ACTIONS(1452),
    [sym__list_marker_dot] = ACTIONS(1452),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1452),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1452),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1452),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1452),
    [sym__blank_line_start] = ACTIONS(1452),
    [sym__html_block_1_start] = ACTIONS(1452),
    [sym__html_block_2_start] = ACTIONS(1452),
    [sym__html_block_3_start] = ACTIONS(1452),
    [sym__html_block_4_start] = ACTIONS(1452),
    [sym__html_block_5_start] = ACTIONS(1452),
    [sym__html_block_6_start] = ACTIONS(1452),
    [sym__html_block_7_start] = ACTIONS(1452),
    [sym__pipe_table_start] = ACTIONS(1452),
  },
  [165] = {
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_DOLLAR] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_DOT] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1358),
    [anon_sym_BSLASH] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym__] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1358),
    [aux_sym__word_token1] = ACTIONS(1358),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1358),
    [aux_sym__word_token2] = ACTIONS(1358),
    [sym__whitespace] = ACTIONS(1358),
    [sym__soft_line_ending] = ACTIONS(1358),
    [sym__block_close] = ACTIONS(1358),
    [sym_block_continuation] = ACTIONS(1496),
    [sym__block_quote_start] = ACTIONS(1358),
    [sym__indented_chunk_start] = ACTIONS(1358),
    [sym_atx_h1_marker] = ACTIONS(1358),
    [sym_atx_h2_marker] = ACTIONS(1358),
    [sym_atx_h3_marker] = ACTIONS(1358),
    [sym_atx_h4_marker] = ACTIONS(1358),
    [sym_atx_h5_marker] = ACTIONS(1358),
    [sym_atx_h6_marker] = ACTIONS(1358),
    [sym__thematic_break] = ACTIONS(1358),
    [sym__list_marker_minus] = ACTIONS(1358),
    [sym__list_marker_plus] = ACTIONS(1358),
    [sym__list_marker_star] = ACTIONS(1358),
    [sym__list_marker_parenthesis] = ACTIONS(1358),
    [sym__list_marker_dot] = ACTIONS(1358),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1358),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1358),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1358),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1358),
    [sym__blank_line_start] = ACTIONS(1358),
    [sym__html_block_1_start] = ACTIONS(1358),
    [sym__html_block_2_start] = ACTIONS(1358),
    [sym__html_block_3_start] = ACTIONS(1358),
    [sym__html_block_4_start] = ACTIONS(1358),
    [sym__html_block_5_start] = ACTIONS(1358),
    [sym__html_block_6_start] = ACTIONS(1358),
    [sym__html_block_7_start] = ACTIONS(1358),
    [sym__pipe_table_start] = ACTIONS(1358),
  },
  [166] = {
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [anon_sym_POUND] = ACTIONS(1352),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_COLON] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_QMARK] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1352),
    [anon_sym_BSLASH] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym__] = ACTIONS(1352),
    [anon_sym_BQUOTE] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_RPAREN] = ACTIONS(1352),
    [aux_sym__word_token1] = ACTIONS(1352),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1352),
    [aux_sym__word_token2] = ACTIONS(1352),
    [sym__whitespace] = ACTIONS(1352),
    [sym__soft_line_ending] = ACTIONS(1352),
    [sym__block_close] = ACTIONS(1352),
    [sym_block_continuation] = ACTIONS(1498),
    [sym__block_quote_start] = ACTIONS(1352),
    [sym__indented_chunk_start] = ACTIONS(1352),
    [sym_atx_h1_marker] = ACTIONS(1352),
    [sym_atx_h2_marker] = ACTIONS(1352),
    [sym_atx_h3_marker] = ACTIONS(1352),
    [sym_atx_h4_marker] = ACTIONS(1352),
    [sym_atx_h5_marker] = ACTIONS(1352),
    [sym_atx_h6_marker] = ACTIONS(1352),
    [sym__thematic_break] = ACTIONS(1352),
    [sym__list_marker_minus] = ACTIONS(1352),
    [sym__list_marker_plus] = ACTIONS(1352),
    [sym__list_marker_star] = ACTIONS(1352),
    [sym__list_marker_parenthesis] = ACTIONS(1352),
    [sym__list_marker_dot] = ACTIONS(1352),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1352),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1352),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1352),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1352),
    [sym__blank_line_start] = ACTIONS(1352),
    [sym__html_block_1_start] = ACTIONS(1352),
    [sym__html_block_2_start] = ACTIONS(1352),
    [sym__html_block_3_start] = ACTIONS(1352),
    [sym__html_block_4_start] = ACTIONS(1352),
    [sym__html_block_5_start] = ACTIONS(1352),
    [sym__html_block_6_start] = ACTIONS(1352),
    [sym__html_block_7_start] = ACTIONS(1352),
    [sym__pipe_table_start] = ACTIONS(1352),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [aux_sym__word_token1] = ACTIONS(1448),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1448),
    [aux_sym__word_token2] = ACTIONS(1448),
    [sym__whitespace] = ACTIONS(1448),
    [sym__soft_line_ending] = ACTIONS(1448),
    [sym_block_continuation] = ACTIONS(1500),
    [sym__block_quote_start] = ACTIONS(1448),
    [sym__indented_chunk_start] = ACTIONS(1448),
    [sym_atx_h1_marker] = ACTIONS(1448),
    [sym_atx_h2_marker] = ACTIONS(1448),
    [sym_atx_h3_marker] = ACTIONS(1448),
    [sym_atx_h4_marker] = ACTIONS(1448),
    [sym_atx_h5_marker] = ACTIONS(1448),
    [sym_atx_h6_marker] = ACTIONS(1448),
    [sym__thematic_break] = ACTIONS(1448),
    [sym__list_marker_minus] = ACTIONS(1448),
    [sym__list_marker_plus] = ACTIONS(1448),
    [sym__list_marker_star] = ACTIONS(1448),
    [sym__list_marker_parenthesis] = ACTIONS(1448),
    [sym__list_marker_dot] = ACTIONS(1448),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1448),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1448),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1448),
    [sym__blank_line_start] = ACTIONS(1448),
    [sym__html_block_1_start] = ACTIONS(1448),
    [sym__html_block_2_start] = ACTIONS(1448),
    [sym__html_block_3_start] = ACTIONS(1448),
    [sym__html_block_4_start] = ACTIONS(1448),
    [sym__html_block_5_start] = ACTIONS(1448),
    [sym__html_block_6_start] = ACTIONS(1448),
    [sym__html_block_7_start] = ACTIONS(1448),
    [sym__pipe_table_start] = ACTIONS(1448),
  },
  [168] = {
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_POUND] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_QMARK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym__] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [aux_sym__word_token1] = ACTIONS(1334),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1334),
    [aux_sym__word_token2] = ACTIONS(1334),
    [sym__whitespace] = ACTIONS(1334),
    [sym__soft_line_ending] = ACTIONS(1334),
    [sym__block_close] = ACTIONS(1334),
    [sym_block_continuation] = ACTIONS(1502),
    [sym__block_quote_start] = ACTIONS(1334),
    [sym__indented_chunk_start] = ACTIONS(1334),
    [sym_atx_h1_marker] = ACTIONS(1334),
    [sym_atx_h2_marker] = ACTIONS(1334),
    [sym_atx_h3_marker] = ACTIONS(1334),
    [sym_atx_h4_marker] = ACTIONS(1334),
    [sym_atx_h5_marker] = ACTIONS(1334),
    [sym_atx_h6_marker] = ACTIONS(1334),
    [sym__thematic_break] = ACTIONS(1334),
    [sym__list_marker_minus] = ACTIONS(1334),
    [sym__list_marker_plus] = ACTIONS(1334),
    [sym__list_marker_star] = ACTIONS(1334),
    [sym__list_marker_parenthesis] = ACTIONS(1334),
    [sym__list_marker_dot] = ACTIONS(1334),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1334),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1334),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1334),
    [sym__blank_line_start] = ACTIONS(1334),
    [sym__html_block_1_start] = ACTIONS(1334),
    [sym__html_block_2_start] = ACTIONS(1334),
    [sym__html_block_3_start] = ACTIONS(1334),
    [sym__html_block_4_start] = ACTIONS(1334),
    [sym__html_block_5_start] = ACTIONS(1334),
    [sym__html_block_6_start] = ACTIONS(1334),
    [sym__html_block_7_start] = ACTIONS(1334),
    [sym__pipe_table_start] = ACTIONS(1334),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_POUND] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [aux_sym__word_token1] = ACTIONS(1372),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1372),
    [aux_sym__word_token2] = ACTIONS(1372),
    [sym__whitespace] = ACTIONS(1372),
    [sym__soft_line_ending] = ACTIONS(1372),
    [sym_block_continuation] = ACTIONS(1504),
    [sym__block_quote_start] = ACTIONS(1372),
    [sym__indented_chunk_start] = ACTIONS(1372),
    [sym_atx_h1_marker] = ACTIONS(1372),
    [sym_atx_h2_marker] = ACTIONS(1372),
    [sym_atx_h3_marker] = ACTIONS(1372),
    [sym_atx_h4_marker] = ACTIONS(1372),
    [sym_atx_h5_marker] = ACTIONS(1372),
    [sym_atx_h6_marker] = ACTIONS(1372),
    [sym__thematic_break] = ACTIONS(1372),
    [sym__list_marker_minus] = ACTIONS(1372),
    [sym__list_marker_plus] = ACTIONS(1372),
    [sym__list_marker_star] = ACTIONS(1372),
    [sym__list_marker_parenthesis] = ACTIONS(1372),
    [sym__list_marker_dot] = ACTIONS(1372),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1372),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1372),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1372),
    [sym__blank_line_start] = ACTIONS(1372),
    [sym__html_block_1_start] = ACTIONS(1372),
    [sym__html_block_2_start] = ACTIONS(1372),
    [sym__html_block_3_start] = ACTIONS(1372),
    [sym__html_block_4_start] = ACTIONS(1372),
    [sym__html_block_5_start] = ACTIONS(1372),
    [sym__html_block_6_start] = ACTIONS(1372),
    [sym__html_block_7_start] = ACTIONS(1372),
    [sym__pipe_table_start] = ACTIONS(1372),
  },
  [170] = {
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_POUND] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(1322),
    [aux_sym__word_token1] = ACTIONS(1322),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1322),
    [aux_sym__word_token2] = ACTIONS(1322),
    [sym__whitespace] = ACTIONS(1322),
    [sym__soft_line_ending] = ACTIONS(1322),
    [sym__block_close] = ACTIONS(1322),
    [sym_block_continuation] = ACTIONS(1506),
    [sym__block_quote_start] = ACTIONS(1322),
    [sym__indented_chunk_start] = ACTIONS(1322),
    [sym_atx_h1_marker] = ACTIONS(1322),
    [sym_atx_h2_marker] = ACTIONS(1322),
    [sym_atx_h3_marker] = ACTIONS(1322),
    [sym_atx_h4_marker] = ACTIONS(1322),
    [sym_atx_h5_marker] = ACTIONS(1322),
    [sym_atx_h6_marker] = ACTIONS(1322),
    [sym__thematic_break] = ACTIONS(1322),
    [sym__list_marker_minus] = ACTIONS(1322),
    [sym__list_marker_plus] = ACTIONS(1322),
    [sym__list_marker_star] = ACTIONS(1322),
    [sym__list_marker_parenthesis] = ACTIONS(1322),
    [sym__list_marker_dot] = ACTIONS(1322),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1322),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1322),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1322),
    [sym__blank_line_start] = ACTIONS(1322),
    [sym__html_block_1_start] = ACTIONS(1322),
    [sym__html_block_2_start] = ACTIONS(1322),
    [sym__html_block_3_start] = ACTIONS(1322),
    [sym__html_block_4_start] = ACTIONS(1322),
    [sym__html_block_5_start] = ACTIONS(1322),
    [sym__html_block_6_start] = ACTIONS(1322),
    [sym__html_block_7_start] = ACTIONS(1322),
    [sym__pipe_table_start] = ACTIONS(1322),
  },
  [171] = {
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_POUND] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1288),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_QMARK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1288),
    [anon_sym__] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [aux_sym__word_token1] = ACTIONS(1288),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1288),
    [aux_sym__word_token2] = ACTIONS(1288),
    [sym__whitespace] = ACTIONS(1288),
    [sym__soft_line_ending] = ACTIONS(1288),
    [sym__block_close] = ACTIONS(1288),
    [sym_block_continuation] = ACTIONS(1508),
    [sym__block_quote_start] = ACTIONS(1288),
    [sym__indented_chunk_start] = ACTIONS(1288),
    [sym_atx_h1_marker] = ACTIONS(1288),
    [sym_atx_h2_marker] = ACTIONS(1288),
    [sym_atx_h3_marker] = ACTIONS(1288),
    [sym_atx_h4_marker] = ACTIONS(1288),
    [sym_atx_h5_marker] = ACTIONS(1288),
    [sym_atx_h6_marker] = ACTIONS(1288),
    [sym__thematic_break] = ACTIONS(1288),
    [sym__list_marker_minus] = ACTIONS(1288),
    [sym__list_marker_plus] = ACTIONS(1288),
    [sym__list_marker_star] = ACTIONS(1288),
    [sym__list_marker_parenthesis] = ACTIONS(1288),
    [sym__list_marker_dot] = ACTIONS(1288),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1288),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1288),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1288),
    [sym__blank_line_start] = ACTIONS(1288),
    [sym__html_block_1_start] = ACTIONS(1288),
    [sym__html_block_2_start] = ACTIONS(1288),
    [sym__html_block_3_start] = ACTIONS(1288),
    [sym__html_block_4_start] = ACTIONS(1288),
    [sym__html_block_5_start] = ACTIONS(1288),
    [sym__html_block_6_start] = ACTIONS(1288),
    [sym__html_block_7_start] = ACTIONS(1288),
    [sym__pipe_table_start] = ACTIONS(1288),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [aux_sym__word_token1] = ACTIONS(1434),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1434),
    [aux_sym__word_token2] = ACTIONS(1434),
    [sym__whitespace] = ACTIONS(1434),
    [sym__soft_line_ending] = ACTIONS(1434),
    [sym_block_continuation] = ACTIONS(1510),
    [sym__block_quote_start] = ACTIONS(1434),
    [sym__indented_chunk_start] = ACTIONS(1434),
    [sym_atx_h1_marker] = ACTIONS(1434),
    [sym_atx_h2_marker] = ACTIONS(1434),
    [sym_atx_h3_marker] = ACTIONS(1434),
    [sym_atx_h4_marker] = ACTIONS(1434),
    [sym_atx_h5_marker] = ACTIONS(1434),
    [sym_atx_h6_marker] = ACTIONS(1434),
    [sym__thematic_break] = ACTIONS(1434),
    [sym__list_marker_minus] = ACTIONS(1434),
    [sym__list_marker_plus] = ACTIONS(1434),
    [sym__list_marker_star] = ACTIONS(1434),
    [sym__list_marker_parenthesis] = ACTIONS(1434),
    [sym__list_marker_dot] = ACTIONS(1434),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1434),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1434),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1434),
    [sym__blank_line_start] = ACTIONS(1434),
    [sym__html_block_1_start] = ACTIONS(1434),
    [sym__html_block_2_start] = ACTIONS(1434),
    [sym__html_block_3_start] = ACTIONS(1434),
    [sym__html_block_4_start] = ACTIONS(1434),
    [sym__html_block_5_start] = ACTIONS(1434),
    [sym__html_block_6_start] = ACTIONS(1434),
    [sym__html_block_7_start] = ACTIONS(1434),
    [sym__pipe_table_start] = ACTIONS(1434),
  },
  [173] = {
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1316),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym__] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [aux_sym__word_token1] = ACTIONS(1316),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1316),
    [aux_sym__word_token2] = ACTIONS(1316),
    [sym__whitespace] = ACTIONS(1316),
    [sym__soft_line_ending] = ACTIONS(1316),
    [sym__block_close] = ACTIONS(1316),
    [sym_block_continuation] = ACTIONS(1512),
    [sym__block_quote_start] = ACTIONS(1316),
    [sym__indented_chunk_start] = ACTIONS(1316),
    [sym_atx_h1_marker] = ACTIONS(1316),
    [sym_atx_h2_marker] = ACTIONS(1316),
    [sym_atx_h3_marker] = ACTIONS(1316),
    [sym_atx_h4_marker] = ACTIONS(1316),
    [sym_atx_h5_marker] = ACTIONS(1316),
    [sym_atx_h6_marker] = ACTIONS(1316),
    [sym__thematic_break] = ACTIONS(1316),
    [sym__list_marker_minus] = ACTIONS(1316),
    [sym__list_marker_plus] = ACTIONS(1316),
    [sym__list_marker_star] = ACTIONS(1316),
    [sym__list_marker_parenthesis] = ACTIONS(1316),
    [sym__list_marker_dot] = ACTIONS(1316),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1316),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1316),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1316),
    [sym__blank_line_start] = ACTIONS(1316),
    [sym__html_block_1_start] = ACTIONS(1316),
    [sym__html_block_2_start] = ACTIONS(1316),
    [sym__html_block_3_start] = ACTIONS(1316),
    [sym__html_block_4_start] = ACTIONS(1316),
    [sym__html_block_5_start] = ACTIONS(1316),
    [sym__html_block_6_start] = ACTIONS(1316),
    [sym__html_block_7_start] = ACTIONS(1316),
    [sym__pipe_table_start] = ACTIONS(1316),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym__] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [aux_sym__word_token1] = ACTIONS(1384),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1384),
    [aux_sym__word_token2] = ACTIONS(1384),
    [sym__whitespace] = ACTIONS(1384),
    [sym__soft_line_ending] = ACTIONS(1384),
    [sym_block_continuation] = ACTIONS(1514),
    [sym__block_quote_start] = ACTIONS(1384),
    [sym__indented_chunk_start] = ACTIONS(1384),
    [sym_atx_h1_marker] = ACTIONS(1384),
    [sym_atx_h2_marker] = ACTIONS(1384),
    [sym_atx_h3_marker] = ACTIONS(1384),
    [sym_atx_h4_marker] = ACTIONS(1384),
    [sym_atx_h5_marker] = ACTIONS(1384),
    [sym_atx_h6_marker] = ACTIONS(1384),
    [sym__thematic_break] = ACTIONS(1384),
    [sym__list_marker_minus] = ACTIONS(1384),
    [sym__list_marker_plus] = ACTIONS(1384),
    [sym__list_marker_star] = ACTIONS(1384),
    [sym__list_marker_parenthesis] = ACTIONS(1384),
    [sym__list_marker_dot] = ACTIONS(1384),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1384),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1384),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1384),
    [sym__blank_line_start] = ACTIONS(1384),
    [sym__html_block_1_start] = ACTIONS(1384),
    [sym__html_block_2_start] = ACTIONS(1384),
    [sym__html_block_3_start] = ACTIONS(1384),
    [sym__html_block_4_start] = ACTIONS(1384),
    [sym__html_block_5_start] = ACTIONS(1384),
    [sym__html_block_6_start] = ACTIONS(1384),
    [sym__html_block_7_start] = ACTIONS(1384),
    [sym__pipe_table_start] = ACTIONS(1384),
  },
  [175] = {
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_RBRACK] = ACTIONS(1342),
    [anon_sym_LT] = ACTIONS(1342),
    [anon_sym_GT] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_DQUOTE] = ACTIONS(1342),
    [anon_sym_POUND] = ACTIONS(1342),
    [anon_sym_DOLLAR] = ACTIONS(1342),
    [anon_sym_PERCENT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_DOT] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1342),
    [anon_sym_COLON] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1342),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_QMARK] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [anon_sym_BSLASH] = ACTIONS(1342),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym__] = ACTIONS(1342),
    [anon_sym_BQUOTE] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_PIPE] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_RPAREN] = ACTIONS(1342),
    [aux_sym__word_token1] = ACTIONS(1342),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1342),
    [aux_sym__word_token2] = ACTIONS(1342),
    [sym__whitespace] = ACTIONS(1342),
    [sym__soft_line_ending] = ACTIONS(1342),
    [sym__block_close] = ACTIONS(1342),
    [sym_block_continuation] = ACTIONS(1516),
    [sym__block_quote_start] = ACTIONS(1342),
    [sym__indented_chunk_start] = ACTIONS(1342),
    [sym_atx_h1_marker] = ACTIONS(1342),
    [sym_atx_h2_marker] = ACTIONS(1342),
    [sym_atx_h3_marker] = ACTIONS(1342),
    [sym_atx_h4_marker] = ACTIONS(1342),
    [sym_atx_h5_marker] = ACTIONS(1342),
    [sym_atx_h6_marker] = ACTIONS(1342),
    [sym__thematic_break] = ACTIONS(1342),
    [sym__list_marker_minus] = ACTIONS(1342),
    [sym__list_marker_plus] = ACTIONS(1342),
    [sym__list_marker_star] = ACTIONS(1342),
    [sym__list_marker_parenthesis] = ACTIONS(1342),
    [sym__list_marker_dot] = ACTIONS(1342),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1342),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1342),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1342),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1342),
    [sym__blank_line_start] = ACTIONS(1342),
    [sym__html_block_1_start] = ACTIONS(1342),
    [sym__html_block_2_start] = ACTIONS(1342),
    [sym__html_block_3_start] = ACTIONS(1342),
    [sym__html_block_4_start] = ACTIONS(1342),
    [sym__html_block_5_start] = ACTIONS(1342),
    [sym__html_block_6_start] = ACTIONS(1342),
    [sym__html_block_7_start] = ACTIONS(1342),
    [sym__pipe_table_start] = ACTIONS(1342),
  },
  [176] = {
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym__] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(1310),
    [aux_sym__word_token1] = ACTIONS(1310),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1310),
    [aux_sym__word_token2] = ACTIONS(1310),
    [sym__whitespace] = ACTIONS(1310),
    [sym__soft_line_ending] = ACTIONS(1310),
    [sym__block_close] = ACTIONS(1310),
    [sym_block_continuation] = ACTIONS(1518),
    [sym__block_quote_start] = ACTIONS(1310),
    [sym__indented_chunk_start] = ACTIONS(1310),
    [sym_atx_h1_marker] = ACTIONS(1310),
    [sym_atx_h2_marker] = ACTIONS(1310),
    [sym_atx_h3_marker] = ACTIONS(1310),
    [sym_atx_h4_marker] = ACTIONS(1310),
    [sym_atx_h5_marker] = ACTIONS(1310),
    [sym_atx_h6_marker] = ACTIONS(1310),
    [sym__thematic_break] = ACTIONS(1310),
    [sym__list_marker_minus] = ACTIONS(1310),
    [sym__list_marker_plus] = ACTIONS(1310),
    [sym__list_marker_star] = ACTIONS(1310),
    [sym__list_marker_parenthesis] = ACTIONS(1310),
    [sym__list_marker_dot] = ACTIONS(1310),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1310),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1310),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1310),
    [sym__blank_line_start] = ACTIONS(1310),
    [sym__html_block_1_start] = ACTIONS(1310),
    [sym__html_block_2_start] = ACTIONS(1310),
    [sym__html_block_3_start] = ACTIONS(1310),
    [sym__html_block_4_start] = ACTIONS(1310),
    [sym__html_block_5_start] = ACTIONS(1310),
    [sym__html_block_6_start] = ACTIONS(1310),
    [sym__html_block_7_start] = ACTIONS(1310),
    [sym__pipe_table_start] = ACTIONS(1310),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_DOLLAR] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_COLON] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_QMARK] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_BSLASH] = ACTIONS(1296),
    [anon_sym_CARET] = ACTIONS(1296),
    [anon_sym__] = ACTIONS(1296),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [aux_sym__word_token1] = ACTIONS(1296),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1296),
    [aux_sym__word_token2] = ACTIONS(1296),
    [sym__whitespace] = ACTIONS(1296),
    [sym__soft_line_ending] = ACTIONS(1296),
    [sym_block_continuation] = ACTIONS(1520),
    [sym__block_quote_start] = ACTIONS(1296),
    [sym__indented_chunk_start] = ACTIONS(1296),
    [sym_atx_h1_marker] = ACTIONS(1296),
    [sym_atx_h2_marker] = ACTIONS(1296),
    [sym_atx_h3_marker] = ACTIONS(1296),
    [sym_atx_h4_marker] = ACTIONS(1296),
    [sym_atx_h5_marker] = ACTIONS(1296),
    [sym_atx_h6_marker] = ACTIONS(1296),
    [sym__thematic_break] = ACTIONS(1296),
    [sym__list_marker_minus] = ACTIONS(1296),
    [sym__list_marker_plus] = ACTIONS(1296),
    [sym__list_marker_star] = ACTIONS(1296),
    [sym__list_marker_parenthesis] = ACTIONS(1296),
    [sym__list_marker_dot] = ACTIONS(1296),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1296),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1296),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1296),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1296),
    [sym__blank_line_start] = ACTIONS(1296),
    [sym__html_block_1_start] = ACTIONS(1296),
    [sym__html_block_2_start] = ACTIONS(1296),
    [sym__html_block_3_start] = ACTIONS(1296),
    [sym__html_block_4_start] = ACTIONS(1296),
    [sym__html_block_5_start] = ACTIONS(1296),
    [sym__html_block_6_start] = ACTIONS(1296),
    [sym__html_block_7_start] = ACTIONS(1296),
    [sym__pipe_table_start] = ACTIONS(1296),
  },
  [178] = {
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_RBRACK] = ACTIONS(1458),
    [anon_sym_LT] = ACTIONS(1458),
    [anon_sym_GT] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_DQUOTE] = ACTIONS(1458),
    [anon_sym_POUND] = ACTIONS(1458),
    [anon_sym_DOLLAR] = ACTIONS(1458),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1458),
    [anon_sym_SQUOTE] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_COMMA] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_DOT] = ACTIONS(1458),
    [anon_sym_SLASH] = ACTIONS(1458),
    [anon_sym_COLON] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1458),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_QMARK] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_BSLASH] = ACTIONS(1458),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym__] = ACTIONS(1458),
    [anon_sym_BQUOTE] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_PIPE] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [aux_sym__word_token1] = ACTIONS(1458),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1458),
    [aux_sym__word_token2] = ACTIONS(1458),
    [sym__whitespace] = ACTIONS(1458),
    [sym__soft_line_ending] = ACTIONS(1458),
    [sym__block_close] = ACTIONS(1458),
    [sym_block_continuation] = ACTIONS(1522),
    [sym__block_quote_start] = ACTIONS(1458),
    [sym__indented_chunk_start] = ACTIONS(1458),
    [sym_atx_h1_marker] = ACTIONS(1458),
    [sym_atx_h2_marker] = ACTIONS(1458),
    [sym_atx_h3_marker] = ACTIONS(1458),
    [sym_atx_h4_marker] = ACTIONS(1458),
    [sym_atx_h5_marker] = ACTIONS(1458),
    [sym_atx_h6_marker] = ACTIONS(1458),
    [sym__thematic_break] = ACTIONS(1458),
    [sym__list_marker_minus] = ACTIONS(1458),
    [sym__list_marker_plus] = ACTIONS(1458),
    [sym__list_marker_star] = ACTIONS(1458),
    [sym__list_marker_parenthesis] = ACTIONS(1458),
    [sym__list_marker_dot] = ACTIONS(1458),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1458),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1458),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1458),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1458),
    [sym__blank_line_start] = ACTIONS(1458),
    [sym__html_block_1_start] = ACTIONS(1458),
    [sym__html_block_2_start] = ACTIONS(1458),
    [sym__html_block_3_start] = ACTIONS(1458),
    [sym__html_block_4_start] = ACTIONS(1458),
    [sym__html_block_5_start] = ACTIONS(1458),
    [sym__html_block_6_start] = ACTIONS(1458),
    [sym__html_block_7_start] = ACTIONS(1458),
    [sym__pipe_table_start] = ACTIONS(1458),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym__] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [aux_sym__word_token1] = ACTIONS(1390),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1390),
    [aux_sym__word_token2] = ACTIONS(1390),
    [sym__whitespace] = ACTIONS(1390),
    [sym__soft_line_ending] = ACTIONS(1390),
    [sym_block_continuation] = ACTIONS(1524),
    [sym__block_quote_start] = ACTIONS(1390),
    [sym__indented_chunk_start] = ACTIONS(1390),
    [sym_atx_h1_marker] = ACTIONS(1390),
    [sym_atx_h2_marker] = ACTIONS(1390),
    [sym_atx_h3_marker] = ACTIONS(1390),
    [sym_atx_h4_marker] = ACTIONS(1390),
    [sym_atx_h5_marker] = ACTIONS(1390),
    [sym_atx_h6_marker] = ACTIONS(1390),
    [sym__thematic_break] = ACTIONS(1390),
    [sym__list_marker_minus] = ACTIONS(1390),
    [sym__list_marker_plus] = ACTIONS(1390),
    [sym__list_marker_star] = ACTIONS(1390),
    [sym__list_marker_parenthesis] = ACTIONS(1390),
    [sym__list_marker_dot] = ACTIONS(1390),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1390),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1390),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1390),
    [sym__blank_line_start] = ACTIONS(1390),
    [sym__html_block_1_start] = ACTIONS(1390),
    [sym__html_block_2_start] = ACTIONS(1390),
    [sym__html_block_3_start] = ACTIONS(1390),
    [sym__html_block_4_start] = ACTIONS(1390),
    [sym__html_block_5_start] = ACTIONS(1390),
    [sym__html_block_6_start] = ACTIONS(1390),
    [sym__html_block_7_start] = ACTIONS(1390),
    [sym__pipe_table_start] = ACTIONS(1390),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [aux_sym__word_token1] = ACTIONS(1440),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1440),
    [aux_sym__word_token2] = ACTIONS(1440),
    [sym__whitespace] = ACTIONS(1440),
    [sym__soft_line_ending] = ACTIONS(1440),
    [sym_block_continuation] = ACTIONS(1526),
    [sym__block_quote_start] = ACTIONS(1440),
    [sym__indented_chunk_start] = ACTIONS(1440),
    [sym_atx_h1_marker] = ACTIONS(1440),
    [sym_atx_h2_marker] = ACTIONS(1440),
    [sym_atx_h3_marker] = ACTIONS(1440),
    [sym_atx_h4_marker] = ACTIONS(1440),
    [sym_atx_h5_marker] = ACTIONS(1440),
    [sym_atx_h6_marker] = ACTIONS(1440),
    [sym__thematic_break] = ACTIONS(1440),
    [sym__list_marker_minus] = ACTIONS(1440),
    [sym__list_marker_plus] = ACTIONS(1440),
    [sym__list_marker_star] = ACTIONS(1440),
    [sym__list_marker_parenthesis] = ACTIONS(1440),
    [sym__list_marker_dot] = ACTIONS(1440),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1440),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1440),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1440),
    [sym__blank_line_start] = ACTIONS(1440),
    [sym__html_block_1_start] = ACTIONS(1440),
    [sym__html_block_2_start] = ACTIONS(1440),
    [sym__html_block_3_start] = ACTIONS(1440),
    [sym__html_block_4_start] = ACTIONS(1440),
    [sym__html_block_5_start] = ACTIONS(1440),
    [sym__html_block_6_start] = ACTIONS(1440),
    [sym__html_block_7_start] = ACTIONS(1440),
    [sym__pipe_table_start] = ACTIONS(1440),
  },
  [181] = {
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_BANG] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [anon_sym_POUND] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_AMP] = ACTIONS(1302),
    [anon_sym_SQUOTE] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_COMMA] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_COLON] = ACTIONS(1302),
    [anon_sym_SEMI] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_QMARK] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [anon_sym_BSLASH] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1302),
    [anon_sym__] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [aux_sym__word_token1] = ACTIONS(1302),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1302),
    [aux_sym__word_token2] = ACTIONS(1302),
    [sym__whitespace] = ACTIONS(1302),
    [sym__soft_line_ending] = ACTIONS(1302),
    [sym__block_close] = ACTIONS(1302),
    [sym_block_continuation] = ACTIONS(1528),
    [sym__block_quote_start] = ACTIONS(1302),
    [sym__indented_chunk_start] = ACTIONS(1302),
    [sym_atx_h1_marker] = ACTIONS(1302),
    [sym_atx_h2_marker] = ACTIONS(1302),
    [sym_atx_h3_marker] = ACTIONS(1302),
    [sym_atx_h4_marker] = ACTIONS(1302),
    [sym_atx_h5_marker] = ACTIONS(1302),
    [sym_atx_h6_marker] = ACTIONS(1302),
    [sym__thematic_break] = ACTIONS(1302),
    [sym__list_marker_minus] = ACTIONS(1302),
    [sym__list_marker_plus] = ACTIONS(1302),
    [sym__list_marker_star] = ACTIONS(1302),
    [sym__list_marker_parenthesis] = ACTIONS(1302),
    [sym__list_marker_dot] = ACTIONS(1302),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1302),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1302),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1302),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1302),
    [sym__blank_line_start] = ACTIONS(1302),
    [sym__html_block_1_start] = ACTIONS(1302),
    [sym__html_block_2_start] = ACTIONS(1302),
    [sym__html_block_3_start] = ACTIONS(1302),
    [sym__html_block_4_start] = ACTIONS(1302),
    [sym__html_block_5_start] = ACTIONS(1302),
    [sym__html_block_6_start] = ACTIONS(1302),
    [sym__html_block_7_start] = ACTIONS(1302),
    [sym__pipe_table_start] = ACTIONS(1302),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [anon_sym_POUND] = ACTIONS(1488),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1488),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_COLON] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_QMARK] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_BSLASH] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1488),
    [anon_sym__] = ACTIONS(1488),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [aux_sym__word_token1] = ACTIONS(1488),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1488),
    [aux_sym__word_token2] = ACTIONS(1488),
    [sym__whitespace] = ACTIONS(1488),
    [sym__soft_line_ending] = ACTIONS(1488),
    [sym_block_continuation] = ACTIONS(1530),
    [sym__block_quote_start] = ACTIONS(1488),
    [sym__indented_chunk_start] = ACTIONS(1488),
    [sym_atx_h1_marker] = ACTIONS(1488),
    [sym_atx_h2_marker] = ACTIONS(1488),
    [sym_atx_h3_marker] = ACTIONS(1488),
    [sym_atx_h4_marker] = ACTIONS(1488),
    [sym_atx_h5_marker] = ACTIONS(1488),
    [sym_atx_h6_marker] = ACTIONS(1488),
    [sym__thematic_break] = ACTIONS(1488),
    [sym__list_marker_minus] = ACTIONS(1488),
    [sym__list_marker_plus] = ACTIONS(1488),
    [sym__list_marker_star] = ACTIONS(1488),
    [sym__list_marker_parenthesis] = ACTIONS(1488),
    [sym__list_marker_dot] = ACTIONS(1488),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1488),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1488),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1488),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1488),
    [sym__blank_line_start] = ACTIONS(1488),
    [sym__html_block_1_start] = ACTIONS(1488),
    [sym__html_block_2_start] = ACTIONS(1488),
    [sym__html_block_3_start] = ACTIONS(1488),
    [sym__html_block_4_start] = ACTIONS(1488),
    [sym__html_block_5_start] = ACTIONS(1488),
    [sym__html_block_6_start] = ACTIONS(1488),
    [sym__html_block_7_start] = ACTIONS(1488),
    [sym__pipe_table_start] = ACTIONS(1488),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_POUND] = ACTIONS(1408),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_COLON] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1408),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(1408),
    [aux_sym__word_token1] = ACTIONS(1408),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1408),
    [aux_sym__word_token2] = ACTIONS(1408),
    [sym__whitespace] = ACTIONS(1408),
    [sym__soft_line_ending] = ACTIONS(1408),
    [sym_block_continuation] = ACTIONS(1532),
    [sym__block_quote_start] = ACTIONS(1408),
    [sym__indented_chunk_start] = ACTIONS(1408),
    [sym_atx_h1_marker] = ACTIONS(1408),
    [sym_atx_h2_marker] = ACTIONS(1408),
    [sym_atx_h3_marker] = ACTIONS(1408),
    [sym_atx_h4_marker] = ACTIONS(1408),
    [sym_atx_h5_marker] = ACTIONS(1408),
    [sym_atx_h6_marker] = ACTIONS(1408),
    [sym__thematic_break] = ACTIONS(1408),
    [sym__list_marker_minus] = ACTIONS(1408),
    [sym__list_marker_plus] = ACTIONS(1408),
    [sym__list_marker_star] = ACTIONS(1408),
    [sym__list_marker_parenthesis] = ACTIONS(1408),
    [sym__list_marker_dot] = ACTIONS(1408),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1408),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1408),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1408),
    [sym__blank_line_start] = ACTIONS(1408),
    [sym__html_block_1_start] = ACTIONS(1408),
    [sym__html_block_2_start] = ACTIONS(1408),
    [sym__html_block_3_start] = ACTIONS(1408),
    [sym__html_block_4_start] = ACTIONS(1408),
    [sym__html_block_5_start] = ACTIONS(1408),
    [sym__html_block_6_start] = ACTIONS(1408),
    [sym__html_block_7_start] = ACTIONS(1408),
    [sym__pipe_table_start] = ACTIONS(1408),
  },
  [184] = {
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_DQUOTE] = ACTIONS(1536),
    [anon_sym_POUND] = ACTIONS(1536),
    [anon_sym_DOLLAR] = ACTIONS(1536),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(1536),
    [anon_sym_STAR] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1536),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_BSLASH] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym__] = ACTIONS(1536),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [aux_sym__word_token1] = ACTIONS(1536),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1536),
    [aux_sym__word_token2] = ACTIONS(1536),
    [sym__whitespace] = ACTIONS(1536),
    [sym__soft_line_ending] = ACTIONS(1536),
    [sym__block_close] = ACTIONS(1536),
    [sym__block_quote_start] = ACTIONS(1536),
    [sym__indented_chunk_start] = ACTIONS(1536),
    [sym_atx_h1_marker] = ACTIONS(1536),
    [sym_atx_h2_marker] = ACTIONS(1536),
    [sym_atx_h3_marker] = ACTIONS(1536),
    [sym_atx_h4_marker] = ACTIONS(1536),
    [sym_atx_h5_marker] = ACTIONS(1536),
    [sym_atx_h6_marker] = ACTIONS(1536),
    [sym__thematic_break] = ACTIONS(1536),
    [sym__list_marker_minus] = ACTIONS(1536),
    [sym__list_marker_plus] = ACTIONS(1536),
    [sym__list_marker_star] = ACTIONS(1536),
    [sym__list_marker_parenthesis] = ACTIONS(1536),
    [sym__list_marker_dot] = ACTIONS(1536),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1536),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1536),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1536),
    [sym__blank_line_start] = ACTIONS(1536),
    [sym__html_block_1_start] = ACTIONS(1536),
    [sym__html_block_2_start] = ACTIONS(1536),
    [sym__html_block_3_start] = ACTIONS(1536),
    [sym__html_block_4_start] = ACTIONS(1536),
    [sym__html_block_5_start] = ACTIONS(1536),
    [sym__html_block_6_start] = ACTIONS(1536),
    [sym__html_block_7_start] = ACTIONS(1536),
    [sym__pipe_table_start] = ACTIONS(1536),
  },
  [185] = {
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [anon_sym_POUND] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_COMMA] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DOT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_BSLASH] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym__] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [aux_sym__word_token1] = ACTIONS(1540),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1540),
    [aux_sym__word_token2] = ACTIONS(1540),
    [sym__whitespace] = ACTIONS(1540),
    [sym__soft_line_ending] = ACTIONS(1540),
    [sym__block_close] = ACTIONS(1540),
    [sym__block_quote_start] = ACTIONS(1540),
    [sym__indented_chunk_start] = ACTIONS(1540),
    [sym_atx_h1_marker] = ACTIONS(1540),
    [sym_atx_h2_marker] = ACTIONS(1540),
    [sym_atx_h3_marker] = ACTIONS(1540),
    [sym_atx_h4_marker] = ACTIONS(1540),
    [sym_atx_h5_marker] = ACTIONS(1540),
    [sym_atx_h6_marker] = ACTIONS(1540),
    [sym__thematic_break] = ACTIONS(1540),
    [sym__list_marker_minus] = ACTIONS(1540),
    [sym__list_marker_plus] = ACTIONS(1540),
    [sym__list_marker_star] = ACTIONS(1540),
    [sym__list_marker_parenthesis] = ACTIONS(1540),
    [sym__list_marker_dot] = ACTIONS(1540),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1540),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1540),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1540),
    [sym__blank_line_start] = ACTIONS(1540),
    [sym__html_block_1_start] = ACTIONS(1540),
    [sym__html_block_2_start] = ACTIONS(1540),
    [sym__html_block_3_start] = ACTIONS(1540),
    [sym__html_block_4_start] = ACTIONS(1540),
    [sym__html_block_5_start] = ACTIONS(1540),
    [sym__html_block_6_start] = ACTIONS(1540),
    [sym__html_block_7_start] = ACTIONS(1540),
    [sym__pipe_table_start] = ACTIONS(1540),
  },
  [186] = {
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [anon_sym_POUND] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_SQUOTE] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_BSLASH] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1544),
    [anon_sym__] = ACTIONS(1544),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [aux_sym__word_token1] = ACTIONS(1544),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1544),
    [aux_sym__word_token2] = ACTIONS(1544),
    [sym__whitespace] = ACTIONS(1544),
    [sym__soft_line_ending] = ACTIONS(1544),
    [sym__block_close] = ACTIONS(1544),
    [sym__block_quote_start] = ACTIONS(1544),
    [sym__indented_chunk_start] = ACTIONS(1544),
    [sym_atx_h1_marker] = ACTIONS(1544),
    [sym_atx_h2_marker] = ACTIONS(1544),
    [sym_atx_h3_marker] = ACTIONS(1544),
    [sym_atx_h4_marker] = ACTIONS(1544),
    [sym_atx_h5_marker] = ACTIONS(1544),
    [sym_atx_h6_marker] = ACTIONS(1544),
    [sym__thematic_break] = ACTIONS(1544),
    [sym__list_marker_minus] = ACTIONS(1544),
    [sym__list_marker_plus] = ACTIONS(1544),
    [sym__list_marker_star] = ACTIONS(1544),
    [sym__list_marker_parenthesis] = ACTIONS(1544),
    [sym__list_marker_dot] = ACTIONS(1544),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1544),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1544),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1544),
    [sym__blank_line_start] = ACTIONS(1544),
    [sym__html_block_1_start] = ACTIONS(1544),
    [sym__html_block_2_start] = ACTIONS(1544),
    [sym__html_block_3_start] = ACTIONS(1544),
    [sym__html_block_4_start] = ACTIONS(1544),
    [sym__html_block_5_start] = ACTIONS(1544),
    [sym__html_block_6_start] = ACTIONS(1544),
    [sym__html_block_7_start] = ACTIONS(1544),
    [sym__pipe_table_start] = ACTIONS(1544),
  },
  [187] = {
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_POUND] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(1548),
    [anon_sym_PERCENT] = ACTIONS(1548),
    [anon_sym_AMP] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1548),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1548),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1548),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_BSLASH] = ACTIONS(1548),
    [anon_sym_CARET] = ACTIONS(1548),
    [anon_sym__] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [aux_sym__word_token1] = ACTIONS(1548),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1548),
    [aux_sym__word_token2] = ACTIONS(1548),
    [sym__whitespace] = ACTIONS(1548),
    [sym__soft_line_ending] = ACTIONS(1548),
    [sym__block_close] = ACTIONS(1548),
    [sym__block_quote_start] = ACTIONS(1548),
    [sym__indented_chunk_start] = ACTIONS(1548),
    [sym_atx_h1_marker] = ACTIONS(1548),
    [sym_atx_h2_marker] = ACTIONS(1548),
    [sym_atx_h3_marker] = ACTIONS(1548),
    [sym_atx_h4_marker] = ACTIONS(1548),
    [sym_atx_h5_marker] = ACTIONS(1548),
    [sym_atx_h6_marker] = ACTIONS(1548),
    [sym__thematic_break] = ACTIONS(1548),
    [sym__list_marker_minus] = ACTIONS(1548),
    [sym__list_marker_plus] = ACTIONS(1548),
    [sym__list_marker_star] = ACTIONS(1548),
    [sym__list_marker_parenthesis] = ACTIONS(1548),
    [sym__list_marker_dot] = ACTIONS(1548),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1548),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1548),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1548),
    [sym__blank_line_start] = ACTIONS(1548),
    [sym__html_block_1_start] = ACTIONS(1548),
    [sym__html_block_2_start] = ACTIONS(1548),
    [sym__html_block_3_start] = ACTIONS(1548),
    [sym__html_block_4_start] = ACTIONS(1548),
    [sym__html_block_5_start] = ACTIONS(1548),
    [sym__html_block_6_start] = ACTIONS(1548),
    [sym__html_block_7_start] = ACTIONS(1548),
    [sym__pipe_table_start] = ACTIONS(1548),
  },
  [188] = {
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [anon_sym_POUND] = ACTIONS(1552),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_PERCENT] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_SEMI] = ACTIONS(1552),
    [anon_sym_EQ] = ACTIONS(1552),
    [anon_sym_QMARK] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(1552),
    [anon_sym_BSLASH] = ACTIONS(1552),
    [anon_sym_CARET] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1552),
    [anon_sym_BQUOTE] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_RPAREN] = ACTIONS(1552),
    [aux_sym__word_token1] = ACTIONS(1552),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1552),
    [aux_sym__word_token2] = ACTIONS(1552),
    [sym__whitespace] = ACTIONS(1552),
    [sym__soft_line_ending] = ACTIONS(1552),
    [sym__block_close] = ACTIONS(1552),
    [sym__block_quote_start] = ACTIONS(1552),
    [sym__indented_chunk_start] = ACTIONS(1552),
    [sym_atx_h1_marker] = ACTIONS(1552),
    [sym_atx_h2_marker] = ACTIONS(1552),
    [sym_atx_h3_marker] = ACTIONS(1552),
    [sym_atx_h4_marker] = ACTIONS(1552),
    [sym_atx_h5_marker] = ACTIONS(1552),
    [sym_atx_h6_marker] = ACTIONS(1552),
    [sym__thematic_break] = ACTIONS(1552),
    [sym__list_marker_minus] = ACTIONS(1552),
    [sym__list_marker_plus] = ACTIONS(1552),
    [sym__list_marker_star] = ACTIONS(1552),
    [sym__list_marker_parenthesis] = ACTIONS(1552),
    [sym__list_marker_dot] = ACTIONS(1552),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1552),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1552),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1552),
    [sym__blank_line_start] = ACTIONS(1552),
    [sym__html_block_1_start] = ACTIONS(1552),
    [sym__html_block_2_start] = ACTIONS(1552),
    [sym__html_block_3_start] = ACTIONS(1552),
    [sym__html_block_4_start] = ACTIONS(1552),
    [sym__html_block_5_start] = ACTIONS(1552),
    [sym__html_block_6_start] = ACTIONS(1552),
    [sym__html_block_7_start] = ACTIONS(1552),
    [sym__pipe_table_start] = ACTIONS(1552),
  },
  [189] = {
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_DQUOTE] = ACTIONS(1556),
    [anon_sym_POUND] = ACTIONS(1556),
    [anon_sym_DOLLAR] = ACTIONS(1556),
    [anon_sym_PERCENT] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1556),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_BSLASH] = ACTIONS(1556),
    [anon_sym_CARET] = ACTIONS(1556),
    [anon_sym__] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [aux_sym__word_token1] = ACTIONS(1556),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1556),
    [aux_sym__word_token2] = ACTIONS(1556),
    [sym__whitespace] = ACTIONS(1556),
    [sym__soft_line_ending] = ACTIONS(1556),
    [sym__block_close] = ACTIONS(1556),
    [sym__block_quote_start] = ACTIONS(1556),
    [sym__indented_chunk_start] = ACTIONS(1556),
    [sym_atx_h1_marker] = ACTIONS(1556),
    [sym_atx_h2_marker] = ACTIONS(1556),
    [sym_atx_h3_marker] = ACTIONS(1556),
    [sym_atx_h4_marker] = ACTIONS(1556),
    [sym_atx_h5_marker] = ACTIONS(1556),
    [sym_atx_h6_marker] = ACTIONS(1556),
    [sym__thematic_break] = ACTIONS(1556),
    [sym__list_marker_minus] = ACTIONS(1556),
    [sym__list_marker_plus] = ACTIONS(1556),
    [sym__list_marker_star] = ACTIONS(1556),
    [sym__list_marker_parenthesis] = ACTIONS(1556),
    [sym__list_marker_dot] = ACTIONS(1556),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1556),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1556),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1556),
    [sym__blank_line_start] = ACTIONS(1556),
    [sym__html_block_1_start] = ACTIONS(1556),
    [sym__html_block_2_start] = ACTIONS(1556),
    [sym__html_block_3_start] = ACTIONS(1556),
    [sym__html_block_4_start] = ACTIONS(1556),
    [sym__html_block_5_start] = ACTIONS(1556),
    [sym__html_block_6_start] = ACTIONS(1556),
    [sym__html_block_7_start] = ACTIONS(1556),
    [sym__pipe_table_start] = ACTIONS(1556),
  },
  [190] = {
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(1560),
    [anon_sym_DOLLAR] = ACTIONS(1560),
    [anon_sym_PERCENT] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1560),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_COLON] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_BSLASH] = ACTIONS(1560),
    [anon_sym_CARET] = ACTIONS(1560),
    [anon_sym__] = ACTIONS(1560),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [aux_sym__word_token1] = ACTIONS(1560),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1560),
    [aux_sym__word_token2] = ACTIONS(1560),
    [sym__whitespace] = ACTIONS(1560),
    [sym__soft_line_ending] = ACTIONS(1560),
    [sym__block_close] = ACTIONS(1560),
    [sym__block_quote_start] = ACTIONS(1560),
    [sym__indented_chunk_start] = ACTIONS(1560),
    [sym_atx_h1_marker] = ACTIONS(1560),
    [sym_atx_h2_marker] = ACTIONS(1560),
    [sym_atx_h3_marker] = ACTIONS(1560),
    [sym_atx_h4_marker] = ACTIONS(1560),
    [sym_atx_h5_marker] = ACTIONS(1560),
    [sym_atx_h6_marker] = ACTIONS(1560),
    [sym__thematic_break] = ACTIONS(1560),
    [sym__list_marker_minus] = ACTIONS(1560),
    [sym__list_marker_plus] = ACTIONS(1560),
    [sym__list_marker_star] = ACTIONS(1560),
    [sym__list_marker_parenthesis] = ACTIONS(1560),
    [sym__list_marker_dot] = ACTIONS(1560),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1560),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1560),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1560),
    [sym__blank_line_start] = ACTIONS(1560),
    [sym__html_block_1_start] = ACTIONS(1560),
    [sym__html_block_2_start] = ACTIONS(1560),
    [sym__html_block_3_start] = ACTIONS(1560),
    [sym__html_block_4_start] = ACTIONS(1560),
    [sym__html_block_5_start] = ACTIONS(1560),
    [sym__html_block_6_start] = ACTIONS(1560),
    [sym__html_block_7_start] = ACTIONS(1560),
    [sym__pipe_table_start] = ACTIONS(1560),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_POUND] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [aux_sym__word_token1] = ACTIONS(1372),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1372),
    [aux_sym__word_token2] = ACTIONS(1372),
    [sym__whitespace] = ACTIONS(1372),
    [sym__soft_line_ending] = ACTIONS(1372),
    [sym__block_quote_start] = ACTIONS(1372),
    [sym__indented_chunk_start] = ACTIONS(1372),
    [sym_atx_h1_marker] = ACTIONS(1372),
    [sym_atx_h2_marker] = ACTIONS(1372),
    [sym_atx_h3_marker] = ACTIONS(1372),
    [sym_atx_h4_marker] = ACTIONS(1372),
    [sym_atx_h5_marker] = ACTIONS(1372),
    [sym_atx_h6_marker] = ACTIONS(1372),
    [sym__thematic_break] = ACTIONS(1372),
    [sym__list_marker_minus] = ACTIONS(1372),
    [sym__list_marker_plus] = ACTIONS(1372),
    [sym__list_marker_star] = ACTIONS(1372),
    [sym__list_marker_parenthesis] = ACTIONS(1372),
    [sym__list_marker_dot] = ACTIONS(1372),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1372),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1372),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1372),
    [sym__blank_line_start] = ACTIONS(1372),
    [sym__html_block_1_start] = ACTIONS(1372),
    [sym__html_block_2_start] = ACTIONS(1372),
    [sym__html_block_3_start] = ACTIONS(1372),
    [sym__html_block_4_start] = ACTIONS(1372),
    [sym__html_block_5_start] = ACTIONS(1372),
    [sym__html_block_6_start] = ACTIONS(1372),
    [sym__html_block_7_start] = ACTIONS(1372),
    [sym__pipe_table_start] = ACTIONS(1372),
  },
  [192] = {
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym__] = ACTIONS(1145),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [aux_sym__word_token1] = ACTIONS(1145),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1145),
    [aux_sym__word_token2] = ACTIONS(1145),
    [sym__whitespace] = ACTIONS(1145),
    [sym__soft_line_ending] = ACTIONS(1145),
    [sym__block_close] = ACTIONS(1145),
    [sym__block_quote_start] = ACTIONS(1145),
    [sym__indented_chunk_start] = ACTIONS(1145),
    [sym_atx_h1_marker] = ACTIONS(1145),
    [sym_atx_h2_marker] = ACTIONS(1145),
    [sym_atx_h3_marker] = ACTIONS(1145),
    [sym_atx_h4_marker] = ACTIONS(1145),
    [sym_atx_h5_marker] = ACTIONS(1145),
    [sym_atx_h6_marker] = ACTIONS(1145),
    [sym__thematic_break] = ACTIONS(1145),
    [sym__list_marker_minus] = ACTIONS(1145),
    [sym__list_marker_plus] = ACTIONS(1145),
    [sym__list_marker_star] = ACTIONS(1145),
    [sym__list_marker_parenthesis] = ACTIONS(1145),
    [sym__list_marker_dot] = ACTIONS(1145),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1145),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1145),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1145),
    [sym__blank_line_start] = ACTIONS(1145),
    [sym__html_block_1_start] = ACTIONS(1145),
    [sym__html_block_2_start] = ACTIONS(1145),
    [sym__html_block_3_start] = ACTIONS(1145),
    [sym__html_block_4_start] = ACTIONS(1145),
    [sym__html_block_5_start] = ACTIONS(1145),
    [sym__html_block_6_start] = ACTIONS(1145),
    [sym__html_block_7_start] = ACTIONS(1145),
    [sym__pipe_table_start] = ACTIONS(1145),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym__] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [aux_sym__word_token1] = ACTIONS(1384),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1384),
    [aux_sym__word_token2] = ACTIONS(1384),
    [sym__whitespace] = ACTIONS(1384),
    [sym__soft_line_ending] = ACTIONS(1384),
    [sym__block_quote_start] = ACTIONS(1384),
    [sym__indented_chunk_start] = ACTIONS(1384),
    [sym_atx_h1_marker] = ACTIONS(1384),
    [sym_atx_h2_marker] = ACTIONS(1384),
    [sym_atx_h3_marker] = ACTIONS(1384),
    [sym_atx_h4_marker] = ACTIONS(1384),
    [sym_atx_h5_marker] = ACTIONS(1384),
    [sym_atx_h6_marker] = ACTIONS(1384),
    [sym__thematic_break] = ACTIONS(1384),
    [sym__list_marker_minus] = ACTIONS(1384),
    [sym__list_marker_plus] = ACTIONS(1384),
    [sym__list_marker_star] = ACTIONS(1384),
    [sym__list_marker_parenthesis] = ACTIONS(1384),
    [sym__list_marker_dot] = ACTIONS(1384),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1384),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1384),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1384),
    [sym__blank_line_start] = ACTIONS(1384),
    [sym__html_block_1_start] = ACTIONS(1384),
    [sym__html_block_2_start] = ACTIONS(1384),
    [sym__html_block_3_start] = ACTIONS(1384),
    [sym__html_block_4_start] = ACTIONS(1384),
    [sym__html_block_5_start] = ACTIONS(1384),
    [sym__html_block_6_start] = ACTIONS(1384),
    [sym__html_block_7_start] = ACTIONS(1384),
    [sym__pipe_table_start] = ACTIONS(1384),
  },
  [194] = {
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1564),
    [anon_sym_DQUOTE] = ACTIONS(1564),
    [anon_sym_POUND] = ACTIONS(1564),
    [anon_sym_DOLLAR] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1564),
    [anon_sym_SQUOTE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_EQ] = ACTIONS(1564),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1564),
    [anon_sym_BSLASH] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym__] = ACTIONS(1564),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [aux_sym__word_token1] = ACTIONS(1564),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1564),
    [aux_sym__word_token2] = ACTIONS(1564),
    [sym__whitespace] = ACTIONS(1564),
    [sym__soft_line_ending] = ACTIONS(1564),
    [sym__block_close] = ACTIONS(1564),
    [sym__block_quote_start] = ACTIONS(1564),
    [sym__indented_chunk_start] = ACTIONS(1564),
    [sym_atx_h1_marker] = ACTIONS(1564),
    [sym_atx_h2_marker] = ACTIONS(1564),
    [sym_atx_h3_marker] = ACTIONS(1564),
    [sym_atx_h4_marker] = ACTIONS(1564),
    [sym_atx_h5_marker] = ACTIONS(1564),
    [sym_atx_h6_marker] = ACTIONS(1564),
    [sym__thematic_break] = ACTIONS(1564),
    [sym__list_marker_minus] = ACTIONS(1564),
    [sym__list_marker_plus] = ACTIONS(1564),
    [sym__list_marker_star] = ACTIONS(1564),
    [sym__list_marker_parenthesis] = ACTIONS(1564),
    [sym__list_marker_dot] = ACTIONS(1564),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1564),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1564),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1564),
    [sym__blank_line_start] = ACTIONS(1564),
    [sym__html_block_1_start] = ACTIONS(1564),
    [sym__html_block_2_start] = ACTIONS(1564),
    [sym__html_block_3_start] = ACTIONS(1564),
    [sym__html_block_4_start] = ACTIONS(1564),
    [sym__html_block_5_start] = ACTIONS(1564),
    [sym__html_block_6_start] = ACTIONS(1564),
    [sym__html_block_7_start] = ACTIONS(1564),
    [sym__pipe_table_start] = ACTIONS(1564),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(1566),
    [anon_sym_DOLLAR] = ACTIONS(1566),
    [anon_sym_PERCENT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1566),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_DOT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [anon_sym_COLON] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1566),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_BSLASH] = ACTIONS(1566),
    [anon_sym_CARET] = ACTIONS(1566),
    [anon_sym__] = ACTIONS(1566),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1566),
    [aux_sym__word_token1] = ACTIONS(1566),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1566),
    [aux_sym__word_token2] = ACTIONS(1566),
    [sym__whitespace] = ACTIONS(1566),
    [sym__soft_line_ending] = ACTIONS(1566),
    [sym__block_quote_start] = ACTIONS(1566),
    [sym__indented_chunk_start] = ACTIONS(1566),
    [sym_atx_h1_marker] = ACTIONS(1566),
    [sym_atx_h2_marker] = ACTIONS(1566),
    [sym_atx_h3_marker] = ACTIONS(1566),
    [sym_atx_h4_marker] = ACTIONS(1566),
    [sym_atx_h5_marker] = ACTIONS(1566),
    [sym_atx_h6_marker] = ACTIONS(1566),
    [sym__thematic_break] = ACTIONS(1566),
    [sym__list_marker_minus] = ACTIONS(1566),
    [sym__list_marker_plus] = ACTIONS(1566),
    [sym__list_marker_star] = ACTIONS(1566),
    [sym__list_marker_parenthesis] = ACTIONS(1566),
    [sym__list_marker_dot] = ACTIONS(1566),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1566),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1566),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1566),
    [sym__blank_line_start] = ACTIONS(1566),
    [sym__html_block_1_start] = ACTIONS(1566),
    [sym__html_block_2_start] = ACTIONS(1566),
    [sym__html_block_3_start] = ACTIONS(1566),
    [sym__html_block_4_start] = ACTIONS(1566),
    [sym__html_block_5_start] = ACTIONS(1566),
    [sym__html_block_6_start] = ACTIONS(1566),
    [sym__html_block_7_start] = ACTIONS(1566),
    [sym__pipe_table_start] = ACTIONS(1566),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [anon_sym_POUND] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_COMMA] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DOT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_BSLASH] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym__] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [aux_sym__word_token1] = ACTIONS(1540),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1540),
    [aux_sym__word_token2] = ACTIONS(1540),
    [sym__whitespace] = ACTIONS(1540),
    [sym__soft_line_ending] = ACTIONS(1540),
    [sym__block_quote_start] = ACTIONS(1540),
    [sym__indented_chunk_start] = ACTIONS(1540),
    [sym_atx_h1_marker] = ACTIONS(1540),
    [sym_atx_h2_marker] = ACTIONS(1540),
    [sym_atx_h3_marker] = ACTIONS(1540),
    [sym_atx_h4_marker] = ACTIONS(1540),
    [sym_atx_h5_marker] = ACTIONS(1540),
    [sym_atx_h6_marker] = ACTIONS(1540),
    [sym__thematic_break] = ACTIONS(1540),
    [sym__list_marker_minus] = ACTIONS(1540),
    [sym__list_marker_plus] = ACTIONS(1540),
    [sym__list_marker_star] = ACTIONS(1540),
    [sym__list_marker_parenthesis] = ACTIONS(1540),
    [sym__list_marker_dot] = ACTIONS(1540),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1540),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1540),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1540),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1540),
    [sym__blank_line_start] = ACTIONS(1540),
    [sym__html_block_1_start] = ACTIONS(1540),
    [sym__html_block_2_start] = ACTIONS(1540),
    [sym__html_block_3_start] = ACTIONS(1540),
    [sym__html_block_4_start] = ACTIONS(1540),
    [sym__html_block_5_start] = ACTIONS(1540),
    [sym__html_block_6_start] = ACTIONS(1540),
    [sym__html_block_7_start] = ACTIONS(1540),
    [sym__pipe_table_start] = ACTIONS(1540),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(1570),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_POUND] = ACTIONS(1570),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_PERCENT] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_DOT] = ACTIONS(1570),
    [anon_sym_SLASH] = ACTIONS(1570),
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_EQ] = ACTIONS(1570),
    [anon_sym_QMARK] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_CARET] = ACTIONS(1570),
    [anon_sym__] = ACTIONS(1570),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [aux_sym__word_token1] = ACTIONS(1570),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1570),
    [aux_sym__word_token2] = ACTIONS(1570),
    [sym__whitespace] = ACTIONS(1570),
    [sym__soft_line_ending] = ACTIONS(1570),
    [sym__block_quote_start] = ACTIONS(1570),
    [sym__indented_chunk_start] = ACTIONS(1570),
    [sym_atx_h1_marker] = ACTIONS(1570),
    [sym_atx_h2_marker] = ACTIONS(1570),
    [sym_atx_h3_marker] = ACTIONS(1570),
    [sym_atx_h4_marker] = ACTIONS(1570),
    [sym_atx_h5_marker] = ACTIONS(1570),
    [sym_atx_h6_marker] = ACTIONS(1570),
    [sym__thematic_break] = ACTIONS(1570),
    [sym__list_marker_minus] = ACTIONS(1570),
    [sym__list_marker_plus] = ACTIONS(1570),
    [sym__list_marker_star] = ACTIONS(1570),
    [sym__list_marker_parenthesis] = ACTIONS(1570),
    [sym__list_marker_dot] = ACTIONS(1570),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1570),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1570),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1570),
    [sym__blank_line_start] = ACTIONS(1570),
    [sym__html_block_1_start] = ACTIONS(1570),
    [sym__html_block_2_start] = ACTIONS(1570),
    [sym__html_block_3_start] = ACTIONS(1570),
    [sym__html_block_4_start] = ACTIONS(1570),
    [sym__html_block_5_start] = ACTIONS(1570),
    [sym__html_block_6_start] = ACTIONS(1570),
    [sym__html_block_7_start] = ACTIONS(1570),
    [sym__pipe_table_start] = ACTIONS(1570),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_POUND] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(1574),
    [anon_sym_PERCENT] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1574),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_DOT] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_EQ] = ACTIONS(1574),
    [anon_sym_QMARK] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(1574),
    [anon_sym_BSLASH] = ACTIONS(1574),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym__] = ACTIONS(1574),
    [anon_sym_BQUOTE] = ACTIONS(1574),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1574),
    [aux_sym__word_token1] = ACTIONS(1574),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1574),
    [aux_sym__word_token2] = ACTIONS(1574),
    [sym__whitespace] = ACTIONS(1574),
    [sym__soft_line_ending] = ACTIONS(1574),
    [sym__block_quote_start] = ACTIONS(1574),
    [sym__indented_chunk_start] = ACTIONS(1574),
    [sym_atx_h1_marker] = ACTIONS(1574),
    [sym_atx_h2_marker] = ACTIONS(1574),
    [sym_atx_h3_marker] = ACTIONS(1574),
    [sym_atx_h4_marker] = ACTIONS(1574),
    [sym_atx_h5_marker] = ACTIONS(1574),
    [sym_atx_h6_marker] = ACTIONS(1574),
    [sym__thematic_break] = ACTIONS(1574),
    [sym__list_marker_minus] = ACTIONS(1574),
    [sym__list_marker_plus] = ACTIONS(1574),
    [sym__list_marker_star] = ACTIONS(1574),
    [sym__list_marker_parenthesis] = ACTIONS(1574),
    [sym__list_marker_dot] = ACTIONS(1574),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1574),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1574),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1574),
    [sym__blank_line_start] = ACTIONS(1574),
    [sym__html_block_1_start] = ACTIONS(1574),
    [sym__html_block_2_start] = ACTIONS(1574),
    [sym__html_block_3_start] = ACTIONS(1574),
    [sym__html_block_4_start] = ACTIONS(1574),
    [sym__html_block_5_start] = ACTIONS(1574),
    [sym__html_block_6_start] = ACTIONS(1574),
    [sym__html_block_7_start] = ACTIONS(1574),
    [sym__pipe_table_start] = ACTIONS(1574),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1580),
    [anon_sym_RBRACK] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_POUND] = ACTIONS(1578),
    [anon_sym_DOLLAR] = ACTIONS(1578),
    [anon_sym_PERCENT] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_DOT] = ACTIONS(1578),
    [anon_sym_SLASH] = ACTIONS(1578),
    [anon_sym_COLON] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_EQ] = ACTIONS(1578),
    [anon_sym_QMARK] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_BSLASH] = ACTIONS(1578),
    [anon_sym_CARET] = ACTIONS(1578),
    [anon_sym__] = ACTIONS(1578),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [aux_sym__word_token1] = ACTIONS(1578),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1578),
    [aux_sym__word_token2] = ACTIONS(1578),
    [sym__whitespace] = ACTIONS(1578),
    [sym__soft_line_ending] = ACTIONS(1578),
    [sym__block_quote_start] = ACTIONS(1578),
    [sym__indented_chunk_start] = ACTIONS(1578),
    [sym_atx_h1_marker] = ACTIONS(1578),
    [sym_atx_h2_marker] = ACTIONS(1578),
    [sym_atx_h3_marker] = ACTIONS(1578),
    [sym_atx_h4_marker] = ACTIONS(1578),
    [sym_atx_h5_marker] = ACTIONS(1578),
    [sym_atx_h6_marker] = ACTIONS(1578),
    [sym__thematic_break] = ACTIONS(1578),
    [sym__list_marker_minus] = ACTIONS(1578),
    [sym__list_marker_plus] = ACTIONS(1578),
    [sym__list_marker_star] = ACTIONS(1578),
    [sym__list_marker_parenthesis] = ACTIONS(1578),
    [sym__list_marker_dot] = ACTIONS(1578),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1578),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1578),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1578),
    [sym__blank_line_start] = ACTIONS(1578),
    [sym__html_block_1_start] = ACTIONS(1578),
    [sym__html_block_2_start] = ACTIONS(1578),
    [sym__html_block_3_start] = ACTIONS(1578),
    [sym__html_block_4_start] = ACTIONS(1578),
    [sym__html_block_5_start] = ACTIONS(1578),
    [sym__html_block_6_start] = ACTIONS(1578),
    [sym__html_block_7_start] = ACTIONS(1578),
    [sym__pipe_table_start] = ACTIONS(1578),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(1582),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_RBRACK] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(1582),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [anon_sym_POUND] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(1582),
    [anon_sym_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1582),
    [anon_sym_SQUOTE] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_AT] = ACTIONS(1582),
    [anon_sym_BSLASH] = ACTIONS(1582),
    [anon_sym_CARET] = ACTIONS(1582),
    [anon_sym__] = ACTIONS(1582),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_LPAREN] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [aux_sym__word_token1] = ACTIONS(1582),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1582),
    [aux_sym__word_token2] = ACTIONS(1582),
    [sym__whitespace] = ACTIONS(1582),
    [sym__soft_line_ending] = ACTIONS(1582),
    [sym__block_quote_start] = ACTIONS(1582),
    [sym__indented_chunk_start] = ACTIONS(1582),
    [sym_atx_h1_marker] = ACTIONS(1582),
    [sym_atx_h2_marker] = ACTIONS(1582),
    [sym_atx_h3_marker] = ACTIONS(1582),
    [sym_atx_h4_marker] = ACTIONS(1582),
    [sym_atx_h5_marker] = ACTIONS(1582),
    [sym_atx_h6_marker] = ACTIONS(1582),
    [sym__thematic_break] = ACTIONS(1582),
    [sym__list_marker_minus] = ACTIONS(1582),
    [sym__list_marker_plus] = ACTIONS(1582),
    [sym__list_marker_star] = ACTIONS(1582),
    [sym__list_marker_parenthesis] = ACTIONS(1582),
    [sym__list_marker_dot] = ACTIONS(1582),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1582),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1582),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1582),
    [sym__blank_line_start] = ACTIONS(1582),
    [sym__html_block_1_start] = ACTIONS(1582),
    [sym__html_block_2_start] = ACTIONS(1582),
    [sym__html_block_3_start] = ACTIONS(1582),
    [sym__html_block_4_start] = ACTIONS(1582),
    [sym__html_block_5_start] = ACTIONS(1582),
    [sym__html_block_6_start] = ACTIONS(1582),
    [sym__html_block_7_start] = ACTIONS(1582),
    [sym__pipe_table_start] = ACTIONS(1582),
  },
  [201] = {
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_RBRACK] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1588),
    [anon_sym_POUND] = ACTIONS(1588),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_PERCENT] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SQUOTE] = ACTIONS(1588),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_COMMA] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_DOT] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_COLON] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1588),
    [anon_sym_QMARK] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1588),
    [anon_sym_BSLASH] = ACTIONS(1588),
    [anon_sym_CARET] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1588),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1588),
    [aux_sym__word_token1] = ACTIONS(1588),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1588),
    [aux_sym__word_token2] = ACTIONS(1588),
    [sym__whitespace] = ACTIONS(1588),
    [sym__soft_line_ending] = ACTIONS(1588),
    [sym__block_close] = ACTIONS(1588),
    [sym__block_quote_start] = ACTIONS(1588),
    [sym__indented_chunk_start] = ACTIONS(1588),
    [sym_atx_h1_marker] = ACTIONS(1588),
    [sym_atx_h2_marker] = ACTIONS(1588),
    [sym_atx_h3_marker] = ACTIONS(1588),
    [sym_atx_h4_marker] = ACTIONS(1588),
    [sym_atx_h5_marker] = ACTIONS(1588),
    [sym_atx_h6_marker] = ACTIONS(1588),
    [sym__thematic_break] = ACTIONS(1588),
    [sym__list_marker_minus] = ACTIONS(1588),
    [sym__list_marker_plus] = ACTIONS(1588),
    [sym__list_marker_star] = ACTIONS(1588),
    [sym__list_marker_parenthesis] = ACTIONS(1588),
    [sym__list_marker_dot] = ACTIONS(1588),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1588),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1588),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1588),
    [sym__blank_line_start] = ACTIONS(1588),
    [sym__html_block_1_start] = ACTIONS(1588),
    [sym__html_block_2_start] = ACTIONS(1588),
    [sym__html_block_3_start] = ACTIONS(1588),
    [sym__html_block_4_start] = ACTIONS(1588),
    [sym__html_block_5_start] = ACTIONS(1588),
    [sym__html_block_6_start] = ACTIONS(1588),
    [sym__html_block_7_start] = ACTIONS(1588),
    [sym__pipe_table_start] = ACTIONS(1588),
  },
  [202] = {
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_RBRACK] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1592),
    [anon_sym_GT] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1592),
    [anon_sym_DQUOTE] = ACTIONS(1592),
    [anon_sym_POUND] = ACTIONS(1592),
    [anon_sym_DOLLAR] = ACTIONS(1592),
    [anon_sym_PERCENT] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1592),
    [anon_sym_SQUOTE] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_COMMA] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_DOT] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1592),
    [anon_sym_QMARK] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1592),
    [anon_sym_BSLASH] = ACTIONS(1592),
    [anon_sym_CARET] = ACTIONS(1592),
    [anon_sym__] = ACTIONS(1592),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1592),
    [anon_sym_PIPE] = ACTIONS(1592),
    [anon_sym_RBRACE] = ACTIONS(1592),
    [anon_sym_TILDE] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1592),
    [anon_sym_RPAREN] = ACTIONS(1592),
    [aux_sym__word_token1] = ACTIONS(1592),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1592),
    [aux_sym__word_token2] = ACTIONS(1592),
    [sym__whitespace] = ACTIONS(1592),
    [sym__soft_line_ending] = ACTIONS(1592),
    [sym__block_close] = ACTIONS(1592),
    [sym__block_quote_start] = ACTIONS(1592),
    [sym__indented_chunk_start] = ACTIONS(1592),
    [sym_atx_h1_marker] = ACTIONS(1592),
    [sym_atx_h2_marker] = ACTIONS(1592),
    [sym_atx_h3_marker] = ACTIONS(1592),
    [sym_atx_h4_marker] = ACTIONS(1592),
    [sym_atx_h5_marker] = ACTIONS(1592),
    [sym_atx_h6_marker] = ACTIONS(1592),
    [sym__thematic_break] = ACTIONS(1592),
    [sym__list_marker_minus] = ACTIONS(1592),
    [sym__list_marker_plus] = ACTIONS(1592),
    [sym__list_marker_star] = ACTIONS(1592),
    [sym__list_marker_parenthesis] = ACTIONS(1592),
    [sym__list_marker_dot] = ACTIONS(1592),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1592),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1592),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1592),
    [sym__blank_line_start] = ACTIONS(1592),
    [sym__html_block_1_start] = ACTIONS(1592),
    [sym__html_block_2_start] = ACTIONS(1592),
    [sym__html_block_3_start] = ACTIONS(1592),
    [sym__html_block_4_start] = ACTIONS(1592),
    [sym__html_block_5_start] = ACTIONS(1592),
    [sym__html_block_6_start] = ACTIONS(1592),
    [sym__html_block_7_start] = ACTIONS(1592),
    [sym__pipe_table_start] = ACTIONS(1592),
  },
  [203] = {
    [anon_sym_LBRACK] = ACTIONS(1187),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_POUND] = ACTIONS(1189),
    [anon_sym_DOLLAR] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_BSLASH] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym__] = ACTIONS(1189),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [aux_sym__word_token1] = ACTIONS(1189),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1189),
    [aux_sym__word_token2] = ACTIONS(1189),
    [sym__whitespace] = ACTIONS(1189),
    [sym__soft_line_ending] = ACTIONS(1189),
    [sym__block_close] = ACTIONS(1189),
    [sym__block_quote_start] = ACTIONS(1189),
    [sym__indented_chunk_start] = ACTIONS(1189),
    [sym_atx_h1_marker] = ACTIONS(1189),
    [sym_atx_h2_marker] = ACTIONS(1189),
    [sym_atx_h3_marker] = ACTIONS(1189),
    [sym_atx_h4_marker] = ACTIONS(1189),
    [sym_atx_h5_marker] = ACTIONS(1189),
    [sym_atx_h6_marker] = ACTIONS(1189),
    [sym__thematic_break] = ACTIONS(1189),
    [sym__list_marker_minus] = ACTIONS(1189),
    [sym__list_marker_plus] = ACTIONS(1189),
    [sym__list_marker_star] = ACTIONS(1189),
    [sym__list_marker_parenthesis] = ACTIONS(1189),
    [sym__list_marker_dot] = ACTIONS(1189),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1189),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1189),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1189),
    [sym__blank_line_start] = ACTIONS(1189),
    [sym__html_block_1_start] = ACTIONS(1189),
    [sym__html_block_2_start] = ACTIONS(1189),
    [sym__html_block_3_start] = ACTIONS(1189),
    [sym__html_block_4_start] = ACTIONS(1189),
    [sym__html_block_5_start] = ACTIONS(1189),
    [sym__html_block_6_start] = ACTIONS(1189),
    [sym__html_block_7_start] = ACTIONS(1189),
    [sym__pipe_table_start] = ACTIONS(1189),
  },
  [204] = {
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_RBRACK] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_BANG] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1596),
    [anon_sym_POUND] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(1596),
    [anon_sym_PERCENT] = ACTIONS(1596),
    [anon_sym_AMP] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_STAR] = ACTIONS(1596),
    [anon_sym_PLUS] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_DOT] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1596),
    [anon_sym_COLON] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_QMARK] = ACTIONS(1596),
    [anon_sym_AT] = ACTIONS(1596),
    [anon_sym_BSLASH] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym__] = ACTIONS(1596),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_RBRACE] = ACTIONS(1596),
    [anon_sym_TILDE] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1596),
    [aux_sym__word_token1] = ACTIONS(1596),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1596),
    [aux_sym__word_token2] = ACTIONS(1596),
    [sym__whitespace] = ACTIONS(1596),
    [sym__soft_line_ending] = ACTIONS(1596),
    [sym__block_close] = ACTIONS(1596),
    [sym__block_quote_start] = ACTIONS(1596),
    [sym__indented_chunk_start] = ACTIONS(1596),
    [sym_atx_h1_marker] = ACTIONS(1596),
    [sym_atx_h2_marker] = ACTIONS(1596),
    [sym_atx_h3_marker] = ACTIONS(1596),
    [sym_atx_h4_marker] = ACTIONS(1596),
    [sym_atx_h5_marker] = ACTIONS(1596),
    [sym_atx_h6_marker] = ACTIONS(1596),
    [sym__thematic_break] = ACTIONS(1596),
    [sym__list_marker_minus] = ACTIONS(1596),
    [sym__list_marker_plus] = ACTIONS(1596),
    [sym__list_marker_star] = ACTIONS(1596),
    [sym__list_marker_parenthesis] = ACTIONS(1596),
    [sym__list_marker_dot] = ACTIONS(1596),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1596),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1596),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1596),
    [sym__blank_line_start] = ACTIONS(1596),
    [sym__html_block_1_start] = ACTIONS(1596),
    [sym__html_block_2_start] = ACTIONS(1596),
    [sym__html_block_3_start] = ACTIONS(1596),
    [sym__html_block_4_start] = ACTIONS(1596),
    [sym__html_block_5_start] = ACTIONS(1596),
    [sym__html_block_6_start] = ACTIONS(1596),
    [sym__html_block_7_start] = ACTIONS(1596),
    [sym__pipe_table_start] = ACTIONS(1596),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(1598),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(1598),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_BANG] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_POUND] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1598),
    [anon_sym_AMP] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_PLUS] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1598),
    [anon_sym_DASH] = ACTIONS(1598),
    [anon_sym_DOT] = ACTIONS(1598),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_COLON] = ACTIONS(1598),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_EQ] = ACTIONS(1598),
    [anon_sym_QMARK] = ACTIONS(1598),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_BSLASH] = ACTIONS(1598),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym__] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [aux_sym__word_token1] = ACTIONS(1598),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1598),
    [aux_sym__word_token2] = ACTIONS(1598),
    [sym__whitespace] = ACTIONS(1598),
    [sym__soft_line_ending] = ACTIONS(1598),
    [sym__block_quote_start] = ACTIONS(1598),
    [sym__indented_chunk_start] = ACTIONS(1598),
    [sym_atx_h1_marker] = ACTIONS(1598),
    [sym_atx_h2_marker] = ACTIONS(1598),
    [sym_atx_h3_marker] = ACTIONS(1598),
    [sym_atx_h4_marker] = ACTIONS(1598),
    [sym_atx_h5_marker] = ACTIONS(1598),
    [sym_atx_h6_marker] = ACTIONS(1598),
    [sym__thematic_break] = ACTIONS(1598),
    [sym__list_marker_minus] = ACTIONS(1598),
    [sym__list_marker_plus] = ACTIONS(1598),
    [sym__list_marker_star] = ACTIONS(1598),
    [sym__list_marker_parenthesis] = ACTIONS(1598),
    [sym__list_marker_dot] = ACTIONS(1598),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1598),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1598),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1598),
    [sym__blank_line_start] = ACTIONS(1598),
    [sym__html_block_1_start] = ACTIONS(1598),
    [sym__html_block_2_start] = ACTIONS(1598),
    [sym__html_block_3_start] = ACTIONS(1598),
    [sym__html_block_4_start] = ACTIONS(1598),
    [sym__html_block_5_start] = ACTIONS(1598),
    [sym__html_block_6_start] = ACTIONS(1598),
    [sym__html_block_7_start] = ACTIONS(1598),
    [sym__pipe_table_start] = ACTIONS(1598),
  },
  [206] = {
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_DQUOTE] = ACTIONS(1604),
    [anon_sym_POUND] = ACTIONS(1604),
    [anon_sym_DOLLAR] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_SQUOTE] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_DOT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1604),
    [anon_sym_EQ] = ACTIONS(1604),
    [anon_sym_QMARK] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_BSLASH] = ACTIONS(1604),
    [anon_sym_CARET] = ACTIONS(1604),
    [anon_sym__] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1604),
    [anon_sym_PIPE] = ACTIONS(1604),
    [anon_sym_RBRACE] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1604),
    [anon_sym_RPAREN] = ACTIONS(1604),
    [aux_sym__word_token1] = ACTIONS(1604),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1604),
    [aux_sym__word_token2] = ACTIONS(1604),
    [sym__whitespace] = ACTIONS(1604),
    [sym__soft_line_ending] = ACTIONS(1604),
    [sym__block_close] = ACTIONS(1604),
    [sym__block_quote_start] = ACTIONS(1604),
    [sym__indented_chunk_start] = ACTIONS(1604),
    [sym_atx_h1_marker] = ACTIONS(1604),
    [sym_atx_h2_marker] = ACTIONS(1604),
    [sym_atx_h3_marker] = ACTIONS(1604),
    [sym_atx_h4_marker] = ACTIONS(1604),
    [sym_atx_h5_marker] = ACTIONS(1604),
    [sym_atx_h6_marker] = ACTIONS(1604),
    [sym__thematic_break] = ACTIONS(1604),
    [sym__list_marker_minus] = ACTIONS(1604),
    [sym__list_marker_plus] = ACTIONS(1604),
    [sym__list_marker_star] = ACTIONS(1604),
    [sym__list_marker_parenthesis] = ACTIONS(1604),
    [sym__list_marker_dot] = ACTIONS(1604),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1604),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1604),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1604),
    [sym__blank_line_start] = ACTIONS(1604),
    [sym__html_block_1_start] = ACTIONS(1604),
    [sym__html_block_2_start] = ACTIONS(1604),
    [sym__html_block_3_start] = ACTIONS(1604),
    [sym__html_block_4_start] = ACTIONS(1604),
    [sym__html_block_5_start] = ACTIONS(1604),
    [sym__html_block_6_start] = ACTIONS(1604),
    [sym__html_block_7_start] = ACTIONS(1604),
    [sym__pipe_table_start] = ACTIONS(1604),
  },
  [207] = {
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_POUND] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym__] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [aux_sym__word_token1] = ACTIONS(1230),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1230),
    [aux_sym__word_token2] = ACTIONS(1230),
    [sym__whitespace] = ACTIONS(1230),
    [sym__soft_line_ending] = ACTIONS(1230),
    [sym__block_close] = ACTIONS(1230),
    [sym__block_quote_start] = ACTIONS(1230),
    [sym__indented_chunk_start] = ACTIONS(1230),
    [sym_atx_h1_marker] = ACTIONS(1230),
    [sym_atx_h2_marker] = ACTIONS(1230),
    [sym_atx_h3_marker] = ACTIONS(1230),
    [sym_atx_h4_marker] = ACTIONS(1230),
    [sym_atx_h5_marker] = ACTIONS(1230),
    [sym_atx_h6_marker] = ACTIONS(1230),
    [sym__thematic_break] = ACTIONS(1230),
    [sym__list_marker_minus] = ACTIONS(1230),
    [sym__list_marker_plus] = ACTIONS(1230),
    [sym__list_marker_star] = ACTIONS(1230),
    [sym__list_marker_parenthesis] = ACTIONS(1230),
    [sym__list_marker_dot] = ACTIONS(1230),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1230),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1230),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1230),
    [sym__blank_line_start] = ACTIONS(1230),
    [sym__html_block_1_start] = ACTIONS(1230),
    [sym__html_block_2_start] = ACTIONS(1230),
    [sym__html_block_3_start] = ACTIONS(1230),
    [sym__html_block_4_start] = ACTIONS(1230),
    [sym__html_block_5_start] = ACTIONS(1230),
    [sym__html_block_6_start] = ACTIONS(1230),
    [sym__html_block_7_start] = ACTIONS(1230),
    [sym__pipe_table_start] = ACTIONS(1230),
  },
  [208] = {
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_POUND] = ACTIONS(1608),
    [anon_sym_DOLLAR] = ACTIONS(1608),
    [anon_sym_PERCENT] = ACTIONS(1608),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_SQUOTE] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_QMARK] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_BSLASH] = ACTIONS(1608),
    [anon_sym_CARET] = ACTIONS(1608),
    [anon_sym__] = ACTIONS(1608),
    [anon_sym_BQUOTE] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_TILDE] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_RPAREN] = ACTIONS(1608),
    [aux_sym__word_token1] = ACTIONS(1608),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1608),
    [aux_sym__word_token2] = ACTIONS(1608),
    [sym__whitespace] = ACTIONS(1608),
    [sym__soft_line_ending] = ACTIONS(1608),
    [sym__block_close] = ACTIONS(1608),
    [sym__block_quote_start] = ACTIONS(1608),
    [sym__indented_chunk_start] = ACTIONS(1608),
    [sym_atx_h1_marker] = ACTIONS(1608),
    [sym_atx_h2_marker] = ACTIONS(1608),
    [sym_atx_h3_marker] = ACTIONS(1608),
    [sym_atx_h4_marker] = ACTIONS(1608),
    [sym_atx_h5_marker] = ACTIONS(1608),
    [sym_atx_h6_marker] = ACTIONS(1608),
    [sym__thematic_break] = ACTIONS(1608),
    [sym__list_marker_minus] = ACTIONS(1608),
    [sym__list_marker_plus] = ACTIONS(1608),
    [sym__list_marker_star] = ACTIONS(1608),
    [sym__list_marker_parenthesis] = ACTIONS(1608),
    [sym__list_marker_dot] = ACTIONS(1608),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1608),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1608),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1608),
    [sym__blank_line_start] = ACTIONS(1608),
    [sym__html_block_1_start] = ACTIONS(1608),
    [sym__html_block_2_start] = ACTIONS(1608),
    [sym__html_block_3_start] = ACTIONS(1608),
    [sym__html_block_4_start] = ACTIONS(1608),
    [sym__html_block_5_start] = ACTIONS(1608),
    [sym__html_block_6_start] = ACTIONS(1608),
    [sym__html_block_7_start] = ACTIONS(1608),
    [sym__pipe_table_start] = ACTIONS(1608),
  },
  [209] = {
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(1612),
    [anon_sym_GT] = ACTIONS(1612),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1612),
    [anon_sym_PERCENT] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_SQUOTE] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_COMMA] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_SLASH] = ACTIONS(1612),
    [anon_sym_COLON] = ACTIONS(1612),
    [anon_sym_SEMI] = ACTIONS(1612),
    [anon_sym_EQ] = ACTIONS(1612),
    [anon_sym_QMARK] = ACTIONS(1612),
    [anon_sym_AT] = ACTIONS(1612),
    [anon_sym_BSLASH] = ACTIONS(1612),
    [anon_sym_CARET] = ACTIONS(1612),
    [anon_sym__] = ACTIONS(1612),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [anon_sym_LBRACE] = ACTIONS(1612),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1612),
    [anon_sym_TILDE] = ACTIONS(1612),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_RPAREN] = ACTIONS(1612),
    [aux_sym__word_token1] = ACTIONS(1612),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1612),
    [aux_sym__word_token2] = ACTIONS(1612),
    [sym__whitespace] = ACTIONS(1612),
    [sym__soft_line_ending] = ACTIONS(1612),
    [sym__block_close] = ACTIONS(1612),
    [sym__block_quote_start] = ACTIONS(1612),
    [sym__indented_chunk_start] = ACTIONS(1612),
    [sym_atx_h1_marker] = ACTIONS(1612),
    [sym_atx_h2_marker] = ACTIONS(1612),
    [sym_atx_h3_marker] = ACTIONS(1612),
    [sym_atx_h4_marker] = ACTIONS(1612),
    [sym_atx_h5_marker] = ACTIONS(1612),
    [sym_atx_h6_marker] = ACTIONS(1612),
    [sym__thematic_break] = ACTIONS(1612),
    [sym__list_marker_minus] = ACTIONS(1612),
    [sym__list_marker_plus] = ACTIONS(1612),
    [sym__list_marker_star] = ACTIONS(1612),
    [sym__list_marker_parenthesis] = ACTIONS(1612),
    [sym__list_marker_dot] = ACTIONS(1612),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1612),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1612),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1612),
    [sym__blank_line_start] = ACTIONS(1612),
    [sym__html_block_1_start] = ACTIONS(1612),
    [sym__html_block_2_start] = ACTIONS(1612),
    [sym__html_block_3_start] = ACTIONS(1612),
    [sym__html_block_4_start] = ACTIONS(1612),
    [sym__html_block_5_start] = ACTIONS(1612),
    [sym__html_block_6_start] = ACTIONS(1612),
    [sym__html_block_7_start] = ACTIONS(1612),
    [sym__pipe_table_start] = ACTIONS(1612),
  },
  [210] = {
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_RBRACK] = ACTIONS(1616),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_GT] = ACTIONS(1616),
    [anon_sym_BANG] = ACTIONS(1616),
    [anon_sym_DQUOTE] = ACTIONS(1616),
    [anon_sym_POUND] = ACTIONS(1616),
    [anon_sym_DOLLAR] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DOT] = ACTIONS(1616),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1616),
    [anon_sym_EQ] = ACTIONS(1616),
    [anon_sym_QMARK] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(1616),
    [anon_sym_BSLASH] = ACTIONS(1616),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym__] = ACTIONS(1616),
    [anon_sym_BQUOTE] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1616),
    [anon_sym_RBRACE] = ACTIONS(1616),
    [anon_sym_TILDE] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1616),
    [aux_sym__word_token1] = ACTIONS(1616),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1616),
    [aux_sym__word_token2] = ACTIONS(1616),
    [sym__whitespace] = ACTIONS(1616),
    [sym__soft_line_ending] = ACTIONS(1616),
    [sym__block_close] = ACTIONS(1616),
    [sym__block_quote_start] = ACTIONS(1616),
    [sym__indented_chunk_start] = ACTIONS(1616),
    [sym_atx_h1_marker] = ACTIONS(1616),
    [sym_atx_h2_marker] = ACTIONS(1616),
    [sym_atx_h3_marker] = ACTIONS(1616),
    [sym_atx_h4_marker] = ACTIONS(1616),
    [sym_atx_h5_marker] = ACTIONS(1616),
    [sym_atx_h6_marker] = ACTIONS(1616),
    [sym__thematic_break] = ACTIONS(1616),
    [sym__list_marker_minus] = ACTIONS(1616),
    [sym__list_marker_plus] = ACTIONS(1616),
    [sym__list_marker_star] = ACTIONS(1616),
    [sym__list_marker_parenthesis] = ACTIONS(1616),
    [sym__list_marker_dot] = ACTIONS(1616),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1616),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1616),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1616),
    [sym__blank_line_start] = ACTIONS(1616),
    [sym__html_block_1_start] = ACTIONS(1616),
    [sym__html_block_2_start] = ACTIONS(1616),
    [sym__html_block_3_start] = ACTIONS(1616),
    [sym__html_block_4_start] = ACTIONS(1616),
    [sym__html_block_5_start] = ACTIONS(1616),
    [sym__html_block_6_start] = ACTIONS(1616),
    [sym__html_block_7_start] = ACTIONS(1616),
    [sym__pipe_table_start] = ACTIONS(1616),
  },
  [211] = {
    [anon_sym_LBRACK] = ACTIONS(1618),
    [anon_sym_RBRACK] = ACTIONS(1620),
    [anon_sym_LT] = ACTIONS(1620),
    [anon_sym_GT] = ACTIONS(1620),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_POUND] = ACTIONS(1620),
    [anon_sym_DOLLAR] = ACTIONS(1620),
    [anon_sym_PERCENT] = ACTIONS(1620),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(1620),
    [anon_sym_PLUS] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_DASH] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1620),
    [anon_sym_SLASH] = ACTIONS(1620),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_EQ] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1620),
    [anon_sym_AT] = ACTIONS(1620),
    [anon_sym_BSLASH] = ACTIONS(1620),
    [anon_sym_CARET] = ACTIONS(1620),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1620),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_TILDE] = ACTIONS(1620),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_RPAREN] = ACTIONS(1620),
    [aux_sym__word_token1] = ACTIONS(1620),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1620),
    [aux_sym__word_token2] = ACTIONS(1620),
    [sym__whitespace] = ACTIONS(1620),
    [sym__soft_line_ending] = ACTIONS(1620),
    [sym__block_close] = ACTIONS(1620),
    [sym__block_quote_start] = ACTIONS(1620),
    [sym__indented_chunk_start] = ACTIONS(1620),
    [sym_atx_h1_marker] = ACTIONS(1620),
    [sym_atx_h2_marker] = ACTIONS(1620),
    [sym_atx_h3_marker] = ACTIONS(1620),
    [sym_atx_h4_marker] = ACTIONS(1620),
    [sym_atx_h5_marker] = ACTIONS(1620),
    [sym_atx_h6_marker] = ACTIONS(1620),
    [sym__thematic_break] = ACTIONS(1620),
    [sym__list_marker_minus] = ACTIONS(1620),
    [sym__list_marker_plus] = ACTIONS(1620),
    [sym__list_marker_star] = ACTIONS(1620),
    [sym__list_marker_parenthesis] = ACTIONS(1620),
    [sym__list_marker_dot] = ACTIONS(1620),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1620),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1620),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1620),
    [sym__blank_line_start] = ACTIONS(1620),
    [sym__html_block_1_start] = ACTIONS(1620),
    [sym__html_block_2_start] = ACTIONS(1620),
    [sym__html_block_3_start] = ACTIONS(1620),
    [sym__html_block_4_start] = ACTIONS(1620),
    [sym__html_block_5_start] = ACTIONS(1620),
    [sym__html_block_6_start] = ACTIONS(1620),
    [sym__html_block_7_start] = ACTIONS(1620),
    [sym__pipe_table_start] = ACTIONS(1620),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym__] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [aux_sym__word_token1] = ACTIONS(1390),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1390),
    [aux_sym__word_token2] = ACTIONS(1390),
    [sym__whitespace] = ACTIONS(1390),
    [sym__soft_line_ending] = ACTIONS(1390),
    [sym__block_quote_start] = ACTIONS(1390),
    [sym__indented_chunk_start] = ACTIONS(1390),
    [sym_atx_h1_marker] = ACTIONS(1390),
    [sym_atx_h2_marker] = ACTIONS(1390),
    [sym_atx_h3_marker] = ACTIONS(1390),
    [sym_atx_h4_marker] = ACTIONS(1390),
    [sym_atx_h5_marker] = ACTIONS(1390),
    [sym_atx_h6_marker] = ACTIONS(1390),
    [sym__thematic_break] = ACTIONS(1390),
    [sym__list_marker_minus] = ACTIONS(1390),
    [sym__list_marker_plus] = ACTIONS(1390),
    [sym__list_marker_star] = ACTIONS(1390),
    [sym__list_marker_parenthesis] = ACTIONS(1390),
    [sym__list_marker_dot] = ACTIONS(1390),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1390),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1390),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1390),
    [sym__blank_line_start] = ACTIONS(1390),
    [sym__html_block_1_start] = ACTIONS(1390),
    [sym__html_block_2_start] = ACTIONS(1390),
    [sym__html_block_3_start] = ACTIONS(1390),
    [sym__html_block_4_start] = ACTIONS(1390),
    [sym__html_block_5_start] = ACTIONS(1390),
    [sym__html_block_6_start] = ACTIONS(1390),
    [sym__html_block_7_start] = ACTIONS(1390),
    [sym__pipe_table_start] = ACTIONS(1390),
  },
  [213] = {
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1624),
    [anon_sym_DOLLAR] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_SQUOTE] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(1624),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_EQ] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1624),
    [anon_sym_AT] = ACTIONS(1624),
    [anon_sym_BSLASH] = ACTIONS(1624),
    [anon_sym_CARET] = ACTIONS(1624),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1624),
    [anon_sym_PIPE] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_TILDE] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [aux_sym__word_token1] = ACTIONS(1624),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1624),
    [aux_sym__word_token2] = ACTIONS(1624),
    [sym__whitespace] = ACTIONS(1624),
    [sym__soft_line_ending] = ACTIONS(1624),
    [sym__block_close] = ACTIONS(1624),
    [sym__block_quote_start] = ACTIONS(1624),
    [sym__indented_chunk_start] = ACTIONS(1624),
    [sym_atx_h1_marker] = ACTIONS(1624),
    [sym_atx_h2_marker] = ACTIONS(1624),
    [sym_atx_h3_marker] = ACTIONS(1624),
    [sym_atx_h4_marker] = ACTIONS(1624),
    [sym_atx_h5_marker] = ACTIONS(1624),
    [sym_atx_h6_marker] = ACTIONS(1624),
    [sym__thematic_break] = ACTIONS(1624),
    [sym__list_marker_minus] = ACTIONS(1624),
    [sym__list_marker_plus] = ACTIONS(1624),
    [sym__list_marker_star] = ACTIONS(1624),
    [sym__list_marker_parenthesis] = ACTIONS(1624),
    [sym__list_marker_dot] = ACTIONS(1624),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1624),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1624),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1624),
    [sym__blank_line_start] = ACTIONS(1624),
    [sym__html_block_1_start] = ACTIONS(1624),
    [sym__html_block_2_start] = ACTIONS(1624),
    [sym__html_block_3_start] = ACTIONS(1624),
    [sym__html_block_4_start] = ACTIONS(1624),
    [sym__html_block_5_start] = ACTIONS(1624),
    [sym__html_block_6_start] = ACTIONS(1624),
    [sym__html_block_7_start] = ACTIONS(1624),
    [sym__pipe_table_start] = ACTIONS(1624),
  },
  [214] = {
    [anon_sym_LBRACK] = ACTIONS(1626),
    [anon_sym_RBRACK] = ACTIONS(1628),
    [anon_sym_LT] = ACTIONS(1628),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_BANG] = ACTIONS(1628),
    [anon_sym_DQUOTE] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_DOLLAR] = ACTIONS(1628),
    [anon_sym_PERCENT] = ACTIONS(1628),
    [anon_sym_AMP] = ACTIONS(1628),
    [anon_sym_SQUOTE] = ACTIONS(1628),
    [anon_sym_STAR] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(1628),
    [anon_sym_DOT] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1628),
    [anon_sym_COLON] = ACTIONS(1628),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_EQ] = ACTIONS(1628),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_AT] = ACTIONS(1628),
    [anon_sym_BSLASH] = ACTIONS(1628),
    [anon_sym_CARET] = ACTIONS(1628),
    [anon_sym__] = ACTIONS(1628),
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [anon_sym_LBRACE] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_TILDE] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1628),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [aux_sym__word_token1] = ACTIONS(1628),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1628),
    [aux_sym__word_token2] = ACTIONS(1628),
    [sym__whitespace] = ACTIONS(1628),
    [sym__soft_line_ending] = ACTIONS(1628),
    [sym__block_close] = ACTIONS(1628),
    [sym__block_quote_start] = ACTIONS(1628),
    [sym__indented_chunk_start] = ACTIONS(1628),
    [sym_atx_h1_marker] = ACTIONS(1628),
    [sym_atx_h2_marker] = ACTIONS(1628),
    [sym_atx_h3_marker] = ACTIONS(1628),
    [sym_atx_h4_marker] = ACTIONS(1628),
    [sym_atx_h5_marker] = ACTIONS(1628),
    [sym_atx_h6_marker] = ACTIONS(1628),
    [sym__thematic_break] = ACTIONS(1628),
    [sym__list_marker_minus] = ACTIONS(1628),
    [sym__list_marker_plus] = ACTIONS(1628),
    [sym__list_marker_star] = ACTIONS(1628),
    [sym__list_marker_parenthesis] = ACTIONS(1628),
    [sym__list_marker_dot] = ACTIONS(1628),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1628),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1628),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1628),
    [sym__blank_line_start] = ACTIONS(1628),
    [sym__html_block_1_start] = ACTIONS(1628),
    [sym__html_block_2_start] = ACTIONS(1628),
    [sym__html_block_3_start] = ACTIONS(1628),
    [sym__html_block_4_start] = ACTIONS(1628),
    [sym__html_block_5_start] = ACTIONS(1628),
    [sym__html_block_6_start] = ACTIONS(1628),
    [sym__html_block_7_start] = ACTIONS(1628),
    [sym__pipe_table_start] = ACTIONS(1628),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_POUND] = ACTIONS(1408),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_COLON] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1408),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(1408),
    [aux_sym__word_token1] = ACTIONS(1408),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1408),
    [aux_sym__word_token2] = ACTIONS(1408),
    [sym__whitespace] = ACTIONS(1408),
    [sym__soft_line_ending] = ACTIONS(1408),
    [sym__block_quote_start] = ACTIONS(1408),
    [sym__indented_chunk_start] = ACTIONS(1408),
    [sym_atx_h1_marker] = ACTIONS(1408),
    [sym_atx_h2_marker] = ACTIONS(1408),
    [sym_atx_h3_marker] = ACTIONS(1408),
    [sym_atx_h4_marker] = ACTIONS(1408),
    [sym_atx_h5_marker] = ACTIONS(1408),
    [sym_atx_h6_marker] = ACTIONS(1408),
    [sym__thematic_break] = ACTIONS(1408),
    [sym__list_marker_minus] = ACTIONS(1408),
    [sym__list_marker_plus] = ACTIONS(1408),
    [sym__list_marker_star] = ACTIONS(1408),
    [sym__list_marker_parenthesis] = ACTIONS(1408),
    [sym__list_marker_dot] = ACTIONS(1408),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1408),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1408),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1408),
    [sym__blank_line_start] = ACTIONS(1408),
    [sym__html_block_1_start] = ACTIONS(1408),
    [sym__html_block_2_start] = ACTIONS(1408),
    [sym__html_block_3_start] = ACTIONS(1408),
    [sym__html_block_4_start] = ACTIONS(1408),
    [sym__html_block_5_start] = ACTIONS(1408),
    [sym__html_block_6_start] = ACTIONS(1408),
    [sym__html_block_7_start] = ACTIONS(1408),
    [sym__pipe_table_start] = ACTIONS(1408),
  },
  [216] = {
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_RBRACK] = ACTIONS(1632),
    [anon_sym_LT] = ACTIONS(1632),
    [anon_sym_GT] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [anon_sym_POUND] = ACTIONS(1632),
    [anon_sym_DOLLAR] = ACTIONS(1632),
    [anon_sym_PERCENT] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1632),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_DASH] = ACTIONS(1632),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_SLASH] = ACTIONS(1632),
    [anon_sym_COLON] = ACTIONS(1632),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(1632),
    [anon_sym_QMARK] = ACTIONS(1632),
    [anon_sym_AT] = ACTIONS(1632),
    [anon_sym_BSLASH] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1632),
    [anon_sym__] = ACTIONS(1632),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_RPAREN] = ACTIONS(1632),
    [aux_sym__word_token1] = ACTIONS(1632),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1632),
    [aux_sym__word_token2] = ACTIONS(1632),
    [sym__whitespace] = ACTIONS(1632),
    [sym__soft_line_ending] = ACTIONS(1632),
    [sym__block_close] = ACTIONS(1632),
    [sym__block_quote_start] = ACTIONS(1632),
    [sym__indented_chunk_start] = ACTIONS(1632),
    [sym_atx_h1_marker] = ACTIONS(1632),
    [sym_atx_h2_marker] = ACTIONS(1632),
    [sym_atx_h3_marker] = ACTIONS(1632),
    [sym_atx_h4_marker] = ACTIONS(1632),
    [sym_atx_h5_marker] = ACTIONS(1632),
    [sym_atx_h6_marker] = ACTIONS(1632),
    [sym__thematic_break] = ACTIONS(1632),
    [sym__list_marker_minus] = ACTIONS(1632),
    [sym__list_marker_plus] = ACTIONS(1632),
    [sym__list_marker_star] = ACTIONS(1632),
    [sym__list_marker_parenthesis] = ACTIONS(1632),
    [sym__list_marker_dot] = ACTIONS(1632),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1632),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1632),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1632),
    [sym__blank_line_start] = ACTIONS(1632),
    [sym__html_block_1_start] = ACTIONS(1632),
    [sym__html_block_2_start] = ACTIONS(1632),
    [sym__html_block_3_start] = ACTIONS(1632),
    [sym__html_block_4_start] = ACTIONS(1632),
    [sym__html_block_5_start] = ACTIONS(1632),
    [sym__html_block_6_start] = ACTIONS(1632),
    [sym__html_block_7_start] = ACTIONS(1632),
    [sym__pipe_table_start] = ACTIONS(1632),
  },
  [217] = {
    [anon_sym_LBRACK] = ACTIONS(1207),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_GT] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_POUND] = ACTIONS(1205),
    [anon_sym_DOLLAR] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1205),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_BSLASH] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym__] = ACTIONS(1205),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [aux_sym__word_token1] = ACTIONS(1205),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1205),
    [aux_sym__word_token2] = ACTIONS(1205),
    [sym__whitespace] = ACTIONS(1205),
    [sym__soft_line_ending] = ACTIONS(1205),
    [sym__block_close] = ACTIONS(1205),
    [sym__block_quote_start] = ACTIONS(1205),
    [sym__indented_chunk_start] = ACTIONS(1205),
    [sym_atx_h1_marker] = ACTIONS(1205),
    [sym_atx_h2_marker] = ACTIONS(1205),
    [sym_atx_h3_marker] = ACTIONS(1205),
    [sym_atx_h4_marker] = ACTIONS(1205),
    [sym_atx_h5_marker] = ACTIONS(1205),
    [sym_atx_h6_marker] = ACTIONS(1205),
    [sym__thematic_break] = ACTIONS(1205),
    [sym__list_marker_minus] = ACTIONS(1205),
    [sym__list_marker_plus] = ACTIONS(1205),
    [sym__list_marker_star] = ACTIONS(1205),
    [sym__list_marker_parenthesis] = ACTIONS(1205),
    [sym__list_marker_dot] = ACTIONS(1205),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1205),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1205),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1205),
    [sym__blank_line_start] = ACTIONS(1205),
    [sym__html_block_1_start] = ACTIONS(1205),
    [sym__html_block_2_start] = ACTIONS(1205),
    [sym__html_block_3_start] = ACTIONS(1205),
    [sym__html_block_4_start] = ACTIONS(1205),
    [sym__html_block_5_start] = ACTIONS(1205),
    [sym__html_block_6_start] = ACTIONS(1205),
    [sym__html_block_7_start] = ACTIONS(1205),
    [sym__pipe_table_start] = ACTIONS(1205),
  },
  [218] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [aux_sym__word_token1] = ACTIONS(1428),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1428),
    [aux_sym__word_token2] = ACTIONS(1428),
    [sym__whitespace] = ACTIONS(1428),
    [sym__soft_line_ending] = ACTIONS(1428),
    [sym__block_quote_start] = ACTIONS(1428),
    [sym__indented_chunk_start] = ACTIONS(1428),
    [sym_atx_h1_marker] = ACTIONS(1428),
    [sym_atx_h2_marker] = ACTIONS(1428),
    [sym_atx_h3_marker] = ACTIONS(1428),
    [sym_atx_h4_marker] = ACTIONS(1428),
    [sym_atx_h5_marker] = ACTIONS(1428),
    [sym_atx_h6_marker] = ACTIONS(1428),
    [sym__thematic_break] = ACTIONS(1428),
    [sym__list_marker_minus] = ACTIONS(1428),
    [sym__list_marker_plus] = ACTIONS(1428),
    [sym__list_marker_star] = ACTIONS(1428),
    [sym__list_marker_parenthesis] = ACTIONS(1428),
    [sym__list_marker_dot] = ACTIONS(1428),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1428),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1428),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1428),
    [sym__blank_line_start] = ACTIONS(1428),
    [sym__html_block_1_start] = ACTIONS(1428),
    [sym__html_block_2_start] = ACTIONS(1428),
    [sym__html_block_3_start] = ACTIONS(1428),
    [sym__html_block_4_start] = ACTIONS(1428),
    [sym__html_block_5_start] = ACTIONS(1428),
    [sym__html_block_6_start] = ACTIONS(1428),
    [sym__html_block_7_start] = ACTIONS(1428),
    [sym__pipe_table_start] = ACTIONS(1428),
  },
  [219] = {
    [anon_sym_LBRACK] = ACTIONS(1634),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_DQUOTE] = ACTIONS(1636),
    [anon_sym_POUND] = ACTIONS(1636),
    [anon_sym_DOLLAR] = ACTIONS(1636),
    [anon_sym_PERCENT] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_COLON] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_EQ] = ACTIONS(1636),
    [anon_sym_QMARK] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(1636),
    [anon_sym_BSLASH] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(1636),
    [anon_sym__] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1636),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [aux_sym__word_token1] = ACTIONS(1636),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1636),
    [aux_sym__word_token2] = ACTIONS(1636),
    [sym__whitespace] = ACTIONS(1636),
    [sym__soft_line_ending] = ACTIONS(1636),
    [sym__block_close] = ACTIONS(1636),
    [sym__block_quote_start] = ACTIONS(1636),
    [sym__indented_chunk_start] = ACTIONS(1636),
    [sym_atx_h1_marker] = ACTIONS(1636),
    [sym_atx_h2_marker] = ACTIONS(1636),
    [sym_atx_h3_marker] = ACTIONS(1636),
    [sym_atx_h4_marker] = ACTIONS(1636),
    [sym_atx_h5_marker] = ACTIONS(1636),
    [sym_atx_h6_marker] = ACTIONS(1636),
    [sym__thematic_break] = ACTIONS(1636),
    [sym__list_marker_minus] = ACTIONS(1636),
    [sym__list_marker_plus] = ACTIONS(1636),
    [sym__list_marker_star] = ACTIONS(1636),
    [sym__list_marker_parenthesis] = ACTIONS(1636),
    [sym__list_marker_dot] = ACTIONS(1636),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1636),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1636),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1636),
    [sym__blank_line_start] = ACTIONS(1636),
    [sym__html_block_1_start] = ACTIONS(1636),
    [sym__html_block_2_start] = ACTIONS(1636),
    [sym__html_block_3_start] = ACTIONS(1636),
    [sym__html_block_4_start] = ACTIONS(1636),
    [sym__html_block_5_start] = ACTIONS(1636),
    [sym__html_block_6_start] = ACTIONS(1636),
    [sym__html_block_7_start] = ACTIONS(1636),
    [sym__pipe_table_start] = ACTIONS(1636),
  },
  [220] = {
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_RBRACK] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1640),
    [anon_sym_DQUOTE] = ACTIONS(1640),
    [anon_sym_POUND] = ACTIONS(1640),
    [anon_sym_DOLLAR] = ACTIONS(1640),
    [anon_sym_PERCENT] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1640),
    [anon_sym_SQUOTE] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(1640),
    [anon_sym_QMARK] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1640),
    [anon_sym_BSLASH] = ACTIONS(1640),
    [anon_sym_CARET] = ACTIONS(1640),
    [anon_sym__] = ACTIONS(1640),
    [anon_sym_BQUOTE] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1640),
    [anon_sym_PIPE] = ACTIONS(1640),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [aux_sym__word_token1] = ACTIONS(1640),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1640),
    [aux_sym__word_token2] = ACTIONS(1640),
    [sym__whitespace] = ACTIONS(1640),
    [sym__soft_line_ending] = ACTIONS(1640),
    [sym__block_close] = ACTIONS(1640),
    [sym__block_quote_start] = ACTIONS(1640),
    [sym__indented_chunk_start] = ACTIONS(1640),
    [sym_atx_h1_marker] = ACTIONS(1640),
    [sym_atx_h2_marker] = ACTIONS(1640),
    [sym_atx_h3_marker] = ACTIONS(1640),
    [sym_atx_h4_marker] = ACTIONS(1640),
    [sym_atx_h5_marker] = ACTIONS(1640),
    [sym_atx_h6_marker] = ACTIONS(1640),
    [sym__thematic_break] = ACTIONS(1640),
    [sym__list_marker_minus] = ACTIONS(1640),
    [sym__list_marker_plus] = ACTIONS(1640),
    [sym__list_marker_star] = ACTIONS(1640),
    [sym__list_marker_parenthesis] = ACTIONS(1640),
    [sym__list_marker_dot] = ACTIONS(1640),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1640),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1640),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1640),
    [sym__blank_line_start] = ACTIONS(1640),
    [sym__html_block_1_start] = ACTIONS(1640),
    [sym__html_block_2_start] = ACTIONS(1640),
    [sym__html_block_3_start] = ACTIONS(1640),
    [sym__html_block_4_start] = ACTIONS(1640),
    [sym__html_block_5_start] = ACTIONS(1640),
    [sym__html_block_6_start] = ACTIONS(1640),
    [sym__html_block_7_start] = ACTIONS(1640),
    [sym__pipe_table_start] = ACTIONS(1640),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [aux_sym__word_token1] = ACTIONS(1434),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1434),
    [aux_sym__word_token2] = ACTIONS(1434),
    [sym__whitespace] = ACTIONS(1434),
    [sym__soft_line_ending] = ACTIONS(1434),
    [sym__block_quote_start] = ACTIONS(1434),
    [sym__indented_chunk_start] = ACTIONS(1434),
    [sym_atx_h1_marker] = ACTIONS(1434),
    [sym_atx_h2_marker] = ACTIONS(1434),
    [sym_atx_h3_marker] = ACTIONS(1434),
    [sym_atx_h4_marker] = ACTIONS(1434),
    [sym_atx_h5_marker] = ACTIONS(1434),
    [sym_atx_h6_marker] = ACTIONS(1434),
    [sym__thematic_break] = ACTIONS(1434),
    [sym__list_marker_minus] = ACTIONS(1434),
    [sym__list_marker_plus] = ACTIONS(1434),
    [sym__list_marker_star] = ACTIONS(1434),
    [sym__list_marker_parenthesis] = ACTIONS(1434),
    [sym__list_marker_dot] = ACTIONS(1434),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1434),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1434),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1434),
    [sym__blank_line_start] = ACTIONS(1434),
    [sym__html_block_1_start] = ACTIONS(1434),
    [sym__html_block_2_start] = ACTIONS(1434),
    [sym__html_block_3_start] = ACTIONS(1434),
    [sym__html_block_4_start] = ACTIONS(1434),
    [sym__html_block_5_start] = ACTIONS(1434),
    [sym__html_block_6_start] = ACTIONS(1434),
    [sym__html_block_7_start] = ACTIONS(1434),
    [sym__pipe_table_start] = ACTIONS(1434),
  },
  [222] = {
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_POUND] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
    [anon_sym_SQUOTE] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DOT] = ACTIONS(1644),
    [anon_sym_SLASH] = ACTIONS(1644),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_BSLASH] = ACTIONS(1644),
    [anon_sym_CARET] = ACTIONS(1644),
    [anon_sym__] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_TILDE] = ACTIONS(1644),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [aux_sym__word_token1] = ACTIONS(1644),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1644),
    [aux_sym__word_token2] = ACTIONS(1644),
    [sym__whitespace] = ACTIONS(1644),
    [sym__soft_line_ending] = ACTIONS(1644),
    [sym__block_close] = ACTIONS(1644),
    [sym__block_quote_start] = ACTIONS(1644),
    [sym__indented_chunk_start] = ACTIONS(1644),
    [sym_atx_h1_marker] = ACTIONS(1644),
    [sym_atx_h2_marker] = ACTIONS(1644),
    [sym_atx_h3_marker] = ACTIONS(1644),
    [sym_atx_h4_marker] = ACTIONS(1644),
    [sym_atx_h5_marker] = ACTIONS(1644),
    [sym_atx_h6_marker] = ACTIONS(1644),
    [sym__thematic_break] = ACTIONS(1644),
    [sym__list_marker_minus] = ACTIONS(1644),
    [sym__list_marker_plus] = ACTIONS(1644),
    [sym__list_marker_star] = ACTIONS(1644),
    [sym__list_marker_parenthesis] = ACTIONS(1644),
    [sym__list_marker_dot] = ACTIONS(1644),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1644),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1644),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1644),
    [sym__blank_line_start] = ACTIONS(1644),
    [sym__html_block_1_start] = ACTIONS(1644),
    [sym__html_block_2_start] = ACTIONS(1644),
    [sym__html_block_3_start] = ACTIONS(1644),
    [sym__html_block_4_start] = ACTIONS(1644),
    [sym__html_block_5_start] = ACTIONS(1644),
    [sym__html_block_6_start] = ACTIONS(1644),
    [sym__html_block_7_start] = ACTIONS(1644),
    [sym__pipe_table_start] = ACTIONS(1644),
  },
  [223] = {
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym__] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(1310),
    [aux_sym__word_token1] = ACTIONS(1310),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1310),
    [aux_sym__word_token2] = ACTIONS(1310),
    [sym__whitespace] = ACTIONS(1310),
    [sym__soft_line_ending] = ACTIONS(1310),
    [sym__block_close] = ACTIONS(1310),
    [sym__block_quote_start] = ACTIONS(1310),
    [sym__indented_chunk_start] = ACTIONS(1310),
    [sym_atx_h1_marker] = ACTIONS(1310),
    [sym_atx_h2_marker] = ACTIONS(1310),
    [sym_atx_h3_marker] = ACTIONS(1310),
    [sym_atx_h4_marker] = ACTIONS(1310),
    [sym_atx_h5_marker] = ACTIONS(1310),
    [sym_atx_h6_marker] = ACTIONS(1310),
    [sym__thematic_break] = ACTIONS(1310),
    [sym__list_marker_minus] = ACTIONS(1310),
    [sym__list_marker_plus] = ACTIONS(1310),
    [sym__list_marker_star] = ACTIONS(1310),
    [sym__list_marker_parenthesis] = ACTIONS(1310),
    [sym__list_marker_dot] = ACTIONS(1310),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1310),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1310),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1310),
    [sym__blank_line_start] = ACTIONS(1310),
    [sym__html_block_1_start] = ACTIONS(1310),
    [sym__html_block_2_start] = ACTIONS(1310),
    [sym__html_block_3_start] = ACTIONS(1310),
    [sym__html_block_4_start] = ACTIONS(1310),
    [sym__html_block_5_start] = ACTIONS(1310),
    [sym__html_block_6_start] = ACTIONS(1310),
    [sym__html_block_7_start] = ACTIONS(1310),
    [sym__pipe_table_start] = ACTIONS(1310),
  },
  [224] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [aux_sym__word_token1] = ACTIONS(1440),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1440),
    [aux_sym__word_token2] = ACTIONS(1440),
    [sym__whitespace] = ACTIONS(1440),
    [sym__soft_line_ending] = ACTIONS(1440),
    [sym__block_quote_start] = ACTIONS(1440),
    [sym__indented_chunk_start] = ACTIONS(1440),
    [sym_atx_h1_marker] = ACTIONS(1440),
    [sym_atx_h2_marker] = ACTIONS(1440),
    [sym_atx_h3_marker] = ACTIONS(1440),
    [sym_atx_h4_marker] = ACTIONS(1440),
    [sym_atx_h5_marker] = ACTIONS(1440),
    [sym_atx_h6_marker] = ACTIONS(1440),
    [sym__thematic_break] = ACTIONS(1440),
    [sym__list_marker_minus] = ACTIONS(1440),
    [sym__list_marker_plus] = ACTIONS(1440),
    [sym__list_marker_star] = ACTIONS(1440),
    [sym__list_marker_parenthesis] = ACTIONS(1440),
    [sym__list_marker_dot] = ACTIONS(1440),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1440),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1440),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1440),
    [sym__blank_line_start] = ACTIONS(1440),
    [sym__html_block_1_start] = ACTIONS(1440),
    [sym__html_block_2_start] = ACTIONS(1440),
    [sym__html_block_3_start] = ACTIONS(1440),
    [sym__html_block_4_start] = ACTIONS(1440),
    [sym__html_block_5_start] = ACTIONS(1440),
    [sym__html_block_6_start] = ACTIONS(1440),
    [sym__html_block_7_start] = ACTIONS(1440),
    [sym__pipe_table_start] = ACTIONS(1440),
  },
  [225] = {
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1316),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym__] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [aux_sym__word_token1] = ACTIONS(1316),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1316),
    [aux_sym__word_token2] = ACTIONS(1316),
    [sym__whitespace] = ACTIONS(1316),
    [sym__soft_line_ending] = ACTIONS(1316),
    [sym__block_close] = ACTIONS(1316),
    [sym__block_quote_start] = ACTIONS(1316),
    [sym__indented_chunk_start] = ACTIONS(1316),
    [sym_atx_h1_marker] = ACTIONS(1316),
    [sym_atx_h2_marker] = ACTIONS(1316),
    [sym_atx_h3_marker] = ACTIONS(1316),
    [sym_atx_h4_marker] = ACTIONS(1316),
    [sym_atx_h5_marker] = ACTIONS(1316),
    [sym_atx_h6_marker] = ACTIONS(1316),
    [sym__thematic_break] = ACTIONS(1316),
    [sym__list_marker_minus] = ACTIONS(1316),
    [sym__list_marker_plus] = ACTIONS(1316),
    [sym__list_marker_star] = ACTIONS(1316),
    [sym__list_marker_parenthesis] = ACTIONS(1316),
    [sym__list_marker_dot] = ACTIONS(1316),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1316),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1316),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1316),
    [sym__blank_line_start] = ACTIONS(1316),
    [sym__html_block_1_start] = ACTIONS(1316),
    [sym__html_block_2_start] = ACTIONS(1316),
    [sym__html_block_3_start] = ACTIONS(1316),
    [sym__html_block_4_start] = ACTIONS(1316),
    [sym__html_block_5_start] = ACTIONS(1316),
    [sym__html_block_6_start] = ACTIONS(1316),
    [sym__html_block_7_start] = ACTIONS(1316),
    [sym__pipe_table_start] = ACTIONS(1316),
  },
  [226] = {
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_POUND] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1288),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_QMARK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1288),
    [anon_sym__] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [aux_sym__word_token1] = ACTIONS(1288),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1288),
    [aux_sym__word_token2] = ACTIONS(1288),
    [sym__whitespace] = ACTIONS(1288),
    [sym__soft_line_ending] = ACTIONS(1288),
    [sym__block_close] = ACTIONS(1288),
    [sym__block_quote_start] = ACTIONS(1288),
    [sym__indented_chunk_start] = ACTIONS(1288),
    [sym_atx_h1_marker] = ACTIONS(1288),
    [sym_atx_h2_marker] = ACTIONS(1288),
    [sym_atx_h3_marker] = ACTIONS(1288),
    [sym_atx_h4_marker] = ACTIONS(1288),
    [sym_atx_h5_marker] = ACTIONS(1288),
    [sym_atx_h6_marker] = ACTIONS(1288),
    [sym__thematic_break] = ACTIONS(1288),
    [sym__list_marker_minus] = ACTIONS(1288),
    [sym__list_marker_plus] = ACTIONS(1288),
    [sym__list_marker_star] = ACTIONS(1288),
    [sym__list_marker_parenthesis] = ACTIONS(1288),
    [sym__list_marker_dot] = ACTIONS(1288),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1288),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1288),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1288),
    [sym__blank_line_start] = ACTIONS(1288),
    [sym__html_block_1_start] = ACTIONS(1288),
    [sym__html_block_2_start] = ACTIONS(1288),
    [sym__html_block_3_start] = ACTIONS(1288),
    [sym__html_block_4_start] = ACTIONS(1288),
    [sym__html_block_5_start] = ACTIONS(1288),
    [sym__html_block_6_start] = ACTIONS(1288),
    [sym__html_block_7_start] = ACTIONS(1288),
    [sym__pipe_table_start] = ACTIONS(1288),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [aux_sym__word_token1] = ACTIONS(1418),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1418),
    [aux_sym__word_token2] = ACTIONS(1418),
    [sym__whitespace] = ACTIONS(1418),
    [sym__soft_line_ending] = ACTIONS(1418),
    [sym__block_quote_start] = ACTIONS(1418),
    [sym__indented_chunk_start] = ACTIONS(1418),
    [sym_atx_h1_marker] = ACTIONS(1418),
    [sym_atx_h2_marker] = ACTIONS(1418),
    [sym_atx_h3_marker] = ACTIONS(1418),
    [sym_atx_h4_marker] = ACTIONS(1418),
    [sym_atx_h5_marker] = ACTIONS(1418),
    [sym_atx_h6_marker] = ACTIONS(1418),
    [sym__thematic_break] = ACTIONS(1418),
    [sym__list_marker_minus] = ACTIONS(1418),
    [sym__list_marker_plus] = ACTIONS(1418),
    [sym__list_marker_star] = ACTIONS(1418),
    [sym__list_marker_parenthesis] = ACTIONS(1418),
    [sym__list_marker_dot] = ACTIONS(1418),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1418),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1418),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1418),
    [sym__blank_line_start] = ACTIONS(1418),
    [sym__html_block_1_start] = ACTIONS(1418),
    [sym__html_block_2_start] = ACTIONS(1418),
    [sym__html_block_3_start] = ACTIONS(1418),
    [sym__html_block_4_start] = ACTIONS(1418),
    [sym__html_block_5_start] = ACTIONS(1418),
    [sym__html_block_6_start] = ACTIONS(1418),
    [sym__html_block_7_start] = ACTIONS(1418),
    [sym__pipe_table_start] = ACTIONS(1418),
  },
  [228] = {
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_POUND] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(1322),
    [aux_sym__word_token1] = ACTIONS(1322),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1322),
    [aux_sym__word_token2] = ACTIONS(1322),
    [sym__whitespace] = ACTIONS(1322),
    [sym__soft_line_ending] = ACTIONS(1322),
    [sym__block_close] = ACTIONS(1322),
    [sym__block_quote_start] = ACTIONS(1322),
    [sym__indented_chunk_start] = ACTIONS(1322),
    [sym_atx_h1_marker] = ACTIONS(1322),
    [sym_atx_h2_marker] = ACTIONS(1322),
    [sym_atx_h3_marker] = ACTIONS(1322),
    [sym_atx_h4_marker] = ACTIONS(1322),
    [sym_atx_h5_marker] = ACTIONS(1322),
    [sym_atx_h6_marker] = ACTIONS(1322),
    [sym__thematic_break] = ACTIONS(1322),
    [sym__list_marker_minus] = ACTIONS(1322),
    [sym__list_marker_plus] = ACTIONS(1322),
    [sym__list_marker_star] = ACTIONS(1322),
    [sym__list_marker_parenthesis] = ACTIONS(1322),
    [sym__list_marker_dot] = ACTIONS(1322),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1322),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1322),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1322),
    [sym__blank_line_start] = ACTIONS(1322),
    [sym__html_block_1_start] = ACTIONS(1322),
    [sym__html_block_2_start] = ACTIONS(1322),
    [sym__html_block_3_start] = ACTIONS(1322),
    [sym__html_block_4_start] = ACTIONS(1322),
    [sym__html_block_5_start] = ACTIONS(1322),
    [sym__html_block_6_start] = ACTIONS(1322),
    [sym__html_block_7_start] = ACTIONS(1322),
    [sym__pipe_table_start] = ACTIONS(1322),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [aux_sym__word_token1] = ACTIONS(1448),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1448),
    [aux_sym__word_token2] = ACTIONS(1448),
    [sym__whitespace] = ACTIONS(1448),
    [sym__soft_line_ending] = ACTIONS(1448),
    [sym__block_quote_start] = ACTIONS(1448),
    [sym__indented_chunk_start] = ACTIONS(1448),
    [sym_atx_h1_marker] = ACTIONS(1448),
    [sym_atx_h2_marker] = ACTIONS(1448),
    [sym_atx_h3_marker] = ACTIONS(1448),
    [sym_atx_h4_marker] = ACTIONS(1448),
    [sym_atx_h5_marker] = ACTIONS(1448),
    [sym_atx_h6_marker] = ACTIONS(1448),
    [sym__thematic_break] = ACTIONS(1448),
    [sym__list_marker_minus] = ACTIONS(1448),
    [sym__list_marker_plus] = ACTIONS(1448),
    [sym__list_marker_star] = ACTIONS(1448),
    [sym__list_marker_parenthesis] = ACTIONS(1448),
    [sym__list_marker_dot] = ACTIONS(1448),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1448),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1448),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1448),
    [sym__blank_line_start] = ACTIONS(1448),
    [sym__html_block_1_start] = ACTIONS(1448),
    [sym__html_block_2_start] = ACTIONS(1448),
    [sym__html_block_3_start] = ACTIONS(1448),
    [sym__html_block_4_start] = ACTIONS(1448),
    [sym__html_block_5_start] = ACTIONS(1448),
    [sym__html_block_6_start] = ACTIONS(1448),
    [sym__html_block_7_start] = ACTIONS(1448),
    [sym__pipe_table_start] = ACTIONS(1448),
  },
  [230] = {
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_POUND] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_QMARK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym__] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [aux_sym__word_token1] = ACTIONS(1334),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1334),
    [aux_sym__word_token2] = ACTIONS(1334),
    [sym__whitespace] = ACTIONS(1334),
    [sym__soft_line_ending] = ACTIONS(1334),
    [sym__block_close] = ACTIONS(1334),
    [sym__block_quote_start] = ACTIONS(1334),
    [sym__indented_chunk_start] = ACTIONS(1334),
    [sym_atx_h1_marker] = ACTIONS(1334),
    [sym_atx_h2_marker] = ACTIONS(1334),
    [sym_atx_h3_marker] = ACTIONS(1334),
    [sym_atx_h4_marker] = ACTIONS(1334),
    [sym_atx_h5_marker] = ACTIONS(1334),
    [sym_atx_h6_marker] = ACTIONS(1334),
    [sym__thematic_break] = ACTIONS(1334),
    [sym__list_marker_minus] = ACTIONS(1334),
    [sym__list_marker_plus] = ACTIONS(1334),
    [sym__list_marker_star] = ACTIONS(1334),
    [sym__list_marker_parenthesis] = ACTIONS(1334),
    [sym__list_marker_dot] = ACTIONS(1334),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1334),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1334),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1334),
    [sym__blank_line_start] = ACTIONS(1334),
    [sym__html_block_1_start] = ACTIONS(1334),
    [sym__html_block_2_start] = ACTIONS(1334),
    [sym__html_block_3_start] = ACTIONS(1334),
    [sym__html_block_4_start] = ACTIONS(1334),
    [sym__html_block_5_start] = ACTIONS(1334),
    [sym__html_block_6_start] = ACTIONS(1334),
    [sym__html_block_7_start] = ACTIONS(1334),
    [sym__pipe_table_start] = ACTIONS(1334),
  },
  [231] = {
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_GT] = ACTIONS(1648),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_POUND] = ACTIONS(1648),
    [anon_sym_DOLLAR] = ACTIONS(1648),
    [anon_sym_PERCENT] = ACTIONS(1648),
    [anon_sym_AMP] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [anon_sym_STAR] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_DOT] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(1648),
    [anon_sym_COLON] = ACTIONS(1648),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_EQ] = ACTIONS(1648),
    [anon_sym_QMARK] = ACTIONS(1648),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_BSLASH] = ACTIONS(1648),
    [anon_sym_CARET] = ACTIONS(1648),
    [anon_sym__] = ACTIONS(1648),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [aux_sym__word_token1] = ACTIONS(1648),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1648),
    [aux_sym__word_token2] = ACTIONS(1648),
    [sym__whitespace] = ACTIONS(1648),
    [sym__soft_line_ending] = ACTIONS(1648),
    [sym_block_continuation] = ACTIONS(1648),
    [sym__block_quote_start] = ACTIONS(1648),
    [sym__indented_chunk_start] = ACTIONS(1648),
    [sym_atx_h1_marker] = ACTIONS(1648),
    [sym_atx_h2_marker] = ACTIONS(1648),
    [sym_atx_h3_marker] = ACTIONS(1648),
    [sym_atx_h4_marker] = ACTIONS(1648),
    [sym_atx_h5_marker] = ACTIONS(1648),
    [sym_atx_h6_marker] = ACTIONS(1648),
    [sym__thematic_break] = ACTIONS(1648),
    [sym__list_marker_minus] = ACTIONS(1648),
    [sym__list_marker_plus] = ACTIONS(1648),
    [sym__list_marker_star] = ACTIONS(1648),
    [sym__list_marker_parenthesis] = ACTIONS(1648),
    [sym__list_marker_dot] = ACTIONS(1648),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1648),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1648),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1648),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1648),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1648),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1648),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1648),
    [sym__blank_line_start] = ACTIONS(1648),
    [sym__html_block_1_start] = ACTIONS(1648),
    [sym__html_block_2_start] = ACTIONS(1648),
    [sym__html_block_3_start] = ACTIONS(1648),
    [sym__html_block_4_start] = ACTIONS(1648),
    [sym__html_block_5_start] = ACTIONS(1648),
    [sym__html_block_6_start] = ACTIONS(1648),
    [sym__html_block_7_start] = ACTIONS(1648),
    [sym__pipe_table_start] = ACTIONS(1648),
  },
  [232] = {
    [anon_sym_LBRACK] = ACTIONS(1650),
    [anon_sym_RBRACK] = ACTIONS(1652),
    [anon_sym_LT] = ACTIONS(1652),
    [anon_sym_GT] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1652),
    [anon_sym_DQUOTE] = ACTIONS(1652),
    [anon_sym_POUND] = ACTIONS(1652),
    [anon_sym_DOLLAR] = ACTIONS(1652),
    [anon_sym_PERCENT] = ACTIONS(1652),
    [anon_sym_AMP] = ACTIONS(1652),
    [anon_sym_SQUOTE] = ACTIONS(1652),
    [anon_sym_STAR] = ACTIONS(1652),
    [anon_sym_PLUS] = ACTIONS(1652),
    [anon_sym_COMMA] = ACTIONS(1652),
    [anon_sym_DASH] = ACTIONS(1652),
    [anon_sym_DOT] = ACTIONS(1652),
    [anon_sym_SLASH] = ACTIONS(1652),
    [anon_sym_COLON] = ACTIONS(1652),
    [anon_sym_SEMI] = ACTIONS(1652),
    [anon_sym_EQ] = ACTIONS(1652),
    [anon_sym_QMARK] = ACTIONS(1652),
    [anon_sym_AT] = ACTIONS(1652),
    [anon_sym_BSLASH] = ACTIONS(1652),
    [anon_sym_CARET] = ACTIONS(1652),
    [anon_sym__] = ACTIONS(1652),
    [anon_sym_BQUOTE] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(1652),
    [anon_sym_PIPE] = ACTIONS(1652),
    [anon_sym_RBRACE] = ACTIONS(1652),
    [anon_sym_TILDE] = ACTIONS(1652),
    [anon_sym_LPAREN] = ACTIONS(1652),
    [anon_sym_RPAREN] = ACTIONS(1652),
    [aux_sym__word_token1] = ACTIONS(1652),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1652),
    [aux_sym__word_token2] = ACTIONS(1652),
    [sym__whitespace] = ACTIONS(1652),
    [sym__soft_line_ending] = ACTIONS(1652),
    [sym_block_continuation] = ACTIONS(1652),
    [sym__block_quote_start] = ACTIONS(1652),
    [sym__indented_chunk_start] = ACTIONS(1652),
    [sym_atx_h1_marker] = ACTIONS(1652),
    [sym_atx_h2_marker] = ACTIONS(1652),
    [sym_atx_h3_marker] = ACTIONS(1652),
    [sym_atx_h4_marker] = ACTIONS(1652),
    [sym_atx_h5_marker] = ACTIONS(1652),
    [sym_atx_h6_marker] = ACTIONS(1652),
    [sym__thematic_break] = ACTIONS(1652),
    [sym__list_marker_minus] = ACTIONS(1652),
    [sym__list_marker_plus] = ACTIONS(1652),
    [sym__list_marker_star] = ACTIONS(1652),
    [sym__list_marker_parenthesis] = ACTIONS(1652),
    [sym__list_marker_dot] = ACTIONS(1652),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1652),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1652),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1652),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1652),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1652),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1652),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1652),
    [sym__blank_line_start] = ACTIONS(1652),
    [sym__html_block_1_start] = ACTIONS(1652),
    [sym__html_block_2_start] = ACTIONS(1652),
    [sym__html_block_3_start] = ACTIONS(1652),
    [sym__html_block_4_start] = ACTIONS(1652),
    [sym__html_block_5_start] = ACTIONS(1652),
    [sym__html_block_6_start] = ACTIONS(1652),
    [sym__html_block_7_start] = ACTIONS(1652),
    [sym__pipe_table_start] = ACTIONS(1652),
  },
  [233] = {
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_POUND] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_BSLASH] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym__] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1169),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [aux_sym__word_token1] = ACTIONS(1169),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1169),
    [aux_sym__word_token2] = ACTIONS(1169),
    [sym__whitespace] = ACTIONS(1169),
    [sym__soft_line_ending] = ACTIONS(1169),
    [sym__block_close] = ACTIONS(1169),
    [sym__block_quote_start] = ACTIONS(1169),
    [sym__indented_chunk_start] = ACTIONS(1169),
    [sym_atx_h1_marker] = ACTIONS(1169),
    [sym_atx_h2_marker] = ACTIONS(1169),
    [sym_atx_h3_marker] = ACTIONS(1169),
    [sym_atx_h4_marker] = ACTIONS(1169),
    [sym_atx_h5_marker] = ACTIONS(1169),
    [sym_atx_h6_marker] = ACTIONS(1169),
    [sym__thematic_break] = ACTIONS(1169),
    [sym__list_marker_minus] = ACTIONS(1169),
    [sym__list_marker_plus] = ACTIONS(1169),
    [sym__list_marker_star] = ACTIONS(1169),
    [sym__list_marker_parenthesis] = ACTIONS(1169),
    [sym__list_marker_dot] = ACTIONS(1169),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1169),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1169),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1169),
    [sym__blank_line_start] = ACTIONS(1169),
    [sym__html_block_1_start] = ACTIONS(1169),
    [sym__html_block_2_start] = ACTIONS(1169),
    [sym__html_block_3_start] = ACTIONS(1169),
    [sym__html_block_4_start] = ACTIONS(1169),
    [sym__html_block_5_start] = ACTIONS(1169),
    [sym__html_block_6_start] = ACTIONS(1169),
    [sym__html_block_7_start] = ACTIONS(1169),
    [sym__pipe_table_start] = ACTIONS(1169),
  },
  [234] = {
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_POUND] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_COLON] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym__] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1250),
    [aux_sym__word_token1] = ACTIONS(1250),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1250),
    [aux_sym__word_token2] = ACTIONS(1250),
    [sym__whitespace] = ACTIONS(1250),
    [sym__soft_line_ending] = ACTIONS(1250),
    [sym__block_close] = ACTIONS(1250),
    [sym__block_quote_start] = ACTIONS(1250),
    [sym__indented_chunk_start] = ACTIONS(1250),
    [sym_atx_h1_marker] = ACTIONS(1250),
    [sym_atx_h2_marker] = ACTIONS(1250),
    [sym_atx_h3_marker] = ACTIONS(1250),
    [sym_atx_h4_marker] = ACTIONS(1250),
    [sym_atx_h5_marker] = ACTIONS(1250),
    [sym_atx_h6_marker] = ACTIONS(1250),
    [sym__thematic_break] = ACTIONS(1250),
    [sym__list_marker_minus] = ACTIONS(1250),
    [sym__list_marker_plus] = ACTIONS(1250),
    [sym__list_marker_star] = ACTIONS(1250),
    [sym__list_marker_parenthesis] = ACTIONS(1250),
    [sym__list_marker_dot] = ACTIONS(1250),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1250),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1250),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1250),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1250),
    [sym__blank_line_start] = ACTIONS(1250),
    [sym__html_block_1_start] = ACTIONS(1250),
    [sym__html_block_2_start] = ACTIONS(1250),
    [sym__html_block_3_start] = ACTIONS(1250),
    [sym__html_block_4_start] = ACTIONS(1250),
    [sym__html_block_5_start] = ACTIONS(1250),
    [sym__html_block_6_start] = ACTIONS(1250),
    [sym__html_block_7_start] = ACTIONS(1250),
    [sym__pipe_table_start] = ACTIONS(1250),
  },
  [235] = {
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_POUND] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [anon_sym_PERCENT] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1656),
    [anon_sym_SQUOTE] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_SLASH] = ACTIONS(1656),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(1656),
    [anon_sym_BSLASH] = ACTIONS(1656),
    [anon_sym_CARET] = ACTIONS(1656),
    [anon_sym__] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [anon_sym_LPAREN] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [aux_sym__word_token1] = ACTIONS(1656),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1656),
    [aux_sym__word_token2] = ACTIONS(1656),
    [sym__whitespace] = ACTIONS(1656),
    [sym__soft_line_ending] = ACTIONS(1656),
    [sym__block_close] = ACTIONS(1656),
    [sym__block_quote_start] = ACTIONS(1656),
    [sym__indented_chunk_start] = ACTIONS(1656),
    [sym_atx_h1_marker] = ACTIONS(1656),
    [sym_atx_h2_marker] = ACTIONS(1656),
    [sym_atx_h3_marker] = ACTIONS(1656),
    [sym_atx_h4_marker] = ACTIONS(1656),
    [sym_atx_h5_marker] = ACTIONS(1656),
    [sym_atx_h6_marker] = ACTIONS(1656),
    [sym__thematic_break] = ACTIONS(1656),
    [sym__list_marker_minus] = ACTIONS(1656),
    [sym__list_marker_plus] = ACTIONS(1656),
    [sym__list_marker_star] = ACTIONS(1656),
    [sym__list_marker_parenthesis] = ACTIONS(1656),
    [sym__list_marker_dot] = ACTIONS(1656),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1656),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1656),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1656),
    [sym__blank_line_start] = ACTIONS(1656),
    [sym__html_block_1_start] = ACTIONS(1656),
    [sym__html_block_2_start] = ACTIONS(1656),
    [sym__html_block_3_start] = ACTIONS(1656),
    [sym__html_block_4_start] = ACTIONS(1656),
    [sym__html_block_5_start] = ACTIONS(1656),
    [sym__html_block_6_start] = ACTIONS(1656),
    [sym__html_block_7_start] = ACTIONS(1656),
    [sym__pipe_table_start] = ACTIONS(1656),
  },
  [236] = {
    [anon_sym_LBRACK] = ACTIONS(1658),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1660),
    [anon_sym_GT] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_POUND] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1660),
    [anon_sym_PERCENT] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_DOT] = ACTIONS(1660),
    [anon_sym_SLASH] = ACTIONS(1660),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_AT] = ACTIONS(1660),
    [anon_sym_BSLASH] = ACTIONS(1660),
    [anon_sym_CARET] = ACTIONS(1660),
    [anon_sym__] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_TILDE] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [aux_sym__word_token1] = ACTIONS(1660),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1660),
    [aux_sym__word_token2] = ACTIONS(1660),
    [sym__whitespace] = ACTIONS(1660),
    [sym__soft_line_ending] = ACTIONS(1660),
    [sym__block_close] = ACTIONS(1660),
    [sym__block_quote_start] = ACTIONS(1660),
    [sym__indented_chunk_start] = ACTIONS(1660),
    [sym_atx_h1_marker] = ACTIONS(1660),
    [sym_atx_h2_marker] = ACTIONS(1660),
    [sym_atx_h3_marker] = ACTIONS(1660),
    [sym_atx_h4_marker] = ACTIONS(1660),
    [sym_atx_h5_marker] = ACTIONS(1660),
    [sym_atx_h6_marker] = ACTIONS(1660),
    [sym__thematic_break] = ACTIONS(1660),
    [sym__list_marker_minus] = ACTIONS(1660),
    [sym__list_marker_plus] = ACTIONS(1660),
    [sym__list_marker_star] = ACTIONS(1660),
    [sym__list_marker_parenthesis] = ACTIONS(1660),
    [sym__list_marker_dot] = ACTIONS(1660),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1660),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1660),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1660),
    [sym__blank_line_start] = ACTIONS(1660),
    [sym__html_block_1_start] = ACTIONS(1660),
    [sym__html_block_2_start] = ACTIONS(1660),
    [sym__html_block_3_start] = ACTIONS(1660),
    [sym__html_block_4_start] = ACTIONS(1660),
    [sym__html_block_5_start] = ACTIONS(1660),
    [sym__html_block_6_start] = ACTIONS(1660),
    [sym__html_block_7_start] = ACTIONS(1660),
    [sym__pipe_table_start] = ACTIONS(1660),
  },
  [237] = {
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_RBRACK] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_POUND] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_PERCENT] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_COMMA] = ACTIONS(1664),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_DOT] = ACTIONS(1664),
    [anon_sym_SLASH] = ACTIONS(1664),
    [anon_sym_COLON] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1664),
    [anon_sym_QMARK] = ACTIONS(1664),
    [anon_sym_AT] = ACTIONS(1664),
    [anon_sym_BSLASH] = ACTIONS(1664),
    [anon_sym_CARET] = ACTIONS(1664),
    [anon_sym__] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_TILDE] = ACTIONS(1664),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [aux_sym__word_token1] = ACTIONS(1664),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1664),
    [aux_sym__word_token2] = ACTIONS(1664),
    [sym__whitespace] = ACTIONS(1664),
    [sym__soft_line_ending] = ACTIONS(1664),
    [sym__block_close] = ACTIONS(1664),
    [sym__block_quote_start] = ACTIONS(1664),
    [sym__indented_chunk_start] = ACTIONS(1664),
    [sym_atx_h1_marker] = ACTIONS(1664),
    [sym_atx_h2_marker] = ACTIONS(1664),
    [sym_atx_h3_marker] = ACTIONS(1664),
    [sym_atx_h4_marker] = ACTIONS(1664),
    [sym_atx_h5_marker] = ACTIONS(1664),
    [sym_atx_h6_marker] = ACTIONS(1664),
    [sym__thematic_break] = ACTIONS(1664),
    [sym__list_marker_minus] = ACTIONS(1664),
    [sym__list_marker_plus] = ACTIONS(1664),
    [sym__list_marker_star] = ACTIONS(1664),
    [sym__list_marker_parenthesis] = ACTIONS(1664),
    [sym__list_marker_dot] = ACTIONS(1664),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1664),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1664),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1664),
    [sym__blank_line_start] = ACTIONS(1664),
    [sym__html_block_1_start] = ACTIONS(1664),
    [sym__html_block_2_start] = ACTIONS(1664),
    [sym__html_block_3_start] = ACTIONS(1664),
    [sym__html_block_4_start] = ACTIONS(1664),
    [sym__html_block_5_start] = ACTIONS(1664),
    [sym__html_block_6_start] = ACTIONS(1664),
    [sym__html_block_7_start] = ACTIONS(1664),
    [sym__pipe_table_start] = ACTIONS(1664),
  },
  [238] = {
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_RBRACK] = ACTIONS(1668),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_BANG] = ACTIONS(1668),
    [anon_sym_DQUOTE] = ACTIONS(1668),
    [anon_sym_POUND] = ACTIONS(1668),
    [anon_sym_DOLLAR] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1668),
    [anon_sym_AMP] = ACTIONS(1668),
    [anon_sym_SQUOTE] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_COMMA] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_DOT] = ACTIONS(1668),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_COLON] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1668),
    [anon_sym_EQ] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1668),
    [anon_sym_BSLASH] = ACTIONS(1668),
    [anon_sym_CARET] = ACTIONS(1668),
    [anon_sym__] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_RBRACE] = ACTIONS(1668),
    [anon_sym_TILDE] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(1668),
    [anon_sym_RPAREN] = ACTIONS(1668),
    [aux_sym__word_token1] = ACTIONS(1668),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1668),
    [aux_sym__word_token2] = ACTIONS(1668),
    [sym__whitespace] = ACTIONS(1668),
    [sym__soft_line_ending] = ACTIONS(1668),
    [sym__block_close] = ACTIONS(1668),
    [sym__block_quote_start] = ACTIONS(1668),
    [sym__indented_chunk_start] = ACTIONS(1668),
    [sym_atx_h1_marker] = ACTIONS(1668),
    [sym_atx_h2_marker] = ACTIONS(1668),
    [sym_atx_h3_marker] = ACTIONS(1668),
    [sym_atx_h4_marker] = ACTIONS(1668),
    [sym_atx_h5_marker] = ACTIONS(1668),
    [sym_atx_h6_marker] = ACTIONS(1668),
    [sym__thematic_break] = ACTIONS(1668),
    [sym__list_marker_minus] = ACTIONS(1668),
    [sym__list_marker_plus] = ACTIONS(1668),
    [sym__list_marker_star] = ACTIONS(1668),
    [sym__list_marker_parenthesis] = ACTIONS(1668),
    [sym__list_marker_dot] = ACTIONS(1668),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1668),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1668),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1668),
    [sym__blank_line_start] = ACTIONS(1668),
    [sym__html_block_1_start] = ACTIONS(1668),
    [sym__html_block_2_start] = ACTIONS(1668),
    [sym__html_block_3_start] = ACTIONS(1668),
    [sym__html_block_4_start] = ACTIONS(1668),
    [sym__html_block_5_start] = ACTIONS(1668),
    [sym__html_block_6_start] = ACTIONS(1668),
    [sym__html_block_7_start] = ACTIONS(1668),
    [sym__pipe_table_start] = ACTIONS(1668),
  },
  [239] = {
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_RBRACK] = ACTIONS(1672),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_POUND] = ACTIONS(1672),
    [anon_sym_DOLLAR] = ACTIONS(1672),
    [anon_sym_PERCENT] = ACTIONS(1672),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_COMMA] = ACTIONS(1672),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_DOT] = ACTIONS(1672),
    [anon_sym_SLASH] = ACTIONS(1672),
    [anon_sym_COLON] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_EQ] = ACTIONS(1672),
    [anon_sym_QMARK] = ACTIONS(1672),
    [anon_sym_AT] = ACTIONS(1672),
    [anon_sym_BSLASH] = ACTIONS(1672),
    [anon_sym_CARET] = ACTIONS(1672),
    [anon_sym__] = ACTIONS(1672),
    [anon_sym_BQUOTE] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_PIPE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_RPAREN] = ACTIONS(1672),
    [aux_sym__word_token1] = ACTIONS(1672),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1672),
    [aux_sym__word_token2] = ACTIONS(1672),
    [sym__whitespace] = ACTIONS(1672),
    [sym__soft_line_ending] = ACTIONS(1672),
    [sym__block_close] = ACTIONS(1672),
    [sym__block_quote_start] = ACTIONS(1672),
    [sym__indented_chunk_start] = ACTIONS(1672),
    [sym_atx_h1_marker] = ACTIONS(1672),
    [sym_atx_h2_marker] = ACTIONS(1672),
    [sym_atx_h3_marker] = ACTIONS(1672),
    [sym_atx_h4_marker] = ACTIONS(1672),
    [sym_atx_h5_marker] = ACTIONS(1672),
    [sym_atx_h6_marker] = ACTIONS(1672),
    [sym__thematic_break] = ACTIONS(1672),
    [sym__list_marker_minus] = ACTIONS(1672),
    [sym__list_marker_plus] = ACTIONS(1672),
    [sym__list_marker_star] = ACTIONS(1672),
    [sym__list_marker_parenthesis] = ACTIONS(1672),
    [sym__list_marker_dot] = ACTIONS(1672),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1672),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1672),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1672),
    [sym__blank_line_start] = ACTIONS(1672),
    [sym__html_block_1_start] = ACTIONS(1672),
    [sym__html_block_2_start] = ACTIONS(1672),
    [sym__html_block_3_start] = ACTIONS(1672),
    [sym__html_block_4_start] = ACTIONS(1672),
    [sym__html_block_5_start] = ACTIONS(1672),
    [sym__html_block_6_start] = ACTIONS(1672),
    [sym__html_block_7_start] = ACTIONS(1672),
    [sym__pipe_table_start] = ACTIONS(1672),
  },
  [240] = {
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_RBRACK] = ACTIONS(1676),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_GT] = ACTIONS(1676),
    [anon_sym_BANG] = ACTIONS(1676),
    [anon_sym_DQUOTE] = ACTIONS(1676),
    [anon_sym_POUND] = ACTIONS(1676),
    [anon_sym_DOLLAR] = ACTIONS(1676),
    [anon_sym_PERCENT] = ACTIONS(1676),
    [anon_sym_AMP] = ACTIONS(1676),
    [anon_sym_SQUOTE] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_COMMA] = ACTIONS(1676),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_DOT] = ACTIONS(1676),
    [anon_sym_SLASH] = ACTIONS(1676),
    [anon_sym_COLON] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1676),
    [anon_sym_EQ] = ACTIONS(1676),
    [anon_sym_QMARK] = ACTIONS(1676),
    [anon_sym_AT] = ACTIONS(1676),
    [anon_sym_BSLASH] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1676),
    [anon_sym__] = ACTIONS(1676),
    [anon_sym_BQUOTE] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_PIPE] = ACTIONS(1676),
    [anon_sym_RBRACE] = ACTIONS(1676),
    [anon_sym_TILDE] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1676),
    [anon_sym_RPAREN] = ACTIONS(1676),
    [aux_sym__word_token1] = ACTIONS(1676),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1676),
    [aux_sym__word_token2] = ACTIONS(1676),
    [sym__whitespace] = ACTIONS(1676),
    [sym__soft_line_ending] = ACTIONS(1676),
    [sym__block_close] = ACTIONS(1676),
    [sym__block_quote_start] = ACTIONS(1676),
    [sym__indented_chunk_start] = ACTIONS(1676),
    [sym_atx_h1_marker] = ACTIONS(1676),
    [sym_atx_h2_marker] = ACTIONS(1676),
    [sym_atx_h3_marker] = ACTIONS(1676),
    [sym_atx_h4_marker] = ACTIONS(1676),
    [sym_atx_h5_marker] = ACTIONS(1676),
    [sym_atx_h6_marker] = ACTIONS(1676),
    [sym__thematic_break] = ACTIONS(1676),
    [sym__list_marker_minus] = ACTIONS(1676),
    [sym__list_marker_plus] = ACTIONS(1676),
    [sym__list_marker_star] = ACTIONS(1676),
    [sym__list_marker_parenthesis] = ACTIONS(1676),
    [sym__list_marker_dot] = ACTIONS(1676),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1676),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1676),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1676),
    [sym__blank_line_start] = ACTIONS(1676),
    [sym__html_block_1_start] = ACTIONS(1676),
    [sym__html_block_2_start] = ACTIONS(1676),
    [sym__html_block_3_start] = ACTIONS(1676),
    [sym__html_block_4_start] = ACTIONS(1676),
    [sym__html_block_5_start] = ACTIONS(1676),
    [sym__html_block_6_start] = ACTIONS(1676),
    [sym__html_block_7_start] = ACTIONS(1676),
    [sym__pipe_table_start] = ACTIONS(1676),
  },
  [241] = {
    [anon_sym_LBRACK] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1680),
    [anon_sym_GT] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_POUND] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_COLON] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_BSLASH] = ACTIONS(1680),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym__] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [aux_sym__word_token1] = ACTIONS(1680),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1680),
    [aux_sym__word_token2] = ACTIONS(1680),
    [sym__whitespace] = ACTIONS(1680),
    [sym__soft_line_ending] = ACTIONS(1680),
    [sym__block_close] = ACTIONS(1680),
    [sym__block_quote_start] = ACTIONS(1680),
    [sym__indented_chunk_start] = ACTIONS(1680),
    [sym_atx_h1_marker] = ACTIONS(1680),
    [sym_atx_h2_marker] = ACTIONS(1680),
    [sym_atx_h3_marker] = ACTIONS(1680),
    [sym_atx_h4_marker] = ACTIONS(1680),
    [sym_atx_h5_marker] = ACTIONS(1680),
    [sym_atx_h6_marker] = ACTIONS(1680),
    [sym__thematic_break] = ACTIONS(1680),
    [sym__list_marker_minus] = ACTIONS(1680),
    [sym__list_marker_plus] = ACTIONS(1680),
    [sym__list_marker_star] = ACTIONS(1680),
    [sym__list_marker_parenthesis] = ACTIONS(1680),
    [sym__list_marker_dot] = ACTIONS(1680),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1680),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1680),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1680),
    [sym__blank_line_start] = ACTIONS(1680),
    [sym__html_block_1_start] = ACTIONS(1680),
    [sym__html_block_2_start] = ACTIONS(1680),
    [sym__html_block_3_start] = ACTIONS(1680),
    [sym__html_block_4_start] = ACTIONS(1680),
    [sym__html_block_5_start] = ACTIONS(1680),
    [sym__html_block_6_start] = ACTIONS(1680),
    [sym__html_block_7_start] = ACTIONS(1680),
    [sym__pipe_table_start] = ACTIONS(1680),
  },
  [242] = {
    [anon_sym_LBRACK] = ACTIONS(1682),
    [anon_sym_RBRACK] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [anon_sym_POUND] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_PERCENT] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_COMMA] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_DOT] = ACTIONS(1684),
    [anon_sym_SLASH] = ACTIONS(1684),
    [anon_sym_COLON] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(1684),
    [anon_sym_QMARK] = ACTIONS(1684),
    [anon_sym_AT] = ACTIONS(1684),
    [anon_sym_BSLASH] = ACTIONS(1684),
    [anon_sym_CARET] = ACTIONS(1684),
    [anon_sym__] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RBRACE] = ACTIONS(1684),
    [anon_sym_TILDE] = ACTIONS(1684),
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [aux_sym__word_token1] = ACTIONS(1684),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1684),
    [aux_sym__word_token2] = ACTIONS(1684),
    [sym__whitespace] = ACTIONS(1684),
    [sym__soft_line_ending] = ACTIONS(1684),
    [sym__block_close] = ACTIONS(1684),
    [sym__block_quote_start] = ACTIONS(1684),
    [sym__indented_chunk_start] = ACTIONS(1684),
    [sym_atx_h1_marker] = ACTIONS(1684),
    [sym_atx_h2_marker] = ACTIONS(1684),
    [sym_atx_h3_marker] = ACTIONS(1684),
    [sym_atx_h4_marker] = ACTIONS(1684),
    [sym_atx_h5_marker] = ACTIONS(1684),
    [sym_atx_h6_marker] = ACTIONS(1684),
    [sym__thematic_break] = ACTIONS(1684),
    [sym__list_marker_minus] = ACTIONS(1684),
    [sym__list_marker_plus] = ACTIONS(1684),
    [sym__list_marker_star] = ACTIONS(1684),
    [sym__list_marker_parenthesis] = ACTIONS(1684),
    [sym__list_marker_dot] = ACTIONS(1684),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1684),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1684),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1684),
    [sym__blank_line_start] = ACTIONS(1684),
    [sym__html_block_1_start] = ACTIONS(1684),
    [sym__html_block_2_start] = ACTIONS(1684),
    [sym__html_block_3_start] = ACTIONS(1684),
    [sym__html_block_4_start] = ACTIONS(1684),
    [sym__html_block_5_start] = ACTIONS(1684),
    [sym__html_block_6_start] = ACTIONS(1684),
    [sym__html_block_7_start] = ACTIONS(1684),
    [sym__pipe_table_start] = ACTIONS(1684),
  },
  [243] = {
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_RBRACK] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [anon_sym_POUND] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1688),
    [anon_sym_SLASH] = ACTIONS(1688),
    [anon_sym_COLON] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1688),
    [anon_sym_BSLASH] = ACTIONS(1688),
    [anon_sym_CARET] = ACTIONS(1688),
    [anon_sym__] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [aux_sym__word_token1] = ACTIONS(1688),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1688),
    [aux_sym__word_token2] = ACTIONS(1688),
    [sym__whitespace] = ACTIONS(1688),
    [sym__soft_line_ending] = ACTIONS(1688),
    [sym__block_close] = ACTIONS(1688),
    [sym__block_quote_start] = ACTIONS(1688),
    [sym__indented_chunk_start] = ACTIONS(1688),
    [sym_atx_h1_marker] = ACTIONS(1688),
    [sym_atx_h2_marker] = ACTIONS(1688),
    [sym_atx_h3_marker] = ACTIONS(1688),
    [sym_atx_h4_marker] = ACTIONS(1688),
    [sym_atx_h5_marker] = ACTIONS(1688),
    [sym_atx_h6_marker] = ACTIONS(1688),
    [sym__thematic_break] = ACTIONS(1688),
    [sym__list_marker_minus] = ACTIONS(1688),
    [sym__list_marker_plus] = ACTIONS(1688),
    [sym__list_marker_star] = ACTIONS(1688),
    [sym__list_marker_parenthesis] = ACTIONS(1688),
    [sym__list_marker_dot] = ACTIONS(1688),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1688),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1688),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1688),
    [sym__blank_line_start] = ACTIONS(1688),
    [sym__html_block_1_start] = ACTIONS(1688),
    [sym__html_block_2_start] = ACTIONS(1688),
    [sym__html_block_3_start] = ACTIONS(1688),
    [sym__html_block_4_start] = ACTIONS(1688),
    [sym__html_block_5_start] = ACTIONS(1688),
    [sym__html_block_6_start] = ACTIONS(1688),
    [sym__html_block_7_start] = ACTIONS(1688),
    [sym__pipe_table_start] = ACTIONS(1688),
  },
  [244] = {
    [anon_sym_LBRACK] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(1692),
    [anon_sym_LT] = ACTIONS(1692),
    [anon_sym_GT] = ACTIONS(1692),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_DQUOTE] = ACTIONS(1692),
    [anon_sym_POUND] = ACTIONS(1692),
    [anon_sym_DOLLAR] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(1692),
    [anon_sym_SQUOTE] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_COMMA] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_DOT] = ACTIONS(1692),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_COLON] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1692),
    [anon_sym_EQ] = ACTIONS(1692),
    [anon_sym_QMARK] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(1692),
    [anon_sym_BSLASH] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1692),
    [anon_sym__] = ACTIONS(1692),
    [anon_sym_BQUOTE] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1692),
    [anon_sym_PIPE] = ACTIONS(1692),
    [anon_sym_RBRACE] = ACTIONS(1692),
    [anon_sym_TILDE] = ACTIONS(1692),
    [anon_sym_LPAREN] = ACTIONS(1692),
    [anon_sym_RPAREN] = ACTIONS(1692),
    [aux_sym__word_token1] = ACTIONS(1692),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1692),
    [aux_sym__word_token2] = ACTIONS(1692),
    [sym__whitespace] = ACTIONS(1692),
    [sym__soft_line_ending] = ACTIONS(1692),
    [sym_block_continuation] = ACTIONS(1692),
    [sym__block_quote_start] = ACTIONS(1692),
    [sym__indented_chunk_start] = ACTIONS(1692),
    [sym_atx_h1_marker] = ACTIONS(1692),
    [sym_atx_h2_marker] = ACTIONS(1692),
    [sym_atx_h3_marker] = ACTIONS(1692),
    [sym_atx_h4_marker] = ACTIONS(1692),
    [sym_atx_h5_marker] = ACTIONS(1692),
    [sym_atx_h6_marker] = ACTIONS(1692),
    [sym__thematic_break] = ACTIONS(1692),
    [sym__list_marker_minus] = ACTIONS(1692),
    [sym__list_marker_plus] = ACTIONS(1692),
    [sym__list_marker_star] = ACTIONS(1692),
    [sym__list_marker_parenthesis] = ACTIONS(1692),
    [sym__list_marker_dot] = ACTIONS(1692),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1692),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1692),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1692),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1692),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1692),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1692),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1692),
    [sym__blank_line_start] = ACTIONS(1692),
    [sym__html_block_1_start] = ACTIONS(1692),
    [sym__html_block_2_start] = ACTIONS(1692),
    [sym__html_block_3_start] = ACTIONS(1692),
    [sym__html_block_4_start] = ACTIONS(1692),
    [sym__html_block_5_start] = ACTIONS(1692),
    [sym__html_block_6_start] = ACTIONS(1692),
    [sym__html_block_7_start] = ACTIONS(1692),
    [sym__pipe_table_start] = ACTIONS(1692),
  },
  [245] = {
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [anon_sym_POUND] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [aux_sym__word_token1] = ACTIONS(1364),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1364),
    [aux_sym__word_token2] = ACTIONS(1364),
    [sym__whitespace] = ACTIONS(1364),
    [sym__soft_line_ending] = ACTIONS(1364),
    [sym__block_close] = ACTIONS(1364),
    [sym__block_quote_start] = ACTIONS(1364),
    [sym__indented_chunk_start] = ACTIONS(1364),
    [sym_atx_h1_marker] = ACTIONS(1364),
    [sym_atx_h2_marker] = ACTIONS(1364),
    [sym_atx_h3_marker] = ACTIONS(1364),
    [sym_atx_h4_marker] = ACTIONS(1364),
    [sym_atx_h5_marker] = ACTIONS(1364),
    [sym_atx_h6_marker] = ACTIONS(1364),
    [sym__thematic_break] = ACTIONS(1364),
    [sym__list_marker_minus] = ACTIONS(1364),
    [sym__list_marker_plus] = ACTIONS(1364),
    [sym__list_marker_star] = ACTIONS(1364),
    [sym__list_marker_parenthesis] = ACTIONS(1364),
    [sym__list_marker_dot] = ACTIONS(1364),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1364),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1364),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1364),
    [sym__blank_line_start] = ACTIONS(1364),
    [sym__html_block_1_start] = ACTIONS(1364),
    [sym__html_block_2_start] = ACTIONS(1364),
    [sym__html_block_3_start] = ACTIONS(1364),
    [sym__html_block_4_start] = ACTIONS(1364),
    [sym__html_block_5_start] = ACTIONS(1364),
    [sym__html_block_6_start] = ACTIONS(1364),
    [sym__html_block_7_start] = ACTIONS(1364),
    [sym__pipe_table_start] = ACTIONS(1364),
  },
  [246] = {
    [anon_sym_LBRACK] = ACTIONS(1694),
    [anon_sym_RBRACK] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1696),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [anon_sym_POUND] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1696),
    [anon_sym_PERCENT] = ACTIONS(1696),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1696),
    [anon_sym_COMMA] = ACTIONS(1696),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_DOT] = ACTIONS(1696),
    [anon_sym_SLASH] = ACTIONS(1696),
    [anon_sym_COLON] = ACTIONS(1696),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_EQ] = ACTIONS(1696),
    [anon_sym_QMARK] = ACTIONS(1696),
    [anon_sym_AT] = ACTIONS(1696),
    [anon_sym_BSLASH] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1696),
    [anon_sym__] = ACTIONS(1696),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(1696),
    [anon_sym_RBRACE] = ACTIONS(1696),
    [anon_sym_TILDE] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1696),
    [anon_sym_RPAREN] = ACTIONS(1696),
    [aux_sym__word_token1] = ACTIONS(1696),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1696),
    [aux_sym__word_token2] = ACTIONS(1696),
    [sym__whitespace] = ACTIONS(1696),
    [sym__soft_line_ending] = ACTIONS(1696),
    [sym_block_continuation] = ACTIONS(1696),
    [sym__block_quote_start] = ACTIONS(1696),
    [sym__indented_chunk_start] = ACTIONS(1696),
    [sym_atx_h1_marker] = ACTIONS(1696),
    [sym_atx_h2_marker] = ACTIONS(1696),
    [sym_atx_h3_marker] = ACTIONS(1696),
    [sym_atx_h4_marker] = ACTIONS(1696),
    [sym_atx_h5_marker] = ACTIONS(1696),
    [sym_atx_h6_marker] = ACTIONS(1696),
    [sym__thematic_break] = ACTIONS(1696),
    [sym__list_marker_minus] = ACTIONS(1696),
    [sym__list_marker_plus] = ACTIONS(1696),
    [sym__list_marker_star] = ACTIONS(1696),
    [sym__list_marker_parenthesis] = ACTIONS(1696),
    [sym__list_marker_dot] = ACTIONS(1696),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1696),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1696),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1696),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1696),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1696),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1696),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1696),
    [sym__blank_line_start] = ACTIONS(1696),
    [sym__html_block_1_start] = ACTIONS(1696),
    [sym__html_block_2_start] = ACTIONS(1696),
    [sym__html_block_3_start] = ACTIONS(1696),
    [sym__html_block_4_start] = ACTIONS(1696),
    [sym__html_block_5_start] = ACTIONS(1696),
    [sym__html_block_6_start] = ACTIONS(1696),
    [sym__html_block_7_start] = ACTIONS(1696),
    [sym__pipe_table_start] = ACTIONS(1696),
  },
  [247] = {
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_RBRACK] = ACTIONS(1700),
    [anon_sym_LT] = ACTIONS(1700),
    [anon_sym_GT] = ACTIONS(1700),
    [anon_sym_BANG] = ACTIONS(1700),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [anon_sym_POUND] = ACTIONS(1700),
    [anon_sym_DOLLAR] = ACTIONS(1700),
    [anon_sym_PERCENT] = ACTIONS(1700),
    [anon_sym_AMP] = ACTIONS(1700),
    [anon_sym_SQUOTE] = ACTIONS(1700),
    [anon_sym_STAR] = ACTIONS(1700),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DOT] = ACTIONS(1700),
    [anon_sym_SLASH] = ACTIONS(1700),
    [anon_sym_COLON] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1700),
    [anon_sym_EQ] = ACTIONS(1700),
    [anon_sym_QMARK] = ACTIONS(1700),
    [anon_sym_AT] = ACTIONS(1700),
    [anon_sym_BSLASH] = ACTIONS(1700),
    [anon_sym_CARET] = ACTIONS(1700),
    [anon_sym__] = ACTIONS(1700),
    [anon_sym_BQUOTE] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1700),
    [anon_sym_PIPE] = ACTIONS(1700),
    [anon_sym_RBRACE] = ACTIONS(1700),
    [anon_sym_TILDE] = ACTIONS(1700),
    [anon_sym_LPAREN] = ACTIONS(1700),
    [anon_sym_RPAREN] = ACTIONS(1700),
    [aux_sym__word_token1] = ACTIONS(1700),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1700),
    [aux_sym__word_token2] = ACTIONS(1700),
    [sym__whitespace] = ACTIONS(1700),
    [sym__soft_line_ending] = ACTIONS(1700),
    [sym_block_continuation] = ACTIONS(1700),
    [sym__block_quote_start] = ACTIONS(1700),
    [sym__indented_chunk_start] = ACTIONS(1700),
    [sym_atx_h1_marker] = ACTIONS(1700),
    [sym_atx_h2_marker] = ACTIONS(1700),
    [sym_atx_h3_marker] = ACTIONS(1700),
    [sym_atx_h4_marker] = ACTIONS(1700),
    [sym_atx_h5_marker] = ACTIONS(1700),
    [sym_atx_h6_marker] = ACTIONS(1700),
    [sym__thematic_break] = ACTIONS(1700),
    [sym__list_marker_minus] = ACTIONS(1700),
    [sym__list_marker_plus] = ACTIONS(1700),
    [sym__list_marker_star] = ACTIONS(1700),
    [sym__list_marker_parenthesis] = ACTIONS(1700),
    [sym__list_marker_dot] = ACTIONS(1700),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1700),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1700),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1700),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1700),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1700),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1700),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1700),
    [sym__blank_line_start] = ACTIONS(1700),
    [sym__html_block_1_start] = ACTIONS(1700),
    [sym__html_block_2_start] = ACTIONS(1700),
    [sym__html_block_3_start] = ACTIONS(1700),
    [sym__html_block_4_start] = ACTIONS(1700),
    [sym__html_block_5_start] = ACTIONS(1700),
    [sym__html_block_6_start] = ACTIONS(1700),
    [sym__html_block_7_start] = ACTIONS(1700),
    [sym__pipe_table_start] = ACTIONS(1700),
  },
  [248] = {
    [anon_sym_LBRACK] = ACTIONS(1702),
    [anon_sym_RBRACK] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_BANG] = ACTIONS(1704),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_POUND] = ACTIONS(1704),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_AMP] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_PLUS] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1704),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_SLASH] = ACTIONS(1704),
    [anon_sym_COLON] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_EQ] = ACTIONS(1704),
    [anon_sym_QMARK] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_BSLASH] = ACTIONS(1704),
    [anon_sym_CARET] = ACTIONS(1704),
    [anon_sym__] = ACTIONS(1704),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_TILDE] = ACTIONS(1704),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(1704),
    [aux_sym__word_token1] = ACTIONS(1704),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1704),
    [aux_sym__word_token2] = ACTIONS(1704),
    [sym__whitespace] = ACTIONS(1704),
    [sym__soft_line_ending] = ACTIONS(1704),
    [sym__block_close] = ACTIONS(1704),
    [sym__block_quote_start] = ACTIONS(1704),
    [sym__indented_chunk_start] = ACTIONS(1704),
    [sym_atx_h1_marker] = ACTIONS(1704),
    [sym_atx_h2_marker] = ACTIONS(1704),
    [sym_atx_h3_marker] = ACTIONS(1704),
    [sym_atx_h4_marker] = ACTIONS(1704),
    [sym_atx_h5_marker] = ACTIONS(1704),
    [sym_atx_h6_marker] = ACTIONS(1704),
    [sym__thematic_break] = ACTIONS(1704),
    [sym__list_marker_minus] = ACTIONS(1704),
    [sym__list_marker_plus] = ACTIONS(1704),
    [sym__list_marker_star] = ACTIONS(1704),
    [sym__list_marker_parenthesis] = ACTIONS(1704),
    [sym__list_marker_dot] = ACTIONS(1704),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1704),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1704),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1704),
    [sym__blank_line_start] = ACTIONS(1704),
    [sym__html_block_1_start] = ACTIONS(1704),
    [sym__html_block_2_start] = ACTIONS(1704),
    [sym__html_block_3_start] = ACTIONS(1704),
    [sym__html_block_4_start] = ACTIONS(1704),
    [sym__html_block_5_start] = ACTIONS(1704),
    [sym__html_block_6_start] = ACTIONS(1704),
    [sym__html_block_7_start] = ACTIONS(1704),
    [sym__pipe_table_start] = ACTIONS(1704),
  },
  [249] = {
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_RBRACK] = ACTIONS(1708),
    [anon_sym_LT] = ACTIONS(1708),
    [anon_sym_GT] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(1708),
    [anon_sym_DQUOTE] = ACTIONS(1708),
    [anon_sym_POUND] = ACTIONS(1708),
    [anon_sym_DOLLAR] = ACTIONS(1708),
    [anon_sym_PERCENT] = ACTIONS(1708),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1708),
    [anon_sym_PLUS] = ACTIONS(1708),
    [anon_sym_COMMA] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1708),
    [anon_sym_DOT] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1708),
    [anon_sym_COLON] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1708),
    [anon_sym_EQ] = ACTIONS(1708),
    [anon_sym_QMARK] = ACTIONS(1708),
    [anon_sym_AT] = ACTIONS(1708),
    [anon_sym_BSLASH] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1708),
    [anon_sym__] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1708),
    [anon_sym_LBRACE] = ACTIONS(1708),
    [anon_sym_PIPE] = ACTIONS(1708),
    [anon_sym_RBRACE] = ACTIONS(1708),
    [anon_sym_TILDE] = ACTIONS(1708),
    [anon_sym_LPAREN] = ACTIONS(1708),
    [anon_sym_RPAREN] = ACTIONS(1708),
    [aux_sym__word_token1] = ACTIONS(1708),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1708),
    [aux_sym__word_token2] = ACTIONS(1708),
    [sym__whitespace] = ACTIONS(1708),
    [sym__soft_line_ending] = ACTIONS(1708),
    [sym__block_close] = ACTIONS(1708),
    [sym__block_quote_start] = ACTIONS(1708),
    [sym__indented_chunk_start] = ACTIONS(1708),
    [sym_atx_h1_marker] = ACTIONS(1708),
    [sym_atx_h2_marker] = ACTIONS(1708),
    [sym_atx_h3_marker] = ACTIONS(1708),
    [sym_atx_h4_marker] = ACTIONS(1708),
    [sym_atx_h5_marker] = ACTIONS(1708),
    [sym_atx_h6_marker] = ACTIONS(1708),
    [sym__thematic_break] = ACTIONS(1708),
    [sym__list_marker_minus] = ACTIONS(1708),
    [sym__list_marker_plus] = ACTIONS(1708),
    [sym__list_marker_star] = ACTIONS(1708),
    [sym__list_marker_parenthesis] = ACTIONS(1708),
    [sym__list_marker_dot] = ACTIONS(1708),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1708),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1708),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1708),
    [sym__blank_line_start] = ACTIONS(1708),
    [sym__html_block_1_start] = ACTIONS(1708),
    [sym__html_block_2_start] = ACTIONS(1708),
    [sym__html_block_3_start] = ACTIONS(1708),
    [sym__html_block_4_start] = ACTIONS(1708),
    [sym__html_block_5_start] = ACTIONS(1708),
    [sym__html_block_6_start] = ACTIONS(1708),
    [sym__html_block_7_start] = ACTIONS(1708),
    [sym__pipe_table_start] = ACTIONS(1708),
  },
  [250] = {
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_EQ] = ACTIONS(1448),
    [anon_sym_QMARK] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym__] = ACTIONS(1448),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [aux_sym__word_token1] = ACTIONS(1448),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1448),
    [aux_sym__word_token2] = ACTIONS(1448),
    [sym__whitespace] = ACTIONS(1448),
    [sym__soft_line_ending] = ACTIONS(1448),
    [sym__block_close] = ACTIONS(1448),
    [sym__block_quote_start] = ACTIONS(1448),
    [sym__indented_chunk_start] = ACTIONS(1448),
    [sym_atx_h1_marker] = ACTIONS(1448),
    [sym_atx_h2_marker] = ACTIONS(1448),
    [sym_atx_h3_marker] = ACTIONS(1448),
    [sym_atx_h4_marker] = ACTIONS(1448),
    [sym_atx_h5_marker] = ACTIONS(1448),
    [sym_atx_h6_marker] = ACTIONS(1448),
    [sym__thematic_break] = ACTIONS(1448),
    [sym__list_marker_minus] = ACTIONS(1448),
    [sym__list_marker_plus] = ACTIONS(1448),
    [sym__list_marker_star] = ACTIONS(1448),
    [sym__list_marker_parenthesis] = ACTIONS(1448),
    [sym__list_marker_dot] = ACTIONS(1448),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1448),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1448),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1448),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1448),
    [sym__blank_line_start] = ACTIONS(1448),
    [sym__html_block_1_start] = ACTIONS(1448),
    [sym__html_block_2_start] = ACTIONS(1448),
    [sym__html_block_3_start] = ACTIONS(1448),
    [sym__html_block_4_start] = ACTIONS(1448),
    [sym__html_block_5_start] = ACTIONS(1448),
    [sym__html_block_6_start] = ACTIONS(1448),
    [sym__html_block_7_start] = ACTIONS(1448),
    [sym__pipe_table_start] = ACTIONS(1448),
  },
  [251] = {
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [aux_sym__word_token1] = ACTIONS(1418),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1418),
    [aux_sym__word_token2] = ACTIONS(1418),
    [sym__whitespace] = ACTIONS(1418),
    [sym__soft_line_ending] = ACTIONS(1418),
    [sym__block_close] = ACTIONS(1418),
    [sym__block_quote_start] = ACTIONS(1418),
    [sym__indented_chunk_start] = ACTIONS(1418),
    [sym_atx_h1_marker] = ACTIONS(1418),
    [sym_atx_h2_marker] = ACTIONS(1418),
    [sym_atx_h3_marker] = ACTIONS(1418),
    [sym_atx_h4_marker] = ACTIONS(1418),
    [sym_atx_h5_marker] = ACTIONS(1418),
    [sym_atx_h6_marker] = ACTIONS(1418),
    [sym__thematic_break] = ACTIONS(1418),
    [sym__list_marker_minus] = ACTIONS(1418),
    [sym__list_marker_plus] = ACTIONS(1418),
    [sym__list_marker_star] = ACTIONS(1418),
    [sym__list_marker_parenthesis] = ACTIONS(1418),
    [sym__list_marker_dot] = ACTIONS(1418),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1418),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1418),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1418),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1418),
    [sym__blank_line_start] = ACTIONS(1418),
    [sym__html_block_1_start] = ACTIONS(1418),
    [sym__html_block_2_start] = ACTIONS(1418),
    [sym__html_block_3_start] = ACTIONS(1418),
    [sym__html_block_4_start] = ACTIONS(1418),
    [sym__html_block_5_start] = ACTIONS(1418),
    [sym__html_block_6_start] = ACTIONS(1418),
    [sym__html_block_7_start] = ACTIONS(1418),
    [sym__pipe_table_start] = ACTIONS(1418),
  },
  [252] = {
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_RBRACK] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1440),
    [anon_sym__] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [aux_sym__word_token1] = ACTIONS(1440),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1440),
    [aux_sym__word_token2] = ACTIONS(1440),
    [sym__whitespace] = ACTIONS(1440),
    [sym__soft_line_ending] = ACTIONS(1440),
    [sym__block_close] = ACTIONS(1440),
    [sym__block_quote_start] = ACTIONS(1440),
    [sym__indented_chunk_start] = ACTIONS(1440),
    [sym_atx_h1_marker] = ACTIONS(1440),
    [sym_atx_h2_marker] = ACTIONS(1440),
    [sym_atx_h3_marker] = ACTIONS(1440),
    [sym_atx_h4_marker] = ACTIONS(1440),
    [sym_atx_h5_marker] = ACTIONS(1440),
    [sym_atx_h6_marker] = ACTIONS(1440),
    [sym__thematic_break] = ACTIONS(1440),
    [sym__list_marker_minus] = ACTIONS(1440),
    [sym__list_marker_plus] = ACTIONS(1440),
    [sym__list_marker_star] = ACTIONS(1440),
    [sym__list_marker_parenthesis] = ACTIONS(1440),
    [sym__list_marker_dot] = ACTIONS(1440),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1440),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1440),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1440),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1440),
    [sym__blank_line_start] = ACTIONS(1440),
    [sym__html_block_1_start] = ACTIONS(1440),
    [sym__html_block_2_start] = ACTIONS(1440),
    [sym__html_block_3_start] = ACTIONS(1440),
    [sym__html_block_4_start] = ACTIONS(1440),
    [sym__html_block_5_start] = ACTIONS(1440),
    [sym__html_block_6_start] = ACTIONS(1440),
    [sym__html_block_7_start] = ACTIONS(1440),
    [sym__pipe_table_start] = ACTIONS(1440),
  },
  [253] = {
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_RBRACK] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym__] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [aux_sym__word_token1] = ACTIONS(1434),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1434),
    [aux_sym__word_token2] = ACTIONS(1434),
    [sym__whitespace] = ACTIONS(1434),
    [sym__soft_line_ending] = ACTIONS(1434),
    [sym__block_close] = ACTIONS(1434),
    [sym__block_quote_start] = ACTIONS(1434),
    [sym__indented_chunk_start] = ACTIONS(1434),
    [sym_atx_h1_marker] = ACTIONS(1434),
    [sym_atx_h2_marker] = ACTIONS(1434),
    [sym_atx_h3_marker] = ACTIONS(1434),
    [sym_atx_h4_marker] = ACTIONS(1434),
    [sym_atx_h5_marker] = ACTIONS(1434),
    [sym_atx_h6_marker] = ACTIONS(1434),
    [sym__thematic_break] = ACTIONS(1434),
    [sym__list_marker_minus] = ACTIONS(1434),
    [sym__list_marker_plus] = ACTIONS(1434),
    [sym__list_marker_star] = ACTIONS(1434),
    [sym__list_marker_parenthesis] = ACTIONS(1434),
    [sym__list_marker_dot] = ACTIONS(1434),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1434),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1434),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1434),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1434),
    [sym__blank_line_start] = ACTIONS(1434),
    [sym__html_block_1_start] = ACTIONS(1434),
    [sym__html_block_2_start] = ACTIONS(1434),
    [sym__html_block_3_start] = ACTIONS(1434),
    [sym__html_block_4_start] = ACTIONS(1434),
    [sym__html_block_5_start] = ACTIONS(1434),
    [sym__html_block_6_start] = ACTIONS(1434),
    [sym__html_block_7_start] = ACTIONS(1434),
    [sym__pipe_table_start] = ACTIONS(1434),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1708),
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_RBRACK] = ACTIONS(1708),
    [anon_sym_LT] = ACTIONS(1708),
    [anon_sym_GT] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(1708),
    [anon_sym_DQUOTE] = ACTIONS(1708),
    [anon_sym_POUND] = ACTIONS(1708),
    [anon_sym_DOLLAR] = ACTIONS(1708),
    [anon_sym_PERCENT] = ACTIONS(1708),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1708),
    [anon_sym_PLUS] = ACTIONS(1708),
    [anon_sym_COMMA] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1708),
    [anon_sym_DOT] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1708),
    [anon_sym_COLON] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1708),
    [anon_sym_EQ] = ACTIONS(1708),
    [anon_sym_QMARK] = ACTIONS(1708),
    [anon_sym_AT] = ACTIONS(1708),
    [anon_sym_BSLASH] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1708),
    [anon_sym__] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1708),
    [anon_sym_LBRACE] = ACTIONS(1708),
    [anon_sym_PIPE] = ACTIONS(1708),
    [anon_sym_RBRACE] = ACTIONS(1708),
    [anon_sym_TILDE] = ACTIONS(1708),
    [anon_sym_LPAREN] = ACTIONS(1708),
    [anon_sym_RPAREN] = ACTIONS(1708),
    [aux_sym__word_token1] = ACTIONS(1708),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1708),
    [aux_sym__word_token2] = ACTIONS(1708),
    [sym__whitespace] = ACTIONS(1708),
    [sym__soft_line_ending] = ACTIONS(1708),
    [sym__block_quote_start] = ACTIONS(1708),
    [sym__indented_chunk_start] = ACTIONS(1708),
    [sym_atx_h1_marker] = ACTIONS(1708),
    [sym_atx_h2_marker] = ACTIONS(1708),
    [sym_atx_h3_marker] = ACTIONS(1708),
    [sym_atx_h4_marker] = ACTIONS(1708),
    [sym_atx_h5_marker] = ACTIONS(1708),
    [sym_atx_h6_marker] = ACTIONS(1708),
    [sym__thematic_break] = ACTIONS(1708),
    [sym__list_marker_minus] = ACTIONS(1708),
    [sym__list_marker_plus] = ACTIONS(1708),
    [sym__list_marker_star] = ACTIONS(1708),
    [sym__list_marker_parenthesis] = ACTIONS(1708),
    [sym__list_marker_dot] = ACTIONS(1708),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1708),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1708),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1708),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1708),
    [sym__blank_line_start] = ACTIONS(1708),
    [sym__html_block_1_start] = ACTIONS(1708),
    [sym__html_block_2_start] = ACTIONS(1708),
    [sym__html_block_3_start] = ACTIONS(1708),
    [sym__html_block_4_start] = ACTIONS(1708),
    [sym__html_block_5_start] = ACTIONS(1708),
    [sym__html_block_6_start] = ACTIONS(1708),
    [sym__html_block_7_start] = ACTIONS(1708),
    [sym__pipe_table_start] = ACTIONS(1708),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(1704),
    [anon_sym_LBRACK] = ACTIONS(1702),
    [anon_sym_RBRACK] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1704),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_BANG] = ACTIONS(1704),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_POUND] = ACTIONS(1704),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_AMP] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_PLUS] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1704),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_SLASH] = ACTIONS(1704),
    [anon_sym_COLON] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_EQ] = ACTIONS(1704),
    [anon_sym_QMARK] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_BSLASH] = ACTIONS(1704),
    [anon_sym_CARET] = ACTIONS(1704),
    [anon_sym__] = ACTIONS(1704),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_TILDE] = ACTIONS(1704),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(1704),
    [aux_sym__word_token1] = ACTIONS(1704),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1704),
    [aux_sym__word_token2] = ACTIONS(1704),
    [sym__whitespace] = ACTIONS(1704),
    [sym__soft_line_ending] = ACTIONS(1704),
    [sym__block_quote_start] = ACTIONS(1704),
    [sym__indented_chunk_start] = ACTIONS(1704),
    [sym_atx_h1_marker] = ACTIONS(1704),
    [sym_atx_h2_marker] = ACTIONS(1704),
    [sym_atx_h3_marker] = ACTIONS(1704),
    [sym_atx_h4_marker] = ACTIONS(1704),
    [sym_atx_h5_marker] = ACTIONS(1704),
    [sym_atx_h6_marker] = ACTIONS(1704),
    [sym__thematic_break] = ACTIONS(1704),
    [sym__list_marker_minus] = ACTIONS(1704),
    [sym__list_marker_plus] = ACTIONS(1704),
    [sym__list_marker_star] = ACTIONS(1704),
    [sym__list_marker_parenthesis] = ACTIONS(1704),
    [sym__list_marker_dot] = ACTIONS(1704),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1704),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1704),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1704),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1704),
    [sym__blank_line_start] = ACTIONS(1704),
    [sym__html_block_1_start] = ACTIONS(1704),
    [sym__html_block_2_start] = ACTIONS(1704),
    [sym__html_block_3_start] = ACTIONS(1704),
    [sym__html_block_4_start] = ACTIONS(1704),
    [sym__html_block_5_start] = ACTIONS(1704),
    [sym__html_block_6_start] = ACTIONS(1704),
    [sym__html_block_7_start] = ACTIONS(1704),
    [sym__pipe_table_start] = ACTIONS(1704),
  },
  [256] = {
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym__] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [aux_sym__word_token1] = ACTIONS(1428),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1428),
    [aux_sym__word_token2] = ACTIONS(1428),
    [sym__whitespace] = ACTIONS(1428),
    [sym__soft_line_ending] = ACTIONS(1428),
    [sym__block_close] = ACTIONS(1428),
    [sym__block_quote_start] = ACTIONS(1428),
    [sym__indented_chunk_start] = ACTIONS(1428),
    [sym_atx_h1_marker] = ACTIONS(1428),
    [sym_atx_h2_marker] = ACTIONS(1428),
    [sym_atx_h3_marker] = ACTIONS(1428),
    [sym_atx_h4_marker] = ACTIONS(1428),
    [sym_atx_h5_marker] = ACTIONS(1428),
    [sym_atx_h6_marker] = ACTIONS(1428),
    [sym__thematic_break] = ACTIONS(1428),
    [sym__list_marker_minus] = ACTIONS(1428),
    [sym__list_marker_plus] = ACTIONS(1428),
    [sym__list_marker_star] = ACTIONS(1428),
    [sym__list_marker_parenthesis] = ACTIONS(1428),
    [sym__list_marker_dot] = ACTIONS(1428),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1428),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1428),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1428),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1428),
    [sym__blank_line_start] = ACTIONS(1428),
    [sym__html_block_1_start] = ACTIONS(1428),
    [sym__html_block_2_start] = ACTIONS(1428),
    [sym__html_block_3_start] = ACTIONS(1428),
    [sym__html_block_4_start] = ACTIONS(1428),
    [sym__html_block_5_start] = ACTIONS(1428),
    [sym__html_block_6_start] = ACTIONS(1428),
    [sym__html_block_7_start] = ACTIONS(1428),
    [sym__pipe_table_start] = ACTIONS(1428),
  },
  [257] = {
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_POUND] = ACTIONS(1408),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_COLON] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym__] = ACTIONS(1408),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(1408),
    [aux_sym__word_token1] = ACTIONS(1408),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1408),
    [aux_sym__word_token2] = ACTIONS(1408),
    [sym__whitespace] = ACTIONS(1408),
    [sym__soft_line_ending] = ACTIONS(1408),
    [sym__block_close] = ACTIONS(1408),
    [sym__block_quote_start] = ACTIONS(1408),
    [sym__indented_chunk_start] = ACTIONS(1408),
    [sym_atx_h1_marker] = ACTIONS(1408),
    [sym_atx_h2_marker] = ACTIONS(1408),
    [sym_atx_h3_marker] = ACTIONS(1408),
    [sym_atx_h4_marker] = ACTIONS(1408),
    [sym_atx_h5_marker] = ACTIONS(1408),
    [sym_atx_h6_marker] = ACTIONS(1408),
    [sym__thematic_break] = ACTIONS(1408),
    [sym__list_marker_minus] = ACTIONS(1408),
    [sym__list_marker_plus] = ACTIONS(1408),
    [sym__list_marker_star] = ACTIONS(1408),
    [sym__list_marker_parenthesis] = ACTIONS(1408),
    [sym__list_marker_dot] = ACTIONS(1408),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1408),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1408),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1408),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1408),
    [sym__blank_line_start] = ACTIONS(1408),
    [sym__html_block_1_start] = ACTIONS(1408),
    [sym__html_block_2_start] = ACTIONS(1408),
    [sym__html_block_3_start] = ACTIONS(1408),
    [sym__html_block_4_start] = ACTIONS(1408),
    [sym__html_block_5_start] = ACTIONS(1408),
    [sym__html_block_6_start] = ACTIONS(1408),
    [sym__html_block_7_start] = ACTIONS(1408),
    [sym__pipe_table_start] = ACTIONS(1408),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(1710),
    [anon_sym_LBRACK] = ACTIONS(1712),
    [anon_sym_RBRACK] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_GT] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_POUND] = ACTIONS(1710),
    [anon_sym_DOLLAR] = ACTIONS(1710),
    [anon_sym_PERCENT] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_COMMA] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_DOT] = ACTIONS(1710),
    [anon_sym_SLASH] = ACTIONS(1710),
    [anon_sym_COLON] = ACTIONS(1710),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_EQ] = ACTIONS(1710),
    [anon_sym_QMARK] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_BSLASH] = ACTIONS(1710),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym__] = ACTIONS(1710),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_RPAREN] = ACTIONS(1710),
    [aux_sym__word_token1] = ACTIONS(1710),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1710),
    [aux_sym__word_token2] = ACTIONS(1710),
    [sym__whitespace] = ACTIONS(1710),
    [sym__soft_line_ending] = ACTIONS(1710),
    [sym__block_quote_start] = ACTIONS(1710),
    [sym__indented_chunk_start] = ACTIONS(1710),
    [sym_atx_h1_marker] = ACTIONS(1710),
    [sym_atx_h2_marker] = ACTIONS(1710),
    [sym_atx_h3_marker] = ACTIONS(1710),
    [sym_atx_h4_marker] = ACTIONS(1710),
    [sym_atx_h5_marker] = ACTIONS(1710),
    [sym_atx_h6_marker] = ACTIONS(1710),
    [sym__thematic_break] = ACTIONS(1710),
    [sym__list_marker_minus] = ACTIONS(1710),
    [sym__list_marker_plus] = ACTIONS(1710),
    [sym__list_marker_star] = ACTIONS(1710),
    [sym__list_marker_parenthesis] = ACTIONS(1710),
    [sym__list_marker_dot] = ACTIONS(1710),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1710),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1710),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1710),
    [sym__blank_line_start] = ACTIONS(1710),
    [sym__html_block_1_start] = ACTIONS(1710),
    [sym__html_block_2_start] = ACTIONS(1710),
    [sym__html_block_3_start] = ACTIONS(1710),
    [sym__html_block_4_start] = ACTIONS(1710),
    [sym__html_block_5_start] = ACTIONS(1710),
    [sym__html_block_6_start] = ACTIONS(1710),
    [sym__html_block_7_start] = ACTIONS(1710),
    [sym__pipe_table_start] = ACTIONS(1710),
  },
  [259] = {
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym__] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [aux_sym__word_token1] = ACTIONS(1390),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1390),
    [aux_sym__word_token2] = ACTIONS(1390),
    [sym__whitespace] = ACTIONS(1390),
    [sym__soft_line_ending] = ACTIONS(1390),
    [sym__block_close] = ACTIONS(1390),
    [sym__block_quote_start] = ACTIONS(1390),
    [sym__indented_chunk_start] = ACTIONS(1390),
    [sym_atx_h1_marker] = ACTIONS(1390),
    [sym_atx_h2_marker] = ACTIONS(1390),
    [sym_atx_h3_marker] = ACTIONS(1390),
    [sym_atx_h4_marker] = ACTIONS(1390),
    [sym_atx_h5_marker] = ACTIONS(1390),
    [sym_atx_h6_marker] = ACTIONS(1390),
    [sym__thematic_break] = ACTIONS(1390),
    [sym__list_marker_minus] = ACTIONS(1390),
    [sym__list_marker_plus] = ACTIONS(1390),
    [sym__list_marker_star] = ACTIONS(1390),
    [sym__list_marker_parenthesis] = ACTIONS(1390),
    [sym__list_marker_dot] = ACTIONS(1390),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1390),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1390),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1390),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1390),
    [sym__blank_line_start] = ACTIONS(1390),
    [sym__html_block_1_start] = ACTIONS(1390),
    [sym__html_block_2_start] = ACTIONS(1390),
    [sym__html_block_3_start] = ACTIONS(1390),
    [sym__html_block_4_start] = ACTIONS(1390),
    [sym__html_block_5_start] = ACTIONS(1390),
    [sym__html_block_6_start] = ACTIONS(1390),
    [sym__html_block_7_start] = ACTIONS(1390),
    [sym__pipe_table_start] = ACTIONS(1390),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(1716),
    [anon_sym_RBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_GT] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1714),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_DOLLAR] = ACTIONS(1714),
    [anon_sym_PERCENT] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1714),
    [anon_sym_PLUS] = ACTIONS(1714),
    [anon_sym_COMMA] = ACTIONS(1714),
    [anon_sym_DASH] = ACTIONS(1714),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_SLASH] = ACTIONS(1714),
    [anon_sym_COLON] = ACTIONS(1714),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_EQ] = ACTIONS(1714),
    [anon_sym_QMARK] = ACTIONS(1714),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_BSLASH] = ACTIONS(1714),
    [anon_sym_CARET] = ACTIONS(1714),
    [anon_sym__] = ACTIONS(1714),
    [anon_sym_BQUOTE] = ACTIONS(1714),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_TILDE] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(1714),
    [aux_sym__word_token1] = ACTIONS(1714),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1714),
    [aux_sym__word_token2] = ACTIONS(1714),
    [sym__whitespace] = ACTIONS(1714),
    [sym__soft_line_ending] = ACTIONS(1714),
    [sym__block_quote_start] = ACTIONS(1714),
    [sym__indented_chunk_start] = ACTIONS(1714),
    [sym_atx_h1_marker] = ACTIONS(1714),
    [sym_atx_h2_marker] = ACTIONS(1714),
    [sym_atx_h3_marker] = ACTIONS(1714),
    [sym_atx_h4_marker] = ACTIONS(1714),
    [sym_atx_h5_marker] = ACTIONS(1714),
    [sym_atx_h6_marker] = ACTIONS(1714),
    [sym__thematic_break] = ACTIONS(1714),
    [sym__list_marker_minus] = ACTIONS(1714),
    [sym__list_marker_plus] = ACTIONS(1714),
    [sym__list_marker_star] = ACTIONS(1714),
    [sym__list_marker_parenthesis] = ACTIONS(1714),
    [sym__list_marker_dot] = ACTIONS(1714),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1714),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1714),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1714),
    [sym__blank_line_start] = ACTIONS(1714),
    [sym__html_block_1_start] = ACTIONS(1714),
    [sym__html_block_2_start] = ACTIONS(1714),
    [sym__html_block_3_start] = ACTIONS(1714),
    [sym__html_block_4_start] = ACTIONS(1714),
    [sym__html_block_5_start] = ACTIONS(1714),
    [sym__html_block_6_start] = ACTIONS(1714),
    [sym__html_block_7_start] = ACTIONS(1714),
    [sym__pipe_table_start] = ACTIONS(1714),
  },
  [261] = {
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(1598),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_BANG] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_POUND] = ACTIONS(1598),
    [anon_sym_DOLLAR] = ACTIONS(1598),
    [anon_sym_PERCENT] = ACTIONS(1598),
    [anon_sym_AMP] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [anon_sym_STAR] = ACTIONS(1598),
    [anon_sym_PLUS] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1598),
    [anon_sym_DASH] = ACTIONS(1598),
    [anon_sym_DOT] = ACTIONS(1598),
    [anon_sym_SLASH] = ACTIONS(1598),
    [anon_sym_COLON] = ACTIONS(1598),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_EQ] = ACTIONS(1598),
    [anon_sym_QMARK] = ACTIONS(1598),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_BSLASH] = ACTIONS(1598),
    [anon_sym_CARET] = ACTIONS(1598),
    [anon_sym__] = ACTIONS(1598),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [aux_sym__word_token1] = ACTIONS(1598),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1598),
    [aux_sym__word_token2] = ACTIONS(1598),
    [sym__whitespace] = ACTIONS(1598),
    [sym__soft_line_ending] = ACTIONS(1598),
    [sym__block_close] = ACTIONS(1598),
    [sym__block_quote_start] = ACTIONS(1598),
    [sym__indented_chunk_start] = ACTIONS(1598),
    [sym_atx_h1_marker] = ACTIONS(1598),
    [sym_atx_h2_marker] = ACTIONS(1598),
    [sym_atx_h3_marker] = ACTIONS(1598),
    [sym_atx_h4_marker] = ACTIONS(1598),
    [sym_atx_h5_marker] = ACTIONS(1598),
    [sym_atx_h6_marker] = ACTIONS(1598),
    [sym__thematic_break] = ACTIONS(1598),
    [sym__list_marker_minus] = ACTIONS(1598),
    [sym__list_marker_plus] = ACTIONS(1598),
    [sym__list_marker_star] = ACTIONS(1598),
    [sym__list_marker_parenthesis] = ACTIONS(1598),
    [sym__list_marker_dot] = ACTIONS(1598),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1598),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1598),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1598),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1598),
    [sym__blank_line_start] = ACTIONS(1598),
    [sym__html_block_1_start] = ACTIONS(1598),
    [sym__html_block_2_start] = ACTIONS(1598),
    [sym__html_block_3_start] = ACTIONS(1598),
    [sym__html_block_4_start] = ACTIONS(1598),
    [sym__html_block_5_start] = ACTIONS(1598),
    [sym__html_block_6_start] = ACTIONS(1598),
    [sym__html_block_7_start] = ACTIONS(1598),
    [sym__pipe_table_start] = ACTIONS(1598),
  },
  [262] = {
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_RBRACK] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(1582),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [anon_sym_POUND] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(1582),
    [anon_sym_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1582),
    [anon_sym_SQUOTE] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1582),
    [anon_sym_COLON] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_EQ] = ACTIONS(1582),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_AT] = ACTIONS(1582),
    [anon_sym_BSLASH] = ACTIONS(1582),
    [anon_sym_CARET] = ACTIONS(1582),
    [anon_sym__] = ACTIONS(1582),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_LPAREN] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [aux_sym__word_token1] = ACTIONS(1582),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1582),
    [aux_sym__word_token2] = ACTIONS(1582),
    [sym__whitespace] = ACTIONS(1582),
    [sym__soft_line_ending] = ACTIONS(1582),
    [sym__block_close] = ACTIONS(1582),
    [sym__block_quote_start] = ACTIONS(1582),
    [sym__indented_chunk_start] = ACTIONS(1582),
    [sym_atx_h1_marker] = ACTIONS(1582),
    [sym_atx_h2_marker] = ACTIONS(1582),
    [sym_atx_h3_marker] = ACTIONS(1582),
    [sym_atx_h4_marker] = ACTIONS(1582),
    [sym_atx_h5_marker] = ACTIONS(1582),
    [sym_atx_h6_marker] = ACTIONS(1582),
    [sym__thematic_break] = ACTIONS(1582),
    [sym__list_marker_minus] = ACTIONS(1582),
    [sym__list_marker_plus] = ACTIONS(1582),
    [sym__list_marker_star] = ACTIONS(1582),
    [sym__list_marker_parenthesis] = ACTIONS(1582),
    [sym__list_marker_dot] = ACTIONS(1582),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1582),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1582),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1582),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1582),
    [sym__blank_line_start] = ACTIONS(1582),
    [sym__html_block_1_start] = ACTIONS(1582),
    [sym__html_block_2_start] = ACTIONS(1582),
    [sym__html_block_3_start] = ACTIONS(1582),
    [sym__html_block_4_start] = ACTIONS(1582),
    [sym__html_block_5_start] = ACTIONS(1582),
    [sym__html_block_6_start] = ACTIONS(1582),
    [sym__html_block_7_start] = ACTIONS(1582),
    [sym__pipe_table_start] = ACTIONS(1582),
  },
  [263] = {
    [anon_sym_LBRACK] = ACTIONS(1580),
    [anon_sym_RBRACK] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_POUND] = ACTIONS(1578),
    [anon_sym_DOLLAR] = ACTIONS(1578),
    [anon_sym_PERCENT] = ACTIONS(1578),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_DOT] = ACTIONS(1578),
    [anon_sym_SLASH] = ACTIONS(1578),
    [anon_sym_COLON] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_EQ] = ACTIONS(1578),
    [anon_sym_QMARK] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_BSLASH] = ACTIONS(1578),
    [anon_sym_CARET] = ACTIONS(1578),
    [anon_sym__] = ACTIONS(1578),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [aux_sym__word_token1] = ACTIONS(1578),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1578),
    [aux_sym__word_token2] = ACTIONS(1578),
    [sym__whitespace] = ACTIONS(1578),
    [sym__soft_line_ending] = ACTIONS(1578),
    [sym__block_close] = ACTIONS(1578),
    [sym__block_quote_start] = ACTIONS(1578),
    [sym__indented_chunk_start] = ACTIONS(1578),
    [sym_atx_h1_marker] = ACTIONS(1578),
    [sym_atx_h2_marker] = ACTIONS(1578),
    [sym_atx_h3_marker] = ACTIONS(1578),
    [sym_atx_h4_marker] = ACTIONS(1578),
    [sym_atx_h5_marker] = ACTIONS(1578),
    [sym_atx_h6_marker] = ACTIONS(1578),
    [sym__thematic_break] = ACTIONS(1578),
    [sym__list_marker_minus] = ACTIONS(1578),
    [sym__list_marker_plus] = ACTIONS(1578),
    [sym__list_marker_star] = ACTIONS(1578),
    [sym__list_marker_parenthesis] = ACTIONS(1578),
    [sym__list_marker_dot] = ACTIONS(1578),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1578),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1578),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1578),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1578),
    [sym__blank_line_start] = ACTIONS(1578),
    [sym__html_block_1_start] = ACTIONS(1578),
    [sym__html_block_2_start] = ACTIONS(1578),
    [sym__html_block_3_start] = ACTIONS(1578),
    [sym__html_block_4_start] = ACTIONS(1578),
    [sym__html_block_5_start] = ACTIONS(1578),
    [sym__html_block_6_start] = ACTIONS(1578),
    [sym__html_block_7_start] = ACTIONS(1578),
    [sym__pipe_table_start] = ACTIONS(1578),
  },
  [264] = {
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_POUND] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(1574),
    [anon_sym_PERCENT] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1574),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_DOT] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_EQ] = ACTIONS(1574),
    [anon_sym_QMARK] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(1574),
    [anon_sym_BSLASH] = ACTIONS(1574),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym__] = ACTIONS(1574),
    [anon_sym_BQUOTE] = ACTIONS(1574),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1574),
    [aux_sym__word_token1] = ACTIONS(1574),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1574),
    [aux_sym__word_token2] = ACTIONS(1574),
    [sym__whitespace] = ACTIONS(1574),
    [sym__soft_line_ending] = ACTIONS(1574),
    [sym__block_close] = ACTIONS(1574),
    [sym__block_quote_start] = ACTIONS(1574),
    [sym__indented_chunk_start] = ACTIONS(1574),
    [sym_atx_h1_marker] = ACTIONS(1574),
    [sym_atx_h2_marker] = ACTIONS(1574),
    [sym_atx_h3_marker] = ACTIONS(1574),
    [sym_atx_h4_marker] = ACTIONS(1574),
    [sym_atx_h5_marker] = ACTIONS(1574),
    [sym_atx_h6_marker] = ACTIONS(1574),
    [sym__thematic_break] = ACTIONS(1574),
    [sym__list_marker_minus] = ACTIONS(1574),
    [sym__list_marker_plus] = ACTIONS(1574),
    [sym__list_marker_star] = ACTIONS(1574),
    [sym__list_marker_parenthesis] = ACTIONS(1574),
    [sym__list_marker_dot] = ACTIONS(1574),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1574),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1574),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1574),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1574),
    [sym__blank_line_start] = ACTIONS(1574),
    [sym__html_block_1_start] = ACTIONS(1574),
    [sym__html_block_2_start] = ACTIONS(1574),
    [sym__html_block_3_start] = ACTIONS(1574),
    [sym__html_block_4_start] = ACTIONS(1574),
    [sym__html_block_5_start] = ACTIONS(1574),
    [sym__html_block_6_start] = ACTIONS(1574),
    [sym__html_block_7_start] = ACTIONS(1574),
    [sym__pipe_table_start] = ACTIONS(1574),
  },
  [265] = {
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_POUND] = ACTIONS(1570),
    [anon_sym_DOLLAR] = ACTIONS(1570),
    [anon_sym_PERCENT] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_DOT] = ACTIONS(1570),
    [anon_sym_SLASH] = ACTIONS(1570),
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_EQ] = ACTIONS(1570),
    [anon_sym_QMARK] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_BSLASH] = ACTIONS(1570),
    [anon_sym_CARET] = ACTIONS(1570),
    [anon_sym__] = ACTIONS(1570),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [aux_sym__word_token1] = ACTIONS(1570),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1570),
    [aux_sym__word_token2] = ACTIONS(1570),
    [sym__whitespace] = ACTIONS(1570),
    [sym__soft_line_ending] = ACTIONS(1570),
    [sym__block_close] = ACTIONS(1570),
    [sym__block_quote_start] = ACTIONS(1570),
    [sym__indented_chunk_start] = ACTIONS(1570),
    [sym_atx_h1_marker] = ACTIONS(1570),
    [sym_atx_h2_marker] = ACTIONS(1570),
    [sym_atx_h3_marker] = ACTIONS(1570),
    [sym_atx_h4_marker] = ACTIONS(1570),
    [sym_atx_h5_marker] = ACTIONS(1570),
    [sym_atx_h6_marker] = ACTIONS(1570),
    [sym__thematic_break] = ACTIONS(1570),
    [sym__list_marker_minus] = ACTIONS(1570),
    [sym__list_marker_plus] = ACTIONS(1570),
    [sym__list_marker_star] = ACTIONS(1570),
    [sym__list_marker_parenthesis] = ACTIONS(1570),
    [sym__list_marker_dot] = ACTIONS(1570),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1570),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1570),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1570),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1570),
    [sym__blank_line_start] = ACTIONS(1570),
    [sym__html_block_1_start] = ACTIONS(1570),
    [sym__html_block_2_start] = ACTIONS(1570),
    [sym__html_block_3_start] = ACTIONS(1570),
    [sym__html_block_4_start] = ACTIONS(1570),
    [sym__html_block_5_start] = ACTIONS(1570),
    [sym__html_block_6_start] = ACTIONS(1570),
    [sym__html_block_7_start] = ACTIONS(1570),
    [sym__pipe_table_start] = ACTIONS(1570),
  },
  [266] = {
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_POUND] = ACTIONS(1566),
    [anon_sym_DOLLAR] = ACTIONS(1566),
    [anon_sym_PERCENT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1566),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_DOT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [anon_sym_COLON] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1566),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_BSLASH] = ACTIONS(1566),
    [anon_sym_CARET] = ACTIONS(1566),
    [anon_sym__] = ACTIONS(1566),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1566),
    [aux_sym__word_token1] = ACTIONS(1566),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1566),
    [aux_sym__word_token2] = ACTIONS(1566),
    [sym__whitespace] = ACTIONS(1566),
    [sym__soft_line_ending] = ACTIONS(1566),
    [sym__block_close] = ACTIONS(1566),
    [sym__block_quote_start] = ACTIONS(1566),
    [sym__indented_chunk_start] = ACTIONS(1566),
    [sym_atx_h1_marker] = ACTIONS(1566),
    [sym_atx_h2_marker] = ACTIONS(1566),
    [sym_atx_h3_marker] = ACTIONS(1566),
    [sym_atx_h4_marker] = ACTIONS(1566),
    [sym_atx_h5_marker] = ACTIONS(1566),
    [sym_atx_h6_marker] = ACTIONS(1566),
    [sym__thematic_break] = ACTIONS(1566),
    [sym__list_marker_minus] = ACTIONS(1566),
    [sym__list_marker_plus] = ACTIONS(1566),
    [sym__list_marker_star] = ACTIONS(1566),
    [sym__list_marker_parenthesis] = ACTIONS(1566),
    [sym__list_marker_dot] = ACTIONS(1566),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1566),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1566),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1566),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1566),
    [sym__blank_line_start] = ACTIONS(1566),
    [sym__html_block_1_start] = ACTIONS(1566),
    [sym__html_block_2_start] = ACTIONS(1566),
    [sym__html_block_3_start] = ACTIONS(1566),
    [sym__html_block_4_start] = ACTIONS(1566),
    [sym__html_block_5_start] = ACTIONS(1566),
    [sym__html_block_6_start] = ACTIONS(1566),
    [sym__html_block_7_start] = ACTIONS(1566),
    [sym__pipe_table_start] = ACTIONS(1566),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [anon_sym_POUND] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1364),
    [anon_sym__] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [aux_sym__word_token1] = ACTIONS(1364),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1364),
    [aux_sym__word_token2] = ACTIONS(1364),
    [sym__whitespace] = ACTIONS(1364),
    [sym__soft_line_ending] = ACTIONS(1364),
    [sym__block_quote_start] = ACTIONS(1364),
    [sym__indented_chunk_start] = ACTIONS(1364),
    [sym_atx_h1_marker] = ACTIONS(1364),
    [sym_atx_h2_marker] = ACTIONS(1364),
    [sym_atx_h3_marker] = ACTIONS(1364),
    [sym_atx_h4_marker] = ACTIONS(1364),
    [sym_atx_h5_marker] = ACTIONS(1364),
    [sym_atx_h6_marker] = ACTIONS(1364),
    [sym__thematic_break] = ACTIONS(1364),
    [sym__list_marker_minus] = ACTIONS(1364),
    [sym__list_marker_plus] = ACTIONS(1364),
    [sym__list_marker_star] = ACTIONS(1364),
    [sym__list_marker_parenthesis] = ACTIONS(1364),
    [sym__list_marker_dot] = ACTIONS(1364),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1364),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1364),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1364),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1364),
    [sym__blank_line_start] = ACTIONS(1364),
    [sym__html_block_1_start] = ACTIONS(1364),
    [sym__html_block_2_start] = ACTIONS(1364),
    [sym__html_block_3_start] = ACTIONS(1364),
    [sym__html_block_4_start] = ACTIONS(1364),
    [sym__html_block_5_start] = ACTIONS(1364),
    [sym__html_block_6_start] = ACTIONS(1364),
    [sym__html_block_7_start] = ACTIONS(1364),
    [sym__pipe_table_start] = ACTIONS(1364),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1718),
    [anon_sym_LBRACK] = ACTIONS(1720),
    [anon_sym_RBRACK] = ACTIONS(1718),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_GT] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1718),
    [anon_sym_PERCENT] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1718),
    [anon_sym_COMMA] = ACTIONS(1718),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_DOT] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(1718),
    [anon_sym_COLON] = ACTIONS(1718),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_EQ] = ACTIONS(1718),
    [anon_sym_QMARK] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(1718),
    [anon_sym_BSLASH] = ACTIONS(1718),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym__] = ACTIONS(1718),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_TILDE] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_RPAREN] = ACTIONS(1718),
    [aux_sym__word_token1] = ACTIONS(1718),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1718),
    [aux_sym__word_token2] = ACTIONS(1718),
    [sym__whitespace] = ACTIONS(1718),
    [sym__soft_line_ending] = ACTIONS(1718),
    [sym__block_quote_start] = ACTIONS(1718),
    [sym__indented_chunk_start] = ACTIONS(1718),
    [sym_atx_h1_marker] = ACTIONS(1718),
    [sym_atx_h2_marker] = ACTIONS(1718),
    [sym_atx_h3_marker] = ACTIONS(1718),
    [sym_atx_h4_marker] = ACTIONS(1718),
    [sym_atx_h5_marker] = ACTIONS(1718),
    [sym_atx_h6_marker] = ACTIONS(1718),
    [sym__thematic_break] = ACTIONS(1718),
    [sym__list_marker_minus] = ACTIONS(1718),
    [sym__list_marker_plus] = ACTIONS(1718),
    [sym__list_marker_star] = ACTIONS(1718),
    [sym__list_marker_parenthesis] = ACTIONS(1718),
    [sym__list_marker_dot] = ACTIONS(1718),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1718),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1718),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1718),
    [sym__blank_line_start] = ACTIONS(1718),
    [sym__html_block_1_start] = ACTIONS(1718),
    [sym__html_block_2_start] = ACTIONS(1718),
    [sym__html_block_3_start] = ACTIONS(1718),
    [sym__html_block_4_start] = ACTIONS(1718),
    [sym__html_block_5_start] = ACTIONS(1718),
    [sym__html_block_6_start] = ACTIONS(1718),
    [sym__html_block_7_start] = ACTIONS(1718),
    [sym__pipe_table_start] = ACTIONS(1718),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_RBRACK] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [anon_sym_POUND] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1688),
    [anon_sym_SLASH] = ACTIONS(1688),
    [anon_sym_COLON] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1688),
    [anon_sym_BSLASH] = ACTIONS(1688),
    [anon_sym_CARET] = ACTIONS(1688),
    [anon_sym__] = ACTIONS(1688),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_TILDE] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [aux_sym__word_token1] = ACTIONS(1688),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1688),
    [aux_sym__word_token2] = ACTIONS(1688),
    [sym__whitespace] = ACTIONS(1688),
    [sym__soft_line_ending] = ACTIONS(1688),
    [sym__block_quote_start] = ACTIONS(1688),
    [sym__indented_chunk_start] = ACTIONS(1688),
    [sym_atx_h1_marker] = ACTIONS(1688),
    [sym_atx_h2_marker] = ACTIONS(1688),
    [sym_atx_h3_marker] = ACTIONS(1688),
    [sym_atx_h4_marker] = ACTIONS(1688),
    [sym_atx_h5_marker] = ACTIONS(1688),
    [sym_atx_h6_marker] = ACTIONS(1688),
    [sym__thematic_break] = ACTIONS(1688),
    [sym__list_marker_minus] = ACTIONS(1688),
    [sym__list_marker_plus] = ACTIONS(1688),
    [sym__list_marker_star] = ACTIONS(1688),
    [sym__list_marker_parenthesis] = ACTIONS(1688),
    [sym__list_marker_dot] = ACTIONS(1688),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1688),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1688),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1688),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1688),
    [sym__blank_line_start] = ACTIONS(1688),
    [sym__html_block_1_start] = ACTIONS(1688),
    [sym__html_block_2_start] = ACTIONS(1688),
    [sym__html_block_3_start] = ACTIONS(1688),
    [sym__html_block_4_start] = ACTIONS(1688),
    [sym__html_block_5_start] = ACTIONS(1688),
    [sym__html_block_6_start] = ACTIONS(1688),
    [sym__html_block_7_start] = ACTIONS(1688),
    [sym__pipe_table_start] = ACTIONS(1688),
  },
  [270] = {
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_EQ] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1384),
    [anon_sym__] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [aux_sym__word_token1] = ACTIONS(1384),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1384),
    [aux_sym__word_token2] = ACTIONS(1384),
    [sym__whitespace] = ACTIONS(1384),
    [sym__soft_line_ending] = ACTIONS(1384),
    [sym__block_close] = ACTIONS(1384),
    [sym__block_quote_start] = ACTIONS(1384),
    [sym__indented_chunk_start] = ACTIONS(1384),
    [sym_atx_h1_marker] = ACTIONS(1384),
    [sym_atx_h2_marker] = ACTIONS(1384),
    [sym_atx_h3_marker] = ACTIONS(1384),
    [sym_atx_h4_marker] = ACTIONS(1384),
    [sym_atx_h5_marker] = ACTIONS(1384),
    [sym_atx_h6_marker] = ACTIONS(1384),
    [sym__thematic_break] = ACTIONS(1384),
    [sym__list_marker_minus] = ACTIONS(1384),
    [sym__list_marker_plus] = ACTIONS(1384),
    [sym__list_marker_star] = ACTIONS(1384),
    [sym__list_marker_parenthesis] = ACTIONS(1384),
    [sym__list_marker_dot] = ACTIONS(1384),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1384),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1384),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1384),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1384),
    [sym__blank_line_start] = ACTIONS(1384),
    [sym__html_block_1_start] = ACTIONS(1384),
    [sym__html_block_2_start] = ACTIONS(1384),
    [sym__html_block_3_start] = ACTIONS(1384),
    [sym__html_block_4_start] = ACTIONS(1384),
    [sym__html_block_5_start] = ACTIONS(1384),
    [sym__html_block_6_start] = ACTIONS(1384),
    [sym__html_block_7_start] = ACTIONS(1384),
    [sym__pipe_table_start] = ACTIONS(1384),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1684),
    [anon_sym_LBRACK] = ACTIONS(1682),
    [anon_sym_RBRACK] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [anon_sym_POUND] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_PERCENT] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
    [anon_sym_SQUOTE] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_COMMA] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_DOT] = ACTIONS(1684),
    [anon_sym_SLASH] = ACTIONS(1684),
    [anon_sym_COLON] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(1684),
    [anon_sym_QMARK] = ACTIONS(1684),
    [anon_sym_AT] = ACTIONS(1684),
    [anon_sym_BSLASH] = ACTIONS(1684),
    [anon_sym_CARET] = ACTIONS(1684),
    [anon_sym__] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RBRACE] = ACTIONS(1684),
    [anon_sym_TILDE] = ACTIONS(1684),
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [aux_sym__word_token1] = ACTIONS(1684),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1684),
    [aux_sym__word_token2] = ACTIONS(1684),
    [sym__whitespace] = ACTIONS(1684),
    [sym__soft_line_ending] = ACTIONS(1684),
    [sym__block_quote_start] = ACTIONS(1684),
    [sym__indented_chunk_start] = ACTIONS(1684),
    [sym_atx_h1_marker] = ACTIONS(1684),
    [sym_atx_h2_marker] = ACTIONS(1684),
    [sym_atx_h3_marker] = ACTIONS(1684),
    [sym_atx_h4_marker] = ACTIONS(1684),
    [sym_atx_h5_marker] = ACTIONS(1684),
    [sym_atx_h6_marker] = ACTIONS(1684),
    [sym__thematic_break] = ACTIONS(1684),
    [sym__list_marker_minus] = ACTIONS(1684),
    [sym__list_marker_plus] = ACTIONS(1684),
    [sym__list_marker_star] = ACTIONS(1684),
    [sym__list_marker_parenthesis] = ACTIONS(1684),
    [sym__list_marker_dot] = ACTIONS(1684),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1684),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1684),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1684),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1684),
    [sym__blank_line_start] = ACTIONS(1684),
    [sym__html_block_1_start] = ACTIONS(1684),
    [sym__html_block_2_start] = ACTIONS(1684),
    [sym__html_block_3_start] = ACTIONS(1684),
    [sym__html_block_4_start] = ACTIONS(1684),
    [sym__html_block_5_start] = ACTIONS(1684),
    [sym__html_block_6_start] = ACTIONS(1684),
    [sym__html_block_7_start] = ACTIONS(1684),
    [sym__pipe_table_start] = ACTIONS(1684),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_POUND] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_COMMA] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [aux_sym__word_token1] = ACTIONS(1274),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1274),
    [aux_sym__word_token2] = ACTIONS(1274),
    [sym__whitespace] = ACTIONS(1274),
    [sym__soft_line_ending] = ACTIONS(1274),
    [sym__block_quote_start] = ACTIONS(1274),
    [sym__indented_chunk_start] = ACTIONS(1274),
    [sym_atx_h1_marker] = ACTIONS(1274),
    [sym_atx_h2_marker] = ACTIONS(1274),
    [sym_atx_h3_marker] = ACTIONS(1274),
    [sym_atx_h4_marker] = ACTIONS(1274),
    [sym_atx_h5_marker] = ACTIONS(1274),
    [sym_atx_h6_marker] = ACTIONS(1274),
    [sym__thematic_break] = ACTIONS(1274),
    [sym__list_marker_minus] = ACTIONS(1274),
    [sym__list_marker_plus] = ACTIONS(1274),
    [sym__list_marker_star] = ACTIONS(1274),
    [sym__list_marker_parenthesis] = ACTIONS(1274),
    [sym__list_marker_dot] = ACTIONS(1274),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1274),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1274),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1274),
    [sym__blank_line_start] = ACTIONS(1274),
    [sym__html_block_1_start] = ACTIONS(1274),
    [sym__html_block_2_start] = ACTIONS(1274),
    [sym__html_block_3_start] = ACTIONS(1274),
    [sym__html_block_4_start] = ACTIONS(1274),
    [sym__html_block_5_start] = ACTIONS(1274),
    [sym__html_block_6_start] = ACTIONS(1274),
    [sym__html_block_7_start] = ACTIONS(1274),
    [sym__pipe_table_start] = ACTIONS(1274),
  },
  [273] = {
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_POUND] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1372),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_QMARK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym__] = ACTIONS(1372),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [aux_sym__word_token1] = ACTIONS(1372),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1372),
    [aux_sym__word_token2] = ACTIONS(1372),
    [sym__whitespace] = ACTIONS(1372),
    [sym__soft_line_ending] = ACTIONS(1372),
    [sym__block_close] = ACTIONS(1372),
    [sym__block_quote_start] = ACTIONS(1372),
    [sym__indented_chunk_start] = ACTIONS(1372),
    [sym_atx_h1_marker] = ACTIONS(1372),
    [sym_atx_h2_marker] = ACTIONS(1372),
    [sym_atx_h3_marker] = ACTIONS(1372),
    [sym_atx_h4_marker] = ACTIONS(1372),
    [sym_atx_h5_marker] = ACTIONS(1372),
    [sym_atx_h6_marker] = ACTIONS(1372),
    [sym__thematic_break] = ACTIONS(1372),
    [sym__list_marker_minus] = ACTIONS(1372),
    [sym__list_marker_plus] = ACTIONS(1372),
    [sym__list_marker_star] = ACTIONS(1372),
    [sym__list_marker_parenthesis] = ACTIONS(1372),
    [sym__list_marker_dot] = ACTIONS(1372),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1372),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1372),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1372),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1372),
    [sym__blank_line_start] = ACTIONS(1372),
    [sym__html_block_1_start] = ACTIONS(1372),
    [sym__html_block_2_start] = ACTIONS(1372),
    [sym__html_block_3_start] = ACTIONS(1372),
    [sym__html_block_4_start] = ACTIONS(1372),
    [sym__html_block_5_start] = ACTIONS(1372),
    [sym__html_block_6_start] = ACTIONS(1372),
    [sym__html_block_7_start] = ACTIONS(1372),
    [sym__pipe_table_start] = ACTIONS(1372),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_GT] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_DOLLAR] = ACTIONS(1722),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_PLUS] = ACTIONS(1722),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_DOT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1722),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(1722),
    [anon_sym_QMARK] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_BSLASH] = ACTIONS(1722),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym__] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [aux_sym__word_token1] = ACTIONS(1722),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1722),
    [aux_sym__word_token2] = ACTIONS(1722),
    [sym__whitespace] = ACTIONS(1722),
    [sym__soft_line_ending] = ACTIONS(1722),
    [sym__block_quote_start] = ACTIONS(1722),
    [sym__indented_chunk_start] = ACTIONS(1722),
    [sym_atx_h1_marker] = ACTIONS(1722),
    [sym_atx_h2_marker] = ACTIONS(1722),
    [sym_atx_h3_marker] = ACTIONS(1722),
    [sym_atx_h4_marker] = ACTIONS(1722),
    [sym_atx_h5_marker] = ACTIONS(1722),
    [sym_atx_h6_marker] = ACTIONS(1722),
    [sym__thematic_break] = ACTIONS(1722),
    [sym__list_marker_minus] = ACTIONS(1722),
    [sym__list_marker_plus] = ACTIONS(1722),
    [sym__list_marker_star] = ACTIONS(1722),
    [sym__list_marker_parenthesis] = ACTIONS(1722),
    [sym__list_marker_dot] = ACTIONS(1722),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1722),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1722),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1722),
    [sym__blank_line_start] = ACTIONS(1722),
    [sym__html_block_1_start] = ACTIONS(1722),
    [sym__html_block_2_start] = ACTIONS(1722),
    [sym__html_block_3_start] = ACTIONS(1722),
    [sym__html_block_4_start] = ACTIONS(1722),
    [sym__html_block_5_start] = ACTIONS(1722),
    [sym__html_block_6_start] = ACTIONS(1722),
    [sym__html_block_7_start] = ACTIONS(1722),
    [sym__pipe_table_start] = ACTIONS(1722),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_RBRACK] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [anon_sym_PERCENT] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_SQUOTE] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1726),
    [anon_sym_COMMA] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_DOT] = ACTIONS(1726),
    [anon_sym_SLASH] = ACTIONS(1726),
    [anon_sym_COLON] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_QMARK] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(1726),
    [anon_sym_BSLASH] = ACTIONS(1726),
    [anon_sym_CARET] = ACTIONS(1726),
    [anon_sym__] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [aux_sym__word_token1] = ACTIONS(1726),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1726),
    [aux_sym__word_token2] = ACTIONS(1726),
    [sym__whitespace] = ACTIONS(1726),
    [sym__soft_line_ending] = ACTIONS(1726),
    [sym__block_quote_start] = ACTIONS(1726),
    [sym__indented_chunk_start] = ACTIONS(1726),
    [sym_atx_h1_marker] = ACTIONS(1726),
    [sym_atx_h2_marker] = ACTIONS(1726),
    [sym_atx_h3_marker] = ACTIONS(1726),
    [sym_atx_h4_marker] = ACTIONS(1726),
    [sym_atx_h5_marker] = ACTIONS(1726),
    [sym_atx_h6_marker] = ACTIONS(1726),
    [sym__thematic_break] = ACTIONS(1726),
    [sym__list_marker_minus] = ACTIONS(1726),
    [sym__list_marker_plus] = ACTIONS(1726),
    [sym__list_marker_star] = ACTIONS(1726),
    [sym__list_marker_parenthesis] = ACTIONS(1726),
    [sym__list_marker_dot] = ACTIONS(1726),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1726),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1726),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1726),
    [sym__blank_line_start] = ACTIONS(1726),
    [sym__html_block_1_start] = ACTIONS(1726),
    [sym__html_block_2_start] = ACTIONS(1726),
    [sym__html_block_3_start] = ACTIONS(1726),
    [sym__html_block_4_start] = ACTIONS(1726),
    [sym__html_block_5_start] = ACTIONS(1726),
    [sym__html_block_6_start] = ACTIONS(1726),
    [sym__html_block_7_start] = ACTIONS(1726),
    [sym__pipe_table_start] = ACTIONS(1726),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1730),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_RBRACK] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_GT] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_POUND] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1730),
    [anon_sym_PERCENT] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_SLASH] = ACTIONS(1730),
    [anon_sym_COLON] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_EQ] = ACTIONS(1730),
    [anon_sym_QMARK] = ACTIONS(1730),
    [anon_sym_AT] = ACTIONS(1730),
    [anon_sym_BSLASH] = ACTIONS(1730),
    [anon_sym_CARET] = ACTIONS(1730),
    [anon_sym__] = ACTIONS(1730),
    [anon_sym_BQUOTE] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_TILDE] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_RPAREN] = ACTIONS(1730),
    [aux_sym__word_token1] = ACTIONS(1730),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1730),
    [aux_sym__word_token2] = ACTIONS(1730),
    [sym__whitespace] = ACTIONS(1730),
    [sym__soft_line_ending] = ACTIONS(1730),
    [sym__block_quote_start] = ACTIONS(1730),
    [sym__indented_chunk_start] = ACTIONS(1730),
    [sym_atx_h1_marker] = ACTIONS(1730),
    [sym_atx_h2_marker] = ACTIONS(1730),
    [sym_atx_h3_marker] = ACTIONS(1730),
    [sym_atx_h4_marker] = ACTIONS(1730),
    [sym_atx_h5_marker] = ACTIONS(1730),
    [sym_atx_h6_marker] = ACTIONS(1730),
    [sym__thematic_break] = ACTIONS(1730),
    [sym__list_marker_minus] = ACTIONS(1730),
    [sym__list_marker_plus] = ACTIONS(1730),
    [sym__list_marker_star] = ACTIONS(1730),
    [sym__list_marker_parenthesis] = ACTIONS(1730),
    [sym__list_marker_dot] = ACTIONS(1730),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1730),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1730),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1730),
    [sym__blank_line_start] = ACTIONS(1730),
    [sym__html_block_1_start] = ACTIONS(1730),
    [sym__html_block_2_start] = ACTIONS(1730),
    [sym__html_block_3_start] = ACTIONS(1730),
    [sym__html_block_4_start] = ACTIONS(1730),
    [sym__html_block_5_start] = ACTIONS(1730),
    [sym__html_block_6_start] = ACTIONS(1730),
    [sym__html_block_7_start] = ACTIONS(1730),
    [sym__pipe_table_start] = ACTIONS(1730),
  },
  [277] = {
    [anon_sym_LBRACK] = ACTIONS(1720),
    [anon_sym_RBRACK] = ACTIONS(1718),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_GT] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_POUND] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(1718),
    [anon_sym_PERCENT] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1718),
    [anon_sym_COMMA] = ACTIONS(1718),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_DOT] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(1718),
    [anon_sym_COLON] = ACTIONS(1718),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_EQ] = ACTIONS(1718),
    [anon_sym_QMARK] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(1718),
    [anon_sym_BSLASH] = ACTIONS(1718),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym__] = ACTIONS(1718),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_TILDE] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_RPAREN] = ACTIONS(1718),
    [aux_sym__word_token1] = ACTIONS(1718),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1718),
    [aux_sym__word_token2] = ACTIONS(1718),
    [sym__whitespace] = ACTIONS(1718),
    [sym__soft_line_ending] = ACTIONS(1718),
    [sym__block_close] = ACTIONS(1718),
    [sym__block_quote_start] = ACTIONS(1718),
    [sym__indented_chunk_start] = ACTIONS(1718),
    [sym_atx_h1_marker] = ACTIONS(1718),
    [sym_atx_h2_marker] = ACTIONS(1718),
    [sym_atx_h3_marker] = ACTIONS(1718),
    [sym_atx_h4_marker] = ACTIONS(1718),
    [sym_atx_h5_marker] = ACTIONS(1718),
    [sym_atx_h6_marker] = ACTIONS(1718),
    [sym__thematic_break] = ACTIONS(1718),
    [sym__list_marker_minus] = ACTIONS(1718),
    [sym__list_marker_plus] = ACTIONS(1718),
    [sym__list_marker_star] = ACTIONS(1718),
    [sym__list_marker_parenthesis] = ACTIONS(1718),
    [sym__list_marker_dot] = ACTIONS(1718),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1718),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1718),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1718),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1718),
    [sym__blank_line_start] = ACTIONS(1718),
    [sym__html_block_1_start] = ACTIONS(1718),
    [sym__html_block_2_start] = ACTIONS(1718),
    [sym__html_block_3_start] = ACTIONS(1718),
    [sym__html_block_4_start] = ACTIONS(1718),
    [sym__html_block_5_start] = ACTIONS(1718),
    [sym__html_block_6_start] = ACTIONS(1718),
    [sym__html_block_7_start] = ACTIONS(1718),
    [sym__pipe_table_start] = ACTIONS(1718),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1734),
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_RBRACK] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [anon_sym_PERCENT] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1734),
    [anon_sym_SLASH] = ACTIONS(1734),
    [anon_sym_COLON] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(1734),
    [anon_sym_BSLASH] = ACTIONS(1734),
    [anon_sym_CARET] = ACTIONS(1734),
    [anon_sym__] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_TILDE] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [aux_sym__word_token1] = ACTIONS(1734),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1734),
    [aux_sym__word_token2] = ACTIONS(1734),
    [sym__whitespace] = ACTIONS(1734),
    [sym__soft_line_ending] = ACTIONS(1734),
    [sym__block_quote_start] = ACTIONS(1734),
    [sym__indented_chunk_start] = ACTIONS(1734),
    [sym_atx_h1_marker] = ACTIONS(1734),
    [sym_atx_h2_marker] = ACTIONS(1734),
    [sym_atx_h3_marker] = ACTIONS(1734),
    [sym_atx_h4_marker] = ACTIONS(1734),
    [sym_atx_h5_marker] = ACTIONS(1734),
    [sym_atx_h6_marker] = ACTIONS(1734),
    [sym__thematic_break] = ACTIONS(1734),
    [sym__list_marker_minus] = ACTIONS(1734),
    [sym__list_marker_plus] = ACTIONS(1734),
    [sym__list_marker_star] = ACTIONS(1734),
    [sym__list_marker_parenthesis] = ACTIONS(1734),
    [sym__list_marker_dot] = ACTIONS(1734),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1734),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1734),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1734),
    [sym__blank_line_start] = ACTIONS(1734),
    [sym__html_block_1_start] = ACTIONS(1734),
    [sym__html_block_2_start] = ACTIONS(1734),
    [sym__html_block_3_start] = ACTIONS(1734),
    [sym__html_block_4_start] = ACTIONS(1734),
    [sym__html_block_5_start] = ACTIONS(1734),
    [sym__html_block_6_start] = ACTIONS(1734),
    [sym__html_block_7_start] = ACTIONS(1734),
    [sym__pipe_table_start] = ACTIONS(1734),
  },
  [279] = {
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_RBRACK] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_BANG] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [anon_sym_POUND] = ACTIONS(1740),
    [anon_sym_DOLLAR] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_DOT] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_COLON] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1740),
    [anon_sym_AT] = ACTIONS(1740),
    [anon_sym_BSLASH] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(1740),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_TILDE] = ACTIONS(1740),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [aux_sym__word_token1] = ACTIONS(1740),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1740),
    [aux_sym__word_token2] = ACTIONS(1740),
    [sym__whitespace] = ACTIONS(1740),
    [sym__soft_line_ending] = ACTIONS(1740),
    [sym__block_close] = ACTIONS(1740),
    [sym__block_quote_start] = ACTIONS(1740),
    [sym__indented_chunk_start] = ACTIONS(1740),
    [sym_atx_h1_marker] = ACTIONS(1740),
    [sym_atx_h2_marker] = ACTIONS(1740),
    [sym_atx_h3_marker] = ACTIONS(1740),
    [sym_atx_h4_marker] = ACTIONS(1740),
    [sym_atx_h5_marker] = ACTIONS(1740),
    [sym_atx_h6_marker] = ACTIONS(1740),
    [sym__thematic_break] = ACTIONS(1740),
    [sym__list_marker_minus] = ACTIONS(1740),
    [sym__list_marker_plus] = ACTIONS(1740),
    [sym__list_marker_star] = ACTIONS(1740),
    [sym__list_marker_parenthesis] = ACTIONS(1740),
    [sym__list_marker_dot] = ACTIONS(1740),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1740),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1740),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1740),
    [sym__blank_line_start] = ACTIONS(1740),
    [sym__html_block_1_start] = ACTIONS(1740),
    [sym__html_block_2_start] = ACTIONS(1740),
    [sym__html_block_3_start] = ACTIONS(1740),
    [sym__html_block_4_start] = ACTIONS(1740),
    [sym__html_block_5_start] = ACTIONS(1740),
    [sym__html_block_6_start] = ACTIONS(1740),
    [sym__html_block_7_start] = ACTIONS(1740),
    [sym__pipe_table_start] = ACTIONS(1740),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1678),
    [anon_sym_RBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1680),
    [anon_sym_GT] = ACTIONS(1680),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_POUND] = ACTIONS(1680),
    [anon_sym_DOLLAR] = ACTIONS(1680),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(1680),
    [anon_sym_COLON] = ACTIONS(1680),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1680),
    [anon_sym_QMARK] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_BSLASH] = ACTIONS(1680),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym__] = ACTIONS(1680),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [aux_sym__word_token1] = ACTIONS(1680),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1680),
    [aux_sym__word_token2] = ACTIONS(1680),
    [sym__whitespace] = ACTIONS(1680),
    [sym__soft_line_ending] = ACTIONS(1680),
    [sym__block_quote_start] = ACTIONS(1680),
    [sym__indented_chunk_start] = ACTIONS(1680),
    [sym_atx_h1_marker] = ACTIONS(1680),
    [sym_atx_h2_marker] = ACTIONS(1680),
    [sym_atx_h3_marker] = ACTIONS(1680),
    [sym_atx_h4_marker] = ACTIONS(1680),
    [sym_atx_h5_marker] = ACTIONS(1680),
    [sym_atx_h6_marker] = ACTIONS(1680),
    [sym__thematic_break] = ACTIONS(1680),
    [sym__list_marker_minus] = ACTIONS(1680),
    [sym__list_marker_plus] = ACTIONS(1680),
    [sym__list_marker_star] = ACTIONS(1680),
    [sym__list_marker_parenthesis] = ACTIONS(1680),
    [sym__list_marker_dot] = ACTIONS(1680),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1680),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1680),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1680),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1680),
    [sym__blank_line_start] = ACTIONS(1680),
    [sym__html_block_1_start] = ACTIONS(1680),
    [sym__html_block_2_start] = ACTIONS(1680),
    [sym__html_block_3_start] = ACTIONS(1680),
    [sym__html_block_4_start] = ACTIONS(1680),
    [sym__html_block_5_start] = ACTIONS(1680),
    [sym__html_block_6_start] = ACTIONS(1680),
    [sym__html_block_7_start] = ACTIONS(1680),
    [sym__pipe_table_start] = ACTIONS(1680),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1676),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_RBRACK] = ACTIONS(1676),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_GT] = ACTIONS(1676),
    [anon_sym_BANG] = ACTIONS(1676),
    [anon_sym_DQUOTE] = ACTIONS(1676),
    [anon_sym_POUND] = ACTIONS(1676),
    [anon_sym_DOLLAR] = ACTIONS(1676),
    [anon_sym_PERCENT] = ACTIONS(1676),
    [anon_sym_AMP] = ACTIONS(1676),
    [anon_sym_SQUOTE] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_COMMA] = ACTIONS(1676),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_DOT] = ACTIONS(1676),
    [anon_sym_SLASH] = ACTIONS(1676),
    [anon_sym_COLON] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1676),
    [anon_sym_EQ] = ACTIONS(1676),
    [anon_sym_QMARK] = ACTIONS(1676),
    [anon_sym_AT] = ACTIONS(1676),
    [anon_sym_BSLASH] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1676),
    [anon_sym__] = ACTIONS(1676),
    [anon_sym_BQUOTE] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_PIPE] = ACTIONS(1676),
    [anon_sym_RBRACE] = ACTIONS(1676),
    [anon_sym_TILDE] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(1676),
    [anon_sym_RPAREN] = ACTIONS(1676),
    [aux_sym__word_token1] = ACTIONS(1676),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1676),
    [aux_sym__word_token2] = ACTIONS(1676),
    [sym__whitespace] = ACTIONS(1676),
    [sym__soft_line_ending] = ACTIONS(1676),
    [sym__block_quote_start] = ACTIONS(1676),
    [sym__indented_chunk_start] = ACTIONS(1676),
    [sym_atx_h1_marker] = ACTIONS(1676),
    [sym_atx_h2_marker] = ACTIONS(1676),
    [sym_atx_h3_marker] = ACTIONS(1676),
    [sym_atx_h4_marker] = ACTIONS(1676),
    [sym_atx_h5_marker] = ACTIONS(1676),
    [sym_atx_h6_marker] = ACTIONS(1676),
    [sym__thematic_break] = ACTIONS(1676),
    [sym__list_marker_minus] = ACTIONS(1676),
    [sym__list_marker_plus] = ACTIONS(1676),
    [sym__list_marker_star] = ACTIONS(1676),
    [sym__list_marker_parenthesis] = ACTIONS(1676),
    [sym__list_marker_dot] = ACTIONS(1676),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1676),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1676),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1676),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1676),
    [sym__blank_line_start] = ACTIONS(1676),
    [sym__html_block_1_start] = ACTIONS(1676),
    [sym__html_block_2_start] = ACTIONS(1676),
    [sym__html_block_3_start] = ACTIONS(1676),
    [sym__html_block_4_start] = ACTIONS(1676),
    [sym__html_block_5_start] = ACTIONS(1676),
    [sym__html_block_6_start] = ACTIONS(1676),
    [sym__html_block_7_start] = ACTIONS(1676),
    [sym__pipe_table_start] = ACTIONS(1676),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_RBRACK] = ACTIONS(1672),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_GT] = ACTIONS(1672),
    [anon_sym_BANG] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_POUND] = ACTIONS(1672),
    [anon_sym_DOLLAR] = ACTIONS(1672),
    [anon_sym_PERCENT] = ACTIONS(1672),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_COMMA] = ACTIONS(1672),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_DOT] = ACTIONS(1672),
    [anon_sym_SLASH] = ACTIONS(1672),
    [anon_sym_COLON] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_EQ] = ACTIONS(1672),
    [anon_sym_QMARK] = ACTIONS(1672),
    [anon_sym_AT] = ACTIONS(1672),
    [anon_sym_BSLASH] = ACTIONS(1672),
    [anon_sym_CARET] = ACTIONS(1672),
    [anon_sym__] = ACTIONS(1672),
    [anon_sym_BQUOTE] = ACTIONS(1672),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_PIPE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_TILDE] = ACTIONS(1672),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_RPAREN] = ACTIONS(1672),
    [aux_sym__word_token1] = ACTIONS(1672),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1672),
    [aux_sym__word_token2] = ACTIONS(1672),
    [sym__whitespace] = ACTIONS(1672),
    [sym__soft_line_ending] = ACTIONS(1672),
    [sym__block_quote_start] = ACTIONS(1672),
    [sym__indented_chunk_start] = ACTIONS(1672),
    [sym_atx_h1_marker] = ACTIONS(1672),
    [sym_atx_h2_marker] = ACTIONS(1672),
    [sym_atx_h3_marker] = ACTIONS(1672),
    [sym_atx_h4_marker] = ACTIONS(1672),
    [sym_atx_h5_marker] = ACTIONS(1672),
    [sym_atx_h6_marker] = ACTIONS(1672),
    [sym__thematic_break] = ACTIONS(1672),
    [sym__list_marker_minus] = ACTIONS(1672),
    [sym__list_marker_plus] = ACTIONS(1672),
    [sym__list_marker_star] = ACTIONS(1672),
    [sym__list_marker_parenthesis] = ACTIONS(1672),
    [sym__list_marker_dot] = ACTIONS(1672),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1672),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1672),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1672),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1672),
    [sym__blank_line_start] = ACTIONS(1672),
    [sym__html_block_1_start] = ACTIONS(1672),
    [sym__html_block_2_start] = ACTIONS(1672),
    [sym__html_block_3_start] = ACTIONS(1672),
    [sym__html_block_4_start] = ACTIONS(1672),
    [sym__html_block_5_start] = ACTIONS(1672),
    [sym__html_block_6_start] = ACTIONS(1672),
    [sym__html_block_7_start] = ACTIONS(1672),
    [sym__pipe_table_start] = ACTIONS(1672),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [anon_sym_RBRACK] = ACTIONS(1668),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_BANG] = ACTIONS(1668),
    [anon_sym_DQUOTE] = ACTIONS(1668),
    [anon_sym_POUND] = ACTIONS(1668),
    [anon_sym_DOLLAR] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1668),
    [anon_sym_AMP] = ACTIONS(1668),
    [anon_sym_SQUOTE] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_COMMA] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_DOT] = ACTIONS(1668),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_COLON] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1668),
    [anon_sym_EQ] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(1668),
    [anon_sym_BSLASH] = ACTIONS(1668),
    [anon_sym_CARET] = ACTIONS(1668),
    [anon_sym__] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_RBRACE] = ACTIONS(1668),
    [anon_sym_TILDE] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(1668),
    [anon_sym_RPAREN] = ACTIONS(1668),
    [aux_sym__word_token1] = ACTIONS(1668),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1668),
    [aux_sym__word_token2] = ACTIONS(1668),
    [sym__whitespace] = ACTIONS(1668),
    [sym__soft_line_ending] = ACTIONS(1668),
    [sym__block_quote_start] = ACTIONS(1668),
    [sym__indented_chunk_start] = ACTIONS(1668),
    [sym_atx_h1_marker] = ACTIONS(1668),
    [sym_atx_h2_marker] = ACTIONS(1668),
    [sym_atx_h3_marker] = ACTIONS(1668),
    [sym_atx_h4_marker] = ACTIONS(1668),
    [sym_atx_h5_marker] = ACTIONS(1668),
    [sym_atx_h6_marker] = ACTIONS(1668),
    [sym__thematic_break] = ACTIONS(1668),
    [sym__list_marker_minus] = ACTIONS(1668),
    [sym__list_marker_plus] = ACTIONS(1668),
    [sym__list_marker_star] = ACTIONS(1668),
    [sym__list_marker_parenthesis] = ACTIONS(1668),
    [sym__list_marker_dot] = ACTIONS(1668),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1668),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1668),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1668),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1668),
    [sym__blank_line_start] = ACTIONS(1668),
    [sym__html_block_1_start] = ACTIONS(1668),
    [sym__html_block_2_start] = ACTIONS(1668),
    [sym__html_block_3_start] = ACTIONS(1668),
    [sym__html_block_4_start] = ACTIONS(1668),
    [sym__html_block_5_start] = ACTIONS(1668),
    [sym__html_block_6_start] = ACTIONS(1668),
    [sym__html_block_7_start] = ACTIONS(1668),
    [sym__pipe_table_start] = ACTIONS(1668),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(1664),
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_RBRACK] = ACTIONS(1664),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_POUND] = ACTIONS(1664),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_PERCENT] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
    [anon_sym_SQUOTE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_COMMA] = ACTIONS(1664),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_DOT] = ACTIONS(1664),
    [anon_sym_SLASH] = ACTIONS(1664),
    [anon_sym_COLON] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1664),
    [anon_sym_EQ] = ACTIONS(1664),
    [anon_sym_QMARK] = ACTIONS(1664),
    [anon_sym_AT] = ACTIONS(1664),
    [anon_sym_BSLASH] = ACTIONS(1664),
    [anon_sym_CARET] = ACTIONS(1664),
    [anon_sym__] = ACTIONS(1664),
    [anon_sym_BQUOTE] = ACTIONS(1664),
    [anon_sym_LBRACE] = ACTIONS(1664),
    [anon_sym_PIPE] = ACTIONS(1664),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_TILDE] = ACTIONS(1664),
    [anon_sym_LPAREN] = ACTIONS(1664),
    [anon_sym_RPAREN] = ACTIONS(1664),
    [aux_sym__word_token1] = ACTIONS(1664),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1664),
    [aux_sym__word_token2] = ACTIONS(1664),
    [sym__whitespace] = ACTIONS(1664),
    [sym__soft_line_ending] = ACTIONS(1664),
    [sym__block_quote_start] = ACTIONS(1664),
    [sym__indented_chunk_start] = ACTIONS(1664),
    [sym_atx_h1_marker] = ACTIONS(1664),
    [sym_atx_h2_marker] = ACTIONS(1664),
    [sym_atx_h3_marker] = ACTIONS(1664),
    [sym_atx_h4_marker] = ACTIONS(1664),
    [sym_atx_h5_marker] = ACTIONS(1664),
    [sym_atx_h6_marker] = ACTIONS(1664),
    [sym__thematic_break] = ACTIONS(1664),
    [sym__list_marker_minus] = ACTIONS(1664),
    [sym__list_marker_plus] = ACTIONS(1664),
    [sym__list_marker_star] = ACTIONS(1664),
    [sym__list_marker_parenthesis] = ACTIONS(1664),
    [sym__list_marker_dot] = ACTIONS(1664),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1664),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1664),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1664),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1664),
    [sym__blank_line_start] = ACTIONS(1664),
    [sym__html_block_1_start] = ACTIONS(1664),
    [sym__html_block_2_start] = ACTIONS(1664),
    [sym__html_block_3_start] = ACTIONS(1664),
    [sym__html_block_4_start] = ACTIONS(1664),
    [sym__html_block_5_start] = ACTIONS(1664),
    [sym__html_block_6_start] = ACTIONS(1664),
    [sym__html_block_7_start] = ACTIONS(1664),
    [sym__pipe_table_start] = ACTIONS(1664),
  },
  [285] = {
    [anon_sym_LBRACK] = ACTIONS(1716),
    [anon_sym_RBRACK] = ACTIONS(1714),
    [anon_sym_LT] = ACTIONS(1714),
    [anon_sym_GT] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1714),
    [anon_sym_DQUOTE] = ACTIONS(1714),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_DOLLAR] = ACTIONS(1714),
    [anon_sym_PERCENT] = ACTIONS(1714),
    [anon_sym_AMP] = ACTIONS(1714),
    [anon_sym_SQUOTE] = ACTIONS(1714),
    [anon_sym_STAR] = ACTIONS(1714),
    [anon_sym_PLUS] = ACTIONS(1714),
    [anon_sym_COMMA] = ACTIONS(1714),
    [anon_sym_DASH] = ACTIONS(1714),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_SLASH] = ACTIONS(1714),
    [anon_sym_COLON] = ACTIONS(1714),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_EQ] = ACTIONS(1714),
    [anon_sym_QMARK] = ACTIONS(1714),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_BSLASH] = ACTIONS(1714),
    [anon_sym_CARET] = ACTIONS(1714),
    [anon_sym__] = ACTIONS(1714),
    [anon_sym_BQUOTE] = ACTIONS(1714),
    [anon_sym_LBRACE] = ACTIONS(1714),
    [anon_sym_PIPE] = ACTIONS(1714),
    [anon_sym_RBRACE] = ACTIONS(1714),
    [anon_sym_TILDE] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(1714),
    [aux_sym__word_token1] = ACTIONS(1714),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1714),
    [aux_sym__word_token2] = ACTIONS(1714),
    [sym__whitespace] = ACTIONS(1714),
    [sym__soft_line_ending] = ACTIONS(1714),
    [sym__block_close] = ACTIONS(1714),
    [sym__block_quote_start] = ACTIONS(1714),
    [sym__indented_chunk_start] = ACTIONS(1714),
    [sym_atx_h1_marker] = ACTIONS(1714),
    [sym_atx_h2_marker] = ACTIONS(1714),
    [sym_atx_h3_marker] = ACTIONS(1714),
    [sym_atx_h4_marker] = ACTIONS(1714),
    [sym_atx_h5_marker] = ACTIONS(1714),
    [sym_atx_h6_marker] = ACTIONS(1714),
    [sym__thematic_break] = ACTIONS(1714),
    [sym__list_marker_minus] = ACTIONS(1714),
    [sym__list_marker_plus] = ACTIONS(1714),
    [sym__list_marker_star] = ACTIONS(1714),
    [sym__list_marker_parenthesis] = ACTIONS(1714),
    [sym__list_marker_dot] = ACTIONS(1714),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1714),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1714),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1714),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1714),
    [sym__blank_line_start] = ACTIONS(1714),
    [sym__html_block_1_start] = ACTIONS(1714),
    [sym__html_block_2_start] = ACTIONS(1714),
    [sym__html_block_3_start] = ACTIONS(1714),
    [sym__html_block_4_start] = ACTIONS(1714),
    [sym__html_block_5_start] = ACTIONS(1714),
    [sym__html_block_6_start] = ACTIONS(1714),
    [sym__html_block_7_start] = ACTIONS(1714),
    [sym__pipe_table_start] = ACTIONS(1714),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1660),
    [anon_sym_LBRACK] = ACTIONS(1658),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1660),
    [anon_sym_GT] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_POUND] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(1660),
    [anon_sym_PERCENT] = ACTIONS(1660),
    [anon_sym_AMP] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_STAR] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_DASH] = ACTIONS(1660),
    [anon_sym_DOT] = ACTIONS(1660),
    [anon_sym_SLASH] = ACTIONS(1660),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_QMARK] = ACTIONS(1660),
    [anon_sym_AT] = ACTIONS(1660),
    [anon_sym_BSLASH] = ACTIONS(1660),
    [anon_sym_CARET] = ACTIONS(1660),
    [anon_sym__] = ACTIONS(1660),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_TILDE] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [aux_sym__word_token1] = ACTIONS(1660),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1660),
    [aux_sym__word_token2] = ACTIONS(1660),
    [sym__whitespace] = ACTIONS(1660),
    [sym__soft_line_ending] = ACTIONS(1660),
    [sym__block_quote_start] = ACTIONS(1660),
    [sym__indented_chunk_start] = ACTIONS(1660),
    [sym_atx_h1_marker] = ACTIONS(1660),
    [sym_atx_h2_marker] = ACTIONS(1660),
    [sym_atx_h3_marker] = ACTIONS(1660),
    [sym_atx_h4_marker] = ACTIONS(1660),
    [sym_atx_h5_marker] = ACTIONS(1660),
    [sym_atx_h6_marker] = ACTIONS(1660),
    [sym__thematic_break] = ACTIONS(1660),
    [sym__list_marker_minus] = ACTIONS(1660),
    [sym__list_marker_plus] = ACTIONS(1660),
    [sym__list_marker_star] = ACTIONS(1660),
    [sym__list_marker_parenthesis] = ACTIONS(1660),
    [sym__list_marker_dot] = ACTIONS(1660),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1660),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1660),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1660),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1660),
    [sym__blank_line_start] = ACTIONS(1660),
    [sym__html_block_1_start] = ACTIONS(1660),
    [sym__html_block_2_start] = ACTIONS(1660),
    [sym__html_block_3_start] = ACTIONS(1660),
    [sym__html_block_4_start] = ACTIONS(1660),
    [sym__html_block_5_start] = ACTIONS(1660),
    [sym__html_block_6_start] = ACTIONS(1660),
    [sym__html_block_7_start] = ACTIONS(1660),
    [sym__pipe_table_start] = ACTIONS(1660),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1656),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_DQUOTE] = ACTIONS(1656),
    [anon_sym_POUND] = ACTIONS(1656),
    [anon_sym_DOLLAR] = ACTIONS(1656),
    [anon_sym_PERCENT] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1656),
    [anon_sym_SQUOTE] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1656),
    [anon_sym_SLASH] = ACTIONS(1656),
    [anon_sym_COLON] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1656),
    [anon_sym_QMARK] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(1656),
    [anon_sym_BSLASH] = ACTIONS(1656),
    [anon_sym_CARET] = ACTIONS(1656),
    [anon_sym__] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1656),
    [anon_sym_PIPE] = ACTIONS(1656),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1656),
    [anon_sym_LPAREN] = ACTIONS(1656),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [aux_sym__word_token1] = ACTIONS(1656),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1656),
    [aux_sym__word_token2] = ACTIONS(1656),
    [sym__whitespace] = ACTIONS(1656),
    [sym__soft_line_ending] = ACTIONS(1656),
    [sym__block_quote_start] = ACTIONS(1656),
    [sym__indented_chunk_start] = ACTIONS(1656),
    [sym_atx_h1_marker] = ACTIONS(1656),
    [sym_atx_h2_marker] = ACTIONS(1656),
    [sym_atx_h3_marker] = ACTIONS(1656),
    [sym_atx_h4_marker] = ACTIONS(1656),
    [sym_atx_h5_marker] = ACTIONS(1656),
    [sym_atx_h6_marker] = ACTIONS(1656),
    [sym__thematic_break] = ACTIONS(1656),
    [sym__list_marker_minus] = ACTIONS(1656),
    [sym__list_marker_plus] = ACTIONS(1656),
    [sym__list_marker_star] = ACTIONS(1656),
    [sym__list_marker_parenthesis] = ACTIONS(1656),
    [sym__list_marker_dot] = ACTIONS(1656),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1656),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1656),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1656),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1656),
    [sym__blank_line_start] = ACTIONS(1656),
    [sym__html_block_1_start] = ACTIONS(1656),
    [sym__html_block_2_start] = ACTIONS(1656),
    [sym__html_block_3_start] = ACTIONS(1656),
    [sym__html_block_4_start] = ACTIONS(1656),
    [sym__html_block_5_start] = ACTIONS(1656),
    [sym__html_block_6_start] = ACTIONS(1656),
    [sym__html_block_7_start] = ACTIONS(1656),
    [sym__pipe_table_start] = ACTIONS(1656),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1744),
    [anon_sym_RBRACK] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [anon_sym_POUND] = ACTIONS(1742),
    [anon_sym_DOLLAR] = ACTIONS(1742),
    [anon_sym_PERCENT] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1742),
    [anon_sym_COMMA] = ACTIONS(1742),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_DOT] = ACTIONS(1742),
    [anon_sym_SLASH] = ACTIONS(1742),
    [anon_sym_COLON] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_EQ] = ACTIONS(1742),
    [anon_sym_QMARK] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(1742),
    [anon_sym_BSLASH] = ACTIONS(1742),
    [anon_sym_CARET] = ACTIONS(1742),
    [anon_sym__] = ACTIONS(1742),
    [anon_sym_BQUOTE] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [aux_sym__word_token1] = ACTIONS(1742),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1742),
    [aux_sym__word_token2] = ACTIONS(1742),
    [sym__whitespace] = ACTIONS(1742),
    [sym__soft_line_ending] = ACTIONS(1742),
    [sym__block_quote_start] = ACTIONS(1742),
    [sym__indented_chunk_start] = ACTIONS(1742),
    [sym_atx_h1_marker] = ACTIONS(1742),
    [sym_atx_h2_marker] = ACTIONS(1742),
    [sym_atx_h3_marker] = ACTIONS(1742),
    [sym_atx_h4_marker] = ACTIONS(1742),
    [sym_atx_h5_marker] = ACTIONS(1742),
    [sym_atx_h6_marker] = ACTIONS(1742),
    [sym__thematic_break] = ACTIONS(1742),
    [sym__list_marker_minus] = ACTIONS(1742),
    [sym__list_marker_plus] = ACTIONS(1742),
    [sym__list_marker_star] = ACTIONS(1742),
    [sym__list_marker_parenthesis] = ACTIONS(1742),
    [sym__list_marker_dot] = ACTIONS(1742),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1742),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1742),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1742),
    [sym__blank_line_start] = ACTIONS(1742),
    [sym__html_block_1_start] = ACTIONS(1742),
    [sym__html_block_2_start] = ACTIONS(1742),
    [sym__html_block_3_start] = ACTIONS(1742),
    [sym__html_block_4_start] = ACTIONS(1742),
    [sym__html_block_5_start] = ACTIONS(1742),
    [sym__html_block_6_start] = ACTIONS(1742),
    [sym__html_block_7_start] = ACTIONS(1742),
    [sym__pipe_table_start] = ACTIONS(1742),
  },
  [289] = {
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_RBRACK] = ACTIONS(1748),
    [anon_sym_LT] = ACTIONS(1748),
    [anon_sym_GT] = ACTIONS(1748),
    [anon_sym_BANG] = ACTIONS(1748),
    [anon_sym_DQUOTE] = ACTIONS(1748),
    [anon_sym_POUND] = ACTIONS(1748),
    [anon_sym_DOLLAR] = ACTIONS(1748),
    [anon_sym_PERCENT] = ACTIONS(1748),
    [anon_sym_AMP] = ACTIONS(1748),
    [anon_sym_SQUOTE] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1748),
    [anon_sym_PLUS] = ACTIONS(1748),
    [anon_sym_COMMA] = ACTIONS(1748),
    [anon_sym_DASH] = ACTIONS(1748),
    [anon_sym_DOT] = ACTIONS(1748),
    [anon_sym_SLASH] = ACTIONS(1748),
    [anon_sym_COLON] = ACTIONS(1748),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_EQ] = ACTIONS(1748),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(1748),
    [anon_sym_BSLASH] = ACTIONS(1748),
    [anon_sym_CARET] = ACTIONS(1748),
    [anon_sym__] = ACTIONS(1748),
    [anon_sym_BQUOTE] = ACTIONS(1748),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_PIPE] = ACTIONS(1748),
    [anon_sym_RBRACE] = ACTIONS(1748),
    [anon_sym_TILDE] = ACTIONS(1748),
    [anon_sym_LPAREN] = ACTIONS(1748),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [aux_sym__word_token1] = ACTIONS(1748),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1748),
    [aux_sym__word_token2] = ACTIONS(1748),
    [sym__whitespace] = ACTIONS(1748),
    [sym__soft_line_ending] = ACTIONS(1748),
    [sym__block_close] = ACTIONS(1748),
    [sym__block_quote_start] = ACTIONS(1748),
    [sym__indented_chunk_start] = ACTIONS(1748),
    [sym_atx_h1_marker] = ACTIONS(1748),
    [sym_atx_h2_marker] = ACTIONS(1748),
    [sym_atx_h3_marker] = ACTIONS(1748),
    [sym_atx_h4_marker] = ACTIONS(1748),
    [sym_atx_h5_marker] = ACTIONS(1748),
    [sym_atx_h6_marker] = ACTIONS(1748),
    [sym__thematic_break] = ACTIONS(1748),
    [sym__list_marker_minus] = ACTIONS(1748),
    [sym__list_marker_plus] = ACTIONS(1748),
    [sym__list_marker_star] = ACTIONS(1748),
    [sym__list_marker_parenthesis] = ACTIONS(1748),
    [sym__list_marker_dot] = ACTIONS(1748),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1748),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1748),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1748),
    [sym__blank_line_start] = ACTIONS(1748),
    [sym__html_block_1_start] = ACTIONS(1748),
    [sym__html_block_2_start] = ACTIONS(1748),
    [sym__html_block_3_start] = ACTIONS(1748),
    [sym__html_block_4_start] = ACTIONS(1748),
    [sym__html_block_5_start] = ACTIONS(1748),
    [sym__html_block_6_start] = ACTIONS(1748),
    [sym__html_block_7_start] = ACTIONS(1748),
    [sym__pipe_table_start] = ACTIONS(1748),
  },
  [290] = {
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_POUND] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1752),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_COMMA] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_COLON] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_EQ] = ACTIONS(1752),
    [anon_sym_QMARK] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1752),
    [anon_sym_BSLASH] = ACTIONS(1752),
    [anon_sym_CARET] = ACTIONS(1752),
    [anon_sym__] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_LPAREN] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [aux_sym__word_token1] = ACTIONS(1752),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1752),
    [aux_sym__word_token2] = ACTIONS(1752),
    [sym__whitespace] = ACTIONS(1752),
    [sym__soft_line_ending] = ACTIONS(1752),
    [sym__block_close] = ACTIONS(1752),
    [sym__block_quote_start] = ACTIONS(1752),
    [sym__indented_chunk_start] = ACTIONS(1752),
    [sym_atx_h1_marker] = ACTIONS(1752),
    [sym_atx_h2_marker] = ACTIONS(1752),
    [sym_atx_h3_marker] = ACTIONS(1752),
    [sym_atx_h4_marker] = ACTIONS(1752),
    [sym_atx_h5_marker] = ACTIONS(1752),
    [sym_atx_h6_marker] = ACTIONS(1752),
    [sym__thematic_break] = ACTIONS(1752),
    [sym__list_marker_minus] = ACTIONS(1752),
    [sym__list_marker_plus] = ACTIONS(1752),
    [sym__list_marker_star] = ACTIONS(1752),
    [sym__list_marker_parenthesis] = ACTIONS(1752),
    [sym__list_marker_dot] = ACTIONS(1752),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1752),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1752),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1752),
    [sym__blank_line_start] = ACTIONS(1752),
    [sym__html_block_1_start] = ACTIONS(1752),
    [sym__html_block_2_start] = ACTIONS(1752),
    [sym__html_block_3_start] = ACTIONS(1752),
    [sym__html_block_4_start] = ACTIONS(1752),
    [sym__html_block_5_start] = ACTIONS(1752),
    [sym__html_block_6_start] = ACTIONS(1752),
    [sym__html_block_7_start] = ACTIONS(1752),
    [sym__pipe_table_start] = ACTIONS(1752),
  },
  [291] = {
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_RBRACK] = ACTIONS(1756),
    [anon_sym_LT] = ACTIONS(1756),
    [anon_sym_GT] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1756),
    [anon_sym_DQUOTE] = ACTIONS(1756),
    [anon_sym_POUND] = ACTIONS(1756),
    [anon_sym_DOLLAR] = ACTIONS(1756),
    [anon_sym_PERCENT] = ACTIONS(1756),
    [anon_sym_AMP] = ACTIONS(1756),
    [anon_sym_SQUOTE] = ACTIONS(1756),
    [anon_sym_STAR] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_COMMA] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_DOT] = ACTIONS(1756),
    [anon_sym_SLASH] = ACTIONS(1756),
    [anon_sym_COLON] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1756),
    [anon_sym_EQ] = ACTIONS(1756),
    [anon_sym_QMARK] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(1756),
    [anon_sym_BSLASH] = ACTIONS(1756),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym__] = ACTIONS(1756),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1756),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_TILDE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [aux_sym__word_token1] = ACTIONS(1756),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1756),
    [aux_sym__word_token2] = ACTIONS(1756),
    [sym__whitespace] = ACTIONS(1756),
    [sym__soft_line_ending] = ACTIONS(1756),
    [sym__block_close] = ACTIONS(1756),
    [sym__block_quote_start] = ACTIONS(1756),
    [sym__indented_chunk_start] = ACTIONS(1756),
    [sym_atx_h1_marker] = ACTIONS(1756),
    [sym_atx_h2_marker] = ACTIONS(1756),
    [sym_atx_h3_marker] = ACTIONS(1756),
    [sym_atx_h4_marker] = ACTIONS(1756),
    [sym_atx_h5_marker] = ACTIONS(1756),
    [sym_atx_h6_marker] = ACTIONS(1756),
    [sym__thematic_break] = ACTIONS(1756),
    [sym__list_marker_minus] = ACTIONS(1756),
    [sym__list_marker_plus] = ACTIONS(1756),
    [sym__list_marker_star] = ACTIONS(1756),
    [sym__list_marker_parenthesis] = ACTIONS(1756),
    [sym__list_marker_dot] = ACTIONS(1756),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1756),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1756),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1756),
    [sym__blank_line_start] = ACTIONS(1756),
    [sym__html_block_1_start] = ACTIONS(1756),
    [sym__html_block_2_start] = ACTIONS(1756),
    [sym__html_block_3_start] = ACTIONS(1756),
    [sym__html_block_4_start] = ACTIONS(1756),
    [sym__html_block_5_start] = ACTIONS(1756),
    [sym__html_block_6_start] = ACTIONS(1756),
    [sym__html_block_7_start] = ACTIONS(1756),
    [sym__pipe_table_start] = ACTIONS(1756),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_DQUOTE] = ACTIONS(1536),
    [anon_sym_POUND] = ACTIONS(1536),
    [anon_sym_DOLLAR] = ACTIONS(1536),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(1536),
    [anon_sym_STAR] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_DOT] = ACTIONS(1536),
    [anon_sym_SLASH] = ACTIONS(1536),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_BSLASH] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym__] = ACTIONS(1536),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [aux_sym__word_token1] = ACTIONS(1536),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1536),
    [aux_sym__word_token2] = ACTIONS(1536),
    [sym__whitespace] = ACTIONS(1536),
    [sym__soft_line_ending] = ACTIONS(1536),
    [sym__block_quote_start] = ACTIONS(1536),
    [sym__indented_chunk_start] = ACTIONS(1536),
    [sym_atx_h1_marker] = ACTIONS(1536),
    [sym_atx_h2_marker] = ACTIONS(1536),
    [sym_atx_h3_marker] = ACTIONS(1536),
    [sym_atx_h4_marker] = ACTIONS(1536),
    [sym_atx_h5_marker] = ACTIONS(1536),
    [sym_atx_h6_marker] = ACTIONS(1536),
    [sym__thematic_break] = ACTIONS(1536),
    [sym__list_marker_minus] = ACTIONS(1536),
    [sym__list_marker_plus] = ACTIONS(1536),
    [sym__list_marker_star] = ACTIONS(1536),
    [sym__list_marker_parenthesis] = ACTIONS(1536),
    [sym__list_marker_dot] = ACTIONS(1536),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1536),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1536),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1536),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1536),
    [sym__blank_line_start] = ACTIONS(1536),
    [sym__html_block_1_start] = ACTIONS(1536),
    [sym__html_block_2_start] = ACTIONS(1536),
    [sym__html_block_3_start] = ACTIONS(1536),
    [sym__html_block_4_start] = ACTIONS(1536),
    [sym__html_block_5_start] = ACTIONS(1536),
    [sym__html_block_6_start] = ACTIONS(1536),
    [sym__html_block_7_start] = ACTIONS(1536),
    [sym__pipe_table_start] = ACTIONS(1536),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1758),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1758),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_GT] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1758),
    [anon_sym_DOLLAR] = ACTIONS(1758),
    [anon_sym_PERCENT] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_SQUOTE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1758),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_SLASH] = ACTIONS(1758),
    [anon_sym_COLON] = ACTIONS(1758),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_EQ] = ACTIONS(1758),
    [anon_sym_QMARK] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(1758),
    [anon_sym_BSLASH] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1758),
    [anon_sym__] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1758),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1758),
    [anon_sym_RPAREN] = ACTIONS(1758),
    [aux_sym__word_token1] = ACTIONS(1758),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1758),
    [aux_sym__word_token2] = ACTIONS(1758),
    [sym__whitespace] = ACTIONS(1758),
    [sym__soft_line_ending] = ACTIONS(1758),
    [sym__block_quote_start] = ACTIONS(1758),
    [sym__indented_chunk_start] = ACTIONS(1758),
    [sym_atx_h1_marker] = ACTIONS(1758),
    [sym_atx_h2_marker] = ACTIONS(1758),
    [sym_atx_h3_marker] = ACTIONS(1758),
    [sym_atx_h4_marker] = ACTIONS(1758),
    [sym_atx_h5_marker] = ACTIONS(1758),
    [sym_atx_h6_marker] = ACTIONS(1758),
    [sym__thematic_break] = ACTIONS(1758),
    [sym__list_marker_minus] = ACTIONS(1758),
    [sym__list_marker_plus] = ACTIONS(1758),
    [sym__list_marker_star] = ACTIONS(1758),
    [sym__list_marker_parenthesis] = ACTIONS(1758),
    [sym__list_marker_dot] = ACTIONS(1758),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1758),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1758),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1758),
    [sym__blank_line_start] = ACTIONS(1758),
    [sym__html_block_1_start] = ACTIONS(1758),
    [sym__html_block_2_start] = ACTIONS(1758),
    [sym__html_block_3_start] = ACTIONS(1758),
    [sym__html_block_4_start] = ACTIONS(1758),
    [sym__html_block_5_start] = ACTIONS(1758),
    [sym__html_block_6_start] = ACTIONS(1758),
    [sym__html_block_7_start] = ACTIONS(1758),
    [sym__pipe_table_start] = ACTIONS(1758),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1738),
    [anon_sym_RBRACK] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(1740),
    [anon_sym_GT] = ACTIONS(1740),
    [anon_sym_BANG] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [anon_sym_POUND] = ACTIONS(1740),
    [anon_sym_DOLLAR] = ACTIONS(1740),
    [anon_sym_PERCENT] = ACTIONS(1740),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [anon_sym_STAR] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_DASH] = ACTIONS(1740),
    [anon_sym_DOT] = ACTIONS(1740),
    [anon_sym_SLASH] = ACTIONS(1740),
    [anon_sym_COLON] = ACTIONS(1740),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_EQ] = ACTIONS(1740),
    [anon_sym_QMARK] = ACTIONS(1740),
    [anon_sym_AT] = ACTIONS(1740),
    [anon_sym_BSLASH] = ACTIONS(1740),
    [anon_sym_CARET] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(1740),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_PIPE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_TILDE] = ACTIONS(1740),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [aux_sym__word_token1] = ACTIONS(1740),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1740),
    [aux_sym__word_token2] = ACTIONS(1740),
    [sym__whitespace] = ACTIONS(1740),
    [sym__soft_line_ending] = ACTIONS(1740),
    [sym__block_quote_start] = ACTIONS(1740),
    [sym__indented_chunk_start] = ACTIONS(1740),
    [sym_atx_h1_marker] = ACTIONS(1740),
    [sym_atx_h2_marker] = ACTIONS(1740),
    [sym_atx_h3_marker] = ACTIONS(1740),
    [sym_atx_h4_marker] = ACTIONS(1740),
    [sym_atx_h5_marker] = ACTIONS(1740),
    [sym_atx_h6_marker] = ACTIONS(1740),
    [sym__thematic_break] = ACTIONS(1740),
    [sym__list_marker_minus] = ACTIONS(1740),
    [sym__list_marker_plus] = ACTIONS(1740),
    [sym__list_marker_star] = ACTIONS(1740),
    [sym__list_marker_parenthesis] = ACTIONS(1740),
    [sym__list_marker_dot] = ACTIONS(1740),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1740),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1740),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1740),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1740),
    [sym__blank_line_start] = ACTIONS(1740),
    [sym__html_block_1_start] = ACTIONS(1740),
    [sym__html_block_2_start] = ACTIONS(1740),
    [sym__html_block_3_start] = ACTIONS(1740),
    [sym__html_block_4_start] = ACTIONS(1740),
    [sym__html_block_5_start] = ACTIONS(1740),
    [sym__html_block_6_start] = ACTIONS(1740),
    [sym__html_block_7_start] = ACTIONS(1740),
    [sym__pipe_table_start] = ACTIONS(1740),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1764),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_SQUOTE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_COMMA] = ACTIONS(1762),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1762),
    [anon_sym_BSLASH] = ACTIONS(1762),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym__] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_TILDE] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [aux_sym__word_token1] = ACTIONS(1762),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1762),
    [aux_sym__word_token2] = ACTIONS(1762),
    [sym__whitespace] = ACTIONS(1762),
    [sym__soft_line_ending] = ACTIONS(1762),
    [sym__block_quote_start] = ACTIONS(1762),
    [sym__indented_chunk_start] = ACTIONS(1762),
    [sym_atx_h1_marker] = ACTIONS(1762),
    [sym_atx_h2_marker] = ACTIONS(1762),
    [sym_atx_h3_marker] = ACTIONS(1762),
    [sym_atx_h4_marker] = ACTIONS(1762),
    [sym_atx_h5_marker] = ACTIONS(1762),
    [sym_atx_h6_marker] = ACTIONS(1762),
    [sym__thematic_break] = ACTIONS(1762),
    [sym__list_marker_minus] = ACTIONS(1762),
    [sym__list_marker_plus] = ACTIONS(1762),
    [sym__list_marker_star] = ACTIONS(1762),
    [sym__list_marker_parenthesis] = ACTIONS(1762),
    [sym__list_marker_dot] = ACTIONS(1762),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1762),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1762),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1762),
    [sym__blank_line_start] = ACTIONS(1762),
    [sym__html_block_1_start] = ACTIONS(1762),
    [sym__html_block_2_start] = ACTIONS(1762),
    [sym__html_block_3_start] = ACTIONS(1762),
    [sym__html_block_4_start] = ACTIONS(1762),
    [sym__html_block_5_start] = ACTIONS(1762),
    [sym__html_block_6_start] = ACTIONS(1762),
    [sym__html_block_7_start] = ACTIONS(1762),
    [sym__pipe_table_start] = ACTIONS(1762),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(1766),
    [anon_sym_LBRACK] = ACTIONS(1768),
    [anon_sym_RBRACK] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_GT] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_DQUOTE] = ACTIONS(1766),
    [anon_sym_POUND] = ACTIONS(1766),
    [anon_sym_DOLLAR] = ACTIONS(1766),
    [anon_sym_PERCENT] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [anon_sym_SQUOTE] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1766),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_COMMA] = ACTIONS(1766),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_SLASH] = ACTIONS(1766),
    [anon_sym_COLON] = ACTIONS(1766),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_EQ] = ACTIONS(1766),
    [anon_sym_QMARK] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(1766),
    [anon_sym_BSLASH] = ACTIONS(1766),
    [anon_sym_CARET] = ACTIONS(1766),
    [anon_sym__] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_TILDE] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_RPAREN] = ACTIONS(1766),
    [aux_sym__word_token1] = ACTIONS(1766),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1766),
    [aux_sym__word_token2] = ACTIONS(1766),
    [sym__whitespace] = ACTIONS(1766),
    [sym__soft_line_ending] = ACTIONS(1766),
    [sym__block_quote_start] = ACTIONS(1766),
    [sym__indented_chunk_start] = ACTIONS(1766),
    [sym_atx_h1_marker] = ACTIONS(1766),
    [sym_atx_h2_marker] = ACTIONS(1766),
    [sym_atx_h3_marker] = ACTIONS(1766),
    [sym_atx_h4_marker] = ACTIONS(1766),
    [sym_atx_h5_marker] = ACTIONS(1766),
    [sym_atx_h6_marker] = ACTIONS(1766),
    [sym__thematic_break] = ACTIONS(1766),
    [sym__list_marker_minus] = ACTIONS(1766),
    [sym__list_marker_plus] = ACTIONS(1766),
    [sym__list_marker_star] = ACTIONS(1766),
    [sym__list_marker_parenthesis] = ACTIONS(1766),
    [sym__list_marker_dot] = ACTIONS(1766),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1766),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1766),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1766),
    [sym__blank_line_start] = ACTIONS(1766),
    [sym__html_block_1_start] = ACTIONS(1766),
    [sym__html_block_2_start] = ACTIONS(1766),
    [sym__html_block_3_start] = ACTIONS(1766),
    [sym__html_block_4_start] = ACTIONS(1766),
    [sym__html_block_5_start] = ACTIONS(1766),
    [sym__html_block_6_start] = ACTIONS(1766),
    [sym__html_block_7_start] = ACTIONS(1766),
    [sym__pipe_table_start] = ACTIONS(1766),
  },
  [297] = {
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_RBRACK] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_GT] = ACTIONS(1772),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_SQUOTE] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(1772),
    [anon_sym_BSLASH] = ACTIONS(1772),
    [anon_sym_CARET] = ACTIONS(1772),
    [anon_sym__] = ACTIONS(1772),
    [anon_sym_BQUOTE] = ACTIONS(1772),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RBRACE] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [anon_sym_LPAREN] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [aux_sym__word_token1] = ACTIONS(1772),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1772),
    [aux_sym__word_token2] = ACTIONS(1772),
    [sym__whitespace] = ACTIONS(1772),
    [sym__soft_line_ending] = ACTIONS(1772),
    [sym__block_close] = ACTIONS(1772),
    [sym__block_quote_start] = ACTIONS(1772),
    [sym__indented_chunk_start] = ACTIONS(1772),
    [sym_atx_h1_marker] = ACTIONS(1772),
    [sym_atx_h2_marker] = ACTIONS(1772),
    [sym_atx_h3_marker] = ACTIONS(1772),
    [sym_atx_h4_marker] = ACTIONS(1772),
    [sym_atx_h5_marker] = ACTIONS(1772),
    [sym_atx_h6_marker] = ACTIONS(1772),
    [sym__thematic_break] = ACTIONS(1772),
    [sym__list_marker_minus] = ACTIONS(1772),
    [sym__list_marker_plus] = ACTIONS(1772),
    [sym__list_marker_star] = ACTIONS(1772),
    [sym__list_marker_parenthesis] = ACTIONS(1772),
    [sym__list_marker_dot] = ACTIONS(1772),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1772),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1772),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1772),
    [sym__blank_line_start] = ACTIONS(1772),
    [sym__html_block_1_start] = ACTIONS(1772),
    [sym__html_block_2_start] = ACTIONS(1772),
    [sym__html_block_3_start] = ACTIONS(1772),
    [sym__html_block_4_start] = ACTIONS(1772),
    [sym__html_block_5_start] = ACTIONS(1772),
    [sym__html_block_6_start] = ACTIONS(1772),
    [sym__html_block_7_start] = ACTIONS(1772),
    [sym__pipe_table_start] = ACTIONS(1772),
  },
  [298] = {
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1776),
    [anon_sym_LT] = ACTIONS(1776),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1776),
    [anon_sym_DQUOTE] = ACTIONS(1776),
    [anon_sym_POUND] = ACTIONS(1776),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_SQUOTE] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_COMMA] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_QMARK] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(1776),
    [anon_sym_BSLASH] = ACTIONS(1776),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym__] = ACTIONS(1776),
    [anon_sym_BQUOTE] = ACTIONS(1776),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_RBRACE] = ACTIONS(1776),
    [anon_sym_TILDE] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1776),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [aux_sym__word_token1] = ACTIONS(1776),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1776),
    [aux_sym__word_token2] = ACTIONS(1776),
    [sym__whitespace] = ACTIONS(1776),
    [sym__soft_line_ending] = ACTIONS(1776),
    [sym__block_close] = ACTIONS(1776),
    [sym__block_quote_start] = ACTIONS(1776),
    [sym__indented_chunk_start] = ACTIONS(1776),
    [sym_atx_h1_marker] = ACTIONS(1776),
    [sym_atx_h2_marker] = ACTIONS(1776),
    [sym_atx_h3_marker] = ACTIONS(1776),
    [sym_atx_h4_marker] = ACTIONS(1776),
    [sym_atx_h5_marker] = ACTIONS(1776),
    [sym_atx_h6_marker] = ACTIONS(1776),
    [sym__thematic_break] = ACTIONS(1776),
    [sym__list_marker_minus] = ACTIONS(1776),
    [sym__list_marker_plus] = ACTIONS(1776),
    [sym__list_marker_star] = ACTIONS(1776),
    [sym__list_marker_parenthesis] = ACTIONS(1776),
    [sym__list_marker_dot] = ACTIONS(1776),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1776),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1776),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1776),
    [sym__blank_line_start] = ACTIONS(1776),
    [sym__html_block_1_start] = ACTIONS(1776),
    [sym__html_block_2_start] = ACTIONS(1776),
    [sym__html_block_3_start] = ACTIONS(1776),
    [sym__html_block_4_start] = ACTIONS(1776),
    [sym__html_block_5_start] = ACTIONS(1776),
    [sym__html_block_6_start] = ACTIONS(1776),
    [sym__html_block_7_start] = ACTIONS(1776),
    [sym__pipe_table_start] = ACTIONS(1776),
  },
  [299] = {
    [anon_sym_LBRACK] = ACTIONS(1768),
    [anon_sym_RBRACK] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_GT] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1766),
    [anon_sym_DQUOTE] = ACTIONS(1766),
    [anon_sym_POUND] = ACTIONS(1766),
    [anon_sym_DOLLAR] = ACTIONS(1766),
    [anon_sym_PERCENT] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [anon_sym_SQUOTE] = ACTIONS(1766),
    [anon_sym_STAR] = ACTIONS(1766),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_COMMA] = ACTIONS(1766),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_SLASH] = ACTIONS(1766),
    [anon_sym_COLON] = ACTIONS(1766),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_EQ] = ACTIONS(1766),
    [anon_sym_QMARK] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(1766),
    [anon_sym_BSLASH] = ACTIONS(1766),
    [anon_sym_CARET] = ACTIONS(1766),
    [anon_sym__] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_RBRACE] = ACTIONS(1766),
    [anon_sym_TILDE] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1766),
    [anon_sym_RPAREN] = ACTIONS(1766),
    [aux_sym__word_token1] = ACTIONS(1766),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1766),
    [aux_sym__word_token2] = ACTIONS(1766),
    [sym__whitespace] = ACTIONS(1766),
    [sym__soft_line_ending] = ACTIONS(1766),
    [sym__block_close] = ACTIONS(1766),
    [sym__block_quote_start] = ACTIONS(1766),
    [sym__indented_chunk_start] = ACTIONS(1766),
    [sym_atx_h1_marker] = ACTIONS(1766),
    [sym_atx_h2_marker] = ACTIONS(1766),
    [sym_atx_h3_marker] = ACTIONS(1766),
    [sym_atx_h4_marker] = ACTIONS(1766),
    [sym_atx_h5_marker] = ACTIONS(1766),
    [sym_atx_h6_marker] = ACTIONS(1766),
    [sym__thematic_break] = ACTIONS(1766),
    [sym__list_marker_minus] = ACTIONS(1766),
    [sym__list_marker_plus] = ACTIONS(1766),
    [sym__list_marker_star] = ACTIONS(1766),
    [sym__list_marker_parenthesis] = ACTIONS(1766),
    [sym__list_marker_dot] = ACTIONS(1766),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1766),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1766),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1766),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1766),
    [sym__blank_line_start] = ACTIONS(1766),
    [sym__html_block_1_start] = ACTIONS(1766),
    [sym__html_block_2_start] = ACTIONS(1766),
    [sym__html_block_3_start] = ACTIONS(1766),
    [sym__html_block_4_start] = ACTIONS(1766),
    [sym__html_block_5_start] = ACTIONS(1766),
    [sym__html_block_6_start] = ACTIONS(1766),
    [sym__html_block_7_start] = ACTIONS(1766),
    [sym__pipe_table_start] = ACTIONS(1766),
  },
  [300] = {
    [anon_sym_LBRACK] = ACTIONS(1764),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_SQUOTE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_COMMA] = ACTIONS(1762),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1762),
    [anon_sym_BSLASH] = ACTIONS(1762),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym__] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_TILDE] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [aux_sym__word_token1] = ACTIONS(1762),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1762),
    [aux_sym__word_token2] = ACTIONS(1762),
    [sym__whitespace] = ACTIONS(1762),
    [sym__soft_line_ending] = ACTIONS(1762),
    [sym__block_close] = ACTIONS(1762),
    [sym__block_quote_start] = ACTIONS(1762),
    [sym__indented_chunk_start] = ACTIONS(1762),
    [sym_atx_h1_marker] = ACTIONS(1762),
    [sym_atx_h2_marker] = ACTIONS(1762),
    [sym_atx_h3_marker] = ACTIONS(1762),
    [sym_atx_h4_marker] = ACTIONS(1762),
    [sym_atx_h5_marker] = ACTIONS(1762),
    [sym_atx_h6_marker] = ACTIONS(1762),
    [sym__thematic_break] = ACTIONS(1762),
    [sym__list_marker_minus] = ACTIONS(1762),
    [sym__list_marker_plus] = ACTIONS(1762),
    [sym__list_marker_star] = ACTIONS(1762),
    [sym__list_marker_parenthesis] = ACTIONS(1762),
    [sym__list_marker_dot] = ACTIONS(1762),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1762),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1762),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1762),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1762),
    [sym__blank_line_start] = ACTIONS(1762),
    [sym__html_block_1_start] = ACTIONS(1762),
    [sym__html_block_2_start] = ACTIONS(1762),
    [sym__html_block_3_start] = ACTIONS(1762),
    [sym__html_block_4_start] = ACTIONS(1762),
    [sym__html_block_5_start] = ACTIONS(1762),
    [sym__html_block_6_start] = ACTIONS(1762),
    [sym__html_block_7_start] = ACTIONS(1762),
    [sym__pipe_table_start] = ACTIONS(1762),
  },
  [301] = {
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1758),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_GT] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_DQUOTE] = ACTIONS(1758),
    [anon_sym_POUND] = ACTIONS(1758),
    [anon_sym_DOLLAR] = ACTIONS(1758),
    [anon_sym_PERCENT] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_SQUOTE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(1758),
    [anon_sym_COMMA] = ACTIONS(1758),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_SLASH] = ACTIONS(1758),
    [anon_sym_COLON] = ACTIONS(1758),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_EQ] = ACTIONS(1758),
    [anon_sym_QMARK] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(1758),
    [anon_sym_BSLASH] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1758),
    [anon_sym__] = ACTIONS(1758),
    [anon_sym_BQUOTE] = ACTIONS(1758),
    [anon_sym_LBRACE] = ACTIONS(1758),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [anon_sym_TILDE] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1758),
    [anon_sym_RPAREN] = ACTIONS(1758),
    [aux_sym__word_token1] = ACTIONS(1758),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1758),
    [aux_sym__word_token2] = ACTIONS(1758),
    [sym__whitespace] = ACTIONS(1758),
    [sym__soft_line_ending] = ACTIONS(1758),
    [sym__block_close] = ACTIONS(1758),
    [sym__block_quote_start] = ACTIONS(1758),
    [sym__indented_chunk_start] = ACTIONS(1758),
    [sym_atx_h1_marker] = ACTIONS(1758),
    [sym_atx_h2_marker] = ACTIONS(1758),
    [sym_atx_h3_marker] = ACTIONS(1758),
    [sym_atx_h4_marker] = ACTIONS(1758),
    [sym_atx_h5_marker] = ACTIONS(1758),
    [sym_atx_h6_marker] = ACTIONS(1758),
    [sym__thematic_break] = ACTIONS(1758),
    [sym__list_marker_minus] = ACTIONS(1758),
    [sym__list_marker_plus] = ACTIONS(1758),
    [sym__list_marker_star] = ACTIONS(1758),
    [sym__list_marker_parenthesis] = ACTIONS(1758),
    [sym__list_marker_dot] = ACTIONS(1758),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1758),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1758),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1758),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1758),
    [sym__blank_line_start] = ACTIONS(1758),
    [sym__html_block_1_start] = ACTIONS(1758),
    [sym__html_block_2_start] = ACTIONS(1758),
    [sym__html_block_3_start] = ACTIONS(1758),
    [sym__html_block_4_start] = ACTIONS(1758),
    [sym__html_block_5_start] = ACTIONS(1758),
    [sym__html_block_6_start] = ACTIONS(1758),
    [sym__html_block_7_start] = ACTIONS(1758),
    [sym__pipe_table_start] = ACTIONS(1758),
  },
  [302] = {
    [anon_sym_LBRACK] = ACTIONS(1778),
    [anon_sym_RBRACK] = ACTIONS(1780),
    [anon_sym_LT] = ACTIONS(1780),
    [anon_sym_GT] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1780),
    [anon_sym_DQUOTE] = ACTIONS(1780),
    [anon_sym_POUND] = ACTIONS(1780),
    [anon_sym_DOLLAR] = ACTIONS(1780),
    [anon_sym_PERCENT] = ACTIONS(1780),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_SQUOTE] = ACTIONS(1780),
    [anon_sym_STAR] = ACTIONS(1780),
    [anon_sym_PLUS] = ACTIONS(1780),
    [anon_sym_COMMA] = ACTIONS(1780),
    [anon_sym_DASH] = ACTIONS(1780),
    [anon_sym_DOT] = ACTIONS(1780),
    [anon_sym_SLASH] = ACTIONS(1780),
    [anon_sym_COLON] = ACTIONS(1780),
    [anon_sym_SEMI] = ACTIONS(1780),
    [anon_sym_EQ] = ACTIONS(1780),
    [anon_sym_QMARK] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(1780),
    [anon_sym_BSLASH] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1780),
    [anon_sym__] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1780),
    [anon_sym_PIPE] = ACTIONS(1780),
    [anon_sym_RBRACE] = ACTIONS(1780),
    [anon_sym_TILDE] = ACTIONS(1780),
    [anon_sym_LPAREN] = ACTIONS(1780),
    [anon_sym_RPAREN] = ACTIONS(1780),
    [aux_sym__word_token1] = ACTIONS(1780),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1780),
    [aux_sym__word_token2] = ACTIONS(1780),
    [sym__whitespace] = ACTIONS(1780),
    [sym__soft_line_ending] = ACTIONS(1780),
    [sym__block_close] = ACTIONS(1780),
    [sym__block_quote_start] = ACTIONS(1780),
    [sym__indented_chunk_start] = ACTIONS(1780),
    [sym_atx_h1_marker] = ACTIONS(1780),
    [sym_atx_h2_marker] = ACTIONS(1780),
    [sym_atx_h3_marker] = ACTIONS(1780),
    [sym_atx_h4_marker] = ACTIONS(1780),
    [sym_atx_h5_marker] = ACTIONS(1780),
    [sym_atx_h6_marker] = ACTIONS(1780),
    [sym__thematic_break] = ACTIONS(1780),
    [sym__list_marker_minus] = ACTIONS(1780),
    [sym__list_marker_plus] = ACTIONS(1780),
    [sym__list_marker_star] = ACTIONS(1780),
    [sym__list_marker_parenthesis] = ACTIONS(1780),
    [sym__list_marker_dot] = ACTIONS(1780),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1780),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1780),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1780),
    [sym__blank_line_start] = ACTIONS(1780),
    [sym__html_block_1_start] = ACTIONS(1780),
    [sym__html_block_2_start] = ACTIONS(1780),
    [sym__html_block_3_start] = ACTIONS(1780),
    [sym__html_block_4_start] = ACTIONS(1780),
    [sym__html_block_5_start] = ACTIONS(1780),
    [sym__html_block_6_start] = ACTIONS(1780),
    [sym__html_block_7_start] = ACTIONS(1780),
    [sym__pipe_table_start] = ACTIONS(1780),
  },
  [303] = {
    [anon_sym_LBRACK] = ACTIONS(1744),
    [anon_sym_RBRACK] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_BANG] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [anon_sym_POUND] = ACTIONS(1742),
    [anon_sym_DOLLAR] = ACTIONS(1742),
    [anon_sym_PERCENT] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [anon_sym_STAR] = ACTIONS(1742),
    [anon_sym_PLUS] = ACTIONS(1742),
    [anon_sym_COMMA] = ACTIONS(1742),
    [anon_sym_DASH] = ACTIONS(1742),
    [anon_sym_DOT] = ACTIONS(1742),
    [anon_sym_SLASH] = ACTIONS(1742),
    [anon_sym_COLON] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_EQ] = ACTIONS(1742),
    [anon_sym_QMARK] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(1742),
    [anon_sym_BSLASH] = ACTIONS(1742),
    [anon_sym_CARET] = ACTIONS(1742),
    [anon_sym__] = ACTIONS(1742),
    [anon_sym_BQUOTE] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_TILDE] = ACTIONS(1742),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [aux_sym__word_token1] = ACTIONS(1742),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1742),
    [aux_sym__word_token2] = ACTIONS(1742),
    [sym__whitespace] = ACTIONS(1742),
    [sym__soft_line_ending] = ACTIONS(1742),
    [sym__block_close] = ACTIONS(1742),
    [sym__block_quote_start] = ACTIONS(1742),
    [sym__indented_chunk_start] = ACTIONS(1742),
    [sym_atx_h1_marker] = ACTIONS(1742),
    [sym_atx_h2_marker] = ACTIONS(1742),
    [sym_atx_h3_marker] = ACTIONS(1742),
    [sym_atx_h4_marker] = ACTIONS(1742),
    [sym_atx_h5_marker] = ACTIONS(1742),
    [sym_atx_h6_marker] = ACTIONS(1742),
    [sym__thematic_break] = ACTIONS(1742),
    [sym__list_marker_minus] = ACTIONS(1742),
    [sym__list_marker_plus] = ACTIONS(1742),
    [sym__list_marker_star] = ACTIONS(1742),
    [sym__list_marker_parenthesis] = ACTIONS(1742),
    [sym__list_marker_dot] = ACTIONS(1742),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1742),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1742),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1742),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1742),
    [sym__blank_line_start] = ACTIONS(1742),
    [sym__html_block_1_start] = ACTIONS(1742),
    [sym__html_block_2_start] = ACTIONS(1742),
    [sym__html_block_3_start] = ACTIONS(1742),
    [sym__html_block_4_start] = ACTIONS(1742),
    [sym__html_block_5_start] = ACTIONS(1742),
    [sym__html_block_6_start] = ACTIONS(1742),
    [sym__html_block_7_start] = ACTIONS(1742),
    [sym__pipe_table_start] = ACTIONS(1742),
  },
  [304] = {
    [anon_sym_LBRACK] = ACTIONS(1736),
    [anon_sym_RBRACK] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [anon_sym_PERCENT] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1734),
    [anon_sym_SLASH] = ACTIONS(1734),
    [anon_sym_COLON] = ACTIONS(1734),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_QMARK] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(1734),
    [anon_sym_BSLASH] = ACTIONS(1734),
    [anon_sym_CARET] = ACTIONS(1734),
    [anon_sym__] = ACTIONS(1734),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_TILDE] = ACTIONS(1734),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [aux_sym__word_token1] = ACTIONS(1734),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1734),
    [aux_sym__word_token2] = ACTIONS(1734),
    [sym__whitespace] = ACTIONS(1734),
    [sym__soft_line_ending] = ACTIONS(1734),
    [sym__block_close] = ACTIONS(1734),
    [sym__block_quote_start] = ACTIONS(1734),
    [sym__indented_chunk_start] = ACTIONS(1734),
    [sym_atx_h1_marker] = ACTIONS(1734),
    [sym_atx_h2_marker] = ACTIONS(1734),
    [sym_atx_h3_marker] = ACTIONS(1734),
    [sym_atx_h4_marker] = ACTIONS(1734),
    [sym_atx_h5_marker] = ACTIONS(1734),
    [sym_atx_h6_marker] = ACTIONS(1734),
    [sym__thematic_break] = ACTIONS(1734),
    [sym__list_marker_minus] = ACTIONS(1734),
    [sym__list_marker_plus] = ACTIONS(1734),
    [sym__list_marker_star] = ACTIONS(1734),
    [sym__list_marker_parenthesis] = ACTIONS(1734),
    [sym__list_marker_dot] = ACTIONS(1734),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1734),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1734),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1734),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1734),
    [sym__blank_line_start] = ACTIONS(1734),
    [sym__html_block_1_start] = ACTIONS(1734),
    [sym__html_block_2_start] = ACTIONS(1734),
    [sym__html_block_3_start] = ACTIONS(1734),
    [sym__html_block_4_start] = ACTIONS(1734),
    [sym__html_block_5_start] = ACTIONS(1734),
    [sym__html_block_6_start] = ACTIONS(1734),
    [sym__html_block_7_start] = ACTIONS(1734),
    [sym__pipe_table_start] = ACTIONS(1734),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(1776),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1776),
    [anon_sym_LT] = ACTIONS(1776),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1776),
    [anon_sym_DQUOTE] = ACTIONS(1776),
    [anon_sym_POUND] = ACTIONS(1776),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_SQUOTE] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_COMMA] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_SEMI] = ACTIONS(1776),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_QMARK] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(1776),
    [anon_sym_BSLASH] = ACTIONS(1776),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym__] = ACTIONS(1776),
    [anon_sym_BQUOTE] = ACTIONS(1776),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_RBRACE] = ACTIONS(1776),
    [anon_sym_TILDE] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1776),
    [anon_sym_RPAREN] = ACTIONS(1776),
    [aux_sym__word_token1] = ACTIONS(1776),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1776),
    [aux_sym__word_token2] = ACTIONS(1776),
    [sym__whitespace] = ACTIONS(1776),
    [sym__soft_line_ending] = ACTIONS(1776),
    [sym__block_quote_start] = ACTIONS(1776),
    [sym__indented_chunk_start] = ACTIONS(1776),
    [sym_atx_h1_marker] = ACTIONS(1776),
    [sym_atx_h2_marker] = ACTIONS(1776),
    [sym_atx_h3_marker] = ACTIONS(1776),
    [sym_atx_h4_marker] = ACTIONS(1776),
    [sym_atx_h5_marker] = ACTIONS(1776),
    [sym_atx_h6_marker] = ACTIONS(1776),
    [sym__thematic_break] = ACTIONS(1776),
    [sym__list_marker_minus] = ACTIONS(1776),
    [sym__list_marker_plus] = ACTIONS(1776),
    [sym__list_marker_star] = ACTIONS(1776),
    [sym__list_marker_parenthesis] = ACTIONS(1776),
    [sym__list_marker_dot] = ACTIONS(1776),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1776),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1776),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1776),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1776),
    [sym__blank_line_start] = ACTIONS(1776),
    [sym__html_block_1_start] = ACTIONS(1776),
    [sym__html_block_2_start] = ACTIONS(1776),
    [sym__html_block_3_start] = ACTIONS(1776),
    [sym__html_block_4_start] = ACTIONS(1776),
    [sym__html_block_5_start] = ACTIONS(1776),
    [sym__html_block_6_start] = ACTIONS(1776),
    [sym__html_block_7_start] = ACTIONS(1776),
    [sym__pipe_table_start] = ACTIONS(1776),
  },
  [306] = {
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_RBRACK] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_GT] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_POUND] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1730),
    [anon_sym_PERCENT] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_SLASH] = ACTIONS(1730),
    [anon_sym_COLON] = ACTIONS(1730),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_EQ] = ACTIONS(1730),
    [anon_sym_QMARK] = ACTIONS(1730),
    [anon_sym_AT] = ACTIONS(1730),
    [anon_sym_BSLASH] = ACTIONS(1730),
    [anon_sym_CARET] = ACTIONS(1730),
    [anon_sym__] = ACTIONS(1730),
    [anon_sym_BQUOTE] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_TILDE] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_RPAREN] = ACTIONS(1730),
    [aux_sym__word_token1] = ACTIONS(1730),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1730),
    [aux_sym__word_token2] = ACTIONS(1730),
    [sym__whitespace] = ACTIONS(1730),
    [sym__soft_line_ending] = ACTIONS(1730),
    [sym__block_close] = ACTIONS(1730),
    [sym__block_quote_start] = ACTIONS(1730),
    [sym__indented_chunk_start] = ACTIONS(1730),
    [sym_atx_h1_marker] = ACTIONS(1730),
    [sym_atx_h2_marker] = ACTIONS(1730),
    [sym_atx_h3_marker] = ACTIONS(1730),
    [sym_atx_h4_marker] = ACTIONS(1730),
    [sym_atx_h5_marker] = ACTIONS(1730),
    [sym_atx_h6_marker] = ACTIONS(1730),
    [sym__thematic_break] = ACTIONS(1730),
    [sym__list_marker_minus] = ACTIONS(1730),
    [sym__list_marker_plus] = ACTIONS(1730),
    [sym__list_marker_star] = ACTIONS(1730),
    [sym__list_marker_parenthesis] = ACTIONS(1730),
    [sym__list_marker_dot] = ACTIONS(1730),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1730),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1730),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1730),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1730),
    [sym__blank_line_start] = ACTIONS(1730),
    [sym__html_block_1_start] = ACTIONS(1730),
    [sym__html_block_2_start] = ACTIONS(1730),
    [sym__html_block_3_start] = ACTIONS(1730),
    [sym__html_block_4_start] = ACTIONS(1730),
    [sym__html_block_5_start] = ACTIONS(1730),
    [sym__html_block_6_start] = ACTIONS(1730),
    [sym__html_block_7_start] = ACTIONS(1730),
    [sym__pipe_table_start] = ACTIONS(1730),
  },
  [307] = {
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_RBRACK] = ACTIONS(1726),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_DQUOTE] = ACTIONS(1726),
    [anon_sym_POUND] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1726),
    [anon_sym_PERCENT] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_SQUOTE] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(1726),
    [anon_sym_COMMA] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_DOT] = ACTIONS(1726),
    [anon_sym_SLASH] = ACTIONS(1726),
    [anon_sym_COLON] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1726),
    [anon_sym_EQ] = ACTIONS(1726),
    [anon_sym_QMARK] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(1726),
    [anon_sym_BSLASH] = ACTIONS(1726),
    [anon_sym_CARET] = ACTIONS(1726),
    [anon_sym__] = ACTIONS(1726),
    [anon_sym_BQUOTE] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1726),
    [anon_sym_PIPE] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1726),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [aux_sym__word_token1] = ACTIONS(1726),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1726),
    [aux_sym__word_token2] = ACTIONS(1726),
    [sym__whitespace] = ACTIONS(1726),
    [sym__soft_line_ending] = ACTIONS(1726),
    [sym__block_close] = ACTIONS(1726),
    [sym__block_quote_start] = ACTIONS(1726),
    [sym__indented_chunk_start] = ACTIONS(1726),
    [sym_atx_h1_marker] = ACTIONS(1726),
    [sym_atx_h2_marker] = ACTIONS(1726),
    [sym_atx_h3_marker] = ACTIONS(1726),
    [sym_atx_h4_marker] = ACTIONS(1726),
    [sym_atx_h5_marker] = ACTIONS(1726),
    [sym_atx_h6_marker] = ACTIONS(1726),
    [sym__thematic_break] = ACTIONS(1726),
    [sym__list_marker_minus] = ACTIONS(1726),
    [sym__list_marker_plus] = ACTIONS(1726),
    [sym__list_marker_star] = ACTIONS(1726),
    [sym__list_marker_parenthesis] = ACTIONS(1726),
    [sym__list_marker_dot] = ACTIONS(1726),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1726),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1726),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1726),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1726),
    [sym__blank_line_start] = ACTIONS(1726),
    [sym__html_block_1_start] = ACTIONS(1726),
    [sym__html_block_2_start] = ACTIONS(1726),
    [sym__html_block_3_start] = ACTIONS(1726),
    [sym__html_block_4_start] = ACTIONS(1726),
    [sym__html_block_5_start] = ACTIONS(1726),
    [sym__html_block_6_start] = ACTIONS(1726),
    [sym__html_block_7_start] = ACTIONS(1726),
    [sym__pipe_table_start] = ACTIONS(1726),
  },
  [308] = {
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_GT] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_DOLLAR] = ACTIONS(1722),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_PLUS] = ACTIONS(1722),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_DOT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1722),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(1722),
    [anon_sym_QMARK] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_BSLASH] = ACTIONS(1722),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym__] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [aux_sym__word_token1] = ACTIONS(1722),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1722),
    [aux_sym__word_token2] = ACTIONS(1722),
    [sym__whitespace] = ACTIONS(1722),
    [sym__soft_line_ending] = ACTIONS(1722),
    [sym__block_close] = ACTIONS(1722),
    [sym__block_quote_start] = ACTIONS(1722),
    [sym__indented_chunk_start] = ACTIONS(1722),
    [sym_atx_h1_marker] = ACTIONS(1722),
    [sym_atx_h2_marker] = ACTIONS(1722),
    [sym_atx_h3_marker] = ACTIONS(1722),
    [sym_atx_h4_marker] = ACTIONS(1722),
    [sym_atx_h5_marker] = ACTIONS(1722),
    [sym_atx_h6_marker] = ACTIONS(1722),
    [sym__thematic_break] = ACTIONS(1722),
    [sym__list_marker_minus] = ACTIONS(1722),
    [sym__list_marker_plus] = ACTIONS(1722),
    [sym__list_marker_star] = ACTIONS(1722),
    [sym__list_marker_parenthesis] = ACTIONS(1722),
    [sym__list_marker_dot] = ACTIONS(1722),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1722),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1722),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1722),
    [sym__blank_line_start] = ACTIONS(1722),
    [sym__html_block_1_start] = ACTIONS(1722),
    [sym__html_block_2_start] = ACTIONS(1722),
    [sym__html_block_3_start] = ACTIONS(1722),
    [sym__html_block_4_start] = ACTIONS(1722),
    [sym__html_block_5_start] = ACTIONS(1722),
    [sym__html_block_6_start] = ACTIONS(1722),
    [sym__html_block_7_start] = ACTIONS(1722),
    [sym__pipe_table_start] = ACTIONS(1722),
  },
  [309] = {
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_GT] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_DOLLAR] = ACTIONS(1722),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_PLUS] = ACTIONS(1722),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_DOT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1722),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(1722),
    [anon_sym_QMARK] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_BSLASH] = ACTIONS(1722),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym__] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [aux_sym__word_token1] = ACTIONS(1722),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1722),
    [aux_sym__word_token2] = ACTIONS(1722),
    [sym__whitespace] = ACTIONS(1722),
    [sym__soft_line_ending] = ACTIONS(1722),
    [sym__block_close] = ACTIONS(1722),
    [sym__block_quote_start] = ACTIONS(1722),
    [sym__indented_chunk_start] = ACTIONS(1722),
    [sym_atx_h1_marker] = ACTIONS(1722),
    [sym_atx_h2_marker] = ACTIONS(1722),
    [sym_atx_h3_marker] = ACTIONS(1722),
    [sym_atx_h4_marker] = ACTIONS(1722),
    [sym_atx_h5_marker] = ACTIONS(1722),
    [sym_atx_h6_marker] = ACTIONS(1722),
    [sym__thematic_break] = ACTIONS(1722),
    [sym__list_marker_minus] = ACTIONS(1722),
    [sym__list_marker_plus] = ACTIONS(1722),
    [sym__list_marker_star] = ACTIONS(1722),
    [sym__list_marker_parenthesis] = ACTIONS(1722),
    [sym__list_marker_dot] = ACTIONS(1722),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1722),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1722),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1722),
    [sym__blank_line_start] = ACTIONS(1722),
    [sym__html_block_1_start] = ACTIONS(1722),
    [sym__html_block_2_start] = ACTIONS(1722),
    [sym__html_block_3_start] = ACTIONS(1722),
    [sym__html_block_4_start] = ACTIONS(1722),
    [sym__html_block_5_start] = ACTIONS(1722),
    [sym__html_block_6_start] = ACTIONS(1722),
    [sym__html_block_7_start] = ACTIONS(1722),
    [sym__pipe_table_start] = ACTIONS(1722),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(1772),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_RBRACK] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_GT] = ACTIONS(1772),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [anon_sym_POUND] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_SQUOTE] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(1772),
    [anon_sym_BSLASH] = ACTIONS(1772),
    [anon_sym_CARET] = ACTIONS(1772),
    [anon_sym__] = ACTIONS(1772),
    [anon_sym_BQUOTE] = ACTIONS(1772),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RBRACE] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [anon_sym_LPAREN] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [aux_sym__word_token1] = ACTIONS(1772),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1772),
    [aux_sym__word_token2] = ACTIONS(1772),
    [sym__whitespace] = ACTIONS(1772),
    [sym__soft_line_ending] = ACTIONS(1772),
    [sym__block_quote_start] = ACTIONS(1772),
    [sym__indented_chunk_start] = ACTIONS(1772),
    [sym_atx_h1_marker] = ACTIONS(1772),
    [sym_atx_h2_marker] = ACTIONS(1772),
    [sym_atx_h3_marker] = ACTIONS(1772),
    [sym_atx_h4_marker] = ACTIONS(1772),
    [sym_atx_h5_marker] = ACTIONS(1772),
    [sym_atx_h6_marker] = ACTIONS(1772),
    [sym__thematic_break] = ACTIONS(1772),
    [sym__list_marker_minus] = ACTIONS(1772),
    [sym__list_marker_plus] = ACTIONS(1772),
    [sym__list_marker_star] = ACTIONS(1772),
    [sym__list_marker_parenthesis] = ACTIONS(1772),
    [sym__list_marker_dot] = ACTIONS(1772),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1772),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1772),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1772),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1772),
    [sym__blank_line_start] = ACTIONS(1772),
    [sym__html_block_1_start] = ACTIONS(1772),
    [sym__html_block_2_start] = ACTIONS(1772),
    [sym__html_block_3_start] = ACTIONS(1772),
    [sym__html_block_4_start] = ACTIONS(1772),
    [sym__html_block_5_start] = ACTIONS(1772),
    [sym__html_block_6_start] = ACTIONS(1772),
    [sym__html_block_7_start] = ACTIONS(1772),
    [sym__pipe_table_start] = ACTIONS(1772),
  },
  [311] = {
    [anon_sym_LBRACK] = ACTIONS(1782),
    [anon_sym_RBRACK] = ACTIONS(1784),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_GT] = ACTIONS(1784),
    [anon_sym_BANG] = ACTIONS(1784),
    [anon_sym_DQUOTE] = ACTIONS(1784),
    [anon_sym_POUND] = ACTIONS(1784),
    [anon_sym_DOLLAR] = ACTIONS(1784),
    [anon_sym_PERCENT] = ACTIONS(1784),
    [anon_sym_AMP] = ACTIONS(1784),
    [anon_sym_SQUOTE] = ACTIONS(1784),
    [anon_sym_STAR] = ACTIONS(1784),
    [anon_sym_PLUS] = ACTIONS(1784),
    [anon_sym_COMMA] = ACTIONS(1784),
    [anon_sym_DASH] = ACTIONS(1784),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_SLASH] = ACTIONS(1784),
    [anon_sym_COLON] = ACTIONS(1784),
    [anon_sym_SEMI] = ACTIONS(1784),
    [anon_sym_EQ] = ACTIONS(1784),
    [anon_sym_QMARK] = ACTIONS(1784),
    [anon_sym_AT] = ACTIONS(1784),
    [anon_sym_BSLASH] = ACTIONS(1784),
    [anon_sym_CARET] = ACTIONS(1784),
    [anon_sym__] = ACTIONS(1784),
    [anon_sym_BQUOTE] = ACTIONS(1784),
    [anon_sym_LBRACE] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1784),
    [anon_sym_RBRACE] = ACTIONS(1784),
    [anon_sym_TILDE] = ACTIONS(1784),
    [anon_sym_LPAREN] = ACTIONS(1784),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [aux_sym__word_token1] = ACTIONS(1784),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1784),
    [aux_sym__word_token2] = ACTIONS(1784),
    [sym__whitespace] = ACTIONS(1784),
    [sym__soft_line_ending] = ACTIONS(1784),
    [sym__block_close] = ACTIONS(1784),
    [sym__block_quote_start] = ACTIONS(1784),
    [sym__indented_chunk_start] = ACTIONS(1784),
    [sym_atx_h1_marker] = ACTIONS(1784),
    [sym_atx_h2_marker] = ACTIONS(1784),
    [sym_atx_h3_marker] = ACTIONS(1784),
    [sym_atx_h4_marker] = ACTIONS(1784),
    [sym_atx_h5_marker] = ACTIONS(1784),
    [sym_atx_h6_marker] = ACTIONS(1784),
    [sym__thematic_break] = ACTIONS(1784),
    [sym__list_marker_minus] = ACTIONS(1784),
    [sym__list_marker_plus] = ACTIONS(1784),
    [sym__list_marker_star] = ACTIONS(1784),
    [sym__list_marker_parenthesis] = ACTIONS(1784),
    [sym__list_marker_dot] = ACTIONS(1784),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1784),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1784),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1784),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1784),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1784),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1784),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1784),
    [sym__blank_line_start] = ACTIONS(1784),
    [sym__html_block_1_start] = ACTIONS(1784),
    [sym__html_block_2_start] = ACTIONS(1784),
    [sym__html_block_3_start] = ACTIONS(1784),
    [sym__html_block_4_start] = ACTIONS(1784),
    [sym__html_block_5_start] = ACTIONS(1784),
    [sym__html_block_6_start] = ACTIONS(1784),
    [sym__html_block_7_start] = ACTIONS(1784),
    [sym__pipe_table_start] = ACTIONS(1784),
  },
  [312] = {
    [anon_sym_LBRACK] = ACTIONS(1712),
    [anon_sym_RBRACK] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_GT] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_POUND] = ACTIONS(1710),
    [anon_sym_DOLLAR] = ACTIONS(1710),
    [anon_sym_PERCENT] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_COMMA] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_DOT] = ACTIONS(1710),
    [anon_sym_SLASH] = ACTIONS(1710),
    [anon_sym_COLON] = ACTIONS(1710),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_EQ] = ACTIONS(1710),
    [anon_sym_QMARK] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_BSLASH] = ACTIONS(1710),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym__] = ACTIONS(1710),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_RPAREN] = ACTIONS(1710),
    [aux_sym__word_token1] = ACTIONS(1710),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1710),
    [aux_sym__word_token2] = ACTIONS(1710),
    [sym__whitespace] = ACTIONS(1710),
    [sym__soft_line_ending] = ACTIONS(1710),
    [sym__block_close] = ACTIONS(1710),
    [sym__block_quote_start] = ACTIONS(1710),
    [sym__indented_chunk_start] = ACTIONS(1710),
    [sym_atx_h1_marker] = ACTIONS(1710),
    [sym_atx_h2_marker] = ACTIONS(1710),
    [sym_atx_h3_marker] = ACTIONS(1710),
    [sym_atx_h4_marker] = ACTIONS(1710),
    [sym_atx_h5_marker] = ACTIONS(1710),
    [sym_atx_h6_marker] = ACTIONS(1710),
    [sym__thematic_break] = ACTIONS(1710),
    [sym__list_marker_minus] = ACTIONS(1710),
    [sym__list_marker_plus] = ACTIONS(1710),
    [sym__list_marker_star] = ACTIONS(1710),
    [sym__list_marker_parenthesis] = ACTIONS(1710),
    [sym__list_marker_dot] = ACTIONS(1710),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1710),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1710),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1710),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1710),
    [sym__blank_line_start] = ACTIONS(1710),
    [sym__html_block_1_start] = ACTIONS(1710),
    [sym__html_block_2_start] = ACTIONS(1710),
    [sym__html_block_3_start] = ACTIONS(1710),
    [sym__html_block_4_start] = ACTIONS(1710),
    [sym__html_block_5_start] = ACTIONS(1710),
    [sym__html_block_6_start] = ACTIONS(1710),
    [sym__html_block_7_start] = ACTIONS(1710),
    [sym__pipe_table_start] = ACTIONS(1710),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(1780),
    [anon_sym_LBRACK] = ACTIONS(1778),
    [anon_sym_RBRACK] = ACTIONS(1780),
    [anon_sym_LT] = ACTIONS(1780),
    [anon_sym_GT] = ACTIONS(1780),
    [anon_sym_BANG] = ACTIONS(1780),
    [anon_sym_DQUOTE] = ACTIONS(1780),
    [anon_sym_POUND] = ACTIONS(1780),
    [anon_sym_DOLLAR] = ACTIONS(1780),
    [anon_sym_PERCENT] = ACTIONS(1780),
    [anon_sym_AMP] = ACTIONS(1780),
    [anon_sym_SQUOTE] = ACTIONS(1780),
    [anon_sym_STAR] = ACTIONS(1780),
    [anon_sym_PLUS] = ACTIONS(1780),
    [anon_sym_COMMA] = ACTIONS(1780),
    [anon_sym_DASH] = ACTIONS(1780),
    [anon_sym_DOT] = ACTIONS(1780),
    [anon_sym_SLASH] = ACTIONS(1780),
    [anon_sym_COLON] = ACTIONS(1780),
    [anon_sym_SEMI] = ACTIONS(1780),
    [anon_sym_EQ] = ACTIONS(1780),
    [anon_sym_QMARK] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(1780),
    [anon_sym_BSLASH] = ACTIONS(1780),
    [anon_sym_CARET] = ACTIONS(1780),
    [anon_sym__] = ACTIONS(1780),
    [anon_sym_BQUOTE] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1780),
    [anon_sym_PIPE] = ACTIONS(1780),
    [anon_sym_RBRACE] = ACTIONS(1780),
    [anon_sym_TILDE] = ACTIONS(1780),
    [anon_sym_LPAREN] = ACTIONS(1780),
    [anon_sym_RPAREN] = ACTIONS(1780),
    [aux_sym__word_token1] = ACTIONS(1780),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1780),
    [aux_sym__word_token2] = ACTIONS(1780),
    [sym__whitespace] = ACTIONS(1780),
    [sym__soft_line_ending] = ACTIONS(1780),
    [sym__block_quote_start] = ACTIONS(1780),
    [sym__indented_chunk_start] = ACTIONS(1780),
    [sym_atx_h1_marker] = ACTIONS(1780),
    [sym_atx_h2_marker] = ACTIONS(1780),
    [sym_atx_h3_marker] = ACTIONS(1780),
    [sym_atx_h4_marker] = ACTIONS(1780),
    [sym_atx_h5_marker] = ACTIONS(1780),
    [sym_atx_h6_marker] = ACTIONS(1780),
    [sym__thematic_break] = ACTIONS(1780),
    [sym__list_marker_minus] = ACTIONS(1780),
    [sym__list_marker_plus] = ACTIONS(1780),
    [sym__list_marker_star] = ACTIONS(1780),
    [sym__list_marker_parenthesis] = ACTIONS(1780),
    [sym__list_marker_dot] = ACTIONS(1780),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1780),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1780),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1780),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1780),
    [sym__blank_line_start] = ACTIONS(1780),
    [sym__html_block_1_start] = ACTIONS(1780),
    [sym__html_block_2_start] = ACTIONS(1780),
    [sym__html_block_3_start] = ACTIONS(1780),
    [sym__html_block_4_start] = ACTIONS(1780),
    [sym__html_block_5_start] = ACTIONS(1780),
    [sym__html_block_6_start] = ACTIONS(1780),
    [sym__html_block_7_start] = ACTIONS(1780),
    [sym__pipe_table_start] = ACTIONS(1780),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [anon_sym_POUND] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_SQUOTE] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_BSLASH] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1544),
    [anon_sym__] = ACTIONS(1544),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [aux_sym__word_token1] = ACTIONS(1544),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1544),
    [aux_sym__word_token2] = ACTIONS(1544),
    [sym__whitespace] = ACTIONS(1544),
    [sym__soft_line_ending] = ACTIONS(1544),
    [sym__block_quote_start] = ACTIONS(1544),
    [sym__indented_chunk_start] = ACTIONS(1544),
    [sym_atx_h1_marker] = ACTIONS(1544),
    [sym_atx_h2_marker] = ACTIONS(1544),
    [sym_atx_h3_marker] = ACTIONS(1544),
    [sym_atx_h4_marker] = ACTIONS(1544),
    [sym_atx_h5_marker] = ACTIONS(1544),
    [sym_atx_h6_marker] = ACTIONS(1544),
    [sym__thematic_break] = ACTIONS(1544),
    [sym__list_marker_minus] = ACTIONS(1544),
    [sym__list_marker_plus] = ACTIONS(1544),
    [sym__list_marker_star] = ACTIONS(1544),
    [sym__list_marker_parenthesis] = ACTIONS(1544),
    [sym__list_marker_dot] = ACTIONS(1544),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1544),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1544),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1544),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1544),
    [sym__blank_line_start] = ACTIONS(1544),
    [sym__html_block_1_start] = ACTIONS(1544),
    [sym__html_block_2_start] = ACTIONS(1544),
    [sym__html_block_3_start] = ACTIONS(1544),
    [sym__html_block_4_start] = ACTIONS(1544),
    [sym__html_block_5_start] = ACTIONS(1544),
    [sym__html_block_6_start] = ACTIONS(1544),
    [sym__html_block_7_start] = ACTIONS(1544),
    [sym__pipe_table_start] = ACTIONS(1544),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_POUND] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(1548),
    [anon_sym_PERCENT] = ACTIONS(1548),
    [anon_sym_AMP] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1548),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1548),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1548),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_BSLASH] = ACTIONS(1548),
    [anon_sym_CARET] = ACTIONS(1548),
    [anon_sym__] = ACTIONS(1548),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [aux_sym__word_token1] = ACTIONS(1548),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1548),
    [aux_sym__word_token2] = ACTIONS(1548),
    [sym__whitespace] = ACTIONS(1548),
    [sym__soft_line_ending] = ACTIONS(1548),
    [sym__block_quote_start] = ACTIONS(1548),
    [sym__indented_chunk_start] = ACTIONS(1548),
    [sym_atx_h1_marker] = ACTIONS(1548),
    [sym_atx_h2_marker] = ACTIONS(1548),
    [sym_atx_h3_marker] = ACTIONS(1548),
    [sym_atx_h4_marker] = ACTIONS(1548),
    [sym_atx_h5_marker] = ACTIONS(1548),
    [sym_atx_h6_marker] = ACTIONS(1548),
    [sym__thematic_break] = ACTIONS(1548),
    [sym__list_marker_minus] = ACTIONS(1548),
    [sym__list_marker_plus] = ACTIONS(1548),
    [sym__list_marker_star] = ACTIONS(1548),
    [sym__list_marker_parenthesis] = ACTIONS(1548),
    [sym__list_marker_dot] = ACTIONS(1548),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1548),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1548),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1548),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1548),
    [sym__blank_line_start] = ACTIONS(1548),
    [sym__html_block_1_start] = ACTIONS(1548),
    [sym__html_block_2_start] = ACTIONS(1548),
    [sym__html_block_3_start] = ACTIONS(1548),
    [sym__html_block_4_start] = ACTIONS(1548),
    [sym__html_block_5_start] = ACTIONS(1548),
    [sym__html_block_6_start] = ACTIONS(1548),
    [sym__html_block_7_start] = ACTIONS(1548),
    [sym__pipe_table_start] = ACTIONS(1548),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [anon_sym_POUND] = ACTIONS(1552),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_PERCENT] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_SEMI] = ACTIONS(1552),
    [anon_sym_EQ] = ACTIONS(1552),
    [anon_sym_QMARK] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(1552),
    [anon_sym_BSLASH] = ACTIONS(1552),
    [anon_sym_CARET] = ACTIONS(1552),
    [anon_sym__] = ACTIONS(1552),
    [anon_sym_BQUOTE] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_RPAREN] = ACTIONS(1552),
    [aux_sym__word_token1] = ACTIONS(1552),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1552),
    [aux_sym__word_token2] = ACTIONS(1552),
    [sym__whitespace] = ACTIONS(1552),
    [sym__soft_line_ending] = ACTIONS(1552),
    [sym__block_quote_start] = ACTIONS(1552),
    [sym__indented_chunk_start] = ACTIONS(1552),
    [sym_atx_h1_marker] = ACTIONS(1552),
    [sym_atx_h2_marker] = ACTIONS(1552),
    [sym_atx_h3_marker] = ACTIONS(1552),
    [sym_atx_h4_marker] = ACTIONS(1552),
    [sym_atx_h5_marker] = ACTIONS(1552),
    [sym_atx_h6_marker] = ACTIONS(1552),
    [sym__thematic_break] = ACTIONS(1552),
    [sym__list_marker_minus] = ACTIONS(1552),
    [sym__list_marker_plus] = ACTIONS(1552),
    [sym__list_marker_star] = ACTIONS(1552),
    [sym__list_marker_parenthesis] = ACTIONS(1552),
    [sym__list_marker_dot] = ACTIONS(1552),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1552),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1552),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1552),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1552),
    [sym__blank_line_start] = ACTIONS(1552),
    [sym__html_block_1_start] = ACTIONS(1552),
    [sym__html_block_2_start] = ACTIONS(1552),
    [sym__html_block_3_start] = ACTIONS(1552),
    [sym__html_block_4_start] = ACTIONS(1552),
    [sym__html_block_5_start] = ACTIONS(1552),
    [sym__html_block_6_start] = ACTIONS(1552),
    [sym__html_block_7_start] = ACTIONS(1552),
    [sym__pipe_table_start] = ACTIONS(1552),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_POUND] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1169),
    [anon_sym_BSLASH] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym__] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1169),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [aux_sym__word_token1] = ACTIONS(1169),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1169),
    [aux_sym__word_token2] = ACTIONS(1169),
    [sym__whitespace] = ACTIONS(1169),
    [sym__soft_line_ending] = ACTIONS(1169),
    [sym__block_quote_start] = ACTIONS(1169),
    [sym__indented_chunk_start] = ACTIONS(1169),
    [sym_atx_h1_marker] = ACTIONS(1169),
    [sym_atx_h2_marker] = ACTIONS(1169),
    [sym_atx_h3_marker] = ACTIONS(1169),
    [sym_atx_h4_marker] = ACTIONS(1169),
    [sym_atx_h5_marker] = ACTIONS(1169),
    [sym_atx_h6_marker] = ACTIONS(1169),
    [sym__thematic_break] = ACTIONS(1169),
    [sym__list_marker_minus] = ACTIONS(1169),
    [sym__list_marker_plus] = ACTIONS(1169),
    [sym__list_marker_star] = ACTIONS(1169),
    [sym__list_marker_parenthesis] = ACTIONS(1169),
    [sym__list_marker_dot] = ACTIONS(1169),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1169),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1169),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1169),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1169),
    [sym__blank_line_start] = ACTIONS(1169),
    [sym__html_block_1_start] = ACTIONS(1169),
    [sym__html_block_2_start] = ACTIONS(1169),
    [sym__html_block_3_start] = ACTIONS(1169),
    [sym__html_block_4_start] = ACTIONS(1169),
    [sym__html_block_5_start] = ACTIONS(1169),
    [sym__html_block_6_start] = ACTIONS(1169),
    [sym__html_block_7_start] = ACTIONS(1169),
    [sym__pipe_table_start] = ACTIONS(1169),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_DQUOTE] = ACTIONS(1556),
    [anon_sym_POUND] = ACTIONS(1556),
    [anon_sym_DOLLAR] = ACTIONS(1556),
    [anon_sym_PERCENT] = ACTIONS(1556),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1556),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_BSLASH] = ACTIONS(1556),
    [anon_sym_CARET] = ACTIONS(1556),
    [anon_sym__] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [aux_sym__word_token1] = ACTIONS(1556),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1556),
    [aux_sym__word_token2] = ACTIONS(1556),
    [sym__whitespace] = ACTIONS(1556),
    [sym__soft_line_ending] = ACTIONS(1556),
    [sym__block_quote_start] = ACTIONS(1556),
    [sym__indented_chunk_start] = ACTIONS(1556),
    [sym_atx_h1_marker] = ACTIONS(1556),
    [sym_atx_h2_marker] = ACTIONS(1556),
    [sym_atx_h3_marker] = ACTIONS(1556),
    [sym_atx_h4_marker] = ACTIONS(1556),
    [sym_atx_h5_marker] = ACTIONS(1556),
    [sym_atx_h6_marker] = ACTIONS(1556),
    [sym__thematic_break] = ACTIONS(1556),
    [sym__list_marker_minus] = ACTIONS(1556),
    [sym__list_marker_plus] = ACTIONS(1556),
    [sym__list_marker_star] = ACTIONS(1556),
    [sym__list_marker_parenthesis] = ACTIONS(1556),
    [sym__list_marker_dot] = ACTIONS(1556),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1556),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1556),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1556),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1556),
    [sym__blank_line_start] = ACTIONS(1556),
    [sym__html_block_1_start] = ACTIONS(1556),
    [sym__html_block_2_start] = ACTIONS(1556),
    [sym__html_block_3_start] = ACTIONS(1556),
    [sym__html_block_4_start] = ACTIONS(1556),
    [sym__html_block_5_start] = ACTIONS(1556),
    [sym__html_block_6_start] = ACTIONS(1556),
    [sym__html_block_7_start] = ACTIONS(1556),
    [sym__pipe_table_start] = ACTIONS(1556),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1748),
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_RBRACK] = ACTIONS(1748),
    [anon_sym_LT] = ACTIONS(1748),
    [anon_sym_GT] = ACTIONS(1748),
    [anon_sym_BANG] = ACTIONS(1748),
    [anon_sym_DQUOTE] = ACTIONS(1748),
    [anon_sym_POUND] = ACTIONS(1748),
    [anon_sym_DOLLAR] = ACTIONS(1748),
    [anon_sym_PERCENT] = ACTIONS(1748),
    [anon_sym_AMP] = ACTIONS(1748),
    [anon_sym_SQUOTE] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1748),
    [anon_sym_PLUS] = ACTIONS(1748),
    [anon_sym_COMMA] = ACTIONS(1748),
    [anon_sym_DASH] = ACTIONS(1748),
    [anon_sym_DOT] = ACTIONS(1748),
    [anon_sym_SLASH] = ACTIONS(1748),
    [anon_sym_COLON] = ACTIONS(1748),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_EQ] = ACTIONS(1748),
    [anon_sym_QMARK] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(1748),
    [anon_sym_BSLASH] = ACTIONS(1748),
    [anon_sym_CARET] = ACTIONS(1748),
    [anon_sym__] = ACTIONS(1748),
    [anon_sym_BQUOTE] = ACTIONS(1748),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_PIPE] = ACTIONS(1748),
    [anon_sym_RBRACE] = ACTIONS(1748),
    [anon_sym_TILDE] = ACTIONS(1748),
    [anon_sym_LPAREN] = ACTIONS(1748),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [aux_sym__word_token1] = ACTIONS(1748),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1748),
    [aux_sym__word_token2] = ACTIONS(1748),
    [sym__whitespace] = ACTIONS(1748),
    [sym__soft_line_ending] = ACTIONS(1748),
    [sym__block_quote_start] = ACTIONS(1748),
    [sym__indented_chunk_start] = ACTIONS(1748),
    [sym_atx_h1_marker] = ACTIONS(1748),
    [sym_atx_h2_marker] = ACTIONS(1748),
    [sym_atx_h3_marker] = ACTIONS(1748),
    [sym_atx_h4_marker] = ACTIONS(1748),
    [sym_atx_h5_marker] = ACTIONS(1748),
    [sym_atx_h6_marker] = ACTIONS(1748),
    [sym__thematic_break] = ACTIONS(1748),
    [sym__list_marker_minus] = ACTIONS(1748),
    [sym__list_marker_plus] = ACTIONS(1748),
    [sym__list_marker_star] = ACTIONS(1748),
    [sym__list_marker_parenthesis] = ACTIONS(1748),
    [sym__list_marker_dot] = ACTIONS(1748),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1748),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1748),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1748),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1748),
    [sym__blank_line_start] = ACTIONS(1748),
    [sym__html_block_1_start] = ACTIONS(1748),
    [sym__html_block_2_start] = ACTIONS(1748),
    [sym__html_block_3_start] = ACTIONS(1748),
    [sym__html_block_4_start] = ACTIONS(1748),
    [sym__html_block_5_start] = ACTIONS(1748),
    [sym__html_block_6_start] = ACTIONS(1748),
    [sym__html_block_7_start] = ACTIONS(1748),
    [sym__pipe_table_start] = ACTIONS(1748),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(1560),
    [anon_sym_DOLLAR] = ACTIONS(1560),
    [anon_sym_PERCENT] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1560),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_COLON] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_BSLASH] = ACTIONS(1560),
    [anon_sym_CARET] = ACTIONS(1560),
    [anon_sym__] = ACTIONS(1560),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [aux_sym__word_token1] = ACTIONS(1560),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1560),
    [aux_sym__word_token2] = ACTIONS(1560),
    [sym__whitespace] = ACTIONS(1560),
    [sym__soft_line_ending] = ACTIONS(1560),
    [sym__block_quote_start] = ACTIONS(1560),
    [sym__indented_chunk_start] = ACTIONS(1560),
    [sym_atx_h1_marker] = ACTIONS(1560),
    [sym_atx_h2_marker] = ACTIONS(1560),
    [sym_atx_h3_marker] = ACTIONS(1560),
    [sym_atx_h4_marker] = ACTIONS(1560),
    [sym_atx_h5_marker] = ACTIONS(1560),
    [sym_atx_h6_marker] = ACTIONS(1560),
    [sym__thematic_break] = ACTIONS(1560),
    [sym__list_marker_minus] = ACTIONS(1560),
    [sym__list_marker_plus] = ACTIONS(1560),
    [sym__list_marker_star] = ACTIONS(1560),
    [sym__list_marker_parenthesis] = ACTIONS(1560),
    [sym__list_marker_dot] = ACTIONS(1560),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1560),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1560),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1560),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1560),
    [sym__blank_line_start] = ACTIONS(1560),
    [sym__html_block_1_start] = ACTIONS(1560),
    [sym__html_block_2_start] = ACTIONS(1560),
    [sym__html_block_3_start] = ACTIONS(1560),
    [sym__html_block_4_start] = ACTIONS(1560),
    [sym__html_block_5_start] = ACTIONS(1560),
    [sym__html_block_6_start] = ACTIONS(1560),
    [sym__html_block_7_start] = ACTIONS(1560),
    [sym__pipe_table_start] = ACTIONS(1560),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym__] = ACTIONS(1145),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [aux_sym__word_token1] = ACTIONS(1145),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1145),
    [aux_sym__word_token2] = ACTIONS(1145),
    [sym__whitespace] = ACTIONS(1145),
    [sym__soft_line_ending] = ACTIONS(1145),
    [sym__block_quote_start] = ACTIONS(1145),
    [sym__indented_chunk_start] = ACTIONS(1145),
    [sym_atx_h1_marker] = ACTIONS(1145),
    [sym_atx_h2_marker] = ACTIONS(1145),
    [sym_atx_h3_marker] = ACTIONS(1145),
    [sym_atx_h4_marker] = ACTIONS(1145),
    [sym_atx_h5_marker] = ACTIONS(1145),
    [sym_atx_h6_marker] = ACTIONS(1145),
    [sym__thematic_break] = ACTIONS(1145),
    [sym__list_marker_minus] = ACTIONS(1145),
    [sym__list_marker_plus] = ACTIONS(1145),
    [sym__list_marker_star] = ACTIONS(1145),
    [sym__list_marker_parenthesis] = ACTIONS(1145),
    [sym__list_marker_dot] = ACTIONS(1145),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1145),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1145),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1145),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1145),
    [sym__blank_line_start] = ACTIONS(1145),
    [sym__html_block_1_start] = ACTIONS(1145),
    [sym__html_block_2_start] = ACTIONS(1145),
    [sym__html_block_3_start] = ACTIONS(1145),
    [sym__html_block_4_start] = ACTIONS(1145),
    [sym__html_block_5_start] = ACTIONS(1145),
    [sym__html_block_6_start] = ACTIONS(1145),
    [sym__html_block_7_start] = ACTIONS(1145),
    [sym__pipe_table_start] = ACTIONS(1145),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1564),
    [anon_sym_DQUOTE] = ACTIONS(1564),
    [anon_sym_POUND] = ACTIONS(1564),
    [anon_sym_DOLLAR] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1564),
    [anon_sym_SQUOTE] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_EQ] = ACTIONS(1564),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1564),
    [anon_sym_BSLASH] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym__] = ACTIONS(1564),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [aux_sym__word_token1] = ACTIONS(1564),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1564),
    [aux_sym__word_token2] = ACTIONS(1564),
    [sym__whitespace] = ACTIONS(1564),
    [sym__soft_line_ending] = ACTIONS(1564),
    [sym__block_quote_start] = ACTIONS(1564),
    [sym__indented_chunk_start] = ACTIONS(1564),
    [sym_atx_h1_marker] = ACTIONS(1564),
    [sym_atx_h2_marker] = ACTIONS(1564),
    [sym_atx_h3_marker] = ACTIONS(1564),
    [sym_atx_h4_marker] = ACTIONS(1564),
    [sym_atx_h5_marker] = ACTIONS(1564),
    [sym_atx_h6_marker] = ACTIONS(1564),
    [sym__thematic_break] = ACTIONS(1564),
    [sym__list_marker_minus] = ACTIONS(1564),
    [sym__list_marker_plus] = ACTIONS(1564),
    [sym__list_marker_star] = ACTIONS(1564),
    [sym__list_marker_parenthesis] = ACTIONS(1564),
    [sym__list_marker_dot] = ACTIONS(1564),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1564),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1564),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1564),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1564),
    [sym__blank_line_start] = ACTIONS(1564),
    [sym__html_block_1_start] = ACTIONS(1564),
    [sym__html_block_2_start] = ACTIONS(1564),
    [sym__html_block_3_start] = ACTIONS(1564),
    [sym__html_block_4_start] = ACTIONS(1564),
    [sym__html_block_5_start] = ACTIONS(1564),
    [sym__html_block_6_start] = ACTIONS(1564),
    [sym__html_block_7_start] = ACTIONS(1564),
    [sym__pipe_table_start] = ACTIONS(1564),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_POUND] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_QMARK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym__] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [aux_sym__word_token1] = ACTIONS(1334),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1334),
    [aux_sym__word_token2] = ACTIONS(1334),
    [sym__whitespace] = ACTIONS(1334),
    [sym__soft_line_ending] = ACTIONS(1334),
    [sym__block_quote_start] = ACTIONS(1334),
    [sym__indented_chunk_start] = ACTIONS(1334),
    [sym_atx_h1_marker] = ACTIONS(1334),
    [sym_atx_h2_marker] = ACTIONS(1334),
    [sym_atx_h3_marker] = ACTIONS(1334),
    [sym_atx_h4_marker] = ACTIONS(1334),
    [sym_atx_h5_marker] = ACTIONS(1334),
    [sym_atx_h6_marker] = ACTIONS(1334),
    [sym__thematic_break] = ACTIONS(1334),
    [sym__list_marker_minus] = ACTIONS(1334),
    [sym__list_marker_plus] = ACTIONS(1334),
    [sym__list_marker_star] = ACTIONS(1334),
    [sym__list_marker_parenthesis] = ACTIONS(1334),
    [sym__list_marker_dot] = ACTIONS(1334),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1334),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1334),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1334),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1334),
    [sym__blank_line_start] = ACTIONS(1334),
    [sym__html_block_1_start] = ACTIONS(1334),
    [sym__html_block_2_start] = ACTIONS(1334),
    [sym__html_block_3_start] = ACTIONS(1334),
    [sym__html_block_4_start] = ACTIONS(1334),
    [sym__html_block_5_start] = ACTIONS(1334),
    [sym__html_block_6_start] = ACTIONS(1334),
    [sym__html_block_7_start] = ACTIONS(1334),
    [sym__pipe_table_start] = ACTIONS(1334),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(1750),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1752),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [anon_sym_POUND] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1752),
    [anon_sym_PERCENT] = ACTIONS(1752),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_PLUS] = ACTIONS(1752),
    [anon_sym_COMMA] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1752),
    [anon_sym_DOT] = ACTIONS(1752),
    [anon_sym_SLASH] = ACTIONS(1752),
    [anon_sym_COLON] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_EQ] = ACTIONS(1752),
    [anon_sym_QMARK] = ACTIONS(1752),
    [anon_sym_AT] = ACTIONS(1752),
    [anon_sym_BSLASH] = ACTIONS(1752),
    [anon_sym_CARET] = ACTIONS(1752),
    [anon_sym__] = ACTIONS(1752),
    [anon_sym_BQUOTE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1752),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_LPAREN] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [aux_sym__word_token1] = ACTIONS(1752),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1752),
    [aux_sym__word_token2] = ACTIONS(1752),
    [sym__whitespace] = ACTIONS(1752),
    [sym__soft_line_ending] = ACTIONS(1752),
    [sym__block_quote_start] = ACTIONS(1752),
    [sym__indented_chunk_start] = ACTIONS(1752),
    [sym_atx_h1_marker] = ACTIONS(1752),
    [sym_atx_h2_marker] = ACTIONS(1752),
    [sym_atx_h3_marker] = ACTIONS(1752),
    [sym_atx_h4_marker] = ACTIONS(1752),
    [sym_atx_h5_marker] = ACTIONS(1752),
    [sym_atx_h6_marker] = ACTIONS(1752),
    [sym__thematic_break] = ACTIONS(1752),
    [sym__list_marker_minus] = ACTIONS(1752),
    [sym__list_marker_plus] = ACTIONS(1752),
    [sym__list_marker_star] = ACTIONS(1752),
    [sym__list_marker_parenthesis] = ACTIONS(1752),
    [sym__list_marker_dot] = ACTIONS(1752),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1752),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1752),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1752),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1752),
    [sym__blank_line_start] = ACTIONS(1752),
    [sym__html_block_1_start] = ACTIONS(1752),
    [sym__html_block_2_start] = ACTIONS(1752),
    [sym__html_block_3_start] = ACTIONS(1752),
    [sym__html_block_4_start] = ACTIONS(1752),
    [sym__html_block_5_start] = ACTIONS(1752),
    [sym__html_block_6_start] = ACTIONS(1752),
    [sym__html_block_7_start] = ACTIONS(1752),
    [sym__pipe_table_start] = ACTIONS(1752),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_RBRACK] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1588),
    [anon_sym_POUND] = ACTIONS(1588),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_PERCENT] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SQUOTE] = ACTIONS(1588),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_COMMA] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_DOT] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_COLON] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1588),
    [anon_sym_QMARK] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1588),
    [anon_sym_BSLASH] = ACTIONS(1588),
    [anon_sym_CARET] = ACTIONS(1588),
    [anon_sym__] = ACTIONS(1588),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1588),
    [aux_sym__word_token1] = ACTIONS(1588),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1588),
    [aux_sym__word_token2] = ACTIONS(1588),
    [sym__whitespace] = ACTIONS(1588),
    [sym__soft_line_ending] = ACTIONS(1588),
    [sym__block_quote_start] = ACTIONS(1588),
    [sym__indented_chunk_start] = ACTIONS(1588),
    [sym_atx_h1_marker] = ACTIONS(1588),
    [sym_atx_h2_marker] = ACTIONS(1588),
    [sym_atx_h3_marker] = ACTIONS(1588),
    [sym_atx_h4_marker] = ACTIONS(1588),
    [sym_atx_h5_marker] = ACTIONS(1588),
    [sym_atx_h6_marker] = ACTIONS(1588),
    [sym__thematic_break] = ACTIONS(1588),
    [sym__list_marker_minus] = ACTIONS(1588),
    [sym__list_marker_plus] = ACTIONS(1588),
    [sym__list_marker_star] = ACTIONS(1588),
    [sym__list_marker_parenthesis] = ACTIONS(1588),
    [sym__list_marker_dot] = ACTIONS(1588),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1588),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1588),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1588),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1588),
    [sym__blank_line_start] = ACTIONS(1588),
    [sym__html_block_1_start] = ACTIONS(1588),
    [sym__html_block_2_start] = ACTIONS(1588),
    [sym__html_block_3_start] = ACTIONS(1588),
    [sym__html_block_4_start] = ACTIONS(1588),
    [sym__html_block_5_start] = ACTIONS(1588),
    [sym__html_block_6_start] = ACTIONS(1588),
    [sym__html_block_7_start] = ACTIONS(1588),
    [sym__pipe_table_start] = ACTIONS(1588),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_POUND] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_QMARK] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(1322),
    [aux_sym__word_token1] = ACTIONS(1322),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1322),
    [aux_sym__word_token2] = ACTIONS(1322),
    [sym__whitespace] = ACTIONS(1322),
    [sym__soft_line_ending] = ACTIONS(1322),
    [sym__block_quote_start] = ACTIONS(1322),
    [sym__indented_chunk_start] = ACTIONS(1322),
    [sym_atx_h1_marker] = ACTIONS(1322),
    [sym_atx_h2_marker] = ACTIONS(1322),
    [sym_atx_h3_marker] = ACTIONS(1322),
    [sym_atx_h4_marker] = ACTIONS(1322),
    [sym_atx_h5_marker] = ACTIONS(1322),
    [sym_atx_h6_marker] = ACTIONS(1322),
    [sym__thematic_break] = ACTIONS(1322),
    [sym__list_marker_minus] = ACTIONS(1322),
    [sym__list_marker_plus] = ACTIONS(1322),
    [sym__list_marker_star] = ACTIONS(1322),
    [sym__list_marker_parenthesis] = ACTIONS(1322),
    [sym__list_marker_dot] = ACTIONS(1322),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1322),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1322),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1322),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1322),
    [sym__blank_line_start] = ACTIONS(1322),
    [sym__html_block_1_start] = ACTIONS(1322),
    [sym__html_block_2_start] = ACTIONS(1322),
    [sym__html_block_3_start] = ACTIONS(1322),
    [sym__html_block_4_start] = ACTIONS(1322),
    [sym__html_block_5_start] = ACTIONS(1322),
    [sym__html_block_6_start] = ACTIONS(1322),
    [sym__html_block_7_start] = ACTIONS(1322),
    [sym__pipe_table_start] = ACTIONS(1322),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(1756),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_RBRACK] = ACTIONS(1756),
    [anon_sym_LT] = ACTIONS(1756),
    [anon_sym_GT] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1756),
    [anon_sym_DQUOTE] = ACTIONS(1756),
    [anon_sym_POUND] = ACTIONS(1756),
    [anon_sym_DOLLAR] = ACTIONS(1756),
    [anon_sym_PERCENT] = ACTIONS(1756),
    [anon_sym_AMP] = ACTIONS(1756),
    [anon_sym_SQUOTE] = ACTIONS(1756),
    [anon_sym_STAR] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_COMMA] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_DOT] = ACTIONS(1756),
    [anon_sym_SLASH] = ACTIONS(1756),
    [anon_sym_COLON] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1756),
    [anon_sym_EQ] = ACTIONS(1756),
    [anon_sym_QMARK] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(1756),
    [anon_sym_BSLASH] = ACTIONS(1756),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym__] = ACTIONS(1756),
    [anon_sym_BQUOTE] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1756),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_TILDE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [aux_sym__word_token1] = ACTIONS(1756),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1756),
    [aux_sym__word_token2] = ACTIONS(1756),
    [sym__whitespace] = ACTIONS(1756),
    [sym__soft_line_ending] = ACTIONS(1756),
    [sym__block_quote_start] = ACTIONS(1756),
    [sym__indented_chunk_start] = ACTIONS(1756),
    [sym_atx_h1_marker] = ACTIONS(1756),
    [sym_atx_h2_marker] = ACTIONS(1756),
    [sym_atx_h3_marker] = ACTIONS(1756),
    [sym_atx_h4_marker] = ACTIONS(1756),
    [sym_atx_h5_marker] = ACTIONS(1756),
    [sym_atx_h6_marker] = ACTIONS(1756),
    [sym__thematic_break] = ACTIONS(1756),
    [sym__list_marker_minus] = ACTIONS(1756),
    [sym__list_marker_plus] = ACTIONS(1756),
    [sym__list_marker_star] = ACTIONS(1756),
    [sym__list_marker_parenthesis] = ACTIONS(1756),
    [sym__list_marker_dot] = ACTIONS(1756),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1756),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1756),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1756),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1756),
    [sym__blank_line_start] = ACTIONS(1756),
    [sym__html_block_1_start] = ACTIONS(1756),
    [sym__html_block_2_start] = ACTIONS(1756),
    [sym__html_block_3_start] = ACTIONS(1756),
    [sym__html_block_4_start] = ACTIONS(1756),
    [sym__html_block_5_start] = ACTIONS(1756),
    [sym__html_block_6_start] = ACTIONS(1756),
    [sym__html_block_7_start] = ACTIONS(1756),
    [sym__pipe_table_start] = ACTIONS(1756),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_POUND] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1288),
    [anon_sym_SLASH] = ACTIONS(1288),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_QMARK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1288),
    [anon_sym__] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [aux_sym__word_token1] = ACTIONS(1288),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1288),
    [aux_sym__word_token2] = ACTIONS(1288),
    [sym__whitespace] = ACTIONS(1288),
    [sym__soft_line_ending] = ACTIONS(1288),
    [sym__block_quote_start] = ACTIONS(1288),
    [sym__indented_chunk_start] = ACTIONS(1288),
    [sym_atx_h1_marker] = ACTIONS(1288),
    [sym_atx_h2_marker] = ACTIONS(1288),
    [sym_atx_h3_marker] = ACTIONS(1288),
    [sym_atx_h4_marker] = ACTIONS(1288),
    [sym_atx_h5_marker] = ACTIONS(1288),
    [sym_atx_h6_marker] = ACTIONS(1288),
    [sym__thematic_break] = ACTIONS(1288),
    [sym__list_marker_minus] = ACTIONS(1288),
    [sym__list_marker_plus] = ACTIONS(1288),
    [sym__list_marker_star] = ACTIONS(1288),
    [sym__list_marker_parenthesis] = ACTIONS(1288),
    [sym__list_marker_dot] = ACTIONS(1288),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1288),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1288),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1288),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1288),
    [sym__blank_line_start] = ACTIONS(1288),
    [sym__html_block_1_start] = ACTIONS(1288),
    [sym__html_block_2_start] = ACTIONS(1288),
    [sym__html_block_3_start] = ACTIONS(1288),
    [sym__html_block_4_start] = ACTIONS(1288),
    [sym__html_block_5_start] = ACTIONS(1288),
    [sym__html_block_6_start] = ACTIONS(1288),
    [sym__html_block_7_start] = ACTIONS(1288),
    [sym__pipe_table_start] = ACTIONS(1288),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_RBRACK] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1592),
    [anon_sym_GT] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1592),
    [anon_sym_DQUOTE] = ACTIONS(1592),
    [anon_sym_POUND] = ACTIONS(1592),
    [anon_sym_DOLLAR] = ACTIONS(1592),
    [anon_sym_PERCENT] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1592),
    [anon_sym_SQUOTE] = ACTIONS(1592),
    [anon_sym_STAR] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_COMMA] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_DOT] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1592),
    [anon_sym_QMARK] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1592),
    [anon_sym_BSLASH] = ACTIONS(1592),
    [anon_sym_CARET] = ACTIONS(1592),
    [anon_sym__] = ACTIONS(1592),
    [anon_sym_BQUOTE] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1592),
    [anon_sym_PIPE] = ACTIONS(1592),
    [anon_sym_RBRACE] = ACTIONS(1592),
    [anon_sym_TILDE] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1592),
    [anon_sym_RPAREN] = ACTIONS(1592),
    [aux_sym__word_token1] = ACTIONS(1592),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1592),
    [aux_sym__word_token2] = ACTIONS(1592),
    [sym__whitespace] = ACTIONS(1592),
    [sym__soft_line_ending] = ACTIONS(1592),
    [sym__block_quote_start] = ACTIONS(1592),
    [sym__indented_chunk_start] = ACTIONS(1592),
    [sym_atx_h1_marker] = ACTIONS(1592),
    [sym_atx_h2_marker] = ACTIONS(1592),
    [sym_atx_h3_marker] = ACTIONS(1592),
    [sym_atx_h4_marker] = ACTIONS(1592),
    [sym_atx_h5_marker] = ACTIONS(1592),
    [sym_atx_h6_marker] = ACTIONS(1592),
    [sym__thematic_break] = ACTIONS(1592),
    [sym__list_marker_minus] = ACTIONS(1592),
    [sym__list_marker_plus] = ACTIONS(1592),
    [sym__list_marker_star] = ACTIONS(1592),
    [sym__list_marker_parenthesis] = ACTIONS(1592),
    [sym__list_marker_dot] = ACTIONS(1592),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1592),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1592),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1592),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1592),
    [sym__blank_line_start] = ACTIONS(1592),
    [sym__html_block_1_start] = ACTIONS(1592),
    [sym__html_block_2_start] = ACTIONS(1592),
    [sym__html_block_3_start] = ACTIONS(1592),
    [sym__html_block_4_start] = ACTIONS(1592),
    [sym__html_block_5_start] = ACTIONS(1592),
    [sym__html_block_6_start] = ACTIONS(1592),
    [sym__html_block_7_start] = ACTIONS(1592),
    [sym__pipe_table_start] = ACTIONS(1592),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1316),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1316),
    [anon_sym__] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [aux_sym__word_token1] = ACTIONS(1316),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1316),
    [aux_sym__word_token2] = ACTIONS(1316),
    [sym__whitespace] = ACTIONS(1316),
    [sym__soft_line_ending] = ACTIONS(1316),
    [sym__block_quote_start] = ACTIONS(1316),
    [sym__indented_chunk_start] = ACTIONS(1316),
    [sym_atx_h1_marker] = ACTIONS(1316),
    [sym_atx_h2_marker] = ACTIONS(1316),
    [sym_atx_h3_marker] = ACTIONS(1316),
    [sym_atx_h4_marker] = ACTIONS(1316),
    [sym_atx_h5_marker] = ACTIONS(1316),
    [sym_atx_h6_marker] = ACTIONS(1316),
    [sym__thematic_break] = ACTIONS(1316),
    [sym__list_marker_minus] = ACTIONS(1316),
    [sym__list_marker_plus] = ACTIONS(1316),
    [sym__list_marker_star] = ACTIONS(1316),
    [sym__list_marker_parenthesis] = ACTIONS(1316),
    [sym__list_marker_dot] = ACTIONS(1316),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1316),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1316),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1316),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1316),
    [sym__blank_line_start] = ACTIONS(1316),
    [sym__html_block_1_start] = ACTIONS(1316),
    [sym__html_block_2_start] = ACTIONS(1316),
    [sym__html_block_3_start] = ACTIONS(1316),
    [sym__html_block_4_start] = ACTIONS(1316),
    [sym__html_block_5_start] = ACTIONS(1316),
    [sym__html_block_6_start] = ACTIONS(1316),
    [sym__html_block_7_start] = ACTIONS(1316),
    [sym__pipe_table_start] = ACTIONS(1316),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1187),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_POUND] = ACTIONS(1189),
    [anon_sym_DOLLAR] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_BSLASH] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym__] = ACTIONS(1189),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [aux_sym__word_token1] = ACTIONS(1189),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1189),
    [aux_sym__word_token2] = ACTIONS(1189),
    [sym__whitespace] = ACTIONS(1189),
    [sym__soft_line_ending] = ACTIONS(1189),
    [sym__block_quote_start] = ACTIONS(1189),
    [sym__indented_chunk_start] = ACTIONS(1189),
    [sym_atx_h1_marker] = ACTIONS(1189),
    [sym_atx_h2_marker] = ACTIONS(1189),
    [sym_atx_h3_marker] = ACTIONS(1189),
    [sym_atx_h4_marker] = ACTIONS(1189),
    [sym_atx_h5_marker] = ACTIONS(1189),
    [sym_atx_h6_marker] = ACTIONS(1189),
    [sym__thematic_break] = ACTIONS(1189),
    [sym__list_marker_minus] = ACTIONS(1189),
    [sym__list_marker_plus] = ACTIONS(1189),
    [sym__list_marker_star] = ACTIONS(1189),
    [sym__list_marker_parenthesis] = ACTIONS(1189),
    [sym__list_marker_dot] = ACTIONS(1189),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1189),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1189),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1189),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1189),
    [sym__blank_line_start] = ACTIONS(1189),
    [sym__html_block_1_start] = ACTIONS(1189),
    [sym__html_block_2_start] = ACTIONS(1189),
    [sym__html_block_3_start] = ACTIONS(1189),
    [sym__html_block_4_start] = ACTIONS(1189),
    [sym__html_block_5_start] = ACTIONS(1189),
    [sym__html_block_6_start] = ACTIONS(1189),
    [sym__html_block_7_start] = ACTIONS(1189),
    [sym__pipe_table_start] = ACTIONS(1189),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym__] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(1310),
    [aux_sym__word_token1] = ACTIONS(1310),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1310),
    [aux_sym__word_token2] = ACTIONS(1310),
    [sym__whitespace] = ACTIONS(1310),
    [sym__soft_line_ending] = ACTIONS(1310),
    [sym__block_quote_start] = ACTIONS(1310),
    [sym__indented_chunk_start] = ACTIONS(1310),
    [sym_atx_h1_marker] = ACTIONS(1310),
    [sym_atx_h2_marker] = ACTIONS(1310),
    [sym_atx_h3_marker] = ACTIONS(1310),
    [sym_atx_h4_marker] = ACTIONS(1310),
    [sym_atx_h5_marker] = ACTIONS(1310),
    [sym_atx_h6_marker] = ACTIONS(1310),
    [sym__thematic_break] = ACTIONS(1310),
    [sym__list_marker_minus] = ACTIONS(1310),
    [sym__list_marker_plus] = ACTIONS(1310),
    [sym__list_marker_star] = ACTIONS(1310),
    [sym__list_marker_parenthesis] = ACTIONS(1310),
    [sym__list_marker_dot] = ACTIONS(1310),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1310),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1310),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1310),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1310),
    [sym__blank_line_start] = ACTIONS(1310),
    [sym__html_block_1_start] = ACTIONS(1310),
    [sym__html_block_2_start] = ACTIONS(1310),
    [sym__html_block_3_start] = ACTIONS(1310),
    [sym__html_block_4_start] = ACTIONS(1310),
    [sym__html_block_5_start] = ACTIONS(1310),
    [sym__html_block_6_start] = ACTIONS(1310),
    [sym__html_block_7_start] = ACTIONS(1310),
    [sym__pipe_table_start] = ACTIONS(1310),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1644),
    [anon_sym_DQUOTE] = ACTIONS(1644),
    [anon_sym_POUND] = ACTIONS(1644),
    [anon_sym_DOLLAR] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
    [anon_sym_SQUOTE] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_DOT] = ACTIONS(1644),
    [anon_sym_SLASH] = ACTIONS(1644),
    [anon_sym_COLON] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1644),
    [anon_sym_QMARK] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_BSLASH] = ACTIONS(1644),
    [anon_sym_CARET] = ACTIONS(1644),
    [anon_sym__] = ACTIONS(1644),
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_PIPE] = ACTIONS(1644),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_TILDE] = ACTIONS(1644),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [aux_sym__word_token1] = ACTIONS(1644),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1644),
    [aux_sym__word_token2] = ACTIONS(1644),
    [sym__whitespace] = ACTIONS(1644),
    [sym__soft_line_ending] = ACTIONS(1644),
    [sym__block_quote_start] = ACTIONS(1644),
    [sym__indented_chunk_start] = ACTIONS(1644),
    [sym_atx_h1_marker] = ACTIONS(1644),
    [sym_atx_h2_marker] = ACTIONS(1644),
    [sym_atx_h3_marker] = ACTIONS(1644),
    [sym_atx_h4_marker] = ACTIONS(1644),
    [sym_atx_h5_marker] = ACTIONS(1644),
    [sym_atx_h6_marker] = ACTIONS(1644),
    [sym__thematic_break] = ACTIONS(1644),
    [sym__list_marker_minus] = ACTIONS(1644),
    [sym__list_marker_plus] = ACTIONS(1644),
    [sym__list_marker_star] = ACTIONS(1644),
    [sym__list_marker_parenthesis] = ACTIONS(1644),
    [sym__list_marker_dot] = ACTIONS(1644),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1644),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1644),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1644),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1644),
    [sym__blank_line_start] = ACTIONS(1644),
    [sym__html_block_1_start] = ACTIONS(1644),
    [sym__html_block_2_start] = ACTIONS(1644),
    [sym__html_block_3_start] = ACTIONS(1644),
    [sym__html_block_4_start] = ACTIONS(1644),
    [sym__html_block_5_start] = ACTIONS(1644),
    [sym__html_block_6_start] = ACTIONS(1644),
    [sym__html_block_7_start] = ACTIONS(1644),
    [sym__pipe_table_start] = ACTIONS(1644),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_RBRACK] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1640),
    [anon_sym_DQUOTE] = ACTIONS(1640),
    [anon_sym_POUND] = ACTIONS(1640),
    [anon_sym_DOLLAR] = ACTIONS(1640),
    [anon_sym_PERCENT] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1640),
    [anon_sym_SQUOTE] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(1640),
    [anon_sym_QMARK] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1640),
    [anon_sym_BSLASH] = ACTIONS(1640),
    [anon_sym_CARET] = ACTIONS(1640),
    [anon_sym__] = ACTIONS(1640),
    [anon_sym_BQUOTE] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1640),
    [anon_sym_PIPE] = ACTIONS(1640),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1640),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [aux_sym__word_token1] = ACTIONS(1640),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1640),
    [aux_sym__word_token2] = ACTIONS(1640),
    [sym__whitespace] = ACTIONS(1640),
    [sym__soft_line_ending] = ACTIONS(1640),
    [sym__block_quote_start] = ACTIONS(1640),
    [sym__indented_chunk_start] = ACTIONS(1640),
    [sym_atx_h1_marker] = ACTIONS(1640),
    [sym_atx_h2_marker] = ACTIONS(1640),
    [sym_atx_h3_marker] = ACTIONS(1640),
    [sym_atx_h4_marker] = ACTIONS(1640),
    [sym_atx_h5_marker] = ACTIONS(1640),
    [sym_atx_h6_marker] = ACTIONS(1640),
    [sym__thematic_break] = ACTIONS(1640),
    [sym__list_marker_minus] = ACTIONS(1640),
    [sym__list_marker_plus] = ACTIONS(1640),
    [sym__list_marker_star] = ACTIONS(1640),
    [sym__list_marker_parenthesis] = ACTIONS(1640),
    [sym__list_marker_dot] = ACTIONS(1640),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1640),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1640),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1640),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1640),
    [sym__blank_line_start] = ACTIONS(1640),
    [sym__html_block_1_start] = ACTIONS(1640),
    [sym__html_block_2_start] = ACTIONS(1640),
    [sym__html_block_3_start] = ACTIONS(1640),
    [sym__html_block_4_start] = ACTIONS(1640),
    [sym__html_block_5_start] = ACTIONS(1640),
    [sym__html_block_6_start] = ACTIONS(1640),
    [sym__html_block_7_start] = ACTIONS(1640),
    [sym__pipe_table_start] = ACTIONS(1640),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_GT] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_POUND] = ACTIONS(1722),
    [anon_sym_DOLLAR] = ACTIONS(1722),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [anon_sym_STAR] = ACTIONS(1722),
    [anon_sym_PLUS] = ACTIONS(1722),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_DASH] = ACTIONS(1722),
    [anon_sym_DOT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1722),
    [anon_sym_COLON] = ACTIONS(1722),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_EQ] = ACTIONS(1722),
    [anon_sym_QMARK] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_BSLASH] = ACTIONS(1722),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym__] = ACTIONS(1722),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [aux_sym__word_token1] = ACTIONS(1722),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1722),
    [aux_sym__word_token2] = ACTIONS(1722),
    [sym__whitespace] = ACTIONS(1722),
    [sym__soft_line_ending] = ACTIONS(1722),
    [sym__block_quote_start] = ACTIONS(1722),
    [sym__indented_chunk_start] = ACTIONS(1722),
    [sym_atx_h1_marker] = ACTIONS(1722),
    [sym_atx_h2_marker] = ACTIONS(1722),
    [sym_atx_h3_marker] = ACTIONS(1722),
    [sym_atx_h4_marker] = ACTIONS(1722),
    [sym_atx_h5_marker] = ACTIONS(1722),
    [sym_atx_h6_marker] = ACTIONS(1722),
    [sym__thematic_break] = ACTIONS(1722),
    [sym__list_marker_minus] = ACTIONS(1722),
    [sym__list_marker_plus] = ACTIONS(1722),
    [sym__list_marker_star] = ACTIONS(1722),
    [sym__list_marker_parenthesis] = ACTIONS(1722),
    [sym__list_marker_dot] = ACTIONS(1722),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1722),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1722),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1722),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1722),
    [sym__blank_line_start] = ACTIONS(1722),
    [sym__html_block_1_start] = ACTIONS(1722),
    [sym__html_block_2_start] = ACTIONS(1722),
    [sym__html_block_3_start] = ACTIONS(1722),
    [sym__html_block_4_start] = ACTIONS(1722),
    [sym__html_block_5_start] = ACTIONS(1722),
    [sym__html_block_6_start] = ACTIONS(1722),
    [sym__html_block_7_start] = ACTIONS(1722),
    [sym__pipe_table_start] = ACTIONS(1722),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_POUND] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [aux_sym__word_token1] = ACTIONS(1350),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1350),
    [aux_sym__word_token2] = ACTIONS(1350),
    [sym__whitespace] = ACTIONS(1350),
    [sym__soft_line_ending] = ACTIONS(1350),
    [sym__block_quote_start] = ACTIONS(1350),
    [sym__indented_chunk_start] = ACTIONS(1350),
    [sym_atx_h1_marker] = ACTIONS(1350),
    [sym_atx_h2_marker] = ACTIONS(1350),
    [sym_atx_h3_marker] = ACTIONS(1350),
    [sym_atx_h4_marker] = ACTIONS(1350),
    [sym_atx_h5_marker] = ACTIONS(1350),
    [sym_atx_h6_marker] = ACTIONS(1350),
    [sym__thematic_break] = ACTIONS(1350),
    [sym__list_marker_minus] = ACTIONS(1350),
    [sym__list_marker_plus] = ACTIONS(1350),
    [sym__list_marker_star] = ACTIONS(1350),
    [sym__list_marker_parenthesis] = ACTIONS(1350),
    [sym__list_marker_dot] = ACTIONS(1350),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1350),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1350),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1350),
    [sym__blank_line_start] = ACTIONS(1350),
    [sym__html_block_1_start] = ACTIONS(1350),
    [sym__html_block_2_start] = ACTIONS(1350),
    [sym__html_block_3_start] = ACTIONS(1350),
    [sym__html_block_4_start] = ACTIONS(1350),
    [sym__html_block_5_start] = ACTIONS(1350),
    [sym__html_block_6_start] = ACTIONS(1350),
    [sym__html_block_7_start] = ACTIONS(1350),
    [sym__pipe_table_start] = ACTIONS(1350),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_RBRACK] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_BANG] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1596),
    [anon_sym_POUND] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(1596),
    [anon_sym_PERCENT] = ACTIONS(1596),
    [anon_sym_AMP] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1596),
    [anon_sym_STAR] = ACTIONS(1596),
    [anon_sym_PLUS] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_DOT] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1596),
    [anon_sym_COLON] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_QMARK] = ACTIONS(1596),
    [anon_sym_AT] = ACTIONS(1596),
    [anon_sym_BSLASH] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1596),
    [anon_sym__] = ACTIONS(1596),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_RBRACE] = ACTIONS(1596),
    [anon_sym_TILDE] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1596),
    [aux_sym__word_token1] = ACTIONS(1596),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1596),
    [aux_sym__word_token2] = ACTIONS(1596),
    [sym__whitespace] = ACTIONS(1596),
    [sym__soft_line_ending] = ACTIONS(1596),
    [sym__block_quote_start] = ACTIONS(1596),
    [sym__indented_chunk_start] = ACTIONS(1596),
    [sym_atx_h1_marker] = ACTIONS(1596),
    [sym_atx_h2_marker] = ACTIONS(1596),
    [sym_atx_h3_marker] = ACTIONS(1596),
    [sym_atx_h4_marker] = ACTIONS(1596),
    [sym_atx_h5_marker] = ACTIONS(1596),
    [sym_atx_h6_marker] = ACTIONS(1596),
    [sym__thematic_break] = ACTIONS(1596),
    [sym__list_marker_minus] = ACTIONS(1596),
    [sym__list_marker_plus] = ACTIONS(1596),
    [sym__list_marker_star] = ACTIONS(1596),
    [sym__list_marker_parenthesis] = ACTIONS(1596),
    [sym__list_marker_dot] = ACTIONS(1596),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1596),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1596),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1596),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1596),
    [sym__blank_line_start] = ACTIONS(1596),
    [sym__html_block_1_start] = ACTIONS(1596),
    [sym__html_block_2_start] = ACTIONS(1596),
    [sym__html_block_3_start] = ACTIONS(1596),
    [sym__html_block_4_start] = ACTIONS(1596),
    [sym__html_block_5_start] = ACTIONS(1596),
    [sym__html_block_6_start] = ACTIONS(1596),
    [sym__html_block_7_start] = ACTIONS(1596),
    [sym__pipe_table_start] = ACTIONS(1596),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_DQUOTE] = ACTIONS(1604),
    [anon_sym_POUND] = ACTIONS(1604),
    [anon_sym_DOLLAR] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1604),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_SQUOTE] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1604),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_COMMA] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_DOT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1604),
    [anon_sym_EQ] = ACTIONS(1604),
    [anon_sym_QMARK] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1604),
    [anon_sym_BSLASH] = ACTIONS(1604),
    [anon_sym_CARET] = ACTIONS(1604),
    [anon_sym__] = ACTIONS(1604),
    [anon_sym_BQUOTE] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1604),
    [anon_sym_PIPE] = ACTIONS(1604),
    [anon_sym_RBRACE] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1604),
    [anon_sym_RPAREN] = ACTIONS(1604),
    [aux_sym__word_token1] = ACTIONS(1604),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1604),
    [aux_sym__word_token2] = ACTIONS(1604),
    [sym__whitespace] = ACTIONS(1604),
    [sym__soft_line_ending] = ACTIONS(1604),
    [sym__block_quote_start] = ACTIONS(1604),
    [sym__indented_chunk_start] = ACTIONS(1604),
    [sym_atx_h1_marker] = ACTIONS(1604),
    [sym_atx_h2_marker] = ACTIONS(1604),
    [sym_atx_h3_marker] = ACTIONS(1604),
    [sym_atx_h4_marker] = ACTIONS(1604),
    [sym_atx_h5_marker] = ACTIONS(1604),
    [sym_atx_h6_marker] = ACTIONS(1604),
    [sym__thematic_break] = ACTIONS(1604),
    [sym__list_marker_minus] = ACTIONS(1604),
    [sym__list_marker_plus] = ACTIONS(1604),
    [sym__list_marker_star] = ACTIONS(1604),
    [sym__list_marker_parenthesis] = ACTIONS(1604),
    [sym__list_marker_dot] = ACTIONS(1604),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1604),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1604),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1604),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1604),
    [sym__blank_line_start] = ACTIONS(1604),
    [sym__html_block_1_start] = ACTIONS(1604),
    [sym__html_block_2_start] = ACTIONS(1604),
    [sym__html_block_3_start] = ACTIONS(1604),
    [sym__html_block_4_start] = ACTIONS(1604),
    [sym__html_block_5_start] = ACTIONS(1604),
    [sym__html_block_6_start] = ACTIONS(1604),
    [sym__html_block_7_start] = ACTIONS(1604),
    [sym__pipe_table_start] = ACTIONS(1604),
  },
  [339] = {
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_POUND] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym__] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1350),
    [aux_sym__word_token1] = ACTIONS(1350),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1350),
    [aux_sym__word_token2] = ACTIONS(1350),
    [sym__whitespace] = ACTIONS(1350),
    [sym__soft_line_ending] = ACTIONS(1350),
    [sym__block_close] = ACTIONS(1350),
    [sym__block_quote_start] = ACTIONS(1350),
    [sym__indented_chunk_start] = ACTIONS(1350),
    [sym_atx_h1_marker] = ACTIONS(1350),
    [sym_atx_h2_marker] = ACTIONS(1350),
    [sym_atx_h3_marker] = ACTIONS(1350),
    [sym_atx_h4_marker] = ACTIONS(1350),
    [sym_atx_h5_marker] = ACTIONS(1350),
    [sym_atx_h6_marker] = ACTIONS(1350),
    [sym__thematic_break] = ACTIONS(1350),
    [sym__list_marker_minus] = ACTIONS(1350),
    [sym__list_marker_plus] = ACTIONS(1350),
    [sym__list_marker_star] = ACTIONS(1350),
    [sym__list_marker_parenthesis] = ACTIONS(1350),
    [sym__list_marker_dot] = ACTIONS(1350),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1350),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1350),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1350),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1350),
    [sym__blank_line_start] = ACTIONS(1350),
    [sym__html_block_1_start] = ACTIONS(1350),
    [sym__html_block_2_start] = ACTIONS(1350),
    [sym__html_block_3_start] = ACTIONS(1350),
    [sym__html_block_4_start] = ACTIONS(1350),
    [sym__html_block_5_start] = ACTIONS(1350),
    [sym__html_block_6_start] = ACTIONS(1350),
    [sym__html_block_7_start] = ACTIONS(1350),
    [sym__pipe_table_start] = ACTIONS(1350),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACK] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_POUND] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym__] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [aux_sym__word_token1] = ACTIONS(1230),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1230),
    [aux_sym__word_token2] = ACTIONS(1230),
    [sym__whitespace] = ACTIONS(1230),
    [sym__soft_line_ending] = ACTIONS(1230),
    [sym__block_quote_start] = ACTIONS(1230),
    [sym__indented_chunk_start] = ACTIONS(1230),
    [sym_atx_h1_marker] = ACTIONS(1230),
    [sym_atx_h2_marker] = ACTIONS(1230),
    [sym_atx_h3_marker] = ACTIONS(1230),
    [sym_atx_h4_marker] = ACTIONS(1230),
    [sym_atx_h5_marker] = ACTIONS(1230),
    [sym_atx_h6_marker] = ACTIONS(1230),
    [sym__thematic_break] = ACTIONS(1230),
    [sym__list_marker_minus] = ACTIONS(1230),
    [sym__list_marker_plus] = ACTIONS(1230),
    [sym__list_marker_star] = ACTIONS(1230),
    [sym__list_marker_parenthesis] = ACTIONS(1230),
    [sym__list_marker_dot] = ACTIONS(1230),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1230),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1230),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1230),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1230),
    [sym__blank_line_start] = ACTIONS(1230),
    [sym__html_block_1_start] = ACTIONS(1230),
    [sym__html_block_2_start] = ACTIONS(1230),
    [sym__html_block_3_start] = ACTIONS(1230),
    [sym__html_block_4_start] = ACTIONS(1230),
    [sym__html_block_5_start] = ACTIONS(1230),
    [sym__html_block_6_start] = ACTIONS(1230),
    [sym__html_block_7_start] = ACTIONS(1230),
    [sym__pipe_table_start] = ACTIONS(1230),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(1608),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_POUND] = ACTIONS(1608),
    [anon_sym_DOLLAR] = ACTIONS(1608),
    [anon_sym_PERCENT] = ACTIONS(1608),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_SQUOTE] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_QMARK] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_BSLASH] = ACTIONS(1608),
    [anon_sym_CARET] = ACTIONS(1608),
    [anon_sym__] = ACTIONS(1608),
    [anon_sym_BQUOTE] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_TILDE] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_RPAREN] = ACTIONS(1608),
    [aux_sym__word_token1] = ACTIONS(1608),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1608),
    [aux_sym__word_token2] = ACTIONS(1608),
    [sym__whitespace] = ACTIONS(1608),
    [sym__soft_line_ending] = ACTIONS(1608),
    [sym__block_quote_start] = ACTIONS(1608),
    [sym__indented_chunk_start] = ACTIONS(1608),
    [sym_atx_h1_marker] = ACTIONS(1608),
    [sym_atx_h2_marker] = ACTIONS(1608),
    [sym_atx_h3_marker] = ACTIONS(1608),
    [sym_atx_h4_marker] = ACTIONS(1608),
    [sym_atx_h5_marker] = ACTIONS(1608),
    [sym_atx_h6_marker] = ACTIONS(1608),
    [sym__thematic_break] = ACTIONS(1608),
    [sym__list_marker_minus] = ACTIONS(1608),
    [sym__list_marker_plus] = ACTIONS(1608),
    [sym__list_marker_star] = ACTIONS(1608),
    [sym__list_marker_parenthesis] = ACTIONS(1608),
    [sym__list_marker_dot] = ACTIONS(1608),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1608),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1608),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1608),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1608),
    [sym__blank_line_start] = ACTIONS(1608),
    [sym__html_block_1_start] = ACTIONS(1608),
    [sym__html_block_2_start] = ACTIONS(1608),
    [sym__html_block_3_start] = ACTIONS(1608),
    [sym__html_block_4_start] = ACTIONS(1608),
    [sym__html_block_5_start] = ACTIONS(1608),
    [sym__html_block_6_start] = ACTIONS(1608),
    [sym__html_block_7_start] = ACTIONS(1608),
    [sym__pipe_table_start] = ACTIONS(1608),
  },
  [342] = {
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_POUND] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_COMMA] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym__] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [aux_sym__word_token1] = ACTIONS(1274),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1274),
    [aux_sym__word_token2] = ACTIONS(1274),
    [sym__whitespace] = ACTIONS(1274),
    [sym__soft_line_ending] = ACTIONS(1274),
    [sym__block_close] = ACTIONS(1274),
    [sym__block_quote_start] = ACTIONS(1274),
    [sym__indented_chunk_start] = ACTIONS(1274),
    [sym_atx_h1_marker] = ACTIONS(1274),
    [sym_atx_h2_marker] = ACTIONS(1274),
    [sym_atx_h3_marker] = ACTIONS(1274),
    [sym_atx_h4_marker] = ACTIONS(1274),
    [sym_atx_h5_marker] = ACTIONS(1274),
    [sym_atx_h6_marker] = ACTIONS(1274),
    [sym__thematic_break] = ACTIONS(1274),
    [sym__list_marker_minus] = ACTIONS(1274),
    [sym__list_marker_plus] = ACTIONS(1274),
    [sym__list_marker_star] = ACTIONS(1274),
    [sym__list_marker_parenthesis] = ACTIONS(1274),
    [sym__list_marker_dot] = ACTIONS(1274),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1274),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1274),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1274),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1274),
    [sym__blank_line_start] = ACTIONS(1274),
    [sym__html_block_1_start] = ACTIONS(1274),
    [sym__html_block_2_start] = ACTIONS(1274),
    [sym__html_block_3_start] = ACTIONS(1274),
    [sym__html_block_4_start] = ACTIONS(1274),
    [sym__html_block_5_start] = ACTIONS(1274),
    [sym__html_block_6_start] = ACTIONS(1274),
    [sym__html_block_7_start] = ACTIONS(1274),
    [sym__pipe_table_start] = ACTIONS(1274),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(1612),
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_RBRACK] = ACTIONS(1612),
    [anon_sym_LT] = ACTIONS(1612),
    [anon_sym_GT] = ACTIONS(1612),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(1612),
    [anon_sym_POUND] = ACTIONS(1612),
    [anon_sym_DOLLAR] = ACTIONS(1612),
    [anon_sym_PERCENT] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_SQUOTE] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1612),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_COMMA] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_DOT] = ACTIONS(1612),
    [anon_sym_SLASH] = ACTIONS(1612),
    [anon_sym_COLON] = ACTIONS(1612),
    [anon_sym_SEMI] = ACTIONS(1612),
    [anon_sym_EQ] = ACTIONS(1612),
    [anon_sym_QMARK] = ACTIONS(1612),
    [anon_sym_AT] = ACTIONS(1612),
    [anon_sym_BSLASH] = ACTIONS(1612),
    [anon_sym_CARET] = ACTIONS(1612),
    [anon_sym__] = ACTIONS(1612),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [anon_sym_LBRACE] = ACTIONS(1612),
    [anon_sym_PIPE] = ACTIONS(1612),
    [anon_sym_RBRACE] = ACTIONS(1612),
    [anon_sym_TILDE] = ACTIONS(1612),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_RPAREN] = ACTIONS(1612),
    [aux_sym__word_token1] = ACTIONS(1612),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1612),
    [aux_sym__word_token2] = ACTIONS(1612),
    [sym__whitespace] = ACTIONS(1612),
    [sym__soft_line_ending] = ACTIONS(1612),
    [sym__block_quote_start] = ACTIONS(1612),
    [sym__indented_chunk_start] = ACTIONS(1612),
    [sym_atx_h1_marker] = ACTIONS(1612),
    [sym_atx_h2_marker] = ACTIONS(1612),
    [sym_atx_h3_marker] = ACTIONS(1612),
    [sym_atx_h4_marker] = ACTIONS(1612),
    [sym_atx_h5_marker] = ACTIONS(1612),
    [sym_atx_h6_marker] = ACTIONS(1612),
    [sym__thematic_break] = ACTIONS(1612),
    [sym__list_marker_minus] = ACTIONS(1612),
    [sym__list_marker_plus] = ACTIONS(1612),
    [sym__list_marker_star] = ACTIONS(1612),
    [sym__list_marker_parenthesis] = ACTIONS(1612),
    [sym__list_marker_dot] = ACTIONS(1612),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1612),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1612),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1612),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1612),
    [sym__blank_line_start] = ACTIONS(1612),
    [sym__html_block_1_start] = ACTIONS(1612),
    [sym__html_block_2_start] = ACTIONS(1612),
    [sym__html_block_3_start] = ACTIONS(1612),
    [sym__html_block_4_start] = ACTIONS(1612),
    [sym__html_block_5_start] = ACTIONS(1612),
    [sym__html_block_6_start] = ACTIONS(1612),
    [sym__html_block_7_start] = ACTIONS(1612),
    [sym__pipe_table_start] = ACTIONS(1612),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1614),
    [anon_sym_RBRACK] = ACTIONS(1616),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_GT] = ACTIONS(1616),
    [anon_sym_BANG] = ACTIONS(1616),
    [anon_sym_DQUOTE] = ACTIONS(1616),
    [anon_sym_POUND] = ACTIONS(1616),
    [anon_sym_DOLLAR] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SQUOTE] = ACTIONS(1616),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_COMMA] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DOT] = ACTIONS(1616),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1616),
    [anon_sym_EQ] = ACTIONS(1616),
    [anon_sym_QMARK] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(1616),
    [anon_sym_BSLASH] = ACTIONS(1616),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym__] = ACTIONS(1616),
    [anon_sym_BQUOTE] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1616),
    [anon_sym_RBRACE] = ACTIONS(1616),
    [anon_sym_TILDE] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1616),
    [anon_sym_RPAREN] = ACTIONS(1616),
    [aux_sym__word_token1] = ACTIONS(1616),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1616),
    [aux_sym__word_token2] = ACTIONS(1616),
    [sym__whitespace] = ACTIONS(1616),
    [sym__soft_line_ending] = ACTIONS(1616),
    [sym__block_quote_start] = ACTIONS(1616),
    [sym__indented_chunk_start] = ACTIONS(1616),
    [sym_atx_h1_marker] = ACTIONS(1616),
    [sym_atx_h2_marker] = ACTIONS(1616),
    [sym_atx_h3_marker] = ACTIONS(1616),
    [sym_atx_h4_marker] = ACTIONS(1616),
    [sym_atx_h5_marker] = ACTIONS(1616),
    [sym_atx_h6_marker] = ACTIONS(1616),
    [sym__thematic_break] = ACTIONS(1616),
    [sym__list_marker_minus] = ACTIONS(1616),
    [sym__list_marker_plus] = ACTIONS(1616),
    [sym__list_marker_star] = ACTIONS(1616),
    [sym__list_marker_parenthesis] = ACTIONS(1616),
    [sym__list_marker_dot] = ACTIONS(1616),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1616),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1616),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1616),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1616),
    [sym__blank_line_start] = ACTIONS(1616),
    [sym__html_block_1_start] = ACTIONS(1616),
    [sym__html_block_2_start] = ACTIONS(1616),
    [sym__html_block_3_start] = ACTIONS(1616),
    [sym__html_block_4_start] = ACTIONS(1616),
    [sym__html_block_5_start] = ACTIONS(1616),
    [sym__html_block_6_start] = ACTIONS(1616),
    [sym__html_block_7_start] = ACTIONS(1616),
    [sym__pipe_table_start] = ACTIONS(1616),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(1620),
    [anon_sym_LBRACK] = ACTIONS(1618),
    [anon_sym_RBRACK] = ACTIONS(1620),
    [anon_sym_LT] = ACTIONS(1620),
    [anon_sym_GT] = ACTIONS(1620),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_POUND] = ACTIONS(1620),
    [anon_sym_DOLLAR] = ACTIONS(1620),
    [anon_sym_PERCENT] = ACTIONS(1620),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(1620),
    [anon_sym_PLUS] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_DASH] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1620),
    [anon_sym_SLASH] = ACTIONS(1620),
    [anon_sym_COLON] = ACTIONS(1620),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_EQ] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1620),
    [anon_sym_AT] = ACTIONS(1620),
    [anon_sym_BSLASH] = ACTIONS(1620),
    [anon_sym_CARET] = ACTIONS(1620),
    [anon_sym__] = ACTIONS(1620),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_PIPE] = ACTIONS(1620),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_TILDE] = ACTIONS(1620),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_RPAREN] = ACTIONS(1620),
    [aux_sym__word_token1] = ACTIONS(1620),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1620),
    [aux_sym__word_token2] = ACTIONS(1620),
    [sym__whitespace] = ACTIONS(1620),
    [sym__soft_line_ending] = ACTIONS(1620),
    [sym__block_quote_start] = ACTIONS(1620),
    [sym__indented_chunk_start] = ACTIONS(1620),
    [sym_atx_h1_marker] = ACTIONS(1620),
    [sym_atx_h2_marker] = ACTIONS(1620),
    [sym_atx_h3_marker] = ACTIONS(1620),
    [sym_atx_h4_marker] = ACTIONS(1620),
    [sym_atx_h5_marker] = ACTIONS(1620),
    [sym_atx_h6_marker] = ACTIONS(1620),
    [sym__thematic_break] = ACTIONS(1620),
    [sym__list_marker_minus] = ACTIONS(1620),
    [sym__list_marker_plus] = ACTIONS(1620),
    [sym__list_marker_star] = ACTIONS(1620),
    [sym__list_marker_parenthesis] = ACTIONS(1620),
    [sym__list_marker_dot] = ACTIONS(1620),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1620),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1620),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1620),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1620),
    [sym__blank_line_start] = ACTIONS(1620),
    [sym__html_block_1_start] = ACTIONS(1620),
    [sym__html_block_2_start] = ACTIONS(1620),
    [sym__html_block_3_start] = ACTIONS(1620),
    [sym__html_block_4_start] = ACTIONS(1620),
    [sym__html_block_5_start] = ACTIONS(1620),
    [sym__html_block_6_start] = ACTIONS(1620),
    [sym__html_block_7_start] = ACTIONS(1620),
    [sym__pipe_table_start] = ACTIONS(1620),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(1624),
    [anon_sym_POUND] = ACTIONS(1624),
    [anon_sym_DOLLAR] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(1624),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_SQUOTE] = ACTIONS(1624),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(1624),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_EQ] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1624),
    [anon_sym_AT] = ACTIONS(1624),
    [anon_sym_BSLASH] = ACTIONS(1624),
    [anon_sym_CARET] = ACTIONS(1624),
    [anon_sym__] = ACTIONS(1624),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1624),
    [anon_sym_PIPE] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_TILDE] = ACTIONS(1624),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [aux_sym__word_token1] = ACTIONS(1624),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1624),
    [aux_sym__word_token2] = ACTIONS(1624),
    [sym__whitespace] = ACTIONS(1624),
    [sym__soft_line_ending] = ACTIONS(1624),
    [sym__block_quote_start] = ACTIONS(1624),
    [sym__indented_chunk_start] = ACTIONS(1624),
    [sym_atx_h1_marker] = ACTIONS(1624),
    [sym_atx_h2_marker] = ACTIONS(1624),
    [sym_atx_h3_marker] = ACTIONS(1624),
    [sym_atx_h4_marker] = ACTIONS(1624),
    [sym_atx_h5_marker] = ACTIONS(1624),
    [sym_atx_h6_marker] = ACTIONS(1624),
    [sym__thematic_break] = ACTIONS(1624),
    [sym__list_marker_minus] = ACTIONS(1624),
    [sym__list_marker_plus] = ACTIONS(1624),
    [sym__list_marker_star] = ACTIONS(1624),
    [sym__list_marker_parenthesis] = ACTIONS(1624),
    [sym__list_marker_dot] = ACTIONS(1624),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1624),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1624),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1624),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1624),
    [sym__blank_line_start] = ACTIONS(1624),
    [sym__html_block_1_start] = ACTIONS(1624),
    [sym__html_block_2_start] = ACTIONS(1624),
    [sym__html_block_3_start] = ACTIONS(1624),
    [sym__html_block_4_start] = ACTIONS(1624),
    [sym__html_block_5_start] = ACTIONS(1624),
    [sym__html_block_6_start] = ACTIONS(1624),
    [sym__html_block_7_start] = ACTIONS(1624),
    [sym__pipe_table_start] = ACTIONS(1624),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(1628),
    [anon_sym_LBRACK] = ACTIONS(1626),
    [anon_sym_RBRACK] = ACTIONS(1628),
    [anon_sym_LT] = ACTIONS(1628),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_BANG] = ACTIONS(1628),
    [anon_sym_DQUOTE] = ACTIONS(1628),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_DOLLAR] = ACTIONS(1628),
    [anon_sym_PERCENT] = ACTIONS(1628),
    [anon_sym_AMP] = ACTIONS(1628),
    [anon_sym_SQUOTE] = ACTIONS(1628),
    [anon_sym_STAR] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(1628),
    [anon_sym_DOT] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1628),
    [anon_sym_COLON] = ACTIONS(1628),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_EQ] = ACTIONS(1628),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_AT] = ACTIONS(1628),
    [anon_sym_BSLASH] = ACTIONS(1628),
    [anon_sym_CARET] = ACTIONS(1628),
    [anon_sym__] = ACTIONS(1628),
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [anon_sym_LBRACE] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_TILDE] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1628),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [aux_sym__word_token1] = ACTIONS(1628),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1628),
    [aux_sym__word_token2] = ACTIONS(1628),
    [sym__whitespace] = ACTIONS(1628),
    [sym__soft_line_ending] = ACTIONS(1628),
    [sym__block_quote_start] = ACTIONS(1628),
    [sym__indented_chunk_start] = ACTIONS(1628),
    [sym_atx_h1_marker] = ACTIONS(1628),
    [sym_atx_h2_marker] = ACTIONS(1628),
    [sym_atx_h3_marker] = ACTIONS(1628),
    [sym_atx_h4_marker] = ACTIONS(1628),
    [sym_atx_h5_marker] = ACTIONS(1628),
    [sym_atx_h6_marker] = ACTIONS(1628),
    [sym__thematic_break] = ACTIONS(1628),
    [sym__list_marker_minus] = ACTIONS(1628),
    [sym__list_marker_plus] = ACTIONS(1628),
    [sym__list_marker_star] = ACTIONS(1628),
    [sym__list_marker_parenthesis] = ACTIONS(1628),
    [sym__list_marker_dot] = ACTIONS(1628),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1628),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1628),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1628),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1628),
    [sym__blank_line_start] = ACTIONS(1628),
    [sym__html_block_1_start] = ACTIONS(1628),
    [sym__html_block_2_start] = ACTIONS(1628),
    [sym__html_block_3_start] = ACTIONS(1628),
    [sym__html_block_4_start] = ACTIONS(1628),
    [sym__html_block_5_start] = ACTIONS(1628),
    [sym__html_block_6_start] = ACTIONS(1628),
    [sym__html_block_7_start] = ACTIONS(1628),
    [sym__pipe_table_start] = ACTIONS(1628),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_RBRACK] = ACTIONS(1632),
    [anon_sym_LT] = ACTIONS(1632),
    [anon_sym_GT] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [anon_sym_POUND] = ACTIONS(1632),
    [anon_sym_DOLLAR] = ACTIONS(1632),
    [anon_sym_PERCENT] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1632),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_DASH] = ACTIONS(1632),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_SLASH] = ACTIONS(1632),
    [anon_sym_COLON] = ACTIONS(1632),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(1632),
    [anon_sym_QMARK] = ACTIONS(1632),
    [anon_sym_AT] = ACTIONS(1632),
    [anon_sym_BSLASH] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1632),
    [anon_sym__] = ACTIONS(1632),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_TILDE] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_RPAREN] = ACTIONS(1632),
    [aux_sym__word_token1] = ACTIONS(1632),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1632),
    [aux_sym__word_token2] = ACTIONS(1632),
    [sym__whitespace] = ACTIONS(1632),
    [sym__soft_line_ending] = ACTIONS(1632),
    [sym__block_quote_start] = ACTIONS(1632),
    [sym__indented_chunk_start] = ACTIONS(1632),
    [sym_atx_h1_marker] = ACTIONS(1632),
    [sym_atx_h2_marker] = ACTIONS(1632),
    [sym_atx_h3_marker] = ACTIONS(1632),
    [sym_atx_h4_marker] = ACTIONS(1632),
    [sym_atx_h5_marker] = ACTIONS(1632),
    [sym_atx_h6_marker] = ACTIONS(1632),
    [sym__thematic_break] = ACTIONS(1632),
    [sym__list_marker_minus] = ACTIONS(1632),
    [sym__list_marker_plus] = ACTIONS(1632),
    [sym__list_marker_star] = ACTIONS(1632),
    [sym__list_marker_parenthesis] = ACTIONS(1632),
    [sym__list_marker_dot] = ACTIONS(1632),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1632),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1632),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1632),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1632),
    [sym__blank_line_start] = ACTIONS(1632),
    [sym__html_block_1_start] = ACTIONS(1632),
    [sym__html_block_2_start] = ACTIONS(1632),
    [sym__html_block_3_start] = ACTIONS(1632),
    [sym__html_block_4_start] = ACTIONS(1632),
    [sym__html_block_5_start] = ACTIONS(1632),
    [sym__html_block_6_start] = ACTIONS(1632),
    [sym__html_block_7_start] = ACTIONS(1632),
    [sym__pipe_table_start] = ACTIONS(1632),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1207),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_GT] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_POUND] = ACTIONS(1205),
    [anon_sym_DOLLAR] = ACTIONS(1205),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1205),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_BSLASH] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym__] = ACTIONS(1205),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [aux_sym__word_token1] = ACTIONS(1205),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1205),
    [aux_sym__word_token2] = ACTIONS(1205),
    [sym__whitespace] = ACTIONS(1205),
    [sym__soft_line_ending] = ACTIONS(1205),
    [sym__block_quote_start] = ACTIONS(1205),
    [sym__indented_chunk_start] = ACTIONS(1205),
    [sym_atx_h1_marker] = ACTIONS(1205),
    [sym_atx_h2_marker] = ACTIONS(1205),
    [sym_atx_h3_marker] = ACTIONS(1205),
    [sym_atx_h4_marker] = ACTIONS(1205),
    [sym_atx_h5_marker] = ACTIONS(1205),
    [sym_atx_h6_marker] = ACTIONS(1205),
    [sym__thematic_break] = ACTIONS(1205),
    [sym__list_marker_minus] = ACTIONS(1205),
    [sym__list_marker_plus] = ACTIONS(1205),
    [sym__list_marker_star] = ACTIONS(1205),
    [sym__list_marker_parenthesis] = ACTIONS(1205),
    [sym__list_marker_dot] = ACTIONS(1205),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1205),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1205),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1205),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1205),
    [sym__blank_line_start] = ACTIONS(1205),
    [sym__html_block_1_start] = ACTIONS(1205),
    [sym__html_block_2_start] = ACTIONS(1205),
    [sym__html_block_3_start] = ACTIONS(1205),
    [sym__html_block_4_start] = ACTIONS(1205),
    [sym__html_block_5_start] = ACTIONS(1205),
    [sym__html_block_6_start] = ACTIONS(1205),
    [sym__html_block_7_start] = ACTIONS(1205),
    [sym__pipe_table_start] = ACTIONS(1205),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1634),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_DQUOTE] = ACTIONS(1636),
    [anon_sym_POUND] = ACTIONS(1636),
    [anon_sym_DOLLAR] = ACTIONS(1636),
    [anon_sym_PERCENT] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_COLON] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_EQ] = ACTIONS(1636),
    [anon_sym_QMARK] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(1636),
    [anon_sym_BSLASH] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(1636),
    [anon_sym__] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1636),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [aux_sym__word_token1] = ACTIONS(1636),
    [anon_sym_LBRACKx_RBRACK] = ACTIONS(1636),
    [aux_sym__word_token2] = ACTIONS(1636),
    [sym__whitespace] = ACTIONS(1636),
    [sym__soft_line_ending] = ACTIONS(1636),
    [sym__block_quote_start] = ACTIONS(1636),
    [sym__indented_chunk_start] = ACTIONS(1636),
    [sym_atx_h1_marker] = ACTIONS(1636),
    [sym_atx_h2_marker] = ACTIONS(1636),
    [sym_atx_h3_marker] = ACTIONS(1636),
    [sym_atx_h4_marker] = ACTIONS(1636),
    [sym_atx_h5_marker] = ACTIONS(1636),
    [sym_atx_h6_marker] = ACTIONS(1636),
    [sym__thematic_break] = ACTIONS(1636),
    [sym__list_marker_minus] = ACTIONS(1636),
    [sym__list_marker_plus] = ACTIONS(1636),
    [sym__list_marker_star] = ACTIONS(1636),
    [sym__list_marker_parenthesis] = ACTIONS(1636),
    [sym__list_marker_dot] = ACTIONS(1636),
    [sym__list_marker_minus_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_plus_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_star_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_parenthesis_dont_interrupt] = ACTIONS(1636),
    [sym__list_marker_dot_dont_interrupt] = ACTIONS(1636),
    [sym__fenced_code_block_start_backtick] = ACTIONS(1636),
    [sym__fenced_code_block_start_tilde] = ACTIONS(1636),
    [sym__blank_line_start] = ACTIONS(1636),
    [sym__html_block_1_start] = ACTIONS(1636),
    [sym__html_block_2_start] = ACTIONS(1636),
    [sym__html_block_3_start] = ACTIONS(1636),
    [sym__html_block_4_start] = ACTIONS(1636),
    [sym__html_block_5_start] = ACTIONS(1636),
    [sym__html_block_6_start] = ACTIONS(1636),
    [sym__html_block_7_start] = ACTIONS(1636),
    [sym__pipe_table_start] = ACTIONS(1636),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(97), 1,
      sym__html_block_1_start,
    ACTIONS(99), 1,
      sym__html_block_2_start,
    ACTIONS(101), 1,
      sym__html_block_3_start,
    ACTIONS(103), 1,
      sym__html_block_4_start,
    ACTIONS(105), 1,
      sym__html_block_5_start,
    ACTIONS(107), 1,
      sym__html_block_6_start,
    ACTIONS(109), 1,
      sym__html_block_7_start,
    ACTIONS(1786), 1,
      anon_sym_LBRACK,
    STATE(914), 1,
      sym_link_label,
    STATE(291), 7,
      sym__html_block_1,
      sym__html_block_2,
      sym__html_block_3,
      sym__html_block_4,
      sym__html_block_5,
      sym__html_block_6,
      sym__html_block_7,
    ACTIONS(1789), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [77] = 11,
    ACTIONS(47), 1,
      sym__html_block_1_start,
    ACTIONS(49), 1,
      sym__html_block_2_start,
    ACTIONS(51), 1,
      sym__html_block_3_start,
    ACTIONS(53), 1,
      sym__html_block_4_start,
    ACTIONS(55), 1,
      sym__html_block_5_start,
    ACTIONS(57), 1,
      sym__html_block_6_start,
    ACTIONS(59), 1,
      sym__html_block_7_start,
    ACTIONS(1786), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_link_label,
    STATE(327), 7,
      sym__html_block_1,
      sym__html_block_2,
      sym__html_block_3,
      sym__html_block_4,
      sym__html_block_5,
      sym__html_block_6,
      sym__html_block_7,
    ACTIONS(1789), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [154] = 9,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(1803), 1,
      sym__soft_line_ending,
    STATE(601), 1,
      sym__last_token_punctuation,
    ACTIONS(1793), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    ACTIONS(1800), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1789), 3,
      sym__line_ending,
      sym__eof,
      anon_sym_RBRACK,
    STATE(424), 5,
      sym_backslash_escape,
      sym__text_inline_no_link,
      sym__soft_line_break,
      sym__word,
      aux_sym_link_label_repeat1,
    ACTIONS(1797), 32,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [221] = 11,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1814), 1,
      sym__whitespace,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(376), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(848), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [290] = 7,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    STATE(374), 1,
      sym__last_token_punctuation,
    ACTIONS(1822), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1826), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(375), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1820), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [351] = 11,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1828), 1,
      sym__whitespace,
    STATE(380), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(837), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [420] = 11,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1830), 1,
      sym__whitespace,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(383), 1,
      sym_language,
    STATE(384), 1,
      sym__newline,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(835), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [489] = 11,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1834), 1,
      sym__whitespace,
    STATE(379), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(850), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [558] = 6,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1838), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1840), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(371), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1836), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [616] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1846), 1,
      sym__block_close,
    ACTIONS(1848), 1,
      sym__fenced_code_block_end_backtick,
    STATE(836), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [678] = 7,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1856), 1,
      sym__line_ending,
    ACTIONS(1850), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    STATE(466), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(1852), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(373), 3,
      sym_backslash_escape,
      sym__line,
      aux_sym_info_string_repeat1,
    ACTIONS(1854), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [738] = 10,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(363), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(846), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [804] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      sym__block_close,
    ACTIONS(1860), 1,
      sym__fenced_code_block_end_backtick,
    STATE(830), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [866] = 7,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1856), 1,
      sym__line_ending,
    ACTIONS(1862), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    STATE(466), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(1852), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(368), 3,
      sym_backslash_escape,
      sym__line,
      aux_sym_info_string_repeat1,
    ACTIONS(1854), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [926] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1858), 1,
      sym__block_close,
    ACTIONS(1860), 1,
      sym__fenced_code_block_end_tilde,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    STATE(832), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [988] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    ACTIONS(1868), 1,
      sym__block_close,
    ACTIONS(1870), 1,
      sym__fenced_code_block_end_tilde,
    STATE(823), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1050] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      sym__block_close,
    ACTIONS(1874), 1,
      sym__fenced_code_block_end_tilde,
    STATE(795), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1112] = 7,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1876), 1,
      sym__line_ending,
    ACTIONS(1850), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    STATE(466), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(1852), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(373), 3,
      sym_backslash_escape,
      sym__line,
      aux_sym_info_string_repeat1,
    ACTIONS(1854), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1172] = 9,
    ACTIONS(11), 1,
      sym__soft_line_ending,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1880), 1,
      sym__line_ending,
    ACTIONS(1882), 1,
      sym__eof,
    STATE(115), 1,
      sym__newline,
    STATE(409), 1,
      aux_sym_paragraph_repeat1,
    STATE(533), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(605), 2,
      sym__soft_line_break,
      sym__line,
    ACTIONS(7), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1236] = 9,
    ACTIONS(11), 1,
      sym__soft_line_ending,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1884), 1,
      sym__line_ending,
    ACTIONS(1886), 1,
      sym__eof,
    STATE(109), 1,
      sym__newline,
    STATE(409), 1,
      aux_sym_paragraph_repeat1,
    STATE(533), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(605), 2,
      sym__soft_line_break,
      sym__line,
    ACTIONS(7), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1300] = 6,
    ACTIONS(1888), 1,
      sym__backslash_escape,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1900), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(371), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1891), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [1358] = 10,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(365), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(845), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [1424] = 7,
    ACTIONS(1902), 1,
      sym__backslash_escape,
    ACTIONS(1914), 1,
      sym__line_ending,
    ACTIONS(1905), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    STATE(466), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(1908), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(373), 3,
      sym_backslash_escape,
      sym__line,
      aux_sym_info_string_repeat1,
    ACTIONS(1911), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1484] = 6,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1918), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1920), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(359), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1916), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [1542] = 6,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1838), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1920), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(371), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1836), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [1600] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    ACTIONS(1922), 1,
      sym__block_close,
    ACTIONS(1924), 1,
      sym__fenced_code_block_end_tilde,
    STATE(820), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1662] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1846), 1,
      sym__block_close,
    ACTIONS(1848), 1,
      sym__fenced_code_block_end_tilde,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1724] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      sym__block_close,
    ACTIONS(1874), 1,
      sym__fenced_code_block_end_backtick,
    STATE(804), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1786] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1922), 1,
      sym__block_close,
    ACTIONS(1924), 1,
      sym__fenced_code_block_end_backtick,
    STATE(818), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1848] = 8,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 1,
      sym__block_close,
    ACTIONS(1928), 1,
      sym__fenced_code_block_end_tilde,
    STATE(855), 1,
      sym_code_fence_content,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(411), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [1910] = 10,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(383), 1,
      sym_language,
    STATE(385), 1,
      sym__newline,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(847), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [1976] = 9,
    ACTIONS(11), 1,
      sym__soft_line_ending,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(1932), 1,
      sym__eof,
    STATE(234), 1,
      sym__newline,
    STATE(409), 1,
      aux_sym_paragraph_repeat1,
    STATE(533), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(605), 2,
      sym__soft_line_break,
      sym__line,
    ACTIONS(7), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2040] = 7,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1936), 1,
      sym__line_ending,
    ACTIONS(1934), 2,
      sym_entity_reference,
      sym_numeric_character_reference,
    STATE(466), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(1852), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(361), 3,
      sym_backslash_escape,
      sym__line,
      aux_sym_info_string_repeat1,
    ACTIONS(1854), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2100] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1926), 1,
      sym__block_close,
    ACTIONS(1928), 1,
      sym__fenced_code_block_end_backtick,
    STATE(853), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2162] = 8,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(1868), 1,
      sym__block_close,
    ACTIONS(1870), 1,
      sym__fenced_code_block_end_backtick,
    STATE(831), 1,
      sym_code_fence_content,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(402), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2224] = 6,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1822), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1826), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
    STATE(375), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(1820), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [2282] = 10,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(366), 1,
      sym__newline,
    STATE(383), 1,
      sym_language,
    STATE(401), 1,
      aux_sym_info_string_repeat2,
    STATE(854), 1,
      sym_info_string,
    ACTIONS(1812), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [2348] = 7,
    ACTIONS(1938), 1,
      anon_sym_LBRACK,
    ACTIONS(1942), 1,
      sym__line_ending,
    ACTIONS(1944), 1,
      sym__block_close,
    ACTIONS(1946), 1,
      sym__html_block_1_end,
    STATE(490), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(425), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_1_repeat1,
    ACTIONS(1940), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2407] = 11,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1956), 1,
      sym__whitespace,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    STATE(482), 1,
      sym__soft_line_break,
    STATE(663), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [2474] = 7,
    ACTIONS(1964), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1966), 1,
      sym__line_ending,
    ACTIONS(1968), 1,
      sym__block_close,
    ACTIONS(1960), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(499), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(406), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_3_repeat1,
    ACTIONS(1962), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2533] = 11,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    ACTIONS(1970), 1,
      sym__whitespace,
    STATE(484), 1,
      sym__soft_line_break,
    STATE(677), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [2600] = 7,
    ACTIONS(1976), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(1978), 1,
      sym__line_ending,
    ACTIONS(1980), 1,
      sym__block_close,
    ACTIONS(1972), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(519), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(393), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_5_repeat1,
    ACTIONS(1974), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2659] = 7,
    ACTIONS(1976), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(1978), 1,
      sym__line_ending,
    ACTIONS(1982), 1,
      sym__block_close,
    ACTIONS(1972), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(519), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(417), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_5_repeat1,
    ACTIONS(1974), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2718] = 7,
    ACTIONS(1938), 1,
      anon_sym_LBRACK,
    ACTIONS(1942), 1,
      sym__line_ending,
    ACTIONS(1946), 1,
      sym__html_block_1_end,
    ACTIONS(1984), 1,
      sym__block_close,
    STATE(490), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(420), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_1_repeat1,
    ACTIONS(1940), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2777] = 7,
    ACTIONS(1990), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(1992), 1,
      sym__line_ending,
    ACTIONS(1994), 1,
      sym__block_close,
    ACTIONS(1986), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(520), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(416), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_2_repeat1,
    ACTIONS(1988), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2836] = 7,
    ACTIONS(1938), 1,
      anon_sym_LBRACK,
    ACTIONS(1942), 1,
      sym__line_ending,
    ACTIONS(1946), 1,
      sym__html_block_1_end,
    ACTIONS(1996), 1,
      sym__block_close,
    STATE(490), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(388), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_1_repeat1,
    ACTIONS(1940), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2895] = 7,
    ACTIONS(1990), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(1992), 1,
      sym__line_ending,
    ACTIONS(1998), 1,
      sym__block_close,
    ACTIONS(1986), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(520), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(426), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_2_repeat1,
    ACTIONS(1988), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [2954] = 7,
    ACTIONS(1964), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1966), 1,
      sym__line_ending,
    ACTIONS(2000), 1,
      sym__block_close,
    ACTIONS(1960), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(499), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(408), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_3_repeat1,
    ACTIONS(1962), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3013] = 7,
    ACTIONS(2002), 1,
      sym__backslash_escape,
    ACTIONS(2011), 1,
      anon_sym_DQUOTE,
    ACTIONS(2013), 1,
      sym__soft_line_ending,
    STATE(530), 1,
      sym__soft_line_break,
    ACTIONS(2008), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(399), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(2005), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3072] = 7,
    ACTIONS(1976), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(1978), 1,
      sym__line_ending,
    ACTIONS(2016), 1,
      sym__block_close,
    ACTIONS(1972), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(519), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(403), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_5_repeat1,
    ACTIONS(1974), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3131] = 9,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(1936), 1,
      sym__line_ending,
    ACTIONS(2020), 1,
      sym__whitespace,
    STATE(364), 1,
      sym_language,
    STATE(538), 1,
      aux_sym_info_string_repeat2,
    ACTIONS(2018), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(1810), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(448), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(1808), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [3194] = 6,
    ACTIONS(1832), 1,
      sym__line_ending,
    ACTIONS(1842), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 2,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(418), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1844), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3251] = 7,
    ACTIONS(1976), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(1978), 1,
      sym__line_ending,
    ACTIONS(2024), 1,
      sym__block_close,
    ACTIONS(1972), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(519), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(417), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_5_repeat1,
    ACTIONS(1974), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3310] = 7,
    ACTIONS(2026), 1,
      sym__backslash_escape,
    ACTIONS(2035), 1,
      anon_sym_SQUOTE,
    ACTIONS(2037), 1,
      sym__soft_line_ending,
    STATE(531), 1,
      sym__soft_line_break,
    ACTIONS(2032), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(404), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(2029), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3369] = 6,
    ACTIONS(2040), 1,
      anon_sym_LBRACK,
    ACTIONS(2046), 1,
      sym__line_ending,
    ACTIONS(2049), 2,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(405), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(2043), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3426] = 7,
    ACTIONS(1964), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1966), 1,
      sym__line_ending,
    ACTIONS(2051), 1,
      sym__block_close,
    ACTIONS(1960), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(499), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(422), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_3_repeat1,
    ACTIONS(1962), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3485] = 6,
    ACTIONS(2053), 1,
      sym__backslash_escape,
    ACTIONS(2059), 1,
      anon_sym_RBRACK,
    ACTIONS(2064), 1,
      sym__soft_line_ending,
    ACTIONS(2061), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(407), 5,
      sym_backslash_escape,
      sym__text_inline_no_link,
      sym__soft_line_break,
      sym__word,
      aux_sym_link_label_repeat1,
    ACTIONS(2056), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3542] = 7,
    ACTIONS(1964), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1966), 1,
      sym__line_ending,
    ACTIONS(2067), 1,
      sym__block_close,
    ACTIONS(1960), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(499), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(422), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_3_repeat1,
    ACTIONS(1962), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3601] = 7,
    ACTIONS(2069), 1,
      anon_sym_LBRACK,
    ACTIONS(2077), 1,
      sym__soft_line_ending,
    STATE(409), 1,
      aux_sym_paragraph_repeat1,
    ACTIONS(2075), 2,
      sym__line_ending,
      sym__eof,
    STATE(533), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(605), 2,
      sym__soft_line_break,
      sym__line,
    ACTIONS(2072), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3660] = 10,
    ACTIONS(2086), 1,
      anon_sym_PIPE,
    ACTIONS(2088), 1,
      sym__whitespace,
    STATE(431), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(704), 1,
      sym_pipe_table_cell,
    STATE(790), 1,
      sym_pipe_table_row,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2090), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3725] = 6,
    ACTIONS(1816), 1,
      sym__line_ending,
    ACTIONS(1864), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 2,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
    STATE(502), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(405), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(1866), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3782] = 11,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    ACTIONS(2092), 1,
      sym__whitespace,
    STATE(465), 1,
      sym__soft_line_break,
    STATE(676), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [3849] = 11,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    ACTIONS(2094), 1,
      sym__whitespace,
    STATE(474), 1,
      sym__soft_line_break,
    STATE(664), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [3916] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2100), 1,
      anon_sym_SQUOTE,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    STATE(531), 1,
      sym__soft_line_break,
    ACTIONS(2098), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(421), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(2096), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [3975] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2100), 1,
      anon_sym_DQUOTE,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    STATE(530), 1,
      sym__soft_line_break,
    ACTIONS(2106), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(419), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(2104), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4034] = 7,
    ACTIONS(1990), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(1992), 1,
      sym__line_ending,
    ACTIONS(2108), 1,
      sym__block_close,
    ACTIONS(1986), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(520), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(423), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_2_repeat1,
    ACTIONS(1988), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4093] = 7,
    ACTIONS(2116), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2119), 1,
      sym__line_ending,
    ACTIONS(2122), 1,
      sym__block_close,
    ACTIONS(2110), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(519), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(417), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_5_repeat1,
    ACTIONS(2113), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4152] = 6,
    ACTIONS(2124), 1,
      anon_sym_LBRACK,
    ACTIONS(2130), 1,
      sym__line_ending,
    ACTIONS(2049), 2,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
    STATE(514), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(418), 3,
      sym__newline,
      sym__line,
      aux_sym_code_fence_content_repeat1,
    ACTIONS(2127), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4209] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE,
    STATE(530), 1,
      sym__soft_line_break,
    ACTIONS(2135), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(399), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(2133), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4268] = 7,
    ACTIONS(1938), 1,
      anon_sym_LBRACK,
    ACTIONS(1942), 1,
      sym__line_ending,
    ACTIONS(1946), 1,
      sym__html_block_1_end,
    ACTIONS(2139), 1,
      sym__block_close,
    STATE(490), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(425), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_1_repeat1,
    ACTIONS(1940), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4327] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    ACTIONS(2137), 1,
      anon_sym_SQUOTE,
    STATE(531), 1,
      sym__soft_line_break,
    ACTIONS(2143), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(404), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(2141), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4386] = 7,
    ACTIONS(2151), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2154), 1,
      sym__line_ending,
    ACTIONS(2157), 1,
      sym__block_close,
    ACTIONS(2145), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(499), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(422), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_3_repeat1,
    ACTIONS(2148), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4445] = 7,
    ACTIONS(2165), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2168), 1,
      sym__line_ending,
    ACTIONS(2171), 1,
      sym__block_close,
    ACTIONS(2159), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(520), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(423), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_2_repeat1,
    ACTIONS(2162), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4504] = 6,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    ACTIONS(2175), 1,
      anon_sym_RBRACK,
    ACTIONS(2177), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(407), 5,
      sym_backslash_escape,
      sym__text_inline_no_link,
      sym__soft_line_break,
      sym__word,
      aux_sym_link_label_repeat1,
    ACTIONS(2173), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4561] = 7,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2185), 1,
      sym__line_ending,
    ACTIONS(2188), 1,
      sym__block_close,
    ACTIONS(2190), 1,
      sym__html_block_1_end,
    STATE(490), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(425), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_1_repeat1,
    ACTIONS(2182), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4620] = 7,
    ACTIONS(1990), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(1992), 1,
      sym__line_ending,
    ACTIONS(2193), 1,
      sym__block_close,
    ACTIONS(1986), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(520), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(423), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_2_repeat1,
    ACTIONS(1988), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4679] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2201), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(433), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4737] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2203), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(460), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4795] = 6,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2207), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(463), 3,
      sym__newline,
      sym__line,
      aux_sym__indented_chunk_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4851] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    ACTIONS(2137), 1,
      anon_sym_RPAREN,
    STATE(551), 1,
      sym__soft_line_break,
    ACTIONS(2211), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(455), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(2209), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [4909] = 9,
    ACTIONS(2213), 1,
      anon_sym_PIPE,
    ACTIONS(2215), 1,
      sym__whitespace,
    STATE(447), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(713), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2217), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4971] = 9,
    ACTIONS(2219), 1,
      anon_sym_PIPE,
    ACTIONS(2221), 1,
      sym__whitespace,
    STATE(444), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(713), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2223), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5033] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2225), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(460), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5091] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2227), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(460), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5149] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2229), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(460), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5207] = 6,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2231), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(463), 3,
      sym__newline,
      sym__line,
      aux_sym__indented_chunk_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5263] = 7,
    ACTIONS(11), 1,
      sym__soft_line_ending,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    STATE(35), 1,
      sym_paragraph,
    STATE(382), 1,
      aux_sym_paragraph_repeat1,
    STATE(533), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(605), 2,
      sym__soft_line_break,
      sym__line,
    ACTIONS(7), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5321] = 6,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2233), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(429), 3,
      sym__newline,
      sym__line,
      aux_sym__indented_chunk_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5377] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2235), 1,
      anon_sym_GT,
    ACTIONS(2237), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(461), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_4_repeat1,
    ACTIONS(2197), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5435] = 10,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    STATE(484), 1,
      sym__soft_line_break,
    STATE(677), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [5499] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2235), 1,
      anon_sym_GT,
    ACTIONS(2239), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(461), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_4_repeat1,
    ACTIONS(2197), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5557] = 5,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    ACTIONS(2241), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(424), 5,
      sym_backslash_escape,
      sym__text_inline_no_link,
      sym__soft_line_break,
      sym__word,
      aux_sym_link_label_repeat1,
    ACTIONS(1793), 34,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5611] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2243), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(434), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [5669] = 9,
    ACTIONS(2213), 1,
      anon_sym_PIPE,
    ACTIONS(2245), 1,
      sym__whitespace,
    STATE(447), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(708), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2247), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5731] = 10,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    STATE(465), 1,
      sym__soft_line_break,
    STATE(676), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [5795] = 9,
    ACTIONS(2249), 1,
      anon_sym_PIPE,
    ACTIONS(2251), 1,
      sym__whitespace,
    STATE(458), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(708), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2253), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5857] = 9,
    ACTIONS(2264), 1,
      anon_sym_PIPE,
    ACTIONS(2267), 1,
      sym__whitespace,
    STATE(447), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(597), 1,
      sym__word,
    STATE(809), 1,
      sym_pipe_table_cell,
    ACTIONS(2258), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2253), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2255), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2261), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5919] = 5,
    ACTIONS(1806), 1,
      sym__backslash_escape,
    ACTIONS(2272), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(462), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(2274), 5,
      sym__line_ending,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym__whitespace,
    ACTIONS(2270), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [5973] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2276), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(428), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6031] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2235), 1,
      anon_sym_GT,
    ACTIONS(2278), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(441), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_4_repeat1,
    ACTIONS(2197), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6089] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2199), 1,
      sym__line_ending,
    ACTIONS(2280), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(435), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6147] = 7,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2235), 1,
      anon_sym_GT,
    ACTIONS(2282), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(439), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_4_repeat1,
    ACTIONS(2197), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6205] = 10,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    STATE(475), 1,
      sym__soft_line_break,
    STATE(674), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [6269] = 10,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(1958), 1,
      sym__soft_line_ending,
    STATE(485), 1,
      sym__soft_line_break,
    STATE(684), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [6333] = 7,
    ACTIONS(2284), 1,
      sym__backslash_escape,
    ACTIONS(2293), 1,
      anon_sym_RPAREN,
    ACTIONS(2295), 1,
      sym__soft_line_ending,
    STATE(551), 1,
      sym__soft_line_break,
    ACTIONS(2290), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(455), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(2287), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6391] = 6,
    ACTIONS(2195), 1,
      anon_sym_LBRACK,
    ACTIONS(2205), 1,
      sym__line_ending,
    ACTIONS(2298), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(436), 3,
      sym__newline,
      sym__line,
      aux_sym__indented_chunk_repeat1,
    ACTIONS(2197), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6447] = 7,
    ACTIONS(1791), 1,
      sym__backslash_escape,
    ACTIONS(2100), 1,
      anon_sym_RPAREN,
    ACTIONS(2102), 1,
      sym__soft_line_ending,
    STATE(551), 1,
      sym__soft_line_break,
    ACTIONS(2302), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(430), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(2300), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6505] = 9,
    ACTIONS(2213), 1,
      anon_sym_PIPE,
    ACTIONS(2304), 1,
      sym__whitespace,
    STATE(447), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(471), 1,
      sym__word,
    STATE(700), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6567] = 5,
    STATE(481), 1,
      sym__last_token_punctuation,
    ACTIONS(2310), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(480), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2312), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2308), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6621] = 7,
    ACTIONS(2314), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      sym__line_ending,
    ACTIONS(2323), 1,
      sym__block_close,
    STATE(550), 1,
      sym__newline,
    STATE(460), 2,
      sym__line,
      aux_sym__html_block_6_repeat1,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2317), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6679] = 7,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_GT,
    ACTIONS(2334), 1,
      sym__line_ending,
    ACTIONS(2337), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(461), 3,
      sym__newline,
      sym__line,
      aux_sym__html_block_4_repeat1,
    ACTIONS(2328), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6737] = 5,
    ACTIONS(2339), 1,
      sym__backslash_escape,
    ACTIONS(2345), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(462), 3,
      sym_backslash_escape,
      sym__word,
      aux_sym_language_repeat1,
    ACTIONS(2348), 5,
      sym__line_ending,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym__whitespace,
    ACTIONS(2342), 31,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [6791] = 6,
    ACTIONS(2350), 1,
      anon_sym_LBRACK,
    ACTIONS(2356), 1,
      sym__line_ending,
    ACTIONS(2359), 1,
      sym__block_close,
    STATE(569), 2,
      sym__word,
      aux_sym__line_repeat1,
    STATE(463), 3,
      sym__newline,
      sym__line,
      aux_sym__indented_chunk_repeat1,
    ACTIONS(2353), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6847] = 5,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2367), 1,
      anon_sym_GT,
    ACTIONS(2365), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(486), 4,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(2363), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [6900] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2369), 1,
      sym__whitespace,
    STATE(684), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [6961] = 4,
    STATE(487), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2373), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2371), 4,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
    ACTIONS(2375), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7012] = 6,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2381), 1,
      anon_sym_LPAREN,
    ACTIONS(2383), 1,
      anon_sym_RPAREN,
    ACTIONS(2379), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(472), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(2377), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [7067] = 4,
    ACTIONS(2387), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(478), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2389), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2385), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7118] = 5,
    ACTIONS(2391), 1,
      sym__backslash_escape,
    ACTIONS(2400), 1,
      anon_sym_GT,
    ACTIONS(2397), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(469), 4,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(2394), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7171] = 8,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(471), 1,
      sym__word,
    STATE(692), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2406), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7230] = 4,
    ACTIONS(2310), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(480), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2312), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2308), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7281] = 6,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2381), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_RPAREN,
    ACTIONS(2410), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(473), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(2408), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [7336] = 6,
    ACTIONS(1900), 1,
      anon_sym_RPAREN,
    ACTIONS(2414), 1,
      sym__backslash_escape,
    ACTIONS(2423), 1,
      anon_sym_LPAREN,
    ACTIONS(2420), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(473), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(2417), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [7391] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      sym__whitespace,
    STATE(677), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [7452] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2428), 1,
      sym__whitespace,
    STATE(681), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [7513] = 6,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2381), 1,
      anon_sym_LPAREN,
    ACTIONS(2434), 1,
      anon_sym_RPAREN,
    ACTIONS(2432), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(479), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(2430), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [7568] = 8,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(471), 1,
      sym__word,
    STATE(703), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7627] = 4,
    ACTIONS(2439), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(478), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2442), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2436), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7678] = 6,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2381), 1,
      anon_sym_LPAREN,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
    ACTIONS(2410), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(473), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(2408), 32,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [7733] = 4,
    ACTIONS(2387), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(478), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2446), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2385), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7784] = 4,
    ACTIONS(2450), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(468), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2446), 4,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
    ACTIONS(2448), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [7835] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      sym__whitespace,
    STATE(676), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [7896] = 8,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(471), 1,
      sym__word,
    STATE(710), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2247), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7955] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2454), 1,
      sym__whitespace,
    STATE(674), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [8016] = 9,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    ACTIONS(2456), 1,
      sym__whitespace,
    STATE(687), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [8077] = 5,
    ACTIONS(2361), 1,
      sym__backslash_escape,
    ACTIONS(2462), 1,
      anon_sym_GT,
    ACTIONS(2460), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(469), 4,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(2458), 33,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8130] = 4,
    STATE(487), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2466), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2464), 4,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
    ACTIONS(2469), 33,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8181] = 4,
    ACTIONS(2472), 1,
      anon_sym_LBRACK,
    STATE(488), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
    ACTIONS(2475), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8231] = 9,
    ACTIONS(2484), 1,
      anon_sym_PIPE,
    ACTIONS(2486), 1,
      sym__whitespace,
    STATE(516), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(791), 1,
      sym_pipe_table_cell,
    STATE(840), 1,
      sym_pipe_table_row,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8291] = 4,
    ACTIONS(2488), 1,
      anon_sym_LBRACK,
    STATE(511), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
    ACTIONS(2490), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8341] = 3,
    ACTIONS(2492), 1,
      sym_block_continuation,
    ACTIONS(1163), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1165), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8389] = 9,
    ACTIONS(2253), 1,
      sym__line_ending,
    ACTIONS(2494), 1,
      anon_sym_PIPE,
    ACTIONS(2497), 1,
      sym__whitespace,
    STATE(492), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(597), 1,
      sym__word,
    STATE(793), 1,
      sym_pipe_table_cell,
    ACTIONS(2258), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2255), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2261), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8449] = 4,
    ACTIONS(2500), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(493), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2503), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8499] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(684), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [8557] = 9,
    ACTIONS(2223), 1,
      sym__line_ending,
    ACTIONS(2506), 1,
      anon_sym_PIPE,
    ACTIONS(2508), 1,
      sym__whitespace,
    STATE(524), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(786), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8617] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(300), 1,
      sym__newline,
    STATE(802), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8671] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(301), 1,
      sym__newline,
    STATE(801), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8725] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(184), 1,
      sym__newline,
    STATE(800), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8779] = 4,
    ACTIONS(2514), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(505), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_QMARK_GT,
    ACTIONS(2516), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8829] = 5,
    STATE(545), 1,
      sym__last_token_punctuation,
    ACTIONS(2312), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2520), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(544), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2518), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8881] = 4,
    ACTIONS(2522), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(501), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2525), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8931] = 4,
    ACTIONS(2528), 1,
      anon_sym_LBRACK,
    STATE(488), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
    ACTIONS(2530), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [8981] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(303), 1,
      sym__newline,
    STATE(799), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9035] = 2,
    ACTIONS(2534), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2532), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9081] = 4,
    ACTIONS(2536), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    STATE(505), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_QMARK_GT,
    ACTIONS(2539), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9131] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(295), 1,
      sym__newline,
    STATE(827), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9185] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(687), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [9243] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(288), 1,
      sym__newline,
    STATE(813), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9297] = 4,
    ACTIONS(2544), 1,
      anon_sym_LBRACK,
    STATE(509), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
    ACTIONS(2547), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9347] = 9,
    ACTIONS(2253), 1,
      sym__line_ending,
    ACTIONS(2550), 1,
      anon_sym_PIPE,
    ACTIONS(2552), 1,
      sym__whitespace,
    STATE(523), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(783), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [9407] = 4,
    ACTIONS(2554), 1,
      anon_sym_LBRACK,
    STATE(511), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
    ACTIONS(2557), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9457] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(304), 1,
      sym__newline,
    STATE(798), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9511] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(278), 1,
      sym__newline,
    STATE(812), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9565] = 4,
    ACTIONS(2560), 1,
      anon_sym_LBRACK,
    STATE(509), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
    ACTIONS(2562), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9615] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    STATE(299), 1,
      sym__newline,
    STATE(803), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9669] = 9,
    ACTIONS(2217), 1,
      sym__line_ending,
    ACTIONS(2564), 1,
      anon_sym_PIPE,
    ACTIONS(2566), 1,
      sym__whitespace,
    STATE(492), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(786), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [9729] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(293), 1,
      sym__newline,
    STATE(794), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9783] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(661), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [9841] = 4,
    ACTIONS(2568), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(501), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2570), 34,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9891] = 4,
    ACTIONS(2572), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    STATE(493), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__block_close,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2574), 34,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9941] = 2,
    ACTIONS(2576), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1900), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [9987] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(674), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [10045] = 9,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(2564), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym__whitespace,
    STATE(492), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(787), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [10105] = 9,
    ACTIONS(2247), 1,
      sym__line_ending,
    ACTIONS(2564), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      sym__whitespace,
    STATE(492), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(783), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [10165] = 2,
    ACTIONS(2584), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2582), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10211] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(680), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [10269] = 3,
    ACTIONS(2590), 1,
      sym_block_continuation,
    ACTIONS(2588), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2586), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10317] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(292), 1,
      sym__newline,
    STATE(815), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10371] = 2,
    ACTIONS(2594), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2592), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10417] = 4,
    ACTIONS(2600), 1,
      sym__soft_line_ending,
    STATE(902), 1,
      sym__soft_line_break,
    ACTIONS(2598), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2596), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10467] = 4,
    ACTIONS(2607), 1,
      sym__soft_line_ending,
    STATE(903), 1,
      sym__soft_line_break,
    ACTIONS(2605), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2603), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10517] = 8,
    ACTIONS(1818), 1,
      sym__backslash_escape,
    ACTIONS(1824), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LT,
    STATE(681), 1,
      sym_link_destination,
    ACTIONS(1950), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(386), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(1948), 5,
      sym_entity_reference,
      sym_numeric_character_reference,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(1952), 26,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [10575] = 4,
    ACTIONS(2610), 1,
      anon_sym_LBRACK,
    STATE(536), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2371), 3,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
    ACTIONS(2612), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10625] = 9,
    ACTIONS(2484), 1,
      anon_sym_PIPE,
    ACTIONS(2486), 1,
      sym__whitespace,
    STATE(516), 1,
      aux_sym_pipe_table_row_repeat1,
    STATE(560), 1,
      sym__word,
    STATE(791), 1,
      sym_pipe_table_cell,
    STATE(805), 1,
      sym_pipe_table_row,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [10685] = 6,
    ACTIONS(2510), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(296), 1,
      sym__newline,
    STATE(828), 1,
      sym__line,
    STATE(585), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2512), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10739] = 4,
    ACTIONS(2614), 1,
      anon_sym_LBRACK,
    STATE(536), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2464), 3,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
    ACTIONS(2617), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10789] = 2,
    ACTIONS(2620), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2442), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10834] = 4,
    STATE(538), 1,
      aux_sym_info_string_repeat2,
    ACTIONS(2626), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(2624), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2622), 34,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10883] = 4,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    ACTIONS(2629), 1,
      sym__close_block,
    STATE(625), 1,
      sym__last_token_punctuation,
    ACTIONS(1789), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10932] = 4,
    ACTIONS(2389), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2633), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(542), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2631), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [10981] = 2,
    ACTIONS(2637), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2635), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11026] = 4,
    ACTIONS(2442), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2642), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(542), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2639), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11075] = 2,
    ACTIONS(2647), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2645), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11120] = 4,
    ACTIONS(2446), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2633), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(542), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2631), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11169] = 4,
    ACTIONS(2446), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2651), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(540), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2649), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11218] = 3,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      sym_block_continuation,
    ACTIONS(1119), 38,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11265] = 2,
    ACTIONS(2657), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2655), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11310] = 2,
    ACTIONS(2659), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2348), 37,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11355] = 3,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(2661), 1,
      sym_block_continuation,
    ACTIONS(1119), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11402] = 4,
    ACTIONS(1424), 1,
      sym__blank_line_start,
    ACTIONS(2663), 1,
      anon_sym_LBRACK,
    STATE(860), 1,
      sym__blank_line,
    ACTIONS(2665), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11451] = 4,
    ACTIONS(2671), 1,
      sym__soft_line_ending,
    STATE(906), 1,
      sym__soft_line_break,
    ACTIONS(2669), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2667), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11500] = 8,
    ACTIONS(2247), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(560), 1,
      sym__word,
    STATE(779), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [11557] = 8,
    ACTIONS(2406), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(560), 1,
      sym__word,
    STATE(775), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [11614] = 3,
    ACTIONS(2678), 1,
      sym_block_continuation,
    ACTIONS(1117), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(1119), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11661] = 2,
    ACTIONS(2682), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2680), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11706] = 5,
    ACTIONS(2312), 1,
      anon_sym_PIPE,
    STATE(574), 1,
      sym__last_token_punctuation,
    ACTIONS(2686), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(582), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2684), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11757] = 4,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 2,
      sym__line_ending,
      sym__block_close,
    STATE(557), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2691), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11806] = 3,
    ACTIONS(2694), 1,
      sym_block_continuation,
    ACTIONS(1117), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1119), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK_RBRACK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11853] = 3,
    ACTIONS(1163), 1,
      anon_sym_LBRACK,
    ACTIONS(2696), 1,
      sym_block_continuation,
    ACTIONS(1165), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11900] = 4,
    ACTIONS(2312), 2,
      sym__line_ending,
      anon_sym_PIPE,
    ACTIONS(2520), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(544), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2518), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11949] = 2,
    ACTIONS(2698), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2464), 37,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [11994] = 2,
    ACTIONS(2700), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2035), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12039] = 3,
    ACTIONS(2702), 1,
      sym_block_continuation,
    ACTIONS(1117), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    ACTIONS(1119), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12086] = 2,
    ACTIONS(2706), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2704), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12131] = 3,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(2708), 1,
      sym_block_continuation,
    ACTIONS(1119), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12178] = 8,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(560), 1,
      sym__word,
    STATE(773), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [12235] = 2,
    ACTIONS(2710), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2011), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12280] = 2,
    ACTIONS(2712), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2253), 38,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12325] = 4,
    ACTIONS(2714), 1,
      anon_sym_LBRACK,
    ACTIONS(2371), 2,
      sym__line_ending,
      sym__block_close,
    STATE(557), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2716), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12374] = 2,
    ACTIONS(1348), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1350), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12419] = 2,
    ACTIONS(2584), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2582), 37,
      sym__line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12464] = 2,
    ACTIONS(2584), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2582), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12509] = 3,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(2718), 1,
      sym_block_continuation,
    ACTIONS(1119), 38,
      sym__line_ending,
      sym__block_close,
      sym__blank_line_start,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12556] = 4,
    ACTIONS(2446), 1,
      anon_sym_PIPE,
    ACTIONS(2722), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(610), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2720), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12604] = 4,
    ACTIONS(2464), 1,
      sym__line_ending,
    ACTIONS(2724), 1,
      anon_sym_LBRACK,
    STATE(575), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2727), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12652] = 3,
    ACTIONS(2730), 1,
      sym_block_continuation,
    ACTIONS(1163), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1165), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12698] = 2,
    ACTIONS(2732), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2122), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK_RBRACK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12742] = 2,
    ACTIONS(2734), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2171), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12786] = 2,
    ACTIONS(1276), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1274), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK_RBRACK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12830] = 2,
    ACTIONS(1276), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(1274), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12874] = 2,
    ACTIONS(2736), 1,
      anon_sym_LBRACK,
    ACTIONS(2188), 38,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12918] = 4,
    ACTIONS(2446), 1,
      anon_sym_PIPE,
    ACTIONS(2740), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(609), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2738), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [12966] = 2,
    ACTIONS(2698), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2464), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK_RBRACK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13010] = 7,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(471), 1,
      sym__word,
    STATE(710), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13064] = 4,
    ACTIONS(2371), 1,
      sym__line_ending,
    ACTIONS(2742), 1,
      anon_sym_LBRACK,
    STATE(575), 2,
      sym__word,
      aux_sym__line_repeat1,
    ACTIONS(2744), 35,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13112] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13156] = 2,
    ACTIONS(1276), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    ACTIONS(1274), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13200] = 7,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(560), 1,
      sym__word,
    STATE(779), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13254] = 2,
    ACTIONS(2748), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2746), 36,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13298] = 3,
    ACTIONS(2750), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      sym__whitespace,
    ACTIONS(2752), 37,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [13344] = 2,
    ACTIONS(2698), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    ACTIONS(2464), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13388] = 7,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(560), 1,
      sym__word,
    STATE(773), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13442] = 2,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 38,
      sym__line_ending,
      sym__block_close,
      sym__blank_line_start,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13486] = 7,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
    STATE(597), 1,
      sym__word,
    STATE(841), 1,
      sym_pipe_table_cell,
    ACTIONS(2758), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2756), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2760), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13540] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13584] = 3,
    ACTIONS(2750), 1,
      anon_sym_LBRACK,
    ACTIONS(2762), 1,
      sym__whitespace,
    ACTIONS(2752), 37,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [13630] = 4,
    ACTIONS(2312), 1,
      anon_sym_PIPE,
    ACTIONS(2686), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(582), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2684), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13678] = 7,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(597), 1,
      sym__word,
    STATE(796), 1,
      sym_pipe_table_cell,
    ACTIONS(2758), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2756), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2760), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13732] = 7,
    ACTIONS(2404), 1,
      sym__whitespace,
    ACTIONS(2764), 1,
      anon_sym_PIPE,
    STATE(471), 1,
      sym__word,
    STATE(712), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [13786] = 2,
    ACTIONS(2766), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2293), 36,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13830] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13874] = 2,
    ACTIONS(2770), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2768), 37,
      sym__soft_line_ending,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13918] = 2,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 38,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [13962] = 7,
    ACTIONS(2676), 1,
      sym__whitespace,
    ACTIONS(2772), 1,
      anon_sym_PIPE,
    STATE(560), 1,
      sym__word,
    STATE(785), 1,
      sym_pipe_table_cell,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2478), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2482), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [14016] = 2,
    ACTIONS(2774), 1,
      anon_sym_LBRACK,
    ACTIONS(2776), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14060] = 2,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_tilde,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14104] = 2,
    ACTIONS(2698), 2,
      anon_sym_LBRACK,
      anon_sym_DASH,
    ACTIONS(2464), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14148] = 2,
    ACTIONS(2778), 2,
      anon_sym_LBRACK,
      anon_sym_QMARK,
    ACTIONS(2157), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_GT,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14192] = 4,
    ACTIONS(2442), 1,
      anon_sym_PIPE,
    ACTIONS(2783), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(609), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2780), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14240] = 4,
    ACTIONS(2389), 1,
      anon_sym_PIPE,
    ACTIONS(2740), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    STATE(609), 2,
      sym__word,
      aux_sym_pipe_table_cell_repeat1,
    ACTIONS(2738), 34,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14288] = 2,
    ACTIONS(2584), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2582), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14332] = 2,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 38,
      sym__line_ending,
      sym__block_close,
      sym__fenced_code_block_end_backtick,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14376] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 38,
      sym__line_ending,
      sym__block_close,
      sym__html_block_1_end,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14420] = 3,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(2786), 1,
      sym_block_continuation,
    ACTIONS(1119), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14466] = 7,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
    STATE(471), 1,
      sym__word,
    STATE(703), 1,
      sym_pipe_table_cell,
    ACTIONS(2082), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2080), 4,
      sym__backslash_escape,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
    ACTIONS(2084), 29,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [14520] = 2,
    ACTIONS(1348), 1,
      anon_sym_LBRACK,
    ACTIONS(1350), 38,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14564] = 2,
    ACTIONS(2790), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2788), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14607] = 2,
    ACTIONS(2712), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2253), 36,
      sym__line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14650] = 2,
    ACTIONS(2682), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2680), 36,
      sym__line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14693] = 2,
    ACTIONS(1348), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1350), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14736] = 2,
    ACTIONS(2576), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(1900), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [14779] = 2,
    ACTIONS(2534), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2532), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [14822] = 2,
    ACTIONS(2657), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2655), 36,
      sym__line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14865] = 2,
    ACTIONS(2792), 1,
      anon_sym_LBRACK,
    ACTIONS(2337), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14908] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14951] = 2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    ACTIONS(2796), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [14994] = 2,
    ACTIONS(2620), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2442), 36,
      sym__line_ending,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [15037] = 2,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1274), 37,
      sym__line_ending,
      sym__block_close,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [15080] = 2,
    ACTIONS(2594), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2592), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
  [15123] = 2,
    ACTIONS(2698), 1,
      anon_sym_LBRACK,
    ACTIONS(2464), 36,
      sym__line_ending,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [15165] = 2,
    ACTIONS(2620), 2,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
    ACTIONS(2442), 35,
      sym__backslash_escape,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym__word_token1,
      anon_sym_LBRACKx_RBRACK,
      aux_sym__word_token2,
      sym__whitespace,
  [15207] = 15,
    ACTIONS(17), 1,
      sym_atx_h1_marker,
    ACTIONS(19), 1,
      sym_atx_h2_marker,
    ACTIONS(21), 1,
      sym_atx_h3_marker,
    ACTIONS(23), 1,
      sym_atx_h4_marker,
    ACTIONS(25), 1,
      sym_atx_h5_marker,
    ACTIONS(27), 1,
      sym_atx_h6_marker,
    ACTIONS(2798), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      sym__atx_heading1,
    STATE(45), 1,
      sym__atx_heading2,
    STATE(49), 1,
      sym__atx_heading3,
    STATE(60), 1,
      sym__atx_heading4,
    STATE(65), 1,
      sym__atx_heading5,
    STATE(70), 1,
      sym__atx_heading6,
    STATE(633), 2,
      sym_section,
      aux_sym_document_repeat2,
    STATE(657), 6,
      sym__section1,
      sym__section2,
      sym__section3,
      sym__section4,
      sym__section5,
      sym__section6,
  [15259] = 15,
    ACTIONS(2800), 1,
      ts_builtin_sym_end,
    ACTIONS(2802), 1,
      sym_atx_h1_marker,
    ACTIONS(2805), 1,
      sym_atx_h2_marker,
    ACTIONS(2808), 1,
      sym_atx_h3_marker,
    ACTIONS(2811), 1,
      sym_atx_h4_marker,
    ACTIONS(2814), 1,
      sym_atx_h5_marker,
    ACTIONS(2817), 1,
      sym_atx_h6_marker,
    STATE(37), 1,
      sym__atx_heading1,
    STATE(45), 1,
      sym__atx_heading2,
    STATE(49), 1,
      sym__atx_heading3,
    STATE(60), 1,
      sym__atx_heading4,
    STATE(65), 1,
      sym__atx_heading5,
    STATE(70), 1,
      sym__atx_heading6,
    STATE(633), 2,
      sym_section,
      aux_sym_document_repeat2,
    STATE(657), 6,
      sym__section1,
      sym__section2,
      sym__section3,
      sym__section4,
      sym__section5,
      sym__section6,
  [15311] = 15,
    ACTIONS(17), 1,
      sym_atx_h1_marker,
    ACTIONS(19), 1,
      sym_atx_h2_marker,
    ACTIONS(21), 1,
      sym_atx_h3_marker,
    ACTIONS(23), 1,
      sym_atx_h4_marker,
    ACTIONS(25), 1,
      sym_atx_h5_marker,
    ACTIONS(27), 1,
      sym_atx_h6_marker,
    ACTIONS(2820), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      sym__atx_heading1,
    STATE(45), 1,
      sym__atx_heading2,
    STATE(49), 1,
      sym__atx_heading3,
    STATE(60), 1,
      sym__atx_heading4,
    STATE(65), 1,
      sym__atx_heading5,
    STATE(70), 1,
      sym__atx_heading6,
    STATE(633), 2,
      sym_section,
      aux_sym_document_repeat2,
    STATE(657), 6,
      sym__section1,
      sym__section2,
      sym__section3,
      sym__section4,
      sym__section5,
      sym__section6,
  [15363] = 15,
    ACTIONS(17), 1,
      sym_atx_h1_marker,
    ACTIONS(19), 1,
      sym_atx_h2_marker,
    ACTIONS(21), 1,
      sym_atx_h3_marker,
    ACTIONS(23), 1,
      sym_atx_h4_marker,
    ACTIONS(25), 1,
      sym_atx_h5_marker,
    ACTIONS(27), 1,
      sym_atx_h6_marker,
    ACTIONS(149), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      sym__atx_heading1,
    STATE(45), 1,
      sym__atx_heading2,
    STATE(49), 1,
      sym__atx_heading3,
    STATE(60), 1,
      sym__atx_heading4,
    STATE(65), 1,
      sym__atx_heading5,
    STATE(70), 1,
      sym__atx_heading6,
    STATE(633), 2,
      sym_section,
      aux_sym_document_repeat2,
    STATE(657), 6,
      sym__section1,
      sym__section2,
      sym__section3,
      sym__section4,
      sym__section5,
      sym__section6,
  [15415] = 15,
    ACTIONS(17), 1,
      sym_atx_h1_marker,
    ACTIONS(19), 1,
      sym_atx_h2_marker,
    ACTIONS(21), 1,
      sym_atx_h3_marker,
    ACTIONS(23), 1,
      sym_atx_h4_marker,
    ACTIONS(25), 1,
      sym_atx_h5_marker,
    ACTIONS(27), 1,
      sym_atx_h6_marker,
    ACTIONS(2822), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      sym__atx_heading1,
    STATE(45), 1,
      sym__atx_heading2,
    STATE(49), 1,
      sym__atx_heading3,
    STATE(60), 1,
      sym__atx_heading4,
    STATE(65), 1,
      sym__atx_heading5,
    STATE(70), 1,
      sym__atx_heading6,
    STATE(633), 2,
      sym_section,
      aux_sym_document_repeat2,
    STATE(657), 6,
      sym__section1,
      sym__section2,
      sym__section3,
      sym__section4,
      sym__section5,
      sym__section6,
  [15467] = 7,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    ACTIONS(2828), 1,
      sym__whitespace,
    STATE(638), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(740), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2830), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15491] = 7,
    ACTIONS(2832), 1,
      anon_sym_DASH,
    ACTIONS(2835), 1,
      anon_sym_COLON,
    ACTIONS(2838), 1,
      sym__whitespace,
    STATE(638), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(807), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2841), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15515] = 7,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    ACTIONS(2843), 1,
      sym__whitespace,
    STATE(638), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(696), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2845), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15539] = 7,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    ACTIONS(2847), 1,
      sym__whitespace,
    STATE(638), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(726), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2849), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15563] = 3,
    ACTIONS(2851), 1,
      anon_sym_DASH,
    STATE(641), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2854), 6,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_COLON,
      anon_sym_PIPE,
      sym__whitespace,
  [15578] = 8,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    ACTIONS(2860), 1,
      anon_sym_PIPE,
    ACTIONS(2862), 1,
      sym__whitespace,
    STATE(639), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(669), 1,
      sym_pipe_table_delimiter_row,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(807), 1,
      sym_pipe_table_delimiter_cell,
  [15603] = 4,
    ACTIONS(2864), 1,
      anon_sym_DASH,
    ACTIONS(2866), 1,
      anon_sym_COLON,
    STATE(641), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2868), 5,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
      sym__whitespace,
  [15620] = 4,
    ACTIONS(2864), 1,
      anon_sym_DASH,
    ACTIONS(2870), 1,
      anon_sym_COLON,
    STATE(641), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2872), 5,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
      sym__whitespace,
  [15637] = 8,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    ACTIONS(2860), 1,
      anon_sym_PIPE,
    ACTIONS(2862), 1,
      sym__whitespace,
    STATE(639), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(675), 1,
      sym_pipe_table_delimiter_row,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(807), 1,
      sym_pipe_table_delimiter_cell,
  [15662] = 7,
    ACTIONS(1286), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(666), 1,
      sym__soft_line_break,
    STATE(707), 1,
      sym_link_title,
  [15684] = 7,
    ACTIONS(1161), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(682), 1,
      sym__soft_line_break,
    STATE(723), 1,
      sym_link_title,
  [15706] = 7,
    ACTIONS(1255), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(685), 1,
      sym__soft_line_break,
    STATE(737), 1,
      sym_link_title,
  [15728] = 5,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(691), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2830), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15746] = 5,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(729), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2849), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15764] = 7,
    ACTIONS(1268), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(667), 1,
      sym__soft_line_break,
    STATE(714), 1,
      sym_link_title,
  [15786] = 7,
    ACTIONS(1185), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(672), 1,
      sym__soft_line_break,
    STATE(698), 1,
      sym_link_title,
  [15808] = 7,
    ACTIONS(1281), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(673), 1,
      sym__soft_line_break,
    STATE(705), 1,
      sym_link_title,
  [15830] = 7,
    ACTIONS(1226), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(668), 1,
      sym__soft_line_break,
    STATE(690), 1,
      sym_link_title,
  [15852] = 7,
    ACTIONS(1221), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(662), 1,
      sym__soft_line_break,
    STATE(733), 1,
      sym_link_title,
  [15874] = 7,
    ACTIONS(1203), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(678), 1,
      sym__soft_line_break,
    STATE(711), 1,
      sym_link_title,
  [15896] = 1,
    ACTIONS(1784), 7,
      sym_atx_h1_marker,
      sym_atx_h2_marker,
      sym_atx_h3_marker,
      sym_atx_h4_marker,
      sym_atx_h5_marker,
      sym_atx_h6_marker,
      ts_builtin_sym_end,
  [15906] = 7,
    ACTIONS(1244), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__soft_line_ending,
    STATE(660), 1,
      sym__soft_line_break,
    STATE(709), 1,
      sym_link_title,
  [15928] = 5,
    ACTIONS(2824), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_COLON,
    STATE(643), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(728), 1,
      sym_pipe_table_delimiter_cell,
    ACTIONS(2882), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [15946] = 6,
    ACTIONS(1203), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2884), 1,
      sym__whitespace,
    STATE(711), 1,
      sym_link_title,
  [15965] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2886), 1,
      sym__whitespace,
    ACTIONS(2888), 1,
      sym__soft_line_ending,
    ACTIONS(2890), 1,
      sym__eof,
    STATE(101), 1,
      sym__soft_line_break,
    STATE(321), 1,
      sym__newline,
  [15984] = 6,
    ACTIONS(1255), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2892), 1,
      sym__whitespace,
    STATE(737), 1,
      sym_link_title,
  [16003] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2894), 1,
      sym__whitespace,
    ACTIONS(2896), 1,
      sym__soft_line_ending,
    ACTIONS(2898), 1,
      sym__eof,
    STATE(116), 1,
      sym__soft_line_break,
    STATE(233), 1,
      sym__newline,
  [16022] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2888), 1,
      sym__soft_line_ending,
    ACTIONS(2900), 1,
      sym__whitespace,
    ACTIONS(2902), 1,
      sym__eof,
    STATE(103), 1,
      sym__soft_line_break,
    STATE(317), 1,
      sym__newline,
  [16041] = 6,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    ACTIONS(2904), 1,
      sym__whitespace,
    STATE(640), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(807), 1,
      sym_pipe_table_delimiter_cell,
  [16060] = 6,
    ACTIONS(1244), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      sym__whitespace,
    STATE(709), 1,
      sym_link_title,
  [16079] = 6,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2908), 1,
      sym__whitespace,
    ACTIONS(2910), 1,
      sym__no_indented_chunk,
    STATE(719), 1,
      sym_link_title,
  [16098] = 6,
    ACTIONS(1161), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2912), 1,
      sym__whitespace,
    STATE(723), 1,
      sym_link_title,
  [16117] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2914), 1,
      sym__eof,
    ACTIONS(2916), 1,
      sym__pipe_table_line_ending,
    STATE(350), 1,
      sym__newline,
    STATE(410), 1,
      sym__pipe_table_newline,
    STATE(689), 1,
      aux_sym_pipe_table_repeat1,
  [16136] = 1,
    ACTIONS(2918), 6,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_DASH,
      anon_sym_COLON,
      sym__whitespace,
  [16145] = 6,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    ACTIONS(2904), 1,
      sym__whitespace,
    STATE(637), 1,
      aux_sym_pipe_table_delimiter_row_repeat1,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(807), 1,
      sym_pipe_table_delimiter_cell,
  [16164] = 6,
    ACTIONS(1221), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      sym__whitespace,
    STATE(733), 1,
      sym_link_title,
  [16183] = 6,
    ACTIONS(1286), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__whitespace,
    STATE(707), 1,
      sym_link_title,
  [16202] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2888), 1,
      sym__soft_line_ending,
    ACTIONS(2924), 1,
      sym__whitespace,
    ACTIONS(2926), 1,
      sym__eof,
    STATE(110), 1,
      sym__soft_line_break,
    STATE(340), 1,
      sym__newline,
  [16221] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2916), 1,
      sym__pipe_table_line_ending,
    ACTIONS(2928), 1,
      sym__eof,
    STATE(219), 1,
      sym__newline,
    STATE(410), 1,
      sym__pipe_table_newline,
    STATE(683), 1,
      aux_sym_pipe_table_repeat1,
  [16240] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2896), 1,
      sym__soft_line_ending,
    ACTIONS(2930), 1,
      sym__whitespace,
    ACTIONS(2932), 1,
      sym__eof,
    STATE(117), 1,
      sym__soft_line_break,
    STATE(217), 1,
      sym__newline,
  [16259] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2888), 1,
      sym__soft_line_ending,
    ACTIONS(2934), 1,
      sym__whitespace,
    ACTIONS(2936), 1,
      sym__eof,
    STATE(105), 1,
      sym__soft_line_break,
    STATE(349), 1,
      sym__newline,
  [16278] = 6,
    ACTIONS(1268), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2938), 1,
      sym__whitespace,
    STATE(714), 1,
      sym_link_title,
  [16297] = 2,
    ACTIONS(2940), 1,
      sym_block_continuation,
    ACTIONS(1165), 5,
      sym__no_indented_chunk,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      sym__whitespace,
  [16308] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2896), 1,
      sym__soft_line_ending,
    ACTIONS(2942), 1,
      sym__whitespace,
    ACTIONS(2944), 1,
      sym__eof,
    STATE(112), 1,
      sym__soft_line_break,
    STATE(192), 1,
      sym__newline,
  [16327] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2888), 1,
      sym__soft_line_ending,
    ACTIONS(2946), 1,
      sym__whitespace,
    ACTIONS(2948), 1,
      sym__eof,
    STATE(106), 1,
      sym__soft_line_break,
    STATE(331), 1,
      sym__newline,
  [16346] = 6,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2950), 1,
      sym__whitespace,
    ACTIONS(2952), 1,
      sym__no_indented_chunk,
    STATE(720), 1,
      sym_link_title,
  [16365] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2916), 1,
      sym__pipe_table_line_ending,
    ACTIONS(2954), 1,
      sym__eof,
    STATE(208), 1,
      sym__newline,
    STATE(410), 1,
      sym__pipe_table_newline,
    STATE(727), 1,
      aux_sym_pipe_table_repeat1,
  [16384] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2896), 1,
      sym__soft_line_ending,
    ACTIONS(2956), 1,
      sym__whitespace,
    ACTIONS(2958), 1,
      sym__eof,
    STATE(107), 1,
      sym__soft_line_break,
    STATE(207), 1,
      sym__newline,
  [16403] = 6,
    ACTIONS(1226), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2960), 1,
      sym__whitespace,
    STATE(690), 1,
      sym_link_title,
  [16422] = 1,
    ACTIONS(2841), 6,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_DASH,
      anon_sym_COLON,
      sym__whitespace,
  [16431] = 6,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(2896), 1,
      sym__soft_line_ending,
    ACTIONS(2962), 1,
      sym__whitespace,
    ACTIONS(2964), 1,
      sym__eof,
    STATE(104), 1,
      sym__soft_line_break,
    STATE(203), 1,
      sym__newline,
  [16450] = 1,
    ACTIONS(2966), 6,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_DASH,
      anon_sym_COLON,
      sym__whitespace,
  [16459] = 6,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2916), 1,
      sym__pipe_table_line_ending,
    ACTIONS(2968), 1,
      sym__eof,
    STATE(341), 1,
      sym__newline,
    STATE(410), 1,
      sym__pipe_table_newline,
    STATE(727), 1,
      aux_sym_pipe_table_repeat1,
  [16478] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(2972), 1,
      sym__eof,
    STATE(318), 2,
      sym__newline,
      sym__soft_line_break,
  [16492] = 3,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2976), 1,
      sym__whitespace,
    ACTIONS(2882), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16504] = 3,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(2980), 1,
      sym__whitespace,
    ACTIONS(2982), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16516] = 1,
    ACTIONS(2984), 5,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
      sym__whitespace,
  [16524] = 5,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    ACTIONS(2986), 1,
      anon_sym_PIPE,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(817), 1,
      sym_pipe_table_delimiter_cell,
  [16540] = 4,
    ACTIONS(2988), 1,
      anon_sym_DASH,
    ACTIONS(2990), 1,
      anon_sym_COLON,
    STATE(697), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2872), 2,
      anon_sym_PIPE,
      sym__whitespace,
  [16554] = 3,
    ACTIONS(2992), 1,
      anon_sym_PIPE,
    ACTIONS(2994), 1,
      sym__whitespace,
    ACTIONS(2849), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16566] = 3,
    ACTIONS(2996), 1,
      anon_sym_DASH,
    STATE(697), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2854), 3,
      anon_sym_COLON,
      anon_sym_PIPE,
      sym__whitespace,
  [16578] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(2999), 1,
      sym__eof,
    STATE(338), 2,
      sym__newline,
      sym__soft_line_break,
  [16592] = 1,
    ACTIONS(3001), 5,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
      anon_sym_PIPE,
      sym__whitespace,
  [16600] = 3,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(3003), 1,
      sym__whitespace,
    ACTIONS(2406), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16612] = 5,
    ACTIONS(1221), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(733), 1,
      sym_link_title,
  [16628] = 5,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(3005), 1,
      sym__no_indented_chunk,
    STATE(722), 1,
      sym_link_title,
  [16644] = 3,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(3007), 1,
      sym__whitespace,
    ACTIONS(2406), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16656] = 3,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(3009), 1,
      sym__whitespace,
    ACTIONS(2217), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16668] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3013), 1,
      sym__eof,
    STATE(206), 2,
      sym__newline,
      sym__soft_line_break,
  [16682] = 5,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2910), 1,
      sym__no_indented_chunk,
    STATE(719), 1,
      sym_link_title,
  [16698] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3015), 1,
      sym__eof,
    STATE(202), 2,
      sym__newline,
      sym__soft_line_break,
  [16712] = 3,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(3017), 1,
      sym__whitespace,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16724] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3019), 1,
      sym__eof,
    STATE(194), 2,
      sym__newline,
      sym__soft_line_break,
  [16738] = 3,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(3021), 1,
      sym__whitespace,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16750] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3023), 1,
      sym__eof,
    STATE(189), 2,
      sym__newline,
      sym__soft_line_break,
  [16764] = 3,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(3025), 1,
      sym__whitespace,
    ACTIONS(2247), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16776] = 3,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(3027), 1,
      sym__whitespace,
    ACTIONS(2247), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16788] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3029), 1,
      sym__eof,
    STATE(188), 2,
      sym__newline,
      sym__soft_line_break,
  [16802] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3031), 1,
      sym__eof,
    STATE(313), 2,
      sym__newline,
      sym__soft_line_break,
  [16816] = 2,
    ACTIONS(3033), 1,
      sym_block_continuation,
    ACTIONS(1119), 4,
      anon_sym_DASH,
      anon_sym_COLON,
      anon_sym_PIPE,
      sym__whitespace,
  [16826] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3035), 1,
      sym__eof,
    STATE(314), 2,
      sym__newline,
      sym__soft_line_break,
  [16840] = 5,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(3037), 1,
      sym__no_indented_chunk,
    STATE(717), 1,
      sym_link_title,
  [16856] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3039), 1,
      sym__eof,
    STATE(187), 2,
      sym__newline,
      sym__soft_line_break,
  [16870] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3041), 1,
      sym__eof,
    STATE(315), 2,
      sym__newline,
      sym__soft_line_break,
  [16884] = 5,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2952), 1,
      sym__no_indented_chunk,
    STATE(720), 1,
      sym_link_title,
  [16900] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3043), 1,
      sym__eof,
    STATE(186), 2,
      sym__newline,
      sym__soft_line_break,
  [16914] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3045), 1,
      sym__eof,
    STATE(316), 2,
      sym__newline,
      sym__soft_line_break,
  [16928] = 4,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3011), 1,
      sym__soft_line_ending,
    ACTIONS(3047), 1,
      sym__eof,
    STATE(302), 2,
      sym__newline,
      sym__soft_line_break,
  [16942] = 5,
    ACTIONS(1161), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(723), 1,
      sym_link_title,
  [16958] = 3,
    ACTIONS(2992), 1,
      anon_sym_PIPE,
    ACTIONS(3049), 1,
      sym__whitespace,
    ACTIONS(2830), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16970] = 4,
    ACTIONS(3053), 1,
      sym__pipe_table_line_ending,
    STATE(410), 1,
      sym__pipe_table_newline,
    STATE(727), 1,
      aux_sym_pipe_table_repeat1,
    ACTIONS(3051), 2,
      sym__line_ending,
      sym__eof,
  [16984] = 3,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(3056), 1,
      sym__whitespace,
    ACTIONS(3058), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [16996] = 3,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(3060), 1,
      sym__whitespace,
    ACTIONS(2830), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17008] = 5,
    ACTIONS(1286), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(707), 1,
      sym_link_title,
  [17024] = 1,
    ACTIONS(1350), 5,
      sym__no_indented_chunk,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      sym__whitespace,
  [17032] = 5,
    ACTIONS(1268), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(714), 1,
      sym_link_title,
  [17048] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3062), 1,
      sym__eof,
    STATE(329), 2,
      sym__newline,
      sym__soft_line_break,
  [17062] = 5,
    ACTIONS(1255), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(737), 1,
      sym_link_title,
  [17078] = 5,
    ACTIONS(1203), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      sym_link_title,
  [17094] = 5,
    ACTIONS(1226), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(690), 1,
      sym_link_title,
  [17110] = 4,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(2970), 1,
      sym__soft_line_ending,
    ACTIONS(3064), 1,
      sym__eof,
    STATE(322), 2,
      sym__newline,
      sym__soft_line_break,
  [17124] = 5,
    ACTIONS(1244), 1,
      sym__no_indented_chunk,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(709), 1,
      sym_link_title,
  [17140] = 4,
    ACTIONS(2988), 1,
      anon_sym_DASH,
    ACTIONS(3066), 1,
      anon_sym_COLON,
    STATE(697), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    ACTIONS(2868), 2,
      anon_sym_PIPE,
      sym__whitespace,
  [17154] = 3,
    ACTIONS(2992), 1,
      anon_sym_PIPE,
    ACTIONS(3068), 1,
      sym__whitespace,
    ACTIONS(2882), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17166] = 1,
    ACTIONS(1274), 4,
      anon_sym_DASH,
      anon_sym_COLON,
      anon_sym_PIPE,
      sym__whitespace,
  [17173] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(715), 1,
      sym_link_title,
  [17186] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(711), 1,
      sym_link_title,
  [17199] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(690), 1,
      sym_link_title,
  [17212] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      sym_link_title,
  [17225] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(714), 1,
      sym_link_title,
  [17238] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(737), 1,
      sym_link_title,
  [17251] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(719), 1,
      sym_link_title,
  [17264] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(707), 1,
      sym_link_title,
  [17277] = 2,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2830), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17286] = 2,
    ACTIONS(3070), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17295] = 2,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(3058), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17304] = 2,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(2982), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17313] = 1,
    ACTIONS(1920), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
  [17320] = 2,
    ACTIONS(3072), 1,
      anon_sym_PIPE,
    ACTIONS(2982), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17329] = 2,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17338] = 2,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(2882), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17347] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(723), 1,
      sym_link_title,
  [17360] = 2,
    ACTIONS(3072), 1,
      anon_sym_PIPE,
    ACTIONS(3074), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17369] = 4,
    ACTIONS(2856), 1,
      anon_sym_DASH,
    ACTIONS(2858), 1,
      anon_sym_COLON,
    STATE(739), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
    STATE(817), 1,
      sym_pipe_table_delimiter_cell,
  [17382] = 2,
    ACTIONS(3072), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17391] = 1,
    ACTIONS(1840), 4,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
      sym__whitespace,
  [17398] = 2,
    ACTIONS(3070), 1,
      anon_sym_PIPE,
    ACTIONS(3076), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17407] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(720), 1,
      sym_link_title,
  [17420] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(709), 1,
      sym_link_title,
  [17433] = 2,
    ACTIONS(3070), 1,
      anon_sym_PIPE,
    ACTIONS(2882), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17442] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(733), 1,
      sym_link_title,
  [17455] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(724), 1,
      sym_link_title,
  [17468] = 2,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(2247), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17477] = 2,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17486] = 2,
    ACTIONS(3072), 1,
      anon_sym_PIPE,
    ACTIONS(2306), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17495] = 4,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    ACTIONS(2876), 1,
      anon_sym_SQUOTE,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    STATE(722), 1,
      sym_link_title,
  [17508] = 3,
    ACTIONS(2406), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
    ACTIONS(3080), 1,
      sym__whitespace,
  [17518] = 1,
    ACTIONS(3082), 3,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
  [17524] = 3,
    ACTIONS(2982), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
    ACTIONS(3084), 1,
      sym__whitespace,
  [17534] = 3,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3086), 1,
      sym__eof,
    STATE(249), 1,
      sym__newline,
  [17544] = 3,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(3088), 1,
      sym__eof,
    STATE(254), 1,
      sym__newline,
  [17554] = 3,
    ACTIONS(3090), 1,
      sym__line_ending,
    ACTIONS(3092), 1,
      sym__eof,
    STATE(911), 1,
      sym__newline,
  [17564] = 3,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
    ACTIONS(3094), 1,
      sym__whitespace,
  [17574] = 3,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3096), 1,
      sym__eof,
    STATE(298), 1,
      sym__newline,
  [17584] = 3,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3098), 1,
      sym__eof,
    STATE(297), 1,
      sym__newline,
  [17594] = 3,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(3100), 1,
      sym__eof,
    STATE(310), 1,
      sym__newline,
  [17604] = 3,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(3102), 1,
      sym__whitespace,
  [17614] = 3,
    ACTIONS(1930), 1,
      sym__line_ending,
    ACTIONS(3104), 1,
      sym__eof,
    STATE(248), 1,
      sym__newline,
  [17624] = 3,
    ACTIONS(2247), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
    ACTIONS(3106), 1,
      sym__whitespace,
  [17634] = 3,
    ACTIONS(2247), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      sym__whitespace,
  [17644] = 3,
    ACTIONS(2406), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(3110), 1,
      sym__whitespace,
  [17654] = 3,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(3112), 1,
      sym__eof,
    STATE(255), 1,
      sym__newline,
  [17664] = 3,
    ACTIONS(2542), 1,
      sym__line_ending,
    ACTIONS(3114), 1,
      sym__eof,
    STATE(305), 1,
      sym__newline,
  [17674] = 1,
    ACTIONS(3051), 3,
      sym__line_ending,
      sym__eof,
      sym__pipe_table_line_ending,
  [17680] = 3,
    ACTIONS(2217), 1,
      sym__line_ending,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(3116), 1,
      sym__whitespace,
  [17690] = 1,
    ACTIONS(3118), 3,
      sym__line_ending,
      sym__soft_line_ending,
      sym__eof,
  [17696] = 2,
    ACTIONS(2674), 1,
      anon_sym_PIPE,
    ACTIONS(2676), 1,
      sym__whitespace,
  [17703] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(198), 1,
      sym__newline,
  [17710] = 2,
    ACTIONS(3120), 1,
      sym__block_close,
    ACTIONS(3122), 1,
      sym__fenced_code_block_end_tilde,
  [17717] = 2,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
    ACTIONS(3124), 1,
      sym__whitespace,
  [17724] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(863), 1,
      sym__newline,
  [17731] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(266), 1,
      sym__newline,
  [17738] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(185), 1,
      sym__newline,
  [17745] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(265), 1,
      sym__newline,
  [17752] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(264), 1,
      sym__newline,
  [17759] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(263), 1,
      sym__newline,
  [17766] = 2,
    ACTIONS(1930), 1,
      sym__line_ending,
    STATE(262), 1,
      sym__newline,
  [17773] = 2,
    ACTIONS(3120), 1,
      sym__block_close,
    ACTIONS(3122), 1,
      sym__fenced_code_block_end_backtick,
  [17780] = 2,
    ACTIONS(3128), 1,
      sym__line_ending,
    STATE(645), 1,
      sym__newline,
  [17787] = 2,
    ACTIONS(244), 1,
      sym__block_close,
    ACTIONS(3130), 1,
      sym_block_continuation,
  [17794] = 2,
    ACTIONS(2992), 1,
      anon_sym_PIPE,
    ACTIONS(3132), 1,
      sym__whitespace,
  [17801] = 2,
    ACTIONS(3134), 1,
      anon_sym_DASH,
    STATE(695), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
  [17808] = 2,
    ACTIONS(2402), 1,
      anon_sym_PIPE,
    ACTIONS(2404), 1,
      sym__whitespace,
  [17815] = 2,
    ACTIONS(2406), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
  [17822] = 2,
    ACTIONS(3136), 1,
      anon_sym_DASH,
    STATE(644), 1,
      aux_sym_pipe_table_delimiter_cell_repeat1,
  [17829] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(195), 1,
      sym__newline,
  [17836] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(196), 1,
      sym__newline,
  [17843] = 2,
    ACTIONS(3074), 1,
      sym__line_ending,
    ACTIONS(3138), 1,
      anon_sym_PIPE,
  [17850] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(197), 1,
      sym__newline,
  [17857] = 2,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(3138), 1,
      anon_sym_PIPE,
  [17864] = 2,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
    ACTIONS(3140), 1,
      sym__whitespace,
  [17871] = 2,
    ACTIONS(1858), 1,
      sym__block_close,
    ACTIONS(1860), 1,
      sym__fenced_code_block_end_backtick,
  [17878] = 2,
    ACTIONS(2306), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
  [17885] = 2,
    ACTIONS(1858), 1,
      sym__block_close,
    ACTIONS(1860), 1,
      sym__fenced_code_block_end_tilde,
  [17892] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(908), 1,
      sym__newline,
  [17899] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(867), 1,
      sym__newline,
  [17906] = 2,
    ACTIONS(1872), 1,
      sym__block_close,
    ACTIONS(1874), 1,
      sym__fenced_code_block_end_tilde,
  [17913] = 2,
    ACTIONS(2982), 1,
      sym__line_ending,
    ACTIONS(3138), 1,
      anon_sym_PIPE,
  [17920] = 2,
    ACTIONS(2406), 1,
      sym__line_ending,
    ACTIONS(3138), 1,
      anon_sym_PIPE,
  [17927] = 2,
    ACTIONS(1165), 1,
      sym__trigger_error,
    ACTIONS(3142), 1,
      sym_block_continuation,
  [17934] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(199), 1,
      sym__newline,
  [17941] = 2,
    ACTIONS(2542), 1,
      sym__line_ending,
    STATE(200), 1,
      sym__newline,
  [17948] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(859), 1,
      sym__newline,
  [17955] = 2,
    ACTIONS(1846), 1,
      sym__block_close,
    ACTIONS(1848), 1,
      sym__fenced_code_block_end_backtick,
  [17962] = 2,
    ACTIONS(1872), 1,
      sym__block_close,
    ACTIONS(1874), 1,
      sym__fenced_code_block_end_backtick,
  [17969] = 2,
    ACTIONS(1846), 1,
      sym__block_close,
    ACTIONS(1848), 1,
      sym__fenced_code_block_end_tilde,
  [17976] = 1,
    ACTIONS(3001), 2,
      anon_sym_PIPE,
      sym__whitespace,
  [17981] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(876), 1,
      sym__newline,
  [17988] = 2,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(385), 1,
      sym__newline,
  [17995] = 2,
    ACTIONS(3144), 1,
      sym__block_close,
    ACTIONS(3146), 1,
      sym__fenced_code_block_end_backtick,
  [18002] = 2,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(366), 1,
      sym__newline,
  [18009] = 2,
    ACTIONS(3144), 1,
      sym__block_close,
    ACTIONS(3146), 1,
      sym__fenced_code_block_end_tilde,
  [18016] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(881), 1,
      sym__newline,
  [18023] = 2,
    ACTIONS(3128), 1,
      sym__line_ending,
    STATE(642), 1,
      sym__newline,
  [18030] = 2,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
    ACTIONS(3148), 1,
      sym__whitespace,
  [18037] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(889), 1,
      sym__newline,
  [18044] = 1,
    ACTIONS(2984), 2,
      anon_sym_PIPE,
      sym__whitespace,
  [18049] = 2,
    ACTIONS(2982), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
  [18056] = 2,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(377), 1,
      sym__newline,
  [18063] = 2,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(360), 1,
      sym__newline,
  [18070] = 2,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(378), 1,
      sym__newline,
  [18077] = 2,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(365), 1,
      sym__newline,
  [18084] = 2,
    ACTIONS(1119), 1,
      sym__block_close,
    ACTIONS(3150), 1,
      sym_block_continuation,
  [18091] = 2,
    ACTIONS(1832), 1,
      sym__line_ending,
    STATE(363), 1,
      sym__newline,
  [18098] = 2,
    ACTIONS(1119), 1,
      sym__close_block,
    ACTIONS(3152), 1,
      sym_block_continuation,
  [18105] = 2,
    ACTIONS(3126), 1,
      sym__line_ending,
    STATE(896), 1,
      sym__newline,
  [18112] = 2,
    ACTIONS(1868), 1,
      sym__block_close,
    ACTIONS(1870), 1,
      sym__fenced_code_block_end_backtick,
  [18119] = 2,
    ACTIONS(1816), 1,
      sym__line_ending,
    STATE(367), 1,
      sym__newline,
  [18126] = 2,
    ACTIONS(1868), 1,
      sym__block_close,
    ACTIONS(1870), 1,
      sym__fenced_code_block_end_tilde,
  [18133] = 2,
    ACTIONS(2247), 1,
      sym__line_ending,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
  [18140] = 1,
    ACTIONS(3154), 1,
      sym__block_close,
  [18144] = 1,
    ACTIONS(3078), 1,
      anon_sym_PIPE,
  [18148] = 1,
    ACTIONS(3120), 1,
      sym__block_close,
  [18152] = 1,
    ACTIONS(3156), 1,
      sym__close_block,
  [18156] = 1,
    ACTIONS(3158), 1,
      sym__close_block,
  [18160] = 1,
    ACTIONS(3160), 1,
      anon_sym_COLON,
  [18164] = 1,
    ACTIONS(3162), 1,
      sym__block_close,
  [18168] = 1,
    ACTIONS(3164), 1,
      sym__close_block,
  [18172] = 1,
    ACTIONS(3166), 1,
      sym__close_block,
  [18176] = 1,
    ACTIONS(1274), 1,
      sym__close_block,
  [18180] = 1,
    ACTIONS(3168), 1,
      sym__block_close,
  [18184] = 1,
    ACTIONS(3170), 1,
      sym__block_close,
  [18188] = 1,
    ACTIONS(3172), 1,
      sym__block_close,
  [18192] = 1,
    ACTIONS(3174), 1,
      sym__block_close,
  [18196] = 1,
    ACTIONS(3176), 1,
      sym__block_close,
  [18200] = 1,
    ACTIONS(3178), 1,
      sym__whitespace,
  [18204] = 1,
    ACTIONS(3180), 1,
      sym__block_close,
  [18208] = 1,
    ACTIONS(1274), 1,
      sym__block_close,
  [18212] = 1,
    ACTIONS(3182), 1,
      sym__block_close,
  [18216] = 1,
    ACTIONS(3184), 1,
      sym__block_close,
  [18220] = 1,
    ACTIONS(151), 1,
      sym__block_close,
  [18224] = 1,
    ACTIONS(3186), 1,
      anon_sym_COLON,
  [18228] = 1,
    ACTIONS(3188), 1,
      sym__close_block,
  [18232] = 1,
    ACTIONS(3070), 1,
      anon_sym_PIPE,
  [18236] = 1,
    ACTIONS(3190), 1,
      sym__block_close,
  [18240] = 1,
    ACTIONS(3192), 1,
      sym__close_block,
  [18244] = 1,
    ACTIONS(3194), 1,
      sym__close_block,
  [18248] = 1,
    ACTIONS(3196), 1,
      sym__block_close,
  [18252] = 1,
    ACTIONS(3198), 1,
      sym__close_block,
  [18256] = 1,
    ACTIONS(3200), 1,
      sym__close_block,
  [18260] = 1,
    ACTIONS(3202), 1,
      sym__block_close,
  [18264] = 1,
    ACTIONS(1350), 1,
      sym__trigger_error,
  [18268] = 1,
    ACTIONS(3144), 1,
      sym__block_close,
  [18272] = 1,
    ACTIONS(3138), 1,
      anon_sym_PIPE,
  [18276] = 1,
    ACTIONS(3204), 1,
      sym__block_close,
  [18280] = 1,
    ACTIONS(3206), 1,
      sym__block_close,
  [18284] = 1,
    ACTIONS(3208), 1,
      sym__block_close,
  [18288] = 1,
    ACTIONS(3210), 1,
      sym__block_close,
  [18292] = 1,
    ACTIONS(3212), 1,
      sym__block_close,
  [18296] = 1,
    ACTIONS(3214), 1,
      sym__block_close,
  [18300] = 1,
    ACTIONS(3216), 1,
      sym__block_close,
  [18304] = 1,
    ACTIONS(2974), 1,
      anon_sym_PIPE,
  [18308] = 1,
    ACTIONS(2978), 1,
      anon_sym_PIPE,
  [18312] = 1,
    ACTIONS(3218), 1,
      sym__block_close,
  [18316] = 1,
    ACTIONS(3220), 1,
      sym__block_close,
  [18320] = 1,
    ACTIONS(3222), 1,
      sym__trigger_error,
  [18324] = 1,
    ACTIONS(3224), 1,
      sym__trigger_error,
  [18328] = 1,
    ACTIONS(3226), 1,
      sym__block_close,
  [18332] = 1,
    ACTIONS(3228), 1,
      anon_sym_COLON,
  [18336] = 1,
    ACTIONS(3230), 1,
      sym__trigger_error,
  [18340] = 1,
    ACTIONS(3232), 1,
      ts_builtin_sym_end,
  [18344] = 1,
    ACTIONS(3234), 1,
      sym__block_close,
  [18348] = 1,
    ACTIONS(3236), 1,
      sym__block_close,
  [18352] = 1,
    ACTIONS(3238), 1,
      sym__block_close,
  [18356] = 1,
    ACTIONS(1772), 1,
      sym__close_block,
  [18360] = 1,
    ACTIONS(3240), 1,
      anon_sym_COLON,
  [18364] = 1,
    ACTIONS(3072), 1,
      anon_sym_PIPE,
  [18368] = 1,
    ACTIONS(3242), 1,
      anon_sym_COLON,
  [18372] = 1,
    ACTIONS(3244), 1,
      sym__close_block,
  [18376] = 1,
    ACTIONS(3246), 1,
      sym__close_block,
  [18380] = 1,
    ACTIONS(3248), 1,
      sym__close_block,
  [18384] = 1,
    ACTIONS(3250), 1,
      sym__close_block,
  [18388] = 1,
    ACTIONS(3252), 1,
      sym__close_block,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(351)] = 0,
  [SMALL_STATE(352)] = 77,
  [SMALL_STATE(353)] = 154,
  [SMALL_STATE(354)] = 221,
  [SMALL_STATE(355)] = 290,
  [SMALL_STATE(356)] = 351,
  [SMALL_STATE(357)] = 420,
  [SMALL_STATE(358)] = 489,
  [SMALL_STATE(359)] = 558,
  [SMALL_STATE(360)] = 616,
  [SMALL_STATE(361)] = 678,
  [SMALL_STATE(362)] = 738,
  [SMALL_STATE(363)] = 804,
  [SMALL_STATE(364)] = 866,
  [SMALL_STATE(365)] = 926,
  [SMALL_STATE(366)] = 988,
  [SMALL_STATE(367)] = 1050,
  [SMALL_STATE(368)] = 1112,
  [SMALL_STATE(369)] = 1172,
  [SMALL_STATE(370)] = 1236,
  [SMALL_STATE(371)] = 1300,
  [SMALL_STATE(372)] = 1358,
  [SMALL_STATE(373)] = 1424,
  [SMALL_STATE(374)] = 1484,
  [SMALL_STATE(375)] = 1542,
  [SMALL_STATE(376)] = 1600,
  [SMALL_STATE(377)] = 1662,
  [SMALL_STATE(378)] = 1724,
  [SMALL_STATE(379)] = 1786,
  [SMALL_STATE(380)] = 1848,
  [SMALL_STATE(381)] = 1910,
  [SMALL_STATE(382)] = 1976,
  [SMALL_STATE(383)] = 2040,
  [SMALL_STATE(384)] = 2100,
  [SMALL_STATE(385)] = 2162,
  [SMALL_STATE(386)] = 2224,
  [SMALL_STATE(387)] = 2282,
  [SMALL_STATE(388)] = 2348,
  [SMALL_STATE(389)] = 2407,
  [SMALL_STATE(390)] = 2474,
  [SMALL_STATE(391)] = 2533,
  [SMALL_STATE(392)] = 2600,
  [SMALL_STATE(393)] = 2659,
  [SMALL_STATE(394)] = 2718,
  [SMALL_STATE(395)] = 2777,
  [SMALL_STATE(396)] = 2836,
  [SMALL_STATE(397)] = 2895,
  [SMALL_STATE(398)] = 2954,
  [SMALL_STATE(399)] = 3013,
  [SMALL_STATE(400)] = 3072,
  [SMALL_STATE(401)] = 3131,
  [SMALL_STATE(402)] = 3194,
  [SMALL_STATE(403)] = 3251,
  [SMALL_STATE(404)] = 3310,
  [SMALL_STATE(405)] = 3369,
  [SMALL_STATE(406)] = 3426,
  [SMALL_STATE(407)] = 3485,
  [SMALL_STATE(408)] = 3542,
  [SMALL_STATE(409)] = 3601,
  [SMALL_STATE(410)] = 3660,
  [SMALL_STATE(411)] = 3725,
  [SMALL_STATE(412)] = 3782,
  [SMALL_STATE(413)] = 3849,
  [SMALL_STATE(414)] = 3916,
  [SMALL_STATE(415)] = 3975,
  [SMALL_STATE(416)] = 4034,
  [SMALL_STATE(417)] = 4093,
  [SMALL_STATE(418)] = 4152,
  [SMALL_STATE(419)] = 4209,
  [SMALL_STATE(420)] = 4268,
  [SMALL_STATE(421)] = 4327,
  [SMALL_STATE(422)] = 4386,
  [SMALL_STATE(423)] = 4445,
  [SMALL_STATE(424)] = 4504,
  [SMALL_STATE(425)] = 4561,
  [SMALL_STATE(426)] = 4620,
  [SMALL_STATE(427)] = 4679,
  [SMALL_STATE(428)] = 4737,
  [SMALL_STATE(429)] = 4795,
  [SMALL_STATE(430)] = 4851,
  [SMALL_STATE(431)] = 4909,
  [SMALL_STATE(432)] = 4971,
  [SMALL_STATE(433)] = 5033,
  [SMALL_STATE(434)] = 5091,
  [SMALL_STATE(435)] = 5149,
  [SMALL_STATE(436)] = 5207,
  [SMALL_STATE(437)] = 5263,
  [SMALL_STATE(438)] = 5321,
  [SMALL_STATE(439)] = 5377,
  [SMALL_STATE(440)] = 5435,
  [SMALL_STATE(441)] = 5499,
  [SMALL_STATE(442)] = 5557,
  [SMALL_STATE(443)] = 5611,
  [SMALL_STATE(444)] = 5669,
  [SMALL_STATE(445)] = 5731,
  [SMALL_STATE(446)] = 5795,
  [SMALL_STATE(447)] = 5857,
  [SMALL_STATE(448)] = 5919,
  [SMALL_STATE(449)] = 5973,
  [SMALL_STATE(450)] = 6031,
  [SMALL_STATE(451)] = 6089,
  [SMALL_STATE(452)] = 6147,
  [SMALL_STATE(453)] = 6205,
  [SMALL_STATE(454)] = 6269,
  [SMALL_STATE(455)] = 6333,
  [SMALL_STATE(456)] = 6391,
  [SMALL_STATE(457)] = 6447,
  [SMALL_STATE(458)] = 6505,
  [SMALL_STATE(459)] = 6567,
  [SMALL_STATE(460)] = 6621,
  [SMALL_STATE(461)] = 6679,
  [SMALL_STATE(462)] = 6737,
  [SMALL_STATE(463)] = 6791,
  [SMALL_STATE(464)] = 6847,
  [SMALL_STATE(465)] = 6900,
  [SMALL_STATE(466)] = 6961,
  [SMALL_STATE(467)] = 7012,
  [SMALL_STATE(468)] = 7067,
  [SMALL_STATE(469)] = 7118,
  [SMALL_STATE(470)] = 7171,
  [SMALL_STATE(471)] = 7230,
  [SMALL_STATE(472)] = 7281,
  [SMALL_STATE(473)] = 7336,
  [SMALL_STATE(474)] = 7391,
  [SMALL_STATE(475)] = 7452,
  [SMALL_STATE(476)] = 7513,
  [SMALL_STATE(477)] = 7568,
  [SMALL_STATE(478)] = 7627,
  [SMALL_STATE(479)] = 7678,
  [SMALL_STATE(480)] = 7733,
  [SMALL_STATE(481)] = 7784,
  [SMALL_STATE(482)] = 7835,
  [SMALL_STATE(483)] = 7896,
  [SMALL_STATE(484)] = 7955,
  [SMALL_STATE(485)] = 8016,
  [SMALL_STATE(486)] = 8077,
  [SMALL_STATE(487)] = 8130,
  [SMALL_STATE(488)] = 8181,
  [SMALL_STATE(489)] = 8231,
  [SMALL_STATE(490)] = 8291,
  [SMALL_STATE(491)] = 8341,
  [SMALL_STATE(492)] = 8389,
  [SMALL_STATE(493)] = 8449,
  [SMALL_STATE(494)] = 8499,
  [SMALL_STATE(495)] = 8557,
  [SMALL_STATE(496)] = 8617,
  [SMALL_STATE(497)] = 8671,
  [SMALL_STATE(498)] = 8725,
  [SMALL_STATE(499)] = 8779,
  [SMALL_STATE(500)] = 8829,
  [SMALL_STATE(501)] = 8881,
  [SMALL_STATE(502)] = 8931,
  [SMALL_STATE(503)] = 8981,
  [SMALL_STATE(504)] = 9035,
  [SMALL_STATE(505)] = 9081,
  [SMALL_STATE(506)] = 9131,
  [SMALL_STATE(507)] = 9185,
  [SMALL_STATE(508)] = 9243,
  [SMALL_STATE(509)] = 9297,
  [SMALL_STATE(510)] = 9347,
  [SMALL_STATE(511)] = 9407,
  [SMALL_STATE(512)] = 9457,
  [SMALL_STATE(513)] = 9511,
  [SMALL_STATE(514)] = 9565,
  [SMALL_STATE(515)] = 9615,
  [SMALL_STATE(516)] = 9669,
  [SMALL_STATE(517)] = 9729,
  [SMALL_STATE(518)] = 9783,
  [SMALL_STATE(519)] = 9841,
  [SMALL_STATE(520)] = 9891,
  [SMALL_STATE(521)] = 9941,
  [SMALL_STATE(522)] = 9987,
  [SMALL_STATE(523)] = 10045,
  [SMALL_STATE(524)] = 10105,
  [SMALL_STATE(525)] = 10165,
  [SMALL_STATE(526)] = 10211,
  [SMALL_STATE(527)] = 10269,
  [SMALL_STATE(528)] = 10317,
  [SMALL_STATE(529)] = 10371,
  [SMALL_STATE(530)] = 10417,
  [SMALL_STATE(531)] = 10467,
  [SMALL_STATE(532)] = 10517,
  [SMALL_STATE(533)] = 10575,
  [SMALL_STATE(534)] = 10625,
  [SMALL_STATE(535)] = 10685,
  [SMALL_STATE(536)] = 10739,
  [SMALL_STATE(537)] = 10789,
  [SMALL_STATE(538)] = 10834,
  [SMALL_STATE(539)] = 10883,
  [SMALL_STATE(540)] = 10932,
  [SMALL_STATE(541)] = 10981,
  [SMALL_STATE(542)] = 11026,
  [SMALL_STATE(543)] = 11075,
  [SMALL_STATE(544)] = 11120,
  [SMALL_STATE(545)] = 11169,
  [SMALL_STATE(546)] = 11218,
  [SMALL_STATE(547)] = 11265,
  [SMALL_STATE(548)] = 11310,
  [SMALL_STATE(549)] = 11355,
  [SMALL_STATE(550)] = 11402,
  [SMALL_STATE(551)] = 11451,
  [SMALL_STATE(552)] = 11500,
  [SMALL_STATE(553)] = 11557,
  [SMALL_STATE(554)] = 11614,
  [SMALL_STATE(555)] = 11661,
  [SMALL_STATE(556)] = 11706,
  [SMALL_STATE(557)] = 11757,
  [SMALL_STATE(558)] = 11806,
  [SMALL_STATE(559)] = 11853,
  [SMALL_STATE(560)] = 11900,
  [SMALL_STATE(561)] = 11949,
  [SMALL_STATE(562)] = 11994,
  [SMALL_STATE(563)] = 12039,
  [SMALL_STATE(564)] = 12086,
  [SMALL_STATE(565)] = 12131,
  [SMALL_STATE(566)] = 12178,
  [SMALL_STATE(567)] = 12235,
  [SMALL_STATE(568)] = 12280,
  [SMALL_STATE(569)] = 12325,
  [SMALL_STATE(570)] = 12374,
  [SMALL_STATE(571)] = 12419,
  [SMALL_STATE(572)] = 12464,
  [SMALL_STATE(573)] = 12509,
  [SMALL_STATE(574)] = 12556,
  [SMALL_STATE(575)] = 12604,
  [SMALL_STATE(576)] = 12652,
  [SMALL_STATE(577)] = 12698,
  [SMALL_STATE(578)] = 12742,
  [SMALL_STATE(579)] = 12786,
  [SMALL_STATE(580)] = 12830,
  [SMALL_STATE(581)] = 12874,
  [SMALL_STATE(582)] = 12918,
  [SMALL_STATE(583)] = 12966,
  [SMALL_STATE(584)] = 13010,
  [SMALL_STATE(585)] = 13064,
  [SMALL_STATE(586)] = 13112,
  [SMALL_STATE(587)] = 13156,
  [SMALL_STATE(588)] = 13200,
  [SMALL_STATE(589)] = 13254,
  [SMALL_STATE(590)] = 13298,
  [SMALL_STATE(591)] = 13344,
  [SMALL_STATE(592)] = 13388,
  [SMALL_STATE(593)] = 13442,
  [SMALL_STATE(594)] = 13486,
  [SMALL_STATE(595)] = 13540,
  [SMALL_STATE(596)] = 13584,
  [SMALL_STATE(597)] = 13630,
  [SMALL_STATE(598)] = 13678,
  [SMALL_STATE(599)] = 13732,
  [SMALL_STATE(600)] = 13786,
  [SMALL_STATE(601)] = 13830,
  [SMALL_STATE(602)] = 13874,
  [SMALL_STATE(603)] = 13918,
  [SMALL_STATE(604)] = 13962,
  [SMALL_STATE(605)] = 14016,
  [SMALL_STATE(606)] = 14060,
  [SMALL_STATE(607)] = 14104,
  [SMALL_STATE(608)] = 14148,
  [SMALL_STATE(609)] = 14192,
  [SMALL_STATE(610)] = 14240,
  [SMALL_STATE(611)] = 14288,
  [SMALL_STATE(612)] = 14332,
  [SMALL_STATE(613)] = 14376,
  [SMALL_STATE(614)] = 14420,
  [SMALL_STATE(615)] = 14466,
  [SMALL_STATE(616)] = 14520,
  [SMALL_STATE(617)] = 14564,
  [SMALL_STATE(618)] = 14607,
  [SMALL_STATE(619)] = 14650,
  [SMALL_STATE(620)] = 14693,
  [SMALL_STATE(621)] = 14736,
  [SMALL_STATE(622)] = 14779,
  [SMALL_STATE(623)] = 14822,
  [SMALL_STATE(624)] = 14865,
  [SMALL_STATE(625)] = 14908,
  [SMALL_STATE(626)] = 14951,
  [SMALL_STATE(627)] = 14994,
  [SMALL_STATE(628)] = 15037,
  [SMALL_STATE(629)] = 15080,
  [SMALL_STATE(630)] = 15123,
  [SMALL_STATE(631)] = 15165,
  [SMALL_STATE(632)] = 15207,
  [SMALL_STATE(633)] = 15259,
  [SMALL_STATE(634)] = 15311,
  [SMALL_STATE(635)] = 15363,
  [SMALL_STATE(636)] = 15415,
  [SMALL_STATE(637)] = 15467,
  [SMALL_STATE(638)] = 15491,
  [SMALL_STATE(639)] = 15515,
  [SMALL_STATE(640)] = 15539,
  [SMALL_STATE(641)] = 15563,
  [SMALL_STATE(642)] = 15578,
  [SMALL_STATE(643)] = 15603,
  [SMALL_STATE(644)] = 15620,
  [SMALL_STATE(645)] = 15637,
  [SMALL_STATE(646)] = 15662,
  [SMALL_STATE(647)] = 15684,
  [SMALL_STATE(648)] = 15706,
  [SMALL_STATE(649)] = 15728,
  [SMALL_STATE(650)] = 15746,
  [SMALL_STATE(651)] = 15764,
  [SMALL_STATE(652)] = 15786,
  [SMALL_STATE(653)] = 15808,
  [SMALL_STATE(654)] = 15830,
  [SMALL_STATE(655)] = 15852,
  [SMALL_STATE(656)] = 15874,
  [SMALL_STATE(657)] = 15896,
  [SMALL_STATE(658)] = 15906,
  [SMALL_STATE(659)] = 15928,
  [SMALL_STATE(660)] = 15946,
  [SMALL_STATE(661)] = 15965,
  [SMALL_STATE(662)] = 15984,
  [SMALL_STATE(663)] = 16003,
  [SMALL_STATE(664)] = 16022,
  [SMALL_STATE(665)] = 16041,
  [SMALL_STATE(666)] = 16060,
  [SMALL_STATE(667)] = 16079,
  [SMALL_STATE(668)] = 16098,
  [SMALL_STATE(669)] = 16117,
  [SMALL_STATE(670)] = 16136,
  [SMALL_STATE(671)] = 16145,
  [SMALL_STATE(672)] = 16164,
  [SMALL_STATE(673)] = 16183,
  [SMALL_STATE(674)] = 16202,
  [SMALL_STATE(675)] = 16221,
  [SMALL_STATE(676)] = 16240,
  [SMALL_STATE(677)] = 16259,
  [SMALL_STATE(678)] = 16278,
  [SMALL_STATE(679)] = 16297,
  [SMALL_STATE(680)] = 16308,
  [SMALL_STATE(681)] = 16327,
  [SMALL_STATE(682)] = 16346,
  [SMALL_STATE(683)] = 16365,
  [SMALL_STATE(684)] = 16384,
  [SMALL_STATE(685)] = 16403,
  [SMALL_STATE(686)] = 16422,
  [SMALL_STATE(687)] = 16431,
  [SMALL_STATE(688)] = 16450,
  [SMALL_STATE(689)] = 16459,
  [SMALL_STATE(690)] = 16478,
  [SMALL_STATE(691)] = 16492,
  [SMALL_STATE(692)] = 16504,
  [SMALL_STATE(693)] = 16516,
  [SMALL_STATE(694)] = 16524,
  [SMALL_STATE(695)] = 16540,
  [SMALL_STATE(696)] = 16554,
  [SMALL_STATE(697)] = 16566,
  [SMALL_STATE(698)] = 16578,
  [SMALL_STATE(699)] = 16592,
  [SMALL_STATE(700)] = 16600,
  [SMALL_STATE(701)] = 16612,
  [SMALL_STATE(702)] = 16628,
  [SMALL_STATE(703)] = 16644,
  [SMALL_STATE(704)] = 16656,
  [SMALL_STATE(705)] = 16668,
  [SMALL_STATE(706)] = 16682,
  [SMALL_STATE(707)] = 16698,
  [SMALL_STATE(708)] = 16712,
  [SMALL_STATE(709)] = 16724,
  [SMALL_STATE(710)] = 16738,
  [SMALL_STATE(711)] = 16750,
  [SMALL_STATE(712)] = 16764,
  [SMALL_STATE(713)] = 16776,
  [SMALL_STATE(714)] = 16788,
  [SMALL_STATE(715)] = 16802,
  [SMALL_STATE(716)] = 16816,
  [SMALL_STATE(717)] = 16826,
  [SMALL_STATE(718)] = 16840,
  [SMALL_STATE(719)] = 16856,
  [SMALL_STATE(720)] = 16870,
  [SMALL_STATE(721)] = 16884,
  [SMALL_STATE(722)] = 16900,
  [SMALL_STATE(723)] = 16914,
  [SMALL_STATE(724)] = 16928,
  [SMALL_STATE(725)] = 16942,
  [SMALL_STATE(726)] = 16958,
  [SMALL_STATE(727)] = 16970,
  [SMALL_STATE(728)] = 16984,
  [SMALL_STATE(729)] = 16996,
  [SMALL_STATE(730)] = 17008,
  [SMALL_STATE(731)] = 17024,
  [SMALL_STATE(732)] = 17032,
  [SMALL_STATE(733)] = 17048,
  [SMALL_STATE(734)] = 17062,
  [SMALL_STATE(735)] = 17078,
  [SMALL_STATE(736)] = 17094,
  [SMALL_STATE(737)] = 17110,
  [SMALL_STATE(738)] = 17124,
  [SMALL_STATE(739)] = 17140,
  [SMALL_STATE(740)] = 17154,
  [SMALL_STATE(741)] = 17166,
  [SMALL_STATE(742)] = 17173,
  [SMALL_STATE(743)] = 17186,
  [SMALL_STATE(744)] = 17199,
  [SMALL_STATE(745)] = 17212,
  [SMALL_STATE(746)] = 17225,
  [SMALL_STATE(747)] = 17238,
  [SMALL_STATE(748)] = 17251,
  [SMALL_STATE(749)] = 17264,
  [SMALL_STATE(750)] = 17277,
  [SMALL_STATE(751)] = 17286,
  [SMALL_STATE(752)] = 17295,
  [SMALL_STATE(753)] = 17304,
  [SMALL_STATE(754)] = 17313,
  [SMALL_STATE(755)] = 17320,
  [SMALL_STATE(756)] = 17329,
  [SMALL_STATE(757)] = 17338,
  [SMALL_STATE(758)] = 17347,
  [SMALL_STATE(759)] = 17360,
  [SMALL_STATE(760)] = 17369,
  [SMALL_STATE(761)] = 17382,
  [SMALL_STATE(762)] = 17391,
  [SMALL_STATE(763)] = 17398,
  [SMALL_STATE(764)] = 17407,
  [SMALL_STATE(765)] = 17420,
  [SMALL_STATE(766)] = 17433,
  [SMALL_STATE(767)] = 17442,
  [SMALL_STATE(768)] = 17455,
  [SMALL_STATE(769)] = 17468,
  [SMALL_STATE(770)] = 17477,
  [SMALL_STATE(771)] = 17486,
  [SMALL_STATE(772)] = 17495,
  [SMALL_STATE(773)] = 17508,
  [SMALL_STATE(774)] = 17518,
  [SMALL_STATE(775)] = 17524,
  [SMALL_STATE(776)] = 17534,
  [SMALL_STATE(777)] = 17544,
  [SMALL_STATE(778)] = 17554,
  [SMALL_STATE(779)] = 17564,
  [SMALL_STATE(780)] = 17574,
  [SMALL_STATE(781)] = 17584,
  [SMALL_STATE(782)] = 17594,
  [SMALL_STATE(783)] = 17604,
  [SMALL_STATE(784)] = 17614,
  [SMALL_STATE(785)] = 17624,
  [SMALL_STATE(786)] = 17634,
  [SMALL_STATE(787)] = 17644,
  [SMALL_STATE(788)] = 17654,
  [SMALL_STATE(789)] = 17664,
  [SMALL_STATE(790)] = 17674,
  [SMALL_STATE(791)] = 17680,
  [SMALL_STATE(792)] = 17690,
  [SMALL_STATE(793)] = 17696,
  [SMALL_STATE(794)] = 17703,
  [SMALL_STATE(795)] = 17710,
  [SMALL_STATE(796)] = 17717,
  [SMALL_STATE(797)] = 17724,
  [SMALL_STATE(798)] = 17731,
  [SMALL_STATE(799)] = 17738,
  [SMALL_STATE(800)] = 17745,
  [SMALL_STATE(801)] = 17752,
  [SMALL_STATE(802)] = 17759,
  [SMALL_STATE(803)] = 17766,
  [SMALL_STATE(804)] = 17773,
  [SMALL_STATE(805)] = 17780,
  [SMALL_STATE(806)] = 17787,
  [SMALL_STATE(807)] = 17794,
  [SMALL_STATE(808)] = 17801,
  [SMALL_STATE(809)] = 17808,
  [SMALL_STATE(810)] = 17815,
  [SMALL_STATE(811)] = 17822,
  [SMALL_STATE(812)] = 17829,
  [SMALL_STATE(813)] = 17836,
  [SMALL_STATE(814)] = 17843,
  [SMALL_STATE(815)] = 17850,
  [SMALL_STATE(816)] = 17857,
  [SMALL_STATE(817)] = 17864,
  [SMALL_STATE(818)] = 17871,
  [SMALL_STATE(819)] = 17878,
  [SMALL_STATE(820)] = 17885,
  [SMALL_STATE(821)] = 17892,
  [SMALL_STATE(822)] = 17899,
  [SMALL_STATE(823)] = 17906,
  [SMALL_STATE(824)] = 17913,
  [SMALL_STATE(825)] = 17920,
  [SMALL_STATE(826)] = 17927,
  [SMALL_STATE(827)] = 17934,
  [SMALL_STATE(828)] = 17941,
  [SMALL_STATE(829)] = 17948,
  [SMALL_STATE(830)] = 17955,
  [SMALL_STATE(831)] = 17962,
  [SMALL_STATE(832)] = 17969,
  [SMALL_STATE(833)] = 17976,
  [SMALL_STATE(834)] = 17981,
  [SMALL_STATE(835)] = 17988,
  [SMALL_STATE(836)] = 17995,
  [SMALL_STATE(837)] = 18002,
  [SMALL_STATE(838)] = 18009,
  [SMALL_STATE(839)] = 18016,
  [SMALL_STATE(840)] = 18023,
  [SMALL_STATE(841)] = 18030,
  [SMALL_STATE(842)] = 18037,
  [SMALL_STATE(843)] = 18044,
  [SMALL_STATE(844)] = 18049,
  [SMALL_STATE(845)] = 18056,
  [SMALL_STATE(846)] = 18063,
  [SMALL_STATE(847)] = 18070,
  [SMALL_STATE(848)] = 18077,
  [SMALL_STATE(849)] = 18084,
  [SMALL_STATE(850)] = 18091,
  [SMALL_STATE(851)] = 18098,
  [SMALL_STATE(852)] = 18105,
  [SMALL_STATE(853)] = 18112,
  [SMALL_STATE(854)] = 18119,
  [SMALL_STATE(855)] = 18126,
  [SMALL_STATE(856)] = 18133,
  [SMALL_STATE(857)] = 18140,
  [SMALL_STATE(858)] = 18144,
  [SMALL_STATE(859)] = 18148,
  [SMALL_STATE(860)] = 18152,
  [SMALL_STATE(861)] = 18156,
  [SMALL_STATE(862)] = 18160,
  [SMALL_STATE(863)] = 18164,
  [SMALL_STATE(864)] = 18168,
  [SMALL_STATE(865)] = 18172,
  [SMALL_STATE(866)] = 18176,
  [SMALL_STATE(867)] = 18180,
  [SMALL_STATE(868)] = 18184,
  [SMALL_STATE(869)] = 18188,
  [SMALL_STATE(870)] = 18192,
  [SMALL_STATE(871)] = 18196,
  [SMALL_STATE(872)] = 18200,
  [SMALL_STATE(873)] = 18204,
  [SMALL_STATE(874)] = 18208,
  [SMALL_STATE(875)] = 18212,
  [SMALL_STATE(876)] = 18216,
  [SMALL_STATE(877)] = 18220,
  [SMALL_STATE(878)] = 18224,
  [SMALL_STATE(879)] = 18228,
  [SMALL_STATE(880)] = 18232,
  [SMALL_STATE(881)] = 18236,
  [SMALL_STATE(882)] = 18240,
  [SMALL_STATE(883)] = 18244,
  [SMALL_STATE(884)] = 18248,
  [SMALL_STATE(885)] = 18252,
  [SMALL_STATE(886)] = 18256,
  [SMALL_STATE(887)] = 18260,
  [SMALL_STATE(888)] = 18264,
  [SMALL_STATE(889)] = 18268,
  [SMALL_STATE(890)] = 18272,
  [SMALL_STATE(891)] = 18276,
  [SMALL_STATE(892)] = 18280,
  [SMALL_STATE(893)] = 18284,
  [SMALL_STATE(894)] = 18288,
  [SMALL_STATE(895)] = 18292,
  [SMALL_STATE(896)] = 18296,
  [SMALL_STATE(897)] = 18300,
  [SMALL_STATE(898)] = 18304,
  [SMALL_STATE(899)] = 18308,
  [SMALL_STATE(900)] = 18312,
  [SMALL_STATE(901)] = 18316,
  [SMALL_STATE(902)] = 18320,
  [SMALL_STATE(903)] = 18324,
  [SMALL_STATE(904)] = 18328,
  [SMALL_STATE(905)] = 18332,
  [SMALL_STATE(906)] = 18336,
  [SMALL_STATE(907)] = 18340,
  [SMALL_STATE(908)] = 18344,
  [SMALL_STATE(909)] = 18348,
  [SMALL_STATE(910)] = 18352,
  [SMALL_STATE(911)] = 18356,
  [SMALL_STATE(912)] = 18360,
  [SMALL_STATE(913)] = 18364,
  [SMALL_STATE(914)] = 18368,
  [SMALL_STATE(915)] = 18372,
  [SMALL_STATE(916)] = 18376,
  [SMALL_STATE(917)] = 18380,
  [SMALL_STATE(918)] = 18384,
  [SMALL_STATE(919)] = 18388,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 0),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1, .production_id = 2),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 2, .production_id = 3),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_content, 1),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_content, 4),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(353),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(533),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(351),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(559),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(23),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(456),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(512),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(503),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(498),
  [182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(497),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(496),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(515),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(780),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(231),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(232),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(244),
  [203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(246),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(247),
  [209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(358),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(354),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(781),
  [218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(394),
  [221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(395),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(390),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(452),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(392),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(451),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(443),
  [239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_quote_repeat1, 2), SHIFT_REPEAT(534),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_content, 3),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section1, 1, .production_id = 1),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(353),
  [253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(533),
  [256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(351),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(559),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(23),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(456),
  [270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(503),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(498),
  [276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(497),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(496),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(515),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(780),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(231),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(232),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(244),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(246),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(247),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(358),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(354),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(781),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(394),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(395),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(390),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(452),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(392),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(451),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(443),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(534),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section1, 2, .production_id = 1),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(352),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(22),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(438),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(508),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(528),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(517),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(506),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(535),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(789),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(357),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(356),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(782),
  [374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(396),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(397),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(398),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(450),
  [386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(400),
  [389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(449),
  [392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(427),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 2), SHIFT_REPEAT(489),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section2, 1, .production_id = 1),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(353),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(533),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(351),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(559),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(23),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(456),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(498),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(497),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(496),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(515),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(780),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(231),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(232),
  [441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(244),
  [444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(246),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(247),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(358),
  [453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(354),
  [456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(781),
  [459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(394),
  [462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(395),
  [465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(390),
  [468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(452),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(392),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(451),
  [477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(443),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(534),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section2, 2, .production_id = 1),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(352),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(22),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(438),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(528),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(517),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(506),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(535),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(789),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(357),
  [512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(356),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(782),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(396),
  [521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(397),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(398),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(450),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(400),
  [533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(449),
  [536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(427),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 2), SHIFT_REPEAT(489),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section3, 1, .production_id = 1),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section3, 2, .production_id = 1),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(353),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(533),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(351),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(559),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2),
  [560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(23),
  [563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(456),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(497),
  [569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(496),
  [572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(515),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(780),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(231),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(232),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(244),
  [587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(246),
  [590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(247),
  [593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(358),
  [596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(354),
  [599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(781),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(394),
  [605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(395),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(390),
  [611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(452),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(392),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(451),
  [620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(443),
  [623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(534),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(352),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(22),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(438),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(517),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(506),
  [641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(535),
  [644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(789),
  [647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(357),
  [650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(356),
  [653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(782),
  [656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(396),
  [659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(397),
  [662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(398),
  [665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(450),
  [668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(400),
  [671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(449),
  [674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(427),
  [677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 2), SHIFT_REPEAT(489),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section4, 2, .production_id = 1),
  [682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(353),
  [685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(533),
  [688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(351),
  [691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(559),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2),
  [696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(23),
  [699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(456),
  [702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(496),
  [705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(515),
  [708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(780),
  [711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(231),
  [714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(232),
  [717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(244),
  [720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(246),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(247),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(358),
  [729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(354),
  [732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(781),
  [735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(394),
  [738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(395),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(390),
  [744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(452),
  [747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(392),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(451),
  [753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(443),
  [756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(534),
  [759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(352),
  [762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(22),
  [765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(438),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(506),
  [771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(535),
  [774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(789),
  [777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(357),
  [780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(356),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(782),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(396),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(397),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(398),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(450),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(400),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(449),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(427),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 2), SHIFT_REPEAT(489),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section4, 1, .production_id = 1),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section5, 2, .production_id = 1),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(353),
  [817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(533),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(351),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(559),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(23),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(456),
  [834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(515),
  [837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(780),
  [840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(231),
  [843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(232),
  [846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(244),
  [849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(246),
  [852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(247),
  [855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(358),
  [858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(354),
  [861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(781),
  [864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(394),
  [867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(395),
  [870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(390),
  [873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(452),
  [876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(392),
  [879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(451),
  [882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(443),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(534),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(352),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(22),
  [894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(438),
  [897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(535),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(789),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(357),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(356),
  [909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(782),
  [912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(396),
  [915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(397),
  [918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(398),
  [921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(450),
  [924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(400),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(449),
  [930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(427),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 2), SHIFT_REPEAT(489),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section5, 1, .production_id = 1),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section6, 2, .production_id = 1),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2),
  [942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(353),
  [945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(533),
  [948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(352),
  [951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(559),
  [954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(22),
  [957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(438),
  [960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(789),
  [963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(231),
  [966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(232),
  [969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(244),
  [972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(246),
  [975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(247),
  [978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(357),
  [981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(356),
  [984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(782),
  [987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(396),
  [990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(397),
  [993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(398),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(450),
  [999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(400),
  [1002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(449),
  [1005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(427),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(489),
  [1011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(351),
  [1014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(23),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(456),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(780),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(358),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(354),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(781),
  [1032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(394),
  [1035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(395),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(390),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(452),
  [1044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(392),
  [1047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(451),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(443),
  [1053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 2), SHIFT_REPEAT(534),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section6, 1, .production_id = 1),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_indented_code_block_repeat1, 2),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_indented_code_block_repeat1, 2),
  [1062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_indented_code_block_repeat1, 2), SHIFT_REPEAT(456),
  [1065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_indented_code_block_repeat1, 2), SHIFT_REPEAT(781),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 2),
  [1070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_star_repeat1, 2),
  [1072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_star_repeat1, 2), SHIFT_REPEAT(244),
  [1075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_minus, 1),
  [1077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_minus, 1),
  [1079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_indented_code_block_repeat1, 2), SHIFT_REPEAT(438),
  [1082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_indented_code_block_repeat1, 2), SHIFT_REPEAT(782),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_parenthesis_repeat1, 2),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_parenthesis_repeat1, 2),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_parenthesis_repeat1, 2), SHIFT_REPEAT(246),
  [1092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_dot_repeat1, 2),
  [1094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_dot_repeat1, 2),
  [1096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_dot_repeat1, 2), SHIFT_REPEAT(247),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indented_code_block, 2),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indented_code_block, 2),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_minus_repeat1, 2),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_minus_repeat1, 2),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_minus_repeat1, 2), SHIFT_REPEAT(231),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 2),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__list_plus_repeat1, 2),
  [1114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_plus_repeat1, 2), SHIFT_REPEAT(232),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__newline, 1),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newline, 1),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_dot, 1),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_dot, 1),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_parenthesis, 1),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_parenthesis, 1),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_star, 1),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_star, 1),
  [1135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_plus, 1),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_plus, 1),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indented_code_block, 1),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indented_code_block, 1),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10), SHIFT(415),
  [1152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10), SHIFT(414),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10), SHIFT(457),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10), SHIFT(721),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 1),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 1),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10),
  [1173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10), SHIFT(415),
  [1176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10), SHIFT(414),
  [1179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10), SHIFT(457),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10), SHIFT(701),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10),
  [1191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10), SHIFT(415),
  [1194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10), SHIFT(414),
  [1197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10), SHIFT(457),
  [1200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10), SHIFT(732),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10), SHIFT(415),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10), SHIFT(414),
  [1215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10), SHIFT(457),
  [1218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10), SHIFT(734),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 10), SHIFT(725),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10),
  [1232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10), SHIFT(415),
  [1235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10), SHIFT(414),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10), SHIFT(457),
  [1241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10), SHIFT(735),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paragraph, 2, .production_id = 4),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paragraph, 2, .production_id = 4),
  [1252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 10), SHIFT(736),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_not_section, 1),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_not_section, 1),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 10), SHIFT(706),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newline, 2),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__newline, 2),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 4, .dynamic_precedence = 10), SHIFT(730),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_reference_definition, 5, .dynamic_precedence = 10), SHIFT(738),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_star, 4),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_star, 4),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_plus, 3),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_plus, 3),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_7, 2),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_7, 2),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_parenthesis, 4),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_parenthesis, 4),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_dot, 4),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_dot, 4),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_minus, 4),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_minus, 4),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_quote, 2),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_quote, 2),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_plus, 4),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_plus, 4),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_5, 2),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_5, 2),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 2),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 2),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_4, 2),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_4, 2),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_3, 2),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_3, 2),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_quote, 4),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_quote, 4),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_quote, 3),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_quote, 3),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_parenthesis, 3),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_parenthesis, 3),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indented_chunk, 3),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indented_chunk, 3),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_1, 3),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_1, 3),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_dot, 3),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_dot, 3),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_star, 3),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_star, 3),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_2, 3),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_2, 3),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_minus, 3),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_minus, 3),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_6, 3),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_6, 3),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_3, 3),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_3, 3),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_4, 3),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_4, 3),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_5, 3),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_5, 3),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_7, 3),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_7, 3),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_2, 2),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_2, 2),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_6, 2),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_6, 2),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_1, 2),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_1, 2),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indented_chunk, 2),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indented_chunk, 2),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading3, 2),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading3, 2),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading2, 3, .production_id = 5),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading2, 3, .production_id = 5),
  [1542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 12, .dynamic_precedence = 20),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 12, .dynamic_precedence = 20),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 11, .dynamic_precedence = 20),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 11, .dynamic_precedence = 20),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 10, .dynamic_precedence = 20),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 10, .dynamic_precedence = 20),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 9, .dynamic_precedence = 20),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 9, .dynamic_precedence = 20),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 9),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 9),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 20),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 8, .dynamic_precedence = 20),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading1, 3, .production_id = 5),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading1, 3, .production_id = 5),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading3, 3, .production_id = 5),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading3, 3, .production_id = 5),
  [1574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading4, 3, .production_id = 5),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading4, 3, .production_id = 5),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading5, 3, .production_id = 5),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading5, 3, .production_id = 5),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading6, 3, .production_id = 5),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading6, 3, .production_id = 5),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 8),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 8),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 20),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 7, .dynamic_precedence = 20),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 7),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 7),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 3),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 3),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 20),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 6, .dynamic_precedence = 20),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_table, 6, .production_id = 8),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table, 6, .production_id = 8),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 6),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 6),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_parenthesis, 5),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_parenthesis, 5),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_dot, 5),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_dot, 5),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_star, 5),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_star, 5),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_minus, 5),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_minus, 5),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__list_item_plus, 5),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_item_plus, 5),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_table, 5, .production_id = 8),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table, 5, .production_id = 8),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 5),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 5),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_quote, 5),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_quote, 5),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_minus, 1),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_minus, 1),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_plus, 1),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_plus, 1),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_7, 4),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_7, 4),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_6, 4),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_6, 4),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_5, 4),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_5, 4),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_4, 4),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_4, 4),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_3, 4),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_3, 4),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_2, 4),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_2, 4),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_block_1, 4),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_block_1, 4),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fenced_code_block, 4),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fenced_code_block, 4),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__indented_chunk, 4),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__indented_chunk, 4),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_star, 1),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_star, 1),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_parenthesis, 1),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_parenthesis, 1),
  [1698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_marker_dot, 1),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_marker_dot, 1),
  [1702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__setext_heading2, 3, .production_id = 6),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setext_heading2, 3, .production_id = 6),
  [1706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__setext_heading1, 3, .production_id = 6),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__setext_heading1, 3, .production_id = 6),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat1, 1),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_document_repeat1, 1),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section3_repeat1, 1, .production_id = 2),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section3_repeat1, 1, .production_id = 2),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section5_repeat1, 1, .production_id = 2),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section5_repeat1, 1, .production_id = 2),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_not_section, 1, .production_id = 1),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_not_section, 1, .production_id = 1),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_block, 1),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_block, 1),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 1),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 1),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading1, 2),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading1, 2),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section4_repeat1, 1, .production_id = 2),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section4_repeat1, 1, .production_id = 2),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading2, 2),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading2, 2),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section2_repeat1, 1, .production_id = 2),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section2_repeat1, 1, .production_id = 2),
  [1750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section1_repeat1, 1, .production_id = 2),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section1_repeat1, 1, .production_id = 2),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_block, 2),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_block, 2),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading4, 2),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading4, 2),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading5, 2),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading5, 2),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atx_heading6, 2),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atx_heading6, 2),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__blank_line, 2),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__blank_line, 2),
  [1774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_thematic_break, 2),
  [1776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thematic_break, 2),
  [1778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_reference_definition, 13, .dynamic_precedence = 20),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference_definition, 13, .dynamic_precedence = 20),
  [1782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 1),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 1),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 1), SHIFT(442),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 1),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 1),
  [1797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 1), SHIFT(424),
  [1800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 1), SHIFT(424),
  [1803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 1), SHIFT(491),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 3, .dynamic_precedence = 10),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_info_string, 2),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_info_string, 3),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(525),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(371),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(371),
  [1897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(476),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [1902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_info_string_repeat1, 2), SHIFT_REPEAT(571),
  [1905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_info_string_repeat1, 2), SHIFT_REPEAT(373),
  [1908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_info_string_repeat1, 2), SHIFT_REPEAT(466),
  [1911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_info_string_repeat1, 2), SHIFT_REPEAT(466),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_info_string_repeat1, 2),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 2, .dynamic_precedence = 10),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_info_string, 1),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(572),
  [2005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(399),
  [2008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(399),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [2013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(491),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_fence_content, 1),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(572),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(404),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(404),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [2037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(491),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(502),
  [2043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(502),
  [2046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(549),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_code_fence_content_repeat1, 2),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(572),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(407),
  [2059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(407),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(491),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_paragraph_repeat1, 2), SHIFT_REPEAT(533),
  [2072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_paragraph_repeat1, 2), SHIFT_REPEAT(533),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_paragraph_repeat1, 2),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_paragraph_repeat1, 2), SHIFT_REPEAT(559),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_repeat1, 1),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_5_repeat1, 2), SHIFT_REPEAT(519),
  [2113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_5_repeat1, 2), SHIFT_REPEAT(519),
  [2116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_5_repeat1, 2), SHIFT_REPEAT(882),
  [2119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_5_repeat1, 2), SHIFT_REPEAT(558),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_5_repeat1, 2),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(514),
  [2127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(514),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_fence_content_repeat1, 2), SHIFT_REPEAT(565),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_3_repeat1, 2), SHIFT_REPEAT(499),
  [2148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_3_repeat1, 2), SHIFT_REPEAT(499),
  [2151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_3_repeat1, 2), SHIFT_REPEAT(883),
  [2154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_3_repeat1, 2), SHIFT_REPEAT(563),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_3_repeat1, 2),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_2_repeat1, 2), SHIFT_REPEAT(520),
  [2162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_2_repeat1, 2), SHIFT_REPEAT(520),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_2_repeat1, 2), SHIFT_REPEAT(885),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_2_repeat1, 2), SHIFT_REPEAT(554),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_2_repeat1, 2),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [2179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_1_repeat1, 2), SHIFT_REPEAT(490),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_1_repeat1, 2), SHIFT_REPEAT(490),
  [2185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_1_repeat1, 2), SHIFT_REPEAT(546),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_1_repeat1, 2),
  [2190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_1_repeat1, 2), SHIFT_REPEAT(886),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 1),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 1),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 2),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2),
  [2255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(597),
  [2258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(556),
  [2261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(556),
  [2264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(447),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(598),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_language, 1),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(572),
  [2287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(455),
  [2290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(455),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [2295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(491),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 3),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_cell, 1),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_6_repeat1, 2), SHIFT_REPEAT(569),
  [2317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_6_repeat1, 2), SHIFT_REPEAT(569),
  [2320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_6_repeat1, 2), SHIFT_REPEAT(573),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_6_repeat1, 2),
  [2325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_block_4_repeat1, 2), SHIFT_REPEAT(569),
  [2328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_4_repeat1, 2), SHIFT_REPEAT(569),
  [2331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_4_repeat1, 2), SHIFT_REPEAT(539),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_block_4_repeat1, 2), SHIFT_REPEAT(614),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_4_repeat1, 2),
  [2339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_language_repeat1, 2), SHIFT_REPEAT(571),
  [2342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_language_repeat1, 2), SHIFT_REPEAT(462),
  [2345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_language_repeat1, 2), SHIFT_REPEAT(462),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_language_repeat1, 2),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__indented_chunk_repeat1, 2), SHIFT_REPEAT(569),
  [2353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__indented_chunk_repeat1, 2), SHIFT_REPEAT(569),
  [2356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__indented_chunk_repeat1, 2), SHIFT_REPEAT(614),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__indented_chunk_repeat1, 2),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line, 1),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_cell, 3),
  [2391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(611),
  [2394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(469),
  [2397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(469),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 4),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(611),
  [2417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(473),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(473),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(467),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(478),
  [2439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(478),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_cell, 2),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2),
  [2466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(487),
  [2469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(487),
  [2472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(488),
  [2475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(488),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(492),
  [2497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2), SHIFT_REPEAT(594),
  [2500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(493),
  [2503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(493),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [2522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(501),
  [2525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(501),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 2),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 2),
  [2536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(505),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(505),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(509),
  [2547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(509),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(511),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(511),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backslash_escape, 1),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backslash_escape, 1),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pipe_table_newline, 1),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pipe_table_newline, 1),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 3),
  [2594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 3),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [2598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [2600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT_REPEAT(826),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [2605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [2607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT_REPEAT(826),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(536),
  [2617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(536),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_info_string_repeat2, 2),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_info_string_repeat2, 2),
  [2626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_info_string_repeat2, 2), SHIFT_REPEAT(538),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [2639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(542),
  [2642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(542),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 3),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pipe_table_row_repeat1, 3),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_language_repeat1, 2),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_6_repeat1, 1),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_6_repeat1, 1),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [2671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1), SHIFT_REPEAT(826),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_row_repeat1, 4),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pipe_table_row_repeat1, 4),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [2688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(557),
  [2691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(557),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2),
  [2700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pipe_table_newline, 2),
  [2706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pipe_table_newline, 2),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [2712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pipe_table_row_repeat1, 2),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(575),
  [2727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__line_repeat1, 2), SHIFT_REPEAT(575),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_5_repeat1, 2),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_2_repeat1, 2),
  [2736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_1_repeat1, 2),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [2750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__word, 1),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__word, 1),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_task_list_marker_checked, 1),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_task_list_marker_unchecked, 1),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_inline_no_link, 2),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_inline_no_link, 2),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_paragraph_repeat1, 1),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_paragraph_repeat1, 1),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_3_repeat1, 2),
  [2780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(609),
  [2783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pipe_table_cell_repeat1, 2), SHIFT_REPEAT(609),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_no_angle, 2),
  [2790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_no_angle, 2),
  [2792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_4_repeat1, 2),
  [2794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_block_6_repeat1, 3),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_block_6_repeat1, 3),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 2, .production_id = 2),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(513),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(508),
  [2808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(528),
  [2811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(517),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(506),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_document_repeat2, 2), SHIFT_REPEAT(535),
  [2820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 2),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 3, .production_id = 3),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 3),
  [2832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 2), SHIFT_REPEAT(739),
  [2835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 2), SHIFT_REPEAT(808),
  [2838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 2), SHIFT_REPEAT(760),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 2),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 1),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 2),
  [2851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_cell_repeat1, 2), SHIFT_REPEAT(641),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_cell_repeat1, 2),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_cell, 1),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_cell, 2, .production_id = 7),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 4),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 3),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_row_repeat1, 4),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 5),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_cell, 3, .production_id = 10),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_delimiter_cell_repeat1, 2), SHIFT_REPEAT(697),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_cell, 2, .production_id = 9),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pipe_table_repeat1, 2),
  [3053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pipe_table_repeat1, 2), SHIFT_REPEAT(527),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 5),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_row, 6),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_table_delimiter_row, 6),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 2),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 3),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_label, 3),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3232] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_markdown_external_scanner_create(void);
void tree_sitter_markdown_external_scanner_destroy(void *);
bool tree_sitter_markdown_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_markdown_external_scanner_serialize(void *, char *);
void tree_sitter_markdown_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_markdown(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_markdown_external_scanner_create,
      tree_sitter_markdown_external_scanner_destroy,
      tree_sitter_markdown_external_scanner_scan,
      tree_sitter_markdown_external_scanner_serialize,
      tree_sitter_markdown_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
